/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var be=["exports","require","vs/base/common/lifecycle","vs/base/browser/dom","vs/base/common/event","vs/base/common/platform","vs/base/common/errors","vs/base/common/types","vs/css!vs/code/electron-sandbox/processExplorer/processExplorerMain","vs/base/common/async","vs/nls!vs/code/electron-sandbox/processExplorer/processExplorerMain","vs/base/common/arrays","vs/base/common/strings","vs/nls","vs/base/browser/keyboardEvent","vs/base/common/uri","vs/base/browser/browser","vs/base/common/codicons","vs/base/common/themables","vs/base/browser/mouseEvent","vs/base/browser/ui/widget","vs/base/browser/window","vs/base/browser/event","vs/base/common/path","vs/base/browser/touch","vs/base/browser/ui/tree/tree","vs/base/common/decorators","vs/base/common/iterator","vs/base/common/lazy","vs/base/common/cancellation","vs/base/parts/sandbox/electron-sandbox/globals","vs/base/common/network","vs/base/common/map","vs/base/common/buffer","vs/base/common/filters","vs/base/common/iconLabels","vs/base/common/actions","vs/base/common/resources","vs/base/browser/ui/scrollbar/scrollbarArrow","vs/base/browser/ui/list/listWidget","vs/platform/instantiation/common/instantiation","vs/base/browser/fastDomNode","vs/base/browser/ui/scrollbar/scrollbarState","vs/base/common/functional","vs/base/common/keyCodes","vs/base/common/linkedList","vs/base/common/numbers","vs/base/common/range","vs/base/common/scrollable","vs/base/common/hash","vs/base/common/symbols","vs/base/common/objects","vs/css!vs/base/browser/ui/actionbar/actionbar","vs/base/common/marshalling","vs/base/browser/dnd","vs/base/browser/formattedTextRenderer","vs/base/browser/globalPointerMoveMonitor","vs/base/browser/ui/aria/aria","vs/base/browser/ui/tree/indexTreeModel","vs/base/browser/ui/scrollbar/abstractScrollbar","vs/base/browser/ui/scrollbar/scrollableElement","vs/base/browser/ui/list/listView","vs/base/common/htmlContent","vs/base/browser/ui/actionbar/actionViewItems","vs/base/browser/ui/actionbar/actionbar","vs/base/browser/ui/inputbox/inputBox","vs/base/browser/ui/toggle/toggle","vs/base/parts/ipc/common/ipc","vs/platform/registry/common/platform","vs/base/browser/iframe","vs/base/browser/ui/list/list","vs/base/browser/ui/list/splice","vs/base/common/arraysFind","vs/base/common/collections","vs/base/common/color","vs/base/common/diff/diffChange","vs/base/common/assert","vs/base/common/idGenerator","vs/base/common/keybindings","vs/base/common/marked/marked","vs/base/common/navigator","vs/base/common/history","vs/base/browser/ui/list/rangeMap","vs/base/common/stopwatch","vs/base/common/cache","vs/base/common/stream","vs/base/common/diff/diff","vs/base/common/ternarySearchTree","vs/base/parts/contextmenu/common/contextmenu","vs/base/parts/ipc/common/ipc.electron","vs/base/parts/contextmenu/electron-sandbox/contextmenu","vs/css!vs/base/browser/ui/aria/aria","vs/css!vs/base/browser/ui/codicons/codicon/codicon","vs/css!vs/base/browser/ui/codicons/codicon/codicon-modifiers","vs/base/browser/ui/codicons/codiconStyles","vs/css!vs/base/browser/ui/findinput/findInput","vs/css!vs/base/browser/ui/inputbox/inputBox","vs/css!vs/base/browser/ui/list/list","vs/css!vs/base/browser/ui/scrollbar/media/scrollbars","vs/css!vs/base/browser/ui/selectBox/selectBox","vs/css!vs/base/browser/ui/selectBox/selectBoxCustom","vs/css!vs/base/browser/ui/toggle/toggle","vs/css!vs/base/browser/ui/tree/media/tree","vs/css!vs/code/electron-sandbox/processExplorer/media/processExplorer","vs/nls!vs/base/browser/ui/actionbar/actionViewItems","vs/nls!vs/base/browser/ui/findinput/findInput","vs/nls!vs/base/browser/ui/findinput/findInputToggles","vs/nls!vs/base/browser/ui/iconLabel/iconLabelHover","vs/nls!vs/base/browser/ui/inputbox/inputBox","vs/nls!vs/base/browser/ui/selectBox/selectBoxCustom","vs/nls!vs/base/browser/ui/tree/abstractTree","vs/nls!vs/base/common/actions","vs/nls!vs/base/common/platform","vs/base/browser/canIUse","vs/base/common/process","vs/base/common/extpath","vs/base/common/mime","vs/base/browser/dompurify/dompurify","vs/base/browser/ui/iconLabel/iconLabels","vs/base/browser/ui/list/rowCache","vs/base/browser/ui/scrollbar/scrollbarVisibilityController","vs/base/browser/ui/selectBox/selectBoxNative","vs/base/browser/ui/tree/objectTreeModel","vs/base/browser/ui/scrollbar/horizontalScrollbar","vs/base/browser/ui/scrollbar/verticalScrollbar","vs/base/browser/markdownRenderer","vs/base/browser/ui/iconLabel/iconLabelHover","vs/base/browser/ui/selectBox/selectBoxCustom","vs/base/browser/ui/selectBox/selectBox","vs/base/browser/ui/findinput/findInputToggles","vs/base/browser/ui/findinput/findInput","vs/base/browser/ui/tree/abstractTree","vs/base/browser/ui/tree/dataTree","vs/base/parts/ipc/electron-sandbox/ipc.electron","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/theme/common/iconRegistry","vs/platform/diagnostics/common/diagnostics","vs/platform/files/common/files","vs/platform/ipc/common/mainProcessService","vs/platform/ipc/electron-sandbox/mainProcessService","vs/platform/native/common/nativeHostService","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/theme/common/iconRegistry","vs/platform/theme/browser/iconsStyleSheet","vs/platform/window/common/window","vs/platform/window/electron-sandbox/window","vs/code/electron-sandbox/processExplorer/processExplorerMain"],pe=function(ae){for(var t=[],v=0,N=ae.length;v<N;v++)t[v]=be[ae[v]];return t};/*! @license DOMPurify 3.0.5 | (c) Cure53 and other contributors | Released under the Apache license 2.0 and Mozilla Public License 2.0 | github.com/cure53/DOMPurify/blob/3.0.5/LICENSE */const{entries:zt,setPrototypeOf:jt,isFrozen:ii,getPrototypeOf:ni,getOwnPropertyDescriptor:si}=Object;let{freeze:it,seal:ut,create:ri}=Object,{apply:Ft,construct:Nt}=typeof Reflect<"u"&&Reflect;Ft||(Ft=function(t,v,N){return t.apply(v,N)}),it||(it=function(t){return t}),ut||(ut=function(t){return t}),Nt||(Nt=function(t,v){return new t(...v)});const oi=at(Array.prototype.forEach),Ht=at(Array.prototype.pop),bt=at(Array.prototype.push),Dt=at(String.prototype.toLowerCase),Ot=at(String.prototype.toString),li=at(String.prototype.match),ct=at(String.prototype.replace),ai=at(String.prototype.indexOf),hi=at(String.prototype.trim),lt=at(RegExp.prototype.test),$t=ui(TypeError);function at(ae){return function(t){for(var v=arguments.length,N=new Array(v>1?v-1:0),i=1;i<v;i++)N[i-1]=arguments[i];return Ft(ae,t,N)}}function ui(ae){return function(){for(var t=arguments.length,v=new Array(t),N=0;N<t;N++)v[N]=arguments[N];return Nt(ae,v)}}function je(ae,t,v){var N;v=(N=v)!==null&&N!==void 0?N:Dt,jt&&jt(ae,null);let i=t.length;for(;i--;){let U=t[i];if(typeof U=="string"){const w=v(U);w!==U&&(ii(t)||(t[i]=w),U=w)}ae[U]=!0}return ae}function gt(ae){const t=ri(null);for(const[v,N]of zt(ae))t[v]=N;return t}function yt(ae,t){for(;ae!==null;){const N=si(ae,t);if(N){if(N.get)return at(N.get);if(typeof N.value=="function")return at(N.value)}ae=ni(ae)}function v(N){return console.warn("fallback value for",N),null}return v}const Ut=it(["a","abbr","acronym","address","area","article","aside","audio","b","bdi","bdo","big","blink","blockquote","body","br","button","canvas","caption","center","cite","code","col","colgroup","content","data","datalist","dd","decorator","del","details","dfn","dialog","dir","div","dl","dt","element","em","fieldset","figcaption","figure","font","footer","form","h1","h2","h3","h4","h5","h6","head","header","hgroup","hr","html","i","img","input","ins","kbd","label","legend","li","main","map","mark","marquee","menu","menuitem","meter","nav","nobr","ol","optgroup","option","output","p","picture","pre","progress","q","rp","rt","ruby","s","samp","section","select","shadow","small","source","spacer","span","strike","strong","style","sub","summary","sup","table","tbody","td","template","textarea","tfoot","th","thead","time","tr","track","tt","u","ul","var","video","wbr"]),Rt=it(["svg","a","altglyph","altglyphdef","altglyphitem","animatecolor","animatemotion","animatetransform","circle","clippath","defs","desc","ellipse","filter","font","g","glyph","glyphref","hkern","image","line","lineargradient","marker","mask","metadata","mpath","path","pattern","polygon","polyline","radialgradient","rect","stop","style","switch","symbol","text","textpath","title","tref","tspan","view","vkern"]),Tt=it(["feBlend","feColorMatrix","feComponentTransfer","feComposite","feConvolveMatrix","feDiffuseLighting","feDisplacementMap","feDistantLight","feDropShadow","feFlood","feFuncA","feFuncB","feFuncG","feFuncR","feGaussianBlur","feImage","feMerge","feMergeNode","feMorphology","feOffset","fePointLight","feSpecularLighting","feSpotLight","feTile","feTurbulence"]),ci=it(["animate","color-profile","cursor","discard","font-face","font-face-format","font-face-name","font-face-src","font-face-uri","foreignobject","hatch","hatchpath","mesh","meshgradient","meshpatch","meshrow","missing-glyph","script","set","solidcolor","unknown","use"]),Lt=it(["math","menclose","merror","mfenced","mfrac","mglyph","mi","mlabeledtr","mmultiscripts","mn","mo","mover","mpadded","mphantom","mroot","mrow","ms","mspace","msqrt","mstyle","msub","msup","msubsup","mtable","mtd","mtext","mtr","munder","munderover","mprescripts"]),fi=it(["maction","maligngroup","malignmark","mlongdiv","mscarries","mscarry","msgroup","mstack","msline","msrow","semantics","annotation","annotation-xml","mprescripts","none"]),Wt=it(["#text"]),Vt=it(["accept","action","align","alt","autocapitalize","autocomplete","autopictureinpicture","autoplay","background","bgcolor","border","capture","cellpadding","cellspacing","checked","cite","class","clear","color","cols","colspan","controls","controlslist","coords","crossorigin","datetime","decoding","default","dir","disabled","disablepictureinpicture","disableremoteplayback","download","draggable","enctype","enterkeyhint","face","for","headers","height","hidden","high","href","hreflang","id","inputmode","integrity","ismap","kind","label","lang","list","loading","loop","low","max","maxlength","media","method","min","minlength","multiple","muted","name","nonce","noshade","novalidate","nowrap","open","optimum","pattern","placeholder","playsinline","poster","preload","pubdate","radiogroup","readonly","rel","required","rev","reversed","role","rows","rowspan","spellcheck","scope","selected","shape","size","sizes","span","srclang","start","src","srcset","step","style","summary","tabindex","title","translate","type","usemap","valign","value","width","xmlns","slot"]),It=it(["accent-height","accumulate","additive","alignment-baseline","ascent","attributename","attributetype","azimuth","basefrequency","baseline-shift","begin","bias","by","class","clip","clippathunits","clip-path","clip-rule","color","color-interpolation","color-interpolation-filters","color-profile","color-rendering","cx","cy","d","dx","dy","diffuseconstant","direction","display","divisor","dur","edgemode","elevation","end","fill","fill-opacity","fill-rule","filter","filterunits","flood-color","flood-opacity","font-family","font-size","font-size-adjust","font-stretch","font-style","font-variant","font-weight","fx","fy","g1","g2","glyph-name","glyphref","gradientunits","gradienttransform","height","href","id","image-rendering","in","in2","k","k1","k2","k3","k4","kerning","keypoints","keysplines","keytimes","lang","lengthadjust","letter-spacing","kernelmatrix","kernelunitlength","lighting-color","local","marker-end","marker-mid","marker-start","markerheight","markerunits","markerwidth","maskcontentunits","maskunits","max","mask","media","method","mode","min","name","numoctaves","offset","operator","opacity","order","orient","orientation","origin","overflow","paint-order","path","pathlength","patterncontentunits","patterntransform","patternunits","points","preservealpha","preserveaspectratio","primitiveunits","r","rx","ry","radius","refx","refy","repeatcount","repeatdur","restart","result","rotate","scale","seed","shape-rendering","specularconstant","specularexponent","spreadmethod","startoffset","stddeviation","stitchtiles","stop-color","stop-opacity","stroke-dasharray","stroke-dashoffset","stroke-linecap","stroke-linejoin","stroke-miterlimit","stroke-opacity","stroke","stroke-width","style","surfacescale","systemlanguage","tabindex","targetx","targety","transform","transform-origin","text-anchor","text-decoration","text-rendering","textlength","type","u1","u2","unicode","values","viewbox","visibility","version","vert-adv-y","vert-origin-x","vert-origin-y","width","word-spacing","wrap","writing-mode","xchannelselector","ychannelselector","x","x1","x2","xmlns","y","y1","y2","z","zoomandpan"]),qt=it(["accent","accentunder","align","bevelled","close","columnsalign","columnlines","columnspan","denomalign","depth","dir","display","displaystyle","encoding","fence","frame","height","href","id","largeop","length","linethickness","lspace","lquote","mathbackground","mathcolor","mathsize","mathvariant","maxsize","minsize","movablelimits","notation","numalign","open","rowalign","rowlines","rowspacing","rowspan","rspace","rquote","scriptlevel","scriptminsize","scriptsizemultiplier","selection","separator","separators","stretchy","subscriptshift","supscriptshift","symmetric","voffset","width","xmlns"]),Et=it(["xlink:href","xml:id","xlink:title","xml:space","xmlns:xlink"]),di=ut(/\{\{[\w\W]*|[\w\W]*\}\}/gm),gi=ut(/<%[\w\W]*|[\w\W]*%>/gm),mi=ut(/\${[\w\W]*}/gm),bi=ut(/^data-[\-\w.\u00B7-\uFFFF]/),$i=ut(/^aria-[\-\w]+$/),_t=ut(/^(?:(?:(?:f|ht)tps?|mailto|tel|callto|sms|cid|xmpp):|[^a-z]|[a-z+.\-]+(?:[^a-z+.\-:]|$))/i),pi=ut(/^(?:\w+script|data):/i),wi=ut(/[\u0000-\u0020\u00A0\u1680\u180E\u2000-\u2029\u205F\u3000]/g),Kt=ut(/^html$/i);var Qt=Object.freeze({__proto__:null,MUSTACHE_EXPR:di,ERB_EXPR:gi,TMPLIT_EXPR:mi,DATA_ATTR:bi,ARIA_ATTR:$i,IS_ALLOWED_URI:_t,IS_SCRIPT_OR_DATA:pi,ATTR_WHITESPACE:wi,DOCTYPE_NAME:Kt});const vi=()=>typeof window>"u"?null:window,Di=function(t,v){if(typeof t!="object"||typeof t.createPolicy!="function")return null;let N=null;const i="data-tt-policy-suffix";v&&v.hasAttribute(i)&&(N=v.getAttribute(i));const U="dompurify"+(N?"#"+N:"");try{return t.createPolicy(U,{createHTML(w){return w},createScriptURL(w){return w}})}catch{return console.warn("TrustedTypes policy "+U+" could not be created."),null}};function xt(){let ae=arguments.length>0&&arguments[0]!==void 0?arguments[0]:vi();const t=Ie=>xt(Ie);if(t.version="3.0.5",t.removed=[],!ae||!ae.document||ae.document.nodeType!==9)return t.isSupported=!1,t;const v=ae.document,N=v.currentScript;let{document:i}=ae;const{DocumentFragment:U,HTMLTemplateElement:w,Node:D,Element:c,NodeFilter:f,NamedNodeMap:d=ae.NamedNodeMap||ae.MozNamedAttrMap,HTMLFormElement:T,DOMParser:s,trustedTypes:a}=ae,e=c.prototype,h=yt(e,"cloneNode"),l=yt(e,"nextSibling"),m=yt(e,"childNodes"),n=yt(e,"parentNode");if(typeof w=="function"){const Ie=i.createElement("template");Ie.content&&Ie.content.ownerDocument&&(i=Ie.content.ownerDocument)}let r,b="";const{implementation:u,createNodeIterator:o,createDocumentFragment:F,getElementsByTagName:z}=i,{importNode:R}=v;let g={};t.isSupported=typeof zt=="function"&&typeof n=="function"&&u&&u.createHTMLDocument!==void 0;const{MUSTACHE_EXPR:y,ERB_EXPR:M,TMPLIT_EXPR:_,DATA_ATTR:x,ARIA_ATTR:O,IS_SCRIPT_OR_DATA:B,ATTR_WHITESPACE:j}=Qt;let{IS_ALLOWED_URI:ie}=Qt,te=null;const ce=je({},[...Ut,...Rt,...Tt,...Lt,...Wt]);let le=null;const oe=je({},[...Vt,...It,...qt,...Et]);let we=Object.seal(Object.create(null,{tagNameCheck:{writable:!0,configurable:!1,enumerable:!0,value:null},attributeNameCheck:{writable:!0,configurable:!1,enumerable:!0,value:null},allowCustomizedBuiltInElements:{writable:!0,configurable:!1,enumerable:!0,value:!1}})),Pe=null,Ae=null,Re=!0,de=!0,ne=!1,fe=!0,Z=!1,V=!1,Y=!1,C=!1,q=!1,$=!1,W=!1,Q=!0,p=!1;const A="user-content-";let E=!0,I=!1,k={},L=null;const S=je({},["annotation-xml","audio","colgroup","desc","foreignobject","head","iframe","math","mi","mn","mo","ms","mtext","noembed","noframes","noscript","plaintext","script","style","svg","template","thead","title","video","xmp"]);let P=null;const H=je({},["audio","video","img","source","image","track"]);let G=null;const ee=je({},["alt","class","for","id","label","name","pattern","placeholder","role","summary","title","value","style","xmlns"]),se="http://www.w3.org/1998/Math/MathML",me="http://www.w3.org/2000/svg",ve="http://www.w3.org/1999/xhtml";let Fe=ve,Ce=!1,De=null;const Te=je({},[se,me,ve],Ot);let Oe;const We=["application/xhtml+xml","text/html"],He="text/html";let Me,Ye=null;const J=i.createElement("form"),he=function(ue){return ue instanceof RegExp||ue instanceof Function},$e=function(ue){if(!(Ye&&Ye===ue)){if((!ue||typeof ue!="object")&&(ue={}),ue=gt(ue),Oe=We.indexOf(ue.PARSER_MEDIA_TYPE)===-1?Oe=He:Oe=ue.PARSER_MEDIA_TYPE,Me=Oe==="application/xhtml+xml"?Ot:Dt,te="ALLOWED_TAGS"in ue?je({},ue.ALLOWED_TAGS,Me):ce,le="ALLOWED_ATTR"in ue?je({},ue.ALLOWED_ATTR,Me):oe,De="ALLOWED_NAMESPACES"in ue?je({},ue.ALLOWED_NAMESPACES,Ot):Te,G="ADD_URI_SAFE_ATTR"in ue?je(gt(ee),ue.ADD_URI_SAFE_ATTR,Me):ee,P="ADD_DATA_URI_TAGS"in ue?je(gt(H),ue.ADD_DATA_URI_TAGS,Me):H,L="FORBID_CONTENTS"in ue?je({},ue.FORBID_CONTENTS,Me):S,Pe="FORBID_TAGS"in ue?je({},ue.FORBID_TAGS,Me):{},Ae="FORBID_ATTR"in ue?je({},ue.FORBID_ATTR,Me):{},k="USE_PROFILES"in ue?ue.USE_PROFILES:!1,Re=ue.ALLOW_ARIA_ATTR!==!1,de=ue.ALLOW_DATA_ATTR!==!1,ne=ue.ALLOW_UNKNOWN_PROTOCOLS||!1,fe=ue.ALLOW_SELF_CLOSE_IN_ATTR!==!1,Z=ue.SAFE_FOR_TEMPLATES||!1,V=ue.WHOLE_DOCUMENT||!1,q=ue.RETURN_DOM||!1,$=ue.RETURN_DOM_FRAGMENT||!1,W=ue.RETURN_TRUSTED_TYPE||!1,C=ue.FORCE_BODY||!1,Q=ue.SANITIZE_DOM!==!1,p=ue.SANITIZE_NAMED_PROPS||!1,E=ue.KEEP_CONTENT!==!1,I=ue.IN_PLACE||!1,ie=ue.ALLOWED_URI_REGEXP||_t,Fe=ue.NAMESPACE||ve,we=ue.CUSTOM_ELEMENT_HANDLING||{},ue.CUSTOM_ELEMENT_HANDLING&&he(ue.CUSTOM_ELEMENT_HANDLING.tagNameCheck)&&(we.tagNameCheck=ue.CUSTOM_ELEMENT_HANDLING.tagNameCheck),ue.CUSTOM_ELEMENT_HANDLING&&he(ue.CUSTOM_ELEMENT_HANDLING.attributeNameCheck)&&(we.attributeNameCheck=ue.CUSTOM_ELEMENT_HANDLING.attributeNameCheck),ue.CUSTOM_ELEMENT_HANDLING&&typeof ue.CUSTOM_ELEMENT_HANDLING.allowCustomizedBuiltInElements=="boolean"&&(we.allowCustomizedBuiltInElements=ue.CUSTOM_ELEMENT_HANDLING.allowCustomizedBuiltInElements),Z&&(de=!1),$&&(q=!0),k&&(te=je({},[...Wt]),le=[],k.html===!0&&(je(te,Ut),je(le,Vt)),k.svg===!0&&(je(te,Rt),je(le,It),je(le,Et)),k.svgFilters===!0&&(je(te,Tt),je(le,It),je(le,Et)),k.mathMl===!0&&(je(te,Lt),je(le,qt),je(le,Et))),ue.ADD_TAGS&&(te===ce&&(te=gt(te)),je(te,ue.ADD_TAGS,Me)),ue.ADD_ATTR&&(le===oe&&(le=gt(le)),je(le,ue.ADD_ATTR,Me)),ue.ADD_URI_SAFE_ATTR&&je(G,ue.ADD_URI_SAFE_ATTR,Me),ue.FORBID_CONTENTS&&(L===S&&(L=gt(L)),je(L,ue.FORBID_CONTENTS,Me)),E&&(te["#text"]=!0),V&&je(te,["html","head","body"]),te.table&&(je(te,["tbody"]),delete Pe.tbody),ue.TRUSTED_TYPES_POLICY){if(typeof ue.TRUSTED_TYPES_POLICY.createHTML!="function")throw $t('TRUSTED_TYPES_POLICY configuration option must provide a "createHTML" hook.');if(typeof ue.TRUSTED_TYPES_POLICY.createScriptURL!="function")throw $t('TRUSTED_TYPES_POLICY configuration option must provide a "createScriptURL" hook.');r=ue.TRUSTED_TYPES_POLICY,b=r.createHTML("")}else r===void 0&&(r=Di(a,N)),r!==null&&typeof b=="string"&&(b=r.createHTML(""));it&&it(ue),Ye=ue}},Ee=je({},["mi","mo","mn","ms","mtext"]),Se=je({},["foreignobject","desc","title","annotation-xml"]),Be=je({},["title","style","font","a","script"]),Ue=je({},Rt);je(Ue,Tt),je(Ue,ci);const Ze=je({},Lt);je(Ze,fi);const Je=function(ue){let ke=n(ue);(!ke||!ke.tagName)&&(ke={namespaceURI:Fe,tagName:"template"});const Ne=Dt(ue.tagName),Ve=Dt(ke.tagName);return De[ue.namespaceURI]?ue.namespaceURI===me?ke.namespaceURI===ve?Ne==="svg":ke.namespaceURI===se?Ne==="svg"&&(Ve==="annotation-xml"||Ee[Ve]):!!Ue[Ne]:ue.namespaceURI===se?ke.namespaceURI===ve?Ne==="math":ke.namespaceURI===me?Ne==="math"&&Se[Ve]:!!Ze[Ne]:ue.namespaceURI===ve?ke.namespaceURI===me&&!Se[Ve]||ke.namespaceURI===se&&!Ee[Ve]?!1:!Ze[Ne]&&(Be[Ne]||!Ue[Ne]):!!(Oe==="application/xhtml+xml"&&De[ue.namespaceURI]):!1},Qe=function(ue){bt(t.removed,{element:ue});try{ue.parentNode.removeChild(ue)}catch{ue.remove()}},qe=function(ue,ke){try{bt(t.removed,{attribute:ke.getAttributeNode(ue),from:ke})}catch{bt(t.removed,{attribute:null,from:ke})}if(ke.removeAttribute(ue),ue==="is"&&!le[ue])if(q||$)try{Qe(ke)}catch{}else try{ke.setAttribute(ue,"")}catch{}},tt=function(ue){let ke,Ne;if(C)ue="<remove></remove>"+ue;else{const st=li(ue,/^[\r\n\t ]+/);Ne=st&&st[0]}Oe==="application/xhtml+xml"&&Fe===ve&&(ue='<html xmlns="http://www.w3.org/1999/xhtml"><head></head><body>'+ue+"</body></html>");const Ve=r?r.createHTML(ue):ue;if(Fe===ve)try{ke=new s().parseFromString(Ve,Oe)}catch{}if(!ke||!ke.documentElement){ke=u.createDocument(Fe,"template",null);try{ke.documentElement.innerHTML=Ce?b:Ve}catch{}}const et=ke.body||ke.documentElement;return ue&&Ne&&et.insertBefore(i.createTextNode(Ne),et.childNodes[0]||null),Fe===ve?z.call(ke,V?"html":"body")[0]:V?ke.documentElement:et},nt=function(ue){return o.call(ue.ownerDocument||ue,ue,f.SHOW_ELEMENT|f.SHOW_COMMENT|f.SHOW_TEXT,null,!1)},dt=function(ue){return ue instanceof T&&(typeof ue.nodeName!="string"||typeof ue.textContent!="string"||typeof ue.removeChild!="function"||!(ue.attributes instanceof d)||typeof ue.removeAttribute!="function"||typeof ue.setAttribute!="function"||typeof ue.namespaceURI!="string"||typeof ue.insertBefore!="function"||typeof ue.hasChildNodes!="function")},ft=function(ue){return typeof D=="object"?ue instanceof D:ue&&typeof ue=="object"&&typeof ue.nodeType=="number"&&typeof ue.nodeName=="string"},ot=function(ue,ke,Ne){g[ue]&&oi(g[ue],Ve=>{Ve.call(t,ke,Ne,Ye)})},At=function(ue){let ke;if(ot("beforeSanitizeElements",ue,null),dt(ue))return Qe(ue),!0;const Ne=Me(ue.nodeName);if(ot("uponSanitizeElement",ue,{tagName:Ne,allowedTags:te}),ue.hasChildNodes()&&!ft(ue.firstElementChild)&&(!ft(ue.content)||!ft(ue.content.firstElementChild))&&lt(/<[/\w]/g,ue.innerHTML)&&lt(/<[/\w]/g,ue.textContent))return Qe(ue),!0;if(!te[Ne]||Pe[Ne]){if(!Pe[Ne]&&pt(Ne)&&(we.tagNameCheck instanceof RegExp&&lt(we.tagNameCheck,Ne)||we.tagNameCheck instanceof Function&&we.tagNameCheck(Ne)))return!1;if(E&&!L[Ne]){const Ve=n(ue)||ue.parentNode,et=m(ue)||ue.childNodes;if(et&&Ve){const st=et.length;for(let Ke=st-1;Ke>=0;--Ke)Ve.insertBefore(h(et[Ke],!0),l(ue))}}return Qe(ue),!0}return ue instanceof c&&!Je(ue)||(Ne==="noscript"||Ne==="noembed"||Ne==="noframes")&&lt(/<\/no(script|embed|frames)/i,ue.innerHTML)?(Qe(ue),!0):(Z&&ue.nodeType===3&&(ke=ue.textContent,ke=ct(ke,y," "),ke=ct(ke,M," "),ke=ct(ke,_," "),ue.textContent!==ke&&(bt(t.removed,{element:ue.cloneNode()}),ue.textContent=ke)),ot("afterSanitizeElements",ue,null),!1)},kt=function(ue,ke,Ne){if(Q&&(ke==="id"||ke==="name")&&(Ne in i||Ne in J))return!1;if(!(de&&!Ae[ke]&&lt(x,ke))){if(!(Re&&lt(O,ke))){if(!le[ke]||Ae[ke]){if(!(pt(ue)&&(we.tagNameCheck instanceof RegExp&&lt(we.tagNameCheck,ue)||we.tagNameCheck instanceof Function&&we.tagNameCheck(ue))&&(we.attributeNameCheck instanceof RegExp&&lt(we.attributeNameCheck,ke)||we.attributeNameCheck instanceof Function&&we.attributeNameCheck(ke))||ke==="is"&&we.allowCustomizedBuiltInElements&&(we.tagNameCheck instanceof RegExp&&lt(we.tagNameCheck,Ne)||we.tagNameCheck instanceof Function&&we.tagNameCheck(Ne))))return!1}else if(!G[ke]){if(!lt(ie,ct(Ne,j,""))){if(!((ke==="src"||ke==="xlink:href"||ke==="href")&&ue!=="script"&&ai(Ne,"data:")===0&&P[ue])){if(!(ne&&!lt(B,ct(Ne,j,"")))){if(Ne)return!1}}}}}}return!0},pt=function(ue){return ue.indexOf("-")>0},Ct=function(ue){let ke,Ne,Ve,et;ot("beforeSanitizeAttributes",ue,null);const{attributes:st}=ue;if(!st)return;const Ke={attrName:"",attrValue:"",keepAttr:!0,allowedAttributes:le};for(et=st.length;et--;){ke=st[et];const{name:ht,namespaceURI:wt}=ke;if(Ne=ht==="value"?ke.value:hi(ke.value),Ve=Me(ht),Ke.attrName=Ve,Ke.attrValue=Ne,Ke.keepAttr=!0,Ke.forceKeepAttr=void 0,ot("uponSanitizeAttribute",ue,Ke),Ne=Ke.attrValue,Ke.forceKeepAttr||(qe(ht,ue),!Ke.keepAttr))continue;if(!fe&&lt(/\/>/i,Ne)){qe(ht,ue);continue}Z&&(Ne=ct(Ne,y," "),Ne=ct(Ne,M," "),Ne=ct(Ne,_," "));const St=Me(ue.nodeName);if(kt(St,Ve,Ne)){if(p&&(Ve==="id"||Ve==="name")&&(qe(ht,ue),Ne=A+Ne),r&&typeof a=="object"&&typeof a.getAttributeType=="function"&&!wt)switch(a.getAttributeType(St,Ve)){case"TrustedHTML":{Ne=r.createHTML(Ne);break}case"TrustedScriptURL":{Ne=r.createScriptURL(Ne);break}}try{wt?ue.setAttributeNS(wt,ht,Ne):ue.setAttribute(ht,Ne),Ht(t.removed)}catch{}}}ot("afterSanitizeAttributes",ue,null)},Mt=function Ie(ue){let ke;const Ne=nt(ue);for(ot("beforeSanitizeShadowDOM",ue,null);ke=Ne.nextNode();)ot("uponSanitizeShadowNode",ke,null),!At(ke)&&(ke.content instanceof U&&Ie(ke.content),Ct(ke));ot("afterSanitizeShadowDOM",ue,null)};return t.sanitize=function(Ie){let ue=arguments.length>1&&arguments[1]!==void 0?arguments[1]:{},ke,Ne,Ve,et;if(Ce=!Ie,Ce&&(Ie="<!-->"),typeof Ie!="string"&&!ft(Ie))if(typeof Ie.toString=="function"){if(Ie=Ie.toString(),typeof Ie!="string")throw $t("dirty is not a string, aborting")}else throw $t("toString is not a function");if(!t.isSupported)return Ie;if(Y||$e(ue),t.removed=[],typeof Ie=="string"&&(I=!1),I){if(Ie.nodeName){const ht=Me(Ie.nodeName);if(!te[ht]||Pe[ht])throw $t("root node is forbidden and cannot be sanitized in-place")}}else if(Ie instanceof D)ke=tt("<!---->"),Ne=ke.ownerDocument.importNode(Ie,!0),Ne.nodeType===1&&Ne.nodeName==="BODY"||Ne.nodeName==="HTML"?ke=Ne:ke.appendChild(Ne);else{if(!q&&!Z&&!V&&Ie.indexOf("<")===-1)return r&&W?r.createHTML(Ie):Ie;if(ke=tt(Ie),!ke)return q?null:W?b:""}ke&&C&&Qe(ke.firstChild);const st=nt(I?Ie:ke);for(;Ve=st.nextNode();)At(Ve)||(Ve.content instanceof U&&Mt(Ve.content),Ct(Ve));if(I)return Ie;if(q){if($)for(et=F.call(ke.ownerDocument);ke.firstChild;)et.appendChild(ke.firstChild);else et=ke;return(le.shadowroot||le.shadowrootmode)&&(et=R.call(v,et,!0)),et}let Ke=V?ke.outerHTML:ke.innerHTML;return V&&te["!doctype"]&&ke.ownerDocument&&ke.ownerDocument.doctype&&ke.ownerDocument.doctype.name&&lt(Kt,ke.ownerDocument.doctype.name)&&(Ke="<!DOCTYPE "+ke.ownerDocument.doctype.name+`>
`+Ke),Z&&(Ke=ct(Ke,y," "),Ke=ct(Ke,M," "),Ke=ct(Ke,_," ")),r&&W?r.createHTML(Ke):Ke},t.setConfig=function(Ie){$e(Ie),Y=!0},t.clearConfig=function(){Ye=null,Y=!1},t.isValidAttribute=function(Ie,ue,ke){Ye||$e({});const Ne=Me(Ie),Ve=Me(ue);return kt(Ne,Ve,ke)},t.addHook=function(Ie,ue){typeof ue=="function"&&(g[Ie]=g[Ie]||[],bt(g[Ie],ue))},t.removeHook=function(Ie){if(g[Ie])return Ht(g[Ie])},t.removeHooks=function(Ie){g[Ie]&&(g[Ie]=[])},t.removeAllHooks=function(){g={}},t}var yi=xt();define("vs/base/browser/dompurify/dompurify",function(){return yi}),define(be[41],pe([1,0]),function(ae,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$BQ=t.$AQ=void 0;class v{constructor(w){this.domNode=w,this.a="",this.b="",this.c="",this.d="",this.e="",this.f="",this.g="",this.h="",this.i="",this.j="",this.k="",this.l="",this.m="",this.n="",this.o="",this.p="",this.q="",this.r="",this.s="",this.t="",this.u="",this.v="",this.w="",this.x="",this.y="",this.z="",this.A=!1,this.B="none",this.C=""}setMaxWidth(w){const D=N(w);this.a!==D&&(this.a=D,this.domNode.style.maxWidth=this.a)}setWidth(w){const D=N(w);this.b!==D&&(this.b=D,this.domNode.style.width=this.b)}setHeight(w){const D=N(w);this.c!==D&&(this.c=D,this.domNode.style.height=this.c)}setTop(w){const D=N(w);this.d!==D&&(this.d=D,this.domNode.style.top=this.d)}setLeft(w){const D=N(w);this.e!==D&&(this.e=D,this.domNode.style.left=this.e)}setBottom(w){const D=N(w);this.f!==D&&(this.f=D,this.domNode.style.bottom=this.f)}setRight(w){const D=N(w);this.g!==D&&(this.g=D,this.domNode.style.right=this.g)}setPaddingTop(w){const D=N(w);this.h!==D&&(this.h=D,this.domNode.style.paddingTop=this.h)}setPaddingLeft(w){const D=N(w);this.i!==D&&(this.i=D,this.domNode.style.paddingLeft=this.i)}setPaddingBottom(w){const D=N(w);this.j!==D&&(this.j=D,this.domNode.style.paddingBottom=this.j)}setPaddingRight(w){const D=N(w);this.k!==D&&(this.k=D,this.domNode.style.paddingRight=this.k)}setFontFamily(w){this.l!==w&&(this.l=w,this.domNode.style.fontFamily=this.l)}setFontWeight(w){this.m!==w&&(this.m=w,this.domNode.style.fontWeight=this.m)}setFontSize(w){const D=N(w);this.n!==D&&(this.n=D,this.domNode.style.fontSize=this.n)}setFontStyle(w){this.o!==w&&(this.o=w,this.domNode.style.fontStyle=this.o)}setFontFeatureSettings(w){this.p!==w&&(this.p=w,this.domNode.style.fontFeatureSettings=this.p)}setFontVariationSettings(w){this.q!==w&&(this.q=w,this.domNode.style.fontVariationSettings=this.q)}setTextDecoration(w){this.r!==w&&(this.r=w,this.domNode.style.textDecoration=this.r)}setLineHeight(w){const D=N(w);this.s!==D&&(this.s=D,this.domNode.style.lineHeight=this.s)}setLetterSpacing(w){const D=N(w);this.t!==D&&(this.t=D,this.domNode.style.letterSpacing=this.t)}setClassName(w){this.u!==w&&(this.u=w,this.domNode.className=this.u)}toggleClassName(w,D){this.domNode.classList.toggle(w,D),this.u=this.domNode.className}setDisplay(w){this.v!==w&&(this.v=w,this.domNode.style.display=this.v)}setPosition(w){this.w!==w&&(this.w=w,this.domNode.style.position=this.w)}setVisibility(w){this.x!==w&&(this.x=w,this.domNode.style.visibility=this.x)}setColor(w){this.y!==w&&(this.y=w,this.domNode.style.color=this.y)}setBackgroundColor(w){this.z!==w&&(this.z=w,this.domNode.style.backgroundColor=this.z)}setLayerHinting(w){this.A!==w&&(this.A=w,this.domNode.style.transform=this.A?"translate3d(0px, 0px, 0px)":"")}setBoxShadow(w){this.C!==w&&(this.C=w,this.domNode.style.boxShadow=w)}setContain(w){this.B!==w&&(this.B=w,this.domNode.style.contain=this.B)}setAttribute(w,D){this.domNode.setAttribute(w,D)}removeAttribute(w){this.domNode.removeAttribute(w)}appendChild(w){this.domNode.appendChild(w.domNode)}removeChild(w){this.domNode.removeChild(w.domNode)}}t.$AQ=v;function N(U){return typeof U=="number"?`${U}px`:U}function i(U){return new v(U)}t.$BQ=i}),define(be[69],pe([1,0]),function(ae,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$TO=t.$SO=void 0;const v=new WeakMap;function N(D){if(!D.parent||D.parent===D)return null;try{const c=D.location,f=D.parent.location;if(c.origin!=="null"&&f.origin!=="null"&&c.origin!==f.origin)return null}catch{return null}return D.parent}class i{static a(c){let f=v.get(c);if(!f){f=[],v.set(c,f);let d=c,T;do T=N(d),T?f.push({window:new WeakRef(d),iframeElement:d.frameElement||null}):f.push({window:new WeakRef(d),iframeElement:null}),d=T;while(d)}return f.slice(0)}static getPositionOfChildWindowRelativeToAncestorWindow(c,f){if(!f||c===f)return{top:0,left:0};let d=0,T=0;const s=this.a(c);for(const a of s){const e=a.window.deref();if(d+=e?.scrollY??0,T+=e?.scrollX??0,e===f||!a.iframeElement)break;const h=a.iframeElement.getBoundingClientRect();d+=h.top,T+=h.left}return{top:d,left:T}}}t.$SO=i;async function U(D,c){if(!crypto.subtle)throw new Error("'crypto.subtle' is not available so webviews will not work. This is likely because the editor is not running in a secure context (https://developer.mozilla.org/en-US/docs/Web/Security/Secure_Contexts).");const f=JSON.stringify({parentOrigin:D,salt:c}),T=new TextEncoder().encode(f),s=await crypto.subtle.digest("sha-256",T);return w(s)}t.$TO=U;function w(D){const f=Array.from(new Uint8Array(D)).map(d=>d.toString(16).padStart(2,"0")).join("");return BigInt(`0x${f}`).toString(32).padStart(52,"0")}}),define(be[70],pe([1,0]),function(ae,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$$Q=t.$0Q=t.$9Q=t.ListDragOverEffect=void 0;var v;(function(U){U[U.Copy=0]="Copy",U[U.Move=1]="Move"})(v||(t.ListDragOverEffect=v={})),t.$9Q={reject(){return{accept:!1}},accept(){return{accept:!0}}};class N extends Error{constructor(w,D){super(`ListError [${w}] ${D}`)}}t.$0Q=N;class i{constructor(){this.c=new WeakMap}getHeight(w){return this.c.get(w)??this.d(w)}setDynamicHeight(w,D){D>0&&this.c.set(w,D)}}t.$$Q=i}),define(be[71],pe([1,0]),function(ae,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$8Q=void 0;class v{constructor(i){this.a=i}splice(i,U,w){this.a.forEach(D=>D.splice(i,U,w))}}t.$8Q=v}),define(be[42],pe([1,0]),function(ae,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$GQ=void 0;const v=20;class N{constructor(U,w,D,c,f,d){this.a=Math.round(w),this.b=Math.round(D),this.c=Math.round(U),this.d=c,this.e=f,this.f=d,this.g=0,this.h=!1,this.i=0,this.j=0,this.k=0,this.m()}clone(){return new N(this.c,this.a,this.b,this.d,this.e,this.f)}setVisibleSize(U){const w=Math.round(U);return this.d!==w?(this.d=w,this.m(),!0):!1}setScrollSize(U){const w=Math.round(U);return this.e!==w?(this.e=w,this.m(),!0):!1}setScrollPosition(U){const w=Math.round(U);return this.f!==w?(this.f=w,this.m(),!0):!1}setScrollbarSize(U){this.a=Math.round(U)}setOppositeScrollbarSize(U){this.b=Math.round(U)}static l(U,w,D,c,f){const d=Math.max(0,D-U),T=Math.max(0,d-2*w),s=c>0&&c>D;if(!s)return{computedAvailableSize:Math.round(d),computedIsNeeded:s,computedSliderSize:Math.round(T),computedSliderRatio:0,computedSliderPosition:0};const a=Math.round(Math.max(v,Math.floor(D*T/c))),e=(T-a)/(c-D),h=f*e;return{computedAvailableSize:Math.round(d),computedIsNeeded:s,computedSliderSize:Math.round(a),computedSliderRatio:e,computedSliderPosition:Math.round(h)}}m(){const U=N.l(this.b,this.c,this.d,this.e,this.f);this.g=U.computedAvailableSize,this.h=U.computedIsNeeded,this.i=U.computedSliderSize,this.j=U.computedSliderRatio,this.k=U.computedSliderPosition}getArrowSize(){return this.c}getScrollPosition(){return this.f}getRectangleLargeSize(){return this.g}getRectangleSmallSize(){return this.a}isNeeded(){return this.h}getSliderSize(){return this.i}getSliderPosition(){return this.k}getDesiredScrollPositionFromOffset(U){if(!this.h)return 0;const w=U-this.c-this.i/2;return Math.round(w/this.j)}getDesiredScrollPositionFromOffsetPaged(U){if(!this.h)return 0;const w=U-this.c;let D=this.f;return w<this.k?D-=this.d:D+=this.d,D}getDesiredScrollPositionFromDelta(U){if(!this.h)return 0;const w=this.k+U;return Math.round(w/this.j)}}t.$GQ=N}),define(be[25],pe([1,0]),function(ae,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$5S=t.$4S=t.$3S=t.TreeDragOverBubble=t.TreeMouseEventTarget=t.ObjectTreeElementCollapseState=t.TreeVisibility=void 0;var v;(function(c){c[c.Hidden=0]="Hidden",c[c.Visible=1]="Visible",c[c.Recurse=2]="Recurse"})(v||(t.TreeVisibility=v={}));var N;(function(c){c[c.Expanded=0]="Expanded",c[c.Collapsed=1]="Collapsed",c[c.PreserveOrExpanded=2]="PreserveOrExpanded",c[c.PreserveOrCollapsed=3]="PreserveOrCollapsed"})(N||(t.ObjectTreeElementCollapseState=N={}));var i;(function(c){c[c.Unknown=0]="Unknown",c[c.Twistie=1]="Twistie",c[c.Element=2]="Element",c[c.Filter=3]="Filter"})(i||(t.TreeMouseEventTarget=i={}));var U;(function(c){c[c.Down=0]="Down",c[c.Up=1]="Up"})(U||(t.TreeDragOverBubble=U={})),t.$3S={acceptBubbleUp(){return{accept:!0,bubble:1}},acceptBubbleDown(c=!1){return{accept:!0,bubble:0,autoExpand:c}},acceptCopyBubbleUp(){return{accept:!0,bubble:1,effect:0}},acceptCopyBubbleDown(c=!1){return{accept:!0,bubble:0,effect:0,autoExpand:c}}};class w extends Error{constructor(f,d){super(`TreeError [${f}] ${d}`)}}t.$4S=w;class D{constructor(f){this.a=f,this.b=new WeakMap}map(f){let d=this.b.get(f);return d||(d=this.a(f),this.b.set(f,d)),d}}t.$5S=D}),define(be[21],pe([1,0]),function(ae,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$xO=t.$window=t.$vO=t.$uO=void 0;function v(i,U){const w=i;typeof w.vscodeWindowId!="number"&&Object.defineProperty(w,"vscodeWindowId",{get:()=>U})}t.$uO=v,t.$vO=window,t.$window=t.$vO;function N(i){return i===t.$vO?!1:typeof i?.vscodeWindowId=="number"}t.$xO=N}),define(be[72],pe([1,0]),function(ae,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$qb=t.$pb=t.$ob=t.$nb=t.$mb=t.$lb=t.$kb=t.$jb=t.$ib=t.$hb=t.$gb=t.$fb=t.$eb=void 0;function v(h,l,m){const n=N(h,l);if(n!==-1)return h[n]}t.$eb=v;function N(h,l,m=h.length-1){for(let n=m;n>=0;n--){const r=h[n];if(l(r))return n}return-1}t.$fb=N;function i(h,l){const m=U(h,l);return m===-1?void 0:h[m]}t.$gb=i;function U(h,l,m=0,n=h.length){let r=m,b=n;for(;r<b;){const u=Math.floor((r+b)/2);l(h[u])?r=u+1:b=u}return r-1}t.$hb=U;function w(h,l){const m=D(h,l);return m===h.length?void 0:h[m]}t.$ib=w;function D(h,l,m=0,n=h.length){let r=m,b=n;for(;r<b;){const u=Math.floor((r+b)/2);l(h[u])?b=u:r=u+1}return r}t.$jb=D;function c(h,l,m=0,n=h.length){const r=D(h,l,m,n);return r===h.length?-1:r}t.$kb=c;class f{static{this.assertInvariants=!1}constructor(l){this.e=l,this.c=0}findLastMonotonous(l){if(f.assertInvariants){if(this.d){for(const n of this.e)if(this.d(n)&&!l(n))throw new Error("MonotonousArray: current predicate must be weaker than (or equal to) the previous predicate.")}this.d=l}const m=U(this.e,l,this.c);return this.c=m+1,m===-1?void 0:this.e[m]}}t.$lb=f;function d(h,l){if(h.length===0)return;let m=h[0];for(let n=1;n<h.length;n++){const r=h[n];l(r,m)>0&&(m=r)}return m}t.$mb=d;function T(h,l){if(h.length===0)return;let m=h[0];for(let n=1;n<h.length;n++){const r=h[n];l(r,m)>=0&&(m=r)}return m}t.$nb=T;function s(h,l){return d(h,(m,n)=>-l(m,n))}t.$ob=s;function a(h,l){if(h.length===0)return-1;let m=0;for(let n=1;n<h.length;n++){const r=h[n];l(r,h[m])>0&&(m=n)}return m}t.$pb=a;function e(h,l){for(const m of h){const n=l(m);if(n!==void 0)return n}}t.$qb=e}),define(be[73],pe([1,0]),function(ae,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$M=t.$L=t.$K=t.$J=void 0;function v(w,D){const c=Object.create(null);for(const f of w){const d=D(f);let T=c[d];T||(T=c[d]=[]),T.push(f)}return c}t.$J=v;function N(w,D){const c=[],f=[];for(const d of w)D.has(d)||c.push(d);for(const d of D)w.has(d)||f.push(d);return{removed:c,added:f}}t.$K=N;function i(w,D){const c=[],f=[];for(const[d,T]of w)D.has(d)||c.push(T);for(const[d,T]of D)w.has(d)||f.push(T);return{removed:c,added:f}}t.$L=i;function U(w,D){const c=new Set;for(const f of D)w.has(f)&&c.add(f);return c}t.$M=U}),define(be[74],pe([1,0]),function(ae,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$4s=t.$3s=t.$2s=t.$1s=void 0;function v(D,c){const f=Math.pow(10,c);return Math.round(D*f)/f}class N{constructor(c,f,d,T=1){this._rgbaBrand=void 0,this.r=Math.min(255,Math.max(0,c))|0,this.g=Math.min(255,Math.max(0,f))|0,this.b=Math.min(255,Math.max(0,d))|0,this.a=v(Math.max(Math.min(1,T),0),3)}static equals(c,f){return c.r===f.r&&c.g===f.g&&c.b===f.b&&c.a===f.a}}t.$1s=N;class i{constructor(c,f,d,T){this._hslaBrand=void 0,this.h=Math.max(Math.min(360,c),0)|0,this.s=v(Math.max(Math.min(1,f),0),3),this.l=v(Math.max(Math.min(1,d),0),3),this.a=v(Math.max(Math.min(1,T),0),3)}static equals(c,f){return c.h===f.h&&c.s===f.s&&c.l===f.l&&c.a===f.a}static fromRGBA(c){const f=c.r/255,d=c.g/255,T=c.b/255,s=c.a,a=Math.max(f,d,T),e=Math.min(f,d,T);let h=0,l=0;const m=(e+a)/2,n=a-e;if(n>0){switch(l=Math.min(m<=.5?n/(2*m):n/(2-2*m),1),a){case f:h=(d-T)/n+(d<T?6:0);break;case d:h=(T-f)/n+2;break;case T:h=(f-d)/n+4;break}h*=60,h=Math.round(h)}return new i(h,l,m,s)}static i(c,f,d){return d<0&&(d+=1),d>1&&(d-=1),d<1/6?c+(f-c)*6*d:d<1/2?f:d<2/3?c+(f-c)*(2/3-d)*6:c}static toRGBA(c){const f=c.h/360,{s:d,l:T,a:s}=c;let a,e,h;if(d===0)a=e=h=T;else{const l=T<.5?T*(1+d):T+d-T*d,m=2*T-l;a=i.i(m,l,f+1/3),e=i.i(m,l,f),h=i.i(m,l,f-1/3)}return new N(Math.round(a*255),Math.round(e*255),Math.round(h*255),s)}}t.$2s=i;class U{constructor(c,f,d,T){this._hsvaBrand=void 0,this.h=Math.max(Math.min(360,c),0)|0,this.s=v(Math.max(Math.min(1,f),0),3),this.v=v(Math.max(Math.min(1,d),0),3),this.a=v(Math.max(Math.min(1,T),0),3)}static equals(c,f){return c.h===f.h&&c.s===f.s&&c.v===f.v&&c.a===f.a}static fromRGBA(c){const f=c.r/255,d=c.g/255,T=c.b/255,s=Math.max(f,d,T),a=Math.min(f,d,T),e=s-a,h=s===0?0:e/s;let l;return e===0?l=0:s===f?l=((d-T)/e%6+6)%6:s===d?l=(T-f)/e+2:l=(f-d)/e+4,new U(Math.round(l*60),h,s,c.a)}static toRGBA(c){const{h:f,s:d,v:T,a:s}=c,a=T*d,e=a*(1-Math.abs(f/60%2-1)),h=T-a;let[l,m,n]=[0,0,0];return f<60?(l=a,m=e):f<120?(l=e,m=a):f<180?(m=a,n=e):f<240?(m=e,n=a):f<300?(l=e,n=a):f<=360&&(l=a,n=e),l=Math.round((l+h)*255),m=Math.round((m+h)*255),n=Math.round((n+h)*255),new N(l,m,n,s)}}t.$3s=U;class w{static fromHex(c){return w.Format.CSS.parseHex(c)||w.red}static equals(c,f){return!c&&!f?!0:!c||!f?!1:c.equals(f)}get hsla(){return this.i?this.i:i.fromRGBA(this.rgba)}get hsva(){return this.j?this.j:U.fromRGBA(this.rgba)}constructor(c){if(c)if(c instanceof N)this.rgba=c;else if(c instanceof i)this.i=c,this.rgba=i.toRGBA(c);else if(c instanceof U)this.j=c,this.rgba=U.toRGBA(c);else throw new Error("Invalid color ctor argument");else throw new Error("Color needs a value")}equals(c){return!!c&&N.equals(this.rgba,c.rgba)&&i.equals(this.hsla,c.hsla)&&U.equals(this.hsva,c.hsva)}getRelativeLuminance(){const c=w.k(this.rgba.r),f=w.k(this.rgba.g),d=w.k(this.rgba.b),T=.2126*c+.7152*f+.0722*d;return v(T,4)}static k(c){const f=c/255;return f<=.03928?f/12.92:Math.pow((f+.055)/1.055,2.4)}getContrastRatio(c){const f=this.getRelativeLuminance(),d=c.getRelativeLuminance();return f>d?(f+.05)/(d+.05):(d+.05)/(f+.05)}isDarker(){return(this.rgba.r*299+this.rgba.g*587+this.rgba.b*114)/1e3<128}isLighter(){return(this.rgba.r*299+this.rgba.g*587+this.rgba.b*114)/1e3>=128}isLighterThan(c){const f=this.getRelativeLuminance(),d=c.getRelativeLuminance();return f>d}isDarkerThan(c){const f=this.getRelativeLuminance(),d=c.getRelativeLuminance();return f<d}lighten(c){return new w(new i(this.hsla.h,this.hsla.s,this.hsla.l+this.hsla.l*c,this.hsla.a))}darken(c){return new w(new i(this.hsla.h,this.hsla.s,this.hsla.l-this.hsla.l*c,this.hsla.a))}transparent(c){const{r:f,g:d,b:T,a:s}=this.rgba;return new w(new N(f,d,T,s*c))}isTransparent(){return this.rgba.a===0}isOpaque(){return this.rgba.a===1}opposite(){return new w(new N(255-this.rgba.r,255-this.rgba.g,255-this.rgba.b,this.rgba.a))}blend(c){const f=c.rgba,d=this.rgba.a,T=f.a,s=d+T*(1-d);if(s<1e-6)return w.transparent;const a=this.rgba.r*d/s+f.r*T*(1-d)/s,e=this.rgba.g*d/s+f.g*T*(1-d)/s,h=this.rgba.b*d/s+f.b*T*(1-d)/s;return new w(new N(a,e,h,s))}makeOpaque(c){if(this.isOpaque()||c.rgba.a!==1)return this;const{r:f,g:d,b:T,a:s}=this.rgba;return new w(new N(c.rgba.r-s*(c.rgba.r-f),c.rgba.g-s*(c.rgba.g-d),c.rgba.b-s*(c.rgba.b-T),1))}flatten(...c){const f=c.reduceRight((d,T)=>w.o(T,d));return w.o(this,f)}static o(c,f){const d=1-c.rgba.a;return new w(new N(d*f.rgba.r+c.rgba.a*c.rgba.r,d*f.rgba.g+c.rgba.a*c.rgba.g,d*f.rgba.b+c.rgba.a*c.rgba.b))}toString(){return this.u||(this.u=w.Format.CSS.format(this)),this.u}static getLighterColor(c,f,d){if(c.isLighterThan(f))return c;d=d||.5;const T=c.getRelativeLuminance(),s=f.getRelativeLuminance();return d=d*(s-T)/s,c.lighten(d)}static getDarkerColor(c,f,d){if(c.isDarkerThan(f))return c;d=d||.5;const T=c.getRelativeLuminance(),s=f.getRelativeLuminance();return d=d*(T-s)/T,c.darken(d)}static{this.white=new w(new N(255,255,255,1))}static{this.black=new w(new N(0,0,0,1))}static{this.red=new w(new N(255,0,0,1))}static{this.blue=new w(new N(0,0,255,1))}static{this.green=new w(new N(0,255,0,1))}static{this.cyan=new w(new N(0,255,255,1))}static{this.lightgrey=new w(new N(211,211,211,1))}static{this.transparent=new w(new N(0,0,0,0))}}t.$4s=w,function(D){let c;(function(f){let d;(function(T){function s(o){return o.rgba.a===1?`rgb(${o.rgba.r}, ${o.rgba.g}, ${o.rgba.b})`:D.Format.CSS.formatRGBA(o)}T.formatRGB=s;function a(o){return`rgba(${o.rgba.r}, ${o.rgba.g}, ${o.rgba.b}, ${+o.rgba.a.toFixed(2)})`}T.formatRGBA=a;function e(o){return o.hsla.a===1?`hsl(${o.hsla.h}, ${(o.hsla.s*100).toFixed(2)}%, ${(o.hsla.l*100).toFixed(2)}%)`:D.Format.CSS.formatHSLA(o)}T.formatHSL=e;function h(o){return`hsla(${o.hsla.h}, ${(o.hsla.s*100).toFixed(2)}%, ${(o.hsla.l*100).toFixed(2)}%, ${o.hsla.a.toFixed(2)})`}T.formatHSLA=h;function l(o){const F=o.toString(16);return F.length!==2?"0"+F:F}function m(o){return`#${l(o.rgba.r)}${l(o.rgba.g)}${l(o.rgba.b)}`}T.formatHex=m;function n(o,F=!1){return F&&o.rgba.a===1?D.Format.CSS.formatHex(o):`#${l(o.rgba.r)}${l(o.rgba.g)}${l(o.rgba.b)}${l(Math.round(o.rgba.a*255))}`}T.formatHexA=n;function r(o){return o.isOpaque()?D.Format.CSS.formatHex(o):D.Format.CSS.formatRGBA(o)}T.format=r;function b(o){const F=o.length;if(F===0||o.charCodeAt(0)!==35)return null;if(F===7){const z=16*u(o.charCodeAt(1))+u(o.charCodeAt(2)),R=16*u(o.charCodeAt(3))+u(o.charCodeAt(4)),g=16*u(o.charCodeAt(5))+u(o.charCodeAt(6));return new D(new N(z,R,g,1))}if(F===9){const z=16*u(o.charCodeAt(1))+u(o.charCodeAt(2)),R=16*u(o.charCodeAt(3))+u(o.charCodeAt(4)),g=16*u(o.charCodeAt(5))+u(o.charCodeAt(6)),y=16*u(o.charCodeAt(7))+u(o.charCodeAt(8));return new D(new N(z,R,g,y/255))}if(F===4){const z=u(o.charCodeAt(1)),R=u(o.charCodeAt(2)),g=u(o.charCodeAt(3));return new D(new N(16*z+z,16*R+R,16*g+g))}if(F===5){const z=u(o.charCodeAt(1)),R=u(o.charCodeAt(2)),g=u(o.charCodeAt(3)),y=u(o.charCodeAt(4));return new D(new N(16*z+z,16*R+R,16*g+g,(16*y+y)/255))}return null}T.parseHex=b;function u(o){switch(o){case 48:return 0;case 49:return 1;case 50:return 2;case 51:return 3;case 52:return 4;case 53:return 5;case 54:return 6;case 55:return 7;case 56:return 8;case 57:return 9;case 97:return 10;case 65:return 10;case 98:return 11;case 66:return 11;case 99:return 12;case 67:return 12;case 100:return 13;case 68:return 13;case 101:return 14;case 69:return 14;case 102:return 15;case 70:return 15}return 0}})(d=f.CSS||(f.CSS={}))})(c=D.Format||(D.Format={}))}(w||(t.$4s=w={}))}),define(be[26],pe([1,0]),function(ae,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$ph=t.$oh=t.$nh=void 0;function v(w){return(D,c,f)=>{let d=null,T=null;if(typeof f.value=="function"?(d="value",T=f.value):typeof f.get=="function"&&(d="get",T=f.get),!T)throw new Error("not supported");f[d]=w(T,c)}}function N(w,D,c){let f=null,d=null;if(typeof c.value=="function"?(f="value",d=c.value,d.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof c.get=="function"&&(f="get",d=c.get),!d)throw new Error("not supported");const T=`$memoize$${D}`;c[f]=function(...s){return this.hasOwnProperty(T)||Object.defineProperty(this,T,{configurable:!1,enumerable:!1,writable:!1,value:d.apply(this,s)}),this[T]}}t.$nh=N;function i(w,D,c){return v((f,d)=>{const T=`$debounce$${d}`,s=`$debounce$result$${d}`;return function(...a){this[s]||(this[s]=c?c():void 0),clearTimeout(this[T]),D&&(this[s]=D(this[s],...a),a=[this[s]]),this[T]=setTimeout(()=>{f.apply(this,a),this[s]=c?c():void 0},w)}})}t.$oh=i;function U(w,D,c){return v((f,d)=>{const T=`$throttle$timer$${d}`,s=`$throttle$result$${d}`,a=`$throttle$lastRun$${d}`,e=`$throttle$pending$${d}`;return function(...h){if(this[s]||(this[s]=c?c():void 0),(this[a]===null||this[a]===void 0)&&(this[a]=-Number.MAX_VALUE),D&&(this[s]=D(this[s],...h)),this[e])return;const l=this[a]+w;l<=Date.now()?(this[a]=Date.now(),f.apply(this,[this[s]]),this[s]=c?c():void 0):(this[e]=!0,this[T]=setTimeout(()=>{this[e]=!1,this[a]=Date.now(),f.apply(this,[this[s]]),this[s]=c?c():void 0},l-Date.now()))}})}t.$ph=U}),define(be[75],pe([1,0]),function(ae,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Cs=void 0;class v{constructor(i,U,w,D){this.originalStart=i,this.originalLength=U,this.modifiedStart=w,this.modifiedLength=D}getOriginalEnd(){return this.originalStart+this.originalLength}getModifiedEnd(){return this.modifiedStart+this.modifiedLength}}t.$Cs=v}),define(be[6],pe([1,0]),function(ae,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$bb=t.$ab=t.$_=t.$$=t.$0=t.$9=t.$8=t.$7=t.$6=t.$5=t.$4=t.$3=t.$2=t.$1=t.$Z=t.$Y=t.setUnexpectedErrorHandler=t.$W=t.$V=void 0;class v{constructor(){this.b=[],this.a=function(o){setTimeout(()=>{throw o.stack?r.isErrorNoTelemetry(o)?new r(o.message+`

`+o.stack):new Error(o.message+`

`+o.stack):o},0)}}addListener(o){return this.b.push(o),()=>{this.d(o)}}c(o){this.b.forEach(F=>{F(o)})}d(o){this.b.splice(this.b.indexOf(o),1)}setUnexpectedErrorHandler(o){this.a=o}getUnexpectedErrorHandler(){return this.a}onUnexpectedError(o){this.a(o),this.c(o)}onUnexpectedExternalError(o){this.a(o)}}t.$V=v,t.$W=new v;function N(u){t.$W.setUnexpectedErrorHandler(u)}t.setUnexpectedErrorHandler=N;function i(u){if(!u||typeof u!="object")return!1;const o=u;return o.code==="EPIPE"&&o.syscall?.toUpperCase()==="WRITE"}t.$Y=i;function U(u){f(u)||t.$W.onUnexpectedError(u)}t.$Z=U;function w(u){f(u)||t.$W.onUnexpectedExternalError(u)}t.$1=w;function D(u){if(u instanceof Error){const{name:o,message:F}=u,z=u.stacktrace||u.stack;return{$isError:!0,name:o,message:F,stack:z,noTelemetry:r.isErrorNoTelemetry(u)}}return u}t.$2=D;const c="Canceled";function f(u){return u instanceof d?!0:u instanceof Error&&u.name===c&&u.message===c}t.$3=f;class d extends Error{constructor(){super(c),this.name=this.message}}t.$4=d;function T(){const u=new Error(c);return u.name=u.message,u}t.$5=T;function s(u){return u?new Error(`Illegal argument: ${u}`):new Error("Illegal argument")}t.$6=s;function a(u){return u?new Error(`Illegal state: ${u}`):new Error("Illegal state")}t.$7=a;class e extends TypeError{constructor(o){super(o?`${o} is read-only and cannot be changed`:"Cannot change read-only property")}}t.$8=e;function h(u){return u?u.message?u.message:u.stack?u.stack.split(`
`)[0]:String(u):"Error"}t.$9=h;class l extends Error{constructor(o){super("NotImplemented"),o&&(this.message=o)}}t.$0=l;class m extends Error{constructor(o){super("NotSupported"),o&&(this.message=o)}}t.$$=m;class n extends Error{constructor(){super(...arguments),this.isExpected=!0}}t.$_=n;class r extends Error{constructor(o){super(o),this.name="CodeExpectedError"}static fromError(o){if(o instanceof r)return o;const F=new r;return F.message=o.message,F.stack=o.stack,F}static isErrorNoTelemetry(o){return o.name==="CodeExpectedError"}}t.$ab=r;class b extends Error{constructor(o){super(o||"An unexpected bug occurred."),Object.setPrototypeOf(this,b.prototype)}}t.$bb=b}),define(be[11],pe([1,0,6,72]),function(ae,t,v,N){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$_b=t.$$b=t.$0b=t.$9b=t.$8b=t.$7b=t.$6b=t.CompareResult=t.$5b=t.$4b=t.$3b=t.$2b=t.$1b=t.$Zb=t.$Yb=t.$Xb=t.$Wb=t.$Vb=t.$Ub=t.$Tb=t.$Sb=t.$Rb=t.$Qb=t.$Pb=t.$Ob=t.$Nb=t.$Mb=t.$Lb=t.$Kb=t.$Jb=t.$Ib=t.$Hb=t.$Gb=t.$Fb=t.top=t.$Db=t.$Cb=t.$Bb=t.$Ab=t.$zb=t.$yb=t.$xb=t.$wb=t.$vb=t.$ub=t.$tb=t.$sb=t.$rb=void 0;function i(p,A=0){return p[p.length-(1+A)]}t.$rb=i;function U(p){if(p.length===0)throw new Error("Invalid tail call");return[p.slice(0,p.length-1),p[p.length-1]]}t.$sb=U;function w(p,A,E=(I,k)=>I===k){if(p===A)return!0;if(!p||!A||p.length!==A.length)return!1;for(let I=0,k=p.length;I<k;I++)if(!E(p[I],A[I]))return!1;return!0}t.$tb=w;function D(p,A){const E=p.length-1;A<E&&(p[A]=p[E]),p.pop()}t.$ub=D;function c(p,A,E){return f(p.length,I=>E(p[I],A))}t.$vb=c;function f(p,A){let E=0,I=p-1;for(;E<=I;){const k=(E+I)/2|0,L=A(k);if(L<0)E=k+1;else if(L>0)I=k-1;else return k}return-(E+1)}t.$wb=f;function d(p,A,E){if(p=p|0,p>=A.length)throw new TypeError("invalid index");const I=A[Math.floor(A.length*Math.random())],k=[],L=[],S=[];for(const P of A){const H=E(P,I);H<0?k.push(P):H>0?L.push(P):S.push(P)}return p<k.length?d(p,k,E):p<k.length+S.length?S[0]:d(p-(k.length+S.length),L,E)}t.$xb=d;function T(p,A){const E=[];let I;for(const k of p.slice(0).sort(A))!I||A(I[0],k)!==0?(I=[k],E.push(I)):I.push(k);return E}t.$yb=T;function*s(p,A){let E,I;for(const k of p)I!==void 0&&A(I,k)?E.push(k):(E&&(yield E),E=[k]),I=k;E&&(yield E)}t.$zb=s;function a(p,A){for(let E=0;E<=p.length;E++)A(E===0?void 0:p[E-1],E===p.length?void 0:p[E])}t.$Ab=a;function e(p,A){for(let E=0;E<p.length;E++)A(E===0?void 0:p[E-1],p[E],E+1===p.length?void 0:p[E+1])}t.$Bb=e;function h(p,A,E){const I=[];function k(P,H,G){if(H===0&&G.length===0)return;const ee=I[I.length-1];ee&&ee.start+ee.deleteCount===P?(ee.deleteCount+=H,ee.toInsert.push(...G)):I.push({start:P,deleteCount:H,toInsert:G})}let L=0,S=0;for(;;){if(L===p.length){k(L,0,A.slice(S));break}if(S===A.length){k(L,p.length-L,[]);break}const P=p[L],H=A[S],G=E(P,H);G===0?(L+=1,S+=1):G<0?(k(L,1,[]),L+=1):G>0&&(k(L,0,[H]),S+=1)}return I}t.$Cb=h;function l(p,A,E){const I=h(p,A,E),k=[],L=[];for(const S of I)k.push(...p.slice(S.start,S.start+S.deleteCount)),L.push(...S.toInsert);return{removed:k,added:L}}t.$Db=l;function m(p,A,E){if(E===0)return[];const I=p.slice(0,E).sort(A);return r(p,A,I,E,p.length),I}t.top=m;function n(p,A,E,I,k){return E===0?Promise.resolve([]):new Promise((L,S)=>{(async()=>{const P=p.length,H=p.slice(0,E).sort(A);for(let G=E,ee=Math.min(E+I,P);G<P;G=ee,ee=Math.min(ee+I,P)){if(G>E&&await new Promise(se=>setTimeout(se)),k&&k.isCancellationRequested)throw new v.$4;r(p,A,H,G,ee)}return H})().then(L,S)})}t.$Fb=n;function r(p,A,E,I,k){for(const L=E.length;I<k;I++){const S=p[I];if(A(S,E[L-1])<0){E.pop();const P=(0,N.$jb)(E,H=>A(S,H)<0);E.splice(P,0,S)}}}function b(p){return p.filter(A=>!!A)}t.$Gb=b;function u(p){let A=0;for(let E=0;E<p.length;E++)p[E]&&(p[A]=p[E],A+=1);p.length=A}t.$Hb=u;function o(p,A,E){p.splice(E,0,p.splice(A,1)[0])}t.$Ib=o;function F(p){return!Array.isArray(p)||p.length===0}t.$Jb=F;function z(p){return Array.isArray(p)&&p.length>0}t.$Kb=z;function R(p,A=E=>E){const E=new Set;return p.filter(I=>{const k=A(I);return E.has(k)?!1:(E.add(k),!0)})}t.$Lb=R;function g(p){const A=new Set;return E=>{const I=p(E);return A.has(I)?!1:(A.add(I),!0)}}t.$Mb=g;function y(p,A){return p.length>0?p[0]:A}t.$Nb=y;function M(p,A){return p.length>0?p[p.length-1]:A}t.$Ob=M;function _(p,A,E=(I,k)=>I===k){let I=0;for(let k=0,L=Math.min(p.length,A.length);k<L&&E(p[k],A[k]);k++)I++;return I}t.$Pb=_;function x(p){return[].concat(...p)}t.$Qb=x;function O(p,A){let E=typeof A=="number"?p:0;typeof A=="number"?E=p:(E=0,A=p);const I=[];if(E<=A)for(let k=E;k<A;k++)I.push(k);else for(let k=E;k>A;k--)I.push(k);return I}t.$Rb=O;function B(p,A,E){return p.reduce((I,k)=>(I[A(k)]=E?E(k):k,I),Object.create(null))}t.$Sb=B;function j(p,A){return p.push(A),()=>ie(p,A)}t.$Tb=j;function ie(p,A){const E=p.indexOf(A);if(E>-1)return p.splice(E,1),A}t.$Ub=ie;function te(p,A,E){const I=p.slice(0,A),k=p.slice(A);return I.concat(E,k)}t.$Vb=te;function ce(p,A){let E;if(typeof A=="number"){let I=A;E=()=>{const k=Math.sin(I++)*179426549;return k-Math.floor(k)}}else E=Math.random;for(let I=p.length-1;I>0;I-=1){const k=Math.floor(E()*(I+1)),L=p[I];p[I]=p[k],p[k]=L}}t.$Wb=ce;function le(p,A){const E=p.indexOf(A);E>-1&&(p.splice(E,1),p.unshift(A))}t.$Xb=le;function oe(p,A){const E=p.indexOf(A);E>-1&&(p.splice(E,1),p.push(A))}t.$Yb=oe;function we(p,A){for(const E of A)p.push(E)}t.$Zb=we;function Pe(p,A){return Array.isArray(p)?p.map(A):A(p)}t.$1b=Pe;function Ae(p){return Array.isArray(p)?p:[p]}t.$2b=Ae;function Re(p){return p[Math.floor(Math.random()*p.length)]}t.$3b=Re;function de(p,A,E){const I=fe(p,A),k=p.length,L=E.length;p.length=k+L;for(let S=k-1;S>=I;S--)p[S+L]=p[S];for(let S=0;S<L;S++)p[S+I]=E[S]}t.$4b=de;function ne(p,A,E,I){const k=fe(p,A);let L=p.splice(k,E);return L===void 0&&(L=[]),de(p,k,I),L}t.$5b=ne;function fe(p,A){return A<0?Math.max(A+p.length,0):Math.min(A,p.length)}var Z;(function(p){function A(L){return L<0}p.isLessThan=A;function E(L){return L<=0}p.isLessThanOrEqual=E;function I(L){return L>0}p.isGreaterThan=I;function k(L){return L===0}p.isNeitherLessOrGreaterThan=k,p.greaterThan=1,p.lessThan=-1,p.neitherLessOrGreaterThan=0})(Z||(t.CompareResult=Z={}));function V(p,A){return(E,I)=>A(p(E),p(I))}t.$6b=V;function Y(...p){return(A,E)=>{for(const I of p){const k=I(A,E);if(!Z.isNeitherLessOrGreaterThan(k))return k}return Z.neitherLessOrGreaterThan}}t.$7b=Y;const C=(p,A)=>p-A;t.$8b=C;const q=(p,A)=>(0,t.$8b)(p?1:0,A?1:0);t.$9b=q;function $(p){return(A,E)=>-p(A,E)}t.$0b=$;class W{constructor(A){this.g=A,this.c=0,this.d=this.g.length-1}get length(){return this.d-this.c+1}takeWhile(A){let E=this.c;for(;E<this.g.length&&A(this.g[E]);)E++;const I=E===this.c?null:this.g.slice(this.c,E);return this.c=E,I}takeFromEndWhile(A){let E=this.d;for(;E>=0&&A(this.g[E]);)E--;const I=E===this.d?null:this.g.slice(E+1,this.d+1);return this.d=E,I}peek(){if(this.length!==0)return this.g[this.c]}peekLast(){if(this.length!==0)return this.g[this.d]}dequeue(){const A=this.g[this.c];return this.c++,A}removeLast(){const A=this.g[this.d];return this.d--,A}takeCount(A){const E=this.g.slice(this.c,this.c+A);return this.c+=A,E}}t.$$b=W;class Q{static{this.empty=new Q(A=>{})}constructor(A){this.iterate=A}forEach(A){this.iterate(E=>(A(E),!0))}toArray(){const A=[];return this.iterate(E=>(A.push(E),!0)),A}filter(A){return new Q(E=>this.iterate(I=>A(I)?E(I):!0))}map(A){return new Q(E=>this.iterate(I=>E(A(I))))}some(A){let E=!1;return this.iterate(I=>(E=A(I),!E)),E}findFirst(A){let E;return this.iterate(I=>A(I)?(E=I,!1):!0),E}findLast(A){let E;return this.iterate(I=>(A(I)&&(E=I),!0)),E}findLastMaxBy(A){let E,I=!0;return this.iterate(k=>((I||Z.isGreaterThan(A(k,E)))&&(I=!1,E=k),!0)),E}}t.$_b=Q}),define(be[76],pe([1,0,6]),function(ae,t,v){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$7c=t.$6c=t.$5c=t.$4c=t.ok=void 0;function N(c,f){if(!c)throw new Error(f?`Assertion failed (${f})`:"Assertion Failed")}t.ok=N;function i(c,f="Unreachable"){throw new Error(f)}t.$4c=i;function U(c){if(!c)throw new v.$bb("Assertion Failed")}t.$5c=U;function w(c){if(!c()){debugger;c(),(0,v.$Z)(new v.$bb("Assertion Failed"))}}t.$6c=w;function D(c,f){let d=0;for(;d<c.length-1;){const T=c[d],s=c[d+1];if(!f(T,s))return!1;d++}return!0}t.$7c=D}),define(be[43],pe([1,0]),function(ae,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$cb=void 0;function v(N,i){const U=this;let w=!1,D;return function(){if(w)return D;if(w=!0,i)try{D=N.apply(U,arguments)}finally{i()}else D=N.apply(U,arguments);return D}}t.$cb=v}),define(be[77],pe([1,0]),function(ae,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$FM=t.$EM=void 0;class v{constructor(i){this.a=i,this.b=0}nextId(){return this.a+ ++this.b}}t.$EM=v,t.$FM=new v("id#")}),define(be[27],pe([1,0]),function(ae,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Iterable=void 0;var v;(function(N){function i(u){return u&&typeof u=="object"&&typeof u[Symbol.iterator]=="function"}N.is=i;const U=Object.freeze([]);function w(){return U}N.empty=w;function*D(u){yield u}N.single=D;function c(u){return i(u)?u:D(u)}N.wrap=c;function f(u){return u||U}N.from=f;function*d(u){for(let o=u.length-1;o>=0;o--)yield u[o]}N.reverse=d;function T(u){return!u||u[Symbol.iterator]().next().done===!0}N.isEmpty=T;function s(u){return u[Symbol.iterator]().next().value}N.first=s;function a(u,o){for(const F of u)if(o(F))return!0;return!1}N.some=a;function e(u,o){for(const F of u)if(o(F))return F}N.find=e;function*h(u,o){for(const F of u)o(F)&&(yield F)}N.filter=h;function*l(u,o){let F=0;for(const z of u)yield o(z,F++)}N.map=l;function*m(...u){for(const o of u)for(const F of o)yield F}N.concat=m;function n(u,o,F){let z=F;for(const R of u)z=o(z,R);return z}N.reduce=n;function*r(u,o,F=u.length){for(o<0&&(o+=u.length),F<0?F+=u.length:F>u.length&&(F=u.length);o<F;o++)yield u[o]}N.slice=r;function b(u,o=Number.POSITIVE_INFINITY){const F=[];if(o===0)return[F,u];const z=u[Symbol.iterator]();for(let R=0;R<o;R++){const g=z.next();if(g.done)return[F,N.empty()];F.push(g.value)}return[F,{[Symbol.iterator](){return z}}]}N.consume=b})(v||(t.Iterable=v={}))}),define(be[44],pe([1,0]),function(ae,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Lq=t.KeyMod=t.KeyCodeUtils=t.$Kq=t.$Jq=t.$Iq=t.$Hq=t.$Gq=t.ScanCode=t.KeyCode=void 0;var v;(function(e){e[e.DependsOnKbLayout=-1]="DependsOnKbLayout",e[e.Unknown=0]="Unknown",e[e.Backspace=1]="Backspace",e[e.Tab=2]="Tab",e[e.Enter=3]="Enter",e[e.Shift=4]="Shift",e[e.Ctrl=5]="Ctrl",e[e.Alt=6]="Alt",e[e.PauseBreak=7]="PauseBreak",e[e.CapsLock=8]="CapsLock",e[e.Escape=9]="Escape",e[e.Space=10]="Space",e[e.PageUp=11]="PageUp",e[e.PageDown=12]="PageDown",e[e.End=13]="End",e[e.Home=14]="Home",e[e.LeftArrow=15]="LeftArrow",e[e.UpArrow=16]="UpArrow",e[e.RightArrow=17]="RightArrow",e[e.DownArrow=18]="DownArrow",e[e.Insert=19]="Insert",e[e.Delete=20]="Delete",e[e.Digit0=21]="Digit0",e[e.Digit1=22]="Digit1",e[e.Digit2=23]="Digit2",e[e.Digit3=24]="Digit3",e[e.Digit4=25]="Digit4",e[e.Digit5=26]="Digit5",e[e.Digit6=27]="Digit6",e[e.Digit7=28]="Digit7",e[e.Digit8=29]="Digit8",e[e.Digit9=30]="Digit9",e[e.KeyA=31]="KeyA",e[e.KeyB=32]="KeyB",e[e.KeyC=33]="KeyC",e[e.KeyD=34]="KeyD",e[e.KeyE=35]="KeyE",e[e.KeyF=36]="KeyF",e[e.KeyG=37]="KeyG",e[e.KeyH=38]="KeyH",e[e.KeyI=39]="KeyI",e[e.KeyJ=40]="KeyJ",e[e.KeyK=41]="KeyK",e[e.KeyL=42]="KeyL",e[e.KeyM=43]="KeyM",e[e.KeyN=44]="KeyN",e[e.KeyO=45]="KeyO",e[e.KeyP=46]="KeyP",e[e.KeyQ=47]="KeyQ",e[e.KeyR=48]="KeyR",e[e.KeyS=49]="KeyS",e[e.KeyT=50]="KeyT",e[e.KeyU=51]="KeyU",e[e.KeyV=52]="KeyV",e[e.KeyW=53]="KeyW",e[e.KeyX=54]="KeyX",e[e.KeyY=55]="KeyY",e[e.KeyZ=56]="KeyZ",e[e.Meta=57]="Meta",e[e.ContextMenu=58]="ContextMenu",e[e.F1=59]="F1",e[e.F2=60]="F2",e[e.F3=61]="F3",e[e.F4=62]="F4",e[e.F5=63]="F5",e[e.F6=64]="F6",e[e.F7=65]="F7",e[e.F8=66]="F8",e[e.F9=67]="F9",e[e.F10=68]="F10",e[e.F11=69]="F11",e[e.F12=70]="F12",e[e.F13=71]="F13",e[e.F14=72]="F14",e[e.F15=73]="F15",e[e.F16=74]="F16",e[e.F17=75]="F17",e[e.F18=76]="F18",e[e.F19=77]="F19",e[e.F20=78]="F20",e[e.F21=79]="F21",e[e.F22=80]="F22",e[e.F23=81]="F23",e[e.F24=82]="F24",e[e.NumLock=83]="NumLock",e[e.ScrollLock=84]="ScrollLock",e[e.Semicolon=85]="Semicolon",e[e.Equal=86]="Equal",e[e.Comma=87]="Comma",e[e.Minus=88]="Minus",e[e.Period=89]="Period",e[e.Slash=90]="Slash",e[e.Backquote=91]="Backquote",e[e.BracketLeft=92]="BracketLeft",e[e.Backslash=93]="Backslash",e[e.BracketRight=94]="BracketRight",e[e.Quote=95]="Quote",e[e.OEM_8=96]="OEM_8",e[e.IntlBackslash=97]="IntlBackslash",e[e.Numpad0=98]="Numpad0",e[e.Numpad1=99]="Numpad1",e[e.Numpad2=100]="Numpad2",e[e.Numpad3=101]="Numpad3",e[e.Numpad4=102]="Numpad4",e[e.Numpad5=103]="Numpad5",e[e.Numpad6=104]="Numpad6",e[e.Numpad7=105]="Numpad7",e[e.Numpad8=106]="Numpad8",e[e.Numpad9=107]="Numpad9",e[e.NumpadMultiply=108]="NumpadMultiply",e[e.NumpadAdd=109]="NumpadAdd",e[e.NUMPAD_SEPARATOR=110]="NUMPAD_SEPARATOR",e[e.NumpadSubtract=111]="NumpadSubtract",e[e.NumpadDecimal=112]="NumpadDecimal",e[e.NumpadDivide=113]="NumpadDivide",e[e.KEY_IN_COMPOSITION=114]="KEY_IN_COMPOSITION",e[e.ABNT_C1=115]="ABNT_C1",e[e.ABNT_C2=116]="ABNT_C2",e[e.AudioVolumeMute=117]="AudioVolumeMute",e[e.AudioVolumeUp=118]="AudioVolumeUp",e[e.AudioVolumeDown=119]="AudioVolumeDown",e[e.BrowserSearch=120]="BrowserSearch",e[e.BrowserHome=121]="BrowserHome",e[e.BrowserBack=122]="BrowserBack",e[e.BrowserForward=123]="BrowserForward",e[e.MediaTrackNext=124]="MediaTrackNext",e[e.MediaTrackPrevious=125]="MediaTrackPrevious",e[e.MediaStop=126]="MediaStop",e[e.MediaPlayPause=127]="MediaPlayPause",e[e.LaunchMediaPlayer=128]="LaunchMediaPlayer",e[e.LaunchMail=129]="LaunchMail",e[e.LaunchApp2=130]="LaunchApp2",e[e.Clear=131]="Clear",e[e.MAX_VALUE=132]="MAX_VALUE"})(v||(t.KeyCode=v={}));var N;(function(e){e[e.DependsOnKbLayout=-1]="DependsOnKbLayout",e[e.None=0]="None",e[e.Hyper=1]="Hyper",e[e.Super=2]="Super",e[e.Fn=3]="Fn",e[e.FnLock=4]="FnLock",e[e.Suspend=5]="Suspend",e[e.Resume=6]="Resume",e[e.Turbo=7]="Turbo",e[e.Sleep=8]="Sleep",e[e.WakeUp=9]="WakeUp",e[e.KeyA=10]="KeyA",e[e.KeyB=11]="KeyB",e[e.KeyC=12]="KeyC",e[e.KeyD=13]="KeyD",e[e.KeyE=14]="KeyE",e[e.KeyF=15]="KeyF",e[e.KeyG=16]="KeyG",e[e.KeyH=17]="KeyH",e[e.KeyI=18]="KeyI",e[e.KeyJ=19]="KeyJ",e[e.KeyK=20]="KeyK",e[e.KeyL=21]="KeyL",e[e.KeyM=22]="KeyM",e[e.KeyN=23]="KeyN",e[e.KeyO=24]="KeyO",e[e.KeyP=25]="KeyP",e[e.KeyQ=26]="KeyQ",e[e.KeyR=27]="KeyR",e[e.KeyS=28]="KeyS",e[e.KeyT=29]="KeyT",e[e.KeyU=30]="KeyU",e[e.KeyV=31]="KeyV",e[e.KeyW=32]="KeyW",e[e.KeyX=33]="KeyX",e[e.KeyY=34]="KeyY",e[e.KeyZ=35]="KeyZ",e[e.Digit1=36]="Digit1",e[e.Digit2=37]="Digit2",e[e.Digit3=38]="Digit3",e[e.Digit4=39]="Digit4",e[e.Digit5=40]="Digit5",e[e.Digit6=41]="Digit6",e[e.Digit7=42]="Digit7",e[e.Digit8=43]="Digit8",e[e.Digit9=44]="Digit9",e[e.Digit0=45]="Digit0",e[e.Enter=46]="Enter",e[e.Escape=47]="Escape",e[e.Backspace=48]="Backspace",e[e.Tab=49]="Tab",e[e.Space=50]="Space",e[e.Minus=51]="Minus",e[e.Equal=52]="Equal",e[e.BracketLeft=53]="BracketLeft",e[e.BracketRight=54]="BracketRight",e[e.Backslash=55]="Backslash",e[e.IntlHash=56]="IntlHash",e[e.Semicolon=57]="Semicolon",e[e.Quote=58]="Quote",e[e.Backquote=59]="Backquote",e[e.Comma=60]="Comma",e[e.Period=61]="Period",e[e.Slash=62]="Slash",e[e.CapsLock=63]="CapsLock",e[e.F1=64]="F1",e[e.F2=65]="F2",e[e.F3=66]="F3",e[e.F4=67]="F4",e[e.F5=68]="F5",e[e.F6=69]="F6",e[e.F7=70]="F7",e[e.F8=71]="F8",e[e.F9=72]="F9",e[e.F10=73]="F10",e[e.F11=74]="F11",e[e.F12=75]="F12",e[e.PrintScreen=76]="PrintScreen",e[e.ScrollLock=77]="ScrollLock",e[e.Pause=78]="Pause",e[e.Insert=79]="Insert",e[e.Home=80]="Home",e[e.PageUp=81]="PageUp",e[e.Delete=82]="Delete",e[e.End=83]="End",e[e.PageDown=84]="PageDown",e[e.ArrowRight=85]="ArrowRight",e[e.ArrowLeft=86]="ArrowLeft",e[e.ArrowDown=87]="ArrowDown",e[e.ArrowUp=88]="ArrowUp",e[e.NumLock=89]="NumLock",e[e.NumpadDivide=90]="NumpadDivide",e[e.NumpadMultiply=91]="NumpadMultiply",e[e.NumpadSubtract=92]="NumpadSubtract",e[e.NumpadAdd=93]="NumpadAdd",e[e.NumpadEnter=94]="NumpadEnter",e[e.Numpad1=95]="Numpad1",e[e.Numpad2=96]="Numpad2",e[e.Numpad3=97]="Numpad3",e[e.Numpad4=98]="Numpad4",e[e.Numpad5=99]="Numpad5",e[e.Numpad6=100]="Numpad6",e[e.Numpad7=101]="Numpad7",e[e.Numpad8=102]="Numpad8",e[e.Numpad9=103]="Numpad9",e[e.Numpad0=104]="Numpad0",e[e.NumpadDecimal=105]="NumpadDecimal",e[e.IntlBackslash=106]="IntlBackslash",e[e.ContextMenu=107]="ContextMenu",e[e.Power=108]="Power",e[e.NumpadEqual=109]="NumpadEqual",e[e.F13=110]="F13",e[e.F14=111]="F14",e[e.F15=112]="F15",e[e.F16=113]="F16",e[e.F17=114]="F17",e[e.F18=115]="F18",e[e.F19=116]="F19",e[e.F20=117]="F20",e[e.F21=118]="F21",e[e.F22=119]="F22",e[e.F23=120]="F23",e[e.F24=121]="F24",e[e.Open=122]="Open",e[e.Help=123]="Help",e[e.Select=124]="Select",e[e.Again=125]="Again",e[e.Undo=126]="Undo",e[e.Cut=127]="Cut",e[e.Copy=128]="Copy",e[e.Paste=129]="Paste",e[e.Find=130]="Find",e[e.AudioVolumeMute=131]="AudioVolumeMute",e[e.AudioVolumeUp=132]="AudioVolumeUp",e[e.AudioVolumeDown=133]="AudioVolumeDown",e[e.NumpadComma=134]="NumpadComma",e[e.IntlRo=135]="IntlRo",e[e.KanaMode=136]="KanaMode",e[e.IntlYen=137]="IntlYen",e[e.Convert=138]="Convert",e[e.NonConvert=139]="NonConvert",e[e.Lang1=140]="Lang1",e[e.Lang2=141]="Lang2",e[e.Lang3=142]="Lang3",e[e.Lang4=143]="Lang4",e[e.Lang5=144]="Lang5",e[e.Abort=145]="Abort",e[e.Props=146]="Props",e[e.NumpadParenLeft=147]="NumpadParenLeft",e[e.NumpadParenRight=148]="NumpadParenRight",e[e.NumpadBackspace=149]="NumpadBackspace",e[e.NumpadMemoryStore=150]="NumpadMemoryStore",e[e.NumpadMemoryRecall=151]="NumpadMemoryRecall",e[e.NumpadMemoryClear=152]="NumpadMemoryClear",e[e.NumpadMemoryAdd=153]="NumpadMemoryAdd",e[e.NumpadMemorySubtract=154]="NumpadMemorySubtract",e[e.NumpadClear=155]="NumpadClear",e[e.NumpadClearEntry=156]="NumpadClearEntry",e[e.ControlLeft=157]="ControlLeft",e[e.ShiftLeft=158]="ShiftLeft",e[e.AltLeft=159]="AltLeft",e[e.MetaLeft=160]="MetaLeft",e[e.ControlRight=161]="ControlRight",e[e.ShiftRight=162]="ShiftRight",e[e.AltRight=163]="AltRight",e[e.MetaRight=164]="MetaRight",e[e.BrightnessUp=165]="BrightnessUp",e[e.BrightnessDown=166]="BrightnessDown",e[e.MediaPlay=167]="MediaPlay",e[e.MediaRecord=168]="MediaRecord",e[e.MediaFastForward=169]="MediaFastForward",e[e.MediaRewind=170]="MediaRewind",e[e.MediaTrackNext=171]="MediaTrackNext",e[e.MediaTrackPrevious=172]="MediaTrackPrevious",e[e.MediaStop=173]="MediaStop",e[e.Eject=174]="Eject",e[e.MediaPlayPause=175]="MediaPlayPause",e[e.MediaSelect=176]="MediaSelect",e[e.LaunchMail=177]="LaunchMail",e[e.LaunchApp2=178]="LaunchApp2",e[e.LaunchApp1=179]="LaunchApp1",e[e.SelectTask=180]="SelectTask",e[e.LaunchScreenSaver=181]="LaunchScreenSaver",e[e.BrowserSearch=182]="BrowserSearch",e[e.BrowserHome=183]="BrowserHome",e[e.BrowserBack=184]="BrowserBack",e[e.BrowserForward=185]="BrowserForward",e[e.BrowserStop=186]="BrowserStop",e[e.BrowserRefresh=187]="BrowserRefresh",e[e.BrowserFavorites=188]="BrowserFavorites",e[e.ZoomToggle=189]="ZoomToggle",e[e.MailReply=190]="MailReply",e[e.MailForward=191]="MailForward",e[e.MailSend=192]="MailSend",e[e.MAX_VALUE=193]="MAX_VALUE"})(N||(t.ScanCode=N={}));class i{constructor(){this._keyCodeToStr=[],this._strToKeyCode=Object.create(null)}define(h,l){this._keyCodeToStr[h]=l,this._strToKeyCode[l.toLowerCase()]=h}keyCodeToStr(h){return this._keyCodeToStr[h]}strToKeyCode(h){return this._strToKeyCode[h.toLowerCase()]||0}}const U=new i,w=new i,D=new i;t.$Gq=new Array(230),t.$Hq={};const c=[],f=Object.create(null),d=Object.create(null);t.$Iq={lowerCaseToEnum:e=>d[e]||0,toEnum:e=>f[e]||0,toString:e=>c[e]||"None"},t.$Jq=[],t.$Kq=[];for(let e=0;e<=193;e++)t.$Jq[e]=-1;for(let e=0;e<=132;e++)t.$Kq[e]=-1;(function(){const e="",h=[[1,0,"None",0,"unknown",0,"VK_UNKNOWN",e,e],[1,1,"Hyper",0,e,0,e,e,e],[1,2,"Super",0,e,0,e,e,e],[1,3,"Fn",0,e,0,e,e,e],[1,4,"FnLock",0,e,0,e,e,e],[1,5,"Suspend",0,e,0,e,e,e],[1,6,"Resume",0,e,0,e,e,e],[1,7,"Turbo",0,e,0,e,e,e],[1,8,"Sleep",0,e,0,"VK_SLEEP",e,e],[1,9,"WakeUp",0,e,0,e,e,e],[0,10,"KeyA",31,"A",65,"VK_A",e,e],[0,11,"KeyB",32,"B",66,"VK_B",e,e],[0,12,"KeyC",33,"C",67,"VK_C",e,e],[0,13,"KeyD",34,"D",68,"VK_D",e,e],[0,14,"KeyE",35,"E",69,"VK_E",e,e],[0,15,"KeyF",36,"F",70,"VK_F",e,e],[0,16,"KeyG",37,"G",71,"VK_G",e,e],[0,17,"KeyH",38,"H",72,"VK_H",e,e],[0,18,"KeyI",39,"I",73,"VK_I",e,e],[0,19,"KeyJ",40,"J",74,"VK_J",e,e],[0,20,"KeyK",41,"K",75,"VK_K",e,e],[0,21,"KeyL",42,"L",76,"VK_L",e,e],[0,22,"KeyM",43,"M",77,"VK_M",e,e],[0,23,"KeyN",44,"N",78,"VK_N",e,e],[0,24,"KeyO",45,"O",79,"VK_O",e,e],[0,25,"KeyP",46,"P",80,"VK_P",e,e],[0,26,"KeyQ",47,"Q",81,"VK_Q",e,e],[0,27,"KeyR",48,"R",82,"VK_R",e,e],[0,28,"KeyS",49,"S",83,"VK_S",e,e],[0,29,"KeyT",50,"T",84,"VK_T",e,e],[0,30,"KeyU",51,"U",85,"VK_U",e,e],[0,31,"KeyV",52,"V",86,"VK_V",e,e],[0,32,"KeyW",53,"W",87,"VK_W",e,e],[0,33,"KeyX",54,"X",88,"VK_X",e,e],[0,34,"KeyY",55,"Y",89,"VK_Y",e,e],[0,35,"KeyZ",56,"Z",90,"VK_Z",e,e],[0,36,"Digit1",22,"1",49,"VK_1",e,e],[0,37,"Digit2",23,"2",50,"VK_2",e,e],[0,38,"Digit3",24,"3",51,"VK_3",e,e],[0,39,"Digit4",25,"4",52,"VK_4",e,e],[0,40,"Digit5",26,"5",53,"VK_5",e,e],[0,41,"Digit6",27,"6",54,"VK_6",e,e],[0,42,"Digit7",28,"7",55,"VK_7",e,e],[0,43,"Digit8",29,"8",56,"VK_8",e,e],[0,44,"Digit9",30,"9",57,"VK_9",e,e],[0,45,"Digit0",21,"0",48,"VK_0",e,e],[1,46,"Enter",3,"Enter",13,"VK_RETURN",e,e],[1,47,"Escape",9,"Escape",27,"VK_ESCAPE",e,e],[1,48,"Backspace",1,"Backspace",8,"VK_BACK",e,e],[1,49,"Tab",2,"Tab",9,"VK_TAB",e,e],[1,50,"Space",10,"Space",32,"VK_SPACE",e,e],[0,51,"Minus",88,"-",189,"VK_OEM_MINUS","-","OEM_MINUS"],[0,52,"Equal",86,"=",187,"VK_OEM_PLUS","=","OEM_PLUS"],[0,53,"BracketLeft",92,"[",219,"VK_OEM_4","[","OEM_4"],[0,54,"BracketRight",94,"]",221,"VK_OEM_6","]","OEM_6"],[0,55,"Backslash",93,"\\",220,"VK_OEM_5","\\","OEM_5"],[0,56,"IntlHash",0,e,0,e,e,e],[0,57,"Semicolon",85,";",186,"VK_OEM_1",";","OEM_1"],[0,58,"Quote",95,"'",222,"VK_OEM_7","'","OEM_7"],[0,59,"Backquote",91,"`",192,"VK_OEM_3","`","OEM_3"],[0,60,"Comma",87,",",188,"VK_OEM_COMMA",",","OEM_COMMA"],[0,61,"Period",89,".",190,"VK_OEM_PERIOD",".","OEM_PERIOD"],[0,62,"Slash",90,"/",191,"VK_OEM_2","/","OEM_2"],[1,63,"CapsLock",8,"CapsLock",20,"VK_CAPITAL",e,e],[1,64,"F1",59,"F1",112,"VK_F1",e,e],[1,65,"F2",60,"F2",113,"VK_F2",e,e],[1,66,"F3",61,"F3",114,"VK_F3",e,e],[1,67,"F4",62,"F4",115,"VK_F4",e,e],[1,68,"F5",63,"F5",116,"VK_F5",e,e],[1,69,"F6",64,"F6",117,"VK_F6",e,e],[1,70,"F7",65,"F7",118,"VK_F7",e,e],[1,71,"F8",66,"F8",119,"VK_F8",e,e],[1,72,"F9",67,"F9",120,"VK_F9",e,e],[1,73,"F10",68,"F10",121,"VK_F10",e,e],[1,74,"F11",69,"F11",122,"VK_F11",e,e],[1,75,"F12",70,"F12",123,"VK_F12",e,e],[1,76,"PrintScreen",0,e,0,e,e,e],[1,77,"ScrollLock",84,"ScrollLock",145,"VK_SCROLL",e,e],[1,78,"Pause",7,"PauseBreak",19,"VK_PAUSE",e,e],[1,79,"Insert",19,"Insert",45,"VK_INSERT",e,e],[1,80,"Home",14,"Home",36,"VK_HOME",e,e],[1,81,"PageUp",11,"PageUp",33,"VK_PRIOR",e,e],[1,82,"Delete",20,"Delete",46,"VK_DELETE",e,e],[1,83,"End",13,"End",35,"VK_END",e,e],[1,84,"PageDown",12,"PageDown",34,"VK_NEXT",e,e],[1,85,"ArrowRight",17,"RightArrow",39,"VK_RIGHT","Right",e],[1,86,"ArrowLeft",15,"LeftArrow",37,"VK_LEFT","Left",e],[1,87,"ArrowDown",18,"DownArrow",40,"VK_DOWN","Down",e],[1,88,"ArrowUp",16,"UpArrow",38,"VK_UP","Up",e],[1,89,"NumLock",83,"NumLock",144,"VK_NUMLOCK",e,e],[1,90,"NumpadDivide",113,"NumPad_Divide",111,"VK_DIVIDE",e,e],[1,91,"NumpadMultiply",108,"NumPad_Multiply",106,"VK_MULTIPLY",e,e],[1,92,"NumpadSubtract",111,"NumPad_Subtract",109,"VK_SUBTRACT",e,e],[1,93,"NumpadAdd",109,"NumPad_Add",107,"VK_ADD",e,e],[1,94,"NumpadEnter",3,e,0,e,e,e],[1,95,"Numpad1",99,"NumPad1",97,"VK_NUMPAD1",e,e],[1,96,"Numpad2",100,"NumPad2",98,"VK_NUMPAD2",e,e],[1,97,"Numpad3",101,"NumPad3",99,"VK_NUMPAD3",e,e],[1,98,"Numpad4",102,"NumPad4",100,"VK_NUMPAD4",e,e],[1,99,"Numpad5",103,"NumPad5",101,"VK_NUMPAD5",e,e],[1,100,"Numpad6",104,"NumPad6",102,"VK_NUMPAD6",e,e],[1,101,"Numpad7",105,"NumPad7",103,"VK_NUMPAD7",e,e],[1,102,"Numpad8",106,"NumPad8",104,"VK_NUMPAD8",e,e],[1,103,"Numpad9",107,"NumPad9",105,"VK_NUMPAD9",e,e],[1,104,"Numpad0",98,"NumPad0",96,"VK_NUMPAD0",e,e],[1,105,"NumpadDecimal",112,"NumPad_Decimal",110,"VK_DECIMAL",e,e],[0,106,"IntlBackslash",97,"OEM_102",226,"VK_OEM_102",e,e],[1,107,"ContextMenu",58,"ContextMenu",93,e,e,e],[1,108,"Power",0,e,0,e,e,e],[1,109,"NumpadEqual",0,e,0,e,e,e],[1,110,"F13",71,"F13",124,"VK_F13",e,e],[1,111,"F14",72,"F14",125,"VK_F14",e,e],[1,112,"F15",73,"F15",126,"VK_F15",e,e],[1,113,"F16",74,"F16",127,"VK_F16",e,e],[1,114,"F17",75,"F17",128,"VK_F17",e,e],[1,115,"F18",76,"F18",129,"VK_F18",e,e],[1,116,"F19",77,"F19",130,"VK_F19",e,e],[1,117,"F20",78,"F20",131,"VK_F20",e,e],[1,118,"F21",79,"F21",132,"VK_F21",e,e],[1,119,"F22",80,"F22",133,"VK_F22",e,e],[1,120,"F23",81,"F23",134,"VK_F23",e,e],[1,121,"F24",82,"F24",135,"VK_F24",e,e],[1,122,"Open",0,e,0,e,e,e],[1,123,"Help",0,e,0,e,e,e],[1,124,"Select",0,e,0,e,e,e],[1,125,"Again",0,e,0,e,e,e],[1,126,"Undo",0,e,0,e,e,e],[1,127,"Cut",0,e,0,e,e,e],[1,128,"Copy",0,e,0,e,e,e],[1,129,"Paste",0,e,0,e,e,e],[1,130,"Find",0,e,0,e,e,e],[1,131,"AudioVolumeMute",117,"AudioVolumeMute",173,"VK_VOLUME_MUTE",e,e],[1,132,"AudioVolumeUp",118,"AudioVolumeUp",175,"VK_VOLUME_UP",e,e],[1,133,"AudioVolumeDown",119,"AudioVolumeDown",174,"VK_VOLUME_DOWN",e,e],[1,134,"NumpadComma",110,"NumPad_Separator",108,"VK_SEPARATOR",e,e],[0,135,"IntlRo",115,"ABNT_C1",193,"VK_ABNT_C1",e,e],[1,136,"KanaMode",0,e,0,e,e,e],[0,137,"IntlYen",0,e,0,e,e,e],[1,138,"Convert",0,e,0,e,e,e],[1,139,"NonConvert",0,e,0,e,e,e],[1,140,"Lang1",0,e,0,e,e,e],[1,141,"Lang2",0,e,0,e,e,e],[1,142,"Lang3",0,e,0,e,e,e],[1,143,"Lang4",0,e,0,e,e,e],[1,144,"Lang5",0,e,0,e,e,e],[1,145,"Abort",0,e,0,e,e,e],[1,146,"Props",0,e,0,e,e,e],[1,147,"NumpadParenLeft",0,e,0,e,e,e],[1,148,"NumpadParenRight",0,e,0,e,e,e],[1,149,"NumpadBackspace",0,e,0,e,e,e],[1,150,"NumpadMemoryStore",0,e,0,e,e,e],[1,151,"NumpadMemoryRecall",0,e,0,e,e,e],[1,152,"NumpadMemoryClear",0,e,0,e,e,e],[1,153,"NumpadMemoryAdd",0,e,0,e,e,e],[1,154,"NumpadMemorySubtract",0,e,0,e,e,e],[1,155,"NumpadClear",131,"Clear",12,"VK_CLEAR",e,e],[1,156,"NumpadClearEntry",0,e,0,e,e,e],[1,0,e,5,"Ctrl",17,"VK_CONTROL",e,e],[1,0,e,4,"Shift",16,"VK_SHIFT",e,e],[1,0,e,6,"Alt",18,"VK_MENU",e,e],[1,0,e,57,"Meta",91,"VK_COMMAND",e,e],[1,157,"ControlLeft",5,e,0,"VK_LCONTROL",e,e],[1,158,"ShiftLeft",4,e,0,"VK_LSHIFT",e,e],[1,159,"AltLeft",6,e,0,"VK_LMENU",e,e],[1,160,"MetaLeft",57,e,0,"VK_LWIN",e,e],[1,161,"ControlRight",5,e,0,"VK_RCONTROL",e,e],[1,162,"ShiftRight",4,e,0,"VK_RSHIFT",e,e],[1,163,"AltRight",6,e,0,"VK_RMENU",e,e],[1,164,"MetaRight",57,e,0,"VK_RWIN",e,e],[1,165,"BrightnessUp",0,e,0,e,e,e],[1,166,"BrightnessDown",0,e,0,e,e,e],[1,167,"MediaPlay",0,e,0,e,e,e],[1,168,"MediaRecord",0,e,0,e,e,e],[1,169,"MediaFastForward",0,e,0,e,e,e],[1,170,"MediaRewind",0,e,0,e,e,e],[1,171,"MediaTrackNext",124,"MediaTrackNext",176,"VK_MEDIA_NEXT_TRACK",e,e],[1,172,"MediaTrackPrevious",125,"MediaTrackPrevious",177,"VK_MEDIA_PREV_TRACK",e,e],[1,173,"MediaStop",126,"MediaStop",178,"VK_MEDIA_STOP",e,e],[1,174,"Eject",0,e,0,e,e,e],[1,175,"MediaPlayPause",127,"MediaPlayPause",179,"VK_MEDIA_PLAY_PAUSE",e,e],[1,176,"MediaSelect",128,"LaunchMediaPlayer",181,"VK_MEDIA_LAUNCH_MEDIA_SELECT",e,e],[1,177,"LaunchMail",129,"LaunchMail",180,"VK_MEDIA_LAUNCH_MAIL",e,e],[1,178,"LaunchApp2",130,"LaunchApp2",183,"VK_MEDIA_LAUNCH_APP2",e,e],[1,179,"LaunchApp1",0,e,0,"VK_MEDIA_LAUNCH_APP1",e,e],[1,180,"SelectTask",0,e,0,e,e,e],[1,181,"LaunchScreenSaver",0,e,0,e,e,e],[1,182,"BrowserSearch",120,"BrowserSearch",170,"VK_BROWSER_SEARCH",e,e],[1,183,"BrowserHome",121,"BrowserHome",172,"VK_BROWSER_HOME",e,e],[1,184,"BrowserBack",122,"BrowserBack",166,"VK_BROWSER_BACK",e,e],[1,185,"BrowserForward",123,"BrowserForward",167,"VK_BROWSER_FORWARD",e,e],[1,186,"BrowserStop",0,e,0,"VK_BROWSER_STOP",e,e],[1,187,"BrowserRefresh",0,e,0,"VK_BROWSER_REFRESH",e,e],[1,188,"BrowserFavorites",0,e,0,"VK_BROWSER_FAVORITES",e,e],[1,189,"ZoomToggle",0,e,0,e,e,e],[1,190,"MailReply",0,e,0,e,e,e],[1,191,"MailForward",0,e,0,e,e,e],[1,192,"MailSend",0,e,0,e,e,e],[1,0,e,114,"KeyInComposition",229,e,e,e],[1,0,e,116,"ABNT_C2",194,"VK_ABNT_C2",e,e],[1,0,e,96,"OEM_8",223,"VK_OEM_8",e,e],[1,0,e,0,e,0,"VK_KANA",e,e],[1,0,e,0,e,0,"VK_HANGUL",e,e],[1,0,e,0,e,0,"VK_JUNJA",e,e],[1,0,e,0,e,0,"VK_FINAL",e,e],[1,0,e,0,e,0,"VK_HANJA",e,e],[1,0,e,0,e,0,"VK_KANJI",e,e],[1,0,e,0,e,0,"VK_CONVERT",e,e],[1,0,e,0,e,0,"VK_NONCONVERT",e,e],[1,0,e,0,e,0,"VK_ACCEPT",e,e],[1,0,e,0,e,0,"VK_MODECHANGE",e,e],[1,0,e,0,e,0,"VK_SELECT",e,e],[1,0,e,0,e,0,"VK_PRINT",e,e],[1,0,e,0,e,0,"VK_EXECUTE",e,e],[1,0,e,0,e,0,"VK_SNAPSHOT",e,e],[1,0,e,0,e,0,"VK_HELP",e,e],[1,0,e,0,e,0,"VK_APPS",e,e],[1,0,e,0,e,0,"VK_PROCESSKEY",e,e],[1,0,e,0,e,0,"VK_PACKET",e,e],[1,0,e,0,e,0,"VK_DBE_SBCSCHAR",e,e],[1,0,e,0,e,0,"VK_DBE_DBCSCHAR",e,e],[1,0,e,0,e,0,"VK_ATTN",e,e],[1,0,e,0,e,0,"VK_CRSEL",e,e],[1,0,e,0,e,0,"VK_EXSEL",e,e],[1,0,e,0,e,0,"VK_EREOF",e,e],[1,0,e,0,e,0,"VK_PLAY",e,e],[1,0,e,0,e,0,"VK_ZOOM",e,e],[1,0,e,0,e,0,"VK_NONAME",e,e],[1,0,e,0,e,0,"VK_PA1",e,e],[1,0,e,0,e,0,"VK_OEM_CLEAR",e,e]],l=[],m=[];for(const n of h){const[r,b,u,o,F,z,R,g,y]=n;if(m[b]||(m[b]=!0,c[b]=u,f[u]=b,d[u.toLowerCase()]=b,r&&(t.$Jq[b]=o,o!==0&&o!==3&&o!==5&&o!==4&&o!==6&&o!==57&&(t.$Kq[o]=b))),!l[o]){if(l[o]=!0,!F)throw new Error(`String representation missing for key code ${o} around scan code ${u}`);U.define(o,F),w.define(o,g||F),D.define(o,y||g||F)}z&&(t.$Gq[z]=o),R&&(t.$Hq[R]=o)}t.$Kq[3]=46})();var T;(function(e){function h(u){return U.keyCodeToStr(u)}e.toString=h;function l(u){return U.strToKeyCode(u)}e.fromString=l;function m(u){return w.keyCodeToStr(u)}e.toUserSettingsUS=m;function n(u){return D.keyCodeToStr(u)}e.toUserSettingsGeneral=n;function r(u){return w.strToKeyCode(u)||D.strToKeyCode(u)}e.fromUserSettings=r;function b(u){if(u>=98&&u<=113)return null;switch(u){case 16:return"Up";case 18:return"Down";case 15:return"Left";case 17:return"Right"}return U.keyCodeToStr(u)}e.toElectronAccelerator=b})(T||(t.KeyCodeUtils=T={}));var s;(function(e){e[e.CtrlCmd=2048]="CtrlCmd",e[e.Shift=1024]="Shift",e[e.Alt=512]="Alt",e[e.WinCtrl=256]="WinCtrl"})(s||(t.KeyMod=s={}));function a(e,h){const l=(h&65535)<<16>>>0;return(e|l)>>>0}t.$Lq=a}),define(be[78],pe([1,0,6]),function(ae,t,v){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Sq=t.$Rq=t.$Qq=t.$Pq=t.$Oq=t.$Nq=t.$Mq=void 0;var N;(function(T){T[T.CtrlCmd=2048]="CtrlCmd",T[T.Shift=1024]="Shift",T[T.Alt=512]="Alt",T[T.WinCtrl=256]="WinCtrl",T[T.KeyCode=255]="KeyCode"})(N||(N={}));function i(T,s){if(typeof T=="number"){if(T===0)return null;const a=(T&65535)>>>0,e=(T&4294901760)>>>16;return e!==0?new c([U(a,s),U(e,s)]):new c([U(a,s)])}else{const a=[];for(let e=0;e<T.length;e++)a.push(U(T[e],s));return new c(a)}}t.$Mq=i;function U(T,s){const a=!!(T&2048),e=!!(T&256),h=s===2?e:a,l=!!(T&1024),m=!!(T&512),n=s===2?a:e,r=T&255;return new w(h,l,m,n,r)}t.$Nq=U;class w{constructor(s,a,e,h,l){this.ctrlKey=s,this.shiftKey=a,this.altKey=e,this.metaKey=h,this.keyCode=l}equals(s){return s instanceof w&&this.ctrlKey===s.ctrlKey&&this.shiftKey===s.shiftKey&&this.altKey===s.altKey&&this.metaKey===s.metaKey&&this.keyCode===s.keyCode}getHashCode(){const s=this.ctrlKey?"1":"0",a=this.shiftKey?"1":"0",e=this.altKey?"1":"0",h=this.metaKey?"1":"0";return`K${s}${a}${e}${h}${this.keyCode}`}isModifierKey(){return this.keyCode===0||this.keyCode===5||this.keyCode===57||this.keyCode===6||this.keyCode===4}toKeybinding(){return new c([this])}isDuplicateModifierCase(){return this.ctrlKey&&this.keyCode===5||this.shiftKey&&this.keyCode===4||this.altKey&&this.keyCode===6||this.metaKey&&this.keyCode===57}}t.$Oq=w;class D{constructor(s,a,e,h,l){this.ctrlKey=s,this.shiftKey=a,this.altKey=e,this.metaKey=h,this.scanCode=l}equals(s){return s instanceof D&&this.ctrlKey===s.ctrlKey&&this.shiftKey===s.shiftKey&&this.altKey===s.altKey&&this.metaKey===s.metaKey&&this.scanCode===s.scanCode}getHashCode(){const s=this.ctrlKey?"1":"0",a=this.shiftKey?"1":"0",e=this.altKey?"1":"0",h=this.metaKey?"1":"0";return`S${s}${a}${e}${h}${this.scanCode}`}isDuplicateModifierCase(){return this.ctrlKey&&(this.scanCode===157||this.scanCode===161)||this.shiftKey&&(this.scanCode===158||this.scanCode===162)||this.altKey&&(this.scanCode===159||this.scanCode===163)||this.metaKey&&(this.scanCode===160||this.scanCode===164)}}t.$Pq=D;class c{constructor(s){if(s.length===0)throw(0,v.$6)("chords");this.chords=s}getHashCode(){let s="";for(let a=0,e=this.chords.length;a<e;a++)a!==0&&(s+=";"),s+=this.chords[a].getHashCode();return s}equals(s){if(s===null||this.chords.length!==s.chords.length)return!1;for(let a=0;a<this.chords.length;a++)if(!this.chords[a].equals(s.chords[a]))return!1;return!0}}t.$Qq=c;class f{constructor(s,a,e,h,l,m){this.ctrlKey=s,this.shiftKey=a,this.altKey=e,this.metaKey=h,this.keyLabel=l,this.keyAriaLabel=m}}t.$Rq=f;class d{}t.$Sq=d}),define(be[28],pe([1,0]),function(ae,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$U=void 0;class v{constructor(i){this.d=i,this.a=!1}get hasValue(){return this.a}get value(){if(!this.a)try{this.b=this.d()}catch(i){this.c=i}finally{this.a=!0}if(this.c)throw this.c;return this.b}get rawValue(){return this.b}}t.$U=v}),define(be[45],pe([1,0]),function(ae,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$2c=void 0;class v{static{this.Undefined=new v(void 0)}constructor(U){this.element=U,this.next=v.Undefined,this.prev=v.Undefined}}class N{constructor(){this.a=v.Undefined,this.b=v.Undefined,this.c=0}get size(){return this.c}isEmpty(){return this.a===v.Undefined}clear(){let U=this.a;for(;U!==v.Undefined;){const w=U.next;U.prev=v.Undefined,U.next=v.Undefined,U=w}this.a=v.Undefined,this.b=v.Undefined,this.c=0}unshift(U){return this.d(U,!1)}push(U){return this.d(U,!0)}d(U,w){const D=new v(U);if(this.a===v.Undefined)this.a=D,this.b=D;else if(w){const f=this.b;this.b=D,D.prev=f,f.next=D}else{const f=this.a;this.a=D,D.next=f,f.prev=D}this.c+=1;let c=!1;return()=>{c||(c=!0,this.e(D))}}shift(){if(this.a!==v.Undefined){const U=this.a.element;return this.e(this.a),U}}pop(){if(this.b!==v.Undefined){const U=this.b.element;return this.e(this.b),U}}e(U){if(U.prev!==v.Undefined&&U.next!==v.Undefined){const w=U.prev;w.next=U.next,U.next.prev=w}else U.prev===v.Undefined&&U.next===v.Undefined?(this.a=v.Undefined,this.b=v.Undefined):U.next===v.Undefined?(this.b=this.b.prev,this.b.next=v.Undefined):U.prev===v.Undefined&&(this.a=this.a.next,this.a.prev=v.Undefined);this.c-=1}*[Symbol.iterator](){let U=this.a;for(;U!==v.Undefined;)yield U.element,U=U.next}}t.$2c=N}),define(be[32],pe([1,0]),function(ae,t){"use strict";var v,N,i;Object.defineProperty(t,"__esModule",{value:!0}),t.$Fc=t.$Ec=t.$Dc=t.$Cc=t.$Bc=t.Touch=t.$Ac=t.$zc=t.$yc=t.$xc=t.$wc=void 0;function U(n,r,b){let u=n.get(r);return u===void 0&&(u=b,n.set(r,u)),u}t.$wc=U;function w(n){const r=[];return n.forEach((b,u)=>{r.push(`${u} => ${b}`)}),`Map(${n.size}) {${r.join(", ")}}`}t.$xc=w;function D(n){const r=[];return n.forEach(b=>{r.push(b)}),`Set(${n.size}) {${r.join(", ")}}`}t.$yc=D;class c{constructor(r,b){this.uri=r,this.value=b}}function f(n){return Array.isArray(n)}class d{static{this.a=r=>r.toString()}constructor(r,b){if(this[v]="ResourceMap",r instanceof d)this.b=new Map(r.b),this.c=b??d.a;else if(f(r)){this.b=new Map,this.c=b??d.a;for(const[u,o]of r)this.set(u,o)}else this.b=new Map,this.c=r??d.a}set(r,b){return this.b.set(this.c(r),new c(r,b)),this}get(r){return this.b.get(this.c(r))?.value}has(r){return this.b.has(this.c(r))}get size(){return this.b.size}clear(){this.b.clear()}delete(r){return this.b.delete(this.c(r))}forEach(r,b){typeof b<"u"&&(r=r.bind(b));for(const[u,o]of this.b)r(o.value,o.uri,this)}*values(){for(const r of this.b.values())yield r.value}*keys(){for(const r of this.b.values())yield r.uri}*entries(){for(const r of this.b.values())yield[r.uri,r.value]}*[(v=Symbol.toStringTag,Symbol.iterator)](){for(const[,r]of this.b)yield[r.uri,r.value]}}t.$zc=d;class T{constructor(r,b){this[N]="ResourceSet",!r||typeof r=="function"?this.a=new d(r):(this.a=new d(b),r.forEach(this.add,this))}get size(){return this.a.size}add(r){return this.a.set(r,r),this}clear(){this.a.clear()}delete(r){return this.a.delete(r)}forEach(r,b){this.a.forEach((u,o)=>r.call(b,o,o,this))}has(r){return this.a.has(r)}entries(){return this.a.entries()}keys(){return this.a.keys()}values(){return this.a.keys()}[(N=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}t.$Ac=T;var s;(function(n){n[n.None=0]="None",n[n.AsOld=1]="AsOld",n[n.AsNew=2]="AsNew"})(s||(t.Touch=s={}));class a{constructor(){this[i]="LinkedMap",this.a=new Map,this.b=void 0,this.c=void 0,this.d=0,this.e=0}clear(){this.a.clear(),this.b=void 0,this.c=void 0,this.d=0,this.e++}isEmpty(){return!this.b&&!this.c}get size(){return this.d}get first(){return this.b?.value}get last(){return this.c?.value}has(r){return this.a.has(r)}get(r,b=0){const u=this.a.get(r);if(u)return b!==0&&this.j(u,b),u.value}set(r,b,u=0){let o=this.a.get(r);if(o)o.value=b,u!==0&&this.j(o,u);else{switch(o={key:r,value:b,next:void 0,previous:void 0},u){case 0:this.h(o);break;case 1:this.g(o);break;case 2:this.h(o);break;default:this.h(o);break}this.a.set(r,o),this.d++}return this}delete(r){return!!this.remove(r)}remove(r){const b=this.a.get(r);if(b)return this.a.delete(r),this.i(b),this.d--,b.value}shift(){if(!this.b&&!this.c)return;if(!this.b||!this.c)throw new Error("Invalid list");const r=this.b;return this.a.delete(r.key),this.i(r),this.d--,r.value}forEach(r,b){const u=this.e;let o=this.b;for(;o;){if(b?r.bind(b)(o.value,o.key,this):r(o.value,o.key,this),this.e!==u)throw new Error("LinkedMap got modified during iteration.");o=o.next}}keys(){const r=this,b=this.e;let u=this.b;const o={[Symbol.iterator](){return o},next(){if(r.e!==b)throw new Error("LinkedMap got modified during iteration.");if(u){const F={value:u.key,done:!1};return u=u.next,F}else return{value:void 0,done:!0}}};return o}values(){const r=this,b=this.e;let u=this.b;const o={[Symbol.iterator](){return o},next(){if(r.e!==b)throw new Error("LinkedMap got modified during iteration.");if(u){const F={value:u.value,done:!1};return u=u.next,F}else return{value:void 0,done:!0}}};return o}entries(){const r=this,b=this.e;let u=this.b;const o={[Symbol.iterator](){return o},next(){if(r.e!==b)throw new Error("LinkedMap got modified during iteration.");if(u){const F={value:[u.key,u.value],done:!1};return u=u.next,F}else return{value:void 0,done:!0}}};return o}[(i=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}f(r){if(r>=this.size)return;if(r===0){this.clear();return}let b=this.b,u=this.size;for(;b&&u>r;)this.a.delete(b.key),b=b.next,u--;this.b=b,this.d=u,b&&(b.previous=void 0),this.e++}g(r){if(!this.b&&!this.c)this.c=r;else if(this.b)r.next=this.b,this.b.previous=r;else throw new Error("Invalid list");this.b=r,this.e++}h(r){if(!this.b&&!this.c)this.b=r;else if(this.c)r.previous=this.c,this.c.next=r;else throw new Error("Invalid list");this.c=r,this.e++}i(r){if(r===this.b&&r===this.c)this.b=void 0,this.c=void 0;else if(r===this.b){if(!r.next)throw new Error("Invalid list");r.next.previous=void 0,this.b=r.next}else if(r===this.c){if(!r.previous)throw new Error("Invalid list");r.previous.next=void 0,this.c=r.previous}else{const b=r.next,u=r.previous;if(!b||!u)throw new Error("Invalid list");b.previous=u,u.next=b}r.next=void 0,r.previous=void 0,this.e++}j(r,b){if(!this.b||!this.c)throw new Error("Invalid list");if(!(b!==1&&b!==2)){if(b===1){if(r===this.b)return;const u=r.next,o=r.previous;r===this.c?(o.next=void 0,this.c=o):(u.previous=o,o.next=u),r.previous=void 0,r.next=this.b,this.b.previous=r,this.b=r,this.e++}else if(b===2){if(r===this.c)return;const u=r.next,o=r.previous;r===this.b?(u.previous=void 0,this.b=u):(u.previous=o,o.next=u),r.next=void 0,r.previous=this.c,this.c.next=r,this.c=r,this.e++}}}toJSON(){const r=[];return this.forEach((b,u)=>{r.push([u,b])}),r}fromJSON(r){this.clear();for(const[b,u]of r)this.set(b,u)}}t.$Bc=a;class e extends a{constructor(r,b=1){super(),this.k=r,this.l=Math.min(Math.max(0,b),1)}get limit(){return this.k}set limit(r){this.k=r,this.m()}get ratio(){return this.l}set ratio(r){this.l=Math.min(Math.max(0,r),1),this.m()}get(r,b=2){return super.get(r,b)}peek(r){return super.get(r,0)}set(r,b){return super.set(r,b,2),this.m(),this}m(){this.size>this.k&&this.f(Math.round(this.k*this.l))}}t.$Cc=e;class h{constructor(){this.a=new Map}add(r){return this.a.set(r,(this.a.get(r)||0)+1),this}delete(r){let b=this.a.get(r)||0;return b===0?!1:(b--,b===0?this.a.delete(r):this.a.set(r,b),!0)}has(r){return this.a.has(r)}}t.$Dc=h;class l{constructor(r){if(this.a=new Map,this.b=new Map,r)for(const[b,u]of r)this.set(b,u)}clear(){this.a.clear(),this.b.clear()}set(r,b){this.a.set(r,b),this.b.set(b,r)}get(r){return this.a.get(r)}getKey(r){return this.b.get(r)}delete(r){const b=this.a.get(r);return b===void 0?!1:(this.a.delete(r),this.b.delete(b),!0)}forEach(r,b){this.a.forEach((u,o)=>{r.call(b,u,o,this)})}keys(){return this.a.keys()}values(){return this.a.values()}}t.$Ec=l;class m{constructor(){this.a=new Map}add(r,b){let u=this.a.get(r);u||(u=new Set,this.a.set(r,u)),u.add(b)}delete(r,b){const u=this.a.get(r);u&&(u.delete(b),u.size===0&&this.a.delete(r))}forEach(r,b){const u=this.a.get(r);u&&u.forEach(b)}get(r){const b=this.a.get(r);return b||new Set}}t.$Fc=m}),define(be[2],pe([1,0,11,73,32,43,27]),function(ae,t,v,N,i,U,w){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$1c=t.$Zc=t.$Yc=t.$Xc=t.$Wc=t.$Vc=t.$Uc=t.$Tc=t.$Sc=t.$Rc=t.$Qc=t.$Pc=t.$Oc=t.$Nc=t.$Mc=t.$Lc=t.$Kc=t.$Jc=t.$Ic=t.$Hc=t.$Gc=void 0;const D=!1;let c=null;class f{constructor(){this.b=new Map}static{this.a=0}c(j){let ie=this.b.get(j);return ie||(ie={parent:null,source:null,isSingleton:!1,value:j,idx:f.a++},this.b.set(j,ie)),ie}trackDisposable(j){const ie=this.c(j);ie.source||(ie.source=new Error().stack)}setParent(j,ie){const te=this.c(j);te.parent=ie}markAsDisposed(j){this.b.delete(j)}markAsSingleton(j){this.c(j).isSingleton=!0}f(j,ie){const te=ie.get(j);if(te)return te;const ce=j.parent?this.f(this.c(j.parent),ie):j;return ie.set(j,ce),ce}getTrackedDisposables(){const j=new Map;return[...this.b.entries()].filter(([,te])=>te.source!==null&&!this.f(te,j).isSingleton).flatMap(([te])=>te)}computeLeakingDisposables(j=10,ie){let te;if(ie)te=ie;else{const Pe=new Map,Ae=[...this.b.values()].filter(de=>de.source!==null&&!this.f(de,Pe).isSingleton);if(Ae.length===0)return;const Re=new Set(Ae.map(de=>de.value));if(te=Ae.filter(de=>!(de.parent&&Re.has(de.parent))),te.length===0)throw new Error("There are cyclic diposable chains!")}if(!te)return;function ce(Pe){function Ae(de,ne){for(;de.length>0&&ne.some(fe=>typeof fe=="string"?fe===de[0]:de[0].match(fe));)de.shift()}const Re=Pe.source.split(`
`).map(de=>de.trim().replace("at ","")).filter(de=>de!=="");return Ae(Re,["Error",/^trackDisposable \(.*\)$/,/^DisposableTracker.trackDisposable \(.*\)$/]),Re.reverse()}const le=new i.$Fc;for(const Pe of te){const Ae=ce(Pe);for(let Re=0;Re<=Ae.length;Re++)le.add(Ae.slice(0,Re).join(`
`),Pe)}te.sort((0,v.$6b)(Pe=>Pe.idx,v.$8b));let oe="",we=0;for(const Pe of te.slice(0,j)){we++;const Ae=ce(Pe),Re=[];for(let de=0;de<Ae.length;de++){let ne=Ae[de];ne=`(shared with ${le.get(Ae.slice(0,de+1).join(`
`)).size}/${te.length} leaks) at ${ne}`;const Z=le.get(Ae.slice(0,de).join(`
`)),V=(0,N.$J)([...Z].map(Y=>ce(Y)[de]),Y=>Y);delete V[Ae[de]];for(const[Y,C]of Object.entries(V))Re.unshift(`    - stacktraces of ${C.length} other leaks continue with ${Y}`);Re.unshift(ne)}oe+=`


==================== Leaking disposable ${we}/${te.length}: ${Pe.value.constructor.name} ====================
${Re.join(`
`)}
============================================================

`}return te.length>j&&(oe+=`


... and ${te.length-j} more leaking disposables

`),{leaks:te,details:oe}}}t.$Gc=f;function d(B){c=B}if(t.$Hc=d,D){const B="__is_disposable_tracked__";d(new class{trackDisposable(j){const ie=new Error("Potentially leaked disposable").stack;setTimeout(()=>{j[B]||console.log(ie)},3e3)}setParent(j,ie){if(j&&j!==o.None)try{j[B]=!0}catch{}}markAsDisposed(j){if(j&&j!==o.None)try{j[B]=!0}catch{}}markAsSingleton(j){}})}function T(B){return c?.trackDisposable(B),B}t.$Ic=T;function s(B){c?.markAsDisposed(B)}t.$Jc=s;function a(B,j){c?.setParent(B,j)}function e(B,j){if(c)for(const ie of B)c.setParent(ie,j)}function h(B){return c?.markAsSingleton(B),B}t.$Kc=h;function l(B){return typeof B.dispose=="function"&&B.dispose.length===0}t.$Lc=l;function m(B){if(w.Iterable.is(B)){const j=[];for(const ie of B)if(ie)try{ie.dispose()}catch(te){j.push(te)}if(j.length===1)throw j[0];if(j.length>1)throw new AggregateError(j,"Encountered errors while disposing of store");return Array.isArray(B)?[]:B}else if(B)return B.dispose(),B}t.$Mc=m;function n(B){for(const j of B)l(j)&&j.dispose();return[]}t.$Nc=n;function r(...B){const j=b(()=>m(B));return e(B,j),j}t.$Oc=r;function b(B){const j=T({dispose:(0,U.$cb)(()=>{s(j),B()})});return j}t.$Pc=b;class u{static{this.DISABLE_DISPOSED_WARNING=!1}constructor(){this.f=new Set,this.g=!1,T(this)}dispose(){this.g||(s(this),this.g=!0,this.clear())}get isDisposed(){return this.g}clear(){if(this.f.size!==0)try{m(this.f)}finally{this.f.clear()}}add(j){if(!j)return j;if(j===this)throw new Error("Cannot register a disposable on itself!");return a(j,this),this.g?u.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this.f.add(j),j}delete(j){if(j){if(j===this)throw new Error("Cannot dispose a disposable on itself!");this.f.delete(j),j.dispose()}}deleteAndLeak(j){j&&this.f.has(j)&&(this.f.delete(j),a(j,null))}}t.$Qc=u;class o{static{this.None=Object.freeze({dispose(){}})}constructor(){this.q=new u,T(this),a(this.q,this)}dispose(){s(this),this.q.dispose()}B(j){if(j===this)throw new Error("Cannot register a disposable on itself!");return this.q.add(j)}}t.$Rc=o;class F{constructor(){this.b=!1,T(this)}get value(){return this.b?void 0:this.a}set value(j){this.b||j===this.a||(this.a?.dispose(),j&&a(j,this),this.a=j)}clear(){this.value=void 0}dispose(){this.b=!0,s(this),this.a?.dispose(),this.a=void 0}clearAndLeak(){const j=this.a;return this.a=void 0,j&&a(j,null),j}}t.$Sc=F;class z{constructor(j){this.a=new F,this.b=!1,this.a.value=j}get value(){return this.a.value}set value(j){this.b||j===this.a.value||(this.a.value=j)}dispose(){this.b=!0,this.a.dispose()}}t.$Tc=z;class R{constructor(j){this.b=j,this.a=1}acquire(){return this.a++,this}release(){return--this.a===0&&this.b.dispose(),this}}t.$Uc=R;class g{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,T(this)}set(j){let ie=j;return this.unset=()=>ie=void 0,this.isset=()=>ie!==void 0,this.dispose=()=>{ie&&(ie(),ie=void 0,s(this))},this}}t.$Vc=g;class y{constructor(){this.a=new Map}acquire(j,...ie){let te=this.a.get(j);te||(te={counter:0,object:this.b(j,...ie)},this.a.set(j,te));const{object:ce}=te,le=(0,U.$cb)(()=>{--te.counter===0&&(this.c(j,te.object),this.a.delete(j))});return te.counter++,{object:ce,dispose:le}}}t.$Wc=y;class M{constructor(j){this.a=j}async acquire(j,...ie){const te=this.a.acquire(j,...ie);try{return{object:await te.object,dispose:()=>te.dispose()}}catch(ce){throw te.dispose(),ce}}}t.$Xc=M;class _{constructor(j){this.object=j}dispose(){}}t.$Yc=_;function x(B){const j=new u;try{B(j)}finally{j.dispose()}}t.$Zc=x;class O{constructor(){this.a=new Map,this.b=!1,T(this)}dispose(){s(this),this.b=!0,this.clearAndDisposeAll()}clearAndDisposeAll(){if(this.a.size)try{m(this.a.values())}finally{this.a.clear()}}has(j){return this.a.has(j)}get size(){return this.a.size}get(j){return this.a.get(j)}set(j,ie,te=!1){this.b&&console.warn(new Error("Trying to add a disposable to a DisposableMap that has already been disposed of. The added object will be leaked!").stack),te||this.a.get(j)?.dispose(),this.a.set(j,ie)}deleteAndDispose(j){this.a.get(j)?.dispose(),this.a.delete(j)}keys(){return this.a.keys()}values(){return this.a.values()}[Symbol.iterator](){return this.a[Symbol.iterator]()}}t.$1c=O}),function(ae,t){typeof define=="function"&&define.amd?define(be[79],pe([0]),t):typeof exports=="object"&&typeof module<"u"?t(exports):(ae=typeof globalThis<"u"?globalThis:ae||self,t(ae.marked={}))}(this,function(ae){"use strict";function t(A,E){for(var I=0;I<E.length;I++){var k=E[I];k.enumerable=k.enumerable||!1,k.configurable=!0,"value"in k&&(k.writable=!0),Object.defineProperty(A,k.key,k)}}function v(A,E,I){return E&&t(A.prototype,E),I&&t(A,I),Object.defineProperty(A,"prototype",{writable:!1}),A}function N(A,E){if(A){if(typeof A=="string")return i(A,E);var I=Object.prototype.toString.call(A).slice(8,-1);if(I==="Object"&&A.constructor&&(I=A.constructor.name),I==="Map"||I==="Set")return Array.from(A);if(I==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(I))return i(A,E)}}function i(A,E){(E==null||E>A.length)&&(E=A.length);for(var I=0,k=new Array(E);I<E;I++)k[I]=A[I];return k}function U(A,E){var I=typeof Symbol<"u"&&A[Symbol.iterator]||A["@@iterator"];if(I)return(I=I.call(A)).next.bind(I);if(Array.isArray(A)||(I=N(A))||E&&A&&typeof A.length=="number"){I&&(A=I);var k=0;return function(){return k>=A.length?{done:!0}:{done:!1,value:A[k++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}function w(){return{async:!1,baseUrl:null,breaks:!1,extensions:null,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}ae.defaults=w();function D(A){ae.defaults=A}var c=/[&<>"']/,f=/[&<>"']/g,d=/[<>"']|&(?!#?\w+;)/,T=/[<>"']|&(?!#?\w+;)/g,s={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},a=function(E){return s[E]};function e(A,E){if(E){if(c.test(A))return A.replace(f,a)}else if(d.test(A))return A.replace(T,a);return A}var h=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function l(A){return A.replace(h,function(E,I){return I=I.toLowerCase(),I==="colon"?":":I.charAt(0)==="#"?I.charAt(1)==="x"?String.fromCharCode(parseInt(I.substring(2),16)):String.fromCharCode(+I.substring(1)):""})}var m=/(^|[^\[])\^/g;function n(A,E){A=typeof A=="string"?A:A.source,E=E||"";var I={replace:function(L,S){return S=S.source||S,S=S.replace(m,"$1"),A=A.replace(L,S),I},getRegex:function(){return new RegExp(A,E)}};return I}var r=/[^\w:]/g,b=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function u(A,E,I){if(A){var k;try{k=decodeURIComponent(l(I)).replace(r,"").toLowerCase()}catch{return null}if(k.indexOf("javascript:")===0||k.indexOf("vbscript:")===0||k.indexOf("data:")===0)return null}E&&!b.test(I)&&(I=g(E,I));try{I=encodeURI(I).replace(/%25/g,"%")}catch{return null}return I}var o={},F=/^[^:]+:\/*[^/]*$/,z=/^([^:]+:)[\s\S]*$/,R=/^([^:]+:\/*[^/]*)[\s\S]*$/;function g(A,E){o[" "+A]||(F.test(A)?o[" "+A]=A+"/":o[" "+A]=x(A,"/",!0)),A=o[" "+A];var I=A.indexOf(":")===-1;return E.substring(0,2)==="//"?I?E:A.replace(z,"$1")+E:E.charAt(0)==="/"?I?E:A.replace(R,"$1")+E:A+E}var y={exec:function(){}};function M(A){for(var E=1,I,k;E<arguments.length;E++){I=arguments[E];for(k in I)Object.prototype.hasOwnProperty.call(I,k)&&(A[k]=I[k])}return A}function _(A,E){var I=A.replace(/\|/g,function(S,P,H){for(var G=!1,ee=P;--ee>=0&&H[ee]==="\\";)G=!G;return G?"|":" |"}),k=I.split(/ \|/),L=0;if(k[0].trim()||k.shift(),k.length>0&&!k[k.length-1].trim()&&k.pop(),k.length>E)k.splice(E);else for(;k.length<E;)k.push("");for(;L<k.length;L++)k[L]=k[L].trim().replace(/\\\|/g,"|");return k}function x(A,E,I){var k=A.length;if(k===0)return"";for(var L=0;L<k;){var S=A.charAt(k-L-1);if(S===E&&!I)L++;else if(S!==E&&I)L++;else break}return A.slice(0,k-L)}function O(A,E){if(A.indexOf(E[1])===-1)return-1;for(var I=A.length,k=0,L=0;L<I;L++)if(A[L]==="\\")L++;else if(A[L]===E[0])k++;else if(A[L]===E[1]&&(k--,k<0))return L;return-1}function B(A){A&&A.sanitize&&!A.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function j(A,E){if(E<1)return"";for(var I="";E>1;)E&1&&(I+=A),E>>=1,A+=A;return I+A}function ie(A,E,I,k){var L=E.href,S=E.title?e(E.title):null,P=A[1].replace(/\\([\[\]])/g,"$1");if(A[0].charAt(0)!=="!"){k.state.inLink=!0;var H={type:"link",raw:I,href:L,title:S,text:P,tokens:k.inlineTokens(P)};return k.state.inLink=!1,H}return{type:"image",raw:I,href:L,title:S,text:e(P)}}function te(A,E){var I=A.match(/^(\s+)(?:```)/);if(I===null)return E;var k=I[1];return E.split(`
`).map(function(L){var S=L.match(/^\s+/);if(S===null)return L;var P=S[0];return P.length>=k.length?L.slice(k.length):L}).join(`
`)}var ce=function(){function A(I){this.options=I||ae.defaults}var E=A.prototype;return E.space=function(k){var L=this.rules.block.newline.exec(k);if(L&&L[0].length>0)return{type:"space",raw:L[0]}},E.code=function(k){var L=this.rules.block.code.exec(k);if(L){var S=L[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:L[0],codeBlockStyle:"indented",text:this.options.pedantic?S:x(S,`
`)}}},E.fences=function(k){var L=this.rules.block.fences.exec(k);if(L){var S=L[0],P=te(S,L[3]||"");return{type:"code",raw:S,lang:L[2]?L[2].trim():L[2],text:P}}},E.heading=function(k){var L=this.rules.block.heading.exec(k);if(L){var S=L[2].trim();if(/#$/.test(S)){var P=x(S,"#");(this.options.pedantic||!P||/ $/.test(P))&&(S=P.trim())}return{type:"heading",raw:L[0],depth:L[1].length,text:S,tokens:this.lexer.inline(S)}}},E.hr=function(k){var L=this.rules.block.hr.exec(k);if(L)return{type:"hr",raw:L[0]}},E.blockquote=function(k){var L=this.rules.block.blockquote.exec(k);if(L){var S=L[0].replace(/^ *>[ \t]?/gm,"");return{type:"blockquote",raw:L[0],tokens:this.lexer.blockTokens(S,[]),text:S}}},E.list=function(k){var L=this.rules.block.list.exec(k);if(L){var S,P,H,G,ee,se,me,ve,Fe,Ce,De,Te,Oe=L[1].trim(),We=Oe.length>1,He={type:"list",raw:"",ordered:We,start:We?+Oe.slice(0,-1):"",loose:!1,items:[]};Oe=We?"\\d{1,9}\\"+Oe.slice(-1):"\\"+Oe,this.options.pedantic&&(Oe=We?Oe:"[*+-]");for(var Me=new RegExp("^( {0,3}"+Oe+")((?:[	 ][^\\n]*)?(?:\\n|$))");k&&(Te=!1,!(!(L=Me.exec(k))||this.rules.block.hr.test(k)));){if(S=L[0],k=k.substring(S.length),ve=L[2].split(`
`,1)[0],Fe=k.split(`
`,1)[0],this.options.pedantic?(G=2,De=ve.trimLeft()):(G=L[2].search(/[^ ]/),G=G>4?1:G,De=ve.slice(G),G+=L[1].length),se=!1,!ve&&/^ *$/.test(Fe)&&(S+=Fe+`
`,k=k.substring(Fe.length+1),Te=!0),!Te)for(var Ye=new RegExp("^ {0,"+Math.min(3,G-1)+"}(?:[*+-]|\\d{1,9}[.)])((?: [^\\n]*)?(?:\\n|$))"),J=new RegExp("^ {0,"+Math.min(3,G-1)+"}((?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$)"),he=new RegExp("^ {0,"+Math.min(3,G-1)+"}(?:```|~~~)"),$e=new RegExp("^ {0,"+Math.min(3,G-1)+"}#");k&&(Ce=k.split(`
`,1)[0],ve=Ce,this.options.pedantic&&(ve=ve.replace(/^ {1,4}(?=( {4})*[^ ])/g,"  ")),!(he.test(ve)||$e.test(ve)||Ye.test(ve)||J.test(k)));){if(ve.search(/[^ ]/)>=G||!ve.trim())De+=`
`+ve.slice(G);else if(!se)De+=`
`+ve;else break;!se&&!ve.trim()&&(se=!0),S+=Ce+`
`,k=k.substring(Ce.length+1)}He.loose||(me?He.loose=!0:/\n *\n *$/.test(S)&&(me=!0)),this.options.gfm&&(P=/^\[[ xX]\] /.exec(De),P&&(H=P[0]!=="[ ] ",De=De.replace(/^\[[ xX]\] +/,""))),He.items.push({type:"list_item",raw:S,task:!!P,checked:H,loose:!1,text:De}),He.raw+=S}He.items[He.items.length-1].raw=S.trimRight(),He.items[He.items.length-1].text=De.trimRight(),He.raw=He.raw.trimRight();var Ee=He.items.length;for(ee=0;ee<Ee;ee++){this.lexer.state.top=!1,He.items[ee].tokens=this.lexer.blockTokens(He.items[ee].text,[]);var Se=He.items[ee].tokens.filter(function(Ue){return Ue.type==="space"}),Be=Se.every(function(Ue){for(var Ze=Ue.raw.split(""),Je=0,Qe=U(Ze),qe;!(qe=Qe()).done;){var tt=qe.value;if(tt===`
`&&(Je+=1),Je>1)return!0}return!1});!He.loose&&Se.length&&Be&&(He.loose=!0,He.items[ee].loose=!0)}return He}},E.html=function(k){var L=this.rules.block.html.exec(k);if(L){var S={type:"html",raw:L[0],pre:!this.options.sanitizer&&(L[1]==="pre"||L[1]==="script"||L[1]==="style"),text:L[0]};if(this.options.sanitize){var P=this.options.sanitizer?this.options.sanitizer(L[0]):e(L[0]);S.type="paragraph",S.text=P,S.tokens=this.lexer.inline(P)}return S}},E.def=function(k){var L=this.rules.block.def.exec(k);if(L){L[3]&&(L[3]=L[3].substring(1,L[3].length-1));var S=L[1].toLowerCase().replace(/\s+/g," ");return{type:"def",tag:S,raw:L[0],href:L[2],title:L[3]}}},E.table=function(k){var L=this.rules.block.table.exec(k);if(L){var S={type:"table",header:_(L[1]).map(function(me){return{text:me}}),align:L[2].replace(/^ *|\| *$/g,"").split(/ *\| */),rows:L[3]&&L[3].trim()?L[3].replace(/\n[ \t]*$/,"").split(`
`):[]};if(S.header.length===S.align.length){S.raw=L[0];var P=S.align.length,H,G,ee,se;for(H=0;H<P;H++)/^ *-+: *$/.test(S.align[H])?S.align[H]="right":/^ *:-+: *$/.test(S.align[H])?S.align[H]="center":/^ *:-+ *$/.test(S.align[H])?S.align[H]="left":S.align[H]=null;for(P=S.rows.length,H=0;H<P;H++)S.rows[H]=_(S.rows[H],S.header.length).map(function(me){return{text:me}});for(P=S.header.length,G=0;G<P;G++)S.header[G].tokens=this.lexer.inline(S.header[G].text);for(P=S.rows.length,G=0;G<P;G++)for(se=S.rows[G],ee=0;ee<se.length;ee++)se[ee].tokens=this.lexer.inline(se[ee].text);return S}}},E.lheading=function(k){var L=this.rules.block.lheading.exec(k);if(L)return{type:"heading",raw:L[0],depth:L[2].charAt(0)==="="?1:2,text:L[1],tokens:this.lexer.inline(L[1])}},E.paragraph=function(k){var L=this.rules.block.paragraph.exec(k);if(L){var S=L[1].charAt(L[1].length-1)===`
`?L[1].slice(0,-1):L[1];return{type:"paragraph",raw:L[0],text:S,tokens:this.lexer.inline(S)}}},E.text=function(k){var L=this.rules.block.text.exec(k);if(L)return{type:"text",raw:L[0],text:L[0],tokens:this.lexer.inline(L[0])}},E.escape=function(k){var L=this.rules.inline.escape.exec(k);if(L)return{type:"escape",raw:L[0],text:e(L[1])}},E.tag=function(k){var L=this.rules.inline.tag.exec(k);if(L)return!this.lexer.state.inLink&&/^<a /i.test(L[0])?this.lexer.state.inLink=!0:this.lexer.state.inLink&&/^<\/a>/i.test(L[0])&&(this.lexer.state.inLink=!1),!this.lexer.state.inRawBlock&&/^<(pre|code|kbd|script)(\s|>)/i.test(L[0])?this.lexer.state.inRawBlock=!0:this.lexer.state.inRawBlock&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(L[0])&&(this.lexer.state.inRawBlock=!1),{type:this.options.sanitize?"text":"html",raw:L[0],inLink:this.lexer.state.inLink,inRawBlock:this.lexer.state.inRawBlock,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(L[0]):e(L[0]):L[0]}},E.link=function(k){var L=this.rules.inline.link.exec(k);if(L){var S=L[2].trim();if(!this.options.pedantic&&/^</.test(S)){if(!/>$/.test(S))return;var P=x(S.slice(0,-1),"\\");if((S.length-P.length)%2===0)return}else{var H=O(L[2],"()");if(H>-1){var G=L[0].indexOf("!")===0?5:4,ee=G+L[1].length+H;L[2]=L[2].substring(0,H),L[0]=L[0].substring(0,ee).trim(),L[3]=""}}var se=L[2],me="";if(this.options.pedantic){var ve=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(se);ve&&(se=ve[1],me=ve[3])}else me=L[3]?L[3].slice(1,-1):"";return se=se.trim(),/^</.test(se)&&(this.options.pedantic&&!/>$/.test(S)?se=se.slice(1):se=se.slice(1,-1)),ie(L,{href:se&&se.replace(this.rules.inline._escapes,"$1"),title:me&&me.replace(this.rules.inline._escapes,"$1")},L[0],this.lexer)}},E.reflink=function(k,L){var S;if((S=this.rules.inline.reflink.exec(k))||(S=this.rules.inline.nolink.exec(k))){var P=(S[2]||S[1]).replace(/\s+/g," ");if(P=L[P.toLowerCase()],!P||!P.href){var H=S[0].charAt(0);return{type:"text",raw:H,text:H}}return ie(S,P,S[0],this.lexer)}},E.emStrong=function(k,L,S){S===void 0&&(S="");var P=this.rules.inline.emStrong.lDelim.exec(k);if(P&&!(P[3]&&S.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u0870-\u0887\u0889-\u088E\u08A0-\u08C9\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C5D\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u1711\u171F-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4C\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7CA\uA7D0\uA7D1\uA7D3\uA7D5-\uA7D9\uA7F2-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDD70-\uDD7A\uDD7C-\uDD8A\uDD8C-\uDD92\uDD94\uDD95\uDD97-\uDDA1\uDDA3-\uDDB1\uDDB3-\uDDB9\uDDBB\uDDBC\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67\uDF80-\uDF85\uDF87-\uDFB0\uDFB2-\uDFBA]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDF70-\uDF81\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC71\uDC72\uDC75\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B\uDF40-\uDF46]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEB0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|\uD80B[\uDF90-\uDFF0]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDE70-\uDEBE\uDEC0-\uDEC9\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82B[\uDFF0-\uDFF3\uDFF5-\uDFFB\uDFFD\uDFFE]|\uD82C[\uDC00-\uDD22\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD837[\uDF00-\uDF1E]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDE90-\uDEAD\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD839[\uDFE0-\uDFE6\uDFE8-\uDFEB\uDFED\uDFEE\uDFF0-\uDFFE]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDF\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF38\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var H=P[1]||P[2]||"";if(!H||H&&(S===""||this.rules.inline.punctuation.exec(S))){var G=P[0].length-1,ee,se,me=G,ve=0,Fe=P[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(Fe.lastIndex=0,L=L.slice(-1*k.length+G);(P=Fe.exec(L))!=null;)if(ee=P[1]||P[2]||P[3]||P[4]||P[5]||P[6],!!ee){if(se=ee.length,P[3]||P[4]){me+=se;continue}else if((P[5]||P[6])&&G%3&&!((G+se)%3)){ve+=se;continue}if(me-=se,!(me>0)){if(se=Math.min(se,se+me+ve),Math.min(G,se)%2){var Ce=k.slice(1,G+P.index+se);return{type:"em",raw:k.slice(0,G+P.index+se+1),text:Ce,tokens:this.lexer.inlineTokens(Ce)}}var De=k.slice(2,G+P.index+se-1);return{type:"strong",raw:k.slice(0,G+P.index+se+1),text:De,tokens:this.lexer.inlineTokens(De)}}}}}},E.codespan=function(k){var L=this.rules.inline.code.exec(k);if(L){var S=L[2].replace(/\n/g," "),P=/[^ ]/.test(S),H=/^ /.test(S)&&/ $/.test(S);return P&&H&&(S=S.substring(1,S.length-1)),S=e(S,!0),{type:"codespan",raw:L[0],text:S}}},E.br=function(k){var L=this.rules.inline.br.exec(k);if(L)return{type:"br",raw:L[0]}},E.del=function(k){var L=this.rules.inline.del.exec(k);if(L)return{type:"del",raw:L[0],text:L[2],tokens:this.lexer.inlineTokens(L[2])}},E.autolink=function(k,L){var S=this.rules.inline.autolink.exec(k);if(S){var P,H;return S[2]==="@"?(P=e(this.options.mangle?L(S[1]):S[1]),H="mailto:"+P):(P=e(S[1]),H=P),{type:"link",raw:S[0],text:P,href:H,tokens:[{type:"text",raw:P,text:P}]}}},E.url=function(k,L){var S;if(S=this.rules.inline.url.exec(k)){var P,H;if(S[2]==="@")P=e(this.options.mangle?L(S[0]):S[0]),H="mailto:"+P;else{var G;do G=S[0],S[0]=this.rules.inline._backpedal.exec(S[0])[0];while(G!==S[0]);P=e(S[0]),S[1]==="www."?H="http://"+P:H=P}return{type:"link",raw:S[0],text:P,href:H,tokens:[{type:"text",raw:P,text:P}]}}},E.inlineText=function(k,L){var S=this.rules.inline.text.exec(k);if(S){var P;return this.lexer.state.inRawBlock?P=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(S[0]):e(S[0]):S[0]:P=e(this.options.smartypants?L(S[0]):S[0]),{type:"text",raw:S[0],text:P}}},A}(),le={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?=\n|$)|$)/,hr:/^ {0,3}((?:-[\t ]*){3,}|(?:_[ \t]*){3,}|(?:\*[ \t]*){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3}bull)([ \t][^\n]+?)?(?:\n|$)/,html:"^ {0,3}(?:<(script|pre|style|textarea)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:(?:\\n *)+\\n|$)|<(?!script|pre|style|textarea)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$)|</(?!script|pre|style|textarea)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$))",def:/^ {0,3}\[(label)\]: *(?:\n *)?<?([^\s>]+)>?(?:(?: +(?:\n *)?| *\n *)(title))? *(?:\n+|$)/,table:y,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html|table| +\n)[^\n]+)*)/,text:/^[^\n]+/};le._label=/(?!\s*\])(?:\\.|[^\[\]\\])+/,le._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,le.def=n(le.def).replace("label",le._label).replace("title",le._title).getRegex(),le.bullet=/(?:[*+-]|\d{1,9}[.)])/,le.listItemStart=n(/^( *)(bull) */).replace("bull",le.bullet).getRegex(),le.list=n(le.list).replace(/bull/g,le.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+le.def.source+")").getRegex(),le._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",le._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,le.html=n(le.html,"i").replace("comment",le._comment).replace("tag",le._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),le.paragraph=n(le._paragraph).replace("hr",le.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("|table","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",le._tag).getRegex(),le.blockquote=n(le.blockquote).replace("paragraph",le.paragraph).getRegex(),le.normal=M({},le),le.gfm=M({},le.normal,{table:"^ *([^\\n ].*\\|.*)\\n {0,3}(?:\\| *)?(:?-+:? *(?:\\| *:?-+:? *)*)(?:\\| *)?(?:\\n((?:(?! *\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),le.gfm.table=n(le.gfm.table).replace("hr",le.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",le._tag).getRegex(),le.gfm.paragraph=n(le._paragraph).replace("hr",le.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("table",le.gfm.table).replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",le._tag).getRegex(),le.pedantic=M({},le.normal,{html:n(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",le._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:y,paragraph:n(le.normal._paragraph).replace("hr",le.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",le.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var oe={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:y,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(ref)\]/,nolink:/^!?\[(ref)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/^[^_*]*?\_\_[^_*]*?\*[^_*]*?(?=\_\_)|[^*]+(?=[^*])|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/^[^_*]*?\*\*[^_*]*?\_[^_*]*?(?=\*\*)|[^_]+(?=[^_])|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:y,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};oe._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",oe.punctuation=n(oe.punctuation).replace(/punctuation/g,oe._punctuation).getRegex(),oe.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,oe.escapedEmSt=/\\\*|\\_/g,oe._comment=n(le._comment).replace("(?:-->|$)","-->").getRegex(),oe.emStrong.lDelim=n(oe.emStrong.lDelim).replace(/punct/g,oe._punctuation).getRegex(),oe.emStrong.rDelimAst=n(oe.emStrong.rDelimAst,"g").replace(/punct/g,oe._punctuation).getRegex(),oe.emStrong.rDelimUnd=n(oe.emStrong.rDelimUnd,"g").replace(/punct/g,oe._punctuation).getRegex(),oe._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,oe._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,oe._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,oe.autolink=n(oe.autolink).replace("scheme",oe._scheme).replace("email",oe._email).getRegex(),oe._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,oe.tag=n(oe.tag).replace("comment",oe._comment).replace("attribute",oe._attribute).getRegex(),oe._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,oe._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,oe._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,oe.link=n(oe.link).replace("label",oe._label).replace("href",oe._href).replace("title",oe._title).getRegex(),oe.reflink=n(oe.reflink).replace("label",oe._label).replace("ref",le._label).getRegex(),oe.nolink=n(oe.nolink).replace("ref",le._label).getRegex(),oe.reflinkSearch=n(oe.reflinkSearch,"g").replace("reflink",oe.reflink).replace("nolink",oe.nolink).getRegex(),oe.normal=M({},oe),oe.pedantic=M({},oe.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:n(/^!?\[(label)\]\((.*?)\)/).replace("label",oe._label).getRegex(),reflink:n(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",oe._label).getRegex()}),oe.gfm=M({},oe.normal,{escape:n(oe.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)))/}),oe.gfm.url=n(oe.gfm.url,"i").replace("email",oe.gfm._extended_email).getRegex(),oe.breaks=M({},oe.gfm,{br:n(oe.br).replace("{2,}","*").getRegex(),text:n(oe.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});function we(A){return A.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function Pe(A){var E="",I,k,L=A.length;for(I=0;I<L;I++)k=A.charCodeAt(I),Math.random()>.5&&(k="x"+k.toString(16)),E+="&#"+k+";";return E}var Ae=function(){function A(I){this.tokens=[],this.tokens.links=Object.create(null),this.options=I||ae.defaults,this.options.tokenizer=this.options.tokenizer||new ce,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options,this.tokenizer.lexer=this,this.inlineQueue=[],this.state={inLink:!1,inRawBlock:!1,top:!0};var k={block:le.normal,inline:oe.normal};this.options.pedantic?(k.block=le.pedantic,k.inline=oe.pedantic):this.options.gfm&&(k.block=le.gfm,this.options.breaks?k.inline=oe.breaks:k.inline=oe.gfm),this.tokenizer.rules=k}A.lex=function(k,L){var S=new A(L);return S.lex(k)},A.lexInline=function(k,L){var S=new A(L);return S.inlineTokens(k)};var E=A.prototype;return E.lex=function(k){k=k.replace(/\r\n|\r/g,`
`),this.blockTokens(k,this.tokens);for(var L;L=this.inlineQueue.shift();)this.inlineTokens(L.src,L.tokens);return this.tokens},E.blockTokens=function(k,L){var S=this;L===void 0&&(L=[]),this.options.pedantic?k=k.replace(/\t/g,"    ").replace(/^ +$/gm,""):k=k.replace(/^( *)(\t+)/gm,function(me,ve,Fe){return ve+"    ".repeat(Fe.length)});for(var P,H,G,ee;k;)if(!(this.options.extensions&&this.options.extensions.block&&this.options.extensions.block.some(function(me){return(P=me.call({lexer:S},k,L))?(k=k.substring(P.raw.length),L.push(P),!0):!1}))){if(P=this.tokenizer.space(k)){k=k.substring(P.raw.length),P.raw.length===1&&L.length>0?L[L.length-1].raw+=`
`:L.push(P);continue}if(P=this.tokenizer.code(k)){k=k.substring(P.raw.length),H=L[L.length-1],H&&(H.type==="paragraph"||H.type==="text")?(H.raw+=`
`+P.raw,H.text+=`
`+P.text,this.inlineQueue[this.inlineQueue.length-1].src=H.text):L.push(P);continue}if(P=this.tokenizer.fences(k)){k=k.substring(P.raw.length),L.push(P);continue}if(P=this.tokenizer.heading(k)){k=k.substring(P.raw.length),L.push(P);continue}if(P=this.tokenizer.hr(k)){k=k.substring(P.raw.length),L.push(P);continue}if(P=this.tokenizer.blockquote(k)){k=k.substring(P.raw.length),L.push(P);continue}if(P=this.tokenizer.list(k)){k=k.substring(P.raw.length),L.push(P);continue}if(P=this.tokenizer.html(k)){k=k.substring(P.raw.length),L.push(P);continue}if(P=this.tokenizer.def(k)){k=k.substring(P.raw.length),H=L[L.length-1],H&&(H.type==="paragraph"||H.type==="text")?(H.raw+=`
`+P.raw,H.text+=`
`+P.raw,this.inlineQueue[this.inlineQueue.length-1].src=H.text):this.tokens.links[P.tag]||(this.tokens.links[P.tag]={href:P.href,title:P.title});continue}if(P=this.tokenizer.table(k)){k=k.substring(P.raw.length),L.push(P);continue}if(P=this.tokenizer.lheading(k)){k=k.substring(P.raw.length),L.push(P);continue}if(G=k,this.options.extensions&&this.options.extensions.startBlock&&function(){var me=1/0,ve=k.slice(1),Fe=void 0;S.options.extensions.startBlock.forEach(function(Ce){Fe=Ce.call({lexer:this},ve),typeof Fe=="number"&&Fe>=0&&(me=Math.min(me,Fe))}),me<1/0&&me>=0&&(G=k.substring(0,me+1))}(),this.state.top&&(P=this.tokenizer.paragraph(G))){H=L[L.length-1],ee&&H.type==="paragraph"?(H.raw+=`
`+P.raw,H.text+=`
`+P.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=H.text):L.push(P),ee=G.length!==k.length,k=k.substring(P.raw.length);continue}if(P=this.tokenizer.text(k)){k=k.substring(P.raw.length),H=L[L.length-1],H&&H.type==="text"?(H.raw+=`
`+P.raw,H.text+=`
`+P.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=H.text):L.push(P);continue}if(k){var se="Infinite loop on byte: "+k.charCodeAt(0);if(this.options.silent){console.error(se);break}else throw new Error(se)}}return this.state.top=!0,L},E.inline=function(k,L){return L===void 0&&(L=[]),this.inlineQueue.push({src:k,tokens:L}),L},E.inlineTokens=function(k,L){var S=this;L===void 0&&(L=[]);var P,H,G,ee=k,se,me,ve;if(this.tokens.links){var Fe=Object.keys(this.tokens.links);if(Fe.length>0)for(;(se=this.tokenizer.rules.inline.reflinkSearch.exec(ee))!=null;)Fe.includes(se[0].slice(se[0].lastIndexOf("[")+1,-1))&&(ee=ee.slice(0,se.index)+"["+j("a",se[0].length-2)+"]"+ee.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(se=this.tokenizer.rules.inline.blockSkip.exec(ee))!=null;)ee=ee.slice(0,se.index)+"["+j("a",se[0].length-2)+"]"+ee.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(se=this.tokenizer.rules.inline.escapedEmSt.exec(ee))!=null;)ee=ee.slice(0,se.index)+"++"+ee.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;k;)if(me||(ve=""),me=!1,!(this.options.extensions&&this.options.extensions.inline&&this.options.extensions.inline.some(function(De){return(P=De.call({lexer:S},k,L))?(k=k.substring(P.raw.length),L.push(P),!0):!1}))){if(P=this.tokenizer.escape(k)){k=k.substring(P.raw.length),L.push(P);continue}if(P=this.tokenizer.tag(k)){k=k.substring(P.raw.length),H=L[L.length-1],H&&P.type==="text"&&H.type==="text"?(H.raw+=P.raw,H.text+=P.text):L.push(P);continue}if(P=this.tokenizer.link(k)){k=k.substring(P.raw.length),L.push(P);continue}if(P=this.tokenizer.reflink(k,this.tokens.links)){k=k.substring(P.raw.length),H=L[L.length-1],H&&P.type==="text"&&H.type==="text"?(H.raw+=P.raw,H.text+=P.text):L.push(P);continue}if(P=this.tokenizer.emStrong(k,ee,ve)){k=k.substring(P.raw.length),L.push(P);continue}if(P=this.tokenizer.codespan(k)){k=k.substring(P.raw.length),L.push(P);continue}if(P=this.tokenizer.br(k)){k=k.substring(P.raw.length),L.push(P);continue}if(P=this.tokenizer.del(k)){k=k.substring(P.raw.length),L.push(P);continue}if(P=this.tokenizer.autolink(k,Pe)){k=k.substring(P.raw.length),L.push(P);continue}if(!this.state.inLink&&(P=this.tokenizer.url(k,Pe))){k=k.substring(P.raw.length),L.push(P);continue}if(G=k,this.options.extensions&&this.options.extensions.startInline&&function(){var De=1/0,Te=k.slice(1),Oe=void 0;S.options.extensions.startInline.forEach(function(We){Oe=We.call({lexer:this},Te),typeof Oe=="number"&&Oe>=0&&(De=Math.min(De,Oe))}),De<1/0&&De>=0&&(G=k.substring(0,De+1))}(),P=this.tokenizer.inlineText(G,we)){k=k.substring(P.raw.length),P.raw.slice(-1)!=="_"&&(ve=P.raw.slice(-1)),me=!0,H=L[L.length-1],H&&H.type==="text"?(H.raw+=P.raw,H.text+=P.text):L.push(P);continue}if(k){var Ce="Infinite loop on byte: "+k.charCodeAt(0);if(this.options.silent){console.error(Ce);break}else throw new Error(Ce)}}return L},v(A,null,[{key:"rules",get:function(){return{block:le,inline:oe}}}]),A}(),Re=function(){function A(I){this.options=I||ae.defaults}var E=A.prototype;return E.code=function(k,L,S){var P=(L||"").match(/\S*/)[0];if(this.options.highlight){var H=this.options.highlight(k,P);H!=null&&H!==k&&(S=!0,k=H)}return k=k.replace(/\n$/,"")+`
`,P?'<pre><code class="'+this.options.langPrefix+e(P,!0)+'">'+(S?k:e(k,!0))+`</code></pre>
`:"<pre><code>"+(S?k:e(k,!0))+`</code></pre>
`},E.blockquote=function(k){return`<blockquote>
`+k+`</blockquote>
`},E.html=function(k){return k},E.heading=function(k,L,S,P){if(this.options.headerIds){var H=this.options.headerPrefix+P.slug(S);return"<h"+L+' id="'+H+'">'+k+"</h"+L+`>
`}return"<h"+L+">"+k+"</h"+L+`>
`},E.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},E.list=function(k,L,S){var P=L?"ol":"ul",H=L&&S!==1?' start="'+S+'"':"";return"<"+P+H+`>
`+k+"</"+P+`>
`},E.listitem=function(k){return"<li>"+k+`</li>
`},E.checkbox=function(k){return"<input "+(k?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},E.paragraph=function(k){return"<p>"+k+`</p>
`},E.table=function(k,L){return L&&(L="<tbody>"+L+"</tbody>"),`<table>
<thead>
`+k+`</thead>
`+L+`</table>
`},E.tablerow=function(k){return`<tr>
`+k+`</tr>
`},E.tablecell=function(k,L){var S=L.header?"th":"td",P=L.align?"<"+S+' align="'+L.align+'">':"<"+S+">";return P+k+("</"+S+`>
`)},E.strong=function(k){return"<strong>"+k+"</strong>"},E.em=function(k){return"<em>"+k+"</em>"},E.codespan=function(k){return"<code>"+k+"</code>"},E.br=function(){return this.options.xhtml?"<br/>":"<br>"},E.del=function(k){return"<del>"+k+"</del>"},E.link=function(k,L,S){if(k=u(this.options.sanitize,this.options.baseUrl,k),k===null)return S;var P='<a href="'+e(k)+'"';return L&&(P+=' title="'+L+'"'),P+=">"+S+"</a>",P},E.image=function(k,L,S){if(k=u(this.options.sanitize,this.options.baseUrl,k),k===null)return S;var P='<img src="'+k+'" alt="'+S+'"';return L&&(P+=' title="'+L+'"'),P+=this.options.xhtml?"/>":">",P},E.text=function(k){return k},A}(),de=function(){function A(){}var E=A.prototype;return E.strong=function(k){return k},E.em=function(k){return k},E.codespan=function(k){return k},E.del=function(k){return k},E.html=function(k){return k},E.text=function(k){return k},E.link=function(k,L,S){return""+S},E.image=function(k,L,S){return""+S},E.br=function(){return""},A}(),ne=function(){function A(){this.seen={}}var E=A.prototype;return E.serialize=function(k){return k.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},E.getNextSafeSlug=function(k,L){var S=k,P=0;if(this.seen.hasOwnProperty(S)){P=this.seen[k];do P++,S=k+"-"+P;while(this.seen.hasOwnProperty(S))}return L||(this.seen[k]=P,this.seen[S]=0),S},E.slug=function(k,L){L===void 0&&(L={});var S=this.serialize(k);return this.getNextSafeSlug(S,L.dryrun)},A}(),fe=function(){function A(I){this.options=I||ae.defaults,this.options.renderer=this.options.renderer||new Re,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new de,this.slugger=new ne}A.parse=function(k,L){var S=new A(L);return S.parse(k)},A.parseInline=function(k,L){var S=new A(L);return S.parseInline(k)};var E=A.prototype;return E.parse=function(k,L){L===void 0&&(L=!0);var S="",P,H,G,ee,se,me,ve,Fe,Ce,De,Te,Oe,We,He,Me,Ye,J,he,$e,Ee=k.length;for(P=0;P<Ee;P++){if(De=k[P],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[De.type]&&($e=this.options.extensions.renderers[De.type].call({parser:this},De),$e!==!1||!["space","hr","heading","code","table","blockquote","list","html","paragraph","text"].includes(De.type))){S+=$e||"";continue}switch(De.type){case"space":continue;case"hr":{S+=this.renderer.hr();continue}case"heading":{S+=this.renderer.heading(this.parseInline(De.tokens),De.depth,l(this.parseInline(De.tokens,this.textRenderer)),this.slugger);continue}case"code":{S+=this.renderer.code(De.text,De.lang,De.escaped);continue}case"table":{for(Fe="",ve="",ee=De.header.length,H=0;H<ee;H++)ve+=this.renderer.tablecell(this.parseInline(De.header[H].tokens),{header:!0,align:De.align[H]});for(Fe+=this.renderer.tablerow(ve),Ce="",ee=De.rows.length,H=0;H<ee;H++){for(me=De.rows[H],ve="",se=me.length,G=0;G<se;G++)ve+=this.renderer.tablecell(this.parseInline(me[G].tokens),{header:!1,align:De.align[G]});Ce+=this.renderer.tablerow(ve)}S+=this.renderer.table(Fe,Ce);continue}case"blockquote":{Ce=this.parse(De.tokens),S+=this.renderer.blockquote(Ce);continue}case"list":{for(Te=De.ordered,Oe=De.start,We=De.loose,ee=De.items.length,Ce="",H=0;H<ee;H++)Me=De.items[H],Ye=Me.checked,J=Me.task,He="",Me.task&&(he=this.renderer.checkbox(Ye),We?Me.tokens.length>0&&Me.tokens[0].type==="paragraph"?(Me.tokens[0].text=he+" "+Me.tokens[0].text,Me.tokens[0].tokens&&Me.tokens[0].tokens.length>0&&Me.tokens[0].tokens[0].type==="text"&&(Me.tokens[0].tokens[0].text=he+" "+Me.tokens[0].tokens[0].text)):Me.tokens.unshift({type:"text",text:he}):He+=he),He+=this.parse(Me.tokens,We),Ce+=this.renderer.listitem(He,J,Ye);S+=this.renderer.list(Ce,Te,Oe);continue}case"html":{S+=this.renderer.html(De.text);continue}case"paragraph":{S+=this.renderer.paragraph(this.parseInline(De.tokens));continue}case"text":{for(Ce=De.tokens?this.parseInline(De.tokens):De.text;P+1<Ee&&k[P+1].type==="text";)De=k[++P],Ce+=`
`+(De.tokens?this.parseInline(De.tokens):De.text);S+=L?this.renderer.paragraph(Ce):Ce;continue}default:{var Se='Token with "'+De.type+'" type was not found.';if(this.options.silent){console.error(Se);return}else throw new Error(Se)}}}return S},E.parseInline=function(k,L){L=L||this.renderer;var S="",P,H,G,ee=k.length;for(P=0;P<ee;P++){if(H=k[P],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[H.type]&&(G=this.options.extensions.renderers[H.type].call({parser:this},H),G!==!1||!["escape","html","link","image","strong","em","codespan","br","del","text"].includes(H.type))){S+=G||"";continue}switch(H.type){case"escape":{S+=L.text(H.text);break}case"html":{S+=L.html(H.text);break}case"link":{S+=L.link(H.href,H.title,this.parseInline(H.tokens,L));break}case"image":{S+=L.image(H.href,H.title,H.text);break}case"strong":{S+=L.strong(this.parseInline(H.tokens,L));break}case"em":{S+=L.em(this.parseInline(H.tokens,L));break}case"codespan":{S+=L.codespan(H.text);break}case"br":{S+=L.br();break}case"del":{S+=L.del(this.parseInline(H.tokens,L));break}case"text":{S+=L.text(H.text);break}default:{var se='Token with "'+H.type+'" type was not found.';if(this.options.silent){console.error(se);return}else throw new Error(se)}}}return S},A}();function Z(A,E,I){if(typeof A>"u"||A===null)throw new Error("marked(): input parameter is undefined or null");if(typeof A!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(A)+", string expected");if(typeof E=="function"&&(I=E,E=null),E=M({},Z.defaults,E||{}),B(E),I){var k=E.highlight,L;try{L=Ae.lex(A,E)}catch(ee){return I(ee)}var S=function(se){var me;if(!se)try{E.walkTokens&&Z.walkTokens(L,E.walkTokens),me=fe.parse(L,E)}catch(ve){se=ve}return E.highlight=k,se?I(se):I(null,me)};if(!k||k.length<3||(delete E.highlight,!L.length))return S();var P=0;Z.walkTokens(L,function(ee){ee.type==="code"&&(P++,setTimeout(function(){k(ee.text,ee.lang,function(se,me){if(se)return S(se);me!=null&&me!==ee.text&&(ee.text=me,ee.escaped=!0),P--,P===0&&S()})},0))}),P===0&&S();return}function H(ee){if(ee.message+=`
Please report this to https://github.com/markedjs/marked.`,E.silent)return"<p>An error occurred:</p><pre>"+e(ee.message+"",!0)+"</pre>";throw ee}try{var G=Ae.lex(A,E);if(E.walkTokens){if(E.async)return Promise.all(Z.walkTokens(G,E.walkTokens)).then(function(){return fe.parse(G,E)}).catch(H);Z.walkTokens(G,E.walkTokens)}return fe.parse(G,E)}catch(ee){H(ee)}}Z.options=Z.setOptions=function(A){return M(Z.defaults,A),D(Z.defaults),Z},Z.getDefaults=w,Z.defaults=ae.defaults,Z.use=function(){for(var A=arguments.length,E=new Array(A),I=0;I<A;I++)E[I]=arguments[I];var k=M.apply(void 0,[{}].concat(E)),L=Z.defaults.extensions||{renderers:{},childTokens:{}},S;E.forEach(function(P){if(P.extensions&&(S=!0,P.extensions.forEach(function(G){if(!G.name)throw new Error("extension name required");if(G.renderer){var ee=L.renderers?L.renderers[G.name]:null;ee?L.renderers[G.name]=function(){for(var se=arguments.length,me=new Array(se),ve=0;ve<se;ve++)me[ve]=arguments[ve];var Fe=G.renderer.apply(this,me);return Fe===!1&&(Fe=ee.apply(this,me)),Fe}:L.renderers[G.name]=G.renderer}if(G.tokenizer){if(!G.level||G.level!=="block"&&G.level!=="inline")throw new Error("extension level must be 'block' or 'inline'");L[G.level]?L[G.level].unshift(G.tokenizer):L[G.level]=[G.tokenizer],G.start&&(G.level==="block"?L.startBlock?L.startBlock.push(G.start):L.startBlock=[G.start]:G.level==="inline"&&(L.startInline?L.startInline.push(G.start):L.startInline=[G.start]))}G.childTokens&&(L.childTokens[G.name]=G.childTokens)})),P.renderer&&function(){var G=Z.defaults.renderer||new Re,ee=function(ve){var Fe=G[ve];G[ve]=function(){for(var Ce=arguments.length,De=new Array(Ce),Te=0;Te<Ce;Te++)De[Te]=arguments[Te];var Oe=P.renderer[ve].apply(G,De);return Oe===!1&&(Oe=Fe.apply(G,De)),Oe}};for(var se in P.renderer)ee(se);k.renderer=G}(),P.tokenizer&&function(){var G=Z.defaults.tokenizer||new ce,ee=function(ve){var Fe=G[ve];G[ve]=function(){for(var Ce=arguments.length,De=new Array(Ce),Te=0;Te<Ce;Te++)De[Te]=arguments[Te];var Oe=P.tokenizer[ve].apply(G,De);return Oe===!1&&(Oe=Fe.apply(G,De)),Oe}};for(var se in P.tokenizer)ee(se);k.tokenizer=G}(),P.walkTokens){var H=Z.defaults.walkTokens;k.walkTokens=function(G){var ee=[];return ee.push(P.walkTokens.call(this,G)),H&&(ee=ee.concat(H.call(this,G))),ee}}S&&(k.extensions=L),Z.setOptions(k)})},Z.walkTokens=function(A,E){for(var I=[],k=function(){var H=S.value;switch(I=I.concat(E.call(Z,H)),H.type){case"table":{for(var G=U(H.header),ee;!(ee=G()).done;){var se=ee.value;I=I.concat(Z.walkTokens(se.tokens,E))}for(var me=U(H.rows),ve;!(ve=me()).done;)for(var Fe=ve.value,Ce=U(Fe),De;!(De=Ce()).done;){var Te=De.value;I=I.concat(Z.walkTokens(Te.tokens,E))}break}case"list":{I=I.concat(Z.walkTokens(H.items,E));break}default:Z.defaults.extensions&&Z.defaults.extensions.childTokens&&Z.defaults.extensions.childTokens[H.type]?Z.defaults.extensions.childTokens[H.type].forEach(function(Oe){I=I.concat(Z.walkTokens(H[Oe],E))}):H.tokens&&(I=I.concat(Z.walkTokens(H.tokens,E)))}},L=U(A),S;!(S=L()).done;)k();return I},Z.parseInline=function(A,E){if(typeof A>"u"||A===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof A!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(A)+", string expected");E=M({},Z.defaults,E||{}),B(E);try{var I=Ae.lexInline(A,E);return E.walkTokens&&Z.walkTokens(I,E.walkTokens),fe.parseInline(I,E)}catch(k){if(k.message+=`
Please report this to https://github.com/markedjs/marked.`,E.silent)return"<p>An error occurred:</p><pre>"+e(k.message+"",!0)+"</pre>";throw k}},Z.Parser=fe,Z.parser=fe.parse,Z.Renderer=Re,Z.TextRenderer=de,Z.Lexer=Ae,Z.lexer=Ae.lex,Z.Tokenizer=ce,Z.Slugger=ne,Z.parse=Z;var V=Z.options,Y=Z.setOptions,C=Z.use,q=Z.walkTokens,$=Z.parseInline,W=Z,Q=fe.parse,p=Ae.lex;ae.Lexer=Ae,ae.Parser=fe,ae.Renderer=Re,ae.Slugger=ne,ae.TextRenderer=de,ae.Tokenizer=ce,ae.getDefaults=w,ae.lexer=p,ae.marked=Z,ae.options=V,ae.parse=W,ae.parseInline=$,ae.parser=Q,ae.setOptions=Y,ae.use=C,ae.walkTokens=q,Object.defineProperty(ae,"__esModule",{value:!0})}),define(be[80],pe([1,0]),function(ae,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$jS=void 0;class v{constructor(i,U=0,w=i.length,D=U-1){this.a=i,this.b=U,this.c=w,this.d=D}current(){return this.d===this.b-1||this.d===this.c?null:this.a[this.d]}next(){return this.d=Math.min(this.d+1,this.c),this.current()}previous(){return this.d=Math.max(this.d-1,this.b-1),this.current()}first(){return this.d=this.b,this.current()}last(){return this.d=this.c-1,this.current()}}t.$jS=v}),define(be[81],pe([1,0,80]),function(ae,t,v){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$lS=t.$kS=void 0;class N{constructor(w=[],D=10){this.h(w),this.b=D,this.d()}getHistory(){return this.j}add(w){this.a.delete(w),this.a.add(w),this.d()}next(){return this.c.next()}previous(){return this.g()!==0?this.c.previous():null}current(){return this.c.current()}first(){return this.c.first()}last(){return this.c.last()}isFirst(){return this.g()===0}isLast(){return this.g()>=this.j.length-1}isNowhere(){return this.c.current()===null}has(w){return this.a.has(w)}clear(){this.h([]),this.d()}d(){this.f();const w=this.j;this.c=new v.$jS(w,0,w.length,w.length)}f(){const w=this.j;w.length>this.b&&this.h(w.slice(w.length-this.b))}g(){const w=this.c.current();return w?this.j.indexOf(w):-1}h(w){this.a=new Set;for(const D of w)this.a.add(D)}get j(){const w=[];return this.a.forEach(D=>w.push(D)),w}}t.$kS=N;class i{get size(){return this.f}constructor(w,D=10){if(this.g=D,w.length<1)throw new Error("not supported");this.f=1,this.b=this.c=this.d={value:w[0],previous:void 0,next:void 0},this.a=new Set([w[0]]);for(let c=1;c<w.length;c++)this.add(w[c])}add(w){const D={value:w,previous:this.c,next:void 0};for(this.c.next=D,this.c=D,this.d=this.c,this.f++,this.a.has(w)?this.h(w):this.a.add(w);this.f>this.g;)this.a.delete(this.b.value),this.b=this.b.next,this.b.previous=void 0,this.f--}replaceLast(w){if(this.c.value===w)return w;const D=this.c.value;return this.a.delete(D),this.c.value=w,this.a.has(w)?this.h(w):this.a.add(w),D}prepend(w){if(this.f===this.g||this.a.has(w))return;const D={value:w,previous:void 0,next:this.b};this.b.previous=D,this.b=D,this.f++,this.a.add(w)}isAtEnd(){return this.d===this.c}current(){return this.d.value}previous(){return this.d.previous&&(this.d=this.d.previous),this.d.value}next(){return this.d.next&&(this.d=this.d.next),this.d.value}has(w){return this.a.has(w)}resetCursor(){return this.d=this.c,this.d.value}*[Symbol.iterator](){let w=this.b;for(;w;)yield w.value,w=w.next}h(w){let D=this.b;for(;D!==this.c;)D.value===w&&(D===this.b?(this.b=this.b.next,this.b.previous=void 0):(D.previous.next=D.next,D.next.previous=D.previous),this.f--),D=D.next}}t.$lS=i}),define(be[46],pe([1,0]),function(ae,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Yl=t.$Xl=t.$Wl=t.rot=t.$Ul=void 0;function v(D,c,f){return Math.min(Math.max(D,c),f)}t.$Ul=v;function N(D,c){return(c+D%c)%c}t.rot=N;class i{constructor(){this.a=0}getNext(){return this.a++}}t.$Wl=i;class U{constructor(){this.a=1,this.b=0}update(c){return this.b=this.b+(c-this.b)/this.a,this.a+=1,this.b}get value(){return this.b}}t.$Xl=U;class w{constructor(c){this.a=0,this.b=0,this.c=[],this.d=0,this.e=0,this.c=new Array(c),this.c.fill(0,0,c)}update(c){const f=this.c[this.d];return this.c[this.d]=c,this.d=(this.d+1)%this.c.length,this.e-=f,this.e+=c,this.a<this.c.length&&(this.a+=1),this.b=this.e/this.a,this.b}get value(){return this.b}}t.$Yl=w}),define(be[47],pe([1,0]),function(ae,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Range=void 0;var v;(function(N){function i(c,f){if(c.start>=f.end||f.start>=c.end)return{start:0,end:0};const d=Math.max(c.start,f.start),T=Math.min(c.end,f.end);return T-d<=0?{start:0,end:0}:{start:d,end:T}}N.intersect=i;function U(c){return c.end-c.start<=0}N.isEmpty=U;function w(c,f){return!U(i(c,f))}N.intersects=w;function D(c,f){const d=[],T={start:c.start,end:Math.min(f.start,c.end)},s={start:Math.max(f.end,c.start),end:c.end};return U(T)||d.push(T),U(s)||d.push(s),d}N.relativeComplement=D})(v||(t.Range=v={}))}),define(be[82],pe([1,0,47]),function(ae,t,v){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$cR=t.$bR=t.$aR=t.$_Q=void 0;function N(c,f){const d=[];for(const T of f){if(c.start>=T.range.end)continue;if(c.end<T.range.start)break;const s=v.Range.intersect(c,T.range);v.Range.isEmpty(s)||d.push({range:s,size:T.size})}return d}t.$_Q=N;function i({start:c,end:f},d){return{start:c+d,end:f+d}}t.$aR=i;function U(c){const f=[];let d=null;for(const T of c){const s=T.range.start,a=T.range.end,e=T.size;if(d&&e===d.size){d.range.end=a;continue}d={range:{start:s,end:a},size:e},f.push(d)}return f}t.$bR=U;function w(...c){return U(c.reduce((f,d)=>f.concat(d),[]))}class D{get paddingTop(){return this.c}set paddingTop(f){this.b=this.b+f-this.c,this.c=f}constructor(f){this.a=[],this.b=0,this.c=0,this.c=f??0,this.b=this.c}splice(f,d,T=[]){const s=T.length-d,a=N({start:0,end:f},this.a),e=N({start:f+d,end:Number.POSITIVE_INFINITY},this.a).map(l=>({range:i(l.range,s),size:l.size})),h=T.map((l,m)=>({range:{start:f+m,end:f+m+1},size:l.size}));this.a=w(a,h,e),this.b=this.c+this.a.reduce((l,m)=>l+m.size*(m.range.end-m.range.start),0)}get count(){const f=this.a.length;return f?this.a[f-1].range.end:0}get size(){return this.b}indexAt(f){if(f<0)return-1;if(f<this.c)return 0;let d=0,T=this.c;for(const s of this.a){const a=s.range.end-s.range.start,e=T+a*s.size;if(f<e)return d+Math.floor((f-T)/s.size);d+=a,T=e}return d}indexAfter(f){return Math.min(this.indexAt(f)+1,this.count)}positionAt(f){if(f<0)return-1;let d=0,T=0;for(const s of this.a){const a=s.range.end-s.range.start,e=T+a;if(f<e)return this.c+d+(f-T)*s.size;d+=a*s.size,T=e}return-1}}t.$cR=D}),define(be[83],pe([1,0]),function(ae,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Nd=void 0;const v=globalThis.performance&&typeof globalThis.performance.now=="function";class N{static create(U){return new N(U)}constructor(U){this.c=v&&U===!1?Date.now:globalThis.performance.now.bind(globalThis.performance),this.a=this.c(),this.b=-1}stop(){this.b=this.c()}reset(){this.a=this.c(),this.b=-1}elapsed(){return this.b!==-1?this.b-this.a:this.c()-this.a}}t.$Nd=N}),define(be[4],pe([1,0,6,43,2,45,83]),function(ae,t,v,N,i,U,w){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$1d=t.$Zd=t.$Yd=t.$Xd=t.$Wd=t.$Vd=t.$Ud=t.$Td=t.$Sd=t.$Rd=t.$Qd=t.$Pd=t.Event=void 0;const D=!1,c=!1;var f;(function(x){x.None=()=>i.$Rc.None;function O(L){if(c){const{onDidAddListener:S}=L,P=e.create();let H=0;L.onDidAddListener=()=>{++H===2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),P.print()),S?.()}}}function B(L,S){return Re(L,()=>{},0,void 0,!0,void 0,S)}x.defer=B;function j(L){return(S,P=null,H)=>{let G=!1,ee;return ee=L(se=>{if(!G)return ee?ee.dispose():G=!0,S.call(P,se)},null,H),G&&ee.dispose(),ee}}x.once=j;function ie(L,S,P){return Pe((H,G=null,ee)=>L(se=>H.call(G,S(se)),null,ee),P)}x.map=ie;function te(L,S,P){return Pe((H,G=null,ee)=>L(se=>{S(se),H.call(G,se)},null,ee),P)}x.forEach=te;function ce(L,S,P){return Pe((H,G=null,ee)=>L(se=>S(se)&&H.call(G,se),null,ee),P)}x.filter=ce;function le(L){return L}x.signal=le;function oe(...L){return(S,P=null,H)=>{const G=(0,i.$Oc)(...L.map(ee=>ee(se=>S.call(P,se))));return Ae(G,H)}}x.any=oe;function we(L,S,P,H){let G=P;return ie(L,ee=>(G=S(G,ee),G),H)}x.reduce=we;function Pe(L,S){let P;const H={onWillAddFirstListener(){P=L(G.fire,G)},onDidRemoveLastListener(){P?.dispose()}};S||O(H);const G=new r(H);return S?.add(G),G.event}function Ae(L,S){return S instanceof Array?S.push(L):S&&S.add(L),L}function Re(L,S,P=100,H=!1,G=!1,ee,se){let me,ve,Fe,Ce=0,De;const Te={leakWarningThreshold:ee,onWillAddFirstListener(){me=L(We=>{Ce++,ve=S(ve,We),H&&!Fe&&(Oe.fire(ve),ve=void 0),De=()=>{const He=ve;ve=void 0,Fe=void 0,(!H||Ce>1)&&Oe.fire(He),Ce=0},typeof P=="number"?(clearTimeout(Fe),Fe=setTimeout(De,P)):Fe===void 0&&(Fe=0,queueMicrotask(De))})},onWillRemoveListener(){G&&Ce>0&&De?.()},onDidRemoveLastListener(){De=void 0,me.dispose()}};se||O(Te);const Oe=new r(Te);return se?.add(Oe),Oe.event}x.debounce=Re;function de(L,S=0,P){return x.debounce(L,(H,G)=>H?(H.push(G),H):[G],S,void 0,!0,void 0,P)}x.accumulate=de;function ne(L,S=(H,G)=>H===G,P){let H=!0,G;return ce(L,ee=>{const se=H||!S(ee,G);return H=!1,G=ee,se},P)}x.latch=ne;function fe(L,S,P){return[x.filter(L,S,P),x.filter(L,H=>!S(H),P)]}x.split=fe;function Z(L,S=!1,P=[],H){let G=P.slice(),ee=L(ve=>{G?G.push(ve):me.fire(ve)});H&&H.add(ee);const se=()=>{G?.forEach(ve=>me.fire(ve)),G=null},me=new r({onWillAddFirstListener(){ee||(ee=L(ve=>me.fire(ve)),H&&H.add(ee))},onDidAddFirstListener(){G&&(S?setTimeout(se):se())},onDidRemoveLastListener(){ee&&ee.dispose(),ee=null}});return H&&H.add(me),me.event}x.buffer=Z;function V(L,S){return(H,G,ee)=>{const se=S(new C);return L(function(me){const ve=se.evaluate(me);ve!==Y&&H.call(G,ve)},void 0,ee)}}x.chain=V;const Y=Symbol("HaltChainable");class C{constructor(){this.f=[]}map(S){return this.f.push(S),this}forEach(S){return this.f.push(P=>(S(P),P)),this}filter(S){return this.f.push(P=>S(P)?P:Y),this}reduce(S,P){let H=P;return this.f.push(G=>(H=S(H,G),H)),this}latch(S=(P,H)=>P===H){let P=!0,H;return this.f.push(G=>{const ee=P||!S(G,H);return P=!1,H=G,ee?G:Y}),this}evaluate(S){for(const P of this.f)if(S=P(S),S===Y)break;return S}}function q(L,S,P=H=>H){const H=(...me)=>se.fire(P(...me)),G=()=>L.on(S,H),ee=()=>L.removeListener(S,H),se=new r({onWillAddFirstListener:G,onDidRemoveLastListener:ee});return se.event}x.fromNodeEventEmitter=q;function $(L,S,P=H=>H){const H=(...me)=>se.fire(P(...me)),G=()=>L.addEventListener(S,H),ee=()=>L.removeEventListener(S,H),se=new r({onWillAddFirstListener:G,onDidRemoveLastListener:ee});return se.event}x.fromDOMEventEmitter=$;function W(L){return new Promise(S=>j(L)(S))}x.toPromise=W;function Q(L){const S=new r;return L.then(P=>{S.fire(P)},()=>{S.fire(void 0)}).finally(()=>{S.dispose()}),S.event}x.fromPromise=Q;function p(L,S,P){return S(P),L(H=>S(H))}x.runAndSubscribe=p;function A(L,S){let P=null;function H(ee){P?.dispose(),P=new i.$Qc,S(ee,P)}H(void 0);const G=L(ee=>H(ee));return(0,i.$Pc)(()=>{G.dispose(),P?.dispose()})}x.runAndSubscribeWithStore=A;class E{constructor(S,P){this._observable=S,this.f=0,this.g=!1;const H={onWillAddFirstListener:()=>{S.addObserver(this)},onDidRemoveLastListener:()=>{S.removeObserver(this)}};P||O(H),this.emitter=new r(H),P&&P.add(this.emitter)}beginUpdate(S){this.f++}handlePossibleChange(S){}handleChange(S,P){this.g=!0}endUpdate(S){this.f--,this.f===0&&(this._observable.reportChanges(),this.g&&(this.g=!1,this.emitter.fire(this._observable.get())))}}function I(L,S){return new E(L,S).emitter.event}x.fromObservable=I;function k(L){return S=>{let P=0,H=!1;const G={beginUpdate(){P++},endUpdate(){P--,P===0&&(L.reportChanges(),H&&(H=!1,S()))},handlePossibleChange(){},handleChange(){H=!0}};return L.addObserver(G),L.reportChanges(),{dispose(){L.removeObserver(G)}}}}x.fromObservableLight=k})(f||(t.Event=f={}));class d{static{this.all=new Set}static{this.f=0}constructor(O){this.listenerCount=0,this.invocationCount=0,this.elapsedOverall=0,this.durations=[],this.name=`${O}_${d.f++}`,d.all.add(this)}start(O){this.g=new w.$Nd,this.listenerCount=O}stop(){if(this.g){const O=this.g.elapsed();this.durations.push(O),this.elapsedOverall+=O,this.invocationCount+=1,this.g=void 0}}}t.$Pd=d;let T=-1;function s(x){const O=T;return T=x,{dispose(){T=O}}}t.$Qd=s;class a{constructor(O,B=Math.random().toString(18).slice(2,5)){this.threshold=O,this.name=B,this.g=0}dispose(){this.f?.clear()}check(O,B){const j=this.threshold;if(j<=0||B<j)return;this.f||(this.f=new Map);const ie=this.f.get(O.value)||0;if(this.f.set(O.value,ie+1),this.g-=1,this.g<=0){this.g=j*.5;let te,ce=0;for(const[le,oe]of this.f)(!te||ce<oe)&&(te=le,ce=oe);console.warn(`[${this.name}] potential listener LEAK detected, having ${B} listeners already. MOST frequent listener (${ce}):`),console.warn(te)}return()=>{const te=this.f.get(O.value)||0;this.f.set(O.value,te-1)}}}class e{static create(){return new e(new Error().stack??"")}constructor(O){this.value=O}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}let h=0;class l{constructor(O){this.value=O,this.id=h++}}const m=2,n=(x,O)=>{if(x instanceof l)O(x);else for(let B=0;B<x.length;B++){const j=x[B];j&&O(j)}};class r{constructor(O){this.w=0,this.f=O,this.g=T>0||this.f?.leakWarningThreshold?new a(this.f?.leakWarningThreshold??T):void 0,this.j=this.f?._profName?new d(this.f._profName):void 0,this.u=this.f?.deliveryQueue}dispose(){if(!this.m){if(this.m=!0,this.u?.current===this&&this.u.reset(),this.t){if(D){const O=this.t;queueMicrotask(()=>{n(O,B=>B.stack?.print())})}this.t=void 0,this.w=0}this.f?.onDidRemoveLastListener?.(),this.g?.dispose()}}get event(){return this.q??=(O,B,j)=>{if(this.g&&this.w>this.g.threshold*3)return console.warn(`[${this.g.name}] REFUSES to accept new listeners because it exceeded its threshold by far`),i.$Rc.None;if(this.m)return i.$Rc.None;B&&(O=O.bind(B));const ie=new l(O);let te,ce;this.g&&this.w>=Math.ceil(this.g.threshold*.2)&&(ie.stack=e.create(),te=this.g.check(ie.stack,this.w+1)),D&&(ie.stack=ce??e.create()),this.t?this.t instanceof l?(this.u??=new u,this.t=[this.t,ie]):this.t.push(ie):(this.f?.onWillAddFirstListener?.(this),this.t=ie,this.f?.onDidAddFirstListener?.(this)),this.w++;const le=(0,i.$Pc)(()=>{te?.(),this.x(ie)});return j instanceof i.$Qc?j.add(le):Array.isArray(j)&&j.push(le),le},this.q}x(O){if(this.f?.onWillRemoveListener?.(this),!this.t)return;if(this.w===1){this.t=void 0,this.f?.onDidRemoveLastListener?.(this),this.w=0;return}const B=this.t,j=B.indexOf(O);if(j===-1)throw console.log("disposed?",this.m),console.log("size?",this.w),console.log("arr?",JSON.stringify(this.t)),new Error("Attempted to dispose unknown listener");this.w--,B[j]=void 0;const ie=this.u.current===this;if(this.w*m<=B.length){let te=0;for(let ce=0;ce<B.length;ce++)B[ce]?B[te++]=B[ce]:ie&&(this.u.end--,te<this.u.i&&this.u.i--);B.length=te}}y(O,B){if(!O)return;const j=this.f?.onListenerError||v.$Z;if(!j){O.value(B);return}try{O.value(B)}catch(ie){j(ie)}}z(O){const B=O.current.t;for(;O.i<O.end;)this.y(B[O.i++],O.value);O.reset()}fire(O){if(this.u?.current&&(this.z(this.u),this.j?.stop()),this.j?.start(this.w),this.t)if(this.t instanceof l)this.y(this.t,O);else{const B=this.u;B.enqueue(this,O,this.t.length),this.z(B)}this.j?.stop()}hasListeners(){return this.w>0}}t.$Rd=r;const b=()=>new u;t.$Sd=b;class u{constructor(){this.i=-1,this.end=0}enqueue(O,B,j){this.i=0,this.end=j,this.current=O,this.value=B}reset(){this.i=this.end,this.current=void 0,this.value=void 0}}class o extends r{async fireAsync(O,B,j){if(this.t)for(this.h||(this.h=new U.$2c),n(this.t,ie=>this.h.push([ie.value,O]));this.h.size>0&&!B.isCancellationRequested;){const[ie,te]=this.h.shift(),ce=[],le={...te,token:B,waitUntil:oe=>{if(Object.isFrozen(ce))throw new Error("waitUntil can NOT be called asynchronous");j&&(oe=j(oe,ie)),ce.push(oe)}};try{ie(le)}catch(oe){(0,v.$Z)(oe);continue}Object.freeze(ce),await Promise.allSettled(ce).then(oe=>{for(const we of oe)we.status==="rejected"&&(0,v.$Z)(we.reason)})}}}t.$Td=o;class F extends r{get isPaused(){return this.h!==0}constructor(O){super(O),this.h=0,this.s=new U.$2c,this.A=O?.merge}pause(){this.h++}resume(){if(this.h!==0&&--this.h===0)if(this.A){if(this.s.size>0){const O=Array.from(this.s);this.s.clear(),super.fire(this.A(O))}}else for(;!this.h&&this.s.size!==0;)super.fire(this.s.shift())}fire(O){this.w&&(this.h!==0?this.s.push(O):super.fire(O))}}t.$Ud=F;class z extends F{constructor(O){super(O),this.k=O.delay??100}fire(O){this.o||(this.pause(),this.o=setTimeout(()=>{this.o=void 0,this.resume()},this.k)),super.fire(O)}}t.$Vd=z;class R extends r{constructor(O){super(O),this.h=[],this.k=O?.merge}fire(O){this.hasListeners()&&(this.h.push(O),this.h.length===1&&queueMicrotask(()=>{this.k?super.fire(this.k(this.h)):this.h.forEach(B=>super.fire(B)),this.h=[]}))}}t.$Wd=R;class g{constructor(){this.g=!1,this.h=[],this.f=new r({onWillAddFirstListener:()=>this.j(),onDidRemoveLastListener:()=>this.k()})}get event(){return this.f.event}add(O){const B={event:O,listener:null};this.h.push(B),this.g&&this.m(B);const j=()=>{this.g&&this.o(B);const ie=this.h.indexOf(B);this.h.splice(ie,1)};return(0,i.$Pc)((0,N.$cb)(j))}j(){this.g=!0,this.h.forEach(O=>this.m(O))}k(){this.g=!1,this.h.forEach(O=>this.o(O))}m(O){O.listener=O.event(B=>this.f.fire(B))}o(O){O.listener&&O.listener.dispose(),O.listener=null}dispose(){this.f.dispose()}}t.$Xd=g;class y{constructor(O,B,j,ie){this.f=new i.$Qc;const te=this.f.add(new g),ce=this.f.add(new i.$1c);function le(oe){ce.set(oe,te.add(ie(oe)))}for(const oe of O)le(oe);this.f.add(B(oe=>{le(oe)})),this.f.add(j(oe=>{ce.deleteAndDispose(oe)})),this.event=te.event}dispose(){this.f.dispose()}}t.$Yd=y;class M{constructor(){this.f=[]}wrapEvent(O){return(B,j,ie)=>O(te=>{const ce=this.f[this.f.length-1];ce?ce.push(()=>B.call(j,te)):B.call(j,te)},void 0,ie)}bufferEvents(O){const B=[];this.f.push(B);const j=O();return this.f.pop(),B.forEach(ie=>ie()),j}}t.$Zd=M;class _{constructor(){this.f=!1,this.g=f.None,this.h=i.$Rc.None,this.j=new r({onDidAddFirstListener:()=>{this.f=!0,this.h=this.g(this.j.fire,this.j)},onDidRemoveLastListener:()=>{this.f=!1,this.h.dispose()}}),this.event=this.j.event}set input(O){this.g=O,this.f&&(this.h.dispose(),this.h=O(this.j.fire,this.j))}dispose(){this.h.dispose(),this.j.dispose()}}t.$1d=_}),define(be[16],pe([1,0,21,4,2]),function(ae,t,v,N,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$QO=t.$PO=t.$OO=t.$NO=t.$MO=t.$LO=t.$KO=t.$JO=t.$IO=t.$HO=t.$GO=t.$FO=t.$EO=t.$DO=t.$CO=t.$BO=t.$AO=t.$zO=void 0;class U{constructor(){this.a=0,this.b=1,this.c=!1,this.d=new N.$Rd,this.onDidChangeFullscreen=this.d.event}static{this.INSTANCE=new U}getZoomLevel(){return this.a}setZoomLevel(u){this.a!==u&&(this.a=u)}getZoomFactor(){return this.b}setZoomFactor(u){this.b=u}setFullscreen(u){this.c!==u&&(this.c=u,this.d.fire())}isFullscreen(){return this.c}}class w extends i.$Rc{constructor(){super(),this.a=this.B(new N.$Rd),this.onDidChange=this.a.event,this.b=()=>this.f(!0),this.c=null,this.f(!1)}f(u){this.c?.removeEventListener("change",this.b),this.c=v.$window.matchMedia(`(resolution: ${v.$window.devicePixelRatio}dppx)`),this.c.addEventListener("change",this.b),u&&this.a.fire()}}class D extends i.$Rc{get value(){return this.b}constructor(){super(),this.a=this.B(new N.$Rd),this.onDidChange=this.a.event,this.b=this.c();const u=this.B(new w);this.B(u.onDidChange(()=>{this.b=this.c(),this.a.fire(this.b)}))}c(){const u=document.createElement("canvas").getContext("2d"),o=v.$window.devicePixelRatio||1,F=u.webkitBackingStorePixelRatio||u.mozBackingStorePixelRatio||u.msBackingStorePixelRatio||u.oBackingStorePixelRatio||u.backingStorePixelRatio||1;return o/F}}class c{constructor(){this.a=null}b(){return this.a||(this.a=(0,i.$Kc)(new D)),this.a}get value(){return this.b().value}get onDidChange(){return this.b().onDidChange}}function f(b,u){typeof b=="string"&&(b=v.$window.matchMedia(b)),b.addEventListener("change",u)}t.$zO=f,t.$AO=new c;function d(b){U.INSTANCE.setZoomLevel(b)}t.$BO=d;function T(){return U.INSTANCE.getZoomLevel()}t.$CO=T;function s(){return U.INSTANCE.getZoomFactor()}t.$DO=s;function a(b){U.INSTANCE.setZoomFactor(b)}t.$EO=a;function e(b){U.INSTANCE.setFullscreen(b)}t.$FO=e;function h(){return U.INSTANCE.isFullscreen()}t.$GO=h,t.$HO=U.INSTANCE.onDidChangeFullscreen;const l=navigator.userAgent;t.$IO=l.indexOf("Firefox")>=0,t.$JO=l.indexOf("AppleWebKit")>=0,t.$KO=l.indexOf("Chrome")>=0,t.$LO=!t.$KO&&l.indexOf("Safari")>=0,t.$MO=!t.$KO&&!t.$LO&&t.$JO,t.$NO=l.indexOf("Electron/")>=0,t.$OO=l.indexOf("Android")>=0;let m=!1;if(v.$window.matchMedia){const b=v.$window.matchMedia("(display-mode: standalone) or (display-mode: window-controls-overlay)"),u=v.$window.matchMedia("(display-mode: fullscreen)");m=b.matches,f(b,({matches:o})=>{m&&u.matches||(m=o)})}function n(){return m}t.$PO=n;function r(){return navigator?.windowControlsOverlay?.visible}t.$QO=r}),define(be[22],pe([1,0,4]),function(ae,t,v){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$4Q=void 0;class N{get event(){return this.a.event}constructor(U,w,D){const c=f=>this.a.fire(f);this.a=new v.$Rd({onWillAddFirstListener:()=>U.addEventListener(w,c,D),onDidRemoveLastListener:()=>U.removeEventListener(w,c,D)})}dispose(){this.a.dispose()}}t.$4Q=N}),define(be[29],pe([1,0,4]),function(ae,t,v){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$2d=t.CancellationToken=void 0;const N=Object.freeze(function(D,c){const f=setTimeout(D.bind(c),0);return{dispose(){clearTimeout(f)}}});var i;(function(D){function c(f){return f===D.None||f===D.Cancelled||f instanceof U?!0:!f||typeof f!="object"?!1:typeof f.isCancellationRequested=="boolean"&&typeof f.onCancellationRequested=="function"}D.isCancellationToken=c,D.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:v.Event.None}),D.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:N})})(i||(t.CancellationToken=i={}));class U{constructor(){this.a=!1,this.b=null}cancel(){this.a||(this.a=!0,this.b&&(this.b.fire(void 0),this.dispose()))}get isCancellationRequested(){return this.a}get onCancellationRequested(){return this.a?N:(this.b||(this.b=new v.$Rd),this.b.event)}dispose(){this.b&&(this.b.dispose(),this.b=null)}}class w{constructor(c){this.f=void 0,this.g=void 0,this.g=c&&c.onCancellationRequested(this.cancel,this)}get token(){return this.f||(this.f=new U),this.f}cancel(){this.f?this.f instanceof U&&this.f.cancel():this.f=i.Cancelled}dispose(c=!1){c&&this.cancel(),this.g?.dispose(),this.f?this.f instanceof U&&this.f.dispose():this.f=i.None}}t.$2d=w}),define(be[84],pe([1,0,29]),function(ae,t,v){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Ce=t.$Be=t.$Ae=void 0;class N{constructor(D){this.b=D,this.a=null}get(){if(this.a)return this.a;const D=new v.$2d,c=this.b(D.token);return this.a={promise:c,dispose:()=>{this.a=null,D.cancel(),D.dispose()}},this.a}}t.$Ae=N;class i{constructor(D){this.c=D,this.a=void 0,this.b=void 0}get(D){const c=JSON.stringify(D);return this.b!==c&&(this.b=c,this.a=this.c(D)),this.a}}t.$Be=i;class U{get cachedValues(){return this.a}constructor(D){this.b=D,this.a=new Map}get(D){if(this.a.has(D))return this.a.get(D);const c=this.b(D);return this.a.set(D,c),c}}t.$Ce=U}),define(be[48],pe([1,0,4,2]),function(ae,t,v,N){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$4r=t.$3r=t.$2r=t.$1r=t.ScrollbarVisibility=void 0;var i;(function(a){a[a.Auto=1]="Auto",a[a.Hidden=2]="Hidden",a[a.Visible=3]="Visible"})(i||(t.ScrollbarVisibility=i={}));class U{constructor(e,h,l,m,n,r,b){this.c=e,this._scrollStateBrand=void 0,this.c&&(h=h|0,l=l|0,m=m|0,n=n|0,r=r|0,b=b|0),this.rawScrollLeft=m,this.rawScrollTop=b,h<0&&(h=0),m+h>l&&(m=l-h),m<0&&(m=0),n<0&&(n=0),b+n>r&&(b=r-n),b<0&&(b=0),this.width=h,this.scrollWidth=l,this.scrollLeft=m,this.height=n,this.scrollHeight=r,this.scrollTop=b}equals(e){return this.rawScrollLeft===e.rawScrollLeft&&this.rawScrollTop===e.rawScrollTop&&this.width===e.width&&this.scrollWidth===e.scrollWidth&&this.scrollLeft===e.scrollLeft&&this.height===e.height&&this.scrollHeight===e.scrollHeight&&this.scrollTop===e.scrollTop}withScrollDimensions(e,h){return new U(this.c,typeof e.width<"u"?e.width:this.width,typeof e.scrollWidth<"u"?e.scrollWidth:this.scrollWidth,h?this.rawScrollLeft:this.scrollLeft,typeof e.height<"u"?e.height:this.height,typeof e.scrollHeight<"u"?e.scrollHeight:this.scrollHeight,h?this.rawScrollTop:this.scrollTop)}withScrollPosition(e){return new U(this.c,this.width,this.scrollWidth,typeof e.scrollLeft<"u"?e.scrollLeft:this.rawScrollLeft,this.height,this.scrollHeight,typeof e.scrollTop<"u"?e.scrollTop:this.rawScrollTop)}createScrollEvent(e,h){const l=this.width!==e.width,m=this.scrollWidth!==e.scrollWidth,n=this.scrollLeft!==e.scrollLeft,r=this.height!==e.height,b=this.scrollHeight!==e.scrollHeight,u=this.scrollTop!==e.scrollTop;return{inSmoothScrolling:h,oldWidth:e.width,oldScrollWidth:e.scrollWidth,oldScrollLeft:e.scrollLeft,width:this.width,scrollWidth:this.scrollWidth,scrollLeft:this.scrollLeft,oldHeight:e.height,oldScrollHeight:e.scrollHeight,oldScrollTop:e.scrollTop,height:this.height,scrollHeight:this.scrollHeight,scrollTop:this.scrollTop,widthChanged:l,scrollWidthChanged:m,scrollLeftChanged:n,heightChanged:r,scrollHeightChanged:b,scrollTopChanged:u}}}t.$1r=U;class w extends N.$Rc{constructor(e){super(),this._scrollableBrand=void 0,this.j=this.B(new v.$Rd),this.onScroll=this.j.event,this.c=e.smoothScrollDuration,this.f=e.scheduleAtNextAnimationFrame,this.g=new U(e.forceIntegerValues,0,0,0,0,0,0),this.h=null}dispose(){this.h&&(this.h.dispose(),this.h=null),super.dispose()}setSmoothScrollDuration(e){this.c=e}validateScrollPosition(e){return this.g.withScrollPosition(e)}getScrollDimensions(){return this.g}setScrollDimensions(e,h){const l=this.g.withScrollDimensions(e,h);this.n(l,!!this.h),this.h?.acceptScrollDimensions(this.g)}getFutureScrollPosition(){return this.h?this.h.to:this.g}getCurrentScrollPosition(){return this.g}setScrollPositionNow(e){const h=this.g.withScrollPosition(e);this.h&&(this.h.dispose(),this.h=null),this.n(h,!1)}setScrollPositionSmooth(e,h){if(this.c===0)return this.setScrollPositionNow(e);if(this.h){e={scrollLeft:typeof e.scrollLeft>"u"?this.h.to.scrollLeft:e.scrollLeft,scrollTop:typeof e.scrollTop>"u"?this.h.to.scrollTop:e.scrollTop};const l=this.g.withScrollPosition(e);if(this.h.to.scrollLeft===l.scrollLeft&&this.h.to.scrollTop===l.scrollTop)return;let m;h?m=new d(this.h.from,l,this.h.startTime,this.h.duration):m=this.h.combine(this.g,l,this.c),this.h.dispose(),this.h=m}else{const l=this.g.withScrollPosition(e);this.h=d.start(this.g,l,this.c)}this.h.animationFrameDisposable=this.f(()=>{this.h&&(this.h.animationFrameDisposable=null,this.m())})}hasPendingScrollAnimation(){return!!this.h}m(){if(!this.h)return;const e=this.h.tick(),h=this.g.withScrollPosition(e);if(this.n(h,!0),!!this.h){if(e.isDone){this.h.dispose(),this.h=null;return}this.h.animationFrameDisposable=this.f(()=>{this.h&&(this.h.animationFrameDisposable=null,this.m())})}}n(e,h){const l=this.g;l.equals(e)||(this.g=e,this.j.fire(this.g.createScrollEvent(l,h)))}}t.$2r=w;class D{constructor(e,h,l){this.scrollLeft=e,this.scrollTop=h,this.isDone=l}}t.$3r=D;function c(a,e){const h=e-a;return function(l){return a+h*s(l)}}function f(a,e,h){return function(l){return l<h?a(l/h):e((l-h)/(1-h))}}class d{constructor(e,h,l,m){this.from=e,this.to=h,this.duration=m,this.startTime=l,this.animationFrameDisposable=null,this.e()}e(){this.c=this.f(this.from.scrollLeft,this.to.scrollLeft,this.to.width),this.d=this.f(this.from.scrollTop,this.to.scrollTop,this.to.height)}f(e,h,l){if(Math.abs(e-h)>2.5*l){let n,r;return e<h?(n=e+.75*l,r=h-.75*l):(n=e-.75*l,r=h+.75*l),f(c(e,n),c(r,h),.33)}return c(e,h)}dispose(){this.animationFrameDisposable!==null&&(this.animationFrameDisposable.dispose(),this.animationFrameDisposable=null)}acceptScrollDimensions(e){this.to=e.withScrollPosition(this.to),this.e()}tick(){return this.g(Date.now())}g(e){const h=(e-this.startTime)/this.duration;if(h<1){const l=this.c(h),m=this.d(h);return new D(l,m,!1)}return new D(this.to.scrollLeft,this.to.scrollTop,!0)}combine(e,h,l){return d.start(e,h,l)}static start(e,h,l){l=l+10;const m=Date.now()-10;return new d(e,h,m,l)}}t.$4r=d;function T(a){return Math.pow(a,3)}function s(a){return 1-T(1-a)}}),define(be[85],pe([1,0,6,2]),function(ae,t,v,N){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$ee=t.$de=t.$ce=t.$be=t.$ae=t.$_d=t.$$d=t.$0d=t.$9d=t.$8d=t.$7d=t.$6d=t.$5d=t.$4d=t.$3d=void 0;function i(b){const u=b;return u?typeof u.read=="function":!1}t.$3d=i;function U(b){const u=b;return u?[u.on,u.pause,u.resume,u.destroy].every(o=>typeof o=="function"):!1}t.$4d=U;function w(b){const u=b;return u?U(u.stream)&&Array.isArray(u.buffer)&&typeof u.ended=="boolean":!1}t.$5d=w;function D(b,u){return new c(b,u)}t.$6d=D;class c{constructor(u,o){this.e=u,this.f=o,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(u){if(!this.a.destroyed){if(this.a.flowing)this.g(u);else if(this.b.data.push(u),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(o=>this.d.push(o))}}error(u){this.a.destroyed||(this.a.flowing?this.h(u):this.b.error.push(u))}end(u){this.a.destroyed||(typeof u<"u"&&this.write(u),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(u){this.c.data.slice(0).forEach(o=>o(u))}h(u){this.c.error.length===0?(0,v.$Z)(u):this.c.error.slice(0).forEach(o=>o(u))}i(){this.c.end.slice(0).forEach(u=>u())}on(u,o){if(!this.a.destroyed)switch(u){case"data":this.c.data.push(o),this.resume();break;case"end":this.c.end.push(o),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(o),this.a.flowing&&this.k();break}}removeListener(u,o){if(this.a.destroyed)return;let F;switch(u){case"data":F=this.c.data;break;case"end":F=this.c.end;break;case"error":F=this.c.error;break}if(F){const z=F.indexOf(o);z>=0&&F.splice(z,1)}}j(){if(this.b.data.length>0){const u=this.e(this.b.data);this.g(u),this.b.data.length=0;const o=[...this.d];this.d.length=0,o.forEach(F=>F())}}k(){if(this.c.error.length>0){for(const u of this.b.error)this.h(u);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function f(b,u){const o=[];let F;for(;(F=b.read())!==null;)o.push(F);return u(o)}t.$7d=f;function d(b,u,o){const F=[];let z;for(;(z=b.read())!==null&&F.length<o;)F.push(z);return z===null&&F.length>0?u(F):{read:()=>{if(F.length>0)return F.shift();if(typeof z<"u"){const R=z;return z=void 0,R}return b.read()}}}t.$8d=d;function T(b,u){return new Promise((o,F)=>{const z=[];s(b,{onData:R=>{u&&z.push(R)},onError:R=>{u?F(R):o(void 0)},onEnd:()=>{o(u?u(z):void 0)}})})}t.$9d=T;function s(b,u,o){b.on("error",F=>{o?.isCancellationRequested||u.onError(F)}),b.on("end",()=>{o?.isCancellationRequested||u.onEnd()}),b.on("data",F=>{o?.isCancellationRequested||u.onData(F)})}t.$0d=s;function a(b,u){return new Promise((o,F)=>{const z=new N.$Qc,R=[],g=_=>{if(R.push(_),R.length>u)return z.dispose(),b.pause(),o({stream:b,buffer:R,ended:!1})},y=_=>(z.dispose(),F(_)),M=()=>(z.dispose(),o({stream:b,buffer:R,ended:!0}));z.add((0,N.$Pc)(()=>b.removeListener("error",y))),b.on("error",y),z.add((0,N.$Pc)(()=>b.removeListener("end",M))),b.on("end",M),z.add((0,N.$Pc)(()=>b.removeListener("data",g))),b.on("data",g)})}t.$$d=a;function e(b,u){const o=D(u);return o.end(b),o}t.$_d=e;function h(){const b=D(()=>{throw new Error("not supported")});return b.end(),b}t.$ae=h;function l(b){let u=!1;return{read:()=>u?null:(u=!0,b)}}t.$be=l;function m(b,u,o){const F=D(o);return s(b,{onData:z=>F.write(u.data(z)),onError:z=>F.error(u.error?u.error(z):z),onEnd:()=>F.end()}),F}t.$ce=m;function n(b,u,o){let F=!1;return{read:()=>{const z=u.read();return F?z:(F=!0,z!==null?o([b,z]):b)}}}t.$de=n;function r(b,u,o){let F=!1;const z=D(o);return s(u,{onData:R=>F?z.write(R):(F=!0,z.write(o([b,R]))),onError:R=>z.error(R),onEnd:()=>{F||(F=!0,z.write(b)),z.end()}}),z}t.$ee=r}),define(be[33],pe([1,0,28,85]),function(ae,t,v,N){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$ze=t.$ye=t.$xe=t.$we=t.$ve=t.$ue=t.$te=t.$se=t.$re=t.$qe=t.$pe=t.$oe=t.$ne=t.$me=t.$le=t.$ke=t.$je=t.$ie=t.$he=t.$ge=t.$fe=void 0;const i=typeof Buffer<"u",U=new v.$U(()=>new Uint8Array(256));let w,D;class c{static alloc(B){return i?new c(Buffer.allocUnsafe(B)):new c(new Uint8Array(B))}static wrap(B){return i&&!Buffer.isBuffer(B)&&(B=Buffer.from(B.buffer,B.byteOffset,B.byteLength)),new c(B)}static fromString(B,j){return!(j?.dontUseNodeBuffer||!1)&&i?new c(Buffer.from(B)):(w||(w=new TextEncoder),new c(w.encode(B)))}static fromByteArray(B){const j=c.alloc(B.length);for(let ie=0,te=B.length;ie<te;ie++)j.buffer[ie]=B[ie];return j}static concat(B,j){if(typeof j>"u"){j=0;for(let ce=0,le=B.length;ce<le;ce++)j+=B[ce].byteLength}const ie=c.alloc(j);let te=0;for(let ce=0,le=B.length;ce<le;ce++){const oe=B[ce];ie.set(oe,te),te+=oe.byteLength}return ie}constructor(B){this.buffer=B,this.byteLength=this.buffer.byteLength}clone(){const B=c.alloc(this.byteLength);return B.set(this),B}toString(){return i?this.buffer.toString():(D||(D=new TextDecoder),D.decode(this.buffer))}slice(B,j){return new c(this.buffer.subarray(B,j))}set(B,j){if(B instanceof c)this.buffer.set(B.buffer,j);else if(B instanceof Uint8Array)this.buffer.set(B,j);else if(B instanceof ArrayBuffer)this.buffer.set(new Uint8Array(B),j);else if(ArrayBuffer.isView(B))this.buffer.set(new Uint8Array(B.buffer,B.byteOffset,B.byteLength),j);else throw new Error("Unknown argument 'array'")}readUInt32BE(B){return s(this.buffer,B)}writeUInt32BE(B,j){a(this.buffer,B,j)}readUInt32LE(B){return e(this.buffer,B)}writeUInt32LE(B,j){h(this.buffer,B,j)}readUInt8(B){return l(this.buffer,B)}writeUInt8(B,j){m(this.buffer,B,j)}indexOf(B,j=0){return f(this.buffer,B instanceof c?B.buffer:B,j)}}t.$fe=c;function f(O,B,j=0){const ie=B.byteLength,te=O.byteLength;if(ie===0)return 0;if(ie===1)return O.indexOf(B[0]);if(ie>te-j)return-1;const ce=U.value;ce.fill(B.length);for(let Pe=0;Pe<B.length;Pe++)ce[B[Pe]]=B.length-Pe-1;let le=j+B.length-1,oe=le,we=-1;for(;le<te;)if(O[le]===B[oe]){if(oe===0){we=le;break}le--,oe--}else le+=Math.max(B.length-oe,ce[O[le]]),oe=B.length-1;return we}t.$ge=f;function d(O,B){return O[B+0]<<0>>>0|O[B+1]<<8>>>0}t.$he=d;function T(O,B,j){O[j+0]=B&255,B=B>>>8,O[j+1]=B&255}t.$ie=T;function s(O,B){return O[B]*2**24+O[B+1]*2**16+O[B+2]*2**8+O[B+3]}t.$je=s;function a(O,B,j){O[j+3]=B,B=B>>>8,O[j+2]=B,B=B>>>8,O[j+1]=B,B=B>>>8,O[j]=B}t.$ke=a;function e(O,B){return O[B+0]<<0>>>0|O[B+1]<<8>>>0|O[B+2]<<16>>>0|O[B+3]<<24>>>0}t.$le=e;function h(O,B,j){O[j+0]=B&255,B=B>>>8,O[j+1]=B&255,B=B>>>8,O[j+2]=B&255,B=B>>>8,O[j+3]=B&255}t.$me=h;function l(O,B){return O[B]}t.$ne=l;function m(O,B,j){O[j]=B}t.$oe=m;function n(O){return N.$7d(O,B=>c.concat(B))}t.$pe=n;function r(O){return N.$be(O)}t.$qe=r;function b(O){return N.$9d(O,B=>c.concat(B))}t.$re=b;async function u(O){return O.ended?c.concat(O.buffer):c.concat([...O.buffer,await b(O.stream)])}t.$se=u;function o(O){return N.$_d(O,B=>c.concat(B))}t.$te=o;function F(O){return N.$ce(O,{data:B=>typeof B=="string"?c.fromString(B):c.wrap(B)},B=>c.concat(B))}t.$ue=F;function z(O){return N.$6d(B=>c.concat(B),O)}t.$ve=z;function R(O,B){return N.$de(O,B,j=>c.concat(j))}t.$we=R;function g(O,B){return N.$ee(O,B,j=>c.concat(j))}t.$xe=g;function y(O){let B=0,j=0,ie=0;const te=new Uint8Array(Math.floor(O.length/4*3)),ce=oe=>{switch(j){case 3:te[ie++]=B|oe,j=0;break;case 2:te[ie++]=B|oe>>>2,B=oe<<6,j=3;break;case 1:te[ie++]=B|oe>>>4,B=oe<<4,j=2;break;default:B=oe<<2,j=1}};for(let oe=0;oe<O.length;oe++){const we=O.charCodeAt(oe);if(we>=65&&we<=90)ce(we-65);else if(we>=97&&we<=122)ce(we-97+26);else if(we>=48&&we<=57)ce(we-48+52);else if(we===43||we===45)ce(62);else if(we===47||we===95)ce(63);else{if(we===61)break;throw new SyntaxError(`Unexpected base64 character ${O[oe]}`)}}const le=ie;for(;j>0;)ce(0);return c.wrap(te).slice(0,le)}t.$ye=y;const M="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",_="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function x({buffer:O},B=!0,j=!1){const ie=j?_:M;let te="";const ce=O.byteLength%3;let le=0;for(;le<O.byteLength-ce;le+=3){const oe=O[le+0],we=O[le+1],Pe=O[le+2];te+=ie[oe>>>2],te+=ie[(oe<<4|we>>>4)&63],te+=ie[(we<<2|Pe>>>6)&63],te+=ie[Pe&63]}if(ce===1){const oe=O[le+0];te+=ie[oe>>>2],te+=ie[oe<<4&63],B&&(te+="==")}else if(ce===2){const oe=O[le+0],we=O[le+1];te+=ie[oe>>>2],te+=ie[(oe<<4|we>>>4)&63],te+=ie[we<<2&63],B&&(te+="=")}return te}t.$ze=x}),define(be[12],pe([1,0,84,28]),function(ae,t,v,N){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Bf=t.$Af=t.$zf=t.$yf=t.GraphemeBreakType=t.$xf=t.$wf=t.$vf=t.$uf=t.$tf=t.$sf=t.$rf=t.$qf=t.$pf=t.$of=t.$nf=t.$mf=t.$lf=t.$kf=t.$jf=t.$if=t.$hf=t.$gf=t.$ff=t.$ef=t.$df=t.$cf=t.$bf=t.$af=t.$_e=t.$$e=t.$0e=t.$9e=t.$8e=t.$7e=t.$6e=t.$5e=t.$4e=t.$3e=t.$2e=t.$1e=t.$Ze=t.$Ye=t.$Xe=t.$We=t.$Ve=t.$Ue=t.$Te=t.$Se=t.$Re=t.$Qe=t.$Pe=t.$Oe=t.$Ne=t.$Me=t.$Le=t.$Ke=t.$Je=t.$Ie=t.$He=t.$Ge=t.$Fe=void 0;function i(J){return!J||typeof J!="string"?!0:J.trim().length===0}t.$Fe=i;const U=/{(\d+)}/g;function w(J,...he){return he.length===0?J:J.replace(U,function($e,Ee){const Se=parseInt(Ee,10);return isNaN(Se)||Se<0||Se>=he.length?$e:he[Se]})}t.$Ge=w;const D=/{([^}]+)}/g;function c(J,he){return Object.keys(he).length===0?J:J.replace(D,($e,Ee)=>he[Ee]??$e)}t.$He=c;function f(J){return J.replace(/[<>&]/g,function(he){switch(he){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return he}})}t.$Ie=f;function d(J){return J.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}t.$Je=d;function T(J,he){let $e=0;const Ee=he.charCodeAt(0);for(let Se=J.length-1;Se>=0;Se--)J.charCodeAt(Se)===Ee&&$e++;return $e}t.$Ke=T;function s(J,he,$e="\u2026"){return J.length<=he?J:`${J.substr(0,he)}${$e}`}t.$Le=s;function a(J,he=" "){const $e=e(J,he);return h($e,he)}t.$Me=a;function e(J,he){if(!J||!he)return J;const $e=he.length;if($e===0||J.length===0)return J;let Ee=0;for(;J.indexOf(he,Ee)===Ee;)Ee=Ee+$e;return J.substring(Ee)}t.$Ne=e;function h(J,he){if(!J||!he)return J;const $e=he.length,Ee=J.length;if($e===0||Ee===0)return J;let Se=Ee,Be=-1;for(;Be=J.lastIndexOf(he,Se-1),!(Be===-1||Be+$e!==Se);){if(Be===0)return"";Se=Be}return J.substring(0,Se)}t.$Oe=h;function l(J){return J.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}t.$Pe=l;function m(J){return J.replace(/\*/g,"")}t.$Qe=m;function n(J,he,$e={}){if(!J)throw new Error("Cannot create regex from empty string");he||(J=d(J)),$e.wholeWord&&(/\B/.test(J.charAt(0))||(J="\\b"+J),/\B/.test(J.charAt(J.length-1))||(J=J+"\\b"));let Ee="";return $e.global&&(Ee+="g"),$e.matchCase||(Ee+="i"),$e.multiline&&(Ee+="m"),$e.unicode&&(Ee+="u"),new RegExp(J,Ee)}t.$Re=n;function r(J){return J.source==="^"||J.source==="^$"||J.source==="$"||J.source==="^\\s*$"?!1:!!(J.exec("")&&J.lastIndex===0)}t.$Se=r;function b(J){return J.split(/\r\n|\r|\n/)}t.$Te=b;function u(J){for(let he=0,$e=J.length;he<$e;he++){const Ee=J.charCodeAt(he);if(Ee!==32&&Ee!==9)return he}return-1}t.$Ue=u;function o(J,he=0,$e=J.length){for(let Ee=he;Ee<$e;Ee++){const Se=J.charCodeAt(Ee);if(Se!==32&&Se!==9)return J.substring(he,Ee)}return J.substring(he,$e)}t.$Ve=o;function F(J,he=J.length-1){for(let $e=he;$e>=0;$e--){const Ee=J.charCodeAt($e);if(Ee!==32&&Ee!==9)return $e}return-1}t.$We=F;function z(J,he,$e){const Ee=[];let Se=0;for(const Be of J.matchAll(he)){if(Ee.push(J.slice(Se,Be.index)),Be.index===void 0)throw new Error("match.index should be defined");Se=Be.index+Be[0].length,Ee.push($e(Be[0],...Be.slice(1),Be.index,J,Be.groups))}return Ee.push(J.slice(Se)),Promise.all(Ee).then(Be=>Be.join(""))}t.$Xe=z;function R(J,he){return J<he?-1:J>he?1:0}t.$Ye=R;function g(J,he,$e=0,Ee=J.length,Se=0,Be=he.length){for(;$e<Ee&&Se<Be;$e++,Se++){const Je=J.charCodeAt($e),Qe=he.charCodeAt(Se);if(Je<Qe)return-1;if(Je>Qe)return 1}const Ue=Ee-$e,Ze=Be-Se;return Ue<Ze?-1:Ue>Ze?1:0}t.$Ze=g;function y(J,he){return M(J,he,0,J.length,0,he.length)}t.$1e=y;function M(J,he,$e=0,Ee=J.length,Se=0,Be=he.length){for(;$e<Ee&&Se<Be;$e++,Se++){let Je=J.charCodeAt($e),Qe=he.charCodeAt(Se);if(Je===Qe)continue;if(Je>=128||Qe>=128)return g(J.toLowerCase(),he.toLowerCase(),$e,Ee,Se,Be);x(Je)&&(Je-=32),x(Qe)&&(Qe-=32);const qe=Je-Qe;if(qe!==0)return qe}const Ue=Ee-$e,Ze=Be-Se;return Ue<Ze?-1:Ue>Ze?1:0}t.$2e=M;function _(J){return J>=48&&J<=57}t.$3e=_;function x(J){return J>=97&&J<=122}t.$4e=x;function O(J){return J>=65&&J<=90}t.$5e=O;function B(J,he){return J.length===he.length&&M(J,he)===0}t.$6e=B;function j(J,he){const $e=he.length;return he.length>J.length?!1:M(J,he,0,$e)===0}t.$7e=j;function ie(J,he){const $e=Math.min(J.length,he.length);let Ee;for(Ee=0;Ee<$e;Ee++)if(J.charCodeAt(Ee)!==he.charCodeAt(Ee))return Ee;return $e}t.$8e=ie;function te(J,he){const $e=Math.min(J.length,he.length);let Ee;const Se=J.length-1,Be=he.length-1;for(Ee=0;Ee<$e;Ee++)if(J.charCodeAt(Se-Ee)!==he.charCodeAt(Be-Ee))return Ee;return $e}t.$9e=te;function ce(J){return 55296<=J&&J<=56319}t.$0e=ce;function le(J){return 56320<=J&&J<=57343}t.$$e=le;function oe(J,he){return(J-55296<<10)+(he-56320)+65536}t.$_e=oe;function we(J,he,$e){const Ee=J.charCodeAt($e);if(ce(Ee)&&$e+1<he){const Se=J.charCodeAt($e+1);if(le(Se))return oe(Ee,Se)}return Ee}t.$af=we;function Pe(J,he){const $e=J.charCodeAt(he-1);if(le($e)&&he>1){const Ee=J.charCodeAt(he-2);if(ce(Ee))return oe(Ee,$e)}return $e}class Ae{get offset(){return this.e}constructor(he,$e=0){this.c=he,this.d=he.length,this.e=$e}setOffset(he){this.e=he}prevCodePoint(){const he=Pe(this.c,this.e);return this.e-=he>=65536?2:1,he}nextCodePoint(){const he=we(this.c,this.d,this.e);return this.e+=he>=65536?2:1,he}eol(){return this.e>=this.d}}t.$bf=Ae;class Re{get offset(){return this.c.offset}constructor(he,$e=0){this.c=new Ae(he,$e)}nextGraphemeLength(){const he=Ce.getInstance(),$e=this.c,Ee=$e.offset;let Se=he.getGraphemeBreakType($e.nextCodePoint());for(;!$e.eol();){const Be=$e.offset,Ue=he.getGraphemeBreakType($e.nextCodePoint());if(ve(Se,Ue)){$e.setOffset(Be);break}Se=Ue}return $e.offset-Ee}prevGraphemeLength(){const he=Ce.getInstance(),$e=this.c,Ee=$e.offset;let Se=he.getGraphemeBreakType($e.prevCodePoint());for(;$e.offset>0;){const Be=$e.offset,Ue=he.getGraphemeBreakType($e.prevCodePoint());if(ve(Ue,Se)){$e.setOffset(Be);break}Se=Ue}return Ee-$e.offset}eol(){return this.c.eol()}}t.$cf=Re;function de(J,he){return new Re(J,he).nextGraphemeLength()}t.$df=de;function ne(J,he){return new Re(J,he).prevGraphemeLength()}t.$ef=ne;function fe(J,he){he>0&&le(J.charCodeAt(he))&&he--;const $e=he+de(J,he);return[$e-ne(J,$e),$e]}t.$ff=fe;function Z(J){const he=new Re(J);let $e=0;for(;!he.eol();)$e++,he.nextGraphemeLength();return $e}t.$gf=Z;let V;function Y(){return/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/}function C(J){return V||(V=Y()),V.test(J)}t.$hf=C;const q=/^[\t\n\r\x20-\x7E]*$/;function $(J){return q.test(J)}t.$if=$,t.$jf=/[\u2028\u2029]/;function W(J){return t.$jf.test(J)}t.$kf=W;function Q(J){return J>=11904&&J<=55215||J>=63744&&J<=64255||J>=65281&&J<=65374}t.$lf=Q;function p(J){return J>=127462&&J<=127487||J===8986||J===8987||J===9200||J===9203||J>=9728&&J<=10175||J===11088||J===11093||J>=127744&&J<=128591||J>=128640&&J<=128764||J>=128992&&J<=129008||J>=129280&&J<=129535||J>=129648&&J<=129782}t.$mf=p;function A(J,he){if(J.length<he)return J;const $e=/\b/g;let Ee=0;for(;$e.test(J)&&!(J.length-$e.lastIndex<he);)Ee=$e.lastIndex,$e.lastIndex+=1;return J.substring(Ee).replace(/^\s/,"")}t.$nf=A;const E=/(:?\x1b\[|\x9B)[=?>!]?[\d;:]*["$#'* ]?[a-zA-Z@^`{}|~]/g,I=/\x1b\].*?\x07/g;function k(J){return J&&(J=J.replace(E,"").replace(I,"")),J}t.$of=k,t.$pf=String.fromCharCode(65279);function L(J){return!!(J&&J.length>0&&J.charCodeAt(0)===65279)}t.$qf=L;function S(J){return L(J)?J.substr(1):J}t.$rf=S;function P(J,he){if(!J||!he||J.length<he.length)return!1;const $e=he.length,Ee=J.toLowerCase();let Se=0,Be=-1;for(;Se<$e;){const Ue=Ee.indexOf(he[Se],Be+1);if(Ue<0)return!1;Be=Ue,Se++}return!0}t.$sf=P;function H(J,he=!1){return J?(he&&(J=J.replace(/\\./g,"")),J.toLowerCase()!==J):!1}t.$tf=H;function G(J){return J.charAt(0).toUpperCase()+J.slice(1)}t.$uf=G;function ee(J,he=1){if(he===0)return"";let $e=-1;do $e=J.indexOf(`
`,$e+1),he--;while(he>0&&$e>=0);return $e===-1?J:(J[$e-1]==="\r"&&$e--,J.substr(0,$e))}t.$vf=ee;function se(J){return J=J%(2*26),J<26?String.fromCharCode(97+J):String.fromCharCode(65+J-26)}t.$wf=se;function me(J){return Ce.getInstance().getGraphemeBreakType(J)}t.$xf=me;function ve(J,he){return J===0?he!==5&&he!==7:J===2&&he===3?!1:J===4||J===2||J===3||he===4||he===2||he===3?!0:!(J===8&&(he===8||he===9||he===11||he===12)||(J===11||J===9)&&(he===9||he===10)||(J===12||J===10)&&he===10||he===5||he===13||he===7||J===1||J===13&&he===14||J===6&&he===6)}var Fe;(function(J){J[J.Other=0]="Other",J[J.Prepend=1]="Prepend",J[J.CR=2]="CR",J[J.LF=3]="LF",J[J.Control=4]="Control",J[J.Extend=5]="Extend",J[J.Regional_Indicator=6]="Regional_Indicator",J[J.SpacingMark=7]="SpacingMark",J[J.L=8]="L",J[J.V=9]="V",J[J.T=10]="T",J[J.LV=11]="LV",J[J.LVT=12]="LVT",J[J.ZWJ=13]="ZWJ",J[J.Extended_Pictographic=14]="Extended_Pictographic"})(Fe||(t.GraphemeBreakType=Fe={}));class Ce{static{this.c=null}static getInstance(){return Ce.c||(Ce.c=new Ce),Ce.c}constructor(){this.d=De()}getGraphemeBreakType(he){if(he<32)return he===10?3:he===13?2:4;if(he<127)return 0;const $e=this.d,Ee=$e.length/3;let Se=1;for(;Se<=Ee;)if(he<$e[3*Se])Se=2*Se;else if(he>$e[3*Se+1])Se=2*Se+1;else return $e[3*Se+2];return 0}}function De(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function Te(J,he){if(J===0)return 0;const $e=Oe(J,he);if($e!==void 0)return $e;const Ee=new Ae(he,J);return Ee.prevCodePoint(),Ee.offset}t.$yf=Te;function Oe(J,he){const $e=new Ae(he,J);let Ee=$e.prevCodePoint();for(;We(Ee)||Ee===65039||Ee===8419;){if($e.offset===0)return;Ee=$e.prevCodePoint()}if(!p(Ee))return;let Se=$e.offset;return Se>0&&$e.prevCodePoint()===8205&&(Se=$e.offset),Se}function We(J){return 127995<=J&&J<=127999}var He;(function(J){J[J.zwj=8205]="zwj",J[J.emojiVariantSelector=65039]="emojiVariantSelector",J[J.enclosingKeyCap=8419]="enclosingKeyCap"})(He||(He={})),t.$zf="\xA0";class Me{static{this.c=new N.$U(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125,119846,109],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}'))}static{this.d=new v.$Be(he=>{function $e(qe){const tt=new Map;for(let nt=0;nt<qe.length;nt+=2)tt.set(qe[nt],qe[nt+1]);return tt}function Ee(qe,tt){const nt=new Map(qe);for(const[dt,ft]of tt)nt.set(dt,ft);return nt}function Se(qe,tt){if(!qe)return tt;const nt=new Map;for(const[dt,ft]of qe)tt.has(dt)&&nt.set(dt,ft);return nt}const Be=this.c.value;let Ue=he.filter(qe=>!qe.startsWith("_")&&qe in Be);Ue.length===0&&(Ue=["_default"]);let Ze;for(const qe of Ue){const tt=$e(Be[qe]);Ze=Se(Ze,tt)}const Je=$e(Be._common),Qe=Ee(Je,Ze);return new Me(Qe)})}static getInstance(he){return Me.d.get(Array.from(he))}static{this.e=new N.$U(()=>Object.keys(Me.c.value).filter(he=>!he.startsWith("_")))}static getLocales(){return Me.e.value}constructor(he){this.f=he}isAmbiguous(he){return this.f.has(he)}getPrimaryConfusable(he){return this.f.get(he)}getConfusableCodePoints(){return new Set(this.f.keys())}}t.$Af=Me;class Ye{static c(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static{this.d=void 0}static e(){return this.d||(this.d=new Set(Ye.c())),this.d}static isInvisibleCharacter(he){return Ye.e().has(he)}static get codePoints(){return Ye.e()}}t.$Bf=Ye}),define(be[34],pe([1,0,32,12]),function(ae,t,v,N){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Xj=t.$Wj=t.$Vj=t.$Uj=t.FuzzyScore=t.$Tj=t.$Sj=t.$Rj=t.$Qj=t.$Pj=t.$Oj=t.$Nj=t.$Mj=t.$Lj=t.$Kj=t.$Jj=t.$Ij=t.or=void 0;function i(...S){return function(P,H){for(let G=0,ee=S.length;G<ee;G++){const se=S[G](P,H);if(se)return se}return null}}t.or=i,t.$Ij=U.bind(void 0,!1),t.$Jj=U.bind(void 0,!0);function U(S,P,H){if(!H||H.length<P.length)return null;let G;return S?G=N.$7e(H,P):G=H.indexOf(P)===0,G?P.length>0?[{start:0,end:P.length}]:[]:null}function w(S,P){const H=P.toLowerCase().indexOf(S.toLowerCase());return H===-1?null:[{start:H,end:H+S.length}]}t.$Kj=w;function D(S,P){return c(S.toLowerCase(),P.toLowerCase(),0,0)}t.$Lj=D;function c(S,P,H,G){if(H===S.length)return[];if(G===P.length)return null;if(S[H]===P[G]){let ee=null;return(ee=c(S,P,H+1,G+1))?m({start:G,end:G+1},ee):null}return c(S,P,H,G+1)}function f(S){return 97<=S&&S<=122}function d(S){return 65<=S&&S<=90}t.$Mj=d;function T(S){return 48<=S&&S<=57}function s(S){return S===32||S===9||S===10||S===13}const a=new Set;"()[]{}<>`'\"-/;:,.?!".split("").forEach(S=>a.add(S.charCodeAt(0)));function e(S){return s(S)||a.has(S)}function h(S,P){return S===P||e(S)&&e(P)}function l(S){return f(S)||d(S)||T(S)}function m(S,P){return P.length===0?P=[S]:S.end===P[0].start?P[0].start=S.start:P.unshift(S),P}function n(S,P){for(let H=P;H<S.length;H++){const G=S.charCodeAt(H);if(d(G)||T(G)||H>0&&!l(S.charCodeAt(H-1)))return H}return S.length}function r(S,P,H,G){if(H===S.length)return[];if(G===P.length)return null;if(S[H]!==P[G].toLowerCase())return null;{let ee=null,se=G+1;for(ee=r(S,P,H+1,G+1);!ee&&(se=n(P,se))<P.length;)ee=r(S,P,H+1,se),se++;return ee===null?null:m({start:G,end:G+1},ee)}}function b(S){let P=0,H=0,G=0,ee=0,se=0;for(let De=0;De<S.length;De++)se=S.charCodeAt(De),d(se)&&P++,f(se)&&H++,l(se)&&G++,T(se)&&ee++;const me=P/S.length,ve=H/S.length,Fe=G/S.length,Ce=ee/S.length;return{upperPercent:me,lowerPercent:ve,alphaPercent:Fe,numericPercent:Ce}}function u(S){const{upperPercent:P,lowerPercent:H}=S;return H===0&&P>.6}function o(S){const{upperPercent:P,lowerPercent:H,alphaPercent:G,numericPercent:ee}=S;return H>.2&&P<.8&&G>.6&&ee<.2}function F(S){let P=0,H=0,G=0,ee=0;for(let se=0;se<S.length;se++)G=S.charCodeAt(se),d(G)&&P++,f(G)&&H++,s(G)&&ee++;return(P===0||H===0)&&ee===0?S.length<=30:P<=5}function z(S,P){if(!P||(P=P.trim(),P.length===0)||!F(S)||P.length>60)return null;const H=b(P);if(!o(H)){if(!u(H))return null;P=P.toLowerCase()}let G=null,ee=0;for(S=S.toLowerCase();ee<P.length&&(G=r(S,P,0,ee))===null;)ee=n(P,ee+1);return G}t.$Nj=z;function R(S,P,H=!1){if(!P||P.length===0)return null;let G=null,ee=0;for(S=S.toLowerCase(),P=P.toLowerCase();ee<P.length&&(G=g(S,P,0,ee,H))===null;)ee=y(P,ee+1);return G}t.$Oj=R;function g(S,P,H,G,ee){if(H===S.length)return[];if(G===P.length)return null;if(h(S.charCodeAt(H),P.charCodeAt(G))){let se=null,me=G+1;if(se=g(S,P,H+1,G+1,ee),!ee)for(;!se&&(me=y(P,me))<P.length;)se=g(S,P,H+1,me,ee),me++;return se?S.charCodeAt(H)!==P.charCodeAt(G)?se:m({start:G,end:G+1},se):null}else return null}function y(S,P){for(let H=P;H<S.length;H++)if(e(S.charCodeAt(H))||H>0&&e(S.charCodeAt(H-1)))return H;return S.length}const M=i(t.$Jj,z,w),_=i(t.$Jj,z,D),x=new v.$Cc(1e4);function O(S,P,H=!1){if(typeof S!="string"||typeof P!="string")return null;let G=x.get(S);G||(G=new RegExp(N.$Pe(S),"i"),x.set(S,G));const ee=G.exec(P);return ee?[{start:ee.index,end:ee.index+ee[0].length}]:H?_(S,P):M(S,P)}t.$Pj=O;function B(S,P){const H=Q(S,S.toLowerCase(),0,P,P.toLowerCase(),0,{firstMatchCanBeWeak:!0,boostFullMatch:!0});return H?ie(H):null}t.$Qj=B;function j(S,P,H,G,ee,se){const me=Math.min(13,S.length);for(;H<me;H++){const ve=Q(S,P,H,G,ee,se,{firstMatchCanBeWeak:!0,boostFullMatch:!0});if(ve)return ve}return[0,se]}t.$Rj=j;function ie(S){if(typeof S>"u")return[];const P=[],H=S[1];for(let G=S.length-1;G>1;G--){const ee=S[G]+H,se=P[P.length-1];se&&se.end===ee?se.end=ee+1:P.push({start:ee,end:ee+1})}return P}t.$Sj=ie;const te=128;function ce(){const S=[],P=[];for(let H=0;H<=te;H++)P[H]=0;for(let H=0;H<=te;H++)S.push(P.slice(0));return S}function le(S){const P=[];for(let H=0;H<=S;H++)P[H]=0;return P}const oe=le(2*te),we=le(2*te),Pe=ce(),Ae=ce(),Re=ce(),de=!1;function ne(S,P,H,G,ee){function se(ve,Fe,Ce=" "){for(;ve.length<Fe;)ve=Ce+ve;return ve}let me=` |   |${G.split("").map(ve=>se(ve,3)).join("|")}
`;for(let ve=0;ve<=H;ve++)ve===0?me+=" |":me+=`${P[ve-1]}|`,me+=S[ve].slice(0,ee+1).map(Fe=>se(Fe.toString(),3)).join("|")+`
`;return me}function fe(S,P,H,G){S=S.substr(P),H=H.substr(G),console.log(ne(Ae,S,S.length,H,H.length)),console.log(ne(Re,S,S.length,H,H.length)),console.log(ne(Pe,S,S.length,H,H.length))}function Z(S,P){if(P<0||P>=S.length)return!1;const H=S.codePointAt(P);switch(H){case 95:case 45:case 46:case 32:case 47:case 92:case 39:case 34:case 58:case 36:case 60:case 62:case 40:case 41:case 91:case 93:case 123:case 125:return!0;case void 0:return!1;default:return!!N.$mf(H)}}function V(S,P){if(P<0||P>=S.length)return!1;switch(S.charCodeAt(P)){case 32:case 9:return!0;default:return!1}}function Y(S,P,H){return P[S]!==H[S]}function C(S,P,H,G,ee,se,me=!1){for(;P<H&&ee<se;)S[P]===G[ee]&&(me&&(oe[P]=ee),P+=1),ee+=1;return P===H}t.$Tj=C;var q;(function(S){S[S.Diag=1]="Diag",S[S.Left=2]="Left",S[S.LeftLeft=3]="LeftLeft"})(q||(q={}));var $;(function(S){S.Default=[-100,0];function P(H){return!H||H.length===2&&H[0]===-100&&H[1]===0}S.isDefault=P})($||(t.FuzzyScore=$={}));class W{static{this.default={boostFullMatch:!0,firstMatchCanBeWeak:!1}}constructor(P,H){this.firstMatchCanBeWeak=P,this.boostFullMatch=H}}t.$Uj=W;function Q(S,P,H,G,ee,se,me=W.default){const ve=S.length>te?te:S.length,Fe=G.length>te?te:G.length;if(H>=ve||se>=Fe||ve-H>Fe-se||!C(P,H,ve,ee,se,Fe,!0))return;p(ve,Fe,H,se,P,ee);let Ce=1,De=1,Te=H,Oe=se;const We=[!1];for(Ce=1,Te=H;Te<ve;Ce++,Te++){const he=oe[Te],$e=we[Te],Ee=Te+1<ve?we[Te+1]:Fe;for(De=he-se+1,Oe=he;Oe<Ee;De++,Oe++){let Se=Number.MIN_SAFE_INTEGER,Be=!1;Oe<=$e&&(Se=A(S,P,Te,H,G,ee,Oe,Fe,se,Pe[Ce-1][De-1]===0,We));let Ue=0;Se!==Number.MAX_SAFE_INTEGER&&(Be=!0,Ue=Se+Ae[Ce-1][De-1]);const Ze=Oe>he,Je=Ze?Ae[Ce][De-1]+(Pe[Ce][De-1]>0?-5:0):0,Qe=Oe>he+1&&Pe[Ce][De-1]>0,qe=Qe?Ae[Ce][De-2]+(Pe[Ce][De-2]>0?-5:0):0;if(Qe&&(!Ze||qe>=Je)&&(!Be||qe>=Ue))Ae[Ce][De]=qe,Re[Ce][De]=3,Pe[Ce][De]=0;else if(Ze&&(!Be||Je>=Ue))Ae[Ce][De]=Je,Re[Ce][De]=2,Pe[Ce][De]=0;else if(Be)Ae[Ce][De]=Ue,Re[Ce][De]=1,Pe[Ce][De]=Pe[Ce-1][De-1]+1;else throw new Error("not possible")}}if(de&&fe(S,H,G,se),!We[0]&&!me.firstMatchCanBeWeak)return;Ce--,De--;const He=[Ae[Ce][De],se];let Me=0,Ye=0;for(;Ce>=1;){let he=De;do{const $e=Re[Ce][he];if($e===3)he=he-2;else if($e===2)he=he-1;else break}while(he>=1);Me>1&&P[H+Ce-1]===ee[se+De-1]&&!Y(he+se-1,G,ee)&&Me+1>Pe[Ce][he]&&(he=De),he===De?Me++:Me=1,Ye||(Ye=he),Ce--,De=he-1,He.push(De)}Fe===ve&&me.boostFullMatch&&(He[0]+=2);const J=Ye-ve;return He[0]-=J,He}t.$Vj=Q;function p(S,P,H,G,ee,se){let me=S-1,ve=P-1;for(;me>=H&&ve>=G;)ee[me]===se[ve]&&(we[me]=ve,me--),ve--}function A(S,P,H,G,ee,se,me,ve,Fe,Ce,De){if(P[H]!==se[me])return Number.MIN_SAFE_INTEGER;let Te=1,Oe=!1;return me===H-G?Te=S[H]===ee[me]?7:5:Y(me,ee,se)&&(me===0||!Y(me-1,ee,se))?(Te=S[H]===ee[me]?7:5,Oe=!0):Z(se,me)&&(me===0||!Z(se,me-1))?Te=5:(Z(se,me-1)||V(se,me-1))&&(Te=5,Oe=!0),Te>1&&H===G&&(De[0]=!0),Oe||(Oe=Y(me,ee,se)||Z(se,me-1)||V(se,me-1)),H===G?me>Fe&&(Te-=Oe?3:5):Ce?Te+=Oe?2:0:Te+=Oe?0:1,me+1===ve&&(Te-=Oe?3:5),Te}function E(S,P,H,G,ee,se,me){return k(S,P,H,G,ee,se,!0,me)}t.$Wj=E;function I(S,P,H,G,ee,se,me){return k(S,P,H,G,ee,se,!1,me)}t.$Xj=I;function k(S,P,H,G,ee,se,me,ve){let Fe=Q(S,P,H,G,ee,se,ve);if(Fe&&!me)return Fe;if(S.length>=3){const Ce=Math.min(7,S.length-1);for(let De=H+1;De<Ce;De++){const Te=L(S,De);if(Te){const Oe=Q(Te,Te.toLowerCase(),H,G,ee,se,ve);Oe&&(Oe[0]-=3,(!Fe||Oe[0]>Fe[0])&&(Fe=Oe))}}}return Fe}function L(S,P){if(P+1>=S.length)return;const H=S[P],G=S[P+1];if(H!==G)return S.slice(0,P)+G+H+S.slice(P+2)}}),define(be[49],pe([1,0,12]),function(ae,t,v){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Pi=t.$Oi=t.$Ni=t.$Mi=t.$Li=t.$Ki=t.$Ji=void 0;function N(m){return i(m,0)}t.$Ji=N;function i(m,n){switch(typeof m){case"object":return m===null?U(349,n):Array.isArray(m)?c(m,n):f(m,n);case"string":return D(m,n);case"boolean":return w(m,n);case"number":return U(m,n);case"undefined":return U(937,n);default:return U(617,n)}}t.$Ki=i;function U(m,n){return(n<<5)-n+m|0}t.$Li=U;function w(m,n){return U(m?433:863,n)}function D(m,n){n=U(149417,n);for(let r=0,b=m.length;r<b;r++)n=U(m.charCodeAt(r),n);return n}t.$Mi=D;function c(m,n){return n=U(104579,n),m.reduce((r,b)=>i(b,r),n)}function f(m,n){return n=U(181387,n),Object.keys(m).sort().reduce((r,b)=>(r=D(b,r),i(m[b],r)),n)}class d{constructor(){this.g=0}get value(){return this.g}hash(n){return this.g=i(n,this.g),this.g}}t.$Ni=d;var T;(function(m){m[m.BLOCK_SIZE=64]="BLOCK_SIZE",m[m.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(T||(T={}));function s(m,n,r=32){const b=r-n,u=~((1<<b)-1);return(m<<n|(u&m)>>>b)>>>0}function a(m,n=0,r=m.byteLength,b=0){for(let u=0;u<r;u++)m[n+u]=b}function e(m,n,r="0"){for(;m.length<n;)m=r+m;return m}function h(m,n=32){return m instanceof ArrayBuffer?Array.from(new Uint8Array(m)).map(r=>r.toString(16).padStart(2,"0")).join(""):e((m>>>0).toString(16),n/4)}t.$Oi=h;class l{static{this.g=new DataView(new ArrayBuffer(320))}constructor(){this.h=1732584193,this.l=4023233417,this.m=2562383102,this.n=271733878,this.o=3285377520,this.p=new Uint8Array(64+3),this.q=new DataView(this.p.buffer),this.r=0,this.t=0,this.u=0,this.v=!1}update(n){const r=n.length;if(r===0)return;const b=this.p;let u=this.r,o=this.u,F,z;for(o!==0?(F=o,z=-1,o=0):(F=n.charCodeAt(0),z=0);;){let R=F;if(v.$0e(F))if(z+1<r){const g=n.charCodeAt(z+1);v.$$e(g)?(z++,R=v.$_e(F,g)):R=65533}else{o=F;break}else v.$$e(F)&&(R=65533);if(u=this.w(b,u,R),z++,z<r)F=n.charCodeAt(z);else break}this.r=u,this.u=o}w(n,r,b){return b<128?n[r++]=b:b<2048?(n[r++]=192|(b&1984)>>>6,n[r++]=128|(b&63)>>>0):b<65536?(n[r++]=224|(b&61440)>>>12,n[r++]=128|(b&4032)>>>6,n[r++]=128|(b&63)>>>0):(n[r++]=240|(b&1835008)>>>18,n[r++]=128|(b&258048)>>>12,n[r++]=128|(b&4032)>>>6,n[r++]=128|(b&63)>>>0),r>=64&&(this.y(),r-=64,this.t+=64,n[0]=n[64+0],n[1]=n[64+1],n[2]=n[64+2]),r}digest(){return this.v||(this.v=!0,this.u&&(this.u=0,this.r=this.w(this.p,this.r,65533)),this.t+=this.r,this.x()),h(this.h)+h(this.l)+h(this.m)+h(this.n)+h(this.o)}x(){this.p[this.r++]=128,a(this.p,this.r),this.r>56&&(this.y(),a(this.p));const n=8*this.t;this.q.setUint32(56,Math.floor(n/4294967296),!1),this.q.setUint32(60,n%4294967296,!1),this.y()}y(){const n=l.g,r=this.q;for(let M=0;M<64;M+=4)n.setUint32(M,r.getUint32(M,!1),!1);for(let M=64;M<320;M+=4)n.setUint32(M,s(n.getUint32(M-12,!1)^n.getUint32(M-32,!1)^n.getUint32(M-56,!1)^n.getUint32(M-64,!1),1),!1);let b=this.h,u=this.l,o=this.m,F=this.n,z=this.o,R,g,y;for(let M=0;M<80;M++)M<20?(R=u&o|~u&F,g=1518500249):M<40?(R=u^o^F,g=1859775393):M<60?(R=u&o|u&F|o&F,g=2400959708):(R=u^o^F,g=3395469782),y=s(b,5)+R+z+g+n.getUint32(M*4,!1)&4294967295,z=F,F=o,o=s(u,30),u=b,b=y;this.h=this.h+b&4294967295,this.l=this.l+u&4294967295,this.m=this.m+o&4294967295,this.n=this.n+F&4294967295,this.o=this.o+z&4294967295}}t.$Pi=l}),define(be[86],pe([1,0,75,49]),function(ae,t,v,N){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Fs=t.$Es=t.$Ds=void 0;class i{constructor(s){this.a=s}getElements(){const s=this.a,a=new Int32Array(s.length);for(let e=0,h=s.length;e<h;e++)a[e]=s.charCodeAt(e);return a}}t.$Ds=i;function U(T,s,a){return new d(new i(T),new i(s)).ComputeDiff(a).changes}t.$Es=U;class w{static Assert(s,a){if(!s)throw new Error(a)}}class D{static Copy(s,a,e,h,l){for(let m=0;m<l;m++)e[h+m]=s[a+m]}static Copy2(s,a,e,h,l){for(let m=0;m<l;m++)e[h+m]=s[a+m]}}var c;(function(T){T[T.MaxDifferencesHistory=1447]="MaxDifferencesHistory"})(c||(c={}));class f{constructor(){this.a=[],this.b=1073741824,this.c=1073741824,this.d=0,this.e=0}MarkNextChange(){(this.d>0||this.e>0)&&this.a.push(new v.$Cs(this.b,this.d,this.c,this.e)),this.d=0,this.e=0,this.b=1073741824,this.c=1073741824}AddOriginalElement(s,a){this.b=Math.min(this.b,s),this.c=Math.min(this.c,a),this.d++}AddModifiedElement(s,a){this.b=Math.min(this.b,s),this.c=Math.min(this.c,a),this.e++}getChanges(){return(this.d>0||this.e>0)&&this.MarkNextChange(),this.a}getReverseChanges(){return(this.d>0||this.e>0)&&this.MarkNextChange(),this.a.reverse(),this.a}}class d{constructor(s,a,e=null){this.a=e,this.b=s,this.c=a;const[h,l,m]=d.o(s),[n,r,b]=d.o(a);this.d=m&&b,this.e=h,this.f=l,this.g=n,this.h=r,this.k=[],this.m=[]}static n(s){return s.length>0&&typeof s[0]=="string"}static o(s){const a=s.getElements();if(d.n(a)){const e=new Int32Array(a.length);for(let h=0,l=a.length;h<l;h++)e[h]=(0,N.$Mi)(a[h],0);return[a,e,!0]}return a instanceof Int32Array?[[],a,!1]:[[],new Int32Array(a),!1]}p(s,a){return this.f[s]!==this.h[a]?!1:this.d?this.e[s]===this.g[a]:!0}q(s,a){if(!this.p(s,a))return!1;const e=d.r(this.b,s),h=d.r(this.c,a);return e===h}static r(s,a){return typeof s.getStrictElement=="function"?s.getStrictElement(a):null}s(s,a){return this.f[s]!==this.f[a]?!1:this.d?this.e[s]===this.e[a]:!0}u(s,a){return this.h[s]!==this.h[a]?!1:this.d?this.g[s]===this.g[a]:!0}ComputeDiff(s){return this.v(0,this.f.length-1,0,this.h.length-1,s)}v(s,a,e,h,l){const m=[!1];let n=this.w(s,a,e,h,m);return l&&(n=this.z(n)),{quitEarly:m[0],changes:n}}w(s,a,e,h,l){for(l[0]=!1;s<=a&&e<=h&&this.p(s,e);)s++,e++;for(;a>=s&&h>=e&&this.p(a,h);)a--,h--;if(s>a||e>h){let o;return e<=h?(w.Assert(s===a+1,"originalStart should only be one more than originalEnd"),o=[new v.$Cs(s,0,e,h-e+1)]):s<=a?(w.Assert(e===h+1,"modifiedStart should only be one more than modifiedEnd"),o=[new v.$Cs(s,a-s+1,e,0)]):(w.Assert(s===a+1,"originalStart should only be one more than originalEnd"),w.Assert(e===h+1,"modifiedStart should only be one more than modifiedEnd"),o=[]),o}const m=[0],n=[0],r=this.y(s,a,e,h,m,n,l),b=m[0],u=n[0];if(r!==null)return r;if(!l[0]){const o=this.w(s,b,e,u,l);let F=[];return l[0]?F=[new v.$Cs(b+1,a-(b+1)+1,u+1,h-(u+1)+1)]:F=this.w(b+1,a,u+1,h,l),this.H(o,F)}return[new v.$Cs(s,a-s+1,e,h-e+1)]}x(s,a,e,h,l,m,n,r,b,u,o,F,z,R,g,y,M,_){let x=null,O=null,B=new f,j=a,ie=e,te=z[0]-y[0]-h,ce=-1073741824,le=this.k.length-1;do{const oe=te+s;oe===j||oe<ie&&b[oe-1]<b[oe+1]?(o=b[oe+1],R=o-te-h,o<ce&&B.MarkNextChange(),ce=o,B.AddModifiedElement(o+1,R),te=oe+1-s):(o=b[oe-1]+1,R=o-te-h,o<ce&&B.MarkNextChange(),ce=o-1,B.AddOriginalElement(o,R+1),te=oe-1-s),le>=0&&(b=this.k[le],s=b[0],j=1,ie=b.length-1)}while(--le>=-1);if(x=B.getReverseChanges(),_[0]){let oe=z[0]+1,we=y[0]+1;if(x!==null&&x.length>0){const Pe=x[x.length-1];oe=Math.max(oe,Pe.getOriginalEnd()),we=Math.max(we,Pe.getModifiedEnd())}O=[new v.$Cs(oe,F-oe+1,we,g-we+1)]}else{B=new f,j=m,ie=n,te=z[0]-y[0]-r,ce=1073741824,le=M?this.m.length-1:this.m.length-2;do{const oe=te+l;oe===j||oe<ie&&u[oe-1]>=u[oe+1]?(o=u[oe+1]-1,R=o-te-r,o>ce&&B.MarkNextChange(),ce=o+1,B.AddOriginalElement(o+1,R+1),te=oe+1-l):(o=u[oe-1],R=o-te-r,o>ce&&B.MarkNextChange(),ce=o,B.AddModifiedElement(o+1,R+1),te=oe-1-l),le>=0&&(u=this.m[le],l=u[0],j=1,ie=u.length-1)}while(--le>=-1);O=B.getChanges()}return this.H(x,O)}y(s,a,e,h,l,m,n){let r=0,b=0,u=0,o=0,F=0,z=0;s--,e--,l[0]=0,m[0]=0,this.k=[],this.m=[];const R=a-s+(h-e),g=R+1,y=new Int32Array(g),M=new Int32Array(g),_=h-e,x=a-s,O=s-e,B=a-h,ie=(x-_)%2===0;y[_]=s,M[x]=a,n[0]=!1;for(let te=1;te<=R/2+1;te++){let ce=0,le=0;u=this.J(_-te,te,_,g),o=this.J(_+te,te,_,g);for(let we=u;we<=o;we+=2){we===u||we<o&&y[we-1]<y[we+1]?r=y[we+1]:r=y[we-1]+1,b=r-(we-_)-O;const Pe=r;for(;r<a&&b<h&&this.p(r+1,b+1);)r++,b++;if(y[we]=r,r+b>ce+le&&(ce=r,le=b),!ie&&Math.abs(we-x)<=te-1&&r>=M[we])return l[0]=r,m[0]=b,Pe<=M[we]&&1447>0&&te<=1447+1?this.x(_,u,o,O,x,F,z,B,y,M,r,a,l,b,h,m,ie,n):null}const oe=(ce-s+(le-e)-te)/2;if(this.a!==null&&!this.a(ce,oe))return n[0]=!0,l[0]=ce,m[0]=le,oe>0&&1447>0&&te<=1447+1?this.x(_,u,o,O,x,F,z,B,y,M,r,a,l,b,h,m,ie,n):(s++,e++,[new v.$Cs(s,a-s+1,e,h-e+1)]);F=this.J(x-te,te,x,g),z=this.J(x+te,te,x,g);for(let we=F;we<=z;we+=2){we===F||we<z&&M[we-1]>=M[we+1]?r=M[we+1]-1:r=M[we-1],b=r-(we-x)-B;const Pe=r;for(;r>s&&b>e&&this.p(r,b);)r--,b--;if(M[we]=r,ie&&Math.abs(we-_)<=te&&r<=y[we])return l[0]=r,m[0]=b,Pe>=y[we]&&1447>0&&te<=1447+1?this.x(_,u,o,O,x,F,z,B,y,M,r,a,l,b,h,m,ie,n):null}if(te<=1447){let we=new Int32Array(o-u+2);we[0]=_-u+1,D.Copy2(y,u,we,1,o-u+1),this.k.push(we),we=new Int32Array(z-F+2),we[0]=x-F+1,D.Copy2(M,F,we,1,z-F+1),this.m.push(we)}}return this.x(_,u,o,O,x,F,z,B,y,M,r,a,l,b,h,m,ie,n)}z(s){for(let a=0;a<s.length;a++){const e=s[a],h=a<s.length-1?s[a+1].originalStart:this.f.length,l=a<s.length-1?s[a+1].modifiedStart:this.h.length,m=e.originalLength>0,n=e.modifiedLength>0;for(;e.originalStart+e.originalLength<h&&e.modifiedStart+e.modifiedLength<l&&(!m||this.s(e.originalStart,e.originalStart+e.originalLength))&&(!n||this.u(e.modifiedStart,e.modifiedStart+e.modifiedLength));){const b=this.q(e.originalStart,e.modifiedStart);if(this.q(e.originalStart+e.originalLength,e.modifiedStart+e.modifiedLength)&&!b)break;e.originalStart++,e.modifiedStart++}const r=[null];if(a<s.length-1&&this.I(s[a],s[a+1],r)){s[a]=r[0],s.splice(a+1,1),a--;continue}}for(let a=s.length-1;a>=0;a--){const e=s[a];let h=0,l=0;if(a>0){const o=s[a-1];h=o.originalStart+o.originalLength,l=o.modifiedStart+o.modifiedLength}const m=e.originalLength>0,n=e.modifiedLength>0;let r=0,b=this.G(e.originalStart,e.originalLength,e.modifiedStart,e.modifiedLength);for(let o=1;;o++){const F=e.originalStart-o,z=e.modifiedStart-o;if(F<h||z<l||m&&!this.s(F,F+e.originalLength)||n&&!this.u(z,z+e.modifiedLength))break;const g=(F===h&&z===l?5:0)+this.G(F,e.originalLength,z,e.modifiedLength);g>b&&(b=g,r=o)}e.originalStart-=r,e.modifiedStart-=r;const u=[null];if(a>0&&this.I(s[a-1],s[a],u)){s[a-1]=u[0],s.splice(a,1),a++;continue}}if(this.d)for(let a=1,e=s.length;a<e;a++){const h=s[a-1],l=s[a],m=l.originalStart-h.originalStart-h.originalLength,n=h.originalStart,r=l.originalStart+l.originalLength,b=r-n,u=h.modifiedStart,o=l.modifiedStart+l.modifiedLength,F=o-u;if(m<5&&b<20&&F<20){const z=this.A(n,b,u,F,m);if(z){const[R,g]=z;(R!==h.originalStart+h.originalLength||g!==h.modifiedStart+h.modifiedLength)&&(h.originalLength=R-h.originalStart,h.modifiedLength=g-h.modifiedStart,l.originalStart=R+m,l.modifiedStart=g+m,l.originalLength=r-l.originalStart,l.modifiedLength=o-l.modifiedStart)}}}return s}A(s,a,e,h,l){if(a<l||h<l)return null;const m=s+a-l+1,n=e+h-l+1;let r=0,b=0,u=0;for(let o=s;o<m;o++)for(let F=e;F<n;F++){const z=this.B(o,F,l);z>0&&z>r&&(r=z,b=o,u=F)}return r>0?[b,u]:null}B(s,a,e){let h=0;for(let l=0;l<e;l++){if(!this.p(s+l,a+l))return 0;h+=this.e[s+l].length}return h}C(s){return s<=0||s>=this.f.length-1?!0:this.d&&/^\s*$/.test(this.e[s])}D(s,a){if(this.C(s)||this.C(s-1))return!0;if(a>0){const e=s+a;if(this.C(e-1)||this.C(e))return!0}return!1}E(s){return s<=0||s>=this.h.length-1?!0:this.d&&/^\s*$/.test(this.g[s])}F(s,a){if(this.E(s)||this.E(s-1))return!0;if(a>0){const e=s+a;if(this.E(e-1)||this.E(e))return!0}return!1}G(s,a,e,h){const l=this.D(s,a)?1:0,m=this.F(e,h)?1:0;return l+m}H(s,a){const e=[];if(s.length===0||a.length===0)return a.length>0?a:s;if(this.I(s[s.length-1],a[0],e)){const h=new Array(s.length+a.length-1);return D.Copy(s,0,h,0,s.length-1),h[s.length-1]=e[0],D.Copy(a,1,h,s.length,a.length-1),h}else{const h=new Array(s.length+a.length);return D.Copy(s,0,h,0,s.length),D.Copy(a,0,h,s.length,a.length),h}}I(s,a,e){if(w.Assert(s.originalStart<=a.originalStart,"Left change is not less than or equal to right change"),w.Assert(s.modifiedStart<=a.modifiedStart,"Left change is not less than or equal to right change"),s.originalStart+s.originalLength>=a.originalStart||s.modifiedStart+s.modifiedLength>=a.modifiedStart){const h=s.originalStart;let l=s.originalLength;const m=s.modifiedStart;let n=s.modifiedLength;return s.originalStart+s.originalLength>=a.originalStart&&(l=a.originalStart+a.originalLength-s.originalStart),s.modifiedStart+s.modifiedLength>=a.modifiedStart&&(n=a.modifiedStart+a.modifiedLength-s.modifiedStart),e[0]=new v.$Cs(h,l,m,n),!0}else return e[0]=null,!1}J(s,a,e,h){if(s>=0&&s<h)return s;const l=e,m=h-e-1,n=a%2===0;if(s<0){const r=l%2===0;return n===r?0:1}else{const r=m%2===0;return n===r?h-1:h-2}}}t.$Fs=d}),define(be[50],pe([1,0]),function(ae,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Od=void 0,t.$Od=Symbol("MicrotaskDelay")}),define(be[87],pe([1,0,11,12]),function(ae,t,v,N){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$2h=t.$1h=t.$Zh=t.$Yh=t.$Xh=void 0;class i{constructor(){this.b="",this.c=0}reset(a){return this.b=a,this.c=0,this}next(){return this.c+=1,this}hasNext(){return this.c<this.b.length-1}cmp(a){const e=a.charCodeAt(0),h=this.b.charCodeAt(this.c);return e-h}value(){return this.b[this.c]}}t.$Xh=i;class U{constructor(a=!0){this.e=a}reset(a){return this.b=a,this.c=0,this.d=0,this.next()}hasNext(){return this.d<this.b.length}next(){this.c=this.d;let a=!0;for(;this.d<this.b.length;this.d++)if(this.b.charCodeAt(this.d)===46)if(a)this.c++;else break;else a=!1;return this}cmp(a){return this.e?(0,N.$Ze)(a,this.b,0,a.length,this.c,this.d):(0,N.$2e)(a,this.b,0,a.length,this.c,this.d)}value(){return this.b.substring(this.c,this.d)}}t.$Yh=U;class w{constructor(a=!0,e=!0){this.f=a,this.g=e}reset(a){this.d=0,this.e=0,this.b=a,this.c=a.length;for(let e=a.length-1;e>=0;e--,this.c--){const h=this.b.charCodeAt(e);if(!(h===47||this.f&&h===92))break}return this.next()}hasNext(){return this.e<this.c}next(){this.d=this.e;let a=!0;for(;this.e<this.c;this.e++){const e=this.b.charCodeAt(this.e);if(e===47||this.f&&e===92)if(a)this.d++;else break;else a=!1}return this}cmp(a){return this.g?(0,N.$Ze)(a,this.b,0,a.length,this.d,this.e):(0,N.$2e)(a,this.b,0,a.length,this.d,this.e)}value(){return this.b.substring(this.d,this.e)}}t.$Zh=w;var D;(function(s){s[s.Scheme=1]="Scheme",s[s.Authority=2]="Authority",s[s.Path=3]="Path",s[s.Query=4]="Query",s[s.Fragment=5]="Fragment"})(D||(D={}));class c{constructor(a,e){this.f=a,this.g=e,this.d=[],this.e=0}reset(a){return this.c=a,this.d=[],this.c.scheme&&this.d.push(1),this.c.authority&&this.d.push(2),this.c.path&&(this.b=new w(!1,!this.f(a)),this.b.reset(a.path),this.b.value()&&this.d.push(3)),this.g(a)||(this.c.query&&this.d.push(4),this.c.fragment&&this.d.push(5)),this.e=0,this}next(){return this.d[this.e]===3&&this.b.hasNext()?this.b.next():this.e+=1,this}hasNext(){return this.d[this.e]===3&&this.b.hasNext()||this.e<this.d.length-1}cmp(a){if(this.d[this.e]===1)return(0,N.$1e)(a,this.c.scheme);if(this.d[this.e]===2)return(0,N.$1e)(a,this.c.authority);if(this.d[this.e]===3)return this.b.cmp(a);if(this.d[this.e]===4)return(0,N.$Ye)(a,this.c.query);if(this.d[this.e]===5)return(0,N.$Ye)(a,this.c.fragment);throw new Error}value(){if(this.d[this.e]===1)return this.c.scheme;if(this.d[this.e]===2)return this.c.authority;if(this.d[this.e]===3)return this.b.value();if(this.d[this.e]===4)return this.c.query;if(this.d[this.e]===5)return this.c.fragment;throw new Error}}t.$1h=c;class f{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const a=this.right;return this.right=a.left,a.left=this,this.updateHeight(),a.updateHeight(),a}rotateRight(){const a=this.left;return this.left=a.right,a.right=this,this.updateHeight(),a.updateHeight(),a}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var d;(function(s){s[s.Left=-1]="Left",s[s.Mid=0]="Mid",s[s.Right=1]="Right"})(d||(d={}));class T{static forUris(a=()=>!1,e=()=>!1){return new T(new c(a,e))}static forPaths(a=!1){return new T(new w(void 0,!a))}static forStrings(){return new T(new i)}static forConfigKeys(){return new T(new U)}constructor(a){this.b=a}clear(){this.c=void 0}fill(a,e){if(e){const h=e.slice(0);(0,v.$Wb)(h);for(const l of h)this.set(l,a)}else{const h=a.slice(0);(0,v.$Wb)(h);for(const l of h)this.set(l[0],l[1])}}set(a,e){const h=this.b.reset(a);let l;this.c||(this.c=new f,this.c.segment=h.value());const m=[];for(l=this.c;;){const r=h.cmp(l.segment);if(r>0)l.left||(l.left=new f,l.left.segment=h.value()),m.push([-1,l]),l=l.left;else if(r<0)l.right||(l.right=new f,l.right.segment=h.value()),m.push([1,l]),l=l.right;else if(h.hasNext())h.next(),l.mid||(l.mid=new f,l.mid.segment=h.value()),m.push([0,l]),l=l.mid;else break}const n=l.value;l.value=e,l.key=a;for(let r=m.length-1;r>=0;r--){const b=m[r][1];b.updateHeight();const u=b.balanceFactor();if(u<-1||u>1){const o=m[r][0],F=m[r+1][0];if(o===1&&F===1)m[r][1]=b.rotateLeft();else if(o===-1&&F===-1)m[r][1]=b.rotateRight();else if(o===1&&F===-1)b.right=m[r+1][1]=m[r+1][1].rotateRight(),m[r][1]=b.rotateLeft();else if(o===-1&&F===1)b.left=m[r+1][1]=m[r+1][1].rotateLeft(),m[r][1]=b.rotateRight();else throw new Error;if(r>0)switch(m[r-1][0]){case-1:m[r-1][1].left=m[r][1];break;case 1:m[r-1][1].right=m[r][1];break;case 0:m[r-1][1].mid=m[r][1];break}else this.c=m[0][1]}}return n}get(a){return this.d(a)?.value}d(a){const e=this.b.reset(a);let h=this.c;for(;h;){const l=e.cmp(h.segment);if(l>0)h=h.left;else if(l<0)h=h.right;else if(e.hasNext())e.next(),h=h.mid;else break}return h}has(a){const e=this.d(a);return!(e?.value===void 0&&e?.mid===void 0)}delete(a){return this.e(a,!1)}deleteSuperstr(a){return this.e(a,!0)}e(a,e){const h=this.b.reset(a),l=[];let m=this.c;for(;m;){const n=h.cmp(m.segment);if(n>0)l.push([-1,m]),m=m.left;else if(n<0)l.push([1,m]),m=m.right;else if(h.hasNext())h.next(),l.push([0,m]),m=m.mid;else break}if(m){if(e?(m.left=void 0,m.mid=void 0,m.right=void 0,m.height=1):(m.key=void 0,m.value=void 0),!m.mid&&!m.value)if(m.left&&m.right){const n=this.f(m.right);if(n.key){const{key:r,value:b,segment:u}=n;this.e(n.key,!1),m.key=r,m.value=b,m.segment=u}}else{const n=m.left??m.right;if(l.length>0){const[r,b]=l[l.length-1];switch(r){case-1:b.left=n;break;case 0:b.mid=n;break;case 1:b.right=n;break}}else this.c=n}for(let n=l.length-1;n>=0;n--){const r=l[n][1];r.updateHeight();const b=r.balanceFactor();if(b>1?(r.right.balanceFactor()>=0||(r.right=r.right.rotateRight()),l[n][1]=r.rotateLeft()):b<-1&&(r.left.balanceFactor()<=0||(r.left=r.left.rotateLeft()),l[n][1]=r.rotateRight()),n>0)switch(l[n-1][0]){case-1:l[n-1][1].left=l[n][1];break;case 1:l[n-1][1].right=l[n][1];break;case 0:l[n-1][1].mid=l[n][1];break}else this.c=l[0][1]}}}f(a){for(;a.left;)a=a.left;return a}findSubstr(a){const e=this.b.reset(a);let h=this.c,l;for(;h;){const m=e.cmp(h.segment);if(m>0)h=h.left;else if(m<0)h=h.right;else if(e.hasNext())e.next(),l=h.value||l,h=h.mid;else break}return h&&h.value||l}findSuperstr(a){return this.g(a,!1)}g(a,e){const h=this.b.reset(a);let l=this.c;for(;l;){const m=h.cmp(l.segment);if(m>0)l=l.left;else if(m<0)l=l.right;else if(h.hasNext())h.next(),l=l.mid;else return l.mid?this.h(l.mid):e?l.value:void 0}}hasElementOrSubtree(a){return this.g(a,!0)!==void 0}forEach(a){for(const[e,h]of this)a(h,e)}*[Symbol.iterator](){yield*this.h(this.c)}h(a){const e=[];return this.j(a,e),e[Symbol.iterator]()}j(a,e){a&&(a.left&&this.j(a.left,e),a.value&&e.push([a.key,a.value]),a.mid&&this.j(a.mid,e),a.right&&this.j(a.right,e))}_isBalanced(){const a=e=>{if(!e)return!0;const h=e.balanceFactor();return h<-1||h>1?!1:a(e.left)&&a(e.right)};return a(this.c)}}t.$2h=T}),define(be[7],pe([1,0]),function(ae,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Tf=t.$Sf=t.$Rf=t.$Qf=t.$Pf=t.$Of=t.$Nf=t.$Mf=t.$Lf=t.$Kf=t.$Jf=t.$If=t.$Hf=t.$Gf=t.$Ff=t.$Ef=t.$Df=t.$Cf=void 0;function v(u){return typeof u=="string"}t.$Cf=v;function N(u){return Array.isArray(u)&&u.every(o=>v(o))}t.$Df=N;function i(u){return typeof u=="object"&&u!==null&&!Array.isArray(u)&&!(u instanceof RegExp)&&!(u instanceof Date)}t.$Ef=i;function U(u){const o=Object.getPrototypeOf(Uint8Array);return typeof u=="object"&&u instanceof o}t.$Ff=U;function w(u){return typeof u=="number"&&!isNaN(u)}t.$Gf=w;function D(u){return!!u&&typeof u[Symbol.iterator]=="function"}t.$Hf=D;function c(u){return u===!0||u===!1}t.$If=c;function f(u){return typeof u>"u"}t.$Jf=f;function d(u){return!T(u)}t.$Kf=d;function T(u){return f(u)||u===null}t.$Lf=T;function s(u,o){if(!u)throw new Error(o?`Unexpected type, expected '${o}'`:"Unexpected type")}t.$Mf=s;function a(u){if(T(u))throw new Error("Assertion Failed: argument is undefined or null");return u}t.$Nf=a;function e(...u){const o=[];for(let F=0;F<u.length;F++){const z=u[F];if(T(z))throw new Error(`Assertion Failed: argument at index ${F} is undefined or null`);o.push(z)}return o}t.$Of=e;const h=Object.prototype.hasOwnProperty;function l(u){if(!i(u))return!1;for(const o in u)if(h.call(u,o))return!1;return!0}t.$Pf=l;function m(u){return typeof u=="function"}t.$Qf=m;function n(...u){return u.length>0&&u.every(m)}t.$Rf=n;function r(u,o){const F=Math.min(u.length,o.length);for(let z=0;z<F;z++)b(u[z],o[z])}t.$Sf=r;function b(u,o){if(v(o)){if(typeof u!==o)throw new Error(`argument does not match constraint: typeof ${o}`)}else if(m(o)){try{if(u instanceof o)return}catch{}if(!T(u)&&u.constructor===o||o.length===1&&o.call(void 0,u)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}t.$Tf=b}),define(be[17],pe([1,0,7]),function(ae,t,v){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$1j=t.$Zj=t.$Yj=void 0;const N=Object.create(null);function i(D,c){if((0,v.$Cf)(c)){const f=N[c];if(f===void 0)throw new Error(`${D} references an unknown codicon: ${c}`);c=f}return N[D]=c,{id:D}}function U(){return N}t.$Yj=U;function w(){return Object.values(t.$1j)}t.$Zj=w,t.$1j={add:i("add",6e4),plus:i("plus",6e4),gistNew:i("gist-new",6e4),repoCreate:i("repo-create",6e4),lightbulb:i("lightbulb",60001),lightBulb:i("light-bulb",60001),repo:i("repo",60002),repoDelete:i("repo-delete",60002),gistFork:i("gist-fork",60003),repoForked:i("repo-forked",60003),gitPullRequest:i("git-pull-request",60004),gitPullRequestAbandoned:i("git-pull-request-abandoned",60004),recordKeys:i("record-keys",60005),keyboard:i("keyboard",60005),tag:i("tag",60006),tagAdd:i("tag-add",60006),tagRemove:i("tag-remove",60006),gitPullRequestLabel:i("git-pull-request-label",60006),person:i("person",60007),personFollow:i("person-follow",60007),personOutline:i("person-outline",60007),personFilled:i("person-filled",60007),gitBranch:i("git-branch",60008),gitBranchCreate:i("git-branch-create",60008),gitBranchDelete:i("git-branch-delete",60008),sourceControl:i("source-control",60008),mirror:i("mirror",60009),mirrorPublic:i("mirror-public",60009),star:i("star",60010),starAdd:i("star-add",60010),starDelete:i("star-delete",60010),starEmpty:i("star-empty",60010),comment:i("comment",60011),commentAdd:i("comment-add",60011),alert:i("alert",60012),warning:i("warning",60012),search:i("search",60013),searchSave:i("search-save",60013),logOut:i("log-out",60014),signOut:i("sign-out",60014),logIn:i("log-in",60015),signIn:i("sign-in",60015),eye:i("eye",60016),eyeUnwatch:i("eye-unwatch",60016),eyeWatch:i("eye-watch",60016),circleFilled:i("circle-filled",60017),primitiveDot:i("primitive-dot",60017),closeDirty:i("close-dirty",60017),debugBreakpoint:i("debug-breakpoint",60017),debugBreakpointDisabled:i("debug-breakpoint-disabled",60017),debugHint:i("debug-hint",60017),primitiveSquare:i("primitive-square",60018),edit:i("edit",60019),pencil:i("pencil",60019),info:i("info",60020),issueOpened:i("issue-opened",60020),gistPrivate:i("gist-private",60021),gitForkPrivate:i("git-fork-private",60021),lock:i("lock",60021),mirrorPrivate:i("mirror-private",60021),close:i("close",60022),removeClose:i("remove-close",60022),x:i("x",60022),repoSync:i("repo-sync",60023),sync:i("sync",60023),clone:i("clone",60024),desktopDownload:i("desktop-download",60024),beaker:i("beaker",60025),microscope:i("microscope",60025),vm:i("vm",60026),deviceDesktop:i("device-desktop",60026),file:i("file",60027),fileText:i("file-text",60027),more:i("more",60028),ellipsis:i("ellipsis",60028),kebabHorizontal:i("kebab-horizontal",60028),mailReply:i("mail-reply",60029),reply:i("reply",60029),organization:i("organization",60030),organizationFilled:i("organization-filled",60030),organizationOutline:i("organization-outline",60030),newFile:i("new-file",60031),fileAdd:i("file-add",60031),newFolder:i("new-folder",60032),fileDirectoryCreate:i("file-directory-create",60032),trash:i("trash",60033),trashcan:i("trashcan",60033),history:i("history",60034),clock:i("clock",60034),folder:i("folder",60035),fileDirectory:i("file-directory",60035),symbolFolder:i("symbol-folder",60035),logoGithub:i("logo-github",60036),markGithub:i("mark-github",60036),github:i("github",60036),terminal:i("terminal",60037),console:i("console",60037),repl:i("repl",60037),zap:i("zap",60038),symbolEvent:i("symbol-event",60038),error:i("error",60039),stop:i("stop",60039),variable:i("variable",60040),symbolVariable:i("symbol-variable",60040),array:i("array",60042),symbolArray:i("symbol-array",60042),symbolModule:i("symbol-module",60043),symbolPackage:i("symbol-package",60043),symbolNamespace:i("symbol-namespace",60043),symbolObject:i("symbol-object",60043),symbolMethod:i("symbol-method",60044),symbolFunction:i("symbol-function",60044),symbolConstructor:i("symbol-constructor",60044),symbolBoolean:i("symbol-boolean",60047),symbolNull:i("symbol-null",60047),symbolNumeric:i("symbol-numeric",60048),symbolNumber:i("symbol-number",60048),symbolStructure:i("symbol-structure",60049),symbolStruct:i("symbol-struct",60049),symbolParameter:i("symbol-parameter",60050),symbolTypeParameter:i("symbol-type-parameter",60050),symbolKey:i("symbol-key",60051),symbolText:i("symbol-text",60051),symbolReference:i("symbol-reference",60052),goToFile:i("go-to-file",60052),symbolEnum:i("symbol-enum",60053),symbolValue:i("symbol-value",60053),symbolRuler:i("symbol-ruler",60054),symbolUnit:i("symbol-unit",60054),activateBreakpoints:i("activate-breakpoints",60055),archive:i("archive",60056),arrowBoth:i("arrow-both",60057),arrowDown:i("arrow-down",60058),arrowLeft:i("arrow-left",60059),arrowRight:i("arrow-right",60060),arrowSmallDown:i("arrow-small-down",60061),arrowSmallLeft:i("arrow-small-left",60062),arrowSmallRight:i("arrow-small-right",60063),arrowSmallUp:i("arrow-small-up",60064),arrowUp:i("arrow-up",60065),bell:i("bell",60066),bold:i("bold",60067),book:i("book",60068),bookmark:i("bookmark",60069),debugBreakpointConditionalUnverified:i("debug-breakpoint-conditional-unverified",60070),debugBreakpointConditional:i("debug-breakpoint-conditional",60071),debugBreakpointConditionalDisabled:i("debug-breakpoint-conditional-disabled",60071),debugBreakpointDataUnverified:i("debug-breakpoint-data-unverified",60072),debugBreakpointData:i("debug-breakpoint-data",60073),debugBreakpointDataDisabled:i("debug-breakpoint-data-disabled",60073),debugBreakpointLogUnverified:i("debug-breakpoint-log-unverified",60074),debugBreakpointLog:i("debug-breakpoint-log",60075),debugBreakpointLogDisabled:i("debug-breakpoint-log-disabled",60075),briefcase:i("briefcase",60076),broadcast:i("broadcast",60077),browser:i("browser",60078),bug:i("bug",60079),calendar:i("calendar",60080),caseSensitive:i("case-sensitive",60081),check:i("check",60082),checklist:i("checklist",60083),chevronDown:i("chevron-down",60084),dropDownButton:i("drop-down-button",60084),chevronLeft:i("chevron-left",60085),chevronRight:i("chevron-right",60086),chevronUp:i("chevron-up",60087),chromeClose:i("chrome-close",60088),chromeMaximize:i("chrome-maximize",60089),chromeMinimize:i("chrome-minimize",60090),chromeRestore:i("chrome-restore",60091),circle:i("circle",60092),circleOutline:i("circle-outline",60092),debugBreakpointUnverified:i("debug-breakpoint-unverified",60092),circleSlash:i("circle-slash",60093),circuitBoard:i("circuit-board",60094),clearAll:i("clear-all",60095),clippy:i("clippy",60096),closeAll:i("close-all",60097),cloudDownload:i("cloud-download",60098),cloudUpload:i("cloud-upload",60099),code:i("code",60100),collapseAll:i("collapse-all",60101),colorMode:i("color-mode",60102),commentDiscussion:i("comment-discussion",60103),compareChanges:i("compare-changes",60157),creditCard:i("credit-card",60105),dash:i("dash",60108),dashboard:i("dashboard",60109),database:i("database",60110),debugContinue:i("debug-continue",60111),debugDisconnect:i("debug-disconnect",60112),debugPause:i("debug-pause",60113),debugRestart:i("debug-restart",60114),debugStart:i("debug-start",60115),debugStepInto:i("debug-step-into",60116),debugStepOut:i("debug-step-out",60117),debugStepOver:i("debug-step-over",60118),debugStop:i("debug-stop",60119),debug:i("debug",60120),deviceCameraVideo:i("device-camera-video",60121),deviceCamera:i("device-camera",60122),deviceMobile:i("device-mobile",60123),diffAdded:i("diff-added",60124),diffIgnored:i("diff-ignored",60125),diffModified:i("diff-modified",60126),diffRemoved:i("diff-removed",60127),diffRenamed:i("diff-renamed",60128),diff:i("diff",60129),discard:i("discard",60130),editorLayout:i("editor-layout",60131),emptyWindow:i("empty-window",60132),exclude:i("exclude",60133),extensions:i("extensions",60134),eyeClosed:i("eye-closed",60135),fileBinary:i("file-binary",60136),fileCode:i("file-code",60137),fileMedia:i("file-media",60138),filePdf:i("file-pdf",60139),fileSubmodule:i("file-submodule",60140),fileSymlinkDirectory:i("file-symlink-directory",60141),fileSymlinkFile:i("file-symlink-file",60142),fileZip:i("file-zip",60143),files:i("files",60144),filter:i("filter",60145),flame:i("flame",60146),foldDown:i("fold-down",60147),foldUp:i("fold-up",60148),fold:i("fold",60149),folderActive:i("folder-active",60150),folderOpened:i("folder-opened",60151),gear:i("gear",60152),gift:i("gift",60153),gistSecret:i("gist-secret",60154),gist:i("gist",60155),gitCommit:i("git-commit",60156),gitCompare:i("git-compare",60157),gitMerge:i("git-merge",60158),githubAction:i("github-action",60159),githubAlt:i("github-alt",60160),globe:i("globe",60161),grabber:i("grabber",60162),graph:i("graph",60163),gripper:i("gripper",60164),heart:i("heart",60165),home:i("home",60166),horizontalRule:i("horizontal-rule",60167),hubot:i("hubot",60168),inbox:i("inbox",60169),issueClosed:i("issue-closed",60324),issueReopened:i("issue-reopened",60171),issues:i("issues",60172),italic:i("italic",60173),jersey:i("jersey",60174),json:i("json",60175),bracket:i("bracket",60175),kebabVertical:i("kebab-vertical",60176),key:i("key",60177),law:i("law",60178),lightbulbAutofix:i("lightbulb-autofix",60179),linkExternal:i("link-external",60180),link:i("link",60181),listOrdered:i("list-ordered",60182),listUnordered:i("list-unordered",60183),liveShare:i("live-share",60184),loading:i("loading",60185),location:i("location",60186),mailRead:i("mail-read",60187),mail:i("mail",60188),markdown:i("markdown",60189),megaphone:i("megaphone",60190),mention:i("mention",60191),milestone:i("milestone",60192),gitPullRequestMilestone:i("git-pull-request-milestone",60192),mortarBoard:i("mortar-board",60193),move:i("move",60194),multipleWindows:i("multiple-windows",60195),mute:i("mute",60196),noNewline:i("no-newline",60197),note:i("note",60198),octoface:i("octoface",60199),openPreview:i("open-preview",60200),package:i("package",60201),paintcan:i("paintcan",60202),pin:i("pin",60203),play:i("play",60204),run:i("run",60204),plug:i("plug",60205),preserveCase:i("preserve-case",60206),preview:i("preview",60207),project:i("project",60208),pulse:i("pulse",60209),question:i("question",60210),quote:i("quote",60211),radioTower:i("radio-tower",60212),reactions:i("reactions",60213),references:i("references",60214),refresh:i("refresh",60215),regex:i("regex",60216),remoteExplorer:i("remote-explorer",60217),remote:i("remote",60218),remove:i("remove",60219),replaceAll:i("replace-all",60220),replace:i("replace",60221),repoClone:i("repo-clone",60222),repoForcePush:i("repo-force-push",60223),repoPull:i("repo-pull",60224),repoPush:i("repo-push",60225),report:i("report",60226),requestChanges:i("request-changes",60227),rocket:i("rocket",60228),rootFolderOpened:i("root-folder-opened",60229),rootFolder:i("root-folder",60230),rss:i("rss",60231),ruby:i("ruby",60232),saveAll:i("save-all",60233),saveAs:i("save-as",60234),save:i("save",60235),screenFull:i("screen-full",60236),screenNormal:i("screen-normal",60237),searchStop:i("search-stop",60238),server:i("server",60240),settingsGear:i("settings-gear",60241),settings:i("settings",60242),shield:i("shield",60243),smiley:i("smiley",60244),sortPrecedence:i("sort-precedence",60245),splitHorizontal:i("split-horizontal",60246),splitVertical:i("split-vertical",60247),squirrel:i("squirrel",60248),starFull:i("star-full",60249),starHalf:i("star-half",60250),symbolClass:i("symbol-class",60251),symbolColor:i("symbol-color",60252),symbolCustomColor:i("symbol-customcolor",60252),symbolConstant:i("symbol-constant",60253),symbolEnumMember:i("symbol-enum-member",60254),symbolField:i("symbol-field",60255),symbolFile:i("symbol-file",60256),symbolInterface:i("symbol-interface",60257),symbolKeyword:i("symbol-keyword",60258),symbolMisc:i("symbol-misc",60259),symbolOperator:i("symbol-operator",60260),symbolProperty:i("symbol-property",60261),wrench:i("wrench",60261),wrenchSubaction:i("wrench-subaction",60261),symbolSnippet:i("symbol-snippet",60262),tasklist:i("tasklist",60263),telescope:i("telescope",60264),textSize:i("text-size",60265),threeBars:i("three-bars",60266),thumbsdown:i("thumbsdown",60267),thumbsup:i("thumbsup",60268),tools:i("tools",60269),triangleDown:i("triangle-down",60270),triangleLeft:i("triangle-left",60271),triangleRight:i("triangle-right",60272),triangleUp:i("triangle-up",60273),twitter:i("twitter",60274),unfold:i("unfold",60275),unlock:i("unlock",60276),unmute:i("unmute",60277),unverified:i("unverified",60278),verified:i("verified",60279),versions:i("versions",60280),vmActive:i("vm-active",60281),vmOutline:i("vm-outline",60282),vmRunning:i("vm-running",60283),watch:i("watch",60284),whitespace:i("whitespace",60285),wholeWord:i("whole-word",60286),window:i("window",60287),wordWrap:i("word-wrap",60288),zoomIn:i("zoom-in",60289),zoomOut:i("zoom-out",60290),listFilter:i("list-filter",60291),listFlat:i("list-flat",60292),listSelection:i("list-selection",60293),selection:i("selection",60293),listTree:i("list-tree",60294),debugBreakpointFunctionUnverified:i("debug-breakpoint-function-unverified",60295),debugBreakpointFunction:i("debug-breakpoint-function",60296),debugBreakpointFunctionDisabled:i("debug-breakpoint-function-disabled",60296),debugStackframeActive:i("debug-stackframe-active",60297),circleSmallFilled:i("circle-small-filled",60298),debugStackframeDot:i("debug-stackframe-dot",60298),debugStackframe:i("debug-stackframe",60299),debugStackframeFocused:i("debug-stackframe-focused",60299),debugBreakpointUnsupported:i("debug-breakpoint-unsupported",60300),symbolString:i("symbol-string",60301),debugReverseContinue:i("debug-reverse-continue",60302),debugStepBack:i("debug-step-back",60303),debugRestartFrame:i("debug-restart-frame",60304),callIncoming:i("call-incoming",60306),callOutgoing:i("call-outgoing",60307),menu:i("menu",60308),expandAll:i("expand-all",60309),feedback:i("feedback",60310),gitPullRequestReviewer:i("git-pull-request-reviewer",60310),groupByRefType:i("group-by-ref-type",60311),ungroupByRefType:i("ungroup-by-ref-type",60312),account:i("account",60313),gitPullRequestAssignee:i("git-pull-request-assignee",60313),bellDot:i("bell-dot",60314),debugConsole:i("debug-console",60315),library:i("library",60316),output:i("output",60317),runAll:i("run-all",60318),syncIgnored:i("sync-ignored",60319),pinned:i("pinned",60320),githubInverted:i("github-inverted",60321),debugAlt:i("debug-alt",60305),serverProcess:i("server-process",60322),serverEnvironment:i("server-environment",60323),pass:i("pass",60324),stopCircle:i("stop-circle",60325),playCircle:i("play-circle",60326),record:i("record",60327),debugAltSmall:i("debug-alt-small",60328),vmConnect:i("vm-connect",60329),cloud:i("cloud",60330),merge:i("merge",60331),exportIcon:i("export",60332),graphLeft:i("graph-left",60333),magnet:i("magnet",60334),notebook:i("notebook",60335),redo:i("redo",60336),checkAll:i("check-all",60337),pinnedDirty:i("pinned-dirty",60338),passFilled:i("pass-filled",60339),circleLargeFilled:i("circle-large-filled",60340),circleLarge:i("circle-large",60341),circleLargeOutline:i("circle-large-outline",60341),combine:i("combine",60342),gather:i("gather",60342),table:i("table",60343),variableGroup:i("variable-group",60344),typeHierarchy:i("type-hierarchy",60345),typeHierarchySub:i("type-hierarchy-sub",60346),typeHierarchySuper:i("type-hierarchy-super",60347),gitPullRequestCreate:i("git-pull-request-create",60348),runAbove:i("run-above",60349),runBelow:i("run-below",60350),notebookTemplate:i("notebook-template",60351),debugRerun:i("debug-rerun",60352),workspaceTrusted:i("workspace-trusted",60353),workspaceUntrusted:i("workspace-untrusted",60354),workspaceUnspecified:i("workspace-unspecified",60355),terminalCmd:i("terminal-cmd",60356),terminalDebian:i("terminal-debian",60357),terminalLinux:i("terminal-linux",60358),terminalPowershell:i("terminal-powershell",60359),terminalTmux:i("terminal-tmux",60360),terminalUbuntu:i("terminal-ubuntu",60361),terminalBash:i("terminal-bash",60362),arrowSwap:i("arrow-swap",60363),copy:i("copy",60364),personAdd:i("person-add",60365),filterFilled:i("filter-filled",60366),wand:i("wand",60367),debugLineByLine:i("debug-line-by-line",60368),inspect:i("inspect",60369),layers:i("layers",60370),layersDot:i("layers-dot",60371),layersActive:i("layers-active",60372),compass:i("compass",60373),compassDot:i("compass-dot",60374),compassActive:i("compass-active",60375),azure:i("azure",60376),issueDraft:i("issue-draft",60377),gitPullRequestClosed:i("git-pull-request-closed",60378),gitPullRequestDraft:i("git-pull-request-draft",60379),debugAll:i("debug-all",60380),debugCoverage:i("debug-coverage",60381),runErrors:i("run-errors",60382),folderLibrary:i("folder-library",60383),debugContinueSmall:i("debug-continue-small",60384),beakerStop:i("beaker-stop",60385),graphLine:i("graph-line",60386),graphScatter:i("graph-scatter",60387),pieChart:i("pie-chart",60388),bracketDot:i("bracket-dot",60389),bracketError:i("bracket-error",60390),lockSmall:i("lock-small",60391),azureDevops:i("azure-devops",60392),verifiedFilled:i("verified-filled",60393),newLine:i("newline",60394),layout:i("layout",60395),layoutActivitybarLeft:i("layout-activitybar-left",60396),layoutActivitybarRight:i("layout-activitybar-right",60397),layoutPanelLeft:i("layout-panel-left",60398),layoutPanelCenter:i("layout-panel-center",60399),layoutPanelJustify:i("layout-panel-justify",60400),layoutPanelRight:i("layout-panel-right",60401),layoutPanel:i("layout-panel",60402),layoutSidebarLeft:i("layout-sidebar-left",60403),layoutSidebarRight:i("layout-sidebar-right",60404),layoutStatusbar:i("layout-statusbar",60405),layoutMenubar:i("layout-menubar",60406),layoutCentered:i("layout-centered",60407),layoutSidebarRightOff:i("layout-sidebar-right-off",60416),layoutPanelOff:i("layout-panel-off",60417),layoutSidebarLeftOff:i("layout-sidebar-left-off",60418),target:i("target",60408),indent:i("indent",60409),recordSmall:i("record-small",60410),errorSmall:i("error-small",60411),arrowCircleDown:i("arrow-circle-down",60412),arrowCircleLeft:i("arrow-circle-left",60413),arrowCircleRight:i("arrow-circle-right",60414),arrowCircleUp:i("arrow-circle-up",60415),heartFilled:i("heart-filled",60420),map:i("map",60421),mapFilled:i("map-filled",60422),circleSmall:i("circle-small",60423),bellSlash:i("bell-slash",60424),bellSlashDot:i("bell-slash-dot",60425),commentUnresolved:i("comment-unresolved",60426),gitPullRequestGoToChanges:i("git-pull-request-go-to-changes",60427),gitPullRequestNewChanges:i("git-pull-request-new-changes",60428),searchFuzzy:i("search-fuzzy",60429),commentDraft:i("comment-draft",60430),send:i("send",60431),sparkle:i("sparkle",60432),insert:i("insert",60433),mic:i("mic",60434),thumbsDownFilled:i("thumbsdown-filled",60435),thumbsUpFilled:i("thumbsup-filled",60436),coffee:i("coffee",60437),snake:i("snake",60438),game:i("game",60439),vr:i("vr",60440),chip:i("chip",60441),piano:i("piano",60442),music:i("music",60443),micFilled:i("mic-filled",60444),gitFetch:i("git-fetch",60445),copilot:i("copilot",60446),dialogError:i("dialog-error","error"),dialogWarning:i("dialog-warning","warning"),dialogInfo:i("dialog-info","info"),dialogClose:i("dialog-close","close"),treeItemExpanded:i("tree-item-expanded","chevron-down"),treeFilterOnTypeOn:i("tree-filter-on-type-on","list-filter"),treeFilterOnTypeOff:i("tree-filter-on-type-off","list-selection"),treeFilterClear:i("tree-filter-clear","close"),treeItemLoading:i("tree-item-loading","loading"),menuSelection:i("menu-selection","check"),menuSubmenu:i("menu-submenu","chevron-right"),menuBarMore:i("menubar-more","more"),scrollbarButtonLeft:i("scrollbar-button-left","triangle-left"),scrollbarButtonRight:i("scrollbar-button-right","triangle-right"),scrollbarButtonUp:i("scrollbar-button-up","triangle-up"),scrollbarButtonDown:i("scrollbar-button-down","triangle-down"),toolBarMore:i("toolbar-more","more"),quickInputBack:i("quick-input-back","arrow-left")}}),define(be[51],pe([1,0,7]),function(ae,t,v){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$ln=t.$kn=t.$jn=t.$in=t.$hn=t.$gn=t.$fn=t.$en=t.$dn=t.$cn=t.$bn=t.$an=void 0;function N(m){if(!m||typeof m!="object"||m instanceof RegExp)return m;const n=Array.isArray(m)?[]:{};return Object.entries(m).forEach(([r,b])=>{n[r]=b&&typeof b=="object"?N(b):b}),n}t.$an=N;function i(m){if(!m||typeof m!="object")return m;const n=[m];for(;n.length>0;){const r=n.shift();Object.freeze(r);for(const b in r)if(U.call(r,b)){const u=r[b];typeof u=="object"&&!Object.isFrozen(u)&&!(0,v.$Ff)(u)&&n.push(u)}}return m}t.$bn=i;const U=Object.prototype.hasOwnProperty;function w(m,n){return D(m,n,new Set)}t.$cn=w;function D(m,n,r){if((0,v.$Lf)(m))return m;const b=n(m);if(typeof b<"u")return b;if(Array.isArray(m)){const u=[];for(const o of m)u.push(D(o,n,r));return u}if((0,v.$Ef)(m)){if(r.has(m))throw new Error("Cannot clone recursive data-structure");r.add(m);const u={};for(const o in m)U.call(m,o)&&(u[o]=D(m[o],n,r));return r.delete(m),u}return m}function c(m,n,r=!0){return(0,v.$Ef)(m)?((0,v.$Ef)(n)&&Object.keys(n).forEach(b=>{b in m?r&&((0,v.$Ef)(m[b])&&(0,v.$Ef)(n[b])?c(m[b],n[b],r):m[b]=n[b]):m[b]=n[b]}),m):n}t.$dn=c;function f(m,n){if(m===n)return!0;if(m==null||n===null||n===void 0||typeof m!=typeof n||typeof m!="object"||Array.isArray(m)!==Array.isArray(n))return!1;let r,b;if(Array.isArray(m)){if(m.length!==n.length)return!1;for(r=0;r<m.length;r++)if(!f(m[r],n[r]))return!1}else{const u=[];for(b in m)u.push(b);u.sort();const o=[];for(b in n)o.push(b);if(o.sort(),!f(u,o))return!1;for(r=0;r<u.length;r++)if(!f(m[u[r]],n[u[r]]))return!1}return!0}t.$en=f;function d(m){const n=new Set;return JSON.stringify(m,(r,b)=>{if((0,v.$Ef)(b)||Array.isArray(b)){if(n.has(b))return"[Circular]";n.add(b)}return b})}t.$fn=d;function T(m,n){const r=Object.create(null);return!m||!n||Object.keys(n).forEach(u=>{const o=m[u],F=n[u];f(o,F)||(r[u]=F)}),r}t.$gn=T;function s(m,n){const r=n.toLowerCase(),b=Object.keys(m).find(u=>u.toLowerCase()===r);return b?m[b]:m[n]}t.$hn=s;function a(m,n){const r=Object.create(null);for(const[b,u]of Object.entries(m))n(b,u)&&(r[b]=u);return r}t.$in=a;function e(m){let n=[];for(;Object.prototype!==m;)n=n.concat(Object.getOwnPropertyNames(m)),m=Object.getPrototypeOf(m);return n}t.$jn=e;function h(m){const n=[];for(const r of e(m))typeof m[r]=="function"&&n.push(r);return n}t.$kn=h;function l(m,n){const r=u=>function(){const o=Array.prototype.slice.call(arguments,0);return n(u,o)},b={};for(const u of m)b[u]=r(u);return b}t.$ln=l}),define(be[18],pe([1,0,17]),function(ae,t,v){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ThemeIcon=t.$2j=t.ThemeColor=void 0;var N;(function(w){function D(c){return c&&typeof c=="object"&&typeof c.id=="string"}w.isThemeColor=D})(N||(t.ThemeColor=N={}));function i(w){return{id:w}}t.$2j=i;var U;(function(w){w.iconNameSegment="[A-Za-z0-9]+",w.iconNameExpression="[A-Za-z0-9-]+",w.iconModifierExpression="~[A-Za-z]+",w.iconNameCharacter="[A-Za-z0-9~-]";const D=new RegExp(`^(${w.iconNameExpression})(${w.iconModifierExpression})?$`);function c(n){const r=D.exec(n.id);if(!r)return c(v.$1j.error);const[,b,u]=r,o=["codicon","codicon-"+b];return u&&o.push("codicon-modifier-"+u.substring(1)),o}w.asClassNameArray=c;function f(n){return c(n).join(" ")}w.asClassName=f;function d(n){return"."+c(n).join(".")}w.asCSSSelector=d;function T(n){return n&&typeof n=="object"&&typeof n.id=="string"&&(typeof n.color>"u"||N.isThemeColor(n.color))}w.isThemeIcon=T;const s=new RegExp(`^\\$\\((${w.iconNameExpression}(?:${w.iconModifierExpression})?)\\)$`);function a(n){const r=s.exec(n);if(!r)return;const[,b]=r;return{id:b}}w.fromString=a;function e(n){return{id:n}}w.fromId=e;function h(n,r){let b=n.id;const u=b.lastIndexOf("~");return u!==-1&&(b=b.substring(0,u)),r&&(b=`${b}~${r}`),{id:b}}w.modify=h;function l(n){const r=n.id.lastIndexOf("~");if(r!==-1)return n.id.substring(r+1)}w.getModifier=l;function m(n,r){return n.id===r.id&&n.color?.id===r.color?.id}w.isEqual=m})(U||(t.ThemeIcon=U={}))}),define(be[35],pe([1,0,34,12,18]),function(ae,t,v,N,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$8j=t.$7j=t.$6j=t.$5j=t.$4j=t.$3j=void 0;const U="$(",w=new RegExp(`\\$\\(${i.ThemeIcon.iconNameExpression}(?:${i.ThemeIcon.iconModifierExpression})?\\)`,"g"),D=new RegExp(`(\\\\)?${w.source}`,"g");function c(m){return m.replace(D,(n,r)=>r?n:`\\${n}`)}t.$3j=c;const f=new RegExp(`\\\\${w.source}`,"g");function d(m){return m.replace(f,n=>`\\${n}`)}t.$4j=d;const T=new RegExp(`(\\s)?(\\\\)?${w.source}(\\s)?`,"g");function s(m){return m.indexOf(U)===-1?m:m.replace(T,(n,r,b,u)=>b?n:r||u||"")}t.$5j=s;function a(m){return m?m.replace(/\$\((.*?)\)/g,(n,r)=>` ${r} `).trim():""}t.$6j=a;const e=new RegExp(`\\$\\(${i.ThemeIcon.iconNameCharacter}+\\)`,"g");function h(m){e.lastIndex=0;let n="";const r=[];let b=0;for(;;){const u=e.lastIndex,o=e.exec(m),F=m.substring(u,o?.index);if(F.length>0){n+=F;for(let z=0;z<F.length;z++)r.push(b)}if(!o)break;b+=o[0].length}return{text:n,iconOffsets:r}}t.$7j=h;function l(m,n,r=!1){const{text:b,iconOffsets:u}=n;if(!u||u.length===0)return(0,v.$Pj)(m,b,r);const o=(0,N.$Ne)(b," "),F=b.length-o.length,z=(0,v.$Pj)(m,o,r);if(z)for(const R of z){const g=u[R.start+F]+F;R.start+=g,R.end+=g}return z}t.$8j=l}),define(be[88],pe([1,0]),function(ae,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$TT=t.$ST=void 0,t.$ST="vscode:contextmenu",t.$TT="vscode:onCloseContextMenu"}),define(be[89],pe([1,0]),function(ae,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$1T=void 0;class v{constructor(i,U){this.a=i,this.onMessage=U}send(i){try{this.a.send("vscode:message",i.buffer)}catch{}}disconnect(){this.a.send("vscode:disconnect",null)}}t.$1T=v}),define(be[30],pe([1,0]),function(ae,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$R=t.$Q=t.$P=t.$O=t.$N=void 0;const v=globalThis.vscode;t.$N=v.ipcRenderer,t.$O=v.ipcMessagePort,t.$P=v.webFrame,t.$Q=v.process,t.$R=v.context}),define(be[90],pe([1,0,88,30]),function(ae,t,v,N){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$WT=void 0;let i=0;function U(D,c,f){const d=[],T=i++,s=`vscode:onContextMenu${T}`,a=(e,h,l)=>{d[h].click?.(l)};N.$N.once(s,a),N.$N.once(v.$TT,(e,h)=>{h===T&&(N.$N.removeListener(s,a),f?.())}),N.$N.send(v.$ST,T,D.map(e=>w(e,d)),s,c)}t.$WT=U;function w(D,c){const f={id:c.length,label:D.label,type:D.type,accelerator:D.accelerator,checked:D.checked,enabled:typeof D.enabled=="boolean"?D.enabled:!0,visible:typeof D.visible=="boolean"?D.visible:!0};return c.push(D),Array.isArray(D.submenu)&&(f.submenu=D.submenu.map(d=>w(d,c))),f}}),define(be[52],pe([8]),{}),define(be[91],pe([8]),{}),define(be[92],pe([8]),{}),define(be[93],pe([8]),{}),define(be[94],pe([1,0,92,93]),function(ae,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0})}),define(be[95],pe([8]),{}),define(be[96],pe([8]),{}),define(be[97],pe([8]),{}),define(be[98],pe([8]),{}),define(be[99],pe([8]),{}),define(be[100],pe([8]),{}),define(be[101],pe([8]),{}),define(be[102],pe([8]),{}),define(be[103],pe([8]),{}),define(be[104],pe([13,10]),function(ae,t){return ae.create("vs/base/browser/ui/actionbar/actionViewItems",t)}),define(be[105],pe([13,10]),function(ae,t){return ae.create("vs/base/browser/ui/findinput/findInput",t)}),define(be[106],pe([13,10]),function(ae,t){return ae.create("vs/base/browser/ui/findinput/findInputToggles",t)}),define(be[107],pe([13,10]),function(ae,t){return ae.create("vs/base/browser/ui/iconLabel/iconLabelHover",t)}),define(be[108],pe([13,10]),function(ae,t){return ae.create("vs/base/browser/ui/inputbox/inputBox",t)}),define(be[109],pe([13,10]),function(ae,t){return ae.create("vs/base/browser/ui/selectBox/selectBoxCustom",t)}),define(be[110],pe([13,10]),function(ae,t){return ae.create("vs/base/browser/ui/tree/abstractTree",t)}),define(be[111],pe([13,10]),function(ae,t){return ae.create("vs/base/common/actions",t)}),define(be[36],pe([1,0,4,2,111]),function(ae,t,v,N,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Fi=t.$Ei=t.$Di=t.$Ci=t.$Bi=t.$Ai=void 0;class U extends N.$Rc{constructor(s,a="",e="",h=!0,l){super(),this.h=this.B(new v.$Rd),this.onDidChange=this.h.event,this.w=!0,this.j=s,this.m=a,this.u=e,this.w=h,this.C=l}get id(){return this.j}get label(){return this.m}set label(s){this.D(s)}D(s){this.m!==s&&(this.m=s,this.h.fire({label:s}))}get tooltip(){return this.n||""}set tooltip(s){this.F(s)}F(s){this.n!==s&&(this.n=s,this.h.fire({tooltip:s}))}get class(){return this.u}set class(s){this.G(s)}G(s){this.u!==s&&(this.u=s,this.h.fire({class:s}))}get enabled(){return this.w}set enabled(s){this.H(s)}H(s){this.w!==s&&(this.w=s,this.h.fire({enabled:s}))}get checked(){return this.z}set checked(s){this.I(s)}I(s){this.z!==s&&(this.z=s,this.h.fire({checked:s}))}async run(s,a){this.C&&await this.C(s)}}t.$Ai=U;class w extends N.$Rc{constructor(){super(...arguments),this.f=this.B(new v.$Rd),this.onWillRun=this.f.event,this.m=this.B(new v.$Rd),this.onDidRun=this.m.event}async run(s,a){if(!s.enabled)return;this.f.fire({action:s});let e;try{await this.u(s,a)}catch(h){e=h}this.m.fire({action:s,error:e})}async u(s,a){await s.run(a)}}t.$Bi=w;class D{constructor(){this.id=D.ID,this.label="",this.tooltip="",this.class="separator",this.enabled=!1,this.checked=!1}static join(...s){let a=[];for(const e of s)e.length&&(a.length?a=[...a,new D,...e]:a=e);return a}static{this.ID="vs.actions.separator"}async run(){}}t.$Ci=D;class c{get actions(){return this.a}constructor(s,a,e,h){this.tooltip="",this.enabled=!0,this.checked=void 0,this.id=s,this.label=a,this.class=h,this.a=e}async run(){}}t.$Di=c;class f extends U{static{this.ID="vs.actions.empty"}constructor(){super(f.ID,i.localize(0,null),void 0,!1)}}t.$Ei=f;function d(T){return{id:T.id,label:T.label,class:void 0,enabled:T.enabled??!0,checked:T.checked??!1,run:async(...s)=>T.run(...s),tooltip:T.label}}t.$Fi=d}),define(be[112],pe([13,10]),function(ae,t){return ae.create("vs/base/common/platform",t)}),define(be[5],pe([1,0,112]),function(ae,t,v){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$I=t.$H=t.$G=t.$F=t.$E=t.$D=t.OS=t.OperatingSystem=t.$B=t.$A=t.$z=t.$y=t.$x=t.Language=t.$w=t.$v=t.$u=t.$t=t.$s=t.$r=t.$q=t.$p=t.$o=t.$n=t.$m=t.$l=t.$k=t.$j=t.$i=t.$h=t.Platform=t.$g=void 0,t.$g="en";let N=!1,i=!1,U=!1,w=!1,D=!1,c=!1,f=!1,d=!1,T=!1,s=!1,a,e=t.$g,h=t.$g,l,m;const n=globalThis;let r;typeof n.vscode<"u"&&typeof n.vscode.process<"u"?r=n.vscode.process:typeof process<"u"&&(r=process);const b=typeof r?.versions?.electron=="string",u=b&&r?.type==="renderer";if(typeof navigator=="object"&&!u)m=navigator.userAgent,N=m.indexOf("Windows")>=0,i=m.indexOf("Macintosh")>=0,d=(m.indexOf("Macintosh")>=0||m.indexOf("iPad")>=0||m.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,U=m.indexOf("Linux")>=0,s=m?.indexOf("Mobi")>=0,c=!0,a=v.getConfiguredDefaultLocale(v.localize(0,null))||t.$g,e=a,h=navigator.language;else if(typeof r=="object"){N=r.platform==="win32",i=r.platform==="darwin",U=r.platform==="linux",w=U&&!!r.env.SNAP&&!!r.env.SNAP_REVISION,f=b,T=!!r.env.CI||!!r.env.BUILD_ARTIFACTSTAGINGDIRECTORY,a=t.$g,e=t.$g;const x=r.env.VSCODE_NLS_CONFIG;if(x)try{const O=JSON.parse(x),B=O.availableLanguages["*"];a=O.locale,h=O.osLocale,e=B||t.$g,l=O._translationsConfigFile}catch{}D=!0}else console.error("Unable to resolve platform.");var o;(function(x){x[x.Web=0]="Web",x[x.Mac=1]="Mac",x[x.Linux=2]="Linux",x[x.Windows=3]="Windows"})(o||(t.Platform=o={}));function F(x){switch(x){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}t.$h=F;let z=0;i?z=1:N?z=3:U&&(z=2),t.$i=N,t.$j=i,t.$k=U,t.$l=w,t.$m=D,t.$n=f,t.$o=c,t.$p=c&&typeof n.importScripts=="function",t.$q=t.$p?n.origin:void 0,t.$r=d,t.$s=s,t.$t=T,t.$u=z,t.$v=m,t.$w=e;var R;(function(x){function O(){return t.$w}x.value=O;function B(){return t.$w.length===2?t.$w==="en":t.$w.length>=3?t.$w[0]==="e"&&t.$w[1]==="n"&&t.$w[2]==="-":!1}x.isDefaultVariant=B;function j(){return t.$w==="en"}x.isDefault=j})(R||(t.Language=R={})),t.$x=a,t.$y=h,t.$z=l,t.$A=typeof n.postMessage=="function"&&!n.importScripts,t.$B=(()=>{if(t.$A){const x=[];n.addEventListener("message",B=>{if(B.data&&B.data.vscodeScheduleAsyncWork)for(let j=0,ie=x.length;j<ie;j++){const te=x[j];if(te.id===B.data.vscodeScheduleAsyncWork){x.splice(j,1),te.callback();return}}});let O=0;return B=>{const j=++O;x.push({id:j,callback:B}),n.postMessage({vscodeScheduleAsyncWork:j},"*")}}return x=>setTimeout(x)})();var g;(function(x){x[x.Windows=1]="Windows",x[x.Macintosh=2]="Macintosh",x[x.Linux=3]="Linux"})(g||(t.OperatingSystem=g={})),t.OS=i||d?2:N?1:3;let y=!0,M=!1;function _(){if(!M){M=!0;const x=new Uint8Array(2);x[0]=1,x[1]=2,y=new Uint16Array(x.buffer)[0]===(2<<8)+1}return y}t.$D=_,t.$E=!!(t.$v&&t.$v.indexOf("Chrome")>=0),t.$F=!!(t.$v&&t.$v.indexOf("Firefox")>=0),t.$G=!!(!t.$E&&t.$v&&t.$v.indexOf("Safari")>=0),t.$H=!!(t.$v&&t.$v.indexOf("Edg/")>=0),t.$I=!!(t.$v&&t.$v.indexOf("Android")>=0)}),define(be[113],pe([1,0,16,21,5]),function(ae,t,v,N,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$RO=t.KeyboardSupport=void 0;var U;(function(w){w[w.Always=0]="Always",w[w.FullScreen=1]="FullScreen",w[w.None=2]="None"})(U||(t.KeyboardSupport=U={})),t.$RO={clipboard:{writeText:i.$m||document.queryCommandSupported&&document.queryCommandSupported("copy")||!!(navigator&&navigator.clipboard&&navigator.clipboard.writeText),readText:i.$m||!!(navigator&&navigator.clipboard&&navigator.clipboard.readText)},keyboard:(()=>i.$m||v.$PO()?0:navigator.keyboard||v.$LO?1:2)(),touch:"ontouchstart"in N.$vO||navigator.maxTouchPoints>0,pointerEvents:N.$vO.PointerEvent&&("ontouchstart"in N.$vO||navigator.maxTouchPoints>0||navigator.maxTouchPoints>0)}}),define(be[14],pe([1,0,16,44,78,5]),function(ae,t,v,N,i,U){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$ZO=t.$YO=t.$XO=void 0;function w(e){if(e.charCode){const l=String.fromCharCode(e.charCode).toUpperCase();return N.KeyCodeUtils.fromString(l)}const h=e.keyCode;if(h===3)return 7;if(v.$IO)switch(h){case 59:return 85;case 60:if(U.$k)return 97;break;case 61:return 86;case 107:return 109;case 109:return 111;case 173:return 88;case 224:if(U.$j)return 57;break}else if(v.$JO){if(U.$j&&h===93)return 57;if(!U.$j&&h===92)return 57}return N.$Gq[h]||0}const D=U.$j?256:2048,c=512,f=1024,d=U.$j?2048:256;function T(e){const h=[];return e.ctrlKey&&h.push("ctrl"),e.shiftKey&&h.push("shift"),e.altKey&&h.push("alt"),e.metaKey&&h.push("meta"),`modifiers: [${h.join(",")}], code: ${e.code}, keyCode: ${e.keyCode}, key: ${e.key}`}t.$XO=T;function s(e){const h=[];return e.ctrlKey&&h.push("ctrl"),e.shiftKey&&h.push("shift"),e.altKey&&h.push("alt"),e.metaKey&&h.push("meta"),`modifiers: [${h.join(",")}], code: ${e.code}, keyCode: ${e.keyCode} ('${N.KeyCodeUtils.toString(e.keyCode)}')`}t.$YO=s;class a{constructor(h){this._standardKeyboardEventBrand=!0;const l=h;this.browserEvent=l,this.target=l.target,this.ctrlKey=l.ctrlKey,this.shiftKey=l.shiftKey,this.altKey=l.altKey,this.metaKey=l.metaKey,this.altGraphKey=l.getModifierState("AltGraph"),this.keyCode=w(l),this.code=l.code,this.ctrlKey=this.ctrlKey||this.keyCode===5,this.altKey=this.altKey||this.keyCode===6,this.shiftKey=this.shiftKey||this.keyCode===4,this.metaKey=this.metaKey||this.keyCode===57,this.a=this.c(),this.b=this.d()}preventDefault(){this.browserEvent&&this.browserEvent.preventDefault&&this.browserEvent.preventDefault()}stopPropagation(){this.browserEvent&&this.browserEvent.stopPropagation&&this.browserEvent.stopPropagation()}toKeyCodeChord(){return this.b}equals(h){return this.a===h}c(){let h=0;this.keyCode!==5&&this.keyCode!==4&&this.keyCode!==6&&this.keyCode!==57&&(h=this.keyCode);let l=0;return this.ctrlKey&&(l|=D),this.altKey&&(l|=c),this.shiftKey&&(l|=f),this.metaKey&&(l|=d),l|=h,l}d(){let h=0;return this.keyCode!==5&&this.keyCode!==4&&this.keyCode!==6&&this.keyCode!==57&&(h=this.keyCode),new i.$Oq(this.ctrlKey,this.shiftKey,this.altKey,this.metaKey,h)}}t.$ZO=a}),define(be[19],pe([1,0,16,69,5]),function(ae,t,v,N,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$WO=t.$VO=t.$UO=void 0;class U{constructor(f,d){this.timestamp=Date.now(),this.browserEvent=d,this.leftButton=d.button===0,this.middleButton=d.button===1,this.rightButton=d.button===2,this.buttons=d.buttons,this.target=d.target,this.detail=d.detail||1,d.type==="dblclick"&&(this.detail=2),this.ctrlKey=d.ctrlKey,this.shiftKey=d.shiftKey,this.altKey=d.altKey,this.metaKey=d.metaKey,typeof d.pageX=="number"?(this.posx=d.pageX,this.posy=d.pageY):(this.posx=d.clientX+this.target.ownerDocument.body.scrollLeft+this.target.ownerDocument.documentElement.scrollLeft,this.posy=d.clientY+this.target.ownerDocument.body.scrollTop+this.target.ownerDocument.documentElement.scrollTop);const T=N.$SO.getPositionOfChildWindowRelativeToAncestorWindow(f,d.view);this.posx-=T.left,this.posy-=T.top}preventDefault(){this.browserEvent.preventDefault()}stopPropagation(){this.browserEvent.stopPropagation()}}t.$UO=U;class w extends U{constructor(f,d){super(f,d),this.dataTransfer=d.dataTransfer}}t.$VO=w;class D{constructor(f,d=0,T=0){if(this.browserEvent=f||null,this.target=f?f.target||f.targetNode||f.srcElement:null,this.deltaY=T,this.deltaX=d,f){const s=f,a=f;if(typeof s.wheelDeltaY<"u")this.deltaY=s.wheelDeltaY/120;else if(typeof a.VERTICAL_AXIS<"u"&&a.axis===a.VERTICAL_AXIS)this.deltaY=-a.detail/3;else if(f.type==="wheel"){const e=f;e.deltaMode===e.DOM_DELTA_LINE?v.$IO&&!i.$j?this.deltaY=-f.deltaY/3:this.deltaY=-f.deltaY:this.deltaY=-f.deltaY/40}if(typeof s.wheelDeltaX<"u")v.$LO&&i.$i?this.deltaX=-(s.wheelDeltaX/120):this.deltaX=s.wheelDeltaX/120;else if(typeof a.HORIZONTAL_AXIS<"u"&&a.axis===a.HORIZONTAL_AXIS)this.deltaX=-f.detail/3;else if(f.type==="wheel"){const e=f;e.deltaMode===e.DOM_DELTA_LINE?v.$IO&&!i.$j?this.deltaX=-f.deltaX/3:this.deltaX=-f.deltaX:this.deltaX=-f.deltaX/40}this.deltaY===0&&this.deltaX===0&&f.wheelDelta&&(this.deltaY=f.wheelDelta/120)}}preventDefault(){this.browserEvent?.preventDefault()}stopPropagation(){this.browserEvent?.stopPropagation()}}t.$WO=D}),define(be[114],pe([1,0,5]),function(ae,t,v){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$dc=t.$cc=t.env=t.cwd=void 0;let N;const i=globalThis.vscode;if(typeof i<"u"&&typeof i.process<"u"){const U=i.process;N={get platform(){return U.platform},get arch(){return U.arch},get env(){return U.env},cwd(){return U.cwd()}}}else typeof process<"u"?N={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:N={get platform(){return v.$i?"win32":v.$j?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};t.cwd=N.cwd,t.env=N.env,t.$cc=N.platform,t.$dc=N.arch}),define(be[23],pe([1,0,114]),function(ae,t,v){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$sc=t.sep=t.$qc=t.$pc=t.$oc=t.$nc=t.$mc=t.$lc=t.$kc=t.$jc=t.$ic=t.$hc=t.$gc=t.$fc=t.$ec=void 0;const N=65,i=97,U=90,w=122,D=46,c=47,f=92,d=58,T=63;class s extends Error{constructor(F,z,R){let g;typeof z=="string"&&z.indexOf("not ")===0?(g="must not be",z=z.replace(/^not /,"")):g="must be";const y=F.indexOf(".")!==-1?"property":"argument";let M=`The "${F}" ${y} ${g} of type ${z}`;M+=`. Received type ${typeof R}`,super(M),this.code="ERR_INVALID_ARG_TYPE"}}function a(o,F){if(o===null||typeof o!="object")throw new s(F,"Object",o)}function e(o,F){if(typeof o!="string")throw new s(F,"string",o)}const h=v.$cc==="win32";function l(o){return o===c||o===f}function m(o){return o===c}function n(o){return o>=N&&o<=U||o>=i&&o<=w}function r(o,F,z,R){let g="",y=0,M=-1,_=0,x=0;for(let O=0;O<=o.length;++O){if(O<o.length)x=o.charCodeAt(O);else{if(R(x))break;x=c}if(R(x)){if(!(M===O-1||_===1))if(_===2){if(g.length<2||y!==2||g.charCodeAt(g.length-1)!==D||g.charCodeAt(g.length-2)!==D){if(g.length>2){const B=g.lastIndexOf(z);B===-1?(g="",y=0):(g=g.slice(0,B),y=g.length-1-g.lastIndexOf(z)),M=O,_=0;continue}else if(g.length!==0){g="",y=0,M=O,_=0;continue}}F&&(g+=g.length>0?`${z}..`:"..",y=2)}else g.length>0?g+=`${z}${o.slice(M+1,O)}`:g=o.slice(M+1,O),y=O-M-1;M=O,_=0}else x===D&&_!==-1?++_:_=-1}return g}function b(o,F){a(F,"pathObject");const z=F.dir||F.root,R=F.base||`${F.name||""}${F.ext||""}`;return z?z===F.root?`${z}${R}`:`${z}${o}${R}`:R}t.$ec={resolve(...o){let F="",z="",R=!1;for(let g=o.length-1;g>=-1;g--){let y;if(g>=0){if(y=o[g],e(y,"path"),y.length===0)continue}else F.length===0?y=v.cwd():(y=v.env[`=${F}`]||v.cwd(),(y===void 0||y.slice(0,2).toLowerCase()!==F.toLowerCase()&&y.charCodeAt(2)===f)&&(y=`${F}\\`));const M=y.length;let _=0,x="",O=!1;const B=y.charCodeAt(0);if(M===1)l(B)&&(_=1,O=!0);else if(l(B))if(O=!0,l(y.charCodeAt(1))){let j=2,ie=j;for(;j<M&&!l(y.charCodeAt(j));)j++;if(j<M&&j!==ie){const te=y.slice(ie,j);for(ie=j;j<M&&l(y.charCodeAt(j));)j++;if(j<M&&j!==ie){for(ie=j;j<M&&!l(y.charCodeAt(j));)j++;(j===M||j!==ie)&&(x=`\\\\${te}\\${y.slice(ie,j)}`,_=j)}}}else _=1;else n(B)&&y.charCodeAt(1)===d&&(x=y.slice(0,2),_=2,M>2&&l(y.charCodeAt(2))&&(O=!0,_=3));if(x.length>0)if(F.length>0){if(x.toLowerCase()!==F.toLowerCase())continue}else F=x;if(R){if(F.length>0)break}else if(z=`${y.slice(_)}\\${z}`,R=O,O&&F.length>0)break}return z=r(z,!R,"\\",l),R?`${F}\\${z}`:`${F}${z}`||"."},normalize(o){e(o,"path");const F=o.length;if(F===0)return".";let z=0,R,g=!1;const y=o.charCodeAt(0);if(F===1)return m(y)?"\\":o;if(l(y))if(g=!0,l(o.charCodeAt(1))){let _=2,x=_;for(;_<F&&!l(o.charCodeAt(_));)_++;if(_<F&&_!==x){const O=o.slice(x,_);for(x=_;_<F&&l(o.charCodeAt(_));)_++;if(_<F&&_!==x){for(x=_;_<F&&!l(o.charCodeAt(_));)_++;if(_===F)return`\\\\${O}\\${o.slice(x)}\\`;_!==x&&(R=`\\\\${O}\\${o.slice(x,_)}`,z=_)}}}else z=1;else n(y)&&o.charCodeAt(1)===d&&(R=o.slice(0,2),z=2,F>2&&l(o.charCodeAt(2))&&(g=!0,z=3));let M=z<F?r(o.slice(z),!g,"\\",l):"";return M.length===0&&!g&&(M="."),M.length>0&&l(o.charCodeAt(F-1))&&(M+="\\"),R===void 0?g?`\\${M}`:M:g?`${R}\\${M}`:`${R}${M}`},isAbsolute(o){e(o,"path");const F=o.length;if(F===0)return!1;const z=o.charCodeAt(0);return l(z)||F>2&&n(z)&&o.charCodeAt(1)===d&&l(o.charCodeAt(2))},join(...o){if(o.length===0)return".";let F,z;for(let y=0;y<o.length;++y){const M=o[y];e(M,"path"),M.length>0&&(F===void 0?F=z=M:F+=`\\${M}`)}if(F===void 0)return".";let R=!0,g=0;if(typeof z=="string"&&l(z.charCodeAt(0))){++g;const y=z.length;y>1&&l(z.charCodeAt(1))&&(++g,y>2&&(l(z.charCodeAt(2))?++g:R=!1))}if(R){for(;g<F.length&&l(F.charCodeAt(g));)g++;g>=2&&(F=`\\${F.slice(g)}`)}return t.$ec.normalize(F)},relative(o,F){if(e(o,"from"),e(F,"to"),o===F)return"";const z=t.$ec.resolve(o),R=t.$ec.resolve(F);if(z===R||(o=z.toLowerCase(),F=R.toLowerCase(),o===F))return"";let g=0;for(;g<o.length&&o.charCodeAt(g)===f;)g++;let y=o.length;for(;y-1>g&&o.charCodeAt(y-1)===f;)y--;const M=y-g;let _=0;for(;_<F.length&&F.charCodeAt(_)===f;)_++;let x=F.length;for(;x-1>_&&F.charCodeAt(x-1)===f;)x--;const O=x-_,B=M<O?M:O;let j=-1,ie=0;for(;ie<B;ie++){const ce=o.charCodeAt(g+ie);if(ce!==F.charCodeAt(_+ie))break;ce===f&&(j=ie)}if(ie!==B){if(j===-1)return R}else{if(O>B){if(F.charCodeAt(_+ie)===f)return R.slice(_+ie+1);if(ie===2)return R.slice(_+ie)}M>B&&(o.charCodeAt(g+ie)===f?j=ie:ie===2&&(j=3)),j===-1&&(j=0)}let te="";for(ie=g+j+1;ie<=y;++ie)(ie===y||o.charCodeAt(ie)===f)&&(te+=te.length===0?"..":"\\..");return _+=j,te.length>0?`${te}${R.slice(_,x)}`:(R.charCodeAt(_)===f&&++_,R.slice(_,x))},toNamespacedPath(o){if(typeof o!="string"||o.length===0)return o;const F=t.$ec.resolve(o);if(F.length<=2)return o;if(F.charCodeAt(0)===f){if(F.charCodeAt(1)===f){const z=F.charCodeAt(2);if(z!==T&&z!==D)return`\\\\?\\UNC\\${F.slice(2)}`}}else if(n(F.charCodeAt(0))&&F.charCodeAt(1)===d&&F.charCodeAt(2)===f)return`\\\\?\\${F}`;return o},dirname(o){e(o,"path");const F=o.length;if(F===0)return".";let z=-1,R=0;const g=o.charCodeAt(0);if(F===1)return l(g)?o:".";if(l(g)){if(z=R=1,l(o.charCodeAt(1))){let _=2,x=_;for(;_<F&&!l(o.charCodeAt(_));)_++;if(_<F&&_!==x){for(x=_;_<F&&l(o.charCodeAt(_));)_++;if(_<F&&_!==x){for(x=_;_<F&&!l(o.charCodeAt(_));)_++;if(_===F)return o;_!==x&&(z=R=_+1)}}}}else n(g)&&o.charCodeAt(1)===d&&(z=F>2&&l(o.charCodeAt(2))?3:2,R=z);let y=-1,M=!0;for(let _=F-1;_>=R;--_)if(l(o.charCodeAt(_))){if(!M){y=_;break}}else M=!1;if(y===-1){if(z===-1)return".";y=z}return o.slice(0,y)},basename(o,F){F!==void 0&&e(F,"ext"),e(o,"path");let z=0,R=-1,g=!0,y;if(o.length>=2&&n(o.charCodeAt(0))&&o.charCodeAt(1)===d&&(z=2),F!==void 0&&F.length>0&&F.length<=o.length){if(F===o)return"";let M=F.length-1,_=-1;for(y=o.length-1;y>=z;--y){const x=o.charCodeAt(y);if(l(x)){if(!g){z=y+1;break}}else _===-1&&(g=!1,_=y+1),M>=0&&(x===F.charCodeAt(M)?--M===-1&&(R=y):(M=-1,R=_))}return z===R?R=_:R===-1&&(R=o.length),o.slice(z,R)}for(y=o.length-1;y>=z;--y)if(l(o.charCodeAt(y))){if(!g){z=y+1;break}}else R===-1&&(g=!1,R=y+1);return R===-1?"":o.slice(z,R)},extname(o){e(o,"path");let F=0,z=-1,R=0,g=-1,y=!0,M=0;o.length>=2&&o.charCodeAt(1)===d&&n(o.charCodeAt(0))&&(F=R=2);for(let _=o.length-1;_>=F;--_){const x=o.charCodeAt(_);if(l(x)){if(!y){R=_+1;break}continue}g===-1&&(y=!1,g=_+1),x===D?z===-1?z=_:M!==1&&(M=1):z!==-1&&(M=-1)}return z===-1||g===-1||M===0||M===1&&z===g-1&&z===R+1?"":o.slice(z,g)},format:b.bind(null,"\\"),parse(o){e(o,"path");const F={root:"",dir:"",base:"",ext:"",name:""};if(o.length===0)return F;const z=o.length;let R=0,g=o.charCodeAt(0);if(z===1)return l(g)?(F.root=F.dir=o,F):(F.base=F.name=o,F);if(l(g)){if(R=1,l(o.charCodeAt(1))){let j=2,ie=j;for(;j<z&&!l(o.charCodeAt(j));)j++;if(j<z&&j!==ie){for(ie=j;j<z&&l(o.charCodeAt(j));)j++;if(j<z&&j!==ie){for(ie=j;j<z&&!l(o.charCodeAt(j));)j++;j===z?R=j:j!==ie&&(R=j+1)}}}}else if(n(g)&&o.charCodeAt(1)===d){if(z<=2)return F.root=F.dir=o,F;if(R=2,l(o.charCodeAt(2))){if(z===3)return F.root=F.dir=o,F;R=3}}R>0&&(F.root=o.slice(0,R));let y=-1,M=R,_=-1,x=!0,O=o.length-1,B=0;for(;O>=R;--O){if(g=o.charCodeAt(O),l(g)){if(!x){M=O+1;break}continue}_===-1&&(x=!1,_=O+1),g===D?y===-1?y=O:B!==1&&(B=1):y!==-1&&(B=-1)}return _!==-1&&(y===-1||B===0||B===1&&y===_-1&&y===M+1?F.base=F.name=o.slice(M,_):(F.name=o.slice(M,y),F.base=o.slice(M,_),F.ext=o.slice(y,_))),M>0&&M!==R?F.dir=o.slice(0,M-1):F.dir=F.root,F},sep:"\\",delimiter:";",win32:null,posix:null};const u=(()=>{if(h){const o=/\\/g;return()=>{const F=v.cwd().replace(o,"/");return F.slice(F.indexOf("/"))}}return()=>v.cwd()})();t.$fc={resolve(...o){let F="",z=!1;for(let R=o.length-1;R>=-1&&!z;R--){const g=R>=0?o[R]:u();e(g,"path"),g.length!==0&&(F=`${g}/${F}`,z=g.charCodeAt(0)===c)}return F=r(F,!z,"/",m),z?`/${F}`:F.length>0?F:"."},normalize(o){if(e(o,"path"),o.length===0)return".";const F=o.charCodeAt(0)===c,z=o.charCodeAt(o.length-1)===c;return o=r(o,!F,"/",m),o.length===0?F?"/":z?"./":".":(z&&(o+="/"),F?`/${o}`:o)},isAbsolute(o){return e(o,"path"),o.length>0&&o.charCodeAt(0)===c},join(...o){if(o.length===0)return".";let F;for(let z=0;z<o.length;++z){const R=o[z];e(R,"path"),R.length>0&&(F===void 0?F=R:F+=`/${R}`)}return F===void 0?".":t.$fc.normalize(F)},relative(o,F){if(e(o,"from"),e(F,"to"),o===F||(o=t.$fc.resolve(o),F=t.$fc.resolve(F),o===F))return"";const z=1,R=o.length,g=R-z,y=1,M=F.length-y,_=g<M?g:M;let x=-1,O=0;for(;O<_;O++){const j=o.charCodeAt(z+O);if(j!==F.charCodeAt(y+O))break;j===c&&(x=O)}if(O===_)if(M>_){if(F.charCodeAt(y+O)===c)return F.slice(y+O+1);if(O===0)return F.slice(y+O)}else g>_&&(o.charCodeAt(z+O)===c?x=O:O===0&&(x=0));let B="";for(O=z+x+1;O<=R;++O)(O===R||o.charCodeAt(O)===c)&&(B+=B.length===0?"..":"/..");return`${B}${F.slice(y+x)}`},toNamespacedPath(o){return o},dirname(o){if(e(o,"path"),o.length===0)return".";const F=o.charCodeAt(0)===c;let z=-1,R=!0;for(let g=o.length-1;g>=1;--g)if(o.charCodeAt(g)===c){if(!R){z=g;break}}else R=!1;return z===-1?F?"/":".":F&&z===1?"//":o.slice(0,z)},basename(o,F){F!==void 0&&e(F,"ext"),e(o,"path");let z=0,R=-1,g=!0,y;if(F!==void 0&&F.length>0&&F.length<=o.length){if(F===o)return"";let M=F.length-1,_=-1;for(y=o.length-1;y>=0;--y){const x=o.charCodeAt(y);if(x===c){if(!g){z=y+1;break}}else _===-1&&(g=!1,_=y+1),M>=0&&(x===F.charCodeAt(M)?--M===-1&&(R=y):(M=-1,R=_))}return z===R?R=_:R===-1&&(R=o.length),o.slice(z,R)}for(y=o.length-1;y>=0;--y)if(o.charCodeAt(y)===c){if(!g){z=y+1;break}}else R===-1&&(g=!1,R=y+1);return R===-1?"":o.slice(z,R)},extname(o){e(o,"path");let F=-1,z=0,R=-1,g=!0,y=0;for(let M=o.length-1;M>=0;--M){const _=o.charCodeAt(M);if(_===c){if(!g){z=M+1;break}continue}R===-1&&(g=!1,R=M+1),_===D?F===-1?F=M:y!==1&&(y=1):F!==-1&&(y=-1)}return F===-1||R===-1||y===0||y===1&&F===R-1&&F===z+1?"":o.slice(F,R)},format:b.bind(null,"/"),parse(o){e(o,"path");const F={root:"",dir:"",base:"",ext:"",name:""};if(o.length===0)return F;const z=o.charCodeAt(0)===c;let R;z?(F.root="/",R=1):R=0;let g=-1,y=0,M=-1,_=!0,x=o.length-1,O=0;for(;x>=R;--x){const B=o.charCodeAt(x);if(B===c){if(!_){y=x+1;break}continue}M===-1&&(_=!1,M=x+1),B===D?g===-1?g=x:O!==1&&(O=1):g!==-1&&(O=-1)}if(M!==-1){const B=y===0&&z?1:y;g===-1||O===0||O===1&&g===M-1&&g===y+1?F.base=F.name=o.slice(B,M):(F.name=o.slice(B,g),F.base=o.slice(B,M),F.ext=o.slice(g,M))}return y>0?F.dir=o.slice(0,y-1):z&&(F.dir="/"),F},sep:"/",delimiter:":",win32:null,posix:null},t.$fc.win32=t.$ec.win32=t.$ec,t.$fc.posix=t.$ec.posix=t.$fc,t.$gc=h?t.$ec.normalize:t.$fc.normalize,t.$hc=h?t.$ec.isAbsolute:t.$fc.isAbsolute,t.$ic=h?t.$ec.join:t.$fc.join,t.$jc=h?t.$ec.resolve:t.$fc.resolve,t.$kc=h?t.$ec.relative:t.$fc.relative,t.$lc=h?t.$ec.dirname:t.$fc.dirname,t.$mc=h?t.$ec.basename:t.$fc.basename,t.$nc=h?t.$ec.extname:t.$fc.extname,t.$oc=h?t.$ec.format:t.$fc.format,t.$pc=h?t.$ec.parse:t.$fc.parse,t.$qc=h?t.$ec.toNamespacedPath:t.$fc.toNamespacedPath,t.sep=h?t.$ec.sep:t.$fc.sep,t.$sc=h?t.$ec.delimiter:t.$fc.delimiter}),define(be[115],pe([1,0,23,5,12,7]),function(ae,t,v,N,i,U){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$0f=t.$9f=t.$8f=t.$7f=t.$6f=t.$5f=t.$4f=t.$3f=t.$2f=t.$1f=t.$Zf=t.$Yf=t.$Xf=t.$Wf=t.$Vf=t.$Uf=void 0;function w(y){return y===47||y===92}t.$Uf=w;function D(y){return y.replace(/[\\/]/g,v.$fc.sep)}t.$Vf=D;function c(y){return y.indexOf("/")===-1&&(y=D(y)),/^[a-zA-Z]:(\/|$)/.test(y)&&(y="/"+y),y}t.$Wf=c;function f(y,M=v.$fc.sep){if(!y)return"";const _=y.length,x=y.charCodeAt(0);if(w(x)){if(w(y.charCodeAt(1))&&!w(y.charCodeAt(2))){let B=3;const j=B;for(;B<_&&!w(y.charCodeAt(B));B++);if(j!==B&&!w(y.charCodeAt(B+1))){for(B+=1;B<_;B++)if(w(y.charCodeAt(B)))return y.slice(0,B+1).replace(/[\\/]/g,M)}}return M}else if(m(x)&&y.charCodeAt(1)===58)return w(y.charCodeAt(2))?y.slice(0,2)+M:y.slice(0,2);let O=y.indexOf("://");if(O!==-1){for(O+=3;O<_;O++)if(w(y.charCodeAt(O)))return y.slice(0,O+1)}return""}t.$Xf=f;function d(y){if(!N.$i||!y||y.length<5)return!1;let M=y.charCodeAt(0);if(M!==92||(M=y.charCodeAt(1),M!==92))return!1;let _=2;const x=_;for(;_<y.length&&(M=y.charCodeAt(_),M!==92);_++);return!(x===_||(M=y.charCodeAt(_+1),isNaN(M)||M===92))}t.$Yf=d;const T=/[\\/:\*\?"<>\|]/g,s=/[\\/]/g,a=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function e(y,M=N.$i){const _=M?T:s;return!(!y||y.length===0||/^\s+$/.test(y)||(_.lastIndex=0,_.test(y))||M&&a.test(y)||y==="."||y===".."||M&&y[y.length-1]==="."||M&&y.length!==y.trim().length||y.length>255)}t.$Zf=e;function h(y,M,_){const x=y===M;return!_||x?x:!y||!M?!1:(0,i.$6e)(y,M)}t.$1f=h;function l(y,M,_,x=v.sep){if(y===M)return!0;if(!y||!M||M.length>y.length)return!1;if(_){if(!(0,i.$7e)(y,M))return!1;if(M.length===y.length)return!0;let B=M.length;return M.charAt(M.length-1)===x&&B--,y.charAt(B)===x}return M.charAt(M.length-1)!==x&&(M+=x),y.indexOf(M)===0}t.$2f=l;function m(y){return y>=65&&y<=90||y>=97&&y<=122}t.$3f=m;function n(y,M){return N.$i&&y.endsWith(":")&&(y+=v.sep),(0,v.$hc)(y)||(y=(0,v.$ic)(M,y)),y=(0,v.$gc)(y),N.$i?(y=(0,i.$Oe)(y,v.sep),y.endsWith(":")&&(y+=v.sep)):(y=(0,i.$Oe)(y,v.sep),y||(y=v.sep)),y}t.$4f=n;function r(y){const M=(0,v.$gc)(y);return N.$i?y.length>3?!1:b(M)&&(y.length===2||M.charCodeAt(2)===92):M===v.$fc.sep}t.$5f=r;function b(y,M=N.$i){return M?m(y.charCodeAt(0))&&y.charCodeAt(1)===58:!1}t.$6f=b;function u(y,M=N.$i){return b(y,M)?y[0]:void 0}t.$7f=u;function o(y,M,_){return M.length>y.length?-1:y===M?0:(_&&(y=y.toLowerCase(),M=M.toLowerCase()),y.indexOf(M))}t.$8f=o;function F(y){const M=y.split(":");let _,x,O;for(const B of M){const j=Number(B);(0,U.$Gf)(j)?x===void 0?x=j:O===void 0&&(O=j):_=_?[_,B].join(":"):B}if(!_)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:_,line:x!==void 0?x:void 0,column:O!==void 0?O:x!==void 0?1:void 0}}t.$9f=F;const z="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789",R="BDEFGHIJKMOQRSTUVWXYZbdefghijkmoqrstuvwxyz0123456789";function g(y,M,_=8){let x="";for(let B=0;B<_;B++){let j;B===0&&N.$i&&!M&&(_===3||_===4)?j=R:j=z,x+=j.charAt(Math.floor(Math.random()*j.length))}let O;return M?O=`${M}-${x}`:O=x,y?(0,v.$ic)(y,O):O}t.$0f=g}),define(be[116],pe([1,0,23]),function(ae,t,v){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Zr=t.$Yr=t.$Xr=t.$Wr=t.$Vr=void 0,t.$Vr=Object.freeze({text:"text/plain",binary:"application/octet-stream",unknown:"application/unknown",markdown:"text/markdown",latex:"text/latex",uriList:"text/uri-list"});const N={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},i={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function U(d){const T=(0,v.$nc)(d),s=N[T.toLowerCase()];return s!==void 0?s:w(d)}t.$Wr=U;function w(d){const T=(0,v.$nc)(d);return i[T.toLowerCase()]}t.$Xr=w;function D(d){for(const T in i)if(i[T]===d)return T}t.$Yr=D;const c=/^(.+)\/(.+?)(;.+)?$/;function f(d,T){const s=c.exec(d);return s?`${s[1].toLowerCase()}/${s[2].toLowerCase()}${s[3]??""}`:T?void 0:d}t.$Zr=f}),define(be[15],pe([1,0,23,5]),function(ae,t,v,N){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$vc=t.$uc=t.URI=void 0;const i=/^\w[\w\d+.-]*$/,U=/^\//,w=/^\/\//;function D(R,g){if(!R.scheme&&g)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${R.authority}", path: "${R.path}", query: "${R.query}", fragment: "${R.fragment}"}`);if(R.scheme&&!i.test(R.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(R.path){if(R.authority){if(!U.test(R.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(w.test(R.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function c(R,g){return!R&&!g?"file":R}function f(R,g){switch(R){case"https":case"http":case"file":g?g[0]!==T&&(g=T+g):g=T;break}return g}const d="",T="/",s=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class a{static isUri(g){return g instanceof a?!0:g?typeof g.authority=="string"&&typeof g.fragment=="string"&&typeof g.path=="string"&&typeof g.query=="string"&&typeof g.scheme=="string"&&typeof g.fsPath=="string"&&typeof g.with=="function"&&typeof g.toString=="function":!1}constructor(g,y,M,_,x,O=!1){typeof g=="object"?(this.scheme=g.scheme||d,this.authority=g.authority||d,this.path=g.path||d,this.query=g.query||d,this.fragment=g.fragment||d):(this.scheme=c(g,O),this.authority=y||d,this.path=f(this.scheme,M||d),this.query=_||d,this.fragment=x||d,D(this,O))}get fsPath(){return b(this,!1)}with(g){if(!g)return this;let{scheme:y,authority:M,path:_,query:x,fragment:O}=g;return y===void 0?y=this.scheme:y===null&&(y=d),M===void 0?M=this.authority:M===null&&(M=d),_===void 0?_=this.path:_===null&&(_=d),x===void 0?x=this.query:x===null&&(x=d),O===void 0?O=this.fragment:O===null&&(O=d),y===this.scheme&&M===this.authority&&_===this.path&&x===this.query&&O===this.fragment?this:new l(y,M,_,x,O)}static parse(g,y=!1){const M=s.exec(g);return M?new l(M[2]||d,z(M[4]||d),z(M[5]||d),z(M[7]||d),z(M[9]||d),y):new l(d,d,d,d,d)}static file(g){let y=d;if(N.$i&&(g=g.replace(/\\/g,T)),g[0]===T&&g[1]===T){const M=g.indexOf(T,2);M===-1?(y=g.substring(2),g=T):(y=g.substring(2,M),g=g.substring(M)||T)}return new l("file",y,g,d,d)}static from(g,y){return new l(g.scheme,g.authority,g.path,g.query,g.fragment,y)}static joinPath(g,...y){if(!g.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let M;return N.$i&&g.scheme==="file"?M=a.file(v.$ec.join(b(g,!0),...y)).path:M=v.$fc.join(g.path,...y),g.with({path:M})}toString(g=!1){return u(this,g)}toJSON(){return this}static revive(g){if(g){if(g instanceof a)return g;{const y=new l(g);return y._formatted=g.external??null,y._fsPath=g._sep===h?g.fsPath??null:null,y}}else return g}}t.URI=a;function e(R){return!R||typeof R!="object"?!1:typeof R.scheme=="string"&&(typeof R.authority=="string"||typeof R.authority>"u")&&(typeof R.path=="string"||typeof R.path>"u")&&(typeof R.query=="string"||typeof R.query>"u")&&(typeof R.fragment=="string"||typeof R.fragment>"u")}t.$uc=e;const h=N.$i?1:void 0;class l extends a{constructor(){super(...arguments),this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=b(this,!1)),this._fsPath}toString(g=!1){return g?u(this,!0):(this._formatted||(this._formatted=u(this,!1)),this._formatted)}toJSON(){const g={$mid:1};return this._fsPath&&(g.fsPath=this._fsPath,g._sep=h),this._formatted&&(g.external=this._formatted),this.path&&(g.path=this.path),this.scheme&&(g.scheme=this.scheme),this.authority&&(g.authority=this.authority),this.query&&(g.query=this.query),this.fragment&&(g.fragment=this.fragment),g}}const m={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function n(R,g,y){let M,_=-1;for(let x=0;x<R.length;x++){const O=R.charCodeAt(x);if(O>=97&&O<=122||O>=65&&O<=90||O>=48&&O<=57||O===45||O===46||O===95||O===126||g&&O===47||y&&O===91||y&&O===93||y&&O===58)_!==-1&&(M+=encodeURIComponent(R.substring(_,x)),_=-1),M!==void 0&&(M+=R.charAt(x));else{M===void 0&&(M=R.substr(0,x));const B=m[O];B!==void 0?(_!==-1&&(M+=encodeURIComponent(R.substring(_,x)),_=-1),M+=B):_===-1&&(_=x)}}return _!==-1&&(M+=encodeURIComponent(R.substring(_))),M!==void 0?M:R}function r(R){let g;for(let y=0;y<R.length;y++){const M=R.charCodeAt(y);M===35||M===63?(g===void 0&&(g=R.substr(0,y)),g+=m[M]):g!==void 0&&(g+=R[y])}return g!==void 0?g:R}function b(R,g){let y;return R.authority&&R.path.length>1&&R.scheme==="file"?y=`//${R.authority}${R.path}`:R.path.charCodeAt(0)===47&&(R.path.charCodeAt(1)>=65&&R.path.charCodeAt(1)<=90||R.path.charCodeAt(1)>=97&&R.path.charCodeAt(1)<=122)&&R.path.charCodeAt(2)===58?g?y=R.path.substr(1):y=R.path[1].toLowerCase()+R.path.substr(2):y=R.path,N.$i&&(y=y.replace(/\//g,"\\")),y}t.$vc=b;function u(R,g){const y=g?r:n;let M="",{scheme:_,authority:x,path:O,query:B,fragment:j}=R;if(_&&(M+=_,M+=":"),(x||_==="file")&&(M+=T,M+=T),x){let ie=x.indexOf("@");if(ie!==-1){const te=x.substr(0,ie);x=x.substr(ie+1),ie=te.lastIndexOf(":"),ie===-1?M+=y(te,!1,!1):(M+=y(te.substr(0,ie),!1,!1),M+=":",M+=y(te.substr(ie+1),!1,!0)),M+="@"}x=x.toLowerCase(),ie=x.lastIndexOf(":"),ie===-1?M+=y(x,!1,!0):(M+=y(x.substr(0,ie),!1,!0),M+=x.substr(ie))}if(O){if(O.length>=3&&O.charCodeAt(0)===47&&O.charCodeAt(2)===58){const ie=O.charCodeAt(1);ie>=65&&ie<=90&&(O=`/${String.fromCharCode(ie+32)}:${O.substr(3)}`)}else if(O.length>=2&&O.charCodeAt(1)===58){const ie=O.charCodeAt(0);ie>=65&&ie<=90&&(O=`${String.fromCharCode(ie+32)}:${O.substr(2)}`)}M+=y(O,!0,!1)}return B&&(M+="?",M+=y(B,!1,!1)),j&&(M+="#",M+=g?j:n(j,!1,!1)),M}function o(R){try{return decodeURIComponent(R)}catch{return R.length>3?R.substr(0,3)+o(R.substr(3)):R}}const F=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function z(R){return R.match(F)?R.replace(F,g=>o(g)):R}}),define(be[53],pe([1,0,33,15]),function(ae,t,v,N){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$sh=t.$rh=t.$qh=void 0;function i(c){return JSON.stringify(c,w)}t.$qh=i;function U(c){let f=JSON.parse(c);return f=D(f),f}t.$rh=U;function w(c,f){return f instanceof RegExp?{$mid:2,source:f.source,flags:f.flags}:f}function D(c,f=0){if(!c||f>200)return c;if(typeof c=="object"){switch(c.$mid){case 1:return N.URI.revive(c);case 2:return new RegExp(c.source,c.flags);case 17:return new Date(c.source)}if(c instanceof v.$fe||c instanceof Uint8Array)return c;if(Array.isArray(c))for(let d=0;d<c.length;++d)c[d]=D(c[d],f+1);else for(const d in c)Object.hasOwnProperty.call(c,d)&&(c[d]=D(c[d],f+1))}return c}t.$sh=D}),define(be[31],pe([1,0,6,5,15]),function(ae,t,v,N,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.COI=t.$gg=t.$fg=t.$eg=t.$dg=t.$cg=t.$bg=t.$ag=t.$_f=t.$$f=t.Schemas=void 0;var U;(function(f){f.inMemory="inmemory",f.vscode="vscode",f.internal="private",f.walkThrough="walkThrough",f.walkThroughSnippet="walkThroughSnippet",f.http="http",f.https="https",f.file="file",f.mailto="mailto",f.untitled="untitled",f.data="data",f.command="command",f.vscodeRemote="vscode-remote",f.vscodeRemoteResource="vscode-remote-resource",f.vscodeManagedRemoteResource="vscode-managed-remote-resource",f.vscodeUserData="vscode-userdata",f.vscodeCustomEditor="vscode-custom-editor",f.vscodeNotebookCell="vscode-notebook-cell",f.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",f.vscodeNotebookCellOutput="vscode-notebook-cell-output",f.vscodeInteractiveInput="vscode-interactive-input",f.vscodeSettings="vscode-settings",f.vscodeWorkspaceTrust="vscode-workspace-trust",f.vscodeTerminal="vscode-terminal",f.vscodeChatSesssion="vscode-chat-editor",f.webviewPanel="webview-panel",f.vscodeWebview="vscode-webview",f.extension="extension",f.vscodeFileResource="vscode-file",f.tmp="tmp",f.vsls="vsls",f.vscodeSourceControl="vscode-scm"})(U||(t.Schemas=U={})),t.$$f="vscode-tkn",t.$_f="tkn";class w{constructor(){this.a=Object.create(null),this.b=Object.create(null),this.c=Object.create(null),this.d="http",this.e=null,this.f=`/${U.vscodeRemoteResource}`}setPreferredWebSchema(d){this.d=d}setDelegate(d){this.e=d}setServerRootPath(d){this.f=`${d}/${U.vscodeRemoteResource}`}set(d,T,s){this.a[d]=T,this.b[d]=s}setConnectionToken(d,T){this.c[d]=T}getPreferredWebSchema(){return this.d}rewrite(d){if(this.e)try{return this.e(d)}catch(l){return v.$Z(l),d}const T=d.authority;let s=this.a[T];s&&s.indexOf(":")!==-1&&s.indexOf("[")===-1&&(s=`[${s}]`);const a=this.b[T],e=this.c[T];let h=`path=${encodeURIComponent(d.path)}`;return typeof e=="string"&&(h+=`&${t.$_f}=${encodeURIComponent(e)}`),i.URI.from({scheme:N.$o?this.d:U.vscodeRemoteResource,authority:`${s}:${a}`,path:this.f,query:h})}}t.$ag=new w,t.$bg="vs/../../extensions",t.$cg="vs/../../node_modules",t.$dg="vs/../../node_modules.asar",t.$eg="vs/../../node_modules.asar.unpacked",t.$fg="vscode-app";class D{static{this.a=t.$fg}asBrowserUri(d){const T=this.b(d,ae);return this.uriToBrowserUri(T)}uriToBrowserUri(d){return d.scheme===U.vscodeRemote?t.$ag.rewrite(d):d.scheme===U.file&&(N.$m||N.$q===`${U.vscodeFileResource}://${D.a}`)?d.with({scheme:U.vscodeFileResource,authority:d.authority||D.a,query:null,fragment:null}):d}asFileUri(d){const T=this.b(d,ae);return this.uriToFileUri(T)}uriToFileUri(d){return d.scheme===U.vscodeFileResource?d.with({scheme:U.file,authority:d.authority!==D.a?d.authority:null,query:null,fragment:null}):d}b(d,T){return i.URI.isUri(d)?d:i.URI.parse(T.toUrl(d))}}t.$gg=new D;var c;(function(f){const d=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);f.CoopAndCoep=Object.freeze(d.get("3"));const T="vscode-coi";function s(e){let h;typeof e=="string"?h=new URL(e).searchParams:e instanceof URL?h=e.searchParams:i.URI.isUri(e)&&(h=new URL(e.toString(!0)).searchParams);const l=h?.get(T);if(l)return d.get(l)}f.getHeadersFromQuery=s;function a(e,h,l){if(!globalThis.crossOriginIsolated)return;const m=h&&l?"3":l?"2":"1";e instanceof URLSearchParams?e.set(T,m):e[T]=m}f.addSearchParam=a})(c||(t.COI=c={}))}),define(be[37],pe([1,0,115,31,23,5,12,15]),function(ae,t,v,N,i,U,w,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Jg=t.DataUri=t.$Ig=t.$Hg=t.$Gg=t.$Fg=t.$Eg=t.$Dg=t.$Cg=t.$Bg=t.$Ag=t.$zg=t.$yg=t.$xg=t.$wg=t.$vg=t.$ug=t.$tg=t.$sg=t.$rg=t.$qg=t.$pg=t.$og=t.$ng=void 0;function c(a){return(0,D.$vc)(a,!0)}t.$ng=c;class f{constructor(e){this.a=e}compare(e,h,l=!1){return e===h?0:(0,w.$Ye)(this.getComparisonKey(e,l),this.getComparisonKey(h,l))}isEqual(e,h,l=!1){return e===h?!0:!e||!h?!1:this.getComparisonKey(e,l)===this.getComparisonKey(h,l)}getComparisonKey(e,h=!1){return e.with({path:this.a(e)?e.path.toLowerCase():void 0,fragment:h?null:void 0}).toString()}ignorePathCasing(e){return this.a(e)}isEqualOrParent(e,h,l=!1){if(e.scheme===h.scheme){if(e.scheme===N.Schemas.file)return v.$2f(c(e),c(h),this.a(e))&&e.query===h.query&&(l||e.fragment===h.fragment);if((0,t.$Eg)(e.authority,h.authority))return v.$2f(e.path,h.path,this.a(e),"/")&&e.query===h.query&&(l||e.fragment===h.fragment)}return!1}joinPath(e,...h){return D.URI.joinPath(e,...h)}basenameOrAuthority(e){return(0,t.$wg)(e)||e.authority}basename(e){return i.$fc.basename(e.path)}extname(e){return i.$fc.extname(e.path)}dirname(e){if(e.path.length===0)return e;let h;return e.scheme===N.Schemas.file?h=D.URI.file(i.$lc(c(e))).path:(h=i.$fc.dirname(e.path),e.authority&&h.length&&h.charCodeAt(0)!==47&&(console.error(`dirname("${e.toString})) resulted in a relative path`),h="/")),e.with({path:h})}normalizePath(e){if(!e.path.length)return e;let h;return e.scheme===N.Schemas.file?h=D.URI.file(i.$gc(c(e))).path:h=i.$fc.normalize(e.path),e.with({path:h})}relativePath(e,h){if(e.scheme!==h.scheme||!(0,t.$Eg)(e.authority,h.authority))return;if(e.scheme===N.Schemas.file){const n=i.$kc(c(e),c(h));return U.$i?v.$Vf(n):n}let l=e.path||"/";const m=h.path||"/";if(this.a(e)){let n=0;for(const r=Math.min(l.length,m.length);n<r&&!(l.charCodeAt(n)!==m.charCodeAt(n)&&l.charAt(n).toLowerCase()!==m.charAt(n).toLowerCase());n++);l=m.substr(0,n)+l.substr(n)}return i.$fc.relative(l,m)}resolvePath(e,h){if(e.scheme===N.Schemas.file){const l=D.URI.file(i.$jc(c(e),h));return e.with({authority:l.authority,path:l.path})}return h=v.$Wf(h),e.with({path:i.$fc.resolve(e.path,h)})}isAbsolutePath(e){return!!e.path&&e.path[0]==="/"}isEqualAuthority(e,h){return e===h||e!==void 0&&h!==void 0&&(0,w.$6e)(e,h)}hasTrailingPathSeparator(e,h=i.sep){if(e.scheme===N.Schemas.file){const l=c(e);return l.length>v.$Xf(l).length&&l[l.length-1]===h}else{const l=e.path;return l.length>1&&l.charCodeAt(l.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(e.fsPath)}}removeTrailingPathSeparator(e,h=i.sep){return(0,t.$Fg)(e,h)?e.with({path:e.path.substr(0,e.path.length-1)}):e}addTrailingPathSeparator(e,h=i.sep){let l=!1;if(e.scheme===N.Schemas.file){const m=c(e);l=m!==void 0&&m.length===v.$Xf(m).length&&m[m.length-1]===h}else{h="/";const m=e.path;l=m.length===1&&m.charCodeAt(m.length-1)===47}return!l&&!(0,t.$Fg)(e,h)?e.with({path:e.path+"/"}):e}}t.$og=f,t.$pg=new f(()=>!1),t.$qg=new f(a=>a.scheme===N.Schemas.file?!U.$k:!0),t.$rg=new f(a=>!0),t.$sg=t.$pg.isEqual.bind(t.$pg),t.$tg=t.$pg.isEqualOrParent.bind(t.$pg),t.$ug=t.$pg.getComparisonKey.bind(t.$pg),t.$vg=t.$pg.basenameOrAuthority.bind(t.$pg),t.$wg=t.$pg.basename.bind(t.$pg),t.$xg=t.$pg.extname.bind(t.$pg),t.$yg=t.$pg.dirname.bind(t.$pg),t.$zg=t.$pg.joinPath.bind(t.$pg),t.$Ag=t.$pg.normalizePath.bind(t.$pg),t.$Bg=t.$pg.relativePath.bind(t.$pg),t.$Cg=t.$pg.resolvePath.bind(t.$pg),t.$Dg=t.$pg.isAbsolutePath.bind(t.$pg),t.$Eg=t.$pg.isEqualAuthority.bind(t.$pg),t.$Fg=t.$pg.hasTrailingPathSeparator.bind(t.$pg),t.$Gg=t.$pg.removeTrailingPathSeparator.bind(t.$pg),t.$Hg=t.$pg.addTrailingPathSeparator.bind(t.$pg);function d(a,e){const h=[];for(let l=0;l<a.length;l++){const m=e(a[l]);a.some((n,r)=>r===l?!1:(0,t.$tg)(m,e(n)))||h.push(a[l])}return h}t.$Ig=d;var T;(function(a){a.META_DATA_LABEL="label",a.META_DATA_DESCRIPTION="description",a.META_DATA_SIZE="size",a.META_DATA_MIME="mime";function e(h){const l=new Map;h.path.substring(h.path.indexOf(";")+1,h.path.lastIndexOf(";")).split(";").forEach(r=>{const[b,u]=r.split(":");b&&u&&l.set(b,u)});const n=h.path.substring(0,h.path.indexOf(";"));return n&&l.set(a.META_DATA_MIME,n),l}a.parseMetaData=e})(T||(t.DataUri=T={}));function s(a,e,h){if(e){let l=a.path;return l&&l[0]!==i.$fc.sep&&(l=i.$fc.sep+l),a.with({scheme:h,authority:e,path:l})}return a.with({scheme:h})}t.$Jg=s}),define(be[9],pe([1,0,29,6,4,2,37,5,50]),function(ae,t,v,N,i,U,w,D,c){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$mh=t.$lh=t.$kh=t.$jh=t.Promises=t.$ih=t.$hh=t.$gh=t.$fh=t.$eh=t.$dh=t.$ch=t.$bh=t.$ah=t.$_g=t.$$g=t.$0g=t.$9g=t.$8g=t.$7g=t.$6g=t.$5g=t.$4g=t.$3g=t.$2g=t.$1g=t.$Zg=t.$Yg=t.$Xg=t.$Wg=t.$Vg=t.$Ug=t.$Tg=t.$Sg=t.$Rg=t.$Qg=t.$Pg=t.$Og=t.$Ng=t.$Mg=t.$Lg=t.$Kg=void 0;function f(Q){return!!Q&&typeof Q.then=="function"}t.$Kg=f;function d(Q){const p=new v.$2d,A=Q(p.token),E=new Promise((I,k)=>{const L=p.token.onCancellationRequested(()=>{L.dispose(),p.dispose(),k(new N.$4)});Promise.resolve(A).then(S=>{L.dispose(),p.dispose(),I(S)},S=>{L.dispose(),p.dispose(),k(S)})});return new class{cancel(){p.cancel()}then(I,k){return E.then(I,k)}catch(I){return this.then(void 0,I)}finally(I){return E.finally(I)}}}t.$Lg=d;function T(Q,p,A){return new Promise((E,I)=>{const k=p.onCancellationRequested(()=>{k.dispose(),E(A)});Q.then(E,I).finally(()=>k.dispose())})}t.$Mg=T;function s(Q,p){return new Promise((A,E)=>{const I=p.onCancellationRequested(()=>{I.dispose(),E(new N.$4)});Q.then(A,E).finally(()=>I.dispose())})}t.$Ng=s;async function a(Q){let p=-1;const A=Q.map((E,I)=>E.then(k=>(p=I,k)));try{return await Promise.race(A)}finally{Q.forEach((E,I)=>{I!==p&&E.cancel()})}}t.$Og=a;function e(Q,p,A){let E;const I=setTimeout(()=>{E?.(void 0),A?.()},p);return Promise.race([Q.finally(()=>clearTimeout(I)),new Promise(k=>E=k)])}t.$Pg=e;function h(Q){return new Promise((p,A)=>{const E=Q();f(E)?E.then(p,A):p(E)})}t.$Qg=h;class l{constructor(){this.f=!1,this.a=null,this.b=null,this.d=null}queue(p){if(this.f)return Promise.reject(new Error("Throttler is disposed"));if(this.a){if(this.d=p,!this.b){const A=()=>{if(this.b=null,this.f)return;const E=this.queue(this.d);return this.d=null,E};this.b=new Promise(E=>{this.a.then(A,A).then(E)})}return new Promise((A,E)=>{this.b.then(A,E)})}return this.a=p(),new Promise((A,E)=>{this.a.then(I=>{this.a=null,A(I)},I=>{this.a=null,E(I)})})}dispose(){this.f=!0}}t.$Rg=l;class m{constructor(){this.a=Promise.resolve(null)}queue(p){return this.a=this.a.then(()=>p(),()=>p())}}t.$Sg=m;class n{constructor(){this.a=new Map}queue(p,A){const I=(this.a.get(p)??Promise.resolve()).catch(()=>{}).then(A).finally(()=>{this.a.get(p)===I&&this.a.delete(p)});return this.a.set(p,I),I}}t.$Tg=n;const r=(Q,p)=>{let A=!0;const E=setTimeout(()=>{A=!1,p()},Q);return{isTriggered:()=>A,dispose:()=>{clearTimeout(E),A=!1}}},b=Q=>{let p=!0;return queueMicrotask(()=>{p&&(p=!1,Q())}),{isTriggered:()=>p,dispose:()=>{p=!1}}};class u{constructor(p){this.defaultDelay=p,this.a=null,this.b=null,this.d=null,this.f=null,this.g=null}trigger(p,A=this.defaultDelay){this.g=p,this.h(),this.b||(this.b=new Promise((I,k)=>{this.d=I,this.f=k}).then(()=>{if(this.b=null,this.d=null,this.g){const I=this.g;return this.g=null,I()}}));const E=()=>{this.a=null,this.d?.(null)};return this.a=A===c.$Od?b(E):r(A,E),this.b}isTriggered(){return!!this.a?.isTriggered()}cancel(){this.h(),this.b&&(this.f?.(new N.$4),this.b=null)}h(){this.a?.dispose(),this.a=null}dispose(){this.cancel()}}t.$Ug=u;class o{constructor(p){this.a=new u(p),this.b=new l}trigger(p,A){return this.a.trigger(()=>this.b.queue(p),A)}isTriggered(){return this.a.isTriggered()}cancel(){this.a.cancel()}dispose(){this.a.dispose(),this.b.dispose()}}t.$Vg=o;class F{constructor(){this.a=!1,this.b=new Promise((p,A)=>{this.d=p})}isOpen(){return this.a}open(){this.a=!0,this.d(!0)}wait(){return this.b}}t.$Wg=F;class z extends F{constructor(p){super(),this.f=setTimeout(()=>this.open(),p)}open(){clearTimeout(this.f),super.open()}}t.$Xg=z;function R(Q,p){return p?new Promise((A,E)=>{const I=setTimeout(()=>{k.dispose(),A()},Q),k=p.onCancellationRequested(()=>{clearTimeout(I),k.dispose(),E(new N.$4)})}):d(A=>R(Q,A))}t.$Yg=R;function g(Q,p=0,A){const E=setTimeout(()=>{Q(),A&&I.dispose()},p),I=(0,U.$Pc)(()=>{clearTimeout(E),A?.deleteAndLeak(I)});return A?.add(I),I}t.$Zg=g;function y(Q){const p=[];let A=0;const E=Q.length;function I(){return A<E?Q[A++]():null}function k(L){L!=null&&p.push(L);const S=I();return S?S.then(k):Promise.resolve(p)}return Promise.resolve(null).then(k)}t.$1g=y;function M(Q,p=E=>!!E,A=null){let E=0;const I=Q.length,k=()=>{if(E>=I)return Promise.resolve(A);const L=Q[E++];return Promise.resolve(L()).then(P=>p(P)?Promise.resolve(P):k())};return k()}t.$2g=M;function _(Q,p=E=>!!E,A=null){if(Q.length===0)return Promise.resolve(A);let E=Q.length;const I=()=>{E=-1;for(const k of Q)k.cancel?.()};return new Promise((k,L)=>{for(const S of Q)S.then(P=>{--E>=0&&p(P)?(I(),k(P)):E===0&&k(A)}).catch(P=>{--E>=0&&(I(),L(P))})})}t.$3g=_;class x{constructor(p){this.a=0,this.d=p,this.f=[],this.b=0,this.g=new i.$Rd}get onDrained(){return this.g.event}get size(){return this.a}queue(p){return this.a++,new Promise((A,E)=>{this.f.push({factory:p,c:A,e:E}),this.h()})}h(){for(;this.f.length&&this.b<this.d;){const p=this.f.shift();this.b++;const A=p.factory();A.then(p.c,p.e),A.then(()=>this.j(),()=>this.j())}}j(){this.a--,this.b--,this.f.length>0?this.h():this.g.fire()}dispose(){this.g.dispose()}}t.$4g=x;class O extends x{constructor(){super(1)}}t.$5g=O;class B{constructor(){this.a=new de,this.b=0}queue(p){return this.a.isRunning()?this.a.queue(()=>this.a.run(this.b++,p())):this.a.run(this.b++,p())}}t.$6g=B;class j{constructor(){this.a=new Map,this.b=new Set,this.d=void 0,this.f=0}async whenDrained(){if(this.g())return;const p=new Z;return this.b.add(p),p.p}g(){for(const[,p]of this.a)if(p.size>0)return!1;return!0}queueFor(p,A=w.$pg){const E=A.getComparisonKey(p);let I=this.a.get(E);if(!I){I=new O;const k=this.f++,L=i.Event.once(I.onDrained)(()=>{I?.dispose(),this.a.delete(E),this.h(),this.d?.deleteAndDispose(k),this.d?.size===0&&(this.d.dispose(),this.d=void 0)});this.d||(this.d=new U.$1c),this.d.set(k,L),this.a.set(E,I)}return I}h(){this.g()&&this.j()}j(){for(const p of this.b)p.complete();this.b.clear()}dispose(){for(const[,p]of this.a)p.dispose();this.a.clear(),this.j(),this.d?.dispose()}}t.$7g=j;class ie{constructor(p,A){this.a=-1,typeof p=="function"&&typeof A=="number"&&this.setIfNotSet(p,A)}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearTimeout(this.a),this.a=-1)}cancelAndSet(p,A){this.cancel(),this.a=setTimeout(()=>{this.a=-1,p()},A)}setIfNotSet(p,A){this.a===-1&&(this.a=setTimeout(()=>{this.a=-1,p()},A))}}t.$8g=ie;class te{constructor(){this.d=void 0}cancel(){this.d?.dispose(),this.d=void 0}cancelAndSet(p,A,E=globalThis){this.cancel();const I=E.setInterval(()=>{p()},A);this.d=(0,U.$Pc)(()=>{E.clearInterval(I),this.d=void 0})}dispose(){this.cancel()}}t.$9g=te;class ce{constructor(p,A){this.b=-1,this.a=p,this.d=A,this.f=this.g.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearTimeout(this.b),this.b=-1)}schedule(p=this.d){this.cancel(),this.b=setTimeout(this.f,p)}get delay(){return this.d}set delay(p){this.d=p}isScheduled(){return this.b!==-1}flush(){this.isScheduled()&&(this.cancel(),this.h())}g(){this.b=-1,this.a&&this.h()}h(){this.a?.()}}t.$0g=ce;class le{constructor(p,A){A%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${A}ms is not a multiple of 1000ms.`),this.a=p,this.b=A,this.d=0,this.f=-1,this.g=this.h.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearInterval(this.f),this.f=-1)}schedule(p=this.b){p%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${p}ms is not a multiple of 1000ms.`),this.cancel(),this.d=Math.ceil(p/1e3),this.f=setInterval(this.g,1e3)}isScheduled(){return this.f!==-1}h(){this.d--,!(this.d>0)&&(clearInterval(this.f),this.f=-1,this.a?.())}}t.$$g=le;class oe extends ce{constructor(p,A){super(p,A),this.j=[]}work(p){this.j.push(p),this.isScheduled()||this.schedule()}h(){const p=this.j;this.j=[],this.a?.(p)}dispose(){this.j=[],super.dispose()}}t.$_g=oe;class we extends U.$Rc{constructor(p,A){super(),this.g=p,this.h=A,this.a=[],this.b=this.B(new U.$Sc),this.f=!1}get pending(){return this.a.length}work(p){if(this.f)return!1;if(typeof this.g.maxBufferedWork=="number"){if(this.b.value){if(this.pending+p.length>this.g.maxBufferedWork)return!1}else if(this.pending+p.length-this.g.maxWorkChunkSize>this.g.maxBufferedWork)return!1}for(const A of p)this.a.push(A);return this.b.value||this.j(),!0}j(){this.h(this.a.splice(0,this.g.maxWorkChunkSize)),this.a.length>0&&(this.b.value=new ce(()=>{this.b.clear(),this.j()},this.g.throttleDelay),this.b.value.schedule())}dispose(){super.dispose(),this.f=!0}}t.$ah=we,function(){typeof globalThis.requestIdleCallback!="function"||typeof globalThis.cancelIdleCallback!="function"?t.$ch=(Q,p)=>{(0,D.$B)(()=>{if(A)return;const E=Date.now()+15;p(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,E-Date.now())}}))});let A=!1;return{dispose(){A||(A=!0)}}}:t.$ch=(Q,p,A)=>{const E=Q.requestIdleCallback(p,typeof A=="number"?{timeout:A}:void 0);let I=!1;return{dispose(){I||(I=!0,Q.cancelIdleCallback(E))}}},t.$bh=Q=>(0,t.$ch)(globalThis,Q)}();class Pe{constructor(p,A){this.g=!1,this.d=()=>{try{this.j=A()}catch(E){this.l=E}finally{this.g=!0}},this.f=(0,t.$ch)(p,()=>this.d())}dispose(){this.f.dispose()}get value(){if(this.g||(this.f.dispose(),this.d()),this.l)throw this.l;return this.j}get isInitialized(){return this.g}}t.$dh=Pe;class Ae extends Pe{constructor(p){super(globalThis,p)}}t.$eh=Ae;async function Re(Q,p,A){let E;for(let I=0;I<A;I++)try{return await Q()}catch(k){E=k,await R(p)}throw E}t.$fh=Re;class de{isRunning(p){return typeof p=="number"?this.a?.taskId===p:!!this.a}get running(){return this.a?.promise}cancelRunning(){this.a?.cancel()}run(p,A,E){return this.a={taskId:p,cancel:()=>E?.(),promise:A},A.then(()=>this.d(p),()=>this.d(p)),A}d(p){this.a&&p===this.a.taskId&&(this.a=void 0,this.f())}f(){if(this.b){const p=this.b;this.b=void 0,p.run().then(p.promiseResolve,p.promiseReject)}}queue(p){if(this.b)this.b.run=p;else{let A,E;const I=new Promise((k,L)=>{A=k,E=L});this.b={run:p,promise:I,promiseResolve:A,promiseReject:E}}return this.b.promise}hasQueued(){return!!this.b}async join(){return this.b?.promise??this.a?.promise}}t.$gh=de;class ne{constructor(p,A=()=>Date.now()){this.d=p,this.f=A,this.a=0,this.b=0}increment(){const p=this.f();return p-this.a>this.d&&(this.a=p,this.b=0),this.b++,this.b}}t.$hh=ne;var fe;(function(Q){Q[Q.Resolved=0]="Resolved",Q[Q.Rejected=1]="Rejected"})(fe||(fe={}));class Z{get isRejected(){return this.d?.outcome===1}get isResolved(){return this.d?.outcome===0}get isSettled(){return!!this.d}get value(){return this.d?.outcome===0?this.d?.value:void 0}constructor(){this.p=new Promise((p,A)=>{this.a=p,this.b=A})}complete(p){return new Promise(A=>{this.a(p),this.d={outcome:0,value:p},A()})}error(p){return new Promise(A=>{this.b(p),this.d={outcome:1,value:p},A()})}cancel(){return this.error(new N.$4)}}t.$ih=Z;var V;(function(Q){async function p(E){let I;const k=await Promise.all(E.map(L=>L.then(S=>S,S=>{I||(I=S)})));if(typeof I<"u")throw I;return k}Q.settled=p;function A(E){return new Promise(async(I,k)=>{try{await E(I,k)}catch(L){k(L)}})}Q.withAsyncBody=A})(V||(t.Promises=V={}));var Y;(function(Q){Q[Q.Initial=0]="Initial",Q[Q.DoneOK=1]="DoneOK",Q[Q.DoneError=2]="DoneError"})(Y||(Y={}));class C{static fromArray(p){return new C(A=>{A.emitMany(p)})}static fromPromise(p){return new C(async A=>{A.emitMany(await p)})}static fromPromises(p){return new C(async A=>{await Promise.all(p.map(async E=>A.emitOne(await E)))})}static merge(p){return new C(async A=>{await Promise.all(p.map(async E=>{for await(const I of E)A.emitOne(I)}))})}static{this.EMPTY=C.fromArray([])}constructor(p){this.a=0,this.b=[],this.d=null,this.f=new i.$Rd,queueMicrotask(async()=>{const A={emitOne:E=>this.g(E),emitMany:E=>this.h(E),reject:E=>this.k(E)};try{await Promise.resolve(p(A)),this.j()}catch(E){this.k(E)}finally{A.emitOne=void 0,A.emitMany=void 0,A.reject=void 0}})}[Symbol.asyncIterator](){let p=0;return{next:async()=>{do{if(this.a===2)throw this.d;if(p<this.b.length)return{done:!1,value:this.b[p++]};if(this.a===1)return{done:!0,value:void 0};await i.Event.toPromise(this.f.event)}while(!0)}}}static map(p,A){return new C(async E=>{for await(const I of p)E.emitOne(A(I))})}map(p){return C.map(this,p)}static filter(p,A){return new C(async E=>{for await(const I of p)A(I)&&E.emitOne(I)})}filter(p){return C.filter(this,p)}static coalesce(p){return C.filter(p,A=>!!A)}coalesce(){return C.coalesce(this)}static async toPromise(p){const A=[];for await(const E of p)A.push(E);return A}toPromise(){return C.toPromise(this)}g(p){this.a===0&&(this.b.push(p),this.f.fire())}h(p){this.a===0&&(this.b=this.b.concat(p),this.f.fire())}j(){this.a===0&&(this.a=1,this.f.fire())}k(p){this.a===0&&(this.a=2,this.d=p,this.f.fire())}}t.$jh=C;class q extends C{constructor(p,A){super(A),this.l=p}cancel(){this.l.cancel()}}t.$kh=q;function $(Q){const p=new v.$2d,A=Q(p.token);return new q(p,async E=>{const I=p.token.onCancellationRequested(()=>{I.dispose(),p.dispose(),E.reject(new N.$4)});try{for await(const k of A){if(p.token.isCancellationRequested)return;E.emitOne(k)}I.dispose(),p.dispose()}catch(k){I.dispose(),p.dispose(),E.reject(k)}})}t.$lh=$;class W{constructor(){this.a=new Z,this.b=new C(E=>{if(p){E.reject(p);return}return A&&E.emitMany(A),this.d=I=>E.reject(I),this.f=I=>E.emitOne(I),this.a.p});let p,A;this.f=E=>{A||(A=[]),A.push(E)},this.d=E=>{p||(p=E)}}get asyncIterable(){return this.b}resolve(){this.a.complete()}reject(p){this.d(p),this.a.complete()}emitOne(p){this.f(p)}}t.$mh=W}),define(be[3],pe([1,0,16,113,14,19,9,6,4,117,2,31,5,15,49,21]),function(ae,t,v,N,i,U,w,D,c,f,d,T,s,a,e,h){"use strict";var l;Object.defineProperty(t,"__esModule",{value:!0}),t.$vQ=t.$uQ=t.h=t.$sQ=t.$rQ=t.$qQ=t.$pQ=t.$oQ=t.$nQ=t.$mQ=t.$lQ=t.DetectedFullscreenMode=t.$kQ=t.$jQ=t.$iQ=t.$hQ=t.$gQ=t.$fQ=t.$eQ=t.$dQ=t.$cQ=t.$bQ=t.$aQ=t.$_P=t.$$P=t.$0P=t.$9P=t.$8P=t.$7P=t.$=t.Namespace=t.$5P=t.$4P=t.$3P=t.$2P=t.$1P=t.$ZP=t.$YP=t.$XP=t.$WP=t.$VP=t.$UP=t.$TP=t.$SP=t.$RP=t.$QP=t.$PP=t.$OP=t.$NP=t.$MP=t.$LP=t.$KP=t.$JP=t.$IP=t.$HP=t.$GP=t.$FP=t.$EP=t.$DP=t.$CP=t.$BP=t.$AP=t.$zP=t.$yP=t.$xP=t.$wP=t.$vP=t.$uP=t.$tP=t.$sP=t.$rP=t.$qP=t.$pP=t.$oP=t.$nP=t.$mP=t.$lP=t.$kP=t.$jP=t.$iP=t.$hP=t.$gP=t.$fP=t.$eP=t.$dP=t.$cP=t.$bP=t.$aP=t.$_O=t.$$O=t.$0O=t.$9O=t.$8O=t.$7O=t.$6O=t.$5O=t.$4O=t.$3O=t.$2O=t.onDidUnregisterWindow=t.onWillUnregisterWindow=t.onDidRegisterWindow=t.getWindowId=t.getWindowsCount=t.getWindows=t.registerWindow=void 0,l=function(){const K=new Map;(0,h.$uO)(h.$vO,1),K.set(h.$vO.vscodeWindowId,{window:h.$vO,disposables:new d.$Qc});const X=new c.$Rd,re=new c.$Rd,ge=new c.$Rd;return{onDidRegisterWindow:X.event,onWillUnregisterWindow:ge.event,onDidUnregisterWindow:re.event,registerWindow(ye){if(K.has(ye.vscodeWindowId))return d.$Rc.None;const Le=new d.$Qc,ze={window:ye,disposables:Le.add(new d.$Qc)};return K.set(ye.vscodeWindowId,ze),Le.add((0,d.$Pc)(()=>{K.delete(ye.vscodeWindowId),re.fire(ye)})),Le.add(r(ye,t.$VP.BEFORE_UNLOAD,()=>{ge.fire(ye)})),X.fire(ze),Le},getWindows(){return K.values()},getWindowsCount(){return K.size},getWindowId(ye){return ye.vscodeWindowId}}}(),t.registerWindow=l.registerWindow,t.getWindows=l.getWindows,t.getWindowsCount=l.getWindowsCount,t.getWindowId=l.getWindowId,t.onDidRegisterWindow=l.onDidRegisterWindow,t.onWillUnregisterWindow=l.onWillUnregisterWindow,t.onDidUnregisterWindow=l.onDidUnregisterWindow;function m(K){for(;K.firstChild;)K.firstChild.remove()}t.$2O=m;class n{constructor(X,re,ge,ye){this.f=X,this.g=re,this.d=ge,this.j=ye||!1,this.f.addEventListener(this.g,this.d,this.j)}dispose(){this.d&&(this.f.removeEventListener(this.g,this.d,this.j),this.f=null,this.d=null)}}function r(K,X,re,ge){return new n(K,X,re,ge)}t.$3O=r;function b(K,X){return function(re){return X(new U.$UO(K,re))}}function u(K){return function(X){return K(new i.$ZO(X))}}const o=function(X,re,ge,ye){let Le=ge;return re==="click"||re==="mousedown"?Le=b(Te(X),ge):(re==="keydown"||re==="keypress"||re==="keyup")&&(Le=u(ge)),r(X,re,Le,ye)};t.$4O=o;const F=function(X,re,ge){const ye=b(Te(X),re);return R(X,ye,ge)};t.$5O=F;const z=function(X,re,ge){const ye=b(Te(X),re);return y(X,ye,ge)};t.$6O=z;function R(K,X,re){return r(K,s.$r&&N.$RO.pointerEvents?t.$VP.POINTER_DOWN:t.$VP.MOUSE_DOWN,X,re)}t.$7O=R;function g(K,X,re){return r(K,s.$r&&N.$RO.pointerEvents?t.$VP.POINTER_MOVE:t.$VP.MOUSE_MOVE,X,re)}t.$8O=g;function y(K,X,re){return r(K,s.$r&&N.$RO.pointerEvents?t.$VP.POINTER_UP:t.$VP.MOUSE_UP,X,re)}t.$9O=y;function M(K,X,re){return(0,w.$ch)(K,X,re)}t.$0O=M;class _ extends w.$dh{constructor(X,re){super(X,re)}}t.$$O=_;function x(K,X,re,ge){let ye=0;const Le=K.setInterval(()=>{ye++,(typeof ge=="number"&&ye>=ge||X()===!0)&&ze.dispose()},re),ze=(0,d.$Pc)(()=>{K.clearInterval(Le)});return ze}t.$bP=x;class O extends w.$9g{cancelAndSet(X,re,ge){return super.cancelAndSet(X,re,ge)}}t.$cP=O;class B{constructor(X,re=0){this.d=X,this.priority=re,this.f=!1}dispose(){this.f=!0}execute(){if(!this.f)try{this.d()}catch(X){(0,D.$Z)(X)}}static sort(X,re){return re.priority-X.priority}}(function(){const K=new Map,X=new Map,re=new Map,ge=new Map,ye=Le=>{re.set(Le,!1);const ze=K.get(Le)??[];for(X.set(Le,ze),K.set(Le,[]),ge.set(Le,!0);ze.length>0;)ze.sort(B.sort),ze.shift().execute();ge.set(Le,!1)};t.$aP=(Le,ze,xe=0)=>{const Ge=(0,t.getWindowId)(Le),_e=new B(ze,xe);let rt=K.get(Ge);return rt||(rt=[],K.set(Ge,rt)),rt.push(_e),re.get(Ge)||(re.set(Ge,!0),Le.requestAnimationFrame(()=>ye(Ge))),_e},t.$_O=(Le,ze,xe)=>{const Ge=(0,t.getWindowId)(Le);if(ge.get(Ge)){const _e=new B(ze,xe);let rt=X.get(Ge);return rt||(rt=[],X.set(Ge,rt)),rt.push(_e),_e}else return(0,t.$aP)(Le,ze,xe)}})();function j(K,X){return(0,t.$aP)(K,X,1e4)}t.$dP=j;function ie(K,X){return(0,t.$aP)(K,X,-1e4)}t.$eP=ie;const te=8,ce=function(K,X){return X};class le extends d.$Rc{constructor(X,re,ge,ye=ce,Le=te){super();let ze=null,xe=0;const Ge=this.B(new w.$8g),_e=()=>{xe=new Date().getTime(),ge(ze),ze=null};this.B(r(X,re,rt=>{ze=ye(ze,rt);const Pt=new Date().getTime()-xe;Pt>=Le?(Ge.cancel(),_e()):Ge.setIfNotSet(_e,Le-Pt)}))}}function oe(K,X,re,ge,ye){return new le(K,X,re,ge,ye)}t.$fP=oe;function we(K){return K.ownerDocument.defaultView.getComputedStyle(K,null)}t.$gP=we;function Pe(K){const X=K.ownerDocument,re=X.defaultView?.window;if(K!==X.body)return new Re(K.clientWidth,K.clientHeight);if(s.$r&&re?.visualViewport)return new Re(re.visualViewport.width,re.visualViewport.height);if(re?.innerWidth&&re.innerHeight)return new Re(re.innerWidth,re.innerHeight);if(X.body&&X.body.clientWidth&&X.body.clientHeight)return new Re(X.body.clientWidth,X.body.clientHeight);if(X.documentElement&&X.documentElement.clientWidth&&X.documentElement.clientHeight)return new Re(X.documentElement.clientWidth,X.documentElement.clientHeight);throw new Error("Unable to figure out browser width and height")}t.$hP=Pe;class Ae{static d(X,re){return parseFloat(re)||0}static f(X,re,ge){const ye=we(X),Le=ye?ye.getPropertyValue(re):"0";return Ae.d(X,Le)}static getBorderLeftWidth(X){return Ae.f(X,"border-left-width","borderLeftWidth")}static getBorderRightWidth(X){return Ae.f(X,"border-right-width","borderRightWidth")}static getBorderTopWidth(X){return Ae.f(X,"border-top-width","borderTopWidth")}static getBorderBottomWidth(X){return Ae.f(X,"border-bottom-width","borderBottomWidth")}static getPaddingLeft(X){return Ae.f(X,"padding-left","paddingLeft")}static getPaddingRight(X){return Ae.f(X,"padding-right","paddingRight")}static getPaddingTop(X){return Ae.f(X,"padding-top","paddingTop")}static getPaddingBottom(X){return Ae.f(X,"padding-bottom","paddingBottom")}static getMarginLeft(X){return Ae.f(X,"margin-left","marginLeft")}static getMarginTop(X){return Ae.f(X,"margin-top","marginTop")}static getMarginRight(X){return Ae.f(X,"margin-right","marginRight")}static getMarginBottom(X){return Ae.f(X,"margin-bottom","marginBottom")}}class Re{static{this.None=new Re(0,0)}constructor(X,re){this.width=X,this.height=re}with(X=this.width,re=this.height){return X!==this.width||re!==this.height?new Re(X,re):this}static is(X){return typeof X=="object"&&typeof X.height=="number"&&typeof X.width=="number"}static lift(X){return X instanceof Re?X:new Re(X.width,X.height)}static equals(X,re){return X===re?!0:!X||!re?!1:X.width===re.width&&X.height===re.height}}t.$iP=Re;function de(K){let X=K.offsetParent,re=K.offsetTop,ge=K.offsetLeft;for(;(K=K.parentNode)!==null&&K!==K.ownerDocument.body&&K!==K.ownerDocument.documentElement;){re-=K.scrollTop;const ye=H(K)?null:we(K);ye&&(ge-=ye.direction!=="rtl"?K.scrollLeft:-K.scrollLeft),K===X&&(ge+=Ae.getBorderLeftWidth(K),re+=Ae.getBorderTopWidth(K),re+=K.offsetTop,ge+=K.offsetLeft,X=K.offsetParent)}return{left:ge,top:re}}t.$jP=de;function ne(K,X,re){typeof X=="number"&&(K.style.width=`${X}px`),typeof re=="number"&&(K.style.height=`${re}px`)}t.$kP=ne;function fe(K,X,re,ge,ye,Le="absolute"){typeof X=="number"&&(K.style.top=`${X}px`),typeof re=="number"&&(K.style.right=`${re}px`),typeof ge=="number"&&(K.style.bottom=`${ge}px`),typeof ye=="number"&&(K.style.left=`${ye}px`),K.style.position=Le}t.$lP=fe;function Z(K){const X=K.getBoundingClientRect();return{left:X.left+(K.ownerDocument.defaultView?.scrollX??0),top:X.top+(K.ownerDocument.defaultView?.scrollY??0),width:X.width,height:X.height}}t.$mP=Z;function V(K){let X=K,re=1;do{const ge=we(X).zoom;ge!=null&&ge!=="1"&&(re*=ge),X=X.parentElement}while(X!==null&&X!==X.ownerDocument.documentElement);return re}t.$nP=V;function Y(K){const X=Ae.getMarginLeft(K)+Ae.getMarginRight(K);return K.offsetWidth+X}t.$oP=Y;function C(K){const X=Ae.getBorderLeftWidth(K)+Ae.getBorderRightWidth(K),re=Ae.getPaddingLeft(K)+Ae.getPaddingRight(K);return K.offsetWidth-X-re}t.$pP=C;function q(K){const X=Ae.getMarginLeft(K)+Ae.getMarginRight(K);return K.scrollWidth+X}t.$qP=q;function $(K){const X=Ae.getBorderTopWidth(K)+Ae.getBorderBottomWidth(K),re=Ae.getPaddingTop(K)+Ae.getPaddingBottom(K);return K.offsetHeight-X-re}t.$rP=$;function W(K){const X=Ae.getMarginTop(K)+Ae.getMarginBottom(K);return K.offsetHeight+X}t.$sP=W;function Q(K,X){if(K===null)return 0;const re=de(K),ge=de(X);return re.left-ge.left}function p(K,X){const re=X.map(ye=>Math.max(q(ye),Y(ye))+Q(ye,K)||0);return Math.max(...re)}t.$tP=p;function A(K,X){return!!X?.contains(K)}t.$uP=A;const E="parentFlowToElementId";function I(K,X){K.dataset[E]=X.id}t.$vP=I;function k(K){const X=K.dataset[E];return typeof X=="string"?K.ownerDocument.getElementById(X):null}function L(K,X){let re=K;for(;re;){if(re===X)return!0;if(re instanceof HTMLElement){const ge=k(re);if(ge){re=ge;continue}}re=re.parentNode}return!1}t.$wP=L;function S(K,X,re){for(;K&&K.nodeType===K.ELEMENT_NODE;){if(K.classList.contains(X))return K;if(re){if(typeof re=="string"){if(K.classList.contains(re))return null}else if(K===re)return null}K=K.parentNode}return null}t.$xP=S;function P(K,X,re){return!!S(K,X,re)}t.$yP=P;function H(K){return K&&!!K.host&&!!K.mode}t.$zP=H;function G(K){return!!ee(K)}t.$AP=G;function ee(K){for(;K.parentNode;){if(K===K.ownerDocument?.body)return null;K=K.parentNode}return H(K)?K:null}t.$BP=ee;function se(){let K=Ce().activeElement;for(;K?.shadowRoot;)K=K.shadowRoot.activeElement;return K}t.$CP=se;function me(K){return K.ownerDocument.activeElement===K}t.$DP=me;function ve(K){return A(K.ownerDocument.activeElement,K)}t.$EP=ve;function Fe(K){return K.ownerDocument===Ce()}t.$FP=Fe;function Ce(){return(0,t.getWindowsCount)()<=1?document:Array.from((0,t.getWindows)()).map(({window:X})=>X.document).find(X=>X.hasFocus())??document}t.$GP=Ce;function De(){return Ce().defaultView?.window??h.$vO}t.$HP=De;function Te(K){const X=K;if(X?.ownerDocument?.defaultView)return X.ownerDocument.defaultView.window;const re=K;return re?.view?re.view.window:h.$vO}t.$IP=Te;function Oe(K){const X=Te(K);X!==De()&&X.focus()}t.$JP=Oe;const We=new Map;function He(K){return We.has(K)}t.$KP=He;function Me(K=h.$vO.document.head,X,re){const ge=document.createElement("style");if(ge.type="text/css",ge.media="screen",X?.(ge),K.appendChild(ge),re&&re.add((0,d.$Pc)(()=>K.removeChild(ge))),K===h.$vO.document.head){const ye=new Set;We.set(ge,ye);for(const{window:Le,disposables:ze}of(0,t.getWindows)()){if(Le===h.$vO)continue;const xe=ze.add(J(ge,ye,Le));re?.add(xe)}}return ge}t.$LP=Me;function Ye(K){const X=new d.$Qc;for(const[re,ge]of We)X.add(J(re,ge,K));return X}t.$MP=Ye;function J(K,X,re){const ge=new d.$Qc,ye=K.cloneNode(!0);re.document.head.appendChild(ye),ge.add((0,d.$Pc)(()=>re.document.head.removeChild(ye)));for(const Le of Se(K))ye.sheet?.insertRule(Le.cssText,ye.sheet?.cssRules.length);return ge.add(t.$NP.observe(K,ge,{childList:!0})(()=>{ye.textContent=K.textContent})),X.add(ye),ge.add((0,d.$Pc)(()=>X.delete(ye))),ge}t.$NP=new class{constructor(){this.mutationObservers=new Map}observe(K,X,re){let ge=this.mutationObservers.get(K);ge||(ge=new Map,this.mutationObservers.set(K,ge));const ye=(0,e.$Ji)(re);let Le=ge.get(ye);if(Le)Le.users+=1;else{const ze=new c.$Rd,xe=new MutationObserver(_e=>ze.fire(_e));xe.observe(K,re);const Ge=Le={users:1,observer:xe,onDidMutate:ze.event};X.add((0,d.$Pc)(()=>{Ge.users-=1,Ge.users===0&&(ze.dispose(),xe.disconnect(),ge?.delete(ye),ge?.size===0&&this.mutationObservers.delete(K))})),ge.set(ye,Le)}return Le.onDidMutate}};function he(K=h.$vO.document.head){const X=document.createElement("meta");return K.appendChild(X),X}t.$OP=he;let $e=null;function Ee(){return $e||($e=Me()),$e}function Se(K){return K?.sheet?.rules?K.sheet.rules:K?.sheet?.cssRules?K.sheet.cssRules:[]}function Be(K,X,re=Ee()){if(!(!re||!X)){re.sheet?.insertRule(`${K} {${X}}`,0);for(const ge of We.get(re)??[])Be(K,X,ge)}}t.$PP=Be;function Ue(K,X=Ee()){if(!X)return;const re=Se(X),ge=[];for(let ye=0;ye<re.length;ye++){const Le=re[ye];Ze(Le)&&Le.selectorText.indexOf(K)!==-1&&ge.push(ye)}for(let ye=ge.length-1;ye>=0;ye--)X.sheet?.deleteRule(ge[ye]);for(const ye of We.get(X)??[])Ue(K,ye)}t.$QP=Ue;function Ze(K){return typeof K.selectorText=="string"}function Je(K){return K instanceof MouseEvent||K instanceof Te(K).MouseEvent}t.$RP=Je;function Qe(K){return K instanceof KeyboardEvent||K instanceof Te(K).KeyboardEvent}t.$SP=Qe;function qe(K){return K instanceof PointerEvent||K instanceof Te(K).PointerEvent}t.$TP=qe;function tt(K){return K instanceof DragEvent||K instanceof Te(K).DragEvent}t.$UP=tt,t.$VP={CLICK:"click",AUXCLICK:"auxclick",DBLCLICK:"dblclick",MOUSE_UP:"mouseup",MOUSE_DOWN:"mousedown",MOUSE_OVER:"mouseover",MOUSE_MOVE:"mousemove",MOUSE_OUT:"mouseout",MOUSE_ENTER:"mouseenter",MOUSE_LEAVE:"mouseleave",MOUSE_WHEEL:"wheel",POINTER_UP:"pointerup",POINTER_DOWN:"pointerdown",POINTER_MOVE:"pointermove",POINTER_LEAVE:"pointerleave",CONTEXT_MENU:"contextmenu",WHEEL:"wheel",KEY_DOWN:"keydown",KEY_PRESS:"keypress",KEY_UP:"keyup",LOAD:"load",BEFORE_UNLOAD:"beforeunload",UNLOAD:"unload",PAGE_SHOW:"pageshow",PAGE_HIDE:"pagehide",PASTE:"paste",ABORT:"abort",ERROR:"error",RESIZE:"resize",SCROLL:"scroll",FULLSCREEN_CHANGE:"fullscreenchange",WK_FULLSCREEN_CHANGE:"webkitfullscreenchange",SELECT:"select",CHANGE:"change",SUBMIT:"submit",RESET:"reset",FOCUS:"focus",FOCUS_IN:"focusin",FOCUS_OUT:"focusout",BLUR:"blur",INPUT:"input",STORAGE:"storage",DRAG_START:"dragstart",DRAG:"drag",DRAG_ENTER:"dragenter",DRAG_LEAVE:"dragleave",DRAG_OVER:"dragover",DROP:"drop",DRAG_END:"dragend",ANIMATION_START:v.$JO?"webkitAnimationStart":"animationstart",ANIMATION_END:v.$JO?"webkitAnimationEnd":"animationend",ANIMATION_ITERATION:v.$JO?"webkitAnimationIteration":"animationiteration"};function nt(K){const X=K;return!!(X&&typeof X.preventDefault=="function"&&typeof X.stopPropagation=="function")}t.$WP=nt,t.$XP={stop:(K,X)=>(K.preventDefault(),X&&K.stopPropagation(),K)};function dt(K){const X=[];for(let re=0;K&&K.nodeType===K.ELEMENT_NODE;re++)X[re]=K.scrollTop,K=K.parentNode;return X}t.$YP=dt;function ft(K,X){for(let re=0;K&&K.nodeType===K.ELEMENT_NODE;re++)K.scrollTop!==X[re]&&(K.scrollTop=X[re]),K=K.parentNode}t.$ZP=ft;class ot extends d.$Rc{static m(X){if(X instanceof HTMLElement){const re=ee(X),ge=re?re.activeElement:X.ownerDocument.activeElement;return A(ge,X)}else{const re=X;return A(re.document.activeElement,re.document)}}constructor(X){super(),this.f=this.B(new c.$Rd),this.onDidFocus=this.f.event,this.g=this.B(new c.$Rd),this.onDidBlur=this.g.event;let re=ot.m(X),ge=!1;const ye=()=>{ge=!1,re||(re=!0,this.f.fire())},Le=()=>{re&&(ge=!0,(X instanceof HTMLElement?Te(X):X).setTimeout(()=>{ge&&(ge=!1,re=!1,this.g.fire())},0))};this.j=()=>{ot.m(X)!==re&&(re?Le():ye())},this.B(r(X,t.$VP.FOCUS,ye,!0)),this.B(r(X,t.$VP.BLUR,Le,!0)),X instanceof HTMLElement&&(this.B(r(X,t.$VP.FOCUS_IN,()=>this.j())),this.B(r(X,t.$VP.FOCUS_OUT,()=>this.j())))}refreshState(){this.j()}}function At(K){return new ot(K)}t.$1P=At;function kt(K,X){return K.after(X),X}t.$2P=kt;function pt(K,...X){if(K.append(...X),X.length===1&&typeof X[0]!="string")return X[0]}t.$3P=pt;function Ct(K,X){return K.insertBefore(X,K.firstChild),X}t.$4P=Ct;function Mt(K,...X){K.innerText="",pt(K,...X)}t.$5P=Mt;const Ie=/([\w\-]+)?(#([\w\-]+))?((\.([\w\-]+))*)/;var ue;(function(K){K.HTML="http://www.w3.org/1999/xhtml",K.SVG="http://www.w3.org/2000/svg"})(ue||(t.Namespace=ue={}));function ke(K,X,re,...ge){const ye=Ie.exec(X);if(!ye)throw new Error("Bad use of emmet");const Le=ye[1]||"div";let ze;return K!==ue.HTML?ze=document.createElementNS(K,Le):ze=document.createElement(Le),ye[3]&&(ze.id=ye[3]),ye[4]&&(ze.className=ye[4].replace(/\./g," ").trim()),re&&Object.entries(re).forEach(([xe,Ge])=>{typeof Ge>"u"||(/^on\w+$/.test(xe)?ze[xe]=Ge:xe==="selected"?Ge&&ze.setAttribute(xe,"true"):ze.setAttribute(xe,Ge))}),ze.append(...ge),ze}function Ne(K,X,...re){return ke(ue.HTML,K,X,...re)}t.$=Ne,Ne.SVG=function(K,X,...re){return ke(ue.SVG,K,X,...re)};function Ve(K,X){const re=[];return K.forEach((ge,ye)=>{ye>0&&(X instanceof Node?re.push(X.cloneNode()):re.push(document.createTextNode(X))),re.push(ge)}),re}t.$7P=Ve;function et(K,...X){K?st(...X):Ke(...X)}t.$8P=et;function st(...K){for(const X of K)X.style.display="",X.removeAttribute("aria-hidden")}t.$9P=st;function Ke(...K){for(const X of K)X.style.display="none",X.setAttribute("aria-hidden","true")}t.$0P=Ke;function ht(K,X){for(;K&&K.nodeType===K.ELEMENT_NODE;){if(K instanceof HTMLElement&&K.hasAttribute(X))return K;K=K.parentNode}return null}function wt(K){!K||!K.hasAttribute("tabIndex")||(K.ownerDocument.activeElement===K&&ht(K.parentElement,"tabIndex")?.focus(),K.removeAttribute("tabindex"))}t.$$P=wt;function St(K){return X=>{X.preventDefault(),X.stopPropagation(),K(X)}}t.$_P=St;function Gt(K){return new Promise(X=>{if(K.document.readyState==="complete"||K.document&&K.document.body!==null)X(void 0);else{const ge=()=>{K.window.removeEventListener("DOMContentLoaded",ge,!1),X()};K.window.addEventListener("DOMContentLoaded",ge,!1)}})}t.$aQ=Gt;function Ai(K,X){const re=K.devicePixelRatio*X;return Math.max(1,Math.floor(re))/K.devicePixelRatio}t.$bQ=Ai;function ki(K){h.$vO.open(K,"_blank","noopener")}t.$cQ=ki;const Xt=780,Yt=640;function Ci(K){const X=Math.floor(h.$vO.screenLeft+h.$vO.innerWidth/2-Xt/2),re=Math.floor(h.$vO.screenTop+h.$vO.innerHeight/2-Yt/2);h.$vO.open(K,"_blank",`width=${Xt},height=${Yt},top=${re},left=${X}`)}t.$dQ=Ci;function Si(K,X=!0){const re=h.$vO.open();return re?(X&&(re.opener=null),re.location.href=K,!0):!1}t.$eQ=Si;function Pi(K,X){const re=()=>{X(),ge=(0,t.$aP)(K,re)};let ge=(0,t.$aP)(K,re);return(0,d.$Pc)(()=>ge.dispose())}t.$fQ=Pi,T.$ag.setPreferredWebSchema(/^https:/.test(h.$vO.location.href)?"https":"http");function Fi(K){return K?`url('${T.$gg.uriToBrowserUri(K).toString(!0).replace(/'/g,"%27")}')`:"url('')"}t.$gQ=Fi;function Ni(K){return`'${K.replace(/'/g,"%27")}'`}t.$hQ=Ni;function Zt(K,X){if(K!==void 0){const re=K.match(/^\s*var\((.+)\)$/);if(re){const ge=re[1].split(",",2);return ge.length===2&&(X=Zt(ge[1].trim(),X)),`var(${ge[0]}, ${X})`}return K}return X}t.$iQ=Zt;function Oi(K,X){let re;if(a.URI.isUri(K))re=K.toString(!0);else{const Le=new Blob([K]);re=URL.createObjectURL(Le),setTimeout(()=>URL.revokeObjectURL(re))}const ge=De(),ye=document.createElement("a");ge.document.body.appendChild(ye),ye.download=X,ye.href=re,ye.click(),setTimeout(()=>ge.document.body.removeChild(ye))}t.$jQ=Oi;function Ri(){return new Promise(K=>{const X=De(),re=document.createElement("input");X.document.body.appendChild(re),re.type="file",re.multiple=!0,c.Event.once(c.Event.fromDOMEventEmitter(re,"input"))(()=>{K(re.files??void 0)}),re.click(),setTimeout(()=>X.document.body.removeChild(re))})}t.$kQ=Ri;var vt;(function(K){K[K.DOCUMENT=1]="DOCUMENT",K[K.BROWSER=2]="BROWSER"})(vt||(t.DetectedFullscreenMode=vt={}));function Ti(K){return K.document.fullscreenElement||K.document.webkitFullscreenElement||K.document.webkitIsFullScreen?{mode:vt.DOCUMENT,guess:!1}:K.innerHeight===K.screen.height?{mode:vt.BROWSER,guess:!1}:(s.$j||s.$k)&&K.outerHeight===K.screen.height&&K.outerWidth===K.screen.width?{mode:vt.BROWSER,guess:!0}:null}t.$lQ=Ti;function Jt(K,X=!1){const re=document.createElement("a");return f.addHook("afterSanitizeAttributes",ge=>{for(const ye of["href","src"])if(ge.hasAttribute(ye)){const Le=ge.getAttribute(ye);if(ye==="href"&&Le.startsWith("#"))continue;if(re.href=Le,!K.includes(re.protocol.replace(/:$/,""))){if(X&&ye==="src"&&re.href.startsWith("data:"))continue;ge.removeAttribute(ye)}}}),(0,d.$Pc)(()=>{f.removeHook("afterSanitizeAttributes")})}t.$mQ=Jt;const Li=[T.Schemas.http,T.Schemas.https,T.Schemas.command];t.$nQ=Object.freeze(["a","abbr","b","bdo","blockquote","br","caption","cite","code","col","colgroup","dd","del","details","dfn","div","dl","dt","em","figcaption","figure","h1","h2","h3","h4","h5","h6","hr","i","img","ins","kbd","label","li","mark","ol","p","pre","q","rp","rt","ruby","samp","small","small","source","span","strike","strong","sub","summary","sup","table","tbody","td","tfoot","th","thead","time","tr","tt","u","ul","var","video","wbr"]);const Ii=Object.freeze({ALLOWED_TAGS:["a","button","blockquote","code","div","h1","h2","h3","h4","h5","h6","hr","input","label","li","p","pre","select","small","span","strong","textarea","ul","ol"],ALLOWED_ATTR:["href","data-href","data-command","target","title","name","src","alt","class","id","role","tabindex","style","data-code","width","height","align","x-dispatch","required","checked","placeholder","type","start"],RETURN_DOM:!1,RETURN_DOM_FRAGMENT:!1,RETURN_TRUSTED_TYPE:!0});function Mi(K,X){const re=Jt(Li);try{const ge=f.sanitize(X,Ii);K.innerHTML=ge}finally{re.dispose()}}t.$oQ=Mi;function Bi(K){const X=new Uint16Array(K.length);for(let ye=0;ye<X.length;ye++)X[ye]=K.charCodeAt(ye);let re="";const ge=new Uint8Array(X.buffer);for(let ye=0;ye<ge.length;ye++)re+=String.fromCharCode(ge[ye]);return re}function zi(K){return btoa(Bi(K))}t.$pQ=zi;class mt extends c.$Rd{constructor(){super(),this.o=new d.$Qc,this.s={altKey:!1,shiftKey:!1,ctrlKey:!1,metaKey:!1},this.o.add(c.Event.runAndSubscribe(t.onDidRegisterWindow,({window:X,disposables:re})=>this.B(X,re),{window:h.$vO,disposables:this.o}))}B(X,re){re.add(r(X,"keydown",ge=>{if(ge.defaultPrevented)return;const ye=new i.$ZO(ge);if(!(ye.keyCode===6&&ge.repeat)){if(ge.altKey&&!this.s.altKey)this.s.lastKeyPressed="alt";else if(ge.ctrlKey&&!this.s.ctrlKey)this.s.lastKeyPressed="ctrl";else if(ge.metaKey&&!this.s.metaKey)this.s.lastKeyPressed="meta";else if(ge.shiftKey&&!this.s.shiftKey)this.s.lastKeyPressed="shift";else if(ye.keyCode!==6)this.s.lastKeyPressed=void 0;else return;this.s.altKey=ge.altKey,this.s.ctrlKey=ge.ctrlKey,this.s.metaKey=ge.metaKey,this.s.shiftKey=ge.shiftKey,this.s.lastKeyPressed&&(this.s.event=ge,this.fire(this.s))}},!0)),re.add(r(X,"keyup",ge=>{ge.defaultPrevented||(!ge.altKey&&this.s.altKey?this.s.lastKeyReleased="alt":!ge.ctrlKey&&this.s.ctrlKey?this.s.lastKeyReleased="ctrl":!ge.metaKey&&this.s.metaKey?this.s.lastKeyReleased="meta":!ge.shiftKey&&this.s.shiftKey?this.s.lastKeyReleased="shift":this.s.lastKeyReleased=void 0,this.s.lastKeyPressed!==this.s.lastKeyReleased&&(this.s.lastKeyPressed=void 0),this.s.altKey=ge.altKey,this.s.ctrlKey=ge.ctrlKey,this.s.metaKey=ge.metaKey,this.s.shiftKey=ge.shiftKey,this.s.lastKeyReleased&&(this.s.event=ge,this.fire(this.s)))},!0)),re.add(r(X.document.body,"mousedown",()=>{this.s.lastKeyPressed=void 0},!0)),re.add(r(X.document.body,"mouseup",()=>{this.s.lastKeyPressed=void 0},!0)),re.add(r(X.document.body,"mousemove",ge=>{ge.buttons&&(this.s.lastKeyPressed=void 0)},!0)),re.add(r(X,"blur",()=>{this.resetKeyStatus()}))}get keyStatus(){return this.s}get isModifierPressed(){return this.s.altKey||this.s.ctrlKey||this.s.metaKey||this.s.shiftKey}resetKeyStatus(){this.C(),this.fire(this.s)}C(){this.s={altKey:!1,shiftKey:!1,ctrlKey:!1,metaKey:!1}}static getInstance(){return mt.A||(mt.A=new mt),mt.A}dispose(){super.dispose(),this.o.dispose()}}t.$qQ=mt;function ji(K){const X=document.cookie.match("(^|[^;]+)\\s*"+K+"\\s*=\\s*([^;]+)");return X?X.pop():void 0}t.$rQ=ji;class Hi extends d.$Rc{constructor(X,re){super(),this.j=X,this.m=re,this.f=0,this.g=0,this.n()}n(){this.m.onDragStart&&this.B(r(this.j,t.$VP.DRAG_START,X=>{this.m.onDragStart?.(X)})),this.m.onDrag&&this.B(r(this.j,t.$VP.DRAG,X=>{this.m.onDrag?.(X)})),this.B(r(this.j,t.$VP.DRAG_ENTER,X=>{this.f++,this.g=X.timeStamp,this.m.onDragEnter?.(X)})),this.B(r(this.j,t.$VP.DRAG_OVER,X=>{X.preventDefault(),this.m.onDragOver?.(X,X.timeStamp-this.g)})),this.B(r(this.j,t.$VP.DRAG_LEAVE,X=>{this.f--,this.f===0&&(this.g=0,this.m.onDragLeave?.(X))})),this.B(r(this.j,t.$VP.DRAG_END,X=>{this.f=0,this.g=0,this.m.onDragEnd?.(X)})),this.B(r(this.j,t.$VP.DROP,X=>{this.f=0,this.g=0,this.m.onDrop?.(X)}))}}t.$sQ=Hi;const Ui=/(?<tag>[\w\-]+)?(?:#(?<id>[\w\-]+))?(?<class>(?:\.(?:[\w\-]+))*)(?:@(?<name>(?:[\w\_])+))?/;function Wi(K,...X){let re,ge;Array.isArray(X[0])?(re={},ge=X[0]):(re=X[0]||{},ge=X[1]);const ye=Ui.exec(K);if(!ye||!ye.groups)throw new Error("Bad use of h");const Le=ye.groups.tag||"div",ze=document.createElement(Le);ye.groups.id&&(ze.id=ye.groups.id);const xe=[];if(ye.groups.class)for(const _e of ye.groups.class.split("."))_e!==""&&xe.push(_e);if(re.className!==void 0)for(const _e of re.className.split("."))_e!==""&&xe.push(_e);xe.length>0&&(ze.className=xe.join(" "));const Ge={};if(ye.groups.name&&(Ge[ye.groups.name]=ze),ge)for(const _e of ge)_e instanceof HTMLElement?ze.appendChild(_e):typeof _e=="string"?ze.append(_e):"root"in _e&&(Object.assign(Ge,_e),ze.appendChild(_e.root));for(const[_e,rt]of Object.entries(re))if(_e!=="className")if(_e==="style")for(const[Pt,Bt]of Object.entries(rt))ze.style.setProperty(ei(Pt),typeof Bt=="number"?Bt+"px":""+Bt);else _e==="tabIndex"?ze.tabIndex=rt:ze.setAttribute(ei(_e),rt.toString());return Ge.root=ze,Ge}t.h=Wi;function ei(K){return K.replace(/([a-z])([A-Z])/g,"$1-$2").toLowerCase()}function ti(K,X){for(const{name:re,value:ge}of K.attributes)X.setAttribute(re,ge)}t.$uQ=ti;function Vi(K,X,re){const ge=K.getAttribute(re);ge?X.setAttribute(re,ge):X.removeAttribute(re)}function qi(K,X,re){ti(K,X);const ge=new d.$Qc;return ge.add(t.$NP.observe(K,ge,{attributes:!0,attributeFilter:re})(ye=>{for(const Le of ye)Le.type==="attributes"&&Le.attributeName&&Vi(K,X,Le.attributeName)})),ge}t.$vQ=qi}),define(be[54],pe([1,0,3,2,116]),function(ae,t,v,N,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$yQ=t.$xQ=t.$wQ=void 0;class U extends N.$Rc{constructor(c,f){super(),this.B((0,v.$3O)(c,"dragover",d=>{d.preventDefault(),this.a||(this.a=setTimeout(()=>{f(),this.a=null},800))})),["dragleave","drop","dragend"].forEach(d=>{this.B((0,v.$3O)(c,d,()=>{this.b()}))})}b(){this.a&&(clearTimeout(this.a),this.a=null)}dispose(){super.dispose(),this.b()}}t.$wQ=U,t.$xQ={RESOURCES:"ResourceURLs",DOWNLOAD_URL:"DownloadURL",FILES:"Files",TEXT:i.$Vr.text,INTERNAL_URI_LIST:"application/vnd.code.uri-list"};function w(D,c,f,d,T){const s=document.createElement("div");if(s.className=f,s.textContent=c,T&&(s.style.color=T),d&&(s.style.background=d),D.dataTransfer){const a=(0,v.$IP)(D).document;a.body.appendChild(s),D.dataTransfer.setDragImage(s,-10,-10),setTimeout(()=>a.body.removeChild(s),0)}}t.$yQ=w}),define(be[55],pe([1,0,3]),function(ae,t,v){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$3Q=t.$2Q=t.$1Q=void 0;function N(s,a={}){const e=U(a);return e.textContent=s,e}t.$1Q=N;function i(s,a={}){const e=U(a);return c(e,f(s,!!a.renderCodeSegments),a.actionHandler,a.renderCodeSegments),e}t.$2Q=i;function U(s){const a=s.inline?"span":"div",e=document.createElement(a);return s.className&&(e.className=s.className),e}t.$3Q=U;class w{constructor(a){this.b=a,this.c=0}eos(){return this.c>=this.b.length}next(){const a=this.peek();return this.advance(),a}peek(){return this.b[this.c]}advance(){this.c++}}var D;(function(s){s[s.Invalid=0]="Invalid",s[s.Root=1]="Root",s[s.Text=2]="Text",s[s.Bold=3]="Bold",s[s.Italics=4]="Italics",s[s.Action=5]="Action",s[s.ActionClose=6]="ActionClose",s[s.Code=7]="Code",s[s.NewLine=8]="NewLine"})(D||(D={}));function c(s,a,e,h){let l;if(a.type===2)l=document.createTextNode(a.content||"");else if(a.type===3)l=document.createElement("b");else if(a.type===4)l=document.createElement("i");else if(a.type===7&&h)l=document.createElement("code");else if(a.type===5&&e){const m=document.createElement("a");e.disposables.add(v.$4O(m,"click",n=>{e.callback(String(a.index),n)})),l=m}else a.type===8?l=document.createElement("br"):a.type===1&&(l=s);l&&s!==l&&s.appendChild(l),l&&Array.isArray(a.children)&&a.children.forEach(m=>{c(l,m,e,h)})}function f(s,a){const e={type:1,children:[]};let h=0,l=e;const m=[],n=new w(s);for(;!n.eos();){let r=n.next();const b=r==="\\"&&T(n.peek(),a)!==0;if(b&&(r=n.next()),!b&&d(r,a)&&r===n.peek()){n.advance(),l.type===2&&(l=m.pop());const u=T(r,a);if(l.type===u||l.type===5&&u===6)l=m.pop();else{const o={type:u,children:[]};u===5&&(o.index=h,h++),l.children.push(o),m.push(l),l=o}}else if(r===`
`)l.type===2&&(l=m.pop()),l.children.push({type:8});else if(l.type!==2){const u={type:2,content:r};l.children.push(u),m.push(l),l=u}else l.content+=r}return l.type===2&&(l=m.pop()),m.length,e}function d(s,a){return T(s,a)!==0}function T(s,a){switch(s){case"*":return 3;case"_":return 4;case"[":return 5;case"]":return 6;case"`":return a?7:0;default:return 0}}}),define(be[56],pe([1,0,3,2]),function(ae,t,v,N){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$CQ=void 0;class i{constructor(){this.a=new N.$Qc,this.b=null,this.c=null}dispose(){this.stopMonitoring(!1),this.a.dispose()}stopMonitoring(w,D){if(!this.isMonitoring())return;this.a.clear(),this.b=null;const c=this.c;this.c=null,w&&c&&c(D)}isMonitoring(){return!!this.b}startMonitoring(w,D,c,f,d){this.isMonitoring()&&this.stopMonitoring(!1),this.b=f,this.c=d;let T=w;try{w.setPointerCapture(D),this.a.add((0,N.$Pc)(()=>{try{w.releasePointerCapture(D)}catch{}}))}catch{T=v.$IP(w)}this.a.add(v.$3O(T,v.$VP.POINTER_MOVE,s=>{if(s.buttons!==c){this.stopMonitoring(!0);return}s.preventDefault(),this.b(s)})),this.a.add(v.$3O(T,v.$VP.POINTER_UP,s=>this.stopMonitoring(!0)))}}t.$CQ=i});var Xe=this&&this.__decorate||function(ae,t,v,N){var i=arguments.length,U=i<3?t:N===null?N=Object.getOwnPropertyDescriptor(t,v):N,w;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")U=Reflect.decorate(ae,t,v,N);else for(var D=ae.length-1;D>=0;D--)(w=ae[D])&&(U=(i<3?w(U):i>3?w(t,v,U):w(t,v))||U);return i>3&&U&&Object.defineProperty(t,v,U),U};define(be[24],pe([1,0,3,21,11,26,4,2,45]),function(ae,t,v,N,i,U,w,D,c){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$zQ=t.EventType=void 0;var f;(function(T){T.Tap="-monaco-gesturetap",T.Change="-monaco-gesturechange",T.Start="-monaco-gesturestart",T.End="-monaco-gesturesend",T.Contextmenu="-monaco-gesturecontextmenu"})(f||(t.EventType=f={}));class d extends D.$Rc{static{this.a=-.005}static{this.c=700}static{this.r=400}constructor(){super(),this.f=!1,this.g=new c.$2c,this.h=new c.$2c,this.m={},this.j=null,this.n=0,this.B(w.Event.runAndSubscribe(v.onDidRegisterWindow,({window:s,disposables:a})=>{a.add(v.$3O(s.document,"touchstart",e=>this.s(e),{passive:!1})),a.add(v.$3O(s.document,"touchend",e=>this.u(s,e))),a.add(v.$3O(s.document,"touchmove",e=>this.D(e),{passive:!1}))},{window:N.$vO,disposables:this.q}))}static addTarget(s){if(!d.isTouchDevice())return D.$Rc.None;d.b||(d.b=(0,D.$Kc)(new d));const a=d.b.g.push(s);return(0,D.$Pc)(a)}static ignoreTarget(s){if(!d.isTouchDevice())return D.$Rc.None;d.b||(d.b=(0,D.$Kc)(new d));const a=d.b.h.push(s);return(0,D.$Pc)(a)}static isTouchDevice(){return"ontouchstart"in N.$vO||navigator.maxTouchPoints>0}dispose(){this.j&&(this.j.dispose(),this.j=null),super.dispose()}s(s){const a=Date.now();this.j&&(this.j.dispose(),this.j=null);for(let e=0,h=s.targetTouches.length;e<h;e++){const l=s.targetTouches.item(e);this.m[l.identifier]={id:l.identifier,initialTarget:l.target,initialTimeStamp:a,initialPageX:l.pageX,initialPageY:l.pageY,rollingTimestamps:[a],rollingPageX:[l.pageX],rollingPageY:[l.pageY]};const m=this.w(f.Start,l.target);m.pageX=l.pageX,m.pageY=l.pageY,this.z(m)}this.f&&(s.preventDefault(),s.stopPropagation(),this.f=!1)}u(s,a){const e=Date.now(),h=Object.keys(this.m).length;for(let l=0,m=a.changedTouches.length;l<m;l++){const n=a.changedTouches.item(l);if(!this.m.hasOwnProperty(String(n.identifier))){console.warn("move of an UNKNOWN touch",n);continue}const r=this.m[n.identifier],b=Date.now()-r.initialTimeStamp;if(b<d.c&&Math.abs(r.initialPageX-i.$rb(r.rollingPageX))<30&&Math.abs(r.initialPageY-i.$rb(r.rollingPageY))<30){const u=this.w(f.Tap,r.initialTarget);u.pageX=i.$rb(r.rollingPageX),u.pageY=i.$rb(r.rollingPageY),this.z(u)}else if(b>=d.c&&Math.abs(r.initialPageX-i.$rb(r.rollingPageX))<30&&Math.abs(r.initialPageY-i.$rb(r.rollingPageY))<30){const u=this.w(f.Contextmenu,r.initialTarget);u.pageX=i.$rb(r.rollingPageX),u.pageY=i.$rb(r.rollingPageY),this.z(u)}else if(h===1){const u=i.$rb(r.rollingPageX),o=i.$rb(r.rollingPageY),F=i.$rb(r.rollingTimestamps)-r.rollingTimestamps[0],z=u-r.rollingPageX[0],R=o-r.rollingPageY[0],g=[...this.g].filter(y=>r.initialTarget instanceof Node&&y.contains(r.initialTarget));this.C(s,g,e,Math.abs(z)/F,z>0?1:-1,u,Math.abs(R)/F,R>0?1:-1,o)}this.z(this.w(f.End,r.initialTarget)),delete this.m[n.identifier]}this.f&&(a.preventDefault(),a.stopPropagation(),this.f=!1)}w(s,a){const e=document.createEvent("CustomEvent");return e.initEvent(s,!1,!0),e.initialTarget=a,e.tapCount=0,e}z(s){if(s.type===f.Tap){const a=new Date().getTime();let e=0;a-this.n>d.r?e=1:e=2,this.n=a,s.tapCount=e}else(s.type===f.Change||s.type===f.Contextmenu)&&(this.n=0);if(s.initialTarget instanceof Node){for(const a of this.h)if(a.contains(s.initialTarget))return;for(const a of this.g)a.contains(s.initialTarget)&&(a.dispatchEvent(s),this.f=!0)}}C(s,a,e,h,l,m,n,r,b){this.j=v.$aP(s,()=>{const u=Date.now(),o=u-e;let F=0,z=0,R=!0;h+=d.a*o,n+=d.a*o,h>0&&(R=!1,F=l*h*o),n>0&&(R=!1,z=r*n*o);const g=this.w(f.Change);g.translationX=F,g.translationY=z,a.forEach(y=>y.dispatchEvent(g)),R||this.C(s,a,u,h,l,m+F,n,r,b+z)})}D(s){const a=Date.now();for(let e=0,h=s.changedTouches.length;e<h;e++){const l=s.changedTouches.item(e);if(!this.m.hasOwnProperty(String(l.identifier))){console.warn("end of an UNKNOWN touch",l);continue}const m=this.m[l.identifier],n=this.w(f.Change,m.initialTarget);n.translationX=l.pageX-i.$rb(m.rollingPageX),n.translationY=l.pageY-i.$rb(m.rollingPageY),n.pageX=l.pageX,n.pageY=l.pageY,this.z(n),m.rollingPageX.length>3&&(m.rollingPageX.shift(),m.rollingPageY.shift(),m.rollingTimestamps.shift()),m.rollingPageX.push(l.pageX),m.rollingPageY.push(l.pageY),m.rollingTimestamps.push(a)}this.f&&(s.preventDefault(),s.stopPropagation(),this.f=!1)}}t.$zQ=d,Xe([U.$nh],d,"isTouchDevice",null)}),define(be[57],pe([1,0,3,91]),function(ae,t,v){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$7Q=t.$6Q=t.$5Q=void 0;const N=2e4;let i,U,w,D,c;function f(a){i=document.createElement("div"),i.className="monaco-aria-container";const e=()=>{const l=document.createElement("div");return l.className="monaco-alert",l.setAttribute("role","alert"),l.setAttribute("aria-atomic","true"),i.appendChild(l),l};U=e(),w=e();const h=()=>{const l=document.createElement("div");return l.className="monaco-status",l.setAttribute("aria-live","polite"),l.setAttribute("aria-atomic","true"),i.appendChild(l),l};D=h(),c=h(),a.appendChild(i)}t.$5Q=f;function d(a){i&&(U.textContent!==a?(v.$2O(w),s(U,a)):(v.$2O(U),s(w,a)))}t.$6Q=d;function T(a){i&&(D.textContent!==a?(v.$2O(c),s(D,a)):(v.$2O(D),s(c,a)))}t.$7Q=T;function s(a,e){v.$2O(a),e.length>N&&(e=e.substr(0,N)),a.textContent=e,a.style.visibility="hidden",a.style.visibility="visible"}}),define(be[118],pe([1,0,3,18]),function(ae,t,v,N){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$tR=t.$sR=void 0;const i=new RegExp(`(\\\\)?\\$\\((${N.ThemeIcon.iconNameExpression}(?:${N.ThemeIcon.iconModifierExpression})?)\\)`,"g");function U(D){const c=new Array;let f,d=0,T=0;for(;(f=i.exec(D))!==null;){T=f.index||0,d<T&&c.push(D.substring(d,T)),d=(f.index||0)+f[0].length;const[,s,a]=f;c.push(s?`$(${a})`:w({id:a}))}return d<D.length&&c.push(D.substring(d)),c}t.$sR=U;function w(D){const c=v.$("span");return c.classList.add(...N.ThemeIcon.asClassNameArray(D)),c}t.$tR=w}),define(be[119],pe([1,0,3]),function(ae,t,v){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$dR=void 0;function N(U){try{U.parentElement?.removeChild(U)}catch{}}class i{constructor(w){this.d=w,this.a=new Map,this.b=new Set,this.c=!1}alloc(w){let D=this.h(w).pop(),c=!1;if(D)c=this.b.has(D.domNode),c&&this.b.delete(D.domNode);else{const f=(0,v.$)(".monaco-list-row"),T=this.i(w).renderTemplate(f);D={domNode:f,templateId:w,templateData:T}}return{row:D,isReusingConnectedDomNode:c}}release(w){w&&this.f(w)}transact(w){if(this.c)throw new Error("Already in transaction");this.c=!0;try{w()}finally{for(const D of this.b)this.g(D);this.b.clear(),this.c=!1}}f(w){const{domNode:D,templateId:c}=w;D&&(this.c?this.b.add(D):this.g(D)),this.h(c).push(w)}g(w){w.classList.remove("scrolling"),N(w)}h(w){let D=this.a.get(w);return D||(D=[],this.a.set(w,D)),D}dispose(){this.a.forEach((w,D)=>{for(const c of w)this.i(D).disposeTemplate(c.templateData),c.templateData=null}),this.a.clear(),this.b.clear()}i(w){const D=this.d.get(w);if(!D)throw new Error(`No renderer found for ${w}`);return D}}t.$dR=i}),define(be[120],pe([1,0,9,2]),function(ae,t,v,N){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$HQ=void 0;class i extends N.$Rc{constructor(w,D,c){super(),this.a=w,this.b=D,this.c=c,this.f=null,this.m=!1,this.j=!1,this.g=!1,this.h=!1,this.n=this.B(new v.$8g)}setVisibility(w){this.a!==w&&(this.a=w,this.s())}setShouldBeVisible(w){this.g=w,this.s()}r(){return this.a===2?!1:this.a===3?!0:this.g}s(){const w=this.r();this.h!==w&&(this.h=w,this.ensureVisibility())}setIsNeeded(w){this.j!==w&&(this.j=w,this.ensureVisibility())}setDomNode(w){this.f=w,this.f.setClassName(this.c),this.setShouldBeVisible(!1)}ensureVisibility(){if(!this.j){this.u(!1);return}this.h?this.t():this.u(!0)}t(){this.m||(this.m=!0,this.n.setIfNotSet(()=>{this.f?.setClassName(this.b)},0))}u(w){this.n.cancel(),this.m&&(this.m=!1,this.f?.setClassName(this.c+(w?" fade":"")))}}t.$HQ=i}),define(be[121],pe([1,0,3,24,11,4,2,5]),function(ae,t,v,N,i,U,w,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$AR=void 0;class c extends w.$Rc{constructor(d,T,s,a){super(),this.f=0,this.b=a||Object.create(null),this.c=[],this.a=document.createElement("select"),this.a.className="monaco-select-box",typeof this.b.ariaLabel=="string"&&this.a.setAttribute("aria-label",this.b.ariaLabel),typeof this.b.ariaDescription=="string"&&this.a.setAttribute("aria-description",this.b.ariaDescription),this.g=this.B(new U.$Rd),this.h=s,this.j(),this.setOptions(d,T)}j(){this.B(N.$zQ.addTarget(this.a)),[N.EventType.Tap].forEach(d=>{this.B(v.$3O(this.a,d,T=>{this.a.focus()}))}),this.B(v.$4O(this.a,"click",d=>{v.$XP.stop(d,!0)})),this.B(v.$4O(this.a,"change",d=>{this.a.title=d.target.value,this.g.fire({index:d.target.selectedIndex,selected:d.target.value})})),this.B(v.$4O(this.a,"keydown",d=>{let T=!1;D.$j?(d.keyCode===18||d.keyCode===16||d.keyCode===10)&&(T=!0):(d.keyCode===18&&d.altKey||d.keyCode===10||d.keyCode===3)&&(T=!0),T&&d.stopPropagation()}))}get onDidSelect(){return this.g.event}setOptions(d,T){(!this.c||!i.$tb(this.c,d))&&(this.c=d,this.a.options.length=0,this.c.forEach((s,a)=>{this.a.add(this.m(s.text,a,s.isDisabled))})),T!==void 0&&this.select(T)}select(d){this.c.length===0?this.f=0:d>=0&&d<this.c.length?this.f=d:d>this.c.length-1?this.select(this.c.length-1):this.f<0&&(this.f=0),this.a.selectedIndex=this.f,this.f<this.c.length&&typeof this.c[this.f].text=="string"?this.a.title=this.c[this.f].text:this.a.title=""}setAriaLabel(d){this.b.ariaLabel=d,this.a.setAttribute("aria-label",d)}focus(){this.a&&(this.a.tabIndex=0,this.a.focus())}blur(){this.a&&(this.a.tabIndex=-1,this.a.blur())}setFocusable(d){this.a.tabIndex=d?0:-1}render(d){d.classList.add("select-container"),d.appendChild(this.a),this.setOptions(this.c,this.f),this.applyStyles()}style(d){this.h=d,this.applyStyles()}applyStyles(){this.a&&(this.a.style.backgroundColor=this.h.selectBackground??"",this.a.style.color=this.h.selectForeground??"",this.a.style.borderColor=this.h.selectBorder??"")}m(d,T,s){const a=document.createElement("option");return a.value=d,a.text=d,a.disabled=!!s,a}}t.$AR=c}),define(be[58],pe([1,0,25,11,9,50,86,4,27]),function(ae,t,v,N,i,U,w,D,c){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$8S=t.$7S=t.$6S=void 0;function f(a){return typeof a=="object"&&"visibility"in a&&"data"in a}t.$6S=f;function d(a){switch(a){case!0:return 1;case!1:return 0;default:return a}}t.$7S=d;function T(a){return typeof a.collapsible=="boolean"}class s{constructor(e,h,l,m={}){this.o=e,this.p=h,this.rootRef=[],this.d=new D.$Zd,this.f=new D.$Rd,this.onDidChangeCollapseState=this.d.wrapEvent(this.f.event),this.g=new D.$Rd,this.onDidChangeRenderNodeCount=this.d.wrapEvent(this.g.event),this.l=new D.$Rd,this.onDidSplice=this.l.event,this.m=new i.$Ug(U.$Od),this.h=typeof m.collapseByDefault>"u"?!1:m.collapseByDefault,this.j=m.filter,this.k=typeof m.autoExpandSingleChildren>"u"?!1:m.autoExpandSingleChildren,this.c={parent:void 0,element:l,children:[],depth:0,visibleChildrenCount:0,visibleChildIndex:-1,collapsible:!1,collapsed:!1,renderNodeCount:0,visibility:1,visible:!0,filterData:void 0}}splice(e,h,l=c.Iterable.empty(),m={}){if(e.length===0)throw new v.$4S(this.o,"Invalid tree location");m.diffIdentityProvider?this.q(m.diffIdentityProvider,e,h,l,m):this.s(e,h,l,m)}q(e,h,l,m=c.Iterable.empty(),n,r=n.diffDepth??0){const{parentNode:b}=this.G(h);if(!b.lastDiffIds)return this.s(h,l,m,n);const u=[...m],o=h[h.length-1],F=new w.$Fs({getElements:()=>b.lastDiffIds},{getElements:()=>[...b.children.slice(0,o),...u,...b.children.slice(o+l)].map(M=>e.getId(M.element).toString())}).ComputeDiff(!1);if(F.quitEarly)return b.lastDiffIds=void 0,this.s(h,l,u,n);const z=h.slice(0,-1),R=(M,_,x)=>{if(r>0)for(let O=0;O<x;O++)M--,_--,this.q(e,[...z,M,0],Number.MAX_SAFE_INTEGER,u[_].children,n,r-1)};let g=Math.min(b.children.length,o+l),y=u.length;for(const M of F.changes.sort((_,x)=>x.originalStart-_.originalStart))R(g,y,g-(M.originalStart+M.originalLength)),g=M.originalStart,y=M.modifiedStart-o,this.s([...z,g],M.originalLength,c.Iterable.slice(u,y,y+M.modifiedLength),n);R(g,y,g)}s(e,h,l=c.Iterable.empty(),{onDidCreateNode:m,onDidDeleteNode:n,diffIdentityProvider:r}){const{parentNode:b,listIndex:u,revealed:o,visible:F}=this.G(e),z=[],R=c.Iterable.map(l,ce=>this.w(ce,b,b.visible?1:0,o,z,m)),g=e[e.length-1],y=b.children.length>0;let M=0;for(let ce=g;ce>=0&&ce<b.children.length;ce--){const le=b.children[ce];if(le.visible){M=le.visibleChildIndex;break}}const _=[];let x=0,O=0;for(const ce of R)_.push(ce),O+=ce.renderNodeCount,ce.visible&&(ce.visibleChildIndex=M+x++);const B=(0,N.$5b)(b.children,g,h,_);r?b.lastDiffIds?(0,N.$5b)(b.lastDiffIds,g,h,_.map(ce=>r.getId(ce.element).toString())):b.lastDiffIds=b.children.map(ce=>r.getId(ce.element).toString()):b.lastDiffIds=void 0;let j=0;for(const ce of B)ce.visible&&j++;if(j!==0)for(let ce=g+_.length;ce<b.children.length;ce++){const le=b.children[ce];le.visible&&(le.visibleChildIndex-=j)}if(b.visibleChildrenCount+=x-j,o&&F){const ce=B.reduce((le,oe)=>le+(oe.visible?oe.renderNodeCount:0),0);this.B(b,O-ce),this.p.splice(u,ce,z)}if(B.length>0&&n){const ce=le=>{n(le),le.children.forEach(ce)};B.forEach(ce)}this.l.fire({insertedNodes:_,deletedNodes:B});const ie=b.children.length>0;y!==ie&&this.setCollapsible(e.slice(0,-1),ie);let te=b;for(;te;){if(te.visibility===2){this.m.trigger(()=>this.refilter());break}te=te.parent}}rerender(e){if(e.length===0)throw new v.$4S(this.o,"Invalid tree location");const{node:h,listIndex:l,revealed:m}=this.F(e);h.visible&&m&&this.p.splice(l,1,[h])}updateElementHeight(e,h){if(e.length===0)throw new v.$4S(this.o,"Invalid tree location");const{listIndex:l}=this.F(e);this.p.updateElementHeight(l,h)}has(e){return this.D(e)}getListIndex(e){const{listIndex:h,visible:l,revealed:m}=this.F(e);return l&&m?h:-1}getListRenderCount(e){return this.E(e).renderNodeCount}isCollapsible(e){return this.E(e).collapsible}setCollapsible(e,h){const l=this.E(e);typeof h>"u"&&(h=!l.collapsible);const m={collapsible:h};return this.d.bufferEvents(()=>this.t(e,m))}isCollapsed(e){return this.E(e).collapsed}setCollapsed(e,h,l){const m=this.E(e);typeof h>"u"&&(h=!m.collapsed);const n={collapsed:h,recursive:l||!1};return this.d.bufferEvents(()=>this.t(e,n))}t(e,h){const{node:l,listIndex:m,revealed:n}=this.F(e),r=this.u(l,m,n,h);if(l!==this.c&&this.k&&r&&!T(h)&&l.collapsible&&!l.collapsed&&!h.recursive){let b=-1;for(let u=0;u<l.children.length;u++)if(l.children[u].visible)if(b>-1){b=-1;break}else b=u;b>-1&&this.t([...e,b],h)}return r}u(e,h,l,m){const n=this.v(e,m,!1);if(!l||!e.visible||!n)return n;const r=e.renderNodeCount,b=this.x(e),u=r-(h===-1?0:1);return this.p.splice(h+1,u,b.slice(1)),n}v(e,h,l){let m;if(e===this.c?m=!1:(T(h)?(m=e.collapsible!==h.collapsible,e.collapsible=h.collapsible):e.collapsible?(m=e.collapsed!==h.collapsed,e.collapsed=h.collapsed):m=!1,m&&this.f.fire({node:e,deep:l})),!T(h)&&h.recursive)for(const n of e.children)m=this.v(n,h,!0)||m;return m}expandTo(e){this.d.bufferEvents(()=>{let h=this.E(e);for(;h.parent;)h=h.parent,e=e.slice(0,e.length-1),h.collapsed&&this.t(e,{collapsed:!1,recursive:!1})})}refilter(){const e=this.c.renderNodeCount,h=this.z(this.c);this.p.splice(0,e,h),this.m.cancel()}w(e,h,l,m,n,r){const b={parent:h,element:e.element,children:[],depth:h.depth+1,visibleChildrenCount:0,visibleChildIndex:-1,collapsible:typeof e.collapsible=="boolean"?e.collapsible:typeof e.collapsed<"u",collapsed:typeof e.collapsed>"u"?this.h:e.collapsed,renderNodeCount:1,visibility:1,visible:!0,filterData:void 0},u=this.C(b,l);b.visibility=u,m&&n.push(b);const o=e.children||c.Iterable.empty(),F=m&&u!==0&&!b.collapsed;let z=0,R=1;for(const g of o){const y=this.w(g,b,u,F,n,r);b.children.push(y),R+=y.renderNodeCount,y.visible&&(y.visibleChildIndex=z++)}return b.collapsible=b.collapsible||b.children.length>0,b.visibleChildrenCount=z,b.visible=u===2?z>0:u===1,b.visible?b.collapsed||(b.renderNodeCount=R):(b.renderNodeCount=0,m&&n.pop()),r?.(b),b}x(e){const h=e.renderNodeCount,l=[];return this.y(e,l),this.B(e.parent,l.length-h),l}y(e,h){if(e.visible===!1)return 0;if(h.push(e),e.renderNodeCount=1,!e.collapsed)for(const l of e.children)e.renderNodeCount+=this.y(l,h);return this.g.fire(e),e.renderNodeCount}z(e){const h=e.renderNodeCount,l=[];return this.A(e,e.visible?1:0,l),this.B(e.parent,l.length-h),l}A(e,h,l,m=!0){let n;if(e!==this.c){if(n=this.C(e,h),n===0)return e.visible=!1,e.renderNodeCount=0,!1;m&&l.push(e)}const r=l.length;e.renderNodeCount=e===this.c?0:1;let b=!1;if(!e.collapsed||n!==0){let u=0;for(const o of e.children)b=this.A(o,n,l,m&&!e.collapsed)||b,o.visible&&(o.visibleChildIndex=u++);e.visibleChildrenCount=u}else e.visibleChildrenCount=0;return e!==this.c&&(e.visible=n===2?b:n===1,e.visibility=n),e.visible?e.collapsed||(e.renderNodeCount+=l.length-r):(e.renderNodeCount=0,m&&l.pop()),this.g.fire(e),e.visible}B(e,h){if(h!==0)for(;e;)e.renderNodeCount+=h,this.g.fire(e),e=e.parent}C(e,h){const l=this.j?this.j.filter(e.element,h):1;return typeof l=="boolean"?(e.filterData=void 0,l?1:0):f(l)?(e.filterData=l.data,d(l.visibility)):(e.filterData=void 0,d(l))}D(e,h=this.c){if(!e||e.length===0)return!0;const[l,...m]=e;return l<0||l>h.children.length?!1:this.D(m,h.children[l])}E(e,h=this.c){if(!e||e.length===0)return h;const[l,...m]=e;if(l<0||l>h.children.length)throw new v.$4S(this.o,"Invalid tree location");return this.E(m,h.children[l])}F(e){if(e.length===0)return{node:this.c,listIndex:-1,revealed:!0,visible:!1};const{parentNode:h,listIndex:l,revealed:m,visible:n}=this.G(e),r=e[e.length-1];if(r<0||r>h.children.length)throw new v.$4S(this.o,"Invalid tree location");const b=h.children[r];return{node:b,listIndex:l,revealed:m,visible:n&&b.visible}}G(e,h=this.c,l=0,m=!0,n=!0){const[r,...b]=e;if(r<0||r>h.children.length)throw new v.$4S(this.o,"Invalid tree location");for(let u=0;u<r;u++)l+=h.children[u].renderNodeCount;return m=m&&!h.collapsed,n=n&&h.visible,b.length===0?{parentNode:h,listIndex:l,revealed:m,visible:n}:this.G(b,h.children[r],l+1,m,n)}getNode(e=[]){return this.E(e)}getNodeLocation(e){const h=[];let l=e;for(;l.parent;)h.push(l.parent.children.indexOf(l)),l=l.parent;return h.reverse()}getParentNodeLocation(e){if(e.length!==0)return e.length===1?[]:(0,N.$sb)(e)[0]}getFirstElementChild(e){const h=this.E(e);if(h.children.length!==0)return h.children[0].element}getLastElementAncestor(e=[]){const h=this.E(e);if(h.children.length!==0)return this.H(h)}H(e){return e.children.length===0?e.element:this.H(e.children[e.children.length-1])}}t.$8S=s}),define(be[122],pe([1,0,58,25,27]),function(ae,t,v,N,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$bT=void 0;class U{get size(){return this.d.size}constructor(D,c,f={}){this.k=D,this.rootRef=null,this.d=new Map,this.f=new Map,this.c=new v.$8S(D,c,null,f),this.onDidSplice=this.c.onDidSplice,this.onDidChangeCollapseState=this.c.onDidChangeCollapseState,this.onDidChangeRenderNodeCount=this.c.onDidChangeRenderNodeCount,f.sorter&&(this.j={compare(d,T){return f.sorter.compare(d.element,T.element)}}),this.h=f.identityProvider}setChildren(D,c=i.Iterable.empty(),f={}){const d=this.o(D);this.l(d,this.m(c),f)}l(D,c=i.Iterable.empty(),f){const d=new Set,T=new Set,s=e=>{if(e.element===null)return;const h=e;if(d.add(h.element),this.d.set(h.element,h),this.h){const l=this.h.getId(h.element).toString();T.add(l),this.f.set(l,h)}f.onDidCreateNode?.(h)},a=e=>{if(e.element===null)return;const h=e;if(d.has(h.element)||this.d.delete(h.element),this.h){const l=this.h.getId(h.element).toString();T.has(l)||this.f.delete(l)}f.onDidDeleteNode?.(h)};this.c.splice([...D,0],Number.MAX_VALUE,c,{...f,onDidCreateNode:s,onDidDeleteNode:a})}m(D=i.Iterable.empty()){return this.j&&(D=[...D].sort(this.j.compare.bind(this.j))),i.Iterable.map(D,c=>{let f=this.d.get(c.element);if(!f&&this.h){const s=this.h.getId(c.element).toString();f=this.f.get(s)}if(!f){let s;return typeof c.collapsed>"u"?s=void 0:c.collapsed===N.ObjectTreeElementCollapseState.Collapsed||c.collapsed===N.ObjectTreeElementCollapseState.PreserveOrCollapsed?s=!0:c.collapsed===N.ObjectTreeElementCollapseState.Expanded||c.collapsed===N.ObjectTreeElementCollapseState.PreserveOrExpanded?s=!1:s=!!c.collapsed,{...c,children:this.m(c.children),collapsed:s}}const d=typeof c.collapsible=="boolean"?c.collapsible:f.collapsible;let T;return typeof c.collapsed>"u"||c.collapsed===N.ObjectTreeElementCollapseState.PreserveOrCollapsed||c.collapsed===N.ObjectTreeElementCollapseState.PreserveOrExpanded?T=f.collapsed:c.collapsed===N.ObjectTreeElementCollapseState.Collapsed?T=!0:c.collapsed===N.ObjectTreeElementCollapseState.Expanded?T=!1:T=!!c.collapsed,{...c,collapsible:d,collapsed:T,children:this.m(c.children)}})}rerender(D){const c=this.o(D);this.c.rerender(c)}updateElementHeight(D,c){const f=this.o(D);this.c.updateElementHeight(f,c)}resort(D=null,c=!0){if(!this.j)return;const f=this.o(D),d=this.c.getNode(f);this.l(f,this.n(d,c),{})}n(D,c,f=!0){let d=[...D.children];return(c||f)&&(d=d.sort(this.j.compare.bind(this.j))),i.Iterable.map(d,T=>({element:T.element,collapsible:T.collapsible,collapsed:T.collapsed,children:this.n(T,c,!1)}))}getFirstElementChild(D=null){const c=this.o(D);return this.c.getFirstElementChild(c)}getLastElementAncestor(D=null){const c=this.o(D);return this.c.getLastElementAncestor(c)}has(D){return this.d.has(D)}getListIndex(D){const c=this.o(D);return this.c.getListIndex(c)}getListRenderCount(D){const c=this.o(D);return this.c.getListRenderCount(c)}isCollapsible(D){const c=this.o(D);return this.c.isCollapsible(c)}setCollapsible(D,c){const f=this.o(D);return this.c.setCollapsible(f,c)}isCollapsed(D){const c=this.o(D);return this.c.isCollapsed(c)}setCollapsed(D,c,f){const d=this.o(D);return this.c.setCollapsed(d,c,f)}expandTo(D){const c=this.o(D);this.c.expandTo(c)}refilter(){this.c.refilter()}getNode(D=null){if(D===null)return this.c.getNode(this.c.rootRef);const c=this.d.get(D);if(!c)throw new N.$4S(this.k,`Tree element not found: ${D}`);return c}getNodeLocation(D){return D.element}getParentNodeLocation(D){if(D===null)throw new N.$4S(this.k,"Invalid getParentNodeLocation call");const c=this.d.get(D);if(!c)throw new N.$4S(this.k,`Tree element not found: ${D}`);const f=this.c.getNodeLocation(c),d=this.c.getParentNodeLocation(f);return this.c.getNode(d).element}o(D){if(D===null)return[];const c=this.d.get(D);if(!c)throw new N.$4S(this.k,`Tree element not found: ${D}`);return this.c.getNodeLocation(c)}}t.$bT=U}),define(be[20],pe([1,0,3,14,19,24,2]),function(ae,t,v,N,i,U,w){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$DQ=void 0;class D extends w.$Rc{f(f,d){this.B(v.$3O(f,v.$VP.CLICK,T=>d(new i.$UO(v.$IP(f),T))))}j(f,d){this.B(v.$3O(f,v.$VP.MOUSE_DOWN,T=>d(new i.$UO(v.$IP(f),T))))}m(f,d){this.B(v.$3O(f,v.$VP.MOUSE_OVER,T=>d(new i.$UO(v.$IP(f),T))))}u(f,d){this.B(v.$3O(f,v.$VP.MOUSE_LEAVE,T=>d(new i.$UO(v.$IP(f),T))))}z(f,d){this.B(v.$3O(f,v.$VP.KEY_DOWN,T=>d(new N.$ZO(T))))}C(f,d){this.B(v.$3O(f,v.$VP.KEY_UP,T=>d(new N.$ZO(T))))}D(f,d){this.B(v.$3O(f,v.$VP.INPUT,d))}F(f,d){this.B(v.$3O(f,v.$VP.BLUR,d))}G(f,d){this.B(v.$3O(f,v.$VP.FOCUS,d))}H(f,d){this.B(v.$3O(f,v.$VP.CHANGE,d))}I(f){return U.$zQ.ignoreTarget(f)}}t.$DQ=D}),define(be[38],pe([1,0,56,20,9,18,3]),function(ae,t,v,N,i,U,w){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$FQ=t.$EQ=void 0,t.$EQ=11;class D extends N.$DQ{constructor(f){super(),this.a=f.onActivate,this.bgDomNode=document.createElement("div"),this.bgDomNode.className="arrow-background",this.bgDomNode.style.position="absolute",this.bgDomNode.style.width=f.bgWidth+"px",this.bgDomNode.style.height=f.bgHeight+"px",typeof f.top<"u"&&(this.bgDomNode.style.top="0px"),typeof f.left<"u"&&(this.bgDomNode.style.left="0px"),typeof f.bottom<"u"&&(this.bgDomNode.style.bottom="0px"),typeof f.right<"u"&&(this.bgDomNode.style.right="0px"),this.domNode=document.createElement("div"),this.domNode.className=f.className,this.domNode.classList.add(...U.ThemeIcon.asClassNameArray(f.icon)),this.domNode.style.position="absolute",this.domNode.style.width=t.$EQ+"px",this.domNode.style.height=t.$EQ+"px",typeof f.top<"u"&&(this.domNode.style.top=f.top+"px"),typeof f.left<"u"&&(this.domNode.style.left=f.left+"px"),typeof f.bottom<"u"&&(this.domNode.style.bottom=f.bottom+"px"),typeof f.right<"u"&&(this.domNode.style.right=f.right+"px"),this.g=this.B(new v.$CQ),this.B(w.$4O(this.bgDomNode,w.$VP.POINTER_DOWN,d=>this.h(d))),this.B(w.$4O(this.domNode,w.$VP.POINTER_DOWN,d=>this.h(d))),this.b=this.B(new w.$cP),this.c=this.B(new i.$8g)}h(f){if(!f.target||!(f.target instanceof Element))return;const d=()=>{this.b.cancelAndSet(()=>this.a(),1e3/24,w.$IP(f))};this.a(),this.b.cancel(),this.c.cancelAndSet(d,200),this.g.startMonitoring(f.target,f.pointerId,f.buttons,T=>{},()=>{this.b.cancel(),this.c.cancel()}),f.preventDefault()}}t.$FQ=D}),define(be[59],pe([1,0,3,41,56,38,120,20,5]),function(ae,t,v,N,i,U,w,D,c){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$IQ=void 0;const f=140;class d extends D.$DQ{constructor(s){super(),this.g=s.lazyRender,this.a=s.host,this.b=s.scrollable,this.c=s.scrollByPage,this.h=s.scrollbarState,this.n=this.B(new w.$HQ(s.visibility,"visible scrollbar "+s.extraScrollbarClassName,"invisible scrollbar "+s.extraScrollbarClassName)),this.n.setIsNeeded(this.h.isNeeded()),this.r=this.B(new i.$CQ),this.s=!0,this.domNode=(0,N.$BQ)(document.createElement("div")),this.domNode.setAttribute("role","presentation"),this.domNode.setAttribute("aria-hidden","true"),this.n.setDomNode(this.domNode),this.domNode.setPosition("absolute"),this.B(v.$3O(this.domNode.domNode,v.$VP.POINTER_DOWN,a=>this.M(a)))}t(s){const a=this.B(new U.$FQ(s));this.domNode.domNode.appendChild(a.bgDomNode),this.domNode.domNode.appendChild(a.domNode)}w(s,a,e,h){this.slider=(0,N.$BQ)(document.createElement("div")),this.slider.setClassName("slider"),this.slider.setPosition("absolute"),this.slider.setTop(s),this.slider.setLeft(a),typeof e=="number"&&this.slider.setWidth(e),typeof h=="number"&&this.slider.setHeight(h),this.slider.setLayerHinting(!0),this.slider.setContain("strict"),this.domNode.domNode.appendChild(this.slider.domNode),this.B(v.$3O(this.slider.domNode,v.$VP.POINTER_DOWN,l=>{l.button===0&&(l.preventDefault(),this.O(l))})),this.f(this.slider.domNode,l=>{l.leftButton&&l.stopPropagation()})}y(s){return this.h.setVisibleSize(s)&&(this.n.setIsNeeded(this.h.isNeeded()),this.s=!0,this.g||this.render()),this.s}J(s){return this.h.setScrollSize(s)&&(this.n.setIsNeeded(this.h.isNeeded()),this.s=!0,this.g||this.render()),this.s}L(s){return this.h.setScrollPosition(s)&&(this.n.setIsNeeded(this.h.isNeeded()),this.s=!0,this.g||this.render()),this.s}beginReveal(){this.n.setShouldBeVisible(!0)}beginHide(){this.n.setShouldBeVisible(!1)}render(){this.s&&(this.s=!1,this.Q(this.h.getRectangleLargeSize(),this.h.getRectangleSmallSize()),this.R(this.h.getSliderSize(),this.h.getArrowSize()+this.h.getSliderPosition()))}M(s){s.target===this.domNode.domNode&&this.N(s)}delegatePointerDown(s){const a=this.domNode.domNode.getClientRects()[0].top,e=a+this.h.getSliderPosition(),h=a+this.h.getSliderPosition()+this.h.getSliderSize(),l=this.U(s);e<=l&&l<=h?s.button===0&&(s.preventDefault(),this.O(s)):this.N(s)}N(s){let a,e;if(s.target===this.domNode.domNode&&typeof s.offsetX=="number"&&typeof s.offsetY=="number")a=s.offsetX,e=s.offsetY;else{const l=v.$mP(this.domNode.domNode);a=s.pageX-l.left,e=s.pageY-l.top}const h=this.S(a,e);this.P(this.c?this.h.getDesiredScrollPositionFromOffsetPaged(h):this.h.getDesiredScrollPositionFromOffset(h)),s.button===0&&(s.preventDefault(),this.O(s))}O(s){if(!s.target||!(s.target instanceof Element))return;const a=this.U(s),e=this.W(s),h=this.h.clone();this.slider.toggleClassName("active",!0),this.r.startMonitoring(s.target,s.pointerId,s.buttons,l=>{const m=this.W(l),n=Math.abs(m-e);if(c.$i&&n>f){this.P(h.getScrollPosition());return}const b=this.U(l)-a;this.P(h.getDesiredScrollPositionFromDelta(b))},()=>{this.slider.toggleClassName("active",!1),this.a.onDragEnd()}),this.a.onDragStart()}P(s){const a={};this.writeScrollPosition(a,s),this.b.setScrollPositionNow(a)}updateScrollbarSize(s){this.X(s),this.h.setScrollbarSize(s),this.s=!0,this.g||this.render()}isNeeded(){return this.h.isNeeded()}}t.$IQ=d}),define(be[123],pe([1,0,19,59,38,42,17]),function(ae,t,v,N,i,U,w){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$JQ=void 0;class D extends N.$IQ{constructor(f,d,T){const s=f.getScrollDimensions(),a=f.getCurrentScrollPosition();if(super({lazyRender:d.lazyRender,host:T,scrollbarState:new U.$GQ(d.horizontalHasArrows?d.arrowSize:0,d.horizontal===2?0:d.horizontalScrollbarSize,d.vertical===2?0:d.verticalScrollbarSize,s.width,s.scrollWidth,a.scrollLeft),visibility:d.horizontal,extraScrollbarClassName:"horizontal",scrollable:f,scrollByPage:d.scrollByPage}),d.horizontalHasArrows){const e=(d.arrowSize-i.$EQ)/2,h=(d.horizontalScrollbarSize-i.$EQ)/2;this.t({className:"scra",icon:w.$1j.scrollbarButtonLeft,top:h,left:e,bottom:void 0,right:void 0,bgWidth:d.arrowSize,bgHeight:d.horizontalScrollbarSize,onActivate:()=>this.a.onMouseWheel(new v.$WO(null,1,0))}),this.t({className:"scra",icon:w.$1j.scrollbarButtonRight,top:h,left:void 0,bottom:void 0,right:e,bgWidth:d.arrowSize,bgHeight:d.horizontalScrollbarSize,onActivate:()=>this.a.onMouseWheel(new v.$WO(null,-1,0))})}this.w(Math.floor((d.horizontalScrollbarSize-d.horizontalSliderSize)/2),0,void 0,d.horizontalSliderSize)}R(f,d){this.slider.setWidth(f),this.slider.setLeft(d)}Q(f,d){this.domNode.setWidth(f),this.domNode.setHeight(d),this.domNode.setLeft(0),this.domNode.setBottom(0)}onDidScroll(f){return this.s=this.J(f.scrollWidth)||this.s,this.s=this.L(f.scrollLeft)||this.s,this.s=this.y(f.width)||this.s,this.s}S(f,d){return f}U(f){return f.pageX}W(f){return f.pageY}X(f){this.slider.setHeight(f)}writeScrollPosition(f,d){f.scrollLeft=d}updateOptions(f){this.updateScrollbarSize(f.horizontal===2?0:f.horizontalScrollbarSize),this.h.setOppositeScrollbarSize(f.vertical===2?0:f.verticalScrollbarSize),this.n.setVisibility(f.horizontal),this.c=f.scrollByPage}}t.$JQ=D}),define(be[124],pe([1,0,19,59,38,42,17]),function(ae,t,v,N,i,U,w){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$KQ=void 0;class D extends N.$IQ{constructor(f,d,T){const s=f.getScrollDimensions(),a=f.getCurrentScrollPosition();if(super({lazyRender:d.lazyRender,host:T,scrollbarState:new U.$GQ(d.verticalHasArrows?d.arrowSize:0,d.vertical===2?0:d.verticalScrollbarSize,0,s.height,s.scrollHeight,a.scrollTop),visibility:d.vertical,extraScrollbarClassName:"vertical",scrollable:f,scrollByPage:d.scrollByPage}),d.verticalHasArrows){const e=(d.arrowSize-i.$EQ)/2,h=(d.verticalScrollbarSize-i.$EQ)/2;this.t({className:"scra",icon:w.$1j.scrollbarButtonUp,top:e,left:h,bottom:void 0,right:void 0,bgWidth:d.verticalScrollbarSize,bgHeight:d.arrowSize,onActivate:()=>this.a.onMouseWheel(new v.$WO(null,0,1))}),this.t({className:"scra",icon:w.$1j.scrollbarButtonDown,top:void 0,left:h,bottom:e,right:void 0,bgWidth:d.verticalScrollbarSize,bgHeight:d.arrowSize,onActivate:()=>this.a.onMouseWheel(new v.$WO(null,0,-1))})}this.w(0,Math.floor((d.verticalScrollbarSize-d.verticalSliderSize)/2),d.verticalSliderSize,void 0)}R(f,d){this.slider.setHeight(f),this.slider.setTop(d)}Q(f,d){this.domNode.setWidth(d),this.domNode.setHeight(f),this.domNode.setRight(0),this.domNode.setTop(0)}onDidScroll(f){return this.s=this.J(f.scrollHeight)||this.s,this.s=this.L(f.scrollTop)||this.s,this.s=this.y(f.height)||this.s,this.s}S(f,d){return d}U(f){return f.pageY}W(f){return f.pageX}X(f){this.slider.setWidth(f)}writeScrollPosition(f,d){f.scrollTop=d}updateOptions(f){this.updateScrollbarSize(f.vertical===2?0:f.verticalScrollbarSize),this.h.setOppositeScrollbarSize(0),this.n.setVisibility(f.vertical),this.c=f.scrollByPage}}t.$KQ=D}),define(be[60],pe([1,0,16,3,41,19,123,124,20,9,4,2,5,48,98]),function(ae,t,v,N,i,U,w,D,c,f,d,T,s,a){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$PQ=t.$OQ=t.$NQ=t.$MQ=t.$LQ=void 0;const e=500,h=50,l=!0;class m{constructor(R,g,y){this.timestamp=R,this.deltaX=g,this.deltaY=y,this.score=0}}class n{static{this.INSTANCE=new n}constructor(){this.a=5,this.b=[],this.c=-1,this.d=-1}isPhysicalMouseWheel(){if(this.c===-1&&this.d===-1)return!1;let R=1,g=0,y=1,M=this.d;do{const _=M===this.c?R:Math.pow(2,-y);if(R-=_,g+=this.b[M].score*_,M===this.c)break;M=(this.a+M-1)%this.a,y++}while(!0);return g<=.5}acceptStandardWheelEvent(R){const g=N.$IP(R.browserEvent).devicePixelRatio/(0,v.$DO)();s.$i||s.$k?this.accept(Date.now(),R.deltaX/g,R.deltaY/g):this.accept(Date.now(),R.deltaX,R.deltaY)}accept(R,g,y){const M=new m(R,g,y);M.score=this.f(M),this.c===-1&&this.d===-1?(this.b[0]=M,this.c=0,this.d=0):(this.d=(this.d+1)%this.a,this.d===this.c&&(this.c=(this.c+1)%this.a),this.b[this.d]=M)}f(R){if(Math.abs(R.deltaX)>0&&Math.abs(R.deltaY)>0)return 1;let g=.5;const y=this.c===-1&&this.d===-1?null:this.b[this.d];return(!this.g(R.deltaX)||!this.g(R.deltaY))&&(g+=.25),Math.min(Math.max(g,0),1)}g(R){return Math.abs(Math.round(R)-R)<.01}}t.$LQ=n;class r extends c.$DQ{get options(){return this.a}constructor(R,g,y){super(),this.O=this.B(new d.$Rd),this.onScroll=this.O.event,this.P=this.B(new d.$Rd),this.onWillScroll=this.P.event,R.style.overflow="hidden",this.a=F(g),this.b=y,this.B(this.b.onScroll(_=>{this.P.fire(_),this.S(_),this.O.fire(_)}));const M={onMouseWheel:_=>this.R(_),onDragStart:()=>this.W(),onDragEnd:()=>this.X()};this.c=this.B(new D.$KQ(this.b,this.a,M)),this.g=this.B(new w.$JQ(this.b,this.a,M)),this.h=document.createElement("div"),this.h.className="monaco-scrollable-element "+this.a.className,this.h.setAttribute("role","presentation"),this.h.style.position="relative",this.h.style.overflow="hidden",this.h.appendChild(R),this.h.appendChild(this.g.domNode.domNode),this.h.appendChild(this.c.domNode.domNode),this.a.useShadows?(this.n=(0,i.$BQ)(document.createElement("div")),this.n.setClassName("shadow"),this.h.appendChild(this.n.domNode),this.r=(0,i.$BQ)(document.createElement("div")),this.r.setClassName("shadow"),this.h.appendChild(this.r.domNode),this.s=(0,i.$BQ)(document.createElement("div")),this.s.setClassName("shadow"),this.h.appendChild(this.s.domNode)):(this.n=null,this.r=null,this.s=null),this.t=this.a.listenOnDomNode||this.h,this.w=[],this.Q(this.a.handleMouseWheel),this.m(this.t,_=>this.Z(_)),this.u(this.t,_=>this.Y(_)),this.L=this.B(new f.$8g),this.y=!1,this.J=!1,this.M=!0,this.N=!0}dispose(){this.w=(0,T.$Mc)(this.w),super.dispose()}getDomNode(){return this.h}getOverviewRulerLayoutInfo(){return{parent:this.h,insertBefore:this.c.domNode.domNode}}delegateVerticalScrollbarPointerDown(R){this.c.delegatePointerDown(R)}getScrollDimensions(){return this.b.getScrollDimensions()}setScrollDimensions(R){this.b.setScrollDimensions(R,!1)}updateClassName(R){this.a.className=R,s.$j&&(this.a.className+=" mac"),this.h.className="monaco-scrollable-element "+this.a.className}updateOptions(R){typeof R.handleMouseWheel<"u"&&(this.a.handleMouseWheel=R.handleMouseWheel,this.Q(this.a.handleMouseWheel)),typeof R.mouseWheelScrollSensitivity<"u"&&(this.a.mouseWheelScrollSensitivity=R.mouseWheelScrollSensitivity),typeof R.fastScrollSensitivity<"u"&&(this.a.fastScrollSensitivity=R.fastScrollSensitivity),typeof R.scrollPredominantAxis<"u"&&(this.a.scrollPredominantAxis=R.scrollPredominantAxis),typeof R.horizontal<"u"&&(this.a.horizontal=R.horizontal),typeof R.vertical<"u"&&(this.a.vertical=R.vertical),typeof R.horizontalScrollbarSize<"u"&&(this.a.horizontalScrollbarSize=R.horizontalScrollbarSize),typeof R.verticalScrollbarSize<"u"&&(this.a.verticalScrollbarSize=R.verticalScrollbarSize),typeof R.scrollByPage<"u"&&(this.a.scrollByPage=R.scrollByPage),this.g.updateOptions(this.a),this.c.updateOptions(this.a),this.a.lazyRender||this.U()}setRevealOnScroll(R){this.N=R}delegateScrollFromMouseWheelEvent(R){this.R(new U.$WO(R))}Q(R){if(this.w.length>0!==R&&(this.w=(0,T.$Mc)(this.w),R)){const y=M=>{this.R(new U.$WO(M))};this.w.push(N.$3O(this.t,N.$VP.MOUSE_WHEEL,y,{passive:!1}))}}R(R){if(R.browserEvent?.defaultPrevented)return;const g=n.INSTANCE;l&&g.acceptStandardWheelEvent(R);let y=!1;if(R.deltaY||R.deltaX){let _=R.deltaY*this.a.mouseWheelScrollSensitivity,x=R.deltaX*this.a.mouseWheelScrollSensitivity;this.a.scrollPredominantAxis&&(this.a.scrollYToX&&x+_===0?x=_=0:Math.abs(_)>=Math.abs(x)?x=0:_=0),this.a.flipAxes&&([_,x]=[x,_]);const O=!s.$j&&R.browserEvent&&R.browserEvent.shiftKey;(this.a.scrollYToX||O)&&!x&&(x=_,_=0),R.browserEvent&&R.browserEvent.altKey&&(x=x*this.a.fastScrollSensitivity,_=_*this.a.fastScrollSensitivity);const B=this.b.getFutureScrollPosition();let j={};if(_){const ie=h*_,te=B.scrollTop-(ie<0?Math.floor(ie):Math.ceil(ie));this.c.writeScrollPosition(j,te)}if(x){const ie=h*x,te=B.scrollLeft-(ie<0?Math.floor(ie):Math.ceil(ie));this.g.writeScrollPosition(j,te)}j=this.b.validateScrollPosition(j),(B.scrollLeft!==j.scrollLeft||B.scrollTop!==j.scrollTop)&&(l&&this.a.mouseWheelSmoothScroll&&g.isPhysicalMouseWheel()?this.b.setScrollPositionSmooth(j):this.b.setScrollPositionNow(j),y=!0)}let M=y;!M&&this.a.alwaysConsumeMouseWheel&&(M=!0),!M&&this.a.consumeMouseWheelIfScrollbarIsNeeded&&(this.c.isNeeded()||this.g.isNeeded())&&(M=!0),M&&(R.preventDefault(),R.stopPropagation())}S(R){this.M=this.g.onDidScroll(R)||this.M,this.M=this.c.onDidScroll(R)||this.M,this.a.useShadows&&(this.M=!0),this.N&&this.$(),this.a.lazyRender||this.U()}renderNow(){if(!this.a.lazyRender)throw new Error("Please use `lazyRender` together with `renderNow`!");this.U()}U(){if(this.M&&(this.M=!1,this.g.render(),this.c.render(),this.a.useShadows)){const R=this.b.getCurrentScrollPosition(),g=R.scrollTop>0,y=R.scrollLeft>0,M=y?" left":"",_=g?" top":"",x=y||g?" top-left-corner":"";this.n.setClassName(`shadow${M}`),this.r.setClassName(`shadow${_}`),this.s.setClassName(`shadow${x}${_}${M}`)}}W(){this.y=!0,this.$()}X(){this.y=!1,this.ab()}Y(R){this.J=!1,this.ab()}Z(R){this.J=!0,this.$()}$(){this.c.beginReveal(),this.g.beginReveal(),this.bb()}ab(){!this.J&&!this.y&&(this.c.beginHide(),this.g.beginHide())}bb(){!this.J&&!this.y&&this.L.cancelAndSet(()=>this.ab(),e)}}t.$MQ=r;class b extends r{constructor(R,g){g=g||{},g.mouseWheelSmoothScroll=!1;const y=new a.$2r({forceIntegerValues:!0,smoothScrollDuration:0,scheduleAtNextAnimationFrame:M=>N.$aP(N.$IP(R),M)});super(R,g,y),this.B(y)}setScrollPosition(R){this.b.setScrollPositionNow(R)}getScrollPosition(){return this.b.getCurrentScrollPosition()}}t.$NQ=b;class u extends r{constructor(R,g,y){super(R,g,y)}setScrollPosition(R){R.reuseAnimation?this.b.setScrollPositionSmooth(R,R.reuseAnimation):this.b.setScrollPositionNow(R)}getScrollPosition(){return this.b.getCurrentScrollPosition()}}t.$OQ=u;class o extends r{constructor(R,g){g=g||{},g.mouseWheelSmoothScroll=!1;const y=new a.$2r({forceIntegerValues:!1,smoothScrollDuration:0,scheduleAtNextAnimationFrame:M=>N.$aP(N.$IP(R),M)});super(R,g,y),this.B(y),this.cb=R,this.B(this.onScroll(M=>{M.scrollTopChanged&&(this.cb.scrollTop=M.scrollTop),M.scrollLeftChanged&&(this.cb.scrollLeft=M.scrollLeft)})),this.scanDomNode()}setScrollPosition(R){this.b.setScrollPositionNow(R)}getScrollPosition(){return this.b.getCurrentScrollPosition()}scanDomNode(){this.setScrollDimensions({width:this.cb.clientWidth,scrollWidth:this.cb.scrollWidth,height:this.cb.clientHeight,scrollHeight:this.cb.scrollHeight}),this.setScrollPosition({scrollLeft:this.cb.scrollLeft,scrollTop:this.cb.scrollTop})}}t.$PQ=o;function F(z){const R={lazyRender:typeof z.lazyRender<"u"?z.lazyRender:!1,className:typeof z.className<"u"?z.className:"",useShadows:typeof z.useShadows<"u"?z.useShadows:!0,handleMouseWheel:typeof z.handleMouseWheel<"u"?z.handleMouseWheel:!0,flipAxes:typeof z.flipAxes<"u"?z.flipAxes:!1,consumeMouseWheelIfScrollbarIsNeeded:typeof z.consumeMouseWheelIfScrollbarIsNeeded<"u"?z.consumeMouseWheelIfScrollbarIsNeeded:!1,alwaysConsumeMouseWheel:typeof z.alwaysConsumeMouseWheel<"u"?z.alwaysConsumeMouseWheel:!1,scrollYToX:typeof z.scrollYToX<"u"?z.scrollYToX:!1,mouseWheelScrollSensitivity:typeof z.mouseWheelScrollSensitivity<"u"?z.mouseWheelScrollSensitivity:1,fastScrollSensitivity:typeof z.fastScrollSensitivity<"u"?z.fastScrollSensitivity:5,scrollPredominantAxis:typeof z.scrollPredominantAxis<"u"?z.scrollPredominantAxis:!0,mouseWheelSmoothScroll:typeof z.mouseWheelSmoothScroll<"u"?z.mouseWheelSmoothScroll:!0,arrowSize:typeof z.arrowSize<"u"?z.arrowSize:11,listenOnDomNode:typeof z.listenOnDomNode<"u"?z.listenOnDomNode:null,horizontal:typeof z.horizontal<"u"?z.horizontal:1,horizontalScrollbarSize:typeof z.horizontalScrollbarSize<"u"?z.horizontalScrollbarSize:10,horizontalSliderSize:typeof z.horizontalSliderSize<"u"?z.horizontalSliderSize:0,horizontalHasArrows:typeof z.horizontalHasArrows<"u"?z.horizontalHasArrows:!1,vertical:typeof z.vertical<"u"?z.vertical:1,verticalScrollbarSize:typeof z.verticalScrollbarSize<"u"?z.verticalScrollbarSize:10,verticalHasArrows:typeof z.verticalHasArrows<"u"?z.verticalHasArrows:!1,verticalSliderSize:typeof z.verticalSliderSize<"u"?z.verticalSliderSize:0,scrollByPage:typeof z.scrollByPage<"u"?z.scrollByPage:!1};return R.horizontalSliderSize=typeof z.horizontalSliderSize<"u"?z.horizontalSliderSize:R.horizontalScrollbarSize,R.verticalSliderSize=typeof z.verticalSliderSize<"u"?z.verticalSliderSize:R.verticalScrollbarSize,s.$j&&(R.className+=" mac"),R}}),define(be[61],pe([1,0,54,3,22,24,60,11,9,26,4,2,47,48,82,119,6]),function(ae,t,v,N,i,U,w,D,c,f,d,T,s,a,e,h,l){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$hR=t.$gR=t.$fR=t.$eR=void 0;const m={CurrentDragAndDropData:void 0},n={useShadows:!0,verticalScrollMode:1,setRowLineHeight:!0,setRowHeight:!0,supportDynamicHeights:!1,dnd:{getDragElements(R){return[R]},getDragURI(){return null},onDragStart(){},onDragOver(){return!1},drop(){},dispose(){}},horizontalScrolling:!1,transformOptimization:!0,alwaysConsumeMouseWheel:!0};class r{get context(){return this.d}set context(g){this.d=g}constructor(g){this.elements=g}update(){}getData(){return this.elements}}t.$eR=r;class b{constructor(g){this.elements=g}update(){}getData(){return this.elements}}t.$fR=b;class u{constructor(){this.types=[],this.files=[]}update(g){if(g.types&&this.types.splice(0,this.types.length,...g.types),g.files){this.files.splice(0,this.files.length);for(let y=0;y<g.files.length;y++){const M=g.files.item(y);M&&(M.size||M.type)&&this.files.push(M)}}}getData(){return{types:this.types,files:this.files}}}t.$gR=u;function o(R,g){return Array.isArray(R)&&Array.isArray(g)?(0,D.$tb)(R,g):R===g}class F{constructor(g){g?.getSetSize?this.getSetSize=g.getSetSize.bind(g):this.getSetSize=(y,M,_)=>_,g?.getPosInSet?this.getPosInSet=g.getPosInSet.bind(g):this.getPosInSet=(y,M)=>M+1,g?.getRole?this.getRole=g.getRole.bind(g):this.getRole=y=>"listitem",g?.isChecked?this.isChecked=g.isChecked.bind(g):this.isChecked=y=>{}}}class z{static{this.c=0}get contentHeight(){return this.g.size}get contentWidth(){return this.E??0}get onDidScroll(){return this.q.onScroll}get onWillScroll(){return this.q.onWillScroll}get containerDomNode(){return this.o}get scrollableElementDomNode(){return this.q.getDomNode()}get P(){return this.O}set P(g){if(g!==this.O){if(g&&this.B)throw new Error("Horizontal scrolling and dynamic heights not supported simultaneously");if(this.O=g,this.domNode.classList.toggle("horizontal-scrolling",this.O),this.O){for(const y of this.d)this.Y(y);this.V(),this.q.setScrollDimensions({width:(0,N.$pP)(this.domNode)}),this.o.style.width=`${Math.max(this.E||0,this.n)}px`}else this.u.cancel(),this.q.setScrollDimensions({width:this.n,scrollWidth:this.n}),this.o.style.width=""}}constructor(g,y,M,_=n){if(this.Q=y,this.domId=`list_id_${++z.c}`,this.j=new Map,this.n=0,this.s=0,this.t=null,this.u=new c.$Ug(50),this.v=!1,this.x=T.$Rc.None,this.y=0,this.G=!1,this.J=T.$Rc.None,this.K=T.$Rc.None,this.L=new T.$Qc,this.M=new d.$Rd,this.N=new d.$Rd,this.onDidChangeContentHeight=d.Event.latch(this.M.event,void 0,this.L),this.onDidChangeContentWidth=d.Event.latch(this.N.event,void 0,this.L),this.O=!1,_.horizontalScrolling&&_.supportDynamicHeights)throw new Error("Horizontal scrolling and dynamic heights not supported simultaneously");this.d=[],this.f=0,this.g=new e.$cR(_.paddingTop??0);for(const O of M)this.j.set(O.templateId,O);this.h=this.L.add(new h.$dR(this.j)),this.k=0,this.m=0,this.domNode=document.createElement("div"),this.domNode.className="monaco-list",this.domNode.classList.add(this.domId),this.domNode.tabIndex=0,this.domNode.classList.toggle("mouse-support",typeof _.mouseSupport=="boolean"?_.mouseSupport:!0),this.O=_.horizontalScrolling??n.horizontalScrolling,this.domNode.classList.toggle("horizontal-scrolling",this.O),this.C=typeof _.paddingBottom>"u"?0:_.paddingBottom,this.D=new F(_.accessibilityProvider),this.o=document.createElement("div"),this.o.className="monaco-list-rows",(_.transformOptimization??n.transformOptimization)&&(this.o.style.transform="translate3d(0px, 0px, 0px)",this.o.style.overflow="hidden",this.o.style.contain="strict"),this.L.add(U.$zQ.addTarget(this.o)),this.p=this.L.add(new a.$2r({forceIntegerValues:!0,smoothScrollDuration:_.smoothScrolling??!1?125:0,scheduleAtNextAnimationFrame:O=>(0,N.$aP)((0,N.$IP)(this.domNode),O)})),this.q=this.L.add(new w.$OQ(this.o,{alwaysConsumeMouseWheel:_.alwaysConsumeMouseWheel??n.alwaysConsumeMouseWheel,horizontal:1,vertical:_.verticalScrollMode??n.verticalScrollMode,useShadows:_.useShadows??n.useShadows,mouseWheelScrollSensitivity:_.mouseWheelScrollSensitivity,fastScrollSensitivity:_.fastScrollSensitivity,scrollByPage:_.scrollByPage},this.p)),this.domNode.appendChild(this.q.getDomNode()),g.appendChild(this.domNode),this.q.onScroll(this.gb,this,this.L),this.L.add((0,N.$3O)(this.o,U.EventType.Change,O=>this.hb(O))),this.L.add((0,N.$3O)(this.q.getDomNode(),"scroll",O=>O.target.scrollTop=0)),this.L.add((0,N.$3O)(this.domNode,"dragover",O=>this.jb(this.fb(O)))),this.L.add((0,N.$3O)(this.domNode,"drop",O=>this.lb(this.fb(O)))),this.L.add((0,N.$3O)(this.domNode,"dragleave",O=>this.kb(this.fb(O)))),this.L.add((0,N.$3O)(this.domNode,"dragend",O=>this.mb(O))),this.z=_.setRowLineHeight??n.setRowLineHeight,this.A=_.setRowHeight??n.setRowHeight,this.B=_.supportDynamicHeights??n.supportDynamicHeights,this.F=_.dnd??this.L.add(n.dnd),this.layout(_.initialSize?.height,_.initialSize?.width)}updateOptions(g){g.paddingBottom!==void 0&&(this.C=g.paddingBottom,this.q.setScrollDimensions({scrollHeight:this.scrollHeight})),g.smoothScrolling!==void 0&&this.p.setSmoothScrollDuration(g.smoothScrolling?125:0),g.horizontalScrolling!==void 0&&(this.P=g.horizontalScrolling);let y;if(g.scrollByPage!==void 0&&(y={...y??{},scrollByPage:g.scrollByPage}),g.mouseWheelScrollSensitivity!==void 0&&(y={...y??{},mouseWheelScrollSensitivity:g.mouseWheelScrollSensitivity}),g.fastScrollSensitivity!==void 0&&(y={...y??{},fastScrollSensitivity:g.fastScrollSensitivity}),y&&this.q.updateOptions(y),g.paddingTop!==void 0&&g.paddingTop!==this.g.paddingTop){const M=this.sb(this.k,this.m),_=g.paddingTop-this.g.paddingTop;this.g.paddingTop=g.paddingTop,this.W(M,Math.max(0,this.k+_),this.m,void 0,void 0,!0),this.setScrollTop(this.k),this.S(),this.B&&this.tb(this.k,this.m)}}delegateScrollFromMouseWheelEvent(g){this.q.delegateScrollFromMouseWheelEvent(g)}delegateVerticalScrollbarPointerDown(g){this.q.delegateVerticalScrollbarPointerDown(g)}updateElementHeight(g,y,M){if(g<0||g>=this.d.length)return;const _=this.d[g].size;if(typeof y>"u"){if(!this.B){console.warn("Dynamic heights not supported");return}this.d[g].lastDynamicHeightWidth=void 0,y=_+this.ub(g)}if(_===y)return;const x=this.sb(this.k,this.m);let O=0;g<x.start||M!==null&&M>g&&M<x.end?O=y-_:O=0,this.g.splice(g,1,[{size:y}]),this.d[g].size=y,this.W(x,Math.max(0,this.k+O),this.m,void 0,void 0,!0),this.setScrollTop(this.k),this.S(),this.B&&this.tb(this.k,this.m)}splice(g,y,M=[]){if(this.v)throw new Error("Can't run recursive splices.");this.v=!0;try{return this.R(g,y,M)}finally{this.v=!1,this.M.fire(this.contentHeight)}}R(g,y,M=[]){const _=this.sb(this.k,this.m),x={start:g,end:g+y},O=s.Range.intersect(_,x),B=new Map;for(let V=O.end-1;V>=O.start;V--){const Y=this.d[V];if(Y.dragStartDisposable.dispose(),Y.checkedDisposable.dispose(),Y.row){let C=B.get(Y.templateId);C||(C=[],B.set(Y.templateId,C));const q=this.j.get(Y.templateId);q&&q.disposeElement&&q.disposeElement(Y.element,V,Y.row.templateData,Y.size),C.push(Y.row)}Y.row=null}const j={start:g+y,end:this.d.length},ie=s.Range.intersect(j,_),te=s.Range.relativeComplement(j,_),ce=M.map(V=>({id:String(this.f++),element:V,templateId:this.Q.getTemplateId(V),size:this.Q.getHeight(V),width:void 0,hasDynamicHeight:!!this.Q.hasDynamicHeight&&this.Q.hasDynamicHeight(V),lastDynamicHeightWidth:void 0,row:null,uri:void 0,dropTarget:!1,dragStartDisposable:T.$Rc.None,checkedDisposable:T.$Rc.None}));let le;g===0&&y>=this.d.length?(this.g=new e.$cR(this.g.paddingTop),this.g.splice(0,0,ce),le=this.d,this.d=ce):(this.g.splice(g,y,ce),le=this.d.splice(g,y,...ce));const oe=M.length-y,we=this.sb(this.k,this.m),Pe=(0,e.$aR)(ie,oe),Ae=s.Range.intersect(we,Pe);for(let V=Ae.start;V<Ae.end;V++)this.Z(this.d[V],V);const Re=s.Range.relativeComplement(Pe,we);for(const V of Re)for(let Y=V.start;Y<V.end;Y++)this.ab(Y);const de=te.map(V=>(0,e.$aR)(V,oe)),fe=[{start:g,end:g+M.length},...de].map(V=>s.Range.intersect(we,V)),Z=this.vb(fe);for(const V of fe)for(let Y=V.start;Y<V.end;Y++){const C=this.d[Y],$=B.get(C.templateId)?.pop();this.X(Y,Z,$)}for(const V of B.values())for(const Y of V)this.h.release(Y);return this.S(),this.B&&this.tb(this.scrollTop,this.renderHeight),le.map(V=>V.element)}S(){this.s=this.contentHeight,this.o.style.height=`${this.s}px`,this.t||(this.t=(0,N.$aP)((0,N.$IP)(this.domNode),()=>{this.q.setScrollDimensions({scrollHeight:this.scrollHeight}),this.V(),this.t=null}))}U(){if(!this.P){this.u.cancel();return}this.u.trigger(()=>this.V())}V(){if(!this.P)return;let g=0;for(const y of this.d)typeof y.width<"u"&&(g=Math.max(g,y.width));this.E=g,this.q.setScrollDimensions({scrollWidth:g===0?0:g+10}),this.N.fire(this.E)}updateWidth(g){if(!this.P||typeof this.E>"u")return;const y=this.d[g];this.Y(y),typeof y.width<"u"&&y.width>this.E&&(this.E=y.width,this.q.setScrollDimensions({scrollWidth:this.E+10}),this.N.fire(this.E))}rerender(){if(this.B){for(const g of this.d)g.lastDynamicHeightWidth=void 0;this.tb(this.k,this.m)}}get length(){return this.d.length}get renderHeight(){return this.q.getScrollDimensions().height}get firstVisibleIndex(){const g=this.sb(this.k,this.m),y=this.g.positionAt(g.start),M=this.g.positionAt(g.start+1);return M!==-1&&(M-y)/2+y<this.scrollTop?g.start+1:g.start}get lastVisibleIndex(){return this.sb(this.k,this.m).end-1}element(g){return this.d[g].element}indexOf(g){return this.d.findIndex(y=>y.element===g)}domElement(g){const y=this.d[g].row;return y&&y.domNode}elementHeight(g){return this.d[g].size}elementTop(g){return this.g.positionAt(g)}indexAt(g){return this.g.indexAt(g)}indexAfter(g){return this.g.indexAfter(g)}layout(g,y){const M={height:typeof g=="number"?g:(0,N.$rP)(this.domNode)};this.t&&(this.t.dispose(),this.t=null,M.scrollHeight=this.scrollHeight),this.q.setScrollDimensions(M),typeof y<"u"&&(this.n=y,this.B&&this.tb(this.scrollTop,this.renderHeight)),this.P&&this.q.setScrollDimensions({width:typeof y=="number"?y:(0,N.$pP)(this.domNode)})}W(g,y,M,_,x,O=!1){const B=this.sb(y,M),j=s.Range.relativeComplement(B,g),ie=s.Range.relativeComplement(g,B),te=this.vb(j);if(O){const ce=s.Range.intersect(g,B);for(let le=ce.start;le<ce.end;le++)this.Z(this.d[le],le)}this.h.transact(()=>{for(const ce of ie)for(let le=ce.start;le<ce.end;le++)this.ab(le);for(const ce of j)for(let le=ce.start;le<ce.end;le++)this.X(le,te)}),_!==void 0&&(this.o.style.left=`-${_}px`),this.o.style.top=`-${y}px`,this.P&&x!==void 0&&(this.o.style.width=`${Math.max(x,this.n)}px`),this.k=y,this.m=M}X(g,y,M){const _=this.d[g];let x=!1;if(!_.row)if(M)_.row=M;else{const te=this.h.alloc(_.templateId);_.row=te.row,x=te.isReusingConnectedDomNode}const O=this.D.getRole(_.element)||"listitem";_.row.domNode.setAttribute("role",O);const B=this.D.isChecked(_.element);if(typeof B=="boolean")_.row.domNode.setAttribute("aria-checked",String(!!B));else if(B){const te=ce=>_.row.domNode.setAttribute("aria-checked",String(!!ce));te(B.value),_.checkedDisposable=B.onDidChange(te)}(x||!_.row.domNode.parentElement)&&(y?this.o.insertBefore(_.row.domNode,y):this.o.appendChild(_.row.domNode)),this.Z(_,g);const j=this.j.get(_.templateId);if(!j)throw new Error(`No renderer found for template id ${_.templateId}`);j?.renderElement(_.element,g,_.row.templateData,_.size);const ie=this.F.getDragURI(_.element);_.dragStartDisposable.dispose(),_.row.domNode.draggable=!!ie,ie&&(_.dragStartDisposable=(0,N.$3O)(_.row.domNode,"dragstart",te=>this.ib(_.element,ie,te))),this.P&&(this.Y(_),this.U())}Y(g){if(!g.row||!g.row.domNode)return;g.row.domNode.style.width="fit-content",g.width=(0,N.$pP)(g.row.domNode);const y=(0,N.$IP)(g.row.domNode).getComputedStyle(g.row.domNode);y.paddingLeft&&(g.width+=parseFloat(y.paddingLeft)),y.paddingRight&&(g.width+=parseFloat(y.paddingRight)),g.row.domNode.style.width=""}Z(g,y){g.row.domNode.style.top=`${this.elementTop(y)}px`,this.A&&(g.row.domNode.style.height=`${g.size}px`),this.z&&(g.row.domNode.style.lineHeight=`${g.size}px`),g.row.domNode.setAttribute("data-index",`${y}`),g.row.domNode.setAttribute("data-last-element",y===this.length-1?"true":"false"),g.row.domNode.setAttribute("data-parity",y%2===0?"even":"odd"),g.row.domNode.setAttribute("aria-setsize",String(this.D.getSetSize(g.element,y,this.length))),g.row.domNode.setAttribute("aria-posinset",String(this.D.getPosInSet(g.element,y))),g.row.domNode.setAttribute("id",this.getElementDomId(y)),g.row.domNode.classList.toggle("drop-target",g.dropTarget)}ab(g){const y=this.d[g];if(y.dragStartDisposable.dispose(),y.checkedDisposable.dispose(),y.row){const M=this.j.get(y.templateId);M&&M.disposeElement&&M.disposeElement(y.element,g,y.row.templateData,y.size),this.h.release(y.row),y.row=null}this.P&&this.U()}getScrollTop(){return this.q.getScrollPosition().scrollTop}setScrollTop(g,y){this.t&&(this.t.dispose(),this.t=null,this.q.setScrollDimensions({scrollHeight:this.scrollHeight})),this.q.setScrollPosition({scrollTop:g,reuseAnimation:y})}getScrollLeft(){return this.q.getScrollPosition().scrollLeft}setScrollLeft(g){this.t&&(this.t.dispose(),this.t=null,this.q.setScrollDimensions({scrollWidth:this.E})),this.q.setScrollPosition({scrollLeft:g})}get scrollTop(){return this.getScrollTop()}set scrollTop(g){this.setScrollTop(g)}get scrollHeight(){return this.s+(this.P?10:0)+this.C}get onMouseClick(){return d.Event.map(this.L.add(new i.$4Q(this.domNode,"click")).event,g=>this.bb(g),this.L)}get onMouseDblClick(){return d.Event.map(this.L.add(new i.$4Q(this.domNode,"dblclick")).event,g=>this.bb(g),this.L)}get onMouseMiddleClick(){return d.Event.filter(d.Event.map(this.L.add(new i.$4Q(this.domNode,"auxclick")).event,g=>this.bb(g),this.L),g=>g.browserEvent.button===1,this.L)}get onMouseUp(){return d.Event.map(this.L.add(new i.$4Q(this.domNode,"mouseup")).event,g=>this.bb(g),this.L)}get onMouseDown(){return d.Event.map(this.L.add(new i.$4Q(this.domNode,"mousedown")).event,g=>this.bb(g),this.L)}get onMouseOver(){return d.Event.map(this.L.add(new i.$4Q(this.domNode,"mouseover")).event,g=>this.bb(g),this.L)}get onMouseMove(){return d.Event.map(this.L.add(new i.$4Q(this.domNode,"mousemove")).event,g=>this.bb(g),this.L)}get onMouseOut(){return d.Event.map(this.L.add(new i.$4Q(this.domNode,"mouseout")).event,g=>this.bb(g),this.L)}get onContextMenu(){return d.Event.any(d.Event.map(this.L.add(new i.$4Q(this.domNode,"contextmenu")).event,g=>this.bb(g),this.L),d.Event.map(this.L.add(new i.$4Q(this.domNode,U.EventType.Contextmenu)).event,g=>this.eb(g),this.L))}get onTouchStart(){return d.Event.map(this.L.add(new i.$4Q(this.domNode,"touchstart")).event,g=>this.db(g),this.L)}get onTap(){return d.Event.map(this.L.add(new i.$4Q(this.o,U.EventType.Tap)).event,g=>this.eb(g),this.L)}bb(g){const y=this.rb(g.target||null),M=typeof y>"u"?void 0:this.d[y],_=M&&M.element;return{browserEvent:g,index:y,element:_}}db(g){const y=this.rb(g.target||null),M=typeof y>"u"?void 0:this.d[y],_=M&&M.element;return{browserEvent:g,index:y,element:_}}eb(g){const y=this.rb(g.initialTarget||null),M=typeof y>"u"?void 0:this.d[y],_=M&&M.element;return{browserEvent:g,index:y,element:_}}fb(g){const y=this.rb(g.target||null),M=typeof y>"u"?void 0:this.d[y],_=M&&M.element;return{browserEvent:g,index:y,element:_}}gb(g){try{const y=this.sb(this.k,this.m);this.W(y,g.scrollTop,g.height,g.scrollLeft,g.scrollWidth),this.B&&this.tb(g.scrollTop,g.height,g.inSmoothScrolling)}catch(y){throw console.error("Got bad scroll event:",g),y}}hb(g){g.preventDefault(),g.stopPropagation(),this.scrollTop-=g.translationY}ib(g,y,M){if(!M.dataTransfer)return;const _=this.F.getDragElements(g);if(M.dataTransfer.effectAllowed="copyMove",M.dataTransfer.setData(v.$xQ.TEXT,y),M.dataTransfer.setDragImage){let x;this.F.getDragLabel&&(x=this.F.getDragLabel(_,M)),typeof x>"u"&&(x=String(_.length));const O=(0,N.$)(".monaco-drag-image");O.textContent=x;const j=(ie=>{for(;ie&&!ie.classList.contains("monaco-workbench");)ie=ie.parentElement;return ie||this.domNode.ownerDocument})(this.domNode);j.appendChild(O),M.dataTransfer.setDragImage(O,-10,-10),setTimeout(()=>j.removeChild(O),0)}this.domNode.classList.add("dragging"),this.H=new r(_),m.CurrentDragAndDropData=new b(_),this.F.onDragStart?.(this.H,M)}jb(g){if(g.browserEvent.preventDefault(),this.K.dispose(),m.CurrentDragAndDropData&&m.CurrentDragAndDropData.getData()==="vscode-ui"||(this.ob(g.browserEvent),!g.browserEvent.dataTransfer))return!1;if(!this.H)if(m.CurrentDragAndDropData)this.H=m.CurrentDragAndDropData;else{if(!g.browserEvent.dataTransfer.types)return!1;this.H=new u}const y=this.F.onDragOver(this.H,g.element,g.index,g.browserEvent);if(this.G=typeof y=="boolean"?y:y.accept,!this.G)return this.I=void 0,this.J.dispose(),!1;g.browserEvent.dataTransfer.dropEffect=typeof y!="boolean"&&y.effect===0?"copy":"move";let M;if(typeof y!="boolean"&&y.feedback?M=y.feedback:typeof g.index>"u"?M=[-1]:M=[g.index],M=(0,D.$Lb)(M).filter(_=>_>=-1&&_<this.length).sort((_,x)=>_-x),M=M[0]===-1?[-1]:M,o(this.I,M))return!0;if(this.I=M,this.J.dispose(),M[0]===-1)this.domNode.classList.add("drop-target"),this.o.classList.add("drop-target"),this.J=(0,T.$Pc)(()=>{this.domNode.classList.remove("drop-target"),this.o.classList.remove("drop-target")});else{for(const _ of M){const x=this.d[_];x.dropTarget=!0,x.row?.domNode.classList.add("drop-target")}this.J=(0,T.$Pc)(()=>{for(const _ of M){const x=this.d[_];x.dropTarget=!1,x.row?.domNode.classList.remove("drop-target")}})}return!0}kb(g){this.K.dispose(),this.K=(0,c.$Zg)(()=>this.nb(),100,this.L),this.H&&this.F.onDragLeave?.(this.H,g.element,g.index,g.browserEvent)}lb(g){if(!this.G)return;const y=this.H;this.qb(),this.nb(),this.domNode.classList.remove("dragging"),this.H=void 0,m.CurrentDragAndDropData=void 0,!(!y||!g.browserEvent.dataTransfer)&&(g.browserEvent.preventDefault(),y.update(g.browserEvent.dataTransfer),this.F.drop(y,g.element,g.index,g.browserEvent))}mb(g){this.G=!1,this.qb(),this.nb(),this.domNode.classList.remove("dragging"),this.H=void 0,m.CurrentDragAndDropData=void 0,this.F.onDragEnd?.(g)}nb(){this.I=void 0,this.J.dispose(),this.J=T.$Rc.None}ob(g){if(!this.w){const y=(0,N.$jP)(this.domNode).top;this.w=(0,N.$fQ)((0,N.$IP)(this.domNode),this.pb.bind(this,y))}this.x.dispose(),this.x=(0,c.$Zg)(()=>{this.w&&(this.w.dispose(),this.w=void 0)},1e3,this.L),this.y=g.pageY}pb(g){if(this.y===void 0)return;const y=this.y-g,M=this.renderHeight-35;y<35?this.scrollTop+=Math.max(-14,Math.floor(.3*(y-35))):y>M&&(this.scrollTop+=Math.min(14,Math.floor(.3*(y-M))))}qb(){this.x.dispose(),this.w&&(this.w.dispose(),this.w=void 0)}rb(g){const y=this.q.getDomNode();let M=g;for(;M instanceof HTMLElement&&M!==this.o&&y.contains(M);){const _=M.getAttribute("data-index");if(_){const x=Number(_);if(!isNaN(x))return x}M=M.parentElement}}sb(g,y){return{start:this.g.indexAt(g),end:this.g.indexAfter(g+y-1)}}tb(g,y,M){const _=this.sb(g,y);let x,O;g===this.elementTop(_.start)?(x=_.start,O=0):_.end-_.start>1&&(x=_.start+1,O=this.elementTop(x)-g);let B=0;for(;;){const j=this.sb(g,y);let ie=!1;for(let te=j.start;te<j.end;te++){const ce=this.ub(te);ce!==0&&this.g.splice(te,1,[this.d[te]]),B+=ce,ie=ie||ce!==0}if(!ie){B!==0&&this.S();const te=s.Range.relativeComplement(_,j);for(const le of te)for(let oe=le.start;oe<le.end;oe++)this.d[oe].row&&this.ab(oe);const ce=s.Range.relativeComplement(j,_);for(const le of ce)for(let oe=le.start;oe<le.end;oe++){const we=oe+1,Pe=we<this.d.length?this.d[we].row:null,Ae=Pe?Pe.domNode:null;this.X(oe,Ae)}for(let le=j.start;le<j.end;le++)this.d[le].row&&this.Z(this.d[le],le);if(typeof x=="number"){const le=this.p.getFutureScrollPosition().scrollTop-g,oe=this.elementTop(x)-O+le;this.setScrollTop(oe,M)}this.M.fire(this.contentHeight);return}}}ub(g){const y=this.d[g];if(this.Q.getDynamicHeight){const O=this.Q.getDynamicHeight(y.element);if(O!==null){const B=y.size;return y.size=O,y.lastDynamicHeightWidth=this.n,O-B}}if(!y.hasDynamicHeight||y.lastDynamicHeightWidth===this.n||this.Q.hasDynamicHeight&&!this.Q.hasDynamicHeight(y.element))return 0;const M=y.size;if(y.row)return y.row.domNode.style.height="",y.size=y.row.domNode.offsetHeight,y.lastDynamicHeightWidth=this.n,y.size-M;const{row:_}=this.h.alloc(y.templateId);_.domNode.style.height="",this.o.appendChild(_.domNode);const x=this.j.get(y.templateId);if(!x)throw new l.$bb("Missing renderer for templateId: "+y.templateId);return x.renderElement(y.element,g,_.templateData,void 0),y.size=_.domNode.offsetHeight,x.disposeElement?.(y.element,g,_.templateData,void 0),this.Q.setDynamicHeight?.(y.element,y.size),y.lastDynamicHeightWidth=this.n,this.o.removeChild(_.domNode),this.h.release(_),y.size-M}vb(g){const y=g[g.length-1];if(!y)return null;const M=this.d[y.end];return!M||!M.row?null:M.row.domNode}getElementDomId(g){return`${this.domId}_${g}`}dispose(){for(const g of this.d)if(g.dragStartDisposable.dispose(),g.checkedDisposable.dispose(),g.row){const y=this.j.get(g.row.templateId);y&&(y.disposeElement?.(g.element,-1,g.row.templateData,void 0),y.disposeTemplate(g.row.templateData))}this.d=[],this.domNode&&this.domNode.parentNode&&this.domNode.parentNode.removeChild(this.domNode),this.w?.dispose(),this.L.dispose()}}t.$hR=z,Xe([f.$nh],z.prototype,"onMouseClick",null),Xe([f.$nh],z.prototype,"onMouseDblClick",null),Xe([f.$nh],z.prototype,"onMouseMiddleClick",null),Xe([f.$nh],z.prototype,"onMouseUp",null),Xe([f.$nh],z.prototype,"onMouseDown",null),Xe([f.$nh],z.prototype,"onMouseOver",null),Xe([f.$nh],z.prototype,"onMouseMove",null),Xe([f.$nh],z.prototype,"onMouseOut",null),Xe([f.$nh],z.prototype,"onContextMenu",null),Xe([f.$nh],z.prototype,"onTouchStart",null),Xe([f.$nh],z.prototype,"onTap",null)}),define(be[39],pe([1,0,3,22,14,24,57,71,11,9,74,26,4,34,2,46,5,7,70,61,19,97]),function(ae,t,v,N,i,U,w,D,c,f,d,T,s,a,e,h,l,m,n,r,b){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$rR=t.$qR=t.$pR=t.$oR=t.$nR=t.$mR=t.$lR=t.TypeNavigationMode=t.$kR=t.$jR=t.$iR=void 0;class u{constructor(C){this.d=C,this.c=[]}get templateId(){return`template:${this.d.name}`}renderTemplate(C){return C}renderElement(C,q,$){const W=this.c.findIndex(Q=>Q.templateData===$);if(W>=0){const Q=this.c[W];this.d.unrender($),Q.index=q}else{const Q={index:q,templateData:$};this.c.push(Q)}this.d.renderIndex(q,$)}splice(C,q,$){const W=[];for(const Q of this.c)Q.index<C?W.push(Q):Q.index>=C+q&&W.push({index:Q.index+$-q,templateData:Q.templateData});this.c=W}renderIndexes(C){for(const{index:q,templateData:$}of this.c)C.indexOf(q)>-1&&this.d.renderIndex(q,$)}disposeTemplate(C){const q=this.c.findIndex($=>$.templateData===C);q<0||this.c.splice(q,1)}}class o{get name(){return this.h}get renderer(){return new u(this)}constructor(C){this.h=C,this.c=0,this.d=[],this.f=[],this.g=new s.$Rd,this.onChange=this.g.event}splice(C,q,$){q=Math.max(0,Math.min(q,this.c-C));const W=$.length-q,Q=C+q,p=[];let A=0;for(;A<this.f.length&&this.f[A]<C;)p.push(this.f[A++]);for(let I=0;I<$.length;I++)$[I]&&p.push(I+C);for(;A<this.f.length&&this.f[A]>=Q;)p.push(this.f[A++]+W);const E=this.c+W;if(this.f.length>0&&p.length===0&&E>0){const I=this.f.find(k=>k>=C)??E-1;p.push(Math.min(I,E-1))}this.renderer.splice(C,q,$.length),this.k(p,p),this.c=E}renderIndex(C,q){q.classList.toggle(this.h,this.contains(C))}unrender(C){C.classList.remove(this.h)}set(C,q){return this.k(C,[...C].sort(de),q)}k(C,q,$){const W=this.d,Q=this.f;this.d=C,this.f=q;const p=Ae(Q,C);return this.renderer.renderIndexes(p),this.g.fire({indexes:C,browserEvent:$}),W}get(){return this.d}contains(C){return(0,c.$vb)(this.f,C,de)>=0}dispose(){(0,e.$Mc)(this.g)}}Xe([T.$nh],o.prototype,"renderer",null);class F extends o{constructor(C){super("selected"),this.l=C}renderIndex(C,q){super.renderIndex(C,q),this.l&&(this.contains(C)?q.setAttribute("aria-selected","true"):q.setAttribute("aria-selected","false"))}}class z{constructor(C,q,$){this.c=C,this.d=q,this.f=$}splice(C,q,$){if(!this.f)return this.c.splice(C,q,new Array($.length).fill(!1));const W=this.c.get().map(A=>this.f.getId(this.d.element(A)).toString());if(W.length===0)return this.c.splice(C,q,new Array($.length).fill(!1));const Q=new Set(W),p=$.map(A=>Q.has(this.f.getId(A).toString()));this.c.splice(C,q,p)}}function R(Y){return Y.tagName==="INPUT"||Y.tagName==="TEXTAREA"}t.$iR=R;function g(Y){return Y.classList.contains("monaco-editor")?!0:Y.classList.contains("monaco-list")||!Y.parentElement?!1:g(Y.parentElement)}t.$jR=g;function y(Y){return Y.tagName==="A"&&Y.classList.contains("monaco-button")||Y.tagName==="DIV"&&Y.classList.contains("monaco-button-dropdown")?!0:Y.classList.contains("monaco-list")||!Y.parentElement?!1:y(Y.parentElement)}t.$kR=y;class M{get g(){return s.Event.chain(this.c.add(new N.$4Q(this.k.domNode,"keydown")).event,C=>C.filter(q=>!R(q.target)).map(q=>new i.$ZO(q)))}constructor(C,q,$){this.h=C,this.k=q,this.c=new e.$Qc,this.d=new e.$Qc,this.f=$.multipleSelectionSupport,this.c.add(this.g(W=>{switch(W.keyCode){case 3:return this.l(W);case 16:return this.o(W);case 18:return this.p(W);case 11:return this.q(W);case 12:return this.s(W);case 9:return this.u(W);case 31:this.f&&(l.$j?W.metaKey:W.ctrlKey)&&this.t(W)}}))}updateOptions(C){C.multipleSelectionSupport!==void 0&&(this.f=C.multipleSelectionSupport)}l(C){C.preventDefault(),C.stopPropagation(),this.h.setSelection(this.h.getFocus(),C.browserEvent)}o(C){C.preventDefault(),C.stopPropagation(),this.h.focusPrevious(1,!1,C.browserEvent);const q=this.h.getFocus()[0];this.h.setAnchor(q),this.h.reveal(q),this.k.domNode.focus()}p(C){C.preventDefault(),C.stopPropagation(),this.h.focusNext(1,!1,C.browserEvent);const q=this.h.getFocus()[0];this.h.setAnchor(q),this.h.reveal(q),this.k.domNode.focus()}q(C){C.preventDefault(),C.stopPropagation(),this.h.focusPreviousPage(C.browserEvent);const q=this.h.getFocus()[0];this.h.setAnchor(q),this.h.reveal(q),this.k.domNode.focus()}s(C){C.preventDefault(),C.stopPropagation(),this.h.focusNextPage(C.browserEvent);const q=this.h.getFocus()[0];this.h.setAnchor(q),this.h.reveal(q),this.k.domNode.focus()}t(C){C.preventDefault(),C.stopPropagation(),this.h.setSelection((0,c.$Rb)(this.h.length),C.browserEvent),this.h.setAnchor(void 0),this.k.domNode.focus()}u(C){this.h.getSelection().length&&(C.preventDefault(),C.stopPropagation(),this.h.setSelection([],C.browserEvent),this.h.setAnchor(void 0),this.k.domNode.focus())}dispose(){this.c.dispose(),this.d.dispose()}}Xe([T.$nh],M.prototype,"g",null);var _;(function(Y){Y[Y.Automatic=0]="Automatic",Y[Y.Trigger=1]="Trigger"})(_||(t.TypeNavigationMode=_={}));var x;(function(Y){Y[Y.Idle=0]="Idle",Y[Y.Typing=1]="Typing"})(x||(x={})),t.$lR=new class{mightProducePrintableCharacter(Y){return Y.ctrlKey||Y.metaKey||Y.altKey?!1:Y.keyCode>=31&&Y.keyCode<=56||Y.keyCode>=21&&Y.keyCode<=30||Y.keyCode>=98&&Y.keyCode<=107||Y.keyCode>=85&&Y.keyCode<=95}};class O{constructor(C,q,$,W,Q){this.o=C,this.p=q,this.q=$,this.s=W,this.t=Q,this.c=!1,this.d=x.Idle,this.f=_.Automatic,this.g=!1,this.h=-1,this.k=new e.$Qc,this.l=new e.$Qc,this.updateOptions(C.options)}updateOptions(C){C.typeNavigationEnabled??!0?this.u():this.v(),this.f=C.typeNavigationMode??_.Automatic}trigger(){this.g=!this.g}u(){if(this.c)return;let C=!1;const q=s.Event.chain(this.k.add(new N.$4Q(this.p.domNode,"keydown")).event,Q=>Q.filter(p=>!R(p.target)).filter(()=>this.f===_.Automatic||this.g).map(p=>new i.$ZO(p)).filter(p=>C||this.s(p)).filter(p=>this.t.mightProducePrintableCharacter(p)).forEach(p=>v.$XP.stop(p,!0)).map(p=>p.browserEvent.key)),$=s.Event.debounce(q,()=>null,800,void 0,void 0,void 0,this.k);s.Event.reduce(s.Event.any(q,$),(Q,p)=>p===null?null:(Q||"")+p,void 0,this.k)(this.x,this,this.k),$(this.w,this,this.k),q(()=>C=!0,void 0,this.k),$(()=>C=!1,void 0,this.k),this.c=!0,this.g=!1}v(){this.c&&(this.k.clear(),this.c=!1,this.g=!1)}w(){const C=this.o.getFocus();if(C.length>0&&C[0]===this.h){const q=this.o.options.accessibilityProvider?.getAriaLabel(this.o.element(C[0]));q&&(0,w.$6Q)(q)}this.h=-1}x(C){if(!C){this.d=x.Idle,this.g=!1;return}const q=this.o.getFocus(),$=q.length>0?q[0]:0,W=this.d===x.Idle?1:0;this.d=x.Typing;for(let Q=0;Q<this.o.length;Q++){const p=($+Q+W)%this.o.length,A=this.q.getKeyboardNavigationLabel(this.p.element(p)),E=A&&A.toString();if(this.o.options.typeNavigationEnabled){if(typeof E<"u"){if((0,a.$Jj)(C,E)){this.h=$,this.o.setFocus([p]),this.o.reveal(p);return}const I=(0,a.$Qj)(C,E);if(I&&I[0].end-I[0].start>1&&I.length===1){this.h=$,this.o.setFocus([p]),this.o.reveal(p);return}}}else if(typeof E>"u"||(0,a.$Jj)(C,E)){this.h=$,this.o.setFocus([p]),this.o.reveal(p);return}}}dispose(){this.v(),this.k.dispose(),this.l.dispose()}}class B{constructor(C,q){this.d=C,this.f=q,this.c=new e.$Qc;const $=s.Event.chain(this.c.add(new N.$4Q(q.domNode,"keydown")).event,Q=>Q.filter(p=>!R(p.target)).map(p=>new i.$ZO(p)));s.Event.chain($,Q=>Q.filter(p=>p.keyCode===2&&!p.ctrlKey&&!p.metaKey&&!p.shiftKey&&!p.altKey))(this.g,this,this.c)}g(C){if(C.target!==this.f.domNode)return;const q=this.d.getFocus();if(q.length===0)return;const $=this.f.domElement(q[0]);if(!$)return;const W=$.querySelector("[tabIndex]");if(!W||!(W instanceof HTMLElement)||W.tabIndex===-1)return;const Q=(0,v.$IP)(W).getComputedStyle(W);Q.visibility==="hidden"||Q.display==="none"||(C.preventDefault(),C.stopPropagation(),W.focus())}dispose(){this.c.dispose()}}function j(Y){return l.$j?Y.browserEvent.metaKey:Y.browserEvent.ctrlKey}t.$mR=j;function ie(Y){return Y.browserEvent.shiftKey}t.$nR=ie;function te(Y){return(0,v.$RP)(Y)&&Y.button===2}const ce={isSelectionSingleChangeEvent:j,isSelectionRangeChangeEvent:ie};class le{constructor(C){this.k=C,this.f=new e.$Qc,this.g=new s.$Rd,this.onPointer=this.g.event,C.options.multipleSelectionSupport!==!1&&(this.c=this.k.options.multipleSelectionController||ce),this.d=typeof C.options.mouseSupport>"u"||!!C.options.mouseSupport,this.d&&(C.onMouseDown(this.s,this,this.f),C.onContextMenu(this.t,this,this.f),C.onMouseDblClick(this.v,this,this.f),C.onTouchStart(this.s,this,this.f),this.f.add(U.$zQ.addTarget(C.getHTMLElement()))),s.Event.any(C.onMouseClick,C.onMouseMiddleClick,C.onTap)(this.u,this,this.f)}updateOptions(C){C.multipleSelectionSupport!==void 0&&(this.c=void 0,C.multipleSelectionSupport&&(this.c=this.k.options.multipleSelectionController||ce))}o(C){return this.c?this.c.isSelectionSingleChangeEvent(C):!1}p(C){return this.c?this.c.isSelectionRangeChangeEvent(C):!1}q(C){return this.o(C)||this.p(C)}s(C){g(C.browserEvent.target)||(0,v.$CP)()!==C.browserEvent.target&&this.k.domFocus()}t(C){if(R(C.browserEvent.target)||g(C.browserEvent.target))return;const q=typeof C.index>"u"?[]:[C.index];this.k.setFocus(q,C.browserEvent)}u(C){if(!this.d||R(C.browserEvent.target)||g(C.browserEvent.target)||C.browserEvent.isHandledByList)return;C.browserEvent.isHandledByList=!0;const q=C.index;if(typeof q>"u"){this.k.setFocus([],C.browserEvent),this.k.setSelection([],C.browserEvent),this.k.setAnchor(void 0);return}if(this.q(C))return this.w(C);this.k.setFocus([q],C.browserEvent),this.k.setAnchor(q),te(C.browserEvent)||this.k.setSelection([q],C.browserEvent),this.g.fire(C)}v(C){if(R(C.browserEvent.target)||g(C.browserEvent.target)||this.q(C)||C.browserEvent.isHandledByList)return;C.browserEvent.isHandledByList=!0;const q=this.k.getFocus();this.k.setSelection(q,C.browserEvent)}w(C){const q=C.index;let $=this.k.getAnchor();if(this.p(C)){typeof $>"u"&&($=this.k.getFocus()[0]??q,this.k.setAnchor($));const W=Math.min($,q),Q=Math.max($,q),p=(0,c.$Rb)(W,Q+1),A=this.k.getSelection(),E=Pe(Ae(A,[$]),$);if(E.length===0)return;const I=Ae(p,Re(A,E));this.k.setSelection(I,C.browserEvent),this.k.setFocus([q],C.browserEvent)}else if(this.o(C)){const W=this.k.getSelection(),Q=W.filter(p=>p!==q);this.k.setFocus([q]),this.k.setAnchor(q),W.length===Q.length?this.k.setSelection([...Q,q],C.browserEvent):this.k.setSelection(Q,C.browserEvent)}}dispose(){this.f.dispose()}}t.$oR=le;class oe{constructor(C,q){this.c=C,this.d=q}style(C){const q=this.d&&`.${this.d}`,$=[];C.listBackground&&$.push(`.monaco-list${q} .monaco-list-rows { background: ${C.listBackground}; }`),C.listFocusBackground&&($.push(`.monaco-list${q}:focus .monaco-list-row.focused { background-color: ${C.listFocusBackground}; }`),$.push(`.monaco-list${q}:focus .monaco-list-row.focused:hover { background-color: ${C.listFocusBackground}; }`)),C.listFocusForeground&&$.push(`.monaco-list${q}:focus .monaco-list-row.focused { color: ${C.listFocusForeground}; }`),C.listActiveSelectionBackground&&($.push(`.monaco-list${q}:focus .monaco-list-row.selected { background-color: ${C.listActiveSelectionBackground}; }`),$.push(`.monaco-list${q}:focus .monaco-list-row.selected:hover { background-color: ${C.listActiveSelectionBackground}; }`)),C.listActiveSelectionForeground&&$.push(`.monaco-list${q}:focus .monaco-list-row.selected { color: ${C.listActiveSelectionForeground}; }`),C.listActiveSelectionIconForeground&&$.push(`.monaco-list${q}:focus .monaco-list-row.selected .codicon { color: ${C.listActiveSelectionIconForeground}; }`),C.listFocusAndSelectionBackground&&$.push(`
				.monaco-drag-image,
				.monaco-list${q}:focus .monaco-list-row.selected.focused { background-color: ${C.listFocusAndSelectionBackground}; }
			`),C.listFocusAndSelectionForeground&&$.push(`
				.monaco-drag-image,
				.monaco-list${q}:focus .monaco-list-row.selected.focused { color: ${C.listFocusAndSelectionForeground}; }
			`),C.listInactiveFocusForeground&&($.push(`.monaco-list${q} .monaco-list-row.focused { color:  ${C.listInactiveFocusForeground}; }`),$.push(`.monaco-list${q} .monaco-list-row.focused:hover { color:  ${C.listInactiveFocusForeground}; }`)),C.listInactiveSelectionIconForeground&&$.push(`.monaco-list${q} .monaco-list-row.focused .codicon { color:  ${C.listInactiveSelectionIconForeground}; }`),C.listInactiveFocusBackground&&($.push(`.monaco-list${q} .monaco-list-row.focused { background-color:  ${C.listInactiveFocusBackground}; }`),$.push(`.monaco-list${q} .monaco-list-row.focused:hover { background-color:  ${C.listInactiveFocusBackground}; }`)),C.listInactiveSelectionBackground&&($.push(`.monaco-list${q} .monaco-list-row.selected { background-color:  ${C.listInactiveSelectionBackground}; }`),$.push(`.monaco-list${q} .monaco-list-row.selected:hover { background-color:  ${C.listInactiveSelectionBackground}; }`)),C.listInactiveSelectionForeground&&$.push(`.monaco-list${q} .monaco-list-row.selected { color: ${C.listInactiveSelectionForeground}; }`),C.listHoverBackground&&$.push(`.monaco-list${q}:not(.drop-target):not(.dragging) .monaco-list-row:hover:not(.selected):not(.focused) { background-color: ${C.listHoverBackground}; }`),C.listHoverForeground&&$.push(`.monaco-list${q}:not(.drop-target):not(.dragging) .monaco-list-row:hover:not(.selected):not(.focused) { color:  ${C.listHoverForeground}; }`);const W=(0,v.$iQ)(C.listFocusAndSelectionOutline,(0,v.$iQ)(C.listSelectionOutline,C.listFocusOutline??""));W&&$.push(`.monaco-list${q}:focus .monaco-list-row.focused.selected { outline: 1px solid ${W}; outline-offset: -1px;}`),C.listFocusOutline&&$.push(`
				.monaco-drag-image,
				.monaco-list${q}:focus .monaco-list-row.focused { outline: 1px solid ${C.listFocusOutline}; outline-offset: -1px; }
				.monaco-workbench.context-menu-visible .monaco-list${q}.last-focused .monaco-list-row.focused { outline: 1px solid ${C.listFocusOutline}; outline-offset: -1px; }
			`);const Q=(0,v.$iQ)(C.listSelectionOutline,C.listInactiveFocusOutline??"");Q&&$.push(`.monaco-list${q} .monaco-list-row.focused.selected { outline: 1px dotted ${Q}; outline-offset: -1px; }`),C.listSelectionOutline&&$.push(`.monaco-list${q} .monaco-list-row.selected { outline: 1px dotted ${C.listSelectionOutline}; outline-offset: -1px; }`),C.listInactiveFocusOutline&&$.push(`.monaco-list${q} .monaco-list-row.focused { outline: 1px dotted ${C.listInactiveFocusOutline}; outline-offset: -1px; }`),C.listHoverOutline&&$.push(`.monaco-list${q} .monaco-list-row:hover { outline: 1px dashed ${C.listHoverOutline}; outline-offset: -1px; }`),C.listDropBackground&&$.push(`
				.monaco-list${q}.drop-target,
				.monaco-list${q} .monaco-list-rows.drop-target,
				.monaco-list${q} .monaco-list-row.drop-target { background-color: ${C.listDropBackground} !important; color: inherit !important; }
			`),C.tableColumnsBorder&&$.push(`
				.monaco-table > .monaco-split-view2,
				.monaco-table > .monaco-split-view2 .monaco-sash.vertical::before,
				.monaco-workbench:not(.reduce-motion) .monaco-table:hover > .monaco-split-view2,
				.monaco-workbench:not(.reduce-motion) .monaco-table:hover > .monaco-split-view2 .monaco-sash.vertical::before {
					border-color: ${C.tableColumnsBorder};
				}

				.monaco-workbench:not(.reduce-motion) .monaco-table > .monaco-split-view2,
				.monaco-workbench:not(.reduce-motion) .monaco-table > .monaco-split-view2 .monaco-sash.vertical::before {
					border-color: transparent;
				}
			`),C.tableOddRowsBackgroundColor&&$.push(`
				.monaco-table .monaco-list-row[data-parity=odd]:not(.focused):not(.selected):not(:hover) .monaco-table-tr,
				.monaco-table .monaco-list:not(:focus) .monaco-list-row[data-parity=odd].focused:not(.selected):not(:hover) .monaco-table-tr,
				.monaco-table .monaco-list:not(.focused) .monaco-list-row[data-parity=odd].focused:not(.selected):not(:hover) .monaco-table-tr {
					background-color: ${C.tableOddRowsBackgroundColor};
				}
			`),this.c.textContent=$.join(`
`)}}t.$pR=oe,t.$qR={listFocusBackground:"#7FB0D0",listActiveSelectionBackground:"#0E639C",listActiveSelectionForeground:"#FFFFFF",listActiveSelectionIconForeground:"#FFFFFF",listFocusAndSelectionOutline:"#90C2F9",listFocusAndSelectionBackground:"#094771",listFocusAndSelectionForeground:"#FFFFFF",listInactiveSelectionBackground:"#3F3F46",listInactiveSelectionIconForeground:"#FFFFFF",listHoverBackground:"#2A2D2E",listDropBackground:"#383B3D",treeIndentGuidesStroke:"#a9a9a9",treeInactiveIndentGuidesStroke:d.$4s.fromHex("#a9a9a9").transparent(.4).toString(),tableColumnsBorder:d.$4s.fromHex("#cccccc").transparent(.2).toString(),tableOddRowsBackgroundColor:d.$4s.fromHex("#cccccc").transparent(.04).toString(),listBackground:void 0,listFocusForeground:void 0,listInactiveSelectionForeground:void 0,listInactiveFocusForeground:void 0,listInactiveFocusBackground:void 0,listHoverForeground:void 0,listFocusOutline:void 0,listInactiveFocusOutline:void 0,listSelectionOutline:void 0,listHoverOutline:void 0};const we={keyboardSupport:!0,mouseSupport:!0,multipleSelectionSupport:!0,dnd:{getDragURI(){return null},onDragStart(){},onDragOver(){return!1},drop(){},dispose(){}}};function Pe(Y,C){const q=Y.indexOf(C);if(q===-1)return[];const $=[];let W=q-1;for(;W>=0&&Y[W]===C-(q-W);)$.push(Y[W--]);for($.reverse(),W=q;W<Y.length&&Y[W]===C+(W-q);)$.push(Y[W++]);return $}function Ae(Y,C){const q=[];let $=0,W=0;for(;$<Y.length||W<C.length;)if($>=Y.length)q.push(C[W++]);else if(W>=C.length)q.push(Y[$++]);else if(Y[$]===C[W]){q.push(Y[$]),$++,W++;continue}else Y[$]<C[W]?q.push(Y[$++]):q.push(C[W++]);return q}function Re(Y,C){const q=[];let $=0,W=0;for(;$<Y.length||W<C.length;)if($>=Y.length)q.push(C[W++]);else if(W>=C.length)q.push(Y[$++]);else if(Y[$]===C[W]){$++,W++;continue}else Y[$]<C[W]?q.push(Y[$++]):W++;return q}const de=(Y,C)=>Y-C;class ne{constructor(C,q){this.c=C,this.d=q}get templateId(){return this.c}renderTemplate(C){return this.d.map(q=>q.renderTemplate(C))}renderElement(C,q,$,W){let Q=0;for(const p of this.d)p.renderElement(C,q,$[Q++],W)}disposeElement(C,q,$,W){let Q=0;for(const p of this.d)p.disposeElement?.(C,q,$[Q],W),Q+=1}disposeTemplate(C){let q=0;for(const $ of this.d)$.disposeTemplate(C[q++])}}class fe{constructor(C){this.c=C,this.templateId="a18n"}renderTemplate(C){return C}renderElement(C,q,$){const W=this.c.getAriaLabel(C);W?$.setAttribute("aria-label",W):$.removeAttribute("aria-label");const Q=this.c.getAriaLevel&&this.c.getAriaLevel(C);typeof Q=="number"?$.setAttribute("aria-level",`${Q}`):$.removeAttribute("aria-level")}disposeTemplate(C){}}class Z{constructor(C,q){this.c=C,this.d=q}getDragElements(C){const q=this.c.getSelectedElements();return q.indexOf(C)>-1?q:[C]}getDragURI(C){return this.d.getDragURI(C)}getDragLabel(C,q){if(this.d.getDragLabel)return this.d.getDragLabel(C,q)}onDragStart(C,q){this.d.onDragStart?.(C,q)}onDragOver(C,q,$,W){return this.d.onDragOver(C,q,$,W)}onDragLeave(C,q,$,W){this.d.onDragLeave?.(C,q,$,W)}onDragEnd(C){this.d.onDragEnd?.(C)}drop(C,q,$,W){this.d.drop(C,q,$,W)}dispose(){this.d.dispose()}}class V{get onDidChangeFocus(){return s.Event.map(this.g.wrapEvent(this.c.onChange),C=>this.G(C),this.y)}get onDidChangeSelection(){return s.Event.map(this.g.wrapEvent(this.d.onChange),C=>this.G(C),this.y)}get domId(){return this.k.domId}get onDidScroll(){return this.k.onDidScroll}get onMouseClick(){return this.k.onMouseClick}get onMouseDblClick(){return this.k.onMouseDblClick}get onMouseMiddleClick(){return this.k.onMouseMiddleClick}get onPointer(){return this.w.onPointer}get onMouseUp(){return this.k.onMouseUp}get onMouseDown(){return this.k.onMouseDown}get onMouseOver(){return this.k.onMouseOver}get onMouseMove(){return this.k.onMouseMove}get onMouseOut(){return this.k.onMouseOut}get onTouchStart(){return this.k.onTouchStart}get onTap(){return this.k.onTap}get onContextMenu(){let C=!1;const q=s.Event.chain(this.y.add(new N.$4Q(this.k.domNode,"keydown")).event,Q=>Q.map(p=>new i.$ZO(p)).filter(p=>C=p.keyCode===58||p.shiftKey&&p.keyCode===68).map(p=>v.$XP.stop(p,!0)).filter(()=>!1)),$=s.Event.chain(this.y.add(new N.$4Q(this.k.domNode,"keyup")).event,Q=>Q.forEach(()=>C=!1).map(p=>new i.$ZO(p)).filter(p=>p.keyCode===58||p.shiftKey&&p.keyCode===68).map(p=>v.$XP.stop(p,!0)).map(({browserEvent:p})=>{const A=this.getFocus(),E=A.length?A[0]:void 0,I=typeof E<"u"?this.k.element(E):void 0,k=typeof E<"u"?this.k.domElement(E):this.k.domNode;return{index:E,element:I,anchor:k,browserEvent:p}})),W=s.Event.chain(this.k.onContextMenu,Q=>Q.filter(p=>!C).map(({element:p,index:A,browserEvent:E})=>({element:p,index:A,anchor:new b.$UO((0,v.$IP)(this.k.domNode),E),browserEvent:E})));return s.Event.any(q,$,W)}get onKeyDown(){return this.y.add(new N.$4Q(this.k.domNode,"keydown")).event}get onKeyUp(){return this.y.add(new N.$4Q(this.k.domNode,"keyup")).event}get onKeyPress(){return this.y.add(new N.$4Q(this.k.domNode,"keypress")).event}get onDidFocus(){return s.Event.signal(this.y.add(new N.$4Q(this.k.domNode,"focus",!0)).event)}get onDidBlur(){return s.Event.signal(this.y.add(new N.$4Q(this.k.domNode,"blur",!0)).event)}constructor(C,q,$,W,Q=we){this.A=C,this.B=Q,this.c=new o("focused"),this.f=new o("anchor"),this.g=new s.$Zd,this.x="",this.y=new e.$Qc,this.z=new s.$Rd,this.onDidDispose=this.z.event;const p=this.B.accessibilityProvider&&this.B.accessibilityProvider.getWidgetRole?this.B.accessibilityProvider?.getWidgetRole():"list";this.d=new F(p!=="listbox");const A=[this.c.renderer,this.d.renderer];this.u=Q.accessibilityProvider,this.u&&(A.push(new fe(this.u)),this.u.onDidChangeActiveDescendant?.(this.I,this,this.y)),W=W.map(I=>new ne(I.templateId,[...A,I]));const E={...Q,dnd:Q.dnd&&new Z(this,Q.dnd)};if(this.k=this.C(q,$,W,E),this.k.domNode.setAttribute("role",p),Q.styleController)this.q=Q.styleController(this.k.domId);else{const I=(0,v.$LP)(this.k.domNode);this.q=new oe(I,this.k.domId)}if(this.o=new D.$8Q([new z(this.c,this.k,Q.identityProvider),new z(this.d,this.k,Q.identityProvider),new z(this.f,this.k,Q.identityProvider),this.k]),this.y.add(this.c),this.y.add(this.d),this.y.add(this.f),this.y.add(this.k),this.y.add(this.z),this.y.add(new B(this,this.k)),(typeof Q.keyboardSupport!="boolean"||Q.keyboardSupport)&&(this.v=new M(this,this.k,Q),this.y.add(this.v)),Q.keyboardNavigationLabelProvider){const I=Q.keyboardNavigationDelegate||t.$lR;this.t=new O(this,this.k,Q.keyboardNavigationLabelProvider,Q.keyboardNavigationEventFilter??(()=>!0),I),this.y.add(this.t)}this.w=this.D(Q),this.y.add(this.w),this.onDidChangeFocus(this.H,this,this.y),this.onDidChangeSelection(this.J,this,this.y),this.u&&(this.ariaLabel=this.u.getWidgetAriaLabel()),this.B.multipleSelectionSupport!==!1&&this.k.domNode.setAttribute("aria-multiselectable","true")}C(C,q,$,W){return new r.$hR(C,q,$,W)}D(C){return new le(this)}updateOptions(C={}){this.B={...this.B,...C},this.t?.updateOptions(this.B),this.B.multipleSelectionController!==void 0&&(this.B.multipleSelectionSupport?this.k.domNode.setAttribute("aria-multiselectable","true"):this.k.domNode.removeAttribute("aria-multiselectable")),this.w.updateOptions(C),this.v?.updateOptions(C),this.k.updateOptions(C)}get options(){return this.B}splice(C,q,$=[]){if(C<0||C>this.k.length)throw new n.$0Q(this.A,`Invalid start index: ${C}`);if(q<0)throw new n.$0Q(this.A,`Invalid delete count: ${q}`);q===0&&$.length===0||this.g.bufferEvents(()=>this.o.splice(C,q,$))}updateWidth(C){this.k.updateWidth(C)}updateElementHeight(C,q){this.k.updateElementHeight(C,q,null)}rerender(){this.k.rerender()}element(C){return this.k.element(C)}indexOf(C){return this.k.indexOf(C)}get length(){return this.k.length}get contentHeight(){return this.k.contentHeight}get contentWidth(){return this.k.contentWidth}get onDidChangeContentHeight(){return this.k.onDidChangeContentHeight}get onDidChangeContentWidth(){return this.k.onDidChangeContentWidth}get scrollTop(){return this.k.getScrollTop()}set scrollTop(C){this.k.setScrollTop(C)}get scrollLeft(){return this.k.getScrollLeft()}set scrollLeft(C){this.k.setScrollLeft(C)}get scrollHeight(){return this.k.scrollHeight}get renderHeight(){return this.k.renderHeight}get firstVisibleIndex(){return this.k.firstVisibleIndex}get lastVisibleIndex(){return this.k.lastVisibleIndex}get ariaLabel(){return this.x}set ariaLabel(C){this.x=C,this.k.domNode.setAttribute("aria-label",C)}domFocus(){this.k.domNode.focus({preventScroll:!0})}layout(C,q){this.k.layout(C,q)}triggerTypeNavigation(){this.t?.trigger()}setSelection(C,q){for(const $ of C)if($<0||$>=this.length)throw new n.$0Q(this.A,`Invalid index ${$}`);this.d.set(C,q)}getSelection(){return this.d.get()}getSelectedElements(){return this.getSelection().map(C=>this.k.element(C))}setAnchor(C){if(typeof C>"u"){this.f.set([]);return}if(C<0||C>=this.length)throw new n.$0Q(this.A,`Invalid index ${C}`);this.f.set([C])}getAnchor(){return(0,c.$Nb)(this.f.get(),void 0)}getAnchorElement(){const C=this.getAnchor();return typeof C>"u"?void 0:this.element(C)}setFocus(C,q){for(const $ of C)if($<0||$>=this.length)throw new n.$0Q(this.A,`Invalid index ${$}`);this.c.set(C,q)}focusNext(C=1,q=!1,$,W){if(this.length===0)return;const Q=this.c.get(),p=this.E(Q.length>0?Q[0]+C:0,q,W);p>-1&&this.setFocus([p],$)}focusPrevious(C=1,q=!1,$,W){if(this.length===0)return;const Q=this.c.get(),p=this.F(Q.length>0?Q[0]-C:0,q,W);p>-1&&this.setFocus([p],$)}async focusNextPage(C,q){let $=this.k.indexAt(this.k.getScrollTop()+this.k.renderHeight);$=$===0?0:$-1;const W=this.getFocus()[0];if(W!==$&&(W===void 0||$>W)){const Q=this.F($,!1,q);Q>-1&&W!==Q?this.setFocus([Q],C):this.setFocus([$],C)}else{const Q=this.k.getScrollTop();let p=Q+this.k.renderHeight;$>W&&(p-=this.k.elementHeight($)),this.k.setScrollTop(p),this.k.getScrollTop()!==Q&&(this.setFocus([]),await(0,f.$Yg)(0),await this.focusNextPage(C,q))}}async focusPreviousPage(C,q){let $;const W=this.k.getScrollTop();W===0?$=this.k.indexAt(W):$=this.k.indexAfter(W-1);const Q=this.getFocus()[0];if(Q!==$&&(Q===void 0||Q>=$)){const p=this.E($,!1,q);p>-1&&Q!==p?this.setFocus([p],C):this.setFocus([$],C)}else{const p=W;this.k.setScrollTop(W-this.k.renderHeight),this.k.getScrollTop()!==p&&(this.setFocus([]),await(0,f.$Yg)(0),await this.focusPreviousPage(C,q))}}focusLast(C,q){if(this.length===0)return;const $=this.F(this.length-1,!1,q);$>-1&&this.setFocus([$],C)}focusFirst(C,q){this.focusNth(0,C,q)}focusNth(C,q,$){if(this.length===0)return;const W=this.E(C,!1,$);W>-1&&this.setFocus([W],q)}E(C,q=!1,$){for(let W=0;W<this.length;W++){if(C>=this.length&&!q)return-1;if(C=C%this.length,!$||$(this.element(C)))return C;C++}return-1}F(C,q=!1,$){for(let W=0;W<this.length;W++){if(C<0&&!q)return-1;if(C=(this.length+C%this.length)%this.length,!$||$(this.element(C)))return C;C--}return-1}getFocus(){return this.c.get()}getFocusedElements(){return this.getFocus().map(C=>this.k.element(C))}reveal(C,q){if(C<0||C>=this.length)throw new n.$0Q(this.A,`Invalid index ${C}`);const $=this.k.getScrollTop(),W=this.k.elementTop(C),Q=this.k.elementHeight(C);if((0,m.$Gf)(q)){const p=Q-this.k.renderHeight;this.k.setScrollTop(p*(0,h.$Ul)(q,0,1)+W)}else{const p=W+Q,A=$+this.k.renderHeight;W<$&&p>=A||(W<$||p>=A&&Q>=this.k.renderHeight?this.k.setScrollTop(W):p>=A&&this.k.setScrollTop(p-this.k.renderHeight))}}getRelativeTop(C){if(C<0||C>=this.length)throw new n.$0Q(this.A,`Invalid index ${C}`);const q=this.k.getScrollTop(),$=this.k.elementTop(C),W=this.k.elementHeight(C);if($<q||$+W>q+this.k.renderHeight)return null;const Q=W-this.k.renderHeight;return Math.abs((q-$)/Q)}isDOMFocused(){return(0,v.$DP)(this.k.domNode)}getHTMLElement(){return this.k.domNode}getElementID(C){return this.k.getElementDomId(C)}style(C){this.q.style(C)}G({indexes:C,browserEvent:q}){return{indexes:C,elements:C.map($=>this.k.element($)),browserEvent:q}}H(){const C=this.c.get();this.k.domNode.classList.toggle("element-focused",C.length>0),this.I()}I(){const C=this.c.get();if(C.length>0){let q;this.u?.getActiveDescendantId&&(q=this.u.getActiveDescendantId(this.k.element(C[0]))),this.k.domNode.setAttribute("aria-activedescendant",q||this.k.getElementDomId(C[0]))}else this.k.domNode.removeAttribute("aria-activedescendant")}J(){const C=this.d.get();this.k.domNode.classList.toggle("selection-none",C.length===0),this.k.domNode.classList.toggle("selection-single",C.length===1),this.k.domNode.classList.toggle("selection-multiple",C.length>1)}dispose(){this.z.fire(),this.y.dispose(),this.z.dispose()}}t.$rR=V,Xe([T.$nh],V.prototype,"onDidChangeFocus",null),Xe([T.$nh],V.prototype,"onDidChangeSelection",null),Xe([T.$nh],V.prototype,"onContextMenu",null),Xe([T.$nh],V.prototype,"onKeyDown",null),Xe([T.$nh],V.prototype,"onKeyUp",null),Xe([T.$nh],V.prototype,"onKeyPress",null),Xe([T.$nh],V.prototype,"onDidFocus",null),Xe([T.$nh],V.prototype,"onDidBlur",null)}),define(be[62],pe([1,0,6,35,37,12,15]),function(ae,t,v,N,i,U,w){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$dk=t.$ck=t.$bk=t.$ak=t.$_j=t.$$j=t.$0j=t.$9j=t.MarkdownStringTextNewlineStyle=void 0;var D;(function(l){l[l.Paragraph=0]="Paragraph",l[l.Break=1]="Break"})(D||(t.MarkdownStringTextNewlineStyle=D={}));class c{constructor(m="",n=!1){if(this.value=m,typeof this.value!="string")throw(0,v.$6)("value");typeof n=="boolean"?(this.isTrusted=n,this.supportThemeIcons=!1,this.supportHtml=!1):(this.isTrusted=n.isTrusted??void 0,this.supportThemeIcons=n.supportThemeIcons??!1,this.supportHtml=n.supportHtml??!1)}appendText(m,n=0){return this.value+=s(this.supportThemeIcons?(0,N.$3j)(m):m).replace(/([ \t]+)/g,(r,b)=>"&nbsp;".repeat(b.length)).replace(/\>/gm,"\\>").replace(/\n/g,n===1?`\\
`:`

`),this}appendMarkdown(m){return this.value+=m,this}appendCodeblock(m,n){return this.value+="\n```",this.value+=m,this.value+=`
`,this.value+=n,this.value+="\n```\n",this}appendLink(m,n,r){return this.value+="[",this.value+=this.c(n,"]"),this.value+="](",this.value+=this.c(String(m),")"),r&&(this.value+=` "${this.c(this.c(r,'"'),")")}"`),this.value+=")",this}c(m,n){const r=new RegExp((0,U.$Je)(n),"g");return m.replace(r,(b,u)=>m.charAt(u-1)!=="\\"?`\\${b}`:b)}}t.$9j=c;function f(l){return d(l)?!l.value:Array.isArray(l)?l.every(f):!0}t.$0j=f;function d(l){return l instanceof c?!0:l&&typeof l=="object"?typeof l.value=="string"&&(typeof l.isTrusted=="boolean"||typeof l.isTrusted=="object"||l.isTrusted===void 0)&&(typeof l.supportThemeIcons=="boolean"||l.supportThemeIcons===void 0):!1}t.$$j=d;function T(l,m){return l===m?!0:!l||!m?!1:l.value===m.value&&l.isTrusted===m.isTrusted&&l.supportThemeIcons===m.supportThemeIcons&&l.supportHtml===m.supportHtml&&(l.baseUri===m.baseUri||!!l.baseUri&&!!m.baseUri&&(0,i.$sg)(w.URI.from(l.baseUri),w.URI.from(m.baseUri)))}t.$_j=T;function s(l){return l.replace(/[\\`*_{}[\]()#+\-!~]/g,"\\$&")}t.$ak=s;function a(l){return l.replace(/"/g,"&quot;")}t.$bk=a;function e(l){return l&&l.replace(/\\([\\`*_{}[\]()#+\-.!~])/g,"$1")}t.$ck=e;function h(l){const m=[],n=l.split("|").map(b=>b.trim());l=n[0];const r=n[1];if(r){const b=/height=(\d+)/.exec(r),u=/width=(\d+)/.exec(r),o=b?b[1]:"",F=u?u[1]:"",z=isFinite(parseInt(F)),R=isFinite(parseInt(o));z&&m.push(`width="${F}"`),R&&m.push(`height="${o}"`)}return{href:l,dimensions:m}}t.$dk=h}),define(be[125],pe([1,0,3,117,22,55,14,19,118,6,4,62,35,77,28,2,79,53,31,51,37,12,15]),function(ae,t,v,N,i,U,w,D,c,f,d,T,s,a,e,h,l,m,n,r,b,u,o){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$yR=t.$xR=t.$wR=t.$vR=t.$uR=void 0;const F=Object.freeze({image:(Z,V,Y)=>{let C=[],q=[];return Z&&({href:Z,dimensions:C}=(0,T.$dk)(Z),q.push(`src="${(0,T.$bk)(Z)}"`)),Y&&q.push(`alt="${(0,T.$bk)(Y)}"`),V&&q.push(`title="${(0,T.$bk)(V)}"`),C.length&&(q=q.concat(C)),"<img "+q.join(" ")+">"},paragraph:Z=>`<p>${Z}</p>`,link:(Z,V,Y)=>typeof Z!="string"?"":(Z===Y&&(Y=(0,T.$ck)(Y)),V=typeof V=="string"?(0,T.$bk)((0,T.$ck)(V)):"",Z=(0,T.$ck)(Z),Z=Z.replace(/&/g,"&amp;").replace(/</g,"&lt;").replace(/>/g,"&gt;").replace(/"/g,"&quot;").replace(/'/g,"&#39;"),`<a href="${Z}" title="${V||Z}">${Y}</a>`)});function z(Z,V={},Y={}){const C=new h.$Qc;let q=!1;const $=(0,U.$3Q)(V),W=function(P){let H;try{H=(0,m.$rh)(decodeURIComponent(P))}catch{}return H?(H=(0,r.$cn)(H,G=>{if(Z.uris&&Z.uris[G])return o.URI.revive(Z.uris[G])}),encodeURIComponent(JSON.stringify(H))):P},Q=function(P,H){const G=Z.uris&&Z.uris[P];let ee=o.URI.revive(G);return H?P.startsWith(n.Schemas.data+":")?P:(ee||(ee=o.URI.parse(P)),n.$gg.uriToBrowserUri(ee).toString(!0)):!ee||o.URI.parse(P).toString()===ee.toString()?P:(ee.query&&(ee=ee.with({query:W(ee.query)})),ee.toString())},p=new l.marked.Renderer;p.image=F.image,p.link=F.link,p.paragraph=F.paragraph;const A=[],E=[];if(V.codeBlockRendererSync?p.code=(P,H)=>{const G=a.$FM.nextId(),ee=V.codeBlockRendererSync(R(H),P);return E.push([G,ee]),`<div class="code" data-code="${G}">${(0,u.$Ie)(P)}</div>`}:V.codeBlockRenderer&&(p.code=(P,H)=>{const G=a.$FM.nextId(),ee=V.codeBlockRenderer(R(H),P);return A.push(ee.then(se=>[G,se])),`<div class="code" data-code="${G}">${(0,u.$Ie)(P)}</div>`}),V.actionHandler){const P=function(ee){let se=ee.target;if(!(se.tagName!=="A"&&(se=se.parentElement,!se||se.tagName!=="A")))try{let me=se.dataset.href;me&&(Z.baseUri&&(me=g(o.URI.from(Z.baseUri),me)),V.actionHandler.callback(me,ee))}catch(me){(0,f.$Z)(me)}finally{ee.preventDefault()}},H=V.actionHandler.disposables.add(new i.$4Q($,"click")),G=V.actionHandler.disposables.add(new i.$4Q($,"auxclick"));V.actionHandler.disposables.add(d.Event.any(H.event,G.event)(ee=>{const se=new D.$UO(v.$IP($),ee);!se.leftButton&&!se.middleButton||P(se)})),V.actionHandler.disposables.add(v.$3O($,"keydown",ee=>{const se=new w.$ZO(ee);!se.equals(10)&&!se.equals(3)||P(se)}))}Z.supportHtml||(Y.sanitizer=P=>(Z.isTrusted?P.match(/^(<span[^>]+>)|(<\/\s*span>)$/):void 0)?P:"",Y.sanitize=!0,Y.silent=!0),Y.renderer=p;let I=Z.value??"";I.length>1e5&&(I=`${I.substr(0,1e5)}\u2026`),Z.supportThemeIcons&&(I=(0,s.$4j)(I));let k;if(V.fillInIncompleteTokens){const P={...l.marked.defaults,...Y},H=l.marked.lexer(I,P),G=te(H);k=l.marked.parser(G,P)}else k=l.marked.parse(I,Y);Z.supportThemeIcons&&(k=(0,c.$sR)(k).map(H=>typeof H=="string"?H:H.outerHTML).join(""));const S=new DOMParser().parseFromString(y(Z,k),"text/html");if(S.body.querySelectorAll("img").forEach(P=>{const H=P.getAttribute("src");if(H){let G=H;try{Z.baseUri&&(G=g(o.URI.from(Z.baseUri),G))}catch{}P.src=Q(G,!0)}}),S.body.querySelectorAll("a").forEach(P=>{const H=P.getAttribute("href");if(P.setAttribute("href",""),!H||/^data:|javascript:/i.test(H)||/^command:/i.test(H)&&!Z.isTrusted||/^command:(\/\/\/)?_workbench\.downloadResource/i.test(H))P.replaceWith(...P.childNodes);else{let G=Q(H,!1);Z.baseUri&&(G=g(o.URI.from(Z.baseUri),H)),P.dataset.href=G}}),$.innerHTML=y(Z,S.body.innerHTML),A.length>0)Promise.all(A).then(P=>{if(q)return;const H=new Map(P),G=$.querySelectorAll("div[data-code]");for(const ee of G){const se=H.get(ee.dataset.code??"");se&&v.$5P(ee,se)}V.asyncRenderCallback?.()});else if(E.length>0){const P=new Map(E),H=$.querySelectorAll("div[data-code]");for(const G of H){const ee=P.get(G.dataset.code??"");ee&&v.$5P(G,ee)}}if(V.asyncRenderCallback)for(const P of $.getElementsByTagName("img")){const H=C.add(v.$3O(P,"load",()=>{H.dispose(),V.asyncRenderCallback()}))}return{element:$,dispose:()=>{q=!0,C.dispose()}}}t.$uR=z;function R(Z){if(!Z)return"";const V=Z.split(/[\s+|:|,|\{|\?]/,1);return V.length?V[0]:Z}function g(Z,V){return/^\w[\w\d+.-]*:/.test(V)?V:Z.path.endsWith("/")?(0,b.$Cg)(Z,V).toString():(0,b.$Cg)((0,b.$yg)(Z),V).toString()}function y(Z,V){const{config:Y,allowedSchemes:C}=M(Z);N.addHook("uponSanitizeAttribute",($,W)=>{if(W.attrName==="style"||W.attrName==="class"){if($.tagName==="SPAN"){if(W.attrName==="style"){W.keepAttr=/^(color\:(#[0-9a-fA-F]+|var\(--vscode(-[a-zA-Z]+)+\));)?(background-color\:(#[0-9a-fA-F]+|var\(--vscode(-[a-zA-Z]+)+\));)?$/.test(W.attrValue);return}else if(W.attrName==="class"){W.keepAttr=/^codicon codicon-[a-z\-]+( codicon-modifier-[a-z\-]+)?$/.test(W.attrValue);return}}W.keepAttr=!1;return}});const q=v.$mQ(C);try{return N.sanitize(V,{...Y,RETURN_TRUSTED_TYPE:!0})}finally{N.removeHook("uponSanitizeAttribute"),q.dispose()}}t.$vR=["align","autoplay","alt","class","controls","data-code","data-href","height","href","loop","muted","playsinline","poster","src","style","target","title","width","start"];function M(Z){const V=[n.Schemas.http,n.Schemas.https,n.Schemas.mailto,n.Schemas.data,n.Schemas.file,n.Schemas.vscodeFileResource,n.Schemas.vscodeRemote,n.Schemas.vscodeRemoteResource];return Z.isTrusted&&V.push(n.Schemas.command),{config:{ALLOWED_TAGS:[...v.$nQ],ALLOWED_ATTR:t.$vR,ALLOW_UNKNOWN_PROTOCOLS:!0},allowedSchemes:V}}function _(Z){return typeof Z=="string"?Z:x(Z)}t.$wR=_;function x(Z){let V=Z.value??"";V.length>1e5&&(V=`${V.substr(0,1e5)}\u2026`);const Y=l.marked.parse(V,{renderer:B.value}).replace(/&(#\d+|[a-zA-Z]+);/g,C=>O.get(C)??C);return y({isTrusted:!1},Y).toString()}t.$xR=x;const O=new Map([["&quot;",'"'],["&nbsp;"," "],["&amp;","&"],["&#39;","'"],["&lt;","<"],["&gt;",">"]]),B=new e.$U(()=>{const Z=new l.marked.Renderer;return Z.code=V=>V,Z.blockquote=V=>V,Z.html=V=>"",Z.heading=(V,Y,C)=>V+`
`,Z.hr=()=>"",Z.list=(V,Y)=>V,Z.listitem=V=>V+`
`,Z.paragraph=V=>V+`
`,Z.table=(V,Y)=>V+Y+`
`,Z.tablerow=V=>V,Z.tablecell=(V,Y)=>V+" ",Z.strong=V=>V,Z.em=V=>V,Z.codespan=V=>V,Z.br=()=>`
`,Z.del=V=>V,Z.image=(V,Y,C)=>"",Z.text=V=>V,Z.link=(V,Y,C)=>C,Z});function j(Z){let V="";return Z.forEach(Y=>{V+=Y.raw}),V}function ie(Z){for(const V of Z.tokens)if(V.type==="text"){const Y=V.raw.split(`
`),C=Y[Y.length-1];if(C.includes("`"))return le(Z);if(C.includes("**"))return Re(Z);if(C.match(/\*\w/))return oe(Z);if(C.match(/(^|\s)__\w/))return de(Z);if(C.match(/(^|\s)_\w/))return we(Z);if(C.match(/(^|\s)\[.*\]\(\w*/))return Pe(Z);if(C.match(/(^|\s)\[\w/))return Ae(Z)}}function te(Z){let V,Y;for(V=0;V<Z.length;V++){const C=Z[V];if(C.type==="paragraph"&&C.raw.match(/(\n|^)```/)){Y=ce(Z.slice(V));break}if(C.type==="paragraph"&&C.raw.match(/(\n|^)\|/)){Y=fe(Z.slice(V));break}if(V===Z.length-1&&C.type==="paragraph"){const q=ie(C);if(q){Y=[q];break}}}if(Y){const C=[...Z.slice(0,V),...Y];return C.links=Z.links,C}return Z}t.$yR=te;function ce(Z){const V=j(Z);return l.marked.lexer(V+"\n```")}function le(Z){return ne(Z,"`")}function oe(Z){return ne(Z,"*")}function we(Z){return ne(Z,"_")}function Pe(Z){return ne(Z,")")}function Ae(Z){return ne(Z,"](about:blank)")}function Re(Z){return ne(Z,"**")}function de(Z){return ne(Z,"__")}function ne(Z,V){const Y=j(Array.isArray(Z)?Z:[Z]);return l.marked.lexer(Y+V)[0]}function fe(Z){const V=j(Z),Y=V.split(`
`);let C,q=!1;for(let $=0;$<Y.length;$++){const W=Y[$].trim();if(typeof C>"u"&&W.match(/^\s*\|/)){const Q=W.match(/(\|[^\|]+)(?=\||$)/g);Q&&(C=Q.length)}else if(typeof C=="number")if(W.match(/^\s*\|/)){if($!==Y.length-1)return;q=!0}else return}if(typeof C=="number"&&C>0){const $=q?Y.slice(0,-1).join(`
`):V,W=!!$.match(/\|\s*$/),Q=$+(W?"":"|")+`
|${" --- |".repeat(C)}`;return l.marked.lexer(Q)}}}),define(be[126],pe([1,0,3,9,29,62,35,2,7,107]),function(ae,t,v,N,i,U,w,D,c,f){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$UQ=t.$TQ=void 0;function d(a,e){(0,c.$Cf)(e)?a.title=(0,w.$5j)(e):e?.markdownNotSupportedFallback?a.title=e.markdownNotSupportedFallback:a.removeAttribute("title")}t.$TQ=d;class T{constructor(e,h,l){this.c=e,this.d=h,this.f=l}async update(e,h,l){if(this.b&&(this.b.dispose(!0),this.b=void 0),this.isDisposed)return;let m;if(e===void 0||(0,c.$Cf)(e)||e instanceof HTMLElement)m=e;else if(!(0,c.$Qf)(e.markdown))m=e.markdown??e.markdownNotSupportedFallback;else{this.a||this.g((0,f.localize)(0,null),h),this.b=new i.$2d;const n=this.b.token;if(m=await e.markdown(n),m===void 0&&(m=e.markdownNotSupportedFallback),this.isDisposed||n.isCancellationRequested)return}this.g(m,h,l)}g(e,h,l){const m=this.a;if(this.h(e)){const n={content:e,target:this.d,showPointer:this.c.placement==="element",hoverPosition:2,skipFadeInAnimation:!this.f||!!m,...l};this.a=this.c.showHover(n,h)}m?.dispose()}h(e){return e?(0,U.$$j)(e)?!!e.value:!0:!1}get isDisposed(){return this.a?.isDisposed}dispose(){this.a?.dispose(),this.b?.dispose(!0),this.b=void 0}}function s(a,e,h,l){let m,n;const r=(z,R)=>{const g=n!==void 0;z&&(n?.dispose(),n=void 0),R&&(m?.dispose(),m=void 0),g&&a.onDidHideHover?.()},b=(z,R,g)=>new N.$8g(async()=>{(!n||n.isDisposed)&&(n=new T(a,g||e,z>0),await n.update(h,R,l))},z),u=()=>{if(m)return;const z=new D.$Qc,R=M=>r(!1,M.fromElement===e);z.add(v.$3O(e,v.$VP.MOUSE_LEAVE,R,!0));const g=()=>r(!0,!0);z.add(v.$3O(e,v.$VP.MOUSE_DOWN,g,!0));const y={targetElements:[e],dispose:()=>{}};if(a.placement===void 0||a.placement==="mouse"){const M=_=>{y.x=_.x+10,_.target instanceof HTMLElement&&_.target.classList.contains("action-label")&&r(!0,!0)};z.add(v.$3O(e,v.$VP.MOUSE_MOVE,M,!0))}z.add(b(a.delay,!1,y)),m=z},o=v.$3O(e,v.$VP.MOUSE_OVER,u,!0);return{show:z=>{r(!1,!0),b(0,z)},hide:()=>{r(!0,!0)},update:async(z,R)=>{h=z,await n?.update(h,void 0,R)},dispose:()=>{o.dispose(),r(!0,!0)}}}t.$UQ=s}),define(be[127],pe([1,0,3,22,14,125,39,11,4,44,2,5,109,100]),function(ae,t,v,N,i,U,w,D,c,f,d,T,s){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$zR=void 0;const a=v.$,e="selectOption.entry.template";class h{get templateId(){return e}renderTemplate(n){const r=Object.create(null);return r.root=n,r.text=v.$3P(n,a(".option-text")),r.detail=v.$3P(n,a(".option-detail")),r.decoratorRight=v.$3P(n,a(".option-decorator-right")),r}renderElement(n,r,b){const u=b,o=n.text,F=n.detail,z=n.decoratorRight,R=n.isDisabled;u.text.textContent=o,u.detail.textContent=F||"",u.decoratorRight.innerText=z||"",R?u.root.classList.add("option-disabled"):u.root.classList.remove("option-disabled")}disposeTemplate(n){}}class l extends d.$Rc{static{this.a=32}static{this.b=2}static{this.c=3}constructor(n,r,b,u,o){super(),this.m=[],this.F=0,this.H=!1,this.J=!1,this.M=!1,this.f=!1,this.s=u,this.g=o||Object.create(null),typeof this.g.minBottomMargin!="number"?this.g.minBottomMargin=l.a:this.g.minBottomMargin<0&&(this.g.minBottomMargin=0),this.h=document.createElement("select"),this.h.className="monaco-select-box monaco-select-box-dropdown-padding",typeof this.g.ariaLabel=="string"&&this.h.setAttribute("aria-label",this.g.ariaLabel),typeof this.g.ariaDescription=="string"&&this.h.setAttribute("aria-description",this.g.ariaDescription),this.r=new c.$Rd,this.B(this.r),this.O(),this.N(b),this.n=r||0,n&&this.setOptions(n,r),this.Q()}getHeight(){return 22}getTemplateId(){return e}N(n){this.u=n,this.w=v.$(".monaco-select-box-dropdown-container"),this.w.classList.add("monaco-select-box-dropdown-padding"),this.I=v.$3P(this.w,a(".select-box-details-pane"));const r=v.$3P(this.w,a(".select-box-dropdown-container-width-control")),b=v.$3P(r,a(".width-control-div"));this.D=document.createElement("span"),this.D.className="option-text-width-control",v.$3P(b,this.D),this.G=0,this.y=v.$LP(this.w),this.w.setAttribute("draggable","true"),this.B(v.$3O(this.w,v.$VP.DRAG_START,u=>{v.$XP.stop(u,!0)}))}O(){this.B(v.$4O(this.h,"change",r=>{this.n=r.target.selectedIndex,this.r.fire({index:r.target.selectedIndex,selected:r.target.value}),this.m[this.n]&&this.m[this.n].text&&(this.h.title=this.m[this.n].text)})),this.B(v.$3O(this.h,v.$VP.CLICK,r=>{v.$XP.stop(r),this.f?this.X(!0):this.W()})),this.B(v.$3O(this.h,v.$VP.MOUSE_DOWN,r=>{v.$XP.stop(r)}));let n;this.B(v.$3O(this.h,"touchstart",r=>{n=this.f})),this.B(v.$3O(this.h,"touchend",r=>{v.$XP.stop(r),n?this.X(!0):this.W()})),this.B(v.$3O(this.h,v.$VP.KEY_DOWN,r=>{const b=new i.$ZO(r);let u=!1;T.$j?(b.keyCode===18||b.keyCode===16||b.keyCode===10||b.keyCode===3)&&(u=!0):(b.keyCode===18&&b.altKey||b.keyCode===16&&b.altKey||b.keyCode===10||b.keyCode===3)&&(u=!0),u&&(this.W(),v.$XP.stop(r,!0))}))}get onDidSelect(){return this.r.event}setOptions(n,r){D.$tb(this.m,n)||(this.m=n,this.h.options.length=0,this.H=!1,this.L=void 0,this.m.forEach((b,u)=>{this.h.add(this.U(b.text,u,b.isDisabled)),typeof b.description=="string"&&(this.H=!0)})),r!==void 0&&(this.select(r),this.F=this.n)}P(){this.z?.splice(0,this.z.length,this.m)}select(n){n>=0&&n<this.m.length?this.n=n:n>this.m.length-1?this.select(this.m.length-1):this.n<0&&(this.n=0),this.h.selectedIndex=this.n,this.m[this.n]&&this.m[this.n].text&&(this.h.title=this.m[this.n].text)}setAriaLabel(n){this.g.ariaLabel=n,this.h.setAttribute("aria-label",this.g.ariaLabel)}focus(){this.h&&(this.h.tabIndex=0,this.h.focus())}blur(){this.h&&(this.h.tabIndex=-1,this.h.blur())}setFocusable(n){this.h.tabIndex=n?0:-1}render(n){this.j=n,n.classList.add("select-container"),n.appendChild(this.h),this.R()}Q(){const n=[];this.s.listFocusBackground&&n.push(`.monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row.focused { background-color: ${this.s.listFocusBackground} !important; }`),this.s.listFocusForeground&&n.push(`.monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row.focused { color: ${this.s.listFocusForeground} !important; }`),this.s.decoratorRightForeground&&n.push(`.monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row:not(.focused) .option-decorator-right { color: ${this.s.decoratorRightForeground}; }`),this.s.selectBackground&&this.s.selectBorder&&this.s.selectBorder!==this.s.selectBackground?(n.push(`.monaco-select-box-dropdown-container { border: 1px solid ${this.s.selectBorder} } `),n.push(`.monaco-select-box-dropdown-container > .select-box-details-pane.border-top { border-top: 1px solid ${this.s.selectBorder} } `),n.push(`.monaco-select-box-dropdown-container > .select-box-details-pane.border-bottom { border-bottom: 1px solid ${this.s.selectBorder} } `)):this.s.selectListBorder&&(n.push(`.monaco-select-box-dropdown-container > .select-box-details-pane.border-top { border-top: 1px solid ${this.s.selectListBorder} } `),n.push(`.monaco-select-box-dropdown-container > .select-box-details-pane.border-bottom { border-bottom: 1px solid ${this.s.selectListBorder} } `)),this.s.listHoverForeground&&n.push(`.monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row:not(.option-disabled):not(.focused):hover { color: ${this.s.listHoverForeground} !important; }`),this.s.listHoverBackground&&n.push(`.monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row:not(.option-disabled):not(.focused):hover { background-color: ${this.s.listHoverBackground} !important; }`),this.s.listFocusOutline&&n.push(`.monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row.focused { outline: 1.6px dotted ${this.s.listFocusOutline} !important; outline-offset: -1.6px !important; }`),this.s.listHoverOutline&&n.push(`.monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row:not(.option-disabled):not(.focused):hover { outline: 1.6px dashed ${this.s.listHoverOutline} !important; outline-offset: -1.6px !important; }`),n.push(".monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row.option-disabled.focused { background-color: transparent !important; color: inherit !important; outline: none !important; }"),n.push(".monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row.option-disabled:hover { background-color: transparent !important; color: inherit !important; outline: none !important; }"),this.y.textContent=n.join(`
`)}R(){const n=this.s.selectBackground??"",r=this.s.selectForeground??"",b=this.s.selectBorder??"";this.h.style.backgroundColor=n,this.h.style.color=r,this.h.style.borderColor=b}S(){const n=this.s.selectBackground??"",r=v.$iQ(this.s.selectListBackground,n);this.C.style.backgroundColor=r,this.I.style.backgroundColor=r;const b=this.s.focusBorder??"";this.w.style.outlineColor=b,this.w.style.outlineOffset="-1px",this.z.style(this.s)}U(n,r,b){const u=document.createElement("option");return u.value=n,u.text=n,u.disabled=!!b,u}W(){this.I.innerText="",!(!this.u||this.f)&&(this.cb(this.w),this.P(),this.u.showContextView({getAnchor:()=>this.h,render:n=>this.Y(n,!0),layout:()=>{this.ab()},onHide:()=>{this.w.classList.remove("visible"),this.h.classList.remove("synthetic-focus")},anchorPosition:this.G},this.g.optionsAsChildren?this.j:void 0),this.f=!0,this.X(!1),this.u.showContextView({getAnchor:()=>this.h,render:n=>this.Y(n),layout:()=>this.ab(),onHide:()=>{this.w.classList.remove("visible"),this.h.classList.remove("synthetic-focus")},anchorPosition:this.G},this.g.optionsAsChildren?this.j:void 0),this.F=this.n,this.f=!0,this.h.setAttribute("aria-expanded","true"))}X(n){!this.u||!this.f||(this.f=!1,this.h.setAttribute("aria-expanded","false"),n&&this.h.focus(),this.u.hideContextView())}Y(n,r){return n.appendChild(this.w),this.ab(r),{dispose:()=>{try{n.removeChild(this.w)}catch{}}}}Z(){let n=0;return this.m.forEach((r,b)=>{this.hb(b),this.I.offsetHeight>n&&(n=this.I.offsetHeight)}),n}ab(n){if(this.J)return!1;if(this.z){this.w.classList.add("visible");const r=v.$IP(this.h),b=v.$mP(this.h),u=v.$IP(this.h).getComputedStyle(this.h),o=parseFloat(u.getPropertyValue("--dropdown-padding-top"))+parseFloat(u.getPropertyValue("--dropdown-padding-bottom")),F=r.innerHeight-b.top-b.height-(this.g.minBottomMargin||0),z=b.top-l.b,R=this.h.offsetWidth,g=this.bb(this.D),y=Math.max(g,Math.round(R)).toString()+"px";this.w.style.width=y,this.z.getHTMLElement().style.height="",this.z.layout();let M=this.z.contentHeight;this.H&&this.L===void 0&&(this.L=this.Z());const _=this.H?this.L:0,x=M+o+_,O=Math.floor((F-o-_)/this.getHeight()),B=Math.floor((z-o-_)/this.getHeight());if(n)return b.top+b.height>r.innerHeight-22||b.top<l.b||O<1&&B<1?!1:(O<l.c&&B>O&&this.m.length>O?(this.G=1,this.w.removeChild(this.C),this.w.removeChild(this.I),this.w.appendChild(this.I),this.w.appendChild(this.C),this.I.classList.remove("border-top"),this.I.classList.add("border-bottom")):(this.G=0,this.w.removeChild(this.C),this.w.removeChild(this.I),this.w.appendChild(this.C),this.w.appendChild(this.I),this.I.classList.remove("border-bottom"),this.I.classList.add("border-top")),!0);if(b.top+b.height>r.innerHeight-22||b.top<l.b||this.G===0&&O<1||this.G===1&&B<1)return this.X(!0),!1;if(this.G===0){if(this.f&&O+B<1)return this.X(!0),!1;x>F&&(M=O*this.getHeight())}else x>z&&(M=B*this.getHeight());return this.z.layout(M),this.z.domFocus(),this.z.length>0&&(this.z.setFocus([this.n||0]),this.z.reveal(this.z.getFocus()[0]||0)),this.H?(this.z.getHTMLElement().style.height=M+o+"px",this.w.style.height=""):this.w.style.height=M+o+"px",this.hb(this.n),this.w.style.width=y,this.C.setAttribute("tabindex","0"),this.h.classList.add("synthetic-focus"),this.w.classList.add("synthetic-focus"),!0}else return!1}bb(n){let r=0;if(n){let b=0,u=0;this.m.forEach((o,F)=>{const z=o.detail?o.detail.length:0,R=o.decoratorRight?o.decoratorRight.length:0,g=o.text.length+z+R;g>u&&(b=F,u=g)}),n.textContent=this.m[b].text+(this.m[b].decoratorRight?this.m[b].decoratorRight+" ":""),r=v.$oP(n)}return r}cb(n){if(this.z)return;this.C=v.$3P(n,a(".select-box-dropdown-list-container")),this.t=new h,this.z=new w.$rR("SelectBoxCustom",this.C,this,[this.t],{useShadows:!1,verticalScrollMode:3,keyboardSupport:!1,mouseSupport:!1,accessibilityProvider:{getAriaLabel:u=>{let o=u.text;return u.detail&&(o+=`. ${u.detail}`),u.decoratorRight&&(o+=`. ${u.decoratorRight}`),u.description&&(o+=`. ${u.description}`),o},getWidgetAriaLabel:()=>(0,s.localize)(0,null),getRole:()=>T.$j?"":"option",getWidgetRole:()=>"listbox"}}),this.g.ariaLabel&&(this.z.ariaLabel=this.g.ariaLabel);const r=this.B(new N.$4Q(this.C,"keydown")),b=c.Event.chain(r.event,u=>u.filter(()=>this.z.length>0).map(o=>new i.$ZO(o)));this.B(c.Event.chain(b,u=>u.filter(o=>o.keyCode===3))(this.jb,this)),this.B(c.Event.chain(b,u=>u.filter(o=>o.keyCode===2))(this.jb,this)),this.B(c.Event.chain(b,u=>u.filter(o=>o.keyCode===9))(this.ib,this)),this.B(c.Event.chain(b,u=>u.filter(o=>o.keyCode===16))(this.lb,this)),this.B(c.Event.chain(b,u=>u.filter(o=>o.keyCode===18))(this.kb,this)),this.B(c.Event.chain(b,u=>u.filter(o=>o.keyCode===12))(this.nb,this)),this.B(c.Event.chain(b,u=>u.filter(o=>o.keyCode===11))(this.mb,this)),this.B(c.Event.chain(b,u=>u.filter(o=>o.keyCode===14))(this.ob,this)),this.B(c.Event.chain(b,u=>u.filter(o=>o.keyCode===13))(this.pb,this)),this.B(c.Event.chain(b,u=>u.filter(o=>o.keyCode>=21&&o.keyCode<=56||o.keyCode>=85&&o.keyCode<=113))(this.qb,this)),this.B(v.$3O(this.z.getHTMLElement(),v.$VP.POINTER_UP,u=>this.db(u))),this.B(this.z.onMouseOver(u=>typeof u.index<"u"&&this.z.setFocus([u.index]))),this.B(this.z.onDidChangeFocus(u=>this.gb(u))),this.B(v.$3O(this.w,v.$VP.FOCUS_OUT,u=>{!this.f||v.$uP(u.relatedTarget,this.w)||this.eb()})),this.z.getHTMLElement().setAttribute("aria-label",this.g.ariaLabel||""),this.z.getHTMLElement().setAttribute("aria-expanded","true"),this.S()}db(n){if(!this.z.length)return;v.$XP.stop(n);const r=n.target;if(!r||r.classList.contains("slider"))return;const b=r.closest(".monaco-list-row");if(!b)return;const u=Number(b.getAttribute("data-index")),o=b.classList.contains("option-disabled");u>=0&&u<this.m.length&&!o&&(this.n=u,this.select(this.n),this.z.setFocus([this.n]),this.z.reveal(this.z.getFocus()[0]),this.n!==this.F&&(this.F=this.n,this.r.fire({index:this.h.selectedIndex,selected:this.m[this.n].text}),this.m[this.n]&&this.m[this.n].text&&(this.h.title=this.m[this.n].text)),this.X(!0))}eb(){this.M||(this.n!==this.F&&this.select(this.F),this.X(!1))}fb(n,r){const b=o=>{for(let F=0;F<o.childNodes.length;F++){const z=o.childNodes.item(F);(z.tagName&&z.tagName.toLowerCase())==="img"?o.removeChild(z):b(z)}},u=(0,U.$uR)({value:n,supportThemeIcons:!0},{actionHandler:r});return u.element.classList.add("select-box-description-markdown"),b(u.element),u.element}gb(n){!this.f||!this.H||this.hb(n.indexes[0])}hb(n){this.I.innerText="";const r=this.m[n],b=r?.description??"",u=r?.descriptionIsMarkdown??!1;if(b){if(u){const o=r.descriptionMarkdownActionHandler;this.I.appendChild(this.fb(b,o))}else this.I.innerText=b;this.I.style.display="block"}else this.I.style.display="none";this.J=!0,this.u.layout(),this.J=!1}ib(n){v.$XP.stop(n),this.select(this.F),this.X(!0)}jb(n){v.$XP.stop(n),this.n!==this.F&&(this.F=this.n,this.r.fire({index:this.h.selectedIndex,selected:this.m[this.n].text}),this.m[this.n]&&this.m[this.n].text&&(this.h.title=this.m[this.n].text)),this.X(!0)}kb(n){if(this.n<this.m.length-1){v.$XP.stop(n,!0);const r=this.m[this.n+1].isDisabled;if(r&&this.m.length>this.n+2)this.n+=2;else{if(r)return;this.n++}this.select(this.n),this.z.setFocus([this.n]),this.z.reveal(this.z.getFocus()[0])}}lb(n){this.n>0&&(v.$XP.stop(n,!0),this.m[this.n-1].isDisabled&&this.n>1?this.n-=2:this.n--,this.select(this.n),this.z.setFocus([this.n]),this.z.reveal(this.z.getFocus()[0]))}mb(n){v.$XP.stop(n),this.z.focusPreviousPage(),setTimeout(()=>{this.n=this.z.getFocus()[0],this.m[this.n].isDisabled&&this.n<this.m.length-1&&(this.n++,this.z.setFocus([this.n])),this.z.reveal(this.n),this.select(this.n)},1)}nb(n){v.$XP.stop(n),this.z.focusNextPage(),setTimeout(()=>{this.n=this.z.getFocus()[0],this.m[this.n].isDisabled&&this.n>0&&(this.n--,this.z.setFocus([this.n])),this.z.reveal(this.n),this.select(this.n)},1)}ob(n){v.$XP.stop(n),!(this.m.length<2)&&(this.n=0,this.m[this.n].isDisabled&&this.n>1&&this.n++,this.z.setFocus([this.n]),this.z.reveal(this.n),this.select(this.n))}pb(n){v.$XP.stop(n),!(this.m.length<2)&&(this.n=this.m.length-1,this.m[this.n].isDisabled&&this.n>1&&this.n--,this.z.setFocus([this.n]),this.z.reveal(this.n),this.select(this.n))}qb(n){const r=f.KeyCodeUtils.toString(n.keyCode);let b=-1;for(let u=0;u<this.m.length-1;u++)if(b=(u+this.n+1)%this.m.length,this.m[b].text.charAt(0).toUpperCase()===r&&!this.m[b].isDisabled){this.select(b),this.z.setFocus([b]),this.z.reveal(this.z.getFocus()[0]),v.$XP.stop(n);break}}dispose(){this.X(!1),super.dispose()}}t.$zR=l}),define(be[128],pe([1,0,39,127,121,20,5,99]),function(ae,t,v,N,i,U,w){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$CR=t.$BR=void 0,t.$BR={...v.$qR,selectBackground:"#3C3C3C",selectForeground:"#F0F0F0",selectBorder:"#3C3C3C",decoratorRightForeground:void 0,selectListBackground:void 0,selectListBorder:void 0,focusBorder:void 0};class D extends U.$DQ{constructor(f,d,T,s,a){super(),w.$j&&!a?.useCustomDrawn?this.a=new i.$AR(f,d,s,a):this.a=new N.$zR(f,d,T,s,a),this.B(this.a)}get onDidSelect(){return this.a.onDidSelect}setOptions(f,d){this.a.setOptions(f,d)}select(f){this.a.select(f)}setAriaLabel(f){this.a.setAriaLabel(f)}focus(){this.a.focus()}blur(){this.a.blur()}setFocusable(f){this.a.setFocusable(f)}render(f){this.a.render(f)}}t.$CR=D}),define(be[63],pe([1,0,16,54,3,24,126,128,36,2,5,7,104,52]),function(ae,t,v,N,i,U,w,D,c,f,d,T,s){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$JR=t.$IR=t.$HR=void 0;class a extends f.$Rc{get action(){return this._action}constructor(m,n,r={}){super(),this.m=r,this._context=m||this,this._action=n,n instanceof c.$Ai&&this.B(n.onDidChange(b=>{this.element&&this.t(b)}))}t(m){m.enabled!==void 0&&this.u(),m.checked!==void 0&&this.G(),m.class!==void 0&&this.F(),m.label!==void 0&&(this.w(),this.C()),m.tooltip!==void 0&&this.C()}get actionRunner(){return this.j||(this.j=this.B(new c.$Bi)),this.j}set actionRunner(m){this.j=m}isEnabled(){return this._action.enabled}setActionContext(m){this._context=m}render(m){const n=this.element=m;this.B(U.$zQ.addTarget(m));const r=this.m&&this.m.draggable;r&&(m.draggable=!0,v.$IO&&this.B((0,i.$3O)(m,i.$VP.DRAG_START,b=>b.dataTransfer?.setData(N.$xQ.TEXT,this._action.label)))),this.B((0,i.$3O)(n,U.EventType.Tap,b=>this.onClick(b,!0))),this.B((0,i.$3O)(n,i.$VP.MOUSE_DOWN,b=>{r||i.$XP.stop(b,!0),this._action.enabled&&b.button===0&&n.classList.add("active")})),d.$j&&this.B((0,i.$3O)(n,i.$VP.CONTEXT_MENU,b=>{b.button===0&&b.ctrlKey===!0&&this.onClick(b)})),this.B((0,i.$3O)(n,i.$VP.CLICK,b=>{i.$XP.stop(b,!0),this.m&&this.m.isMenu||this.onClick(b)})),this.B((0,i.$3O)(n,i.$VP.DBLCLICK,b=>{i.$XP.stop(b,!0)})),[i.$VP.MOUSE_UP,i.$VP.MOUSE_OUT].forEach(b=>{this.B((0,i.$3O)(n,b,u=>{i.$XP.stop(u),n.classList.remove("active")}))})}onClick(m,n=!1){i.$XP.stop(m,!0);const r=T.$Lf(this._context)?this.m?.useEventAsContext?m:{preserveFocus:n}:this._context;this.actionRunner.run(this._action,r)}focus(){this.element&&(this.element.tabIndex=0,this.element.focus(),this.element.classList.add("focused"))}isFocused(){return!!this.element?.classList.contains("focused")}blur(){this.element&&(this.element.blur(),this.element.tabIndex=-1,this.element.classList.remove("focused"))}setFocusable(m){this.element&&(this.element.tabIndex=m?0:-1)}get trapsArrowNavigation(){return!1}u(){}w(){}z(){return this.action.tooltip}C(){if(!this.element)return;const m=this.z()??"";this.D(),this.m.hoverDelegate?(this.element.title="",this.f?this.f.update(m):(this.f=(0,w.$UQ)(this.m.hoverDelegate,this.element,m),this.q.add(this.f))):this.element.title=m}D(){if(this.element){const m=this.z()??"";this.element.setAttribute("aria-label",m)}}F(){}G(){}dispose(){this.element&&(this.element.remove(),this.element=void 0),this._context=void 0,super.dispose()}}t.$HR=a;class e extends a{constructor(m,n,r){super(m,n,r),this.m=r,this.m.icon=r.icon!==void 0?r.icon:!1,this.m.label=r.label!==void 0?r.label:!0,this.J=""}render(m){super.render(m),T.$Mf(this.element);const n=document.createElement("a");if(n.classList.add("action-label"),n.setAttribute("role",this.L()),this.H=n,this.element.appendChild(n),this.m.label&&this.m.keybinding){const r=document.createElement("span");r.classList.add("keybinding"),r.textContent=this.m.keybinding,this.element.appendChild(r)}this.F(),this.w(),this.C(),this.u(),this.G()}L(){return this._action.id===c.$Ci.ID?"presentation":this.m.isMenu?"menuitem":"button"}focus(){this.H&&(this.H.tabIndex=0,this.H.focus())}isFocused(){return!!this.H&&this.H?.tabIndex===0}blur(){this.H&&(this.H.tabIndex=-1)}setFocusable(m){this.H&&(this.H.tabIndex=m?0:-1)}w(){this.m.label&&this.H&&(this.H.textContent=this.action.label)}z(){let m=null;return this.action.tooltip?m=this.action.tooltip:!this.m.label&&this.action.label&&this.m.icon&&(m=this.action.label,this.m.keybinding&&(m=s.localize(0,null,m,this.m.keybinding))),m??void 0}F(){this.J&&this.H&&this.H.classList.remove(...this.J.split(" ")),this.m.icon?(this.J=this.action.class,this.H&&(this.H.classList.add("codicon"),this.J&&this.H.classList.add(...this.J.split(" "))),this.u()):this.H?.classList.remove("codicon")}u(){this.action.enabled?(this.H&&(this.H.removeAttribute("aria-disabled"),this.H.classList.remove("disabled")),this.element?.classList.remove("disabled")):(this.H&&(this.H.setAttribute("aria-disabled","true"),this.H.classList.add("disabled")),this.element?.classList.add("disabled"))}D(){if(this.H){const m=this.z()??"";this.H.setAttribute("aria-label",m)}}G(){this.H&&(this.action.checked!==void 0?(this.H.classList.toggle("checked",this.action.checked),this.H.setAttribute("aria-checked",this.action.checked?"true":"false"),this.H.setAttribute("role","checkbox")):(this.H.classList.remove("checked"),this.H.setAttribute("aria-checked",""),this.H.setAttribute("role",this.L())))}}t.$IR=e;class h extends a{constructor(m,n,r,b,u,o,F){super(m,n),this.b=new D.$CR(r,b,u,o,F),this.b.setFocusable(!1),this.B(this.b),this.g()}setOptions(m,n){this.b.setOptions(m,n)}select(m){this.b.select(m)}g(){this.B(this.b.onDidSelect(m=>this.n(m.selected,m.index)))}n(m,n){this.actionRunner.run(this._action,this.r(m,n))}r(m,n){return m}setFocusable(m){this.b.setFocusable(m)}focus(){this.b?.focus()}blur(){this.b?.blur()}render(m){this.b.render(m)}}t.$JR=h}),define(be[64],pe([1,0,3,14,63,36,4,2,7,52]),function(ae,t,v,N,i,U,w,D,c){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$WQ=t.$VQ=t.ActionsOrientation=void 0;var f;(function(s){s[s.HORIZONTAL=0]="HORIZONTAL",s[s.VERTICAL=1]="VERTICAL"})(f||(t.ActionsOrientation=f={}));class d extends D.$Rc{constructor(a,e={}){super(),this.g=this.B(new D.$Qc),this.r=this.B(new D.$1c),this.w=!1,this.y=!0,this.C=this.B(new w.$Rd),this.onDidBlur=this.C.event,this.D=this.B(new w.$Rd({onWillAddFirstListener:()=>this.F=!0})),this.onDidCancel=this.D.event,this.F=!1,this.G=this.B(new w.$Rd),this.onDidRun=this.G.event,this.H=this.B(new w.$Rd),this.onWillRun=this.H.event,this.b=e,this.j=e.context??null,this.m=this.b.orientation??0,this.n={keyDown:this.b.triggerKeys?.keyDown??!1,keys:this.b.triggerKeys?.keys??[3,10]},this.b.actionRunner?this.f=this.b.actionRunner:(this.f=new U.$Bi,this.g.add(this.f)),this.g.add(this.f.onDidRun(m=>this.G.fire(m))),this.g.add(this.f.onWillRun(m=>this.H.fire(m))),this.viewItems=[],this.t=void 0,this.domNode=document.createElement("div"),this.domNode.className="monaco-action-bar",e.animated!==!1&&this.domNode.classList.add("animated");let h,l;switch(this.m){case 0:h=[15],l=[17];break;case 1:h=[16],l=[18],this.domNode.className+=" vertical";break}this.B(v.$3O(this.domNode,v.$VP.KEY_DOWN,m=>{const n=new N.$ZO(m);let r=!0;const b=typeof this.t=="number"?this.viewItems[this.t]:void 0;h&&(n.equals(h[0])||n.equals(h[1]))?r=this.P():l&&(n.equals(l[0])||n.equals(l[1]))?r=this.O():n.equals(9)&&this.F?this.D.fire():n.equals(14)?r=this.M():n.equals(13)?r=this.N():n.equals(2)&&b instanceof i.$HR&&b.trapsArrowNavigation?r=this.O():this.J(n)?this.n.keyDown?this.R(n):this.w=!0:r=!1,r&&(n.preventDefault(),n.stopPropagation())})),this.B(v.$3O(this.domNode,v.$VP.KEY_UP,m=>{const n=new N.$ZO(m);this.J(n)?(!this.n.keyDown&&this.w&&(this.w=!1,this.R(n)),n.preventDefault(),n.stopPropagation()):(n.equals(2)||n.equals(1026))&&this.L()})),this.u=this.B(v.$1P(this.domNode)),this.B(this.u.onDidBlur(()=>{(v.$CP()===this.domNode||!v.$uP(v.$CP(),this.domNode))&&(this.C.fire(),this.s=this.t,this.t=void 0,this.w=!1)})),this.B(this.u.onDidFocus(()=>this.L())),this.z=document.createElement("ul"),this.z.className="actions-container",this.b.highlightToggledItems&&this.z.classList.add("highlight-toggled"),this.z.setAttribute("role",this.b.ariaRole||"toolbar"),this.b.ariaLabel&&this.z.setAttribute("aria-label",this.b.ariaLabel),this.domNode.appendChild(this.z),a.appendChild(this.domNode)}I(){this.length()>=2?this.z.setAttribute("role",this.b.ariaRole||"toolbar"):this.z.setAttribute("role","presentation")}setAriaLabel(a){a?this.z.setAttribute("aria-label",a):this.z.removeAttribute("aria-label")}setFocusable(a){if(this.y=a,this.y){const e=this.viewItems.find(h=>h instanceof i.$HR&&h.isEnabled());e instanceof i.$HR&&e.setFocusable(!0)}else this.viewItems.forEach(e=>{e instanceof i.$HR&&e.setFocusable(!1)})}J(a){let e=!1;return this.n.keys.forEach(h=>{e=e||a.equals(h)}),e}L(){for(let a=0;a<this.z.children.length;a++){const e=this.z.children[a];if(v.$uP(v.$CP(),e)){this.t=a,this.viewItems[this.t]?.showHover?.();break}}}get context(){return this.j}set context(a){this.j=a,this.viewItems.forEach(e=>e.setActionContext(a))}get actionRunner(){return this.f}set actionRunner(a){this.f=a,this.g.clear(),this.g.add(this.f.onDidRun(e=>this.G.fire(e))),this.g.add(this.f.onWillRun(e=>this.H.fire(e))),this.viewItems.forEach(e=>e.actionRunner=a)}getContainer(){return this.domNode}hasAction(a){return this.viewItems.findIndex(e=>e.action.id===a.id)!==-1}getAction(a){if(typeof a=="number")return this.viewItems[a]?.action;if(a instanceof HTMLElement){for(;a.parentElement!==this.z;){if(!a.parentElement)return;a=a.parentElement}for(let e=0;e<this.z.childNodes.length;e++)if(this.z.childNodes[e]===a)return this.viewItems[e].action}}push(a,e={}){const h=Array.isArray(a)?a:[a];let l=c.$Gf(e.index)?e.index:null;h.forEach(m=>{const n=document.createElement("li");n.className="action-item",n.setAttribute("role","presentation");let r;const b={hoverDelegate:this.b.hoverDelegate,...e};this.b.actionViewItemProvider&&(r=this.b.actionViewItemProvider(m,b)),r||(r=new i.$IR(this.context,m,b)),this.b.allowContextMenu||this.r.set(r,v.$3O(n,v.$VP.CONTEXT_MENU,u=>{v.$XP.stop(u,!0)})),r.actionRunner=this.f,r.setActionContext(this.context),r.render(n),this.y&&r instanceof i.$HR&&this.viewItems.length===0&&r.setFocusable(!0),l===null||l<0||l>=this.z.children.length?(this.z.appendChild(n),this.viewItems.push(r)):(this.z.insertBefore(n,this.z.children[l]),this.viewItems.splice(l,0,r),l++)}),typeof this.t=="number"&&this.focus(this.t),this.I()}getWidth(a){if(a>=0&&a<this.z.children.length){const e=this.z.children.item(a);if(e)return e.clientWidth}return 0}getHeight(a){if(a>=0&&a<this.z.children.length){const e=this.z.children.item(a);if(e)return e.clientHeight}return 0}pull(a){a>=0&&a<this.viewItems.length&&(this.z.removeChild(this.z.childNodes[a]),this.r.deleteAndDispose(this.viewItems[a]),(0,D.$Mc)(this.viewItems.splice(a,1)),this.I())}clear(){this.isEmpty()||(this.viewItems=(0,D.$Mc)(this.viewItems),this.r.clearAndDisposeAll(),v.$2O(this.z),this.I())}length(){return this.viewItems.length}isEmpty(){return this.viewItems.length===0}focus(a){let e=!1,h;if(a===void 0?e=!0:typeof a=="number"?h=a:typeof a=="boolean"&&(e=a),e&&typeof this.t>"u"){const l=this.viewItems.findIndex(m=>m.isEnabled());this.t=l===-1?void 0:l,this.Q(void 0,void 0,!0)}else h!==void 0&&(this.t=h),this.Q(void 0,void 0,!0)}M(){return this.t=this.length()-1,this.O(!0)}N(){return this.t=0,this.P(!0)}O(a){if(typeof this.t>"u")this.t=this.viewItems.length-1;else if(this.viewItems.length<=1)return!1;const e=this.t;let h;do{if(!a&&this.b.preventLoopNavigation&&this.t+1>=this.viewItems.length)return this.t=e,!1;this.t=(this.t+1)%this.viewItems.length,h=this.viewItems[this.t]}while(this.t!==e&&(this.b.focusOnlyEnabledItems&&!h.isEnabled()||h.action.id===U.$Ci.ID));return this.Q(),!0}P(a){if(typeof this.t>"u")this.t=0;else if(this.viewItems.length<=1)return!1;const e=this.t;let h;do{if(this.t=this.t-1,this.t<0){if(!a&&this.b.preventLoopNavigation)return this.t=e,!1;this.t=this.viewItems.length-1}h=this.viewItems[this.t]}while(this.t!==e&&(this.b.focusOnlyEnabledItems&&!h.isEnabled()||h.action.id===U.$Ci.ID));return this.Q(!0),!0}Q(a,e,h=!1){typeof this.t>"u"&&this.z.focus({preventScroll:e}),this.s!==void 0&&this.s!==this.t&&this.viewItems[this.s]?.blur();const l=this.t!==void 0?this.viewItems[this.t]:void 0;if(l){let m=!0;c.$Qf(l.focus)||(m=!1),this.b.focusOnlyEnabledItems&&c.$Qf(l.isEnabled)&&!l.isEnabled()&&(m=!1),l.action.id===U.$Ci.ID&&(m=!1),m&&l.showHover?.(),m?(h||this.s!==this.t)&&(l.focus(a),this.s=this.t):(this.z.focus({preventScroll:e}),this.s=void 0)}}R(a){if(typeof this.t>"u")return;const e=this.viewItems[this.t];if(e instanceof i.$HR){const h=e._context===null||e._context===void 0?a:e._context;this.run(e._action,h)}}async run(a,e){await this.f.run(a,e)}dispose(){this.j=void 0,this.viewItems=(0,D.$Mc)(this.viewItems),this.getContainer().remove(),super.dispose()}}t.$VQ=d;function T(s){if(!s.length)return s;let a=-1;for(let h=0;h<s.length;h++)if(s[h].id!==U.$Ci.ID){a=h;break}if(a===-1)return[];s=s.slice(a);for(let h=s.length-1;h>=0&&s[h].id===U.$Ci.ID;h--)s.splice(h,1);let e=!1;for(let h=s.length-1;h>=0;h--){const l=s[h].id===U.$Ci.ID;l&&!e?s.splice(h,1):l?l&&(e=!1):e=!0}return s}t.$WQ=T}),define(be[65],pe([1,0,3,22,55,64,57,60,20,4,81,51,108,96]),function(ae,t,v,N,i,U,w,D,c,f,d,T,s){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$oS=t.$nS=t.$mS=t.MessageType=void 0;const a=v.$;var e;(function(m){m[m.INFO=1]="INFO",m[m.WARNING=2]="WARNING",m[m.ERROR=3]="ERROR"})(e||(t.MessageType=e={})),t.$mS={inputBackground:"#3C3C3C",inputForeground:"#CCCCCC",inputValidationInfoBorder:"#55AAFF",inputValidationInfoBackground:"#063B49",inputValidationWarningBorder:"#B89500",inputValidationWarningBackground:"#352A05",inputValidationErrorBorder:"#BE1100",inputValidationErrorBackground:"#5A1D1D",inputBorder:void 0,inputValidationErrorForeground:void 0,inputValidationInfoForeground:void 0,inputValidationWarningForeground:void 0};class h extends c.$DQ{constructor(n,r,b){super(),this.w="idle",this.M=Number.POSITIVE_INFINITY,this.O=this.B(new f.$Rd),this.onDidChange=this.O.event,this.P=this.B(new f.$Rd),this.onDidHeightChange=this.P.event,this.a=r,this.g=b,this.h=null,this.n=this.g.placeholder||"",this.r=this.g.tooltip??(this.n||""),this.s=this.g.ariaLabel||"",this.g.validationOptions&&(this.t=this.g.validationOptions.validation),this.element=v.$3P(n,a(".monaco-inputbox.idle"));const u=this.g.flexibleHeight?"textarea":"input",o=v.$3P(this.element,a(".ibwrapper"));if(this.b=v.$3P(o,a(u+".input.empty")),this.b.setAttribute("autocorrect","off"),this.b.setAttribute("autocapitalize","off"),this.b.setAttribute("spellcheck","false"),this.G(this.b,()=>this.element.classList.add("synthetic-focus")),this.F(this.b,()=>this.element.classList.remove("synthetic-focus")),this.g.flexibleHeight){this.M=typeof this.g.flexibleMaxHeight=="number"?this.g.flexibleMaxHeight:Number.POSITIVE_INFINITY,this.y=v.$3P(o,a("div.mirror")),this.y.innerText="\xA0",this.N=new D.$NQ(this.element,{vertical:1}),this.g.flexibleWidth&&(this.b.setAttribute("wrap","off"),this.y.style.whiteSpace="pre",this.y.style.wordWrap="initial"),v.$3P(n,this.N.getDomNode()),this.B(this.N),this.B(this.N.onScroll(R=>this.b.scrollTop=R.scrollTop));const F=this.B(new N.$4Q(n.ownerDocument,"selectionchange")),z=f.Event.filter(F.event,()=>n.ownerDocument.getSelection()?.anchorNode===o);this.B(z(this.S,this)),this.B(this.onDidHeightChange(this.S,this))}else this.b.type=this.g.type||"text",this.b.setAttribute("wrap","off");this.s&&this.b.setAttribute("aria-label",this.s),this.n&&!this.g.showPlaceholderOnFocus&&this.setPlaceHolder(this.n),this.r&&this.setTooltip(this.r),this.D(this.b,()=>this.Y()),this.F(this.b,()=>this.Q()),this.G(this.b,()=>this.R()),this.B(this.I(this.b)),setTimeout(()=>this.Z(),0),this.g.actions&&(this.c=this.B(new U.$VQ(this.element)),this.c.push(this.g.actions,{icon:!0,label:!1})),this.ab()}Q(){this.X(),this.g.showPlaceholderOnFocus&&this.b.setAttribute("placeholder","")}R(){this.W(),this.g.showPlaceholderOnFocus&&this.b.setAttribute("placeholder",this.n||"")}setPlaceHolder(n){this.n=n,this.b.setAttribute("placeholder",n)}setTooltip(n){this.r=n,this.b.title=n}setAriaLabel(n){this.s=n,n?this.b.setAttribute("aria-label",this.s):this.b.removeAttribute("aria-label")}getAriaLabel(){return this.s}get mirrorElement(){return this.y}get inputElement(){return this.b}get value(){return this.b.value}set value(n){this.b.value!==n&&(this.b.value=n,this.Y())}get step(){return this.b.step}set step(n){this.b.step=n}get height(){return typeof this.J=="number"?this.J:v.$sP(this.element)}focus(){this.b.focus()}blur(){this.b.blur()}hasFocus(){return v.$DP(this.b)}select(n=null){this.b.select(),n&&(this.b.setSelectionRange(n.start,n.end),n.end===this.b.value.length&&(this.b.scrollLeft=this.b.scrollWidth))}isSelectionAtEnd(){return this.b.selectionEnd===this.b.value.length&&this.b.selectionStart===this.b.selectionEnd}enable(){this.b.removeAttribute("disabled")}disable(){this.blur(),this.b.disabled=!0,this.X()}setEnabled(n){n?this.enable():this.disable()}get width(){return v.$oP(this.b)}set width(n){if(this.g.flexibleHeight&&this.g.flexibleWidth){let r=0;if(this.y){const b=parseFloat(this.y.style.paddingLeft||"")||0,u=parseFloat(this.y.style.paddingRight||"")||0;r=b+u}this.b.style.width=n-r+"px"}else this.b.style.width=n+"px";this.y&&(this.y.style.width=n+"px")}set paddingRight(n){this.b.style.width=`calc(100% - ${n}px)`,this.y&&(this.y.style.paddingRight=n+"px")}S(){if(typeof this.L!="number"||typeof this.J!="number"||!this.N)return;const n=this.L,r=this.J,b=this.b.scrollTop;this.N.setScrollDimensions({scrollHeight:n,height:r}),this.N.setScrollPosition({scrollTop:b})}showMessage(n,r){if(this.w==="open"&&(0,T.$en)(this.h,n))return;this.h=n,this.element.classList.remove("idle"),this.element.classList.remove("info"),this.element.classList.remove("warning"),this.element.classList.remove("error"),this.element.classList.add(this.U(n.type));const b=this.stylesForType(this.h.type);this.element.style.border=`1px solid ${v.$iQ(b.border,"transparent")}`,this.h.content&&(this.hasFocus()||r)&&this.W()}hideMessage(){this.h=null,this.element.classList.remove("info"),this.element.classList.remove("warning"),this.element.classList.remove("error"),this.element.classList.add("idle"),this.X(),this.ab()}isInputValid(){return!!this.t&&!this.t(this.value)}validate(){let n=null;return this.t&&(n=this.t(this.value),n?(this.inputElement.setAttribute("aria-invalid","true"),this.showMessage(n)):this.inputElement.hasAttribute("aria-invalid")&&(this.inputElement.removeAttribute("aria-invalid"),this.hideMessage())),n?.type}stylesForType(n){const r=this.g.inputBoxStyles;switch(n){case 1:return{border:r.inputValidationInfoBorder,background:r.inputValidationInfoBackground,foreground:r.inputValidationInfoForeground};case 2:return{border:r.inputValidationWarningBorder,background:r.inputValidationWarningBackground,foreground:r.inputValidationWarningForeground};default:return{border:r.inputValidationErrorBorder,background:r.inputValidationErrorBackground,foreground:r.inputValidationErrorForeground}}}U(n){switch(n){case 1:return"info";case 2:return"warning";default:return"error"}}W(){if(!this.a||!this.h)return;let n;const r=()=>n.style.width=v.$oP(this.element)+"px";this.a.showContextView({getAnchor:()=>this.element,anchorAlignment:1,render:u=>{if(!this.h)return null;n=v.$3P(u,a(".monaco-inputbox-container")),r();const o={inline:!0,className:"monaco-inputbox-message"},F=this.h.formatContent?(0,i.$2Q)(this.h.content,o):(0,i.$1Q)(this.h.content,o);F.classList.add(this.U(this.h.type));const z=this.stylesForType(this.h.type);return F.style.backgroundColor=z.background??"",F.style.color=z.foreground??"",F.style.border=z.border?`1px solid ${z.border}`:"",v.$3P(n,F),null},onHide:()=>{this.w="closed"},layout:r});let b;this.h.type===3?b=s.localize(0,null,this.h.content):this.h.type===2?b=s.localize(1,null,this.h.content):b=s.localize(2,null,this.h.content),w.$6Q(b),this.w="open"}X(){this.a&&(this.w==="open"&&this.a.hideContextView(),this.w="idle")}Y(){this.O.fire(this.value),this.validate(),this.Z(),this.b.classList.toggle("empty",!this.value),this.w==="open"&&this.a&&this.a.layout()}Z(){if(!this.y)return;const n=this.value,b=n.charCodeAt(n.length-1)===10?" ":"";(n+b).replace(/\u000c/g,"")?this.y.textContent=n+b:this.y.innerText="\xA0",this.layout()}ab(){const n=this.g.inputBoxStyles,r=n.inputBackground??"",b=n.inputForeground??"",u=n.inputBorder??"";this.element.style.backgroundColor=r,this.element.style.color=b,this.b.style.backgroundColor="inherit",this.b.style.color=b,this.element.style.border=`1px solid ${v.$iQ(u,"transparent")}`}layout(){if(!this.y)return;const n=this.L;this.L=v.$sP(this.y),n!==this.L&&(this.J=Math.min(this.L,this.M),this.b.style.height=this.J+"px",this.P.fire(this.L))}insertAtCursor(n){const r=this.inputElement,b=r.selectionStart,u=r.selectionEnd,o=r.value;b!==null&&u!==null&&(this.value=o.substr(0,b)+n+o.substr(u),r.setSelectionRange(b+1,b+1),this.layout())}dispose(){this.X(),this.h=null,this.c?.dispose(),super.dispose()}}t.$nS=h;class l extends h{constructor(n,r,b){const u=s.localize(3,null,"\u21C5"),o=s.localize(4,null,"\u21C5");super(n,r,b),this.db=this.B(new f.$Rd),this.onDidFocus=this.db.event,this.eb=this.B(new f.$Rd),this.onDidBlur=this.eb.event,this.bb=new d.$kS(b.history,100);const F=()=>{if(b.showHistoryHint&&b.showHistoryHint()&&!this.n.endsWith(u)&&!this.n.endsWith(o)&&this.bb.getHistory().length){const z=this.n.endsWith(")")?u:o,R=this.n+z;b.showPlaceholderOnFocus&&!v.$DP(this.b)?this.n=R:this.setPlaceHolder(R)}};this.cb=new MutationObserver((z,R)=>{z.forEach(g=>{g.target.textContent||F()})}),this.cb.observe(this.b,{attributeFilter:["class"]}),this.G(this.b,()=>F()),this.F(this.b,()=>{const z=R=>{if(this.n.endsWith(R)){const g=this.n.slice(0,this.n.length-R.length);return b.showPlaceholderOnFocus?this.n=g:this.setPlaceHolder(g),!0}else return!1};z(o)||z(u)})}dispose(){super.dispose(),this.cb&&(this.cb.disconnect(),this.cb=void 0)}addToHistory(n){this.value&&(n||this.value!==this.hb())&&this.bb.add(this.value)}prependHistory(n){const r=this.getHistory();this.clearHistory(),n.forEach(b=>{this.bb.add(b)}),r.forEach(b=>{this.bb.add(b)})}getHistory(){return this.bb.getHistory()}isAtFirstInHistory(){return this.bb.isFirst()}isAtLastInHistory(){return this.bb.isLast()}isNowhereInHistory(){return this.bb.isNowhere()}showNextValue(){this.bb.has(this.value)||this.addToHistory();let n=this.jb();n&&(n=n===this.value?this.jb():n),this.value=n??"",w.$7Q(this.value?this.value:s.localize(5,null))}showPreviousValue(){this.bb.has(this.value)||this.addToHistory();let n=this.ib();n&&(n=n===this.value?this.ib():n),n&&(this.value=n,w.$7Q(this.value))}clearHistory(){this.bb.clear()}setPlaceHolder(n){super.setPlaceHolder(n),this.setTooltip(n)}Q(){super.Q(),this.eb.fire()}R(){super.R(),this.db.fire()}hb(){let n=this.bb.current();return n||(n=this.bb.last(),this.bb.next()),n}ib(){return this.bb.previous()||this.bb.first()}jb(){return this.bb.next()}}t.$oS=l}),define(be[66],pe([1,0,63,20,17,18,4,3,101]),function(ae,t,v,N,i,U,w,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$GR=t.$FR=t.$ER=t.$DR=void 0,t.$DR={inputActiveOptionBorder:"#007ACC00",inputActiveOptionForeground:"#FFFFFF",inputActiveOptionBackground:"#0E639C50"};class c extends v.$HR{constructor(s,a,e){super(s,a,e),this.a=this.B(new f({actionClassName:this._action.class,isChecked:!!this._action.checked,title:this.m.keybinding?`${this._action.label} (${this.m.keybinding})`:this._action.label,notFocusable:!0,inputActiveOptionBackground:e.toggleStyles?.inputActiveOptionBackground,inputActiveOptionBorder:e.toggleStyles?.inputActiveOptionBorder,inputActiveOptionForeground:e.toggleStyles?.inputActiveOptionForeground})),this.B(this.a.onChange(()=>this._action.checked=!!this.a&&this.a.checked))}render(s){this.element=s,this.element.appendChild(this.a.domNode)}u(){this.a&&(this.isEnabled()?this.a.enable():this.a.disable())}G(){this.a.checked=!!this._action.checked}focus(){this.a.domNode.tabIndex=0,this.a.focus()}blur(){this.a.domNode.tabIndex=-1,this.a.domNode.blur()}setFocusable(s){this.a.domNode.tabIndex=s?0:-1}}t.$ER=c;class f extends N.$DQ{constructor(s){super(),this.a=this.B(new w.$Rd),this.onChange=this.a.event,this.b=this.B(new w.$Rd),this.onKeyDown=this.b.event,this.c=s,this.s=this.c.isChecked;const a=["monaco-custom-toggle"];this.c.icon&&(this.g=this.c.icon,a.push(...U.ThemeIcon.asClassNameArray(this.g))),this.c.actionClassName&&a.push(...this.c.actionClassName.split(" ")),this.s&&a.push("checked"),this.domNode=document.createElement("div"),this.domNode.title=this.c.title,this.domNode.classList.add(...a),this.c.notFocusable||(this.domNode.tabIndex=0),this.domNode.setAttribute("role","checkbox"),this.domNode.setAttribute("aria-checked",String(this.s)),this.domNode.setAttribute("aria-label",this.c.title),this.t(),this.f(this.domNode,e=>{this.enabled&&(this.checked=!this.s,this.a.fire(!1),e.preventDefault())}),this.B(this.I(this.domNode)),this.z(this.domNode,e=>{if(e.keyCode===10||e.keyCode===3){this.checked=!this.s,this.a.fire(!0),e.preventDefault(),e.stopPropagation();return}this.b.fire(e)})}get enabled(){return this.domNode.getAttribute("aria-disabled")!=="true"}focus(){this.domNode.focus()}get checked(){return this.s}set checked(s){this.s=s,this.domNode.setAttribute("aria-checked",String(this.s)),this.domNode.classList.toggle("checked",this.s),this.t()}setIcon(s){this.g&&this.domNode.classList.remove(...U.ThemeIcon.asClassNameArray(this.g)),this.g=s,this.g&&this.domNode.classList.add(...U.ThemeIcon.asClassNameArray(this.g))}width(){return 2+2+2+16}t(){this.domNode&&(this.domNode.style.borderColor=this.s&&this.c.inputActiveOptionBorder||"",this.domNode.style.color=this.s&&this.c.inputActiveOptionForeground||"inherit",this.domNode.style.backgroundColor=this.s&&this.c.inputActiveOptionBackground||"")}enable(){this.domNode.setAttribute("aria-disabled",String(!1))}disable(){this.domNode.setAttribute("aria-disabled",String(!0))}setTitle(s){this.domNode.title=s,this.domNode.setAttribute("aria-label",s)}}t.$FR=f;class d extends N.$DQ{constructor(s,a,e){super(),this.c=s,this.g=a,this.a=new f({title:this.c,isChecked:this.g,icon:i.$1j.check,actionClassName:"monaco-checkbox",...t.$DR}),this.domNode=this.a.domNode,this.b=e,this.h(),this.B(this.a.onChange(()=>this.h()))}get checked(){return this.a.checked}set checked(s){this.a.checked=s,this.h()}focus(){this.domNode.focus()}hasFocus(){return(0,D.$DP)(this.domNode)}h(){this.domNode.style.color=this.b.checkboxForeground||"",this.domNode.style.backgroundColor=this.b.checkboxBackground||"",this.domNode.style.borderColor=this.b.checkboxBorder||""}}t.$GR=d}),define(be[129],pe([1,0,66,17,106]),function(ae,t,v,N,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$BS=t.$AS=t.$zS=void 0;const U=i.localize(0,null),w=i.localize(1,null),D=i.localize(2,null);class c extends v.$FR{constructor(s){super({icon:N.$1j.caseSensitive,title:U+s.appendTitle,isChecked:s.isChecked,inputActiveOptionBorder:s.inputActiveOptionBorder,inputActiveOptionForeground:s.inputActiveOptionForeground,inputActiveOptionBackground:s.inputActiveOptionBackground})}}t.$zS=c;class f extends v.$FR{constructor(s){super({icon:N.$1j.wholeWord,title:w+s.appendTitle,isChecked:s.isChecked,inputActiveOptionBorder:s.inputActiveOptionBorder,inputActiveOptionForeground:s.inputActiveOptionForeground,inputActiveOptionBackground:s.inputActiveOptionBackground})}}t.$AS=f;class d extends v.$FR{constructor(s){super({icon:N.$1j.regex,title:D+s.appendTitle,isChecked:s.isChecked,inputActiveOptionBorder:s.inputActiveOptionBorder,inputActiveOptionForeground:s.inputActiveOptionForeground,inputActiveOptionBackground:s.inputActiveOptionBackground})}}t.$BS=d}),define(be[130],pe([1,0,3,129,65,20,4,105,2,95]),function(ae,t,v,N,i,U,w,D,c){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$CS=void 0;const f=D.localize(0,null);class d extends U.$DQ{static{this.OPTION_CHANGE="optionChange"}constructor(s,a,e){super(),this.n=!0,this.s=!1,this.w=this.B(new c.$Sc),this.N=[],this.O=this.B(new w.$Rd),this.onDidOptionChange=this.O.event,this.P=this.B(new w.$Rd),this.onKeyDown=this.P.event,this.Q=this.B(new w.$Rd),this.onMouseDown=this.Q.event,this.R=this.B(new w.$Rd),this.onInput=this.R.event,this.S=this.B(new w.$Rd),this.onKeyUp=this.S.event,this.U=this.B(new w.$Rd),this.onCaseSensitiveKeyDown=this.U.event,this.W=this.B(new w.$Rd),this.onRegexKeyDown=this.W.event,this.Y=0,this.a=e.placeholder||"",this.b=e.validation,this.c=e.label||f,this.h=!!e.showCommonFindToggles;const h=e.appendCaseSensitiveLabel||"",l=e.appendWholeWordsLabel||"",m=e.appendRegexLabel||"",n=e.history||[],r=!!e.flexibleHeight,b=!!e.flexibleWidth,u=e.flexibleMaxHeight;if(this.domNode=document.createElement("div"),this.domNode.classList.add("monaco-findInput"),this.inputBox=this.B(new i.$oS(this.domNode,a,{placeholder:this.a||"",ariaLabel:this.c||"",validationOptions:{validation:this.b},history:n,showHistoryHint:e.showHistoryHint,flexibleHeight:r,flexibleWidth:b,flexibleMaxHeight:u,inputBoxStyles:e.inputBoxStyles})),this.h){this.J=this.B(new N.$BS({appendTitle:m,isChecked:!1,...e.toggleStyles})),this.B(this.J.onChange(F=>{this.O.fire(F),!F&&this.n&&this.inputBox.focus(),this.validate()})),this.B(this.J.onKeyDown(F=>{this.W.fire(F)})),this.L=this.B(new N.$AS({appendTitle:l,isChecked:!1,...e.toggleStyles})),this.B(this.L.onChange(F=>{this.O.fire(F),!F&&this.n&&this.inputBox.focus(),this.validate()})),this.M=this.B(new N.$zS({appendTitle:h,isChecked:!1,...e.toggleStyles})),this.B(this.M.onChange(F=>{this.O.fire(F),!F&&this.n&&this.inputBox.focus(),this.validate()})),this.B(this.M.onKeyDown(F=>{this.U.fire(F)}));const o=[this.M.domNode,this.L.domNode,this.J.domNode];this.z(this.domNode,F=>{if(F.equals(15)||F.equals(17)||F.equals(9)){const z=o.indexOf(this.domNode.ownerDocument.activeElement);if(z>=0){let R=-1;F.equals(17)?R=(z+1)%o.length:F.equals(15)&&(z===0?R=o.length-1:R=z-1),F.equals(9)?(o[z].blur(),this.inputBox.focus()):R>=0&&o[R].focus(),v.$XP.stop(F,!0)}}})}this.y=document.createElement("div"),this.y.className="controls",this.y.style.display=this.h?"":"none",this.M&&this.y.append(this.M.domNode),this.L&&this.y.appendChild(this.L.domNode),this.J&&this.y.appendChild(this.J.domNode),this.setAdditionalToggles(e?.additionalToggles),this.y&&this.domNode.appendChild(this.y),s?.appendChild(this.domNode),this.B(v.$3O(this.inputBox.inputElement,"compositionstart",o=>{this.s=!0})),this.B(v.$3O(this.inputBox.inputElement,"compositionend",o=>{this.s=!1,this.R.fire()})),this.z(this.inputBox.inputElement,o=>this.P.fire(o)),this.C(this.inputBox.inputElement,o=>this.S.fire(o)),this.D(this.inputBox.inputElement,o=>this.R.fire()),this.j(this.inputBox.inputElement,o=>this.Q.fire(o))}get isImeSessionInProgress(){return this.s}get onDidChange(){return this.inputBox.onDidChange}layout(s){this.inputBox.layout(),this.X(s.collapsedFindWidget)}enable(){this.domNode.classList.remove("disabled"),this.inputBox.enable(),this.J?.enable(),this.L?.enable(),this.M?.enable();for(const s of this.N)s.enable()}disable(){this.domNode.classList.add("disabled"),this.inputBox.disable(),this.J?.disable(),this.L?.disable(),this.M?.disable();for(const s of this.N)s.disable()}setFocusInputOnOptionClick(s){this.n=s}setEnabled(s){s?this.enable():this.disable()}setAdditionalToggles(s){for(const a of this.N)a.domNode.remove();this.N=[],this.w.value=new c.$Qc;for(const a of s??[])this.w.value.add(a),this.y.appendChild(a.domNode),this.w.value.add(a.onChange(e=>{this.O.fire(e),!e&&this.n&&this.inputBox.focus()})),this.N.push(a);this.N.length>0&&(this.y.style.display=""),this.X()}X(s=!1){s?this.inputBox.paddingRight=0:this.inputBox.paddingRight=(this.M?.width()??0)+(this.L?.width()??0)+(this.J?.width()??0)+this.N.reduce((a,e)=>a+e.width(),0)}clear(){this.Z(),this.setValue(""),this.focus()}getValue(){return this.inputBox.value}setValue(s){this.inputBox.value!==s&&(this.inputBox.value=s)}onSearchSubmit(){this.inputBox.addToHistory()}select(){this.inputBox.select()}focus(){this.inputBox.focus()}getCaseSensitive(){return this.M?.checked??!1}setCaseSensitive(s){this.M&&(this.M.checked=s)}getWholeWords(){return this.L?.checked??!1}setWholeWords(s){this.L&&(this.L.checked=s)}getRegex(){return this.J?.checked??!1}setRegex(s){this.J&&(this.J.checked=s,this.validate())}focusOnCaseSensitive(){this.M?.focus()}focusOnRegex(){this.J?.focus()}highlightFindOptions(){this.domNode.classList.remove("highlight-"+this.Y),this.Y=1-this.Y,this.domNode.classList.add("highlight-"+this.Y)}validate(){this.inputBox.validate()}showMessage(s){this.inputBox.showMessage(s)}clearMessage(){this.inputBox.hideMessage()}Z(){this.inputBox.hideMessage()}}t.$CS=d}),define(be[131],pe([1,0,3,22,14,64,130,65,61,39,66,58,25,36,11,9,17,18,32,4,34,2,46,7,110,102]),function(ae,t,v,N,i,U,w,D,c,f,d,T,s,a,e,h,l,m,n,r,b,u,o,F,z){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$aT=t.TreeFindMatchType=t.TreeFindMode=t.$_S=t.$$S=t.RenderIndentGuides=t.$0S=t.$9S=void 0;class R extends c.$eR{set context($){this.c.context=$}get context(){return this.c.context}constructor($){super($.elements.map(W=>W.element)),this.c=$}}function g(q){return q instanceof c.$eR?new R(q):q}class y{constructor($,W){this.d=$,this.f=W,this.b=u.$Rc.None,this.c=new u.$Qc}getDragURI($){return this.f.getDragURI($.element)}getDragLabel($,W){if(this.f.getDragLabel)return this.f.getDragLabel($.map(Q=>Q.element),W)}onDragStart($,W){this.f.onDragStart?.(g($),W)}onDragOver($,W,Q,p,A=!0){const E=this.f.onDragOver(g($),W&&W.element,Q,p),I=this.a!==W;if(I&&(this.b.dispose(),this.a=W),typeof W>"u")return E;if(I&&typeof E!="boolean"&&E.autoExpand&&(this.b=(0,h.$Zg)(()=>{const H=this.d(),G=H.getNodeLocation(W);H.isCollapsed(G)&&H.setCollapsed(G,!1),this.a=void 0},500,this.c)),typeof E=="boolean"||!E.accept||typeof E.bubble>"u"||E.feedback){if(!A){const H=typeof E=="boolean"?E:E.accept,G=typeof E=="boolean"?void 0:E.effect;return{accept:H,effect:G,feedback:[Q]}}return E}if(E.bubble===1){const H=this.d(),G=H.getNodeLocation(W),ee=H.getParentNodeLocation(G),se=H.getNode(ee),me=ee&&H.getListIndex(ee);return this.onDragOver($,se,me,p,!1)}const k=this.d(),L=k.getNodeLocation(W),S=k.getListIndex(L),P=k.getListRenderCount(L);return{...E,feedback:(0,e.$Rb)(S,S+P)}}drop($,W,Q,p){this.b.dispose(),this.a=void 0,this.f.drop(g($),W&&W.element,Q,p)}onDragEnd($){this.f.onDragEnd?.($)}dispose(){this.c.dispose(),this.f.dispose()}}function M(q,$){return $&&{...$,identityProvider:$.identityProvider&&{getId(W){return $.identityProvider.getId(W.element)}},dnd:$.dnd&&new y(q,$.dnd),multipleSelectionController:$.multipleSelectionController&&{isSelectionSingleChangeEvent(W){return $.multipleSelectionController.isSelectionSingleChangeEvent({...W,element:W.element})},isSelectionRangeChangeEvent(W){return $.multipleSelectionController.isSelectionRangeChangeEvent({...W,element:W.element})}},accessibilityProvider:$.accessibilityProvider&&{...$.accessibilityProvider,getSetSize(W){const Q=q(),p=Q.getNodeLocation(W),A=Q.getParentNodeLocation(p);return Q.getNode(A).visibleChildrenCount},getPosInSet(W){return W.visibleChildIndex+1},isChecked:$.accessibilityProvider&&$.accessibilityProvider.isChecked?W=>$.accessibilityProvider.isChecked(W.element):void 0,getRole:$.accessibilityProvider&&$.accessibilityProvider.getRole?W=>$.accessibilityProvider.getRole(W.element):()=>"treeitem",getAriaLabel(W){return $.accessibilityProvider.getAriaLabel(W.element)},getWidgetAriaLabel(){return $.accessibilityProvider.getWidgetAriaLabel()},getWidgetRole:$.accessibilityProvider&&$.accessibilityProvider.getWidgetRole?()=>$.accessibilityProvider.getWidgetRole():()=>"tree",getAriaLevel:$.accessibilityProvider&&$.accessibilityProvider.getAriaLevel?W=>$.accessibilityProvider.getAriaLevel(W.element):W=>W.depth,getActiveDescendantId:$.accessibilityProvider.getActiveDescendantId&&(W=>$.accessibilityProvider.getActiveDescendantId(W.element))},keyboardNavigationLabelProvider:$.keyboardNavigationLabelProvider&&{...$.keyboardNavigationLabelProvider,getKeyboardNavigationLabel(W){return $.keyboardNavigationLabelProvider.getKeyboardNavigationLabel(W.element)}}}}class _{constructor($){this.a=$}getHeight($){return this.a.getHeight($.element)}getTemplateId($){return this.a.getTemplateId($.element)}hasDynamicHeight($){return!!this.a.hasDynamicHeight&&this.a.hasDynamicHeight($.element)}setDynamicHeight($,W){this.a.setDynamicHeight?.($.element,W)}}t.$9S=_;class x{static lift($){return $ instanceof x?$:new x($)}static empty($=0){return new x({focus:[],selection:[],expanded:Object.create(null),scrollTop:$})}constructor($){if(this.focus=new Set($.focus),this.selection=new Set($.selection),$.expanded instanceof Array){this.expanded=Object.create(null);for(const W of $.expanded)this.expanded[W]=1}else this.expanded=$.expanded;this.expanded=$.expanded,this.scrollTop=$.scrollTop}toJSON(){return{focus:Array.from(this.focus),selection:Array.from(this.selection),expanded:this.expanded,scrollTop:this.scrollTop}}}t.$0S=x;var O;(function(q){q.None="none",q.OnHover="onHover",q.Always="always"})(O||(t.RenderIndentGuides=O={}));class B{get elements(){return this.b}constructor($,W=[]){this.b=W,this.a=new u.$Qc,this.onDidChange=r.Event.forEach($,Q=>this.b=Q,this.a)}dispose(){this.a.dispose()}}class j{static{this.a=8}constructor($,W,Q,p,A,E={}){this.o=$,this.p=W,this.q=p,this.s=A,this.b=new Map,this.c=new Map,this.d=j.a,this.f=!1,this.g=!1,this.j=new Set,this.k=u.$Rc.None,this.m=new u.$Qc,this.templateId=$.templateId,this.updateOptions(E),r.Event.map(Q,I=>I.node)(this.u,this,this.m),$.onDidChangeTwistieState?.(this.t,this,this.m)}updateOptions($={}){if(typeof $.indent<"u"){const W=(0,o.$Ul)($.indent,0,40);if(W!==this.d){this.d=W;for(const[Q,p]of this.c)this.v(Q,p)}}if(typeof $.renderIndentGuides<"u"){const W=$.renderIndentGuides!==O.None;if(W!==this.g){this.g=W;for(const[Q,p]of this.c)this.w(Q,p);if(this.k.dispose(),W){const Q=new u.$Qc;this.q.onDidChange(this.x,this,Q),this.k=Q,this.x(this.q.elements)}}}typeof $.hideTwistiesOfChildlessElements<"u"&&(this.f=$.hideTwistiesOfChildlessElements)}renderTemplate($){const W=(0,v.$3P)($,(0,v.$)(".monaco-tl-row")),Q=(0,v.$3P)(W,(0,v.$)(".monaco-tl-indent")),p=(0,v.$3P)(W,(0,v.$)(".monaco-tl-twistie")),A=(0,v.$3P)(W,(0,v.$)(".monaco-tl-contents")),E=this.o.renderTemplate(A);return{container:$,indent:Q,twistie:p,indentGuidesDisposable:u.$Rc.None,templateData:E}}renderElement($,W,Q,p){this.c.set($,Q),this.b.set($.element,$),this.v($,Q),this.o.renderElement($,W,Q.templateData,p)}disposeElement($,W,Q,p){Q.indentGuidesDisposable.dispose(),this.o.disposeElement?.($,W,Q.templateData,p),typeof p=="number"&&(this.c.delete($),this.b.delete($.element))}disposeTemplate($){this.o.disposeTemplate($.templateData)}t($){const W=this.b.get($);W&&this.u(W)}u($){const W=this.c.get($);W&&(this.x(this.q.elements),this.v($,W))}v($,W){const Q=j.a+($.depth-1)*this.d;W.twistie.style.paddingLeft=`${Q}px`,W.indent.style.width=`${Q+this.d-16}px`,$.collapsible?W.container.setAttribute("aria-expanded",String(!$.collapsed)):W.container.removeAttribute("aria-expanded"),W.twistie.classList.remove(...m.ThemeIcon.asClassNameArray(l.$1j.treeItemExpanded));let p=!1;this.o.renderTwistie&&(p=this.o.renderTwistie($.element,W.twistie)),$.collapsible&&(!this.f||$.visibleChildrenCount>0)?(p||W.twistie.classList.add(...m.ThemeIcon.asClassNameArray(l.$1j.treeItemExpanded)),W.twistie.classList.add("collapsible"),W.twistie.classList.toggle("collapsed",$.collapsed)):W.twistie.classList.remove("collapsible","collapsed"),this.w($,W)}w($,W){if((0,v.$2O)(W.indent),W.indentGuidesDisposable.dispose(),!this.g)return;const Q=new u.$Qc,p=this.p();for(;;){const A=p.getNodeLocation($),E=p.getParentNodeLocation(A);if(!E)break;const I=p.getNode(E),k=(0,v.$)(".indent-guide",{style:`width: ${this.d}px`});this.j.has(I)&&k.classList.add("active"),W.indent.childElementCount===0?W.indent.appendChild(k):W.indent.insertBefore(k,W.indent.firstElementChild),this.s.add(I,k),Q.add((0,u.$Pc)(()=>this.s.delete(I,k))),$=I}W.indentGuidesDisposable=Q}x($){if(!this.g)return;const W=new Set,Q=this.p();$.forEach(p=>{const A=Q.getNodeLocation(p);try{const E=Q.getParentNodeLocation(A);p.collapsible&&p.children.length>0&&!p.collapsed?W.add(p):E&&W.add(Q.getNode(E))}catch{}}),this.j.forEach(p=>{W.has(p)||this.s.forEach(p,A=>A.classList.remove("active"))}),W.forEach(p=>{this.j.has(p)||this.s.forEach(p,A=>A.classList.add("active"))}),this.j=W}dispose(){this.c.clear(),this.b.clear(),this.k.dispose(),(0,u.$Mc)(this.m)}}class ie{get totalCount(){return this.a}get matchCount(){return this.b}set pattern($){this.c=$,this.d=$.toLowerCase()}constructor($,W,Q){this.g=$,this.j=W,this.k=Q,this.a=0,this.b=0,this.c="",this.d="",this.f=new u.$Qc,$.onWillRefilter(this.m,this,this.f)}filter($,W){let Q=1;if(this.k){const E=this.k.filter($,W);if(typeof E=="boolean"?Q=E?1:0:(0,T.$6S)(E)?Q=(0,T.$7S)(E.visibility):Q=E,Q===0)return!1}if(this.a++,!this.c)return this.b++,{data:b.FuzzyScore.Default,visibility:Q};const p=this.j.getKeyboardNavigationLabel($),A=Array.isArray(p)?p:[p];for(const E of A){const I=E&&E.toString();if(typeof I>"u")return{data:b.FuzzyScore.Default,visibility:Q};let k;if(this.g.findMatchType===we.Contiguous){const L=I.toLowerCase().indexOf(this.d);if(L>-1){k=[Number.MAX_SAFE_INTEGER,0];for(let S=this.d.length;S>0;S--)k.push(L+S-1)}}else k=(0,b.$Vj)(this.c,this.d,0,I,I.toLowerCase(),0,{firstMatchCanBeWeak:!0,boostFullMatch:!0});if(k)return this.b++,A.length===1?{data:k,visibility:Q}:{data:{label:I,score:k},visibility:Q}}return this.g.findMode===oe.Filter?typeof this.g.options.defaultFindVisibility=="number"?this.g.options.defaultFindVisibility:this.g.options.defaultFindVisibility?this.g.options.defaultFindVisibility($):2:{data:b.FuzzyScore.Default,visibility:Q}}m(){this.a=0,this.b=0}dispose(){(0,u.$Mc)(this.f)}}class te extends d.$FR{constructor($){super({icon:l.$1j.listFilter,title:(0,z.localize)(0,null),isChecked:$.isChecked??!1,inputActiveOptionBorder:$.inputActiveOptionBorder,inputActiveOptionForeground:$.inputActiveOptionForeground,inputActiveOptionBackground:$.inputActiveOptionBackground})}}t.$$S=te;class ce extends d.$FR{constructor($){super({icon:l.$1j.searchFuzzy,title:(0,z.localize)(1,null),isChecked:$.isChecked??!1,inputActiveOptionBorder:$.inputActiveOptionBorder,inputActiveOptionForeground:$.inputActiveOptionForeground,inputActiveOptionBackground:$.inputActiveOptionBackground})}}t.$_S=ce;const le={inputBoxStyles:D.$mS,toggleStyles:d.$DR,listFilterWidgetBackground:void 0,listFilterWidgetNoMatchesOutline:void 0,listFilterWidgetOutline:void 0,listFilterWidgetShadow:void 0};var oe;(function(q){q[q.Highlight=0]="Highlight",q[q.Filter=1]="Filter"})(oe||(t.TreeFindMode=oe={}));var we;(function(q){q[q.Fuzzy=0]="Fuzzy",q[q.Contiguous=1]="Contiguous"})(we||(t.TreeFindMatchType=we={}));class Pe extends u.$Rc{set mode($){this.b.checked=$===oe.Filter,this.f.inputBox.setPlaceHolder($===oe.Filter?(0,z.localize)(2,null):(0,z.localize)(3,null))}set matchType($){this.c.checked=$===we.Fuzzy}get value(){return this.f.inputBox.value}set value($){this.f.inputBox.value=$}constructor($,W,Q,p,A,E){super(),this.t=W,this.a=(0,v.h)(".monaco-tree-type-filter",[(0,v.h)(".monaco-tree-type-filter-grab.codicon.codicon-debug-gripper@grab",{tabIndex:0}),(0,v.h)(".monaco-tree-type-filter-input@findInput"),(0,v.h)(".monaco-tree-type-filter-actionbar@actionbar")]),this.j=0,this.m=0,this.s=0,this._onDidDisable=new r.$Rd,this.onDidDisable=this._onDidDisable.event,$.appendChild(this.a.root),this.B((0,u.$Pc)(()=>$.removeChild(this.a.root)));const I=E?.styles??le;I.listFilterWidgetBackground&&(this.a.root.style.backgroundColor=I.listFilterWidgetBackground),I.listFilterWidgetShadow&&(this.a.root.style.boxShadow=`0 0 8px 2px ${I.listFilterWidgetShadow}`),this.b=this.B(new te({...I.toggleStyles,isChecked:p===oe.Filter})),this.c=this.B(new ce({...I.toggleStyles,isChecked:A===we.Fuzzy})),this.onDidChangeMode=r.Event.map(this.b.onChange,()=>this.b.checked?oe.Filter:oe.Highlight,this.q),this.onDidChangeMatchType=r.Event.map(this.c.onChange,()=>this.c.checked?we.Fuzzy:we.Contiguous,this.q),this.f=this.B(new w.$CS(this.a.findInput,Q,{label:(0,z.localize)(4,null),additionalToggles:[this.b,this.c],showCommonFindToggles:!1,inputBoxStyles:I.inputBoxStyles,toggleStyles:I.toggleStyles,history:E?.history})),this.g=this.B(new U.$VQ(this.a.actionbar)),this.mode=p;const k=this.B(new N.$4Q(this.f.inputBox.inputElement,"keydown")),L=r.Event.chain(k.event,G=>G.map(ee=>new i.$ZO(ee)));this.B(L(G=>{if(G.equals(3)){G.preventDefault(),G.stopPropagation(),this.f.inputBox.addToHistory(),this.t.domFocus();return}if(G.equals(18)){G.preventDefault(),G.stopPropagation(),this.f.inputBox.isAtLastInHistory()||this.f.inputBox.isNowhereInHistory()?(this.f.inputBox.addToHistory(),this.t.domFocus()):this.f.inputBox.showNextValue();return}if(G.equals(16)){G.preventDefault(),G.stopPropagation(),this.f.inputBox.showPreviousValue();return}}));const S=this.B(new a.$Ai("close",(0,z.localize)(5,null),"codicon codicon-close",!0,()=>this.dispose()));this.g.push(S,{icon:!0,label:!1});const P=this.B(new N.$4Q(this.a.grab,"mousedown"));this.B(P.event(G=>{const ee=new u.$Qc,se=ee.add(new N.$4Q((0,v.$IP)(G),"mousemove")),me=ee.add(new N.$4Q((0,v.$IP)(G),"mouseup")),ve=this.m,Fe=G.pageX,Ce=this.s,De=G.pageY;this.a.grab.classList.add("grabbing");const Te=this.a.root.style.transition;this.a.root.style.transition="unset";const Oe=We=>{const He=We.pageX-Fe;this.m=ve-He;const Me=We.pageY-De;this.s=Ce+Me,this.layout()};ee.add(se.event(Oe)),ee.add(me.event(We=>{Oe(We),this.a.grab.classList.remove("grabbing"),this.a.root.style.transition=Te,ee.dispose()}))}));const H=r.Event.chain(this.B(new N.$4Q(this.a.grab,"keydown")).event,G=>G.map(ee=>new i.$ZO(ee)));this.B(H(G=>{let ee,se;if(G.keyCode===15?ee=Number.POSITIVE_INFINITY:G.keyCode===17?ee=0:G.keyCode===10&&(ee=this.m===0?Number.POSITIVE_INFINITY:0),G.keyCode===16?se=0:G.keyCode===18&&(se=Number.POSITIVE_INFINITY),ee!==void 0&&(G.preventDefault(),G.stopPropagation(),this.m=ee,this.layout()),se!==void 0){G.preventDefault(),G.stopPropagation(),this.s=se;const me=this.a.root.style.transition;this.a.root.style.transition="unset",this.layout(),setTimeout(()=>{this.a.root.style.transition=me},0)}})),this.onDidChangeValue=this.f.onDidChange}getHistory(){return this.f.inputBox.getHistory()}focus(){this.f.focus()}select(){this.f.select(),this.f.inputBox.addToHistory(!0)}layout($=this.j){this.j=$,this.m=(0,o.$Ul)(this.m,0,Math.max(0,$-212)),this.a.root.style.right=`${this.m}px`,this.s=(0,o.$Ul)(this.s,0,24),this.a.root.style.top=`${this.s}px`}showMessage($){this.f.showMessage($)}clearMessage(){this.f.clearMessage()}async dispose(){this._onDidDisable.fire(),this.a.root.classList.add("disabled"),await(0,h.$Yg)(300),super.dispose()}}class Ae{get pattern(){return this.b}get mode(){return this.d}set mode($){$!==this.d&&(this.d=$,this.g&&(this.g.mode=this.d),this.t.refilter(),this.A(),this.k.fire($))}get matchType(){return this.f}set matchType($){$!==this.f&&(this.f=$,this.g&&(this.g.matchType=this.f),this.t.refilter(),this.A(),this.m.fire($))}constructor($,W,Q,p,A,E={}){this.t=$,this.u=Q,this.v=p,this.w=A,this.x=E,this.b="",this.c="",this.j=0,this.k=new r.$Rd,this.onDidChangeMode=this.k.event,this.m=new r.$Rd,this.onDidChangeMatchType=this.m.event,this.o=new r.$Rd,this.onDidChangePattern=this.o.event,this.p=new r.$Rd,this.onDidChangeOpenState=this.p.event,this.q=new u.$Qc,this.s=new u.$Qc,this.d=$.options.defaultFindMode??oe.Highlight,this.f=$.options.defaultFindMatchType??we.Fuzzy,W.onDidSplice(this.z,this,this.s)}updateOptions($={}){$.defaultFindMode!==void 0&&(this.mode=$.defaultFindMode),$.defaultFindMatchType!==void 0&&(this.matchType=$.defaultFindMatchType)}open(){if(this.g){this.g.focus(),this.g.select();return}this.g=new Pe(this.u.getHTMLElement(),this.t,this.w,this.mode,this.matchType,{...this.x,history:this.a}),this.q.add(this.g),this.g.onDidChangeValue(this.y,this,this.q),this.g.onDidChangeMode($=>this.mode=$,void 0,this.q),this.g.onDidChangeMatchType($=>this.matchType=$,void 0,this.q),this.g.onDidDisable(this.close,this,this.q),this.g.layout(this.j),this.g.focus(),this.g.value=this.c,this.g.select(),this.p.fire(!0)}close(){this.g&&(this.a=this.g.getHistory(),this.g=void 0,this.q.clear(),this.c=this.pattern,this.y(""),this.t.domFocus(),this.p.fire(!1))}y($){this.b=$,this.o.fire($),this.v.pattern=$,this.t.refilter(),$&&this.t.focusNext(0,!0,void 0,Q=>!b.FuzzyScore.isDefault(Q.filterData));const W=this.t.getFocus();if(W.length>0){const Q=W[0];this.t.getRelativeTop(Q)===null&&this.t.reveal(Q,.5)}this.A()}z(){!this.g||this.pattern.length===0||(this.t.refilter(),this.A())}A(){const $=this.v.totalCount>0&&this.v.matchCount===0;this.pattern&&$?this.t.options.showNotFoundMessage??!0?this.g?.showMessage({type:2,content:(0,z.localize)(6,null)}):this.g?.showMessage({type:2}):this.g?.clearMessage()}shouldAllowFocus($){return!this.g||!this.pattern||this.d===oe.Filter||this.v.totalCount>0&&this.v.matchCount<=1?!0:!b.FuzzyScore.isDefault($.filterData)}layout($){this.j=$,this.g?.layout($)}dispose(){this.a=void 0,this.o.dispose(),this.q.dispose(),this.s.dispose()}}function Re(q){let $=s.TreeMouseEventTarget.Unknown;return(0,v.$yP)(q.browserEvent.target,"monaco-tl-twistie","monaco-tl-row")?$=s.TreeMouseEventTarget.Twistie:(0,v.$yP)(q.browserEvent.target,"monaco-tl-contents","monaco-tl-row")?$=s.TreeMouseEventTarget.Element:(0,v.$yP)(q.browserEvent.target,"monaco-tree-type-filter","monaco-list")&&($=s.TreeMouseEventTarget.Filter),{browserEvent:q.browserEvent,element:q.element?q.element.element:null,target:$}}function de(q){return{element:q.element?q.element.element:null,browserEvent:q.browserEvent,anchor:q.anchor}}function ne(q,$){$(q),q.children.forEach(W=>ne(W,$))}class fe{get f(){return this.d||(this.d=this.m()),this.d}constructor($,W){this.g=$,this.j=W,this.a=[],this.c=new r.$Rd,this.onDidChange=this.c.event}set($,W){!W?.__forceEvent&&(0,e.$tb)(this.a,$)||this.k($,!1,W)}k($,W,Q){if(this.a=[...$],this.b=void 0,this.d=void 0,!W){const p=this;this.c.fire({get elements(){return p.get()},browserEvent:Q})}}get(){return this.b||(this.b=this.a.map($=>$.element)),[...this.b]}getNodes(){return this.a}has($){return this.f.has($)}onDidModelSplice({insertedNodes:$,deletedNodes:W}){if(!this.j){const k=this.m(),L=S=>k.delete(S);W.forEach(S=>ne(S,L)),this.set([...k.values()]);return}const Q=new Set,p=k=>Q.add(this.j.getId(k.element).toString());W.forEach(k=>ne(k,p));const A=new Map,E=k=>A.set(this.j.getId(k.element).toString(),k);$.forEach(k=>ne(k,E));const I=[];for(const k of this.a){const L=this.j.getId(k.element).toString();if(!Q.has(L))I.push(k);else{const P=A.get(L);P&&P.visible&&I.push(P)}}if(this.a.length>0&&I.length===0){const k=this.g();k&&I.push(k)}this.k(I,!0)}m(){const $=new Set;for(const W of this.a)$.add(W);return $}}class Z extends f.$oR{constructor($,W){super($),this.x=W}u($){if((0,f.$kR)($.browserEvent.target)||(0,f.$iR)($.browserEvent.target)||(0,f.$jR)($.browserEvent.target)||$.browserEvent.isHandledByList)return;const W=$.element;if(!W)return super.u($);if(this.p($)||this.o($))return super.u($);const Q=$.browserEvent.target,p=Q.classList.contains("monaco-tl-twistie")||Q.classList.contains("monaco-icon-label")&&Q.classList.contains("folder-icon")&&$.browserEvent.offsetX<16;let A=!1;if(typeof this.x.expandOnlyOnTwistieClick=="function"?A=this.x.expandOnlyOnTwistieClick(W.element):A=!!this.x.expandOnlyOnTwistieClick,A&&!p&&$.browserEvent.detail!==2)return super.u($);if(!this.x.expandOnDoubleClick&&$.browserEvent.detail===2)return super.u($);if(W.collapsible){const E=this.x.getNodeLocation(W),I=$.browserEvent.altKey;if(this.x.setFocus([E]),this.x.toggleCollapsed(E,I),A&&p){$.browserEvent.isHandledByList=!0;return}}super.u($)}v($){$.browserEvent.target.classList.contains("monaco-tl-twistie")||!this.x.expandOnDoubleClick||$.browserEvent.isHandledByList||super.v($)}}class V extends f.$rR{constructor($,W,Q,p,A,E,I,k){super($,W,Q,p,k),this.p=A,this.s=E,this.K=I}D($){return new Z(this,$.tree)}splice($,W,Q=[]){if(super.splice($,W,Q),Q.length===0)return;const p=[],A=[];let E;Q.forEach((I,k)=>{this.p.has(I)&&p.push($+k),this.s.has(I)&&A.push($+k),this.K.has(I)&&(E=$+k)}),p.length>0&&super.setFocus((0,e.$Lb)([...super.getFocus(),...p])),A.length>0&&super.setSelection((0,e.$Lb)([...super.getSelection(),...A])),typeof E=="number"&&super.setAnchor(E)}setFocus($,W,Q=!1){super.setFocus($,W),Q||this.p.set($.map(p=>this.element(p)),W)}setSelection($,W,Q=!1){super.setSelection($,W),Q||this.s.set($.map(p=>this.element(p)),W)}setAnchor($,W=!1){super.setAnchor($),W||(typeof $>"u"?this.K.set([]):this.K.set([this.element($)]))}}class Y{get onDidScroll(){return this.j.onDidScroll}get onDidChangeFocus(){return this.w.wrapEvent(this.p.onDidChange)}get onDidChangeSelection(){return this.w.wrapEvent(this.q.onDidChange)}get onMouseClick(){return r.Event.map(this.j.onMouseClick,Re)}get onMouseDblClick(){return r.Event.filter(r.Event.map(this.j.onMouseDblClick,Re),$=>$.target!==s.TreeMouseEventTarget.Filter)}get onContextMenu(){return r.Event.map(this.j.onContextMenu,de)}get onTap(){return r.Event.map(this.j.onTap,Re)}get onPointer(){return r.Event.map(this.j.onPointer,Re)}get onKeyDown(){return this.j.onKeyDown}get onKeyUp(){return this.j.onKeyUp}get onKeyPress(){return this.j.onKeyPress}get onDidFocus(){return this.j.onDidFocus}get onDidBlur(){return this.j.onDidBlur}get onDidChangeModel(){return r.Event.signal(this.o.onDidSplice)}get onDidChangeCollapseState(){return this.o.onDidChangeCollapseState}get onDidChangeRenderNodeCount(){return this.o.onDidChangeRenderNodeCount}get findMode(){return this.x?.mode??oe.Highlight}set findMode($){this.x&&(this.x.mode=$)}get findMatchType(){return this.x?.matchType??we.Fuzzy}set findMatchType($){this.x&&(this.x.matchType=$)}get onDidChangeFindPattern(){return this.x?this.x.onDidChangePattern:r.Event.None}get expandOnDoubleClick(){return typeof this.E.expandOnDoubleClick>"u"?!0:this.E.expandOnDoubleClick}get expandOnlyOnTwistieClick(){return typeof this.E.expandOnlyOnTwistieClick>"u"?!0:this.E.expandOnlyOnTwistieClick}get onDidDispose(){return this.j.onDidDispose}constructor($,W,Q,p,A={}){this.D=$,this.E=A,this.w=new r.$Zd,this.onDidChangeFindOpenState=r.Event.None,this.A=new u.$Qc,this.B=new r.$Rd,this.onWillRefilter=this.B.event,this.C=new r.$Rd,this.onDidUpdateOptions=this.C.event;const E=new _(Q),I=new r.$1d,k=new r.$1d,L=this.A.add(new B(k.event)),S=new n.$Fc;this.k=p.map(se=>new j(se,()=>this.o,I.event,L,S,A));for(const se of this.k)this.A.add(se);let P;A.keyboardNavigationLabelProvider&&(P=new ie(this,A.keyboardNavigationLabelProvider,A.filter),A={...A,filter:P},this.A.add(P)),this.p=new fe(()=>this.j.getFocusedElements()[0],A.identityProvider),this.q=new fe(()=>this.j.getSelectedElements()[0],A.identityProvider),this.u=new fe(()=>this.j.getAnchorElement(),A.identityProvider),this.j=new V($,W,E,this.k,this.p,this.q,this.u,{...M(()=>this.o,A),tree:this}),this.o=this.I($,this.j,A),I.input=this.o.onDidChangeCollapseState;const H=r.Event.forEach(this.o.onDidSplice,se=>{this.w.bufferEvents(()=>{this.p.onDidModelSplice(se),this.q.onDidModelSplice(se)})},this.A);H(()=>null,null,this.A);const G=this.A.add(new r.$Rd),ee=this.A.add(new h.$Ug(0));if(this.A.add(r.Event.any(H,this.p.onDidChange,this.q.onDidChange)(()=>{ee.trigger(()=>{const se=new Set;for(const me of this.p.getNodes())se.add(me);for(const me of this.q.getNodes())se.add(me);G.fire([...se.values()])})})),k.input=G.event,A.keyboardSupport!==!1){const se=r.Event.chain(this.j.onKeyDown,me=>me.filter(ve=>!(0,f.$iR)(ve.target)).map(ve=>new i.$ZO(ve)));r.Event.chain(se,me=>me.filter(ve=>ve.keyCode===15))(this.F,this,this.A),r.Event.chain(se,me=>me.filter(ve=>ve.keyCode===17))(this.G,this,this.A),r.Event.chain(se,me=>me.filter(ve=>ve.keyCode===10))(this.H,this,this.A)}if((A.findWidgetEnabled??!0)&&A.keyboardNavigationLabelProvider&&A.contextViewProvider){const se=this.options.findWidgetStyles?{styles:this.options.findWidgetStyles}:void 0;this.x=new Ae(this,this.o,this.j,P,A.contextViewProvider,se),this.y=me=>this.x.shouldAllowFocus(me),this.onDidChangeFindOpenState=this.x.onDidChangeOpenState,this.A.add(this.x),this.onDidChangeFindMode=this.x.onDidChangeMode,this.onDidChangeFindMatchType=this.x.onDidChangeMatchType}else this.onDidChangeFindMode=r.Event.None,this.onDidChangeFindMatchType=r.Event.None;this.z=(0,v.$LP)(this.j.getHTMLElement()),this.getHTMLElement().classList.toggle("always",this.E.renderIndentGuides===O.Always)}updateOptions($={}){this.E={...this.E,...$};for(const W of this.k)W.updateOptions($);this.j.updateOptions(this.E),this.x?.updateOptions($),this.C.fire(this.E),this.getHTMLElement().classList.toggle("always",this.E.renderIndentGuides===O.Always)}get options(){return this.E}updateWidth($){const W=this.o.getListIndex($);W!==-1&&this.j.updateWidth(W)}getHTMLElement(){return this.j.getHTMLElement()}get contentHeight(){return this.j.contentHeight}get contentWidth(){return this.j.contentWidth}get onDidChangeContentHeight(){return this.j.onDidChangeContentHeight}get onDidChangeContentWidth(){return this.j.onDidChangeContentWidth}get scrollTop(){return this.j.scrollTop}set scrollTop($){this.j.scrollTop=$}get scrollLeft(){return this.j.scrollLeft}set scrollLeft($){this.j.scrollLeft=$}get scrollHeight(){return this.j.scrollHeight}get renderHeight(){return this.j.renderHeight}get firstVisibleElement(){const $=this.j.firstVisibleIndex;return $<0||$>=this.j.length?void 0:this.j.element($).element}get lastVisibleElement(){const $=this.j.lastVisibleIndex;return this.j.element($).element}get ariaLabel(){return this.j.ariaLabel}set ariaLabel($){this.j.ariaLabel=$}get selectionSize(){return this.q.getNodes().length}domFocus(){this.j.domFocus()}isDOMFocused(){return(0,v.$DP)(this.getHTMLElement())}layout($,W){this.j.layout($,W),(0,F.$Gf)(W)&&this.x?.layout(W)}style($){const W=`.${this.j.domId}`,Q=[];$.treeIndentGuidesStroke&&(Q.push(`.monaco-list${W}:hover .monaco-tl-indent > .indent-guide, .monaco-list${W}.always .monaco-tl-indent > .indent-guide  { border-color: ${$.treeInactiveIndentGuidesStroke}; }`),Q.push(`.monaco-list${W} .monaco-tl-indent > .indent-guide.active { border-color: ${$.treeIndentGuidesStroke}; }`)),this.z.textContent=Q.join(`
`),this.j.style($)}getParentElement($){const W=this.o.getParentNodeLocation($);return this.o.getNode(W).element}getFirstElementChild($){return this.o.getFirstElementChild($)}getNode($){return this.o.getNode($)}getNodeLocation($){return this.o.getNodeLocation($)}collapse($,W=!1){return this.o.setCollapsed($,!0,W)}expand($,W=!1){return this.o.setCollapsed($,!1,W)}toggleCollapsed($,W=!1){return this.o.setCollapsed($,void 0,W)}expandAll(){this.o.setCollapsed(this.o.rootRef,!1,!0)}collapseAll(){this.o.setCollapsed(this.o.rootRef,!0,!0)}isCollapsible($){return this.o.isCollapsible($)}setCollapsible($,W){return this.o.setCollapsible($,W)}isCollapsed($){return this.o.isCollapsed($)}expandTo($){this.o.expandTo($)}triggerTypeNavigation(){this.j.triggerTypeNavigation()}openFind(){this.x?.open()}closeFind(){this.x?.close()}refilter(){this.B.fire(void 0),this.o.refilter()}setAnchor($){if(typeof $>"u")return this.j.setAnchor(void 0);const W=this.o.getNode($);this.u.set([W]);const Q=this.o.getListIndex($);Q>-1&&this.j.setAnchor(Q,!0)}getAnchor(){return(0,e.$Nb)(this.u.get(),void 0)}setSelection($,W){const Q=$.map(A=>this.o.getNode(A));this.q.set(Q,W);const p=$.map(A=>this.o.getListIndex(A)).filter(A=>A>-1);this.j.setSelection(p,W,!0)}getSelection(){return this.q.get()}setFocus($,W){const Q=$.map(A=>this.o.getNode(A));this.p.set(Q,W);const p=$.map(A=>this.o.getListIndex(A)).filter(A=>A>-1);this.j.setFocus(p,W,!0)}focusNext($=1,W=!1,Q,p=this.y){this.j.focusNext($,W,Q,p)}focusPrevious($=1,W=!1,Q,p=this.y){this.j.focusPrevious($,W,Q,p)}focusNextPage($,W=this.y){return this.j.focusNextPage($,W)}focusPreviousPage($,W=this.y){return this.j.focusPreviousPage($,W)}focusLast($,W=this.y){this.j.focusLast($,W)}focusFirst($,W=this.y){this.j.focusFirst($,W)}getFocus(){return this.p.get()}reveal($,W){this.o.expandTo($);const Q=this.o.getListIndex($);Q!==-1&&this.j.reveal(Q,W)}getRelativeTop($){const W=this.o.getListIndex($);return W===-1?null:this.j.getRelativeTop(W)}getViewState($=this.options.identityProvider){if(!$)throw new s.$4S(this.D,"Can't get tree view state without an identity provider");const W=E=>$.getId(E).toString(),Q=x.empty(this.scrollTop);for(const E of this.getFocus())Q.focus.add(W(E));for(const E of this.getSelection())Q.selection.add(W(E));const p=this.o.getNode(),A=[p];for(;A.length>0;){const E=A.shift();E!==p&&E.collapsible&&(Q.expanded[W(E.element)]=E.collapsed?0:1),A.push(...E.children)}return Q}F($){$.preventDefault(),$.stopPropagation();const W=this.j.getFocusedElements();if(W.length===0)return;const Q=W[0],p=this.o.getNodeLocation(Q);if(!this.o.setCollapsed(p,!0)){const E=this.o.getParentNodeLocation(p);if(!E)return;const I=this.o.getListIndex(E);this.j.reveal(I),this.j.setFocus([I])}}G($){$.preventDefault(),$.stopPropagation();const W=this.j.getFocusedElements();if(W.length===0)return;const Q=W[0],p=this.o.getNodeLocation(Q);if(!this.o.setCollapsed(p,!1)){if(!Q.children.some(k=>k.visible))return;const[E]=this.j.getFocus(),I=E+1;this.j.reveal(I),this.j.setFocus([I])}}H($){$.preventDefault(),$.stopPropagation();const W=this.j.getFocusedElements();if(W.length===0)return;const Q=W[0],p=this.o.getNodeLocation(Q),A=$.browserEvent.altKey;this.o.setCollapsed(p,void 0,A)}navigate($){return new C(this.j,this.o,$)}dispose(){(0,u.$Mc)(this.A),this.j.dispose()}}t.$aT=Y;class C{constructor($,W,Q){this.b=$,this.c=W,Q?this.a=this.c.getListIndex(Q):this.a=-1}current(){return this.a<0||this.a>=this.b.length?null:this.b.element(this.a).element}previous(){return this.a--,this.current()}next(){return this.a++,this.current()}first(){return this.a=0,this.current()}last(){return this.a=this.b.length-1,this.current()}}}),define(be[132],pe([1,0,131,122,25,27]),function(ae,t,v,N,i,U){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$lT=void 0;class w extends v.$aT{constructor(c,f,d,T,s,a={}){super(c,f,d,T,a),this.f=c,this.g=s,this.d=new Map,this.c=a.identityProvider}getInput(){return this.b}setInput(c,f){if(f&&!this.c)throw new i.$4S(this.f,"Can't restore tree view state without an identity provider");if(this.b=c,!c){this.d.clear(),this.o.setChildren(null,U.Iterable.empty());return}if(!f){this.m(c);return}const d=[],T=[],s=e=>{const h=this.c.getId(e).toString();return!f.expanded[h]},a=e=>{const h=this.c.getId(e.element).toString();f.focus.has(h)&&d.push(e.element),f.selection.has(h)&&T.push(e.element)};this.m(c,s,a),this.setFocus(d),this.setSelection(T),f&&typeof f.scrollTop=="number"&&(this.scrollTop=f.scrollTop)}updateChildren(c=this.b){if(typeof this.b>"u")throw new i.$4S(this.f,"Tree input not set");let f;this.c&&(f=d=>{const T=this.c.getId(d).toString(),s=this.d.get(T);if(s)return s.collapsed}),this.m(c,f)}resort(c=this.b,f=!0){this.o.resort(c===this.b?null:c,f)}refresh(c){if(c===void 0){this.j.rerender();return}this.o.rerender(c)}m(c,f,d){let T;if(this.c){const s=new Set,a=d;d=e=>{const h=this.c.getId(e.element).toString();s.add(h),this.d.set(h,e),a?.(e)},T=e=>{const h=this.c.getId(e.element).toString();s.has(h)||this.d.delete(h)}}this.o.setChildren(c===this.b?null:c,this.s(c,f).elements,{onDidCreateNode:d,onDidDeleteNode:T})}s(c,f){const d=[...this.g.getChildren(c)];return{elements:U.Iterable.map(d,s=>{const{elements:a,size:e}=this.s(s,f),h=this.g.hasChildren?this.g.hasChildren(s):void 0,l=e===0?void 0:f&&f(s);return{element:s,children:a,collapsible:h,collapsed:l}}),size:d.length}}I(c,f,d){return new N.$bT(c,f,d)}}t.$lT=w}),define(be[67],pe([1,0,11,9,33,29,26,6,4,2,53,12,7]),function(ae,t,v,N,i,U,w,D,c,f,d,T,s){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Eh=t.ProxyChannel=t.$Dh=t.$Ch=t.$Bh=t.$Ah=t.$zh=t.$yh=t.RequestInitiator=t.$xh=t.$wh=t.$vh=t.$uh=t.$th=void 0;var a;(function(de){de[de.Promise=100]="Promise",de[de.PromiseCancel=101]="PromiseCancel",de[de.EventListen=102]="EventListen",de[de.EventDispose=103]="EventDispose"})(a||(a={}));function e(de){switch(de){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var h;(function(de){de[de.Initialize=200]="Initialize",de[de.PromiseSuccess=201]="PromiseSuccess",de[de.PromiseError=202]="PromiseError",de[de.PromiseErrorObj=203]="PromiseErrorObj",de[de.EventFire=204]="EventFire"})(h||(h={}));function l(de){switch(de){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var m;(function(de){de[de.Uninitialized=0]="Uninitialized",de[de.Idle=1]="Idle"})(m||(m={}));function n(de){let ne=0;for(let fe=0;;fe+=7){const Z=de.read(1);if(ne|=(Z.buffer[0]&127)<<fe,!(Z.buffer[0]&128))return ne}}const r=z(0);function b(de,ne){if(ne===0){de.write(r);return}let fe=0;for(let V=ne;V!==0;V=V>>>7)fe++;const Z=i.$fe.alloc(fe);for(let V=0;ne!==0;V++)Z.buffer[V]=ne&127,ne=ne>>>7,ne>0&&(Z.buffer[V]|=128);de.write(Z)}class u{constructor(ne){this.b=ne,this.a=0}read(ne){const fe=this.b.slice(this.a,this.a+ne);return this.a+=fe.byteLength,fe}}t.$th=u;class o{constructor(){this.a=[]}get buffer(){return i.$fe.concat(this.a)}write(ne){this.a.push(ne)}}t.$uh=o;var F;(function(de){de[de.Undefined=0]="Undefined",de[de.String=1]="String",de[de.Buffer=2]="Buffer",de[de.VSBuffer=3]="VSBuffer",de[de.Array=4]="Array",de[de.Object=5]="Object",de[de.Int=6]="Int"})(F||(F={}));function z(de){const ne=i.$fe.alloc(1);return ne.writeUInt8(de,0),ne}const R={Undefined:z(F.Undefined),String:z(F.String),Buffer:z(F.Buffer),VSBuffer:z(F.VSBuffer),Array:z(F.Array),Object:z(F.Object),Uint:z(F.Int)},g=typeof Buffer<"u";function y(de,ne){if(typeof ne>"u")de.write(R.Undefined);else if(typeof ne=="string"){const fe=i.$fe.fromString(ne);de.write(R.String),b(de,fe.byteLength),de.write(fe)}else if(g&&Buffer.isBuffer(ne)){const fe=i.$fe.wrap(ne);de.write(R.Buffer),b(de,fe.byteLength),de.write(fe)}else if(ne instanceof i.$fe)de.write(R.VSBuffer),b(de,ne.byteLength),de.write(ne);else if(Array.isArray(ne)){de.write(R.Array),b(de,ne.length);for(const fe of ne)y(de,fe)}else if(typeof ne=="number"&&(ne|0)===ne)de.write(R.Uint),b(de,ne);else{const fe=i.$fe.fromString(JSON.stringify(ne));de.write(R.Object),b(de,fe.byteLength),de.write(fe)}}t.$vh=y;function M(de){switch(de.read(1).readUInt8(0)){case F.Undefined:return;case F.String:return de.read(n(de)).toString();case F.Buffer:return de.read(n(de)).buffer;case F.VSBuffer:return de.read(n(de));case F.Array:{const fe=n(de),Z=[];for(let V=0;V<fe;V++)Z.push(M(de));return Z}case F.Object:return JSON.parse(de.read(n(de)).toString());case F.Int:return n(de)}}t.$wh=M;class _{constructor(ne,fe,Z=null,V=1e3){this.h=ne,this.j=fe,this.k=Z,this.l=V,this.b=new Map,this.d=new Map,this.g=new Map,this.f=this.h.onMessage(Y=>this.q(Y)),this.m({type:200})}registerChannel(ne,fe){this.b.set(ne,fe),setTimeout(()=>this.w(ne),0)}m(ne){switch(ne.type){case 200:{const fe=this.o([ne.type]);this.k?.logOutgoing(fe,0,1,l(ne.type));return}case 201:case 202:case 204:case 203:{const fe=this.o([ne.type,ne.id],ne.data);this.k?.logOutgoing(fe,ne.id,1,l(ne.type),ne.data);return}}}o(ne,fe=void 0){const Z=new o;return y(Z,ne),y(Z,fe),this.p(Z.buffer)}p(ne){try{return this.h.send(ne),ne.byteLength}catch{return 0}}q(ne){const fe=new u(ne),Z=M(fe),V=M(fe),Y=Z[0];switch(Y){case 100:return this.k?.logIncoming(ne.byteLength,Z[1],1,`${e(Y)}: ${Z[2]}.${Z[3]}`,V),this.s({type:Y,id:Z[1],channelName:Z[2],name:Z[3],arg:V});case 102:return this.k?.logIncoming(ne.byteLength,Z[1],1,`${e(Y)}: ${Z[2]}.${Z[3]}`,V),this.t({type:Y,id:Z[1],channelName:Z[2],name:Z[3],arg:V});case 101:return this.k?.logIncoming(ne.byteLength,Z[1],1,`${e(Y)}`),this.u({type:Y,id:Z[1]});case 103:return this.k?.logIncoming(ne.byteLength,Z[1],1,`${e(Y)}`),this.u({type:Y,id:Z[1]})}}s(ne){const fe=this.b.get(ne.channelName);if(!fe){this.v(ne);return}const Z=new U.$2d;let V;try{V=fe.call(this.j,ne.name,ne.arg,Z.token)}catch(q){V=Promise.reject(q)}const Y=ne.id;V.then(q=>{this.m({id:Y,data:q,type:201})},q=>{q instanceof Error?this.m({id:Y,data:{message:q.message,name:q.name,stack:q.stack?q.stack.split?q.stack.split(`
`):q.stack:void 0},type:202}):this.m({id:Y,data:q,type:203})}).finally(()=>{C.dispose(),this.d.delete(ne.id)});const C=(0,f.$Pc)(()=>Z.cancel());this.d.set(ne.id,C)}t(ne){const fe=this.b.get(ne.channelName);if(!fe){this.v(ne);return}const Z=ne.id,Y=fe.listen(this.j,ne.name,ne.arg)(C=>this.m({id:Z,data:C,type:204}));this.d.set(ne.id,Y)}u(ne){const fe=this.d.get(ne.id);fe&&(fe.dispose(),this.d.delete(ne.id))}v(ne){let fe=this.g.get(ne.channelName);fe||(fe=[],this.g.set(ne.channelName,fe));const Z=setTimeout(()=>{console.error(`Unknown channel: ${ne.channelName}`),ne.type===100&&this.m({id:ne.id,data:{name:"Unknown channel",message:`Channel name '${ne.channelName}' timed out after ${this.l}ms`,stack:void 0},type:202})},this.l);fe.push({request:ne,timeoutTimer:Z})}w(ne){const fe=this.g.get(ne);if(fe){for(const Z of fe)switch(clearTimeout(Z.timeoutTimer),Z.request.type){case 100:this.s(Z.request);break;case 102:this.t(Z.request);break}this.g.delete(ne)}}dispose(){this.f&&(this.f.dispose(),this.f=null),(0,f.$Mc)(this.d.values()),this.d.clear()}}t.$xh=_;var x;(function(de){de[de.LocalSide=0]="LocalSide",de[de.OtherSide=1]="OtherSide"})(x||(t.RequestInitiator=x={}));class O{constructor(ne,fe=null){this.l=ne,this.a=!1,this.b=m.Uninitialized,this.d=new Set,this.f=new Map,this.g=0,this.k=new c.$Rd,this.onDidInitialize=this.k.event,this.h=this.l.onMessage(Z=>this.s(Z)),this.j=fe}getChannel(ne){const fe=this;return{call(Z,V,Y){return fe.a?Promise.reject(new D.$4):fe.m(ne,Z,V,Y)},listen(Z,V){return fe.a?c.Event.None:fe.o(ne,Z,V)}}}m(ne,fe,Z,V=U.CancellationToken.None){const Y=this.g++,q={id:Y,type:100,channelName:ne,name:fe,arg:Z};if(V.isCancellationRequested)return Promise.reject(new D.$4);let $;return new Promise((Q,p)=>{if(V.isCancellationRequested)return p(new D.$4);const A=()=>{const L=S=>{switch(S.type){case 201:this.f.delete(Y),Q(S.data);break;case 202:{this.f.delete(Y);const P=new Error(S.data.message);P.stack=Array.isArray(S.data.stack)?S.data.stack.join(`
`):S.data.stack,P.name=S.data.name,p(P);break}case 203:this.f.delete(Y),p(S.data);break}};this.f.set(Y,L),this.p(q)};let E=null;this.b===m.Idle?A():(E=(0,N.$Lg)(L=>this.u()),E.then(()=>{E=null,A()}));const I=()=>{E?(E.cancel(),E=null):this.p({id:Y,type:101}),p(new D.$4)},k=V.onCancellationRequested(I);$=(0,f.$Oc)((0,f.$Pc)(I),k),this.d.add($)}).finally(()=>{$.dispose(),this.d.delete($)})}o(ne,fe,Z){const V=this.g++,C={id:V,type:102,channelName:ne,name:fe,arg:Z};let q=null;const $=new c.$Rd({onWillAddFirstListener:()=>{q=(0,N.$Lg)(Q=>this.u()),q.then(()=>{q=null,this.d.add($),this.p(C)})},onDidRemoveLastListener:()=>{q?(q.cancel(),q=null):(this.d.delete($),this.p({id:V,type:103}))}}),W=Q=>$.fire(Q.data);return this.f.set(V,W),$.event}p(ne){switch(ne.type){case 100:case 102:{const fe=this.q([ne.type,ne.id,ne.channelName,ne.name],ne.arg);this.j?.logOutgoing(fe,ne.id,0,`${e(ne.type)}: ${ne.channelName}.${ne.name}`,ne.arg);return}case 101:case 103:{const fe=this.q([ne.type,ne.id]);this.j?.logOutgoing(fe,ne.id,0,e(ne.type));return}}}q(ne,fe=void 0){const Z=new o;return y(Z,ne),y(Z,fe),this.r(Z.buffer)}r(ne){try{return this.l.send(ne),ne.byteLength}catch{return 0}}s(ne){const fe=new u(ne),Z=M(fe),V=M(fe),Y=Z[0];switch(Y){case 200:return this.j?.logIncoming(ne.byteLength,0,0,l(Y)),this.t({type:Z[0]});case 201:case 202:case 204:case 203:return this.j?.logIncoming(ne.byteLength,Z[1],0,l(Y),V),this.t({type:Z[0],id:Z[1],data:V})}}t(ne){if(ne.type===200){this.b=m.Idle,this.k.fire();return}this.f.get(ne.id)?.(ne)}get onDidInitializePromise(){return c.Event.toPromise(this.onDidInitialize)}u(){return this.b===m.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.a=!0,this.h&&(this.h.dispose(),this.h=null),(0,f.$Mc)(this.d.values()),this.d.clear()}}t.$yh=O,Xe([w.$nh],O.prototype,"onDidInitializePromise",null);class B{get connections(){const ne=[];return this.f.forEach(fe=>ne.push(fe)),ne}constructor(ne){this.a=new Map,this.f=new Set,this.g=new c.$Rd,this.onDidAddConnection=this.g.event,this.h=new c.$Rd,this.onDidRemoveConnection=this.h.event,this.j=new f.$Qc,this.j.add(ne(({protocol:fe,onDidClientDisconnect:Z})=>{const V=c.Event.once(fe.onMessage);this.j.add(V(Y=>{const C=new u(Y),q=M(C),$=new _(fe,q),W=new O(fe);this.a.forEach((p,A)=>$.registerChannel(A,p));const Q={channelServer:$,channelClient:W,ctx:q};this.f.add(Q),this.g.fire(Q),this.j.add(Z(()=>{$.dispose(),W.dispose(),this.f.delete(Q),this.h.fire(Q)}))}))}))}getChannel(ne,fe){const Z=this;return{call(V,Y,C){let q;if((0,s.$Qf)(fe)){const W=(0,v.$3b)(Z.connections.filter(fe));q=W?Promise.resolve(W):c.Event.toPromise(c.Event.filter(Z.onDidAddConnection,fe))}else q=fe.routeCall(Z,V,Y);const $=q.then(W=>W.channelClient.getChannel(ne));return ie($).call(V,Y,C)},listen(V,Y){if((0,s.$Qf)(fe))return Z.k(ne,fe,V,Y);const C=fe.routeEvent(Z,V,Y).then(q=>q.channelClient.getChannel(ne));return ie(C).listen(V,Y)}}}k(ne,fe,Z,V){const Y=this;let C;const q=new c.$Rd({onWillAddFirstListener:()=>{C=new f.$Qc;const $=new c.$Xd,W=new Map,Q=A=>{const I=A.channelClient.getChannel(ne).listen(Z,V),k=$.add(I);W.set(A,k)},p=A=>{const E=W.get(A);E&&(E.dispose(),W.delete(A))};Y.connections.filter(fe).forEach(Q),c.Event.filter(Y.onDidAddConnection,fe)(Q,void 0,C),Y.onDidRemoveConnection(p,void 0,C),$.event(q.fire,q,C),C.add($)},onDidRemoveLastListener:()=>{C?.dispose(),C=void 0}});return q.event}registerChannel(ne,fe){this.a.set(ne,fe);for(const Z of this.f)Z.channelServer.registerChannel(ne,fe)}dispose(){this.j.dispose();for(const ne of this.f)ne.channelClient.dispose(),ne.channelServer.dispose();this.f.clear(),this.a.clear(),this.g.dispose(),this.h.dispose()}}t.$zh=B;class j{constructor(ne,fe,Z=null){const V=new o;y(V,fe),ne.send(V.buffer),this.a=new O(ne,Z),this.d=new _(ne,fe,Z)}getChannel(ne){return this.a.getChannel(ne)}registerChannel(ne,fe){this.d.registerChannel(ne,fe)}dispose(){this.a.dispose(),this.d.dispose()}}t.$Ah=j;function ie(de){return{call(ne,fe,Z){return de.then(V=>V.call(ne,fe,Z))},listen(ne,fe){const Z=new c.$1d;return de.then(V=>Z.input=V.listen(ne,fe)),Z.event}}}t.$Bh=ie;function te(de){let ne=!1;return{call(fe,Z,V){return ne?de.call(fe,Z,V):(0,N.$Yg)(0).then(()=>ne=!0).then(()=>de.call(fe,Z,V))},listen(fe,Z){if(ne)return de.listen(fe,Z);const V=new c.$1d;return(0,N.$Yg)(0).then(()=>ne=!0).then(()=>V.input=de.listen(fe,Z)),V.event}}}t.$Ch=te;class ce{constructor(ne){this.a=ne}routeCall(ne){return this.b(ne)}routeEvent(ne){return this.b(ne)}async b(ne){for(const fe of ne.connections)if(await Promise.resolve(this.a(fe.ctx)))return Promise.resolve(fe);return await c.Event.toPromise(ne.onDidAddConnection),await this.b(ne)}}t.$Dh=ce;var le;(function(de){function ne(Y,C,q){const $=Y,W=q&&q.disableMarshalling,Q=new Map;for(const p in $)Z(p)&&Q.set(p,c.Event.buffer($[p],!0,void 0,C));return new class{listen(p,A,E){const I=Q.get(A);if(I)return I;if(V(A)){const k=$[A];if(typeof k=="function")return k.call($,E)}throw new D.$ab(`Event not found: ${A}`)}call(p,A,E){const I=$[A];if(typeof I=="function"){if(!W&&Array.isArray(E))for(let L=0;L<E.length;L++)E[L]=(0,d.$sh)(E[L]);let k=I.apply($,E);return k instanceof Promise||(k=Promise.resolve(k)),k}throw new D.$ab(`Method not found: ${A}`)}}}de.fromService=ne;function fe(Y,C){const q=C&&C.disableMarshalling;return new Proxy({},{get($,W){if(typeof W=="string")return C?.properties?.has(W)?C.properties.get(W):V(W)?function(Q){return Y.listen(W,Q)}:Z(W)?Y.listen(W):async function(...Q){let p;C&&!(0,s.$Lf)(C.context)?p=[C.context,...Q]:p=Q;const A=await Y.call(W,p);return q?A:(0,d.$sh)(A)};throw new D.$ab(`Property not found: ${String(W)}`)}})}de.toService=fe;function Z(Y){return Y[0]==="o"&&Y[1]==="n"&&T.$5e(Y.charCodeAt(2))}function V(Y){return/^onDynamic/.test(Y)&&T.$5e(Y.charCodeAt(9))}})(le||(t.ProxyChannel=le={}));const oe=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function we(de){if(Array.isArray(de))return de;if(de&&typeof de=="object"&&typeof de.toString=="function"){const ne=de.toString();if(ne!=="[object Object]")return ne}return de}function Pe(de){return Array.isArray(de)?de.map(we):we(de)}function Ae(de,ne,fe,Z,V,Y,C){C=Pe(C);const q=oe[V],$=q[Z%q.length];let W=[`%c[${de}]%c[${String(ne).padStart(7," ")}]%c[len: ${String(fe).padStart(5," ")}]%c${String(Z).padStart(5," ")} - ${Y}`,"color: darkgreen","color: grey","color: grey",`color: ${$}`];/\($/.test(Y)?(W=W.concat(C),W.push(")")):W.push(C),console.log.apply(console,W)}class Re{constructor(ne,fe){this.d=ne,this.f=fe,this.a=0,this.b=0}logOutgoing(ne,fe,Z,V,Y){this.b+=ne,Ae(this.d,this.b,ne,fe,Z,V,Y)}logIncoming(ne,fe,Z,V,Y){this.a+=ne,Ae(this.f,this.a,ne,fe,Z,V,Y)}}t.$Eh=Re}),define(be[133],pe([1,0,33,4,67,89,30]),function(ae,t,v,N,i,U,w){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$5T=void 0;class D extends i.$Ah{static f(){const f=N.Event.fromNodeEventEmitter(w.$N,"vscode:message",(d,T)=>v.$fe.wrap(T));return w.$N.send("vscode:hello"),new U.$1T(w.$N,f)}constructor(f){const d=D.f();super(d,f),this.b=d}dispose(){this.b.disconnect()}}t.$5T=D}),define(be[134],pe([13,10]),function(ae,t){return ae.create("vs/platform/files/common/files",t)}),define(be[135],pe([13,10]),function(ae,t){return ae.create("vs/platform/theme/common/iconRegistry",t)}),define(be[40],pe([1,0]),function(ae,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Wh=t.$Vh=t.$Uh=t._util=void 0;var v;(function(w){w.serviceIds=new Map,w.DI_TARGET="$di$target",w.DI_DEPENDENCIES="$di$dependencies";function D(c){return c[w.DI_DEPENDENCIES]||[]}w.getServiceDependencies=D})(v||(t._util=v={})),t.$Uh=i("instantiationService");function N(w,D,c){D[v.DI_TARGET]===D?D[v.DI_DEPENDENCIES].push({id:w,index:c}):(D[v.DI_DEPENDENCIES]=[{id:w,index:c}],D[v.DI_TARGET]=D)}function i(w){if(v.serviceIds.has(w))return v.serviceIds.get(w);const D=function(c,f,d){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");N(D,c,d)};return D.toString=()=>w,v.serviceIds.set(w,D),D}t.$Vh=i;function U(w){return w}t.$Wh=U}),define(be[136],pe([1,0,40]),function(ae,t,v){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$ym=t.$xm=t.$wm=t.ID=void 0,t.ID="diagnosticsService",t.$wm=(0,v.$Vh)(t.ID);function N(U){return!!U.hostName&&!!U.errorMessage}t.$xm=N;class i{async getPerformanceInfo(w,D){return{}}async getSystemInfo(w,D){return{processArgs:"nullProcessArgs",gpuStatus:"nullGpuStatus",screenReader:"nullScreenReader",remoteData:[],os:"nullOs",memory:"nullMemory",vmHint:"nullVmHint"}}async getDiagnostics(w,D){return""}async getWorkspaceFileExtensions(w){return{extensions:[]}}async reportWorkspaceStats(w){}}t.$ym=i}),define(be[137],pe([1,0,87,23,12,7,15,134,40,5,31,28]),function(ae,t,v,N,i,U,w,D,c,f,d,T){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Nk=t.$Mk=t.$Lk=t.$Kk=t.$Jk=t.FileKind=t.$Ik=t.$Hk=t.$Gk=t.$Fk=t.$Ek=t.$Dk=t.$Ck=t.FileOperationResult=t.$Bk=t.$Ak=t.$zk=t.$yk=t.$xk=t.FileChangeType=t.$wk=t.FileOperation=t.$vk=t.$uk=t.$tk=t.$sk=t.$rk=t.$qk=t.FileSystemProviderErrorCode=t.$pk=t.$ok=t.$nk=t.$mk=t.$lk=t.$kk=t.$jk=t.$ik=t.$hk=t.FileSystemProviderCapabilities=t.$gk=t.FilePermission=t.FileType=t.$fk=t.$ek=void 0,t.$ek=(0,c.$Vh)("fileService");function s(V){return V.create===!0}t.$fk=s;var a;(function(V){V[V.Unknown=0]="Unknown",V[V.File=1]="File",V[V.Directory=2]="Directory",V[V.SymbolicLink=64]="SymbolicLink"})(a||(t.FileType=a={}));var e;(function(V){V[V.Readonly=1]="Readonly",V[V.Locked=2]="Locked"})(e||(t.FilePermission=e={}));function h(V){const Y=V;return!!Y&&typeof Y.onDidChange=="function"}t.$gk=h;var l;(function(V){V[V.None=0]="None",V[V.FileReadWrite=2]="FileReadWrite",V[V.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",V[V.FileReadStream=16]="FileReadStream",V[V.FileFolderCopy=8]="FileFolderCopy",V[V.PathCaseSensitive=1024]="PathCaseSensitive",V[V.Readonly=2048]="Readonly",V[V.Trash=4096]="Trash",V[V.FileWriteUnlock=8192]="FileWriteUnlock",V[V.FileAtomicRead=16384]="FileAtomicRead",V[V.FileAtomicWrite=32768]="FileAtomicWrite",V[V.FileAtomicDelete=65536]="FileAtomicDelete",V[V.FileClone=131072]="FileClone"})(l||(t.FileSystemProviderCapabilities=l={}));function m(V){return!!(V.capabilities&2)}t.$hk=m;function n(V){return!!(V.capabilities&8)}t.$ik=n;function r(V){return!!(V.capabilities&131072)}t.$jk=r;function b(V){return!!(V.capabilities&4)}t.$kk=b;function u(V){return!!(V.capabilities&16)}t.$lk=u;function o(V){return m(V)?!!(V.capabilities&16384):!1}t.$mk=o;function F(V){return m(V)?!!(V.capabilities&32768):!1}t.$nk=F;function z(V){return!!(V.capabilities&65536)}t.$ok=z;function R(V){return!!(V.capabilities&2048)}t.$pk=R;var g;(function(V){V.FileExists="EntryExists",V.FileNotFound="EntryNotFound",V.FileNotADirectory="EntryNotADirectory",V.FileIsADirectory="EntryIsADirectory",V.FileExceedsStorageQuota="EntryExceedsStorageQuota",V.FileTooLarge="EntryTooLarge",V.FileWriteLocked="EntryWriteLocked",V.NoPermissions="NoPermissions",V.Unavailable="Unavailable",V.Unknown="Unknown"})(g||(t.FileSystemProviderErrorCode=g={}));class y extends Error{static create(Y,C){const q=new y(Y.toString(),C);return x(q,C),q}constructor(Y,C){super(Y),this.code=C}}t.$qk=y;function M(V,Y){return y.create(V,Y)}t.$rk=M;function _(V){return V||M((0,D.localize)(0,null),g.Unknown)}t.$sk=_;function x(V,Y){return V.name=Y?`${Y} (FileSystemError)`:"FileSystemError",V}t.$tk=x;function O(V){if(!V)return g.Unknown;if(V instanceof y)return V.code;const Y=/^(.+) \(FileSystemError\)$/.exec(V.name);if(!Y)return g.Unknown;switch(Y[1]){case g.FileExists:return g.FileExists;case g.FileIsADirectory:return g.FileIsADirectory;case g.FileNotADirectory:return g.FileNotADirectory;case g.FileNotFound:return g.FileNotFound;case g.FileTooLarge:return g.FileTooLarge;case g.FileWriteLocked:return g.FileWriteLocked;case g.NoPermissions:return g.NoPermissions;case g.Unavailable:return g.Unavailable}return g.Unknown}t.$uk=O;function B(V){if(V instanceof oe)return V.fileOperationResult;switch(O(V)){case g.FileNotFound:return 1;case g.FileIsADirectory:return 0;case g.FileNotADirectory:return 9;case g.FileWriteLocked:return 5;case g.NoPermissions:return 6;case g.FileExists:return 4;case g.FileTooLarge:return 7;default:return 10}}t.$vk=B;var j;(function(V){V[V.CREATE=0]="CREATE",V[V.DELETE=1]="DELETE",V[V.MOVE=2]="MOVE",V[V.COPY=3]="COPY",V[V.WRITE=4]="WRITE"})(j||(t.FileOperation=j={}));class ie{constructor(Y,C,q){this.resource=Y,this.operation=C,this.target=q}isOperation(Y){return this.operation===Y}}t.$wk=ie;var te;(function(V){V[V.UPDATED=0]="UPDATED",V[V.ADDED=1]="ADDED",V[V.DELETED=2]="DELETED"})(te||(t.FileChangeType=te={}));class ce{static{this.a=null}constructor(Y,C){this.c=C,this.b=void 0,this.d=new T.$U(()=>{const q=v.$2h.forUris(()=>this.c);return q.fill(this.rawAdded.map($=>[$,!0])),q}),this.f=new T.$U(()=>{const q=v.$2h.forUris(()=>this.c);return q.fill(this.rawUpdated.map($=>[$,!0])),q}),this.g=new T.$U(()=>{const q=v.$2h.forUris(()=>this.c);return q.fill(this.rawDeleted.map($=>[$,!0])),q}),this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[];for(const q of Y){switch(q.type){case 1:this.rawAdded.push(q.resource);break;case 0:this.rawUpdated.push(q.resource);break;case 2:this.rawDeleted.push(q.resource);break}this.b!==ce.a&&(typeof q.cId=="number"?this.b===void 0?this.b=q.cId:this.b!==q.cId&&(this.b=ce.a):this.b!==void 0&&(this.b=ce.a))}}contains(Y,...C){return this.h(Y,{includeChildren:!1},...C)}affects(Y,...C){return this.h(Y,{includeChildren:!0},...C)}h(Y,C,...q){if(!Y)return!1;const $=q.length>0;return!!((!$||q.includes(1))&&(this.d.value.get(Y)||C.includeChildren&&this.d.value.findSuperstr(Y))||(!$||q.includes(0))&&(this.f.value.get(Y)||C.includeChildren&&this.f.value.findSuperstr(Y))||(!$||q.includes(2))&&(this.g.value.findSubstr(Y)||C.includeChildren&&this.g.value.findSuperstr(Y)))}gotAdded(){return this.rawAdded.length>0}gotDeleted(){return this.rawDeleted.length>0}gotUpdated(){return this.rawUpdated.length>0}correlates(Y){return this.b===Y}hasCorrelation(){return typeof this.b=="number"}}t.$xk=ce;function le(V,Y,C){return!V||!Y||V===Y||Y.length>V.length?!1:(Y.charAt(Y.length-1)!==N.sep&&(Y+=N.sep),C?(0,i.$7e)(V,Y):V.indexOf(Y)===0)}t.$yk=le;class oe extends Error{constructor(Y,C,q){super(Y),this.fileOperationResult=C,this.options=q}}t.$zk=oe;class we extends oe{constructor(Y,C,q,$){super(Y,C,$),this.fileOperationResult=C,this.size=q}}t.$Ak=we;class Pe extends oe{constructor(Y,C,q){super(Y,2,q),this.stat=C}}t.$Bk=Pe;var Ae;(function(V){V[V.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",V[V.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",V[V.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",V[V.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",V[V.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",V[V.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",V[V.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",V[V.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",V[V.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",V[V.FILE_NOT_DIRECTORY=9]="FILE_NOT_DIRECTORY",V[V.FILE_OTHER_ERROR=10]="FILE_OTHER_ERROR"})(Ae||(t.FileOperationResult=Ae={})),t.$Ck={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},t.$Dk={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},t.$Ek="files.associations",t.$Fk="files.exclude",t.$Gk="files.readonlyInclude",t.$Hk="files.readonlyExclude",t.$Ik="files.readonlyFromPermissions";var Re;(function(V){V[V.FILE=0]="FILE",V[V.FOLDER=1]="FOLDER",V[V.ROOT_FOLDER=2]="ROOT_FOLDER"})(Re||(t.FileKind=Re={})),t.$Jk="";function de(V){if(!(typeof V.size!="number"||typeof V.mtime!="number"))return V.mtime.toString(29)+V.size.toString(31)}t.$Kk=de;async function ne(V,Y){if(!Y.hasProvider(w.URI.from({scheme:V.scheme})))return new Promise(C=>{const q=Y.onDidChangeFileSystemProviderRegistrations($=>{$.scheme===V.scheme&&$.added&&(q.dispose(),C())})})}t.$Lk=ne;class fe{static{this.KB=1024}static{this.MB=fe.KB*fe.KB}static{this.GB=fe.MB*fe.KB}static{this.TB=fe.GB*fe.KB}static formatSize(Y){return(0,U.$Gf)(Y)||(Y=0),Y<fe.KB?(0,D.localize)(1,null,Y.toFixed(0)):Y<fe.MB?(0,D.localize)(2,null,(Y/fe.KB).toFixed(2)):Y<fe.GB?(0,D.localize)(3,null,(Y/fe.MB).toFixed(2)):Y<fe.TB?(0,D.localize)(4,null,(Y/fe.GB).toFixed(2)):(0,D.localize)(5,null,(Y/fe.TB).toFixed(2))}}t.$Mk=fe;function Z(V){const Y=typeof V=="string"||V?.scheme===d.Schemas.vscodeRemote;return typeof V!="string"&&V?.scheme===d.Schemas.file?1024*fe.MB:Y?10*fe.MB:f.$o?50*fe.MB:1024*fe.MB}t.$Nk=Z}),define(be[138],pe([1,0,40]),function(ae,t,v){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$U9b=t.$T9b=void 0,t.$T9b=(0,v.$Vh)("mainProcessService");class N{constructor(U,w){this.a=U,this.b=w}getChannel(U){return this.a.getChannel(U,this.b)}registerChannel(U,w){this.a.registerChannel(U,w)}}t.$U9b=N}),define(be[139],pe([1,0,2,133]),function(ae,t,v,N){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$V9b=void 0;class i extends v.$Rc{constructor(w){super(),this.a=this.B(new N.$5T(`window:${w}`))}getChannel(w){return this.a.getChannel(w)}registerChannel(w,D){this.a.registerChannel(w,D)}}t.$V9b=i});var Ei=this&&this.__param||function(ae,t){return function(v,N){t(v,N,ae)}};define(be[140],pe([1,0,67,138]),function(ae,t,v,N){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Z9b=void 0;let i=class{constructor(w,D){return this.windowId=w,v.ProxyChannel.toService(D.getChannel("nativeHost"),{context:w,properties:(()=>{const c=new Map;return c.set("windowId",w),c})()})}};t.$Z9b=i,t.$Z9b=i=Xe([Ei(1,N.$T9b)],i)}),define(be[68],pe([1,0,76,7]),function(ae,t,v,N){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$mn=void 0;class i{constructor(){this.a=new Map}add(w,D){v.ok(N.$Cf(w)),v.ok(N.$Ef(D)),v.ok(!this.a.has(w),"There is already an extension with this id"),this.a.set(w,D)}knows(w){return this.a.has(w)}as(w){return this.a.get(w)||null}}t.$mn=new i}),define(be[141],pe([1,0,4,68]),function(ae,t,v,N){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$nn=void 0,t.$nn={JSONContribution:"base.contributions.json"};function i(D){return D.length>0&&D.charAt(D.length-1)==="#"?D.substring(0,D.length-1):D}class U{constructor(){this.b=new v.$Rd,this.onDidChangeSchema=this.b.event,this.a={}}registerSchema(c,f){this.a[i(c)]=f,this.b.fire(c)}notifySchemaChanged(c){this.b.fire(c)}getSchemaContributions(){return{schemas:this.a}}}const w=new U;N.$mn.add(t.$nn.JSONContribution,w)}),define(be[142],pe([1,0,9,17,18,4,7,15,135,141,68]),function(ae,t,v,N,i,U,w,D,c,f,d){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$gw=t.$fw=t.$ew=t.$dw=t.$cw=t.$bw=t.$aw=t.$_v=t.IconFontDefinition=t.IconContribution=t.$$v=void 0,t.$$v={IconContribution:"base.contributions.icons"};var T;(function(b){function u(o,F){let z=o.defaults;for(;i.ThemeIcon.isThemeIcon(z);){const R=e.getIcon(z.id);if(!R)return;z=R.defaults}return z}b.getDefinition=u})(T||(t.IconContribution=T={}));var s;(function(b){function u(F){return{weight:F.weight,style:F.style,src:F.src.map(z=>({format:z.format,location:z.location.toString()}))}}b.toJSONObject=u;function o(F){const z=R=>(0,w.$Cf)(R)?R:void 0;if(F&&Array.isArray(F.src)&&F.src.every(R=>(0,w.$Cf)(R.format)&&(0,w.$Cf)(R.location)))return{weight:z(F.weight),style:z(F.style),src:F.src.map(R=>({format:R.format,location:D.URI.parse(R.location)}))}}b.fromJSONObject=o})(s||(t.IconFontDefinition=s={}));class a{constructor(){this.a=new U.$Rd,this.onDidChange=this.a.event,this.d={definitions:{icons:{type:"object",properties:{fontId:{type:"string",description:(0,c.localize)(0,null)},fontCharacter:{type:"string",description:(0,c.localize)(1,null)}},additionalProperties:!1,defaultSnippets:[{body:{fontCharacter:"\\\\e030"}}]}},type:"object",properties:{}},this.e={type:"string",pattern:`^${i.ThemeIcon.iconNameExpression}$`,enum:[],enumDescriptions:[]},this.b={},this.f={}}registerIcon(u,o,F,z){const R=this.b[u];if(R){if(F&&!R.description){R.description=F,this.d.properties[u].markdownDescription=`${F} $(${u})`;const M=this.e.enum.indexOf(u);M!==-1&&(this.e.enumDescriptions[M]=F),this.a.fire()}return R}const g={id:u,description:F,defaults:o,deprecationMessage:z};this.b[u]=g;const y={$ref:"#/definitions/icons"};return z&&(y.deprecationMessage=z),F&&(y.markdownDescription=`${F}: $(${u})`),this.d.properties[u]=y,this.e.enum.push(u),this.e.enumDescriptions.push(F||""),this.a.fire(),{id:u}}deregisterIcon(u){delete this.b[u],delete this.d.properties[u];const o=this.e.enum.indexOf(u);o!==-1&&(this.e.enum.splice(o,1),this.e.enumDescriptions.splice(o,1)),this.a.fire()}getIcons(){return Object.keys(this.b).map(u=>this.b[u])}getIcon(u){return this.b[u]}getIconSchema(){return this.d}getIconReferenceSchema(){return this.e}registerIconFont(u,o){const F=this.f[u];return F||(this.f[u]=o,this.a.fire(),o)}deregisterIconFont(u){delete this.f[u]}getIconFont(u){return this.f[u]}toString(){const u=(R,g)=>R.id.localeCompare(g.id),o=R=>{for(;i.ThemeIcon.isThemeIcon(R.defaults);)R=this.b[R.defaults.id];return`codicon codicon-${R?R.id:""}`},F=[];F.push("| preview     | identifier                        | default codicon ID                | description"),F.push("| ----------- | --------------------------------- | --------------------------------- | --------------------------------- |");const z=Object.keys(this.b).map(R=>this.b[R]);for(const R of z.filter(g=>!!g.description).sort(u))F.push(`|<i class="${o(R)}"></i>|${R.id}|${i.ThemeIcon.isThemeIcon(R.defaults)?R.defaults.id:R.id}|${R.description||""}|`);F.push("| preview     | identifier                        "),F.push("| ----------- | --------------------------------- |");for(const R of z.filter(g=>!i.ThemeIcon.isThemeIcon(g.defaults)).sort(u))F.push(`|<i class="${o(R)}"></i>|${R.id}|`);return F.join(`
`)}}const e=new a;d.$mn.add(t.$$v.IconContribution,e);function h(b,u,o,F){return e.registerIcon(b,u,o,F)}t.$_v=h;function l(){return e}t.$aw=l;function m(){const b=(0,N.$Yj)();for(const u in b){const o="\\"+b[u].toString(16);e.registerIcon(u,{fontCharacter:o})}}m(),t.$bw="vscode://schemas/icons";const n=d.$mn.as(f.$nn.JSONContribution);n.registerSchema(t.$bw,e.getIconSchema());const r=new v.$0g(()=>n.notifySchemaChanged(t.$bw),200);e.onDidChange(()=>{r.isScheduled()||r.schedule()}),t.$cw=h("widget-close",N.$1j.close,(0,c.localize)(2,null)),t.$dw=h("goto-previous-location",N.$1j.arrowUp,(0,c.localize)(3,null)),t.$ew=h("goto-next-location",N.$1j.arrowDown,(0,c.localize)(4,null)),t.$fw=i.ThemeIcon.modify(N.$1j.sync,"spin"),t.$gw=i.ThemeIcon.modify(N.$1j.loading,"spin")}),define(be[143],pe([1,0,3,4,2,18,142]),function(ae,t,v,N,i,U,w){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$zDb=t.$yDb=void 0;function D(f){const d=new i.$Qc,T=d.add(new N.$Rd),s=(0,w.$aw)();return d.add(s.onDidChange(()=>T.fire())),f&&d.add(f.onDidProductIconThemeChange(()=>T.fire())),{dispose:()=>d.dispose(),onDidChange:T.event,getCSS(){const a=f?f.getProductIconTheme():new c,e={},h=m=>{const n=a.getIcon(m);if(!n)return;const r=n.font;return r?(e[r.id]=r.definition,`.codicon-${m.id}:before { content: '${n.fontCharacter}'; font-family: ${(0,v.$hQ)(r.id)}; }`):`.codicon-${m.id}:before { content: '${n.fontCharacter}'; }`},l=[];for(const m of s.getIcons()){const n=h(m);n&&l.push(n)}for(const m in e){const n=e[m],r=n.weight?`font-weight: ${n.weight};`:"",b=n.style?`font-style: ${n.style};`:"",u=n.src.map(o=>`${(0,v.$gQ)(o.location)} format('${o.format}')`).join(", ");l.push(`@font-face { src: ${u}; font-family: ${(0,v.$hQ)(m)};${r}${b} font-display: block; }`)}return l.join(`
`)}}}t.$yDb=D;class c{getIcon(d){const T=(0,w.$aw)();let s=d.defaults;for(;U.ThemeIcon.isThemeIcon(s);){const a=T.getIcon(s.id);if(!a)return;s=a.defaults}return s}}t.$zDb=c}),define(be[144],pe([1,0,5]),function(ae,t,v){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$tC=t.$sC=t.$rC=t.$qC=t.$pC=t.$oC=t.$nC=t.$mC=t.$lC=void 0,t.$lC={WIDTH:400,WIDTH_WITH_VERTICAL_PANEL:600,HEIGHT:270};function N(T){return typeof T.parentId=="number"}t.$mC=N;function i(T){return!!T.workspaceUri}t.$nC=i;function U(T){return!!T.folderUri}t.$oC=U;function w(T){return!!T.fileUri}t.$pC=w;function D(T){const s=c(T),a=T.getValue("window.menuBarVisibility");return a==="default"||s==="native"&&a==="compact"||v.$j&&v.$m?"classic":a}t.$qC=D;function c(T){if(v.$o)return"custom";const s=T.getValue("window");if(s){if(v.$j&&s.nativeTabs===!0||v.$j&&s.nativeFullScreen===!1)return"native";const h=s.titleBarStyle;if(h==="native"||h==="custom")return h}return v.$k?"native":"custom"}t.$rC=c;function f(T){return!(!v.$i||v.$o||c(T)==="native")}t.$sC=f;function d(T=0){return Math.pow(1.2,T)}t.$tC=d}),define(be[145],pe([1,0,16,3,21,30,144]),function(ae,t,v,N,i,U,w){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$49b=t.$39b=t.$29b=void 0;function D(T){for(const{window:s}of(0,N.getWindows)())c(s)?.webFrame?.setZoomLevel(T);(0,v.$EO)((0,w.$tC)(T)),(0,v.$BO)(T)}t.$29b=D;function c(T){if(T===i.$vO)return{ipcRenderer:U.$N,webFrame:U.$P};{const s=T;if(s?.vscode?.ipcRenderer&&s?.vscode?.webFrame)return s.vscode}}function f(){D((0,v.$CO)()+1)}t.$39b=f;function d(){D((0,v.$CO)()-1)}t.$49b=d}),define(be[146],pe([1,0,10,3,132,9,90,30,136,137,139,140,143,145,14,21,103,94]),function(ae,t,v,N,i,U,w,D,c,f,d,T,s,a,e,h){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.startup=void 0;const l=/\s--inspect(?:-brk|port)?=(?<port>\d+)?/,m=/\s--inspect-port=(?<port>\d+)/;class n{getHeight(O){return 22}getTemplateId(O){return g(O)?"process":z(O)?"machine":(0,c.$xm)(O)?"error":R(O)?"header":""}}class r{hasChildren(O){return(0,c.$xm)(O)?!1:g(O)?!!O.children?.length:!0}getChildren(O){return g(O)?O.children?O.children:[]:(0,c.$xm)(O)?[]:R(O)?O.processRoots.length>1?O.processRoots:[O.processRoots[0].rootProcess]:z(O)?[O.rootProcess]:[O.processes]}}class b{constructor(){this.templateId="header"}renderTemplate(O){const B=(0,N.$3P)(O,(0,N.$)(".row")),j=(0,N.$3P)(B,(0,N.$)(".nameLabel")),ie=(0,N.$3P)(B,(0,N.$)(".cpu")),te=(0,N.$3P)(B,(0,N.$)(".memory")),ce=(0,N.$3P)(B,(0,N.$)(".pid"));return{name:j,CPU:ie,memory:te,PID:ce}}renderElement(O,B,j,ie){j.name.textContent=(0,v.localize)(0,null),j.CPU.textContent=(0,v.localize)(1,null),j.PID.textContent=(0,v.localize)(2,null),j.memory.textContent=(0,v.localize)(3,null)}disposeTemplate(O){}}class u{constructor(){this.templateId="machine"}renderTemplate(O){const B=Object.create(null),j=(0,N.$3P)(O,(0,N.$)(".row"));return B.name=(0,N.$3P)(j,(0,N.$)(".nameLabel")),B}renderElement(O,B,j,ie){j.name.textContent=O.element.name}disposeTemplate(O){}}class o{constructor(){this.templateId="error"}renderTemplate(O){const B=Object.create(null),j=(0,N.$3P)(O,(0,N.$)(".row"));return B.name=(0,N.$3P)(j,(0,N.$)(".nameLabel")),B}renderElement(O,B,j,ie){j.name.textContent=O.element.errorMessage}disposeTemplate(O){}}class F{constructor(O,B,j){this.a=O,this.b=B,this.c=j,this.templateId="process"}renderTemplate(O){const B=(0,N.$3P)(O,(0,N.$)(".row")),j=(0,N.$3P)(B,(0,N.$)(".nameLabel")),ie=(0,N.$3P)(B,(0,N.$)(".cpu")),te=(0,N.$3P)(B,(0,N.$)(".memory")),ce=(0,N.$3P)(B,(0,N.$)(".pid"));return{name:j,CPU:ie,PID:ce,memory:te}}renderElement(O,B,j,ie){const{element:te}=O,ce=te.pid.toFixed(0);let le=te.name;this.c.has(te.pid)&&(le=this.c.get(te.pid)),j.name.textContent=le,j.name.title=te.cmd,j.CPU.textContent=te.load.toFixed(0),j.PID.textContent=ce,j.PID.parentElement.id=`pid-${ce}`;const oe=this.a==="win32"?te.mem:this.b*(te.mem/100);j.memory.textContent=(oe/f.$Mk.MB).toFixed(0)}disposeTemplate(O){}}function z(x){return!!x.name&&!!x.rootProcess}function R(x){return!!x.processRoots}function g(x){return!!x.pid}class y{constructor(O,B){this.f=B,this.b=new Map;const j=new d.$V9b(O);this.c=new T.$Z9b(O,j),this.k(B.styles),this.g(B),D.$N.on("vscode:pidToNameResponse",(ie,te)=>{this.b=new Map;for(const[ce,le]of te)this.b.set(ce,le)}),D.$N.on("vscode:listProcessesResponse",async(ie,te)=>{te.forEach((ce,le)=>{g(ce.rootProcess)&&(ce.rootProcess.name=le===0?`${this.f.applicationName} main`:"remote agent")}),this.d?(this.d.setInput({processes:{processRoots:te}}),this.d.layout(h.$vO.innerHeight,h.$vO.innerWidth)):await this.h(te),this.m(0)}),this.a=Date.now(),D.$N.send("vscode:pidToNameRequest"),D.$N.send("vscode:listProcesses")}g(O){h.$vO.document.onkeydown=B=>{const j=O.platform==="darwin"?B.metaKey:B.ctrlKey;j&&B.keyCode===87&&(B.stopPropagation(),B.preventDefault(),D.$N.send("vscode:closeProcessExplorer")),j&&B.keyCode===187&&(0,a.$39b)(),j&&B.keyCode===189&&(0,a.$49b)()}}async h(O){const B=h.$vO.document.getElementById("process-list");if(!B)return;const{totalmem:j}=await this.c.getOSStatistics(),ie=[new F(this.f.platform,j,this.b),new b,new u,new o];this.d=new i.$lT("processExplorer",B,new n,ie,new r,{identityProvider:{getId:te=>g(te)?te.pid.toString():(0,c.$xm)(te)?te.hostName:R(te)?"processes":z(te)?te.name:"header"}}),this.d.setInput({processes:{processRoots:O}}),this.d.layout(h.$vO.innerHeight,h.$vO.innerWidth),this.d.onKeyDown(te=>{const ce=new e.$ZO(te);if(ce.keyCode===35&&ce.altKey){const le=this.n();Promise.all(le.map(oe=>this.c.killProcess(oe,"SIGTERM"))).then(()=>this.d?.refresh())}}),this.d.onContextMenu(te=>{g(te.element)&&this.l(te.element,!0)}),B.style.height=`${h.$vO.innerHeight}px`,h.$vO.addEventListener("resize",()=>{B.style.height=`${h.$vO.innerHeight}px`,this.d?.layout(h.$vO.innerHeight,h.$vO.innerWidth)})}i(O){const B=l.exec(O);return B&&B.groups.port!=="0"||O.indexOf("node ")>=0||O.indexOf("node.exe")>=0}j(O){const B={type:"node",request:"attach",name:`process ${O.pid}`};let j=l.exec(O.cmd);j?B.port=Number(j.groups.port):B.processId=String(O.pid),j=m.exec(O.cmd),j&&(B.port=Number(j.groups.port)),D.$N.send("vscode:workbenchCommand",{id:"debug.startFromConfig",from:"processExplorer",args:[B]})}k(O){const B=(0,N.$LP)(),j=[];O.listFocusBackground&&(j.push(`.monaco-list:focus .monaco-list-row.focused { background-color: ${O.listFocusBackground}; }`),j.push(`.monaco-list:focus .monaco-list-row.focused:hover { background-color: ${O.listFocusBackground}; }`)),O.listFocusForeground&&j.push(`.monaco-list:focus .monaco-list-row.focused { color: ${O.listFocusForeground}; }`),O.listActiveSelectionBackground&&(j.push(`.monaco-list:focus .monaco-list-row.selected { background-color: ${O.listActiveSelectionBackground}; }`),j.push(`.monaco-list:focus .monaco-list-row.selected:hover { background-color: ${O.listActiveSelectionBackground}; }`)),O.listActiveSelectionForeground&&j.push(`.monaco-list:focus .monaco-list-row.selected { color: ${O.listActiveSelectionForeground}; }`),O.listHoverBackground&&j.push(`.monaco-list-row:hover:not(.selected):not(.focused) { background-color: ${O.listHoverBackground}; }`),O.listHoverForeground&&j.push(`.monaco-list-row:hover:not(.selected):not(.focused) { color: ${O.listHoverForeground}; }`),O.listFocusOutline&&j.push(`.monaco-list:focus .monaco-list-row.focused { outline: 1px solid ${O.listFocusOutline}; outline-offset: -1px; }`),O.listHoverOutline&&j.push(`.monaco-list-row:hover { outline: 1px dashed ${O.listHoverOutline}; outline-offset: -1px; }`),O.scrollbarShadowColor&&j.push(`
				.monaco-scrollable-element > .shadow.top {
					box-shadow: ${O.scrollbarShadowColor} 0 6px 6px -6px inset;
				}

				.monaco-scrollable-element > .shadow.left {
					box-shadow: ${O.scrollbarShadowColor} 6px 0 6px -6px inset;
				}

				.monaco-scrollable-element > .shadow.top.left {
					box-shadow: ${O.scrollbarShadowColor} 6px 6px 6px -6px inset;
				}
			`),O.scrollbarSliderBackgroundColor&&j.push(`
				.monaco-scrollable-element > .scrollbar > .slider {
					background: ${O.scrollbarSliderBackgroundColor};
				}
			`),O.scrollbarSliderHoverBackgroundColor&&j.push(`
				.monaco-scrollable-element > .scrollbar > .slider:hover {
					background: ${O.scrollbarSliderHoverBackgroundColor};
				}
			`),O.scrollbarSliderActiveBackgroundColor&&j.push(`
				.monaco-scrollable-element > .scrollbar > .slider.active {
					background: ${O.scrollbarSliderActiveBackgroundColor};
				}
			`),B.textContent=j.join(`
`),O.color&&(h.$vO.document.body.style.color=O.color)}l(O,B){const j=[],ie=Number(O.pid);B&&(j.push({accelerator:"Alt+E",label:(0,v.localize)(4,null),click:()=>{this.c.killProcess(ie,"SIGTERM")}}),j.push({label:(0,v.localize)(5,null),click:()=>{this.c.killProcess(ie,"SIGKILL")}}),j.push({type:"separator"})),j.push({label:(0,v.localize)(6,null),click:()=>{const te=this.n();te?.includes(ie)||(te.length=0,te.push(ie));const ce=te?.map(le=>h.$vO.document.getElementById(`pid-${le}`)).filter(le=>!!le);if(ce){const le=ce.map(oe=>oe.innerText).filter(oe=>!!oe);this.c.writeClipboardText(le.join(`
`))}}}),j.push({label:(0,v.localize)(7,null),click:()=>{const te=h.$vO.document.getElementById("process-list");te&&this.c.writeClipboardText(te.innerText)}}),O&&B&&this.i(O.cmd)&&(j.push({type:"separator"}),j.push({label:(0,v.localize)(8,null),click:()=>{this.j(O)}})),(0,w.$WT)(j)}m(O){setTimeout(()=>{const B=Date.now(),j=O+B-this.a;this.a=B,j>1e3?(D.$N.send("vscode:pidToNameRequest"),D.$N.send("vscode:listProcesses")):this.m(j)},200)}n(){return this.d?.getSelection()?.map(O=>{if(!(!O||!("pid"in O)))return O.pid}).filter(O=>!!O)}}function M(){const x=(0,N.$LP)();x.id="codiconStyles";const O=(0,s.$yDb)(void 0);function B(){x.textContent=O.getCSS()}const j=new U.$0g(B,0);O.onDidChange(()=>j.schedule()),j.schedule()}function _(x){const O=x.data.platform==="win32"?"windows":x.data.platform==="linux"?"linux":"mac";h.$vO.document.body.classList.add(O),M(),(0,a.$29b)(x.data.zoomLevel),new y(x.windowId,x.data)}t.startup=_})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/94959e85502687ec77e23eb0d4d4b1a827b919af/core/vs/code/electron-sandbox/processExplorer/processExplorerMain.js.map
