/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var te=["require","exports","vs/base/common/lifecycle","vs/base/common/types","vs/base/common/event","vs/nls!vs/code/node/cliProcessMain","vs/platform/log/common/log","vs/nls","vs/base/common/async","vs/base/common/errors","vs/platform/instantiation/common/instantiation","vs/base/common/uri","vs/platform/files/common/files","vs/base/common/platform","vs/base/common/buffer","vs/base/common/network","vs/base/common/path","vs/base/common/resources","vs/platform/environment/common/environment","vs/base/common/arrays","vs/base/common/cancellation","vs/platform/extensionManagement/common/extensionManagement","vs/platform/uriIdentity/common/uriIdentity","vs/platform/userDataProfile/common/userDataProfile","vs/base/node/pfs","vs/platform/configuration/common/configuration","vs/platform/telemetry/common/telemetry","vs/platform/extensionManagement/common/extensionManagementUtil","vs/base/common/uuid","vs/base/common/strings","vs/base/common/objects","vs/base/common/map","vs/platform/product/common/productService","os","vs/base/common/errorMessage","vs/base/common/process","vs/platform/registry/common/platform","vs/platform/extensions/common/extensions","vs/platform/policy/common/policy","vs/platform/telemetry/common/telemetryUtils","vs/platform/extensionManagement/common/extensionsProfileScannerService","vs/base/common/hash","vs/base/common/semver/semver","vs/platform/configuration/common/configurationRegistry","vs/platform/request/common/request","vs/base/common/stream","vs/base/common/marshalling","vs/base/common/ternarySearchTree","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/descriptors","vs/platform/extensionManagement/common/extensionsScannerService","vs/base/node/zip","vs/base/common/decorators","vs/base/common/json","vs/base/common/severity","vs/base/common/processes","vs/base/node/processes","vs/base/parts/ipc/common/ipc","child_process","vs/platform/download/common/download","vs/platform/extensionManagement/node/extensionSignatureVerificationService","vs/platform/files/common/io","vs/platform/files/common/watcher","vs/platform/instantiation/common/serviceCollection","vs/platform/languagePacks/common/languagePacks","vs/base/common/iterator","vs/platform/configuration/common/configurationModels","vs/platform/remote/common/remoteHosts","vs/platform/state/node/stateService","vs/platform/telemetry/common/commonProperties","vs/base/common/amd","vs/base/common/assert","vs/base/common/numbers","vs/base/common/skipList","vs/base/node/macAddress","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/common/jsonErrorMessages","vs/base/common/jsonErrorMessages","vs/base/common/console","vs/amdX","vs/base/node/id","vs/base/node/powershell","vs/base/node/shell","vs/base/parts/ipc/node/ipc.cp","vs/base/parts/storage/common/storage","vs/nls!vs/base/node/zip","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/contextkey/common/contextkey","vs/nls!vs/platform/contextkey/common/scanner","vs/nls!vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensionManagement/common/extensionManagementCLI","vs/nls!vs/platform/extensionManagement/common/extensionNls","vs/nls!vs/platform/extensionManagement/common/extensionsScannerService","vs/nls!vs/platform/extensionManagement/node/extensionManagementService","vs/nls!vs/platform/extensionManagement/node/extensionManagementUtil","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/fileService","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/languagePacks/common/languagePacks","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/shell/node/shellEnv","vs/nls!vs/platform/telemetry/common/telemetryService","vs/nls!vs/platform/userDataProfile/common/userDataProfile","vs/nls!vs/platform/workspace/common/workspace","vs/platform/contextkey/common/scanner","vs/platform/environment/common/environmentService","vs/platform/environment/node/userDataPath","vs/platform/environment/node/environmentService","vs/platform/extensionManagement/common/extensionNls","vs/platform/externalServices/common/serviceMachineId","vs/platform/instantiation/common/extensions","vs/platform/instantiation/common/graph","vs/platform/contextkey/common/contextkey","vs/platform/files/node/watcher/nodejs/nodejsWatcher","vs/platform/files/node/watcher/nodejs/nodejsClient","vs/platform/files/node/watcher/watcherClient","vs/platform/instantiation/common/instantiationService","vs/platform/files/common/diskFileSystemProvider","vs/platform/files/common/fileService","vs/base/common/performance","vs/platform/files/node/diskFileSystemProvider","fs","vs/platform/log/common/logService","vs/platform/log/node/spdlogLog","vs/platform/log/node/loggerService","vs/platform/policy/common/filePolicyService","vs/platform/policy/node/nativePolicyService","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configurations","vs/platform/configuration/common/configurationService","vs/platform/extensionManagement/node/extensionsManifestCache","vs/platform/download/common/downloadService","vs/platform/request/node/proxy","url","vs/platform/shell/node/shellEnv","vs/platform/state/node/state","vs/platform/extensionManagement/common/extensionManagementCLI","vs/platform/extensionManagement/node/extensionsWatcher","vs/platform/externalServices/common/marketplace","vs/platform/languagePacks/node/languagePacks","vs/platform/telemetry/common/1dsAppender","vs/platform/telemetry/common/telemetryService","vs/platform/product/common/product","vs/platform/telemetry/node/1dsAppender","vs/platform/telemetry/node/telemetry","vs/platform/telemetry/node/telemetryUtils","vs/platform/uriIdentity/common/uriIdentityService","vs/platform/userData/common/fileUserDataProvider","vs/platform/workspace/common/workspace","vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/platform/extensionManagement/node/extensionLifecycle","vs/platform/extensionManagement/node/extensionsProfileScannerService","vs/platform/extensionManagement/node/extensionsScannerService","vs/platform/storage/common/storage","vs/platform/extensionManagement/common/extensionGalleryService","vs/platform/userDataProfile/node/userDataProfile","vs/platform/extensionManagement/node/extensionDownloader","vs/platform/extensionManagement/node/extensionManagementUtil","vs/platform/extensionManagement/node/extensionManagementService","vs/platform/request/node/requestService","vs/base/common/lazy","path","vs/base/common/glob","vs/platform/files/node/watcher/nodejs/nodejsWatcherLib","vs/base/common/linkedList","graceful-fs","vs/base/common/extpath","@vscode/policy-watcher","vs/platform/environment/node/argvHelper","crypto","https","vs/base/common/stopwatch","yauzl","yazl","zlib","@vscode/proxy-agent","vs/code/node/cliProcessMain"],ne=function(J){for(var e=[],L=0,N=J.length;L<N;L++)e[L]=te[J[L]];return e};define(te[70],ne([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$T=e.$S=void 0,e.$S=!1;class L{static get(){const D=new Map,A=new Map,j=new Map,v=new Map;function h(f,S){f.has(S.detail)||f.set(S.detail,-S.timestamp)}function c(f,S){const y=f.get(S.detail);y&&(y>=0||f.set(S.detail,y+S.timestamp))}let E=[];typeof J=="function"&&typeof J.getStats=="function"&&(E=J.getStats().slice(0).sort((f,S)=>f.timestamp-S.timestamp));for(const f of E)switch(f.type){case 10:h(D,f);break;case 11:case 12:c(D,f);break;case 21:h(A,f);break;case 22:c(A,f);break;case 33:h(j,f);break;case 34:c(j,f);break;case 31:h(v,f);break;case 32:c(v,f);break}let R=0;j.forEach(f=>R+=f);function d(f){const S=[];return f.forEach((y,$)=>S.push([$,y])),S}return{amdLoad:d(D),amdInvoke:d(A),nodeRequire:d(j),nodeEval:d(v),nodeRequireTotal:R}}static toMarkdownTable(D,A){let j="";const v=[];return D.forEach((h,c)=>{v[c]=h.length}),A.forEach(h=>{h.forEach((c,E)=>{typeof c>"u"&&(c=h[E]="-");const R=c.toString().length;v[E]=Math.max(R,v[E])})}),D.forEach((h,c)=>{j+=`| ${h+" ".repeat(v[c]-h.toString().length)} `}),j+=`|
`,D.forEach((h,c)=>{j+=`| ${"-".repeat(v[c])} `}),j+=`|
`,A.forEach(h=>{h.forEach((c,E)=>{typeof c<"u"&&(j+=`| ${c+" ".repeat(v[E]-c.toString().length)} `)}),j+=`|
`}),j}}e.$T=L}),define(te[52],ne([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ph=e.$oh=e.$nh=void 0;function L(j){return(v,h,c)=>{let E=null,R=null;if(typeof c.value=="function"?(E="value",R=c.value):typeof c.get=="function"&&(E="get",R=c.get),!R)throw new Error("not supported");c[E]=j(R,h)}}function N(j,v,h){let c=null,E=null;if(typeof h.value=="function"?(c="value",E=h.value,E.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof h.get=="function"&&(c="get",E=h.get),!E)throw new Error("not supported");const R=`$memoize$${v}`;h[c]=function(...d){return this.hasOwnProperty(R)||Object.defineProperty(this,R,{configurable:!1,enumerable:!1,writable:!1,value:E.apply(this,d)}),this[R]}}e.$nh=N;function D(j,v,h){return L((c,E)=>{const R=`$debounce$${E}`,d=`$debounce$result$${E}`;return function(...f){this[d]||(this[d]=h?h():void 0),clearTimeout(this[R]),v&&(this[d]=v(this[d],...f),f=[this[d]]),this[R]=setTimeout(()=>{c.apply(this,f),this[d]=h?h():void 0},j)}})}e.$oh=D;function A(j,v,h){return L((c,E)=>{const R=`$throttle$timer$${E}`,d=`$throttle$result$${E}`,f=`$throttle$lastRun$${E}`,S=`$throttle$pending$${E}`;return function(...y){if(this[d]||(this[d]=h?h():void 0),(this[f]===null||this[f]===void 0)&&(this[f]=-Number.MAX_VALUE),v&&(this[d]=v(this[d],...y)),this[S])return;const $=this[f]+j;$<=Date.now()?(this[f]=Date.now(),c.apply(this,[this[d]]),this[d]=h?h():void 0):(this[S]=!0,this[R]=setTimeout(()=>{this[S]=!1,this[f]=Date.now(),c.apply(this,[this[d]]),this[d]=h?h():void 0},$-Date.now()))}})}e.$ph=A}),define(te[71],ne([0,1,9]),function(J,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7c=e.$6c=e.$5c=e.$4c=e.ok=void 0;function N(h,c){if(!h)throw new Error(c?`Assertion failed (${c})`:"Assertion Failed")}e.ok=N;function D(h,c="Unreachable"){throw new Error(c)}e.$4c=D;function A(h){if(!h)throw new L.$bb("Assertion Failed")}e.$5c=A;function j(h){if(!h()){debugger;h(),(0,L.$Z)(new L.$bb("Assertion Failed"))}}e.$6c=j;function v(h,c){let E=0;for(;E<h.length-1;){const R=h[E],d=h[E+1];if(!c(R,d))return!1;E++}return!0}e.$7c=v}),define(te[53],ne([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_m=e.$$m=e.$0m=e.$9m=e.$8m=e.$7m=e.$6m=e.$5m=e.$4m=e.$3m=e.$2m=e.$1m=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var L;(function(s){s[s.None=0]="None",s[s.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",s[s.UnexpectedEndOfString=2]="UnexpectedEndOfString",s[s.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",s[s.InvalidUnicode=4]="InvalidUnicode",s[s.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",s[s.InvalidCharacter=6]="InvalidCharacter"})(L||(e.ScanError=L={}));var N;(function(s){s[s.OpenBraceToken=1]="OpenBraceToken",s[s.CloseBraceToken=2]="CloseBraceToken",s[s.OpenBracketToken=3]="OpenBracketToken",s[s.CloseBracketToken=4]="CloseBracketToken",s[s.CommaToken=5]="CommaToken",s[s.ColonToken=6]="ColonToken",s[s.NullKeyword=7]="NullKeyword",s[s.TrueKeyword=8]="TrueKeyword",s[s.FalseKeyword=9]="FalseKeyword",s[s.StringLiteral=10]="StringLiteral",s[s.NumericLiteral=11]="NumericLiteral",s[s.LineCommentTrivia=12]="LineCommentTrivia",s[s.BlockCommentTrivia=13]="BlockCommentTrivia",s[s.LineBreakTrivia=14]="LineBreakTrivia",s[s.Trivia=15]="Trivia",s[s.Unknown=16]="Unknown",s[s.EOF=17]="EOF"})(N||(e.SyntaxKind=N={}));var D;(function(s){s[s.InvalidSymbol=1]="InvalidSymbol",s[s.InvalidNumberFormat=2]="InvalidNumberFormat",s[s.PropertyNameExpected=3]="PropertyNameExpected",s[s.ValueExpected=4]="ValueExpected",s[s.ColonExpected=5]="ColonExpected",s[s.CommaExpected=6]="CommaExpected",s[s.CloseBraceExpected=7]="CloseBraceExpected",s[s.CloseBracketExpected=8]="CloseBracketExpected",s[s.EndOfFileExpected=9]="EndOfFileExpected",s[s.InvalidCommentToken=10]="InvalidCommentToken",s[s.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",s[s.UnexpectedEndOfString=12]="UnexpectedEndOfString",s[s.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",s[s.InvalidUnicode=14]="InvalidUnicode",s[s.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",s[s.InvalidCharacter=16]="InvalidCharacter"})(D||(e.ParseErrorCode=D={}));var A;(function(s){s.DEFAULT={allowTrailingComma:!0}})(A||(e.ParseOptions=A={}));function j(s,o=!1){let t=0;const n=s.length;let i="",r=0,l=16,k=0;function b(se){let ue=0,ce=0;for(;ue<se;){const re=s.charCodeAt(t);if(re>=48&&re<=57)ce=ce*16+re-48;else if(re>=65&&re<=70)ce=ce*16+re-65+10;else if(re>=97&&re<=102)ce=ce*16+re-97+10;else break;t++,ue++}return ue<se&&(ce=-1),ce}function p(se){t=se,i="",r=0,l=16,k=0}function O(){const se=t;if(s.charCodeAt(t)===48)t++;else for(t++;t<s.length&&c(s.charCodeAt(t));)t++;if(t<s.length&&s.charCodeAt(t)===46)if(t++,t<s.length&&c(s.charCodeAt(t)))for(t++;t<s.length&&c(s.charCodeAt(t));)t++;else return k=3,s.substring(se,t);let ue=t;if(t<s.length&&(s.charCodeAt(t)===69||s.charCodeAt(t)===101))if(t++,(t<s.length&&s.charCodeAt(t)===43||s.charCodeAt(t)===45)&&t++,t<s.length&&c(s.charCodeAt(t))){for(t++;t<s.length&&c(s.charCodeAt(t));)t++;ue=t}else k=3;return s.substring(se,ue)}function B(){let se="",ue=t;for(;;){if(t>=n){se+=s.substring(ue,t),k=2;break}const ce=s.charCodeAt(t);if(ce===34){se+=s.substring(ue,t),t++;break}if(ce===92){if(se+=s.substring(ue,t),t++,t>=n){k=2;break}switch(s.charCodeAt(t++)){case 34:se+='"';break;case 92:se+="\\";break;case 47:se+="/";break;case 98:se+="\b";break;case 102:se+="\f";break;case 110:se+=`
`;break;case 114:se+="\r";break;case 116:se+="	";break;case 117:{const q=b(4);q>=0?se+=String.fromCharCode(q):k=4;break}default:k=5}ue=t;continue}if(ce>=0&&ce<=31)if(h(ce)){se+=s.substring(ue,t),k=2;break}else k=6;t++}return se}function _(){if(i="",k=0,r=t,t>=n)return r=n,l=17;let se=s.charCodeAt(t);if(v(se)){do t++,i+=String.fromCharCode(se),se=s.charCodeAt(t);while(v(se));return l=15}if(h(se))return t++,i+=String.fromCharCode(se),se===13&&s.charCodeAt(t)===10&&(t++,i+=`
`),l=14;switch(se){case 123:return t++,l=1;case 125:return t++,l=2;case 91:return t++,l=3;case 93:return t++,l=4;case 58:return t++,l=6;case 44:return t++,l=5;case 34:return t++,i=B(),l=10;case 47:{const ue=t-1;if(s.charCodeAt(t+1)===47){for(t+=2;t<n&&!h(s.charCodeAt(t));)t++;return i=s.substring(ue,t),l=12}if(s.charCodeAt(t+1)===42){t+=2;const ce=n-1;let re=!1;for(;t<ce;){if(s.charCodeAt(t)===42&&s.charCodeAt(t+1)===47){t+=2,re=!0;break}t++}return re||(t++,k=1),i=s.substring(ue,t),l=13}return i+=String.fromCharCode(se),t++,l=16}case 45:if(i+=String.fromCharCode(se),t++,t===n||!c(s.charCodeAt(t)))return l=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return i+=O(),l=11;default:for(;t<n&&ee(se);)t++,se=s.charCodeAt(t);if(r!==t){switch(i=s.substring(r,t),i){case"true":return l=8;case"false":return l=9;case"null":return l=7}return l=16}return i+=String.fromCharCode(se),t++,l=16}}function ee(se){if(v(se)||h(se))return!1;switch(se){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function oe(){let se;do se=_();while(se>=12&&se<=15);return se}return{setPosition:p,getPosition:()=>t,scan:o?oe:_,getToken:()=>l,getTokenValue:()=>i,getTokenOffset:()=>r,getTokenLength:()=>t-r,getTokenError:()=>k}}e.$1m=j;function v(s){return s===32||s===9||s===11||s===12||s===160||s===5760||s>=8192&&s<=8203||s===8239||s===8287||s===12288||s===65279}function h(s){return s===10||s===13||s===8232||s===8233}function c(s){return s>=48&&s<=57}var E;(function(s){s[s.nullCharacter=0]="nullCharacter",s[s.maxAsciiCharacter=127]="maxAsciiCharacter",s[s.lineFeed=10]="lineFeed",s[s.carriageReturn=13]="carriageReturn",s[s.lineSeparator=8232]="lineSeparator",s[s.paragraphSeparator=8233]="paragraphSeparator",s[s.nextLine=133]="nextLine",s[s.space=32]="space",s[s.nonBreakingSpace=160]="nonBreakingSpace",s[s.enQuad=8192]="enQuad",s[s.emQuad=8193]="emQuad",s[s.enSpace=8194]="enSpace",s[s.emSpace=8195]="emSpace",s[s.threePerEmSpace=8196]="threePerEmSpace",s[s.fourPerEmSpace=8197]="fourPerEmSpace",s[s.sixPerEmSpace=8198]="sixPerEmSpace",s[s.figureSpace=8199]="figureSpace",s[s.punctuationSpace=8200]="punctuationSpace",s[s.thinSpace=8201]="thinSpace",s[s.hairSpace=8202]="hairSpace",s[s.zeroWidthSpace=8203]="zeroWidthSpace",s[s.narrowNoBreakSpace=8239]="narrowNoBreakSpace",s[s.ideographicSpace=12288]="ideographicSpace",s[s.mathematicalSpace=8287]="mathematicalSpace",s[s.ogham=5760]="ogham",s[s._=95]="_",s[s.$=36]="$",s[s._0=48]="_0",s[s._1=49]="_1",s[s._2=50]="_2",s[s._3=51]="_3",s[s._4=52]="_4",s[s._5=53]="_5",s[s._6=54]="_6",s[s._7=55]="_7",s[s._8=56]="_8",s[s._9=57]="_9",s[s.a=97]="a",s[s.b=98]="b",s[s.c=99]="c",s[s.d=100]="d",s[s.e=101]="e",s[s.f=102]="f",s[s.g=103]="g",s[s.h=104]="h",s[s.i=105]="i",s[s.j=106]="j",s[s.k=107]="k",s[s.l=108]="l",s[s.m=109]="m",s[s.n=110]="n",s[s.o=111]="o",s[s.p=112]="p",s[s.q=113]="q",s[s.r=114]="r",s[s.s=115]="s",s[s.t=116]="t",s[s.u=117]="u",s[s.v=118]="v",s[s.w=119]="w",s[s.x=120]="x",s[s.y=121]="y",s[s.z=122]="z",s[s.A=65]="A",s[s.B=66]="B",s[s.C=67]="C",s[s.D=68]="D",s[s.E=69]="E",s[s.F=70]="F",s[s.G=71]="G",s[s.H=72]="H",s[s.I=73]="I",s[s.J=74]="J",s[s.K=75]="K",s[s.L=76]="L",s[s.M=77]="M",s[s.N=78]="N",s[s.O=79]="O",s[s.P=80]="P",s[s.Q=81]="Q",s[s.R=82]="R",s[s.S=83]="S",s[s.T=84]="T",s[s.U=85]="U",s[s.V=86]="V",s[s.W=87]="W",s[s.X=88]="X",s[s.Y=89]="Y",s[s.Z=90]="Z",s[s.ampersand=38]="ampersand",s[s.asterisk=42]="asterisk",s[s.at=64]="at",s[s.backslash=92]="backslash",s[s.bar=124]="bar",s[s.caret=94]="caret",s[s.closeBrace=125]="closeBrace",s[s.closeBracket=93]="closeBracket",s[s.closeParen=41]="closeParen",s[s.colon=58]="colon",s[s.comma=44]="comma",s[s.dot=46]="dot",s[s.doubleQuote=34]="doubleQuote",s[s.equals=61]="equals",s[s.exclamation=33]="exclamation",s[s.greaterThan=62]="greaterThan",s[s.lessThan=60]="lessThan",s[s.minus=45]="minus",s[s.openBrace=123]="openBrace",s[s.openBracket=91]="openBracket",s[s.openParen=40]="openParen",s[s.percent=37]="percent",s[s.plus=43]="plus",s[s.question=63]="question",s[s.semicolon=59]="semicolon",s[s.singleQuote=39]="singleQuote",s[s.slash=47]="slash",s[s.tilde=126]="tilde",s[s.backspace=8]="backspace",s[s.formFeed=12]="formFeed",s[s.byteOrderMark=65279]="byteOrderMark",s[s.tab=9]="tab",s[s.verticalTab=11]="verticalTab"})(E||(E={}));function R(s,o){const t=[],n=new Object;let i;const r={value:{},offset:0,length:0,type:"object",parent:void 0};let l=!1;function k(b,p,O,B){r.value=b,r.offset=p,r.length=O,r.type=B,r.colonOffset=void 0,i=r}try{I(s,{onObjectBegin:(b,p)=>{if(o<=b)throw n;i=void 0,l=o>b,t.push("")},onObjectProperty:(b,p,O)=>{if(o<p||(k(b,p,O,"property"),t[t.length-1]=b,o<=p+O))throw n},onObjectEnd:(b,p)=>{if(o<=b)throw n;i=void 0,t.pop()},onArrayBegin:(b,p)=>{if(o<=b)throw n;i=void 0,t.push(0)},onArrayEnd:(b,p)=>{if(o<=b)throw n;i=void 0,t.pop()},onLiteralValue:(b,p,O)=>{if(o<p||(k(b,p,O,P(b)),o<=p+O))throw n},onSeparator:(b,p,O)=>{if(o<=p)throw n;if(b===":"&&i&&i.type==="property")i.colonOffset=p,l=!1,i=void 0;else if(b===","){const B=t[t.length-1];typeof B=="number"?t[t.length-1]=B+1:(l=!0,t[t.length-1]=""),i=void 0}}})}catch(b){if(b!==n)throw b}return{path:t,previousNode:i,isAtPropertyKey:l,matches:b=>{let p=0;for(let O=0;p<b.length&&O<t.length;O++)if(b[p]===t[O]||b[p]==="*")p++;else if(b[p]!=="**")return!1;return p===b.length}}}e.$2m=R;function d(s,o=[],t=A.DEFAULT){let n=null,i=[];const r=[];function l(b){Array.isArray(i)?i.push(b):n!==null&&(i[n]=b)}return I(s,{onObjectBegin:()=>{const b={};l(b),r.push(i),i=b,n=null},onObjectProperty:b=>{n=b},onObjectEnd:()=>{i=r.pop()},onArrayBegin:()=>{const b=[];l(b),r.push(i),i=b,n=null},onArrayEnd:()=>{i=r.pop()},onLiteralValue:l,onError:(b,p,O)=>{o.push({error:b,offset:p,length:O})}},t),i[0]}e.$3m=d;function f(s,o=[],t=A.DEFAULT){let n={type:"array",offset:-1,length:-1,children:[],parent:void 0};function i(b){n.type==="property"&&(n.length=b-n.offset,n=n.parent)}function r(b){return n.children.push(b),b}I(s,{onObjectBegin:b=>{n=r({type:"object",offset:b,length:-1,parent:n,children:[]})},onObjectProperty:(b,p,O)=>{n=r({type:"property",offset:p,length:-1,parent:n,children:[]}),n.children.push({type:"string",value:b,offset:p,length:O,parent:n})},onObjectEnd:(b,p)=>{n.length=b+p-n.offset,n=n.parent,i(b+p)},onArrayBegin:(b,p)=>{n=r({type:"array",offset:b,length:-1,parent:n,children:[]})},onArrayEnd:(b,p)=>{n.length=b+p-n.offset,n=n.parent,i(b+p)},onLiteralValue:(b,p,O)=>{r({type:P(b),offset:p,length:O,parent:n,value:b}),i(p+O)},onSeparator:(b,p,O)=>{n.type==="property"&&(b===":"?n.colonOffset=p:b===","&&i(p))},onError:(b,p,O)=>{o.push({error:b,offset:p,length:O})}},t);const k=n.children[0];return k&&delete k.parent,k}e.$4m=f;function S(s,o){if(!s)return;let t=s;for(const n of o)if(typeof n=="string"){if(t.type!=="object"||!Array.isArray(t.children))return;let i=!1;for(const r of t.children)if(Array.isArray(r.children)&&r.children[0].value===n){t=r.children[1],i=!0;break}if(!i)return}else{const i=n;if(t.type!=="array"||i<0||!Array.isArray(t.children)||i>=t.children.length)return;t=t.children[i]}return t}e.$5m=S;function y(s){if(!s.parent||!s.parent.children)return[];const o=y(s.parent);if(s.parent.type==="property"){const t=s.parent.children[0].value;o.push(t)}else if(s.parent.type==="array"){const t=s.parent.children.indexOf(s);t!==-1&&o.push(t)}return o}e.$6m=y;function $(s){switch(s.type){case"array":return s.children.map($);case"object":{const o=Object.create(null);for(const t of s.children){const n=t.children[1];n&&(o[t.children[0].value]=$(n))}return o}case"null":case"string":case"number":case"boolean":return s.value;default:return}}e.$7m=$;function u(s,o,t=!1){return o>=s.offset&&o<s.offset+s.length||t&&o===s.offset+s.length}e.$8m=u;function m(s,o,t=!1){if(u(s,o,t)){const n=s.children;if(Array.isArray(n))for(let i=0;i<n.length&&n[i].offset<=o;i++){const r=m(n[i],o,t);if(r)return r}return s}}e.$9m=m;function I(s,o,t=A.DEFAULT){const n=j(s,!1);function i(Z){return Z?()=>Z(n.getTokenOffset(),n.getTokenLength()):()=>!0}function r(Z){return Z?Y=>Z(Y,n.getTokenOffset(),n.getTokenLength()):()=>!0}const l=i(o.onObjectBegin),k=r(o.onObjectProperty),b=i(o.onObjectEnd),p=i(o.onArrayBegin),O=i(o.onArrayEnd),B=r(o.onLiteralValue),_=r(o.onSeparator),ee=i(o.onComment),oe=r(o.onError),se=t&&t.disallowComments,ue=t&&t.allowTrailingComma;function ce(){for(;;){const Z=n.scan();switch(n.getTokenError()){case 4:re(14);break;case 5:re(15);break;case 3:re(13);break;case 1:se||re(11);break;case 2:re(12);break;case 6:re(16);break}switch(Z){case 12:case 13:se?re(10):ee();break;case 16:re(1);break;case 15:case 14:break;default:return Z}}}function re(Z,Y=[],C=[]){if(oe(Z),Y.length+C.length>0){let F=n.getToken();for(;F!==17;){if(Y.indexOf(F)!==-1){ce();break}else if(C.indexOf(F)!==-1)break;F=ce()}}}function q(Z){const Y=n.getTokenValue();return Z?B(Y):k(Y),ce(),!0}function Q(){switch(n.getToken()){case 11:{let Z=0;try{Z=JSON.parse(n.getTokenValue()),typeof Z!="number"&&(re(2),Z=0)}catch{re(2)}B(Z);break}case 7:B(null);break;case 8:B(!0);break;case 9:B(!1);break;default:return!1}return ce(),!0}function T(){return n.getToken()!==10?(re(3,[],[2,5]),!1):(q(!1),n.getToken()===6?(_(":"),ce(),G()||re(4,[],[2,5])):re(5,[],[2,5]),!0)}function U(){l(),ce();let Z=!1;for(;n.getToken()!==2&&n.getToken()!==17;){if(n.getToken()===5){if(Z||re(4,[],[]),_(","),ce(),n.getToken()===2&&ue)break}else Z&&re(6,[],[]);T()||re(4,[],[2,5]),Z=!0}return b(),n.getToken()!==2?re(7,[2],[]):ce(),!0}function H(){p(),ce();let Z=!1;for(;n.getToken()!==4&&n.getToken()!==17;){if(n.getToken()===5){if(Z||re(4,[],[]),_(","),ce(),n.getToken()===4&&ue)break}else Z&&re(6,[],[]);G()||re(4,[],[4,5]),Z=!0}return O(),n.getToken()!==4?re(8,[4],[]):ce(),!0}function G(){switch(n.getToken()){case 3:return H();case 1:return U();case 10:return q(!0);default:return Q()}}return ce(),n.getToken()===17?t.allowEmptyContent?!0:(re(4,[],[]),!1):G()?(n.getToken()!==17&&re(9,[],[]),!0):(re(4,[],[]),!1)}e.$0m=I;function w(s,o){const t=j(s),n=[];let i,r=0,l;do switch(l=t.getPosition(),i=t.scan(),i){case 12:case 13:case 17:r!==l&&n.push(s.substring(r,l)),o!==void 0&&n.push(t.getTokenValue().replace(/[^\r\n]/g,o)),r=t.getPosition();break}while(i!==17);return n.join("")}e.$$m=w;function P(s){switch(typeof s){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(s){if(Array.isArray(s))return"array"}else return"null";return"object"}default:return"null"}}e.$_m=P}),define(te[72],ne([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yl=e.$Xl=e.$Wl=e.rot=e.$Ul=void 0;function L(v,h,c){return Math.min(Math.max(v,h),c)}e.$Ul=L;function N(v,h){return(h+v%h)%h}e.rot=N;class D{constructor(){this.a=0}getNext(){return this.a++}}e.$Wl=D;class A{constructor(){this.a=1,this.b=0}update(h){return this.b=this.b+(h-this.b)/this.a,this.a+=1,this.b}get value(){return this.b}}e.$Xl=A;class j{constructor(h){this.a=0,this.b=0,this.c=[],this.d=0,this.e=0,this.c=new Array(h),this.c.fill(0,0,h)}update(h){const c=this.c[this.d];return this.c[this.d]=h,this.d=(this.d+1)%this.c.length,this.e-=c,this.e+=h,this.a<this.c.length&&(this.a+=1),this.b=this.e/this.a,this.b}get value(){return this.b}}e.$Yl=j}),function(){function J(D){const A=[];typeof D=="number"&&A.push("code/timeOrigin",D);function j(h){A.push(h,Date.now())}function v(){const h=[];for(let c=0;c<A.length;c+=2)h.push({name:A[c],startTime:A[c+1]});return h}return{mark:j,getMarks:v}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?J():{mark(D){performance.mark(D)},getMarks(){let D=performance.timeOrigin;typeof D!="number"&&(D=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const A=[{name:"code/timeOrigin",startTime:Math.round(D)}];for(const j of performance.getEntriesByType("mark"))A.push({name:j.name,startTime:Math.round(D+j.startTime)});return A}};if(typeof process=="object"){const D=performance?.timeOrigin??Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return J(D)}else return console.trace("perf-util loaded in UNKNOWN environment"),J()}function L(D){return D.MonacoPerformanceMarks||(D.MonacoPerformanceMarks=e()),D.MonacoPerformanceMarks}var N;typeof global=="object"?N=global:typeof self=="object"?N=self:N={},typeof define=="function"?define("vs/base/common/performance",[],function(){return L(N)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=L(N):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),N.perf=L(N))}(),function(J,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var L=e();for(var N in L)(typeof exports=="object"?exports:J)[N]=L[N]}}(typeof self<"u"?self:this,function(){return function(J){var e={};function L(N){if(e[N])return e[N].exports;var D=e[N]={i:N,l:!1,exports:{}};return J[N].call(D.exports,D,D.exports,L),D.l=!0,D.exports}return L.m=J,L.c=e,L.d=function(N,D,A){L.o(N,D)||Object.defineProperty(N,D,{enumerable:!0,get:A})},L.r=function(N){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(N,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(N,"__esModule",{value:!0})},L.t=function(N,D){if(1&D&&(N=L(N)),8&D||4&D&&typeof N=="object"&&N&&N.__esModule)return N;var A=Object.create(null);if(L.r(A),Object.defineProperty(A,"default",{enumerable:!0,value:N}),2&D&&typeof N!="string")for(var j in N)L.d(A,j,function(v){return N[v]}.bind(null,j));return A},L.n=function(N){var D=N&&N.__esModule?function(){return N.default}:function(){return N};return L.d(D,"a",D),D},L.o=function(N,D){return Object.prototype.hasOwnProperty.call(N,D)},L.p="",L(L.s=0)}([function(J,e,L){(function(N){var D;e=J.exports=C,D=typeof N=="object"&&N.env&&N.env.NODE_DEBUG&&/\bsemver\b/i.test(N.env.NODE_DEBUG)?function(){var V=Array.prototype.slice.call(arguments,0);V.unshift("SEMVER"),console.log.apply(console,V)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var A=256,j=Number.MAX_SAFE_INTEGER||9007199254740991,v=e.re=[],h=e.src=[],c=0,E=c++;h[E]="0|[1-9]\\d*";var R=c++;h[R]="[0-9]+";var d=c++;h[d]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var f=c++;h[f]="("+h[E]+")\\.("+h[E]+")\\.("+h[E]+")";var S=c++;h[S]="("+h[R]+")\\.("+h[R]+")\\.("+h[R]+")";var y=c++;h[y]="(?:"+h[E]+"|"+h[d]+")";var $=c++;h[$]="(?:"+h[R]+"|"+h[d]+")";var u=c++;h[u]="(?:-("+h[y]+"(?:\\."+h[y]+")*))";var m=c++;h[m]="(?:-?("+h[$]+"(?:\\."+h[$]+")*))";var I=c++;h[I]="[0-9A-Za-z-]+";var w=c++;h[w]="(?:\\+("+h[I]+"(?:\\."+h[I]+")*))";var P=c++,s="v?"+h[f]+h[u]+"?"+h[w]+"?";h[P]="^"+s+"$";var o="[v=\\s]*"+h[S]+h[m]+"?"+h[w]+"?",t=c++;h[t]="^"+o+"$";var n=c++;h[n]="((?:<|>)?=?)";var i=c++;h[i]=h[R]+"|x|X|\\*";var r=c++;h[r]=h[E]+"|x|X|\\*";var l=c++;h[l]="[v=\\s]*("+h[r]+")(?:\\.("+h[r]+")(?:\\.("+h[r]+")(?:"+h[u]+")?"+h[w]+"?)?)?";var k=c++;h[k]="[v=\\s]*("+h[i]+")(?:\\.("+h[i]+")(?:\\.("+h[i]+")(?:"+h[m]+")?"+h[w]+"?)?)?";var b=c++;h[b]="^"+h[n]+"\\s*"+h[l]+"$";var p=c++;h[p]="^"+h[n]+"\\s*"+h[k]+"$";var O=c++;h[O]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var B=c++;h[B]="(?:~>?)";var _=c++;h[_]="(\\s*)"+h[B]+"\\s+",v[_]=new RegExp(h[_],"g");var ee=c++;h[ee]="^"+h[B]+h[l]+"$";var oe=c++;h[oe]="^"+h[B]+h[k]+"$";var se=c++;h[se]="(?:\\^)";var ue=c++;h[ue]="(\\s*)"+h[se]+"\\s+",v[ue]=new RegExp(h[ue],"g");var ce=c++;h[ce]="^"+h[se]+h[l]+"$";var re=c++;h[re]="^"+h[se]+h[k]+"$";var q=c++;h[q]="^"+h[n]+"\\s*("+o+")$|^$";var Q=c++;h[Q]="^"+h[n]+"\\s*("+s+")$|^$";var T=c++;h[T]="(\\s*)"+h[n]+"\\s*("+o+"|"+h[l]+")",v[T]=new RegExp(h[T],"g");var U=c++;h[U]="^\\s*("+h[l]+")\\s+-\\s+("+h[l]+")\\s*$";var H=c++;h[H]="^\\s*("+h[k]+")\\s+-\\s+("+h[k]+")\\s*$";var G=c++;h[G]="(<|>)?=?\\s*\\*";for(var Z=0;Z<35;Z++)D(Z,h[Z]),v[Z]||(v[Z]=new RegExp(h[Z]));function Y(V,K){if(V instanceof C)return V;if(typeof V!="string"||V.length>A||!(K?v[t]:v[P]).test(V))return null;try{return new C(V,K)}catch{return null}}function C(V,K){if(V instanceof C){if(V.loose===K)return V;V=V.version}else if(typeof V!="string")throw new TypeError("Invalid Version: "+V);if(V.length>A)throw new TypeError("version is longer than "+A+" characters");if(!(this instanceof C))return new C(V,K);D("SemVer",V,K),this.loose=K;var x=V.trim().match(K?v[t]:v[P]);if(!x)throw new TypeError("Invalid Version: "+V);if(this.raw=V,this.major=+x[1],this.minor=+x[2],this.patch=+x[3],this.major>j||this.major<0)throw new TypeError("Invalid major version");if(this.minor>j||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>j||this.patch<0)throw new TypeError("Invalid patch version");x[4]?this.prerelease=x[4].split(".").map(function($e){if(/^[0-9]+$/.test($e)){var ye=+$e;if(ye>=0&&ye<j)return ye}return $e}):this.prerelease=[],this.build=x[5]?x[5].split("."):[],this.format()}e.parse=Y,e.valid=function(V,K){var x=Y(V,K);return x?x.version:null},e.clean=function(V,K){var x=Y(V.trim().replace(/^[=v]+/,""),K);return x?x.version:null},e.SemVer=C,C.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},C.prototype.toString=function(){return this.version},C.prototype.compare=function(V){return D("SemVer.compare",this.version,this.loose,V),V instanceof C||(V=new C(V,this.loose)),this.compareMain(V)||this.comparePre(V)},C.prototype.compareMain=function(V){return V instanceof C||(V=new C(V,this.loose)),a(this.major,V.major)||a(this.minor,V.minor)||a(this.patch,V.patch)},C.prototype.comparePre=function(V){if(V instanceof C||(V=new C(V,this.loose)),this.prerelease.length&&!V.prerelease.length)return-1;if(!this.prerelease.length&&V.prerelease.length)return 1;if(!this.prerelease.length&&!V.prerelease.length)return 0;var K=0;do{var x=this.prerelease[K],$e=V.prerelease[K];if(D("prerelease compare",K,x,$e),x===void 0&&$e===void 0)return 0;if($e===void 0)return 1;if(x===void 0)return-1;if(x!==$e)return a(x,$e)}while(++K)},C.prototype.inc=function(V,K){switch(V){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",K);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",K);break;case"prepatch":this.prerelease.length=0,this.inc("patch",K),this.inc("pre",K);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",K),this.inc("pre",K);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var x=this.prerelease.length;--x>=0;)typeof this.prerelease[x]=="number"&&(this.prerelease[x]++,x=-2);x===-1&&this.prerelease.push(0)}K&&(this.prerelease[0]===K?isNaN(this.prerelease[1])&&(this.prerelease=[K,0]):this.prerelease=[K,0]);break;default:throw new Error("invalid increment argument: "+V)}return this.format(),this.raw=this.version,this},e.inc=function(V,K,x,$e){typeof x=="string"&&($e=x,x=void 0);try{return new C(V,x).inc(K,$e).version}catch{return null}},e.diff=function(V,K){if(X(V,K))return null;var x=Y(V),$e=Y(K);if(x.prerelease.length||$e.prerelease.length){for(var ye in x)if((ye==="major"||ye==="minor"||ye==="patch")&&x[ye]!==$e[ye])return"pre"+ye;return"prerelease"}for(var ye in x)if((ye==="major"||ye==="minor"||ye==="patch")&&x[ye]!==$e[ye])return ye},e.compareIdentifiers=a;var F=/^[0-9]+$/;function a(V,K){var x=F.test(V),$e=F.test(K);return x&&$e&&(V=+V,K=+K),x&&!$e?-1:$e&&!x?1:V<K?-1:V>K?1:0}function g(V,K,x){return new C(V,x).compare(new C(K,x))}function z(V,K,x){return g(V,K,x)>0}function M(V,K,x){return g(V,K,x)<0}function X(V,K,x){return g(V,K,x)===0}function W(V,K,x){return g(V,K,x)!==0}function le(V,K,x){return g(V,K,x)>=0}function ae(V,K,x){return g(V,K,x)<=0}function me(V,K,x,$e){var ye;switch(K){case"===":typeof V=="object"&&(V=V.version),typeof x=="object"&&(x=x.version),ye=V===x;break;case"!==":typeof V=="object"&&(V=V.version),typeof x=="object"&&(x=x.version),ye=V!==x;break;case"":case"=":case"==":ye=X(V,x,$e);break;case"!=":ye=W(V,x,$e);break;case">":ye=z(V,x,$e);break;case">=":ye=le(V,x,$e);break;case"<":ye=M(V,x,$e);break;case"<=":ye=ae(V,x,$e);break;default:throw new TypeError("Invalid operator: "+K)}return ye}function de(V,K){if(V instanceof de){if(V.loose===K)return V;V=V.value}if(!(this instanceof de))return new de(V,K);D("comparator",V,K),this.loose=K,this.parse(V),this.semver===ge?this.value="":this.value=this.operator+this.semver.version,D("comp",this)}e.rcompareIdentifiers=function(V,K){return a(K,V)},e.major=function(V,K){return new C(V,K).major},e.minor=function(V,K){return new C(V,K).minor},e.patch=function(V,K){return new C(V,K).patch},e.compare=g,e.compareLoose=function(V,K){return g(V,K,!0)},e.rcompare=function(V,K,x){return g(K,V,x)},e.sort=function(V,K){return V.sort(function(x,$e){return e.compare(x,$e,K)})},e.rsort=function(V,K){return V.sort(function(x,$e){return e.rcompare(x,$e,K)})},e.gt=z,e.lt=M,e.eq=X,e.neq=W,e.gte=le,e.lte=ae,e.cmp=me,e.Comparator=de;var ge={};function fe(V,K){if(V instanceof fe)return V.loose===K?V:new fe(V.raw,K);if(V instanceof de)return new fe(V.value,K);if(!(this instanceof fe))return new fe(V,K);if(this.loose=K,this.raw=V,this.set=V.split(/\s*\|\|\s*/).map(function(x){return this.parseRange(x.trim())},this).filter(function(x){return x.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+V);this.format()}function he(V){return!V||V.toLowerCase()==="x"||V==="*"}function we(V,K,x,$e,ye,De,Se,Le,Ie,je,Ue,Re,Ne){return((K=he(x)?"":he($e)?">="+x+".0.0":he(ye)?">="+x+"."+$e+".0":">="+K)+" "+(Le=he(Ie)?"":he(je)?"<"+(+Ie+1)+".0.0":he(Ue)?"<"+Ie+"."+(+je+1)+".0":Re?"<="+Ie+"."+je+"."+Ue+"-"+Re:"<="+Le)).trim()}function be(V,K){for(var x=0;x<V.length;x++)if(!V[x].test(K))return!1;if(K.prerelease.length){for(x=0;x<V.length;x++)if(D(V[x].semver),V[x].semver!==ge&&V[x].semver.prerelease.length>0){var $e=V[x].semver;if($e.major===K.major&&$e.minor===K.minor&&$e.patch===K.patch)return!0}return!1}return!0}function ke(V,K,x){try{K=new fe(K,x)}catch{return!1}return K.test(V)}function Ce(V,K,x,$e){var ye,De,Se,Le,Ie;switch(V=new C(V,$e),K=new fe(K,$e),x){case">":ye=z,De=ae,Se=M,Le=">",Ie=">=";break;case"<":ye=M,De=le,Se=z,Le="<",Ie="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(ke(V,K,$e))return!1;for(var je=0;je<K.set.length;++je){var Ue=K.set[je],Re=null,Ne=null;if(Ue.forEach(function(ze){ze.semver===ge&&(ze=new de(">=0.0.0")),Re=Re||ze,Ne=Ne||ze,ye(ze.semver,Re.semver,$e)?Re=ze:Se(ze.semver,Ne.semver,$e)&&(Ne=ze)}),Re.operator===Le||Re.operator===Ie||(!Ne.operator||Ne.operator===Le)&&De(V,Ne.semver)||Ne.operator===Ie&&Se(V,Ne.semver))return!1}return!0}de.prototype.parse=function(V){var K=this.loose?v[q]:v[Q],x=V.match(K);if(!x)throw new TypeError("Invalid comparator: "+V);this.operator=x[1],this.operator==="="&&(this.operator=""),x[2]?this.semver=new C(x[2],this.loose):this.semver=ge},de.prototype.toString=function(){return this.value},de.prototype.test=function(V){return D("Comparator.test",V,this.loose),this.semver===ge||(typeof V=="string"&&(V=new C(V,this.loose)),me(V,this.operator,this.semver,this.loose))},de.prototype.intersects=function(V,K){if(!(V instanceof de))throw new TypeError("a Comparator is required");var x;if(this.operator==="")return x=new fe(V.value,K),ke(this.value,x,K);if(V.operator==="")return x=new fe(this.value,K),ke(V.semver,x,K);var $e=!(this.operator!==">="&&this.operator!==">"||V.operator!==">="&&V.operator!==">"),ye=!(this.operator!=="<="&&this.operator!=="<"||V.operator!=="<="&&V.operator!=="<"),De=this.semver.version===V.semver.version,Se=!(this.operator!==">="&&this.operator!=="<="||V.operator!==">="&&V.operator!=="<="),Le=me(this.semver,"<",V.semver,K)&&(this.operator===">="||this.operator===">")&&(V.operator==="<="||V.operator==="<"),Ie=me(this.semver,">",V.semver,K)&&(this.operator==="<="||this.operator==="<")&&(V.operator===">="||V.operator===">");return $e||ye||De&&Se||Le||Ie},e.Range=fe,fe.prototype.format=function(){return this.range=this.set.map(function(V){return V.join(" ").trim()}).join("||").trim(),this.range},fe.prototype.toString=function(){return this.range},fe.prototype.parseRange=function(V){var K=this.loose;V=V.trim(),D("range",V,K);var x=K?v[H]:v[U];V=V.replace(x,we),D("hyphen replace",V),V=V.replace(v[T],"$1$2$3"),D("comparator trim",V,v[T]),V=(V=(V=V.replace(v[_],"$1~")).replace(v[ue],"$1^")).split(/\s+/).join(" ");var $e=K?v[q]:v[Q],ye=V.split(" ").map(function(De){return function(Se,Le){return D("comp",Se),Se=function(Ie,je){return Ie.trim().split(/\s+/).map(function(Ue){return function(Re,Ne){D("caret",Re,Ne);var ze=Ne?v[re]:v[ce];return Re.replace(ze,function(Ae,ve,Ee,Pe,Oe){var Fe;return D("caret",Re,Ae,ve,Ee,Pe,Oe),he(ve)?Fe="":he(Ee)?Fe=">="+ve+".0.0 <"+(+ve+1)+".0.0":he(Pe)?Fe=ve==="0"?">="+ve+"."+Ee+".0 <"+ve+"."+(+Ee+1)+".0":">="+ve+"."+Ee+".0 <"+(+ve+1)+".0.0":Oe?(D("replaceCaret pr",Oe),Oe.charAt(0)!=="-"&&(Oe="-"+Oe),Fe=ve==="0"?Ee==="0"?">="+ve+"."+Ee+"."+Pe+Oe+" <"+ve+"."+Ee+"."+(+Pe+1):">="+ve+"."+Ee+"."+Pe+Oe+" <"+ve+"."+(+Ee+1)+".0":">="+ve+"."+Ee+"."+Pe+Oe+" <"+(+ve+1)+".0.0"):(D("no pr"),Fe=ve==="0"?Ee==="0"?">="+ve+"."+Ee+"."+Pe+" <"+ve+"."+Ee+"."+(+Pe+1):">="+ve+"."+Ee+"."+Pe+" <"+ve+"."+(+Ee+1)+".0":">="+ve+"."+Ee+"."+Pe+" <"+(+ve+1)+".0.0"),D("caret return",Fe),Fe})}(Ue,je)}).join(" ")}(Se,Le),D("caret",Se),Se=function(Ie,je){return Ie.trim().split(/\s+/).map(function(Ue){return function(Re,Ne){var ze=Ne?v[oe]:v[ee];return Re.replace(ze,function(Ae,ve,Ee,Pe,Oe){var Fe;return D("tilde",Re,Ae,ve,Ee,Pe,Oe),he(ve)?Fe="":he(Ee)?Fe=">="+ve+".0.0 <"+(+ve+1)+".0.0":he(Pe)?Fe=">="+ve+"."+Ee+".0 <"+ve+"."+(+Ee+1)+".0":Oe?(D("replaceTilde pr",Oe),Oe.charAt(0)!=="-"&&(Oe="-"+Oe),Fe=">="+ve+"."+Ee+"."+Pe+Oe+" <"+ve+"."+(+Ee+1)+".0"):Fe=">="+ve+"."+Ee+"."+Pe+" <"+ve+"."+(+Ee+1)+".0",D("tilde return",Fe),Fe})}(Ue,je)}).join(" ")}(Se,Le),D("tildes",Se),Se=function(Ie,je){return D("replaceXRanges",Ie,je),Ie.split(/\s+/).map(function(Ue){return function(Re,Ne){Re=Re.trim();var ze=Ne?v[p]:v[b];return Re.replace(ze,function(Ae,ve,Ee,Pe,Oe,Fe){D("xRange",Re,Ae,ve,Ee,Pe,Oe,Fe);var qe=he(Ee),Me=qe||he(Pe),Te=Me||he(Oe);return ve==="="&&Te&&(ve=""),qe?Ae=ve===">"||ve==="<"?"<0.0.0":"*":ve&&Te?(Me&&(Pe=0),Te&&(Oe=0),ve===">"?(ve=">=",Me?(Ee=+Ee+1,Pe=0,Oe=0):Te&&(Pe=+Pe+1,Oe=0)):ve==="<="&&(ve="<",Me?Ee=+Ee+1:Pe=+Pe+1),Ae=ve+Ee+"."+Pe+"."+Oe):Me?Ae=">="+Ee+".0.0 <"+(+Ee+1)+".0.0":Te&&(Ae=">="+Ee+"."+Pe+".0 <"+Ee+"."+(+Pe+1)+".0"),D("xRange return",Ae),Ae})}(Ue,je)}).join(" ")}(Se,Le),D("xrange",Se),Se=function(Ie,je){return D("replaceStars",Ie,je),Ie.trim().replace(v[G],"")}(Se,Le),D("stars",Se),Se}(De,K)}).join(" ").split(/\s+/);return this.loose&&(ye=ye.filter(function(De){return!!De.match($e)})),ye=ye.map(function(De){return new de(De,K)})},fe.prototype.intersects=function(V,K){if(!(V instanceof fe))throw new TypeError("a Range is required");return this.set.some(function(x){return x.every(function($e){return V.set.some(function(ye){return ye.every(function(De){return $e.intersects(De,K)})})})})},e.toComparators=function(V,K){return new fe(V,K).set.map(function(x){return x.map(function($e){return $e.value}).join(" ").trim().split(" ")})},fe.prototype.test=function(V){if(!V)return!1;typeof V=="string"&&(V=new C(V,this.loose));for(var K=0;K<this.set.length;K++)if(be(this.set[K],V))return!0;return!1},e.satisfies=ke,e.maxSatisfying=function(V,K,x){var $e=null,ye=null;try{var De=new fe(K,x)}catch{return null}return V.forEach(function(Se){De.test(Se)&&($e&&ye.compare(Se)!==-1||(ye=new C($e=Se,x)))}),$e},e.minSatisfying=function(V,K,x){var $e=null,ye=null;try{var De=new fe(K,x)}catch{return null}return V.forEach(function(Se){De.test(Se)&&($e&&ye.compare(Se)!==1||(ye=new C($e=Se,x)))}),$e},e.validRange=function(V,K){try{return new fe(V,K).range||"*"}catch{return null}},e.ltr=function(V,K,x){return Ce(V,K,"<",x)},e.gtr=function(V,K,x){return Ce(V,K,">",x)},e.outside=Ce,e.prerelease=function(V,K){var x=Y(V,K);return x&&x.prerelease.length?x.prerelease:null},e.intersects=function(V,K,x){return V=new fe(V,x),K=new fe(K,x),V.intersects(K)},e.coerce=function(V){if(V instanceof C)return V;if(typeof V!="string")return null;var K=V.match(v[O]);return K==null?null:Y((K[1]||"0")+"."+(K[2]||"0")+"."+(K[3]||"0"))}}).call(this,L(1))},function(J,e){var L,N,D=J.exports={};function A(){throw new Error("setTimeout has not been defined")}function j(){throw new Error("clearTimeout has not been defined")}function v($){if(L===setTimeout)return setTimeout($,0);if((L===A||!L)&&setTimeout)return L=setTimeout,setTimeout($,0);try{return L($,0)}catch{try{return L.call(null,$,0)}catch{return L.call(this,$,0)}}}(function(){try{L=typeof setTimeout=="function"?setTimeout:A}catch{L=A}try{N=typeof clearTimeout=="function"?clearTimeout:j}catch{N=j}})();var h,c=[],E=!1,R=-1;function d(){E&&h&&(E=!1,h.length?c=h.concat(c):R=-1,c.length&&f())}function f(){if(!E){var $=v(d);E=!0;for(var u=c.length;u;){for(h=c,c=[];++R<u;)h&&h[R].run();R=-1,u=c.length}h=null,E=!1,function(m){if(N===clearTimeout)return clearTimeout(m);if((N===j||!N)&&clearTimeout)return N=clearTimeout,clearTimeout(m);try{N(m)}catch{try{return N.call(null,m)}catch{return N.call(this,m)}}}($)}}function S($,u){this.fun=$,this.array=u}function y(){}D.nextTick=function($){var u=new Array(arguments.length-1);if(arguments.length>1)for(var m=1;m<arguments.length;m++)u[m-1]=arguments[m];c.push(new S($,u)),c.length!==1||E||v(f)},S.prototype.run=function(){this.fun.apply(null,this.array)},D.title="browser",D.browser=!0,D.env={},D.argv=[],D.version="",D.versions={},D.on=y,D.addListener=y,D.once=y,D.off=y,D.removeListener=y,D.removeAllListeners=y,D.emit=y,D.prependListener=y,D.prependOnceListener=y,D.listeners=function($){return[]},D.binding=function($){throw new Error("process.binding is not supported")},D.cwd=function(){return"/"},D.chdir=function($){throw new Error("process.chdir is not supported")},D.umask=function(){return 0}}])}),define(te[73],ne([0,1]),function(J,e){"use strict";var L;Object.defineProperty(e,"__esModule",{value:!0}),e.$Er=void 0;class N{constructor(v,h,c){this.level=v,this.key=h,this.value=c,this.forward=[]}}const D=void 0;class A{constructor(v,h=2**16){this.comparator=v,this[L]="SkipList",this.d=0,this.f=0,this.c=Math.max(1,Math.log2(h)|0),this.e=new N(this.c,D,D)}get size(){return this.f}clear(){this.e=new N(this.c,D,D),this.f=0}has(v){return!!A.g(this,v,this.comparator)}get(v){return A.g(this,v,this.comparator)?.value}set(v,h){return A.h(this,v,h,this.comparator)&&(this.f+=1),this}delete(v){const h=A.k(this,v,this.comparator);return h&&(this.f-=1),h}forEach(v,h){let c=this.e.forward[0];for(;c;)v.call(h,c.value,c.key,this),c=c.forward[0]}[(L=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}*entries(){let v=this.e.forward[0];for(;v;)yield[v.key,v.value],v=v.forward[0]}*keys(){let v=this.e.forward[0];for(;v;)yield v.key,v=v.forward[0]}*values(){let v=this.e.forward[0];for(;v;)yield v.value,v=v.forward[0]}toString(){let v="[SkipList]:",h=this.e.forward[0];for(;h;)v+=`node(${h.key}, ${h.value}, lvl:${h.level})`,h=h.forward[0];return v}static g(v,h,c){let E=v.e;for(let R=v.d-1;R>=0;R--)for(;E.forward[R]&&c(E.forward[R].key,h)<0;)E=E.forward[R];if(E=E.forward[0],E&&c(E.key,h)===0)return E}static h(v,h,c,E){const R=[];let d=v.e;for(let f=v.d-1;f>=0;f--){for(;d.forward[f]&&E(d.forward[f].key,h)<0;)d=d.forward[f];R[f]=d}if(d=d.forward[0],d&&E(d.key,h)===0)return d.value=c,!1;{const f=A.j(v);if(f>v.d){for(let S=v.d;S<f;S++)R[S]=v.e;v.d=f}d=new N(f,h,c);for(let S=0;S<f;S++)d.forward[S]=R[S].forward[S],R[S].forward[S]=d;return!0}}static j(v,h=.5){let c=1;for(;Math.random()<h&&c<v.c;)c+=1;return c}static k(v,h,c){const E=[];let R=v.e;for(let d=v.d-1;d>=0;d--){for(;R.forward[d]&&c(R.forward[d].key,h)<0;)R=R.forward[d];E[d]=R}if(R=R.forward[0],!R||c(R.key,h)!==0)return!1;for(let d=0;d<v.d&&E[d].forward[d]===R;d++)E[d].forward[d]=R.forward[d];for(;v.d>0&&v.e.forward[v.d-1]===D;)v.d-=1;return!0}}e.$Er=A}),define(te[45],ne([0,1,9,2]),function(J,e,L,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ee=e.$de=e.$ce=e.$be=e.$ae=e.$_d=e.$$d=e.$0d=e.$9d=e.$8d=e.$7d=e.$6d=e.$5d=e.$4d=e.$3d=void 0;function D(w){const P=w;return P?typeof P.read=="function":!1}e.$3d=D;function A(w){const P=w;return P?[P.on,P.pause,P.resume,P.destroy].every(s=>typeof s=="function"):!1}e.$4d=A;function j(w){const P=w;return P?A(P.stream)&&Array.isArray(P.buffer)&&typeof P.ended=="boolean":!1}e.$5d=j;function v(w,P){return new h(w,P)}e.$6d=v;class h{constructor(P,s){this.e=P,this.f=s,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(P){if(!this.a.destroyed){if(this.a.flowing)this.g(P);else if(this.b.data.push(P),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(s=>this.d.push(s))}}error(P){this.a.destroyed||(this.a.flowing?this.h(P):this.b.error.push(P))}end(P){this.a.destroyed||(typeof P<"u"&&this.write(P),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(P){this.c.data.slice(0).forEach(s=>s(P))}h(P){this.c.error.length===0?(0,L.$Z)(P):this.c.error.slice(0).forEach(s=>s(P))}i(){this.c.end.slice(0).forEach(P=>P())}on(P,s){if(!this.a.destroyed)switch(P){case"data":this.c.data.push(s),this.resume();break;case"end":this.c.end.push(s),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(s),this.a.flowing&&this.k();break}}removeListener(P,s){if(this.a.destroyed)return;let o;switch(P){case"data":o=this.c.data;break;case"end":o=this.c.end;break;case"error":o=this.c.error;break}if(o){const t=o.indexOf(s);t>=0&&o.splice(t,1)}}j(){if(this.b.data.length>0){const P=this.e(this.b.data);this.g(P),this.b.data.length=0;const s=[...this.d];this.d.length=0,s.forEach(o=>o())}}k(){if(this.c.error.length>0){for(const P of this.b.error)this.h(P);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function c(w,P){const s=[];let o;for(;(o=w.read())!==null;)s.push(o);return P(s)}e.$7d=c;function E(w,P,s){const o=[];let t;for(;(t=w.read())!==null&&o.length<s;)o.push(t);return t===null&&o.length>0?P(o):{read:()=>{if(o.length>0)return o.shift();if(typeof t<"u"){const n=t;return t=void 0,n}return w.read()}}}e.$8d=E;function R(w,P){return new Promise((s,o)=>{const t=[];d(w,{onData:n=>{P&&t.push(n)},onError:n=>{P?o(n):s(void 0)},onEnd:()=>{s(P?P(t):void 0)}})})}e.$9d=R;function d(w,P,s){w.on("error",o=>{s?.isCancellationRequested||P.onError(o)}),w.on("end",()=>{s?.isCancellationRequested||P.onEnd()}),w.on("data",o=>{s?.isCancellationRequested||P.onData(o)})}e.$0d=d;function f(w,P){return new Promise((s,o)=>{const t=new N.$Qc,n=[],i=k=>{if(n.push(k),n.length>P)return t.dispose(),w.pause(),s({stream:w,buffer:n,ended:!1})},r=k=>(t.dispose(),o(k)),l=()=>(t.dispose(),s({stream:w,buffer:n,ended:!0}));t.add((0,N.$Pc)(()=>w.removeListener("error",r))),w.on("error",r),t.add((0,N.$Pc)(()=>w.removeListener("end",l))),w.on("end",l),t.add((0,N.$Pc)(()=>w.removeListener("data",i))),w.on("data",i)})}e.$$d=f;function S(w,P){const s=v(P);return s.end(w),s}e.$_d=S;function y(){const w=v(()=>{throw new Error("not supported")});return w.end(),w}e.$ae=y;function $(w){let P=!1;return{read:()=>P?null:(P=!0,w)}}e.$be=$;function u(w,P,s){const o=v(s);return d(w,{onData:t=>o.write(P.data(t)),onError:t=>o.error(P.error?P.error(t):t),onEnd:()=>o.end()}),o}e.$ce=u;function m(w,P,s){let o=!1;return{read:()=>{const t=P.read();return o?t:(o=!0,t!==null?s([w,t]):w)}}}e.$de=m;function I(w,P,s){let o=!1;const t=v(s);return d(P,{onData:n=>o?t.write(n):(o=!0,t.write(s([w,n]))),onError:n=>t.error(n),onEnd:()=>{o||(o=!0,t.write(w)),t.end()}}),t}e.$ee=I}),define(te[14],ne([0,1,164,45]),function(J,e,L,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ze=e.$ye=e.$xe=e.$we=e.$ve=e.$ue=e.$te=e.$se=e.$re=e.$qe=e.$pe=e.$oe=e.$ne=e.$me=e.$le=e.$ke=e.$je=e.$ie=e.$he=e.$ge=e.$fe=void 0;const D=typeof Buffer<"u",A=new L.$U(()=>new Uint8Array(256));let j,v;class h{static alloc(O){return D?new h(Buffer.allocUnsafe(O)):new h(new Uint8Array(O))}static wrap(O){return D&&!Buffer.isBuffer(O)&&(O=Buffer.from(O.buffer,O.byteOffset,O.byteLength)),new h(O)}static fromString(O,B){return!(B?.dontUseNodeBuffer||!1)&&D?new h(Buffer.from(O)):(j||(j=new TextEncoder),new h(j.encode(O)))}static fromByteArray(O){const B=h.alloc(O.length);for(let _=0,ee=O.length;_<ee;_++)B.buffer[_]=O[_];return B}static concat(O,B){if(typeof B>"u"){B=0;for(let oe=0,se=O.length;oe<se;oe++)B+=O[oe].byteLength}const _=h.alloc(B);let ee=0;for(let oe=0,se=O.length;oe<se;oe++){const ue=O[oe];_.set(ue,ee),ee+=ue.byteLength}return _}constructor(O){this.buffer=O,this.byteLength=this.buffer.byteLength}clone(){const O=h.alloc(this.byteLength);return O.set(this),O}toString(){return D?this.buffer.toString():(v||(v=new TextDecoder),v.decode(this.buffer))}slice(O,B){return new h(this.buffer.subarray(O,B))}set(O,B){if(O instanceof h)this.buffer.set(O.buffer,B);else if(O instanceof Uint8Array)this.buffer.set(O,B);else if(O instanceof ArrayBuffer)this.buffer.set(new Uint8Array(O),B);else if(ArrayBuffer.isView(O))this.buffer.set(new Uint8Array(O.buffer,O.byteOffset,O.byteLength),B);else throw new Error("Unknown argument 'array'")}readUInt32BE(O){return d(this.buffer,O)}writeUInt32BE(O,B){f(this.buffer,O,B)}readUInt32LE(O){return S(this.buffer,O)}writeUInt32LE(O,B){y(this.buffer,O,B)}readUInt8(O){return $(this.buffer,O)}writeUInt8(O,B){u(this.buffer,O,B)}indexOf(O,B=0){return c(this.buffer,O instanceof h?O.buffer:O,B)}}e.$fe=h;function c(p,O,B=0){const _=O.byteLength,ee=p.byteLength;if(_===0)return 0;if(_===1)return p.indexOf(O[0]);if(_>ee-B)return-1;const oe=A.value;oe.fill(O.length);for(let re=0;re<O.length;re++)oe[O[re]]=O.length-re-1;let se=B+O.length-1,ue=se,ce=-1;for(;se<ee;)if(p[se]===O[ue]){if(ue===0){ce=se;break}se--,ue--}else se+=Math.max(O.length-ue,oe[p[se]]),ue=O.length-1;return ce}e.$ge=c;function E(p,O){return p[O+0]<<0>>>0|p[O+1]<<8>>>0}e.$he=E;function R(p,O,B){p[B+0]=O&255,O=O>>>8,p[B+1]=O&255}e.$ie=R;function d(p,O){return p[O]*2**24+p[O+1]*2**16+p[O+2]*2**8+p[O+3]}e.$je=d;function f(p,O,B){p[B+3]=O,O=O>>>8,p[B+2]=O,O=O>>>8,p[B+1]=O,O=O>>>8,p[B]=O}e.$ke=f;function S(p,O){return p[O+0]<<0>>>0|p[O+1]<<8>>>0|p[O+2]<<16>>>0|p[O+3]<<24>>>0}e.$le=S;function y(p,O,B){p[B+0]=O&255,O=O>>>8,p[B+1]=O&255,O=O>>>8,p[B+2]=O&255,O=O>>>8,p[B+3]=O&255}e.$me=y;function $(p,O){return p[O]}e.$ne=$;function u(p,O,B){p[B]=O}e.$oe=u;function m(p){return N.$7d(p,O=>h.concat(O))}e.$pe=m;function I(p){return N.$be(p)}e.$qe=I;function w(p){return N.$9d(p,O=>h.concat(O))}e.$re=w;async function P(p){return p.ended?h.concat(p.buffer):h.concat([...p.buffer,await w(p.stream)])}e.$se=P;function s(p){return N.$_d(p,O=>h.concat(O))}e.$te=s;function o(p){return N.$ce(p,{data:O=>typeof O=="string"?h.fromString(O):h.wrap(O)},O=>h.concat(O))}e.$ue=o;function t(p){return N.$6d(O=>h.concat(O),p)}e.$ve=t;function n(p,O){return N.$de(p,O,B=>h.concat(B))}e.$we=n;function i(p,O){return N.$ee(p,O,B=>h.concat(B))}e.$xe=i;function r(p){let O=0,B=0,_=0;const ee=new Uint8Array(Math.floor(p.length/4*3)),oe=ue=>{switch(B){case 3:ee[_++]=O|ue,B=0;break;case 2:ee[_++]=O|ue>>>2,O=ue<<6,B=3;break;case 1:ee[_++]=O|ue>>>4,O=ue<<4,B=2;break;default:O=ue<<2,B=1}};for(let ue=0;ue<p.length;ue++){const ce=p.charCodeAt(ue);if(ce>=65&&ce<=90)oe(ce-65);else if(ce>=97&&ce<=122)oe(ce-97+26);else if(ce>=48&&ce<=57)oe(ce-48+52);else if(ce===43||ce===45)oe(62);else if(ce===47||ce===95)oe(63);else{if(ce===61)break;throw new SyntaxError(`Unexpected base64 character ${p[ue]}`)}}const se=_;for(;B>0;)oe(0);return h.wrap(ee).slice(0,se)}e.$ye=r;const l="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",k="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function b({buffer:p},O=!0,B=!1){const _=B?k:l;let ee="";const oe=p.byteLength%3;let se=0;for(;se<p.byteLength-oe;se+=3){const ue=p[se+0],ce=p[se+1],re=p[se+2];ee+=_[ue>>>2],ee+=_[(ue<<4|ce>>>4)&63],ee+=_[(ce<<2|re>>>6)&63],ee+=_[re&63]}if(oe===1){const ue=p[se+0];ee+=_[ue>>>2],ee+=_[ue<<4&63],O&&(ee+="==")}else if(oe===2){const ue=p[se+0],ce=p[se+1];ee+=_[ue>>>2],ee+=_[(ue<<4|ce>>>4)&63],ee+=_[ce<<2&63],O&&(ee+="=")}return ee}e.$ze=b}),define(te[41],ne([0,1,29]),function(J,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pi=e.$Oi=e.$Ni=e.$Mi=e.$Li=e.$Ki=e.$Ji=void 0;function N(u){return D(u,0)}e.$Ji=N;function D(u,m){switch(typeof u){case"object":return u===null?A(349,m):Array.isArray(u)?h(u,m):c(u,m);case"string":return v(u,m);case"boolean":return j(u,m);case"number":return A(u,m);case"undefined":return A(937,m);default:return A(617,m)}}e.$Ki=D;function A(u,m){return(m<<5)-m+u|0}e.$Li=A;function j(u,m){return A(u?433:863,m)}function v(u,m){m=A(149417,m);for(let I=0,w=u.length;I<w;I++)m=A(u.charCodeAt(I),m);return m}e.$Mi=v;function h(u,m){return m=A(104579,m),u.reduce((I,w)=>D(w,I),m)}function c(u,m){return m=A(181387,m),Object.keys(u).sort().reduce((I,w)=>(I=v(w,I),D(u[w],I)),m)}class E{constructor(){this.g=0}get value(){return this.g}hash(m){return this.g=D(m,this.g),this.g}}e.$Ni=E;var R;(function(u){u[u.BLOCK_SIZE=64]="BLOCK_SIZE",u[u.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(R||(R={}));function d(u,m,I=32){const w=I-m,P=~((1<<w)-1);return(u<<m|(P&u)>>>w)>>>0}function f(u,m=0,I=u.byteLength,w=0){for(let P=0;P<I;P++)u[m+P]=w}function S(u,m,I="0"){for(;u.length<m;)u=I+u;return u}function y(u,m=32){return u instanceof ArrayBuffer?Array.from(new Uint8Array(u)).map(I=>I.toString(16).padStart(2,"0")).join(""):S((u>>>0).toString(16),m/4)}e.$Oi=y;class ${static{this.g=new DataView(new ArrayBuffer(320))}constructor(){this.h=1732584193,this.l=4023233417,this.m=2562383102,this.n=271733878,this.o=3285377520,this.p=new Uint8Array(64+3),this.q=new DataView(this.p.buffer),this.r=0,this.t=0,this.u=0,this.v=!1}update(m){const I=m.length;if(I===0)return;const w=this.p;let P=this.r,s=this.u,o,t;for(s!==0?(o=s,t=-1,s=0):(o=m.charCodeAt(0),t=0);;){let n=o;if(L.$0e(o))if(t+1<I){const i=m.charCodeAt(t+1);L.$$e(i)?(t++,n=L.$_e(o,i)):n=65533}else{s=o;break}else L.$$e(o)&&(n=65533);if(P=this.w(w,P,n),t++,t<I)o=m.charCodeAt(t);else break}this.r=P,this.u=s}w(m,I,w){return w<128?m[I++]=w:w<2048?(m[I++]=192|(w&1984)>>>6,m[I++]=128|(w&63)>>>0):w<65536?(m[I++]=224|(w&61440)>>>12,m[I++]=128|(w&4032)>>>6,m[I++]=128|(w&63)>>>0):(m[I++]=240|(w&1835008)>>>18,m[I++]=128|(w&258048)>>>12,m[I++]=128|(w&4032)>>>6,m[I++]=128|(w&63)>>>0),I>=64&&(this.y(),I-=64,this.t+=64,m[0]=m[64+0],m[1]=m[64+1],m[2]=m[64+2]),I}digest(){return this.v||(this.v=!0,this.u&&(this.u=0,this.r=this.w(this.p,this.r,65533)),this.t+=this.r,this.x()),y(this.h)+y(this.l)+y(this.m)+y(this.n)+y(this.o)}x(){this.p[this.r++]=128,f(this.p,this.r),this.r>56&&(this.y(),f(this.p));const m=8*this.t;this.q.setUint32(56,Math.floor(m/4294967296),!1),this.q.setUint32(60,m%4294967296,!1),this.y()}y(){const m=$.g,I=this.q;for(let l=0;l<64;l+=4)m.setUint32(l,I.getUint32(l,!1),!1);for(let l=64;l<320;l+=4)m.setUint32(l,d(m.getUint32(l-12,!1)^m.getUint32(l-32,!1)^m.getUint32(l-56,!1)^m.getUint32(l-64,!1),1),!1);let w=this.h,P=this.l,s=this.m,o=this.n,t=this.o,n,i,r;for(let l=0;l<80;l++)l<20?(n=P&s|~P&o,i=1518500249):l<40?(n=P^s^o,i=1859775393):l<60?(n=P&s|P&o|s&o,i=2400959708):(n=P^s^o,i=3395469782),r=d(w,5)+n+t+i+m.getUint32(l*4,!1)&4294967295,t=o,o=s,s=d(P,30),P=w,w=r;this.h=this.h+w&4294967295,this.l=this.l+P&4294967295,this.m=this.m+s&4294967295,this.n=this.n+o&4294967295,this.o=this.o+t&4294967295}}e.$Pi=$}),define(te[54],ne([0,1,29]),function(J,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var N;(function(D){D[D.Ignore=0]="Ignore",D[D.Info=1]="Info",D[D.Warning=2]="Warning",D[D.Error=3]="Error"})(N||(N={})),function(D){const A="error",j="warning",v="warn",h="info",c="ignore";function E(d){return d?L.$6e(A,d)?D.Error:L.$6e(j,d)||L.$6e(v,d)?D.Warning:L.$6e(h,d)?D.Info:D.Ignore:D.Ignore}D.fromValue=E;function R(d){switch(d){case D.Error:return A;case D.Warning:return j;case D.Info:return h;default:return c}}D.toString=R}(N||(N={})),e.default=N}),define(te[30],ne([0,1,3]),function(J,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ln=e.$kn=e.$jn=e.$in=e.$hn=e.$gn=e.$fn=e.$en=e.$dn=e.$cn=e.$bn=e.$an=void 0;function N(u){if(!u||typeof u!="object"||u instanceof RegExp)return u;const m=Array.isArray(u)?[]:{};return Object.entries(u).forEach(([I,w])=>{m[I]=w&&typeof w=="object"?N(w):w}),m}e.$an=N;function D(u){if(!u||typeof u!="object")return u;const m=[u];for(;m.length>0;){const I=m.shift();Object.freeze(I);for(const w in I)if(A.call(I,w)){const P=I[w];typeof P=="object"&&!Object.isFrozen(P)&&!(0,L.$Ff)(P)&&m.push(P)}}return u}e.$bn=D;const A=Object.prototype.hasOwnProperty;function j(u,m){return v(u,m,new Set)}e.$cn=j;function v(u,m,I){if((0,L.$Lf)(u))return u;const w=m(u);if(typeof w<"u")return w;if(Array.isArray(u)){const P=[];for(const s of u)P.push(v(s,m,I));return P}if((0,L.$Ef)(u)){if(I.has(u))throw new Error("Cannot clone recursive data-structure");I.add(u);const P={};for(const s in u)A.call(u,s)&&(P[s]=v(u[s],m,I));return I.delete(u),P}return u}function h(u,m,I=!0){return(0,L.$Ef)(u)?((0,L.$Ef)(m)&&Object.keys(m).forEach(w=>{w in u?I&&((0,L.$Ef)(u[w])&&(0,L.$Ef)(m[w])?h(u[w],m[w],I):u[w]=m[w]):u[w]=m[w]}),u):m}e.$dn=h;function c(u,m){if(u===m)return!0;if(u==null||m===null||m===void 0||typeof u!=typeof m||typeof u!="object"||Array.isArray(u)!==Array.isArray(m))return!1;let I,w;if(Array.isArray(u)){if(u.length!==m.length)return!1;for(I=0;I<u.length;I++)if(!c(u[I],m[I]))return!1}else{const P=[];for(w in u)P.push(w);P.sort();const s=[];for(w in m)s.push(w);if(s.sort(),!c(P,s))return!1;for(I=0;I<P.length;I++)if(!c(u[P[I]],m[P[I]]))return!1}return!0}e.$en=c;function E(u){const m=new Set;return JSON.stringify(u,(I,w)=>{if((0,L.$Ef)(w)||Array.isArray(w)){if(m.has(w))return"[Circular]";m.add(w)}return w})}e.$fn=E;function R(u,m){const I=Object.create(null);return!u||!m||Object.keys(m).forEach(P=>{const s=u[P],o=m[P];c(s,o)||(I[P]=o)}),I}e.$gn=R;function d(u,m){const I=m.toLowerCase(),w=Object.keys(u).find(P=>P.toLowerCase()===I);return w?u[w]:u[m]}e.$hn=d;function f(u,m){const I=Object.create(null);for(const[w,P]of Object.entries(u))m(w,P)&&(I[w]=P);return I}e.$in=f;function S(u){let m=[];for(;Object.prototype!==u;)m=m.concat(Object.getOwnPropertyNames(u)),u=Object.getPrototypeOf(u);return m}e.$jn=S;function y(u){const m=[];for(const I of S(u))typeof u[I]=="function"&&m.push(I);return m}e.$kn=y;function $(u,m){const I=P=>function(){const s=Array.prototype.slice.call(arguments,0);return m(P,s)},w={};for(const P of u)w[P]=I(P);return w}e.$ln=$}),define(te[28],ne([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ig=e.$hg=void 0;const L=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function N(D){return L.test(D)}e.$hg=N,e.$ig=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let D;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?D=crypto.getRandomValues.bind(crypto):D=function(v){for(let h=0;h<v.length;h++)v[h]=Math.floor(Math.random()*256);return v};const A=new Uint8Array(16),j=[];for(let v=0;v<256;v++)j.push(v.toString(16).padStart(2,"0"));return function(){D(A),A[6]=A[6]&15|64,A[8]=A[8]&63|128;let h=0,c="";return c+=j[A[h++]],c+=j[A[h++]],c+=j[A[h++]],c+=j[A[h++]],c+="-",c+=j[A[h++]],c+=j[A[h++]],c+="-",c+=j[A[h++]],c+=j[A[h++]],c+="-",c+=j[A[h++]],c+=j[A[h++]],c+="-",c+=j[A[h++]],c+=j[A[h++]],c+=j[A[h++]],c+=j[A[h++]],c+=j[A[h++]],c+=j[A[h++]],c}}()}),define(te[74],ne([0,1,33]),function(J,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wm=void 0;const N=new Set(["00:00:00:00:00:00","ff:ff:ff:ff:ff:ff","ac:de:48:00:11:22"]);function D(j){const v=j.replace(/\-/g,":").toLowerCase();return!N.has(v)}function A(){const j=(0,L.networkInterfaces)();for(const v in j){const h=j[v];if(h){for(const{mac:c}of h)if(D(c))return c}}throw new Error("Unable to retrieve mac address (unexpected format)")}e.$Wm=A}),define(te[75],ne([7,5]),function(J,e){return J.create("vs/base/common/date",e)}),define(te[76],ne([0,1,75]),function(J,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$km=e.$jm=void 0;const N=60,D=N*60,A=D*24,j=A*7,v=A*30,h=A*365;function c(R,d,f,S){typeof R!="number"&&(R=R.getTime());const y=Math.round((new Date().getTime()-R)/1e3);if(y<-30)return(0,L.localize)(0,null,c(new Date().getTime()+y*1e3,!1));if(!S&&y<30)return(0,L.localize)(1,null);let $;return y<N?($=y,d?$===1?f?(0,L.localize)(2,null,$):(0,L.localize)(3,null,$):f?(0,L.localize)(4,null,$):(0,L.localize)(5,null,$):$===1?f?(0,L.localize)(6,null,$):(0,L.localize)(7,null,$):f?(0,L.localize)(8,null,$):(0,L.localize)(9,null,$)):y<D?($=Math.floor(y/N),d?$===1?f?(0,L.localize)(10,null,$):(0,L.localize)(11,null,$):f?(0,L.localize)(12,null,$):(0,L.localize)(13,null,$):$===1?f?(0,L.localize)(14,null,$):(0,L.localize)(15,null,$):f?(0,L.localize)(16,null,$):(0,L.localize)(17,null,$)):y<A?($=Math.floor(y/D),d?$===1?f?(0,L.localize)(18,null,$):(0,L.localize)(19,null,$):f?(0,L.localize)(20,null,$):(0,L.localize)(21,null,$):$===1?f?(0,L.localize)(22,null,$):(0,L.localize)(23,null,$):f?(0,L.localize)(24,null,$):(0,L.localize)(25,null,$)):y<j?($=Math.floor(y/A),d?$===1?(0,L.localize)(26,null,$):(0,L.localize)(27,null,$):$===1?(0,L.localize)(28,null,$):(0,L.localize)(29,null,$)):y<v?($=Math.floor(y/j),d?$===1?f?(0,L.localize)(30,null,$):(0,L.localize)(31,null,$):f?(0,L.localize)(32,null,$):(0,L.localize)(33,null,$):$===1?f?(0,L.localize)(34,null,$):(0,L.localize)(35,null,$):f?(0,L.localize)(36,null,$):(0,L.localize)(37,null,$)):y<h?($=Math.floor(y/v),d?$===1?f?(0,L.localize)(38,null,$):(0,L.localize)(39,null,$):f?(0,L.localize)(40,null,$):(0,L.localize)(41,null,$):$===1?f?(0,L.localize)(42,null,$):(0,L.localize)(43,null,$):f?(0,L.localize)(44,null,$):(0,L.localize)(45,null,$)):($=Math.floor(y/h),d?$===1?f?(0,L.localize)(46,null,$):(0,L.localize)(47,null,$):f?(0,L.localize)(48,null,$):(0,L.localize)(49,null,$):$===1?f?(0,L.localize)(50,null,$):(0,L.localize)(51,null,$):f?(0,L.localize)(52,null,$):(0,L.localize)(53,null,$))}e.$jm=c;function E(R){return R.getFullYear()+"-"+String(R.getMonth()+1).padStart(2,"0")+"-"+String(R.getDate()).padStart(2,"0")+"T"+String(R.getHours()).padStart(2,"0")+":"+String(R.getMinutes()).padStart(2,"0")+":"+String(R.getSeconds()).padStart(2,"0")+"."+(R.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.$km=E}),define(te[77],ne([7,5]),function(J,e){return J.create("vs/base/common/errorMessage",e)}),define(te[34],ne([0,1,19,3,77]),function(J,e,L,N,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ii=e.$Hi=e.$Gi=void 0;function A(R,d){return d&&(R.stack||R.stacktrace)?D.localize(0,null,v(R),j(R.stack)||j(R.stacktrace)):v(R)}function j(R){return Array.isArray(R)?R.join(`
`):R}function v(R){return R.code==="ERR_UNC_HOST_NOT_ALLOWED"?`${R.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`:typeof R.code=="string"&&typeof R.errno=="number"&&typeof R.syscall=="string"?D.localize(1,null,R.message):R.message||D.localize(2,null)}function h(R=null,d=!1){if(!R)return D.localize(3,null);if(Array.isArray(R)){const f=L.$Gb(R),S=h(f[0],d);return f.length>1?D.localize(4,null,S,f.length):S}if(N.$Cf(R))return R;if(R.detail){const f=R.detail;if(f.error)return A(f.error,d);if(f.exception)return A(f.exception,d)}return R.stack?A(R,d):R.message?R.message:D.localize(5,null)}e.$Gi=h;function c(R){const d=R;return d instanceof Error&&Array.isArray(d.actions)}e.$Hi=c;function E(R,d){let f;return typeof R=="string"?f=new Error(R):f=R,f.actions=d,f}e.$Ii=E}),define(te[78],ne([7,5]),function(J,e){return J.create("vs/base/common/jsonErrorMessages",e)}),define(te[79],ne([0,1,78]),function(J,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Cp=void 0;function N(D){switch(D){case 1:return(0,L.localize)(0,null);case 2:return(0,L.localize)(1,null);case 3:return(0,L.localize)(2,null);case 4:return(0,L.localize)(3,null);case 5:return(0,L.localize)(4,null);case 6:return(0,L.localize)(5,null);case 7:return(0,L.localize)(6,null);case 8:return(0,L.localize)(7,null);case 9:return(0,L.localize)(8,null);default:return""}}e.$Cp=N}),define(te[55],ne([0,1,13]),function(J,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gl=e.$Fl=e.TerminateResponseCode=e.Source=void 0;var N;(function(v){v[v.stdout=0]="stdout",v[v.stderr=1]="stderr"})(N||(e.Source=N={}));var D;(function(v){v[v.Success=0]="Success",v[v.Unknown=1]="Unknown",v[v.AccessDenied=2]="AccessDenied",v[v.ProcessNotFound=3]="ProcessNotFound"})(D||(e.TerminateResponseCode=D={}));function A(v,...h){const c=h.reduce((d,f)=>(d[f]=!0,d),{}),E=[/^ELECTRON_.+$/,/^VSCODE_(?!(PORTABLE|SHELL_LOGIN|ENV_REPLACE|ENV_APPEND|ENV_PREPEND)).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(v).filter(d=>!c[d]).forEach(d=>{for(let f=0;f<E.length;f++)if(d.search(E[f])!==-1){delete v[d];break}})}e.$Fl=A;function j(v){v&&(delete v.DEBUG,L.$j&&delete v.DYLD_LIBRARY_PATH,L.$k&&delete v.LD_PRELOAD)}e.$Gl=j}),define(te[80],ne([0,1,11]),function(J,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.log=e.$6p=e.$5p=e.$4p=void 0;function N(c){const E=c;return E&&typeof E.type=="string"&&typeof E.severity=="string"}e.$4p=N;function D(c){const E=[];let R;try{const d=JSON.parse(c.arguments),f=d[d.length-1];f&&f.__$stack&&(d.pop(),R=f.__$stack),E.push(...d)}catch{E.push("Unable to log remote console arguments",c.arguments)}return{args:E,stack:R}}e.$5p=D;function A(c){if(typeof c!="string")return A(D(c).stack);const E=c;if(E){const R=j(E),d=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(R||"");if(d&&d.length===4)return{uri:L.URI.file(d[1]),line:Number(d[2]),column:Number(d[3])}}}e.$6p=A;function j(c){if(!c)return c;const E=c.indexOf(`
`);return E===-1?c:c.substring(0,E)}function v(c,E){const{args:R,stack:d}=D(c),f=typeof R[0]=="string"&&R.length===1;let S=j(d);S&&(S=`(${S.trim()})`);let y=[];if(typeof R[0]=="string"?S&&f?y=[`%c[${E}] %c${R[0]} %c${S}`,h("blue"),h(""),h("grey")]:y=[`%c[${E}] %c${R[0]}`,h("blue"),h(""),...R.slice(1)]:y=[`%c[${E}]%`,h("blue"),...R],S&&!f&&y.push(S),typeof console[c.severity]!="function")throw new Error("Unknown console method");console[c.severity].apply(console,y)}e.log=v;function h(c){return`color: ${c}`}}),define(te[46],ne([0,1,14,11]),function(J,e,L,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sh=e.$rh=e.$qh=void 0;function D(h){return JSON.stringify(h,j)}e.$qh=D;function A(h){let c=JSON.parse(h);return c=v(c),c}e.$rh=A;function j(h,c){return c instanceof RegExp?{$mid:2,source:c.source,flags:c.flags}:c}function v(h,c=0){if(!h||c>200)return h;if(typeof h=="object"){switch(h.$mid){case 1:return N.URI.revive(h);case 2:return new RegExp(h.source,h.flags);case 17:return new Date(h.source)}if(h instanceof L.$fe||h instanceof Uint8Array)return h;if(Array.isArray(h))for(let E=0;E<h.length;++E)h[E]=v(h[E],c+1);else for(const E in h)Object.hasOwnProperty.call(h,E)&&(h[E]=v(h[E],c+1))}return h}e.$sh=v}),define(te[81],ne([0,1,70,15,13,11]),function(J,e,L,N,D,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$NC=void 0;class j{constructor(d,f,S){this.id=d,this.dependencies=f,this.callback=S}}class v{static{this.INSTANCE=new v}constructor(){this.a=typeof self=="object"&&self.constructor&&self.constructor.name==="DedicatedWorkerGlobalScope",this.b=typeof document=="object",this.c=[],this.d=!1}g(){this.d||(this.d=!0,globalThis.define=(d,f,S)=>{typeof d!="string"&&(S=f,f=d,d=null),(typeof f!="object"||!Array.isArray(f))&&(S=f,f=null),this.c.push(new j(d,f,S))},globalThis.define.amd=!0,this.b?this.f=window.trustedTypes?.createPolicy("amdLoader",{createScriptURL(d){if(d.startsWith(window.location.origin)||d.startsWith("vscode-file://vscode-app"))return d;throw new Error(`[trusted_script_src] Invalid script url: ${d}`)}}):this.a&&(this.f=globalThis.trustedTypes?.createPolicy("amdLoader",{createScriptURL(d){return d}})))}async load(d){this.g();const f=await(this.a?this.i(d):this.b?this.h(d):this.j(d));if(!f)throw new Error(`Did not receive a define call from script ${d}`);if(Array.isArray(f.dependencies)&&f.dependencies.length>0)throw new Error(`Cannot resolve dependencies for script ${d}. The dependencies are: ${f.dependencies.join(", ")}`);return typeof f.callback=="function"?f.callback([]):f.callback}h(d){return new Promise((f,S)=>{const y=document.createElement("script");y.setAttribute("async","async"),y.setAttribute("type","text/javascript");const $=()=>{y.removeEventListener("load",u),y.removeEventListener("error",m)},u=I=>{$(),f(this.c.pop())},m=I=>{$(),S(I)};y.addEventListener("load",u),y.addEventListener("error",m),this.f&&(d=this.f.createScriptURL(d)),y.setAttribute("src",d),window.document.getElementsByTagName("head")[0].appendChild(y)})}i(d){return new Promise((f,S)=>{try{this.f&&(d=this.f.createScriptURL(d)),importScripts(d),f(this.c.pop())}catch(y){S(y)}})}async j(d){try{const f=globalThis._VSCODE_NODE_MODULES.fs,S=globalThis._VSCODE_NODE_MODULES.vm,y=globalThis._VSCODE_NODE_MODULES.module,$=A.URI.parse(d).fsPath,u=f.readFileSync($).toString(),m=y.wrap(u.replace(/^#!.*/,""));return new S.Script(m).runInThisContext().apply(),this.c.pop()}catch(f){throw f}}}const h=new Map;let c={};typeof globalThis.require=="object"&&(c=globalThis.require.paths??{});async function E(R,d,f){if(L.$S){f===void 0&&(f=!!(globalThis._VSCODE_PRODUCT_JSON??globalThis.vscode?.context?.configuration()?.product)?.commit),c[R]&&(R=c[R]);const S=`${R}/${d}`;if(h.has(S))return h.get(S);let y;if(/^\w[\w\d+.-]*:\/\//.test(S))y=S;else{const I=`${f&&!D.$o?N.$dg:N.$cg}/${S}`;y=N.$gg.asBrowserUri(I).toString(!0)}const $=v.INSTANCE.load(y);return h.set(S,$),$}else return await new Promise((S,y)=>{J([R],S,y)})}e.$NC=E}),define(te[82],ne([0,1,33,47,28,74,13]),function(J,e,L,N,D,A,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zm=e.$Ym=e.$Xm=void 0,e.$Xm=new class{c(d){return this.a||(this.a=N.$2h.forStrings(),this.a.set("00-50-56",!0),this.a.set("00-0C-29",!0),this.a.set("00-05-69",!0),this.a.set("00-03-FF",!0),this.a.set("00-1C-42",!0),this.a.set("00-16-3E",!0),this.a.set("08-00-27",!0),this.a.set("00:50:56",!0),this.a.set("00:0C:29",!0),this.a.set("00:05:69",!0),this.a.set("00:03:FF",!0),this.a.set("00:1C:42",!0),this.a.set("00:16:3E",!0),this.a.set("08:00:27",!0)),!!this.a.findSubstr(d)}value(){if(this.b===void 0){let d=0,f=0;const S=(0,L.networkInterfaces)();for(const y in S){const $=S[y];if($)for(const{mac:u,internal:m}of $)m||(f+=1,this.c(u.toUpperCase())&&(d+=1))}this.b=f>0?d/f:0}return this.b}};let v;async function h(d){return v||(v=(async()=>await c(d)||D.$ig())()),v}e.$Ym=h;async function c(d){try{const f=await new Promise((y,$)=>{J(["crypto"],y,$)}),S=(0,A.$Wm)();return f.createHash("sha256").update(S,"utf8").digest("hex")}catch(f){d(f);return}}const E="Software\\Microsoft\\SQMClient";async function R(d){if(j.$i){const f=await new Promise((S,y)=>{J(["@vscode/windows-registry"],S,y)});try{return f.GetStringRegKey("HKEY_LOCAL_MACHINE",E,"MachineId")||""}catch(S){return d(S),""}}return""}e.$Zm=R}),define(te[83],ne([0,1,33,16,24]),function(J,e,L,N,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$El=e.$Dl=void 0;const A=/^\d+$/,j=/^Microsoft.PowerShell_.*/,v=/^Microsoft.PowerShellPreview_.*/;var h;(function(w){w[w.x64=0]="x64",w[w.x86=1]="x86",w[w.ARM=2]="ARM"})(h||(h={}));let c;switch(process.arch){case"ia32":c=1;break;case"arm":case"arm64":c=2;break;default:c=0;break}let E;process.env.PROCESSOR_ARCHITEW6432?E=process.env.PROCESSOR_ARCHITEW6432==="ARM64"?2:0:process.env.PROCESSOR_ARCHITECTURE==="ARM64"?E=2:process.env.PROCESSOR_ARCHITECTURE==="X86"?E=1:E=0;class R{constructor(P,s,o){this.exePath=P,this.displayName=s,this.a=o}async exists(){return this.a===void 0&&(this.a=await D.SymlinkSupport.existsFile(this.exePath)),this.a}}function d({useAlternateBitness:w=!1}={}){return w?c===0?process.env["ProgramFiles(x86)"]||null:E===0&&process.env.ProgramW6432||null:process.env.ProgramFiles||null}async function f({useAlternateBitness:w=!1,findPreview:P=!1}={}){const s=d({useAlternateBitness:w});if(!s)return null;const o=N.$ic(s,"PowerShell");if(!await D.SymlinkSupport.existsDirectory(o))return null;let t=-1,n=null;for(const l of await D.Promises.readdir(o)){let k=-1;if(P){const p=l.indexOf("-");if(p<0)continue;const O=l.substring(0,p);if(!A.test(O)||l.substring(p+1)!=="preview")continue;k=parseInt(O,10)}else{if(!A.test(l))continue;k=parseInt(l,10)}if(k<=t)continue;const b=N.$ic(o,l,"pwsh.exe");await D.SymlinkSupport.existsFile(b)&&(n=b,t=k)}if(!n)return null;const i=s.includes("x86")?" (x86)":"",r=P?" Preview":"";return new R(n,`PowerShell${r}${i}`,!0)}async function S({findPreview:w}={}){if(!process.env.LOCALAPPDATA)return null;const P=N.$ic(process.env.LOCALAPPDATA,"Microsoft","WindowsApps");if(!await D.SymlinkSupport.existsDirectory(P))return null;const{pwshMsixDirRegex:s,pwshMsixName:o}=w?{pwshMsixDirRegex:v,pwshMsixName:"PowerShell Preview (Store)"}:{pwshMsixDirRegex:j,pwshMsixName:"PowerShell (Store)"};for(const t of await D.Promises.readdir(P))if(s.test(t)){const n=N.$ic(P,t,"pwsh.exe");return new R(n,o)}return null}function y(){const w=N.$ic(L.homedir(),".dotnet","tools","pwsh.exe");return new R(w,".NET Core PowerShell Global Tool")}function $(){const w=N.$ic(process.env.windir,c===1&&E!==1?"SysNative":"System32","WindowsPowerShell","v1.0","powershell.exe");return new R(w,"Windows PowerShell",!0)}async function*u(){let w=await f();w&&(yield w),w=await f({useAlternateBitness:!0}),w&&(yield w),w=await S(),w&&(yield w),w=y(),w&&(yield w),w=await f({findPreview:!0}),w&&(yield w),w=await S({findPreview:!0}),w&&(yield w),w=await f({useAlternateBitness:!0,findPreview:!0}),w&&(yield w),w=$(),w&&(yield w)}async function*m(){for await(const w of u())await w.exists()&&(yield w)}e.$Dl=m;async function I(){for await(const w of m())return w;return null}e.$El=I}),define(te[56],ne([0,1,16,13,35,55,3,24]),function(J,e,L,N,D,A,j,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.$Il=e.$Hl=e.TerminateResponseCode=e.Source=void 0,Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return A.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return A.TerminateResponseCode}});function h(R=D.env){return R.comspec||"cmd.exe"}e.$Hl=h;function c(R){let d=[],f=!1;const S=function(y){if(f){d.push(y);return}(!R.send(y,u=>{if(u&&console.error(u),f=!1,d.length>0){const m=d.slice(0);d=[],m.forEach(I=>S(I))}})||N.$i)&&(f=!0)};return{send:S}}e.$Il=c;var E;(function(R){async function d(f,S,y){if(L.$hc(f))return f;if(S===void 0&&(S=D.cwd()),L.$lc(f)!=="."||(y===void 0&&j.$Cf(D.env.PATH)&&(y=D.env.PATH.split(L.$sc)),y===void 0||y.length===0))return L.$ic(S,f);async function u(m){if(await v.Promises.exists(m)){let I;try{I=await v.Promises.stat(m)}catch(w){w.message.startsWith("EACCES")&&(I=await v.Promises.lstat(m))}return I?!I.isDirectory():!1}return!1}for(const m of y){let I;if(L.$hc(m)?I=L.$ic(m,f):I=L.$ic(S,m,f),await u(I))return I;let w=I+".com";if(await u(w)||(w=I+".exe",await u(w)))return w}return L.$ic(S,f)}R.findExecutable=d})(E||(e.win32=E={}))}),define(te[84],ne([0,1,33,13,83,56]),function(J,e,L,N,D,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jl=void 0;async function j(R,d){return R===1?N.$i?E():A.$Hl(d):h(R,d)}e.$Jl=j;let v=null;function h(R,d){if(N.$k&&R===2||N.$j&&R===3)return"/bin/bash";if(!v){let f;if(N.$i)f="/bin/bash";else{if(f=d.SHELL,!f)try{f=(0,L.userInfo)().shell}catch{}f||(f="sh"),f==="/bin/false"&&(f="/bin/bash")}v=f}return v}let c=null;async function E(){return c||(c=(await(0,D.$El)()).exePath),c}});var pe=this&&this.__decorate||function(J,e,L,N){var D=arguments.length,A=D<3?e:N===null?N=Object.getOwnPropertyDescriptor(e,L):N,j;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")A=Reflect.decorate(J,e,L,N);else for(var v=J.length-1;v>=0;v--)(j=J[v])&&(A=(D<3?j(A):D>3?j(e,L,A):j(e,L))||A);return D>3&&A&&Object.defineProperty(e,L,A),A};define(te[57],ne([0,1,19,8,14,20,52,9,4,2,46,29,3]),function(J,e,L,N,D,A,j,v,h,c,E,R,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Eh=e.ProxyChannel=e.$Dh=e.$Ch=e.$Bh=e.$Ah=e.$zh=e.$yh=e.RequestInitiator=e.$xh=e.$wh=e.$vh=e.$uh=e.$th=void 0;var f;(function(T){T[T.Promise=100]="Promise",T[T.PromiseCancel=101]="PromiseCancel",T[T.EventListen=102]="EventListen",T[T.EventDispose=103]="EventDispose"})(f||(f={}));function S(T){switch(T){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var y;(function(T){T[T.Initialize=200]="Initialize",T[T.PromiseSuccess=201]="PromiseSuccess",T[T.PromiseError=202]="PromiseError",T[T.PromiseErrorObj=203]="PromiseErrorObj",T[T.EventFire=204]="EventFire"})(y||(y={}));function $(T){switch(T){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var u;(function(T){T[T.Uninitialized=0]="Uninitialized",T[T.Idle=1]="Idle"})(u||(u={}));function m(T){let U=0;for(let H=0;;H+=7){const G=T.read(1);if(U|=(G.buffer[0]&127)<<H,!(G.buffer[0]&128))return U}}const I=t(0);function w(T,U){if(U===0){T.write(I);return}let H=0;for(let Z=U;Z!==0;Z=Z>>>7)H++;const G=D.$fe.alloc(H);for(let Z=0;U!==0;Z++)G.buffer[Z]=U&127,U=U>>>7,U>0&&(G.buffer[Z]|=128);T.write(G)}class P{constructor(U){this.b=U,this.a=0}read(U){const H=this.b.slice(this.a,this.a+U);return this.a+=H.byteLength,H}}e.$th=P;class s{constructor(){this.a=[]}get buffer(){return D.$fe.concat(this.a)}write(U){this.a.push(U)}}e.$uh=s;var o;(function(T){T[T.Undefined=0]="Undefined",T[T.String=1]="String",T[T.Buffer=2]="Buffer",T[T.VSBuffer=3]="VSBuffer",T[T.Array=4]="Array",T[T.Object=5]="Object",T[T.Int=6]="Int"})(o||(o={}));function t(T){const U=D.$fe.alloc(1);return U.writeUInt8(T,0),U}const n={Undefined:t(o.Undefined),String:t(o.String),Buffer:t(o.Buffer),VSBuffer:t(o.VSBuffer),Array:t(o.Array),Object:t(o.Object),Uint:t(o.Int)},i=typeof Buffer<"u";function r(T,U){if(typeof U>"u")T.write(n.Undefined);else if(typeof U=="string"){const H=D.$fe.fromString(U);T.write(n.String),w(T,H.byteLength),T.write(H)}else if(i&&Buffer.isBuffer(U)){const H=D.$fe.wrap(U);T.write(n.Buffer),w(T,H.byteLength),T.write(H)}else if(U instanceof D.$fe)T.write(n.VSBuffer),w(T,U.byteLength),T.write(U);else if(Array.isArray(U)){T.write(n.Array),w(T,U.length);for(const H of U)r(T,H)}else if(typeof U=="number"&&(U|0)===U)T.write(n.Uint),w(T,U);else{const H=D.$fe.fromString(JSON.stringify(U));T.write(n.Object),w(T,H.byteLength),T.write(H)}}e.$vh=r;function l(T){switch(T.read(1).readUInt8(0)){case o.Undefined:return;case o.String:return T.read(m(T)).toString();case o.Buffer:return T.read(m(T)).buffer;case o.VSBuffer:return T.read(m(T));case o.Array:{const H=m(T),G=[];for(let Z=0;Z<H;Z++)G.push(l(T));return G}case o.Object:return JSON.parse(T.read(m(T)).toString());case o.Int:return m(T)}}e.$wh=l;class k{constructor(U,H,G=null,Z=1e3){this.h=U,this.j=H,this.k=G,this.l=Z,this.b=new Map,this.d=new Map,this.g=new Map,this.f=this.h.onMessage(Y=>this.q(Y)),this.m({type:200})}registerChannel(U,H){this.b.set(U,H),setTimeout(()=>this.w(U),0)}m(U){switch(U.type){case 200:{const H=this.o([U.type]);this.k?.logOutgoing(H,0,1,$(U.type));return}case 201:case 202:case 204:case 203:{const H=this.o([U.type,U.id],U.data);this.k?.logOutgoing(H,U.id,1,$(U.type),U.data);return}}}o(U,H=void 0){const G=new s;return r(G,U),r(G,H),this.p(G.buffer)}p(U){try{return this.h.send(U),U.byteLength}catch{return 0}}q(U){const H=new P(U),G=l(H),Z=l(H),Y=G[0];switch(Y){case 100:return this.k?.logIncoming(U.byteLength,G[1],1,`${S(Y)}: ${G[2]}.${G[3]}`,Z),this.s({type:Y,id:G[1],channelName:G[2],name:G[3],arg:Z});case 102:return this.k?.logIncoming(U.byteLength,G[1],1,`${S(Y)}: ${G[2]}.${G[3]}`,Z),this.t({type:Y,id:G[1],channelName:G[2],name:G[3],arg:Z});case 101:return this.k?.logIncoming(U.byteLength,G[1],1,`${S(Y)}`),this.u({type:Y,id:G[1]});case 103:return this.k?.logIncoming(U.byteLength,G[1],1,`${S(Y)}`),this.u({type:Y,id:G[1]})}}s(U){const H=this.b.get(U.channelName);if(!H){this.v(U);return}const G=new A.$2d;let Z;try{Z=H.call(this.j,U.name,U.arg,G.token)}catch(F){Z=Promise.reject(F)}const Y=U.id;Z.then(F=>{this.m({id:Y,data:F,type:201})},F=>{F instanceof Error?this.m({id:Y,data:{message:F.message,name:F.name,stack:F.stack?F.stack.split?F.stack.split(`
`):F.stack:void 0},type:202}):this.m({id:Y,data:F,type:203})}).finally(()=>{C.dispose(),this.d.delete(U.id)});const C=(0,c.$Pc)(()=>G.cancel());this.d.set(U.id,C)}t(U){const H=this.b.get(U.channelName);if(!H){this.v(U);return}const G=U.id,Y=H.listen(this.j,U.name,U.arg)(C=>this.m({id:G,data:C,type:204}));this.d.set(U.id,Y)}u(U){const H=this.d.get(U.id);H&&(H.dispose(),this.d.delete(U.id))}v(U){let H=this.g.get(U.channelName);H||(H=[],this.g.set(U.channelName,H));const G=setTimeout(()=>{console.error(`Unknown channel: ${U.channelName}`),U.type===100&&this.m({id:U.id,data:{name:"Unknown channel",message:`Channel name '${U.channelName}' timed out after ${this.l}ms`,stack:void 0},type:202})},this.l);H.push({request:U,timeoutTimer:G})}w(U){const H=this.g.get(U);if(H){for(const G of H)switch(clearTimeout(G.timeoutTimer),G.request.type){case 100:this.s(G.request);break;case 102:this.t(G.request);break}this.g.delete(U)}}dispose(){this.f&&(this.f.dispose(),this.f=null),(0,c.$Mc)(this.d.values()),this.d.clear()}}e.$xh=k;var b;(function(T){T[T.LocalSide=0]="LocalSide",T[T.OtherSide=1]="OtherSide"})(b||(e.RequestInitiator=b={}));class p{constructor(U,H=null){this.l=U,this.a=!1,this.b=u.Uninitialized,this.d=new Set,this.f=new Map,this.g=0,this.k=new h.$Rd,this.onDidInitialize=this.k.event,this.h=this.l.onMessage(G=>this.s(G)),this.j=H}getChannel(U){const H=this;return{call(G,Z,Y){return H.a?Promise.reject(new v.$4):H.m(U,G,Z,Y)},listen(G,Z){return H.a?h.Event.None:H.o(U,G,Z)}}}m(U,H,G,Z=A.CancellationToken.None){const Y=this.g++,F={id:Y,type:100,channelName:U,name:H,arg:G};if(Z.isCancellationRequested)return Promise.reject(new v.$4);let a;return new Promise((z,M)=>{if(Z.isCancellationRequested)return M(new v.$4);const X=()=>{const me=de=>{switch(de.type){case 201:this.f.delete(Y),z(de.data);break;case 202:{this.f.delete(Y);const ge=new Error(de.data.message);ge.stack=Array.isArray(de.data.stack)?de.data.stack.join(`
`):de.data.stack,ge.name=de.data.name,M(ge);break}case 203:this.f.delete(Y),M(de.data);break}};this.f.set(Y,me),this.p(F)};let W=null;this.b===u.Idle?X():(W=(0,N.$Lg)(me=>this.u()),W.then(()=>{W=null,X()}));const le=()=>{W?(W.cancel(),W=null):this.p({id:Y,type:101}),M(new v.$4)},ae=Z.onCancellationRequested(le);a=(0,c.$Oc)((0,c.$Pc)(le),ae),this.d.add(a)}).finally(()=>{a.dispose(),this.d.delete(a)})}o(U,H,G){const Z=this.g++,C={id:Z,type:102,channelName:U,name:H,arg:G};let F=null;const a=new h.$Rd({onWillAddFirstListener:()=>{F=(0,N.$Lg)(z=>this.u()),F.then(()=>{F=null,this.d.add(a),this.p(C)})},onDidRemoveLastListener:()=>{F?(F.cancel(),F=null):(this.d.delete(a),this.p({id:Z,type:103}))}}),g=z=>a.fire(z.data);return this.f.set(Z,g),a.event}p(U){switch(U.type){case 100:case 102:{const H=this.q([U.type,U.id,U.channelName,U.name],U.arg);this.j?.logOutgoing(H,U.id,0,`${S(U.type)}: ${U.channelName}.${U.name}`,U.arg);return}case 101:case 103:{const H=this.q([U.type,U.id]);this.j?.logOutgoing(H,U.id,0,S(U.type));return}}}q(U,H=void 0){const G=new s;return r(G,U),r(G,H),this.r(G.buffer)}r(U){try{return this.l.send(U),U.byteLength}catch{return 0}}s(U){const H=new P(U),G=l(H),Z=l(H),Y=G[0];switch(Y){case 200:return this.j?.logIncoming(U.byteLength,0,0,$(Y)),this.t({type:G[0]});case 201:case 202:case 204:case 203:return this.j?.logIncoming(U.byteLength,G[1],0,$(Y),Z),this.t({type:G[0],id:G[1],data:Z})}}t(U){if(U.type===200){this.b=u.Idle,this.k.fire();return}this.f.get(U.id)?.(U)}get onDidInitializePromise(){return h.Event.toPromise(this.onDidInitialize)}u(){return this.b===u.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.a=!0,this.h&&(this.h.dispose(),this.h=null),(0,c.$Mc)(this.d.values()),this.d.clear()}}e.$yh=p,pe([j.$nh],p.prototype,"onDidInitializePromise",null);class O{get connections(){const U=[];return this.f.forEach(H=>U.push(H)),U}constructor(U){this.a=new Map,this.f=new Set,this.g=new h.$Rd,this.onDidAddConnection=this.g.event,this.h=new h.$Rd,this.onDidRemoveConnection=this.h.event,this.j=new c.$Qc,this.j.add(U(({protocol:H,onDidClientDisconnect:G})=>{const Z=h.Event.once(H.onMessage);this.j.add(Z(Y=>{const C=new P(Y),F=l(C),a=new k(H,F),g=new p(H);this.a.forEach((M,X)=>a.registerChannel(X,M));const z={channelServer:a,channelClient:g,ctx:F};this.f.add(z),this.g.fire(z),this.j.add(G(()=>{a.dispose(),g.dispose(),this.f.delete(z),this.h.fire(z)}))}))}))}getChannel(U,H){const G=this;return{call(Z,Y,C){let F;if((0,d.$Qf)(H)){const g=(0,L.$3b)(G.connections.filter(H));F=g?Promise.resolve(g):h.Event.toPromise(h.Event.filter(G.onDidAddConnection,H))}else F=H.routeCall(G,Z,Y);const a=F.then(g=>g.channelClient.getChannel(U));return _(a).call(Z,Y,C)},listen(Z,Y){if((0,d.$Qf)(H))return G.k(U,H,Z,Y);const C=H.routeEvent(G,Z,Y).then(F=>F.channelClient.getChannel(U));return _(C).listen(Z,Y)}}}k(U,H,G,Z){const Y=this;let C;const F=new h.$Rd({onWillAddFirstListener:()=>{C=new c.$Qc;const a=new h.$Xd,g=new Map,z=X=>{const le=X.channelClient.getChannel(U).listen(G,Z),ae=a.add(le);g.set(X,ae)},M=X=>{const W=g.get(X);W&&(W.dispose(),g.delete(X))};Y.connections.filter(H).forEach(z),h.Event.filter(Y.onDidAddConnection,H)(z,void 0,C),Y.onDidRemoveConnection(M,void 0,C),a.event(F.fire,F,C),C.add(a)},onDidRemoveLastListener:()=>{C?.dispose(),C=void 0}});return F.event}registerChannel(U,H){this.a.set(U,H);for(const G of this.f)G.channelServer.registerChannel(U,H)}dispose(){this.j.dispose();for(const U of this.f)U.channelClient.dispose(),U.channelServer.dispose();this.f.clear(),this.a.clear(),this.g.dispose(),this.h.dispose()}}e.$zh=O;class B{constructor(U,H,G=null){const Z=new s;r(Z,H),U.send(Z.buffer),this.a=new p(U,G),this.d=new k(U,H,G)}getChannel(U){return this.a.getChannel(U)}registerChannel(U,H){this.d.registerChannel(U,H)}dispose(){this.a.dispose(),this.d.dispose()}}e.$Ah=B;function _(T){return{call(U,H,G){return T.then(Z=>Z.call(U,H,G))},listen(U,H){const G=new h.$1d;return T.then(Z=>G.input=Z.listen(U,H)),G.event}}}e.$Bh=_;function ee(T){let U=!1;return{call(H,G,Z){return U?T.call(H,G,Z):(0,N.$Yg)(0).then(()=>U=!0).then(()=>T.call(H,G,Z))},listen(H,G){if(U)return T.listen(H,G);const Z=new h.$1d;return(0,N.$Yg)(0).then(()=>U=!0).then(()=>Z.input=T.listen(H,G)),Z.event}}}e.$Ch=ee;class oe{constructor(U){this.a=U}routeCall(U){return this.b(U)}routeEvent(U){return this.b(U)}async b(U){for(const H of U.connections)if(await Promise.resolve(this.a(H.ctx)))return Promise.resolve(H);return await h.Event.toPromise(U.onDidAddConnection),await this.b(U)}}e.$Dh=oe;var se;(function(T){function U(Y,C,F){const a=Y,g=F&&F.disableMarshalling,z=new Map;for(const M in a)G(M)&&z.set(M,h.Event.buffer(a[M],!0,void 0,C));return new class{listen(M,X,W){const le=z.get(X);if(le)return le;if(Z(X)){const ae=a[X];if(typeof ae=="function")return ae.call(a,W)}throw new v.$ab(`Event not found: ${X}`)}call(M,X,W){const le=a[X];if(typeof le=="function"){if(!g&&Array.isArray(W))for(let me=0;me<W.length;me++)W[me]=(0,E.$sh)(W[me]);let ae=le.apply(a,W);return ae instanceof Promise||(ae=Promise.resolve(ae)),ae}throw new v.$ab(`Method not found: ${X}`)}}}T.fromService=U;function H(Y,C){const F=C&&C.disableMarshalling;return new Proxy({},{get(a,g){if(typeof g=="string")return C?.properties?.has(g)?C.properties.get(g):Z(g)?function(z){return Y.listen(g,z)}:G(g)?Y.listen(g):async function(...z){let M;C&&!(0,d.$Lf)(C.context)?M=[C.context,...z]:M=z;const X=await Y.call(g,M);return F?X:(0,E.$sh)(X)};throw new v.$ab(`Property not found: ${String(g)}`)}})}T.toService=H;function G(Y){return Y[0]==="o"&&Y[1]==="n"&&R.$5e(Y.charCodeAt(2))}function Z(Y){return/^onDynamic/.test(Y)&&R.$5e(Y.charCodeAt(9))}})(se||(e.ProxyChannel=se={}));const ue=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function ce(T){if(Array.isArray(T))return T;if(T&&typeof T=="object"&&typeof T.toString=="function"){const U=T.toString();if(U!=="[object Object]")return U}return T}function re(T){return Array.isArray(T)?T.map(ce):ce(T)}function q(T,U,H,G,Z,Y,C){C=re(C);const F=ue[Z],a=F[G%F.length];let g=[`%c[${T}]%c[${String(U).padStart(7," ")}]%c[len: ${String(H).padStart(5," ")}]%c${String(G).padStart(5," ")} - ${Y}`,"color: darkgreen","color: grey","color: grey",`color: ${a}`];/\($/.test(Y)?(g=g.concat(C),g.push(")")):g.push(C),console.log.apply(console,g)}class Q{constructor(U,H){this.d=U,this.f=H,this.a=0,this.b=0}logOutgoing(U,H,G,Z,Y){this.b+=U,q(this.d,this.b,U,H,G,Z,Y)}logIncoming(U,H,G,Z,Y){this.a+=U,q(this.f,this.a,U,H,G,Z,Y)}}e.$Eh=Q}),define(te[85],ne([0,1,58,8,14,20,80,9,4,2,30,56,55,57]),function(J,e,L,N,D,A,j,v,h,c,E,R,d,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9p=e.$8p=void 0;class S extends f.$xh{constructor(u){super({send:m=>{try{process.send?.(m.buffer.toString("base64"))}catch{}},onMessage:h.Event.fromNodeEventEmitter(process,"message",m=>D.$fe.wrap(Buffer.from(m,"base64")))},u),process.once("disconnect",()=>this.dispose())}}e.$8p=S;class y{constructor(u,m){this.i=u,this.j=m,this.c=new Set,this.g=new Map,this.h=new h.$Rd,this.onDidProcessExit=this.h.event;const I=m&&m.timeout?m.timeout:6e4;this.b=new N.$Ug(I),this.d=null,this.f=null}getChannel(u){const m=this;return{call(I,w,P){return m.k(u,I,w,P)},listen(I,w){return m.l(u,I,w)}}}k(u,m,I,w=A.CancellationToken.None){if(!this.b)return Promise.reject(new Error("disposed"));if(w.isCancellationRequested)return Promise.reject(v.$5());this.b.cancel();const P=this.n(u),s=(0,N.$Lg)(n=>P.call(m,I,n)),o=w.onCancellationRequested(()=>s.cancel()),t=(0,c.$Pc)(()=>s.cancel());return this.c.add(t),s.finally(()=>{o.dispose(),this.c.delete(t),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}),s}l(u,m,I){if(!this.b)return h.Event.None;this.b.cancel();let w;const P=new h.$Rd({onWillAddFirstListener:()=>{w=this.n(u).listen(m,I)(P.fire,P),this.c.add(w)},onDidRemoveLastListener:()=>{this.c.delete(w),w.dispose(),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}});return P.event}get m(){if(!this.f){const u=this.j&&this.j.args?this.j.args:[],m=Object.create(null);m.env={...(0,E.$an)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.j&&this.j.env&&(m.env={...m.env,...this.j.env}),this.j&&this.j.freshExecArgv&&(m.execArgv=[]),this.j&&typeof this.j.debug=="number"&&(m.execArgv=["--nolazy","--inspect="+this.j.debug]),this.j&&typeof this.j.debugBrk=="number"&&(m.execArgv=["--nolazy","--inspect-brk="+this.j.debugBrk]),m.execArgv===void 0&&(m.execArgv=process.execArgv.filter(i=>!/^--inspect(-brk)?=/.test(i)).filter(i=>!i.startsWith("--vscode-"))),(0,d.$Gl)(m.env),this.d=(0,L.fork)(this.i,u,m);const I=new h.$Rd;h.Event.fromNodeEventEmitter(this.d,"message",i=>i)(i=>{if((0,j.$4p)(i)){(0,j.log)(i,`IPC Library: ${this.j.serverName}`);return}I.fire(D.$fe.wrap(Buffer.from(i,"base64")))});const P=this.j.useQueue?(0,R.$Il)(this.d):this.d,s=i=>this.d&&this.d.connected&&P.send(i.buffer.toString("base64")),o=I.event,t={send:s,onMessage:o};this.f=new f.$yh(t);const n=()=>this.o();process.once("exit",n),this.d.on("error",i=>console.warn('IPC "'+this.j.serverName+'" errored with '+i)),this.d.on("exit",(i,r)=>{process.removeListener("exit",n),this.c.forEach(l=>(0,c.$Mc)(l)),this.c.clear(),i!==0&&r!=="SIGTERM"&&console.warn('IPC "'+this.j.serverName+'" crashed with exit code '+i+" and signal "+r),this.b?.cancel(),this.o(),this.h.fire({code:i,signal:r})})}return this.f}n(u){let m=this.g.get(u);return m||(m=this.m.getChannel(u),this.g.set(u,m)),m}o(){this.f&&(this.d&&(this.d.kill(),this.d=null),this.f=null,this.g.clear())}dispose(){this.h.dispose(),this.b?.cancel(),this.b=void 0,this.o(),this.c.clear()}}e.$9p=y}),define(te[86],ne([0,1,8,4,2,46,3]),function(J,e,L,N,D,A,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9o=e.$8o=e.StorageState=e.$7o=e.StorageHint=void 0;var v;(function(d){d[d.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST",d[d.STORAGE_IN_MEMORY=1]="STORAGE_IN_MEMORY"})(v||(e.StorageHint=v={}));function h(d){const f=d;return f?.changed instanceof Map||f?.deleted instanceof Set}e.$7o=h;var c;(function(d){d[d.None=0]="None",d[d.Initialized=1]="Initialized",d[d.Closed=2]="Closed"})(c||(e.StorageState=c={}));class E extends D.$Rc{static{this.a=100}constructor(f,S=Object.create(null)){super(),this.r=f,this.s=S,this.b=this.B(new N.$Ud),this.onDidChangeStorage=this.b.event,this.c=c.None,this.f=new Map,this.g=this.B(new L.$Vg(E.a)),this.h=new Set,this.j=new Map,this.m=void 0,this.n=[],this.t()}t(){this.B(this.r.onDidChangeItemsExternal(f=>this.u(f)))}u(f){this.b.pause();try{f.changed?.forEach((S,y)=>this.w(y,S)),f.deleted?.forEach(S=>this.w(S,void 0))}finally{this.b.resume()}}w(f,S){if(this.c===c.Closed)return;let y=!1;(0,j.$Lf)(S)?y=this.f.delete(f):this.f.get(f)!==S&&(this.f.set(f,S),y=!0),y&&this.b.fire({key:f,external:!0})}get items(){return this.f}get size(){return this.f.size}async init(){this.c===c.None&&(this.c=c.Initialized,this.s.hint!==v.STORAGE_DOES_NOT_EXIST&&(this.f=await this.r.getItems()))}get(f,S){const y=this.f.get(f);return(0,j.$Lf)(y)?S:y}getBoolean(f,S){const y=this.get(f);return(0,j.$Lf)(y)?S:y==="true"}getNumber(f,S){const y=this.get(f);return(0,j.$Lf)(y)?S:parseInt(y,10)}getObject(f,S){const y=this.get(f);return(0,j.$Lf)(y)?S:(0,A.$rh)(y)}async set(f,S,y=!1){if(this.c===c.Closed)return;if((0,j.$Lf)(S))return this.delete(f,y);const $=(0,j.$Ef)(S)||Array.isArray(S)?(0,A.$qh)(S):String(S);if(this.f.get(f)!==$)return this.f.set(f,$),this.j.set(f,$),this.h.delete(f),this.b.fire({key:f,external:y}),this.D()}async delete(f,S=!1){if(!(this.c===c.Closed||!this.f.delete(f)))return this.h.has(f)||this.h.add(f),this.j.delete(f),this.b.fire({key:f,external:S}),this.D()}async optimize(){if(this.c!==c.Closed)return await this.flush(0),this.r.optimize()}async close(){return this.m||(this.m=this.y()),this.m}async y(){this.c=c.Closed;try{await this.D(0)}catch{}await this.r.close(()=>this.f)}get z(){return this.j.size>0||this.h.size>0}async C(){if(!this.z)return;const f={insert:this.j,delete:this.h};return this.h=new Set,this.j=new Map,this.r.updateItems(f).finally(()=>{if(!this.z)for(;this.n.length;)this.n.pop()?.()})}async flush(f){if(this.z)return this.D(f)}async D(f){return this.s.hint===v.STORAGE_IN_MEMORY?this.C():this.g.trigger(()=>this.C(),f)}async whenFlushed(){if(this.z)return new Promise(f=>this.n.push(f))}isInMemory(){return this.s.hint===v.STORAGE_IN_MEMORY}}e.$8o=E;class R{constructor(){this.onDidChangeItemsExternal=N.Event.None,this.a=new Map}async getItems(){return this.a}async updateItems(f){f.insert?.forEach((S,y)=>this.a.set(y,S)),f.delete?.forEach(S=>this.a.delete(S))}async optimize(){}async close(){}}e.$9o=R}),define(te[87],ne([7,5]),function(J,e){return J.create("vs/base/node/zip",e)}),define(te[88],ne([7,5]),function(J,e){return J.create("vs/platform/configuration/common/configurationRegistry",e)}),define(te[89],ne([7,5]),function(J,e){return J.create("vs/platform/contextkey/common/contextkey",e)}),define(te[90],ne([7,5]),function(J,e){return J.create("vs/platform/contextkey/common/scanner",e)}),define(te[91],ne([7,5]),function(J,e){return J.create("vs/platform/extensionManagement/common/abstractExtensionManagementService",e)}),define(te[92],ne([7,5]),function(J,e){return J.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(te[93],ne([7,5]),function(J,e){return J.create("vs/platform/extensionManagement/common/extensionManagementCLI",e)}),define(te[94],ne([7,5]),function(J,e){return J.create("vs/platform/extensionManagement/common/extensionNls",e)}),define(te[95],ne([7,5]),function(J,e){return J.create("vs/platform/extensionManagement/common/extensionsScannerService",e)}),define(te[96],ne([7,5]),function(J,e){return J.create("vs/platform/extensionManagement/node/extensionManagementService",e)}),define(te[97],ne([7,5]),function(J,e){return J.create("vs/platform/extensionManagement/node/extensionManagementUtil",e)}),define(te[98],ne([7,5]),function(J,e){return J.create("vs/platform/extensions/common/extensionValidator",e)}),define(te[99],ne([7,5]),function(J,e){return J.create("vs/platform/files/common/fileService",e)}),define(te[100],ne([7,5]),function(J,e){return J.create("vs/platform/files/common/io",e)}),define(te[101],ne([7,5]),function(J,e){return J.create("vs/platform/files/node/diskFileSystemProvider",e)}),define(te[102],ne([7,5]),function(J,e){return J.create("vs/platform/languagePacks/common/languagePacks",e)}),define(te[103],ne([7,5]),function(J,e){return J.create("vs/platform/request/common/request",e)}),define(te[104],ne([7,5]),function(J,e){return J.create("vs/platform/shell/node/shellEnv",e)}),define(te[105],ne([7,5]),function(J,e){return J.create("vs/platform/telemetry/common/telemetryService",e)}),define(te[106],ne([7,5]),function(J,e){return J.create("vs/platform/userDataProfile/common/userDataProfile",e)}),define(te[107],ne([7,5]),function(J,e){return J.create("vs/platform/workspace/common/workspace",e)}),define(te[108],ne([0,1,9,90]),function(J,e,L,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qi=e.TokenType=void 0;var D;(function(c){c[c.LParen=0]="LParen",c[c.RParen=1]="RParen",c[c.Neg=2]="Neg",c[c.Eq=3]="Eq",c[c.NotEq=4]="NotEq",c[c.Lt=5]="Lt",c[c.LtEq=6]="LtEq",c[c.Gt=7]="Gt",c[c.GtEq=8]="GtEq",c[c.RegexOp=9]="RegexOp",c[c.RegexStr=10]="RegexStr",c[c.True=11]="True",c[c.False=12]="False",c[c.In=13]="In",c[c.Not=14]="Not",c[c.And=15]="And",c[c.Or=16]="Or",c[c.Str=17]="Str",c[c.QuotedStr=18]="QuotedStr",c[c.Error=19]="Error",c[c.EOF=20]="EOF"})(D||(e.TokenType=D={}));function A(...c){switch(c.length){case 1:return(0,N.localize)(0,null,c[0]);case 2:return(0,N.localize)(1,null,c[0],c[1]);case 3:return(0,N.localize)(2,null,c[0],c[1],c[2]);default:return}}const j=(0,N.localize)(3,null),v=(0,N.localize)(4,null);class h{constructor(){this.c="",this.d=0,this.e=0,this.f=[],this.g=[],this.m=/[a-zA-Z0-9_<>\-\./\\:\*\?\+\[\]\^,#@;"%\$\p{L}-]+/uy}static getLexeme(E){switch(E.type){case 0:return"(";case 1:return")";case 2:return"!";case 3:return E.isTripleEq?"===":"==";case 4:return E.isTripleEq?"!==":"!=";case 5:return"<";case 6:return"<=";case 7:return">=";case 8:return">=";case 9:return"=~";case 10:return E.lexeme;case 11:return"true";case 12:return"false";case 13:return"in";case 14:return"not";case 15:return"&&";case 16:return"||";case 17:return E.lexeme;case 18:return E.lexeme;case 19:return E.lexeme;case 20:return"EOF";default:throw(0,L.$7)(`unhandled token type: ${JSON.stringify(E)}; have you forgotten to add a case?`)}}static{this.a=new Set(["i","g","s","m","y","u"].map(E=>E.charCodeAt(0)))}static{this.b=new Map([["not",14],["in",13],["false",12],["true",11]])}get errors(){return this.g}reset(E){return this.c=E,this.d=0,this.e=0,this.f=[],this.g=[],this}scan(){for(;!this.r();)switch(this.d=this.e,this.i()){case 40:this.k(0);break;case 41:this.k(1);break;case 33:if(this.h(61)){const R=this.h(61);this.f.push({type:4,offset:this.d,isTripleEq:R})}else this.k(2);break;case 39:this.o();break;case 47:this.q();break;case 61:if(this.h(61)){const R=this.h(61);this.f.push({type:3,offset:this.d,isTripleEq:R})}else this.h(126)?this.k(9):this.l(A("==","=~"));break;case 60:this.k(this.h(61)?6:5);break;case 62:this.k(this.h(61)?8:7);break;case 38:this.h(38)?this.k(15):this.l(A("&&"));break;case 124:this.h(124)?this.k(16):this.l(A("||"));break;case 32:case 13:case 9:case 10:case 160:break;default:this.n()}return this.d=this.e,this.k(20),Array.from(this.f)}h(E){return this.r()||this.c.charCodeAt(this.e)!==E?!1:(this.e++,!0)}i(){return this.c.charCodeAt(this.e++)}j(){return this.r()?0:this.c.charCodeAt(this.e)}k(E){this.f.push({type:E,offset:this.d})}l(E){const R=this.d,d=this.c.substring(this.d,this.e),f={type:19,offset:this.d,lexeme:d};this.g.push({offset:R,lexeme:d,additionalInfo:E}),this.f.push(f)}n(){this.m.lastIndex=this.d;const E=this.m.exec(this.c);if(E){this.e=this.d+E[0].length;const R=this.c.substring(this.d,this.e),d=h.b.get(R);d?this.k(d):this.f.push({type:17,lexeme:R,offset:this.d})}}o(){for(;this.j()!==39&&!this.r();)this.i();if(this.r()){this.l(j);return}this.i(),this.f.push({type:18,lexeme:this.c.substring(this.d+1,this.e-1),offset:this.d+1})}q(){let E=this.e,R=!1,d=!1;for(;;){if(E>=this.c.length){this.e=E,this.l(v);return}const S=this.c.charCodeAt(E);if(R)R=!1;else if(S===47&&!d){E++;break}else S===91?d=!0:S===92?R=!0:S===93&&(d=!1);E++}for(;E<this.c.length&&h.a.has(this.c.charCodeAt(E));)E++;this.e=E;const f=this.c.substring(this.d,this.e);this.f.push({type:10,lexeme:f,offset:this.d})}r(){return this.e>=this.c.length}}e.$Qi=h}),define(te[109],ne([0,1,76,52,15,16,35,17,11]),function(J,e,L,N,D,A,j,v,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$om=e.$nm=e.$mm=e.$lm=void 0,e.$lm=/^([^.]+\..+):(.+)$/;class c{get appRoot(){return(0,A.$lc)(D.$gg.asFileUri("").fsPath)}get userHome(){return h.URI.file(this.b.homeDir)}get userDataPath(){return this.b.userDataDir}get appSettingsHome(){return h.URI.file((0,A.$ic)(this.userDataPath,"User"))}get tmpDir(){return h.URI.file(this.b.tmpDir)}get cacheHome(){return h.URI.file(this.userDataPath)}get stateResource(){return(0,v.$zg)(this.appSettingsHome,"globalStorage","storage.json")}get userRoamingDataHome(){return this.appSettingsHome.with({scheme:D.Schemas.vscodeUserData})}get userDataSyncHome(){return(0,v.$zg)(this.appSettingsHome,"sync")}get logsHome(){if(!this.args.logsPath){const f=(0,L.$km)(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=(0,A.$ic)(this.userDataPath,"logs",f)}return h.URI.file(this.args.logsPath)}get sync(){return this.args.sync}get machineSettingsResource(){return(0,v.$zg)(h.URI.file((0,A.$ic)(this.userDataPath,"Machine")),"settings.json")}get workspaceStorageHome(){return(0,v.$zg)(this.appSettingsHome,"workspaceStorage")}get localHistoryHome(){return(0,v.$zg)(this.appSettingsHome,"History")}get keyboardLayoutResource(){return(0,v.$zg)(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const f=j.env.VSCODE_PORTABLE;return f?h.URI.file((0,A.$ic)(f,"argv.json")):(0,v.$zg)(this.userHome,this.c.dataFolderName,"argv.json")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return h.URI.file((0,A.$ic)(this.userDataPath,"Workspaces"))}get builtinExtensionsPath(){const f=this.args["builtin-extensions-dir"];return f?(0,A.$jc)(f):(0,A.$gc)((0,A.$ic)(D.$gg.asFileUri("").fsPath,"..","extensions"))}get extensionsDownloadLocation(){const f=this.args["extensions-download-dir"];return f?h.URI.file((0,A.$jc)(f)):h.URI.file((0,A.$ic)(this.userDataPath,"CachedExtensionVSIXs"))}get extensionsPath(){const f=this.args["extensions-dir"];if(f)return(0,A.$jc)(f);const S=j.env.VSCODE_EXTENSIONS;if(S)return S;const y=j.env.VSCODE_PORTABLE;return y?(0,A.$ic)(y,"extensions"):(0,v.$zg)(this.userHome,this.c.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const f=this.args.extensionDevelopmentPath;if(Array.isArray(f))return f.map(S=>/^[^:/?#]+?:\/\//.test(S)?h.URI.parse(S):h.URI.file((0,A.$gc)(S)))}get extensionDevelopmentKind(){return this.args.extensionDevelopmentKind?.map(f=>f==="ui"||f==="workspace"||f==="web"?f:"workspace")}get extensionTestsLocationURI(){const f=this.args.extensionTestsPath;if(f)return/^[^:/?#]+?:\/\//.test(f)?h.URI.parse(f):h.URI.file((0,A.$gc)(f))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const f=this.args["disable-extension"];if(f){if(typeof f=="string")return[f];if(Array.isArray(f)&&f.length>0)return f}return!1}get debugExtensionHost(){return E(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!j.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log?.find(f=>!e.$lm.test(f))}get extensionLogLevel(){const f=[];for(const S of this.args.log||[]){const y=e.$lm.exec(S);y&&y[1]&&y[2]&&f.push([y[1],y[2]])}return f.length?f:void 0}get serviceMachineIdResource(){return(0,v.$zg)(h.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get disableTelemetry(){return!!this.args["disable-telemetry"]}get disableWorkspaceTrust(){return!!this.args["disable-workspace-trust"]}get useInMemorySecretStorage(){return!!this.args["use-inmemory-secretstorage"]}get policyFile(){if(this.args["__enable-file-policy"]){const f=j.env.VSCODE_PORTABLE;return f?h.URI.file((0,A.$ic)(f,"policy.json")):(0,v.$zg)(this.userHome,this.c.dataFolderName,"policy.json")}}get continueOn(){return this.args.continueOn}set continueOn(f){this.args.continueOn=f}get args(){return this.a}constructor(f,S,y){this.a=f,this.b=S,this.c=y,this.editSessionId=this.args.editSessionId}}e.$mm=c,pe([N.$nh],c.prototype,"appRoot",null),pe([N.$nh],c.prototype,"userHome",null),pe([N.$nh],c.prototype,"userDataPath",null),pe([N.$nh],c.prototype,"appSettingsHome",null),pe([N.$nh],c.prototype,"tmpDir",null),pe([N.$nh],c.prototype,"cacheHome",null),pe([N.$nh],c.prototype,"stateResource",null),pe([N.$nh],c.prototype,"userRoamingDataHome",null),pe([N.$nh],c.prototype,"userDataSyncHome",null),pe([N.$nh],c.prototype,"sync",null),pe([N.$nh],c.prototype,"machineSettingsResource",null),pe([N.$nh],c.prototype,"workspaceStorageHome",null),pe([N.$nh],c.prototype,"localHistoryHome",null),pe([N.$nh],c.prototype,"keyboardLayoutResource",null),pe([N.$nh],c.prototype,"argvResource",null),pe([N.$nh],c.prototype,"isExtensionDevelopment",null),pe([N.$nh],c.prototype,"untitledWorkspacesHome",null),pe([N.$nh],c.prototype,"builtinExtensionsPath",null),pe([N.$nh],c.prototype,"extensionsPath",null),pe([N.$nh],c.prototype,"extensionDevelopmentLocationURI",null),pe([N.$nh],c.prototype,"extensionDevelopmentKind",null),pe([N.$nh],c.prototype,"extensionTestsLocationURI",null),pe([N.$nh],c.prototype,"debugExtensionHost",null),pe([N.$nh],c.prototype,"logLevel",null),pe([N.$nh],c.prototype,"extensionLogLevel",null),pe([N.$nh],c.prototype,"serviceMachineIdResource",null),pe([N.$nh],c.prototype,"disableTelemetry",null),pe([N.$nh],c.prototype,"disableWorkspaceTrust",null),pe([N.$nh],c.prototype,"useInMemorySecretStorage",null),pe([N.$nh],c.prototype,"policyFile",null);function E(d,f){return R(d["inspect-extensions"],d["inspect-brk-extensions"],5870,f,d.debugId,d.extensionEnvironment)}e.$nm=E;function R(d,f,S,y,$,u){const I=Number(f||d)||(y?null:S),w=I?!!f:!1;let P;if(u)try{P=JSON.parse(u)}catch{}return{port:I,break:w,debugId:$,env:P}}e.$om=R}),function(){"use strict";function J(e,L,N){function D(j,v){const h=A(j,v),c=[h];return e.isAbsolute(h)||c.unshift(N),e.resolve(...c)}function A(j,v){process.env.VSCODE_DEV&&(v="code-oss-dev");const h=process.env.VSCODE_PORTABLE;if(h)return e.join(h,"user-data");let c=process.env.VSCODE_APPDATA;if(c)return e.join(c,v);const E=j["user-data-dir"];if(E)return E;switch(process.platform){case"win32":if(c=process.env.APPDATA,!c){const R=process.env.USERPROFILE;if(typeof R!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");c=e.join(R,"AppData","Roaming")}break;case"darwin":c=e.join(L.homedir(),"Library","Application Support");break;case"linux":c=process.env.XDG_CONFIG_HOME||e.join(L.homedir(),".config");break;default:throw new Error("Platform not supported")}return e.join(c,v)}return{getUserDataPath:D}}if(typeof define=="function")define(te[110],ne([165,33,35]),function(e,L,N){return J(e,L,N.cwd())});else if(typeof module=="object"&&typeof module.exports=="object"){const e=require("path"),L=require("os");module.exports=J(e,L,process.env.VSCODE_CWD||process.cwd())}else throw new Error("Unknown context")}(),define(te[111],ne([0,1,33,109,110]),function(J,e,L,N,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rm=e.$qm=e.$pm=void 0;class A extends N.$mm{constructor(c,E){super(c,{homeDir:(0,L.homedir)(),tmpDir:(0,L.tmpdir)(),userDataDir:(0,D.getUserDataPath)(c,E.nameShort)},E)}}e.$pm=A;function j(h,c){return(0,N.$om)(h["inspect-ptyhost"],h["inspect-brk-ptyhost"],5877,c,h.extensionEnvironment)}e.$qm=j;function v(h,c){return(0,N.$om)(h["inspect-sharedprocess"],h["inspect-brk-sharedprocess"],5879,c,h.extensionEnvironment)}e.$rm=v}),define(te[112],ne([0,1,3,94]),function(J,e,L,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dp=void 0;function D(j,v,h,c){try{A(j,v,h,c)}catch(E){j.error(E?.message??E)}return v}e.$Dp=D;function A(j,v,h,c){const E=(R,d,f)=>{const S=R[d];if((0,L.$Cf)(S)){const y=S,$=y.length;if($>1&&y[0]==="%"&&y[$-1]==="%"){const u=y.substr(1,$-2);let m=h[u];m===void 0&&c&&(m=c[u]);const I=typeof m=="string"?m:m?.message,w=c?.[u],P=typeof w=="string"?w:w?.message;if(!I){P||j.warn(`[${v.name}]: ${(0,N.localize)(0,null,u)}`);return}if(f&&(d==="title"||d==="category")&&P&&P!==I){const s={value:I,original:P};R[d]=s}else R[d]=I}}else if((0,L.$Ef)(S))for(const y in S)S.hasOwnProperty(y)&&(y==="commands"?E(S,y,!0):E(S,y,f));else if(Array.isArray(S))for(let y=0;y<S.length;y++)E(S,y,f)};for(const R in v)v.hasOwnProperty(R)&&E(v,R)}}),define(te[48],ne([0,1,17,54,98,42]),function(J,e,L,N,D,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xo=e.$Wo=e.$Vo=e.$Uo=e.$To=e.$So=e.$Ro=void 0;const j=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,v=/^-(\d{4})(\d{2})(\d{2})$/;function h(u){return u=u.trim(),u==="*"||j.test(u)}e.$Ro=h;function c(u){if(!h(u))return null;if(u=u.trim(),u==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const m=u.match(j);return m?{hasCaret:m[1]==="^",hasGreaterEquals:m[1]===">=",majorBase:m[2]==="x"?0:parseInt(m[2],10),majorMustEqual:m[2]!=="x",minorBase:m[4]==="x"?0:parseInt(m[4],10),minorMustEqual:m[4]!=="x",patchBase:m[6]==="x"?0:parseInt(m[6],10),patchMustEqual:m[6]!=="x",preRelease:m[8]||null}:null}e.$So=c;function E(u){if(!u)return null;const m=u.majorBase,I=u.majorMustEqual,w=u.minorBase;let P=u.minorMustEqual;const s=u.patchBase;let o=u.patchMustEqual;u.hasCaret&&(m===0||(P=!1),o=!1);let t=0;if(u.preRelease){const n=v.exec(u.preRelease);if(n){const[,i,r,l]=n;t=Date.UTC(Number(i),Number(r)-1,Number(l))}}return{majorBase:m,majorMustEqual:I,minorBase:w,minorMustEqual:P,patchBase:s,patchMustEqual:o,isMinimum:u.hasGreaterEquals,notBefore:t}}e.$To=E;function R(u,m,I){let w;typeof u=="string"?w=E(c(u)):w=u;let P;m instanceof Date?P=m.getTime():typeof m=="string"&&(P=new Date(m).getTime());let s;if(typeof I=="string"?s=E(c(I)):s=I,!w||!s)return!1;const o=w.majorBase,t=w.minorBase,n=w.patchBase;let i=s.majorBase,r=s.minorBase,l=s.patchBase;const k=s.notBefore;let b=s.majorMustEqual,p=s.minorMustEqual,O=s.patchMustEqual;return s.isMinimum?o>i?!0:o<i?!1:t>r?!0:t<r||P&&P<k?!1:n>=l:(o===1&&i===0&&(!b||!p||!O)&&(i=1,r=0,l=0,b=!0,p=!1,O=!1),o<i?!1:o>i?!b:t<r?!1:t>r?!p:n<l?!1:n>l?!O:!(P&&P<k))}e.$Uo=R;function d(u,m,I,w,P){const s=[];if(typeof w.publisher<"u"&&typeof w.publisher!="string")return s.push([N.default.Error,D.localize(0,null)]),s;if(typeof w.name!="string")return s.push([N.default.Error,D.localize(1,null,"name")]),s;if(typeof w.version!="string")return s.push([N.default.Error,D.localize(2,null,"version")]),s;if(!w.engines)return s.push([N.default.Error,D.localize(3,null,"engines")]),s;if(typeof w.engines.vscode!="string")return s.push([N.default.Error,D.localize(4,null,"engines.vscode")]),s;if(typeof w.extensionDependencies<"u"&&!$(w.extensionDependencies))return s.push([N.default.Error,D.localize(5,null,"extensionDependencies")]),s;if(typeof w.activationEvents<"u"){if(!$(w.activationEvents))return s.push([N.default.Error,D.localize(6,null,"activationEvents")]),s;if(typeof w.main>"u"&&typeof w.browser>"u")return s.push([N.default.Error,D.localize(7,null,"activationEvents","main","browser")]),s}if(typeof w.extensionKind<"u"&&typeof w.main>"u"&&s.push([N.default.Warning,D.localize(8,null,"extensionKind")]),typeof w.main<"u"){if(typeof w.main!="string")return s.push([N.default.Error,D.localize(9,null,"main")]),s;{const n=(0,L.$zg)(I,w.main);(0,L.$tg)(n,I)||s.push([N.default.Warning,D.localize(10,null,n.path,I.path)])}}if(typeof w.browser<"u"){if(typeof w.browser!="string")return s.push([N.default.Error,D.localize(11,null,"browser")]),s;{const n=(0,L.$zg)(I,w.browser);(0,L.$tg)(n,I)||s.push([N.default.Warning,D.localize(12,null,n.path,I.path)])}}if(!A.valid(w.version))return s.push([N.default.Error,D.localize(13,null)]),s;const o=[];if(!f(u,m,w,P,o))for(const n of o)s.push([N.default.Error,n]);return s}e.$Vo=d;function f(u,m,I,w,P){return w||typeof I.main>"u"&&typeof I.browser>"u"?!0:y(u,m,I.engines.vscode,P)}e.$Wo=f;function S(u,m,I){return u==="*"||y(m,I,u)}e.$Xo=S;function y(u,m,I,w=[]){const P=E(c(I));if(!P)return w.push(D.localize(14,null,I)),!1;if(P.majorBase===0){if(!P.majorMustEqual||!P.minorMustEqual)return w.push(D.localize(15,null,I)),!1}else if(!P.majorMustEqual)return w.push(D.localize(16,null,I)),!1;return R(u,m,P)?!0:(w.push(D.localize(17,null,u,I)),!1)}function $(u){if(!Array.isArray(u))return!1;for(let m=0,I=u.length;m<I;m++)if(typeof u[m]!="string")return!1;return!0}}),define(te[113],ne([0,1,14,28]),function(J,e,L,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fp=void 0;async function D(A,j,v){let h=v&&v.get("storage.serviceMachineId",-1)||null;if(h)return h;try{const E=(await j.readFile(A.serviceMachineIdResource)).value.toString();h=(0,N.$hg)(E)?E:null}catch{h=null}if(!h){h=(0,N.$ig)();try{await j.writeFile(A.serviceMachineIdResource,L.$fe.fromString(h))}catch{}}return v?.store("storage.serviceMachineId",h,-1,1),h}e.$fp=D}),define(te[49],ne([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sh=void 0;class L{constructor(D,A=[],j=!1){this.ctor=D,this.staticArguments=A,this.supportsDelayedInstantiation=j}}e.$Sh=L}),define(te[114],ne([0,1,49]),function(J,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dr=e.$Cr=e.InstantiationType=void 0;const N=[];var D;(function(v){v[v.Eager=0]="Eager",v[v.Delayed=1]="Delayed"})(D||(e.InstantiationType=D={}));function A(v,h,c){h instanceof L.$Sh||(h=new L.$Sh(h,[],!!c)),N.push([v,h])}e.$Cr=A;function j(){return N}e.$Dr=j}),define(te[115],ne([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$iq=e.$hq=void 0;class L{constructor(A,j){this.key=A,this.data=j,this.incoming=new Map,this.outgoing=new Map}}e.$hq=L;class N{constructor(A){this.b=A,this.a=new Map}roots(){const A=[];for(const j of this.a.values())j.outgoing.size===0&&A.push(j);return A}insertEdge(A,j){const v=this.lookupOrInsertNode(A),h=this.lookupOrInsertNode(j);v.outgoing.set(h.key,h),h.incoming.set(v.key,v)}removeNode(A){const j=this.b(A);this.a.delete(j);for(const v of this.a.values())v.outgoing.delete(j),v.incoming.delete(j)}lookupOrInsertNode(A){const j=this.b(A);let v=this.a.get(j);return v||(v=new L(j,A),this.a.set(j,v)),v}lookup(A){return this.a.get(this.b(A))}isEmpty(){return this.a.size===0}toString(){const A=[];for(const[j,v]of this.a)A.push(`${j}
	(-> incoming)[${[...v.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...v.outgoing.keys()].join(",")}]
`);return A.join(`
`)}findCycleSlow(){for(const[A,j]of this.a){const v=new Set([A]),h=this.c(j,v);if(h)return h}}c(A,j){for(const[v,h]of A.outgoing){if(j.has(v))return[...j,v].join(" -> ");j.add(v);const c=this.c(h,j);if(c)return c;j.delete(v)}}}e.$iq=N}),define(te[25],ne([0,1,3,11,10]),function(J,e,L,N,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zi=e.$yi=e.$xi=e.$wi=e.$vi=e.$ui=e.$ti=e.$si=e.ConfigurationTarget=e.$ri=e.$qi=e.$pi=void 0,e.$pi=(0,D.$Vh)("configurationService");function A(u){return u&&typeof u=="object"&&(!u.overrideIdentifier||typeof u.overrideIdentifier=="string")&&(!u.resource||u.resource instanceof N.URI)}e.$qi=A;function j(u){return u&&typeof u=="object"&&(!u.overrideIdentifiers||Array.isArray(u.overrideIdentifiers))&&!u.overrideIdentifier&&(!u.resource||u.resource instanceof N.URI)}e.$ri=j;var v;(function(u){u[u.APPLICATION=1]="APPLICATION",u[u.USER=2]="USER",u[u.USER_LOCAL=3]="USER_LOCAL",u[u.USER_REMOTE=4]="USER_REMOTE",u[u.WORKSPACE=5]="WORKSPACE",u[u.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",u[u.DEFAULT=7]="DEFAULT",u[u.MEMORY=8]="MEMORY"})(v||(e.ConfigurationTarget=v={}));function h(u){switch(u){case 1:return"APPLICATION";case 2:return"USER";case 3:return"USER_LOCAL";case 4:return"USER_REMOTE";case 5:return"WORKSPACE";case 6:return"WORKSPACE_FOLDER";case 7:return"DEFAULT";case 8:return"MEMORY"}}e.$si=h;function c(u){return u.applicationValue!==void 0||u.userValue!==void 0||u.userLocalValue!==void 0||u.userRemoteValue!==void 0||u.workspaceValue!==void 0||u.workspaceFolderValue!==void 0}e.$ti=c;function E(u,m){const I=Object.create(null);for(const w in u)R(I,w,u[w],m);return I}e.$ui=E;function R(u,m,I,w){const P=m.split("."),s=P.pop();let o=u;for(let t=0;t<P.length;t++){const n=P[t];let i=o[n];switch(typeof i){case"undefined":i=o[n]=Object.create(null);break;case"object":break;default:w(`Ignoring ${m} as ${P.slice(0,t+1).join(".")} is ${JSON.stringify(i)}`);return}o=i}if(typeof o=="object"&&o!==null)try{o[s]=I}catch{w(`Ignoring ${m} as ${P.join(".")} is ${JSON.stringify(o)}`)}else w(`Ignoring ${m} as ${P.join(".")} is ${JSON.stringify(o)}`)}e.$vi=R;function d(u,m){const I=m.split(".");f(u,I)}e.$wi=d;function f(u,m){const I=m.shift();if(m.length===0){delete u[I];return}if(Object.keys(u).indexOf(I)!==-1){const w=u[I];typeof w=="object"&&!Array.isArray(w)&&(f(w,m),Object.keys(w).length===0&&delete u[I])}}function S(u,m,I){function w(o,t){let n=o;for(const i of t){if(typeof n!="object"||n===null)return;n=n[i]}return n}const P=m.split("."),s=w(u,P);return typeof s>"u"?I:s}e.$xi=S;function y(u,m,I){Object.keys(m).forEach(w=>{w!=="__proto__"&&(w in u?L.$Ef(u[w])&&L.$Ef(m[w])?y(u[w],m[w],I):I&&(u[w]=m[w]):u[w]=m[w])})}e.$yi=y;function $(u){return u.replace(/[\[\]]/g,"")}e.$zi=$}),define(te[116],ne([0,1,13,29,108,10,89,9]),function(J,e,L,N,D,A,j,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cj=e.$bj=e.$aj=e.$_i=e.$$i=e.$0i=e.$9i=e.$8i=e.$7i=e.$6i=e.$5i=e.$4i=e.$3i=e.$2i=e.$1i=e.$Zi=e.$Yi=e.$Xi=e.$Wi=e.$Vi=e.$Ui=e.$Ti=e.$Si=e.ContextKeyExprType=e.$Ri=void 0;const h=new Map;h.set("false",!1),h.set("true",!0),h.set("isMac",L.$j),h.set("isLinux",L.$k),h.set("isWindows",L.$i),h.set("isWeb",L.$o),h.set("isMacNative",L.$j&&!L.$o),h.set("isEdge",L.$H),h.set("isFirefox",L.$F),h.set("isChrome",L.$E),h.set("isSafari",L.$G);function c(F,a){if(h.get(F)!==void 0)throw(0,v.$6)("contextkey.setConstant(k, v) invoked with already set constant `k`");h.set(F,a)}e.$Ri=c;const E=Object.prototype.hasOwnProperty;var R;(function(F){F[F.False=0]="False",F[F.True=1]="True",F[F.Defined=2]="Defined",F[F.Not=3]="Not",F[F.Equals=4]="Equals",F[F.NotEquals=5]="NotEquals",F[F.And=6]="And",F[F.Regex=7]="Regex",F[F.NotRegex=8]="NotRegex",F[F.Or=9]="Or",F[F.In=10]="In",F[F.NotIn=11]="NotIn",F[F.Greater=12]="Greater",F[F.GreaterEquals=13]="GreaterEquals",F[F.Smaller=14]="Smaller",F[F.SmallerEquals=15]="SmallerEquals"})(R||(e.ContextKeyExprType=R={}));const d={regexParsingWithErrorRecovery:!0},f=(0,j.localize)(0,null),S=(0,j.localize)(1,null),y=(0,j.localize)(2,null),$=(0,j.localize)(3,null),u=(0,j.localize)(4,null),m=(0,j.localize)(5,null),I=(0,j.localize)(6,null),w=(0,j.localize)(7,null);class P{static{this.c=new Error}get lexingErrors(){return this.d.errors}get parsingErrors(){return this.h}constructor(a=d){this.k=a,this.d=new D.$Qi,this.f=[],this.g=0,this.h=[],this.v=/g|y/g}parse(a){if(a===""){this.h.push({message:f,offset:0,lexeme:"",additionalInfo:S});return}this.f=this.d.reset(a).scan(),this.g=0,this.h=[];try{const g=this.l();if(!this.E()){const z=this.D(),M=z.type===17?m:void 0;throw this.h.push({message:u,offset:z.offset,lexeme:D.$Qi.getLexeme(z),additionalInfo:M}),P.c}return g}catch(g){if(g!==P.c)throw g;return}}l(){return this.m()}m(){const a=[this.o()];for(;this.y(16);){const g=this.o();a.push(g)}return a.length===1?a[0]:s.or(...a)}o(){const a=[this.s()];for(;this.y(15);){const g=this.s();a.push(g)}return a.length===1?a[0]:s.and(...a)}s(){if(this.y(2)){const a=this.D();switch(a.type){case 11:return this.z(),i.INSTANCE;case 12:return this.z(),r.INSTANCE;case 0:{this.z();const g=this.l();return this.A(1,$),g?.negate()}case 17:return this.z(),B.create(a.lexeme);default:throw this.B("KEY | true | false | '(' expression ')'",a)}}return this.t()}t(){const a=this.D();switch(a.type){case 11:return this.z(),s.true();case 12:return this.z(),s.false();case 0:{this.z();const g=this.l();return this.A(1,$),g}case 17:{const g=a.lexeme;if(this.z(),this.y(9)){const M=this.D();if(!this.k.regexParsingWithErrorRecovery){if(this.z(),M.type!==10)throw this.B("REGEX",M);const X=M.lexeme,W=X.lastIndexOf("/"),le=W===X.length-1?void 0:this.w(X.substring(W+1));let ae;try{ae=new RegExp(X.substring(1,W),le)}catch{throw this.B("REGEX",M)}return ce.create(g,ae)}switch(M.type){case 10:case 19:{const X=[M.lexeme];this.z();let W=this.D(),le=0;for(let fe=0;fe<M.lexeme.length;fe++)M.lexeme.charCodeAt(fe)===40?le++:M.lexeme.charCodeAt(fe)===41&&le--;for(;!this.E()&&W.type!==15&&W.type!==16;){switch(W.type){case 0:le++;break;case 1:le--;break;case 10:case 18:for(let fe=0;fe<W.lexeme.length;fe++)W.lexeme.charCodeAt(fe)===40?le++:M.lexeme.charCodeAt(fe)===41&&le--}if(le<0)break;X.push(D.$Qi.getLexeme(W)),this.z(),W=this.D()}const ae=X.join(""),me=ae.lastIndexOf("/"),de=me===ae.length-1?void 0:this.w(ae.substring(me+1));let ge;try{ge=new RegExp(ae.substring(1,me),de)}catch{throw this.B("REGEX",M)}return s.regex(g,ge)}case 18:{const X=M.lexeme;this.z();let W=null;if(!(0,N.$Fe)(X)){const le=X.indexOf("/"),ae=X.lastIndexOf("/");if(le!==ae&&le>=0){const me=X.slice(le+1,ae),de=X[ae+1]==="i"?"i":"";try{W=new RegExp(me,de)}catch{throw this.B("REGEX",M)}}}if(W===null)throw this.B("REGEX",M);return ce.create(g,W)}default:throw this.B("REGEX",this.D())}}if(this.y(14)){this.A(13,y);const M=this.u();return s.notIn(g,M)}switch(this.D().type){case 3:{this.z();const M=this.u();if(this.x().type===18)return s.equals(g,M);switch(M){case"true":return s.has(g);case"false":return s.not(g);default:return s.equals(g,M)}}case 4:{this.z();const M=this.u();if(this.x().type===18)return s.notEquals(g,M);switch(M){case"true":return s.not(g);case"false":return s.has(g);default:return s.notEquals(g,M)}}case 5:return this.z(),se.create(g,this.u());case 6:return this.z(),ue.create(g,this.u());case 7:return this.z(),ee.create(g,this.u());case 8:return this.z(),oe.create(g,this.u());case 13:return this.z(),s.in(g,this.u());default:return s.has(g)}}case 20:throw this.h.push({message:I,offset:a.offset,lexeme:"",additionalInfo:w}),P.c;default:throw this.B(`true | false | KEY 
	| KEY '=~' REGEX 
	| KEY ('==' | '!=' | '<' | '<=' | '>' | '>=' | 'in' | 'not' 'in') value`,this.D())}}u(){const a=this.D();switch(a.type){case 17:case 18:return this.z(),a.lexeme;case 11:return this.z(),"true";case 12:return this.z(),"false";case 13:return this.z(),"in";default:return""}}w(a){return a.replaceAll(this.v,"")}x(){return this.f[this.g-1]}y(a){return this.C(a)?(this.z(),!0):!1}z(){return this.E()||this.g++,this.x()}A(a,g){if(this.C(a))return this.z();throw this.B(g,this.D())}B(a,g,z){const M=(0,j.localize)(8,null,a,D.$Qi.getLexeme(g)),X=g.offset,W=D.$Qi.getLexeme(g);return this.h.push({message:M,offset:X,lexeme:W,additionalInfo:z}),P.c}C(a){return this.D().type===a}D(){return this.f[this.g]}E(){return this.D().type===20}}e.$Si=P;class s{static false(){return i.INSTANCE}static true(){return r.INSTANCE}static has(a){return l.create(a)}static equals(a,g){return k.create(a,g)}static notEquals(a,g){return O.create(a,g)}static regex(a,g){return ce.create(a,g)}static in(a,g){return b.create(a,g)}static notIn(a,g){return p.create(a,g)}static not(a){return B.create(a)}static and(...a){return Q.create(a,null,!0)}static or(...a){return T.create(a,null,!0)}static greater(a,g){return ee.create(a,g)}static greaterEquals(a,g){return oe.create(a,g)}static smaller(a,g){return se.create(a,g)}static smallerEquals(a,g){return ue.create(a,g)}static{this.c=new P({regexParsingWithErrorRecovery:!1})}static deserialize(a){return a==null?void 0:this.c.parse(a)}}e.$Ti=s;function o(F){const a=new P({regexParsingWithErrorRecovery:!1});return F.map(g=>(a.parse(g),a.lexingErrors.length>0?a.lexingErrors.map(z=>({errorMessage:z.additionalInfo?(0,j.localize)(9,null,z.additionalInfo):(0,j.localize)(10,null),offset:z.offset,length:z.lexeme.length})):a.parsingErrors.length>0?a.parsingErrors.map(z=>({errorMessage:z.additionalInfo?`${z.message}. ${z.additionalInfo}`:z.message,offset:z.offset,length:z.lexeme.length})):[]))}e.$Ui=o;function t(F,a){const g=F?F.substituteConstants():void 0,z=a?a.substituteConstants():void 0;return!g&&!z?!0:!g||!z?!1:g.equals(z)}e.$Vi=t;function n(F,a){return F.cmp(a)}class i{static{this.INSTANCE=new i}constructor(){this.type=0}cmp(a){return this.type-a.type}equals(a){return a.type===this.type}substituteConstants(){return this}evaluate(a){return!1}serialize(){return"false"}keys(){return[]}map(a){return this}negate(){return r.INSTANCE}}e.$Wi=i;class r{static{this.INSTANCE=new r}constructor(){this.type=1}cmp(a){return this.type-a.type}equals(a){return a.type===this.type}substituteConstants(){return this}evaluate(a){return!0}serialize(){return"true"}keys(){return[]}map(a){return this}negate(){return i.INSTANCE}}e.$Xi=r;class l{static create(a,g=null){const z=h.get(a);return typeof z=="boolean"?z?r.INSTANCE:i.INSTANCE:new l(a,g)}constructor(a,g){this.key=a,this.c=g,this.type=2}cmp(a){return a.type!==this.type?this.type-a.type:H(this.key,a.key)}equals(a){return a.type===this.type?this.key===a.key:!1}substituteConstants(){const a=h.get(this.key);return typeof a=="boolean"?a?r.INSTANCE:i.INSTANCE:this}evaluate(a){return!!a.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(a){return a.mapDefined(this.key)}negate(){return this.c||(this.c=B.create(this.key,this)),this.c}}e.$Yi=l;class k{static create(a,g,z=null){if(typeof g=="boolean")return g?l.create(a,z):B.create(a,z);const M=h.get(a);return typeof M=="boolean"?g===(M?"true":"false")?r.INSTANCE:i.INSTANCE:new k(a,g,z)}constructor(a,g,z){this.c=a,this.d=g,this.f=z,this.type=4}cmp(a){return a.type!==this.type?this.type-a.type:G(this.c,this.d,a.c,a.d)}equals(a){return a.type===this.type?this.c===a.c&&this.d===a.d:!1}substituteConstants(){const a=h.get(this.c);if(typeof a=="boolean"){const g=a?"true":"false";return this.d===g?r.INSTANCE:i.INSTANCE}return this}evaluate(a){return a.getValue(this.c)==this.d}serialize(){return`${this.c} == '${this.d}'`}keys(){return[this.c]}map(a){return a.mapEquals(this.c,this.d)}negate(){return this.f||(this.f=O.create(this.c,this.d,this)),this.f}}e.$Zi=k;class b{static create(a,g){return new b(a,g)}constructor(a,g){this.d=a,this.f=g,this.type=10,this.c=null}cmp(a){return a.type!==this.type?this.type-a.type:G(this.d,this.f,a.d,a.f)}equals(a){return a.type===this.type?this.d===a.d&&this.f===a.f:!1}substituteConstants(){return this}evaluate(a){const g=a.getValue(this.f),z=a.getValue(this.d);return Array.isArray(g)?g.includes(z):typeof z=="string"&&typeof g=="object"&&g!==null?E.call(g,z):!1}serialize(){return`${this.d} in '${this.f}'`}keys(){return[this.d,this.f]}map(a){return a.mapIn(this.d,this.f)}negate(){return this.c||(this.c=p.create(this.d,this.f)),this.c}}e.$1i=b;class p{static create(a,g){return new p(a,g)}constructor(a,g){this.d=a,this.f=g,this.type=11,this.c=b.create(a,g)}cmp(a){return a.type!==this.type?this.type-a.type:this.c.cmp(a.c)}equals(a){return a.type===this.type?this.c.equals(a.c):!1}substituteConstants(){return this}evaluate(a){return!this.c.evaluate(a)}serialize(){return`${this.d} not in '${this.f}'`}keys(){return this.c.keys()}map(a){return a.mapNotIn(this.d,this.f)}negate(){return this.c}}e.$2i=p;class O{static create(a,g,z=null){if(typeof g=="boolean")return g?B.create(a,z):l.create(a,z);const M=h.get(a);return typeof M=="boolean"?g===(M?"true":"false")?i.INSTANCE:r.INSTANCE:new O(a,g,z)}constructor(a,g,z){this.c=a,this.d=g,this.f=z,this.type=5}cmp(a){return a.type!==this.type?this.type-a.type:G(this.c,this.d,a.c,a.d)}equals(a){return a.type===this.type?this.c===a.c&&this.d===a.d:!1}substituteConstants(){const a=h.get(this.c);if(typeof a=="boolean"){const g=a?"true":"false";return this.d===g?i.INSTANCE:r.INSTANCE}return this}evaluate(a){return a.getValue(this.c)!=this.d}serialize(){return`${this.c} != '${this.d}'`}keys(){return[this.c]}map(a){return a.mapNotEquals(this.c,this.d)}negate(){return this.f||(this.f=k.create(this.c,this.d,this)),this.f}}e.$3i=O;class B{static create(a,g=null){const z=h.get(a);return typeof z=="boolean"?z?i.INSTANCE:r.INSTANCE:new B(a,g)}constructor(a,g){this.c=a,this.d=g,this.type=3}cmp(a){return a.type!==this.type?this.type-a.type:H(this.c,a.c)}equals(a){return a.type===this.type?this.c===a.c:!1}substituteConstants(){const a=h.get(this.c);return typeof a=="boolean"?a?i.INSTANCE:r.INSTANCE:this}evaluate(a){return!a.getValue(this.c)}serialize(){return`!${this.c}`}keys(){return[this.c]}map(a){return a.mapNot(this.c)}negate(){return this.d||(this.d=l.create(this.c,this)),this.d}}e.$4i=B;function _(F,a){if(typeof F=="string"){const g=parseFloat(F);isNaN(g)||(F=g)}return typeof F=="string"||typeof F=="number"?a(F):i.INSTANCE}class ee{static create(a,g,z=null){return _(g,M=>new ee(a,M,z))}constructor(a,g,z){this.c=a,this.d=g,this.f=z,this.type=12}cmp(a){return a.type!==this.type?this.type-a.type:G(this.c,this.d,a.c,a.d)}equals(a){return a.type===this.type?this.c===a.c&&this.d===a.d:!1}substituteConstants(){return this}evaluate(a){return typeof this.d=="string"?!1:parseFloat(a.getValue(this.c))>this.d}serialize(){return`${this.c} > ${this.d}`}keys(){return[this.c]}map(a){return a.mapGreater(this.c,this.d)}negate(){return this.f||(this.f=ue.create(this.c,this.d,this)),this.f}}e.$5i=ee;class oe{static create(a,g,z=null){return _(g,M=>new oe(a,M,z))}constructor(a,g,z){this.c=a,this.d=g,this.f=z,this.type=13}cmp(a){return a.type!==this.type?this.type-a.type:G(this.c,this.d,a.c,a.d)}equals(a){return a.type===this.type?this.c===a.c&&this.d===a.d:!1}substituteConstants(){return this}evaluate(a){return typeof this.d=="string"?!1:parseFloat(a.getValue(this.c))>=this.d}serialize(){return`${this.c} >= ${this.d}`}keys(){return[this.c]}map(a){return a.mapGreaterEquals(this.c,this.d)}negate(){return this.f||(this.f=se.create(this.c,this.d,this)),this.f}}e.$6i=oe;class se{static create(a,g,z=null){return _(g,M=>new se(a,M,z))}constructor(a,g,z){this.c=a,this.d=g,this.f=z,this.type=14}cmp(a){return a.type!==this.type?this.type-a.type:G(this.c,this.d,a.c,a.d)}equals(a){return a.type===this.type?this.c===a.c&&this.d===a.d:!1}substituteConstants(){return this}evaluate(a){return typeof this.d=="string"?!1:parseFloat(a.getValue(this.c))<this.d}serialize(){return`${this.c} < ${this.d}`}keys(){return[this.c]}map(a){return a.mapSmaller(this.c,this.d)}negate(){return this.f||(this.f=oe.create(this.c,this.d,this)),this.f}}e.$7i=se;class ue{static create(a,g,z=null){return _(g,M=>new ue(a,M,z))}constructor(a,g,z){this.c=a,this.d=g,this.f=z,this.type=15}cmp(a){return a.type!==this.type?this.type-a.type:G(this.c,this.d,a.c,a.d)}equals(a){return a.type===this.type?this.c===a.c&&this.d===a.d:!1}substituteConstants(){return this}evaluate(a){return typeof this.d=="string"?!1:parseFloat(a.getValue(this.c))<=this.d}serialize(){return`${this.c} <= ${this.d}`}keys(){return[this.c]}map(a){return a.mapSmallerEquals(this.c,this.d)}negate(){return this.f||(this.f=ee.create(this.c,this.d,this)),this.f}}e.$8i=ue;class ce{static create(a,g){return new ce(a,g)}constructor(a,g){this.d=a,this.f=g,this.type=7,this.c=null}cmp(a){if(a.type!==this.type)return this.type-a.type;if(this.d<a.d)return-1;if(this.d>a.d)return 1;const g=this.f?this.f.source:"",z=a.f?a.f.source:"";return g<z?-1:g>z?1:0}equals(a){if(a.type===this.type){const g=this.f?this.f.source:"",z=a.f?a.f.source:"";return this.d===a.d&&g===z}return!1}substituteConstants(){return this}evaluate(a){const g=a.getValue(this.d);return this.f?this.f.test(g):!1}serialize(){const a=this.f?`/${this.f.source}/${this.f.flags}`:"/invalid/";return`${this.d} =~ ${a}`}keys(){return[this.d]}map(a){return a.mapRegex(this.d,this.f)}negate(){return this.c||(this.c=re.create(this)),this.c}}e.$9i=ce;class re{static create(a){return new re(a)}constructor(a){this.c=a,this.type=8}cmp(a){return a.type!==this.type?this.type-a.type:this.c.cmp(a.c)}equals(a){return a.type===this.type?this.c.equals(a.c):!1}substituteConstants(){return this}evaluate(a){return!this.c.evaluate(a)}serialize(){return`!(${this.c.serialize()})`}keys(){return this.c.keys()}map(a){return new re(this.c.map(a))}negate(){return this.c}}e.$0i=re;function q(F){let a=null;for(let g=0,z=F.length;g<z;g++){const M=F[g].substituteConstants();if(F[g]!==M&&a===null){a=[];for(let X=0;X<g;X++)a[X]=F[X]}a!==null&&(a[g]=M)}return a===null?F:a}class Q{static create(a,g,z){return Q.d(a,g,z)}constructor(a,g){this.expr=a,this.c=g,this.type=6}cmp(a){if(a.type!==this.type)return this.type-a.type;if(this.expr.length<a.expr.length)return-1;if(this.expr.length>a.expr.length)return 1;for(let g=0,z=this.expr.length;g<z;g++){const M=n(this.expr[g],a.expr[g]);if(M!==0)return M}return 0}equals(a){if(a.type===this.type){if(this.expr.length!==a.expr.length)return!1;for(let g=0,z=this.expr.length;g<z;g++)if(!this.expr[g].equals(a.expr[g]))return!1;return!0}return!1}substituteConstants(){const a=q(this.expr);return a===this.expr?this:Q.create(a,this.c,!1)}evaluate(a){for(let g=0,z=this.expr.length;g<z;g++)if(!this.expr[g].evaluate(a))return!1;return!0}static d(a,g,z){const M=[];let X=!1;for(const W of a)if(W){if(W.type===1){X=!0;continue}if(W.type===0)return i.INSTANCE;if(W.type===6){M.push(...W.expr);continue}M.push(W)}if(M.length===0&&X)return r.INSTANCE;if(M.length!==0){if(M.length===1)return M[0];M.sort(n);for(let W=1;W<M.length;W++)M[W-1].equals(M[W])&&(M.splice(W,1),W--);if(M.length===1)return M[0];for(;M.length>1;){const W=M[M.length-1];if(W.type!==9)break;M.pop();const le=M.pop(),ae=M.length===0,me=T.create(W.expr.map(de=>Q.create([de,le],null,z)),null,ae);me&&(M.push(me),M.sort(n))}if(M.length===1)return M[0];if(z){for(let W=0;W<M.length;W++)for(let le=W+1;le<M.length;le++)if(M[W].negate().equals(M[le]))return i.INSTANCE;if(M.length===1)return M[0]}return new Q(M,g)}}serialize(){return this.expr.map(a=>a.serialize()).join(" && ")}keys(){const a=[];for(const g of this.expr)a.push(...g.keys());return a}map(a){return new Q(this.expr.map(g=>g.map(a)),null)}negate(){if(!this.c){const a=[];for(const g of this.expr)a.push(g.negate());this.c=T.create(a,this,!0)}return this.c}}e.$$i=Q;class T{static create(a,g,z){return T.d(a,g,z)}constructor(a,g){this.expr=a,this.c=g,this.type=9}cmp(a){if(a.type!==this.type)return this.type-a.type;if(this.expr.length<a.expr.length)return-1;if(this.expr.length>a.expr.length)return 1;for(let g=0,z=this.expr.length;g<z;g++){const M=n(this.expr[g],a.expr[g]);if(M!==0)return M}return 0}equals(a){if(a.type===this.type){if(this.expr.length!==a.expr.length)return!1;for(let g=0,z=this.expr.length;g<z;g++)if(!this.expr[g].equals(a.expr[g]))return!1;return!0}return!1}substituteConstants(){const a=q(this.expr);return a===this.expr?this:T.create(a,this.c,!1)}evaluate(a){for(let g=0,z=this.expr.length;g<z;g++)if(this.expr[g].evaluate(a))return!0;return!1}static d(a,g,z){let M=[],X=!1;if(a){for(let W=0,le=a.length;W<le;W++){const ae=a[W];if(ae){if(ae.type===0){X=!0;continue}if(ae.type===1)return r.INSTANCE;if(ae.type===9){M=M.concat(ae.expr);continue}M.push(ae)}}if(M.length===0&&X)return i.INSTANCE;M.sort(n)}if(M.length!==0){if(M.length===1)return M[0];for(let W=1;W<M.length;W++)M[W-1].equals(M[W])&&(M.splice(W,1),W--);if(M.length===1)return M[0];if(z){for(let W=0;W<M.length;W++)for(let le=W+1;le<M.length;le++)if(M[W].negate().equals(M[le]))return r.INSTANCE;if(M.length===1)return M[0]}return new T(M,g)}}serialize(){return this.expr.map(a=>a.serialize()).join(" || ")}keys(){const a=[];for(const g of this.expr)a.push(...g.keys());return a}map(a){return new T(this.expr.map(g=>g.map(a)),null)}negate(){if(!this.c){const a=[];for(const g of this.expr)a.push(g.negate());for(;a.length>1;){const g=a.shift(),z=a.shift(),M=[];for(const X of C(g))for(const W of C(z))M.push(Q.create([X,W],null,!1));a.unshift(T.create(M,null,!1))}this.c=T.create(a,this,!0)}return this.c}}e.$_i=T;class U extends l{static{this.d=[]}static all(){return U.d.values()}constructor(a,g,z){super(a,null),this.f=g,typeof z=="object"?U.d.push({...z,key:a}):z!==!0&&U.d.push({key:a,description:z,type:g!=null?typeof g:void 0})}bindTo(a){return a.createKey(this.key,this.f)}getValue(a){return a.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(a){return k.create(this.key,a)}notEqualsTo(a){return O.create(this.key,a)}}e.$aj=U,e.$bj=(0,A.$Vh)("contextKeyService");function H(F,a){return F<a?-1:F>a?1:0}function G(F,a,g,z){return F<g?-1:F>g?1:a<z?-1:a>z?1:0}function Z(F,a){if(F.type===0||a.type===1)return!0;if(F.type===9)return a.type===9?Y(F.expr,a.expr):!1;if(a.type===9){for(const g of a.expr)if(Z(F,g))return!0;return!1}if(F.type===6){if(a.type===6)return Y(a.expr,F.expr);for(const g of F.expr)if(Z(g,a))return!0;return!1}return F.equals(a)}e.$cj=Z;function Y(F,a){let g=0,z=0;for(;g<F.length&&z<a.length;){const M=F[g].cmp(a[z]);if(M<0)return!1;M===0&&g++,z++}return g===F.length}function C(F){return F.type===9?F.expr:[F]}}),define(te[59],ne([0,1,10]),function(J,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Un=void 0,e.$Un=(0,L.$Vh)("downloadService")}),define(te[18],ne([0,1,10]),function(J,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4h=e.$3h=void 0,e.$3h=(0,L.$Vh)("environmentService"),e.$4h=(0,L.$Wh)(e.$3h)}),define(te[21],ne([0,1,92,10]),function(J,e,L,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mo=e.$lo=e.$ko=e.$jo=e.$io=e.$ho=e.$go=e.$fo=e.$eo=e.ExtensionSignaturetErrorCode=e.ExtensionManagementErrorCode=e.$do=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.$co=e.$bo=e.$ao=e.$_n=e.$$n=e.$0n=e.$9n=e.$8n=e.$7n=e.$6n=e.$5n=e.$4n=void 0,e.$4n="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.$5n=new RegExp(e.$4n),e.$6n="__web_extension",e.$7n="skipWalkthrough",e.$8n="extensionsSync",e.$9n="dependecyOrPackExtensionInstall";function D(u){switch(u){case"win32-x64":return"Windows 64 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.$0n=D;function A(u){switch(u){case"win32-x64":return"win32-x64";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.$$n=A;function j(u,m){switch(u){case 3:return m==="x64"?"win32-x64":m==="arm64"?"win32-arm64":"unknown";case 2:return m==="x64"?"linux-x64":m==="arm64"?"linux-arm64":m==="arm"?"linux-armhf":"unknown";case"alpine":return m==="x64"?"alpine-x64":m==="arm64"?"alpine-arm64":"unknown";case 1:return m==="x64"?"darwin-x64":m==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.$_n=j;function v(u,m){return m==="web"&&!u.includes("web")}e.$ao=v;function h(u,m,I){return v(m,I)?!1:u==="undefined"||u==="universal"?!0:u==="unknown"?!1:u===I}e.$bo=h;function c(u){return u&&typeof u=="object"&&typeof u.id=="string"&&(!u.uuid||typeof u.uuid=="string")}e.$co=c;var E;(function(u){u[u.NoneOrRelevance=0]="NoneOrRelevance",u[u.LastUpdatedDate=1]="LastUpdatedDate",u[u.Title=2]="Title",u[u.PublisherName=3]="PublisherName",u[u.InstallCount=4]="InstallCount",u[u.PublishedDate=10]="PublishedDate",u[u.AverageRating=6]="AverageRating",u[u.WeightedRating=12]="WeightedRating"})(E||(e.SortBy=E={}));var R;(function(u){u[u.Default=0]="Default",u[u.Ascending=1]="Ascending",u[u.Descending=2]="Descending"})(R||(e.SortOrder=R={}));var d;(function(u){u.Install="install",u.Uninstall="uninstall"})(d||(e.StatisticType=d={}));var f;(function(u){u[u.None=1]="None",u[u.Install=2]="Install",u[u.Update=3]="Update",u[u.Migrate=4]="Migrate"})(f||(e.InstallOperation=f={})),e.$do=(0,N.$Vh)("extensionGalleryService");var S;(function(u){u.Unsupported="Unsupported",u.Deprecated="Deprecated",u.Malicious="Malicious",u.Incompatible="Incompatible",u.IncompatibleTargetPlatform="IncompatibleTargetPlatform",u.ReleaseVersionNotFound="ReleaseVersionNotFound",u.Invalid="Invalid",u.Download="Download",u.Extract="Extract",u.Delete="Delete",u.Rename="Rename",u.CorruptZip="CorruptZip",u.IncompleteZip="IncompleteZip",u.Signature="Signature",u.Internal="Internal"})(S||(e.ExtensionManagementErrorCode=S={}));var y;(function(u){u.UnknownError="UnknownError",u.PackageIsInvalidZip="PackageIsInvalidZip",u.SignatureArchiveIsInvalidZip="SignatureArchiveIsInvalidZip"})(y||(e.ExtensionSignaturetErrorCode=y={}));class $ extends Error{constructor(m,I){super(m),this.code=I,this.name=I}}e.$eo=$,e.$fo=(0,N.$Vh)("extensionManagementService"),e.$go="extensionsIdentifiers/disabled",e.$ho="extensionsIdentifiers/enabled",e.$io=(0,N.$Vh)("IGlobalExtensionEnablementService"),e.$jo=(0,N.$Vh)("IExtensionTipsService"),e.$ko=(0,L.localize)(0,null),e.$lo={value:e.$ko,original:"Extensions"},e.$mo={value:(0,L.localize)(1,null),original:"Preferences"}}),define(te[60],ne([0,1,10]),function(J,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lp=e.$kp=void 0,e.$kp=(0,L.$Vh)("IExtensionSignatureVerificationService");class N{b(){return this.a||(this.a=new Promise((A,j)=>J(["node-vsce-sign"],async v=>A(v),j))),this.a}async verify(A,j,v){let h;try{h=await this.b()}catch{return!1}return h.verify(A,j,v)}}e.$lp=N}),define(te[61],ne([0,1,14,9,100,12]),function(J,e,L,N,D,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sp=void 0;async function j(E,R,d,f,S,y){let $;try{await v(E,R,d,f,S,y)}catch(u){$=u}finally{$&&S.errorTransformer&&($=S.errorTransformer($)),typeof $<"u"&&d.error($),d.end()}}e.$Sp=j;async function v(E,R,d,f,S,y){h(y);const $=await E.open(R,{create:!1});try{h(y);let u=0,m=0,I=S&&typeof S.length=="number"?S.length:void 0,w=L.$fe.alloc(Math.min(S.bufferSize,typeof I=="number"?I:S.bufferSize)),P=S&&typeof S.position=="number"?S.position:0,s=0;do m=await E.read($,P,w.buffer,s,w.byteLength-s),P+=m,s+=m,u+=m,typeof I=="number"&&(I-=m),s===w.byteLength&&(await d.write(f(w)),w=L.$fe.alloc(Math.min(S.bufferSize,typeof I=="number"?I:S.bufferSize)),s=0);while(m>0&&(typeof I!="number"||I>0)&&h(y)&&c(u,S));if(s>0){let o=s;typeof I=="number"&&(o=Math.min(s,I)),d.write(f(w.slice(0,o)))}}catch(u){throw(0,A.$sk)(u)}finally{await E.close($)}}function h(E){if(E.isCancellationRequested)throw(0,N.$5)();return!0}function c(E,R){if(typeof R?.limits?.size=="number"&&E>R.limits.size)throw(0,A.$rk)((0,D.localize)(0,null),A.FileSystemProviderErrorCode.FileTooLarge);return!0}}),define(te[117],ne([0,1,4,166,2,13,167]),function(J,e,L,N,D,A,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$eq=void 0;class v extends D.$Rc{constructor(){super(...arguments),this.a=this.B(new L.$Rd),this.onDidChangeFile=this.a.event,this.b=this.B(new L.$Rd),this.onDidLogMessage=this.b.event,this.onDidError=L.Event.None,this.c=new Map,this.f=!1}async watch(c){const E=this.j(c),R=E.filter(f=>{const S=this.c.get(f.path);return S?!(0,N.$Gj)(S.request.excludes,f.excludes)||!(0,N.$Gj)(S.request.includes,f.includes):!0}),d=Array.from(this.c.values()).filter(({request:f})=>!E.find(S=>S.path===f.path&&(0,N.$Gj)(S.excludes,f.excludes)&&(0,N.$Gj)(S.includes,f.includes))).map(({request:f})=>f.path);R.length&&this.m(`Request to start watching: ${R.map(f=>`${f.path} (excludes: ${f.excludes.length>0?f.excludes:"<none>"}, includes: ${f.includes&&f.includes.length>0?JSON.stringify(f.includes):"<all>"}, correlationId: ${typeof f.correlationId=="number"?f.correlationId:"<none>"})`).join(",")}`),d.length&&this.m(`Request to stop watching: ${d.join(",")}`);for(const f of d)this.h(f);for(const f of R)this.g(f)}g(c){const E=new j.$cq(c,d=>this.a.fire(d),d=>this.b.fire(d),this.f),R={request:c,instance:E};this.c.set(c.path,R)}async stop(){for(const[c]of this.c)this.h(c);this.c.clear()}h(c){const E=this.c.get(c);E&&(this.c.delete(c),E.instance.dispose())}j(c){const E=new Map;for(const R of c){const d=A.$k?R.path:R.path.toLowerCase();let f=E.get(R.correlationId);f||(f=new Map,E.set(R.correlationId,f)),f.set(d,R)}return Array.from(E.values()).map(R=>Array.from(R.values())).flat()}async setVerboseLogging(c){this.f=c;for(const[,E]of this.c)E.instance.setVerboseLogging(c)}m(c){this.f&&this.b.fire({type:"trace",message:this.n(c)})}n(c,E){return E?`[File Watcher (node.js)] ${c} (path: ${E.request.path})`:`[File Watcher (node.js)] ${c}`}}e.$eq=v}),define(te[118],ne([0,1,62,117]),function(J,e,L,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fq=void 0;class D extends L.$Wp{constructor(j,v,h){super(j,v,h),this.s()}r(j){return j.add(new N.$eq)}}e.$fq=D}),define(te[119],ne([0,1,15,57,85,62]),function(J,e,L,N,D,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0p=void 0;class j extends A.$Xp{constructor(h,c,E){super(h,c,E),this.s()}r(h){const c=h.add(new D.$9p(L.$gg.asFileUri("bootstrap-fork").fsPath,{serverName:"File Watcher",args:["--type=fileWatcher"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/watcherMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));return h.add(c.onDidProcessExit(({code:E,signal:R})=>this.t(`terminated by itself with code ${E}, signal: ${R}`))),N.ProxyChannel.toService((0,N.$Ch)(c.getChannel("watcher")))}}e.$0p=j}),define(te[63],ne([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Th=void 0;class L{constructor(...D){this.a=new Map;for(const[A,j]of D)this.set(A,j)}set(D,A){const j=this.a.get(D);return this.a.set(D,A),j}has(D){return this.a.has(D)}get(D){return this.a.get(D)}}e.$Th=L}),define(te[120],ne([0,1,8,9,2,49,115,10,63,168]),function(J,e,L,N,D,A,j,v,h,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kq=e.$jq=void 0;const E=!1;class R extends Error{constructor($){super("cyclic dependency between services"),this.message=$.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${$.toString()}`}}class d{constructor($=new h.$Th,u=!1,m,I=E){this.f=$,this.g=u,this.h=m,this.i=I,this.o=new Set,this.f.set(v.$Uh,this),this._globalGraph=I?m?._globalGraph??new j.$iq(w=>w):void 0}createChild($){return new d($,this.g,this,this.i)}invokeFunction($,...u){const m=S.traceInvocation(this.i,$);let I=!1;try{return $({get:P=>{if(I)throw(0,N.$7)("service accessor is only valid during the invocation of its target method");const s=this.m(P,m);if(!s)throw new Error(`[invokeFunction] unknown service '${P}'`);return s}},...u)}finally{I=!0,m.stop()}}createInstance($,...u){let m,I;return $ instanceof A.$Sh?(m=S.traceCreation(this.i,$.ctor),I=this.j($.ctor,$.staticArguments.concat(u),m)):(m=S.traceCreation(this.i,$),I=this.j($,u,m)),m.stop(),I}j($,u=[],m){const I=v._util.getServiceDependencies($).sort((s,o)=>s.index-o.index),w=[];for(const s of I){const o=this.m(s.id,m);o||this.u(`[createInstance] ${$.name} depends on UNKNOWN service ${s.id}.`,!1),w.push(o)}const P=I.length>0?I[0].index:u.length;if(u.length!==P){console.trace(`[createInstance] First service dependency of ${$.name} at position ${P+1} conflicts with ${u.length} static arguments`);const s=P-u.length;s>0?u=u.concat(new Array(s)):u=u.slice(0,P)}return Reflect.construct($,u.concat(w))}k($,u){if(this.f.get($)instanceof A.$Sh)this.f.set($,u);else if(this.h)this.h.k($,u);else throw new Error("illegalState - setting UNKNOWN service instance")}l($){const u=this.f.get($);return!u&&this.h?this.h.l($):u}m($,u){this._globalGraph&&this.c&&this._globalGraph.insertEdge(this.c,String($));const m=this.l($);return m instanceof A.$Sh?this.q($,m,u.branch($,!0)):(u.branch($,!1),m)}q($,u,m){if(this.o.has($))throw new Error(`illegal state - RECURSIVELY instantiating service '${$}'`);this.o.add($);try{return this.r($,u,m)}finally{this.o.delete($)}}r($,u,m){const I=new j.$iq(s=>s.id.toString());let w=0;const P=[{id:$,desc:u,_trace:m}];for(;P.length;){const s=P.pop();if(I.lookupOrInsertNode(s),w++>1e3)throw new R(I);for(const o of v._util.getServiceDependencies(s.desc.ctor)){const t=this.l(o.id);if(t||this.u(`[createInstance] ${$} depends on ${o.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(s.id),String(o.id)),t instanceof A.$Sh){const n={id:o.id,desc:t,_trace:s._trace.branch(o.id,!0)};I.insertEdge(s,n),P.push(n)}}}for(;;){const s=I.roots();if(s.length===0){if(!I.isEmpty())throw new R(I);break}for(const{data:o}of s){if(this.l(o.id)instanceof A.$Sh){const n=this.s(o.id,o.desc.ctor,o.desc.staticArguments,o.desc.supportsDelayedInstantiation,o._trace);this.k(o.id,n)}I.removeNode(o)}}return this.l($)}s($,u,m=[],I,w){if(this.f.get($)instanceof A.$Sh)return this.t($,u,m,I,w);if(this.h)return this.h.s($,u,m,I,w);throw new Error(`illegalState - creating UNKNOWN service instance ${u.name}`)}t($,u,m=[],I,w){if(I){const P=new d(void 0,this.g,this,this.i);P.c=String($);const s=new Map,o=new L.$eh(()=>{const t=P.j(u,m,w);for(const[n,i]of s){const r=t[n];if(typeof r=="function")for(const l of i)r.apply(t,l)}return s.clear(),t});return new Proxy(Object.create(null),{get(t,n){if(!o.isInitialized&&typeof n=="string"&&(n.startsWith("onDid")||n.startsWith("onWill"))){let l=s.get(n);return l||(l=new c.$2c,s.set(n,l)),(b,p,O)=>{const B=l.push([b,p,O]);return(0,D.$Pc)(B)}}if(n in t)return t[n];const i=o.value;let r=i[n];return typeof r!="function"||(r=r.bind(i),t[n]=r),r},set(t,n,i){return o.value[n]=i,!0},getPrototypeOf(t){return u.prototype}})}else return this.j(u,m,w)}u($,u){if(u&&console.warn($),this.g)throw new Error($)}}e.$jq=d;var f;(function(y){y[y.None=0]="None",y[y.Creation=1]="Creation",y[y.Invocation=2]="Invocation",y[y.Branch=3]="Branch"})(f||(f={}));class S{static{this.all=new Set}static{this.c=new class extends S{constructor(){super(0,null)}stop(){}branch(){return this}}}static traceInvocation($,u){return $?new S(2,u.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):S.c}static traceCreation($,u){return $?new S(1,u.name):S.c}static{this.f=0}constructor($,u){this.type=$,this.name=u,this.g=Date.now(),this.h=[]}branch($,u){const m=new S(3,$.toString());return this.h.push([$,u,m]),m}stop(){const $=Date.now()-this.g;S.f+=$;let u=!1;function m(w,P){const s=[],o=new Array(w+1).join("	");for(const[t,n,i]of P.h)if(n&&i){u=!0,s.push(`${o}CREATES -> ${t}`);const r=m(w+1,i);r&&s.push(r)}else s.push(`${o}uses -> ${t}`);return s.join(`
`)}const I=[`${this.type===1?"CREATE":"CALL"} ${this.name}`,`${m(1,this)}`,`DONE, took ${$.toFixed(2)}ms (grand total ${S.f.toFixed(2)}ms)`];($>2||u)&&S.all.add(I.join(`
`))}}e.$kq=S});var ie=this&&this.__param||function(J,e){return function(L,N){e(L,N,J)}};define(te[64],ne([0,1,20,2,13,102,21,10]),function(J,e,L,N,D,A,j,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zq=e.$Yq=e.$Xq=void 0;function h(E){return E.tags.find(R=>R.startsWith("lp-"))?.split("lp-")[1]}e.$Xq=h,e.$Yq=(0,v.$Vh)("languagePackService");let c=class extends N.$Rc{constructor(R){super(),this.c=R}async getAvailableLanguages(){const R=new L.$2d;setTimeout(()=>R.cancel(),1e3);let d;try{d=await this.c.query({text:'category:"language packs"',pageSize:20},R.token)}catch{return[]}const S=d.firstPage.filter(y=>y.properties.localizedLanguages?.length&&y.tags.some($=>$.startsWith("lp-"))).map(y=>{const $=y.properties.localizedLanguages?.[0],u=h(y);return{...this.f(u,$,y),extensionId:y.identifier.id,galleryExtension:y}});return S.push(this.f("en","English")),S}f(R,d,f){const S=d??R;let y;if(S!==R&&(y=`(${R})`),R.toLowerCase()===D.$w.toLowerCase()&&(y??="",y+=(0,A.localize)(0,null)),f?.installCount){y??="";const $=f.installCount;let u;$>1e6?u=`${Math.floor($/1e5)/10}M`:$>1e3?u=`${Math.floor($/1e3)}K`:u=String($),y+=` $(cloud-download) ${u}`}return{id:R,label:S,description:y}}};e.$Zq=c,e.$Zq=c=pe([ie(0,j.$do)],c)}),define(te[6],ne([0,1,34,4,41,2,31,13,17,3,11,116,10]),function(J,e,L,N,D,A,j,v,h,c,E,R,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uj=e.$tj=e.$sj=e.$rj=e.$qj=e.$pj=e.$oj=e.$nj=e.$mj=e.$lj=e.$kj=e.$jj=e.$ij=e.log=e.$gj=e.LogLevel=e.$fj=e.$ej=e.$dj=void 0,e.$dj=(0,d.$Vh)("logService"),e.$ej=(0,d.$Vh)("loggerService");function f(){return new Date().toISOString()}function S(b){return(0,c.$Gf)(b)}e.$fj=S;var y;(function(b){b[b.Off=0]="Off",b[b.Trace=1]="Trace",b[b.Debug=2]="Debug",b[b.Info=3]="Info",b[b.Warning=4]="Warning",b[b.Error=5]="Error"})(y||(e.LogLevel=y={})),e.$gj=y.Info;function $(b,p,O){switch(p){case y.Trace:b.trace(O);break;case y.Debug:b.debug(O);break;case y.Info:b.info(O);break;case y.Warning:b.warn(O);break;case y.Error:b.error(O);break;case y.Off:break;default:throw new Error(`Invalid log level ${p}`)}}e.log=$;function u(b,p=!1){let O="";for(let B=0;B<b.length;B++){let _=b[B];if(_ instanceof Error&&(_=(0,L.$Gi)(_,p)),typeof _=="object")try{_=JSON.stringify(_)}catch{}O+=(B>0?" ":"")+_}return O}class m extends A.$Rc{constructor(){super(...arguments),this.b=e.$gj,this.c=this.B(new N.$Rd),this.onDidChangeLogLevel=this.c.event}setLevel(p){this.b!==p&&(this.b=p,this.c.fire(this.b))}getLevel(){return this.b}f(p){return this.b!==y.Off&&this.b<=p}}e.$ij=m;class I extends m{constructor(p){super(),this.h=p}f(p){return this.h||super.f(p)}trace(p,...O){this.f(y.Trace)&&this.g(y.Trace,u([p,...O],!0))}debug(p,...O){this.f(y.Debug)&&this.g(y.Debug,u([p,...O]))}info(p,...O){this.f(y.Info)&&this.g(y.Info,u([p,...O]))}warn(p,...O){this.f(y.Warning)&&this.g(y.Warning,u([p,...O]))}error(p,...O){if(this.f(y.Error))if(p instanceof Error){const B=Array.prototype.slice.call(arguments);B[0]=p.stack,this.g(y.Error,u(B))}else this.g(y.Error,u([p,...O]))}flush(){}}e.$jj=I;class w extends m{constructor(p=e.$gj){super(),this.setLevel(p),this.g=!v.$i}trace(p,...O){this.f(y.Trace)&&(this.g?console.log(`\x1B[90m[main ${f()}]\x1B[0m`,p,...O):console.log(`[main ${f()}]`,p,...O))}debug(p,...O){this.f(y.Debug)&&(this.g?console.log(`\x1B[90m[main ${f()}]\x1B[0m`,p,...O):console.log(`[main ${f()}]`,p,...O))}info(p,...O){this.f(y.Info)&&(this.g?console.log(`\x1B[90m[main ${f()}]\x1B[0m`,p,...O):console.log(`[main ${f()}]`,p,...O))}warn(p,...O){this.f(y.Warning)&&(this.g?console.warn(`\x1B[93m[main ${f()}]\x1B[0m`,p,...O):console.warn(`[main ${f()}]`,p,...O))}error(p,...O){this.f(y.Error)&&(this.g?console.error(`\x1B[91m[main ${f()}]\x1B[0m`,p,...O):console.error(`[main ${f()}]`,p,...O))}dispose(){}flush(){}}e.$kj=w;class P extends m{constructor(p=e.$gj,O=!0){super(),this.g=O,this.setLevel(p)}trace(p,...O){this.f(y.Trace)&&(this.g?console.log("%cTRACE","color: #888",p,...O):console.log(p,...O))}debug(p,...O){this.f(y.Debug)&&(this.g?console.log("%cDEBUG","background: #eee; color: #888",p,...O):console.log(p,...O))}info(p,...O){this.f(y.Info)&&(this.g?console.log("%c INFO","color: #33f",p,...O):console.log(p,...O))}warn(p,...O){this.f(y.Warning)&&(this.g?console.log("%c WARN","color: #993",p,...O):console.log(p,...O))}error(p,...O){this.f(y.Error)&&(this.g?console.log("%c  ERR","color: #f33",p,...O):console.error(p,...O))}dispose(){}flush(){}}e.$lj=P;class s extends m{constructor(p,O=e.$gj){super(),this.g=p,this.setLevel(O)}trace(p,...O){this.f(y.Trace)&&this.g.log(y.Trace,[this.h(p),...O])}debug(p,...O){this.f(y.Debug)&&this.g.log(y.Debug,[this.h(p),...O])}info(p,...O){this.f(y.Info)&&this.g.log(y.Info,[this.h(p),...O])}warn(p,...O){this.f(y.Warning)&&this.g.log(y.Warning,[this.h(p),...O])}error(p,...O){this.f(y.Error)&&this.g.log(y.Error,[this.h(p),...O])}h(p){return typeof p=="string"?p:(0,L.$Gi)(p,this.f(y.Trace))}dispose(){}flush(){}}e.$mj=s;class o extends m{constructor(p){super(),this.g=p,p.length&&this.setLevel(p[0].getLevel())}setLevel(p){for(const O of this.g)O.setLevel(p);super.setLevel(p)}trace(p,...O){for(const B of this.g)B.trace(p,...O)}debug(p,...O){for(const B of this.g)B.debug(p,...O)}info(p,...O){for(const B of this.g)B.info(p,...O)}warn(p,...O){for(const B of this.g)B.warn(p,...O)}error(p,...O){for(const B of this.g)B.error(p,...O)}flush(){for(const p of this.g)p.flush()}dispose(){for(const p of this.g)p.dispose()}}e.$nj=o;class t extends A.$Rc{constructor(p,O,B){if(super(),this.h=p,this.j=O,this.b=new j.$zc,this.c=this.B(new N.$Rd),this.onDidChangeLoggers=this.c.event,this.f=this.B(new N.$Rd),this.onDidChangeLogLevel=this.f.event,this.g=this.B(new N.$Rd),this.onDidChangeVisibility=this.g.event,B)for(const _ of B)this.b.set(_.resource,{logger:void 0,info:_})}m(p){return(0,c.$Cf)(p)?[...this.b.values()].find(O=>O.info.id===p):this.b.get(p)}getLogger(p){return this.m(p)?.logger}createLogger(p,O){const B=this.n(p),_=(0,c.$Cf)(p)?p:O?.id??(0,D.$Ji)(B.toString()).toString(16);let ee=this.b.get(B)?.logger;const oe=O?.logLevel==="always"?y.Trace:O?.logLevel;ee||(ee=this.s(B,oe??this.getLogLevel(B)??this.h,{...O,id:_}));const se={logger:ee,info:{resource:B,id:_,logLevel:oe,name:O?.name,hidden:O?.hidden,extensionId:O?.extensionId,when:O?.when}};return this.registerLogger(se.info),this.b.set(B,se),ee}n(p){return(0,c.$Cf)(p)?(0,h.$zg)(this.j,`${p}.log`):p}setLogLevel(p,O){if(E.URI.isUri(p)){const B=p,_=O,ee=this.b.get(B);ee&&_!==ee.info.logLevel&&(ee.info.logLevel=_===this.h?void 0:_,ee.logger?.setLevel(_),this.b.set(ee.info.resource,ee),this.f.fire([B,_]))}else{this.h=p;for(const[B,_]of this.b.entries())this.b.get(B)?.info.logLevel===void 0&&_.logger?.setLevel(this.h);this.f.fire(this.h)}}setVisibility(p,O){const B=this.m(p);B&&O!==!B.info.hidden&&(B.info.hidden=!O,this.b.set(B.info.resource,B),this.g.fire([B.info.resource,O]))}getLogLevel(p){let O;return p&&(O=this.b.get(p)?.info.logLevel),O??this.h}registerLogger(p){const O=this.b.get(p.resource);O?O.info.hidden!==p.hidden&&this.setVisibility(p.resource,!p.hidden):(this.b.set(p.resource,{info:p,logger:void 0}),this.c.fire({added:[p],removed:[]}))}deregisterLogger(p){const O=this.b.get(p);O&&(O.logger&&O.logger.dispose(),this.b.delete(p),this.c.fire({added:[],removed:[O.info]}))}*getRegisteredLoggers(){for(const p of this.b.values())yield p.info}getRegisteredLogger(p){return this.b.get(p)?.info}dispose(){this.b.forEach(p=>p.logger?.dispose()),this.b.clear(),super.dispose()}}e.$oj=t;class n{constructor(){this.onDidChangeLogLevel=new N.$Rd().event}setLevel(p){}getLevel(){return y.Info}trace(p,...O){}debug(p,...O){}info(p,...O){}warn(p,...O){}error(p,...O){}critical(p,...O){}dispose(){}flush(){}}e.$pj=n;class i extends n{}e.$qj=i;function r(b){if(b.verbose)return y.Trace;if(typeof b.logLevel=="string"){const p=k(b.logLevel.toLowerCase());if(p!==void 0)return p}return e.$gj}e.$rj=r;function l(b){switch(b){case y.Trace:return"trace";case y.Debug:return"debug";case y.Info:return"info";case y.Warning:return"warn";case y.Error:return"error";case y.Off:return"off"}}e.$sj=l;function k(b){switch(b){case"trace":return y.Trace;case"debug":return y.Debug;case"info":return y.Info;case"warn":return y.Warning;case"error":return y.Error;case"critical":return y.Error;case"off":return y.Off}}e.$tj=k,e.$uj=new R.$aj("logLevel",l(y.Info))}),define(te[121],ne([0,1,19,8,9,4,2,16,62,6]),function(J,e,L,N,D,A,j,v,h,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3p=void 0;class E extends j.$Rc{constructor(d,f){super(),this.a=d,this.b=f,this.c=this.B(new A.$Rd),this.onDidChangeFile=this.c.event,this.g=this.B(new A.$Rd),this.onDidWatchError=this.g.event,this.j=[],this.m=this.B(new N.$Vg(0)),this.w=[],this.y=this.B(new N.$Vg(0))}watch(d,f){return f.recursive||this.b?.watcher?.forceUniversal?this.n(d,f):this.z(d,f)}n(d,f){const S={path:this.H(d),excludes:f.excludes,includes:f.includes,recursive:f.recursive,correlationId:f.correlationId},y=(0,L.$Tb)(this.j,S);return this.r(),(0,j.$Pc)(()=>{y(),this.r()})}r(){this.m.trigger(()=>this.s()).catch(d=>(0,D.$Z)(d))}s(){this.h||(this.h=this.B(this.t(f=>this.c.fire((0,h.$Yp)(f)),f=>this.G(f),this.a.getLevel()===c.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.h?.setVerboseLogging(this.a.getLevel()===c.LogLevel.Trace)})));const d=this.b?.watcher?.recursive?.usePolling;if(d===!0)for(const f of this.j)(0,h.$Up)(f)&&(f.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);else if(Array.isArray(d))for(const f of this.j)(0,h.$Up)(f)&&d.includes(f.path)&&(f.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);return this.h.watch(this.j)}z(d,f){const S={path:this.H(d),excludes:f.excludes,includes:f.includes,recursive:!1,correlationId:f.correlationId},y=(0,L.$Tb)(this.w,S);return this.C(),(0,j.$Pc)(()=>{y(),this.C()})}C(){this.y.trigger(()=>this.D()).catch(d=>(0,D.$Z)(d))}D(){return this.u||(this.u=this.B(this.F(d=>this.c.fire((0,h.$Yp)(d)),d=>this.G(d),this.a.getLevel()===c.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.u?.setVerboseLogging(this.a.getLevel()===c.LogLevel.Trace)}))),this.u.watch(this.w)}G(d){d.type==="error"&&this.g.fire(d.message),this.a[d.type](d.message)}H(d){return(0,v.$gc)(d.fsPath)}}e.$3p=E}),define(te[122],ne([0,1,19,8,14,20,4,41,65,2,47,15,123,17,45,99,12,61,6,9]),function(J,e,L,N,D,A,j,v,h,c,E,R,d,f,S,y,$,u,m,I){"use strict";var w;Object.defineProperty(e,"__esModule",{value:!0}),e.$Tp=void 0;let P=class extends c.$Rc{static{w=this}constructor(o){super(),this.b=o,this.a=256*1024,this.c=this.B(new j.$Rd),this.onDidChangeFileSystemProviderRegistrations=this.c.event,this.f=this.B(new j.$Rd),this.onWillActivateFileSystemProvider=this.f.event,this.g=this.B(new j.$Rd),this.onDidChangeFileSystemProviderCapabilities=this.g.event,this.h=new Map,this.r=this.B(new j.$Rd),this.onDidRunOperation=this.r.event,this.X=this.B(new j.$Rd),this.Y=this.B(new j.$Rd),this.onDidFilesChange=this.Y.event,this.Z=this.B(new j.$Rd),this.onDidWatchError=this.Z.event,this.$=new Map,this.cb=this.B(new N.$7g)}registerProvider(o,t){if(this.h.has(o))throw new Error(`A filesystem provider for the scheme '${o}' is already registered.`);(0,d.mark)(`code/registerFilesystem/${o}`);const n=new c.$Qc;return this.h.set(o,t),this.c.fire({added:!0,scheme:o,provider:t}),n.add(t.onDidChangeFile(i=>{const r=new $.$xk(i,!this.S(t));this.X.fire(r),r.hasCorrelation()||this.Y.fire(r)})),typeof t.onDidWatchError=="function"&&n.add(t.onDidWatchError(i=>this.Z.fire(new Error(i)))),n.add(t.onDidChangeCapabilities(()=>this.g.fire({provider:t,scheme:o}))),(0,c.$Pc)(()=>{this.c.fire({added:!1,scheme:o,provider:t}),this.h.delete(o),(0,c.$Mc)(n)})}getProvider(o){return this.h.get(o)}async activateProvider(o){const t=[];this.f.fire({scheme:o,join(n){t.push(n)}}),!this.h.has(o)&&await N.Promises.settled(t)}async canHandleResource(o){return await this.activateProvider(o.scheme),this.hasProvider(o)}hasProvider(o){return this.h.has(o.scheme)}hasCapability(o,t){const n=this.h.get(o.scheme);return!!(n&&n.capabilities&t)}listCapabilities(){return h.Iterable.map(this.h,([o,t])=>({scheme:o,capabilities:t.capabilities}))}async j(o){if(!(0,f.$Dg)(o))throw new $.$zk((0,y.localize)(0,null,this.sb(o)),8);await this.activateProvider(o.scheme);const t=this.h.get(o.scheme);if(!t){const n=new I.$ab;throw n.message=(0,y.localize)(1,null,o.toString()),n}return t}async m(o){const t=await this.j(o);if((0,$.$kk)(t)||(0,$.$hk)(t)||(0,$.$lk)(t))return t;throw new Error(`Filesystem provider for scheme '${o.scheme}' neither has FileReadWrite, FileReadStream nor FileOpenReadWriteClose capability which is needed for the read operation.`)}async n(o){const t=await this.j(o);if((0,$.$kk)(t)||(0,$.$hk)(t))return t;throw new Error(`Filesystem provider for scheme '${o.scheme}' neither has FileReadWrite nor FileOpenReadWriteClose capability which is needed for the write operation.`)}async resolve(o,t){try{return await this.s(o,t)}catch(n){throw(0,$.$uk)(n)===$.FileSystemProviderErrorCode.FileNotFound?new $.$zk((0,y.localize)(2,null,this.sb(o)),1):(0,$.$sk)(n)}}async s(o,t){const n=await this.j(o),i=this.S(n),r=t?.resolveTo,l=t?.resolveSingleChildDescendants,k=t?.resolveMetadata,b=await n.stat(o);let p;return this.t(n,o,b,void 0,!!k,(O,B)=>(p||(p=E.$2h.forUris(()=>!i),p.set(o,!0),r&&p.fill(!0,r)),p.get(O.resource)||p.findSuperstr(O.resource.with({query:null,fragment:null}))?!0:O.isDirectory&&l?B===1:!1))}async t(o,t,n,i,r,l){const{providerExtUri:k}=this.R(o),b={resource:t,name:k.basename(t),isFile:(n.type&$.FileType.File)!==0,isDirectory:(n.type&$.FileType.Directory)!==0,isSymbolicLink:(n.type&$.FileType.SymbolicLink)!==0,mtime:n.mtime,ctime:n.ctime,size:n.size,readonly:!!((n.permissions??0)&$.FilePermission.Readonly)||!!(o.capabilities&2048),locked:!!((n.permissions??0)&$.FilePermission.Locked),etag:(0,$.$Kk)({mtime:n.mtime,size:n.size}),children:void 0};if(b.isDirectory&&l(b,i)){try{const p=await o.readdir(t),O=await N.Promises.settled(p.map(async([B,_])=>{try{const ee=k.joinPath(t,B),oe=r?await o.stat(ee):{type:_};return await this.t(o,ee,oe,p.length,r,l)}catch(ee){return this.b.trace(ee),null}}));b.children=(0,L.$Gb)(O)}catch(p){this.b.trace(p),b.children=[]}return b}return b}async resolveAll(o){return N.Promises.settled(o.map(async t=>{try{return{stat:await this.s(t.resource,t.options),success:!0}}catch(n){return this.b.trace(n),{stat:void 0,success:!1}}}))}async stat(o){const t=await this.j(o),n=await t.stat(o);return this.t(t,o,n,void 0,!0,()=>!1)}async exists(o){const t=await this.j(o);try{return!!await t.stat(o)}catch{return!1}}async canCreateFile(o,t){try{await this.u(o,t)}catch(n){return n}return!0}async u(o,t){if(!t?.overwrite&&await this.exists(o))throw new $.$zk((0,y.localize)(3,null,this.sb(o)),3,t)}async createFile(o,t=D.$fe.fromString(""),n){await this.u(o,n);const i=await this.writeFile(o,t);return this.r.fire(new $.$wk(o,0,i)),i}async writeFile(o,t,n){const i=this.qb(await this.n(o),o),{providerExtUri:r}=this.R(i);let l=n;if((0,$.$nk)(i)&&!l?.atomic){const k=i.enforceAtomicWriteFile?.(o);k&&(l={...n,atomic:k})}try{await this.w(i,o,l)||await this.U(i,r.dirname(o));let b;if((0,$.$hk)(i)&&!(t instanceof D.$fe))if((0,S.$4d)(t)){const p=await(0,S.$$d)(t,3);p.ended?b=D.$fe.concat(p.buffer):b=p}else b=(0,S.$8d)(t,p=>D.$fe.concat(p),3);else b=t;!(0,$.$kk)(i)||(0,$.$hk)(i)&&b instanceof D.$fe||(0,$.$hk)(i)&&(0,$.$nk)(i)&&l?.atomic?await this.hb(i,o,l,b):await this.db(i,o,l,b instanceof D.$fe?(0,D.$qe)(b):b),this.r.fire(new $.$wk(o,4))}catch(k){throw new $.$zk((0,y.localize)(4,null,this.sb(o),(0,$.$sk)(k).toString()),(0,$.$vk)(k),l)}return this.resolve(o,{resolveMetadata:!0})}async w(o,t,n){const i=!!n?.unlock;if(i&&!(o.capabilities&8192))throw new Error((0,y.localize)(5,null,this.sb(t)));if(!!n?.atomic){if(!(o.capabilities&32768))throw new Error((0,y.localize)(6,null,this.sb(t)));if(!(o.capabilities&2))throw new Error((0,y.localize)(7,null,this.sb(t)));if(i)throw new Error((0,y.localize)(8,null,this.sb(t)))}let l;try{l=await o.stat(t)}catch{return}if(l.type&$.FileType.Directory)throw new $.$zk((0,y.localize)(9,null,this.sb(t)),0,n);if(this.rb(t,l),typeof n?.mtime=="number"&&typeof n.etag=="string"&&n.etag!==$.$Jk&&typeof l.mtime=="number"&&typeof l.size=="number"&&n.mtime<l.mtime&&n.etag!==(0,$.$Kk)({mtime:n.mtime,size:l.size}))throw new $.$zk((0,y.localize)(10,null),3,n);return l}async readFile(o,t,n){const i=await this.m(o);return t?.atomic?this.z(i,o,t,n):this.C(i,o,t,n)}async z(o,t,n,i){return new Promise((r,l)=>{this.cb.queueFor(t,this.R(o).providerExtUri).queue(async()=>{try{const k=await this.C(o,t,n,i);r(k)}catch(k){l(k)}})})}async C(o,t,n,i){const r=await this.D(o,t,{...n,preferUnbuffered:!0},i);return{...r,value:await(0,D.$re)(r.value)}}async readFileStream(o,t,n){const i=await this.m(o);return this.D(i,o,t,n)}async D(o,t,n,i){const r=new A.$2d(i);let l=n;(0,$.$mk)(o)&&o.enforceAtomicReadFile?.(t)&&(l={...n,atomic:!0});const k=this.J(t,l).then(p=>p,p=>{throw r.dispose(!0),p});let b;try{return typeof l?.etag=="string"&&l.etag!==$.$Jk&&await k,l?.atomic&&(0,$.$mk)(o)||!((0,$.$kk)(o)||(0,$.$lk)(o))||(0,$.$hk)(o)&&l?.preferUnbuffered?b=this.I(o,t,l):(0,$.$lk)(o)?b=this.G(o,t,r.token,l):b=this.H(o,t,r.token,l),b.on("end",()=>r.dispose()),b.on("error",()=>r.dispose()),{...await k,value:b}}catch(p){throw b&&await(0,S.$9d)(b),this.F(p,t,l)}}F(o,t,n){const i=(0,y.localize)(11,null,this.sb(t),(0,$.$sk)(o).toString());return o instanceof $.$Bk?new $.$Bk(i,o.stat,n):o instanceof $.$Ak?new $.$Ak(i,o.fileOperationResult,o.size,o.options):new $.$zk(i,(0,$.$vk)(o),n)}G(o,t,n,i=Object.create(null)){const r=o.readFileStream(t,i,n);return(0,S.$ce)(r,{data:l=>l instanceof D.$fe?l:D.$fe.wrap(l),error:l=>this.F(l,t,i)},l=>D.$fe.concat(l))}H(o,t,n,i=Object.create(null)){const r=(0,D.$ve)();return(0,u.$Sp)(o,t,r,l=>l,{...i,bufferSize:this.a,errorTransformer:l=>this.F(l,t,i)},n),r}I(o,t,n){const i=(0,S.$6d)(r=>D.$fe.concat(r));return(async()=>{try{let r;n?.atomic&&(0,$.$mk)(o)?r=await o.readFile(t,{atomic:!0}):r=await o.readFile(t),typeof n?.position=="number"&&(r=r.slice(n.position)),typeof n?.length=="number"&&(r=r.slice(0,n.length)),this.L(t,r.byteLength,n),i.end(D.$fe.wrap(r))}catch(r){i.error(r),i.end()}})(),i}async J(o,t){const n=await this.resolve(o,{resolveMetadata:!0});if(n.isDirectory)throw new $.$zk((0,y.localize)(12,null,this.sb(o)),0,t);if(typeof t?.etag=="string"&&t.etag!==$.$Jk&&t.etag===n.etag)throw new $.$Bk((0,y.localize)(13,null),n,t);return this.L(o,n.size,t),n}L(o,t,n){if(typeof n?.limits?.size=="number"&&t>n.limits.size)throw new $.$Ak((0,y.localize)(14,null,this.sb(o)),7,t,n)}async canMove(o,t,n){return this.M(o,t,"move",n)}async canCopy(o,t,n){return this.M(o,t,"copy",n)}async M(o,t,n,i){if(o.toString()!==t.toString())try{const r=n==="move"?this.qb(await this.n(o),o):await this.m(o),l=this.qb(await this.n(t),t);await this.Q(r,o,l,t,n,i)}catch(r){return r}return!0}async move(o,t,n){const i=this.qb(await this.n(o),o),r=this.qb(await this.n(t),t),l=await this.N(i,o,r,t,"move",!!n),k=await this.resolve(t,{resolveMetadata:!0});return this.r.fire(new $.$wk(o,l==="move"?2:3,k)),k}async copy(o,t,n){const i=await this.m(o),r=this.qb(await this.n(t),t),l=await this.N(i,o,r,t,"copy",!!n),k=await this.resolve(t,{resolveMetadata:!0});return this.r.fire(new $.$wk(o,l==="copy"?3:2,k)),k}async N(o,t,n,i,r,l){if(t.toString()===i.toString())return r;const{exists:k,isSameResourceWithDifferentPathCase:b}=await this.Q(o,t,n,i,r,l);if(k&&!b&&l&&await this.del(i,{recursive:!0}),await this.U(n,this.R(n).providerExtUri.dirname(i)),r==="copy"){if(o===n&&(0,$.$ik)(o))await o.copy(t,i,{overwrite:l});else{const p=await this.resolve(t);p.isDirectory?await this.P(o,p,n,i):await this.O(o,t,n,i)}return r}else return o===n?(await o.rename(t,i,{overwrite:l}),r):(await this.N(o,t,n,i,"copy",l),await this.del(t,{recursive:!0}),"copy")}async O(o,t,n,i){if((0,$.$kk)(o)&&(0,$.$kk)(n))return this.jb(o,t,n,i);if((0,$.$kk)(o)&&(0,$.$hk)(n))return this.pb(o,t,n,i);if((0,$.$hk)(o)&&(0,$.$kk)(n))return this.nb(o,t,n,i);if((0,$.$hk)(o)&&(0,$.$hk)(n))return this.lb(o,t,n,i)}async P(o,t,n,i){await n.mkdir(i),Array.isArray(t.children)&&await N.Promises.settled(t.children.map(async r=>{const l=this.R(n).providerExtUri.joinPath(i,r.name);return r.isDirectory?this.P(o,await this.resolve(r.resource),n,l):this.O(o,r.resource,n,l)}))}async Q(o,t,n,i,r,l){let k=!1;if(o===n){const{providerExtUri:p,isPathCaseSensitive:O}=this.R(o);if(O||(k=p.isEqual(t,i)),k&&r==="copy")throw new Error((0,y.localize)(15,null,this.sb(t),this.sb(i)));if(!k&&p.isEqualOrParent(i,t))throw new Error((0,y.localize)(16,null,this.sb(t),this.sb(i)))}const b=await this.exists(i);if(b&&!k){if(!l)throw new $.$zk((0,y.localize)(17,null,this.sb(t),this.sb(i)),4);if(o===n){const{providerExtUri:p}=this.R(o);if(p.isEqualOrParent(t,i))throw new Error((0,y.localize)(18,null,this.sb(t),this.sb(i)))}}return{exists:b,isSameResourceWithDifferentPathCase:k}}R(o){const t=this.S(o);return{providerExtUri:t?f.$pg:f.$rg,isPathCaseSensitive:t}}S(o){return!!(o.capabilities&1024)}async createFolder(o){const t=this.qb(await this.j(o),o);await this.U(t,o);const n=await this.resolve(o,{resolveMetadata:!0});return this.r.fire(new $.$wk(o,0,n)),n}async U(o,t){const n=[],{providerExtUri:i}=this.R(o);for(;!i.isEqual(t,i.dirname(t));)try{if(!((await o.stat(t)).type&$.FileType.Directory))throw new Error((0,y.localize)(19,null,this.sb(t)));break}catch(r){if((0,$.$uk)(r)!==$.FileSystemProviderErrorCode.FileNotFound)throw r;n.push(i.basename(t)),t=i.dirname(t)}for(let r=n.length-1;r>=0;r--){t=i.joinPath(t,n[r]);try{await o.mkdir(t)}catch(l){if((0,$.$uk)(l)!==$.FileSystemProviderErrorCode.FileExists)throw l}}}async canDelete(o,t){try{await this.W(o,t)}catch(n){return n}return!0}async W(o,t){const n=this.qb(await this.j(o),o),i=!!t?.useTrash;if(i&&!(n.capabilities&4096))throw new Error((0,y.localize)(20,null,this.sb(o)));const r=t?.atomic;if(r&&!(n.capabilities&65536))throw new Error((0,y.localize)(21,null,this.sb(o)));if(i&&r)throw new Error((0,y.localize)(22,null,this.sb(o)));let l;try{l=await n.stat(o)}catch{}if(l)this.rb(o,l);else throw new $.$zk((0,y.localize)(23,null,this.sb(o)),1);if(!!!t?.recursive){const b=await this.resolve(o);if(b.isDirectory&&Array.isArray(b.children)&&b.children.length>0)throw new Error((0,y.localize)(24,null,this.sb(o)))}return n}async del(o,t){const n=await this.W(o,t);let i=t;if((0,$.$ok)(n)&&!i?.atomic){const b=n.enforceAtomicDelete?.(o);b&&(i={...t,atomic:b})}const r=!!i?.useTrash,l=!!i?.recursive,k=i?.atomic??!1;await n.delete(o,{recursive:l,useTrash:r,atomic:k}),this.r.fire(new $.$wk(o,1))}async cloneFile(o,t){const n=await this.j(o),i=this.qb(await this.n(t),t);if(n===i&&this.R(n).providerExtUri.isEqual(o,t))return;if(n===i&&(0,$.$jk)(n))return n.cloneFile(o,t);await this.U(i,this.R(i).providerExtUri.dirname(t));const r=this.cb.queueFor(o,this.R(n).providerExtUri);return n===i&&(0,$.$ik)(n)?r.queue(()=>n.copy(o,t,{overwrite:!0})):r.queue(()=>this.O(n,o,i,t))}static{this.ab=0}createWatcher(o,t){return this.watch(o,{...t,correlationId:w.ab++})}watch(o,t={recursive:!1,excludes:[]}){const n=new c.$Qc;let i=!1,r=()=>{i=!0};n.add((0,c.$Pc)(()=>r())),(async()=>{try{const k=await this.bb(o,t);i?(0,c.$Mc)(k):r=()=>(0,c.$Mc)(k)}catch(k){this.b.error(k)}})();const l=t.correlationId;if(typeof l=="number"){const k=n.add(new j.$Rd);return n.add(this.X.event(p=>{p.correlates(l)&&k.fire(p)})),{onDidChange:k.event,dispose:()=>n.dispose()}}return n}async bb(o,t){const n=await this.j(o),i=(0,v.$Ji)([this.R(n).providerExtUri.getComparisonKey(o),t]);let r=this.$.get(i);return r||(r={count:0,disposable:n.watch(o,t)},this.$.set(i,r)),r.count+=1,(0,c.$Pc)(()=>{r&&(r.count--,r.count===0&&((0,c.$Mc)(r.disposable),this.$.delete(i)))})}dispose(){super.dispose();for(const[,o]of this.$)(0,c.$Mc)(o.disposable);this.$.clear()}async db(o,t,n,i){return this.cb.queueFor(t,this.R(o).providerExtUri).queue(async()=>{const r=await o.open(t,{create:!0,unlock:n?.unlock??!1});try{(0,S.$4d)(i)||(0,S.$5d)(i)?await this.eb(o,r,i):await this.fb(o,r,i)}catch(l){throw(0,$.$sk)(l)}finally{await o.close(r)}})}async eb(o,t,n){let i=0,r;if((0,S.$5d)(n)){if(n.buffer.length>0){const l=D.$fe.concat(n.buffer);await this.gb(o,t,l,l.byteLength,i,0),i+=l.byteLength}if(n.ended)return;r=n.stream}else r=n;return new Promise((l,k)=>{(0,S.$0d)(r,{onData:async b=>{r.pause();try{await this.gb(o,t,b,b.byteLength,i,0)}catch(p){return k(p)}i+=b.byteLength,setTimeout(()=>r.resume())},onError:b=>k(b),onEnd:()=>l()})})}async fb(o,t,n){let i=0,r;for(;(r=n.read())!==null;)await this.gb(o,t,r,r.byteLength,i,0),i+=r.byteLength}async gb(o,t,n,i,r,l){let k=0;for(;k<i;){const b=await o.write(t,r+k,n.buffer,l+k,i-k);k+=b}}async hb(o,t,n,i){return this.cb.queueFor(t,this.R(o).providerExtUri).queue(()=>this.ib(o,t,n,i))}async ib(o,t,n,i){let r;i instanceof D.$fe?r=i:(0,S.$4d)(i)?r=await(0,D.$re)(i):(0,S.$5d)(i)?r=await(0,D.$se)(i):r=(0,D.$pe)(i),await o.writeFile(t,r.buffer,{create:!0,overwrite:!0,unlock:n?.unlock??!1,atomic:n?.atomic??!1})}async jb(o,t,n,i){return this.cb.queueFor(i,this.R(n).providerExtUri).queue(()=>this.kb(o,t,n,i))}async kb(o,t,n,i){let r,l;try{r=await o.open(t,{create:!1}),l=await n.open(i,{create:!0,unlock:!1});const k=D.$fe.alloc(this.a);let b=0,p=0,O=0;do O=await o.read(r,b,k.buffer,p,k.byteLength-p),await this.gb(n,l,k,O,b,p),b+=O,p+=O,p===k.byteLength&&(p=0);while(O>0)}catch(k){throw(0,$.$sk)(k)}finally{await N.Promises.settled([typeof r=="number"?o.close(r):Promise.resolve(),typeof l=="number"?n.close(l):Promise.resolve()])}}async lb(o,t,n,i){return this.cb.queueFor(i,this.R(n).providerExtUri).queue(()=>this.mb(o,t,n,i))}async mb(o,t,n,i){return n.writeFile(i,await o.readFile(t),{create:!0,overwrite:!0,unlock:!1,atomic:!1})}async nb(o,t,n,i){return this.cb.queueFor(i,this.R(n).providerExtUri).queue(()=>this.ob(o,t,n,i))}async ob(o,t,n,i){const r=await n.open(i,{create:!0,unlock:!1});try{const l=await o.readFile(t);await this.gb(n,r,D.$fe.wrap(l),l.byteLength,0,0)}catch(l){throw(0,$.$sk)(l)}finally{await n.close(r)}}async pb(o,t,n,i){const r=await(0,D.$re)(this.H(o,t,A.CancellationToken.None));await this.hb(n,i,void 0,r)}qb(o,t){if(o.capabilities&2048)throw new $.$zk((0,y.localize)(25,null,this.sb(t)),6);return o}rb(o,t){if((t.permissions??0)&$.FilePermission.Readonly)throw new $.$zk((0,y.localize)(26,null,this.sb(o)),6)}sb(o){return o.scheme===R.Schemas.file?o.fsPath:o.toString(!0)}};e.$Tp=P,e.$Tp=P=w=pe([ie(0,m.$dj)],P)}),define(te[124],ne([0,1,125,169,8,31,14,4,170,2,16,13,17,45,24,101,12,61,121,34,119,118]),function(J,e,L,N,D,A,j,v,h,c,E,R,d,f,S,y,$,u,m,I,w,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gq=void 0,(()=>{try{(0,N.gracefulify)(L)}catch(o){console.error(`Error enabling graceful-fs: ${(0,I.$Gi)(o)}`)}})();class s extends m.$3p{static{this.I=!1}constructor(t,n){super(t,n),this.onDidChangeCapabilities=v.Event.None,this.N=new A.$zc(i=>d.$qg.getComparisonKey(i)),this.U=new Map,this.W=new Map,this.X=new Map}get capabilities(){return this.J||(this.J=253982,R.$k&&(this.J|=1024)),this.J}async stat(t){try{const{stat:n,symbolicLink:i}=await S.SymlinkSupport.stat(this.H(t));return{type:this.M(n,i),ctime:n.birthtime.getTime(),mtime:n.mtime.getTime(),size:n.size,permissions:n.mode&128?void 0:$.FilePermission.Locked}}catch(n){throw this.fb(n)}}async L(t){try{return await this.stat(t)}catch{return}}async readdir(t){try{const n=await S.Promises.readdir(this.H(t),{withFileTypes:!0}),i=[];return await Promise.all(n.map(async r=>{try{let l;r.isSymbolicLink()?l=(await this.stat((0,d.$zg)(t,r.name))).type:l=this.M(r),i.push([r.name,l])}catch(l){this.a.trace(l)}})),i}catch(n){throw this.fb(n)}}M(t,n){let i;return n?.dangling?i=$.FileType.Unknown:t.isFile()?i=$.FileType.File:t.isDirectory()?i=$.FileType.Directory:i=$.FileType.Unknown,n&&(i|=$.FileType.SymbolicLink),i}async O(t){const n=this.H(t);this.P(`[Disk FileSystemProvider]: createResourceLock() - request to acquire resource lock (${n})`);let i;for(;i=this.N.get(t);)this.P(`[Disk FileSystemProvider]: createResourceLock() - waiting for resource lock to be released (${n})`),await i.wait();const r=new D.$Wg;return this.N.set(t,r),this.P(`[Disk FileSystemProvider]: createResourceLock() - new resource lock created (${n})`),(0,c.$Pc)(()=>{this.P(`[Disk FileSystemProvider]: createResourceLock() - resource lock dispose() (${n})`),this.N.get(t)===r&&(this.P(`[Disk FileSystemProvider]: createResourceLock() - resource lock removed from resource-lock map (${n})`),this.N.delete(t)),this.P(`[Disk FileSystemProvider]: createResourceLock() - resource lock barrier open() (${n})`),r.open()})}async readFile(t,n){let i;try{n?.atomic&&(this.P(`[Disk FileSystemProvider]: atomic read operation started (${this.H(t)})`),i=await this.O(t));const r=this.H(t);return await S.Promises.readFile(r)}catch(r){throw this.fb(r)}finally{i?.dispose()}}P(t){s.I&&this.a.trace(t)}readFileStream(t,n,i){const r=(0,f.$6d)(l=>j.$fe.concat(l.map(k=>j.$fe.wrap(k))).buffer);return(0,u.$Sp)(this,t,r,l=>l.buffer,{...n,bufferSize:256*1024},i),r}async writeFile(t,n,i){return i?.atomic!==!1&&i?.atomic?.postfix&&await this.Q(t)?this.R(t,(0,d.$zg)((0,d.$yg)(t),`${(0,d.$wg)(t)}${i.atomic.postfix}`),n,i):this.S(t,n,i)}async Q(t){try{const n=this.H(t),{symbolicLink:i}=await S.SymlinkSupport.stat(n);if(i)return!1}catch{}return!0}async R(t,n,i,r){const l=new c.$Qc;try{l.add(await this.O(t)),l.add(await this.O(n)),await this.S(n,i,r,!0);try{await this.rename(n,t,{overwrite:!0})}catch(k){try{await this.delete(n,{recursive:!1,useTrash:!1,atomic:!1})}catch{}throw k}}finally{l.dispose()}}async S(t,n,i,r){let l;try{const k=this.H(t);if(!i.create||!i.overwrite){if(await S.Promises.exists(k)){if(!i.overwrite)throw(0,$.$rk)((0,y.localize)(0,null),$.FileSystemProviderErrorCode.FileExists)}else if(!i.create)throw(0,$.$rk)((0,y.localize)(1,null),$.FileSystemProviderErrorCode.FileNotFound)}l=await this.open(t,{create:!0,unlock:i.unlock},r),await this.write(l,0,n,0,n.byteLength)}catch(k){throw await this.gb(t,k)}finally{typeof l=="number"&&await this.close(l)}}static{this.Y=!0}static configureFlushOnWrite(t){s.Y=t}async open(t,n,i){const r=this.H(t);let l;(0,$.$fk)(n)&&!i&&(l=await this.O(t));let k;try{if((0,$.$fk)(n)&&n.unlock)try{const{stat:p}=await S.SymlinkSupport.stat(r);p.mode&128||await S.Promises.chmod(r,p.mode|128)}catch(p){p.code!=="ENOENT"&&this.a.trace(p)}let b;if((0,$.$fk)(n)){if(R.$i)try{await S.Promises.truncate(r,0),b="r+"}catch(p){p.code!=="ENOENT"&&this.a.trace(p)}b||(b="w")}else b="r";k=await S.Promises.open(r,b)}catch(b){throw l?.dispose(),(0,$.$fk)(n)?await this.gb(t,b):this.fb(b)}if(this.U.set(k,0),(0,$.$fk)(n)&&this.X.set(k,t),l){const b=this.W.get(k);this.P(`[Disk FileSystemProvider]: open() - storing lock for handle ${k} (${r})`),this.W.set(k,l),b&&(this.P(`[Disk FileSystemProvider]: open() - disposing a previous lock that was still stored on same handle ${k} (${r})`),b.dispose())}return k}async close(t){const n=this.W.get(t);try{if(this.U.delete(t),this.X.delete(t)&&s.Y)try{await S.Promises.fdatasync(t)}catch(i){s.configureFlushOnWrite(!1),this.a.error(i)}return await S.Promises.close(t)}catch(i){throw this.fb(i)}finally{n&&(this.W.get(t)===n&&(this.P(`[Disk FileSystemProvider]: close() - resource lock removed from handle-lock map ${t}`),this.W.delete(t)),this.P(`[Disk FileSystemProvider]: close() - disposing lock for handle ${t}`),n.dispose())}}async read(t,n,i,r,l){const k=this.Z(t,n);let b=null;try{b=(await S.Promises.read(t,i,r,l,k)).bytesRead}catch(p){throw this.fb(p)}finally{this.$(t,k,b)}return b}Z(t,n){return n===this.U.get(t)?null:n}$(t,n,i){const r=this.U.get(t);typeof r=="number"&&(typeof n=="number"||(typeof i=="number"?this.U.set(t,r+i):this.U.delete(t)))}async write(t,n,i,r,l){return(0,D.$fh)(()=>this.ab(t,n,i,r,l),100,3)}async ab(t,n,i,r,l){const k=this.Z(t,n);let b=null;try{b=(await S.Promises.write(t,i,r,l,k)).bytesWritten}catch(p){throw await this.gb(this.X.get(t),p)}finally{this.$(t,k,b)}return b}async mkdir(t){try{await S.Promises.mkdir(this.H(t))}catch(n){throw this.fb(n)}}async delete(t,n){try{const i=this.H(t);if(n.recursive){let r;n?.atomic!==!1&&n.atomic.postfix&&(r=(0,E.$ic)((0,E.$lc)(i),`${(0,E.$mc)(i)}${n.atomic.postfix}`)),await S.Promises.rm(i,S.RimRafMode.MOVE,r)}else try{await S.Promises.unlink(i)}catch(r){if(r.code==="EPERM"||r.code==="EISDIR"){let l=!1;try{const{stat:k,symbolicLink:b}=await S.SymlinkSupport.stat(i);l=k.isDirectory()&&!b}catch{}if(l)await S.Promises.rmdir(i);else throw r}else throw r}}catch(i){throw this.fb(i)}}async rename(t,n,i){const r=this.H(t),l=this.H(n);if(r!==l)try{await this.bb(t,n,"move",i.overwrite),await S.Promises.rename(r,l)}catch(k){throw(k.code==="EINVAL"||k.code==="EBUSY"||k.code==="ENAMETOOLONG")&&(k=new Error((0,y.localize)(2,null,(0,E.$mc)(r),(0,E.$mc)((0,E.$lc)(l)),k.toString()))),this.fb(k)}}async copy(t,n,i){const r=this.H(t),l=this.H(n);if(r!==l)try{await this.bb(t,n,"copy",i.overwrite),await S.Promises.copy(r,l,{preserveSymlinks:!0})}catch(k){throw(k.code==="EINVAL"||k.code==="EBUSY"||k.code==="ENAMETOOLONG")&&(k=new Error((0,y.localize)(3,null,(0,E.$mc)(r),(0,E.$mc)((0,E.$lc)(l)),k.toString()))),this.fb(k)}}async bb(t,n,i,r){const l=this.H(t),k=this.H(n);let b=!1;if(!!(this.capabilities&1024)||(b=(0,h.$1f)(l,k,!0)),b){if(i==="copy")throw(0,$.$rk)((0,y.localize)(4,null),$.FileSystemProviderErrorCode.FileExists);if(i==="move")return}const O=await this.L(t);if(!O)throw(0,$.$rk)((0,y.localize)(5,null),$.FileSystemProviderErrorCode.FileNotFound);const B=await this.L(n);if(B){if(!r)throw(0,$.$rk)((0,y.localize)(6,null),$.FileSystemProviderErrorCode.FileExists);O.type&$.FileType.File&&B.type&$.FileType.File||await this.delete(n,{recursive:!0,useTrash:!1,atomic:!1})}}async cloneFile(t,n){return this.cb(t,n,!1)}async cb(t,n,i){const r=this.H(t),l=this.H(n),k=!!(this.capabilities&1024);if((0,h.$1f)(r,l,!k))return;const b=new c.$Qc;try{b.add(await this.O(t)),b.add(await this.O(n)),i&&await S.Promises.mkdir((0,E.$lc)(l),{recursive:!0}),await S.Promises.copyFile(r,l)}catch(p){if(p.code==="ENOENT"&&!i)return this.cb(t,n,!0);throw this.fb(p)}finally{b.dispose()}}t(t,n,i){return new w.$0p(r=>t(r),r=>n(r),i)}F(t,n,i){return new P.$fq(r=>t(r),r=>n(r),i)}fb(t){if(t instanceof $.$qk)return t;let n=t,i;switch(t.code){case"ENOENT":i=$.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":i=$.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":i=$.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":i=$.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":i=$.FileSystemProviderErrorCode.NoPermissions;break;case"ERR_UNC_HOST_NOT_ALLOWED":n=`${t.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`,i=$.FileSystemProviderErrorCode.Unknown;break;default:i=$.FileSystemProviderErrorCode.Unknown}return(0,$.$rk)(n,i)}async gb(t,n){let i=this.fb(n);if(t&&i.code===$.FileSystemProviderErrorCode.NoPermissions)try{const{stat:r}=await S.SymlinkSupport.stat(this.H(t));r.mode&128||(i=(0,$.$rk)(n,$.FileSystemProviderErrorCode.FileWriteLocked))}catch(r){this.a.trace(r)}return i}}e.$gq=s}),define(te[126],ne([0,1,2,6]),function(J,e,L,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$WN=void 0;class D extends L.$Rc{constructor(j,v=[]){super(),this.a=new N.$nj([j,...v]),this.B(j.onDidChangeLogLevel(h=>this.setLevel(h)))}get onDidChangeLogLevel(){return this.a.onDidChangeLogLevel}setLevel(j){this.a.setLevel(j)}getLevel(){return this.a.getLevel()}trace(j,...v){this.a.trace(j,...v)}debug(j,...v){this.a.debug(j,...v)}info(j,...v){this.a.info(j,...v)}warn(j,...v){this.a.warn(j,...v)}error(j,...v){this.a.error(j,...v)}flush(){this.a.flush()}}e.$WN=D}),define(te[127],ne([0,1,12,6]),function(J,e,L,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$LN=void 0;var D;(function(c){c[c.Trace=0]="Trace",c[c.Debug=1]="Debug",c[c.Info=2]="Info",c[c.Warning=3]="Warning",c[c.Error=4]="Error",c[c.Critical=5]="Critical",c[c.Off=6]="Off"})(D||(D={}));async function A(c,E,R,d,f){try{const S=await new Promise(($,u)=>{J(["@vscode/spdlog"],$,u)});S.setFlushOn(D.Trace);const y=await S.createAsyncRotatingLogger(c,E,R,d);return f?y.clearFormatters():y.setPattern("%Y-%m-%d %H:%M:%S.%e [%l] %v"),y}catch(S){console.error(S)}return null}function j(c,E,R){switch(E){case N.LogLevel.Trace:c.trace(R);break;case N.LogLevel.Debug:c.debug(R);break;case N.LogLevel.Info:c.info(R);break;case N.LogLevel.Warning:c.warn(R);break;case N.LogLevel.Error:c.error(R);break;case N.LogLevel.Off:break;default:throw new Error(`Invalid log level ${E}`)}}function v(c,E){switch(E){case N.LogLevel.Trace:c.setLevel(D.Trace);break;case N.LogLevel.Debug:c.setLevel(D.Debug);break;case N.LogLevel.Info:c.setLevel(D.Info);break;case N.LogLevel.Warning:c.setLevel(D.Warning);break;case N.LogLevel.Error:c.setLevel(D.Error);break;case N.LogLevel.Off:c.setLevel(D.Off);break;default:throw new Error(`Invalid log level ${E}`)}}class h extends N.$jj{constructor(E,R,d,f,S){super(),this.m=[],this.setLevel(S),this.n=this.s(E,R,d,f),this.B(this.onDidChangeLogLevel(y=>{this.r&&v(this.r,y)}))}async s(E,R,d,f){const S=d?6:1,y=30/S*L.$Mk.MB,$=await A(E,R,y,S,f);if($){this.r=$,v(this.r,this.getLevel());for(const{level:u,message:m}of this.m)j(this.r,u,m);this.m=[]}}g(E,R){this.r?j(this.r,E,R):this.getLevel()<=E&&this.m.push({level:E,message:R})}flush(){this.r?this.r.flush():this.n.then(()=>this.flush())}dispose(){this.r?this.u():this.n.then(()=>this.u())}u(){this.r&&(this.r.drop(),this.r=void 0)}}e.$LN=h}),define(te[128],ne([0,1,28,6,127]),function(J,e,L,N,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$MN=void 0;class A extends N.$oj{s(v,h,c){return new D.$LN((0,L.$ig)(),v.fsPath,!c?.donotRotate,!!c?.donotUseFormatters,h)}}e.$MN=A}),define(te[38],ne([0,1,4,65,2,10]),function(J,e,L,N,D,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qn=e.$pn=e.$on=void 0,e.$on=(0,A.$Vh)("policy");class j extends D.$Rc{constructor(){super(...arguments),this.f={},this.g=new Map,this.h=this.B(new L.$Rd),this.onDidChange=this.h.event}async updatePolicyDefinitions(c){const E=Object.keys(this.f).length;return this.f={...c,...this.f},E!==Object.keys(this.f).length&&await this.j(c),N.Iterable.reduce(this.g.entries(),(R,[d,f])=>({...R,[d]:f}),{})}getPolicyValue(c){return this.g.get(c)}serialize(){return N.Iterable.reduce(Object.entries(this.f),(c,[E,R])=>({...c,[E]:{definition:R,value:this.g.get(E)}}),{})}}e.$pn=j;class v{constructor(){this.onDidChange=L.Event.None}async updatePolicyDefinitions(){return{}}getPolicyValue(){}serialize(){}}e.$qn=v}),define(te[129],ne([0,1,8,4,65,3,12,6,38]),function(J,e,L,N,D,A,j,v,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$R9b=void 0;function c(R,d){const f=[];for(const S of new Set(D.Iterable.concat(R.keys(),d.keys())))R.get(S)!==d.get(S)&&f.push(S);return f}let E=class extends h.$pn{constructor(d,f,S){super(),this.m=d,this.n=f,this.s=S,this.c=this.B(new L.$Vg(500));const y=N.Event.filter(f.onDidFilesChange,$=>$.affects(d));this.B(f.watch(d)),this.B(y(()=>this.c.trigger(()=>this.w())))}async j(){await this.w()}async u(){const d=new Map;try{const f=await this.n.readFile(this.m),S=JSON.parse(f.value.toString());if(!(0,A.$Ef)(S))throw new Error("Policy file isn't a JSON object");for(const y of Object.keys(S))this.f[y]&&d.set(y,S[y])}catch(f){f.fileOperationResult!==1&&this.s.error("[FilePolicyService] Failed to read policies",f)}return d}async w(){const d=await this.u(),f=c(this.g,d);this.g=d,f.length>0&&this.h.fire(f)}};e.$R9b=E,e.$R9b=E=pe([ie(1,j.$ek),ie(2,v.$dj)],E)}),define(te[130],ne([0,1,38,8,171,2,6]),function(J,e,L,N,D,A,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Q9b=void 0;let v=class extends L.$pn{constructor(c,E){super(),this.m=c,this.n=E,this.a=new N.$Rg,this.b=this.B(new A.$Sc)}async j(c){this.m.trace(`NativePolicyService#_updatePolicyDefinitions - Found ${Object.keys(c).length} policy definitions`),await this.a.queue(()=>new Promise((E,R)=>{try{this.b.value=(0,D.createWatcher)(this.n,c,d=>{this.t(d),E()})}catch(d){this.m.error("NativePolicyService#_updatePolicyDefinitions - Error creating watcher:",d),R(d)}}))}t(c){this.m.trace(`NativePolicyService#_onDidPolicyChange - Updated policy values: ${JSON.stringify(c)}`);for(const E in c){const R=c[E];R===void 0?this.g.delete(E):this.g.set(E,R)}this.h.fire(Object.keys(c))}};e.$Q9b=v,e.$Q9b=v=pe([ie(0,j.$dj)],v)}),define(te[32],ne([0,1,10]),function(J,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wj=e.$vj=void 0,e.$vj=(0,L.$Vh)("productService"),e.$wj="vscode://schemas/vscode-product"}),define(te[36],ne([0,1,71,3]),function(J,e,L,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mn=void 0;class D{constructor(){this.a=new Map}add(j,v){L.ok(N.$Cf(j)),L.ok(N.$Ef(v)),L.ok(!this.a.has(j),"There is already an extension with this id"),this.a.set(j,v)}knows(j){return this.a.has(j)}as(j){return this.a.get(j)||null}}e.$mn=new D}),define(te[131],ne([0,1,4,36]),function(J,e,L,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nn=void 0,e.$nn={JSONContribution:"base.contributions.json"};function D(v){return v.length>0&&v.charAt(v.length-1)==="#"?v.substring(0,v.length-1):v}class A{constructor(){this.b=new L.$Rd,this.onDidChangeSchema=this.b.event,this.a={}}registerSchema(h,c){this.a[D(h)]=c,this.b.fire(h)}notifySchemaChanged(h){this.b.fire(h)}getSchemaContributions(){return{schemas:this.a}}}const j=new A;N.$mn.add(e.$nn.JSONContribution,j)}),define(te[43],ne([0,1,19,4,3,88,25,131,36]),function(J,e,L,N,D,A,j,v,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gn=e.$Fn=e.$En=e.$Dn=e.$Cn=e.$Bn=e.$An=e.$zn=e.$yn=e.$xn=e.$wn=e.$vn=e.$un=e.$tn=e.$sn=e.ConfigurationScope=e.$rn=e.EditPresentationTypes=void 0;var c;(function(P){P.Multiline="multilineText",P.Singleline="singlelineText"})(c||(e.EditPresentationTypes=c={})),e.$rn={Configuration:"base.contributions.configuration"};var E;(function(P){P[P.APPLICATION=1]="APPLICATION",P[P.MACHINE=2]="MACHINE",P[P.WINDOW=3]="WINDOW",P[P.RESOURCE=4]="RESOURCE",P[P.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",P[P.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(E||(e.ConfigurationScope=E={})),e.$sn={properties:{},patternProperties:{}},e.$tn={properties:{},patternProperties:{}},e.$un={properties:{},patternProperties:{}},e.$vn={properties:{},patternProperties:{}},e.$wn={properties:{},patternProperties:{}},e.$xn={properties:{},patternProperties:{}},e.$yn="vscode://schemas/settings/resourceLanguage",e.$zn="vscode://schemas/settings/configurationDefaults";const R=h.$mn.as(v.$nn.JSONContribution);class d{constructor(){this.h=new Set,this.i=new N.$Rd,this.onDidSchemaChange=this.i.event,this.j=new N.$Rd,this.onDidUpdateConfiguration=this.j.event,this.a=new Map,this.b={id:"defaultOverrides",title:A.localize(0,null),properties:{}},this.c=[this.b],this.g={properties:{},patternProperties:{},additionalProperties:!0,allowTrailingCommas:!0,allowComments:!0},this.d={},this.e=new Map,this.f={},R.registerSchema(e.$yn,this.g),this.v()}registerConfiguration(s,o=!0){this.registerConfigurations([s],o)}registerConfigurations(s,o=!0){const t=new Set;this.n(s,o,t),R.registerSchema(e.$yn,this.g),this.i.fire(),this.j.fire({properties:t})}deregisterConfigurations(s){const o=new Set;this.o(s,o),R.registerSchema(e.$yn,this.g),this.i.fire(),this.j.fire({properties:o})}updateConfigurations({add:s,remove:o}){const t=new Set;this.o(o,t),this.n(s,!1,t),R.registerSchema(e.$yn,this.g),this.i.fire(),this.j.fire({properties:t})}registerDefaultConfigurations(s){const o=new Set;this.k(s,o),this.i.fire(),this.j.fire({properties:o,defaultsOverrides:!0})}k(s,o){const t=[];for(const{overrides:n,source:i}of s)for(const r in n)if(o.add(r),e.$Bn.test(r)){const l=this.a.get(r),k=l?.valuesSources??new Map;if(i)for(const B of Object.keys(n[r]))k.set(B,i);const b={...l?.value||{},...n[r]};this.a.set(r,{source:i,value:b,valuesSources:k});const p=(0,j.$zi)(r),O={type:"object",default:b,description:A.localize(1,null,p),$ref:e.$yn,defaultDefaultValue:b,source:D.$Cf(i)?void 0:i,defaultValueSource:i};t.push(...y(r)),this.d[r]=O,this.b.properties[r]=O}else{this.a.set(r,{value:n[r],source:i});const l=this.d[r];l&&(this.w(r,l),this.r(r,l))}this.m(t)}deregisterDefaultConfigurations(s){const o=new Set;this.l(s,o),this.i.fire(),this.j.fire({properties:o,defaultsOverrides:!0})}l(s,o){for(const{overrides:t,source:n}of s)for(const i in t){const r=this.a.get(i),l=D.$Cf(n)?n:n?.id,k=D.$Cf(r?.source)?r?.source:r?.source?.id;if(l===k)if(o.add(i),this.a.delete(i),e.$Bn.test(i))delete this.d[i],delete this.b.properties[i];else{const b=this.d[i];b&&(this.w(i,b),this.r(i,b))}}this.u()}deltaConfiguration(s){let o=!1;const t=new Set;s.removedDefaults&&(this.l(s.removedDefaults,t),o=!0),s.addedDefaults&&(this.k(s.addedDefaults,t),o=!0),s.removedConfigurations&&this.o(s.removedConfigurations,t),s.addedConfigurations&&this.n(s.addedConfigurations,!1,t),this.i.fire(),this.j.fire({properties:t,defaultsOverrides:o})}notifyConfigurationSchemaUpdated(...s){this.i.fire()}registerOverrideIdentifiers(s){this.m(s),this.i.fire()}m(s){for(const o of s)this.h.add(o);this.u()}n(s,o,t){s.forEach(n=>{this.p(n,o,n.extensionInfo,n.restrictedProperties,void 0,t),this.c.push(n),this.q(n)})}o(s,o){const t=n=>{if(n.properties)for(const i in n.properties){o.add(i);const r=this.d[i];r?.policy?.name&&this.e.delete(r.policy.name),delete this.d[i],this.s(i,n.properties[i])}n.allOf?.forEach(i=>t(i))};for(const n of s){t(n);const i=this.c.indexOf(n);i!==-1&&this.c.splice(i,1)}}p(s,o=!0,t,n,i=3,r){i=D.$Lf(s.scope)?i:s.scope;const l=s.properties;if(l)for(const b in l){const p=l[b];if(o&&I(b,p)){delete l[b];continue}if(p.source=t,p.defaultDefaultValue=l[b].default,this.w(b,p),e.$Bn.test(b)?p.scope=void 0:(p.scope=D.$Lf(p.scope)?i:p.scope,p.restricted=D.$Lf(p.restricted)?!!n?.includes(b):p.restricted),l[b].hasOwnProperty("included")&&!l[b].included){this.f[b]=l[b],delete l[b];continue}else this.d[b]=l[b],l[b].policy?.name&&this.e.set(l[b].policy.name,b);!l[b].deprecationMessage&&l[b].markdownDeprecationMessage&&(l[b].deprecationMessage=l[b].markdownDeprecationMessage),r.add(b)}const k=s.allOf;if(k)for(const b of k)this.p(b,o,t,n,i,r)}getConfigurations(){return this.c}getConfigurationProperties(){return this.d}getPolicyConfigurations(){return this.e}getExcludedConfigurationProperties(){return this.f}getConfigurationDefaultsOverrides(){return this.a}q(s){const o=t=>{const n=t.properties;if(n)for(const r in n)this.r(r,n[r]);t.allOf?.forEach(o)};o(s)}r(s,o){switch(e.$sn.properties[s]=o,o.scope){case 1:e.$tn.properties[s]=o;break;case 2:e.$un.properties[s]=o;break;case 6:e.$vn.properties[s]=o;break;case 3:e.$wn.properties[s]=o;break;case 4:e.$xn.properties[s]=o;break;case 5:e.$xn.properties[s]=o,this.g.properties[s]=o;break}}s(s,o){switch(delete e.$sn.properties[s],o.scope){case 1:delete e.$tn.properties[s];break;case 2:delete e.$un.properties[s];break;case 6:delete e.$vn.properties[s];break;case 3:delete e.$wn.properties[s];break;case 4:case 5:delete e.$xn.properties[s],delete this.g.properties[s];break}}u(){for(const s of this.h.values()){const o=`[${s}]`,t={type:"object",description:A.localize(2,null),errorMessage:A.localize(3,null),$ref:e.$yn};this.w(o,t),e.$sn.properties[o]=t,e.$tn.properties[o]=t,e.$un.properties[o]=t,e.$vn.properties[o]=t,e.$wn.properties[o]=t,e.$xn.properties[o]=t}}v(){const s={type:"object",description:A.localize(4,null),errorMessage:A.localize(5,null),$ref:e.$yn};e.$sn.patternProperties[e.$An]=s,e.$tn.patternProperties[e.$An]=s,e.$un.patternProperties[e.$An]=s,e.$vn.patternProperties[e.$An]=s,e.$wn.patternProperties[e.$An]=s,e.$xn.patternProperties[e.$An]=s,this.i.fire()}w(s,o){const t=this.a.get(s);let n=t?.value,i=t?.source;D.$Jf(n)&&(n=o.defaultDefaultValue,i=void 0),D.$Jf(n)&&(n=u(o.type)),o.default=n,o.defaultValueSource=i}}const f="\\[([^\\]]+)\\]",S=new RegExp(f,"g");e.$An=`^(${f})+$`,e.$Bn=new RegExp(e.$An);function y(P){const s=[];if(e.$Bn.test(P)){let o=S.exec(P);for(;o?.length;){const t=o[1].trim();t&&s.push(t),o=S.exec(P)}}return(0,L.$Lb)(s)}e.$Cn=y;function $(P){return P.reduce((s,o)=>`${s}[${o}]`,"")}e.$Dn=$;function u(P){switch(Array.isArray(P)?P[0]:P){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.$En=u;const m=new d;h.$mn.add(e.$rn.Configuration,m);function I(P,s){return P.trim()?e.$Bn.test(P)?A.localize(7,null,P):m.getConfigurationProperties()[P]!==void 0?A.localize(8,null,P):s.policy?.name&&m.getPolicyConfigurations().get(s.policy?.name)!==void 0?A.localize(9,null,P,s.policy?.name,m.getPolicyConfigurations().get(s.policy?.name)):null:A.localize(6,null)}e.$Fn=I;function w(){const P=[],s=m.getConfigurationProperties();for(const o of Object.keys(s))P.push([o,s[o].scope]);return P.push(["launch",4]),P.push(["task",4]),P}e.$Gn=w}),define(te[66],ne([0,1,19,4,53,2,31,30,3,11,25,43,36]),function(J,e,L,N,D,A,j,v,h,c,E,R,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mn=e.$Ln=e.$Kn=e.$Jn=e.$In=e.$Hn=void 0;function f(o){return Object.isFrozen(o)?o:v.$bn(o)}class S{constructor(t={},n=[],i=[],r){this.b=t,this.c=n,this.d=i,this.raw=r,this.a=new Map}get rawConfiguration(){if(!this.f)if(this.raw?.length){const t=this.raw.map(n=>{if(n instanceof S)return n;const i=new y("");return i.parseRaw(n),i.configurationModel});this.f=t.reduce((n,i)=>i===n?i:n.merge(i),t[0])}else this.f=this;return this.f}get contents(){return this.b}get overrides(){return this.d}get keys(){return this.c}isEmpty(){return this.c.length===0&&Object.keys(this.b).length===0&&this.d.length===0}getValue(t){return t?(0,E.$xi)(this.contents,t):this.contents}inspect(t,n){const i=this.rawConfiguration.getValue(t),r=n?this.rawConfiguration.getOverrideValue(t,n):void 0,l=n?this.rawConfiguration.override(n).getValue(t):i;return{value:i,override:r,merged:l}}getOverrideValue(t,n){const i=this.i(n);return i?t?(0,E.$xi)(i,t):i:void 0}getKeysForOverrideIdentifier(t){const n=[];for(const i of this.overrides)i.identifiers.includes(t)&&n.push(...i.keys);return L.$Lb(n)}getAllOverrideIdentifiers(){const t=[];for(const n of this.overrides)t.push(...n.identifiers);return L.$Lb(t)}override(t){let n=this.a.get(t);return n||(n=this.g(t),this.a.set(t,n)),n}merge(...t){const n=v.$an(this.contents),i=v.$an(this.overrides),r=[...this.keys],l=this.raw?.length?[...this.raw]:[this];for(const k of t)if(l.push(...k.raw?.length?k.raw:[k]),!k.isEmpty()){this.h(n,k.contents);for(const b of k.overrides){const[p]=i.filter(O=>L.$tb(O.identifiers,b.identifiers));p?(this.h(p.contents,b.contents),p.keys.push(...b.keys),p.keys=L.$Lb(p.keys)):i.push(v.$an(b))}for(const b of k.keys)r.indexOf(b)===-1&&r.push(b)}return new S(n,r,i,l.every(k=>k instanceof S)?void 0:l)}g(t){const n=this.i(t);if(!n||typeof n!="object"||!Object.keys(n).length)return this;const i={};for(const r of L.$Lb([...Object.keys(this.contents),...Object.keys(n)])){let l=this.contents[r];const k=n[r];k&&(typeof l=="object"&&typeof k=="object"?(l=v.$an(l),this.h(l,k)):l=k),i[r]=l}return new S(i,this.keys,this.overrides)}h(t,n){for(const i of Object.keys(n)){if(i in t&&h.$Ef(t[i])&&h.$Ef(n[i])){this.h(t[i],n[i]);continue}t[i]=v.$an(n[i])}}i(t){let n=null,i=null;const r=l=>{l&&(i?this.h(i,l):i=v.$an(l))};for(const l of this.overrides)l.identifiers.length===1&&l.identifiers[0]===t?n=l.contents:l.identifiers.includes(t)&&r(l.contents);return r(n),i}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}addValue(t,n){this.j(t,n,!0)}setValue(t,n){this.j(t,n,!1)}removeValue(t){const n=this.keys.indexOf(t);n!==-1&&(this.keys.splice(n,1),(0,E.$wi)(this.contents,t),R.$Bn.test(t)&&this.overrides.splice(this.overrides.findIndex(i=>L.$tb(i.identifiers,(0,R.$Cn)(t))),1))}j(t,n,i){(0,E.$vi)(this.contents,t,n,r=>console.error(r)),i=i||this.keys.indexOf(t)===-1,i&&this.keys.push(t),R.$Bn.test(t)&&this.overrides.push({identifiers:(0,R.$Cn)(t),keys:Object.keys(this.contents[t]),contents:(0,E.$ui)(this.contents[t],r=>console.error(r))})}}e.$Hn=S;class y{constructor(t){this.f=t,this.a=null,this.b=null,this.c=[],this.d=[]}get configurationModel(){return this.b||new S}get restrictedConfigurations(){return this.c}get errors(){return this.d}parse(t,n){if(!h.$Lf(t)){const i=this.g(t);this.parseRaw(i,n)}}reparse(t){this.a&&this.parseRaw(this.a,t)}parseRaw(t,n){this.a=t;const{contents:i,keys:r,overrides:l,restricted:k,hasExcludedProperties:b}=this.h(t,n);this.b=new S(i,r,l,b?[t]:void 0),this.c=k||[]}g(t){let n={},i=null,r=[];const l=[],k=[];function b(O){Array.isArray(r)?r.push(O):i!==null&&(r[i]=O)}const p={onObjectBegin:()=>{const O={};b(O),l.push(r),r=O,i=null},onObjectProperty:O=>{i=O},onObjectEnd:()=>{r=l.pop()},onArrayBegin:()=>{const O=[];b(O),l.push(r),r=O,i=null},onArrayEnd:()=>{r=l.pop()},onLiteralValue:b,onError:(O,B,_)=>{k.push({error:O,offset:B,length:_})}};if(t)try{D.$0m(t,p),n=r[0]||{}}catch(O){console.error(`Error while parsing settings file ${this.f}: ${O}`),this.d=[O]}return n}h(t,n){const i=d.$mn.as(R.$rn.Configuration).getConfigurationProperties(),r=this.i(t,i,!0,n);t=r.raw;const l=(0,E.$ui)(t,p=>console.error(`Conflict in settings file ${this.f}: ${p}`)),k=Object.keys(t),b=this.j(t,p=>console.error(`Conflict in settings file ${this.f}: ${p}`));return{contents:l,keys:k,overrides:b,restricted:r.restricted,hasExcludedProperties:r.hasExcludedProperties}}i(t,n,i,r){let l=!1;if(!r?.scopes&&!r?.skipRestricted&&!r?.exclude?.length)return{raw:t,restricted:[],hasExcludedProperties:l};const k={},b=[];for(const p in t)if(R.$Bn.test(p)&&i){const O=this.i(t[p],n,!1,r);k[p]=O.raw,l=l||O.hasExcludedProperties,b.push(...O.restricted)}else{const O=n[p],B=O?typeof O.scope<"u"?O.scope:3:void 0;O?.restricted&&b.push(p),!r.exclude?.includes(p)&&(r.include?.includes(p)||(B===void 0||r.scopes===void 0||r.scopes.includes(B))&&!(r.skipRestricted&&O?.restricted))?k[p]=t[p]:l=!0}return{raw:k,restricted:b,hasExcludedProperties:l}}j(t,n){const i=[];for(const r of Object.keys(t))if(R.$Bn.test(r)){const l={};for(const k in t[r])l[k]=t[r][k];i.push({identifiers:(0,R.$Cn)(r),keys:Object.keys(l),contents:(0,E.$ui)(l,n)})}return i}}e.$In=y;class $ extends A.$Rc{constructor(t,n,i,r){super(),this.c=t,this.f=n,this.g=r,this.b=this.B(new N.$Rd),this.onDidChange=this.b.event,this.a=new y(this.c.toString()),this.B(this.g.watch(i.dirname(this.c))),this.B(this.g.watch(this.c)),this.B(N.Event.any(N.Event.filter(this.g.onDidFilesChange,l=>l.contains(this.c)),N.Event.filter(this.g.onDidRunOperation,l=>(l.isOperation(0)||l.isOperation(3)||l.isOperation(1)||l.isOperation(4))&&i.isEqual(l.resource,t)))(()=>this.b.fire()))}async loadConfiguration(){try{const t=await this.g.readFile(this.c);return this.a.parse(t.value.toString()||"{}",this.f),this.a.configurationModel}catch{return new S}}reparse(t){return t&&(this.f=t),this.a.reparse(this.f),this.a.configurationModel}getRestrictedSettings(){return this.a.restrictedConfigurations}}e.$Jn=$;class u{constructor(t,n,i,r,l,k,b,p,O,B,_,ee,oe){this.a=t,this.b=n,this.c=i,this.overrideIdentifiers=r,this.d=l,this.f=k,this.g=b,this.h=p,this.i=O,this.j=B,this.k=_,this.l=ee,this.m=oe}get value(){return f(this.c)}n(t,n,i){const r=t.inspect(n,i);return{get value(){return f(r.value)},get override(){return f(r.override)},get merged(){return f(r.merged)}}}get q(){return this.p||(this.p=this.n(this.d,this.a,this.b.overrideIdentifier)),this.p}get defaultValue(){return this.q.merged}get default(){return this.q.value!==void 0||this.q.override!==void 0?{value:this.q.value,override:this.q.override}:void 0}get s(){return this.r===void 0&&(this.r=this.f?this.n(this.f,this.a):null),this.r}get policyValue(){return this.s?.merged}get policy(){return this.s?.value!==void 0?{value:this.s.value}:void 0}get u(){return this.t===void 0&&(this.t=this.g?this.n(this.g,this.a):null),this.t}get applicationValue(){return this.u?.merged}get application(){return this.u?.value!==void 0||this.u?.override!==void 0?{value:this.u.value,override:this.u.override}:void 0}get w(){return this.v||(this.v=this.n(this.h,this.a,this.b.overrideIdentifier)),this.v}get userValue(){return this.w.merged}get user(){return this.w.value!==void 0||this.w.override!==void 0?{value:this.w.value,override:this.w.override}:void 0}get y(){return this.x||(this.x=this.n(this.i,this.a,this.b.overrideIdentifier)),this.x}get userLocalValue(){return this.y.merged}get userLocal(){return this.y.value!==void 0||this.y.override!==void 0?{value:this.y.value,override:this.y.override}:void 0}get A(){return this.z||(this.z=this.n(this.j,this.a,this.b.overrideIdentifier)),this.z}get userRemoteValue(){return this.A.merged}get userRemote(){return this.A.value!==void 0||this.A.override!==void 0?{value:this.A.value,override:this.A.override}:void 0}get D(){return this.B===void 0&&(this.B=this.k?this.n(this.k,this.a,this.b.overrideIdentifier):null),this.B}get workspaceValue(){return this.D?.merged}get workspace(){return this.D?.value!==void 0||this.D?.override!==void 0?{value:this.D.value,override:this.D.override}:void 0}get F(){return this.E===void 0&&(this.E=this.l?this.n(this.l,this.a,this.b.overrideIdentifier):null),this.E}get workspaceFolderValue(){return this.F?.merged}get workspaceFolder(){return this.F?.value!==void 0||this.F?.override!==void 0?{value:this.F.value,override:this.F.override}:void 0}get H(){return this.G===void 0&&(this.G=this.n(this.m,this.a,this.b.overrideIdentifier)),this.G}get memoryValue(){return this.H.merged}get memory(){return this.H.value!==void 0||this.H.override!==void 0?{value:this.H.value,override:this.H.override}:void 0}}class m{constructor(t,n,i,r,l=new S,k=new S,b=new j.$zc,p=new S,O=new j.$zc){this.c=t,this.d=n,this.f=i,this.g=r,this.h=l,this.i=k,this.j=b,this.l=p,this.m=O,this.a=null,this.b=new j.$zc,this.n=null}getValue(t,n,i){return this.p(t,n,i).getValue(t)}updateValue(t,n,i={}){let r;i.resource?(r=this.m.get(i.resource),r||(r=new S,this.m.set(i.resource,r))):r=this.l,n===void 0?r.removeValue(t):r.setValue(t,n),i.resource||(this.a=null)}inspect(t,n,i){const r=this.p(t,n,i),l=this.t(n.resource,i),k=n.resource?this.m.get(n.resource)||this.l:this.l,b=new Set;for(const p of r.overrides)for(const O of p.identifiers)r.getOverrideValue(t,O)!==void 0&&b.add(O);return new u(t,n,r.getValue(t),b.size?[...b]:void 0,this.c,this.d.isEmpty()?void 0:this.d,this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration,this.userConfiguration,this.localUserConfiguration,this.remoteUserConfiguration,i?this.i:void 0,l||void 0,k)}keys(t){const n=this.t(void 0,t);return{default:this.c.keys.slice(0),user:this.userConfiguration.keys.slice(0),workspace:this.i.keys.slice(0),workspaceFolder:n?n.keys.slice(0):[]}}updateDefaultConfiguration(t){this.c=t,this.a=null,this.b.clear()}updatePolicyConfiguration(t){this.d=t}updateApplicationConfiguration(t){this.f=t,this.a=null,this.b.clear()}updateLocalUserConfiguration(t){this.g=t,this.n=null,this.a=null,this.b.clear()}updateRemoteUserConfiguration(t){this.h=t,this.n=null,this.a=null,this.b.clear()}updateWorkspaceConfiguration(t){this.i=t,this.a=null,this.b.clear()}updateFolderConfiguration(t,n){this.j.set(t,n),this.b.delete(t)}deleteFolderConfiguration(t){this.folderConfigurations.delete(t),this.b.delete(t)}compareAndUpdateDefaultConfiguration(t,n){const i=[];if(!n){const{added:r,updated:l,removed:k}=P(this.c,t);n=[...r,...l,...k]}for(const r of n)for(const l of(0,R.$Cn)(r)){const k=this.c.getKeysForOverrideIdentifier(l),b=t.getKeysForOverrideIdentifier(l),p=[...b.filter(O=>k.indexOf(O)===-1),...k.filter(O=>b.indexOf(O)===-1),...k.filter(O=>!v.$en(this.c.override(l).getValue(O),t.override(l).getValue(O)))];i.push([l,p])}return this.updateDefaultConfiguration(t),{keys:n,overrides:i}}compareAndUpdatePolicyConfiguration(t){const{added:n,updated:i,removed:r}=P(this.d,t),l=[...n,...i,...r];return l.length&&this.updatePolicyConfiguration(t),{keys:l,overrides:[]}}compareAndUpdateApplicationConfiguration(t){const{added:n,updated:i,removed:r,overrides:l}=P(this.applicationConfiguration,t),k=[...n,...i,...r];return k.length&&this.updateApplicationConfiguration(t),{keys:k,overrides:l}}compareAndUpdateLocalUserConfiguration(t){const{added:n,updated:i,removed:r,overrides:l}=P(this.localUserConfiguration,t),k=[...n,...i,...r];return k.length&&this.updateLocalUserConfiguration(t),{keys:k,overrides:l}}compareAndUpdateRemoteUserConfiguration(t){const{added:n,updated:i,removed:r,overrides:l}=P(this.remoteUserConfiguration,t),k=[...n,...i,...r];return k.length&&this.updateRemoteUserConfiguration(t),{keys:k,overrides:l}}compareAndUpdateWorkspaceConfiguration(t){const{added:n,updated:i,removed:r,overrides:l}=P(this.workspaceConfiguration,t),k=[...n,...i,...r];return k.length&&this.updateWorkspaceConfiguration(t),{keys:k,overrides:l}}compareAndUpdateFolderConfiguration(t,n){const i=this.folderConfigurations.get(t),{added:r,updated:l,removed:k,overrides:b}=P(i,n),p=[...r,...l,...k];return(p.length||!i)&&this.updateFolderConfiguration(t,n),{keys:p,overrides:b}}compareAndDeleteFolderConfiguration(t){const n=this.folderConfigurations.get(t);if(!n)throw new Error("Unknown folder");this.deleteFolderConfiguration(t);const{added:i,updated:r,removed:l,overrides:k}=P(n,void 0);return{keys:[...i,...r,...l],overrides:k}}get defaults(){return this.c}get applicationConfiguration(){return this.f}get userConfiguration(){return this.n||(this.n=this.h.isEmpty()?this.g:this.g.merge(this.h)),this.n}get localUserConfiguration(){return this.g}get remoteUserConfiguration(){return this.h}get workspaceConfiguration(){return this.i}get folderConfigurations(){return this.j}p(t,n,i){let r=this.q(n,i);return n.overrideIdentifier&&(r=r.override(n.overrideIdentifier)),!this.d.isEmpty()&&this.d.getValue(t)!==void 0&&(r=r.merge(this.d)),r}q({resource:t},n){let i=this.r();if(n&&t){const r=n.getFolder(t);r&&(i=this.s(r.uri)||i);const l=this.m.get(t);l&&(i=i.merge(l))}return i}r(){return this.a||(this.a=this.c.merge(this.applicationConfiguration,this.userConfiguration,this.i,this.l)),this.a}s(t){let n=this.b.get(t);if(!n){const i=this.r(),r=this.j.get(t);r?(n=i.merge(r),this.b.set(t,n)):n=i}return n}t(t,n){if(n&&t){const i=n.getFolder(t);if(i)return this.j.get(i.uri)}}toData(){return{defaults:{contents:this.c.contents,overrides:this.c.overrides,keys:this.c.keys},policy:{contents:this.d.contents,overrides:this.d.overrides,keys:this.d.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this.i.contents,overrides:this.i.overrides,keys:this.i.keys},folders:[...this.j.keys()].reduce((t,n)=>{const{contents:i,overrides:r,keys:l}=this.j.get(n);return t.push([n,{contents:i,overrides:r,keys:l}]),t},[])}}allKeys(){const t=new Set;return this.c.keys.forEach(n=>t.add(n)),this.userConfiguration.keys.forEach(n=>t.add(n)),this.i.keys.forEach(n=>t.add(n)),this.j.forEach(n=>n.keys.forEach(i=>t.add(i))),[...t.values()]}u(){const t=new Set;return this.c.getAllOverrideIdentifiers().forEach(n=>t.add(n)),this.userConfiguration.getAllOverrideIdentifiers().forEach(n=>t.add(n)),this.i.getAllOverrideIdentifiers().forEach(n=>t.add(n)),this.j.forEach(n=>n.getAllOverrideIdentifiers().forEach(i=>t.add(i))),[...t.values()]}v(t){const n=new Set;return this.c.getKeysForOverrideIdentifier(t).forEach(i=>n.add(i)),this.userConfiguration.getKeysForOverrideIdentifier(t).forEach(i=>n.add(i)),this.i.getKeysForOverrideIdentifier(t).forEach(i=>n.add(i)),this.j.forEach(i=>i.getKeysForOverrideIdentifier(t).forEach(r=>n.add(r))),[...n.values()]}static parse(t){const n=this.w(t.defaults),i=this.w(t.policy),r=this.w(t.application),l=this.w(t.user),k=this.w(t.workspace),b=t.folders.reduce((p,O)=>(p.set(c.URI.revive(O[0]),this.w(O[1])),p),new j.$zc);return new m(n,i,r,l,new S,k,b,new S,new j.$zc)}static w(t){return new S(t.contents,t.keys,t.overrides)}}e.$Kn=m;function I(...o){if(o.length===0)return{keys:[],overrides:[]};if(o.length===1)return o[0];const t=new Set,n=new Map;for(const r of o)r.keys.forEach(l=>t.add(l)),r.overrides.forEach(([l,k])=>{const b=(0,j.$wc)(n,l,new Set);k.forEach(p=>b.add(p))});const i=[];return n.forEach((r,l)=>i.push([l,[...r.values()]])),{keys:[...t.values()],overrides:i}}e.$Ln=I;class w{constructor(t,n,i,r){this.change=t,this.f=n,this.g=i,this.h=r,this.a=`
`,this.b=this.a.charCodeAt(0),this.c=".".charCodeAt(0),this.affectedKeys=new Set,this.i=void 0;for(const l of t.keys)this.affectedKeys.add(l);for(const[,l]of t.overrides)for(const k of l)this.affectedKeys.add(k);this.d=this.a;for(const l of this.affectedKeys)this.d+=l+this.a}get previousConfiguration(){return!this.i&&this.f&&(this.i=m.parse(this.f.data)),this.i}affectsConfiguration(t,n){const i=this.a+t,r=this.d.indexOf(i);if(r<0)return!1;const l=r+i.length;if(l>=this.d.length)return!1;const k=this.d.charCodeAt(l);if(k!==this.b&&k!==this.c)return!1;if(n){const b=this.previousConfiguration?this.previousConfiguration.getValue(t,n,this.f?.workspace):void 0,p=this.g.getValue(t,n,this.h);return!v.$en(b,p)}return!0}}e.$Mn=w;function P(o,t){const{added:n,removed:i,updated:r}=s(t?.rawConfiguration,o?.rawConfiguration),l=[],k=o?.getAllOverrideIdentifiers()||[],b=t?.getAllOverrideIdentifiers()||[];if(t){const p=b.filter(O=>!k.includes(O));for(const O of p)l.push([O,t.getKeysForOverrideIdentifier(O)])}if(o){const p=k.filter(O=>!b.includes(O));for(const O of p)l.push([O,o.getKeysForOverrideIdentifier(O)])}if(t&&o){for(const p of k)if(b.includes(p)){const O=s({contents:o.getOverrideValue(void 0,p)||{},keys:o.getKeysForOverrideIdentifier(p)},{contents:t.getOverrideValue(void 0,p)||{},keys:t.getKeysForOverrideIdentifier(p)});l.push([p,[...O.added,...O.removed,...O.updated]])}}return{added:n,removed:i,updated:r,overrides:l}}function s(o,t){const n=o?t?o.keys.filter(l=>t.keys.indexOf(l)===-1):[...o.keys]:[],i=t?o?t.keys.filter(l=>o.keys.indexOf(l)===-1):[...t.keys]:[],r=[];if(o&&t){for(const l of t.keys)if(o.keys.indexOf(l)!==-1){const k=(0,E.$xi)(t.contents,l),b=(0,E.$xi)(o.contents,l);v.$en(k,b)||r.push(l)}}return{added:n,removed:i,updated:r}}}),define(te[132],ne([0,1,19,4,2,30,3,66,43,6,38,36]),function(J,e,L,N,D,A,j,v,h,c,E,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pn=e.$On=e.$Nn=void 0;class d extends D.$Rc{constructor(){super(...arguments),this.a=this.B(new N.$Rd),this.onDidChangeConfiguration=this.a.event,this.b=new v.$Hn}get configurationModel(){return this.b}async initialize(){return this.g(),this.B(R.$mn.as(h.$rn.Configuration).onDidUpdateConfiguration(({properties:$,defaultsOverrides:u})=>this.c(Array.from($),u))),this.configurationModel}reload(){return this.g(),this.configurationModel}c($,u){this.h($,R.$mn.as(h.$rn.Configuration).getConfigurationProperties()),this.a.fire({defaults:this.configurationModel,properties:$})}f(){return{}}g(){this.b=new v.$Hn;const $=R.$mn.as(h.$rn.Configuration).getConfigurationProperties();this.h(Object.keys($),$)}h($,u){const m=this.f();for(const I of $){const w=m[I],P=u[I];w!==void 0?this.b.addValue(I,w):P?this.b.addValue(I,P.default):this.b.removeValue(I)}}}e.$Nn=d;class f{constructor(){this.onDidChangeConfiguration=N.Event.None,this.configurationModel=new v.$Hn}async initialize(){return this.configurationModel}}e.$On=f;let S=class extends D.$Rc{get configurationModel(){return this.b}constructor($,u,m){super(),this.c=$,this.f=u,this.g=m,this.a=this.B(new N.$Rd),this.onDidChangeConfiguration=this.a.event,this.b=new v.$Hn}async initialize(){return this.g.trace("PolicyConfiguration#initialize"),this.m(await this.h(this.c.configurationModel.keys),!1),this.B(this.f.onDidChange($=>this.j($))),this.B(this.c.onDidChangeConfiguration(async({properties:$})=>this.m(await this.h($),!0))),this.b}async h($){this.g.trace("PolicyConfiguration#updatePolicyDefinitions",$);const u={},m=[],I=R.$mn.as(h.$rn.Configuration).getConfigurationProperties();for(const w of $){const P=I[w];if(!P){m.push(w);continue}if(P.policy){if(P.type!=="string"&&P.type!=="number"){this.g.warn(`Policy ${P.policy.name} has unsupported type ${P.type}`);continue}m.push(w),u[P.policy.name]={type:P.type}}}return(0,j.$Pf)(u)||await this.f.updatePolicyDefinitions(u),m}j($){this.g.trace("PolicyConfiguration#onDidChangePolicies",$);const u=R.$mn.as(h.$rn.Configuration).getPolicyConfigurations(),m=(0,L.$Gb)($.map(I=>u.get(I)));this.m(m,!0)}m($,u){this.g.trace("PolicyConfiguration#update",$);const m=R.$mn.as(h.$rn.Configuration).getConfigurationProperties(),I=[],w=this.b.isEmpty();for(const P of $){const s=m[P]?.policy?.name;if(s){const o=this.f.getPolicyValue(s);(w?o!==void 0:!(0,A.$en)(this.b.getValue(P),o))&&I.push([P,o])}else this.b.getValue(P)!==void 0&&I.push([P,void 0])}if(I.length){this.g.trace("PolicyConfiguration#changed",I);const P=this.b;this.b=new v.$Hn;for(const s of P.keys)this.b.setValue(s,P.getValue(s));for(const[s,o]of I)o===void 0?this.b.removeValue(s):this.b.setValue(s,o);u&&this.a.fire(this.b)}}};e.$Pn=S,e.$Pn=S=pe([ie(1,E.$on),ie(2,c.$dj)],S)}),define(te[133],ne([0,1,8,4,2,17,25,66,132,38]),function(J,e,L,N,D,A,j,v,h,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qn=void 0;class E extends D.$Rc{constructor(d,f,S,y){super(),this.j=d,this.h=this.B(new N.$Rd),this.onDidChangeConfiguration=this.h.event,this.b=this.B(new h.$Nn),this.c=S instanceof c.$qn?new h.$On:this.B(new h.$Pn(this.b,S,y)),this.f=this.B(new v.$Jn(this.j,{},A.$qg,f)),this.a=new v.$Kn(this.b.configurationModel,this.c.configurationModel,new v.$Hn,new v.$Hn),this.g=this.B(new L.$0g(()=>this.reloadConfiguration(),50)),this.B(this.b.onDidChangeConfiguration(({defaults:$,properties:u})=>this.n($,u))),this.B(this.c.onDidChangeConfiguration($=>this.r($))),this.B(this.f.onDidChange(()=>this.g.schedule()))}async initialize(){const[d,f,S]=await Promise.all([this.b.initialize(),this.c.initialize(),this.f.loadConfiguration()]);this.a=new v.$Kn(d,f,new v.$Hn,S)}getConfigurationData(){return this.a.toData()}getValue(d,f){const S=typeof d=="string"?d:void 0,y=(0,j.$qi)(d)?d:(0,j.$qi)(f)?f:{};return this.a.getValue(S,y,void 0)}updateValue(d,f,S,y){return Promise.reject(new Error("not supported"))}inspect(d){return this.a.inspect(d,{},void 0)}keys(){return this.a.keys(void 0)}async reloadConfiguration(){const d=await this.f.loadConfiguration();this.m(d)}m(d){const f=this.a.toData(),S=this.a.compareAndUpdateLocalUserConfiguration(d);this.s(S,f,2)}n(d,f){const S=this.a.toData(),y=this.a.compareAndUpdateDefaultConfiguration(d,f);this.s(y,S,7)}r(d){const f=this.a.toData(),S=this.a.compareAndUpdatePolicyConfiguration(d);this.s(S,f,7)}s(d,f,S){const y=new v.$Mn(d,{data:f},this.a);y.source=S,y.sourceConfig=this.t(S),this.h.fire(y)}t(d){switch(d){case 7:return this.a.defaults.contents;case 2:return this.a.localUserConfiguration.contents}return{}}}e.$Qn=E}),define(te[67],ne([0,1,15]),function(J,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5k=e.$4k=e.$3k=e.$2k=e.$1k=void 0;function N(c){return c.scheme===L.Schemas.vscodeRemote?c.authority:void 0}e.$1k=N;function D(c){if(!c)return;const E=c.indexOf("+");return E<0?c:c.substr(0,E)}e.$2k=D;function A(c){return`/${c.quality??"oss"}-${c.commit??"dev"}`}e.$3k=A;function j(c){const{host:E,port:R}=h(c);if(typeof R>"u")throw new Error("Remote authority doesn't contain a port!");return{host:E,port:R}}e.$4k=j;function v(c,E){let{host:R,port:d}=h(c);return typeof d>"u"&&(d=E),{host:R,port:d}}e.$5k=v;function h(c){const E=c.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(E)return{host:E[1],port:parseInt(E[2],10)};const R=c.match(/^(\[[0-9a-z:]+\])$/);if(R)return{host:R[1],port:void 0};const d=c.match(/(.*):(\d+)$/);return d?{host:d[1],port:parseInt(d[2],10)}:{host:c,port:void 0}}}),define(te[37],ne([0,1,29,10,67]),function(J,e,L,N,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gm=e.$fm=e.$em=e.$dm=e.$cm=e.$bm=e.$am=e.$_l=e.TargetPlatform=e.ExtensionType=e.$$l=e.$0l=e.$9l=e.$8l=e.$7l=e.$6l=void 0,e.$6l="extensions.user.cache",e.$7l="extensions.builtin.cache",e.$8l="undefined_publisher",e.$9l=["ui","workspace","web"];function A(y){if(typeof y=="object"&&y!==null&&y.supported!==!0)return y.description}e.$0l=A,e.$$l=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var j;(function(y){y[y.System=0]="System",y[y.User=1]="User"})(j||(e.ExtensionType=j={}));var v;(function(y){y.WIN32_X64="win32-x64",y.WIN32_ARM64="win32-arm64",y.LINUX_X64="linux-x64",y.LINUX_ARM64="linux-arm64",y.LINUX_ARMHF="linux-armhf",y.ALPINE_X64="alpine-x64",y.ALPINE_ARM64="alpine-arm64",y.DARWIN_X64="darwin-x64",y.DARWIN_ARM64="darwin-arm64",y.WEB="web",y.UNIVERSAL="universal",y.UNKNOWN="unknown",y.UNDEFINED="undefined"})(v||(e.TargetPlatform=v={}));class h{constructor($){this.value=$,this._lower=$.toLowerCase()}static equals($,u){if(typeof $>"u"||$===null)return typeof u>"u"||u===null;if(typeof u>"u"||u===null)return!1;if(typeof $=="string"||typeof u=="string"){const m=typeof $=="string"?$:$.value,I=typeof u=="string"?u:u.value;return L.$6e(m,I)}return $._lower===u._lower}static toKey($){return typeof $=="string"?$.toLowerCase():$._lower}}e.$_l=h;class c{get size(){return this.c.size}constructor($){if(this.c=new Set,$)for(const u of $)this.add(u)}add($){this.c.add(h.toKey($))}delete($){return this.c.delete(h.toKey($))}has($){return this.c.has(h.toKey($))}}e.$am=c;class E{constructor(){this.c=new Map}clear(){this.c.clear()}delete($){this.c.delete(h.toKey($))}get($){return this.c.get(h.toKey($))}has($){return this.c.has(h.toKey($))}set($,u){this.c.set(h.toKey($),u)}values(){return this.c.values()}forEach($){this.c.forEach($)}[Symbol.iterator](){return this.c[Symbol.iterator]()}}e.$bm=E;function R(y){return d(y)}e.$cm=R;function d(y){return y.contributes&&y.contributes.localizations?y.contributes.localizations.length>0:!1}e.$dm=d;function f(y){return y.contributes&&y.contributes.authentication?y.contributes.authentication.length>0:!1}e.$em=f;function S(y,$){if($){const u=`onResolveRemoteAuthority:${(0,D.$2k)($)}`;return!!y.activationEvents?.includes(u)}return!1}e.$fm=S,e.$gm=(0,N.$Vh)("IBuiltinExtensionsScannerService")}),define(te[134],ne([0,1,2,37,12]),function(J,e,L,N,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mp=void 0;class A extends L.$Rc{constructor(v,h,c,E,R){super(),this.a=v,this.b=h,this.c=c,this.f=R,this.B(E.onDidInstallExtensions(d=>this.g(d))),this.B(E.onDidUninstallExtension(d=>this.h(d)))}g(v){for(const h of v)h.local&&this.invalidate(h.profileLocation)}h(v){v.error||this.invalidate(v.profileLocation)}async invalidate(v){if(v)for(const h of this.a.profiles)this.c.extUri.isEqual(h.extensionsResource,v)&&await this.j(h);else await this.j(this.a.defaultProfile)}async j(v){try{await this.b.del(this.c.extUri.joinPath(v.cacheHome,N.$6l))}catch(h){(0,D.$vk)(h)!==1&&this.f.error(h)}}}e.$Mp=A}),define(te[44],ne([0,1,14,9,2,103,43,10,6,36]),function(J,e,L,N,D,A,j,v,h,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6o=e.$5o=e.$4o=e.$3o=e.$2o=e.$1o=e.$Zo=e.$Yo=void 0,e.$Yo=(0,v.$Vh)("requestService");class E{constructor(P){this.b=P}toJSON(){if(!this.a){const P=Object.create(null);for(const s in this.b)s.toLowerCase()==="authorization"||s.toLowerCase()==="proxy-authorization"?P[s]="*****":P[s]=this.b[s];this.a=P}return this.a}}class R extends D.$Rc{constructor(P){super(),this.b=0,this.a=P.createLogger("network",{name:(0,A.localize)(0,null),when:h.$uj.isEqualTo((0,h.$sj)(h.LogLevel.Trace)).serialize()})}async c(P,s,o){const t=`${P} #${++this.b}: ${s.url}`;this.a.trace(`${t} - begin`,s.type,new E(s.headers??{}));try{const n=await o();return this.a.trace(`${t} - end`,s.type,n.res.statusCode,n.res.headers),n}catch(n){throw this.a.error(`${t} - error`,s.type,(0,N.$9)(n)),n}}}e.$Zo=R;function d(w){return w.res.statusCode&&w.res.statusCode>=200&&w.res.statusCode<300||w.res.statusCode===1223}e.$1o=d;function f(w){return w.res.statusCode===204}e.$2o=f;async function S(w){return f(w)?null:(await(0,L.$re)(w.stream)).toString()}e.$3o=S;async function y(w){if(!d(w))throw new Error("Server returned "+w.res.statusCode);return S(w)}e.$4o=y;async function $(w){if(!d(w))throw new Error("Server returned "+w.res.statusCode);if(f(w))return null;const s=(await(0,L.$re)(w.stream)).toString();try{return JSON.parse(s)}catch(o){throw o.message+=`:
`+s,o}}e.$5o=$;function u(w){I(w)}e.$6o=u;let m;function I(w){const P=c.$mn.as(j.$rn.Configuration),s=m;m={id:"http",order:15,title:(0,A.localize)(1,null),type:"object",scope:w,properties:{"http.proxy":{type:"string",pattern:"^(https?|socks|socks4a?|socks5h?)://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,A.localize)(2,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,A.localize)(3,null),restricted:!0},"http.proxyKerberosServicePrincipal":{type:"string",markdownDescription:(0,A.localize)(4,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,A.localize)(5,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,A.localize)(6,null),(0,A.localize)(7,null),(0,A.localize)(8,null),(0,A.localize)(9,null)],default:"override",description:(0,A.localize)(10,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,A.localize)(11,null),restricted:!0},"http.experimental.systemCertificatesV2":{type:"boolean",tags:["experimental"],default:!1,description:(0,A.localize)(12,null),restricted:!0}}},P.updateConfigurations({add:[m],remove:s?[s]:[]})}I(1)}),define(te[135],ne([0,1,20,15,12,44]),function(J,e,L,N,D,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_N=void 0;let j=class{constructor(h,c){this.a=h,this.b=c}async download(h,c,E=L.CancellationToken.None){if(h.scheme===N.Schemas.file||h.scheme===N.Schemas.vscodeRemote){await this.b.copy(h,c);return}const R={type:"GET",url:h.toString(!0)},d=await this.a.request(R,E);if(d.res.statusCode===200)await this.b.writeFile(c,d.stream);else{const f=await(0,A.$4o)(d);throw new Error(`Expected 200, got back ${d.res.statusCode} instead.

${f}`)}}};e.$_N=j,e.$_N=j=pe([ie(0,A.$Yo),ie(1,D.$ek)],j)}),define(te[136],ne([0,1,137,3]),function(J,e,L,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4q=void 0;function D(j,v){return j.protocol==="http:"?v.HTTP_PROXY||v.http_proxy||null:j.protocol==="https:"&&(v.HTTPS_PROXY||v.https_proxy||v.HTTP_PROXY||v.http_proxy)||null}async function A(j,v,h={}){const c=(0,L.parse)(j),E=h.proxyUrl||D(c,v);if(!E)return null;const R=(0,L.parse)(E);if(!/^https?:$/.test(R.protocol||""))return null;const d={host:R.hostname||"",port:(R.port?+R.port:0)||(R.protocol==="https"?443:80),auth:R.auth,rejectUnauthorized:(0,N.$If)(h.strictSSL)?h.strictSSL:!0};return c.protocol==="http:"?new(await new Promise((f,S)=>{J(["http-proxy-agent"],f,S)})).HttpProxyAgent(E,d):new(await new Promise((f,S)=>{J(["https-proxy-agent"],f,S)})).HttpsProxyAgent(E,d)}e.$4q=A}),define(te[138],ne([0,1,58,16,104,20,34,9,13,28,84,172,8,72]),function(J,e,L,N,D,A,j,v,h,c,E,R,d,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zl=void 0;let S;async function y(u,m,I,w){return I["force-disable-user-env"]?(m.trace("resolveShellEnv(): skipped (--force-disable-user-env)"),{}):h.$i?(m.trace("resolveShellEnv(): skipped (Windows)"),{}):(0,R.$Tl)(w)&&!I["force-user-env"]?(m.trace("resolveShellEnv(): skipped (VSCODE_CLI is set)"),{}):((0,R.$Tl)(w)?m.trace("resolveShellEnv(): running (--force-user-env)"):m.trace("resolveShellEnv(): running (macOS/Linux)"),S||(S=d.Promises.withAsyncBody(async(P,s)=>{const o=new A.$2d;let t=1e4;const n=u.getValue("application.shellEnvironmentResolutionTimeout");typeof n=="number"&&(t=(0,f.$Ul)(n,1,120)*1e3);const i=setTimeout(()=>{o.dispose(!0),s(new Error((0,D.localize)(0,null)))},t);try{P(await $(m,o.token))}catch(r){!(0,v.$3)(r)&&!o.token.isCancellationRequested?s(new Error((0,D.localize)(1,null,(0,j.$Gi)(r)))):P({})}finally{clearTimeout(i),o.dispose()}})),S)}e.$Zl=y;async function $(u,m){const I=process.env.ELECTRON_RUN_AS_NODE;u.trace("getUnixShellEnvironment#runAsNode",I);const w=process.env.ELECTRON_NO_ATTACH_CONSOLE;u.trace("getUnixShellEnvironment#noAttach",w);const P=(0,c.$ig)().replace(/-/g,"").substr(0,12),s=new RegExp(P+"({.*})"+P),o={...process.env,ELECTRON_RUN_AS_NODE:"1",ELECTRON_NO_ATTACH_CONSOLE:"1",VSCODE_RESOLVING_ENVIRONMENT:"1"};u.trace("getUnixShellEnvironment#env",o);const t=await(0,E.$Jl)(h.OS,o);return u.trace("getUnixShellEnvironment#shell",t),new Promise((n,i)=>{if(m.isCancellationRequested)return i(new v.$4);const r=(0,N.$mc)(t);let l,k;const b=process.versions.electron&&process.versions["microsoft-build"]?"--ms-enable-electron-run-as-node":"";/^pwsh(-preview)?$/.test(r)?(l=`& '${process.execPath}' ${b} -p '''${P}'' + JSON.stringify(process.env) + ''${P}'''`,k=["-Login","-Command"]):r==="nu"?(l=`^'${process.execPath}' ${b} -p '"${P}" + JSON.stringify(process.env) + "${P}"'`,k=["-i","-l","-c"]):(l=`'${process.execPath}' ${b} -p '"${P}" + JSON.stringify(process.env) + "${P}"'`,r==="tcsh"||r==="csh"?k=["-ic"]:k=["-i","-l","-c"]),u.trace("getUnixShellEnvironment#spawn",JSON.stringify(k),l);const p=(0,L.spawn)(t,[...k,l],{detached:!0,stdio:["ignore","pipe","pipe"],env:o});m.onCancellationRequested(()=>(p.kill(),i(new v.$4))),p.on("error",_=>{u.error("getUnixShellEnvironment#errorChildProcess",(0,j.$Gi)(_)),i(_)});const O=[];p.stdout.on("data",_=>O.push(_));const B=[];p.stderr.on("data",_=>B.push(_)),p.on("close",(_,ee)=>{const oe=Buffer.concat(O).toString("utf8");u.trace("getUnixShellEnvironment#raw",oe);const se=Buffer.concat(B).toString("utf8");if(se.trim()&&u.trace("getUnixShellEnvironment#stderr",se),_||ee)return i(new Error((0,D.localize)(2,null,_,ee)));const ue=s.exec(oe),ce=ue?ue[1]:"{}";try{const re=JSON.parse(ce);I?re.ELECTRON_RUN_AS_NODE=I:delete re.ELECTRON_RUN_AS_NODE,w?re.ELECTRON_NO_ATTACH_CONSOLE=w:delete re.ELECTRON_NO_ATTACH_CONSOLE,delete re.VSCODE_RESOLVING_ENVIRONMENT,delete re.XDG_RUNTIME_DIR,u.trace("getUnixShellEnvironment#result",re),n(re)}catch(re){u.error("getUnixShellEnvironment#errorCaught",(0,j.$Gi)(re)),i(re)}})})}}),define(te[139],ne([0,1,10]),function(J,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ON=e.$NN=void 0,e.$NN=(0,L.$Vh)("stateReadService"),e.$ON=(0,L.$Vh)("stateService")}),define(te[68],ne([0,1,8,14,2,3,18,12,6]),function(J,e,L,N,D,A,j,v,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$RN=e.$QN=e.$PN=e.SaveStrategy=void 0;var c;(function(f){f[f.IMMEDIATE=0]="IMMEDIATE",f[f.DELAYED=1]="DELAYED"})(c||(e.SaveStrategy=c={}));class E extends D.$Rc{constructor(S,y,$,u){super(),this.h=S,this.j=y,this.m=$,this.n=u,this.a=Object.create(null),this.b="",this.c=this.B(new L.$Vg(this.j===0?0:100)),this.f=void 0,this.g=void 0}init(){return this.f||(this.f=this.r()),this.f}async r(){try{this.b=(await this.n.readFile(this.h)).value.toString(),this.a=JSON.parse(this.b)}catch(S){S.fileOperationResult!==1&&this.m.error(S)}}getItem(S,y){const $=this.a[S];return(0,A.$Lf)($)?y:$}setItem(S,y){this.setItems([{key:S,data:y}])}setItems(S){let y=!1;for(const{key:$,data:u}of S)this.a[$]!==u&&((0,A.$Lf)(u)?(0,A.$Jf)(this.a[$])||(this.a[$]=void 0,y=!0):(this.a[$]=u,y=!0));y&&this.s()}removeItem(S){(0,A.$Jf)(this.a[S])||(this.a[S]=void 0,this.s())}async s(){if(!this.g)return this.c.trigger(()=>this.t())}async t(){if(!this.f)return;await this.f;const S=JSON.stringify(this.a,null,4);if(S!==this.b)try{await this.n.writeFile(this.h,N.$fe.fromString(S),{atomic:{postfix:".vsctmp"}}),this.b=S}catch(y){this.m.error(y)}}async close(){return this.g||(this.g=this.c.trigger(()=>this.t(),0)),this.g}}e.$PN=E;let R=class extends D.$Rc{constructor(S,y,$,u){super(),this.a=this.B(new E(y.stateResource,S,$,u))}async init(){await this.a.init()}getItem(S,y){return this.a.getItem(S,y)}};e.$QN=R,e.$QN=R=pe([ie(1,j.$3h),ie(2,h.$dj),ie(3,v.$ek)],R);class d extends R{setItem(S,y){this.a.setItem(S,y)}setItems(S){this.a.setItems(S)}removeItem(S){this.a.removeItem(S)}close(){return this.a.close()}}e.$RN=d}),define(te[69],ne([0,1,13,35,28]),function(J,e,L,N,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$oo=e.$no=void 0;function A(h){if(L.$u===2&&/^penguin(\.|$)/i.test(h))return"chromebook"}function j(h,c,E,R,d,f,S,y,$){const u=Object.create(null);u["common.machineId"]=f,u["common.sqmId"]=S,u.sessionID=(0,D.$ig)()+Date.now(),u.commitHash=R,u.version=d,u["common.platformVersion"]=(h||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),u["common.platform"]=(0,L.$h)(L.$u),u["common.nodePlatform"]=N.$cc,u["common.nodeArch"]=E,u["common.product"]=$||"desktop",y&&(u["common.msftInternal"]=y);let m=0;const I=Date.now();Object.defineProperties(u,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-I,enumerable:!0},"common.sequence":{get:()=>m++,enumerable:!0}}),L.$l&&(u["common.snap"]="true");const w=A(c);return w&&(u["common.platformDetail"]=w),u}e.$no=j;function v(h){const c=N.env.USERDNSDOMAIN;if(!c)return!1;const E=c.toLowerCase();return h.some(R=>E===R)}e.$oo=v}),define(te[26],ne([0,1,10]),function(J,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.$sl=e.$rl=e.$ql=e.$pl=e.$ol=e.$nl=e.$ml=e.$ll=e.$kl=e.$jl=e.$il=void 0,e.$il=(0,L.$Vh)("telemetryService"),e.$jl=(0,L.$Vh)("customEndpointTelemetryService"),e.$kl="telemetry.currentSessionDate",e.$ll="telemetry.firstSessionDate",e.$ml="telemetry.lastSessionDate",e.$nl="telemetry.machineId",e.$ol="telemetry.sqmId",e.$pl="telemetry",e.$ql="telemetry.telemetryLevel",e.$rl="telemetry.enableCrashReporter",e.$sl="telemetry.enableTelemetry";var N;(function(A){A[A.NONE=0]="NONE",A[A.CRASH=1]="CRASH",A[A.ERROR=2]="ERROR",A[A.USAGE=3]="USAGE"})(N||(e.TelemetryLevel=N={}));var D;(function(A){A.OFF="off",A.CRASH="crash",A.ERROR="error",A.ON="all"})(D||(e.TelemetryConfiguration=D={}))}),define(te[39],ne([0,1,30,3,4,25,67,69,26]),function(J,e,L,N,D,A,j,v,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Eo=e.$Do=e.$Co=e.$Bo=e.$Ao=e.$zo=e.$yo=e.$xo=e.$wo=e.$vo=e.$uo=e.$to=e.$so=e.$ro=e.$qo=e.$po=void 0;class c{constructor(i){this.value=i,this.isTrustedTelemetryValue=!0}}e.$po=c;class E{constructor(){this.telemetryLevel=0,this.sessionId="someValue.sessionId",this.machineId="someValue.machineId",this.firstSessionDate="someValue.firstSessionDate",this.sendErrorTelemetry=!1}publicLog(){}publicLog2(){}publicLogError(){}publicLogError2(){}setExperimentProperty(){}}e.$qo=E,e.$ro=new E;class R{async publicLog(i,r,l){}async publicLogError(i,r,l){}}e.$so=R,e.$to="telemetry",e.$uo="extensionTelemetryLog",e.$vo={log:()=>null,flush:()=>Promise.resolve(null)};function d(n,i){return D.Event.debounce(i.onDidChangeConfiguration,(l,k)=>{const b=l?new Set([...l.affectedKeys,...k.affectedKeys]):k.affectedKeys;return{...k,affectedKeys:b}},1e3,!0)(l=>{l.source!==7&&n.publicLog2("updateConfiguration",{configurationSource:(0,A.$si)(l.source),configurationKeys:Array.from(l.affectedKeys)})})}e.$wo=d;function f(n,i){return!i.isBuilt&&!i.disableTelemetry?!0:!(i.disableTelemetry||!n.enableTelemetry)}e.$xo=f;function S(n,i){return i.extensionTestsLocationURI?!0:!(i.isBuilt||i.disableTelemetry||n.enableTelemetry&&n.aiConfig?.ariaKey)}e.$yo=S;function y(n){const i=n.getValue(h.$ql),r=n.getValue(h.$rl);if(n.getValue(h.$sl)===!1||r===!1)return 0;switch(i??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}e.$zo=y;function $(n){const i={},r={},l={};I(n,l);for(let k in l){k=k.length>150?k.substr(k.length-149):k;const b=l[k];typeof b=="number"?r[k]=b:typeof b=="boolean"?r[k]=b?1:0:typeof b=="string"?(b.length>8192&&console.warn(`Telemetry property: ${k} has been trimmed to 8192, the original length is ${b.length}`),i[k]=b.substring(0,8191)):typeof b<"u"&&b!==null&&(i[k]=b)}return{properties:i,measurements:r}}e.$Ao=$;const u=new Set(["ssh-remote","dev-container","attached-container","wsl","tunnel","codespaces","amlext"]);function m(n){if(!n)return"none";const i=(0,j.$2k)(n);return u.has(i)?i:"other"}e.$Bo=m;function I(n,i,r=0,l){if(n)for(const k of Object.getOwnPropertyNames(n)){const b=n[k],p=l?l+k:k;Array.isArray(b)?i[p]=(0,L.$fn)(b):b instanceof Date?i[p]=b.toISOString():(0,N.$Ef)(b)?r<2?I(b,i,r+1,p+"."):i[p]=(0,L.$fn)(b):i[p]=b}}function w(n,i){const r=n.msftInternalDomains||[],l=i.getValue("telemetry.internalTesting");return(0,v.$oo)(r)||l}e.$Co=w;function P(n){return[n.appRoot,n.extensionsPath,n.userHome.fsPath,n.tmpDir.fsPath,n.userDataPath]}e.$Do=P;function s(n,i){if(!n||!n.includes("/")&&!n.includes("\\"))return n;let r=n;const l=[];for(const O of i)for(;;){const B=O.exec(n);if(!B)break;l.push([B.index,O.lastIndex])}const k=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,b=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let p=0;for(r="";;){const O=b.exec(n);if(!O)break;const B=l.some(([_,ee])=>O.index<ee&&_<b.lastIndex);!k.test(O[0])&&!B&&(r+=n.substring(p,O.index)+"<REDACTED: user-file-path>",p=b.lastIndex)}return p<n.length&&(r+=n.substr(p)),r}function o(n){if(!n)return n;const i=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/i},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const r of i)if(r.regex.test(n))return`<REDACTED: ${r.label}>`;return n}function t(n,i){return(0,L.$cn)(n,r=>{if(r instanceof c||Object.hasOwnProperty.call(r,"isTrustedTelemetryValue"))return r.value;if(typeof r=="string"){let l=r.replaceAll("%20"," ");l=s(l,i);for(const k of i)l=l.replace(k,"");return l=o(l),l}})}e.$Eo=t}),define(te[27],ne([0,1,29,21,37,13,11,9,35,39]),function(J,e,L,N,D,A,j,v,h,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qo=e.$Po=e.$Oo=e.$No=e.$Mo=e.$Lo=e.$Ko=e.$Jo=e.$Io=e.$Ho=e.$Go=e.$Fo=void 0;function E(t,n){return t.uuid&&n.uuid?t.uuid===n.uuid:t.id===n.id?!0:(0,L.$1e)(t.id,n.id)===0}e.$Fo=E;const R=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class d{static create(n){const i=n.manifest?n.manifest.version:n.version,r=n.manifest?n.targetPlatform:n.properties.targetPlatform;return new d(n.identifier,i,r)}static parse(n){const i=R.exec(n);return i&&i[1]&&i[2]?new d({id:i[1]},i[2],i[4]||void 0):null}constructor(n,i,r="undefined"){this.version=i,this.targetPlatform=r,this.id=n.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals(n){return n instanceof d?E(this,n)&&this.version===n.version&&this.targetPlatform===n.targetPlatform:!1}}e.$Go=d;const f=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function S(t){const n=f.exec(t);return n&&n[1]?[$(n[1]),n[2]]:[$(t),void 0]}e.$Ho=S;function y(t,n){return`${t}.${n}`}e.$Io=y;function $(t){return t.toLowerCase()}e.$Jo=$;function u(t,n){return $(y(t??D.$8l,n))}e.$Ko=u;function m(t,n){const i=[],r=l=>{for(const k of i)if(k.some(b=>E(n(b),n(l))))return k;return null};for(const l of t){const k=r(l);k?k.push(l):i.push([l])}return i}e.$Lo=m;function I(t){return{id:t.identifier.id,name:t.manifest.name,galleryId:null,publisherId:t.publisherId,publisherName:t.manifest.publisher,publisherDisplayName:t.publisherDisplayName,dependencies:t.manifest.extensionDependencies&&t.manifest.extensionDependencies.length>0}}e.$Mo=I;function w(t){return{id:new c.$po(t.identifier.id),name:new c.$po(t.name),galleryId:t.identifier.uuid,publisherId:t.publisherId,publisherName:t.publisher,publisherDisplayName:t.publisherDisplayName,isPreReleaseVersion:t.properties.isPreReleaseVersion,dependencies:!!(t.properties.dependencies&&t.properties.dependencies.length>0),isSigned:t.isSigned,...t.telemetryData}}e.$No=w,e.$Oo=new D.$_l("pprice.better-merge");function P(t,n){const i=[],r=n.manifest.extensionDependencies?.slice(0)??[];for(;r.length;){const l=r.shift();if(l&&i.every(k=>!E(k.identifier,{id:l}))){const k=t.filter(b=>E(b.identifier,{id:l}));k.length===1&&(i.push(k[0]),r.push(...k[0].manifest.extensionDependencies?.slice(0)??[]))}}return i}e.$Po=P;async function s(t,n){if(!A.$k)return!1;let i;try{i=(await t.readFile(j.URI.file("/etc/os-release"))).value.toString()}catch{try{i=(await t.readFile(j.URI.file("/usr/lib/os-release"))).value.toString()}catch(l){n.debug("Error while getting the os-release file.",(0,v.$9)(l))}}return!!i&&(i.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}async function o(t,n){const i=await s(t,n),r=(0,N.$_n)(i?"alpine":A.$u,h.$dc);return n.debug("ComputeTargetPlatform:",r),r}e.$Qo=o}),define(te[140],ne([0,1,20,9,15,17,42,11,93,21,27,37]),function(J,e,L,N,D,A,j,v,h,c,E,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mp=void 0;const d=$=>(0,h.localize)(0,null,$),f=(0,h.localize)(1,null,"ms-dotnettools.csharp");function S($,u){return u?`${$.publisher}.${$.name}@${$.version}`:`${$.publisher}.${$.name}`}let y=class{constructor(u,m,I){this.a=u,this.b=m,this.d=I}get f(){}async listExtensions(u,m,I){let w=await this.b.getInstalled(1,I);const P=R.$$l.map(o=>o.toLowerCase());if(m&&m!==""){if(P.indexOf(m.toLowerCase())<0){this.a.info("Invalid category please enter a valid category. To list valid categories run --category without a category specified");return}w=w.filter(o=>o.manifest.categories?o.manifest.categories.map(n=>n.toLowerCase()).indexOf(m.toLowerCase())>-1:!1)}else if(m===""){this.a.info("Possible Categories: "),P.forEach(o=>{this.a.info(o)});return}this.f&&this.a.info((0,h.localize)(2,null,this.f)),w=w.sort((o,t)=>o.identifier.id.localeCompare(t.identifier.id));let s;for(const o of w)s!==o.identifier.id&&(s=o.identifier.id,this.a.info(S(o.manifest,u)))}async installExtensions(u,m,I,w){const P=[];try{const s=[];u.length&&this.a.info(this.f?(0,h.localize)(3,null,this.f):(0,h.localize)(4,null));const o=[];let t=[];const n=(r,l,k)=>{t.push({id:r,version:l!=="prerelease"?l:void 0,installOptions:{...I,isBuiltin:k,installPreReleaseVersion:l==="prerelease"||I.installPreReleaseVersion}})};for(const r of u)if(r instanceof v.URI)o.push({vsix:r,installOptions:I});else{const[l,k]=(0,E.$Ho)(r);n(l,k,!1)}for(const r of m)if(r instanceof v.URI)o.push({vsix:r,installOptions:{...I,isBuiltin:!0,donotIncludePackAndDependencies:!0}});else{const[l,k]=(0,E.$Ho)(r);n(l,k,!0)}const i=await this.b.getInstalled(1,I.profileLocation);if(o.length&&await Promise.all(o.map(async({vsix:r,installOptions:l})=>{try{const k=await this.g(r,l,w,i);k&&s.push(k)}catch(k){this.a.error(k),P.push(r.toString())}})),t.length&&(t=t.filter(({id:r,version:l})=>{const k=i.find(b=>(0,E.$Fo)(b.identifier,{id:r}));if(k){if(!w&&(!l||l==="prerelease"&&k.preRelease))return this.a.info((0,h.localize)(5,null,r,k.manifest.version,r)),!1;if(l&&k.manifest.version===l)return this.a.info((0,h.localize)(6,null,`${r}@${l}`)),!1}return!0}),t.length)){const r=await this.h(t);await Promise.all(t.map(async l=>{const k=r.get(l.id.toLowerCase());if(k)try{const b=await this.j(l,k,i);b&&s.push(b)}catch(b){this.a.error(b.message||b.stack||b),P.push(l.id)}else this.a.error(`${d(l.version?`${l.id}@${l.version}`:l.id)}
${f}`),P.push(l.id)}))}}catch(s){throw this.a.error((0,h.localize)(7,null,(0,N.$9)(s))),s}if(P.length)throw new Error((0,h.localize)(8,null,P.join(", ")))}async g(u,m,I,w){const P=await this.b.getManifest(u);if(!P)throw new Error("Invalid vsix");if(await this.l(P,I,m.profileLocation,w))try{return await this.b.install(u,m),this.a.info((0,h.localize)(9,null,(0,A.$wg)(u))),P}catch(o){if((0,N.$3)(o))return this.a.info((0,h.localize)(10,null,(0,A.$wg)(u))),null;throw o}return null}async h(u){const m=new Map,I=u.some(s=>s.installOptions.installPreReleaseVersion),w=await this.b.getTargetPlatform(),P=[];for(const s of u)c.$5n.test(s.id)&&P.push({...s,preRelease:I});if(P.length){const s=await this.d.getExtensions(P,{targetPlatform:w},L.CancellationToken.None);for(const o of s)m.set(o.identifier.id.toLowerCase(),o)}return m}async j({id:u,version:m,installOptions:I},w,P){const s=await this.d.getManifest(w,L.CancellationToken.None);if(s&&!this.k(s))return null;const o=P.find(t=>(0,E.$Fo)(t.identifier,w.identifier));if(o){if(w.version===o.manifest.version)return this.a.info((0,h.localize)(11,null,m?`${u}@${m}`:u)),null;this.a.info((0,h.localize)(12,null,u,w.version))}try{I.isBuiltin?this.a.info(m?(0,h.localize)(13,null,u,m):(0,h.localize)(14,null,u)):this.a.info(m?(0,h.localize)(15,null,u,m):(0,h.localize)(16,null,u));const t=await this.b.installFromGallery(w,{...I,installGivenVersion:!!m});return this.a.info((0,h.localize)(17,null,u,t.manifest.version)),s}catch(t){if((0,N.$3)(t))return this.a.info((0,h.localize)(18,null,u)),null;throw t}}k(u){return!0}async l(u,m,I,w){if(!m){const P={id:(0,E.$Ko)(u.publisher,u.name)},s=w.find(o=>(0,E.$Fo)(P,o.identifier)&&(0,j.gt)(o.manifest.version,u.version));if(s)return this.a.info((0,h.localize)(19,null,s.identifier.id,s.manifest.version,u.version)),!1}return this.k(u)}async uninstallExtensions(u,m,I){const w=async s=>{if(s instanceof v.URI){const o=await this.b.getManifest(s);return S(o)}return s},P=[];for(const s of u){const o=await w(s),n=(await this.b.getInstalled(void 0,I)).filter(i=>(0,E.$Fo)(i.identifier,{id:o}));if(!n.length)throw new Error(`${this.m(o)}
${f}`);if(n.some(i=>i.type===0)){this.a.info((0,h.localize)(20,null,o));return}if(!m&&n.some(i=>i.isBuiltin)){this.a.info((0,h.localize)(21,null,o));return}this.a.info((0,h.localize)(22,null,o));for(const i of n)await this.b.uninstall(i,{profileLocation:I}),P.push(i);this.f?this.a.info((0,h.localize)(23,null,o,this.f)):this.a.info((0,h.localize)(24,null,o))}}async locateExtension(u){const m=await this.b.getInstalled();u.forEach(I=>{m.forEach(w=>{if(w.identifier.id===I&&w.location.scheme===D.Schemas.file){this.a.info(w.location.fsPath);return}})})}m(u){return this.f?(0,h.localize)(25,null,u,this.f):(0,h.localize)(26,null,u)}};e.$mp=y,e.$mp=y=pe([ie(1,c.$fo),ie(2,c.$do)],y)}),define(te[141],ne([0,1,4,2,31,27,37]),function(J,e,L,N,D,A,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Np=void 0;class v extends N.$Rc{constructor(c,E,R,d,f,S,y){super(),this.f=c,this.g=E,this.h=R,this.j=d,this.m=f,this.n=S,this.r=y,this.a=this.B(new L.$Rd),this.onDidChangeExtensionsByAnotherSource=this.a.event,this.b=new Map,this.c=this.B(new N.$1c),this.s().then(null,$=>y.error($))}async s(){await this.g.initializeDefaultProfileExtensions(),await this.u(this.h.profiles),this.t(),await this.H()}t(){this.B(this.h.onDidChangeProfiles(c=>this.u(c.added))),this.B(this.j.onAddExtensions(c=>this.w(c))),this.B(this.j.onDidAddExtensions(c=>this.y(c))),this.B(this.j.onRemoveExtensions(c=>this.z(c))),this.B(this.j.onDidRemoveExtensions(c=>this.C(c))),this.B(this.n.onDidFilesChange(c=>this.D(c)))}async u(c){try{c.length&&await Promise.all(c.map(E=>(this.c.set(E.id,(0,N.$Oc)(this.n.watch(this.m.extUri.dirname(E.extensionsResource)),this.n.watch(E.extensionsResource))),this.G(E.extensionsResource))))}catch(E){throw this.r.error(E),E}}async w(c){for(const E of c.extensions)this.I(this.L(E.identifier,E.version),c.profileLocation)}async y(c){for(const E of c.extensions){const R=this.L(E.identifier,E.version);c.error?this.J(R,c.profileLocation):this.I(R,c.profileLocation)}}async z(c){for(const E of c.extensions)this.J(this.L(E.identifier,E.version),c.profileLocation)}async C(c){const E=[],R=[];for(const d of c.extensions){const f=this.L(d.identifier,d.version);c.error?this.I(f,c.profileLocation):(this.J(f,c.profileLocation),this.b.has(f)||(this.r.debug("Extension is removed from all profiles",d.identifier.id,d.version),R.push(this.f.scanInstalledExtensionAtLocation(d.location).then(S=>{S?E.push(S):this.r.info("Extension not found at the location",d.location.toString())},S=>this.r.error(S)))))}try{await Promise.all(R),E.length&&await this.H(E)}catch(d){this.r.error(d)}}D(c){for(const E of this.h.profiles)c.contains(E.extensionsResource,0,1)&&this.F(E.extensionsResource)}async F(c){const E=[],R=[],d=await this.j.scanProfileExtensions(c),f=new Set,S=new Set;for(const[y,$]of this.b)$.has(c)&&S.add(y);for(const y of d){const $=this.L(y.identifier,y.version);f.add($),S.has($)||(E.push(y.identifier),this.I($,c))}for(const y of S)if(!f.has(y)){const $=this.M(y);$&&(R.push($.identifier),this.J(y,c))}(E.length||R.length)&&this.a.fire({added:E.length?{extensions:E,profileLocation:c}:void 0,removed:R.length?{extensions:R,profileLocation:c}:void 0})}async G(c){const E=await this.j.scanProfileExtensions(c);for(const R of E)this.I(this.L(R.identifier,R.version),c)}async H(c){c||(c=(await this.f.scanAllUserInstalledExtensions()).filter(R=>!this.b.has(this.L(R.identifier,R.manifest.version)))),c.length&&await this.f.markAsUninstalled(...c)}I(c,E){let R=this.b.get(c);R||this.b.set(c,R=new D.$Ac(d=>this.m.extUri.getComparisonKey(d))),R.add(E)}J(c,E){const R=this.b.get(c);R&&R.delete(E),R?.size||this.b.delete(c)}L(c,E){return`${j.$_l.toKey(c.id)}@${E}`}M(c){const[E,R]=(0,A.$Ho)(c);return R?{identifier:{id:E},version:R}:void 0}}e.$Np=v}),define(te[142],ne([0,1,113,39]),function(J,e,L,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gp=void 0;async function D(A,j,v,h,c,E,R){const d={"X-Market-Client-Id":`VSCode ${A}`,"User-Agent":`VSCode ${A} (${j.nameShort})`};if((0,N.$xo)(j,v)&&(0,N.$zo)(h)===3){const f=await(0,L.$fp)(v,c,E);d["X-Market-User-Id"]=f,d["VSCode-SessionId"]=R.machineId||f}return d}e.$gp=D}),define(te[143],ne([0,1,173,19,8,2,15,16,24,18,21,27,6,64,11]),function(J,e,L,N,D,A,j,v,h,c,E,R,d,f,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1q=void 0;let y=class extends f.$Zq{constructor(I,w,P,s){super(P),this.h=I,this.j=s,this.g=this.B(new $(w,s)),this.h.registerParticipant({postInstall:async o=>this.m(o),postUninstall:async o=>this.n(o)})}async getBuiltInExtensionTranslationsUri(I,w){const s=(await this.g.getLanguagePacks())[w];if(!s){this.j.warn(`No language pack found for ${w}`);return}const o=s.translations[I];return o?S.URI.file(o):void 0}async getInstalledLanguages(){const I=await this.g.getLanguagePacks(),w=Object.keys(I).map(P=>{const s=I[P];return{...this.f(P,s.label),extensionId:s.extensions[0].extensionIdentifier.id}});return w.push(this.f("en","English")),w.sort((P,s)=>P.label.localeCompare(s.label)),w}async m(I){I&&I.manifest&&I.manifest.contributes&&I.manifest.contributes.localizations&&I.manifest.contributes.localizations.length&&(this.j.info("Adding language packs from the extension",I.identifier.id),await this.update())}async n(I){const w=await this.g.getLanguagePacks();Object.keys(w).some(P=>w[P]&&w[P].extensions.some(s=>(0,R.$Fo)(s.extensionIdentifier,I.identifier)))&&(this.j.info("Removing language packs from the extension",I.identifier.id),await this.update())}async update(){const[I,w]=await Promise.all([this.g.getLanguagePacks(),this.h.getInstalled()]),P=await this.g.update(w);return!(0,N.$tb)(Object.keys(I),Object.keys(P))}};e.$1q=y,e.$1q=y=pe([ie(0,E.$fo),ie(1,c.$4h),ie(2,E.$do),ie(3,d.$dj)],y);let $=class extends A.$Rc{constructor(I,w){super(),this.j=w,this.c={},this.f=(0,v.$ic)(I.userDataPath,"languagepacks.json"),this.g=new D.$5g}getLanguagePacks(){return this.g.size||!this.h?this.s().then(()=>this.c):Promise.resolve(this.c)}update(I){return this.s(w=>{Object.keys(w).forEach(P=>delete w[P]),this.m(w,...I)}).then(()=>this.c)}m(I,...w){for(const P of w)P&&P.manifest&&P.manifest.contributes&&P.manifest.contributes.localizations&&P.manifest.contributes.localizations.length&&this.n(I,P);Object.keys(I).forEach(P=>this.r(I[P]))}n(I,w){const P=w.identifier,s=w.manifest.contributes&&w.manifest.contributes.localizations?w.manifest.contributes.localizations:[];for(const o of s)if(w.location.scheme===j.Schemas.file&&u(o)){let t=I[o.languageId];t||(t={hash:"",extensions:[],translations:{},label:o.localizedLanguageName??o.languageName},I[o.languageId]=t);const n=t.extensions.filter(i=>(0,R.$Fo)(i.extensionIdentifier,P))[0];n?n.version=w.manifest.version:t.extensions.push({extensionIdentifier:P,version:w.manifest.version});for(const i of o.translations)t.translations[i.id]=(0,v.$ic)(w.location.fsPath,i.path)}}r(I){if(I){const w=(0,L.createHash)("md5");for(const P of I.extensions)w.update(P.extensionIdentifier.uuid||P.extensionIdentifier.id).update(P.version);I.hash=w.digest("hex")}}s(I=()=>null){return this.g.queue(()=>{let w=null;return h.Promises.readFile(this.f,"utf8").then(void 0,P=>P.code==="ENOENT"?Promise.resolve("{}"):Promise.reject(P)).then(P=>{try{return JSON.parse(P)}catch{return{}}}).then(P=>(w=I(P),P)).then(P=>{for(const o of Object.keys(P))P[o]||delete P[o];this.c=P,this.h=!0;const s=JSON.stringify(this.c);return this.j.debug("Writing language packs",s),h.Promises.writeFile(this.f,s)}).then(()=>w,P=>this.j.error(P))})}};$=pe([ie(0,c.$4h),ie(1,d.$dj)],$);function u(m){if(typeof m.languageId!="string"||!Array.isArray(m.translations)||m.translations.length===0)return!1;for(const I of m.translations)if(typeof I.id!="string"||typeof I.path!="string")return!1;return!(m.languageName&&typeof m.languageName!="string"||m.localizedLanguageName&&typeof m.localizedLanguageName!="string")}}),define(te[144],ne([0,1,81,9,30,39]),function(J,e,L,N,D,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$JN=void 0;const j="https://mobile.events.data.microsoft.com/OneCollector/1.0",v="https://mobile.events.data.microsoft.com/ping";async function h(E,R,d){const f=await(0,L.$NC)("@microsoft/1ds-core-js","dist/ms.core.js"),S=await(0,L.$NC)("@microsoft/1ds-post-js","dist/ms.post.js"),y=new f.AppInsightsCore,$=new S.PostChannel,u={instrumentationKey:E,endpointUrl:j,loggingLevelTelemetry:0,loggingLevelConsole:0,disableCookiesUsage:!0,disableDbgExt:!0,disableInstrumentationKeyValidation:!0,channels:[[$]]};if(d){u.extensionConfig={};const m={alwaysUseXhrOverride:!0,httpXHROverride:d};u.extensionConfig[$.identifier]=m}return y.initialize(u,[]),y.addTelemetryInitializer(m=>{R&&(m.ext=m.ext??{},m.ext.utc=m.ext.utc??{},m.ext.utc.flags=8462029)}),y}class c{constructor(R,d,f,S,y){this.e=R,this.f=d,this.g=f,this.h=y,this.c=j,this.d=v,this.g||(this.g={}),typeof S=="function"?this.a=S():this.a=S,this.b=null}i(R){if(this.a){if(typeof this.a!="string"){R(this.a);return}this.b||(this.b=h(this.a,this.e,this.h)),this.b.then(d=>{R(d)},d=>{(0,N.$Z)(d),console.error(d)})}}log(R,d){if(!this.a)return;d=(0,D.$dn)(d,this.g),d=(0,A.$Ao)(d);const f=this.f+"/"+R;try{this.i(S=>{S.pluginVersionString=d?.properties.version??"Unknown",S.track({name:f,baseData:{name:f,properties:d?.properties,measurements:d?.measurements}})})}catch{}}flush(){return this.a?new Promise(R=>{this.i(d=>{d.unload(!0,()=>{this.a=void 0,R(void 0)})})}):Promise.resolve(void 0)}}e.$JN=c}),define(te[145],ne([0,1,2,30,13,29,105,25,43,146,32,36,26,39]),function(J,e,L,N,D,A,j,v,h,c,E,R,d,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7q=void 0;let S=class{static{this.IDLE_START_EVENT_NAME="UserIdleStart"}static{this.IDLE_STOP_EVENT_NAME="UserIdleStop"}constructor(u,m,I){this.k=m,this.l=I,this.d={},this.i=new L.$Qc,this.j=[],this.b=u.appenders,this.c=u.commonProperties??Object.create(null),this.sessionId=this.c.sessionID,this.machineId=this.c["common.machineId"],this.firstSessionDate=this.c["common.firstSessionDate"],this.msftInternal=this.c["common.msftInternal"],this.f=u.piiPaths||[],this.g=3,this.h=!!u.sendErrorTelemetry,this.j=[/(vscode-)?file:\/\/\/.*?\/resources\/app\//gi];for(const w of this.f)this.j.push(new RegExp((0,A.$Je)(w),"gi")),w.indexOf("\\")>=0&&this.j.push(new RegExp((0,A.$Je)(w.replace(/\\/g,"/")),"gi"));this.m(),this.i.add(this.k.onDidChangeConfiguration(w=>{(w.affectsConfiguration(d.$ql)||w.affectsConfiguration(d.$sl)||w.affectsConfiguration(d.$rl))&&this.m()}))}setExperimentProperty(u,m){this.d[u]=m}m(){let u=(0,f.$zo)(this.k);const m=this.l.enabledTelemetryLevels;if(m){this.h=this.sendErrorTelemetry?m.error:!1;const I=m.usage?3:m.error?2:0;u=Math.min(u,I)}this.g=u}get sendErrorTelemetry(){return this.h}get telemetryLevel(){return this.g}dispose(){this.i.dispose()}n(u,m,I){this.g<m||(I=(0,N.$dn)(I,this.d),I=(0,f.$Eo)(I,this.j),I=(0,N.$dn)(I,this.c),this.b.forEach(w=>w.log(u,I)))}publicLog(u,m){this.n(u,3,m)}publicLog2(u,m){this.publicLog(u,m)}publicLogError(u,m){this.h&&this.n(u,2,m)}publicLogError2(u,m){this.publicLogError(u,m)}};e.$7q=S,e.$7q=S=pe([ie(1,v.$pi),ie(2,E.$vj)],S);function y(){const $=(0,j.localize)(0,null,c.default.nameLong),u=c.default.privacyStatementUrl?(0,j.localize)(2,null,"https://aka.ms/vscode-telemetry",c.default.privacyStatementUrl):(0,j.localize)(1,null,"https://aka.ms/vscode-telemetry"),m=D.$o?"":(0,j.localize)(3,null),I=(0,j.localize)(4,null),w=(0,j.localize)(5,null),P=(0,j.localize)(6,null),s=(0,j.localize)(7,null),o=`
|       | ${I} | ${w} | ${P} |
|:------|:---------------------:|:---------------:|:--------------:|
| all   |            \u2713          |        \u2713        |        \u2713       |
| error |            \u2713          |        \u2713        |        -       |
| crash |            \u2713          |        -        |        -       |
| off   |            -          |        -        |        -       |
`,t=(0,j.localize)(8,null);return`
${$} ${u} ${m}

&nbsp;

${s}
${o}

&nbsp;

${t}
`}R.$mn.as(h.$rn.Configuration).registerConfiguration({id:d.$pl,order:1,type:"object",title:(0,j.localize)(9,null),properties:{[d.$ql]:{type:"string",enum:["all","error","crash","off"],enumDescriptions:[(0,j.localize)(10,null),(0,j.localize)(11,null),(0,j.localize)(12,null),(0,j.localize)(13,null)],markdownDescription:y(),default:"all",restricted:!0,scope:1,tags:["usesOnlineServices","telemetry"]}}}),R.$mn.as(h.$rn.Configuration).registerConfiguration({id:d.$pl,order:110,type:"object",title:(0,j.localize)(14,null),properties:{[d.$sl]:{type:"boolean",markdownDescription:c.default.privacyStatementUrl?(0,j.localize)(16,null,c.default.nameLong,c.default.privacyStatementUrl):(0,j.localize)(15,null,c.default.nameLong),default:!0,restricted:!0,markdownDeprecationMessage:(0,j.localize)(17,null,`\`#${d.$ql}#\``),scope:1,tags:["usesOnlineServices","telemetry"]}}})}),define(te[147],ne([0,1,14,20,174,144]),function(J,e,L,N,D,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$KN=void 0;async function j(E,R){const d=await R.request(E,N.CancellationToken.None),f=(await(0,L.$re)(d.stream)).toString(),S=d.res.statusCode??200;return{headers:d.res.headers,statusCode:S,responseData:f}}async function v(E){const R={method:E.type,headers:E.headers};return new Promise((f,S)=>{const y=D.request(E.url??"",R,$=>{$.on("data",function(u){f({headers:$.headers,statusCode:$.statusCode??200,responseData:u.toString()})}),$.on("error",function(u){S(u)})});y.write(E.data,$=>{$&&S($)}),y.end()})}async function h(E,R,d){const f=typeof R.data=="string"?R.data:new TextDecoder().decode(R.data),S={type:"POST",headers:{...R.headers,"Content-Type":"application/json","Content-Length":Buffer.byteLength(R.data).toString()},url:R.urlString,data:f};try{const y=E?await j(S,E):await v(S);d(y.statusCode,y.headers,y.responseData)}catch{d(0,{})}}class c extends A.$JN{constructor(R,d,f,S,y){const $={sendPOST:(u,m)=>{h(R,u,m)}};super(d,f,S,y,$)}}e.$KN=c}),define(te[148],ne([0,1,16,24]),function(J,e,L,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$c0b=void 0;async function D(A,j){const v=Object.create(null),h=(E,R)=>{const d=JSON.parse(E);v[R]=d};if(j){const E=[],R=await N.Promises.readdir(j);for(const f of R)try{(await N.Promises.stat((0,L.$ic)(j,f))).isDirectory()&&E.push(f)}catch{}const d=[];for(const f of E)(await N.Promises.readdir((0,L.$ic)(j,f))).filter(y=>y==="telemetry.json").length===1&&d.push(f);for(const f of d){const S=(await N.Promises.readFile((0,L.$ic)(j,f,"telemetry.json"))).toString();h(S,f)}}let c=(await N.Promises.readFile((0,L.$ic)(A,"telemetry-core.json"))).toString();return h(c,"vscode-core"),c=(await N.Promises.readFile((0,L.$ic)(A,"telemetry-extensions.json"))).toString(),h(c,"vscode-extensions"),JSON.stringify(v,null,4)}e.$c0b=D}),define(te[149],ne([0,1,13,82,26]),function(J,e,L,N,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$v9b=e.$u9b=void 0;async function A(v,h){let c=v.getItem(D.$nl);return(typeof c!="string"||L.$j&&c==="6c9d2bc8f91b89624add29c0abeae7fb42bf539fa1cdb2e3e57cd668fa9bcead")&&(c=await(0,N.$Ym)(h.error.bind(h))),c}e.$u9b=A;async function j(v,h){let c=v.getItem(D.$ol);return typeof c!="string"&&(c=await(0,N.$Zm)(h.error.bind(h))),c}e.$v9b=j}),define(te[22],ne([0,1,10]),function(J,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ok=void 0,e.$Ok=(0,L.$Vh)("IUriIdentityService")}),define(te[150],ne([0,1,22,114,12,17,73,4,2]),function(J,e,L,N,D,A,j,v,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fr=void 0;class c{static{this._clock=0}constructor(d){this.uri=d,this.time=c._clock++}touch(){return this.time=c._clock++,this}}let E=class{constructor(d){this.g=d,this.c=new h.$Qc,this.f=2**16;const f=new Map,S=y=>{let $=f.get(y.scheme);return $===void 0&&($=d.hasProvider(y)&&!this.g.hasCapability(y,1024),f.set(y.scheme,$)),$};this.c.add(v.Event.any(d.onDidChangeFileSystemProviderRegistrations,d.onDidChangeFileSystemProviderCapabilities)(y=>{f.delete(y.scheme)})),this.extUri=new A.$og(S),this.d=new j.$Er((y,$)=>this.extUri.compare(y,$,!0),this.f)}dispose(){this.c.dispose(),this.d.clear()}asCanonicalUri(d){this.g.hasProvider(d)&&(d=(0,A.$Ag)(d));const f=this.d.get(d);return f?f.touch().uri.with({fragment:d.fragment}):(this.d.set(d,new c(d)),this.h(),d)}h(){if(this.d.size<this.f)return;const d=[...this.d.entries()].sort((S,y)=>S[1].time<y[1].time?1:S[1].time>y[1].time?-1:0);c._clock=0,this.d.clear();const f=this.f*.5;for(let S=0;S<f;S++)this.d.set(d[S][0],d[S][1].touch())}};e.$Fr=E,e.$Fr=E=pe([ie(0,D.$ek)],E),(0,N.$Cr)(L.$Ok,E,1)}),define(te[151],ne([0,1,4,2,12,47,31]),function(J,e,L,N,D,A,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$S9b=void 0;class v extends N.$Rc{constructor(c,E,R,d,f,S){super(),this.f=c,this.g=E,this.h=R,this.j=d,this.m=f,this.n=S,this.capabilities=this.g.capabilities,this.onDidChangeCapabilities=this.g.onDidChangeCapabilities,this.a=this.B(new L.$Rd),this.onDidChangeFile=this.a.event,this.b=A.$2h.forUris(()=>!(this.capabilities&1024)),this.c=new j.$Ac(y=>this.m.extUri.getComparisonKey(this.t(y))),this.r(),this.B(d.onDidChangeProfiles(()=>this.r())),this.B(this.g.onDidChangeFile(y=>this.s(y)))}r(){this.c.clear();for(const c of this.j.profiles)this.c.add(c.settingsResource),this.c.add(c.keybindingsResource),this.c.add(c.tasksResource),this.c.add(c.extensionsResource)}open(c,E){return this.g.open(this.t(c),E)}close(c){return this.g.close(c)}read(c,E,R,d,f){return this.g.read(c,E,R,d,f)}write(c,E,R,d,f){return this.g.write(c,E,R,d,f)}watch(c,E){this.b.set(c,c);const R=this.g.watch(this.t(c),E);return(0,N.$Pc)(()=>{this.b.delete(c),R.dispose()})}stat(c){return this.g.stat(this.t(c))}mkdir(c){return this.g.mkdir(this.t(c))}rename(c,E,R){return this.g.rename(this.t(c),this.t(E),R)}readFile(c,E){return this.g.readFile(this.t(c),E)}readFileStream(c,E,R){return this.g.readFileStream(this.t(c),E,R)}readdir(c){return this.g.readdir(this.t(c))}enforceAtomicReadFile(c){return this.c.has(c)}writeFile(c,E,R){return this.g.writeFile(this.t(c),E,R)}enforceAtomicWriteFile(c){return this.c.has(c)?{postfix:".vsctmp"}:!1}delete(c,E){return this.g.delete(this.t(c),E)}copy(c,E,R){if((0,D.$ik)(this.g))return this.g.copy(this.t(c),this.t(E),R);throw new Error("copy not supported")}cloneFile(c,E){if((0,D.$jk)(this.g))return this.g.cloneFile(this.t(c),this.t(E));throw new Error("clone not supported")}s(c){const E=[];for(const R of c){if(R.resource.scheme!==this.f)continue;const d=this.u(R.resource);this.b.findSubstr(d)&&E.push({resource:d,type:R.type,cId:R.cId})}E.length&&(this.n.debug("User data changed"),this.a.fire(E))}t(c){return c.with({scheme:this.f})}u(c){return c.with({scheme:this.h})}}e.$S9b=v}),define(te[152],ne([0,1,107,16,47,17,11,10,15]),function(J,e,L,N,D,A,j,v,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$oi=e.$ni=e.$mi=e.$li=e.$ki=e.$ji=e.$ii=e.$hi=e.$gi=e.$fi=e.$ei=e.$di=e.$ci=e.$bi=e.$ai=e.WorkbenchState=e.$_h=e.$$h=e.$0h=e.$9h=e.$8h=e.$7h=e.$6h=e.$5h=void 0,e.$5h=(0,v.$Vh)("contextService");function c(n){const i=n;return typeof i?.id=="string"&&j.URI.isUri(i.uri)}e.$6h=c;function E(n){return typeof n?.id=="string"&&!c(n)&&!d(n)}e.$7h=E,e.$8h={id:"ext-dev"},e.$9h={id:"empty-window"};function R(n,i){if(typeof n=="string"||typeof n>"u")return typeof n=="string"?{id:(0,N.$mc)(n)}:i?e.$8h:e.$9h;const r=n;return r.configuration?{id:r.id,configPath:r.configuration}:r.folders.length===1?{id:r.id,uri:r.folders[0].uri}:{id:r.id}}e.$0h=R;function d(n){const i=n;return typeof i?.id=="string"&&j.URI.isUri(i.configPath)}e.$$h=d;function f(n){const i=n;if(i?.uri)return{id:i.id,uri:j.URI.revive(i.uri)};const r=n;if(r?.configPath)return{id:r.id,configPath:j.URI.revive(r.configPath)};if(n?.id)return{id:n.id}}e.$_h=f;var S;(function(n){n[n.EMPTY=1]="EMPTY",n[n.FOLDER=2]="FOLDER",n[n.WORKSPACE=3]="WORKSPACE"})(S||(e.WorkbenchState=S={}));function y(n){const i=n;return!!(i&&typeof i=="object"&&typeof i.id=="string"&&Array.isArray(i.folders))}e.$ai=y;function $(n){const i=n;return!!(i&&typeof i=="object"&&j.URI.isUri(i.uri)&&typeof i.name=="string"&&typeof i.toResource=="function")}e.$bi=$;class u{constructor(i,r,l,k,b){this.h=i,this.j=l,this.k=k,this.l=b,this.c=D.$2h.forUris(this.l,()=>!0),this.folders=r}update(i){this.h=i.id,this.k=i.configuration,this.j=i.transient,this.l=i.l,this.folders=i.folders}get folders(){return this.g}set folders(i){this.g=i,this.n()}get id(){return this.h}get transient(){return this.j}get configuration(){return this.k}set configuration(i){this.k=i}getFolder(i){return i&&this.c.findSubstr(i)||null}n(){this.c=D.$2h.forUris(this.l,()=>!0);for(const i of this.folders)this.c.set(i.uri,i)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.$ci=u;class m{constructor(i,r){this.raw=r,this.uri=i.uri,this.index=i.index,this.name=i.name}toResource(i){return(0,A.$zg)(this.uri,i)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.$di=m;function I(n){return new m({uri:n,index:0,name:(0,A.$vg)(n)},{uri:n.toString()})}e.$ei=I,e.$fi="code-workspace",e.$gi=`.${e.$fi}`,e.$hi=[{name:(0,L.localize)(0,null),extensions:[e.$fi]}],e.$ii="workspace.json";function w(n,i){return A.$qg.isEqualOrParent(n,i.untitledWorkspacesHome)}e.$ji=w;function P(n){let i;return j.URI.isUri(n)?i=n:i=n.configuration,i?.scheme===h.Schemas.tmp}e.$ki=P,e.$li="4064f6ec-cb38-4ad0-af64-ee6467e63c82";function s(n){return n.id===e.$li}e.$mi=s;function o(n,i){return!w(n,i)&&!P(n)}e.$ni=o;function t(n){return(typeof n=="string"?(0,N.$nc)(n):(0,A.$xg)(n))===e.$gi}e.$oi=t}),define(te[23],ne([0,1,41,4,2,17,11,106,18,12,10,6,152,31,22,8,28,29,3]),function(J,e,L,N,D,A,j,v,h,c,E,R,d,f,S,y,$,u,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Uk=e.$Tk=e.$Sk=e.$Rk=e.$Qk=e.$Pk=e.ProfileResourceType=void 0;var I;(function(n){n.Settings="settings",n.Keybindings="keybindings",n.Snippets="snippets",n.Tasks="tasks",n.Extensions="extensions",n.GlobalState="globalState"})(I||(e.ProfileResourceType=I={}));function w(n){const i=n;return!!(i&&typeof i=="object"&&typeof i.id=="string"&&typeof i.isDefault=="boolean"&&typeof i.name=="string"&&j.URI.isUri(i.location)&&j.URI.isUri(i.globalStorageHome)&&j.URI.isUri(i.settingsResource)&&j.URI.isUri(i.keybindingsResource)&&j.URI.isUri(i.tasksResource)&&j.URI.isUri(i.snippetsHome)&&j.URI.isUri(i.extensionsResource))}e.$Pk=w,e.$Qk=(0,E.$Vh)("IUserDataProfilesService");function P(n,i){return{id:n.id,isDefault:n.isDefault,name:n.name,shortName:n.shortName,icon:n.icon,location:j.URI.revive(n.location).with({scheme:i}),globalStorageHome:j.URI.revive(n.globalStorageHome).with({scheme:i}),settingsResource:j.URI.revive(n.settingsResource).with({scheme:i}),keybindingsResource:j.URI.revive(n.keybindingsResource).with({scheme:i}),tasksResource:j.URI.revive(n.tasksResource).with({scheme:i}),snippetsHome:j.URI.revive(n.snippetsHome).with({scheme:i}),extensionsResource:j.URI.revive(n.extensionsResource).with({scheme:i}),cacheHome:j.URI.revive(n.cacheHome).with({scheme:i}),useDefaultFlags:n.useDefaultFlags,isTransient:n.isTransient}}e.$Rk=P;function s(n,i,r,l,k,b){return{id:n,name:i,location:r,isDefault:!1,shortName:k?.shortName,icon:k?.icon,globalStorageHome:b&&k?.useDefaultFlags?.globalState?b.globalStorageHome:(0,A.$zg)(r,"globalStorage"),settingsResource:b&&k?.useDefaultFlags?.settings?b.settingsResource:(0,A.$zg)(r,"settings.json"),keybindingsResource:b&&k?.useDefaultFlags?.keybindings?b.keybindingsResource:(0,A.$zg)(r,"keybindings.json"),tasksResource:b&&k?.useDefaultFlags?.tasks?b.tasksResource:(0,A.$zg)(r,"tasks.json"),snippetsHome:b&&k?.useDefaultFlags?.snippets?b.snippetsHome:(0,A.$zg)(r,"snippets"),extensionsResource:b&&k?.useDefaultFlags?.extensions?b.extensionsResource:(0,A.$zg)(r,"extensions.json"),cacheHome:(0,A.$zg)(l,n),useDefaultFlags:k?.useDefaultFlags,isTransient:k?.transient}}e.$Sk=s;let o=class extends D.$Rc{static{this.b="userDataProfiles"}static{this.c="profileAssociations"}get defaultProfile(){return this.profiles[0]}get profiles(){return[...this.C.profiles,...this.s.profiles]}constructor(i,r,l,k){super(),this.t=i,this.u=r,this.w=l,this.y=k,this.f=!0,this.h=this.B(new N.$Rd),this.onDidChangeProfiles=this.h.event,this.j=this.B(new N.$Rd),this.onWillCreateProfile=this.j.event,this.m=this.B(new N.$Rd),this.onWillRemoveProfile=this.m.event,this.n=this.B(new N.$Rd),this.onDidResetWorkspaces=this.n.event,this.r=new Map,this.s={profiles:[],workspaces:new f.$zc,emptyWindows:new Map},this.profilesHome=(0,A.$zg)(this.t.userRoamingDataHome,"profiles"),this.g=(0,A.$zg)(this.t.cacheHome,"CachedProfilesData")}init(){this.z=void 0}setEnablement(i){this.f!==i&&(this.z=void 0,this.f=i)}isEnabled(){return this.f}get C(){if(!this.z){const i=this.D(),r=[i];if(this.f)try{for(const b of this.O()){if(!b.name||!(0,m.$Cf)(b.name)||!b.location){this.y.warn("Skipping the invalid stored profile",b.location||b.name);continue}r.push(s((0,A.$wg)(b.location),b.name,b.location,this.g,{shortName:b.shortName,icon:b.icon,useDefaultFlags:b.useDefaultFlags},i))}}catch(b){this.y.error(b)}const l=new f.$zc,k=new Map;if(r.length)try{const b=this.Q();if(b.workspaces)for(const[p,O]of Object.entries(b.workspaces)){const B=j.URI.parse(p),_=r.find(ee=>ee.id===O);_&&l.set(B,_)}if(b.emptyWindows)for(const[p,O]of Object.entries(b.emptyWindows)){const B=r.find(_=>_.id===O);B&&k.set(p,B)}}catch(b){this.y.error(b)}this.z={profiles:r,workspaces:l,emptyWindows:k}}return this.z}D(){const i=s("__default__profile__",(0,v.localize)(0,null),this.t.userRoamingDataHome,this.g);return{...i,extensionsResource:this.S()??i.extensionsResource,isDefault:!0}}async createTransientProfile(i){const r="Temp",l=new RegExp(`${(0,u.$Je)(r)}\\s(\\d+)`);let k=0;for(const p of this.profiles){const O=l.exec(p.name),B=O?parseInt(O[1]):0;k=B>k?B:k}const b=`${r} ${k+1}`;return this.createProfile((0,L.$Ji)((0,$.$ig)()).toString(16),b,{transient:!0},i)}async createNamedProfile(i,r,l){return this.createProfile((0,L.$Ji)((0,$.$ig)()).toString(16),i,r,l)}async createProfile(i,r,l,k){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const b=await this.F(i,r,l);return k&&await this.setProfileForWorkspace(k,b),b}async F(i,r,l){if(!(0,m.$Cf)(r)||!r)throw new Error("Name of the profile is mandatory and must be of type `string`");let k=this.r.get(r);return k||(k=(async()=>{try{const b=this.profiles.find(B=>B.name===r||B.id===i);if(b)return b;const p=s(i,r,(0,A.$zg)(this.profilesHome,i),this.g,l,this.defaultProfile);await this.u.createFolder(p.location);const O=[];return this.j.fire({profile:p,join(B){O.push(B)}}),await y.Promises.settled(O),this.I([p],[],[]),p}finally{this.r.delete(r)}})(),this.r.set(r,k)),k}async updateProfile(i,r){if(!this.f)throw new Error("Profiles are disabled in the current environment.");let l=this.profiles.find(k=>k.id===i.id);if(!l)throw new Error(`Profile '${i.name}' does not exist`);return l=s(l.id,r.name??l.name,l.location,this.g,{shortName:r.shortName??l.shortName,icon:r.icon===null?void 0:r.icon??l.icon,transient:r.transient??l.isTransient,useDefaultFlags:r.useDefaultFlags??l.useDefaultFlags},this.defaultProfile),this.I([],[],[l]),l}async removeProfile(i){if(!this.f)throw new Error("Profiles are disabled in the current environment.");if(i.isDefault)throw new Error("Cannot remove default profile");const r=this.profiles.find(k=>k.id===i.id);if(!r)throw new Error(`Profile '${i.name}' does not exist`);const l=[];this.m.fire({profile:r,join(k){l.push(k)}});try{await Promise.allSettled(l)}catch(k){this.y.error(k)}for(const k of[...this.C.emptyWindows.keys()])r.id===this.C.emptyWindows.get(k)?.id&&this.C.emptyWindows.delete(k);for(const k of[...this.C.workspaces.keys()])r.id===this.C.workspaces.get(k)?.id&&this.C.workspaces.delete(k);this.M(),this.I([],[r],[]);try{await this.u.del(r.cacheHome,{recursive:!0})}catch(k){(0,c.$vk)(k)!==1&&this.y.error(k)}}async setProfileForWorkspace(i,r){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const l=this.profiles.find(k=>k.id===r.id);if(!l)throw new Error(`Profile '${r.name}' does not exist`);this.L(i,l)}unsetWorkspace(i,r){if(!this.f)throw new Error("Profiles are disabled in the current environment.");this.L(i,void 0,r)}async resetWorkspaces(){this.s.workspaces.clear(),this.s.emptyWindows.clear(),this.C.workspaces.clear(),this.C.emptyWindows.clear(),this.M(),this.n.fire()}async cleanUp(){if(this.f&&await this.u.exists(this.profilesHome)){const i=await this.u.resolve(this.profilesHome);await Promise.all((i.children||[]).filter(r=>r.isDirectory&&this.profiles.every(l=>!this.w.extUri.isEqual(l.location,r.resource))).map(r=>this.u.del(r.resource,{recursive:!0})))}}async cleanUpTransientProfiles(){if(!this.f)return;const i=this.s.profiles.filter(r=>!this.H(r));await Promise.allSettled(i.map(r=>this.removeProfile(r)))}getProfileForWorkspace(i){const r=this.G(i);return j.URI.isUri(r)?this.s.workspaces.get(r)??this.C.workspaces.get(r):this.s.emptyWindows.get(r)??this.C.emptyWindows.get(r)}G(i){return(0,d.$6h)(i)?i.uri:(0,d.$$h)(i)?i.configPath:i.id}H(i){return!!([...this.s.emptyWindows.values()].some(r=>this.w.extUri.isEqual(r.location,i.location))||[...this.s.workspaces.values()].some(r=>this.w.extUri.isEqual(r.location,i.location))||[...this.C.emptyWindows.values()].some(r=>this.w.extUri.isEqual(r.location,i.location))||[...this.C.workspaces.values()].some(r=>this.w.extUri.isEqual(r.location,i.location)))}I(i,r,l){const k=[...this.profiles,...i],b=[];this.s.profiles=[];for(let p of k)p.isDefault||r.some(O=>p.id===O.id)||(p=l.find(O=>p.id===O.id)??p,p.isTransient?this.s.profiles.push(p):b.push({location:p.location,name:p.name,shortName:p.shortName,icon:p.icon,useDefaultFlags:p.useDefaultFlags}));this.P(b),this.z=void 0,this.J(i,r,l)}J(i,r,l){this.h.fire({added:i,removed:r,updated:l,all:this.profiles})}L(i,r,l){l=r?.isTransient?!0:l,l||this.L(i,void 0,!0);const k=this.G(i),b=l?this.s:this.C;j.URI.isUri(k)?(b.workspaces.delete(k),r&&b.workspaces.set(k,r)):(b.emptyWindows.delete(k),r&&b.emptyWindows.set(k,r)),l||this.M()}M(){const i={};for(const[l,k]of this.C.workspaces.entries())i[l.toString()]=k.id;const r={};for(const[l,k]of this.C.emptyWindows.entries())r[l.toString()]=k.id;this.R({workspaces:i,emptyWindows:r}),this.z=void 0}N(i){const r={},l=this.D();if(i.workspaces)for(const[b,p]of Object.entries(i.workspaces)){const O=j.URI.parse(p);r[b]=this.w.extUri.isEqual(O,l.location)?l.id:this.w.extUri.basename(O)}const k={};if(i.emptyWindows)for(const[b,p]of Object.entries(i.emptyWindows)){const O=j.URI.parse(p);k[b]=this.w.extUri.isEqual(O,l.location)?l.id:this.w.extUri.basename(O)}return{workspaces:r,emptyWindows:k}}O(){return[]}P(i){throw new Error("not implemented")}Q(){return{}}R(i){throw new Error("not implemented")}S(){}};e.$Tk=o,e.$Tk=o=pe([ie(0,h.$3h),ie(1,c.$ek),ie(2,S.$Ok),ie(3,R.$dj)],o);class t extends o{constructor(){super(...arguments),this.a=[],this.X={}}O(){return this.a}P(i){this.a=i}Q(){return this.X}R(i){this.X=i}}e.$Uk=t}),define(te[153],ne([0,1,19,8,20,9,4,2,13,3,11,91,21,27,37,6,32,26,22,23]),function(J,e,L,N,D,A,j,v,h,c,E,R,d,f,S,y,$,u,m,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yp=e.$xp=e.$wp=e.$vp=void 0;let w=class extends v.$Rc{get onInstallExtension(){return this.n.event}get onDidInstallExtensions(){return this.s.event}get onUninstallExtension(){return this.t.event}get onDidUninstallExtension(){return this.u.event}get onDidUpdateExtensionMetadata(){return this.w.event}constructor(i,r,l,k,b,p){super(),this.z=i,this.C=r,this.D=l,this.F=k,this.G=b,this.H=p,this.h=0,this.j=new Map,this.m=new Map,this.n=this.B(new j.$Rd),this.s=this.B(new j.$Rd),this.t=this.B(new j.$Rd),this.u=this.B(new j.$Rd),this.w=this.B(new j.$Rd),this.y=[],this.B((0,v.$Pc)(()=>{this.j.forEach(({task:O})=>O.cancel()),this.m.forEach(O=>O.cancel()),this.j.clear(),this.m.clear()}))}async canInstall(i){const r=await this.getTargetPlatform();return i.allTargetPlatforms.some(l=>(0,d.$bo)(l,i.allTargetPlatforms,r))}async installFromGallery(i,r={}){try{const k=(await this.installGalleryExtensions([{extension:i,options:r}])).find(({identifier:b})=>(0,f.$Fo)(b,i.identifier));if(k?.local)return k?.local;throw k?.error?k.error:s(new Error(`Unknown error while installing extension ${i.identifier.id}`))}catch(l){throw s(l)}}async installGalleryExtensions(i){if(!this.z.isEnabled())throw new d.$eo(R.localize(0,null),d.ExtensionManagementErrorCode.Internal);const r=[],l=[];await Promise.allSettled(i.map(async({extension:k,options:b})=>{try{const p=await this.O(k,!!b?.installGivenVersion,!!b?.installPreReleaseVersion);l.push({...p,options:b})}catch(p){r.push({identifier:k.identifier,operation:2,source:k,error:p})}})),l.length&&r.push(...await this.I(l));for(const k of r)k.error&&(this.F.error("Failed to install extension.",k.identifier.id),this.F.error(k.error),k.source&&!E.URI.isUri(k.source)&&o(this.C,"extensionGallery:install",{extensionData:(0,f.$No)(k.source),error:k.error}));return r}async uninstall(i,r={}){return this.F.trace("ExtensionManagementService#uninstall",i.identifier.id),this.Q(i,r)}async toggleAppliationScope(i,r){if((0,S.$cm)(i.manifest)||i.isBuiltin)return i;if(i.isApplicationScoped){let l=await this.updateMetadata(i,{isApplicationScoped:!1},this.H.defaultProfile.extensionsResource);this.D.extUri.isEqual(r,this.H.defaultProfile.extensionsResource)||(l=await this.ab(i,this.H.defaultProfile.extensionsResource,r));for(const k of this.H.profiles){const b=(await this.getInstalled(1,k.extensionsResource)).find(p=>(0,f.$Fo)(p.identifier,i.identifier));b?this.w.fire(b):this.u.fire({identifier:i.identifier,profileLocation:k.extensionsResource})}return l}else{const l=this.D.extUri.isEqual(r,this.H.defaultProfile.extensionsResource)?await this.updateMetadata(i,{isApplicationScoped:!0},this.H.defaultProfile.extensionsResource):await this.ab(i,r,this.H.defaultProfile.extensionsResource,{isApplicationScoped:!0});return this.s.fire([{identifier:l.identifier,operation:2,local:l,profileLocation:this.H.defaultProfile.extensionsResource,applicationScoped:!0}]),l}}getExtensionsControlManifest(){const i=new Date().getTime();return(!this.g||i-this.h>1e3*60*5)&&(this.g=this.X(),this.h=i),this.g}registerParticipant(i){this.y.push(i)}async I(i){const r=[];return await Promise.allSettled(i.map(async l=>{try{const k=await this.J(l,(b,p)=>i.some(O=>(0,f.$Jo)(p.identifier.id)===(0,f.$Ko)(O.manifest.publisher,O.manifest.name))?!1:this.L(b,p));r.push(...k)}catch(k){r.push({identifier:{id:(0,f.$Ko)(l.manifest.publisher,l.manifest.name)},operation:2,source:l.extension,error:k})}})),this.s.fire(r),r}async J({manifest:i,extension:r,options:l},k){const b=l.isApplicationScoped||l.isBuiltin||(0,S.$cm)(i),p={...l,installOnlyNewlyAddedFromExtensionPack:E.URI.isUri(r)?l.installOnlyNewlyAddedFromExtensionPack:!0,isApplicationScoped:b,profileLocation:b?this.H.defaultProfile.extensionsResource:l.profileLocation??this.Y()},O=ue=>`${f.$Go.create(ue).toString()}${p.profileLocation?`-${p.profileLocation.toString()}`:""}`;if(!E.URI.isUri(r)){const ue=this.j.get(O(r));if(ue)return this.F.info("Extensions is already requested to install",r.identifier.id),await ue.task.waitUntilTaskIsFinished(),[]}const B=[],_=[],ee=[],oe=this.Z(i,r,p);E.URI.isUri(r)||this.j.set(O(r),{task:oe,waitingTasks:[]}),this.n.fire({identifier:oe.identifier,source:r,profileLocation:p.profileLocation}),this.F.info("Installing extension:",oe.identifier.id),B.push({task:oe,manifest:i});let se=!1;try{if(p.donotIncludePackAndDependencies)this.F.info("Installing the extension without checking dependencies and pack",oe.identifier.id);else try{const ce=await this.N(oe.identifier,i,!!p.installOnlyNewlyAddedFromExtensionPack,!!p.installPreReleaseVersion,p.profileLocation),re=await this.getInstalled(void 0,p.profileLocation),q={...p,donotIncludePackAndDependencies:!0,context:{...p.context,[d.$9n]:!0}};for(const{gallery:Q,manifest:T}of(0,L.$Lb)(ce,({gallery:U})=>U.identifier.id)){se=se||!!T.extensionDependencies?.some(G=>(0,f.$Fo)({id:G},oe.identifier));const U=O(Q),H=this.j.get(U);if(H){if(k(oe,H.task)){const G=H.task.identifier;this.F.info("Waiting for already requested installing extension",G.id,oe.identifier.id),H.waitingTasks.push(oe),_.push(j.Event.toPromise(j.Event.filter(this.onDidInstallExtensions,Z=>Z.some(Y=>(0,f.$Fo)(Y.identifier,G)))).then(Z=>{if(this.F.info("Finished waiting for already requested installing extension",G.id,oe.identifier.id),!Z.find(C=>(0,f.$Fo)(C.identifier,G))?.local)throw new Error(`Extension ${G.id} is not installed`)}))}}else if(!re.some(({identifier:G})=>(0,f.$Fo)(G,Q.identifier))){const G=this.Z(T,Q,q);this.j.set(U,{task:G,waitingTasks:[oe]}),this.n.fire({identifier:G.identifier,source:Q,profileLocation:p.profileLocation}),this.F.info("Installing extension:",G.identifier.id,oe.identifier.id),B.push({task:G,manifest:T})}}}catch(ce){if(E.URI.isUri(oe.source))(0,L.$Kb)(i.extensionDependencies)&&this.F.warn("Cannot install dependencies of extension:",oe.identifier.id,ce.message),(0,L.$Kb)(i.extensionPack)&&this.F.warn("Cannot install packed extensions of extension:",oe.identifier.id,ce.message);else throw this.F.error("Error while preparing to install dependencies and extension packs of the extension:",oe.identifier.id),ce}const ue=B.reduce((ce,{task:re,manifest:q})=>(ce.set(re.identifier.id.toLowerCase(),{task:re,manifest:q}),ce),new Map);for(;ue.size;){let ce;const re=[...ue.values()].filter(({manifest:q})=>!q.extensionDependencies?.some(Q=>ue.has(Q.toLowerCase())));re.length?ce=ue.size===1?re:re.filter(({task:q})=>!(q===oe&&!se)):(this.F.info("Found extensions with circular dependencies",re.map(({task:q})=>q.identifier.id)),ce=[...ue.values()]),await this.M(ce.map(async({task:q})=>{const Q=new Date().getTime();try{const T=await q.run();if(await this.M(this.y.map(U=>U.postInstall(T,q.source,p,D.CancellationToken.None))),!E.URI.isUri(q.source)){const U=q.operation===3,H=U?void 0:(new Date().getTime()-q.source.lastUpdated)/1e3;if(o(this.C,U?"extensionGallery:update":"extensionGallery:install",{extensionData:(0,f.$No)(q.source),verificationStatus:q.verificationStatus,duration:new Date().getTime()-Q,durationSinceUpdate:H}),h.$o&&q.operation!==3)try{await this.z.reportStatistic(T.manifest.publisher,T.manifest.name,T.manifest.version,"install")}catch{}}ee.push({local:T,identifier:q.identifier,operation:q.operation,source:q.source,context:q.options.context,profileLocation:q.profileLocation,applicationScoped:T.isApplicationScoped})}catch(T){throw E.URI.isUri(q.source)||o(this.C,q.operation===3?"extensionGallery:update":"extensionGallery:install",{extensionData:(0,f.$No)(q.source),verificationStatus:q.verificationStatus,duration:new Date().getTime()-Q,error:T}),this.F.error("Error while installing the extension:",q.identifier.id),T}finally{ue.delete(q.identifier.id.toLowerCase())}}))}return _.length&&await this.M(_),ee.forEach(({identifier:ce})=>this.F.info("Extension installed successfully:",ce.id)),ee}catch(ue){if(B.forEach(({task:ce})=>ce.cancel()),ee.length)try{const ce=await Promise.allSettled(ee.map(({local:re})=>this.$(re,{versionOnly:!0,profileLocation:p.profileLocation}).run()));for(let re=0;re<ce.length;re++){const q=ce[re],{identifier:Q}=ee[re];q.status==="fulfilled"?this.F.info("Rollback: Uninstalled extension",Q.id):this.F.warn("Rollback: Error while uninstalling extension",Q.id,(0,A.$9)(q.reason))}}catch(ce){this.F.warn("Error while rolling back extensions",(0,A.$9)(ce),ee.map(({identifier:re})=>re.id))}return B.map(({task:ce})=>({identifier:ce.identifier,operation:2,source:ce.source,context:p.context,profileLocation:p.profileLocation,error:ue}))}finally{for(const{task:ue}of B)ue.source&&!E.URI.isUri(ue.source)&&this.j.delete(O(ue.source))}}L(i,r){for(const[,{task:l,waitingTasks:k}]of this.j.entries())if(l===i&&(k.includes(r)||k.some(b=>this.L(b,r)))||l===r&&k[0]&&!this.L(i,k[0]))return!1;return!0}async M(i){const r=[],l=[],k=await Promise.allSettled(i);for(const b of k)b.status==="fulfilled"?r.push(b.value):l.push(b.reason);if(l.length)throw P(l);return r}async N(i,r,l,k,b){if(!this.z.isEnabled())return[];const p=await this.getInstalled(void 0,b),O=[],B=[],_=async(ee,oe)=>{O.push(ee);const se=oe.extensionDependencies||[],ue=[...se];if(oe.extensionPack){const ce=l?p.find(re=>(0,f.$Fo)(re.identifier,ee)):void 0;for(const re of oe.extensionPack)ce&&ce.manifest.extensionPack&&ce.manifest.extensionPack.some(q=>(0,f.$Fo)({id:q},{id:re}))||ue.every(q=>!(0,f.$Fo)({id:q},{id:re}))&&ue.push(re)}if(ue.length){const ce=ue.filter(re=>O.every(q=>!(0,f.$Fo)(q,{id:re})));if(ce.length){const re=await this.z.getExtensions(ce.map(q=>({id:q,preRelease:k})),D.CancellationToken.None);for(const q of re){if(O.find(U=>(0,f.$Fo)(U,q.identifier)))continue;const Q=se.some(U=>(0,f.$Fo)({id:U},q.identifier));let T;try{T=await this.O(q,!1,k)}catch(U){if(Q)throw U;this.F.info("Skipping the packed extension as it cannot be installed",q.identifier.id,(0,A.$9)(U));continue}B.push({gallery:T.extension,manifest:T.manifest}),await _(T.extension.identifier,T.manifest)}}}};return await _(i,r),B}async O(i,r,l){let k;const b=await this.getExtensionsControlManifest();if(b.malicious.some(B=>(0,f.$Fo)(i.identifier,B)))throw new d.$eo(R.localize(1,null,i.identifier.id),d.ExtensionManagementErrorCode.Malicious);const p=b.deprecated[i.identifier.id.toLowerCase()];if(p?.extension?.autoMigrate){if(this.F.info(`The '${i.identifier.id}' extension is deprecated, fetching the compatible '${p.extension.id}' extension instead.`),k=(await this.z.getExtensions([{id:p.extension.id,preRelease:p.extension.preRelease}],{targetPlatform:await this.getTargetPlatform(),compatible:!0},D.CancellationToken.None))[0],!k)throw new d.$eo(R.localize(2,null,i.identifier.id,p.extension.id),d.ExtensionManagementErrorCode.Deprecated)}else{if(!await this.canInstall(i)){const B=await this.getTargetPlatform();throw new d.$eo(R.localize(3,null,i.identifier.id,this.G.nameLong,(0,d.$0n)(B)),d.ExtensionManagementErrorCode.IncompatibleTargetPlatform)}if(k=await this.P(i,r,l),!k)throw!l&&i.properties.isPreReleaseVersion&&(await this.z.getExtensions([i.identifier],D.CancellationToken.None))[0]?new d.$eo(R.localize(4,null,i.identifier.id),d.ExtensionManagementErrorCode.ReleaseVersionNotFound):new d.$eo(R.localize(5,null,i.identifier.id,this.G.nameLong,this.G.version),d.ExtensionManagementErrorCode.Incompatible)}this.F.info("Getting Manifest...",k.identifier.id);const O=await this.z.getManifest(k,D.CancellationToken.None);if(O===null)throw new d.$eo(`Missing manifest for extension ${k.identifier.id}`,d.ExtensionManagementErrorCode.Invalid);if(O.version!==k.version)throw new d.$eo(`Cannot install '${k.identifier.id}' extension because of version mismatch in Marketplace`,d.ExtensionManagementErrorCode.Invalid);return{extension:k,manifest:O}}async P(i,r,l){const k=await this.getTargetPlatform();let b=null;return!r&&i.hasPreReleaseVersion&&i.properties.isPreReleaseVersion!==l&&(b=(await this.z.getExtensions([{...i.identifier,preRelease:l}],{targetPlatform:k,compatible:!0},D.CancellationToken.None))[0]||null),!b&&await this.z.isExtensionCompatible(i,l,k)&&(b=i),b||(r?b=(await this.z.getExtensions([{...i.identifier,version:i.version}],{targetPlatform:k,compatible:!0},D.CancellationToken.None))[0]||null:b=await this.z.getCompatibleExtension(i,l,k)),b}async Q(i,r){const l={...r,profileLocation:i.isApplicationScoped?this.H.defaultProfile.extensionsResource:r.profileLocation??this.Y()},k=ee=>`${ee.id.toLowerCase()}${l.versionOnly?`-${i.manifest.version}`:""}${l.profileLocation?`@${l.profileLocation.toString()}`:""}`,b=this.m.get(k(i.identifier));if(b)return this.F.info("Extensions is already requested to uninstall",i.identifier.id),b.waitUntilTaskIsFinished();const p=ee=>{const oe=this.$(ee,l);return this.m.set(k(oe.extension.identifier),oe),l.profileLocation?this.F.info("Uninstalling extension from the profile:",`${ee.identifier.id}@${ee.manifest.version}`,l.profileLocation.toString()):this.F.info("Uninstalling extension:",`${ee.identifier.id}@${ee.manifest.version}`),this.t.fire({identifier:ee.identifier,profileLocation:l.profileLocation,applicationScoped:ee.isApplicationScoped}),oe},O=(ee,oe)=>{oe?l.profileLocation?this.F.error("Failed to uninstall extension from the profile:",`${ee.identifier.id}@${ee.manifest.version}`,l.profileLocation.toString(),oe.message):this.F.error("Failed to uninstall extension:",`${ee.identifier.id}@${ee.manifest.version}`,oe.message):l.profileLocation?this.F.info("Successfully uninstalled extension from the profile",`${ee.identifier.id}@${ee.manifest.version}`,l.profileLocation.toString()):this.F.info("Successfully uninstalled extension:",`${ee.identifier.id}@${ee.manifest.version}`),o(this.C,"extensionGallery:uninstall",{extensionData:(0,f.$Mo)(ee),error:oe}),this.u.fire({identifier:ee.identifier,error:oe?.code,profileLocation:l.profileLocation,applicationScoped:ee.isApplicationScoped})},B=[],_=[];try{B.push(p(i));const ee=await this.getInstalled(1,l.profileLocation);if(l.donotIncludePack)this.F.info("Uninstalling the extension without including packed extension",`${i.identifier.id}@${i.manifest.version}`);else{const oe=this.U(i,ee);for(const se of oe)this.m.has(k(se.identifier))?this.F.info("Extensions is already requested to uninstall",se.identifier.id):B.push(p(se))}l.donotCheckDependents?this.F.info("Uninstalling the extension without checking dependents",`${i.identifier.id}@${i.manifest.version}`):this.R(B.map(oe=>oe.extension),ee,i),await this.M(B.map(async oe=>{try{if(await oe.run(),await this.M(this.y.map(se=>se.postUninstall(oe.extension,l,D.CancellationToken.None))),oe.extension.identifier.uuid)try{await this.z.reportStatistic(oe.extension.manifest.publisher,oe.extension.manifest.name,oe.extension.manifest.version,"uninstall")}catch{}O(oe.extension)}catch(se){const ue=se instanceof d.$eo?se:new d.$eo((0,A.$9)(se),d.ExtensionManagementErrorCode.Internal);throw O(oe.extension,ue),ue}finally{_.push(oe)}}))}catch(ee){const oe=ee instanceof d.$eo?ee:new d.$eo((0,A.$9)(ee),d.ExtensionManagementErrorCode.Internal);for(const se of B){try{se.cancel()}catch{}_.includes(se)||O(se.extension,oe)}throw oe}finally{for(const ee of B)this.m.delete(k(ee.extension.identifier))||this.F.warn("Uninstallation task is not found in the cache",ee.extension.identifier.id)}}R(i,r,l){for(const k of i){const b=this.W(k,r);if(b.length){const p=b.filter(O=>!i.some(B=>(0,f.$Fo)(B.identifier,O.identifier)));if(p.length)throw new Error(this.S(k,p,l))}}}S(i,r,l){return l===i?r.length===1?R.localize(6,null,l.manifest.displayName||l.manifest.name,r[0].manifest.displayName||r[0].manifest.name):r.length===2?R.localize(7,null,l.manifest.displayName||l.manifest.name,r[0].manifest.displayName||r[0].manifest.name,r[1].manifest.displayName||r[1].manifest.name):R.localize(8,null,l.manifest.displayName||l.manifest.name,r[0].manifest.displayName||r[0].manifest.name,r[1].manifest.displayName||r[1].manifest.name):r.length===1?R.localize(9,null,l.manifest.displayName||l.manifest.name,i.manifest.displayName||i.manifest.name,r[0].manifest.displayName||r[0].manifest.name):r.length===2?R.localize(10,null,l.manifest.displayName||l.manifest.name,i.manifest.displayName||i.manifest.name,r[0].manifest.displayName||r[0].manifest.name,r[1].manifest.displayName||r[1].manifest.name):R.localize(11,null,l.manifest.displayName||l.manifest.name,i.manifest.displayName||i.manifest.name,r[0].manifest.displayName||r[0].manifest.name,r[1].manifest.displayName||r[1].manifest.name)}U(i,r,l=[]){if(l.indexOf(i)!==-1)return[];l.push(i);const k=i.manifest.extensionPack?i.manifest.extensionPack:[];if(k.length){const b=r.filter(O=>!O.isBuiltin&&k.some(B=>(0,f.$Fo)({id:B},O.identifier))),p=[];for(const O of b)p.push(...this.U(O,r,l));return[...b,...p]}return[]}W(i,r){return r.filter(l=>l.manifest.extensionDependencies&&l.manifest.extensionDependencies.some(k=>(0,f.$Fo)({id:k},i.identifier)))}async X(){try{this.F.trace("ExtensionManagementService.refreshReportedCache");const i=await this.z.getExtensionsControlManifest();return this.F.trace("ExtensionManagementService.refreshControlCache",i),i}catch{return this.F.trace("ExtensionManagementService.refreshControlCache - failed to get extension control manifest"),{malicious:[],deprecated:{},search:[]}}}};e.$vp=w,e.$vp=w=pe([ie(0,d.$do),ie(1,u.$il),ie(2,m.$Ok),ie(3,y.$dj),ie(4,$.$vj),ie(5,I.$Qk)],w);function P(n){const i=Array.isArray(n)?n:[n];return i.length===1?i[0]instanceof Error?i[0]:new Error(i[0]):i.reduce((r,l)=>new Error(`${r.message}${r.message?",":""}${l instanceof Error?l.message:l}`),new Error(""))}e.$wp=P;function s(n){if(n instanceof d.$eo)return n;const i=new d.$eo(n.message,d.ExtensionManagementErrorCode.Internal);return i.stack=n.stack,i}e.$xp=s;function o(n,i,{extensionData:r,verificationStatus:l,duration:k,error:b,durationSinceUpdate:p}){let O,B;(0,c.$Kf)(l)&&(l===!0?l="Verified":(l===!1||(O=d.ExtensionManagementErrorCode.Signature,B=l),l="Unverified")),b&&(b instanceof d.$eo?(O=b.code,b.code===d.ExtensionManagementErrorCode.Signature&&(B=b.message)):O=d.ExtensionManagementErrorCode.Internal),n.publicLog(i,{...r,verificationStatus:l,success:!b,duration:k,errorcode:O,errorcodeDetail:B,durationSinceUpdate:p})}class t{constructor(){this.d=new N.$Wg}async waitUntilTaskIsFinished(){return await this.d.wait(),this.g}async run(){return this.g||(this.g=(0,N.$Lg)(i=>this.h(i))),this.d.open(),this.g}cancel(){this.g||(this.g=(0,N.$Lg)(i=>new Promise((r,l)=>{const k=i.onCancellationRequested(()=>{k.dispose(),l(new A.$4)})})),this.d.open()),this.g.cancel()}}e.$yp=t}),define(te[40],ne([0,1,8,14,2,4,31,11,21,27,12,10,6,23,22,3,9,26]),function(J,e,L,N,D,A,j,v,h,c,E,R,d,f,S,y,$,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bp=e.$Ap=e.$zp=e.ExtensionsProfileScanningErrorCode=void 0;var m;(function(o){o.ERROR_PROFILE_NOT_FOUND="ERROR_PROFILE_NOT_FOUND",o.ERROR_INVALID_CONTENT="ERROR_INVALID_CONTENT"})(m||(e.ExtensionsProfileScanningErrorCode=m={}));class I extends Error{constructor(t,n){super(t),this.code=n}}e.$zp=I,e.$Ap=(0,R.$Vh)("IExtensionsProfileScannerService");let w=class extends D.$Rc{constructor(t,n,i,r,l,k){super(),this.j=t,this.m=n,this.n=i,this.r=r,this.s=l,this.t=k,this.b=this.B(new A.$Rd),this.onAddExtensions=this.b.event,this.c=this.B(new A.$Rd),this.onDidAddExtensions=this.c.event,this.f=this.B(new A.$Rd),this.onRemoveExtensions=this.f.event,this.g=this.B(new A.$Rd),this.onDidRemoveExtensions=this.g.event,this.h=new j.$zc}scanProfileExtensions(t,n){return this.u(t,void 0,n)}async addExtensionsToProfile(t,n){const i=[],r=[];try{return await this.u(n,l=>{const k=[];for(const b of l)t.some(([p])=>(0,c.$Fo)(p.identifier,b.identifier)&&p.manifest.version!==b.version)?i.push(b):k.push(b);for(const[b,p]of t){const O=k.findIndex(_=>(0,c.$Fo)(_.identifier,b.identifier)&&_.version===b.manifest.version),B={identifier:b.identifier,version:b.manifest.version,location:b.location,metadata:p};O===-1?(r.push(B),k.push(B)):k.splice(O,1,B)}return r.length&&this.b.fire({extensions:r,profileLocation:n}),i.length&&this.f.fire({extensions:i,profileLocation:n}),k}),r.length&&this.c.fire({extensions:r,profileLocation:n}),i.length&&this.g.fire({extensions:i,profileLocation:n}),r}catch(l){throw r.length&&this.c.fire({extensions:r,error:l,profileLocation:n}),i.length&&this.g.fire({extensions:i,error:l,profileLocation:n}),l}}async updateMetadata(t,n){const i=[];return await this.u(n,r=>{const l=[];for(const k of r){const b=t.find(([p])=>(0,c.$Fo)(p.identifier,k.identifier)&&p.manifest.version===k.version);b&&(k.metadata={...k.metadata,...b[1]},i.push(k)),l.push(k)}return l}),i}async removeExtensionFromProfile(t,n){const i=[];try{await this.u(n,r=>{const l=[];for(const k of r)(0,c.$Fo)(k.identifier,t.identifier)?i.push(k):l.push(k);return i.length&&this.f.fire({extensions:i,profileLocation:n}),l}),i.length&&this.g.fire({extensions:i,profileLocation:n})}catch(r){throw i.length&&this.g.fire({extensions:i,error:r,profileLocation:n}),r}}async u(t,n,i){return this.F(t).queue(async()=>{let r=[],l;try{const k=await this.m.readFile(t);l=JSON.parse(k.value.toString().trim()||"[]")}catch(k){if((0,E.$vk)(k)!==1)throw k;if(this.r.extUri.isEqual(t,this.n.defaultProfile.extensionsResource)&&(l=await this.D()),!l&&i?.bailOutWhenFileNotFound)throw new I((0,$.$9)(k),"ERROR_PROFILE_NOT_FOUND")}if(l){Array.isArray(l)||this.w(t);let k=!1;for(const b of l){P(b)||this.w(t);let p;if((0,y.$Cf)(b.relativeLocation)&&b.relativeLocation)p=this.z(b.relativeLocation);else if((0,y.$Cf)(b.location))p=this.z(b.location),k=!0,b.relativeLocation=b.location,b.location=p.toJSON();else{p=v.URI.revive(b.location);const O=this.y(p);O&&(k=!0,b.relativeLocation=O)}r.push({identifier:b.identifier,location:p,version:b.version,metadata:b.metadata})}k&&await this.m.writeFile(t,N.$fe.fromString(JSON.stringify(l)))}if(n){r=n(r);const k=r.map(b=>({identifier:b.identifier,version:b.version,location:b.location.toJSON(),relativeLocation:this.y(b.location),metadata:b.metadata}));await this.m.writeFile(t,N.$fe.fromString(JSON.stringify(k)))}return r})}w(t){const n=new I(`Invalid extensions content in ${t.toString()}`,"ERROR_INVALID_CONTENT");throw this.s.publicLogError2("extensionsProfileScanningError",{code:n.code}),n}y(t){return this.r.extUri.isEqual(this.r.extUri.dirname(t),this.j)?this.r.extUri.basename(t):void 0}z(t){return this.r.extUri.joinPath(this.j,t)}async D(){return this.C||(this.C=(async()=>{const t=this.r.extUri.joinPath(this.n.defaultProfile.location,"extensions.json"),n=this.r.extUri.joinPath(this.j,".init-default-profile-extensions");let i;try{i=(await this.m.readFile(t)).value.toString()}catch(l){if((0,E.$vk)(l)===1)return;throw l}this.t.info("Migrating extensions from old default profile location",t.toString());let r;try{const l=JSON.parse(i);Array.isArray(l)&&l.every(k=>P(k))?r=l:this.t.warn("Skipping migrating from old default profile locaiton: Found invalid data",l)}catch(l){this.t.error(l)}if(r)try{await this.m.createFile(this.n.defaultProfile.extensionsResource,N.$fe.fromString(JSON.stringify(r)),{overwrite:!1}),this.t.info("Migrated extensions from old default profile location to new location",t.toString(),this.n.defaultProfile.extensionsResource.toString())}catch(l){if((0,E.$vk)(l)===3)this.t.info("Migration from old default profile location to new location is done by another window",t.toString(),this.n.defaultProfile.extensionsResource.toString());else throw l}try{await this.m.del(t)}catch(l){(0,E.$vk)(l)!==1&&this.t.error(l)}try{await this.m.del(n)}catch(l){(0,E.$vk)(l)!==1&&this.t.error(l)}return r})()),this.C}F(t){let n=this.h.get(t);return n||(n=new L.$5g,this.h.set(t,n)),n}};e.$Bp=w,e.$Bp=w=pe([ie(1,E.$ek),ie(2,f.$Qk),ie(3,S.$Ok),ie(4,u.$il),ie(5,d.$dj)],w);function P(o){return(0,y.$Ef)(o)&&(0,h.$co)(o.identifier)&&(s(o.location)||(0,y.$Cf)(o.location)&&o.location)&&((0,y.$Jf)(o.relativeLocation)||(0,y.$Cf)(o.relativeLocation))&&o.version&&(0,y.$Cf)(o.version)}function s(o){return o?(0,y.$Cf)(o.path)&&(0,y.$Cf)(o.scheme):!1}}),define(te[50],ne([0,1,19,8,30,14,9,53,79,2,15,16,13,17,42,54,3,11,95,18,27,37,48,12,10,6,32,4,46,40,23,22,112]),function(J,e,L,N,D,A,j,v,h,c,E,R,d,f,S,y,$,u,m,I,w,P,s,o,t,n,i,r,l,k,b,p,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ip=e.$Hp=e.$Gp=e.$Fp=e.$Ep=e.Translations=void 0;var B;(function(re){function q(Q,T){if(Q===T)return!0;const U=Object.keys(Q),H=new Set;for(const G of Object.keys(T))H.add(G);if(U.length!==H.size)return!1;for(const G of U){if(Q[G]!==T[G])return!1;H.delete(G)}return H.size===0}re.equals=q})(B||(e.Translations=B={})),e.$Ep=(0,t.$Vh)("IExtensionsScannerService");let _=class extends c.$Rc{constructor(q,Q,T,U,H,G,Z,Y,C,F,a,g){super(),this.systemExtensionsLocation=q,this.userExtensionsLocation=Q,this.r=T,this.s=U,this.t=H,this.u=G,this.w=Z,this.y=Y,this.z=C,this.C=F,this.D=a,this.F=g,this.g=this.B(new r.$Rd),this.onDidChangeCache=this.g.event,this.h=(0,f.$zg)(this.userExtensionsLocation,".obsolete"),this.j=this.B(this.F.createInstance(se,this.s,this.h)),this.m=this.B(this.F.createInstance(se,this.s,this.h)),this.n=this.B(this.F.createInstance(oe,this.h)),this.H=void 0,this.B(this.j.onDidChangeCache(()=>this.g.fire(0))),this.B(this.m.onDidChangeCache(()=>this.g.fire(1)))}getTargetPlatform(){return this.G||(this.G=(0,w.$Qo)(this.w,this.y)),this.G}async scanAllExtensions(q,Q,T){const[U,H]=await Promise.all([this.scanSystemExtensions(q),this.scanUserExtensions(Q)]),G=T?await this.scanExtensionsUnderDevelopment(q,[...U,...H]):[];return this.L(U,H,G,await this.getTargetPlatform(),!0)}async scanSystemExtensions(q){const Q=[];Q.push(this.M(!!q.useCache,q.language)),Q.push(this.N(q.language,!!q.checkControlFile));const[T,U]=await Promise.all(Q);return this.J([...T,...U],0,q,!1)}async scanUserExtensions(q){const Q=q.profileLocation??this.userExtensionsLocation;this.y.trace("Started scanning user extensions",Q);const T=this.D.extUri.isEqual(q.profileLocation,this.t.defaultProfile.extensionsResource)?{bailOutWhenFileNotFound:!0}:void 0,U=await this.P(Q,!!q.profileLocation,1,!q.includeUninstalled,q.language,!0,T),H=q.useCache&&!U.devMode&&U.excludeObsolete?this.m:this.n;let G;try{G=await H.scanExtensions(U)}catch(Z){if(Z instanceof k.$zp&&Z.code==="ERROR_PROFILE_NOT_FOUND")await this.I(),G=await H.scanExtensions(U);else throw Z}return G=await this.J(G,1,q,!0),this.y.trace("Scanned user extensions:",G.length),G}async scanExtensionsUnderDevelopment(q,Q){if(this.z.isExtensionDevelopment&&this.z.extensionDevelopmentLocationURI){const T=(await Promise.all(this.z.extensionDevelopmentLocationURI.filter(U=>U.scheme===E.Schemas.file).map(async U=>{const H=await this.P(U,!1,1,!0,q.language,!1,void 0);return(await this.n.scanOneOrMultipleExtensions(H)).map(Z=>(Z.type=Q.find(Y=>(0,w.$Fo)(Y.identifier,Z.identifier))?.type??Z.type,this.n.validate(Z,H)))}))).flat();return this.J(T,"development",q,!0)}return[]}async scanExistingExtension(q,Q,T){const U=await this.P(q,!1,Q,!0,T.language,!0,void 0),H=await this.n.scanExtension(U);return!H||!T.includeInvalid&&!H.isValid?null:H}async scanOneOrMultipleExtensions(q,Q,T){const U=await this.P(q,!1,Q,!0,T.language,!0,void 0),H=await this.n.scanOneOrMultipleExtensions(U);return this.J(H,Q,T,!0)}async scanMetadata(q){const Q=(0,f.$zg)(q,"package.json"),T=(await this.w.readFile(Q)).value.toString();return JSON.parse(T).__metadata}async updateMetadata(q,Q){const T=(0,f.$zg)(q,"package.json"),U=(await this.w.readFile(T)).value.toString(),H=JSON.parse(U);Q.isMachineScoped===!1&&delete Q.isMachineScoped,Q.isBuiltin===!1&&delete Q.isBuiltin,H.__metadata={...H.__metadata,...Q},await this.w.writeFile((0,f.$zg)(q,"package.json"),A.$fe.fromString(JSON.stringify(H,null,"	")))}async initializeDefaultProfileExtensions(){try{await this.u.scanProfileExtensions(this.t.defaultProfile.extensionsResource,{bailOutWhenFileNotFound:!0})}catch(q){if(q instanceof k.$zp&&q.code==="ERROR_PROFILE_NOT_FOUND")await this.I();else throw q}}async I(){return this.H||(this.H=(async()=>{try{this.y.info("Started initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString());const q=await this.scanUserExtensions({includeInvalid:!0});if(q.length)await this.u.addExtensionsToProfile(q.map(Q=>[Q,Q.metadata]),this.t.defaultProfile.extensionsResource);else try{await this.w.createFile(this.t.defaultProfile.extensionsResource,A.$fe.fromString(JSON.stringify([])))}catch(Q){(0,o.$vk)(Q)!==1&&this.y.warn("Failed to create default profile extensions manifest in extensions installation folder.",this.userExtensionsLocation.toString(),(0,j.$9)(Q))}this.y.info("Completed initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString())}catch(q){this.y.error(q)}finally{this.H=void 0}})()),this.H}async J(q,Q,T,U){return T.includeAllVersions||(q=this.L(Q===0?q:void 0,Q===1?q:void 0,Q==="development"?q:void 0,await this.getTargetPlatform(),U)),T.includeInvalid||(q=q.filter(H=>H.isValid)),q.sort((H,G)=>{const Z=R.$mc(H.location.fsPath),Y=R.$mc(G.location.fsPath);return Z<Y?-1:Z>Y?1:0})}L(q,Q,T,U,H){const G=(Y,C,F)=>{if(Y.isValid&&!C.isValid)return!1;if(Y.isValid===C.isValid){if(H&&S.gt(Y.manifest.version,C.manifest.version))return this.y.debug(`Skipping extension ${C.location.path} with lower version ${C.manifest.version} in favour of ${Y.location.path} with version ${Y.manifest.version}`),!1;if(S.eq(Y.manifest.version,C.manifest.version)){if(Y.type===0)return this.y.debug(`Skipping extension ${C.location.path} in favour of system extension ${Y.location.path} with same version`),!1;if(Y.targetPlatform===U)return this.y.debug(`Skipping extension ${C.location.path} from different target platform ${C.targetPlatform}`),!1}}return F?this.y.warn(`Overwriting user extension ${Y.location.path} with ${C.location.path}.`):this.y.debug(`Overwriting user extension ${Y.location.path} with ${C.location.path}.`),!0},Z=new P.$bm;return q?.forEach(Y=>{const C=Z.get(Y.identifier.id);(!C||G(C,Y,!1))&&Z.set(Y.identifier.id,Y)}),Q?.forEach(Y=>{const C=Z.get(Y.identifier.id);if(!C&&q&&Y.type===0){this.y.debug(`Skipping obsolete system extension ${Y.location.path}.`);return}(!C||G(C,Y,!1))&&Z.set(Y.identifier.id,Y)}),T?.forEach(Y=>{const C=Z.get(Y.identifier.id);(!C||G(C,Y,!0))&&Z.set(Y.identifier.id,Y),Z.set(Y.identifier.id,Y)}),[...Z.values()]}async M(q,Q){this.y.trace("Started scanning system extensions");const T=await this.P(this.systemExtensionsLocation,!1,0,!0,Q,!0,void 0),H=await(q&&!T.devMode?this.j:this.n).scanExtensions(T);return this.y.trace("Scanned system extensions:",H.length),H}async N(q,Q){const T=this.z.isBuilt?[]:this.C.builtInExtensions;if(!T?.length)return[];this.y.trace("Started scanning dev system extensions");const U=Q?await this.O():{},H=[],G=u.URI.file(R.$gc(R.$ic(E.$gg.asFileUri("").fsPath,"..",".build","builtInExtensions")));for(const Y of T){const C=U[Y.name]||"marketplace";switch(C){case"disabled":break;case"marketplace":H.push((0,f.$zg)(G,Y.name));break;default:H.push(u.URI.file(C));break}}const Z=await Promise.all(H.map(async Y=>this.n.scanExtension(await this.P(Y,!1,0,!0,q,!0,void 0))));return this.y.trace("Scanned dev system extensions:",Z.length),(0,L.$Gb)(Z)}async O(){try{const q=await this.w.readFile(this.r);return JSON.parse(q.value.toString())}catch{return{}}}async P(q,Q,T,U,H,G,Z){const Y=await this.f(H??d.$w),C=await this.Q(q),F=Q&&!this.D.extUri.isEqual(q,this.t.defaultProfile.extensionsResource)?this.t.defaultProfile.extensionsResource:void 0,a=F?await this.Q(F):void 0;return new ee(q,C,F,a,Q,Z,T,U,G,this.C.version,this.C.date,this.C.commit,!this.z.isBuilt,H,Y)}async Q(q){try{const Q=await this.w.stat(q);if(typeof Q.mtime=="number")return Q.mtime}catch{}}};e.$Fp=_,e.$Fp=_=pe([ie(4,b.$Qk),ie(5,k.$Ap),ie(6,o.$ek),ie(7,n.$dj),ie(8,I.$3h),ie(9,i.$vj),ie(10,p.$Ok),ie(11,t.$Uh)],_);class ee{constructor(q,Q,T,U,H,G,Z,Y,C,F,a,g,z,M,X){this.location=q,this.mtime=Q,this.applicationExtensionslocation=T,this.applicationExtensionslocationMtime=U,this.profile=H,this.profileScanOptions=G,this.type=Z,this.excludeObsolete=Y,this.validate=C,this.productVersion=F,this.productDate=a,this.productCommit=g,this.devMode=z,this.language=M,this.translations=X}static createNlsConfiguration(q){return{language:q.language,pseudo:q.language==="pseudo",devMode:q.devMode,translations:q.translations}}static equals(q,Q){return(0,f.$sg)(q.location,Q.location)&&q.mtime===Q.mtime&&(0,f.$sg)(q.applicationExtensionslocation,Q.applicationExtensionslocation)&&q.applicationExtensionslocationMtime===Q.applicationExtensionslocationMtime&&q.profile===Q.profile&&D.$en(q.profileScanOptions,Q.profileScanOptions)&&q.type===Q.type&&q.excludeObsolete===Q.excludeObsolete&&q.validate===Q.validate&&q.productVersion===Q.productVersion&&q.productDate===Q.productDate&&q.productCommit===Q.productCommit&&q.devMode===Q.devMode&&q.language===Q.language&&B.equals(q.translations,Q.translations)}}e.$Gp=ee;let oe=class extends c.$Rc{constructor(q,Q,T,U,H){super(),this.f=q,this.g=Q,this.h=T,this.j=U,this.m=H}async scanExtensions(q){const Q=q.profile?await this.r(q):await this.n(q);let T={};if(q.excludeObsolete&&q.type===1)try{const U=(await this.j.readFile(this.f)).value.toString();T=JSON.parse(U)}catch{}return(0,$.$Pf)(T)?Q:Q.filter(U=>!T[w.$Go.create(U).toString()])}async n(q){const Q=await this.j.resolve(q.location);if(!Q.children?.length)return[];const T=await Promise.all(Q.children.map(async U=>{if(!U.isDirectory||q.type===1&&(0,f.$wg)(U.resource).indexOf(".")===0)return null;const H=new ee(U.resource,q.mtime,q.applicationExtensionslocation,q.applicationExtensionslocationMtime,q.profile,q.profileScanOptions,q.type,q.excludeObsolete,q.validate,q.productVersion,q.productDate,q.productCommit,q.devMode,q.language,q.translations);return this.scanExtension(H)}));return(0,L.$Gb)(T).sort((U,H)=>U.location.path<H.location.path?-1:1)}async r(q){let Q=await this.s(q.location,()=>!0,q);if(q.applicationExtensionslocation&&!this.h.extUri.isEqual(q.location,q.applicationExtensionslocation)){Q=Q.filter(U=>!U.metadata?.isApplicationScoped);const T=await this.s(q.applicationExtensionslocation,U=>!!U.metadata?.isBuiltin||!!U.metadata?.isApplicationScoped,q);Q.push(...T)}return Q}async s(q,Q,T){const U=await this.g.scanProfileExtensions(q,T.profileScanOptions);if(!U.length)return[];const H=await Promise.all(U.map(async G=>{if(Q(G)){const Z=new ee(G.location,T.mtime,T.applicationExtensionslocation,T.applicationExtensionslocationMtime,T.profile,T.profileScanOptions,T.type,T.excludeObsolete,T.validate,T.productVersion,T.productDate,T.productCommit,T.devMode,T.language,T.translations);return this.scanExtension(Z,G.metadata)}return null}));return(0,L.$Gb)(H)}async scanOneOrMultipleExtensions(q){try{if(await this.j.exists((0,f.$zg)(q.location,"package.json"))){const Q=await this.scanExtension(q);return Q?[Q]:[]}else return await this.scanExtensions(q)}catch(Q){return this.m.error(`Error scanning extensions at ${q.location.path}:`,(0,j.$9)(Q)),[]}}async scanExtension(q,Q){try{let T=await this.scanExtensionManifest(q.location);if(T){T.publisher||(T.publisher=P.$8l),Q=Q??T.__metadata,delete T.__metadata;const U=(0,w.$Ko)(T.publisher,T.name),H=Q?.id?{id:U,uuid:Q.id}:{id:U},G=Q?.isSystem?0:q.type,Z=G===0||!!Q?.isBuiltin;T=await this.t(q.location,T,ee.createNlsConfiguration(q));const Y={type:G,identifier:H,manifest:T,location:q.location,isBuiltin:Z,targetPlatform:Q?.targetPlatform??"undefined",metadata:Q,isValid:!0,validations:[]};return q.validate?this.validate(Y,q):Y}}catch(T){q.type!==0&&this.m.error(T)}return null}validate(q,Q){let T=!0;const U=(0,s.$Vo)(Q.productVersion,Q.productDate,Q.location,q.manifest,q.isBuiltin);for(const[H,G]of U)H===y.default.Error&&(T=!1,this.m.error(this.z(Q.location,G)));return q.isValid=T,q.validations=U,q}async scanExtensionManifest(q){const Q=(0,f.$zg)(q,"package.json");let T;try{T=(await this.j.readFile(Q)).value.toString()}catch(H){return(0,o.$vk)(H)!==1&&this.m.error(this.z(q,(0,m.localize)(0,null,Q.path,H.message))),null}let U;try{U=JSON.parse(T)}catch{const G=[];(0,v.$3m)(T,G);for(const Z of G)this.m.error(this.z(q,(0,m.localize)(1,null,Q.path,Z.offset,Z.length,(0,h.$Cp)(Z.error))));return null}return(0,v.$_m)(U)!=="object"?(this.m.error(this.z(q,(0,m.localize)(2,null,Q.path))),null):U}async t(q,Q,T){const U=await this.u(q,Q,T);if(U)try{const H=[],G=await this.w(U.default,H);if(H.length>0)return H.forEach(Y=>{this.m.error(this.z(q,(0,m.localize)(3,null,U.default?.path,(0,h.$Cp)(Y.error))))}),Q;if((0,v.$_m)(U)!=="object")return this.m.error(this.z(q,(0,m.localize)(4,null,U.default?.path))),Q;const Z=U.values||Object.create(null);return(0,O.$Dp)(this.m,Q,Z,G)}catch{}return Q}async u(q,Q,T){const U=(0,f.$zg)(q,"package.nls.json"),H=(C,F)=>{F.forEach(a=>{this.m.error(this.z(q,(0,m.localize)(5,null,C?.path,(0,h.$Cp)(a.error))))})},G=C=>{this.m.error(this.z(q,(0,m.localize)(6,null,C?.path)))},Z=`${Q.publisher}.${Q.name}`,Y=T.translations[Z];if(Y)try{const C=u.URI.file(Y),F=(await this.j.readFile(C)).value.toString(),a=[],g=(0,v.$3m)(F,a);return a.length>0?(H(C,a),{values:void 0,default:U}):(0,v.$_m)(g)!=="object"?(G(C),{values:void 0,default:U}):{values:g.contents?g.contents.package:void 0,default:U}}catch{return{values:void 0,default:U}}else{if(!await this.j.exists(U))return;let F;try{F=await this.y(q,T)}catch{return}if(!F.localized)return{values:void 0,default:F.original};try{const a=(await this.j.readFile(F.localized)).value.toString(),g=[],z=(0,v.$3m)(a,g);return g.length>0?(H(F.localized,g),{values:void 0,default:F.original}):(0,v.$_m)(z)!=="object"?(G(F.localized),{values:void 0,default:F.original}):{values:z,default:F.original}}catch{return{values:void 0,default:F.original}}}}async w(q,Q){if(q)try{const T=(await this.j.readFile(q)).value.toString();return(0,v.$3m)(T,Q)}catch{}}y(q,Q){return new Promise((T,U)=>{const H=G=>{const Z=(0,f.$zg)(q,`package.nls.${G}.json`);this.j.exists(Z).then(Y=>{Y&&T({localized:Z,original:(0,f.$zg)(q,"package.nls.json")});const C=G.lastIndexOf("-");C===-1?T({localized:(0,f.$zg)(q,"package.nls.json"),original:null}):(G=G.substring(0,C),H(G))})};if(Q.devMode||Q.pseudo||!Q.language)return T({localized:(0,f.$zg)(q,"package.nls.json"),original:null});H(Q.language)})}z(q,Q){return`[${q.path}]: ${Q}`}};oe=pe([ie(1,k.$Ap),ie(2,p.$Ok),ie(3,o.$ek),ie(4,n.$dj)],oe);let se=class extends oe{constructor(q,Q,T,U,H,G,Z){super(Q,U,H,G,Z),this.G=q,this.H=T,this.D=this.B(new N.$Vg(3e3)),this.F=this.B(new r.$Rd),this.onDidChangeCache=this.F.event}async scanExtensions(q){const Q=this.M(q),T=await this.I(Q);if(this.C=q,T&&T.input&&ee.equals(T.input,this.C))return this.m.debug("Using cached extensions scan result",q.location.toString()),this.D.trigger(()=>this.L()),T.result.map(H=>(H.location=u.URI.revive(H.location),H));const U=await super.scanExtensions(q);return await this.J(Q,{input:q,result:U}),U}async I(q){try{const Q=await this.j.readFile(q),T=JSON.parse(Q.value.toString());return{result:T.result,input:(0,l.$sh)(T.input)}}catch(Q){this.m.debug("Error while reading the extension cache file:",q.path,(0,j.$9)(Q))}return null}async J(q,Q){try{await this.j.writeFile(q,A.$fe.fromString(JSON.stringify(Q)))}catch(T){this.m.debug("Error while writing the extension cache file:",q.path,(0,j.$9)(T))}}async L(){if(!this.C)return;const q=this.M(this.C),Q=await this.I(q);if(!Q)return;const T=Q.result,U=JSON.parse(JSON.stringify(await super.scanExtensions(this.C)));if(!D.$en(U,T))try{this.m.info("Invalidating Cache",T,U),await this.j.del(q),this.F.fire()}catch(H){this.m.error(H)}}M(q){const Q=this.N(q);return this.h.extUri.joinPath(Q.cacheHome,q.type===0?P.$7l:P.$6l)}N(q){return q.type===0?this.H.defaultProfile:q.profile?this.h.extUri.isEqual(q.location,this.G.extensionsResource)?this.G:this.H.profiles.find(Q=>this.h.extUri.isEqual(q.location,Q.extensionsResource))??this.G:this.H.defaultProfile}};se=pe([ie(2,b.$Qk),ie(3,k.$Ap),ie(4,p.$Ok),ie(5,o.$ek),ie(6,n.$dj)],se);function ue(re,q){const Q=(0,w.$Io)(re.manifest.publisher,re.manifest.name);return{id:Q,identifier:new P.$_l(Q),isBuiltin:re.type===0,isUserBuiltin:re.type===1&&re.isBuiltin,isUnderDevelopment:q,extensionLocation:re.location,uuid:re.identifier.uuid,targetPlatform:re.targetPlatform,...re.manifest}}e.$Hp=ue;class ce extends _{constructor(q,Q,T,U,H,G,Z,Y,C,F,a,g){super(q,Q,(0,f.$zg)(T,".vscode-oss-dev","extensions","control.json"),U,H,G,Z,Y,C,F,a,g),this.R=(async()=>{if(d.$z)try{const z=await this.w.readFile(u.URI.file(d.$z));return JSON.parse(z.value.toString())}catch{}return Object.create(null)})()}f(q){return this.R}}e.$Ip=ce}),define(te[154],ne([0,1,58,8,34,4,2,15,16,24,6,23]),function(J,e,L,N,D,A,j,v,h,c,E,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kp=void 0;let d=class extends j.$Rc{constructor(S,y){super(),this.b=S,this.f=y,this.a=new N.$4g(5)}async postUninstall(S){const y=this.g(S,"uninstall");y&&(this.f.info(S.identifier.id,S.manifest.version,"Running post uninstall script"),await this.a.queue(async()=>{try{await this.h(y.script,"uninstall",y.args,!0,S),this.f.info("Finished running post uninstall script",S.identifier.id,S.manifest.version)}catch($){this.f.error("Failed to run post uninstall script",S.identifier.id,S.manifest.version),this.f.error($)}}));try{await c.Promises.rm(this.m(S))}catch($){this.f.error("Error while removing extension storage path",S.identifier.id),this.f.error($)}}g(S,y){const $=`vscode:${y}`;if(S.location.scheme===v.Schemas.file&&S.manifest&&S.manifest.scripts&&typeof S.manifest.scripts[$]=="string"){const u=S.manifest.scripts[$].split(" ");return u.length<2||u[0]!=="node"||!u[1]?(this.f.warn(S.identifier.id,S.manifest.version,`${$} should be a node script`),null):{script:(0,h.$ic)(S.location.fsPath,u[1]),args:u.slice(2)||[]}}return null}h(S,y,$,u,m){return new Promise((I,w)=>{const P=this.j(S,y,$,m);let s;const o=t=>{s&&(clearTimeout(s),s=null),t?w(t):I(void 0)};P.on("error",t=>{o((0,D.$Gi)(t)||"Unknown")}),P.on("exit",(t,n)=>{o(t?`post-${y} process exited with code ${t}`:void 0)}),u&&(s=setTimeout(()=>{s=null,P.kill(),w("timed out")},5e3))})}j(S,y,$,u){const m={silent:!0,execArgv:void 0},I=(0,L.fork)(S,[`--type=extension-post-${y}`,...$],m);I.stdout.setEncoding("utf8"),I.stderr.setEncoding("utf8");const w=A.Event.fromNodeEventEmitter(I.stdout,"data"),P=A.Event.fromNodeEventEmitter(I.stderr,"data");w(t=>this.f.info(u.identifier.id,u.manifest.version,`post-${y}`,t)),P(t=>this.f.error(u.identifier.id,u.manifest.version,`post-${y}`,t));const s=A.Event.any(A.Event.map(w,t=>({data:`%c${t}`,format:[""]})),A.Event.map(P,t=>({data:`%c${t}`,format:["color: red"]})));return A.Event.debounce(s,(t,n)=>t?{data:t.data+n.data,format:[...t.format,...n.format]}:{data:n.data,format:n.format},100)(t=>{console.group(u.identifier.id),console.log(t.data,...t.format),console.groupEnd()}),I}m(S){return(0,h.$ic)(this.b.defaultProfile.globalStorageHome.fsPath,S.identifier.id.toLowerCase())}};e.$Kp=d,e.$Kp=d=pe([ie(0,R.$Qk),ie(1,E.$dj)],d)}),define(te[155],ne([0,1,6,23,22,26,40,12,18,11]),function(J,e,L,N,D,A,j,v,h,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$VN=void 0;let E=class extends j.$Bp{constructor(d,f,S,y,$,u){super(c.URI.file(d.extensionsPath),f,S,y,$,u)}};e.$VN=E,e.$VN=E=pe([ie(0,h.$4h),ie(1,v.$ek),ie(2,N.$Qk),ie(3,D.$Ok),ie(4,A.$il),ie(5,L.$dj)],E)}),define(te[156],ne([0,1,11,18,40,50,12,10,6,32,22,23]),function(J,e,L,N,D,A,j,v,h,c,E,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$r9b=void 0;let d=class extends A.$Ip{constructor(S,y,$,u,m,I,w,P){super(L.URI.file(m.builtinExtensionsPath),L.URI.file(m.extensionsPath),m.userHome,S.defaultProfile,S,y,$,u,m,I,w,P)}};e.$r9b=d,e.$r9b=d=pe([ie(0,R.$Qk),ie(1,D.$Ap),ie(2,j.$ek),ie(3,h.$dj),ie(4,N.$4h),ie(5,c.$vj),ie(6,E.$Ok),ie(7,v.$Uh)],d)}),define(te[157],ne([0,1,8,4,2,123,3,86,10,23]),function(J,e,L,N,D,A,j,v,h,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ep=e.$dp=e.$cp=e.$bp=e.$ap=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.$_o=e.$$o=e.$0o=void 0,e.$0o="__$__isNewStorageMarker",e.$$o="__$__targetStorageMarker",e.$_o=(0,h.$Vh)("storageService");var E;(function(m){m[m.NONE=0]="NONE",m[m.SHUTDOWN=1]="SHUTDOWN"})(E||(e.WillSaveStateReason=E={}));var R;(function(m){m[m.APPLICATION=-1]="APPLICATION",m[m.PROFILE=0]="PROFILE",m[m.WORKSPACE=1]="WORKSPACE"})(R||(e.StorageScope=R={}));var d;(function(m){m[m.USER=0]="USER",m[m.MACHINE=1]="MACHINE"})(d||(e.StorageTarget=d={}));function f(m){const I=m.get(e.$$o);if(I)try{return JSON.parse(I)}catch{}return Object.create(null)}e.$ap=f;class S extends D.$Rc{static{this.a=60*1e3}constructor(I={flushInterval:S.a}){super(),this.m=I,this.b=this.B(new N.$Ud),this.c=this.B(new N.$Ud),this.onDidChangeTarget=this.c.event,this.f=this.B(new N.$Rd),this.onWillSaveState=this.f.event,this.h=this.B(new L.$0g(()=>this.n(),this.m.flushInterval)),this.j=this.B(new D.$Sc),this.C=void 0,this.F=void 0,this.H=void 0}onDidChangeValue(I,w,P){return N.Event.filter(this.b.event,s=>s.scope===I&&(w===void 0||s.key===w),P)}n(){this.j.value=(0,L.$bh)(()=>{this.r()&&this.flush(),this.h.schedule()})}r(){return!0}t(){(0,D.$Mc)([this.j,this.h])}initialize(){return this.g||(this.g=(async()=>{(0,A.mark)("code/willInitStorage");try{await this.O()}finally{(0,A.mark)("code/didInitStorage")}this.h.schedule()})()),this.g}u(I,w){const{key:P,external:s}=w;if(P===e.$$o){switch(I){case-1:this.H=void 0;break;case 0:this.F=void 0;break;case 1:this.C=void 0;break}this.c.fire({scope:I})}else this.b.fire({scope:I,key:P,target:this.J(I)[P],external:s})}w(I){this.f.fire({reason:I})}get(I,w,P){return this.P(w)?.get(I,P)}getBoolean(I,w,P){return this.P(w)?.getBoolean(I,P)}getNumber(I,w,P){return this.P(w)?.getNumber(I,P)}getObject(I,w,P){return this.P(w)?.getObject(I,P)}storeAll(I,w){this.y(()=>{for(const P of I)this.store(P.key,P.value,P.scope,P.target,w)})}store(I,w,P,s,o=!1){if((0,j.$Lf)(w)){this.remove(I,P,o);return}this.y(()=>{this.z(I,P,s),this.P(P)?.set(I,w,o)})}remove(I,w,P=!1){this.y(()=>{this.z(I,w,void 0),this.P(w)?.delete(I,P)})}y(I){this.b.pause(),this.c.pause();try{I()}finally{this.b.resume(),this.c.resume()}}keys(I,w){const P=[],s=this.J(I);for(const o of Object.keys(s))s[o]===w&&P.push(o);return P}z(I,w,P,s=!1){const o=this.J(w);typeof P=="number"?o[I]!==P&&(o[I]=P,this.P(w)?.set(e.$$o,JSON.stringify(o),s)):typeof o[I]=="number"&&(delete o[I],this.P(w)?.set(e.$$o,JSON.stringify(o),s))}get D(){return this.C||(this.C=this.L(1)),this.C}get G(){return this.F||(this.F=this.L(0)),this.F}get I(){return this.H||(this.H=this.L(-1)),this.H}J(I){switch(I){case-1:return this.I;case 0:return this.G;default:return this.D}}L(I){const w=this.P(I);return w?f(w):Object.create(null)}isNew(I){return this.getBoolean(e.$0o,I)===!0}async flush(I=E.NONE){this.f.fire({reason:I});const w=this.P(-1),P=this.P(0),s=this.P(1);switch(I){case E.NONE:await L.Promises.settled([w?.whenFlushed()??Promise.resolve(),P?.whenFlushed()??Promise.resolve(),s?.whenFlushed()??Promise.resolve()]);break;case E.SHUTDOWN:await L.Promises.settled([w?.flush(0)??Promise.resolve(),P?.flush(0)??Promise.resolve(),s?.flush(0)??Promise.resolve()]);break}}async log(){const I=this.P(-1)?.items??new Map,w=this.P(0)?.items??new Map,P=this.P(1)?.items??new Map;return u(I,w,P,this.Q(-1)??"",this.Q(0)??"",this.Q(1)??"")}async optimize(I){return await this.flush(),this.P(I)?.optimize()}async switch(I,w){return this.w(E.NONE),(0,c.$Pk)(I)?this.R(I,w):this.S(I,w)}M(I,w){return!(I.id===w.id||y(w)&&y(I))}N(I,w,P){this.y(()=>{const s=new Set;for(const[o,t]of I)s.add(o),w.get(o)!==t&&this.u(P,{key:o,external:!0});for(const[o]of w.items)s.has(o)||this.u(P,{key:o,external:!0})})}}e.$bp=S;function y(m){return m.isDefault||!!m.useDefaultFlags?.globalState}e.$cp=y;class $ extends S{constructor(){super(),this.U=this.B(new v.$8o(new v.$9o,{hint:v.StorageHint.STORAGE_IN_MEMORY})),this.W=this.B(new v.$8o(new v.$9o,{hint:v.StorageHint.STORAGE_IN_MEMORY})),this.X=this.B(new v.$8o(new v.$9o,{hint:v.StorageHint.STORAGE_IN_MEMORY})),this.B(this.X.onDidChangeStorage(I=>this.u(1,I))),this.B(this.W.onDidChangeStorage(I=>this.u(0,I))),this.B(this.U.onDidChangeStorage(I=>this.u(-1,I)))}P(I){switch(I){case-1:return this.U;case 0:return this.W;default:return this.X}}Q(I){switch(I){case-1:return"inMemory (application)";case 0:return"inMemory (profile)";default:return"inMemory (workspace)"}}async O(){}async R(){}async S(){}r(){return!1}hasScope(I){return!1}}e.$dp=$;async function u(m,I,w,P,s,o){const t=B=>{try{return JSON.parse(B)}catch{return B}},n=new Map,i=new Map;m.forEach((B,_)=>{n.set(_,B),i.set(_,t(B))});const r=new Map,l=new Map;I.forEach((B,_)=>{r.set(_,B),l.set(_,t(B))});const k=new Map,b=new Map;w.forEach((B,_)=>{k.set(_,B),b.set(_,t(B))}),console.group(P!==s?`Storage: Application (path: ${P})`:`Storage: Application & Profile (path: ${P}, default profile)`);const p=[];if(n.forEach((B,_)=>{p.push({key:_,value:B})}),console.table(p),console.groupEnd(),console.log(i),P!==s){console.group(`Storage: Profile (path: ${s}, profile specific)`);const B=[];r.forEach((_,ee)=>{B.push({key:ee,value:_})}),console.table(B),console.groupEnd(),console.log(l)}console.group(`Storage: Workspace (path: ${o})`);const O=[];k.forEach((B,_)=>{O.push({key:_,value:B})}),console.table(O),console.groupEnd(),console.log(b)}e.$ep=u}),define(te[158],ne([0,1,19,20,9,13,35,3,11,25,18,21,27,48,12,6,32,44,142,157,26,175]),function(J,e,L,N,D,A,j,v,h,c,E,R,d,f,S,y,$,u,m,I,w,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jp=e.$ip=e.$hp=void 0;const s=A.$o?"web":(0,R.$_n)(A.$u,j.$dc),o="X-Market-Search-Activity-Id";var t;(function(a){a[a.None=0]="None",a[a.IncludeVersions=1]="IncludeVersions",a[a.IncludeFiles=2]="IncludeFiles",a[a.IncludeCategoryAndTags=4]="IncludeCategoryAndTags",a[a.IncludeSharedAccounts=8]="IncludeSharedAccounts",a[a.IncludeVersionProperties=16]="IncludeVersionProperties",a[a.ExcludeNonValidated=32]="ExcludeNonValidated",a[a.IncludeInstallationTargets=64]="IncludeInstallationTargets",a[a.IncludeAssetUri=128]="IncludeAssetUri",a[a.IncludeStatistics=256]="IncludeStatistics",a[a.IncludeLatestVersionOnly=512]="IncludeLatestVersionOnly",a[a.Unpublished=4096]="Unpublished",a[a.IncludeNameConflictInfo=32768]="IncludeNameConflictInfo"})(t||(t={}));function n(...a){return String(a.reduce((g,z)=>g|z,0))}var i;(function(a){a[a.Tag=1]="Tag",a[a.ExtensionId=4]="ExtensionId",a[a.Category=5]="Category",a[a.ExtensionName=7]="ExtensionName",a[a.Target=8]="Target",a[a.Featured=9]="Featured",a[a.SearchText=10]="SearchText",a[a.ExcludeWithFlags=12]="ExcludeWithFlags"})(i||(i={}));const r={Icon:"Microsoft.VisualStudio.Services.Icons.Default",Details:"Microsoft.VisualStudio.Services.Content.Details",Changelog:"Microsoft.VisualStudio.Services.Content.Changelog",Manifest:"Microsoft.VisualStudio.Code.Manifest",VSIX:"Microsoft.VisualStudio.Services.VSIXPackage",License:"Microsoft.VisualStudio.Services.Content.License",Repository:"Microsoft.VisualStudio.Services.Links.Source",Signature:"Microsoft.VisualStudio.Services.VsixSignature"},l={Dependency:"Microsoft.VisualStudio.Code.ExtensionDependencies",ExtensionPack:"Microsoft.VisualStudio.Code.ExtensionPack",Engine:"Microsoft.VisualStudio.Code.Engine",PreRelease:"Microsoft.VisualStudio.Code.PreRelease",LocalizedLanguages:"Microsoft.VisualStudio.Code.LocalizedLanguages",WebExtension:"Microsoft.VisualStudio.Code.WebExtension",SponsorLink:"Microsoft.VisualStudio.Code.SponsorLink"},b={pageNumber:1,pageSize:10,sortBy:0,sortOrder:0,flags:t.None,criteria:[],assetTypes:[]};class p{constructor(g=b){this.d=g}get pageNumber(){return this.d.pageNumber}get pageSize(){return this.d.pageSize}get sortBy(){return this.d.sortBy}get sortOrder(){return this.d.sortOrder}get flags(){return this.d.flags}get criteria(){return this.d.criteria}withPage(g,z=this.d.pageSize){return new p({...this.d,pageNumber:g,pageSize:z})}withFilter(g,...z){const M=[...this.d.criteria,...z.length?z.map(X=>({filterType:g,value:X})):[{filterType:g}]];return new p({...this.d,criteria:M})}withSortBy(g){return new p({...this.d,sortBy:g})}withSortOrder(g){return new p({...this.d,sortOrder:g})}withFlags(...g){return new p({...this.d,flags:g.reduce((z,M)=>z|M,0)})}withAssetTypes(...g){return new p({...this.d,assetTypes:g})}withSource(g){return new p({...this.d,source:g})}get raw(){const{criteria:g,pageNumber:z,pageSize:M,sortBy:X,sortOrder:W,flags:le,assetTypes:ae}=this.d;return{filters:[{criteria:g,pageNumber:z,pageSize:M,sortBy:X,sortOrder:W}],assetTypes:ae,flags:le}}get searchText(){const g=this.d.criteria.filter(z=>z.filterType===i.SearchText)[0];return g&&g.value?g.value:""}get telemetryData(){return{filterTypes:this.d.criteria.map(g=>String(g.filterType)),flags:this.d.flags,sortBy:String(this.sortBy),sortOrder:String(this.sortOrder),pageNumber:String(this.pageNumber),source:this.d.source,searchTextLength:this.searchText.length}}}function O(a,g){const z=(a||[]).filter(M=>M.statisticName===g)[0];return z?z.value:0}function B(a){const g="Microsoft.VisualStudio.Code.Translation.";return a.files.filter(M=>M.assetType.indexOf(g)===0).reduce((M,X)=>{const W=oe(a,X.assetType);return W&&M.push([X.assetType.substring(g.length),W]),M},[])}function _(a){if(a.properties){const g=a.properties.filter(X=>X.key===r.Repository),z=new RegExp("((git|ssh|http(s)?)|(git@[\\w.]+))(:(//)?)([\\w.@:/\\-~]+)(.git)(/)?"),M=g.filter(X=>z.test(X.value))[0];return M?{uri:M.value,fallbackUri:M.value}:null}return oe(a,r.Repository)}function ee(a){return{uri:`${a.fallbackAssetUri}/${r.VSIX}?redirect=true${a.targetPlatform?`&targetPlatform=${a.targetPlatform}`:""}`,fallbackUri:`${a.fallbackAssetUri}/${r.VSIX}${a.targetPlatform?`?targetPlatform=${a.targetPlatform}`:""}`}}function oe(a,g){return a.files.filter(M=>M.assetType===g)[0]?{uri:`${a.assetUri}/${g}${a.targetPlatform?`?targetPlatform=${a.targetPlatform}`:""}`,fallbackUri:`${a.fallbackAssetUri}/${g}${a.targetPlatform?`?targetPlatform=${a.targetPlatform}`:""}`}:null}function se(a,g){const z=a.properties?a.properties.filter(X=>X.key===g):[],M=z.length>0&&z[0].value;return M?M.split(",").map(X=>(0,d.$Jo)(X)):[]}function ue(a){const g=a.properties?a.properties.filter(z=>z.key===l.Engine):[];return g.length>0&&g[0].value||""}function ce(a){const g=a.properties?a.properties.filter(z=>z.key===l.PreRelease):[];return g.length>0&&g[0].value==="true"}function re(a){const g=a.properties?a.properties.filter(M=>M.key===l.LocalizedLanguages):[],z=g.length>0&&g[0].value||"";return z?z.split(","):[]}function q(a){return a.properties?.find(g=>g.key===l.SponsorLink)?.value}function Q(a){return a.indexOf("preview")!==-1}function T(a){return a.targetPlatform?(0,R.$$n)(a.targetPlatform):"undefined"}function U(a){const g=(0,L.$Lb)(a.versions.map(T)),z=!!a.tags?.includes(R.$6n),M=g.indexOf("web");return z?M===-1&&g.push("web"):M!==-1&&g.splice(M,1),g}function H(a,g){for(let z=0;z<a.length;z++){const M=a[z];if(M.version===a[z-1]?.version){let X=z;if(T(M)===g)for(;X>0&&a[X-1].version===M.version;)X--;X!==z&&(a.splice(z,1),a.splice(X,0,M))}}return a}e.$hp=H;function G(a,g,z){a.telemetryData={index:g,querySource:z,queryActivityId:a.queryContext?.[o]}}function Z(a,g,z,M){const X=a.versions[0],W={manifest:oe(g,r.Manifest),readme:oe(g,r.Details),changelog:oe(g,r.Changelog),license:oe(g,r.License),repository:_(g),download:ee(g),icon:oe(g,r.Icon),signature:oe(g,r.Signature),coreTranslations:B(g)};return{identifier:{id:(0,d.$Ko)(a.publisher.publisherName,a.extensionName),uuid:a.extensionId},name:a.extensionName,version:g.version,displayName:a.displayName,publisherId:a.publisher.publisherId,publisher:a.publisher.publisherName,publisherDisplayName:a.publisher.displayName,publisherDomain:a.publisher.domain?{link:a.publisher.domain,verified:!!a.publisher.isDomainVerified}:void 0,publisherSponsorLink:q(X),description:a.shortDescription||"",installCount:O(a.statistics,"install"),rating:O(a.statistics,"averagerating"),ratingCount:O(a.statistics,"ratingcount"),categories:a.categories||[],tags:a.tags||[],releaseDate:Date.parse(a.releaseDate),lastUpdated:Date.parse(a.lastUpdated),allTargetPlatforms:z,assets:W,properties:{dependencies:se(g,l.Dependency),extensionPack:se(g,l.ExtensionPack),engine:ue(g),localizedLanguages:re(g),targetPlatform:T(g),isPreReleaseVersion:ce(g)},hasPreReleaseVersion:ce(X),hasReleaseVersion:!0,preview:Q(a.flags),isSigned:!!W.signature,queryContext:M}}let Y=class{constructor(g,z,M,X,W,le,ae,me){this.k=z,this.l=M,this.n=X,this.o=W,this.q=le,this.u=ae,this.w=me;const de=ae.extensionsGallery,ge=de?.servicePPEUrl&&me.getValue("_extensionsGallery.enablePPE");this.d=ge?de.servicePPEUrl:de?.serviceUrl,this.g=ge?void 0:de?.searchUrl,this.h=de?.controlUrl,this.j=(0,m.$gp)(ae.version,ae,this.n,this.w,this.q,g,this.o)}x(g=""){return`${this.d}${g}`}isEnabled(){return!!this.d}async getExtensions(g,z,M){const X=N.CancellationToken.isCancellationToken(z)?{}:z,W=N.CancellationToken.isCancellationToken(z)?z:M,le=[],ae=[],me=[],de=[];let ge=!0;for(const we of g){we.uuid?ae.push(we.uuid):le.push(we.id);const be=!!(we.version||we.preRelease);me.push({id:we.id,uuid:we.uuid,includePreRelease:be}),we.version&&de.push({id:we.id,uuid:we.uuid,version:we.version}),ge=ge&&!!we.hasPreRelease&&!be}if(!ae.length&&!le.length)return[];let fe=new p().withPage(1,g.length);ae.length&&(fe=fe.withFilter(i.ExtensionId,...ae)),le.length&&(fe=fe.withFilter(i.ExtensionName,...le)),(X.queryAllVersions||ge)&&(fe=fe.withFlags(fe.flags,t.IncludeVersions)),X.source&&(fe=fe.withSource(X.source));const{extensions:he}=await this.z(fe,{targetPlatform:X.targetPlatform??s,includePreRelease:me,versions:de,compatible:!!X.compatible},W);return X.source&&he.forEach((we,be)=>G(we,be,X.source)),he}async getCompatibleExtension(g,z,M){if((0,R.$ao)(g.allTargetPlatforms,M))return null;if(await this.isExtensionCompatible(g,z,M))return g;const X=new p().withFlags(t.IncludeVersions).withPage(1,1).withFilter(i.ExtensionId,g.identifier.uuid),{extensions:W}=await this.z(X,{targetPlatform:M,compatible:!0,includePreRelease:z},N.CancellationToken.None);return W[0]||null}async isExtensionCompatible(g,z,M){if(!(0,R.$bo)(g.properties.targetPlatform,g.allTargetPlatforms,M)||!z&&g.properties.isPreReleaseVersion)return!1;let X=g.properties.engine;if(!X){const W=await this.getManifest(g,N.CancellationToken.None);if(!W)throw new Error("Manifest was not found");X=W.engines.vscode}return(0,f.$Xo)(X,this.u.version,this.u.date)}async y(g,z,M,X,W){if(!(0,R.$bo)(T(g),X,W)||z!=="any"&&ce(g)!==(z==="prerelease"))return!1;if(M)try{const le=await this.E(g);if(!(0,f.$Xo)(le,this.u.version,this.u.date))return!1}catch(le){return this.l.error(`Error while getting the engine for the version ${g.version}.`,(0,D.$9)(le)),!1}return!0}async query(g,z){let M=g.text||"";const X=g.pageSize??50;let W=new p().withPage(1,X);M?(M=M.replace(/\bcategory:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(ge,fe,he)=>(W=W.withFilter(i.Category,he||fe),"")),M=M.replace(/\btag:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(ge,fe,he)=>(W=W.withFilter(i.Tag,he||fe),"")),M=M.replace(/\bfeatured(\s+|\b|$)/g,()=>(W=W.withFilter(i.Featured),"")),M=M.trim(),M&&(M=M.length<200?M:M.substring(0,200),W=W.withFilter(i.SearchText,M)),W=W.withSortBy(0)):g.ids?W=W.withFilter(i.ExtensionId,...g.ids):g.names?W=W.withFilter(i.ExtensionName,...g.names):W=W.withSortBy(4),typeof g.sortBy=="number"&&(W=W.withSortBy(g.sortBy)),typeof g.sortOrder=="number"&&(W=W.withSortOrder(g.sortOrder)),g.source&&(W=W.withSource(g.source));const le=async(ge,fe)=>{const{extensions:he,total:we}=await this.z(ge,{targetPlatform:s,compatible:!1,includePreRelease:!!g.includePreRelease},fe);return he.forEach((be,ke)=>G(be,(ge.pageNumber-1)*ge.pageSize+ke,g.source)),{extensions:he,total:we}},{extensions:ae,total:me}=await le(W,z),de=async(ge,fe)=>{if(fe.isCancellationRequested)throw new D.$4;const{extensions:he}=await le(W.withPage(ge+1),fe);return he};return{firstPage:ae,total:me,pageSize:W.pageSize,getPage:de}}async z(g,z,M){const X=g.flags;g.flags&t.IncludeLatestVersionOnly&&g.flags&t.IncludeVersions&&(g=g.withFlags(g.flags&~t.IncludeVersions,t.IncludeLatestVersionOnly)),!(g.flags&t.IncludeLatestVersionOnly)&&!(g.flags&t.IncludeVersions)&&(g=g.withFlags(g.flags,t.IncludeLatestVersionOnly)),z.versions?.length&&(g=g.withFlags(g.flags&~t.IncludeLatestVersionOnly,t.IncludeVersions)),g=g.withFlags(g.flags,t.IncludeAssetUri,t.IncludeCategoryAndTags,t.IncludeFiles,t.IncludeStatistics,t.IncludeVersionProperties);const{galleryExtensions:W,total:le,context:ae}=await this.B(g,M);if(!(g.flags&t.IncludeLatestVersionOnly)){const fe=[];for(const he of W){const we=await this.A(he,z,ae);we&&fe.push(we)}return{extensions:fe,total:le}}const de=[],ge=new Map;for(let fe=0;fe<W.length;fe++){const he=W[fe],we={id:(0,d.$Ko)(he.publisher.publisherName,he.extensionName),uuid:he.extensionId},be=(0,v.$If)(z.includePreRelease)?z.includePreRelease:!!z.includePreRelease.find(Ce=>(0,d.$Fo)(Ce,we))?.includePreRelease;if(z.compatible&&(0,R.$ao)(U(he),z.targetPlatform))continue;const ke=await this.A(he,z,ae);!ke||ke.properties.isPreReleaseVersion&&(!be||!ke.hasReleaseVersion)||!ke.properties.isPreReleaseVersion&&ke.properties.targetPlatform!==z.targetPlatform&&ke.hasPreReleaseVersion?ge.set(he.extensionId,fe):de.push([fe,ke])}if(ge.size){const fe=new P.$Nd,he=new p().withFlags(X&~t.IncludeLatestVersionOnly,t.IncludeVersions).withPage(1,ge.size).withFilter(i.ExtensionId,...ge.keys()),{extensions:we}=await this.z(he,z,M);this.o.publicLog2("galleryService:additionalQuery",{duration:fe.elapsed(),count:ge.size});for(const be of we){const ke=ge.get(be.identifier.uuid);de.push([ke,be])}}return{extensions:de.sort((fe,he)=>fe[0]-he[0]).map(([,fe])=>fe),total:le}}async A(g,z,M){const X={id:(0,d.$Ko)(g.publisher.publisherName,g.extensionName),uuid:g.extensionId},W=z.versions?.find(de=>(0,d.$Fo)(de,X))?.version,le=(0,v.$If)(z.includePreRelease)?z.includePreRelease:!!z.includePreRelease.find(de=>(0,d.$Fo)(de,X))?.includePreRelease,ae=U(g),me=H(g.versions,z.targetPlatform);if(z.compatible&&(0,R.$ao)(ae,z.targetPlatform))return null;for(let de=0;de<me.length;de++){const ge=me[de];if(!(W&&ge.version!==W)){if(await this.y(ge,le?"any":"release",z.compatible,ae,z.targetPlatform))return Z(g,ge,ae,M);if(W&&ge.version===W)return null}}return W||z.compatible?null:Z(g,g.versions[0],ae)}async B(g,z){if(!this.isEnabled())throw new Error("No extension gallery service configured.");g=g.withFlags(g.flags,t.ExcludeNonValidated).withFilter(i.Target,"Microsoft.VisualStudio.Code").withFilter(i.ExcludeWithFlags,n(t.Unpublished));const M=await this.j,X=JSON.stringify(g.raw),W={...M,"Content-Type":"application/json",Accept:"application/json;api-version=3.0-preview.1","Accept-Encoding":"gzip","Content-Length":String(X.length)},le=new P.$Nd;let ae,me,de=0;try{if(ae=await this.k.request({type:"POST",url:this.g&&g.criteria.some(fe=>fe.filterType===i.SearchText)?this.g:this.x("/extensionquery"),data:X,headers:W},z),ae.res.statusCode&&ae.res.statusCode>=400&&ae.res.statusCode<500)return{galleryExtensions:[],total:de};const ge=await(0,u.$5o)(ae);if(ge){const fe=ge.results[0],he=fe.extensions,we=fe.resultMetadata&&fe.resultMetadata.filter(be=>be.metadataType==="ResultCount")[0];return de=we&&we.metadataItems.filter(be=>be.name==="TotalCount")[0].count||0,{galleryExtensions:he,total:de,context:{[o]:ae.res.headers.activityid}}}return{galleryExtensions:[],total:de}}catch(ge){throw me=ge,ge}finally{this.o.publicLog2("galleryService:query",{...g.telemetryData,requestBodySize:String(X.length),duration:le.elapsed(),success:!!ae&&(0,u.$1o)(ae),responseBodySize:ae?.res.headers["Content-Length"],statusCode:ae?String(ae.res.statusCode):void 0,errorCode:me?(0,D.$3)(me)?"canceled":(0,D.$9)(me).startsWith("XHR timeout")?"timeout":"failed":void 0,count:String(de)})}}async reportStatistic(g,z,M,X){if(!this.isEnabled())return;const W=A.$o?this.x(`/itemName/${g}.${z}/version/${M}/statType/${X==="install"?"1":"3"}/vscodewebextension`):this.x(`/publishers/${g}/extensions/${z}/${M}/stats?statType=${X}`),le=A.$o?"api-version=6.1-preview.1":"*/*;api-version=4.0-preview.1",me={...await this.j,Accept:le};try{await this.k.request({type:"POST",url:W,headers:me},N.CancellationToken.None)}catch{}}async download(g,z,M){this.l.trace("ExtensionGalleryService#download",g.identifier.id);const X=(0,d.$No)(g),W=new Date().getTime(),le=fe=>this.o.publicLog("galleryService:downloadVSIX",{...X,duration:fe}),ae=M===2?"install":M===3?"update":"",me=ae?{uri:`${g.assets.download.uri}${h.URI.parse(g.assets.download.uri).query?"&":"?"}${ae}=true`,fallbackUri:`${g.assets.download.fallbackUri}${h.URI.parse(g.assets.download.fallbackUri).query?"&":"?"}${ae}=true`}:g.assets.download,de=g.queryContext?.[o]?{[o]:g.queryContext[o]}:void 0,ge=await this.D(me,de?{headers:de}:void 0);await this.q.writeFile(z,ge.stream),le(new Date().getTime()-W)}async downloadSignatureArchive(g,z){if(!g.assets.signature)throw new Error("No signature asset found");this.l.trace("ExtensionGalleryService#downloadSignatureArchive",g.identifier.id);const M=await this.D(g.assets.signature);await this.q.writeFile(z,M.stream)}async getReadme(g,z){if(g.assets.readme){const M=await this.D(g.assets.readme,{},z);return await(0,u.$4o)(M)||""}return""}async getManifest(g,z){if(g.assets.manifest){const M=await this.D(g.assets.manifest,{},z),X=await(0,u.$4o)(M);return X?JSON.parse(X):null}return null}async C(g,z){const M=oe(g,r.Manifest);if(!M)throw new Error("Manifest was not found");const X={"Accept-Encoding":"gzip"},W=await this.D(M,{headers:X});return await(0,u.$5o)(W)}async getCoreTranslation(g,z){const M=g.assets.coreTranslations.filter(X=>X[0]===z.toUpperCase())[0];if(M){const X=await this.D(M[1]),W=await(0,u.$4o)(X);return W?JSON.parse(W):null}return null}async getChangelog(g,z){if(g.assets.changelog){const M=await this.D(g.assets.changelog,{},z);return await(0,u.$4o)(M)||""}return""}async getAllCompatibleVersions(g,z,M){let X=new p().withFlags(t.IncludeVersions,t.IncludeCategoryAndTags,t.IncludeFiles,t.IncludeVersionProperties).withPage(1,1);g.identifier.uuid?X=X.withFilter(i.ExtensionId,g.identifier.uuid):X=X.withFilter(i.ExtensionName,g.identifier.id);const{galleryExtensions:W}=await this.B(X,N.CancellationToken.None);if(!W.length)return[];const le=U(W[0]);if((0,R.$ao)(le,M))return[];const ae=[];await Promise.all(W[0].versions.map(async ge=>{try{await this.y(ge,z?"any":"release",!0,le,M)&&ae.push(ge)}catch{}}));const me=[],de=new Set;for(const ge of H(ae,M))de.has(ge.version)||(de.add(ge.version),me.push({version:ge.version,date:ge.lastUpdated,isPreReleaseVersion:ce(ge)}));return me}async D(g,z={},M=N.CancellationToken.None){const X=await this.j,W={type:"GET"},le={...X,...z.headers||{}};z={...z,...W,headers:le};const ae=g.uri,me=g.fallbackUri,de={...z,url:ae};try{const ge=await this.k.request(de,M);if(ge.res.statusCode===200)return ge;const fe=await(0,u.$4o)(ge);throw new Error(`Expected 200, got back ${ge.res.statusCode} instead.

${fe}`)}catch(ge){if((0,D.$3)(ge))throw ge;const fe=(0,D.$9)(ge);this.o.publicLog2("galleryService:cdnFallback",{url:ae,message:fe});const he={...z,url:me};return this.k.request(he,M)}}async E(g){let z=ue(g);if(!z){const M=await this.C(g,N.CancellationToken.None);if(!M)throw new Error("Manifest was not found");z=M.engines.vscode}return z}async getExtensionsControlManifest(){if(!this.isEnabled())throw new Error("No extension gallery service configured.");if(!this.h)return{malicious:[],deprecated:{},search:[]};const g=await this.k.request({type:"GET",url:this.h},N.CancellationToken.None);if(g.res.statusCode!==200)throw new Error("Could not get extensions report.");const z=await(0,u.$5o)(g),M=[],X={},W=[];if(z){for(const le of z.malicious)M.push({id:le});if(z.migrateToPreRelease)for(const[le,ae]of Object.entries(z.migrateToPreRelease))(!ae.engine||(0,f.$Xo)(ae.engine,this.u.version,this.u.date))&&(X[le.toLowerCase()]={disallowInstall:!0,extension:{id:ae.id,displayName:ae.displayName,autoMigrate:{storage:!!ae.migrateStorage},preRelease:!0}});if(z.deprecated)for(const[le,ae]of Object.entries(z.deprecated))ae&&(X[le.toLowerCase()]=(0,v.$If)(ae)?{}:ae);if(z.search)for(const le of z.search)W.push(le)}return{malicious:M,deprecated:X,search:W}}};Y=pe([ie(1,u.$Yo),ie(2,y.$dj),ie(3,E.$3h),ie(4,w.$il),ie(5,S.$ek),ie(6,$.$vj),ie(7,c.$pi)],Y);let C=class extends Y{constructor(g,z,M,X,W,le,ae,me){super(g,z,M,X,W,le,ae,me)}};e.$ip=C,e.$ip=C=pe([ie(0,I.$_o),ie(1,u.$Yo),ie(2,y.$dj),ie(3,E.$3h),ie(4,w.$il),ie(5,S.$ek),ie(6,$.$vj),ie(7,c.$pi)],C);let F=class extends Y{constructor(g,z,M,X,W,le,ae){super(void 0,g,z,M,X,W,le,ae)}};e.$jp=F,e.$jp=F=pe([ie(0,u.$Yo),ie(1,y.$dj),ie(2,E.$3h),ie(3,w.$il),ie(4,S.$ek),ie(5,$.$vj),ie(6,c.$pi)],F)}),define(te[159],ne([0,1,11,18,12,6,139,22,23,3,68]),function(J,e,L,N,D,A,j,v,h,c,E){"use strict";var R,d;Object.defineProperty(e,"__esModule",{value:!0}),e.$UN=e.$TN=e.$SN=void 0;let f=class extends h.$Tk{static{R=this}static{this.a="profileAssociationsMigration"}constructor(u,m,I,w,P){super(I,w,m,P),this.U=u,this.W=I}O(){return this.U.getItem(R.b,[]).map(m=>({...m,location:(0,c.$Cf)(m.location)?this.w.extUri.joinPath(this.profilesHome,m.location):L.URI.revive(m.location)}))}Q(){const u=this.U.getItem(R.c,{});return this.U.getItem(R.a,!1)?u:this.N(u)}S(){return this.w.extUri.joinPath(L.URI.file(this.W.extensionsPath).with({scheme:this.profilesHome.scheme}),"extensions.json")}};e.$SN=f,e.$SN=f=R=pe([ie(0,j.$NN),ie(1,v.$Ok),ie(2,N.$4h),ie(3,D.$ek),ie(4,A.$dj)],f);let S=d=class extends f{constructor(u,m,I,w,P){super(u,m,I,w,P),this.$=u}P(u){u.length?this.$.setItem(d.b,u.map(m=>({...m,location:this.w.extUri.basename(m.location)}))):this.$.removeItem(d.b)}O(){const u=super.O();return this.$.getItem("userDataProfilesMigration",!1)||(this.P(u),this.$.setItem("userDataProfilesMigration",!0)),u}R(u){u.emptyWindows||u.workspaces?this.$.setItem(d.c,u):this.$.removeItem(d.c)}Q(){const u="workspaceAndProfileInfo",m=this.$.getItem(u,void 0);if(m){this.$.removeItem(u);const w=m.reduce((P,{workspace:s,profile:o})=>(P[L.URI.revive(s).toString()]=L.URI.revive(o).toString(),P),{});this.$.setItem(d.c,{workspaces:w})}const I=super.Q();return this.$.getItem(d.a,!1)||(this.R(I),this.$.setItem(d.a,!0)),I}};e.$TN=S,e.$TN=S=d=pe([ie(0,j.$ON),ie(1,v.$Ok),ie(2,N.$4h),ie(3,D.$ek),ie(4,A.$dj)],S);let y=class extends S{constructor(u,m,I,w){super(new E.$RN(0,m,w,I),u,m,I,w)}async init(){return await this.$.init(),super.init()}};e.$UN=y,e.$UN=y=pe([ie(0,v.$Ok),ie(1,N.$4h),ie(2,D.$ek),ie(3,A.$dj)],y)}),define(te[51],ne([0,1,125,8,16,3,24,87,176,177]),function(J,e,L,N,D,A,j,v,h,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$up=e.$tp=e.zip=e.$rp=e.$qp=void 0,e.$qp="end of central directory record signature not found";const E=new RegExp(e.$qp);class R extends Error{constructor(o,t){let n=t.message;switch(o){case"CorruptZip":n=`Corrupt ZIP: ${n}`;break}super(n),this.type=o,this.cause=t}}e.$rp=R;function d(s){const o=s.externalFileAttributes>>16||33188;return[448,56,7].map(t=>o&t).reduce((t,n)=>t+n,o&61440)}function f(s){if(s instanceof R)return s;let o;return E.test(s.message)&&(o="CorruptZip"),new R(o,s)}function S(s,o,t,n,i,r){const l=D.$lc(o),k=D.$ic(n,l);if(!k.startsWith(n))return Promise.reject(new Error(v.localize(0,null,o)));const b=D.$ic(n,o);let p;return r.onCancellationRequested(()=>{p?.destroy()}),Promise.resolve(j.Promises.mkdir(k,{recursive:!0})).then(()=>new Promise((O,B)=>{if(!r.isCancellationRequested)try{p=(0,L.createWriteStream)(b,{mode:t}),p.once("close",()=>O()),p.once("error",B),s.once("error",B),s.pipe(p)}catch(_){B(_)}}))}function y(s,o,t,n){let i=(0,N.$Lg)(()=>Promise.resolve()),r=0;const l=n.onCancellationRequested(()=>{i.cancel(),s.close()});return new Promise((k,b)=>{const p=new N.$Sg,O=B=>{B.isCancellationRequested||(r++,s.readEntry())};s.once("error",b),s.once("close",()=>i.then(()=>{n.isCancellationRequested||s.entryCount===r?k():b(new R("Incomplete",new Error(v.localize(1,null,r,s.entryCount))))},b)),s.readEntry(),s.on("entry",B=>{if(n.isCancellationRequested)return;if(!t.sourcePathRegex.test(B.fileName)){O(n);return}const _=B.fileName.replace(t.sourcePathRegex,"");if(/\/$/.test(_)){const se=D.$ic(o,_);i=(0,N.$Lg)(ue=>j.Promises.mkdir(se,{recursive:!0}).then(()=>O(ue)).then(void 0,b));return}const ee=u(s,B),oe=d(B);i=(0,N.$Lg)(se=>p.queue(()=>ee.then(ue=>S(ue,_,oe,o,t,se).then(()=>O(se)))).then(null,b))})}).finally(()=>l.dispose())}function $(s,o=!1){return new Promise((t,n)=>{(0,h.open)(s,o?{lazyEntries:!0}:void 0,(i,r)=>{i?n(f(i)):t((0,A.$Nf)(r))})})}function u(s,o){return new Promise((t,n)=>{s.openReadStream(o,(i,r)=>{i?n(f(i)):t((0,A.$Nf)(r))})})}function m(s,o){return new Promise((t,n)=>{const i=new c.ZipFile;o.forEach(l=>{l.contents?i.addBuffer(typeof l.contents=="string"?Buffer.from(l.contents,"utf8"):l.contents,l.path):l.localPath&&i.addFile(l.localPath,l.path)}),i.end();const r=(0,L.createWriteStream)(s);i.outputStream.pipe(r),i.outputStream.once("error",n),r.once("error",n),r.once("finish",()=>t(s))})}e.zip=m;function I(s,o,t={},n){const i=new RegExp(t.sourcePath?`^${t.sourcePath}`:"");let r=$(s,!0);return t.overwrite&&(r=r.then(l=>j.Promises.rm(o).then(()=>l))),r.then(l=>y(l,o,{sourcePathRegex:i},n))}e.$tp=I;function w(s,o){return $(s).then(t=>new Promise((n,i)=>{t.on("entry",r=>{r.fileName===o&&u(t,r).then(l=>n(l),l=>i(l))}),t.once("close",()=>i(new Error(v.localize(2,null,o))))}))}function P(s,o){return w(s,o).then(t=>new Promise((n,i)=>{const r=[];t.once("error",i),t.on("data",l=>r.push(l)),t.on("end",()=>n(Buffer.concat(r)))}))}e.$up=P}),define(te[160],ne([0,1,8,9,2,15,17,42,3,28,24,51,25,18,21,27,60,12,6]),function(J,e,L,N,D,A,j,v,h,c,E,R,d,f,S,y,$,u,m){"use strict";var I;Object.defineProperty(e,"__esModule",{value:!0}),e.$Jp=void 0;let w=class extends D.$Rc{static{I=this}static{this.c=".sigzip"}constructor(s,o,t,n,i,r){super(),this.h=o,this.j=t,this.m=n,this.n=i,this.r=r,this.extensionsDownloadDir=s.extensionsDownloadLocation,this.f=20,this.g=this.y()}async download(s,o,t){await this.g;const n=(0,j.$zg)(this.extensionsDownloadDir,this.z(s));try{await this.w(s,n,r=>this.j.download(s,r,o))}catch(r){throw new S.$eo(r.message,S.ExtensionManagementErrorCode.Download)}let i=!1;if(t&&this.t(s)){const r=await this.u(s);try{i=await this.n.verify(n.fsPath,r.fsPath,this.r.getLevel()===m.LogLevel.Trace)}catch(l){const k=l;if(i=k.code,k.output&&this.r.trace(`Extension signature verification details for ${s.identifier.id} ${s.version}:
${k.output}`),i===S.ExtensionSignaturetErrorCode.PackageIsInvalidZip||i===S.ExtensionSignaturetErrorCode.SignatureArchiveIsInvalidZip)throw new S.$eo(R.$qp,S.ExtensionManagementErrorCode.CorruptZip)}finally{try{await this.delete(r)}catch(l){this.r.error(l)}}}return i===!0?this.r.info(`Extension signature is verified: ${s.identifier.id}`):i===!1?this.r.info(`Extension signature verification is not done: ${s.identifier.id}`):this.r.warn(`Extension signature verification failed with error '${i}': ${s.identifier.id}`),{location:n,verificationStatus:i}}t(s){if(!s.isSigned)return!1;const o=this.m.getValue("extensions.verifySignature");return(0,h.$If)(o)?o:!0}async u(s){await this.g;const o=(0,j.$zg)(this.extensionsDownloadDir,`${this.z(s)}${I.c}`);return await this.w(s,o,t=>this.j.downloadSignatureArchive(s,t)),o}async w(s,o,t){if(await this.h.exists(o))return;if(o.scheme!==A.Schemas.file){await t(o);return}const n=(0,j.$zg)(this.extensionsDownloadDir,`.${(0,c.$ig)()}`);await this.h.exists(n)||await t(n);try{await E.Promises.rename(n.fsPath,o.fsPath,2*60*1e3)}catch(i){try{await this.h.del(n)}catch{}if(i.code==="ENOTEMPTY")this.r.info("Rename failed because the file was downloaded by another source. So ignoring renaming.",s.identifier.id,o.path);else throw this.r.info(`Rename failed because of ${(0,N.$9)(i)}. Deleted the file from downloaded location`,n.path),i}}async delete(s){await this.g,await this.h.del(s)}async y(){try{if(!await this.h.exists(this.extensionsDownloadDir)){this.r.trace("Extension VSIX downloads cache dir does not exist");return}const s=await this.h.resolve(this.extensionsDownloadDir,{resolveMetadata:!0});if(s.children){const o=[],t=[],n=[];for(const l of s.children)if(l.name.endsWith(I.c))n.push(l.resource);else{const k=y.$Go.parse(l.name);k&&t.push([k,l])}const i=(0,y.$Lo)(t,([l])=>l),r=[];for(const l of i)l.sort((k,b)=>v.rcompare(k[0].version,b[0].version)),o.push(...l.slice(1).map(k=>k[1].resource)),r.push(l[0][1]);r.sort((l,k)=>l.mtime-k.mtime),o.push(...r.slice(0,Math.max(0,r.length-this.f)).map(l=>l.resource)),o.push(...n),await L.Promises.settled(o.map(l=>(this.r.trace("Deleting from cache",l.path),this.h.del(l))))}}catch(s){this.r.error(s)}}z(s){return this.f?y.$Go.create(s).toString().toLowerCase():(0,c.$ig)()}};e.$Jp=w,e.$Jp=w=I=pe([ie(0,f.$4h),ie(1,u.$ek),ie(2,S.$do),ie(3,d.$pi),ie(4,$.$kp),ie(5,m.$dj)],w)}),define(te[161],ne([0,1,51,97]),function(J,e,L,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lp=void 0;function D(A){return(0,L.$up)(A,"extension/package.json").then(j=>{try{return JSON.parse(j.toString("utf8"))}catch{throw new Error((0,N.localize)(0,null))}})}e.$Lp=D}),define(te[162],ne([0,1,8,14,20,34,9,4,41,2,31,15,16,17,42,3,11,28,24,51,96,59,18,153,21,27,40,50,160,154,161,134,141,48,12,10,6,32,26,22,23]),function(J,e,L,N,D,A,j,v,h,c,E,R,d,f,S,y,$,u,m,I,w,P,s,o,t,n,i,r,l,k,b,p,O,B,_,ee,oe,se,ue,ce,re){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rp=e.$Qp=e.$Pp=e.$Op=void 0,e.$Op=(0,ee.$Wh)(t.$fo);const q=".vsctmp";let Q=class extends o.$vp{constructor(C,F,a,g,z,M,X,W,le,ae,me,de){super(C,F,me,a,ae,de),this.fb=z,this.gb=M,this.hb=X,this.ib=le,this.eb=new Map,this.rb=new E.$Ac;const ge=this.B(W.createInstance(k.$Kp));this.bb=this.B(W.createInstance(T,he=>ge.postUninstall(he))),this.cb=this.B(new p.$Mp(de,le,me,this,this.F)),this.db=this.B(W.createInstance(l.$Jp));const fe=this.B(new O.$Np(this,this.fb,de,M,me,le,a));this.B(fe.onDidChangeExtensionsByAnotherSource(he=>this.qb(he))),this.sb()}getTargetPlatform(){return this.jb||(this.jb=(0,n.$Qo)(this.ib,this.F)),this.jb}async zip(C){this.F.trace("ExtensionManagementService#zip",C.identifier.id);const F=await this.pb(C),a=await(0,I.zip)((0,f.$zg)(this.db.extensionsDownloadDir,(0,u.$ig)()).fsPath,F);return $.URI.file(a)}async unzip(C){return this.F.trace("ExtensionManagementService#unzip",C.toString()),(await this.install(C)).identifier}async getManifest(C){const{location:F,cleanup:a}=await this.lb(C),g=d.$jc(F.fsPath);try{return await(0,b.$Lp)(g)}finally{await a()}}getInstalled(C,F=this.H.defaultProfile.extensionsResource){return this.bb.scanExtensions(C??null,F)}scanAllUserInstalledExtensions(){return this.bb.scanAllUserExtensions(!1)}scanInstalledExtensionAtLocation(C){return this.bb.scanUserExtensionAtLocation(C)}async install(C,F={}){this.F.trace("ExtensionManagementService#install",C.toString());const{location:a,cleanup:g}=await this.lb(C);try{const z=await(0,b.$Lp)(d.$jc(a.fsPath)),M=(0,n.$Ko)(z.publisher,z.name);if(z.engines&&z.engines.vscode&&!(0,B.$Xo)(z.engines.vscode,this.G.version,this.G.date))throw new Error(w.localize(0,null,M,this.G.version));const W=(await this.I([{manifest:z,extension:a,options:F}])).find(({identifier:le})=>(0,n.$Fo)(le,{id:M}));if(W?.local)return W.local;throw W?.error?W.error:(0,o.$xp)(new Error(`Unknown error while installing extension ${M}`))}finally{await g()}}async installFromLocation(C,F){this.F.trace("ExtensionManagementService#installFromLocation",C.toString());const a=await this.bb.scanUserExtensionAtLocation(C);if(!a)throw new Error(`Cannot find a valid extension from the location ${C.toString()}`);return await this.ub([[a,void 0]],F),this.F.info("Successfully installed extension",a.identifier.id,F.toString()),a}async installExtensionsFromProfile(C,F,a){this.F.trace("ExtensionManagementService#installExtensionsFromProfile",C,F.toString(),a.toString());const g=(await this.bb.scanExtensions(1,F)).filter(z=>C.some(M=>(0,n.$Fo)(M,z.identifier)));if(g.length){const z=await Promise.all(g.map(M=>this.bb.scanMetadata(M,F)));await this.ub(g.map((M,X)=>[M,z[X]]),a),this.F.info("Successfully installed extensions",g.map(M=>M.identifier.id),a.toString())}return g}async updateMetadata(C,F,a=this.H.defaultProfile.extensionsResource){return this.F.trace("ExtensionManagementService#updateMetadata",C.identifier.id),F.isPreReleaseVersion&&(F.preRelease=!0),F.isMachineScoped===!1&&(F.isMachineScoped=void 0),F.isBuiltin===!1&&(F.isBuiltin=void 0),F.pinned===!1&&(F.pinned=void 0),C=await this.bb.updateMetadata(C,F,a),this.cb.invalidate(a),this.w.fire(C),C}async reinstallFromGallery(C){if(this.F.trace("ExtensionManagementService#reinstallFromGallery",C.identifier.id),!this.z.isEnabled())throw new Error(w.localize(1,null));const F=await this.getTargetPlatform(),[a]=await this.z.getExtensions([{...C.identifier,preRelease:C.preRelease}],{targetPlatform:F,compatible:!0},D.CancellationToken.None);if(!a)throw new Error(w.localize(2,null));await this.bb.setUninstalled(C);try{await this.bb.removeUninstalledExtension(C)}catch(g){throw new Error(w.localize(3,null,(0,A.$Gi)(g)))}return this.installFromGallery(a)}ab(C,F,a,g){return this.bb.copyExtension(C,F,a,g)}copyExtensions(C,F){return this.bb.copyExtensions(C,F)}markAsUninstalled(...C){return this.bb.setUninstalled(...C)}async cleanUp(){this.F.trace("ExtensionManagementService#cleanUp");try{await this.bb.cleanUp()}catch(C){this.F.error(C)}}async download(C,F,a){const{location:g}=await this.db.download(C,F,!a);return g}async lb(C){if(C.scheme===R.Schemas.file)return{location:C,async cleanup(){}};this.F.trace("Downloading extension from",C.toString());const F=(0,f.$zg)(this.db.extensionsDownloadDir,(0,u.$ig)());return await this.hb.download(C,F),this.F.info("Downloaded extension to",F.toString()),{location:F,cleanup:async()=>{try{await this.ib.del(F)}catch(g){this.F.error(g)}}}}Y(){return this.H.defaultProfile.extensionsResource}Z(C,F,a){if($.URI.isUri(F))return new G(C,F,a,this.z,this.bb,this.D,this.H,this.fb,this.gb,this.F);const g=n.$Go.create(F).toString();let z=this.eb.get(g);return z||(this.eb.set(g,z=new H(C,F,a,this.db,this.bb,this.D,this.H,this.fb,this.gb,this.F)),z.waitUntilTaskIsFinished().finally(()=>this.eb.delete(g))),z}$(C,F){return new Z(C,F.profileLocation,this.gb)}async pb(C){const F=async g=>{let z=await m.Promises.readdir(g);z=z.map(W=>d.$ic(g,W));const M=await Promise.all(z.map(W=>m.Promises.stat(W)));let X=Promise.resolve([]);return M.forEach((W,le)=>{const ae=z[le];W.isFile()&&(X=X.then(me=>[...me,ae])),W.isDirectory()&&(X=X.then(me=>F(ae).then(de=>[...me,...de])))}),X};return(await F(C.location.fsPath)).map(g=>({path:`extension/${d.$kc(C.location.fsPath,g)}`,localPath:g}))}async qb({added:C,removed:F}){if(F){const a=C&&this.D.extUri.isEqual(F.profileLocation,C.profileLocation)?F.extensions.filter(g=>C.extensions.every(z=>!(0,n.$Fo)(z,g))):F.extensions;for(const g of a)this.F.info("Extensions removed from another source",g.id,F.profileLocation.toString()),this.u.fire({identifier:g,profileLocation:F.profileLocation})}if(C){const g=(await this.bb.scanExtensions(1,C.profileLocation)).filter(z=>C.extensions.some(M=>(0,n.$Fo)(M,z.identifier)));this.s.fire(g.map(z=>(this.F.info("Extensions added from another source",z.identifier.id,C.profileLocation.toString()),{identifier:z.identifier,local:z,profileLocation:C.profileLocation,operation:1})))}}async sb(){this.B(this.bb.onExtract(F=>this.rb.add(F)));const C=await this.ib.resolve(this.fb.userExtensionsLocation);for(const F of C.children??[])F.isDirectory&&this.rb.add(F.resource);this.B(this.ib.watch(this.fb.userExtensionsLocation)),this.B(this.ib.onDidFilesChange(F=>this.tb(F)))}async tb(C){if(!C.affects(this.fb.userExtensionsLocation,1))return;const F=[];for(const a of C.rawAdded){if(this.rb.has(a)||!this.D.extUri.isEqual(this.D.extUri.dirname(a),this.fb.userExtensionsLocation)||this.D.extUri.isEqual(a,this.D.extUri.joinPath(this.fb.userExtensionsLocation,".obsolete"))||this.D.extUri.basename(a).startsWith(".")||!(await this.ib.stat(a)).isDirectory)continue;const g=await this.bb.scanUserExtensionAtLocation(a);g&&g.installedTimestamp===void 0&&(this.rb.add(a),F.push(g))}F.length&&(await this.ub(F.map(a=>[a,void 0]),this.H.defaultProfile.extensionsResource),this.F.info("Added extensions to default profile from external source",F.map(a=>a.identifier.id)))}async ub(C,F){const a=C.map(g=>g[0]);await this.vb(a),await this.gb.addExtensionsToProfile(C,F),this.s.fire(a.map(g=>({local:g,identifier:g.identifier,operation:1,profileLocation:F})))}async vb(C){const F=await this.bb.getUninstalledExtensions();for(const a of C){const g=n.$Go.create(a);F[g.toString()]&&(this.F.trace("Removing the extension from uninstalled list:",g.id),await this.bb.setInstalled(g),this.F.info("Removed the extension from uninstalled list:",g.id))}}};e.$Pp=Q,e.$Pp=Q=pe([ie(0,t.$do),ie(1,ue.$il),ie(2,oe.$dj),ie(3,s.$4h),ie(4,r.$Ep),ie(5,i.$Ap),ie(6,P.$Un),ie(7,ee.$Uh),ie(8,_.$ek),ie(9,se.$vj),ie(10,ce.$Ok),ie(11,re.$Qk)],Q);let T=class extends c.$Rc{constructor(C,F,a,g,z,M){super(),this.j=C,this.m=F,this.n=a,this.s=g,this.t=z,this.u=M,this.h=this.B(new v.$Rd),this.onExtract=this.h.event,this.c=(0,f.$zg)(this.n.userExtensionsLocation,".obsolete"),this.g=new L.$5g}async cleanUp(){await this.H(),await this.G()}async scanExtensions(C,F){const a={includeInvalid:!0,profileLocation:F};let g=[];return C===null||C===0?g.push(...await this.n.scanAllExtensions({includeInvalid:!0},a,!1)):C===1&&g.push(...await this.n.scanUserExtensions(a)),g=C!==null?g.filter(z=>z.type===C):g,Promise.all(g.map(z=>this.F(z)))}async scanAllUserExtensions(C){const F=await this.n.scanUserExtensions({includeAllVersions:!C,includeInvalid:!0});return Promise.all(F.map(a=>this.F(a)))}async scanUserExtensionAtLocation(C){try{const F=await this.n.scanExistingExtension(C,1,{includeInvalid:!0});if(F)return await this.F(F)}catch(F){this.u.error(F)}return null}async extractUserExtension(C,F,a,g,z){const M=C.toString(),X=$.URI.file(d.$ic(this.n.userExtensionsLocation.fsPath,`.${(0,u.$ig)()}`)),W=$.URI.file(d.$ic(this.n.userExtensionsLocation.fsPath,M));let le=await this.m.exists(W);if(le&&g){try{await this.y(C.id,W,"removeExisting")}catch{throw new t.$eo(w.localize(4,null,W.fsPath,C.id),t.ExtensionManagementErrorCode.Delete)}le=!1}if(!le)try{try{this.u.trace(`Started extracting the extension from ${F} to ${W.fsPath}`),await(0,I.$tp)(F,X.fsPath,{sourcePath:"extension",overwrite:!0},z),this.u.info(`Extracted extension to ${W}:`,C.id)}catch(ae){let me=t.ExtensionManagementErrorCode.Extract;throw ae instanceof I.$rp&&(ae.type==="CorruptZip"?me=t.ExtensionManagementErrorCode.CorruptZip:ae.type==="Incomplete"&&(me=t.ExtensionManagementErrorCode.IncompleteZip)),new t.$eo(ae.message,me)}await this.n.updateMetadata(X,a);try{this.u.trace(`Started renaming the extension from ${X.fsPath} to ${W.fsPath}`),await this.C(X.fsPath,W.fsPath),this.u.info("Renamed to",W.fsPath)}catch(ae){if(ae.code==="ENOTEMPTY")this.u.info("Rename failed because extension was installed by another source. So ignoring renaming.",C.id);else throw this.u.info(`Rename failed because of ${(0,j.$9)(ae)}. Deleted from extracted location`,X),ae}this.h.fire(W)}catch(ae){try{await this.m.del(X,{recursive:!0})}catch{}throw ae}return this.D(W,1)}async scanMetadata(C,F){return F?(await this.w(C,F))?.metadata:this.n.scanMetadata(C.location)}async w(C,F){return(await this.s.scanProfileExtensions(F)).find(g=>(0,n.$Fo)(g.identifier,C.identifier))}async updateMetadata(C,F,a){return a?await this.s.updateMetadata([[C,F]],a):await this.n.updateMetadata(C.location,F),this.D(C.location,C.type,a)}getUninstalledExtensions(){return this.z()}async setUninstalled(...C){const F=C.map(a=>n.$Go.create(a));await this.z(a=>F.forEach(g=>{a[g.toString()]=!0,this.u.info("Marked extension as uninstalled",g.toString())}))}async setInstalled(C){await this.z(F=>delete F[C.toString()])}async removeExtension(C,F){if(this.t.extUri.isEqualOrParent(C.location,this.n.userExtensionsLocation))return this.y(C.identifier.id,C.location,F)}async removeUninstalledExtension(C){await this.removeExtension(C,"uninstalled"),await this.z(F=>delete F[n.$Go.create(C).toString()])}async copyExtension(C,F,a,g){const z=await this.w(C,F),M=await this.w(C,a);return g={...z?.metadata,...g},M?await this.s.updateMetadata([[C,{...M.metadata,...g}]],a):await this.s.addExtensionsToProfile([[C,g]],a),this.D(C.location,C.type,a)}async copyExtensions(C,F){const a=await this.scanExtensions(1,C),g=await Promise.all(a.filter(z=>!z.isApplicationScoped).map(async z=>[z,await this.scanMetadata(z,C)]));await this.s.addExtensionsToProfile(g,F)}async y(C,F,a){this.u.trace(`Deleting ${a} extension from disk`,C,F.fsPath);const g=this.t.extUri.joinPath(this.t.extUri.dirname(F),`${this.t.extUri.basename(F)}.${(0,h.$Ji)((0,u.$ig)()).toString(16)}${q}`);await this.C(F.fsPath,g.fsPath),await this.m.del(g,{recursive:!0}),this.u.info(`Deleted ${a} extension from disk`,C,F.fsPath)}async z(C){return this.g.queue(async()=>{let F;try{F=(await this.m.readFile(this.c,"utf8")).value.toString()}catch(g){if((0,_.$vk)(g)!==1)throw g}let a={};if(F)try{a=JSON.parse(F)}catch{}return C&&(C(a),Object.keys(a).length?await this.m.writeFile(this.c,N.$fe.fromString(JSON.stringify(a))):await this.m.del(this.c)),a})}async C(C,F){try{await m.Promises.rename(C,F,2*60*1e3)}catch(a){throw new t.$eo(a.message||w.localize(5,null,C,F),a.code||t.ExtensionManagementErrorCode.Rename)}}async D(C,F,a){if(a){const z=(await this.n.scanUserExtensions({profileLocation:a})).find(M=>this.t.extUri.isEqual(M.location,C));if(z)return this.F(z)}else{const g=await this.n.scanExistingExtension(C,F,{includeInvalid:!0});if(g)return this.F(g)}throw new Error(w.localize(6,null,C.path))}async F(C){const F=await this.m.resolve(C.location);let a,g;return F.children&&(a=F.children.find(({name:z})=>/^readme(\.txt|\.md|)$/i.test(z))?.resource,g=F.children.find(({name:z})=>/^changelog(\.txt|\.md|)$/i.test(z))?.resource),{identifier:C.identifier,type:C.type,isBuiltin:C.isBuiltin||!!C.metadata?.isBuiltin,location:C.location,manifest:C.manifest,targetPlatform:C.targetPlatform,validations:C.validations,isValid:C.isValid,readmeUrl:a,changelogUrl:g,publisherDisplayName:C.metadata?.publisherDisplayName||null,publisherId:C.metadata?.publisherId||null,isApplicationScoped:!!C.metadata?.isApplicationScoped,isMachineScoped:!!C.metadata?.isMachineScoped,isPreReleaseVersion:!!C.metadata?.isPreReleaseVersion,preRelease:!!C.metadata?.preRelease,installedTimestamp:C.metadata?.installedTimestamp,updated:!!C.metadata?.updated,pinned:!!C.metadata?.pinned}}async G(){const C=await this.getUninstalledExtensions();if(Object.keys(C).length===0){this.u.debug("No uninstalled extensions found.");return}this.u.debug("Removing uninstalled extensions:",Object.keys(C));const F=await this.n.scanUserExtensions({includeAllVersions:!0,includeUninstalled:!0,includeInvalid:!0}),a=new Set;for(const z of F)C[n.$Go.create(z).toString()]||a.add(z.identifier.id.toLowerCase());try{const z=(0,n.$Lo)(F,M=>M.identifier);await L.Promises.settled(z.map(async M=>{const X=M.sort((W,le)=>S.rcompare(W.manifest.version,le.manifest.version))[0];a.has(X.identifier.id.toLowerCase())||await this.j(await this.F(X))}))}catch(z){this.u.error(z)}const g=F.filter(z=>z.metadata&&C[n.$Go.create(z).toString()]);await Promise.allSettled(g.map(z=>this.removeUninstalledExtension(z)))}async H(){this.u.trace("ExtensionManagementService#removeTempDeleteFolders");let C;try{C=await this.m.resolve(this.n.userExtensionsLocation)}catch(F){(0,_.$vk)(F)!==1&&this.u.error(F);return}if(C?.children)try{await Promise.allSettled(C.children.map(async F=>{if(!(!F.isDirectory||!F.name.endsWith(q))){this.u.trace("Deleting the temporarily deleted folder",F.resource.toString());try{await this.m.del(F.resource,{recursive:!0}),this.u.trace("Deleted the temporarily deleted folder",F.resource.toString())}catch(a){(0,_.$vk)(a)!==1&&this.u.error(a)}}}))}catch{}}};e.$Qp=T,e.$Qp=T=pe([ie(1,_.$ek),ie(2,r.$Ep),ie(3,i.$Ap),ie(4,ce.$Ok),ie(5,oe.$dj)],T);class U extends o.$yp{get profileLocation(){return this.j}get verificationStatus(){return this.k}get operation(){return(0,y.$Jf)(this.options.operation)?this.l:this.options.operation}constructor(C,F,a,g,z,M,X,W,le){super(),this.identifier=C,this.source=F,this.options=a,this.m=g,this.n=z,this.o=M,this.p=X,this.q=W,this.s=le,this.j=this.options.profileLocation,this.k=!1,this.l=2}async h(C){const[F,a]=await this.x(C);return this.j=F.isBuiltin||F.isApplicationScoped?this.o.defaultProfile.extensionsResource:this.options.profileLocation,this.n.extUri.isEqual(this.o.defaultProfile.extensionsResource,this.j)&&await this.p.initializeDefaultProfileExtensions(),await this.q.addExtensionsToProfile([[F,a]],this.j),F}async u({zipPath:C,key:F,metadata:a},g,z){let M=await this.v(F);return M||(this.s.trace("Extracting extension...",F.id),M=await this.m.extractUserExtension(F,C,a,g,z),this.s.info("Extracting extension completed.",F.id)),M}async v(C){return await this.w(C)?(this.s.trace("Removing the extension from uninstalled list:",C.id),await this.m.setInstalled(C),this.s.info("Removed the extension from uninstalled list:",C.id),(await this.m.scanAllUserExtensions(!0)).find(g=>n.$Go.create(g).equals(C))):void 0}async w(C){return!!(await this.m.getUninstalledExtensions())[C.toString()]}}class H extends U{constructor(C,F,a,g,z,M,X,W,le,ae){super(F.identifier,F,a,z,M,X,W,le,ae),this.y=F,this.z=g}async x(C){const a=(await this.m.scanExtensions(null,this.options.profileLocation)).find(X=>(0,n.$Fo)(X.identifier,this.y.identifier));a&&(this.l=3);const g={id:this.y.identifier.uuid,publisherId:this.y.publisherId,publisherDisplayName:this.y.publisherDisplayName,targetPlatform:this.y.properties.targetPlatform,isApplicationScoped:this.options.isApplicationScoped||a?.isApplicationScoped,isMachineScoped:this.options.isMachineScoped||a?.isMachineScoped,isBuiltin:this.options.isBuiltin||a?.isBuiltin,isSystem:a?.type===0?!0:void 0,updated:!!a,isPreReleaseVersion:this.y.properties.isPreReleaseVersion,installedTimestamp:Date.now(),pinned:this.options.installGivenVersion?!0:void 0,preRelease:this.y.properties.isPreReleaseVersion||((0,y.$If)(this.options.installPreReleaseVersion)?this.options.installPreReleaseVersion:a?.preRelease)};if(a?.manifest.version===this.y.version)return[await this.m.updateMetadata(a,g),g];const{location:z,verificationStatus:M}=await this.z.download(this.y,this.l,!this.options.donotVerifySignature);try{return this.k=M,this.B(z.fsPath),[await this.u({zipPath:z.fsPath,key:n.$Go.create(this.y),metadata:g},!1,C),g]}catch(X){try{await this.z.delete(z)}catch(W){this.s.warn("Error while deleting the downloaded file",z.toString(),(0,j.$9)(W))}throw X}}async B(C){try{await(0,b.$Lp)(C)}catch(F){throw new t.$eo((0,o.$wp)(F).message,t.ExtensionManagementErrorCode.Invalid)}}}e.$Rp=H;class G extends U{constructor(C,F,a,g,z,M,X,W,le,ae){super({id:(0,n.$Ko)(C.publisher,C.name)},F,a,z,M,X,W,le,ae),this.y=C,this.z=F,this.A=g}async h(C){const F=await super.h(C);return this.D(F,C),F}async x(C){const F=new n.$Go(this.identifier,this.y.version),g=(await this.m.scanExtensions(1,this.options.profileLocation)).find(X=>(0,n.$Fo)(this.identifier,X.identifier)),z={isApplicationScoped:this.options.isApplicationScoped||g?.isApplicationScoped,isMachineScoped:this.options.isMachineScoped||g?.isMachineScoped,isBuiltin:this.options.isBuiltin||g?.isBuiltin,installedTimestamp:Date.now(),pinned:this.options.installGivenVersion?!0:void 0};if(g)if(this.l=3,F.equals(new n.$Go(g.identifier,g.manifest.version)))try{await this.m.removeExtension(g,"existing")}catch{throw new Error(w.localize(7,null,this.y.displayName||this.y.name))}else!this.options.profileLocation&&S.gt(g.manifest.version,this.y.version)&&await this.m.setUninstalled(g);else{const X=await this.v(F);if(X)try{await this.m.removeExtension(X,"existing")}catch{throw new Error(w.localize(8,null,this.y.displayName||this.y.name))}}return[await this.u({zipPath:d.$jc(this.z.fsPath),key:F,metadata:z},!0,C),z]}async D(C,F){try{let[a]=await this.A.getExtensions([{id:C.identifier.id,version:C.manifest.version}],F);if(a||([a]=await this.A.getExtensions([{id:C.identifier.id}],F)),a){const g={id:a.identifier.uuid,publisherDisplayName:a.publisherDisplayName,publisherId:a.publisherId,isPreReleaseVersion:a.properties.isPreReleaseVersion,preRelease:a.properties.isPreReleaseVersion||this.options.installPreReleaseVersion};await this.m.updateMetadata(C,g,this.options.profileLocation)}}catch{}}}class Z extends o.$yp{constructor(C,F,a){super(),this.extension=C,this.j=F,this.k=a}async h(C){await this.k.removeExtensionFromProfile(this.extension,this.j)}}}),define(te[163],ne([0,1,137,8,14,9,3,25,18,138,6,44,136,178,179]),function(J,e,L,N,D,A,j,v,h,c,E,R,d,f,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6q=e.$5q=void 0;let y=class extends R.$Zo{constructor(I,w,P,s){super(s),this.m=I,this.n=w,this.r=P,this.s(),this.B(I.onDidChangeConfiguration(o=>{o.affectsConfiguration("http")&&this.s()}))}s(){const I=this.m.getValue("http");this.f=I?.proxy,this.g=!!I?.proxyStrictSSL,this.h=I?.proxyAuthorization}async request(I,w){const{f:P,g:s}=this;let o;try{o=await(0,c.$Zl)(this.m,this.r,this.n.args,process.env)}catch(i){this.j||(this.j=!0,this.r.error("resolving shell environment failed",(0,A.$9)(i)))}const t={...process.env,...o},n=I.agent?I.agent:await(0,d.$4q)(I.url||"",t,{proxyUrl:P,strictSSL:s});return I.agent=n,I.strictSSL=s,this.h&&(I.headers={...I.headers||{},"Proxy-Authorization":this.h}),this.c(I.isChromiumNetwork?"electron":"node",I,()=>u(I,w))}async resolveProxy(I){}async loadCertificates(){return(0,S.loadSystemCertificates)({log:this.r})}};e.$5q=y,e.$5q=y=pe([ie(0,v.$pi),ie(1,h.$4h),ie(2,E.$dj),ie(3,E.$ej)],y);async function $(m){return((0,L.parse)(m.url).protocol==="https:"?await new Promise((P,s)=>{J(["https"],P,s)}):await new Promise((P,s)=>{J(["http"],P,s)})).request}async function u(m,I){return N.Promises.withAsyncBody(async(w,P)=>{const s=(0,L.parse)(m.url),o=m.getRawRequest?m.getRawRequest(m):await $(m),t={hostname:s.hostname,port:s.port?parseInt(s.port):s.protocol==="https:"?443:80,protocol:s.protocol,path:s.path,method:m.type||"GET",headers:m.headers,agent:m.agent,rejectUnauthorized:(0,j.$If)(m.strictSSL)?m.strictSSL:!0};m.user&&m.password&&(t.auth=m.user+":"+m.password);const n=o(t,i=>{const r=(0,j.$Gf)(m.followRedirects)?m.followRedirects:3;if(i.statusCode&&i.statusCode>=300&&i.statusCode<400&&r>0&&i.headers.location)u({...m,url:i.headers.location,followRedirects:r-1},I).then(w,P);else{let l=i;!m.isChromiumNetwork&&i.headers["content-encoding"]==="gzip"&&(l=i.pipe((0,f.createGunzip)())),w({res:i,stream:(0,D.$ue)(l)})}});n.on("error",P),m.timeout&&n.setTimeout(m.timeout),m.isChromiumNetwork&&n.removeHeader("Content-Length"),m.data&&typeof m.data=="string"&&n.write(m.data),n.end(),I.onCancellationRequested(()=>{n.abort(),P(new A.$4)})})}e.$6q=u}),define(te[180],ne([0,1,33,8,34,9,2,15,16,13,35,11,24,25,133,59,135,18,111,158,21,60,140,40,50,162,156,12,122,124,49,120,63,64,143,6,129,38,130,146,32,44,163,68,69,26,145,39,147,148,22,150,23,159,149,155,126,128,5,151]),function(J,e,L,N,D,A,j,v,h,c,E,R,d,f,S,y,$,u,m,I,w,P,s,o,t,n,i,r,l,k,b,p,O,B,_,ee,oe,se,ue,ce,re,q,Q,T,U,H,G,Z,Y,C,F,a,g,z,M,X,W,le,ae,me){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.main=void 0;class de extends j.$Rc{constructor(he){super(),this.b=he,this.c()}c(){process.once("exit",()=>this.dispose())}async run(){const[he,we]=await this.f();return he.invokeFunction(async be=>{const ke=be.get(ee.$dj),Ce=be.get(r.$ek),V=be.get(u.$4h),K=be.get(g.$Qk);ke.info("CLI main",this.b),this.g(ke),await this.h(V,Ce,K,he),await Promise.all(we.map(x=>{(0,N.$Pg)(x.flush(),1e3)}))})}async f(){const he=new O.$Th,we={_serviceBrand:void 0,...ce.default};he.set(re.$vj,we);const be=new m.$pm(this.b,we);he.set(u.$4h,be),await Promise.all([be.appSettingsHome.with({scheme:v.Schemas.file}).fsPath,be.extensionsPath].map(Ae=>Ae?d.Promises.mkdir(Ae,{recursive:!0}):void 0));const ke=new le.$MN((0,ee.$rj)(be),be.logsHome);he.set(ee.$ej,ke);const Ce=this.B(ke.createLogger("cli",{name:(0,ae.localize)(0,null)})),V=[];ke.getLogLevel()===ee.LogLevel.Trace&&V.push(new ee.$lj(ke.getLogLevel()));const K=this.B(new W.$WN(Ce,V));he.set(ee.$dj,K);const x=this.B(new l.$Tp(K));he.set(r.$ek,x);const $e=this.B(new k.$gq(K));x.registerProvider(v.Schemas.file,$e);const ye=new a.$Fr(x);he.set(F.$Ok,ye);const De=new T.$QN(1,be,K,x),Se=new z.$SN(De,ye,be,x,K);he.set(g.$Qk,Se),x.registerProvider(v.Schemas.vscodeUserData,new me.$S9b(v.Schemas.file,$e,v.Schemas.vscodeUserData,Se,ye,K));const Le=c.$i&&we.win32RegValueName?this.B(new ue.$Q9b(K,we.win32RegValueName)):be.policyFile?this.B(new oe.$R9b(be.policyFile,x,K)):new se.$qn;he.set(se.$on,Le);const Ie=this.B(new S.$Qn(Se.defaultProfile.settingsResource,x,Le,K));he.set(f.$pi,Ie),await Promise.all([De.init(),Ie.initialize()]);let je;try{je=await(0,M.$u9b)(De,K)}catch(Ae){Ae.code!=="ENOENT"&&K.error(Ae)}const Ue=await(0,M.$v9b)(De,K);Se.init(),he.set(F.$Ok,new a.$Fr(x));const Re=new Q.$5q(Ie,be,K,ke);he.set(q.$Yo,Re),he.set(y.$Un,new b.$Sh($.$_N,void 0,!0)),he.set(o.$Ap,new b.$Sh(X.$VN,void 0,!0)),he.set(t.$Ep,new b.$Sh(i.$r9b,void 0,!0)),he.set(P.$kp,new b.$Sh(P.$lp,void 0,!0)),he.set(n.$Op,new b.$Sh(n.$Pp,void 0,!0)),he.set(w.$do,new b.$Sh(I.$jp,void 0,!0)),he.set(B.$Yq,new b.$Sh(_.$1q,void 0,!1));const Ne=[],ze=(0,Z.$Co)(we,Ie);if((0,Z.$xo)(we,be)){we.aiConfig&&we.aiConfig.ariaKey&&Ne.push(new Y.$KN(Re,ze,"monacoworkbench",null,we.aiConfig.ariaKey));const Ae={appenders:Ne,sendErrorTelemetry:!1,commonProperties:(0,U.$no)((0,L.release)(),(0,L.hostname)(),process.arch,we.commit,we.version,je,Ue,ze),piiPaths:(0,Z.$Do)(be)};he.set(H.$il,new b.$Sh(G.$7q,[Ae],!1))}else he.set(H.$il,Z.$ro);return[new p.$jq(he),Ne]}g(he){(0,A.setUnexpectedErrorHandler)(we=>{const be=(0,D.$Gi)(we,!0);be&&he.error(`[uncaught exception in CLI]: ${be}`)}),process.on("uncaughtException",we=>{(0,A.$Y)(we)||(0,A.$Z)(we)}),process.on("unhandledRejection",we=>(0,A.$Z)(we))}async h(he,we,be,ke){let Ce;if(he.args.profile&&(Ce=be.profiles.find(K=>K.name===he.args.profile),!Ce))throw new Error(`Profile '${he.args.profile}' not found.`);const V=(Ce??be.defaultProfile).extensionsResource;if(this.b["list-extensions"])return ke.createInstance(s.$mp,new ee.$lj(ee.LogLevel.Info,!1)).listExtensions(!!this.b["show-versions"],this.b.category,V);if(this.b["install-extension"]||this.b["install-builtin-extension"]){const K={isMachineScoped:!!this.b["do-not-sync"],installPreReleaseVersion:!!this.b["pre-release"],profileLocation:V};return ke.createInstance(s.$mp,new ee.$lj(ee.LogLevel.Info,!1)).installExtensions(this.j(this.b["install-extension"]||[]),this.j(this.b["install-builtin-extension"]||[]),K,!!this.b.force)}else{if(this.b["uninstall-extension"])return ke.createInstance(s.$mp,new ee.$lj(ee.LogLevel.Info,!1)).uninstallExtensions(this.j(this.b["uninstall-extension"]),!!this.b.force,V);if(this.b["locate-extension"])return ke.createInstance(s.$mp,new ee.$lj(ee.LogLevel.Info,!1)).locateExtension(this.b["locate-extension"]);this.b.telemetry&&console.log(await(0,C.$c0b)(he.appRoot,he.extensionsPath))}}j(he){return he.map(we=>/\.vsix$/i.test(we)?R.URI.file((0,h.$hc)(we)?we:(0,h.$ic)((0,E.cwd)(),we)):we)}}async function ge(fe){const he=new de(fe);try{await he.run()}finally{he.dispose()}}e.main=ge})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/94959e85502687ec77e23eb0d4d4b1a827b919af/core/vs/code/node/cliProcessMain.js.map
