/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var ae=["require","exports","vs/base/common/lifecycle","vs/base/common/event","vs/platform/instantiation/common/instantiation","vs/base/common/platform","vs/base/common/async","vs/base/common/errors","vs/platform/log/common/log","vs/nls!vs/code/node/sharedProcess/sharedProcessMain","vs/base/common/uri","vs/platform/files/common/files","vs/base/common/types","vs/nls","vs/platform/environment/common/environment","vs/base/common/buffer","vs/base/common/path","vs/platform/userDataProfile/common/userDataProfile","vs/base/common/arrays","vs/base/common/resources","vs/platform/configuration/common/configuration","vs/platform/storage/common/storage","vs/platform/telemetry/common/telemetry","vs/base/common/network","vs/platform/userDataSync/common/userDataSync","vs/platform/product/common/productService","vs/base/common/cancellation","vs/base/common/strings","vs/platform/uriIdentity/common/uriIdentity","vs/platform/extensionManagement/common/extensionManagement","vs/base/common/objects","vs/base/node/pfs","vs/base/common/uuid","vs/platform/extensionManagement/common/extensionManagementUtil","vs/base/common/map","vs/base/common/json","os","vs/base/common/process","vs/base/common/errorMessage","vs/platform/userDataSync/common/abstractSynchronizer","vs/base/parts/ipc/common/ipc","vs/platform/registry/common/platform","vs/base/common/jsonFormatter","vs/platform/externalServices/common/serviceMachineId","vs/platform/extensions/common/extensions","vs/platform/telemetry/common/telemetryUtils","vs/base/common/stream","vs/base/common/ternarySearchTree","vs/base/common/extpath","vs/platform/files/common/watcher","vs/platform/configuration/common/configurationRegistry","vs/platform/extensionManagement/common/extensionsProfileScannerService","vs/base/common/hash","fs","vs/base/common/semver/semver","vs/platform/ipc/common/mainProcessService","vs/platform/native/common/native","vs/platform/policy/common/policy","vs/platform/request/common/request","vs/platform/userDataProfile/common/userDataProfileStorageService","vs/base/common/iterator","vs/base/common/lazy","vs/base/common/stopwatch","net","vs/base/common/date","vs/base/common/marshalling","child_process","vs/base/parts/ipc/common/ipc.net","vs/base/parts/storage/common/storage","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/descriptors","crypto","vs/platform/instantiation/common/serviceCollection","vs/platform/languagePacks/common/languagePacks","vs/platform/configuration/common/configurationModels","vs/platform/remote/common/remoteHosts","vs/platform/storage/common/storageIpc","vs/platform/tunnel/common/tunnel","vs/platform/userDataSync/common/content","vs/platform/userDataSync/common/userDataSyncAccount","vs/platform/extensionManagement/common/extensionsScannerService","vs/platform/extensionManagement/common/extensionStorage","vs/platform/userDataSync/common/userDataSyncMachines","vs/base/node/zip","vs/base/common/decorators","vs/base/common/functional","vs/base/common/jsonEdit","vs/base/common/linkedList","vs/base/common/normalization","vs/base/common/severity","vs/base/common/processes","vs/base/common/glob","vs/base/common/uriIpc","vs/base/parts/ipc/node/ipc.cp","vs/platform/contextkey/common/contextkey","vs/platform/diagnostics/common/diagnostics","vs/platform/download/common/download","vs/platform/extensionManagement/node/extensionSignatureVerificationService","vs/platform/extensionRecommendations/common/extensionRecommendations","vs/platform/files/common/io","vs/base/common/performance","vs/platform/lifecycle/node/sharedProcessLifecycleService","vs/platform/product/common/product","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/remote/common/remoteSocketFactoryService","vs/platform/remoteTunnel/common/remoteTunnel","vs/platform/sign/common/sign","vs/platform/telemetry/common/commonProperties","vs/platform/telemetry/common/telemetryIpc","vs/platform/telemetry/common/telemetryLogAppender","vs/platform/telemetry/common/telemetryService","vs/platform/userDataSync/common/ignoredExtensions","vs/platform/workspace/common/workspace","vs/platform/extensionManagement/common/extensionEnablementService","vs/platform/userDataSync/common/extensionsSync","vs/platform/userDataSync/common/globalStateSync","vs/platform/userDataSync/common/keybindingsSync","vs/platform/userDataSync/common/settingsSync","vs/platform/userDataSync/common/snippetsSync","vs/platform/userDataSync/common/tasksSync","vs/platform/userDataSync/common/userDataProfilesManifestSync","vs/platform/extensionManagement/node/extensionManagementService","vs/base/parts/ipc/node/ipc.net","vs/base/common/amd","vs/base/common/arraysFind","vs/base/common/collections","vs/base/common/assert","vs/base/common/skipList","vs/base/common/cache","vs/base/common/symbols","vs/base/node/macAddress","vs/base/node/nodeStreams","vs/base/node/ports","vs/base/parts/sandbox/node/electronTypes","vs/nls!vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/common/jsonErrorMessages","vs/base/common/jsonErrorMessages","vs/nls!vs/base/common/platform","vs/base/common/mime","vs/base/common/console","vs/amdX","vs/base/node/id","vs/base/node/extpath","vs/base/node/processes","vs/base/node/ps","vs/base/parts/ipc/node/ipc.mp","vs/nls!vs/base/node/zip","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/contextkey/common/contextkey","vs/nls!vs/platform/contextkey/common/scanner","vs/nls!vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensionManagement/common/extensionNls","vs/nls!vs/platform/extensionManagement/common/extensionsScannerService","vs/nls!vs/platform/extensionManagement/node/extensionManagementService","vs/nls!vs/platform/extensionManagement/node/extensionManagementUtil","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/fileService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/languagePacks/common/languagePacks","vs/nls!vs/platform/remoteTunnel/common/remoteTunnel","vs/nls!vs/platform/remoteTunnel/node/remoteTunnelService","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/telemetry/common/telemetryLogAppender","vs/nls!vs/platform/telemetry/common/telemetryService","vs/nls!vs/platform/userDataProfile/common/userDataProfile","vs/nls!vs/platform/userDataSync/common/abstractSynchronizer","vs/nls!vs/platform/userDataSync/common/keybindingsSync","vs/nls!vs/platform/userDataSync/common/settingsSync","vs/nls!vs/platform/userDataSync/common/userDataAutoSyncService","vs/nls!vs/platform/userDataSync/common/userDataSync","vs/nls!vs/platform/userDataSync/common/userDataSyncLog","vs/nls!vs/platform/userDataSync/common/userDataSyncMachines","vs/nls!vs/platform/userDataSync/common/userDataSyncResourceProvider","vs/nls!vs/platform/workspace/common/workspace","vs/platform/contextkey/common/scanner","vs/platform/environment/common/environmentService","vs/platform/environment/node/userDataPath","vs/platform/environment/node/environmentService","vs/platform/extensionManagement/common/extensionNls","vs/platform/extensionRecommendations/common/extensionRecommendationsIpc","vs/platform/instantiation/common/extensions","vs/platform/instantiation/common/graph","vs/platform/checksum/common/checksumService","vs/platform/extensionManagement/common/extensionManagementIpc","vs/platform/checksum/node/checksumService","vs/platform/files/common/diskFileSystemProviderClient","vs/platform/files/node/watcher/nodejs/nodejsWatcherLib","vs/platform/files/node/watcher/nodejs/nodejsWatcher","vs/platform/files/node/watcher/nodejs/nodejsClient","vs/platform/files/node/watcher/watcherClient","vs/platform/instantiation/common/instantiationService","vs/code/node/sharedProcess/contrib/localizationsUpdater","vs/code/node/sharedProcess/contrib/logsDataCleaner","vs/platform/files/common/diskFileSystemProvider","vs/platform/files/common/fileService","vs/platform/files/node/diskFileSystemProvider","vs/platform/log/common/logIpc","vs/platform/log/common/logService","vs/platform/native/common/nativeHostService","vs/platform/policy/common/policyIpc","vs/code/node/sharedProcess/contrib/codeCacheCleaner","vs/code/node/sharedProcess/contrib/languagePackCachedDataCleaner","vs/platform/profiling/common/profiling","vs/platform/profiling/node/profilingService","vs/platform/configuration/common/configurations","vs/platform/configuration/common/configurationService","vs/platform/remote/common/managedSocket","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/extensionManagement/node/extensionsManifestCache","vs/platform/remote/common/remoteAgentConnection","vs/platform/remote/common/sharedProcessTunnelService","vs/platform/download/common/downloadService","vs/platform/request/common/requestIpc","vs/platform/sharedProcess/common/sharedProcess","vs/platform/sign/common/abstractSignService","vs/platform/sign/node/signService","vs/platform/diagnostics/node/diagnosticsService","vs/platform/extensionManagement/common/extensionTipsService","vs/platform/extensionManagement/common/unsupportedExtensionsMigration","vs/platform/extensionManagement/node/extensionsWatcher","vs/platform/externalServices/common/marketplace","vs/platform/languagePacks/node/languagePacks","vs/platform/telemetry/common/1dsAppender","vs/platform/telemetry/node/1dsAppender","vs/platform/telemetry/node/customEndpointTelemetryService","vs/platform/tunnel/node/sharedProcessTunnelService","vs/platform/uriIdentity/common/uriIdentityService","vs/platform/userData/common/fileUserDataProvider","vs/platform/userDataSync/common/extensionsMerge","vs/platform/userDataSync/common/keybindingsMerge","vs/platform/userDataSync/common/snippetsMerge","vs/platform/userDataSync/common/userDataProfilesManifestMerge","vs/platform/userDataSync/common/globalStateMerge","vs/platform/userDataSync/common/settingsMerge","vs/platform/userDataSync/common/userDataSyncIpc","vs/platform/userDataSync/common/userDataSyncLog","vs/platform/windows/node/windowTracker","vs/code/node/sharedProcess/contrib/userDataProfilesCleaner","vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/platform/extensionManagement/node/extensionLifecycle","vs/platform/extensionManagement/node/extensionsProfileScannerService","vs/platform/extensionManagement/node/extensionsScannerService","vs/platform/extensionManagement/common/extensionGalleryService","vs/platform/extensionManagement/node/extensionTipsService","vs/platform/remoteTunnel/node/remoteTunnelService","vs/platform/storage/common/storageService","vs/platform/userDataProfile/common/userDataProfileIpc","vs/platform/userDataProfile/node/userDataProfileStorageService","vs/platform/userDataSync/common/userDataSyncEnablementService","vs/platform/userDataSync/common/userDataSyncLocalStoreService","vs/platform/userDataSync/common/userDataAutoSyncService","vs/platform/userDataSync/common/userDataSyncResourceProvider","vs/platform/userDataSync/common/userDataSyncService","vs/platform/userDataSync/common/userDataSyncServiceIpc","vs/platform/userDataSync/common/userDataSyncStoreService","vs/platform/userDataSync/node/userDataAutoSyncService","vs/platform/workspaces/node/workspaces","vs/code/node/sharedProcess/contrib/storageDataCleaner","vs/platform/extensionManagement/node/extensionDownloader","vs/platform/extensionManagement/node/extensionManagementUtil","vs/code/node/sharedProcess/contrib/extensions","vs/platform/remote/node/nodeSocketFactory","vs/platform/tunnel/node/tunnelService","stream","util","path","graceful-fs","https","yauzl","yazl","zlib","vs/code/node/sharedProcess/sharedProcessMain"],ce=function(ie){for(var e=[],D=0,A=ie.length;D<A;D++)e[D]=ae[ie[D]];return e};define(ae[123],ce([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$T=e.$S=void 0,e.$S=!1;class D{static get(){const L=new Map,j=new Map,O=new Map,C=new Map;function S(l,g){l.has(g.detail)||l.set(g.detail,-g.timestamp)}function d(l,g){const y=l.get(g.detail);y&&(y>=0||l.set(g.detail,y+g.timestamp))}let R=[];typeof ie=="function"&&typeof ie.getStats=="function"&&(R=ie.getStats().slice(0).sort((l,g)=>l.timestamp-g.timestamp));for(const l of R)switch(l.type){case 10:S(L,l);break;case 11:case 12:d(L,l);break;case 21:S(j,l);break;case 22:d(j,l);break;case 33:S(O,l);break;case 34:d(O,l);break;case 31:S(C,l);break;case 32:d(C,l);break}let E=0;O.forEach(l=>E+=l);function b(l){const g=[];return l.forEach((y,w)=>g.push([w,y])),g}return{amdLoad:b(L),amdInvoke:b(j),nodeRequire:b(O),nodeEval:b(C),nodeRequireTotal:E}}static toMarkdownTable(L,j){let O="";const C=[];return L.forEach((S,d)=>{C[d]=S.length}),j.forEach(S=>{S.forEach((d,R)=>{typeof d>"u"&&(d=S[R]="-");const E=d.toString().length;C[R]=Math.max(E,C[R])})}),L.forEach((S,d)=>{O+=`| ${S+" ".repeat(C[d]-S.toString().length)} `}),O+=`|
`,L.forEach((S,d)=>{O+=`| ${"-".repeat(C[d])} `}),O+=`|
`,j.forEach(S=>{S.forEach((d,R)=>{typeof d<"u"&&(O+=`| ${d+" ".repeat(C[R]-d.toString().length)} `)}),O+=`|
`}),O}}e.$T=D}),define(ae[124],ce([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qb=e.$pb=e.$ob=e.$nb=e.$mb=e.$lb=e.$kb=e.$jb=e.$ib=e.$hb=e.$gb=e.$fb=e.$eb=void 0;function D(y,w,c){const u=A(y,w);if(u!==-1)return y[u]}e.$eb=D;function A(y,w,c=y.length-1){for(let u=c;u>=0;u--){const h=y[u];if(w(h))return u}return-1}e.$fb=A;function L(y,w){const c=j(y,w);return c===-1?void 0:y[c]}e.$gb=L;function j(y,w,c=0,u=y.length){let h=c,m=u;for(;h<m;){const k=Math.floor((h+m)/2);w(y[k])?h=k+1:m=k}return h-1}e.$hb=j;function O(y,w){const c=C(y,w);return c===y.length?void 0:y[c]}e.$ib=O;function C(y,w,c=0,u=y.length){let h=c,m=u;for(;h<m;){const k=Math.floor((h+m)/2);w(y[k])?m=k:h=k+1}return h}e.$jb=C;function S(y,w,c=0,u=y.length){const h=C(y,w,c,u);return h===y.length?-1:h}e.$kb=S;class d{static{this.assertInvariants=!1}constructor(w){this.e=w,this.c=0}findLastMonotonous(w){if(d.assertInvariants){if(this.d){for(const u of this.e)if(this.d(u)&&!w(u))throw new Error("MonotonousArray: current predicate must be weaker than (or equal to) the previous predicate.")}this.d=w}const c=j(this.e,w,this.c);return this.c=c+1,c===-1?void 0:this.e[c]}}e.$lb=d;function R(y,w){if(y.length===0)return;let c=y[0];for(let u=1;u<y.length;u++){const h=y[u];w(h,c)>0&&(c=h)}return c}e.$mb=R;function E(y,w){if(y.length===0)return;let c=y[0];for(let u=1;u<y.length;u++){const h=y[u];w(h,c)>=0&&(c=h)}return c}e.$nb=E;function b(y,w){return R(y,(c,u)=>-w(c,u))}e.$ob=b;function l(y,w){if(y.length===0)return-1;let c=0;for(let u=1;u<y.length;u++){const h=y[u];w(h,y[c])>0&&(c=u)}return c}e.$pb=l;function g(y,w){for(const c of y){const u=w(c);if(u!==void 0)return u}}e.$qb=g}),define(ae[125],ce([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$M=e.$L=e.$K=e.$J=void 0;function D(O,C){const S=Object.create(null);for(const d of O){const R=C(d);let E=S[R];E||(E=S[R]=[]),E.push(d)}return S}e.$J=D;function A(O,C){const S=[],d=[];for(const R of O)C.has(R)||S.push(R);for(const R of C)O.has(R)||d.push(R);return{removed:S,added:d}}e.$K=A;function L(O,C){const S=[],d=[];for(const[R,E]of O)C.has(R)||S.push(E);for(const[R,E]of C)O.has(R)||d.push(E);return{removed:S,added:d}}e.$L=L;function j(O,C){const S=new Set;for(const d of C)O.has(d)&&S.add(d);return S}e.$M=j}),define(ae[84],ce([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ph=e.$oh=e.$nh=void 0;function D(O){return(C,S,d)=>{let R=null,E=null;if(typeof d.value=="function"?(R="value",E=d.value):typeof d.get=="function"&&(R="get",E=d.get),!E)throw new Error("not supported");d[R]=O(E,S)}}function A(O,C,S){let d=null,R=null;if(typeof S.value=="function"?(d="value",R=S.value,R.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof S.get=="function"&&(d="get",R=S.get),!R)throw new Error("not supported");const E=`$memoize$${C}`;S[d]=function(...b){return this.hasOwnProperty(E)||Object.defineProperty(this,E,{configurable:!1,enumerable:!1,writable:!1,value:R.apply(this,b)}),this[E]}}e.$nh=A;function L(O,C,S){return D((d,R)=>{const E=`$debounce$${R}`,b=`$debounce$result$${R}`;return function(...l){this[b]||(this[b]=S?S():void 0),clearTimeout(this[E]),C&&(this[b]=C(this[b],...l),l=[this[b]]),this[E]=setTimeout(()=>{d.apply(this,l),this[b]=S?S():void 0},O)}})}e.$oh=L;function j(O,C,S){return D((d,R)=>{const E=`$throttle$timer$${R}`,b=`$throttle$result$${R}`,l=`$throttle$lastRun$${R}`,g=`$throttle$pending$${R}`;return function(...y){if(this[b]||(this[b]=S?S():void 0),(this[l]===null||this[l]===void 0)&&(this[l]=-Number.MAX_VALUE),C&&(this[b]=C(this[b],...y)),this[g])return;const w=this[l]+O;w<=Date.now()?(this[l]=Date.now(),d.apply(this,[this[b]]),this[b]=S?S():void 0):(this[g]=!0,this[E]=setTimeout(()=>{this[g]=!1,this[l]=Date.now(),d.apply(this,[this[b]]),this[b]=S?S():void 0},w-Date.now()))}})}e.$ph=j}),define(ae[7],ce([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bb=e.$ab=e.$_=e.$$=e.$0=e.$9=e.$8=e.$7=e.$6=e.$5=e.$4=e.$3=e.$2=e.$1=e.$Z=e.$Y=e.setUnexpectedErrorHandler=e.$W=e.$V=void 0;class D{constructor(){this.b=[],this.a=function(s){setTimeout(()=>{throw s.stack?h.isErrorNoTelemetry(s)?new h(s.message+`

`+s.stack):new Error(s.message+`

`+s.stack):s},0)}}addListener(s){return this.b.push(s),()=>{this.d(s)}}c(s){this.b.forEach(a=>{a(s)})}d(s){this.b.splice(this.b.indexOf(s),1)}setUnexpectedErrorHandler(s){this.a=s}getUnexpectedErrorHandler(){return this.a}onUnexpectedError(s){this.a(s),this.c(s)}onUnexpectedExternalError(s){this.a(s)}}e.$V=D,e.$W=new D;function A(k){e.$W.setUnexpectedErrorHandler(k)}e.setUnexpectedErrorHandler=A;function L(k){if(!k||typeof k!="object")return!1;const s=k;return s.code==="EPIPE"&&s.syscall?.toUpperCase()==="WRITE"}e.$Y=L;function j(k){d(k)||e.$W.onUnexpectedError(k)}e.$Z=j;function O(k){d(k)||e.$W.onUnexpectedExternalError(k)}e.$1=O;function C(k){if(k instanceof Error){const{name:s,message:a}=k,n=k.stacktrace||k.stack;return{$isError:!0,name:s,message:a,stack:n,noTelemetry:h.isErrorNoTelemetry(k)}}return k}e.$2=C;const S="Canceled";function d(k){return k instanceof R?!0:k instanceof Error&&k.name===S&&k.message===S}e.$3=d;class R extends Error{constructor(){super(S),this.name=this.message}}e.$4=R;function E(){const k=new Error(S);return k.name=k.message,k}e.$5=E;function b(k){return k?new Error(`Illegal argument: ${k}`):new Error("Illegal argument")}e.$6=b;function l(k){return k?new Error(`Illegal state: ${k}`):new Error("Illegal state")}e.$7=l;class g extends TypeError{constructor(s){super(s?`${s} is read-only and cannot be changed`:"Cannot change read-only property")}}e.$8=g;function y(k){return k?k.message?k.message:k.stack?k.stack.split(`
`)[0]:String(k):"Error"}e.$9=y;class w extends Error{constructor(s){super("NotImplemented"),s&&(this.message=s)}}e.$0=w;class c extends Error{constructor(s){super("NotSupported"),s&&(this.message=s)}}e.$$=c;class u extends Error{constructor(){super(...arguments),this.isExpected=!0}}e.$_=u;class h extends Error{constructor(s){super(s),this.name="CodeExpectedError"}static fromError(s){if(s instanceof h)return s;const a=new h;return a.message=s.message,a.stack=s.stack,a}static isErrorNoTelemetry(s){return s.name==="CodeExpectedError"}}e.$ab=h;class m extends Error{constructor(s){super(s||"An unexpected bug occurred."),Object.setPrototypeOf(this,m.prototype)}}e.$bb=m}),define(ae[18],ce([0,1,7,124]),function(ie,e,D,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_b=e.$$b=e.$0b=e.$9b=e.$8b=e.$7b=e.$6b=e.CompareResult=e.$5b=e.$4b=e.$3b=e.$2b=e.$1b=e.$Zb=e.$Yb=e.$Xb=e.$Wb=e.$Vb=e.$Ub=e.$Tb=e.$Sb=e.$Rb=e.$Qb=e.$Pb=e.$Ob=e.$Nb=e.$Mb=e.$Lb=e.$Kb=e.$Jb=e.$Ib=e.$Hb=e.$Gb=e.$Fb=e.top=e.$Db=e.$Cb=e.$Bb=e.$Ab=e.$zb=e.$yb=e.$xb=e.$wb=e.$vb=e.$ub=e.$tb=e.$sb=e.$rb=void 0;function L(N,V=0){return N[N.length-(1+V)]}e.$rb=L;function j(N){if(N.length===0)throw new Error("Invalid tail call");return[N.slice(0,N.length-1),N[N.length-1]]}e.$sb=j;function O(N,V,G=(te,oe)=>te===oe){if(N===V)return!0;if(!N||!V||N.length!==V.length)return!1;for(let te=0,oe=N.length;te<oe;te++)if(!G(N[te],V[te]))return!1;return!0}e.$tb=O;function C(N,V){const G=N.length-1;V<G&&(N[V]=N[G]),N.pop()}e.$ub=C;function S(N,V,G){return d(N.length,te=>G(N[te],V))}e.$vb=S;function d(N,V){let G=0,te=N-1;for(;G<=te;){const oe=(G+te)/2|0,ue=V(oe);if(ue<0)G=oe+1;else if(ue>0)te=oe-1;else return oe}return-(G+1)}e.$wb=d;function R(N,V,G){if(N=N|0,N>=V.length)throw new TypeError("invalid index");const te=V[Math.floor(V.length*Math.random())],oe=[],ue=[],he=[];for(const ge of V){const de=G(ge,te);de<0?oe.push(ge):de>0?ue.push(ge):he.push(ge)}return N<oe.length?R(N,oe,G):N<oe.length+he.length?he[0]:R(N-(oe.length+he.length),ue,G)}e.$xb=R;function E(N,V){const G=[];let te;for(const oe of N.slice(0).sort(V))!te||V(te[0],oe)!==0?(te=[oe],G.push(te)):te.push(oe);return G}e.$yb=E;function*b(N,V){let G,te;for(const oe of N)te!==void 0&&V(te,oe)?G.push(oe):(G&&(yield G),G=[oe]),te=oe;G&&(yield G)}e.$zb=b;function l(N,V){for(let G=0;G<=N.length;G++)V(G===0?void 0:N[G-1],G===N.length?void 0:N[G])}e.$Ab=l;function g(N,V){for(let G=0;G<N.length;G++)V(G===0?void 0:N[G-1],N[G],G+1===N.length?void 0:N[G+1])}e.$Bb=g;function y(N,V,G){const te=[];function oe(ge,de,we){if(de===0&&we.length===0)return;const ve=te[te.length-1];ve&&ve.start+ve.deleteCount===ge?(ve.deleteCount+=de,ve.toInsert.push(...we)):te.push({start:ge,deleteCount:de,toInsert:we})}let ue=0,he=0;for(;;){if(ue===N.length){oe(ue,0,V.slice(he));break}if(he===V.length){oe(ue,N.length-ue,[]);break}const ge=N[ue],de=V[he],we=G(ge,de);we===0?(ue+=1,he+=1):we<0?(oe(ue,1,[]),ue+=1):we>0&&(oe(ue,0,[de]),he+=1)}return te}e.$Cb=y;function w(N,V,G){const te=y(N,V,G),oe=[],ue=[];for(const he of te)oe.push(...N.slice(he.start,he.start+he.deleteCount)),ue.push(...he.toInsert);return{removed:oe,added:ue}}e.$Db=w;function c(N,V,G){if(G===0)return[];const te=N.slice(0,G).sort(V);return h(N,V,te,G,N.length),te}e.top=c;function u(N,V,G,te,oe){return G===0?Promise.resolve([]):new Promise((ue,he)=>{(async()=>{const ge=N.length,de=N.slice(0,G).sort(V);for(let we=G,ve=Math.min(G+te,ge);we<ge;we=ve,ve=Math.min(ve+te,ge)){if(we>G&&await new Promise(Ie=>setTimeout(Ie)),oe&&oe.isCancellationRequested)throw new D.$4;h(N,V,de,we,ve)}return de})().then(ue,he)})}e.$Fb=u;function h(N,V,G,te,oe){for(const ue=G.length;te<oe;te++){const he=N[te];if(V(he,G[ue-1])<0){G.pop();const ge=(0,A.$jb)(G,de=>V(he,de)<0);G.splice(ge,0,he)}}}function m(N){return N.filter(V=>!!V)}e.$Gb=m;function k(N){let V=0;for(let G=0;G<N.length;G++)N[G]&&(N[V]=N[G],V+=1);N.length=V}e.$Hb=k;function s(N,V,G){N.splice(G,0,N.splice(V,1)[0])}e.$Ib=s;function a(N){return!Array.isArray(N)||N.length===0}e.$Jb=a;function n(N){return Array.isArray(N)&&N.length>0}e.$Kb=n;function i(N,V=G=>G){const G=new Set;return N.filter(te=>{const oe=V(te);return G.has(oe)?!1:(G.add(oe),!0)})}e.$Lb=i;function t(N){const V=new Set;return G=>{const te=N(G);return V.has(te)?!1:(V.add(te),!0)}}e.$Mb=t;function r(N,V){return N.length>0?N[0]:V}e.$Nb=r;function o(N,V){return N.length>0?N[N.length-1]:V}e.$Ob=o;function v(N,V,G=(te,oe)=>te===oe){let te=0;for(let oe=0,ue=Math.min(N.length,V.length);oe<ue&&G(N[oe],V[oe]);oe++)te++;return te}e.$Pb=v;function $(N){return[].concat(...N)}e.$Qb=$;function f(N,V){let G=typeof V=="number"?N:0;typeof V=="number"?G=N:(G=0,V=N);const te=[];if(G<=V)for(let oe=G;oe<V;oe++)te.push(oe);else for(let oe=G;oe>V;oe--)te.push(oe);return te}e.$Rb=f;function p(N,V,G){return N.reduce((te,oe)=>(te[V(oe)]=G?G(oe):oe,te),Object.create(null))}e.$Sb=p;function I(N,V){return N.push(V),()=>T(N,V)}e.$Tb=I;function T(N,V){const G=N.indexOf(V);if(G>-1)return N.splice(G,1),V}e.$Ub=T;function M(N,V,G){const te=N.slice(0,V),oe=N.slice(V);return te.concat(G,oe)}e.$Vb=M;function z(N,V){let G;if(typeof V=="number"){let te=V;G=()=>{const oe=Math.sin(te++)*179426549;return oe-Math.floor(oe)}}else G=Math.random;for(let te=N.length-1;te>0;te-=1){const oe=Math.floor(G()*(te+1)),ue=N[te];N[te]=N[oe],N[oe]=ue}}e.$Wb=z;function q(N,V){const G=N.indexOf(V);G>-1&&(N.splice(G,1),N.unshift(V))}e.$Xb=q;function Y(N,V){const G=N.indexOf(V);G>-1&&(N.splice(G,1),N.push(V))}e.$Yb=Y;function Q(N,V){for(const G of V)N.push(G)}e.$Zb=Q;function x(N,V){return Array.isArray(N)?N.map(V):V(N)}e.$1b=x;function H(N){return Array.isArray(N)?N:[N]}e.$2b=H;function Z(N){return N[Math.floor(Math.random()*N.length)]}e.$3b=Z;function J(N,V,G){const te=ee(N,V),oe=N.length,ue=G.length;N.length=oe+ue;for(let he=oe-1;he>=te;he--)N[he+ue]=N[he];for(let he=0;he<ue;he++)N[he+te]=G[he]}e.$4b=J;function W(N,V,G,te){const oe=ee(N,V);let ue=N.splice(oe,G);return ue===void 0&&(ue=[]),J(N,oe,te),ue}e.$5b=W;function ee(N,V){return V<0?Math.max(V+N.length,0):Math.min(V,N.length)}var ne;(function(N){function V(ue){return ue<0}N.isLessThan=V;function G(ue){return ue<=0}N.isLessThanOrEqual=G;function te(ue){return ue>0}N.isGreaterThan=te;function oe(ue){return ue===0}N.isNeitherLessOrGreaterThan=oe,N.greaterThan=1,N.lessThan=-1,N.neitherLessOrGreaterThan=0})(ne||(e.CompareResult=ne={}));function _(N,V){return(G,te)=>V(N(G),N(te))}e.$6b=_;function se(...N){return(V,G)=>{for(const te of N){const oe=te(V,G);if(!ne.isNeitherLessOrGreaterThan(oe))return oe}return ne.neitherLessOrGreaterThan}}e.$7b=se;const K=(N,V)=>N-V;e.$8b=K;const U=(N,V)=>(0,e.$8b)(N?1:0,V?1:0);e.$9b=U;function P(N){return(V,G)=>-N(V,G)}e.$0b=P;class F{constructor(V){this.g=V,this.c=0,this.d=this.g.length-1}get length(){return this.d-this.c+1}takeWhile(V){let G=this.c;for(;G<this.g.length&&V(this.g[G]);)G++;const te=G===this.c?null:this.g.slice(this.c,G);return this.c=G,te}takeFromEndWhile(V){let G=this.d;for(;G>=0&&V(this.g[G]);)G--;const te=G===this.d?null:this.g.slice(G+1,this.d+1);return this.d=G,te}peek(){if(this.length!==0)return this.g[this.c]}peekLast(){if(this.length!==0)return this.g[this.d]}dequeue(){const V=this.g[this.c];return this.c++,V}removeLast(){const V=this.g[this.d];return this.d--,V}takeCount(V){const G=this.g.slice(this.c,this.c+V);return this.c+=V,G}}e.$$b=F;class B{static{this.empty=new B(V=>{})}constructor(V){this.iterate=V}forEach(V){this.iterate(G=>(V(G),!0))}toArray(){const V=[];return this.iterate(G=>(V.push(G),!0)),V}filter(V){return new B(G=>this.iterate(te=>V(te)?G(te):!0))}map(V){return new B(G=>this.iterate(te=>G(V(te))))}some(V){let G=!1;return this.iterate(te=>(G=V(te),!G)),G}findFirst(V){let G;return this.iterate(te=>V(te)?(G=te,!1):!0),G}findLast(V){let G;return this.iterate(te=>(V(te)&&(G=te),!0)),G}findLastMaxBy(V){let G,te=!0;return this.iterate(oe=>((te||ne.isGreaterThan(V(oe,G)))&&(te=!1,G=oe),!0)),G}}e.$_b=B}),define(ae[126],ce([0,1,7]),function(ie,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7c=e.$6c=e.$5c=e.$4c=e.ok=void 0;function A(S,d){if(!S)throw new Error(d?`Assertion failed (${d})`:"Assertion Failed")}e.ok=A;function L(S,d="Unreachable"){throw new Error(d)}e.$4c=L;function j(S){if(!S)throw new D.$bb("Assertion Failed")}e.$5c=j;function O(S){if(!S()){debugger;S(),(0,D.$Z)(new D.$bb("Assertion Failed"))}}e.$6c=O;function C(S,d){let R=0;for(;R<S.length-1;){const E=S[R],b=S[R+1];if(!d(E,b))return!1;R++}return!0}e.$7c=C}),define(ae[85],ce([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cb=void 0;function D(A,L){const j=this;let O=!1,C;return function(){if(O)return C;if(O=!0,L)try{C=A.apply(j,arguments)}finally{L()}else C=A.apply(j,arguments);return C}}e.$cb=D}),define(ae[60],ce([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var D;(function(A){function L(k){return k&&typeof k=="object"&&typeof k[Symbol.iterator]=="function"}A.is=L;const j=Object.freeze([]);function O(){return j}A.empty=O;function*C(k){yield k}A.single=C;function S(k){return L(k)?k:C(k)}A.wrap=S;function d(k){return k||j}A.from=d;function*R(k){for(let s=k.length-1;s>=0;s--)yield k[s]}A.reverse=R;function E(k){return!k||k[Symbol.iterator]().next().done===!0}A.isEmpty=E;function b(k){return k[Symbol.iterator]().next().value}A.first=b;function l(k,s){for(const a of k)if(s(a))return!0;return!1}A.some=l;function g(k,s){for(const a of k)if(s(a))return a}A.find=g;function*y(k,s){for(const a of k)s(a)&&(yield a)}A.filter=y;function*w(k,s){let a=0;for(const n of k)yield s(n,a++)}A.map=w;function*c(...k){for(const s of k)for(const a of s)yield a}A.concat=c;function u(k,s,a){let n=a;for(const i of k)n=s(n,i);return n}A.reduce=u;function*h(k,s,a=k.length){for(s<0&&(s+=k.length),a<0?a+=k.length:a>k.length&&(a=k.length);s<a;s++)yield k[s]}A.slice=h;function m(k,s=Number.POSITIVE_INFINITY){const a=[];if(s===0)return[a,k];const n=k[Symbol.iterator]();for(let i=0;i<s;i++){const t=n.next();if(t.done)return[a,A.empty()];a.push(t.value)}return[a,{[Symbol.iterator](){return n}}]}A.consume=m})(D||(e.Iterable=D={}))}),define(ae[35],ce([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_m=e.$$m=e.$0m=e.$9m=e.$8m=e.$7m=e.$6m=e.$5m=e.$4m=e.$3m=e.$2m=e.$1m=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var D;(function(s){s[s.None=0]="None",s[s.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",s[s.UnexpectedEndOfString=2]="UnexpectedEndOfString",s[s.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",s[s.InvalidUnicode=4]="InvalidUnicode",s[s.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",s[s.InvalidCharacter=6]="InvalidCharacter"})(D||(e.ScanError=D={}));var A;(function(s){s[s.OpenBraceToken=1]="OpenBraceToken",s[s.CloseBraceToken=2]="CloseBraceToken",s[s.OpenBracketToken=3]="OpenBracketToken",s[s.CloseBracketToken=4]="CloseBracketToken",s[s.CommaToken=5]="CommaToken",s[s.ColonToken=6]="ColonToken",s[s.NullKeyword=7]="NullKeyword",s[s.TrueKeyword=8]="TrueKeyword",s[s.FalseKeyword=9]="FalseKeyword",s[s.StringLiteral=10]="StringLiteral",s[s.NumericLiteral=11]="NumericLiteral",s[s.LineCommentTrivia=12]="LineCommentTrivia",s[s.BlockCommentTrivia=13]="BlockCommentTrivia",s[s.LineBreakTrivia=14]="LineBreakTrivia",s[s.Trivia=15]="Trivia",s[s.Unknown=16]="Unknown",s[s.EOF=17]="EOF"})(A||(e.SyntaxKind=A={}));var L;(function(s){s[s.InvalidSymbol=1]="InvalidSymbol",s[s.InvalidNumberFormat=2]="InvalidNumberFormat",s[s.PropertyNameExpected=3]="PropertyNameExpected",s[s.ValueExpected=4]="ValueExpected",s[s.ColonExpected=5]="ColonExpected",s[s.CommaExpected=6]="CommaExpected",s[s.CloseBraceExpected=7]="CloseBraceExpected",s[s.CloseBracketExpected=8]="CloseBracketExpected",s[s.EndOfFileExpected=9]="EndOfFileExpected",s[s.InvalidCommentToken=10]="InvalidCommentToken",s[s.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",s[s.UnexpectedEndOfString=12]="UnexpectedEndOfString",s[s.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",s[s.InvalidUnicode=14]="InvalidUnicode",s[s.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",s[s.InvalidCharacter=16]="InvalidCharacter"})(L||(e.ParseErrorCode=L={}));var j;(function(s){s.DEFAULT={allowTrailingComma:!0}})(j||(e.ParseOptions=j={}));function O(s,a=!1){let n=0;const i=s.length;let t="",r=0,o=16,v=0;function $(q){let Y=0,Q=0;for(;Y<q;){const x=s.charCodeAt(n);if(x>=48&&x<=57)Q=Q*16+x-48;else if(x>=65&&x<=70)Q=Q*16+x-65+10;else if(x>=97&&x<=102)Q=Q*16+x-97+10;else break;n++,Y++}return Y<q&&(Q=-1),Q}function f(q){n=q,t="",r=0,o=16,v=0}function p(){const q=n;if(s.charCodeAt(n)===48)n++;else for(n++;n<s.length&&d(s.charCodeAt(n));)n++;if(n<s.length&&s.charCodeAt(n)===46)if(n++,n<s.length&&d(s.charCodeAt(n)))for(n++;n<s.length&&d(s.charCodeAt(n));)n++;else return v=3,s.substring(q,n);let Y=n;if(n<s.length&&(s.charCodeAt(n)===69||s.charCodeAt(n)===101))if(n++,(n<s.length&&s.charCodeAt(n)===43||s.charCodeAt(n)===45)&&n++,n<s.length&&d(s.charCodeAt(n))){for(n++;n<s.length&&d(s.charCodeAt(n));)n++;Y=n}else v=3;return s.substring(q,Y)}function I(){let q="",Y=n;for(;;){if(n>=i){q+=s.substring(Y,n),v=2;break}const Q=s.charCodeAt(n);if(Q===34){q+=s.substring(Y,n),n++;break}if(Q===92){if(q+=s.substring(Y,n),n++,n>=i){v=2;break}switch(s.charCodeAt(n++)){case 34:q+='"';break;case 92:q+="\\";break;case 47:q+="/";break;case 98:q+="\b";break;case 102:q+="\f";break;case 110:q+=`
`;break;case 114:q+="\r";break;case 116:q+="	";break;case 117:{const H=$(4);H>=0?q+=String.fromCharCode(H):v=4;break}default:v=5}Y=n;continue}if(Q>=0&&Q<=31)if(S(Q)){q+=s.substring(Y,n),v=2;break}else v=6;n++}return q}function T(){if(t="",v=0,r=n,n>=i)return r=i,o=17;let q=s.charCodeAt(n);if(C(q)){do n++,t+=String.fromCharCode(q),q=s.charCodeAt(n);while(C(q));return o=15}if(S(q))return n++,t+=String.fromCharCode(q),q===13&&s.charCodeAt(n)===10&&(n++,t+=`
`),o=14;switch(q){case 123:return n++,o=1;case 125:return n++,o=2;case 91:return n++,o=3;case 93:return n++,o=4;case 58:return n++,o=6;case 44:return n++,o=5;case 34:return n++,t=I(),o=10;case 47:{const Y=n-1;if(s.charCodeAt(n+1)===47){for(n+=2;n<i&&!S(s.charCodeAt(n));)n++;return t=s.substring(Y,n),o=12}if(s.charCodeAt(n+1)===42){n+=2;const Q=i-1;let x=!1;for(;n<Q;){if(s.charCodeAt(n)===42&&s.charCodeAt(n+1)===47){n+=2,x=!0;break}n++}return x||(n++,v=1),t=s.substring(Y,n),o=13}return t+=String.fromCharCode(q),n++,o=16}case 45:if(t+=String.fromCharCode(q),n++,n===i||!d(s.charCodeAt(n)))return o=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return t+=p(),o=11;default:for(;n<i&&M(q);)n++,q=s.charCodeAt(n);if(r!==n){switch(t=s.substring(r,n),t){case"true":return o=8;case"false":return o=9;case"null":return o=7}return o=16}return t+=String.fromCharCode(q),n++,o=16}}function M(q){if(C(q)||S(q))return!1;switch(q){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function z(){let q;do q=T();while(q>=12&&q<=15);return q}return{setPosition:f,getPosition:()=>n,scan:a?z:T,getToken:()=>o,getTokenValue:()=>t,getTokenOffset:()=>r,getTokenLength:()=>n-r,getTokenError:()=>v}}e.$1m=O;function C(s){return s===32||s===9||s===11||s===12||s===160||s===5760||s>=8192&&s<=8203||s===8239||s===8287||s===12288||s===65279}function S(s){return s===10||s===13||s===8232||s===8233}function d(s){return s>=48&&s<=57}var R;(function(s){s[s.nullCharacter=0]="nullCharacter",s[s.maxAsciiCharacter=127]="maxAsciiCharacter",s[s.lineFeed=10]="lineFeed",s[s.carriageReturn=13]="carriageReturn",s[s.lineSeparator=8232]="lineSeparator",s[s.paragraphSeparator=8233]="paragraphSeparator",s[s.nextLine=133]="nextLine",s[s.space=32]="space",s[s.nonBreakingSpace=160]="nonBreakingSpace",s[s.enQuad=8192]="enQuad",s[s.emQuad=8193]="emQuad",s[s.enSpace=8194]="enSpace",s[s.emSpace=8195]="emSpace",s[s.threePerEmSpace=8196]="threePerEmSpace",s[s.fourPerEmSpace=8197]="fourPerEmSpace",s[s.sixPerEmSpace=8198]="sixPerEmSpace",s[s.figureSpace=8199]="figureSpace",s[s.punctuationSpace=8200]="punctuationSpace",s[s.thinSpace=8201]="thinSpace",s[s.hairSpace=8202]="hairSpace",s[s.zeroWidthSpace=8203]="zeroWidthSpace",s[s.narrowNoBreakSpace=8239]="narrowNoBreakSpace",s[s.ideographicSpace=12288]="ideographicSpace",s[s.mathematicalSpace=8287]="mathematicalSpace",s[s.ogham=5760]="ogham",s[s._=95]="_",s[s.$=36]="$",s[s._0=48]="_0",s[s._1=49]="_1",s[s._2=50]="_2",s[s._3=51]="_3",s[s._4=52]="_4",s[s._5=53]="_5",s[s._6=54]="_6",s[s._7=55]="_7",s[s._8=56]="_8",s[s._9=57]="_9",s[s.a=97]="a",s[s.b=98]="b",s[s.c=99]="c",s[s.d=100]="d",s[s.e=101]="e",s[s.f=102]="f",s[s.g=103]="g",s[s.h=104]="h",s[s.i=105]="i",s[s.j=106]="j",s[s.k=107]="k",s[s.l=108]="l",s[s.m=109]="m",s[s.n=110]="n",s[s.o=111]="o",s[s.p=112]="p",s[s.q=113]="q",s[s.r=114]="r",s[s.s=115]="s",s[s.t=116]="t",s[s.u=117]="u",s[s.v=118]="v",s[s.w=119]="w",s[s.x=120]="x",s[s.y=121]="y",s[s.z=122]="z",s[s.A=65]="A",s[s.B=66]="B",s[s.C=67]="C",s[s.D=68]="D",s[s.E=69]="E",s[s.F=70]="F",s[s.G=71]="G",s[s.H=72]="H",s[s.I=73]="I",s[s.J=74]="J",s[s.K=75]="K",s[s.L=76]="L",s[s.M=77]="M",s[s.N=78]="N",s[s.O=79]="O",s[s.P=80]="P",s[s.Q=81]="Q",s[s.R=82]="R",s[s.S=83]="S",s[s.T=84]="T",s[s.U=85]="U",s[s.V=86]="V",s[s.W=87]="W",s[s.X=88]="X",s[s.Y=89]="Y",s[s.Z=90]="Z",s[s.ampersand=38]="ampersand",s[s.asterisk=42]="asterisk",s[s.at=64]="at",s[s.backslash=92]="backslash",s[s.bar=124]="bar",s[s.caret=94]="caret",s[s.closeBrace=125]="closeBrace",s[s.closeBracket=93]="closeBracket",s[s.closeParen=41]="closeParen",s[s.colon=58]="colon",s[s.comma=44]="comma",s[s.dot=46]="dot",s[s.doubleQuote=34]="doubleQuote",s[s.equals=61]="equals",s[s.exclamation=33]="exclamation",s[s.greaterThan=62]="greaterThan",s[s.lessThan=60]="lessThan",s[s.minus=45]="minus",s[s.openBrace=123]="openBrace",s[s.openBracket=91]="openBracket",s[s.openParen=40]="openParen",s[s.percent=37]="percent",s[s.plus=43]="plus",s[s.question=63]="question",s[s.semicolon=59]="semicolon",s[s.singleQuote=39]="singleQuote",s[s.slash=47]="slash",s[s.tilde=126]="tilde",s[s.backspace=8]="backspace",s[s.formFeed=12]="formFeed",s[s.byteOrderMark=65279]="byteOrderMark",s[s.tab=9]="tab",s[s.verticalTab=11]="verticalTab"})(R||(R={}));function E(s,a){const n=[],i=new Object;let t;const r={value:{},offset:0,length:0,type:"object",parent:void 0};let o=!1;function v($,f,p,I){r.value=$,r.offset=f,r.length=p,r.type=I,r.colonOffset=void 0,t=r}try{h(s,{onObjectBegin:($,f)=>{if(a<=$)throw i;t=void 0,o=a>$,n.push("")},onObjectProperty:($,f,p)=>{if(a<f||(v($,f,p,"property"),n[n.length-1]=$,a<=f+p))throw i},onObjectEnd:($,f)=>{if(a<=$)throw i;t=void 0,n.pop()},onArrayBegin:($,f)=>{if(a<=$)throw i;t=void 0,n.push(0)},onArrayEnd:($,f)=>{if(a<=$)throw i;t=void 0,n.pop()},onLiteralValue:($,f,p)=>{if(a<f||(v($,f,p,k($)),a<=f+p))throw i},onSeparator:($,f,p)=>{if(a<=f)throw i;if($===":"&&t&&t.type==="property")t.colonOffset=f,o=!1,t=void 0;else if($===","){const I=n[n.length-1];typeof I=="number"?n[n.length-1]=I+1:(o=!0,n[n.length-1]=""),t=void 0}}})}catch($){if($!==i)throw $}return{path:n,previousNode:t,isAtPropertyKey:o,matches:$=>{let f=0;for(let p=0;f<$.length&&p<n.length;p++)if($[f]===n[p]||$[f]==="*")f++;else if($[f]!=="**")return!1;return f===$.length}}}e.$2m=E;function b(s,a=[],n=j.DEFAULT){let i=null,t=[];const r=[];function o($){Array.isArray(t)?t.push($):i!==null&&(t[i]=$)}return h(s,{onObjectBegin:()=>{const $={};o($),r.push(t),t=$,i=null},onObjectProperty:$=>{i=$},onObjectEnd:()=>{t=r.pop()},onArrayBegin:()=>{const $=[];o($),r.push(t),t=$,i=null},onArrayEnd:()=>{t=r.pop()},onLiteralValue:o,onError:($,f,p)=>{a.push({error:$,offset:f,length:p})}},n),t[0]}e.$3m=b;function l(s,a=[],n=j.DEFAULT){let i={type:"array",offset:-1,length:-1,children:[],parent:void 0};function t($){i.type==="property"&&(i.length=$-i.offset,i=i.parent)}function r($){return i.children.push($),$}h(s,{onObjectBegin:$=>{i=r({type:"object",offset:$,length:-1,parent:i,children:[]})},onObjectProperty:($,f,p)=>{i=r({type:"property",offset:f,length:-1,parent:i,children:[]}),i.children.push({type:"string",value:$,offset:f,length:p,parent:i})},onObjectEnd:($,f)=>{i.length=$+f-i.offset,i=i.parent,t($+f)},onArrayBegin:($,f)=>{i=r({type:"array",offset:$,length:-1,parent:i,children:[]})},onArrayEnd:($,f)=>{i.length=$+f-i.offset,i=i.parent,t($+f)},onLiteralValue:($,f,p)=>{r({type:k($),offset:f,length:p,parent:i,value:$}),t(f+p)},onSeparator:($,f,p)=>{i.type==="property"&&($===":"?i.colonOffset=f:$===","&&t(f))},onError:($,f,p)=>{a.push({error:$,offset:f,length:p})}},n);const v=i.children[0];return v&&delete v.parent,v}e.$4m=l;function g(s,a){if(!s)return;let n=s;for(const i of a)if(typeof i=="string"){if(n.type!=="object"||!Array.isArray(n.children))return;let t=!1;for(const r of n.children)if(Array.isArray(r.children)&&r.children[0].value===i){n=r.children[1],t=!0;break}if(!t)return}else{const t=i;if(n.type!=="array"||t<0||!Array.isArray(n.children)||t>=n.children.length)return;n=n.children[t]}return n}e.$5m=g;function y(s){if(!s.parent||!s.parent.children)return[];const a=y(s.parent);if(s.parent.type==="property"){const n=s.parent.children[0].value;a.push(n)}else if(s.parent.type==="array"){const n=s.parent.children.indexOf(s);n!==-1&&a.push(n)}return a}e.$6m=y;function w(s){switch(s.type){case"array":return s.children.map(w);case"object":{const a=Object.create(null);for(const n of s.children){const i=n.children[1];i&&(a[n.children[0].value]=w(i))}return a}case"null":case"string":case"number":case"boolean":return s.value;default:return}}e.$7m=w;function c(s,a,n=!1){return a>=s.offset&&a<s.offset+s.length||n&&a===s.offset+s.length}e.$8m=c;function u(s,a,n=!1){if(c(s,a,n)){const i=s.children;if(Array.isArray(i))for(let t=0;t<i.length&&i[t].offset<=a;t++){const r=u(i[t],a,n);if(r)return r}return s}}e.$9m=u;function h(s,a,n=j.DEFAULT){const i=O(s,!1);function t(_){return _?()=>_(i.getTokenOffset(),i.getTokenLength()):()=>!0}function r(_){return _?se=>_(se,i.getTokenOffset(),i.getTokenLength()):()=>!0}const o=t(a.onObjectBegin),v=r(a.onObjectProperty),$=t(a.onObjectEnd),f=t(a.onArrayBegin),p=t(a.onArrayEnd),I=r(a.onLiteralValue),T=r(a.onSeparator),M=t(a.onComment),z=r(a.onError),q=n&&n.disallowComments,Y=n&&n.allowTrailingComma;function Q(){for(;;){const _=i.scan();switch(i.getTokenError()){case 4:x(14);break;case 5:x(15);break;case 3:x(13);break;case 1:q||x(11);break;case 2:x(12);break;case 6:x(16);break}switch(_){case 12:case 13:q?x(10):M();break;case 16:x(1);break;case 15:case 14:break;default:return _}}}function x(_,se=[],K=[]){if(z(_),se.length+K.length>0){let U=i.getToken();for(;U!==17;){if(se.indexOf(U)!==-1){Q();break}else if(K.indexOf(U)!==-1)break;U=Q()}}}function H(_){const se=i.getTokenValue();return _?I(se):v(se),Q(),!0}function Z(){switch(i.getToken()){case 11:{let _=0;try{_=JSON.parse(i.getTokenValue()),typeof _!="number"&&(x(2),_=0)}catch{x(2)}I(_);break}case 7:I(null);break;case 8:I(!0);break;case 9:I(!1);break;default:return!1}return Q(),!0}function J(){return i.getToken()!==10?(x(3,[],[2,5]),!1):(H(!1),i.getToken()===6?(T(":"),Q(),ne()||x(4,[],[2,5])):x(5,[],[2,5]),!0)}function W(){o(),Q();let _=!1;for(;i.getToken()!==2&&i.getToken()!==17;){if(i.getToken()===5){if(_||x(4,[],[]),T(","),Q(),i.getToken()===2&&Y)break}else _&&x(6,[],[]);J()||x(4,[],[2,5]),_=!0}return $(),i.getToken()!==2?x(7,[2],[]):Q(),!0}function ee(){f(),Q();let _=!1;for(;i.getToken()!==4&&i.getToken()!==17;){if(i.getToken()===5){if(_||x(4,[],[]),T(","),Q(),i.getToken()===4&&Y)break}else _&&x(6,[],[]);ne()||x(4,[],[4,5]),_=!0}return p(),i.getToken()!==4?x(8,[4],[]):Q(),!0}function ne(){switch(i.getToken()){case 3:return ee();case 1:return W();case 10:return H(!0);default:return Z()}}return Q(),i.getToken()===17?n.allowEmptyContent?!0:(x(4,[],[]),!1):ne()?(i.getToken()!==17&&x(9,[],[]),!0):(x(4,[],[]),!1)}e.$0m=h;function m(s,a){const n=O(s),i=[];let t,r=0,o;do switch(o=n.getPosition(),t=n.scan(),t){case 12:case 13:case 17:r!==o&&i.push(s.substring(r,o)),a!==void 0&&i.push(n.getTokenValue().replace(/[^\r\n]/g,a)),r=n.getPosition();break}while(t!==17);return i.join("")}e.$$m=m;function k(s){switch(typeof s){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(s){if(Array.isArray(s))return"array"}else return"null";return"object"}default:return"null"}}e.$_m=k}),define(ae[42],ce([0,1,35]),function(ie,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vT=e.$uT=e.$tT=e.$sT=void 0;function A(d,R,E){let b,l,g,y,w;if(R){for(y=R.offset,w=y+R.length,g=y;g>0&&!S(d,g-1);)g--;let o=w;for(;o<d.length&&!S(d,o);)o++;l=d.substring(g,o),b=O(l,E)}else l=d,b=0,g=0,y=0,w=d.length;const c=C(E,d);let u=!1,h=0,m;E.insertSpaces?m=j(" ",E.tabSize||4):m="	";const k=(0,D.$1m)(l,!1);let s=!1;function a(){return c+j(m,b+h)}function n(){let o=k.scan();for(u=!1;o===15||o===14;)u=u||o===14,o=k.scan();return s=o===16||k.getTokenError()!==0,o}const i=[];function t(o,v,$){!s&&v<w&&$>y&&d.substring(v,$)!==o&&i.push({offset:v,length:$-v,content:o})}let r=n();if(r!==17){const o=k.getTokenOffset()+g,v=j(m,b);t(v,g,o)}for(;r!==17;){let o=k.getTokenOffset()+k.getTokenLength()+g,v=n(),$="";for(;!u&&(v===12||v===13);){const p=k.getTokenOffset()+g;t(" ",o,p),o=k.getTokenOffset()+k.getTokenLength()+g,$=v===12?a():"",v=n()}if(v===2)r!==1&&(h--,$=a());else if(v===4)r!==3&&(h--,$=a());else{switch(r){case 3:case 1:h++,$=a();break;case 5:case 12:$=a();break;case 13:u?$=a():$=" ";break;case 6:$=" ";break;case 10:if(v===6){$="";break}case 7:case 8:case 9:case 11:case 2:case 4:v===12||v===13?$=" ":v!==5&&v!==17&&(s=!0);break;case 16:s=!0;break}u&&(v===12||v===13)&&($=a())}const f=k.getTokenOffset()+g;t($,o,f),r=v}return i}e.$sT=A;function L(d,R){const E=JSON.stringify(d,void 0,R.insertSpaces?R.tabSize||4:"	");return R.eol!==void 0?E.replace(/\r\n|\r|\n/g,R.eol):E}e.$tT=L;function j(d,R){let E="";for(let b=0;b<R;b++)E+=d;return E}function O(d,R){let E=0,b=0;const l=R.tabSize||4;for(;E<d.length;){const g=d.charAt(E);if(g===" ")b++;else if(g==="	")b+=l;else break;E++}return Math.floor(b/l)}function C(d,R){for(let E=0;E<R.length;E++){const b=R.charAt(E);if(b==="\r")return E+1<R.length&&R.charAt(E+1)===`
`?`\r
`:"\r";if(b===`
`)return`
`}return d&&d.eol||`
`}e.$uT=C;function S(d,R){return`\r
`.indexOf(d.charAt(R))!==-1}e.$vT=S}),define(ae[86],ce([0,1,35,42]),function(ie,e,D,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$AT=e.$zT=e.$yT=e.$xT=e.$wT=void 0;function L(d,R,E){return j(d,R,void 0,E)}e.$wT=L;function j(d,R,E,b,l){const g=R.slice(),y=[],w=(0,D.$4m)(d,y);let c,u;for(;g.length>0&&(u=g.pop(),c=(0,D.$5m)(w,g),c===void 0&&E!==void 0);)typeof u=="string"?E={[u]:E}:E=[E];if(c)if(c.type==="object"&&typeof u=="string"&&Array.isArray(c.children)){const h=(0,D.$5m)(c,[u]);if(h!==void 0)if(E===void 0){if(!h.parent)throw new Error("Malformed AST");const m=c.children.indexOf(h.parent);let k,s=h.parent.offset+h.parent.length;if(m>0){const a=c.children[m-1];k=a.offset+a.length}else k=c.offset+1,c.children.length>1&&(s=c.children[1].offset);return O(d,{offset:k,length:s-k,content:""},b)}else return O(d,{offset:h.offset,length:h.length,content:JSON.stringify(E)},b);else{if(E===void 0)return[];const m=`${JSON.stringify(u)}: ${JSON.stringify(E)}`,k=l?l(c.children.map(a=>a.children[0].value)):c.children.length;let s;if(k>0){const a=c.children[k-1];s={offset:a.offset+a.length,length:0,content:","+m}}else c.children.length===0?s={offset:c.offset+1,length:0,content:m}:s={offset:c.offset+1,length:0,content:m+","};return O(d,s,b)}}else if(c.type==="array"&&typeof u=="number"&&Array.isArray(c.children))if(E!==void 0){const h=`${JSON.stringify(E)}`;let m;if(c.children.length===0||u===0)m={offset:c.offset+1,length:0,content:c.children.length===0?h:h+","};else{const k=u===-1||u>c.children.length?c.children.length:u,s=c.children[k-1];m={offset:s.offset+s.length,length:0,content:","+h}}return O(d,m,b)}else{const h=u,m=c.children[h];let k;if(c.children.length===1)k={offset:c.offset+1,length:c.length-2,content:""};else if(c.children.length-1===h){const s=c.children[h-1],a=s.offset+s.length,n=c.offset+c.length;k={offset:a,length:n-2-a,content:""}}else k={offset:m.offset,length:c.children[h+1].offset-m.offset,content:""};return O(d,k,b)}else throw new Error(`Can not add ${typeof u!="number"?"index":"property"} to parent of type ${c.type}`);else{if(E===void 0)throw new Error("Can not delete in empty document");return O(d,{offset:w?w.offset:0,length:w?w.length:0,content:JSON.stringify(E)},b)}}e.$xT=j;function O(d,R,E){let b=C(d,R),l=R.offset,g=R.offset+R.content.length;if(R.length===0||R.content.length===0){for(;l>0&&!(0,A.$vT)(b,l-1);)l--;for(;g<b.length&&!(0,A.$vT)(b,g);)g++}const y=(0,A.$sT)(b,{offset:l,length:g-l},E);for(let c=y.length-1;c>=0;c--){const u=y[c];b=C(b,u),l=Math.min(l,u.offset),g=Math.max(g,u.offset+u.length),g+=u.content.length-u.length}const w=d.length-(b.length-g)-l;return[{offset:l,length:w,content:b.substring(l,g)}]}e.$yT=O;function C(d,R){return d.substring(0,R.offset)+R.content+d.substring(R.offset+R.length)}e.$zT=C;function S(d,R){const E=R.slice(0).sort((l,g)=>{const y=l.offset-g.offset;return y===0?l.length-g.length:y});let b=d.length;for(let l=E.length-1;l>=0;l--){const g=E[l];if(g.offset+g.length<=b)d=C(d,g);else throw new Error("Overlapping edit");b=g.offset}return d}e.$AT=S}),define(ae[61],ce([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$U=void 0;class D{constructor(L){this.d=L,this.a=!1}get hasValue(){return this.a}get value(){if(!this.a)try{this.b=this.d()}catch(L){this.c=L}finally{this.a=!0}if(this.c)throw this.c;return this.b}get rawValue(){return this.b}}e.$U=D}),define(ae[87],ce([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2c=void 0;class D{static{this.Undefined=new D(void 0)}constructor(j){this.element=j,this.next=D.Undefined,this.prev=D.Undefined}}class A{constructor(){this.a=D.Undefined,this.b=D.Undefined,this.c=0}get size(){return this.c}isEmpty(){return this.a===D.Undefined}clear(){let j=this.a;for(;j!==D.Undefined;){const O=j.next;j.prev=D.Undefined,j.next=D.Undefined,j=O}this.a=D.Undefined,this.b=D.Undefined,this.c=0}unshift(j){return this.d(j,!1)}push(j){return this.d(j,!0)}d(j,O){const C=new D(j);if(this.a===D.Undefined)this.a=C,this.b=C;else if(O){const d=this.b;this.b=C,C.prev=d,d.next=C}else{const d=this.a;this.a=C,C.next=d,d.prev=C}this.c+=1;let S=!1;return()=>{S||(S=!0,this.e(C))}}shift(){if(this.a!==D.Undefined){const j=this.a.element;return this.e(this.a),j}}pop(){if(this.b!==D.Undefined){const j=this.b.element;return this.e(this.b),j}}e(j){if(j.prev!==D.Undefined&&j.next!==D.Undefined){const O=j.prev;O.next=j.next,j.next.prev=O}else j.prev===D.Undefined&&j.next===D.Undefined?(this.a=D.Undefined,this.b=D.Undefined):j.next===D.Undefined?(this.b=this.b.prev,this.b.next=D.Undefined):j.prev===D.Undefined&&(this.a=this.a.next,this.a.prev=D.Undefined);this.c-=1}*[Symbol.iterator](){let j=this.a;for(;j!==D.Undefined;)yield j.element,j=j.next}}e.$2c=A}),define(ae[34],ce([0,1]),function(ie,e){"use strict";var D,A,L;Object.defineProperty(e,"__esModule",{value:!0}),e.$Fc=e.$Ec=e.$Dc=e.$Cc=e.$Bc=e.Touch=e.$Ac=e.$zc=e.$yc=e.$xc=e.$wc=void 0;function j(u,h,m){let k=u.get(h);return k===void 0&&(k=m,u.set(h,k)),k}e.$wc=j;function O(u){const h=[];return u.forEach((m,k)=>{h.push(`${k} => ${m}`)}),`Map(${u.size}) {${h.join(", ")}}`}e.$xc=O;function C(u){const h=[];return u.forEach(m=>{h.push(m)}),`Set(${u.size}) {${h.join(", ")}}`}e.$yc=C;class S{constructor(h,m){this.uri=h,this.value=m}}function d(u){return Array.isArray(u)}class R{static{this.a=h=>h.toString()}constructor(h,m){if(this[D]="ResourceMap",h instanceof R)this.b=new Map(h.b),this.c=m??R.a;else if(d(h)){this.b=new Map,this.c=m??R.a;for(const[k,s]of h)this.set(k,s)}else this.b=new Map,this.c=h??R.a}set(h,m){return this.b.set(this.c(h),new S(h,m)),this}get(h){return this.b.get(this.c(h))?.value}has(h){return this.b.has(this.c(h))}get size(){return this.b.size}clear(){this.b.clear()}delete(h){return this.b.delete(this.c(h))}forEach(h,m){typeof m<"u"&&(h=h.bind(m));for(const[k,s]of this.b)h(s.value,s.uri,this)}*values(){for(const h of this.b.values())yield h.value}*keys(){for(const h of this.b.values())yield h.uri}*entries(){for(const h of this.b.values())yield[h.uri,h.value]}*[(D=Symbol.toStringTag,Symbol.iterator)](){for(const[,h]of this.b)yield[h.uri,h.value]}}e.$zc=R;class E{constructor(h,m){this[A]="ResourceSet",!h||typeof h=="function"?this.a=new R(h):(this.a=new R(m),h.forEach(this.add,this))}get size(){return this.a.size}add(h){return this.a.set(h,h),this}clear(){this.a.clear()}delete(h){return this.a.delete(h)}forEach(h,m){this.a.forEach((k,s)=>h.call(m,s,s,this))}has(h){return this.a.has(h)}entries(){return this.a.entries()}keys(){return this.a.keys()}values(){return this.a.keys()}[(A=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}e.$Ac=E;var b;(function(u){u[u.None=0]="None",u[u.AsOld=1]="AsOld",u[u.AsNew=2]="AsNew"})(b||(e.Touch=b={}));class l{constructor(){this[L]="LinkedMap",this.a=new Map,this.b=void 0,this.c=void 0,this.d=0,this.e=0}clear(){this.a.clear(),this.b=void 0,this.c=void 0,this.d=0,this.e++}isEmpty(){return!this.b&&!this.c}get size(){return this.d}get first(){return this.b?.value}get last(){return this.c?.value}has(h){return this.a.has(h)}get(h,m=0){const k=this.a.get(h);if(k)return m!==0&&this.j(k,m),k.value}set(h,m,k=0){let s=this.a.get(h);if(s)s.value=m,k!==0&&this.j(s,k);else{switch(s={key:h,value:m,next:void 0,previous:void 0},k){case 0:this.h(s);break;case 1:this.g(s);break;case 2:this.h(s);break;default:this.h(s);break}this.a.set(h,s),this.d++}return this}delete(h){return!!this.remove(h)}remove(h){const m=this.a.get(h);if(m)return this.a.delete(h),this.i(m),this.d--,m.value}shift(){if(!this.b&&!this.c)return;if(!this.b||!this.c)throw new Error("Invalid list");const h=this.b;return this.a.delete(h.key),this.i(h),this.d--,h.value}forEach(h,m){const k=this.e;let s=this.b;for(;s;){if(m?h.bind(m)(s.value,s.key,this):h(s.value,s.key,this),this.e!==k)throw new Error("LinkedMap got modified during iteration.");s=s.next}}keys(){const h=this,m=this.e;let k=this.b;const s={[Symbol.iterator](){return s},next(){if(h.e!==m)throw new Error("LinkedMap got modified during iteration.");if(k){const a={value:k.key,done:!1};return k=k.next,a}else return{value:void 0,done:!0}}};return s}values(){const h=this,m=this.e;let k=this.b;const s={[Symbol.iterator](){return s},next(){if(h.e!==m)throw new Error("LinkedMap got modified during iteration.");if(k){const a={value:k.value,done:!1};return k=k.next,a}else return{value:void 0,done:!0}}};return s}entries(){const h=this,m=this.e;let k=this.b;const s={[Symbol.iterator](){return s},next(){if(h.e!==m)throw new Error("LinkedMap got modified during iteration.");if(k){const a={value:[k.key,k.value],done:!1};return k=k.next,a}else return{value:void 0,done:!0}}};return s}[(L=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}f(h){if(h>=this.size)return;if(h===0){this.clear();return}let m=this.b,k=this.size;for(;m&&k>h;)this.a.delete(m.key),m=m.next,k--;this.b=m,this.d=k,m&&(m.previous=void 0),this.e++}g(h){if(!this.b&&!this.c)this.c=h;else if(this.b)h.next=this.b,this.b.previous=h;else throw new Error("Invalid list");this.b=h,this.e++}h(h){if(!this.b&&!this.c)this.b=h;else if(this.c)h.previous=this.c,this.c.next=h;else throw new Error("Invalid list");this.c=h,this.e++}i(h){if(h===this.b&&h===this.c)this.b=void 0,this.c=void 0;else if(h===this.b){if(!h.next)throw new Error("Invalid list");h.next.previous=void 0,this.b=h.next}else if(h===this.c){if(!h.previous)throw new Error("Invalid list");h.previous.next=void 0,this.c=h.previous}else{const m=h.next,k=h.previous;if(!m||!k)throw new Error("Invalid list");m.previous=k,k.next=m}h.next=void 0,h.previous=void 0,this.e++}j(h,m){if(!this.b||!this.c)throw new Error("Invalid list");if(!(m!==1&&m!==2)){if(m===1){if(h===this.b)return;const k=h.next,s=h.previous;h===this.c?(s.next=void 0,this.c=s):(k.previous=s,s.next=k),h.previous=void 0,h.next=this.b,this.b.previous=h,this.b=h,this.e++}else if(m===2){if(h===this.c)return;const k=h.next,s=h.previous;h===this.b?(k.previous=void 0,this.b=k):(k.previous=s,s.next=k),h.next=void 0,h.previous=this.c,this.c.next=h,this.c=h,this.e++}}}toJSON(){const h=[];return this.forEach((m,k)=>{h.push([k,m])}),h}fromJSON(h){this.clear();for(const[m,k]of h)this.set(m,k)}}e.$Bc=l;class g extends l{constructor(h,m=1){super(),this.k=h,this.l=Math.min(Math.max(0,m),1)}get limit(){return this.k}set limit(h){this.k=h,this.m()}get ratio(){return this.l}set ratio(h){this.l=Math.min(Math.max(0,h),1),this.m()}get(h,m=2){return super.get(h,m)}peek(h){return super.get(h,0)}set(h,m){return super.set(h,m,2),this.m(),this}m(){this.size>this.k&&this.f(Math.round(this.k*this.l))}}e.$Cc=g;class y{constructor(){this.a=new Map}add(h){return this.a.set(h,(this.a.get(h)||0)+1),this}delete(h){let m=this.a.get(h)||0;return m===0?!1:(m--,m===0?this.a.delete(h):this.a.set(h,m),!0)}has(h){return this.a.has(h)}}e.$Dc=y;class w{constructor(h){if(this.a=new Map,this.b=new Map,h)for(const[m,k]of h)this.set(m,k)}clear(){this.a.clear(),this.b.clear()}set(h,m){this.a.set(h,m),this.b.set(m,h)}get(h){return this.a.get(h)}getKey(h){return this.b.get(h)}delete(h){const m=this.a.get(h);return m===void 0?!1:(this.a.delete(h),this.b.delete(m),!0)}forEach(h,m){this.a.forEach((k,s)=>{h.call(m,k,s,this)})}keys(){return this.a.keys()}values(){return this.a.values()}}e.$Ec=w;class c{constructor(){this.a=new Map}add(h,m){let k=this.a.get(h);k||(k=new Set,this.a.set(h,k)),k.add(m)}delete(h,m){const k=this.a.get(h);k&&(k.delete(m),k.size===0&&this.a.delete(h))}forEach(h,m){const k=this.a.get(h);k&&k.forEach(m)}get(h){const m=this.a.get(h);return m||new Set}}e.$Fc=c}),define(ae[2],ce([0,1,18,125,34,85,60]),function(ie,e,D,A,L,j,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1c=e.$Zc=e.$Yc=e.$Xc=e.$Wc=e.$Vc=e.$Uc=e.$Tc=e.$Sc=e.$Rc=e.$Qc=e.$Pc=e.$Oc=e.$Nc=e.$Mc=e.$Lc=e.$Kc=e.$Jc=e.$Ic=e.$Hc=e.$Gc=void 0;const C=!1;let S=null;class d{constructor(){this.b=new Map}static{this.a=0}c(I){let T=this.b.get(I);return T||(T={parent:null,source:null,isSingleton:!1,value:I,idx:d.a++},this.b.set(I,T)),T}trackDisposable(I){const T=this.c(I);T.source||(T.source=new Error().stack)}setParent(I,T){const M=this.c(I);M.parent=T}markAsDisposed(I){this.b.delete(I)}markAsSingleton(I){this.c(I).isSingleton=!0}f(I,T){const M=T.get(I);if(M)return M;const z=I.parent?this.f(this.c(I.parent),T):I;return T.set(I,z),z}getTrackedDisposables(){const I=new Map;return[...this.b.entries()].filter(([,M])=>M.source!==null&&!this.f(M,I).isSingleton).flatMap(([M])=>M)}computeLeakingDisposables(I=10,T){let M;if(T)M=T;else{const x=new Map,H=[...this.b.values()].filter(J=>J.source!==null&&!this.f(J,x).isSingleton);if(H.length===0)return;const Z=new Set(H.map(J=>J.value));if(M=H.filter(J=>!(J.parent&&Z.has(J.parent))),M.length===0)throw new Error("There are cyclic diposable chains!")}if(!M)return;function z(x){function H(J,W){for(;J.length>0&&W.some(ee=>typeof ee=="string"?ee===J[0]:J[0].match(ee));)J.shift()}const Z=x.source.split(`
`).map(J=>J.trim().replace("at ","")).filter(J=>J!=="");return H(Z,["Error",/^trackDisposable \(.*\)$/,/^DisposableTracker.trackDisposable \(.*\)$/]),Z.reverse()}const q=new L.$Fc;for(const x of M){const H=z(x);for(let Z=0;Z<=H.length;Z++)q.add(H.slice(0,Z).join(`
`),x)}M.sort((0,D.$6b)(x=>x.idx,D.$8b));let Y="",Q=0;for(const x of M.slice(0,I)){Q++;const H=z(x),Z=[];for(let J=0;J<H.length;J++){let W=H[J];W=`(shared with ${q.get(H.slice(0,J+1).join(`
`)).size}/${M.length} leaks) at ${W}`;const ne=q.get(H.slice(0,J).join(`
`)),_=(0,A.$J)([...ne].map(se=>z(se)[J]),se=>se);delete _[H[J]];for(const[se,K]of Object.entries(_))Z.unshift(`    - stacktraces of ${K.length} other leaks continue with ${se}`);Z.unshift(W)}Y+=`


==================== Leaking disposable ${Q}/${M.length}: ${x.value.constructor.name} ====================
${Z.join(`
`)}
============================================================

`}return M.length>I&&(Y+=`


... and ${M.length-I} more leaking disposables

`),{leaks:M,details:Y}}}e.$Gc=d;function R(p){S=p}if(e.$Hc=R,C){const p="__is_disposable_tracked__";R(new class{trackDisposable(I){const T=new Error("Potentially leaked disposable").stack;setTimeout(()=>{I[p]||console.log(T)},3e3)}setParent(I,T){if(I&&I!==s.None)try{I[p]=!0}catch{}}markAsDisposed(I){if(I&&I!==s.None)try{I[p]=!0}catch{}}markAsSingleton(I){}})}function E(p){return S?.trackDisposable(p),p}e.$Ic=E;function b(p){S?.markAsDisposed(p)}e.$Jc=b;function l(p,I){S?.setParent(p,I)}function g(p,I){if(S)for(const T of p)S.setParent(T,I)}function y(p){return S?.markAsSingleton(p),p}e.$Kc=y;function w(p){return typeof p.dispose=="function"&&p.dispose.length===0}e.$Lc=w;function c(p){if(O.Iterable.is(p)){const I=[];for(const T of p)if(T)try{T.dispose()}catch(M){I.push(M)}if(I.length===1)throw I[0];if(I.length>1)throw new AggregateError(I,"Encountered errors while disposing of store");return Array.isArray(p)?[]:p}else if(p)return p.dispose(),p}e.$Mc=c;function u(p){for(const I of p)w(I)&&I.dispose();return[]}e.$Nc=u;function h(...p){const I=m(()=>c(p));return g(p,I),I}e.$Oc=h;function m(p){const I=E({dispose:(0,j.$cb)(()=>{b(I),p()})});return I}e.$Pc=m;class k{static{this.DISABLE_DISPOSED_WARNING=!1}constructor(){this.f=new Set,this.g=!1,E(this)}dispose(){this.g||(b(this),this.g=!0,this.clear())}get isDisposed(){return this.g}clear(){if(this.f.size!==0)try{c(this.f)}finally{this.f.clear()}}add(I){if(!I)return I;if(I===this)throw new Error("Cannot register a disposable on itself!");return l(I,this),this.g?k.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this.f.add(I),I}delete(I){if(I){if(I===this)throw new Error("Cannot dispose a disposable on itself!");this.f.delete(I),I.dispose()}}deleteAndLeak(I){I&&this.f.has(I)&&(this.f.delete(I),l(I,null))}}e.$Qc=k;class s{static{this.None=Object.freeze({dispose(){}})}constructor(){this.q=new k,E(this),l(this.q,this)}dispose(){b(this),this.q.dispose()}B(I){if(I===this)throw new Error("Cannot register a disposable on itself!");return this.q.add(I)}}e.$Rc=s;class a{constructor(){this.b=!1,E(this)}get value(){return this.b?void 0:this.a}set value(I){this.b||I===this.a||(this.a?.dispose(),I&&l(I,this),this.a=I)}clear(){this.value=void 0}dispose(){this.b=!0,b(this),this.a?.dispose(),this.a=void 0}clearAndLeak(){const I=this.a;return this.a=void 0,I&&l(I,null),I}}e.$Sc=a;class n{constructor(I){this.a=new a,this.b=!1,this.a.value=I}get value(){return this.a.value}set value(I){this.b||I===this.a.value||(this.a.value=I)}dispose(){this.b=!0,this.a.dispose()}}e.$Tc=n;class i{constructor(I){this.b=I,this.a=1}acquire(){return this.a++,this}release(){return--this.a===0&&this.b.dispose(),this}}e.$Uc=i;class t{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,E(this)}set(I){let T=I;return this.unset=()=>T=void 0,this.isset=()=>T!==void 0,this.dispose=()=>{T&&(T(),T=void 0,b(this))},this}}e.$Vc=t;class r{constructor(){this.a=new Map}acquire(I,...T){let M=this.a.get(I);M||(M={counter:0,object:this.b(I,...T)},this.a.set(I,M));const{object:z}=M,q=(0,j.$cb)(()=>{--M.counter===0&&(this.c(I,M.object),this.a.delete(I))});return M.counter++,{object:z,dispose:q}}}e.$Wc=r;class o{constructor(I){this.a=I}async acquire(I,...T){const M=this.a.acquire(I,...T);try{return{object:await M.object,dispose:()=>M.dispose()}}catch(z){throw M.dispose(),z}}}e.$Xc=o;class v{constructor(I){this.object=I}dispose(){}}e.$Yc=v;function $(p){const I=new k;try{p(I)}finally{I.dispose()}}e.$Zc=$;class f{constructor(){this.a=new Map,this.b=!1,E(this)}dispose(){b(this),this.b=!0,this.clearAndDisposeAll()}clearAndDisposeAll(){if(this.a.size)try{c(this.a.values())}finally{this.a.clear()}}has(I){return this.a.has(I)}get size(){return this.a.size}get(I){return this.a.get(I)}set(I,T,M=!1){this.b&&console.warn(new Error("Trying to add a disposable to a DisposableMap that has already been disposed of. The added object will be leaked!").stack),M||this.a.get(I)?.dispose(),this.a.set(I,T)}deleteAndDispose(I){this.a.get(I)?.dispose(),this.a.delete(I)}keys(){return this.a.keys()}values(){return this.a.values()}[Symbol.iterator](){return this.a[Symbol.iterator]()}}e.$1c=f}),define(ae[88],ce([0,1,34]),function(ie,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wl=e.$vl=e.$ul=void 0;const A=new D.$Cc(1e4);function L(d){return S(d,"NFC",A)}e.$ul=L;const j=new D.$Cc(1e4);function O(d){return S(d,"NFD",j)}e.$vl=O;const C=/[^\u0000-\u0080]/;function S(d,R,E){if(!d)return d;const b=E.get(d);if(b)return b;let l;return C.test(d)?l=d.normalize(R):l=d,E.set(d,l),l}e.$wl=function(){const d=/[\u0300-\u036f]/g;return function(R){return O(R).replace(d,"")}}()}),function(){function ie(L){const j=[];typeof L=="number"&&j.push("code/timeOrigin",L);function O(S){j.push(S,Date.now())}function C(){const S=[];for(let d=0;d<j.length;d+=2)S.push({name:j[d],startTime:j[d+1]});return S}return{mark:O,getMarks:C}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?ie():{mark(L){performance.mark(L)},getMarks(){let L=performance.timeOrigin;typeof L!="number"&&(L=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const j=[{name:"code/timeOrigin",startTime:Math.round(L)}];for(const O of performance.getEntriesByType("mark"))j.push({name:O.name,startTime:Math.round(L+O.startTime)});return j}};if(typeof process=="object"){const L=performance?.timeOrigin??Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return ie(L)}else return console.trace("perf-util loaded in UNKNOWN environment"),ie()}function D(L){return L.MonacoPerformanceMarks||(L.MonacoPerformanceMarks=e()),L.MonacoPerformanceMarks}var A;typeof global=="object"?A=global:typeof self=="object"?A=self:A={},typeof define=="function"?define("vs/base/common/performance",[],function(){return D(A)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=D(A):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),A.perf=D(A))}(),function(ie,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var D=e();for(var A in D)(typeof exports=="object"?exports:ie)[A]=D[A]}}(typeof self<"u"?self:this,function(){return function(ie){var e={};function D(A){if(e[A])return e[A].exports;var L=e[A]={i:A,l:!1,exports:{}};return ie[A].call(L.exports,L,L.exports,D),L.l=!0,L.exports}return D.m=ie,D.c=e,D.d=function(A,L,j){D.o(A,L)||Object.defineProperty(A,L,{enumerable:!0,get:j})},D.r=function(A){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(A,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(A,"__esModule",{value:!0})},D.t=function(A,L){if(1&L&&(A=D(A)),8&L||4&L&&typeof A=="object"&&A&&A.__esModule)return A;var j=Object.create(null);if(D.r(j),Object.defineProperty(j,"default",{enumerable:!0,value:A}),2&L&&typeof A!="string")for(var O in A)D.d(j,O,function(C){return A[C]}.bind(null,O));return j},D.n=function(A){var L=A&&A.__esModule?function(){return A.default}:function(){return A};return D.d(L,"a",L),L},D.o=function(A,L){return Object.prototype.hasOwnProperty.call(A,L)},D.p="",D(D.s=0)}([function(ie,e,D){(function(A){var L;e=ie.exports=K,L=typeof A=="object"&&A.env&&A.env.NODE_DEBUG&&/\bsemver\b/i.test(A.env.NODE_DEBUG)?function(){var le=Array.prototype.slice.call(arguments,0);le.unshift("SEMVER"),console.log.apply(console,le)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var j=256,O=Number.MAX_SAFE_INTEGER||9007199254740991,C=e.re=[],S=e.src=[],d=0,R=d++;S[R]="0|[1-9]\\d*";var E=d++;S[E]="[0-9]+";var b=d++;S[b]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var l=d++;S[l]="("+S[R]+")\\.("+S[R]+")\\.("+S[R]+")";var g=d++;S[g]="("+S[E]+")\\.("+S[E]+")\\.("+S[E]+")";var y=d++;S[y]="(?:"+S[R]+"|"+S[b]+")";var w=d++;S[w]="(?:"+S[E]+"|"+S[b]+")";var c=d++;S[c]="(?:-("+S[y]+"(?:\\."+S[y]+")*))";var u=d++;S[u]="(?:-?("+S[w]+"(?:\\."+S[w]+")*))";var h=d++;S[h]="[0-9A-Za-z-]+";var m=d++;S[m]="(?:\\+("+S[h]+"(?:\\."+S[h]+")*))";var k=d++,s="v?"+S[l]+S[c]+"?"+S[m]+"?";S[k]="^"+s+"$";var a="[v=\\s]*"+S[g]+S[u]+"?"+S[m]+"?",n=d++;S[n]="^"+a+"$";var i=d++;S[i]="((?:<|>)?=?)";var t=d++;S[t]=S[E]+"|x|X|\\*";var r=d++;S[r]=S[R]+"|x|X|\\*";var o=d++;S[o]="[v=\\s]*("+S[r]+")(?:\\.("+S[r]+")(?:\\.("+S[r]+")(?:"+S[c]+")?"+S[m]+"?)?)?";var v=d++;S[v]="[v=\\s]*("+S[t]+")(?:\\.("+S[t]+")(?:\\.("+S[t]+")(?:"+S[u]+")?"+S[m]+"?)?)?";var $=d++;S[$]="^"+S[i]+"\\s*"+S[o]+"$";var f=d++;S[f]="^"+S[i]+"\\s*"+S[v]+"$";var p=d++;S[p]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var I=d++;S[I]="(?:~>?)";var T=d++;S[T]="(\\s*)"+S[I]+"\\s+",C[T]=new RegExp(S[T],"g");var M=d++;S[M]="^"+S[I]+S[o]+"$";var z=d++;S[z]="^"+S[I]+S[v]+"$";var q=d++;S[q]="(?:\\^)";var Y=d++;S[Y]="(\\s*)"+S[q]+"\\s+",C[Y]=new RegExp(S[Y],"g");var Q=d++;S[Q]="^"+S[q]+S[o]+"$";var x=d++;S[x]="^"+S[q]+S[v]+"$";var H=d++;S[H]="^"+S[i]+"\\s*("+a+")$|^$";var Z=d++;S[Z]="^"+S[i]+"\\s*("+s+")$|^$";var J=d++;S[J]="(\\s*)"+S[i]+"\\s*("+a+"|"+S[o]+")",C[J]=new RegExp(S[J],"g");var W=d++;S[W]="^\\s*("+S[o]+")\\s+-\\s+("+S[o]+")\\s*$";var ee=d++;S[ee]="^\\s*("+S[v]+")\\s+-\\s+("+S[v]+")\\s*$";var ne=d++;S[ne]="(<|>)?=?\\s*\\*";for(var _=0;_<35;_++)L(_,S[_]),C[_]||(C[_]=new RegExp(S[_]));function se(le,$e){if(le instanceof K)return le;if(typeof le!="string"||le.length>j||!($e?C[n]:C[k]).test(le))return null;try{return new K(le,$e)}catch{return null}}function K(le,$e){if(le instanceof K){if(le.loose===$e)return le;le=le.version}else if(typeof le!="string")throw new TypeError("Invalid Version: "+le);if(le.length>j)throw new TypeError("version is longer than "+j+" characters");if(!(this instanceof K))return new K(le,$e);L("SemVer",le,$e),this.loose=$e;var be=le.trim().match($e?C[n]:C[k]);if(!be)throw new TypeError("Invalid Version: "+le);if(this.raw=le,this.major=+be[1],this.minor=+be[2],this.patch=+be[3],this.major>O||this.major<0)throw new TypeError("Invalid major version");if(this.minor>O||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>O||this.patch<0)throw new TypeError("Invalid patch version");be[4]?this.prerelease=be[4].split(".").map(function(Se){if(/^[0-9]+$/.test(Se)){var Pe=+Se;if(Pe>=0&&Pe<O)return Pe}return Se}):this.prerelease=[],this.build=be[5]?be[5].split("."):[],this.format()}e.parse=se,e.valid=function(le,$e){var be=se(le,$e);return be?be.version:null},e.clean=function(le,$e){var be=se(le.trim().replace(/^[=v]+/,""),$e);return be?be.version:null},e.SemVer=K,K.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},K.prototype.toString=function(){return this.version},K.prototype.compare=function(le){return L("SemVer.compare",this.version,this.loose,le),le instanceof K||(le=new K(le,this.loose)),this.compareMain(le)||this.comparePre(le)},K.prototype.compareMain=function(le){return le instanceof K||(le=new K(le,this.loose)),P(this.major,le.major)||P(this.minor,le.minor)||P(this.patch,le.patch)},K.prototype.comparePre=function(le){if(le instanceof K||(le=new K(le,this.loose)),this.prerelease.length&&!le.prerelease.length)return-1;if(!this.prerelease.length&&le.prerelease.length)return 1;if(!this.prerelease.length&&!le.prerelease.length)return 0;var $e=0;do{var be=this.prerelease[$e],Se=le.prerelease[$e];if(L("prerelease compare",$e,be,Se),be===void 0&&Se===void 0)return 0;if(Se===void 0)return 1;if(be===void 0)return-1;if(be!==Se)return P(be,Se)}while(++$e)},K.prototype.inc=function(le,$e){switch(le){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",$e);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",$e);break;case"prepatch":this.prerelease.length=0,this.inc("patch",$e),this.inc("pre",$e);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",$e),this.inc("pre",$e);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var be=this.prerelease.length;--be>=0;)typeof this.prerelease[be]=="number"&&(this.prerelease[be]++,be=-2);be===-1&&this.prerelease.push(0)}$e&&(this.prerelease[0]===$e?isNaN(this.prerelease[1])&&(this.prerelease=[$e,0]):this.prerelease=[$e,0]);break;default:throw new Error("invalid increment argument: "+le)}return this.format(),this.raw=this.version,this},e.inc=function(le,$e,be,Se){typeof be=="string"&&(Se=be,be=void 0);try{return new K(le,be).inc($e,Se).version}catch{return null}},e.diff=function(le,$e){if(V(le,$e))return null;var be=se(le),Se=se($e);if(be.prerelease.length||Se.prerelease.length){for(var Pe in be)if((Pe==="major"||Pe==="minor"||Pe==="patch")&&be[Pe]!==Se[Pe])return"pre"+Pe;return"prerelease"}for(var Pe in be)if((Pe==="major"||Pe==="minor"||Pe==="patch")&&be[Pe]!==Se[Pe])return Pe},e.compareIdentifiers=P;var U=/^[0-9]+$/;function P(le,$e){var be=U.test(le),Se=U.test($e);return be&&Se&&(le=+le,$e=+$e),be&&!Se?-1:Se&&!be?1:le<$e?-1:le>$e?1:0}function F(le,$e,be){return new K(le,be).compare(new K($e,be))}function B(le,$e,be){return F(le,$e,be)>0}function N(le,$e,be){return F(le,$e,be)<0}function V(le,$e,be){return F(le,$e,be)===0}function G(le,$e,be){return F(le,$e,be)!==0}function te(le,$e,be){return F(le,$e,be)>=0}function oe(le,$e,be){return F(le,$e,be)<=0}function ue(le,$e,be,Se){var Pe;switch($e){case"===":typeof le=="object"&&(le=le.version),typeof be=="object"&&(be=be.version),Pe=le===be;break;case"!==":typeof le=="object"&&(le=le.version),typeof be=="object"&&(be=be.version),Pe=le!==be;break;case"":case"=":case"==":Pe=V(le,be,Se);break;case"!=":Pe=G(le,be,Se);break;case">":Pe=B(le,be,Se);break;case">=":Pe=te(le,be,Se);break;case"<":Pe=N(le,be,Se);break;case"<=":Pe=oe(le,be,Se);break;default:throw new TypeError("Invalid operator: "+$e)}return Pe}function he(le,$e){if(le instanceof he){if(le.loose===$e)return le;le=le.value}if(!(this instanceof he))return new he(le,$e);L("comparator",le,$e),this.loose=$e,this.parse(le),this.semver===ge?this.value="":this.value=this.operator+this.semver.version,L("comp",this)}e.rcompareIdentifiers=function(le,$e){return P($e,le)},e.major=function(le,$e){return new K(le,$e).major},e.minor=function(le,$e){return new K(le,$e).minor},e.patch=function(le,$e){return new K(le,$e).patch},e.compare=F,e.compareLoose=function(le,$e){return F(le,$e,!0)},e.rcompare=function(le,$e,be){return F($e,le,be)},e.sort=function(le,$e){return le.sort(function(be,Se){return e.compare(be,Se,$e)})},e.rsort=function(le,$e){return le.sort(function(be,Se){return e.rcompare(be,Se,$e)})},e.gt=B,e.lt=N,e.eq=V,e.neq=G,e.gte=te,e.lte=oe,e.cmp=ue,e.Comparator=he;var ge={};function de(le,$e){if(le instanceof de)return le.loose===$e?le:new de(le.raw,$e);if(le instanceof he)return new de(le.value,$e);if(!(this instanceof de))return new de(le,$e);if(this.loose=$e,this.raw=le,this.set=le.split(/\s*\|\|\s*/).map(function(be){return this.parseRange(be.trim())},this).filter(function(be){return be.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+le);this.format()}function we(le){return!le||le.toLowerCase()==="x"||le==="*"}function ve(le,$e,be,Se,Pe,ze,je,Ue,Te,re,fe,me,ye){return(($e=we(be)?"":we(Se)?">="+be+".0.0":we(Pe)?">="+be+"."+Se+".0":">="+$e)+" "+(Ue=we(Te)?"":we(re)?"<"+(+Te+1)+".0.0":we(fe)?"<"+Te+"."+(+re+1)+".0":me?"<="+Te+"."+re+"."+fe+"-"+me:"<="+Ue)).trim()}function Ie(le,$e){for(var be=0;be<le.length;be++)if(!le[be].test($e))return!1;if($e.prerelease.length){for(be=0;be<le.length;be++)if(L(le[be].semver),le[be].semver!==ge&&le[be].semver.prerelease.length>0){var Se=le[be].semver;if(Se.major===$e.major&&Se.minor===$e.minor&&Se.patch===$e.patch)return!0}return!1}return!0}function Ne(le,$e,be){try{$e=new de($e,be)}catch{return!1}return $e.test(le)}function Me(le,$e,be,Se){var Pe,ze,je,Ue,Te;switch(le=new K(le,Se),$e=new de($e,Se),be){case">":Pe=B,ze=oe,je=N,Ue=">",Te=">=";break;case"<":Pe=N,ze=te,je=B,Ue="<",Te="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(Ne(le,$e,Se))return!1;for(var re=0;re<$e.set.length;++re){var fe=$e.set[re],me=null,ye=null;if(fe.forEach(function(ke){ke.semver===ge&&(ke=new he(">=0.0.0")),me=me||ke,ye=ye||ke,Pe(ke.semver,me.semver,Se)?me=ke:je(ke.semver,ye.semver,Se)&&(ye=ke)}),me.operator===Ue||me.operator===Te||(!ye.operator||ye.operator===Ue)&&ze(le,ye.semver)||ye.operator===Te&&je(le,ye.semver))return!1}return!0}he.prototype.parse=function(le){var $e=this.loose?C[H]:C[Z],be=le.match($e);if(!be)throw new TypeError("Invalid comparator: "+le);this.operator=be[1],this.operator==="="&&(this.operator=""),be[2]?this.semver=new K(be[2],this.loose):this.semver=ge},he.prototype.toString=function(){return this.value},he.prototype.test=function(le){return L("Comparator.test",le,this.loose),this.semver===ge||(typeof le=="string"&&(le=new K(le,this.loose)),ue(le,this.operator,this.semver,this.loose))},he.prototype.intersects=function(le,$e){if(!(le instanceof he))throw new TypeError("a Comparator is required");var be;if(this.operator==="")return be=new de(le.value,$e),Ne(this.value,be,$e);if(le.operator==="")return be=new de(this.value,$e),Ne(le.semver,be,$e);var Se=!(this.operator!==">="&&this.operator!==">"||le.operator!==">="&&le.operator!==">"),Pe=!(this.operator!=="<="&&this.operator!=="<"||le.operator!=="<="&&le.operator!=="<"),ze=this.semver.version===le.semver.version,je=!(this.operator!==">="&&this.operator!=="<="||le.operator!==">="&&le.operator!=="<="),Ue=ue(this.semver,"<",le.semver,$e)&&(this.operator===">="||this.operator===">")&&(le.operator==="<="||le.operator==="<"),Te=ue(this.semver,">",le.semver,$e)&&(this.operator==="<="||this.operator==="<")&&(le.operator===">="||le.operator===">");return Se||Pe||ze&&je||Ue||Te},e.Range=de,de.prototype.format=function(){return this.range=this.set.map(function(le){return le.join(" ").trim()}).join("||").trim(),this.range},de.prototype.toString=function(){return this.range},de.prototype.parseRange=function(le){var $e=this.loose;le=le.trim(),L("range",le,$e);var be=$e?C[ee]:C[W];le=le.replace(be,ve),L("hyphen replace",le),le=le.replace(C[J],"$1$2$3"),L("comparator trim",le,C[J]),le=(le=(le=le.replace(C[T],"$1~")).replace(C[Y],"$1^")).split(/\s+/).join(" ");var Se=$e?C[H]:C[Z],Pe=le.split(" ").map(function(ze){return function(je,Ue){return L("comp",je),je=function(Te,re){return Te.trim().split(/\s+/).map(function(fe){return function(me,ye){L("caret",me,ye);var ke=ye?C[x]:C[Q];return me.replace(ke,function(Ce,Re,Oe,De,Ae){var Fe;return L("caret",me,Ce,Re,Oe,De,Ae),we(Re)?Fe="":we(Oe)?Fe=">="+Re+".0.0 <"+(+Re+1)+".0.0":we(De)?Fe=Re==="0"?">="+Re+"."+Oe+".0 <"+Re+"."+(+Oe+1)+".0":">="+Re+"."+Oe+".0 <"+(+Re+1)+".0.0":Ae?(L("replaceCaret pr",Ae),Ae.charAt(0)!=="-"&&(Ae="-"+Ae),Fe=Re==="0"?Oe==="0"?">="+Re+"."+Oe+"."+De+Ae+" <"+Re+"."+Oe+"."+(+De+1):">="+Re+"."+Oe+"."+De+Ae+" <"+Re+"."+(+Oe+1)+".0":">="+Re+"."+Oe+"."+De+Ae+" <"+(+Re+1)+".0.0"):(L("no pr"),Fe=Re==="0"?Oe==="0"?">="+Re+"."+Oe+"."+De+" <"+Re+"."+Oe+"."+(+De+1):">="+Re+"."+Oe+"."+De+" <"+Re+"."+(+Oe+1)+".0":">="+Re+"."+Oe+"."+De+" <"+(+Re+1)+".0.0"),L("caret return",Fe),Fe})}(fe,re)}).join(" ")}(je,Ue),L("caret",je),je=function(Te,re){return Te.trim().split(/\s+/).map(function(fe){return function(me,ye){var ke=ye?C[z]:C[M];return me.replace(ke,function(Ce,Re,Oe,De,Ae){var Fe;return L("tilde",me,Ce,Re,Oe,De,Ae),we(Re)?Fe="":we(Oe)?Fe=">="+Re+".0.0 <"+(+Re+1)+".0.0":we(De)?Fe=">="+Re+"."+Oe+".0 <"+Re+"."+(+Oe+1)+".0":Ae?(L("replaceTilde pr",Ae),Ae.charAt(0)!=="-"&&(Ae="-"+Ae),Fe=">="+Re+"."+Oe+"."+De+Ae+" <"+Re+"."+(+Oe+1)+".0"):Fe=">="+Re+"."+Oe+"."+De+" <"+Re+"."+(+Oe+1)+".0",L("tilde return",Fe),Fe})}(fe,re)}).join(" ")}(je,Ue),L("tildes",je),je=function(Te,re){return L("replaceXRanges",Te,re),Te.split(/\s+/).map(function(fe){return function(me,ye){me=me.trim();var ke=ye?C[f]:C[$];return me.replace(ke,function(Ce,Re,Oe,De,Ae,Fe){L("xRange",me,Ce,Re,Oe,De,Ae,Fe);var Be=we(Oe),qe=Be||we(De),We=qe||we(Ae);return Re==="="&&We&&(Re=""),Be?Ce=Re===">"||Re==="<"?"<0.0.0":"*":Re&&We?(qe&&(De=0),We&&(Ae=0),Re===">"?(Re=">=",qe?(Oe=+Oe+1,De=0,Ae=0):We&&(De=+De+1,Ae=0)):Re==="<="&&(Re="<",qe?Oe=+Oe+1:De=+De+1),Ce=Re+Oe+"."+De+"."+Ae):qe?Ce=">="+Oe+".0.0 <"+(+Oe+1)+".0.0":We&&(Ce=">="+Oe+"."+De+".0 <"+Oe+"."+(+De+1)+".0"),L("xRange return",Ce),Ce})}(fe,re)}).join(" ")}(je,Ue),L("xrange",je),je=function(Te,re){return L("replaceStars",Te,re),Te.trim().replace(C[ne],"")}(je,Ue),L("stars",je),je}(ze,$e)}).join(" ").split(/\s+/);return this.loose&&(Pe=Pe.filter(function(ze){return!!ze.match(Se)})),Pe=Pe.map(function(ze){return new he(ze,$e)})},de.prototype.intersects=function(le,$e){if(!(le instanceof de))throw new TypeError("a Range is required");return this.set.some(function(be){return be.every(function(Se){return le.set.some(function(Pe){return Pe.every(function(ze){return Se.intersects(ze,$e)})})})})},e.toComparators=function(le,$e){return new de(le,$e).set.map(function(be){return be.map(function(Se){return Se.value}).join(" ").trim().split(" ")})},de.prototype.test=function(le){if(!le)return!1;typeof le=="string"&&(le=new K(le,this.loose));for(var $e=0;$e<this.set.length;$e++)if(Ie(this.set[$e],le))return!0;return!1},e.satisfies=Ne,e.maxSatisfying=function(le,$e,be){var Se=null,Pe=null;try{var ze=new de($e,be)}catch{return null}return le.forEach(function(je){ze.test(je)&&(Se&&Pe.compare(je)!==-1||(Pe=new K(Se=je,be)))}),Se},e.minSatisfying=function(le,$e,be){var Se=null,Pe=null;try{var ze=new de($e,be)}catch{return null}return le.forEach(function(je){ze.test(je)&&(Se&&Pe.compare(je)!==1||(Pe=new K(Se=je,be)))}),Se},e.validRange=function(le,$e){try{return new de(le,$e).range||"*"}catch{return null}},e.ltr=function(le,$e,be){return Me(le,$e,"<",be)},e.gtr=function(le,$e,be){return Me(le,$e,">",be)},e.outside=Me,e.prerelease=function(le,$e){var be=se(le,$e);return be&&be.prerelease.length?be.prerelease:null},e.intersects=function(le,$e,be){return le=new de(le,be),$e=new de($e,be),le.intersects($e)},e.coerce=function(le){if(le instanceof K)return le;if(typeof le!="string")return null;var $e=le.match(C[p]);return $e==null?null:se(($e[1]||"0")+"."+($e[2]||"0")+"."+($e[3]||"0"))}}).call(this,D(1))},function(ie,e){var D,A,L=ie.exports={};function j(){throw new Error("setTimeout has not been defined")}function O(){throw new Error("clearTimeout has not been defined")}function C(w){if(D===setTimeout)return setTimeout(w,0);if((D===j||!D)&&setTimeout)return D=setTimeout,setTimeout(w,0);try{return D(w,0)}catch{try{return D.call(null,w,0)}catch{return D.call(this,w,0)}}}(function(){try{D=typeof setTimeout=="function"?setTimeout:j}catch{D=j}try{A=typeof clearTimeout=="function"?clearTimeout:O}catch{A=O}})();var S,d=[],R=!1,E=-1;function b(){R&&S&&(R=!1,S.length?d=S.concat(d):E=-1,d.length&&l())}function l(){if(!R){var w=C(b);R=!0;for(var c=d.length;c;){for(S=d,d=[];++E<c;)S&&S[E].run();E=-1,c=d.length}S=null,R=!1,function(u){if(A===clearTimeout)return clearTimeout(u);if((A===O||!A)&&clearTimeout)return A=clearTimeout,clearTimeout(u);try{A(u)}catch{try{return A.call(null,u)}catch{return A.call(this,u)}}}(w)}}function g(w,c){this.fun=w,this.array=c}function y(){}L.nextTick=function(w){var c=new Array(arguments.length-1);if(arguments.length>1)for(var u=1;u<arguments.length;u++)c[u-1]=arguments[u];d.push(new g(w,c)),d.length!==1||R||C(l)},g.prototype.run=function(){this.fun.apply(null,this.array)},L.title="browser",L.browser=!0,L.env={},L.argv=[],L.version="",L.versions={},L.on=y,L.addListener=y,L.once=y,L.off=y,L.removeListener=y,L.removeAllListeners=y,L.emit=y,L.prependListener=y,L.prependOnceListener=y,L.listeners=function(w){return[]},L.binding=function(w){throw new Error("process.binding is not supported")},L.cwd=function(){return"/"},L.chdir=function(w){throw new Error("process.chdir is not supported")},L.umask=function(){return 0}}])}),define(ae[127],ce([0,1]),function(ie,e){"use strict";var D;Object.defineProperty(e,"__esModule",{value:!0}),e.$Er=void 0;class A{constructor(C,S,d){this.level=C,this.key=S,this.value=d,this.forward=[]}}const L=void 0;class j{constructor(C,S=2**16){this.comparator=C,this[D]="SkipList",this.d=0,this.f=0,this.c=Math.max(1,Math.log2(S)|0),this.e=new A(this.c,L,L)}get size(){return this.f}clear(){this.e=new A(this.c,L,L),this.f=0}has(C){return!!j.g(this,C,this.comparator)}get(C){return j.g(this,C,this.comparator)?.value}set(C,S){return j.h(this,C,S,this.comparator)&&(this.f+=1),this}delete(C){const S=j.k(this,C,this.comparator);return S&&(this.f-=1),S}forEach(C,S){let d=this.e.forward[0];for(;d;)C.call(S,d.value,d.key,this),d=d.forward[0]}[(D=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}*entries(){let C=this.e.forward[0];for(;C;)yield[C.key,C.value],C=C.forward[0]}*keys(){let C=this.e.forward[0];for(;C;)yield C.key,C=C.forward[0]}*values(){let C=this.e.forward[0];for(;C;)yield C.value,C=C.forward[0]}toString(){let C="[SkipList]:",S=this.e.forward[0];for(;S;)C+=`node(${S.key}, ${S.value}, lvl:${S.level})`,S=S.forward[0];return C}static g(C,S,d){let R=C.e;for(let E=C.d-1;E>=0;E--)for(;R.forward[E]&&d(R.forward[E].key,S)<0;)R=R.forward[E];if(R=R.forward[0],R&&d(R.key,S)===0)return R}static h(C,S,d,R){const E=[];let b=C.e;for(let l=C.d-1;l>=0;l--){for(;b.forward[l]&&R(b.forward[l].key,S)<0;)b=b.forward[l];E[l]=b}if(b=b.forward[0],b&&R(b.key,S)===0)return b.value=d,!1;{const l=j.j(C);if(l>C.d){for(let g=C.d;g<l;g++)E[g]=C.e;C.d=l}b=new A(l,S,d);for(let g=0;g<l;g++)b.forward[g]=E[g].forward[g],E[g].forward[g]=b;return!0}}static j(C,S=.5){let d=1;for(;Math.random()<S&&d<C.c;)d+=1;return d}static k(C,S,d){const R=[];let E=C.e;for(let b=C.d-1;b>=0;b--){for(;E.forward[b]&&d(E.forward[b].key,S)<0;)E=E.forward[b];R[b]=E}if(E=E.forward[0],!E||d(E.key,S)!==0)return!1;for(let b=0;b<C.d&&R[b].forward[b]===E;b++)R[b].forward[b]=E.forward[b];for(;C.d>0&&C.e.forward[C.d-1]===L;)C.d-=1;return!0}}e.$Er=j}),define(ae[62],ce([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nd=void 0;const D=globalThis.performance&&typeof globalThis.performance.now=="function";class A{static create(j){return new A(j)}constructor(j){this.c=D&&j===!1?Date.now:globalThis.performance.now.bind(globalThis.performance),this.a=this.c(),this.b=-1}stop(){this.b=this.c()}reset(){this.a=this.c(),this.b=-1}elapsed(){return this.b!==-1?this.b-this.a:this.c()-this.a}}e.$Nd=A}),define(ae[3],ce([0,1,7,85,2,87,62]),function(ie,e,D,A,L,j,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1d=e.$Zd=e.$Yd=e.$Xd=e.$Wd=e.$Vd=e.$Ud=e.$Td=e.$Sd=e.$Rd=e.$Qd=e.$Pd=e.Event=void 0;const C=!1,S=!1;var d;(function($){$.None=()=>L.$Rc.None;function f(ue){if(S){const{onDidAddListener:he}=ue,ge=g.create();let de=0;ue.onDidAddListener=()=>{++de===2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),ge.print()),he?.()}}}function p(ue,he){return Z(ue,()=>{},0,void 0,!0,void 0,he)}$.defer=p;function I(ue){return(he,ge=null,de)=>{let we=!1,ve;return ve=ue(Ie=>{if(!we)return ve?ve.dispose():we=!0,he.call(ge,Ie)},null,de),we&&ve.dispose(),ve}}$.once=I;function T(ue,he,ge){return x((de,we=null,ve)=>ue(Ie=>de.call(we,he(Ie)),null,ve),ge)}$.map=T;function M(ue,he,ge){return x((de,we=null,ve)=>ue(Ie=>{he(Ie),de.call(we,Ie)},null,ve),ge)}$.forEach=M;function z(ue,he,ge){return x((de,we=null,ve)=>ue(Ie=>he(Ie)&&de.call(we,Ie),null,ve),ge)}$.filter=z;function q(ue){return ue}$.signal=q;function Y(...ue){return(he,ge=null,de)=>{const we=(0,L.$Oc)(...ue.map(ve=>ve(Ie=>he.call(ge,Ie))));return H(we,de)}}$.any=Y;function Q(ue,he,ge,de){let we=ge;return T(ue,ve=>(we=he(we,ve),we),de)}$.reduce=Q;function x(ue,he){let ge;const de={onWillAddFirstListener(){ge=ue(we.fire,we)},onDidRemoveLastListener(){ge?.dispose()}};he||f(de);const we=new h(de);return he?.add(we),we.event}function H(ue,he){return he instanceof Array?he.push(ue):he&&he.add(ue),ue}function Z(ue,he,ge=100,de=!1,we=!1,ve,Ie){let Ne,Me,le,$e=0,be;const Se={leakWarningThreshold:ve,onWillAddFirstListener(){Ne=ue(ze=>{$e++,Me=he(Me,ze),de&&!le&&(Pe.fire(Me),Me=void 0),be=()=>{const je=Me;Me=void 0,le=void 0,(!de||$e>1)&&Pe.fire(je),$e=0},typeof ge=="number"?(clearTimeout(le),le=setTimeout(be,ge)):le===void 0&&(le=0,queueMicrotask(be))})},onWillRemoveListener(){we&&$e>0&&be?.()},onDidRemoveLastListener(){be=void 0,Ne.dispose()}};Ie||f(Se);const Pe=new h(Se);return Ie?.add(Pe),Pe.event}$.debounce=Z;function J(ue,he=0,ge){return $.debounce(ue,(de,we)=>de?(de.push(we),de):[we],he,void 0,!0,void 0,ge)}$.accumulate=J;function W(ue,he=(de,we)=>de===we,ge){let de=!0,we;return z(ue,ve=>{const Ie=de||!he(ve,we);return de=!1,we=ve,Ie},ge)}$.latch=W;function ee(ue,he,ge){return[$.filter(ue,he,ge),$.filter(ue,de=>!he(de),ge)]}$.split=ee;function ne(ue,he=!1,ge=[],de){let we=ge.slice(),ve=ue(Me=>{we?we.push(Me):Ne.fire(Me)});de&&de.add(ve);const Ie=()=>{we?.forEach(Me=>Ne.fire(Me)),we=null},Ne=new h({onWillAddFirstListener(){ve||(ve=ue(Me=>Ne.fire(Me)),de&&de.add(ve))},onDidAddFirstListener(){we&&(he?setTimeout(Ie):Ie())},onDidRemoveLastListener(){ve&&ve.dispose(),ve=null}});return de&&de.add(Ne),Ne.event}$.buffer=ne;function _(ue,he){return(de,we,ve)=>{const Ie=he(new K);return ue(function(Ne){const Me=Ie.evaluate(Ne);Me!==se&&de.call(we,Me)},void 0,ve)}}$.chain=_;const se=Symbol("HaltChainable");class K{constructor(){this.f=[]}map(he){return this.f.push(he),this}forEach(he){return this.f.push(ge=>(he(ge),ge)),this}filter(he){return this.f.push(ge=>he(ge)?ge:se),this}reduce(he,ge){let de=ge;return this.f.push(we=>(de=he(de,we),de)),this}latch(he=(ge,de)=>ge===de){let ge=!0,de;return this.f.push(we=>{const ve=ge||!he(we,de);return ge=!1,de=we,ve?we:se}),this}evaluate(he){for(const ge of this.f)if(he=ge(he),he===se)break;return he}}function U(ue,he,ge=de=>de){const de=(...Ne)=>Ie.fire(ge(...Ne)),we=()=>ue.on(he,de),ve=()=>ue.removeListener(he,de),Ie=new h({onWillAddFirstListener:we,onDidRemoveLastListener:ve});return Ie.event}$.fromNodeEventEmitter=U;function P(ue,he,ge=de=>de){const de=(...Ne)=>Ie.fire(ge(...Ne)),we=()=>ue.addEventListener(he,de),ve=()=>ue.removeEventListener(he,de),Ie=new h({onWillAddFirstListener:we,onDidRemoveLastListener:ve});return Ie.event}$.fromDOMEventEmitter=P;function F(ue){return new Promise(he=>I(ue)(he))}$.toPromise=F;function B(ue){const he=new h;return ue.then(ge=>{he.fire(ge)},()=>{he.fire(void 0)}).finally(()=>{he.dispose()}),he.event}$.fromPromise=B;function N(ue,he,ge){return he(ge),ue(de=>he(de))}$.runAndSubscribe=N;function V(ue,he){let ge=null;function de(ve){ge?.dispose(),ge=new L.$Qc,he(ve,ge)}de(void 0);const we=ue(ve=>de(ve));return(0,L.$Pc)(()=>{we.dispose(),ge?.dispose()})}$.runAndSubscribeWithStore=V;class G{constructor(he,ge){this._observable=he,this.f=0,this.g=!1;const de={onWillAddFirstListener:()=>{he.addObserver(this)},onDidRemoveLastListener:()=>{he.removeObserver(this)}};ge||f(de),this.emitter=new h(de),ge&&ge.add(this.emitter)}beginUpdate(he){this.f++}handlePossibleChange(he){}handleChange(he,ge){this.g=!0}endUpdate(he){this.f--,this.f===0&&(this._observable.reportChanges(),this.g&&(this.g=!1,this.emitter.fire(this._observable.get())))}}function te(ue,he){return new G(ue,he).emitter.event}$.fromObservable=te;function oe(ue){return he=>{let ge=0,de=!1;const we={beginUpdate(){ge++},endUpdate(){ge--,ge===0&&(ue.reportChanges(),de&&(de=!1,he()))},handlePossibleChange(){},handleChange(){de=!0}};return ue.addObserver(we),ue.reportChanges(),{dispose(){ue.removeObserver(we)}}}}$.fromObservableLight=oe})(d||(e.Event=d={}));class R{static{this.all=new Set}static{this.f=0}constructor(f){this.listenerCount=0,this.invocationCount=0,this.elapsedOverall=0,this.durations=[],this.name=`${f}_${R.f++}`,R.all.add(this)}start(f){this.g=new O.$Nd,this.listenerCount=f}stop(){if(this.g){const f=this.g.elapsed();this.durations.push(f),this.elapsedOverall+=f,this.invocationCount+=1,this.g=void 0}}}e.$Pd=R;let E=-1;function b($){const f=E;return E=$,{dispose(){E=f}}}e.$Qd=b;class l{constructor(f,p=Math.random().toString(18).slice(2,5)){this.threshold=f,this.name=p,this.g=0}dispose(){this.f?.clear()}check(f,p){const I=this.threshold;if(I<=0||p<I)return;this.f||(this.f=new Map);const T=this.f.get(f.value)||0;if(this.f.set(f.value,T+1),this.g-=1,this.g<=0){this.g=I*.5;let M,z=0;for(const[q,Y]of this.f)(!M||z<Y)&&(M=q,z=Y);console.warn(`[${this.name}] potential listener LEAK detected, having ${p} listeners already. MOST frequent listener (${z}):`),console.warn(M)}return()=>{const M=this.f.get(f.value)||0;this.f.set(f.value,M-1)}}}class g{static create(){return new g(new Error().stack??"")}constructor(f){this.value=f}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}let y=0;class w{constructor(f){this.value=f,this.id=y++}}const c=2,u=($,f)=>{if($ instanceof w)f($);else for(let p=0;p<$.length;p++){const I=$[p];I&&f(I)}};class h{constructor(f){this.w=0,this.f=f,this.g=E>0||this.f?.leakWarningThreshold?new l(this.f?.leakWarningThreshold??E):void 0,this.j=this.f?._profName?new R(this.f._profName):void 0,this.u=this.f?.deliveryQueue}dispose(){if(!this.m){if(this.m=!0,this.u?.current===this&&this.u.reset(),this.t){if(C){const f=this.t;queueMicrotask(()=>{u(f,p=>p.stack?.print())})}this.t=void 0,this.w=0}this.f?.onDidRemoveLastListener?.(),this.g?.dispose()}}get event(){return this.q??=(f,p,I)=>{if(this.g&&this.w>this.g.threshold*3)return console.warn(`[${this.g.name}] REFUSES to accept new listeners because it exceeded its threshold by far`),L.$Rc.None;if(this.m)return L.$Rc.None;p&&(f=f.bind(p));const T=new w(f);let M,z;this.g&&this.w>=Math.ceil(this.g.threshold*.2)&&(T.stack=g.create(),M=this.g.check(T.stack,this.w+1)),C&&(T.stack=z??g.create()),this.t?this.t instanceof w?(this.u??=new k,this.t=[this.t,T]):this.t.push(T):(this.f?.onWillAddFirstListener?.(this),this.t=T,this.f?.onDidAddFirstListener?.(this)),this.w++;const q=(0,L.$Pc)(()=>{M?.(),this.x(T)});return I instanceof L.$Qc?I.add(q):Array.isArray(I)&&I.push(q),q},this.q}x(f){if(this.f?.onWillRemoveListener?.(this),!this.t)return;if(this.w===1){this.t=void 0,this.f?.onDidRemoveLastListener?.(this),this.w=0;return}const p=this.t,I=p.indexOf(f);if(I===-1)throw console.log("disposed?",this.m),console.log("size?",this.w),console.log("arr?",JSON.stringify(this.t)),new Error("Attempted to dispose unknown listener");this.w--,p[I]=void 0;const T=this.u.current===this;if(this.w*c<=p.length){let M=0;for(let z=0;z<p.length;z++)p[z]?p[M++]=p[z]:T&&(this.u.end--,M<this.u.i&&this.u.i--);p.length=M}}y(f,p){if(!f)return;const I=this.f?.onListenerError||D.$Z;if(!I){f.value(p);return}try{f.value(p)}catch(T){I(T)}}z(f){const p=f.current.t;for(;f.i<f.end;)this.y(p[f.i++],f.value);f.reset()}fire(f){if(this.u?.current&&(this.z(this.u),this.j?.stop()),this.j?.start(this.w),this.t)if(this.t instanceof w)this.y(this.t,f);else{const p=this.u;p.enqueue(this,f,this.t.length),this.z(p)}this.j?.stop()}hasListeners(){return this.w>0}}e.$Rd=h;const m=()=>new k;e.$Sd=m;class k{constructor(){this.i=-1,this.end=0}enqueue(f,p,I){this.i=0,this.end=I,this.current=f,this.value=p}reset(){this.i=this.end,this.current=void 0,this.value=void 0}}class s extends h{async fireAsync(f,p,I){if(this.t)for(this.h||(this.h=new j.$2c),u(this.t,T=>this.h.push([T.value,f]));this.h.size>0&&!p.isCancellationRequested;){const[T,M]=this.h.shift(),z=[],q={...M,token:p,waitUntil:Y=>{if(Object.isFrozen(z))throw new Error("waitUntil can NOT be called asynchronous");I&&(Y=I(Y,T)),z.push(Y)}};try{T(q)}catch(Y){(0,D.$Z)(Y);continue}Object.freeze(z),await Promise.allSettled(z).then(Y=>{for(const Q of Y)Q.status==="rejected"&&(0,D.$Z)(Q.reason)})}}}e.$Td=s;class a extends h{get isPaused(){return this.h!==0}constructor(f){super(f),this.h=0,this.s=new j.$2c,this.A=f?.merge}pause(){this.h++}resume(){if(this.h!==0&&--this.h===0)if(this.A){if(this.s.size>0){const f=Array.from(this.s);this.s.clear(),super.fire(this.A(f))}}else for(;!this.h&&this.s.size!==0;)super.fire(this.s.shift())}fire(f){this.w&&(this.h!==0?this.s.push(f):super.fire(f))}}e.$Ud=a;class n extends a{constructor(f){super(f),this.k=f.delay??100}fire(f){this.o||(this.pause(),this.o=setTimeout(()=>{this.o=void 0,this.resume()},this.k)),super.fire(f)}}e.$Vd=n;class i extends h{constructor(f){super(f),this.h=[],this.k=f?.merge}fire(f){this.hasListeners()&&(this.h.push(f),this.h.length===1&&queueMicrotask(()=>{this.k?super.fire(this.k(this.h)):this.h.forEach(p=>super.fire(p)),this.h=[]}))}}e.$Wd=i;class t{constructor(){this.g=!1,this.h=[],this.f=new h({onWillAddFirstListener:()=>this.j(),onDidRemoveLastListener:()=>this.k()})}get event(){return this.f.event}add(f){const p={event:f,listener:null};this.h.push(p),this.g&&this.m(p);const I=()=>{this.g&&this.o(p);const T=this.h.indexOf(p);this.h.splice(T,1)};return(0,L.$Pc)((0,A.$cb)(I))}j(){this.g=!0,this.h.forEach(f=>this.m(f))}k(){this.g=!1,this.h.forEach(f=>this.o(f))}m(f){f.listener=f.event(p=>this.f.fire(p))}o(f){f.listener&&f.listener.dispose(),f.listener=null}dispose(){this.f.dispose()}}e.$Xd=t;class r{constructor(f,p,I,T){this.f=new L.$Qc;const M=this.f.add(new t),z=this.f.add(new L.$1c);function q(Y){z.set(Y,M.add(T(Y)))}for(const Y of f)q(Y);this.f.add(p(Y=>{q(Y)})),this.f.add(I(Y=>{z.deleteAndDispose(Y)})),this.event=M.event}dispose(){this.f.dispose()}}e.$Yd=r;class o{constructor(){this.f=[]}wrapEvent(f){return(p,I,T)=>f(M=>{const z=this.f[this.f.length-1];z?z.push(()=>p.call(I,M)):p.call(I,M)},void 0,T)}bufferEvents(f){const p=[];this.f.push(p);const I=f();return this.f.pop(),p.forEach(T=>T()),I}}e.$Zd=o;class v{constructor(){this.f=!1,this.g=d.None,this.h=L.$Rc.None,this.j=new h({onDidAddFirstListener:()=>{this.f=!0,this.h=this.g(this.j.fire,this.j)},onDidRemoveLastListener:()=>{this.f=!1,this.h.dispose()}}),this.event=this.j.event}set input(f){this.g=f,this.f&&(this.h.dispose(),this.h=f(this.j.fire,this.j))}dispose(){this.h.dispose(),this.j.dispose()}}e.$1d=v}),define(ae[26],ce([0,1,3]),function(ie,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2d=e.CancellationToken=void 0;const A=Object.freeze(function(C,S){const d=setTimeout(C.bind(S),0);return{dispose(){clearTimeout(d)}}});var L;(function(C){function S(d){return d===C.None||d===C.Cancelled||d instanceof j?!0:!d||typeof d!="object"?!1:typeof d.isCancellationRequested=="boolean"&&typeof d.onCancellationRequested=="function"}C.isCancellationToken=S,C.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:D.Event.None}),C.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:A})})(L||(e.CancellationToken=L={}));class j{constructor(){this.a=!1,this.b=null}cancel(){this.a||(this.a=!0,this.b&&(this.b.fire(void 0),this.dispose()))}get isCancellationRequested(){return this.a}get onCancellationRequested(){return this.a?A:(this.b||(this.b=new D.$Rd),this.b.event)}dispose(){this.b&&(this.b.dispose(),this.b=null)}}class O{constructor(S){this.f=void 0,this.g=void 0,this.g=S&&S.onCancellationRequested(this.cancel,this)}get token(){return this.f||(this.f=new j),this.f}cancel(){this.f?this.f instanceof j&&this.f.cancel():this.f=L.Cancelled}dispose(S=!1){S&&this.cancel(),this.g?.dispose(),this.f?this.f instanceof j&&this.f.dispose():this.f=L.None}}e.$2d=O}),define(ae[128],ce([0,1,26]),function(ie,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ce=e.$Be=e.$Ae=void 0;class A{constructor(C){this.b=C,this.a=null}get(){if(this.a)return this.a;const C=new D.$2d,S=this.b(C.token);return this.a={promise:S,dispose:()=>{this.a=null,C.cancel(),C.dispose()}},this.a}}e.$Ae=A;class L{constructor(C){this.c=C,this.a=void 0,this.b=void 0}get(C){const S=JSON.stringify(C);return this.b!==S&&(this.b=S,this.a=this.c(C)),this.a}}e.$Be=L;class j{get cachedValues(){return this.a}constructor(C){this.b=C,this.a=new Map}get(C){if(this.a.has(C))return this.a.get(C);const S=this.b(C);return this.a.set(C,S),S}}e.$Ce=j}),define(ae[46],ce([0,1,7,2]),function(ie,e,D,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ee=e.$de=e.$ce=e.$be=e.$ae=e.$_d=e.$$d=e.$0d=e.$9d=e.$8d=e.$7d=e.$6d=e.$5d=e.$4d=e.$3d=void 0;function L(m){const k=m;return k?typeof k.read=="function":!1}e.$3d=L;function j(m){const k=m;return k?[k.on,k.pause,k.resume,k.destroy].every(s=>typeof s=="function"):!1}e.$4d=j;function O(m){const k=m;return k?j(k.stream)&&Array.isArray(k.buffer)&&typeof k.ended=="boolean":!1}e.$5d=O;function C(m,k){return new S(m,k)}e.$6d=C;class S{constructor(k,s){this.e=k,this.f=s,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(k){if(!this.a.destroyed){if(this.a.flowing)this.g(k);else if(this.b.data.push(k),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(s=>this.d.push(s))}}error(k){this.a.destroyed||(this.a.flowing?this.h(k):this.b.error.push(k))}end(k){this.a.destroyed||(typeof k<"u"&&this.write(k),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(k){this.c.data.slice(0).forEach(s=>s(k))}h(k){this.c.error.length===0?(0,D.$Z)(k):this.c.error.slice(0).forEach(s=>s(k))}i(){this.c.end.slice(0).forEach(k=>k())}on(k,s){if(!this.a.destroyed)switch(k){case"data":this.c.data.push(s),this.resume();break;case"end":this.c.end.push(s),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(s),this.a.flowing&&this.k();break}}removeListener(k,s){if(this.a.destroyed)return;let a;switch(k){case"data":a=this.c.data;break;case"end":a=this.c.end;break;case"error":a=this.c.error;break}if(a){const n=a.indexOf(s);n>=0&&a.splice(n,1)}}j(){if(this.b.data.length>0){const k=this.e(this.b.data);this.g(k),this.b.data.length=0;const s=[...this.d];this.d.length=0,s.forEach(a=>a())}}k(){if(this.c.error.length>0){for(const k of this.b.error)this.h(k);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function d(m,k){const s=[];let a;for(;(a=m.read())!==null;)s.push(a);return k(s)}e.$7d=d;function R(m,k,s){const a=[];let n;for(;(n=m.read())!==null&&a.length<s;)a.push(n);return n===null&&a.length>0?k(a):{read:()=>{if(a.length>0)return a.shift();if(typeof n<"u"){const i=n;return n=void 0,i}return m.read()}}}e.$8d=R;function E(m,k){return new Promise((s,a)=>{const n=[];b(m,{onData:i=>{k&&n.push(i)},onError:i=>{k?a(i):s(void 0)},onEnd:()=>{s(k?k(n):void 0)}})})}e.$9d=E;function b(m,k,s){m.on("error",a=>{s?.isCancellationRequested||k.onError(a)}),m.on("end",()=>{s?.isCancellationRequested||k.onEnd()}),m.on("data",a=>{s?.isCancellationRequested||k.onData(a)})}e.$0d=b;function l(m,k){return new Promise((s,a)=>{const n=new A.$Qc,i=[],t=v=>{if(i.push(v),i.length>k)return n.dispose(),m.pause(),s({stream:m,buffer:i,ended:!1})},r=v=>(n.dispose(),a(v)),o=()=>(n.dispose(),s({stream:m,buffer:i,ended:!0}));n.add((0,A.$Pc)(()=>m.removeListener("error",r))),m.on("error",r),n.add((0,A.$Pc)(()=>m.removeListener("end",o))),m.on("end",o),n.add((0,A.$Pc)(()=>m.removeListener("data",t))),m.on("data",t)})}e.$$d=l;function g(m,k){const s=C(k);return s.end(m),s}e.$_d=g;function y(){const m=C(()=>{throw new Error("not supported")});return m.end(),m}e.$ae=y;function w(m){let k=!1;return{read:()=>k?null:(k=!0,m)}}e.$be=w;function c(m,k,s){const a=C(s);return b(m,{onData:n=>a.write(k.data(n)),onError:n=>a.error(k.error?k.error(n):n),onEnd:()=>a.end()}),a}e.$ce=c;function u(m,k,s){let a=!1;return{read:()=>{const n=k.read();return a?n:(a=!0,n!==null?s([m,n]):m)}}}e.$de=u;function h(m,k,s){let a=!1;const n=C(s);return b(k,{onData:i=>a?n.write(i):(a=!0,n.write(s([m,i]))),onError:i=>n.error(i),onEnd:()=>{a||(a=!0,n.write(m)),n.end()}}),n}e.$ee=h}),define(ae[15],ce([0,1,61,46]),function(ie,e,D,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ze=e.$ye=e.$xe=e.$we=e.$ve=e.$ue=e.$te=e.$se=e.$re=e.$qe=e.$pe=e.$oe=e.$ne=e.$me=e.$le=e.$ke=e.$je=e.$ie=e.$he=e.$ge=e.$fe=void 0;const L=typeof Buffer<"u",j=new D.$U(()=>new Uint8Array(256));let O,C;class S{static alloc(p){return L?new S(Buffer.allocUnsafe(p)):new S(new Uint8Array(p))}static wrap(p){return L&&!Buffer.isBuffer(p)&&(p=Buffer.from(p.buffer,p.byteOffset,p.byteLength)),new S(p)}static fromString(p,I){return!(I?.dontUseNodeBuffer||!1)&&L?new S(Buffer.from(p)):(O||(O=new TextEncoder),new S(O.encode(p)))}static fromByteArray(p){const I=S.alloc(p.length);for(let T=0,M=p.length;T<M;T++)I.buffer[T]=p[T];return I}static concat(p,I){if(typeof I>"u"){I=0;for(let z=0,q=p.length;z<q;z++)I+=p[z].byteLength}const T=S.alloc(I);let M=0;for(let z=0,q=p.length;z<q;z++){const Y=p[z];T.set(Y,M),M+=Y.byteLength}return T}constructor(p){this.buffer=p,this.byteLength=this.buffer.byteLength}clone(){const p=S.alloc(this.byteLength);return p.set(this),p}toString(){return L?this.buffer.toString():(C||(C=new TextDecoder),C.decode(this.buffer))}slice(p,I){return new S(this.buffer.subarray(p,I))}set(p,I){if(p instanceof S)this.buffer.set(p.buffer,I);else if(p instanceof Uint8Array)this.buffer.set(p,I);else if(p instanceof ArrayBuffer)this.buffer.set(new Uint8Array(p),I);else if(ArrayBuffer.isView(p))this.buffer.set(new Uint8Array(p.buffer,p.byteOffset,p.byteLength),I);else throw new Error("Unknown argument 'array'")}readUInt32BE(p){return b(this.buffer,p)}writeUInt32BE(p,I){l(this.buffer,p,I)}readUInt32LE(p){return g(this.buffer,p)}writeUInt32LE(p,I){y(this.buffer,p,I)}readUInt8(p){return w(this.buffer,p)}writeUInt8(p,I){c(this.buffer,p,I)}indexOf(p,I=0){return d(this.buffer,p instanceof S?p.buffer:p,I)}}e.$fe=S;function d(f,p,I=0){const T=p.byteLength,M=f.byteLength;if(T===0)return 0;if(T===1)return f.indexOf(p[0]);if(T>M-I)return-1;const z=j.value;z.fill(p.length);for(let x=0;x<p.length;x++)z[p[x]]=p.length-x-1;let q=I+p.length-1,Y=q,Q=-1;for(;q<M;)if(f[q]===p[Y]){if(Y===0){Q=q;break}q--,Y--}else q+=Math.max(p.length-Y,z[f[q]]),Y=p.length-1;return Q}e.$ge=d;function R(f,p){return f[p+0]<<0>>>0|f[p+1]<<8>>>0}e.$he=R;function E(f,p,I){f[I+0]=p&255,p=p>>>8,f[I+1]=p&255}e.$ie=E;function b(f,p){return f[p]*2**24+f[p+1]*2**16+f[p+2]*2**8+f[p+3]}e.$je=b;function l(f,p,I){f[I+3]=p,p=p>>>8,f[I+2]=p,p=p>>>8,f[I+1]=p,p=p>>>8,f[I]=p}e.$ke=l;function g(f,p){return f[p+0]<<0>>>0|f[p+1]<<8>>>0|f[p+2]<<16>>>0|f[p+3]<<24>>>0}e.$le=g;function y(f,p,I){f[I+0]=p&255,p=p>>>8,f[I+1]=p&255,p=p>>>8,f[I+2]=p&255,p=p>>>8,f[I+3]=p&255}e.$me=y;function w(f,p){return f[p]}e.$ne=w;function c(f,p,I){f[I]=p}e.$oe=c;function u(f){return A.$7d(f,p=>S.concat(p))}e.$pe=u;function h(f){return A.$be(f)}e.$qe=h;function m(f){return A.$9d(f,p=>S.concat(p))}e.$re=m;async function k(f){return f.ended?S.concat(f.buffer):S.concat([...f.buffer,await m(f.stream)])}e.$se=k;function s(f){return A.$_d(f,p=>S.concat(p))}e.$te=s;function a(f){return A.$ce(f,{data:p=>typeof p=="string"?S.fromString(p):S.wrap(p)},p=>S.concat(p))}e.$ue=a;function n(f){return A.$6d(p=>S.concat(p),f)}e.$ve=n;function i(f,p){return A.$de(f,p,I=>S.concat(I))}e.$we=i;function t(f,p){return A.$ee(f,p,I=>S.concat(I))}e.$xe=t;function r(f){let p=0,I=0,T=0;const M=new Uint8Array(Math.floor(f.length/4*3)),z=Y=>{switch(I){case 3:M[T++]=p|Y,I=0;break;case 2:M[T++]=p|Y>>>2,p=Y<<6,I=3;break;case 1:M[T++]=p|Y>>>4,p=Y<<4,I=2;break;default:p=Y<<2,I=1}};for(let Y=0;Y<f.length;Y++){const Q=f.charCodeAt(Y);if(Q>=65&&Q<=90)z(Q-65);else if(Q>=97&&Q<=122)z(Q-97+26);else if(Q>=48&&Q<=57)z(Q-48+52);else if(Q===43||Q===45)z(62);else if(Q===47||Q===95)z(63);else{if(Q===61)break;throw new SyntaxError(`Unexpected base64 character ${f[Y]}`)}}const q=T;for(;I>0;)z(0);return S.wrap(M).slice(0,q)}e.$ye=r;const o="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",v="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function $({buffer:f},p=!0,I=!1){const T=I?v:o;let M="";const z=f.byteLength%3;let q=0;for(;q<f.byteLength-z;q+=3){const Y=f[q+0],Q=f[q+1],x=f[q+2];M+=T[Y>>>2],M+=T[(Y<<4|Q>>>4)&63],M+=T[(Q<<2|x>>>6)&63],M+=T[x&63]}if(z===1){const Y=f[q+0];M+=T[Y>>>2],M+=T[Y<<4&63],p&&(M+="==")}else if(z===2){const Y=f[q+0],Q=f[q+1];M+=T[Y>>>2],M+=T[(Y<<4|Q>>>4)&63],M+=T[Q<<2&63],p&&(M+="=")}return M}e.$ze=$}),define(ae[27],ce([0,1,128,61]),function(ie,e,D,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bf=e.$Af=e.$zf=e.$yf=e.GraphemeBreakType=e.$xf=e.$wf=e.$vf=e.$uf=e.$tf=e.$sf=e.$rf=e.$qf=e.$pf=e.$of=e.$nf=e.$mf=e.$lf=e.$kf=e.$jf=e.$if=e.$hf=e.$gf=e.$ff=e.$ef=e.$df=e.$cf=e.$bf=e.$af=e.$_e=e.$$e=e.$0e=e.$9e=e.$8e=e.$7e=e.$6e=e.$5e=e.$4e=e.$3e=e.$2e=e.$1e=e.$Ze=e.$Ye=e.$Xe=e.$We=e.$Ve=e.$Ue=e.$Te=e.$Se=e.$Re=e.$Qe=e.$Pe=e.$Oe=e.$Ne=e.$Me=e.$Le=e.$Ke=e.$Je=e.$Ie=e.$He=e.$Ge=e.$Fe=void 0;function L(re){return!re||typeof re!="string"?!0:re.trim().length===0}e.$Fe=L;const j=/{(\d+)}/g;function O(re,...fe){return fe.length===0?re:re.replace(j,function(me,ye){const ke=parseInt(ye,10);return isNaN(ke)||ke<0||ke>=fe.length?me:fe[ke]})}e.$Ge=O;const C=/{([^}]+)}/g;function S(re,fe){return Object.keys(fe).length===0?re:re.replace(C,(me,ye)=>fe[ye]??me)}e.$He=S;function d(re){return re.replace(/[<>&]/g,function(fe){switch(fe){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return fe}})}e.$Ie=d;function R(re){return re.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}e.$Je=R;function E(re,fe){let me=0;const ye=fe.charCodeAt(0);for(let ke=re.length-1;ke>=0;ke--)re.charCodeAt(ke)===ye&&me++;return me}e.$Ke=E;function b(re,fe,me="\u2026"){return re.length<=fe?re:`${re.substr(0,fe)}${me}`}e.$Le=b;function l(re,fe=" "){const me=g(re,fe);return y(me,fe)}e.$Me=l;function g(re,fe){if(!re||!fe)return re;const me=fe.length;if(me===0||re.length===0)return re;let ye=0;for(;re.indexOf(fe,ye)===ye;)ye=ye+me;return re.substring(ye)}e.$Ne=g;function y(re,fe){if(!re||!fe)return re;const me=fe.length,ye=re.length;if(me===0||ye===0)return re;let ke=ye,Ce=-1;for(;Ce=re.lastIndexOf(fe,ke-1),!(Ce===-1||Ce+me!==ke);){if(Ce===0)return"";ke=Ce}return re.substring(0,ke)}e.$Oe=y;function w(re){return re.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}e.$Pe=w;function c(re){return re.replace(/\*/g,"")}e.$Qe=c;function u(re,fe,me={}){if(!re)throw new Error("Cannot create regex from empty string");fe||(re=R(re)),me.wholeWord&&(/\B/.test(re.charAt(0))||(re="\\b"+re),/\B/.test(re.charAt(re.length-1))||(re=re+"\\b"));let ye="";return me.global&&(ye+="g"),me.matchCase||(ye+="i"),me.multiline&&(ye+="m"),me.unicode&&(ye+="u"),new RegExp(re,ye)}e.$Re=u;function h(re){return re.source==="^"||re.source==="^$"||re.source==="$"||re.source==="^\\s*$"?!1:!!(re.exec("")&&re.lastIndex===0)}e.$Se=h;function m(re){return re.split(/\r\n|\r|\n/)}e.$Te=m;function k(re){for(let fe=0,me=re.length;fe<me;fe++){const ye=re.charCodeAt(fe);if(ye!==32&&ye!==9)return fe}return-1}e.$Ue=k;function s(re,fe=0,me=re.length){for(let ye=fe;ye<me;ye++){const ke=re.charCodeAt(ye);if(ke!==32&&ke!==9)return re.substring(fe,ye)}return re.substring(fe,me)}e.$Ve=s;function a(re,fe=re.length-1){for(let me=fe;me>=0;me--){const ye=re.charCodeAt(me);if(ye!==32&&ye!==9)return me}return-1}e.$We=a;function n(re,fe,me){const ye=[];let ke=0;for(const Ce of re.matchAll(fe)){if(ye.push(re.slice(ke,Ce.index)),Ce.index===void 0)throw new Error("match.index should be defined");ke=Ce.index+Ce[0].length,ye.push(me(Ce[0],...Ce.slice(1),Ce.index,re,Ce.groups))}return ye.push(re.slice(ke)),Promise.all(ye).then(Ce=>Ce.join(""))}e.$Xe=n;function i(re,fe){return re<fe?-1:re>fe?1:0}e.$Ye=i;function t(re,fe,me=0,ye=re.length,ke=0,Ce=fe.length){for(;me<ye&&ke<Ce;me++,ke++){const De=re.charCodeAt(me),Ae=fe.charCodeAt(ke);if(De<Ae)return-1;if(De>Ae)return 1}const Re=ye-me,Oe=Ce-ke;return Re<Oe?-1:Re>Oe?1:0}e.$Ze=t;function r(re,fe){return o(re,fe,0,re.length,0,fe.length)}e.$1e=r;function o(re,fe,me=0,ye=re.length,ke=0,Ce=fe.length){for(;me<ye&&ke<Ce;me++,ke++){let De=re.charCodeAt(me),Ae=fe.charCodeAt(ke);if(De===Ae)continue;if(De>=128||Ae>=128)return t(re.toLowerCase(),fe.toLowerCase(),me,ye,ke,Ce);$(De)&&(De-=32),$(Ae)&&(Ae-=32);const Fe=De-Ae;if(Fe!==0)return Fe}const Re=ye-me,Oe=Ce-ke;return Re<Oe?-1:Re>Oe?1:0}e.$2e=o;function v(re){return re>=48&&re<=57}e.$3e=v;function $(re){return re>=97&&re<=122}e.$4e=$;function f(re){return re>=65&&re<=90}e.$5e=f;function p(re,fe){return re.length===fe.length&&o(re,fe)===0}e.$6e=p;function I(re,fe){const me=fe.length;return fe.length>re.length?!1:o(re,fe,0,me)===0}e.$7e=I;function T(re,fe){const me=Math.min(re.length,fe.length);let ye;for(ye=0;ye<me;ye++)if(re.charCodeAt(ye)!==fe.charCodeAt(ye))return ye;return me}e.$8e=T;function M(re,fe){const me=Math.min(re.length,fe.length);let ye;const ke=re.length-1,Ce=fe.length-1;for(ye=0;ye<me;ye++)if(re.charCodeAt(ke-ye)!==fe.charCodeAt(Ce-ye))return ye;return me}e.$9e=M;function z(re){return 55296<=re&&re<=56319}e.$0e=z;function q(re){return 56320<=re&&re<=57343}e.$$e=q;function Y(re,fe){return(re-55296<<10)+(fe-56320)+65536}e.$_e=Y;function Q(re,fe,me){const ye=re.charCodeAt(me);if(z(ye)&&me+1<fe){const ke=re.charCodeAt(me+1);if(q(ke))return Y(ye,ke)}return ye}e.$af=Q;function x(re,fe){const me=re.charCodeAt(fe-1);if(q(me)&&fe>1){const ye=re.charCodeAt(fe-2);if(z(ye))return Y(ye,me)}return me}class H{get offset(){return this.e}constructor(fe,me=0){this.c=fe,this.d=fe.length,this.e=me}setOffset(fe){this.e=fe}prevCodePoint(){const fe=x(this.c,this.e);return this.e-=fe>=65536?2:1,fe}nextCodePoint(){const fe=Q(this.c,this.d,this.e);return this.e+=fe>=65536?2:1,fe}eol(){return this.e>=this.d}}e.$bf=H;class Z{get offset(){return this.c.offset}constructor(fe,me=0){this.c=new H(fe,me)}nextGraphemeLength(){const fe=$e.getInstance(),me=this.c,ye=me.offset;let ke=fe.getGraphemeBreakType(me.nextCodePoint());for(;!me.eol();){const Ce=me.offset,Re=fe.getGraphemeBreakType(me.nextCodePoint());if(Me(ke,Re)){me.setOffset(Ce);break}ke=Re}return me.offset-ye}prevGraphemeLength(){const fe=$e.getInstance(),me=this.c,ye=me.offset;let ke=fe.getGraphemeBreakType(me.prevCodePoint());for(;me.offset>0;){const Ce=me.offset,Re=fe.getGraphemeBreakType(me.prevCodePoint());if(Me(Re,ke)){me.setOffset(Ce);break}ke=Re}return ye-me.offset}eol(){return this.c.eol()}}e.$cf=Z;function J(re,fe){return new Z(re,fe).nextGraphemeLength()}e.$df=J;function W(re,fe){return new Z(re,fe).prevGraphemeLength()}e.$ef=W;function ee(re,fe){fe>0&&q(re.charCodeAt(fe))&&fe--;const me=fe+J(re,fe);return[me-W(re,me),me]}e.$ff=ee;function ne(re){const fe=new Z(re);let me=0;for(;!fe.eol();)me++,fe.nextGraphemeLength();return me}e.$gf=ne;let _;function se(){return/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/}function K(re){return _||(_=se()),_.test(re)}e.$hf=K;const U=/^[\t\n\r\x20-\x7E]*$/;function P(re){return U.test(re)}e.$if=P,e.$jf=/[\u2028\u2029]/;function F(re){return e.$jf.test(re)}e.$kf=F;function B(re){return re>=11904&&re<=55215||re>=63744&&re<=64255||re>=65281&&re<=65374}e.$lf=B;function N(re){return re>=127462&&re<=127487||re===8986||re===8987||re===9200||re===9203||re>=9728&&re<=10175||re===11088||re===11093||re>=127744&&re<=128591||re>=128640&&re<=128764||re>=128992&&re<=129008||re>=129280&&re<=129535||re>=129648&&re<=129782}e.$mf=N;function V(re,fe){if(re.length<fe)return re;const me=/\b/g;let ye=0;for(;me.test(re)&&!(re.length-me.lastIndex<fe);)ye=me.lastIndex,me.lastIndex+=1;return re.substring(ye).replace(/^\s/,"")}e.$nf=V;const G=/(:?\x1b\[|\x9B)[=?>!]?[\d;:]*["$#'* ]?[a-zA-Z@^`{}|~]/g,te=/\x1b\].*?\x07/g;function oe(re){return re&&(re=re.replace(G,"").replace(te,"")),re}e.$of=oe,e.$pf=String.fromCharCode(65279);function ue(re){return!!(re&&re.length>0&&re.charCodeAt(0)===65279)}e.$qf=ue;function he(re){return ue(re)?re.substr(1):re}e.$rf=he;function ge(re,fe){if(!re||!fe||re.length<fe.length)return!1;const me=fe.length,ye=re.toLowerCase();let ke=0,Ce=-1;for(;ke<me;){const Re=ye.indexOf(fe[ke],Ce+1);if(Re<0)return!1;Ce=Re,ke++}return!0}e.$sf=ge;function de(re,fe=!1){return re?(fe&&(re=re.replace(/\\./g,"")),re.toLowerCase()!==re):!1}e.$tf=de;function we(re){return re.charAt(0).toUpperCase()+re.slice(1)}e.$uf=we;function ve(re,fe=1){if(fe===0)return"";let me=-1;do me=re.indexOf(`
`,me+1),fe--;while(fe>0&&me>=0);return me===-1?re:(re[me-1]==="\r"&&me--,re.substr(0,me))}e.$vf=ve;function Ie(re){return re=re%(2*26),re<26?String.fromCharCode(97+re):String.fromCharCode(65+re-26)}e.$wf=Ie;function Ne(re){return $e.getInstance().getGraphemeBreakType(re)}e.$xf=Ne;function Me(re,fe){return re===0?fe!==5&&fe!==7:re===2&&fe===3?!1:re===4||re===2||re===3||fe===4||fe===2||fe===3?!0:!(re===8&&(fe===8||fe===9||fe===11||fe===12)||(re===11||re===9)&&(fe===9||fe===10)||(re===12||re===10)&&fe===10||fe===5||fe===13||fe===7||re===1||re===13&&fe===14||re===6&&fe===6)}var le;(function(re){re[re.Other=0]="Other",re[re.Prepend=1]="Prepend",re[re.CR=2]="CR",re[re.LF=3]="LF",re[re.Control=4]="Control",re[re.Extend=5]="Extend",re[re.Regional_Indicator=6]="Regional_Indicator",re[re.SpacingMark=7]="SpacingMark",re[re.L=8]="L",re[re.V=9]="V",re[re.T=10]="T",re[re.LV=11]="LV",re[re.LVT=12]="LVT",re[re.ZWJ=13]="ZWJ",re[re.Extended_Pictographic=14]="Extended_Pictographic"})(le||(e.GraphemeBreakType=le={}));class $e{static{this.c=null}static getInstance(){return $e.c||($e.c=new $e),$e.c}constructor(){this.d=be()}getGraphemeBreakType(fe){if(fe<32)return fe===10?3:fe===13?2:4;if(fe<127)return 0;const me=this.d,ye=me.length/3;let ke=1;for(;ke<=ye;)if(fe<me[3*ke])ke=2*ke;else if(fe>me[3*ke+1])ke=2*ke+1;else return me[3*ke+2];return 0}}function be(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function Se(re,fe){if(re===0)return 0;const me=Pe(re,fe);if(me!==void 0)return me;const ye=new H(fe,re);return ye.prevCodePoint(),ye.offset}e.$yf=Se;function Pe(re,fe){const me=new H(fe,re);let ye=me.prevCodePoint();for(;ze(ye)||ye===65039||ye===8419;){if(me.offset===0)return;ye=me.prevCodePoint()}if(!N(ye))return;let ke=me.offset;return ke>0&&me.prevCodePoint()===8205&&(ke=me.offset),ke}function ze(re){return 127995<=re&&re<=127999}var je;(function(re){re[re.zwj=8205]="zwj",re[re.emojiVariantSelector=65039]="emojiVariantSelector",re[re.enclosingKeyCap=8419]="enclosingKeyCap"})(je||(je={})),e.$zf="\xA0";class Ue{static{this.c=new A.$U(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125,119846,109],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}'))}static{this.d=new D.$Be(fe=>{function me(Fe){const Be=new Map;for(let qe=0;qe<Fe.length;qe+=2)Be.set(Fe[qe],Fe[qe+1]);return Be}function ye(Fe,Be){const qe=new Map(Fe);for(const[We,_e]of Be)qe.set(We,_e);return qe}function ke(Fe,Be){if(!Fe)return Be;const qe=new Map;for(const[We,_e]of Fe)Be.has(We)&&qe.set(We,_e);return qe}const Ce=this.c.value;let Re=fe.filter(Fe=>!Fe.startsWith("_")&&Fe in Ce);Re.length===0&&(Re=["_default"]);let Oe;for(const Fe of Re){const Be=me(Ce[Fe]);Oe=ke(Oe,Be)}const De=me(Ce._common),Ae=ye(De,Oe);return new Ue(Ae)})}static getInstance(fe){return Ue.d.get(Array.from(fe))}static{this.e=new A.$U(()=>Object.keys(Ue.c.value).filter(fe=>!fe.startsWith("_")))}static getLocales(){return Ue.e.value}constructor(fe){this.f=fe}isAmbiguous(fe){return this.f.has(fe)}getPrimaryConfusable(fe){return this.f.get(fe)}getConfusableCodePoints(){return new Set(this.f.keys())}}e.$Af=Ue;class Te{static c(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static{this.d=void 0}static e(){return this.d||(this.d=new Set(Te.c())),this.d}static isInvisibleCharacter(fe){return Te.e().has(fe)}static get codePoints(){return Te.e()}}e.$Bf=Te}),define(ae[52],ce([0,1,27]),function(ie,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pi=e.$Oi=e.$Ni=e.$Mi=e.$Li=e.$Ki=e.$Ji=void 0;function A(c){return L(c,0)}e.$Ji=A;function L(c,u){switch(typeof c){case"object":return c===null?j(349,u):Array.isArray(c)?S(c,u):d(c,u);case"string":return C(c,u);case"boolean":return O(c,u);case"number":return j(c,u);case"undefined":return j(937,u);default:return j(617,u)}}e.$Ki=L;function j(c,u){return(u<<5)-u+c|0}e.$Li=j;function O(c,u){return j(c?433:863,u)}function C(c,u){u=j(149417,u);for(let h=0,m=c.length;h<m;h++)u=j(c.charCodeAt(h),u);return u}e.$Mi=C;function S(c,u){return u=j(104579,u),c.reduce((h,m)=>L(m,h),u)}function d(c,u){return u=j(181387,u),Object.keys(c).sort().reduce((h,m)=>(h=C(m,h),L(c[m],h)),u)}class R{constructor(){this.g=0}get value(){return this.g}hash(u){return this.g=L(u,this.g),this.g}}e.$Ni=R;var E;(function(c){c[c.BLOCK_SIZE=64]="BLOCK_SIZE",c[c.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(E||(E={}));function b(c,u,h=32){const m=h-u,k=~((1<<m)-1);return(c<<u|(k&c)>>>m)>>>0}function l(c,u=0,h=c.byteLength,m=0){for(let k=0;k<h;k++)c[u+k]=m}function g(c,u,h="0"){for(;c.length<u;)c=h+c;return c}function y(c,u=32){return c instanceof ArrayBuffer?Array.from(new Uint8Array(c)).map(h=>h.toString(16).padStart(2,"0")).join(""):g((c>>>0).toString(16),u/4)}e.$Oi=y;class w{static{this.g=new DataView(new ArrayBuffer(320))}constructor(){this.h=1732584193,this.l=4023233417,this.m=2562383102,this.n=271733878,this.o=3285377520,this.p=new Uint8Array(64+3),this.q=new DataView(this.p.buffer),this.r=0,this.t=0,this.u=0,this.v=!1}update(u){const h=u.length;if(h===0)return;const m=this.p;let k=this.r,s=this.u,a,n;for(s!==0?(a=s,n=-1,s=0):(a=u.charCodeAt(0),n=0);;){let i=a;if(D.$0e(a))if(n+1<h){const t=u.charCodeAt(n+1);D.$$e(t)?(n++,i=D.$_e(a,t)):i=65533}else{s=a;break}else D.$$e(a)&&(i=65533);if(k=this.w(m,k,i),n++,n<h)a=u.charCodeAt(n);else break}this.r=k,this.u=s}w(u,h,m){return m<128?u[h++]=m:m<2048?(u[h++]=192|(m&1984)>>>6,u[h++]=128|(m&63)>>>0):m<65536?(u[h++]=224|(m&61440)>>>12,u[h++]=128|(m&4032)>>>6,u[h++]=128|(m&63)>>>0):(u[h++]=240|(m&1835008)>>>18,u[h++]=128|(m&258048)>>>12,u[h++]=128|(m&4032)>>>6,u[h++]=128|(m&63)>>>0),h>=64&&(this.y(),h-=64,this.t+=64,u[0]=u[64+0],u[1]=u[64+1],u[2]=u[64+2]),h}digest(){return this.v||(this.v=!0,this.u&&(this.u=0,this.r=this.w(this.p,this.r,65533)),this.t+=this.r,this.x()),y(this.h)+y(this.l)+y(this.m)+y(this.n)+y(this.o)}x(){this.p[this.r++]=128,l(this.p,this.r),this.r>56&&(this.y(),l(this.p));const u=8*this.t;this.q.setUint32(56,Math.floor(u/4294967296),!1),this.q.setUint32(60,u%4294967296,!1),this.y()}y(){const u=w.g,h=this.q;for(let o=0;o<64;o+=4)u.setUint32(o,h.getUint32(o,!1),!1);for(let o=64;o<320;o+=4)u.setUint32(o,b(u.getUint32(o-12,!1)^u.getUint32(o-32,!1)^u.getUint32(o-56,!1)^u.getUint32(o-64,!1),1),!1);let m=this.h,k=this.l,s=this.m,a=this.n,n=this.o,i,t,r;for(let o=0;o<80;o++)o<20?(i=k&s|~k&a,t=1518500249):o<40?(i=k^s^a,t=1859775393):o<60?(i=k&s|k&a|s&a,t=2400959708):(i=k^s^a,t=3395469782),r=b(m,5)+i+n+t+u.getUint32(o*4,!1)&4294967295,n=a,a=s,s=b(k,30),k=m,m=r;this.h=this.h+m&4294967295,this.l=this.l+k&4294967295,this.m=this.m+s&4294967295,this.n=this.n+a&4294967295,this.o=this.o+n&4294967295}}e.$Pi=w}),define(ae[89],ce([0,1,27]),function(ie,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var A;(function(L){L[L.Ignore=0]="Ignore",L[L.Info=1]="Info",L[L.Warning=2]="Warning",L[L.Error=3]="Error"})(A||(A={})),function(L){const j="error",O="warning",C="warn",S="info",d="ignore";function R(b){return b?D.$6e(j,b)?L.Error:D.$6e(O,b)||D.$6e(C,b)?L.Warning:D.$6e(S,b)?L.Info:L.Ignore:L.Ignore}L.fromValue=R;function E(b){switch(b){case L.Error:return j;case L.Warning:return O;case L.Info:return S;default:return d}}L.toString=E}(A||(A={})),e.default=A}),define(ae[129],ce([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Od=void 0,e.$Od=Symbol("MicrotaskDelay")}),define(ae[47],ce([0,1,18,27]),function(ie,e,D,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2h=e.$1h=e.$Zh=e.$Yh=e.$Xh=void 0;class L{constructor(){this.b="",this.c=0}reset(l){return this.b=l,this.c=0,this}next(){return this.c+=1,this}hasNext(){return this.c<this.b.length-1}cmp(l){const g=l.charCodeAt(0),y=this.b.charCodeAt(this.c);return g-y}value(){return this.b[this.c]}}e.$Xh=L;class j{constructor(l=!0){this.e=l}reset(l){return this.b=l,this.c=0,this.d=0,this.next()}hasNext(){return this.d<this.b.length}next(){this.c=this.d;let l=!0;for(;this.d<this.b.length;this.d++)if(this.b.charCodeAt(this.d)===46)if(l)this.c++;else break;else l=!1;return this}cmp(l){return this.e?(0,A.$Ze)(l,this.b,0,l.length,this.c,this.d):(0,A.$2e)(l,this.b,0,l.length,this.c,this.d)}value(){return this.b.substring(this.c,this.d)}}e.$Yh=j;class O{constructor(l=!0,g=!0){this.f=l,this.g=g}reset(l){this.d=0,this.e=0,this.b=l,this.c=l.length;for(let g=l.length-1;g>=0;g--,this.c--){const y=this.b.charCodeAt(g);if(!(y===47||this.f&&y===92))break}return this.next()}hasNext(){return this.e<this.c}next(){this.d=this.e;let l=!0;for(;this.e<this.c;this.e++){const g=this.b.charCodeAt(this.e);if(g===47||this.f&&g===92)if(l)this.d++;else break;else l=!1}return this}cmp(l){return this.g?(0,A.$Ze)(l,this.b,0,l.length,this.d,this.e):(0,A.$2e)(l,this.b,0,l.length,this.d,this.e)}value(){return this.b.substring(this.d,this.e)}}e.$Zh=O;var C;(function(b){b[b.Scheme=1]="Scheme",b[b.Authority=2]="Authority",b[b.Path=3]="Path",b[b.Query=4]="Query",b[b.Fragment=5]="Fragment"})(C||(C={}));class S{constructor(l,g){this.f=l,this.g=g,this.d=[],this.e=0}reset(l){return this.c=l,this.d=[],this.c.scheme&&this.d.push(1),this.c.authority&&this.d.push(2),this.c.path&&(this.b=new O(!1,!this.f(l)),this.b.reset(l.path),this.b.value()&&this.d.push(3)),this.g(l)||(this.c.query&&this.d.push(4),this.c.fragment&&this.d.push(5)),this.e=0,this}next(){return this.d[this.e]===3&&this.b.hasNext()?this.b.next():this.e+=1,this}hasNext(){return this.d[this.e]===3&&this.b.hasNext()||this.e<this.d.length-1}cmp(l){if(this.d[this.e]===1)return(0,A.$1e)(l,this.c.scheme);if(this.d[this.e]===2)return(0,A.$1e)(l,this.c.authority);if(this.d[this.e]===3)return this.b.cmp(l);if(this.d[this.e]===4)return(0,A.$Ye)(l,this.c.query);if(this.d[this.e]===5)return(0,A.$Ye)(l,this.c.fragment);throw new Error}value(){if(this.d[this.e]===1)return this.c.scheme;if(this.d[this.e]===2)return this.c.authority;if(this.d[this.e]===3)return this.b.value();if(this.d[this.e]===4)return this.c.query;if(this.d[this.e]===5)return this.c.fragment;throw new Error}}e.$1h=S;class d{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const l=this.right;return this.right=l.left,l.left=this,this.updateHeight(),l.updateHeight(),l}rotateRight(){const l=this.left;return this.left=l.right,l.right=this,this.updateHeight(),l.updateHeight(),l}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var R;(function(b){b[b.Left=-1]="Left",b[b.Mid=0]="Mid",b[b.Right=1]="Right"})(R||(R={}));class E{static forUris(l=()=>!1,g=()=>!1){return new E(new S(l,g))}static forPaths(l=!1){return new E(new O(void 0,!l))}static forStrings(){return new E(new L)}static forConfigKeys(){return new E(new j)}constructor(l){this.b=l}clear(){this.c=void 0}fill(l,g){if(g){const y=g.slice(0);(0,D.$Wb)(y);for(const w of y)this.set(w,l)}else{const y=l.slice(0);(0,D.$Wb)(y);for(const w of y)this.set(w[0],w[1])}}set(l,g){const y=this.b.reset(l);let w;this.c||(this.c=new d,this.c.segment=y.value());const c=[];for(w=this.c;;){const h=y.cmp(w.segment);if(h>0)w.left||(w.left=new d,w.left.segment=y.value()),c.push([-1,w]),w=w.left;else if(h<0)w.right||(w.right=new d,w.right.segment=y.value()),c.push([1,w]),w=w.right;else if(y.hasNext())y.next(),w.mid||(w.mid=new d,w.mid.segment=y.value()),c.push([0,w]),w=w.mid;else break}const u=w.value;w.value=g,w.key=l;for(let h=c.length-1;h>=0;h--){const m=c[h][1];m.updateHeight();const k=m.balanceFactor();if(k<-1||k>1){const s=c[h][0],a=c[h+1][0];if(s===1&&a===1)c[h][1]=m.rotateLeft();else if(s===-1&&a===-1)c[h][1]=m.rotateRight();else if(s===1&&a===-1)m.right=c[h+1][1]=c[h+1][1].rotateRight(),c[h][1]=m.rotateLeft();else if(s===-1&&a===1)m.left=c[h+1][1]=c[h+1][1].rotateLeft(),c[h][1]=m.rotateRight();else throw new Error;if(h>0)switch(c[h-1][0]){case-1:c[h-1][1].left=c[h][1];break;case 1:c[h-1][1].right=c[h][1];break;case 0:c[h-1][1].mid=c[h][1];break}else this.c=c[0][1]}}return u}get(l){return this.d(l)?.value}d(l){const g=this.b.reset(l);let y=this.c;for(;y;){const w=g.cmp(y.segment);if(w>0)y=y.left;else if(w<0)y=y.right;else if(g.hasNext())g.next(),y=y.mid;else break}return y}has(l){const g=this.d(l);return!(g?.value===void 0&&g?.mid===void 0)}delete(l){return this.e(l,!1)}deleteSuperstr(l){return this.e(l,!0)}e(l,g){const y=this.b.reset(l),w=[];let c=this.c;for(;c;){const u=y.cmp(c.segment);if(u>0)w.push([-1,c]),c=c.left;else if(u<0)w.push([1,c]),c=c.right;else if(y.hasNext())y.next(),w.push([0,c]),c=c.mid;else break}if(c){if(g?(c.left=void 0,c.mid=void 0,c.right=void 0,c.height=1):(c.key=void 0,c.value=void 0),!c.mid&&!c.value)if(c.left&&c.right){const u=this.f(c.right);if(u.key){const{key:h,value:m,segment:k}=u;this.e(u.key,!1),c.key=h,c.value=m,c.segment=k}}else{const u=c.left??c.right;if(w.length>0){const[h,m]=w[w.length-1];switch(h){case-1:m.left=u;break;case 0:m.mid=u;break;case 1:m.right=u;break}}else this.c=u}for(let u=w.length-1;u>=0;u--){const h=w[u][1];h.updateHeight();const m=h.balanceFactor();if(m>1?(h.right.balanceFactor()>=0||(h.right=h.right.rotateRight()),w[u][1]=h.rotateLeft()):m<-1&&(h.left.balanceFactor()<=0||(h.left=h.left.rotateLeft()),w[u][1]=h.rotateRight()),u>0)switch(w[u-1][0]){case-1:w[u-1][1].left=w[u][1];break;case 1:w[u-1][1].right=w[u][1];break;case 0:w[u-1][1].mid=w[u][1];break}else this.c=w[0][1]}}}f(l){for(;l.left;)l=l.left;return l}findSubstr(l){const g=this.b.reset(l);let y=this.c,w;for(;y;){const c=g.cmp(y.segment);if(c>0)y=y.left;else if(c<0)y=y.right;else if(g.hasNext())g.next(),w=y.value||w,y=y.mid;else break}return y&&y.value||w}findSuperstr(l){return this.g(l,!1)}g(l,g){const y=this.b.reset(l);let w=this.c;for(;w;){const c=y.cmp(w.segment);if(c>0)w=w.left;else if(c<0)w=w.right;else if(y.hasNext())y.next(),w=w.mid;else return w.mid?this.h(w.mid):g?w.value:void 0}}hasElementOrSubtree(l){return this.g(l,!0)!==void 0}forEach(l){for(const[g,y]of this)l(y,g)}*[Symbol.iterator](){yield*this.h(this.c)}h(l){const g=[];return this.j(l,g),g[Symbol.iterator]()}j(l,g){l&&(l.left&&this.j(l.left,g),l.value&&g.push([l.key,l.value]),l.mid&&this.j(l.mid,g),l.right&&this.j(l.right,g))}_isBalanced(){const l=g=>{if(!g)return!0;const y=g.balanceFactor();return y<-1||y>1?!1:l(g.left)&&l(g.right)};return l(this.c)}}e.$2h=E}),define(ae[12],ce([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tf=e.$Sf=e.$Rf=e.$Qf=e.$Pf=e.$Of=e.$Nf=e.$Mf=e.$Lf=e.$Kf=e.$Jf=e.$If=e.$Hf=e.$Gf=e.$Ff=e.$Ef=e.$Df=e.$Cf=void 0;function D(k){return typeof k=="string"}e.$Cf=D;function A(k){return Array.isArray(k)&&k.every(s=>D(s))}e.$Df=A;function L(k){return typeof k=="object"&&k!==null&&!Array.isArray(k)&&!(k instanceof RegExp)&&!(k instanceof Date)}e.$Ef=L;function j(k){const s=Object.getPrototypeOf(Uint8Array);return typeof k=="object"&&k instanceof s}e.$Ff=j;function O(k){return typeof k=="number"&&!isNaN(k)}e.$Gf=O;function C(k){return!!k&&typeof k[Symbol.iterator]=="function"}e.$Hf=C;function S(k){return k===!0||k===!1}e.$If=S;function d(k){return typeof k>"u"}e.$Jf=d;function R(k){return!E(k)}e.$Kf=R;function E(k){return d(k)||k===null}e.$Lf=E;function b(k,s){if(!k)throw new Error(s?`Unexpected type, expected '${s}'`:"Unexpected type")}e.$Mf=b;function l(k){if(E(k))throw new Error("Assertion Failed: argument is undefined or null");return k}e.$Nf=l;function g(...k){const s=[];for(let a=0;a<k.length;a++){const n=k[a];if(E(n))throw new Error(`Assertion Failed: argument at index ${a} is undefined or null`);s.push(n)}return s}e.$Of=g;const y=Object.prototype.hasOwnProperty;function w(k){if(!L(k))return!1;for(const s in k)if(y.call(k,s))return!1;return!0}e.$Pf=w;function c(k){return typeof k=="function"}e.$Qf=c;function u(...k){return k.length>0&&k.every(c)}e.$Rf=u;function h(k,s){const a=Math.min(k.length,s.length);for(let n=0;n<a;n++)m(k[n],s[n])}e.$Sf=h;function m(k,s){if(D(s)){if(typeof k!==s)throw new Error(`argument does not match constraint: typeof ${s}`)}else if(c(s)){try{if(k instanceof s)return}catch{}if(!E(k)&&k.constructor===s||s.length===1&&s.call(void 0,k)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}e.$Tf=m}),define(ae[30],ce([0,1,12]),function(ie,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ln=e.$kn=e.$jn=e.$in=e.$hn=e.$gn=e.$fn=e.$en=e.$dn=e.$cn=e.$bn=e.$an=void 0;function A(c){if(!c||typeof c!="object"||c instanceof RegExp)return c;const u=Array.isArray(c)?[]:{};return Object.entries(c).forEach(([h,m])=>{u[h]=m&&typeof m=="object"?A(m):m}),u}e.$an=A;function L(c){if(!c||typeof c!="object")return c;const u=[c];for(;u.length>0;){const h=u.shift();Object.freeze(h);for(const m in h)if(j.call(h,m)){const k=h[m];typeof k=="object"&&!Object.isFrozen(k)&&!(0,D.$Ff)(k)&&u.push(k)}}return c}e.$bn=L;const j=Object.prototype.hasOwnProperty;function O(c,u){return C(c,u,new Set)}e.$cn=O;function C(c,u,h){if((0,D.$Lf)(c))return c;const m=u(c);if(typeof m<"u")return m;if(Array.isArray(c)){const k=[];for(const s of c)k.push(C(s,u,h));return k}if((0,D.$Ef)(c)){if(h.has(c))throw new Error("Cannot clone recursive data-structure");h.add(c);const k={};for(const s in c)j.call(c,s)&&(k[s]=C(c[s],u,h));return h.delete(c),k}return c}function S(c,u,h=!0){return(0,D.$Ef)(c)?((0,D.$Ef)(u)&&Object.keys(u).forEach(m=>{m in c?h&&((0,D.$Ef)(c[m])&&(0,D.$Ef)(u[m])?S(c[m],u[m],h):c[m]=u[m]):c[m]=u[m]}),c):u}e.$dn=S;function d(c,u){if(c===u)return!0;if(c==null||u===null||u===void 0||typeof c!=typeof u||typeof c!="object"||Array.isArray(c)!==Array.isArray(u))return!1;let h,m;if(Array.isArray(c)){if(c.length!==u.length)return!1;for(h=0;h<c.length;h++)if(!d(c[h],u[h]))return!1}else{const k=[];for(m in c)k.push(m);k.sort();const s=[];for(m in u)s.push(m);if(s.sort(),!d(k,s))return!1;for(h=0;h<k.length;h++)if(!d(c[k[h]],u[k[h]]))return!1}return!0}e.$en=d;function R(c){const u=new Set;return JSON.stringify(c,(h,m)=>{if((0,D.$Ef)(m)||Array.isArray(m)){if(u.has(m))return"[Circular]";u.add(m)}return m})}e.$fn=R;function E(c,u){const h=Object.create(null);return!c||!u||Object.keys(u).forEach(k=>{const s=c[k],a=u[k];d(s,a)||(h[k]=a)}),h}e.$gn=E;function b(c,u){const h=u.toLowerCase(),m=Object.keys(c).find(k=>k.toLowerCase()===h);return m?c[m]:c[u]}e.$hn=b;function l(c,u){const h=Object.create(null);for(const[m,k]of Object.entries(c))u(m,k)&&(h[m]=k);return h}e.$in=l;function g(c){let u=[];for(;Object.prototype!==c;)u=u.concat(Object.getOwnPropertyNames(c)),c=Object.getPrototypeOf(c);return u}e.$jn=g;function y(c){const u=[];for(const h of g(c))typeof c[h]=="function"&&u.push(h);return u}e.$kn=y;function w(c,u){const h=k=>function(){const s=Array.prototype.slice.call(arguments,0);return u(k,s)},m={};for(const k of c)m[k]=h(k);return m}e.$ln=w}),define(ae[32],ce([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ig=e.$hg=void 0;const D=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function A(L){return D.test(L)}e.$hg=A,e.$ig=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let L;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?L=crypto.getRandomValues.bind(crypto):L=function(C){for(let S=0;S<C.length;S++)C[S]=Math.floor(Math.random()*256);return C};const j=new Uint8Array(16),O=[];for(let C=0;C<256;C++)O.push(C.toString(16).padStart(2,"0"));return function(){L(j),j[6]=j[6]&15|64,j[8]=j[8]&63|128;let S=0,d="";return d+=O[j[S++]],d+=O[j[S++]],d+=O[j[S++]],d+=O[j[S++]],d+="-",d+=O[j[S++]],d+=O[j[S++]],d+="-",d+=O[j[S++]],d+=O[j[S++]],d+="-",d+=O[j[S++]],d+=O[j[S++]],d+="-",d+=O[j[S++]],d+=O[j[S++]],d+=O[j[S++]],d+=O[j[S++]],d+=O[j[S++]],d+=O[j[S++]],d}}()}),define(ae[130],ce([0,1,36]),function(ie,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wm=void 0;const A=new Set(["00:00:00:00:00:00","ff:ff:ff:ff:ff:ff","ac:de:48:00:11:22"]);function L(O){const C=O.replace(/\-/g,":").toLowerCase();return!A.has(C)}function j(){const O=(0,D.networkInterfaces)();for(const C in O){const S=O[C];if(S){for(const{mac:d}of S)if(L(d))return d}}throw new Error("Unable to retrieve mac address (unexpected format)")}e.$Wm=j}),define(ae[131],ce([0,1,267,15]),function(ie,e,D,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$QT=void 0;class L extends D.Transform{constructor(O){if(super(),typeof O=="number")this.b=O,this.c=1;else{const C=Buffer.isBuffer(O)?O:Buffer.from(O);this.b=C.length===1?C[0]:C,this.c=C.length}}_transform(O,C,S){this.a?this.a=Buffer.concat([this.a,O]):this.a=O;let d=0;for(;d<this.a.length;){const R=typeof this.b=="number"?this.a.indexOf(this.b,d):(0,A.$ge)(this.a,this.b,d);if(R===-1)break;this.push(this.a.slice(d,R+this.c)),d=R+this.c}this.a=d===this.a.length?void 0:this.a.slice(d),S()}_flush(O){this.a&&this.push(this.a),O()}}e.$QT=L}),define(ae[132],ce([0,1,63]),function(ie,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mg=e.$lg=e.$kg=void 0;function A(C,S,d,R=1){let E=!1;return new Promise(b=>{const l=setTimeout(()=>{if(!E)return E=!0,b(0)},d);L(C,S,R,g=>{if(!E)return E=!0,clearTimeout(l),b(g)})})}e.$kg=A;function L(C,S,d,R){if(S===0)return R(0);const E=new D.Socket;E.once("connect",()=>(O(E),L(C+d,S-1,d,R))),E.once("data",()=>{}),E.once("error",b=>(O(E),b.code!=="ECONNREFUSED"?L(C+d,S-1,d,R):R(C))),E.connect(C,"127.0.0.1")}e.$lg={1:!0,7:!0,9:!0,11:!0,13:!0,15:!0,17:!0,19:!0,20:!0,21:!0,22:!0,23:!0,25:!0,37:!0,42:!0,43:!0,53:!0,69:!0,77:!0,79:!0,87:!0,95:!0,101:!0,102:!0,103:!0,104:!0,109:!0,110:!0,111:!0,113:!0,115:!0,117:!0,119:!0,123:!0,135:!0,137:!0,139:!0,143:!0,161:!0,179:!0,389:!0,427:!0,465:!0,512:!0,513:!0,514:!0,515:!0,526:!0,530:!0,531:!0,532:!0,540:!0,548:!0,554:!0,556:!0,563:!0,587:!0,601:!0,636:!0,989:!0,990:!0,993:!0,995:!0,1719:!0,1720:!0,1723:!0,2049:!0,3659:!0,4045:!0,5060:!0,5061:!0,6e3:!0,6566:!0,6665:!0,6666:!0,6667:!0,6668:!0,6669:!0,6697:!0,10080:!0};function j(C,S,d,R="127.0.0.1"){let E=!1,b,l=1;const g=D.createServer({pauseOnConnect:!0});function y(w,c){E||(E=!0,g.removeAllListeners(),g.close(),b&&clearTimeout(b),c(w))}return new Promise(w=>{b=setTimeout(()=>{y(0,w)},d),g.on("listening",()=>{y(C,w)}),g.on("error",c=>{c&&(c.code==="EADDRINUSE"||c.code==="EACCES")&&l<S?(C++,l++,g.listen(C,R)):y(0,w)}),g.on("close",()=>{y(0,w)}),g.listen(C,R)})}e.$mg=j;function O(C){try{C.removeAllListeners("connect"),C.removeAllListeners("error"),C.end(),C.destroy(),C.unref()}catch(S){console.error(S)}}}),define(ae[133],ce([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7T=void 0;function D(A){return!!A.parentPort}e.$7T=D}),define(ae[134],ce([13,9]),function(ie,e){return ie.create("vs/base/common/date",e)}),define(ae[64],ce([0,1,134]),function(ie,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$km=e.$jm=void 0;const A=60,L=A*60,j=L*24,O=j*7,C=j*30,S=j*365;function d(E,b,l,g){typeof E!="number"&&(E=E.getTime());const y=Math.round((new Date().getTime()-E)/1e3);if(y<-30)return(0,D.localize)(0,null,d(new Date().getTime()+y*1e3,!1));if(!g&&y<30)return(0,D.localize)(1,null);let w;return y<A?(w=y,b?w===1?l?(0,D.localize)(2,null,w):(0,D.localize)(3,null,w):l?(0,D.localize)(4,null,w):(0,D.localize)(5,null,w):w===1?l?(0,D.localize)(6,null,w):(0,D.localize)(7,null,w):l?(0,D.localize)(8,null,w):(0,D.localize)(9,null,w)):y<L?(w=Math.floor(y/A),b?w===1?l?(0,D.localize)(10,null,w):(0,D.localize)(11,null,w):l?(0,D.localize)(12,null,w):(0,D.localize)(13,null,w):w===1?l?(0,D.localize)(14,null,w):(0,D.localize)(15,null,w):l?(0,D.localize)(16,null,w):(0,D.localize)(17,null,w)):y<j?(w=Math.floor(y/L),b?w===1?l?(0,D.localize)(18,null,w):(0,D.localize)(19,null,w):l?(0,D.localize)(20,null,w):(0,D.localize)(21,null,w):w===1?l?(0,D.localize)(22,null,w):(0,D.localize)(23,null,w):l?(0,D.localize)(24,null,w):(0,D.localize)(25,null,w)):y<O?(w=Math.floor(y/j),b?w===1?(0,D.localize)(26,null,w):(0,D.localize)(27,null,w):w===1?(0,D.localize)(28,null,w):(0,D.localize)(29,null,w)):y<C?(w=Math.floor(y/O),b?w===1?l?(0,D.localize)(30,null,w):(0,D.localize)(31,null,w):l?(0,D.localize)(32,null,w):(0,D.localize)(33,null,w):w===1?l?(0,D.localize)(34,null,w):(0,D.localize)(35,null,w):l?(0,D.localize)(36,null,w):(0,D.localize)(37,null,w)):y<S?(w=Math.floor(y/C),b?w===1?l?(0,D.localize)(38,null,w):(0,D.localize)(39,null,w):l?(0,D.localize)(40,null,w):(0,D.localize)(41,null,w):w===1?l?(0,D.localize)(42,null,w):(0,D.localize)(43,null,w):l?(0,D.localize)(44,null,w):(0,D.localize)(45,null,w)):(w=Math.floor(y/S),b?w===1?l?(0,D.localize)(46,null,w):(0,D.localize)(47,null,w):l?(0,D.localize)(48,null,w):(0,D.localize)(49,null,w):w===1?l?(0,D.localize)(50,null,w):(0,D.localize)(51,null,w):l?(0,D.localize)(52,null,w):(0,D.localize)(53,null,w))}e.$jm=d;function R(E){return E.getFullYear()+"-"+String(E.getMonth()+1).padStart(2,"0")+"-"+String(E.getDate()).padStart(2,"0")+"T"+String(E.getHours()).padStart(2,"0")+":"+String(E.getMinutes()).padStart(2,"0")+":"+String(E.getSeconds()).padStart(2,"0")+"."+(E.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.$km=R}),define(ae[135],ce([13,9]),function(ie,e){return ie.create("vs/base/common/errorMessage",e)}),define(ae[38],ce([0,1,18,12,135]),function(ie,e,D,A,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ii=e.$Hi=e.$Gi=void 0;function j(E,b){return b&&(E.stack||E.stacktrace)?L.localize(0,null,C(E),O(E.stack)||O(E.stacktrace)):C(E)}function O(E){return Array.isArray(E)?E.join(`
`):E}function C(E){return E.code==="ERR_UNC_HOST_NOT_ALLOWED"?`${E.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`:typeof E.code=="string"&&typeof E.errno=="number"&&typeof E.syscall=="string"?L.localize(1,null,E.message):E.message||L.localize(2,null)}function S(E=null,b=!1){if(!E)return L.localize(3,null);if(Array.isArray(E)){const l=D.$Gb(E),g=S(l[0],b);return l.length>1?L.localize(4,null,g,l.length):g}if(A.$Cf(E))return E;if(E.detail){const l=E.detail;if(l.error)return j(l.error,b);if(l.exception)return j(l.exception,b)}return E.stack?j(E,b):E.message?E.message:L.localize(5,null)}e.$Gi=S;function d(E){const b=E;return b instanceof Error&&Array.isArray(b.actions)}e.$Hi=d;function R(E,b){let l;return typeof E=="string"?l=new Error(E):l=E,l.actions=b,l}e.$Ii=R}),define(ae[136],ce([13,9]),function(ie,e){return ie.create("vs/base/common/jsonErrorMessages",e)}),define(ae[137],ce([0,1,136]),function(ie,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Cp=void 0;function A(L){switch(L){case 1:return(0,D.localize)(0,null);case 2:return(0,D.localize)(1,null);case 3:return(0,D.localize)(2,null);case 4:return(0,D.localize)(3,null);case 5:return(0,D.localize)(4,null);case 6:return(0,D.localize)(5,null);case 7:return(0,D.localize)(6,null);case 8:return(0,D.localize)(7,null);case 9:return(0,D.localize)(8,null);default:return""}}e.$Cp=A}),define(ae[138],ce([13,9]),function(ie,e){return ie.create("vs/base/common/platform",e)}),define(ae[5],ce([0,1,138]),function(ie,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$I=e.$H=e.$G=e.$F=e.$E=e.$D=e.OS=e.OperatingSystem=e.$B=e.$A=e.$z=e.$y=e.$x=e.Language=e.$w=e.$v=e.$u=e.$t=e.$s=e.$r=e.$q=e.$p=e.$o=e.$n=e.$m=e.$l=e.$k=e.$j=e.$i=e.$h=e.Platform=e.$g=void 0,e.$g="en";let A=!1,L=!1,j=!1,O=!1,C=!1,S=!1,d=!1,R=!1,E=!1,b=!1,l,g=e.$g,y=e.$g,w,c;const u=globalThis;let h;typeof u.vscode<"u"&&typeof u.vscode.process<"u"?h=u.vscode.process:typeof process<"u"&&(h=process);const m=typeof h?.versions?.electron=="string",k=m&&h?.type==="renderer";if(typeof navigator=="object"&&!k)c=navigator.userAgent,A=c.indexOf("Windows")>=0,L=c.indexOf("Macintosh")>=0,R=(c.indexOf("Macintosh")>=0||c.indexOf("iPad")>=0||c.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,j=c.indexOf("Linux")>=0,b=c?.indexOf("Mobi")>=0,S=!0,l=D.getConfiguredDefaultLocale(D.localize(0,null))||e.$g,g=l,y=navigator.language;else if(typeof h=="object"){A=h.platform==="win32",L=h.platform==="darwin",j=h.platform==="linux",O=j&&!!h.env.SNAP&&!!h.env.SNAP_REVISION,d=m,E=!!h.env.CI||!!h.env.BUILD_ARTIFACTSTAGINGDIRECTORY,l=e.$g,g=e.$g;const $=h.env.VSCODE_NLS_CONFIG;if($)try{const f=JSON.parse($),p=f.availableLanguages["*"];l=f.locale,y=f.osLocale,g=p||e.$g,w=f._translationsConfigFile}catch{}C=!0}else console.error("Unable to resolve platform.");var s;(function($){$[$.Web=0]="Web",$[$.Mac=1]="Mac",$[$.Linux=2]="Linux",$[$.Windows=3]="Windows"})(s||(e.Platform=s={}));function a($){switch($){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}e.$h=a;let n=0;L?n=1:A?n=3:j&&(n=2),e.$i=A,e.$j=L,e.$k=j,e.$l=O,e.$m=C,e.$n=d,e.$o=S,e.$p=S&&typeof u.importScripts=="function",e.$q=e.$p?u.origin:void 0,e.$r=R,e.$s=b,e.$t=E,e.$u=n,e.$v=c,e.$w=g;var i;(function($){function f(){return e.$w}$.value=f;function p(){return e.$w.length===2?e.$w==="en":e.$w.length>=3?e.$w[0]==="e"&&e.$w[1]==="n"&&e.$w[2]==="-":!1}$.isDefaultVariant=p;function I(){return e.$w==="en"}$.isDefault=I})(i||(e.Language=i={})),e.$x=l,e.$y=y,e.$z=w,e.$A=typeof u.postMessage=="function"&&!u.importScripts,e.$B=(()=>{if(e.$A){const $=[];u.addEventListener("message",p=>{if(p.data&&p.data.vscodeScheduleAsyncWork)for(let I=0,T=$.length;I<T;I++){const M=$[I];if(M.id===p.data.vscodeScheduleAsyncWork){$.splice(I,1),M.callback();return}}});let f=0;return p=>{const I=++f;$.push({id:I,callback:p}),u.postMessage({vscodeScheduleAsyncWork:I},"*")}}return $=>setTimeout($)})();var t;(function($){$[$.Windows=1]="Windows",$[$.Macintosh=2]="Macintosh",$[$.Linux=3]="Linux"})(t||(e.OperatingSystem=t={})),e.OS=L||R?2:A?1:3;let r=!0,o=!1;function v(){if(!o){o=!0;const $=new Uint8Array(2);$[0]=1,$[1]=2,r=new Uint16Array($.buffer)[0]===(2<<8)+1}return r}e.$D=v,e.$E=!!(e.$v&&e.$v.indexOf("Chrome")>=0),e.$F=!!(e.$v&&e.$v.indexOf("Firefox")>=0),e.$G=!!(!e.$E&&e.$v&&e.$v.indexOf("Safari")>=0),e.$H=!!(e.$v&&e.$v.indexOf("Edg/")>=0),e.$I=!!(e.$v&&e.$v.indexOf("Android")>=0)}),define(ae[37],ce([0,1,5]),function(ie,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dc=e.$cc=e.env=e.cwd=void 0;let A;const L=globalThis.vscode;if(typeof L<"u"&&typeof L.process<"u"){const j=L.process;A={get platform(){return j.platform},get arch(){return j.arch},get env(){return j.env},cwd(){return j.cwd()}}}else typeof process<"u"?A={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:A={get platform(){return D.$i?"win32":D.$j?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};e.cwd=A.cwd,e.env=A.env,e.$cc=A.platform,e.$dc=A.arch}),define(ae[16],ce([0,1,37]),function(ie,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sc=e.sep=e.$qc=e.$pc=e.$oc=e.$nc=e.$mc=e.$lc=e.$kc=e.$jc=e.$ic=e.$hc=e.$gc=e.$fc=e.$ec=void 0;const A=65,L=97,j=90,O=122,C=46,S=47,d=92,R=58,E=63;class b extends Error{constructor(a,n,i){let t;typeof n=="string"&&n.indexOf("not ")===0?(t="must not be",n=n.replace(/^not /,"")):t="must be";const r=a.indexOf(".")!==-1?"property":"argument";let o=`The "${a}" ${r} ${t} of type ${n}`;o+=`. Received type ${typeof i}`,super(o),this.code="ERR_INVALID_ARG_TYPE"}}function l(s,a){if(s===null||typeof s!="object")throw new b(a,"Object",s)}function g(s,a){if(typeof s!="string")throw new b(a,"string",s)}const y=D.$cc==="win32";function w(s){return s===S||s===d}function c(s){return s===S}function u(s){return s>=A&&s<=j||s>=L&&s<=O}function h(s,a,n,i){let t="",r=0,o=-1,v=0,$=0;for(let f=0;f<=s.length;++f){if(f<s.length)$=s.charCodeAt(f);else{if(i($))break;$=S}if(i($)){if(!(o===f-1||v===1))if(v===2){if(t.length<2||r!==2||t.charCodeAt(t.length-1)!==C||t.charCodeAt(t.length-2)!==C){if(t.length>2){const p=t.lastIndexOf(n);p===-1?(t="",r=0):(t=t.slice(0,p),r=t.length-1-t.lastIndexOf(n)),o=f,v=0;continue}else if(t.length!==0){t="",r=0,o=f,v=0;continue}}a&&(t+=t.length>0?`${n}..`:"..",r=2)}else t.length>0?t+=`${n}${s.slice(o+1,f)}`:t=s.slice(o+1,f),r=f-o-1;o=f,v=0}else $===C&&v!==-1?++v:v=-1}return t}function m(s,a){l(a,"pathObject");const n=a.dir||a.root,i=a.base||`${a.name||""}${a.ext||""}`;return n?n===a.root?`${n}${i}`:`${n}${s}${i}`:i}e.$ec={resolve(...s){let a="",n="",i=!1;for(let t=s.length-1;t>=-1;t--){let r;if(t>=0){if(r=s[t],g(r,"path"),r.length===0)continue}else a.length===0?r=D.cwd():(r=D.env[`=${a}`]||D.cwd(),(r===void 0||r.slice(0,2).toLowerCase()!==a.toLowerCase()&&r.charCodeAt(2)===d)&&(r=`${a}\\`));const o=r.length;let v=0,$="",f=!1;const p=r.charCodeAt(0);if(o===1)w(p)&&(v=1,f=!0);else if(w(p))if(f=!0,w(r.charCodeAt(1))){let I=2,T=I;for(;I<o&&!w(r.charCodeAt(I));)I++;if(I<o&&I!==T){const M=r.slice(T,I);for(T=I;I<o&&w(r.charCodeAt(I));)I++;if(I<o&&I!==T){for(T=I;I<o&&!w(r.charCodeAt(I));)I++;(I===o||I!==T)&&($=`\\\\${M}\\${r.slice(T,I)}`,v=I)}}}else v=1;else u(p)&&r.charCodeAt(1)===R&&($=r.slice(0,2),v=2,o>2&&w(r.charCodeAt(2))&&(f=!0,v=3));if($.length>0)if(a.length>0){if($.toLowerCase()!==a.toLowerCase())continue}else a=$;if(i){if(a.length>0)break}else if(n=`${r.slice(v)}\\${n}`,i=f,f&&a.length>0)break}return n=h(n,!i,"\\",w),i?`${a}\\${n}`:`${a}${n}`||"."},normalize(s){g(s,"path");const a=s.length;if(a===0)return".";let n=0,i,t=!1;const r=s.charCodeAt(0);if(a===1)return c(r)?"\\":s;if(w(r))if(t=!0,w(s.charCodeAt(1))){let v=2,$=v;for(;v<a&&!w(s.charCodeAt(v));)v++;if(v<a&&v!==$){const f=s.slice($,v);for($=v;v<a&&w(s.charCodeAt(v));)v++;if(v<a&&v!==$){for($=v;v<a&&!w(s.charCodeAt(v));)v++;if(v===a)return`\\\\${f}\\${s.slice($)}\\`;v!==$&&(i=`\\\\${f}\\${s.slice($,v)}`,n=v)}}}else n=1;else u(r)&&s.charCodeAt(1)===R&&(i=s.slice(0,2),n=2,a>2&&w(s.charCodeAt(2))&&(t=!0,n=3));let o=n<a?h(s.slice(n),!t,"\\",w):"";return o.length===0&&!t&&(o="."),o.length>0&&w(s.charCodeAt(a-1))&&(o+="\\"),i===void 0?t?`\\${o}`:o:t?`${i}\\${o}`:`${i}${o}`},isAbsolute(s){g(s,"path");const a=s.length;if(a===0)return!1;const n=s.charCodeAt(0);return w(n)||a>2&&u(n)&&s.charCodeAt(1)===R&&w(s.charCodeAt(2))},join(...s){if(s.length===0)return".";let a,n;for(let r=0;r<s.length;++r){const o=s[r];g(o,"path"),o.length>0&&(a===void 0?a=n=o:a+=`\\${o}`)}if(a===void 0)return".";let i=!0,t=0;if(typeof n=="string"&&w(n.charCodeAt(0))){++t;const r=n.length;r>1&&w(n.charCodeAt(1))&&(++t,r>2&&(w(n.charCodeAt(2))?++t:i=!1))}if(i){for(;t<a.length&&w(a.charCodeAt(t));)t++;t>=2&&(a=`\\${a.slice(t)}`)}return e.$ec.normalize(a)},relative(s,a){if(g(s,"from"),g(a,"to"),s===a)return"";const n=e.$ec.resolve(s),i=e.$ec.resolve(a);if(n===i||(s=n.toLowerCase(),a=i.toLowerCase(),s===a))return"";let t=0;for(;t<s.length&&s.charCodeAt(t)===d;)t++;let r=s.length;for(;r-1>t&&s.charCodeAt(r-1)===d;)r--;const o=r-t;let v=0;for(;v<a.length&&a.charCodeAt(v)===d;)v++;let $=a.length;for(;$-1>v&&a.charCodeAt($-1)===d;)$--;const f=$-v,p=o<f?o:f;let I=-1,T=0;for(;T<p;T++){const z=s.charCodeAt(t+T);if(z!==a.charCodeAt(v+T))break;z===d&&(I=T)}if(T!==p){if(I===-1)return i}else{if(f>p){if(a.charCodeAt(v+T)===d)return i.slice(v+T+1);if(T===2)return i.slice(v+T)}o>p&&(s.charCodeAt(t+T)===d?I=T:T===2&&(I=3)),I===-1&&(I=0)}let M="";for(T=t+I+1;T<=r;++T)(T===r||s.charCodeAt(T)===d)&&(M+=M.length===0?"..":"\\..");return v+=I,M.length>0?`${M}${i.slice(v,$)}`:(i.charCodeAt(v)===d&&++v,i.slice(v,$))},toNamespacedPath(s){if(typeof s!="string"||s.length===0)return s;const a=e.$ec.resolve(s);if(a.length<=2)return s;if(a.charCodeAt(0)===d){if(a.charCodeAt(1)===d){const n=a.charCodeAt(2);if(n!==E&&n!==C)return`\\\\?\\UNC\\${a.slice(2)}`}}else if(u(a.charCodeAt(0))&&a.charCodeAt(1)===R&&a.charCodeAt(2)===d)return`\\\\?\\${a}`;return s},dirname(s){g(s,"path");const a=s.length;if(a===0)return".";let n=-1,i=0;const t=s.charCodeAt(0);if(a===1)return w(t)?s:".";if(w(t)){if(n=i=1,w(s.charCodeAt(1))){let v=2,$=v;for(;v<a&&!w(s.charCodeAt(v));)v++;if(v<a&&v!==$){for($=v;v<a&&w(s.charCodeAt(v));)v++;if(v<a&&v!==$){for($=v;v<a&&!w(s.charCodeAt(v));)v++;if(v===a)return s;v!==$&&(n=i=v+1)}}}}else u(t)&&s.charCodeAt(1)===R&&(n=a>2&&w(s.charCodeAt(2))?3:2,i=n);let r=-1,o=!0;for(let v=a-1;v>=i;--v)if(w(s.charCodeAt(v))){if(!o){r=v;break}}else o=!1;if(r===-1){if(n===-1)return".";r=n}return s.slice(0,r)},basename(s,a){a!==void 0&&g(a,"ext"),g(s,"path");let n=0,i=-1,t=!0,r;if(s.length>=2&&u(s.charCodeAt(0))&&s.charCodeAt(1)===R&&(n=2),a!==void 0&&a.length>0&&a.length<=s.length){if(a===s)return"";let o=a.length-1,v=-1;for(r=s.length-1;r>=n;--r){const $=s.charCodeAt(r);if(w($)){if(!t){n=r+1;break}}else v===-1&&(t=!1,v=r+1),o>=0&&($===a.charCodeAt(o)?--o===-1&&(i=r):(o=-1,i=v))}return n===i?i=v:i===-1&&(i=s.length),s.slice(n,i)}for(r=s.length-1;r>=n;--r)if(w(s.charCodeAt(r))){if(!t){n=r+1;break}}else i===-1&&(t=!1,i=r+1);return i===-1?"":s.slice(n,i)},extname(s){g(s,"path");let a=0,n=-1,i=0,t=-1,r=!0,o=0;s.length>=2&&s.charCodeAt(1)===R&&u(s.charCodeAt(0))&&(a=i=2);for(let v=s.length-1;v>=a;--v){const $=s.charCodeAt(v);if(w($)){if(!r){i=v+1;break}continue}t===-1&&(r=!1,t=v+1),$===C?n===-1?n=v:o!==1&&(o=1):n!==-1&&(o=-1)}return n===-1||t===-1||o===0||o===1&&n===t-1&&n===i+1?"":s.slice(n,t)},format:m.bind(null,"\\"),parse(s){g(s,"path");const a={root:"",dir:"",base:"",ext:"",name:""};if(s.length===0)return a;const n=s.length;let i=0,t=s.charCodeAt(0);if(n===1)return w(t)?(a.root=a.dir=s,a):(a.base=a.name=s,a);if(w(t)){if(i=1,w(s.charCodeAt(1))){let I=2,T=I;for(;I<n&&!w(s.charCodeAt(I));)I++;if(I<n&&I!==T){for(T=I;I<n&&w(s.charCodeAt(I));)I++;if(I<n&&I!==T){for(T=I;I<n&&!w(s.charCodeAt(I));)I++;I===n?i=I:I!==T&&(i=I+1)}}}}else if(u(t)&&s.charCodeAt(1)===R){if(n<=2)return a.root=a.dir=s,a;if(i=2,w(s.charCodeAt(2))){if(n===3)return a.root=a.dir=s,a;i=3}}i>0&&(a.root=s.slice(0,i));let r=-1,o=i,v=-1,$=!0,f=s.length-1,p=0;for(;f>=i;--f){if(t=s.charCodeAt(f),w(t)){if(!$){o=f+1;break}continue}v===-1&&($=!1,v=f+1),t===C?r===-1?r=f:p!==1&&(p=1):r!==-1&&(p=-1)}return v!==-1&&(r===-1||p===0||p===1&&r===v-1&&r===o+1?a.base=a.name=s.slice(o,v):(a.name=s.slice(o,r),a.base=s.slice(o,v),a.ext=s.slice(r,v))),o>0&&o!==i?a.dir=s.slice(0,o-1):a.dir=a.root,a},sep:"\\",delimiter:";",win32:null,posix:null};const k=(()=>{if(y){const s=/\\/g;return()=>{const a=D.cwd().replace(s,"/");return a.slice(a.indexOf("/"))}}return()=>D.cwd()})();e.$fc={resolve(...s){let a="",n=!1;for(let i=s.length-1;i>=-1&&!n;i--){const t=i>=0?s[i]:k();g(t,"path"),t.length!==0&&(a=`${t}/${a}`,n=t.charCodeAt(0)===S)}return a=h(a,!n,"/",c),n?`/${a}`:a.length>0?a:"."},normalize(s){if(g(s,"path"),s.length===0)return".";const a=s.charCodeAt(0)===S,n=s.charCodeAt(s.length-1)===S;return s=h(s,!a,"/",c),s.length===0?a?"/":n?"./":".":(n&&(s+="/"),a?`/${s}`:s)},isAbsolute(s){return g(s,"path"),s.length>0&&s.charCodeAt(0)===S},join(...s){if(s.length===0)return".";let a;for(let n=0;n<s.length;++n){const i=s[n];g(i,"path"),i.length>0&&(a===void 0?a=i:a+=`/${i}`)}return a===void 0?".":e.$fc.normalize(a)},relative(s,a){if(g(s,"from"),g(a,"to"),s===a||(s=e.$fc.resolve(s),a=e.$fc.resolve(a),s===a))return"";const n=1,i=s.length,t=i-n,r=1,o=a.length-r,v=t<o?t:o;let $=-1,f=0;for(;f<v;f++){const I=s.charCodeAt(n+f);if(I!==a.charCodeAt(r+f))break;I===S&&($=f)}if(f===v)if(o>v){if(a.charCodeAt(r+f)===S)return a.slice(r+f+1);if(f===0)return a.slice(r+f)}else t>v&&(s.charCodeAt(n+f)===S?$=f:f===0&&($=0));let p="";for(f=n+$+1;f<=i;++f)(f===i||s.charCodeAt(f)===S)&&(p+=p.length===0?"..":"/..");return`${p}${a.slice(r+$)}`},toNamespacedPath(s){return s},dirname(s){if(g(s,"path"),s.length===0)return".";const a=s.charCodeAt(0)===S;let n=-1,i=!0;for(let t=s.length-1;t>=1;--t)if(s.charCodeAt(t)===S){if(!i){n=t;break}}else i=!1;return n===-1?a?"/":".":a&&n===1?"//":s.slice(0,n)},basename(s,a){a!==void 0&&g(a,"ext"),g(s,"path");let n=0,i=-1,t=!0,r;if(a!==void 0&&a.length>0&&a.length<=s.length){if(a===s)return"";let o=a.length-1,v=-1;for(r=s.length-1;r>=0;--r){const $=s.charCodeAt(r);if($===S){if(!t){n=r+1;break}}else v===-1&&(t=!1,v=r+1),o>=0&&($===a.charCodeAt(o)?--o===-1&&(i=r):(o=-1,i=v))}return n===i?i=v:i===-1&&(i=s.length),s.slice(n,i)}for(r=s.length-1;r>=0;--r)if(s.charCodeAt(r)===S){if(!t){n=r+1;break}}else i===-1&&(t=!1,i=r+1);return i===-1?"":s.slice(n,i)},extname(s){g(s,"path");let a=-1,n=0,i=-1,t=!0,r=0;for(let o=s.length-1;o>=0;--o){const v=s.charCodeAt(o);if(v===S){if(!t){n=o+1;break}continue}i===-1&&(t=!1,i=o+1),v===C?a===-1?a=o:r!==1&&(r=1):a!==-1&&(r=-1)}return a===-1||i===-1||r===0||r===1&&a===i-1&&a===n+1?"":s.slice(a,i)},format:m.bind(null,"/"),parse(s){g(s,"path");const a={root:"",dir:"",base:"",ext:"",name:""};if(s.length===0)return a;const n=s.charCodeAt(0)===S;let i;n?(a.root="/",i=1):i=0;let t=-1,r=0,o=-1,v=!0,$=s.length-1,f=0;for(;$>=i;--$){const p=s.charCodeAt($);if(p===S){if(!v){r=$+1;break}continue}o===-1&&(v=!1,o=$+1),p===C?t===-1?t=$:f!==1&&(f=1):t!==-1&&(f=-1)}if(o!==-1){const p=r===0&&n?1:r;t===-1||f===0||f===1&&t===o-1&&t===r+1?a.base=a.name=s.slice(p,o):(a.name=s.slice(p,t),a.base=s.slice(p,o),a.ext=s.slice(t,o))}return r>0?a.dir=s.slice(0,r-1):n&&(a.dir="/"),a},sep:"/",delimiter:":",win32:null,posix:null},e.$fc.win32=e.$ec.win32=e.$ec,e.$fc.posix=e.$ec.posix=e.$fc,e.$gc=y?e.$ec.normalize:e.$fc.normalize,e.$hc=y?e.$ec.isAbsolute:e.$fc.isAbsolute,e.$ic=y?e.$ec.join:e.$fc.join,e.$jc=y?e.$ec.resolve:e.$fc.resolve,e.$kc=y?e.$ec.relative:e.$fc.relative,e.$lc=y?e.$ec.dirname:e.$fc.dirname,e.$mc=y?e.$ec.basename:e.$fc.basename,e.$nc=y?e.$ec.extname:e.$fc.extname,e.$oc=y?e.$ec.format:e.$fc.format,e.$pc=y?e.$ec.parse:e.$fc.parse,e.$qc=y?e.$ec.toNamespacedPath:e.$fc.toNamespacedPath,e.sep=y?e.$ec.sep:e.$fc.sep,e.$sc=y?e.$ec.delimiter:e.$fc.delimiter}),define(ae[48],ce([0,1,16,5,27,12]),function(ie,e,D,A,L,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0f=e.$9f=e.$8f=e.$7f=e.$6f=e.$5f=e.$4f=e.$3f=e.$2f=e.$1f=e.$Zf=e.$Yf=e.$Xf=e.$Wf=e.$Vf=e.$Uf=void 0;function O(r){return r===47||r===92}e.$Uf=O;function C(r){return r.replace(/[\\/]/g,D.$fc.sep)}e.$Vf=C;function S(r){return r.indexOf("/")===-1&&(r=C(r)),/^[a-zA-Z]:(\/|$)/.test(r)&&(r="/"+r),r}e.$Wf=S;function d(r,o=D.$fc.sep){if(!r)return"";const v=r.length,$=r.charCodeAt(0);if(O($)){if(O(r.charCodeAt(1))&&!O(r.charCodeAt(2))){let p=3;const I=p;for(;p<v&&!O(r.charCodeAt(p));p++);if(I!==p&&!O(r.charCodeAt(p+1))){for(p+=1;p<v;p++)if(O(r.charCodeAt(p)))return r.slice(0,p+1).replace(/[\\/]/g,o)}}return o}else if(c($)&&r.charCodeAt(1)===58)return O(r.charCodeAt(2))?r.slice(0,2)+o:r.slice(0,2);let f=r.indexOf("://");if(f!==-1){for(f+=3;f<v;f++)if(O(r.charCodeAt(f)))return r.slice(0,f+1)}return""}e.$Xf=d;function R(r){if(!A.$i||!r||r.length<5)return!1;let o=r.charCodeAt(0);if(o!==92||(o=r.charCodeAt(1),o!==92))return!1;let v=2;const $=v;for(;v<r.length&&(o=r.charCodeAt(v),o!==92);v++);return!($===v||(o=r.charCodeAt(v+1),isNaN(o)||o===92))}e.$Yf=R;const E=/[\\/:\*\?"<>\|]/g,b=/[\\/]/g,l=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function g(r,o=A.$i){const v=o?E:b;return!(!r||r.length===0||/^\s+$/.test(r)||(v.lastIndex=0,v.test(r))||o&&l.test(r)||r==="."||r===".."||o&&r[r.length-1]==="."||o&&r.length!==r.trim().length||r.length>255)}e.$Zf=g;function y(r,o,v){const $=r===o;return!v||$?$:!r||!o?!1:(0,L.$6e)(r,o)}e.$1f=y;function w(r,o,v,$=D.sep){if(r===o)return!0;if(!r||!o||o.length>r.length)return!1;if(v){if(!(0,L.$7e)(r,o))return!1;if(o.length===r.length)return!0;let p=o.length;return o.charAt(o.length-1)===$&&p--,r.charAt(p)===$}return o.charAt(o.length-1)!==$&&(o+=$),r.indexOf(o)===0}e.$2f=w;function c(r){return r>=65&&r<=90||r>=97&&r<=122}e.$3f=c;function u(r,o){return A.$i&&r.endsWith(":")&&(r+=D.sep),(0,D.$hc)(r)||(r=(0,D.$ic)(o,r)),r=(0,D.$gc)(r),A.$i?(r=(0,L.$Oe)(r,D.sep),r.endsWith(":")&&(r+=D.sep)):(r=(0,L.$Oe)(r,D.sep),r||(r=D.sep)),r}e.$4f=u;function h(r){const o=(0,D.$gc)(r);return A.$i?r.length>3?!1:m(o)&&(r.length===2||o.charCodeAt(2)===92):o===D.$fc.sep}e.$5f=h;function m(r,o=A.$i){return o?c(r.charCodeAt(0))&&r.charCodeAt(1)===58:!1}e.$6f=m;function k(r,o=A.$i){return m(r,o)?r[0]:void 0}e.$7f=k;function s(r,o,v){return o.length>r.length?-1:r===o?0:(v&&(r=r.toLowerCase(),o=o.toLowerCase()),r.indexOf(o))}e.$8f=s;function a(r){const o=r.split(":");let v,$,f;for(const p of o){const I=Number(p);(0,j.$Gf)(I)?$===void 0?$=I:f===void 0&&(f=I):v=v?[v,p].join(":"):p}if(!v)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:v,line:$!==void 0?$:void 0,column:f!==void 0?f:$!==void 0?1:void 0}}e.$9f=a;const n="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789",i="BDEFGHIJKMOQRSTUVWXYZbdefghijkmoqrstuvwxyz0123456789";function t(r,o,v=8){let $="";for(let p=0;p<v;p++){let I;p===0&&A.$i&&!o&&(v===3||v===4)?I=i:I=n,$+=I.charAt(Math.floor(Math.random()*I.length))}let f;return o?f=`${o}-${$}`:f=$,r?(0,D.$ic)(r,f):f}e.$0f=t}),define(ae[139],ce([0,1,16]),function(ie,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zr=e.$Yr=e.$Xr=e.$Wr=e.$Vr=void 0,e.$Vr=Object.freeze({text:"text/plain",binary:"application/octet-stream",unknown:"application/unknown",markdown:"text/markdown",latex:"text/latex",uriList:"text/uri-list"});const A={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},L={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function j(R){const E=(0,D.$nc)(R),b=A[E.toLowerCase()];return b!==void 0?b:O(R)}e.$Wr=j;function O(R){const E=(0,D.$nc)(R);return L[E.toLowerCase()]}e.$Xr=O;function C(R){for(const E in L)if(L[E]===R)return E}e.$Yr=C;const S=/^(.+)\/(.+?)(;.+)?$/;function d(R,E){const b=S.exec(R);return b?`${b[1].toLowerCase()}/${b[2].toLowerCase()}${b[3]??""}`:E?void 0:R}e.$Zr=d}),define(ae[90],ce([0,1,5]),function(ie,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gl=e.$Fl=e.TerminateResponseCode=e.Source=void 0;var A;(function(C){C[C.stdout=0]="stdout",C[C.stderr=1]="stderr"})(A||(e.Source=A={}));var L;(function(C){C[C.Success=0]="Success",C[C.Unknown=1]="Unknown",C[C.AccessDenied=2]="AccessDenied",C[C.ProcessNotFound=3]="ProcessNotFound"})(L||(e.TerminateResponseCode=L={}));function j(C,...S){const d=S.reduce((b,l)=>(b[l]=!0,b),{}),R=[/^ELECTRON_.+$/,/^VSCODE_(?!(PORTABLE|SHELL_LOGIN|ENV_REPLACE|ENV_APPEND|ENV_PREPEND)).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(C).filter(b=>!d[b]).forEach(b=>{for(let l=0;l<R.length;l++)if(b.search(R[l])!==-1){delete C[b];break}})}e.$Fl=j;function O(C){C&&(delete C.DEBUG,D.$j&&delete C.DYLD_LIBRARY_PATH,D.$k&&delete C.LD_PRELOAD)}e.$Gl=O}),define(ae[10],ce([0,1,16,5]),function(ie,e,D,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vc=e.$uc=e.URI=void 0;const L=/^\w[\w\d+.-]*$/,j=/^\//,O=/^\/\//;function C(i,t){if(!i.scheme&&t)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${i.authority}", path: "${i.path}", query: "${i.query}", fragment: "${i.fragment}"}`);if(i.scheme&&!L.test(i.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(i.path){if(i.authority){if(!j.test(i.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(O.test(i.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function S(i,t){return!i&&!t?"file":i}function d(i,t){switch(i){case"https":case"http":case"file":t?t[0]!==E&&(t=E+t):t=E;break}return t}const R="",E="/",b=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class l{static isUri(t){return t instanceof l?!0:t?typeof t.authority=="string"&&typeof t.fragment=="string"&&typeof t.path=="string"&&typeof t.query=="string"&&typeof t.scheme=="string"&&typeof t.fsPath=="string"&&typeof t.with=="function"&&typeof t.toString=="function":!1}constructor(t,r,o,v,$,f=!1){typeof t=="object"?(this.scheme=t.scheme||R,this.authority=t.authority||R,this.path=t.path||R,this.query=t.query||R,this.fragment=t.fragment||R):(this.scheme=S(t,f),this.authority=r||R,this.path=d(this.scheme,o||R),this.query=v||R,this.fragment=$||R,C(this,f))}get fsPath(){return m(this,!1)}with(t){if(!t)return this;let{scheme:r,authority:o,path:v,query:$,fragment:f}=t;return r===void 0?r=this.scheme:r===null&&(r=R),o===void 0?o=this.authority:o===null&&(o=R),v===void 0?v=this.path:v===null&&(v=R),$===void 0?$=this.query:$===null&&($=R),f===void 0?f=this.fragment:f===null&&(f=R),r===this.scheme&&o===this.authority&&v===this.path&&$===this.query&&f===this.fragment?this:new w(r,o,v,$,f)}static parse(t,r=!1){const o=b.exec(t);return o?new w(o[2]||R,n(o[4]||R),n(o[5]||R),n(o[7]||R),n(o[9]||R),r):new w(R,R,R,R,R)}static file(t){let r=R;if(A.$i&&(t=t.replace(/\\/g,E)),t[0]===E&&t[1]===E){const o=t.indexOf(E,2);o===-1?(r=t.substring(2),t=E):(r=t.substring(2,o),t=t.substring(o)||E)}return new w("file",r,t,R,R)}static from(t,r){return new w(t.scheme,t.authority,t.path,t.query,t.fragment,r)}static joinPath(t,...r){if(!t.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let o;return A.$i&&t.scheme==="file"?o=l.file(D.$ec.join(m(t,!0),...r)).path:o=D.$fc.join(t.path,...r),t.with({path:o})}toString(t=!1){return k(this,t)}toJSON(){return this}static revive(t){if(t){if(t instanceof l)return t;{const r=new w(t);return r._formatted=t.external??null,r._fsPath=t._sep===y?t.fsPath??null:null,r}}else return t}}e.URI=l;function g(i){return!i||typeof i!="object"?!1:typeof i.scheme=="string"&&(typeof i.authority=="string"||typeof i.authority>"u")&&(typeof i.path=="string"||typeof i.path>"u")&&(typeof i.query=="string"||typeof i.query>"u")&&(typeof i.fragment=="string"||typeof i.fragment>"u")}e.$uc=g;const y=A.$i?1:void 0;class w extends l{constructor(){super(...arguments),this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=m(this,!1)),this._fsPath}toString(t=!1){return t?k(this,!0):(this._formatted||(this._formatted=k(this,!1)),this._formatted)}toJSON(){const t={$mid:1};return this._fsPath&&(t.fsPath=this._fsPath,t._sep=y),this._formatted&&(t.external=this._formatted),this.path&&(t.path=this.path),this.scheme&&(t.scheme=this.scheme),this.authority&&(t.authority=this.authority),this.query&&(t.query=this.query),this.fragment&&(t.fragment=this.fragment),t}}const c={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function u(i,t,r){let o,v=-1;for(let $=0;$<i.length;$++){const f=i.charCodeAt($);if(f>=97&&f<=122||f>=65&&f<=90||f>=48&&f<=57||f===45||f===46||f===95||f===126||t&&f===47||r&&f===91||r&&f===93||r&&f===58)v!==-1&&(o+=encodeURIComponent(i.substring(v,$)),v=-1),o!==void 0&&(o+=i.charAt($));else{o===void 0&&(o=i.substr(0,$));const p=c[f];p!==void 0?(v!==-1&&(o+=encodeURIComponent(i.substring(v,$)),v=-1),o+=p):v===-1&&(v=$)}}return v!==-1&&(o+=encodeURIComponent(i.substring(v))),o!==void 0?o:i}function h(i){let t;for(let r=0;r<i.length;r++){const o=i.charCodeAt(r);o===35||o===63?(t===void 0&&(t=i.substr(0,r)),t+=c[o]):t!==void 0&&(t+=i[r])}return t!==void 0?t:i}function m(i,t){let r;return i.authority&&i.path.length>1&&i.scheme==="file"?r=`//${i.authority}${i.path}`:i.path.charCodeAt(0)===47&&(i.path.charCodeAt(1)>=65&&i.path.charCodeAt(1)<=90||i.path.charCodeAt(1)>=97&&i.path.charCodeAt(1)<=122)&&i.path.charCodeAt(2)===58?t?r=i.path.substr(1):r=i.path[1].toLowerCase()+i.path.substr(2):r=i.path,A.$i&&(r=r.replace(/\//g,"\\")),r}e.$vc=m;function k(i,t){const r=t?h:u;let o="",{scheme:v,authority:$,path:f,query:p,fragment:I}=i;if(v&&(o+=v,o+=":"),($||v==="file")&&(o+=E,o+=E),$){let T=$.indexOf("@");if(T!==-1){const M=$.substr(0,T);$=$.substr(T+1),T=M.lastIndexOf(":"),T===-1?o+=r(M,!1,!1):(o+=r(M.substr(0,T),!1,!1),o+=":",o+=r(M.substr(T+1),!1,!0)),o+="@"}$=$.toLowerCase(),T=$.lastIndexOf(":"),T===-1?o+=r($,!1,!0):(o+=r($.substr(0,T),!1,!0),o+=$.substr(T))}if(f){if(f.length>=3&&f.charCodeAt(0)===47&&f.charCodeAt(2)===58){const T=f.charCodeAt(1);T>=65&&T<=90&&(f=`/${String.fromCharCode(T+32)}:${f.substr(3)}`)}else if(f.length>=2&&f.charCodeAt(1)===58){const T=f.charCodeAt(0);T>=65&&T<=90&&(f=`${String.fromCharCode(T+32)}:${f.substr(2)}`)}o+=r(f,!0,!1)}return p&&(o+="?",o+=r(p,!1,!1)),I&&(o+="#",o+=t?I:u(I,!1,!1)),o}function s(i){try{return decodeURIComponent(i)}catch{return i.length>3?i.substr(0,3)+s(i.substr(3)):i}}const a=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function n(i){return i.match(a)?i.replace(a,t=>s(t)):i}}),define(ae[140],ce([0,1,10]),function(ie,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.log=e.$6p=e.$5p=e.$4p=void 0;function A(d){const R=d;return R&&typeof R.type=="string"&&typeof R.severity=="string"}e.$4p=A;function L(d){const R=[];let E;try{const b=JSON.parse(d.arguments),l=b[b.length-1];l&&l.__$stack&&(b.pop(),E=l.__$stack),R.push(...b)}catch{R.push("Unable to log remote console arguments",d.arguments)}return{args:R,stack:E}}e.$5p=L;function j(d){if(typeof d!="string")return j(L(d).stack);const R=d;if(R){const E=O(R),b=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(E||"");if(b&&b.length===4)return{uri:D.URI.file(b[1]),line:Number(b[2]),column:Number(b[3])}}}e.$6p=j;function O(d){if(!d)return d;const R=d.indexOf(`
`);return R===-1?d:d.substring(0,R)}function C(d,R){const{args:E,stack:b}=L(d),l=typeof E[0]=="string"&&E.length===1;let g=O(b);g&&(g=`(${g.trim()})`);let y=[];if(typeof E[0]=="string"?g&&l?y=[`%c[${R}] %c${E[0]} %c${g}`,S("blue"),S(""),S("grey")]:y=[`%c[${R}] %c${E[0]}`,S("blue"),S(""),...E.slice(1)]:y=[`%c[${R}]%`,S("blue"),...E],g&&!l&&y.push(g),typeof console[d.severity]!="function")throw new Error("Unknown console method");console[d.severity].apply(console,y)}e.log=C;function S(d){return`color: ${d}`}}),define(ae[65],ce([0,1,15,10]),function(ie,e,D,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sh=e.$rh=e.$qh=void 0;function L(S){return JSON.stringify(S,O)}e.$qh=L;function j(S){let d=JSON.parse(S);return d=C(d),d}e.$rh=j;function O(S,d){return d instanceof RegExp?{$mid:2,source:d.source,flags:d.flags}:d}function C(S,d=0){if(!S||d>200)return S;if(typeof S=="object"){switch(S.$mid){case 1:return A.URI.revive(S);case 2:return new RegExp(S.source,S.flags);case 17:return new Date(S.source)}if(S instanceof D.$fe||S instanceof Uint8Array)return S;if(Array.isArray(S))for(let R=0;R<S.length;++R)S[R]=C(S[R],d+1);else for(const R in S)Object.hasOwnProperty.call(S,R)&&(S[R]=C(S[R],d+1))}return S}e.$sh=C}),define(ae[23],ce([0,1,7,5,10]),function(ie,e,D,A,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.$gg=e.$fg=e.$eg=e.$dg=e.$cg=e.$bg=e.$ag=e.$_f=e.$$f=e.Schemas=void 0;var j;(function(d){d.inMemory="inmemory",d.vscode="vscode",d.internal="private",d.walkThrough="walkThrough",d.walkThroughSnippet="walkThroughSnippet",d.http="http",d.https="https",d.file="file",d.mailto="mailto",d.untitled="untitled",d.data="data",d.command="command",d.vscodeRemote="vscode-remote",d.vscodeRemoteResource="vscode-remote-resource",d.vscodeManagedRemoteResource="vscode-managed-remote-resource",d.vscodeUserData="vscode-userdata",d.vscodeCustomEditor="vscode-custom-editor",d.vscodeNotebookCell="vscode-notebook-cell",d.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",d.vscodeNotebookCellOutput="vscode-notebook-cell-output",d.vscodeInteractiveInput="vscode-interactive-input",d.vscodeSettings="vscode-settings",d.vscodeWorkspaceTrust="vscode-workspace-trust",d.vscodeTerminal="vscode-terminal",d.vscodeChatSesssion="vscode-chat-editor",d.webviewPanel="webview-panel",d.vscodeWebview="vscode-webview",d.extension="extension",d.vscodeFileResource="vscode-file",d.tmp="tmp",d.vsls="vsls",d.vscodeSourceControl="vscode-scm"})(j||(e.Schemas=j={})),e.$$f="vscode-tkn",e.$_f="tkn";class O{constructor(){this.a=Object.create(null),this.b=Object.create(null),this.c=Object.create(null),this.d="http",this.e=null,this.f=`/${j.vscodeRemoteResource}`}setPreferredWebSchema(R){this.d=R}setDelegate(R){this.e=R}setServerRootPath(R){this.f=`${R}/${j.vscodeRemoteResource}`}set(R,E,b){this.a[R]=E,this.b[R]=b}setConnectionToken(R,E){this.c[R]=E}getPreferredWebSchema(){return this.d}rewrite(R){if(this.e)try{return this.e(R)}catch(w){return D.$Z(w),R}const E=R.authority;let b=this.a[E];b&&b.indexOf(":")!==-1&&b.indexOf("[")===-1&&(b=`[${b}]`);const l=this.b[E],g=this.c[E];let y=`path=${encodeURIComponent(R.path)}`;return typeof g=="string"&&(y+=`&${e.$_f}=${encodeURIComponent(g)}`),L.URI.from({scheme:A.$o?this.d:j.vscodeRemoteResource,authority:`${b}:${l}`,path:this.f,query:y})}}e.$ag=new O,e.$bg="vs/../../extensions",e.$cg="vs/../../node_modules",e.$dg="vs/../../node_modules.asar",e.$eg="vs/../../node_modules.asar.unpacked",e.$fg="vscode-app";class C{static{this.a=e.$fg}asBrowserUri(R){const E=this.b(R,ie);return this.uriToBrowserUri(E)}uriToBrowserUri(R){return R.scheme===j.vscodeRemote?e.$ag.rewrite(R):R.scheme===j.file&&(A.$m||A.$q===`${j.vscodeFileResource}://${C.a}`)?R.with({scheme:j.vscodeFileResource,authority:R.authority||C.a,query:null,fragment:null}):R}asFileUri(R){const E=this.b(R,ie);return this.uriToFileUri(E)}uriToFileUri(R){return R.scheme===j.vscodeFileResource?R.with({scheme:j.file,authority:R.authority!==C.a?R.authority:null,query:null,fragment:null}):R}b(R,E){return L.URI.isUri(R)?R:L.URI.parse(E.toUrl(R))}}e.$gg=new C;var S;(function(d){const R=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);d.CoopAndCoep=Object.freeze(R.get("3"));const E="vscode-coi";function b(g){let y;typeof g=="string"?y=new URL(g).searchParams:g instanceof URL?y=g.searchParams:L.URI.isUri(g)&&(y=new URL(g.toString(!0)).searchParams);const w=y?.get(E);if(w)return R.get(w)}d.getHeadersFromQuery=b;function l(g,y,w){if(!globalThis.crossOriginIsolated)return;const c=y&&w?"3":w?"2":"1";g instanceof URLSearchParams?g.set(E,c):g[E]=c}d.addSearchParam=l})(S||(e.COI=S={}))}),define(ae[141],ce([0,1,123,23,5,10]),function(ie,e,D,A,L,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$NC=void 0;class O{constructor(b,l,g){this.id=b,this.dependencies=l,this.callback=g}}class C{static{this.INSTANCE=new C}constructor(){this.a=typeof self=="object"&&self.constructor&&self.constructor.name==="DedicatedWorkerGlobalScope",this.b=typeof document=="object",this.c=[],this.d=!1}g(){this.d||(this.d=!0,globalThis.define=(b,l,g)=>{typeof b!="string"&&(g=l,l=b,b=null),(typeof l!="object"||!Array.isArray(l))&&(g=l,l=null),this.c.push(new O(b,l,g))},globalThis.define.amd=!0,this.b?this.f=window.trustedTypes?.createPolicy("amdLoader",{createScriptURL(b){if(b.startsWith(window.location.origin)||b.startsWith("vscode-file://vscode-app"))return b;throw new Error(`[trusted_script_src] Invalid script url: ${b}`)}}):this.a&&(this.f=globalThis.trustedTypes?.createPolicy("amdLoader",{createScriptURL(b){return b}})))}async load(b){this.g();const l=await(this.a?this.i(b):this.b?this.h(b):this.j(b));if(!l)throw new Error(`Did not receive a define call from script ${b}`);if(Array.isArray(l.dependencies)&&l.dependencies.length>0)throw new Error(`Cannot resolve dependencies for script ${b}. The dependencies are: ${l.dependencies.join(", ")}`);return typeof l.callback=="function"?l.callback([]):l.callback}h(b){return new Promise((l,g)=>{const y=document.createElement("script");y.setAttribute("async","async"),y.setAttribute("type","text/javascript");const w=()=>{y.removeEventListener("load",c),y.removeEventListener("error",u)},c=h=>{w(),l(this.c.pop())},u=h=>{w(),g(h)};y.addEventListener("load",c),y.addEventListener("error",u),this.f&&(b=this.f.createScriptURL(b)),y.setAttribute("src",b),window.document.getElementsByTagName("head")[0].appendChild(y)})}i(b){return new Promise((l,g)=>{try{this.f&&(b=this.f.createScriptURL(b)),importScripts(b),l(this.c.pop())}catch(y){g(y)}})}async j(b){try{const l=globalThis._VSCODE_NODE_MODULES.fs,g=globalThis._VSCODE_NODE_MODULES.vm,y=globalThis._VSCODE_NODE_MODULES.module,w=j.URI.parse(b).fsPath,c=l.readFileSync(w).toString(),u=y.wrap(c.replace(/^#!.*/,""));return new g.Script(u).runInThisContext().apply(),this.c.pop()}catch(l){throw l}}}const S=new Map;let d={};typeof globalThis.require=="object"&&(d=globalThis.require.paths??{});async function R(E,b,l){if(D.$S){l===void 0&&(l=!!(globalThis._VSCODE_PRODUCT_JSON??globalThis.vscode?.context?.configuration()?.product)?.commit),d[E]&&(E=d[E]);const g=`${E}/${b}`;if(S.has(g))return S.get(g);let y;if(/^\w[\w\d+.-]*:\/\//.test(g))y=g;else{const h=`${l&&!L.$o?A.$dg:A.$cg}/${g}`;y=A.$gg.asBrowserUri(h).toString(!0)}const w=C.INSTANCE.load(y);return S.set(g,w),w}else return await new Promise((g,y)=>{ie([E],g,y)})}e.$NC=R}),define(ae[19],ce([0,1,48,23,16,5,27,10]),function(ie,e,D,A,L,j,O,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jg=e.DataUri=e.$Ig=e.$Hg=e.$Gg=e.$Fg=e.$Eg=e.$Dg=e.$Cg=e.$Bg=e.$Ag=e.$zg=e.$yg=e.$xg=e.$wg=e.$vg=e.$ug=e.$tg=e.$sg=e.$rg=e.$qg=e.$pg=e.$og=e.$ng=void 0;function S(l){return(0,C.$vc)(l,!0)}e.$ng=S;class d{constructor(g){this.a=g}compare(g,y,w=!1){return g===y?0:(0,O.$Ye)(this.getComparisonKey(g,w),this.getComparisonKey(y,w))}isEqual(g,y,w=!1){return g===y?!0:!g||!y?!1:this.getComparisonKey(g,w)===this.getComparisonKey(y,w)}getComparisonKey(g,y=!1){return g.with({path:this.a(g)?g.path.toLowerCase():void 0,fragment:y?null:void 0}).toString()}ignorePathCasing(g){return this.a(g)}isEqualOrParent(g,y,w=!1){if(g.scheme===y.scheme){if(g.scheme===A.Schemas.file)return D.$2f(S(g),S(y),this.a(g))&&g.query===y.query&&(w||g.fragment===y.fragment);if((0,e.$Eg)(g.authority,y.authority))return D.$2f(g.path,y.path,this.a(g),"/")&&g.query===y.query&&(w||g.fragment===y.fragment)}return!1}joinPath(g,...y){return C.URI.joinPath(g,...y)}basenameOrAuthority(g){return(0,e.$wg)(g)||g.authority}basename(g){return L.$fc.basename(g.path)}extname(g){return L.$fc.extname(g.path)}dirname(g){if(g.path.length===0)return g;let y;return g.scheme===A.Schemas.file?y=C.URI.file(L.$lc(S(g))).path:(y=L.$fc.dirname(g.path),g.authority&&y.length&&y.charCodeAt(0)!==47&&(console.error(`dirname("${g.toString})) resulted in a relative path`),y="/")),g.with({path:y})}normalizePath(g){if(!g.path.length)return g;let y;return g.scheme===A.Schemas.file?y=C.URI.file(L.$gc(S(g))).path:y=L.$fc.normalize(g.path),g.with({path:y})}relativePath(g,y){if(g.scheme!==y.scheme||!(0,e.$Eg)(g.authority,y.authority))return;if(g.scheme===A.Schemas.file){const u=L.$kc(S(g),S(y));return j.$i?D.$Vf(u):u}let w=g.path||"/";const c=y.path||"/";if(this.a(g)){let u=0;for(const h=Math.min(w.length,c.length);u<h&&!(w.charCodeAt(u)!==c.charCodeAt(u)&&w.charAt(u).toLowerCase()!==c.charAt(u).toLowerCase());u++);w=c.substr(0,u)+w.substr(u)}return L.$fc.relative(w,c)}resolvePath(g,y){if(g.scheme===A.Schemas.file){const w=C.URI.file(L.$jc(S(g),y));return g.with({authority:w.authority,path:w.path})}return y=D.$Wf(y),g.with({path:L.$fc.resolve(g.path,y)})}isAbsolutePath(g){return!!g.path&&g.path[0]==="/"}isEqualAuthority(g,y){return g===y||g!==void 0&&y!==void 0&&(0,O.$6e)(g,y)}hasTrailingPathSeparator(g,y=L.sep){if(g.scheme===A.Schemas.file){const w=S(g);return w.length>D.$Xf(w).length&&w[w.length-1]===y}else{const w=g.path;return w.length>1&&w.charCodeAt(w.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(g.fsPath)}}removeTrailingPathSeparator(g,y=L.sep){return(0,e.$Fg)(g,y)?g.with({path:g.path.substr(0,g.path.length-1)}):g}addTrailingPathSeparator(g,y=L.sep){let w=!1;if(g.scheme===A.Schemas.file){const c=S(g);w=c!==void 0&&c.length===D.$Xf(c).length&&c[c.length-1]===y}else{y="/";const c=g.path;w=c.length===1&&c.charCodeAt(c.length-1)===47}return!w&&!(0,e.$Fg)(g,y)?g.with({path:g.path+"/"}):g}}e.$og=d,e.$pg=new d(()=>!1),e.$qg=new d(l=>l.scheme===A.Schemas.file?!j.$k:!0),e.$rg=new d(l=>!0),e.$sg=e.$pg.isEqual.bind(e.$pg),e.$tg=e.$pg.isEqualOrParent.bind(e.$pg),e.$ug=e.$pg.getComparisonKey.bind(e.$pg),e.$vg=e.$pg.basenameOrAuthority.bind(e.$pg),e.$wg=e.$pg.basename.bind(e.$pg),e.$xg=e.$pg.extname.bind(e.$pg),e.$yg=e.$pg.dirname.bind(e.$pg),e.$zg=e.$pg.joinPath.bind(e.$pg),e.$Ag=e.$pg.normalizePath.bind(e.$pg),e.$Bg=e.$pg.relativePath.bind(e.$pg),e.$Cg=e.$pg.resolvePath.bind(e.$pg),e.$Dg=e.$pg.isAbsolutePath.bind(e.$pg),e.$Eg=e.$pg.isEqualAuthority.bind(e.$pg),e.$Fg=e.$pg.hasTrailingPathSeparator.bind(e.$pg),e.$Gg=e.$pg.removeTrailingPathSeparator.bind(e.$pg),e.$Hg=e.$pg.addTrailingPathSeparator.bind(e.$pg);function R(l,g){const y=[];for(let w=0;w<l.length;w++){const c=g(l[w]);l.some((u,h)=>h===w?!1:(0,e.$tg)(c,g(u)))||y.push(l[w])}return y}e.$Ig=R;var E;(function(l){l.META_DATA_LABEL="label",l.META_DATA_DESCRIPTION="description",l.META_DATA_SIZE="size",l.META_DATA_MIME="mime";function g(y){const w=new Map;y.path.substring(y.path.indexOf(";")+1,y.path.lastIndexOf(";")).split(";").forEach(h=>{const[m,k]=h.split(":");m&&k&&w.set(m,k)});const u=y.path.substring(0,y.path.indexOf(";"));return u&&w.set(l.META_DATA_MIME,u),w}l.parseMetaData=g})(E||(e.DataUri=E={}));function b(l,g,y){if(g){let w=l.path;return w&&w[0]!==L.$fc.sep&&(w=L.$fc.sep+w),l.with({scheme:y,authority:g,path:w})}return l.with({scheme:y})}e.$Jg=b}),define(ae[6],ce([0,1,26,7,3,2,19,5,129]),function(ie,e,D,A,L,j,O,C,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mh=e.$lh=e.$kh=e.$jh=e.Promises=e.$ih=e.$hh=e.$gh=e.$fh=e.$eh=e.$dh=e.$ch=e.$bh=e.$ah=e.$_g=e.$$g=e.$0g=e.$9g=e.$8g=e.$7g=e.$6g=e.$5g=e.$4g=e.$3g=e.$2g=e.$1g=e.$Zg=e.$Yg=e.$Xg=e.$Wg=e.$Vg=e.$Ug=e.$Tg=e.$Sg=e.$Rg=e.$Qg=e.$Pg=e.$Og=e.$Ng=e.$Mg=e.$Lg=e.$Kg=void 0;function d(B){return!!B&&typeof B.then=="function"}e.$Kg=d;function R(B){const N=new D.$2d,V=B(N.token),G=new Promise((te,oe)=>{const ue=N.token.onCancellationRequested(()=>{ue.dispose(),N.dispose(),oe(new A.$4)});Promise.resolve(V).then(he=>{ue.dispose(),N.dispose(),te(he)},he=>{ue.dispose(),N.dispose(),oe(he)})});return new class{cancel(){N.cancel()}then(te,oe){return G.then(te,oe)}catch(te){return this.then(void 0,te)}finally(te){return G.finally(te)}}}e.$Lg=R;function E(B,N,V){return new Promise((G,te)=>{const oe=N.onCancellationRequested(()=>{oe.dispose(),G(V)});B.then(G,te).finally(()=>oe.dispose())})}e.$Mg=E;function b(B,N){return new Promise((V,G)=>{const te=N.onCancellationRequested(()=>{te.dispose(),G(new A.$4)});B.then(V,G).finally(()=>te.dispose())})}e.$Ng=b;async function l(B){let N=-1;const V=B.map((G,te)=>G.then(oe=>(N=te,oe)));try{return await Promise.race(V)}finally{B.forEach((G,te)=>{te!==N&&G.cancel()})}}e.$Og=l;function g(B,N,V){let G;const te=setTimeout(()=>{G?.(void 0),V?.()},N);return Promise.race([B.finally(()=>clearTimeout(te)),new Promise(oe=>G=oe)])}e.$Pg=g;function y(B){return new Promise((N,V)=>{const G=B();d(G)?G.then(N,V):N(G)})}e.$Qg=y;class w{constructor(){this.f=!1,this.a=null,this.b=null,this.d=null}queue(N){if(this.f)return Promise.reject(new Error("Throttler is disposed"));if(this.a){if(this.d=N,!this.b){const V=()=>{if(this.b=null,this.f)return;const G=this.queue(this.d);return this.d=null,G};this.b=new Promise(G=>{this.a.then(V,V).then(G)})}return new Promise((V,G)=>{this.b.then(V,G)})}return this.a=N(),new Promise((V,G)=>{this.a.then(te=>{this.a=null,V(te)},te=>{this.a=null,G(te)})})}dispose(){this.f=!0}}e.$Rg=w;class c{constructor(){this.a=Promise.resolve(null)}queue(N){return this.a=this.a.then(()=>N(),()=>N())}}e.$Sg=c;class u{constructor(){this.a=new Map}queue(N,V){const te=(this.a.get(N)??Promise.resolve()).catch(()=>{}).then(V).finally(()=>{this.a.get(N)===te&&this.a.delete(N)});return this.a.set(N,te),te}}e.$Tg=u;const h=(B,N)=>{let V=!0;const G=setTimeout(()=>{V=!1,N()},B);return{isTriggered:()=>V,dispose:()=>{clearTimeout(G),V=!1}}},m=B=>{let N=!0;return queueMicrotask(()=>{N&&(N=!1,B())}),{isTriggered:()=>N,dispose:()=>{N=!1}}};class k{constructor(N){this.defaultDelay=N,this.a=null,this.b=null,this.d=null,this.f=null,this.g=null}trigger(N,V=this.defaultDelay){this.g=N,this.h(),this.b||(this.b=new Promise((te,oe)=>{this.d=te,this.f=oe}).then(()=>{if(this.b=null,this.d=null,this.g){const te=this.g;return this.g=null,te()}}));const G=()=>{this.a=null,this.d?.(null)};return this.a=V===S.$Od?m(G):h(V,G),this.b}isTriggered(){return!!this.a?.isTriggered()}cancel(){this.h(),this.b&&(this.f?.(new A.$4),this.b=null)}h(){this.a?.dispose(),this.a=null}dispose(){this.cancel()}}e.$Ug=k;class s{constructor(N){this.a=new k(N),this.b=new w}trigger(N,V){return this.a.trigger(()=>this.b.queue(N),V)}isTriggered(){return this.a.isTriggered()}cancel(){this.a.cancel()}dispose(){this.a.dispose(),this.b.dispose()}}e.$Vg=s;class a{constructor(){this.a=!1,this.b=new Promise((N,V)=>{this.d=N})}isOpen(){return this.a}open(){this.a=!0,this.d(!0)}wait(){return this.b}}e.$Wg=a;class n extends a{constructor(N){super(),this.f=setTimeout(()=>this.open(),N)}open(){clearTimeout(this.f),super.open()}}e.$Xg=n;function i(B,N){return N?new Promise((V,G)=>{const te=setTimeout(()=>{oe.dispose(),V()},B),oe=N.onCancellationRequested(()=>{clearTimeout(te),oe.dispose(),G(new A.$4)})}):R(V=>i(B,V))}e.$Yg=i;function t(B,N=0,V){const G=setTimeout(()=>{B(),V&&te.dispose()},N),te=(0,j.$Pc)(()=>{clearTimeout(G),V?.deleteAndLeak(te)});return V?.add(te),te}e.$Zg=t;function r(B){const N=[];let V=0;const G=B.length;function te(){return V<G?B[V++]():null}function oe(ue){ue!=null&&N.push(ue);const he=te();return he?he.then(oe):Promise.resolve(N)}return Promise.resolve(null).then(oe)}e.$1g=r;function o(B,N=G=>!!G,V=null){let G=0;const te=B.length,oe=()=>{if(G>=te)return Promise.resolve(V);const ue=B[G++];return Promise.resolve(ue()).then(ge=>N(ge)?Promise.resolve(ge):oe())};return oe()}e.$2g=o;function v(B,N=G=>!!G,V=null){if(B.length===0)return Promise.resolve(V);let G=B.length;const te=()=>{G=-1;for(const oe of B)oe.cancel?.()};return new Promise((oe,ue)=>{for(const he of B)he.then(ge=>{--G>=0&&N(ge)?(te(),oe(ge)):G===0&&oe(V)}).catch(ge=>{--G>=0&&(te(),ue(ge))})})}e.$3g=v;class ${constructor(N){this.a=0,this.d=N,this.f=[],this.b=0,this.g=new L.$Rd}get onDrained(){return this.g.event}get size(){return this.a}queue(N){return this.a++,new Promise((V,G)=>{this.f.push({factory:N,c:V,e:G}),this.h()})}h(){for(;this.f.length&&this.b<this.d;){const N=this.f.shift();this.b++;const V=N.factory();V.then(N.c,N.e),V.then(()=>this.j(),()=>this.j())}}j(){this.a--,this.b--,this.f.length>0?this.h():this.g.fire()}dispose(){this.g.dispose()}}e.$4g=$;class f extends ${constructor(){super(1)}}e.$5g=f;class p{constructor(){this.a=new J,this.b=0}queue(N){return this.a.isRunning()?this.a.queue(()=>this.a.run(this.b++,N())):this.a.run(this.b++,N())}}e.$6g=p;class I{constructor(){this.a=new Map,this.b=new Set,this.d=void 0,this.f=0}async whenDrained(){if(this.g())return;const N=new ne;return this.b.add(N),N.p}g(){for(const[,N]of this.a)if(N.size>0)return!1;return!0}queueFor(N,V=O.$pg){const G=V.getComparisonKey(N);let te=this.a.get(G);if(!te){te=new f;const oe=this.f++,ue=L.Event.once(te.onDrained)(()=>{te?.dispose(),this.a.delete(G),this.h(),this.d?.deleteAndDispose(oe),this.d?.size===0&&(this.d.dispose(),this.d=void 0)});this.d||(this.d=new j.$1c),this.d.set(oe,ue),this.a.set(G,te)}return te}h(){this.g()&&this.j()}j(){for(const N of this.b)N.complete();this.b.clear()}dispose(){for(const[,N]of this.a)N.dispose();this.a.clear(),this.j(),this.d?.dispose()}}e.$7g=I;class T{constructor(N,V){this.a=-1,typeof N=="function"&&typeof V=="number"&&this.setIfNotSet(N,V)}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearTimeout(this.a),this.a=-1)}cancelAndSet(N,V){this.cancel(),this.a=setTimeout(()=>{this.a=-1,N()},V)}setIfNotSet(N,V){this.a===-1&&(this.a=setTimeout(()=>{this.a=-1,N()},V))}}e.$8g=T;class M{constructor(){this.d=void 0}cancel(){this.d?.dispose(),this.d=void 0}cancelAndSet(N,V,G=globalThis){this.cancel();const te=G.setInterval(()=>{N()},V);this.d=(0,j.$Pc)(()=>{G.clearInterval(te),this.d=void 0})}dispose(){this.cancel()}}e.$9g=M;class z{constructor(N,V){this.b=-1,this.a=N,this.d=V,this.f=this.g.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearTimeout(this.b),this.b=-1)}schedule(N=this.d){this.cancel(),this.b=setTimeout(this.f,N)}get delay(){return this.d}set delay(N){this.d=N}isScheduled(){return this.b!==-1}flush(){this.isScheduled()&&(this.cancel(),this.h())}g(){this.b=-1,this.a&&this.h()}h(){this.a?.()}}e.$0g=z;class q{constructor(N,V){V%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${V}ms is not a multiple of 1000ms.`),this.a=N,this.b=V,this.d=0,this.f=-1,this.g=this.h.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearInterval(this.f),this.f=-1)}schedule(N=this.b){N%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${N}ms is not a multiple of 1000ms.`),this.cancel(),this.d=Math.ceil(N/1e3),this.f=setInterval(this.g,1e3)}isScheduled(){return this.f!==-1}h(){this.d--,!(this.d>0)&&(clearInterval(this.f),this.f=-1,this.a?.())}}e.$$g=q;class Y extends z{constructor(N,V){super(N,V),this.j=[]}work(N){this.j.push(N),this.isScheduled()||this.schedule()}h(){const N=this.j;this.j=[],this.a?.(N)}dispose(){this.j=[],super.dispose()}}e.$_g=Y;class Q extends j.$Rc{constructor(N,V){super(),this.g=N,this.h=V,this.a=[],this.b=this.B(new j.$Sc),this.f=!1}get pending(){return this.a.length}work(N){if(this.f)return!1;if(typeof this.g.maxBufferedWork=="number"){if(this.b.value){if(this.pending+N.length>this.g.maxBufferedWork)return!1}else if(this.pending+N.length-this.g.maxWorkChunkSize>this.g.maxBufferedWork)return!1}for(const V of N)this.a.push(V);return this.b.value||this.j(),!0}j(){this.h(this.a.splice(0,this.g.maxWorkChunkSize)),this.a.length>0&&(this.b.value=new z(()=>{this.b.clear(),this.j()},this.g.throttleDelay),this.b.value.schedule())}dispose(){super.dispose(),this.f=!0}}e.$ah=Q,function(){typeof globalThis.requestIdleCallback!="function"||typeof globalThis.cancelIdleCallback!="function"?e.$ch=(B,N)=>{(0,C.$B)(()=>{if(V)return;const G=Date.now()+15;N(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,G-Date.now())}}))});let V=!1;return{dispose(){V||(V=!0)}}}:e.$ch=(B,N,V)=>{const G=B.requestIdleCallback(N,typeof V=="number"?{timeout:V}:void 0);let te=!1;return{dispose(){te||(te=!0,B.cancelIdleCallback(G))}}},e.$bh=B=>(0,e.$ch)(globalThis,B)}();class x{constructor(N,V){this.g=!1,this.d=()=>{try{this.j=V()}catch(G){this.l=G}finally{this.g=!0}},this.f=(0,e.$ch)(N,()=>this.d())}dispose(){this.f.dispose()}get value(){if(this.g||(this.f.dispose(),this.d()),this.l)throw this.l;return this.j}get isInitialized(){return this.g}}e.$dh=x;class H extends x{constructor(N){super(globalThis,N)}}e.$eh=H;async function Z(B,N,V){let G;for(let te=0;te<V;te++)try{return await B()}catch(oe){G=oe,await i(N)}throw G}e.$fh=Z;class J{isRunning(N){return typeof N=="number"?this.a?.taskId===N:!!this.a}get running(){return this.a?.promise}cancelRunning(){this.a?.cancel()}run(N,V,G){return this.a={taskId:N,cancel:()=>G?.(),promise:V},V.then(()=>this.d(N),()=>this.d(N)),V}d(N){this.a&&N===this.a.taskId&&(this.a=void 0,this.f())}f(){if(this.b){const N=this.b;this.b=void 0,N.run().then(N.promiseResolve,N.promiseReject)}}queue(N){if(this.b)this.b.run=N;else{let V,G;const te=new Promise((oe,ue)=>{V=oe,G=ue});this.b={run:N,promise:te,promiseResolve:V,promiseReject:G}}return this.b.promise}hasQueued(){return!!this.b}async join(){return this.b?.promise??this.a?.promise}}e.$gh=J;class W{constructor(N,V=()=>Date.now()){this.d=N,this.f=V,this.a=0,this.b=0}increment(){const N=this.f();return N-this.a>this.d&&(this.a=N,this.b=0),this.b++,this.b}}e.$hh=W;var ee;(function(B){B[B.Resolved=0]="Resolved",B[B.Rejected=1]="Rejected"})(ee||(ee={}));class ne{get isRejected(){return this.d?.outcome===1}get isResolved(){return this.d?.outcome===0}get isSettled(){return!!this.d}get value(){return this.d?.outcome===0?this.d?.value:void 0}constructor(){this.p=new Promise((N,V)=>{this.a=N,this.b=V})}complete(N){return new Promise(V=>{this.a(N),this.d={outcome:0,value:N},V()})}error(N){return new Promise(V=>{this.b(N),this.d={outcome:1,value:N},V()})}cancel(){return this.error(new A.$4)}}e.$ih=ne;var _;(function(B){async function N(G){let te;const oe=await Promise.all(G.map(ue=>ue.then(he=>he,he=>{te||(te=he)})));if(typeof te<"u")throw te;return oe}B.settled=N;function V(G){return new Promise(async(te,oe)=>{try{await G(te,oe)}catch(ue){oe(ue)}})}B.withAsyncBody=V})(_||(e.Promises=_={}));var se;(function(B){B[B.Initial=0]="Initial",B[B.DoneOK=1]="DoneOK",B[B.DoneError=2]="DoneError"})(se||(se={}));class K{static fromArray(N){return new K(V=>{V.emitMany(N)})}static fromPromise(N){return new K(async V=>{V.emitMany(await N)})}static fromPromises(N){return new K(async V=>{await Promise.all(N.map(async G=>V.emitOne(await G)))})}static merge(N){return new K(async V=>{await Promise.all(N.map(async G=>{for await(const te of G)V.emitOne(te)}))})}static{this.EMPTY=K.fromArray([])}constructor(N){this.a=0,this.b=[],this.d=null,this.f=new L.$Rd,queueMicrotask(async()=>{const V={emitOne:G=>this.g(G),emitMany:G=>this.h(G),reject:G=>this.k(G)};try{await Promise.resolve(N(V)),this.j()}catch(G){this.k(G)}finally{V.emitOne=void 0,V.emitMany=void 0,V.reject=void 0}})}[Symbol.asyncIterator](){let N=0;return{next:async()=>{do{if(this.a===2)throw this.d;if(N<this.b.length)return{done:!1,value:this.b[N++]};if(this.a===1)return{done:!0,value:void 0};await L.Event.toPromise(this.f.event)}while(!0)}}}static map(N,V){return new K(async G=>{for await(const te of N)G.emitOne(V(te))})}map(N){return K.map(this,N)}static filter(N,V){return new K(async G=>{for await(const te of N)V(te)&&G.emitOne(te)})}filter(N){return K.filter(this,N)}static coalesce(N){return K.filter(N,V=>!!V)}coalesce(){return K.coalesce(this)}static async toPromise(N){const V=[];for await(const G of N)V.push(G);return V}toPromise(){return K.toPromise(this)}g(N){this.a===0&&(this.b.push(N),this.f.fire())}h(N){this.a===0&&(this.b=this.b.concat(N),this.f.fire())}j(){this.a===0&&(this.a=1,this.f.fire())}k(N){this.a===0&&(this.a=2,this.d=N,this.f.fire())}}e.$jh=K;class U extends K{constructor(N,V){super(V),this.l=N}cancel(){this.l.cancel()}}e.$kh=U;function P(B){const N=new D.$2d,V=B(N.token);return new U(N,async G=>{const te=N.token.onCancellationRequested(()=>{te.dispose(),N.dispose(),G.reject(new A.$4)});try{for await(const oe of V){if(N.token.isCancellationRequested)return;G.emitOne(oe)}te.dispose(),N.dispose()}catch(oe){te.dispose(),N.dispose(),G.reject(oe)}})}e.$lh=P;class F{constructor(){this.a=new ne,this.b=new K(G=>{if(N){G.reject(N);return}return V&&G.emitMany(V),this.d=te=>G.reject(te),this.f=te=>G.emitOne(te),this.a.p});let N,V;this.f=G=>{V||(V=[]),V.push(G)},this.d=G=>{N||(N=G)}}get asyncIterable(){return this.b}resolve(){this.a.complete()}reject(N){this.d(N),this.a.complete()}emitOne(N){this.f(N)}}e.$mh=F}),define(ae[91],ce([0,1,18,6,48,34,16,5,27]),function(ie,e,D,A,L,j,O,C,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gj=e.$Fj=e.$Ej=e.$Dj=e.$Cj=e.$Bj=e.$Aj=e.$zj=e.$yj=e.$xj=void 0;function d(){return Object.create(null)}e.$xj=d,e.$yj="**",e.$zj="/";const R="[/\\\\]",E="[^/\\\\]",b=/\//g;function l(Z,J){switch(Z){case 0:return"";case 1:return`${E}*?`;default:return`(?:${R}|${E}+${R}${J?`|${R}${E}+`:""})*?`}}function g(Z,J){if(!Z)return[];const W=[];let ee=!1,ne=!1,_="";for(const se of Z){switch(se){case J:if(!ee&&!ne){W.push(_),_="";continue}break;case"{":ee=!0;break;case"}":ee=!1;break;case"[":ne=!0;break;case"]":ne=!1;break}_+=se}return _&&W.push(_),W}e.$Aj=g;function y(Z){if(!Z)return"";let J="";const W=g(Z,e.$zj);if(W.every(ee=>ee===e.$yj))J=".*";else{let ee=!1;W.forEach((ne,_)=>{if(ne===e.$yj){if(ee)return;J+=l(2,_===W.length-1)}else{let se=!1,K="",U=!1,P="";for(const F of ne){if(F!=="}"&&se){K+=F;continue}if(U&&(F!=="]"||!P)){let B;F==="-"?B=F:(F==="^"||F==="!")&&!P?B="^":F===e.$zj?B="":B=(0,S.$Je)(F),P+=B;continue}switch(F){case"{":se=!0;continue;case"[":U=!0;continue;case"}":{const N=`(?:${g(K,",").map(V=>y(V)).join("|")})`;J+=N,se=!1,K="";break}case"]":{J+="["+P+"]",U=!1,P="";break}case"?":J+=E;continue;case"*":J+=l(1);continue;default:J+=(0,S.$Je)(F)}}_<W.length-1&&(W[_+1]!==e.$yj||_+2<W.length)&&(J+=R)}ee=ne===e.$yj})}return J}const w=/^\*\*\/\*\.[\w\.-]+$/,c=/^\*\*\/([\w\.-]+)\/?$/,u=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,h=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,m=/^\*\*((\/[\w\.-]+)+)\/?$/,k=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,s=new j.$Cc(1e4),a=function(){return!1},n=function(){return null};function i(Z,J){if(!Z)return n;let W;typeof Z!="string"?W=Z.pattern:W=Z,W=W.trim();const ee=`${W}_${!!J.trimForExclusions}`;let ne=s.get(ee);if(ne)return t(ne,Z);let _;return w.test(W)?ne=o(W.substr(4),W):(_=c.exec(r(W,J)))?ne=v(_[1],W):(J.trimForExclusions?h:u).test(W)?ne=$(W,J):(_=m.exec(r(W,J)))?ne=f(_[1].substr(1),W,!0):(_=k.exec(r(W,J)))?ne=f(_[1],W,!1):ne=p(W),s.set(ee,ne),t(ne,Z)}function t(Z,J){if(typeof J=="string")return Z;const W=function(ee,ne){return(0,L.$2f)(ee,J.base,!C.$k)?Z((0,S.$Ne)(ee.substr(J.base.length),O.sep),ne):null};return W.allBasenames=Z.allBasenames,W.allPaths=Z.allPaths,W.basenames=Z.basenames,W.patterns=Z.patterns,W}function r(Z,J){return J.trimForExclusions&&Z.endsWith("/**")?Z.substr(0,Z.length-2):Z}function o(Z,J){return function(W,ee){return typeof W=="string"&&W.endsWith(Z)?J:null}}function v(Z,J){const W=`/${Z}`,ee=`\\${Z}`,ne=function(se,K){return typeof se!="string"?null:K?K===Z?J:null:se===Z||se.endsWith(W)||se.endsWith(ee)?J:null},_=[Z];return ne.basenames=_,ne.patterns=[J],ne.allBasenames=_,ne}function $(Z,J){const W=x(Z.slice(1,-1).split(",").map(K=>i(K,J)).filter(K=>K!==n),Z),ee=W.length;if(!ee)return n;if(ee===1)return W[0];const ne=function(K,U){for(let P=0,F=W.length;P<F;P++)if(W[P](K,U))return Z;return null},_=W.find(K=>!!K.allBasenames);_&&(ne.allBasenames=_.allBasenames);const se=W.reduce((K,U)=>U.allPaths?K.concat(U.allPaths):K,[]);return se.length&&(ne.allPaths=se),ne}function f(Z,J,W){const ee=O.sep===O.$fc.sep,ne=ee?Z:Z.replace(b,O.sep),_=O.sep+ne,se=O.$fc.sep+Z;let K;return W?K=function(U,P){return typeof U=="string"&&(U===ne||U.endsWith(_)||!ee&&(U===Z||U.endsWith(se)))?J:null}:K=function(U,P){return typeof U=="string"&&(U===ne||!ee&&U===Z)?J:null},K.allPaths=[(W?"*/":"./")+Z],K}function p(Z){try{const J=new RegExp(`^${y(Z)}$`);return function(W){return J.lastIndex=0,typeof W=="string"&&J.test(W)?Z:null}}catch{return n}}function I(Z,J,W){return!Z||typeof J!="string"?!1:T(Z)(J,void 0,W)}e.$Bj=I;function T(Z,J={}){if(!Z)return a;if(typeof Z=="string"||M(Z)){const W=i(Z,J);if(W===n)return a;const ee=function(ne,_){return!!W(ne,_)};return W.allBasenames&&(ee.allBasenames=W.allBasenames),W.allPaths&&(ee.allPaths=W.allPaths),ee}return Y(Z,J)}e.$Cj=T;function M(Z){const J=Z;return J?typeof J.base=="string"&&typeof J.pattern=="string":!1}e.$Dj=M;function z(Z){return Z.allBasenames||[]}e.$Ej=z;function q(Z){return Z.allPaths||[]}e.$Fj=q;function Y(Z,J){const W=x(Object.getOwnPropertyNames(Z).map(K=>Q(K,Z[K],J)).filter(K=>K!==n)),ee=W.length;if(!ee)return n;if(!W.some(K=>!!K.requiresSiblings)){if(ee===1)return W[0];const K=function(F,B){let N;for(let V=0,G=W.length;V<G;V++){const te=W[V](F,B);if(typeof te=="string")return te;(0,A.$Kg)(te)&&(N||(N=[]),N.push(te))}return N?(async()=>{for(const V of N){const G=await V;if(typeof G=="string")return G}return null})():null},U=W.find(F=>!!F.allBasenames);U&&(K.allBasenames=U.allBasenames);const P=W.reduce((F,B)=>B.allPaths?F.concat(B.allPaths):F,[]);return P.length&&(K.allPaths=P),K}const ne=function(K,U,P){let F,B;for(let N=0,V=W.length;N<V;N++){const G=W[N];G.requiresSiblings&&P&&(U||(U=(0,O.$mc)(K)),F||(F=U.substr(0,U.length-(0,O.$nc)(K).length)));const te=G(K,U,F,P);if(typeof te=="string")return te;(0,A.$Kg)(te)&&(B||(B=[]),B.push(te))}return B?(async()=>{for(const N of B){const V=await N;if(typeof V=="string")return V}return null})():null},_=W.find(K=>!!K.allBasenames);_&&(ne.allBasenames=_.allBasenames);const se=W.reduce((K,U)=>U.allPaths?K.concat(U.allPaths):K,[]);return se.length&&(ne.allPaths=se),ne}function Q(Z,J,W){if(J===!1)return n;const ee=i(Z,W);if(ee===n)return n;if(typeof J=="boolean")return ee;if(J){const ne=J.when;if(typeof ne=="string"){const _=(se,K,U,P)=>{if(!P||!ee(se,K))return null;const F=ne.replace("$(basename)",()=>U),B=P(F);return(0,A.$Kg)(B)?B.then(N=>N?Z:null):B?Z:null};return _.requiresSiblings=!0,_}}return ee}function x(Z,J){const W=Z.filter(K=>!!K.basenames);if(W.length<2)return Z;const ee=W.reduce((K,U)=>{const P=U.basenames;return P?K.concat(P):K},[]);let ne;if(J){ne=[];for(let K=0,U=ee.length;K<U;K++)ne.push(J)}else ne=W.reduce((K,U)=>{const P=U.patterns;return P?K.concat(P):K},[]);const _=function(K,U){if(typeof K!="string")return null;if(!U){let F;for(F=K.length;F>0;F--){const B=K.charCodeAt(F-1);if(B===47||B===92)break}U=K.substr(F)}const P=ee.indexOf(U);return P!==-1?ne[P]:null};_.basenames=ee,_.patterns=ne,_.allBasenames=ee;const se=Z.filter(K=>!K.basenames);return se.push(_),se}function H(Z,J){return(0,D.$tb)(Z,J,(W,ee)=>typeof W=="string"&&typeof ee=="string"?W===ee:typeof W!="string"&&typeof ee!="string"?W.base===ee.base&&W.pattern===ee.pattern:!1)}e.$Gj=H}),define(ae[92],ce([0,1,15,10]),function(ie,e,D,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vm=e.$Um=e.$Tm=e.$Sm=e.$Rm=void 0;function L(E){return E.toJSON()}class j{constructor(b){this.a=b}transformIncoming(b){const l=this.a.transformIncoming(b);return l===b?b:L(A.URI.from(l))}transformOutgoing(b){const l=this.a.transformOutgoing(b);return l===b?b:L(A.URI.from(l))}transformOutgoingURI(b){const l=this.a.transformOutgoing(b);return l===b?b:A.URI.from(l)}transformOutgoingScheme(b){return this.a.transformOutgoingScheme(b)}}e.$Rm=j,e.$Sm=new class{transformIncoming(E){return E}transformOutgoing(E){return E}transformOutgoingURI(E){return E}transformOutgoingScheme(E){return E}};function O(E,b,l){if(!E||l>200)return null;if(typeof E=="object"){if(E instanceof A.URI)return b.transformOutgoing(E);for(const g in E)if(Object.hasOwnProperty.call(E,g)){const y=O(E[g],b,l+1);y!==null&&(E[g]=y)}}return null}function C(E,b){const l=O(E,b,0);return l===null?E:l}e.$Tm=C;function S(E,b,l,g){if(!E||g>200)return null;if(typeof E=="object"){if(E.$mid===1)return l?A.URI.revive(b.transformIncoming(E)):b.transformIncoming(E);if(E instanceof D.$fe)return null;for(const y in E)if(Object.hasOwnProperty.call(E,y)){const w=S(E[y],b,l,g+1);w!==null&&(E[y]=w)}}return null}function d(E,b){const l=S(E,b,!1,0);return l===null?E:l}e.$Um=d;function R(E,b){const l=S(E,b,!0,0);return l===null?E:l}e.$Vm=R}),define(ae[142],ce([0,1,36,47,32,130,5]),function(ie,e,D,A,L,j,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zm=e.$Ym=e.$Xm=void 0,e.$Xm=new class{c(b){return this.a||(this.a=A.$2h.forStrings(),this.a.set("00-50-56",!0),this.a.set("00-0C-29",!0),this.a.set("00-05-69",!0),this.a.set("00-03-FF",!0),this.a.set("00-1C-42",!0),this.a.set("00-16-3E",!0),this.a.set("08-00-27",!0),this.a.set("00:50:56",!0),this.a.set("00:0C:29",!0),this.a.set("00:05:69",!0),this.a.set("00:03:FF",!0),this.a.set("00:1C:42",!0),this.a.set("00:16:3E",!0),this.a.set("08:00:27",!0)),!!this.a.findSubstr(b)}value(){if(this.b===void 0){let b=0,l=0;const g=(0,D.networkInterfaces)();for(const y in g){const w=g[y];if(w)for(const{mac:c,internal:u}of w)u||(l+=1,this.c(c.toUpperCase())&&(b+=1))}this.b=l>0?b/l:0}return this.b}};let C;async function S(b){return C||(C=(async()=>await d(b)||L.$ig())()),C}e.$Ym=S;async function d(b){try{const l=await new Promise((y,w)=>{ie(["crypto"],y,w)}),g=(0,j.$Wm)();return l.createHash("sha256").update(g,"utf8").digest("hex")}catch(l){b(l);return}}const R="Software\\Microsoft\\SQMClient";async function E(b){if(O.$i){const l=await new Promise((g,y)=>{ie(["@vscode/windows-registry"],g,y)});try{return l.GetStringRegKey("HKEY_LOCAL_MACHINE",R,"MachineId")||""}catch(g){return b(g),""}}return""}e.$Zm=E}),define(ae[31],ce([0,1,53,36,268,6,48,88,16,5,19,10]),function(ie,e,D,A,L,j,O,C,S,d,R,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.writeFileSync=e.configureFlushOnWrite=e.SymlinkSupport=e.whenDeleted=e.readdirSync=e.rimrafSync=e.RimRafMode=void 0;var b;(function(Q){Q[Q.UNLINK=0]="UNLINK",Q[Q.MOVE=1]="MOVE"})(b||(e.RimRafMode=b={}));async function l(Q,x=b.UNLINK,H){if((0,O.$5f)(Q))throw new Error("rimraf - will refuse to recursively delete root");return x===b.UNLINK?y(Q):g(Q,H)}async function g(Q,x=(0,O.$0f)((0,A.tmpdir)())){try{try{await D.promises.rename(Q,x)}catch(H){return H.code==="ENOENT"?void 0:y(Q)}y(x).catch(H=>{})}catch(H){if(H.code!=="ENOENT")throw H}}async function y(Q){return(0,L.promisify)(D.rm)(Q,{recursive:!0,force:!0,maxRetries:3})}function w(Q){if((0,O.$5f)(Q))throw new Error("rimraf - will refuse to recursively delete root");D.rmSync(Q,{recursive:!0,force:!0,maxRetries:3})}e.rimrafSync=w;async function c(Q,x){return m(await(x?u(Q):(0,L.promisify)(D.readdir)(Q)))}async function u(Q){try{return await(0,L.promisify)(D.readdir)(Q,{withFileTypes:!0})}catch(Z){console.warn("[node.js fs] readdir with filetypes failed with error: ",Z)}const x=[],H=await c(Q);for(const Z of H){let J=!1,W=!1,ee=!1;try{const ne=await e.Promises.lstat((0,S.$ic)(Q,Z));J=ne.isFile(),W=ne.isDirectory(),ee=ne.isSymbolicLink()}catch(ne){console.warn("[node.js fs] unexpected error from lstat after readdir: ",ne)}x.push({name:Z,isFile:()=>J,isDirectory:()=>W,isSymbolicLink:()=>ee})}return x}function h(Q){return m(D.readdirSync(Q))}e.readdirSync=h;function m(Q){return Q.map(x=>typeof x=="string"?d.$j?(0,C.$ul)(x):x:(x.name=d.$j?(0,C.$ul)(x.name):x.name,x))}async function k(Q){const x=await c(Q),H=[];for(const Z of x)await a.existsDirectory((0,S.$ic)(Q,Z))&&H.push(Z);return H}function s(Q,x=1e3){return new Promise(H=>{let Z=!1;const J=setInterval(()=>{Z||(Z=!0,D.access(Q,W=>{Z=!1,W&&(clearInterval(J),H(void 0))}))},x)})}e.whenDeleted=s;var a;(function(Q){async function x(J){let W;try{if(W=await e.Promises.lstat(J),!W.isSymbolicLink())return{stat:W}}catch{}try{return{stat:await e.Promises.stat(J),symbolicLink:W?.isSymbolicLink()?{dangling:!1}:void 0}}catch(ee){if(ee.code==="ENOENT"&&W)return{stat:W,symbolicLink:{dangling:!0}};if(d.$i&&ee.code==="EACCES")try{return{stat:await e.Promises.stat(await e.Promises.readlink(J)),symbolicLink:{dangling:!1}}}catch(ne){if(ne.code==="ENOENT"&&W)return{stat:W,symbolicLink:{dangling:!0}};throw ne}throw ee}}Q.stat=x;async function H(J){try{const{stat:W,symbolicLink:ee}=await Q.stat(J);return W.isFile()&&ee?.dangling!==!0}catch{}return!1}Q.existsFile=H;async function Z(J){try{const{stat:W,symbolicLink:ee}=await Q.stat(J);return W.isDirectory()&&ee?.dangling!==!0}catch{}return!1}Q.existsDirectory=Z})(a||(e.SymlinkSupport=a={}));const n=new j.$7g;function i(Q,x,H){return n.queueFor(E.URI.file(Q),R.$qg).queue(()=>{const Z=$(H);return new Promise((J,W)=>o(Q,x,Z,ee=>ee?W(ee):J()))})}let t=!0;function r(Q){t=Q}e.configureFlushOnWrite=r;function o(Q,x,H,Z){if(!t)return D.writeFile(Q,x,{mode:H.mode,flag:H.flag},Z);D.open(Q,H.flag,H.mode,(J,W)=>{if(J)return Z(J);D.writeFile(W,x,ee=>{if(ee)return D.close(W,()=>Z(ee));D.fdatasync(W,ne=>(ne&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",ne),r(!1)),D.close(W,_=>Z(_))))})})}function v(Q,x,H){const Z=$(H);if(!t)return D.writeFileSync(Q,x,{mode:Z.mode,flag:Z.flag});const J=D.openSync(Q,Z.flag,Z.mode);try{D.writeFileSync(J,x);try{D.fdatasyncSync(J)}catch(W){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",W),r(!1)}}finally{D.closeSync(J)}}e.writeFileSync=v;function $(Q){return Q?{mode:typeof Q.mode=="number"?Q.mode:438,flag:typeof Q.flag=="string"?Q.flag:"w"}:{mode:438,flag:"w"}}async function f(Q,x,H=6e4){if(Q!==x)try{d.$i&&typeof H=="number"?await p(Q,x,Date.now(),H):await(0,L.promisify)(D.rename)(Q,x)}catch(Z){if(Q.toLowerCase()!==x.toLowerCase()&&Z.code==="EXDEV"||Q.endsWith("."))await I(Q,x,{preserveSymlinks:!1}),await l(Q,b.MOVE);else throw Z}}async function p(Q,x,H,Z,J=0){try{return await(0,L.promisify)(D.rename)(Q,x)}catch(W){if(W.code!=="EACCES"&&W.code!=="EPERM"&&W.code!=="EBUSY")throw W;if(Date.now()-H>=Z)throw console.error(`[node.js fs] rename failed after ${J} retries with error: ${W}`),W;if(J===0){let ee=!1;try{const{stat:ne}=await a.stat(x);ne.isFile()||(ee=!0)}catch{}if(ee)throw W}return await(0,j.$Yg)(Math.min(100,J*10)),p(Q,x,H,Z,J+1)}}async function I(Q,x,H){return M(Q,x,{root:{source:Q,target:x},options:H,handledSourcePaths:new Set})}const T=511;async function M(Q,x,H){if(H.handledSourcePaths.has(Q))return;H.handledSourcePaths.add(Q);const{stat:Z,symbolicLink:J}=await a.stat(Q);if(J){if(H.options.preserveSymlinks)try{return await Y(Q,x,H)}catch(W){console.warn("[node.js fs] copy of symlink failed: ",W)}if(J.dangling)return}return Z.isDirectory()?z(Q,x,Z.mode&T,H):q(Q,x,Z.mode&T)}async function z(Q,x,H,Z){await e.Promises.mkdir(x,{recursive:!0,mode:H});const J=await c(Q);for(const W of J)await M((0,S.$ic)(Q,W),(0,S.$ic)(x,W),Z)}async function q(Q,x,H){await e.Promises.copyFile(Q,x),await e.Promises.chmod(x,H)}async function Y(Q,x,H){let Z=await e.Promises.readlink(Q);(0,O.$2f)(Z,H.root.source,!d.$k)&&(Z=(0,S.$ic)(H.root.target,Z.substr(H.root.source.length+1))),await e.Promises.symlink(Z,x)}e.Promises=new class{get access(){return(0,L.promisify)(D.access)}get stat(){return(0,L.promisify)(D.stat)}get lstat(){return(0,L.promisify)(D.lstat)}get utimes(){return(0,L.promisify)(D.utimes)}get read(){return(Q,x,H,Z,J)=>new Promise((W,ee)=>{D.read(Q,x,H,Z,J,(ne,_,se)=>ne?ee(ne):W({bytesRead:_,buffer:se}))})}get readFile(){return(0,L.promisify)(D.readFile)}get write(){return(Q,x,H,Z,J)=>new Promise((W,ee)=>{D.write(Q,x,H,Z,J,(ne,_,se)=>ne?ee(ne):W({bytesWritten:_,buffer:se}))})}get appendFile(){return(0,L.promisify)(D.appendFile)}get fdatasync(){return(0,L.promisify)(D.fdatasync)}get truncate(){return(0,L.promisify)(D.truncate)}get copyFile(){return(0,L.promisify)(D.copyFile)}get open(){return(0,L.promisify)(D.open)}get close(){return(0,L.promisify)(D.close)}get symlink(){return(0,L.promisify)(D.symlink)}get readlink(){return(0,L.promisify)(D.readlink)}get chmod(){return(0,L.promisify)(D.chmod)}get mkdir(){return(0,L.promisify)(D.mkdir)}get unlink(){return(0,L.promisify)(D.unlink)}get rmdir(){return(0,L.promisify)(D.rmdir)}get realpath(){return(0,L.promisify)(D.realpath)}async exists(Q){try{return await e.Promises.access(Q),!0}catch{return!1}}get readdir(){return c}get readDirsInDir(){return k}get writeFile(){return i}get rm(){return l}get rename(){return f}get copy(){return I}}}),define(ae[143],ce([0,1,53,16,5,27,31]),function(ie,e,D,A,L,j,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bq=e.$aq=e.$_p=e.$$p=void 0;function C(b){if(L.$k)return b;const l=(0,A.$lc)(b);if(b===l)return b;const g=((0,A.$mc)(b)||b).toLowerCase();try{const w=(0,O.readdirSync)(l).filter(c=>c.toLowerCase()===g);if(w.length===1){const c=C(l);if(c)return(0,A.$ic)(c,w[0])}else if(w.length>1){const c=w.indexOf(g);if(c>=0){const u=C(l);if(u)return(0,A.$ic)(u,w[c])}}}catch{}return null}e.$$p=C;async function S(b){if(L.$k)return b;const l=(0,A.$lc)(b);if(b===l)return b;const g=((0,A.$mc)(b)||b).toLowerCase();try{const w=(await O.Promises.readdir(l)).filter(c=>c.toLowerCase()===g);if(w.length===1){const c=await S(l);if(c)return(0,A.$ic)(c,w[0])}else if(w.length>1){const c=w.indexOf(g);if(c>=0){const u=await S(l);if(u)return(0,A.$ic)(u,w[c])}}}catch{}return null}e.$_p=S;async function d(b){try{return await O.Promises.realpath(b)}catch{const g=E(b);return await O.Promises.access(g,D.constants.R_OK),g}}e.$aq=d;function R(b){try{return D.realpathSync(b)}catch{const g=E(b);return D.accessSync(g,D.constants.R_OK),g}}e.$bq=R;function E(b){return(0,j.$Oe)((0,A.$gc)(b),A.sep)}}),define(ae[144],ce([0,1,16,5,37,90,12,31]),function(ie,e,D,A,L,j,O,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.$Il=e.$Hl=e.TerminateResponseCode=e.Source=void 0,Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return j.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return j.TerminateResponseCode}});function S(E=L.env){return E.comspec||"cmd.exe"}e.$Hl=S;function d(E){let b=[],l=!1;const g=function(y){if(l){b.push(y);return}(!E.send(y,c=>{if(c&&console.error(c),l=!1,b.length>0){const u=b.slice(0);b=[],u.forEach(h=>g(h))}})||A.$i)&&(l=!0)};return{send:g}}e.$Il=d;var R;(function(E){async function b(l,g,y){if(D.$hc(l))return l;if(g===void 0&&(g=L.cwd()),D.$lc(l)!=="."||(y===void 0&&O.$Cf(L.env.PATH)&&(y=L.env.PATH.split(D.$sc)),y===void 0||y.length===0))return D.$ic(g,l);async function c(u){if(await C.Promises.exists(u)){let h;try{h=await C.Promises.stat(u)}catch(m){m.message.startsWith("EACCES")&&(h=await C.Promises.lstat(u))}return h?!h.isDirectory():!1}return!1}for(const u of y){let h;if(D.$hc(u)?h=D.$ic(u,l):h=D.$ic(g,u,l),await c(h))return h;let m=h+".com";if(await c(m)||(m=h+".exe",await c(m)))return m}return D.$ic(g,l)}E.findExecutable=b})(R||(e.win32=R={}))}),define(ae[145],ce([0,1,66,23]),function(ie,e,D,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ir=void 0;function L(O){return new Promise((C,S)=>{let d;const R=new Map;function E(l,g,y,w,c){const u=R.get(g);if(l===O||u){const h={name:b(y),cmd:y,pid:l,ppid:g,load:w,mem:c};R.set(l,h),l===O&&(d=h),u&&(u.children||(u.children=[]),u.children.push(h),u.children.length>1&&(u.children=u.children.sort((m,k)=>m.pid-k.pid)))}}function b(l){const g=/--utility-sub-type=network/i,y=/--ms-enable-electron-run-as-node/i,w=/--crashes-directory/i,c=/\\pipe\\winpty-control/i,u=/conhost\.exe.+--headless/i,h=/--type=([a-zA-Z-]+)/;if(w.exec(l))return"electron-crash-reporter";if(c.exec(l))return"winpty-agent";if(u.exec(l))return"conpty-agent";let m=h.exec(l);if(m&&m.length===2)return m[1]==="renderer"?"window":m[1]==="utility"?g.exec(l)?"utility-network-service":"utility-process":m[1]==="extensionHost"?"extension-host":m[1];const k=/[a-zA-Z-]+\.js/g;let s="";do m=k.exec(l),m&&(s+=m+" ");while(m);return s&&l.indexOf("node ")<0&&l.indexOf("node.exe")<0?`electron-nodejs (${s})`:y.exec(l)?`electron-nodejs (${l})`:l}if(process.platform==="win32"){const l=g=>g.indexOf("\\\\?\\")===0||g.indexOf("\\??\\")===0?g.substring(4):g.indexOf('"\\\\?\\')===0||g.indexOf('"\\??\\')===0?'"'+g.substring(5):g;new Promise((g,y)=>{ie(["@vscode/windows-process-tree"],g,y)}).then(g=>{g.getProcessList(O,y=>{if(!y){S(new Error(`Root process ${O} not found`));return}g.getProcessCpuUsage(y,w=>{const c=new Map;w.forEach(u=>{const h=l(u.commandLine||"");c.set(u.pid,{name:b(h),cmd:h,pid:u.pid,ppid:u.ppid,load:u.cpu||0,mem:u.memory||0})}),d=c.get(O),d?(c.forEach(u=>{const h=c.get(u.ppid);h&&(h.children||(h.children=[]),h.children.push(u))}),c.forEach(u=>{u.children&&(u.children=u.children.sort((h,m)=>h.pid-m.pid))}),C(d)):S(new Error(`Root process ${O} not found`))})},g.ProcessDataFlag.CommandLine|g.ProcessDataFlag.Memory)})}else{let l=function(){let g=[d];const y=[];for(;g.length;){const c=g.shift();c&&(y.push(c.pid),c.children&&(g=g.concat(c.children)))}let w=JSON.stringify(A.$gg.asFileUri("vs/base/node/cpuUsage.sh").fsPath);w+=" "+y.join(" "),(0,D.exec)(w,{},(c,u,h)=>{if(c||h)S(c||new Error(h.toString()));else{const m=u.toString().split(`
`);for(let k=0;k<y.length;k++){const s=R.get(y[k]);s.load=parseFloat(m[k])}if(!d){S(new Error(`Root process ${O} not found`));return}C(d)}})};(0,D.exec)("which ps",{},(g,y,w)=>{if(g||w)if(process.platform!=="linux")S(g||new Error(w.toString()));else{const c=JSON.stringify(A.$gg.asFileUri("vs/base/node/ps.sh").fsPath);(0,D.exec)(c,{},(u,h,m)=>{u||m?S(u||new Error(m.toString())):(j(h,E),l())})}else{const c=y.toString().trim(),u="-ax -o pid=,ppid=,pcpu=,pmem=,command=";(0,D.exec)(`${c} ${u}`,{maxBuffer:1e3*1024,env:{LC_NUMERIC:"en_US.UTF-8"}},(h,m,k)=>{h||k&&!k.includes("screen size is bogus")?S(h||new Error(k.toString())):(j(m,E),process.platform==="linux"?l():d?C(d):S(new Error(`Root process ${O} not found`)))})}})}})}e.$Ir=L;function j(O,C){const S=/^\s*([0-9]+)\s+([0-9]+)\s+([0-9]+\.[0-9]+)\s+([0-9]+\.[0-9]+)\s+(.+)$/,d=O.toString().split(`
`);for(const R of d){const E=S.exec(R.trim());E&&E.length===6&&C(parseInt(E[1]),parseInt(E[2]),E[5],parseFloat(E[3]),parseFloat(E[4]))}}});var pe=this&&this.__decorate||function(ie,e,D,A){var L=arguments.length,j=L<3?e:A===null?A=Object.getOwnPropertyDescriptor(e,D):A,O;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")j=Reflect.decorate(ie,e,D,A);else for(var C=ie.length-1;C>=0;C--)(O=ie[C])&&(j=(L<3?O(j):L>3?O(e,D,j):O(e,D))||j);return L>3&&j&&Object.defineProperty(e,D,j),j};define(ae[40],ce([0,1,18,6,15,26,84,7,3,2,65,27,12]),function(ie,e,D,A,L,j,O,C,S,d,R,E,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Eh=e.ProxyChannel=e.$Dh=e.$Ch=e.$Bh=e.$Ah=e.$zh=e.$yh=e.RequestInitiator=e.$xh=e.$wh=e.$vh=e.$uh=e.$th=void 0;var l;(function(J){J[J.Promise=100]="Promise",J[J.PromiseCancel=101]="PromiseCancel",J[J.EventListen=102]="EventListen",J[J.EventDispose=103]="EventDispose"})(l||(l={}));function g(J){switch(J){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var y;(function(J){J[J.Initialize=200]="Initialize",J[J.PromiseSuccess=201]="PromiseSuccess",J[J.PromiseError=202]="PromiseError",J[J.PromiseErrorObj=203]="PromiseErrorObj",J[J.EventFire=204]="EventFire"})(y||(y={}));function w(J){switch(J){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var c;(function(J){J[J.Uninitialized=0]="Uninitialized",J[J.Idle=1]="Idle"})(c||(c={}));function u(J){let W=0;for(let ee=0;;ee+=7){const ne=J.read(1);if(W|=(ne.buffer[0]&127)<<ee,!(ne.buffer[0]&128))return W}}const h=n(0);function m(J,W){if(W===0){J.write(h);return}let ee=0;for(let _=W;_!==0;_=_>>>7)ee++;const ne=L.$fe.alloc(ee);for(let _=0;W!==0;_++)ne.buffer[_]=W&127,W=W>>>7,W>0&&(ne.buffer[_]|=128);J.write(ne)}class k{constructor(W){this.b=W,this.a=0}read(W){const ee=this.b.slice(this.a,this.a+W);return this.a+=ee.byteLength,ee}}e.$th=k;class s{constructor(){this.a=[]}get buffer(){return L.$fe.concat(this.a)}write(W){this.a.push(W)}}e.$uh=s;var a;(function(J){J[J.Undefined=0]="Undefined",J[J.String=1]="String",J[J.Buffer=2]="Buffer",J[J.VSBuffer=3]="VSBuffer",J[J.Array=4]="Array",J[J.Object=5]="Object",J[J.Int=6]="Int"})(a||(a={}));function n(J){const W=L.$fe.alloc(1);return W.writeUInt8(J,0),W}const i={Undefined:n(a.Undefined),String:n(a.String),Buffer:n(a.Buffer),VSBuffer:n(a.VSBuffer),Array:n(a.Array),Object:n(a.Object),Uint:n(a.Int)},t=typeof Buffer<"u";function r(J,W){if(typeof W>"u")J.write(i.Undefined);else if(typeof W=="string"){const ee=L.$fe.fromString(W);J.write(i.String),m(J,ee.byteLength),J.write(ee)}else if(t&&Buffer.isBuffer(W)){const ee=L.$fe.wrap(W);J.write(i.Buffer),m(J,ee.byteLength),J.write(ee)}else if(W instanceof L.$fe)J.write(i.VSBuffer),m(J,W.byteLength),J.write(W);else if(Array.isArray(W)){J.write(i.Array),m(J,W.length);for(const ee of W)r(J,ee)}else if(typeof W=="number"&&(W|0)===W)J.write(i.Uint),m(J,W);else{const ee=L.$fe.fromString(JSON.stringify(W));J.write(i.Object),m(J,ee.byteLength),J.write(ee)}}e.$vh=r;function o(J){switch(J.read(1).readUInt8(0)){case a.Undefined:return;case a.String:return J.read(u(J)).toString();case a.Buffer:return J.read(u(J)).buffer;case a.VSBuffer:return J.read(u(J));case a.Array:{const ee=u(J),ne=[];for(let _=0;_<ee;_++)ne.push(o(J));return ne}case a.Object:return JSON.parse(J.read(u(J)).toString());case a.Int:return u(J)}}e.$wh=o;class v{constructor(W,ee,ne=null,_=1e3){this.h=W,this.j=ee,this.k=ne,this.l=_,this.b=new Map,this.d=new Map,this.g=new Map,this.f=this.h.onMessage(se=>this.q(se)),this.m({type:200})}registerChannel(W,ee){this.b.set(W,ee),setTimeout(()=>this.w(W),0)}m(W){switch(W.type){case 200:{const ee=this.o([W.type]);this.k?.logOutgoing(ee,0,1,w(W.type));return}case 201:case 202:case 204:case 203:{const ee=this.o([W.type,W.id],W.data);this.k?.logOutgoing(ee,W.id,1,w(W.type),W.data);return}}}o(W,ee=void 0){const ne=new s;return r(ne,W),r(ne,ee),this.p(ne.buffer)}p(W){try{return this.h.send(W),W.byteLength}catch{return 0}}q(W){const ee=new k(W),ne=o(ee),_=o(ee),se=ne[0];switch(se){case 100:return this.k?.logIncoming(W.byteLength,ne[1],1,`${g(se)}: ${ne[2]}.${ne[3]}`,_),this.s({type:se,id:ne[1],channelName:ne[2],name:ne[3],arg:_});case 102:return this.k?.logIncoming(W.byteLength,ne[1],1,`${g(se)}: ${ne[2]}.${ne[3]}`,_),this.t({type:se,id:ne[1],channelName:ne[2],name:ne[3],arg:_});case 101:return this.k?.logIncoming(W.byteLength,ne[1],1,`${g(se)}`),this.u({type:se,id:ne[1]});case 103:return this.k?.logIncoming(W.byteLength,ne[1],1,`${g(se)}`),this.u({type:se,id:ne[1]})}}s(W){const ee=this.b.get(W.channelName);if(!ee){this.v(W);return}const ne=new j.$2d;let _;try{_=ee.call(this.j,W.name,W.arg,ne.token)}catch(U){_=Promise.reject(U)}const se=W.id;_.then(U=>{this.m({id:se,data:U,type:201})},U=>{U instanceof Error?this.m({id:se,data:{message:U.message,name:U.name,stack:U.stack?U.stack.split?U.stack.split(`
`):U.stack:void 0},type:202}):this.m({id:se,data:U,type:203})}).finally(()=>{K.dispose(),this.d.delete(W.id)});const K=(0,d.$Pc)(()=>ne.cancel());this.d.set(W.id,K)}t(W){const ee=this.b.get(W.channelName);if(!ee){this.v(W);return}const ne=W.id,se=ee.listen(this.j,W.name,W.arg)(K=>this.m({id:ne,data:K,type:204}));this.d.set(W.id,se)}u(W){const ee=this.d.get(W.id);ee&&(ee.dispose(),this.d.delete(W.id))}v(W){let ee=this.g.get(W.channelName);ee||(ee=[],this.g.set(W.channelName,ee));const ne=setTimeout(()=>{console.error(`Unknown channel: ${W.channelName}`),W.type===100&&this.m({id:W.id,data:{name:"Unknown channel",message:`Channel name '${W.channelName}' timed out after ${this.l}ms`,stack:void 0},type:202})},this.l);ee.push({request:W,timeoutTimer:ne})}w(W){const ee=this.g.get(W);if(ee){for(const ne of ee)switch(clearTimeout(ne.timeoutTimer),ne.request.type){case 100:this.s(ne.request);break;case 102:this.t(ne.request);break}this.g.delete(W)}}dispose(){this.f&&(this.f.dispose(),this.f=null),(0,d.$Mc)(this.d.values()),this.d.clear()}}e.$xh=v;var $;(function(J){J[J.LocalSide=0]="LocalSide",J[J.OtherSide=1]="OtherSide"})($||(e.RequestInitiator=$={}));class f{constructor(W,ee=null){this.l=W,this.a=!1,this.b=c.Uninitialized,this.d=new Set,this.f=new Map,this.g=0,this.k=new S.$Rd,this.onDidInitialize=this.k.event,this.h=this.l.onMessage(ne=>this.s(ne)),this.j=ee}getChannel(W){const ee=this;return{call(ne,_,se){return ee.a?Promise.reject(new C.$4):ee.m(W,ne,_,se)},listen(ne,_){return ee.a?S.Event.None:ee.o(W,ne,_)}}}m(W,ee,ne,_=j.CancellationToken.None){const se=this.g++,U={id:se,type:100,channelName:W,name:ee,arg:ne};if(_.isCancellationRequested)return Promise.reject(new C.$4);let P;return new Promise((B,N)=>{if(_.isCancellationRequested)return N(new C.$4);const V=()=>{const ue=he=>{switch(he.type){case 201:this.f.delete(se),B(he.data);break;case 202:{this.f.delete(se);const ge=new Error(he.data.message);ge.stack=Array.isArray(he.data.stack)?he.data.stack.join(`
`):he.data.stack,ge.name=he.data.name,N(ge);break}case 203:this.f.delete(se),N(he.data);break}};this.f.set(se,ue),this.p(U)};let G=null;this.b===c.Idle?V():(G=(0,A.$Lg)(ue=>this.u()),G.then(()=>{G=null,V()}));const te=()=>{G?(G.cancel(),G=null):this.p({id:se,type:101}),N(new C.$4)},oe=_.onCancellationRequested(te);P=(0,d.$Oc)((0,d.$Pc)(te),oe),this.d.add(P)}).finally(()=>{P.dispose(),this.d.delete(P)})}o(W,ee,ne){const _=this.g++,K={id:_,type:102,channelName:W,name:ee,arg:ne};let U=null;const P=new S.$Rd({onWillAddFirstListener:()=>{U=(0,A.$Lg)(B=>this.u()),U.then(()=>{U=null,this.d.add(P),this.p(K)})},onDidRemoveLastListener:()=>{U?(U.cancel(),U=null):(this.d.delete(P),this.p({id:_,type:103}))}}),F=B=>P.fire(B.data);return this.f.set(_,F),P.event}p(W){switch(W.type){case 100:case 102:{const ee=this.q([W.type,W.id,W.channelName,W.name],W.arg);this.j?.logOutgoing(ee,W.id,0,`${g(W.type)}: ${W.channelName}.${W.name}`,W.arg);return}case 101:case 103:{const ee=this.q([W.type,W.id]);this.j?.logOutgoing(ee,W.id,0,g(W.type));return}}}q(W,ee=void 0){const ne=new s;return r(ne,W),r(ne,ee),this.r(ne.buffer)}r(W){try{return this.l.send(W),W.byteLength}catch{return 0}}s(W){const ee=new k(W),ne=o(ee),_=o(ee),se=ne[0];switch(se){case 200:return this.j?.logIncoming(W.byteLength,0,0,w(se)),this.t({type:ne[0]});case 201:case 202:case 204:case 203:return this.j?.logIncoming(W.byteLength,ne[1],0,w(se),_),this.t({type:ne[0],id:ne[1],data:_})}}t(W){if(W.type===200){this.b=c.Idle,this.k.fire();return}this.f.get(W.id)?.(W)}get onDidInitializePromise(){return S.Event.toPromise(this.onDidInitialize)}u(){return this.b===c.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.a=!0,this.h&&(this.h.dispose(),this.h=null),(0,d.$Mc)(this.d.values()),this.d.clear()}}e.$yh=f,pe([O.$nh],f.prototype,"onDidInitializePromise",null);class p{get connections(){const W=[];return this.f.forEach(ee=>W.push(ee)),W}constructor(W){this.a=new Map,this.f=new Set,this.g=new S.$Rd,this.onDidAddConnection=this.g.event,this.h=new S.$Rd,this.onDidRemoveConnection=this.h.event,this.j=new d.$Qc,this.j.add(W(({protocol:ee,onDidClientDisconnect:ne})=>{const _=S.Event.once(ee.onMessage);this.j.add(_(se=>{const K=new k(se),U=o(K),P=new v(ee,U),F=new f(ee);this.a.forEach((N,V)=>P.registerChannel(V,N));const B={channelServer:P,channelClient:F,ctx:U};this.f.add(B),this.g.fire(B),this.j.add(ne(()=>{P.dispose(),F.dispose(),this.f.delete(B),this.h.fire(B)}))}))}))}getChannel(W,ee){const ne=this;return{call(_,se,K){let U;if((0,b.$Qf)(ee)){const F=(0,D.$3b)(ne.connections.filter(ee));U=F?Promise.resolve(F):S.Event.toPromise(S.Event.filter(ne.onDidAddConnection,ee))}else U=ee.routeCall(ne,_,se);const P=U.then(F=>F.channelClient.getChannel(W));return T(P).call(_,se,K)},listen(_,se){if((0,b.$Qf)(ee))return ne.k(W,ee,_,se);const K=ee.routeEvent(ne,_,se).then(U=>U.channelClient.getChannel(W));return T(K).listen(_,se)}}}k(W,ee,ne,_){const se=this;let K;const U=new S.$Rd({onWillAddFirstListener:()=>{K=new d.$Qc;const P=new S.$Xd,F=new Map,B=V=>{const te=V.channelClient.getChannel(W).listen(ne,_),oe=P.add(te);F.set(V,oe)},N=V=>{const G=F.get(V);G&&(G.dispose(),F.delete(V))};se.connections.filter(ee).forEach(B),S.Event.filter(se.onDidAddConnection,ee)(B,void 0,K),se.onDidRemoveConnection(N,void 0,K),P.event(U.fire,U,K),K.add(P)},onDidRemoveLastListener:()=>{K?.dispose(),K=void 0}});return U.event}registerChannel(W,ee){this.a.set(W,ee);for(const ne of this.f)ne.channelServer.registerChannel(W,ee)}dispose(){this.j.dispose();for(const W of this.f)W.channelClient.dispose(),W.channelServer.dispose();this.f.clear(),this.a.clear(),this.g.dispose(),this.h.dispose()}}e.$zh=p;class I{constructor(W,ee,ne=null){const _=new s;r(_,ee),W.send(_.buffer),this.a=new f(W,ne),this.d=new v(W,ee,ne)}getChannel(W){return this.a.getChannel(W)}registerChannel(W,ee){this.d.registerChannel(W,ee)}dispose(){this.a.dispose(),this.d.dispose()}}e.$Ah=I;function T(J){return{call(W,ee,ne){return J.then(_=>_.call(W,ee,ne))},listen(W,ee){const ne=new S.$1d;return J.then(_=>ne.input=_.listen(W,ee)),ne.event}}}e.$Bh=T;function M(J){let W=!1;return{call(ee,ne,_){return W?J.call(ee,ne,_):(0,A.$Yg)(0).then(()=>W=!0).then(()=>J.call(ee,ne,_))},listen(ee,ne){if(W)return J.listen(ee,ne);const _=new S.$1d;return(0,A.$Yg)(0).then(()=>W=!0).then(()=>_.input=J.listen(ee,ne)),_.event}}}e.$Ch=M;class z{constructor(W){this.a=W}routeCall(W){return this.b(W)}routeEvent(W){return this.b(W)}async b(W){for(const ee of W.connections)if(await Promise.resolve(this.a(ee.ctx)))return Promise.resolve(ee);return await S.Event.toPromise(W.onDidAddConnection),await this.b(W)}}e.$Dh=z;var q;(function(J){function W(se,K,U){const P=se,F=U&&U.disableMarshalling,B=new Map;for(const N in P)ne(N)&&B.set(N,S.Event.buffer(P[N],!0,void 0,K));return new class{listen(N,V,G){const te=B.get(V);if(te)return te;if(_(V)){const oe=P[V];if(typeof oe=="function")return oe.call(P,G)}throw new C.$ab(`Event not found: ${V}`)}call(N,V,G){const te=P[V];if(typeof te=="function"){if(!F&&Array.isArray(G))for(let ue=0;ue<G.length;ue++)G[ue]=(0,R.$sh)(G[ue]);let oe=te.apply(P,G);return oe instanceof Promise||(oe=Promise.resolve(oe)),oe}throw new C.$ab(`Method not found: ${V}`)}}}J.fromService=W;function ee(se,K){const U=K&&K.disableMarshalling;return new Proxy({},{get(P,F){if(typeof F=="string")return K?.properties?.has(F)?K.properties.get(F):_(F)?function(B){return se.listen(F,B)}:ne(F)?se.listen(F):async function(...B){let N;K&&!(0,b.$Lf)(K.context)?N=[K.context,...B]:N=B;const V=await se.call(F,N);return U?V:(0,R.$sh)(V)};throw new C.$ab(`Property not found: ${String(F)}`)}})}J.toService=ee;function ne(se){return se[0]==="o"&&se[1]==="n"&&E.$5e(se.charCodeAt(2))}function _(se){return/^onDynamic/.test(se)&&E.$5e(se.charCodeAt(9))}})(q||(e.ProxyChannel=q={}));const Y=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function Q(J){if(Array.isArray(J))return J;if(J&&typeof J=="object"&&typeof J.toString=="function"){const W=J.toString();if(W!=="[object Object]")return W}return J}function x(J){return Array.isArray(J)?J.map(Q):Q(J)}function H(J,W,ee,ne,_,se,K){K=x(K);const U=Y[_],P=U[ne%U.length];let F=[`%c[${J}]%c[${String(W).padStart(7," ")}]%c[len: ${String(ee).padStart(5," ")}]%c${String(ne).padStart(5," ")} - ${se}`,"color: darkgreen","color: grey","color: grey",`color: ${P}`];/\($/.test(se)?(F=F.concat(K),F.push(")")):F.push(K),console.log.apply(console,F)}class Z{constructor(W,ee){this.d=W,this.f=ee,this.a=0,this.b=0}logOutgoing(W,ee,ne,_,se){this.b+=W,H(this.d,this.b,W,ee,ne,_,se)}logIncoming(W,ee,ne,_,se){this.a+=W,H(this.f,this.a,W,ee,ne,_,se)}}e.$Eh=Z}),define(ae[67],ce([0,1,15,3,2,40]),function(ie,e,D,A,L,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jh=e.$Ih=e.$Hh=e.$Gh=e.ProtocolConstants=e.$Fh=e.SocketCloseEventType=e.SocketDiagnostics=e.SocketDiagnosticsEventType=void 0;var O;(function(i){i.Created="created",i.Read="read",i.Write="write",i.Open="open",i.Error="error",i.Close="close",i.BrowserWebSocketBlobReceived="browserWebSocketBlobReceived",i.NodeEndReceived="nodeEndReceived",i.NodeEndSent="nodeEndSent",i.NodeDrainBegin="nodeDrainBegin",i.NodeDrainEnd="nodeDrainEnd",i.zlibInflateError="zlibInflateError",i.zlibInflateData="zlibInflateData",i.zlibInflateInitialWrite="zlibInflateInitialWrite",i.zlibInflateInitialFlushFired="zlibInflateInitialFlushFired",i.zlibInflateWrite="zlibInflateWrite",i.zlibInflateFlushFired="zlibInflateFlushFired",i.zlibDeflateError="zlibDeflateError",i.zlibDeflateData="zlibDeflateData",i.zlibDeflateWrite="zlibDeflateWrite",i.zlibDeflateFlushFired="zlibDeflateFlushFired",i.WebSocketNodeSocketWrite="webSocketNodeSocketWrite",i.WebSocketNodeSocketPeekedHeader="webSocketNodeSocketPeekedHeader",i.WebSocketNodeSocketReadHeader="webSocketNodeSocketReadHeader",i.WebSocketNodeSocketReadData="webSocketNodeSocketReadData",i.WebSocketNodeSocketUnmaskedData="webSocketNodeSocketUnmaskedData",i.WebSocketNodeSocketDrainBegin="webSocketNodeSocketDrainBegin",i.WebSocketNodeSocketDrainEnd="webSocketNodeSocketDrainEnd",i.ProtocolHeaderRead="protocolHeaderRead",i.ProtocolMessageRead="protocolMessageRead",i.ProtocolHeaderWrite="protocolHeaderWrite",i.ProtocolMessageWrite="protocolMessageWrite",i.ProtocolWrite="protocolWrite"})(O||(e.SocketDiagnosticsEventType=O={}));var C;(function(i){i.enableDiagnostics=!1,i.records=[];const t=new WeakMap;let r=0;function o($,f){if(!t.has($)){const p=String(++r);t.set($,p)}return t.get($)}function v($,f,p,I){if(!i.enableDiagnostics)return;const T=o($,f);if(I instanceof D.$fe||I instanceof Uint8Array||I instanceof ArrayBuffer||ArrayBuffer.isView(I)){const M=D.$fe.alloc(I.byteLength);M.set(I),i.records.push({timestamp:Date.now(),id:T,label:f,type:p,buff:M})}else i.records.push({timestamp:Date.now(),id:T,label:f,type:p,data:I})}i.traceSocketEvent=v})(C||(e.SocketDiagnostics=C={}));var S;(function(i){i[i.NodeSocketCloseEvent=0]="NodeSocketCloseEvent",i[i.WebSocketCloseEvent=1]="WebSocketCloseEvent"})(S||(e.SocketCloseEventType=S={}));let d=null;function R(){return d||(d=D.$fe.alloc(0)),d}class E{get byteLength(){return this.b}constructor(){this.a=[],this.b=0}acceptChunk(t){this.a.push(t),this.b+=t.byteLength}read(t){return this.c(t,!0)}peek(t){return this.c(t,!1)}c(t,r){if(t===0)return R();if(t>this.b)throw new Error("Cannot read so many bytes!");if(this.a[0].byteLength===t){const f=this.a[0];return r&&(this.a.shift(),this.b-=t),f}if(this.a[0].byteLength>t){const f=this.a[0].slice(0,t);return r&&(this.a[0]=this.a[0].slice(t),this.b-=t),f}const o=D.$fe.alloc(t);let v=0,$=0;for(;t>0;){const f=this.a[$];if(f.byteLength>t){const p=f.slice(0,t);o.set(p,v),v+=t,r&&(this.a[$]=f.slice(t),this.b-=t),t-=t}else o.set(f,v),v+=f.byteLength,r?(this.a.shift(),this.b-=f.byteLength):$++,t-=f.byteLength}return o}}e.$Fh=E;var b;(function(i){i[i.None=0]="None",i[i.Regular=1]="Regular",i[i.Control=2]="Control",i[i.Ack=3]="Ack",i[i.Disconnect=5]="Disconnect",i[i.ReplayRequest=6]="ReplayRequest",i[i.Pause=7]="Pause",i[i.Resume=8]="Resume",i[i.KeepAlive=9]="KeepAlive"})(b||(b={}));function l(i){switch(i){case 0:return"None";case 1:return"Regular";case 2:return"Control";case 3:return"Ack";case 5:return"Disconnect";case 6:return"ReplayRequest";case 7:return"PauseWriting";case 8:return"ResumeWriting";case 9:return"KeepAlive"}}var g;(function(i){i[i.HeaderLength=13]="HeaderLength",i[i.AcknowledgeTime=2e3]="AcknowledgeTime",i[i.TimeoutTime=2e4]="TimeoutTime",i[i.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",i[i.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime",i[i.KeepAliveSendTime=5e3]="KeepAliveSendTime"})(g||(e.ProtocolConstants=g={}));class y{constructor(t,r,o,v){this.type=t,this.id=r,this.ack=o,this.data=v,this.writtenTime=0}get size(){return this.data.byteLength}}class w extends L.$Rc{constructor(t){super(),this.f=this.B(new A.$Rd),this.onMessage=this.f.event,this.g={readHead:!0,readLen:13,messageType:0,id:0,ack:0},this.a=t,this.b=!1,this.c=new E,this.B(this.a.onData(r=>this.acceptChunk(r))),this.lastReadTime=Date.now()}acceptChunk(t){if(!(!t||t.byteLength===0))for(this.lastReadTime=Date.now(),this.c.acceptChunk(t);this.c.byteLength>=this.g.readLen;){const r=this.c.read(this.g.readLen);if(this.g.readHead)this.g.readHead=!1,this.g.readLen=r.readUInt32BE(9),this.g.messageType=r.readUInt8(0),this.g.id=r.readUInt32BE(1),this.g.ack=r.readUInt32BE(5),this.a.traceSocketEvent("protocolHeaderRead",{messageType:l(this.g.messageType),id:this.g.id,ack:this.g.ack,messageSize:this.g.readLen});else{const o=this.g.messageType,v=this.g.id,$=this.g.ack;if(this.g.readHead=!0,this.g.readLen=13,this.g.messageType=0,this.g.id=0,this.g.ack=0,this.a.traceSocketEvent("protocolMessageRead",r),this.f.fire(new y(o,v,$,r)),this.b)break}}}readEntireBuffer(){return this.c.read(this.c.byteLength)}dispose(){this.b=!0,super.dispose()}}class c{constructor(t){this.k=null,this.a=!1,this.b=!1,this.c=t,this.d=[],this.f=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch{}this.a=!0}drain(){return this.flush(),this.c.drain()}flush(){this.m()}pause(){this.b=!0}resume(){this.b=!1,this.l()}write(t){if(this.a)return;t.writtenTime=Date.now(),this.lastWriteTime=Date.now();const r=D.$fe.alloc(13);r.writeUInt8(t.type,0),r.writeUInt32BE(t.id,1),r.writeUInt32BE(t.ack,5),r.writeUInt32BE(t.data.byteLength,9),this.c.traceSocketEvent("protocolHeaderWrite",{messageType:l(t.type),id:t.id,ack:t.ack,messageSize:t.data.byteLength}),this.c.traceSocketEvent("protocolMessageWrite",t.data),this.j(r,t.data)}g(t,r){const o=this.f===0;return this.d.push(t,r),this.f+=t.byteLength+r.byteLength,o}h(){const t=D.$fe.concat(this.d,this.f);return this.d.length=0,this.f=0,t}j(t,r){this.g(t,r)&&this.l()}l(){this.k||(this.k=setTimeout(()=>{this.k=null,this.m()}))}m(){if(this.f===0||this.b)return;const t=this.h();this.c.traceSocketEvent("protocolWrite",{byteLength:t.byteLength}),this.c.write(t)}}class u extends L.$Rc{constructor(t){super(),this.f=new A.$Rd,this.onMessage=this.f.event,this.g=new A.$Rd,this.onDidDispose=this.g.event,this.a=t,this.b=this.B(new c(this.a)),this.c=this.B(new w(this.a)),this.B(this.c.onMessage(r=>{r.type===1&&this.f.fire(r.data)})),this.B(this.a.onClose(()=>this.g.fire()))}drain(){return this.b.drain()}getSocket(){return this.a}sendDisconnect(){}send(t){this.b.write(new y(1,0,0,t))}}e.$Gh=u;class h extends j.$Ah{static fromSocket(t,r){return new h(new u(t),r)}get onDidDispose(){return this.b.onDidDispose}constructor(t,r,o=null){super(t,r,o),this.b=t}dispose(){super.dispose();const t=this.b.getSocket();this.b.sendDisconnect(),this.b.dispose(),t.end()}}e.$Hh=h;class m{constructor(){this.b=!1,this.c=!1,this.d=[],this.a=new A.$Rd({onWillAddFirstListener:()=>{this.b=!0,queueMicrotask(()=>this.f())},onDidRemoveLastListener:()=>{this.b=!1}}),this.event=this.a.event}f(){if(!this.c){for(this.c=!0;this.b&&this.d.length>0;)this.a.fire(this.d.shift());this.c=!1}}fire(t){this.b?this.d.length>0?this.d.push(t):this.a.fire(t):this.d.push(t)}flushBuffer(){this.d=[]}}e.$Ih=m;class k{constructor(t){this.data=t,this.next=null}}class s{constructor(){this.a=null,this.b=null}length(){let t=0,r=this.a;for(;r;)r=r.next,t++;return t}peek(){return this.a?this.a.data:null}toArray(){const t=[];let r=0,o=this.a;for(;o;)t[r++]=o.data,o=o.next;return t}pop(){if(this.a){if(this.a===this.b){this.a=null,this.b=null;return}this.a=this.a.next}}push(t){const r=new k(t);if(!this.a){this.a=r,this.b=r;return}this.b.next=r,this.b=r}}class a{static{this.a=10}static{this.b=null}static getInstance(){return a.b||(a.b=new a),a.b}constructor(){this.c=[];const t=Date.now();for(let r=0;r<a.a;r++)this.c[r]=t-1e3*r;setInterval(()=>{for(let r=a.a;r>=1;r--)this.c[r]=this.c[r-1];this.c[0]=Date.now()},1e3)}d(){const t=Date.now(),r=(1+a.a)*1e3;let o=0;for(let v=0;v<a.a;v++)t-this.c[v]<=r&&o++;return 1-o/a.a}hasHighLoad(){return this.d()>=.5}}class n{get unacknowledgedCount(){return this.c-this.d}constructor(t){this.u=new m,this.onControlMessage=this.u.event,this.v=new m,this.onMessage=this.v.event,this.w=new m,this.onDidDispose=this.w.event,this.x=new m,this.onSocketClose=this.x.event,this.y=new m,this.onSocketTimeout=this.y.event,this.s=t.loadEstimator??a.getInstance(),this.t=t.sendKeepAlive??!0,this.a=!1,this.b=new s,this.c=0,this.d=0,this.f=null,this.g=0,this.h=0,this.j=0,this.k=null,this.m=0,this.n=Date.now(),this.r=new L.$Qc,this.o=t.socket,this.p=this.r.add(new c(this.o)),this.q=this.r.add(new w(this.o)),this.r.add(this.q.onMessage(r=>this.z(r))),this.r.add(this.o.onClose(r=>this.x.fire(r))),t.initialChunk&&this.q.acceptChunk(t.initialChunk),this.t?this.l=setInterval(()=>{this.D()},5e3):this.l=null}dispose(){this.f&&(clearTimeout(this.f),this.f=null),this.k&&(clearTimeout(this.k),this.k=null),this.l&&(clearInterval(this.l),this.l=null),this.r.dispose()}drain(){return this.p.drain()}sendDisconnect(){const t=new y(5,0,0,R());this.p.write(t),this.p.flush()}sendPause(){const t=new y(7,0,0,R());this.p.write(t)}sendResume(){const t=new y(8,0,0,R());this.p.write(t)}pauseSocketWriting(){this.p.pause()}getSocket(){return this.o}getMillisSinceLastIncomingData(){return Date.now()-this.q.lastReadTime}beginAcceptReconnection(t,r){this.a=!0,this.r.dispose(),this.r=new L.$Qc,this.u.flushBuffer(),this.x.flushBuffer(),this.y.flushBuffer(),this.o.dispose(),this.m=0,this.n=Date.now(),this.o=t,this.p=this.r.add(new c(this.o)),this.q=this.r.add(new w(this.o)),this.r.add(this.q.onMessage(o=>this.z(o))),this.r.add(this.o.onClose(o=>this.x.fire(o))),this.q.acceptChunk(r)}endAcceptReconnection(){this.a=!1,this.h=this.g;const t=new y(3,0,this.h,R());this.p.write(t);const r=this.b.toArray();for(let o=0,v=r.length;o<v;o++)this.p.write(r[o]);this.B()}acceptDisconnect(){this.w.fire()}z(t){if(t.ack>this.d){this.d=t.ack;do{const r=this.b.peek();if(r&&r.id<=t.ack)this.b.pop();else break}while(!0)}switch(t.type){case 0:break;case 1:{if(t.id>this.g)if(t.id!==this.g+1){const r=Date.now();r-this.m>1e4&&(this.m=r,this.p.write(new y(6,0,0,R())))}else this.g=t.id,this.j=Date.now(),this.A(),this.v.fire(t.data);break}case 2:{this.u.fire(t.data);break}case 3:break;case 5:{this.w.fire();break}case 6:{const r=this.b.toArray();for(let o=0,v=r.length;o<v;o++)this.p.write(r[o]);this.B();break}case 7:{this.p.pause();break}case 8:{this.p.resume();break}case 9:break}}readEntireBuffer(){return this.q.readEntireBuffer()}flush(){this.p.flush()}send(t){const r=++this.c;this.h=this.g;const o=new y(1,r,this.h,t);this.b.push(o),this.a||(this.p.write(o),this.B())}sendControl(t){const r=new y(2,0,0,t);this.p.write(r)}A(){if(this.g<=this.h||this.k)return;const t=Date.now()-this.j;if(t>=2e3){this.C();return}this.k=setTimeout(()=>{this.k=null,this.A()},2e3-t+5)}B(){if(this.c<=this.d||this.f||this.a)return;const t=this.b.peek(),r=Date.now()-t.writtenTime,o=Date.now()-this.q.lastReadTime,v=Date.now()-this.n;if(r>=2e4&&o>=2e4&&v>=2e4&&!this.s.hasHighLoad()){this.n=Date.now(),this.y.fire({unacknowledgedMsgCount:this.b.length(),timeSinceOldestUnacknowledgedMsg:r,timeSinceLastReceivedSomeData:o});return}const $=Math.max(2e4-r,2e4-o,2e4-v,500);this.f=setTimeout(()=>{this.f=null,this.B()},$)}C(){if(this.g<=this.h)return;this.h=this.g;const t=new y(3,0,this.h,R());this.p.write(t)}D(){this.h=this.g;const t=new y(9,0,this.h,R());this.p.write(t)}}e.$Jh=n}),define(ae[93],ce([0,1,66,6,15,26,140,7,3,2,30,144,90,40]),function(ie,e,D,A,L,j,O,C,S,d,R,E,b,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9p=e.$8p=void 0;class g extends l.$xh{constructor(c){super({send:u=>{try{process.send?.(u.buffer.toString("base64"))}catch{}},onMessage:S.Event.fromNodeEventEmitter(process,"message",u=>L.$fe.wrap(Buffer.from(u,"base64")))},c),process.once("disconnect",()=>this.dispose())}}e.$8p=g;class y{constructor(c,u){this.i=c,this.j=u,this.c=new Set,this.g=new Map,this.h=new S.$Rd,this.onDidProcessExit=this.h.event;const h=u&&u.timeout?u.timeout:6e4;this.b=new A.$Ug(h),this.d=null,this.f=null}getChannel(c){const u=this;return{call(h,m,k){return u.k(c,h,m,k)},listen(h,m){return u.l(c,h,m)}}}k(c,u,h,m=j.CancellationToken.None){if(!this.b)return Promise.reject(new Error("disposed"));if(m.isCancellationRequested)return Promise.reject(C.$5());this.b.cancel();const k=this.n(c),s=(0,A.$Lg)(i=>k.call(u,h,i)),a=m.onCancellationRequested(()=>s.cancel()),n=(0,d.$Pc)(()=>s.cancel());return this.c.add(n),s.finally(()=>{a.dispose(),this.c.delete(n),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}),s}l(c,u,h){if(!this.b)return S.Event.None;this.b.cancel();let m;const k=new S.$Rd({onWillAddFirstListener:()=>{m=this.n(c).listen(u,h)(k.fire,k),this.c.add(m)},onDidRemoveLastListener:()=>{this.c.delete(m),m.dispose(),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}});return k.event}get m(){if(!this.f){const c=this.j&&this.j.args?this.j.args:[],u=Object.create(null);u.env={...(0,R.$an)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.j&&this.j.env&&(u.env={...u.env,...this.j.env}),this.j&&this.j.freshExecArgv&&(u.execArgv=[]),this.j&&typeof this.j.debug=="number"&&(u.execArgv=["--nolazy","--inspect="+this.j.debug]),this.j&&typeof this.j.debugBrk=="number"&&(u.execArgv=["--nolazy","--inspect-brk="+this.j.debugBrk]),u.execArgv===void 0&&(u.execArgv=process.execArgv.filter(t=>!/^--inspect(-brk)?=/.test(t)).filter(t=>!t.startsWith("--vscode-"))),(0,b.$Gl)(u.env),this.d=(0,D.fork)(this.i,c,u);const h=new S.$Rd;S.Event.fromNodeEventEmitter(this.d,"message",t=>t)(t=>{if((0,O.$4p)(t)){(0,O.log)(t,`IPC Library: ${this.j.serverName}`);return}h.fire(L.$fe.wrap(Buffer.from(t,"base64")))});const k=this.j.useQueue?(0,E.$Il)(this.d):this.d,s=t=>this.d&&this.d.connected&&k.send(t.buffer.toString("base64")),a=h.event,n={send:s,onMessage:a};this.f=new l.$yh(n);const i=()=>this.o();process.once("exit",i),this.d.on("error",t=>console.warn('IPC "'+this.j.serverName+'" errored with '+t)),this.d.on("exit",(t,r)=>{process.removeListener("exit",i),this.c.forEach(o=>(0,d.$Mc)(o)),this.c.clear(),t!==0&&r!=="SIGTERM"&&console.warn('IPC "'+this.j.serverName+'" crashed with exit code '+t+" and signal "+r),this.b?.cancel(),this.o(),this.h.fire({code:t,signal:r})})}return this.f}n(c){let u=this.g.get(c);return u||(u=this.m.getChannel(c),this.g.set(c,u)),u}o(){this.f&&(this.d&&(this.d.kill(),this.d=null),this.f=null,this.g.clear())}dispose(){this.h.dispose(),this.b?.cancel(),this.b=void 0,this.o(),this.c.clear()}}e.$9p=y}),define(ae[146],ce([0,1,133,15,40,3,12,18]),function(ie,e,D,A,L,j,O,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9T=e.$8T=void 0;class S{constructor(b){this.a=b,this.onMessage=j.Event.fromNodeEventEmitter(this.a,"message",l=>A.$fe.wrap(l.data)),b.start()}send(b){this.a.postMessage(b.buffer)}disconnect(){this.a.close()}}class d extends L.$zh{static b(b){(0,O.$Mf)((0,D.$7T)(process),"Electron Utility Process");const l=new j.$Rd;return process.parentPort.on("message",g=>{if(b?.handledClientConnection(g))return;const y=(0,C.$Nb)(g.ports);y&&l.fire(y)}),j.Event.map(l.event,g=>({protocol:new S(g),onDidClientDisconnect:j.Event.fromNodeEventEmitter(g,"close")}))}constructor(b){super(d.b(b))}}e.$8T=d;function R(E,b,l){const g=y=>{y.data===b&&(E.removeListener("message",g),l())};E.on("message",g)}e.$9T=R}),define(ae[68],ce([0,1,6,3,2,65,12]),function(ie,e,D,A,L,j,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9o=e.$8o=e.StorageState=e.$7o=e.StorageHint=void 0;var C;(function(b){b[b.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST",b[b.STORAGE_IN_MEMORY=1]="STORAGE_IN_MEMORY"})(C||(e.StorageHint=C={}));function S(b){const l=b;return l?.changed instanceof Map||l?.deleted instanceof Set}e.$7o=S;var d;(function(b){b[b.None=0]="None",b[b.Initialized=1]="Initialized",b[b.Closed=2]="Closed"})(d||(e.StorageState=d={}));class R extends L.$Rc{static{this.a=100}constructor(l,g=Object.create(null)){super(),this.r=l,this.s=g,this.b=this.B(new A.$Ud),this.onDidChangeStorage=this.b.event,this.c=d.None,this.f=new Map,this.g=this.B(new D.$Vg(R.a)),this.h=new Set,this.j=new Map,this.m=void 0,this.n=[],this.t()}t(){this.B(this.r.onDidChangeItemsExternal(l=>this.u(l)))}u(l){this.b.pause();try{l.changed?.forEach((g,y)=>this.w(y,g)),l.deleted?.forEach(g=>this.w(g,void 0))}finally{this.b.resume()}}w(l,g){if(this.c===d.Closed)return;let y=!1;(0,O.$Lf)(g)?y=this.f.delete(l):this.f.get(l)!==g&&(this.f.set(l,g),y=!0),y&&this.b.fire({key:l,external:!0})}get items(){return this.f}get size(){return this.f.size}async init(){this.c===d.None&&(this.c=d.Initialized,this.s.hint!==C.STORAGE_DOES_NOT_EXIST&&(this.f=await this.r.getItems()))}get(l,g){const y=this.f.get(l);return(0,O.$Lf)(y)?g:y}getBoolean(l,g){const y=this.get(l);return(0,O.$Lf)(y)?g:y==="true"}getNumber(l,g){const y=this.get(l);return(0,O.$Lf)(y)?g:parseInt(y,10)}getObject(l,g){const y=this.get(l);return(0,O.$Lf)(y)?g:(0,j.$rh)(y)}async set(l,g,y=!1){if(this.c===d.Closed)return;if((0,O.$Lf)(g))return this.delete(l,y);const w=(0,O.$Ef)(g)||Array.isArray(g)?(0,j.$qh)(g):String(g);if(this.f.get(l)!==w)return this.f.set(l,w),this.j.set(l,w),this.h.delete(l),this.b.fire({key:l,external:y}),this.D()}async delete(l,g=!1){if(!(this.c===d.Closed||!this.f.delete(l)))return this.h.has(l)||this.h.add(l),this.j.delete(l),this.b.fire({key:l,external:g}),this.D()}async optimize(){if(this.c!==d.Closed)return await this.flush(0),this.r.optimize()}async close(){return this.m||(this.m=this.y()),this.m}async y(){this.c=d.Closed;try{await this.D(0)}catch{}await this.r.close(()=>this.f)}get z(){return this.j.size>0||this.h.size>0}async C(){if(!this.z)return;const l={insert:this.j,delete:this.h};return this.h=new Set,this.j=new Map,this.r.updateItems(l).finally(()=>{if(!this.z)for(;this.n.length;)this.n.pop()?.()})}async flush(l){if(this.z)return this.D(l)}async D(l){return this.s.hint===C.STORAGE_IN_MEMORY?this.C():this.g.trigger(()=>this.C(),l)}async whenFlushed(){if(this.z)return new Promise(l=>this.n.push(l))}isInMemory(){return this.s.hint===C.STORAGE_IN_MEMORY}}e.$8o=R;class E{constructor(){this.onDidChangeItemsExternal=A.Event.None,this.a=new Map}async getItems(){return this.a}async updateItems(l){l.insert?.forEach((g,y)=>this.a.set(y,g)),l.delete?.forEach(g=>this.a.delete(g))}async optimize(){}async close(){}}e.$9o=E}),define(ae[147],ce([13,9]),function(ie,e){return ie.create("vs/base/node/zip",e)}),define(ae[148],ce([13,9]),function(ie,e){return ie.create("vs/platform/configuration/common/configurationRegistry",e)}),define(ae[149],ce([13,9]),function(ie,e){return ie.create("vs/platform/contextkey/common/contextkey",e)}),define(ae[150],ce([13,9]),function(ie,e){return ie.create("vs/platform/contextkey/common/scanner",e)}),define(ae[151],ce([13,9]),function(ie,e){return ie.create("vs/platform/extensionManagement/common/abstractExtensionManagementService",e)}),define(ae[152],ce([13,9]),function(ie,e){return ie.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(ae[153],ce([13,9]),function(ie,e){return ie.create("vs/platform/extensionManagement/common/extensionNls",e)}),define(ae[154],ce([13,9]),function(ie,e){return ie.create("vs/platform/extensionManagement/common/extensionsScannerService",e)}),define(ae[155],ce([13,9]),function(ie,e){return ie.create("vs/platform/extensionManagement/node/extensionManagementService",e)}),define(ae[156],ce([13,9]),function(ie,e){return ie.create("vs/platform/extensionManagement/node/extensionManagementUtil",e)}),define(ae[157],ce([13,9]),function(ie,e){return ie.create("vs/platform/extensions/common/extensionValidator",e)}),define(ae[158],ce([13,9]),function(ie,e){return ie.create("vs/platform/files/common/fileService",e)}),define(ae[159],ce([13,9]),function(ie,e){return ie.create("vs/platform/files/common/files",e)}),define(ae[160],ce([13,9]),function(ie,e){return ie.create("vs/platform/files/common/io",e)}),define(ae[161],ce([13,9]),function(ie,e){return ie.create("vs/platform/files/node/diskFileSystemProvider",e)}),define(ae[162],ce([13,9]),function(ie,e){return ie.create("vs/platform/languagePacks/common/languagePacks",e)}),define(ae[163],ce([13,9]),function(ie,e){return ie.create("vs/platform/remoteTunnel/common/remoteTunnel",e)}),define(ae[164],ce([13,9]),function(ie,e){return ie.create("vs/platform/remoteTunnel/node/remoteTunnelService",e)}),define(ae[165],ce([13,9]),function(ie,e){return ie.create("vs/platform/request/common/request",e)}),define(ae[166],ce([13,9]),function(ie,e){return ie.create("vs/platform/telemetry/common/telemetryLogAppender",e)}),define(ae[167],ce([13,9]),function(ie,e){return ie.create("vs/platform/telemetry/common/telemetryService",e)}),define(ae[168],ce([13,9]),function(ie,e){return ie.create("vs/platform/userDataProfile/common/userDataProfile",e)}),define(ae[169],ce([13,9]),function(ie,e){return ie.create("vs/platform/userDataSync/common/abstractSynchronizer",e)}),define(ae[170],ce([13,9]),function(ie,e){return ie.create("vs/platform/userDataSync/common/keybindingsSync",e)}),define(ae[171],ce([13,9]),function(ie,e){return ie.create("vs/platform/userDataSync/common/settingsSync",e)}),define(ae[172],ce([13,9]),function(ie,e){return ie.create("vs/platform/userDataSync/common/userDataAutoSyncService",e)}),define(ae[173],ce([13,9]),function(ie,e){return ie.create("vs/platform/userDataSync/common/userDataSync",e)}),define(ae[174],ce([13,9]),function(ie,e){return ie.create("vs/platform/userDataSync/common/userDataSyncLog",e)}),define(ae[175],ce([13,9]),function(ie,e){return ie.create("vs/platform/userDataSync/common/userDataSyncMachines",e)}),define(ae[176],ce([13,9]),function(ie,e){return ie.create("vs/platform/userDataSync/common/userDataSyncResourceProvider",e)}),define(ae[177],ce([13,9]),function(ie,e){return ie.create("vs/platform/workspace/common/workspace",e)}),define(ae[178],ce([0,1,7,150]),function(ie,e,D,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qi=e.TokenType=void 0;var L;(function(d){d[d.LParen=0]="LParen",d[d.RParen=1]="RParen",d[d.Neg=2]="Neg",d[d.Eq=3]="Eq",d[d.NotEq=4]="NotEq",d[d.Lt=5]="Lt",d[d.LtEq=6]="LtEq",d[d.Gt=7]="Gt",d[d.GtEq=8]="GtEq",d[d.RegexOp=9]="RegexOp",d[d.RegexStr=10]="RegexStr",d[d.True=11]="True",d[d.False=12]="False",d[d.In=13]="In",d[d.Not=14]="Not",d[d.And=15]="And",d[d.Or=16]="Or",d[d.Str=17]="Str",d[d.QuotedStr=18]="QuotedStr",d[d.Error=19]="Error",d[d.EOF=20]="EOF"})(L||(e.TokenType=L={}));function j(...d){switch(d.length){case 1:return(0,A.localize)(0,null,d[0]);case 2:return(0,A.localize)(1,null,d[0],d[1]);case 3:return(0,A.localize)(2,null,d[0],d[1],d[2]);default:return}}const O=(0,A.localize)(3,null),C=(0,A.localize)(4,null);class S{constructor(){this.c="",this.d=0,this.e=0,this.f=[],this.g=[],this.m=/[a-zA-Z0-9_<>\-\./\\:\*\?\+\[\]\^,#@;"%\$\p{L}-]+/uy}static getLexeme(R){switch(R.type){case 0:return"(";case 1:return")";case 2:return"!";case 3:return R.isTripleEq?"===":"==";case 4:return R.isTripleEq?"!==":"!=";case 5:return"<";case 6:return"<=";case 7:return">=";case 8:return">=";case 9:return"=~";case 10:return R.lexeme;case 11:return"true";case 12:return"false";case 13:return"in";case 14:return"not";case 15:return"&&";case 16:return"||";case 17:return R.lexeme;case 18:return R.lexeme;case 19:return R.lexeme;case 20:return"EOF";default:throw(0,D.$7)(`unhandled token type: ${JSON.stringify(R)}; have you forgotten to add a case?`)}}static{this.a=new Set(["i","g","s","m","y","u"].map(R=>R.charCodeAt(0)))}static{this.b=new Map([["not",14],["in",13],["false",12],["true",11]])}get errors(){return this.g}reset(R){return this.c=R,this.d=0,this.e=0,this.f=[],this.g=[],this}scan(){for(;!this.r();)switch(this.d=this.e,this.i()){case 40:this.k(0);break;case 41:this.k(1);break;case 33:if(this.h(61)){const E=this.h(61);this.f.push({type:4,offset:this.d,isTripleEq:E})}else this.k(2);break;case 39:this.o();break;case 47:this.q();break;case 61:if(this.h(61)){const E=this.h(61);this.f.push({type:3,offset:this.d,isTripleEq:E})}else this.h(126)?this.k(9):this.l(j("==","=~"));break;case 60:this.k(this.h(61)?6:5);break;case 62:this.k(this.h(61)?8:7);break;case 38:this.h(38)?this.k(15):this.l(j("&&"));break;case 124:this.h(124)?this.k(16):this.l(j("||"));break;case 32:case 13:case 9:case 10:case 160:break;default:this.n()}return this.d=this.e,this.k(20),Array.from(this.f)}h(R){return this.r()||this.c.charCodeAt(this.e)!==R?!1:(this.e++,!0)}i(){return this.c.charCodeAt(this.e++)}j(){return this.r()?0:this.c.charCodeAt(this.e)}k(R){this.f.push({type:R,offset:this.d})}l(R){const E=this.d,b=this.c.substring(this.d,this.e),l={type:19,offset:this.d,lexeme:b};this.g.push({offset:E,lexeme:b,additionalInfo:R}),this.f.push(l)}n(){this.m.lastIndex=this.d;const R=this.m.exec(this.c);if(R){this.e=this.d+R[0].length;const E=this.c.substring(this.d,this.e),b=S.b.get(E);b?this.k(b):this.f.push({type:17,lexeme:E,offset:this.d})}}o(){for(;this.j()!==39&&!this.r();)this.i();if(this.r()){this.l(O);return}this.i(),this.f.push({type:18,lexeme:this.c.substring(this.d+1,this.e-1),offset:this.d+1})}q(){let R=this.e,E=!1,b=!1;for(;;){if(R>=this.c.length){this.e=R,this.l(C);return}const g=this.c.charCodeAt(R);if(E)E=!1;else if(g===47&&!b){R++;break}else g===91?b=!0:g===92?E=!0:g===93&&(b=!1);R++}for(;R<this.c.length&&S.a.has(this.c.charCodeAt(R));)R++;this.e=R;const l=this.c.substring(this.d,this.e);this.f.push({type:10,lexeme:l,offset:this.d})}r(){return this.e>=this.c.length}}e.$Qi=S}),define(ae[179],ce([0,1,64,84,23,16,37,19,10]),function(ie,e,D,A,L,j,O,C,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$om=e.$nm=e.$mm=e.$lm=void 0,e.$lm=/^([^.]+\..+):(.+)$/;class d{get appRoot(){return(0,j.$lc)(L.$gg.asFileUri("").fsPath)}get userHome(){return S.URI.file(this.b.homeDir)}get userDataPath(){return this.b.userDataDir}get appSettingsHome(){return S.URI.file((0,j.$ic)(this.userDataPath,"User"))}get tmpDir(){return S.URI.file(this.b.tmpDir)}get cacheHome(){return S.URI.file(this.userDataPath)}get stateResource(){return(0,C.$zg)(this.appSettingsHome,"globalStorage","storage.json")}get userRoamingDataHome(){return this.appSettingsHome.with({scheme:L.Schemas.vscodeUserData})}get userDataSyncHome(){return(0,C.$zg)(this.appSettingsHome,"sync")}get logsHome(){if(!this.args.logsPath){const l=(0,D.$km)(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=(0,j.$ic)(this.userDataPath,"logs",l)}return S.URI.file(this.args.logsPath)}get sync(){return this.args.sync}get machineSettingsResource(){return(0,C.$zg)(S.URI.file((0,j.$ic)(this.userDataPath,"Machine")),"settings.json")}get workspaceStorageHome(){return(0,C.$zg)(this.appSettingsHome,"workspaceStorage")}get localHistoryHome(){return(0,C.$zg)(this.appSettingsHome,"History")}get keyboardLayoutResource(){return(0,C.$zg)(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const l=O.env.VSCODE_PORTABLE;return l?S.URI.file((0,j.$ic)(l,"argv.json")):(0,C.$zg)(this.userHome,this.c.dataFolderName,"argv.json")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return S.URI.file((0,j.$ic)(this.userDataPath,"Workspaces"))}get builtinExtensionsPath(){const l=this.args["builtin-extensions-dir"];return l?(0,j.$jc)(l):(0,j.$gc)((0,j.$ic)(L.$gg.asFileUri("").fsPath,"..","extensions"))}get extensionsDownloadLocation(){const l=this.args["extensions-download-dir"];return l?S.URI.file((0,j.$jc)(l)):S.URI.file((0,j.$ic)(this.userDataPath,"CachedExtensionVSIXs"))}get extensionsPath(){const l=this.args["extensions-dir"];if(l)return(0,j.$jc)(l);const g=O.env.VSCODE_EXTENSIONS;if(g)return g;const y=O.env.VSCODE_PORTABLE;return y?(0,j.$ic)(y,"extensions"):(0,C.$zg)(this.userHome,this.c.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const l=this.args.extensionDevelopmentPath;if(Array.isArray(l))return l.map(g=>/^[^:/?#]+?:\/\//.test(g)?S.URI.parse(g):S.URI.file((0,j.$gc)(g)))}get extensionDevelopmentKind(){return this.args.extensionDevelopmentKind?.map(l=>l==="ui"||l==="workspace"||l==="web"?l:"workspace")}get extensionTestsLocationURI(){const l=this.args.extensionTestsPath;if(l)return/^[^:/?#]+?:\/\//.test(l)?S.URI.parse(l):S.URI.file((0,j.$gc)(l))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const l=this.args["disable-extension"];if(l){if(typeof l=="string")return[l];if(Array.isArray(l)&&l.length>0)return l}return!1}get debugExtensionHost(){return R(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!O.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log?.find(l=>!e.$lm.test(l))}get extensionLogLevel(){const l=[];for(const g of this.args.log||[]){const y=e.$lm.exec(g);y&&y[1]&&y[2]&&l.push([y[1],y[2]])}return l.length?l:void 0}get serviceMachineIdResource(){return(0,C.$zg)(S.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get disableTelemetry(){return!!this.args["disable-telemetry"]}get disableWorkspaceTrust(){return!!this.args["disable-workspace-trust"]}get useInMemorySecretStorage(){return!!this.args["use-inmemory-secretstorage"]}get policyFile(){if(this.args["__enable-file-policy"]){const l=O.env.VSCODE_PORTABLE;return l?S.URI.file((0,j.$ic)(l,"policy.json")):(0,C.$zg)(this.userHome,this.c.dataFolderName,"policy.json")}}get continueOn(){return this.args.continueOn}set continueOn(l){this.args.continueOn=l}get args(){return this.a}constructor(l,g,y){this.a=l,this.b=g,this.c=y,this.editSessionId=this.args.editSessionId}}e.$mm=d,pe([A.$nh],d.prototype,"appRoot",null),pe([A.$nh],d.prototype,"userHome",null),pe([A.$nh],d.prototype,"userDataPath",null),pe([A.$nh],d.prototype,"appSettingsHome",null),pe([A.$nh],d.prototype,"tmpDir",null),pe([A.$nh],d.prototype,"cacheHome",null),pe([A.$nh],d.prototype,"stateResource",null),pe([A.$nh],d.prototype,"userRoamingDataHome",null),pe([A.$nh],d.prototype,"userDataSyncHome",null),pe([A.$nh],d.prototype,"sync",null),pe([A.$nh],d.prototype,"machineSettingsResource",null),pe([A.$nh],d.prototype,"workspaceStorageHome",null),pe([A.$nh],d.prototype,"localHistoryHome",null),pe([A.$nh],d.prototype,"keyboardLayoutResource",null),pe([A.$nh],d.prototype,"argvResource",null),pe([A.$nh],d.prototype,"isExtensionDevelopment",null),pe([A.$nh],d.prototype,"untitledWorkspacesHome",null),pe([A.$nh],d.prototype,"builtinExtensionsPath",null),pe([A.$nh],d.prototype,"extensionsPath",null),pe([A.$nh],d.prototype,"extensionDevelopmentLocationURI",null),pe([A.$nh],d.prototype,"extensionDevelopmentKind",null),pe([A.$nh],d.prototype,"extensionTestsLocationURI",null),pe([A.$nh],d.prototype,"debugExtensionHost",null),pe([A.$nh],d.prototype,"logLevel",null),pe([A.$nh],d.prototype,"extensionLogLevel",null),pe([A.$nh],d.prototype,"serviceMachineIdResource",null),pe([A.$nh],d.prototype,"disableTelemetry",null),pe([A.$nh],d.prototype,"disableWorkspaceTrust",null),pe([A.$nh],d.prototype,"useInMemorySecretStorage",null),pe([A.$nh],d.prototype,"policyFile",null);function R(b,l){return E(b["inspect-extensions"],b["inspect-brk-extensions"],5870,l,b.debugId,b.extensionEnvironment)}e.$nm=R;function E(b,l,g,y,w,c){const h=Number(l||b)||(y?null:g),m=h?!!l:!1;let k;if(c)try{k=JSON.parse(c)}catch{}return{port:h,break:m,debugId:w,env:k}}e.$om=E}),function(){"use strict";function ie(e,D,A){function L(O,C){const S=j(O,C),d=[S];return e.isAbsolute(S)||d.unshift(A),e.resolve(...d)}function j(O,C){process.env.VSCODE_DEV&&(C="code-oss-dev");const S=process.env.VSCODE_PORTABLE;if(S)return e.join(S,"user-data");let d=process.env.VSCODE_APPDATA;if(d)return e.join(d,C);const R=O["user-data-dir"];if(R)return R;switch(process.platform){case"win32":if(d=process.env.APPDATA,!d){const E=process.env.USERPROFILE;if(typeof E!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");d=e.join(E,"AppData","Roaming")}break;case"darwin":d=e.join(D.homedir(),"Library","Application Support");break;case"linux":d=process.env.XDG_CONFIG_HOME||e.join(D.homedir(),".config");break;default:throw new Error("Platform not supported")}return e.join(d,C)}return{getUserDataPath:L}}if(typeof define=="function")define(ae[180],ce([269,36,37]),function(e,D,A){return ie(e,D,A.cwd())});else if(typeof module=="object"&&typeof module.exports=="object"){const e=require("path"),D=require("os");module.exports=ie(e,D,process.env.VSCODE_CWD||process.cwd())}else throw new Error("Unknown context")}(),define(ae[181],ce([0,1,36,179,180]),function(ie,e,D,A,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rm=e.$qm=e.$pm=void 0;class j extends A.$mm{constructor(d,R){super(d,{homeDir:(0,D.homedir)(),tmpDir:(0,D.tmpdir)(),userDataDir:(0,L.getUserDataPath)(d,R.nameShort)},R)}}e.$pm=j;function O(S,d){return(0,A.$om)(S["inspect-ptyhost"],S["inspect-brk-ptyhost"],5877,d,S.extensionEnvironment)}e.$qm=O;function C(S,d){return(0,A.$om)(S["inspect-sharedprocess"],S["inspect-brk-sharedprocess"],5879,d,S.extensionEnvironment)}e.$rm=C}),define(ae[182],ce([0,1,12,153]),function(ie,e,D,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dp=void 0;function L(O,C,S,d){try{j(O,C,S,d)}catch(R){O.error(R?.message??R)}return C}e.$Dp=L;function j(O,C,S,d){const R=(E,b,l)=>{const g=E[b];if((0,D.$Cf)(g)){const y=g,w=y.length;if(w>1&&y[0]==="%"&&y[w-1]==="%"){const c=y.substr(1,w-2);let u=S[c];u===void 0&&d&&(u=d[c]);const h=typeof u=="string"?u:u?.message,m=d?.[c],k=typeof m=="string"?m:m?.message;if(!h){k||O.warn(`[${C.name}]: ${(0,A.localize)(0,null,c)}`);return}if(l&&(b==="title"||b==="category")&&k&&k!==h){const s={value:h,original:k};E[b]=s}else E[b]=h}}else if((0,D.$Ef)(g))for(const y in g)g.hasOwnProperty(y)&&(y==="commands"?R(g,y,!0):R(g,y,l));else if(Array.isArray(g))for(let y=0;y<g.length;y++)R(g,y,l)};for(const E in C)C.hasOwnProperty(E)&&R(C,E)}}),define(ae[183],ce([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$N0b=e.$M0b=void 0;class D{constructor(j){this.a=j}get ignoredRecommendations(){throw new Error("not supported")}promptImportantExtensionsInstallNotification(j){return this.a.call("promptImportantExtensionsInstallNotification",[j])}promptWorkspaceRecommendations(j){throw new Error("not supported")}hasToIgnoreRecommendationNotifications(){throw new Error("not supported")}}e.$M0b=D;class A{constructor(j){this.a=j}listen(j,O){throw new Error(`Event not found: ${O}`)}call(j,O,C){switch(O){case"promptImportantExtensionsInstallNotification":return this.a.promptImportantExtensionsInstallNotification(C[0])}throw new Error(`Call not found: ${O}`)}}e.$N0b=A}),define(ae[69],ce([0,1,19,89,157,54]),function(ie,e,D,A,L,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xo=e.$Wo=e.$Vo=e.$Uo=e.$To=e.$So=e.$Ro=void 0;const O=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,C=/^-(\d{4})(\d{2})(\d{2})$/;function S(c){return c=c.trim(),c==="*"||O.test(c)}e.$Ro=S;function d(c){if(!S(c))return null;if(c=c.trim(),c==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const u=c.match(O);return u?{hasCaret:u[1]==="^",hasGreaterEquals:u[1]===">=",majorBase:u[2]==="x"?0:parseInt(u[2],10),majorMustEqual:u[2]!=="x",minorBase:u[4]==="x"?0:parseInt(u[4],10),minorMustEqual:u[4]!=="x",patchBase:u[6]==="x"?0:parseInt(u[6],10),patchMustEqual:u[6]!=="x",preRelease:u[8]||null}:null}e.$So=d;function R(c){if(!c)return null;const u=c.majorBase,h=c.majorMustEqual,m=c.minorBase;let k=c.minorMustEqual;const s=c.patchBase;let a=c.patchMustEqual;c.hasCaret&&(u===0||(k=!1),a=!1);let n=0;if(c.preRelease){const i=C.exec(c.preRelease);if(i){const[,t,r,o]=i;n=Date.UTC(Number(t),Number(r)-1,Number(o))}}return{majorBase:u,majorMustEqual:h,minorBase:m,minorMustEqual:k,patchBase:s,patchMustEqual:a,isMinimum:c.hasGreaterEquals,notBefore:n}}e.$To=R;function E(c,u,h){let m;typeof c=="string"?m=R(d(c)):m=c;let k;u instanceof Date?k=u.getTime():typeof u=="string"&&(k=new Date(u).getTime());let s;if(typeof h=="string"?s=R(d(h)):s=h,!m||!s)return!1;const a=m.majorBase,n=m.minorBase,i=m.patchBase;let t=s.majorBase,r=s.minorBase,o=s.patchBase;const v=s.notBefore;let $=s.majorMustEqual,f=s.minorMustEqual,p=s.patchMustEqual;return s.isMinimum?a>t?!0:a<t?!1:n>r?!0:n<r||k&&k<v?!1:i>=o:(a===1&&t===0&&(!$||!f||!p)&&(t=1,r=0,o=0,$=!0,f=!1,p=!1),a<t?!1:a>t?!$:n<r?!1:n>r?!f:i<o?!1:i>o?!p:!(k&&k<v))}e.$Uo=E;function b(c,u,h,m,k){const s=[];if(typeof m.publisher<"u"&&typeof m.publisher!="string")return s.push([A.default.Error,L.localize(0,null)]),s;if(typeof m.name!="string")return s.push([A.default.Error,L.localize(1,null,"name")]),s;if(typeof m.version!="string")return s.push([A.default.Error,L.localize(2,null,"version")]),s;if(!m.engines)return s.push([A.default.Error,L.localize(3,null,"engines")]),s;if(typeof m.engines.vscode!="string")return s.push([A.default.Error,L.localize(4,null,"engines.vscode")]),s;if(typeof m.extensionDependencies<"u"&&!w(m.extensionDependencies))return s.push([A.default.Error,L.localize(5,null,"extensionDependencies")]),s;if(typeof m.activationEvents<"u"){if(!w(m.activationEvents))return s.push([A.default.Error,L.localize(6,null,"activationEvents")]),s;if(typeof m.main>"u"&&typeof m.browser>"u")return s.push([A.default.Error,L.localize(7,null,"activationEvents","main","browser")]),s}if(typeof m.extensionKind<"u"&&typeof m.main>"u"&&s.push([A.default.Warning,L.localize(8,null,"extensionKind")]),typeof m.main<"u"){if(typeof m.main!="string")return s.push([A.default.Error,L.localize(9,null,"main")]),s;{const i=(0,D.$zg)(h,m.main);(0,D.$tg)(i,h)||s.push([A.default.Warning,L.localize(10,null,i.path,h.path)])}}if(typeof m.browser<"u"){if(typeof m.browser!="string")return s.push([A.default.Error,L.localize(11,null,"browser")]),s;{const i=(0,D.$zg)(h,m.browser);(0,D.$tg)(i,h)||s.push([A.default.Warning,L.localize(12,null,i.path,h.path)])}}if(!j.valid(m.version))return s.push([A.default.Error,L.localize(13,null)]),s;const a=[];if(!l(c,u,m,k,a))for(const i of a)s.push([A.default.Error,i]);return s}e.$Vo=b;function l(c,u,h,m,k){return m||typeof h.main>"u"&&typeof h.browser>"u"?!0:y(c,u,h.engines.vscode,k)}e.$Wo=l;function g(c,u,h){return c==="*"||y(u,h,c)}e.$Xo=g;function y(c,u,h,m=[]){const k=R(d(h));if(!k)return m.push(L.localize(14,null,h)),!1;if(k.majorBase===0){if(!k.majorMustEqual||!k.minorMustEqual)return m.push(L.localize(15,null,h)),!1}else if(!k.majorMustEqual)return m.push(L.localize(16,null,h)),!1;return E(c,u,k)?!0:(m.push(L.localize(17,null,c,h)),!1)}function w(c){if(!Array.isArray(c))return!1;for(let u=0,h=c.length;u<h;u++)if(typeof c[u]!="string")return!1;return!0}}),define(ae[43],ce([0,1,15,32]),function(ie,e,D,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fp=void 0;async function L(j,O,C){let S=C&&C.get("storage.serviceMachineId",-1)||null;if(S)return S;try{const R=(await O.readFile(j.serviceMachineIdResource)).value.toString();S=(0,A.$hg)(R)?R:null}catch{S=null}if(!S){S=(0,A.$ig)();try{await O.writeFile(j.serviceMachineIdResource,D.$fe.fromString(S))}catch{}}return C?.store("storage.serviceMachineId",S,-1,1),S}e.$fp=L}),define(ae[70],ce([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sh=void 0;class D{constructor(L,j=[],O=!1){this.ctor=L,this.staticArguments=j,this.supportsDelayedInstantiation=O}}e.$Sh=D}),define(ae[184],ce([0,1,70]),function(ie,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dr=e.$Cr=e.InstantiationType=void 0;const A=[];var L;(function(C){C[C.Eager=0]="Eager",C[C.Delayed=1]="Delayed"})(L||(e.InstantiationType=L={}));function j(C,S,d){S instanceof D.$Sh||(S=new D.$Sh(S,[],!!d)),A.push([C,S])}e.$Cr=j;function O(){return A}e.$Dr=O}),define(ae[185],ce([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$iq=e.$hq=void 0;class D{constructor(j,O){this.key=j,this.data=O,this.incoming=new Map,this.outgoing=new Map}}e.$hq=D;class A{constructor(j){this.b=j,this.a=new Map}roots(){const j=[];for(const O of this.a.values())O.outgoing.size===0&&j.push(O);return j}insertEdge(j,O){const C=this.lookupOrInsertNode(j),S=this.lookupOrInsertNode(O);C.outgoing.set(S.key,S),S.incoming.set(C.key,C)}removeNode(j){const O=this.b(j);this.a.delete(O);for(const C of this.a.values())C.outgoing.delete(O),C.incoming.delete(O)}lookupOrInsertNode(j){const O=this.b(j);let C=this.a.get(O);return C||(C=new D(O,j),this.a.set(O,C)),C}lookup(j){return this.a.get(this.b(j))}isEmpty(){return this.a.size===0}toString(){const j=[];for(const[O,C]of this.a)j.push(`${O}
	(-> incoming)[${[...C.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...C.outgoing.keys()].join(",")}]
`);return j.join(`
`)}findCycleSlow(){for(const[j,O]of this.a){const C=new Set([j]),S=this.c(O,C);if(S)return S}}c(j,O){for(const[C,S]of j.outgoing){if(O.has(C))return[...O,C].join(" -> ");O.add(C);const d=this.c(S,O);if(d)return d;O.delete(C)}}}e.$iq=A}),define(ae[4],ce([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wh=e.$Vh=e.$Uh=e._util=void 0;var D;(function(O){O.serviceIds=new Map,O.DI_TARGET="$di$target",O.DI_DEPENDENCIES="$di$dependencies";function C(S){return S[O.DI_DEPENDENCIES]||[]}O.getServiceDependencies=C})(D||(e._util=D={})),e.$Uh=L("instantiationService");function A(O,C,S){C[D.DI_TARGET]===C?C[D.DI_DEPENDENCIES].push({id:O,index:S}):(C[D.DI_DEPENDENCIES]=[{id:O,index:S}],C[D.DI_TARGET]=C)}function L(O){if(D.serviceIds.has(O))return D.serviceIds.get(O);const C=function(S,d,R){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");A(C,S,R)};return C.toString=()=>O,D.serviceIds.set(O,C),C}e.$Vh=L;function j(O){return O}e.$Wh=j}),define(ae[186],ce([0,1,4]),function(ie,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$j0b=void 0,e.$j0b=(0,D.$Vh)("checksumService")}),define(ae[20],ce([0,1,12,10,4]),function(ie,e,D,A,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zi=e.$yi=e.$xi=e.$wi=e.$vi=e.$ui=e.$ti=e.$si=e.ConfigurationTarget=e.$ri=e.$qi=e.$pi=void 0,e.$pi=(0,L.$Vh)("configurationService");function j(c){return c&&typeof c=="object"&&(!c.overrideIdentifier||typeof c.overrideIdentifier=="string")&&(!c.resource||c.resource instanceof A.URI)}e.$qi=j;function O(c){return c&&typeof c=="object"&&(!c.overrideIdentifiers||Array.isArray(c.overrideIdentifiers))&&!c.overrideIdentifier&&(!c.resource||c.resource instanceof A.URI)}e.$ri=O;var C;(function(c){c[c.APPLICATION=1]="APPLICATION",c[c.USER=2]="USER",c[c.USER_LOCAL=3]="USER_LOCAL",c[c.USER_REMOTE=4]="USER_REMOTE",c[c.WORKSPACE=5]="WORKSPACE",c[c.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",c[c.DEFAULT=7]="DEFAULT",c[c.MEMORY=8]="MEMORY"})(C||(e.ConfigurationTarget=C={}));function S(c){switch(c){case 1:return"APPLICATION";case 2:return"USER";case 3:return"USER_LOCAL";case 4:return"USER_REMOTE";case 5:return"WORKSPACE";case 6:return"WORKSPACE_FOLDER";case 7:return"DEFAULT";case 8:return"MEMORY"}}e.$si=S;function d(c){return c.applicationValue!==void 0||c.userValue!==void 0||c.userLocalValue!==void 0||c.userRemoteValue!==void 0||c.workspaceValue!==void 0||c.workspaceFolderValue!==void 0}e.$ti=d;function R(c,u){const h=Object.create(null);for(const m in c)E(h,m,c[m],u);return h}e.$ui=R;function E(c,u,h,m){const k=u.split("."),s=k.pop();let a=c;for(let n=0;n<k.length;n++){const i=k[n];let t=a[i];switch(typeof t){case"undefined":t=a[i]=Object.create(null);break;case"object":break;default:m(`Ignoring ${u} as ${k.slice(0,n+1).join(".")} is ${JSON.stringify(t)}`);return}a=t}if(typeof a=="object"&&a!==null)try{a[s]=h}catch{m(`Ignoring ${u} as ${k.join(".")} is ${JSON.stringify(a)}`)}else m(`Ignoring ${u} as ${k.join(".")} is ${JSON.stringify(a)}`)}e.$vi=E;function b(c,u){const h=u.split(".");l(c,h)}e.$wi=b;function l(c,u){const h=u.shift();if(u.length===0){delete c[h];return}if(Object.keys(c).indexOf(h)!==-1){const m=c[h];typeof m=="object"&&!Array.isArray(m)&&(l(m,u),Object.keys(m).length===0&&delete c[h])}}function g(c,u,h){function m(a,n){let i=a;for(const t of n){if(typeof i!="object"||i===null)return;i=i[t]}return i}const k=u.split("."),s=m(c,k);return typeof s>"u"?h:s}e.$xi=g;function y(c,u,h){Object.keys(u).forEach(m=>{m!=="__proto__"&&(m in c?D.$Ef(c[m])&&D.$Ef(u[m])?y(c[m],u[m],h):h&&(c[m]=u[m]):c[m]=u[m])})}e.$yi=y;function w(c){return c.replace(/[\[\]]/g,"")}e.$zi=w}),define(ae[94],ce([0,1,5,27,178,4,149,7]),function(ie,e,D,A,L,j,O,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cj=e.$bj=e.$aj=e.$_i=e.$$i=e.$0i=e.$9i=e.$8i=e.$7i=e.$6i=e.$5i=e.$4i=e.$3i=e.$2i=e.$1i=e.$Zi=e.$Yi=e.$Xi=e.$Wi=e.$Vi=e.$Ui=e.$Ti=e.$Si=e.ContextKeyExprType=e.$Ri=void 0;const S=new Map;S.set("false",!1),S.set("true",!0),S.set("isMac",D.$j),S.set("isLinux",D.$k),S.set("isWindows",D.$i),S.set("isWeb",D.$o),S.set("isMacNative",D.$j&&!D.$o),S.set("isEdge",D.$H),S.set("isFirefox",D.$F),S.set("isChrome",D.$E),S.set("isSafari",D.$G);function d(U,P){if(S.get(U)!==void 0)throw(0,C.$6)("contextkey.setConstant(k, v) invoked with already set constant `k`");S.set(U,P)}e.$Ri=d;const R=Object.prototype.hasOwnProperty;var E;(function(U){U[U.False=0]="False",U[U.True=1]="True",U[U.Defined=2]="Defined",U[U.Not=3]="Not",U[U.Equals=4]="Equals",U[U.NotEquals=5]="NotEquals",U[U.And=6]="And",U[U.Regex=7]="Regex",U[U.NotRegex=8]="NotRegex",U[U.Or=9]="Or",U[U.In=10]="In",U[U.NotIn=11]="NotIn",U[U.Greater=12]="Greater",U[U.GreaterEquals=13]="GreaterEquals",U[U.Smaller=14]="Smaller",U[U.SmallerEquals=15]="SmallerEquals"})(E||(e.ContextKeyExprType=E={}));const b={regexParsingWithErrorRecovery:!0},l=(0,O.localize)(0,null),g=(0,O.localize)(1,null),y=(0,O.localize)(2,null),w=(0,O.localize)(3,null),c=(0,O.localize)(4,null),u=(0,O.localize)(5,null),h=(0,O.localize)(6,null),m=(0,O.localize)(7,null);class k{static{this.c=new Error}get lexingErrors(){return this.d.errors}get parsingErrors(){return this.h}constructor(P=b){this.k=P,this.d=new L.$Qi,this.f=[],this.g=0,this.h=[],this.v=/g|y/g}parse(P){if(P===""){this.h.push({message:l,offset:0,lexeme:"",additionalInfo:g});return}this.f=this.d.reset(P).scan(),this.g=0,this.h=[];try{const F=this.l();if(!this.E()){const B=this.D(),N=B.type===17?u:void 0;throw this.h.push({message:c,offset:B.offset,lexeme:L.$Qi.getLexeme(B),additionalInfo:N}),k.c}return F}catch(F){if(F!==k.c)throw F;return}}l(){return this.m()}m(){const P=[this.o()];for(;this.y(16);){const F=this.o();P.push(F)}return P.length===1?P[0]:s.or(...P)}o(){const P=[this.s()];for(;this.y(15);){const F=this.s();P.push(F)}return P.length===1?P[0]:s.and(...P)}s(){if(this.y(2)){const P=this.D();switch(P.type){case 11:return this.z(),t.INSTANCE;case 12:return this.z(),r.INSTANCE;case 0:{this.z();const F=this.l();return this.A(1,w),F?.negate()}case 17:return this.z(),I.create(P.lexeme);default:throw this.B("KEY | true | false | '(' expression ')'",P)}}return this.t()}t(){const P=this.D();switch(P.type){case 11:return this.z(),s.true();case 12:return this.z(),s.false();case 0:{this.z();const F=this.l();return this.A(1,w),F}case 17:{const F=P.lexeme;if(this.z(),this.y(9)){const N=this.D();if(!this.k.regexParsingWithErrorRecovery){if(this.z(),N.type!==10)throw this.B("REGEX",N);const V=N.lexeme,G=V.lastIndexOf("/"),te=G===V.length-1?void 0:this.w(V.substring(G+1));let oe;try{oe=new RegExp(V.substring(1,G),te)}catch{throw this.B("REGEX",N)}return Q.create(F,oe)}switch(N.type){case 10:case 19:{const V=[N.lexeme];this.z();let G=this.D(),te=0;for(let de=0;de<N.lexeme.length;de++)N.lexeme.charCodeAt(de)===40?te++:N.lexeme.charCodeAt(de)===41&&te--;for(;!this.E()&&G.type!==15&&G.type!==16;){switch(G.type){case 0:te++;break;case 1:te--;break;case 10:case 18:for(let de=0;de<G.lexeme.length;de++)G.lexeme.charCodeAt(de)===40?te++:N.lexeme.charCodeAt(de)===41&&te--}if(te<0)break;V.push(L.$Qi.getLexeme(G)),this.z(),G=this.D()}const oe=V.join(""),ue=oe.lastIndexOf("/"),he=ue===oe.length-1?void 0:this.w(oe.substring(ue+1));let ge;try{ge=new RegExp(oe.substring(1,ue),he)}catch{throw this.B("REGEX",N)}return s.regex(F,ge)}case 18:{const V=N.lexeme;this.z();let G=null;if(!(0,A.$Fe)(V)){const te=V.indexOf("/"),oe=V.lastIndexOf("/");if(te!==oe&&te>=0){const ue=V.slice(te+1,oe),he=V[oe+1]==="i"?"i":"";try{G=new RegExp(ue,he)}catch{throw this.B("REGEX",N)}}}if(G===null)throw this.B("REGEX",N);return Q.create(F,G)}default:throw this.B("REGEX",this.D())}}if(this.y(14)){this.A(13,y);const N=this.u();return s.notIn(F,N)}switch(this.D().type){case 3:{this.z();const N=this.u();if(this.x().type===18)return s.equals(F,N);switch(N){case"true":return s.has(F);case"false":return s.not(F);default:return s.equals(F,N)}}case 4:{this.z();const N=this.u();if(this.x().type===18)return s.notEquals(F,N);switch(N){case"true":return s.not(F);case"false":return s.has(F);default:return s.notEquals(F,N)}}case 5:return this.z(),q.create(F,this.u());case 6:return this.z(),Y.create(F,this.u());case 7:return this.z(),M.create(F,this.u());case 8:return this.z(),z.create(F,this.u());case 13:return this.z(),s.in(F,this.u());default:return s.has(F)}}case 20:throw this.h.push({message:h,offset:P.offset,lexeme:"",additionalInfo:m}),k.c;default:throw this.B(`true | false | KEY 
	| KEY '=~' REGEX 
	| KEY ('==' | '!=' | '<' | '<=' | '>' | '>=' | 'in' | 'not' 'in') value`,this.D())}}u(){const P=this.D();switch(P.type){case 17:case 18:return this.z(),P.lexeme;case 11:return this.z(),"true";case 12:return this.z(),"false";case 13:return this.z(),"in";default:return""}}w(P){return P.replaceAll(this.v,"")}x(){return this.f[this.g-1]}y(P){return this.C(P)?(this.z(),!0):!1}z(){return this.E()||this.g++,this.x()}A(P,F){if(this.C(P))return this.z();throw this.B(F,this.D())}B(P,F,B){const N=(0,O.localize)(8,null,P,L.$Qi.getLexeme(F)),V=F.offset,G=L.$Qi.getLexeme(F);return this.h.push({message:N,offset:V,lexeme:G,additionalInfo:B}),k.c}C(P){return this.D().type===P}D(){return this.f[this.g]}E(){return this.D().type===20}}e.$Si=k;class s{static false(){return t.INSTANCE}static true(){return r.INSTANCE}static has(P){return o.create(P)}static equals(P,F){return v.create(P,F)}static notEquals(P,F){return p.create(P,F)}static regex(P,F){return Q.create(P,F)}static in(P,F){return $.create(P,F)}static notIn(P,F){return f.create(P,F)}static not(P){return I.create(P)}static and(...P){return Z.create(P,null,!0)}static or(...P){return J.create(P,null,!0)}static greater(P,F){return M.create(P,F)}static greaterEquals(P,F){return z.create(P,F)}static smaller(P,F){return q.create(P,F)}static smallerEquals(P,F){return Y.create(P,F)}static{this.c=new k({regexParsingWithErrorRecovery:!1})}static deserialize(P){return P==null?void 0:this.c.parse(P)}}e.$Ti=s;function a(U){const P=new k({regexParsingWithErrorRecovery:!1});return U.map(F=>(P.parse(F),P.lexingErrors.length>0?P.lexingErrors.map(B=>({errorMessage:B.additionalInfo?(0,O.localize)(9,null,B.additionalInfo):(0,O.localize)(10,null),offset:B.offset,length:B.lexeme.length})):P.parsingErrors.length>0?P.parsingErrors.map(B=>({errorMessage:B.additionalInfo?`${B.message}. ${B.additionalInfo}`:B.message,offset:B.offset,length:B.lexeme.length})):[]))}e.$Ui=a;function n(U,P){const F=U?U.substituteConstants():void 0,B=P?P.substituteConstants():void 0;return!F&&!B?!0:!F||!B?!1:F.equals(B)}e.$Vi=n;function i(U,P){return U.cmp(P)}class t{static{this.INSTANCE=new t}constructor(){this.type=0}cmp(P){return this.type-P.type}equals(P){return P.type===this.type}substituteConstants(){return this}evaluate(P){return!1}serialize(){return"false"}keys(){return[]}map(P){return this}negate(){return r.INSTANCE}}e.$Wi=t;class r{static{this.INSTANCE=new r}constructor(){this.type=1}cmp(P){return this.type-P.type}equals(P){return P.type===this.type}substituteConstants(){return this}evaluate(P){return!0}serialize(){return"true"}keys(){return[]}map(P){return this}negate(){return t.INSTANCE}}e.$Xi=r;class o{static create(P,F=null){const B=S.get(P);return typeof B=="boolean"?B?r.INSTANCE:t.INSTANCE:new o(P,F)}constructor(P,F){this.key=P,this.c=F,this.type=2}cmp(P){return P.type!==this.type?this.type-P.type:ee(this.key,P.key)}equals(P){return P.type===this.type?this.key===P.key:!1}substituteConstants(){const P=S.get(this.key);return typeof P=="boolean"?P?r.INSTANCE:t.INSTANCE:this}evaluate(P){return!!P.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(P){return P.mapDefined(this.key)}negate(){return this.c||(this.c=I.create(this.key,this)),this.c}}e.$Yi=o;class v{static create(P,F,B=null){if(typeof F=="boolean")return F?o.create(P,B):I.create(P,B);const N=S.get(P);return typeof N=="boolean"?F===(N?"true":"false")?r.INSTANCE:t.INSTANCE:new v(P,F,B)}constructor(P,F,B){this.c=P,this.d=F,this.f=B,this.type=4}cmp(P){return P.type!==this.type?this.type-P.type:ne(this.c,this.d,P.c,P.d)}equals(P){return P.type===this.type?this.c===P.c&&this.d===P.d:!1}substituteConstants(){const P=S.get(this.c);if(typeof P=="boolean"){const F=P?"true":"false";return this.d===F?r.INSTANCE:t.INSTANCE}return this}evaluate(P){return P.getValue(this.c)==this.d}serialize(){return`${this.c} == '${this.d}'`}keys(){return[this.c]}map(P){return P.mapEquals(this.c,this.d)}negate(){return this.f||(this.f=p.create(this.c,this.d,this)),this.f}}e.$Zi=v;class ${static create(P,F){return new $(P,F)}constructor(P,F){this.d=P,this.f=F,this.type=10,this.c=null}cmp(P){return P.type!==this.type?this.type-P.type:ne(this.d,this.f,P.d,P.f)}equals(P){return P.type===this.type?this.d===P.d&&this.f===P.f:!1}substituteConstants(){return this}evaluate(P){const F=P.getValue(this.f),B=P.getValue(this.d);return Array.isArray(F)?F.includes(B):typeof B=="string"&&typeof F=="object"&&F!==null?R.call(F,B):!1}serialize(){return`${this.d} in '${this.f}'`}keys(){return[this.d,this.f]}map(P){return P.mapIn(this.d,this.f)}negate(){return this.c||(this.c=f.create(this.d,this.f)),this.c}}e.$1i=$;class f{static create(P,F){return new f(P,F)}constructor(P,F){this.d=P,this.f=F,this.type=11,this.c=$.create(P,F)}cmp(P){return P.type!==this.type?this.type-P.type:this.c.cmp(P.c)}equals(P){return P.type===this.type?this.c.equals(P.c):!1}substituteConstants(){return this}evaluate(P){return!this.c.evaluate(P)}serialize(){return`${this.d} not in '${this.f}'`}keys(){return this.c.keys()}map(P){return P.mapNotIn(this.d,this.f)}negate(){return this.c}}e.$2i=f;class p{static create(P,F,B=null){if(typeof F=="boolean")return F?I.create(P,B):o.create(P,B);const N=S.get(P);return typeof N=="boolean"?F===(N?"true":"false")?t.INSTANCE:r.INSTANCE:new p(P,F,B)}constructor(P,F,B){this.c=P,this.d=F,this.f=B,this.type=5}cmp(P){return P.type!==this.type?this.type-P.type:ne(this.c,this.d,P.c,P.d)}equals(P){return P.type===this.type?this.c===P.c&&this.d===P.d:!1}substituteConstants(){const P=S.get(this.c);if(typeof P=="boolean"){const F=P?"true":"false";return this.d===F?t.INSTANCE:r.INSTANCE}return this}evaluate(P){return P.getValue(this.c)!=this.d}serialize(){return`${this.c} != '${this.d}'`}keys(){return[this.c]}map(P){return P.mapNotEquals(this.c,this.d)}negate(){return this.f||(this.f=v.create(this.c,this.d,this)),this.f}}e.$3i=p;class I{static create(P,F=null){const B=S.get(P);return typeof B=="boolean"?B?t.INSTANCE:r.INSTANCE:new I(P,F)}constructor(P,F){this.c=P,this.d=F,this.type=3}cmp(P){return P.type!==this.type?this.type-P.type:ee(this.c,P.c)}equals(P){return P.type===this.type?this.c===P.c:!1}substituteConstants(){const P=S.get(this.c);return typeof P=="boolean"?P?t.INSTANCE:r.INSTANCE:this}evaluate(P){return!P.getValue(this.c)}serialize(){return`!${this.c}`}keys(){return[this.c]}map(P){return P.mapNot(this.c)}negate(){return this.d||(this.d=o.create(this.c,this)),this.d}}e.$4i=I;function T(U,P){if(typeof U=="string"){const F=parseFloat(U);isNaN(F)||(U=F)}return typeof U=="string"||typeof U=="number"?P(U):t.INSTANCE}class M{static create(P,F,B=null){return T(F,N=>new M(P,N,B))}constructor(P,F,B){this.c=P,this.d=F,this.f=B,this.type=12}cmp(P){return P.type!==this.type?this.type-P.type:ne(this.c,this.d,P.c,P.d)}equals(P){return P.type===this.type?this.c===P.c&&this.d===P.d:!1}substituteConstants(){return this}evaluate(P){return typeof this.d=="string"?!1:parseFloat(P.getValue(this.c))>this.d}serialize(){return`${this.c} > ${this.d}`}keys(){return[this.c]}map(P){return P.mapGreater(this.c,this.d)}negate(){return this.f||(this.f=Y.create(this.c,this.d,this)),this.f}}e.$5i=M;class z{static create(P,F,B=null){return T(F,N=>new z(P,N,B))}constructor(P,F,B){this.c=P,this.d=F,this.f=B,this.type=13}cmp(P){return P.type!==this.type?this.type-P.type:ne(this.c,this.d,P.c,P.d)}equals(P){return P.type===this.type?this.c===P.c&&this.d===P.d:!1}substituteConstants(){return this}evaluate(P){return typeof this.d=="string"?!1:parseFloat(P.getValue(this.c))>=this.d}serialize(){return`${this.c} >= ${this.d}`}keys(){return[this.c]}map(P){return P.mapGreaterEquals(this.c,this.d)}negate(){return this.f||(this.f=q.create(this.c,this.d,this)),this.f}}e.$6i=z;class q{static create(P,F,B=null){return T(F,N=>new q(P,N,B))}constructor(P,F,B){this.c=P,this.d=F,this.f=B,this.type=14}cmp(P){return P.type!==this.type?this.type-P.type:ne(this.c,this.d,P.c,P.d)}equals(P){return P.type===this.type?this.c===P.c&&this.d===P.d:!1}substituteConstants(){return this}evaluate(P){return typeof this.d=="string"?!1:parseFloat(P.getValue(this.c))<this.d}serialize(){return`${this.c} < ${this.d}`}keys(){return[this.c]}map(P){return P.mapSmaller(this.c,this.d)}negate(){return this.f||(this.f=z.create(this.c,this.d,this)),this.f}}e.$7i=q;class Y{static create(P,F,B=null){return T(F,N=>new Y(P,N,B))}constructor(P,F,B){this.c=P,this.d=F,this.f=B,this.type=15}cmp(P){return P.type!==this.type?this.type-P.type:ne(this.c,this.d,P.c,P.d)}equals(P){return P.type===this.type?this.c===P.c&&this.d===P.d:!1}substituteConstants(){return this}evaluate(P){return typeof this.d=="string"?!1:parseFloat(P.getValue(this.c))<=this.d}serialize(){return`${this.c} <= ${this.d}`}keys(){return[this.c]}map(P){return P.mapSmallerEquals(this.c,this.d)}negate(){return this.f||(this.f=M.create(this.c,this.d,this)),this.f}}e.$8i=Y;class Q{static create(P,F){return new Q(P,F)}constructor(P,F){this.d=P,this.f=F,this.type=7,this.c=null}cmp(P){if(P.type!==this.type)return this.type-P.type;if(this.d<P.d)return-1;if(this.d>P.d)return 1;const F=this.f?this.f.source:"",B=P.f?P.f.source:"";return F<B?-1:F>B?1:0}equals(P){if(P.type===this.type){const F=this.f?this.f.source:"",B=P.f?P.f.source:"";return this.d===P.d&&F===B}return!1}substituteConstants(){return this}evaluate(P){const F=P.getValue(this.d);return this.f?this.f.test(F):!1}serialize(){const P=this.f?`/${this.f.source}/${this.f.flags}`:"/invalid/";return`${this.d} =~ ${P}`}keys(){return[this.d]}map(P){return P.mapRegex(this.d,this.f)}negate(){return this.c||(this.c=x.create(this)),this.c}}e.$9i=Q;class x{static create(P){return new x(P)}constructor(P){this.c=P,this.type=8}cmp(P){return P.type!==this.type?this.type-P.type:this.c.cmp(P.c)}equals(P){return P.type===this.type?this.c.equals(P.c):!1}substituteConstants(){return this}evaluate(P){return!this.c.evaluate(P)}serialize(){return`!(${this.c.serialize()})`}keys(){return this.c.keys()}map(P){return new x(this.c.map(P))}negate(){return this.c}}e.$0i=x;function H(U){let P=null;for(let F=0,B=U.length;F<B;F++){const N=U[F].substituteConstants();if(U[F]!==N&&P===null){P=[];for(let V=0;V<F;V++)P[V]=U[V]}P!==null&&(P[F]=N)}return P===null?U:P}class Z{static create(P,F,B){return Z.d(P,F,B)}constructor(P,F){this.expr=P,this.c=F,this.type=6}cmp(P){if(P.type!==this.type)return this.type-P.type;if(this.expr.length<P.expr.length)return-1;if(this.expr.length>P.expr.length)return 1;for(let F=0,B=this.expr.length;F<B;F++){const N=i(this.expr[F],P.expr[F]);if(N!==0)return N}return 0}equals(P){if(P.type===this.type){if(this.expr.length!==P.expr.length)return!1;for(let F=0,B=this.expr.length;F<B;F++)if(!this.expr[F].equals(P.expr[F]))return!1;return!0}return!1}substituteConstants(){const P=H(this.expr);return P===this.expr?this:Z.create(P,this.c,!1)}evaluate(P){for(let F=0,B=this.expr.length;F<B;F++)if(!this.expr[F].evaluate(P))return!1;return!0}static d(P,F,B){const N=[];let V=!1;for(const G of P)if(G){if(G.type===1){V=!0;continue}if(G.type===0)return t.INSTANCE;if(G.type===6){N.push(...G.expr);continue}N.push(G)}if(N.length===0&&V)return r.INSTANCE;if(N.length!==0){if(N.length===1)return N[0];N.sort(i);for(let G=1;G<N.length;G++)N[G-1].equals(N[G])&&(N.splice(G,1),G--);if(N.length===1)return N[0];for(;N.length>1;){const G=N[N.length-1];if(G.type!==9)break;N.pop();const te=N.pop(),oe=N.length===0,ue=J.create(G.expr.map(he=>Z.create([he,te],null,B)),null,oe);ue&&(N.push(ue),N.sort(i))}if(N.length===1)return N[0];if(B){for(let G=0;G<N.length;G++)for(let te=G+1;te<N.length;te++)if(N[G].negate().equals(N[te]))return t.INSTANCE;if(N.length===1)return N[0]}return new Z(N,F)}}serialize(){return this.expr.map(P=>P.serialize()).join(" && ")}keys(){const P=[];for(const F of this.expr)P.push(...F.keys());return P}map(P){return new Z(this.expr.map(F=>F.map(P)),null)}negate(){if(!this.c){const P=[];for(const F of this.expr)P.push(F.negate());this.c=J.create(P,this,!0)}return this.c}}e.$$i=Z;class J{static create(P,F,B){return J.d(P,F,B)}constructor(P,F){this.expr=P,this.c=F,this.type=9}cmp(P){if(P.type!==this.type)return this.type-P.type;if(this.expr.length<P.expr.length)return-1;if(this.expr.length>P.expr.length)return 1;for(let F=0,B=this.expr.length;F<B;F++){const N=i(this.expr[F],P.expr[F]);if(N!==0)return N}return 0}equals(P){if(P.type===this.type){if(this.expr.length!==P.expr.length)return!1;for(let F=0,B=this.expr.length;F<B;F++)if(!this.expr[F].equals(P.expr[F]))return!1;return!0}return!1}substituteConstants(){const P=H(this.expr);return P===this.expr?this:J.create(P,this.c,!1)}evaluate(P){for(let F=0,B=this.expr.length;F<B;F++)if(this.expr[F].evaluate(P))return!0;return!1}static d(P,F,B){let N=[],V=!1;if(P){for(let G=0,te=P.length;G<te;G++){const oe=P[G];if(oe){if(oe.type===0){V=!0;continue}if(oe.type===1)return r.INSTANCE;if(oe.type===9){N=N.concat(oe.expr);continue}N.push(oe)}}if(N.length===0&&V)return t.INSTANCE;N.sort(i)}if(N.length!==0){if(N.length===1)return N[0];for(let G=1;G<N.length;G++)N[G-1].equals(N[G])&&(N.splice(G,1),G--);if(N.length===1)return N[0];if(B){for(let G=0;G<N.length;G++)for(let te=G+1;te<N.length;te++)if(N[G].negate().equals(N[te]))return r.INSTANCE;if(N.length===1)return N[0]}return new J(N,F)}}serialize(){return this.expr.map(P=>P.serialize()).join(" || ")}keys(){const P=[];for(const F of this.expr)P.push(...F.keys());return P}map(P){return new J(this.expr.map(F=>F.map(P)),null)}negate(){if(!this.c){const P=[];for(const F of this.expr)P.push(F.negate());for(;P.length>1;){const F=P.shift(),B=P.shift(),N=[];for(const V of K(F))for(const G of K(B))N.push(Z.create([V,G],null,!1));P.unshift(J.create(N,null,!1))}this.c=J.create(P,this,!0)}return this.c}}e.$_i=J;class W extends o{static{this.d=[]}static all(){return W.d.values()}constructor(P,F,B){super(P,null),this.f=F,typeof B=="object"?W.d.push({...B,key:P}):B!==!0&&W.d.push({key:P,description:B,type:F!=null?typeof F:void 0})}bindTo(P){return P.createKey(this.key,this.f)}getValue(P){return P.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(P){return v.create(this.key,P)}notEqualsTo(P){return p.create(this.key,P)}}e.$aj=W,e.$bj=(0,j.$Vh)("contextKeyService");function ee(U,P){return U<P?-1:U>P?1:0}function ne(U,P,F,B){return U<F?-1:U>F?1:P<B?-1:P>B?1:0}function _(U,P){if(U.type===0||P.type===1)return!0;if(U.type===9)return P.type===9?se(U.expr,P.expr):!1;if(P.type===9){for(const F of P.expr)if(_(U,F))return!0;return!1}if(U.type===6){if(P.type===6)return se(P.expr,U.expr);for(const F of U.expr)if(_(F,P))return!0;return!1}return U.equals(P)}e.$cj=_;function se(U,P){let F=0,B=0;for(;F<U.length&&B<P.length;){const N=U[F].cmp(P[B]);if(N<0)return!1;N===0&&F++,B++}return F===U.length}function K(U){return U.type===9?U.expr:[U]}}),define(ae[95],ce([0,1,4]),function(ie,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ym=e.$xm=e.$wm=e.ID=void 0,e.ID="diagnosticsService",e.$wm=(0,D.$Vh)(e.ID);function A(j){return!!j.hostName&&!!j.errorMessage}e.$xm=A;class L{async getPerformanceInfo(O,C){return{}}async getSystemInfo(O,C){return{processArgs:"nullProcessArgs",gpuStatus:"nullGpuStatus",screenReader:"nullScreenReader",remoteData:[],os:"nullOs",memory:"nullMemory",vmHint:"nullVmHint"}}async getDiagnostics(O,C){return""}async getWorkspaceFileExtensions(O){return{extensions:[]}}async reportWorkspaceStats(O){}}e.$ym=L}),define(ae[96],ce([0,1,4]),function(ie,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Un=void 0,e.$Un=(0,D.$Vh)("downloadService")}),define(ae[14],ce([0,1,4]),function(ie,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4h=e.$3h=void 0,e.$3h=(0,D.$Vh)("environmentService"),e.$4h=(0,D.$Wh)(e.$3h)}),define(ae[29],ce([0,1,152,4]),function(ie,e,D,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mo=e.$lo=e.$ko=e.$jo=e.$io=e.$ho=e.$go=e.$fo=e.$eo=e.ExtensionSignaturetErrorCode=e.ExtensionManagementErrorCode=e.$do=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.$co=e.$bo=e.$ao=e.$_n=e.$$n=e.$0n=e.$9n=e.$8n=e.$7n=e.$6n=e.$5n=e.$4n=void 0,e.$4n="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.$5n=new RegExp(e.$4n),e.$6n="__web_extension",e.$7n="skipWalkthrough",e.$8n="extensionsSync",e.$9n="dependecyOrPackExtensionInstall";function L(c){switch(c){case"win32-x64":return"Windows 64 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.$0n=L;function j(c){switch(c){case"win32-x64":return"win32-x64";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.$$n=j;function O(c,u){switch(c){case 3:return u==="x64"?"win32-x64":u==="arm64"?"win32-arm64":"unknown";case 2:return u==="x64"?"linux-x64":u==="arm64"?"linux-arm64":u==="arm"?"linux-armhf":"unknown";case"alpine":return u==="x64"?"alpine-x64":u==="arm64"?"alpine-arm64":"unknown";case 1:return u==="x64"?"darwin-x64":u==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.$_n=O;function C(c,u){return u==="web"&&!c.includes("web")}e.$ao=C;function S(c,u,h){return C(u,h)?!1:c==="undefined"||c==="universal"?!0:c==="unknown"?!1:c===h}e.$bo=S;function d(c){return c&&typeof c=="object"&&typeof c.id=="string"&&(!c.uuid||typeof c.uuid=="string")}e.$co=d;var R;(function(c){c[c.NoneOrRelevance=0]="NoneOrRelevance",c[c.LastUpdatedDate=1]="LastUpdatedDate",c[c.Title=2]="Title",c[c.PublisherName=3]="PublisherName",c[c.InstallCount=4]="InstallCount",c[c.PublishedDate=10]="PublishedDate",c[c.AverageRating=6]="AverageRating",c[c.WeightedRating=12]="WeightedRating"})(R||(e.SortBy=R={}));var E;(function(c){c[c.Default=0]="Default",c[c.Ascending=1]="Ascending",c[c.Descending=2]="Descending"})(E||(e.SortOrder=E={}));var b;(function(c){c.Install="install",c.Uninstall="uninstall"})(b||(e.StatisticType=b={}));var l;(function(c){c[c.None=1]="None",c[c.Install=2]="Install",c[c.Update=3]="Update",c[c.Migrate=4]="Migrate"})(l||(e.InstallOperation=l={})),e.$do=(0,A.$Vh)("extensionGalleryService");var g;(function(c){c.Unsupported="Unsupported",c.Deprecated="Deprecated",c.Malicious="Malicious",c.Incompatible="Incompatible",c.IncompatibleTargetPlatform="IncompatibleTargetPlatform",c.ReleaseVersionNotFound="ReleaseVersionNotFound",c.Invalid="Invalid",c.Download="Download",c.Extract="Extract",c.Delete="Delete",c.Rename="Rename",c.CorruptZip="CorruptZip",c.IncompleteZip="IncompleteZip",c.Signature="Signature",c.Internal="Internal"})(g||(e.ExtensionManagementErrorCode=g={}));var y;(function(c){c.UnknownError="UnknownError",c.PackageIsInvalidZip="PackageIsInvalidZip",c.SignatureArchiveIsInvalidZip="SignatureArchiveIsInvalidZip"})(y||(e.ExtensionSignaturetErrorCode=y={}));class w extends Error{constructor(u,h){super(u),this.code=h,this.name=h}}e.$eo=w,e.$fo=(0,A.$Vh)("extensionManagementService"),e.$go="extensionsIdentifiers/disabled",e.$ho="extensionsIdentifiers/enabled",e.$io=(0,A.$Vh)("IGlobalExtensionEnablementService"),e.$jo=(0,A.$Vh)("IExtensionTipsService"),e.$ko=(0,D.localize)(0,null),e.$lo={value:e.$ko,original:"Extensions"},e.$mo={value:(0,D.localize)(1,null),original:"Preferences"}}),define(ae[187],ce([0,1,3,2,30,10,92,29]),function(ie,e,D,A,L,j,O,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pp=e.$op=e.$np=void 0;function S(w,c){return w?j.URI.revive(c?c.transformIncoming(w):w):void 0}function d(w,c){return c?c.transformOutgoingURI(w):w}function R(w,c){c=c||O.$Sm;const u=w.manifest;return{...(0,O.$Vm)({...w,manifest:void 0},c),manifest:u}}function E(w,c){return w?.profileLocation?(0,O.$Vm)(w,c??O.$Sm):w}function b(w,c){return c?(0,L.$cn)(w,u=>u instanceof j.URI?c.transformOutgoingURI(u):void 0):w}class l{constructor(c,u){this.a=c,this.b=u,this.onInstallExtension=D.Event.buffer(c.onInstallExtension,!0),this.onDidInstallExtensions=D.Event.buffer(c.onDidInstallExtensions,!0),this.onUninstallExtension=D.Event.buffer(c.onUninstallExtension,!0),this.onDidUninstallExtension=D.Event.buffer(c.onDidUninstallExtension,!0),this.onDidUpdateExtensionMetadata=D.Event.buffer(c.onDidUpdateExtensionMetadata,!0)}listen(c,u){const h=this.b(c);switch(u){case"onInstallExtension":return D.Event.map(this.onInstallExtension,m=>({...m,profileLocation:m.profileLocation?d(m.profileLocation,h):m.profileLocation}));case"onDidInstallExtensions":return D.Event.map(this.onDidInstallExtensions,m=>m.map(k=>({...k,local:k.local?b(k.local,h):k.local,profileLocation:k.profileLocation?d(k.profileLocation,h):k.profileLocation})));case"onUninstallExtension":return D.Event.map(this.onUninstallExtension,m=>({...m,profileLocation:m.profileLocation?d(m.profileLocation,h):m.profileLocation}));case"onDidUninstallExtension":return D.Event.map(this.onDidUninstallExtension,m=>({...m,profileLocation:m.profileLocation?d(m.profileLocation,h):m.profileLocation}));case"onDidUpdateExtensionMetadata":return D.Event.map(this.onDidUpdateExtensionMetadata,m=>b(m,h))}throw new Error("Invalid listen")}async call(c,u,h){const m=this.b(c);switch(u){case"zip":{const k=R(h[0],m),s=await this.a.zip(k);return d(s,m)}case"unzip":return this.a.unzip(S(h[0],m));case"install":return this.a.install(S(h[0],m),E(h[1],m));case"installFromLocation":return this.a.installFromLocation(S(h[0],m),S(h[1],m));case"installExtensionsFromProfile":return this.a.installExtensionsFromProfile(h[0],S(h[1],m),S(h[2],m));case"getManifest":return this.a.getManifest(S(h[0],m));case"getTargetPlatform":return this.a.getTargetPlatform();case"canInstall":return this.a.canInstall(h[0]);case"installFromGallery":return this.a.installFromGallery(h[0],E(h[1],m));case"installGalleryExtensions":{const k=h[0];return this.a.installGalleryExtensions(k.map(({extension:s,options:a})=>({extension:s,options:E(a,m)??{}})))}case"uninstall":return this.a.uninstall(R(h[0],m),E(h[1],m));case"reinstallFromGallery":return this.a.reinstallFromGallery(R(h[0],m));case"getInstalled":return(await this.a.getInstalled(h[0],S(h[1],m))).map(s=>b(s,m));case"toggleAppliationScope":{const k=await this.a.toggleAppliationScope(R(h[0],m),S(h[1],m));return b(k,m)}case"copyExtensions":return this.a.copyExtensions(S(h[0],m),S(h[1],m));case"updateMetadata":{const k=await this.a.updateMetadata(R(h[0],m),h[1],S(h[2],m));return b(k,m)}case"getExtensionsControlManifest":return this.a.getExtensionsControlManifest();case"download":return this.a.download(h[0],h[1],h[2]);case"cleanUp":return this.a.cleanUp()}throw new Error("Invalid call")}}e.$np=l;class g extends A.$Rc{get onInstallExtension(){return this.c.event}get onDidInstallExtensions(){return this.f.event}get onUninstallExtension(){return this.g.event}get onDidUninstallExtension(){return this.h.event}get onDidUpdateExtensionMetadata(){return this.j.event}constructor(c){super(),this.m=c,this.c=this.B(new D.$Rd),this.f=this.B(new D.$Rd),this.g=this.B(new D.$Rd),this.h=this.B(new D.$Rd),this.j=this.B(new D.$Rd),this.B(this.m.listen("onInstallExtension")(u=>this.n(this.c,{...u,source:this.r(u.source)?j.URI.revive(u.source):u.source,profileLocation:j.URI.revive(u.profileLocation)}))),this.B(this.m.listen("onDidInstallExtensions")(u=>this.n(this.f,u.map(h=>({...h,local:h.local?R(h.local,null):h.local,source:this.r(h.source)?j.URI.revive(h.source):h.source,profileLocation:j.URI.revive(h.profileLocation)}))))),this.B(this.m.listen("onUninstallExtension")(u=>this.n(this.g,{...u,profileLocation:j.URI.revive(u.profileLocation)}))),this.B(this.m.listen("onDidUninstallExtension")(u=>this.n(this.h,{...u,profileLocation:j.URI.revive(u.profileLocation)}))),this.B(this.m.listen("onDidUpdateExtensionMetadata")(u=>this.j.fire(R(u,null))))}n(c,u){c.fire(u)}r(c){return c?typeof c.path=="string"&&typeof c.scheme=="string":!1}getTargetPlatform(){return this.s||(this.s=this.m.call("getTargetPlatform")),this.s}async canInstall(c){const u=await this.getTargetPlatform();return c.allTargetPlatforms.some(h=>(0,C.$bo)(h,c.allTargetPlatforms,u))}zip(c){return Promise.resolve(this.m.call("zip",[c]).then(u=>j.URI.revive(u)))}unzip(c){return Promise.resolve(this.m.call("unzip",[c]))}install(c,u){return Promise.resolve(this.m.call("install",[c,u])).then(h=>R(h,null))}installFromLocation(c,u){return Promise.resolve(this.m.call("installFromLocation",[c,u])).then(h=>R(h,null))}async installExtensionsFromProfile(c,u,h){return(await this.m.call("installExtensionsFromProfile",[c,u,h])).map(k=>R(k,null))}getManifest(c){return Promise.resolve(this.m.call("getManifest",[c]))}installFromGallery(c,u){return Promise.resolve(this.m.call("installFromGallery",[c,u])).then(h=>R(h,null))}async installGalleryExtensions(c){return(await this.m.call("installGalleryExtensions",[c])).map(h=>({...h,local:h.local?R(h.local,null):h.local,source:this.r(h.source)?j.URI.revive(h.source):h.source,profileLocation:j.URI.revive(h.profileLocation)}))}uninstall(c,u){return Promise.resolve(this.m.call("uninstall",[c,u]))}reinstallFromGallery(c){return Promise.resolve(this.m.call("reinstallFromGallery",[c])).then(u=>R(u,null))}getInstalled(c=null,u){return Promise.resolve(this.m.call("getInstalled",[c,u])).then(h=>h.map(m=>R(m,null)))}updateMetadata(c,u,h){return Promise.resolve(this.m.call("updateMetadata",[c,u,h])).then(m=>R(m,null))}toggleAppliationScope(c,u){return this.m.call("toggleAppliationScope",[c,u]).then(h=>R(h,null))}copyExtensions(c,u){return this.m.call("copyExtensions",[c,u])}getExtensionsControlManifest(){return Promise.resolve(this.m.call("getExtensionsControlManifest"))}async download(c,u,h){const m=await this.m.call("download",[c,u,h]);return j.URI.revive(m)}async cleanUp(){return this.m.call("cleanUp")}registerParticipant(){throw new Error("Not Supported")}}e.$op=g;class y{constructor(c){this.a=c}listen(c,u){throw new Error("Invalid listen")}call(c,u,h){switch(u){case"getConfigBasedTips":return this.a.getConfigBasedTips(j.URI.revive(h[0]));case"getImportantExecutableBasedTips":return this.a.getImportantExecutableBasedTips();case"getOtherExecutableBasedTips":return this.a.getOtherExecutableBasedTips()}throw new Error("Invalid call")}}e.$pp=y}),define(ae[97],ce([0,1,4]),function(ie,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lp=e.$kp=void 0,e.$kp=(0,D.$Vh)("IExtensionSignatureVerificationService");class A{b(){return this.a||(this.a=new Promise((j,O)=>ie(["node-vsce-sign"],async C=>j(C),O))),this.a}async verify(j,O,C){let S;try{S=await this.b()}catch{return!1}return S.verify(j,O,C)}}e.$lp=A}),define(ae[98],ce([0,1,4]),function(ie,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$aXb=e.RecommendationsNotificationResult=e.$_Wb=e.RecommendationSource=void 0;var A;(function(O){O[O.FILE=1]="FILE",O[O.WORKSPACE=2]="WORKSPACE",O[O.EXE=3]="EXE"})(A||(e.RecommendationSource=A={}));function L(O){switch(O){case 1:return"file";case 2:return"workspace";case 3:return"exe"}}e.$_Wb=L;var j;(function(O){O.Ignored="ignored",O.Cancelled="cancelled",O.TooMany="toomany",O.IncompatibleWindow="incompatibleWindow",O.Accepted="reacted"})(j||(e.RecommendationsNotificationResult=j={})),e.$aXb=(0,D.$Vh)("IExtensionRecommendationNotificationService")}),define(ae[11],ce([0,1,47,16,27,12,10,159,4,5,23,61]),function(ie,e,D,A,L,j,O,C,S,d,R,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nk=e.$Mk=e.$Lk=e.$Kk=e.$Jk=e.FileKind=e.$Ik=e.$Hk=e.$Gk=e.$Fk=e.$Ek=e.$Dk=e.$Ck=e.FileOperationResult=e.$Bk=e.$Ak=e.$zk=e.$yk=e.$xk=e.FileChangeType=e.$wk=e.FileOperation=e.$vk=e.$uk=e.$tk=e.$sk=e.$rk=e.$qk=e.FileSystemProviderErrorCode=e.$pk=e.$ok=e.$nk=e.$mk=e.$lk=e.$kk=e.$jk=e.$ik=e.$hk=e.FileSystemProviderCapabilities=e.$gk=e.FilePermission=e.FileType=e.$fk=e.$ek=void 0,e.$ek=(0,S.$Vh)("fileService");function b(_){return _.create===!0}e.$fk=b;var l;(function(_){_[_.Unknown=0]="Unknown",_[_.File=1]="File",_[_.Directory=2]="Directory",_[_.SymbolicLink=64]="SymbolicLink"})(l||(e.FileType=l={}));var g;(function(_){_[_.Readonly=1]="Readonly",_[_.Locked=2]="Locked"})(g||(e.FilePermission=g={}));function y(_){const se=_;return!!se&&typeof se.onDidChange=="function"}e.$gk=y;var w;(function(_){_[_.None=0]="None",_[_.FileReadWrite=2]="FileReadWrite",_[_.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",_[_.FileReadStream=16]="FileReadStream",_[_.FileFolderCopy=8]="FileFolderCopy",_[_.PathCaseSensitive=1024]="PathCaseSensitive",_[_.Readonly=2048]="Readonly",_[_.Trash=4096]="Trash",_[_.FileWriteUnlock=8192]="FileWriteUnlock",_[_.FileAtomicRead=16384]="FileAtomicRead",_[_.FileAtomicWrite=32768]="FileAtomicWrite",_[_.FileAtomicDelete=65536]="FileAtomicDelete",_[_.FileClone=131072]="FileClone"})(w||(e.FileSystemProviderCapabilities=w={}));function c(_){return!!(_.capabilities&2)}e.$hk=c;function u(_){return!!(_.capabilities&8)}e.$ik=u;function h(_){return!!(_.capabilities&131072)}e.$jk=h;function m(_){return!!(_.capabilities&4)}e.$kk=m;function k(_){return!!(_.capabilities&16)}e.$lk=k;function s(_){return c(_)?!!(_.capabilities&16384):!1}e.$mk=s;function a(_){return c(_)?!!(_.capabilities&32768):!1}e.$nk=a;function n(_){return!!(_.capabilities&65536)}e.$ok=n;function i(_){return!!(_.capabilities&2048)}e.$pk=i;var t;(function(_){_.FileExists="EntryExists",_.FileNotFound="EntryNotFound",_.FileNotADirectory="EntryNotADirectory",_.FileIsADirectory="EntryIsADirectory",_.FileExceedsStorageQuota="EntryExceedsStorageQuota",_.FileTooLarge="EntryTooLarge",_.FileWriteLocked="EntryWriteLocked",_.NoPermissions="NoPermissions",_.Unavailable="Unavailable",_.Unknown="Unknown"})(t||(e.FileSystemProviderErrorCode=t={}));class r extends Error{static create(se,K){const U=new r(se.toString(),K);return $(U,K),U}constructor(se,K){super(se),this.code=K}}e.$qk=r;function o(_,se){return r.create(_,se)}e.$rk=o;function v(_){return _||o((0,C.localize)(0,null),t.Unknown)}e.$sk=v;function $(_,se){return _.name=se?`${se} (FileSystemError)`:"FileSystemError",_}e.$tk=$;function f(_){if(!_)return t.Unknown;if(_ instanceof r)return _.code;const se=/^(.+) \(FileSystemError\)$/.exec(_.name);if(!se)return t.Unknown;switch(se[1]){case t.FileExists:return t.FileExists;case t.FileIsADirectory:return t.FileIsADirectory;case t.FileNotADirectory:return t.FileNotADirectory;case t.FileNotFound:return t.FileNotFound;case t.FileTooLarge:return t.FileTooLarge;case t.FileWriteLocked:return t.FileWriteLocked;case t.NoPermissions:return t.NoPermissions;case t.Unavailable:return t.Unavailable}return t.Unknown}e.$uk=f;function p(_){if(_ instanceof Y)return _.fileOperationResult;switch(f(_)){case t.FileNotFound:return 1;case t.FileIsADirectory:return 0;case t.FileNotADirectory:return 9;case t.FileWriteLocked:return 5;case t.NoPermissions:return 6;case t.FileExists:return 4;case t.FileTooLarge:return 7;default:return 10}}e.$vk=p;var I;(function(_){_[_.CREATE=0]="CREATE",_[_.DELETE=1]="DELETE",_[_.MOVE=2]="MOVE",_[_.COPY=3]="COPY",_[_.WRITE=4]="WRITE"})(I||(e.FileOperation=I={}));class T{constructor(se,K,U){this.resource=se,this.operation=K,this.target=U}isOperation(se){return this.operation===se}}e.$wk=T;var M;(function(_){_[_.UPDATED=0]="UPDATED",_[_.ADDED=1]="ADDED",_[_.DELETED=2]="DELETED"})(M||(e.FileChangeType=M={}));class z{static{this.a=null}constructor(se,K){this.c=K,this.b=void 0,this.d=new E.$U(()=>{const U=D.$2h.forUris(()=>this.c);return U.fill(this.rawAdded.map(P=>[P,!0])),U}),this.f=new E.$U(()=>{const U=D.$2h.forUris(()=>this.c);return U.fill(this.rawUpdated.map(P=>[P,!0])),U}),this.g=new E.$U(()=>{const U=D.$2h.forUris(()=>this.c);return U.fill(this.rawDeleted.map(P=>[P,!0])),U}),this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[];for(const U of se){switch(U.type){case 1:this.rawAdded.push(U.resource);break;case 0:this.rawUpdated.push(U.resource);break;case 2:this.rawDeleted.push(U.resource);break}this.b!==z.a&&(typeof U.cId=="number"?this.b===void 0?this.b=U.cId:this.b!==U.cId&&(this.b=z.a):this.b!==void 0&&(this.b=z.a))}}contains(se,...K){return this.h(se,{includeChildren:!1},...K)}affects(se,...K){return this.h(se,{includeChildren:!0},...K)}h(se,K,...U){if(!se)return!1;const P=U.length>0;return!!((!P||U.includes(1))&&(this.d.value.get(se)||K.includeChildren&&this.d.value.findSuperstr(se))||(!P||U.includes(0))&&(this.f.value.get(se)||K.includeChildren&&this.f.value.findSuperstr(se))||(!P||U.includes(2))&&(this.g.value.findSubstr(se)||K.includeChildren&&this.g.value.findSuperstr(se)))}gotAdded(){return this.rawAdded.length>0}gotDeleted(){return this.rawDeleted.length>0}gotUpdated(){return this.rawUpdated.length>0}correlates(se){return this.b===se}hasCorrelation(){return typeof this.b=="number"}}e.$xk=z;function q(_,se,K){return!_||!se||_===se||se.length>_.length?!1:(se.charAt(se.length-1)!==A.sep&&(se+=A.sep),K?(0,L.$7e)(_,se):_.indexOf(se)===0)}e.$yk=q;class Y extends Error{constructor(se,K,U){super(se),this.fileOperationResult=K,this.options=U}}e.$zk=Y;class Q extends Y{constructor(se,K,U,P){super(se,K,P),this.fileOperationResult=K,this.size=U}}e.$Ak=Q;class x extends Y{constructor(se,K,U){super(se,2,U),this.stat=K}}e.$Bk=x;var H;(function(_){_[_.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",_[_.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",_[_.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",_[_.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",_[_.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",_[_.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",_[_.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",_[_.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",_[_.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",_[_.FILE_NOT_DIRECTORY=9]="FILE_NOT_DIRECTORY",_[_.FILE_OTHER_ERROR=10]="FILE_OTHER_ERROR"})(H||(e.FileOperationResult=H={})),e.$Ck={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.$Dk={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.$Ek="files.associations",e.$Fk="files.exclude",e.$Gk="files.readonlyInclude",e.$Hk="files.readonlyExclude",e.$Ik="files.readonlyFromPermissions";var Z;(function(_){_[_.FILE=0]="FILE",_[_.FOLDER=1]="FOLDER",_[_.ROOT_FOLDER=2]="ROOT_FOLDER"})(Z||(e.FileKind=Z={})),e.$Jk="";function J(_){if(!(typeof _.size!="number"||typeof _.mtime!="number"))return _.mtime.toString(29)+_.size.toString(31)}e.$Kk=J;async function W(_,se){if(!se.hasProvider(O.URI.from({scheme:_.scheme})))return new Promise(K=>{const U=se.onDidChangeFileSystemProviderRegistrations(P=>{P.scheme===_.scheme&&P.added&&(U.dispose(),K())})})}e.$Lk=W;class ee{static{this.KB=1024}static{this.MB=ee.KB*ee.KB}static{this.GB=ee.MB*ee.KB}static{this.TB=ee.GB*ee.KB}static formatSize(se){return(0,j.$Gf)(se)||(se=0),se<ee.KB?(0,C.localize)(1,null,se.toFixed(0)):se<ee.MB?(0,C.localize)(2,null,(se/ee.KB).toFixed(2)):se<ee.GB?(0,C.localize)(3,null,(se/ee.MB).toFixed(2)):se<ee.TB?(0,C.localize)(4,null,(se/ee.GB).toFixed(2)):(0,C.localize)(5,null,(se/ee.TB).toFixed(2))}}e.$Mk=ee;function ne(_){const se=typeof _=="string"||_?.scheme===R.Schemas.vscodeRemote;return typeof _!="string"&&_?.scheme===R.Schemas.file?1024*ee.MB:se?10*ee.MB:d.$o?50*ee.MB:1024*ee.MB}e.$Nk=ne});var X=this&&this.__param||function(ie,e){return function(D,A){e(D,A,ie)}};define(ae[188],ce([0,1,71,46,11]),function(ie,e,D,A,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$k0b=void 0;let j=class{constructor(C){this.a=C}async checksum(C){const S=(await this.a.readFileStream(C)).value;return new Promise((d,R)=>{const E=(0,D.createHash)("md5");(0,A.$0d)(S,{onData:b=>E.update(b.buffer),onError:b=>R(b),onEnd:()=>d(E.digest("base64").replace(/=+$/,""))})})}};e.$k0b=j,e.$k0b=j=pe([X(0,L.$ek)],j)}),define(ae[99],ce([0,1,15,7,160,11]),function(ie,e,D,A,L,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sp=void 0;async function O(R,E,b,l,g,y){let w;try{await C(R,E,b,l,g,y)}catch(c){w=c}finally{w&&g.errorTransformer&&(w=g.errorTransformer(w)),typeof w<"u"&&b.error(w),b.end()}}e.$Sp=O;async function C(R,E,b,l,g,y){S(y);const w=await R.open(E,{create:!1});try{S(y);let c=0,u=0,h=g&&typeof g.length=="number"?g.length:void 0,m=D.$fe.alloc(Math.min(g.bufferSize,typeof h=="number"?h:g.bufferSize)),k=g&&typeof g.position=="number"?g.position:0,s=0;do u=await R.read(w,k,m.buffer,s,m.byteLength-s),k+=u,s+=u,c+=u,typeof h=="number"&&(h-=u),s===m.byteLength&&(await b.write(l(m)),m=D.$fe.alloc(Math.min(g.bufferSize,typeof h=="number"?h:g.bufferSize)),s=0);while(u>0&&(typeof h!="number"||h>0)&&S(y)&&d(c,g));if(s>0){let a=s;typeof h=="number"&&(a=Math.min(s,h)),b.write(l(m.slice(0,a)))}}catch(c){throw(0,j.$sk)(c)}finally{await R.close(w)}}function S(R){if(R.isCancellationRequested)throw(0,A.$5)();return!0}function d(R,E){if(typeof E?.limits?.size=="number"&&R>E.limits.size)throw(0,j.$rk)((0,L.localize)(0,null),j.FileSystemProviderErrorCode.FileTooLarge);return!0}}),define(ae[49],ce([0,1,91,2,16,5,10,11]),function(ie,e,D,A,L,j,O,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2p=e.$1p=e.$Zp=e.$Yp=e.$Xp=e.$Wp=e.$Vp=e.$Up=void 0;function S(c){return c.recursive===!0}e.$Up=S;class d extends A.$Rc{static{this.a=5}constructor(u,h,m,k){super(),this.h=u,this.j=h,this.m=m,this.n=k,this.c=this.B(new A.$Sc),this.f=void 0,this.g=0}s(){const u=new A.$Qc;this.c.value=u,this.b=this.r(u),this.b.setVerboseLogging(this.m),u.add(this.b.onDidChangeFile(h=>this.h(h))),u.add(this.b.onDidLogMessage(h=>this.j(h))),u.add(this.b.onDidError(h=>this.t(h)))}t(u){this.n.restartOnError?this.g<d.a&&this.f?(this.w(`restarting watcher after error: ${u}`),this.u(this.f)):this.w(`gave up attempting to restart watcher after error: ${u}`):this.w(u)}u(u){this.g++,this.s(),this.watch(u)}async watch(u){this.f=u,await this.b?.watch(u)}async setVerboseLogging(u){this.m=u,await this.b?.setVerboseLogging(u)}w(u){this.j({type:"error",message:`[File Watcher (${this.n.type})] ${u}`})}y(u){this.j({type:"trace",message:`[File Watcher (${this.n.type})] ${u}`})}dispose(){return this.b=void 0,super.dispose()}}e.$Vp=d;class R extends d{constructor(u,h,m){super(u,h,m,{type:"node.js",restartOnError:!1})}}e.$Wp=R;class E extends d{constructor(u,h,m){super(u,h,m,{type:"universal",restartOnError:!0})}}e.$Xp=E;function b(c){return c.map(u=>({type:u.type,resource:O.URI.revive(u.resource),cId:u.cId}))}e.$Yp=b;function l(c){const u=new w;for(const h of c)u.processEvent(h);return u.coalesce()}e.$Zp=l;function g(c,u){return typeof u=="string"&&!u.startsWith(D.$yj)&&!(0,L.$hc)(u)?{base:c,pattern:u}:u}e.$1p=g;function y(c,u){const h=[];for(const m of u)h.push((0,D.$Cj)(g(c,m)));return h}e.$2p=y;class w{constructor(){this.a=new Set,this.b=new Map}c(u){return j.$k?u.resource.fsPath:u.resource.fsPath.toLowerCase()}processEvent(u){const h=this.b.get(this.c(u));let m=!1;if(h){const k=h.type,s=u.type;h.resource.fsPath!==u.resource.fsPath&&(u.type===2||u.type===1)?m=!0:k===1&&s===2?(this.b.delete(this.c(u)),this.a.delete(h)):k===2&&s===1?h.type=0:k===1&&s===0||(h.type=s)}else m=!0;m&&(this.a.add(u),this.b.set(this.c(u),u))}coalesce(){const u=[],h=[];return Array.from(this.a).filter(m=>m.type!==2?(u.push(m),!1):!0).sort((m,k)=>m.resource.fsPath.length-k.resource.fsPath.length).filter(m=>h.some(k=>(0,C.$yk)(m.resource.fsPath,k,!j.$k))?!1:(h.push(m.resource.fsPath),!0)).concat(u)}}}),define(ae[189],ce([0,1,15,38,7,3,2,46,32,11,49]),function(ie,e,D,A,L,j,O,C,S,d,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$FN=e.$EN=void 0,e.$EN="localFilesystem";class E extends O.$Rc{constructor(l,g){super(),this.a=l,this.b=g,this.onDidChangeCapabilities=j.Event.None,this.f=this.B(new j.$Rd),this.onDidChangeFile=this.f.event,this.g=this.B(new j.$Rd),this.onDidWatchError=this.g.event,this.h=(0,S.$ig)(),this.j()}get capabilities(){return this.c||(this.c=253982,this.b.pathCaseSensitive&&(this.c|=1024),this.b.trash&&(this.c|=4096)),this.c}stat(l){return this.a.call("stat",[l])}readdir(l){return this.a.call("readdir",[l])}async readFile(l,g){const{buffer:y}=await this.a.call("readFile",[l,g]);return y}readFileStream(l,g,y){const w=(0,C.$6d)(u=>D.$fe.concat(u.map(h=>D.$fe.wrap(h))).buffer),c=new O.$Qc;return c.add(this.a.listen("readFileStream",[l,g])(u=>{if(u instanceof D.$fe)w.write(u.buffer);else{if(u==="end")w.end();else{let h;if(u instanceof Error)h=u;else{const m=u;h=(0,d.$rk)(m.message??(0,A.$Gi)(m),m.code??d.FileSystemProviderErrorCode.Unknown)}w.error(h),w.end()}c.dispose()}})),c.add(y.onCancellationRequested(()=>{w.error((0,L.$5)()),w.end(),c.dispose()})),w}writeFile(l,g,y){return this.a.call("writeFile",[l,D.$fe.wrap(g),y])}open(l,g){return this.a.call("open",[l,g])}close(l){return this.a.call("close",[l])}async read(l,g,y,w,c){const[u,h]=await this.a.call("read",[l,g,c]);return y.set(u.buffer.slice(0,h),w),h}write(l,g,y,w,c){return this.a.call("write",[l,g,D.$fe.wrap(y),w,c])}mkdir(l){return this.a.call("mkdir",[l])}delete(l,g){return this.a.call("delete",[l,g])}rename(l,g,y){return this.a.call("rename",[l,g,y])}copy(l,g,y){return this.a.call("copy",[l,g,y])}cloneFile(l,g){return this.a.call("cloneFile",[l,g])}j(){this.B(this.a.listen("fileChange",[this.h])(l=>{if(Array.isArray(l)){const g=l;this.f.fire((0,R.$Yp)(g))}else{const g=l;this.g.fire(g)}}))}watch(l,g){const y=(0,S.$ig)();return this.a.call("watch",[this.h,y,l,g]),(0,O.$Pc)(()=>this.a.call("unwatch",[this.h,y]))}}e.$FN=E}),define(ae[190],ce([0,1,53,6,26,48,2,88,16,5,19,10,143,31,49]),function(ie,e,D,A,L,j,O,C,S,d,R,E,b,l,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dq=e.$cq=void 0;class y extends O.$Rc{static{this.a=100}static{this.b=75}constructor(u,h,m,k){super(),this.m=u,this.n=h,this.r=m,this.s=k,this.c=this.B(new A.$ah({maxWorkChunkSize:100,throttleDelay:200,maxBufferedWork:1e4},s=>this.n(s))),this.f=this.B(new A.$_g(s=>this.z(s),y.b)),this.g=(0,g.$2p)(this.m.path,this.m.excludes),this.h=this.m.includes?(0,g.$2p)(this.m.path,this.m.includes):void 0,this.j=new L.$2d,this.ready=this.t()}async t(){try{const u=await this.u(this.m);if(this.j.token.isCancellationRequested)return;const h=await l.Promises.stat(u);this.B(await this.w(u,h.isDirectory()))}catch(u){u.code!=="ENOENT"?this.D(u):this.G(u)}}async u(u){let h=u.path;try{h=await l.Promises.realpath(u.path),u.path===h&&(h=await(0,b.$_p)(u.path)??u.path),u.path!==h&&this.G(`correcting a path to watch that seems to be a symbolic link or wrong casing (original: ${u.path}, real: ${h})`)}catch{}return h}async w(u,h){if(d.$j&&(0,j.$2f)(u,"/Volumes/",!0))return this.D(`Refusing to watch ${u} for changes using fs.watch() for possibly being a network share where watching is unreliable and unstable.`),O.$Rc.None;const m=new L.$2d(this.j.token),k=new O.$Qc;try{const s=E.URI.file(this.m.path),a=(0,S.$mc)(u),n=(0,D.watch)(u);k.add((0,O.$Pc)(()=>{n.removeAllListeners(),n.close()})),this.G(`Started watching: '${u}'`);const i=new Set;if(h)try{for(const r of await l.Promises.readdir(u))i.add(r)}catch(r){this.D(r)}const t=new Map;k.add((0,O.$Pc)(()=>{for(const[,r]of t)r.dispose();t.clear()})),n.on("error",(r,o)=>{this.D(`Failed to watch ${u} for changes using fs.watch() (${r}, ${o})`),this.dispose()}),n.on("change",(r,o)=>{if(m.token.isCancellationRequested)return;this.G(`[raw] ["${r}"] ${o}`);let v="";if(o&&(v=o.toString(),d.$j&&(v=(0,C.$ul)(v))),!(!v||r!=="change"&&r!=="rename"))if(h)if(r==="rename"){t.get(v)?.dispose();const $=setTimeout(async()=>{if(t.delete(v),v===a&&!await l.Promises.exists(u)){this.F("Watcher shutdown because watched path got deleted"),this.dispose();return}const f=await this.C((0,S.$ic)(u,v));if(m.token.isCancellationRequested)return;let p;f?i.has(v)?p=0:(p=1,i.add(v)):(i.delete(v),p=2),this.y({resource:(0,R.$zg)(s,v),type:p,cId:this.m.correlationId})},y.a);t.set(v,(0,O.$Pc)(()=>clearTimeout($)))}else{let $;i.has(v)?$=0:($=1,i.add(v)),this.y({resource:(0,R.$zg)(s,v),type:$,cId:this.m.correlationId})}else if(r==="rename"||v!==a){const $=setTimeout(async()=>{const f=await l.Promises.exists(u);m.token.isCancellationRequested||(f?(this.y({resource:s,type:0,cId:this.m.correlationId},!0),k.add(await this.w(u,!1))):(this.y({resource:s,type:2,cId:this.m.correlationId},!0),this.f.flush(),this.dispose()))},y.a);k.clear(),k.add((0,O.$Pc)(()=>clearTimeout($)))}else this.y({resource:s,type:0,cId:this.m.correlationId},!0)})}catch(s){await l.Promises.exists(u)&&!m.token.isCancellationRequested&&this.D(`Failed to watch ${u} for changes using fs.watch() (${s.toString()})`)}return(0,O.$Pc)(()=>{m.dispose(!0),k.dispose()})}y(u,h=!1){this.j.token.isCancellationRequested||(this.s&&this.G(`${u.type===1?"[ADDED]":u.type===2?"[DELETED]":"[CHANGED]"} ${u.resource.fsPath}`),!h&&this.g.some(m=>m(u.resource.fsPath))?this.s&&this.G(` >> ignored (excluded) ${u.resource.fsPath}`):!h&&this.h&&this.h.length>0&&!this.h.some(m=>m(u.resource.fsPath))?this.s&&this.G(` >> ignored (not included) ${u.resource.fsPath}`):this.f.work(u))}z(u){const h=(0,g.$Zp)(u);if(h.length>0){if(this.s)for(const k of h)this.G(` >> normalized ${k.type===1?"[ADDED]":k.type===2?"[DELETED]":"[CHANGED]"} ${k.resource.fsPath}`);this.c.work(h)?this.c.pending>0&&this.G(`started throttling events due to large amount of file change events at once (pending: ${this.c.pending}, most recent change: ${h[0].resource.fsPath}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`):this.F(`started ignoring events due to too many file change events at once (incoming: ${h.length}, most recent change: ${h[0].resource.fsPath}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`)}}async C(u){if(d.$k)return l.Promises.exists(u);try{const h=(0,S.$mc)(u);return(await l.Promises.readdir((0,S.$lc)(u))).some(k=>k===h)}catch(h){return this.G(h),!1}}setVerboseLogging(u){this.s=u}D(u){this.j.token.isCancellationRequested||this.r?.({type:"error",message:`[File Watcher (node.js)] ${u}`})}F(u){this.j.token.isCancellationRequested||this.r?.({type:"warn",message:`[File Watcher (node.js)] ${u}`})}G(u){!this.j.token.isCancellationRequested&&this.s&&this.r?.({type:"trace",message:`[File Watcher (node.js)] ${u}`})}dispose(){this.G(`stopping file watcher on ${this.m.path}`),this.j.dispose(!0),super.dispose()}}e.$cq=y;async function w(c,u,h,m,k=512){const s=await l.Promises.open(c,"r"),a=Buffer.allocUnsafe(k),n=new L.$2d(m);let i,t=!1;const r={path:c,excludes:[],recursive:!1},o=new y(r,v=>{(async()=>{for(const{type:$}of v)if($===0){if(t)return;t=!0;try{for(;!n.token.isCancellationRequested;){const{bytesRead:f}=await l.Promises.read(s,a,0,k,null);if(!f||n.token.isCancellationRequested)break;u(a.slice(0,f))}}catch(f){i=new Error(f),n.dispose(!0)}finally{t=!1}}})()});return await o.ready,h(),new Promise((v,$)=>{n.token.onCancellationRequested(async()=>{o.dispose();try{await l.Promises.close(s)}catch(f){i=new Error(f)}i?$(i):v()})})}e.$dq=w}),define(ae[191],ce([0,1,3,91,2,5,190]),function(ie,e,D,A,L,j,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$eq=void 0;class C extends L.$Rc{constructor(){super(...arguments),this.a=this.B(new D.$Rd),this.onDidChangeFile=this.a.event,this.b=this.B(new D.$Rd),this.onDidLogMessage=this.b.event,this.onDidError=D.Event.None,this.c=new Map,this.f=!1}async watch(d){const R=this.j(d),E=R.filter(l=>{const g=this.c.get(l.path);return g?!(0,A.$Gj)(g.request.excludes,l.excludes)||!(0,A.$Gj)(g.request.includes,l.includes):!0}),b=Array.from(this.c.values()).filter(({request:l})=>!R.find(g=>g.path===l.path&&(0,A.$Gj)(g.excludes,l.excludes)&&(0,A.$Gj)(g.includes,l.includes))).map(({request:l})=>l.path);E.length&&this.m(`Request to start watching: ${E.map(l=>`${l.path} (excludes: ${l.excludes.length>0?l.excludes:"<none>"}, includes: ${l.includes&&l.includes.length>0?JSON.stringify(l.includes):"<all>"}, correlationId: ${typeof l.correlationId=="number"?l.correlationId:"<none>"})`).join(",")}`),b.length&&this.m(`Request to stop watching: ${b.join(",")}`);for(const l of b)this.h(l);for(const l of E)this.g(l)}g(d){const R=new O.$cq(d,b=>this.a.fire(b),b=>this.b.fire(b),this.f),E={request:d,instance:R};this.c.set(d.path,E)}async stop(){for(const[d]of this.c)this.h(d);this.c.clear()}h(d){const R=this.c.get(d);R&&(this.c.delete(d),R.instance.dispose())}j(d){const R=new Map;for(const E of d){const b=j.$k?E.path:E.path.toLowerCase();let l=R.get(E.correlationId);l||(l=new Map,R.set(E.correlationId,l)),l.set(b,E)}return Array.from(R.values()).map(E=>Array.from(E.values())).flat()}async setVerboseLogging(d){this.f=d;for(const[,R]of this.c)R.instance.setVerboseLogging(d)}m(d){this.f&&this.b.fire({type:"trace",message:this.n(d)})}n(d,R){return R?`[File Watcher (node.js)] ${d} (path: ${R.request.path})`:`[File Watcher (node.js)] ${d}`}}e.$eq=C}),define(ae[192],ce([0,1,49,191]),function(ie,e,D,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fq=void 0;class L extends D.$Wp{constructor(O,C,S){super(O,C,S),this.s()}r(O){return O.add(new A.$eq)}}e.$fq=L}),define(ae[193],ce([0,1,23,40,93,49]),function(ie,e,D,A,L,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0p=void 0;class O extends j.$Xp{constructor(S,d,R){super(S,d,R),this.s()}r(S){const d=S.add(new L.$9p(D.$gg.asFileUri("bootstrap-fork").fsPath,{serverName:"File Watcher",args:["--type=fileWatcher"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/watcherMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));return S.add(d.onDidProcessExit(({code:R,signal:E})=>this.t(`terminated by itself with code ${R}, signal: ${E}`))),A.ProxyChannel.toService((0,A.$Ch)(d.getChannel("watcher")))}}e.$0p=O}),define(ae[72],ce([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Th=void 0;class D{constructor(...L){this.a=new Map;for(const[j,O]of L)this.set(j,O)}set(L,j){const O=this.a.get(L);return this.a.set(L,j),O}has(L){return this.a.has(L)}get(L){return this.a.get(L)}}e.$Th=D}),define(ae[194],ce([0,1,6,7,2,70,185,4,72,87]),function(ie,e,D,A,L,j,O,C,S,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kq=e.$jq=void 0;const R=!1;class E extends Error{constructor(w){super("cyclic dependency between services"),this.message=w.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${w.toString()}`}}class b{constructor(w=new S.$Th,c=!1,u,h=R){this.f=w,this.g=c,this.h=u,this.i=h,this.o=new Set,this.f.set(C.$Uh,this),this._globalGraph=h?u?._globalGraph??new O.$iq(m=>m):void 0}createChild(w){return new b(w,this.g,this,this.i)}invokeFunction(w,...c){const u=g.traceInvocation(this.i,w);let h=!1;try{return w({get:k=>{if(h)throw(0,A.$7)("service accessor is only valid during the invocation of its target method");const s=this.m(k,u);if(!s)throw new Error(`[invokeFunction] unknown service '${k}'`);return s}},...c)}finally{h=!0,u.stop()}}createInstance(w,...c){let u,h;return w instanceof j.$Sh?(u=g.traceCreation(this.i,w.ctor),h=this.j(w.ctor,w.staticArguments.concat(c),u)):(u=g.traceCreation(this.i,w),h=this.j(w,c,u)),u.stop(),h}j(w,c=[],u){const h=C._util.getServiceDependencies(w).sort((s,a)=>s.index-a.index),m=[];for(const s of h){const a=this.m(s.id,u);a||this.u(`[createInstance] ${w.name} depends on UNKNOWN service ${s.id}.`,!1),m.push(a)}const k=h.length>0?h[0].index:c.length;if(c.length!==k){console.trace(`[createInstance] First service dependency of ${w.name} at position ${k+1} conflicts with ${c.length} static arguments`);const s=k-c.length;s>0?c=c.concat(new Array(s)):c=c.slice(0,k)}return Reflect.construct(w,c.concat(m))}k(w,c){if(this.f.get(w)instanceof j.$Sh)this.f.set(w,c);else if(this.h)this.h.k(w,c);else throw new Error("illegalState - setting UNKNOWN service instance")}l(w){const c=this.f.get(w);return!c&&this.h?this.h.l(w):c}m(w,c){this._globalGraph&&this.c&&this._globalGraph.insertEdge(this.c,String(w));const u=this.l(w);return u instanceof j.$Sh?this.q(w,u,c.branch(w,!0)):(c.branch(w,!1),u)}q(w,c,u){if(this.o.has(w))throw new Error(`illegal state - RECURSIVELY instantiating service '${w}'`);this.o.add(w);try{return this.r(w,c,u)}finally{this.o.delete(w)}}r(w,c,u){const h=new O.$iq(s=>s.id.toString());let m=0;const k=[{id:w,desc:c,_trace:u}];for(;k.length;){const s=k.pop();if(h.lookupOrInsertNode(s),m++>1e3)throw new E(h);for(const a of C._util.getServiceDependencies(s.desc.ctor)){const n=this.l(a.id);if(n||this.u(`[createInstance] ${w} depends on ${a.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(s.id),String(a.id)),n instanceof j.$Sh){const i={id:a.id,desc:n,_trace:s._trace.branch(a.id,!0)};h.insertEdge(s,i),k.push(i)}}}for(;;){const s=h.roots();if(s.length===0){if(!h.isEmpty())throw new E(h);break}for(const{data:a}of s){if(this.l(a.id)instanceof j.$Sh){const i=this.s(a.id,a.desc.ctor,a.desc.staticArguments,a.desc.supportsDelayedInstantiation,a._trace);this.k(a.id,i)}h.removeNode(a)}}return this.l(w)}s(w,c,u=[],h,m){if(this.f.get(w)instanceof j.$Sh)return this.t(w,c,u,h,m);if(this.h)return this.h.s(w,c,u,h,m);throw new Error(`illegalState - creating UNKNOWN service instance ${c.name}`)}t(w,c,u=[],h,m){if(h){const k=new b(void 0,this.g,this,this.i);k.c=String(w);const s=new Map,a=new D.$eh(()=>{const n=k.j(c,u,m);for(const[i,t]of s){const r=n[i];if(typeof r=="function")for(const o of t)r.apply(n,o)}return s.clear(),n});return new Proxy(Object.create(null),{get(n,i){if(!a.isInitialized&&typeof i=="string"&&(i.startsWith("onDid")||i.startsWith("onWill"))){let o=s.get(i);return o||(o=new d.$2c,s.set(i,o)),($,f,p)=>{const I=o.push([$,f,p]);return(0,L.$Pc)(I)}}if(i in n)return n[i];const t=a.value;let r=t[i];return typeof r!="function"||(r=r.bind(t),n[i]=r),r},set(n,i,t){return a.value[i]=t,!0},getPrototypeOf(n){return c.prototype}})}else return this.j(c,u,m)}u(w,c){if(c&&console.warn(w),this.g)throw new Error(w)}}e.$jq=b;var l;(function(y){y[y.None=0]="None",y[y.Creation=1]="Creation",y[y.Invocation=2]="Invocation",y[y.Branch=3]="Branch"})(l||(l={}));class g{static{this.all=new Set}static{this.c=new class extends g{constructor(){super(0,null)}stop(){}branch(){return this}}}static traceInvocation(w,c){return w?new g(2,c.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):g.c}static traceCreation(w,c){return w?new g(1,c.name):g.c}static{this.f=0}constructor(w,c){this.type=w,this.name=c,this.g=Date.now(),this.h=[]}branch(w,c){const u=new g(3,w.toString());return this.h.push([w,c,u]),u}stop(){const w=Date.now()-this.g;g.f+=w;let c=!1;function u(m,k){const s=[],a=new Array(m+1).join("	");for(const[n,i,t]of k.h)if(i&&t){c=!0,s.push(`${a}CREATES -> ${n}`);const r=u(m+1,t);r&&s.push(r)}else s.push(`${a}uses -> ${n}`);return s.join(`
`)}const h=[`${this.type===1?"CREATE":"CALL"} ${this.name}`,`${u(1,this)}`,`DONE, took ${w.toFixed(2)}ms (grand total ${g.f.toFixed(2)}ms)`];(w>2||c)&&g.all.add(h.join(`
`))}}e.$kq=g}),define(ae[55],ce([0,1,4]),function(ie,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$U9b=e.$T9b=void 0,e.$T9b=(0,D.$Vh)("mainProcessService");class A{constructor(j,O){this.a=j,this.b=O}getChannel(j){return this.a.getChannel(j,this.b)}registerChannel(j,O){this.a.registerChannel(j,O)}}e.$U9b=A}),define(ae[73],ce([0,1,26,2,5,162,29,4]),function(ie,e,D,A,L,j,O,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zq=e.$Yq=e.$Xq=void 0;function S(R){return R.tags.find(E=>E.startsWith("lp-"))?.split("lp-")[1]}e.$Xq=S,e.$Yq=(0,C.$Vh)("languagePackService");let d=class extends A.$Rc{constructor(E){super(),this.c=E}async getAvailableLanguages(){const E=new D.$2d;setTimeout(()=>E.cancel(),1e3);let b;try{b=await this.c.query({text:'category:"language packs"',pageSize:20},E.token)}catch{return[]}const g=b.firstPage.filter(y=>y.properties.localizedLanguages?.length&&y.tags.some(w=>w.startsWith("lp-"))).map(y=>{const w=y.properties.localizedLanguages?.[0],c=S(y);return{...this.f(c,w,y),extensionId:y.identifier.id,galleryExtension:y}});return g.push(this.f("en","English")),g}f(E,b,l){const g=b??E;let y;if(g!==E&&(y=`(${E})`),E.toLowerCase()===L.$w.toLowerCase()&&(y??="",y+=(0,j.localize)(0,null)),l?.installCount){y??="";const w=l.installCount;let c;w>1e6?c=`${Math.floor(w/1e5)/10}M`:w>1e3?c=`${Math.floor(w/1e3)}K`:c=String(w),y+=` $(cloud-download) ${c}`}return{id:E,label:g,description:y}}};e.$Zq=d,e.$Zq=d=pe([X(0,O.$do)],d)}),define(ae[195],ce([0,1,2,73]),function(ie,e,D,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$g0b=void 0;let L=class extends D.$Rc{constructor(O){super(),this.a=O,this.b()}b(){this.a.update()}};e.$g0b=L,e.$g0b=L=pe([X(0,A.$Yq)],L)}),define(ae[8],ce([0,1,38,3,52,2,34,5,19,12,10,94,4]),function(ie,e,D,A,L,j,O,C,S,d,R,E,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uj=e.$tj=e.$sj=e.$rj=e.$qj=e.$pj=e.$oj=e.$nj=e.$mj=e.$lj=e.$kj=e.$jj=e.$ij=e.log=e.$gj=e.LogLevel=e.$fj=e.$ej=e.$dj=void 0,e.$dj=(0,b.$Vh)("logService"),e.$ej=(0,b.$Vh)("loggerService");function l(){return new Date().toISOString()}function g($){return(0,d.$Gf)($)}e.$fj=g;var y;(function($){$[$.Off=0]="Off",$[$.Trace=1]="Trace",$[$.Debug=2]="Debug",$[$.Info=3]="Info",$[$.Warning=4]="Warning",$[$.Error=5]="Error"})(y||(e.LogLevel=y={})),e.$gj=y.Info;function w($,f,p){switch(f){case y.Trace:$.trace(p);break;case y.Debug:$.debug(p);break;case y.Info:$.info(p);break;case y.Warning:$.warn(p);break;case y.Error:$.error(p);break;case y.Off:break;default:throw new Error(`Invalid log level ${f}`)}}e.log=w;function c($,f=!1){let p="";for(let I=0;I<$.length;I++){let T=$[I];if(T instanceof Error&&(T=(0,D.$Gi)(T,f)),typeof T=="object")try{T=JSON.stringify(T)}catch{}p+=(I>0?" ":"")+T}return p}class u extends j.$Rc{constructor(){super(...arguments),this.b=e.$gj,this.c=this.B(new A.$Rd),this.onDidChangeLogLevel=this.c.event}setLevel(f){this.b!==f&&(this.b=f,this.c.fire(this.b))}getLevel(){return this.b}f(f){return this.b!==y.Off&&this.b<=f}}e.$ij=u;class h extends u{constructor(f){super(),this.h=f}f(f){return this.h||super.f(f)}trace(f,...p){this.f(y.Trace)&&this.g(y.Trace,c([f,...p],!0))}debug(f,...p){this.f(y.Debug)&&this.g(y.Debug,c([f,...p]))}info(f,...p){this.f(y.Info)&&this.g(y.Info,c([f,...p]))}warn(f,...p){this.f(y.Warning)&&this.g(y.Warning,c([f,...p]))}error(f,...p){if(this.f(y.Error))if(f instanceof Error){const I=Array.prototype.slice.call(arguments);I[0]=f.stack,this.g(y.Error,c(I))}else this.g(y.Error,c([f,...p]))}flush(){}}e.$jj=h;class m extends u{constructor(f=e.$gj){super(),this.setLevel(f),this.g=!C.$i}trace(f,...p){this.f(y.Trace)&&(this.g?console.log(`\x1B[90m[main ${l()}]\x1B[0m`,f,...p):console.log(`[main ${l()}]`,f,...p))}debug(f,...p){this.f(y.Debug)&&(this.g?console.log(`\x1B[90m[main ${l()}]\x1B[0m`,f,...p):console.log(`[main ${l()}]`,f,...p))}info(f,...p){this.f(y.Info)&&(this.g?console.log(`\x1B[90m[main ${l()}]\x1B[0m`,f,...p):console.log(`[main ${l()}]`,f,...p))}warn(f,...p){this.f(y.Warning)&&(this.g?console.warn(`\x1B[93m[main ${l()}]\x1B[0m`,f,...p):console.warn(`[main ${l()}]`,f,...p))}error(f,...p){this.f(y.Error)&&(this.g?console.error(`\x1B[91m[main ${l()}]\x1B[0m`,f,...p):console.error(`[main ${l()}]`,f,...p))}dispose(){}flush(){}}e.$kj=m;class k extends u{constructor(f=e.$gj,p=!0){super(),this.g=p,this.setLevel(f)}trace(f,...p){this.f(y.Trace)&&(this.g?console.log("%cTRACE","color: #888",f,...p):console.log(f,...p))}debug(f,...p){this.f(y.Debug)&&(this.g?console.log("%cDEBUG","background: #eee; color: #888",f,...p):console.log(f,...p))}info(f,...p){this.f(y.Info)&&(this.g?console.log("%c INFO","color: #33f",f,...p):console.log(f,...p))}warn(f,...p){this.f(y.Warning)&&(this.g?console.log("%c WARN","color: #993",f,...p):console.log(f,...p))}error(f,...p){this.f(y.Error)&&(this.g?console.log("%c  ERR","color: #f33",f,...p):console.error(f,...p))}dispose(){}flush(){}}e.$lj=k;class s extends u{constructor(f,p=e.$gj){super(),this.g=f,this.setLevel(p)}trace(f,...p){this.f(y.Trace)&&this.g.log(y.Trace,[this.h(f),...p])}debug(f,...p){this.f(y.Debug)&&this.g.log(y.Debug,[this.h(f),...p])}info(f,...p){this.f(y.Info)&&this.g.log(y.Info,[this.h(f),...p])}warn(f,...p){this.f(y.Warning)&&this.g.log(y.Warning,[this.h(f),...p])}error(f,...p){this.f(y.Error)&&this.g.log(y.Error,[this.h(f),...p])}h(f){return typeof f=="string"?f:(0,D.$Gi)(f,this.f(y.Trace))}dispose(){}flush(){}}e.$mj=s;class a extends u{constructor(f){super(),this.g=f,f.length&&this.setLevel(f[0].getLevel())}setLevel(f){for(const p of this.g)p.setLevel(f);super.setLevel(f)}trace(f,...p){for(const I of this.g)I.trace(f,...p)}debug(f,...p){for(const I of this.g)I.debug(f,...p)}info(f,...p){for(const I of this.g)I.info(f,...p)}warn(f,...p){for(const I of this.g)I.warn(f,...p)}error(f,...p){for(const I of this.g)I.error(f,...p)}flush(){for(const f of this.g)f.flush()}dispose(){for(const f of this.g)f.dispose()}}e.$nj=a;class n extends j.$Rc{constructor(f,p,I){if(super(),this.h=f,this.j=p,this.b=new O.$zc,this.c=this.B(new A.$Rd),this.onDidChangeLoggers=this.c.event,this.f=this.B(new A.$Rd),this.onDidChangeLogLevel=this.f.event,this.g=this.B(new A.$Rd),this.onDidChangeVisibility=this.g.event,I)for(const T of I)this.b.set(T.resource,{logger:void 0,info:T})}m(f){return(0,d.$Cf)(f)?[...this.b.values()].find(p=>p.info.id===f):this.b.get(f)}getLogger(f){return this.m(f)?.logger}createLogger(f,p){const I=this.n(f),T=(0,d.$Cf)(f)?f:p?.id??(0,L.$Ji)(I.toString()).toString(16);let M=this.b.get(I)?.logger;const z=p?.logLevel==="always"?y.Trace:p?.logLevel;M||(M=this.s(I,z??this.getLogLevel(I)??this.h,{...p,id:T}));const q={logger:M,info:{resource:I,id:T,logLevel:z,name:p?.name,hidden:p?.hidden,extensionId:p?.extensionId,when:p?.when}};return this.registerLogger(q.info),this.b.set(I,q),M}n(f){return(0,d.$Cf)(f)?(0,S.$zg)(this.j,`${f}.log`):f}setLogLevel(f,p){if(R.URI.isUri(f)){const I=f,T=p,M=this.b.get(I);M&&T!==M.info.logLevel&&(M.info.logLevel=T===this.h?void 0:T,M.logger?.setLevel(T),this.b.set(M.info.resource,M),this.f.fire([I,T]))}else{this.h=f;for(const[I,T]of this.b.entries())this.b.get(I)?.info.logLevel===void 0&&T.logger?.setLevel(this.h);this.f.fire(this.h)}}setVisibility(f,p){const I=this.m(f);I&&p!==!I.info.hidden&&(I.info.hidden=!p,this.b.set(I.info.resource,I),this.g.fire([I.info.resource,p]))}getLogLevel(f){let p;return f&&(p=this.b.get(f)?.info.logLevel),p??this.h}registerLogger(f){const p=this.b.get(f.resource);p?p.info.hidden!==f.hidden&&this.setVisibility(f.resource,!f.hidden):(this.b.set(f.resource,{info:f,logger:void 0}),this.c.fire({added:[f],removed:[]}))}deregisterLogger(f){const p=this.b.get(f);p&&(p.logger&&p.logger.dispose(),this.b.delete(f),this.c.fire({added:[],removed:[p.info]}))}*getRegisteredLoggers(){for(const f of this.b.values())yield f.info}getRegisteredLogger(f){return this.b.get(f)?.info}dispose(){this.b.forEach(f=>f.logger?.dispose()),this.b.clear(),super.dispose()}}e.$oj=n;class i{constructor(){this.onDidChangeLogLevel=new A.$Rd().event}setLevel(f){}getLevel(){return y.Info}trace(f,...p){}debug(f,...p){}info(f,...p){}warn(f,...p){}error(f,...p){}critical(f,...p){}dispose(){}flush(){}}e.$pj=i;class t extends i{}e.$qj=t;function r($){if($.verbose)return y.Trace;if(typeof $.logLevel=="string"){const f=v($.logLevel.toLowerCase());if(f!==void 0)return f}return e.$gj}e.$rj=r;function o($){switch($){case y.Trace:return"trace";case y.Debug:return"debug";case y.Info:return"info";case y.Warning:return"warn";case y.Error:return"error";case y.Off:return"off"}}e.$sj=o;function v($){switch($){case"trace":return y.Trace;case"debug":return y.Debug;case"info":return y.Info;case"warn":return y.Warning;case"error":return y.Error;case"critical":return y.Error;case"off":return y.Off}}e.$tj=v,e.$uj=new E.$aj("logLevel",o(y.Info))}),define(ae[196],ce([0,1,6,7,2,23,16,19,31,14,8]),function(ie,e,D,A,L,j,O,C,S,d,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$h0b=void 0;let E=class extends L.$Rc{constructor(l,g){super(),this.a=l,this.b=g,this.B(new D.$0g(()=>{this.c()},10*1e3)).schedule()}async c(){this.b.trace("[logs cleanup]: Starting to clean up old logs.");try{const l=(0,C.$wg)(this.a.logsHome),g=(0,C.$yg)(this.a.logsHome.with({scheme:j.Schemas.file})).fsPath,c=(await S.Promises.readdir(g)).filter(h=>/^\d{8}T\d{6}$/.test(h)).sort().filter(h=>h!==l),u=c.slice(0,Math.max(0,c.length-9));u.length>0&&(this.b.trace(`[logs cleanup]: Removing log folders '${u.join(", ")}'`),await Promise.all(u.map(h=>S.Promises.rm((0,O.$ic)(g,h)))))}catch(l){(0,A.$Z)(l)}}};e.$h0b=E,e.$h0b=E=pe([X(0,d.$3h),X(1,R.$dj)],E)}),define(ae[197],ce([0,1,18,6,7,3,2,16,49,8]),function(ie,e,D,A,L,j,O,C,S,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3p=void 0;class R extends O.$Rc{constructor(b,l){super(),this.a=b,this.b=l,this.c=this.B(new j.$Rd),this.onDidChangeFile=this.c.event,this.g=this.B(new j.$Rd),this.onDidWatchError=this.g.event,this.j=[],this.m=this.B(new A.$Vg(0)),this.w=[],this.y=this.B(new A.$Vg(0))}watch(b,l){return l.recursive||this.b?.watcher?.forceUniversal?this.n(b,l):this.z(b,l)}n(b,l){const g={path:this.H(b),excludes:l.excludes,includes:l.includes,recursive:l.recursive,correlationId:l.correlationId},y=(0,D.$Tb)(this.j,g);return this.r(),(0,O.$Pc)(()=>{y(),this.r()})}r(){this.m.trigger(()=>this.s()).catch(b=>(0,L.$Z)(b))}s(){this.h||(this.h=this.B(this.t(l=>this.c.fire((0,S.$Yp)(l)),l=>this.G(l),this.a.getLevel()===d.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.h?.setVerboseLogging(this.a.getLevel()===d.LogLevel.Trace)})));const b=this.b?.watcher?.recursive?.usePolling;if(b===!0)for(const l of this.j)(0,S.$Up)(l)&&(l.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);else if(Array.isArray(b))for(const l of this.j)(0,S.$Up)(l)&&b.includes(l.path)&&(l.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);return this.h.watch(this.j)}z(b,l){const g={path:this.H(b),excludes:l.excludes,includes:l.includes,recursive:!1,correlationId:l.correlationId},y=(0,D.$Tb)(this.w,g);return this.C(),(0,O.$Pc)(()=>{y(),this.C()})}C(){this.y.trigger(()=>this.D()).catch(b=>(0,L.$Z)(b))}D(){return this.u||(this.u=this.B(this.F(b=>this.c.fire((0,S.$Yp)(b)),b=>this.G(b),this.a.getLevel()===d.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.u?.setVerboseLogging(this.a.getLevel()===d.LogLevel.Trace)}))),this.u.watch(this.w)}G(b){b.type==="error"&&this.g.fire(b.message),this.a[b.type](b.message)}H(b){return(0,C.$gc)(b.fsPath)}}e.$3p=R}),define(ae[198],ce([0,1,18,6,15,26,3,52,60,2,47,23,100,19,46,158,11,99,8,7]),function(ie,e,D,A,L,j,O,C,S,d,R,E,b,l,g,y,w,c,u,h){"use strict";var m;Object.defineProperty(e,"__esModule",{value:!0}),e.$Tp=void 0;let k=class extends d.$Rc{static{m=this}constructor(a){super(),this.b=a,this.a=256*1024,this.c=this.B(new O.$Rd),this.onDidChangeFileSystemProviderRegistrations=this.c.event,this.f=this.B(new O.$Rd),this.onWillActivateFileSystemProvider=this.f.event,this.g=this.B(new O.$Rd),this.onDidChangeFileSystemProviderCapabilities=this.g.event,this.h=new Map,this.r=this.B(new O.$Rd),this.onDidRunOperation=this.r.event,this.X=this.B(new O.$Rd),this.Y=this.B(new O.$Rd),this.onDidFilesChange=this.Y.event,this.Z=this.B(new O.$Rd),this.onDidWatchError=this.Z.event,this.$=new Map,this.cb=this.B(new A.$7g)}registerProvider(a,n){if(this.h.has(a))throw new Error(`A filesystem provider for the scheme '${a}' is already registered.`);(0,b.mark)(`code/registerFilesystem/${a}`);const i=new d.$Qc;return this.h.set(a,n),this.c.fire({added:!0,scheme:a,provider:n}),i.add(n.onDidChangeFile(t=>{const r=new w.$xk(t,!this.S(n));this.X.fire(r),r.hasCorrelation()||this.Y.fire(r)})),typeof n.onDidWatchError=="function"&&i.add(n.onDidWatchError(t=>this.Z.fire(new Error(t)))),i.add(n.onDidChangeCapabilities(()=>this.g.fire({provider:n,scheme:a}))),(0,d.$Pc)(()=>{this.c.fire({added:!1,scheme:a,provider:n}),this.h.delete(a),(0,d.$Mc)(i)})}getProvider(a){return this.h.get(a)}async activateProvider(a){const n=[];this.f.fire({scheme:a,join(i){n.push(i)}}),!this.h.has(a)&&await A.Promises.settled(n)}async canHandleResource(a){return await this.activateProvider(a.scheme),this.hasProvider(a)}hasProvider(a){return this.h.has(a.scheme)}hasCapability(a,n){const i=this.h.get(a.scheme);return!!(i&&i.capabilities&n)}listCapabilities(){return S.Iterable.map(this.h,([a,n])=>({scheme:a,capabilities:n.capabilities}))}async j(a){if(!(0,l.$Dg)(a))throw new w.$zk((0,y.localize)(0,null,this.sb(a)),8);await this.activateProvider(a.scheme);const n=this.h.get(a.scheme);if(!n){const i=new h.$ab;throw i.message=(0,y.localize)(1,null,a.toString()),i}return n}async m(a){const n=await this.j(a);if((0,w.$kk)(n)||(0,w.$hk)(n)||(0,w.$lk)(n))return n;throw new Error(`Filesystem provider for scheme '${a.scheme}' neither has FileReadWrite, FileReadStream nor FileOpenReadWriteClose capability which is needed for the read operation.`)}async n(a){const n=await this.j(a);if((0,w.$kk)(n)||(0,w.$hk)(n))return n;throw new Error(`Filesystem provider for scheme '${a.scheme}' neither has FileReadWrite nor FileOpenReadWriteClose capability which is needed for the write operation.`)}async resolve(a,n){try{return await this.s(a,n)}catch(i){throw(0,w.$uk)(i)===w.FileSystemProviderErrorCode.FileNotFound?new w.$zk((0,y.localize)(2,null,this.sb(a)),1):(0,w.$sk)(i)}}async s(a,n){const i=await this.j(a),t=this.S(i),r=n?.resolveTo,o=n?.resolveSingleChildDescendants,v=n?.resolveMetadata,$=await i.stat(a);let f;return this.t(i,a,$,void 0,!!v,(p,I)=>(f||(f=R.$2h.forUris(()=>!t),f.set(a,!0),r&&f.fill(!0,r)),f.get(p.resource)||f.findSuperstr(p.resource.with({query:null,fragment:null}))?!0:p.isDirectory&&o?I===1:!1))}async t(a,n,i,t,r,o){const{providerExtUri:v}=this.R(a),$={resource:n,name:v.basename(n),isFile:(i.type&w.FileType.File)!==0,isDirectory:(i.type&w.FileType.Directory)!==0,isSymbolicLink:(i.type&w.FileType.SymbolicLink)!==0,mtime:i.mtime,ctime:i.ctime,size:i.size,readonly:!!((i.permissions??0)&w.FilePermission.Readonly)||!!(a.capabilities&2048),locked:!!((i.permissions??0)&w.FilePermission.Locked),etag:(0,w.$Kk)({mtime:i.mtime,size:i.size}),children:void 0};if($.isDirectory&&o($,t)){try{const f=await a.readdir(n),p=await A.Promises.settled(f.map(async([I,T])=>{try{const M=v.joinPath(n,I),z=r?await a.stat(M):{type:T};return await this.t(a,M,z,f.length,r,o)}catch(M){return this.b.trace(M),null}}));$.children=(0,D.$Gb)(p)}catch(f){this.b.trace(f),$.children=[]}return $}return $}async resolveAll(a){return A.Promises.settled(a.map(async n=>{try{return{stat:await this.s(n.resource,n.options),success:!0}}catch(i){return this.b.trace(i),{stat:void 0,success:!1}}}))}async stat(a){const n=await this.j(a),i=await n.stat(a);return this.t(n,a,i,void 0,!0,()=>!1)}async exists(a){const n=await this.j(a);try{return!!await n.stat(a)}catch{return!1}}async canCreateFile(a,n){try{await this.u(a,n)}catch(i){return i}return!0}async u(a,n){if(!n?.overwrite&&await this.exists(a))throw new w.$zk((0,y.localize)(3,null,this.sb(a)),3,n)}async createFile(a,n=L.$fe.fromString(""),i){await this.u(a,i);const t=await this.writeFile(a,n);return this.r.fire(new w.$wk(a,0,t)),t}async writeFile(a,n,i){const t=this.qb(await this.n(a),a),{providerExtUri:r}=this.R(t);let o=i;if((0,w.$nk)(t)&&!o?.atomic){const v=t.enforceAtomicWriteFile?.(a);v&&(o={...i,atomic:v})}try{await this.w(t,a,o)||await this.U(t,r.dirname(a));let $;if((0,w.$hk)(t)&&!(n instanceof L.$fe))if((0,g.$4d)(n)){const f=await(0,g.$$d)(n,3);f.ended?$=L.$fe.concat(f.buffer):$=f}else $=(0,g.$8d)(n,f=>L.$fe.concat(f),3);else $=n;!(0,w.$kk)(t)||(0,w.$hk)(t)&&$ instanceof L.$fe||(0,w.$hk)(t)&&(0,w.$nk)(t)&&o?.atomic?await this.hb(t,a,o,$):await this.db(t,a,o,$ instanceof L.$fe?(0,L.$qe)($):$),this.r.fire(new w.$wk(a,4))}catch(v){throw new w.$zk((0,y.localize)(4,null,this.sb(a),(0,w.$sk)(v).toString()),(0,w.$vk)(v),o)}return this.resolve(a,{resolveMetadata:!0})}async w(a,n,i){const t=!!i?.unlock;if(t&&!(a.capabilities&8192))throw new Error((0,y.localize)(5,null,this.sb(n)));if(!!i?.atomic){if(!(a.capabilities&32768))throw new Error((0,y.localize)(6,null,this.sb(n)));if(!(a.capabilities&2))throw new Error((0,y.localize)(7,null,this.sb(n)));if(t)throw new Error((0,y.localize)(8,null,this.sb(n)))}let o;try{o=await a.stat(n)}catch{return}if(o.type&w.FileType.Directory)throw new w.$zk((0,y.localize)(9,null,this.sb(n)),0,i);if(this.rb(n,o),typeof i?.mtime=="number"&&typeof i.etag=="string"&&i.etag!==w.$Jk&&typeof o.mtime=="number"&&typeof o.size=="number"&&i.mtime<o.mtime&&i.etag!==(0,w.$Kk)({mtime:i.mtime,size:o.size}))throw new w.$zk((0,y.localize)(10,null),3,i);return o}async readFile(a,n,i){const t=await this.m(a);return n?.atomic?this.z(t,a,n,i):this.C(t,a,n,i)}async z(a,n,i,t){return new Promise((r,o)=>{this.cb.queueFor(n,this.R(a).providerExtUri).queue(async()=>{try{const v=await this.C(a,n,i,t);r(v)}catch(v){o(v)}})})}async C(a,n,i,t){const r=await this.D(a,n,{...i,preferUnbuffered:!0},t);return{...r,value:await(0,L.$re)(r.value)}}async readFileStream(a,n,i){const t=await this.m(a);return this.D(t,a,n,i)}async D(a,n,i,t){const r=new j.$2d(t);let o=i;(0,w.$mk)(a)&&a.enforceAtomicReadFile?.(n)&&(o={...i,atomic:!0});const v=this.J(n,o).then(f=>f,f=>{throw r.dispose(!0),f});let $;try{return typeof o?.etag=="string"&&o.etag!==w.$Jk&&await v,o?.atomic&&(0,w.$mk)(a)||!((0,w.$kk)(a)||(0,w.$lk)(a))||(0,w.$hk)(a)&&o?.preferUnbuffered?$=this.I(a,n,o):(0,w.$lk)(a)?$=this.G(a,n,r.token,o):$=this.H(a,n,r.token,o),$.on("end",()=>r.dispose()),$.on("error",()=>r.dispose()),{...await v,value:$}}catch(f){throw $&&await(0,g.$9d)($),this.F(f,n,o)}}F(a,n,i){const t=(0,y.localize)(11,null,this.sb(n),(0,w.$sk)(a).toString());return a instanceof w.$Bk?new w.$Bk(t,a.stat,i):a instanceof w.$Ak?new w.$Ak(t,a.fileOperationResult,a.size,a.options):new w.$zk(t,(0,w.$vk)(a),i)}G(a,n,i,t=Object.create(null)){const r=a.readFileStream(n,t,i);return(0,g.$ce)(r,{data:o=>o instanceof L.$fe?o:L.$fe.wrap(o),error:o=>this.F(o,n,t)},o=>L.$fe.concat(o))}H(a,n,i,t=Object.create(null)){const r=(0,L.$ve)();return(0,c.$Sp)(a,n,r,o=>o,{...t,bufferSize:this.a,errorTransformer:o=>this.F(o,n,t)},i),r}I(a,n,i){const t=(0,g.$6d)(r=>L.$fe.concat(r));return(async()=>{try{let r;i?.atomic&&(0,w.$mk)(a)?r=await a.readFile(n,{atomic:!0}):r=await a.readFile(n),typeof i?.position=="number"&&(r=r.slice(i.position)),typeof i?.length=="number"&&(r=r.slice(0,i.length)),this.L(n,r.byteLength,i),t.end(L.$fe.wrap(r))}catch(r){t.error(r),t.end()}})(),t}async J(a,n){const i=await this.resolve(a,{resolveMetadata:!0});if(i.isDirectory)throw new w.$zk((0,y.localize)(12,null,this.sb(a)),0,n);if(typeof n?.etag=="string"&&n.etag!==w.$Jk&&n.etag===i.etag)throw new w.$Bk((0,y.localize)(13,null),i,n);return this.L(a,i.size,n),i}L(a,n,i){if(typeof i?.limits?.size=="number"&&n>i.limits.size)throw new w.$Ak((0,y.localize)(14,null,this.sb(a)),7,n,i)}async canMove(a,n,i){return this.M(a,n,"move",i)}async canCopy(a,n,i){return this.M(a,n,"copy",i)}async M(a,n,i,t){if(a.toString()!==n.toString())try{const r=i==="move"?this.qb(await this.n(a),a):await this.m(a),o=this.qb(await this.n(n),n);await this.Q(r,a,o,n,i,t)}catch(r){return r}return!0}async move(a,n,i){const t=this.qb(await this.n(a),a),r=this.qb(await this.n(n),n),o=await this.N(t,a,r,n,"move",!!i),v=await this.resolve(n,{resolveMetadata:!0});return this.r.fire(new w.$wk(a,o==="move"?2:3,v)),v}async copy(a,n,i){const t=await this.m(a),r=this.qb(await this.n(n),n),o=await this.N(t,a,r,n,"copy",!!i),v=await this.resolve(n,{resolveMetadata:!0});return this.r.fire(new w.$wk(a,o==="copy"?3:2,v)),v}async N(a,n,i,t,r,o){if(n.toString()===t.toString())return r;const{exists:v,isSameResourceWithDifferentPathCase:$}=await this.Q(a,n,i,t,r,o);if(v&&!$&&o&&await this.del(t,{recursive:!0}),await this.U(i,this.R(i).providerExtUri.dirname(t)),r==="copy"){if(a===i&&(0,w.$ik)(a))await a.copy(n,t,{overwrite:o});else{const f=await this.resolve(n);f.isDirectory?await this.P(a,f,i,t):await this.O(a,n,i,t)}return r}else return a===i?(await a.rename(n,t,{overwrite:o}),r):(await this.N(a,n,i,t,"copy",o),await this.del(n,{recursive:!0}),"copy")}async O(a,n,i,t){if((0,w.$kk)(a)&&(0,w.$kk)(i))return this.jb(a,n,i,t);if((0,w.$kk)(a)&&(0,w.$hk)(i))return this.pb(a,n,i,t);if((0,w.$hk)(a)&&(0,w.$kk)(i))return this.nb(a,n,i,t);if((0,w.$hk)(a)&&(0,w.$hk)(i))return this.lb(a,n,i,t)}async P(a,n,i,t){await i.mkdir(t),Array.isArray(n.children)&&await A.Promises.settled(n.children.map(async r=>{const o=this.R(i).providerExtUri.joinPath(t,r.name);return r.isDirectory?this.P(a,await this.resolve(r.resource),i,o):this.O(a,r.resource,i,o)}))}async Q(a,n,i,t,r,o){let v=!1;if(a===i){const{providerExtUri:f,isPathCaseSensitive:p}=this.R(a);if(p||(v=f.isEqual(n,t)),v&&r==="copy")throw new Error((0,y.localize)(15,null,this.sb(n),this.sb(t)));if(!v&&f.isEqualOrParent(t,n))throw new Error((0,y.localize)(16,null,this.sb(n),this.sb(t)))}const $=await this.exists(t);if($&&!v){if(!o)throw new w.$zk((0,y.localize)(17,null,this.sb(n),this.sb(t)),4);if(a===i){const{providerExtUri:f}=this.R(a);if(f.isEqualOrParent(n,t))throw new Error((0,y.localize)(18,null,this.sb(n),this.sb(t)))}}return{exists:$,isSameResourceWithDifferentPathCase:v}}R(a){const n=this.S(a);return{providerExtUri:n?l.$pg:l.$rg,isPathCaseSensitive:n}}S(a){return!!(a.capabilities&1024)}async createFolder(a){const n=this.qb(await this.j(a),a);await this.U(n,a);const i=await this.resolve(a,{resolveMetadata:!0});return this.r.fire(new w.$wk(a,0,i)),i}async U(a,n){const i=[],{providerExtUri:t}=this.R(a);for(;!t.isEqual(n,t.dirname(n));)try{if(!((await a.stat(n)).type&w.FileType.Directory))throw new Error((0,y.localize)(19,null,this.sb(n)));break}catch(r){if((0,w.$uk)(r)!==w.FileSystemProviderErrorCode.FileNotFound)throw r;i.push(t.basename(n)),n=t.dirname(n)}for(let r=i.length-1;r>=0;r--){n=t.joinPath(n,i[r]);try{await a.mkdir(n)}catch(o){if((0,w.$uk)(o)!==w.FileSystemProviderErrorCode.FileExists)throw o}}}async canDelete(a,n){try{await this.W(a,n)}catch(i){return i}return!0}async W(a,n){const i=this.qb(await this.j(a),a),t=!!n?.useTrash;if(t&&!(i.capabilities&4096))throw new Error((0,y.localize)(20,null,this.sb(a)));const r=n?.atomic;if(r&&!(i.capabilities&65536))throw new Error((0,y.localize)(21,null,this.sb(a)));if(t&&r)throw new Error((0,y.localize)(22,null,this.sb(a)));let o;try{o=await i.stat(a)}catch{}if(o)this.rb(a,o);else throw new w.$zk((0,y.localize)(23,null,this.sb(a)),1);if(!!!n?.recursive){const $=await this.resolve(a);if($.isDirectory&&Array.isArray($.children)&&$.children.length>0)throw new Error((0,y.localize)(24,null,this.sb(a)))}return i}async del(a,n){const i=await this.W(a,n);let t=n;if((0,w.$ok)(i)&&!t?.atomic){const $=i.enforceAtomicDelete?.(a);$&&(t={...n,atomic:$})}const r=!!t?.useTrash,o=!!t?.recursive,v=t?.atomic??!1;await i.delete(a,{recursive:o,useTrash:r,atomic:v}),this.r.fire(new w.$wk(a,1))}async cloneFile(a,n){const i=await this.j(a),t=this.qb(await this.n(n),n);if(i===t&&this.R(i).providerExtUri.isEqual(a,n))return;if(i===t&&(0,w.$jk)(i))return i.cloneFile(a,n);await this.U(t,this.R(t).providerExtUri.dirname(n));const r=this.cb.queueFor(a,this.R(i).providerExtUri);return i===t&&(0,w.$ik)(i)?r.queue(()=>i.copy(a,n,{overwrite:!0})):r.queue(()=>this.O(i,a,t,n))}static{this.ab=0}createWatcher(a,n){return this.watch(a,{...n,correlationId:m.ab++})}watch(a,n={recursive:!1,excludes:[]}){const i=new d.$Qc;let t=!1,r=()=>{t=!0};i.add((0,d.$Pc)(()=>r())),(async()=>{try{const v=await this.bb(a,n);t?(0,d.$Mc)(v):r=()=>(0,d.$Mc)(v)}catch(v){this.b.error(v)}})();const o=n.correlationId;if(typeof o=="number"){const v=i.add(new O.$Rd);return i.add(this.X.event(f=>{f.correlates(o)&&v.fire(f)})),{onDidChange:v.event,dispose:()=>i.dispose()}}return i}async bb(a,n){const i=await this.j(a),t=(0,C.$Ji)([this.R(i).providerExtUri.getComparisonKey(a),n]);let r=this.$.get(t);return r||(r={count:0,disposable:i.watch(a,n)},this.$.set(t,r)),r.count+=1,(0,d.$Pc)(()=>{r&&(r.count--,r.count===0&&((0,d.$Mc)(r.disposable),this.$.delete(t)))})}dispose(){super.dispose();for(const[,a]of this.$)(0,d.$Mc)(a.disposable);this.$.clear()}async db(a,n,i,t){return this.cb.queueFor(n,this.R(a).providerExtUri).queue(async()=>{const r=await a.open(n,{create:!0,unlock:i?.unlock??!1});try{(0,g.$4d)(t)||(0,g.$5d)(t)?await this.eb(a,r,t):await this.fb(a,r,t)}catch(o){throw(0,w.$sk)(o)}finally{await a.close(r)}})}async eb(a,n,i){let t=0,r;if((0,g.$5d)(i)){if(i.buffer.length>0){const o=L.$fe.concat(i.buffer);await this.gb(a,n,o,o.byteLength,t,0),t+=o.byteLength}if(i.ended)return;r=i.stream}else r=i;return new Promise((o,v)=>{(0,g.$0d)(r,{onData:async $=>{r.pause();try{await this.gb(a,n,$,$.byteLength,t,0)}catch(f){return v(f)}t+=$.byteLength,setTimeout(()=>r.resume())},onError:$=>v($),onEnd:()=>o()})})}async fb(a,n,i){let t=0,r;for(;(r=i.read())!==null;)await this.gb(a,n,r,r.byteLength,t,0),t+=r.byteLength}async gb(a,n,i,t,r,o){let v=0;for(;v<t;){const $=await a.write(n,r+v,i.buffer,o+v,t-v);v+=$}}async hb(a,n,i,t){return this.cb.queueFor(n,this.R(a).providerExtUri).queue(()=>this.ib(a,n,i,t))}async ib(a,n,i,t){let r;t instanceof L.$fe?r=t:(0,g.$4d)(t)?r=await(0,L.$re)(t):(0,g.$5d)(t)?r=await(0,L.$se)(t):r=(0,L.$pe)(t),await a.writeFile(n,r.buffer,{create:!0,overwrite:!0,unlock:i?.unlock??!1,atomic:i?.atomic??!1})}async jb(a,n,i,t){return this.cb.queueFor(t,this.R(i).providerExtUri).queue(()=>this.kb(a,n,i,t))}async kb(a,n,i,t){let r,o;try{r=await a.open(n,{create:!1}),o=await i.open(t,{create:!0,unlock:!1});const v=L.$fe.alloc(this.a);let $=0,f=0,p=0;do p=await a.read(r,$,v.buffer,f,v.byteLength-f),await this.gb(i,o,v,p,$,f),$+=p,f+=p,f===v.byteLength&&(f=0);while(p>0)}catch(v){throw(0,w.$sk)(v)}finally{await A.Promises.settled([typeof r=="number"?a.close(r):Promise.resolve(),typeof o=="number"?i.close(o):Promise.resolve()])}}async lb(a,n,i,t){return this.cb.queueFor(t,this.R(i).providerExtUri).queue(()=>this.mb(a,n,i,t))}async mb(a,n,i,t){return i.writeFile(t,await a.readFile(n),{create:!0,overwrite:!0,unlock:!1,atomic:!1})}async nb(a,n,i,t){return this.cb.queueFor(t,this.R(i).providerExtUri).queue(()=>this.ob(a,n,i,t))}async ob(a,n,i,t){const r=await i.open(t,{create:!0,unlock:!1});try{const o=await a.readFile(n);await this.gb(i,r,L.$fe.wrap(o),o.byteLength,0,0)}catch(o){throw(0,w.$sk)(o)}finally{await i.close(r)}}async pb(a,n,i,t){const r=await(0,L.$re)(this.H(a,n,j.CancellationToken.None));await this.hb(i,t,void 0,r)}qb(a,n){if(a.capabilities&2048)throw new w.$zk((0,y.localize)(25,null,this.sb(n)),6);return a}rb(a,n){if((n.permissions??0)&w.FilePermission.Readonly)throw new w.$zk((0,y.localize)(26,null,this.sb(a)),6)}sb(a){return a.scheme===E.Schemas.file?a.fsPath:a.toString(!0)}};e.$Tp=k,e.$Tp=k=m=pe([X(0,u.$dj)],k)}),define(ae[199],ce([0,1,53,270,6,34,15,3,48,2,16,5,19,46,31,161,11,99,197,38,193,192]),function(ie,e,D,A,L,j,O,C,S,d,R,E,b,l,g,y,w,c,u,h,m,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gq=void 0,(()=>{try{(0,A.gracefulify)(D)}catch(a){console.error(`Error enabling graceful-fs: ${(0,h.$Gi)(a)}`)}})();class s extends u.$3p{static{this.I=!1}constructor(n,i){super(n,i),this.onDidChangeCapabilities=C.Event.None,this.N=new j.$zc(t=>b.$qg.getComparisonKey(t)),this.U=new Map,this.W=new Map,this.X=new Map}get capabilities(){return this.J||(this.J=253982,E.$k&&(this.J|=1024)),this.J}async stat(n){try{const{stat:i,symbolicLink:t}=await g.SymlinkSupport.stat(this.H(n));return{type:this.M(i,t),ctime:i.birthtime.getTime(),mtime:i.mtime.getTime(),size:i.size,permissions:i.mode&128?void 0:w.FilePermission.Locked}}catch(i){throw this.fb(i)}}async L(n){try{return await this.stat(n)}catch{return}}async readdir(n){try{const i=await g.Promises.readdir(this.H(n),{withFileTypes:!0}),t=[];return await Promise.all(i.map(async r=>{try{let o;r.isSymbolicLink()?o=(await this.stat((0,b.$zg)(n,r.name))).type:o=this.M(r),t.push([r.name,o])}catch(o){this.a.trace(o)}})),t}catch(i){throw this.fb(i)}}M(n,i){let t;return i?.dangling?t=w.FileType.Unknown:n.isFile()?t=w.FileType.File:n.isDirectory()?t=w.FileType.Directory:t=w.FileType.Unknown,i&&(t|=w.FileType.SymbolicLink),t}async O(n){const i=this.H(n);this.P(`[Disk FileSystemProvider]: createResourceLock() - request to acquire resource lock (${i})`);let t;for(;t=this.N.get(n);)this.P(`[Disk FileSystemProvider]: createResourceLock() - waiting for resource lock to be released (${i})`),await t.wait();const r=new L.$Wg;return this.N.set(n,r),this.P(`[Disk FileSystemProvider]: createResourceLock() - new resource lock created (${i})`),(0,d.$Pc)(()=>{this.P(`[Disk FileSystemProvider]: createResourceLock() - resource lock dispose() (${i})`),this.N.get(n)===r&&(this.P(`[Disk FileSystemProvider]: createResourceLock() - resource lock removed from resource-lock map (${i})`),this.N.delete(n)),this.P(`[Disk FileSystemProvider]: createResourceLock() - resource lock barrier open() (${i})`),r.open()})}async readFile(n,i){let t;try{i?.atomic&&(this.P(`[Disk FileSystemProvider]: atomic read operation started (${this.H(n)})`),t=await this.O(n));const r=this.H(n);return await g.Promises.readFile(r)}catch(r){throw this.fb(r)}finally{t?.dispose()}}P(n){s.I&&this.a.trace(n)}readFileStream(n,i,t){const r=(0,l.$6d)(o=>O.$fe.concat(o.map(v=>O.$fe.wrap(v))).buffer);return(0,c.$Sp)(this,n,r,o=>o.buffer,{...i,bufferSize:256*1024},t),r}async writeFile(n,i,t){return t?.atomic!==!1&&t?.atomic?.postfix&&await this.Q(n)?this.R(n,(0,b.$zg)((0,b.$yg)(n),`${(0,b.$wg)(n)}${t.atomic.postfix}`),i,t):this.S(n,i,t)}async Q(n){try{const i=this.H(n),{symbolicLink:t}=await g.SymlinkSupport.stat(i);if(t)return!1}catch{}return!0}async R(n,i,t,r){const o=new d.$Qc;try{o.add(await this.O(n)),o.add(await this.O(i)),await this.S(i,t,r,!0);try{await this.rename(i,n,{overwrite:!0})}catch(v){try{await this.delete(i,{recursive:!1,useTrash:!1,atomic:!1})}catch{}throw v}}finally{o.dispose()}}async S(n,i,t,r){let o;try{const v=this.H(n);if(!t.create||!t.overwrite){if(await g.Promises.exists(v)){if(!t.overwrite)throw(0,w.$rk)((0,y.localize)(0,null),w.FileSystemProviderErrorCode.FileExists)}else if(!t.create)throw(0,w.$rk)((0,y.localize)(1,null),w.FileSystemProviderErrorCode.FileNotFound)}o=await this.open(n,{create:!0,unlock:t.unlock},r),await this.write(o,0,i,0,i.byteLength)}catch(v){throw await this.gb(n,v)}finally{typeof o=="number"&&await this.close(o)}}static{this.Y=!0}static configureFlushOnWrite(n){s.Y=n}async open(n,i,t){const r=this.H(n);let o;(0,w.$fk)(i)&&!t&&(o=await this.O(n));let v;try{if((0,w.$fk)(i)&&i.unlock)try{const{stat:f}=await g.SymlinkSupport.stat(r);f.mode&128||await g.Promises.chmod(r,f.mode|128)}catch(f){f.code!=="ENOENT"&&this.a.trace(f)}let $;if((0,w.$fk)(i)){if(E.$i)try{await g.Promises.truncate(r,0),$="r+"}catch(f){f.code!=="ENOENT"&&this.a.trace(f)}$||($="w")}else $="r";v=await g.Promises.open(r,$)}catch($){throw o?.dispose(),(0,w.$fk)(i)?await this.gb(n,$):this.fb($)}if(this.U.set(v,0),(0,w.$fk)(i)&&this.X.set(v,n),o){const $=this.W.get(v);this.P(`[Disk FileSystemProvider]: open() - storing lock for handle ${v} (${r})`),this.W.set(v,o),$&&(this.P(`[Disk FileSystemProvider]: open() - disposing a previous lock that was still stored on same handle ${v} (${r})`),$.dispose())}return v}async close(n){const i=this.W.get(n);try{if(this.U.delete(n),this.X.delete(n)&&s.Y)try{await g.Promises.fdatasync(n)}catch(t){s.configureFlushOnWrite(!1),this.a.error(t)}return await g.Promises.close(n)}catch(t){throw this.fb(t)}finally{i&&(this.W.get(n)===i&&(this.P(`[Disk FileSystemProvider]: close() - resource lock removed from handle-lock map ${n}`),this.W.delete(n)),this.P(`[Disk FileSystemProvider]: close() - disposing lock for handle ${n}`),i.dispose())}}async read(n,i,t,r,o){const v=this.Z(n,i);let $=null;try{$=(await g.Promises.read(n,t,r,o,v)).bytesRead}catch(f){throw this.fb(f)}finally{this.$(n,v,$)}return $}Z(n,i){return i===this.U.get(n)?null:i}$(n,i,t){const r=this.U.get(n);typeof r=="number"&&(typeof i=="number"||(typeof t=="number"?this.U.set(n,r+t):this.U.delete(n)))}async write(n,i,t,r,o){return(0,L.$fh)(()=>this.ab(n,i,t,r,o),100,3)}async ab(n,i,t,r,o){const v=this.Z(n,i);let $=null;try{$=(await g.Promises.write(n,t,r,o,v)).bytesWritten}catch(f){throw await this.gb(this.X.get(n),f)}finally{this.$(n,v,$)}return $}async mkdir(n){try{await g.Promises.mkdir(this.H(n))}catch(i){throw this.fb(i)}}async delete(n,i){try{const t=this.H(n);if(i.recursive){let r;i?.atomic!==!1&&i.atomic.postfix&&(r=(0,R.$ic)((0,R.$lc)(t),`${(0,R.$mc)(t)}${i.atomic.postfix}`)),await g.Promises.rm(t,g.RimRafMode.MOVE,r)}else try{await g.Promises.unlink(t)}catch(r){if(r.code==="EPERM"||r.code==="EISDIR"){let o=!1;try{const{stat:v,symbolicLink:$}=await g.SymlinkSupport.stat(t);o=v.isDirectory()&&!$}catch{}if(o)await g.Promises.rmdir(t);else throw r}else throw r}}catch(t){throw this.fb(t)}}async rename(n,i,t){const r=this.H(n),o=this.H(i);if(r!==o)try{await this.bb(n,i,"move",t.overwrite),await g.Promises.rename(r,o)}catch(v){throw(v.code==="EINVAL"||v.code==="EBUSY"||v.code==="ENAMETOOLONG")&&(v=new Error((0,y.localize)(2,null,(0,R.$mc)(r),(0,R.$mc)((0,R.$lc)(o)),v.toString()))),this.fb(v)}}async copy(n,i,t){const r=this.H(n),o=this.H(i);if(r!==o)try{await this.bb(n,i,"copy",t.overwrite),await g.Promises.copy(r,o,{preserveSymlinks:!0})}catch(v){throw(v.code==="EINVAL"||v.code==="EBUSY"||v.code==="ENAMETOOLONG")&&(v=new Error((0,y.localize)(3,null,(0,R.$mc)(r),(0,R.$mc)((0,R.$lc)(o)),v.toString()))),this.fb(v)}}async bb(n,i,t,r){const o=this.H(n),v=this.H(i);let $=!1;if(!!(this.capabilities&1024)||($=(0,S.$1f)(o,v,!0)),$){if(t==="copy")throw(0,w.$rk)((0,y.localize)(4,null),w.FileSystemProviderErrorCode.FileExists);if(t==="move")return}const p=await this.L(n);if(!p)throw(0,w.$rk)((0,y.localize)(5,null),w.FileSystemProviderErrorCode.FileNotFound);const I=await this.L(i);if(I){if(!r)throw(0,w.$rk)((0,y.localize)(6,null),w.FileSystemProviderErrorCode.FileExists);p.type&w.FileType.File&&I.type&w.FileType.File||await this.delete(i,{recursive:!0,useTrash:!1,atomic:!1})}}async cloneFile(n,i){return this.cb(n,i,!1)}async cb(n,i,t){const r=this.H(n),o=this.H(i),v=!!(this.capabilities&1024);if((0,S.$1f)(r,o,!v))return;const $=new d.$Qc;try{$.add(await this.O(n)),$.add(await this.O(i)),t&&await g.Promises.mkdir((0,R.$lc)(o),{recursive:!0}),await g.Promises.copyFile(r,o)}catch(f){if(f.code==="ENOENT"&&!t)return this.cb(n,i,!0);throw this.fb(f)}finally{$.dispose()}}t(n,i,t){return new m.$0p(r=>n(r),r=>i(r),t)}F(n,i,t){return new k.$fq(r=>n(r),r=>i(r),t)}fb(n){if(n instanceof w.$qk)return n;let i=n,t;switch(n.code){case"ENOENT":t=w.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":t=w.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":t=w.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":t=w.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":t=w.FileSystemProviderErrorCode.NoPermissions;break;case"ERR_UNC_HOST_NOT_ALLOWED":i=`${n.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`,t=w.FileSystemProviderErrorCode.Unknown;break;default:t=w.FileSystemProviderErrorCode.Unknown}return(0,w.$rk)(i,t)}async gb(n,i){let t=this.fb(i);if(n&&t.code===w.FileSystemProviderErrorCode.NoPermissions)try{const{stat:r}=await g.SymlinkSupport.stat(this.H(n));r.mode&128||(t=(0,w.$rk)(i,w.FileSystemProviderErrorCode.FileWriteLocked))}catch(r){this.a.trace(r)}return t}}e.$gq=s}),define(ae[101],ce([0,1,3,2,4,8]),function(ie,e,D,A,L,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$K0b=e.$J0b=void 0,e.$J0b=(0,L.$Vh)("sharedProcessLifecycleService");let O=class extends A.$Rc{constructor(S){super(),this.b=S,this.a=this.B(new D.$Rd),this.onWillShutdown=this.a.event}fireOnWillShutdown(){this.b.trace("Lifecycle#onWillShutdown.fire()"),this.a.fire()}};e.$K0b=O,e.$K0b=O=pe([X(0,j.$dj)],O)}),define(ae[200],ce([0,1,10,3,8,2]),function(ie,e,D,A,L,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gr=e.$fr=e.$er=void 0;class O extends L.$oj{constructor(E,b,l,g,y){super(b,l,g),this.r=E,this.t=y,this.B(y.listen("onDidChangeLogLevel",E)(w=>{(0,L.$fj)(w)?super.setLogLevel(w):super.setLogLevel(D.URI.revive(w[0]),w[1])})),this.B(y.listen("onDidChangeVisibility",E)(([w,c])=>super.setVisibility(D.URI.revive(w),c))),this.B(y.listen("onDidChangeLoggers",E)(({added:w,removed:c})=>{for(const u of w)super.registerLogger({...u,resource:D.URI.revive(u.resource)});for(const u of c)super.deregisterLogger(u.resource)}))}createConsoleMainLogger(){return new L.$mj({log:(E,b)=>{this.t.call("consoleLog",[E,b])}})}registerLogger(E){super.registerLogger(E),this.t.call("registerLogger",[E,this.r])}deregisterLogger(E){super.deregisterLogger(E),this.t.call("deregisterLogger",[E,this.r])}setLogLevel(E,b){super.setLogLevel(E,b),this.t.call("setLogLevel",[E,b])}setVisibility(E,b){super.setVisibility(E,b),this.t.call("setVisibility",[this.n(E),b])}s(E,b,l){return new C(this.t,E,b,l,this.r)}static setLogLevel(E,b,l){return E.call("setLogLevel",[b,l])}}e.$er=O;class C extends L.$jj{constructor(E,b,l,g,y){super(g?.logLevel==="always"),this.r=E,this.s=b,this.m=!1,this.n=[],this.setLevel(l),this.r.call("createLogger",[b,g,y]).then(()=>{this.u(this.n),this.m=!0})}g(E,b){const l=[[E,b]];this.m?this.u(l):this.n.push(...l)}u(E){this.r.call("log",[this.s,E])}}class S{constructor(E,b){this.a=E,this.b=b}listen(E,b){const l=this.b(E);switch(b){case"onDidChangeLoggers":return A.Event.map(this.a.onDidChangeLoggers,g=>({added:[...g.added].map(y=>this.c(y,l)),removed:[...g.removed].map(y=>this.c(y,l))}));case"onDidChangeVisibility":return A.Event.map(this.a.onDidChangeVisibility,g=>[l.transformOutgoingURI(g[0]),g[1]]);case"onDidChangeLogLevel":return A.Event.map(this.a.onDidChangeLogLevel,g=>(0,L.$fj)(g)?g:[l.transformOutgoingURI(g[0]),g[1]])}throw new Error(`Event not found: ${b}`)}async call(E,b,l){const g=this.b(E);switch(b){case"setLogLevel":return(0,L.$fj)(l[0])?this.a.setLogLevel(l[0]):this.a.setLogLevel(D.URI.revive(g.transformIncoming(l[0][0])),l[0][1]);case"getRegisteredLoggers":return Promise.resolve([...this.a.getRegisteredLoggers()].map(y=>this.c(y,g)))}throw new Error(`Call not found: ${b}`)}c(E,b){return{...E,resource:b.transformOutgoingURI(E.resource)}}}e.$fr=S;class d extends j.$Rc{constructor(E,b){super(),b.call("setLogLevel",[E.getLogLevel()]),this.B(E.onDidChangeLogLevel(l=>b.call("setLogLevel",[l]))),b.call("getRegisteredLoggers").then(l=>{for(const g of l)E.registerLogger({...g,resource:D.URI.revive(g.resource)})}),this.B(b.listen("onDidChangeVisibility")(([l,g])=>E.setVisibility(D.URI.revive(l),g))),this.B(b.listen("onDidChangeLoggers")(({added:l,removed:g})=>{for(const y of l)E.registerLogger({...y,resource:D.URI.revive(y.resource)});for(const y of g)E.deregisterLogger(y.resource)}))}}e.$gr=d}),define(ae[201],ce([0,1,2,8]),function(ie,e,D,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$WN=void 0;class L extends D.$Rc{constructor(O,C=[]){super(),this.a=new A.$nj([O,...C]),this.B(O.onDidChangeLogLevel(S=>this.setLevel(S)))}get onDidChangeLogLevel(){return this.a.onDidChangeLogLevel}setLevel(O){this.a.setLevel(O)}getLevel(){return this.a.getLevel()}trace(O,...C){this.a.trace(O,...C)}debug(O,...C){this.a.debug(O,...C)}info(O,...C){this.a.info(O,...C)}warn(O,...C){this.a.warn(O,...C)}error(O,...C){this.a.error(O,...C)}flush(){this.a.flush()}}e.$WN=L}),define(ae[56],ce([0,1,4]),function(ie,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$F8b=void 0,e.$F8b=(0,D.$Vh)("nativeHostService")}),define(ae[202],ce([0,1,40,55]),function(ie,e,D,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Z9b=void 0;let L=class{constructor(O,C){return this.windowId=O,D.ProxyChannel.toService(C.getChannel("nativeHost"),{context:O,properties:(()=>{const S=new Map;return S.set("windowId",O),S})()})}};e.$Z9b=L,e.$Z9b=L=pe([X(1,A.$T9b)],L)}),define(ae[57],ce([0,1,3,60,2,4]),function(ie,e,D,A,L,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qn=e.$pn=e.$on=void 0,e.$on=(0,j.$Vh)("policy");class O extends L.$Rc{constructor(){super(...arguments),this.f={},this.g=new Map,this.h=this.B(new D.$Rd),this.onDidChange=this.h.event}async updatePolicyDefinitions(d){const R=Object.keys(this.f).length;return this.f={...d,...this.f},R!==Object.keys(this.f).length&&await this.j(d),A.Iterable.reduce(this.g.entries(),(E,[b,l])=>({...E,[b]:l}),{})}getPolicyValue(d){return this.g.get(d)}serialize(){return A.Iterable.reduce(Object.entries(this.f),(d,[R,E])=>({...d,[R]:{definition:E,value:this.g.get(R)}}),{})}}e.$pn=O;class C{constructor(){this.onDidChange=D.Event.None}async updatePolicyDefinitions(){return{}}getPolicyValue(){}serialize(){}}e.$qn=C}),define(ae[203],ce([0,1,3,2,57]),function(ie,e,D,A,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$q9b=e.$p9b=void 0;class j{constructor(S){this.b=S,this.a=new A.$Qc}listen(S,d){switch(d){case"onDidChange":return D.Event.map(this.b.onDidChange,R=>R.reduce((E,b)=>({...E,[b]:this.b.getPolicyValue(b)??null}),{}),this.a)}throw new Error(`Event not found: ${d}`)}call(S,d,R){switch(d){case"updatePolicyDefinitions":return this.b.updatePolicyDefinitions(R)}throw new Error(`Call not found: ${d}`)}dispose(){this.a.dispose()}}e.$p9b=j;class O extends L.$pn{constructor(S,d){super(),this.a=d;for(const R in S){const{definition:E,value:b}=S[R];this.f[R]=E,b!==void 0&&this.g.set(R,b)}this.a.listen("onDidChange")(R=>{for(const E in R){const b=R[E];b===null?this.g.delete(E):this.g.set(E,b)}this.h.fire(Object.keys(R))})}async j(S){const d=await this.a.call("updatePolicyDefinitions",S);for(const R in d)this.g.set(R,d[R])}}e.$q9b=O}),define(ae[102],ce([0,1,37]),function(ie,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let A;const L=globalThis.vscode;if(typeof L<"u"&&typeof L.context<"u"){const j=L.context.configuration();if(j)A=j.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(globalThis._VSCODE_PRODUCT_JSON&&globalThis._VSCODE_PACKAGE_JSON){if(A=globalThis._VSCODE_PRODUCT_JSON,D.env.VSCODE_DEV&&Object.assign(A,{nameShort:`${A.nameShort} Dev`,nameLong:`${A.nameLong} Dev`,dataFolderName:`${A.dataFolderName}-dev`,serverDataFolderName:A.serverDataFolderName?`${A.serverDataFolderName}-dev`:void 0}),!A.version){const j=globalThis._VSCODE_PACKAGE_JSON;Object.assign(A,{version:j.version})}}else A={},Object.keys(A).length===0&&Object.assign(A,{version:"1.82.0-dev",nameShort:"Code - OSS Dev",nameLong:"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt",serverLicenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt"});e.default=A}),define(ae[25],ce([0,1,4]),function(ie,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wj=e.$vj=void 0,e.$vj=(0,D.$Vh)("productService"),e.$wj="vscode://schemas/vscode-product"}),define(ae[204],ce([0,1,6,7,2,16,31,8,25]),function(ie,e,D,A,L,j,O,C,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$e0b=void 0;let d=class extends L.$Rc{constructor(E,b,l){super(),this.b=b,this.c=l,this.a=this.b.quality!=="stable"?1e3*60*60*24*7:1e3*60*60*24*30*3,E&&this.B(new D.$0g(()=>{this.f(E)},3e4)).schedule()}async f(E){this.c.trace("[code cache cleanup]: Starting to clean up old code cache folders.");try{const b=Date.now(),l=(0,j.$lc)(E),g=(0,j.$mc)(E),y=await O.Promises.readdir(l);await Promise.all(y.map(async w=>{if(w===g)return;const c=(0,j.$ic)(l,w),u=await O.Promises.stat(c);if(u.isDirectory()&&b-u.mtime.getTime()>this.a)return this.c.trace(`[code cache cleanup]: Removing code cache folder ${w}.`),O.Promises.rm(c)}))}catch(b){(0,A.$Z)(b)}}};e.$e0b=d,e.$e0b=d=pe([X(1,S.$vj),X(2,C.$dj)],d)}),define(ae[205],ce([0,1,6,7,2,16,31,14,8,25]),function(ie,e,D,A,L,j,O,C,S,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$f0b=void 0;let R=class extends L.$Rc{constructor(b,l,g){super(),this.b=b,this.c=l,this.f=g,this.a=this.f.quality!=="stable"?1e3*60*60*24*7:1e3*60*60*24*30*3,this.b.isBuilt&&this.B(new D.$0g(()=>{this.g()},4e4)).schedule()}async g(){this.c.trace("[language pack cache cleanup]: Starting to clean up unused language packs.");try{const b=Object.create(null),l=JSON.parse(await O.Promises.readFile((0,j.$ic)(this.b.userDataPath,"languagepacks.json"),"utf8"));for(const u of Object.keys(l)){const h=l[u];b[`${h.hash}.${u}`]=!0}const g=(0,j.$ic)(this.b.userDataPath,"clp");if(!await O.Promises.exists(g))return;const w=await O.Promises.readdir(g);for(const u of w){if(b[u]){this.c.trace(`[language pack cache cleanup]: Skipping folder ${u}. Language pack still in use.`);continue}this.c.trace(`[language pack cache cleanup]: Removing unused language pack: ${u}`),await O.Promises.rm((0,j.$ic)(g,u))}const c=Date.now();for(const u of Object.keys(b)){const h=(0,j.$ic)(g,u),m=await O.Promises.readdir(h);for(const k of m){if(k==="tcf.json")continue;const s=(0,j.$ic)(h,k),a=await O.Promises.stat(s);a.isDirectory()&&c-a.mtime.getTime()>this.a&&(this.c.trace(`[language pack cache cleanup]: Removing language pack cache folder: ${(0,j.$ic)(u,k)}`),await O.Promises.rm(s))}}}catch(b){(0,A.$Z)(b)}}};e.$f0b=R,e.$f0b=R=pe([X(0,C.$4h),X(1,S.$dj),X(2,d.$vj)],R)}),define(ae[206],ce([0,1,16,4]),function(ie,e,D,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Utils=e.$yF=void 0,e.$yF=(0,A.$Vh)("IV8InspectProfilingService");var L;(function(j){function O(S){return!!(S.samples&&S.timeDeltas)}j.isValidProfile=O;function C(S,d="noAbsolutePaths"){for(const R of S.nodes)R.callFrame&&R.callFrame.url&&((0,D.$hc)(R.callFrame.url)||/^\w[\w\d+.-]*:\/\/\/?/.test(R.callFrame.url))&&(R.callFrame.url=(0,D.$ic)(d,(0,D.$mc)(R.callFrame.url)));return S}j.rewriteAbsolutePaths=C})(L||(e.Utils=L={}))}),define(ae[207],ce([0,1,32]),function(ie,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$z0b=void 0;class A{constructor(){this.a=new Map}async startProfiling(j){const C=await(await new Promise((d,R)=>{ie(["v8-inspect-profiler"],d,R)})).startProfiling({port:j.port,checkForPaused:!0}),S=(0,D.$ig)();return this.a.set(S,C),S}async stopProfiling(j){const O=this.a.get(j);if(!O)throw new Error(`UNKNOWN session '${j}'`);const C=await O.stop();return this.a.delete(j),C.profile}}e.$z0b=A}),define(ae[41],ce([0,1,126,12]),function(ie,e,D,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mn=void 0;class L{constructor(){this.a=new Map}add(O,C){D.ok(A.$Cf(O)),D.ok(A.$Ef(C)),D.ok(!this.a.has(O),"There is already an extension with this id"),this.a.set(O,C)}knows(O){return this.a.has(O)}as(O){return this.a.get(O)||null}}e.$mn=new L}),define(ae[103],ce([0,1,3,41]),function(ie,e,D,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nn=void 0,e.$nn={JSONContribution:"base.contributions.json"};function L(C){return C.length>0&&C.charAt(C.length-1)==="#"?C.substring(0,C.length-1):C}class j{constructor(){this.b=new D.$Rd,this.onDidChangeSchema=this.b.event,this.a={}}registerSchema(S,d){this.a[L(S)]=d,this.b.fire(S)}notifySchemaChanged(S){this.b.fire(S)}getSchemaContributions(){return{schemas:this.a}}}const O=new j;A.$mn.add(e.$nn.JSONContribution,O)}),define(ae[50],ce([0,1,18,3,12,148,20,103,41]),function(ie,e,D,A,L,j,O,C,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gn=e.$Fn=e.$En=e.$Dn=e.$Cn=e.$Bn=e.$An=e.$zn=e.$yn=e.$xn=e.$wn=e.$vn=e.$un=e.$tn=e.$sn=e.ConfigurationScope=e.$rn=e.EditPresentationTypes=void 0;var d;(function(k){k.Multiline="multilineText",k.Singleline="singlelineText"})(d||(e.EditPresentationTypes=d={})),e.$rn={Configuration:"base.contributions.configuration"};var R;(function(k){k[k.APPLICATION=1]="APPLICATION",k[k.MACHINE=2]="MACHINE",k[k.WINDOW=3]="WINDOW",k[k.RESOURCE=4]="RESOURCE",k[k.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",k[k.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(R||(e.ConfigurationScope=R={})),e.$sn={properties:{},patternProperties:{}},e.$tn={properties:{},patternProperties:{}},e.$un={properties:{},patternProperties:{}},e.$vn={properties:{},patternProperties:{}},e.$wn={properties:{},patternProperties:{}},e.$xn={properties:{},patternProperties:{}},e.$yn="vscode://schemas/settings/resourceLanguage",e.$zn="vscode://schemas/settings/configurationDefaults";const E=S.$mn.as(C.$nn.JSONContribution);class b{constructor(){this.h=new Set,this.i=new A.$Rd,this.onDidSchemaChange=this.i.event,this.j=new A.$Rd,this.onDidUpdateConfiguration=this.j.event,this.a=new Map,this.b={id:"defaultOverrides",title:j.localize(0,null),properties:{}},this.c=[this.b],this.g={properties:{},patternProperties:{},additionalProperties:!0,allowTrailingCommas:!0,allowComments:!0},this.d={},this.e=new Map,this.f={},E.registerSchema(e.$yn,this.g),this.v()}registerConfiguration(s,a=!0){this.registerConfigurations([s],a)}registerConfigurations(s,a=!0){const n=new Set;this.n(s,a,n),E.registerSchema(e.$yn,this.g),this.i.fire(),this.j.fire({properties:n})}deregisterConfigurations(s){const a=new Set;this.o(s,a),E.registerSchema(e.$yn,this.g),this.i.fire(),this.j.fire({properties:a})}updateConfigurations({add:s,remove:a}){const n=new Set;this.o(a,n),this.n(s,!1,n),E.registerSchema(e.$yn,this.g),this.i.fire(),this.j.fire({properties:n})}registerDefaultConfigurations(s){const a=new Set;this.k(s,a),this.i.fire(),this.j.fire({properties:a,defaultsOverrides:!0})}k(s,a){const n=[];for(const{overrides:i,source:t}of s)for(const r in i)if(a.add(r),e.$Bn.test(r)){const o=this.a.get(r),v=o?.valuesSources??new Map;if(t)for(const I of Object.keys(i[r]))v.set(I,t);const $={...o?.value||{},...i[r]};this.a.set(r,{source:t,value:$,valuesSources:v});const f=(0,O.$zi)(r),p={type:"object",default:$,description:j.localize(1,null,f),$ref:e.$yn,defaultDefaultValue:$,source:L.$Cf(t)?void 0:t,defaultValueSource:t};n.push(...y(r)),this.d[r]=p,this.b.properties[r]=p}else{this.a.set(r,{value:i[r],source:t});const o=this.d[r];o&&(this.w(r,o),this.r(r,o))}this.m(n)}deregisterDefaultConfigurations(s){const a=new Set;this.l(s,a),this.i.fire(),this.j.fire({properties:a,defaultsOverrides:!0})}l(s,a){for(const{overrides:n,source:i}of s)for(const t in n){const r=this.a.get(t),o=L.$Cf(i)?i:i?.id,v=L.$Cf(r?.source)?r?.source:r?.source?.id;if(o===v)if(a.add(t),this.a.delete(t),e.$Bn.test(t))delete this.d[t],delete this.b.properties[t];else{const $=this.d[t];$&&(this.w(t,$),this.r(t,$))}}this.u()}deltaConfiguration(s){let a=!1;const n=new Set;s.removedDefaults&&(this.l(s.removedDefaults,n),a=!0),s.addedDefaults&&(this.k(s.addedDefaults,n),a=!0),s.removedConfigurations&&this.o(s.removedConfigurations,n),s.addedConfigurations&&this.n(s.addedConfigurations,!1,n),this.i.fire(),this.j.fire({properties:n,defaultsOverrides:a})}notifyConfigurationSchemaUpdated(...s){this.i.fire()}registerOverrideIdentifiers(s){this.m(s),this.i.fire()}m(s){for(const a of s)this.h.add(a);this.u()}n(s,a,n){s.forEach(i=>{this.p(i,a,i.extensionInfo,i.restrictedProperties,void 0,n),this.c.push(i),this.q(i)})}o(s,a){const n=i=>{if(i.properties)for(const t in i.properties){a.add(t);const r=this.d[t];r?.policy?.name&&this.e.delete(r.policy.name),delete this.d[t],this.s(t,i.properties[t])}i.allOf?.forEach(t=>n(t))};for(const i of s){n(i);const t=this.c.indexOf(i);t!==-1&&this.c.splice(t,1)}}p(s,a=!0,n,i,t=3,r){t=L.$Lf(s.scope)?t:s.scope;const o=s.properties;if(o)for(const $ in o){const f=o[$];if(a&&h($,f)){delete o[$];continue}if(f.source=n,f.defaultDefaultValue=o[$].default,this.w($,f),e.$Bn.test($)?f.scope=void 0:(f.scope=L.$Lf(f.scope)?t:f.scope,f.restricted=L.$Lf(f.restricted)?!!i?.includes($):f.restricted),o[$].hasOwnProperty("included")&&!o[$].included){this.f[$]=o[$],delete o[$];continue}else this.d[$]=o[$],o[$].policy?.name&&this.e.set(o[$].policy.name,$);!o[$].deprecationMessage&&o[$].markdownDeprecationMessage&&(o[$].deprecationMessage=o[$].markdownDeprecationMessage),r.add($)}const v=s.allOf;if(v)for(const $ of v)this.p($,a,n,i,t,r)}getConfigurations(){return this.c}getConfigurationProperties(){return this.d}getPolicyConfigurations(){return this.e}getExcludedConfigurationProperties(){return this.f}getConfigurationDefaultsOverrides(){return this.a}q(s){const a=n=>{const i=n.properties;if(i)for(const r in i)this.r(r,i[r]);n.allOf?.forEach(a)};a(s)}r(s,a){switch(e.$sn.properties[s]=a,a.scope){case 1:e.$tn.properties[s]=a;break;case 2:e.$un.properties[s]=a;break;case 6:e.$vn.properties[s]=a;break;case 3:e.$wn.properties[s]=a;break;case 4:e.$xn.properties[s]=a;break;case 5:e.$xn.properties[s]=a,this.g.properties[s]=a;break}}s(s,a){switch(delete e.$sn.properties[s],a.scope){case 1:delete e.$tn.properties[s];break;case 2:delete e.$un.properties[s];break;case 6:delete e.$vn.properties[s];break;case 3:delete e.$wn.properties[s];break;case 4:case 5:delete e.$xn.properties[s],delete this.g.properties[s];break}}u(){for(const s of this.h.values()){const a=`[${s}]`,n={type:"object",description:j.localize(2,null),errorMessage:j.localize(3,null),$ref:e.$yn};this.w(a,n),e.$sn.properties[a]=n,e.$tn.properties[a]=n,e.$un.properties[a]=n,e.$vn.properties[a]=n,e.$wn.properties[a]=n,e.$xn.properties[a]=n}}v(){const s={type:"object",description:j.localize(4,null),errorMessage:j.localize(5,null),$ref:e.$yn};e.$sn.patternProperties[e.$An]=s,e.$tn.patternProperties[e.$An]=s,e.$un.patternProperties[e.$An]=s,e.$vn.patternProperties[e.$An]=s,e.$wn.patternProperties[e.$An]=s,e.$xn.patternProperties[e.$An]=s,this.i.fire()}w(s,a){const n=this.a.get(s);let i=n?.value,t=n?.source;L.$Jf(i)&&(i=a.defaultDefaultValue,t=void 0),L.$Jf(i)&&(i=c(a.type)),a.default=i,a.defaultValueSource=t}}const l="\\[([^\\]]+)\\]",g=new RegExp(l,"g");e.$An=`^(${l})+$`,e.$Bn=new RegExp(e.$An);function y(k){const s=[];if(e.$Bn.test(k)){let a=g.exec(k);for(;a?.length;){const n=a[1].trim();n&&s.push(n),a=g.exec(k)}}return(0,D.$Lb)(s)}e.$Cn=y;function w(k){return k.reduce((s,a)=>`${s}[${a}]`,"")}e.$Dn=w;function c(k){switch(Array.isArray(k)?k[0]:k){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.$En=c;const u=new b;S.$mn.add(e.$rn.Configuration,u);function h(k,s){return k.trim()?e.$Bn.test(k)?j.localize(7,null,k):u.getConfigurationProperties()[k]!==void 0?j.localize(8,null,k):s.policy?.name&&u.getPolicyConfigurations().get(s.policy?.name)!==void 0?j.localize(9,null,k,s.policy?.name,u.getPolicyConfigurations().get(s.policy?.name)):null:j.localize(6,null)}e.$Fn=h;function m(){const k=[],s=u.getConfigurationProperties();for(const a of Object.keys(s))k.push([a,s[a].scope]);return k.push(["launch",4]),k.push(["task",4]),k}e.$Gn=m}),define(ae[74],ce([0,1,18,3,35,2,34,30,12,10,20,50,41]),function(ie,e,D,A,L,j,O,C,S,d,R,E,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mn=e.$Ln=e.$Kn=e.$Jn=e.$In=e.$Hn=void 0;function l(a){return Object.isFrozen(a)?a:C.$bn(a)}class g{constructor(n={},i=[],t=[],r){this.b=n,this.c=i,this.d=t,this.raw=r,this.a=new Map}get rawConfiguration(){if(!this.f)if(this.raw?.length){const n=this.raw.map(i=>{if(i instanceof g)return i;const t=new y("");return t.parseRaw(i),t.configurationModel});this.f=n.reduce((i,t)=>t===i?t:i.merge(t),n[0])}else this.f=this;return this.f}get contents(){return this.b}get overrides(){return this.d}get keys(){return this.c}isEmpty(){return this.c.length===0&&Object.keys(this.b).length===0&&this.d.length===0}getValue(n){return n?(0,R.$xi)(this.contents,n):this.contents}inspect(n,i){const t=this.rawConfiguration.getValue(n),r=i?this.rawConfiguration.getOverrideValue(n,i):void 0,o=i?this.rawConfiguration.override(i).getValue(n):t;return{value:t,override:r,merged:o}}getOverrideValue(n,i){const t=this.i(i);return t?n?(0,R.$xi)(t,n):t:void 0}getKeysForOverrideIdentifier(n){const i=[];for(const t of this.overrides)t.identifiers.includes(n)&&i.push(...t.keys);return D.$Lb(i)}getAllOverrideIdentifiers(){const n=[];for(const i of this.overrides)n.push(...i.identifiers);return D.$Lb(n)}override(n){let i=this.a.get(n);return i||(i=this.g(n),this.a.set(n,i)),i}merge(...n){const i=C.$an(this.contents),t=C.$an(this.overrides),r=[...this.keys],o=this.raw?.length?[...this.raw]:[this];for(const v of n)if(o.push(...v.raw?.length?v.raw:[v]),!v.isEmpty()){this.h(i,v.contents);for(const $ of v.overrides){const[f]=t.filter(p=>D.$tb(p.identifiers,$.identifiers));f?(this.h(f.contents,$.contents),f.keys.push(...$.keys),f.keys=D.$Lb(f.keys)):t.push(C.$an($))}for(const $ of v.keys)r.indexOf($)===-1&&r.push($)}return new g(i,r,t,o.every(v=>v instanceof g)?void 0:o)}g(n){const i=this.i(n);if(!i||typeof i!="object"||!Object.keys(i).length)return this;const t={};for(const r of D.$Lb([...Object.keys(this.contents),...Object.keys(i)])){let o=this.contents[r];const v=i[r];v&&(typeof o=="object"&&typeof v=="object"?(o=C.$an(o),this.h(o,v)):o=v),t[r]=o}return new g(t,this.keys,this.overrides)}h(n,i){for(const t of Object.keys(i)){if(t in n&&S.$Ef(n[t])&&S.$Ef(i[t])){this.h(n[t],i[t]);continue}n[t]=C.$an(i[t])}}i(n){let i=null,t=null;const r=o=>{o&&(t?this.h(t,o):t=C.$an(o))};for(const o of this.overrides)o.identifiers.length===1&&o.identifiers[0]===n?i=o.contents:o.identifiers.includes(n)&&r(o.contents);return r(i),t}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}addValue(n,i){this.j(n,i,!0)}setValue(n,i){this.j(n,i,!1)}removeValue(n){const i=this.keys.indexOf(n);i!==-1&&(this.keys.splice(i,1),(0,R.$wi)(this.contents,n),E.$Bn.test(n)&&this.overrides.splice(this.overrides.findIndex(t=>D.$tb(t.identifiers,(0,E.$Cn)(n))),1))}j(n,i,t){(0,R.$vi)(this.contents,n,i,r=>console.error(r)),t=t||this.keys.indexOf(n)===-1,t&&this.keys.push(n),E.$Bn.test(n)&&this.overrides.push({identifiers:(0,E.$Cn)(n),keys:Object.keys(this.contents[n]),contents:(0,R.$ui)(this.contents[n],r=>console.error(r))})}}e.$Hn=g;class y{constructor(n){this.f=n,this.a=null,this.b=null,this.c=[],this.d=[]}get configurationModel(){return this.b||new g}get restrictedConfigurations(){return this.c}get errors(){return this.d}parse(n,i){if(!S.$Lf(n)){const t=this.g(n);this.parseRaw(t,i)}}reparse(n){this.a&&this.parseRaw(this.a,n)}parseRaw(n,i){this.a=n;const{contents:t,keys:r,overrides:o,restricted:v,hasExcludedProperties:$}=this.h(n,i);this.b=new g(t,r,o,$?[n]:void 0),this.c=v||[]}g(n){let i={},t=null,r=[];const o=[],v=[];function $(p){Array.isArray(r)?r.push(p):t!==null&&(r[t]=p)}const f={onObjectBegin:()=>{const p={};$(p),o.push(r),r=p,t=null},onObjectProperty:p=>{t=p},onObjectEnd:()=>{r=o.pop()},onArrayBegin:()=>{const p=[];$(p),o.push(r),r=p,t=null},onArrayEnd:()=>{r=o.pop()},onLiteralValue:$,onError:(p,I,T)=>{v.push({error:p,offset:I,length:T})}};if(n)try{L.$0m(n,f),i=r[0]||{}}catch(p){console.error(`Error while parsing settings file ${this.f}: ${p}`),this.d=[p]}return i}h(n,i){const t=b.$mn.as(E.$rn.Configuration).getConfigurationProperties(),r=this.i(n,t,!0,i);n=r.raw;const o=(0,R.$ui)(n,f=>console.error(`Conflict in settings file ${this.f}: ${f}`)),v=Object.keys(n),$=this.j(n,f=>console.error(`Conflict in settings file ${this.f}: ${f}`));return{contents:o,keys:v,overrides:$,restricted:r.restricted,hasExcludedProperties:r.hasExcludedProperties}}i(n,i,t,r){let o=!1;if(!r?.scopes&&!r?.skipRestricted&&!r?.exclude?.length)return{raw:n,restricted:[],hasExcludedProperties:o};const v={},$=[];for(const f in n)if(E.$Bn.test(f)&&t){const p=this.i(n[f],i,!1,r);v[f]=p.raw,o=o||p.hasExcludedProperties,$.push(...p.restricted)}else{const p=i[f],I=p?typeof p.scope<"u"?p.scope:3:void 0;p?.restricted&&$.push(f),!r.exclude?.includes(f)&&(r.include?.includes(f)||(I===void 0||r.scopes===void 0||r.scopes.includes(I))&&!(r.skipRestricted&&p?.restricted))?v[f]=n[f]:o=!0}return{raw:v,restricted:$,hasExcludedProperties:o}}j(n,i){const t=[];for(const r of Object.keys(n))if(E.$Bn.test(r)){const o={};for(const v in n[r])o[v]=n[r][v];t.push({identifiers:(0,E.$Cn)(r),keys:Object.keys(o),contents:(0,R.$ui)(o,i)})}return t}}e.$In=y;class w extends j.$Rc{constructor(n,i,t,r){super(),this.c=n,this.f=i,this.g=r,this.b=this.B(new A.$Rd),this.onDidChange=this.b.event,this.a=new y(this.c.toString()),this.B(this.g.watch(t.dirname(this.c))),this.B(this.g.watch(this.c)),this.B(A.Event.any(A.Event.filter(this.g.onDidFilesChange,o=>o.contains(this.c)),A.Event.filter(this.g.onDidRunOperation,o=>(o.isOperation(0)||o.isOperation(3)||o.isOperation(1)||o.isOperation(4))&&t.isEqual(o.resource,n)))(()=>this.b.fire()))}async loadConfiguration(){try{const n=await this.g.readFile(this.c);return this.a.parse(n.value.toString()||"{}",this.f),this.a.configurationModel}catch{return new g}}reparse(n){return n&&(this.f=n),this.a.reparse(this.f),this.a.configurationModel}getRestrictedSettings(){return this.a.restrictedConfigurations}}e.$Jn=w;class c{constructor(n,i,t,r,o,v,$,f,p,I,T,M,z){this.a=n,this.b=i,this.c=t,this.overrideIdentifiers=r,this.d=o,this.f=v,this.g=$,this.h=f,this.i=p,this.j=I,this.k=T,this.l=M,this.m=z}get value(){return l(this.c)}n(n,i,t){const r=n.inspect(i,t);return{get value(){return l(r.value)},get override(){return l(r.override)},get merged(){return l(r.merged)}}}get q(){return this.p||(this.p=this.n(this.d,this.a,this.b.overrideIdentifier)),this.p}get defaultValue(){return this.q.merged}get default(){return this.q.value!==void 0||this.q.override!==void 0?{value:this.q.value,override:this.q.override}:void 0}get s(){return this.r===void 0&&(this.r=this.f?this.n(this.f,this.a):null),this.r}get policyValue(){return this.s?.merged}get policy(){return this.s?.value!==void 0?{value:this.s.value}:void 0}get u(){return this.t===void 0&&(this.t=this.g?this.n(this.g,this.a):null),this.t}get applicationValue(){return this.u?.merged}get application(){return this.u?.value!==void 0||this.u?.override!==void 0?{value:this.u.value,override:this.u.override}:void 0}get w(){return this.v||(this.v=this.n(this.h,this.a,this.b.overrideIdentifier)),this.v}get userValue(){return this.w.merged}get user(){return this.w.value!==void 0||this.w.override!==void 0?{value:this.w.value,override:this.w.override}:void 0}get y(){return this.x||(this.x=this.n(this.i,this.a,this.b.overrideIdentifier)),this.x}get userLocalValue(){return this.y.merged}get userLocal(){return this.y.value!==void 0||this.y.override!==void 0?{value:this.y.value,override:this.y.override}:void 0}get A(){return this.z||(this.z=this.n(this.j,this.a,this.b.overrideIdentifier)),this.z}get userRemoteValue(){return this.A.merged}get userRemote(){return this.A.value!==void 0||this.A.override!==void 0?{value:this.A.value,override:this.A.override}:void 0}get D(){return this.B===void 0&&(this.B=this.k?this.n(this.k,this.a,this.b.overrideIdentifier):null),this.B}get workspaceValue(){return this.D?.merged}get workspace(){return this.D?.value!==void 0||this.D?.override!==void 0?{value:this.D.value,override:this.D.override}:void 0}get F(){return this.E===void 0&&(this.E=this.l?this.n(this.l,this.a,this.b.overrideIdentifier):null),this.E}get workspaceFolderValue(){return this.F?.merged}get workspaceFolder(){return this.F?.value!==void 0||this.F?.override!==void 0?{value:this.F.value,override:this.F.override}:void 0}get H(){return this.G===void 0&&(this.G=this.n(this.m,this.a,this.b.overrideIdentifier)),this.G}get memoryValue(){return this.H.merged}get memory(){return this.H.value!==void 0||this.H.override!==void 0?{value:this.H.value,override:this.H.override}:void 0}}class u{constructor(n,i,t,r,o=new g,v=new g,$=new O.$zc,f=new g,p=new O.$zc){this.c=n,this.d=i,this.f=t,this.g=r,this.h=o,this.i=v,this.j=$,this.l=f,this.m=p,this.a=null,this.b=new O.$zc,this.n=null}getValue(n,i,t){return this.p(n,i,t).getValue(n)}updateValue(n,i,t={}){let r;t.resource?(r=this.m.get(t.resource),r||(r=new g,this.m.set(t.resource,r))):r=this.l,i===void 0?r.removeValue(n):r.setValue(n,i),t.resource||(this.a=null)}inspect(n,i,t){const r=this.p(n,i,t),o=this.t(i.resource,t),v=i.resource?this.m.get(i.resource)||this.l:this.l,$=new Set;for(const f of r.overrides)for(const p of f.identifiers)r.getOverrideValue(n,p)!==void 0&&$.add(p);return new c(n,i,r.getValue(n),$.size?[...$]:void 0,this.c,this.d.isEmpty()?void 0:this.d,this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration,this.userConfiguration,this.localUserConfiguration,this.remoteUserConfiguration,t?this.i:void 0,o||void 0,v)}keys(n){const i=this.t(void 0,n);return{default:this.c.keys.slice(0),user:this.userConfiguration.keys.slice(0),workspace:this.i.keys.slice(0),workspaceFolder:i?i.keys.slice(0):[]}}updateDefaultConfiguration(n){this.c=n,this.a=null,this.b.clear()}updatePolicyConfiguration(n){this.d=n}updateApplicationConfiguration(n){this.f=n,this.a=null,this.b.clear()}updateLocalUserConfiguration(n){this.g=n,this.n=null,this.a=null,this.b.clear()}updateRemoteUserConfiguration(n){this.h=n,this.n=null,this.a=null,this.b.clear()}updateWorkspaceConfiguration(n){this.i=n,this.a=null,this.b.clear()}updateFolderConfiguration(n,i){this.j.set(n,i),this.b.delete(n)}deleteFolderConfiguration(n){this.folderConfigurations.delete(n),this.b.delete(n)}compareAndUpdateDefaultConfiguration(n,i){const t=[];if(!i){const{added:r,updated:o,removed:v}=k(this.c,n);i=[...r,...o,...v]}for(const r of i)for(const o of(0,E.$Cn)(r)){const v=this.c.getKeysForOverrideIdentifier(o),$=n.getKeysForOverrideIdentifier(o),f=[...$.filter(p=>v.indexOf(p)===-1),...v.filter(p=>$.indexOf(p)===-1),...v.filter(p=>!C.$en(this.c.override(o).getValue(p),n.override(o).getValue(p)))];t.push([o,f])}return this.updateDefaultConfiguration(n),{keys:i,overrides:t}}compareAndUpdatePolicyConfiguration(n){const{added:i,updated:t,removed:r}=k(this.d,n),o=[...i,...t,...r];return o.length&&this.updatePolicyConfiguration(n),{keys:o,overrides:[]}}compareAndUpdateApplicationConfiguration(n){const{added:i,updated:t,removed:r,overrides:o}=k(this.applicationConfiguration,n),v=[...i,...t,...r];return v.length&&this.updateApplicationConfiguration(n),{keys:v,overrides:o}}compareAndUpdateLocalUserConfiguration(n){const{added:i,updated:t,removed:r,overrides:o}=k(this.localUserConfiguration,n),v=[...i,...t,...r];return v.length&&this.updateLocalUserConfiguration(n),{keys:v,overrides:o}}compareAndUpdateRemoteUserConfiguration(n){const{added:i,updated:t,removed:r,overrides:o}=k(this.remoteUserConfiguration,n),v=[...i,...t,...r];return v.length&&this.updateRemoteUserConfiguration(n),{keys:v,overrides:o}}compareAndUpdateWorkspaceConfiguration(n){const{added:i,updated:t,removed:r,overrides:o}=k(this.workspaceConfiguration,n),v=[...i,...t,...r];return v.length&&this.updateWorkspaceConfiguration(n),{keys:v,overrides:o}}compareAndUpdateFolderConfiguration(n,i){const t=this.folderConfigurations.get(n),{added:r,updated:o,removed:v,overrides:$}=k(t,i),f=[...r,...o,...v];return(f.length||!t)&&this.updateFolderConfiguration(n,i),{keys:f,overrides:$}}compareAndDeleteFolderConfiguration(n){const i=this.folderConfigurations.get(n);if(!i)throw new Error("Unknown folder");this.deleteFolderConfiguration(n);const{added:t,updated:r,removed:o,overrides:v}=k(i,void 0);return{keys:[...t,...r,...o],overrides:v}}get defaults(){return this.c}get applicationConfiguration(){return this.f}get userConfiguration(){return this.n||(this.n=this.h.isEmpty()?this.g:this.g.merge(this.h)),this.n}get localUserConfiguration(){return this.g}get remoteUserConfiguration(){return this.h}get workspaceConfiguration(){return this.i}get folderConfigurations(){return this.j}p(n,i,t){let r=this.q(i,t);return i.overrideIdentifier&&(r=r.override(i.overrideIdentifier)),!this.d.isEmpty()&&this.d.getValue(n)!==void 0&&(r=r.merge(this.d)),r}q({resource:n},i){let t=this.r();if(i&&n){const r=i.getFolder(n);r&&(t=this.s(r.uri)||t);const o=this.m.get(n);o&&(t=t.merge(o))}return t}r(){return this.a||(this.a=this.c.merge(this.applicationConfiguration,this.userConfiguration,this.i,this.l)),this.a}s(n){let i=this.b.get(n);if(!i){const t=this.r(),r=this.j.get(n);r?(i=t.merge(r),this.b.set(n,i)):i=t}return i}t(n,i){if(i&&n){const t=i.getFolder(n);if(t)return this.j.get(t.uri)}}toData(){return{defaults:{contents:this.c.contents,overrides:this.c.overrides,keys:this.c.keys},policy:{contents:this.d.contents,overrides:this.d.overrides,keys:this.d.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this.i.contents,overrides:this.i.overrides,keys:this.i.keys},folders:[...this.j.keys()].reduce((n,i)=>{const{contents:t,overrides:r,keys:o}=this.j.get(i);return n.push([i,{contents:t,overrides:r,keys:o}]),n},[])}}allKeys(){const n=new Set;return this.c.keys.forEach(i=>n.add(i)),this.userConfiguration.keys.forEach(i=>n.add(i)),this.i.keys.forEach(i=>n.add(i)),this.j.forEach(i=>i.keys.forEach(t=>n.add(t))),[...n.values()]}u(){const n=new Set;return this.c.getAllOverrideIdentifiers().forEach(i=>n.add(i)),this.userConfiguration.getAllOverrideIdentifiers().forEach(i=>n.add(i)),this.i.getAllOverrideIdentifiers().forEach(i=>n.add(i)),this.j.forEach(i=>i.getAllOverrideIdentifiers().forEach(t=>n.add(t))),[...n.values()]}v(n){const i=new Set;return this.c.getKeysForOverrideIdentifier(n).forEach(t=>i.add(t)),this.userConfiguration.getKeysForOverrideIdentifier(n).forEach(t=>i.add(t)),this.i.getKeysForOverrideIdentifier(n).forEach(t=>i.add(t)),this.j.forEach(t=>t.getKeysForOverrideIdentifier(n).forEach(r=>i.add(r))),[...i.values()]}static parse(n){const i=this.w(n.defaults),t=this.w(n.policy),r=this.w(n.application),o=this.w(n.user),v=this.w(n.workspace),$=n.folders.reduce((f,p)=>(f.set(d.URI.revive(p[0]),this.w(p[1])),f),new O.$zc);return new u(i,t,r,o,new g,v,$,new g,new O.$zc)}static w(n){return new g(n.contents,n.keys,n.overrides)}}e.$Kn=u;function h(...a){if(a.length===0)return{keys:[],overrides:[]};if(a.length===1)return a[0];const n=new Set,i=new Map;for(const r of a)r.keys.forEach(o=>n.add(o)),r.overrides.forEach(([o,v])=>{const $=(0,O.$wc)(i,o,new Set);v.forEach(f=>$.add(f))});const t=[];return i.forEach((r,o)=>t.push([o,[...r.values()]])),{keys:[...n.values()],overrides:t}}e.$Ln=h;class m{constructor(n,i,t,r){this.change=n,this.f=i,this.g=t,this.h=r,this.a=`
`,this.b=this.a.charCodeAt(0),this.c=".".charCodeAt(0),this.affectedKeys=new Set,this.i=void 0;for(const o of n.keys)this.affectedKeys.add(o);for(const[,o]of n.overrides)for(const v of o)this.affectedKeys.add(v);this.d=this.a;for(const o of this.affectedKeys)this.d+=o+this.a}get previousConfiguration(){return!this.i&&this.f&&(this.i=u.parse(this.f.data)),this.i}affectsConfiguration(n,i){const t=this.a+n,r=this.d.indexOf(t);if(r<0)return!1;const o=r+t.length;if(o>=this.d.length)return!1;const v=this.d.charCodeAt(o);if(v!==this.b&&v!==this.c)return!1;if(i){const $=this.previousConfiguration?this.previousConfiguration.getValue(n,i,this.f?.workspace):void 0,f=this.g.getValue(n,i,this.h);return!C.$en($,f)}return!0}}e.$Mn=m;function k(a,n){const{added:i,removed:t,updated:r}=s(n?.rawConfiguration,a?.rawConfiguration),o=[],v=a?.getAllOverrideIdentifiers()||[],$=n?.getAllOverrideIdentifiers()||[];if(n){const f=$.filter(p=>!v.includes(p));for(const p of f)o.push([p,n.getKeysForOverrideIdentifier(p)])}if(a){const f=v.filter(p=>!$.includes(p));for(const p of f)o.push([p,a.getKeysForOverrideIdentifier(p)])}if(n&&a){for(const f of v)if($.includes(f)){const p=s({contents:a.getOverrideValue(void 0,f)||{},keys:a.getKeysForOverrideIdentifier(f)},{contents:n.getOverrideValue(void 0,f)||{},keys:n.getKeysForOverrideIdentifier(f)});o.push([f,[...p.added,...p.removed,...p.updated]])}}return{added:i,removed:t,updated:r,overrides:o}}function s(a,n){const i=a?n?a.keys.filter(o=>n.keys.indexOf(o)===-1):[...a.keys]:[],t=n?a?n.keys.filter(o=>a.keys.indexOf(o)===-1):[...n.keys]:[],r=[];if(a&&n){for(const o of n.keys)if(a.keys.indexOf(o)!==-1){const v=(0,R.$xi)(n.contents,o),$=(0,R.$xi)(a.contents,o);C.$en(v,$)||r.push(o)}}return{added:i,removed:t,updated:r}}}),define(ae[208],ce([0,1,18,3,2,30,12,74,50,8,57,41]),function(ie,e,D,A,L,j,O,C,S,d,R,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pn=e.$On=e.$Nn=void 0;class b extends L.$Rc{constructor(){super(...arguments),this.a=this.B(new A.$Rd),this.onDidChangeConfiguration=this.a.event,this.b=new C.$Hn}get configurationModel(){return this.b}async initialize(){return this.g(),this.B(E.$mn.as(S.$rn.Configuration).onDidUpdateConfiguration(({properties:w,defaultsOverrides:c})=>this.c(Array.from(w),c))),this.configurationModel}reload(){return this.g(),this.configurationModel}c(w,c){this.h(w,E.$mn.as(S.$rn.Configuration).getConfigurationProperties()),this.a.fire({defaults:this.configurationModel,properties:w})}f(){return{}}g(){this.b=new C.$Hn;const w=E.$mn.as(S.$rn.Configuration).getConfigurationProperties();this.h(Object.keys(w),w)}h(w,c){const u=this.f();for(const h of w){const m=u[h],k=c[h];m!==void 0?this.b.addValue(h,m):k?this.b.addValue(h,k.default):this.b.removeValue(h)}}}e.$Nn=b;class l{constructor(){this.onDidChangeConfiguration=A.Event.None,this.configurationModel=new C.$Hn}async initialize(){return this.configurationModel}}e.$On=l;let g=class extends L.$Rc{get configurationModel(){return this.b}constructor(w,c,u){super(),this.c=w,this.f=c,this.g=u,this.a=this.B(new A.$Rd),this.onDidChangeConfiguration=this.a.event,this.b=new C.$Hn}async initialize(){return this.g.trace("PolicyConfiguration#initialize"),this.m(await this.h(this.c.configurationModel.keys),!1),this.B(this.f.onDidChange(w=>this.j(w))),this.B(this.c.onDidChangeConfiguration(async({properties:w})=>this.m(await this.h(w),!0))),this.b}async h(w){this.g.trace("PolicyConfiguration#updatePolicyDefinitions",w);const c={},u=[],h=E.$mn.as(S.$rn.Configuration).getConfigurationProperties();for(const m of w){const k=h[m];if(!k){u.push(m);continue}if(k.policy){if(k.type!=="string"&&k.type!=="number"){this.g.warn(`Policy ${k.policy.name} has unsupported type ${k.type}`);continue}u.push(m),c[k.policy.name]={type:k.type}}}return(0,O.$Pf)(c)||await this.f.updatePolicyDefinitions(c),u}j(w){this.g.trace("PolicyConfiguration#onDidChangePolicies",w);const c=E.$mn.as(S.$rn.Configuration).getPolicyConfigurations(),u=(0,D.$Gb)(w.map(h=>c.get(h)));this.m(u,!0)}m(w,c){this.g.trace("PolicyConfiguration#update",w);const u=E.$mn.as(S.$rn.Configuration).getConfigurationProperties(),h=[],m=this.b.isEmpty();for(const k of w){const s=u[k]?.policy?.name;if(s){const a=this.f.getPolicyValue(s);(m?a!==void 0:!(0,j.$en)(this.b.getValue(k),a))&&h.push([k,a])}else this.b.getValue(k)!==void 0&&h.push([k,void 0])}if(h.length){this.g.trace("PolicyConfiguration#changed",h);const k=this.b;this.b=new C.$Hn;for(const s of k.keys)this.b.setValue(s,k.getValue(s));for(const[s,a]of h)a===void 0?this.b.removeValue(s):this.b.setValue(s,a);c&&this.a.fire(this.b)}}};e.$Pn=g,e.$Pn=g=pe([X(1,R.$on),X(2,d.$dj)],g)}),define(ae[209],ce([0,1,6,3,2,19,20,74,208,57]),function(ie,e,D,A,L,j,O,C,S,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qn=void 0;class R extends L.$Rc{constructor(b,l,g,y){super(),this.j=b,this.h=this.B(new A.$Rd),this.onDidChangeConfiguration=this.h.event,this.b=this.B(new S.$Nn),this.c=g instanceof d.$qn?new S.$On:this.B(new S.$Pn(this.b,g,y)),this.f=this.B(new C.$Jn(this.j,{},j.$qg,l)),this.a=new C.$Kn(this.b.configurationModel,this.c.configurationModel,new C.$Hn,new C.$Hn),this.g=this.B(new D.$0g(()=>this.reloadConfiguration(),50)),this.B(this.b.onDidChangeConfiguration(({defaults:w,properties:c})=>this.n(w,c))),this.B(this.c.onDidChangeConfiguration(w=>this.r(w))),this.B(this.f.onDidChange(()=>this.g.schedule()))}async initialize(){const[b,l,g]=await Promise.all([this.b.initialize(),this.c.initialize(),this.f.loadConfiguration()]);this.a=new C.$Kn(b,l,new C.$Hn,g)}getConfigurationData(){return this.a.toData()}getValue(b,l){const g=typeof b=="string"?b:void 0,y=(0,O.$qi)(b)?b:(0,O.$qi)(l)?l:{};return this.a.getValue(g,y,void 0)}updateValue(b,l,g,y){return Promise.reject(new Error("not supported"))}inspect(b){return this.a.inspect(b,{},void 0)}keys(){return this.a.keys(void 0)}async reloadConfiguration(){const b=await this.f.loadConfiguration();this.m(b)}m(b){const l=this.a.toData(),g=this.a.compareAndUpdateLocalUserConfiguration(b);this.s(g,l,2)}n(b,l){const g=this.a.toData(),y=this.a.compareAndUpdateDefaultConfiguration(b,l);this.s(y,g,7)}r(b){const l=this.a.toData(),g=this.a.compareAndUpdatePolicyConfiguration(b);this.s(g,l,7)}s(b,l,g){const y=new C.$Mn(b,{data:l},this.a);y.source=g,y.sourceConfig=this.t(g),this.h.fire(y)}t(b){switch(b){case 7:return this.a.defaults.contents;case 2:return this.a.localUserConfiguration.contents}return{}}}e.$Qn=R}),define(ae[210],ce([0,1,15,3,2,67]),function(ie,e,D,A,L,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9pb=e.$8pb=e.$7pb=e.$6pb=void 0;const O=(d,R,E)=>{const b=new Uint8Array(16);for(let y=0;y<16;y++)b[y]=Math.round(Math.random()*256);const l=(0,D.$ze)(D.$fe.wrap(b));return[`GET ws://localhost${d}?${R}&skipWebSocketFrames=true HTTP/1.1`,"Connection: Upgrade","Upgrade: websocket",`Sec-WebSocket-Key: ${l}`].join(`\r
`)+`\r
\r
`};e.$6pb=O,e.$7pb=D.$fe.fromString(`\r
\r
`);async function C(d,R,E,b,l){d.write(D.$fe.fromString((0,e.$6pb)(R,E,b)));const g=new L.$Qc;try{return await new Promise((y,w)=>{let c;g.add(d.onData(u=>{c?c=D.$fe.concat([c,u],c.byteLength+u.byteLength):c=u;const h=c.indexOf(e.$7pb);if(h===-1)return;y(d),d.pauseData();const m=c.slice(h+e.$7pb.byteLength);m.byteLength&&l.onData.fire(m)})),g.add(d.onClose(u=>w(u??new Error("socket closed")))),g.add(d.onEnd(()=>w(new Error("socket ended"))))})}catch(y){throw d.dispose(),y}finally{g.dispose()}}e.$8pb=C;class S extends L.$Rc{constructor(R,E){super(),this.g=R,this.a=this.B(new A.$Ud),this.onData=(...b)=>(this.a.isPaused&&queueMicrotask(()=>this.a.resume()),this.a.event(...b)),this.b=this.B(new A.$Rd),this.onDidDispose=this.b.event,this.f=!1,this.B(E.onData),this.B(E.onData.event(b=>this.a.fire(b))),this.onClose=this.B(E.onClose).event,this.onEnd=this.B(E.onEnd).event}pauseData(){this.a.pause()}drain(){return Promise.resolve()}end(){this.f=!0,this.h()}traceSocketEvent(R,E){j.SocketDiagnostics.traceSocketEvent(this,this.g,R,E)}dispose(){this.f||this.h(),this.b.fire(),super.dispose()}}e.$9pb=S}),define(ae[211],ce([0,1,7,4]),function(ie,e,D,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zk=e.$Yk=e.RemoteAuthorityResolverErrorCode=e.$Xk=e.$Wk=e.RemoteConnectionType=e.$Vk=void 0,e.$Vk=(0,A.$Vh)("remoteAuthorityResolverService");var L;(function(R){R[R.WebSocket=0]="WebSocket",R[R.Managed=1]="Managed"})(L||(e.RemoteConnectionType=L={}));class j{constructor(E){this.id=E,this.type=1}toString(){return`Managed(${this.id})`}}e.$Wk=j;class O{constructor(E,b){this.host=E,this.port=b,this.type=0}toString(){return`WebSocket(${this.host}:${this.port})`}}e.$Xk=O;var C;(function(R){R.Unknown="Unknown",R.NotAvailable="NotAvailable",R.TemporarilyNotAvailable="TemporarilyNotAvailable",R.NoResolverFound="NoResolverFound",R.InvalidAuthority="InvalidAuthority"})(C||(e.RemoteAuthorityResolverErrorCode=C={}));class S extends D.$ab{static isNotAvailable(E){return E instanceof S&&E._code===C.NotAvailable}static isTemporarilyNotAvailable(E){return E instanceof S&&E._code===C.TemporarilyNotAvailable}static isNoResolverFound(E){return E instanceof S&&E._code===C.NoResolverFound}static isInvalidAuthority(E){return E instanceof S&&E._code===C.InvalidAuthority}static isHandled(E){return E instanceof S&&E.isHandled}constructor(E,b=C.Unknown,l){super(E),this._message=E,this._code=b,this._detail=l,this.isHandled=b===C.NotAvailable&&l===!0,Object.setPrototypeOf(this,S.prototype)}}e.$Yk=S;function d(R){const E=R.indexOf("+");return E===-1?R:R.substring(0,E)}e.$Zk=d}),define(ae[75],ce([0,1,23]),function(ie,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5k=e.$4k=e.$3k=e.$2k=e.$1k=void 0;function A(d){return d.scheme===D.Schemas.vscodeRemote?d.authority:void 0}e.$1k=A;function L(d){if(!d)return;const R=d.indexOf("+");return R<0?d:d.substr(0,R)}e.$2k=L;function j(d){return`/${d.quality??"oss"}-${d.commit??"dev"}`}e.$3k=j;function O(d){const{host:R,port:E}=S(d);if(typeof E>"u")throw new Error("Remote authority doesn't contain a port!");return{host:R,port:E}}e.$4k=O;function C(d,R){let{host:E,port:b}=S(d);return typeof b>"u"&&(b=R),{host:E,port:b}}e.$5k=C;function S(d){const R=d.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(R)return{host:R[1],port:parseInt(R[2],10)};const E=d.match(/^(\[[0-9a-z:]+\])$/);if(E)return{host:E[1],port:void 0};const b=d.match(/(.*):(\d+)$/);return b?{host:b[1],port:parseInt(b[2],10)}:{host:d,port:void 0}}}),define(ae[44],ce([0,1,27,4,75]),function(ie,e,D,A,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gm=e.$fm=e.$em=e.$dm=e.$cm=e.$bm=e.$am=e.$_l=e.TargetPlatform=e.ExtensionType=e.$$l=e.$0l=e.$9l=e.$8l=e.$7l=e.$6l=void 0,e.$6l="extensions.user.cache",e.$7l="extensions.builtin.cache",e.$8l="undefined_publisher",e.$9l=["ui","workspace","web"];function j(y){if(typeof y=="object"&&y!==null&&y.supported!==!0)return y.description}e.$0l=j,e.$$l=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var O;(function(y){y[y.System=0]="System",y[y.User=1]="User"})(O||(e.ExtensionType=O={}));var C;(function(y){y.WIN32_X64="win32-x64",y.WIN32_ARM64="win32-arm64",y.LINUX_X64="linux-x64",y.LINUX_ARM64="linux-arm64",y.LINUX_ARMHF="linux-armhf",y.ALPINE_X64="alpine-x64",y.ALPINE_ARM64="alpine-arm64",y.DARWIN_X64="darwin-x64",y.DARWIN_ARM64="darwin-arm64",y.WEB="web",y.UNIVERSAL="universal",y.UNKNOWN="unknown",y.UNDEFINED="undefined"})(C||(e.TargetPlatform=C={}));class S{constructor(w){this.value=w,this._lower=w.toLowerCase()}static equals(w,c){if(typeof w>"u"||w===null)return typeof c>"u"||c===null;if(typeof c>"u"||c===null)return!1;if(typeof w=="string"||typeof c=="string"){const u=typeof w=="string"?w:w.value,h=typeof c=="string"?c:c.value;return D.$6e(u,h)}return w._lower===c._lower}static toKey(w){return typeof w=="string"?w.toLowerCase():w._lower}}e.$_l=S;class d{get size(){return this.c.size}constructor(w){if(this.c=new Set,w)for(const c of w)this.add(c)}add(w){this.c.add(S.toKey(w))}delete(w){return this.c.delete(S.toKey(w))}has(w){return this.c.has(S.toKey(w))}}e.$am=d;class R{constructor(){this.c=new Map}clear(){this.c.clear()}delete(w){this.c.delete(S.toKey(w))}get(w){return this.c.get(S.toKey(w))}has(w){return this.c.has(S.toKey(w))}set(w,c){this.c.set(S.toKey(w),c)}values(){return this.c.values()}forEach(w){this.c.forEach(w)}[Symbol.iterator](){return this.c[Symbol.iterator]()}}e.$bm=R;function E(y){return b(y)}e.$cm=E;function b(y){return y.contributes&&y.contributes.localizations?y.contributes.localizations.length>0:!1}e.$dm=b;function l(y){return y.contributes&&y.contributes.authentication?y.contributes.authentication.length>0:!1}e.$em=l;function g(y,w){if(w){const c=`onResolveRemoteAuthority:${(0,L.$2k)(w)}`;return!!y.activationEvents?.includes(c)}return!1}e.$fm=g,e.$gm=(0,A.$Vh)("IBuiltinExtensionsScannerService")}),define(ae[212],ce([0,1,2,44,11]),function(ie,e,D,A,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mp=void 0;class j extends D.$Rc{constructor(C,S,d,R,E){super(),this.a=C,this.b=S,this.c=d,this.f=E,this.B(R.onDidInstallExtensions(b=>this.g(b))),this.B(R.onDidUninstallExtension(b=>this.h(b)))}g(C){for(const S of C)S.local&&this.invalidate(S.profileLocation)}h(C){C.error||this.invalidate(C.profileLocation)}async invalidate(C){if(C)for(const S of this.a.profiles)this.c.extUri.isEqual(S.extensionsResource,C)&&await this.j(S);else await this.j(this.a.defaultProfile)}async j(C){try{await this.b.del(this.c.extUri.joinPath(C.cacheHome,A.$6l))}catch(S){(0,L.$vk)(S)!==1&&this.f.error(S)}}}e.$Mp=j}),define(ae[213],ce([0,1,6,15,26,7,3,2,100,62,32,67,211,75]),function(ie,e,D,A,L,j,O,C,S,d,R,E,b,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hl=e.$gl=e.$fl=e.$el=e.$dl=e.$cl=e.$bl=e.$al=e.PersistentConnectionEventType=e.$_k=e.$$k=e.$0k=e.ConnectionType=void 0;const g=30*1e3;var y;(function(U){U[U.Management=1]="Management",U[U.ExtensionHost=2]="ExtensionHost",U[U.Tunnel=3]="Tunnel"})(y||(e.ConnectionType=y={}));function w(U){switch(U){case 1:return"Management";case 2:return"ExtensionHost";case 3:return"Tunnel"}}function c(U){const P=new L.$2d;return setTimeout(()=>P.cancel(),U),P.token}function u(U,P){if(U.isCancellationRequested||P.isCancellationRequested)return L.CancellationToken.Cancelled;const F=new L.$2d;return U.onCancellationRequested(()=>F.cancel()),P.onCancellationRequested(()=>F.cancel()),F.token}class h{get didTimeout(){return this.c==="timedout"}constructor(P){this.c="pending",this.d=new C.$Qc,this.promise=new Promise((F,B)=>{this.f=F,this.g=B}),P.isCancellationRequested?this.h():this.d.add(P.onCancellationRequested(()=>this.h()))}registerDisposable(P){this.c==="pending"?this.d.add(P):P.dispose()}h(){this.c==="pending"&&(this.d.dispose(),this.c="timedout",this.g(this.i()))}i(){const P=new Error("Time limit reached");return P.code="ETIMEDOUT",P.syscall="connect",P}resolve(P){this.c==="pending"&&(this.d.dispose(),this.c="resolved",this.f(P))}reject(P){this.c==="pending"&&(this.d.dispose(),this.c="rejected",this.g(P))}}function m(U,P){const F=new h(P);return F.registerDisposable(U.onControlMessage(B=>{const N=JSON.parse(B.toString()),V=W(N);V?F.reject(V):F.resolve(N)})),F.promise}function k(U,P,F,B,N,V,G,te){const oe=new h(te),ue=d.$Nd.create(!1);return U.info(`Creating a socket (${G})...`),S.mark(`code/willCreateSocket/${V}`),P.connect(F,B,N,G).then(he=>{oe.didTimeout?(S.mark(`code/didCreateSocketError/${V}`),U.info(`Creating a socket (${G}) finished after ${ue.elapsed()} ms, but this is too late and has timed out already.`),he?.dispose()):(S.mark(`code/didCreateSocketOK/${V}`),U.info(`Creating a socket (${G}) was successful after ${ue.elapsed()} ms.`),oe.resolve(he))},he=>{S.mark(`code/didCreateSocketError/${V}`),U.info(`Creating a socket (${G}) returned an error after ${ue.elapsed()} ms.`),U.error(he),oe.reject(he)}),oe.promise}function s(U,P){const F=new h(P);return U.then(B=>{F.didTimeout||F.resolve(B)},B=>{F.didTimeout||F.reject(B)}),F.promise}async function a(U,P,F,B){const N=se(U,P);U.logService.trace(`${N} 1/6. invoking socketFactory.connect().`);let V;try{V=await k(U.logService,U.remoteSocketFactoryService,U.connectTo,(0,l.$3k)(U),`reconnectionToken=${U.reconnectionToken}&reconnection=${U.reconnectionProtocol?"true":"false"}`,w(P),`renderer-${w(P)}-${U.reconnectionToken}`,B)}catch(he){throw U.logService.error(`${N} socketFactory.connect() failed or timed out. Error:`),U.logService.error(he),he}U.logService.trace(`${N} 2/6. socketFactory.connect() was successful.`);let G,te;U.reconnectionProtocol?(U.reconnectionProtocol.beginAcceptReconnection(V,null),G=U.reconnectionProtocol,te=!1):(G=new E.$Jh({socket:V}),te=!0),U.logService.trace(`${N} 3/6. sending AuthRequest control message.`);const oe=await s(U.signService.createNewMessage((0,R.$ig)()),B),ue={type:"auth",auth:U.connectionToken||"00000000000000000000",data:oe.data};G.sendControl(A.$fe.fromString(JSON.stringify(ue)));try{const he=await m(G,u(B,c(1e4)));if(he.type!=="sign"||typeof he.data!="string"){const ve=new Error("Unexpected handshake message");throw ve.code="VSCODE_CONNECTION_ERROR",ve}if(U.logService.trace(`${N} 4/6. received SignRequest control message.`),!await s(U.signService.validate(oe,he.signedData),B)){const ve=new Error("Refused to connect to unsupported server");throw ve.code="VSCODE_CONNECTION_ERROR",ve}const de=await s(U.signService.sign(he.data),B),we={type:"connectionType",commit:U.commit,signedData:de,desiredConnectionType:P};return F&&(we.args=F),U.logService.trace(`${N} 5/6. sending ConnectionTypeRequest control message.`),G.sendControl(A.$fe.fromString(JSON.stringify(we))),{protocol:G,ownsProtocol:te}}catch(he){throw he&&he.code==="ETIMEDOUT"&&(U.logService.error(`${N} the handshake timed out. Error:`),U.logService.error(he)),he&&he.code==="VSCODE_CONNECTION_ERROR"&&(U.logService.error(`${N} received error control message when negotiating connection. Error:`),U.logService.error(he)),te&&J(G),he}}async function n(U,P,F,B){const N=Date.now(),V=se(U,P),{protocol:G,ownsProtocol:te}=await a(U,P,F,B),oe=new h(B);return oe.registerDisposable(G.onControlMessage(ue=>{const he=JSON.parse(ue.toString()),ge=W(he);ge?(U.logService.error(`${V} received error control message when negotiating connection. Error:`),U.logService.error(ge),te&&J(G),oe.reject(ge)):(U.reconnectionProtocol?.endAcceptReconnection(),U.logService.trace(`${V} 6/6. handshake finished, connection is up and running after ${K(N)}!`),oe.resolve({protocol:G,firstMessage:he}))})),oe.promise}async function i(U,P){const{protocol:F}=await n(U,1,void 0,P);return{protocol:F}}async function t(U,P,F){const{protocol:B,firstMessage:N}=await n(U,2,P,F),V=N&&N.debugPort;return{protocol:B,debugPort:V}}async function r(U,P,F){const B=Date.now(),N=se(U,3),{protocol:V}=await a(U,3,P,F);return U.logService.trace(`${N} 6/6. handshake finished, connection is up and running after ${K(B)}!`),V}async function o(U,P,F){const{connectTo:B,connectionToken:N}=await U.addressProvider.getAddress();return{commit:U.commit,quality:U.quality,connectTo:B,connectionToken:N,reconnectionToken:P,reconnectionProtocol:F,remoteSocketFactoryService:U.remoteSocketFactoryService,signService:U.signService,logService:U.logService}}async function v(U,P,F){return f(U,async B=>{const{protocol:N}=await i(B,L.CancellationToken.None);return new H(U,P,F,B.reconnectionToken,N)})}e.$0k=v;async function $(U,P){return f(U,async F=>{const{protocol:B,debugPort:N}=await t(F,P,L.CancellationToken.None);return new Z(U,P,F.reconnectionToken,B,N)})}e.$$k=$;async function f(U,P){for(let B=1;;B++)try{const N=(0,R.$ig)(),V=await o(U,N,null);return await P(V)}catch(N){if(B<5)U.logService.error(`[remote-connection][attempt ${B}] An error occurred in initial connection! Will retry... Error:`),U.logService.error(N);else throw U.logService.error(`[remote-connection][attempt ${B}]  An error occurred in initial connection! It will be treated as a permanent error. Error:`),U.logService.error(N),x.triggerPermanentFailure(0,0,b.$Yk.isHandled(N)),N}}async function p(U,P,F){const B=await o(U,(0,R.$ig)(),null);return await r(B,{host:P,port:F},L.CancellationToken.None)}e.$_k=p;function I(U){return(0,D.$Lg)(P=>new Promise((F,B)=>{const N=setTimeout(F,U*1e3);P.onCancellationRequested(()=>{clearTimeout(N),F()})}))}var T;(function(U){U[U.ConnectionLost=0]="ConnectionLost",U[U.ReconnectionWait=1]="ReconnectionWait",U[U.ReconnectionRunning=2]="ReconnectionRunning",U[U.ReconnectionPermanentFailure=3]="ReconnectionPermanentFailure",U[U.ConnectionGain=4]="ConnectionGain"})(T||(e.PersistentConnectionEventType=T={}));class M{constructor(P,F){this.reconnectionToken=P,this.millisSinceLastIncomingData=F,this.type=0}}e.$al=M;class z{constructor(P,F,B,N){this.reconnectionToken=P,this.millisSinceLastIncomingData=F,this.durationSeconds=B,this.c=N,this.type=1}skipWait(){this.c.cancel()}}e.$bl=z;class q{constructor(P,F,B){this.reconnectionToken=P,this.millisSinceLastIncomingData=F,this.attempt=B,this.type=2}}e.$cl=q;class Y{constructor(P,F,B){this.reconnectionToken=P,this.millisSinceLastIncomingData=F,this.attempt=B,this.type=4}}e.$dl=Y;class Q{constructor(P,F,B,N){this.reconnectionToken=P,this.millisSinceLastIncomingData=F,this.attempt=B,this.handled=N,this.type=3}}e.$el=Q;class x extends C.$Rc{static triggerPermanentFailure(P,F,B){this._permanentFailure=!0,this.f=P,this.g=F,this.h=B,this.j.forEach(N=>N.D(this.f,this.g,this.h))}static debugTriggerReconnection(){this.j.forEach(P=>P.y())}static debugPauseSocketWriting(){this.j.forEach(P=>P.F())}static{this._permanentFailure=!1}static{this.f=0}static{this.g=0}static{this.h=!1}static{this.j=[]}get n(){return this.c||x._permanentFailure}constructor(P,F,B,N,V){super(),this.t=P,this.u=F,this.reconnectionToken=B,this.protocol=N,this.w=V,this.m=this.B(new O.$Rd),this.onDidStateChange=this.m.event,this.c=!1,this.r=!1,this.s=!1,this.m.fire(new Y(this.reconnectionToken,0,0)),this.B(N.onSocketClose(G=>{const te=_(this.t,this.reconnectionToken,!0);G?G.type===0?(this.u.logService.info(`${te} received socket close event (hadError: ${G.hadError}).`),G.error&&this.u.logService.error(G.error)):(this.u.logService.info(`${te} received socket close event (wasClean: ${G.wasClean}, code: ${G.code}, reason: ${G.reason}).`),G.event&&this.u.logService.error(G.event)):this.u.logService.info(`${te} received socket close event.`),this.y()})),this.B(N.onSocketTimeout(G=>{const te=_(this.t,this.reconnectionToken,!0);this.u.logService.info(`${te} received socket timeout event (unacknowledgedMsgCount: ${G.unacknowledgedMsgCount}, timeSinceOldestUnacknowledgedMsg: ${G.timeSinceOldestUnacknowledgedMsg}, timeSinceLastReceivedSomeData: ${G.timeSinceLastReceivedSomeData}).`),this.y()})),x.j.push(this),this.B((0,C.$Pc)(()=>{const G=x.j.indexOf(this);G>=0&&x.j.splice(G,1)})),this.n&&this.D(x.f,x.g,x.h)}dispose(){super.dispose(),this.s=!0}async y(){if(!this.r)try{this.r=!0,await this.z()}finally{this.r=!1}}async z(){if(this.n||this.s)return;const P=_(this.t,this.reconnectionToken,!0);this.u.logService.info(`${P} starting reconnecting loop. You can get more information with the trace log level.`),this.m.fire(new M(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData()));const F=[0,5,5,10,10,10,10,10,30];let B=-1;do{B++;const N=B<F.length?F[B]:F[F.length-1];try{if(N>0){const G=I(N);this.m.fire(new z(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),N,G)),this.u.logService.info(`${P} waiting for ${N} seconds before reconnecting...`);try{await G}catch{}}if(this.n){this.u.logService.error(`${P} permanent failure occurred while running the reconnecting loop.`);break}this.m.fire(new q(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),B+1)),this.u.logService.info(`${P} resolving connection...`);const V=await o(this.u,this.reconnectionToken,this.protocol);this.u.logService.info(`${P} connecting to ${V.connectTo}...`),await this.G(V,c(g)),this.u.logService.info(`${P} reconnected!`),this.m.fire(new Y(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),B+1));break}catch(V){if(V.code==="VSCODE_CONNECTION_ERROR"){this.u.logService.error(`${P} A permanent error occurred in the reconnecting loop! Will give up now! Error:`),this.u.logService.error(V),this.C(this.protocol.getMillisSinceLastIncomingData(),B+1,!1);break}if(B>360){this.u.logService.error(`${P} An error occurred while reconnecting, but it will be treated as a permanent error because the reconnection grace time has expired! Will give up now! Error:`),this.u.logService.error(V),this.C(this.protocol.getMillisSinceLastIncomingData(),B+1,!1);break}if(b.$Yk.isTemporarilyNotAvailable(V)){this.u.logService.info(`${P} A temporarily not available error occurred while trying to reconnect, will try again...`),this.u.logService.trace(V);continue}if((V.code==="ETIMEDOUT"||V.code==="ENETUNREACH"||V.code==="ECONNREFUSED"||V.code==="ECONNRESET")&&V.syscall==="connect"){this.u.logService.info(`${P} A network error occurred while trying to reconnect, will try again...`),this.u.logService.trace(V);continue}if((0,j.$3)(V)){this.u.logService.info(`${P} A promise cancelation error occurred while trying to reconnect, will try again...`),this.u.logService.trace(V);continue}if(V instanceof b.$Yk){this.u.logService.error(`${P} A RemoteAuthorityResolverError occurred while trying to reconnect. Will give up now! Error:`),this.u.logService.error(V),this.C(this.protocol.getMillisSinceLastIncomingData(),B+1,b.$Yk.isHandled(V));break}this.u.logService.error(`${P} An unknown error occurred while trying to reconnect, since this is an unknown case, it will be treated as a permanent error! Will give up now! Error:`),this.u.logService.error(V),this.C(this.protocol.getMillisSinceLastIncomingData(),B+1,!1);break}}while(!this.n&&!this.s)}C(P,F,B){this.w?x.triggerPermanentFailure(P,F,B):this.D(P,F,B)}D(P,F,B){this.m.fire(new Q(this.reconnectionToken,P,F,B)),J(this.protocol)}F(){this.protocol.pauseSocketWriting()}}e.$fl=x;class H extends x{constructor(P,F,B,N,V){super(1,P,N,V,!0),this.client=this.B(new E.$Hh(V,{remoteAuthority:F,clientId:B},P.ipcLogger))}async G(P,F){await i(P,F)}}e.$gl=H;class Z extends x{constructor(P,F,B,N,V){super(2,P,B,N,!1),this.H=F,this.debugPort=V}async G(P,F){await t(P,this.H,F)}}e.$hl=Z;function J(U){try{U.acceptDisconnect();const P=U.getSocket();U.dispose(),P.dispose()}catch(P){(0,j.$Z)(P)}}function W(U){if(U&&U.type==="error"){const P=new Error(`Connection error: ${U.reason}`);return P.code="VSCODE_CONNECTION_ERROR",P}return null}function ee(U,P){for(;U.length<P;)U+=" ";return U}function ne(U,P){return`[remote-connection][${ee(w(U),13)}][${P.substr(0,5)}\u2026]`}function _(U,P,F){return`${ne(U,P)}[${F?"reconnect":"initial"}]`}function se(U,P){return`${_(P,U.reconnectionToken,!!U.reconnectionProtocol)}[${U.connectTo}]`}function K(U){return`${Date.now()-U} ms`}}),define(ae[104],ce([0,1,2,4]),function(ie,e,D,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7k=e.$6k=void 0,e.$6k=(0,A.$Vh)("remoteSocketFactoryService");class L{constructor(){this.a={}}register(O,C){return this.a[O]??=[],this.a[O].push(C),(0,D.$Pc)(()=>{const S=this.a[O]?.indexOf(C);typeof S=="number"&&S>=0&&this.a[O]?.splice(S,1)})}b(O){return(this.a[O.type]||[]).find(S=>S.supports(O))}connect(O,C,S,d){const R=this.b(O);if(!R)throw new Error(`No socket factory found for ${O}`);return R.connect(O,C,S,d)}}e.$7k=L}),define(ae[214],ce([0,1,4]),function(ie,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$x0b=e.$w0b=void 0,e.$w0b=(0,D.$Vh)("sharedProcessTunnelService"),e.$x0b="sharedProcessTunnel"}),define(ae[105],ce([0,1,4,163]),function(ie,e,D,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$H0b=e.$G0b=e.$F0b=e.$E0b=e.$D0b=e.TunnelStates=e.$C0b=e.$B0b=void 0,e.$B0b=(0,D.$Vh)("IRemoteTunnelService"),e.$C0b={active:!1};var L;(function(j){j.disconnected=O=>({type:"disconnected",onTokenFailed:O}),j.connected=(O,C)=>({type:"connected",info:O,serviceInstallFailed:C}),j.connecting=O=>({type:"connecting",progress:O}),j.uninitialized={type:"uninitialized"}})(L||(e.TunnelStates=L={})),e.$D0b="remote.tunnels.access",e.$E0b=e.$D0b+".hostNameOverride",e.$F0b=e.$D0b+".preventSleep",e.$G0b="remoteTunnelService",e.$H0b=(0,A.localize)(0,null)}),define(ae[58],ce([0,1,15,7,2,165,50,4,8,41]),function(ie,e,D,A,L,j,O,C,S,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6o=e.$5o=e.$4o=e.$3o=e.$2o=e.$1o=e.$Zo=e.$Yo=void 0,e.$Yo=(0,C.$Vh)("requestService");class R{constructor(k){this.b=k}toJSON(){if(!this.a){const k=Object.create(null);for(const s in this.b)s.toLowerCase()==="authorization"||s.toLowerCase()==="proxy-authorization"?k[s]="*****":k[s]=this.b[s];this.a=k}return this.a}}class E extends L.$Rc{constructor(k){super(),this.b=0,this.a=k.createLogger("network",{name:(0,j.localize)(0,null),when:S.$uj.isEqualTo((0,S.$sj)(S.LogLevel.Trace)).serialize()})}async c(k,s,a){const n=`${k} #${++this.b}: ${s.url}`;this.a.trace(`${n} - begin`,s.type,new R(s.headers??{}));try{const i=await a();return this.a.trace(`${n} - end`,s.type,i.res.statusCode,i.res.headers),i}catch(i){throw this.a.error(`${n} - error`,s.type,(0,A.$9)(i)),i}}}e.$Zo=E;function b(m){return m.res.statusCode&&m.res.statusCode>=200&&m.res.statusCode<300||m.res.statusCode===1223}e.$1o=b;function l(m){return m.res.statusCode===204}e.$2o=l;async function g(m){return l(m)?null:(await(0,D.$re)(m.stream)).toString()}e.$3o=g;async function y(m){if(!b(m))throw new Error("Server returned "+m.res.statusCode);return g(m)}e.$4o=y;async function w(m){if(!b(m))throw new Error("Server returned "+m.res.statusCode);if(l(m))return null;const s=(await(0,D.$re)(m.stream)).toString();try{return JSON.parse(s)}catch(a){throw a.message+=`:
`+s,a}}e.$5o=w;function c(m){h(m)}e.$6o=c;let u;function h(m){const k=d.$mn.as(O.$rn.Configuration),s=u;u={id:"http",order:15,title:(0,j.localize)(1,null),type:"object",scope:m,properties:{"http.proxy":{type:"string",pattern:"^(https?|socks|socks4a?|socks5h?)://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,j.localize)(2,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,j.localize)(3,null),restricted:!0},"http.proxyKerberosServicePrincipal":{type:"string",markdownDescription:(0,j.localize)(4,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,j.localize)(5,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,j.localize)(6,null),(0,j.localize)(7,null),(0,j.localize)(8,null),(0,j.localize)(9,null)],default:"override",description:(0,j.localize)(10,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,j.localize)(11,null),restricted:!0},"http.experimental.systemCertificatesV2":{type:"boolean",tags:["experimental"],default:!1,description:(0,j.localize)(12,null),restricted:!0}}},k.updateConfigurations({add:[u],remove:s?[s]:[]})}h(1)}),define(ae[215],ce([0,1,26,23,11,58]),function(ie,e,D,A,L,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_N=void 0;let O=class{constructor(S,d){this.a=S,this.b=d}async download(S,d,R=D.CancellationToken.None){if(S.scheme===A.Schemas.file||S.scheme===A.Schemas.vscodeRemote){await this.b.copy(S,d);return}const E={type:"GET",url:S.toString(!0)},b=await this.a.request(E,R);if(b.res.statusCode===200)await this.b.writeFile(d,b.stream);else{const l=await(0,j.$4o)(b);throw new Error(`Expected 200, got back ${b.res.statusCode} instead.

${l}`)}}};e.$_N=O,e.$_N=O=pe([X(0,j.$Yo),X(1,L.$ek)],O)}),define(ae[216],ce([0,1,15,26]),function(ie,e,D,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3q=e.$2q=void 0;class L{constructor(C){this.a=C}listen(C,S){throw new Error("Invalid listen")}call(C,S,d,R=A.CancellationToken.None){switch(S){case"request":return this.a.request(d[0],R).then(async({res:E,stream:b})=>{const l=await(0,D.$re)(b);return[{statusCode:E.statusCode,headers:E.headers},l]});case"resolveProxy":return this.a.resolveProxy(d[0]);case"loadCertificates":return this.a.loadCertificates()}throw new Error("Invalid call")}}e.$2q=L;class j{constructor(C){this.a=C}async request(C,S){const[d,R]=await this.a.call("request",[C],S);return{res:d,stream:(0,D.$te)(R)}}async resolveProxy(C){return this.a.call("resolveProxy",[C])}async loadCertificates(){return this.a.call("loadCertificates")}}e.$3q=j}),define(ae[217],ce([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$28b=e.$18b=e.$Z8b=void 0,e.$Z8b={exit:"vscode:electron-main->shared-process=exit",ipcReady:"vscode:shared-process->electron-main=ipc-ready",initDone:"vscode:shared-process->electron-main=init-done"},e.$18b={request:"vscode:createSharedProcessChannelConnection",response:"vscode:createSharedProcessChannelConnectionResult"},e.$28b={request:"vscode:createSharedProcessRawConnection",response:"vscode:createSharedProcessRawConnectionResult"}}),define(ae[218],ce([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$V4b=void 0;class D{constructor(){this.b=new Map}static{this.a=1}async createNewMessage(L){try{const j=await this.c();if(j){const O=String(D.a++);return this.b.set(O,j),{id:O,data:j.createNewMessage(L)}}}catch{}return{id:"",data:L}}async validate(L,j){if(!L.id)return!0;const O=this.b.get(L.id);if(!O)return!1;this.b.delete(L.id);try{return O.validate(j)==="ok"}catch{return!1}finally{O.dispose?.()}}async sign(L){try{return await this.d(L)}catch{}return L}}e.$V4b=D}),define(ae[106],ce([0,1,4]),function(ie,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9k=e.$8k=void 0,e.$8k="signService",e.$9k=(0,D.$Vh)(e.$8k)}),define(ae[219],ce([0,1,218]),function(ie,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$P9b=void 0;class A extends D.$V4b{c(){return this.h().then(j=>new j.validator)}d(j){return this.h().then(O=>new O.signer().sign(j))}h(){return new Promise((j,O)=>ie(["vsda"],j,O))}}e.$P9b=A}),define(ae[76],ce([0,1,3,2]),function(ie,e,D,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dEb=e.$cEb=e.$bEb=e.$aEb=void 0;class L extends A.$Rc{constructor(E,b,l){super(),this.a=E,this.b=b,this.c=l}async getItems(){const E={profile:this.b,workspace:this.c},b=await this.a.call("getItems",E);return new Map(b)}updateItems(E){const b={profile:this.b,workspace:this.c};return E.insert&&(b.insert=Array.from(E.insert.entries())),E.delete&&(b.delete=Array.from(E.delete.values())),this.a.call("updateItems",b)}optimize(){const E={profile:this.b,workspace:this.c};return this.a.call("optimize",E)}}class j extends L{constructor(E,b){super(E,b,void 0),this.f=this.B(new D.$Rd),this.onDidChangeItemsExternal=this.f.event,this.g()}g(){this.B(this.a.listen("onDidChangeStorage",{profile:this.b})(E=>this.h(E)))}h(E){(Array.isArray(E.changed)||Array.isArray(E.deleted))&&this.f.fire({changed:E.changed?new Map(E.changed):void 0,deleted:E.deleted?new Set(E.deleted):void 0})}}class O extends j{constructor(E){super(E,void 0)}async close(){this.dispose()}}e.$aEb=O;class C extends j{constructor(E,b){super(E,b)}async close(){this.dispose()}}e.$bEb=C;class S extends L{constructor(E,b){super(E,void 0,b),this.onDidChangeItemsExternal=D.Event.None}async close(){this.dispose()}}e.$cEb=S;class d{constructor(E){this.a=E}isUsed(E){const b={payload:E,profile:void 0,workspace:void 0};return this.a.call("isUsed",b)}}e.$dEb=d}),define(ae[107],ce([0,1,5,37,32]),function(ie,e,D,A,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$oo=e.$no=void 0;function j(S){if(D.$u===2&&/^penguin(\.|$)/i.test(S))return"chromebook"}function O(S,d,R,E,b,l,g,y,w){const c=Object.create(null);c["common.machineId"]=l,c["common.sqmId"]=g,c.sessionID=(0,L.$ig)()+Date.now(),c.commitHash=E,c.version=b,c["common.platformVersion"]=(S||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),c["common.platform"]=(0,D.$h)(D.$u),c["common.nodePlatform"]=A.$cc,c["common.nodeArch"]=R,c["common.product"]=w||"desktop",y&&(c["common.msftInternal"]=y);let u=0;const h=Date.now();Object.defineProperties(c,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-h,enumerable:!0},"common.sequence":{get:()=>u++,enumerable:!0}}),D.$l&&(c["common.snap"]="true");const m=j(d);return m&&(c["common.platformDetail"]=m),c}e.$no=O;function C(S){const d=A.env.USERDNSDOMAIN;if(!d)return!1;const R=d.toLowerCase();return S.some(E=>R===E)}e.$oo=C}),define(ae[22],ce([0,1,4]),function(ie,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.$sl=e.$rl=e.$ql=e.$pl=e.$ol=e.$nl=e.$ml=e.$ll=e.$kl=e.$jl=e.$il=void 0,e.$il=(0,D.$Vh)("telemetryService"),e.$jl=(0,D.$Vh)("customEndpointTelemetryService"),e.$kl="telemetry.currentSessionDate",e.$ll="telemetry.firstSessionDate",e.$ml="telemetry.lastSessionDate",e.$nl="telemetry.machineId",e.$ol="telemetry.sqmId",e.$pl="telemetry",e.$ql="telemetry.telemetryLevel",e.$rl="telemetry.enableCrashReporter",e.$sl="telemetry.enableTelemetry";var A;(function(j){j[j.NONE=0]="NONE",j[j.CRASH=1]="CRASH",j[j.ERROR=2]="ERROR",j[j.USAGE=3]="USAGE"})(A||(e.TelemetryLevel=A={}));var L;(function(j){j.OFF="off",j.CRASH="crash",j.ERROR="error",j.ON="all"})(L||(e.TelemetryConfiguration=L={}))}),define(ae[220],ce([0,1,36,6,35,23,16,5,10,142,31,145,95,11,25,22]),function(ie,e,D,A,L,j,O,C,S,d,R,E,b,l,g,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mr=e.$Lr=e.$Kr=e.$Jr=void 0;const w=new Map;async function c(s,a){const n=`${s}::${a.join(":")}`,i=w.get(n);if(i)return i;const t=[{tag:"grunt.js",filePattern:/^gruntfile\.js$/i},{tag:"gulp.js",filePattern:/^gulpfile\.js$/i},{tag:"tsconfig.json",filePattern:/^tsconfig\.json$/i},{tag:"package.json",filePattern:/^package\.json$/i},{tag:"jsconfig.json",filePattern:/^jsconfig\.json$/i},{tag:"tslint.json",filePattern:/^tslint\.json$/i},{tag:"eslint.json",filePattern:/^eslint\.json$/i},{tag:"tasks.json",filePattern:/^tasks\.json$/i},{tag:"launch.json",filePattern:/^launch\.json$/i},{tag:"settings.json",filePattern:/^settings\.json$/i},{tag:"webpack.config.js",filePattern:/^webpack\.config\.js$/i},{tag:"project.json",filePattern:/^project\.json$/i},{tag:"makefile",filePattern:/^makefile$/i},{tag:"sln",filePattern:/^.+\.sln$/i},{tag:"csproj",filePattern:/^.+\.csproj$/i},{tag:"cmake",filePattern:/^.+\.cmake$/i},{tag:"github-actions",filePattern:/^.+\.ya?ml$/i,relativePathPattern:/^\.github(?:\/|\\)workflows$/i},{tag:"devcontainer.json",filePattern:/^devcontainer\.json$/i},{tag:"dockerfile",filePattern:/^(dockerfile|docker\-compose\.ya?ml)$/i}],r=new Map,o=new Map,v=2e4;function $(p,I,T,M){const z=I.substring(p.length+1);return A.Promises.withAsyncBody(async q=>{let Y;try{Y=await R.Promises.readdir(I,{withFileTypes:!0})}catch{q();return}if(M.count>=v){M.count+=Y.length,M.maxReached=!0,q();return}let Q=Y.length;if(Q===0){q();return}let x=Y;M.count+Y.length>v&&(M.maxReached=!0,Q=v-M.count,x=Y.slice(0,Q)),M.count+=Y.length;for(const H of x)if(H.isDirectory()){if(T.includes(H.name)||await $(p,(0,O.$ic)(I,H.name),T,M),--Q===0){q();return}}else{const Z=H.name.lastIndexOf(".");if(Z>=0){const J=H.name.substring(Z+1);J&&r.set(J,(r.get(J)??0)+1)}for(const J of t)J.relativePathPattern?.test(z)!==!1&&J.filePattern.test(H.name)&&o.set(J.tag,(o.get(J.tag)??0)+1);if(--Q===0){q();return}}})}const f=A.Promises.withAsyncBody(async p=>{const I={count:0,maxReached:!1};await $(s,s,a,I);const T=await m(s);p({configFiles:u(o),fileTypes:u(r),fileCount:I.count,maxFilesReached:I.maxReached,launchConfigFiles:T})});return w.set(n,f),f}e.$Jr=c;function u(s){return Array.from(s.entries(),([a,n])=>({name:a,count:n})).sort((a,n)=>n.count-a.count)}function h(){const s={os:`${D.type()} ${D.arch()} ${D.release()}`,memory:`${(D.totalmem()/l.$Mk.GB).toFixed(2)}GB (${(D.freemem()/l.$Mk.GB).toFixed(2)}GB free)`,vmHint:`${Math.round(d.$Xm.value()*100)}%`},a=D.cpus();return a&&a.length>0&&(s.cpus=`${a[0].model} (${a.length} x ${a[0].speed})`),s}e.$Kr=h;async function m(s){try{const a=new Map,n=(0,O.$ic)(s,".vscode","launch.json"),i=await R.Promises.readFile(n),t=[],r=(0,L.$3m)(i.toString(),t);if(t.length)return console.log(`Unable to parse ${n}`),[];if((0,L.$_m)(r)==="object"&&r.configurations)for(const o of r.configurations){const v=o.type;v&&(a.has(v)?a.set(v,a.get(v)+1):a.set(v,1))}return u(a)}catch{return[]}}e.$Lr=m;let k=class{constructor(a,n){this.c=a,this.d=n}f(a){const n=[];return n.push(`OS Version:       ${a.os}`),n.push(`CPUs:             ${a.cpus}`),n.push(`Memory (System):  ${a.memory}`),n.push(`VM:               ${a.vmHint}`),n.join(`
`)}g(a){const n=[];n.push(`Version:          ${this.d.nameShort} ${this.d.version} (${this.d.commit||"Commit unknown"}, ${this.d.date||"Date unknown"})`),n.push(`OS Version:       ${D.type()} ${D.arch()} ${D.release()}`);const i=D.cpus();return i&&i.length>0&&n.push(`CPUs:             ${i[0].model} (${i.length} x ${i[0].speed})`),n.push(`Memory (System):  ${(D.totalmem()/l.$Mk.GB).toFixed(2)}GB (${(D.freemem()/l.$Mk.GB).toFixed(2)}GB free)`),C.$i||n.push(`Load (avg):       ${D.loadavg().map(t=>Math.round(t)).join(", ")}`),n.push(`VM:               ${Math.round(d.$Xm.value()*100)}%`),n.push(`Screen Reader:    ${a.screenReader?"yes":"no"}`),n.push(`Process Argv:     ${a.mainArguments.join(" ")}`),n.push(`GPU Status:       ${this.j(a.gpuFeatureStatus)}`),n.join(`
`)}async getPerformanceInfo(a,n){return Promise.all([(0,E.$Ir)(a.mainPID),this.k(a)]).then(async i=>{let[t,r]=i,o=this.m(a,t);return n.forEach(v=>{if((0,b.$xm)(v))o+=`
${v.errorMessage}`,r+=`
${v.errorMessage}`;else if(o+=`

Remote: ${v.hostName}`,v.processes&&(o+=`
${this.m(a,v.processes)}`),v.workspaceMetadata){r+=`
|  Remote: ${v.hostName}`;for(const $ of Object.keys(v.workspaceMetadata)){const f=v.workspaceMetadata[$];let p=`${f.fileCount} files`;f.maxFilesReached&&(p=`more than ${p}`),r+=`|    Folder (${$}): ${p}`,r+=this.h(f)}}}),{processInfo:o,workspaceInfo:r}})}async getSystemInfo(a,n){const{memory:i,vmHint:t,os:r,cpus:o}=h(),v={os:r,memory:i,cpus:o,vmHint:t,processArgs:`${a.mainArguments.join(" ")}`,gpuStatus:a.gpuFeatureStatus,screenReader:`${a.screenReader?"yes":"no"}`,remoteData:n};return C.$i||(v.load=`${D.loadavg().map($=>Math.round($)).join(", ")}`),C.$k&&(v.linuxEnv={desktopSession:process.env.DESKTOP_SESSION,xdgSessionDesktop:process.env.XDG_SESSION_DESKTOP,xdgCurrentDesktop:process.env.XDG_CURRENT_DESKTOP,xdgSessionType:process.env.XDG_SESSION_TYPE}),Promise.resolve(v)}async getDiagnostics(a,n){const i=[];return(0,E.$Ir)(a.mainPID).then(async t=>(i.push(""),i.push(this.g(a)),i.push(""),i.push(this.m(a,t)),a.windows.some(r=>r.folderURIs&&r.folderURIs.length>0&&!r.remoteAuthority)&&(i.push(""),i.push("Workspace Stats: "),i.push(await this.k(a))),n.forEach(r=>{if((0,b.$xm)(r))i.push(`
${r.errorMessage}`);else if(i.push(`

`),i.push(`Remote:           ${r.hostName}`),i.push(this.f(r.machineInfo)),r.processes&&i.push(this.m(a,r.processes)),r.workspaceMetadata)for(const o of Object.keys(r.workspaceMetadata)){const v=r.workspaceMetadata[o];let $=`${v.fileCount} files`;v.maxFilesReached&&($=`more than ${$}`),i.push(`Folder (${o}): ${$}`),i.push(this.h(v))}}),i.push(""),i.push(""),i.join(`
`)))}h(a){const n=[];let t=0;const r=(f,p)=>{const I=` ${f}(${p})`;t+I.length>60?(n.push(o),o="|                 ",t=o.length):t+=I.length,o+=I};let o="|      File types:";const v=10,$=a.fileTypes.length>v?v:a.fileTypes.length;for(let f=0;f<$;f++){const p=a.fileTypes[f];r(p.name,p.count)}if(n.push(o),a.configFiles.length>=0&&(o="|      Conf files:",t=0,a.configFiles.forEach(f=>{r(f.name,f.count)}),n.push(o)),a.launchConfigFiles.length>0){let f="|      Launch Configs:";a.launchConfigFiles.forEach(p=>{const I=p.count>1?` ${p.name}(${p.count})`:` ${p.name}`;f+=I}),n.push(f)}return n.join(`
`)}j(a){const n=Math.max(...Object.keys(a).map(i=>i.length));return Object.keys(a).map(i=>`${i}:  ${" ".repeat(n-i.length)}  ${a[i]}`).join(`
                  `)}k(a){const n=[],i=[];return a.windows.forEach(t=>{t.folderURIs.length===0||t.remoteAuthority||(n.push(`|  Window (${t.title})`),t.folderURIs.forEach(r=>{const o=S.URI.revive(r);if(o.scheme===j.Schemas.file){const v=o.fsPath;i.push(c(v,["node_modules",".git"]).then($=>{let f=`${$.fileCount} files`;$.maxFilesReached&&(f=`more than ${f}`),n.push(`|    Folder (${(0,O.$mc)(v)}): ${f}`),n.push(this.h($))}).catch($=>{n.push(`|      Error: Unable to collect workspace stats for folder ${v} (${$.toString()})`)}))}else n.push(`|    Folder (${o.toString()}): Workspace stats not available.`)}))}),Promise.all(i).then(t=>n.join(`
`)).catch(t=>`Unable to collect workspace stats: ${t}`)}m(a,n){const i=new Map;a.windows.forEach(r=>i.set(r.pid,`window [${r.id}] (${r.title})`)),a.pidToNames.forEach(({pid:r,name:o})=>i.set(r,o));const t=[];return t.push("CPU %	Mem MB	   PID	Process"),n&&this.n(a.mainPID,i,t,n,0),t.join(`
`)}n(a,n,i,t,r){const o=r===0;let v;o?v=t.pid===a?`${this.d.applicationName} main`:"remote agent":n.has(t.pid)?v=n.get(t.pid):v=`${"  ".repeat(r)} ${t.name}`;const $=process.platform==="win32"?t.mem:D.totalmem()*(t.mem/100);i.push(`${t.load.toFixed(0).padStart(5," ")}	${($/l.$Mk.MB).toFixed(0).padStart(6," ")}	${t.pid.toFixed(0).padStart(6," ")}	${v}`),Array.isArray(t.children)&&t.children.forEach(f=>this.n(a,n,i,f,r+1))}async getWorkspaceFileExtensions(a){const n=new Set;for(const{uri:i}of a.folders){const t=S.URI.revive(i);if(t.scheme!==j.Schemas.file)continue;const r=t.fsPath;try{(await c(r,["node_modules",".git"])).fileTypes.forEach(v=>n.add(v.name))}catch{}}return{extensions:[...n]}}async reportWorkspaceStats(a){for(const{uri:n}of a.folders){const i=S.URI.revive(n);if(i.scheme!==j.Schemas.file)continue;const t=i.fsPath;try{const r=await c(t,["node_modules",".git"]);this.c.publicLog2("workspace.stats",{"workspace.id":a.telemetryId,rendererSessionId:a.rendererSessionId}),r.fileTypes.forEach(o=>{this.c.publicLog2("workspace.stats.file",{rendererSessionId:a.rendererSessionId,type:o.name,count:o.count})}),r.launchConfigFiles.forEach(o=>{this.c.publicLog2("workspace.stats.launchConfigFile",{rendererSessionId:a.rendererSessionId,type:o.name,count:o.count})}),r.configFiles.forEach(o=>{this.c.publicLog2("workspace.stats.configFiles",{rendererSessionId:a.rendererSessionId,type:o.name,count:o.count})})}catch{}}}};e.$Mr=k,e.$Mr=k=pe([X(0,y.$il),X(1,g.$vj)],k)}),define(ae[108],ce([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$68b=e.$58b=void 0;class D{constructor(j){this.b=j}listen(j,O){throw new Error(`Event not found: ${O}`)}call(j,O,{eventName:C,data:S}){return this.b.forEach(d=>d.log(C,S)),Promise.resolve(null)}}e.$58b=D;class A{constructor(j){this.b=j}log(j,O){return this.b.call("log",{eventName:j,data:O}).then(void 0,C=>`Failed to log telemetry: ${console.warn(C)}`),Promise.resolve(null)}flush(){return Promise.resolve()}}e.$68b=A}),define(ae[45],ce([0,1,30,12,3,20,75,107,22]),function(ie,e,D,A,L,j,O,C,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Eo=e.$Do=e.$Co=e.$Bo=e.$Ao=e.$zo=e.$yo=e.$xo=e.$wo=e.$vo=e.$uo=e.$to=e.$so=e.$ro=e.$qo=e.$po=void 0;class d{constructor(t){this.value=t,this.isTrustedTelemetryValue=!0}}e.$po=d;class R{constructor(){this.telemetryLevel=0,this.sessionId="someValue.sessionId",this.machineId="someValue.machineId",this.firstSessionDate="someValue.firstSessionDate",this.sendErrorTelemetry=!1}publicLog(){}publicLog2(){}publicLogError(){}publicLogError2(){}setExperimentProperty(){}}e.$qo=R,e.$ro=new R;class E{async publicLog(t,r,o){}async publicLogError(t,r,o){}}e.$so=E,e.$to="telemetry",e.$uo="extensionTelemetryLog",e.$vo={log:()=>null,flush:()=>Promise.resolve(null)};function b(i,t){return L.Event.debounce(t.onDidChangeConfiguration,(o,v)=>{const $=o?new Set([...o.affectedKeys,...v.affectedKeys]):v.affectedKeys;return{...v,affectedKeys:$}},1e3,!0)(o=>{o.source!==7&&i.publicLog2("updateConfiguration",{configurationSource:(0,j.$si)(o.source),configurationKeys:Array.from(o.affectedKeys)})})}e.$wo=b;function l(i,t){return!t.isBuilt&&!t.disableTelemetry?!0:!(t.disableTelemetry||!i.enableTelemetry)}e.$xo=l;function g(i,t){return t.extensionTestsLocationURI?!0:!(t.isBuilt||t.disableTelemetry||i.enableTelemetry&&i.aiConfig?.ariaKey)}e.$yo=g;function y(i){const t=i.getValue(S.$ql),r=i.getValue(S.$rl);if(i.getValue(S.$sl)===!1||r===!1)return 0;switch(t??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}e.$zo=y;function w(i){const t={},r={},o={};h(i,o);for(let v in o){v=v.length>150?v.substr(v.length-149):v;const $=o[v];typeof $=="number"?r[v]=$:typeof $=="boolean"?r[v]=$?1:0:typeof $=="string"?($.length>8192&&console.warn(`Telemetry property: ${v} has been trimmed to 8192, the original length is ${$.length}`),t[v]=$.substring(0,8191)):typeof $<"u"&&$!==null&&(t[v]=$)}return{properties:t,measurements:r}}e.$Ao=w;const c=new Set(["ssh-remote","dev-container","attached-container","wsl","tunnel","codespaces","amlext"]);function u(i){if(!i)return"none";const t=(0,O.$2k)(i);return c.has(t)?t:"other"}e.$Bo=u;function h(i,t,r=0,o){if(i)for(const v of Object.getOwnPropertyNames(i)){const $=i[v],f=o?o+v:v;Array.isArray($)?t[f]=(0,D.$fn)($):$ instanceof Date?t[f]=$.toISOString():(0,A.$Ef)($)?r<2?h($,t,r+1,f+"."):t[f]=(0,D.$fn)($):t[f]=$}}function m(i,t){const r=i.msftInternalDomains||[],o=t.getValue("telemetry.internalTesting");return(0,C.$oo)(r)||o}e.$Co=m;function k(i){return[i.appRoot,i.extensionsPath,i.userHome.fsPath,i.tmpDir.fsPath,i.userDataPath]}e.$Do=k;function s(i,t){if(!i||!i.includes("/")&&!i.includes("\\"))return i;let r=i;const o=[];for(const p of t)for(;;){const I=p.exec(i);if(!I)break;o.push([I.index,p.lastIndex])}const v=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,$=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let f=0;for(r="";;){const p=$.exec(i);if(!p)break;const I=o.some(([T,M])=>p.index<M&&T<$.lastIndex);!v.test(p[0])&&!I&&(r+=i.substring(f,p.index)+"<REDACTED: user-file-path>",f=$.lastIndex)}return f<i.length&&(r+=i.substr(f)),r}function a(i){if(!i)return i;const t=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/i},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const r of t)if(r.regex.test(i))return`<REDACTED: ${r.label}>`;return i}function n(i,t){return(0,D.$cn)(i,r=>{if(r instanceof d||Object.hasOwnProperty.call(r,"isTrustedTelemetryValue"))return r.value;if(typeof r=="string"){let o=r.replaceAll("%20"," ");o=s(o,t);for(const v of t)o=o.replace(v,"");return o=a(o),o}})}e.$Eo=n}),define(ae[33],ce([0,1,27,29,44,5,10,7,37,45]),function(ie,e,D,A,L,j,O,C,S,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qo=e.$Po=e.$Oo=e.$No=e.$Mo=e.$Lo=e.$Ko=e.$Jo=e.$Io=e.$Ho=e.$Go=e.$Fo=void 0;function R(n,i){return n.uuid&&i.uuid?n.uuid===i.uuid:n.id===i.id?!0:(0,D.$1e)(n.id,i.id)===0}e.$Fo=R;const E=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class b{static create(i){const t=i.manifest?i.manifest.version:i.version,r=i.manifest?i.targetPlatform:i.properties.targetPlatform;return new b(i.identifier,t,r)}static parse(i){const t=E.exec(i);return t&&t[1]&&t[2]?new b({id:t[1]},t[2],t[4]||void 0):null}constructor(i,t,r="undefined"){this.version=t,this.targetPlatform=r,this.id=i.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals(i){return i instanceof b?R(this,i)&&this.version===i.version&&this.targetPlatform===i.targetPlatform:!1}}e.$Go=b;const l=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function g(n){const i=l.exec(n);return i&&i[1]?[w(i[1]),i[2]]:[w(n),void 0]}e.$Ho=g;function y(n,i){return`${n}.${i}`}e.$Io=y;function w(n){return n.toLowerCase()}e.$Jo=w;function c(n,i){return w(y(n??L.$8l,i))}e.$Ko=c;function u(n,i){const t=[],r=o=>{for(const v of t)if(v.some($=>R(i($),i(o))))return v;return null};for(const o of n){const v=r(o);v?v.push(o):t.push([o])}return t}e.$Lo=u;function h(n){return{id:n.identifier.id,name:n.manifest.name,galleryId:null,publisherId:n.publisherId,publisherName:n.manifest.publisher,publisherDisplayName:n.publisherDisplayName,dependencies:n.manifest.extensionDependencies&&n.manifest.extensionDependencies.length>0}}e.$Mo=h;function m(n){return{id:new d.$po(n.identifier.id),name:new d.$po(n.name),galleryId:n.identifier.uuid,publisherId:n.publisherId,publisherName:n.publisher,publisherDisplayName:n.publisherDisplayName,isPreReleaseVersion:n.properties.isPreReleaseVersion,dependencies:!!(n.properties.dependencies&&n.properties.dependencies.length>0),isSigned:n.isSigned,...n.telemetryData}}e.$No=m,e.$Oo=new L.$_l("pprice.better-merge");function k(n,i){const t=[],r=i.manifest.extensionDependencies?.slice(0)??[];for(;r.length;){const o=r.shift();if(o&&t.every(v=>!R(v.identifier,{id:o}))){const v=n.filter($=>R($.identifier,{id:o}));v.length===1&&(t.push(v[0]),r.push(...v[0].manifest.extensionDependencies?.slice(0)??[]))}}return t}e.$Po=k;async function s(n,i){if(!j.$k)return!1;let t;try{t=(await n.readFile(O.URI.file("/etc/os-release"))).value.toString()}catch{try{t=(await n.readFile(O.URI.file("/usr/lib/os-release"))).value.toString()}catch(o){i.debug("Error while getting the os-release file.",(0,C.$9)(o))}}return!!t&&(t.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}async function a(n,i){const t=await s(n,i),r=(0,A.$_n)(t?"alpine":j.$u,S.$dc);return i.debug("ComputeTargetPlatform:",r),r}e.$Qo=a}),define(ae[221],ce([0,1,18,2,19,10,11,25,6,3,16,5,37,33]),function(ie,e,D,A,L,j,O,C,S,d,R,E,b,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$16b=e.$Z6b=void 0;let g=class extends A.$Rc{constructor(h,m){super(),this.b=h,this.c=m,this.a=new Map,this.c.configBasedExtensionTips&&Object.entries(this.c.configBasedExtensionTips).forEach(([,k])=>this.a.set(k.configPath,k))}getConfigBasedTips(h){return this.f(h)}async getImportantExecutableBasedTips(){return[]}async getOtherExecutableBasedTips(){return[]}async f(h){const m=[];for(const[k,s]of this.a)if(!(s.configScheme&&s.configScheme!==h.scheme))try{const a=(await this.b.readFile((0,L.$zg)(h,k))).value.toString();for(const[n,i]of Object.entries(s.recommendations))(!i.contentPattern||new RegExp(i.contentPattern,"mig").test(a))&&m.push({extensionId:n,extensionName:i.name,configName:s.configName,important:!!i.important,isExtensionPack:!!i.isExtensionPack,whenNotInstalled:i.whenNotInstalled})}catch{}return m}};e.$Z6b=g,e.$Z6b=g=pe([X(0,O.$ek),X(1,C.$vj)],g);const y="extensionTips/promptedExecutableTips",w="extensionTips/lastPromptedMediumImpExeTime";class c extends g{constructor(h,m,k,s,a,n,i,t){super(i,t),this.r=h,this.s=m,this.t=k,this.u=s,this.w=a,this.z=n,this.g=new Map,this.h=new Map,this.j=new Map,this.m=new Map,this.n=new Map,t.exeBasedExtensionTips&&Object.entries(t.exeBasedExtensionTips).forEach(([r,o])=>{const v=[],$=[],f=[];Object.entries(o.recommendations).forEach(([p,I])=>{I.important?o.important?v.push({extensionId:p,extensionName:I.name,isExtensionPack:!!I.isExtensionPack}):$.push({extensionId:p,extensionName:I.name,isExtensionPack:!!I.isExtensionPack}):f.push({extensionId:p,extensionName:I.name,isExtensionPack:!!I.isExtensionPack})}),v.length&&this.g.set(r,{exeFriendlyName:o.friendlyName,windowsPath:o.windowsPath,recommendations:v}),$.length&&this.h.set(r,{exeFriendlyName:o.friendlyName,windowsPath:o.windowsPath,recommendations:$}),f.length&&this.j.set(r,{exeFriendlyName:o.friendlyName,windowsPath:o.windowsPath,recommendations:f})}),(0,S.$Zg)(async()=>{await this.C(),this.F(),this.G()},3e3,this.q)}async getImportantExecutableBasedTips(){const h=await this.O(this.g),m=await this.O(this.h);return[...h,...m]}getOtherExecutableBasedTips(){return this.O(this.j)}async C(){const h=await this.O(this.g),m=await this.O(this.h),k=await this.u.getInstalled();this.m=this.D(h,k),this.n=this.D(m,k)}D(h,m){const k=new Map;h.forEach(t=>k.set(t.extensionId.toLowerCase(),t));const{installed:s,uninstalled:a}=this.N([...k.keys()],m);for(const t of s){const r=k.get(t);r&&this.t.publicLog2("exeExtensionRecommendations:alreadyInstalled",{extensionId:t,exeName:r.exeName})}for(const t of a){const r=k.get(t);r&&this.t.publicLog2("exeExtensionRecommendations:notInstalled",{extensionId:t,exeName:r.exeName})}const n=this.L(),i=new Map;for(const t of a){const r=k.get(t);if(r&&(!n[r.exeName]||!n[r.exeName].includes(r.extensionId))){let o=i.get(r.exeName);o||(o=[],i.set(r.exeName,o)),o.push(r)}}return i}F(){if(this.m.size===0)return;const[h,m]=[...this.m.entries()][0];this.H(m).then(k=>{switch(k){case"reacted":this.M(m[0].exeName,m);break;case"ignored":this.m.delete(h);break;case"incompatibleWindow":{const s=d.Event.once(d.Event.latch(d.Event.any(this.s.onDidOpenMainWindow,this.s.onDidFocusMainWindow)));this.B(s(()=>this.F()));break}case"toomany":{const s=this.B(new A.$Sc);s.value=(0,S.$Zg)(()=>{s.dispose(),this.F()},60*60*1e3);break}}})}G(){if(this.n.size===0)return;const h=this.I(),m=Date.now()-h,k=7*24*60*60*1e3;if(m<k){const n=this.B(new A.$Sc);n.value=(0,S.$Zg)(()=>{n.dispose(),this.G()},k-m);return}const[s,a]=[...this.n.entries()][0];this.H(a).then(n=>{switch(n){case"reacted":{this.J(Date.now()),this.n.delete(s),this.M(a[0].exeName,a);const i=this.B(new A.$Sc);i.value=(0,S.$Zg)(()=>{i.dispose(),this.G()},k);break}case"ignored":this.n.delete(s),this.G();break;case"incompatibleWindow":{const i=d.Event.once(d.Event.latch(d.Event.any(this.s.onDidOpenMainWindow,this.s.onDidFocusMainWindow)));this.B(i(()=>this.G()));break}case"toomany":{const i=this.B(new A.$Sc);i.value=(0,S.$Zg)(()=>{i.dispose(),this.G()},60*60*1e3);break}}})}async H(h){const m=await this.u.getInstalled(1),k=h.filter(s=>!s.whenNotInstalled||s.whenNotInstalled.every(a=>m.every(n=>!(0,l.$Fo)(n.identifier,{id:a})))).map(({extensionId:s})=>s.toLowerCase());return this.z.promptImportantExtensionsInstallNotification({extensions:k,source:3,name:h[0].exeFriendlyName,searchValue:`@exe:"${h[0].exeName}"`})}I(){let h=this.w.getNumber(w,-1);return h||(h=Date.now(),this.J(h)),h}J(h){this.w.store(w,h,-1,1)}L(){return JSON.parse(this.w.get(y,-1,"{}"))}M(h,m){const k=this.L();k[h]=m.map(({extensionId:s})=>s.toLowerCase()),this.w.store(y,JSON.stringify(k),-1,0)}N(h,m){const k=[],s=[],a=m.reduce((n,i)=>(n.add(i.identifier.id.toLowerCase()),n),new Set);return h.forEach(n=>{a.has(n.toLowerCase())?k.push(n):s.push(n)}),{installed:k,uninstalled:s}}async O(h){const m=[],k=new Map;for(const s of h.keys()){const a=h.get(s);if(!a||!(0,D.$Kb)(a.recommendations))continue;const n=[];E.$i?a.windowsPath&&n.push(a.windowsPath.replace("%USERPROFILE%",()=>b.env.USERPROFILE).replace("%ProgramFiles(x86)%",()=>b.env["ProgramFiles(x86)"]).replace("%ProgramFiles%",()=>b.env.ProgramFiles).replace("%APPDATA%",()=>b.env.APPDATA).replace("%WINDIR%",()=>b.env.WINDIR)):(n.push((0,R.$ic)("/usr/local/bin",s)),n.push((0,R.$ic)("/usr/bin",s)),n.push((0,R.$ic)(this.r.fsPath,s)));for(const i of n){let t=k.get(i);if(t===void 0&&(t=await this.b.exists(j.URI.file(i)),k.set(i,t)),t)for(const{extensionId:r,extensionName:o,isExtensionPack:v,whenNotInstalled:$}of a.recommendations)m.push({extensionId:r,extensionName:o,isExtensionPack:v,exeName:s,exeFriendlyName:a.exeFriendlyName,windowsPath:a.windowsPath,whenNotInstalled:$})}}return m}}e.$16b=c}),define(ae[222],ce([0,1,26,33]),function(ie,e,D,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qXb=void 0;async function L(j,O,C,S,d){try{const R=await j.getExtensionsControlManifest();if(!R.deprecated)return;const E=await j.getInstalled(1);for(const[b,l]of Object.entries(R.deprecated)){if(!l?.extension)continue;const{id:g,autoMigrate:y,preRelease:w}=l.extension;if(!y)continue;const c=E.find(h=>(0,A.$Fo)(h.identifier,{id:b}));if(!c)continue;const u=(await O.getExtensions([{id:g,preRelease:w}],{targetPlatform:await j.getTargetPlatform(),compatible:!0},D.CancellationToken.None))[0];if(!u){d.info(`Skipping migrating '${c.identifier.id}' extension because, the comaptible target '${g}' extension is not found`);continue}try{d.info(`Migrating '${c.identifier.id}' extension to '${g}' extension...`);const h=!S.getDisabledExtensions().some(k=>(0,A.$Fo)(k,c.identifier));await j.uninstall(c),d.info(`Uninstalled the unsupported extension '${c.identifier.id}'`);let m=E.find(k=>(0,A.$Fo)(k.identifier,{id:g}));(!m||!m.isPreReleaseVersion&&h)&&(m=await j.installFromGallery(u,{installPreReleaseVersion:!0,isMachineScoped:c.isMachineScoped,operation:4}),d.info(`Installed the pre-release extension '${m.identifier.id}'`),h||(await S.disableExtension(m.identifier),d.info(`Disabled the pre-release extension '${m.identifier.id}' because the unsupported extension '${c.identifier.id}' is disabled`)),y.storage&&(C.addToMigrationList((0,A.$Io)(c.manifest.publisher,c.manifest.name),(0,A.$Io)(m.manifest.publisher,m.manifest.name)),d.info("Added pre-release extension to the storage migration list"))),d.info(`Migrated '${c.identifier.id}' extension to '${g}' extension.`)}catch(h){d.error(h)}}}catch(R){d.error(R)}}e.$qXb=L}),define(ae[223],ce([0,1,3,2,34,33,44]),function(ie,e,D,A,L,j,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Np=void 0;class C extends A.$Rc{constructor(d,R,E,b,l,g,y){super(),this.f=d,this.g=R,this.h=E,this.j=b,this.m=l,this.n=g,this.r=y,this.a=this.B(new D.$Rd),this.onDidChangeExtensionsByAnotherSource=this.a.event,this.b=new Map,this.c=this.B(new A.$1c),this.s().then(null,w=>y.error(w))}async s(){await this.g.initializeDefaultProfileExtensions(),await this.u(this.h.profiles),this.t(),await this.H()}t(){this.B(this.h.onDidChangeProfiles(d=>this.u(d.added))),this.B(this.j.onAddExtensions(d=>this.w(d))),this.B(this.j.onDidAddExtensions(d=>this.y(d))),this.B(this.j.onRemoveExtensions(d=>this.z(d))),this.B(this.j.onDidRemoveExtensions(d=>this.C(d))),this.B(this.n.onDidFilesChange(d=>this.D(d)))}async u(d){try{d.length&&await Promise.all(d.map(R=>(this.c.set(R.id,(0,A.$Oc)(this.n.watch(this.m.extUri.dirname(R.extensionsResource)),this.n.watch(R.extensionsResource))),this.G(R.extensionsResource))))}catch(R){throw this.r.error(R),R}}async w(d){for(const R of d.extensions)this.I(this.L(R.identifier,R.version),d.profileLocation)}async y(d){for(const R of d.extensions){const E=this.L(R.identifier,R.version);d.error?this.J(E,d.profileLocation):this.I(E,d.profileLocation)}}async z(d){for(const R of d.extensions)this.J(this.L(R.identifier,R.version),d.profileLocation)}async C(d){const R=[],E=[];for(const b of d.extensions){const l=this.L(b.identifier,b.version);d.error?this.I(l,d.profileLocation):(this.J(l,d.profileLocation),this.b.has(l)||(this.r.debug("Extension is removed from all profiles",b.identifier.id,b.version),E.push(this.f.scanInstalledExtensionAtLocation(b.location).then(g=>{g?R.push(g):this.r.info("Extension not found at the location",b.location.toString())},g=>this.r.error(g)))))}try{await Promise.all(E),R.length&&await this.H(R)}catch(b){this.r.error(b)}}D(d){for(const R of this.h.profiles)d.contains(R.extensionsResource,0,1)&&this.F(R.extensionsResource)}async F(d){const R=[],E=[],b=await this.j.scanProfileExtensions(d),l=new Set,g=new Set;for(const[y,w]of this.b)w.has(d)&&g.add(y);for(const y of b){const w=this.L(y.identifier,y.version);l.add(w),g.has(w)||(R.push(y.identifier),this.I(w,d))}for(const y of g)if(!l.has(y)){const w=this.M(y);w&&(E.push(w.identifier),this.J(y,d))}(R.length||E.length)&&this.a.fire({added:R.length?{extensions:R,profileLocation:d}:void 0,removed:E.length?{extensions:E,profileLocation:d}:void 0})}async G(d){const R=await this.j.scanProfileExtensions(d);for(const E of R)this.I(this.L(E.identifier,E.version),d)}async H(d){d||(d=(await this.f.scanAllUserInstalledExtensions()).filter(E=>!this.b.has(this.L(E.identifier,E.manifest.version)))),d.length&&await this.f.markAsUninstalled(...d)}I(d,R){let E=this.b.get(d);E||this.b.set(d,E=new L.$Ac(b=>this.m.extUri.getComparisonKey(b))),E.add(R)}J(d,R){const E=this.b.get(d);E&&E.delete(R),E?.size||this.b.delete(d)}L(d,R){return`${O.$_l.toKey(d.id)}@${R}`}M(d){const[R,E]=(0,j.$Ho)(d);return E?{identifier:{id:R},version:E}:void 0}}e.$Np=C}),define(ae[224],ce([0,1,43,45]),function(ie,e,D,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gp=void 0;async function L(j,O,C,S,d,R,E){const b={"X-Market-Client-Id":`VSCode ${j}`,"User-Agent":`VSCode ${j} (${O.nameShort})`};if((0,A.$xo)(O,C)&&(0,A.$zo)(S)===3){const l=await(0,D.$fp)(C,d,R);b["X-Market-User-Id"]=l,b["VSCode-SessionId"]=E.machineId||l}return b}e.$gp=L}),define(ae[225],ce([0,1,71,18,6,2,23,16,31,14,29,33,8,73,10]),function(ie,e,D,A,L,j,O,C,S,d,R,E,b,l,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1q=void 0;let y=class extends l.$Zq{constructor(h,m,k,s){super(k),this.h=h,this.j=s,this.g=this.B(new w(m,s)),this.h.registerParticipant({postInstall:async a=>this.m(a),postUninstall:async a=>this.n(a)})}async getBuiltInExtensionTranslationsUri(h,m){const s=(await this.g.getLanguagePacks())[m];if(!s){this.j.warn(`No language pack found for ${m}`);return}const a=s.translations[h];return a?g.URI.file(a):void 0}async getInstalledLanguages(){const h=await this.g.getLanguagePacks(),m=Object.keys(h).map(k=>{const s=h[k];return{...this.f(k,s.label),extensionId:s.extensions[0].extensionIdentifier.id}});return m.push(this.f("en","English")),m.sort((k,s)=>k.label.localeCompare(s.label)),m}async m(h){h&&h.manifest&&h.manifest.contributes&&h.manifest.contributes.localizations&&h.manifest.contributes.localizations.length&&(this.j.info("Adding language packs from the extension",h.identifier.id),await this.update())}async n(h){const m=await this.g.getLanguagePacks();Object.keys(m).some(k=>m[k]&&m[k].extensions.some(s=>(0,E.$Fo)(s.extensionIdentifier,h.identifier)))&&(this.j.info("Removing language packs from the extension",h.identifier.id),await this.update())}async update(){const[h,m]=await Promise.all([this.g.getLanguagePacks(),this.h.getInstalled()]),k=await this.g.update(m);return!(0,A.$tb)(Object.keys(h),Object.keys(k))}};e.$1q=y,e.$1q=y=pe([X(0,R.$fo),X(1,d.$4h),X(2,R.$do),X(3,b.$dj)],y);let w=class extends j.$Rc{constructor(h,m){super(),this.j=m,this.c={},this.f=(0,C.$ic)(h.userDataPath,"languagepacks.json"),this.g=new L.$5g}getLanguagePacks(){return this.g.size||!this.h?this.s().then(()=>this.c):Promise.resolve(this.c)}update(h){return this.s(m=>{Object.keys(m).forEach(k=>delete m[k]),this.m(m,...h)}).then(()=>this.c)}m(h,...m){for(const k of m)k&&k.manifest&&k.manifest.contributes&&k.manifest.contributes.localizations&&k.manifest.contributes.localizations.length&&this.n(h,k);Object.keys(h).forEach(k=>this.r(h[k]))}n(h,m){const k=m.identifier,s=m.manifest.contributes&&m.manifest.contributes.localizations?m.manifest.contributes.localizations:[];for(const a of s)if(m.location.scheme===O.Schemas.file&&c(a)){let n=h[a.languageId];n||(n={hash:"",extensions:[],translations:{},label:a.localizedLanguageName??a.languageName},h[a.languageId]=n);const i=n.extensions.filter(t=>(0,E.$Fo)(t.extensionIdentifier,k))[0];i?i.version=m.manifest.version:n.extensions.push({extensionIdentifier:k,version:m.manifest.version});for(const t of a.translations)n.translations[t.id]=(0,C.$ic)(m.location.fsPath,t.path)}}r(h){if(h){const m=(0,D.createHash)("md5");for(const k of h.extensions)m.update(k.extensionIdentifier.uuid||k.extensionIdentifier.id).update(k.version);h.hash=m.digest("hex")}}s(h=()=>null){return this.g.queue(()=>{let m=null;return S.Promises.readFile(this.f,"utf8").then(void 0,k=>k.code==="ENOENT"?Promise.resolve("{}"):Promise.reject(k)).then(k=>{try{return JSON.parse(k)}catch{return{}}}).then(k=>(m=h(k),k)).then(k=>{for(const a of Object.keys(k))k[a]||delete k[a];this.c=k,this.h=!0;const s=JSON.stringify(this.c);return this.j.debug("Writing language packs",s),S.Promises.writeFile(this.f,s)}).then(()=>m,k=>this.j.error(k))})}};w=pe([X(0,d.$4h),X(1,b.$dj)],w);function c(u){if(typeof u.languageId!="string"||!Array.isArray(u.translations)||u.translations.length===0)return!1;for(const h of u.translations)if(typeof h.id!="string"||typeof h.path!="string")return!1;return!(u.languageName&&typeof u.languageName!="string"||u.localizedLanguageName&&typeof u.localizedLanguageName!="string")}}),define(ae[226],ce([0,1,141,7,30,45]),function(ie,e,D,A,L,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$JN=void 0;const O="https://mobile.events.data.microsoft.com/OneCollector/1.0",C="https://mobile.events.data.microsoft.com/ping";async function S(R,E,b){const l=await(0,D.$NC)("@microsoft/1ds-core-js","dist/ms.core.js"),g=await(0,D.$NC)("@microsoft/1ds-post-js","dist/ms.post.js"),y=new l.AppInsightsCore,w=new g.PostChannel,c={instrumentationKey:R,endpointUrl:O,loggingLevelTelemetry:0,loggingLevelConsole:0,disableCookiesUsage:!0,disableDbgExt:!0,disableInstrumentationKeyValidation:!0,channels:[[w]]};if(b){c.extensionConfig={};const u={alwaysUseXhrOverride:!0,httpXHROverride:b};c.extensionConfig[w.identifier]=u}return y.initialize(c,[]),y.addTelemetryInitializer(u=>{E&&(u.ext=u.ext??{},u.ext.utc=u.ext.utc??{},u.ext.utc.flags=8462029)}),y}class d{constructor(E,b,l,g,y){this.e=E,this.f=b,this.g=l,this.h=y,this.c=O,this.d=C,this.g||(this.g={}),typeof g=="function"?this.a=g():this.a=g,this.b=null}i(E){if(this.a){if(typeof this.a!="string"){E(this.a);return}this.b||(this.b=S(this.a,this.e,this.h)),this.b.then(b=>{E(b)},b=>{(0,A.$Z)(b),console.error(b)})}}log(E,b){if(!this.a)return;b=(0,L.$dn)(b,this.g),b=(0,j.$Ao)(b);const l=this.f+"/"+E;try{this.i(g=>{g.pluginVersionString=b?.properties.version??"Unknown",g.track({name:l,baseData:{name:l,properties:b?.properties,measurements:b?.measurements}})})}catch{}}flush(){return this.a?new Promise(E=>{this.i(b=>{b.unload(!0,()=>{this.a=void 0,E(void 0)})})}):Promise.resolve(void 0)}}e.$JN=d}),define(ae[109],ce([0,1,2,166,14,8,25,45]),function(ie,e,D,A,L,j,O,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$o6b=void 0;let S=class extends D.$Rc{constructor(R,E,b,l,g=""){super(),this.b=g;const y=E.getLogger(C.$to);if(y)this.a=this.B(y);else{const c=(0,C.$yo)(l,b)?" (Not Sent)":"",u=()=>(0,C.$xo)(l,b)&&R.getLevel()===j.LogLevel.Trace;this.a=this.B(E.createLogger(C.$to,{name:(0,A.localize)(0,null,c),hidden:!u()})),this.B(R.onDidChangeLogLevel(()=>E.setVisibility(C.$to,u()))),this.a.info("Below are logs for every telemetry event sent from VS Code once the log level is set to trace."),this.a.info("===========================================================")}}flush(){return Promise.resolve(void 0)}log(R,E){this.a.trace(`${this.b}telemetry/${R}`,(0,C.$Ao)(E))}};e.$o6b=S,e.$o6b=S=pe([X(0,j.$dj),X(1,j.$ej),X(2,L.$3h),X(3,O.$vj)],S)}),define(ae[110],ce([0,1,2,30,5,27,167,20,50,102,25,41,22,45]),function(ie,e,D,A,L,j,O,C,S,d,R,E,b,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7q=void 0;let g=class{static{this.IDLE_START_EVENT_NAME="UserIdleStart"}static{this.IDLE_STOP_EVENT_NAME="UserIdleStop"}constructor(c,u,h){this.k=u,this.l=h,this.d={},this.i=new D.$Qc,this.j=[],this.b=c.appenders,this.c=c.commonProperties??Object.create(null),this.sessionId=this.c.sessionID,this.machineId=this.c["common.machineId"],this.firstSessionDate=this.c["common.firstSessionDate"],this.msftInternal=this.c["common.msftInternal"],this.f=c.piiPaths||[],this.g=3,this.h=!!c.sendErrorTelemetry,this.j=[/(vscode-)?file:\/\/\/.*?\/resources\/app\//gi];for(const m of this.f)this.j.push(new RegExp((0,j.$Je)(m),"gi")),m.indexOf("\\")>=0&&this.j.push(new RegExp((0,j.$Je)(m.replace(/\\/g,"/")),"gi"));this.m(),this.i.add(this.k.onDidChangeConfiguration(m=>{(m.affectsConfiguration(b.$ql)||m.affectsConfiguration(b.$sl)||m.affectsConfiguration(b.$rl))&&this.m()}))}setExperimentProperty(c,u){this.d[c]=u}m(){let c=(0,l.$zo)(this.k);const u=this.l.enabledTelemetryLevels;if(u){this.h=this.sendErrorTelemetry?u.error:!1;const h=u.usage?3:u.error?2:0;c=Math.min(c,h)}this.g=c}get sendErrorTelemetry(){return this.h}get telemetryLevel(){return this.g}dispose(){this.i.dispose()}n(c,u,h){this.g<u||(h=(0,A.$dn)(h,this.d),h=(0,l.$Eo)(h,this.j),h=(0,A.$dn)(h,this.c),this.b.forEach(m=>m.log(c,h)))}publicLog(c,u){this.n(c,3,u)}publicLog2(c,u){this.publicLog(c,u)}publicLogError(c,u){this.h&&this.n(c,2,u)}publicLogError2(c,u){this.publicLogError(c,u)}};e.$7q=g,e.$7q=g=pe([X(1,C.$pi),X(2,R.$vj)],g);function y(){const w=(0,O.localize)(0,null,d.default.nameLong),c=d.default.privacyStatementUrl?(0,O.localize)(2,null,"https://aka.ms/vscode-telemetry",d.default.privacyStatementUrl):(0,O.localize)(1,null,"https://aka.ms/vscode-telemetry"),u=L.$o?"":(0,O.localize)(3,null),h=(0,O.localize)(4,null),m=(0,O.localize)(5,null),k=(0,O.localize)(6,null),s=(0,O.localize)(7,null),a=`
|       | ${h} | ${m} | ${k} |
|:------|:---------------------:|:---------------:|:--------------:|
| all   |            \u2713          |        \u2713        |        \u2713       |
| error |            \u2713          |        \u2713        |        -       |
| crash |            \u2713          |        -        |        -       |
| off   |            -          |        -        |        -       |
`,n=(0,O.localize)(8,null);return`
${w} ${c} ${u}

&nbsp;

${s}
${a}

&nbsp;

${n}
`}E.$mn.as(S.$rn.Configuration).registerConfiguration({id:b.$pl,order:1,type:"object",title:(0,O.localize)(9,null),properties:{[b.$ql]:{type:"string",enum:["all","error","crash","off"],enumDescriptions:[(0,O.localize)(10,null),(0,O.localize)(11,null),(0,O.localize)(12,null),(0,O.localize)(13,null)],markdownDescription:y(),default:"all",restricted:!0,scope:1,tags:["usesOnlineServices","telemetry"]}}}),E.$mn.as(S.$rn.Configuration).registerConfiguration({id:b.$pl,order:110,type:"object",title:(0,O.localize)(14,null),properties:{[b.$sl]:{type:"boolean",markdownDescription:d.default.privacyStatementUrl?(0,O.localize)(16,null,d.default.nameLong,d.default.privacyStatementUrl):(0,O.localize)(15,null,d.default.nameLong),default:!0,restricted:!0,markdownDeprecationMessage:(0,O.localize)(17,null,`\`#${b.$ql}#\``),scope:1,tags:["usesOnlineServices","telemetry"]}}})}),define(ae[227],ce([0,1,15,26,271,226]),function(ie,e,D,A,L,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$KN=void 0;async function O(R,E){const b=await E.request(R,A.CancellationToken.None),l=(await(0,D.$re)(b.stream)).toString(),g=b.res.statusCode??200;return{headers:b.res.headers,statusCode:g,responseData:l}}async function C(R){const E={method:R.type,headers:R.headers};return new Promise((l,g)=>{const y=L.request(R.url??"",E,w=>{w.on("data",function(c){l({headers:w.headers,statusCode:w.statusCode??200,responseData:c.toString()})}),w.on("error",function(c){g(c)})});y.write(R.data,w=>{w&&g(w)}),y.end()})}async function S(R,E,b){const l=typeof E.data=="string"?E.data:new TextDecoder().decode(E.data),g={type:"POST",headers:{...E.headers,"Content-Type":"application/json","Content-Length":Buffer.byteLength(E.data).toString()},url:E.urlString,data:l};try{const y=R?await O(g,R):await C(g);b(y.statusCode,y.headers,y.responseData)}catch{b(0,{})}}class d extends j.$JN{constructor(E,b,l,g,y){const w={sendPOST:(c,u)=>{S(E,c,u)}};super(b,l,g,y,w)}}e.$KN=d}),define(ae[228],ce([0,1,23,93,20,14,8,25,22,108,109,110]),function(ie,e,D,A,L,j,O,C,S,d,R,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$l0b=void 0;let b=class{constructor(g,y,w,c,u,h){this.b=g,this.c=y,this.d=w,this.e=c,this.f=u,this.g=h,this.a=new Map}h(g){if(!this.a.has(g.id)){const y=Object.create(null);y["common.vscodemachineid"]=this.c.machineId,y["common.vscodesessionid"]=this.c.sessionId;const w=[g.id,JSON.stringify(y),g.aiKey],u=new A.$9p(D.$gg.asFileUri("bootstrap-fork").fsPath,{serverName:"Debug Telemetry",timeout:1e3*60*5,args:w,env:{ELECTRON_RUN_AS_NODE:1,VSCODE_PIPE_LOGGING:"true",VSCODE_AMD_ENTRYPOINT:"vs/workbench/contrib/debug/node/telemetryApp"}}).getChannel("telemetryAppender"),h=[new d.$68b(u),new R.$o6b(this.d,this.e,this.f,this.g,`[${g.id}] `)];this.a.set(g.id,new E.$7q({appenders:h,sendErrorTelemetry:g.sendErrorTelemetry},this.b,this.g))}return this.a.get(g.id)}publicLog(g,y,w){this.h(g).publicLog(y,w)}publicLogError(g,y,w){this.h(g).publicLogError(y,w)}};e.$l0b=b,e.$l0b=b=pe([X(0,L.$pi),X(1,S.$il),X(2,O.$dj),X(3,O.$ej),X(4,j.$3h),X(5,C.$vj)],b)}),define(ae[77],ce([0,1,3,20,4,8]),function(ie,e,D,A,L,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nv=e.$mv=e.$lv=e.$kv=e.$jv=e.$iv=e.$hv=e.$gv=e.ProvidedOnAutoForward=e.$fv=e.TunnelPrivacyId=e.TunnelProtocol=e.$ev=e.$dv=void 0,e.$dv=(0,L.$Vh)("tunnelService"),e.$ev=(0,L.$Vh)("sharedTunnelsService");var O;(function(w){w.Http="http",w.Https="https"})(O||(e.TunnelProtocol=O={}));var C;(function(w){w.ConstantPrivate="constantPrivate",w.Private="private",w.Public="public"})(C||(e.TunnelPrivacyId=C={}));function S(w){return!!w.forwardPort}e.$fv=S;var d;(function(w){w[w.Notify=1]="Notify",w[w.OpenBrowser=2]="OpenBrowser",w[w.OpenPreview=3]="OpenPreview",w[w.Silent=4]="Silent",w[w.Ignore=5]="Ignore",w[w.OpenBrowserOnce=6]="OpenBrowserOnce"})(d||(e.ProvidedOnAutoForward=d={}));function R(w){if(w.scheme!=="http"&&w.scheme!=="https")return;const c=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(w.authority);if(c)return{address:c[1],port:+c[2]}}e.$gv=R,e.$hv=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function E(w){return e.$hv.indexOf(w)>=0}e.$iv=E,e.$jv=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function b(w){return e.$jv.indexOf(w)>=0}e.$kv=b;function l(w,c,u,h){if(u===1)return!1;if(u===2&&b(c)){const m=/(\d+)\.(\d+)\.(\d+)/g.exec(h);if(m?.length===4&&parseInt(m[1])>=18)return!1}return w<1024}e.$lv=l;class g{constructor(c,u,h){this.remoteAddress=c,this.localAddress=u,this.b=h,this.a=new D.$Rd,this.onDidDispose=this.a.event}dispose(){return this.a.fire(),this.b()}}e.$mv=g;let y=class{constructor(c,u){this.j=c,this.k=u,this.a=new D.$Rd,this.onTunnelOpened=this.a.event,this.b=new D.$Rd,this.onTunnelClosed=this.b.event,this.c=new D.$Rd,this.onAddedTunnelProvider=this.c.event,this.e=new Map,this.g=!1,this.h=[],this.i=new Set}get hasTunnelProvider(){return!!this.f}get l(){const c=this.k.getValue("remote.localPortHost");return!c||c==="localhost"?"127.0.0.1":"0.0.0.0"}setTunnelProvider(c){return this.f=c,c?(this.c.fire(),{dispose:()=>{this.f=void 0,this.g=!1,this.h=[]}}):(this.g=!1,this.h=[],this.c.fire(),{dispose:()=>{}})}setTunnelFeatures(c){this.g=c.elevation,this.h=c.privacyOptions}get canElevate(){return this.g}get canChangePrivacy(){return this.h.length>0}get privacyOptions(){return this.h}get tunnels(){return this.m()}async m(){const c=[],u=Array.from(this.e.values());for(const h of u){const m=Array.from(h.values());for(const k of m){const s=await k.value;s&&typeof s!="string"&&c.push(s)}}return c}async dispose(){for(const c of this.e.values()){for(const{value:u}of c.values())await u.then(h=>typeof h!="string"?h?.dispose():void 0);c.clear()}this.e.clear()}setEnvironmentTunnel(c,u,h,m,k){this.p(c,u,Promise.resolve({tunnelRemoteHost:c,tunnelRemotePort:u,localAddress:h,privacy:m,protocol:k,dispose:()=>Promise.resolve()}))}async getExistingTunnel(c,u){(b(c)||E(c))&&(c=e.$hv[0]);const h=this.r(c,u);if(h)return++h.refcount,h.value}openTunnel(c,u,h,m,k,s=!1,a,n){this.j.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${u}:${h} on local port ${k}.`);const i=this.f??c;if(!i)return;if(u||(u="localhost"),m||(m=this.l),this.f&&this.i.has(h)){this.j.debug("ForwardedPorts: (TunnelService) Another call to create a tunnel with the same address has occurred before the last one completed. This call will be ignored.");return}const t=this.s(i,u,h,m,k,s,a,n);return t?t.then(r=>{if(r){if(typeof r=="string")return this.j.trace("ForwardedPorts: (TunnelService) The tunnel provider returned an error when creating the tunnel."),this.q(u,h),r}else{this.j.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.q(u,h);return}this.j.trace("ForwardedPorts: (TunnelService) New tunnel established.");const o=this.n(r);return(r.tunnelRemoteHost!==u||r.tunnelRemotePort!==h)&&this.j.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),a&&r.privacy!==a&&this.j.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Privacy mismatch."),this.a.fire(o),o}):(this.j.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),t)}n(c){return{tunnelRemotePort:c.tunnelRemotePort,tunnelRemoteHost:c.tunnelRemoteHost,tunnelLocalPort:c.tunnelLocalPort,localAddress:c.localAddress,privacy:c.privacy,protocol:c.protocol,dispose:async()=>{this.j.trace(`ForwardedPorts: (TunnelService) dispose request for ${c.tunnelRemoteHost}:${c.tunnelRemotePort} `);const u=this.e.get(c.tunnelRemoteHost);if(u){const h=u.get(c.tunnelRemotePort);h&&(h.refcount--,await this.o(c.tunnelRemoteHost,c.tunnelRemotePort,h))}}}}async o(c,u,h){if(h.refcount<=0){this.j.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${c}:${u}.`);const m=h.value.then(async k=>{k&&typeof k!="string"&&(await k.dispose(!0),this.b.fire({host:k.tunnelRemoteHost,port:k.tunnelRemotePort}))});return this.e.has(c)&&this.e.get(c).delete(u),m}}async closeTunnel(c,u){this.j.trace(`ForwardedPorts: (TunnelService) close request for ${c}:${u} `);const h=this.e.get(c);if(h&&h.has(u)){const m=h.get(u);m.refcount=0,await this.o(c,u,m)}}p(c,u,h){this.e.has(c)||this.e.set(c,new Map),this.e.get(c).set(u,{refcount:1,value:h})}async q(c,u){const h=this.e.get(c);if(h){const m=h.get(u),k=m?await m.value:void 0;(!k||typeof k=="string")&&h.delete(u),h.size===0&&this.e.delete(c)}}r(c,u){const h=[c];E(c)?(h.push(...e.$hv),h.push(...e.$jv)):b(c)&&h.push(...e.$jv);const m=h.map(k=>this.e.get(k));for(const k of m){const s=k?.get(u);if(s)return s}}canTunnel(c){return!!R(c)}t(c,u,h,m,k,s,a){this.j.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${u}:${h} on local port ${m}.`);const n=h;this.i.add(n);const i=m===void 0?h:m,t={elevationRequired:k?this.isPortPrivileged(i):!1},r={remoteAddress:{host:u,port:h},localAddressPort:m,privacy:s,public:s?s!==C.Private:void 0,protocol:a},o=c.forwardPort(r,t);return o?(this.p(u,h,o),o.finally(()=>{this.j.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),this.i.delete(n)})):this.i.delete(n),o}};e.$nv=y,e.$nv=y=pe([X(0,j.$dj),X(1,A.$pi)],y)}),define(ae[229],ce([0,1,8,77,2,7,6]),function(ie,e,D,A,L,j,O){"use strict";var C;Object.defineProperty(e,"__esModule",{value:!0}),e.$y0b=void 0;class S extends L.$Rc{constructor(){super(),this.a=null,this.b=null}async getAddress(){return this.a?this.a:(this.b||(this.b=new O.$ih),this.b.p)}setAddress(E){this.a=E,this.b&&(this.b.complete(E),this.b=null)}setTunnel(E){this.B(E)}}let d=class extends L.$Rc{static{C=this}static{this.a=0}constructor(E,b){super(),this.f=E,this.g=b,this.b=new Map,this.c=new Set}dispose(){super.dispose(),this.b.forEach(E=>E.dispose())}async createTunnel(){return{id:String(++C.a)}}async startTunnel(E,b,l,g,y,w,c){const u=new S,h=await Promise.resolve(this.f.openTunnel(E,u,l,g,y,w,c));if(!h||typeof h=="string")throw this.g.info(`[SharedProcessTunnelService] Could not create a tunnel to ${l}:${g} (remote).`),u.dispose(),new Error("Could not create tunnel");if(this.c.has(b))throw this.c.delete(b),u.dispose(),await h.dispose(),(0,j.$5)();return u.setTunnel(h),this.b.set(b,u),this.g.info(`[SharedProcessTunnelService] Created tunnel ${b}: ${h.localAddress} (local) to ${l}:${g} (remote).`),{tunnelLocalPort:h.tunnelLocalPort,localAddress:h.localAddress}}async setAddress(E,b){const l=this.b.get(E);l&&l.setAddress(b)}async destroyTunnel(E){const b=this.b.get(E);if(b){this.g.info(`[SharedProcessTunnelService] Disposing tunnel ${E}.`),this.b.delete(E),await b.dispose();return}this.c.add(E)}};e.$y0b=d,e.$y0b=d=C=pe([X(0,A.$ev),X(1,D.$dj)],d)}),define(ae[28],ce([0,1,4]),function(ie,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ok=void 0,e.$Ok=(0,D.$Vh)("IUriIdentityService")}),define(ae[230],ce([0,1,28,184,11,19,127,3,2]),function(ie,e,D,A,L,j,O,C,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fr=void 0;class d{static{this._clock=0}constructor(b){this.uri=b,this.time=d._clock++}touch(){return this.time=d._clock++,this}}let R=class{constructor(b){this.g=b,this.c=new S.$Qc,this.f=2**16;const l=new Map,g=y=>{let w=l.get(y.scheme);return w===void 0&&(w=b.hasProvider(y)&&!this.g.hasCapability(y,1024),l.set(y.scheme,w)),w};this.c.add(C.Event.any(b.onDidChangeFileSystemProviderRegistrations,b.onDidChangeFileSystemProviderCapabilities)(y=>{l.delete(y.scheme)})),this.extUri=new j.$og(g),this.d=new O.$Er((y,w)=>this.extUri.compare(y,w,!0),this.f)}dispose(){this.c.dispose(),this.d.clear()}asCanonicalUri(b){this.g.hasProvider(b)&&(b=(0,j.$Ag)(b));const l=this.d.get(b);return l?l.touch().uri.with({fragment:b.fragment}):(this.d.set(b,new d(b)),this.h(),b)}h(){if(this.d.size<this.f)return;const b=[...this.d.entries()].sort((g,y)=>g[1].time<y[1].time?1:g[1].time>y[1].time?-1:0);d._clock=0,this.d.clear();const l=this.f*.5;for(let g=0;g<l;g++)this.d.set(b[g][0],b[g][1].touch())}};e.$Fr=R,e.$Fr=R=pe([X(0,L.$ek)],R),(0,A.$Cr)(D.$Ok,R,1)}),define(ae[231],ce([0,1,3,2,11,47,34]),function(ie,e,D,A,L,j,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$S9b=void 0;class C extends A.$Rc{constructor(d,R,E,b,l,g){super(),this.f=d,this.g=R,this.h=E,this.j=b,this.m=l,this.n=g,this.capabilities=this.g.capabilities,this.onDidChangeCapabilities=this.g.onDidChangeCapabilities,this.a=this.B(new D.$Rd),this.onDidChangeFile=this.a.event,this.b=j.$2h.forUris(()=>!(this.capabilities&1024)),this.c=new O.$Ac(y=>this.m.extUri.getComparisonKey(this.t(y))),this.r(),this.B(b.onDidChangeProfiles(()=>this.r())),this.B(this.g.onDidChangeFile(y=>this.s(y)))}r(){this.c.clear();for(const d of this.j.profiles)this.c.add(d.settingsResource),this.c.add(d.keybindingsResource),this.c.add(d.tasksResource),this.c.add(d.extensionsResource)}open(d,R){return this.g.open(this.t(d),R)}close(d){return this.g.close(d)}read(d,R,E,b,l){return this.g.read(d,R,E,b,l)}write(d,R,E,b,l){return this.g.write(d,R,E,b,l)}watch(d,R){this.b.set(d,d);const E=this.g.watch(this.t(d),R);return(0,A.$Pc)(()=>{this.b.delete(d),E.dispose()})}stat(d){return this.g.stat(this.t(d))}mkdir(d){return this.g.mkdir(this.t(d))}rename(d,R,E){return this.g.rename(this.t(d),this.t(R),E)}readFile(d,R){return this.g.readFile(this.t(d),R)}readFileStream(d,R,E){return this.g.readFileStream(this.t(d),R,E)}readdir(d){return this.g.readdir(this.t(d))}enforceAtomicReadFile(d){return this.c.has(d)}writeFile(d,R,E){return this.g.writeFile(this.t(d),R,E)}enforceAtomicWriteFile(d){return this.c.has(d)?{postfix:".vsctmp"}:!1}delete(d,R){return this.g.delete(this.t(d),R)}copy(d,R,E){if((0,L.$ik)(this.g))return this.g.copy(this.t(d),this.t(R),E);throw new Error("copy not supported")}cloneFile(d,R){if((0,L.$jk)(this.g))return this.g.cloneFile(this.t(d),this.t(R));throw new Error("clone not supported")}s(d){const R=[];for(const E of d){if(E.resource.scheme!==this.f)continue;const b=this.u(E.resource);this.b.findSubstr(b)&&R.push({resource:b,type:E.type,cId:E.cId})}R.length&&(this.n.debug("User data changed"),this.a.fire(R))}t(d){return d.with({scheme:this.f})}u(d){return d.with({scheme:this.h})}}e.$S9b=C}),define(ae[78],ce([0,1,86]),function(ie,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$TDb=e.$SDb=e.edit=void 0;function A(O,C,S,d){const R=(0,D.$xT)(O,C,S,d)[0];return R&&(O=O.substring(0,R.offset)+R.content+O.substring(R.offset+R.length)),O}e.edit=A;function L(O,C,S){let d=S;for(;d>=0;){if(O.charAt(d)===C.charAt(C.length-1)&&C.length===1)return d+1;if(d--,C.length===2&&d>=0&&O.charAt(d)===C.charAt(0))return d+2}return 0}e.$SDb=L;function j(O,C,S){let d=S;for(;d>=0;)if(O.charAt(d)===C.charAt(C.length-1)&&C.length===1||(d++,C.length===2&&d>=0&&O.charAt(d)===C.charAt(1)))return d;return O.length-1}e.$TDb=j}),define(ae[232],ce([0,1,30,54,12]),function(ie,e,D,A,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$74b=void 0;function j(l,g,y,w,c,u){const h=[],m=[],k=[];if(!g){const q=l.filter(({identifier:Y})=>c.every(Q=>Q.toLowerCase()!==Y.id.toLowerCase()));return{local:{added:h,removed:m,updated:k},remote:q.length>0?{added:q,updated:[],removed:[],all:q}:null}}l=l.map(E),g=g.map(E),y=y?y.map(E):null;const s=new Map,a=q=>{q.uuid&&s.set(q.id.toLowerCase(),q.uuid)};l.forEach(({identifier:q})=>a(q)),g.forEach(({identifier:q})=>a(q)),y?.forEach(({identifier:q})=>a(q)),w?.forEach(({identifier:q})=>a(q)),u?.forEach(q=>a(q));const n=q=>{const Y=q.identifier.uuid||s.get(q.identifier.id.toLowerCase());return Y?`uuid:${Y}`:`id:${q.identifier.id.toLowerCase()}`},i=(q,Y)=>(q.set(n(Y),Y),q),t=l.reduce(i,new Map),r=g.reduce(i,new Map),o=g.reduce((q,Y)=>i(q,(0,D.$an)(Y)),new Map),v=y?y.reduce(i,new Map):null,$=w.reduce(i,new Map),f=c.reduce((q,Y)=>{const Q=s.get(Y.toLowerCase());return q.add(Q?`uuid:${Q}`:`id:${Y.toLowerCase()}`)},new Set),p=u?u.reduce((q,{id:Y,uuid:Q})=>(Q=Q??s.get(Y.toLowerCase()),q.add(Q?`uuid:${Q}`:`id:${Y.toLowerCase()}`)),new Set):null,I=O(t,r,f,!1);if(I.added.size>0||I.removed.size>0||I.updated.size>0){const q=O(v,t,f,!1),Y=O(v,r,f,!0),Q=(x,H,Z,J)=>{let W,ee,ne;return H.installed?(W=J.pinned,ne=J.preRelease,W&&(ee=J.version)):(W=Z.pinned,ne=Z.preRelease,W&&(ee=Z.version)),W===void 0&&(W=H.pinned,W&&(ee=H.version)),ne===void 0&&(ne=H.preRelease),{...J,installed:H.installed||Z.installed,pinned:W,preRelease:ne,version:ee??(Z.version&&(!H.installed||A.gt(Z.version,H.version))?Z.version:H.version),state:S(H,Z,v?.get(x))}};for(const x of Y.removed.values()){const H=t.get(x);if(!H)continue;const Z=(0,L.$Nf)(v?.get(x)),J=p&&!p.has(x)&&Z.installed;H.installed&&J?m.push(H.identifier):o.set(x,H)}for(const x of Y.added.values()){const H=(0,L.$Nf)(r.get(x)),Z=t.get(x);if(Z){if(I.updated.has(x)){const J=Q(x,Z,H,H);C(Z,H,!1,!1)||k.push(b(J,x)),o.set(x,J)}}else H.installed&&h.push(b(H,x))}for(const x of Y.updated.values()){const H=(0,L.$Nf)(r.get(x)),Z=(0,L.$Nf)(v?.get(x)),J=t.get(x);if(J)if(p&&!p.has(x)&&Z.installed&&J.installed&&!H.installed)m.push(J.identifier);else{const ee=Q(x,J,H,H);k.push(b(ee,x)),o.set(x,ee)}else H.installed&&h.push(b(H,x))}for(const x of q.added.values())Y.added.has(x)||o.set(x,(0,L.$Nf)(t.get(x)));for(const x of q.updated.values()){if(Y.removed.has(x)||Y.updated.has(x))continue;const H=(0,L.$Nf)(t.get(x)),Z=(0,L.$Nf)(r.get(x));o.set(x,Q(x,H,Z,H))}for(const x of q.removed.values())Y.updated.has(x)||Y.removed.has(x)||$.has(x)||(0,L.$Nf)(r.get(x)).installed&&p&&(p.has(x)||!(0,L.$Nf)(v?.get(x)).installed||o.delete(x))}const T=[],M=O(r,o,new Set,!0),z=M.added.size>0||M.updated.size>0||M.removed.size>0;return z&&o.forEach((q,Y)=>T.push(b(q,Y))),{local:{added:h,removed:m,updated:k},remote:z?{added:[...M.added].map(q=>o.get(q)),updated:[...M.updated].map(q=>o.get(q)),removed:[...M.removed].map(q=>r.get(q)),all:T}:null}}e.$74b=j;function O(l,g,y,w){const c=l?[...l.keys()].filter(s=>!y.has(s)):[],u=[...g.keys()].filter(s=>!y.has(s)),h=u.filter(s=>!c.includes(s)).reduce((s,a)=>(s.add(a),s),new Set),m=c.filter(s=>!u.includes(s)).reduce((s,a)=>(s.add(a),s),new Set),k=new Set;for(const s of c){if(m.has(s))continue;const a=l.get(s),n=g.get(s);(!n||!C(a,n,w,!0))&&k.add(s)}return{added:h,removed:m,updated:k}}function C(l,g,y,w){return!(l.disabled!==g.disabled||!!l.isApplicationScoped!=!!g.isApplicationScoped||w&&l.installed!==g.installed||l.installed&&g.installed&&(l.preRelease!==g.preRelease||l.pinned!==g.pinned||g.pinned&&l.version!==g.version)||!R(l.state,g.state)||y&&l.version!==g.version)}function S(l,g,y){const w=l.state,c=g.state,u=y?.state;if(!g.version||w&&A.gt(l.version,g.version))return w;if(c&&A.gt(g.version,l.version)||!w)return c;if(!c)return w;const h=(0,D.$an)(w),m=u?d(u,c):{added:Object.keys(c).reduce((s,a)=>(s.add(a),s),new Set),removed:new Set,updated:new Set},k=u?d(u,w):{added:Object.keys(w).reduce((s,a)=>(s.add(a),s),new Set),removed:new Set,updated:new Set};for(const s of[...m.added.values(),...m.updated.values()])h[s]=c[s];for(const s of m.removed.values())k.updated.has(s)||delete h[s];return h}function d(l,g){const y=Object.keys(l),w=Object.keys(g),c=w.filter(m=>!y.includes(m)).reduce((m,k)=>(m.add(k),m),new Set),u=y.filter(m=>!w.includes(m)).reduce((m,k)=>(m.add(k),m),new Set),h=new Set;for(const m of y){if(u.has(m))continue;const k=l[m],s=g[m];(0,D.$en)(k,s)||h.add(m)}return{added:c,removed:u,updated:h}}function R(l={},g={}){const{added:y,removed:w,updated:c}=d(l,g);return y.size===0&&w.size===0&&c.size===0}function E(l){return{...l,disabled:!!l.disabled,installed:!!l.installed}}function b(l,g){const y={...l,identifier:{id:l.identifier.id,uuid:g.startsWith("uuid:")?g.substring(5):void 0},preRelease:!!l.preRelease,pinned:!!l.pinned};return l.disabled||delete y.disabled,l.installed||delete y.installed,l.state||delete y.state,l.isApplicationScoped||delete y.isApplicationScoped,y}}),define(ae[111],ce([0,1,18,20,4]),function(ie,e,D,A,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$QFb=e.$PFb=void 0,e.$PFb=(0,L.$Vh)("IIgnoredExtensionsManagementService");let j=class{constructor(C){this.a=C}hasToNeverSyncExtension(C){return this.b().includes(C.toLowerCase())}hasToAlwaysSyncExtension(C){return this.b().includes(`-${C.toLowerCase()}`)}updateIgnoredExtensions(C,S){let d=[...this.a.getValue("settingsSync.ignoredExtensions")].map(R=>R.toLowerCase());return d=d.filter(R=>R!==C&&R!==`-${C}`),S&&d.push(C.toLowerCase()),this.a.updateValue("settingsSync.ignoredExtensions",d.length?d:void 0,2)}updateSynchronizedExtensions(C,S){let d=[...this.a.getValue("settingsSync.ignoredExtensions")].map(R=>R.toLowerCase());return d=d.filter(R=>R!==C&&R!==`-${C}`),S&&d.push(`-${C.toLowerCase()}`),this.a.updateValue("settingsSync.ignoredExtensions",d.length?d:void 0,2)}getIgnoredExtensions(C){const S=C.filter(b=>b.isMachineScoped).map(b=>b.identifier.id.toLowerCase()),d=this.b().map(b=>b.toLowerCase()),R=[],E=[];if(Array.isArray(d))for(const b of d)b.startsWith("-")?E.push(b.substring(1)):R.push(b);return(0,D.$Lb)([...S,...R].filter(b=>!E.includes(b)))}b(){let C=this.a.inspect("settingsSync.ignoredExtensions").userValue;return C!==void 0||(C=this.a.inspect("sync.ignoredExtensions").userValue,C!==void 0)?C:(this.a.getValue("settingsSync.ignoredExtensions")||[]).map(S=>S.toLowerCase())}};e.$QFb=j,e.$QFb=j=pe([X(0,A.$pi)],j)}),define(ae[233],ce([0,1,18,35,30,94,78]),function(ie,e,D,A,L,j,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$a5b=void 0;function C(m){return(0,A.$3m)(m)||[]}async function S(m,k,s,a,n){const i=C(m),t=C(k),r=s?C(s):null,o=[...i,...t,...r||[]].map(Q=>Q.key),v=await n.resolveUserBindings(o),$=R(i,t,r,v);if(!$.hasLocalForwarded&&!$.hasRemoteForwarded)return{mergeContent:m,hasChanges:!1,hasConflicts:!1};if(!$.hasLocalForwarded&&$.hasRemoteForwarded)return{mergeContent:k,hasChanges:!0,hasConflicts:!1};if($.hasLocalForwarded&&!$.hasRemoteForwarded)return{mergeContent:m,hasChanges:!0,hasConflicts:!1};const f=b(i),p=b(t),I=r?b(r):null,T=g(f,p,v),M=I?g(I,f,v):{added:[...f.keys()].reduce((Q,x)=>(Q.add(x),Q),new Set),removed:new Set,updated:new Set},z=I?g(I,p,v):{added:[...p.keys()].reduce((Q,x)=>(Q.add(x),Q),new Set),removed:new Set,updated:new Set},q=d(T,M,z);let Y=m;for(const Q of q.removed.values())q.conflicts.has(Q)||(Y=u(Y,Q,a));for(const Q of q.added.values()){if(q.conflicts.has(Q))continue;const x=p.get(Q);if(x.some(H=>H.command!==`-${Q}`&&$.conflicts.has(v[H.key]))){q.conflicts.add(Q);continue}Y=c(Y,x,a)}for(const Q of q.updated.values()){if(q.conflicts.has(Q))continue;const x=p.get(Q);if(x.some(H=>H.command!==`-${Q}`&&$.conflicts.has(v[H.key]))){q.conflicts.add(Q);continue}Y=h(Y,Q,x,a)}return{mergeContent:Y,hasChanges:!0,hasConflicts:q.conflicts.size>0}}e.$a5b=S;function d(m,k,s){const a=new Set,n=new Set,i=new Set,t=new Set;for(const r of k.removed.values())s.updated.has(r)&&t.add(r);for(const r of s.removed.values())t.has(r)||(k.updated.has(r)?t.add(r):n.add(r));for(const r of k.added.values())t.has(r)||s.added.has(r)&&m.updated.has(r)&&t.add(r);for(const r of s.added.values())t.has(r)||(k.added.has(r)?m.updated.has(r)&&t.add(r):a.add(r));for(const r of k.updated.values())t.has(r)||s.updated.has(r)&&m.updated.has(r)&&t.add(r);for(const r of s.updated.values())t.has(r)||(k.updated.has(r)?m.updated.has(r)&&t.add(r):i.add(r));return{added:a,removed:n,updated:i,conflicts:t}}function R(m,k,s,a){const n=new Set,i=E(m,a),t=E(k,a),r=s?E(s,a):null,o=l(i,t);if(o.added.size===0&&o.removed.size===0&&o.updated.size===0)return{hasLocalForwarded:!1,hasRemoteForwarded:!1,added:n,removed:n,updated:n,conflicts:n};const v=r?l(r,i):{added:[...i.keys()].reduce((M,z)=>(M.add(z),M),new Set),removed:new Set,updated:new Set};if(v.added.size===0&&v.removed.size===0&&v.updated.size===0)return{hasLocalForwarded:!1,hasRemoteForwarded:!0,added:n,removed:n,updated:n,conflicts:n};const $=r?l(r,t):{added:[...t.keys()].reduce((M,z)=>(M.add(z),M),new Set),removed:new Set,updated:new Set};if($.added.size===0&&$.removed.size===0&&$.updated.size===0)return{hasLocalForwarded:!0,hasRemoteForwarded:!1,added:n,removed:n,updated:n,conflicts:n};const{added:f,removed:p,updated:I,conflicts:T}=d(o,v,$);return{hasLocalForwarded:!0,hasRemoteForwarded:!0,added:f,removed:p,updated:I,conflicts:T}}function E(m,k){const s=new Map;for(const a of m){const n=k[a.key];let i=s.get(n);i||(i=[],s.set(n,i)),i.push(a)}return s}function b(m){const k=new Map;for(const s of m){const a=s.command[0]==="-"?s.command.substring(1):s.command;let n=k.get(a);n||(n=[],k.set(a,n)),n.push(s)}return k}function l(m,k){const s=[...m.keys()],a=[...k.keys()],n=a.filter(r=>!s.includes(r)).reduce((r,o)=>(r.add(o),r),new Set),i=s.filter(r=>!a.includes(r)).reduce((r,o)=>(r.add(o),r),new Set),t=new Set;for(const r of s){if(i.has(r))continue;const o=m.get(r).map($=>({...$,key:r})),v=k.get(r).map($=>({...$,key:r}));(0,D.$tb)(o,v,($,f)=>w($,f))||t.add(r)}return{added:n,removed:i,updated:t}}function g(m,k,s){const a=[...m.keys()],n=[...k.keys()],i=n.filter(o=>!a.includes(o)).reduce((o,v)=>(o.add(v),o),new Set),t=a.filter(o=>!n.includes(o)).reduce((o,v)=>(o.add(v),o),new Set),r=new Set;for(const o of a){if(t.has(o))continue;const v=m.get(o).map(f=>({...f,key:s[f.key]})),$=k.get(o).map(f=>({...f,key:s[f.key]}));y(v,$)||r.add(o)}return{added:i,removed:t,updated:r}}function y(m,k){return!(!(0,D.$tb)(m.filter(({command:s})=>s[0]!=="-"),k.filter(({command:s})=>s[0]!=="-"),(s,a)=>w(s,a))||!(0,D.$tb)(m.filter(({command:s})=>s[0]==="-"),k.filter(({command:s})=>s[0]==="-"),(s,a)=>w(s,a)))}function w(m,k){if(m.command!==k.command||m.key!==k.key)return!1;const s=j.$Ti.deserialize(m.when),a=j.$Ti.deserialize(k.when);return!(s&&!a||!s&&a||s&&a&&!s.equals(a)||!L.$en(m.args,k.args))}function c(m,k,s){for(const a of k)m=O.edit(m,[-1],a,s);return m}function u(m,k,s){const a=C(m);for(let n=a.length-1;n>=0;n--)(a[n].command===k||a[n].command===`-${k}`)&&(m=O.edit(m,[n],void 0,s));return m}function h(m,k,s,a){const n=C(m),i=n.findIndex(t=>t.command===k||t.command===`-${k}`);for(let t=n.length-1;t>=0;t--)(n[t].command===k||n[t].command===`-${k}`)&&(m=O.edit(m,[t],void 0,a));for(let t=s.length-1;t>=0;t--)m=O.edit(m,[i],s[t],a);return m}}),define(ae[234],ce([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$i5b=e.$h5b=void 0;function D(j,O,C){const S={},d={},R=new Set;if(!O)return{local:{added:S,updated:d,removed:[...R.values()]},remote:{added:j,updated:{},removed:[]},conflicts:[]};const E=A(j,O);if(E.added.size===0&&E.removed.size===0&&E.updated.size===0)return{local:{added:S,updated:d,removed:[...R.values()]},remote:{added:{},updated:{},removed:[]},conflicts:[]};const b=A(C,j),l=A(C,O),g={},y={},w=new Set,c=new Set;for(const u of b.removed.values())l.updated.has(u)?S[u]=O[u]:w.add(u);for(const u of l.removed.values())c.has(u)||(b.updated.has(u)?c.add(u):R.add(u));for(const u of b.updated.values())c.has(u)||(l.updated.has(u)?E.updated.has(u)&&c.add(u):y[u]=j[u]);for(const u of l.updated.values())c.has(u)||(b.updated.has(u)?E.updated.has(u)&&c.add(u):j[u]!==void 0&&(d[u]=O[u]));for(const u of b.added.values())c.has(u)||(l.added.has(u)?E.updated.has(u)&&c.add(u):g[u]=j[u]);for(const u of l.added.values())c.has(u)||(b.added.has(u)?E.updated.has(u)&&c.add(u):S[u]=O[u]);return{local:{added:S,removed:[...R.values()],updated:d},remote:{added:g,removed:[...w.values()],updated:y},conflicts:[...c.values()]}}e.$h5b=D;function A(j,O){const C=j?Object.keys(j):[],S=O?Object.keys(O):[],d=S.filter(b=>!C.includes(b)).reduce((b,l)=>(b.add(l),b),new Set),R=C.filter(b=>!S.includes(b)).reduce((b,l)=>(b.add(l),b),new Set),E=new Set;for(const b of C){if(R.has(b))continue;const l=j[b],g=O[b];l!==g&&E.add(b)}return{added:d,removed:R,updated:E}}function L(j,O){const{added:C,removed:S,updated:d}=A(j,O);return C.size===0&&S.size===0&&d.size===0}e.$i5b=L}),define(ae[235],ce([0,1,30]),function(ie,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$46b=void 0;function A(j,O,C,S){const d={added:[],removed:[],updated:[]};let R={added:[],removed:[],updated:[]};if(!O){const b=j.filter(({id:l})=>!S.includes(l));return b.length?R.added=b:R=null,{local:d,remote:R}}const E=L(j,O,S);if(E.added.length>0||E.removed.length>0||E.updated.length>0){const b=L(C,j,S),l=L(C,O,S);for(const g of l.removed){const y=j.find(w=>w.id===g);y&&d.removed.push(y)}for(const g of l.added){const y=O.find(w=>w.id===g);b.added.includes(g)?E.updated.includes(g)&&d.updated.push(y):d.added.push(y)}for(const g of l.updated)d.updated.push(O.find(y=>y.id===g));for(const g of b.added)l.added.includes(g)||R.added.push(j.find(y=>y.id===g));for(const g of b.updated)l.removed.includes(g)||l.updated.includes(g)||R.updated.push(j.find(y=>y.id===g));for(const g of b.removed){const y=O.find(w=>w.id===g);y&&R.removed.push(y)}}return R.added.length===0&&R.removed.length===0&&R.updated.length===0&&(R=null),{local:d,remote:R}}e.$46b=A;function L(j,O,C){j=j?j.filter(({id:l})=>!C.includes(l)):[],O=O.filter(({id:l})=>!C.includes(l));const S=j.map(({id:l})=>l),d=O.map(({id:l})=>l),R=d.filter(l=>!S.includes(l)),E=S.filter(l=>!d.includes(l)),b=[];for(const{id:l,name:g,shortName:y,icon:w,useDefaultFlags:c}of j){if(E.includes(l))continue;const u=O.find(h=>h.id===l);(!u||u.name!==g||u.shortName!==y||u.icon!==w||!(0,D.$en)(u.useDefaultFlags,c))&&b.push(l)}return{added:R,removed:E,updated:b}}}),define(ae[24],ce([0,1,18,12,173,50,29,4,103,41]),function(ie,e,D,A,L,j,O,C,S,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ehb=e.$dhb=e.$chb=e.$bhb=e.$ahb=e.$_gb=e.$$gb=e.$0gb=e.$9gb=e.$8gb=e.$7gb=e.MergeState=e.Change=e.SyncStatus=e.$6gb=e.$5gb=e.$4gb=e.UserDataSyncErrorCode=e.$3gb=e.$2gb=e.$1gb=e.$Zgb=e.$Ygb=e.$Xgb=e.$Wgb=e.$Vgb=e.$Ugb=e.SyncResource=e.$Tgb=e.$Sgb=e.$Rgb=e.$Qgb=e.$Pgb=e.$Ogb=void 0;function R(){const t=d.$mn.as(j.$rn.Configuration).getConfigurationProperties();return Object.keys(t).filter(r=>!!t[r].disallowSyncIgnore)}e.$Ogb=R;function E(){const t=d.$mn.as(j.$rn.Configuration).getConfigurationProperties(),r=Object.keys(t).filter($=>!!t[$].ignoreSync),o=Object.keys(t).filter($=>t[$].scope===2||t[$].scope===6),v=R();return(0,D.$Lb)([...r,...o,...v])}e.$Pgb=E,e.$Qgb="settingsSync",e.$Rgb="settingsSync.keybindingsPerPlatform";function b(){const t="vscode://schemas/ignoredSettings",r=d.$mn.as(j.$rn.Configuration);r.registerConfiguration({id:"settingsSync",order:30,title:(0,L.localize)(0,null),type:"object",properties:{[e.$Rgb]:{type:"boolean",description:(0,L.localize)(1,null),default:!0,scope:1,tags:["sync","usesOnlineServices"]},"settingsSync.ignoredExtensions":{type:"array",markdownDescription:(0,L.localize)(2,null),items:[{type:"string",pattern:O.$4n,errorMessage:(0,L.localize)(3,null)}],default:[],scope:1,uniqueItems:!0,disallowSyncIgnore:!0,tags:["sync","usesOnlineServices"]},"settingsSync.ignoredSettings":{type:"array",description:(0,L.localize)(4,null),default:[],scope:1,$ref:t,additionalProperties:!0,uniqueItems:!0,disallowSyncIgnore:!0,tags:["sync","usesOnlineServices"]}}});const o=d.$mn.as(S.$nn.JSONContribution),v=()=>{const $=R(),f=E(),p=Object.keys(j.$sn.properties).filter(M=>!f.includes(M)),I=f.filter(M=>!$.includes(M)),T={items:{type:"string",enum:[...p,...I.map(M=>`-${M}`)]}};o.registerSchema(t,T)};return r.onDidUpdateConfiguration(()=>v())}e.$Sgb=b;function l(t){return t&&(0,A.$Ef)(t)&&(0,A.$Cf)(t.id)&&Array.isArray(t.scopes)}e.$Tgb=l;var g;(function(t){t.Settings="settings",t.Keybindings="keybindings",t.Snippets="snippets",t.Tasks="tasks",t.Extensions="extensions",t.GlobalState="globalState",t.Profiles="profiles",t.WorkspaceState="workspaceState"})(g||(e.SyncResource=g={})),e.$Ugb=["settings","keybindings","snippets","tasks","extensions","globalState","profiles"];function y(t,...r){return t?[t,...r]:r}e.$Vgb=y;function w(t,r,o,v){return v.joinPath(o.userDataSyncHome,...y(t,r,`lastSync${r}.json`))}e.$Wgb=w,e.$Xgb=(0,C.$Vh)("IUserDataSyncStoreManagementService"),e.$Ygb=(0,C.$Vh)("IUserDataSyncStoreService"),e.$Zgb=(0,C.$Vh)("IUserDataSyncLocalStoreService"),e.$1gb="x-operation-id",e.$2gb="X-Execution-Id";function c(t){const r={};return r[e.$2gb]=t,r}e.$3gb=c;var u;(function(t){t.Unauthorized="Unauthorized",t.Forbidden="Forbidden",t.NotFound="NotFound",t.MethodNotFound="MethodNotFound",t.Conflict="Conflict",t.Gone="Gone",t.PreconditionFailed="PreconditionFailed",t.TooLarge="TooLarge",t.UpgradeRequired="UpgradeRequired",t.PreconditionRequired="PreconditionRequired",t.TooManyRequests="RemoteTooManyRequests",t.TooManyRequestsAndRetryAfter="TooManyRequestsAndRetryAfter",t.RequestFailed="RequestFailed",t.RequestCanceled="RequestCanceled",t.RequestTimeout="RequestTimeout",t.RequestProtocolNotSupported="RequestProtocolNotSupported",t.RequestPathNotEscaped="RequestPathNotEscaped",t.RequestHeadersNotObject="RequestHeadersNotObject",t.NoCollection="NoCollection",t.NoRef="NoRef",t.EmptyResponse="EmptyResponse",t.TurnedOff="TurnedOff",t.SessionExpired="SessionExpired",t.ServiceChanged="ServiceChanged",t.DefaultServiceChanged="DefaultServiceChanged",t.LocalTooManyProfiles="LocalTooManyProfiles",t.LocalTooManyRequests="LocalTooManyRequests",t.LocalPreconditionFailed="LocalPreconditionFailed",t.LocalInvalidContent="LocalInvalidContent",t.LocalError="LocalError",t.IncompatibleLocalContent="IncompatibleLocalContent",t.IncompatibleRemoteContent="IncompatibleRemoteContent",t.Unknown="Unknown"})(u||(e.UserDataSyncErrorCode=u={}));class h extends Error{constructor(r,o,v,$){super(r),this.code=o,this.resource=v,this.operationId=$,this.name=`${this.code} (UserDataSyncError) syncResource:${this.resource||"unknown"} operationId:${this.operationId||"unknown"}`}}e.$4gb=h;class m extends h{constructor(r,o,v,$,f){super(r,v,void 0,f),this.url=o,this.serverCode=$}}e.$5gb=m;class k extends h{constructor(r,o){super(r,o)}}e.$6gb=k,function(t){function r(o){if(o instanceof t)return o;const v=/^(.+) \(UserDataSyncError\) syncResource:(.+) operationId:(.+)$/.exec(o.name);if(v&&v[1]){const $=v[2]==="unknown"?void 0:v[2],f=v[3]==="unknown"?void 0:v[3];return new t(o.message,v[1],$,f)}return new t(o.message,"Unknown")}t.toUserDataSyncError=r}(h||(e.$4gb=h={}));var s;(function(t){t.Uninitialized="uninitialized",t.Idle="idle",t.Syncing="syncing",t.HasConflicts="hasConflicts"})(s||(e.SyncStatus=s={}));var a;(function(t){t[t.None=0]="None",t[t.Added=1]="Added",t[t.Modified=2]="Modified",t[t.Deleted=3]="Deleted"})(a||(e.Change=a={}));var n;(function(t){t.Preview="preview",t.Conflict="conflict",t.Accepted="accepted"})(n||(e.MergeState=n={})),e.$7gb="sync.store.url.type";function i(t){return`sync.enable.${t}`}e.$8gb=i,e.$9gb=(0,C.$Vh)("IUserDataSyncEnablementService"),e.$0gb=(0,C.$Vh)("IUserDataSyncService"),e.$$gb=(0,C.$Vh)("IUserDataSyncResourceProviderService"),e.$_gb=(0,C.$Vh)("IUserDataAutoSyncService"),e.$ahb=(0,C.$Vh)("IUserDataSyncUtilService"),e.$bhb=(0,C.$Vh)("IUserDataSyncLogService"),e.$chb="userDataSync",e.$dhb="vscode-userdata-sync",e.$ehb="preview"}),define(ae[236],ce([0,1,30,24]),function(ie,e,D,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_Eb=void 0;function L(O,C,S,d,R){if(!C)return{remote:{added:Object.keys(O),removed:[],updated:[],all:Object.keys(O).length>0?O:null},local:{added:{},removed:[],updated:{}}};const E=j(O,C);if(E.added.size===0&&E.removed.size===0&&E.updated.size===0)return{remote:{added:[],removed:[],updated:[],all:null},local:{added:{},removed:[],updated:{}}};const b=S?j(S,C):{added:Object.keys(C).reduce((u,h)=>(u.add(h),u),new Set),removed:new Set,updated:new Set},l=S?j(S,O):{added:Object.keys(O).reduce((u,h)=>(u.add(h),u),new Set),removed:new Set,updated:new Set},g={added:{},removed:[],updated:{}},y=D.$an(C),w=!S;for(const u of l.added.values())u!==A.$7gb&&w&&b.added.has(u)||(y[u]=O[u]);for(const u of l.updated.values())y[u]=O[u];for(const u of l.removed.values())d.unregistered.includes(u)||delete y[u];for(const u of b.added.values()){const h=C[u];if(d.machine.includes(u)){R.info(`GlobalState: Skipped adding ${u} in local storage because it is declared as machine scoped.`);continue}if(S&&l.added.has(u))continue;const m=O[u];m&&m.value===h.value||u===A.$7gb&&w&&l.added.has(u)||(m?g.updated[u]=h:g.added[u]=h)}for(const u of b.updated.values()){const h=C[u];if(d.machine.includes(u)){R.info(`GlobalState: Skipped updating ${u} in local storage because it is declared as machine scoped.`);continue}if(l.updated.has(u)||l.removed.has(u))continue;const m=O[u];m&&m.value===h.value||(g.updated[u]=h)}for(const u of b.removed.values()){if(d.machine.includes(u)){R.trace(`GlobalState: Skipped removing ${u} in local storage because it is declared as machine scoped.`);continue}l.updated.has(u)||l.removed.has(u)||g.removed.push(u)}const c=j(C,y);return{local:g,remote:{added:[...c.added],updated:[...c.updated],removed:[...c.removed],all:c.added.size===0&&c.removed.size===0&&c.updated.size===0?null:y}}}e.$_Eb=L;function j(O,C){const S=Object.keys(O),d=Object.keys(C),R=d.filter(l=>!S.includes(l)).reduce((l,g)=>(l.add(g),l),new Set),E=S.filter(l=>!d.includes(l)).reduce((l,g)=>(l.add(g),l),new Set),b=new Set;for(const l of S){if(E.has(l))continue;const g=O[l],y=C[l];D.$en(g,y)||b.add(l)}return{added:R,removed:E,updated:b}}}),define(ae[237],ce([0,1,18,35,86,42,30,78,24]),function(ie,e,D,A,L,j,O,C,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ZDb=e.$YDb=e.$XDb=e.$WDb=e.$VDb=e.$UDb=void 0;function d(o,v,$){let f=[];$?f=E($):f=R(v);const p=[],I=[...(0,S.$Ogb)()];if(Array.isArray(f))for(const T of f)T.startsWith("-")?I.push(T.substring(1)):p.push(T);return(0,D.$Lb)([...o,...p].filter(T=>!I.includes(T)))}e.$UDb=d;function R(o){let v=o.inspect("settingsSync.ignoredSettings").userValue;return v!==void 0||(v=o.inspect("sync.ignoredSettings").userValue,v!==void 0)?v:o.getValue("settingsSync.ignoredSettings")||[]}function E(o){const v=(0,A.$3m)(o);return v?v["settingsSync.ignoredSettings"]||v["sync.ignoredSettings"]||[]:[]}function b(o,v){const $=(0,A.$3m)(o)||{};let f="{}";for(const p of Object.keys($)){const I=(0,L.$xT)(f,[p],$[p],v);f=(0,L.$AT)(f,I)}return f}e.$VDb=b;function l(o,v,$,f){if($.length){const p=r(v),I=(0,A.$3m)(v)||{},T=(0,A.$3m)(o);if(!T)return o;const M=[];for(const z of $){const q=I[z],Y=T[z];q===void 0?o=C.edit(o,[z],void 0,f):Y!==void 0?o=C.edit(o,[z],q,f):M.push(s(z,p))}M.sort((z,q)=>z.startOffset-q.startOffset),M.forEach(z=>o=u(z.setting.key,v,o,f))}return o}e.$WDb=l;function g(o,v,$,f,p,I){const T=l(o,v,f,I),M=$!==T,z=$!==v;if(!M&&!z)return{conflictsSettings:[],localContent:null,remoteContent:null,hasConflicts:!1};if(M&&!z)return{conflictsSettings:[],localContent:null,remoteContent:T,hasConflicts:!1};if(z&&!M)return{conflictsSettings:[],localContent:l(v,o,f,I),remoteContent:null,hasConflicts:!1};if($===null&&w(o)){const F=y(o,v,f)?null:l(v,o,f,I);return{conflictsSettings:[],localContent:F,remoteContent:null,hasConflicts:!1}}let q=o,Y=v;const Q=(0,A.$3m)(o),x=(0,A.$3m)(v),H=$?(0,A.$3m)($):null,Z=f.reduce((F,B)=>(F.add(B),F),new Set),J=c(Q,x,Z),W=c(H,Q,Z),ee=c(H,x,Z),ne=new Map,_=new Set,se=F=>{_.add(F);const B=p.filter(({key:N})=>N===F)[0];B?(q=C.edit(q,[F],B.value,I),Y=C.edit(Y,[F],B.value,I)):ne.set(F,{key:F,localValue:Q[F],remoteValue:x[F]})};for(const F of W.removed.values())ee.updated.has(F)?se(F):Y=C.edit(Y,[F],void 0,I);for(const F of ee.removed.values())_.has(F)||(W.updated.has(F)?se(F):q=C.edit(q,[F],void 0,I));for(const F of W.updated.values())_.has(F)||(ee.updated.has(F)?J.updated.has(F)&&se(F):Y=C.edit(Y,[F],Q[F],I));for(const F of ee.updated.values())_.has(F)||(W.updated.has(F)?J.updated.has(F)&&se(F):q=C.edit(q,[F],x[F],I));for(const F of W.added.values())_.has(F)||(ee.added.has(F)?J.updated.has(F)&&se(F):Y=u(F,q,Y,I));for(const F of ee.added.values())_.has(F)||(W.added.has(F)?J.updated.has(F)&&se(F):q=u(F,Y,q,I));const K=ne.size>0||!y(q,Y,f),U=K||!y(q,o,[]),P=K||!y(Y,v,[]);return{localContent:U?q:null,remoteContent:P?Y:null,conflictsSettings:[...ne.values()],hasConflicts:K}}e.$XDb=g;function y(o,v,$){if(o===v)return!0;const f=(0,A.$3m)(o),p=(0,A.$3m)(v),I=$.reduce((z,q)=>(z.add(q),z),new Set),T=r(o).filter(z=>!(z.setting&&I.has(z.setting.key))),M=r(v).filter(z=>!(z.setting&&I.has(z.setting.key)));if(T.length!==M.length)return!1;for(let z=0;z<T.length;z++){const q=T[z],Y=M[z];if(q.setting&&Y.setting){if(q.setting.key!==Y.setting.key||!O.$en(f[q.setting.key],p[q.setting.key]))return!1}else if(!q.setting&&!Y.setting){if(q.value!==Y.value)return!1}else return!1}return!0}function w(o){return o?r(o).length===0:!0}e.$YDb=w;function c(o,v,$){const f=o?Object.keys(o).filter(z=>!$.has(z)):[],p=Object.keys(v).filter(z=>!$.has(z)),I=p.filter(z=>!f.includes(z)).reduce((z,q)=>(z.add(q),z),new Set),T=f.filter(z=>!p.includes(z)).reduce((z,q)=>(z.add(q),z),new Set),M=new Set;if(o)for(const z of f){if(T.has(z))continue;const q=o[z],Y=v[z];O.$en(q,Y)||M.add(z)}return{added:I,removed:T,updated:M}}function u(o,v,$,f){const p=(0,A.$3m)(v),I=r(v),T=r($),M=h(o,I,T);return m($,o,p[o],M,T,f)}e.$ZDb=u;function h(o,v,$){const f=v.findIndex(I=>I.setting?.key===o),p=v[f-1];if(p){if(p.setting){const T=s(p.setting.key,$);if(T)return{index:$.indexOf(T),insertAfter:!0}}else{const T=a(f,v);if(T){const M=s(T.setting.key,$);if(M){const z=n($.indexOf(M),$),q=i(v,T,v[f]);if(z){const Y=i($,M,z),Q=t(q,Y);return Q?{index:$.indexOf(Q),insertAfter:!0}:{index:$.indexOf(z),insertAfter:!1}}else{const Y=i($,M,$[$.length-1]),Q=t(q,Y);return Q?{index:$.indexOf(Q),insertAfter:!0}:{index:$.length-1,insertAfter:!0}}}}}const I=v[f+1];if(I)if(I.setting){const T=s(I.setting.key,$);if(T)return{index:$.indexOf(T),insertAfter:!1}}else{const T=n(f,v);if(T){const M=s(T.setting.key,$);if(M){const z=a($.indexOf(M),$),q=i(v,v[f],T);if(z){const Y=i($,z,M),Q=t(q.reverse(),Y.reverse());return Q?{index:$.indexOf(Q),insertAfter:!1}:{index:$.indexOf(z),insertAfter:!0}}else{const Y=i($,$[0],M),Q=t(q.reverse(),Y.reverse());return Q?{index:$.indexOf(Q),insertAfter:!1}:{index:0,insertAfter:!1}}}}}}return{index:$.length-1,insertAfter:!0}}function m(o,v,$,f,p,I){let T;return f.index===-1?T=(0,L.$xT)(o,[v],$,I):T=k(o,v,$,f,p,I).map(M=>(0,L.$yT)(o,M,I)[0]),(0,L.$AT)(o,T)}function k(o,v,$,f,p,I){const T=`${JSON.stringify(v)}: ${JSON.stringify($)}`,M=(0,j.$uT)(I,o),z=p[f.index];if(f.insertAfter){const q=[];if(z.setting)q.push({offset:z.endOffset,length:0,content:","+T});else{const Y=n(f.index,p),Q=a(f.index,p),x=Q?.setting?.commaOffset;Q&&x===void 0&&q.push({offset:Q.endOffset,length:0,content:","});const H=x!==void 0&&x>z.endOffset;q.push({offset:H?x+1:z.endOffset,length:0,content:Y?M+T+",":M+T})}return q}else{if(z.setting)return[{offset:z.startOffset,length:0,content:T+","}];const q=(p[f.index-1]&&!p[f.index-1].setting?M:"")+T+(n(f.index,p)?",":"")+M;return[{offset:z.startOffset,length:0,content:q}]}}function s(o,v){return v.filter($=>$.setting?.key===o)[0]}function a(o,v){for(let $=o-1;$>=0;$--)if(v[$].setting)return v[$]}function n(o,v){for(let $=o+1;$<v.length;$++)if(v[$].setting)return v[$]}function i(o,v,$){const f=o.indexOf(v),p=o.indexOf($);return o.filter((I,T)=>f<T&&T<p)}function t(o,v){if(o.length&&v.length){let $=0;for(;$<v.length&&$<o.length;$++)if(o[$].value!==v[$].value)return v[$-1];return v[$-1]}}function r(o){const v=[];let $=-1,f,p;const I={onObjectBegin:T=>{$++},onObjectProperty:(T,M,z)=>{$===0&&(f=M,p=T)},onObjectEnd:(T,M)=>{$--,$===0&&v.push({startOffset:f,endOffset:T+M,value:o.substring(f,T+M),setting:{key:p,commaOffset:void 0}})},onArrayBegin:(T,M)=>{$++},onArrayEnd:(T,M)=>{$--,$===0&&v.push({startOffset:f,endOffset:T+M,value:o.substring(f,T+M),setting:{key:p,commaOffset:void 0}})},onLiteralValue:(T,M,z)=>{$===0&&v.push({startOffset:f,endOffset:M+z,value:o.substring(f,M+z),setting:{key:p,commaOffset:void 0}})},onSeparator:(T,M,z)=>{if($===0&&T===","){let q=v.length-1;for(;q>=0&&!v[q].setting;q--);const Y=v[q];Y&&v.splice(q,1,{startOffset:Y.startOffset,endOffset:Y.endOffset,value:Y.value,setting:{key:Y.setting.key,commaOffset:M}})}},onComment:(T,M)=>{$===0&&v.push({startOffset:T,endOffset:T+M,value:o.substring(T,T+M)})}};return(0,A.$0m)(o,I),v}}),define(ae[79],ce([0,1,3,2,4,24]),function(ie,e,D,A,L,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$FDb=e.$EDb=void 0,e.$EDb=(0,L.$Vh)("IUserDataSyncAccountService");let O=class extends A.$Rc{get account(){return this.a}constructor(S,d){super(),this.g=S,this.h=d,this.b=this.B(new D.$Rd),this.onDidChangeAccount=this.b.event,this.c=this.B(new D.$Rd),this.onTokenFailed=this.c.event,this.f=!1,this.B(S.onTokenFailed(R=>{this.h.info("Settings Sync auth token failed",this.account?.authenticationProviderId,this.f,R),this.updateAccount(void 0),R==="Forbidden"?this.c.fire(!0):this.c.fire(this.f),this.f=!0})),this.B(S.onTokenSucceed(()=>this.f=!1))}async updateAccount(S){(S&&this.a?S.token!==this.a.token||S.authenticationProviderId!==this.a.authenticationProviderId:S!==this.a)&&(this.a=S,this.a&&this.g.setAuthToken(this.a.token,this.a.authenticationProviderId),this.b.fire(S))}};e.$FDb=O,e.$FDb=O=pe([X(0,j.$Ygb),X(1,j.$bhb)],O)}),define(ae[238],ce([0,1,2,10]),function(ie,e,D,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$s0b=e.$r0b=e.$q0b=e.$p0b=e.$o0b=e.$n0b=e.$m0b=void 0;class L{constructor(b){this.a=b}listen(b,l){switch(l){case"onError":return this.a.onError}throw new Error(`Event not found: ${l}`)}call(b,l,g){switch(l){case"triggerSync":return this.a.triggerSync(g[0],g[1],g[2]);case"turnOn":return this.a.turnOn();case"turnOff":return this.a.turnOff(g[0])}throw new Error("Invalid call")}}e.$m0b=L;class j{constructor(b){this.a=b}listen(b,l){throw new Error(`Event not found: ${l}`)}call(b,l,g){switch(l){case"resolveDefaultIgnoredSettings":return this.a.resolveDefaultIgnoredSettings();case"resolveUserKeybindings":return this.a.resolveUserBindings(g[0]);case"resolveFormattingOptions":return this.a.resolveFormattingOptions(A.URI.revive(g[0]))}throw new Error("Invalid call")}}e.$n0b=j;class O{constructor(b){this.a=b}async resolveDefaultIgnoredSettings(){return this.a.call("resolveDefaultIgnoredSettings")}async resolveUserBindings(b){return this.a.call("resolveUserKeybindings",[b])}async resolveFormattingOptions(b){return this.a.call("resolveFormattingOptions",[b])}}e.$o0b=O;class C{constructor(b){this.a=b}listen(b,l){switch(l){case"onDidChange":return this.a.onDidChange}throw new Error(`Event not found: ${l}`)}async call(b,l,g){switch(l){case"getMachines":return this.a.getMachines();case"addCurrentMachine":return this.a.addCurrentMachine();case"removeCurrentMachine":return this.a.removeCurrentMachine();case"renameMachine":return this.a.renameMachine(g[0],g[1]);case"setEnablements":return this.a.setEnablements(g)}throw new Error("Invalid call")}}e.$p0b=C;class S{constructor(b){this.a=b}listen(b,l){switch(l){case"onDidChangeAccount":return this.a.onDidChangeAccount;case"onTokenFailed":return this.a.onTokenFailed}throw new Error(`Event not found: ${l}`)}call(b,l,g){switch(l){case"_getInitialData":return Promise.resolve(this.a.account);case"updateAccount":return this.a.updateAccount(g)}throw new Error("Invalid call")}}e.$q0b=S;class d{constructor(b){this.a=b}listen(b,l){switch(l){case"onDidChangeUserDataSyncStore":return this.a.onDidChangeUserDataSyncStore}throw new Error(`Event not found: ${l}`)}call(b,l,g){switch(l){case"switch":return this.a.switch(g[0]);case"getPreviousUserDataSyncStore":return this.a.getPreviousUserDataSyncStore()}throw new Error("Invalid call")}}e.$r0b=d;class R extends D.$Rc{constructor(b){super(),this.a=b,this.onDidChangeUserDataSyncStore=this.a.listen("onDidChangeUserDataSyncStore")}async switch(b){return this.a.call("switch",[b])}async getPreviousUserDataSyncStore(){const b=await this.a.call("getPreviousUserDataSyncStore");return this.b(b)}b(b){return{url:A.URI.revive(b.url),type:b.type,defaultUrl:A.URI.revive(b.defaultUrl),insidersUrl:A.URI.revive(b.insidersUrl),stableUrl:A.URI.revive(b.stableUrl),canSwitch:b.canSwitch,authenticationProviders:b.authenticationProviders}}}e.$s0b=R}),define(ae[239],ce([0,1,19,174,14,8,24]),function(ie,e,D,A,L,j,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$RFb=void 0;let C=class extends j.$ij{constructor(d,R){super(),this.g=this.B(d.createLogger((0,D.$zg)(R.logsHome,`${O.$chb}.log`),{id:O.$chb,name:(0,A.localize)(0,null)}))}trace(d,...R){this.g.trace(d,...R)}debug(d,...R){this.g.debug(d,...R)}info(d,...R){this.g.info(d,...R)}warn(d,...R){this.g.warn(d,...R)}error(d,...R){this.g.error(d,...R)}flush(){this.g.flush()}};e.$RFb=C,e.$RFb=C=pe([X(0,j.$ej),X(1,L.$3h)],C)}),define(ae[240],ce([0,1,6,3,2]),function(ie,e,D,A,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$n9b=void 0;class j extends L.$Rc{constructor({onDidOpenMainWindow:C,onDidFocusMainWindow:S,getActiveWindowId:d}){super(),this.a=this.B(new L.$Qc),A.Event.latch(A.Event.any(C,S))(this.f,this,this.a),this.b=(0,D.$Lg)(()=>d()),(async()=>{try{const E=await this.b;this.c=typeof this.c=="number"?this.c:E}catch{}finally{this.b=void 0}})()}f(C){this.b&&(this.b.cancel(),this.b=void 0),this.c=C}async getActiveClientId(){return`window:${this.b?await this.b:this.c}`}}e.$n9b=j}),define(ae[112],ce([0,1,177,16,47,19,10,4,23]),function(ie,e,D,A,L,j,O,C,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$oi=e.$ni=e.$mi=e.$li=e.$ki=e.$ji=e.$ii=e.$hi=e.$gi=e.$fi=e.$ei=e.$di=e.$ci=e.$bi=e.$ai=e.WorkbenchState=e.$_h=e.$$h=e.$0h=e.$9h=e.$8h=e.$7h=e.$6h=e.$5h=void 0,e.$5h=(0,C.$Vh)("contextService");function d(i){const t=i;return typeof t?.id=="string"&&O.URI.isUri(t.uri)}e.$6h=d;function R(i){return typeof i?.id=="string"&&!d(i)&&!b(i)}e.$7h=R,e.$8h={id:"ext-dev"},e.$9h={id:"empty-window"};function E(i,t){if(typeof i=="string"||typeof i>"u")return typeof i=="string"?{id:(0,A.$mc)(i)}:t?e.$8h:e.$9h;const r=i;return r.configuration?{id:r.id,configPath:r.configuration}:r.folders.length===1?{id:r.id,uri:r.folders[0].uri}:{id:r.id}}e.$0h=E;function b(i){const t=i;return typeof t?.id=="string"&&O.URI.isUri(t.configPath)}e.$$h=b;function l(i){const t=i;if(t?.uri)return{id:t.id,uri:O.URI.revive(t.uri)};const r=i;if(r?.configPath)return{id:r.id,configPath:O.URI.revive(r.configPath)};if(i?.id)return{id:i.id}}e.$_h=l;var g;(function(i){i[i.EMPTY=1]="EMPTY",i[i.FOLDER=2]="FOLDER",i[i.WORKSPACE=3]="WORKSPACE"})(g||(e.WorkbenchState=g={}));function y(i){const t=i;return!!(t&&typeof t=="object"&&typeof t.id=="string"&&Array.isArray(t.folders))}e.$ai=y;function w(i){const t=i;return!!(t&&typeof t=="object"&&O.URI.isUri(t.uri)&&typeof t.name=="string"&&typeof t.toResource=="function")}e.$bi=w;class c{constructor(t,r,o,v,$){this.h=t,this.j=o,this.k=v,this.l=$,this.c=L.$2h.forUris(this.l,()=>!0),this.folders=r}update(t){this.h=t.id,this.k=t.configuration,this.j=t.transient,this.l=t.l,this.folders=t.folders}get folders(){return this.g}set folders(t){this.g=t,this.n()}get id(){return this.h}get transient(){return this.j}get configuration(){return this.k}set configuration(t){this.k=t}getFolder(t){return t&&this.c.findSubstr(t)||null}n(){this.c=L.$2h.forUris(this.l,()=>!0);for(const t of this.folders)this.c.set(t.uri,t)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.$ci=c;class u{constructor(t,r){this.raw=r,this.uri=t.uri,this.index=t.index,this.name=t.name}toResource(t){return(0,j.$zg)(this.uri,t)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.$di=u;function h(i){return new u({uri:i,index:0,name:(0,j.$vg)(i)},{uri:i.toString()})}e.$ei=h,e.$fi="code-workspace",e.$gi=`.${e.$fi}`,e.$hi=[{name:(0,D.localize)(0,null),extensions:[e.$fi]}],e.$ii="workspace.json";function m(i,t){return j.$qg.isEqualOrParent(i,t.untitledWorkspacesHome)}e.$ji=m;function k(i){let t;return O.URI.isUri(i)?t=i:t=i.configuration,t?.scheme===S.Schemas.tmp}e.$ki=k,e.$li="4064f6ec-cb38-4ad0-af64-ee6467e63c82";function s(i){return i.id===e.$li}e.$mi=s;function a(i,t){return!m(i,t)&&!k(i)}e.$ni=a;function n(i){return(typeof i=="string"?(0,A.$nc)(i):(0,j.$xg)(i))===e.$gi}e.$oi=n}),define(ae[17],ce([0,1,52,3,2,19,10,168,14,11,4,8,112,34,28,6,32,27,12]),function(ie,e,D,A,L,j,O,C,S,d,R,E,b,l,g,y,w,c,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Uk=e.$Tk=e.$Sk=e.$Rk=e.$Qk=e.$Pk=e.ProfileResourceType=void 0;var h;(function(i){i.Settings="settings",i.Keybindings="keybindings",i.Snippets="snippets",i.Tasks="tasks",i.Extensions="extensions",i.GlobalState="globalState"})(h||(e.ProfileResourceType=h={}));function m(i){const t=i;return!!(t&&typeof t=="object"&&typeof t.id=="string"&&typeof t.isDefault=="boolean"&&typeof t.name=="string"&&O.URI.isUri(t.location)&&O.URI.isUri(t.globalStorageHome)&&O.URI.isUri(t.settingsResource)&&O.URI.isUri(t.keybindingsResource)&&O.URI.isUri(t.tasksResource)&&O.URI.isUri(t.snippetsHome)&&O.URI.isUri(t.extensionsResource))}e.$Pk=m,e.$Qk=(0,R.$Vh)("IUserDataProfilesService");function k(i,t){return{id:i.id,isDefault:i.isDefault,name:i.name,shortName:i.shortName,icon:i.icon,location:O.URI.revive(i.location).with({scheme:t}),globalStorageHome:O.URI.revive(i.globalStorageHome).with({scheme:t}),settingsResource:O.URI.revive(i.settingsResource).with({scheme:t}),keybindingsResource:O.URI.revive(i.keybindingsResource).with({scheme:t}),tasksResource:O.URI.revive(i.tasksResource).with({scheme:t}),snippetsHome:O.URI.revive(i.snippetsHome).with({scheme:t}),extensionsResource:O.URI.revive(i.extensionsResource).with({scheme:t}),cacheHome:O.URI.revive(i.cacheHome).with({scheme:t}),useDefaultFlags:i.useDefaultFlags,isTransient:i.isTransient}}e.$Rk=k;function s(i,t,r,o,v,$){return{id:i,name:t,location:r,isDefault:!1,shortName:v?.shortName,icon:v?.icon,globalStorageHome:$&&v?.useDefaultFlags?.globalState?$.globalStorageHome:(0,j.$zg)(r,"globalStorage"),settingsResource:$&&v?.useDefaultFlags?.settings?$.settingsResource:(0,j.$zg)(r,"settings.json"),keybindingsResource:$&&v?.useDefaultFlags?.keybindings?$.keybindingsResource:(0,j.$zg)(r,"keybindings.json"),tasksResource:$&&v?.useDefaultFlags?.tasks?$.tasksResource:(0,j.$zg)(r,"tasks.json"),snippetsHome:$&&v?.useDefaultFlags?.snippets?$.snippetsHome:(0,j.$zg)(r,"snippets"),extensionsResource:$&&v?.useDefaultFlags?.extensions?$.extensionsResource:(0,j.$zg)(r,"extensions.json"),cacheHome:(0,j.$zg)(o,i),useDefaultFlags:v?.useDefaultFlags,isTransient:v?.transient}}e.$Sk=s;let a=class extends L.$Rc{static{this.b="userDataProfiles"}static{this.c="profileAssociations"}get defaultProfile(){return this.profiles[0]}get profiles(){return[...this.C.profiles,...this.s.profiles]}constructor(t,r,o,v){super(),this.t=t,this.u=r,this.w=o,this.y=v,this.f=!0,this.h=this.B(new A.$Rd),this.onDidChangeProfiles=this.h.event,this.j=this.B(new A.$Rd),this.onWillCreateProfile=this.j.event,this.m=this.B(new A.$Rd),this.onWillRemoveProfile=this.m.event,this.n=this.B(new A.$Rd),this.onDidResetWorkspaces=this.n.event,this.r=new Map,this.s={profiles:[],workspaces:new l.$zc,emptyWindows:new Map},this.profilesHome=(0,j.$zg)(this.t.userRoamingDataHome,"profiles"),this.g=(0,j.$zg)(this.t.cacheHome,"CachedProfilesData")}init(){this.z=void 0}setEnablement(t){this.f!==t&&(this.z=void 0,this.f=t)}isEnabled(){return this.f}get C(){if(!this.z){const t=this.D(),r=[t];if(this.f)try{for(const $ of this.O()){if(!$.name||!(0,u.$Cf)($.name)||!$.location){this.y.warn("Skipping the invalid stored profile",$.location||$.name);continue}r.push(s((0,j.$wg)($.location),$.name,$.location,this.g,{shortName:$.shortName,icon:$.icon,useDefaultFlags:$.useDefaultFlags},t))}}catch($){this.y.error($)}const o=new l.$zc,v=new Map;if(r.length)try{const $=this.Q();if($.workspaces)for(const[f,p]of Object.entries($.workspaces)){const I=O.URI.parse(f),T=r.find(M=>M.id===p);T&&o.set(I,T)}if($.emptyWindows)for(const[f,p]of Object.entries($.emptyWindows)){const I=r.find(T=>T.id===p);I&&v.set(f,I)}}catch($){this.y.error($)}this.z={profiles:r,workspaces:o,emptyWindows:v}}return this.z}D(){const t=s("__default__profile__",(0,C.localize)(0,null),this.t.userRoamingDataHome,this.g);return{...t,extensionsResource:this.S()??t.extensionsResource,isDefault:!0}}async createTransientProfile(t){const r="Temp",o=new RegExp(`${(0,c.$Je)(r)}\\s(\\d+)`);let v=0;for(const f of this.profiles){const p=o.exec(f.name),I=p?parseInt(p[1]):0;v=I>v?I:v}const $=`${r} ${v+1}`;return this.createProfile((0,D.$Ji)((0,w.$ig)()).toString(16),$,{transient:!0},t)}async createNamedProfile(t,r,o){return this.createProfile((0,D.$Ji)((0,w.$ig)()).toString(16),t,r,o)}async createProfile(t,r,o,v){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const $=await this.F(t,r,o);return v&&await this.setProfileForWorkspace(v,$),$}async F(t,r,o){if(!(0,u.$Cf)(r)||!r)throw new Error("Name of the profile is mandatory and must be of type `string`");let v=this.r.get(r);return v||(v=(async()=>{try{const $=this.profiles.find(I=>I.name===r||I.id===t);if($)return $;const f=s(t,r,(0,j.$zg)(this.profilesHome,t),this.g,o,this.defaultProfile);await this.u.createFolder(f.location);const p=[];return this.j.fire({profile:f,join(I){p.push(I)}}),await y.Promises.settled(p),this.I([f],[],[]),f}finally{this.r.delete(r)}})(),this.r.set(r,v)),v}async updateProfile(t,r){if(!this.f)throw new Error("Profiles are disabled in the current environment.");let o=this.profiles.find(v=>v.id===t.id);if(!o)throw new Error(`Profile '${t.name}' does not exist`);return o=s(o.id,r.name??o.name,o.location,this.g,{shortName:r.shortName??o.shortName,icon:r.icon===null?void 0:r.icon??o.icon,transient:r.transient??o.isTransient,useDefaultFlags:r.useDefaultFlags??o.useDefaultFlags},this.defaultProfile),this.I([],[],[o]),o}async removeProfile(t){if(!this.f)throw new Error("Profiles are disabled in the current environment.");if(t.isDefault)throw new Error("Cannot remove default profile");const r=this.profiles.find(v=>v.id===t.id);if(!r)throw new Error(`Profile '${t.name}' does not exist`);const o=[];this.m.fire({profile:r,join(v){o.push(v)}});try{await Promise.allSettled(o)}catch(v){this.y.error(v)}for(const v of[...this.C.emptyWindows.keys()])r.id===this.C.emptyWindows.get(v)?.id&&this.C.emptyWindows.delete(v);for(const v of[...this.C.workspaces.keys()])r.id===this.C.workspaces.get(v)?.id&&this.C.workspaces.delete(v);this.M(),this.I([],[r],[]);try{await this.u.del(r.cacheHome,{recursive:!0})}catch(v){(0,d.$vk)(v)!==1&&this.y.error(v)}}async setProfileForWorkspace(t,r){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const o=this.profiles.find(v=>v.id===r.id);if(!o)throw new Error(`Profile '${r.name}' does not exist`);this.L(t,o)}unsetWorkspace(t,r){if(!this.f)throw new Error("Profiles are disabled in the current environment.");this.L(t,void 0,r)}async resetWorkspaces(){this.s.workspaces.clear(),this.s.emptyWindows.clear(),this.C.workspaces.clear(),this.C.emptyWindows.clear(),this.M(),this.n.fire()}async cleanUp(){if(this.f&&await this.u.exists(this.profilesHome)){const t=await this.u.resolve(this.profilesHome);await Promise.all((t.children||[]).filter(r=>r.isDirectory&&this.profiles.every(o=>!this.w.extUri.isEqual(o.location,r.resource))).map(r=>this.u.del(r.resource,{recursive:!0})))}}async cleanUpTransientProfiles(){if(!this.f)return;const t=this.s.profiles.filter(r=>!this.H(r));await Promise.allSettled(t.map(r=>this.removeProfile(r)))}getProfileForWorkspace(t){const r=this.G(t);return O.URI.isUri(r)?this.s.workspaces.get(r)??this.C.workspaces.get(r):this.s.emptyWindows.get(r)??this.C.emptyWindows.get(r)}G(t){return(0,b.$6h)(t)?t.uri:(0,b.$$h)(t)?t.configPath:t.id}H(t){return!!([...this.s.emptyWindows.values()].some(r=>this.w.extUri.isEqual(r.location,t.location))||[...this.s.workspaces.values()].some(r=>this.w.extUri.isEqual(r.location,t.location))||[...this.C.emptyWindows.values()].some(r=>this.w.extUri.isEqual(r.location,t.location))||[...this.C.workspaces.values()].some(r=>this.w.extUri.isEqual(r.location,t.location)))}I(t,r,o){const v=[...this.profiles,...t],$=[];this.s.profiles=[];for(let f of v)f.isDefault||r.some(p=>f.id===p.id)||(f=o.find(p=>f.id===p.id)??f,f.isTransient?this.s.profiles.push(f):$.push({location:f.location,name:f.name,shortName:f.shortName,icon:f.icon,useDefaultFlags:f.useDefaultFlags}));this.P($),this.z=void 0,this.J(t,r,o)}J(t,r,o){this.h.fire({added:t,removed:r,updated:o,all:this.profiles})}L(t,r,o){o=r?.isTransient?!0:o,o||this.L(t,void 0,!0);const v=this.G(t),$=o?this.s:this.C;O.URI.isUri(v)?($.workspaces.delete(v),r&&$.workspaces.set(v,r)):($.emptyWindows.delete(v),r&&$.emptyWindows.set(v,r)),o||this.M()}M(){const t={};for(const[o,v]of this.C.workspaces.entries())t[o.toString()]=v.id;const r={};for(const[o,v]of this.C.emptyWindows.entries())r[o.toString()]=v.id;this.R({workspaces:t,emptyWindows:r}),this.z=void 0}N(t){const r={},o=this.D();if(t.workspaces)for(const[$,f]of Object.entries(t.workspaces)){const p=O.URI.parse(f);r[$]=this.w.extUri.isEqual(p,o.location)?o.id:this.w.extUri.basename(p)}const v={};if(t.emptyWindows)for(const[$,f]of Object.entries(t.emptyWindows)){const p=O.URI.parse(f);v[$]=this.w.extUri.isEqual(p,o.location)?o.id:this.w.extUri.basename(p)}return{workspaces:r,emptyWindows:v}}O(){return[]}P(t){throw new Error("not implemented")}Q(){return{}}R(t){throw new Error("not implemented")}S(){}};e.$Tk=a,e.$Tk=a=pe([X(0,S.$3h),X(1,d.$ek),X(2,g.$Ok),X(3,E.$dj)],a);class n extends a{constructor(){super(...arguments),this.a=[],this.X={}}O(){return this.a}P(t){this.a=t}Q(){return this.X}R(t){this.X=t}}e.$Uk=n}),define(ae[241],ce([0,1,6,2,17]),function(ie,e,D,A,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$A0b=void 0;let j=class extends A.$Rc{constructor(C){super(),this.B(new D.$0g(()=>{C.cleanUp()},10*1e3)).schedule()}};e.$A0b=j,e.$A0b=j=pe([X(0,L.$Qk)],j)}),define(ae[242],ce([0,1,18,6,26,7,3,2,5,12,10,151,29,33,44,8,25,22,28,17]),function(ie,e,D,A,L,j,O,C,S,d,R,E,b,l,g,y,w,c,u,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yp=e.$xp=e.$wp=e.$vp=void 0;let m=class extends C.$Rc{get onInstallExtension(){return this.n.event}get onDidInstallExtensions(){return this.s.event}get onUninstallExtension(){return this.t.event}get onDidUninstallExtension(){return this.u.event}get onDidUpdateExtensionMetadata(){return this.w.event}constructor(t,r,o,v,$,f){super(),this.z=t,this.C=r,this.D=o,this.F=v,this.G=$,this.H=f,this.h=0,this.j=new Map,this.m=new Map,this.n=this.B(new O.$Rd),this.s=this.B(new O.$Rd),this.t=this.B(new O.$Rd),this.u=this.B(new O.$Rd),this.w=this.B(new O.$Rd),this.y=[],this.B((0,C.$Pc)(()=>{this.j.forEach(({task:p})=>p.cancel()),this.m.forEach(p=>p.cancel()),this.j.clear(),this.m.clear()}))}async canInstall(t){const r=await this.getTargetPlatform();return t.allTargetPlatforms.some(o=>(0,b.$bo)(o,t.allTargetPlatforms,r))}async installFromGallery(t,r={}){try{const v=(await this.installGalleryExtensions([{extension:t,options:r}])).find(({identifier:$})=>(0,l.$Fo)($,t.identifier));if(v?.local)return v?.local;throw v?.error?v.error:s(new Error(`Unknown error while installing extension ${t.identifier.id}`))}catch(o){throw s(o)}}async installGalleryExtensions(t){if(!this.z.isEnabled())throw new b.$eo(E.localize(0,null),b.ExtensionManagementErrorCode.Internal);const r=[],o=[];await Promise.allSettled(t.map(async({extension:v,options:$})=>{try{const f=await this.O(v,!!$?.installGivenVersion,!!$?.installPreReleaseVersion);o.push({...f,options:$})}catch(f){r.push({identifier:v.identifier,operation:2,source:v,error:f})}})),o.length&&r.push(...await this.I(o));for(const v of r)v.error&&(this.F.error("Failed to install extension.",v.identifier.id),this.F.error(v.error),v.source&&!R.URI.isUri(v.source)&&a(this.C,"extensionGallery:install",{extensionData:(0,l.$No)(v.source),error:v.error}));return r}async uninstall(t,r={}){return this.F.trace("ExtensionManagementService#uninstall",t.identifier.id),this.Q(t,r)}async toggleAppliationScope(t,r){if((0,g.$cm)(t.manifest)||t.isBuiltin)return t;if(t.isApplicationScoped){let o=await this.updateMetadata(t,{isApplicationScoped:!1},this.H.defaultProfile.extensionsResource);this.D.extUri.isEqual(r,this.H.defaultProfile.extensionsResource)||(o=await this.ab(t,this.H.defaultProfile.extensionsResource,r));for(const v of this.H.profiles){const $=(await this.getInstalled(1,v.extensionsResource)).find(f=>(0,l.$Fo)(f.identifier,t.identifier));$?this.w.fire($):this.u.fire({identifier:t.identifier,profileLocation:v.extensionsResource})}return o}else{const o=this.D.extUri.isEqual(r,this.H.defaultProfile.extensionsResource)?await this.updateMetadata(t,{isApplicationScoped:!0},this.H.defaultProfile.extensionsResource):await this.ab(t,r,this.H.defaultProfile.extensionsResource,{isApplicationScoped:!0});return this.s.fire([{identifier:o.identifier,operation:2,local:o,profileLocation:this.H.defaultProfile.extensionsResource,applicationScoped:!0}]),o}}getExtensionsControlManifest(){const t=new Date().getTime();return(!this.g||t-this.h>1e3*60*5)&&(this.g=this.X(),this.h=t),this.g}registerParticipant(t){this.y.push(t)}async I(t){const r=[];return await Promise.allSettled(t.map(async o=>{try{const v=await this.J(o,($,f)=>t.some(p=>(0,l.$Jo)(f.identifier.id)===(0,l.$Ko)(p.manifest.publisher,p.manifest.name))?!1:this.L($,f));r.push(...v)}catch(v){r.push({identifier:{id:(0,l.$Ko)(o.manifest.publisher,o.manifest.name)},operation:2,source:o.extension,error:v})}})),this.s.fire(r),r}async J({manifest:t,extension:r,options:o},v){const $=o.isApplicationScoped||o.isBuiltin||(0,g.$cm)(t),f={...o,installOnlyNewlyAddedFromExtensionPack:R.URI.isUri(r)?o.installOnlyNewlyAddedFromExtensionPack:!0,isApplicationScoped:$,profileLocation:$?this.H.defaultProfile.extensionsResource:o.profileLocation??this.Y()},p=Y=>`${l.$Go.create(Y).toString()}${f.profileLocation?`-${f.profileLocation.toString()}`:""}`;if(!R.URI.isUri(r)){const Y=this.j.get(p(r));if(Y)return this.F.info("Extensions is already requested to install",r.identifier.id),await Y.task.waitUntilTaskIsFinished(),[]}const I=[],T=[],M=[],z=this.Z(t,r,f);R.URI.isUri(r)||this.j.set(p(r),{task:z,waitingTasks:[]}),this.n.fire({identifier:z.identifier,source:r,profileLocation:f.profileLocation}),this.F.info("Installing extension:",z.identifier.id),I.push({task:z,manifest:t});let q=!1;try{if(f.donotIncludePackAndDependencies)this.F.info("Installing the extension without checking dependencies and pack",z.identifier.id);else try{const Q=await this.N(z.identifier,t,!!f.installOnlyNewlyAddedFromExtensionPack,!!f.installPreReleaseVersion,f.profileLocation),x=await this.getInstalled(void 0,f.profileLocation),H={...f,donotIncludePackAndDependencies:!0,context:{...f.context,[b.$9n]:!0}};for(const{gallery:Z,manifest:J}of(0,D.$Lb)(Q,({gallery:W})=>W.identifier.id)){q=q||!!J.extensionDependencies?.some(ne=>(0,l.$Fo)({id:ne},z.identifier));const W=p(Z),ee=this.j.get(W);if(ee){if(v(z,ee.task)){const ne=ee.task.identifier;this.F.info("Waiting for already requested installing extension",ne.id,z.identifier.id),ee.waitingTasks.push(z),T.push(O.Event.toPromise(O.Event.filter(this.onDidInstallExtensions,_=>_.some(se=>(0,l.$Fo)(se.identifier,ne)))).then(_=>{if(this.F.info("Finished waiting for already requested installing extension",ne.id,z.identifier.id),!_.find(K=>(0,l.$Fo)(K.identifier,ne))?.local)throw new Error(`Extension ${ne.id} is not installed`)}))}}else if(!x.some(({identifier:ne})=>(0,l.$Fo)(ne,Z.identifier))){const ne=this.Z(J,Z,H);this.j.set(W,{task:ne,waitingTasks:[z]}),this.n.fire({identifier:ne.identifier,source:Z,profileLocation:f.profileLocation}),this.F.info("Installing extension:",ne.identifier.id,z.identifier.id),I.push({task:ne,manifest:J})}}}catch(Q){if(R.URI.isUri(z.source))(0,D.$Kb)(t.extensionDependencies)&&this.F.warn("Cannot install dependencies of extension:",z.identifier.id,Q.message),(0,D.$Kb)(t.extensionPack)&&this.F.warn("Cannot install packed extensions of extension:",z.identifier.id,Q.message);else throw this.F.error("Error while preparing to install dependencies and extension packs of the extension:",z.identifier.id),Q}const Y=I.reduce((Q,{task:x,manifest:H})=>(Q.set(x.identifier.id.toLowerCase(),{task:x,manifest:H}),Q),new Map);for(;Y.size;){let Q;const x=[...Y.values()].filter(({manifest:H})=>!H.extensionDependencies?.some(Z=>Y.has(Z.toLowerCase())));x.length?Q=Y.size===1?x:x.filter(({task:H})=>!(H===z&&!q)):(this.F.info("Found extensions with circular dependencies",x.map(({task:H})=>H.identifier.id)),Q=[...Y.values()]),await this.M(Q.map(async({task:H})=>{const Z=new Date().getTime();try{const J=await H.run();if(await this.M(this.y.map(W=>W.postInstall(J,H.source,f,L.CancellationToken.None))),!R.URI.isUri(H.source)){const W=H.operation===3,ee=W?void 0:(new Date().getTime()-H.source.lastUpdated)/1e3;if(a(this.C,W?"extensionGallery:update":"extensionGallery:install",{extensionData:(0,l.$No)(H.source),verificationStatus:H.verificationStatus,duration:new Date().getTime()-Z,durationSinceUpdate:ee}),S.$o&&H.operation!==3)try{await this.z.reportStatistic(J.manifest.publisher,J.manifest.name,J.manifest.version,"install")}catch{}}M.push({local:J,identifier:H.identifier,operation:H.operation,source:H.source,context:H.options.context,profileLocation:H.profileLocation,applicationScoped:J.isApplicationScoped})}catch(J){throw R.URI.isUri(H.source)||a(this.C,H.operation===3?"extensionGallery:update":"extensionGallery:install",{extensionData:(0,l.$No)(H.source),verificationStatus:H.verificationStatus,duration:new Date().getTime()-Z,error:J}),this.F.error("Error while installing the extension:",H.identifier.id),J}finally{Y.delete(H.identifier.id.toLowerCase())}}))}return T.length&&await this.M(T),M.forEach(({identifier:Q})=>this.F.info("Extension installed successfully:",Q.id)),M}catch(Y){if(I.forEach(({task:Q})=>Q.cancel()),M.length)try{const Q=await Promise.allSettled(M.map(({local:x})=>this.$(x,{versionOnly:!0,profileLocation:f.profileLocation}).run()));for(let x=0;x<Q.length;x++){const H=Q[x],{identifier:Z}=M[x];H.status==="fulfilled"?this.F.info("Rollback: Uninstalled extension",Z.id):this.F.warn("Rollback: Error while uninstalling extension",Z.id,(0,j.$9)(H.reason))}}catch(Q){this.F.warn("Error while rolling back extensions",(0,j.$9)(Q),M.map(({identifier:x})=>x.id))}return I.map(({task:Q})=>({identifier:Q.identifier,operation:2,source:Q.source,context:f.context,profileLocation:f.profileLocation,error:Y}))}finally{for(const{task:Y}of I)Y.source&&!R.URI.isUri(Y.source)&&this.j.delete(p(Y.source))}}L(t,r){for(const[,{task:o,waitingTasks:v}]of this.j.entries())if(o===t&&(v.includes(r)||v.some($=>this.L($,r)))||o===r&&v[0]&&!this.L(t,v[0]))return!1;return!0}async M(t){const r=[],o=[],v=await Promise.allSettled(t);for(const $ of v)$.status==="fulfilled"?r.push($.value):o.push($.reason);if(o.length)throw k(o);return r}async N(t,r,o,v,$){if(!this.z.isEnabled())return[];const f=await this.getInstalled(void 0,$),p=[],I=[],T=async(M,z)=>{p.push(M);const q=z.extensionDependencies||[],Y=[...q];if(z.extensionPack){const Q=o?f.find(x=>(0,l.$Fo)(x.identifier,M)):void 0;for(const x of z.extensionPack)Q&&Q.manifest.extensionPack&&Q.manifest.extensionPack.some(H=>(0,l.$Fo)({id:H},{id:x}))||Y.every(H=>!(0,l.$Fo)({id:H},{id:x}))&&Y.push(x)}if(Y.length){const Q=Y.filter(x=>p.every(H=>!(0,l.$Fo)(H,{id:x})));if(Q.length){const x=await this.z.getExtensions(Q.map(H=>({id:H,preRelease:v})),L.CancellationToken.None);for(const H of x){if(p.find(W=>(0,l.$Fo)(W,H.identifier)))continue;const Z=q.some(W=>(0,l.$Fo)({id:W},H.identifier));let J;try{J=await this.O(H,!1,v)}catch(W){if(Z)throw W;this.F.info("Skipping the packed extension as it cannot be installed",H.identifier.id,(0,j.$9)(W));continue}I.push({gallery:J.extension,manifest:J.manifest}),await T(J.extension.identifier,J.manifest)}}}};return await T(t,r),I}async O(t,r,o){let v;const $=await this.getExtensionsControlManifest();if($.malicious.some(I=>(0,l.$Fo)(t.identifier,I)))throw new b.$eo(E.localize(1,null,t.identifier.id),b.ExtensionManagementErrorCode.Malicious);const f=$.deprecated[t.identifier.id.toLowerCase()];if(f?.extension?.autoMigrate){if(this.F.info(`The '${t.identifier.id}' extension is deprecated, fetching the compatible '${f.extension.id}' extension instead.`),v=(await this.z.getExtensions([{id:f.extension.id,preRelease:f.extension.preRelease}],{targetPlatform:await this.getTargetPlatform(),compatible:!0},L.CancellationToken.None))[0],!v)throw new b.$eo(E.localize(2,null,t.identifier.id,f.extension.id),b.ExtensionManagementErrorCode.Deprecated)}else{if(!await this.canInstall(t)){const I=await this.getTargetPlatform();throw new b.$eo(E.localize(3,null,t.identifier.id,this.G.nameLong,(0,b.$0n)(I)),b.ExtensionManagementErrorCode.IncompatibleTargetPlatform)}if(v=await this.P(t,r,o),!v)throw!o&&t.properties.isPreReleaseVersion&&(await this.z.getExtensions([t.identifier],L.CancellationToken.None))[0]?new b.$eo(E.localize(4,null,t.identifier.id),b.ExtensionManagementErrorCode.ReleaseVersionNotFound):new b.$eo(E.localize(5,null,t.identifier.id,this.G.nameLong,this.G.version),b.ExtensionManagementErrorCode.Incompatible)}this.F.info("Getting Manifest...",v.identifier.id);const p=await this.z.getManifest(v,L.CancellationToken.None);if(p===null)throw new b.$eo(`Missing manifest for extension ${v.identifier.id}`,b.ExtensionManagementErrorCode.Invalid);if(p.version!==v.version)throw new b.$eo(`Cannot install '${v.identifier.id}' extension because of version mismatch in Marketplace`,b.ExtensionManagementErrorCode.Invalid);return{extension:v,manifest:p}}async P(t,r,o){const v=await this.getTargetPlatform();let $=null;return!r&&t.hasPreReleaseVersion&&t.properties.isPreReleaseVersion!==o&&($=(await this.z.getExtensions([{...t.identifier,preRelease:o}],{targetPlatform:v,compatible:!0},L.CancellationToken.None))[0]||null),!$&&await this.z.isExtensionCompatible(t,o,v)&&($=t),$||(r?$=(await this.z.getExtensions([{...t.identifier,version:t.version}],{targetPlatform:v,compatible:!0},L.CancellationToken.None))[0]||null:$=await this.z.getCompatibleExtension(t,o,v)),$}async Q(t,r){const o={...r,profileLocation:t.isApplicationScoped?this.H.defaultProfile.extensionsResource:r.profileLocation??this.Y()},v=M=>`${M.id.toLowerCase()}${o.versionOnly?`-${t.manifest.version}`:""}${o.profileLocation?`@${o.profileLocation.toString()}`:""}`,$=this.m.get(v(t.identifier));if($)return this.F.info("Extensions is already requested to uninstall",t.identifier.id),$.waitUntilTaskIsFinished();const f=M=>{const z=this.$(M,o);return this.m.set(v(z.extension.identifier),z),o.profileLocation?this.F.info("Uninstalling extension from the profile:",`${M.identifier.id}@${M.manifest.version}`,o.profileLocation.toString()):this.F.info("Uninstalling extension:",`${M.identifier.id}@${M.manifest.version}`),this.t.fire({identifier:M.identifier,profileLocation:o.profileLocation,applicationScoped:M.isApplicationScoped}),z},p=(M,z)=>{z?o.profileLocation?this.F.error("Failed to uninstall extension from the profile:",`${M.identifier.id}@${M.manifest.version}`,o.profileLocation.toString(),z.message):this.F.error("Failed to uninstall extension:",`${M.identifier.id}@${M.manifest.version}`,z.message):o.profileLocation?this.F.info("Successfully uninstalled extension from the profile",`${M.identifier.id}@${M.manifest.version}`,o.profileLocation.toString()):this.F.info("Successfully uninstalled extension:",`${M.identifier.id}@${M.manifest.version}`),a(this.C,"extensionGallery:uninstall",{extensionData:(0,l.$Mo)(M),error:z}),this.u.fire({identifier:M.identifier,error:z?.code,profileLocation:o.profileLocation,applicationScoped:M.isApplicationScoped})},I=[],T=[];try{I.push(f(t));const M=await this.getInstalled(1,o.profileLocation);if(o.donotIncludePack)this.F.info("Uninstalling the extension without including packed extension",`${t.identifier.id}@${t.manifest.version}`);else{const z=this.U(t,M);for(const q of z)this.m.has(v(q.identifier))?this.F.info("Extensions is already requested to uninstall",q.identifier.id):I.push(f(q))}o.donotCheckDependents?this.F.info("Uninstalling the extension without checking dependents",`${t.identifier.id}@${t.manifest.version}`):this.R(I.map(z=>z.extension),M,t),await this.M(I.map(async z=>{try{if(await z.run(),await this.M(this.y.map(q=>q.postUninstall(z.extension,o,L.CancellationToken.None))),z.extension.identifier.uuid)try{await this.z.reportStatistic(z.extension.manifest.publisher,z.extension.manifest.name,z.extension.manifest.version,"uninstall")}catch{}p(z.extension)}catch(q){const Y=q instanceof b.$eo?q:new b.$eo((0,j.$9)(q),b.ExtensionManagementErrorCode.Internal);throw p(z.extension,Y),Y}finally{T.push(z)}}))}catch(M){const z=M instanceof b.$eo?M:new b.$eo((0,j.$9)(M),b.ExtensionManagementErrorCode.Internal);for(const q of I){try{q.cancel()}catch{}T.includes(q)||p(q.extension,z)}throw z}finally{for(const M of I)this.m.delete(v(M.extension.identifier))||this.F.warn("Uninstallation task is not found in the cache",M.extension.identifier.id)}}R(t,r,o){for(const v of t){const $=this.W(v,r);if($.length){const f=$.filter(p=>!t.some(I=>(0,l.$Fo)(I.identifier,p.identifier)));if(f.length)throw new Error(this.S(v,f,o))}}}S(t,r,o){return o===t?r.length===1?E.localize(6,null,o.manifest.displayName||o.manifest.name,r[0].manifest.displayName||r[0].manifest.name):r.length===2?E.localize(7,null,o.manifest.displayName||o.manifest.name,r[0].manifest.displayName||r[0].manifest.name,r[1].manifest.displayName||r[1].manifest.name):E.localize(8,null,o.manifest.displayName||o.manifest.name,r[0].manifest.displayName||r[0].manifest.name,r[1].manifest.displayName||r[1].manifest.name):r.length===1?E.localize(9,null,o.manifest.displayName||o.manifest.name,t.manifest.displayName||t.manifest.name,r[0].manifest.displayName||r[0].manifest.name):r.length===2?E.localize(10,null,o.manifest.displayName||o.manifest.name,t.manifest.displayName||t.manifest.name,r[0].manifest.displayName||r[0].manifest.name,r[1].manifest.displayName||r[1].manifest.name):E.localize(11,null,o.manifest.displayName||o.manifest.name,t.manifest.displayName||t.manifest.name,r[0].manifest.displayName||r[0].manifest.name,r[1].manifest.displayName||r[1].manifest.name)}U(t,r,o=[]){if(o.indexOf(t)!==-1)return[];o.push(t);const v=t.manifest.extensionPack?t.manifest.extensionPack:[];if(v.length){const $=r.filter(p=>!p.isBuiltin&&v.some(I=>(0,l.$Fo)({id:I},p.identifier))),f=[];for(const p of $)f.push(...this.U(p,r,o));return[...$,...f]}return[]}W(t,r){return r.filter(o=>o.manifest.extensionDependencies&&o.manifest.extensionDependencies.some(v=>(0,l.$Fo)({id:v},t.identifier)))}async X(){try{this.F.trace("ExtensionManagementService.refreshReportedCache");const t=await this.z.getExtensionsControlManifest();return this.F.trace("ExtensionManagementService.refreshControlCache",t),t}catch{return this.F.trace("ExtensionManagementService.refreshControlCache - failed to get extension control manifest"),{malicious:[],deprecated:{},search:[]}}}};e.$vp=m,e.$vp=m=pe([X(0,b.$do),X(1,c.$il),X(2,u.$Ok),X(3,y.$dj),X(4,w.$vj),X(5,h.$Qk)],m);function k(i){const t=Array.isArray(i)?i:[i];return t.length===1?t[0]instanceof Error?t[0]:new Error(t[0]):t.reduce((r,o)=>new Error(`${r.message}${r.message?",":""}${o instanceof Error?o.message:o}`),new Error(""))}e.$wp=k;function s(i){if(i instanceof b.$eo)return i;const t=new b.$eo(i.message,b.ExtensionManagementErrorCode.Internal);return t.stack=i.stack,t}e.$xp=s;function a(i,t,{extensionData:r,verificationStatus:o,duration:v,error:$,durationSinceUpdate:f}){let p,I;(0,d.$Kf)(o)&&(o===!0?o="Verified":(o===!1||(p=b.ExtensionManagementErrorCode.Signature,I=o),o="Unverified")),$&&($ instanceof b.$eo?(p=$.code,$.code===b.ExtensionManagementErrorCode.Signature&&(I=$.message)):p=b.ExtensionManagementErrorCode.Internal),i.publicLog(t,{...r,verificationStatus:o,success:!$,duration:v,errorcode:p,errorcodeDetail:I,durationSinceUpdate:f})}class n{constructor(){this.d=new A.$Wg}async waitUntilTaskIsFinished(){return await this.d.wait(),this.g}async run(){return this.g||(this.g=(0,A.$Lg)(t=>this.h(t))),this.d.open(),this.g}cancel(){this.g||(this.g=(0,A.$Lg)(t=>new Promise((r,o)=>{const v=t.onCancellationRequested(()=>{v.dispose(),o(new j.$4)})})),this.d.open()),this.g.cancel()}}e.$yp=n}),define(ae[51],ce([0,1,6,15,2,3,34,10,29,33,11,4,8,17,28,12,7,22]),function(ie,e,D,A,L,j,O,C,S,d,R,E,b,l,g,y,w,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bp=e.$Ap=e.$zp=e.ExtensionsProfileScanningErrorCode=void 0;var u;(function(a){a.ERROR_PROFILE_NOT_FOUND="ERROR_PROFILE_NOT_FOUND",a.ERROR_INVALID_CONTENT="ERROR_INVALID_CONTENT"})(u||(e.ExtensionsProfileScanningErrorCode=u={}));class h extends Error{constructor(n,i){super(n),this.code=i}}e.$zp=h,e.$Ap=(0,E.$Vh)("IExtensionsProfileScannerService");let m=class extends L.$Rc{constructor(n,i,t,r,o,v){super(),this.j=n,this.m=i,this.n=t,this.r=r,this.s=o,this.t=v,this.b=this.B(new j.$Rd),this.onAddExtensions=this.b.event,this.c=this.B(new j.$Rd),this.onDidAddExtensions=this.c.event,this.f=this.B(new j.$Rd),this.onRemoveExtensions=this.f.event,this.g=this.B(new j.$Rd),this.onDidRemoveExtensions=this.g.event,this.h=new O.$zc}scanProfileExtensions(n,i){return this.u(n,void 0,i)}async addExtensionsToProfile(n,i){const t=[],r=[];try{return await this.u(i,o=>{const v=[];for(const $ of o)n.some(([f])=>(0,d.$Fo)(f.identifier,$.identifier)&&f.manifest.version!==$.version)?t.push($):v.push($);for(const[$,f]of n){const p=v.findIndex(T=>(0,d.$Fo)(T.identifier,$.identifier)&&T.version===$.manifest.version),I={identifier:$.identifier,version:$.manifest.version,location:$.location,metadata:f};p===-1?(r.push(I),v.push(I)):v.splice(p,1,I)}return r.length&&this.b.fire({extensions:r,profileLocation:i}),t.length&&this.f.fire({extensions:t,profileLocation:i}),v}),r.length&&this.c.fire({extensions:r,profileLocation:i}),t.length&&this.g.fire({extensions:t,profileLocation:i}),r}catch(o){throw r.length&&this.c.fire({extensions:r,error:o,profileLocation:i}),t.length&&this.g.fire({extensions:t,error:o,profileLocation:i}),o}}async updateMetadata(n,i){const t=[];return await this.u(i,r=>{const o=[];for(const v of r){const $=n.find(([f])=>(0,d.$Fo)(f.identifier,v.identifier)&&f.manifest.version===v.version);$&&(v.metadata={...v.metadata,...$[1]},t.push(v)),o.push(v)}return o}),t}async removeExtensionFromProfile(n,i){const t=[];try{await this.u(i,r=>{const o=[];for(const v of r)(0,d.$Fo)(v.identifier,n.identifier)?t.push(v):o.push(v);return t.length&&this.f.fire({extensions:t,profileLocation:i}),o}),t.length&&this.g.fire({extensions:t,profileLocation:i})}catch(r){throw t.length&&this.g.fire({extensions:t,error:r,profileLocation:i}),r}}async u(n,i,t){return this.F(n).queue(async()=>{let r=[],o;try{const v=await this.m.readFile(n);o=JSON.parse(v.value.toString().trim()||"[]")}catch(v){if((0,R.$vk)(v)!==1)throw v;if(this.r.extUri.isEqual(n,this.n.defaultProfile.extensionsResource)&&(o=await this.D()),!o&&t?.bailOutWhenFileNotFound)throw new h((0,w.$9)(v),"ERROR_PROFILE_NOT_FOUND")}if(o){Array.isArray(o)||this.w(n);let v=!1;for(const $ of o){k($)||this.w(n);let f;if((0,y.$Cf)($.relativeLocation)&&$.relativeLocation)f=this.z($.relativeLocation);else if((0,y.$Cf)($.location))f=this.z($.location),v=!0,$.relativeLocation=$.location,$.location=f.toJSON();else{f=C.URI.revive($.location);const p=this.y(f);p&&(v=!0,$.relativeLocation=p)}r.push({identifier:$.identifier,location:f,version:$.version,metadata:$.metadata})}v&&await this.m.writeFile(n,A.$fe.fromString(JSON.stringify(o)))}if(i){r=i(r);const v=r.map($=>({identifier:$.identifier,version:$.version,location:$.location.toJSON(),relativeLocation:this.y($.location),metadata:$.metadata}));await this.m.writeFile(n,A.$fe.fromString(JSON.stringify(v)))}return r})}w(n){const i=new h(`Invalid extensions content in ${n.toString()}`,"ERROR_INVALID_CONTENT");throw this.s.publicLogError2("extensionsProfileScanningError",{code:i.code}),i}y(n){return this.r.extUri.isEqual(this.r.extUri.dirname(n),this.j)?this.r.extUri.basename(n):void 0}z(n){return this.r.extUri.joinPath(this.j,n)}async D(){return this.C||(this.C=(async()=>{const n=this.r.extUri.joinPath(this.n.defaultProfile.location,"extensions.json"),i=this.r.extUri.joinPath(this.j,".init-default-profile-extensions");let t;try{t=(await this.m.readFile(n)).value.toString()}catch(o){if((0,R.$vk)(o)===1)return;throw o}this.t.info("Migrating extensions from old default profile location",n.toString());let r;try{const o=JSON.parse(t);Array.isArray(o)&&o.every(v=>k(v))?r=o:this.t.warn("Skipping migrating from old default profile locaiton: Found invalid data",o)}catch(o){this.t.error(o)}if(r)try{await this.m.createFile(this.n.defaultProfile.extensionsResource,A.$fe.fromString(JSON.stringify(r)),{overwrite:!1}),this.t.info("Migrated extensions from old default profile location to new location",n.toString(),this.n.defaultProfile.extensionsResource.toString())}catch(o){if((0,R.$vk)(o)===3)this.t.info("Migration from old default profile location to new location is done by another window",n.toString(),this.n.defaultProfile.extensionsResource.toString());else throw o}try{await this.m.del(n)}catch(o){(0,R.$vk)(o)!==1&&this.t.error(o)}try{await this.m.del(i)}catch(o){(0,R.$vk)(o)!==1&&this.t.error(o)}return r})()),this.C}F(n){let i=this.h.get(n);return i||(i=new D.$5g,this.h.set(n,i)),i}};e.$Bp=m,e.$Bp=m=pe([X(1,R.$ek),X(2,l.$Qk),X(3,g.$Ok),X(4,c.$il),X(5,b.$dj)],m);function k(a){return(0,y.$Ef)(a)&&(0,S.$co)(a.identifier)&&(s(a.location)||(0,y.$Cf)(a.location)&&a.location)&&((0,y.$Jf)(a.relativeLocation)||(0,y.$Cf)(a.relativeLocation))&&a.version&&(0,y.$Cf)(a.version)}function s(a){return a?(0,y.$Cf)(a.path)&&(0,y.$Cf)(a.scheme):!1}}),define(ae[80],ce([0,1,18,6,30,15,7,35,137,2,23,16,5,19,54,89,12,10,154,14,33,44,69,11,4,8,25,3,65,51,17,28,182]),function(ie,e,D,A,L,j,O,C,S,d,R,E,b,l,g,y,w,c,u,h,m,k,s,a,n,i,t,r,o,v,$,f,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ip=e.$Hp=e.$Gp=e.$Fp=e.$Ep=e.Translations=void 0;var I;(function(x){function H(Z,J){if(Z===J)return!0;const W=Object.keys(Z),ee=new Set;for(const ne of Object.keys(J))ee.add(ne);if(W.length!==ee.size)return!1;for(const ne of W){if(Z[ne]!==J[ne])return!1;ee.delete(ne)}return ee.size===0}x.equals=H})(I||(e.Translations=I={})),e.$Ep=(0,n.$Vh)("IExtensionsScannerService");let T=class extends d.$Rc{constructor(H,Z,J,W,ee,ne,_,se,K,U,P,F){super(),this.systemExtensionsLocation=H,this.userExtensionsLocation=Z,this.r=J,this.s=W,this.t=ee,this.u=ne,this.w=_,this.y=se,this.z=K,this.C=U,this.D=P,this.F=F,this.g=this.B(new r.$Rd),this.onDidChangeCache=this.g.event,this.h=(0,l.$zg)(this.userExtensionsLocation,".obsolete"),this.j=this.B(this.F.createInstance(q,this.s,this.h)),this.m=this.B(this.F.createInstance(q,this.s,this.h)),this.n=this.B(this.F.createInstance(z,this.h)),this.H=void 0,this.B(this.j.onDidChangeCache(()=>this.g.fire(0))),this.B(this.m.onDidChangeCache(()=>this.g.fire(1)))}getTargetPlatform(){return this.G||(this.G=(0,m.$Qo)(this.w,this.y)),this.G}async scanAllExtensions(H,Z,J){const[W,ee]=await Promise.all([this.scanSystemExtensions(H),this.scanUserExtensions(Z)]),ne=J?await this.scanExtensionsUnderDevelopment(H,[...W,...ee]):[];return this.L(W,ee,ne,await this.getTargetPlatform(),!0)}async scanSystemExtensions(H){const Z=[];Z.push(this.M(!!H.useCache,H.language)),Z.push(this.N(H.language,!!H.checkControlFile));const[J,W]=await Promise.all(Z);return this.J([...J,...W],0,H,!1)}async scanUserExtensions(H){const Z=H.profileLocation??this.userExtensionsLocation;this.y.trace("Started scanning user extensions",Z);const J=this.D.extUri.isEqual(H.profileLocation,this.t.defaultProfile.extensionsResource)?{bailOutWhenFileNotFound:!0}:void 0,W=await this.P(Z,!!H.profileLocation,1,!H.includeUninstalled,H.language,!0,J),ee=H.useCache&&!W.devMode&&W.excludeObsolete?this.m:this.n;let ne;try{ne=await ee.scanExtensions(W)}catch(_){if(_ instanceof v.$zp&&_.code==="ERROR_PROFILE_NOT_FOUND")await this.I(),ne=await ee.scanExtensions(W);else throw _}return ne=await this.J(ne,1,H,!0),this.y.trace("Scanned user extensions:",ne.length),ne}async scanExtensionsUnderDevelopment(H,Z){if(this.z.isExtensionDevelopment&&this.z.extensionDevelopmentLocationURI){const J=(await Promise.all(this.z.extensionDevelopmentLocationURI.filter(W=>W.scheme===R.Schemas.file).map(async W=>{const ee=await this.P(W,!1,1,!0,H.language,!1,void 0);return(await this.n.scanOneOrMultipleExtensions(ee)).map(_=>(_.type=Z.find(se=>(0,m.$Fo)(se.identifier,_.identifier))?.type??_.type,this.n.validate(_,ee)))}))).flat();return this.J(J,"development",H,!0)}return[]}async scanExistingExtension(H,Z,J){const W=await this.P(H,!1,Z,!0,J.language,!0,void 0),ee=await this.n.scanExtension(W);return!ee||!J.includeInvalid&&!ee.isValid?null:ee}async scanOneOrMultipleExtensions(H,Z,J){const W=await this.P(H,!1,Z,!0,J.language,!0,void 0),ee=await this.n.scanOneOrMultipleExtensions(W);return this.J(ee,Z,J,!0)}async scanMetadata(H){const Z=(0,l.$zg)(H,"package.json"),J=(await this.w.readFile(Z)).value.toString();return JSON.parse(J).__metadata}async updateMetadata(H,Z){const J=(0,l.$zg)(H,"package.json"),W=(await this.w.readFile(J)).value.toString(),ee=JSON.parse(W);Z.isMachineScoped===!1&&delete Z.isMachineScoped,Z.isBuiltin===!1&&delete Z.isBuiltin,ee.__metadata={...ee.__metadata,...Z},await this.w.writeFile((0,l.$zg)(H,"package.json"),j.$fe.fromString(JSON.stringify(ee,null,"	")))}async initializeDefaultProfileExtensions(){try{await this.u.scanProfileExtensions(this.t.defaultProfile.extensionsResource,{bailOutWhenFileNotFound:!0})}catch(H){if(H instanceof v.$zp&&H.code==="ERROR_PROFILE_NOT_FOUND")await this.I();else throw H}}async I(){return this.H||(this.H=(async()=>{try{this.y.info("Started initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString());const H=await this.scanUserExtensions({includeInvalid:!0});if(H.length)await this.u.addExtensionsToProfile(H.map(Z=>[Z,Z.metadata]),this.t.defaultProfile.extensionsResource);else try{await this.w.createFile(this.t.defaultProfile.extensionsResource,j.$fe.fromString(JSON.stringify([])))}catch(Z){(0,a.$vk)(Z)!==1&&this.y.warn("Failed to create default profile extensions manifest in extensions installation folder.",this.userExtensionsLocation.toString(),(0,O.$9)(Z))}this.y.info("Completed initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString())}catch(H){this.y.error(H)}finally{this.H=void 0}})()),this.H}async J(H,Z,J,W){return J.includeAllVersions||(H=this.L(Z===0?H:void 0,Z===1?H:void 0,Z==="development"?H:void 0,await this.getTargetPlatform(),W)),J.includeInvalid||(H=H.filter(ee=>ee.isValid)),H.sort((ee,ne)=>{const _=E.$mc(ee.location.fsPath),se=E.$mc(ne.location.fsPath);return _<se?-1:_>se?1:0})}L(H,Z,J,W,ee){const ne=(se,K,U)=>{if(se.isValid&&!K.isValid)return!1;if(se.isValid===K.isValid){if(ee&&g.gt(se.manifest.version,K.manifest.version))return this.y.debug(`Skipping extension ${K.location.path} with lower version ${K.manifest.version} in favour of ${se.location.path} with version ${se.manifest.version}`),!1;if(g.eq(se.manifest.version,K.manifest.version)){if(se.type===0)return this.y.debug(`Skipping extension ${K.location.path} in favour of system extension ${se.location.path} with same version`),!1;if(se.targetPlatform===W)return this.y.debug(`Skipping extension ${K.location.path} from different target platform ${K.targetPlatform}`),!1}}return U?this.y.warn(`Overwriting user extension ${se.location.path} with ${K.location.path}.`):this.y.debug(`Overwriting user extension ${se.location.path} with ${K.location.path}.`),!0},_=new k.$bm;return H?.forEach(se=>{const K=_.get(se.identifier.id);(!K||ne(K,se,!1))&&_.set(se.identifier.id,se)}),Z?.forEach(se=>{const K=_.get(se.identifier.id);if(!K&&H&&se.type===0){this.y.debug(`Skipping obsolete system extension ${se.location.path}.`);return}(!K||ne(K,se,!1))&&_.set(se.identifier.id,se)}),J?.forEach(se=>{const K=_.get(se.identifier.id);(!K||ne(K,se,!0))&&_.set(se.identifier.id,se),_.set(se.identifier.id,se)}),[..._.values()]}async M(H,Z){this.y.trace("Started scanning system extensions");const J=await this.P(this.systemExtensionsLocation,!1,0,!0,Z,!0,void 0),ee=await(H&&!J.devMode?this.j:this.n).scanExtensions(J);return this.y.trace("Scanned system extensions:",ee.length),ee}async N(H,Z){const J=this.z.isBuilt?[]:this.C.builtInExtensions;if(!J?.length)return[];this.y.trace("Started scanning dev system extensions");const W=Z?await this.O():{},ee=[],ne=c.URI.file(E.$gc(E.$ic(R.$gg.asFileUri("").fsPath,"..",".build","builtInExtensions")));for(const se of J){const K=W[se.name]||"marketplace";switch(K){case"disabled":break;case"marketplace":ee.push((0,l.$zg)(ne,se.name));break;default:ee.push(c.URI.file(K));break}}const _=await Promise.all(ee.map(async se=>this.n.scanExtension(await this.P(se,!1,0,!0,H,!0,void 0))));return this.y.trace("Scanned dev system extensions:",_.length),(0,D.$Gb)(_)}async O(){try{const H=await this.w.readFile(this.r);return JSON.parse(H.value.toString())}catch{return{}}}async P(H,Z,J,W,ee,ne,_){const se=await this.f(ee??b.$w),K=await this.Q(H),U=Z&&!this.D.extUri.isEqual(H,this.t.defaultProfile.extensionsResource)?this.t.defaultProfile.extensionsResource:void 0,P=U?await this.Q(U):void 0;return new M(H,K,U,P,Z,_,J,W,ne,this.C.version,this.C.date,this.C.commit,!this.z.isBuilt,ee,se)}async Q(H){try{const Z=await this.w.stat(H);if(typeof Z.mtime=="number")return Z.mtime}catch{}}};e.$Fp=T,e.$Fp=T=pe([X(4,$.$Qk),X(5,v.$Ap),X(6,a.$ek),X(7,i.$dj),X(8,h.$3h),X(9,t.$vj),X(10,f.$Ok),X(11,n.$Uh)],T);class M{constructor(H,Z,J,W,ee,ne,_,se,K,U,P,F,B,N,V){this.location=H,this.mtime=Z,this.applicationExtensionslocation=J,this.applicationExtensionslocationMtime=W,this.profile=ee,this.profileScanOptions=ne,this.type=_,this.excludeObsolete=se,this.validate=K,this.productVersion=U,this.productDate=P,this.productCommit=F,this.devMode=B,this.language=N,this.translations=V}static createNlsConfiguration(H){return{language:H.language,pseudo:H.language==="pseudo",devMode:H.devMode,translations:H.translations}}static equals(H,Z){return(0,l.$sg)(H.location,Z.location)&&H.mtime===Z.mtime&&(0,l.$sg)(H.applicationExtensionslocation,Z.applicationExtensionslocation)&&H.applicationExtensionslocationMtime===Z.applicationExtensionslocationMtime&&H.profile===Z.profile&&L.$en(H.profileScanOptions,Z.profileScanOptions)&&H.type===Z.type&&H.excludeObsolete===Z.excludeObsolete&&H.validate===Z.validate&&H.productVersion===Z.productVersion&&H.productDate===Z.productDate&&H.productCommit===Z.productCommit&&H.devMode===Z.devMode&&H.language===Z.language&&I.equals(H.translations,Z.translations)}}e.$Gp=M;let z=class extends d.$Rc{constructor(H,Z,J,W,ee){super(),this.f=H,this.g=Z,this.h=J,this.j=W,this.m=ee}async scanExtensions(H){const Z=H.profile?await this.r(H):await this.n(H);let J={};if(H.excludeObsolete&&H.type===1)try{const W=(await this.j.readFile(this.f)).value.toString();J=JSON.parse(W)}catch{}return(0,w.$Pf)(J)?Z:Z.filter(W=>!J[m.$Go.create(W).toString()])}async n(H){const Z=await this.j.resolve(H.location);if(!Z.children?.length)return[];const J=await Promise.all(Z.children.map(async W=>{if(!W.isDirectory||H.type===1&&(0,l.$wg)(W.resource).indexOf(".")===0)return null;const ee=new M(W.resource,H.mtime,H.applicationExtensionslocation,H.applicationExtensionslocationMtime,H.profile,H.profileScanOptions,H.type,H.excludeObsolete,H.validate,H.productVersion,H.productDate,H.productCommit,H.devMode,H.language,H.translations);return this.scanExtension(ee)}));return(0,D.$Gb)(J).sort((W,ee)=>W.location.path<ee.location.path?-1:1)}async r(H){let Z=await this.s(H.location,()=>!0,H);if(H.applicationExtensionslocation&&!this.h.extUri.isEqual(H.location,H.applicationExtensionslocation)){Z=Z.filter(W=>!W.metadata?.isApplicationScoped);const J=await this.s(H.applicationExtensionslocation,W=>!!W.metadata?.isBuiltin||!!W.metadata?.isApplicationScoped,H);Z.push(...J)}return Z}async s(H,Z,J){const W=await this.g.scanProfileExtensions(H,J.profileScanOptions);if(!W.length)return[];const ee=await Promise.all(W.map(async ne=>{if(Z(ne)){const _=new M(ne.location,J.mtime,J.applicationExtensionslocation,J.applicationExtensionslocationMtime,J.profile,J.profileScanOptions,J.type,J.excludeObsolete,J.validate,J.productVersion,J.productDate,J.productCommit,J.devMode,J.language,J.translations);return this.scanExtension(_,ne.metadata)}return null}));return(0,D.$Gb)(ee)}async scanOneOrMultipleExtensions(H){try{if(await this.j.exists((0,l.$zg)(H.location,"package.json"))){const Z=await this.scanExtension(H);return Z?[Z]:[]}else return await this.scanExtensions(H)}catch(Z){return this.m.error(`Error scanning extensions at ${H.location.path}:`,(0,O.$9)(Z)),[]}}async scanExtension(H,Z){try{let J=await this.scanExtensionManifest(H.location);if(J){J.publisher||(J.publisher=k.$8l),Z=Z??J.__metadata,delete J.__metadata;const W=(0,m.$Ko)(J.publisher,J.name),ee=Z?.id?{id:W,uuid:Z.id}:{id:W},ne=Z?.isSystem?0:H.type,_=ne===0||!!Z?.isBuiltin;J=await this.t(H.location,J,M.createNlsConfiguration(H));const se={type:ne,identifier:ee,manifest:J,location:H.location,isBuiltin:_,targetPlatform:Z?.targetPlatform??"undefined",metadata:Z,isValid:!0,validations:[]};return H.validate?this.validate(se,H):se}}catch(J){H.type!==0&&this.m.error(J)}return null}validate(H,Z){let J=!0;const W=(0,s.$Vo)(Z.productVersion,Z.productDate,Z.location,H.manifest,H.isBuiltin);for(const[ee,ne]of W)ee===y.default.Error&&(J=!1,this.m.error(this.z(Z.location,ne)));return H.isValid=J,H.validations=W,H}async scanExtensionManifest(H){const Z=(0,l.$zg)(H,"package.json");let J;try{J=(await this.j.readFile(Z)).value.toString()}catch(ee){return(0,a.$vk)(ee)!==1&&this.m.error(this.z(H,(0,u.localize)(0,null,Z.path,ee.message))),null}let W;try{W=JSON.parse(J)}catch{const ne=[];(0,C.$3m)(J,ne);for(const _ of ne)this.m.error(this.z(H,(0,u.localize)(1,null,Z.path,_.offset,_.length,(0,S.$Cp)(_.error))));return null}return(0,C.$_m)(W)!=="object"?(this.m.error(this.z(H,(0,u.localize)(2,null,Z.path))),null):W}async t(H,Z,J){const W=await this.u(H,Z,J);if(W)try{const ee=[],ne=await this.w(W.default,ee);if(ee.length>0)return ee.forEach(se=>{this.m.error(this.z(H,(0,u.localize)(3,null,W.default?.path,(0,S.$Cp)(se.error))))}),Z;if((0,C.$_m)(W)!=="object")return this.m.error(this.z(H,(0,u.localize)(4,null,W.default?.path))),Z;const _=W.values||Object.create(null);return(0,p.$Dp)(this.m,Z,_,ne)}catch{}return Z}async u(H,Z,J){const W=(0,l.$zg)(H,"package.nls.json"),ee=(K,U)=>{U.forEach(P=>{this.m.error(this.z(H,(0,u.localize)(5,null,K?.path,(0,S.$Cp)(P.error))))})},ne=K=>{this.m.error(this.z(H,(0,u.localize)(6,null,K?.path)))},_=`${Z.publisher}.${Z.name}`,se=J.translations[_];if(se)try{const K=c.URI.file(se),U=(await this.j.readFile(K)).value.toString(),P=[],F=(0,C.$3m)(U,P);return P.length>0?(ee(K,P),{values:void 0,default:W}):(0,C.$_m)(F)!=="object"?(ne(K),{values:void 0,default:W}):{values:F.contents?F.contents.package:void 0,default:W}}catch{return{values:void 0,default:W}}else{if(!await this.j.exists(W))return;let U;try{U=await this.y(H,J)}catch{return}if(!U.localized)return{values:void 0,default:U.original};try{const P=(await this.j.readFile(U.localized)).value.toString(),F=[],B=(0,C.$3m)(P,F);return F.length>0?(ee(U.localized,F),{values:void 0,default:U.original}):(0,C.$_m)(B)!=="object"?(ne(U.localized),{values:void 0,default:U.original}):{values:B,default:U.original}}catch{return{values:void 0,default:U.original}}}}async w(H,Z){if(H)try{const J=(await this.j.readFile(H)).value.toString();return(0,C.$3m)(J,Z)}catch{}}y(H,Z){return new Promise((J,W)=>{const ee=ne=>{const _=(0,l.$zg)(H,`package.nls.${ne}.json`);this.j.exists(_).then(se=>{se&&J({localized:_,original:(0,l.$zg)(H,"package.nls.json")});const K=ne.lastIndexOf("-");K===-1?J({localized:(0,l.$zg)(H,"package.nls.json"),original:null}):(ne=ne.substring(0,K),ee(ne))})};if(Z.devMode||Z.pseudo||!Z.language)return J({localized:(0,l.$zg)(H,"package.nls.json"),original:null});ee(Z.language)})}z(H,Z){return`[${H.path}]: ${Z}`}};z=pe([X(1,v.$Ap),X(2,f.$Ok),X(3,a.$ek),X(4,i.$dj)],z);let q=class extends z{constructor(H,Z,J,W,ee,ne,_){super(Z,W,ee,ne,_),this.G=H,this.H=J,this.D=this.B(new A.$Vg(3e3)),this.F=this.B(new r.$Rd),this.onDidChangeCache=this.F.event}async scanExtensions(H){const Z=this.M(H),J=await this.I(Z);if(this.C=H,J&&J.input&&M.equals(J.input,this.C))return this.m.debug("Using cached extensions scan result",H.location.toString()),this.D.trigger(()=>this.L()),J.result.map(ee=>(ee.location=c.URI.revive(ee.location),ee));const W=await super.scanExtensions(H);return await this.J(Z,{input:H,result:W}),W}async I(H){try{const Z=await this.j.readFile(H),J=JSON.parse(Z.value.toString());return{result:J.result,input:(0,o.$sh)(J.input)}}catch(Z){this.m.debug("Error while reading the extension cache file:",H.path,(0,O.$9)(Z))}return null}async J(H,Z){try{await this.j.writeFile(H,j.$fe.fromString(JSON.stringify(Z)))}catch(J){this.m.debug("Error while writing the extension cache file:",H.path,(0,O.$9)(J))}}async L(){if(!this.C)return;const H=this.M(this.C),Z=await this.I(H);if(!Z)return;const J=Z.result,W=JSON.parse(JSON.stringify(await super.scanExtensions(this.C)));if(!L.$en(W,J))try{this.m.info("Invalidating Cache",J,W),await this.j.del(H),this.F.fire()}catch(ee){this.m.error(ee)}}M(H){const Z=this.N(H);return this.h.extUri.joinPath(Z.cacheHome,H.type===0?k.$7l:k.$6l)}N(H){return H.type===0?this.H.defaultProfile:H.profile?this.h.extUri.isEqual(H.location,this.G.extensionsResource)?this.G:this.H.profiles.find(Z=>this.h.extUri.isEqual(H.location,Z.extensionsResource))??this.G:this.H.defaultProfile}};q=pe([X(2,$.$Qk),X(3,v.$Ap),X(4,f.$Ok),X(5,a.$ek),X(6,i.$dj)],q);function Y(x,H){const Z=(0,m.$Io)(x.manifest.publisher,x.manifest.name);return{id:Z,identifier:new k.$_l(Z),isBuiltin:x.type===0,isUserBuiltin:x.type===1&&x.isBuiltin,isUnderDevelopment:H,extensionLocation:x.location,uuid:x.identifier.uuid,targetPlatform:x.targetPlatform,...x.manifest}}e.$Hp=Y;class Q extends T{constructor(H,Z,J,W,ee,ne,_,se,K,U,P,F){super(H,Z,(0,l.$zg)(J,".vscode-oss-dev","extensions","control.json"),W,ee,ne,_,se,K,U,P,F),this.R=(async()=>{if(b.$z)try{const B=await this.w.readFile(c.URI.file(b.$z));return JSON.parse(B.value.toString())}catch{}return Object.create(null)})()}f(H){return this.R}}e.$Ip=Q}),define(ae[243],ce([0,1,66,6,38,3,2,23,16,31,8,17]),function(ie,e,D,A,L,j,O,C,S,d,R,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kp=void 0;let b=class extends O.$Rc{constructor(g,y){super(),this.b=g,this.f=y,this.a=new A.$4g(5)}async postUninstall(g){const y=this.g(g,"uninstall");y&&(this.f.info(g.identifier.id,g.manifest.version,"Running post uninstall script"),await this.a.queue(async()=>{try{await this.h(y.script,"uninstall",y.args,!0,g),this.f.info("Finished running post uninstall script",g.identifier.id,g.manifest.version)}catch(w){this.f.error("Failed to run post uninstall script",g.identifier.id,g.manifest.version),this.f.error(w)}}));try{await d.Promises.rm(this.m(g))}catch(w){this.f.error("Error while removing extension storage path",g.identifier.id),this.f.error(w)}}g(g,y){const w=`vscode:${y}`;if(g.location.scheme===C.Schemas.file&&g.manifest&&g.manifest.scripts&&typeof g.manifest.scripts[w]=="string"){const c=g.manifest.scripts[w].split(" ");return c.length<2||c[0]!=="node"||!c[1]?(this.f.warn(g.identifier.id,g.manifest.version,`${w} should be a node script`),null):{script:(0,S.$ic)(g.location.fsPath,c[1]),args:c.slice(2)||[]}}return null}h(g,y,w,c,u){return new Promise((h,m)=>{const k=this.j(g,y,w,u);let s;const a=n=>{s&&(clearTimeout(s),s=null),n?m(n):h(void 0)};k.on("error",n=>{a((0,L.$Gi)(n)||"Unknown")}),k.on("exit",(n,i)=>{a(n?`post-${y} process exited with code ${n}`:void 0)}),c&&(s=setTimeout(()=>{s=null,k.kill(),m("timed out")},5e3))})}j(g,y,w,c){const u={silent:!0,execArgv:void 0},h=(0,D.fork)(g,[`--type=extension-post-${y}`,...w],u);h.stdout.setEncoding("utf8"),h.stderr.setEncoding("utf8");const m=j.Event.fromNodeEventEmitter(h.stdout,"data"),k=j.Event.fromNodeEventEmitter(h.stderr,"data");m(n=>this.f.info(c.identifier.id,c.manifest.version,`post-${y}`,n)),k(n=>this.f.error(c.identifier.id,c.manifest.version,`post-${y}`,n));const s=j.Event.any(j.Event.map(m,n=>({data:`%c${n}`,format:[""]})),j.Event.map(k,n=>({data:`%c${n}`,format:["color: red"]})));return j.Event.debounce(s,(n,i)=>n?{data:n.data+i.data,format:[...n.format,...i.format]}:{data:i.data,format:i.format},100)(n=>{console.group(c.identifier.id),console.log(n.data,...n.format),console.groupEnd()}),h}m(g){return(0,S.$ic)(this.b.defaultProfile.globalStorageHome.fsPath,g.identifier.id.toLowerCase())}};e.$Kp=b,e.$Kp=b=pe([X(0,E.$Qk),X(1,R.$dj)],b)}),define(ae[244],ce([0,1,8,17,28,22,51,11,14,10]),function(ie,e,D,A,L,j,O,C,S,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$VN=void 0;let R=class extends O.$Bp{constructor(b,l,g,y,w,c){super(d.URI.file(b.extensionsPath),l,g,y,w,c)}};e.$VN=R,e.$VN=R=pe([X(0,S.$4h),X(1,C.$ek),X(2,A.$Qk),X(3,L.$Ok),X(4,j.$il),X(5,D.$dj)],R)}),define(ae[245],ce([0,1,10,14,51,80,11,4,8,25,28,17]),function(ie,e,D,A,L,j,O,C,S,d,R,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$r9b=void 0;let b=class extends j.$Ip{constructor(g,y,w,c,u,h,m,k){super(D.URI.file(u.builtinExtensionsPath),D.URI.file(u.extensionsPath),u.userHome,g.defaultProfile,g,y,w,c,u,h,m,k)}};e.$r9b=b,e.$r9b=b=pe([X(0,E.$Qk),X(1,L.$Ap),X(2,O.$ek),X(3,S.$dj),X(4,A.$4h),X(5,d.$vj),X(6,R.$Ok),X(7,C.$Uh)],b)}),define(ae[21],ce([0,1,6,3,2,100,12,68,4,17]),function(ie,e,D,A,L,j,O,C,S,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ep=e.$dp=e.$cp=e.$bp=e.$ap=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.$_o=e.$$o=e.$0o=void 0,e.$0o="__$__isNewStorageMarker",e.$$o="__$__targetStorageMarker",e.$_o=(0,S.$Vh)("storageService");var R;(function(u){u[u.NONE=0]="NONE",u[u.SHUTDOWN=1]="SHUTDOWN"})(R||(e.WillSaveStateReason=R={}));var E;(function(u){u[u.APPLICATION=-1]="APPLICATION",u[u.PROFILE=0]="PROFILE",u[u.WORKSPACE=1]="WORKSPACE"})(E||(e.StorageScope=E={}));var b;(function(u){u[u.USER=0]="USER",u[u.MACHINE=1]="MACHINE"})(b||(e.StorageTarget=b={}));function l(u){const h=u.get(e.$$o);if(h)try{return JSON.parse(h)}catch{}return Object.create(null)}e.$ap=l;class g extends L.$Rc{static{this.a=60*1e3}constructor(h={flushInterval:g.a}){super(),this.m=h,this.b=this.B(new A.$Ud),this.c=this.B(new A.$Ud),this.onDidChangeTarget=this.c.event,this.f=this.B(new A.$Rd),this.onWillSaveState=this.f.event,this.h=this.B(new D.$0g(()=>this.n(),this.m.flushInterval)),this.j=this.B(new L.$Sc),this.C=void 0,this.F=void 0,this.H=void 0}onDidChangeValue(h,m,k){return A.Event.filter(this.b.event,s=>s.scope===h&&(m===void 0||s.key===m),k)}n(){this.j.value=(0,D.$bh)(()=>{this.r()&&this.flush(),this.h.schedule()})}r(){return!0}t(){(0,L.$Mc)([this.j,this.h])}initialize(){return this.g||(this.g=(async()=>{(0,j.mark)("code/willInitStorage");try{await this.O()}finally{(0,j.mark)("code/didInitStorage")}this.h.schedule()})()),this.g}u(h,m){const{key:k,external:s}=m;if(k===e.$$o){switch(h){case-1:this.H=void 0;break;case 0:this.F=void 0;break;case 1:this.C=void 0;break}this.c.fire({scope:h})}else this.b.fire({scope:h,key:k,target:this.J(h)[k],external:s})}w(h){this.f.fire({reason:h})}get(h,m,k){return this.P(m)?.get(h,k)}getBoolean(h,m,k){return this.P(m)?.getBoolean(h,k)}getNumber(h,m,k){return this.P(m)?.getNumber(h,k)}getObject(h,m,k){return this.P(m)?.getObject(h,k)}storeAll(h,m){this.y(()=>{for(const k of h)this.store(k.key,k.value,k.scope,k.target,m)})}store(h,m,k,s,a=!1){if((0,O.$Lf)(m)){this.remove(h,k,a);return}this.y(()=>{this.z(h,k,s),this.P(k)?.set(h,m,a)})}remove(h,m,k=!1){this.y(()=>{this.z(h,m,void 0),this.P(m)?.delete(h,k)})}y(h){this.b.pause(),this.c.pause();try{h()}finally{this.b.resume(),this.c.resume()}}keys(h,m){const k=[],s=this.J(h);for(const a of Object.keys(s))s[a]===m&&k.push(a);return k}z(h,m,k,s=!1){const a=this.J(m);typeof k=="number"?a[h]!==k&&(a[h]=k,this.P(m)?.set(e.$$o,JSON.stringify(a),s)):typeof a[h]=="number"&&(delete a[h],this.P(m)?.set(e.$$o,JSON.stringify(a),s))}get D(){return this.C||(this.C=this.L(1)),this.C}get G(){return this.F||(this.F=this.L(0)),this.F}get I(){return this.H||(this.H=this.L(-1)),this.H}J(h){switch(h){case-1:return this.I;case 0:return this.G;default:return this.D}}L(h){const m=this.P(h);return m?l(m):Object.create(null)}isNew(h){return this.getBoolean(e.$0o,h)===!0}async flush(h=R.NONE){this.f.fire({reason:h});const m=this.P(-1),k=this.P(0),s=this.P(1);switch(h){case R.NONE:await D.Promises.settled([m?.whenFlushed()??Promise.resolve(),k?.whenFlushed()??Promise.resolve(),s?.whenFlushed()??Promise.resolve()]);break;case R.SHUTDOWN:await D.Promises.settled([m?.flush(0)??Promise.resolve(),k?.flush(0)??Promise.resolve(),s?.flush(0)??Promise.resolve()]);break}}async log(){const h=this.P(-1)?.items??new Map,m=this.P(0)?.items??new Map,k=this.P(1)?.items??new Map;return c(h,m,k,this.Q(-1)??"",this.Q(0)??"",this.Q(1)??"")}async optimize(h){return await this.flush(),this.P(h)?.optimize()}async switch(h,m){return this.w(R.NONE),(0,d.$Pk)(h)?this.R(h,m):this.S(h,m)}M(h,m){return!(h.id===m.id||y(m)&&y(h))}N(h,m,k){this.y(()=>{const s=new Set;for(const[a,n]of h)s.add(a),m.get(a)!==n&&this.u(k,{key:a,external:!0});for(const[a]of m.items)s.has(a)||this.u(k,{key:a,external:!0})})}}e.$bp=g;function y(u){return u.isDefault||!!u.useDefaultFlags?.globalState}e.$cp=y;class w extends g{constructor(){super(),this.U=this.B(new C.$8o(new C.$9o,{hint:C.StorageHint.STORAGE_IN_MEMORY})),this.W=this.B(new C.$8o(new C.$9o,{hint:C.StorageHint.STORAGE_IN_MEMORY})),this.X=this.B(new C.$8o(new C.$9o,{hint:C.StorageHint.STORAGE_IN_MEMORY})),this.B(this.X.onDidChangeStorage(h=>this.u(1,h))),this.B(this.W.onDidChangeStorage(h=>this.u(0,h))),this.B(this.U.onDidChangeStorage(h=>this.u(-1,h)))}P(h){switch(h){case-1:return this.U;case 0:return this.W;default:return this.X}}Q(h){switch(h){case-1:return"inMemory (application)";case 0:return"inMemory (profile)";default:return"inMemory (workspace)"}}async O(){}async R(){}async S(){}r(){return!1}hasScope(h){return!1}}e.$dp=w;async function c(u,h,m,k,s,a){const n=I=>{try{return JSON.parse(I)}catch{return I}},i=new Map,t=new Map;u.forEach((I,T)=>{i.set(T,I),t.set(T,n(I))});const r=new Map,o=new Map;h.forEach((I,T)=>{r.set(T,I),o.set(T,n(I))});const v=new Map,$=new Map;m.forEach((I,T)=>{v.set(T,I),$.set(T,n(I))}),console.group(k!==s?`Storage: Application (path: ${k})`:`Storage: Application & Profile (path: ${k}, default profile)`);const f=[];if(i.forEach((I,T)=>{f.push({key:T,value:I})}),console.table(f),console.groupEnd(),console.log(t),k!==s){console.group(`Storage: Profile (path: ${s}, profile specific)`);const I=[];r.forEach((T,M)=>{I.push({key:M,value:T})}),console.table(I),console.groupEnd(),console.log(o)}console.group(`Storage: Workspace (path: ${a})`);const p=[];v.forEach((I,T)=>{p.push({key:T,value:I})}),console.table(p),console.groupEnd(),console.log($)}e.$ep=c}),define(ae[113],ce([0,1,3,2,12,29,33,21]),function(ie,e,D,A,L,j,O,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$DDb=e.$CDb=void 0;let S=class extends A.$Rc{constructor(E,b){super(),this.a=new D.$Rd,this.onDidChangeEnablement=this.a.event,this.b=this.B(new d(E)),this.B(this.b.onDidChange(l=>this.a.fire({extensions:l,source:"storage"}))),this.B(b.onDidInstallExtensions(l=>l.forEach(({local:g,operation:y})=>{g&&y===4&&this.f(g.identifier)})))}async enableExtension(E,b){return this.f(E)?(this.a.fire({extensions:[E],source:b}),!0):!1}async disableExtension(E,b){return this.c(E)?(this.a.fire({extensions:[E],source:b}),!0):!1}getDisabledExtensions(){return this.h(j.$go)}async getDisabledExtensionsAsync(){return this.getDisabledExtensions()}c(E){const b=this.getDisabledExtensions();return b.every(l=>!(0,O.$Fo)(l,E))?(b.push(E),this.g(b),!0):!1}f(E){const b=this.getDisabledExtensions();for(let l=0;l<b.length;l++){const g=b[l];if((0,O.$Fo)(g,E))return b.splice(l,1),this.g(b),!0}return!1}g(E){this.j(j.$go,E)}h(E){return this.b.get(E,0)}j(E,b){this.b.set(E,b,0)}};e.$CDb=S,e.$CDb=S=pe([X(0,C.$_o),X(1,j.$fo)],S);class d extends A.$Rc{constructor(E){super(),this.c=E,this.a=Object.create(null),this.b=this.B(new D.$Rd),this.onDidChange=this.b.event,this.B(E.onDidChangeValue(0,void 0,this.B(new A.$Qc))(b=>this.f(b)))}get(E,b){let l;return b===0?((0,L.$Lf)(this.a[E])&&(this.a[E]=this.g(E,b)),l=this.a[E]):l=this.g(E,b),JSON.parse(l)}set(E,b,l){const g=JSON.stringify(b.map(({id:w,uuid:c})=>({id:w,uuid:c})));this.g(E,l)!==g&&(l===0&&(b.length?this.a[E]=g:delete this.a[E]),this.h(E,b.length?g:void 0,l))}f(E){if(!(0,L.$Lf)(this.a[E.key])&&this.g(E.key,E.scope)!==this.a[E.key]){const l=this.get(E.key,E.scope);delete this.a[E.key];const g=this.get(E.key,E.scope),y=l.filter(c=>!g.some(u=>(0,O.$Fo)(c,u))),w=g.filter(c=>!l.some(u=>(0,O.$Fo)(u,c)));(y.length||w.length)&&this.b.fire([...y,...w])}}g(E,b){return this.c.get(E,b,"[]")}h(E,b,l){b?this.c.store(E,b,l,1):this.c.remove(E,l)}}e.$DDb=d}),define(ae[246],ce([0,1,18,26,7,5,37,12,10,20,14,29,33,69,11,8,25,58,224,21,22,62]),function(ie,e,D,A,L,j,O,C,S,d,R,E,b,l,g,y,w,c,u,h,m,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jp=e.$ip=e.$hp=void 0;const s=j.$o?"web":(0,E.$_n)(j.$u,O.$dc),a="X-Market-Search-Activity-Id";var n;(function(P){P[P.None=0]="None",P[P.IncludeVersions=1]="IncludeVersions",P[P.IncludeFiles=2]="IncludeFiles",P[P.IncludeCategoryAndTags=4]="IncludeCategoryAndTags",P[P.IncludeSharedAccounts=8]="IncludeSharedAccounts",P[P.IncludeVersionProperties=16]="IncludeVersionProperties",P[P.ExcludeNonValidated=32]="ExcludeNonValidated",P[P.IncludeInstallationTargets=64]="IncludeInstallationTargets",P[P.IncludeAssetUri=128]="IncludeAssetUri",P[P.IncludeStatistics=256]="IncludeStatistics",P[P.IncludeLatestVersionOnly=512]="IncludeLatestVersionOnly",P[P.Unpublished=4096]="Unpublished",P[P.IncludeNameConflictInfo=32768]="IncludeNameConflictInfo"})(n||(n={}));function i(...P){return String(P.reduce((F,B)=>F|B,0))}var t;(function(P){P[P.Tag=1]="Tag",P[P.ExtensionId=4]="ExtensionId",P[P.Category=5]="Category",P[P.ExtensionName=7]="ExtensionName",P[P.Target=8]="Target",P[P.Featured=9]="Featured",P[P.SearchText=10]="SearchText",P[P.ExcludeWithFlags=12]="ExcludeWithFlags"})(t||(t={}));const r={Icon:"Microsoft.VisualStudio.Services.Icons.Default",Details:"Microsoft.VisualStudio.Services.Content.Details",Changelog:"Microsoft.VisualStudio.Services.Content.Changelog",Manifest:"Microsoft.VisualStudio.Code.Manifest",VSIX:"Microsoft.VisualStudio.Services.VSIXPackage",License:"Microsoft.VisualStudio.Services.Content.License",Repository:"Microsoft.VisualStudio.Services.Links.Source",Signature:"Microsoft.VisualStudio.Services.VsixSignature"},o={Dependency:"Microsoft.VisualStudio.Code.ExtensionDependencies",ExtensionPack:"Microsoft.VisualStudio.Code.ExtensionPack",Engine:"Microsoft.VisualStudio.Code.Engine",PreRelease:"Microsoft.VisualStudio.Code.PreRelease",LocalizedLanguages:"Microsoft.VisualStudio.Code.LocalizedLanguages",WebExtension:"Microsoft.VisualStudio.Code.WebExtension",SponsorLink:"Microsoft.VisualStudio.Code.SponsorLink"},$={pageNumber:1,pageSize:10,sortBy:0,sortOrder:0,flags:n.None,criteria:[],assetTypes:[]};class f{constructor(F=$){this.d=F}get pageNumber(){return this.d.pageNumber}get pageSize(){return this.d.pageSize}get sortBy(){return this.d.sortBy}get sortOrder(){return this.d.sortOrder}get flags(){return this.d.flags}get criteria(){return this.d.criteria}withPage(F,B=this.d.pageSize){return new f({...this.d,pageNumber:F,pageSize:B})}withFilter(F,...B){const N=[...this.d.criteria,...B.length?B.map(V=>({filterType:F,value:V})):[{filterType:F}]];return new f({...this.d,criteria:N})}withSortBy(F){return new f({...this.d,sortBy:F})}withSortOrder(F){return new f({...this.d,sortOrder:F})}withFlags(...F){return new f({...this.d,flags:F.reduce((B,N)=>B|N,0)})}withAssetTypes(...F){return new f({...this.d,assetTypes:F})}withSource(F){return new f({...this.d,source:F})}get raw(){const{criteria:F,pageNumber:B,pageSize:N,sortBy:V,sortOrder:G,flags:te,assetTypes:oe}=this.d;return{filters:[{criteria:F,pageNumber:B,pageSize:N,sortBy:V,sortOrder:G}],assetTypes:oe,flags:te}}get searchText(){const F=this.d.criteria.filter(B=>B.filterType===t.SearchText)[0];return F&&F.value?F.value:""}get telemetryData(){return{filterTypes:this.d.criteria.map(F=>String(F.filterType)),flags:this.d.flags,sortBy:String(this.sortBy),sortOrder:String(this.sortOrder),pageNumber:String(this.pageNumber),source:this.d.source,searchTextLength:this.searchText.length}}}function p(P,F){const B=(P||[]).filter(N=>N.statisticName===F)[0];return B?B.value:0}function I(P){const F="Microsoft.VisualStudio.Code.Translation.";return P.files.filter(N=>N.assetType.indexOf(F)===0).reduce((N,V)=>{const G=z(P,V.assetType);return G&&N.push([V.assetType.substring(F.length),G]),N},[])}function T(P){if(P.properties){const F=P.properties.filter(V=>V.key===r.Repository),B=new RegExp("((git|ssh|http(s)?)|(git@[\\w.]+))(:(//)?)([\\w.@:/\\-~]+)(.git)(/)?"),N=F.filter(V=>B.test(V.value))[0];return N?{uri:N.value,fallbackUri:N.value}:null}return z(P,r.Repository)}function M(P){return{uri:`${P.fallbackAssetUri}/${r.VSIX}?redirect=true${P.targetPlatform?`&targetPlatform=${P.targetPlatform}`:""}`,fallbackUri:`${P.fallbackAssetUri}/${r.VSIX}${P.targetPlatform?`?targetPlatform=${P.targetPlatform}`:""}`}}function z(P,F){return P.files.filter(N=>N.assetType===F)[0]?{uri:`${P.assetUri}/${F}${P.targetPlatform?`?targetPlatform=${P.targetPlatform}`:""}`,fallbackUri:`${P.fallbackAssetUri}/${F}${P.targetPlatform?`?targetPlatform=${P.targetPlatform}`:""}`}:null}function q(P,F){const B=P.properties?P.properties.filter(V=>V.key===F):[],N=B.length>0&&B[0].value;return N?N.split(",").map(V=>(0,b.$Jo)(V)):[]}function Y(P){const F=P.properties?P.properties.filter(B=>B.key===o.Engine):[];return F.length>0&&F[0].value||""}function Q(P){const F=P.properties?P.properties.filter(B=>B.key===o.PreRelease):[];return F.length>0&&F[0].value==="true"}function x(P){const F=P.properties?P.properties.filter(N=>N.key===o.LocalizedLanguages):[],B=F.length>0&&F[0].value||"";return B?B.split(","):[]}function H(P){return P.properties?.find(F=>F.key===o.SponsorLink)?.value}function Z(P){return P.indexOf("preview")!==-1}function J(P){return P.targetPlatform?(0,E.$$n)(P.targetPlatform):"undefined"}function W(P){const F=(0,D.$Lb)(P.versions.map(J)),B=!!P.tags?.includes(E.$6n),N=F.indexOf("web");return B?N===-1&&F.push("web"):N!==-1&&F.splice(N,1),F}function ee(P,F){for(let B=0;B<P.length;B++){const N=P[B];if(N.version===P[B-1]?.version){let V=B;if(J(N)===F)for(;V>0&&P[V-1].version===N.version;)V--;V!==B&&(P.splice(B,1),P.splice(V,0,N))}}return P}e.$hp=ee;function ne(P,F,B){P.telemetryData={index:F,querySource:B,queryActivityId:P.queryContext?.[a]}}function _(P,F,B,N){const V=P.versions[0],G={manifest:z(F,r.Manifest),readme:z(F,r.Details),changelog:z(F,r.Changelog),license:z(F,r.License),repository:T(F),download:M(F),icon:z(F,r.Icon),signature:z(F,r.Signature),coreTranslations:I(F)};return{identifier:{id:(0,b.$Ko)(P.publisher.publisherName,P.extensionName),uuid:P.extensionId},name:P.extensionName,version:F.version,displayName:P.displayName,publisherId:P.publisher.publisherId,publisher:P.publisher.publisherName,publisherDisplayName:P.publisher.displayName,publisherDomain:P.publisher.domain?{link:P.publisher.domain,verified:!!P.publisher.isDomainVerified}:void 0,publisherSponsorLink:H(V),description:P.shortDescription||"",installCount:p(P.statistics,"install"),rating:p(P.statistics,"averagerating"),ratingCount:p(P.statistics,"ratingcount"),categories:P.categories||[],tags:P.tags||[],releaseDate:Date.parse(P.releaseDate),lastUpdated:Date.parse(P.lastUpdated),allTargetPlatforms:B,assets:G,properties:{dependencies:q(F,o.Dependency),extensionPack:q(F,o.ExtensionPack),engine:Y(F),localizedLanguages:x(F),targetPlatform:J(F),isPreReleaseVersion:Q(F)},hasPreReleaseVersion:Q(V),hasReleaseVersion:!0,preview:Z(P.flags),isSigned:!!G.signature,queryContext:N}}let se=class{constructor(F,B,N,V,G,te,oe,ue){this.k=B,this.l=N,this.n=V,this.o=G,this.q=te,this.u=oe,this.w=ue;const he=oe.extensionsGallery,ge=he?.servicePPEUrl&&ue.getValue("_extensionsGallery.enablePPE");this.d=ge?he.servicePPEUrl:he?.serviceUrl,this.g=ge?void 0:he?.searchUrl,this.h=he?.controlUrl,this.j=(0,u.$gp)(oe.version,oe,this.n,this.w,this.q,F,this.o)}x(F=""){return`${this.d}${F}`}isEnabled(){return!!this.d}async getExtensions(F,B,N){const V=A.CancellationToken.isCancellationToken(B)?{}:B,G=A.CancellationToken.isCancellationToken(B)?B:N,te=[],oe=[],ue=[],he=[];let ge=!0;for(const ve of F){ve.uuid?oe.push(ve.uuid):te.push(ve.id);const Ie=!!(ve.version||ve.preRelease);ue.push({id:ve.id,uuid:ve.uuid,includePreRelease:Ie}),ve.version&&he.push({id:ve.id,uuid:ve.uuid,version:ve.version}),ge=ge&&!!ve.hasPreRelease&&!Ie}if(!oe.length&&!te.length)return[];let de=new f().withPage(1,F.length);oe.length&&(de=de.withFilter(t.ExtensionId,...oe)),te.length&&(de=de.withFilter(t.ExtensionName,...te)),(V.queryAllVersions||ge)&&(de=de.withFlags(de.flags,n.IncludeVersions)),V.source&&(de=de.withSource(V.source));const{extensions:we}=await this.z(de,{targetPlatform:V.targetPlatform??s,includePreRelease:ue,versions:he,compatible:!!V.compatible},G);return V.source&&we.forEach((ve,Ie)=>ne(ve,Ie,V.source)),we}async getCompatibleExtension(F,B,N){if((0,E.$ao)(F.allTargetPlatforms,N))return null;if(await this.isExtensionCompatible(F,B,N))return F;const V=new f().withFlags(n.IncludeVersions).withPage(1,1).withFilter(t.ExtensionId,F.identifier.uuid),{extensions:G}=await this.z(V,{targetPlatform:N,compatible:!0,includePreRelease:B},A.CancellationToken.None);return G[0]||null}async isExtensionCompatible(F,B,N){if(!(0,E.$bo)(F.properties.targetPlatform,F.allTargetPlatforms,N)||!B&&F.properties.isPreReleaseVersion)return!1;let V=F.properties.engine;if(!V){const G=await this.getManifest(F,A.CancellationToken.None);if(!G)throw new Error("Manifest was not found");V=G.engines.vscode}return(0,l.$Xo)(V,this.u.version,this.u.date)}async y(F,B,N,V,G){if(!(0,E.$bo)(J(F),V,G)||B!=="any"&&Q(F)!==(B==="prerelease"))return!1;if(N)try{const te=await this.E(F);if(!(0,l.$Xo)(te,this.u.version,this.u.date))return!1}catch(te){return this.l.error(`Error while getting the engine for the version ${F.version}.`,(0,L.$9)(te)),!1}return!0}async query(F,B){let N=F.text||"";const V=F.pageSize??50;let G=new f().withPage(1,V);N?(N=N.replace(/\bcategory:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(ge,de,we)=>(G=G.withFilter(t.Category,we||de),"")),N=N.replace(/\btag:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(ge,de,we)=>(G=G.withFilter(t.Tag,we||de),"")),N=N.replace(/\bfeatured(\s+|\b|$)/g,()=>(G=G.withFilter(t.Featured),"")),N=N.trim(),N&&(N=N.length<200?N:N.substring(0,200),G=G.withFilter(t.SearchText,N)),G=G.withSortBy(0)):F.ids?G=G.withFilter(t.ExtensionId,...F.ids):F.names?G=G.withFilter(t.ExtensionName,...F.names):G=G.withSortBy(4),typeof F.sortBy=="number"&&(G=G.withSortBy(F.sortBy)),typeof F.sortOrder=="number"&&(G=G.withSortOrder(F.sortOrder)),F.source&&(G=G.withSource(F.source));const te=async(ge,de)=>{const{extensions:we,total:ve}=await this.z(ge,{targetPlatform:s,compatible:!1,includePreRelease:!!F.includePreRelease},de);return we.forEach((Ie,Ne)=>ne(Ie,(ge.pageNumber-1)*ge.pageSize+Ne,F.source)),{extensions:we,total:ve}},{extensions:oe,total:ue}=await te(G,B),he=async(ge,de)=>{if(de.isCancellationRequested)throw new L.$4;const{extensions:we}=await te(G.withPage(ge+1),de);return we};return{firstPage:oe,total:ue,pageSize:G.pageSize,getPage:he}}async z(F,B,N){const V=F.flags;F.flags&n.IncludeLatestVersionOnly&&F.flags&n.IncludeVersions&&(F=F.withFlags(F.flags&~n.IncludeVersions,n.IncludeLatestVersionOnly)),!(F.flags&n.IncludeLatestVersionOnly)&&!(F.flags&n.IncludeVersions)&&(F=F.withFlags(F.flags,n.IncludeLatestVersionOnly)),B.versions?.length&&(F=F.withFlags(F.flags&~n.IncludeLatestVersionOnly,n.IncludeVersions)),F=F.withFlags(F.flags,n.IncludeAssetUri,n.IncludeCategoryAndTags,n.IncludeFiles,n.IncludeStatistics,n.IncludeVersionProperties);const{galleryExtensions:G,total:te,context:oe}=await this.B(F,N);if(!(F.flags&n.IncludeLatestVersionOnly)){const de=[];for(const we of G){const ve=await this.A(we,B,oe);ve&&de.push(ve)}return{extensions:de,total:te}}const he=[],ge=new Map;for(let de=0;de<G.length;de++){const we=G[de],ve={id:(0,b.$Ko)(we.publisher.publisherName,we.extensionName),uuid:we.extensionId},Ie=(0,C.$If)(B.includePreRelease)?B.includePreRelease:!!B.includePreRelease.find(Me=>(0,b.$Fo)(Me,ve))?.includePreRelease;if(B.compatible&&(0,E.$ao)(W(we),B.targetPlatform))continue;const Ne=await this.A(we,B,oe);!Ne||Ne.properties.isPreReleaseVersion&&(!Ie||!Ne.hasReleaseVersion)||!Ne.properties.isPreReleaseVersion&&Ne.properties.targetPlatform!==B.targetPlatform&&Ne.hasPreReleaseVersion?ge.set(we.extensionId,de):he.push([de,Ne])}if(ge.size){const de=new k.$Nd,we=new f().withFlags(V&~n.IncludeLatestVersionOnly,n.IncludeVersions).withPage(1,ge.size).withFilter(t.ExtensionId,...ge.keys()),{extensions:ve}=await this.z(we,B,N);this.o.publicLog2("galleryService:additionalQuery",{duration:de.elapsed(),count:ge.size});for(const Ie of ve){const Ne=ge.get(Ie.identifier.uuid);he.push([Ne,Ie])}}return{extensions:he.sort((de,we)=>de[0]-we[0]).map(([,de])=>de),total:te}}async A(F,B,N){const V={id:(0,b.$Ko)(F.publisher.publisherName,F.extensionName),uuid:F.extensionId},G=B.versions?.find(he=>(0,b.$Fo)(he,V))?.version,te=(0,C.$If)(B.includePreRelease)?B.includePreRelease:!!B.includePreRelease.find(he=>(0,b.$Fo)(he,V))?.includePreRelease,oe=W(F),ue=ee(F.versions,B.targetPlatform);if(B.compatible&&(0,E.$ao)(oe,B.targetPlatform))return null;for(let he=0;he<ue.length;he++){const ge=ue[he];if(!(G&&ge.version!==G)){if(await this.y(ge,te?"any":"release",B.compatible,oe,B.targetPlatform))return _(F,ge,oe,N);if(G&&ge.version===G)return null}}return G||B.compatible?null:_(F,F.versions[0],oe)}async B(F,B){if(!this.isEnabled())throw new Error("No extension gallery service configured.");F=F.withFlags(F.flags,n.ExcludeNonValidated).withFilter(t.Target,"Microsoft.VisualStudio.Code").withFilter(t.ExcludeWithFlags,i(n.Unpublished));const N=await this.j,V=JSON.stringify(F.raw),G={...N,"Content-Type":"application/json",Accept:"application/json;api-version=3.0-preview.1","Accept-Encoding":"gzip","Content-Length":String(V.length)},te=new k.$Nd;let oe,ue,he=0;try{if(oe=await this.k.request({type:"POST",url:this.g&&F.criteria.some(de=>de.filterType===t.SearchText)?this.g:this.x("/extensionquery"),data:V,headers:G},B),oe.res.statusCode&&oe.res.statusCode>=400&&oe.res.statusCode<500)return{galleryExtensions:[],total:he};const ge=await(0,c.$5o)(oe);if(ge){const de=ge.results[0],we=de.extensions,ve=de.resultMetadata&&de.resultMetadata.filter(Ie=>Ie.metadataType==="ResultCount")[0];return he=ve&&ve.metadataItems.filter(Ie=>Ie.name==="TotalCount")[0].count||0,{galleryExtensions:we,total:he,context:{[a]:oe.res.headers.activityid}}}return{galleryExtensions:[],total:he}}catch(ge){throw ue=ge,ge}finally{this.o.publicLog2("galleryService:query",{...F.telemetryData,requestBodySize:String(V.length),duration:te.elapsed(),success:!!oe&&(0,c.$1o)(oe),responseBodySize:oe?.res.headers["Content-Length"],statusCode:oe?String(oe.res.statusCode):void 0,errorCode:ue?(0,L.$3)(ue)?"canceled":(0,L.$9)(ue).startsWith("XHR timeout")?"timeout":"failed":void 0,count:String(he)})}}async reportStatistic(F,B,N,V){if(!this.isEnabled())return;const G=j.$o?this.x(`/itemName/${F}.${B}/version/${N}/statType/${V==="install"?"1":"3"}/vscodewebextension`):this.x(`/publishers/${F}/extensions/${B}/${N}/stats?statType=${V}`),te=j.$o?"api-version=6.1-preview.1":"*/*;api-version=4.0-preview.1",ue={...await this.j,Accept:te};try{await this.k.request({type:"POST",url:G,headers:ue},A.CancellationToken.None)}catch{}}async download(F,B,N){this.l.trace("ExtensionGalleryService#download",F.identifier.id);const V=(0,b.$No)(F),G=new Date().getTime(),te=de=>this.o.publicLog("galleryService:downloadVSIX",{...V,duration:de}),oe=N===2?"install":N===3?"update":"",ue=oe?{uri:`${F.assets.download.uri}${S.URI.parse(F.assets.download.uri).query?"&":"?"}${oe}=true`,fallbackUri:`${F.assets.download.fallbackUri}${S.URI.parse(F.assets.download.fallbackUri).query?"&":"?"}${oe}=true`}:F.assets.download,he=F.queryContext?.[a]?{[a]:F.queryContext[a]}:void 0,ge=await this.D(ue,he?{headers:he}:void 0);await this.q.writeFile(B,ge.stream),te(new Date().getTime()-G)}async downloadSignatureArchive(F,B){if(!F.assets.signature)throw new Error("No signature asset found");this.l.trace("ExtensionGalleryService#downloadSignatureArchive",F.identifier.id);const N=await this.D(F.assets.signature);await this.q.writeFile(B,N.stream)}async getReadme(F,B){if(F.assets.readme){const N=await this.D(F.assets.readme,{},B);return await(0,c.$4o)(N)||""}return""}async getManifest(F,B){if(F.assets.manifest){const N=await this.D(F.assets.manifest,{},B),V=await(0,c.$4o)(N);return V?JSON.parse(V):null}return null}async C(F,B){const N=z(F,r.Manifest);if(!N)throw new Error("Manifest was not found");const V={"Accept-Encoding":"gzip"},G=await this.D(N,{headers:V});return await(0,c.$5o)(G)}async getCoreTranslation(F,B){const N=F.assets.coreTranslations.filter(V=>V[0]===B.toUpperCase())[0];if(N){const V=await this.D(N[1]),G=await(0,c.$4o)(V);return G?JSON.parse(G):null}return null}async getChangelog(F,B){if(F.assets.changelog){const N=await this.D(F.assets.changelog,{},B);return await(0,c.$4o)(N)||""}return""}async getAllCompatibleVersions(F,B,N){let V=new f().withFlags(n.IncludeVersions,n.IncludeCategoryAndTags,n.IncludeFiles,n.IncludeVersionProperties).withPage(1,1);F.identifier.uuid?V=V.withFilter(t.ExtensionId,F.identifier.uuid):V=V.withFilter(t.ExtensionName,F.identifier.id);const{galleryExtensions:G}=await this.B(V,A.CancellationToken.None);if(!G.length)return[];const te=W(G[0]);if((0,E.$ao)(te,N))return[];const oe=[];await Promise.all(G[0].versions.map(async ge=>{try{await this.y(ge,B?"any":"release",!0,te,N)&&oe.push(ge)}catch{}}));const ue=[],he=new Set;for(const ge of ee(oe,N))he.has(ge.version)||(he.add(ge.version),ue.push({version:ge.version,date:ge.lastUpdated,isPreReleaseVersion:Q(ge)}));return ue}async D(F,B={},N=A.CancellationToken.None){const V=await this.j,G={type:"GET"},te={...V,...B.headers||{}};B={...B,...G,headers:te};const oe=F.uri,ue=F.fallbackUri,he={...B,url:oe};try{const ge=await this.k.request(he,N);if(ge.res.statusCode===200)return ge;const de=await(0,c.$4o)(ge);throw new Error(`Expected 200, got back ${ge.res.statusCode} instead.

${de}`)}catch(ge){if((0,L.$3)(ge))throw ge;const de=(0,L.$9)(ge);this.o.publicLog2("galleryService:cdnFallback",{url:oe,message:de});const we={...B,url:ue};return this.k.request(we,N)}}async E(F){let B=Y(F);if(!B){const N=await this.C(F,A.CancellationToken.None);if(!N)throw new Error("Manifest was not found");B=N.engines.vscode}return B}async getExtensionsControlManifest(){if(!this.isEnabled())throw new Error("No extension gallery service configured.");if(!this.h)return{malicious:[],deprecated:{},search:[]};const F=await this.k.request({type:"GET",url:this.h},A.CancellationToken.None);if(F.res.statusCode!==200)throw new Error("Could not get extensions report.");const B=await(0,c.$5o)(F),N=[],V={},G=[];if(B){for(const te of B.malicious)N.push({id:te});if(B.migrateToPreRelease)for(const[te,oe]of Object.entries(B.migrateToPreRelease))(!oe.engine||(0,l.$Xo)(oe.engine,this.u.version,this.u.date))&&(V[te.toLowerCase()]={disallowInstall:!0,extension:{id:oe.id,displayName:oe.displayName,autoMigrate:{storage:!!oe.migrateStorage},preRelease:!0}});if(B.deprecated)for(const[te,oe]of Object.entries(B.deprecated))oe&&(V[te.toLowerCase()]=(0,C.$If)(oe)?{}:oe);if(B.search)for(const te of B.search)G.push(te)}return{malicious:N,deprecated:V,search:G}}};se=pe([X(1,c.$Yo),X(2,y.$dj),X(3,R.$3h),X(4,m.$il),X(5,g.$ek),X(6,w.$vj),X(7,d.$pi)],se);let K=class extends se{constructor(F,B,N,V,G,te,oe,ue){super(F,B,N,V,G,te,oe,ue)}};e.$ip=K,e.$ip=K=pe([X(0,h.$_o),X(1,c.$Yo),X(2,y.$dj),X(3,R.$3h),X(4,m.$il),X(5,g.$ek),X(6,w.$vj),X(7,d.$pi)],K);let U=class extends se{constructor(F,B,N,V,G,te,oe){super(void 0,F,B,N,V,G,te,oe)}};e.$jp=U,e.$jp=U=pe([X(0,c.$Yo),X(1,y.$dj),X(2,R.$3h),X(3,m.$il),X(4,g.$ek),X(5,w.$vj),X(6,d.$pi)],U)}),define(ae[81],ce([0,1,4,3,2,21,33,25,18,8,12]),function(ie,e,D,A,L,j,O,C,S,d,R){"use strict";var E;Object.defineProperty(e,"__esModule",{value:!0}),e.$4u=e.$3u=void 0,e.$3u=(0,D.$Vh)("IExtensionStorageService");const b=/^extensionKeys\/([^.]+\..+)@(\d+\.\d+\.\d+(-.*)?)$/;let l=class extends L.$Rc{static{E=this}static{this.a=512*1024}static b(y){return`extensionKeys/${(0,O.$Jo)(y.id)}@${y.version}`}static c(y){const w=b.exec(y);if(w&&w[1])return{id:w[1],version:w[2]}}static async removeOutdatedExtensionVersions(y,w){const c=await y.getInstalled(),u=[];for(const[h,m]of E.f(w)){const k=c.find(s=>(0,O.$Fo)(s.identifier,{id:h}))?.manifest.version;for(const s of m)k!==s&&u.push(E.b({id:h,version:s}))}for(const h of u)w.remove(h,0)}static f(y){const w=new Map,c=y.keys(0,1);for(const u of c){const h=E.c(u);if(h){let m=w.get(h.id.toLowerCase());m||w.set(h.id.toLowerCase(),m=[]),m.push(h.version)}}return w}constructor(y,w,c){super(),this.j=y,this.m=w,this.n=c,this.g=this.B(new A.$Rd),this.onDidChangeExtensionStorageToSync=this.g.event,this.h=E.f(y),this.B(this.j.onDidChangeValue(0,void 0,this.B(new L.$Qc))(u=>this.r(u)))}r(y){if(this.h.has(y.key.toLowerCase())){this.g.fire();return}const w=E.c(y.key);if(w){if(this.j.get(y.key,0)===void 0)this.h.delete(w.id.toLowerCase());else{let c=this.h.get(w.id.toLowerCase());c||this.h.set(w.id.toLowerCase(),c=[]),c.push(w.version),this.g.fire()}return}}s(y){if((0,R.$Cf)(y))return y;const w=y.manifest?y.manifest.publisher:y.publisher,c=y.manifest?y.manifest.name:y.name;return(0,O.$Io)(w,c)}getExtensionState(y,w){const c=this.s(y),u=this.getExtensionStateRaw(y,w);if(u)try{return JSON.parse(u)}catch(h){this.n.error(`[mainThreadStorage] unexpected error parsing storage contents (extensionId: ${c}, global: ${w}): ${h}`)}}getExtensionStateRaw(y,w){const c=this.s(y),u=this.j.get(c,w?0:1);return u&&u?.length>E.a&&this.n.warn(`[mainThreadStorage] large extension state detected (extensionId: ${c}, global: ${w}): ${u.length/1024}kb. Consider to use 'storageUri' or 'globalStorageUri' to store this data on disk instead.`),u}setExtensionState(y,w,c){const u=this.s(y);w===void 0?this.j.remove(u,c?0:1):this.j.store(u,JSON.stringify(w),c?0:1,1)}setKeysForSync(y,w){this.j.store(E.b(y),JSON.stringify(w),0,1)}getKeysForSync(y){const w=this.m.extensionSyncedKeys?.[y.id.toLowerCase()],c=this.j.get(E.b(y),0),u=c?JSON.parse(c):void 0;return u&&w?(0,S.$Lb)([...u,...w]):u||w}addToMigrationList(y,w){if(y!==w){const c=this.t.filter(u=>!u.includes(y)&&!u.includes(w));c.push([y,w]),this.t=c}}getSourceExtensionToMigrate(y){const w=this.t.find(([,c])=>y===c);return w?w[0]:void 0}get t(){const y=this.j.get("extensionStorage.migrationList",-1,"[]");try{const w=JSON.parse(y);if(Array.isArray(w))return w}catch{}return[]}set t(y){y.length?this.j.store("extensionStorage.migrationList",JSON.stringify(y),-1,1):this.j.remove("extensionStorage.migrationList",-1)}};e.$4u=l,e.$4u=l=E=pe([X(0,j.$_o),X(1,C.$vj),X(2,d.$dj)],l)}),define(ae[247],ce([0,1,29,11,25,14,98,56,21,22,221]),function(ie,e,D,A,L,j,O,C,S,d,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$P0b=void 0;let E=class extends R.$16b{constructor(l,g,y,w,c,u,h,m){super(l.userHome,c,g,y,w,u,h,m)}};e.$P0b=E,e.$P0b=E=pe([X(0,j.$4h),X(1,d.$il),X(2,D.$fo),X(3,S.$_o),X(4,C.$F8b),X(5,O.$aXb),X(6,A.$ek),X(7,L.$vj)],E)}),define(ae[248],ce([0,1,105,3,22,14,2,8,16,66,25,5,6,101,20,164,36,21,12,131,19]),function(ie,e,D,A,L,j,O,C,S,d,R,E,b,l,g,y,w,c,u,h,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$L0b=void 0;const k=[D.$E0b,D.$F0b],s="remoteTunnelSession",a="remoteTunnelIsService";let n=class extends O.$Rc{constructor(o,v,$,f,p,I,T){super(),this.y=o,this.z=v,this.C=$,this.D=I,this.F=T,this.f=new A.$Rd,this.onDidTokenFailed=this.f.event,this.g=new A.$Rd,this.onDidChangeTunnelStatus=this.g.event,this.h=new A.$Rd,this.onDidChangeMode=this.h.event,this.n=D.$C0b,this.w=!1,this.I=(M,z)=>{z?this.j.error(M):this.j.info(M)},this.j=this.B(f.createLogger((0,m.$zg)($.logsHome,`${D.$G0b}.log`),{id:D.$G0b,name:D.$H0b})),this.t=new b.$Ug(100),this.B(this.j.onDidChangeLogLevel(M=>this.j.info("Log level changed to "+(0,C.$sj)(M)))),this.B(p.onWillShutdown(()=>{this.r?.cancel(),this.r=void 0,this.dispose()})),this.B(I.onDidChangeConfiguration(M=>{k.some(z=>M.affectsConfiguration(z))&&this.t.trigger(()=>this.L())})),this.n=this.R(),this.s=D.TunnelStates.uninitialized}async getTunnelStatus(){return this.s}G(o){this.s=o,this.g.fire(o)}H(o){t(this.n,o)||(this.n=o,this.S(o),this.h.fire(this.n),o.active?(this.j.info(`Session updated: ${o.session.accountLabel} (${o.session.providerId}) (service=${o.asService})`),o.session.token&&this.j.info(`Session token updated: ${o.session.accountLabel} (${o.session.providerId})`)):this.j.info("Session reset"))}getMode(){return Promise.resolve(this.n)}async initialize(o){if(this.w)return this.s;this.w=!0,this.H(o);try{await this.t.trigger(()=>this.L())}catch(v){this.j.error(v)}return this.s}J(){if(!this.u){let o;E.$j?o=this.C.appRoot:o=(0,S.$lc)((0,S.$lc)(this.C.appRoot)),this.u=(0,S.$ic)(o,"bin",`${this.z.tunnelApplicationName}${E.$i?".exe":""}`)}return this.u}async startTunnel(o){if(t(this.n,o)&&this.s.type!=="disconnected")return this.s;this.H(o);try{await this.t.trigger(()=>this.L())}catch(v){this.j.error(v)}return this.s}async stopTunnel(){if(this.r&&(this.r.cancel(),this.r=void 0),!this.n.active)return;const o=this.n.asService;this.H(D.$C0b);try{o&&this.O("uninstallService",["service","uninstall"])}catch(v){this.j.error(v)}try{await this.O("stop",["kill"])}catch(v){this.j.error(v)}this.G(D.TunnelStates.disconnected())}async L(){this.y.publicLog2("remoteTunnel.enablement",{enabled:this.n.active,service:this.n.active&&this.n.asService}),this.r&&(this.r.cancel(),this.r=void 0);let o="",v=!1;const $=(z,q)=>{q?this.j.error(z):o+=z,!this.C.isBuilt&&z.startsWith("   Compiling")&&this.G(D.TunnelStates.connecting((0,y.localize)(0,null)))},f=this.O("status",["status"],$);this.r=f;try{if(await f,this.r!==f)return;let z;try{z=JSON.parse(o.trim().split(`
`).find(q=>q.startsWith("{")))}catch{this.j.error(`Could not parse status output: ${JSON.stringify(o.trim())}`),this.G(D.TunnelStates.disconnected());return}if(v=z.service_installed,this.j.info(z.tunnel?"Other tunnel running, attaching...":"No other tunnel running"),!z.tunnel&&!this.n.active){this.G(D.TunnelStates.disconnected());return}}catch(z){this.j.error(z),this.G(D.TunnelStates.disconnected());return}finally{this.r===f&&(this.r=void 0)}const p=this.n.active?this.n.session:void 0;if(p&&p.token){const z=p.token;this.G(D.TunnelStates.connecting((0,y.localize)(1,null,p.accountLabel,p.providerId)));const q=(Q,x)=>{Q=Q.replaceAll(z,"*".repeat(4)),$(Q,x)},Y=this.O("login",["user","login","--provider",p.providerId,"--access-token",z,"--log",(0,C.$sj)(this.j.getLevel())],q);this.r=Y;try{if(await Y,this.r!==Y)return}catch(Q){this.j.error(Q),this.r=void 0,this.f.fire(p),this.G(D.TunnelStates.disconnected(p));return}}const I=this.Q();I?this.G(D.TunnelStates.connecting((0,y.localize)(2,null,I))):this.G(D.TunnelStates.connecting((0,y.localize)(3,null)));const T=["--accept-server-license-terms","--log",(0,C.$sj)(this.j.getLevel())];I?T.push("--name",I):T.push("--random-name");let M=!1;return this.n.active&&this.n.asService&&!v&&(M=await this.M(T)===!1),this.N(p,T,M)}async M(o){let v;try{v=await this.O("serviceInstall",["service","install",...o])}catch($){this.j.error($),v=1}if(v!==0){const $=(0,y.localize)(4,null);return this.j.warn($),this.G(D.TunnelStates.connecting($)),!1}return!0}async N(o,v,$){v.push("--parent-process-id",String(process.pid)),this.P()&&v.push("--no-sleep");let f=!1;const p=this.O("tunnel",v,(I,T)=>{T?this.j.error(I):this.j.info(I),I.includes("Connected to an existing tunnel process")&&(f=!0);const M=I.match(/Open this link in your browser (https:\/\/([^\/\s]+)\/([^\/\s]+)\/([^\/\s]+))/);if(M){const z={link:M[1],domain:M[2],tunnelName:M[4],isAttached:f};this.G(D.TunnelStates.connected(z,$))}else I.match(/error refreshing token/)&&(p.cancel(),this.f.fire(o),this.G(D.TunnelStates.disconnected(o)))});this.r=p,p.finally(()=>{p===this.r&&(this.j.info("tunnel process terminated"),this.r=void 0,this.n=D.$C0b,this.G(D.TunnelStates.disconnected()))})}O(o,v,$=this.I){return(0,b.$Lg)(f=>new Promise((p,I)=>{f.isCancellationRequested&&p(-1);let T;const M=["ignore","pipe","pipe"];if(f.onCancellationRequested(()=>{T&&(this.j.info(`${o} terminating(${T.pid})`),T.kill())}),!this.C.isBuilt)$(`Building tunnel CLI from sources and run
`,!1),$(`${o} Spawning: cargo run -- tunnel ${v.join(" ")}
`,!1),T=(0,d.spawn)("cargo",["run","--","tunnel",...v],{cwd:(0,S.$ic)(this.C.appRoot,"cli"),stdio:M});else{$(`Running tunnel CLI
`,!1);const z=this.J();$(`${o} Spawning: ${z} tunnel ${v.join(" ")}
`,!1),T=(0,d.spawn)(z,["tunnel",...v],{cwd:(0,w.homedir)(),stdio:M})}T.stdout.pipe(new h.$QT(`
`)).on("data",z=>{if(T){const q=z.toString();$(q,!1)}}),T.stderr.pipe(new h.$QT(`
`)).on("data",z=>{if(T){const q=z.toString();$(q,!0)}}),T.on("exit",z=>{T&&($(`${o} exit(${T.pid}): + ${z} `,!1),T=void 0,p(z||0))}),T.on("error",z=>{T&&($(`${o} error(${T.pid}): + ${z} `,!0),T=void 0,I())})}))}async getTunnelName(){return this.Q()}P(){return!!this.D.getValue(D.$F0b)}Q(){let o=this.D.getValue(D.$E0b)||(0,w.hostname)();return o=o.replace(/^-+/g,"").replace(/[^\w-]/g,"").substring(0,20),o||void 0}R(){try{const o=this.F.get(s,-1),v=this.F.getBoolean(a,-1,!1);if(o){const $=JSON.parse(o);if($&&(0,u.$Cf)($.accountLabel)&&(0,u.$Cf)($.sessionId)&&(0,u.$Cf)($.providerId))return{active:!0,session:$,asService:v};this.j.error("Problems restoring session from storage, invalid format",$)}}catch(o){this.j.error("Problems restoring session from storage",o)}return D.$C0b}S(o){if(o.active){const v={providerId:o.session.providerId,sessionId:o.session.sessionId,accountLabel:o.session.accountLabel};this.F.store(s,JSON.stringify(v),-1,1),this.F.store(a,o.asService,-1,1)}else this.F.remove(s,-1),this.F.remove(a,-1)}};e.$L0b=n,e.$L0b=n=pe([X(0,L.$il),X(1,R.$vj),X(2,j.$4h),X(3,C.$ej),X(4,l.$J0b),X(5,g.$pi),X(6,c.$_o)],n);function i(r,o){return r&&o?r.sessionId===o.sessionId&&r.providerId===o.providerId&&r.token===o.token:r===o}const t=(r,o)=>r.active!==o.active?!1:r.active&&o.active?r.asService===o.asService&&i(r.session,o.session):!0}),define(ae[249],ce([0,1,6,2,23,19,68,21,76,17]),function(ie,e,D,A,L,j,O,C,S,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Q0b=void 0;class R extends C.$bp{constructor(b,l,g,y){super(),this.bb=b,this.cb=l,this.db=g,this.eb=y,this.s=this.cb.defaultProfile,this.U=this.fb(),this.W=this.cb.currentProfile,this.X=this.B(new A.$Qc),this.Y=this.gb(this.W),this.Z=this.bb?.id,this.$=this.B(new A.$Qc),this.ab=this.hb(this.bb)}fb(){const b=this.B(new S.$aEb(this.db.getChannel("storage"))),l=this.B(new O.$8o(b));return this.B(l.onDidChangeStorage(g=>this.u(-1,g))),l}gb(b){this.X.clear(),this.W=b;let l;if((0,C.$cp)(b))l=this.U;else{const g=this.X.add(new S.$bEb(this.db.getChannel("storage"),b));l=this.X.add(new O.$8o(g))}return this.X.add(l.onDidChangeStorage(g=>this.u(0,g))),l}hb(b){this.$.clear(),this.Z=b?.id;let l;if(b){const g=this.$.add(new S.$cEb(this.db.getChannel("storage"),b));l=this.$.add(new O.$8o(g)),this.$.add(l.onDidChangeStorage(y=>this.u(1,y)))}return l}async O(){await D.Promises.settled([this.U.init(),this.Y.init(),this.ab?.init()??Promise.resolve()])}P(b){switch(b){case-1:return this.U;case 0:return this.Y;default:return this.ab}}Q(b){switch(b){case-1:return this.s.globalStorageHome.with({scheme:L.Schemas.file}).fsPath;case 0:return this.W?.globalStorageHome.with({scheme:L.Schemas.file}).fsPath;default:return this.Z?`${(0,j.$zg)(this.eb.workspaceStorageHome,this.Z,"state.vscdb").with({scheme:L.Schemas.file}).fsPath}`:void 0}}async close(){this.t(),this.w(C.WillSaveStateReason.SHUTDOWN),await D.Promises.settled([this.U.close(),this.Y.close(),this.ab?.close()??Promise.resolve()])}async R(b){if(!this.M(this.W,b))return;const l=this.Y,g=l.items;l!==this.U&&await l.close(),this.Y=this.gb(b),await this.Y.init(),this.N(g,this.Y,0)}async S(b,l){const g=this.ab,y=g?.items??new Map;await g?.close(),this.ab=this.hb(b),await this.ab.init(),this.N(y,this.ab,1)}hasScope(b){return(0,d.$Pk)(b)?this.W.id===b.id:this.Z===b.id}}e.$Q0b=R}),define(ae[250],ce([0,1,3,2,17,92]),function(ie,e,D,A,L,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4N=e.$3N=void 0;class O{constructor(d,R){this.a=d,this.b=R}listen(d,R){const E=this.b(d);switch(R){case"onDidChangeProfiles":return D.Event.map(this.a.onDidChangeProfiles,b=>({all:b.all.map(l=>(0,j.$Tm)({...l},E)),added:b.added.map(l=>(0,j.$Tm)({...l},E)),removed:b.removed.map(l=>(0,j.$Tm)({...l},E)),updated:b.updated.map(l=>(0,j.$Tm)({...l},E))}))}throw new Error(`Invalid listen ${R}`)}async call(d,R,E){const b=this.b(d);switch(R){case"createProfile":{const l=await this.a.createProfile(E[0],E[1],E[2]);return(0,j.$Tm)({...l},b)}case"updateProfile":{let l=(0,L.$Rk)((0,j.$Um)(E[0],b),this.a.profilesHome.scheme);return l=await this.a.updateProfile(l,E[1]),(0,j.$Tm)({...l},b)}case"removeProfile":{const l=(0,L.$Rk)((0,j.$Um)(E[0],b),this.a.profilesHome.scheme);return this.a.removeProfile(l)}}throw new Error(`Invalid call ${R}`)}}e.$3N=O;class C extends A.$Rc{get defaultProfile(){return this.profiles[0]}get profiles(){return this.a}constructor(d,R,E){super(),this.profilesHome=R,this.f=E,this.a=[],this.b=this.B(new D.$Rd),this.onDidChangeProfiles=this.b.event,this.c=!0,this.a=d.map(b=>(0,L.$Rk)(b,this.profilesHome.scheme)),this.B(this.f.listen("onDidChangeProfiles")(b=>{const l=b.added.map(w=>(0,L.$Rk)(w,this.profilesHome.scheme)),g=b.removed.map(w=>(0,L.$Rk)(w,this.profilesHome.scheme)),y=b.updated.map(w=>(0,L.$Rk)(w,this.profilesHome.scheme));this.a=b.all.map(w=>(0,L.$Rk)(w,this.profilesHome.scheme)),this.b.fire({added:l,removed:g,updated:y,all:this.profiles})})),this.onDidResetWorkspaces=this.f.listen("onDidResetWorkspaces")}setEnablement(d){this.c=d}isEnabled(){return this.c}async createNamedProfile(d,R,E){const b=await this.f.call("createNamedProfile",[d,R,E]);return(0,L.$Rk)(b,this.profilesHome.scheme)}async createProfile(d,R,E,b){const l=await this.f.call("createProfile",[d,R,E,b]);return(0,L.$Rk)(l,this.profilesHome.scheme)}async createTransientProfile(d){const R=await this.f.call("createTransientProfile",[d]);return(0,L.$Rk)(R,this.profilesHome.scheme)}async setProfileForWorkspace(d,R){await this.f.call("setProfileForWorkspace",[d,R])}removeProfile(d){return this.f.call("removeProfile",[d])}async updateProfile(d,R){const E=await this.f.call("updateProfile",[d,R]);return(0,L.$Rk)(E,this.profilesHome.scheme)}resetWorkspaces(){return this.f.call("resetWorkspaces")}cleanUp(){return this.f.call("cleanUp")}cleanUpTransientProfiles(){return this.f.call("cleanUpTransientProfiles")}}e.$4N=C}),define(ae[59],ce([0,1,2,68,4,21,3,76,17]),function(ie,e,D,A,L,j,O,C,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gEb=e.$fEb=e.$eEb=void 0,e.$eEb=(0,L.$Vh)("IUserDataProfileStorageService");let d=class extends D.$Rc{constructor(l){super(),this.a=l}async readStorageData(l){return this.withProfileScopedStorageService(l,async g=>this.b(g))}async updateStorageData(l,g,y){return this.withProfileScopedStorageService(l,async w=>this.c(w,g,y))}async withProfileScopedStorageService(l,g){if(this.a.hasScope(l))return g(this.a);const y=await this.g(l),w=new E(y);try{await w.initialize();const c=await g(w);return await w.flush(),c}finally{w.dispose(),await this.f(y)}}b(l){const g=new Map,y=w=>{for(const c of l.keys(0,w))g.set(c,{value:l.get(c,0),target:w})};return y(0),y(1),g}c(l,g,y){l.storeAll(Array.from(g.entries()).map(([w,c])=>({key:w,value:c,scope:0,target:y})),!0)}async f(l){try{await l.close()}finally{(0,D.$Lc)(l)&&l.dispose()}}};e.$fEb=d,e.$fEb=d=pe([X(0,j.$_o)],d);class R extends d{constructor(l,g,y,w){super(y),this.j=l;const c=l.getChannel("profileStorageListener"),u=this.B(new D.$Sc);this.h=this.B(new O.$Rd({onWillAddFirstListener:()=>{u.value=c.listen("onDidChange")(h=>{w.trace("profile storage changes",h),this.h.fire({targetChanges:h.targetChanges.map(m=>(0,S.$Rk)(m,g.profilesHome.scheme)),valueChanges:h.valueChanges.map(m=>({...m,profile:(0,S.$Rk)(m.profile,g.profilesHome.scheme)}))})})},onDidRemoveLastListener:()=>u.value=void 0})),this.onDidChange=this.h.event}async g(l){const g=this.j.getChannel("storage");return(0,j.$cp)(l)?new C.$aEb(g):new C.$bEb(g,l)}}e.$gEb=R;class E extends j.$bp{constructor(l){super({flushInterval:100}),this.s=this.B(new A.$8o(l))}O(){return this.s.init()}P(l){return l===0?this.s:void 0}Q(){}async R(){}async S(){}hasScope(){return!1}}}),define(ae[251],ce([0,1,21,8,17,55,59]),function(ie,e,D,A,L,j,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$v0b=void 0;let C=class extends O.$gEb{constructor(d,R,E,b){super(d,R,E,b)}};e.$v0b=C,e.$v0b=C=pe([X(0,j.$T9b),X(1,L.$Qk),X(2,D.$_o),X(3,A.$dj)],C)}),define(ae[39],ce([0,1,18,6,15,26,3,35,2,27,12,169,20,14,11,8,43,21,22,28,24,17]),function(ie,e,D,A,L,j,O,C,S,d,R,E,b,l,g,y,w,c,u,h,m,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$Eb=e.$0Eb=e.$9Eb=e.$8Eb=e.$7Eb=e.$6Eb=e.$5Eb=void 0;function s(v){return!!(v&&v.ref!==void 0&&typeof v.ref=="string"&&v.ref!==""&&v.syncData!==void 0&&(v.syncData===null||a(v.syncData)))}e.$5Eb=s;function a(v){return!!(v&&v.version!==void 0&&typeof v.version=="number"&&v.content!==void 0&&typeof v.content=="string"&&(Object.keys(v).length===2||Object.keys(v).length===3&&v.machineId!==void 0&&typeof v.machineId=="string"))}e.$6Eb=a;function n(v,$){return`${(0,d.$uf)(v)}${$.isDefault?"":` (${$.name})`}`}e.$7Eb=n;let i=class extends S.$Rc{get status(){return this.m}get conflicts(){return{...this.syncResource,conflicts:this.s}}constructor($,f,p,I,T,M,z,q,Y,Q,x,H){super(),this.syncResource=$,this.collection=f,this.G=p,this.H=I,this.I=T,this.J=M,this.L=z,this.M=q,this.N=Y,this.O=Q,this.P=x,this.c=null,this.m="idle",this.n=this.B(new O.$Rd),this.onDidChangeStatus=this.n.event,this.s=[],this.t=this.B(new O.$Rd),this.onDidChangeConflicts=this.t.event,this.u=this.B(new A.$Vg(50)),this.w=this.B(new O.$Rd),this.onDidChangeLocal=this.w.event,this.z=`${this.collection?`${this.collection}.`:""}${this.syncResource.syncResource}.lastSyncUserData`,this.C=!1,this.F={},this.resource=this.syncResource.syncResource,this.D=n($.syncResource,$.profile),this.h=H.extUri,this.f=this.h.joinPath(I.userDataSyncHome,...(0,m.$Vgb)($.profile.isDefault?void 0:$.profile.id,$.syncResource)),this.g=this.h.joinPath(this.f,m.$ehb),this.y=(0,m.$Wgb)($.profile.isDefault?void 0:$.profile.id,$.syncResource,I,this.h),this.j=(0,w.$fp)(I,p,T)}Q(){this.u.trigger(()=>this.R())}async R(){if(this.status==="hasConflicts"){this.O.info(`${this.D}: In conflicts state and local change detected. Syncing again...`);const $=await this.c;this.c=null;const f=await this.Y($.remoteUserData,$.lastSyncUserData,!0,this.ob());this.S(f)}else{this.O.trace(`${this.D}: Checking for local changes...`);const $=await this.getLastSyncUserData();($?await this.ub($):!0)&&this.w.fire()}}S($){this.m!==$&&(this.m=$,this.n.fire($))}async sync($,f={}){await this.U($,!0,this.ob(),f)}async preview($,f,p={}){return this.U($,!1,f,p)}async apply($,f={}){try{this.F={...f};const p=await this.ab($);return this.S(p),this.c}finally{this.F={}}}async U($,f,p,I){try{if(this.F={...I},this.status==="hasConflicts")return this.O.info(`${this.D}: Skipped synchronizing ${this.resource.toLowerCase()} as there are conflicts.`),this.c;if(this.status==="syncing")return this.O.info(`${this.D}: Skipped synchronizing ${this.resource.toLowerCase()} as it is running already.`),this.c;this.O.trace(`${this.D}: Started synchronizing ${this.resource.toLowerCase()}...`),this.S("syncing");let T="idle";try{const M=await this.getLastSyncUserData(),z=await this.X($,M);return T=await this.Y(z,M,f,p),T==="hasConflicts"?this.O.info(`${this.D}: Detected conflicts while synchronizing ${this.resource.toLowerCase()}.`):T==="idle"&&this.O.trace(`${this.D}: Finished synchronizing ${this.resource.toLowerCase()}.`),this.c||null}finally{this.S(T)}}finally{this.F={}}}async replace($){const f=this.kb($);if(!f)return!1;await this.stop();try{this.O.trace(`${this.D}: Started resetting ${this.resource.toLowerCase()}...`),this.S("syncing");const p=await this.getLastSyncUserData(),I=await this.X(null,p),T=await this.W(I),M=await this.qb({ref:I.ref,syncData:f},p,T,this.ob(),j.CancellationToken.None),z=[];for(const q of M){const Y=await this.sb(q,q.remoteResource,void 0,j.CancellationToken.None),{remoteChange:Q}=await this.sb(q,q.previewResource,q.remoteContent,j.CancellationToken.None);z.push([q,{...Y,remoteChange:Q!==0?Q:2}])}await this.tb(I,p,z,!1),this.O.info(`${this.D}: Finished resetting ${this.resource.toLowerCase()}.`)}finally{this.S("idle")}return!0}async W($){const f=await this.j;return!!$.syncData?.machineId&&$.syncData.machineId===f}async X($,f){if(f){const p=$?$[this.resource]:void 0;if(f.ref===p||p===void 0&&f.syncData===null)return f}return this.getRemoteUserData(f)}async Y($,f,p,I){if($.syncData&&$.syncData.version>this.pb)throw this.N.publicLog2("sync/incompatible",{source:this.resource}),new m.$4gb((0,E.localize)(0,null,this.resource,this.pb,$.syncData.version),"IncompatibleLocalContent",this.resource);try{return await this.Z($,f,p,I)}catch(T){if(T instanceof m.$4gb)switch(T.code){case"LocalPreconditionFailed":return this.O.info(`${this.D}: Failed to synchronize ${this.D} as there is a new local version available. Synchronizing again...`),this.Y($,f,p,I);case"Conflict":case"PreconditionFailed":return this.O.info(`${this.D}: Failed to synchronize as there is a new remote version available. Synchronizing again...`),$=await this.getRemoteUserData(null),f=await this.getLastSyncUserData(),this.Y($,f,p,I)}throw T}}async Z($,f,p,I){try{const T=await this.W($),M=!T&&f===null&&this.gb()!==void 0,z=p&&!M;this.c||(this.c=(0,A.$Lg)(Y=>this.eb($,f,T,z,I,Y)));let q=await this.c;if(p&&M){this.O.info(`${this.D}: Accepting remote because it was synced before and the last sync data is not available.`);for(const Y of q.resourcePreviews)q=await this.accept(Y.remoteResource)||q}return this.cb(q.resourcePreviews),q.resourcePreviews.some(({mergeState:Y})=>Y==="conflict")?"hasConflicts":p?await this.ab(!1):"syncing"}catch(T){throw this.c=null,T}}async merge($){return await this.$($,async f=>{const p=await this.rb(f,j.CancellationToken.None);await this.G.writeFile(f.previewResource,L.$fe.fromString(p?.content||""));const I=p&&!p.hasConflicts?await this.sb(f,f.previewResource,void 0,j.CancellationToken.None):void 0;return f.acceptResult=I,f.mergeState=p.hasConflicts?"conflict":I?"accepted":"preview",f.localChange=I?I.localChange:p.localChange,f.remoteChange=I?I.remoteChange:p.remoteChange,f}),this.c}async accept($,f){return await this.$($,async p=>{const I=await this.sb(p,$,f,j.CancellationToken.None);return p.acceptResult=I,p.mergeState="accepted",p.localChange=I.localChange,p.remoteChange=I.remoteChange,p}),this.c}async discard($){return await this.$($,async f=>{const p=await this.rb(f,j.CancellationToken.None);return await this.G.writeFile(f.previewResource,L.$fe.fromString(p.content||"")),f.acceptResult=void 0,f.mergeState="preview",f.localChange=p.localChange,f.remoteChange=p.remoteChange,f}),this.c}async $($,f){if(!this.c)return;let p=await this.c;const I=p.resourcePreviews.findIndex(({localResource:T,remoteResource:M,previewResource:z})=>this.h.isEqual(T,$)||this.h.isEqual(M,$)||this.h.isEqual(z,$));I!==-1&&(this.c=(0,A.$Lg)(async T=>{const M=[...p.resourcePreviews];return M[I]=await f(M[I]),{...p,resourcePreviews:M}}),p=await this.c,this.cb(p.resourcePreviews),p.resourcePreviews.some(({mergeState:T})=>T==="conflict")?this.S("hasConflicts"):this.S("syncing"))}async ab($){if(!this.c)return"idle";const f=await this.c;return f.resourcePreviews.some(({mergeState:p})=>p==="conflict")?"hasConflicts":f.resourcePreviews.some(({mergeState:p})=>p!=="accepted")?"syncing":(await this.tb(f.remoteUserData,f.lastSyncUserData,f.resourcePreviews.map(p=>[p,p.acceptResult]),$),this.c=null,await this.bb(),"idle")}async bb(){try{await this.G.del(this.g,{recursive:!0})}catch{}}cb($){const f=$.filter(({mergeState:p})=>p==="conflict");(0,D.$tb)(this.s,f,(p,I)=>this.h.isEqual(p.previewResource,I.previewResource))||(this.s=f,this.t.fire(this.conflicts))}async hasPreviouslySynced(){const $=await this.getLastSyncUserData();return!!$&&$.syncData!==null}async db($){const f=this.c?await this.c:null;if(f)for(const p of f.resourcePreviews){if(this.h.isEqual(p.acceptedResource,$))return p.acceptResult?p.acceptResult.content:null;if(this.h.isEqual(p.remoteResource,$))return p.remoteContent;if(this.h.isEqual(p.localResource,$))return p.localContent;if(this.h.isEqual(p.baseResource,$))return p.baseContent}return null}async resetLocal(){this.I.remove(this.z,-1);try{await this.G.del(this.y)}catch($){(0,g.$vk)($)!==1&&this.O.error($)}}async eb($,f,p,I,T,M){const z=await this.qb($,f,p,T,M),q=[];for(const Y of z){const Q=Y.previewResource.with({scheme:m.$dhb,authority:"accepted"});if(Y.localChange===0&&Y.remoteChange===0)q.push({...Y,acceptedResource:Q,acceptResult:{content:null,localChange:0,remoteChange:0},mergeState:"accepted"});else{const x=I?await this.rb(Y,M):void 0;if(M.isCancellationRequested)break;await this.G.writeFile(Y.previewResource,L.$fe.fromString(x?.content||""));const H=x&&!x.hasConflicts?await this.sb(Y,Y.previewResource,void 0,M):void 0;q.push({...Y,acceptResult:H,mergeState:x?.hasConflicts?"conflict":H?"accepted":"preview",localChange:H?H.localChange:x?x.localChange:Y.localChange,remoteChange:H?H.remoteChange:x?x.remoteChange:Y.remoteChange})}}return{syncResource:this.resource,profile:this.syncResource.profile,remoteUserData:$,lastSyncUserData:f,resourcePreviews:q,isLastSyncFromCurrentMachine:p}}async getLastSyncUserData(){let $=this.gb();if($||($=await this.jb()),!$)return this.O.info(`${this.D}: Last sync data state does not exist.`),null;const f=JSON.parse($),p=this.M.getResourceSyncStateVersion(this.resource);if(this.C=!!f.version&&!!p&&f.version!==p,this.C)return this.O.info(`${this.D}: Reset last sync state because last sync state version ${f.version} is not compatible with current sync state version ${p}.`),await this.resetLocal(),null;let I,T=1;for(;I===void 0&&T++<6;)try{const M=await this.hb();M&&(M.ref===f.ref?I=M.syncData:this.O.info(`${this.D}: Last sync data stored locally is not same as the last sync state.`));break}catch(M){if(M instanceof g.$zk&&M.fileOperationResult===1){this.O.info(`${this.D}: Last sync resource does not exist locally.`);break}else{if(M instanceof m.$4gb)throw M;this.O.error(M,T)}}if(I===void 0)try{const M=await this.J.resolveResourceContent(this.resource,f.ref,this.collection,this.F);I=M===null?null:this.kb(M),await this.ib({ref:f.ref,syncData:I})}catch(M){if(M instanceof m.$4gb&&M.code==="NotFound")this.O.info(`${this.D}: Last sync resource does not exist remotely.`);else throw M}return I===void 0?null:{...f,syncData:I}}async fb($,f={}){if(f.ref||f.version)throw new Error("Cannot have core properties as additional");const p=this.M.getResourceSyncStateVersion(this.resource),I={ref:$.ref,version:p,...f};this.I.store(this.z,JSON.stringify(I),-1,1),await this.ib($)}gb(){return this.I.get(this.z,-1)}async hb(){const $=(await this.G.readFile(this.y)).value.toString();try{const f=$?JSON.parse($):void 0;if(s(f))return f}catch(f){this.O.error(f)}}async ib($){await this.G.writeFile(this.y,L.$fe.fromString(JSON.stringify($)))}async jb(){try{const $=await this.G.readFile(this.y),f=JSON.parse($.value.toString());await this.G.del(this.y),f.ref&&f.content!==void 0?(this.I.store(this.z,JSON.stringify({...f,content:void 0}),-1,1),await this.ib({ref:f.ref,syncData:f.content===null?null:JSON.parse(f.content)})):this.O.info(`${this.D}: Migrating last sync user data. Invalid data.`,f)}catch($){$ instanceof g.$zk&&$.fileOperationResult===1?this.O.info(`${this.D}: Migrating last sync user data. Resource does not exist.`):this.O.error($)}return this.I.get(this.z,-1)}async getRemoteUserData($){const{ref:f,content:p}=await this.lb($);let I=null;return p!==null&&(I=this.kb(p)),{ref:f,syncData:I}}kb($){try{const f=JSON.parse($);if(a(f))return f}catch(f){this.O.error(f)}throw new m.$4gb((0,E.localize)(1,null),"IncompatibleRemoteContent",this.resource)}async lb($){const f=$?{ref:$.ref,content:$.syncData?JSON.stringify($.syncData):null}:null;return this.J.readResource(this.resource,f,this.collection,this.F)}async mb($,f){const p=await this.j,I={version:this.pb,machineId:p,content:$};try{return f=await this.J.writeResource(this.resource,JSON.stringify(I),f,this.collection,this.F),{ref:f,syncData:I}}catch(T){throw T instanceof m.$4gb&&T.code==="TooLarge"&&(T=new m.$4gb(T.message,T.code,this.resource)),T}}async nb($){const f={version:this.pb,content:$};return this.L.writeResource(this.resource,JSON.stringify(f),new Date,this.syncResource.profile.isDefault?void 0:this.syncResource.profile.id)}async stop(){this.status!=="idle"&&(this.O.trace(`${this.D}: Stopping synchronizing ${this.resource.toLowerCase()}.`),this.c&&(this.c.cancel(),this.c=null),this.cb([]),await this.bb(),this.S("idle"),this.O.info(`${this.D}: Stopped synchronizing ${this.resource.toLowerCase()}.`))}ob(){return this.P.getValue(m.$Qgb)}};e.$8Eb=i,e.$8Eb=i=pe([X(2,g.$ek),X(3,l.$3h),X(4,c.$_o),X(5,m.$Ygb),X(6,m.$Zgb),X(7,m.$9gb),X(8,u.$il),X(9,m.$bhb),X(10,b.$pi),X(11,h.$Ok)],i);let t=class extends i{constructor($,f,p,I,T,M,z,q,Y,Q,x,H,Z){super(f,p,I,T,M,z,q,Y,Q,x,H,Z),this.r=$,this.B(this.G.watch(this.h.dirname($))),this.B(this.G.onDidFilesChange(J=>this.yb(J)))}async vb(){try{return await this.G.readFile(this.r)}catch{return null}}async wb($,f,p){try{f?await this.G.writeFile(this.r,L.$fe.fromString($),p?void 0:f):await this.G.createFile(this.r,L.$fe.fromString($),{overwrite:p})}catch(I){throw I instanceof g.$zk&&I.fileOperationResult===1||I instanceof g.$zk&&I.fileOperationResult===3?new m.$4gb(I.message,"LocalPreconditionFailed"):I}}async xb(){try{await this.G.del(this.r)}catch($){if(!($ instanceof g.$zk&&$.fileOperationResult===1))throw $}}yb($){$.contains(this.r)&&this.Q()}};e.$9Eb=t,e.$9Eb=t=pe([X(3,g.$ek),X(4,l.$3h),X(5,c.$_o),X(6,m.$Ygb),X(7,m.$Zgb),X(8,m.$9gb),X(9,u.$il),X(10,m.$bhb),X(11,b.$pi),X(12,h.$Ok)],t);let r=class extends t{constructor($,f,p,I,T,M,z,q,Y,Q,x,H,Z,J){super($,f,p,I,T,M,z,q,Y,Q,x,Z,J),this.zb=H,this.Bb=void 0}Ab($,f){const p=[],I=(0,C.$3m)($,p,{allowEmptyContent:!0,allowTrailingComma:!0});return p.length>0||!(0,R.$Jf)(I)&&f!==Array.isArray(I)}Cb(){return this.Bb||(this.Bb=this.zb.resolveFormattingOptions(this.r)),this.Bb}};e.$0Eb=r,e.$0Eb=r=pe([X(3,g.$ek),X(4,l.$3h),X(5,c.$_o),X(6,m.$Ygb),X(7,m.$Zgb),X(8,m.$9gb),X(9,u.$il),X(10,m.$bhb),X(11,m.$ahb),X(12,b.$pi),X(13,h.$Ok)],r);let o=class{constructor($,f,p,I,T,M,z){this.resource=$,this.g=f,this.h=p,this.j=I,this.k=T,this.l=M,this.d=z.extUri,this.f=(0,m.$Wgb)(void 0,this.resource,p,this.d)}async initialize({ref:$,content:f}){if(!f){this.j.info("Remote content does not exist.",this.resource);return}const p=this.m(f);if(p)try{await this.o({ref:$,syncData:p})}catch(I){this.j.error(I)}}m($){try{const f=JSON.parse($);if(a(f))return f}catch(f){this.j.error(f)}this.j.info("Cannot parse sync data as it is not compatible with the current version.",this.resource)}async n($,f={}){if(f.ref||f.version)throw new Error("Cannot have core properties as additional");const p={ref:$.ref,version:void 0,...f};this.l.store(`${this.resource}.lastSyncUserData`,JSON.stringify(p),-1,1),await this.k.writeFile(this.f,L.$fe.fromString(JSON.stringify($)))}};e.$$Eb=o,e.$$Eb=o=pe([X(1,k.$Qk),X(2,l.$3h),X(3,y.$dj),X(4,g.$ek),X(5,c.$_o),X(6,h.$Ok)],o)}),define(ae[114],ce([0,1,6,26,7,3,42,2,27,20,14,113,29,33,81,44,11,4,72,8,21,22,28,17,39,232,111,24,59]),function(ie,e,D,A,L,j,O,C,S,d,R,E,b,l,g,y,w,c,u,h,m,k,s,a,n,i,t,r,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_4b=e.$$4b=e.$04b=e.$94b=e.$84b=void 0;async function v(M,z){const q=JSON.parse(M.content);if(M.version===1||M.version===2){const Y=(await z.getInstalled(0)).filter(Q=>Q.isBuiltin);for(const Q of q)M.version===1&&(Q.enabled===!1&&(Q.disabled=!0),delete Q.enabled),M.version===2&&Y.every(x=>!(0,l.$Fo)(x.identifier,Q.identifier))&&(Q.installed=!0)}return q}function $(M){return JSON.parse(M.content)}e.$84b=$;function f(M,z){return M.sort((q,Y)=>!q.identifier.uuid&&Y.identifier.uuid?-1:q.identifier.uuid&&!Y.identifier.uuid?1:(0,S.$Ye)(q.identifier.id,Y.identifier.id)),z?(0,O.$tT)(M,{}):JSON.stringify(M)}e.$94b=f;let p=class extends n.$8Eb{constructor(z,q,Y,Q,x,H,Z,J,W,ee,ne,_,se,K,U,P,F){super({syncResource:"extensions",profile:z},q,Q,Y,x,H,Z,_,se,ee,ne,U),this.Cb=J,this.Db=W,this.Eb=F,this.pb=6,this.wb=this.h.joinPath(this.g,"extensions.json"),this.xb=this.wb.with({scheme:r.$dhb,authority:"base"}),this.yb=this.wb.with({scheme:r.$dhb,authority:"local"}),this.zb=this.wb.with({scheme:r.$dhb,authority:"remote"}),this.Ab=this.wb.with({scheme:r.$dhb,authority:"accepted"}),this.Bb=this.Eb.createInstance(I),this.B(j.Event.any(j.Event.filter(this.Cb.onDidInstallExtensions,B=>B.some(({local:N})=>!!N)),j.Event.filter(this.Cb.onDidUninstallExtension,B=>!B.error),j.Event.filter(P.onDidChange,B=>B.valueChanges.some(({profile:N,changes:V})=>this.syncResource.profile.id===N.id&&V.some(G=>G.key===b.$go))),K.onDidChangeExtensionStorageToSync)(()=>this.Q()))}async qb(z,q){const Y=z.syncData?await v(z.syncData,this.Cb):null,Q=q?.skippedExtensions??[],x=q?.builtinExtensions??null,H=q?.syncData?await v(q.syncData,this.Cb):null,{localExtensions:Z,ignoredExtensions:J}=await this.Bb.getLocalExtensions(this.syncResource.profile);Y?this.O.trace(`${this.D}: Merging remote extensions with local extensions...`):this.O.trace(`${this.D}: Remote extensions does not exist. Synchronizing extensions for the first time.`);const{local:W,remote:ee}=(0,i.$74b)(Z,Y,H,Q,J,x),ne={local:W,remote:ee,content:this.Hb(Z,W.added,W.updated,W.removed),localChange:W.added.length>0||W.removed.length>0||W.updated.length>0?2:0,remoteChange:ee!==null?2:0},_=this.Ob(Z,!1);return[{skippedExtensions:Q,builtinExtensions:x,baseResource:this.xb,baseContent:H?this.Ob(H,!1):_,localResource:this.yb,localContent:_,localExtensions:Z,remoteResource:this.zb,remoteExtensions:Y,remoteContent:Y?this.Ob(Y,!1):null,previewResource:this.wb,previewResult:ne,localChange:ne.localChange,remoteChange:ne.remoteChange,acceptedResource:this.Ab}]}async ub(z){const q=z.syncData?await v(z.syncData,this.Cb):null,{localExtensions:Y,ignoredExtensions:Q}=await this.Bb.getLocalExtensions(this.syncResource.profile),{remote:x}=(0,i.$74b)(Y,q,q,z.skippedExtensions||[],Q,z.builtinExtensions||[]);return x!==null}Hb(z,q,Y,Q){const x=[...q,...Y],H=new Set,Z=J=>{H.add(J.id.toLowerCase()),J.uuid&&H.add(J.uuid)};x.forEach(({identifier:J})=>Z(J)),Q.forEach(Z);for(const J of z)H.has(J.identifier.id.toLowerCase())||J.identifier.uuid&&H.has(J.identifier.uuid)||x.push(J);return this.Ob(x,!1)}async rb(z,q){return{...z.previewResult,hasConflicts:!1}}async sb(z,q,Y,Q){if(this.h.isEqual(q,this.yb))return this.Kb(z);if(this.h.isEqual(q,this.zb))return this.Lb(z);if(this.h.isEqual(q,this.wb))return z.previewResult;throw new Error(`Invalid Resource: ${q.toString()}`)}async Kb(z){const q=await this.Cb.getInstalled(void 0,this.syncResource.profile.extensionsResource),Y=this.Db.getIgnoredExtensions(q),Q=(0,i.$74b)(z.localExtensions,null,null,z.skippedExtensions,Y,z.builtinExtensions),{local:x,remote:H}=Q;return{content:z.localContent,local:x,remote:H,localChange:x.added.length>0||x.removed.length>0||x.updated.length>0?2:0,remoteChange:H!==null?2:0}}async Lb(z){const q=await this.Cb.getInstalled(void 0,this.syncResource.profile.extensionsResource),Y=this.Db.getIgnoredExtensions(q),Q=z.remoteContent?JSON.parse(z.remoteContent):null;if(Q!==null){const x=(0,i.$74b)(z.localExtensions,Q,z.localExtensions,[],Y,z.builtinExtensions),{local:H,remote:Z}=x;return{content:z.remoteContent,local:H,remote:Z,localChange:H.added.length>0||H.removed.length>0||H.updated.length>0?2:0,remoteChange:Z!==null?2:0}}else return{content:z.remoteContent,local:{added:[],removed:[],updated:[]},remote:null,localChange:0,remoteChange:0}}async tb(z,q,Y,Q){let{skippedExtensions:x,builtinExtensions:H,localExtensions:Z}=Y[0][0];const{local:J,remote:W,localChange:ee,remoteChange:ne}=Y[0][1];if(ee===0&&ne===0&&this.O.info(`${this.D}: No changes found during synchronizing extensions.`),ee!==0&&(await this.nb(JSON.stringify(Z)),x=await this.Bb.updateLocalExtensions(J.added,J.removed,J.updated,x,this.syncResource.profile)),W){this.O.trace(`${this.D}: Updating remote extensions...`);const _=JSON.stringify(W.all);z=await this.mb(_,Q?null:z.ref),this.O.info(`${this.D}: Updated remote extensions.${W.added.length?` Added: ${JSON.stringify(W.added.map(se=>se.identifier.id))}.`:""}${W.updated.length?` Updated: ${JSON.stringify(W.updated.map(se=>se.identifier.id))}.`:""}${W.removed.length?` Removed: ${JSON.stringify(W.removed.map(se=>se.identifier.id))}.`:""}`)}q?.ref!==z.ref&&(this.O.trace(`${this.D}: Updating last synchronized extensions...`),H=this.Nb(Z,H),await this.fb(z,{skippedExtensions:x,builtinExtensions:H}),this.O.info(`${this.D}: Updated last synchronized extensions.${x.length?` Skipped: ${JSON.stringify(x.map(_=>_.identifier.id))}.`:""}`))}Nb(z,q){const Y=new Set,Q=[];for(const x of z)Y.add(x.identifier.id.toLowerCase()),x.installed||Q.push(x.identifier);if(q)for(const x of q)Y.has(x.id.toLowerCase())||Q.push(x);return Q}async resolveContent(z){if(this.h.isEqual(this.zb,z)||this.h.isEqual(this.xb,z)||this.h.isEqual(this.yb,z)||this.h.isEqual(this.Ab,z)){const q=await this.db(z);return q&&this.Ob(JSON.parse(q),!0)}return null}Ob(z,q){return f(z,q)}async hasLocalData(){try{const{localExtensions:z}=await this.Bb.getLocalExtensions(this.syncResource.profile);if(z.some(q=>q.installed||q.disabled))return!0}catch{}return!1}};e.$04b=p,e.$04b=p=pe([X(2,R.$3h),X(3,w.$ek),X(4,m.$_o),X(5,r.$Ygb),X(6,r.$Zgb),X(7,b.$fo),X(8,t.$PFb),X(9,r.$bhb),X(10,d.$pi),X(11,r.$9gb),X(12,k.$il),X(13,g.$3u),X(14,s.$Ok),X(15,o.$eEb),X(16,c.$Uh)],p);let I=class{constructor(z,q,Y,Q,x,H){this.a=z,this.b=q,this.c=Y,this.d=Q,this.f=x,this.g=H}async getLocalExtensions(z){const q=await this.a.getInstalled(void 0,z.extensionsResource),Y=this.d.getIgnoredExtensions(q);return{localExtensions:await this.j(z,async(x,H)=>{const Z=x.getDisabledExtensions();return q.map(J=>{const{identifier:W,isBuiltin:ee,manifest:ne,preRelease:_,pinned:se,isApplicationScoped:K}=J,U={identifier:W,preRelease:_,version:ne.version,pinned:!!se};K&&!(0,y.$cm)(ne)&&(U.isApplicationScoped=K),Z.some(P=>(0,l.$Fo)(P,W))&&(U.disabled=!0),ee||(U.installed=!0);try{const P=H.getKeysForSync({id:W.id,version:ne.version});if(P){const F=H.getExtensionState(J,!0)||{};U.state=Object.keys(F).reduce((B,N)=>(P.includes(N)&&(B[N]=F[N]),B),{})}}catch(P){this.g.info(`${(0,n.$7Eb)("extensions",z)}: Error while parsing extension state`,(0,L.$9)(P))}return U})}),ignoredExtensions:Y}}async updateLocalExtensions(z,q,Y,Q,x){const H=(0,n.$7Eb)("extensions",x),Z=[],J=new Map,W=[],ee=[],ne=await this.a.getInstalled(void 0,x.extensionsResource);if((z.length||Y.length)&&await this.j(x,async(K,U)=>{await D.Promises.settled([...z,...Y].map(async P=>{const F=ne.find(V=>(0,l.$Fo)(V.identifier,P.identifier));if(F&&F.isBuiltin){P.state&&F.manifest.version===P.version&&this.h(P.state,F,F.manifest.version,U),K.getDisabledExtensions().some(G=>(0,l.$Fo)(G,P.identifier))!==!!P.disabled&&(P.disabled?(this.g.trace(`${H}: Disabling extension...`,P.identifier.id),await K.disableExtension(P.identifier),this.g.info(`${H}: Disabled extension`,P.identifier.id)):(this.g.trace(`${H}: Enabling extension...`,P.identifier.id),await K.enableExtension(P.identifier),this.g.info(`${H}: Enabled extension`,P.identifier.id))),W.push(P.identifier);return}const B=P.pinned?P.version:void 0,N=(await this.c.getExtensions([{...P.identifier,version:B,preRelease:B?void 0:P.preRelease}],A.CancellationToken.None))[0];if(P.state&&(F?F.manifest.version===P.version:N)&&this.h(P.state,F||N,F?.manifest.version,U),N)try{K.getDisabledExtensions().some(G=>(0,l.$Fo)(G,P.identifier))!==!!P.disabled&&(P.disabled?(this.g.trace(`${H}: Disabling extension...`,P.identifier.id,N.version),await K.disableExtension(N.identifier),this.g.info(`${H}: Disabled extension`,P.identifier.id,N.version)):(this.g.trace(`${H}: Enabling extension...`,P.identifier.id,N.version),await K.enableExtension(N.identifier),this.g.info(`${H}: Enabled extension`,P.identifier.id,N.version))),(!F||F.preRelease!==P.preRelease||F.pinned!==P.pinned||B&&F.manifest.version!==B)&&(await this.a.canInstall(N)?(Z.push({extension:N,options:{isMachineScoped:!1,donotIncludePackAndDependencies:!0,installGivenVersion:P.pinned&&!!P.version,installPreReleaseVersion:P.preRelease,profileLocation:x.extensionsResource,isApplicationScoped:P.isApplicationScoped,context:{[b.$7n]:!0,[b.$8n]:!0}}}),J.set(N.identifier.id.toLowerCase(),P)):(this.g.info(`${H}: Skipped synchronizing extension because it cannot be installed.`,N.displayName||N.identifier.id),ee.push(P)))}catch(V){ee.push(P),this.g.error(V),this.g.info(`${H}: Skipped synchronizing extension`,N.displayName||N.identifier.id)}else ee.push(P),this.g.info(`${H}: Skipped synchronizing extension because the extension is not found.`,P.identifier.id)}))}),q.length){const K=ne.filter(({identifier:U,isBuiltin:P})=>!P&&q.some(F=>(0,l.$Fo)(U,F)));await D.Promises.settled(K.map(async U=>{this.g.trace(`${H}: Uninstalling local extension...`,U.identifier.id),await this.a.uninstall(U,{donotIncludePack:!0,donotCheckDependents:!0,profileLocation:x.extensionsResource}),this.g.info(`${H}: Uninstalled local extension.`,U.identifier.id),W.push(U.identifier)}))}const _=await this.a.installGalleryExtensions(Z);for(const{identifier:K,local:U,error:P,source:F}of _){const B=F;if(U)this.g.info(`${H}: Installed extension.`,K.id,B.version),W.push(K);else{const N=J.get(K.id.toLowerCase());N&&(ee.push(N),this.g.info(`${H}: Skipped synchronizing extension`,B.displayName||B.identifier.id)),P instanceof b.$eo&&[b.ExtensionManagementErrorCode.Incompatible,b.ExtensionManagementErrorCode.IncompatibleTargetPlatform].includes(P.code)?this.g.info(`${H}: Skipped synchronizing extension because the compatible extension is not found.`,B.displayName||B.identifier.id):P&&this.g.error(P)}}const se=[];for(const K of Q)W.some(U=>(0,l.$Fo)(U,K.identifier))||se.push(K);for(const K of ee)se.some(U=>(0,l.$Fo)(U.identifier,K.identifier))||se.push(K);return se}h(z,q,Y,Q){const x=Q.getExtensionState(q,!0)||{},H=Y?Q.getKeysForSync({id:q.identifier.id,version:Y}):void 0;H?H.forEach(Z=>{x[Z]=z[Z]}):Object.keys(z).forEach(Z=>x[Z]=z[Z]),Q.setExtensionState(q,x,!0)}async j(z,q){return this.b.withProfileScopedStorageService(z,async Y=>{const Q=new C.$Qc,x=this.f.createChild(new u.$Th([m.$_o,Y])),H=Q.add(x.createInstance(E.$CDb)),Z=Q.add(x.createInstance(g.$4u));try{return await q(H,Z)}finally{Q.dispose()}})}};e.$$4b=I,e.$$4b=I=pe([X(0,b.$fo),X(1,o.$eEb),X(2,b.$do),X(3,t.$PFb),X(4,c.$Uh),X(5,r.$bhb)],I);let T=class extends n.$$Eb{constructor(z,q,Y,Q,x,H,Z,J){super("extensions",Q,x,H,Y,Z,J),this.p=z,this.q=q}async t(z){return z.syncData?await v(z.syncData,this.p):null}u(z,q){const Y=[],Q=[],x=[];for(const H of z){if(this.q.hasToNeverSyncExtension(H.identifier.id))continue;const Z=q.find(J=>(0,l.$Fo)(J.identifier,H.identifier));Z?(Y.push(Z),H.disabled&&x.push(H.identifier)):H.installed&&(Q.push({...H.identifier,preRelease:!!H.preRelease}),H.disabled&&x.push(H.identifier))}return{installedExtensions:Y,newExtensions:Q,disabledExtensions:x,remoteExtensions:z}}};e.$_4b=T,e.$_4b=T=pe([X(0,b.$fo),X(1,t.$PFb),X(2,w.$ek),X(3,a.$Qk),X(4,R.$3h),X(5,h.$dj),X(6,m.$_o),X(7,s.$Ok)],T)}),define(ae[115],ce([0,1,15,7,3,35,42,5,32,20,14,11,8,43,21,22,28,39,78,236,24,17,59,4]),function(ie,e,D,A,L,j,O,C,S,d,R,E,b,l,g,y,w,c,u,h,m,k,s,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$eFb=e.$dFb=e.$cFb=e.$bFb=e.$aFb=void 0;const n="globalState.argv.",i=["locale"];function t(p,I){const T=p.storage?Object.keys(p.storage).sort():[],M={};return T.forEach(z=>M[z]=p.storage[z]),p.storage=M,I?(0,O.$tT)(p,{}):JSON.stringify(p)}e.$aFb=t;const r=1;let o=class extends c.$8Eb{constructor(I,T,M,z,q,Y,Q,x,H,Z,J,W,ee,ne){super({syncResource:"globalState",profile:I},T,z,x,W,q,Y,H,Z,Q,J,ee),this.Bb=M,this.pb=r,this.vb=this.h.joinPath(this.g,"globalState.json"),this.wb=this.vb.with({scheme:m.$dhb,authority:"base"}),this.xb=this.vb.with({scheme:m.$dhb,authority:"local"}),this.yb=this.vb.with({scheme:m.$dhb,authority:"remote"}),this.zb=this.vb.with({scheme:m.$dhb,authority:"accepted"}),this.Ab=ne.createInstance(v),this.B(z.watch(this.h.dirname(this.H.argvResource))),this.B(L.Event.any(L.Event.filter(z.onDidFilesChange,_=>_.contains(this.H.argvResource)),L.Event.filter(M.onDidChange,_=>!!(_.targetChanges.some(se=>this.syncResource.profile.id===se.id)||_.valueChanges.some(({profile:se,changes:K})=>this.syncResource.profile.id===se.id&&K.some(U=>U.target===0)))))(()=>this.Q()))}async qb(I,T,M){const z=I.syncData?JSON.parse(I.syncData.content):null;T=T===null&&M?I:T;const q=T&&T.syncData?JSON.parse(T.syncData.content):null,Y=await this.Ab.getLocalGlobalState(this.syncResource.profile);z?this.O.trace(`${this.D}: Merging remote ui state with local ui state...`):this.O.trace(`${this.D}: Remote ui state does not exist. Synchronizing ui state for the first time.`);const Q=await this.Jb(q),{local:x,remote:H}=(0,h.$_Eb)(Y.storage,z?z.storage:null,q?q.storage:null,Q,this.O),Z={content:null,local:x,remote:H,localChange:Object.keys(x.added).length>0||Object.keys(x.updated).length>0||x.removed.length>0?2:0,remoteChange:H.all!==null?2:0},J=t(Y,!1);return[{baseResource:this.wb,baseContent:q?t(q,!1):J,localResource:this.xb,localContent:J,localUserData:Y,remoteResource:this.yb,remoteContent:z?t(z,!1):null,previewResource:this.vb,previewResult:Z,localChange:Z.localChange,remoteChange:Z.remoteChange,acceptedResource:this.zb,storageKeys:Q}]}async ub(I){const T=I.syncData?JSON.parse(I.syncData.content):null;if(T===null)return!0;const M=await this.Ab.getLocalGlobalState(this.syncResource.profile),z=await this.Jb(T),{remote:q}=(0,h.$_Eb)(M.storage,T.storage,T.storage,z,this.O);return q.all!==null}async rb(I,T){return{...I.previewResult,hasConflicts:!1}}async sb(I,T,M,z){if(this.h.isEqual(T,this.xb))return this.Gb(I);if(this.h.isEqual(T,this.yb))return this.Hb(I);if(this.h.isEqual(T,this.vb))return I.previewResult;throw new Error(`Invalid Resource: ${T.toString()}`)}async Gb(I){return{content:I.localContent,local:{added:{},removed:[],updated:{}},remote:{added:Object.keys(I.localUserData.storage),removed:[],updated:[],all:I.localUserData.storage},localChange:0,remoteChange:2}}async Hb(I){if(I.remoteContent!==null){const T=JSON.parse(I.remoteContent),{local:M,remote:z}=(0,h.$_Eb)(I.localUserData.storage,T.storage,null,I.storageKeys,this.O);return{content:I.remoteContent,local:M,remote:z,localChange:Object.keys(M.added).length>0||Object.keys(M.updated).length>0||M.removed.length>0?2:0,remoteChange:z!==null?2:0}}else return{content:I.remoteContent,local:{added:{},removed:[],updated:{}},remote:{added:[],removed:[],updated:[],all:null},localChange:0,remoteChange:0}}async tb(I,T,M,z){const{localUserData:q}=M[0][0],{local:Y,remote:Q,localChange:x,remoteChange:H}=M[0][1];if(x===0&&H===0&&this.O.info(`${this.D}: No changes found during synchronizing ui state.`),x!==0&&(this.O.trace(`${this.D}: Updating local ui state...`),await this.nb(JSON.stringify(q)),await this.Ab.writeLocalGlobalState(Y,this.syncResource.profile),this.O.info(`${this.D}: Updated local ui state`)),H!==0){this.O.trace(`${this.D}: Updating remote ui state...`);const Z=JSON.stringify({storage:Q.all});I=await this.mb(Z,z?null:I.ref),this.O.info(`${this.D}: Updated remote ui state.${Q.added.length?` Added: ${Q.added}.`:""}${Q.updated.length?` Updated: ${Q.updated}.`:""}${Q.removed.length?` Removed: ${Q.removed}.`:""}`)}T?.ref!==I.ref&&(this.O.trace(`${this.D}: Updating last synchronized ui state...`),await this.fb(I),this.O.info(`${this.D}: Updated last synchronized ui state`))}async resolveContent(I){if(this.h.isEqual(this.yb,I)||this.h.isEqual(this.wb,I)||this.h.isEqual(this.xb,I)||this.h.isEqual(this.zb,I)){const T=await this.db(I);return T&&t(JSON.parse(T),!0)}return null}async hasLocalData(){try{const{storage:I}=await this.Ab.getLocalGlobalState(this.syncResource.profile);if(Object.keys(I).length>1||I[`${n}.locale`]?.value!=="en")return!0}catch{}return!1}async Jb(I){const T=await this.Bb.readStorageData(this.syncResource.profile),M=[],z=[];for(const[Q,x]of T)x.target===0?M.push(Q):x.target===1&&z.push(Q);const q=[...M,...z],Y=I?.storage?Object.keys(I.storage).filter(Q=>!Q.startsWith(n)&&!q.includes(Q)&&T.get(Q)!==void 0):[];if(!C.$o){const Q=[...m.$Ugb.map(x=>(0,m.$8gb)(x)),m.$7gb];Y.push(...Q),z.push(...Q)}return{user:M,machine:z,unregistered:Y}}};e.$bFb=o,e.$bFb=o=pe([X(2,s.$eEb),X(3,E.$ek),X(4,m.$Ygb),X(5,m.$Zgb),X(6,m.$bhb),X(7,R.$3h),X(8,m.$9gb),X(9,y.$il),X(10,d.$pi),X(11,g.$_o),X(12,w.$Ok),X(13,a.$Uh)],o);let v=class{constructor(I,T,M,z){this.a=I,this.b=T,this.c=M,this.d=z}async getLocalGlobalState(I){const T={};if(I.isDefault){const z=await this.f(),q=(0,j.$3m)(z);for(const Y of i)q[Y]!==void 0&&(T[`${n}${Y}`]={version:1,value:q[Y]})}const M=await this.c.readStorageData(I);for(const[z,q]of M)q.value&&q.target===0&&(T[z]={version:1,value:q.value});return{storage:T}}async f(){try{this.d.debug("GlobalStateSync#getLocalArgvContent",this.b.argvResource);const I=await this.a.readFile(this.b.argvResource);return this.d.debug("GlobalStateSync#getLocalArgvContent - Resolved",this.b.argvResource),I.value.toString()}catch(I){this.d.debug((0,A.$9)(I))}return"{}"}async writeLocalGlobalState({added:I,removed:T,updated:M},z){const q=(0,c.$7Eb)("globalState",z),Y={},Q=new Map,x=await this.c.readStorageData(z),H=(Z,J)=>{for(const W of Z){if(W.startsWith(n)){Y[W.substring(n.length)]=J?J[W].value:void 0;continue}if(J){const ee=J[W];ee.value!==x.get(W)?.value&&Q.set(W,ee.value)}else x.get(W)!==void 0&&Q.set(W,void 0)}};if(H(Object.keys(I),I),H(Object.keys(M),M),H(T),Object.keys(Y).length){this.d.trace(`${q}: Updating locale...`);const Z=await this.f();let J=Z;for(const W of Object.keys(Y))J=(0,u.edit)(J,[W],Y[W],{});Z!==J&&(this.d.trace(`${q}: Updating locale...`),await this.a.writeFile(this.b.argvResource,D.$fe.fromString(J)),this.d.info(`${q}: Updated locale.`)),this.d.info(`${q}: Updated locale`)}Q.size&&(this.d.trace(`${q}: Updating global state...`),await this.c.updateStorageData(z,Q,0),this.d.info(`${q}: Updated global state`,[...Q.keys()]))}};e.$cFb=v,e.$cFb=v=pe([X(0,E.$ek),X(1,R.$3h),X(2,s.$eEb),X(3,m.$bhb)],v);let $=class extends c.$$Eb{constructor(I,T,M,z,q,Y){super("globalState",M,z,q,T,I,Y)}async o(I){const T=I.syncData?JSON.parse(I.syncData.content):null;if(!T){this.j.info("Skipping initializing global state because remote global state does not exist.");return}const M={},z={};for(const q of Object.keys(T.storage))q.startsWith(n)?M[q.substring(n.length)]=T.storage[q].value:this.l.get(q,0)===void 0&&(z[q]=T.storage[q].value);if(Object.keys(M).length){let q="{}";try{q=(await this.k.readFile(this.h.argvResource)).value.toString()}catch{}for(const Y of Object.keys(M))q=(0,u.edit)(q,[Y],M[Y],{});await this.k.writeFile(this.h.argvResource,D.$fe.fromString(q))}if(Object.keys(z).length){const q=[];for(const Y of Object.keys(z))q.push({key:Y,value:z[Y],scope:0,target:0});this.l.storeAll(q,!0)}}};e.$dFb=$,e.$dFb=$=pe([X(0,g.$_o),X(1,E.$ek),X(2,k.$Qk),X(3,R.$3h),X(4,m.$bhb),X(5,w.$Ok)],$);let f=class{constructor(I,T,M,z,q){this.a=I,this.b=T,this.c=M,this.d=z,this.f=q}getSyncStoreType(I){return this.h(I)?.storage[m.$7gb]?.value}async sync(I){const T=(0,m.$3gb)((0,S.$ig)());try{return await this.g(I,T)}catch(M){if(M instanceof m.$4gb)switch(M.code){case"PreconditionFailed":return this.f.info("Failed to synchronize UserDataSyncStoreType as there is a new remote version available. Synchronizing again..."),this.g(I,T)}throw M}}async g(I,T){const M=await this.a.readResource("globalState",null,void 0,T),z=this.h(M)||{storage:{}};z.storage[m.$7gb]={value:I,version:r};const q=await(0,l.$fp)(this.c,this.d,this.b),Y={version:r,machineId:q,content:t(z,!1)};await this.a.writeResource("globalState",JSON.stringify(Y),M.ref,void 0,T)}h({content:I}){if(!I)return null;const T=JSON.parse(I);if((0,c.$6Eb)(T))return T?JSON.parse(T.content):null;throw new Error("Invalid remote data")}};e.$eFb=f,e.$eFb=f=pe([X(1,g.$_o),X(2,R.$3h),X(3,E.$ek),X(4,b.$dj)],f)}),define(ae[116],ce([0,1,18,15,3,35,5,12,170,20,14,11,21,22,28,17,39,233,24]),function(ie,e,D,A,L,j,O,C,S,d,R,E,b,l,g,y,w,c,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$d5b=e.$c5b=e.$b5b=void 0;function h(s,a,n){try{const i=JSON.parse(s);if(!a)return(0,C.$Jf)(i.all)?null:i.all;switch(O.OS){case 2:return(0,C.$Jf)(i.mac)?null:i.mac;case 3:return(0,C.$Jf)(i.linux)?null:i.linux;case 1:return(0,C.$Jf)(i.windows)?null:i.windows}}catch(i){return n.error(i),null}}e.$b5b=h;let m=class extends w.$0Eb{constructor(a,n,i,t,r,o,v,$,f,p,I,T,M){super(a.keybindingsResource,{syncResource:"keybindings",profile:a},n,$,f,p,i,t,v,T,r,I,o,M),this.pb=2,this.Eb=this.h.joinPath(this.g,"keybindings.json"),this.Fb=this.Eb.with({scheme:u.$dhb,authority:"base"}),this.Gb=this.Eb.with({scheme:u.$dhb,authority:"local"}),this.Hb=this.Eb.with({scheme:u.$dhb,authority:"remote"}),this.Ib=this.Eb.with({scheme:u.$dhb,authority:"accepted"}),this.B(L.Event.filter(o.onDidChangeConfiguration,z=>z.affectsConfiguration("settingsSync.keybindingsPerPlatform"))(()=>this.Q()))}async qb(a,n,i,t){const r=a.syncData?h(a.syncData.content,t.keybindingsPerPlatform??this.Qb(),this.O):null;n=n===null&&i?a:n;const o=n?this.Ob(n):null,v=await this.vb(),$=await this.Cb();let f=null,p=!1,I=!1,T=!1;if(r){let q=v?v.value.toString():"[]";if(q=q||"[]",this.Ab(q,!0))throw new u.$4gb((0,S.localize)(0,null),"LocalInvalidContent",this.resource);if(!o||o!==q||o!==r){this.O.trace(`${this.D}: Merging remote keybindings with local keybindings...`);const Y=await(0,c.$a5b)(q,r,o,$,this.zb);Y.hasChanges&&(f=Y.mergeContent,T=Y.hasConflicts,p=T||Y.mergeContent!==q,I=T||Y.mergeContent!==r)}}else v&&(this.O.trace(`${this.D}: Remote keybindings does not exist. Synchronizing keybindings for the first time.`),f=v.value.toString(),I=!0);const M={content:T?o:f,localChange:p?v?2:1:0,remoteChange:I?2:0,hasConflicts:T},z=v?v.value.toString():null;return[{fileContent:v,baseResource:this.Fb,baseContent:o,localResource:this.Gb,localContent:z,localChange:M.localChange,remoteResource:this.Hb,remoteContent:r,remoteChange:M.remoteChange,previewResource:this.Eb,previewResult:M,acceptedResource:this.Ib}]}async ub(a){const n=this.Ob(a);if(n===null)return!0;const i=await this.vb(),t=i?i.value.toString():"",r=await this.Cb(),o=await(0,c.$a5b)(t||"[]",n,n,r,this.zb);return o.hasConflicts||o.mergeContent!==n}async rb(a,n){return a.previewResult}async sb(a,n,i,t){if(this.h.isEqual(n,this.Gb))return{content:a.fileContent?a.fileContent.value.toString():null,localChange:0,remoteChange:2};if(this.h.isEqual(n,this.Hb))return{content:a.remoteContent,localChange:2,remoteChange:0};if(this.h.isEqual(n,this.Eb))return i===void 0?{content:a.previewResult.content,localChange:a.previewResult.localChange,remoteChange:a.previewResult.remoteChange}:{content:i,localChange:2,remoteChange:2};throw new Error(`Invalid Resource: ${n.toString()}`)}async tb(a,n,i,t){const{fileContent:r}=i[0][0];let{content:o,localChange:v,remoteChange:$}=i[0][1];if(v===0&&$===0&&this.O.info(`${this.D}: No changes found during synchronizing keybindings.`),o!==null&&(o=o.trim(),o=o||"[]",this.Ab(o,!0)))throw new u.$4gb((0,S.localize)(1,null),"LocalInvalidContent",this.resource);if(v!==0&&(this.O.trace(`${this.D}: Updating local keybindings...`),r&&await this.nb(this.Pb(r.value.toString())),await this.wb(o||"[]",r,t),this.O.info(`${this.D}: Updated local keybindings`)),$!==0){this.O.trace(`${this.D}: Updating remote keybindings...`);const f=this.Pb(o||"[]",a.syncData?.content);a=await this.mb(f,t?null:a.ref),this.O.info(`${this.D}: Updated remote keybindings`)}try{await this.G.del(this.Eb)}catch{}n?.ref!==a.ref&&(this.O.trace(`${this.D}: Updating last synchronized keybindings...`),await this.fb(a,{platformSpecific:this.Qb()}),this.O.info(`${this.D}: Updated last synchronized keybindings`))}async hasLocalData(){try{const a=await this.vb();if(a){const n=(0,j.$3m)(a.value.toString());if((0,D.$Kb)(n))return!0}}catch(a){if(a.fileOperationResult!==1)return!0}return!1}async resolveContent(a){return this.h.isEqual(this.Hb,a)||this.h.isEqual(this.Fb,a)||this.h.isEqual(this.Gb,a)||this.h.isEqual(this.Ib,a)?this.db(a):null}Ob(a){return!a.syncData||a.platformSpecific!==void 0&&a.platformSpecific!==this.Qb()?null:h(a.syncData.content,this.Qb(),this.O)}Pb(a,n){let i={};try{i=JSON.parse(n||"{}")}catch(t){this.O.error(t)}switch(this.Qb()?delete i.all:i.all=a,O.OS){case 2:i.mac=a;break;case 3:i.linux=a;break;case 1:i.windows=a;break}return JSON.stringify(i)}Qb(){return!!this.P.getValue(u.$Rgb)}};e.$c5b=m,e.$c5b=m=pe([X(2,u.$Ygb),X(3,u.$Zgb),X(4,u.$bhb),X(5,d.$pi),X(6,u.$9gb),X(7,E.$ek),X(8,R.$3h),X(9,b.$_o),X(10,u.$ahb),X(11,l.$il),X(12,g.$Ok)],m);let k=class extends w.$$Eb{constructor(a,n,i,t,r,o){super("keybindings",n,i,t,a,r,o)}async o(a){const n=a.syncData?this.p(a.syncData.content):null;if(!n){this.j.info("Skipping initializing keybindings because remote keybindings does not exist.");return}if(!await this.i()){this.j.info("Skipping initializing keybindings because local keybindings exist.");return}await this.k.writeFile(this.g.defaultProfile.keybindingsResource,A.$fe.fromString(n)),await this.n(a)}async i(){try{const a=await this.k.readFile(this.g.defaultProfile.settingsResource),n=(0,j.$3m)(a.value.toString());return!(0,D.$Kb)(n)}catch(a){return a.fileOperationResult===1}}p(a){try{return h(a,!0,this.j)}catch(n){return this.j.error(n),null}}};e.$d5b=k,e.$d5b=k=pe([X(0,E.$ek),X(1,y.$Qk),X(2,R.$3h),X(3,u.$bhb),X(4,b.$_o),X(5,g.$Ok)],k)}),define(ae[117],ce([0,1,15,3,171,20,74,14,29,11,21,22,28,17,39,237,24]),function(ie,e,D,A,L,j,O,C,S,d,R,E,b,l,g,y,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$g5b=e.$f5b=e.$e5b=void 0;function c(k){return k&&k.settings&&typeof k.settings=="string"&&Object.keys(k).length===1}function u(k){const s=JSON.parse(k);return c(s)?s:{settings:k}}e.$e5b=u;let h=class extends g.$0Eb{constructor(s,a,n,i,t,r,o,v,$,f,p,I,T,M){super(s.settingsResource,{syncResource:"settings",profile:s},a,n,i,t,r,o,p,I,v,$,f,M),this.Eb=T,this.pb=2,this.previewResource=this.h.joinPath(this.g,"settings.json"),this.baseResource=this.previewResource.with({scheme:w.$dhb,authority:"base"}),this.localResource=this.previewResource.with({scheme:w.$dhb,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:w.$dhb,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:w.$dhb,authority:"accepted"}),this.Ob=void 0}async getRemoteUserDataSyncConfiguration(s){const a=await this.getLastSyncUserData(),n=await this.X(s,a),i=this.Lb(n),t=new O.$In(w.$Qgb);return i?.settings&&t.parse(i.settings),t.configurationModel.getValue(w.$Qgb)||{}}async qb(s,a,n){const i=await this.vb(),t=await this.Cb(),r=this.Lb(s);a=a===null&&n?s:a;const o=a?this.Lb(a):null,v=await this.Pb();let $=null,f=!1,p=!1,I=!1;if(r){let q=i?i.value.toString().trim():"{}";q=q||"{}",this.Qb(q),this.O.trace(`${this.D}: Merging remote settings with local settings...`);const Y=(0,y.$XDb)(q,r.settings,o?o.settings:null,v,[],t);$=Y.localContent||Y.remoteContent,f=Y.localContent!==null,p=Y.remoteContent!==null,I=Y.hasConflicts}else i&&(this.O.trace(`${this.D}: Remote settings does not exist. Synchronizing settings for the first time.`),$=i.value.toString().trim()||"{}",this.Qb($),p=!0);const T=i?i.value.toString():null,M=o?.settings??null,z={content:I?M:$,localChange:f?2:0,remoteChange:p?2:0,hasConflicts:I};return[{fileContent:i,baseResource:this.baseResource,baseContent:M,localResource:this.localResource,localContent:T,localChange:z.localChange,remoteResource:this.remoteResource,remoteContent:r?r.settings:null,remoteChange:z.remoteChange,previewResource:this.previewResource,previewResult:z,acceptedResource:this.acceptedResource}]}async ub(s){const a=this.Lb(s);if(a===null)return!0;const n=await this.vb(),i=n?n.value.toString().trim():"",t=await this.Pb(),r=await this.Cb();return(0,y.$XDb)(i||"{}",a.settings,a.settings,t,[],r).remoteContent!==null}async rb(s,a){const n=await this.Cb(),i=await this.Pb();return{...s.previewResult,content:s.previewResult.content?(0,y.$WDb)(s.previewResult.content,"{}",i,n):null}}async sb(s,a,n,i){const t=await this.Cb(),r=await this.Pb();if(this.h.isEqual(a,this.localResource))return{content:s.fileContent?(0,y.$WDb)(s.fileContent.value.toString(),"{}",r,t):null,localChange:0,remoteChange:2};if(this.h.isEqual(a,this.remoteResource))return{content:s.remoteContent!==null?(0,y.$WDb)(s.remoteContent,s.fileContent?s.fileContent.value.toString():"{}",r,t):null,localChange:2,remoteChange:0};if(this.h.isEqual(a,this.previewResource))return n===void 0?{content:s.previewResult.content,localChange:s.previewResult.localChange,remoteChange:s.previewResult.remoteChange}:{content:n!==null?(0,y.$WDb)(n,s.fileContent?s.fileContent.value.toString():"{}",r,t):null,localChange:2,remoteChange:2};throw new Error(`Invalid Resource: ${a.toString()}`)}async tb(s,a,n,i){const{fileContent:t}=n[0][0];let{content:r,localChange:o,remoteChange:v}=n[0][1];if(o===0&&v===0&&this.O.info(`${this.D}: No changes found during synchronizing settings.`),r=r?r.trim():"{}",r=r||"{}",this.Qb(r),o!==0&&(this.O.trace(`${this.D}: Updating local settings...`),t&&await this.nb(JSON.stringify(this.Nb(t.value.toString()))),await this.wb(r,t,i),await this.P.reloadConfiguration(3),this.O.info(`${this.D}: Updated local settings`)),v!==0){const $=await this.Cb(),f=this.Lb(s),p=await this.Pb(r);r=(0,y.$WDb)(r,f?f.settings:"{}",p,$),this.O.trace(`${this.D}: Updating remote settings...`),s=await this.mb(JSON.stringify(this.Nb(r)),i?null:s.ref),this.O.info(`${this.D}: Updated remote settings`)}try{await this.G.del(this.previewResource)}catch{}a?.ref!==s.ref&&(this.O.trace(`${this.D}: Updating last synchronized settings...`),await this.fb(s),this.O.info(`${this.D}: Updated last synchronized settings`))}async hasLocalData(){try{const s=await this.vb();if(s)return!(0,y.$YDb)(s.value.toString())}catch(s){if(s.fileOperationResult!==1)return!0}return!1}async resolveContent(s){return this.h.isEqual(this.remoteResource,s)||this.h.isEqual(this.localResource,s)||this.h.isEqual(this.acceptedResource,s)||this.h.isEqual(this.baseResource,s)?this.db(s):null}async db(s){let a=await super.db(s);if(a){const n=await this.Cb(),i=await this.Pb();a=(0,y.$WDb)(a,"{}",i,n)}return a}Lb(s){return s.syncData?this.Mb(s.syncData.content):null}Mb(s){try{return u(s)}catch(a){this.O.error(a)}return null}Nb(s){return{settings:s}}async Pb(s){if(!this.Ob){this.Ob=this.zb.resolveDefaultIgnoredSettings();const n=this.B(A.Event.any(A.Event.filter(this.Eb.onDidInstallExtensions,i=>i.some(({local:t})=>!!t)),A.Event.filter(this.Eb.onDidUninstallExtension,i=>!i.error))(()=>{n.dispose(),this.Ob=void 0}))}const a=await this.Ob;return(0,y.$UDb)(a,this.P,s)}Qb(s){if(this.Ab(s,!1))throw new w.$4gb((0,L.localize)(0,null),"LocalInvalidContent",this.resource)}};e.$f5b=h,e.$f5b=h=pe([X(2,d.$ek),X(3,C.$3h),X(4,R.$_o),X(5,w.$Ygb),X(6,w.$Zgb),X(7,w.$bhb),X(8,w.$ahb),X(9,j.$pi),X(10,w.$9gb),X(11,E.$il),X(12,S.$fo),X(13,b.$Ok)],h);let m=class extends g.$$Eb{constructor(s,a,n,i,t,r){super("settings",a,n,i,s,t,r)}async o(s){const a=s.syncData?this.p(s.syncData.content):null;if(!a){this.j.info("Skipping initializing settings because remote settings does not exist.");return}if(!await this.i()){this.j.info("Skipping initializing settings because local settings exist.");return}await this.k.writeFile(this.g.defaultProfile.settingsResource,D.$fe.fromString(a.settings)),await this.n(s)}async i(){try{const s=await this.k.readFile(this.g.defaultProfile.settingsResource);return(0,y.$YDb)(s.value.toString().trim())}catch(s){return s.fileOperationResult===1}}p(s){try{return u(s)}catch(a){this.j.error(a)}return null}};e.$g5b=m,e.$g5b=m=pe([X(0,d.$ek),X(1,l.$Qk),X(2,C.$3h),X(3,w.$bhb),X(4,R.$_o),X(5,b.$Ok)],m)}),define(ae[118],ce([0,1,15,3,30,20,14,11,21,22,28,17,39,234,24]),function(ie,e,D,A,L,j,O,C,S,d,R,E,b,l,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$l5b=e.$k5b=e.$j5b=void 0;function y(u){return JSON.parse(u.content)}e.$j5b=y;let w=class extends b.$8Eb{constructor(h,m,k,s,a,n,i,t,r,o,v,$){super({syncResource:"snippets",profile:h},m,s,k,a,n,i,o,v,t,r,$),this.pb=1,this.vb=h.snippetsHome,this.B(this.G.watch(k.userRoamingDataHome)),this.B(this.G.watch(this.vb)),this.B(A.Event.filter(this.G.onDidFilesChange,f=>f.affects(this.vb))(()=>this.Q()))}async qb(h,m,k){const s=await this.Hb(),a=this.Gb(s),n=h.syncData?this.Fb(h.syncData):null;m=m===null&&k?h:m;const i=m&&m.syncData?this.Fb(m.syncData):null;n?this.O.trace(`${this.D}: Merging remote snippets with local snippets...`):this.O.trace(`${this.D}: Remote snippets does not exist. Synchronizing snippets for the first time.`);const t=(0,l.$h5b)(a,n,i);return this.Bb(t,s,n||{},i||{})}async ub(h){const m=h.syncData?this.Fb(h.syncData):null;if(m===null)return!0;const k=await this.Hb(),s=this.Gb(k),a=(0,l.$h5b)(s,m,m);return Object.keys(a.remote.added).length>0||Object.keys(a.remote.updated).length>0||a.remote.removed.length>0||a.conflicts.length>0}async rb(h,m){return h.previewResult}async sb(h,m,k,s){if(this.h.isEqualOrParent(m,this.g.with({scheme:g.$dhb,authority:"local"})))return{content:h.fileContent?h.fileContent.value.toString():null,localChange:0,remoteChange:h.fileContent?h.remoteContent!==null?2:1:3};if(this.h.isEqualOrParent(m,this.g.with({scheme:g.$dhb,authority:"remote"})))return{content:h.remoteContent,localChange:h.remoteContent!==null?h.fileContent?2:1:3,remoteChange:0};if(this.h.isEqualOrParent(m,this.g))return k===void 0?{content:h.previewResult.content,localChange:h.previewResult.localChange,remoteChange:h.previewResult.remoteChange}:{content:k,localChange:k===null?h.fileContent!==null?3:0:2,remoteChange:k===null?h.remoteContent!==null?3:0:2};throw new Error(`Invalid Resource: ${m.toString()}`)}async tb(h,m,k,s){const a=k.map(([n,i])=>({...n,acceptResult:i}));a.every(({localChange:n,remoteChange:i})=>n===0&&i===0)&&this.O.info(`${this.D}: No changes found during synchronizing snippets.`),a.some(({localChange:n})=>n!==0)&&(await this.Cb(a),await this.Db(a,s)),a.some(({remoteChange:n})=>n!==0)&&(h=await this.Eb(a,h,s)),m?.ref!==h.ref&&(this.O.trace(`${this.D}: Updating last synchronized snippets...`),await this.fb(h),this.O.info(`${this.D}: Updated last synchronized snippets`));for(const{previewResource:n}of a)try{await this.G.del(n)}catch{}}Bb(h,m,k,s){const a=new Map;for(const n of Object.keys(h.local.added)){const i={content:h.local.added[n],hasConflicts:!1,localChange:1,remoteChange:0};a.set(n,{baseResource:this.h.joinPath(this.g,n).with({scheme:g.$dhb,authority:"base"}),baseContent:null,fileContent:null,localResource:this.h.joinPath(this.g,n).with({scheme:g.$dhb,authority:"local"}),localContent:null,remoteResource:this.h.joinPath(this.g,n).with({scheme:g.$dhb,authority:"remote"}),remoteContent:k[n],previewResource:this.h.joinPath(this.g,n),previewResult:i,localChange:i.localChange,remoteChange:i.remoteChange,acceptedResource:this.h.joinPath(this.g,n).with({scheme:g.$dhb,authority:"accepted"})})}for(const n of Object.keys(h.local.updated)){const i={content:h.local.updated[n],hasConflicts:!1,localChange:2,remoteChange:0},t=m[n]?m[n].value.toString():null;a.set(n,{baseResource:this.h.joinPath(this.g,n).with({scheme:g.$dhb,authority:"base"}),baseContent:s[n]??null,localResource:this.h.joinPath(this.g,n).with({scheme:g.$dhb,authority:"local"}),fileContent:m[n],localContent:t,remoteResource:this.h.joinPath(this.g,n).with({scheme:g.$dhb,authority:"remote"}),remoteContent:k[n],previewResource:this.h.joinPath(this.g,n),previewResult:i,localChange:i.localChange,remoteChange:i.remoteChange,acceptedResource:this.h.joinPath(this.g,n).with({scheme:g.$dhb,authority:"accepted"})})}for(const n of h.local.removed){const i={content:null,hasConflicts:!1,localChange:3,remoteChange:0},t=m[n]?m[n].value.toString():null;a.set(n,{baseResource:this.h.joinPath(this.g,n).with({scheme:g.$dhb,authority:"base"}),baseContent:s[n]??null,localResource:this.h.joinPath(this.g,n).with({scheme:g.$dhb,authority:"local"}),fileContent:m[n],localContent:t,remoteResource:this.h.joinPath(this.g,n).with({scheme:g.$dhb,authority:"remote"}),remoteContent:null,previewResource:this.h.joinPath(this.g,n),previewResult:i,localChange:i.localChange,remoteChange:i.remoteChange,acceptedResource:this.h.joinPath(this.g,n).with({scheme:g.$dhb,authority:"accepted"})})}for(const n of Object.keys(h.remote.added)){const i={content:h.remote.added[n],hasConflicts:!1,localChange:0,remoteChange:1},t=m[n]?m[n].value.toString():null;a.set(n,{baseResource:this.h.joinPath(this.g,n).with({scheme:g.$dhb,authority:"base"}),baseContent:s[n]??null,localResource:this.h.joinPath(this.g,n).with({scheme:g.$dhb,authority:"local"}),fileContent:m[n],localContent:t,remoteResource:this.h.joinPath(this.g,n).with({scheme:g.$dhb,authority:"remote"}),remoteContent:null,previewResource:this.h.joinPath(this.g,n),previewResult:i,localChange:i.localChange,remoteChange:i.remoteChange,acceptedResource:this.h.joinPath(this.g,n).with({scheme:g.$dhb,authority:"accepted"})})}for(const n of Object.keys(h.remote.updated)){const i={content:h.remote.updated[n],hasConflicts:!1,localChange:0,remoteChange:2},t=m[n]?m[n].value.toString():null;a.set(n,{baseResource:this.h.joinPath(this.g,n).with({scheme:g.$dhb,authority:"base"}),baseContent:s[n]??null,localResource:this.h.joinPath(this.g,n).with({scheme:g.$dhb,authority:"local"}),fileContent:m[n],localContent:t,remoteResource:this.h.joinPath(this.g,n).with({scheme:g.$dhb,authority:"remote"}),remoteContent:k[n],previewResource:this.h.joinPath(this.g,n),previewResult:i,localChange:i.localChange,remoteChange:i.remoteChange,acceptedResource:this.h.joinPath(this.g,n).with({scheme:g.$dhb,authority:"accepted"})})}for(const n of h.remote.removed){const i={content:null,hasConflicts:!1,localChange:0,remoteChange:3};a.set(n,{baseResource:this.h.joinPath(this.g,n).with({scheme:g.$dhb,authority:"base"}),baseContent:s[n]??null,localResource:this.h.joinPath(this.g,n).with({scheme:g.$dhb,authority:"local"}),fileContent:null,localContent:null,remoteResource:this.h.joinPath(this.g,n).with({scheme:g.$dhb,authority:"remote"}),remoteContent:k[n],previewResource:this.h.joinPath(this.g,n),previewResult:i,localChange:i.localChange,remoteChange:i.remoteChange,acceptedResource:this.h.joinPath(this.g,n).with({scheme:g.$dhb,authority:"accepted"})})}for(const n of h.conflicts){const i={content:s[n]??null,hasConflicts:!0,localChange:m[n]?2:1,remoteChange:k[n]?2:1},t=m[n]?m[n].value.toString():null;a.set(n,{baseResource:this.h.joinPath(this.g,n).with({scheme:g.$dhb,authority:"base"}),baseContent:s[n]??null,localResource:this.h.joinPath(this.g,n).with({scheme:g.$dhb,authority:"local"}),fileContent:m[n]||null,localContent:t,remoteResource:this.h.joinPath(this.g,n).with({scheme:g.$dhb,authority:"remote"}),remoteContent:k[n]||null,previewResource:this.h.joinPath(this.g,n),previewResult:i,localChange:i.localChange,remoteChange:i.remoteChange,acceptedResource:this.h.joinPath(this.g,n).with({scheme:g.$dhb,authority:"accepted"})})}for(const n of Object.keys(m))if(!a.has(n)){const i={content:m[n]?m[n].value.toString():null,hasConflicts:!1,localChange:0,remoteChange:0},t=m[n]?m[n].value.toString():null;a.set(n,{baseResource:this.h.joinPath(this.g,n).with({scheme:g.$dhb,authority:"base"}),baseContent:s[n]??null,localResource:this.h.joinPath(this.g,n).with({scheme:g.$dhb,authority:"local"}),fileContent:m[n]||null,localContent:t,remoteResource:this.h.joinPath(this.g,n).with({scheme:g.$dhb,authority:"remote"}),remoteContent:k[n]||null,previewResource:this.h.joinPath(this.g,n),previewResult:i,localChange:i.localChange,remoteChange:i.remoteChange,acceptedResource:this.h.joinPath(this.g,n).with({scheme:g.$dhb,authority:"accepted"})})}return[...a.values()]}async resolveContent(h){return this.h.isEqualOrParent(h,this.g.with({scheme:g.$dhb,authority:"remote"}))||this.h.isEqualOrParent(h,this.g.with({scheme:g.$dhb,authority:"local"}))||this.h.isEqualOrParent(h,this.g.with({scheme:g.$dhb,authority:"base"}))||this.h.isEqualOrParent(h,this.g.with({scheme:g.$dhb,authority:"accepted"}))?this.db(h):null}async hasLocalData(){try{const h=await this.Hb();if(Object.keys(h).length)return!0}catch{}return!1}async Cb(h){const m={};for(const k of h)k.fileContent&&(m[this.h.basename(k.localResource)]=k.fileContent);await this.nb(JSON.stringify(this.Gb(m)))}async Db(h,m){for(const{fileContent:k,acceptResult:s,localResource:a,remoteResource:n,localChange:i}of h)if(i!==0){const t=n?this.h.basename(n):this.h.basename(a),r=this.h.joinPath(this.vb,t);i===3?(this.O.trace(`${this.D}: Deleting snippet...`,this.h.basename(r)),await this.G.del(r),this.O.info(`${this.D}: Deleted snippet`,this.h.basename(r))):i===1?(this.O.trace(`${this.D}: Creating snippet...`,this.h.basename(r)),await this.G.createFile(r,D.$fe.fromString(s.content),{overwrite:m}),this.O.info(`${this.D}: Created snippet`,this.h.basename(r))):(this.O.trace(`${this.D}: Updating snippet...`,this.h.basename(r)),await this.G.writeFile(r,D.$fe.fromString(s.content),m?void 0:k),this.O.info(`${this.D}: Updated snippet`,this.h.basename(r)))}}async Eb(h,m,k){const s=m.syncData?this.Fb(m.syncData):{},a=(0,L.$an)(s);for(const{acceptResult:n,localResource:i,remoteResource:t,remoteChange:r}of h)if(r!==0){const o=i?this.h.basename(i):this.h.basename(t);r===3?delete a[o]:a[o]=n.content}return(0,l.$i5b)(s,a)||(this.O.trace(`${this.D}: Updating remote snippets...`),m=await this.mb(JSON.stringify(a),k?null:m.ref),this.O.info(`${this.D}: Updated remote snippets`)),m}Fb(h){return y(h)}Gb(h){const m={};for(const k of Object.keys(h))m[k]=h[k].value.toString();return m}async Hb(){const h={};let m;try{m=await this.G.resolve(this.vb)}catch(k){if(k instanceof C.$zk&&k.fileOperationResult===1)return h;throw k}for(const k of m.children||[]){const s=k.resource,a=this.h.extname(s);if(a===".json"||a===".code-snippets"){const n=this.h.relativePath(this.vb,s),i=await this.G.readFile(s);h[n]=i}}return h}};e.$k5b=w,e.$k5b=w=pe([X(2,O.$3h),X(3,C.$ek),X(4,S.$_o),X(5,g.$Ygb),X(6,g.$Zgb),X(7,g.$bhb),X(8,j.$pi),X(9,g.$9gb),X(10,d.$il),X(11,R.$Ok)],w);let c=class extends b.$$Eb{constructor(h,m,k,s,a,n){super("snippets",m,k,s,h,a,n)}async o(h){const m=h.syncData?JSON.parse(h.syncData.content):null;if(!m){this.j.info("Skipping initializing snippets because remote snippets does not exist.");return}if(!await this.i()){this.j.info("Skipping initializing snippets because local snippets exist.");return}for(const s of Object.keys(m)){const a=m[s];if(a){const n=this.d.joinPath(this.g.defaultProfile.snippetsHome,s);await this.k.createFile(n,D.$fe.fromString(a)),this.j.info("Created snippet",this.d.basename(n))}}await this.n(h)}async i(){try{return!(await this.k.resolve(this.g.defaultProfile.snippetsHome)).children?.length}catch(h){return h.fileOperationResult===1}}};e.$l5b=c,e.$l5b=c=pe([X(0,C.$ek),X(1,E.$Qk),X(2,O.$3h),X(3,g.$bhb),X(4,S.$_o),X(5,R.$Ok)],c)}),define(ae[119],ce([0,1,15,20,14,11,21,22,28,17,39,24]),function(ie,e,D,A,L,j,O,C,S,d,R,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$o5b=e.$n5b=e.$m5b=void 0;function b(w,c){try{return JSON.parse(w).tasks??null}catch(u){return c.error(u),null}}e.$m5b=b;let l=class extends R.$9Eb{constructor(c,u,h,m,k,s,a,n,i,t,r,o){super(c.tasksResource,{syncResource:"tasks",profile:c},u,n,i,t,h,m,a,r,k,s,o),this.pb=1,this.Ab=this.h.joinPath(this.g,"tasks.json"),this.Bb=this.Ab.with({scheme:E.$dhb,authority:"base"}),this.Cb=this.Ab.with({scheme:E.$dhb,authority:"local"}),this.Db=this.Ab.with({scheme:E.$dhb,authority:"remote"}),this.Eb=this.Ab.with({scheme:E.$dhb,authority:"accepted"})}async qb(c,u,h,m){const k=c.syncData?b(c.syncData.content,this.O):null;u=u===null&&h?c:u;const s=u?.syncData?b(u.syncData.content,this.O):null,a=await this.vb();let n=null,i=!1,t=!1,r=!1;if(c.syncData){const $=a?a.value.toString():null;if(!s||s!==$||s!==k){this.O.trace(`${this.D}: Merging remote tasks with local tasks...`);const f=y($,k,s);n=f.content,r=f.hasConflicts,i=f.hasLocalChanged,t=f.hasRemoteChanged}}else a&&(this.O.trace(`${this.D}: Remote tasks does not exist. Synchronizing tasks for the first time.`),n=a.value.toString(),t=!0);const o={content:r?s:n,localChange:i?a?2:1:0,remoteChange:t?2:0,hasConflicts:r},v=a?a.value.toString():null;return[{fileContent:a,baseResource:this.Bb,baseContent:s,localResource:this.Cb,localContent:v,localChange:o.localChange,remoteResource:this.Db,remoteContent:k,remoteChange:o.remoteChange,previewResource:this.Ab,previewResult:o,acceptedResource:this.Eb}]}async ub(c){const u=c?.syncData?b(c.syncData.content,this.O):null;if(u===null)return!0;const h=await this.vb(),m=h?h.value.toString():null,k=y(m,u,u);return k.hasLocalChanged||k.hasRemoteChanged}async rb(c,u){return c.previewResult}async sb(c,u,h,m){if(this.h.isEqual(u,this.Cb))return{content:c.fileContent?c.fileContent.value.toString():null,localChange:0,remoteChange:2};if(this.h.isEqual(u,this.Db))return{content:c.remoteContent,localChange:2,remoteChange:0};if(this.h.isEqual(u,this.Ab))return h===void 0?{content:c.previewResult.content,localChange:c.previewResult.localChange,remoteChange:c.previewResult.remoteChange}:{content:h,localChange:2,remoteChange:2};throw new Error(`Invalid Resource: ${u.toString()}`)}async tb(c,u,h,m){const{fileContent:k}=h[0][0],{content:s,localChange:a,remoteChange:n}=h[0][1];if(a===0&&n===0&&this.O.info(`${this.D}: No changes found during synchronizing tasks.`),a!==0&&(this.O.trace(`${this.D}: Updating local tasks...`),k&&await this.nb(JSON.stringify(this.Kb(k.value.toString()))),s?await this.wb(s,k,m):await this.xb(),this.O.info(`${this.D}: Updated local tasks`)),n!==0){this.O.trace(`${this.D}: Updating remote tasks...`);const i=JSON.stringify(this.Kb(s));c=await this.mb(i,m?null:c.ref),this.O.info(`${this.D}: Updated remote tasks`)}try{await this.G.del(this.Ab)}catch{}u?.ref!==c.ref&&(this.O.trace(`${this.D}: Updating last synchronized tasks...`),await this.fb(c),this.O.info(`${this.D}: Updated last synchronized tasks`))}async hasLocalData(){return this.G.exists(this.r)}async resolveContent(c){return this.h.isEqual(this.Db,c)||this.h.isEqual(this.Bb,c)||this.h.isEqual(this.Cb,c)||this.h.isEqual(this.Eb,c)?this.db(c):null}Kb(c){return c?{tasks:c}:{}}};e.$n5b=l,e.$n5b=l=pe([X(2,E.$Ygb),X(3,E.$Zgb),X(4,E.$bhb),X(5,A.$pi),X(6,E.$9gb),X(7,j.$ek),X(8,L.$3h),X(9,O.$_o),X(10,C.$il),X(11,S.$Ok)],l);let g=class extends R.$$Eb{constructor(c,u,h,m,k,s){super("tasks",u,h,m,c,k,s),this.c=this.g.defaultProfile.tasksResource}async o(c){const u=c.syncData?b(c.syncData.content,this.j):null;if(!u){this.j.info("Skipping initializing tasks because remote tasks does not exist.");return}if(!await this.p()){this.j.info("Skipping initializing tasks because local tasks exist.");return}await this.k.writeFile(this.c,D.$fe.fromString(u)),await this.n(c)}async p(){return this.k.exists(this.c)}};e.$o5b=g,e.$o5b=g=pe([X(0,j.$ek),X(1,d.$Qk),X(2,L.$3h),X(3,E.$bhb),X(4,O.$_o),X(5,S.$Ok)],g);function y(w,c,u){if(w===null&&c===null&&u===null)return{content:null,hasLocalChanged:!1,hasRemoteChanged:!1,hasConflicts:!1};if(w===c)return{content:null,hasLocalChanged:!1,hasRemoteChanged:!1,hasConflicts:!1};const h=u!==w,m=u!==c;return!h&&!m?{content:null,hasLocalChanged:!1,hasRemoteChanged:!1,hasConflicts:!1}:h&&!m?{content:w,hasRemoteChanged:!0,hasLocalChanged:!1,hasConflicts:!1}:m&&!h?{content:c,hasLocalChanged:!0,hasRemoteChanged:!1,hasConflicts:!1}:{content:w,hasLocalChanged:!0,hasRemoteChanged:!0,hasConflicts:!0}}}),define(ae[120],ce([0,1,42,20,14,11,21,22,28,17,39,235,24]),function(ie,e,D,A,L,j,O,C,S,d,R,E,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$76b=e.$66b=e.$56b=void 0;let l=class extends R.$8Eb{constructor(c,u,h,m,k,s,a,n,i,t,r,o,v){super({syncResource:"profiles",profile:c},u,m,k,s,a,n,r,o,i,t,v),this.vb=h,this.pb=2,this.previewResource=this.h.joinPath(this.g,"profiles.json"),this.baseResource=this.previewResource.with({scheme:b.$dhb,authority:"base"}),this.localResource=this.previewResource.with({scheme:b.$dhb,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:b.$dhb,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:b.$dhb,authority:"accepted"}),this.B(h.onDidChangeProfiles(()=>this.Q()))}async getLastSyncedProfiles(){const c=await this.getLastSyncUserData();return c?.syncData?y(c.syncData):null}async getRemoteSyncedProfiles(c){const u=await this.getLastSyncUserData(),h=await this.X(c,u);return h?.syncData?y(h.syncData):null}async qb(c,u,h){if(!this.vb.isEnabled())throw new b.$4gb("Cannot sync profiles because they are disabled","LocalError");const m=c.syncData?y(c.syncData):null,k=u?.syncData?y(u.syncData):null,s=this.Db(),{local:a,remote:n}=(0,E.$46b)(s,m,k,[]),i={local:a,remote:n,content:k?this.Eb(k):null,localChange:a.added.length>0||a.removed.length>0||a.updated.length>0?2:0,remoteChange:n!==null?2:0},t=g(s,!1);return[{baseResource:this.baseResource,baseContent:k?this.Eb(k):null,localResource:this.localResource,localContent:t,remoteResource:this.remoteResource,remoteContent:m?this.Eb(m):null,remoteProfiles:m,previewResource:this.previewResource,previewResult:i,localChange:i.localChange,remoteChange:i.remoteChange,acceptedResource:this.acceptedResource}]}async ub(c){const u=c?.syncData?y(c.syncData):null,h=this.Db(),{remote:m}=(0,E.$46b)(h,u,u,[]);return!!m?.added.length||!!m?.removed.length||!!m?.updated.length}async rb(c,u){return{...c.previewResult,hasConflicts:!1}}async sb(c,u,h,m){if(this.h.isEqual(u,this.localResource))return this.Ab(c);if(this.h.isEqual(u,this.remoteResource))return this.Bb(c);if(this.h.isEqual(u,this.previewResource))return c.previewResult;throw new Error(`Invalid Resource: ${u.toString()}`)}async Ab(c){const u=this.Db(),h=(0,E.$46b)(u,null,null,[]),{local:m,remote:k}=h;return{content:c.localContent,local:m,remote:k,localChange:m.added.length>0||m.removed.length>0||m.updated.length>0?2:0,remoteChange:k!==null?2:0}}async Bb(c){const u=c.remoteContent?JSON.parse(c.remoteContent):null,h=[],m=[];for(const k of this.Db()){const s=u?.find(a=>a.id===k.id);s&&(h.push({id:k.id,name:k.name,collection:s.collection}),m.push(k))}if(u!==null){const k=(0,E.$46b)(m,u,h,[]),{local:s,remote:a}=k;return{content:c.remoteContent,local:s,remote:a,localChange:s.added.length>0||s.removed.length>0||s.updated.length>0?2:0,remoteChange:a!==null?2:0}}else return{content:c.remoteContent,local:{added:[],removed:[],updated:[]},remote:null,localChange:0,remoteChange:0}}async tb(c,u,h,m){const{local:k,remote:s,localChange:a,remoteChange:n}=h[0][1];a===0&&n===0&&this.O.info(`${this.D}: No changes found during synchronizing profiles.`);const i=h[0][0].remoteProfiles||[];if(i.length+(s?.added.length??0)-(s?.removed.length??0)>20)throw new b.$4gb("Too many profiles to sync. Please remove some profiles and try again.","LocalTooManyProfiles");if(a!==0){await this.nb(g(this.Db(),!1));const t=[];for(const r of k.added)t.push((async()=>{this.O.trace(`${this.D}: Creating '${r.name}' profile...`),await this.vb.createProfile(r.id,r.name,{shortName:r.shortName,icon:r.icon,useDefaultFlags:r.useDefaultFlags}),this.O.info(`${this.D}: Created profile '${r.name}'.`)})());for(const r of k.removed)t.push((async()=>{this.O.trace(`${this.D}: Removing '${r.name}' profile...`),await this.vb.removeProfile(r),this.O.info(`${this.D}: Removed profile '${r.name}'.`)})());for(const r of k.updated){const o=this.vb.profiles.find(v=>v.id===r.id);o?t.push((async()=>{this.O.trace(`${this.D}: Updating '${r.name}' profile...`),await this.vb.updateProfile(o,{name:r.name,shortName:r.shortName,icon:r.icon,useDefaultFlags:r.useDefaultFlags}),this.O.info(`${this.D}: Updated profile '${r.name}'.`)})()):this.O.info(`${this.D}: Could not find profile with id '${r.id}' to update.`)}await Promise.all(t)}if(n!==0){this.O.trace(`${this.D}: Updating remote profiles...`);const t=[],r=i.length+(s?.added.length??0)<=20;if(r)for(const o of s?.added||[]){const v=await this.J.createCollection(this.F);t.push(v),i.push({id:o.id,name:o.name,collection:v,shortName:o.shortName,icon:o.icon,useDefaultFlags:o.useDefaultFlags})}else this.O.info(`${this.D}: Could not create remote profiles as there are too many profiles.`);for(const o of s?.removed||[])i.splice(i.findIndex(({id:v})=>o.id===v),1);for(const o of s?.updated||[]){const v=i.find(({id:$})=>o.id===$);v&&i.splice(i.indexOf(v),1,{...v,id:o.id,name:o.name,shortName:o.shortName,icon:o.icon,useDefaultFlags:o.useDefaultFlags})}try{c=await this.updateRemoteProfiles(i,m?null:c.ref),this.O.info(`${this.D}: Updated remote profiles.${r&&s?.added.length?` Added: ${JSON.stringify(s.added.map(o=>o.name))}.`:""}${s?.updated.length?` Updated: ${JSON.stringify(s.updated.map(o=>o.name))}.`:""}${s?.removed.length?` Removed: ${JSON.stringify(s.removed.map(o=>o.name))}.`:""}`)}catch(o){if(t.length){this.O.info(`${this.D}: Failed to update remote profiles. Cleaning up added collections...`);for(const v of t)await this.J.deleteCollection(v,this.F)}throw o}for(const o of s?.removed||[])await this.J.deleteCollection(o.collection,this.F)}u?.ref!==c.ref&&(this.O.trace(`${this.D}: Updating last synchronized profiles...`),await this.fb(c),this.O.info(`${this.D}: Updated last synchronized profiles.`))}async updateRemoteProfiles(c,u){return this.mb(this.Eb(c),u)}async hasLocalData(){return this.Db().length>0}async resolveContent(c){if(this.h.isEqual(this.remoteResource,c)||this.h.isEqual(this.baseResource,c)||this.h.isEqual(this.localResource,c)||this.h.isEqual(this.acceptedResource,c)){const u=await this.db(c);return u&&(0,D.$tT)(JSON.parse(u),{})}return null}Db(){return this.vb.profiles.filter(c=>!c.isDefault&&!c.isTransient)}Eb(c){return JSON.stringify([...c].sort((u,h)=>u.name.localeCompare(h.name)))}};e.$56b=l,e.$56b=l=pe([X(2,d.$Qk),X(3,j.$ek),X(4,L.$3h),X(5,O.$_o),X(6,b.$Ygb),X(7,b.$Zgb),X(8,b.$bhb),X(9,A.$pi),X(10,b.$9gb),X(11,C.$il),X(12,S.$Ok)],l);function g(w,c){const u=[...w].sort((h,m)=>h.name.localeCompare(m.name)).map(h=>({id:h.id,name:h.name}));return c?(0,D.$tT)(u,{}):JSON.stringify(u)}e.$66b=g;function y(w){return JSON.parse(w.content)}e.$76b=y}),define(ae[252],ce([0,1,3,2,5,14,21,22,24]),function(ie,e,D,A,L,j,O,C,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$R6b=void 0;const d="sync.enable";let R=class extends A.$Rc{constructor(b,l,g,y){super(),this.c=b,this.f=l,this.g=g,this.h=y,this.a=new D.$Rd,this.onDidChangeEnablement=this.a.event,this.b=new D.$Rd,this.onDidChangeResourceEnablement=this.b.event,this.B(b.onDidChangeValue(-1,void 0,this.B(new A.$Qc))(w=>this.m(w)))}isEnabled(){switch(this.g.sync){case"on":return!0;case"off":return!1}return this.c.getBoolean(d,-1,!1)}canToggleEnablement(){return this.h.userDataSyncStore!==void 0&&this.g.sync===void 0}setEnablement(b){b&&!this.canToggleEnablement()||(this.f.publicLog2(d,{enabled:b}),this.c.store(d,b,-1,1))}isResourceEnabled(b){return this.c.getBoolean((0,S.$8gb)(b),-1,!0)}setResourceEnablement(b,l){if(this.isResourceEnabled(b)!==l){const g=(0,S.$8gb)(b);this.j(g,l)}}getResourceSyncStateVersion(b){}j(b,l){this.c.store(b,l,-1,L.$o?0:1)}m(b){if(d===b.key){this.a.fire(this.isEnabled());return}const l=S.$Ugb.filter(g=>(0,S.$8gb)(g)===b.key)[0];if(l){this.b.fire([l,this.isResourceEnabled(l)]);return}}};e.$R6b=R,e.$R6b=R=pe([X(0,O.$_o),X(1,C.$il),X(2,j.$3h),X(3,S.$Xgb)],R)}),define(ae[253],ce([0,1,6,15,64,2,19,20,14,11,17,24]),function(ie,e,D,A,L,j,O,C,S,d,R,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$36b=void 0;let b=class extends j.$Rc{constructor(g,y,w,c,u){super(),this.a=g,this.b=y,this.c=w,this.f=c,this.g=u,this.h()}async h(){for(const y of this.g.profiles)for(const w of E.$Ugb)try{await this.m(this.j(w,y.isDefault?void 0:y.id))}catch(c){this.f.error(c)}let g;try{g=await this.b.resolve(this.a.userDataSyncHome)}catch(y){(0,d.$vk)(y)!==1&&this.f.error(y);return}if(g.children){for(const y of g.children)if(y.isDirectory&&!this.g.profiles.some(w=>w.id===y.name))try{this.f.info("Deleting non existing profile from backup",y.resource.path),await this.b.del(y.resource,{recursive:!0})}catch(w){this.f.error(w)}}}async getAllResourceRefs(g,y,w){const c=this.j(g,y,w);try{const u=await this.b.resolve(c);if(u.children)return u.children.filter(m=>m.isFile&&!m.name.startsWith("lastSync")).sort().reverse().map(m=>({ref:m.name,created:this.n(m)}))}catch(u){if((0,d.$vk)(u)!==1)throw u}return[]}async resolveResourceContent(g,y,w,c){const u=this.j(g,w,c),h=(0,O.$zg)(u,y);try{return(await this.b.readFile(h)).value.toString()}catch(m){return this.f.error(m),null}}async writeResource(g,y,w,c,u){const h=this.j(g,c,u),m=(0,O.$zg)(h,`${(0,L.$km)(w).replace(/-|:|\.\d+Z$/g,"")}.json`);try{await this.b.writeFile(m,A.$fe.fromString(y))}catch(k){this.f.error(k)}}j(g,y,w=this.a.userDataSyncHome){return(0,O.$zg)(w,...y?[y,g]:[g])}async m(g){try{try{if(!await this.b.exists(g))return}catch{return}const y=await this.b.resolve(g);if(y.children){const w=y.children.filter(m=>m.isFile&&/^\d{8}T\d{6}(\.json)?$/.test(m.name)).sort(),c=1e3*60*60*24*(this.c.getValue("sync.localBackupDuration")||30);let u=w.filter(m=>Date.now()-this.n(m)>c);const h=w.length-u.length;h<10&&(u=u.slice(10-h)),await D.Promises.settled(u.map(async m=>{this.f.info("Deleting from backup",m.resource.path),await this.b.del(m.resource)}))}}catch(y){this.f.error(y)}}n(g){return new Date(parseInt(g.name.substring(0,4)),parseInt(g.name.substring(4,6))-1,parseInt(g.name.substring(6,8)),parseInt(g.name.substring(9,11)),parseInt(g.name.substring(11,13)),parseInt(g.name.substring(13,15))).getTime()}};e.$36b=b,e.$36b=b=pe([X(0,S.$3h),X(1,d.$ek),X(2,C.$pi),X(3,E.$bhb),X(4,R.$Qk)],b)}),define(ae[82],ce([0,1,3,2,5,27,175,14,11,4,25,43,21,24]),function(ie,e,D,A,L,j,O,C,S,d,R,E,b,l){"use strict";var g;Object.defineProperty(e,"__esModule",{value:!0}),e.$Ngb=e.$Mgb=e.$Lgb=void 0,e.$Lgb=(0,d.$Vh)("IUserDataSyncMachinesService");const y="sync.currentMachineName",w="Safari",c="Chrome",u="Edge",h="Firefox",m="Android";function k(n){switch(n){case w:case c:case u:case h:case m:case(0,L.$h)(0):return!0}return!1}e.$Mgb=k;function s(){return L.$G?w:L.$E?c:L.$H?u:L.$F?h:L.$I?m:(0,L.$h)(L.$o?0:L.$u)}let a=class extends A.$Rc{static{g=this}static{this.a=1}static{this.b="machines"}constructor(i,t,r,o,v,$){super(),this.h=r,this.j=o,this.m=v,this.n=$,this.c=this.B(new D.$Rd),this.onDidChange=this.c.event,this.g=null,this.f=(0,E.$fp)(i,t,r)}async getMachines(i){const t=await this.f;return(await this.s(i)).machines.map(o=>({...o,isCurrent:o.id===t}))}async addCurrentMachine(i){const t=await this.f,r=await this.s(i);r.machines.some(({id:o})=>o===t)||(r.machines.push({id:t,name:this.r(r.machines),platform:s()}),await this.t(r))}async removeCurrentMachine(i){const t=await this.f,r=await this.s(i),o=r.machines.filter(({id:v})=>v!==t);o.length!==r.machines.length&&(r.machines=o,await this.t(r))}async renameMachine(i,t,r){const o=await this.s(r),v=o.machines.find(({id:$})=>$===i);if(v){v.name=t,await this.t(o);const $=await this.f;i===$&&this.h.store(y,t,-1,1)}}async setEnablements(i){const t=await this.s();for(const[r,o]of i){const v=t.machines.find($=>$.id===r);v&&(v.disabled=o?void 0:!0)}await this.t(t)}r(i){const t=this.h.get(y,-1);if(t)return t;const r=`${this.n.embedderIdentifier?`${this.n.embedderIdentifier} - `:""}${s()} (${this.n.nameShort})`,o=new RegExp(`${(0,j.$Je)(r)}\\s#(\\d+)`);let v=0;for(const $ of i){const f=o.exec($.name),p=f?parseInt(f[1]):0;v=p>v?p:v}return`${r} #${v+1}`}async s(i){this.g=await this.u(i);const t=this.w(this.g);if(t.version!==g.a)throw new Error((0,O.localize)(0,null,this.n.nameLong));return t}async t(i){const t=JSON.stringify(i),r=await this.j.writeResource(g.b,t,this.g?.ref||null);this.g={ref:r,content:t},this.c.fire()}async u(i){if(this.g){const t=i&&i.latest?i.latest[g.b]:void 0;if(this.g.ref===t)return this.g;if(t===void 0&&this.g.content===null)return this.g}return this.j.readResource(g.b,this.g)}w(i){if(i.content!==null)try{return JSON.parse(i.content)}catch(t){this.m.error(t)}return{version:g.a,machines:[]}}};e.$Ngb=a,e.$Ngb=a=g=pe([X(0,C.$3h),X(1,S.$ek),X(2,b.$_o),X(3,l.$Ygb),X(4,l.$bhb),X(5,R.$vj)],a)}),define(ae[254],ce([0,1,6,64,38,7,3,2,5,19,10,172,25,21,22,24,79,82]),function(ie,e,D,A,L,j,O,C,S,d,R,E,b,l,g,y,w,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$96b=void 0;const u="sync.disableMachineEventually",h="sync.sessionId",m="sync.storeUrl",k="sync.productQuality";let s=class extends C.$Rc{get n(){const i=this.H.get(m,-1);return i?R.URI.parse(i):void 0}set n(i){i?this.H.store(m,i.toString(),-1,1):this.H.remove(m,-1)}get s(){return this.H.get(k,-1)}set s(i){i?this.H.store(k,i,-1,1):this.H.remove(k,-1)}constructor(i,t,r,o,v,$,f,p,I,T){super(),this.u=t,this.w=r,this.y=o,this.z=v,this.C=$,this.D=f,this.F=p,this.G=I,this.H=T,this.a=this.B(new C.$Sc),this.b=0,this.c=void 0,this.g=!1,this.h=this.B(new O.$Rd),this.onError=this.h.event,this.S=[],this.f=this.B(new D.$Vg(this.U())),this.j=this.n,this.n=t.userDataSyncStore?.url,this.r=this.s,this.s=i.quality,this.n&&(this.C.info("Using settings sync service",this.n.toString()),this.B(t.onDidChangeUserDataSyncStore(()=>{(0,d.$sg)(this.n,t.userDataSyncStore?.url)||(this.j=this.n,this.n=t.userDataSyncStore?.url,this.n&&this.C.info("Using settings sync service",this.n.toString()))})),this.y.isEnabled()?this.C.info("Auto Sync is enabled."):this.C.info("Auto Sync is disabled."),this.I(),this.Q()&&this.P(),this.B(f.onDidChangeAccount(()=>this.I())),this.B(r.onDidChangeDonotMakeRequestsUntil(()=>this.I())),this.B(v.onDidChangeLocal(M=>this.triggerSync([M],!1,!1))),this.B(O.Event.filter(this.y.onDidChangeResourceEnablement,([,M])=>M)(()=>this.triggerSync(["resourceEnablement"],!1,!1))),this.B(this.u.onDidChangeUserDataSyncStore(()=>this.triggerSync(["userDataSyncStoreChanged"],!1,!1))))}I(){const{enabled:i,message:t}=this.L();i?this.a.value===void 0&&(this.a.value=new a(this.j,1e3*60*5,this.u,this.w,this.z,this.G,this.C,this.F,this.H),this.a.value.register(this.a.value.onDidStartSync(()=>this.c=new Date().getTime())),this.a.value.register(this.a.value.onDidFinishSync(r=>this.O(r))),this.J()&&this.a.value.start()):(this.f.cancel(),this.a.value!==void 0?(t&&this.C.info(t),this.a.clear()):t&&this.y.isEnabled()&&this.C.info(t))}J(){return!0}L(){return this.y.isEnabled()?this.D.account?this.w.donotMakeRequestsUntil?{enabled:!1,message:`Auto Sync: Suspended until ${(0,A.$km)(this.w.donotMakeRequestsUntil)} because server is not accepting requests until then.`}:this.g?{enabled:!1,message:"Auto Sync: Suspended until restart."}:{enabled:!0}:{enabled:!1,message:"Auto Sync: Suspended until auth token is available."}:{enabled:!1,message:"Auto Sync: Disabled."}}async turnOn(){this.R(),this.j=this.n,this.M(!0)}async turnOff(i,t,r){try{this.D.account&&!r&&await this.G.removeCurrentMachine(),this.M(!1),this.H.remove(h,-1),i?(this.F.publicLog2("sync/turnOffEveryWhere"),await this.z.reset()):await this.z.resetLocal()}catch(o){if(this.C.error(o),t)this.M(!1);else throw o}}M(i){this.y.isEnabled()!==i&&(this.y.setEnablement(i),this.I())}N(){return!!this.r&&!!this.s&&this.r!==this.s}async O(i){if(!i){this.b=0;return}const t=y.$4gb.toUserDataSyncError(i);t instanceof y.$6gb&&this.F.publicLog2("autosync/error",{code:t.code,service:this.u.userDataSyncStore.url.toString()}),t.code==="SessionExpired"?(await this.turnOff(!1,!0),this.C.info("Auto Sync: Turned off sync because current session is expired")):t.code==="TurnedOff"?(await this.turnOff(!1,!0),this.C.info("Auto Sync: Turned off sync because sync is turned off in the cloud")):t.code==="LocalTooManyRequests"?(this.g=!0,this.C.info("Auto Sync: Suspended sync because of making too many requests to server"),this.I()):t.code==="RemoteTooManyRequests"?(await this.turnOff(!1,!0,!0),this.P(),this.C.info("Auto Sync: Turned off sync because of making too many requests to server")):t.code==="MethodNotFound"?(await this.turnOff(!1,!0),this.C.info("Auto Sync: Turned off sync because current client is making requests to server that are not supported")):t.code==="UpgradeRequired"||t.code==="Gone"?(await this.turnOff(!1,!0,!0),this.P(),this.C.info("Auto Sync: Turned off sync because current client is not compatible with server. Requires client upgrade.")):t.code==="IncompatibleLocalContent"?(await this.turnOff(!1,!0),this.C.info(`Auto Sync: Turned off sync because server has ${t.resource} content with newer version than of client. Requires client upgrade.`)):t.code==="IncompatibleRemoteContent"?(await this.turnOff(!1,!0),this.C.info(`Auto Sync: Turned off sync because server has ${t.resource} content with older version than of client. Requires server reset.`)):t.code==="ServiceChanged"||t.code==="DefaultServiceChanged"?S.$o&&t.code==="DefaultServiceChanged"&&!this.N()?(await this.turnOff(!1,!0),this.C.info("Auto Sync: Turned off sync because default sync service is changed.")):(await this.turnOff(!1,!0,!0),await this.turnOn(),this.C.info("Auto Sync: Sync Service changed. Turned off auto sync, reset local state and turned on auto sync.")):(this.C.error(t),this.b++),this.h.fire(t)}async P(){this.H.store(u,!0,-1,1),await(0,D.$Yg)(1e3*60*10),this.Q()&&(this.R(),!this.y.isEnabled()&&this.D.account&&await this.G.removeCurrentMachine())}Q(){return this.H.getBoolean(u,-1,!1)}R(){this.H.remove(u,-1)}async triggerSync(i,t,r){if(this.a.value===void 0)return this.f.cancel();if(t&&this.c&&Math.round((new Date().getTime()-this.c)/1e3)<10){this.C.debug("Auto Sync: Skipped. Limited to once per 10 seconds.");return}return this.S.push(...i),this.f.trigger(async()=>{this.C.trace("activity sources",...this.S);const o=this.D.account?.authenticationProviderId||"";this.F.publicLog2("sync/triggered",{sources:this.S,providerId:o}),this.S=[],this.a.value&&await this.a.value.sync("Activity",r)},this.b?this.U()*1*Math.min(Math.pow(2,this.b),60):this.U())}U(){return 2e3}};e.$96b=s,e.$96b=s=pe([X(0,b.$vj),X(1,y.$Xgb),X(2,y.$Ygb),X(3,y.$9gb),X(4,y.$0gb),X(5,y.$bhb),X(6,w.$EDb),X(7,g.$il),X(8,c.$Lgb),X(9,l.$_o)],s);class a extends C.$Rc{static{this.a="Interval"}constructor(i,t,r,o,v,$,f,p,I){super(),this.m=i,this.n=t,this.r=r,this.s=o,this.u=v,this.w=$,this.y=f,this.z=p,this.C=I,this.b=this.B(new C.$Sc),this.c=this.B(new O.$Rd),this.onDidStartSync=this.c.event,this.f=this.B(new O.$Rd),this.onDidFinishSync=this.f.event,this.g=null}start(){this.B(this.onDidFinishSync(()=>this.D())),this.B((0,C.$Pc)(()=>{this.j&&(this.j.cancel(),this.y.info("Auto sync: Cancelled sync that is in progress"),this.j=void 0),this.h?.stop(),this.y.info("Auto Sync: Stopped")})),this.sync(a.a,!1)}D(){this.b.value=(0,D.$Zg)(()=>{this.sync(a.a,!1),this.b.value=void 0},this.n)}sync(i,t){const r=(0,D.$Lg)(async o=>{if(this.j)try{this.y.debug("Auto Sync: Waiting until sync is finished."),await this.j}catch(v){if((0,j.$3)(v))return}return this.H(i,t,o)});return this.j=r,this.j.finally(()=>this.j=void 0),this.j}F(){return this.m!==void 0&&!(0,d.$sg)(this.m,this.r.userDataSyncStore?.url)}async G(){const i=await this.r.getPreviousUserDataSyncStore(),t=this.r.userDataSyncStore;return!!t&&!!i&&(!(0,d.$sg)(t.defaultUrl,i.defaultUrl)||!(0,d.$sg)(t.insidersUrl,i.insidersUrl)||!(0,d.$sg)(t.stableUrl,i.stableUrl))}async H(i,t,r){this.y.info(`Auto Sync: Triggered by ${i}`),this.c.fire();let o;try{await this.I(t,r)}catch(v){if(this.y.error(v),o=v,y.$4gb.toUserDataSyncError(v).code==="MethodNotFound")try{this.y.info("Auto Sync: Client is making invalid requests. Cleaning up data..."),await this.u.cleanUpRemoteData(),this.y.info("Auto Sync: Retrying sync..."),await this.I(t,r),o=void 0}catch($){this.y.error($),o=$}}this.f.fire(o)}async I(i,t){if(this.h=await this.u.createSyncTask(this.g,i),t.isCancellationRequested)return;if(this.g=this.h.manifest,this.g===null&&await this.u.hasPreviouslySynced())throw this.F()?await this.G()?new y.$6gb((0,E.localize)(0,null),"DefaultServiceChanged"):new y.$6gb((0,E.localize)(1,null),"ServiceChanged"):new y.$6gb((0,E.localize)(2,null),"TurnedOff");const r=this.C.get(h,-1);if(r&&this.g&&r!==this.g.session)throw this.F()?await this.G()?new y.$6gb((0,E.localize)(3,null),"DefaultServiceChanged"):new y.$6gb((0,E.localize)(4,null),"ServiceChanged"):new y.$6gb((0,E.localize)(5,null),"SessionExpired");const o=await this.w.getMachines(this.g||void 0);if(t.isCancellationRequested)return;const v=o.find(f=>f.isCurrent);if(v?.disabled)throw new y.$6gb((0,E.localize)(6,null),"TurnedOff");const $=new Date().getTime();if(await this.h.run(),this.z.publicLog2("settingsSync:sync",{duration:new Date().getTime()-$}),this.g===null)try{this.g=await this.s.manifest(null)}catch(f){throw new y.$6gb((0,L.$Gi)(f),f instanceof y.$4gb?f.code:"Unknown")}this.g&&this.g.session!==r&&this.C.store(h,this.g.session,-1,1),!t.isCancellationRequested&&(v||await this.w.addCurrentMachine(this.g||void 0))}register(i){return super.B(i)}}}),define(ae[255],ce([0,1,10,176,14,11,43,21,28,24,17,39,118,117,116,20,119,114,115,4,120,42,27]),function(ie,e,D,A,L,j,O,C,S,d,R,E,b,l,g,y,w,c,u,h,m,k,s){"use strict";var a;Object.defineProperty(e,"__esModule",{value:!0}),e.$G7b=void 0;let n=class{static{a=this}static{this.a="not-existing-resource"}static{this.b="remote-backup"}static{this.c="local-backup"}constructor(t,r,o,v,$,f,p,I,T,M){this.e=t,this.f=r,this.g=o,this.h=$,this.i=f,this.j=p,this.k=I,this.l=T,this.n=M,this.d=v.extUri}async getRemoteSyncedProfiles(){const t=await this.e.readResource("profiles",null,void 0);if(t.content){const r=this.L(t.content,"profiles");return(0,m.$76b)(r)}return[]}async getLocalSyncedProfiles(t){const r=await this.f.getAllResourceRefs("profiles",void 0,t);if(r.length){const o=await this.f.resolveResourceContent("profiles",r[0].ref,void 0,t);if(o){const v=this.L(o,"profiles");return(0,m.$76b)(v)}}return[]}async getLocalSyncedMachines(t){const r=await this.f.getAllResourceRefs("machines",void 0,t);if(r.length){const o=await this.f.resolveResourceContent("machines",r[0].ref,void 0,t);if(o)return JSON.parse(o).machines.map($=>({...$,isCurrent:!1}))}return[]}async getRemoteSyncResourceHandles(t,r){return(await this.e.getAllResourceRefs(t,r?.collection)).map(({created:v,ref:$})=>({created:v,uri:this.J({remote:!0,syncResource:t,profile:r?.id??this.k.defaultProfile.id,location:void 0,collection:r?.collection,ref:$,node:void 0})}))}async getLocalSyncResourceHandles(t,r,o){return(await this.f.getAllResourceRefs(t,r?.collection,o)).map(({created:$,ref:f})=>({created:$,uri:this.J({remote:!1,syncResource:t,profile:r?.id??this.k.defaultProfile.id,collection:r?.collection,ref:f,node:void 0,location:o})}))}resolveUserDataSyncResource({uri:t}){const r=this.K(t),o=r?this.k.profiles.find(v=>v.id===r.profile):void 0;return r&&o?{profile:o,syncResource:r?.syncResource}:void 0}async getAssociatedResources({uri:t}){const r=this.K(t);if(!r)return[];const o=this.k.profiles.find(v=>v.id===r.profile);switch(r.syncResource){case"settings":return this.s(t,o);case"keybindings":return this.u(t,o);case"tasks":return this.w(t,o);case"snippets":return this.y(t,o);case"globalState":return this.D(t,o);case"extensions":return this.A(t,o);case"profiles":return this.G(t,o);case"workspaceState":return[]}}async getMachineId({uri:t}){const r=this.K(t);if(r){if(r.remote){if(r.ref){const{content:o}=await this.M(r.syncResource,r.ref,r.collection);if(o)return this.L(o,r.syncResource)?.machineId}return}if(r.location){if(r.ref){const o=await this.f.resolveResourceContent(r.syncResource,r.ref,r.collection,r.location);if(o)return this.L(o,r.syncResource)?.machineId}return}return(0,O.$fp)(this.h,this.j,this.i)}}async resolveContent(t){const r=this.K(t);if(!r||r.node===a.a)return null;if(r.ref){const o=await this.o(r.remote,r.syncResource,r.collection,r.ref,r.location);return r.node&&o?this.q(r.syncResource,o,r.node):o}return!r.remote&&!r.node?this.r(r.syncResource,r.profile):null}async o(t,r,o,v,$){if(t){const{content:f}=await this.M(r,v,o);return f}return this.f.resolveResourceContent(r,v,o,$)}q(t,r,o){const v=this.L(r,t);switch(t){case"settings":return this.t(v,o);case"keybindings":return this.v(v,o);case"tasks":return this.x(v,o);case"snippets":return this.z(v,o);case"globalState":return this.E(v,o);case"extensions":return this.B(v,o);case"profiles":return this.H(v,o);case"workspaceState":return null}}async r(t,r){const o=this.k.profiles.find(v=>v.id===r);if(!o)return null;switch(t){case"globalState":return this.F(o);case"extensions":return this.C(o);case"profiles":return this.I(o);case"settings":return null;case"keybindings":return null;case"tasks":return null;case"snippets":return null;case"workspaceState":return null}}s(t,r){const o=this.d.joinPath(t,"settings.json"),v=r?r.settingsResource:this.d.joinPath(t,a.a);return[{resource:o,comparableResource:v}]}t(t,r){switch(r){case"settings.json":return(0,l.$e5b)(t.content).settings}return null}u(t,r){const o=this.d.joinPath(t,"keybindings.json"),v=r?r.keybindingsResource:this.d.joinPath(t,a.a);return[{resource:o,comparableResource:v}]}v(t,r){switch(r){case"keybindings.json":return(0,g.$b5b)(t.content,!!this.l.getValue(d.$Rgb),this.g)}return null}w(t,r){const o=this.d.joinPath(t,"tasks.json"),v=r?r.tasksResource:this.d.joinPath(t,a.a);return[{resource:o,comparableResource:v}]}x(t,r){switch(r){case"tasks.json":return(0,w.$m5b)(t.content,this.g)}return null}async y(t,r){const o=await this.resolveContent(t);if(o){const v=this.L(o,"snippets");if(v){const $=(0,b.$j5b)(v),f=[];for(const p of Object.keys($)){const I=this.d.joinPath(t,p),T=r?this.d.joinPath(r.snippetsHome,p):this.d.joinPath(t,a.a);f.push({resource:I,comparableResource:T})}return f}}return[]}z(t,r){return(0,b.$j5b)(t)[r]||null}A(t,r){const o=this.d.joinPath(t,"extensions.json"),v=r?this.J({remote:!1,syncResource:"extensions",profile:r.id,location:void 0,collection:void 0,ref:void 0,node:void 0}):this.d.joinPath(t,a.a);return[{resource:o,comparableResource:v}]}B(t,r){switch(r){case"extensions.json":return(0,c.$94b)((0,c.$84b)(t),!0)}return null}async C(t){const{localExtensions:r}=await this.n.createInstance(c.$$4b).getLocalExtensions(t);return(0,c.$94b)(r,!0)}D(t,r){const o=this.d.joinPath(t,"globalState.json"),v=r?this.J({remote:!1,syncResource:"globalState",profile:r.id,location:void 0,collection:void 0,ref:void 0,node:void 0}):this.d.joinPath(t,a.a);return[{resource:o,comparableResource:v}]}E(t,r){switch(r){case"globalState.json":return(0,u.$aFb)(JSON.parse(t.content),!0)}return null}async F(t){const r=await this.n.createInstance(u.$cFb).getLocalGlobalState(t);return(0,u.$aFb)(r,!0)}G(t,r){const o=this.d.joinPath(t,"profiles.json"),v=this.J({remote:!1,syncResource:"profiles",profile:this.k.defaultProfile.id,location:void 0,collection:void 0,ref:void 0,node:void 0});return[{resource:o,comparableResource:v}]}H(t,r){switch(r){case"profiles.json":return(0,k.$tT)(JSON.parse(t.content),{})}return null}async I(t){return(0,m.$66b)(this.k.profiles.filter(r=>!r.isDefault&&!r.isTransient),!0)}J(t){const r=t.remote?a.b:a.c,o=[];return t.location&&(o.push(`scheme:${t.location.scheme}`),o.push(`authority:${t.location.authority}`),o.push((0,s.$Me)(t.location.path,"/"))),o.push(`syncResource:${t.syncResource}`),o.push(`profile:${t.profile}`),t.collection&&o.push(`collection:${t.collection}`),t.ref&&o.push(`ref:${t.ref}`),t.node&&o.push(t.node),this.d.joinPath(D.URI.from({scheme:d.$dhb,authority:r,path:"/",query:t.location?.query,fragment:t.location?.fragment}),...o)}K(t){if(t.scheme!==d.$dhb)return;const r=[];for(;t.path!=="/";)r.unshift(this.d.basename(t)),t=this.d.dirname(t);if(r.length<2)return;const o=t.authority===a.b;let v,$;const f=[];let p,I,T,M,z;for(;r.length;){const q=r.shift();q.startsWith("scheme:")?v=q.substring(7):q.startsWith("authority:")?$=q.substring(10):q.startsWith("syncResource:")?p=q.substring(13):q.startsWith("profile:")?I=q.substring(8):q.startsWith("collection:")?T=q.substring(11):q.startsWith("ref:")?M=q.substring(4):p?z=q:f.push(q)}return{remote:o,syncResource:p,profile:I,collection:T,ref:M,node:z,location:v&&$!==void 0?this.d.joinPath(D.URI.from({scheme:v,authority:$,query:t.query,fragment:t.fragment,path:"/"}),...f):void 0}}L(t,r){try{const o=JSON.parse(t);if((0,E.$6Eb)(o))return o}catch(o){this.g.error(o)}throw new d.$4gb((0,A.localize)(0,null),"IncompatibleRemoteContent",r)}async M(t,r,o){const v=await this.e.resolveResourceContent(t,r,o);return{ref:r,content:v}}};e.$G7b=n,e.$G7b=n=a=pe([X(0,d.$Ygb),X(1,d.$Zgb),X(2,d.$bhb),X(3,S.$Ok),X(4,L.$3h),X(5,C.$_o),X(6,j.$ek),X(7,R.$Qk),X(8,y.$pi),X(9,h.$Uh)],n)}),define(ae[256],ce([0,1,18,6,26,38,3,2,19,12,32,20,29,11,4,21,22,17,114,115,116,117,118,119,120,24]),function(ie,e,D,A,L,j,O,C,S,d,R,E,b,l,g,y,w,c,u,h,m,k,s,a,n,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$86b=void 0;const t="sync.lastSyncTime";let r=class extends C.$Rc{get status(){return this.f}get conflicts(){return this.j}get lastSyncTime(){return this.t}constructor(p,I,T,M,z,q,Y,Q,x,H,Z){super(),this.C=p,this.D=I,this.F=T,this.G=M,this.H=z,this.I=q,this.J=Y,this.L=Q,this.M=x,this.N=H,this.O=Z,this.f="uninitialized",this.g=this.B(new O.$Rd),this.onDidChangeStatus=this.g.event,this.h=this.B(new O.$Rd),this.onDidChangeLocal=this.h.event,this.j=[],this.m=this.B(new O.$Rd),this.onDidChangeConflicts=this.m.event,this.n=[],this.r=this.B(new O.$Rd),this.onSyncErrors=this.r.event,this.t=void 0,this.u=this.B(new O.$Rd),this.onDidChangeLastSyncTime=this.u.event,this.w=this.B(new O.$Rd),this.onDidResetLocal=this.w.event,this.y=this.B(new O.$Rd),this.onDidResetRemote=this.y.event,this.z=new Map,this.f=T.userDataSyncStore?"idle":"uninitialized",this.t=this.J.getNumber(t,-1,void 0),this.B((0,C.$Pc)(()=>this.bb()))}async createSyncTask(p,I){this.cb(),this.H.info("Sync started.");const T=new Date().getTime(),M=(0,R.$ig)();try{const Q=(0,i.$3gb)(M);I&&(Q["Cache-Control"]="no-cache"),p=await this.D.manifest(p,Q)}catch(Q){const x=i.$4gb.toUserDataSyncError(Q);throw $(x,M,this.F,this.I),x}const z=!1,q=this;let Y;return{manifest:p,async run(){if(z)throw new Error("Can run a task only once");Y=(0,A.$Lg)(Q=>q.P(p,!1,M,Q)),await Y.finally(()=>Y=void 0),q.H.info(`Sync done. Took ${new Date().getTime()-T}ms`),q.$()},stop(){return Y?.cancel(),q.U()}}}async createManualSyncTask(){if(this.cb(),this.L.isEnabled())throw new i.$4gb("Cannot start manual sync when sync is enabled","LocalError");this.H.info("Sync started.");const p=new Date().getTime(),I=(0,R.$ig)(),T=(0,i.$3gb)(I);let M;try{M=await this.D.manifest(null,T)}catch(Y){const Q=i.$4gb.toUserDataSyncError(Y);throw $(Q,I,this.F,this.I),Q}await this.resetLocal();const z=this,q=new L.$2d;return{id:I,async merge(){return z.P(M,!0,I,q.token)},async apply(){try{try{await z.R(M,I,q.token)}catch(Y){if(i.$4gb.toUserDataSyncError(Y).code==="MethodNotFound")z.H.info("Client is making invalid requests. Cleaning up data..."),await z.cleanUpRemoteData(),z.H.info("Applying manual sync again..."),await z.R(M,I,q.token);else throw Y}}catch(Y){throw z.H.error(Y),Y}z.H.info(`Sync done. Took ${new Date().getTime()-p}ms`),z.$()},async stop(){q.cancel(),await z.U(),await z.resetLocal()}}}async P(p,I,T,M){this.n=[];try{this.status!=="hasConflicts"&&this.Y("syncing");const z=this.getOrCreateActiveProfileSynchronizer(this.M.defaultProfile,void 0);this.n.push(...await this.S(z,p,I,T,M));const q=z.enabled.find(Y=>Y.resource==="profiles");if(q){const Y=await q.getLastSyncedProfiles()||[];if(M.isCancellationRequested)return;await this.Q(Y,p,I,T,M)}}finally{this.status!=="hasConflicts"&&this.Y("idle"),this.r.fire(this.n)}}async Q(p,I,T,M,z){for(const q of p){if(z.isCancellationRequested)return;const Y=this.M.profiles.find(x=>x.id===q.id);if(!Y){this.H.error(`Profile with id:${q.id} and name: ${q.name} does not exist locally to sync.`);continue}this.H.info("Syncing profile.",q.name);const Q=this.getOrCreateActiveProfileSynchronizer(Y,q);this.n.push(...await this.S(Q,I,T,M,z))}for(const[q,Y]of this.z.entries())this.M.profiles.some(Q=>Q.id===Y[0].profile.id)||(Y[1].dispose(),this.z.delete(q))}async R(p,I,T){const M=this.ab();for(const x of M){if(T.isCancellationRequested)return;await x.apply(I,T)}const z=M.find(x=>x.profile.isDefault);if(!z)return;const q=z.enabled.find(x=>x.resource==="profiles");if(!q)return;const Q=(await q.getRemoteSyncedProfiles(p?.latest??null)||[]).filter(x=>M.every(H=>H.profile.id!==x.id));Q.length&&await this.Q(Q,p,!1,I,T)}async S(p,I,T,M,z){return(await p.sync(I,T,M,z)).map(([Y,Q])=>({profile:p.profile,syncResource:Y,error:Q}))}async U(){this.status!=="idle"&&await Promise.allSettled(this.ab().map(p=>p.stop()))}async resolveContent(p){const I=await this.N.resolveContent(p);if(I)return I;for(const T of this.ab())for(const M of T.enabled){const z=await M.resolveContent(p);if(z)return z}return null}async replace(p){this.cb();const I=this.N.resolveUserDataSyncResource(p);if(!I)return;const T=await this.resolveContent(p.uri);T&&await this.W(I.profile,async M=>{if(I.syncResource===M.resource)return await M.replace(T),!0})}async accept(p,I,T,M){this.cb(),await this.W(p.profile,async z=>{if(p.syncResource===z.resource)return await z.accept(I,T),M&&await z.apply((0,d.$If)(M)?!1:M.force,(0,i.$3gb)((0,R.$ig)())),!0})}async hasLocalData(){return!!await this.W(this.M.defaultProfile,async I=>{if(I.resource!=="globalState"&&await I.hasLocalData())return!0})}async hasPreviouslySynced(){return!!await this.W(this.M.defaultProfile,async I=>{if(await I.hasPreviouslySynced())return!0})}async reset(){this.cb(),await this.resetRemote(),await this.resetLocal()}async resetRemote(){this.cb();try{await this.D.clear(),this.H.info("Cleared data on server")}catch(p){this.H.error(p)}this.y.fire()}async resetLocal(){this.cb(),this.t=void 0,this.J.remove(t,-1);for(const[p]of this.z.values())try{await p.resetLocal()}catch(I){this.H.error(I)}this.bb(),this.w.fire(),this.H.info("Did reset the local sync state.")}async cleanUpRemoteData(){const p=await this.N.getRemoteSyncedProfiles(),I=p.map(q=>q.collection),T=await this.D.getAllCollections(),M=T.filter(q=>!I.includes(q));M.length&&(this.H.info(`Deleting ${M.length} redundant collections on server`),await Promise.allSettled(M.map(q=>this.D.deleteCollection(q))),this.H.info("Deleted redundant collections on server"));const z=p.filter(q=>T.includes(q.collection));if(z.length!==p.length){const q=this.G.createInstance(n.$56b,this.M.defaultProfile,void 0);try{this.H.info("Resetting the last synced state of profiles"),await q.resetLocal(),this.H.info("Did reset the last synced state of profiles"),this.H.info("Updating remote profiles with invalid collections on server"),await q.updateRemoteProfiles(z,null),this.H.info("Updated remote profiles on server")}finally{q.dispose()}}}async saveRemoteActivityData(p){this.cb();const I=await this.D.getActivityData();await this.C.writeFile(p,I)}async extractActivityData(p,I){const T=(await this.C.readFile(p)).value.toString(),M=JSON.parse(T);if(M.resources)for(const z in M.resources)for(const q of M.resources[z])await this.O.writeResource(z,q.content,new Date(q.created*1e3),void 0,I);if(M.collections)for(const z in M.collections)for(const q in M.collections[z].resources)for(const Y of M.collections[z].resources?.[q]??[])await this.O.writeResource(q,Y.content,new Date(Y.created*1e3),z,I)}async W(p,I){const T=new C.$Qc;try{const M=this.z.get(p.id);if(M){const x=await this.X(M[0],I,T);return(0,d.$Jf)(x)?null:x}if(p.isDefault){const x=T.add(this.G.createInstance(o,p,void 0)),H=await this.X(x,I,T);return(0,d.$Jf)(H)?null:H}if(this.M.isEnabled())return null;const z=T.add(this.G.createInstance(n.$56b,p,void 0)),q=await this.D.manifest(null),Q=(await z.getRemoteSyncedProfiles(q?.latest??null)||[]).find(x=>x.id===p.id);if(Q){const x=T.add(this.G.createInstance(o,p,Q.collection)),H=await this.X(x,I,T);return(0,d.$Jf)(H)?null:H}return null}finally{T.dispose()}}async X(p,I,T){const M=[...p.enabled,...p.disabled.reduce((z,q)=>(q!=="workspaceState"&&z.push(T.add(p.createSynchronizer(q))),z),[])];for(const z of M){const q=await I(z);if(!(0,d.$Jf)(q))return q}}Y(p){const I=this.f;this.f!==p&&(this.f=p,this.g.fire(p),I==="hasConflicts"&&this.$())}Z(){const p=this.ab().map(I=>I.conflicts).flat();(0,D.$tb)(this.j,p,(I,T)=>I.profile.id===T.profile.id&&I.syncResource===T.syncResource&&(0,D.$tb)(I.conflicts,T.conflicts,(M,z)=>(0,S.$sg)(M.previewResource,z.previewResource)))||(this.j=p,this.m.fire(p))}$(){this.status==="idle"&&(this.t=new Date().getTime(),this.J.store(t,this.t,-1,1),this.u.fire(this.t))}getOrCreateActiveProfileSynchronizer(p,I){let T=this.z.get(p.id);if(T&&T[0].collection!==I?.collection&&(this.H.error("Profile synchronizer collection does not match with the remote sync profile collection"),T[1].dispose(),T=void 0,this.z.delete(p.id)),!T){const M=new C.$Qc,z=M.add(this.G.createInstance(o,p,I?.collection));M.add(z.onDidChangeStatus(q=>this.Y(q))),M.add(z.onDidChangeConflicts(q=>this.Z())),M.add(z.onDidChangeLocal(q=>this.h.fire(q))),this.z.set(p.id,T=[z,M])}return T[0]}ab(){const p=[];for(const[I]of this.z.values())p.push(I);return p}bb(){this.z.forEach(([,p])=>p.dispose()),this.z.clear()}cb(){if(!this.F.userDataSyncStore)throw new Error("Not enabled")}};e.$86b=r,e.$86b=r=pe([X(0,l.$ek),X(1,i.$Ygb),X(2,i.$Xgb),X(3,g.$Uh),X(4,i.$bhb),X(5,w.$il),X(6,y.$_o),X(7,i.$9gb),X(8,c.$Qk),X(9,i.$$gb),X(10,i.$Zgb)],r);let o=class extends C.$Rc{get enabled(){return this.f.sort((p,I)=>p[1]-I[1]).map(([p])=>p)}get disabled(){return i.$Ugb.filter(p=>!this.r.isResourceEnabled(p))}get status(){return this.g}get conflicts(){return this.m}constructor(p,I,T,M,z,q,Y,Q,x,H){super(),this.profile=p,this.collection=I,this.r=T,this.t=M,this.u=z,this.w=q,this.y=Y,this.z=Q,this.C=x,this.D=H,this.f=[],this.g="idle",this.h=this.B(new O.$Rd),this.onDidChangeStatus=this.h.event,this.j=this.B(new O.$Rd),this.onDidChangeLocal=this.j.event,this.m=[],this.n=this.B(new O.$Rd),this.onDidChangeConflicts=this.n.event,this.B(T.onDidChangeResourceEnablement(([Z,J])=>this.F(Z,J))),this.B((0,C.$Pc)(()=>this.f.splice(0,this.f.length).forEach(([,,Z])=>Z.dispose())));for(const Z of i.$Ugb)T.isResourceEnabled(Z)&&this.G(Z)}F(p,I){I?this.G(p):this.H(p)}G(p){if(this.f.some(([z])=>z.resource===p))return;if(p==="extensions"&&!this.u.isEnabled()){this.z.info("Skipping extensions sync because gallery is not configured");return}if(p==="profiles"&&(!this.profile.isDefault||!this.C.isEnabled())||p==="workspaceState")return;if(p!=="profiles"&&this.profile.useDefaultFlags?.[p]){this.z.debug(`Skipping syncing ${p} in ${this.profile.name} because it is already synced by default profile`);return}const I=new C.$Qc,T=I.add(this.createSynchronizer(p));I.add(T.onDidChangeStatus(()=>this.L())),I.add(T.onDidChangeConflicts(()=>this.M())),I.add(T.onDidChangeLocal(()=>this.j.fire(p)));const M=this.N(p);this.f.push([T,M,I])}H(p){const I=this.f.findIndex(([T])=>T.resource===p);if(I!==-1){const[[T,,M]]=this.f.splice(I,1);M.dispose(),this.L(),Promise.allSettled([T.stop(),T.resetLocal()]).then(null,z=>this.z.error(z))}}createSynchronizer(p){switch(p){case"settings":return this.t.createInstance(k.$f5b,this.profile,this.collection);case"keybindings":return this.t.createInstance(m.$c5b,this.profile,this.collection);case"snippets":return this.t.createInstance(s.$k5b,this.profile,this.collection);case"tasks":return this.t.createInstance(a.$n5b,this.profile,this.collection);case"globalState":return this.t.createInstance(h.$bFb,this.profile,this.collection);case"extensions":return this.t.createInstance(u.$04b,this.profile,this.collection);case"profiles":return this.t.createInstance(n.$56b,this.profile,this.collection)}}async sync(p,I,T,M){if(M.isCancellationRequested)return[];const z=this.enabled;if(!z.length)return[];try{const q=[],Y=(0,i.$3gb)(T),Q=(this.collection?p?.collections?.[this.collection]?.latest:p?.latest)??null,x=I?await this.I(Q):{};for(const H of z){if(M.isCancellationRequested)return[];if(!this.r.isResourceEnabled(H.resource))return[];try{if(I){const Z=await H.preview(Q,x,Y);if(Z)for(const J of Z.resourcePreviews)(J.localChange!==0||J.remoteChange!==0)&&J.mergeState==="preview"&&await H.merge(J.previewResource)}else await H.sync(Q,Y)}catch(Z){const J=i.$4gb.toUserDataSyncError(Z);if($(J,T,this.w,this.y),v(Z))throw J;this.z.error(Z),this.z.error(`${H.resource}: ${(0,j.$Gi)(Z)}`),q.push([H.resource,J])}}return q}finally{this.L()}}async apply(p,I){const T=(0,i.$3gb)(p);for(const M of this.enabled){if(I.isCancellationRequested)return;try{await M.apply(!1,T)}catch(z){const q=i.$4gb.toUserDataSyncError(z);if($(q,p,this.w,this.y),v(z))throw q;this.z.error(z),this.z.error(`${M.resource}: ${(0,j.$Gi)(z)}`)}}}async stop(){for(const p of this.enabled)try{p.status!=="idle"&&await p.stop()}catch(I){this.z.error(I)}}async resetLocal(){for(const p of this.enabled)try{await p.resetLocal()}catch(I){this.z.error(`${p.resource}: ${(0,j.$Gi)(I)}`),this.z.error(I)}}async I(p){if(!this.profile.isDefault)return{};const I=this.D.getValue(i.$Qgb),T=this.enabled.find(M=>M instanceof k.$f5b);if(T){const M=await T.getRemoteUserDataSyncConfiguration(p);return{...I,...M}}return I}J(p){this.g!==p&&(this.g=p,this.h.fire(p))}L(){return this.M(),this.enabled.some(p=>p.status==="hasConflicts")?this.J("hasConflicts"):this.enabled.some(p=>p.status==="syncing")?this.J("syncing"):this.J("idle")}M(){const p=this.enabled.filter(I=>I.status==="hasConflicts").filter(I=>I.conflicts.conflicts.length>0).map(I=>I.conflicts);(0,D.$tb)(this.m,p,(I,T)=>I.syncResource===T.syncResource&&(0,D.$tb)(I.conflicts,T.conflicts,(M,z)=>(0,S.$sg)(M.previewResource,z.previewResource)))||(this.m=p,this.n.fire(p))}N(p){switch(p){case"settings":return 0;case"keybindings":return 1;case"snippets":return 2;case"tasks":return 3;case"globalState":return 4;case"extensions":return 5;case"profiles":return 6;case"workspaceState":return 7}}};o=pe([X(2,i.$9gb),X(3,g.$Uh),X(4,b.$do),X(5,i.$Xgb),X(6,w.$il),X(7,i.$bhb),X(8,c.$Qk),X(9,E.$pi)],o);function v(f){if(f instanceof i.$4gb)switch(f.code){case"MethodNotFound":case"TooLarge":case"RemoteTooManyRequests":case"TooManyRequestsAndRetryAfter":case"LocalTooManyRequests":case"LocalTooManyProfiles":case"Gone":case"UpgradeRequired":case"IncompatibleRemoteContent":case"IncompatibleLocalContent":return!0}return!1}function $(f,p,I,T){T.publicLog2("sync/error",{code:f.code,serverCode:f instanceof i.$5gb?String(f.serverCode):void 0,url:f instanceof i.$5gb?f.url:void 0,resource:f.resource,executionId:p,service:I.userDataSyncStore.url.toString()})}}),define(ae[257],ce([0,1,3,2,10,17,24]),function(ie,e,D,A,L,j,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$u0b=e.$t0b=void 0;function C(b,l){return{...b,profile:(0,j.$Rk)(b.profile,l.profilesHome.scheme)}}function S(b){return{created:b.created,uri:L.URI.revive(b.uri)}}class d{constructor(l,g,y){this.c=l,this.d=g,this.f=y,this.a=new Map,this.b=new D.$Rd}listen(l,g){switch(g){case"onDidChangeStatus":return this.c.onDidChangeStatus;case"onDidChangeConflicts":return this.c.onDidChangeConflicts;case"onDidChangeLocal":return this.c.onDidChangeLocal;case"onDidChangeLastSyncTime":return this.c.onDidChangeLastSyncTime;case"onSyncErrors":return this.c.onSyncErrors;case"onDidResetLocal":return this.c.onDidResetLocal;case"onDidResetRemote":return this.c.onDidResetRemote;case"manualSync/onSynchronizeResources":return this.b.event}throw new Error(`Event not found: ${g}`)}async call(l,g,y){try{return await this.g(l,g,y)}catch(w){throw this.f.error(w),w}}async g(l,g,y){switch(g){case"_getInitialData":return Promise.resolve([this.c.status,this.c.conflicts,this.c.lastSyncTime]);case"reset":return this.c.reset();case"resetRemote":return this.c.resetRemote();case"resetLocal":return this.c.resetLocal();case"hasPreviouslySynced":return this.c.hasPreviouslySynced();case"hasLocalData":return this.c.hasLocalData();case"resolveContent":return this.c.resolveContent(L.URI.revive(y[0]));case"accept":return this.c.accept(C(y[0],this.d),L.URI.revive(y[1]),y[2],y[3]);case"replace":return this.c.replace(S(y[0]));case"cleanUpRemoteData":return this.c.cleanUpRemoteData();case"getRemoteActivityData":return this.c.saveRemoteActivityData(L.URI.revive(y[0]));case"extractActivityData":return this.c.extractActivityData(L.URI.revive(y[0]),L.URI.revive(y[1]));case"createManualSyncTask":return this.i()}if(g.startsWith("manualSync/")){const w=g.substring(11),c=y[0],u=this.h(c);switch(y=y.slice(1),w){case"merge":return u.merge();case"apply":return u.apply().then(()=>this.a.delete(this.j(u.id)));case"stop":return u.stop().finally(()=>this.a.delete(this.j(u.id)))}}throw new Error("Invalid call")}h(l){const g=this.a.get(this.j(l));if(!g)throw new Error(`Manual sync taks not found: ${l}`);return g}async i(){const l=await this.c.createManualSyncTask();return this.a.set(this.j(l.id),l),l.id}j(l){return`manualSyncTask-${l}`}}e.$t0b=d;let R=class extends A.$Rc{get status(){return this.b}get onDidChangeLocal(){return this.a.listen("onDidChangeLocal")}get conflicts(){return this.f}get lastSyncTime(){return this.h}get onDidResetLocal(){return this.a.listen("onDidResetLocal")}get onDidResetRemote(){return this.a.listen("onDidResetRemote")}constructor(l,g){super(),this.n=g,this.b="uninitialized",this.c=this.B(new D.$Rd),this.onDidChangeStatus=this.c.event,this.f=[],this.g=this.B(new D.$Rd),this.onDidChangeConflicts=this.g.event,this.h=void 0,this.j=this.B(new D.$Rd),this.onDidChangeLastSyncTime=this.j.event,this.m=this.B(new D.$Rd),this.onSyncErrors=this.m.event,this.a={call(y,w,c){return l.call(y,w,c).then(null,u=>{throw O.$4gb.toUserDataSyncError(u)})},listen(y,w){return l.listen(y,w)}},this.a.call("_getInitialData").then(([y,w,c])=>{this.s(y),this.t(w),c&&this.u(c),this.B(this.a.listen("onDidChangeStatus")(u=>this.s(u))),this.B(this.a.listen("onDidChangeLastSyncTime")(u=>this.u(u)))}),this.B(this.a.listen("onDidChangeConflicts")(y=>this.t(y))),this.B(this.a.listen("onSyncErrors")(y=>this.m.fire(y.map(w=>({...w,error:O.$4gb.toUserDataSyncError(w.error)})))))}createSyncTask(){throw new Error("not supported")}async createManualSyncTask(){const l=await this.a.call("createManualSyncTask"),g=this;return new E(l,{async call(w,c,u){return g.a.call(`manualSync/${w}`,[l,...Array.isArray(c)?c:[c]],u)},listen(){throw new Error("not supported")}})}reset(){return this.a.call("reset")}resetRemote(){return this.a.call("resetRemote")}resetLocal(){return this.a.call("resetLocal")}hasPreviouslySynced(){return this.a.call("hasPreviouslySynced")}hasLocalData(){return this.a.call("hasLocalData")}accept(l,g,y,w){return this.a.call("accept",[l,g,y,w])}resolveContent(l){return this.a.call("resolveContent",[l])}cleanUpRemoteData(){return this.a.call("cleanUpRemoteData")}replace(l){return this.a.call("replace",[l])}saveRemoteActivityData(l){return this.a.call("getRemoteActivityData",[l])}extractActivityData(l,g){return this.a.call("extractActivityData",[l,g])}async s(l){this.b=l,this.c.fire(l)}async t(l){this.f=l.map(g=>({syncResource:g.syncResource,profile:(0,j.$Rk)(g.profile,this.n.profilesHome.scheme),conflicts:g.conflicts.map(y=>({...y,baseResource:L.URI.revive(y.baseResource),localResource:L.URI.revive(y.localResource),remoteResource:L.URI.revive(y.remoteResource),previewResource:L.URI.revive(y.previewResource)}))})),this.g.fire(this.f)}u(l){this.h!==l&&(this.h=l,this.j.fire(l))}};e.$u0b=R,e.$u0b=R=pe([X(1,j.$Qk)],R);class E extends A.$Rc{constructor(l,g){super(),this.id=l,this.a=g}async merge(){return this.a.call("merge")}async apply(){return this.a.call("apply")}stop(){return this.a.call("stop")}dispose(){this.a.call("dispose")}}}),define(ae[258],ce([0,1,6,26,7,3,2,139,5,19,12,10,32,20,14,11,25,58,43,21,24]),function(ie,e,D,A,L,j,O,C,S,d,R,E,b,l,g,y,w,c,u,h,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4Eb=e.$3Eb=e.$2Eb=e.$1Eb=e.$ZEb=void 0;const k="configurationSync.store",s="sync.previous.store",a="sync.donot-make-requests-until",n="sync.user-session-id",i="sync.machine-session-id",t=100,r=1e3*60*5;let o=class extends O.$Rc{get userDataSyncStore(){return this.b}get c(){return this.h.get(m.$7gb,-1)}set c(T){this.h.store(m.$7gb,T,-1,S.$o?0:1)}constructor(T,M,z){super(),this.f=T,this.g=M,this.h=z,this.a=this.B(new j.$Rd),this.onDidChangeUserDataSyncStore=this.a.event,this.j();const q=this.B(new O.$Qc);this.B(j.Event.filter(z.onDidChangeValue(-1,m.$7gb,q),()=>this.c!==this.userDataSyncStore?.type,q)(()=>this.j()))}j(){this.b=this.m(this.f[k]),this.a.fire()}m(T){if(T&&(T=S.$o&&T.web?{...T,...T.web}:T,(0,R.$Cf)(T.url)&&(0,R.$Ef)(T.authenticationProviders)&&Object.keys(T.authenticationProviders).every(M=>Array.isArray(T.authenticationProviders[M].scopes)))){const M=T,z=!!M.canSwitch,q=M.url===M.insidersUrl?"insiders":"stable",Y=(z?this.c:void 0)||q,Q=Y==="insiders"?M.insidersUrl:Y==="stable"?M.stableUrl:M.url;return{url:E.URI.parse(Q),type:Y,defaultType:q,defaultUrl:E.URI.parse(M.url),stableUrl:E.URI.parse(M.stableUrl),insidersUrl:E.URI.parse(M.insidersUrl),canSwitch:z,authenticationProviders:Object.keys(M.authenticationProviders).reduce((x,H)=>(x.push({id:H,scopes:M.authenticationProviders[H].scopes}),x),[])}}}};e.$ZEb=o,e.$ZEb=o=pe([X(0,w.$vj),X(1,l.$pi),X(2,h.$_o)],o);let v=class extends o{constructor(T,M,z){super(T,M,z);const q=this.h.get(s,-1);q&&(this.n=JSON.parse(q));const Y=this.f[k];Y?this.h.store(s,JSON.stringify(Y),-1,1):this.h.remove(s,-1)}async switch(T){T!==this.c&&(this.c=T,this.j())}async getPreviousUserDataSyncStore(){return this.m(this.n)}};e.$1Eb=v,e.$1Eb=v=pe([X(0,w.$vj),X(1,l.$pi),X(2,h.$_o)],v);let $=class extends O.$Rc{get donotMakeRequestsUntil(){return this.j}constructor(T,M,z,q,Y,Q,x){super(),this.n=z,this.r=q,this.s=x,this.g=this.B(new j.$Rd),this.onTokenFailed=this.g.event,this.h=this.B(new j.$Rd),this.onTokenSucceed=this.h.event,this.j=void 0,this.m=this.B(new j.$Rd),this.onDidChangeDonotMakeRequestsUntil=this.m.event,this.w=void 0,this.t(T),this.c=(0,u.$fp)(Y,Q,x).then(H=>{const Z={"X-Client-Name":`${M.applicationName}${S.$o?"-web":""}`,"X-Client-Version":M.version};return M.commit&&(Z["X-Client-Commit"]=M.commit),Z}),this.f=new p(t,r,this.n,this.r),this.u(),this.B((0,O.$Pc)(()=>{this.w&&(this.w.cancel(),this.w=void 0)}))}setAuthToken(T,M){this.b={token:T,type:M}}t(T){this.a=T?(0,d.$zg)(T,"v1"):void 0}u(){const T=this.s.getNumber(a,-1);T&&Date.now()<T&&this.y(new Date(T))}y(T){this.j?.getTime()!==T?.getTime()&&(this.j=T,this.w&&(this.w.cancel(),this.w=void 0),this.j?(this.s.store(a,this.j.getTime(),-1,1),this.w=(0,D.$Lg)(M=>(0,D.$Yg)(this.j.getTime()-Date.now(),M).then(()=>this.y(void 0))),this.w.then(null,M=>null)):this.s.remove(a,-1),this.m.fire())}async getAllCollections(T={}){if(!this.a)throw new Error("No settings sync store url configured.");const M=(0,d.$zg)(this.a,"collection").toString();T={...T},T["Content-Type"]="application/json";const z=await this.D(M,{type:"GET",headers:T},[],A.CancellationToken.None);return(await(0,c.$5o)(z))?.map(({id:q})=>q)||[]}async createCollection(T={}){if(!this.a)throw new Error("No settings sync store url configured.");const M=(0,d.$zg)(this.a,"collection").toString();T={...T},T["Content-Type"]=C.$Vr.text;const z=await this.D(M,{type:"POST",headers:T},[],A.CancellationToken.None),q=await(0,c.$4o)(z);if(!q)throw new m.$5gb("Server did not return the collection id",M,"NoCollection",z.res.statusCode,z.res.headers[m.$1gb]);return q}async deleteCollection(T,M={}){if(!this.a)throw new Error("No settings sync store url configured.");const z=T?(0,d.$zg)(this.a,"collection",T).toString():(0,d.$zg)(this.a,"collection").toString();M={...M},await this.D(z,{type:"DELETE",headers:M},[],A.CancellationToken.None)}async getAllResourceRefs(T,M){if(!this.a)throw new Error("No settings sync store url configured.");const z=this.z(this.a,M,T),q={},Y=await this.D(z.toString(),{type:"GET",headers:q},[],A.CancellationToken.None);return(await(0,c.$5o)(Y)||[]).map(({url:x,created:H})=>({ref:(0,d.$Bg)(z,z.with({path:x})),created:H*1e3}))}async resolveResourceContent(T,M,z,q={}){if(!this.a)throw new Error("No settings sync store url configured.");const Y=(0,d.$zg)(this.z(this.a,z,T),M).toString();q={...q},q["Cache-Control"]="no-cache";const Q=await this.D(Y,{type:"GET",headers:q},[],A.CancellationToken.None);return await(0,c.$4o)(Q)}async deleteResource(T,M,z){if(!this.a)throw new Error("No settings sync store url configured.");const q=M!==null?(0,d.$zg)(this.z(this.a,z,T),M).toString():this.z(this.a,z,T).toString(),Y={};await this.D(q,{type:"DELETE",headers:Y},[],A.CancellationToken.None)}async deleteResources(){if(!this.a)throw new Error("No settings sync store url configured.");const T=(0,d.$zg)(this.a,"resource").toString(),M={"Content-Type":C.$Vr.text};await this.D(T,{type:"DELETE",headers:M},[],A.CancellationToken.None)}async readResource(T,M,z,q={}){if(!this.a)throw new Error("No settings sync store url configured.");const Y=(0,d.$zg)(this.z(this.a,z,T),"latest").toString();q={...q},q["Cache-Control"]="no-cache",M&&(q["If-None-Match"]=M.ref);const Q=await this.D(Y,{type:"GET",headers:q},[304],A.CancellationToken.None);let x=null;if(Q.res.statusCode===304&&(x=M),x===null){const H=Q.res.headers.etag;if(!H)throw new m.$5gb("Server did not return the ref",Y,"NoRef",Q.res.statusCode,Q.res.headers[m.$1gb]);const Z=await(0,c.$4o)(Q);if(!Z&&Q.res.statusCode===304)throw new m.$5gb("Empty response",Y,"EmptyResponse",Q.res.statusCode,Q.res.headers[m.$1gb]);x={ref:H,content:Z}}return x}async writeResource(T,M,z,q,Y={}){if(!this.a)throw new Error("No settings sync store url configured.");const Q=this.z(this.a,q,T).toString();Y={...Y},Y["Content-Type"]=C.$Vr.text,z&&(Y["If-Match"]=z);const x=await this.D(Q,{type:"POST",data:M,headers:Y},[],A.CancellationToken.None),H=x.res.headers.etag;if(!H)throw new m.$5gb("Server did not return the ref",Q,"NoRef",x.res.statusCode,x.res.headers[m.$1gb]);return H}async manifest(T,M={}){if(!this.a)throw new Error("No settings sync store url configured.");const z=(0,d.$zg)(this.a,"manifest").toString();M={...M},M["Content-Type"]="application/json",T&&(M["If-None-Match"]=T.ref);const q=await this.D(z,{type:"GET",headers:M},[304],A.CancellationToken.None);let Y=null;if(q.res.statusCode===304&&(Y=T),!Y){const x=q.res.headers.etag;if(!x)throw new m.$5gb("Server did not return the ref",z,"NoRef",q.res.statusCode,q.res.headers[m.$1gb]);const H=await(0,c.$4o)(q);if(!H&&q.res.statusCode===304)throw new m.$5gb("Empty response",z,"EmptyResponse",q.res.statusCode,q.res.headers[m.$1gb]);H&&(Y={...JSON.parse(H),ref:x})}const Q=this.s.get(n,-1);return Q&&Y&&Q!==Y.session&&this.C(),Y===null&&Q&&this.C(),Y&&this.s.store(n,Y.session,-1,1),Y}async clear(){if(!this.a)throw new Error("No settings sync store url configured.");await this.deleteCollection(),await this.deleteResources(),this.C()}async getActivityData(){if(!this.a)throw new Error("No settings sync store url configured.");const T=(0,d.$zg)(this.a,"download").toString(),M={},z=await this.D(T,{type:"GET",headers:M},[],A.CancellationToken.None);if(!(0,c.$1o)(z))throw new m.$5gb("Server returned "+z.res.statusCode,T,"EmptyResponse",z.res.statusCode,z.res.headers[m.$1gb]);if((0,c.$2o)(z))throw new m.$5gb("Empty response",T,"EmptyResponse",z.res.statusCode,z.res.headers[m.$1gb]);return z.stream}z(T,M,z){return M?(0,d.$zg)(T,"collection",M,"resource",z):(0,d.$zg)(T,"resource",z)}C(){this.s.remove(n,-1),this.s.remove(i,-1)}async D(T,M,z,q){if(!this.b)throw new m.$5gb("No Auth Token Available",T,"Unauthorized",void 0,void 0);if(this.j&&Date.now()<this.j.getTime())throw new m.$5gb(`${M.type} request '${T}' failed because of too many requests (429).`,T,"TooManyRequestsAndRetryAfter",void 0,void 0);this.y(void 0);const Y=await this.c;M.headers={...M.headers||{},...Y,"X-Account-Type":this.b.type,authorization:`Bearer ${this.b.token}`},this.F(M.headers),this.r.trace("Sending request to server",{url:T,type:M.type,headers:{...M.headers,authorization:void 0}});let Q;try{Q=await this.f.request(T,M,q)}catch(W){if(!(W instanceof m.$5gb)){let ee="RequestFailed";const ne=(0,L.$9)(W).toLowerCase();ne.includes("xhr timeout")?ee="RequestTimeout":ne.includes("protocol")&&ne.includes("not supported")?ee="RequestProtocolNotSupported":ne.includes("request path contains unescaped characters")?ee="RequestPathNotEscaped":ne.includes("headers must be an object")?ee="RequestHeadersNotObject":(0,L.$3)(W)&&(ee="RequestCanceled"),W=new m.$5gb(`Connection refused for the request '${T}'.`,T,ee,void 0,void 0)}throw this.r.info("Request failed",T),W}const x=Q.res.headers[m.$1gb],H={url:T,status:Q.res.statusCode,"execution-id":M.headers[m.$2gb],"operation-id":x},Z=(0,c.$1o)(Q)||Q.res.statusCode&&z.includes(Q.res.statusCode);let J="";if(Z?this.r.trace("Request succeeded",H):(J=await(0,c.$3o)(Q)||"",this.r.info("Request failed",H,J)),Q.res.statusCode===401||Q.res.statusCode===403){if(this.b=void 0,Q.res.statusCode===401)throw this.g.fire("Unauthorized"),new m.$5gb(`${M.type} request '${T}' failed because of Unauthorized (401).`,T,"Unauthorized",Q.res.statusCode,x);if(Q.res.statusCode===403)throw this.g.fire("Forbidden"),new m.$5gb(`${M.type} request '${T}' failed because the access is forbidden (403).`,T,"Forbidden",Q.res.statusCode,x)}if(this.h.fire(),Q.res.statusCode===404)throw new m.$5gb(`${M.type} request '${T}' failed because the requested resource is not found (404).`,T,"NotFound",Q.res.statusCode,x);if(Q.res.statusCode===405)throw new m.$5gb(`${M.type} request '${T}' failed because the requested endpoint is not found (405). ${J}`,T,"MethodNotFound",Q.res.statusCode,x);if(Q.res.statusCode===409)throw new m.$5gb(`${M.type} request '${T}' failed because of Conflict (409). There is new data for this resource. Make the request again with latest data.`,T,"Conflict",Q.res.statusCode,x);if(Q.res.statusCode===410)throw new m.$5gb(`${M.type} request '${T}' failed because the requested resource is not longer available (410).`,T,"Gone",Q.res.statusCode,x);if(Q.res.statusCode===412)throw new m.$5gb(`${M.type} request '${T}' failed because of Precondition Failed (412). There is new data for this resource. Make the request again with latest data.`,T,"PreconditionFailed",Q.res.statusCode,x);if(Q.res.statusCode===413)throw new m.$5gb(`${M.type} request '${T}' failed because of too large payload (413).`,T,"TooLarge",Q.res.statusCode,x);if(Q.res.statusCode===426)throw new m.$5gb(`${M.type} request '${T}' failed with status Upgrade Required (426). Please upgrade the client and try again.`,T,"UpgradeRequired",Q.res.statusCode,x);if(Q.res.statusCode===429){const W=Q.res.headers["retry-after"];throw W?(this.y(new Date(Date.now()+parseInt(W)*1e3)),new m.$5gb(`${M.type} request '${T}' failed because of too many requests (429).`,T,"TooManyRequestsAndRetryAfter",Q.res.statusCode,x)):new m.$5gb(`${M.type} request '${T}' failed because of too many requests (429).`,T,"RemoteTooManyRequests",Q.res.statusCode,x)}if(!Z)throw new m.$5gb("Server returned "+Q.res.statusCode,T,"Unknown",Q.res.statusCode,x);return Q}F(T){let M=this.s.get(i,-1);M===void 0&&(M=(0,b.$ig)(),this.s.store(i,M,-1,1)),T["X-Machine-Session-Id"]=M;const z=this.s.get(n,-1);z!==void 0&&(T["X-User-Session-Id"]=z)}};e.$2Eb=$,e.$2Eb=$=pe([X(1,w.$vj),X(2,c.$Yo),X(3,m.$bhb),X(4,g.$3h),X(5,y.$ek),X(6,h.$_o)],$);let f=class extends ${constructor(T,M,z,q,Y,Q,x){super(T.userDataSyncStore?.url,M,z,q,Y,Q,x),this.B(T.onDidChangeUserDataSyncStore(()=>this.t(T.userDataSyncStore?.url)))}};e.$3Eb=f,e.$3Eb=f=pe([X(0,m.$Xgb),X(1,w.$vj),X(2,c.$Yo),X(3,m.$bhb),X(4,g.$3h),X(5,y.$ek),X(6,h.$_o)],f);class p{constructor(T,M,z,q){this.c=T,this.d=M,this.f=z,this.g=q,this.a=[],this.b=void 0}request(T,M,z){if(this.h()&&this.i(),M.url=T,this.a.length>=this.c)throw this.g.info("Too many requests",...this.a),new m.$5gb(`Too many requests. Only ${this.c} requests allowed in ${this.d/(1e3*60)} minutes.`,T,"LocalTooManyRequests",void 0,void 0);return this.b=this.b||new Date,this.a.push(T),this.f.request(M,z)}h(){return this.b!==void 0&&new Date().getTime()-this.b.getTime()>this.d}i(){this.a=[],this.b=void 0}}e.$4Eb=p}),define(ae[259],ce([0,1,3,56,25,21,22,254,24,79,82]),function(ie,e,D,A,L,j,O,C,S,d,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$O0b=void 0;let E=class extends C.$96b{constructor(l,g,y,w,c,u,h,m,k,s,a){super(l,g,y,w,c,h,m,k,s,a),this.B(D.Event.debounce(D.Event.any(D.Event.map(u.onDidFocusMainWindow,()=>"windowFocus"),D.Event.map(u.onDidOpenMainWindow,()=>"windowOpen")),(n,i)=>n?[...n,i]:[i],1e3)(n=>this.triggerSync(n,!0,!1)))}};e.$O0b=E,e.$O0b=E=pe([X(0,L.$vj),X(1,S.$Xgb),X(2,S.$Ygb),X(3,S.$9gb),X(4,S.$0gb),X(5,A.$F8b),X(6,S.$bhb),X(7,d.$EDb),X(8,O.$il),X(9,R.$Lgb),X(10,j.$_o)],E)}),define(ae[260],ce([0,1,71,23,5,19]),function(ie,e,D,A,L,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$a8b=e.$_7b=e.$$7b=e.$07b=void 0,e.$07b=128/4;function O(d){function R(){let E=d.scheme===A.Schemas.file?(0,j.$ng)(d):d.toString();return L.$k||(E=E.toLowerCase()),(0,D.createHash)("md5").update(E).digest("hex")}return{id:R(),configPath:d}}e.$$7b=O;function C(d,R){function E(){if(d.scheme!==A.Schemas.file)return(0,D.createHash)("md5").update(d.toString()).digest("hex");if(!R)return;let l;return L.$k?l=R.ino:L.$j?l=R.birthtime.getTime():L.$i&&(typeof R.birthtimeMs=="number"?l=Math.floor(R.birthtimeMs):l=R.birthtime.getTime()),(0,D.createHash)("md5").update(d.fsPath).update(l?String(l):"").digest("hex")}const b=E();if(typeof b=="string")return{id:b,uri:d}}e.$_7b=C;function S(){return{id:(Date.now()+Math.round(Math.random()*1e3)).toString()}}e.$a8b=S}),define(ae[261],ce([0,1,6,7,2,16,31,14,8,76,112,260,56,55,23]),function(ie,e,D,A,L,j,O,C,S,d,R,E,b,l,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$i0b=void 0;let y=class extends L.$Rc{constructor(c,u,h,m){super(),this.a=c,this.b=u,this.c=h,this.f=m,this.B(new D.$0g(()=>{this.g()},30*1e3)).schedule()}async g(){this.b.trace("[storage cleanup]: Starting to clean up workspace storage folders for unused empty workspaces.");try{const c=this.a.workspaceStorageHome.with({scheme:g.Schemas.file}).fsPath,u=await O.Promises.readdir(c),h=new d.$dEb(this.f.getChannel("storage"));await Promise.all(u.map(async m=>{const k=(0,j.$ic)(c,m);m.length===E.$07b||m===R.$8h.id||(await this.c.getWindows({includeAuxiliaryWindows:!1})).some(n=>n.workspace?.id===m)||await h.isUsed(k)||(this.b.trace(`[storage cleanup]: Deleting workspace storage folder ${m} as it seems to be an unused empty workspace.`),await O.Promises.rm(k))}))}catch(c){(0,A.$Z)(c)}}};e.$i0b=y,e.$i0b=y=pe([X(0,C.$4h),X(1,S.$dj),X(2,b.$F8b),X(3,l.$T9b)],y)}),define(ae[83],ce([0,1,53,6,16,12,31,147,272,273]),function(ie,e,D,A,L,j,O,C,S,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$up=e.$tp=e.zip=e.$rp=e.$qp=void 0,e.$qp="end of central directory record signature not found";const R=new RegExp(e.$qp);class E extends Error{constructor(a,n){let i=n.message;switch(a){case"CorruptZip":i=`Corrupt ZIP: ${i}`;break}super(i),this.type=a,this.cause=n}}e.$rp=E;function b(s){const a=s.externalFileAttributes>>16||33188;return[448,56,7].map(n=>a&n).reduce((n,i)=>n+i,a&61440)}function l(s){if(s instanceof E)return s;let a;return R.test(s.message)&&(a="CorruptZip"),new E(a,s)}function g(s,a,n,i,t,r){const o=L.$lc(a),v=L.$ic(i,o);if(!v.startsWith(i))return Promise.reject(new Error(C.localize(0,null,a)));const $=L.$ic(i,a);let f;return r.onCancellationRequested(()=>{f?.destroy()}),Promise.resolve(O.Promises.mkdir(v,{recursive:!0})).then(()=>new Promise((p,I)=>{if(!r.isCancellationRequested)try{f=(0,D.createWriteStream)($,{mode:n}),f.once("close",()=>p()),f.once("error",I),s.once("error",I),s.pipe(f)}catch(T){I(T)}}))}function y(s,a,n,i){let t=(0,A.$Lg)(()=>Promise.resolve()),r=0;const o=i.onCancellationRequested(()=>{t.cancel(),s.close()});return new Promise((v,$)=>{const f=new A.$Sg,p=I=>{I.isCancellationRequested||(r++,s.readEntry())};s.once("error",$),s.once("close",()=>t.then(()=>{i.isCancellationRequested||s.entryCount===r?v():$(new E("Incomplete",new Error(C.localize(1,null,r,s.entryCount))))},$)),s.readEntry(),s.on("entry",I=>{if(i.isCancellationRequested)return;if(!n.sourcePathRegex.test(I.fileName)){p(i);return}const T=I.fileName.replace(n.sourcePathRegex,"");if(/\/$/.test(T)){const q=L.$ic(a,T);t=(0,A.$Lg)(Y=>O.Promises.mkdir(q,{recursive:!0}).then(()=>p(Y)).then(void 0,$));return}const M=c(s,I),z=b(I);t=(0,A.$Lg)(q=>f.queue(()=>M.then(Y=>g(Y,T,z,a,n,q).then(()=>p(q)))).then(null,$))})}).finally(()=>o.dispose())}function w(s,a=!1){return new Promise((n,i)=>{(0,S.open)(s,a?{lazyEntries:!0}:void 0,(t,r)=>{t?i(l(t)):n((0,j.$Nf)(r))})})}function c(s,a){return new Promise((n,i)=>{s.openReadStream(a,(t,r)=>{t?i(l(t)):n((0,j.$Nf)(r))})})}function u(s,a){return new Promise((n,i)=>{const t=new d.ZipFile;a.forEach(o=>{o.contents?t.addBuffer(typeof o.contents=="string"?Buffer.from(o.contents,"utf8"):o.contents,o.path):o.localPath&&t.addFile(o.localPath,o.path)}),t.end();const r=(0,D.createWriteStream)(s);t.outputStream.pipe(r),t.outputStream.once("error",i),r.once("error",i),r.once("finish",()=>n(s))})}e.zip=u;function h(s,a,n={},i){const t=new RegExp(n.sourcePath?`^${n.sourcePath}`:"");let r=w(s,!0);return n.overwrite&&(r=r.then(o=>O.Promises.rm(a).then(()=>o))),r.then(o=>y(o,a,{sourcePathRegex:t},i))}e.$tp=h;function m(s,a){return w(s).then(n=>new Promise((i,t)=>{n.on("entry",r=>{r.fileName===a&&c(n,r).then(o=>i(o),o=>t(o))}),n.once("close",()=>t(new Error(C.localize(2,null,a))))}))}function k(s,a){return m(s,a).then(n=>new Promise((i,t)=>{const r=[];n.once("error",t),n.on("data",o=>r.push(o)),n.on("end",()=>i(Buffer.concat(r)))}))}e.$up=k}),define(ae[262],ce([0,1,6,7,2,23,19,54,12,32,31,83,20,14,29,33,97,11,8]),function(ie,e,D,A,L,j,O,C,S,d,R,E,b,l,g,y,w,c,u){"use strict";var h;Object.defineProperty(e,"__esModule",{value:!0}),e.$Jp=void 0;let m=class extends L.$Rc{static{h=this}static{this.c=".sigzip"}constructor(s,a,n,i,t,r){super(),this.h=a,this.j=n,this.m=i,this.n=t,this.r=r,this.extensionsDownloadDir=s.extensionsDownloadLocation,this.f=20,this.g=this.y()}async download(s,a,n){await this.g;const i=(0,O.$zg)(this.extensionsDownloadDir,this.z(s));try{await this.w(s,i,r=>this.j.download(s,r,a))}catch(r){throw new g.$eo(r.message,g.ExtensionManagementErrorCode.Download)}let t=!1;if(n&&this.t(s)){const r=await this.u(s);try{t=await this.n.verify(i.fsPath,r.fsPath,this.r.getLevel()===u.LogLevel.Trace)}catch(o){const v=o;if(t=v.code,v.output&&this.r.trace(`Extension signature verification details for ${s.identifier.id} ${s.version}:
${v.output}`),t===g.ExtensionSignaturetErrorCode.PackageIsInvalidZip||t===g.ExtensionSignaturetErrorCode.SignatureArchiveIsInvalidZip)throw new g.$eo(E.$qp,g.ExtensionManagementErrorCode.CorruptZip)}finally{try{await this.delete(r)}catch(o){this.r.error(o)}}}return t===!0?this.r.info(`Extension signature is verified: ${s.identifier.id}`):t===!1?this.r.info(`Extension signature verification is not done: ${s.identifier.id}`):this.r.warn(`Extension signature verification failed with error '${t}': ${s.identifier.id}`),{location:i,verificationStatus:t}}t(s){if(!s.isSigned)return!1;const a=this.m.getValue("extensions.verifySignature");return(0,S.$If)(a)?a:!0}async u(s){await this.g;const a=(0,O.$zg)(this.extensionsDownloadDir,`${this.z(s)}${h.c}`);return await this.w(s,a,n=>this.j.downloadSignatureArchive(s,n)),a}async w(s,a,n){if(await this.h.exists(a))return;if(a.scheme!==j.Schemas.file){await n(a);return}const i=(0,O.$zg)(this.extensionsDownloadDir,`.${(0,d.$ig)()}`);await this.h.exists(i)||await n(i);try{await R.Promises.rename(i.fsPath,a.fsPath,2*60*1e3)}catch(t){try{await this.h.del(i)}catch{}if(t.code==="ENOTEMPTY")this.r.info("Rename failed because the file was downloaded by another source. So ignoring renaming.",s.identifier.id,a.path);else throw this.r.info(`Rename failed because of ${(0,A.$9)(t)}. Deleted the file from downloaded location`,i.path),t}}async delete(s){await this.g,await this.h.del(s)}async y(){try{if(!await this.h.exists(this.extensionsDownloadDir)){this.r.trace("Extension VSIX downloads cache dir does not exist");return}const s=await this.h.resolve(this.extensionsDownloadDir,{resolveMetadata:!0});if(s.children){const a=[],n=[],i=[];for(const o of s.children)if(o.name.endsWith(h.c))i.push(o.resource);else{const v=y.$Go.parse(o.name);v&&n.push([v,o])}const t=(0,y.$Lo)(n,([o])=>o),r=[];for(const o of t)o.sort((v,$)=>C.rcompare(v[0].version,$[0].version)),a.push(...o.slice(1).map(v=>v[1].resource)),r.push(o[0][1]);r.sort((o,v)=>o.mtime-v.mtime),a.push(...r.slice(0,Math.max(0,r.length-this.f)).map(o=>o.resource)),a.push(...i),await D.Promises.settled(a.map(o=>(this.r.trace("Deleting from cache",o.path),this.h.del(o))))}}catch(s){this.r.error(s)}}z(s){return this.f?y.$Go.create(s).toString().toLowerCase():(0,d.$ig)()}};e.$Jp=m,e.$Jp=m=h=pe([X(0,l.$4h),X(1,c.$ek),X(2,g.$do),X(3,b.$pi),X(4,w.$kp),X(5,u.$dj)],m)}),define(ae[263],ce([0,1,83,156]),function(ie,e,D,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lp=void 0;function L(j){return(0,D.$up)(j,"extension/package.json").then(O=>{try{return JSON.parse(O.toString("utf8"))}catch{throw new Error((0,A.localize)(0,null))}})}e.$Lp=L}),define(ae[121],ce([0,1,6,15,26,38,7,3,52,2,34,23,16,19,54,12,10,32,31,83,155,96,14,242,29,33,51,80,262,243,263,212,223,69,11,4,8,25,22,28,17]),function(ie,e,D,A,L,j,O,C,S,d,R,E,b,l,g,y,w,c,u,h,m,k,s,a,n,i,t,r,o,v,$,f,p,I,T,M,z,q,Y,Q,x){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rp=e.$Qp=e.$Pp=e.$Op=void 0,e.$Op=(0,M.$Wh)(n.$fo);const H=".vsctmp";let Z=class extends a.$vp{constructor(K,U,P,F,B,N,V,G,te,oe,ue,he){super(K,U,ue,P,oe,he),this.fb=B,this.gb=N,this.hb=V,this.ib=te,this.eb=new Map,this.rb=new R.$Ac;const ge=this.B(G.createInstance(v.$Kp));this.bb=this.B(G.createInstance(J,we=>ge.postUninstall(we))),this.cb=this.B(new f.$Mp(he,te,ue,this,this.F)),this.db=this.B(G.createInstance(o.$Jp));const de=this.B(new p.$Np(this,this.fb,he,N,ue,te,P));this.B(de.onDidChangeExtensionsByAnotherSource(we=>this.qb(we))),this.sb()}getTargetPlatform(){return this.jb||(this.jb=(0,i.$Qo)(this.ib,this.F)),this.jb}async zip(K){this.F.trace("ExtensionManagementService#zip",K.identifier.id);const U=await this.pb(K),P=await(0,h.zip)((0,l.$zg)(this.db.extensionsDownloadDir,(0,c.$ig)()).fsPath,U);return w.URI.file(P)}async unzip(K){return this.F.trace("ExtensionManagementService#unzip",K.toString()),(await this.install(K)).identifier}async getManifest(K){const{location:U,cleanup:P}=await this.lb(K),F=b.$jc(U.fsPath);try{return await(0,$.$Lp)(F)}finally{await P()}}getInstalled(K,U=this.H.defaultProfile.extensionsResource){return this.bb.scanExtensions(K??null,U)}scanAllUserInstalledExtensions(){return this.bb.scanAllUserExtensions(!1)}scanInstalledExtensionAtLocation(K){return this.bb.scanUserExtensionAtLocation(K)}async install(K,U={}){this.F.trace("ExtensionManagementService#install",K.toString());const{location:P,cleanup:F}=await this.lb(K);try{const B=await(0,$.$Lp)(b.$jc(P.fsPath)),N=(0,i.$Ko)(B.publisher,B.name);if(B.engines&&B.engines.vscode&&!(0,I.$Xo)(B.engines.vscode,this.G.version,this.G.date))throw new Error(m.localize(0,null,N,this.G.version));const G=(await this.I([{manifest:B,extension:P,options:U}])).find(({identifier:te})=>(0,i.$Fo)(te,{id:N}));if(G?.local)return G.local;throw G?.error?G.error:(0,a.$xp)(new Error(`Unknown error while installing extension ${N}`))}finally{await F()}}async installFromLocation(K,U){this.F.trace("ExtensionManagementService#installFromLocation",K.toString());const P=await this.bb.scanUserExtensionAtLocation(K);if(!P)throw new Error(`Cannot find a valid extension from the location ${K.toString()}`);return await this.ub([[P,void 0]],U),this.F.info("Successfully installed extension",P.identifier.id,U.toString()),P}async installExtensionsFromProfile(K,U,P){this.F.trace("ExtensionManagementService#installExtensionsFromProfile",K,U.toString(),P.toString());const F=(await this.bb.scanExtensions(1,U)).filter(B=>K.some(N=>(0,i.$Fo)(N,B.identifier)));if(F.length){const B=await Promise.all(F.map(N=>this.bb.scanMetadata(N,U)));await this.ub(F.map((N,V)=>[N,B[V]]),P),this.F.info("Successfully installed extensions",F.map(N=>N.identifier.id),P.toString())}return F}async updateMetadata(K,U,P=this.H.defaultProfile.extensionsResource){return this.F.trace("ExtensionManagementService#updateMetadata",K.identifier.id),U.isPreReleaseVersion&&(U.preRelease=!0),U.isMachineScoped===!1&&(U.isMachineScoped=void 0),U.isBuiltin===!1&&(U.isBuiltin=void 0),U.pinned===!1&&(U.pinned=void 0),K=await this.bb.updateMetadata(K,U,P),this.cb.invalidate(P),this.w.fire(K),K}async reinstallFromGallery(K){if(this.F.trace("ExtensionManagementService#reinstallFromGallery",K.identifier.id),!this.z.isEnabled())throw new Error(m.localize(1,null));const U=await this.getTargetPlatform(),[P]=await this.z.getExtensions([{...K.identifier,preRelease:K.preRelease}],{targetPlatform:U,compatible:!0},L.CancellationToken.None);if(!P)throw new Error(m.localize(2,null));await this.bb.setUninstalled(K);try{await this.bb.removeUninstalledExtension(K)}catch(F){throw new Error(m.localize(3,null,(0,j.$Gi)(F)))}return this.installFromGallery(P)}ab(K,U,P,F){return this.bb.copyExtension(K,U,P,F)}copyExtensions(K,U){return this.bb.copyExtensions(K,U)}markAsUninstalled(...K){return this.bb.setUninstalled(...K)}async cleanUp(){this.F.trace("ExtensionManagementService#cleanUp");try{await this.bb.cleanUp()}catch(K){this.F.error(K)}}async download(K,U,P){const{location:F}=await this.db.download(K,U,!P);return F}async lb(K){if(K.scheme===E.Schemas.file)return{location:K,async cleanup(){}};this.F.trace("Downloading extension from",K.toString());const U=(0,l.$zg)(this.db.extensionsDownloadDir,(0,c.$ig)());return await this.hb.download(K,U),this.F.info("Downloaded extension to",U.toString()),{location:U,cleanup:async()=>{try{await this.ib.del(U)}catch(F){this.F.error(F)}}}}Y(){return this.H.defaultProfile.extensionsResource}Z(K,U,P){if(w.URI.isUri(U))return new ne(K,U,P,this.z,this.bb,this.D,this.H,this.fb,this.gb,this.F);const F=i.$Go.create(U).toString();let B=this.eb.get(F);return B||(this.eb.set(F,B=new ee(K,U,P,this.db,this.bb,this.D,this.H,this.fb,this.gb,this.F)),B.waitUntilTaskIsFinished().finally(()=>this.eb.delete(F))),B}$(K,U){return new _(K,U.profileLocation,this.gb)}async pb(K){const U=async F=>{let B=await u.Promises.readdir(F);B=B.map(G=>b.$ic(F,G));const N=await Promise.all(B.map(G=>u.Promises.stat(G)));let V=Promise.resolve([]);return N.forEach((G,te)=>{const oe=B[te];G.isFile()&&(V=V.then(ue=>[...ue,oe])),G.isDirectory()&&(V=V.then(ue=>U(oe).then(he=>[...ue,...he])))}),V};return(await U(K.location.fsPath)).map(F=>({path:`extension/${b.$kc(K.location.fsPath,F)}`,localPath:F}))}async qb({added:K,removed:U}){if(U){const P=K&&this.D.extUri.isEqual(U.profileLocation,K.profileLocation)?U.extensions.filter(F=>K.extensions.every(B=>!(0,i.$Fo)(B,F))):U.extensions;for(const F of P)this.F.info("Extensions removed from another source",F.id,U.profileLocation.toString()),this.u.fire({identifier:F,profileLocation:U.profileLocation})}if(K){const F=(await this.bb.scanExtensions(1,K.profileLocation)).filter(B=>K.extensions.some(N=>(0,i.$Fo)(N,B.identifier)));this.s.fire(F.map(B=>(this.F.info("Extensions added from another source",B.identifier.id,K.profileLocation.toString()),{identifier:B.identifier,local:B,profileLocation:K.profileLocation,operation:1})))}}async sb(){this.B(this.bb.onExtract(U=>this.rb.add(U)));const K=await this.ib.resolve(this.fb.userExtensionsLocation);for(const U of K.children??[])U.isDirectory&&this.rb.add(U.resource);this.B(this.ib.watch(this.fb.userExtensionsLocation)),this.B(this.ib.onDidFilesChange(U=>this.tb(U)))}async tb(K){if(!K.affects(this.fb.userExtensionsLocation,1))return;const U=[];for(const P of K.rawAdded){if(this.rb.has(P)||!this.D.extUri.isEqual(this.D.extUri.dirname(P),this.fb.userExtensionsLocation)||this.D.extUri.isEqual(P,this.D.extUri.joinPath(this.fb.userExtensionsLocation,".obsolete"))||this.D.extUri.basename(P).startsWith(".")||!(await this.ib.stat(P)).isDirectory)continue;const F=await this.bb.scanUserExtensionAtLocation(P);F&&F.installedTimestamp===void 0&&(this.rb.add(P),U.push(F))}U.length&&(await this.ub(U.map(P=>[P,void 0]),this.H.defaultProfile.extensionsResource),this.F.info("Added extensions to default profile from external source",U.map(P=>P.identifier.id)))}async ub(K,U){const P=K.map(F=>F[0]);await this.vb(P),await this.gb.addExtensionsToProfile(K,U),this.s.fire(P.map(F=>({local:F,identifier:F.identifier,operation:1,profileLocation:U})))}async vb(K){const U=await this.bb.getUninstalledExtensions();for(const P of K){const F=i.$Go.create(P);U[F.toString()]&&(this.F.trace("Removing the extension from uninstalled list:",F.id),await this.bb.setInstalled(F),this.F.info("Removed the extension from uninstalled list:",F.id))}}};e.$Pp=Z,e.$Pp=Z=pe([X(0,n.$do),X(1,Y.$il),X(2,z.$dj),X(3,s.$4h),X(4,r.$Ep),X(5,t.$Ap),X(6,k.$Un),X(7,M.$Uh),X(8,T.$ek),X(9,q.$vj),X(10,Q.$Ok),X(11,x.$Qk)],Z);let J=class extends d.$Rc{constructor(K,U,P,F,B,N){super(),this.j=K,this.m=U,this.n=P,this.s=F,this.t=B,this.u=N,this.h=this.B(new C.$Rd),this.onExtract=this.h.event,this.c=(0,l.$zg)(this.n.userExtensionsLocation,".obsolete"),this.g=new D.$5g}async cleanUp(){await this.H(),await this.G()}async scanExtensions(K,U){const P={includeInvalid:!0,profileLocation:U};let F=[];return K===null||K===0?F.push(...await this.n.scanAllExtensions({includeInvalid:!0},P,!1)):K===1&&F.push(...await this.n.scanUserExtensions(P)),F=K!==null?F.filter(B=>B.type===K):F,Promise.all(F.map(B=>this.F(B)))}async scanAllUserExtensions(K){const U=await this.n.scanUserExtensions({includeAllVersions:!K,includeInvalid:!0});return Promise.all(U.map(P=>this.F(P)))}async scanUserExtensionAtLocation(K){try{const U=await this.n.scanExistingExtension(K,1,{includeInvalid:!0});if(U)return await this.F(U)}catch(U){this.u.error(U)}return null}async extractUserExtension(K,U,P,F,B){const N=K.toString(),V=w.URI.file(b.$ic(this.n.userExtensionsLocation.fsPath,`.${(0,c.$ig)()}`)),G=w.URI.file(b.$ic(this.n.userExtensionsLocation.fsPath,N));let te=await this.m.exists(G);if(te&&F){try{await this.y(K.id,G,"removeExisting")}catch{throw new n.$eo(m.localize(4,null,G.fsPath,K.id),n.ExtensionManagementErrorCode.Delete)}te=!1}if(!te)try{try{this.u.trace(`Started extracting the extension from ${U} to ${G.fsPath}`),await(0,h.$tp)(U,V.fsPath,{sourcePath:"extension",overwrite:!0},B),this.u.info(`Extracted extension to ${G}:`,K.id)}catch(oe){let ue=n.ExtensionManagementErrorCode.Extract;throw oe instanceof h.$rp&&(oe.type==="CorruptZip"?ue=n.ExtensionManagementErrorCode.CorruptZip:oe.type==="Incomplete"&&(ue=n.ExtensionManagementErrorCode.IncompleteZip)),new n.$eo(oe.message,ue)}await this.n.updateMetadata(V,P);try{this.u.trace(`Started renaming the extension from ${V.fsPath} to ${G.fsPath}`),await this.C(V.fsPath,G.fsPath),this.u.info("Renamed to",G.fsPath)}catch(oe){if(oe.code==="ENOTEMPTY")this.u.info("Rename failed because extension was installed by another source. So ignoring renaming.",K.id);else throw this.u.info(`Rename failed because of ${(0,O.$9)(oe)}. Deleted from extracted location`,V),oe}this.h.fire(G)}catch(oe){try{await this.m.del(V,{recursive:!0})}catch{}throw oe}return this.D(G,1)}async scanMetadata(K,U){return U?(await this.w(K,U))?.metadata:this.n.scanMetadata(K.location)}async w(K,U){return(await this.s.scanProfileExtensions(U)).find(F=>(0,i.$Fo)(F.identifier,K.identifier))}async updateMetadata(K,U,P){return P?await this.s.updateMetadata([[K,U]],P):await this.n.updateMetadata(K.location,U),this.D(K.location,K.type,P)}getUninstalledExtensions(){return this.z()}async setUninstalled(...K){const U=K.map(P=>i.$Go.create(P));await this.z(P=>U.forEach(F=>{P[F.toString()]=!0,this.u.info("Marked extension as uninstalled",F.toString())}))}async setInstalled(K){await this.z(U=>delete U[K.toString()])}async removeExtension(K,U){if(this.t.extUri.isEqualOrParent(K.location,this.n.userExtensionsLocation))return this.y(K.identifier.id,K.location,U)}async removeUninstalledExtension(K){await this.removeExtension(K,"uninstalled"),await this.z(U=>delete U[i.$Go.create(K).toString()])}async copyExtension(K,U,P,F){const B=await this.w(K,U),N=await this.w(K,P);return F={...B?.metadata,...F},N?await this.s.updateMetadata([[K,{...N.metadata,...F}]],P):await this.s.addExtensionsToProfile([[K,F]],P),this.D(K.location,K.type,P)}async copyExtensions(K,U){const P=await this.scanExtensions(1,K),F=await Promise.all(P.filter(B=>!B.isApplicationScoped).map(async B=>[B,await this.scanMetadata(B,K)]));await this.s.addExtensionsToProfile(F,U)}async y(K,U,P){this.u.trace(`Deleting ${P} extension from disk`,K,U.fsPath);const F=this.t.extUri.joinPath(this.t.extUri.dirname(U),`${this.t.extUri.basename(U)}.${(0,S.$Ji)((0,c.$ig)()).toString(16)}${H}`);await this.C(U.fsPath,F.fsPath),await this.m.del(F,{recursive:!0}),this.u.info(`Deleted ${P} extension from disk`,K,U.fsPath)}async z(K){return this.g.queue(async()=>{let U;try{U=(await this.m.readFile(this.c,"utf8")).value.toString()}catch(F){if((0,T.$vk)(F)!==1)throw F}let P={};if(U)try{P=JSON.parse(U)}catch{}return K&&(K(P),Object.keys(P).length?await this.m.writeFile(this.c,A.$fe.fromString(JSON.stringify(P))):await this.m.del(this.c)),P})}async C(K,U){try{await u.Promises.rename(K,U,2*60*1e3)}catch(P){throw new n.$eo(P.message||m.localize(5,null,K,U),P.code||n.ExtensionManagementErrorCode.Rename)}}async D(K,U,P){if(P){const B=(await this.n.scanUserExtensions({profileLocation:P})).find(N=>this.t.extUri.isEqual(N.location,K));if(B)return this.F(B)}else{const F=await this.n.scanExistingExtension(K,U,{includeInvalid:!0});if(F)return this.F(F)}throw new Error(m.localize(6,null,K.path))}async F(K){const U=await this.m.resolve(K.location);let P,F;return U.children&&(P=U.children.find(({name:B})=>/^readme(\.txt|\.md|)$/i.test(B))?.resource,F=U.children.find(({name:B})=>/^changelog(\.txt|\.md|)$/i.test(B))?.resource),{identifier:K.identifier,type:K.type,isBuiltin:K.isBuiltin||!!K.metadata?.isBuiltin,location:K.location,manifest:K.manifest,targetPlatform:K.targetPlatform,validations:K.validations,isValid:K.isValid,readmeUrl:P,changelogUrl:F,publisherDisplayName:K.metadata?.publisherDisplayName||null,publisherId:K.metadata?.publisherId||null,isApplicationScoped:!!K.metadata?.isApplicationScoped,isMachineScoped:!!K.metadata?.isMachineScoped,isPreReleaseVersion:!!K.metadata?.isPreReleaseVersion,preRelease:!!K.metadata?.preRelease,installedTimestamp:K.metadata?.installedTimestamp,updated:!!K.metadata?.updated,pinned:!!K.metadata?.pinned}}async G(){const K=await this.getUninstalledExtensions();if(Object.keys(K).length===0){this.u.debug("No uninstalled extensions found.");return}this.u.debug("Removing uninstalled extensions:",Object.keys(K));const U=await this.n.scanUserExtensions({includeAllVersions:!0,includeUninstalled:!0,includeInvalid:!0}),P=new Set;for(const B of U)K[i.$Go.create(B).toString()]||P.add(B.identifier.id.toLowerCase());try{const B=(0,i.$Lo)(U,N=>N.identifier);await D.Promises.settled(B.map(async N=>{const V=N.sort((G,te)=>g.rcompare(G.manifest.version,te.manifest.version))[0];P.has(V.identifier.id.toLowerCase())||await this.j(await this.F(V))}))}catch(B){this.u.error(B)}const F=U.filter(B=>B.metadata&&K[i.$Go.create(B).toString()]);await Promise.allSettled(F.map(B=>this.removeUninstalledExtension(B)))}async H(){this.u.trace("ExtensionManagementService#removeTempDeleteFolders");let K;try{K=await this.m.resolve(this.n.userExtensionsLocation)}catch(U){(0,T.$vk)(U)!==1&&this.u.error(U);return}if(K?.children)try{await Promise.allSettled(K.children.map(async U=>{if(!(!U.isDirectory||!U.name.endsWith(H))){this.u.trace("Deleting the temporarily deleted folder",U.resource.toString());try{await this.m.del(U.resource,{recursive:!0}),this.u.trace("Deleted the temporarily deleted folder",U.resource.toString())}catch(P){(0,T.$vk)(P)!==1&&this.u.error(P)}}}))}catch{}}};e.$Qp=J,e.$Qp=J=pe([X(1,T.$ek),X(2,r.$Ep),X(3,t.$Ap),X(4,Q.$Ok),X(5,z.$dj)],J);class W extends a.$yp{get profileLocation(){return this.j}get verificationStatus(){return this.k}get operation(){return(0,y.$Jf)(this.options.operation)?this.l:this.options.operation}constructor(K,U,P,F,B,N,V,G,te){super(),this.identifier=K,this.source=U,this.options=P,this.m=F,this.n=B,this.o=N,this.p=V,this.q=G,this.s=te,this.j=this.options.profileLocation,this.k=!1,this.l=2}async h(K){const[U,P]=await this.x(K);return this.j=U.isBuiltin||U.isApplicationScoped?this.o.defaultProfile.extensionsResource:this.options.profileLocation,this.n.extUri.isEqual(this.o.defaultProfile.extensionsResource,this.j)&&await this.p.initializeDefaultProfileExtensions(),await this.q.addExtensionsToProfile([[U,P]],this.j),U}async u({zipPath:K,key:U,metadata:P},F,B){let N=await this.v(U);return N||(this.s.trace("Extracting extension...",U.id),N=await this.m.extractUserExtension(U,K,P,F,B),this.s.info("Extracting extension completed.",U.id)),N}async v(K){return await this.w(K)?(this.s.trace("Removing the extension from uninstalled list:",K.id),await this.m.setInstalled(K),this.s.info("Removed the extension from uninstalled list:",K.id),(await this.m.scanAllUserExtensions(!0)).find(F=>i.$Go.create(F).equals(K))):void 0}async w(K){return!!(await this.m.getUninstalledExtensions())[K.toString()]}}class ee extends W{constructor(K,U,P,F,B,N,V,G,te,oe){super(U.identifier,U,P,B,N,V,G,te,oe),this.y=U,this.z=F}async x(K){const P=(await this.m.scanExtensions(null,this.options.profileLocation)).find(V=>(0,i.$Fo)(V.identifier,this.y.identifier));P&&(this.l=3);const F={id:this.y.identifier.uuid,publisherId:this.y.publisherId,publisherDisplayName:this.y.publisherDisplayName,targetPlatform:this.y.properties.targetPlatform,isApplicationScoped:this.options.isApplicationScoped||P?.isApplicationScoped,isMachineScoped:this.options.isMachineScoped||P?.isMachineScoped,isBuiltin:this.options.isBuiltin||P?.isBuiltin,isSystem:P?.type===0?!0:void 0,updated:!!P,isPreReleaseVersion:this.y.properties.isPreReleaseVersion,installedTimestamp:Date.now(),pinned:this.options.installGivenVersion?!0:void 0,preRelease:this.y.properties.isPreReleaseVersion||((0,y.$If)(this.options.installPreReleaseVersion)?this.options.installPreReleaseVersion:P?.preRelease)};if(P?.manifest.version===this.y.version)return[await this.m.updateMetadata(P,F),F];const{location:B,verificationStatus:N}=await this.z.download(this.y,this.l,!this.options.donotVerifySignature);try{return this.k=N,this.B(B.fsPath),[await this.u({zipPath:B.fsPath,key:i.$Go.create(this.y),metadata:F},!1,K),F]}catch(V){try{await this.z.delete(B)}catch(G){this.s.warn("Error while deleting the downloaded file",B.toString(),(0,O.$9)(G))}throw V}}async B(K){try{await(0,$.$Lp)(K)}catch(U){throw new n.$eo((0,a.$wp)(U).message,n.ExtensionManagementErrorCode.Invalid)}}}e.$Rp=ee;class ne extends W{constructor(K,U,P,F,B,N,V,G,te,oe){super({id:(0,i.$Ko)(K.publisher,K.name)},U,P,B,N,V,G,te,oe),this.y=K,this.z=U,this.A=F}async h(K){const U=await super.h(K);return this.D(U,K),U}async x(K){const U=new i.$Go(this.identifier,this.y.version),F=(await this.m.scanExtensions(1,this.options.profileLocation)).find(V=>(0,i.$Fo)(this.identifier,V.identifier)),B={isApplicationScoped:this.options.isApplicationScoped||F?.isApplicationScoped,isMachineScoped:this.options.isMachineScoped||F?.isMachineScoped,isBuiltin:this.options.isBuiltin||F?.isBuiltin,installedTimestamp:Date.now(),pinned:this.options.installGivenVersion?!0:void 0};if(F)if(this.l=3,U.equals(new i.$Go(F.identifier,F.manifest.version)))try{await this.m.removeExtension(F,"existing")}catch{throw new Error(m.localize(7,null,this.y.displayName||this.y.name))}else!this.options.profileLocation&&g.gt(F.manifest.version,this.y.version)&&await this.m.setUninstalled(F);else{const V=await this.v(U);if(V)try{await this.m.removeExtension(V,"existing")}catch{throw new Error(m.localize(8,null,this.y.displayName||this.y.name))}}return[await this.u({zipPath:b.$jc(this.z.fsPath),key:U,metadata:B},!0,K),B]}async D(K,U){try{let[P]=await this.A.getExtensions([{id:K.identifier.id,version:K.manifest.version}],U);if(P||([P]=await this.A.getExtensions([{id:K.identifier.id}],U)),P){const F={id:P.identifier.uuid,publisherDisplayName:P.publisherDisplayName,publisherId:P.publisherId,isPreReleaseVersion:P.properties.isPreReleaseVersion,preRelease:P.properties.isPreReleaseVersion||this.options.installPreReleaseVersion};await this.m.updateMetadata(K,F,this.options.profileLocation)}}catch{}}}class _ extends a.$yp{constructor(K,U,P){super(),this.extension=K,this.j=U,this.k=P}async h(K){await this.k.removeExtensionFromProfile(this.extension,this.j)}}}),define(ae[264],ce([0,1,2,29,81,222,121,8,21]),function(ie,e,D,A,L,j,O,C,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$I0b=void 0;let d=class extends D.$Rc{constructor(E,b,l,g,y,w){super(),E.cleanUp(),(0,j.$qXb)(E,b,l,g,w),L.$4u.removeOutdatedExtensionVersions(E,y)}};e.$I0b=d,e.$I0b=d=pe([X(0,O.$Op),X(1,A.$do),X(2,L.$3u),X(3,A.$io),X(4,S.$_o),X(5,C.$dj)],d)}),define(ae[122],ce([0,1,71,63,36,274,15,7,3,2,16,5,32,40,67]),function(ie,e,D,A,L,j,O,C,S,d,R,E,b,l,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rh=e.$Qh=e.$Ph=e.$Oh=e.$Nh=e.$Mh=e.$Lh=e.$Kh=void 0;class y{traceSocketEvent(f,p){g.SocketDiagnostics.traceSocketEvent(this.socket,this.debugLabel,f,p)}constructor(f,p=""){this.f=!0,this.debugLabel=p,this.socket=f,this.traceSocketEvent("created",{type:"NodeSocket"}),this.a=I=>{if(this.traceSocketEvent("error",{code:I?.code,message:I?.message}),I){if(I.code==="EPIPE")return;(0,C.$Z)(I)}},this.socket.on("error",this.a),this.b=I=>{this.traceSocketEvent("close",{hadError:I}),this.f=!1},this.socket.on("close",this.b),this.d=()=>{this.traceSocketEvent("nodeEndReceived"),this.f=!1},this.socket.on("end",this.d)}dispose(){this.socket.off("error",this.a),this.socket.off("close",this.b),this.socket.off("end",this.d),this.socket.destroy()}onData(f){const p=I=>{this.traceSocketEvent("read",I),f(O.$fe.wrap(I))};return this.socket.on("data",p),{dispose:()=>this.socket.off("data",p)}}onClose(f){const p=I=>{f({type:0,hadError:I,error:void 0})};return this.socket.on("close",p),{dispose:()=>this.socket.off("close",p)}}onEnd(f){const p=()=>{f()};return this.socket.on("end",p),{dispose:()=>this.socket.off("end",p)}}write(f){if(!(this.socket.destroyed||!this.f))try{this.traceSocketEvent("write",f),this.socket.write(f.buffer,p=>{if(p){if(p.code==="EPIPE")return;(0,C.$Z)(p)}})}catch(p){if(p.code==="EPIPE")return;(0,C.$Z)(p)}}end(){this.traceSocketEvent("nodeEndSent"),this.socket.end()}drain(){return this.traceSocketEvent("nodeDrainBegin"),new Promise((f,p)=>{if(this.socket.bufferSize===0){this.traceSocketEvent("nodeDrainEnd"),f();return}const I=()=>{this.socket.off("close",I),this.socket.off("end",I),this.socket.off("error",I),this.socket.off("timeout",I),this.socket.off("drain",I),this.traceSocketEvent("nodeDrainEnd"),f()};this.socket.on("close",I),this.socket.on("end",I),this.socket.on("error",I),this.socket.on("timeout",I),this.socket.on("drain",I)})}}e.$Kh=y;var w;(function($){$[$.MinHeaderByteSize=2]="MinHeaderByteSize",$[$.MaxWebSocketMessageLength=262144]="MaxWebSocketMessageLength"})(w||(w={}));var c;(function($){$[$.PeekHeader=1]="PeekHeader",$[$.ReadHeader=2]="ReadHeader",$[$.ReadBody=3]="ReadBody",$[$.Fin=4]="Fin"})(c||(c={}));class u extends d.$Rc{get permessageDeflate(){return this.a.permessageDeflate}get recordedInflateBytes(){return this.a.recordedInflateBytes}traceSocketEvent(f,p){this.socket.traceSocketEvent(f,p)}constructor(f,p,I,T){super(),this.f=this.B(new S.$Rd),this.g=this.B(new S.$Rd),this.h=!1,this.j={state:1,readLen:2,fin:0,compressed:!1,firstFrameOfMessage:!0,mask:0,opcode:0},this.socket=f,this.traceSocketEvent("created",{type:"WebSocketNodeSocket",permessageDeflate:p,inflateBytesLength:I?.byteLength||0,recordInflateBytes:T}),this.a=this.B(new h(this,p,I,T,this.f,(M,z)=>this.m(M,z))),this.B(this.a.onError(M=>{console.error(M),(0,C.$Z)(M),this.g.fire({type:0,hadError:!0,error:M})})),this.b=new g.$Fh,this.B(this.socket.onData(M=>this.n(M))),this.B(this.socket.onClose(async M=>{this.a.isProcessingReadQueue()&&await S.Event.toPromise(this.a.onDidFinishProcessingReadQueue),this.g.fire(M)}))}dispose(){this.a.isProcessingWriteQueue()?this.B(this.a.onDidFinishProcessingWriteQueue(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(f){return this.f.event(f)}onClose(f){return this.g.event(f)}onEnd(f){return this.socket.onEnd(f)}write(f){let p=0;for(;p<f.byteLength;)this.a.writeMessage(f.slice(p,Math.min(p+262144,f.byteLength)),{compressed:!0,opcode:2}),p+=262144}m(f,{compressed:p,opcode:I}){if(this.h)return;this.traceSocketEvent("webSocketNodeSocketWrite",f);let T=2;f.byteLength<126?T+=0:f.byteLength<2**16?T+=2:T+=8;const M=O.$fe.alloc(T),z=p?64:0,q=I&15;if(M.writeUInt8(128|z|q,0),f.byteLength<126)M.writeUInt8(f.byteLength,1);else if(f.byteLength<2**16){M.writeUInt8(126,1);let Y=1;M.writeUInt8(f.byteLength>>>8&255,++Y),M.writeUInt8(f.byteLength>>>0&255,++Y)}else{M.writeUInt8(127,1);let Y=1;M.writeUInt8(0,++Y),M.writeUInt8(0,++Y),M.writeUInt8(0,++Y),M.writeUInt8(0,++Y),M.writeUInt8(f.byteLength>>>24&255,++Y),M.writeUInt8(f.byteLength>>>16&255,++Y),M.writeUInt8(f.byteLength>>>8&255,++Y),M.writeUInt8(f.byteLength>>>0&255,++Y)}this.socket.write(O.$fe.concat([M,f]))}end(){this.h=!0,this.socket.end()}n(f){if(f.byteLength!==0){for(this.b.acceptChunk(f);this.b.byteLength>=this.j.readLen;)if(this.j.state===1){const p=this.b.peek(this.j.readLen),I=p.readUInt8(0),T=(I&128)>>>7,M=(I&64)>>>6,z=I&15,q=p.readUInt8(1),Y=(q&128)>>>7,Q=q&127;this.j.state=2,this.j.readLen=2+(Y?4:0)+(Q===126?2:0)+(Q===127?8:0),this.j.fin=T,this.j.firstFrameOfMessage&&(this.j.compressed=!!M),this.j.firstFrameOfMessage=!!T,this.j.mask=0,this.j.opcode=z,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{headerSize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin,opcode:this.j.opcode})}else if(this.j.state===2){const p=this.b.read(this.j.readLen),I=p.readUInt8(1),T=(I&128)>>>7;let M=I&127,z=1;M===126?M=p.readUInt8(++z)*2**8+p.readUInt8(++z):M===127&&(M=p.readUInt8(++z)*0+p.readUInt8(++z)*0+p.readUInt8(++z)*0+p.readUInt8(++z)*0+p.readUInt8(++z)*2**24+p.readUInt8(++z)*2**16+p.readUInt8(++z)*2**8+p.readUInt8(++z));let q=0;T&&(q=p.readUInt8(++z)*2**24+p.readUInt8(++z)*2**16+p.readUInt8(++z)*2**8+p.readUInt8(++z)),this.j.state=3,this.j.readLen=M,this.j.mask=q,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{bodySize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin,mask:this.j.mask,opcode:this.j.opcode})}else if(this.j.state===3){const p=this.b.read(this.j.readLen);this.traceSocketEvent("webSocketNodeSocketReadData",p),s(p,this.j.mask),this.traceSocketEvent("webSocketNodeSocketUnmaskedData",p),this.j.state=1,this.j.readLen=2,this.j.mask=0,this.j.opcode<=2?this.a.acceptFrame(p,this.j.compressed,!!this.j.fin):this.j.opcode===9&&this.a.writeMessage(p,{compressed:!1,opcode:10})}}}async drain(){this.traceSocketEvent("webSocketNodeSocketDrainBegin"),this.a.isProcessingWriteQueue()&&await S.Event.toPromise(this.a.onDidFinishProcessingWriteQueue),await this.socket.drain(),this.traceSocketEvent("webSocketNodeSocketDrainEnd")}}e.$Lh=u;class h extends d.$Rc{get permessageDeflate(){return!!(this.b&&this.f)}get recordedInflateBytes(){return this.b?this.b.recordedInflateBytes:O.$fe.alloc(0)}constructor(f,p,I,T,M,z){super(),this.n=f,this.r=M,this.s=z,this.a=this.B(new S.$Rd),this.onError=this.a.event,this.g=[],this.h=[],this.j=this.B(new S.$Rd),this.onDidFinishProcessingReadQueue=this.j.event,this.m=this.B(new S.$Rd),this.onDidFinishProcessingWriteQueue=this.m.event,this.t=!1,this.y=!1,p?(this.b=this.B(new m(this.n,T,I,{windowBits:15})),this.f=this.B(new k(this.n,{windowBits:15})),this.B(this.b.onError(q=>this.a.fire(q))),this.B(this.f.onError(q=>this.a.fire(q)))):(this.b=null,this.f=null)}writeMessage(f,p){this.g.push({data:f,options:p}),this.u()}async u(){if(!this.t){for(this.t=!0;this.g.length>0;){const{data:f,options:p}=this.g.shift();if(this.f&&p.compressed){const I=await this.w(this.f,f);this.s(I,p)}else this.s(f,{...p,compressed:!1})}this.t=!1,this.m.fire()}}isProcessingWriteQueue(){return this.t}w(f,p){return new Promise((I,T)=>{f.write(p),f.flush(M=>I(M))})}acceptFrame(f,p,I){this.h.push({data:f,isCompressed:p,isLastFrameOfMessage:I}),this.z()}async z(){if(!this.y){for(this.y=!0;this.h.length>0;){const f=this.h.shift();if(this.b&&f.isCompressed){const p=await this.C(this.b,f.data,f.isLastFrameOfMessage);this.r.fire(p)}else this.r.fire(f.data)}this.y=!1,this.j.fire()}}isProcessingReadQueue(){return this.y}C(f,p,I){return new Promise((T,M)=>{f.write(p),I&&f.write(O.$fe.fromByteArray([0,0,255,255])),f.flush(z=>T(z))})}}class m extends d.$Rc{get recordedInflateBytes(){return this.j?O.$fe.concat(this.f):O.$fe.alloc(0)}constructor(f,p,I,T){super(),this.h=f,this.j=p,this.a=this.B(new S.$Rd),this.onError=this.a.event,this.f=[],this.g=[],this.b=(0,j.createInflateRaw)(T),this.b.on("error",M=>{this.h.traceSocketEvent("zlibInflateError",{message:M?.message,code:M?.code}),this.a.fire(M)}),this.b.on("data",M=>{this.h.traceSocketEvent("zlibInflateData",M),this.g.push(O.$fe.wrap(M))}),I&&(this.h.traceSocketEvent("zlibInflateInitialWrite",I.buffer),this.b.write(I.buffer),this.b.flush(()=>{this.h.traceSocketEvent("zlibInflateInitialFlushFired"),this.g.length=0}))}write(f){this.j&&this.f.push(f.clone()),this.h.traceSocketEvent("zlibInflateWrite",f),this.b.write(f.buffer)}flush(f){this.b.flush(()=>{this.h.traceSocketEvent("zlibInflateFlushFired");const p=O.$fe.concat(this.g);this.g.length=0,f(p)})}}class k extends d.$Rc{constructor(f,p){super(),this.g=f,this.a=this.B(new S.$Rd),this.onError=this.a.event,this.f=[],this.b=(0,j.createDeflateRaw)({windowBits:15}),this.b.on("error",I=>{this.g.traceSocketEvent("zlibDeflateError",{message:I?.message,code:I?.code}),this.a.fire(I)}),this.b.on("data",I=>{this.g.traceSocketEvent("zlibDeflateData",I),this.f.push(O.$fe.wrap(I))})}write(f){this.g.traceSocketEvent("zlibDeflateWrite",f.buffer),this.b.write(f.buffer)}flush(f){this.b.flush(2,()=>{this.g.traceSocketEvent("zlibDeflateFlushFired");let p=O.$fe.concat(this.f);this.f.length=0,p=p.slice(0,p.byteLength-4),f(p)})}}function s($,f){if(f===0)return;const p=$.byteLength>>>2;for(let Y=0;Y<p;Y++){const Q=$.readUInt32BE(Y*4);$.writeUInt32BE(Q^f,Y*4)}const I=p*4,T=$.byteLength-I,M=f>>>24&255,z=f>>>16&255,q=f>>>8&255;T>=1&&$.writeUInt8($.readUInt8(I)^M,I),T>=2&&$.writeUInt8($.readUInt8(I+1)^z,I+1),T>=3&&$.writeUInt8($.readUInt8(I+2)^q,I+2)}e.$Mh=process.env.XDG_RUNTIME_DIR;const a={[2]:107,[1]:103};function n(){const $=(0,b.$ig)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${$}-sock`;const f=process.platform!=="darwin"&&e.$Mh?e.$Mh:(0,L.tmpdir)(),p=(0,R.$ic)(f,`vscode-ipc-${$}.sock`);return t(p),p}e.$Nh=n;function i($,f,p){const I=(0,D.createHash)("md5").update($).digest("hex");if(process.platform==="win32")return`\\\\.\\pipe\\${I}-${p}-${f}-sock`;const T=p.substr(0,4),M=f.substr(0,6),z=I.substr(0,8);let q;return process.platform!=="darwin"&&e.$Mh&&!process.env.VSCODE_PORTABLE?q=(0,R.$ic)(e.$Mh,`vscode-${z}-${T}-${M}.sock`):q=(0,R.$ic)($,`${T}-${M}.sock`),t(q),q}e.$Oh=i;function t($){const f=a[E.$u];typeof f=="number"&&$.length>=f&&console.warn(`WARNING: IPC handle "${$}" is longer than ${f} chars, try a shorter --user-data-dir`)}class r extends l.$zh{static b(f){const p=S.Event.fromNodeEventEmitter(f,"connection");return S.Event.map(p,I=>({protocol:new g.$Gh(new y(I,"ipc-server-connection")),onDidClientDisconnect:S.Event.once(S.Event.fromNodeEventEmitter(I,"close"))}))}constructor(f){super(r.b(f)),this.d=f}dispose(){super.dispose(),this.d&&(this.d.close(),this.d=null)}}e.$Ph=r;function o($){return new Promise((f,p)=>{const I=(0,A.createServer)();I.on("error",p),I.listen($,()=>{I.removeListener("error",p),f(new r(I))})})}e.$Qh=o;function v($,f){return new Promise((p,I)=>{const T=(0,A.createConnection)($,()=>{T.removeListener("error",I),p(g.$Hh.fromSocket(new y(T,`ipc-client${f}`),f))});T.once("error",I)})}e.$Rh=v}),define(ae[265],ce([0,1,63,122,210]),function(ie,e,D,A,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$R0b=void 0,e.$R0b=new class{supports(j){return!0}connect({host:j,port:O},C,S,d){return new Promise((R,E)=>{const b=D.createConnection({host:j,port:O},()=>{b.removeListener("error",E),b.write((0,L.$6pb)(C,S,d));const l=g=>{g.toString().indexOf(`\r
\r
`)>=0&&(b.off("data",l),R(new A.$Kh(b,d)))};b.on("data",l)});b.setNoDelay(!0),b.once("error",E)})}}}),define(ae[266],ce([0,1,63,36,132,122,6,2,5,20,8,25,213,104,106,77,15]),function(ie,e,D,A,L,j,O,C,S,d,R,E,b,l,g,y,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$N9b=e.$M9b=e.$L9b=e.$K9b=void 0;async function c(s,a,n,i,t){let r;for(let o=3;o&&(r?.dispose(),r=await new u(s,a,n,i,t).waitForReady(),!(t&&L.$lg[t]||!L.$lg[r.tunnelLocalPort]));o--);return r}class u extends C.$Rc{constructor(a,n,i,t,r){super(),this.m=n,this.n=r,this.privacy=y.TunnelPrivacyId.Private,this.j=new Map,this.a=a,this.b=D.createServer(),this.c=new O.$Wg,this.f=()=>this.c.open(),this.b.on("listening",this.f),this.g=o=>this.r(o),this.b.on("connection",this.g),this.h=()=>{},this.b.on("error",this.h),this.tunnelRemotePort=t,this.tunnelRemoteHost=i}async dispose(){super.dispose(),this.b.removeListener("listening",this.f),this.b.removeListener("connection",this.g),this.b.removeListener("error",this.h),this.b.close(),Array.from(this.j.values()).forEach(n=>{n()})}async waitForReady(){const a=this.n??this.tunnelRemotePort,n=(0,y.$kv)(this.m)?"0.0.0.0":"127.0.0.1";let i=await(0,L.$mg)(a,2,1e3,n),t=null;return this.b.listen(i,this.m),await this.c.wait(),t=this.b.address(),t||(i=0,this.b.listen(i,this.m),await this.c.wait(),t=this.b.address()),this.tunnelLocalPort=t.port,this.localAddress=`${this.tunnelRemoteHost==="127.0.0.1"?"127.0.0.1":"localhost"}:${t.port}`,this}async r(a){a.pause();const n=(0,y.$iv)(this.tunnelRemoteHost)||(0,y.$kv)(this.tunnelRemoteHost)?"localhost":this.tunnelRemoteHost,i=await(0,b.$_k)(this.a,n,this.tunnelRemotePort),t=i.getSocket(),r=i.readEntireBuffer();i.dispose(),r.byteLength>0&&a.write(r.buffer),a.on("end",()=>{a.localAddress&&this.j.delete(a.localAddress),t.end()}),a.on("close",()=>t.end()),a.on("error",()=>{a.localAddress&&this.j.delete(a.localAddress),t instanceof j.$Kh?t.socket.destroy():t.end()}),t instanceof j.$Kh?this.t(a,t):this.s(a,t),a.localAddress&&this.j.set(a.localAddress,()=>{a.end(),t.end()})}s(a,n){n.onClose(()=>a.destroy()),n.onEnd(()=>a.end()),n.onData(i=>a.write(i.buffer)),a.on("data",i=>n.write(w.$fe.wrap(i))),a.resume()}t(a,n){const i=n.socket;i.on("end",()=>a.end()),i.on("close",()=>a.end()),i.on("error",()=>{a.destroy()}),i.pipe(a),a.pipe(i)}}e.$K9b=u;let h=class extends y.$nv{constructor(a,n,i,t,r){super(n,r),this.u=a,this.v=i,this.w=t}isPortPrivileged(a){return(0,y.$lv)(a,this.l,S.OS,A.release())}s(a,n,i,t,r,o,v,$){const f=this.r(n,i);if(f)return++f.refcount,f.value;if((0,y.$fv)(a))return this.t(a,n,i,r,o,v,$);{this.j.trace(`ForwardedPorts: (TunnelService) Creating tunnel without provider ${n}:${i} on local port ${r}.`);const p={commit:this.w.commit,quality:this.w.quality,addressProvider:a,remoteSocketFactoryService:this.u,signService:this.v,logService:this.j,ipcLogger:null},I=c(p,t,n,i,r);return this.j.trace("ForwardedPorts: (TunnelService) Tunnel created without provider."),this.p(n,i,I),I}}};e.$L9b=h,e.$L9b=h=pe([X(0,l.$6k),X(1,R.$dj),X(2,g.$9k),X(3,E.$vj),X(4,d.$pi)],h);let m=class extends h{constructor(a,n,i,t,r){super(a,n,i,t,r)}};e.$M9b=m,e.$M9b=m=pe([X(0,l.$6k),X(1,R.$dj),X(2,g.$9k),X(3,E.$vj),X(4,d.$pi)],m);let k=class extends C.$Rc{constructor(a,n,i,t,r){super(),this.b=a,this.c=n,this.f=i,this.g=t,this.h=r,this.a=new Map}async openTunnel(a,n,i,t,r,o,v,$,f){if(this.c.trace(`ForwardedPorts: (SharedTunnelService) openTunnel request for ${i}:${t} on local port ${o}.`),!this.a.has(a)){const p=new m(this.b,this.c,this.g,this.f,this.h);this.B(p),this.a.set(a,p),p.onTunnelClosed(async()=>{(await p.tunnels).length===0&&(p.dispose(),this.a.delete(a))})}return this.a.get(a).openTunnel(n,i,t,r,o,v,$,f)}};e.$N9b=k,e.$N9b=k=pe([X(0,l.$6k),X(1,R.$dj),X(2,E.$vj),X(3,g.$9k),X(4,d.$pi)],k)}),define(ae[275],ce([0,1,36,38,7,2,23,10,18,3,40,146,204,205,195,196,261,186,188,20,209,95,220,96,215,14,113,246,29,97,187,121,98,11,198,199,70,4,194,72,73,225,8,200,102,25,58,21,107,22,108,109,110,45,228,81,111,24,79,253,238,239,82,252,256,257,258,59,251,240,106,219,77,266,214,229,28,230,5,231,189,207,206,80,245,17,51,203,57,250,227,241,105,255,264,9,201,101,248,244,216,183,56,202,259,247,55,249,104,265,181,217]),function(ie,e,D,A,L,j,O,C,S,d,R,E,b,l,g,y,w,c,u,h,m,k,s,a,n,i,t,r,o,v,$,f,p,I,T,M,z,q,Y,Q,x,H,Z,J,W,ee,ne,_,se,K,U,P,F,B,N,V,G,te,oe,ue,he,ge,de,we,ve,Ie,Ne,Me,le,$e,be,Se,Pe,ze,je,Ue,Te,re,fe,me,ye,ke,Ce,Re,Oe,De,Ae,Fe,Be,qe,We,_e,ut,yt,vt,Et,kt,ft,St,Rt,Pt,Ct,It,Ot,Dt,jt,dt,Lt,gt,At,Nt,it){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.main=void 0;class Ft extends j.$Rc{constructor(Ee){super(),this.f=Ee,this.a=this.B(new E.$8T(this)),this.b=void 0,this.c=this.B(new d.$Rd),this.g()}g(){let Ee=!1;const Le=()=>{Ee||(Ee=!0,this.b?.fireOnWillShutdown(),this.dispose())};process.once("exit",Le),(0,E.$9T)(process.parentPort,it.$Z8b.exit,Le)}async init(){const Ee=await this.h();(0,te.$Sgb)(),Ee.invokeFunction(Le=>{const Ke=Le.get(Z.$dj),Ve=Le.get(K.$il),Qe=Le.get(De.$Qk);Ke.trace("sharedProcess configuration",JSON.stringify(this.f)),this.j(Le),this.m(Ke),this.n(Ve,Qe),this.B(Qe.onDidChangeProfiles(()=>this.n(Ve,Qe)))}),this.B((0,j.$Oc)(Ee.createInstance(b.$e0b,this.f.codeCachePath),Ee.createInstance(l.$f0b),Ee.createInstance(w.$i0b),Ee.createInstance(y.$h0b),Ee.createInstance(g.$g0b),Ee.createInstance(vt.$I0b),Ee.createInstance(_e.$A0b)))}async h(){const Ee=new Q.$Th,Le={_serviceBrand:void 0,...W.default};Ee.set(ee.$vj,Le);const Ke=new R.$Dh(He=>He==="main"),Ve=new dt.$U9b(this.a,Ke);Ee.set(dt.$T9b,Ve);const Qe=this.f.policiesData?new Fe.$q9b(this.f.policiesData,Ve.getChannel("policy")):new Be.$qn;Ee.set(Be.$on,Qe);const Ge=new Nt.$pm(this.f.args,Le);Ee.set(i.$4h,Ge);const xe=new J.$er(void 0,this.f.logLevel,Ge.logsHome,this.f.loggers.map(He=>({...He,resource:C.URI.revive(He.resource)})),Ve.getChannel("logger"));Ee.set(Z.$ej,xe);const st=this.B(xe.createLogger("sharedprocess",{name:(0,Et.localize)(0,null)})),ct=this.B(new Z.$lj(st.getLevel())),Je=this.B(new kt.$WN(st,[ct]));Ee.set(Z.$dj,Je),this.b=this.B(new ft.$K0b(Je)),Ee.set(ft.$J0b,this.b);const Ze=this.B(new T.$Tp(Je));Ee.set(I.$ek,Ze);const lt=this.B(new M.$gq(Je));Ze.registerProvider(O.Schemas.file,lt);const rt=new re.$Fr(Ze);Ee.set(Te.$Ok,rt);const Xe=this.B(new qe.$4N(this.f.profiles.all,C.URI.revive(this.f.profiles.home).with({scheme:Ge.userRoamingDataHome.scheme}),Ve.getChannel("userDataProfiles")));Ee.set(De.$Qk,Xe);const ht=this.B(new me.$S9b(O.Schemas.file,this.B(new ye.$FN(Ve.getChannel(ye.$EN),{pathCaseSensitive:fe.$k})),O.Schemas.vscodeUserData,Xe,rt,Je));Ze.registerProvider(O.Schemas.vscodeUserData,ht);const Ye=this.B(new m.$Qn(Xe.defaultProfile.settingsResource,Ze,Qe,Je));Ee.set(h.$pi,Ye);const et=new Lt.$Q0b(void 0,{defaultProfile:Xe.defaultProfile,currentProfile:Xe.defaultProfile},Ve,Ge);Ee.set(_.$_o,et),this.B((0,j.$Pc)(()=>et.flush())),await Promise.all([Ye.initialize(),et.initialize()]);const mt=new Pt.$3q(Ve.getChannel("request"));Ee.set(ne.$Yo,mt),Ee.set(c.$j0b,new z.$Sh(u.$k0b,void 0,!1)),Ee.set(Ce.$yF,new z.$Sh(ke.$z0b,void 0,!1));const bt=new Ot.$Z9b(-1,Ve);Ee.set(It.$F8b,bt),Ee.set(a.$Un,new z.$Sh(n.$_N,void 0,!0));const Tt=this.B(new $e.$n9b(bt)),Mt=new R.$Dh(He=>Tt.getActiveClientId().then(at=>He===at));Ee.set(p.$aXb,new Ct.$M0b(this.a.getChannel("extensionRecommendationNotification",Mt)));let ot;const tt=[],wt=(0,B.$Co)(Le,Ye);if((0,B.$xo)(Le,Ge)){const He=new P.$o6b(Je,xe,Ge,Le);if(tt.push(He),!(0,B.$yo)(Le,Ge)&&Le.aiConfig?.ariaKey){const at=new We.$KN(mt,wt,"monacoworkbench",null,Le.aiConfig.ariaKey);this.B((0,j.$Pc)(()=>at.flush())),tt.push(at)}ot=new F.$7q({appenders:tt,commonProperties:(0,se.$no)((0,D.release)(),(0,D.hostname)(),process.arch,Le.commit,Le.version,this.f.machineId,this.f.sqmId,wt),sendErrorTelemetry:!0,piiPaths:(0,B.$Do)(Ge)},Ye,Le)}else{ot=B.$ro;const He=B.$vo;tt.push(He)}this.a.registerChannel("telemetryAppender",new U.$58b(tt)),Ee.set(K.$il,ot);const zt=new N.$l0b(Ye,ot,Je,xe,Ge,Le);Ee.set(K.$jl,zt),Ee.set(Ae.$Ap,new z.$Sh(Rt.$VN,void 0,!0)),Ee.set(Re.$Ep,new z.$Sh(Oe.$r9b,void 0,!0)),Ee.set(v.$kp,new z.$Sh(v.$lp,void 0,!0)),Ee.set(f.$Op,new z.$Sh(f.$Pp,void 0,!0)),Ee.set(o.$do,new z.$Sh(r.$ip,void 0,!0)),Ee.set(o.$jo,new z.$Sh(jt.$P0b,void 0,!1)),Ee.set(x.$Yq,new z.$Sh(H.$1q,void 0,!1)),Ee.set(k.$wm,new z.$Sh(s.$Mr,void 0,!1)),Ee.set(oe.$EDb,new z.$Sh(oe.$FDb,void 0,!0)),Ee.set(te.$bhb,new z.$Sh(ge.$RFb,void 0,!0)),Ee.set(te.$ahb,new he.$o0b(this.a.getChannel("userDataSyncUtil",He=>He.ctx!=="main"))),Ee.set(o.$io,new z.$Sh(t.$CDb,void 0,!1)),Ee.set(G.$PFb,new z.$Sh(G.$QFb,void 0,!0)),Ee.set(V.$3u,new z.$Sh(V.$4u)),Ee.set(te.$Xgb,new z.$Sh(Ne.$1Eb,void 0,!0)),Ee.set(te.$Ygb,new z.$Sh(Ne.$3Eb,void 0,!0)),Ee.set(de.$Lgb,new z.$Sh(de.$Ngb,void 0,!0)),Ee.set(te.$Zgb,new z.$Sh(ue.$36b,void 0,!1)),Ee.set(te.$9gb,new z.$Sh(we.$R6b,void 0,!0)),Ee.set(te.$0gb,new z.$Sh(ve.$86b,void 0,!1)),Ee.set(Me.$eEb,new z.$Sh(le.$v0b,void 0,!0)),Ee.set(te.$$gb,new z.$Sh(yt.$G7b,void 0,!0)),Ee.set(be.$9k,new z.$Sh(Se.$P9b,void 0,!1));const pt=new gt.$7k;return Ee.set(gt.$6k,pt),pt.register(0,At.$R0b),Ee.set(Pe.$ev,new z.$Sh(ze.$N9b)),Ee.set(je.$w0b,new z.$Sh(Ue.$y0b)),Ee.set(ut.$B0b,new z.$Sh(St.$L0b)),new Y.$jq(Ee)}j(Ee){const Le=this.B(new j.$Qc),Ke=new $.$np(Ee.get(o.$fo),()=>null);this.a.registerChannel("extensions",Ke);const Ve=R.ProxyChannel.fromService(Ee.get(x.$Yq),Le);this.a.registerChannel("languagePacks",Ve);const Qe=R.ProxyChannel.fromService(Ee.get(k.$wm),Le);this.a.registerChannel("diagnostics",Qe);const Ge=new $.$pp(Ee.get(o.$jo));this.a.registerChannel("extensionTipsService",Ge);const xe=R.ProxyChannel.fromService(Ee.get(c.$j0b),Le);this.a.registerChannel("checksum",xe);const st=R.ProxyChannel.fromService(Ee.get(Ce.$yF),Le);this.a.registerChannel("v8InspectProfiling",st);const ct=new he.$p0b(Ee.get(de.$Lgb));this.a.registerChannel("userDataSyncMachines",ct);const Je=R.ProxyChannel.fromService(Ee.get(K.$jl),Le);this.a.registerChannel("customEndpointTelemetry",Je);const Ze=new he.$q0b(Ee.get(oe.$EDb));this.a.registerChannel("userDataSyncAccount",Ze);const lt=new he.$r0b(Ee.get(te.$Xgb));this.a.registerChannel("userDataSyncStoreManagement",lt);const rt=new Ie.$t0b(Ee.get(te.$0gb),Ee.get(De.$Qk),Ee.get(Z.$dj));this.a.registerChannel("userDataSync",rt);const Xe=this.B(Ee.get(q.$Uh).createInstance(Dt.$O0b)),ht=new he.$m0b(Xe);this.a.registerChannel("userDataAutoSync",ht),this.a.registerChannel("IUserDataSyncResourceProviderService",R.ProxyChannel.fromService(Ee.get(te.$$gb),Le));const Ye=R.ProxyChannel.fromService(Ee.get(je.$w0b),Le);this.a.registerChannel(je.$x0b,Ye);const et=R.ProxyChannel.fromService(Ee.get(ut.$B0b),Le);this.a.registerChannel("remoteTunnel",et)}m(Ee){process.on("uncaughtException",Le=>(0,L.$Z)(Le)),process.on("unhandledRejection",Le=>(0,L.$Z)(Le)),(0,L.setUnexpectedErrorHandler)(Le=>{const Ke=(0,A.$Gi)(Le,!0);Ke&&Ee.error(`[uncaught exception in sharedProcess]: ${Ke}`)})}n(Ee,Le){Ee.publicLog2("profilesInfo",{count:Le.profiles.length})}handledClientConnection(Ee){if(Ee.data!==it.$28b.response)return!1;const Le=(0,S.$Nb)(Ee.ports);return Le?(this.c.fire(Le),!0):!1}}async function $t(nt){const Ee=new Ft(nt);process.parentPort.postMessage(it.$Z8b.ipcReady),await Ee.init(),process.parentPort.postMessage(it.$Z8b.initDone)}e.main=$t,process.parentPort.once("message",nt=>{$t(nt.data)})})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/94959e85502687ec77e23eb0d4d4b1a827b919af/core/vs/code/node/sharedProcess/sharedProcessMain.js.map
