/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var ke=["exports","require","vs/base/common/uri","vs/base/common/lifecycle","vs/base/common/event","vs/platform/instantiation/common/instantiation","vs/workbench/api/common/extHost.protocol","vs/workbench/api/common/extHostTypes","vs/base/common/errors","vs/nls","vs/nls!vs/workbench/api/node/extensionHostProcess","vs/base/common/platform","vs/base/common/async","vs/base/common/strings","vs/platform/log/common/log","vs/workbench/api/common/extHostTypeConverters","vs/base/common/path","vs/base/common/network","vs/base/common/types","vs/base/common/arrays","vs/workbench/api/common/extHostRpcService","vs/base/common/cancellation","vs/base/common/buffer","vs/base/common/resources","vs/base/common/objects","vs/workbench/services/extensions/common/extensions","vs/platform/extensions/common/extensions","vs/workbench/api/common/extHostInitDataService","vs/base/common/map","vs/editor/common/core/range","vs/base/node/pfs","vs/platform/files/common/files","vs/base/common/uuid","vs/base/common/extpath","vs/base/common/glob","vs/workbench/api/common/extHostCommands","vs/workbench/services/search/common/search","vs/platform/registry/common/platform","vs/base/common/stopwatch","vs/base/common/severity","vs/platform/workspace/common/workspace","vs/workbench/api/common/extHostWorkspace","vs/workbench/api/common/extHostConfiguration","vs/base/common/errorMessage","vs/platform/configuration/common/configuration","vs/platform/contextkey/common/contextkey","vs/workbench/api/common/extHostTerminalService","vs/workbench/api/common/extHostExtensionService","vs/base/common/lazy","vs/base/common/process","child_process","vs/base/common/iterator","vs/base/common/hash","vs/editor/common/core/position","vs/base/common/marshalling","fs","vs/base/common/performance","vs/workbench/api/common/extHostFileSystemInfo","vs/workbench/api/common/extHostVariableResolverService","vs/base/common/decorators","vs/base/common/assert","vs/base/common/themables","net","os","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/remote/common/remoteHosts","vs/workbench/api/common/extHostUriTransformerService","vs/workbench/contrib/testing/common/testId","vs/workbench/services/extensions/common/proxyIdentifier","vs/workbench/api/common/extHostDocumentsAndEditors","vs/workbench/api/common/extHostEditorTabs","vs/workbench/api/common/extHostFileSystemConsumer","vs/workbench/api/common/extHostTunnelService","vs/base/common/collections","vs/base/common/functional","vs/base/common/linkedList","vs/base/common/normalization","vs/base/common/ternarySearchTree","vs/base/common/codicons","vs/editor/common/model","vs/base/common/htmlContent","vs/base/parts/ipc/common/ipc","vs/base/parts/ipc/common/ipc.net","vs/editor/common/languages","vs/platform/files/common/watcher","vs/platform/progress/common/progress","vs/platform/configuration/common/configurationRegistry","vs/platform/telemetry/common/telemetryUtils","vs/platform/tunnel/common/tunnel","vs/workbench/contrib/testing/common/testTypes","vs/workbench/api/common/extHostTelemetry","vs/workbench/api/common/extHostApiDeprecationService","vs/workbench/api/common/extHostStoragePaths","vs/workbench/api/common/extHostWebview","vs/workbench/services/search/common/searchExtTypes","vs/workbench/api/common/extHostTask","vs/workbench/api/common/extHostDebugService","vs/workbench/api/common/extHostSearch","vs/base/common/stream","vs/editor/common/model/textModelSearch","vs/base/common/mime","vs/base/common/processes","vs/base/common/labels","vs/base/node/extpath","vs/base/node/processes","vs/platform/instantiation/common/descriptors","vs/platform/instantiation/common/extensions","vs/platform/instantiation/common/serviceCollection","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/sign/common/sign","vs/workbench/api/common/cache","vs/workbench/contrib/notebook/common/notebookCommon","vs/workbench/contrib/testing/common/testItemCollection","vs/workbench/contrib/webview/common/webview","vs/workbench/services/extensions/common/extensionHostProtocol","vs/workbench/api/common/extHostLocalizationService","vs/workbench/api/common/extHostManagedSockets","vs/workbench/api/common/extHostSecretState","vs/workbench/api/common/extHostStorage","vs/workbench/services/search/node/ripgrepSearchUtils","vs/base/parts/ipc/node/ipc.net","vs/base/common/arraysFind","vs/base/common/idGenerator","vs/base/common/numbers","vs/base/common/filters","vs/base/common/uint","vs/editor/common/core/characterClassifier","vs/editor/common/core/wordHelper","vs/editor/common/model/pieceTreeTextBuffer/pieceTreeBase","vs/base/common/comparers","vs/base/common/fuzzyScorer","vs/base/common/uriIpc","vs/editor/common/services/semanticTokensDto","vs/editor/common/config/editorOptions","vs/platform/environment/common/environment","vs/platform/extensionManagement/common/extensionManagement","vs/platform/markers/common/markers","vs/platform/opener/common/opener","vs/platform/product/common/productService","vs/platform/extensionManagement/common/implicitActivationEvents","vs/platform/sign/node/signService","vs/workbench/common/editor","vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/workbench/api/common/extHostDocumentData","vs/workbench/api/common/extHostTestingPrivateApi","vs/workbench/services/editor/common/editorGroupsService","vs/workbench/services/environment/common/environmentService","vs/workbench/services/extensions/common/extensionDescriptionRegistry","vs/workbench/api/common/extHostNotebookEditor","vs/workbench/api/common/extHostTestItem","vs/workbench/api/common/extHostTextEditor","vs/workbench/api/common/extHostDecorations","vs/workbench/api/common/extHostLoggerService","vs/workbench/api/common/extHostWindow","vs/workbench/api/common/extHostOutput","vs/workbench/services/remote/common/remoteAgentService","vs/workbench/services/search/common/textSearchManager","vs/workbench/services/search/node/textSearchManager","vs/workbench/services/search/node/ripgrepTextSearchEngine","vs/base/common/amd","vs/base/common/json","vs/base/common/marked/marked","vs/base/common/cache","vs/base/common/symbols","vs/base/common/iconLabels","vs/base/common/dataTransfer","vs/base/node/ports","vs/editor/common/core/eolCounter","vs/editor/common/core/editOperation","vs/editor/common/core/selection","vs/editor/common/core/textModelDefaults","vs/editor/common/core/wordCharacterClassifier","vs/editor/common/languages/languageConfiguration","vs/editor/common/languages/linkComputer","vs/editor/common/model/pieceTreeTextBuffer/rbTreeBase","vs/editor/common/model/prefixSumComputer","vs/editor/common/model/mirrorTextModel","vs/editor/common/services/treeViewsDnd","vs/editor/common/tokenizationRegistry","vs/nls!vs/base/common/actions","vs/base/common/actions","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/common/platform","vs/base/common/console","vs/amdX","vs/base/parts/ipc/node/ipc.cp","vs/base/parts/storage/common/storage","vs/editor/common/core/stringBuilder","vs/editor/common/core/textChange","vs/editor/common/languageSelector","vs/editor/common/model/pieceTreeTextBuffer/pieceTreeTextBuffer","vs/editor/common/model/pieceTreeTextBuffer/pieceTreeTextBufferBuilder","vs/nls!vs/editor/common/config/editorOptions","vs/nls!vs/editor/common/languages","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/contextkey/common/contextkey","vs/nls!vs/platform/contextkey/common/scanner","vs/nls!vs/platform/dialogs/common/dialogs","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/externalTerminal/node/externalTerminalService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/markers/common/markers","vs/nls!vs/platform/theme/common/iconRegistry","vs/nls!vs/platform/userDataProfile/common/userDataProfile","vs/nls!vs/platform/workspace/common/workspace","vs/nls!vs/workbench/api/common/extHostChatAgents2","vs/nls!vs/workbench/api/common/extHostDiagnostics","vs/nls!vs/workbench/api/common/extHostExtensionService","vs/nls!vs/workbench/api/common/extHostLanguageFeatures","vs/nls!vs/workbench/api/common/extHostLogService","vs/nls!vs/workbench/api/common/extHostNotebook","vs/nls!vs/workbench/api/common/extHostProgress","vs/nls!vs/workbench/api/common/extHostStatusBar","vs/nls!vs/workbench/api/common/extHostTelemetry","vs/nls!vs/workbench/api/common/extHostTerminalService","vs/nls!vs/workbench/api/common/extHostTreeViews","vs/nls!vs/workbench/api/common/extHostTunnelService","vs/nls!vs/workbench/api/common/extHostWorkspace","vs/nls!vs/workbench/api/node/extHostDebugService","vs/nls!vs/workbench/common/configuration","vs/nls!vs/workbench/common/editor","vs/nls!vs/workbench/common/views","vs/nls!vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/nls!vs/workbench/contrib/debug/common/debug","vs/nls!vs/workbench/contrib/debug/node/debugAdapter","vs/nls!vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/nls!vs/workbench/contrib/tasks/common/tasks","vs/nls!vs/workbench/services/configurationResolver/common/variableResolver","vs/nls!vs/workbench/services/editor/common/editorResolverService","vs/nls!vs/workbench/services/extensions/common/extensionsRegistry","vs/nls!vs/workbench/services/remote/common/tunnelModel","vs/nls!vs/workbench/services/search/common/queryBuilder","vs/platform/contextkey/common/scanner","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/graph","vs/platform/dialogs/common/dialogs","vs/platform/externalTerminal/common/externalTerminal","vs/platform/externalTerminal/node/externalTerminalService","vs/platform/files/common/io","vs/platform/files/node/watcher/nodejs/nodejsWatcherLib","vs/platform/files/node/watcher/nodejs/nodejsWatcher","vs/platform/files/node/watcher/nodejs/nodejsClient","vs/platform/files/node/watcher/watcherClient","vs/platform/instantiation/common/instantiationService","vs/platform/files/common/diskFileSystemProvider","vs/platform/files/node/diskFileSystemProvider","vs/platform/log/common/logService","vs/platform/log/node/spdlogLog","vs/platform/notification/common/notification","vs/platform/product/common/product","vs/platform/configuration/common/configurationModels","vs/platform/remote/common/managedSocket","vs/platform/remote/common/remoteAgentConnection","vs/platform/remote/common/remoteSocketFactoryService","vs/platform/sign/common/abstractSignService","vs/platform/telemetry/common/commonProperties","vs/platform/telemetry/common/telemetry","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/terminal/common/environmentVariableShared","vs/platform/terminal/common/terminalDataBuffering","vs/platform/theme/common/iconRegistry","vs/platform/uriIdentity/common/uriIdentity","vs/platform/workspace/common/editSessions","vs/platform/workspace/common/virtualWorkspace","vs/platform/userDataProfile/common/userDataProfile","vs/platform/storage/common/storage","vs/workbench/api/common/extHostLogService","vs/workbench/api/common/extHostMemento","vs/workbench/api/common/extHostNotebookDocuments","vs/workbench/api/common/extHostSecrets","vs/workbench/api/common/extHostWebviewMessaging","vs/workbench/api/node/proxyResolver","http","vs/workbench/api/node/uriTransformer","vs/workbench/common/views","vs/workbench/contrib/chat/common/chatService","vs/workbench/contrib/debug/common/debug","vs/workbench/contrib/debug/common/debugUtils","vs/workbench/contrib/debug/node/debugAdapter","vs/workbench/contrib/debug/node/terminals","vs/workbench/api/common/extHostTheming","vs/workbench/contrib/notebook/common/notebookExecutionService","vs/workbench/contrib/search/common/cellSearchModel","vs/workbench/api/common/extHostCodeInsets","vs/workbench/services/configurationResolver/common/configurationResolver","vs/workbench/services/configurationResolver/common/variableResolver","vs/workbench/services/editor/common/editorService","vs/workbench/services/extensions/common/extensionHostEnv","vs/workbench/api/common/extHostExtensionActivator","vs/workbench/api/common/extHostDocumentSaveParticipant","vs/workbench/api/common/extHostNotebookDocument","vs/workbench/api/common/extHostNotebookDocumentSaveParticipant","vs/workbench/api/common/extHostNotebookEditors","vs/workbench/api/common/extHostProgress","vs/workbench/api/common/extHostTreeViews","vs/workbench/services/extensions/common/extensionsApiProposals","vs/workbench/services/extensions/common/extensionsRegistry","vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/workbench/contrib/tasks/common/tasks","vs/workbench/services/extensions/common/lazyPromise","vs/workbench/api/common/extHostAiRelatedInformation","vs/workbench/api/common/extHostAuthentication","vs/workbench/api/common/extHostBulkEdits","vs/workbench/api/common/extHostChat","vs/workbench/api/common/extHostChatAgents2","vs/workbench/api/common/extHostChatProvider","vs/workbench/api/common/extHostChatVariables","vs/workbench/api/common/extHostClipboard","vs/workbench/api/common/extHostApiCommands","vs/workbench/api/common/extHostComments","vs/workbench/api/common/extHostConsoleForwarder","vs/workbench/api/common/extHostDiagnostics","vs/workbench/api/common/extHostDialogs","vs/workbench/api/common/extHostDocumentContentProviders","vs/workbench/api/common/extHostDocuments","vs/workbench/api/common/extHostEmbeddingVector","vs/workbench/api/common/extHostFileSystem","vs/workbench/api/common/extHostFileSystemEventService","vs/workbench/api/common/extHostInlineChat","vs/workbench/api/common/extHostInteractive","vs/workbench/api/common/extHostIssueReporter","vs/workbench/api/common/extHostLabelService","vs/workbench/api/common/extHostLanguageFeatures","vs/workbench/api/common/extHostLanguages","vs/workbench/api/common/extHostMessageService","vs/workbench/api/common/extHostNotebookKernels","vs/workbench/api/common/extHostNotebookRenderers","vs/workbench/api/common/extHostProfileContentHandler","vs/workbench/api/common/extHostQuickDiff","vs/workbench/api/common/extHostQuickOpen","vs/workbench/api/common/extHostSCM","vs/workbench/api/common/extHostShare","vs/workbench/api/common/extHostSpeech","vs/workbench/api/common/extHostStatusBar","vs/workbench/api/common/extHostTesting","vs/workbench/api/common/extHostTextEditors","vs/workbench/api/common/extHostTimeline","vs/workbench/api/common/extHostUriOpener","vs/workbench/api/common/extHostUrls","vs/workbench/api/common/extHostCustomEditors","vs/workbench/api/common/extHostWebviewPanels","vs/workbench/api/common/extHostWebviewView","vs/workbench/api/node/extHostConsoleForwarder","vs/workbench/api/node/extHostDiskFileSystemProvider","vs/workbench/api/node/extHostDownloadService","vs/workbench/api/node/extHostLoggerService","vs/workbench/api/node/extHostStoragePaths","vs/workbench/api/node/extHostTerminalService","vs/workbench/services/extensions/common/rpcProtocol","vs/workbench/services/output/common/output","vs/workbench/common/configuration","vs/workbench/services/editor/common/editorResolverService","vs/workbench/services/path/common/pathService","vs/workbench/services/remote/common/tunnelModel","vs/workbench/contrib/search/common/searchNotebookHelpers","vs/workbench/api/common/extHostNotebook","vs/workbench/services/search/common/fileSearchManager","vs/workbench/services/search/common/queryBuilder","vs/workbench/services/extensions/common/workspaceContains","vs/workbench/api/common/extHostRequireInterceptor","vs/workbench/api/common/extensionHostMain","vs/workbench/api/node/extHostDebugService","vs/workbench/api/node/extHostTask","vs/workbench/api/node/extHostVariableResolverService","vs/workbench/api/common/extHost.api.impl","vs/workbench/api/common/extHost.common.services","vs/workbench/services/search/node/ripgrepFileSearch","@vscode/ripgrep","vs/workbench/services/search/node/fileSearch","string_decoder","vs/workbench/services/textfile/common/encoding","vs/workbench/services/search/node/ripgrepSearchProvider","vs/workbench/services/search/node/textSearchAdapter","vs/workbench/services/search/node/rawSearchService","vs/workbench/api/node/extHostSearch","vs/platform/tunnel/node/tunnelService","vs/workbench/api/node/extHostCLIServer","vs/workbench/api/node/extHostExtensionService","vs/workbench/api/node/extHostTunnelService","vs/workbench/api/node/extHost.node.services","util","vs/base/common/semver/semver","graceful-fs","https","tls","@vscode/proxy-agent","events","vscode-regexpp","crypto","zlib","vs/workbench/api/node/extensionHostProcess","minimist"],Se=function(me){for(var e=[],C=0,F=me.length;C<F;C++)e[C]=ke[me[C]];return e};define(ke[159],Se([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$T=e.$S=void 0,e.$S=!1;class C{static get(){const f=new Map,L=new Map,M=new Map,b=new Map;function v(y,k){y.has(k.detail)||y.set(k.detail,-k.timestamp)}function g(y,k){const w=y.get(k.detail);w&&(w>=0||y.set(k.detail,w+k.timestamp))}let A=[];typeof me=="function"&&typeof me.getStats=="function"&&(A=me.getStats().slice(0).sort((y,k)=>y.timestamp-k.timestamp));for(const y of A)switch(y.type){case 10:v(f,y);break;case 11:case 12:g(f,y);break;case 21:v(L,y);break;case 22:g(L,y);break;case 33:v(M,y);break;case 34:g(M,y);break;case 31:v(b,y);break;case 32:g(b,y);break}let I=0;M.forEach(y=>I+=y);function $(y){const k=[];return y.forEach((w,u)=>k.push([u,w])),k}return{amdLoad:$(f),amdInvoke:$(L),nodeRequire:$(M),nodeEval:$(b),nodeRequireTotal:I}}static toMarkdownTable(f,L){let M="";const b=[];return f.forEach((v,g)=>{b[g]=v.length}),L.forEach(v=>{v.forEach((g,A)=>{typeof g>"u"&&(g=v[A]="-");const I=g.toString().length;b[A]=Math.max(I,b[A])})}),f.forEach((v,g)=>{M+=`| ${v+" ".repeat(b[g]-v.toString().length)} `}),M+=`|
`,f.forEach((v,g)=>{M+=`| ${"-".repeat(b[g])} `}),M+=`|
`,L.forEach(v=>{v.forEach((g,A)=>{typeof g<"u"&&(M+=`| ${g+" ".repeat(b[A]-g.toString().length)} `)}),M+=`|
`}),M}}e.$T=C}),define(ke[121],Se([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qb=e.$pb=e.$ob=e.$nb=e.$mb=e.$lb=e.$kb=e.$jb=e.$ib=e.$hb=e.$gb=e.$fb=e.$eb=void 0;function C(w,u,o){const i=F(w,u);if(i!==-1)return w[i]}e.$eb=C;function F(w,u,o=w.length-1){for(let i=o;i>=0;i--){const n=w[i];if(u(n))return i}return-1}e.$fb=F;function f(w,u){const o=L(w,u);return o===-1?void 0:w[o]}e.$gb=f;function L(w,u,o=0,i=w.length){let n=o,r=i;for(;n<r;){const a=Math.floor((n+r)/2);u(w[a])?n=a+1:r=a}return n-1}e.$hb=L;function M(w,u){const o=b(w,u);return o===w.length?void 0:w[o]}e.$ib=M;function b(w,u,o=0,i=w.length){let n=o,r=i;for(;n<r;){const a=Math.floor((n+r)/2);u(w[a])?r=a:n=a+1}return n}e.$jb=b;function v(w,u,o=0,i=w.length){const n=b(w,u,o,i);return n===w.length?-1:n}e.$kb=v;class g{static{this.assertInvariants=!1}constructor(u){this.e=u,this.c=0}findLastMonotonous(u){if(g.assertInvariants){if(this.d){for(const i of this.e)if(this.d(i)&&!u(i))throw new Error("MonotonousArray: current predicate must be weaker than (or equal to) the previous predicate.")}this.d=u}const o=L(this.e,u,this.c);return this.c=o+1,o===-1?void 0:this.e[o]}}e.$lb=g;function A(w,u){if(w.length===0)return;let o=w[0];for(let i=1;i<w.length;i++){const n=w[i];u(n,o)>0&&(o=n)}return o}e.$mb=A;function I(w,u){if(w.length===0)return;let o=w[0];for(let i=1;i<w.length;i++){const n=w[i];u(n,o)>=0&&(o=n)}return o}e.$nb=I;function $(w,u){return A(w,(o,i)=>-u(o,i))}e.$ob=$;function y(w,u){if(w.length===0)return-1;let o=0;for(let i=1;i<w.length;i++){const n=w[i];u(n,w[o])>0&&(o=i)}return o}e.$pb=y;function k(w,u){for(const o of w){const i=u(o);if(i!==void 0)return i}}e.$qb=k}),define(ke[73],Se([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$M=e.$L=e.$K=e.$J=void 0;function C(M,b){const v=Object.create(null);for(const g of M){const A=b(g);let I=v[A];I||(I=v[A]=[]),I.push(g)}return v}e.$J=C;function F(M,b){const v=[],g=[];for(const A of M)b.has(A)||v.push(A);for(const A of b)M.has(A)||g.push(A);return{removed:v,added:g}}e.$K=F;function f(M,b){const v=[],g=[];for(const[A,I]of M)b.has(A)||v.push(I);for(const[A,I]of b)M.has(A)||g.push(I);return{removed:v,added:g}}e.$L=f;function L(M,b){const v=new Set;for(const g of b)M.has(g)&&v.add(g);return v}e.$M=L}),define(ke[59],Se([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ph=e.$oh=e.$nh=void 0;function C(M){return(b,v,g)=>{let A=null,I=null;if(typeof g.value=="function"?(A="value",I=g.value):typeof g.get=="function"&&(A="get",I=g.get),!I)throw new Error("not supported");g[A]=M(I,v)}}function F(M,b,v){let g=null,A=null;if(typeof v.value=="function"?(g="value",A=v.value,A.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof v.get=="function"&&(g="get",A=v.get),!A)throw new Error("not supported");const I=`$memoize$${b}`;v[g]=function(...$){return this.hasOwnProperty(I)||Object.defineProperty(this,I,{configurable:!1,enumerable:!1,writable:!1,value:A.apply(this,$)}),this[I]}}e.$nh=F;function f(M,b,v){return C((g,A)=>{const I=`$debounce$${A}`,$=`$debounce$result$${A}`;return function(...y){this[$]||(this[$]=v?v():void 0),clearTimeout(this[I]),b&&(this[$]=b(this[$],...y),y=[this[$]]),this[I]=setTimeout(()=>{g.apply(this,y),this[$]=v?v():void 0},M)}})}e.$oh=f;function L(M,b,v){return C((g,A)=>{const I=`$throttle$timer$${A}`,$=`$throttle$result$${A}`,y=`$throttle$lastRun$${A}`,k=`$throttle$pending$${A}`;return function(...w){if(this[$]||(this[$]=v?v():void 0),(this[y]===null||this[y]===void 0)&&(this[y]=-Number.MAX_VALUE),b&&(this[$]=b(this[$],...w)),this[k])return;const u=this[y]+M;u<=Date.now()?(this[y]=Date.now(),g.apply(this,[this[$]]),this[$]=v?v():void 0):(this[k]=!0,this[I]=setTimeout(()=>{this[k]=!1,this[y]=Date.now(),g.apply(this,[this[$]]),this[$]=v?v():void 0},u-Date.now()))}})}e.$ph=L}),define(ke[8],Se([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bb=e.$ab=e.$_=e.$$=e.$0=e.$9=e.$8=e.$7=e.$6=e.$5=e.$4=e.$3=e.$2=e.$1=e.$Z=e.$Y=e.setUnexpectedErrorHandler=e.$W=e.$V=void 0;class C{constructor(){this.b=[],this.a=function(t){setTimeout(()=>{throw t.stack?n.isErrorNoTelemetry(t)?new n(t.message+`

`+t.stack):new Error(t.message+`

`+t.stack):t},0)}}addListener(t){return this.b.push(t),()=>{this.d(t)}}c(t){this.b.forEach(s=>{s(t)})}d(t){this.b.splice(this.b.indexOf(t),1)}setUnexpectedErrorHandler(t){this.a=t}getUnexpectedErrorHandler(){return this.a}onUnexpectedError(t){this.a(t),this.c(t)}onUnexpectedExternalError(t){this.a(t)}}e.$V=C,e.$W=new C;function F(a){e.$W.setUnexpectedErrorHandler(a)}e.setUnexpectedErrorHandler=F;function f(a){if(!a||typeof a!="object")return!1;const t=a;return t.code==="EPIPE"&&t.syscall?.toUpperCase()==="WRITE"}e.$Y=f;function L(a){g(a)||e.$W.onUnexpectedError(a)}e.$Z=L;function M(a){g(a)||e.$W.onUnexpectedExternalError(a)}e.$1=M;function b(a){if(a instanceof Error){const{name:t,message:s}=a,d=a.stacktrace||a.stack;return{$isError:!0,name:t,message:s,stack:d,noTelemetry:n.isErrorNoTelemetry(a)}}return a}e.$2=b;const v="Canceled";function g(a){return a instanceof A?!0:a instanceof Error&&a.name===v&&a.message===v}e.$3=g;class A extends Error{constructor(){super(v),this.name=this.message}}e.$4=A;function I(){const a=new Error(v);return a.name=a.message,a}e.$5=I;function $(a){return a?new Error(`Illegal argument: ${a}`):new Error("Illegal argument")}e.$6=$;function y(a){return a?new Error(`Illegal state: ${a}`):new Error("Illegal state")}e.$7=y;class k extends TypeError{constructor(t){super(t?`${t} is read-only and cannot be changed`:"Cannot change read-only property")}}e.$8=k;function w(a){return a?a.message?a.message:a.stack?a.stack.split(`
`)[0]:String(a):"Error"}e.$9=w;class u extends Error{constructor(t){super("NotImplemented"),t&&(this.message=t)}}e.$0=u;class o extends Error{constructor(t){super("NotSupported"),t&&(this.message=t)}}e.$$=o;class i extends Error{constructor(){super(...arguments),this.isExpected=!0}}e.$_=i;class n extends Error{constructor(t){super(t),this.name="CodeExpectedError"}static fromError(t){if(t instanceof n)return t;const s=new n;return s.message=t.message,s.stack=t.stack,s}static isErrorNoTelemetry(t){return t.name==="CodeExpectedError"}}e.$ab=n;class r extends Error{constructor(t){super(t||"An unexpected bug occurred."),Object.setPrototypeOf(this,r.prototype)}}e.$bb=r}),define(ke[19],Se([1,0,8,121]),function(me,e,C,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_b=e.$$b=e.$0b=e.$9b=e.$8b=e.$7b=e.$6b=e.CompareResult=e.$5b=e.$4b=e.$3b=e.$2b=e.$1b=e.$Zb=e.$Yb=e.$Xb=e.$Wb=e.$Vb=e.$Ub=e.$Tb=e.$Sb=e.$Rb=e.$Qb=e.$Pb=e.$Ob=e.$Nb=e.$Mb=e.$Lb=e.$Kb=e.$Jb=e.$Ib=e.$Hb=e.$Gb=e.$Fb=e.top=e.$Db=e.$Cb=e.$Bb=e.$Ab=e.$zb=e.$yb=e.$xb=e.$wb=e.$vb=e.$ub=e.$tb=e.$sb=e.$rb=void 0;function f(H,Y=0){return H[H.length-(1+Y)]}e.$rb=f;function L(H){if(H.length===0)throw new Error("Invalid tail call");return[H.slice(0,H.length-1),H[H.length-1]]}e.$sb=L;function M(H,Y,Z=($e,ne)=>$e===ne){if(H===Y)return!0;if(!H||!Y||H.length!==Y.length)return!1;for(let $e=0,ne=H.length;$e<ne;$e++)if(!Z(H[$e],Y[$e]))return!1;return!0}e.$tb=M;function b(H,Y){const Z=H.length-1;Y<Z&&(H[Y]=H[Z]),H.pop()}e.$ub=b;function v(H,Y,Z){return g(H.length,$e=>Z(H[$e],Y))}e.$vb=v;function g(H,Y){let Z=0,$e=H-1;for(;Z<=$e;){const ne=(Z+$e)/2|0,fe=Y(ne);if(fe<0)Z=ne+1;else if(fe>0)$e=ne-1;else return ne}return-(Z+1)}e.$wb=g;function A(H,Y,Z){if(H=H|0,H>=Y.length)throw new TypeError("invalid index");const $e=Y[Math.floor(Y.length*Math.random())],ne=[],fe=[],te=[];for(const de of Y){const pe=Z(de,$e);pe<0?ne.push(de):pe>0?fe.push(de):te.push(de)}return H<ne.length?A(H,ne,Z):H<ne.length+te.length?te[0]:A(H-(ne.length+te.length),fe,Z)}e.$xb=A;function I(H,Y){const Z=[];let $e;for(const ne of H.slice(0).sort(Y))!$e||Y($e[0],ne)!==0?($e=[ne],Z.push($e)):$e.push(ne);return Z}e.$yb=I;function*$(H,Y){let Z,$e;for(const ne of H)$e!==void 0&&Y($e,ne)?Z.push(ne):(Z&&(yield Z),Z=[ne]),$e=ne;Z&&(yield Z)}e.$zb=$;function y(H,Y){for(let Z=0;Z<=H.length;Z++)Y(Z===0?void 0:H[Z-1],Z===H.length?void 0:H[Z])}e.$Ab=y;function k(H,Y){for(let Z=0;Z<H.length;Z++)Y(Z===0?void 0:H[Z-1],H[Z],Z+1===H.length?void 0:H[Z+1])}e.$Bb=k;function w(H,Y,Z){const $e=[];function ne(de,pe,Pe){if(pe===0&&Pe.length===0)return;const B=$e[$e.length-1];B&&B.start+B.deleteCount===de?(B.deleteCount+=pe,B.toInsert.push(...Pe)):$e.push({start:de,deleteCount:pe,toInsert:Pe})}let fe=0,te=0;for(;;){if(fe===H.length){ne(fe,0,Y.slice(te));break}if(te===Y.length){ne(fe,H.length-fe,[]);break}const de=H[fe],pe=Y[te],Pe=Z(de,pe);Pe===0?(fe+=1,te+=1):Pe<0?(ne(fe,1,[]),fe+=1):Pe>0&&(ne(fe,0,[pe]),te+=1)}return $e}e.$Cb=w;function u(H,Y,Z){const $e=w(H,Y,Z),ne=[],fe=[];for(const te of $e)ne.push(...H.slice(te.start,te.start+te.deleteCount)),fe.push(...te.toInsert);return{removed:ne,added:fe}}e.$Db=u;function o(H,Y,Z){if(Z===0)return[];const $e=H.slice(0,Z).sort(Y);return n(H,Y,$e,Z,H.length),$e}e.top=o;function i(H,Y,Z,$e,ne){return Z===0?Promise.resolve([]):new Promise((fe,te)=>{(async()=>{const de=H.length,pe=H.slice(0,Z).sort(Y);for(let Pe=Z,B=Math.min(Z+$e,de);Pe<de;Pe=B,B=Math.min(B+$e,de)){if(Pe>Z&&await new Promise(X=>setTimeout(X)),ne&&ne.isCancellationRequested)throw new C.$4;n(H,Y,pe,Pe,B)}return pe})().then(fe,te)})}e.$Fb=i;function n(H,Y,Z,$e,ne){for(const fe=Z.length;$e<ne;$e++){const te=H[$e];if(Y(te,Z[fe-1])<0){Z.pop();const de=(0,F.$jb)(Z,pe=>Y(te,pe)<0);Z.splice(de,0,te)}}}function r(H){return H.filter(Y=>!!Y)}e.$Gb=r;function a(H){let Y=0;for(let Z=0;Z<H.length;Z++)H[Z]&&(H[Y]=H[Z],Y+=1);H.length=Y}e.$Hb=a;function t(H,Y,Z){H.splice(Z,0,H.splice(Y,1)[0])}e.$Ib=t;function s(H){return!Array.isArray(H)||H.length===0}e.$Jb=s;function d(H){return Array.isArray(H)&&H.length>0}e.$Kb=d;function c(H,Y=Z=>Z){const Z=new Set;return H.filter($e=>{const ne=Y($e);return Z.has(ne)?!1:(Z.add(ne),!0)})}e.$Lb=c;function l(H){const Y=new Set;return Z=>{const $e=H(Z);return Y.has($e)?!1:(Y.add($e),!0)}}e.$Mb=l;function h(H,Y){return H.length>0?H[0]:Y}e.$Nb=h;function E(H,Y){return H.length>0?H[H.length-1]:Y}e.$Ob=E;function D(H,Y,Z=($e,ne)=>$e===ne){let $e=0;for(let ne=0,fe=Math.min(H.length,Y.length);ne<fe&&Z(H[ne],Y[ne]);ne++)$e++;return $e}e.$Pb=D;function m(H){return[].concat(...H)}e.$Qb=m;function p(H,Y){let Z=typeof Y=="number"?H:0;typeof Y=="number"?Z=H:(Z=0,Y=H);const $e=[];if(Z<=Y)for(let ne=Z;ne<Y;ne++)$e.push(ne);else for(let ne=Z;ne>Y;ne--)$e.push(ne);return $e}e.$Rb=p;function S(H,Y,Z){return H.reduce(($e,ne)=>($e[Y(ne)]=Z?Z(ne):ne,$e),Object.create(null))}e.$Sb=S;function P(H,Y){return H.push(Y),()=>z(H,Y)}e.$Tb=P;function z(H,Y){const Z=H.indexOf(Y);if(Z>-1)return H.splice(Z,1),Y}e.$Ub=z;function j(H,Y,Z){const $e=H.slice(0,Y),ne=H.slice(Y);return $e.concat(Z,ne)}e.$Vb=j;function R(H,Y){let Z;if(typeof Y=="number"){let $e=Y;Z=()=>{const ne=Math.sin($e++)*179426549;return ne-Math.floor(ne)}}else Z=Math.random;for(let $e=H.length-1;$e>0;$e-=1){const ne=Math.floor(Z()*($e+1)),fe=H[$e];H[$e]=H[ne],H[ne]=fe}}e.$Wb=R;function T(H,Y){const Z=H.indexOf(Y);Z>-1&&(H.splice(Z,1),H.unshift(Y))}e.$Xb=T;function N(H,Y){const Z=H.indexOf(Y);Z>-1&&(H.splice(Z,1),H.push(Y))}e.$Yb=N;function O(H,Y){for(const Z of Y)H.push(Z)}e.$Zb=O;function W(H,Y){return Array.isArray(H)?H.map(Y):Y(H)}e.$1b=W;function x(H){return Array.isArray(H)?H:[H]}e.$2b=x;function le(H){return H[Math.floor(Math.random()*H.length)]}e.$3b=le;function G(H,Y,Z){const $e=Q(H,Y),ne=H.length,fe=Z.length;H.length=ne+fe;for(let te=ne-1;te>=$e;te--)H[te+fe]=H[te];for(let te=0;te<fe;te++)H[te+$e]=Z[te]}e.$4b=G;function J(H,Y,Z,$e){const ne=Q(H,Y);let fe=H.splice(ne,Z);return fe===void 0&&(fe=[]),G(H,ne,$e),fe}e.$5b=J;function Q(H,Y){return Y<0?Math.max(Y+H.length,0):Math.min(Y,H.length)}var oe;(function(H){function Y(fe){return fe<0}H.isLessThan=Y;function Z(fe){return fe<=0}H.isLessThanOrEqual=Z;function $e(fe){return fe>0}H.isGreaterThan=$e;function ne(fe){return fe===0}H.isNeitherLessOrGreaterThan=ne,H.greaterThan=1,H.lessThan=-1,H.neitherLessOrGreaterThan=0})(oe||(e.CompareResult=oe={}));function _(H,Y){return(Z,$e)=>Y(H(Z),H($e))}e.$6b=_;function Ee(...H){return(Y,Z)=>{for(const $e of H){const ne=$e(Y,Z);if(!oe.isNeitherLessOrGreaterThan(ne))return ne}return oe.neitherLessOrGreaterThan}}e.$7b=Ee;const he=(H,Y)=>H-Y;e.$8b=he;const q=(H,Y)=>(0,e.$8b)(H?1:0,Y?1:0);e.$9b=q;function U(H){return(Y,Z)=>-H(Y,Z)}e.$0b=U;class ie{constructor(Y){this.g=Y,this.c=0,this.d=this.g.length-1}get length(){return this.d-this.c+1}takeWhile(Y){let Z=this.c;for(;Z<this.g.length&&Y(this.g[Z]);)Z++;const $e=Z===this.c?null:this.g.slice(this.c,Z);return this.c=Z,$e}takeFromEndWhile(Y){let Z=this.d;for(;Z>=0&&Y(this.g[Z]);)Z--;const $e=Z===this.d?null:this.g.slice(Z+1,this.d+1);return this.d=Z,$e}peek(){if(this.length!==0)return this.g[this.c]}peekLast(){if(this.length!==0)return this.g[this.d]}dequeue(){const Y=this.g[this.c];return this.c++,Y}removeLast(){const Y=this.g[this.d];return this.d--,Y}takeCount(Y){const Z=this.g.slice(this.c,this.c+Y);return this.c+=Y,Z}}e.$$b=ie;class be{static{this.empty=new be(Y=>{})}constructor(Y){this.iterate=Y}forEach(Y){this.iterate(Z=>(Y(Z),!0))}toArray(){const Y=[];return this.iterate(Z=>(Y.push(Z),!0)),Y}filter(Y){return new be(Z=>this.iterate($e=>Y($e)?Z($e):!0))}map(Y){return new be(Z=>this.iterate($e=>Z(Y($e))))}some(Y){let Z=!1;return this.iterate($e=>(Z=Y($e),!Z)),Z}findFirst(Y){let Z;return this.iterate($e=>Y($e)?(Z=$e,!1):!0),Z}findLast(Y){let Z;return this.iterate($e=>(Y($e)&&(Z=$e),!0)),Z}findLastMaxBy(Y){let Z,$e=!0;return this.iterate(ne=>(($e||oe.isGreaterThan(Y(ne,Z)))&&($e=!1,Z=ne),!0)),Z}}e.$_b=be}),define(ke[60],Se([1,0,8]),function(me,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7c=e.$6c=e.$5c=e.$4c=e.ok=void 0;function F(v,g){if(!v)throw new Error(g?`Assertion failed (${g})`:"Assertion Failed")}e.ok=F;function f(v,g="Unreachable"){throw new Error(g)}e.$4c=f;function L(v){if(!v)throw new C.$bb("Assertion Failed")}e.$5c=L;function M(v){if(!v()){debugger;v(),(0,C.$Z)(new C.$bb("Assertion Failed"))}}e.$6c=M;function b(v,g){let A=0;for(;A<v.length-1;){const I=v[A],$=v[A+1];if(!g(I,$))return!1;A++}return!0}e.$7c=b}),define(ke[74],Se([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cb=void 0;function C(F,f){const L=this;let M=!1,b;return function(){if(M)return b;if(M=!0,f)try{b=F.apply(L,arguments)}finally{f()}else b=F.apply(L,arguments);return b}}e.$cb=C}),define(ke[122],Se([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$FM=e.$EM=void 0;class C{constructor(f){this.a=f,this.b=0}nextId(){return this.a+ ++this.b}}e.$EM=C,e.$FM=new C("id#")}),define(ke[51],Se([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var C;(function(F){function f(a){return a&&typeof a=="object"&&typeof a[Symbol.iterator]=="function"}F.is=f;const L=Object.freeze([]);function M(){return L}F.empty=M;function*b(a){yield a}F.single=b;function v(a){return f(a)?a:b(a)}F.wrap=v;function g(a){return a||L}F.from=g;function*A(a){for(let t=a.length-1;t>=0;t--)yield a[t]}F.reverse=A;function I(a){return!a||a[Symbol.iterator]().next().done===!0}F.isEmpty=I;function $(a){return a[Symbol.iterator]().next().value}F.first=$;function y(a,t){for(const s of a)if(t(s))return!0;return!1}F.some=y;function k(a,t){for(const s of a)if(t(s))return s}F.find=k;function*w(a,t){for(const s of a)t(s)&&(yield s)}F.filter=w;function*u(a,t){let s=0;for(const d of a)yield t(d,s++)}F.map=u;function*o(...a){for(const t of a)for(const s of t)yield s}F.concat=o;function i(a,t,s){let d=s;for(const c of a)d=t(d,c);return d}F.reduce=i;function*n(a,t,s=a.length){for(t<0&&(t+=a.length),s<0?s+=a.length:s>a.length&&(s=a.length);t<s;t++)yield a[t]}F.slice=n;function r(a,t=Number.POSITIVE_INFINITY){const s=[];if(t===0)return[s,a];const d=a[Symbol.iterator]();for(let c=0;c<t;c++){const l=d.next();if(l.done)return[s,F.empty()];s.push(l.value)}return[s,{[Symbol.iterator](){return d}}]}F.consume=r})(C||(e.Iterable=C={}))}),define(ke[160],Se([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_m=e.$$m=e.$0m=e.$9m=e.$8m=e.$7m=e.$6m=e.$5m=e.$4m=e.$3m=e.$2m=e.$1m=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var C;(function(t){t[t.None=0]="None",t[t.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=2]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",t[t.InvalidUnicode=4]="InvalidUnicode",t[t.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",t[t.InvalidCharacter=6]="InvalidCharacter"})(C||(e.ScanError=C={}));var F;(function(t){t[t.OpenBraceToken=1]="OpenBraceToken",t[t.CloseBraceToken=2]="CloseBraceToken",t[t.OpenBracketToken=3]="OpenBracketToken",t[t.CloseBracketToken=4]="CloseBracketToken",t[t.CommaToken=5]="CommaToken",t[t.ColonToken=6]="ColonToken",t[t.NullKeyword=7]="NullKeyword",t[t.TrueKeyword=8]="TrueKeyword",t[t.FalseKeyword=9]="FalseKeyword",t[t.StringLiteral=10]="StringLiteral",t[t.NumericLiteral=11]="NumericLiteral",t[t.LineCommentTrivia=12]="LineCommentTrivia",t[t.BlockCommentTrivia=13]="BlockCommentTrivia",t[t.LineBreakTrivia=14]="LineBreakTrivia",t[t.Trivia=15]="Trivia",t[t.Unknown=16]="Unknown",t[t.EOF=17]="EOF"})(F||(e.SyntaxKind=F={}));var f;(function(t){t[t.InvalidSymbol=1]="InvalidSymbol",t[t.InvalidNumberFormat=2]="InvalidNumberFormat",t[t.PropertyNameExpected=3]="PropertyNameExpected",t[t.ValueExpected=4]="ValueExpected",t[t.ColonExpected=5]="ColonExpected",t[t.CommaExpected=6]="CommaExpected",t[t.CloseBraceExpected=7]="CloseBraceExpected",t[t.CloseBracketExpected=8]="CloseBracketExpected",t[t.EndOfFileExpected=9]="EndOfFileExpected",t[t.InvalidCommentToken=10]="InvalidCommentToken",t[t.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=12]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",t[t.InvalidUnicode=14]="InvalidUnicode",t[t.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",t[t.InvalidCharacter=16]="InvalidCharacter"})(f||(e.ParseErrorCode=f={}));var L;(function(t){t.DEFAULT={allowTrailingComma:!0}})(L||(e.ParseOptions=L={}));function M(t,s=!1){let d=0;const c=t.length;let l="",h=0,E=16,D=0;function m(T){let N=0,O=0;for(;N<T;){const W=t.charCodeAt(d);if(W>=48&&W<=57)O=O*16+W-48;else if(W>=65&&W<=70)O=O*16+W-65+10;else if(W>=97&&W<=102)O=O*16+W-97+10;else break;d++,N++}return N<T&&(O=-1),O}function p(T){d=T,l="",h=0,E=16,D=0}function S(){const T=d;if(t.charCodeAt(d)===48)d++;else for(d++;d<t.length&&g(t.charCodeAt(d));)d++;if(d<t.length&&t.charCodeAt(d)===46)if(d++,d<t.length&&g(t.charCodeAt(d)))for(d++;d<t.length&&g(t.charCodeAt(d));)d++;else return D=3,t.substring(T,d);let N=d;if(d<t.length&&(t.charCodeAt(d)===69||t.charCodeAt(d)===101))if(d++,(d<t.length&&t.charCodeAt(d)===43||t.charCodeAt(d)===45)&&d++,d<t.length&&g(t.charCodeAt(d))){for(d++;d<t.length&&g(t.charCodeAt(d));)d++;N=d}else D=3;return t.substring(T,N)}function P(){let T="",N=d;for(;;){if(d>=c){T+=t.substring(N,d),D=2;break}const O=t.charCodeAt(d);if(O===34){T+=t.substring(N,d),d++;break}if(O===92){if(T+=t.substring(N,d),d++,d>=c){D=2;break}switch(t.charCodeAt(d++)){case 34:T+='"';break;case 92:T+="\\";break;case 47:T+="/";break;case 98:T+="\b";break;case 102:T+="\f";break;case 110:T+=`
`;break;case 114:T+="\r";break;case 116:T+="	";break;case 117:{const x=m(4);x>=0?T+=String.fromCharCode(x):D=4;break}default:D=5}N=d;continue}if(O>=0&&O<=31)if(v(O)){T+=t.substring(N,d),D=2;break}else D=6;d++}return T}function z(){if(l="",D=0,h=d,d>=c)return h=c,E=17;let T=t.charCodeAt(d);if(b(T)){do d++,l+=String.fromCharCode(T),T=t.charCodeAt(d);while(b(T));return E=15}if(v(T))return d++,l+=String.fromCharCode(T),T===13&&t.charCodeAt(d)===10&&(d++,l+=`
`),E=14;switch(T){case 123:return d++,E=1;case 125:return d++,E=2;case 91:return d++,E=3;case 93:return d++,E=4;case 58:return d++,E=6;case 44:return d++,E=5;case 34:return d++,l=P(),E=10;case 47:{const N=d-1;if(t.charCodeAt(d+1)===47){for(d+=2;d<c&&!v(t.charCodeAt(d));)d++;return l=t.substring(N,d),E=12}if(t.charCodeAt(d+1)===42){d+=2;const O=c-1;let W=!1;for(;d<O;){if(t.charCodeAt(d)===42&&t.charCodeAt(d+1)===47){d+=2,W=!0;break}d++}return W||(d++,D=1),l=t.substring(N,d),E=13}return l+=String.fromCharCode(T),d++,E=16}case 45:if(l+=String.fromCharCode(T),d++,d===c||!g(t.charCodeAt(d)))return E=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return l+=S(),E=11;default:for(;d<c&&j(T);)d++,T=t.charCodeAt(d);if(h!==d){switch(l=t.substring(h,d),l){case"true":return E=8;case"false":return E=9;case"null":return E=7}return E=16}return l+=String.fromCharCode(T),d++,E=16}}function j(T){if(b(T)||v(T))return!1;switch(T){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function R(){let T;do T=z();while(T>=12&&T<=15);return T}return{setPosition:p,getPosition:()=>d,scan:s?R:z,getToken:()=>E,getTokenValue:()=>l,getTokenOffset:()=>h,getTokenLength:()=>d-h,getTokenError:()=>D}}e.$1m=M;function b(t){return t===32||t===9||t===11||t===12||t===160||t===5760||t>=8192&&t<=8203||t===8239||t===8287||t===12288||t===65279}function v(t){return t===10||t===13||t===8232||t===8233}function g(t){return t>=48&&t<=57}var A;(function(t){t[t.nullCharacter=0]="nullCharacter",t[t.maxAsciiCharacter=127]="maxAsciiCharacter",t[t.lineFeed=10]="lineFeed",t[t.carriageReturn=13]="carriageReturn",t[t.lineSeparator=8232]="lineSeparator",t[t.paragraphSeparator=8233]="paragraphSeparator",t[t.nextLine=133]="nextLine",t[t.space=32]="space",t[t.nonBreakingSpace=160]="nonBreakingSpace",t[t.enQuad=8192]="enQuad",t[t.emQuad=8193]="emQuad",t[t.enSpace=8194]="enSpace",t[t.emSpace=8195]="emSpace",t[t.threePerEmSpace=8196]="threePerEmSpace",t[t.fourPerEmSpace=8197]="fourPerEmSpace",t[t.sixPerEmSpace=8198]="sixPerEmSpace",t[t.figureSpace=8199]="figureSpace",t[t.punctuationSpace=8200]="punctuationSpace",t[t.thinSpace=8201]="thinSpace",t[t.hairSpace=8202]="hairSpace",t[t.zeroWidthSpace=8203]="zeroWidthSpace",t[t.narrowNoBreakSpace=8239]="narrowNoBreakSpace",t[t.ideographicSpace=12288]="ideographicSpace",t[t.mathematicalSpace=8287]="mathematicalSpace",t[t.ogham=5760]="ogham",t[t._=95]="_",t[t.$=36]="$",t[t._0=48]="_0",t[t._1=49]="_1",t[t._2=50]="_2",t[t._3=51]="_3",t[t._4=52]="_4",t[t._5=53]="_5",t[t._6=54]="_6",t[t._7=55]="_7",t[t._8=56]="_8",t[t._9=57]="_9",t[t.a=97]="a",t[t.b=98]="b",t[t.c=99]="c",t[t.d=100]="d",t[t.e=101]="e",t[t.f=102]="f",t[t.g=103]="g",t[t.h=104]="h",t[t.i=105]="i",t[t.j=106]="j",t[t.k=107]="k",t[t.l=108]="l",t[t.m=109]="m",t[t.n=110]="n",t[t.o=111]="o",t[t.p=112]="p",t[t.q=113]="q",t[t.r=114]="r",t[t.s=115]="s",t[t.t=116]="t",t[t.u=117]="u",t[t.v=118]="v",t[t.w=119]="w",t[t.x=120]="x",t[t.y=121]="y",t[t.z=122]="z",t[t.A=65]="A",t[t.B=66]="B",t[t.C=67]="C",t[t.D=68]="D",t[t.E=69]="E",t[t.F=70]="F",t[t.G=71]="G",t[t.H=72]="H",t[t.I=73]="I",t[t.J=74]="J",t[t.K=75]="K",t[t.L=76]="L",t[t.M=77]="M",t[t.N=78]="N",t[t.O=79]="O",t[t.P=80]="P",t[t.Q=81]="Q",t[t.R=82]="R",t[t.S=83]="S",t[t.T=84]="T",t[t.U=85]="U",t[t.V=86]="V",t[t.W=87]="W",t[t.X=88]="X",t[t.Y=89]="Y",t[t.Z=90]="Z",t[t.ampersand=38]="ampersand",t[t.asterisk=42]="asterisk",t[t.at=64]="at",t[t.backslash=92]="backslash",t[t.bar=124]="bar",t[t.caret=94]="caret",t[t.closeBrace=125]="closeBrace",t[t.closeBracket=93]="closeBracket",t[t.closeParen=41]="closeParen",t[t.colon=58]="colon",t[t.comma=44]="comma",t[t.dot=46]="dot",t[t.doubleQuote=34]="doubleQuote",t[t.equals=61]="equals",t[t.exclamation=33]="exclamation",t[t.greaterThan=62]="greaterThan",t[t.lessThan=60]="lessThan",t[t.minus=45]="minus",t[t.openBrace=123]="openBrace",t[t.openBracket=91]="openBracket",t[t.openParen=40]="openParen",t[t.percent=37]="percent",t[t.plus=43]="plus",t[t.question=63]="question",t[t.semicolon=59]="semicolon",t[t.singleQuote=39]="singleQuote",t[t.slash=47]="slash",t[t.tilde=126]="tilde",t[t.backspace=8]="backspace",t[t.formFeed=12]="formFeed",t[t.byteOrderMark=65279]="byteOrderMark",t[t.tab=9]="tab",t[t.verticalTab=11]="verticalTab"})(A||(A={}));function I(t,s){const d=[],c=new Object;let l;const h={value:{},offset:0,length:0,type:"object",parent:void 0};let E=!1;function D(m,p,S,P){h.value=m,h.offset=p,h.length=S,h.type=P,h.colonOffset=void 0,l=h}try{n(t,{onObjectBegin:(m,p)=>{if(s<=m)throw c;l=void 0,E=s>m,d.push("")},onObjectProperty:(m,p,S)=>{if(s<p||(D(m,p,S,"property"),d[d.length-1]=m,s<=p+S))throw c},onObjectEnd:(m,p)=>{if(s<=m)throw c;l=void 0,d.pop()},onArrayBegin:(m,p)=>{if(s<=m)throw c;l=void 0,d.push(0)},onArrayEnd:(m,p)=>{if(s<=m)throw c;l=void 0,d.pop()},onLiteralValue:(m,p,S)=>{if(s<p||(D(m,p,S,a(m)),s<=p+S))throw c},onSeparator:(m,p,S)=>{if(s<=p)throw c;if(m===":"&&l&&l.type==="property")l.colonOffset=p,E=!1,l=void 0;else if(m===","){const P=d[d.length-1];typeof P=="number"?d[d.length-1]=P+1:(E=!0,d[d.length-1]=""),l=void 0}}})}catch(m){if(m!==c)throw m}return{path:d,previousNode:l,isAtPropertyKey:E,matches:m=>{let p=0;for(let S=0;p<m.length&&S<d.length;S++)if(m[p]===d[S]||m[p]==="*")p++;else if(m[p]!=="**")return!1;return p===m.length}}}e.$2m=I;function $(t,s=[],d=L.DEFAULT){let c=null,l=[];const h=[];function E(m){Array.isArray(l)?l.push(m):c!==null&&(l[c]=m)}return n(t,{onObjectBegin:()=>{const m={};E(m),h.push(l),l=m,c=null},onObjectProperty:m=>{c=m},onObjectEnd:()=>{l=h.pop()},onArrayBegin:()=>{const m=[];E(m),h.push(l),l=m,c=null},onArrayEnd:()=>{l=h.pop()},onLiteralValue:E,onError:(m,p,S)=>{s.push({error:m,offset:p,length:S})}},d),l[0]}e.$3m=$;function y(t,s=[],d=L.DEFAULT){let c={type:"array",offset:-1,length:-1,children:[],parent:void 0};function l(m){c.type==="property"&&(c.length=m-c.offset,c=c.parent)}function h(m){return c.children.push(m),m}n(t,{onObjectBegin:m=>{c=h({type:"object",offset:m,length:-1,parent:c,children:[]})},onObjectProperty:(m,p,S)=>{c=h({type:"property",offset:p,length:-1,parent:c,children:[]}),c.children.push({type:"string",value:m,offset:p,length:S,parent:c})},onObjectEnd:(m,p)=>{c.length=m+p-c.offset,c=c.parent,l(m+p)},onArrayBegin:(m,p)=>{c=h({type:"array",offset:m,length:-1,parent:c,children:[]})},onArrayEnd:(m,p)=>{c.length=m+p-c.offset,c=c.parent,l(m+p)},onLiteralValue:(m,p,S)=>{h({type:a(m),offset:p,length:S,parent:c,value:m}),l(p+S)},onSeparator:(m,p,S)=>{c.type==="property"&&(m===":"?c.colonOffset=p:m===","&&l(p))},onError:(m,p,S)=>{s.push({error:m,offset:p,length:S})}},d);const D=c.children[0];return D&&delete D.parent,D}e.$4m=y;function k(t,s){if(!t)return;let d=t;for(const c of s)if(typeof c=="string"){if(d.type!=="object"||!Array.isArray(d.children))return;let l=!1;for(const h of d.children)if(Array.isArray(h.children)&&h.children[0].value===c){d=h.children[1],l=!0;break}if(!l)return}else{const l=c;if(d.type!=="array"||l<0||!Array.isArray(d.children)||l>=d.children.length)return;d=d.children[l]}return d}e.$5m=k;function w(t){if(!t.parent||!t.parent.children)return[];const s=w(t.parent);if(t.parent.type==="property"){const d=t.parent.children[0].value;s.push(d)}else if(t.parent.type==="array"){const d=t.parent.children.indexOf(t);d!==-1&&s.push(d)}return s}e.$6m=w;function u(t){switch(t.type){case"array":return t.children.map(u);case"object":{const s=Object.create(null);for(const d of t.children){const c=d.children[1];c&&(s[d.children[0].value]=u(c))}return s}case"null":case"string":case"number":case"boolean":return t.value;default:return}}e.$7m=u;function o(t,s,d=!1){return s>=t.offset&&s<t.offset+t.length||d&&s===t.offset+t.length}e.$8m=o;function i(t,s,d=!1){if(o(t,s,d)){const c=t.children;if(Array.isArray(c))for(let l=0;l<c.length&&c[l].offset<=s;l++){const h=i(c[l],s,d);if(h)return h}return t}}e.$9m=i;function n(t,s,d=L.DEFAULT){const c=M(t,!1);function l(_){return _?()=>_(c.getTokenOffset(),c.getTokenLength()):()=>!0}function h(_){return _?Ee=>_(Ee,c.getTokenOffset(),c.getTokenLength()):()=>!0}const E=l(s.onObjectBegin),D=h(s.onObjectProperty),m=l(s.onObjectEnd),p=l(s.onArrayBegin),S=l(s.onArrayEnd),P=h(s.onLiteralValue),z=h(s.onSeparator),j=l(s.onComment),R=h(s.onError),T=d&&d.disallowComments,N=d&&d.allowTrailingComma;function O(){for(;;){const _=c.scan();switch(c.getTokenError()){case 4:W(14);break;case 5:W(15);break;case 3:W(13);break;case 1:T||W(11);break;case 2:W(12);break;case 6:W(16);break}switch(_){case 12:case 13:T?W(10):j();break;case 16:W(1);break;case 15:case 14:break;default:return _}}}function W(_,Ee=[],he=[]){if(R(_),Ee.length+he.length>0){let q=c.getToken();for(;q!==17;){if(Ee.indexOf(q)!==-1){O();break}else if(he.indexOf(q)!==-1)break;q=O()}}}function x(_){const Ee=c.getTokenValue();return _?P(Ee):D(Ee),O(),!0}function le(){switch(c.getToken()){case 11:{let _=0;try{_=JSON.parse(c.getTokenValue()),typeof _!="number"&&(W(2),_=0)}catch{W(2)}P(_);break}case 7:P(null);break;case 8:P(!0);break;case 9:P(!1);break;default:return!1}return O(),!0}function G(){return c.getToken()!==10?(W(3,[],[2,5]),!1):(x(!1),c.getToken()===6?(z(":"),O(),oe()||W(4,[],[2,5])):W(5,[],[2,5]),!0)}function J(){E(),O();let _=!1;for(;c.getToken()!==2&&c.getToken()!==17;){if(c.getToken()===5){if(_||W(4,[],[]),z(","),O(),c.getToken()===2&&N)break}else _&&W(6,[],[]);G()||W(4,[],[2,5]),_=!0}return m(),c.getToken()!==2?W(7,[2],[]):O(),!0}function Q(){p(),O();let _=!1;for(;c.getToken()!==4&&c.getToken()!==17;){if(c.getToken()===5){if(_||W(4,[],[]),z(","),O(),c.getToken()===4&&N)break}else _&&W(6,[],[]);oe()||W(4,[],[4,5]),_=!0}return S(),c.getToken()!==4?W(8,[4],[]):O(),!0}function oe(){switch(c.getToken()){case 3:return Q();case 1:return J();case 10:return x(!0);default:return le()}}return O(),c.getToken()===17?d.allowEmptyContent?!0:(W(4,[],[]),!1):oe()?(c.getToken()!==17&&W(9,[],[]),!0):(W(4,[],[]),!1)}e.$0m=n;function r(t,s){const d=M(t),c=[];let l,h=0,E;do switch(E=d.getPosition(),l=d.scan(),l){case 12:case 13:case 17:h!==E&&c.push(t.substring(h,E)),s!==void 0&&c.push(d.getTokenValue().replace(/[^\r\n]/g,s)),h=d.getPosition();break}while(l!==17);return c.join("")}e.$$m=r;function a(t){switch(typeof t){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(t){if(Array.isArray(t))return"array"}else return"null";return"object"}default:return"null"}}e.$_m=a}),define(ke[48],Se([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$U=void 0;class C{constructor(f){this.d=f,this.a=!1}get hasValue(){return this.a}get value(){if(!this.a)try{this.b=this.d()}catch(f){this.c=f}finally{this.a=!0}if(this.c)throw this.c;return this.b}get rawValue(){return this.b}}e.$U=C}),define(ke[75],Se([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2c=void 0;class C{static{this.Undefined=new C(void 0)}constructor(L){this.element=L,this.next=C.Undefined,this.prev=C.Undefined}}class F{constructor(){this.a=C.Undefined,this.b=C.Undefined,this.c=0}get size(){return this.c}isEmpty(){return this.a===C.Undefined}clear(){let L=this.a;for(;L!==C.Undefined;){const M=L.next;L.prev=C.Undefined,L.next=C.Undefined,L=M}this.a=C.Undefined,this.b=C.Undefined,this.c=0}unshift(L){return this.d(L,!1)}push(L){return this.d(L,!0)}d(L,M){const b=new C(L);if(this.a===C.Undefined)this.a=b,this.b=b;else if(M){const g=this.b;this.b=b,b.prev=g,g.next=b}else{const g=this.a;this.a=b,b.next=g,g.prev=b}this.c+=1;let v=!1;return()=>{v||(v=!0,this.e(b))}}shift(){if(this.a!==C.Undefined){const L=this.a.element;return this.e(this.a),L}}pop(){if(this.b!==C.Undefined){const L=this.b.element;return this.e(this.b),L}}e(L){if(L.prev!==C.Undefined&&L.next!==C.Undefined){const M=L.prev;M.next=L.next,L.next.prev=M}else L.prev===C.Undefined&&L.next===C.Undefined?(this.a=C.Undefined,this.b=C.Undefined):L.next===C.Undefined?(this.b=this.b.prev,this.b.next=C.Undefined):L.prev===C.Undefined&&(this.a=this.a.next,this.a.prev=C.Undefined);this.c-=1}*[Symbol.iterator](){let L=this.a;for(;L!==C.Undefined;)yield L.element,L=L.next}}e.$2c=F}),define(ke[28],Se([1,0]),function(me,e){"use strict";var C,F,f;Object.defineProperty(e,"__esModule",{value:!0}),e.$Fc=e.$Ec=e.$Dc=e.$Cc=e.$Bc=e.Touch=e.$Ac=e.$zc=e.$yc=e.$xc=e.$wc=void 0;function L(i,n,r){let a=i.get(n);return a===void 0&&(a=r,i.set(n,a)),a}e.$wc=L;function M(i){const n=[];return i.forEach((r,a)=>{n.push(`${a} => ${r}`)}),`Map(${i.size}) {${n.join(", ")}}`}e.$xc=M;function b(i){const n=[];return i.forEach(r=>{n.push(r)}),`Set(${i.size}) {${n.join(", ")}}`}e.$yc=b;class v{constructor(n,r){this.uri=n,this.value=r}}function g(i){return Array.isArray(i)}class A{static{this.a=n=>n.toString()}constructor(n,r){if(this[C]="ResourceMap",n instanceof A)this.b=new Map(n.b),this.c=r??A.a;else if(g(n)){this.b=new Map,this.c=r??A.a;for(const[a,t]of n)this.set(a,t)}else this.b=new Map,this.c=n??A.a}set(n,r){return this.b.set(this.c(n),new v(n,r)),this}get(n){return this.b.get(this.c(n))?.value}has(n){return this.b.has(this.c(n))}get size(){return this.b.size}clear(){this.b.clear()}delete(n){return this.b.delete(this.c(n))}forEach(n,r){typeof r<"u"&&(n=n.bind(r));for(const[a,t]of this.b)n(t.value,t.uri,this)}*values(){for(const n of this.b.values())yield n.value}*keys(){for(const n of this.b.values())yield n.uri}*entries(){for(const n of this.b.values())yield[n.uri,n.value]}*[(C=Symbol.toStringTag,Symbol.iterator)](){for(const[,n]of this.b)yield[n.uri,n.value]}}e.$zc=A;class I{constructor(n,r){this[F]="ResourceSet",!n||typeof n=="function"?this.a=new A(n):(this.a=new A(r),n.forEach(this.add,this))}get size(){return this.a.size}add(n){return this.a.set(n,n),this}clear(){this.a.clear()}delete(n){return this.a.delete(n)}forEach(n,r){this.a.forEach((a,t)=>n.call(r,t,t,this))}has(n){return this.a.has(n)}entries(){return this.a.entries()}keys(){return this.a.keys()}values(){return this.a.keys()}[(F=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}e.$Ac=I;var $;(function(i){i[i.None=0]="None",i[i.AsOld=1]="AsOld",i[i.AsNew=2]="AsNew"})($||(e.Touch=$={}));class y{constructor(){this[f]="LinkedMap",this.a=new Map,this.b=void 0,this.c=void 0,this.d=0,this.e=0}clear(){this.a.clear(),this.b=void 0,this.c=void 0,this.d=0,this.e++}isEmpty(){return!this.b&&!this.c}get size(){return this.d}get first(){return this.b?.value}get last(){return this.c?.value}has(n){return this.a.has(n)}get(n,r=0){const a=this.a.get(n);if(a)return r!==0&&this.j(a,r),a.value}set(n,r,a=0){let t=this.a.get(n);if(t)t.value=r,a!==0&&this.j(t,a);else{switch(t={key:n,value:r,next:void 0,previous:void 0},a){case 0:this.h(t);break;case 1:this.g(t);break;case 2:this.h(t);break;default:this.h(t);break}this.a.set(n,t),this.d++}return this}delete(n){return!!this.remove(n)}remove(n){const r=this.a.get(n);if(r)return this.a.delete(n),this.i(r),this.d--,r.value}shift(){if(!this.b&&!this.c)return;if(!this.b||!this.c)throw new Error("Invalid list");const n=this.b;return this.a.delete(n.key),this.i(n),this.d--,n.value}forEach(n,r){const a=this.e;let t=this.b;for(;t;){if(r?n.bind(r)(t.value,t.key,this):n(t.value,t.key,this),this.e!==a)throw new Error("LinkedMap got modified during iteration.");t=t.next}}keys(){const n=this,r=this.e;let a=this.b;const t={[Symbol.iterator](){return t},next(){if(n.e!==r)throw new Error("LinkedMap got modified during iteration.");if(a){const s={value:a.key,done:!1};return a=a.next,s}else return{value:void 0,done:!0}}};return t}values(){const n=this,r=this.e;let a=this.b;const t={[Symbol.iterator](){return t},next(){if(n.e!==r)throw new Error("LinkedMap got modified during iteration.");if(a){const s={value:a.value,done:!1};return a=a.next,s}else return{value:void 0,done:!0}}};return t}entries(){const n=this,r=this.e;let a=this.b;const t={[Symbol.iterator](){return t},next(){if(n.e!==r)throw new Error("LinkedMap got modified during iteration.");if(a){const s={value:[a.key,a.value],done:!1};return a=a.next,s}else return{value:void 0,done:!0}}};return t}[(f=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}f(n){if(n>=this.size)return;if(n===0){this.clear();return}let r=this.b,a=this.size;for(;r&&a>n;)this.a.delete(r.key),r=r.next,a--;this.b=r,this.d=a,r&&(r.previous=void 0),this.e++}g(n){if(!this.b&&!this.c)this.c=n;else if(this.b)n.next=this.b,this.b.previous=n;else throw new Error("Invalid list");this.b=n,this.e++}h(n){if(!this.b&&!this.c)this.b=n;else if(this.c)n.previous=this.c,this.c.next=n;else throw new Error("Invalid list");this.c=n,this.e++}i(n){if(n===this.b&&n===this.c)this.b=void 0,this.c=void 0;else if(n===this.b){if(!n.next)throw new Error("Invalid list");n.next.previous=void 0,this.b=n.next}else if(n===this.c){if(!n.previous)throw new Error("Invalid list");n.previous.next=void 0,this.c=n.previous}else{const r=n.next,a=n.previous;if(!r||!a)throw new Error("Invalid list");r.previous=a,a.next=r}n.next=void 0,n.previous=void 0,this.e++}j(n,r){if(!this.b||!this.c)throw new Error("Invalid list");if(!(r!==1&&r!==2)){if(r===1){if(n===this.b)return;const a=n.next,t=n.previous;n===this.c?(t.next=void 0,this.c=t):(a.previous=t,t.next=a),n.previous=void 0,n.next=this.b,this.b.previous=n,this.b=n,this.e++}else if(r===2){if(n===this.c)return;const a=n.next,t=n.previous;n===this.b?(a.previous=void 0,this.b=a):(a.previous=t,t.next=a),n.next=void 0,n.previous=this.c,this.c.next=n,this.c=n,this.e++}}}toJSON(){const n=[];return this.forEach((r,a)=>{n.push([a,r])}),n}fromJSON(n){this.clear();for(const[r,a]of n)this.set(r,a)}}e.$Bc=y;class k extends y{constructor(n,r=1){super(),this.k=n,this.l=Math.min(Math.max(0,r),1)}get limit(){return this.k}set limit(n){this.k=n,this.m()}get ratio(){return this.l}set ratio(n){this.l=Math.min(Math.max(0,n),1),this.m()}get(n,r=2){return super.get(n,r)}peek(n){return super.get(n,0)}set(n,r){return super.set(n,r,2),this.m(),this}m(){this.size>this.k&&this.f(Math.round(this.k*this.l))}}e.$Cc=k;class w{constructor(){this.a=new Map}add(n){return this.a.set(n,(this.a.get(n)||0)+1),this}delete(n){let r=this.a.get(n)||0;return r===0?!1:(r--,r===0?this.a.delete(n):this.a.set(n,r),!0)}has(n){return this.a.has(n)}}e.$Dc=w;class u{constructor(n){if(this.a=new Map,this.b=new Map,n)for(const[r,a]of n)this.set(r,a)}clear(){this.a.clear(),this.b.clear()}set(n,r){this.a.set(n,r),this.b.set(r,n)}get(n){return this.a.get(n)}getKey(n){return this.b.get(n)}delete(n){const r=this.a.get(n);return r===void 0?!1:(this.a.delete(n),this.b.delete(r),!0)}forEach(n,r){this.a.forEach((a,t)=>{n.call(r,a,t,this)})}keys(){return this.a.keys()}values(){return this.a.values()}}e.$Ec=u;class o{constructor(){this.a=new Map}add(n,r){let a=this.a.get(n);a||(a=new Set,this.a.set(n,a)),a.add(r)}delete(n,r){const a=this.a.get(n);a&&(a.delete(r),a.size===0&&this.a.delete(n))}forEach(n,r){const a=this.a.get(n);a&&a.forEach(r)}get(n){const r=this.a.get(n);return r||new Set}}e.$Fc=o}),define(ke[3],Se([1,0,19,73,28,74,51]),function(me,e,C,F,f,L,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1c=e.$Zc=e.$Yc=e.$Xc=e.$Wc=e.$Vc=e.$Uc=e.$Tc=e.$Sc=e.$Rc=e.$Qc=e.$Pc=e.$Oc=e.$Nc=e.$Mc=e.$Lc=e.$Kc=e.$Jc=e.$Ic=e.$Hc=e.$Gc=void 0;const b=!1;let v=null;class g{constructor(){this.b=new Map}static{this.a=0}c(P){let z=this.b.get(P);return z||(z={parent:null,source:null,isSingleton:!1,value:P,idx:g.a++},this.b.set(P,z)),z}trackDisposable(P){const z=this.c(P);z.source||(z.source=new Error().stack)}setParent(P,z){const j=this.c(P);j.parent=z}markAsDisposed(P){this.b.delete(P)}markAsSingleton(P){this.c(P).isSingleton=!0}f(P,z){const j=z.get(P);if(j)return j;const R=P.parent?this.f(this.c(P.parent),z):P;return z.set(P,R),R}getTrackedDisposables(){const P=new Map;return[...this.b.entries()].filter(([,j])=>j.source!==null&&!this.f(j,P).isSingleton).flatMap(([j])=>j)}computeLeakingDisposables(P=10,z){let j;if(z)j=z;else{const W=new Map,x=[...this.b.values()].filter(G=>G.source!==null&&!this.f(G,W).isSingleton);if(x.length===0)return;const le=new Set(x.map(G=>G.value));if(j=x.filter(G=>!(G.parent&&le.has(G.parent))),j.length===0)throw new Error("There are cyclic diposable chains!")}if(!j)return;function R(W){function x(G,J){for(;G.length>0&&J.some(Q=>typeof Q=="string"?Q===G[0]:G[0].match(Q));)G.shift()}const le=W.source.split(`
`).map(G=>G.trim().replace("at ","")).filter(G=>G!=="");return x(le,["Error",/^trackDisposable \(.*\)$/,/^DisposableTracker.trackDisposable \(.*\)$/]),le.reverse()}const T=new f.$Fc;for(const W of j){const x=R(W);for(let le=0;le<=x.length;le++)T.add(x.slice(0,le).join(`
`),W)}j.sort((0,C.$6b)(W=>W.idx,C.$8b));let N="",O=0;for(const W of j.slice(0,P)){O++;const x=R(W),le=[];for(let G=0;G<x.length;G++){let J=x[G];J=`(shared with ${T.get(x.slice(0,G+1).join(`
`)).size}/${j.length} leaks) at ${J}`;const oe=T.get(x.slice(0,G).join(`
`)),_=(0,F.$J)([...oe].map(Ee=>R(Ee)[G]),Ee=>Ee);delete _[x[G]];for(const[Ee,he]of Object.entries(_))le.unshift(`    - stacktraces of ${he.length} other leaks continue with ${Ee}`);le.unshift(J)}N+=`


==================== Leaking disposable ${O}/${j.length}: ${W.value.constructor.name} ====================
${le.join(`
`)}
============================================================

`}return j.length>P&&(N+=`


... and ${j.length-P} more leaking disposables

`),{leaks:j,details:N}}}e.$Gc=g;function A(S){v=S}if(e.$Hc=A,b){const S="__is_disposable_tracked__";A(new class{trackDisposable(P){const z=new Error("Potentially leaked disposable").stack;setTimeout(()=>{P[S]||console.log(z)},3e3)}setParent(P,z){if(P&&P!==t.None)try{P[S]=!0}catch{}}markAsDisposed(P){if(P&&P!==t.None)try{P[S]=!0}catch{}}markAsSingleton(P){}})}function I(S){return v?.trackDisposable(S),S}e.$Ic=I;function $(S){v?.markAsDisposed(S)}e.$Jc=$;function y(S,P){v?.setParent(S,P)}function k(S,P){if(v)for(const z of S)v.setParent(z,P)}function w(S){return v?.markAsSingleton(S),S}e.$Kc=w;function u(S){return typeof S.dispose=="function"&&S.dispose.length===0}e.$Lc=u;function o(S){if(M.Iterable.is(S)){const P=[];for(const z of S)if(z)try{z.dispose()}catch(j){P.push(j)}if(P.length===1)throw P[0];if(P.length>1)throw new AggregateError(P,"Encountered errors while disposing of store");return Array.isArray(S)?[]:S}else if(S)return S.dispose(),S}e.$Mc=o;function i(S){for(const P of S)u(P)&&P.dispose();return[]}e.$Nc=i;function n(...S){const P=r(()=>o(S));return k(S,P),P}e.$Oc=n;function r(S){const P=I({dispose:(0,L.$cb)(()=>{$(P),S()})});return P}e.$Pc=r;class a{static{this.DISABLE_DISPOSED_WARNING=!1}constructor(){this.f=new Set,this.g=!1,I(this)}dispose(){this.g||($(this),this.g=!0,this.clear())}get isDisposed(){return this.g}clear(){if(this.f.size!==0)try{o(this.f)}finally{this.f.clear()}}add(P){if(!P)return P;if(P===this)throw new Error("Cannot register a disposable on itself!");return y(P,this),this.g?a.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this.f.add(P),P}delete(P){if(P){if(P===this)throw new Error("Cannot dispose a disposable on itself!");this.f.delete(P),P.dispose()}}deleteAndLeak(P){P&&this.f.has(P)&&(this.f.delete(P),y(P,null))}}e.$Qc=a;class t{static{this.None=Object.freeze({dispose(){}})}constructor(){this.q=new a,I(this),y(this.q,this)}dispose(){$(this),this.q.dispose()}B(P){if(P===this)throw new Error("Cannot register a disposable on itself!");return this.q.add(P)}}e.$Rc=t;class s{constructor(){this.b=!1,I(this)}get value(){return this.b?void 0:this.a}set value(P){this.b||P===this.a||(this.a?.dispose(),P&&y(P,this),this.a=P)}clear(){this.value=void 0}dispose(){this.b=!0,$(this),this.a?.dispose(),this.a=void 0}clearAndLeak(){const P=this.a;return this.a=void 0,P&&y(P,null),P}}e.$Sc=s;class d{constructor(P){this.a=new s,this.b=!1,this.a.value=P}get value(){return this.a.value}set value(P){this.b||P===this.a.value||(this.a.value=P)}dispose(){this.b=!0,this.a.dispose()}}e.$Tc=d;class c{constructor(P){this.b=P,this.a=1}acquire(){return this.a++,this}release(){return--this.a===0&&this.b.dispose(),this}}e.$Uc=c;class l{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,I(this)}set(P){let z=P;return this.unset=()=>z=void 0,this.isset=()=>z!==void 0,this.dispose=()=>{z&&(z(),z=void 0,$(this))},this}}e.$Vc=l;class h{constructor(){this.a=new Map}acquire(P,...z){let j=this.a.get(P);j||(j={counter:0,object:this.b(P,...z)},this.a.set(P,j));const{object:R}=j,T=(0,L.$cb)(()=>{--j.counter===0&&(this.c(P,j.object),this.a.delete(P))});return j.counter++,{object:R,dispose:T}}}e.$Wc=h;class E{constructor(P){this.a=P}async acquire(P,...z){const j=this.a.acquire(P,...z);try{return{object:await j.object,dispose:()=>j.dispose()}}catch(R){throw j.dispose(),R}}}e.$Xc=E;class D{constructor(P){this.object=P}dispose(){}}e.$Yc=D;function m(S){const P=new a;try{S(P)}finally{P.dispose()}}e.$Zc=m;class p{constructor(){this.a=new Map,this.b=!1,I(this)}dispose(){$(this),this.b=!0,this.clearAndDisposeAll()}clearAndDisposeAll(){if(this.a.size)try{o(this.a.values())}finally{this.a.clear()}}has(P){return this.a.has(P)}get size(){return this.a.size}get(P){return this.a.get(P)}set(P,z,j=!1){this.b&&console.warn(new Error("Trying to add a disposable to a DisposableMap that has already been disposed of. The added object will be leaked!").stack),j||this.a.get(P)?.dispose(),this.a.set(P,z)}deleteAndDispose(P){this.a.get(P)?.dispose(),this.a.delete(P)}keys(){return this.a.keys()}values(){return this.a.values()}[Symbol.iterator](){return this.a[Symbol.iterator]()}}e.$1c=p}),function(me,e){typeof define=="function"&&define.amd?define(ke[161],Se([0]),e):typeof exports=="object"&&typeof module<"u"?e(exports):(me=typeof globalThis<"u"?globalThis:me||self,e(me.marked={}))}(this,function(me){"use strict";function e(Y,Z){for(var $e=0;$e<Z.length;$e++){var ne=Z[$e];ne.enumerable=ne.enumerable||!1,ne.configurable=!0,"value"in ne&&(ne.writable=!0),Object.defineProperty(Y,ne.key,ne)}}function C(Y,Z,$e){return Z&&e(Y.prototype,Z),$e&&e(Y,$e),Object.defineProperty(Y,"prototype",{writable:!1}),Y}function F(Y,Z){if(Y){if(typeof Y=="string")return f(Y,Z);var $e=Object.prototype.toString.call(Y).slice(8,-1);if($e==="Object"&&Y.constructor&&($e=Y.constructor.name),$e==="Map"||$e==="Set")return Array.from(Y);if($e==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test($e))return f(Y,Z)}}function f(Y,Z){(Z==null||Z>Y.length)&&(Z=Y.length);for(var $e=0,ne=new Array(Z);$e<Z;$e++)ne[$e]=Y[$e];return ne}function L(Y,Z){var $e=typeof Symbol<"u"&&Y[Symbol.iterator]||Y["@@iterator"];if($e)return($e=$e.call(Y)).next.bind($e);if(Array.isArray(Y)||($e=F(Y))||Z&&Y&&typeof Y.length=="number"){$e&&(Y=$e);var ne=0;return function(){return ne>=Y.length?{done:!0}:{done:!1,value:Y[ne++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}function M(){return{async:!1,baseUrl:null,breaks:!1,extensions:null,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}me.defaults=M();function b(Y){me.defaults=Y}var v=/[&<>"']/,g=/[&<>"']/g,A=/[<>"']|&(?!#?\w+;)/,I=/[<>"']|&(?!#?\w+;)/g,$={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},y=function(Z){return $[Z]};function k(Y,Z){if(Z){if(v.test(Y))return Y.replace(g,y)}else if(A.test(Y))return Y.replace(I,y);return Y}var w=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function u(Y){return Y.replace(w,function(Z,$e){return $e=$e.toLowerCase(),$e==="colon"?":":$e.charAt(0)==="#"?$e.charAt(1)==="x"?String.fromCharCode(parseInt($e.substring(2),16)):String.fromCharCode(+$e.substring(1)):""})}var o=/(^|[^\[])\^/g;function i(Y,Z){Y=typeof Y=="string"?Y:Y.source,Z=Z||"";var $e={replace:function(fe,te){return te=te.source||te,te=te.replace(o,"$1"),Y=Y.replace(fe,te),$e},getRegex:function(){return new RegExp(Y,Z)}};return $e}var n=/[^\w:]/g,r=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function a(Y,Z,$e){if(Y){var ne;try{ne=decodeURIComponent(u($e)).replace(n,"").toLowerCase()}catch{return null}if(ne.indexOf("javascript:")===0||ne.indexOf("vbscript:")===0||ne.indexOf("data:")===0)return null}Z&&!r.test($e)&&($e=l(Z,$e));try{$e=encodeURI($e).replace(/%25/g,"%")}catch{return null}return $e}var t={},s=/^[^:]+:\/*[^/]*$/,d=/^([^:]+:)[\s\S]*$/,c=/^([^:]+:\/*[^/]*)[\s\S]*$/;function l(Y,Z){t[" "+Y]||(s.test(Y)?t[" "+Y]=Y+"/":t[" "+Y]=m(Y,"/",!0)),Y=t[" "+Y];var $e=Y.indexOf(":")===-1;return Z.substring(0,2)==="//"?$e?Z:Y.replace(d,"$1")+Z:Z.charAt(0)==="/"?$e?Z:Y.replace(c,"$1")+Z:Y+Z}var h={exec:function(){}};function E(Y){for(var Z=1,$e,ne;Z<arguments.length;Z++){$e=arguments[Z];for(ne in $e)Object.prototype.hasOwnProperty.call($e,ne)&&(Y[ne]=$e[ne])}return Y}function D(Y,Z){var $e=Y.replace(/\|/g,function(te,de,pe){for(var Pe=!1,B=de;--B>=0&&pe[B]==="\\";)Pe=!Pe;return Pe?"|":" |"}),ne=$e.split(/ \|/),fe=0;if(ne[0].trim()||ne.shift(),ne.length>0&&!ne[ne.length-1].trim()&&ne.pop(),ne.length>Z)ne.splice(Z);else for(;ne.length<Z;)ne.push("");for(;fe<ne.length;fe++)ne[fe]=ne[fe].trim().replace(/\\\|/g,"|");return ne}function m(Y,Z,$e){var ne=Y.length;if(ne===0)return"";for(var fe=0;fe<ne;){var te=Y.charAt(ne-fe-1);if(te===Z&&!$e)fe++;else if(te!==Z&&$e)fe++;else break}return Y.slice(0,ne-fe)}function p(Y,Z){if(Y.indexOf(Z[1])===-1)return-1;for(var $e=Y.length,ne=0,fe=0;fe<$e;fe++)if(Y[fe]==="\\")fe++;else if(Y[fe]===Z[0])ne++;else if(Y[fe]===Z[1]&&(ne--,ne<0))return fe;return-1}function S(Y){Y&&Y.sanitize&&!Y.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function P(Y,Z){if(Z<1)return"";for(var $e="";Z>1;)Z&1&&($e+=Y),Z>>=1,Y+=Y;return $e+Y}function z(Y,Z,$e,ne){var fe=Z.href,te=Z.title?k(Z.title):null,de=Y[1].replace(/\\([\[\]])/g,"$1");if(Y[0].charAt(0)!=="!"){ne.state.inLink=!0;var pe={type:"link",raw:$e,href:fe,title:te,text:de,tokens:ne.inlineTokens(de)};return ne.state.inLink=!1,pe}return{type:"image",raw:$e,href:fe,title:te,text:k(de)}}function j(Y,Z){var $e=Y.match(/^(\s+)(?:```)/);if($e===null)return Z;var ne=$e[1];return Z.split(`
`).map(function(fe){var te=fe.match(/^\s+/);if(te===null)return fe;var de=te[0];return de.length>=ne.length?fe.slice(ne.length):fe}).join(`
`)}var R=function(){function Y($e){this.options=$e||me.defaults}var Z=Y.prototype;return Z.space=function(ne){var fe=this.rules.block.newline.exec(ne);if(fe&&fe[0].length>0)return{type:"space",raw:fe[0]}},Z.code=function(ne){var fe=this.rules.block.code.exec(ne);if(fe){var te=fe[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:fe[0],codeBlockStyle:"indented",text:this.options.pedantic?te:m(te,`
`)}}},Z.fences=function(ne){var fe=this.rules.block.fences.exec(ne);if(fe){var te=fe[0],de=j(te,fe[3]||"");return{type:"code",raw:te,lang:fe[2]?fe[2].trim():fe[2],text:de}}},Z.heading=function(ne){var fe=this.rules.block.heading.exec(ne);if(fe){var te=fe[2].trim();if(/#$/.test(te)){var de=m(te,"#");(this.options.pedantic||!de||/ $/.test(de))&&(te=de.trim())}return{type:"heading",raw:fe[0],depth:fe[1].length,text:te,tokens:this.lexer.inline(te)}}},Z.hr=function(ne){var fe=this.rules.block.hr.exec(ne);if(fe)return{type:"hr",raw:fe[0]}},Z.blockquote=function(ne){var fe=this.rules.block.blockquote.exec(ne);if(fe){var te=fe[0].replace(/^ *>[ \t]?/gm,"");return{type:"blockquote",raw:fe[0],tokens:this.lexer.blockTokens(te,[]),text:te}}},Z.list=function(ne){var fe=this.rules.block.list.exec(ne);if(fe){var te,de,pe,Pe,B,X,re,ae,ee,ge,ye,je,We=fe[1].trim(),et=We.length>1,Ze={type:"list",raw:"",ordered:et,start:et?+We.slice(0,-1):"",loose:!1,items:[]};We=et?"\\d{1,9}\\"+We.slice(-1):"\\"+We,this.options.pedantic&&(We=et?We:"[*+-]");for(var rt=new RegExp("^( {0,3}"+We+")((?:[	 ][^\\n]*)?(?:\\n|$))");ne&&(je=!1,!(!(fe=rt.exec(ne))||this.rules.block.hr.test(ne)));){if(te=fe[0],ne=ne.substring(te.length),ae=fe[2].split(`
`,1)[0],ee=ne.split(`
`,1)[0],this.options.pedantic?(Pe=2,ye=ae.trimLeft()):(Pe=fe[2].search(/[^ ]/),Pe=Pe>4?1:Pe,ye=ae.slice(Pe),Pe+=fe[1].length),X=!1,!ae&&/^ *$/.test(ee)&&(te+=ee+`
`,ne=ne.substring(ee.length+1),je=!0),!je)for(var nt=new RegExp("^ {0,"+Math.min(3,Pe-1)+"}(?:[*+-]|\\d{1,9}[.)])((?: [^\\n]*)?(?:\\n|$))"),Ae=new RegExp("^ {0,"+Math.min(3,Pe-1)+"}((?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$)"),Oe=new RegExp("^ {0,"+Math.min(3,Pe-1)+"}(?:```|~~~)"),Ve=new RegExp("^ {0,"+Math.min(3,Pe-1)+"}#");ne&&(ge=ne.split(`
`,1)[0],ae=ge,this.options.pedantic&&(ae=ae.replace(/^ {1,4}(?=( {4})*[^ ])/g,"  ")),!(Oe.test(ae)||Ve.test(ae)||nt.test(ae)||Ae.test(ne)));){if(ae.search(/[^ ]/)>=Pe||!ae.trim())ye+=`
`+ae.slice(Pe);else if(!X)ye+=`
`+ae;else break;!X&&!ae.trim()&&(X=!0),te+=ge+`
`,ne=ne.substring(ge.length+1)}Ze.loose||(re?Ze.loose=!0:/\n *\n *$/.test(te)&&(re=!0)),this.options.gfm&&(de=/^\[[ xX]\] /.exec(ye),de&&(pe=de[0]!=="[ ] ",ye=ye.replace(/^\[[ xX]\] +/,""))),Ze.items.push({type:"list_item",raw:te,task:!!de,checked:pe,loose:!1,text:ye}),Ze.raw+=te}Ze.items[Ze.items.length-1].raw=te.trimRight(),Ze.items[Ze.items.length-1].text=ye.trimRight(),Ze.raw=Ze.raw.trimRight();var Le=Ze.items.length;for(B=0;B<Le;B++){this.lexer.state.top=!1,Ze.items[B].tokens=this.lexer.blockTokens(Ze.items[B].text,[]);var Ye=Ze.items[B].tokens.filter(function(ce){return ce.type==="space"}),ue=Ye.every(function(ce){for(var Ie=ce.raw.split(""),Ke=0,Ge=L(Ie),_e;!(_e=Ge()).done;){var st=_e.value;if(st===`
`&&(Ke+=1),Ke>1)return!0}return!1});!Ze.loose&&Ye.length&&ue&&(Ze.loose=!0,Ze.items[B].loose=!0)}return Ze}},Z.html=function(ne){var fe=this.rules.block.html.exec(ne);if(fe){var te={type:"html",raw:fe[0],pre:!this.options.sanitizer&&(fe[1]==="pre"||fe[1]==="script"||fe[1]==="style"),text:fe[0]};if(this.options.sanitize){var de=this.options.sanitizer?this.options.sanitizer(fe[0]):k(fe[0]);te.type="paragraph",te.text=de,te.tokens=this.lexer.inline(de)}return te}},Z.def=function(ne){var fe=this.rules.block.def.exec(ne);if(fe){fe[3]&&(fe[3]=fe[3].substring(1,fe[3].length-1));var te=fe[1].toLowerCase().replace(/\s+/g," ");return{type:"def",tag:te,raw:fe[0],href:fe[2],title:fe[3]}}},Z.table=function(ne){var fe=this.rules.block.table.exec(ne);if(fe){var te={type:"table",header:D(fe[1]).map(function(re){return{text:re}}),align:fe[2].replace(/^ *|\| *$/g,"").split(/ *\| */),rows:fe[3]&&fe[3].trim()?fe[3].replace(/\n[ \t]*$/,"").split(`
`):[]};if(te.header.length===te.align.length){te.raw=fe[0];var de=te.align.length,pe,Pe,B,X;for(pe=0;pe<de;pe++)/^ *-+: *$/.test(te.align[pe])?te.align[pe]="right":/^ *:-+: *$/.test(te.align[pe])?te.align[pe]="center":/^ *:-+ *$/.test(te.align[pe])?te.align[pe]="left":te.align[pe]=null;for(de=te.rows.length,pe=0;pe<de;pe++)te.rows[pe]=D(te.rows[pe],te.header.length).map(function(re){return{text:re}});for(de=te.header.length,Pe=0;Pe<de;Pe++)te.header[Pe].tokens=this.lexer.inline(te.header[Pe].text);for(de=te.rows.length,Pe=0;Pe<de;Pe++)for(X=te.rows[Pe],B=0;B<X.length;B++)X[B].tokens=this.lexer.inline(X[B].text);return te}}},Z.lheading=function(ne){var fe=this.rules.block.lheading.exec(ne);if(fe)return{type:"heading",raw:fe[0],depth:fe[2].charAt(0)==="="?1:2,text:fe[1],tokens:this.lexer.inline(fe[1])}},Z.paragraph=function(ne){var fe=this.rules.block.paragraph.exec(ne);if(fe){var te=fe[1].charAt(fe[1].length-1)===`
`?fe[1].slice(0,-1):fe[1];return{type:"paragraph",raw:fe[0],text:te,tokens:this.lexer.inline(te)}}},Z.text=function(ne){var fe=this.rules.block.text.exec(ne);if(fe)return{type:"text",raw:fe[0],text:fe[0],tokens:this.lexer.inline(fe[0])}},Z.escape=function(ne){var fe=this.rules.inline.escape.exec(ne);if(fe)return{type:"escape",raw:fe[0],text:k(fe[1])}},Z.tag=function(ne){var fe=this.rules.inline.tag.exec(ne);if(fe)return!this.lexer.state.inLink&&/^<a /i.test(fe[0])?this.lexer.state.inLink=!0:this.lexer.state.inLink&&/^<\/a>/i.test(fe[0])&&(this.lexer.state.inLink=!1),!this.lexer.state.inRawBlock&&/^<(pre|code|kbd|script)(\s|>)/i.test(fe[0])?this.lexer.state.inRawBlock=!0:this.lexer.state.inRawBlock&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(fe[0])&&(this.lexer.state.inRawBlock=!1),{type:this.options.sanitize?"text":"html",raw:fe[0],inLink:this.lexer.state.inLink,inRawBlock:this.lexer.state.inRawBlock,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(fe[0]):k(fe[0]):fe[0]}},Z.link=function(ne){var fe=this.rules.inline.link.exec(ne);if(fe){var te=fe[2].trim();if(!this.options.pedantic&&/^</.test(te)){if(!/>$/.test(te))return;var de=m(te.slice(0,-1),"\\");if((te.length-de.length)%2===0)return}else{var pe=p(fe[2],"()");if(pe>-1){var Pe=fe[0].indexOf("!")===0?5:4,B=Pe+fe[1].length+pe;fe[2]=fe[2].substring(0,pe),fe[0]=fe[0].substring(0,B).trim(),fe[3]=""}}var X=fe[2],re="";if(this.options.pedantic){var ae=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(X);ae&&(X=ae[1],re=ae[3])}else re=fe[3]?fe[3].slice(1,-1):"";return X=X.trim(),/^</.test(X)&&(this.options.pedantic&&!/>$/.test(te)?X=X.slice(1):X=X.slice(1,-1)),z(fe,{href:X&&X.replace(this.rules.inline._escapes,"$1"),title:re&&re.replace(this.rules.inline._escapes,"$1")},fe[0],this.lexer)}},Z.reflink=function(ne,fe){var te;if((te=this.rules.inline.reflink.exec(ne))||(te=this.rules.inline.nolink.exec(ne))){var de=(te[2]||te[1]).replace(/\s+/g," ");if(de=fe[de.toLowerCase()],!de||!de.href){var pe=te[0].charAt(0);return{type:"text",raw:pe,text:pe}}return z(te,de,te[0],this.lexer)}},Z.emStrong=function(ne,fe,te){te===void 0&&(te="");var de=this.rules.inline.emStrong.lDelim.exec(ne);if(de&&!(de[3]&&te.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u0870-\u0887\u0889-\u088E\u08A0-\u08C9\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C5D\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u1711\u171F-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4C\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7CA\uA7D0\uA7D1\uA7D3\uA7D5-\uA7D9\uA7F2-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDD70-\uDD7A\uDD7C-\uDD8A\uDD8C-\uDD92\uDD94\uDD95\uDD97-\uDDA1\uDDA3-\uDDB1\uDDB3-\uDDB9\uDDBB\uDDBC\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67\uDF80-\uDF85\uDF87-\uDFB0\uDFB2-\uDFBA]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDF70-\uDF81\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC71\uDC72\uDC75\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B\uDF40-\uDF46]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEB0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|\uD80B[\uDF90-\uDFF0]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDE70-\uDEBE\uDEC0-\uDEC9\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82B[\uDFF0-\uDFF3\uDFF5-\uDFFB\uDFFD\uDFFE]|\uD82C[\uDC00-\uDD22\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD837[\uDF00-\uDF1E]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDE90-\uDEAD\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD839[\uDFE0-\uDFE6\uDFE8-\uDFEB\uDFED\uDFEE\uDFF0-\uDFFE]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDF\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF38\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var pe=de[1]||de[2]||"";if(!pe||pe&&(te===""||this.rules.inline.punctuation.exec(te))){var Pe=de[0].length-1,B,X,re=Pe,ae=0,ee=de[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(ee.lastIndex=0,fe=fe.slice(-1*ne.length+Pe);(de=ee.exec(fe))!=null;)if(B=de[1]||de[2]||de[3]||de[4]||de[5]||de[6],!!B){if(X=B.length,de[3]||de[4]){re+=X;continue}else if((de[5]||de[6])&&Pe%3&&!((Pe+X)%3)){ae+=X;continue}if(re-=X,!(re>0)){if(X=Math.min(X,X+re+ae),Math.min(Pe,X)%2){var ge=ne.slice(1,Pe+de.index+X);return{type:"em",raw:ne.slice(0,Pe+de.index+X+1),text:ge,tokens:this.lexer.inlineTokens(ge)}}var ye=ne.slice(2,Pe+de.index+X-1);return{type:"strong",raw:ne.slice(0,Pe+de.index+X+1),text:ye,tokens:this.lexer.inlineTokens(ye)}}}}}},Z.codespan=function(ne){var fe=this.rules.inline.code.exec(ne);if(fe){var te=fe[2].replace(/\n/g," "),de=/[^ ]/.test(te),pe=/^ /.test(te)&&/ $/.test(te);return de&&pe&&(te=te.substring(1,te.length-1)),te=k(te,!0),{type:"codespan",raw:fe[0],text:te}}},Z.br=function(ne){var fe=this.rules.inline.br.exec(ne);if(fe)return{type:"br",raw:fe[0]}},Z.del=function(ne){var fe=this.rules.inline.del.exec(ne);if(fe)return{type:"del",raw:fe[0],text:fe[2],tokens:this.lexer.inlineTokens(fe[2])}},Z.autolink=function(ne,fe){var te=this.rules.inline.autolink.exec(ne);if(te){var de,pe;return te[2]==="@"?(de=k(this.options.mangle?fe(te[1]):te[1]),pe="mailto:"+de):(de=k(te[1]),pe=de),{type:"link",raw:te[0],text:de,href:pe,tokens:[{type:"text",raw:de,text:de}]}}},Z.url=function(ne,fe){var te;if(te=this.rules.inline.url.exec(ne)){var de,pe;if(te[2]==="@")de=k(this.options.mangle?fe(te[0]):te[0]),pe="mailto:"+de;else{var Pe;do Pe=te[0],te[0]=this.rules.inline._backpedal.exec(te[0])[0];while(Pe!==te[0]);de=k(te[0]),te[1]==="www."?pe="http://"+de:pe=de}return{type:"link",raw:te[0],text:de,href:pe,tokens:[{type:"text",raw:de,text:de}]}}},Z.inlineText=function(ne,fe){var te=this.rules.inline.text.exec(ne);if(te){var de;return this.lexer.state.inRawBlock?de=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(te[0]):k(te[0]):te[0]:de=k(this.options.smartypants?fe(te[0]):te[0]),{type:"text",raw:te[0],text:de}}},Y}(),T={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?=\n|$)|$)/,hr:/^ {0,3}((?:-[\t ]*){3,}|(?:_[ \t]*){3,}|(?:\*[ \t]*){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3}bull)([ \t][^\n]+?)?(?:\n|$)/,html:"^ {0,3}(?:<(script|pre|style|textarea)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:(?:\\n *)+\\n|$)|<(?!script|pre|style|textarea)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$)|</(?!script|pre|style|textarea)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$))",def:/^ {0,3}\[(label)\]: *(?:\n *)?<?([^\s>]+)>?(?:(?: +(?:\n *)?| *\n *)(title))? *(?:\n+|$)/,table:h,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html|table| +\n)[^\n]+)*)/,text:/^[^\n]+/};T._label=/(?!\s*\])(?:\\.|[^\[\]\\])+/,T._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,T.def=i(T.def).replace("label",T._label).replace("title",T._title).getRegex(),T.bullet=/(?:[*+-]|\d{1,9}[.)])/,T.listItemStart=i(/^( *)(bull) */).replace("bull",T.bullet).getRegex(),T.list=i(T.list).replace(/bull/g,T.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+T.def.source+")").getRegex(),T._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",T._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,T.html=i(T.html,"i").replace("comment",T._comment).replace("tag",T._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),T.paragraph=i(T._paragraph).replace("hr",T.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("|table","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",T._tag).getRegex(),T.blockquote=i(T.blockquote).replace("paragraph",T.paragraph).getRegex(),T.normal=E({},T),T.gfm=E({},T.normal,{table:"^ *([^\\n ].*\\|.*)\\n {0,3}(?:\\| *)?(:?-+:? *(?:\\| *:?-+:? *)*)(?:\\| *)?(?:\\n((?:(?! *\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),T.gfm.table=i(T.gfm.table).replace("hr",T.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",T._tag).getRegex(),T.gfm.paragraph=i(T._paragraph).replace("hr",T.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("table",T.gfm.table).replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",T._tag).getRegex(),T.pedantic=E({},T.normal,{html:i(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",T._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:h,paragraph:i(T.normal._paragraph).replace("hr",T.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",T.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var N={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:h,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(ref)\]/,nolink:/^!?\[(ref)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/^[^_*]*?\_\_[^_*]*?\*[^_*]*?(?=\_\_)|[^*]+(?=[^*])|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/^[^_*]*?\*\*[^_*]*?\_[^_*]*?(?=\*\*)|[^_]+(?=[^_])|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:h,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};N._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",N.punctuation=i(N.punctuation).replace(/punctuation/g,N._punctuation).getRegex(),N.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,N.escapedEmSt=/\\\*|\\_/g,N._comment=i(T._comment).replace("(?:-->|$)","-->").getRegex(),N.emStrong.lDelim=i(N.emStrong.lDelim).replace(/punct/g,N._punctuation).getRegex(),N.emStrong.rDelimAst=i(N.emStrong.rDelimAst,"g").replace(/punct/g,N._punctuation).getRegex(),N.emStrong.rDelimUnd=i(N.emStrong.rDelimUnd,"g").replace(/punct/g,N._punctuation).getRegex(),N._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,N._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,N._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,N.autolink=i(N.autolink).replace("scheme",N._scheme).replace("email",N._email).getRegex(),N._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,N.tag=i(N.tag).replace("comment",N._comment).replace("attribute",N._attribute).getRegex(),N._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,N._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,N._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,N.link=i(N.link).replace("label",N._label).replace("href",N._href).replace("title",N._title).getRegex(),N.reflink=i(N.reflink).replace("label",N._label).replace("ref",T._label).getRegex(),N.nolink=i(N.nolink).replace("ref",T._label).getRegex(),N.reflinkSearch=i(N.reflinkSearch,"g").replace("reflink",N.reflink).replace("nolink",N.nolink).getRegex(),N.normal=E({},N),N.pedantic=E({},N.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:i(/^!?\[(label)\]\((.*?)\)/).replace("label",N._label).getRegex(),reflink:i(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",N._label).getRegex()}),N.gfm=E({},N.normal,{escape:i(N.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)))/}),N.gfm.url=i(N.gfm.url,"i").replace("email",N.gfm._extended_email).getRegex(),N.breaks=E({},N.gfm,{br:i(N.br).replace("{2,}","*").getRegex(),text:i(N.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});function O(Y){return Y.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function W(Y){var Z="",$e,ne,fe=Y.length;for($e=0;$e<fe;$e++)ne=Y.charCodeAt($e),Math.random()>.5&&(ne="x"+ne.toString(16)),Z+="&#"+ne+";";return Z}var x=function(){function Y($e){this.tokens=[],this.tokens.links=Object.create(null),this.options=$e||me.defaults,this.options.tokenizer=this.options.tokenizer||new R,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options,this.tokenizer.lexer=this,this.inlineQueue=[],this.state={inLink:!1,inRawBlock:!1,top:!0};var ne={block:T.normal,inline:N.normal};this.options.pedantic?(ne.block=T.pedantic,ne.inline=N.pedantic):this.options.gfm&&(ne.block=T.gfm,this.options.breaks?ne.inline=N.breaks:ne.inline=N.gfm),this.tokenizer.rules=ne}Y.lex=function(ne,fe){var te=new Y(fe);return te.lex(ne)},Y.lexInline=function(ne,fe){var te=new Y(fe);return te.inlineTokens(ne)};var Z=Y.prototype;return Z.lex=function(ne){ne=ne.replace(/\r\n|\r/g,`
`),this.blockTokens(ne,this.tokens);for(var fe;fe=this.inlineQueue.shift();)this.inlineTokens(fe.src,fe.tokens);return this.tokens},Z.blockTokens=function(ne,fe){var te=this;fe===void 0&&(fe=[]),this.options.pedantic?ne=ne.replace(/\t/g,"    ").replace(/^ +$/gm,""):ne=ne.replace(/^( *)(\t+)/gm,function(re,ae,ee){return ae+"    ".repeat(ee.length)});for(var de,pe,Pe,B;ne;)if(!(this.options.extensions&&this.options.extensions.block&&this.options.extensions.block.some(function(re){return(de=re.call({lexer:te},ne,fe))?(ne=ne.substring(de.raw.length),fe.push(de),!0):!1}))){if(de=this.tokenizer.space(ne)){ne=ne.substring(de.raw.length),de.raw.length===1&&fe.length>0?fe[fe.length-1].raw+=`
`:fe.push(de);continue}if(de=this.tokenizer.code(ne)){ne=ne.substring(de.raw.length),pe=fe[fe.length-1],pe&&(pe.type==="paragraph"||pe.type==="text")?(pe.raw+=`
`+de.raw,pe.text+=`
`+de.text,this.inlineQueue[this.inlineQueue.length-1].src=pe.text):fe.push(de);continue}if(de=this.tokenizer.fences(ne)){ne=ne.substring(de.raw.length),fe.push(de);continue}if(de=this.tokenizer.heading(ne)){ne=ne.substring(de.raw.length),fe.push(de);continue}if(de=this.tokenizer.hr(ne)){ne=ne.substring(de.raw.length),fe.push(de);continue}if(de=this.tokenizer.blockquote(ne)){ne=ne.substring(de.raw.length),fe.push(de);continue}if(de=this.tokenizer.list(ne)){ne=ne.substring(de.raw.length),fe.push(de);continue}if(de=this.tokenizer.html(ne)){ne=ne.substring(de.raw.length),fe.push(de);continue}if(de=this.tokenizer.def(ne)){ne=ne.substring(de.raw.length),pe=fe[fe.length-1],pe&&(pe.type==="paragraph"||pe.type==="text")?(pe.raw+=`
`+de.raw,pe.text+=`
`+de.raw,this.inlineQueue[this.inlineQueue.length-1].src=pe.text):this.tokens.links[de.tag]||(this.tokens.links[de.tag]={href:de.href,title:de.title});continue}if(de=this.tokenizer.table(ne)){ne=ne.substring(de.raw.length),fe.push(de);continue}if(de=this.tokenizer.lheading(ne)){ne=ne.substring(de.raw.length),fe.push(de);continue}if(Pe=ne,this.options.extensions&&this.options.extensions.startBlock&&function(){var re=1/0,ae=ne.slice(1),ee=void 0;te.options.extensions.startBlock.forEach(function(ge){ee=ge.call({lexer:this},ae),typeof ee=="number"&&ee>=0&&(re=Math.min(re,ee))}),re<1/0&&re>=0&&(Pe=ne.substring(0,re+1))}(),this.state.top&&(de=this.tokenizer.paragraph(Pe))){pe=fe[fe.length-1],B&&pe.type==="paragraph"?(pe.raw+=`
`+de.raw,pe.text+=`
`+de.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=pe.text):fe.push(de),B=Pe.length!==ne.length,ne=ne.substring(de.raw.length);continue}if(de=this.tokenizer.text(ne)){ne=ne.substring(de.raw.length),pe=fe[fe.length-1],pe&&pe.type==="text"?(pe.raw+=`
`+de.raw,pe.text+=`
`+de.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=pe.text):fe.push(de);continue}if(ne){var X="Infinite loop on byte: "+ne.charCodeAt(0);if(this.options.silent){console.error(X);break}else throw new Error(X)}}return this.state.top=!0,fe},Z.inline=function(ne,fe){return fe===void 0&&(fe=[]),this.inlineQueue.push({src:ne,tokens:fe}),fe},Z.inlineTokens=function(ne,fe){var te=this;fe===void 0&&(fe=[]);var de,pe,Pe,B=ne,X,re,ae;if(this.tokens.links){var ee=Object.keys(this.tokens.links);if(ee.length>0)for(;(X=this.tokenizer.rules.inline.reflinkSearch.exec(B))!=null;)ee.includes(X[0].slice(X[0].lastIndexOf("[")+1,-1))&&(B=B.slice(0,X.index)+"["+P("a",X[0].length-2)+"]"+B.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(X=this.tokenizer.rules.inline.blockSkip.exec(B))!=null;)B=B.slice(0,X.index)+"["+P("a",X[0].length-2)+"]"+B.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(X=this.tokenizer.rules.inline.escapedEmSt.exec(B))!=null;)B=B.slice(0,X.index)+"++"+B.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;ne;)if(re||(ae=""),re=!1,!(this.options.extensions&&this.options.extensions.inline&&this.options.extensions.inline.some(function(ye){return(de=ye.call({lexer:te},ne,fe))?(ne=ne.substring(de.raw.length),fe.push(de),!0):!1}))){if(de=this.tokenizer.escape(ne)){ne=ne.substring(de.raw.length),fe.push(de);continue}if(de=this.tokenizer.tag(ne)){ne=ne.substring(de.raw.length),pe=fe[fe.length-1],pe&&de.type==="text"&&pe.type==="text"?(pe.raw+=de.raw,pe.text+=de.text):fe.push(de);continue}if(de=this.tokenizer.link(ne)){ne=ne.substring(de.raw.length),fe.push(de);continue}if(de=this.tokenizer.reflink(ne,this.tokens.links)){ne=ne.substring(de.raw.length),pe=fe[fe.length-1],pe&&de.type==="text"&&pe.type==="text"?(pe.raw+=de.raw,pe.text+=de.text):fe.push(de);continue}if(de=this.tokenizer.emStrong(ne,B,ae)){ne=ne.substring(de.raw.length),fe.push(de);continue}if(de=this.tokenizer.codespan(ne)){ne=ne.substring(de.raw.length),fe.push(de);continue}if(de=this.tokenizer.br(ne)){ne=ne.substring(de.raw.length),fe.push(de);continue}if(de=this.tokenizer.del(ne)){ne=ne.substring(de.raw.length),fe.push(de);continue}if(de=this.tokenizer.autolink(ne,W)){ne=ne.substring(de.raw.length),fe.push(de);continue}if(!this.state.inLink&&(de=this.tokenizer.url(ne,W))){ne=ne.substring(de.raw.length),fe.push(de);continue}if(Pe=ne,this.options.extensions&&this.options.extensions.startInline&&function(){var ye=1/0,je=ne.slice(1),We=void 0;te.options.extensions.startInline.forEach(function(et){We=et.call({lexer:this},je),typeof We=="number"&&We>=0&&(ye=Math.min(ye,We))}),ye<1/0&&ye>=0&&(Pe=ne.substring(0,ye+1))}(),de=this.tokenizer.inlineText(Pe,O)){ne=ne.substring(de.raw.length),de.raw.slice(-1)!=="_"&&(ae=de.raw.slice(-1)),re=!0,pe=fe[fe.length-1],pe&&pe.type==="text"?(pe.raw+=de.raw,pe.text+=de.text):fe.push(de);continue}if(ne){var ge="Infinite loop on byte: "+ne.charCodeAt(0);if(this.options.silent){console.error(ge);break}else throw new Error(ge)}}return fe},C(Y,null,[{key:"rules",get:function(){return{block:T,inline:N}}}]),Y}(),le=function(){function Y($e){this.options=$e||me.defaults}var Z=Y.prototype;return Z.code=function(ne,fe,te){var de=(fe||"").match(/\S*/)[0];if(this.options.highlight){var pe=this.options.highlight(ne,de);pe!=null&&pe!==ne&&(te=!0,ne=pe)}return ne=ne.replace(/\n$/,"")+`
`,de?'<pre><code class="'+this.options.langPrefix+k(de,!0)+'">'+(te?ne:k(ne,!0))+`</code></pre>
`:"<pre><code>"+(te?ne:k(ne,!0))+`</code></pre>
`},Z.blockquote=function(ne){return`<blockquote>
`+ne+`</blockquote>
`},Z.html=function(ne){return ne},Z.heading=function(ne,fe,te,de){if(this.options.headerIds){var pe=this.options.headerPrefix+de.slug(te);return"<h"+fe+' id="'+pe+'">'+ne+"</h"+fe+`>
`}return"<h"+fe+">"+ne+"</h"+fe+`>
`},Z.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},Z.list=function(ne,fe,te){var de=fe?"ol":"ul",pe=fe&&te!==1?' start="'+te+'"':"";return"<"+de+pe+`>
`+ne+"</"+de+`>
`},Z.listitem=function(ne){return"<li>"+ne+`</li>
`},Z.checkbox=function(ne){return"<input "+(ne?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},Z.paragraph=function(ne){return"<p>"+ne+`</p>
`},Z.table=function(ne,fe){return fe&&(fe="<tbody>"+fe+"</tbody>"),`<table>
<thead>
`+ne+`</thead>
`+fe+`</table>
`},Z.tablerow=function(ne){return`<tr>
`+ne+`</tr>
`},Z.tablecell=function(ne,fe){var te=fe.header?"th":"td",de=fe.align?"<"+te+' align="'+fe.align+'">':"<"+te+">";return de+ne+("</"+te+`>
`)},Z.strong=function(ne){return"<strong>"+ne+"</strong>"},Z.em=function(ne){return"<em>"+ne+"</em>"},Z.codespan=function(ne){return"<code>"+ne+"</code>"},Z.br=function(){return this.options.xhtml?"<br/>":"<br>"},Z.del=function(ne){return"<del>"+ne+"</del>"},Z.link=function(ne,fe,te){if(ne=a(this.options.sanitize,this.options.baseUrl,ne),ne===null)return te;var de='<a href="'+k(ne)+'"';return fe&&(de+=' title="'+fe+'"'),de+=">"+te+"</a>",de},Z.image=function(ne,fe,te){if(ne=a(this.options.sanitize,this.options.baseUrl,ne),ne===null)return te;var de='<img src="'+ne+'" alt="'+te+'"';return fe&&(de+=' title="'+fe+'"'),de+=this.options.xhtml?"/>":">",de},Z.text=function(ne){return ne},Y}(),G=function(){function Y(){}var Z=Y.prototype;return Z.strong=function(ne){return ne},Z.em=function(ne){return ne},Z.codespan=function(ne){return ne},Z.del=function(ne){return ne},Z.html=function(ne){return ne},Z.text=function(ne){return ne},Z.link=function(ne,fe,te){return""+te},Z.image=function(ne,fe,te){return""+te},Z.br=function(){return""},Y}(),J=function(){function Y(){this.seen={}}var Z=Y.prototype;return Z.serialize=function(ne){return ne.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},Z.getNextSafeSlug=function(ne,fe){var te=ne,de=0;if(this.seen.hasOwnProperty(te)){de=this.seen[ne];do de++,te=ne+"-"+de;while(this.seen.hasOwnProperty(te))}return fe||(this.seen[ne]=de,this.seen[te]=0),te},Z.slug=function(ne,fe){fe===void 0&&(fe={});var te=this.serialize(ne);return this.getNextSafeSlug(te,fe.dryrun)},Y}(),Q=function(){function Y($e){this.options=$e||me.defaults,this.options.renderer=this.options.renderer||new le,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new G,this.slugger=new J}Y.parse=function(ne,fe){var te=new Y(fe);return te.parse(ne)},Y.parseInline=function(ne,fe){var te=new Y(fe);return te.parseInline(ne)};var Z=Y.prototype;return Z.parse=function(ne,fe){fe===void 0&&(fe=!0);var te="",de,pe,Pe,B,X,re,ae,ee,ge,ye,je,We,et,Ze,rt,nt,Ae,Oe,Ve,Le=ne.length;for(de=0;de<Le;de++){if(ye=ne[de],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[ye.type]&&(Ve=this.options.extensions.renderers[ye.type].call({parser:this},ye),Ve!==!1||!["space","hr","heading","code","table","blockquote","list","html","paragraph","text"].includes(ye.type))){te+=Ve||"";continue}switch(ye.type){case"space":continue;case"hr":{te+=this.renderer.hr();continue}case"heading":{te+=this.renderer.heading(this.parseInline(ye.tokens),ye.depth,u(this.parseInline(ye.tokens,this.textRenderer)),this.slugger);continue}case"code":{te+=this.renderer.code(ye.text,ye.lang,ye.escaped);continue}case"table":{for(ee="",ae="",B=ye.header.length,pe=0;pe<B;pe++)ae+=this.renderer.tablecell(this.parseInline(ye.header[pe].tokens),{header:!0,align:ye.align[pe]});for(ee+=this.renderer.tablerow(ae),ge="",B=ye.rows.length,pe=0;pe<B;pe++){for(re=ye.rows[pe],ae="",X=re.length,Pe=0;Pe<X;Pe++)ae+=this.renderer.tablecell(this.parseInline(re[Pe].tokens),{header:!1,align:ye.align[Pe]});ge+=this.renderer.tablerow(ae)}te+=this.renderer.table(ee,ge);continue}case"blockquote":{ge=this.parse(ye.tokens),te+=this.renderer.blockquote(ge);continue}case"list":{for(je=ye.ordered,We=ye.start,et=ye.loose,B=ye.items.length,ge="",pe=0;pe<B;pe++)rt=ye.items[pe],nt=rt.checked,Ae=rt.task,Ze="",rt.task&&(Oe=this.renderer.checkbox(nt),et?rt.tokens.length>0&&rt.tokens[0].type==="paragraph"?(rt.tokens[0].text=Oe+" "+rt.tokens[0].text,rt.tokens[0].tokens&&rt.tokens[0].tokens.length>0&&rt.tokens[0].tokens[0].type==="text"&&(rt.tokens[0].tokens[0].text=Oe+" "+rt.tokens[0].tokens[0].text)):rt.tokens.unshift({type:"text",text:Oe}):Ze+=Oe),Ze+=this.parse(rt.tokens,et),ge+=this.renderer.listitem(Ze,Ae,nt);te+=this.renderer.list(ge,je,We);continue}case"html":{te+=this.renderer.html(ye.text);continue}case"paragraph":{te+=this.renderer.paragraph(this.parseInline(ye.tokens));continue}case"text":{for(ge=ye.tokens?this.parseInline(ye.tokens):ye.text;de+1<Le&&ne[de+1].type==="text";)ye=ne[++de],ge+=`
`+(ye.tokens?this.parseInline(ye.tokens):ye.text);te+=fe?this.renderer.paragraph(ge):ge;continue}default:{var Ye='Token with "'+ye.type+'" type was not found.';if(this.options.silent){console.error(Ye);return}else throw new Error(Ye)}}}return te},Z.parseInline=function(ne,fe){fe=fe||this.renderer;var te="",de,pe,Pe,B=ne.length;for(de=0;de<B;de++){if(pe=ne[de],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[pe.type]&&(Pe=this.options.extensions.renderers[pe.type].call({parser:this},pe),Pe!==!1||!["escape","html","link","image","strong","em","codespan","br","del","text"].includes(pe.type))){te+=Pe||"";continue}switch(pe.type){case"escape":{te+=fe.text(pe.text);break}case"html":{te+=fe.html(pe.text);break}case"link":{te+=fe.link(pe.href,pe.title,this.parseInline(pe.tokens,fe));break}case"image":{te+=fe.image(pe.href,pe.title,pe.text);break}case"strong":{te+=fe.strong(this.parseInline(pe.tokens,fe));break}case"em":{te+=fe.em(this.parseInline(pe.tokens,fe));break}case"codespan":{te+=fe.codespan(pe.text);break}case"br":{te+=fe.br();break}case"del":{te+=fe.del(this.parseInline(pe.tokens,fe));break}case"text":{te+=fe.text(pe.text);break}default:{var X='Token with "'+pe.type+'" type was not found.';if(this.options.silent){console.error(X);return}else throw new Error(X)}}}return te},Y}();function oe(Y,Z,$e){if(typeof Y>"u"||Y===null)throw new Error("marked(): input parameter is undefined or null");if(typeof Y!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(Y)+", string expected");if(typeof Z=="function"&&($e=Z,Z=null),Z=E({},oe.defaults,Z||{}),S(Z),$e){var ne=Z.highlight,fe;try{fe=x.lex(Y,Z)}catch(B){return $e(B)}var te=function(X){var re;if(!X)try{Z.walkTokens&&oe.walkTokens(fe,Z.walkTokens),re=Q.parse(fe,Z)}catch(ae){X=ae}return Z.highlight=ne,X?$e(X):$e(null,re)};if(!ne||ne.length<3||(delete Z.highlight,!fe.length))return te();var de=0;oe.walkTokens(fe,function(B){B.type==="code"&&(de++,setTimeout(function(){ne(B.text,B.lang,function(X,re){if(X)return te(X);re!=null&&re!==B.text&&(B.text=re,B.escaped=!0),de--,de===0&&te()})},0))}),de===0&&te();return}function pe(B){if(B.message+=`
Please report this to https://github.com/markedjs/marked.`,Z.silent)return"<p>An error occurred:</p><pre>"+k(B.message+"",!0)+"</pre>";throw B}try{var Pe=x.lex(Y,Z);if(Z.walkTokens){if(Z.async)return Promise.all(oe.walkTokens(Pe,Z.walkTokens)).then(function(){return Q.parse(Pe,Z)}).catch(pe);oe.walkTokens(Pe,Z.walkTokens)}return Q.parse(Pe,Z)}catch(B){pe(B)}}oe.options=oe.setOptions=function(Y){return E(oe.defaults,Y),b(oe.defaults),oe},oe.getDefaults=M,oe.defaults=me.defaults,oe.use=function(){for(var Y=arguments.length,Z=new Array(Y),$e=0;$e<Y;$e++)Z[$e]=arguments[$e];var ne=E.apply(void 0,[{}].concat(Z)),fe=oe.defaults.extensions||{renderers:{},childTokens:{}},te;Z.forEach(function(de){if(de.extensions&&(te=!0,de.extensions.forEach(function(Pe){if(!Pe.name)throw new Error("extension name required");if(Pe.renderer){var B=fe.renderers?fe.renderers[Pe.name]:null;B?fe.renderers[Pe.name]=function(){for(var X=arguments.length,re=new Array(X),ae=0;ae<X;ae++)re[ae]=arguments[ae];var ee=Pe.renderer.apply(this,re);return ee===!1&&(ee=B.apply(this,re)),ee}:fe.renderers[Pe.name]=Pe.renderer}if(Pe.tokenizer){if(!Pe.level||Pe.level!=="block"&&Pe.level!=="inline")throw new Error("extension level must be 'block' or 'inline'");fe[Pe.level]?fe[Pe.level].unshift(Pe.tokenizer):fe[Pe.level]=[Pe.tokenizer],Pe.start&&(Pe.level==="block"?fe.startBlock?fe.startBlock.push(Pe.start):fe.startBlock=[Pe.start]:Pe.level==="inline"&&(fe.startInline?fe.startInline.push(Pe.start):fe.startInline=[Pe.start]))}Pe.childTokens&&(fe.childTokens[Pe.name]=Pe.childTokens)})),de.renderer&&function(){var Pe=oe.defaults.renderer||new le,B=function(ae){var ee=Pe[ae];Pe[ae]=function(){for(var ge=arguments.length,ye=new Array(ge),je=0;je<ge;je++)ye[je]=arguments[je];var We=de.renderer[ae].apply(Pe,ye);return We===!1&&(We=ee.apply(Pe,ye)),We}};for(var X in de.renderer)B(X);ne.renderer=Pe}(),de.tokenizer&&function(){var Pe=oe.defaults.tokenizer||new R,B=function(ae){var ee=Pe[ae];Pe[ae]=function(){for(var ge=arguments.length,ye=new Array(ge),je=0;je<ge;je++)ye[je]=arguments[je];var We=de.tokenizer[ae].apply(Pe,ye);return We===!1&&(We=ee.apply(Pe,ye)),We}};for(var X in de.tokenizer)B(X);ne.tokenizer=Pe}(),de.walkTokens){var pe=oe.defaults.walkTokens;ne.walkTokens=function(Pe){var B=[];return B.push(de.walkTokens.call(this,Pe)),pe&&(B=B.concat(pe.call(this,Pe))),B}}te&&(ne.extensions=fe),oe.setOptions(ne)})},oe.walkTokens=function(Y,Z){for(var $e=[],ne=function(){var pe=te.value;switch($e=$e.concat(Z.call(oe,pe)),pe.type){case"table":{for(var Pe=L(pe.header),B;!(B=Pe()).done;){var X=B.value;$e=$e.concat(oe.walkTokens(X.tokens,Z))}for(var re=L(pe.rows),ae;!(ae=re()).done;)for(var ee=ae.value,ge=L(ee),ye;!(ye=ge()).done;){var je=ye.value;$e=$e.concat(oe.walkTokens(je.tokens,Z))}break}case"list":{$e=$e.concat(oe.walkTokens(pe.items,Z));break}default:oe.defaults.extensions&&oe.defaults.extensions.childTokens&&oe.defaults.extensions.childTokens[pe.type]?oe.defaults.extensions.childTokens[pe.type].forEach(function(We){$e=$e.concat(oe.walkTokens(pe[We],Z))}):pe.tokens&&($e=$e.concat(oe.walkTokens(pe.tokens,Z)))}},fe=L(Y),te;!(te=fe()).done;)ne();return $e},oe.parseInline=function(Y,Z){if(typeof Y>"u"||Y===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof Y!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(Y)+", string expected");Z=E({},oe.defaults,Z||{}),S(Z);try{var $e=x.lexInline(Y,Z);return Z.walkTokens&&oe.walkTokens($e,Z.walkTokens),Q.parseInline($e,Z)}catch(ne){if(ne.message+=`
Please report this to https://github.com/markedjs/marked.`,Z.silent)return"<p>An error occurred:</p><pre>"+k(ne.message+"",!0)+"</pre>";throw ne}},oe.Parser=Q,oe.parser=Q.parse,oe.Renderer=le,oe.TextRenderer=G,oe.Lexer=x,oe.lexer=x.lex,oe.Tokenizer=R,oe.Slugger=J,oe.parse=oe;var _=oe.options,Ee=oe.setOptions,he=oe.use,q=oe.walkTokens,U=oe.parseInline,ie=oe,be=Q.parse,H=x.lex;me.Lexer=x,me.Parser=Q,me.Renderer=le,me.Slugger=J,me.TextRenderer=G,me.Tokenizer=R,me.getDefaults=M,me.lexer=H,me.marked=oe,me.options=_,me.parse=ie,me.parseInline=U,me.parser=be,me.setOptions=Ee,me.use=he,me.walkTokens=q,Object.defineProperty(me,"__esModule",{value:!0})}),define(ke[76],Se([1,0,28]),function(me,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wl=e.$vl=e.$ul=void 0;const F=new C.$Cc(1e4);function f(g){return v(g,"NFC",F)}e.$ul=f;const L=new C.$Cc(1e4);function M(g){return v(g,"NFD",L)}e.$vl=M;const b=/[^\u0000-\u0080]/;function v(g,A,I){if(!g)return g;const $=I.get(g);if($)return $;let y;return b.test(g)?y=g.normalize(A):y=g,I.set(g,y),y}e.$wl=function(){const g=/[\u0300-\u036f]/g;return function(A){return M(A).replace(g,"")}}()}),define(ke[123],Se([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yl=e.$Xl=e.$Wl=e.rot=e.$Ul=void 0;function C(b,v,g){return Math.min(Math.max(b,v),g)}e.$Ul=C;function F(b,v){return(v+b%v)%v}e.rot=F;class f{constructor(){this.a=0}getNext(){return this.a++}}e.$Wl=f;class L{constructor(){this.a=1,this.b=0}update(v){return this.b=this.b+(v-this.b)/this.a,this.a+=1,this.b}get value(){return this.b}}e.$Xl=L;class M{constructor(v){this.a=0,this.b=0,this.c=[],this.d=0,this.e=0,this.c=new Array(v),this.c.fill(0,0,v)}update(v){const g=this.c[this.d];return this.c[this.d]=v,this.d=(this.d+1)%this.c.length,this.e-=g,this.e+=v,this.a<this.c.length&&(this.a+=1),this.b=this.e/this.a,this.b}get value(){return this.b}}e.$Yl=M}),function(){function me(f){const L=[];typeof f=="number"&&L.push("code/timeOrigin",f);function M(v){L.push(v,Date.now())}function b(){const v=[];for(let g=0;g<L.length;g+=2)v.push({name:L[g],startTime:L[g+1]});return v}return{mark:M,getMarks:b}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?me():{mark(f){performance.mark(f)},getMarks(){let f=performance.timeOrigin;typeof f!="number"&&(f=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const L=[{name:"code/timeOrigin",startTime:Math.round(f)}];for(const M of performance.getEntriesByType("mark"))L.push({name:M.name,startTime:Math.round(f+M.startTime)});return L}};if(typeof process=="object"){const f=performance?.timeOrigin??Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return me(f)}else return console.trace("perf-util loaded in UNKNOWN environment"),me()}function C(f){return f.MonacoPerformanceMarks||(f.MonacoPerformanceMarks=e()),f.MonacoPerformanceMarks}var F;typeof global=="object"?F=global:typeof self=="object"?F=self:F={},typeof define=="function"?define("vs/base/common/performance",[],function(){return C(F)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=C(F):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),F.perf=C(F))}(),function(me,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var C=e();for(var F in C)(typeof exports=="object"?exports:me)[F]=C[F]}}(typeof self<"u"?self:this,function(){return function(me){var e={};function C(F){if(e[F])return e[F].exports;var f=e[F]={i:F,l:!1,exports:{}};return me[F].call(f.exports,f,f.exports,C),f.l=!0,f.exports}return C.m=me,C.c=e,C.d=function(F,f,L){C.o(F,f)||Object.defineProperty(F,f,{enumerable:!0,get:L})},C.r=function(F){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(F,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(F,"__esModule",{value:!0})},C.t=function(F,f){if(1&f&&(F=C(F)),8&f||4&f&&typeof F=="object"&&F&&F.__esModule)return F;var L=Object.create(null);if(C.r(L),Object.defineProperty(L,"default",{enumerable:!0,value:F}),2&f&&typeof F!="string")for(var M in F)C.d(L,M,function(b){return F[b]}.bind(null,M));return L},C.n=function(F){var f=F&&F.__esModule?function(){return F.default}:function(){return F};return C.d(f,"a",f),f},C.o=function(F,f){return Object.prototype.hasOwnProperty.call(F,f)},C.p="",C(C.s=0)}([function(me,e,C){(function(F){var f;e=me.exports=he,f=typeof F=="object"&&F.env&&F.env.NODE_DEBUG&&/\bsemver\b/i.test(F.env.NODE_DEBUG)?function(){var ee=Array.prototype.slice.call(arguments,0);ee.unshift("SEMVER"),console.log.apply(console,ee)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var L=256,M=Number.MAX_SAFE_INTEGER||9007199254740991,b=e.re=[],v=e.src=[],g=0,A=g++;v[A]="0|[1-9]\\d*";var I=g++;v[I]="[0-9]+";var $=g++;v[$]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var y=g++;v[y]="("+v[A]+")\\.("+v[A]+")\\.("+v[A]+")";var k=g++;v[k]="("+v[I]+")\\.("+v[I]+")\\.("+v[I]+")";var w=g++;v[w]="(?:"+v[A]+"|"+v[$]+")";var u=g++;v[u]="(?:"+v[I]+"|"+v[$]+")";var o=g++;v[o]="(?:-("+v[w]+"(?:\\."+v[w]+")*))";var i=g++;v[i]="(?:-?("+v[u]+"(?:\\."+v[u]+")*))";var n=g++;v[n]="[0-9A-Za-z-]+";var r=g++;v[r]="(?:\\+("+v[n]+"(?:\\."+v[n]+")*))";var a=g++,t="v?"+v[y]+v[o]+"?"+v[r]+"?";v[a]="^"+t+"$";var s="[v=\\s]*"+v[k]+v[i]+"?"+v[r]+"?",d=g++;v[d]="^"+s+"$";var c=g++;v[c]="((?:<|>)?=?)";var l=g++;v[l]=v[I]+"|x|X|\\*";var h=g++;v[h]=v[A]+"|x|X|\\*";var E=g++;v[E]="[v=\\s]*("+v[h]+")(?:\\.("+v[h]+")(?:\\.("+v[h]+")(?:"+v[o]+")?"+v[r]+"?)?)?";var D=g++;v[D]="[v=\\s]*("+v[l]+")(?:\\.("+v[l]+")(?:\\.("+v[l]+")(?:"+v[i]+")?"+v[r]+"?)?)?";var m=g++;v[m]="^"+v[c]+"\\s*"+v[E]+"$";var p=g++;v[p]="^"+v[c]+"\\s*"+v[D]+"$";var S=g++;v[S]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var P=g++;v[P]="(?:~>?)";var z=g++;v[z]="(\\s*)"+v[P]+"\\s+",b[z]=new RegExp(v[z],"g");var j=g++;v[j]="^"+v[P]+v[E]+"$";var R=g++;v[R]="^"+v[P]+v[D]+"$";var T=g++;v[T]="(?:\\^)";var N=g++;v[N]="(\\s*)"+v[T]+"\\s+",b[N]=new RegExp(v[N],"g");var O=g++;v[O]="^"+v[T]+v[E]+"$";var W=g++;v[W]="^"+v[T]+v[D]+"$";var x=g++;v[x]="^"+v[c]+"\\s*("+s+")$|^$";var le=g++;v[le]="^"+v[c]+"\\s*("+t+")$|^$";var G=g++;v[G]="(\\s*)"+v[c]+"\\s*("+s+"|"+v[E]+")",b[G]=new RegExp(v[G],"g");var J=g++;v[J]="^\\s*("+v[E]+")\\s+-\\s+("+v[E]+")\\s*$";var Q=g++;v[Q]="^\\s*("+v[D]+")\\s+-\\s+("+v[D]+")\\s*$";var oe=g++;v[oe]="(<|>)?=?\\s*\\*";for(var _=0;_<35;_++)f(_,v[_]),b[_]||(b[_]=new RegExp(v[_]));function Ee(ee,ge){if(ee instanceof he)return ee;if(typeof ee!="string"||ee.length>L||!(ge?b[d]:b[a]).test(ee))return null;try{return new he(ee,ge)}catch{return null}}function he(ee,ge){if(ee instanceof he){if(ee.loose===ge)return ee;ee=ee.version}else if(typeof ee!="string")throw new TypeError("Invalid Version: "+ee);if(ee.length>L)throw new TypeError("version is longer than "+L+" characters");if(!(this instanceof he))return new he(ee,ge);f("SemVer",ee,ge),this.loose=ge;var ye=ee.trim().match(ge?b[d]:b[a]);if(!ye)throw new TypeError("Invalid Version: "+ee);if(this.raw=ee,this.major=+ye[1],this.minor=+ye[2],this.patch=+ye[3],this.major>M||this.major<0)throw new TypeError("Invalid major version");if(this.minor>M||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>M||this.patch<0)throw new TypeError("Invalid patch version");ye[4]?this.prerelease=ye[4].split(".").map(function(je){if(/^[0-9]+$/.test(je)){var We=+je;if(We>=0&&We<M)return We}return je}):this.prerelease=[],this.build=ye[5]?ye[5].split("."):[],this.format()}e.parse=Ee,e.valid=function(ee,ge){var ye=Ee(ee,ge);return ye?ye.version:null},e.clean=function(ee,ge){var ye=Ee(ee.trim().replace(/^[=v]+/,""),ge);return ye?ye.version:null},e.SemVer=he,he.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},he.prototype.toString=function(){return this.version},he.prototype.compare=function(ee){return f("SemVer.compare",this.version,this.loose,ee),ee instanceof he||(ee=new he(ee,this.loose)),this.compareMain(ee)||this.comparePre(ee)},he.prototype.compareMain=function(ee){return ee instanceof he||(ee=new he(ee,this.loose)),U(this.major,ee.major)||U(this.minor,ee.minor)||U(this.patch,ee.patch)},he.prototype.comparePre=function(ee){if(ee instanceof he||(ee=new he(ee,this.loose)),this.prerelease.length&&!ee.prerelease.length)return-1;if(!this.prerelease.length&&ee.prerelease.length)return 1;if(!this.prerelease.length&&!ee.prerelease.length)return 0;var ge=0;do{var ye=this.prerelease[ge],je=ee.prerelease[ge];if(f("prerelease compare",ge,ye,je),ye===void 0&&je===void 0)return 0;if(je===void 0)return 1;if(ye===void 0)return-1;if(ye!==je)return U(ye,je)}while(++ge)},he.prototype.inc=function(ee,ge){switch(ee){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",ge);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",ge);break;case"prepatch":this.prerelease.length=0,this.inc("patch",ge),this.inc("pre",ge);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",ge),this.inc("pre",ge);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var ye=this.prerelease.length;--ye>=0;)typeof this.prerelease[ye]=="number"&&(this.prerelease[ye]++,ye=-2);ye===-1&&this.prerelease.push(0)}ge&&(this.prerelease[0]===ge?isNaN(this.prerelease[1])&&(this.prerelease=[ge,0]):this.prerelease=[ge,0]);break;default:throw new Error("invalid increment argument: "+ee)}return this.format(),this.raw=this.version,this},e.inc=function(ee,ge,ye,je){typeof ye=="string"&&(je=ye,ye=void 0);try{return new he(ee,ye).inc(ge,je).version}catch{return null}},e.diff=function(ee,ge){if(Y(ee,ge))return null;var ye=Ee(ee),je=Ee(ge);if(ye.prerelease.length||je.prerelease.length){for(var We in ye)if((We==="major"||We==="minor"||We==="patch")&&ye[We]!==je[We])return"pre"+We;return"prerelease"}for(var We in ye)if((We==="major"||We==="minor"||We==="patch")&&ye[We]!==je[We])return We},e.compareIdentifiers=U;var q=/^[0-9]+$/;function U(ee,ge){var ye=q.test(ee),je=q.test(ge);return ye&&je&&(ee=+ee,ge=+ge),ye&&!je?-1:je&&!ye?1:ee<ge?-1:ee>ge?1:0}function ie(ee,ge,ye){return new he(ee,ye).compare(new he(ge,ye))}function be(ee,ge,ye){return ie(ee,ge,ye)>0}function H(ee,ge,ye){return ie(ee,ge,ye)<0}function Y(ee,ge,ye){return ie(ee,ge,ye)===0}function Z(ee,ge,ye){return ie(ee,ge,ye)!==0}function $e(ee,ge,ye){return ie(ee,ge,ye)>=0}function ne(ee,ge,ye){return ie(ee,ge,ye)<=0}function fe(ee,ge,ye,je){var We;switch(ge){case"===":typeof ee=="object"&&(ee=ee.version),typeof ye=="object"&&(ye=ye.version),We=ee===ye;break;case"!==":typeof ee=="object"&&(ee=ee.version),typeof ye=="object"&&(ye=ye.version),We=ee!==ye;break;case"":case"=":case"==":We=Y(ee,ye,je);break;case"!=":We=Z(ee,ye,je);break;case">":We=be(ee,ye,je);break;case">=":We=$e(ee,ye,je);break;case"<":We=H(ee,ye,je);break;case"<=":We=ne(ee,ye,je);break;default:throw new TypeError("Invalid operator: "+ge)}return We}function te(ee,ge){if(ee instanceof te){if(ee.loose===ge)return ee;ee=ee.value}if(!(this instanceof te))return new te(ee,ge);f("comparator",ee,ge),this.loose=ge,this.parse(ee),this.semver===de?this.value="":this.value=this.operator+this.semver.version,f("comp",this)}e.rcompareIdentifiers=function(ee,ge){return U(ge,ee)},e.major=function(ee,ge){return new he(ee,ge).major},e.minor=function(ee,ge){return new he(ee,ge).minor},e.patch=function(ee,ge){return new he(ee,ge).patch},e.compare=ie,e.compareLoose=function(ee,ge){return ie(ee,ge,!0)},e.rcompare=function(ee,ge,ye){return ie(ge,ee,ye)},e.sort=function(ee,ge){return ee.sort(function(ye,je){return e.compare(ye,je,ge)})},e.rsort=function(ee,ge){return ee.sort(function(ye,je){return e.rcompare(ye,je,ge)})},e.gt=be,e.lt=H,e.eq=Y,e.neq=Z,e.gte=$e,e.lte=ne,e.cmp=fe,e.Comparator=te;var de={};function pe(ee,ge){if(ee instanceof pe)return ee.loose===ge?ee:new pe(ee.raw,ge);if(ee instanceof te)return new pe(ee.value,ge);if(!(this instanceof pe))return new pe(ee,ge);if(this.loose=ge,this.raw=ee,this.set=ee.split(/\s*\|\|\s*/).map(function(ye){return this.parseRange(ye.trim())},this).filter(function(ye){return ye.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+ee);this.format()}function Pe(ee){return!ee||ee.toLowerCase()==="x"||ee==="*"}function B(ee,ge,ye,je,We,et,Ze,rt,nt,Ae,Oe,Ve,Le){return((ge=Pe(ye)?"":Pe(je)?">="+ye+".0.0":Pe(We)?">="+ye+"."+je+".0":">="+ge)+" "+(rt=Pe(nt)?"":Pe(Ae)?"<"+(+nt+1)+".0.0":Pe(Oe)?"<"+nt+"."+(+Ae+1)+".0":Ve?"<="+nt+"."+Ae+"."+Oe+"-"+Ve:"<="+rt)).trim()}function X(ee,ge){for(var ye=0;ye<ee.length;ye++)if(!ee[ye].test(ge))return!1;if(ge.prerelease.length){for(ye=0;ye<ee.length;ye++)if(f(ee[ye].semver),ee[ye].semver!==de&&ee[ye].semver.prerelease.length>0){var je=ee[ye].semver;if(je.major===ge.major&&je.minor===ge.minor&&je.patch===ge.patch)return!0}return!1}return!0}function re(ee,ge,ye){try{ge=new pe(ge,ye)}catch{return!1}return ge.test(ee)}function ae(ee,ge,ye,je){var We,et,Ze,rt,nt;switch(ee=new he(ee,je),ge=new pe(ge,je),ye){case">":We=be,et=ne,Ze=H,rt=">",nt=">=";break;case"<":We=H,et=$e,Ze=be,rt="<",nt="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(re(ee,ge,je))return!1;for(var Ae=0;Ae<ge.set.length;++Ae){var Oe=ge.set[Ae],Ve=null,Le=null;if(Oe.forEach(function(Ye){Ye.semver===de&&(Ye=new te(">=0.0.0")),Ve=Ve||Ye,Le=Le||Ye,We(Ye.semver,Ve.semver,je)?Ve=Ye:Ze(Ye.semver,Le.semver,je)&&(Le=Ye)}),Ve.operator===rt||Ve.operator===nt||(!Le.operator||Le.operator===rt)&&et(ee,Le.semver)||Le.operator===nt&&Ze(ee,Le.semver))return!1}return!0}te.prototype.parse=function(ee){var ge=this.loose?b[x]:b[le],ye=ee.match(ge);if(!ye)throw new TypeError("Invalid comparator: "+ee);this.operator=ye[1],this.operator==="="&&(this.operator=""),ye[2]?this.semver=new he(ye[2],this.loose):this.semver=de},te.prototype.toString=function(){return this.value},te.prototype.test=function(ee){return f("Comparator.test",ee,this.loose),this.semver===de||(typeof ee=="string"&&(ee=new he(ee,this.loose)),fe(ee,this.operator,this.semver,this.loose))},te.prototype.intersects=function(ee,ge){if(!(ee instanceof te))throw new TypeError("a Comparator is required");var ye;if(this.operator==="")return ye=new pe(ee.value,ge),re(this.value,ye,ge);if(ee.operator==="")return ye=new pe(this.value,ge),re(ee.semver,ye,ge);var je=!(this.operator!==">="&&this.operator!==">"||ee.operator!==">="&&ee.operator!==">"),We=!(this.operator!=="<="&&this.operator!=="<"||ee.operator!=="<="&&ee.operator!=="<"),et=this.semver.version===ee.semver.version,Ze=!(this.operator!==">="&&this.operator!=="<="||ee.operator!==">="&&ee.operator!=="<="),rt=fe(this.semver,"<",ee.semver,ge)&&(this.operator===">="||this.operator===">")&&(ee.operator==="<="||ee.operator==="<"),nt=fe(this.semver,">",ee.semver,ge)&&(this.operator==="<="||this.operator==="<")&&(ee.operator===">="||ee.operator===">");return je||We||et&&Ze||rt||nt},e.Range=pe,pe.prototype.format=function(){return this.range=this.set.map(function(ee){return ee.join(" ").trim()}).join("||").trim(),this.range},pe.prototype.toString=function(){return this.range},pe.prototype.parseRange=function(ee){var ge=this.loose;ee=ee.trim(),f("range",ee,ge);var ye=ge?b[Q]:b[J];ee=ee.replace(ye,B),f("hyphen replace",ee),ee=ee.replace(b[G],"$1$2$3"),f("comparator trim",ee,b[G]),ee=(ee=(ee=ee.replace(b[z],"$1~")).replace(b[N],"$1^")).split(/\s+/).join(" ");var je=ge?b[x]:b[le],We=ee.split(" ").map(function(et){return function(Ze,rt){return f("comp",Ze),Ze=function(nt,Ae){return nt.trim().split(/\s+/).map(function(Oe){return function(Ve,Le){f("caret",Ve,Le);var Ye=Le?b[W]:b[O];return Ve.replace(Ye,function(ue,ce,Ie,Ke,Ge){var _e;return f("caret",Ve,ue,ce,Ie,Ke,Ge),Pe(ce)?_e="":Pe(Ie)?_e=">="+ce+".0.0 <"+(+ce+1)+".0.0":Pe(Ke)?_e=ce==="0"?">="+ce+"."+Ie+".0 <"+ce+"."+(+Ie+1)+".0":">="+ce+"."+Ie+".0 <"+(+ce+1)+".0.0":Ge?(f("replaceCaret pr",Ge),Ge.charAt(0)!=="-"&&(Ge="-"+Ge),_e=ce==="0"?Ie==="0"?">="+ce+"."+Ie+"."+Ke+Ge+" <"+ce+"."+Ie+"."+(+Ke+1):">="+ce+"."+Ie+"."+Ke+Ge+" <"+ce+"."+(+Ie+1)+".0":">="+ce+"."+Ie+"."+Ke+Ge+" <"+(+ce+1)+".0.0"):(f("no pr"),_e=ce==="0"?Ie==="0"?">="+ce+"."+Ie+"."+Ke+" <"+ce+"."+Ie+"."+(+Ke+1):">="+ce+"."+Ie+"."+Ke+" <"+ce+"."+(+Ie+1)+".0":">="+ce+"."+Ie+"."+Ke+" <"+(+ce+1)+".0.0"),f("caret return",_e),_e})}(Oe,Ae)}).join(" ")}(Ze,rt),f("caret",Ze),Ze=function(nt,Ae){return nt.trim().split(/\s+/).map(function(Oe){return function(Ve,Le){var Ye=Le?b[R]:b[j];return Ve.replace(Ye,function(ue,ce,Ie,Ke,Ge){var _e;return f("tilde",Ve,ue,ce,Ie,Ke,Ge),Pe(ce)?_e="":Pe(Ie)?_e=">="+ce+".0.0 <"+(+ce+1)+".0.0":Pe(Ke)?_e=">="+ce+"."+Ie+".0 <"+ce+"."+(+Ie+1)+".0":Ge?(f("replaceTilde pr",Ge),Ge.charAt(0)!=="-"&&(Ge="-"+Ge),_e=">="+ce+"."+Ie+"."+Ke+Ge+" <"+ce+"."+(+Ie+1)+".0"):_e=">="+ce+"."+Ie+"."+Ke+" <"+ce+"."+(+Ie+1)+".0",f("tilde return",_e),_e})}(Oe,Ae)}).join(" ")}(Ze,rt),f("tildes",Ze),Ze=function(nt,Ae){return f("replaceXRanges",nt,Ae),nt.split(/\s+/).map(function(Oe){return function(Ve,Le){Ve=Ve.trim();var Ye=Le?b[p]:b[m];return Ve.replace(Ye,function(ue,ce,Ie,Ke,Ge,_e){f("xRange",Ve,ue,ce,Ie,Ke,Ge,_e);var st=Pe(Ie),lt=st||Pe(Ke),wt=lt||Pe(Ge);return ce==="="&&wt&&(ce=""),st?ue=ce===">"||ce==="<"?"<0.0.0":"*":ce&&wt?(lt&&(Ke=0),wt&&(Ge=0),ce===">"?(ce=">=",lt?(Ie=+Ie+1,Ke=0,Ge=0):wt&&(Ke=+Ke+1,Ge=0)):ce==="<="&&(ce="<",lt?Ie=+Ie+1:Ke=+Ke+1),ue=ce+Ie+"."+Ke+"."+Ge):lt?ue=">="+Ie+".0.0 <"+(+Ie+1)+".0.0":wt&&(ue=">="+Ie+"."+Ke+".0 <"+Ie+"."+(+Ke+1)+".0"),f("xRange return",ue),ue})}(Oe,Ae)}).join(" ")}(Ze,rt),f("xrange",Ze),Ze=function(nt,Ae){return f("replaceStars",nt,Ae),nt.trim().replace(b[oe],"")}(Ze,rt),f("stars",Ze),Ze}(et,ge)}).join(" ").split(/\s+/);return this.loose&&(We=We.filter(function(et){return!!et.match(je)})),We=We.map(function(et){return new te(et,ge)})},pe.prototype.intersects=function(ee,ge){if(!(ee instanceof pe))throw new TypeError("a Range is required");return this.set.some(function(ye){return ye.every(function(je){return ee.set.some(function(We){return We.every(function(et){return je.intersects(et,ge)})})})})},e.toComparators=function(ee,ge){return new pe(ee,ge).set.map(function(ye){return ye.map(function(je){return je.value}).join(" ").trim().split(" ")})},pe.prototype.test=function(ee){if(!ee)return!1;typeof ee=="string"&&(ee=new he(ee,this.loose));for(var ge=0;ge<this.set.length;ge++)if(X(this.set[ge],ee))return!0;return!1},e.satisfies=re,e.maxSatisfying=function(ee,ge,ye){var je=null,We=null;try{var et=new pe(ge,ye)}catch{return null}return ee.forEach(function(Ze){et.test(Ze)&&(je&&We.compare(Ze)!==-1||(We=new he(je=Ze,ye)))}),je},e.minSatisfying=function(ee,ge,ye){var je=null,We=null;try{var et=new pe(ge,ye)}catch{return null}return ee.forEach(function(Ze){et.test(Ze)&&(je&&We.compare(Ze)!==1||(We=new he(je=Ze,ye)))}),je},e.validRange=function(ee,ge){try{return new pe(ee,ge).range||"*"}catch{return null}},e.ltr=function(ee,ge,ye){return ae(ee,ge,"<",ye)},e.gtr=function(ee,ge,ye){return ae(ee,ge,">",ye)},e.outside=ae,e.prerelease=function(ee,ge){var ye=Ee(ee,ge);return ye&&ye.prerelease.length?ye.prerelease:null},e.intersects=function(ee,ge,ye){return ee=new pe(ee,ye),ge=new pe(ge,ye),ee.intersects(ge)},e.coerce=function(ee){if(ee instanceof he)return ee;if(typeof ee!="string")return null;var ge=ee.match(b[S]);return ge==null?null:Ee((ge[1]||"0")+"."+(ge[2]||"0")+"."+(ge[3]||"0"))}}).call(this,C(1))},function(me,e){var C,F,f=me.exports={};function L(){throw new Error("setTimeout has not been defined")}function M(){throw new Error("clearTimeout has not been defined")}function b(u){if(C===setTimeout)return setTimeout(u,0);if((C===L||!C)&&setTimeout)return C=setTimeout,setTimeout(u,0);try{return C(u,0)}catch{try{return C.call(null,u,0)}catch{return C.call(this,u,0)}}}(function(){try{C=typeof setTimeout=="function"?setTimeout:L}catch{C=L}try{F=typeof clearTimeout=="function"?clearTimeout:M}catch{F=M}})();var v,g=[],A=!1,I=-1;function $(){A&&v&&(A=!1,v.length?g=v.concat(g):I=-1,g.length&&y())}function y(){if(!A){var u=b($);A=!0;for(var o=g.length;o;){for(v=g,g=[];++I<o;)v&&v[I].run();I=-1,o=g.length}v=null,A=!1,function(i){if(F===clearTimeout)return clearTimeout(i);if((F===M||!F)&&clearTimeout)return F=clearTimeout,clearTimeout(i);try{F(i)}catch{try{return F.call(null,i)}catch{return F.call(this,i)}}}(u)}}function k(u,o){this.fun=u,this.array=o}function w(){}f.nextTick=function(u){var o=new Array(arguments.length-1);if(arguments.length>1)for(var i=1;i<arguments.length;i++)o[i-1]=arguments[i];g.push(new k(u,o)),g.length!==1||A||b(y)},k.prototype.run=function(){this.fun.apply(null,this.array)},f.title="browser",f.browser=!0,f.env={},f.argv=[],f.version="",f.versions={},f.on=w,f.addListener=w,f.once=w,f.off=w,f.removeListener=w,f.removeAllListeners=w,f.emit=w,f.prependListener=w,f.prependOnceListener=w,f.listeners=function(u){return[]},f.binding=function(u){throw new Error("process.binding is not supported")},f.cwd=function(){return"/"},f.chdir=function(u){throw new Error("process.chdir is not supported")},f.umask=function(){return 0}}])}),define(ke[38],Se([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nd=void 0;const C=globalThis.performance&&typeof globalThis.performance.now=="function";class F{static create(L){return new F(L)}constructor(L){this.c=C&&L===!1?Date.now:globalThis.performance.now.bind(globalThis.performance),this.a=this.c(),this.b=-1}stop(){this.b=this.c()}reset(){this.a=this.c(),this.b=-1}elapsed(){return this.b!==-1?this.b-this.a:this.c()-this.a}}e.$Nd=F}),define(ke[4],Se([1,0,8,74,3,75,38]),function(me,e,C,F,f,L,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1d=e.$Zd=e.$Yd=e.$Xd=e.$Wd=e.$Vd=e.$Ud=e.$Td=e.$Sd=e.$Rd=e.$Qd=e.$Pd=e.Event=void 0;const b=!1,v=!1;var g;(function(m){m.None=()=>f.$Rc.None;function p(fe){if(v){const{onDidAddListener:te}=fe,de=k.create();let pe=0;fe.onDidAddListener=()=>{++pe===2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),de.print()),te?.()}}}function S(fe,te){return le(fe,()=>{},0,void 0,!0,void 0,te)}m.defer=S;function P(fe){return(te,de=null,pe)=>{let Pe=!1,B;return B=fe(X=>{if(!Pe)return B?B.dispose():Pe=!0,te.call(de,X)},null,pe),Pe&&B.dispose(),B}}m.once=P;function z(fe,te,de){return W((pe,Pe=null,B)=>fe(X=>pe.call(Pe,te(X)),null,B),de)}m.map=z;function j(fe,te,de){return W((pe,Pe=null,B)=>fe(X=>{te(X),pe.call(Pe,X)},null,B),de)}m.forEach=j;function R(fe,te,de){return W((pe,Pe=null,B)=>fe(X=>te(X)&&pe.call(Pe,X),null,B),de)}m.filter=R;function T(fe){return fe}m.signal=T;function N(...fe){return(te,de=null,pe)=>{const Pe=(0,f.$Oc)(...fe.map(B=>B(X=>te.call(de,X))));return x(Pe,pe)}}m.any=N;function O(fe,te,de,pe){let Pe=de;return z(fe,B=>(Pe=te(Pe,B),Pe),pe)}m.reduce=O;function W(fe,te){let de;const pe={onWillAddFirstListener(){de=fe(Pe.fire,Pe)},onDidRemoveLastListener(){de?.dispose()}};te||p(pe);const Pe=new n(pe);return te?.add(Pe),Pe.event}function x(fe,te){return te instanceof Array?te.push(fe):te&&te.add(fe),fe}function le(fe,te,de=100,pe=!1,Pe=!1,B,X){let re,ae,ee,ge=0,ye;const je={leakWarningThreshold:B,onWillAddFirstListener(){re=fe(et=>{ge++,ae=te(ae,et),pe&&!ee&&(We.fire(ae),ae=void 0),ye=()=>{const Ze=ae;ae=void 0,ee=void 0,(!pe||ge>1)&&We.fire(Ze),ge=0},typeof de=="number"?(clearTimeout(ee),ee=setTimeout(ye,de)):ee===void 0&&(ee=0,queueMicrotask(ye))})},onWillRemoveListener(){Pe&&ge>0&&ye?.()},onDidRemoveLastListener(){ye=void 0,re.dispose()}};X||p(je);const We=new n(je);return X?.add(We),We.event}m.debounce=le;function G(fe,te=0,de){return m.debounce(fe,(pe,Pe)=>pe?(pe.push(Pe),pe):[Pe],te,void 0,!0,void 0,de)}m.accumulate=G;function J(fe,te=(pe,Pe)=>pe===Pe,de){let pe=!0,Pe;return R(fe,B=>{const X=pe||!te(B,Pe);return pe=!1,Pe=B,X},de)}m.latch=J;function Q(fe,te,de){return[m.filter(fe,te,de),m.filter(fe,pe=>!te(pe),de)]}m.split=Q;function oe(fe,te=!1,de=[],pe){let Pe=de.slice(),B=fe(ae=>{Pe?Pe.push(ae):re.fire(ae)});pe&&pe.add(B);const X=()=>{Pe?.forEach(ae=>re.fire(ae)),Pe=null},re=new n({onWillAddFirstListener(){B||(B=fe(ae=>re.fire(ae)),pe&&pe.add(B))},onDidAddFirstListener(){Pe&&(te?setTimeout(X):X())},onDidRemoveLastListener(){B&&B.dispose(),B=null}});return pe&&pe.add(re),re.event}m.buffer=oe;function _(fe,te){return(pe,Pe,B)=>{const X=te(new he);return fe(function(re){const ae=X.evaluate(re);ae!==Ee&&pe.call(Pe,ae)},void 0,B)}}m.chain=_;const Ee=Symbol("HaltChainable");class he{constructor(){this.f=[]}map(te){return this.f.push(te),this}forEach(te){return this.f.push(de=>(te(de),de)),this}filter(te){return this.f.push(de=>te(de)?de:Ee),this}reduce(te,de){let pe=de;return this.f.push(Pe=>(pe=te(pe,Pe),pe)),this}latch(te=(de,pe)=>de===pe){let de=!0,pe;return this.f.push(Pe=>{const B=de||!te(Pe,pe);return de=!1,pe=Pe,B?Pe:Ee}),this}evaluate(te){for(const de of this.f)if(te=de(te),te===Ee)break;return te}}function q(fe,te,de=pe=>pe){const pe=(...re)=>X.fire(de(...re)),Pe=()=>fe.on(te,pe),B=()=>fe.removeListener(te,pe),X=new n({onWillAddFirstListener:Pe,onDidRemoveLastListener:B});return X.event}m.fromNodeEventEmitter=q;function U(fe,te,de=pe=>pe){const pe=(...re)=>X.fire(de(...re)),Pe=()=>fe.addEventListener(te,pe),B=()=>fe.removeEventListener(te,pe),X=new n({onWillAddFirstListener:Pe,onDidRemoveLastListener:B});return X.event}m.fromDOMEventEmitter=U;function ie(fe){return new Promise(te=>P(fe)(te))}m.toPromise=ie;function be(fe){const te=new n;return fe.then(de=>{te.fire(de)},()=>{te.fire(void 0)}).finally(()=>{te.dispose()}),te.event}m.fromPromise=be;function H(fe,te,de){return te(de),fe(pe=>te(pe))}m.runAndSubscribe=H;function Y(fe,te){let de=null;function pe(B){de?.dispose(),de=new f.$Qc,te(B,de)}pe(void 0);const Pe=fe(B=>pe(B));return(0,f.$Pc)(()=>{Pe.dispose(),de?.dispose()})}m.runAndSubscribeWithStore=Y;class Z{constructor(te,de){this._observable=te,this.f=0,this.g=!1;const pe={onWillAddFirstListener:()=>{te.addObserver(this)},onDidRemoveLastListener:()=>{te.removeObserver(this)}};de||p(pe),this.emitter=new n(pe),de&&de.add(this.emitter)}beginUpdate(te){this.f++}handlePossibleChange(te){}handleChange(te,de){this.g=!0}endUpdate(te){this.f--,this.f===0&&(this._observable.reportChanges(),this.g&&(this.g=!1,this.emitter.fire(this._observable.get())))}}function $e(fe,te){return new Z(fe,te).emitter.event}m.fromObservable=$e;function ne(fe){return te=>{let de=0,pe=!1;const Pe={beginUpdate(){de++},endUpdate(){de--,de===0&&(fe.reportChanges(),pe&&(pe=!1,te()))},handlePossibleChange(){},handleChange(){pe=!0}};return fe.addObserver(Pe),fe.reportChanges(),{dispose(){fe.removeObserver(Pe)}}}}m.fromObservableLight=ne})(g||(e.Event=g={}));class A{static{this.all=new Set}static{this.f=0}constructor(p){this.listenerCount=0,this.invocationCount=0,this.elapsedOverall=0,this.durations=[],this.name=`${p}_${A.f++}`,A.all.add(this)}start(p){this.g=new M.$Nd,this.listenerCount=p}stop(){if(this.g){const p=this.g.elapsed();this.durations.push(p),this.elapsedOverall+=p,this.invocationCount+=1,this.g=void 0}}}e.$Pd=A;let I=-1;function $(m){const p=I;return I=m,{dispose(){I=p}}}e.$Qd=$;class y{constructor(p,S=Math.random().toString(18).slice(2,5)){this.threshold=p,this.name=S,this.g=0}dispose(){this.f?.clear()}check(p,S){const P=this.threshold;if(P<=0||S<P)return;this.f||(this.f=new Map);const z=this.f.get(p.value)||0;if(this.f.set(p.value,z+1),this.g-=1,this.g<=0){this.g=P*.5;let j,R=0;for(const[T,N]of this.f)(!j||R<N)&&(j=T,R=N);console.warn(`[${this.name}] potential listener LEAK detected, having ${S} listeners already. MOST frequent listener (${R}):`),console.warn(j)}return()=>{const j=this.f.get(p.value)||0;this.f.set(p.value,j-1)}}}class k{static create(){return new k(new Error().stack??"")}constructor(p){this.value=p}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}let w=0;class u{constructor(p){this.value=p,this.id=w++}}const o=2,i=(m,p)=>{if(m instanceof u)p(m);else for(let S=0;S<m.length;S++){const P=m[S];P&&p(P)}};class n{constructor(p){this.w=0,this.f=p,this.g=I>0||this.f?.leakWarningThreshold?new y(this.f?.leakWarningThreshold??I):void 0,this.j=this.f?._profName?new A(this.f._profName):void 0,this.u=this.f?.deliveryQueue}dispose(){if(!this.m){if(this.m=!0,this.u?.current===this&&this.u.reset(),this.t){if(b){const p=this.t;queueMicrotask(()=>{i(p,S=>S.stack?.print())})}this.t=void 0,this.w=0}this.f?.onDidRemoveLastListener?.(),this.g?.dispose()}}get event(){return this.q??=(p,S,P)=>{if(this.g&&this.w>this.g.threshold*3)return console.warn(`[${this.g.name}] REFUSES to accept new listeners because it exceeded its threshold by far`),f.$Rc.None;if(this.m)return f.$Rc.None;S&&(p=p.bind(S));const z=new u(p);let j,R;this.g&&this.w>=Math.ceil(this.g.threshold*.2)&&(z.stack=k.create(),j=this.g.check(z.stack,this.w+1)),b&&(z.stack=R??k.create()),this.t?this.t instanceof u?(this.u??=new a,this.t=[this.t,z]):this.t.push(z):(this.f?.onWillAddFirstListener?.(this),this.t=z,this.f?.onDidAddFirstListener?.(this)),this.w++;const T=(0,f.$Pc)(()=>{j?.(),this.x(z)});return P instanceof f.$Qc?P.add(T):Array.isArray(P)&&P.push(T),T},this.q}x(p){if(this.f?.onWillRemoveListener?.(this),!this.t)return;if(this.w===1){this.t=void 0,this.f?.onDidRemoveLastListener?.(this),this.w=0;return}const S=this.t,P=S.indexOf(p);if(P===-1)throw console.log("disposed?",this.m),console.log("size?",this.w),console.log("arr?",JSON.stringify(this.t)),new Error("Attempted to dispose unknown listener");this.w--,S[P]=void 0;const z=this.u.current===this;if(this.w*o<=S.length){let j=0;for(let R=0;R<S.length;R++)S[R]?S[j++]=S[R]:z&&(this.u.end--,j<this.u.i&&this.u.i--);S.length=j}}y(p,S){if(!p)return;const P=this.f?.onListenerError||C.$Z;if(!P){p.value(S);return}try{p.value(S)}catch(z){P(z)}}z(p){const S=p.current.t;for(;p.i<p.end;)this.y(S[p.i++],p.value);p.reset()}fire(p){if(this.u?.current&&(this.z(this.u),this.j?.stop()),this.j?.start(this.w),this.t)if(this.t instanceof u)this.y(this.t,p);else{const S=this.u;S.enqueue(this,p,this.t.length),this.z(S)}this.j?.stop()}hasListeners(){return this.w>0}}e.$Rd=n;const r=()=>new a;e.$Sd=r;class a{constructor(){this.i=-1,this.end=0}enqueue(p,S,P){this.i=0,this.end=P,this.current=p,this.value=S}reset(){this.i=this.end,this.current=void 0,this.value=void 0}}class t extends n{async fireAsync(p,S,P){if(this.t)for(this.h||(this.h=new L.$2c),i(this.t,z=>this.h.push([z.value,p]));this.h.size>0&&!S.isCancellationRequested;){const[z,j]=this.h.shift(),R=[],T={...j,token:S,waitUntil:N=>{if(Object.isFrozen(R))throw new Error("waitUntil can NOT be called asynchronous");P&&(N=P(N,z)),R.push(N)}};try{z(T)}catch(N){(0,C.$Z)(N);continue}Object.freeze(R),await Promise.allSettled(R).then(N=>{for(const O of N)O.status==="rejected"&&(0,C.$Z)(O.reason)})}}}e.$Td=t;class s extends n{get isPaused(){return this.h!==0}constructor(p){super(p),this.h=0,this.s=new L.$2c,this.A=p?.merge}pause(){this.h++}resume(){if(this.h!==0&&--this.h===0)if(this.A){if(this.s.size>0){const p=Array.from(this.s);this.s.clear(),super.fire(this.A(p))}}else for(;!this.h&&this.s.size!==0;)super.fire(this.s.shift())}fire(p){this.w&&(this.h!==0?this.s.push(p):super.fire(p))}}e.$Ud=s;class d extends s{constructor(p){super(p),this.k=p.delay??100}fire(p){this.o||(this.pause(),this.o=setTimeout(()=>{this.o=void 0,this.resume()},this.k)),super.fire(p)}}e.$Vd=d;class c extends n{constructor(p){super(p),this.h=[],this.k=p?.merge}fire(p){this.hasListeners()&&(this.h.push(p),this.h.length===1&&queueMicrotask(()=>{this.k?super.fire(this.k(this.h)):this.h.forEach(S=>super.fire(S)),this.h=[]}))}}e.$Wd=c;class l{constructor(){this.g=!1,this.h=[],this.f=new n({onWillAddFirstListener:()=>this.j(),onDidRemoveLastListener:()=>this.k()})}get event(){return this.f.event}add(p){const S={event:p,listener:null};this.h.push(S),this.g&&this.m(S);const P=()=>{this.g&&this.o(S);const z=this.h.indexOf(S);this.h.splice(z,1)};return(0,f.$Pc)((0,F.$cb)(P))}j(){this.g=!0,this.h.forEach(p=>this.m(p))}k(){this.g=!1,this.h.forEach(p=>this.o(p))}m(p){p.listener=p.event(S=>this.f.fire(S))}o(p){p.listener&&p.listener.dispose(),p.listener=null}dispose(){this.f.dispose()}}e.$Xd=l;class h{constructor(p,S,P,z){this.f=new f.$Qc;const j=this.f.add(new l),R=this.f.add(new f.$1c);function T(N){R.set(N,j.add(z(N)))}for(const N of p)T(N);this.f.add(S(N=>{T(N)})),this.f.add(P(N=>{R.deleteAndDispose(N)})),this.event=j.event}dispose(){this.f.dispose()}}e.$Yd=h;class E{constructor(){this.f=[]}wrapEvent(p){return(S,P,z)=>p(j=>{const R=this.f[this.f.length-1];R?R.push(()=>S.call(P,j)):S.call(P,j)},void 0,z)}bufferEvents(p){const S=[];this.f.push(S);const P=p();return this.f.pop(),S.forEach(z=>z()),P}}e.$Zd=E;class D{constructor(){this.f=!1,this.g=g.None,this.h=f.$Rc.None,this.j=new n({onDidAddFirstListener:()=>{this.f=!0,this.h=this.g(this.j.fire,this.j)},onDidRemoveLastListener:()=>{this.f=!1,this.h.dispose()}}),this.event=this.j.event}set input(p){this.g=p,this.f&&(this.h.dispose(),this.h=p(this.j.fire,this.j))}dispose(){this.h.dispose(),this.j.dispose()}}e.$1d=D}),define(ke[21],Se([1,0,4]),function(me,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2d=e.CancellationToken=void 0;const F=Object.freeze(function(b,v){const g=setTimeout(b.bind(v),0);return{dispose(){clearTimeout(g)}}});var f;(function(b){function v(g){return g===b.None||g===b.Cancelled||g instanceof L?!0:!g||typeof g!="object"?!1:typeof g.isCancellationRequested=="boolean"&&typeof g.onCancellationRequested=="function"}b.isCancellationToken=v,b.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:C.Event.None}),b.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:F})})(f||(e.CancellationToken=f={}));class L{constructor(){this.a=!1,this.b=null}cancel(){this.a||(this.a=!0,this.b&&(this.b.fire(void 0),this.dispose()))}get isCancellationRequested(){return this.a}get onCancellationRequested(){return this.a?F:(this.b||(this.b=new C.$Rd),this.b.event)}dispose(){this.b&&(this.b.dispose(),this.b=null)}}class M{constructor(v){this.f=void 0,this.g=void 0,this.g=v&&v.onCancellationRequested(this.cancel,this)}get token(){return this.f||(this.f=new L),this.f}cancel(){this.f?this.f instanceof L&&this.f.cancel():this.f=f.Cancelled}dispose(v=!1){v&&this.cancel(),this.g?.dispose(),this.f?this.f instanceof L&&this.f.dispose():this.f=f.None}}e.$2d=M}),define(ke[162],Se([1,0,21]),function(me,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ce=e.$Be=e.$Ae=void 0;class F{constructor(b){this.b=b,this.a=null}get(){if(this.a)return this.a;const b=new C.$2d,v=this.b(b.token);return this.a={promise:v,dispose:()=>{this.a=null,b.cancel(),b.dispose()}},this.a}}e.$Ae=F;class f{constructor(b){this.c=b,this.a=void 0,this.b=void 0}get(b){const v=JSON.stringify(b);return this.b!==v&&(this.b=v,this.a=this.c(b)),this.a}}e.$Be=f;class L{get cachedValues(){return this.a}constructor(b){this.b=b,this.a=new Map}get(b){if(this.a.has(b))return this.a.get(b);const v=this.b(b);return this.a.set(b,v),v}}e.$Ce=L}),define(ke[98],Se([1,0,8,3]),function(me,e,C,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ee=e.$de=e.$ce=e.$be=e.$ae=e.$_d=e.$$d=e.$0d=e.$9d=e.$8d=e.$7d=e.$6d=e.$5d=e.$4d=e.$3d=void 0;function f(r){const a=r;return a?typeof a.read=="function":!1}e.$3d=f;function L(r){const a=r;return a?[a.on,a.pause,a.resume,a.destroy].every(t=>typeof t=="function"):!1}e.$4d=L;function M(r){const a=r;return a?L(a.stream)&&Array.isArray(a.buffer)&&typeof a.ended=="boolean":!1}e.$5d=M;function b(r,a){return new v(r,a)}e.$6d=b;class v{constructor(a,t){this.e=a,this.f=t,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(a){if(!this.a.destroyed){if(this.a.flowing)this.g(a);else if(this.b.data.push(a),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(t=>this.d.push(t))}}error(a){this.a.destroyed||(this.a.flowing?this.h(a):this.b.error.push(a))}end(a){this.a.destroyed||(typeof a<"u"&&this.write(a),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(a){this.c.data.slice(0).forEach(t=>t(a))}h(a){this.c.error.length===0?(0,C.$Z)(a):this.c.error.slice(0).forEach(t=>t(a))}i(){this.c.end.slice(0).forEach(a=>a())}on(a,t){if(!this.a.destroyed)switch(a){case"data":this.c.data.push(t),this.resume();break;case"end":this.c.end.push(t),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(t),this.a.flowing&&this.k();break}}removeListener(a,t){if(this.a.destroyed)return;let s;switch(a){case"data":s=this.c.data;break;case"end":s=this.c.end;break;case"error":s=this.c.error;break}if(s){const d=s.indexOf(t);d>=0&&s.splice(d,1)}}j(){if(this.b.data.length>0){const a=this.e(this.b.data);this.g(a),this.b.data.length=0;const t=[...this.d];this.d.length=0,t.forEach(s=>s())}}k(){if(this.c.error.length>0){for(const a of this.b.error)this.h(a);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function g(r,a){const t=[];let s;for(;(s=r.read())!==null;)t.push(s);return a(t)}e.$7d=g;function A(r,a,t){const s=[];let d;for(;(d=r.read())!==null&&s.length<t;)s.push(d);return d===null&&s.length>0?a(s):{read:()=>{if(s.length>0)return s.shift();if(typeof d<"u"){const c=d;return d=void 0,c}return r.read()}}}e.$8d=A;function I(r,a){return new Promise((t,s)=>{const d=[];$(r,{onData:c=>{a&&d.push(c)},onError:c=>{a?s(c):t(void 0)},onEnd:()=>{t(a?a(d):void 0)}})})}e.$9d=I;function $(r,a,t){r.on("error",s=>{t?.isCancellationRequested||a.onError(s)}),r.on("end",()=>{t?.isCancellationRequested||a.onEnd()}),r.on("data",s=>{t?.isCancellationRequested||a.onData(s)})}e.$0d=$;function y(r,a){return new Promise((t,s)=>{const d=new F.$Qc,c=[],l=D=>{if(c.push(D),c.length>a)return d.dispose(),r.pause(),t({stream:r,buffer:c,ended:!1})},h=D=>(d.dispose(),s(D)),E=()=>(d.dispose(),t({stream:r,buffer:c,ended:!0}));d.add((0,F.$Pc)(()=>r.removeListener("error",h))),r.on("error",h),d.add((0,F.$Pc)(()=>r.removeListener("end",E))),r.on("end",E),d.add((0,F.$Pc)(()=>r.removeListener("data",l))),r.on("data",l)})}e.$$d=y;function k(r,a){const t=b(a);return t.end(r),t}e.$_d=k;function w(){const r=b(()=>{throw new Error("not supported")});return r.end(),r}e.$ae=w;function u(r){let a=!1;return{read:()=>a?null:(a=!0,r)}}e.$be=u;function o(r,a,t){const s=b(t);return $(r,{onData:d=>s.write(a.data(d)),onError:d=>s.error(a.error?a.error(d):d),onEnd:()=>s.end()}),s}e.$ce=o;function i(r,a,t){let s=!1;return{read:()=>{const d=a.read();return s?d:(s=!0,d!==null?t([r,d]):r)}}}e.$de=i;function n(r,a,t){let s=!1;const d=b(t);return $(a,{onData:c=>s?d.write(c):(s=!0,d.write(t([r,c]))),onError:c=>d.error(c),onEnd:()=>{s||(s=!0,d.write(r)),d.end()}}),d}e.$ee=n}),define(ke[22],Se([1,0,48,98]),function(me,e,C,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ze=e.$ye=e.$xe=e.$we=e.$ve=e.$ue=e.$te=e.$se=e.$re=e.$qe=e.$pe=e.$oe=e.$ne=e.$me=e.$le=e.$ke=e.$je=e.$ie=e.$he=e.$ge=e.$fe=void 0;const f=typeof Buffer<"u",L=new C.$U(()=>new Uint8Array(256));let M,b;class v{static alloc(S){return f?new v(Buffer.allocUnsafe(S)):new v(new Uint8Array(S))}static wrap(S){return f&&!Buffer.isBuffer(S)&&(S=Buffer.from(S.buffer,S.byteOffset,S.byteLength)),new v(S)}static fromString(S,P){return!(P?.dontUseNodeBuffer||!1)&&f?new v(Buffer.from(S)):(M||(M=new TextEncoder),new v(M.encode(S)))}static fromByteArray(S){const P=v.alloc(S.length);for(let z=0,j=S.length;z<j;z++)P.buffer[z]=S[z];return P}static concat(S,P){if(typeof P>"u"){P=0;for(let R=0,T=S.length;R<T;R++)P+=S[R].byteLength}const z=v.alloc(P);let j=0;for(let R=0,T=S.length;R<T;R++){const N=S[R];z.set(N,j),j+=N.byteLength}return z}constructor(S){this.buffer=S,this.byteLength=this.buffer.byteLength}clone(){const S=v.alloc(this.byteLength);return S.set(this),S}toString(){return f?this.buffer.toString():(b||(b=new TextDecoder),b.decode(this.buffer))}slice(S,P){return new v(this.buffer.subarray(S,P))}set(S,P){if(S instanceof v)this.buffer.set(S.buffer,P);else if(S instanceof Uint8Array)this.buffer.set(S,P);else if(S instanceof ArrayBuffer)this.buffer.set(new Uint8Array(S),P);else if(ArrayBuffer.isView(S))this.buffer.set(new Uint8Array(S.buffer,S.byteOffset,S.byteLength),P);else throw new Error("Unknown argument 'array'")}readUInt32BE(S){return $(this.buffer,S)}writeUInt32BE(S,P){y(this.buffer,S,P)}readUInt32LE(S){return k(this.buffer,S)}writeUInt32LE(S,P){w(this.buffer,S,P)}readUInt8(S){return u(this.buffer,S)}writeUInt8(S,P){o(this.buffer,S,P)}indexOf(S,P=0){return g(this.buffer,S instanceof v?S.buffer:S,P)}}e.$fe=v;function g(p,S,P=0){const z=S.byteLength,j=p.byteLength;if(z===0)return 0;if(z===1)return p.indexOf(S[0]);if(z>j-P)return-1;const R=L.value;R.fill(S.length);for(let W=0;W<S.length;W++)R[S[W]]=S.length-W-1;let T=P+S.length-1,N=T,O=-1;for(;T<j;)if(p[T]===S[N]){if(N===0){O=T;break}T--,N--}else T+=Math.max(S.length-N,R[p[T]]),N=S.length-1;return O}e.$ge=g;function A(p,S){return p[S+0]<<0>>>0|p[S+1]<<8>>>0}e.$he=A;function I(p,S,P){p[P+0]=S&255,S=S>>>8,p[P+1]=S&255}e.$ie=I;function $(p,S){return p[S]*2**24+p[S+1]*2**16+p[S+2]*2**8+p[S+3]}e.$je=$;function y(p,S,P){p[P+3]=S,S=S>>>8,p[P+2]=S,S=S>>>8,p[P+1]=S,S=S>>>8,p[P]=S}e.$ke=y;function k(p,S){return p[S+0]<<0>>>0|p[S+1]<<8>>>0|p[S+2]<<16>>>0|p[S+3]<<24>>>0}e.$le=k;function w(p,S,P){p[P+0]=S&255,S=S>>>8,p[P+1]=S&255,S=S>>>8,p[P+2]=S&255,S=S>>>8,p[P+3]=S&255}e.$me=w;function u(p,S){return p[S]}e.$ne=u;function o(p,S,P){p[P]=S}e.$oe=o;function i(p){return F.$7d(p,S=>v.concat(S))}e.$pe=i;function n(p){return F.$be(p)}e.$qe=n;function r(p){return F.$9d(p,S=>v.concat(S))}e.$re=r;async function a(p){return p.ended?v.concat(p.buffer):v.concat([...p.buffer,await r(p.stream)])}e.$se=a;function t(p){return F.$_d(p,S=>v.concat(S))}e.$te=t;function s(p){return F.$ce(p,{data:S=>typeof S=="string"?v.fromString(S):v.wrap(S)},S=>v.concat(S))}e.$ue=s;function d(p){return F.$6d(S=>v.concat(S),p)}e.$ve=d;function c(p,S){return F.$de(p,S,P=>v.concat(P))}e.$we=c;function l(p,S){return F.$ee(p,S,P=>v.concat(P))}e.$xe=l;function h(p){let S=0,P=0,z=0;const j=new Uint8Array(Math.floor(p.length/4*3)),R=N=>{switch(P){case 3:j[z++]=S|N,P=0;break;case 2:j[z++]=S|N>>>2,S=N<<6,P=3;break;case 1:j[z++]=S|N>>>4,S=N<<4,P=2;break;default:S=N<<2,P=1}};for(let N=0;N<p.length;N++){const O=p.charCodeAt(N);if(O>=65&&O<=90)R(O-65);else if(O>=97&&O<=122)R(O-97+26);else if(O>=48&&O<=57)R(O-48+52);else if(O===43||O===45)R(62);else if(O===47||O===95)R(63);else{if(O===61)break;throw new SyntaxError(`Unexpected base64 character ${p[N]}`)}}const T=z;for(;P>0;)R(0);return v.wrap(j).slice(0,T)}e.$ye=h;const E="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",D="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function m({buffer:p},S=!0,P=!1){const z=P?D:E;let j="";const R=p.byteLength%3;let T=0;for(;T<p.byteLength-R;T+=3){const N=p[T+0],O=p[T+1],W=p[T+2];j+=z[N>>>2],j+=z[(N<<4|O>>>4)&63],j+=z[(O<<2|W>>>6)&63],j+=z[W&63]}if(R===1){const N=p[T+0];j+=z[N>>>2],j+=z[N<<4&63],S&&(j+="==")}else if(R===2){const N=p[T+0],O=p[T+1];j+=z[N>>>2],j+=z[(N<<4|O>>>4)&63],j+=z[O<<2&63],S&&(j+="=")}return j}e.$ze=m}),define(ke[13],Se([1,0,162,48]),function(me,e,C,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bf=e.$Af=e.$zf=e.$yf=e.GraphemeBreakType=e.$xf=e.$wf=e.$vf=e.$uf=e.$tf=e.$sf=e.$rf=e.$qf=e.$pf=e.$of=e.$nf=e.$mf=e.$lf=e.$kf=e.$jf=e.$if=e.$hf=e.$gf=e.$ff=e.$ef=e.$df=e.$cf=e.$bf=e.$af=e.$_e=e.$$e=e.$0e=e.$9e=e.$8e=e.$7e=e.$6e=e.$5e=e.$4e=e.$3e=e.$2e=e.$1e=e.$Ze=e.$Ye=e.$Xe=e.$We=e.$Ve=e.$Ue=e.$Te=e.$Se=e.$Re=e.$Qe=e.$Pe=e.$Oe=e.$Ne=e.$Me=e.$Le=e.$Ke=e.$Je=e.$Ie=e.$He=e.$Ge=e.$Fe=void 0;function f(Ae){return!Ae||typeof Ae!="string"?!0:Ae.trim().length===0}e.$Fe=f;const L=/{(\d+)}/g;function M(Ae,...Oe){return Oe.length===0?Ae:Ae.replace(L,function(Ve,Le){const Ye=parseInt(Le,10);return isNaN(Ye)||Ye<0||Ye>=Oe.length?Ve:Oe[Ye]})}e.$Ge=M;const b=/{([^}]+)}/g;function v(Ae,Oe){return Object.keys(Oe).length===0?Ae:Ae.replace(b,(Ve,Le)=>Oe[Le]??Ve)}e.$He=v;function g(Ae){return Ae.replace(/[<>&]/g,function(Oe){switch(Oe){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return Oe}})}e.$Ie=g;function A(Ae){return Ae.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}e.$Je=A;function I(Ae,Oe){let Ve=0;const Le=Oe.charCodeAt(0);for(let Ye=Ae.length-1;Ye>=0;Ye--)Ae.charCodeAt(Ye)===Le&&Ve++;return Ve}e.$Ke=I;function $(Ae,Oe,Ve="\u2026"){return Ae.length<=Oe?Ae:`${Ae.substr(0,Oe)}${Ve}`}e.$Le=$;function y(Ae,Oe=" "){const Ve=k(Ae,Oe);return w(Ve,Oe)}e.$Me=y;function k(Ae,Oe){if(!Ae||!Oe)return Ae;const Ve=Oe.length;if(Ve===0||Ae.length===0)return Ae;let Le=0;for(;Ae.indexOf(Oe,Le)===Le;)Le=Le+Ve;return Ae.substring(Le)}e.$Ne=k;function w(Ae,Oe){if(!Ae||!Oe)return Ae;const Ve=Oe.length,Le=Ae.length;if(Ve===0||Le===0)return Ae;let Ye=Le,ue=-1;for(;ue=Ae.lastIndexOf(Oe,Ye-1),!(ue===-1||ue+Ve!==Ye);){if(ue===0)return"";Ye=ue}return Ae.substring(0,Ye)}e.$Oe=w;function u(Ae){return Ae.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}e.$Pe=u;function o(Ae){return Ae.replace(/\*/g,"")}e.$Qe=o;function i(Ae,Oe,Ve={}){if(!Ae)throw new Error("Cannot create regex from empty string");Oe||(Ae=A(Ae)),Ve.wholeWord&&(/\B/.test(Ae.charAt(0))||(Ae="\\b"+Ae),/\B/.test(Ae.charAt(Ae.length-1))||(Ae=Ae+"\\b"));let Le="";return Ve.global&&(Le+="g"),Ve.matchCase||(Le+="i"),Ve.multiline&&(Le+="m"),Ve.unicode&&(Le+="u"),new RegExp(Ae,Le)}e.$Re=i;function n(Ae){return Ae.source==="^"||Ae.source==="^$"||Ae.source==="$"||Ae.source==="^\\s*$"?!1:!!(Ae.exec("")&&Ae.lastIndex===0)}e.$Se=n;function r(Ae){return Ae.split(/\r\n|\r|\n/)}e.$Te=r;function a(Ae){for(let Oe=0,Ve=Ae.length;Oe<Ve;Oe++){const Le=Ae.charCodeAt(Oe);if(Le!==32&&Le!==9)return Oe}return-1}e.$Ue=a;function t(Ae,Oe=0,Ve=Ae.length){for(let Le=Oe;Le<Ve;Le++){const Ye=Ae.charCodeAt(Le);if(Ye!==32&&Ye!==9)return Ae.substring(Oe,Le)}return Ae.substring(Oe,Ve)}e.$Ve=t;function s(Ae,Oe=Ae.length-1){for(let Ve=Oe;Ve>=0;Ve--){const Le=Ae.charCodeAt(Ve);if(Le!==32&&Le!==9)return Ve}return-1}e.$We=s;function d(Ae,Oe,Ve){const Le=[];let Ye=0;for(const ue of Ae.matchAll(Oe)){if(Le.push(Ae.slice(Ye,ue.index)),ue.index===void 0)throw new Error("match.index should be defined");Ye=ue.index+ue[0].length,Le.push(Ve(ue[0],...ue.slice(1),ue.index,Ae,ue.groups))}return Le.push(Ae.slice(Ye)),Promise.all(Le).then(ue=>ue.join(""))}e.$Xe=d;function c(Ae,Oe){return Ae<Oe?-1:Ae>Oe?1:0}e.$Ye=c;function l(Ae,Oe,Ve=0,Le=Ae.length,Ye=0,ue=Oe.length){for(;Ve<Le&&Ye<ue;Ve++,Ye++){const Ke=Ae.charCodeAt(Ve),Ge=Oe.charCodeAt(Ye);if(Ke<Ge)return-1;if(Ke>Ge)return 1}const ce=Le-Ve,Ie=ue-Ye;return ce<Ie?-1:ce>Ie?1:0}e.$Ze=l;function h(Ae,Oe){return E(Ae,Oe,0,Ae.length,0,Oe.length)}e.$1e=h;function E(Ae,Oe,Ve=0,Le=Ae.length,Ye=0,ue=Oe.length){for(;Ve<Le&&Ye<ue;Ve++,Ye++){let Ke=Ae.charCodeAt(Ve),Ge=Oe.charCodeAt(Ye);if(Ke===Ge)continue;if(Ke>=128||Ge>=128)return l(Ae.toLowerCase(),Oe.toLowerCase(),Ve,Le,Ye,ue);m(Ke)&&(Ke-=32),m(Ge)&&(Ge-=32);const _e=Ke-Ge;if(_e!==0)return _e}const ce=Le-Ve,Ie=ue-Ye;return ce<Ie?-1:ce>Ie?1:0}e.$2e=E;function D(Ae){return Ae>=48&&Ae<=57}e.$3e=D;function m(Ae){return Ae>=97&&Ae<=122}e.$4e=m;function p(Ae){return Ae>=65&&Ae<=90}e.$5e=p;function S(Ae,Oe){return Ae.length===Oe.length&&E(Ae,Oe)===0}e.$6e=S;function P(Ae,Oe){const Ve=Oe.length;return Oe.length>Ae.length?!1:E(Ae,Oe,0,Ve)===0}e.$7e=P;function z(Ae,Oe){const Ve=Math.min(Ae.length,Oe.length);let Le;for(Le=0;Le<Ve;Le++)if(Ae.charCodeAt(Le)!==Oe.charCodeAt(Le))return Le;return Ve}e.$8e=z;function j(Ae,Oe){const Ve=Math.min(Ae.length,Oe.length);let Le;const Ye=Ae.length-1,ue=Oe.length-1;for(Le=0;Le<Ve;Le++)if(Ae.charCodeAt(Ye-Le)!==Oe.charCodeAt(ue-Le))return Le;return Ve}e.$9e=j;function R(Ae){return 55296<=Ae&&Ae<=56319}e.$0e=R;function T(Ae){return 56320<=Ae&&Ae<=57343}e.$$e=T;function N(Ae,Oe){return(Ae-55296<<10)+(Oe-56320)+65536}e.$_e=N;function O(Ae,Oe,Ve){const Le=Ae.charCodeAt(Ve);if(R(Le)&&Ve+1<Oe){const Ye=Ae.charCodeAt(Ve+1);if(T(Ye))return N(Le,Ye)}return Le}e.$af=O;function W(Ae,Oe){const Ve=Ae.charCodeAt(Oe-1);if(T(Ve)&&Oe>1){const Le=Ae.charCodeAt(Oe-2);if(R(Le))return N(Le,Ve)}return Ve}class x{get offset(){return this.e}constructor(Oe,Ve=0){this.c=Oe,this.d=Oe.length,this.e=Ve}setOffset(Oe){this.e=Oe}prevCodePoint(){const Oe=W(this.c,this.e);return this.e-=Oe>=65536?2:1,Oe}nextCodePoint(){const Oe=O(this.c,this.d,this.e);return this.e+=Oe>=65536?2:1,Oe}eol(){return this.e>=this.d}}e.$bf=x;class le{get offset(){return this.c.offset}constructor(Oe,Ve=0){this.c=new x(Oe,Ve)}nextGraphemeLength(){const Oe=ge.getInstance(),Ve=this.c,Le=Ve.offset;let Ye=Oe.getGraphemeBreakType(Ve.nextCodePoint());for(;!Ve.eol();){const ue=Ve.offset,ce=Oe.getGraphemeBreakType(Ve.nextCodePoint());if(ae(Ye,ce)){Ve.setOffset(ue);break}Ye=ce}return Ve.offset-Le}prevGraphemeLength(){const Oe=ge.getInstance(),Ve=this.c,Le=Ve.offset;let Ye=Oe.getGraphemeBreakType(Ve.prevCodePoint());for(;Ve.offset>0;){const ue=Ve.offset,ce=Oe.getGraphemeBreakType(Ve.prevCodePoint());if(ae(ce,Ye)){Ve.setOffset(ue);break}Ye=ce}return Le-Ve.offset}eol(){return this.c.eol()}}e.$cf=le;function G(Ae,Oe){return new le(Ae,Oe).nextGraphemeLength()}e.$df=G;function J(Ae,Oe){return new le(Ae,Oe).prevGraphemeLength()}e.$ef=J;function Q(Ae,Oe){Oe>0&&T(Ae.charCodeAt(Oe))&&Oe--;const Ve=Oe+G(Ae,Oe);return[Ve-J(Ae,Ve),Ve]}e.$ff=Q;function oe(Ae){const Oe=new le(Ae);let Ve=0;for(;!Oe.eol();)Ve++,Oe.nextGraphemeLength();return Ve}e.$gf=oe;let _;function Ee(){return/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/}function he(Ae){return _||(_=Ee()),_.test(Ae)}e.$hf=he;const q=/^[\t\n\r\x20-\x7E]*$/;function U(Ae){return q.test(Ae)}e.$if=U,e.$jf=/[\u2028\u2029]/;function ie(Ae){return e.$jf.test(Ae)}e.$kf=ie;function be(Ae){return Ae>=11904&&Ae<=55215||Ae>=63744&&Ae<=64255||Ae>=65281&&Ae<=65374}e.$lf=be;function H(Ae){return Ae>=127462&&Ae<=127487||Ae===8986||Ae===8987||Ae===9200||Ae===9203||Ae>=9728&&Ae<=10175||Ae===11088||Ae===11093||Ae>=127744&&Ae<=128591||Ae>=128640&&Ae<=128764||Ae>=128992&&Ae<=129008||Ae>=129280&&Ae<=129535||Ae>=129648&&Ae<=129782}e.$mf=H;function Y(Ae,Oe){if(Ae.length<Oe)return Ae;const Ve=/\b/g;let Le=0;for(;Ve.test(Ae)&&!(Ae.length-Ve.lastIndex<Oe);)Le=Ve.lastIndex,Ve.lastIndex+=1;return Ae.substring(Le).replace(/^\s/,"")}e.$nf=Y;const Z=/(:?\x1b\[|\x9B)[=?>!]?[\d;:]*["$#'* ]?[a-zA-Z@^`{}|~]/g,$e=/\x1b\].*?\x07/g;function ne(Ae){return Ae&&(Ae=Ae.replace(Z,"").replace($e,"")),Ae}e.$of=ne,e.$pf=String.fromCharCode(65279);function fe(Ae){return!!(Ae&&Ae.length>0&&Ae.charCodeAt(0)===65279)}e.$qf=fe;function te(Ae){return fe(Ae)?Ae.substr(1):Ae}e.$rf=te;function de(Ae,Oe){if(!Ae||!Oe||Ae.length<Oe.length)return!1;const Ve=Oe.length,Le=Ae.toLowerCase();let Ye=0,ue=-1;for(;Ye<Ve;){const ce=Le.indexOf(Oe[Ye],ue+1);if(ce<0)return!1;ue=ce,Ye++}return!0}e.$sf=de;function pe(Ae,Oe=!1){return Ae?(Oe&&(Ae=Ae.replace(/\\./g,"")),Ae.toLowerCase()!==Ae):!1}e.$tf=pe;function Pe(Ae){return Ae.charAt(0).toUpperCase()+Ae.slice(1)}e.$uf=Pe;function B(Ae,Oe=1){if(Oe===0)return"";let Ve=-1;do Ve=Ae.indexOf(`
`,Ve+1),Oe--;while(Oe>0&&Ve>=0);return Ve===-1?Ae:(Ae[Ve-1]==="\r"&&Ve--,Ae.substr(0,Ve))}e.$vf=B;function X(Ae){return Ae=Ae%(2*26),Ae<26?String.fromCharCode(97+Ae):String.fromCharCode(65+Ae-26)}e.$wf=X;function re(Ae){return ge.getInstance().getGraphemeBreakType(Ae)}e.$xf=re;function ae(Ae,Oe){return Ae===0?Oe!==5&&Oe!==7:Ae===2&&Oe===3?!1:Ae===4||Ae===2||Ae===3||Oe===4||Oe===2||Oe===3?!0:!(Ae===8&&(Oe===8||Oe===9||Oe===11||Oe===12)||(Ae===11||Ae===9)&&(Oe===9||Oe===10)||(Ae===12||Ae===10)&&Oe===10||Oe===5||Oe===13||Oe===7||Ae===1||Ae===13&&Oe===14||Ae===6&&Oe===6)}var ee;(function(Ae){Ae[Ae.Other=0]="Other",Ae[Ae.Prepend=1]="Prepend",Ae[Ae.CR=2]="CR",Ae[Ae.LF=3]="LF",Ae[Ae.Control=4]="Control",Ae[Ae.Extend=5]="Extend",Ae[Ae.Regional_Indicator=6]="Regional_Indicator",Ae[Ae.SpacingMark=7]="SpacingMark",Ae[Ae.L=8]="L",Ae[Ae.V=9]="V",Ae[Ae.T=10]="T",Ae[Ae.LV=11]="LV",Ae[Ae.LVT=12]="LVT",Ae[Ae.ZWJ=13]="ZWJ",Ae[Ae.Extended_Pictographic=14]="Extended_Pictographic"})(ee||(e.GraphemeBreakType=ee={}));class ge{static{this.c=null}static getInstance(){return ge.c||(ge.c=new ge),ge.c}constructor(){this.d=ye()}getGraphemeBreakType(Oe){if(Oe<32)return Oe===10?3:Oe===13?2:4;if(Oe<127)return 0;const Ve=this.d,Le=Ve.length/3;let Ye=1;for(;Ye<=Le;)if(Oe<Ve[3*Ye])Ye=2*Ye;else if(Oe>Ve[3*Ye+1])Ye=2*Ye+1;else return Ve[3*Ye+2];return 0}}function ye(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function je(Ae,Oe){if(Ae===0)return 0;const Ve=We(Ae,Oe);if(Ve!==void 0)return Ve;const Le=new x(Oe,Ae);return Le.prevCodePoint(),Le.offset}e.$yf=je;function We(Ae,Oe){const Ve=new x(Oe,Ae);let Le=Ve.prevCodePoint();for(;et(Le)||Le===65039||Le===8419;){if(Ve.offset===0)return;Le=Ve.prevCodePoint()}if(!H(Le))return;let Ye=Ve.offset;return Ye>0&&Ve.prevCodePoint()===8205&&(Ye=Ve.offset),Ye}function et(Ae){return 127995<=Ae&&Ae<=127999}var Ze;(function(Ae){Ae[Ae.zwj=8205]="zwj",Ae[Ae.emojiVariantSelector=65039]="emojiVariantSelector",Ae[Ae.enclosingKeyCap=8419]="enclosingKeyCap"})(Ze||(Ze={})),e.$zf="\xA0";class rt{static{this.c=new F.$U(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125,119846,109],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}'))}static{this.d=new C.$Be(Oe=>{function Ve(_e){const st=new Map;for(let lt=0;lt<_e.length;lt+=2)st.set(_e[lt],_e[lt+1]);return st}function Le(_e,st){const lt=new Map(_e);for(const[wt,Ue]of st)lt.set(wt,Ue);return lt}function Ye(_e,st){if(!_e)return st;const lt=new Map;for(const[wt,Ue]of _e)st.has(wt)&&lt.set(wt,Ue);return lt}const ue=this.c.value;let ce=Oe.filter(_e=>!_e.startsWith("_")&&_e in ue);ce.length===0&&(ce=["_default"]);let Ie;for(const _e of ce){const st=Ve(ue[_e]);Ie=Ye(Ie,st)}const Ke=Ve(ue._common),Ge=Le(Ke,Ie);return new rt(Ge)})}static getInstance(Oe){return rt.d.get(Array.from(Oe))}static{this.e=new F.$U(()=>Object.keys(rt.c.value).filter(Oe=>!Oe.startsWith("_")))}static getLocales(){return rt.e.value}constructor(Oe){this.f=Oe}isAmbiguous(Oe){return this.f.has(Oe)}getPrimaryConfusable(Oe){return this.f.get(Oe)}getConfusableCodePoints(){return new Set(this.f.keys())}}e.$Af=rt;class nt{static c(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static{this.d=void 0}static e(){return this.d||(this.d=new Set(nt.c())),this.d}static isInvisibleCharacter(Oe){return nt.e().has(Oe)}static get codePoints(){return nt.e()}}e.$Bf=nt}),define(ke[124],Se([1,0,28,13]),function(me,e,C,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xj=e.$Wj=e.$Vj=e.$Uj=e.FuzzyScore=e.$Tj=e.$Sj=e.$Rj=e.$Qj=e.$Pj=e.$Oj=e.$Nj=e.$Mj=e.$Lj=e.$Kj=e.$Jj=e.$Ij=e.or=void 0;function f(...te){return function(de,pe){for(let Pe=0,B=te.length;Pe<B;Pe++){const X=te[Pe](de,pe);if(X)return X}return null}}e.or=f,e.$Ij=L.bind(void 0,!1),e.$Jj=L.bind(void 0,!0);function L(te,de,pe){if(!pe||pe.length<de.length)return null;let Pe;return te?Pe=F.$7e(pe,de):Pe=pe.indexOf(de)===0,Pe?de.length>0?[{start:0,end:de.length}]:[]:null}function M(te,de){const pe=de.toLowerCase().indexOf(te.toLowerCase());return pe===-1?null:[{start:pe,end:pe+te.length}]}e.$Kj=M;function b(te,de){return v(te.toLowerCase(),de.toLowerCase(),0,0)}e.$Lj=b;function v(te,de,pe,Pe){if(pe===te.length)return[];if(Pe===de.length)return null;if(te[pe]===de[Pe]){let B=null;return(B=v(te,de,pe+1,Pe+1))?o({start:Pe,end:Pe+1},B):null}return v(te,de,pe,Pe+1)}function g(te){return 97<=te&&te<=122}function A(te){return 65<=te&&te<=90}e.$Mj=A;function I(te){return 48<=te&&te<=57}function $(te){return te===32||te===9||te===10||te===13}const y=new Set;"()[]{}<>`'\"-/;:,.?!".split("").forEach(te=>y.add(te.charCodeAt(0)));function k(te){return $(te)||y.has(te)}function w(te,de){return te===de||k(te)&&k(de)}function u(te){return g(te)||A(te)||I(te)}function o(te,de){return de.length===0?de=[te]:te.end===de[0].start?de[0].start=te.start:de.unshift(te),de}function i(te,de){for(let pe=de;pe<te.length;pe++){const Pe=te.charCodeAt(pe);if(A(Pe)||I(Pe)||pe>0&&!u(te.charCodeAt(pe-1)))return pe}return te.length}function n(te,de,pe,Pe){if(pe===te.length)return[];if(Pe===de.length)return null;if(te[pe]!==de[Pe].toLowerCase())return null;{let B=null,X=Pe+1;for(B=n(te,de,pe+1,Pe+1);!B&&(X=i(de,X))<de.length;)B=n(te,de,pe+1,X),X++;return B===null?null:o({start:Pe,end:Pe+1},B)}}function r(te){let de=0,pe=0,Pe=0,B=0,X=0;for(let ye=0;ye<te.length;ye++)X=te.charCodeAt(ye),A(X)&&de++,g(X)&&pe++,u(X)&&Pe++,I(X)&&B++;const re=de/te.length,ae=pe/te.length,ee=Pe/te.length,ge=B/te.length;return{upperPercent:re,lowerPercent:ae,alphaPercent:ee,numericPercent:ge}}function a(te){const{upperPercent:de,lowerPercent:pe}=te;return pe===0&&de>.6}function t(te){const{upperPercent:de,lowerPercent:pe,alphaPercent:Pe,numericPercent:B}=te;return pe>.2&&de<.8&&Pe>.6&&B<.2}function s(te){let de=0,pe=0,Pe=0,B=0;for(let X=0;X<te.length;X++)Pe=te.charCodeAt(X),A(Pe)&&de++,g(Pe)&&pe++,$(Pe)&&B++;return(de===0||pe===0)&&B===0?te.length<=30:de<=5}function d(te,de){if(!de||(de=de.trim(),de.length===0)||!s(te)||de.length>60)return null;const pe=r(de);if(!t(pe)){if(!a(pe))return null;de=de.toLowerCase()}let Pe=null,B=0;for(te=te.toLowerCase();B<de.length&&(Pe=n(te,de,0,B))===null;)B=i(de,B+1);return Pe}e.$Nj=d;function c(te,de,pe=!1){if(!de||de.length===0)return null;let Pe=null,B=0;for(te=te.toLowerCase(),de=de.toLowerCase();B<de.length&&(Pe=l(te,de,0,B,pe))===null;)B=h(de,B+1);return Pe}e.$Oj=c;function l(te,de,pe,Pe,B){if(pe===te.length)return[];if(Pe===de.length)return null;if(w(te.charCodeAt(pe),de.charCodeAt(Pe))){let X=null,re=Pe+1;if(X=l(te,de,pe+1,Pe+1,B),!B)for(;!X&&(re=h(de,re))<de.length;)X=l(te,de,pe+1,re,B),re++;return X?te.charCodeAt(pe)!==de.charCodeAt(Pe)?X:o({start:Pe,end:Pe+1},X):null}else return null}function h(te,de){for(let pe=de;pe<te.length;pe++)if(k(te.charCodeAt(pe))||pe>0&&k(te.charCodeAt(pe-1)))return pe;return te.length}const E=f(e.$Jj,d,M),D=f(e.$Jj,d,b),m=new C.$Cc(1e4);function p(te,de,pe=!1){if(typeof te!="string"||typeof de!="string")return null;let Pe=m.get(te);Pe||(Pe=new RegExp(F.$Pe(te),"i"),m.set(te,Pe));const B=Pe.exec(de);return B?[{start:B.index,end:B.index+B[0].length}]:pe?D(te,de):E(te,de)}e.$Pj=p;function S(te,de){const pe=be(te,te.toLowerCase(),0,de,de.toLowerCase(),0,{firstMatchCanBeWeak:!0,boostFullMatch:!0});return pe?z(pe):null}e.$Qj=S;function P(te,de,pe,Pe,B,X){const re=Math.min(13,te.length);for(;pe<re;pe++){const ae=be(te,de,pe,Pe,B,X,{firstMatchCanBeWeak:!0,boostFullMatch:!0});if(ae)return ae}return[0,X]}e.$Rj=P;function z(te){if(typeof te>"u")return[];const de=[],pe=te[1];for(let Pe=te.length-1;Pe>1;Pe--){const B=te[Pe]+pe,X=de[de.length-1];X&&X.end===B?X.end=B+1:de.push({start:B,end:B+1})}return de}e.$Sj=z;const j=128;function R(){const te=[],de=[];for(let pe=0;pe<=j;pe++)de[pe]=0;for(let pe=0;pe<=j;pe++)te.push(de.slice(0));return te}function T(te){const de=[];for(let pe=0;pe<=te;pe++)de[pe]=0;return de}const N=T(2*j),O=T(2*j),W=R(),x=R(),le=R(),G=!1;function J(te,de,pe,Pe,B){function X(ae,ee,ge=" "){for(;ae.length<ee;)ae=ge+ae;return ae}let re=` |   |${Pe.split("").map(ae=>X(ae,3)).join("|")}
`;for(let ae=0;ae<=pe;ae++)ae===0?re+=" |":re+=`${de[ae-1]}|`,re+=te[ae].slice(0,B+1).map(ee=>X(ee.toString(),3)).join("|")+`
`;return re}function Q(te,de,pe,Pe){te=te.substr(de),pe=pe.substr(Pe),console.log(J(x,te,te.length,pe,pe.length)),console.log(J(le,te,te.length,pe,pe.length)),console.log(J(W,te,te.length,pe,pe.length))}function oe(te,de){if(de<0||de>=te.length)return!1;const pe=te.codePointAt(de);switch(pe){case 95:case 45:case 46:case 32:case 47:case 92:case 39:case 34:case 58:case 36:case 60:case 62:case 40:case 41:case 91:case 93:case 123:case 125:return!0;case void 0:return!1;default:return!!F.$mf(pe)}}function _(te,de){if(de<0||de>=te.length)return!1;switch(te.charCodeAt(de)){case 32:case 9:return!0;default:return!1}}function Ee(te,de,pe){return de[te]!==pe[te]}function he(te,de,pe,Pe,B,X,re=!1){for(;de<pe&&B<X;)te[de]===Pe[B]&&(re&&(N[de]=B),de+=1),B+=1;return de===pe}e.$Tj=he;var q;(function(te){te[te.Diag=1]="Diag",te[te.Left=2]="Left",te[te.LeftLeft=3]="LeftLeft"})(q||(q={}));var U;(function(te){te.Default=[-100,0];function de(pe){return!pe||pe.length===2&&pe[0]===-100&&pe[1]===0}te.isDefault=de})(U||(e.FuzzyScore=U={}));class ie{static{this.default={boostFullMatch:!0,firstMatchCanBeWeak:!1}}constructor(de,pe){this.firstMatchCanBeWeak=de,this.boostFullMatch=pe}}e.$Uj=ie;function be(te,de,pe,Pe,B,X,re=ie.default){const ae=te.length>j?j:te.length,ee=Pe.length>j?j:Pe.length;if(pe>=ae||X>=ee||ae-pe>ee-X||!he(de,pe,ae,B,X,ee,!0))return;H(ae,ee,pe,X,de,B);let ge=1,ye=1,je=pe,We=X;const et=[!1];for(ge=1,je=pe;je<ae;ge++,je++){const Oe=N[je],Ve=O[je],Le=je+1<ae?O[je+1]:ee;for(ye=Oe-X+1,We=Oe;We<Le;ye++,We++){let Ye=Number.MIN_SAFE_INTEGER,ue=!1;We<=Ve&&(Ye=Y(te,de,je,pe,Pe,B,We,ee,X,W[ge-1][ye-1]===0,et));let ce=0;Ye!==Number.MAX_SAFE_INTEGER&&(ue=!0,ce=Ye+x[ge-1][ye-1]);const Ie=We>Oe,Ke=Ie?x[ge][ye-1]+(W[ge][ye-1]>0?-5:0):0,Ge=We>Oe+1&&W[ge][ye-1]>0,_e=Ge?x[ge][ye-2]+(W[ge][ye-2]>0?-5:0):0;if(Ge&&(!Ie||_e>=Ke)&&(!ue||_e>=ce))x[ge][ye]=_e,le[ge][ye]=3,W[ge][ye]=0;else if(Ie&&(!ue||Ke>=ce))x[ge][ye]=Ke,le[ge][ye]=2,W[ge][ye]=0;else if(ue)x[ge][ye]=ce,le[ge][ye]=1,W[ge][ye]=W[ge-1][ye-1]+1;else throw new Error("not possible")}}if(G&&Q(te,pe,Pe,X),!et[0]&&!re.firstMatchCanBeWeak)return;ge--,ye--;const Ze=[x[ge][ye],X];let rt=0,nt=0;for(;ge>=1;){let Oe=ye;do{const Ve=le[ge][Oe];if(Ve===3)Oe=Oe-2;else if(Ve===2)Oe=Oe-1;else break}while(Oe>=1);rt>1&&de[pe+ge-1]===B[X+ye-1]&&!Ee(Oe+X-1,Pe,B)&&rt+1>W[ge][Oe]&&(Oe=ye),Oe===ye?rt++:rt=1,nt||(nt=Oe),ge--,ye=Oe-1,Ze.push(ye)}ee===ae&&re.boostFullMatch&&(Ze[0]+=2);const Ae=nt-ae;return Ze[0]-=Ae,Ze}e.$Vj=be;function H(te,de,pe,Pe,B,X){let re=te-1,ae=de-1;for(;re>=pe&&ae>=Pe;)B[re]===X[ae]&&(O[re]=ae,re--),ae--}function Y(te,de,pe,Pe,B,X,re,ae,ee,ge,ye){if(de[pe]!==X[re])return Number.MIN_SAFE_INTEGER;let je=1,We=!1;return re===pe-Pe?je=te[pe]===B[re]?7:5:Ee(re,B,X)&&(re===0||!Ee(re-1,B,X))?(je=te[pe]===B[re]?7:5,We=!0):oe(X,re)&&(re===0||!oe(X,re-1))?je=5:(oe(X,re-1)||_(X,re-1))&&(je=5,We=!0),je>1&&pe===Pe&&(ye[0]=!0),We||(We=Ee(re,B,X)||oe(X,re-1)||_(X,re-1)),pe===Pe?re>ee&&(je-=We?3:5):ge?je+=We?2:0:je+=We?0:1,re+1===ae&&(je-=We?3:5),je}function Z(te,de,pe,Pe,B,X,re){return ne(te,de,pe,Pe,B,X,!0,re)}e.$Wj=Z;function $e(te,de,pe,Pe,B,X,re){return ne(te,de,pe,Pe,B,X,!1,re)}e.$Xj=$e;function ne(te,de,pe,Pe,B,X,re,ae){let ee=be(te,de,pe,Pe,B,X,ae);if(ee&&!re)return ee;if(te.length>=3){const ge=Math.min(7,te.length-1);for(let ye=pe+1;ye<ge;ye++){const je=fe(te,ye);if(je){const We=be(je,je.toLowerCase(),pe,Pe,B,X,ae);We&&(We[0]-=3,(!ee||We[0]>ee[0])&&(ee=We))}}}return ee}function fe(te,de){if(de+1>=te.length)return;const pe=te[de],Pe=te[de+1];if(pe!==Pe)return te.slice(0,de)+Pe+pe+te.slice(de+2)}}),define(ke[52],Se([1,0,13]),function(me,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pi=e.$Oi=e.$Ni=e.$Mi=e.$Li=e.$Ki=e.$Ji=void 0;function F(o){return f(o,0)}e.$Ji=F;function f(o,i){switch(typeof o){case"object":return o===null?L(349,i):Array.isArray(o)?v(o,i):g(o,i);case"string":return b(o,i);case"boolean":return M(o,i);case"number":return L(o,i);case"undefined":return L(937,i);default:return L(617,i)}}e.$Ki=f;function L(o,i){return(i<<5)-i+o|0}e.$Li=L;function M(o,i){return L(o?433:863,i)}function b(o,i){i=L(149417,i);for(let n=0,r=o.length;n<r;n++)i=L(o.charCodeAt(n),i);return i}e.$Mi=b;function v(o,i){return i=L(104579,i),o.reduce((n,r)=>f(r,n),i)}function g(o,i){return i=L(181387,i),Object.keys(o).sort().reduce((n,r)=>(n=b(r,n),f(o[r],n)),i)}class A{constructor(){this.g=0}get value(){return this.g}hash(i){return this.g=f(i,this.g),this.g}}e.$Ni=A;var I;(function(o){o[o.BLOCK_SIZE=64]="BLOCK_SIZE",o[o.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(I||(I={}));function $(o,i,n=32){const r=n-i,a=~((1<<r)-1);return(o<<i|(a&o)>>>r)>>>0}function y(o,i=0,n=o.byteLength,r=0){for(let a=0;a<n;a++)o[i+a]=r}function k(o,i,n="0"){for(;o.length<i;)o=n+o;return o}function w(o,i=32){return o instanceof ArrayBuffer?Array.from(new Uint8Array(o)).map(n=>n.toString(16).padStart(2,"0")).join(""):k((o>>>0).toString(16),i/4)}e.$Oi=w;class u{static{this.g=new DataView(new ArrayBuffer(320))}constructor(){this.h=1732584193,this.l=4023233417,this.m=2562383102,this.n=271733878,this.o=3285377520,this.p=new Uint8Array(64+3),this.q=new DataView(this.p.buffer),this.r=0,this.t=0,this.u=0,this.v=!1}update(i){const n=i.length;if(n===0)return;const r=this.p;let a=this.r,t=this.u,s,d;for(t!==0?(s=t,d=-1,t=0):(s=i.charCodeAt(0),d=0);;){let c=s;if(C.$0e(s))if(d+1<n){const l=i.charCodeAt(d+1);C.$$e(l)?(d++,c=C.$_e(s,l)):c=65533}else{t=s;break}else C.$$e(s)&&(c=65533);if(a=this.w(r,a,c),d++,d<n)s=i.charCodeAt(d);else break}this.r=a,this.u=t}w(i,n,r){return r<128?i[n++]=r:r<2048?(i[n++]=192|(r&1984)>>>6,i[n++]=128|(r&63)>>>0):r<65536?(i[n++]=224|(r&61440)>>>12,i[n++]=128|(r&4032)>>>6,i[n++]=128|(r&63)>>>0):(i[n++]=240|(r&1835008)>>>18,i[n++]=128|(r&258048)>>>12,i[n++]=128|(r&4032)>>>6,i[n++]=128|(r&63)>>>0),n>=64&&(this.y(),n-=64,this.t+=64,i[0]=i[64+0],i[1]=i[64+1],i[2]=i[64+2]),n}digest(){return this.v||(this.v=!0,this.u&&(this.u=0,this.r=this.w(this.p,this.r,65533)),this.t+=this.r,this.x()),w(this.h)+w(this.l)+w(this.m)+w(this.n)+w(this.o)}x(){this.p[this.r++]=128,y(this.p,this.r),this.r>56&&(this.y(),y(this.p));const i=8*this.t;this.q.setUint32(56,Math.floor(i/4294967296),!1),this.q.setUint32(60,i%4294967296,!1),this.y()}y(){const i=u.g,n=this.q;for(let E=0;E<64;E+=4)i.setUint32(E,n.getUint32(E,!1),!1);for(let E=64;E<320;E+=4)i.setUint32(E,$(i.getUint32(E-12,!1)^i.getUint32(E-32,!1)^i.getUint32(E-56,!1)^i.getUint32(E-64,!1),1),!1);let r=this.h,a=this.l,t=this.m,s=this.n,d=this.o,c,l,h;for(let E=0;E<80;E++)E<20?(c=a&t|~a&s,l=1518500249):E<40?(c=a^t^s,l=1859775393):E<60?(c=a&t|a&s|t&s,l=2400959708):(c=a^t^s,l=3395469782),h=$(r,5)+c+d+l+i.getUint32(E*4,!1)&4294967295,d=s,s=t,t=$(a,30),a=r,r=h;this.h=this.h+r&4294967295,this.l=this.l+a&4294967295,this.m=this.m+t&4294967295,this.n=this.n+s&4294967295,this.o=this.o+d&4294967295}}e.$Pi=u}),define(ke[39],Se([1,0,13]),function(me,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var F;(function(f){f[f.Ignore=0]="Ignore",f[f.Info=1]="Info",f[f.Warning=2]="Warning",f[f.Error=3]="Error"})(F||(F={})),function(f){const L="error",M="warning",b="warn",v="info",g="ignore";function A($){return $?C.$6e(L,$)?f.Error:C.$6e(M,$)||C.$6e(b,$)?f.Warning:C.$6e(v,$)?f.Info:f.Ignore:f.Ignore}f.fromValue=A;function I($){switch($){case f.Error:return L;case f.Warning:return M;case f.Info:return v;default:return g}}f.toString=I}(F||(F={})),e.default=F}),define(ke[163],Se([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Od=void 0,e.$Od=Symbol("MicrotaskDelay")}),define(ke[77],Se([1,0,19,13]),function(me,e,C,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2h=e.$1h=e.$Zh=e.$Yh=e.$Xh=void 0;class f{constructor(){this.b="",this.c=0}reset(y){return this.b=y,this.c=0,this}next(){return this.c+=1,this}hasNext(){return this.c<this.b.length-1}cmp(y){const k=y.charCodeAt(0),w=this.b.charCodeAt(this.c);return k-w}value(){return this.b[this.c]}}e.$Xh=f;class L{constructor(y=!0){this.e=y}reset(y){return this.b=y,this.c=0,this.d=0,this.next()}hasNext(){return this.d<this.b.length}next(){this.c=this.d;let y=!0;for(;this.d<this.b.length;this.d++)if(this.b.charCodeAt(this.d)===46)if(y)this.c++;else break;else y=!1;return this}cmp(y){return this.e?(0,F.$Ze)(y,this.b,0,y.length,this.c,this.d):(0,F.$2e)(y,this.b,0,y.length,this.c,this.d)}value(){return this.b.substring(this.c,this.d)}}e.$Yh=L;class M{constructor(y=!0,k=!0){this.f=y,this.g=k}reset(y){this.d=0,this.e=0,this.b=y,this.c=y.length;for(let k=y.length-1;k>=0;k--,this.c--){const w=this.b.charCodeAt(k);if(!(w===47||this.f&&w===92))break}return this.next()}hasNext(){return this.e<this.c}next(){this.d=this.e;let y=!0;for(;this.e<this.c;this.e++){const k=this.b.charCodeAt(this.e);if(k===47||this.f&&k===92)if(y)this.d++;else break;else y=!1}return this}cmp(y){return this.g?(0,F.$Ze)(y,this.b,0,y.length,this.d,this.e):(0,F.$2e)(y,this.b,0,y.length,this.d,this.e)}value(){return this.b.substring(this.d,this.e)}}e.$Zh=M;var b;(function($){$[$.Scheme=1]="Scheme",$[$.Authority=2]="Authority",$[$.Path=3]="Path",$[$.Query=4]="Query",$[$.Fragment=5]="Fragment"})(b||(b={}));class v{constructor(y,k){this.f=y,this.g=k,this.d=[],this.e=0}reset(y){return this.c=y,this.d=[],this.c.scheme&&this.d.push(1),this.c.authority&&this.d.push(2),this.c.path&&(this.b=new M(!1,!this.f(y)),this.b.reset(y.path),this.b.value()&&this.d.push(3)),this.g(y)||(this.c.query&&this.d.push(4),this.c.fragment&&this.d.push(5)),this.e=0,this}next(){return this.d[this.e]===3&&this.b.hasNext()?this.b.next():this.e+=1,this}hasNext(){return this.d[this.e]===3&&this.b.hasNext()||this.e<this.d.length-1}cmp(y){if(this.d[this.e]===1)return(0,F.$1e)(y,this.c.scheme);if(this.d[this.e]===2)return(0,F.$1e)(y,this.c.authority);if(this.d[this.e]===3)return this.b.cmp(y);if(this.d[this.e]===4)return(0,F.$Ye)(y,this.c.query);if(this.d[this.e]===5)return(0,F.$Ye)(y,this.c.fragment);throw new Error}value(){if(this.d[this.e]===1)return this.c.scheme;if(this.d[this.e]===2)return this.c.authority;if(this.d[this.e]===3)return this.b.value();if(this.d[this.e]===4)return this.c.query;if(this.d[this.e]===5)return this.c.fragment;throw new Error}}e.$1h=v;class g{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const y=this.right;return this.right=y.left,y.left=this,this.updateHeight(),y.updateHeight(),y}rotateRight(){const y=this.left;return this.left=y.right,y.right=this,this.updateHeight(),y.updateHeight(),y}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var A;(function($){$[$.Left=-1]="Left",$[$.Mid=0]="Mid",$[$.Right=1]="Right"})(A||(A={}));class I{static forUris(y=()=>!1,k=()=>!1){return new I(new v(y,k))}static forPaths(y=!1){return new I(new M(void 0,!y))}static forStrings(){return new I(new f)}static forConfigKeys(){return new I(new L)}constructor(y){this.b=y}clear(){this.c=void 0}fill(y,k){if(k){const w=k.slice(0);(0,C.$Wb)(w);for(const u of w)this.set(u,y)}else{const w=y.slice(0);(0,C.$Wb)(w);for(const u of w)this.set(u[0],u[1])}}set(y,k){const w=this.b.reset(y);let u;this.c||(this.c=new g,this.c.segment=w.value());const o=[];for(u=this.c;;){const n=w.cmp(u.segment);if(n>0)u.left||(u.left=new g,u.left.segment=w.value()),o.push([-1,u]),u=u.left;else if(n<0)u.right||(u.right=new g,u.right.segment=w.value()),o.push([1,u]),u=u.right;else if(w.hasNext())w.next(),u.mid||(u.mid=new g,u.mid.segment=w.value()),o.push([0,u]),u=u.mid;else break}const i=u.value;u.value=k,u.key=y;for(let n=o.length-1;n>=0;n--){const r=o[n][1];r.updateHeight();const a=r.balanceFactor();if(a<-1||a>1){const t=o[n][0],s=o[n+1][0];if(t===1&&s===1)o[n][1]=r.rotateLeft();else if(t===-1&&s===-1)o[n][1]=r.rotateRight();else if(t===1&&s===-1)r.right=o[n+1][1]=o[n+1][1].rotateRight(),o[n][1]=r.rotateLeft();else if(t===-1&&s===1)r.left=o[n+1][1]=o[n+1][1].rotateLeft(),o[n][1]=r.rotateRight();else throw new Error;if(n>0)switch(o[n-1][0]){case-1:o[n-1][1].left=o[n][1];break;case 1:o[n-1][1].right=o[n][1];break;case 0:o[n-1][1].mid=o[n][1];break}else this.c=o[0][1]}}return i}get(y){return this.d(y)?.value}d(y){const k=this.b.reset(y);let w=this.c;for(;w;){const u=k.cmp(w.segment);if(u>0)w=w.left;else if(u<0)w=w.right;else if(k.hasNext())k.next(),w=w.mid;else break}return w}has(y){const k=this.d(y);return!(k?.value===void 0&&k?.mid===void 0)}delete(y){return this.e(y,!1)}deleteSuperstr(y){return this.e(y,!0)}e(y,k){const w=this.b.reset(y),u=[];let o=this.c;for(;o;){const i=w.cmp(o.segment);if(i>0)u.push([-1,o]),o=o.left;else if(i<0)u.push([1,o]),o=o.right;else if(w.hasNext())w.next(),u.push([0,o]),o=o.mid;else break}if(o){if(k?(o.left=void 0,o.mid=void 0,o.right=void 0,o.height=1):(o.key=void 0,o.value=void 0),!o.mid&&!o.value)if(o.left&&o.right){const i=this.f(o.right);if(i.key){const{key:n,value:r,segment:a}=i;this.e(i.key,!1),o.key=n,o.value=r,o.segment=a}}else{const i=o.left??o.right;if(u.length>0){const[n,r]=u[u.length-1];switch(n){case-1:r.left=i;break;case 0:r.mid=i;break;case 1:r.right=i;break}}else this.c=i}for(let i=u.length-1;i>=0;i--){const n=u[i][1];n.updateHeight();const r=n.balanceFactor();if(r>1?(n.right.balanceFactor()>=0||(n.right=n.right.rotateRight()),u[i][1]=n.rotateLeft()):r<-1&&(n.left.balanceFactor()<=0||(n.left=n.left.rotateLeft()),u[i][1]=n.rotateRight()),i>0)switch(u[i-1][0]){case-1:u[i-1][1].left=u[i][1];break;case 1:u[i-1][1].right=u[i][1];break;case 0:u[i-1][1].mid=u[i][1];break}else this.c=u[0][1]}}}f(y){for(;y.left;)y=y.left;return y}findSubstr(y){const k=this.b.reset(y);let w=this.c,u;for(;w;){const o=k.cmp(w.segment);if(o>0)w=w.left;else if(o<0)w=w.right;else if(k.hasNext())k.next(),u=w.value||u,w=w.mid;else break}return w&&w.value||u}findSuperstr(y){return this.g(y,!1)}g(y,k){const w=this.b.reset(y);let u=this.c;for(;u;){const o=w.cmp(u.segment);if(o>0)u=u.left;else if(o<0)u=u.right;else if(w.hasNext())w.next(),u=u.mid;else return u.mid?this.h(u.mid):k?u.value:void 0}}hasElementOrSubtree(y){return this.g(y,!0)!==void 0}forEach(y){for(const[k,w]of this)y(w,k)}*[Symbol.iterator](){yield*this.h(this.c)}h(y){const k=[];return this.j(y,k),k[Symbol.iterator]()}j(y,k){y&&(y.left&&this.j(y.left,k),y.value&&k.push([y.key,y.value]),y.mid&&this.j(y.mid,k),y.right&&this.j(y.right,k))}_isBalanced(){const y=k=>{if(!k)return!0;const w=k.balanceFactor();return w<-1||w>1?!1:y(k.left)&&y(k.right)};return y(this.c)}}e.$2h=I}),define(ke[18],Se([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tf=e.$Sf=e.$Rf=e.$Qf=e.$Pf=e.$Of=e.$Nf=e.$Mf=e.$Lf=e.$Kf=e.$Jf=e.$If=e.$Hf=e.$Gf=e.$Ff=e.$Ef=e.$Df=e.$Cf=void 0;function C(a){return typeof a=="string"}e.$Cf=C;function F(a){return Array.isArray(a)&&a.every(t=>C(t))}e.$Df=F;function f(a){return typeof a=="object"&&a!==null&&!Array.isArray(a)&&!(a instanceof RegExp)&&!(a instanceof Date)}e.$Ef=f;function L(a){const t=Object.getPrototypeOf(Uint8Array);return typeof a=="object"&&a instanceof t}e.$Ff=L;function M(a){return typeof a=="number"&&!isNaN(a)}e.$Gf=M;function b(a){return!!a&&typeof a[Symbol.iterator]=="function"}e.$Hf=b;function v(a){return a===!0||a===!1}e.$If=v;function g(a){return typeof a>"u"}e.$Jf=g;function A(a){return!I(a)}e.$Kf=A;function I(a){return g(a)||a===null}e.$Lf=I;function $(a,t){if(!a)throw new Error(t?`Unexpected type, expected '${t}'`:"Unexpected type")}e.$Mf=$;function y(a){if(I(a))throw new Error("Assertion Failed: argument is undefined or null");return a}e.$Nf=y;function k(...a){const t=[];for(let s=0;s<a.length;s++){const d=a[s];if(I(d))throw new Error(`Assertion Failed: argument at index ${s} is undefined or null`);t.push(d)}return t}e.$Of=k;const w=Object.prototype.hasOwnProperty;function u(a){if(!f(a))return!1;for(const t in a)if(w.call(a,t))return!1;return!0}e.$Pf=u;function o(a){return typeof a=="function"}e.$Qf=o;function i(...a){return a.length>0&&a.every(o)}e.$Rf=i;function n(a,t){const s=Math.min(a.length,t.length);for(let d=0;d<s;d++)r(a[d],t[d])}e.$Sf=n;function r(a,t){if(C(t)){if(typeof a!==t)throw new Error(`argument does not match constraint: typeof ${t}`)}else if(o(t)){try{if(a instanceof t)return}catch{}if(!I(a)&&a.constructor===t||t.length===1&&t.call(void 0,a)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}e.$Tf=r}),define(ke[78],Se([1,0,18]),function(me,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1j=e.$Zj=e.$Yj=void 0;const F=Object.create(null);function f(b,v){if((0,C.$Cf)(v)){const g=F[v];if(g===void 0)throw new Error(`${b} references an unknown codicon: ${v}`);v=g}return F[b]=v,{id:b}}function L(){return F}e.$Yj=L;function M(){return Object.values(e.$1j)}e.$Zj=M,e.$1j={add:f("add",6e4),plus:f("plus",6e4),gistNew:f("gist-new",6e4),repoCreate:f("repo-create",6e4),lightbulb:f("lightbulb",60001),lightBulb:f("light-bulb",60001),repo:f("repo",60002),repoDelete:f("repo-delete",60002),gistFork:f("gist-fork",60003),repoForked:f("repo-forked",60003),gitPullRequest:f("git-pull-request",60004),gitPullRequestAbandoned:f("git-pull-request-abandoned",60004),recordKeys:f("record-keys",60005),keyboard:f("keyboard",60005),tag:f("tag",60006),tagAdd:f("tag-add",60006),tagRemove:f("tag-remove",60006),gitPullRequestLabel:f("git-pull-request-label",60006),person:f("person",60007),personFollow:f("person-follow",60007),personOutline:f("person-outline",60007),personFilled:f("person-filled",60007),gitBranch:f("git-branch",60008),gitBranchCreate:f("git-branch-create",60008),gitBranchDelete:f("git-branch-delete",60008),sourceControl:f("source-control",60008),mirror:f("mirror",60009),mirrorPublic:f("mirror-public",60009),star:f("star",60010),starAdd:f("star-add",60010),starDelete:f("star-delete",60010),starEmpty:f("star-empty",60010),comment:f("comment",60011),commentAdd:f("comment-add",60011),alert:f("alert",60012),warning:f("warning",60012),search:f("search",60013),searchSave:f("search-save",60013),logOut:f("log-out",60014),signOut:f("sign-out",60014),logIn:f("log-in",60015),signIn:f("sign-in",60015),eye:f("eye",60016),eyeUnwatch:f("eye-unwatch",60016),eyeWatch:f("eye-watch",60016),circleFilled:f("circle-filled",60017),primitiveDot:f("primitive-dot",60017),closeDirty:f("close-dirty",60017),debugBreakpoint:f("debug-breakpoint",60017),debugBreakpointDisabled:f("debug-breakpoint-disabled",60017),debugHint:f("debug-hint",60017),primitiveSquare:f("primitive-square",60018),edit:f("edit",60019),pencil:f("pencil",60019),info:f("info",60020),issueOpened:f("issue-opened",60020),gistPrivate:f("gist-private",60021),gitForkPrivate:f("git-fork-private",60021),lock:f("lock",60021),mirrorPrivate:f("mirror-private",60021),close:f("close",60022),removeClose:f("remove-close",60022),x:f("x",60022),repoSync:f("repo-sync",60023),sync:f("sync",60023),clone:f("clone",60024),desktopDownload:f("desktop-download",60024),beaker:f("beaker",60025),microscope:f("microscope",60025),vm:f("vm",60026),deviceDesktop:f("device-desktop",60026),file:f("file",60027),fileText:f("file-text",60027),more:f("more",60028),ellipsis:f("ellipsis",60028),kebabHorizontal:f("kebab-horizontal",60028),mailReply:f("mail-reply",60029),reply:f("reply",60029),organization:f("organization",60030),organizationFilled:f("organization-filled",60030),organizationOutline:f("organization-outline",60030),newFile:f("new-file",60031),fileAdd:f("file-add",60031),newFolder:f("new-folder",60032),fileDirectoryCreate:f("file-directory-create",60032),trash:f("trash",60033),trashcan:f("trashcan",60033),history:f("history",60034),clock:f("clock",60034),folder:f("folder",60035),fileDirectory:f("file-directory",60035),symbolFolder:f("symbol-folder",60035),logoGithub:f("logo-github",60036),markGithub:f("mark-github",60036),github:f("github",60036),terminal:f("terminal",60037),console:f("console",60037),repl:f("repl",60037),zap:f("zap",60038),symbolEvent:f("symbol-event",60038),error:f("error",60039),stop:f("stop",60039),variable:f("variable",60040),symbolVariable:f("symbol-variable",60040),array:f("array",60042),symbolArray:f("symbol-array",60042),symbolModule:f("symbol-module",60043),symbolPackage:f("symbol-package",60043),symbolNamespace:f("symbol-namespace",60043),symbolObject:f("symbol-object",60043),symbolMethod:f("symbol-method",60044),symbolFunction:f("symbol-function",60044),symbolConstructor:f("symbol-constructor",60044),symbolBoolean:f("symbol-boolean",60047),symbolNull:f("symbol-null",60047),symbolNumeric:f("symbol-numeric",60048),symbolNumber:f("symbol-number",60048),symbolStructure:f("symbol-structure",60049),symbolStruct:f("symbol-struct",60049),symbolParameter:f("symbol-parameter",60050),symbolTypeParameter:f("symbol-type-parameter",60050),symbolKey:f("symbol-key",60051),symbolText:f("symbol-text",60051),symbolReference:f("symbol-reference",60052),goToFile:f("go-to-file",60052),symbolEnum:f("symbol-enum",60053),symbolValue:f("symbol-value",60053),symbolRuler:f("symbol-ruler",60054),symbolUnit:f("symbol-unit",60054),activateBreakpoints:f("activate-breakpoints",60055),archive:f("archive",60056),arrowBoth:f("arrow-both",60057),arrowDown:f("arrow-down",60058),arrowLeft:f("arrow-left",60059),arrowRight:f("arrow-right",60060),arrowSmallDown:f("arrow-small-down",60061),arrowSmallLeft:f("arrow-small-left",60062),arrowSmallRight:f("arrow-small-right",60063),arrowSmallUp:f("arrow-small-up",60064),arrowUp:f("arrow-up",60065),bell:f("bell",60066),bold:f("bold",60067),book:f("book",60068),bookmark:f("bookmark",60069),debugBreakpointConditionalUnverified:f("debug-breakpoint-conditional-unverified",60070),debugBreakpointConditional:f("debug-breakpoint-conditional",60071),debugBreakpointConditionalDisabled:f("debug-breakpoint-conditional-disabled",60071),debugBreakpointDataUnverified:f("debug-breakpoint-data-unverified",60072),debugBreakpointData:f("debug-breakpoint-data",60073),debugBreakpointDataDisabled:f("debug-breakpoint-data-disabled",60073),debugBreakpointLogUnverified:f("debug-breakpoint-log-unverified",60074),debugBreakpointLog:f("debug-breakpoint-log",60075),debugBreakpointLogDisabled:f("debug-breakpoint-log-disabled",60075),briefcase:f("briefcase",60076),broadcast:f("broadcast",60077),browser:f("browser",60078),bug:f("bug",60079),calendar:f("calendar",60080),caseSensitive:f("case-sensitive",60081),check:f("check",60082),checklist:f("checklist",60083),chevronDown:f("chevron-down",60084),dropDownButton:f("drop-down-button",60084),chevronLeft:f("chevron-left",60085),chevronRight:f("chevron-right",60086),chevronUp:f("chevron-up",60087),chromeClose:f("chrome-close",60088),chromeMaximize:f("chrome-maximize",60089),chromeMinimize:f("chrome-minimize",60090),chromeRestore:f("chrome-restore",60091),circle:f("circle",60092),circleOutline:f("circle-outline",60092),debugBreakpointUnverified:f("debug-breakpoint-unverified",60092),circleSlash:f("circle-slash",60093),circuitBoard:f("circuit-board",60094),clearAll:f("clear-all",60095),clippy:f("clippy",60096),closeAll:f("close-all",60097),cloudDownload:f("cloud-download",60098),cloudUpload:f("cloud-upload",60099),code:f("code",60100),collapseAll:f("collapse-all",60101),colorMode:f("color-mode",60102),commentDiscussion:f("comment-discussion",60103),compareChanges:f("compare-changes",60157),creditCard:f("credit-card",60105),dash:f("dash",60108),dashboard:f("dashboard",60109),database:f("database",60110),debugContinue:f("debug-continue",60111),debugDisconnect:f("debug-disconnect",60112),debugPause:f("debug-pause",60113),debugRestart:f("debug-restart",60114),debugStart:f("debug-start",60115),debugStepInto:f("debug-step-into",60116),debugStepOut:f("debug-step-out",60117),debugStepOver:f("debug-step-over",60118),debugStop:f("debug-stop",60119),debug:f("debug",60120),deviceCameraVideo:f("device-camera-video",60121),deviceCamera:f("device-camera",60122),deviceMobile:f("device-mobile",60123),diffAdded:f("diff-added",60124),diffIgnored:f("diff-ignored",60125),diffModified:f("diff-modified",60126),diffRemoved:f("diff-removed",60127),diffRenamed:f("diff-renamed",60128),diff:f("diff",60129),discard:f("discard",60130),editorLayout:f("editor-layout",60131),emptyWindow:f("empty-window",60132),exclude:f("exclude",60133),extensions:f("extensions",60134),eyeClosed:f("eye-closed",60135),fileBinary:f("file-binary",60136),fileCode:f("file-code",60137),fileMedia:f("file-media",60138),filePdf:f("file-pdf",60139),fileSubmodule:f("file-submodule",60140),fileSymlinkDirectory:f("file-symlink-directory",60141),fileSymlinkFile:f("file-symlink-file",60142),fileZip:f("file-zip",60143),files:f("files",60144),filter:f("filter",60145),flame:f("flame",60146),foldDown:f("fold-down",60147),foldUp:f("fold-up",60148),fold:f("fold",60149),folderActive:f("folder-active",60150),folderOpened:f("folder-opened",60151),gear:f("gear",60152),gift:f("gift",60153),gistSecret:f("gist-secret",60154),gist:f("gist",60155),gitCommit:f("git-commit",60156),gitCompare:f("git-compare",60157),gitMerge:f("git-merge",60158),githubAction:f("github-action",60159),githubAlt:f("github-alt",60160),globe:f("globe",60161),grabber:f("grabber",60162),graph:f("graph",60163),gripper:f("gripper",60164),heart:f("heart",60165),home:f("home",60166),horizontalRule:f("horizontal-rule",60167),hubot:f("hubot",60168),inbox:f("inbox",60169),issueClosed:f("issue-closed",60324),issueReopened:f("issue-reopened",60171),issues:f("issues",60172),italic:f("italic",60173),jersey:f("jersey",60174),json:f("json",60175),bracket:f("bracket",60175),kebabVertical:f("kebab-vertical",60176),key:f("key",60177),law:f("law",60178),lightbulbAutofix:f("lightbulb-autofix",60179),linkExternal:f("link-external",60180),link:f("link",60181),listOrdered:f("list-ordered",60182),listUnordered:f("list-unordered",60183),liveShare:f("live-share",60184),loading:f("loading",60185),location:f("location",60186),mailRead:f("mail-read",60187),mail:f("mail",60188),markdown:f("markdown",60189),megaphone:f("megaphone",60190),mention:f("mention",60191),milestone:f("milestone",60192),gitPullRequestMilestone:f("git-pull-request-milestone",60192),mortarBoard:f("mortar-board",60193),move:f("move",60194),multipleWindows:f("multiple-windows",60195),mute:f("mute",60196),noNewline:f("no-newline",60197),note:f("note",60198),octoface:f("octoface",60199),openPreview:f("open-preview",60200),package:f("package",60201),paintcan:f("paintcan",60202),pin:f("pin",60203),play:f("play",60204),run:f("run",60204),plug:f("plug",60205),preserveCase:f("preserve-case",60206),preview:f("preview",60207),project:f("project",60208),pulse:f("pulse",60209),question:f("question",60210),quote:f("quote",60211),radioTower:f("radio-tower",60212),reactions:f("reactions",60213),references:f("references",60214),refresh:f("refresh",60215),regex:f("regex",60216),remoteExplorer:f("remote-explorer",60217),remote:f("remote",60218),remove:f("remove",60219),replaceAll:f("replace-all",60220),replace:f("replace",60221),repoClone:f("repo-clone",60222),repoForcePush:f("repo-force-push",60223),repoPull:f("repo-pull",60224),repoPush:f("repo-push",60225),report:f("report",60226),requestChanges:f("request-changes",60227),rocket:f("rocket",60228),rootFolderOpened:f("root-folder-opened",60229),rootFolder:f("root-folder",60230),rss:f("rss",60231),ruby:f("ruby",60232),saveAll:f("save-all",60233),saveAs:f("save-as",60234),save:f("save",60235),screenFull:f("screen-full",60236),screenNormal:f("screen-normal",60237),searchStop:f("search-stop",60238),server:f("server",60240),settingsGear:f("settings-gear",60241),settings:f("settings",60242),shield:f("shield",60243),smiley:f("smiley",60244),sortPrecedence:f("sort-precedence",60245),splitHorizontal:f("split-horizontal",60246),splitVertical:f("split-vertical",60247),squirrel:f("squirrel",60248),starFull:f("star-full",60249),starHalf:f("star-half",60250),symbolClass:f("symbol-class",60251),symbolColor:f("symbol-color",60252),symbolCustomColor:f("symbol-customcolor",60252),symbolConstant:f("symbol-constant",60253),symbolEnumMember:f("symbol-enum-member",60254),symbolField:f("symbol-field",60255),symbolFile:f("symbol-file",60256),symbolInterface:f("symbol-interface",60257),symbolKeyword:f("symbol-keyword",60258),symbolMisc:f("symbol-misc",60259),symbolOperator:f("symbol-operator",60260),symbolProperty:f("symbol-property",60261),wrench:f("wrench",60261),wrenchSubaction:f("wrench-subaction",60261),symbolSnippet:f("symbol-snippet",60262),tasklist:f("tasklist",60263),telescope:f("telescope",60264),textSize:f("text-size",60265),threeBars:f("three-bars",60266),thumbsdown:f("thumbsdown",60267),thumbsup:f("thumbsup",60268),tools:f("tools",60269),triangleDown:f("triangle-down",60270),triangleLeft:f("triangle-left",60271),triangleRight:f("triangle-right",60272),triangleUp:f("triangle-up",60273),twitter:f("twitter",60274),unfold:f("unfold",60275),unlock:f("unlock",60276),unmute:f("unmute",60277),unverified:f("unverified",60278),verified:f("verified",60279),versions:f("versions",60280),vmActive:f("vm-active",60281),vmOutline:f("vm-outline",60282),vmRunning:f("vm-running",60283),watch:f("watch",60284),whitespace:f("whitespace",60285),wholeWord:f("whole-word",60286),window:f("window",60287),wordWrap:f("word-wrap",60288),zoomIn:f("zoom-in",60289),zoomOut:f("zoom-out",60290),listFilter:f("list-filter",60291),listFlat:f("list-flat",60292),listSelection:f("list-selection",60293),selection:f("selection",60293),listTree:f("list-tree",60294),debugBreakpointFunctionUnverified:f("debug-breakpoint-function-unverified",60295),debugBreakpointFunction:f("debug-breakpoint-function",60296),debugBreakpointFunctionDisabled:f("debug-breakpoint-function-disabled",60296),debugStackframeActive:f("debug-stackframe-active",60297),circleSmallFilled:f("circle-small-filled",60298),debugStackframeDot:f("debug-stackframe-dot",60298),debugStackframe:f("debug-stackframe",60299),debugStackframeFocused:f("debug-stackframe-focused",60299),debugBreakpointUnsupported:f("debug-breakpoint-unsupported",60300),symbolString:f("symbol-string",60301),debugReverseContinue:f("debug-reverse-continue",60302),debugStepBack:f("debug-step-back",60303),debugRestartFrame:f("debug-restart-frame",60304),callIncoming:f("call-incoming",60306),callOutgoing:f("call-outgoing",60307),menu:f("menu",60308),expandAll:f("expand-all",60309),feedback:f("feedback",60310),gitPullRequestReviewer:f("git-pull-request-reviewer",60310),groupByRefType:f("group-by-ref-type",60311),ungroupByRefType:f("ungroup-by-ref-type",60312),account:f("account",60313),gitPullRequestAssignee:f("git-pull-request-assignee",60313),bellDot:f("bell-dot",60314),debugConsole:f("debug-console",60315),library:f("library",60316),output:f("output",60317),runAll:f("run-all",60318),syncIgnored:f("sync-ignored",60319),pinned:f("pinned",60320),githubInverted:f("github-inverted",60321),debugAlt:f("debug-alt",60305),serverProcess:f("server-process",60322),serverEnvironment:f("server-environment",60323),pass:f("pass",60324),stopCircle:f("stop-circle",60325),playCircle:f("play-circle",60326),record:f("record",60327),debugAltSmall:f("debug-alt-small",60328),vmConnect:f("vm-connect",60329),cloud:f("cloud",60330),merge:f("merge",60331),exportIcon:f("export",60332),graphLeft:f("graph-left",60333),magnet:f("magnet",60334),notebook:f("notebook",60335),redo:f("redo",60336),checkAll:f("check-all",60337),pinnedDirty:f("pinned-dirty",60338),passFilled:f("pass-filled",60339),circleLargeFilled:f("circle-large-filled",60340),circleLarge:f("circle-large",60341),circleLargeOutline:f("circle-large-outline",60341),combine:f("combine",60342),gather:f("gather",60342),table:f("table",60343),variableGroup:f("variable-group",60344),typeHierarchy:f("type-hierarchy",60345),typeHierarchySub:f("type-hierarchy-sub",60346),typeHierarchySuper:f("type-hierarchy-super",60347),gitPullRequestCreate:f("git-pull-request-create",60348),runAbove:f("run-above",60349),runBelow:f("run-below",60350),notebookTemplate:f("notebook-template",60351),debugRerun:f("debug-rerun",60352),workspaceTrusted:f("workspace-trusted",60353),workspaceUntrusted:f("workspace-untrusted",60354),workspaceUnspecified:f("workspace-unspecified",60355),terminalCmd:f("terminal-cmd",60356),terminalDebian:f("terminal-debian",60357),terminalLinux:f("terminal-linux",60358),terminalPowershell:f("terminal-powershell",60359),terminalTmux:f("terminal-tmux",60360),terminalUbuntu:f("terminal-ubuntu",60361),terminalBash:f("terminal-bash",60362),arrowSwap:f("arrow-swap",60363),copy:f("copy",60364),personAdd:f("person-add",60365),filterFilled:f("filter-filled",60366),wand:f("wand",60367),debugLineByLine:f("debug-line-by-line",60368),inspect:f("inspect",60369),layers:f("layers",60370),layersDot:f("layers-dot",60371),layersActive:f("layers-active",60372),compass:f("compass",60373),compassDot:f("compass-dot",60374),compassActive:f("compass-active",60375),azure:f("azure",60376),issueDraft:f("issue-draft",60377),gitPullRequestClosed:f("git-pull-request-closed",60378),gitPullRequestDraft:f("git-pull-request-draft",60379),debugAll:f("debug-all",60380),debugCoverage:f("debug-coverage",60381),runErrors:f("run-errors",60382),folderLibrary:f("folder-library",60383),debugContinueSmall:f("debug-continue-small",60384),beakerStop:f("beaker-stop",60385),graphLine:f("graph-line",60386),graphScatter:f("graph-scatter",60387),pieChart:f("pie-chart",60388),bracketDot:f("bracket-dot",60389),bracketError:f("bracket-error",60390),lockSmall:f("lock-small",60391),azureDevops:f("azure-devops",60392),verifiedFilled:f("verified-filled",60393),newLine:f("newline",60394),layout:f("layout",60395),layoutActivitybarLeft:f("layout-activitybar-left",60396),layoutActivitybarRight:f("layout-activitybar-right",60397),layoutPanelLeft:f("layout-panel-left",60398),layoutPanelCenter:f("layout-panel-center",60399),layoutPanelJustify:f("layout-panel-justify",60400),layoutPanelRight:f("layout-panel-right",60401),layoutPanel:f("layout-panel",60402),layoutSidebarLeft:f("layout-sidebar-left",60403),layoutSidebarRight:f("layout-sidebar-right",60404),layoutStatusbar:f("layout-statusbar",60405),layoutMenubar:f("layout-menubar",60406),layoutCentered:f("layout-centered",60407),layoutSidebarRightOff:f("layout-sidebar-right-off",60416),layoutPanelOff:f("layout-panel-off",60417),layoutSidebarLeftOff:f("layout-sidebar-left-off",60418),target:f("target",60408),indent:f("indent",60409),recordSmall:f("record-small",60410),errorSmall:f("error-small",60411),arrowCircleDown:f("arrow-circle-down",60412),arrowCircleLeft:f("arrow-circle-left",60413),arrowCircleRight:f("arrow-circle-right",60414),arrowCircleUp:f("arrow-circle-up",60415),heartFilled:f("heart-filled",60420),map:f("map",60421),mapFilled:f("map-filled",60422),circleSmall:f("circle-small",60423),bellSlash:f("bell-slash",60424),bellSlashDot:f("bell-slash-dot",60425),commentUnresolved:f("comment-unresolved",60426),gitPullRequestGoToChanges:f("git-pull-request-go-to-changes",60427),gitPullRequestNewChanges:f("git-pull-request-new-changes",60428),searchFuzzy:f("search-fuzzy",60429),commentDraft:f("comment-draft",60430),send:f("send",60431),sparkle:f("sparkle",60432),insert:f("insert",60433),mic:f("mic",60434),thumbsDownFilled:f("thumbsdown-filled",60435),thumbsUpFilled:f("thumbsup-filled",60436),coffee:f("coffee",60437),snake:f("snake",60438),game:f("game",60439),vr:f("vr",60440),chip:f("chip",60441),piano:f("piano",60442),music:f("music",60443),micFilled:f("mic-filled",60444),gitFetch:f("git-fetch",60445),copilot:f("copilot",60446),dialogError:f("dialog-error","error"),dialogWarning:f("dialog-warning","warning"),dialogInfo:f("dialog-info","info"),dialogClose:f("dialog-close","close"),treeItemExpanded:f("tree-item-expanded","chevron-down"),treeFilterOnTypeOn:f("tree-filter-on-type-on","list-filter"),treeFilterOnTypeOff:f("tree-filter-on-type-off","list-selection"),treeFilterClear:f("tree-filter-clear","close"),treeItemLoading:f("tree-item-loading","loading"),menuSelection:f("menu-selection","check"),menuSubmenu:f("menu-submenu","chevron-right"),menuBarMore:f("menubar-more","more"),scrollbarButtonLeft:f("scrollbar-button-left","triangle-left"),scrollbarButtonRight:f("scrollbar-button-right","triangle-right"),scrollbarButtonUp:f("scrollbar-button-up","triangle-up"),scrollbarButtonDown:f("scrollbar-button-down","triangle-down"),toolBarMore:f("toolbar-more","more"),quickInputBack:f("quick-input-back","arrow-left")}}),define(ke[24],Se([1,0,18]),function(me,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ln=e.$kn=e.$jn=e.$in=e.$hn=e.$gn=e.$fn=e.$en=e.$dn=e.$cn=e.$bn=e.$an=void 0;function F(o){if(!o||typeof o!="object"||o instanceof RegExp)return o;const i=Array.isArray(o)?[]:{};return Object.entries(o).forEach(([n,r])=>{i[n]=r&&typeof r=="object"?F(r):r}),i}e.$an=F;function f(o){if(!o||typeof o!="object")return o;const i=[o];for(;i.length>0;){const n=i.shift();Object.freeze(n);for(const r in n)if(L.call(n,r)){const a=n[r];typeof a=="object"&&!Object.isFrozen(a)&&!(0,C.$Ff)(a)&&i.push(a)}}return o}e.$bn=f;const L=Object.prototype.hasOwnProperty;function M(o,i){return b(o,i,new Set)}e.$cn=M;function b(o,i,n){if((0,C.$Lf)(o))return o;const r=i(o);if(typeof r<"u")return r;if(Array.isArray(o)){const a=[];for(const t of o)a.push(b(t,i,n));return a}if((0,C.$Ef)(o)){if(n.has(o))throw new Error("Cannot clone recursive data-structure");n.add(o);const a={};for(const t in o)L.call(o,t)&&(a[t]=b(o[t],i,n));return n.delete(o),a}return o}function v(o,i,n=!0){return(0,C.$Ef)(o)?((0,C.$Ef)(i)&&Object.keys(i).forEach(r=>{r in o?n&&((0,C.$Ef)(o[r])&&(0,C.$Ef)(i[r])?v(o[r],i[r],n):o[r]=i[r]):o[r]=i[r]}),o):i}e.$dn=v;function g(o,i){if(o===i)return!0;if(o==null||i===null||i===void 0||typeof o!=typeof i||typeof o!="object"||Array.isArray(o)!==Array.isArray(i))return!1;let n,r;if(Array.isArray(o)){if(o.length!==i.length)return!1;for(n=0;n<o.length;n++)if(!g(o[n],i[n]))return!1}else{const a=[];for(r in o)a.push(r);a.sort();const t=[];for(r in i)t.push(r);if(t.sort(),!g(a,t))return!1;for(n=0;n<a.length;n++)if(!g(o[a[n]],i[a[n]]))return!1}return!0}e.$en=g;function A(o){const i=new Set;return JSON.stringify(o,(n,r)=>{if((0,C.$Ef)(r)||Array.isArray(r)){if(i.has(r))return"[Circular]";i.add(r)}return r})}e.$fn=A;function I(o,i){const n=Object.create(null);return!o||!i||Object.keys(i).forEach(a=>{const t=o[a],s=i[a];g(t,s)||(n[a]=s)}),n}e.$gn=I;function $(o,i){const n=i.toLowerCase(),r=Object.keys(o).find(a=>a.toLowerCase()===n);return r?o[r]:o[i]}e.$hn=$;function y(o,i){const n=Object.create(null);for(const[r,a]of Object.entries(o))i(r,a)&&(n[r]=a);return n}e.$in=y;function k(o){let i=[];for(;Object.prototype!==o;)i=i.concat(Object.getOwnPropertyNames(o)),o=Object.getPrototypeOf(o);return i}e.$jn=k;function w(o){const i=[];for(const n of k(o))typeof o[n]=="function"&&i.push(n);return i}e.$kn=w;function u(o,i){const n=a=>function(){const t=Array.prototype.slice.call(arguments,0);return i(a,t)},r={};for(const a of o)r[a]=n(a);return r}e.$ln=u}),define(ke[61],Se([1,0,78]),function(me,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ThemeIcon=e.$2j=e.ThemeColor=void 0;var F;(function(M){function b(v){return v&&typeof v=="object"&&typeof v.id=="string"}M.isThemeColor=b})(F||(e.ThemeColor=F={}));function f(M){return{id:M}}e.$2j=f;var L;(function(M){M.iconNameSegment="[A-Za-z0-9]+",M.iconNameExpression="[A-Za-z0-9-]+",M.iconModifierExpression="~[A-Za-z]+",M.iconNameCharacter="[A-Za-z0-9~-]";const b=new RegExp(`^(${M.iconNameExpression})(${M.iconModifierExpression})?$`);function v(i){const n=b.exec(i.id);if(!n)return v(C.$1j.error);const[,r,a]=n,t=["codicon","codicon-"+r];return a&&t.push("codicon-modifier-"+a.substring(1)),t}M.asClassNameArray=v;function g(i){return v(i).join(" ")}M.asClassName=g;function A(i){return"."+v(i).join(".")}M.asCSSSelector=A;function I(i){return i&&typeof i=="object"&&typeof i.id=="string"&&(typeof i.color>"u"||F.isThemeColor(i.color))}M.isThemeIcon=I;const $=new RegExp(`^\\$\\((${M.iconNameExpression}(?:${M.iconModifierExpression})?)\\)$`);function y(i){const n=$.exec(i);if(!n)return;const[,r]=n;return{id:r}}M.fromString=y;function k(i){return{id:i}}M.fromId=k;function w(i,n){let r=i.id;const a=r.lastIndexOf("~");return a!==-1&&(r=r.substring(0,a)),n&&(r=`${r}~${n}`),{id:r}}M.modify=w;function u(i){const n=i.id.lastIndexOf("~");if(n!==-1)return i.id.substring(n+1)}M.getModifier=u;function o(i,n){return i.id===n.id&&i.color?.id===n.color?.id}M.isEqual=o})(L||(e.ThemeIcon=L={}))}),define(ke[164],Se([1,0,124,13,61]),function(me,e,C,F,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8j=e.$7j=e.$6j=e.$5j=e.$4j=e.$3j=void 0;const L="$(",M=new RegExp(`\\$\\(${f.ThemeIcon.iconNameExpression}(?:${f.ThemeIcon.iconModifierExpression})?\\)`,"g"),b=new RegExp(`(\\\\)?${M.source}`,"g");function v(o){return o.replace(b,(i,n)=>n?i:`\\${i}`)}e.$3j=v;const g=new RegExp(`\\\\${M.source}`,"g");function A(o){return o.replace(g,i=>`\\${i}`)}e.$4j=A;const I=new RegExp(`(\\s)?(\\\\)?${M.source}(\\s)?`,"g");function $(o){return o.indexOf(L)===-1?o:o.replace(I,(i,n,r,a)=>r?i:n||a||"")}e.$5j=$;function y(o){return o?o.replace(/\$\((.*?)\)/g,(i,n)=>` ${n} `).trim():""}e.$6j=y;const k=new RegExp(`\\$\\(${f.ThemeIcon.iconNameCharacter}+\\)`,"g");function w(o){k.lastIndex=0;let i="";const n=[];let r=0;for(;;){const a=k.lastIndex,t=k.exec(o),s=o.substring(a,t?.index);if(s.length>0){i+=s;for(let d=0;d<s.length;d++)n.push(r)}if(!t)break;r+=t[0].length}return{text:i,iconOffsets:n}}e.$7j=w;function u(o,i,n=!1){const{text:r,iconOffsets:a}=i;if(!a||a.length===0)return(0,C.$Pj)(o,r,n);const t=(0,F.$Ne)(r," "),s=r.length-t.length,d=(0,C.$Pj)(o,t,n);if(d)for(const c of d){const l=a[c.start+s]+s;c.start+=l,c.end+=l}return d}e.$8j=u}),define(ke[125],Se([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ee=e.$De=e.Constants=void 0;var C;(function(L){L[L.MAX_SAFE_SMALL_INTEGER=1073741824]="MAX_SAFE_SMALL_INTEGER",L[L.MIN_SAFE_SMALL_INTEGER=-1073741824]="MIN_SAFE_SMALL_INTEGER",L[L.MAX_UINT_8=255]="MAX_UINT_8",L[L.MAX_UINT_16=65535]="MAX_UINT_16",L[L.MAX_UINT_32=4294967295]="MAX_UINT_32",L[L.UNICODE_SUPPLEMENTARY_PLANE_BEGIN=65536]="UNICODE_SUPPLEMENTARY_PLANE_BEGIN"})(C||(e.Constants=C={}));function F(L){return L<0?0:L>255?255:L|0}e.$De=F;function f(L){return L<0?0:L>4294967295?4294967295:L|0}e.$Ee=f}),define(ke[32],Se([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ig=e.$hg=void 0;const C=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function F(f){return C.test(f)}e.$hg=F,e.$ig=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let f;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?f=crypto.getRandomValues.bind(crypto):f=function(b){for(let v=0;v<b.length;v++)b[v]=Math.floor(Math.random()*256);return b};const L=new Uint8Array(16),M=[];for(let b=0;b<256;b++)M.push(b.toString(16).padStart(2,"0"));return function(){f(L),L[6]=L[6]&15|64,L[8]=L[8]&63|128;let v=0,g="";return g+=M[L[v++]],g+=M[L[v++]],g+=M[L[v++]],g+=M[L[v++]],g+="-",g+=M[L[v++]],g+=M[L[v++]],g+="-",g+=M[L[v++]],g+=M[L[v++]],g+="-",g+=M[L[v++]],g+=M[L[v++]],g+="-",g+=M[L[v++]],g+=M[L[v++]],g+=M[L[v++]],g+=M[L[v++]],g+=M[L[v++]],g+=M[L[v++]],g}}()}),define(ke[165],Se([1,0,19,51,32]),function(me,e,C,F,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9s=e.$8s=e.$7s=e.$6s=e.$5s=void 0;function L(I){return{asString:async()=>I,asFile:()=>{},value:typeof I=="string"?I:void 0}}e.$5s=L;function M(I,$,y){const k={id:(0,f.$ig)(),name:I,uri:$,data:y};return{asString:async()=>"",asFile:()=>k,value:void 0}}e.$6s=M;class b{constructor(){this.a=new Map}get size(){let $=0;for(const y of this.a)$++;return $}has($){return this.a.has(this.b($))}matches($){const y=[...this.a.keys()];return F.Iterable.some(this,([k,w])=>w.asFile())&&y.push("files"),A(v($),y)}get($){return this.a.get(this.b($))?.[0]}append($,y){const k=this.a.get($);k?k.push(y):this.a.set(this.b($),[y])}replace($,y){this.a.set(this.b($),[y])}delete($){this.a.delete(this.b($))}*[Symbol.iterator](){for(const[$,y]of this.a)for(const k of y)yield[$,k]}b($){return v($)}}e.$7s=b;function v(I){return I.toLowerCase()}function g(I,$){return A(v(I),$.map(v))}e.$8s=g;function A(I,$){if(I==="*/*")return $.length>0;if($.includes(I))return!0;const y=I.match(/^([a-z]+)\/([a-z]+|\*)$/i);if(!y)return!1;const[k,w,u]=y;return u==="*"?$.some(o=>o.startsWith(w+"/")):!1}e.$9s=Object.freeze({create:I=>(0,C.$Lb)(I.map($=>$.toString())).join(`\r
`),split:I=>I.split(`\r
`),parse:I=>e.$9s.split(I).filter($=>!$.startsWith("#"))})}),define(ke[166],Se([1,0,62]),function(me,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mg=e.$lg=e.$kg=void 0;function F(b,v,g,A=1){let I=!1;return new Promise($=>{const y=setTimeout(()=>{if(!I)return I=!0,$(0)},g);f(b,v,A,k=>{if(!I)return I=!0,clearTimeout(y),$(k)})})}e.$kg=F;function f(b,v,g,A){if(v===0)return A(0);const I=new C.Socket;I.once("connect",()=>(M(I),f(b+g,v-1,g,A))),I.once("data",()=>{}),I.once("error",$=>(M(I),$.code!=="ECONNREFUSED"?f(b+g,v-1,g,A):A(b))),I.connect(b,"127.0.0.1")}e.$lg={1:!0,7:!0,9:!0,11:!0,13:!0,15:!0,17:!0,19:!0,20:!0,21:!0,22:!0,23:!0,25:!0,37:!0,42:!0,43:!0,53:!0,69:!0,77:!0,79:!0,87:!0,95:!0,101:!0,102:!0,103:!0,104:!0,109:!0,110:!0,111:!0,113:!0,115:!0,117:!0,119:!0,123:!0,135:!0,137:!0,139:!0,143:!0,161:!0,179:!0,389:!0,427:!0,465:!0,512:!0,513:!0,514:!0,515:!0,526:!0,530:!0,531:!0,532:!0,540:!0,548:!0,554:!0,556:!0,563:!0,587:!0,601:!0,636:!0,989:!0,990:!0,993:!0,995:!0,1719:!0,1720:!0,1723:!0,2049:!0,3659:!0,4045:!0,5060:!0,5061:!0,6e3:!0,6566:!0,6665:!0,6666:!0,6667:!0,6668:!0,6669:!0,6697:!0,10080:!0};function L(b,v,g,A="127.0.0.1"){let I=!1,$,y=1;const k=C.createServer({pauseOnConnect:!0});function w(u,o){I||(I=!0,k.removeAllListeners(),k.close(),$&&clearTimeout($),o(u))}return new Promise(u=>{$=setTimeout(()=>{w(0,u)},g),k.on("listening",()=>{w(b,u)}),k.on("error",o=>{o&&(o.code==="EADDRINUSE"||o.code==="EACCES")&&y<v?(b++,y++,k.listen(b,A)):w(0,u)}),k.on("close",()=>{w(0,u)}),k.listen(b,A)})}e.$mg=L;function M(b){try{b.removeAllListeners("connect"),b.removeAllListeners("error"),b.end(),b.destroy(),b.unref()}catch(v){console.error(v)}}}),define(ke[126],Se([1,0,125]),function(me,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xs=e.$Ws=void 0;class F{constructor(b){const v=(0,C.$De)(b);this.c=v,this.a=F.d(v),this.b=new Map}static d(b){const v=new Uint8Array(256);return v.fill(b),v}set(b,v){const g=(0,C.$De)(v);b>=0&&b<256?this.a[b]=g:this.b.set(b,g)}get(b){return b>=0&&b<256?this.a[b]:this.b.get(b)||this.c}clear(){this.a.fill(this.c),this.b.clear()}}e.$Ws=F;var f;(function(M){M[M.False=0]="False",M[M.True=1]="True"})(f||(f={}));class L{constructor(){this.a=new F(0)}add(b){this.a.set(b,1)}has(b){return this.a.get(b)===1}clear(){return this.a.clear()}}e.$Xs=L}),define(ke[167],Se([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_s=e.StringEOL=void 0;var C;(function(f){f[f.Unknown=0]="Unknown",f[f.Invalid=3]="Invalid",f[f.LF=1]="LF",f[f.CRLF=2]="CRLF"})(C||(e.StringEOL=C={}));function F(f){let L=0,M=0,b=0,v=0;for(let g=0,A=f.length;g<A;g++){const I=f.charCodeAt(g);I===13?(L===0&&(M=g),L++,g+1<A&&f.charCodeAt(g+1)===10?(v|=2,g++):v|=3,b=g+1):I===10&&(v|=1,L===0&&(M=g),L++,b=g+1)}return L===0&&(M=f.length),[L,M,f.length-b,v]}e.$_s=F}),define(ke[53],Se([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ys=void 0;class C{constructor(f,L){this.lineNumber=f,this.column=L}with(f=this.lineNumber,L=this.column){return f===this.lineNumber&&L===this.column?this:new C(f,L)}delta(f=0,L=0){return this.with(this.lineNumber+f,this.column+L)}equals(f){return C.equals(this,f)}static equals(f,L){return!f&&!L?!0:!!f&&!!L&&f.lineNumber===L.lineNumber&&f.column===L.column}isBefore(f){return C.isBefore(this,f)}static isBefore(f,L){return f.lineNumber<L.lineNumber?!0:L.lineNumber<f.lineNumber?!1:f.column<L.column}isBeforeOrEqual(f){return C.isBeforeOrEqual(this,f)}static isBeforeOrEqual(f,L){return f.lineNumber<L.lineNumber?!0:L.lineNumber<f.lineNumber?!1:f.column<=L.column}static compare(f,L){const M=f.lineNumber|0,b=L.lineNumber|0;if(M===b){const v=f.column|0,g=L.column|0;return v-g}return M-b}clone(){return new C(this.lineNumber,this.column)}toString(){return"("+this.lineNumber+","+this.column+")"}static lift(f){return new C(f.lineNumber,f.column)}static isIPosition(f){return f&&typeof f.lineNumber=="number"&&typeof f.column=="number"}}e.$ys=C}),define(ke[29],Se([1,0,53]),function(me,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zs=void 0;class F{constructor(L,M,b,v){L>b||L===b&&M>v?(this.startLineNumber=b,this.startColumn=v,this.endLineNumber=L,this.endColumn=M):(this.startLineNumber=L,this.startColumn=M,this.endLineNumber=b,this.endColumn=v)}isEmpty(){return F.isEmpty(this)}static isEmpty(L){return L.startLineNumber===L.endLineNumber&&L.startColumn===L.endColumn}containsPosition(L){return F.containsPosition(this,L)}static containsPosition(L,M){return!(M.lineNumber<L.startLineNumber||M.lineNumber>L.endLineNumber||M.lineNumber===L.startLineNumber&&M.column<L.startColumn||M.lineNumber===L.endLineNumber&&M.column>L.endColumn)}static strictContainsPosition(L,M){return!(M.lineNumber<L.startLineNumber||M.lineNumber>L.endLineNumber||M.lineNumber===L.startLineNumber&&M.column<=L.startColumn||M.lineNumber===L.endLineNumber&&M.column>=L.endColumn)}containsRange(L){return F.containsRange(this,L)}static containsRange(L,M){return!(M.startLineNumber<L.startLineNumber||M.endLineNumber<L.startLineNumber||M.startLineNumber>L.endLineNumber||M.endLineNumber>L.endLineNumber||M.startLineNumber===L.startLineNumber&&M.startColumn<L.startColumn||M.endLineNumber===L.endLineNumber&&M.endColumn>L.endColumn)}strictContainsRange(L){return F.strictContainsRange(this,L)}static strictContainsRange(L,M){return!(M.startLineNumber<L.startLineNumber||M.endLineNumber<L.startLineNumber||M.startLineNumber>L.endLineNumber||M.endLineNumber>L.endLineNumber||M.startLineNumber===L.startLineNumber&&M.startColumn<=L.startColumn||M.endLineNumber===L.endLineNumber&&M.endColumn>=L.endColumn)}plusRange(L){return F.plusRange(this,L)}static plusRange(L,M){let b,v,g,A;return M.startLineNumber<L.startLineNumber?(b=M.startLineNumber,v=M.startColumn):M.startLineNumber===L.startLineNumber?(b=M.startLineNumber,v=Math.min(M.startColumn,L.startColumn)):(b=L.startLineNumber,v=L.startColumn),M.endLineNumber>L.endLineNumber?(g=M.endLineNumber,A=M.endColumn):M.endLineNumber===L.endLineNumber?(g=M.endLineNumber,A=Math.max(M.endColumn,L.endColumn)):(g=L.endLineNumber,A=L.endColumn),new F(b,v,g,A)}intersectRanges(L){return F.intersectRanges(this,L)}static intersectRanges(L,M){let b=L.startLineNumber,v=L.startColumn,g=L.endLineNumber,A=L.endColumn;const I=M.startLineNumber,$=M.startColumn,y=M.endLineNumber,k=M.endColumn;return b<I?(b=I,v=$):b===I&&(v=Math.max(v,$)),g>y?(g=y,A=k):g===y&&(A=Math.min(A,k)),b>g||b===g&&v>A?null:new F(b,v,g,A)}equalsRange(L){return F.equalsRange(this,L)}static equalsRange(L,M){return!L&&!M?!0:!!L&&!!M&&L.startLineNumber===M.startLineNumber&&L.startColumn===M.startColumn&&L.endLineNumber===M.endLineNumber&&L.endColumn===M.endColumn}getEndPosition(){return F.getEndPosition(this)}static getEndPosition(L){return new C.$ys(L.endLineNumber,L.endColumn)}getStartPosition(){return F.getStartPosition(this)}static getStartPosition(L){return new C.$ys(L.startLineNumber,L.startColumn)}toString(){return"["+this.startLineNumber+","+this.startColumn+" -> "+this.endLineNumber+","+this.endColumn+"]"}setEndPosition(L,M){return new F(this.startLineNumber,this.startColumn,L,M)}setStartPosition(L,M){return new F(L,M,this.endLineNumber,this.endColumn)}collapseToStart(){return F.collapseToStart(this)}static collapseToStart(L){return new F(L.startLineNumber,L.startColumn,L.startLineNumber,L.startColumn)}collapseToEnd(){return F.collapseToEnd(this)}static collapseToEnd(L){return new F(L.endLineNumber,L.endColumn,L.endLineNumber,L.endColumn)}delta(L){return new F(this.startLineNumber+L,this.startColumn,this.endLineNumber+L,this.endColumn)}static fromPositions(L,M=L){return new F(L.lineNumber,L.column,M.lineNumber,M.column)}static lift(L){return L?new F(L.startLineNumber,L.startColumn,L.endLineNumber,L.endColumn):null}static isIRange(L){return L&&typeof L.startLineNumber=="number"&&typeof L.startColumn=="number"&&typeof L.endLineNumber=="number"&&typeof L.endColumn=="number"}static areIntersectingOrTouching(L,M){return!(L.endLineNumber<M.startLineNumber||L.endLineNumber===M.startLineNumber&&L.endColumn<M.startColumn||M.endLineNumber<L.startLineNumber||M.endLineNumber===L.startLineNumber&&M.endColumn<L.startColumn)}static areIntersecting(L,M){return!(L.endLineNumber<M.startLineNumber||L.endLineNumber===M.startLineNumber&&L.endColumn<=M.startColumn||M.endLineNumber<L.startLineNumber||M.endLineNumber===L.startLineNumber&&M.endColumn<=L.startColumn)}static compareRangesUsingStarts(L,M){if(L&&M){const g=L.startLineNumber|0,A=M.startLineNumber|0;if(g===A){const I=L.startColumn|0,$=M.startColumn|0;if(I===$){const y=L.endLineNumber|0,k=M.endLineNumber|0;if(y===k){const w=L.endColumn|0,u=M.endColumn|0;return w-u}return y-k}return I-$}return g-A}return(L?1:0)-(M?1:0)}static compareRangesUsingEnds(L,M){return L.endLineNumber===M.endLineNumber?L.endColumn===M.endColumn?L.startLineNumber===M.startLineNumber?L.startColumn-M.startColumn:L.startLineNumber-M.startLineNumber:L.endColumn-M.endColumn:L.endLineNumber-M.endLineNumber}static spansMultipleLines(L){return L.endLineNumber>L.startLineNumber}toJSON(){return this}}e.$zs=F}),define(ke[168],Se([1,0,29]),function(me,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$As=void 0;class F{static insert(L,M){return{range:new C.$zs(L.lineNumber,L.column,L.lineNumber,L.column),text:M,forceMoveMarkers:!0}}static delete(L){return{range:L,text:null}}static replace(L,M){return{range:L,text:M}}static replaceMove(L,M){return{range:L,text:M,forceMoveMarkers:!0}}}e.$As=F}),define(ke[169],Se([1,0,53,29]),function(me,e,C,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bs=e.SelectionDirection=void 0;var f;(function(M){M[M.LTR=0]="LTR",M[M.RTL=1]="RTL"})(f||(e.SelectionDirection=f={}));class L extends F.$zs{constructor(b,v,g,A){super(b,v,g,A),this.selectionStartLineNumber=b,this.selectionStartColumn=v,this.positionLineNumber=g,this.positionColumn=A}toString(){return"["+this.selectionStartLineNumber+","+this.selectionStartColumn+" -> "+this.positionLineNumber+","+this.positionColumn+"]"}equalsSelection(b){return L.selectionsEqual(this,b)}static selectionsEqual(b,v){return b.selectionStartLineNumber===v.selectionStartLineNumber&&b.selectionStartColumn===v.selectionStartColumn&&b.positionLineNumber===v.positionLineNumber&&b.positionColumn===v.positionColumn}getDirection(){return this.selectionStartLineNumber===this.startLineNumber&&this.selectionStartColumn===this.startColumn?0:1}setEndPosition(b,v){return this.getDirection()===0?new L(this.startLineNumber,this.startColumn,b,v):new L(b,v,this.startLineNumber,this.startColumn)}getPosition(){return new C.$ys(this.positionLineNumber,this.positionColumn)}getSelectionStart(){return new C.$ys(this.selectionStartLineNumber,this.selectionStartColumn)}setStartPosition(b,v){return this.getDirection()===0?new L(b,v,this.endLineNumber,this.endColumn):new L(this.endLineNumber,this.endColumn,b,v)}static fromPositions(b,v=b){return new L(b.lineNumber,b.column,v.lineNumber,v.column)}static fromRange(b,v){return v===0?new L(b.startLineNumber,b.startColumn,b.endLineNumber,b.endColumn):new L(b.endLineNumber,b.endColumn,b.startLineNumber,b.startColumn)}static liftSelection(b){return new L(b.selectionStartLineNumber,b.selectionStartColumn,b.positionLineNumber,b.positionColumn)}static selectionsArrEqual(b,v){if(b&&!v||!b&&v)return!1;if(!b&&!v)return!0;if(b.length!==v.length)return!1;for(let g=0,A=b.length;g<A;g++)if(!this.selectionsEqual(b[g],v[g]))return!1;return!0}static isISelection(b){return b&&typeof b.selectionStartLineNumber=="number"&&typeof b.selectionStartColumn=="number"&&typeof b.positionLineNumber=="number"&&typeof b.positionColumn=="number"}static createWithDirection(b,v,g,A,I){return I===0?new L(b,v,g,A):new L(g,A,b,v)}}e.$Bs=L}),define(ke[170],Se([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9r=void 0,e.$9r={tabSize:4,indentSize:4,insertSpaces:!0,detectIndentation:!0,trimAutoWhitespace:!0,largeFileOptimizations:!0,bracketPairColorizationOptions:{enabled:!0,independentColorPoolPerBracketType:!1}}}),define(ke[171],Se([1,0,126]),function(me,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zs=e.$Ys=e.WordCharacterClass=void 0;var F;(function(M){M[M.Regular=0]="Regular",M[M.Whitespace=1]="Whitespace",M[M.WordSeparator=2]="WordSeparator"})(F||(e.WordCharacterClass=F={}));class f extends C.$Ws{constructor(b){super(0);for(let v=0,g=b.length;v<g;v++)this.set(b.charCodeAt(v),2);this.set(32,1),this.set(9,1)}}e.$Ys=f;function L(M){const b={};return v=>(b.hasOwnProperty(v)||(b[v]=M(v)),b[v])}e.$Zs=L(M=>new f(M))}),define(ke[127],Se([1,0,51,3,75]),function(me,e,C,F,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bs=e.$as=e.$_r=e.$$r=e.$0r=void 0,e.$0r="`~!@#$%^&*()-=+[{]}\\|;:'\",.<>/?";function L(I=""){let $="(-?\\d*\\.\\d\\w*)|([^";for(const y of e.$0r)I.indexOf(y)>=0||($+="\\"+y);return $+="\\s]+)",new RegExp($,"g")}e.$$r=L();function M(I){let $=e.$$r;if(I&&I instanceof RegExp)if(I.global)$=I;else{let y="g";I.ignoreCase&&(y+="i"),I.multiline&&(y+="m"),I.unicode&&(y+="u"),$=new RegExp(I.source,y)}return $.lastIndex=0,$}e.$_r=M;const b=new f.$2c;b.unshift({maxLen:1e3,windowSize:15,timeBudget:150});function v(I){const $=b.unshift(I);return(0,F.$Pc)($)}e.$as=v;function g(I,$,y,k,w){if(w||(w=C.Iterable.first(b)),y.length>w.maxLen){let r=I-w.maxLen/2;return r<0?r=0:k+=r,y=y.substring(r,I+w.maxLen/2),g(I,$,y,k,w)}const u=Date.now(),o=I-1-k;let i=-1,n=null;for(let r=1;!(Date.now()-u>=w.timeBudget);r++){const a=o-w.windowSize*r;$.lastIndex=Math.max(0,a);const t=A($,y,o,i);if(!t&&n||(n=t,a<=0))break;i=a}if(n){const r={word:n[0],startColumn:k+1+n.index,endColumn:k+1+n.index+n[0].length};return $.lastIndex=0,r}return null}e.$bs=g;function A(I,$,y,k){let w;for(;w=I.exec($);){const u=w.index||0;if(u<=y&&I.lastIndex>=y)return w;if(k>0&&u>k)return null}return null}}),define(ke[172],Se([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wt=e.$vt=e.IndentAction=void 0;var C;(function(M){M[M.None=0]="None",M[M.Indent=1]="Indent",M[M.IndentOutdent=2]="IndentOutdent",M[M.Outdent=3]="Outdent"})(C||(e.IndentAction=C={}));class F{constructor(b){if(this.e=null,this.f=!1,this.open=b.open,this.close=b.close,this.b=!0,this.c=!0,this.d=!0,Array.isArray(b.notIn))for(let v=0,g=b.notIn.length;v<g;v++)switch(b.notIn[v]){case"string":this.b=!1;break;case"comment":this.c=!1;break;case"regex":this.d=!1;break}}isOK(b){switch(b){case 0:return!0;case 1:return this.c;case 2:return this.b;case 3:return this.d}}shouldAutoClose(b,v){if(b.getTokenCount()===0)return!0;const g=b.findTokenIndexAtOffset(v-2),A=b.getStandardTokenType(g);return this.isOK(A)}g(b,v){for(let g=b;g<=v;g++){const A=String.fromCharCode(g);if(!this.open.includes(A)&&!this.close.includes(A))return A}return null}findNeutralCharacter(){return this.f||(this.f=!0,this.e||(this.e=this.g(48,57)),this.e||(this.e=this.g(97,122)),this.e||(this.e=this.g(65,90))),this.e}}e.$vt=F;class f{constructor(b){this.autoClosingPairsOpenByStart=new Map,this.autoClosingPairsOpenByEnd=new Map,this.autoClosingPairsCloseByStart=new Map,this.autoClosingPairsCloseByEnd=new Map,this.autoClosingPairsCloseSingleChar=new Map;for(const v of b)L(this.autoClosingPairsOpenByStart,v.open.charAt(0),v),L(this.autoClosingPairsOpenByEnd,v.open.charAt(v.open.length-1),v),L(this.autoClosingPairsCloseByStart,v.close.charAt(0),v),L(this.autoClosingPairsCloseByEnd,v.close.charAt(v.close.length-1),v),v.close.length===1&&v.open.length===1&&L(this.autoClosingPairsCloseSingleChar,v.close,v)}}e.$wt=f;function L(M,b,v){M.has(b)?M.get(b).push(v):M.set(b,[v])}}),define(ke[173],Se([1,0,126]),function(me,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$AZ=e.$zZ=e.$yZ=e.State=void 0;var F;(function(y){y[y.Invalid=0]="Invalid",y[y.Start=1]="Start",y[y.H=2]="H",y[y.HT=3]="HT",y[y.HTT=4]="HTT",y[y.HTTP=5]="HTTP",y[y.F=6]="F",y[y.FI=7]="FI",y[y.FIL=8]="FIL",y[y.BeforeColon=9]="BeforeColon",y[y.AfterColon=10]="AfterColon",y[y.AlmostThere=11]="AlmostThere",y[y.End=12]="End",y[y.Accept=13]="Accept",y[y.LastKnownState=14]="LastKnownState"})(F||(e.State=F={}));class f{constructor(k,w,u){const o=new Uint8Array(k*w);for(let i=0,n=k*w;i<n;i++)o[i]=u;this.a=o,this.rows=k,this.cols=w}get(k,w){return this.a[k*this.cols+w]}set(k,w,u){this.a[k*this.cols+w]=u}}class L{constructor(k){let w=0,u=0;for(let i=0,n=k.length;i<n;i++){const[r,a,t]=k[i];a>w&&(w=a),r>u&&(u=r),t>u&&(u=t)}w++,u++;const o=new f(u,w,0);for(let i=0,n=k.length;i<n;i++){const[r,a,t]=k[i];o.set(r,a,t)}this.a=o,this.b=w}nextState(k,w){return w<0||w>=this.b?0:this.a.get(k,w)}}e.$yZ=L;let M=null;function b(){return M===null&&(M=new L([[1,104,2],[1,72,2],[1,102,6],[1,70,6],[2,116,3],[2,84,3],[3,116,4],[3,84,4],[4,112,5],[4,80,5],[5,115,9],[5,83,9],[5,58,10],[6,105,7],[6,73,7],[7,108,8],[7,76,8],[8,101,9],[8,69,9],[9,58,10],[10,47,11],[11,47,12]])),M}var v;(function(y){y[y.None=0]="None",y[y.ForceTermination=1]="ForceTermination",y[y.CannotEndIn=2]="CannotEndIn"})(v||(v={}));let g=null;function A(){if(g===null){g=new C.$Ws(0);const y=` 	<>'"\u3001\u3002\uFF61\uFF64\uFF0C\uFF0E\uFF1A\uFF1B\u2018\u3008\u300C\u300E\u3014\uFF08\uFF3B\uFF5B\uFF62\uFF63\uFF5D\uFF3D\uFF09\u3015\u300F\u300D\u3009\u2019\uFF40\uFF5E\u2026`;for(let w=0;w<y.length;w++)g.set(y.charCodeAt(w),1);const k=".,;:";for(let w=0;w<k.length;w++)g.set(k.charCodeAt(w),2)}return g}class I{static a(k,w,u,o,i){let n=i-1;do{const r=w.charCodeAt(n);if(k.get(r)!==2)break;n--}while(n>o);if(o>0){const r=w.charCodeAt(o-1),a=w.charCodeAt(n);(r===40&&a===41||r===91&&a===93||r===123&&a===125)&&n--}return{range:{startLineNumber:u,startColumn:o+1,endLineNumber:u,endColumn:n+2},url:w.substring(o,n+1)}}static computeLinks(k,w=b()){const u=A(),o=[];for(let i=1,n=k.getLineCount();i<=n;i++){const r=k.getLineContent(i),a=r.length;let t=0,s=0,d=0,c=1,l=!1,h=!1,E=!1,D=!1;for(;t<a;){let m=!1;const p=r.charCodeAt(t);if(c===13){let S;switch(p){case 40:l=!0,S=0;break;case 41:S=l?0:1;break;case 91:E=!0,h=!0,S=0;break;case 93:E=!1,S=h?0:1;break;case 123:D=!0,S=0;break;case 125:S=D?0:1;break;case 39:case 34:case 96:d===p?S=1:d===39||d===34||d===96?S=0:S=1;break;case 42:S=d===42?1:0;break;case 124:S=d===124?1:0;break;case 32:S=E?0:1;break;default:S=u.get(p)}S===1&&(o.push(I.a(u,r,i,s,t)),m=!0)}else if(c===12){let S;p===91?(h=!0,S=0):S=u.get(p),S===1?m=!0:c=13}else c=w.nextState(c,p),c===0&&(m=!0);m&&(c=1,l=!1,h=!1,D=!1,s=t+1,d=p),t++}c===13&&o.push(I.a(u,r,i,s,a))}return o}}e.$zZ=I;function $(y){return!y||typeof y.getLineCount!="function"||typeof y.getLineContent!="function"?[]:I.computeLinks(y)}e.$AZ=$}),define(ke[79],Se([1,0,24]),function(me,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vu=e.$Uu=e.$Tu=e.$Su=e.ModelConstants=e.PositionAffinity=e.$Ru=e.TrackedRangeStickiness=e.$Qu=e.$Pu=e.EndOfLineSequence=e.DefaultEndOfLine=e.EndOfLinePreference=e.InjectedTextCursorStops=e.MinimapPosition=e.GlyphMarginLane=e.OverviewRulerLane=void 0;var F;(function(r){r[r.Left=1]="Left",r[r.Center=2]="Center",r[r.Right=4]="Right",r[r.Full=7]="Full"})(F||(e.OverviewRulerLane=F={}));var f;(function(r){r[r.Left=1]="Left",r[r.Right=2]="Right"})(f||(e.GlyphMarginLane=f={}));var L;(function(r){r[r.Inline=1]="Inline",r[r.Gutter=2]="Gutter"})(L||(e.MinimapPosition=L={}));var M;(function(r){r[r.Both=0]="Both",r[r.Right=1]="Right",r[r.Left=2]="Left",r[r.None=3]="None"})(M||(e.InjectedTextCursorStops=M={}));var b;(function(r){r[r.TextDefined=0]="TextDefined",r[r.LF=1]="LF",r[r.CRLF=2]="CRLF"})(b||(e.EndOfLinePreference=b={}));var v;(function(r){r[r.LF=1]="LF",r[r.CRLF=2]="CRLF"})(v||(e.DefaultEndOfLine=v={}));var g;(function(r){r[r.LF=0]="LF",r[r.CRLF=1]="CRLF"})(g||(e.EndOfLineSequence=g={}));class A{get originalIndentSize(){return this.a?"tabSize":this.indentSize}constructor(a){this._textModelResolvedOptionsBrand=void 0,this.tabSize=Math.max(1,a.tabSize|0),a.indentSize==="tabSize"?(this.indentSize=this.tabSize,this.a=!0):(this.indentSize=Math.max(1,a.indentSize|0),this.a=!1),this.insertSpaces=!!a.insertSpaces,this.defaultEOL=a.defaultEOL|0,this.trimAutoWhitespace=!!a.trimAutoWhitespace,this.bracketPairColorizationOptions=a.bracketPairColorizationOptions}equals(a){return this.tabSize===a.tabSize&&this.a===a.a&&this.indentSize===a.indentSize&&this.insertSpaces===a.insertSpaces&&this.defaultEOL===a.defaultEOL&&this.trimAutoWhitespace===a.trimAutoWhitespace&&(0,C.$en)(this.bracketPairColorizationOptions,a.bracketPairColorizationOptions)}createChangeEvent(a){return{tabSize:this.tabSize!==a.tabSize,indentSize:this.indentSize!==a.indentSize,insertSpaces:this.insertSpaces!==a.insertSpaces,trimAutoWhitespace:this.trimAutoWhitespace!==a.trimAutoWhitespace}}}e.$Pu=A;class I{constructor(a,t){this._findMatchBrand=void 0,this.range=a,this.matches=t}}e.$Qu=I;var $;(function(r){r[r.AlwaysGrowsWhenTypingAtEdges=0]="AlwaysGrowsWhenTypingAtEdges",r[r.NeverGrowsWhenTypingAtEdges=1]="NeverGrowsWhenTypingAtEdges",r[r.GrowsOnlyWhenTypingBefore=2]="GrowsOnlyWhenTypingBefore",r[r.GrowsOnlyWhenTypingAfter=3]="GrowsOnlyWhenTypingAfter"})($||(e.TrackedRangeStickiness=$={}));function y(r){return r&&typeof r.read=="function"}e.$Ru=y;var k;(function(r){r[r.Left=0]="Left",r[r.Right=1]="Right",r[r.None=2]="None",r[r.LeftOfInjectedText=3]="LeftOfInjectedText",r[r.RightOfInjectedText=4]="RightOfInjectedText"})(k||(e.PositionAffinity=k={}));var w;(function(r){r[r.FIRST_LINE_DETECTION_LENGTH_LIMIT=1e3]="FIRST_LINE_DETECTION_LENGTH_LIMIT"})(w||(e.ModelConstants=w={}));class u{constructor(a,t,s,d,c,l){this.identifier=a,this.range=t,this.text=s,this.forceMoveMarkers=d,this.isAutoWhitespaceEdit=c,this._isTracked=l}}e.$Su=u;class o{constructor(a,t,s){this.regex=a,this.wordSeparators=t,this.simpleSearch=s}}e.$Tu=o;class i{constructor(a,t,s){this.reverseEdits=a,this.changes=t,this.trimAutoWhitespaceLineNumbers=s}}e.$Uu=i;function n(r){return!r.isTooLargeForSyncing()&&!r.isForSimpleWidget}e.$Vu=n}),define(ke[174],Se([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zB=e.$yB=e.$xB=e.$wB=e.$vB=e.$uB=e.$tB=e.$sB=e.$rB=e.NodeColor=e.$qB=void 0;class C{constructor(u,o){this.piece=u,this.color=o,this.size_left=0,this.lf_left=0,this.parent=this,this.left=this,this.right=this}next(){if(this.right!==e.$rB)return f(this.right);let u=this;for(;u.parent!==e.$rB&&u.parent.left!==u;)u=u.parent;return u.parent===e.$rB?e.$rB:u.parent}prev(){if(this.left!==e.$rB)return L(this.left);let u=this;for(;u.parent!==e.$rB&&u.parent.right!==u;)u=u.parent;return u.parent===e.$rB?e.$rB:u.parent}detach(){this.parent=null,this.left=null,this.right=null}}e.$qB=C;var F;(function(w){w[w.Black=0]="Black",w[w.Red=1]="Red"})(F||(e.NodeColor=F={})),e.$rB=new C(null,0),e.$rB.parent=e.$rB,e.$rB.left=e.$rB,e.$rB.right=e.$rB,e.$rB.color=0;function f(w){for(;w.left!==e.$rB;)w=w.left;return w}e.$sB=f;function L(w){for(;w.right!==e.$rB;)w=w.right;return w}e.$tB=L;function M(w){return w===e.$rB?0:w.size_left+w.piece.length+M(w.right)}function b(w){return w===e.$rB?0:w.lf_left+w.piece.lineFeedCnt+b(w.right)}function v(){e.$rB.parent=e.$rB}function g(w,u){const o=u.right;o.size_left+=u.size_left+(u.piece?u.piece.length:0),o.lf_left+=u.lf_left+(u.piece?u.piece.lineFeedCnt:0),u.right=o.left,o.left!==e.$rB&&(o.left.parent=u),o.parent=u.parent,u.parent===e.$rB?w.root=o:u.parent.left===u?u.parent.left=o:u.parent.right=o,o.left=u,u.parent=o}e.$uB=g;function A(w,u){const o=u.left;u.left=o.right,o.right!==e.$rB&&(o.right.parent=u),o.parent=u.parent,u.size_left-=o.size_left+(o.piece?o.piece.length:0),u.lf_left-=o.lf_left+(o.piece?o.piece.lineFeedCnt:0),u.parent===e.$rB?w.root=o:u===u.parent.right?u.parent.right=o:u.parent.left=o,o.right=u,u.parent=o}e.$vB=A;function I(w,u){let o,i;if(u.left===e.$rB?(i=u,o=i.right):u.right===e.$rB?(i=u,o=i.left):(i=f(u.right),o=i.right),i===w.root){w.root=o,o.color=0,u.detach(),v(),w.root.parent=e.$rB;return}const n=i.color===1;if(i===i.parent.left?i.parent.left=o:i.parent.right=o,i===u?(o.parent=i.parent,k(w,o)):(i.parent===u?o.parent=i:o.parent=i.parent,k(w,o),i.left=u.left,i.right=u.right,i.parent=u.parent,i.color=u.color,u===w.root?w.root=i:u===u.parent.left?u.parent.left=i:u.parent.right=i,i.left!==e.$rB&&(i.left.parent=i),i.right!==e.$rB&&(i.right.parent=i),i.size_left=u.size_left,i.lf_left=u.lf_left,k(w,i)),u.detach(),o.parent.left===o){const a=M(o),t=b(o);if(a!==o.parent.size_left||t!==o.parent.lf_left){const s=a-o.parent.size_left,d=t-o.parent.lf_left;o.parent.size_left=a,o.parent.lf_left=t,y(w,o.parent,s,d)}}if(k(w,o.parent),n){v();return}let r;for(;o!==w.root&&o.color===0;)o===o.parent.left?(r=o.parent.right,r.color===1&&(r.color=0,o.parent.color=1,g(w,o.parent),r=o.parent.right),r.left.color===0&&r.right.color===0?(r.color=1,o=o.parent):(r.right.color===0&&(r.left.color=0,r.color=1,A(w,r),r=o.parent.right),r.color=o.parent.color,o.parent.color=0,r.right.color=0,g(w,o.parent),o=w.root)):(r=o.parent.left,r.color===1&&(r.color=0,o.parent.color=1,A(w,o.parent),r=o.parent.left),r.left.color===0&&r.right.color===0?(r.color=1,o=o.parent):(r.left.color===0&&(r.right.color=0,r.color=1,g(w,r),r=o.parent.left),r.color=o.parent.color,o.parent.color=0,r.left.color=0,A(w,o.parent),o=w.root));o.color=0,v()}e.$wB=I;function $(w,u){for(k(w,u);u!==w.root&&u.parent.color===1;)if(u.parent===u.parent.parent.left){const o=u.parent.parent.right;o.color===1?(u.parent.color=0,o.color=0,u.parent.parent.color=1,u=u.parent.parent):(u===u.parent.right&&(u=u.parent,g(w,u)),u.parent.color=0,u.parent.parent.color=1,A(w,u.parent.parent))}else{const o=u.parent.parent.left;o.color===1?(u.parent.color=0,o.color=0,u.parent.parent.color=1,u=u.parent.parent):(u===u.parent.left&&(u=u.parent,A(w,u)),u.parent.color=0,u.parent.parent.color=1,g(w,u.parent.parent))}w.root.color=0}e.$xB=$;function y(w,u,o,i){for(;u!==w.root&&u!==e.$rB;)u.parent.left===u&&(u.parent.size_left+=o,u.parent.lf_left+=i),u=u.parent}e.$yB=y;function k(w,u){let o=0,i=0;if(u!==w.root){for(;u!==w.root&&u===u.parent.right;)u=u.parent;if(u!==w.root)for(u=u.parent,o=M(u.left)-u.size_left,i=b(u.left)-u.lf_left,u.size_left+=o,u.lf_left+=i;u!==w.root&&(o!==0||i!==0);)u.parent.left===u&&(u.parent.size_left+=o,u.parent.lf_left+=i),u=u.parent}}e.$zB=k}),define(ke[175],Se([1,0,19,125]),function(me,e,C,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1u=e.$Zu=e.$Yu=void 0;class f{constructor(v){this.a=v,this.b=new Uint32Array(v.length),this.c=new Int32Array(1),this.c[0]=-1}getCount(){return this.a.length}insertValues(v,g){v=(0,F.$Ee)(v);const A=this.a,I=this.b,$=g.length;return $===0?!1:(this.a=new Uint32Array(A.length+$),this.a.set(A.subarray(0,v),0),this.a.set(A.subarray(v),v+$),this.a.set(g,v),v-1<this.c[0]&&(this.c[0]=v-1),this.b=new Uint32Array(this.a.length),this.c[0]>=0&&this.b.set(I.subarray(0,this.c[0]+1)),!0)}setValue(v,g){return v=(0,F.$Ee)(v),g=(0,F.$Ee)(g),this.a[v]===g?!1:(this.a[v]=g,v-1<this.c[0]&&(this.c[0]=v-1),!0)}removeValues(v,g){v=(0,F.$Ee)(v),g=(0,F.$Ee)(g);const A=this.a,I=this.b;if(v>=A.length)return!1;const $=A.length-v;return g>=$&&(g=$),g===0?!1:(this.a=new Uint32Array(A.length-g),this.a.set(A.subarray(0,v),0),this.a.set(A.subarray(v+g),v),this.b=new Uint32Array(this.a.length),v-1<this.c[0]&&(this.c[0]=v-1),this.c[0]>=0&&this.b.set(I.subarray(0,this.c[0]+1)),!0)}getTotalSum(){return this.a.length===0?0:this.d(this.a.length-1)}getPrefixSum(v){return v<0?0:(v=(0,F.$Ee)(v),this.d(v))}d(v){if(v<=this.c[0])return this.b[v];let g=this.c[0]+1;g===0&&(this.b[0]=this.a[0],g++),v>=this.a.length&&(v=this.a.length-1);for(let A=g;A<=v;A++)this.b[A]=this.b[A-1]+this.a[A];return this.c[0]=Math.max(this.c[0],v),this.b[v]}getIndexOf(v){v=Math.floor(v),this.getTotalSum();let g=0,A=this.a.length-1,I=0,$=0,y=0;for(;g<=A;)if(I=g+(A-g)/2|0,$=this.b[I],y=$-this.a[I],v<y)A=I-1;else if(v>=$)g=I+1;else break;return new M(I,v-y)}}e.$Yu=f;class L{constructor(v){this.a=v,this.b=!1,this.c=-1,this.d=[],this.e=[]}getTotalSum(){return this.g(),this.e.length}getPrefixSum(v){return this.g(),v===0?0:this.d[v-1]}getIndexOf(v){this.g();const g=this.e[v],A=g>0?this.d[g-1]:0;return new M(g,v-A)}removeValues(v,g){this.a.splice(v,g),this.f(v)}insertValues(v,g){this.a=(0,C.$Vb)(this.a,v,g),this.f(v)}f(v){this.b=!1,this.c=Math.min(this.c,v-1)}g(){if(!this.b){for(let v=this.c+1,g=this.a.length;v<g;v++){const A=this.a[v],I=v>0?this.d[v-1]:0;this.d[v]=I+A;for(let $=0;$<A;$++)this.e[I+$]=v}this.d.length=this.a.length,this.e.length=this.d[this.d.length-1],this.b=!0,this.c=this.a.length-1}}setValue(v,g){this.a[v]!==g&&(this.a[v]=g,this.f(v))}}e.$Zu=L;class M{constructor(v,g){this.index=v,this.remainder=g,this._prefixSumIndexOfResultBrand=void 0,this.index=v,this.remainder=g}}e.$1u=M}),define(ke[176],Se([1,0,13,53,175]),function(me,e,C,F,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2u=void 0;class L{constructor(b,v,g,A){this.d=b,this.f=v,this.g=g,this.h=A,this.j=null,this.k=null}dispose(){this.f.length=0}get version(){return this.h}getText(){return this.k===null&&(this.k=this.f.join(this.g)),this.k}onEvents(b){b.eol&&b.eol!==this.g&&(this.g=b.eol,this.j=null);const v=b.changes;for(const g of v)this.o(g.range),this.p(new F.$ys(g.range.startLineNumber,g.range.startColumn),g.text);this.h=b.versionId,this.k=null}l(){if(!this.j){const b=this.g.length,v=this.f.length,g=new Uint32Array(v);for(let A=0;A<v;A++)g[A]=this.f[A].length+b;this.j=new f.$Yu(g)}}n(b,v){this.f[b]=v,this.j&&this.j.setValue(b,this.f[b].length+this.g.length)}o(b){if(b.startLineNumber===b.endLineNumber){if(b.startColumn===b.endColumn)return;this.n(b.startLineNumber-1,this.f[b.startLineNumber-1].substring(0,b.startColumn-1)+this.f[b.startLineNumber-1].substring(b.endColumn-1));return}this.n(b.startLineNumber-1,this.f[b.startLineNumber-1].substring(0,b.startColumn-1)+this.f[b.endLineNumber-1].substring(b.endColumn-1)),this.f.splice(b.startLineNumber,b.endLineNumber-b.startLineNumber),this.j&&this.j.removeValues(b.startLineNumber,b.endLineNumber-b.startLineNumber)}p(b,v){if(v.length===0)return;const g=(0,C.$Te)(v);if(g.length===1){this.n(b.lineNumber-1,this.f[b.lineNumber-1].substring(0,b.column-1)+g[0]+this.f[b.lineNumber-1].substring(b.column-1));return}g[g.length-1]+=this.f[b.lineNumber-1].substring(b.column-1),this.n(b.lineNumber-1,this.f[b.lineNumber-1].substring(0,b.column-1)+g[0]);const A=new Uint32Array(g.length-1);for(let I=1;I<g.length;I++)this.f.splice(b.lineNumber+I-1,0,g[I]),A[I-1]=g[I].length+this.g.length;this.j&&this.j.insertValues(b.lineNumber,A)}}e.$2u=L}),define(ke[99],Se([1,0,13,171,53,29,79]),function(me,e,C,F,f,L,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$FB=e.$EB=e.$DB=e.$CB=e.$BB=e.$AB=void 0;const b=999;class v{constructor(i,n,r,a){this.searchString=i,this.isRegex=n,this.matchCase=r,this.wordSeparators=a}parseSearchRequest(){if(this.searchString==="")return null;let i;this.isRegex?i=g(this.searchString):i=this.searchString.indexOf(`
`)>=0;let n=null;try{n=C.$Re(this.searchString,this.isRegex,{matchCase:this.matchCase,wholeWord:!1,multiline:i,global:!0,unicode:!0})}catch{return null}if(!n)return null;let r=!this.isRegex&&!i;return r&&this.searchString.toLowerCase()!==this.searchString.toUpperCase()&&(r=this.matchCase),new M.$Tu(n,this.wordSeparators?(0,F.$Zs)(this.wordSeparators):null,r?this.searchString:null)}}e.$AB=v;function g(o){if(!o||o.length===0)return!1;for(let i=0,n=o.length;i<n;i++){const r=o.charCodeAt(i);if(r===10)return!0;if(r===92){if(i++,i>=n)break;const a=o.charCodeAt(i);if(a===110||a===114||a===87)return!0}}return!1}e.$BB=g;function A(o,i,n){if(!n)return new M.$Qu(o,null);const r=[];for(let a=0,t=i.length;a<t;a++)r[a]=i[a];return new M.$Qu(o,r)}e.$CB=A;class I{constructor(i){const n=[];let r=0;for(let a=0,t=i.length;a<t;a++)i.charCodeAt(a)===10&&(n[r++]=a);this.a=n}findLineFeedCountBeforeOffset(i){const n=this.a;let r=0,a=n.length-1;if(a===-1||i<=n[0])return 0;for(;r<a;){const t=r+((a-r)/2>>0);n[t]>=i?a=t-1:n[t+1]>=i?(r=t,a=t):r=t+1}return r+1}}class ${static findMatches(i,n,r,a,t){const s=n.parseSearchRequest();return s?s.regex.multiline?this.b(i,r,new u(s.wordSeparators,s.regex),a,t):this.c(i,r,s,a,t):[]}static a(i,n,r,a,t,s){let d,c=0;a?(c=a.findLineFeedCountBeforeOffset(t),d=n+t+c):d=n+t;let l;if(a){const m=a.findLineFeedCountBeforeOffset(t+s.length)-c;l=d+s.length+m}else l=d+s.length;const h=i.getPositionAt(d),E=i.getPositionAt(l);return new L.$zs(h.lineNumber,h.column,E.lineNumber,E.column)}static b(i,n,r,a,t){const s=i.getOffsetAt(n.getStartPosition()),d=i.getValueInRange(n,1),c=i.getEOL()===`\r
`?new I(d):null,l=[];let h=0,E;for(r.reset(0);E=r.next(d);)if(l[h++]=A(this.a(i,s,d,c,E.index,E[0]),E,a),h>=t)return l;return l}static c(i,n,r,a,t){const s=[];let d=0;if(n.startLineNumber===n.endLineNumber){const l=i.getLineContent(n.startLineNumber).substring(n.startColumn-1,n.endColumn-1);return d=this.d(r,l,n.startLineNumber,n.startColumn-1,d,s,a,t),s}const c=i.getLineContent(n.startLineNumber).substring(n.startColumn-1);d=this.d(r,c,n.startLineNumber,n.startColumn-1,d,s,a,t);for(let l=n.startLineNumber+1;l<n.endLineNumber&&d<t;l++)d=this.d(r,i.getLineContent(l),l,0,d,s,a,t);if(d<t){const l=i.getLineContent(n.endLineNumber).substring(0,n.endColumn-1);d=this.d(r,l,n.endLineNumber,0,d,s,a,t)}return s}static d(i,n,r,a,t,s,d,c){const l=i.wordSeparators;if(!d&&i.simpleSearch){const D=i.simpleSearch,m=D.length,p=n.length;let S=-m;for(;(S=n.indexOf(D,S+m))!==-1;)if((!l||w(l,n,p,S,m))&&(s[t++]=new M.$Qu(new L.$zs(r,S+1+a,r,S+1+m+a),null),t>=c))return t;return t}const h=new u(i.wordSeparators,i.regex);let E;h.reset(0);do if(E=h.next(n),E&&(s[t++]=A(new L.$zs(r,E.index+1+a,r,E.index+1+E[0].length+a),E,d),t>=c))return t;while(E);return t}static findNextMatch(i,n,r,a){const t=n.parseSearchRequest();if(!t)return null;const s=new u(t.wordSeparators,t.regex);return t.regex.multiline?this.e(i,r,s,a):this.f(i,r,s,a)}static e(i,n,r,a){const t=new f.$ys(n.lineNumber,1),s=i.getOffsetAt(t),d=i.getLineCount(),c=i.getValueInRange(new L.$zs(t.lineNumber,t.column,d,i.getLineMaxColumn(d)),1),l=i.getEOL()===`\r
`?new I(c):null;r.reset(n.column-1);const h=r.next(c);return h?A(this.a(i,s,c,l,h.index,h[0]),h,a):n.lineNumber!==1||n.column!==1?this.e(i,new f.$ys(1,1),r,a):null}static f(i,n,r,a){const t=i.getLineCount(),s=n.lineNumber,d=i.getLineContent(s),c=this.g(r,d,s,n.column,a);if(c)return c;for(let l=1;l<=t;l++){const h=(s+l-1)%t,E=i.getLineContent(h+1),D=this.g(r,E,h+1,1,a);if(D)return D}return null}static g(i,n,r,a,t){i.reset(a-1);const s=i.next(n);return s?A(new L.$zs(r,s.index+1,r,s.index+1+s[0].length),s,t):null}static findPreviousMatch(i,n,r,a){const t=n.parseSearchRequest();if(!t)return null;const s=new u(t.wordSeparators,t.regex);return t.regex.multiline?this.h(i,r,s,a):this.j(i,r,s,a)}static h(i,n,r,a){const t=this.b(i,new L.$zs(1,1,n.lineNumber,n.column),r,a,10*b);if(t.length>0)return t[t.length-1];const s=i.getLineCount();return n.lineNumber!==s||n.column!==i.getLineMaxColumn(s)?this.h(i,new f.$ys(s,i.getLineMaxColumn(s)),r,a):null}static j(i,n,r,a){const t=i.getLineCount(),s=n.lineNumber,d=i.getLineContent(s).substring(0,n.column-1),c=this.k(r,d,s,a);if(c)return c;for(let l=1;l<=t;l++){const h=(t+s-l-1)%t,E=i.getLineContent(h+1),D=this.k(r,E,h+1,a);if(D)return D}return null}static k(i,n,r,a){let t=null,s;for(i.reset(0);s=i.next(n);)t=A(new L.$zs(r,s.index+1,r,s.index+1+s[0].length),s,a);return t}}e.$DB=$;function y(o,i,n,r,a){if(r===0)return!0;const t=i.charCodeAt(r-1);if(o.get(t)!==0||t===13||t===10)return!0;if(a>0){const s=i.charCodeAt(r);if(o.get(s)!==0)return!0}return!1}function k(o,i,n,r,a){if(r+a===n)return!0;const t=i.charCodeAt(r+a);if(o.get(t)!==0||t===13||t===10)return!0;if(a>0){const s=i.charCodeAt(r+a-1);if(o.get(s)!==0)return!0}return!1}function w(o,i,n,r,a){return y(o,i,n,r,a)&&k(o,i,n,r,a)}e.$EB=w;class u{constructor(i,n){this._wordSeparators=i,this.a=n,this.b=-1,this.c=0}reset(i){this.a.lastIndex=i,this.b=-1,this.c=0}next(i){const n=i.length;let r;do{if(this.b+this.c===n||(r=this.a.exec(i),!r))return null;const a=r.index,t=r[0].length;if(a===this.b&&t===this.c){if(t===0){C.$af(i,n,this.a.lastIndex)>65535?this.a.lastIndex+=2:this.a.lastIndex+=1;continue}return null}if(this.b=a,this.c=t,!this._wordSeparators||w(this._wordSeparators,i,n,a,t))return r}while(r);return null}}e.$FB=u}),define(ke[128],Se([1,0,53,29,79,174,99]),function(me,e,C,F,f,L,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$KB=e.$JB=e.$IB=e.$HB=e.$GB=void 0;const b=65535;function v(o){let i;return o[o.length-1]<65536?i=new Uint16Array(o.length):i=new Uint32Array(o.length),i.set(o,0),i}class g{constructor(i,n,r,a,t){this.lineStarts=i,this.cr=n,this.lf=r,this.crlf=a,this.isBasicASCII=t}}function A(o,i=!0){const n=[0];let r=1;for(let a=0,t=o.length;a<t;a++){const s=o.charCodeAt(a);s===13?a+1<t&&o.charCodeAt(a+1)===10?(n[r++]=a+2,a++):n[r++]=a+1:s===10&&(n[r++]=a+1)}return i?v(n):n}e.$GB=A;function I(o,i){o.length=0,o[0]=0;let n=1,r=0,a=0,t=0,s=!0;for(let c=0,l=i.length;c<l;c++){const h=i.charCodeAt(c);h===13?c+1<l&&i.charCodeAt(c+1)===10?(t++,o[n++]=c+2,c++):(r++,o[n++]=c+1):h===10?(a++,o[n++]=c+1):s&&h!==9&&(h<32||h>126)&&(s=!1)}const d=new g(v(o),r,a,t,s);return o.length=0,d}e.$HB=I;class ${constructor(i,n,r,a,t){this.bufferIndex=i,this.start=n,this.end=r,this.lineFeedCnt=a,this.length=t}}e.$IB=$;class y{constructor(i,n){this.buffer=i,this.lineStarts=n}}e.$JB=y;class k{constructor(i,n){this.a=[],this.c=i,this.d=n,this.b=0,i.root!==L.$rB&&i.iterate(i.root,r=>(r!==L.$rB&&this.a.push(r.piece),!0))}read(){return this.a.length===0?this.b===0?(this.b++,this.d):null:this.b>this.a.length-1?null:this.b===0?this.d+this.c.getPieceContent(this.a[this.b++]):this.c.getPieceContent(this.a[this.b++])}}class w{constructor(i){this.a=i,this.b=[]}get(i){for(let n=this.b.length-1;n>=0;n--){const r=this.b[n];if(r.nodeStartOffset<=i&&r.nodeStartOffset+r.node.piece.length>=i)return r}return null}get2(i){for(let n=this.b.length-1;n>=0;n--){const r=this.b[n];if(r.nodeStartLineNumber&&r.nodeStartLineNumber<i&&r.nodeStartLineNumber+r.node.piece.lineFeedCnt>=i)return r}return null}set(i){this.b.length>=this.a&&this.b.shift(),this.b.push(i)}validate(i){let n=!1;const r=this.b;for(let a=0;a<r.length;a++){const t=r[a];if(t.node.parent===null||t.nodeStartOffset>=i){r[a]=null,n=!0;continue}}if(n){const a=[];for(const t of r)t!==null&&a.push(t);this.b=a}}}class u{constructor(i,n,r){this.create(i,n,r)}create(i,n,r){this.a=[new y("",[0])],this.g={line:0,column:0},this.root=L.$rB,this.b=1,this.c=0,this.d=n,this.e=n.length,this.f=r;let a=null;for(let t=0,s=i.length;t<s;t++)if(i[t].buffer.length>0){i[t].lineStarts||(i[t].lineStarts=A(i[t].buffer));const d=new $(t+1,{line:0,column:0},{line:i[t].lineStarts.length-1,column:i[t].buffer.length-i[t].lineStarts[i[t].lineStarts.length-1]},i[t].lineStarts.length-1,i[t].buffer.length);this.a.push(i[t]),a=this.S(a,d)}this.h=new w(1),this.j={lineNumber:0,value:""},this.y()}normalizeEOL(i){const n=b,r=n-Math.floor(n/3),a=r*2;let t="",s=0;const d=[];if(this.iterate(this.root,c=>{const l=this.R(c),h=l.length;if(s<=r||s+h<a)return t+=l,s+=h,!0;const E=t.replace(/\r\n|\r|\n/g,i);return d.push(new y(E,A(E))),t=l,s=h,!0}),s>0){const c=t.replace(/\r\n|\r|\n/g,i);d.push(new y(c,A(c)))}this.create(d,i,!0)}getEOL(){return this.d}setEOL(i){this.d=i,this.e=this.d.length,this.normalizeEOL(i)}createSnapshot(i){return new k(this,i)}equal(i){if(this.getLength()!==i.getLength()||this.getLineCount()!==i.getLineCount())return!1;let n=0;return this.iterate(this.root,a=>{if(a===L.$rB)return!0;const t=this.R(a),s=t.length,d=i.G(n),c=i.G(n+s),l=i.getValueInRange2(d,c);return n+=s,t===l})}getOffsetAt(i,n){let r=0,a=this.root;for(;a!==L.$rB;)if(a.left!==L.$rB&&a.lf_left+1>=i)a=a.left;else if(a.lf_left+a.piece.lineFeedCnt+1>=i){r+=a.size_left;const t=this.B(a,i-a.lf_left-2);return r+=t+n-1}else i-=a.lf_left+a.piece.lineFeedCnt,r+=a.size_left+a.piece.length,a=a.right;return r}getPositionAt(i){i=Math.floor(i),i=Math.max(0,i);let n=this.root,r=0;const a=i;for(;n!==L.$rB;)if(n.size_left!==0&&n.size_left>=i)n=n.left;else if(n.size_left+n.piece.length>=i){const t=this.A(n,i-n.size_left);if(r+=n.lf_left+t.index,t.index===0){const s=this.getOffsetAt(r+1,1),d=a-s;return new C.$ys(r+1,d+1)}return new C.$ys(r+1,t.remainder+1)}else if(i-=n.size_left+n.piece.length,r+=n.lf_left+n.piece.lineFeedCnt,n.right===L.$rB){const t=this.getOffsetAt(r+1,1),s=a-i-t;return new C.$ys(r+1,s+1)}else n=n.right;return new C.$ys(1,1)}getValueInRange(i,n){if(i.startLineNumber===i.endLineNumber&&i.startColumn===i.endColumn)return"";const r=this.H(i.startLineNumber,i.startColumn),a=this.H(i.endLineNumber,i.endColumn),t=this.getValueInRange2(r,a);return n?n!==this.d||!this.f?t.replace(/\r\n|\r|\n/g,n):n===this.getEOL()&&this.f?t:t.replace(/\r\n|\r|\n/g,n):t}getValueInRange2(i,n){if(i.node===n.node){const d=i.node,c=this.a[d.piece.bufferIndex].buffer,l=this.u(d.piece.bufferIndex,d.piece.start);return c.substring(l+i.remainder,l+n.remainder)}let r=i.node;const a=this.a[r.piece.bufferIndex].buffer,t=this.u(r.piece.bufferIndex,r.piece.start);let s=a.substring(t+i.remainder,t+r.piece.length);for(r=r.next();r!==L.$rB;){const d=this.a[r.piece.bufferIndex].buffer,c=this.u(r.piece.bufferIndex,r.piece.start);if(r===n.node){s+=d.substring(c,c+n.remainder);break}else s+=d.substr(c,r.piece.length);r=r.next()}return s}getLinesContent(){const i=[];let n=0,r="",a=!1;return this.iterate(this.root,t=>{if(t===L.$rB)return!0;const s=t.piece;let d=s.length;if(d===0)return!0;const c=this.a[s.bufferIndex].buffer,l=this.a[s.bufferIndex].lineStarts,h=s.start.line,E=s.end.line;let D=l[h]+s.start.column;if(a&&(c.charCodeAt(D)===10&&(D++,d--),i[n++]=r,r="",a=!1,d===0))return!0;if(h===E)return!this.f&&c.charCodeAt(D+d-1)===13?(a=!0,r+=c.substr(D,d-1)):r+=c.substr(D,d),!0;r+=this.f?c.substring(D,Math.max(D,l[h+1]-this.e)):c.substring(D,l[h+1]).replace(/(\r\n|\r|\n)$/,""),i[n++]=r;for(let m=h+1;m<E;m++)r=this.f?c.substring(l[m],l[m+1]-this.e):c.substring(l[m],l[m+1]).replace(/(\r\n|\r|\n)$/,""),i[n++]=r;return!this.f&&c.charCodeAt(l[E]+s.end.column-1)===13?(a=!0,s.end.column===0?n--:r=c.substr(l[E],s.end.column-1)):r=c.substr(l[E],s.end.column),!0}),a&&(i[n++]=r,r=""),i[n++]=r,i}getLength(){return this.c}getLineCount(){return this.b}getLineContent(i){return this.j.lineNumber===i?this.j.value:(this.j.lineNumber=i,i===this.b?this.j.value=this.getLineRawContent(i):this.f?this.j.value=this.getLineRawContent(i,this.e):this.j.value=this.getLineRawContent(i).replace(/(\r\n|\r|\n)$/,""),this.j.value)}l(i){if(i.remainder===i.node.piece.length){const n=i.node.next();if(!n)return 0;const r=this.a[n.piece.bufferIndex],a=this.u(n.piece.bufferIndex,n.piece.start);return r.buffer.charCodeAt(a)}else{const n=this.a[i.node.piece.bufferIndex],a=this.u(i.node.piece.bufferIndex,i.node.piece.start)+i.remainder;return n.buffer.charCodeAt(a)}}getLineCharCode(i,n){const r=this.H(i,n+1);return this.l(r)}getLineLength(i){if(i===this.getLineCount()){const n=this.getOffsetAt(i,1);return this.getLength()-n}return this.getOffsetAt(i+1,1)-this.getOffsetAt(i,1)-this.e}getCharCode(i){const n=this.G(i);return this.l(n)}findMatchesInNode(i,n,r,a,t,s,d,c,l,h,E){const D=this.a[i.piece.bufferIndex],m=this.u(i.piece.bufferIndex,i.piece.start),p=this.u(i.piece.bufferIndex,t),S=this.u(i.piece.bufferIndex,s);let P;const z={line:0,column:0};let j,R;n._wordSeparators?(j=D.buffer.substring(p,S),R=T=>T+p,n.reset(0)):(j=D.buffer,R=T=>T,n.reset(p));do if(P=n.next(j),P){if(R(P.index)>=S)return h;this.s(i,R(P.index)-m,z);const T=this.t(i.piece.bufferIndex,t,z),N=z.line===t.line?z.column-t.column+a:z.column+1,O=N+P[0].length;if(E[h++]=(0,M.$CB)(new F.$zs(r+T,N,r+T,O),P,c),R(P.index)+P[0].length>=S||h>=l)return h}while(P);return h}findMatchesLineByLine(i,n,r,a){const t=[];let s=0;const d=new M.$FB(n.wordSeparators,n.regex);let c=this.H(i.startLineNumber,i.startColumn);if(c===null)return[];const l=this.H(i.endLineNumber,i.endColumn);if(l===null)return[];let h=this.s(c.node,c.remainder);const E=this.s(l.node,l.remainder);if(c.node===l.node)return this.findMatchesInNode(c.node,d,i.startLineNumber,i.startColumn,h,E,n,r,a,s,t),t;let D=i.startLineNumber,m=c.node;for(;m!==l.node;){const S=this.t(m.piece.bufferIndex,h,m.piece.end);if(S>=1){const z=this.a[m.piece.bufferIndex].lineStarts,j=this.u(m.piece.bufferIndex,m.piece.start),R=z[h.line+S],T=D===i.startLineNumber?i.startColumn:1;if(s=this.findMatchesInNode(m,d,D,T,h,this.s(m,R-j),n,r,a,s,t),s>=a)return t;D+=S}const P=D===i.startLineNumber?i.startColumn-1:0;if(D===i.endLineNumber){const z=this.getLineContent(D).substring(P,i.endColumn-1);return s=this.n(n,d,z,i.endLineNumber,P,s,t,r,a),t}if(s=this.n(n,d,this.getLineContent(D).substr(P),D,P,s,t,r,a),s>=a)return t;D++,c=this.H(D,1),m=c.node,h=this.s(c.node,c.remainder)}if(D===i.endLineNumber){const S=D===i.startLineNumber?i.startColumn-1:0,P=this.getLineContent(D).substring(S,i.endColumn-1);return s=this.n(n,d,P,i.endLineNumber,S,s,t,r,a),t}const p=D===i.startLineNumber?i.startColumn:1;return s=this.findMatchesInNode(l.node,d,D,p,h,E,n,r,a,s,t),t}n(i,n,r,a,t,s,d,c,l){const h=i.wordSeparators;if(!c&&i.simpleSearch){const D=i.simpleSearch,m=D.length,p=r.length;let S=-m;for(;(S=r.indexOf(D,S+m))!==-1;)if((!h||(0,M.$EB)(h,r,p,S,m))&&(d[s++]=new f.$Qu(new F.$zs(a,S+1+t,a,S+1+m+t),null),s>=l))return s;return s}let E;n.reset(0);do if(E=n.next(r),E&&(d[s++]=(0,M.$CB)(new F.$zs(a,E.index+1+t,a,E.index+1+E[0].length+t),E,c),s>=l))return s;while(E);return s}insert(i,n,r=!1){if(this.f=this.f&&r,this.j.lineNumber=0,this.j.value="",this.root!==L.$rB){const{node:a,remainder:t,nodeStartOffset:s}=this.G(i),d=a.piece,c=d.bufferIndex,l=this.s(a,t);if(a.piece.bufferIndex===0&&d.end.line===this.g.line&&d.end.column===this.g.column&&s+d.length===i&&n.length<b){this.F(a,n),this.y();return}if(s===i)this.o(n,a),this.h.validate(i);else if(s+a.piece.length>i){const h=[];let E=new $(d.bufferIndex,l,d.end,this.t(d.bufferIndex,l,d.end),this.u(c,d.end)-this.u(c,l));if(this.K()&&this.M(n)&&this.I(a,t)===10){const S={line:E.start.line+1,column:0};E=new $(E.bufferIndex,S,E.end,this.t(E.bufferIndex,S,E.end),E.length-1),n+=`
`}if(this.K()&&this.L(n))if(this.I(a,t-1)===13){const S=this.s(a,t-1);this.C(a,S),n="\r"+n,a.piece.length===0&&h.push(a)}else this.C(a,l);else this.C(a,l);const D=this.w(n);E.length>0&&this.S(a,E);let m=a;for(let p=0;p<D.length;p++)m=this.S(m,D[p]);this.v(h)}else this.q(n,a)}else{const a=this.w(n);let t=this.T(null,a[0]);for(let s=1;s<a.length;s++)t=this.S(t,a[s])}this.y()}delete(i,n){if(this.j.lineNumber=0,this.j.value="",n<=0||this.root===L.$rB)return;const r=this.G(i),a=this.G(i+n),t=r.node,s=a.node;if(t===s){const D=this.s(t,r.remainder),m=this.s(t,a.remainder);if(r.nodeStartOffset===i){if(n===t.piece.length){const p=t.next();(0,L.$wB)(this,t),this.N(p),this.y();return}this.D(t,m),this.h.validate(i),this.N(t),this.y();return}if(r.nodeStartOffset+t.piece.length===i+n){this.C(t,D),this.O(t),this.y();return}this.E(t,D,m),this.y();return}const d=[],c=this.s(t,r.remainder);this.C(t,c),this.h.validate(i),t.piece.length===0&&d.push(t);const l=this.s(s,a.remainder);this.D(s,l),s.piece.length===0&&d.push(s);const h=t.next();for(let D=h;D!==L.$rB&&D!==s;D=D.next())d.push(D);const E=t.piece.length===0?t.prev():t;this.v(d),this.O(E),this.y()}o(i,n){const r=[];if(this.K()&&this.M(i)&&this.L(n)){const s=n.piece,d={line:s.start.line+1,column:0},c=new $(s.bufferIndex,d,s.end,this.t(s.bufferIndex,d,s.end),s.length-1);n.piece=c,i+=`
`,(0,L.$yB)(this,n,-1,-1),n.piece.length===0&&r.push(n)}const a=this.w(i);let t=this.T(n,a[a.length-1]);for(let s=a.length-2;s>=0;s--)t=this.T(t,a[s]);this.N(t),this.v(r)}q(i,n){this.Q(i,n)&&(i+=`
`);const r=this.w(i),a=this.S(n,r[0]);let t=a;for(let s=1;s<r.length;s++)t=this.S(t,r[s]);this.N(a)}s(i,n,r){const a=i.piece,t=i.piece.bufferIndex,s=this.a[t].lineStarts,c=s[a.start.line]+a.start.column+n;let l=a.start.line,h=a.end.line,E=0,D=0,m=0;for(;l<=h&&(E=l+(h-l)/2|0,m=s[E],E!==h);)if(D=s[E+1],c<m)h=E-1;else if(c>=D)l=E+1;else break;return r?(r.line=E,r.column=c-m,null):{line:E,column:c-m}}t(i,n,r){if(r.column===0)return r.line-n.line;const a=this.a[i].lineStarts;if(r.line===a.length-1)return r.line-n.line;const t=a[r.line+1],s=a[r.line]+r.column;if(t>s+1)return r.line-n.line;const d=s-1;return this.a[i].buffer.charCodeAt(d)===13?r.line-n.line+1:r.line-n.line}u(i,n){return this.a[i].lineStarts[n.line]+n.column}v(i){for(let n=0;n<i.length;n++)(0,L.$wB)(this,i[n])}w(i){if(i.length>b){const h=[];for(;i.length>b;){const D=i.charCodeAt(b-1);let m;D===13||D>=55296&&D<=56319?(m=i.substring(0,b-1),i=i.substring(b-1)):(m=i.substring(0,b),i=i.substring(b));const p=A(m);h.push(new $(this.a.length,{line:0,column:0},{line:p.length-1,column:m.length-p[p.length-1]},p.length-1,m.length)),this.a.push(new y(m,p))}const E=A(i);return h.push(new $(this.a.length,{line:0,column:0},{line:E.length-1,column:i.length-E[E.length-1]},E.length-1,i.length)),this.a.push(new y(i,E)),h}let n=this.a[0].buffer.length;const r=A(i,!1);let a=this.g;if(this.a[0].lineStarts[this.a[0].lineStarts.length-1]===n&&n!==0&&this.L(i)&&this.M(this.a[0].buffer)){this.g={line:this.g.line,column:this.g.column+1},a=this.g;for(let h=0;h<r.length;h++)r[h]+=n+1;this.a[0].lineStarts=this.a[0].lineStarts.concat(r.slice(1)),this.a[0].buffer+="_"+i,n+=1}else{if(n!==0)for(let h=0;h<r.length;h++)r[h]+=n;this.a[0].lineStarts=this.a[0].lineStarts.concat(r.slice(1)),this.a[0].buffer+=i}const t=this.a[0].buffer.length,s=this.a[0].lineStarts.length-1,d=t-this.a[0].lineStarts[s],c={line:s,column:d},l=new $(0,a,c,this.t(0,a,c),t-n);return this.g=c,[l]}getLinesRawContent(){return this.U(this.root)}getLineRawContent(i,n=0){let r=this.root,a="";const t=this.h.get2(i);if(t){r=t.node;const s=this.B(r,i-t.nodeStartLineNumber-1),d=this.a[r.piece.bufferIndex].buffer,c=this.u(r.piece.bufferIndex,r.piece.start);if(t.nodeStartLineNumber+r.piece.lineFeedCnt===i)a=d.substring(c+s,c+r.piece.length);else{const l=this.B(r,i-t.nodeStartLineNumber);return d.substring(c+s,c+l-n)}}else{let s=0;const d=i;for(;r!==L.$rB;)if(r.left!==L.$rB&&r.lf_left>=i-1)r=r.left;else if(r.lf_left+r.piece.lineFeedCnt>i-1){const c=this.B(r,i-r.lf_left-2),l=this.B(r,i-r.lf_left-1),h=this.a[r.piece.bufferIndex].buffer,E=this.u(r.piece.bufferIndex,r.piece.start);return s+=r.size_left,this.h.set({node:r,nodeStartOffset:s,nodeStartLineNumber:d-(i-1-r.lf_left)}),h.substring(E+c,E+l-n)}else if(r.lf_left+r.piece.lineFeedCnt===i-1){const c=this.B(r,i-r.lf_left-2),l=this.a[r.piece.bufferIndex].buffer,h=this.u(r.piece.bufferIndex,r.piece.start);a=l.substring(h+c,h+r.piece.length);break}else i-=r.lf_left+r.piece.lineFeedCnt,s+=r.size_left+r.piece.length,r=r.right}for(r=r.next();r!==L.$rB;){const s=this.a[r.piece.bufferIndex].buffer;if(r.piece.lineFeedCnt>0){const d=this.B(r,0),c=this.u(r.piece.bufferIndex,r.piece.start);return a+=s.substring(c,c+d-n),a}else{const d=this.u(r.piece.bufferIndex,r.piece.start);a+=s.substr(d,r.piece.length)}r=r.next()}return a}y(){let i=this.root,n=1,r=0;for(;i!==L.$rB;)n+=i.lf_left+i.piece.lineFeedCnt,r+=i.size_left+i.piece.length,i=i.right;this.b=n,this.c=r,this.h.validate(this.c)}A(i,n){const r=i.piece,a=this.s(i,n),t=a.line-r.start.line;if(this.u(r.bufferIndex,r.end)-this.u(r.bufferIndex,r.start)===n){const s=this.t(i.piece.bufferIndex,r.start,a);if(s!==t)return{index:s,remainder:0}}return{index:t,remainder:a.column}}B(i,n){if(n<0)return 0;const r=i.piece,a=this.a[r.bufferIndex].lineStarts,t=r.start.line+n+1;return t>r.end.line?a[r.end.line]+r.end.column-a[r.start.line]-r.start.column:a[t]-a[r.start.line]-r.start.column}C(i,n){const r=i.piece,a=r.lineFeedCnt,t=this.u(r.bufferIndex,r.end),s=n,d=this.u(r.bufferIndex,s),c=this.t(r.bufferIndex,r.start,s),l=c-a,h=d-t,E=r.length+h;i.piece=new $(r.bufferIndex,r.start,s,c,E),(0,L.$yB)(this,i,h,l)}D(i,n){const r=i.piece,a=r.lineFeedCnt,t=this.u(r.bufferIndex,r.start),s=n,d=this.t(r.bufferIndex,s,r.end),c=this.u(r.bufferIndex,s),l=d-a,h=t-c,E=r.length+h;i.piece=new $(r.bufferIndex,s,r.end,d,E),(0,L.$yB)(this,i,h,l)}E(i,n,r){const a=i.piece,t=a.start,s=a.end,d=a.length,c=a.lineFeedCnt,l=n,h=this.t(a.bufferIndex,a.start,l),E=this.u(a.bufferIndex,n)-this.u(a.bufferIndex,t);i.piece=new $(a.bufferIndex,a.start,l,h,E),(0,L.$yB)(this,i,E-d,h-c);const D=new $(a.bufferIndex,r,s,this.t(a.bufferIndex,r,s),this.u(a.bufferIndex,s)-this.u(a.bufferIndex,r)),m=this.S(i,D);this.N(m)}F(i,n){this.Q(n,i)&&(n+=`
`);const r=this.K()&&this.L(n)&&this.M(i),a=this.a[0].buffer.length;this.a[0].buffer+=n;const t=A(n,!1);for(let m=0;m<t.length;m++)t[m]+=a;if(r){const m=this.a[0].lineStarts[this.a[0].lineStarts.length-2];this.a[0].lineStarts.pop(),this.g={line:this.g.line-1,column:a-m}}this.a[0].lineStarts=this.a[0].lineStarts.concat(t.slice(1));const s=this.a[0].lineStarts.length-1,d=this.a[0].buffer.length-this.a[0].lineStarts[s],c={line:s,column:d},l=i.piece.length+n.length,h=i.piece.lineFeedCnt,E=this.t(0,i.piece.start,c),D=E-h;i.piece=new $(i.piece.bufferIndex,i.piece.start,c,E,l),this.g=c,(0,L.$yB)(this,i,n.length,D)}G(i){let n=this.root;const r=this.h.get(i);if(r)return{node:r.node,nodeStartOffset:r.nodeStartOffset,remainder:i-r.nodeStartOffset};let a=0;for(;n!==L.$rB;)if(n.size_left>i)n=n.left;else if(n.size_left+n.piece.length>=i){a+=n.size_left;const t={node:n,remainder:i-n.size_left,nodeStartOffset:a};return this.h.set(t),t}else i-=n.size_left+n.piece.length,a+=n.size_left+n.piece.length,n=n.right;return null}H(i,n){let r=this.root,a=0;for(;r!==L.$rB;)if(r.left!==L.$rB&&r.lf_left>=i-1)r=r.left;else if(r.lf_left+r.piece.lineFeedCnt>i-1){const t=this.B(r,i-r.lf_left-2),s=this.B(r,i-r.lf_left-1);return a+=r.size_left,{node:r,remainder:Math.min(t+n-1,s),nodeStartOffset:a}}else if(r.lf_left+r.piece.lineFeedCnt===i-1){const t=this.B(r,i-r.lf_left-2);if(t+n-1<=r.piece.length)return{node:r,remainder:t+n-1,nodeStartOffset:a};n-=r.piece.length-t;break}else i-=r.lf_left+r.piece.lineFeedCnt,a+=r.size_left+r.piece.length,r=r.right;for(r=r.next();r!==L.$rB;){if(r.piece.lineFeedCnt>0){const t=this.B(r,0),s=this.J(r);return{node:r,remainder:Math.min(n-1,t),nodeStartOffset:s}}else if(r.piece.length>=n-1){const t=this.J(r);return{node:r,remainder:n-1,nodeStartOffset:t}}else n-=r.piece.length;r=r.next()}return null}I(i,n){if(i.piece.lineFeedCnt<1)return-1;const r=this.a[i.piece.bufferIndex],a=this.u(i.piece.bufferIndex,i.piece.start)+n;return r.buffer.charCodeAt(a)}J(i){if(!i)return 0;let n=i.size_left;for(;i!==this.root;)i.parent.right===i&&(n+=i.parent.size_left+i.parent.piece.length),i=i.parent;return n}K(){return!(this.f&&this.d===`
`)}L(i){if(typeof i=="string")return i.charCodeAt(0)===10;if(i===L.$rB||i.piece.lineFeedCnt===0)return!1;const n=i.piece,r=this.a[n.bufferIndex].lineStarts,a=n.start.line,t=r[a]+n.start.column;return a===r.length-1||r[a+1]>t+1?!1:this.a[n.bufferIndex].buffer.charCodeAt(t)===10}M(i){return typeof i=="string"?i.charCodeAt(i.length-1)===13:i===L.$rB||i.piece.lineFeedCnt===0?!1:this.I(i,i.piece.length-1)===13}N(i){if(this.K()&&this.L(i)){const n=i.prev();this.M(n)&&this.P(n,i)}}O(i){if(this.K()&&this.M(i)){const n=i.next();this.L(n)&&this.P(i,n)}}P(i,n){const r=[],a=this.a[i.piece.bufferIndex].lineStarts;let t;i.piece.end.column===0?t={line:i.piece.end.line-1,column:a[i.piece.end.line]-a[i.piece.end.line-1]-1}:t={line:i.piece.end.line,column:i.piece.end.column-1};const s=i.piece.length-1,d=i.piece.lineFeedCnt-1;i.piece=new $(i.piece.bufferIndex,i.piece.start,t,d,s),(0,L.$yB)(this,i,-1,-1),i.piece.length===0&&r.push(i);const c={line:n.piece.start.line+1,column:0},l=n.piece.length-1,h=this.t(n.piece.bufferIndex,c,n.piece.end);n.piece=new $(n.piece.bufferIndex,c,n.piece.end,h,l),(0,L.$yB)(this,n,-1,-1),n.piece.length===0&&r.push(n);const E=this.w(`\r
`);this.S(i,E[0]);for(let D=0;D<r.length;D++)(0,L.$wB)(this,r[D])}Q(i,n){if(this.K()&&this.M(i)){const r=n.next();if(this.L(r)){if(i+=`
`,r.piece.length===1)(0,L.$wB)(this,r);else{const a=r.piece,t={line:a.start.line+1,column:0},s=a.length-1,d=this.t(a.bufferIndex,t,a.end);r.piece=new $(a.bufferIndex,t,a.end,d,s),(0,L.$yB)(this,r,-1,-1)}return!0}}return!1}iterate(i,n){if(i===L.$rB)return n(L.$rB);const r=this.iterate(i.left,n);return r&&n(i)&&this.iterate(i.right,n)}R(i){if(i===L.$rB)return"";const n=this.a[i.piece.bufferIndex],r=i.piece,a=this.u(r.bufferIndex,r.start),t=this.u(r.bufferIndex,r.end);return n.buffer.substring(a,t)}getPieceContent(i){const n=this.a[i.bufferIndex],r=this.u(i.bufferIndex,i.start),a=this.u(i.bufferIndex,i.end);return n.buffer.substring(r,a)}S(i,n){const r=new L.$qB(n,1);if(r.left=L.$rB,r.right=L.$rB,r.parent=L.$rB,r.size_left=0,r.lf_left=0,this.root===L.$rB)this.root=r,r.color=0;else if(i.right===L.$rB)i.right=r,r.parent=i;else{const t=(0,L.$sB)(i.right);t.left=r,r.parent=t}return(0,L.$xB)(this,r),r}T(i,n){const r=new L.$qB(n,1);if(r.left=L.$rB,r.right=L.$rB,r.parent=L.$rB,r.size_left=0,r.lf_left=0,this.root===L.$rB)this.root=r,r.color=0;else if(i.left===L.$rB)i.left=r,r.parent=i;else{const a=(0,L.$tB)(i.left);a.right=r,r.parent=a}return(0,L.$xB)(this,r),r}U(i){let n="";return this.iterate(i,r=>(n+=this.R(r),!0)),n}}e.$KB=u}),define(ke[177],Se([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$o8=e.$n8=void 0;class C{constructor(){this.a=new Map}removeDragOperationTransfer(L){if(L&&this.a.has(L)){const M=this.a.get(L);return this.a.delete(L),M}}addDragOperationTransfer(L,M){this.a.set(L,M)}}e.$n8=C;class F{constructor(L){this.identifier=L}}e.$o8=F}),define(ke[178],Se([1,0,4,3]),function(me,e,C,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$s=void 0;class f{constructor(){this.a=new Map,this.b=new Map,this.c=new C.$Rd,this.onDidChange=this.c.event,this.d=null}handleChange(b){this.c.fire({changedLanguages:b,changedColorMap:!1})}register(b,v){return this.a.set(b,v),this.handleChange([b]),(0,F.$Pc)(()=>{this.a.get(b)===v&&(this.a.delete(b),this.handleChange([b]))})}get(b){return this.a.get(b)||null}registerFactory(b,v){this.b.get(b)?.dispose();const g=new L(this,b,v);return this.b.set(b,g),(0,F.$Pc)(()=>{const A=this.b.get(b);!A||A!==g||(this.b.delete(b),A.dispose())})}async getOrCreate(b){const v=this.get(b);if(v)return v;const g=this.b.get(b);return!g||g.isResolved?null:(await g.resolve(),this.get(b))}isResolved(b){if(this.get(b))return!0;const g=this.b.get(b);return!!(!g||g.isResolved)}setColorMap(b){this.d=b,this.c.fire({changedLanguages:Array.from(this.a.keys()),changedColorMap:!0})}getColorMap(){return this.d}getDefaultBackground(){return this.d&&this.d.length>2?this.d[2]:null}}e.$$s=f;class L extends F.$Rc{get isResolved(){return this.c}constructor(b,v,g){super(),this.f=b,this.g=v,this.h=g,this.a=!1,this.b=null,this.c=!1}dispose(){this.a=!0,super.dispose()}async resolve(){return this.b||(this.b=this.j()),this.b}async j(){const b=await this.h.tokenizationSupport;this.c=!0,b&&!this.a&&this.B(this.f.register(this.g,b))}}}),define(ke[179],Se([9,10]),function(me,e){return me.create("vs/base/common/actions",e)}),define(ke[180],Se([1,0,4,3,179]),function(me,e,C,F,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fi=e.$Ei=e.$Di=e.$Ci=e.$Bi=e.$Ai=void 0;class L extends F.$Rc{constructor($,y="",k="",w=!0,u){super(),this.h=this.B(new C.$Rd),this.onDidChange=this.h.event,this.w=!0,this.j=$,this.m=y,this.u=k,this.w=w,this.C=u}get id(){return this.j}get label(){return this.m}set label($){this.D($)}D($){this.m!==$&&(this.m=$,this.h.fire({label:$}))}get tooltip(){return this.n||""}set tooltip($){this.F($)}F($){this.n!==$&&(this.n=$,this.h.fire({tooltip:$}))}get class(){return this.u}set class($){this.G($)}G($){this.u!==$&&(this.u=$,this.h.fire({class:$}))}get enabled(){return this.w}set enabled($){this.H($)}H($){this.w!==$&&(this.w=$,this.h.fire({enabled:$}))}get checked(){return this.z}set checked($){this.I($)}I($){this.z!==$&&(this.z=$,this.h.fire({checked:$}))}async run($,y){this.C&&await this.C($)}}e.$Ai=L;class M extends F.$Rc{constructor(){super(...arguments),this.f=this.B(new C.$Rd),this.onWillRun=this.f.event,this.m=this.B(new C.$Rd),this.onDidRun=this.m.event}async run($,y){if(!$.enabled)return;this.f.fire({action:$});let k;try{await this.u($,y)}catch(w){k=w}this.m.fire({action:$,error:k})}async u($,y){await $.run(y)}}e.$Bi=M;class b{constructor(){this.id=b.ID,this.label="",this.tooltip="",this.class="separator",this.enabled=!1,this.checked=!1}static join(...$){let y=[];for(const k of $)k.length&&(y.length?y=[...y,new b,...k]:y=k);return y}static{this.ID="vs.actions.separator"}async run(){}}e.$Ci=b;class v{get actions(){return this.a}constructor($,y,k,w){this.tooltip="",this.enabled=!0,this.checked=void 0,this.id=$,this.label=y,this.class=w,this.a=k}async run(){}}e.$Di=v;class g extends L{static{this.ID="vs.actions.empty"}constructor(){super(g.ID,f.localize(0,null),void 0,!1)}}e.$Ei=g;function A(I){return{id:I.id,label:I.label,class:void 0,enabled:I.enabled??!0,checked:I.checked??!1,run:async(...$)=>I.run(...$),tooltip:I.label}}e.$Fi=A}),define(ke[181],Se([9,10]),function(me,e){return me.create("vs/base/common/date",e)}),define(ke[182],Se([1,0,181]),function(me,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$km=e.$jm=void 0;const F=60,f=F*60,L=f*24,M=L*7,b=L*30,v=L*365;function g(I,$,y,k){typeof I!="number"&&(I=I.getTime());const w=Math.round((new Date().getTime()-I)/1e3);if(w<-30)return(0,C.localize)(0,null,g(new Date().getTime()+w*1e3,!1));if(!k&&w<30)return(0,C.localize)(1,null);let u;return w<F?(u=w,$?u===1?y?(0,C.localize)(2,null,u):(0,C.localize)(3,null,u):y?(0,C.localize)(4,null,u):(0,C.localize)(5,null,u):u===1?y?(0,C.localize)(6,null,u):(0,C.localize)(7,null,u):y?(0,C.localize)(8,null,u):(0,C.localize)(9,null,u)):w<f?(u=Math.floor(w/F),$?u===1?y?(0,C.localize)(10,null,u):(0,C.localize)(11,null,u):y?(0,C.localize)(12,null,u):(0,C.localize)(13,null,u):u===1?y?(0,C.localize)(14,null,u):(0,C.localize)(15,null,u):y?(0,C.localize)(16,null,u):(0,C.localize)(17,null,u)):w<L?(u=Math.floor(w/f),$?u===1?y?(0,C.localize)(18,null,u):(0,C.localize)(19,null,u):y?(0,C.localize)(20,null,u):(0,C.localize)(21,null,u):u===1?y?(0,C.localize)(22,null,u):(0,C.localize)(23,null,u):y?(0,C.localize)(24,null,u):(0,C.localize)(25,null,u)):w<M?(u=Math.floor(w/L),$?u===1?(0,C.localize)(26,null,u):(0,C.localize)(27,null,u):u===1?(0,C.localize)(28,null,u):(0,C.localize)(29,null,u)):w<b?(u=Math.floor(w/M),$?u===1?y?(0,C.localize)(30,null,u):(0,C.localize)(31,null,u):y?(0,C.localize)(32,null,u):(0,C.localize)(33,null,u):u===1?y?(0,C.localize)(34,null,u):(0,C.localize)(35,null,u):y?(0,C.localize)(36,null,u):(0,C.localize)(37,null,u)):w<v?(u=Math.floor(w/b),$?u===1?y?(0,C.localize)(38,null,u):(0,C.localize)(39,null,u):y?(0,C.localize)(40,null,u):(0,C.localize)(41,null,u):u===1?y?(0,C.localize)(42,null,u):(0,C.localize)(43,null,u):y?(0,C.localize)(44,null,u):(0,C.localize)(45,null,u)):(u=Math.floor(w/v),$?u===1?y?(0,C.localize)(46,null,u):(0,C.localize)(47,null,u):y?(0,C.localize)(48,null,u):(0,C.localize)(49,null,u):u===1?y?(0,C.localize)(50,null,u):(0,C.localize)(51,null,u):y?(0,C.localize)(52,null,u):(0,C.localize)(53,null,u))}e.$jm=g;function A(I){return I.getFullYear()+"-"+String(I.getMonth()+1).padStart(2,"0")+"-"+String(I.getDate()).padStart(2,"0")+"T"+String(I.getHours()).padStart(2,"0")+":"+String(I.getMinutes()).padStart(2,"0")+":"+String(I.getSeconds()).padStart(2,"0")+"."+(I.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.$km=A}),define(ke[183],Se([9,10]),function(me,e){return me.create("vs/base/common/errorMessage",e)}),define(ke[43],Se([1,0,19,18,183]),function(me,e,C,F,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ii=e.$Hi=e.$Gi=void 0;function L(I,$){return $&&(I.stack||I.stacktrace)?f.localize(0,null,b(I),M(I.stack)||M(I.stacktrace)):b(I)}function M(I){return Array.isArray(I)?I.join(`
`):I}function b(I){return I.code==="ERR_UNC_HOST_NOT_ALLOWED"?`${I.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`:typeof I.code=="string"&&typeof I.errno=="number"&&typeof I.syscall=="string"?f.localize(1,null,I.message):I.message||f.localize(2,null)}function v(I=null,$=!1){if(!I)return f.localize(3,null);if(Array.isArray(I)){const y=C.$Gb(I),k=v(y[0],$);return y.length>1?f.localize(4,null,k,y.length):k}if(F.$Cf(I))return I;if(I.detail){const y=I.detail;if(y.error)return L(y.error,$);if(y.exception)return L(y.exception,$)}return I.stack?L(I,$):I.message?I.message:f.localize(5,null)}e.$Gi=v;function g(I){const $=I;return $ instanceof Error&&Array.isArray($.actions)}e.$Hi=g;function A(I,$){let y;return typeof I=="string"?y=new Error(I):y=I,y.actions=$,y}e.$Ii=A}),define(ke[184],Se([9,10]),function(me,e){return me.create("vs/base/common/platform",e)}),define(ke[11],Se([1,0,184]),function(me,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$I=e.$H=e.$G=e.$F=e.$E=e.$D=e.OS=e.OperatingSystem=e.$B=e.$A=e.$z=e.$y=e.$x=e.Language=e.$w=e.$v=e.$u=e.$t=e.$s=e.$r=e.$q=e.$p=e.$o=e.$n=e.$m=e.$l=e.$k=e.$j=e.$i=e.$h=e.Platform=e.$g=void 0,e.$g="en";let F=!1,f=!1,L=!1,M=!1,b=!1,v=!1,g=!1,A=!1,I=!1,$=!1,y,k=e.$g,w=e.$g,u,o;const i=globalThis;let n;typeof i.vscode<"u"&&typeof i.vscode.process<"u"?n=i.vscode.process:typeof process<"u"&&(n=process);const r=typeof n?.versions?.electron=="string",a=r&&n?.type==="renderer";if(typeof navigator=="object"&&!a)o=navigator.userAgent,F=o.indexOf("Windows")>=0,f=o.indexOf("Macintosh")>=0,A=(o.indexOf("Macintosh")>=0||o.indexOf("iPad")>=0||o.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,L=o.indexOf("Linux")>=0,$=o?.indexOf("Mobi")>=0,v=!0,y=C.getConfiguredDefaultLocale(C.localize(0,null))||e.$g,k=y,w=navigator.language;else if(typeof n=="object"){F=n.platform==="win32",f=n.platform==="darwin",L=n.platform==="linux",M=L&&!!n.env.SNAP&&!!n.env.SNAP_REVISION,g=r,I=!!n.env.CI||!!n.env.BUILD_ARTIFACTSTAGINGDIRECTORY,y=e.$g,k=e.$g;const m=n.env.VSCODE_NLS_CONFIG;if(m)try{const p=JSON.parse(m),S=p.availableLanguages["*"];y=p.locale,w=p.osLocale,k=S||e.$g,u=p._translationsConfigFile}catch{}b=!0}else console.error("Unable to resolve platform.");var t;(function(m){m[m.Web=0]="Web",m[m.Mac=1]="Mac",m[m.Linux=2]="Linux",m[m.Windows=3]="Windows"})(t||(e.Platform=t={}));function s(m){switch(m){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}e.$h=s;let d=0;f?d=1:F?d=3:L&&(d=2),e.$i=F,e.$j=f,e.$k=L,e.$l=M,e.$m=b,e.$n=g,e.$o=v,e.$p=v&&typeof i.importScripts=="function",e.$q=e.$p?i.origin:void 0,e.$r=A,e.$s=$,e.$t=I,e.$u=d,e.$v=o,e.$w=k;var c;(function(m){function p(){return e.$w}m.value=p;function S(){return e.$w.length===2?e.$w==="en":e.$w.length>=3?e.$w[0]==="e"&&e.$w[1]==="n"&&e.$w[2]==="-":!1}m.isDefaultVariant=S;function P(){return e.$w==="en"}m.isDefault=P})(c||(e.Language=c={})),e.$x=y,e.$y=w,e.$z=u,e.$A=typeof i.postMessage=="function"&&!i.importScripts,e.$B=(()=>{if(e.$A){const m=[];i.addEventListener("message",S=>{if(S.data&&S.data.vscodeScheduleAsyncWork)for(let P=0,z=m.length;P<z;P++){const j=m[P];if(j.id===S.data.vscodeScheduleAsyncWork){m.splice(P,1),j.callback();return}}});let p=0;return S=>{const P=++p;m.push({id:P,callback:S}),i.postMessage({vscodeScheduleAsyncWork:P},"*")}}return m=>setTimeout(m)})();var l;(function(m){m[m.Windows=1]="Windows",m[m.Macintosh=2]="Macintosh",m[m.Linux=3]="Linux"})(l||(e.OperatingSystem=l={})),e.OS=f||A?2:F?1:3;let h=!0,E=!1;function D(){if(!E){E=!0;const m=new Uint8Array(2);m[0]=1,m[1]=2,h=new Uint16Array(m.buffer)[0]===(2<<8)+1}return h}e.$D=D,e.$E=!!(e.$v&&e.$v.indexOf("Chrome")>=0),e.$F=!!(e.$v&&e.$v.indexOf("Firefox")>=0),e.$G=!!(!e.$E&&e.$v&&e.$v.indexOf("Safari")>=0),e.$H=!!(e.$v&&e.$v.indexOf("Edg/")>=0),e.$I=!!(e.$v&&e.$v.indexOf("Android")>=0)}),define(ke[49],Se([1,0,11]),function(me,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dc=e.$cc=e.env=e.cwd=void 0;let F;const f=globalThis.vscode;if(typeof f<"u"&&typeof f.process<"u"){const L=f.process;F={get platform(){return L.platform},get arch(){return L.arch},get env(){return L.env},cwd(){return L.cwd()}}}else typeof process<"u"?F={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:F={get platform(){return C.$i?"win32":C.$j?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};e.cwd=F.cwd,e.env=F.env,e.$cc=F.platform,e.$dc=F.arch}),define(ke[16],Se([1,0,49]),function(me,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sc=e.sep=e.$qc=e.$pc=e.$oc=e.$nc=e.$mc=e.$lc=e.$kc=e.$jc=e.$ic=e.$hc=e.$gc=e.$fc=e.$ec=void 0;const F=65,f=97,L=90,M=122,b=46,v=47,g=92,A=58,I=63;class $ extends Error{constructor(s,d,c){let l;typeof d=="string"&&d.indexOf("not ")===0?(l="must not be",d=d.replace(/^not /,"")):l="must be";const h=s.indexOf(".")!==-1?"property":"argument";let E=`The "${s}" ${h} ${l} of type ${d}`;E+=`. Received type ${typeof c}`,super(E),this.code="ERR_INVALID_ARG_TYPE"}}function y(t,s){if(t===null||typeof t!="object")throw new $(s,"Object",t)}function k(t,s){if(typeof t!="string")throw new $(s,"string",t)}const w=C.$cc==="win32";function u(t){return t===v||t===g}function o(t){return t===v}function i(t){return t>=F&&t<=L||t>=f&&t<=M}function n(t,s,d,c){let l="",h=0,E=-1,D=0,m=0;for(let p=0;p<=t.length;++p){if(p<t.length)m=t.charCodeAt(p);else{if(c(m))break;m=v}if(c(m)){if(!(E===p-1||D===1))if(D===2){if(l.length<2||h!==2||l.charCodeAt(l.length-1)!==b||l.charCodeAt(l.length-2)!==b){if(l.length>2){const S=l.lastIndexOf(d);S===-1?(l="",h=0):(l=l.slice(0,S),h=l.length-1-l.lastIndexOf(d)),E=p,D=0;continue}else if(l.length!==0){l="",h=0,E=p,D=0;continue}}s&&(l+=l.length>0?`${d}..`:"..",h=2)}else l.length>0?l+=`${d}${t.slice(E+1,p)}`:l=t.slice(E+1,p),h=p-E-1;E=p,D=0}else m===b&&D!==-1?++D:D=-1}return l}function r(t,s){y(s,"pathObject");const d=s.dir||s.root,c=s.base||`${s.name||""}${s.ext||""}`;return d?d===s.root?`${d}${c}`:`${d}${t}${c}`:c}e.$ec={resolve(...t){let s="",d="",c=!1;for(let l=t.length-1;l>=-1;l--){let h;if(l>=0){if(h=t[l],k(h,"path"),h.length===0)continue}else s.length===0?h=C.cwd():(h=C.env[`=${s}`]||C.cwd(),(h===void 0||h.slice(0,2).toLowerCase()!==s.toLowerCase()&&h.charCodeAt(2)===g)&&(h=`${s}\\`));const E=h.length;let D=0,m="",p=!1;const S=h.charCodeAt(0);if(E===1)u(S)&&(D=1,p=!0);else if(u(S))if(p=!0,u(h.charCodeAt(1))){let P=2,z=P;for(;P<E&&!u(h.charCodeAt(P));)P++;if(P<E&&P!==z){const j=h.slice(z,P);for(z=P;P<E&&u(h.charCodeAt(P));)P++;if(P<E&&P!==z){for(z=P;P<E&&!u(h.charCodeAt(P));)P++;(P===E||P!==z)&&(m=`\\\\${j}\\${h.slice(z,P)}`,D=P)}}}else D=1;else i(S)&&h.charCodeAt(1)===A&&(m=h.slice(0,2),D=2,E>2&&u(h.charCodeAt(2))&&(p=!0,D=3));if(m.length>0)if(s.length>0){if(m.toLowerCase()!==s.toLowerCase())continue}else s=m;if(c){if(s.length>0)break}else if(d=`${h.slice(D)}\\${d}`,c=p,p&&s.length>0)break}return d=n(d,!c,"\\",u),c?`${s}\\${d}`:`${s}${d}`||"."},normalize(t){k(t,"path");const s=t.length;if(s===0)return".";let d=0,c,l=!1;const h=t.charCodeAt(0);if(s===1)return o(h)?"\\":t;if(u(h))if(l=!0,u(t.charCodeAt(1))){let D=2,m=D;for(;D<s&&!u(t.charCodeAt(D));)D++;if(D<s&&D!==m){const p=t.slice(m,D);for(m=D;D<s&&u(t.charCodeAt(D));)D++;if(D<s&&D!==m){for(m=D;D<s&&!u(t.charCodeAt(D));)D++;if(D===s)return`\\\\${p}\\${t.slice(m)}\\`;D!==m&&(c=`\\\\${p}\\${t.slice(m,D)}`,d=D)}}}else d=1;else i(h)&&t.charCodeAt(1)===A&&(c=t.slice(0,2),d=2,s>2&&u(t.charCodeAt(2))&&(l=!0,d=3));let E=d<s?n(t.slice(d),!l,"\\",u):"";return E.length===0&&!l&&(E="."),E.length>0&&u(t.charCodeAt(s-1))&&(E+="\\"),c===void 0?l?`\\${E}`:E:l?`${c}\\${E}`:`${c}${E}`},isAbsolute(t){k(t,"path");const s=t.length;if(s===0)return!1;const d=t.charCodeAt(0);return u(d)||s>2&&i(d)&&t.charCodeAt(1)===A&&u(t.charCodeAt(2))},join(...t){if(t.length===0)return".";let s,d;for(let h=0;h<t.length;++h){const E=t[h];k(E,"path"),E.length>0&&(s===void 0?s=d=E:s+=`\\${E}`)}if(s===void 0)return".";let c=!0,l=0;if(typeof d=="string"&&u(d.charCodeAt(0))){++l;const h=d.length;h>1&&u(d.charCodeAt(1))&&(++l,h>2&&(u(d.charCodeAt(2))?++l:c=!1))}if(c){for(;l<s.length&&u(s.charCodeAt(l));)l++;l>=2&&(s=`\\${s.slice(l)}`)}return e.$ec.normalize(s)},relative(t,s){if(k(t,"from"),k(s,"to"),t===s)return"";const d=e.$ec.resolve(t),c=e.$ec.resolve(s);if(d===c||(t=d.toLowerCase(),s=c.toLowerCase(),t===s))return"";let l=0;for(;l<t.length&&t.charCodeAt(l)===g;)l++;let h=t.length;for(;h-1>l&&t.charCodeAt(h-1)===g;)h--;const E=h-l;let D=0;for(;D<s.length&&s.charCodeAt(D)===g;)D++;let m=s.length;for(;m-1>D&&s.charCodeAt(m-1)===g;)m--;const p=m-D,S=E<p?E:p;let P=-1,z=0;for(;z<S;z++){const R=t.charCodeAt(l+z);if(R!==s.charCodeAt(D+z))break;R===g&&(P=z)}if(z!==S){if(P===-1)return c}else{if(p>S){if(s.charCodeAt(D+z)===g)return c.slice(D+z+1);if(z===2)return c.slice(D+z)}E>S&&(t.charCodeAt(l+z)===g?P=z:z===2&&(P=3)),P===-1&&(P=0)}let j="";for(z=l+P+1;z<=h;++z)(z===h||t.charCodeAt(z)===g)&&(j+=j.length===0?"..":"\\..");return D+=P,j.length>0?`${j}${c.slice(D,m)}`:(c.charCodeAt(D)===g&&++D,c.slice(D,m))},toNamespacedPath(t){if(typeof t!="string"||t.length===0)return t;const s=e.$ec.resolve(t);if(s.length<=2)return t;if(s.charCodeAt(0)===g){if(s.charCodeAt(1)===g){const d=s.charCodeAt(2);if(d!==I&&d!==b)return`\\\\?\\UNC\\${s.slice(2)}`}}else if(i(s.charCodeAt(0))&&s.charCodeAt(1)===A&&s.charCodeAt(2)===g)return`\\\\?\\${s}`;return t},dirname(t){k(t,"path");const s=t.length;if(s===0)return".";let d=-1,c=0;const l=t.charCodeAt(0);if(s===1)return u(l)?t:".";if(u(l)){if(d=c=1,u(t.charCodeAt(1))){let D=2,m=D;for(;D<s&&!u(t.charCodeAt(D));)D++;if(D<s&&D!==m){for(m=D;D<s&&u(t.charCodeAt(D));)D++;if(D<s&&D!==m){for(m=D;D<s&&!u(t.charCodeAt(D));)D++;if(D===s)return t;D!==m&&(d=c=D+1)}}}}else i(l)&&t.charCodeAt(1)===A&&(d=s>2&&u(t.charCodeAt(2))?3:2,c=d);let h=-1,E=!0;for(let D=s-1;D>=c;--D)if(u(t.charCodeAt(D))){if(!E){h=D;break}}else E=!1;if(h===-1){if(d===-1)return".";h=d}return t.slice(0,h)},basename(t,s){s!==void 0&&k(s,"ext"),k(t,"path");let d=0,c=-1,l=!0,h;if(t.length>=2&&i(t.charCodeAt(0))&&t.charCodeAt(1)===A&&(d=2),s!==void 0&&s.length>0&&s.length<=t.length){if(s===t)return"";let E=s.length-1,D=-1;for(h=t.length-1;h>=d;--h){const m=t.charCodeAt(h);if(u(m)){if(!l){d=h+1;break}}else D===-1&&(l=!1,D=h+1),E>=0&&(m===s.charCodeAt(E)?--E===-1&&(c=h):(E=-1,c=D))}return d===c?c=D:c===-1&&(c=t.length),t.slice(d,c)}for(h=t.length-1;h>=d;--h)if(u(t.charCodeAt(h))){if(!l){d=h+1;break}}else c===-1&&(l=!1,c=h+1);return c===-1?"":t.slice(d,c)},extname(t){k(t,"path");let s=0,d=-1,c=0,l=-1,h=!0,E=0;t.length>=2&&t.charCodeAt(1)===A&&i(t.charCodeAt(0))&&(s=c=2);for(let D=t.length-1;D>=s;--D){const m=t.charCodeAt(D);if(u(m)){if(!h){c=D+1;break}continue}l===-1&&(h=!1,l=D+1),m===b?d===-1?d=D:E!==1&&(E=1):d!==-1&&(E=-1)}return d===-1||l===-1||E===0||E===1&&d===l-1&&d===c+1?"":t.slice(d,l)},format:r.bind(null,"\\"),parse(t){k(t,"path");const s={root:"",dir:"",base:"",ext:"",name:""};if(t.length===0)return s;const d=t.length;let c=0,l=t.charCodeAt(0);if(d===1)return u(l)?(s.root=s.dir=t,s):(s.base=s.name=t,s);if(u(l)){if(c=1,u(t.charCodeAt(1))){let P=2,z=P;for(;P<d&&!u(t.charCodeAt(P));)P++;if(P<d&&P!==z){for(z=P;P<d&&u(t.charCodeAt(P));)P++;if(P<d&&P!==z){for(z=P;P<d&&!u(t.charCodeAt(P));)P++;P===d?c=P:P!==z&&(c=P+1)}}}}else if(i(l)&&t.charCodeAt(1)===A){if(d<=2)return s.root=s.dir=t,s;if(c=2,u(t.charCodeAt(2))){if(d===3)return s.root=s.dir=t,s;c=3}}c>0&&(s.root=t.slice(0,c));let h=-1,E=c,D=-1,m=!0,p=t.length-1,S=0;for(;p>=c;--p){if(l=t.charCodeAt(p),u(l)){if(!m){E=p+1;break}continue}D===-1&&(m=!1,D=p+1),l===b?h===-1?h=p:S!==1&&(S=1):h!==-1&&(S=-1)}return D!==-1&&(h===-1||S===0||S===1&&h===D-1&&h===E+1?s.base=s.name=t.slice(E,D):(s.name=t.slice(E,h),s.base=t.slice(E,D),s.ext=t.slice(h,D))),E>0&&E!==c?s.dir=t.slice(0,E-1):s.dir=s.root,s},sep:"\\",delimiter:";",win32:null,posix:null};const a=(()=>{if(w){const t=/\\/g;return()=>{const s=C.cwd().replace(t,"/");return s.slice(s.indexOf("/"))}}return()=>C.cwd()})();e.$fc={resolve(...t){let s="",d=!1;for(let c=t.length-1;c>=-1&&!d;c--){const l=c>=0?t[c]:a();k(l,"path"),l.length!==0&&(s=`${l}/${s}`,d=l.charCodeAt(0)===v)}return s=n(s,!d,"/",o),d?`/${s}`:s.length>0?s:"."},normalize(t){if(k(t,"path"),t.length===0)return".";const s=t.charCodeAt(0)===v,d=t.charCodeAt(t.length-1)===v;return t=n(t,!s,"/",o),t.length===0?s?"/":d?"./":".":(d&&(t+="/"),s?`/${t}`:t)},isAbsolute(t){return k(t,"path"),t.length>0&&t.charCodeAt(0)===v},join(...t){if(t.length===0)return".";let s;for(let d=0;d<t.length;++d){const c=t[d];k(c,"path"),c.length>0&&(s===void 0?s=c:s+=`/${c}`)}return s===void 0?".":e.$fc.normalize(s)},relative(t,s){if(k(t,"from"),k(s,"to"),t===s||(t=e.$fc.resolve(t),s=e.$fc.resolve(s),t===s))return"";const d=1,c=t.length,l=c-d,h=1,E=s.length-h,D=l<E?l:E;let m=-1,p=0;for(;p<D;p++){const P=t.charCodeAt(d+p);if(P!==s.charCodeAt(h+p))break;P===v&&(m=p)}if(p===D)if(E>D){if(s.charCodeAt(h+p)===v)return s.slice(h+p+1);if(p===0)return s.slice(h+p)}else l>D&&(t.charCodeAt(d+p)===v?m=p:p===0&&(m=0));let S="";for(p=d+m+1;p<=c;++p)(p===c||t.charCodeAt(p)===v)&&(S+=S.length===0?"..":"/..");return`${S}${s.slice(h+m)}`},toNamespacedPath(t){return t},dirname(t){if(k(t,"path"),t.length===0)return".";const s=t.charCodeAt(0)===v;let d=-1,c=!0;for(let l=t.length-1;l>=1;--l)if(t.charCodeAt(l)===v){if(!c){d=l;break}}else c=!1;return d===-1?s?"/":".":s&&d===1?"//":t.slice(0,d)},basename(t,s){s!==void 0&&k(s,"ext"),k(t,"path");let d=0,c=-1,l=!0,h;if(s!==void 0&&s.length>0&&s.length<=t.length){if(s===t)return"";let E=s.length-1,D=-1;for(h=t.length-1;h>=0;--h){const m=t.charCodeAt(h);if(m===v){if(!l){d=h+1;break}}else D===-1&&(l=!1,D=h+1),E>=0&&(m===s.charCodeAt(E)?--E===-1&&(c=h):(E=-1,c=D))}return d===c?c=D:c===-1&&(c=t.length),t.slice(d,c)}for(h=t.length-1;h>=0;--h)if(t.charCodeAt(h)===v){if(!l){d=h+1;break}}else c===-1&&(l=!1,c=h+1);return c===-1?"":t.slice(d,c)},extname(t){k(t,"path");let s=-1,d=0,c=-1,l=!0,h=0;for(let E=t.length-1;E>=0;--E){const D=t.charCodeAt(E);if(D===v){if(!l){d=E+1;break}continue}c===-1&&(l=!1,c=E+1),D===b?s===-1?s=E:h!==1&&(h=1):s!==-1&&(h=-1)}return s===-1||c===-1||h===0||h===1&&s===c-1&&s===d+1?"":t.slice(s,c)},format:r.bind(null,"/"),parse(t){k(t,"path");const s={root:"",dir:"",base:"",ext:"",name:""};if(t.length===0)return s;const d=t.charCodeAt(0)===v;let c;d?(s.root="/",c=1):c=0;let l=-1,h=0,E=-1,D=!0,m=t.length-1,p=0;for(;m>=c;--m){const S=t.charCodeAt(m);if(S===v){if(!D){h=m+1;break}continue}E===-1&&(D=!1,E=m+1),S===b?l===-1?l=m:p!==1&&(p=1):l!==-1&&(p=-1)}if(E!==-1){const S=h===0&&d?1:h;l===-1||p===0||p===1&&l===E-1&&l===h+1?s.base=s.name=t.slice(S,E):(s.name=t.slice(S,l),s.base=t.slice(S,E),s.ext=t.slice(l,E))}return h>0?s.dir=t.slice(0,h-1):d&&(s.dir="/"),s},sep:"/",delimiter:":",win32:null,posix:null},e.$fc.win32=e.$ec.win32=e.$ec,e.$fc.posix=e.$ec.posix=e.$fc,e.$gc=w?e.$ec.normalize:e.$fc.normalize,e.$hc=w?e.$ec.isAbsolute:e.$fc.isAbsolute,e.$ic=w?e.$ec.join:e.$fc.join,e.$jc=w?e.$ec.resolve:e.$fc.resolve,e.$kc=w?e.$ec.relative:e.$fc.relative,e.$lc=w?e.$ec.dirname:e.$fc.dirname,e.$mc=w?e.$ec.basename:e.$fc.basename,e.$nc=w?e.$ec.extname:e.$fc.extname,e.$oc=w?e.$ec.format:e.$fc.format,e.$pc=w?e.$ec.parse:e.$fc.parse,e.$qc=w?e.$ec.toNamespacedPath:e.$fc.toNamespacedPath,e.sep=w?e.$ec.sep:e.$fc.sep,e.$sc=w?e.$ec.delimiter:e.$fc.delimiter}),define(ke[129],Se([1,0,48,16]),function(me,e,C,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zq=e.$yq=e.$xq=e.$wq=e.$vq=e.$uq=e.$tq=e.$sq=e.$rq=e.$qq=e.$pq=e.$oq=e.$nq=void 0;const f=new C.$U(()=>{const D=new Intl.Collator(void 0,{numeric:!0,sensitivity:"base"});return{collator:D,collatorIsNumeric:D.resolvedOptions().numeric}}),L=new C.$U(()=>({collator:new Intl.Collator(void 0,{numeric:!0})})),M=new C.$U(()=>({collator:new Intl.Collator(void 0,{numeric:!0,sensitivity:"accent"})}));function b(D,m,p=!1){const S=D||"",P=m||"",z=f.value.collator.compare(S,P);return f.value.collatorIsNumeric&&z===0&&S!==P?S<P?-1:1:z}e.$nq=b;function v(D,m){const p=L.value.collator;return D=D||"",m=m||"",r(p,D,m)}e.$oq=v;function g(D,m){const p=L.value.collator;return D=D||"",m=m||"",d(D,m)||r(p,D,m)}e.$pq=g;function A(D,m){const p=L.value.collator;return D=D||"",m=m||"",s(D,m)||r(p,D,m)}e.$qq=A;function I(D,m){return D=D||"",m=m||"",D===m?0:D<m?-1:1}e.$rq=I;function $(D,m){const[p,S]=i(D),[P,z]=i(m);let j=f.value.collator.compare(S,z);if(j===0){if(f.value.collatorIsNumeric&&S!==z)return S<z?-1:1;if(j=f.value.collator.compare(p,P),f.value.collatorIsNumeric&&j===0&&p!==P)return p<P?-1:1}return j}e.$sq=$;function y(D,m){D=D||"",m=m||"";const p=n(D),S=n(m),P=L.value.collator,z=M.value.collator;return r(z,p,S)||r(P,D,m)}e.$tq=y;function k(D,m){D=D||"",m=m||"";const p=n(D),S=n(m),P=L.value.collator,z=M.value.collator;return r(z,p,S)||d(D,m)||r(P,D,m)}e.$uq=k;function w(D,m){D=D||"",m=m||"";const p=n(D),S=n(m),P=L.value.collator,z=M.value.collator;return r(z,p,S)||s(D,m)||r(P,D,m)}e.$vq=w;function u(D,m){D=D||"",m=m||"";const p=n(D).toLowerCase(),S=n(m).toLowerCase();return p!==S?p<S?-1:1:D!==m?D<m?-1:1:0}e.$wq=u;const o=/^(.*?)(\.([^.]*))?$/;function i(D,m=!1){const p=D?o.exec(D):[];let S=[p&&p[1]||"",p&&p[3]||""];return m&&(!S[0]&&S[1]||S[0]&&S[0].charAt(0)===".")&&(S=[S[0]+"."+S[1],""]),S}function n(D){const m=D?o.exec(D):[];return m&&m[1]&&m[1].charAt(0)!=="."&&m[3]||""}function r(D,m,p){const S=D.compare(m,p);return S!==0?S:m.length!==p.length?m.length<p.length?-1:1:0}function a(D){const m=D.charAt(0);return m.toLocaleUpperCase()!==m}function t(D){const m=D.charAt(0);return m.toLocaleLowerCase()!==m}function s(D,m){return a(D)&&t(m)?-1:t(D)&&a(m)?1:0}function d(D,m){return t(D)&&a(m)?-1:a(D)&&t(m)?1:0}function c(D,m,p=!1){return p||(D=D&&D.toLowerCase(),m=m&&m.toLowerCase()),D===m?0:D<m?-1:1}function l(D,m,p=!1){const S=D.split(F.sep),P=m.split(F.sep),z=S.length-1,j=P.length-1;let R,T;for(let N=0;;N++){if(R=z===N,T=j===N,R&&T)return b(S[N],P[N],p);if(R)return-1;if(T)return 1;const O=c(S[N],P[N],p);if(O!==0)return O}}e.$xq=l;function h(D,m,p){const S=D.toLowerCase(),P=m.toLowerCase(),z=E(D,m,p);if(z)return z;const j=S.endsWith(p),R=P.endsWith(p);if(j!==R)return j?-1:1;const T=b(S,P);return T!==0?T:S.localeCompare(P)}e.$yq=h;function E(D,m,p){const S=D.toLowerCase(),P=m.toLowerCase(),z=S.startsWith(p),j=P.startsWith(p);if(z!==j)return z?-1:1;if(z&&j){if(S.length<P.length)return-1;if(S.length>P.length)return 1}return 0}e.$zq=E}),define(ke[33],Se([1,0,16,11,13,18]),function(me,e,C,F,f,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0f=e.$9f=e.$8f=e.$7f=e.$6f=e.$5f=e.$4f=e.$3f=e.$2f=e.$1f=e.$Zf=e.$Yf=e.$Xf=e.$Wf=e.$Vf=e.$Uf=void 0;function M(h){return h===47||h===92}e.$Uf=M;function b(h){return h.replace(/[\\/]/g,C.$fc.sep)}e.$Vf=b;function v(h){return h.indexOf("/")===-1&&(h=b(h)),/^[a-zA-Z]:(\/|$)/.test(h)&&(h="/"+h),h}e.$Wf=v;function g(h,E=C.$fc.sep){if(!h)return"";const D=h.length,m=h.charCodeAt(0);if(M(m)){if(M(h.charCodeAt(1))&&!M(h.charCodeAt(2))){let S=3;const P=S;for(;S<D&&!M(h.charCodeAt(S));S++);if(P!==S&&!M(h.charCodeAt(S+1))){for(S+=1;S<D;S++)if(M(h.charCodeAt(S)))return h.slice(0,S+1).replace(/[\\/]/g,E)}}return E}else if(o(m)&&h.charCodeAt(1)===58)return M(h.charCodeAt(2))?h.slice(0,2)+E:h.slice(0,2);let p=h.indexOf("://");if(p!==-1){for(p+=3;p<D;p++)if(M(h.charCodeAt(p)))return h.slice(0,p+1)}return""}e.$Xf=g;function A(h){if(!F.$i||!h||h.length<5)return!1;let E=h.charCodeAt(0);if(E!==92||(E=h.charCodeAt(1),E!==92))return!1;let D=2;const m=D;for(;D<h.length&&(E=h.charCodeAt(D),E!==92);D++);return!(m===D||(E=h.charCodeAt(D+1),isNaN(E)||E===92))}e.$Yf=A;const I=/[\\/:\*\?"<>\|]/g,$=/[\\/]/g,y=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function k(h,E=F.$i){const D=E?I:$;return!(!h||h.length===0||/^\s+$/.test(h)||(D.lastIndex=0,D.test(h))||E&&y.test(h)||h==="."||h===".."||E&&h[h.length-1]==="."||E&&h.length!==h.trim().length||h.length>255)}e.$Zf=k;function w(h,E,D){const m=h===E;return!D||m?m:!h||!E?!1:(0,f.$6e)(h,E)}e.$1f=w;function u(h,E,D,m=C.sep){if(h===E)return!0;if(!h||!E||E.length>h.length)return!1;if(D){if(!(0,f.$7e)(h,E))return!1;if(E.length===h.length)return!0;let S=E.length;return E.charAt(E.length-1)===m&&S--,h.charAt(S)===m}return E.charAt(E.length-1)!==m&&(E+=m),h.indexOf(E)===0}e.$2f=u;function o(h){return h>=65&&h<=90||h>=97&&h<=122}e.$3f=o;function i(h,E){return F.$i&&h.endsWith(":")&&(h+=C.sep),(0,C.$hc)(h)||(h=(0,C.$ic)(E,h)),h=(0,C.$gc)(h),F.$i?(h=(0,f.$Oe)(h,C.sep),h.endsWith(":")&&(h+=C.sep)):(h=(0,f.$Oe)(h,C.sep),h||(h=C.sep)),h}e.$4f=i;function n(h){const E=(0,C.$gc)(h);return F.$i?h.length>3?!1:r(E)&&(h.length===2||E.charCodeAt(2)===92):E===C.$fc.sep}e.$5f=n;function r(h,E=F.$i){return E?o(h.charCodeAt(0))&&h.charCodeAt(1)===58:!1}e.$6f=r;function a(h,E=F.$i){return r(h,E)?h[0]:void 0}e.$7f=a;function t(h,E,D){return E.length>h.length?-1:h===E?0:(D&&(h=h.toLowerCase(),E=E.toLowerCase()),h.indexOf(E))}e.$8f=t;function s(h){const E=h.split(":");let D,m,p;for(const S of E){const P=Number(S);(0,L.$Gf)(P)?m===void 0?m=P:p===void 0&&(p=P):D=D?[D,S].join(":"):S}if(!D)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:D,line:m!==void 0?m:void 0,column:p!==void 0?p:m!==void 0?1:void 0}}e.$9f=s;const d="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789",c="BDEFGHIJKMOQRSTUVWXYZbdefghijkmoqrstuvwxyz0123456789";function l(h,E,D=8){let m="";for(let S=0;S<D;S++){let P;S===0&&F.$i&&!E&&(D===3||D===4)?P=c:P=d,m+=P.charAt(Math.floor(Math.random()*P.length))}let p;return E?p=`${E}-${m}`:p=m,h?(0,C.$ic)(h,p):p}e.$0f=l}),define(ke[130],Se([1,0,129,124,52,16,11,13]),function(me,e,C,F,f,L,M,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fq=e.$Eq=e.$Dq=e.$Cq=e.$Bq=e.$Aq=void 0;const v=0,g=[v,[]];function A(W,x,le,G){if(!W||!x)return g;const J=W.length,Q=x.length;if(J<Q)return g;const oe=W.toLowerCase();return I(x,le,Q,W,oe,J,G)}e.$Aq=A;function I(W,x,le,G,J,Q,oe){const _=[],Ee=[];for(let ie=0;ie<le;ie++){const be=ie*Q,H=be-Q,Y=ie>0,Z=W[ie],$e=x[ie];for(let ne=0;ne<Q;ne++){const fe=ne>0,te=be+ne,de=te-1,pe=H+ne-1,Pe=fe?_[de]:0,B=Y&&fe?_[pe]:0,X=Y&&fe?Ee[pe]:0;let re;!B&&Y?re=0:re=$(Z,$e,G,J,ne,X),re&&B+re>=Pe&&(oe||Y||J.startsWith(x,ne))?(Ee[te]=X+1,_[te]=B+re):(Ee[te]=v,_[te]=Pe)}}const he=[];let q=le-1,U=Q-1;for(;q>=0&&U>=0;){const ie=q*Q+U;Ee[ie]===v||(he.push(U),q--),U--}return[_[le*Q-1],he.reverse()]}function $(W,x,le,G,J,Q){let oe=0;if(!y(x,G[J]))return oe;if(oe+=1,Q>0&&(oe+=Q*5),W===le[J]&&(oe+=1),J===0)oe+=8;else{const _=k(le.charCodeAt(J-1));_?oe+=_:(0,F.$Mj)(le.charCodeAt(J))&&Q===0&&(oe+=2)}return oe}function y(W,x){return W===x?!0:W==="/"||W==="\\"?x==="/"||x==="\\":!1}function k(W){switch(W){case 47:case 92:return 5;case 95:case 45:case 46:case 32:case 39:case 34:case 58:return 4;default:return 0}}const w=[void 0,[]];function u(W,x,le=0,G=0){const J=x;return J.values&&J.values.length>1?o(W,J.values,le,G):i(W,x,le,G)}e.$Bq=u;function o(W,x,le,G){let J=0;const Q=[];for(const oe of x){const[_,Ee]=i(W,oe,le,G);if(typeof _!="number")return w;J+=_,Q.push(...Ee)}return[J,D(Q)]}function i(W,x,le,G){const J=(0,F.$Vj)(x.original,x.originalLowercase,le,W,W.toLowerCase(),G,{firstMatchCanBeWeak:!0,boostFullMatch:!0});return J?[J[0],(0,F.$Sj)(J)]:w}const n=Object.freeze({score:0}),r=1<<18,a=1<<17,t=1<<16;function s(W,x,le,G){const J=G.values?G.values:[G];return(0,f.$Ji)({[G.normalized]:{values:J.map(oe=>({value:oe.normalized,expectContiguousMatch:oe.expectContiguousMatch})),label:W,description:x,allowNonContiguousMatches:le}})}function d(W,x,le,G,J){if(!W||!x.normalized)return n;const Q=G.getItemLabel(W);if(!Q)return n;const oe=G.getItemDescription(W),_=s(Q,oe,le,x),Ee=J[_];if(Ee)return Ee;const he=c(Q,oe,G.getItemPath(W),x,le);return J[_]=he,he}e.$Cq=d;function c(W,x,le,G,J){const Q=!le||!G.containsPathSeparator;return le&&(M.$k?G.pathNormalized===le:(0,b.$6e)(G.pathNormalized,le))?{score:r,labelMatch:[{start:0,end:W.length}],descriptionMatch:x?[{start:0,end:x.length}]:void 0}:G.values&&G.values.length>1?l(W,x,le,G.values,Q,J):h(W,x,le,G,Q,J)}function l(W,x,le,G,J,Q){let oe=0;const _=[],Ee=[];for(const he of G){const{score:q,labelMatch:U,descriptionMatch:ie}=h(W,x,le,he,J,Q);if(q===v)return n;oe+=q,U&&_.push(...U),ie&&Ee.push(...ie)}return{score:oe,labelMatch:D(_),descriptionMatch:D(Ee)}}function h(W,x,le,G,J,Q){if(J||!x){const[oe,_]=A(W,G.normalized,G.normalizedLowercase,Q&&!G.expectContiguousMatch);if(oe){const Ee=(0,F.$Jj)(G.normalized,W);let he;if(Ee){he=a;const q=Math.round(G.normalized.length/W.length*100);he+=q}else he=t;return{score:he+oe,labelMatch:Ee||E(_)}}}if(x){let oe=x;le&&(oe=`${x}${L.sep}`);const _=oe.length,Ee=`${oe}${W}`,[he,q]=A(Ee,G.normalized,G.normalizedLowercase,Q&&!G.expectContiguousMatch);if(he){const U=E(q),ie=[],be=[];return U.forEach(H=>{H.start<_&&H.end>_?(ie.push({start:0,end:H.end-_}),be.push({start:H.start,end:_})):H.start>=_?ie.push({start:H.start-_,end:H.end-_}):be.push(H)}),{score:he,labelMatch:ie,descriptionMatch:be}}}return n}function E(W){const x=[];if(!W)return x;let le;for(const G of W)le&&le.end===G?le.end+=1:(le={start:G,end:G+1},x.push(le));return x}function D(W){const x=W.sort((J,Q)=>J.start-Q.start),le=[];let G;for(const J of x)!G||!m(G,J)?(G=J,le.push(J)):(G.start=Math.min(G.start,J.start),G.end=Math.max(G.end,J.end));return le}function m(W,x){return!(W.end<x.start||x.end<W.start)}function p(W,x,le,G,J,Q){const oe=d(W,le,G,J,Q),_=d(x,le,G,J,Q),Ee=oe.score,he=_.score;if((Ee===r||he===r)&&Ee!==he)return Ee===r?-1:1;if(Ee>t||he>t){if(Ee!==he)return Ee>he?-1:1;if(Ee<a&&he<a){const Z=P(oe.labelMatch,_.labelMatch);if(Z!==0)return Z}const H=J.getItemLabel(W)||"",Y=J.getItemLabel(x)||"";if(H.length!==Y.length)return H.length-Y.length}if(Ee!==he)return Ee>he?-1:1;const q=Array.isArray(oe.labelMatch)&&oe.labelMatch.length>0,U=Array.isArray(_.labelMatch)&&_.labelMatch.length>0;if(q&&!U)return-1;if(U&&!q)return 1;const ie=S(W,oe,J),be=S(x,_,J);return ie&&be&&ie!==be?be>ie?-1:1:z(W,x,le,J)}e.$Dq=p;function S(W,x,le){let G=-1,J=-1;if(x.descriptionMatch&&x.descriptionMatch.length?G=x.descriptionMatch[0].start:x.labelMatch&&x.labelMatch.length&&(G=x.labelMatch[0].start),x.labelMatch&&x.labelMatch.length){if(J=x.labelMatch[x.labelMatch.length-1].end,x.descriptionMatch&&x.descriptionMatch.length){const Q=le.getItemDescription(W);Q&&(J+=Q.length)}}else x.descriptionMatch&&x.descriptionMatch.length&&(J=x.descriptionMatch[x.descriptionMatch.length-1].end);return J-G}function P(W,x){if(!W&&!x||(!W||!W.length)&&(!x||!x.length))return 0;if(!x||!x.length)return-1;if(!W||!W.length)return 1;const le=W[0].start,J=W[W.length-1].end-le,Q=x[0].start,_=x[x.length-1].end-Q;return J===_?0:_<J?1:-1}function z(W,x,le,G){const J=G.getItemLabel(W)||"",Q=G.getItemLabel(x)||"",oe=G.getItemDescription(W),_=G.getItemDescription(x),Ee=J.length+(oe?oe.length:0),he=Q.length+(_?_.length:0);if(Ee!==he)return Ee-he;const q=G.getItemPath(W),U=G.getItemPath(x);return q&&U&&q.length!==U.length?q.length-U.length:J!==Q?(0,C.$yq)(J,Q,le.normalized):oe&&_&&oe!==_?(0,C.$yq)(oe,_,le.normalized):q&&U&&q!==U?(0,C.$yq)(q,U,le.normalized):0}function j(W){return W.startsWith('"')&&W.endsWith('"')}const R=" ";function T(W){typeof W!="string"&&(W="");const x=W.toLowerCase(),{pathNormalized:le,normalized:G,normalizedLowercase:J}=N(W),Q=le.indexOf(L.sep)>=0,oe=j(W);let _;const Ee=W.split(R);if(Ee.length>1)for(const he of Ee){const q=j(he),{pathNormalized:U,normalized:ie,normalizedLowercase:be}=N(he);ie&&(_||(_=[]),_.push({original:he,originalLowercase:he.toLowerCase(),pathNormalized:U,normalized:ie,normalizedLowercase:be,expectContiguousMatch:q}))}return{original:W,originalLowercase:x,pathNormalized:le,normalized:G,normalizedLowercase:J,values:_,containsPathSeparator:Q,expectContiguousMatch:oe}}e.$Eq=T;function N(W){let x;M.$i?x=W.replace(/\//g,L.sep):x=W.replace(/\\/g,L.sep);const le=(0,b.$Qe)(x).replace(/\s|"/g,"");return{pathNormalized:x,normalized:le,normalizedLowercase:le.toLowerCase()}}function O(W){return Array.isArray(W)?T(W.map(x=>x.original).join(R)):T(W.original)}e.$Fq=O}),define(ke[100],Se([1,0,16]),function(me,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zr=e.$Yr=e.$Xr=e.$Wr=e.$Vr=void 0,e.$Vr=Object.freeze({text:"text/plain",binary:"application/octet-stream",unknown:"application/unknown",markdown:"text/markdown",latex:"text/latex",uriList:"text/uri-list"});const F={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},f={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function L(A){const I=(0,C.$nc)(A),$=F[I.toLowerCase()];return $!==void 0?$:M(A)}e.$Wr=L;function M(A){const I=(0,C.$nc)(A);return f[I.toLowerCase()]}e.$Xr=M;function b(A){for(const I in f)if(f[I]===A)return I}e.$Yr=b;const v=/^(.+)\/(.+?)(;.+)?$/;function g(A,I){const $=v.exec(A);return $?`${$[1].toLowerCase()}/${$[2].toLowerCase()}${$[3]??""}`:I?void 0:A}e.$Zr=g}),define(ke[101],Se([1,0,11]),function(me,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gl=e.$Fl=e.TerminateResponseCode=e.Source=void 0;var F;(function(b){b[b.stdout=0]="stdout",b[b.stderr=1]="stderr"})(F||(e.Source=F={}));var f;(function(b){b[b.Success=0]="Success",b[b.Unknown=1]="Unknown",b[b.AccessDenied=2]="AccessDenied",b[b.ProcessNotFound=3]="ProcessNotFound"})(f||(e.TerminateResponseCode=f={}));function L(b,...v){const g=v.reduce(($,y)=>($[y]=!0,$),{}),A=[/^ELECTRON_.+$/,/^VSCODE_(?!(PORTABLE|SHELL_LOGIN|ENV_REPLACE|ENV_APPEND|ENV_PREPEND)).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(b).filter($=>!g[$]).forEach($=>{for(let y=0;y<A.length;y++)if($.search(A[y])!==-1){delete b[$];break}})}e.$Fl=L;function M(b){b&&(delete b.DEBUG,C.$j&&delete b.DYLD_LIBRARY_PATH,C.$k&&delete b.LD_PRELOAD)}e.$Gl=M}),define(ke[2],Se([1,0,16,11]),function(me,e,C,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vc=e.$uc=e.URI=void 0;const f=/^\w[\w\d+.-]*$/,L=/^\//,M=/^\/\//;function b(c,l){if(!c.scheme&&l)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${c.authority}", path: "${c.path}", query: "${c.query}", fragment: "${c.fragment}"}`);if(c.scheme&&!f.test(c.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(c.path){if(c.authority){if(!L.test(c.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(M.test(c.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function v(c,l){return!c&&!l?"file":c}function g(c,l){switch(c){case"https":case"http":case"file":l?l[0]!==I&&(l=I+l):l=I;break}return l}const A="",I="/",$=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class y{static isUri(l){return l instanceof y?!0:l?typeof l.authority=="string"&&typeof l.fragment=="string"&&typeof l.path=="string"&&typeof l.query=="string"&&typeof l.scheme=="string"&&typeof l.fsPath=="string"&&typeof l.with=="function"&&typeof l.toString=="function":!1}constructor(l,h,E,D,m,p=!1){typeof l=="object"?(this.scheme=l.scheme||A,this.authority=l.authority||A,this.path=l.path||A,this.query=l.query||A,this.fragment=l.fragment||A):(this.scheme=v(l,p),this.authority=h||A,this.path=g(this.scheme,E||A),this.query=D||A,this.fragment=m||A,b(this,p))}get fsPath(){return r(this,!1)}with(l){if(!l)return this;let{scheme:h,authority:E,path:D,query:m,fragment:p}=l;return h===void 0?h=this.scheme:h===null&&(h=A),E===void 0?E=this.authority:E===null&&(E=A),D===void 0?D=this.path:D===null&&(D=A),m===void 0?m=this.query:m===null&&(m=A),p===void 0?p=this.fragment:p===null&&(p=A),h===this.scheme&&E===this.authority&&D===this.path&&m===this.query&&p===this.fragment?this:new u(h,E,D,m,p)}static parse(l,h=!1){const E=$.exec(l);return E?new u(E[2]||A,d(E[4]||A),d(E[5]||A),d(E[7]||A),d(E[9]||A),h):new u(A,A,A,A,A)}static file(l){let h=A;if(F.$i&&(l=l.replace(/\\/g,I)),l[0]===I&&l[1]===I){const E=l.indexOf(I,2);E===-1?(h=l.substring(2),l=I):(h=l.substring(2,E),l=l.substring(E)||I)}return new u("file",h,l,A,A)}static from(l,h){return new u(l.scheme,l.authority,l.path,l.query,l.fragment,h)}static joinPath(l,...h){if(!l.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let E;return F.$i&&l.scheme==="file"?E=y.file(C.$ec.join(r(l,!0),...h)).path:E=C.$fc.join(l.path,...h),l.with({path:E})}toString(l=!1){return a(this,l)}toJSON(){return this}static revive(l){if(l){if(l instanceof y)return l;{const h=new u(l);return h._formatted=l.external??null,h._fsPath=l._sep===w?l.fsPath??null:null,h}}else return l}}e.URI=y;function k(c){return!c||typeof c!="object"?!1:typeof c.scheme=="string"&&(typeof c.authority=="string"||typeof c.authority>"u")&&(typeof c.path=="string"||typeof c.path>"u")&&(typeof c.query=="string"||typeof c.query>"u")&&(typeof c.fragment=="string"||typeof c.fragment>"u")}e.$uc=k;const w=F.$i?1:void 0;class u extends y{constructor(){super(...arguments),this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=r(this,!1)),this._fsPath}toString(l=!1){return l?a(this,!0):(this._formatted||(this._formatted=a(this,!1)),this._formatted)}toJSON(){const l={$mid:1};return this._fsPath&&(l.fsPath=this._fsPath,l._sep=w),this._formatted&&(l.external=this._formatted),this.path&&(l.path=this.path),this.scheme&&(l.scheme=this.scheme),this.authority&&(l.authority=this.authority),this.query&&(l.query=this.query),this.fragment&&(l.fragment=this.fragment),l}}const o={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function i(c,l,h){let E,D=-1;for(let m=0;m<c.length;m++){const p=c.charCodeAt(m);if(p>=97&&p<=122||p>=65&&p<=90||p>=48&&p<=57||p===45||p===46||p===95||p===126||l&&p===47||h&&p===91||h&&p===93||h&&p===58)D!==-1&&(E+=encodeURIComponent(c.substring(D,m)),D=-1),E!==void 0&&(E+=c.charAt(m));else{E===void 0&&(E=c.substr(0,m));const S=o[p];S!==void 0?(D!==-1&&(E+=encodeURIComponent(c.substring(D,m)),D=-1),E+=S):D===-1&&(D=m)}}return D!==-1&&(E+=encodeURIComponent(c.substring(D))),E!==void 0?E:c}function n(c){let l;for(let h=0;h<c.length;h++){const E=c.charCodeAt(h);E===35||E===63?(l===void 0&&(l=c.substr(0,h)),l+=o[E]):l!==void 0&&(l+=c[h])}return l!==void 0?l:c}function r(c,l){let h;return c.authority&&c.path.length>1&&c.scheme==="file"?h=`//${c.authority}${c.path}`:c.path.charCodeAt(0)===47&&(c.path.charCodeAt(1)>=65&&c.path.charCodeAt(1)<=90||c.path.charCodeAt(1)>=97&&c.path.charCodeAt(1)<=122)&&c.path.charCodeAt(2)===58?l?h=c.path.substr(1):h=c.path[1].toLowerCase()+c.path.substr(2):h=c.path,F.$i&&(h=h.replace(/\//g,"\\")),h}e.$vc=r;function a(c,l){const h=l?n:i;let E="",{scheme:D,authority:m,path:p,query:S,fragment:P}=c;if(D&&(E+=D,E+=":"),(m||D==="file")&&(E+=I,E+=I),m){let z=m.indexOf("@");if(z!==-1){const j=m.substr(0,z);m=m.substr(z+1),z=j.lastIndexOf(":"),z===-1?E+=h(j,!1,!1):(E+=h(j.substr(0,z),!1,!1),E+=":",E+=h(j.substr(z+1),!1,!0)),E+="@"}m=m.toLowerCase(),z=m.lastIndexOf(":"),z===-1?E+=h(m,!1,!0):(E+=h(m.substr(0,z),!1,!0),E+=m.substr(z))}if(p){if(p.length>=3&&p.charCodeAt(0)===47&&p.charCodeAt(2)===58){const z=p.charCodeAt(1);z>=65&&z<=90&&(p=`/${String.fromCharCode(z+32)}:${p.substr(3)}`)}else if(p.length>=2&&p.charCodeAt(1)===58){const z=p.charCodeAt(0);z>=65&&z<=90&&(p=`${String.fromCharCode(z+32)}:${p.substr(2)}`)}E+=h(p,!0,!1)}return S&&(E+="?",E+=h(S,!1,!1)),P&&(E+="#",E+=l?P:i(P,!1,!1)),E}function t(c){try{return decodeURIComponent(c)}catch{return c.length>3?c.substr(0,3)+t(c.substr(3)):c}}const s=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function d(c){return c.match(s)?c.replace(s,l=>t(l)):c}}),define(ke[185],Se([1,0,2]),function(me,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.log=e.$6p=e.$5p=e.$4p=void 0;function F(g){const A=g;return A&&typeof A.type=="string"&&typeof A.severity=="string"}e.$4p=F;function f(g){const A=[];let I;try{const $=JSON.parse(g.arguments),y=$[$.length-1];y&&y.__$stack&&($.pop(),I=y.__$stack),A.push(...$)}catch{A.push("Unable to log remote console arguments",g.arguments)}return{args:A,stack:I}}e.$5p=f;function L(g){if(typeof g!="string")return L(f(g).stack);const A=g;if(A){const I=M(A),$=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(I||"");if($&&$.length===4)return{uri:C.URI.file($[1]),line:Number($[2]),column:Number($[3])}}}e.$6p=L;function M(g){if(!g)return g;const A=g.indexOf(`
`);return A===-1?g:g.substring(0,A)}function b(g,A){const{args:I,stack:$}=f(g),y=typeof I[0]=="string"&&I.length===1;let k=M($);k&&(k=`(${k.trim()})`);let w=[];if(typeof I[0]=="string"?k&&y?w=[`%c[${A}] %c${I[0]} %c${k}`,v("blue"),v(""),v("grey")]:w=[`%c[${A}] %c${I[0]}`,v("blue"),v(""),...I.slice(1)]:w=[`%c[${A}]%`,v("blue"),...I],k&&!y&&w.push(k),typeof console[g.severity]!="function")throw new Error("Unknown console method");console[g.severity].apply(console,w)}e.log=b;function v(g){return`color: ${g}`}}),define(ke[54],Se([1,0,22,2]),function(me,e,C,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sh=e.$rh=e.$qh=void 0;function f(v){return JSON.stringify(v,M)}e.$qh=f;function L(v){let g=JSON.parse(v);return g=b(g),g}e.$rh=L;function M(v,g){return g instanceof RegExp?{$mid:2,source:g.source,flags:g.flags}:g}function b(v,g=0){if(!v||g>200)return v;if(typeof v=="object"){switch(v.$mid){case 1:return F.URI.revive(v);case 2:return new RegExp(v.source,v.flags);case 17:return new Date(v.source)}if(v instanceof C.$fe||v instanceof Uint8Array)return v;if(Array.isArray(v))for(let A=0;A<v.length;++A)v[A]=b(v[A],g+1);else for(const A in v)Object.hasOwnProperty.call(v,A)&&(v[A]=b(v[A],g+1))}return v}e.$sh=b}),define(ke[17],Se([1,0,8,11,2]),function(me,e,C,F,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.$gg=e.$fg=e.$eg=e.$dg=e.$cg=e.$bg=e.$ag=e.$_f=e.$$f=e.Schemas=void 0;var L;(function(g){g.inMemory="inmemory",g.vscode="vscode",g.internal="private",g.walkThrough="walkThrough",g.walkThroughSnippet="walkThroughSnippet",g.http="http",g.https="https",g.file="file",g.mailto="mailto",g.untitled="untitled",g.data="data",g.command="command",g.vscodeRemote="vscode-remote",g.vscodeRemoteResource="vscode-remote-resource",g.vscodeManagedRemoteResource="vscode-managed-remote-resource",g.vscodeUserData="vscode-userdata",g.vscodeCustomEditor="vscode-custom-editor",g.vscodeNotebookCell="vscode-notebook-cell",g.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",g.vscodeNotebookCellOutput="vscode-notebook-cell-output",g.vscodeInteractiveInput="vscode-interactive-input",g.vscodeSettings="vscode-settings",g.vscodeWorkspaceTrust="vscode-workspace-trust",g.vscodeTerminal="vscode-terminal",g.vscodeChatSesssion="vscode-chat-editor",g.webviewPanel="webview-panel",g.vscodeWebview="vscode-webview",g.extension="extension",g.vscodeFileResource="vscode-file",g.tmp="tmp",g.vsls="vsls",g.vscodeSourceControl="vscode-scm"})(L||(e.Schemas=L={})),e.$$f="vscode-tkn",e.$_f="tkn";class M{constructor(){this.a=Object.create(null),this.b=Object.create(null),this.c=Object.create(null),this.d="http",this.e=null,this.f=`/${L.vscodeRemoteResource}`}setPreferredWebSchema(A){this.d=A}setDelegate(A){this.e=A}setServerRootPath(A){this.f=`${A}/${L.vscodeRemoteResource}`}set(A,I,$){this.a[A]=I,this.b[A]=$}setConnectionToken(A,I){this.c[A]=I}getPreferredWebSchema(){return this.d}rewrite(A){if(this.e)try{return this.e(A)}catch(u){return C.$Z(u),A}const I=A.authority;let $=this.a[I];$&&$.indexOf(":")!==-1&&$.indexOf("[")===-1&&($=`[${$}]`);const y=this.b[I],k=this.c[I];let w=`path=${encodeURIComponent(A.path)}`;return typeof k=="string"&&(w+=`&${e.$_f}=${encodeURIComponent(k)}`),f.URI.from({scheme:F.$o?this.d:L.vscodeRemoteResource,authority:`${$}:${y}`,path:this.f,query:w})}}e.$ag=new M,e.$bg="vs/../../extensions",e.$cg="vs/../../node_modules",e.$dg="vs/../../node_modules.asar",e.$eg="vs/../../node_modules.asar.unpacked",e.$fg="vscode-app";class b{static{this.a=e.$fg}asBrowserUri(A){const I=this.b(A,me);return this.uriToBrowserUri(I)}uriToBrowserUri(A){return A.scheme===L.vscodeRemote?e.$ag.rewrite(A):A.scheme===L.file&&(F.$m||F.$q===`${L.vscodeFileResource}://${b.a}`)?A.with({scheme:L.vscodeFileResource,authority:A.authority||b.a,query:null,fragment:null}):A}asFileUri(A){const I=this.b(A,me);return this.uriToFileUri(I)}uriToFileUri(A){return A.scheme===L.vscodeFileResource?A.with({scheme:L.file,authority:A.authority!==b.a?A.authority:null,query:null,fragment:null}):A}b(A,I){return f.URI.isUri(A)?A:f.URI.parse(I.toUrl(A))}}e.$gg=new b;var v;(function(g){const A=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);g.CoopAndCoep=Object.freeze(A.get("3"));const I="vscode-coi";function $(k){let w;typeof k=="string"?w=new URL(k).searchParams:k instanceof URL?w=k.searchParams:f.URI.isUri(k)&&(w=new URL(k.toString(!0)).searchParams);const u=w?.get(I);if(u)return A.get(u)}g.getHeadersFromQuery=$;function y(k,w,u){if(!globalThis.crossOriginIsolated)return;const o=w&&u?"3":u?"2":"1";k instanceof URLSearchParams?k.set(I,o):k[I]=o}g.addSearchParam=y})(v||(e.COI=v={}))}),define(ke[186],Se([1,0,159,17,11,2]),function(me,e,C,F,f,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$NC=void 0;class M{constructor($,y,k){this.id=$,this.dependencies=y,this.callback=k}}class b{static{this.INSTANCE=new b}constructor(){this.a=typeof self=="object"&&self.constructor&&self.constructor.name==="DedicatedWorkerGlobalScope",this.b=typeof document=="object",this.c=[],this.d=!1}g(){this.d||(this.d=!0,globalThis.define=($,y,k)=>{typeof $!="string"&&(k=y,y=$,$=null),(typeof y!="object"||!Array.isArray(y))&&(k=y,y=null),this.c.push(new M($,y,k))},globalThis.define.amd=!0,this.b?this.f=window.trustedTypes?.createPolicy("amdLoader",{createScriptURL($){if($.startsWith(window.location.origin)||$.startsWith("vscode-file://vscode-app"))return $;throw new Error(`[trusted_script_src] Invalid script url: ${$}`)}}):this.a&&(this.f=globalThis.trustedTypes?.createPolicy("amdLoader",{createScriptURL($){return $}})))}async load($){this.g();const y=await(this.a?this.i($):this.b?this.h($):this.j($));if(!y)throw new Error(`Did not receive a define call from script ${$}`);if(Array.isArray(y.dependencies)&&y.dependencies.length>0)throw new Error(`Cannot resolve dependencies for script ${$}. The dependencies are: ${y.dependencies.join(", ")}`);return typeof y.callback=="function"?y.callback([]):y.callback}h($){return new Promise((y,k)=>{const w=document.createElement("script");w.setAttribute("async","async"),w.setAttribute("type","text/javascript");const u=()=>{w.removeEventListener("load",o),w.removeEventListener("error",i)},o=n=>{u(),y(this.c.pop())},i=n=>{u(),k(n)};w.addEventListener("load",o),w.addEventListener("error",i),this.f&&($=this.f.createScriptURL($)),w.setAttribute("src",$),window.document.getElementsByTagName("head")[0].appendChild(w)})}i($){return new Promise((y,k)=>{try{this.f&&($=this.f.createScriptURL($)),importScripts($),y(this.c.pop())}catch(w){k(w)}})}async j($){try{const y=globalThis._VSCODE_NODE_MODULES.fs,k=globalThis._VSCODE_NODE_MODULES.vm,w=globalThis._VSCODE_NODE_MODULES.module,u=L.URI.parse($).fsPath,o=y.readFileSync(u).toString(),i=w.wrap(o.replace(/^#!.*/,""));return new k.Script(i).runInThisContext().apply(),this.c.pop()}catch(y){throw y}}}const v=new Map;let g={};typeof globalThis.require=="object"&&(g=globalThis.require.paths??{});async function A(I,$,y){if(C.$S){y===void 0&&(y=!!(globalThis._VSCODE_PRODUCT_JSON??globalThis.vscode?.context?.configuration()?.product)?.commit),g[I]&&(I=g[I]);const k=`${I}/${$}`;if(v.has(k))return v.get(k);let w;if(/^\w[\w\d+.-]*:\/\//.test(k))w=k;else{const n=`${y&&!f.$o?F.$dg:F.$cg}/${k}`;w=F.$gg.asBrowserUri(n).toString(!0)}const u=b.INSTANCE.load(w);return v.set(k,u),u}else return await new Promise((k,w)=>{me([I],k,w)})}e.$NC=A}),define(ke[23],Se([1,0,33,17,16,11,13,2]),function(me,e,C,F,f,L,M,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jg=e.DataUri=e.$Ig=e.$Hg=e.$Gg=e.$Fg=e.$Eg=e.$Dg=e.$Cg=e.$Bg=e.$Ag=e.$zg=e.$yg=e.$xg=e.$wg=e.$vg=e.$ug=e.$tg=e.$sg=e.$rg=e.$qg=e.$pg=e.$og=e.$ng=void 0;function v(y){return(0,b.$vc)(y,!0)}e.$ng=v;class g{constructor(k){this.a=k}compare(k,w,u=!1){return k===w?0:(0,M.$Ye)(this.getComparisonKey(k,u),this.getComparisonKey(w,u))}isEqual(k,w,u=!1){return k===w?!0:!k||!w?!1:this.getComparisonKey(k,u)===this.getComparisonKey(w,u)}getComparisonKey(k,w=!1){return k.with({path:this.a(k)?k.path.toLowerCase():void 0,fragment:w?null:void 0}).toString()}ignorePathCasing(k){return this.a(k)}isEqualOrParent(k,w,u=!1){if(k.scheme===w.scheme){if(k.scheme===F.Schemas.file)return C.$2f(v(k),v(w),this.a(k))&&k.query===w.query&&(u||k.fragment===w.fragment);if((0,e.$Eg)(k.authority,w.authority))return C.$2f(k.path,w.path,this.a(k),"/")&&k.query===w.query&&(u||k.fragment===w.fragment)}return!1}joinPath(k,...w){return b.URI.joinPath(k,...w)}basenameOrAuthority(k){return(0,e.$wg)(k)||k.authority}basename(k){return f.$fc.basename(k.path)}extname(k){return f.$fc.extname(k.path)}dirname(k){if(k.path.length===0)return k;let w;return k.scheme===F.Schemas.file?w=b.URI.file(f.$lc(v(k))).path:(w=f.$fc.dirname(k.path),k.authority&&w.length&&w.charCodeAt(0)!==47&&(console.error(`dirname("${k.toString})) resulted in a relative path`),w="/")),k.with({path:w})}normalizePath(k){if(!k.path.length)return k;let w;return k.scheme===F.Schemas.file?w=b.URI.file(f.$gc(v(k))).path:w=f.$fc.normalize(k.path),k.with({path:w})}relativePath(k,w){if(k.scheme!==w.scheme||!(0,e.$Eg)(k.authority,w.authority))return;if(k.scheme===F.Schemas.file){const i=f.$kc(v(k),v(w));return L.$i?C.$Vf(i):i}let u=k.path||"/";const o=w.path||"/";if(this.a(k)){let i=0;for(const n=Math.min(u.length,o.length);i<n&&!(u.charCodeAt(i)!==o.charCodeAt(i)&&u.charAt(i).toLowerCase()!==o.charAt(i).toLowerCase());i++);u=o.substr(0,i)+u.substr(i)}return f.$fc.relative(u,o)}resolvePath(k,w){if(k.scheme===F.Schemas.file){const u=b.URI.file(f.$jc(v(k),w));return k.with({authority:u.authority,path:u.path})}return w=C.$Wf(w),k.with({path:f.$fc.resolve(k.path,w)})}isAbsolutePath(k){return!!k.path&&k.path[0]==="/"}isEqualAuthority(k,w){return k===w||k!==void 0&&w!==void 0&&(0,M.$6e)(k,w)}hasTrailingPathSeparator(k,w=f.sep){if(k.scheme===F.Schemas.file){const u=v(k);return u.length>C.$Xf(u).length&&u[u.length-1]===w}else{const u=k.path;return u.length>1&&u.charCodeAt(u.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(k.fsPath)}}removeTrailingPathSeparator(k,w=f.sep){return(0,e.$Fg)(k,w)?k.with({path:k.path.substr(0,k.path.length-1)}):k}addTrailingPathSeparator(k,w=f.sep){let u=!1;if(k.scheme===F.Schemas.file){const o=v(k);u=o!==void 0&&o.length===C.$Xf(o).length&&o[o.length-1]===w}else{w="/";const o=k.path;u=o.length===1&&o.charCodeAt(o.length-1)===47}return!u&&!(0,e.$Fg)(k,w)?k.with({path:k.path+"/"}):k}}e.$og=g,e.$pg=new g(()=>!1),e.$qg=new g(y=>y.scheme===F.Schemas.file?!L.$k:!0),e.$rg=new g(y=>!0),e.$sg=e.$pg.isEqual.bind(e.$pg),e.$tg=e.$pg.isEqualOrParent.bind(e.$pg),e.$ug=e.$pg.getComparisonKey.bind(e.$pg),e.$vg=e.$pg.basenameOrAuthority.bind(e.$pg),e.$wg=e.$pg.basename.bind(e.$pg),e.$xg=e.$pg.extname.bind(e.$pg),e.$yg=e.$pg.dirname.bind(e.$pg),e.$zg=e.$pg.joinPath.bind(e.$pg),e.$Ag=e.$pg.normalizePath.bind(e.$pg),e.$Bg=e.$pg.relativePath.bind(e.$pg),e.$Cg=e.$pg.resolvePath.bind(e.$pg),e.$Dg=e.$pg.isAbsolutePath.bind(e.$pg),e.$Eg=e.$pg.isEqualAuthority.bind(e.$pg),e.$Fg=e.$pg.hasTrailingPathSeparator.bind(e.$pg),e.$Gg=e.$pg.removeTrailingPathSeparator.bind(e.$pg),e.$Hg=e.$pg.addTrailingPathSeparator.bind(e.$pg);function A(y,k){const w=[];for(let u=0;u<y.length;u++){const o=k(y[u]);y.some((i,n)=>n===u?!1:(0,e.$tg)(o,k(i)))||w.push(y[u])}return w}e.$Ig=A;var I;(function(y){y.META_DATA_LABEL="label",y.META_DATA_DESCRIPTION="description",y.META_DATA_SIZE="size",y.META_DATA_MIME="mime";function k(w){const u=new Map;w.path.substring(w.path.indexOf(";")+1,w.path.lastIndexOf(";")).split(";").forEach(n=>{const[r,a]=n.split(":");r&&a&&u.set(r,a)});const i=w.path.substring(0,w.path.indexOf(";"));return i&&u.set(y.META_DATA_MIME,i),u}y.parseMetaData=k})(I||(e.DataUri=I={}));function $(y,k,w){if(k){let u=y.path;return u&&u[0]!==f.$fc.sep&&(u=f.$fc.sep+u),y.with({scheme:w,authority:k,path:u})}return y.with({scheme:w})}e.$Jg=$}),define(ke[12],Se([1,0,21,8,4,3,23,11,163]),function(me,e,C,F,f,L,M,b,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mh=e.$lh=e.$kh=e.$jh=e.Promises=e.$ih=e.$hh=e.$gh=e.$fh=e.$eh=e.$dh=e.$ch=e.$bh=e.$ah=e.$_g=e.$$g=e.$0g=e.$9g=e.$8g=e.$7g=e.$6g=e.$5g=e.$4g=e.$3g=e.$2g=e.$1g=e.$Zg=e.$Yg=e.$Xg=e.$Wg=e.$Vg=e.$Ug=e.$Tg=e.$Sg=e.$Rg=e.$Qg=e.$Pg=e.$Og=e.$Ng=e.$Mg=e.$Lg=e.$Kg=void 0;function g(be){return!!be&&typeof be.then=="function"}e.$Kg=g;function A(be){const H=new C.$2d,Y=be(H.token),Z=new Promise(($e,ne)=>{const fe=H.token.onCancellationRequested(()=>{fe.dispose(),H.dispose(),ne(new F.$4)});Promise.resolve(Y).then(te=>{fe.dispose(),H.dispose(),$e(te)},te=>{fe.dispose(),H.dispose(),ne(te)})});return new class{cancel(){H.cancel()}then($e,ne){return Z.then($e,ne)}catch($e){return this.then(void 0,$e)}finally($e){return Z.finally($e)}}}e.$Lg=A;function I(be,H,Y){return new Promise((Z,$e)=>{const ne=H.onCancellationRequested(()=>{ne.dispose(),Z(Y)});be.then(Z,$e).finally(()=>ne.dispose())})}e.$Mg=I;function $(be,H){return new Promise((Y,Z)=>{const $e=H.onCancellationRequested(()=>{$e.dispose(),Z(new F.$4)});be.then(Y,Z).finally(()=>$e.dispose())})}e.$Ng=$;async function y(be){let H=-1;const Y=be.map((Z,$e)=>Z.then(ne=>(H=$e,ne)));try{return await Promise.race(Y)}finally{be.forEach((Z,$e)=>{$e!==H&&Z.cancel()})}}e.$Og=y;function k(be,H,Y){let Z;const $e=setTimeout(()=>{Z?.(void 0),Y?.()},H);return Promise.race([be.finally(()=>clearTimeout($e)),new Promise(ne=>Z=ne)])}e.$Pg=k;function w(be){return new Promise((H,Y)=>{const Z=be();g(Z)?Z.then(H,Y):H(Z)})}e.$Qg=w;class u{constructor(){this.f=!1,this.a=null,this.b=null,this.d=null}queue(H){if(this.f)return Promise.reject(new Error("Throttler is disposed"));if(this.a){if(this.d=H,!this.b){const Y=()=>{if(this.b=null,this.f)return;const Z=this.queue(this.d);return this.d=null,Z};this.b=new Promise(Z=>{this.a.then(Y,Y).then(Z)})}return new Promise((Y,Z)=>{this.b.then(Y,Z)})}return this.a=H(),new Promise((Y,Z)=>{this.a.then($e=>{this.a=null,Y($e)},$e=>{this.a=null,Z($e)})})}dispose(){this.f=!0}}e.$Rg=u;class o{constructor(){this.a=Promise.resolve(null)}queue(H){return this.a=this.a.then(()=>H(),()=>H())}}e.$Sg=o;class i{constructor(){this.a=new Map}queue(H,Y){const $e=(this.a.get(H)??Promise.resolve()).catch(()=>{}).then(Y).finally(()=>{this.a.get(H)===$e&&this.a.delete(H)});return this.a.set(H,$e),$e}}e.$Tg=i;const n=(be,H)=>{let Y=!0;const Z=setTimeout(()=>{Y=!1,H()},be);return{isTriggered:()=>Y,dispose:()=>{clearTimeout(Z),Y=!1}}},r=be=>{let H=!0;return queueMicrotask(()=>{H&&(H=!1,be())}),{isTriggered:()=>H,dispose:()=>{H=!1}}};class a{constructor(H){this.defaultDelay=H,this.a=null,this.b=null,this.d=null,this.f=null,this.g=null}trigger(H,Y=this.defaultDelay){this.g=H,this.h(),this.b||(this.b=new Promise(($e,ne)=>{this.d=$e,this.f=ne}).then(()=>{if(this.b=null,this.d=null,this.g){const $e=this.g;return this.g=null,$e()}}));const Z=()=>{this.a=null,this.d?.(null)};return this.a=Y===v.$Od?r(Z):n(Y,Z),this.b}isTriggered(){return!!this.a?.isTriggered()}cancel(){this.h(),this.b&&(this.f?.(new F.$4),this.b=null)}h(){this.a?.dispose(),this.a=null}dispose(){this.cancel()}}e.$Ug=a;class t{constructor(H){this.a=new a(H),this.b=new u}trigger(H,Y){return this.a.trigger(()=>this.b.queue(H),Y)}isTriggered(){return this.a.isTriggered()}cancel(){this.a.cancel()}dispose(){this.a.dispose(),this.b.dispose()}}e.$Vg=t;class s{constructor(){this.a=!1,this.b=new Promise((H,Y)=>{this.d=H})}isOpen(){return this.a}open(){this.a=!0,this.d(!0)}wait(){return this.b}}e.$Wg=s;class d extends s{constructor(H){super(),this.f=setTimeout(()=>this.open(),H)}open(){clearTimeout(this.f),super.open()}}e.$Xg=d;function c(be,H){return H?new Promise((Y,Z)=>{const $e=setTimeout(()=>{ne.dispose(),Y()},be),ne=H.onCancellationRequested(()=>{clearTimeout($e),ne.dispose(),Z(new F.$4)})}):A(Y=>c(be,Y))}e.$Yg=c;function l(be,H=0,Y){const Z=setTimeout(()=>{be(),Y&&$e.dispose()},H),$e=(0,L.$Pc)(()=>{clearTimeout(Z),Y?.deleteAndLeak($e)});return Y?.add($e),$e}e.$Zg=l;function h(be){const H=[];let Y=0;const Z=be.length;function $e(){return Y<Z?be[Y++]():null}function ne(fe){fe!=null&&H.push(fe);const te=$e();return te?te.then(ne):Promise.resolve(H)}return Promise.resolve(null).then(ne)}e.$1g=h;function E(be,H=Z=>!!Z,Y=null){let Z=0;const $e=be.length,ne=()=>{if(Z>=$e)return Promise.resolve(Y);const fe=be[Z++];return Promise.resolve(fe()).then(de=>H(de)?Promise.resolve(de):ne())};return ne()}e.$2g=E;function D(be,H=Z=>!!Z,Y=null){if(be.length===0)return Promise.resolve(Y);let Z=be.length;const $e=()=>{Z=-1;for(const ne of be)ne.cancel?.()};return new Promise((ne,fe)=>{for(const te of be)te.then(de=>{--Z>=0&&H(de)?($e(),ne(de)):Z===0&&ne(Y)}).catch(de=>{--Z>=0&&($e(),fe(de))})})}e.$3g=D;class m{constructor(H){this.a=0,this.d=H,this.f=[],this.b=0,this.g=new f.$Rd}get onDrained(){return this.g.event}get size(){return this.a}queue(H){return this.a++,new Promise((Y,Z)=>{this.f.push({factory:H,c:Y,e:Z}),this.h()})}h(){for(;this.f.length&&this.b<this.d;){const H=this.f.shift();this.b++;const Y=H.factory();Y.then(H.c,H.e),Y.then(()=>this.j(),()=>this.j())}}j(){this.a--,this.b--,this.f.length>0?this.h():this.g.fire()}dispose(){this.g.dispose()}}e.$4g=m;class p extends m{constructor(){super(1)}}e.$5g=p;class S{constructor(){this.a=new G,this.b=0}queue(H){return this.a.isRunning()?this.a.queue(()=>this.a.run(this.b++,H())):this.a.run(this.b++,H())}}e.$6g=S;class P{constructor(){this.a=new Map,this.b=new Set,this.d=void 0,this.f=0}async whenDrained(){if(this.g())return;const H=new oe;return this.b.add(H),H.p}g(){for(const[,H]of this.a)if(H.size>0)return!1;return!0}queueFor(H,Y=M.$pg){const Z=Y.getComparisonKey(H);let $e=this.a.get(Z);if(!$e){$e=new p;const ne=this.f++,fe=f.Event.once($e.onDrained)(()=>{$e?.dispose(),this.a.delete(Z),this.h(),this.d?.deleteAndDispose(ne),this.d?.size===0&&(this.d.dispose(),this.d=void 0)});this.d||(this.d=new L.$1c),this.d.set(ne,fe),this.a.set(Z,$e)}return $e}h(){this.g()&&this.j()}j(){for(const H of this.b)H.complete();this.b.clear()}dispose(){for(const[,H]of this.a)H.dispose();this.a.clear(),this.j(),this.d?.dispose()}}e.$7g=P;class z{constructor(H,Y){this.a=-1,typeof H=="function"&&typeof Y=="number"&&this.setIfNotSet(H,Y)}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearTimeout(this.a),this.a=-1)}cancelAndSet(H,Y){this.cancel(),this.a=setTimeout(()=>{this.a=-1,H()},Y)}setIfNotSet(H,Y){this.a===-1&&(this.a=setTimeout(()=>{this.a=-1,H()},Y))}}e.$8g=z;class j{constructor(){this.d=void 0}cancel(){this.d?.dispose(),this.d=void 0}cancelAndSet(H,Y,Z=globalThis){this.cancel();const $e=Z.setInterval(()=>{H()},Y);this.d=(0,L.$Pc)(()=>{Z.clearInterval($e),this.d=void 0})}dispose(){this.cancel()}}e.$9g=j;class R{constructor(H,Y){this.b=-1,this.a=H,this.d=Y,this.f=this.g.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearTimeout(this.b),this.b=-1)}schedule(H=this.d){this.cancel(),this.b=setTimeout(this.f,H)}get delay(){return this.d}set delay(H){this.d=H}isScheduled(){return this.b!==-1}flush(){this.isScheduled()&&(this.cancel(),this.h())}g(){this.b=-1,this.a&&this.h()}h(){this.a?.()}}e.$0g=R;class T{constructor(H,Y){Y%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${Y}ms is not a multiple of 1000ms.`),this.a=H,this.b=Y,this.d=0,this.f=-1,this.g=this.h.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearInterval(this.f),this.f=-1)}schedule(H=this.b){H%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${H}ms is not a multiple of 1000ms.`),this.cancel(),this.d=Math.ceil(H/1e3),this.f=setInterval(this.g,1e3)}isScheduled(){return this.f!==-1}h(){this.d--,!(this.d>0)&&(clearInterval(this.f),this.f=-1,this.a?.())}}e.$$g=T;class N extends R{constructor(H,Y){super(H,Y),this.j=[]}work(H){this.j.push(H),this.isScheduled()||this.schedule()}h(){const H=this.j;this.j=[],this.a?.(H)}dispose(){this.j=[],super.dispose()}}e.$_g=N;class O extends L.$Rc{constructor(H,Y){super(),this.g=H,this.h=Y,this.a=[],this.b=this.B(new L.$Sc),this.f=!1}get pending(){return this.a.length}work(H){if(this.f)return!1;if(typeof this.g.maxBufferedWork=="number"){if(this.b.value){if(this.pending+H.length>this.g.maxBufferedWork)return!1}else if(this.pending+H.length-this.g.maxWorkChunkSize>this.g.maxBufferedWork)return!1}for(const Y of H)this.a.push(Y);return this.b.value||this.j(),!0}j(){this.h(this.a.splice(0,this.g.maxWorkChunkSize)),this.a.length>0&&(this.b.value=new R(()=>{this.b.clear(),this.j()},this.g.throttleDelay),this.b.value.schedule())}dispose(){super.dispose(),this.f=!0}}e.$ah=O,function(){typeof globalThis.requestIdleCallback!="function"||typeof globalThis.cancelIdleCallback!="function"?e.$ch=(be,H)=>{(0,b.$B)(()=>{if(Y)return;const Z=Date.now()+15;H(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,Z-Date.now())}}))});let Y=!1;return{dispose(){Y||(Y=!0)}}}:e.$ch=(be,H,Y)=>{const Z=be.requestIdleCallback(H,typeof Y=="number"?{timeout:Y}:void 0);let $e=!1;return{dispose(){$e||($e=!0,be.cancelIdleCallback(Z))}}},e.$bh=be=>(0,e.$ch)(globalThis,be)}();class W{constructor(H,Y){this.g=!1,this.d=()=>{try{this.j=Y()}catch(Z){this.l=Z}finally{this.g=!0}},this.f=(0,e.$ch)(H,()=>this.d())}dispose(){this.f.dispose()}get value(){if(this.g||(this.f.dispose(),this.d()),this.l)throw this.l;return this.j}get isInitialized(){return this.g}}e.$dh=W;class x extends W{constructor(H){super(globalThis,H)}}e.$eh=x;async function le(be,H,Y){let Z;for(let $e=0;$e<Y;$e++)try{return await be()}catch(ne){Z=ne,await c(H)}throw Z}e.$fh=le;class G{isRunning(H){return typeof H=="number"?this.a?.taskId===H:!!this.a}get running(){return this.a?.promise}cancelRunning(){this.a?.cancel()}run(H,Y,Z){return this.a={taskId:H,cancel:()=>Z?.(),promise:Y},Y.then(()=>this.d(H),()=>this.d(H)),Y}d(H){this.a&&H===this.a.taskId&&(this.a=void 0,this.f())}f(){if(this.b){const H=this.b;this.b=void 0,H.run().then(H.promiseResolve,H.promiseReject)}}queue(H){if(this.b)this.b.run=H;else{let Y,Z;const $e=new Promise((ne,fe)=>{Y=ne,Z=fe});this.b={run:H,promise:$e,promiseResolve:Y,promiseReject:Z}}return this.b.promise}hasQueued(){return!!this.b}async join(){return this.b?.promise??this.a?.promise}}e.$gh=G;class J{constructor(H,Y=()=>Date.now()){this.d=H,this.f=Y,this.a=0,this.b=0}increment(){const H=this.f();return H-this.a>this.d&&(this.a=H,this.b=0),this.b++,this.b}}e.$hh=J;var Q;(function(be){be[be.Resolved=0]="Resolved",be[be.Rejected=1]="Rejected"})(Q||(Q={}));class oe{get isRejected(){return this.d?.outcome===1}get isResolved(){return this.d?.outcome===0}get isSettled(){return!!this.d}get value(){return this.d?.outcome===0?this.d?.value:void 0}constructor(){this.p=new Promise((H,Y)=>{this.a=H,this.b=Y})}complete(H){return new Promise(Y=>{this.a(H),this.d={outcome:0,value:H},Y()})}error(H){return new Promise(Y=>{this.b(H),this.d={outcome:1,value:H},Y()})}cancel(){return this.error(new F.$4)}}e.$ih=oe;var _;(function(be){async function H(Z){let $e;const ne=await Promise.all(Z.map(fe=>fe.then(te=>te,te=>{$e||($e=te)})));if(typeof $e<"u")throw $e;return ne}be.settled=H;function Y(Z){return new Promise(async($e,ne)=>{try{await Z($e,ne)}catch(fe){ne(fe)}})}be.withAsyncBody=Y})(_||(e.Promises=_={}));var Ee;(function(be){be[be.Initial=0]="Initial",be[be.DoneOK=1]="DoneOK",be[be.DoneError=2]="DoneError"})(Ee||(Ee={}));class he{static fromArray(H){return new he(Y=>{Y.emitMany(H)})}static fromPromise(H){return new he(async Y=>{Y.emitMany(await H)})}static fromPromises(H){return new he(async Y=>{await Promise.all(H.map(async Z=>Y.emitOne(await Z)))})}static merge(H){return new he(async Y=>{await Promise.all(H.map(async Z=>{for await(const $e of Z)Y.emitOne($e)}))})}static{this.EMPTY=he.fromArray([])}constructor(H){this.a=0,this.b=[],this.d=null,this.f=new f.$Rd,queueMicrotask(async()=>{const Y={emitOne:Z=>this.g(Z),emitMany:Z=>this.h(Z),reject:Z=>this.k(Z)};try{await Promise.resolve(H(Y)),this.j()}catch(Z){this.k(Z)}finally{Y.emitOne=void 0,Y.emitMany=void 0,Y.reject=void 0}})}[Symbol.asyncIterator](){let H=0;return{next:async()=>{do{if(this.a===2)throw this.d;if(H<this.b.length)return{done:!1,value:this.b[H++]};if(this.a===1)return{done:!0,value:void 0};await f.Event.toPromise(this.f.event)}while(!0)}}}static map(H,Y){return new he(async Z=>{for await(const $e of H)Z.emitOne(Y($e))})}map(H){return he.map(this,H)}static filter(H,Y){return new he(async Z=>{for await(const $e of H)Y($e)&&Z.emitOne($e)})}filter(H){return he.filter(this,H)}static coalesce(H){return he.filter(H,Y=>!!Y)}coalesce(){return he.coalesce(this)}static async toPromise(H){const Y=[];for await(const Z of H)Y.push(Z);return Y}toPromise(){return he.toPromise(this)}g(H){this.a===0&&(this.b.push(H),this.f.fire())}h(H){this.a===0&&(this.b=this.b.concat(H),this.f.fire())}j(){this.a===0&&(this.a=1,this.f.fire())}k(H){this.a===0&&(this.a=2,this.d=H,this.f.fire())}}e.$jh=he;class q extends he{constructor(H,Y){super(Y),this.l=H}cancel(){this.l.cancel()}}e.$kh=q;function U(be){const H=new C.$2d,Y=be(H.token);return new q(H,async Z=>{const $e=H.token.onCancellationRequested(()=>{$e.dispose(),H.dispose(),Z.reject(new F.$4)});try{for await(const ne of Y){if(H.token.isCancellationRequested)return;Z.emitOne(ne)}$e.dispose(),H.dispose()}catch(ne){$e.dispose(),H.dispose(),Z.reject(ne)}})}e.$lh=U;class ie{constructor(){this.a=new oe,this.b=new he(Z=>{if(H){Z.reject(H);return}return Y&&Z.emitMany(Y),this.d=$e=>Z.reject($e),this.f=$e=>Z.emitOne($e),this.a.p});let H,Y;this.f=Z=>{Y||(Y=[]),Y.push(Z)},this.d=Z=>{H||(H=Z)}}get asyncIterable(){return this.b}resolve(){this.a.complete()}reject(H){this.d(H),this.a.complete()}emitOne(H){this.f(H)}}e.$mh=ie}),define(ke[34],Se([1,0,19,12,33,28,16,11,13]),function(me,e,C,F,f,L,M,b,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gj=e.$Fj=e.$Ej=e.$Dj=e.$Cj=e.$Bj=e.$Aj=e.$zj=e.$yj=e.$xj=void 0;function g(){return Object.create(null)}e.$xj=g,e.$yj="**",e.$zj="/";const A="[/\\\\]",I="[^/\\\\]",$=/\//g;function y(le,G){switch(le){case 0:return"";case 1:return`${I}*?`;default:return`(?:${A}|${I}+${A}${G?`|${A}${I}+`:""})*?`}}function k(le,G){if(!le)return[];const J=[];let Q=!1,oe=!1,_="";for(const Ee of le){switch(Ee){case G:if(!Q&&!oe){J.push(_),_="";continue}break;case"{":Q=!0;break;case"}":Q=!1;break;case"[":oe=!0;break;case"]":oe=!1;break}_+=Ee}return _&&J.push(_),J}e.$Aj=k;function w(le){if(!le)return"";let G="";const J=k(le,e.$zj);if(J.every(Q=>Q===e.$yj))G=".*";else{let Q=!1;J.forEach((oe,_)=>{if(oe===e.$yj){if(Q)return;G+=y(2,_===J.length-1)}else{let Ee=!1,he="",q=!1,U="";for(const ie of oe){if(ie!=="}"&&Ee){he+=ie;continue}if(q&&(ie!=="]"||!U)){let be;ie==="-"?be=ie:(ie==="^"||ie==="!")&&!U?be="^":ie===e.$zj?be="":be=(0,v.$Je)(ie),U+=be;continue}switch(ie){case"{":Ee=!0;continue;case"[":q=!0;continue;case"}":{const H=`(?:${k(he,",").map(Y=>w(Y)).join("|")})`;G+=H,Ee=!1,he="";break}case"]":{G+="["+U+"]",q=!1,U="";break}case"?":G+=I;continue;case"*":G+=y(1);continue;default:G+=(0,v.$Je)(ie)}}_<J.length-1&&(J[_+1]!==e.$yj||_+2<J.length)&&(G+=A)}Q=oe===e.$yj})}return G}const u=/^\*\*\/\*\.[\w\.-]+$/,o=/^\*\*\/([\w\.-]+)\/?$/,i=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,n=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,r=/^\*\*((\/[\w\.-]+)+)\/?$/,a=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,t=new L.$Cc(1e4),s=function(){return!1},d=function(){return null};function c(le,G){if(!le)return d;let J;typeof le!="string"?J=le.pattern:J=le,J=J.trim();const Q=`${J}_${!!G.trimForExclusions}`;let oe=t.get(Q);if(oe)return l(oe,le);let _;return u.test(J)?oe=E(J.substr(4),J):(_=o.exec(h(J,G)))?oe=D(_[1],J):(G.trimForExclusions?n:i).test(J)?oe=m(J,G):(_=r.exec(h(J,G)))?oe=p(_[1].substr(1),J,!0):(_=a.exec(h(J,G)))?oe=p(_[1],J,!1):oe=S(J),t.set(Q,oe),l(oe,le)}function l(le,G){if(typeof G=="string")return le;const J=function(Q,oe){return(0,f.$2f)(Q,G.base,!b.$k)?le((0,v.$Ne)(Q.substr(G.base.length),M.sep),oe):null};return J.allBasenames=le.allBasenames,J.allPaths=le.allPaths,J.basenames=le.basenames,J.patterns=le.patterns,J}function h(le,G){return G.trimForExclusions&&le.endsWith("/**")?le.substr(0,le.length-2):le}function E(le,G){return function(J,Q){return typeof J=="string"&&J.endsWith(le)?G:null}}function D(le,G){const J=`/${le}`,Q=`\\${le}`,oe=function(Ee,he){return typeof Ee!="string"?null:he?he===le?G:null:Ee===le||Ee.endsWith(J)||Ee.endsWith(Q)?G:null},_=[le];return oe.basenames=_,oe.patterns=[G],oe.allBasenames=_,oe}function m(le,G){const J=W(le.slice(1,-1).split(",").map(he=>c(he,G)).filter(he=>he!==d),le),Q=J.length;if(!Q)return d;if(Q===1)return J[0];const oe=function(he,q){for(let U=0,ie=J.length;U<ie;U++)if(J[U](he,q))return le;return null},_=J.find(he=>!!he.allBasenames);_&&(oe.allBasenames=_.allBasenames);const Ee=J.reduce((he,q)=>q.allPaths?he.concat(q.allPaths):he,[]);return Ee.length&&(oe.allPaths=Ee),oe}function p(le,G,J){const Q=M.sep===M.$fc.sep,oe=Q?le:le.replace($,M.sep),_=M.sep+oe,Ee=M.$fc.sep+le;let he;return J?he=function(q,U){return typeof q=="string"&&(q===oe||q.endsWith(_)||!Q&&(q===le||q.endsWith(Ee)))?G:null}:he=function(q,U){return typeof q=="string"&&(q===oe||!Q&&q===le)?G:null},he.allPaths=[(J?"*/":"./")+le],he}function S(le){try{const G=new RegExp(`^${w(le)}$`);return function(J){return G.lastIndex=0,typeof J=="string"&&G.test(J)?le:null}}catch{return d}}function P(le,G,J){return!le||typeof G!="string"?!1:z(le)(G,void 0,J)}e.$Bj=P;function z(le,G={}){if(!le)return s;if(typeof le=="string"||j(le)){const J=c(le,G);if(J===d)return s;const Q=function(oe,_){return!!J(oe,_)};return J.allBasenames&&(Q.allBasenames=J.allBasenames),J.allPaths&&(Q.allPaths=J.allPaths),Q}return N(le,G)}e.$Cj=z;function j(le){const G=le;return G?typeof G.base=="string"&&typeof G.pattern=="string":!1}e.$Dj=j;function R(le){return le.allBasenames||[]}e.$Ej=R;function T(le){return le.allPaths||[]}e.$Fj=T;function N(le,G){const J=W(Object.getOwnPropertyNames(le).map(he=>O(he,le[he],G)).filter(he=>he!==d)),Q=J.length;if(!Q)return d;if(!J.some(he=>!!he.requiresSiblings)){if(Q===1)return J[0];const he=function(ie,be){let H;for(let Y=0,Z=J.length;Y<Z;Y++){const $e=J[Y](ie,be);if(typeof $e=="string")return $e;(0,F.$Kg)($e)&&(H||(H=[]),H.push($e))}return H?(async()=>{for(const Y of H){const Z=await Y;if(typeof Z=="string")return Z}return null})():null},q=J.find(ie=>!!ie.allBasenames);q&&(he.allBasenames=q.allBasenames);const U=J.reduce((ie,be)=>be.allPaths?ie.concat(be.allPaths):ie,[]);return U.length&&(he.allPaths=U),he}const oe=function(he,q,U){let ie,be;for(let H=0,Y=J.length;H<Y;H++){const Z=J[H];Z.requiresSiblings&&U&&(q||(q=(0,M.$mc)(he)),ie||(ie=q.substr(0,q.length-(0,M.$nc)(he).length)));const $e=Z(he,q,ie,U);if(typeof $e=="string")return $e;(0,F.$Kg)($e)&&(be||(be=[]),be.push($e))}return be?(async()=>{for(const H of be){const Y=await H;if(typeof Y=="string")return Y}return null})():null},_=J.find(he=>!!he.allBasenames);_&&(oe.allBasenames=_.allBasenames);const Ee=J.reduce((he,q)=>q.allPaths?he.concat(q.allPaths):he,[]);return Ee.length&&(oe.allPaths=Ee),oe}function O(le,G,J){if(G===!1)return d;const Q=c(le,J);if(Q===d)return d;if(typeof G=="boolean")return Q;if(G){const oe=G.when;if(typeof oe=="string"){const _=(Ee,he,q,U)=>{if(!U||!Q(Ee,he))return null;const ie=oe.replace("$(basename)",()=>q),be=U(ie);return(0,F.$Kg)(be)?be.then(H=>H?le:null):be?le:null};return _.requiresSiblings=!0,_}}return Q}function W(le,G){const J=le.filter(he=>!!he.basenames);if(J.length<2)return le;const Q=J.reduce((he,q)=>{const U=q.basenames;return U?he.concat(U):he},[]);let oe;if(G){oe=[];for(let he=0,q=Q.length;he<q;he++)oe.push(G)}else oe=J.reduce((he,q)=>{const U=q.patterns;return U?he.concat(U):he},[]);const _=function(he,q){if(typeof he!="string")return null;if(!q){let ie;for(ie=he.length;ie>0;ie--){const be=he.charCodeAt(ie-1);if(be===47||be===92)break}q=he.substr(ie)}const U=Q.indexOf(q);return U!==-1?oe[U]:null};_.basenames=Q,_.patterns=oe,_.allBasenames=Q;const Ee=le.filter(he=>!he.basenames);return Ee.push(_),Ee}function x(le,G){return(0,C.$tb)(le,G,(J,Q)=>typeof J=="string"&&typeof Q=="string"?J===Q:typeof J!="string"&&typeof Q!="string"?J.base===Q.base&&J.pattern===Q.pattern:!1)}e.$Gj=x}),define(ke[80],Se([1,0,8,164,23,13,2]),function(me,e,C,F,f,L,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dk=e.$ck=e.$bk=e.$ak=e.$_j=e.$$j=e.$0j=e.$9j=e.MarkdownStringTextNewlineStyle=void 0;var b;(function(u){u[u.Paragraph=0]="Paragraph",u[u.Break=1]="Break"})(b||(e.MarkdownStringTextNewlineStyle=b={}));class v{constructor(o="",i=!1){if(this.value=o,typeof this.value!="string")throw(0,C.$6)("value");typeof i=="boolean"?(this.isTrusted=i,this.supportThemeIcons=!1,this.supportHtml=!1):(this.isTrusted=i.isTrusted??void 0,this.supportThemeIcons=i.supportThemeIcons??!1,this.supportHtml=i.supportHtml??!1)}appendText(o,i=0){return this.value+=$(this.supportThemeIcons?(0,F.$3j)(o):o).replace(/([ \t]+)/g,(n,r)=>"&nbsp;".repeat(r.length)).replace(/\>/gm,"\\>").replace(/\n/g,i===1?`\\
`:`

`),this}appendMarkdown(o){return this.value+=o,this}appendCodeblock(o,i){return this.value+="\n```",this.value+=o,this.value+=`
`,this.value+=i,this.value+="\n```\n",this}appendLink(o,i,n){return this.value+="[",this.value+=this.c(i,"]"),this.value+="](",this.value+=this.c(String(o),")"),n&&(this.value+=` "${this.c(this.c(n,'"'),")")}"`),this.value+=")",this}c(o,i){const n=new RegExp((0,L.$Je)(i),"g");return o.replace(n,(r,a)=>o.charAt(a-1)!=="\\"?`\\${r}`:r)}}e.$9j=v;function g(u){return A(u)?!u.value:Array.isArray(u)?u.every(g):!0}e.$0j=g;function A(u){return u instanceof v?!0:u&&typeof u=="object"?typeof u.value=="string"&&(typeof u.isTrusted=="boolean"||typeof u.isTrusted=="object"||u.isTrusted===void 0)&&(typeof u.supportThemeIcons=="boolean"||u.supportThemeIcons===void 0):!1}e.$$j=A;function I(u,o){return u===o?!0:!u||!o?!1:u.value===o.value&&u.isTrusted===o.isTrusted&&u.supportThemeIcons===o.supportThemeIcons&&u.supportHtml===o.supportHtml&&(u.baseUri===o.baseUri||!!u.baseUri&&!!o.baseUri&&(0,f.$sg)(M.URI.from(u.baseUri),M.URI.from(o.baseUri)))}e.$_j=I;function $(u){return u.replace(/[\\`*_{}[\]()#+\-!~]/g,"\\$&")}e.$ak=$;function y(u){return u.replace(/"/g,"&quot;")}e.$bk=y;function k(u){return u&&u.replace(/\\([\\`*_{}[\]()#+\-.!~])/g,"$1")}e.$ck=k;function w(u){const o=[],i=u.split("|").map(r=>r.trim());u=i[0];const n=i[1];if(n){const r=/height=(\d+)/.exec(n),a=/width=(\d+)/.exec(n),t=r?r[1]:"",s=a?a[1]:"",d=isFinite(parseInt(s)),c=isFinite(parseInt(t));d&&o.push(`width="${s}"`),c&&o.push(`height="${t}"`)}return{href:u,dimensions:o}}e.$dk=w}),define(ke[102],Se([1,0,19,33,16,11,23,13]),function(me,e,C,F,f,L,M,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gv=e.$Fv=e.$Ev=e.$Dv=e.$Cv=e.$Bv=e.$Av=e.$zv=e.$yv=e.$xv=void 0;function v(c,l){const{os:h,tildify:E,relative:D}=l;if(D){const S=g(c,D,h);if(typeof S=="string")return S}let m=c.fsPath;if(h===1&&!L.$i?m=m.replace(/\//g,"\\"):h!==1&&L.$i&&(m=m.replace(/\\/g,"/")),h!==1&&E?.userHome){const S=E.userHome.fsPath;let P;c.scheme!==E.userHome.scheme&&c.path[0]===f.$fc.sep&&c.path[1]!==f.$fc.sep?P=E.userHome.with({path:c.path}).fsPath:P=m,m=$(P,S,h)}return(h===1?f.$ec:f.$fc).normalize(A(m,h===1))}e.$xv=v;function g(c,l,h){const E=h===1?f.$ec:f.$fc,D=h===3?M.$pg:M.$rg,m=l.getWorkspace(),p=(0,C.$Nb)(m.folders);if(!p)return;c.scheme!==p.uri.scheme&&c.path[0]===f.$fc.sep&&c.path[1]!==f.$fc.sep&&(c=p.uri.with({path:c.path}));const S=l.getWorkspaceFolder(c);if(!S)return;let P;if(D.isEqual(S.uri,c)?P="":P=D.relativePath(S.uri,c)??"",P&&(P=E.normalize(P)),m.folders.length>1&&!l.noPrefix){const z=S.name?S.name:D.basenameOrAuthority(S.uri);P=P?`${z} \u2022 ${P}`:z}return P}function A(c,l=L.$i){return(0,F.$6f)(c,l)?c.charAt(0).toUpperCase()+c.slice(1):c}e.$yv=A;let I=Object.create(null);function $(c,l,h=L.OS){if(h===1||!c||!l)return c;let E=I.original===l?I.normalized:void 0;E||(E=l,L.$i&&(E=(0,F.$Vf)(E)),E=`${(0,b.$Oe)(E,f.$fc.sep)}${f.$fc.sep}`,I={original:l,normalized:E});let D=c;return L.$i&&(D=(0,F.$Vf)(D)),(h===3?D.startsWith(E):(0,b.$7e)(D,E))?`~/${D.substr(E.length)}`:c}e.$zv=$;function y(c,l){return c.replace(/^~($|\/|\\)/,`${l}$1`)}e.$Av=y;const k="\u2026",w="\\\\",u="~";function o(c,l=f.sep){const h=new Array(c.length);let E=!1;for(let D=0;D<c.length;D++){const m=c[D];if(m===""){h[D]=`.${l}`;continue}if(!m){h[D]=m;continue}E=!0;let p="",S=m;S.indexOf(w)===0?(p=S.substr(0,S.indexOf(w)+w.length),S=S.substr(S.indexOf(w)+w.length)):S.indexOf(l)===0?(p=S.substr(0,S.indexOf(l)+l.length),S=S.substr(S.indexOf(l)+l.length)):S.indexOf(u)===0&&(p=S.substr(0,S.indexOf(u)+u.length),S=S.substr(S.indexOf(u)+u.length));const P=S.split(l);for(let z=1;E&&z<=P.length;z++)for(let j=P.length-z;E&&j>=0;j--){E=!1;let R=P.slice(j,j+z).join(l);for(let T=0;!E&&T<c.length;T++)if(T!==D&&c[T]&&c[T].indexOf(R)>-1){const N=j+z===P.length,O=j>0&&c[T].indexOf(l)>-1?l+R:R,W=c[T].endsWith(O);E=!N||W}if(!E){let T="";(P[0].endsWith(":")||p!=="")&&(j===1&&(j=0,z++,R=P[0]+l+R),j>0&&(T=P[0]+l),T=p+T),j>0&&(T=T+k+l),T=T+R,j+z<P.length&&(T=T+l+k),h[D]=T}}E&&(h[D]=m)}return h}e.$Bv=o;var i;(function(c){c[c.TEXT=0]="TEXT",c[c.VARIABLE=1]="VARIABLE",c[c.SEPARATOR=2]="SEPARATOR"})(i||(i={}));function n(c,l=Object.create(null)){const h=[];let E=!1,D="";for(const m of c)if(m==="$"||E&&m==="{")D&&h.push({value:D,type:i.TEXT}),D="",E=!0;else if(m==="}"&&E){const p=l[D];if(typeof p=="string")p.length&&h.push({value:p,type:i.VARIABLE});else if(p){const S=h[h.length-1];(!S||S.type!==i.SEPARATOR)&&h.push({value:p.label,type:i.SEPARATOR})}D="",E=!1}else D+=m;return D&&!E&&h.push({value:D,type:i.TEXT}),h.filter((m,p)=>{if(m.type===i.SEPARATOR){const S=h[p-1],P=h[p+1];return[S,P].every(z=>z&&(z.type===i.VARIABLE||z.type===i.TEXT)&&z.value.length>0)}return!0}).map(m=>m.value).join("")}e.$Cv=n;function r(c,l){return L.$j||l?c.replace(/\(&&\w\)|&&/g,"").replace(/&/g,L.$j?"&":"&&"):c.replace(/&&|&/g,h=>h==="&"?"&&":"&")}e.$Dv=r;function a(c,l){return L.$j||l?c.replace(/\(&&\w\)|&&/g,""):L.$i?c.replace(/&&|&/g,h=>h==="&"?"&&":"&"):c.replace(/&&/g,"_")}e.$Ev=a;function t(c){return c.replace(/&/g,"&&")}e.$Fv=t;function s(c){if(c.endsWith("]")){const l=c.lastIndexOf(" [",c.length-2);if(l!==-1){const h=d(c.substring(0,l));return{name:h.name,parentPath:h.parentPath+c.substring(l)}}}return d(c)}e.$Gv=s;function d(c){const l=c.indexOf("/")!==-1?f.$fc:f.$ec,h=l.basename(c),E=l.dirname(c);return h.length?{name:h,parentPath:E}:{name:E,parentPath:""}}}),define(ke[131],Se([1,0,22,2]),function(me,e,C,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vm=e.$Um=e.$Tm=e.$Sm=e.$Rm=void 0;function f(I){return I.toJSON()}class L{constructor($){this.a=$}transformIncoming($){const y=this.a.transformIncoming($);return y===$?$:f(F.URI.from(y))}transformOutgoing($){const y=this.a.transformOutgoing($);return y===$?$:f(F.URI.from(y))}transformOutgoingURI($){const y=this.a.transformOutgoing($);return y===$?$:F.URI.from(y)}transformOutgoingScheme($){return this.a.transformOutgoingScheme($)}}e.$Rm=L,e.$Sm=new class{transformIncoming(I){return I}transformOutgoing(I){return I}transformOutgoingURI(I){return I}transformOutgoingScheme(I){return I}};function M(I,$,y){if(!I||y>200)return null;if(typeof I=="object"){if(I instanceof F.URI)return $.transformOutgoing(I);for(const k in I)if(Object.hasOwnProperty.call(I,k)){const w=M(I[k],$,y+1);w!==null&&(I[k]=w)}}return null}function b(I,$){const y=M(I,$,0);return y===null?I:y}e.$Tm=b;function v(I,$,y,k){if(!I||k>200)return null;if(typeof I=="object"){if(I.$mid===1)return y?F.URI.revive($.transformIncoming(I)):$.transformIncoming(I);if(I instanceof C.$fe)return null;for(const w in I)if(Object.hasOwnProperty.call(I,w)){const u=v(I[w],$,y,k+1);u!==null&&(I[w]=u)}}return null}function g(I,$){const y=v(I,$,!1,0);return y===null?I:y}e.$Um=g;function A(I,$){const y=v(I,$,!0,0);return y===null?I:y}e.$Vm=A}),define(ke[30],Se([1,0,55,63,385,12,33,76,16,11,23,2]),function(me,e,C,F,f,L,M,b,v,g,A,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.writeFileSync=e.configureFlushOnWrite=e.SymlinkSupport=e.whenDeleted=e.readdirSync=e.rimrafSync=e.RimRafMode=void 0;var $;(function(O){O[O.UNLINK=0]="UNLINK",O[O.MOVE=1]="MOVE"})($||(e.RimRafMode=$={}));async function y(O,W=$.UNLINK,x){if((0,M.$5f)(O))throw new Error("rimraf - will refuse to recursively delete root");return W===$.UNLINK?w(O):k(O,x)}async function k(O,W=(0,M.$0f)((0,F.tmpdir)())){try{try{await C.promises.rename(O,W)}catch(x){return x.code==="ENOENT"?void 0:w(O)}w(W).catch(x=>{})}catch(x){if(x.code!=="ENOENT")throw x}}async function w(O){return(0,f.promisify)(C.rm)(O,{recursive:!0,force:!0,maxRetries:3})}function u(O){if((0,M.$5f)(O))throw new Error("rimraf - will refuse to recursively delete root");C.rmSync(O,{recursive:!0,force:!0,maxRetries:3})}e.rimrafSync=u;async function o(O,W){return r(await(W?i(O):(0,f.promisify)(C.readdir)(O)))}async function i(O){try{return await(0,f.promisify)(C.readdir)(O,{withFileTypes:!0})}catch(le){console.warn("[node.js fs] readdir with filetypes failed with error: ",le)}const W=[],x=await o(O);for(const le of x){let G=!1,J=!1,Q=!1;try{const oe=await e.Promises.lstat((0,v.$ic)(O,le));G=oe.isFile(),J=oe.isDirectory(),Q=oe.isSymbolicLink()}catch(oe){console.warn("[node.js fs] unexpected error from lstat after readdir: ",oe)}W.push({name:le,isFile:()=>G,isDirectory:()=>J,isSymbolicLink:()=>Q})}return W}function n(O){return r(C.readdirSync(O))}e.readdirSync=n;function r(O){return O.map(W=>typeof W=="string"?g.$j?(0,b.$ul)(W):W:(W.name=g.$j?(0,b.$ul)(W.name):W.name,W))}async function a(O){const W=await o(O),x=[];for(const le of W)await s.existsDirectory((0,v.$ic)(O,le))&&x.push(le);return x}function t(O,W=1e3){return new Promise(x=>{let le=!1;const G=setInterval(()=>{le||(le=!0,C.access(O,J=>{le=!1,J&&(clearInterval(G),x(void 0))}))},W)})}e.whenDeleted=t;var s;(function(O){async function W(G){let J;try{if(J=await e.Promises.lstat(G),!J.isSymbolicLink())return{stat:J}}catch{}try{return{stat:await e.Promises.stat(G),symbolicLink:J?.isSymbolicLink()?{dangling:!1}:void 0}}catch(Q){if(Q.code==="ENOENT"&&J)return{stat:J,symbolicLink:{dangling:!0}};if(g.$i&&Q.code==="EACCES")try{return{stat:await e.Promises.stat(await e.Promises.readlink(G)),symbolicLink:{dangling:!1}}}catch(oe){if(oe.code==="ENOENT"&&J)return{stat:J,symbolicLink:{dangling:!0}};throw oe}throw Q}}O.stat=W;async function x(G){try{const{stat:J,symbolicLink:Q}=await O.stat(G);return J.isFile()&&Q?.dangling!==!0}catch{}return!1}O.existsFile=x;async function le(G){try{const{stat:J,symbolicLink:Q}=await O.stat(G);return J.isDirectory()&&Q?.dangling!==!0}catch{}return!1}O.existsDirectory=le})(s||(e.SymlinkSupport=s={}));const d=new L.$7g;function c(O,W,x){return d.queueFor(I.URI.file(O),A.$qg).queue(()=>{const le=m(x);return new Promise((G,J)=>E(O,W,le,Q=>Q?J(Q):G()))})}let l=!0;function h(O){l=O}e.configureFlushOnWrite=h;function E(O,W,x,le){if(!l)return C.writeFile(O,W,{mode:x.mode,flag:x.flag},le);C.open(O,x.flag,x.mode,(G,J)=>{if(G)return le(G);C.writeFile(J,W,Q=>{if(Q)return C.close(J,()=>le(Q));C.fdatasync(J,oe=>(oe&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",oe),h(!1)),C.close(J,_=>le(_))))})})}function D(O,W,x){const le=m(x);if(!l)return C.writeFileSync(O,W,{mode:le.mode,flag:le.flag});const G=C.openSync(O,le.flag,le.mode);try{C.writeFileSync(G,W);try{C.fdatasyncSync(G)}catch(J){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",J),h(!1)}}finally{C.closeSync(G)}}e.writeFileSync=D;function m(O){return O?{mode:typeof O.mode=="number"?O.mode:438,flag:typeof O.flag=="string"?O.flag:"w"}:{mode:438,flag:"w"}}async function p(O,W,x=6e4){if(O!==W)try{g.$i&&typeof x=="number"?await S(O,W,Date.now(),x):await(0,f.promisify)(C.rename)(O,W)}catch(le){if(O.toLowerCase()!==W.toLowerCase()&&le.code==="EXDEV"||O.endsWith("."))await P(O,W,{preserveSymlinks:!1}),await y(O,$.MOVE);else throw le}}async function S(O,W,x,le,G=0){try{return await(0,f.promisify)(C.rename)(O,W)}catch(J){if(J.code!=="EACCES"&&J.code!=="EPERM"&&J.code!=="EBUSY")throw J;if(Date.now()-x>=le)throw console.error(`[node.js fs] rename failed after ${G} retries with error: ${J}`),J;if(G===0){let Q=!1;try{const{stat:oe}=await s.stat(W);oe.isFile()||(Q=!0)}catch{}if(Q)throw J}return await(0,L.$Yg)(Math.min(100,G*10)),S(O,W,x,le,G+1)}}async function P(O,W,x){return j(O,W,{root:{source:O,target:W},options:x,handledSourcePaths:new Set})}const z=511;async function j(O,W,x){if(x.handledSourcePaths.has(O))return;x.handledSourcePaths.add(O);const{stat:le,symbolicLink:G}=await s.stat(O);if(G){if(x.options.preserveSymlinks)try{return await N(O,W,x)}catch(J){console.warn("[node.js fs] copy of symlink failed: ",J)}if(G.dangling)return}return le.isDirectory()?R(O,W,le.mode&z,x):T(O,W,le.mode&z)}async function R(O,W,x,le){await e.Promises.mkdir(W,{recursive:!0,mode:x});const G=await o(O);for(const J of G)await j((0,v.$ic)(O,J),(0,v.$ic)(W,J),le)}async function T(O,W,x){await e.Promises.copyFile(O,W),await e.Promises.chmod(W,x)}async function N(O,W,x){let le=await e.Promises.readlink(O);(0,M.$2f)(le,x.root.source,!g.$k)&&(le=(0,v.$ic)(x.root.target,le.substr(x.root.source.length+1))),await e.Promises.symlink(le,W)}e.Promises=new class{get access(){return(0,f.promisify)(C.access)}get stat(){return(0,f.promisify)(C.stat)}get lstat(){return(0,f.promisify)(C.lstat)}get utimes(){return(0,f.promisify)(C.utimes)}get read(){return(O,W,x,le,G)=>new Promise((J,Q)=>{C.read(O,W,x,le,G,(oe,_,Ee)=>oe?Q(oe):J({bytesRead:_,buffer:Ee}))})}get readFile(){return(0,f.promisify)(C.readFile)}get write(){return(O,W,x,le,G)=>new Promise((J,Q)=>{C.write(O,W,x,le,G,(oe,_,Ee)=>oe?Q(oe):J({bytesWritten:_,buffer:Ee}))})}get appendFile(){return(0,f.promisify)(C.appendFile)}get fdatasync(){return(0,f.promisify)(C.fdatasync)}get truncate(){return(0,f.promisify)(C.truncate)}get copyFile(){return(0,f.promisify)(C.copyFile)}get open(){return(0,f.promisify)(C.open)}get close(){return(0,f.promisify)(C.close)}get symlink(){return(0,f.promisify)(C.symlink)}get readlink(){return(0,f.promisify)(C.readlink)}get chmod(){return(0,f.promisify)(C.chmod)}get mkdir(){return(0,f.promisify)(C.mkdir)}get unlink(){return(0,f.promisify)(C.unlink)}get rmdir(){return(0,f.promisify)(C.rmdir)}get realpath(){return(0,f.promisify)(C.realpath)}async exists(O){try{return await e.Promises.access(O),!0}catch{return!1}}get readdir(){return o}get readDirsInDir(){return a}get writeFile(){return c}get rm(){return y}get rename(){return p}get copy(){return P}}}),define(ke[103],Se([1,0,55,16,11,13,30]),function(me,e,C,F,f,L,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bq=e.$aq=e.$_p=e.$$p=void 0;function b($){if(f.$k)return $;const y=(0,F.$lc)($);if($===y)return $;const k=((0,F.$mc)($)||$).toLowerCase();try{const u=(0,M.readdirSync)(y).filter(o=>o.toLowerCase()===k);if(u.length===1){const o=b(y);if(o)return(0,F.$ic)(o,u[0])}else if(u.length>1){const o=u.indexOf(k);if(o>=0){const i=b(y);if(i)return(0,F.$ic)(i,u[o])}}}catch{}return null}e.$$p=b;async function v($){if(f.$k)return $;const y=(0,F.$lc)($);if($===y)return $;const k=((0,F.$mc)($)||$).toLowerCase();try{const u=(await M.Promises.readdir(y)).filter(o=>o.toLowerCase()===k);if(u.length===1){const o=await v(y);if(o)return(0,F.$ic)(o,u[0])}else if(u.length>1){const o=u.indexOf(k);if(o>=0){const i=await v(y);if(i)return(0,F.$ic)(i,u[o])}}}catch{}return null}e.$_p=v;async function g($){try{return await M.Promises.realpath($)}catch{const k=I($);return await M.Promises.access(k,C.constants.R_OK),k}}e.$aq=g;function A($){try{return C.realpathSync($)}catch{const k=I($);return C.accessSync(k,C.constants.R_OK),k}}e.$bq=A;function I($){return(0,L.$Oe)((0,F.$gc)($),F.sep)}}),define(ke[104],Se([1,0,16,11,49,101,18,30]),function(me,e,C,F,f,L,M,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.$Il=e.$Hl=e.TerminateResponseCode=e.Source=void 0,Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return L.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return L.TerminateResponseCode}});function v(I=f.env){return I.comspec||"cmd.exe"}e.$Hl=v;function g(I){let $=[],y=!1;const k=function(w){if(y){$.push(w);return}(!I.send(w,o=>{if(o&&console.error(o),y=!1,$.length>0){const i=$.slice(0);$=[],i.forEach(n=>k(n))}})||F.$i)&&(y=!0)};return{send:k}}e.$Il=g;var A;(function(I){async function $(y,k,w){if(C.$hc(y))return y;if(k===void 0&&(k=f.cwd()),C.$lc(y)!=="."||(w===void 0&&M.$Cf(f.env.PATH)&&(w=f.env.PATH.split(C.$sc)),w===void 0||w.length===0))return C.$ic(k,y);async function o(i){if(await b.Promises.exists(i)){let n;try{n=await b.Promises.stat(i)}catch(r){r.message.startsWith("EACCES")&&(n=await b.Promises.lstat(i))}return n?!n.isDirectory():!1}return!1}for(const i of w){let n;if(C.$hc(i)?n=C.$ic(i,y):n=C.$ic(k,i,y),await o(n))return n;let r=n+".com";if(await o(r)||(r=n+".exe",await o(r)))return r}return C.$ic(k,y)}I.findExecutable=$})(A||(e.win32=A={}))});var He=this&&this.__decorate||function(me,e,C,F){var f=arguments.length,L=f<3?e:F===null?F=Object.getOwnPropertyDescriptor(e,C):F,M;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")L=Reflect.decorate(me,e,C,F);else for(var b=me.length-1;b>=0;b--)(M=me[b])&&(L=(f<3?M(L):f>3?M(e,C,L):M(e,C))||L);return f>3&&L&&Object.defineProperty(e,C,L),L};define(ke[81],Se([1,0,19,12,22,21,59,8,4,3,54,13,18]),function(me,e,C,F,f,L,M,b,v,g,A,I,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Eh=e.ProxyChannel=e.$Dh=e.$Ch=e.$Bh=e.$Ah=e.$zh=e.$yh=e.RequestInitiator=e.$xh=e.$wh=e.$vh=e.$uh=e.$th=void 0;var y;(function(G){G[G.Promise=100]="Promise",G[G.PromiseCancel=101]="PromiseCancel",G[G.EventListen=102]="EventListen",G[G.EventDispose=103]="EventDispose"})(y||(y={}));function k(G){switch(G){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var w;(function(G){G[G.Initialize=200]="Initialize",G[G.PromiseSuccess=201]="PromiseSuccess",G[G.PromiseError=202]="PromiseError",G[G.PromiseErrorObj=203]="PromiseErrorObj",G[G.EventFire=204]="EventFire"})(w||(w={}));function u(G){switch(G){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var o;(function(G){G[G.Uninitialized=0]="Uninitialized",G[G.Idle=1]="Idle"})(o||(o={}));function i(G){let J=0;for(let Q=0;;Q+=7){const oe=G.read(1);if(J|=(oe.buffer[0]&127)<<Q,!(oe.buffer[0]&128))return J}}const n=d(0);function r(G,J){if(J===0){G.write(n);return}let Q=0;for(let _=J;_!==0;_=_>>>7)Q++;const oe=f.$fe.alloc(Q);for(let _=0;J!==0;_++)oe.buffer[_]=J&127,J=J>>>7,J>0&&(oe.buffer[_]|=128);G.write(oe)}class a{constructor(J){this.b=J,this.a=0}read(J){const Q=this.b.slice(this.a,this.a+J);return this.a+=Q.byteLength,Q}}e.$th=a;class t{constructor(){this.a=[]}get buffer(){return f.$fe.concat(this.a)}write(J){this.a.push(J)}}e.$uh=t;var s;(function(G){G[G.Undefined=0]="Undefined",G[G.String=1]="String",G[G.Buffer=2]="Buffer",G[G.VSBuffer=3]="VSBuffer",G[G.Array=4]="Array",G[G.Object=5]="Object",G[G.Int=6]="Int"})(s||(s={}));function d(G){const J=f.$fe.alloc(1);return J.writeUInt8(G,0),J}const c={Undefined:d(s.Undefined),String:d(s.String),Buffer:d(s.Buffer),VSBuffer:d(s.VSBuffer),Array:d(s.Array),Object:d(s.Object),Uint:d(s.Int)},l=typeof Buffer<"u";function h(G,J){if(typeof J>"u")G.write(c.Undefined);else if(typeof J=="string"){const Q=f.$fe.fromString(J);G.write(c.String),r(G,Q.byteLength),G.write(Q)}else if(l&&Buffer.isBuffer(J)){const Q=f.$fe.wrap(J);G.write(c.Buffer),r(G,Q.byteLength),G.write(Q)}else if(J instanceof f.$fe)G.write(c.VSBuffer),r(G,J.byteLength),G.write(J);else if(Array.isArray(J)){G.write(c.Array),r(G,J.length);for(const Q of J)h(G,Q)}else if(typeof J=="number"&&(J|0)===J)G.write(c.Uint),r(G,J);else{const Q=f.$fe.fromString(JSON.stringify(J));G.write(c.Object),r(G,Q.byteLength),G.write(Q)}}e.$vh=h;function E(G){switch(G.read(1).readUInt8(0)){case s.Undefined:return;case s.String:return G.read(i(G)).toString();case s.Buffer:return G.read(i(G)).buffer;case s.VSBuffer:return G.read(i(G));case s.Array:{const Q=i(G),oe=[];for(let _=0;_<Q;_++)oe.push(E(G));return oe}case s.Object:return JSON.parse(G.read(i(G)).toString());case s.Int:return i(G)}}e.$wh=E;class D{constructor(J,Q,oe=null,_=1e3){this.h=J,this.j=Q,this.k=oe,this.l=_,this.b=new Map,this.d=new Map,this.g=new Map,this.f=this.h.onMessage(Ee=>this.q(Ee)),this.m({type:200})}registerChannel(J,Q){this.b.set(J,Q),setTimeout(()=>this.w(J),0)}m(J){switch(J.type){case 200:{const Q=this.o([J.type]);this.k?.logOutgoing(Q,0,1,u(J.type));return}case 201:case 202:case 204:case 203:{const Q=this.o([J.type,J.id],J.data);this.k?.logOutgoing(Q,J.id,1,u(J.type),J.data);return}}}o(J,Q=void 0){const oe=new t;return h(oe,J),h(oe,Q),this.p(oe.buffer)}p(J){try{return this.h.send(J),J.byteLength}catch{return 0}}q(J){const Q=new a(J),oe=E(Q),_=E(Q),Ee=oe[0];switch(Ee){case 100:return this.k?.logIncoming(J.byteLength,oe[1],1,`${k(Ee)}: ${oe[2]}.${oe[3]}`,_),this.s({type:Ee,id:oe[1],channelName:oe[2],name:oe[3],arg:_});case 102:return this.k?.logIncoming(J.byteLength,oe[1],1,`${k(Ee)}: ${oe[2]}.${oe[3]}`,_),this.t({type:Ee,id:oe[1],channelName:oe[2],name:oe[3],arg:_});case 101:return this.k?.logIncoming(J.byteLength,oe[1],1,`${k(Ee)}`),this.u({type:Ee,id:oe[1]});case 103:return this.k?.logIncoming(J.byteLength,oe[1],1,`${k(Ee)}`),this.u({type:Ee,id:oe[1]})}}s(J){const Q=this.b.get(J.channelName);if(!Q){this.v(J);return}const oe=new L.$2d;let _;try{_=Q.call(this.j,J.name,J.arg,oe.token)}catch(q){_=Promise.reject(q)}const Ee=J.id;_.then(q=>{this.m({id:Ee,data:q,type:201})},q=>{q instanceof Error?this.m({id:Ee,data:{message:q.message,name:q.name,stack:q.stack?q.stack.split?q.stack.split(`
`):q.stack:void 0},type:202}):this.m({id:Ee,data:q,type:203})}).finally(()=>{he.dispose(),this.d.delete(J.id)});const he=(0,g.$Pc)(()=>oe.cancel());this.d.set(J.id,he)}t(J){const Q=this.b.get(J.channelName);if(!Q){this.v(J);return}const oe=J.id,Ee=Q.listen(this.j,J.name,J.arg)(he=>this.m({id:oe,data:he,type:204}));this.d.set(J.id,Ee)}u(J){const Q=this.d.get(J.id);Q&&(Q.dispose(),this.d.delete(J.id))}v(J){let Q=this.g.get(J.channelName);Q||(Q=[],this.g.set(J.channelName,Q));const oe=setTimeout(()=>{console.error(`Unknown channel: ${J.channelName}`),J.type===100&&this.m({id:J.id,data:{name:"Unknown channel",message:`Channel name '${J.channelName}' timed out after ${this.l}ms`,stack:void 0},type:202})},this.l);Q.push({request:J,timeoutTimer:oe})}w(J){const Q=this.g.get(J);if(Q){for(const oe of Q)switch(clearTimeout(oe.timeoutTimer),oe.request.type){case 100:this.s(oe.request);break;case 102:this.t(oe.request);break}this.g.delete(J)}}dispose(){this.f&&(this.f.dispose(),this.f=null),(0,g.$Mc)(this.d.values()),this.d.clear()}}e.$xh=D;var m;(function(G){G[G.LocalSide=0]="LocalSide",G[G.OtherSide=1]="OtherSide"})(m||(e.RequestInitiator=m={}));class p{constructor(J,Q=null){this.l=J,this.a=!1,this.b=o.Uninitialized,this.d=new Set,this.f=new Map,this.g=0,this.k=new v.$Rd,this.onDidInitialize=this.k.event,this.h=this.l.onMessage(oe=>this.s(oe)),this.j=Q}getChannel(J){const Q=this;return{call(oe,_,Ee){return Q.a?Promise.reject(new b.$4):Q.m(J,oe,_,Ee)},listen(oe,_){return Q.a?v.Event.None:Q.o(J,oe,_)}}}m(J,Q,oe,_=L.CancellationToken.None){const Ee=this.g++,q={id:Ee,type:100,channelName:J,name:Q,arg:oe};if(_.isCancellationRequested)return Promise.reject(new b.$4);let U;return new Promise((be,H)=>{if(_.isCancellationRequested)return H(new b.$4);const Y=()=>{const fe=te=>{switch(te.type){case 201:this.f.delete(Ee),be(te.data);break;case 202:{this.f.delete(Ee);const de=new Error(te.data.message);de.stack=Array.isArray(te.data.stack)?te.data.stack.join(`
`):te.data.stack,de.name=te.data.name,H(de);break}case 203:this.f.delete(Ee),H(te.data);break}};this.f.set(Ee,fe),this.p(q)};let Z=null;this.b===o.Idle?Y():(Z=(0,F.$Lg)(fe=>this.u()),Z.then(()=>{Z=null,Y()}));const $e=()=>{Z?(Z.cancel(),Z=null):this.p({id:Ee,type:101}),H(new b.$4)},ne=_.onCancellationRequested($e);U=(0,g.$Oc)((0,g.$Pc)($e),ne),this.d.add(U)}).finally(()=>{U.dispose(),this.d.delete(U)})}o(J,Q,oe){const _=this.g++,he={id:_,type:102,channelName:J,name:Q,arg:oe};let q=null;const U=new v.$Rd({onWillAddFirstListener:()=>{q=(0,F.$Lg)(be=>this.u()),q.then(()=>{q=null,this.d.add(U),this.p(he)})},onDidRemoveLastListener:()=>{q?(q.cancel(),q=null):(this.d.delete(U),this.p({id:_,type:103}))}}),ie=be=>U.fire(be.data);return this.f.set(_,ie),U.event}p(J){switch(J.type){case 100:case 102:{const Q=this.q([J.type,J.id,J.channelName,J.name],J.arg);this.j?.logOutgoing(Q,J.id,0,`${k(J.type)}: ${J.channelName}.${J.name}`,J.arg);return}case 101:case 103:{const Q=this.q([J.type,J.id]);this.j?.logOutgoing(Q,J.id,0,k(J.type));return}}}q(J,Q=void 0){const oe=new t;return h(oe,J),h(oe,Q),this.r(oe.buffer)}r(J){try{return this.l.send(J),J.byteLength}catch{return 0}}s(J){const Q=new a(J),oe=E(Q),_=E(Q),Ee=oe[0];switch(Ee){case 200:return this.j?.logIncoming(J.byteLength,0,0,u(Ee)),this.t({type:oe[0]});case 201:case 202:case 204:case 203:return this.j?.logIncoming(J.byteLength,oe[1],0,u(Ee),_),this.t({type:oe[0],id:oe[1],data:_})}}t(J){if(J.type===200){this.b=o.Idle,this.k.fire();return}this.f.get(J.id)?.(J)}get onDidInitializePromise(){return v.Event.toPromise(this.onDidInitialize)}u(){return this.b===o.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.a=!0,this.h&&(this.h.dispose(),this.h=null),(0,g.$Mc)(this.d.values()),this.d.clear()}}e.$yh=p,He([M.$nh],p.prototype,"onDidInitializePromise",null);class S{get connections(){const J=[];return this.f.forEach(Q=>J.push(Q)),J}constructor(J){this.a=new Map,this.f=new Set,this.g=new v.$Rd,this.onDidAddConnection=this.g.event,this.h=new v.$Rd,this.onDidRemoveConnection=this.h.event,this.j=new g.$Qc,this.j.add(J(({protocol:Q,onDidClientDisconnect:oe})=>{const _=v.Event.once(Q.onMessage);this.j.add(_(Ee=>{const he=new a(Ee),q=E(he),U=new D(Q,q),ie=new p(Q);this.a.forEach((H,Y)=>U.registerChannel(Y,H));const be={channelServer:U,channelClient:ie,ctx:q};this.f.add(be),this.g.fire(be),this.j.add(oe(()=>{U.dispose(),ie.dispose(),this.f.delete(be),this.h.fire(be)}))}))}))}getChannel(J,Q){const oe=this;return{call(_,Ee,he){let q;if((0,$.$Qf)(Q)){const ie=(0,C.$3b)(oe.connections.filter(Q));q=ie?Promise.resolve(ie):v.Event.toPromise(v.Event.filter(oe.onDidAddConnection,Q))}else q=Q.routeCall(oe,_,Ee);const U=q.then(ie=>ie.channelClient.getChannel(J));return z(U).call(_,Ee,he)},listen(_,Ee){if((0,$.$Qf)(Q))return oe.k(J,Q,_,Ee);const he=Q.routeEvent(oe,_,Ee).then(q=>q.channelClient.getChannel(J));return z(he).listen(_,Ee)}}}k(J,Q,oe,_){const Ee=this;let he;const q=new v.$Rd({onWillAddFirstListener:()=>{he=new g.$Qc;const U=new v.$Xd,ie=new Map,be=Y=>{const $e=Y.channelClient.getChannel(J).listen(oe,_),ne=U.add($e);ie.set(Y,ne)},H=Y=>{const Z=ie.get(Y);Z&&(Z.dispose(),ie.delete(Y))};Ee.connections.filter(Q).forEach(be),v.Event.filter(Ee.onDidAddConnection,Q)(be,void 0,he),Ee.onDidRemoveConnection(H,void 0,he),U.event(q.fire,q,he),he.add(U)},onDidRemoveLastListener:()=>{he?.dispose(),he=void 0}});return q.event}registerChannel(J,Q){this.a.set(J,Q);for(const oe of this.f)oe.channelServer.registerChannel(J,Q)}dispose(){this.j.dispose();for(const J of this.f)J.channelClient.dispose(),J.channelServer.dispose();this.f.clear(),this.a.clear(),this.g.dispose(),this.h.dispose()}}e.$zh=S;class P{constructor(J,Q,oe=null){const _=new t;h(_,Q),J.send(_.buffer),this.a=new p(J,oe),this.d=new D(J,Q,oe)}getChannel(J){return this.a.getChannel(J)}registerChannel(J,Q){this.d.registerChannel(J,Q)}dispose(){this.a.dispose(),this.d.dispose()}}e.$Ah=P;function z(G){return{call(J,Q,oe){return G.then(_=>_.call(J,Q,oe))},listen(J,Q){const oe=new v.$1d;return G.then(_=>oe.input=_.listen(J,Q)),oe.event}}}e.$Bh=z;function j(G){let J=!1;return{call(Q,oe,_){return J?G.call(Q,oe,_):(0,F.$Yg)(0).then(()=>J=!0).then(()=>G.call(Q,oe,_))},listen(Q,oe){if(J)return G.listen(Q,oe);const _=new v.$1d;return(0,F.$Yg)(0).then(()=>J=!0).then(()=>_.input=G.listen(Q,oe)),_.event}}}e.$Ch=j;class R{constructor(J){this.a=J}routeCall(J){return this.b(J)}routeEvent(J){return this.b(J)}async b(J){for(const Q of J.connections)if(await Promise.resolve(this.a(Q.ctx)))return Promise.resolve(Q);return await v.Event.toPromise(J.onDidAddConnection),await this.b(J)}}e.$Dh=R;var T;(function(G){function J(Ee,he,q){const U=Ee,ie=q&&q.disableMarshalling,be=new Map;for(const H in U)oe(H)&&be.set(H,v.Event.buffer(U[H],!0,void 0,he));return new class{listen(H,Y,Z){const $e=be.get(Y);if($e)return $e;if(_(Y)){const ne=U[Y];if(typeof ne=="function")return ne.call(U,Z)}throw new b.$ab(`Event not found: ${Y}`)}call(H,Y,Z){const $e=U[Y];if(typeof $e=="function"){if(!ie&&Array.isArray(Z))for(let fe=0;fe<Z.length;fe++)Z[fe]=(0,A.$sh)(Z[fe]);let ne=$e.apply(U,Z);return ne instanceof Promise||(ne=Promise.resolve(ne)),ne}throw new b.$ab(`Method not found: ${Y}`)}}}G.fromService=J;function Q(Ee,he){const q=he&&he.disableMarshalling;return new Proxy({},{get(U,ie){if(typeof ie=="string")return he?.properties?.has(ie)?he.properties.get(ie):_(ie)?function(be){return Ee.listen(ie,be)}:oe(ie)?Ee.listen(ie):async function(...be){let H;he&&!(0,$.$Lf)(he.context)?H=[he.context,...be]:H=be;const Y=await Ee.call(ie,H);return q?Y:(0,A.$sh)(Y)};throw new b.$ab(`Property not found: ${String(ie)}`)}})}G.toService=Q;function oe(Ee){return Ee[0]==="o"&&Ee[1]==="n"&&I.$5e(Ee.charCodeAt(2))}function _(Ee){return/^onDynamic/.test(Ee)&&I.$5e(Ee.charCodeAt(9))}})(T||(e.ProxyChannel=T={}));const N=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function O(G){if(Array.isArray(G))return G;if(G&&typeof G=="object"&&typeof G.toString=="function"){const J=G.toString();if(J!=="[object Object]")return J}return G}function W(G){return Array.isArray(G)?G.map(O):O(G)}function x(G,J,Q,oe,_,Ee,he){he=W(he);const q=N[_],U=q[oe%q.length];let ie=[`%c[${G}]%c[${String(J).padStart(7," ")}]%c[len: ${String(Q).padStart(5," ")}]%c${String(oe).padStart(5," ")} - ${Ee}`,"color: darkgreen","color: grey","color: grey",`color: ${U}`];/\($/.test(Ee)?(ie=ie.concat(he),ie.push(")")):ie.push(he),console.log.apply(console,ie)}class le{constructor(J,Q){this.d=J,this.f=Q,this.a=0,this.b=0}logOutgoing(J,Q,oe,_,Ee){this.b+=J,x(this.d,this.b,J,Q,oe,_,Ee)}logIncoming(J,Q,oe,_,Ee){this.a+=J,x(this.f,this.a,J,Q,oe,_,Ee)}}e.$Eh=le}),define(ke[82],Se([1,0,22,4,3,81]),function(me,e,C,F,f,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jh=e.$Ih=e.$Hh=e.$Gh=e.ProtocolConstants=e.$Fh=e.SocketCloseEventType=e.SocketDiagnostics=e.SocketDiagnosticsEventType=void 0;var M;(function(c){c.Created="created",c.Read="read",c.Write="write",c.Open="open",c.Error="error",c.Close="close",c.BrowserWebSocketBlobReceived="browserWebSocketBlobReceived",c.NodeEndReceived="nodeEndReceived",c.NodeEndSent="nodeEndSent",c.NodeDrainBegin="nodeDrainBegin",c.NodeDrainEnd="nodeDrainEnd",c.zlibInflateError="zlibInflateError",c.zlibInflateData="zlibInflateData",c.zlibInflateInitialWrite="zlibInflateInitialWrite",c.zlibInflateInitialFlushFired="zlibInflateInitialFlushFired",c.zlibInflateWrite="zlibInflateWrite",c.zlibInflateFlushFired="zlibInflateFlushFired",c.zlibDeflateError="zlibDeflateError",c.zlibDeflateData="zlibDeflateData",c.zlibDeflateWrite="zlibDeflateWrite",c.zlibDeflateFlushFired="zlibDeflateFlushFired",c.WebSocketNodeSocketWrite="webSocketNodeSocketWrite",c.WebSocketNodeSocketPeekedHeader="webSocketNodeSocketPeekedHeader",c.WebSocketNodeSocketReadHeader="webSocketNodeSocketReadHeader",c.WebSocketNodeSocketReadData="webSocketNodeSocketReadData",c.WebSocketNodeSocketUnmaskedData="webSocketNodeSocketUnmaskedData",c.WebSocketNodeSocketDrainBegin="webSocketNodeSocketDrainBegin",c.WebSocketNodeSocketDrainEnd="webSocketNodeSocketDrainEnd",c.ProtocolHeaderRead="protocolHeaderRead",c.ProtocolMessageRead="protocolMessageRead",c.ProtocolHeaderWrite="protocolHeaderWrite",c.ProtocolMessageWrite="protocolMessageWrite",c.ProtocolWrite="protocolWrite"})(M||(e.SocketDiagnosticsEventType=M={}));var b;(function(c){c.enableDiagnostics=!1,c.records=[];const l=new WeakMap;let h=0;function E(m,p){if(!l.has(m)){const S=String(++h);l.set(m,S)}return l.get(m)}function D(m,p,S,P){if(!c.enableDiagnostics)return;const z=E(m,p);if(P instanceof C.$fe||P instanceof Uint8Array||P instanceof ArrayBuffer||ArrayBuffer.isView(P)){const j=C.$fe.alloc(P.byteLength);j.set(P),c.records.push({timestamp:Date.now(),id:z,label:p,type:S,buff:j})}else c.records.push({timestamp:Date.now(),id:z,label:p,type:S,data:P})}c.traceSocketEvent=D})(b||(e.SocketDiagnostics=b={}));var v;(function(c){c[c.NodeSocketCloseEvent=0]="NodeSocketCloseEvent",c[c.WebSocketCloseEvent=1]="WebSocketCloseEvent"})(v||(e.SocketCloseEventType=v={}));let g=null;function A(){return g||(g=C.$fe.alloc(0)),g}class I{get byteLength(){return this.b}constructor(){this.a=[],this.b=0}acceptChunk(l){this.a.push(l),this.b+=l.byteLength}read(l){return this.c(l,!0)}peek(l){return this.c(l,!1)}c(l,h){if(l===0)return A();if(l>this.b)throw new Error("Cannot read so many bytes!");if(this.a[0].byteLength===l){const p=this.a[0];return h&&(this.a.shift(),this.b-=l),p}if(this.a[0].byteLength>l){const p=this.a[0].slice(0,l);return h&&(this.a[0]=this.a[0].slice(l),this.b-=l),p}const E=C.$fe.alloc(l);let D=0,m=0;for(;l>0;){const p=this.a[m];if(p.byteLength>l){const S=p.slice(0,l);E.set(S,D),D+=l,h&&(this.a[m]=p.slice(l),this.b-=l),l-=l}else E.set(p,D),D+=p.byteLength,h?(this.a.shift(),this.b-=p.byteLength):m++,l-=p.byteLength}return E}}e.$Fh=I;var $;(function(c){c[c.None=0]="None",c[c.Regular=1]="Regular",c[c.Control=2]="Control",c[c.Ack=3]="Ack",c[c.Disconnect=5]="Disconnect",c[c.ReplayRequest=6]="ReplayRequest",c[c.Pause=7]="Pause",c[c.Resume=8]="Resume",c[c.KeepAlive=9]="KeepAlive"})($||($={}));function y(c){switch(c){case 0:return"None";case 1:return"Regular";case 2:return"Control";case 3:return"Ack";case 5:return"Disconnect";case 6:return"ReplayRequest";case 7:return"PauseWriting";case 8:return"ResumeWriting";case 9:return"KeepAlive"}}var k;(function(c){c[c.HeaderLength=13]="HeaderLength",c[c.AcknowledgeTime=2e3]="AcknowledgeTime",c[c.TimeoutTime=2e4]="TimeoutTime",c[c.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",c[c.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime",c[c.KeepAliveSendTime=5e3]="KeepAliveSendTime"})(k||(e.ProtocolConstants=k={}));class w{constructor(l,h,E,D){this.type=l,this.id=h,this.ack=E,this.data=D,this.writtenTime=0}get size(){return this.data.byteLength}}class u extends f.$Rc{constructor(l){super(),this.f=this.B(new F.$Rd),this.onMessage=this.f.event,this.g={readHead:!0,readLen:13,messageType:0,id:0,ack:0},this.a=l,this.b=!1,this.c=new I,this.B(this.a.onData(h=>this.acceptChunk(h))),this.lastReadTime=Date.now()}acceptChunk(l){if(!(!l||l.byteLength===0))for(this.lastReadTime=Date.now(),this.c.acceptChunk(l);this.c.byteLength>=this.g.readLen;){const h=this.c.read(this.g.readLen);if(this.g.readHead)this.g.readHead=!1,this.g.readLen=h.readUInt32BE(9),this.g.messageType=h.readUInt8(0),this.g.id=h.readUInt32BE(1),this.g.ack=h.readUInt32BE(5),this.a.traceSocketEvent("protocolHeaderRead",{messageType:y(this.g.messageType),id:this.g.id,ack:this.g.ack,messageSize:this.g.readLen});else{const E=this.g.messageType,D=this.g.id,m=this.g.ack;if(this.g.readHead=!0,this.g.readLen=13,this.g.messageType=0,this.g.id=0,this.g.ack=0,this.a.traceSocketEvent("protocolMessageRead",h),this.f.fire(new w(E,D,m,h)),this.b)break}}}readEntireBuffer(){return this.c.read(this.c.byteLength)}dispose(){this.b=!0,super.dispose()}}class o{constructor(l){this.k=null,this.a=!1,this.b=!1,this.c=l,this.d=[],this.f=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch{}this.a=!0}drain(){return this.flush(),this.c.drain()}flush(){this.m()}pause(){this.b=!0}resume(){this.b=!1,this.l()}write(l){if(this.a)return;l.writtenTime=Date.now(),this.lastWriteTime=Date.now();const h=C.$fe.alloc(13);h.writeUInt8(l.type,0),h.writeUInt32BE(l.id,1),h.writeUInt32BE(l.ack,5),h.writeUInt32BE(l.data.byteLength,9),this.c.traceSocketEvent("protocolHeaderWrite",{messageType:y(l.type),id:l.id,ack:l.ack,messageSize:l.data.byteLength}),this.c.traceSocketEvent("protocolMessageWrite",l.data),this.j(h,l.data)}g(l,h){const E=this.f===0;return this.d.push(l,h),this.f+=l.byteLength+h.byteLength,E}h(){const l=C.$fe.concat(this.d,this.f);return this.d.length=0,this.f=0,l}j(l,h){this.g(l,h)&&this.l()}l(){this.k||(this.k=setTimeout(()=>{this.k=null,this.m()}))}m(){if(this.f===0||this.b)return;const l=this.h();this.c.traceSocketEvent("protocolWrite",{byteLength:l.byteLength}),this.c.write(l)}}class i extends f.$Rc{constructor(l){super(),this.f=new F.$Rd,this.onMessage=this.f.event,this.g=new F.$Rd,this.onDidDispose=this.g.event,this.a=l,this.b=this.B(new o(this.a)),this.c=this.B(new u(this.a)),this.B(this.c.onMessage(h=>{h.type===1&&this.f.fire(h.data)})),this.B(this.a.onClose(()=>this.g.fire()))}drain(){return this.b.drain()}getSocket(){return this.a}sendDisconnect(){}send(l){this.b.write(new w(1,0,0,l))}}e.$Gh=i;class n extends L.$Ah{static fromSocket(l,h){return new n(new i(l),h)}get onDidDispose(){return this.b.onDidDispose}constructor(l,h,E=null){super(l,h,E),this.b=l}dispose(){super.dispose();const l=this.b.getSocket();this.b.sendDisconnect(),this.b.dispose(),l.end()}}e.$Hh=n;class r{constructor(){this.b=!1,this.c=!1,this.d=[],this.a=new F.$Rd({onWillAddFirstListener:()=>{this.b=!0,queueMicrotask(()=>this.f())},onDidRemoveLastListener:()=>{this.b=!1}}),this.event=this.a.event}f(){if(!this.c){for(this.c=!0;this.b&&this.d.length>0;)this.a.fire(this.d.shift());this.c=!1}}fire(l){this.b?this.d.length>0?this.d.push(l):this.a.fire(l):this.d.push(l)}flushBuffer(){this.d=[]}}e.$Ih=r;class a{constructor(l){this.data=l,this.next=null}}class t{constructor(){this.a=null,this.b=null}length(){let l=0,h=this.a;for(;h;)h=h.next,l++;return l}peek(){return this.a?this.a.data:null}toArray(){const l=[];let h=0,E=this.a;for(;E;)l[h++]=E.data,E=E.next;return l}pop(){if(this.a){if(this.a===this.b){this.a=null,this.b=null;return}this.a=this.a.next}}push(l){const h=new a(l);if(!this.a){this.a=h,this.b=h;return}this.b.next=h,this.b=h}}class s{static{this.a=10}static{this.b=null}static getInstance(){return s.b||(s.b=new s),s.b}constructor(){this.c=[];const l=Date.now();for(let h=0;h<s.a;h++)this.c[h]=l-1e3*h;setInterval(()=>{for(let h=s.a;h>=1;h--)this.c[h]=this.c[h-1];this.c[0]=Date.now()},1e3)}d(){const l=Date.now(),h=(1+s.a)*1e3;let E=0;for(let D=0;D<s.a;D++)l-this.c[D]<=h&&E++;return 1-E/s.a}hasHighLoad(){return this.d()>=.5}}class d{get unacknowledgedCount(){return this.c-this.d}constructor(l){this.u=new r,this.onControlMessage=this.u.event,this.v=new r,this.onMessage=this.v.event,this.w=new r,this.onDidDispose=this.w.event,this.x=new r,this.onSocketClose=this.x.event,this.y=new r,this.onSocketTimeout=this.y.event,this.s=l.loadEstimator??s.getInstance(),this.t=l.sendKeepAlive??!0,this.a=!1,this.b=new t,this.c=0,this.d=0,this.f=null,this.g=0,this.h=0,this.j=0,this.k=null,this.m=0,this.n=Date.now(),this.r=new f.$Qc,this.o=l.socket,this.p=this.r.add(new o(this.o)),this.q=this.r.add(new u(this.o)),this.r.add(this.q.onMessage(h=>this.z(h))),this.r.add(this.o.onClose(h=>this.x.fire(h))),l.initialChunk&&this.q.acceptChunk(l.initialChunk),this.t?this.l=setInterval(()=>{this.D()},5e3):this.l=null}dispose(){this.f&&(clearTimeout(this.f),this.f=null),this.k&&(clearTimeout(this.k),this.k=null),this.l&&(clearInterval(this.l),this.l=null),this.r.dispose()}drain(){return this.p.drain()}sendDisconnect(){const l=new w(5,0,0,A());this.p.write(l),this.p.flush()}sendPause(){const l=new w(7,0,0,A());this.p.write(l)}sendResume(){const l=new w(8,0,0,A());this.p.write(l)}pauseSocketWriting(){this.p.pause()}getSocket(){return this.o}getMillisSinceLastIncomingData(){return Date.now()-this.q.lastReadTime}beginAcceptReconnection(l,h){this.a=!0,this.r.dispose(),this.r=new f.$Qc,this.u.flushBuffer(),this.x.flushBuffer(),this.y.flushBuffer(),this.o.dispose(),this.m=0,this.n=Date.now(),this.o=l,this.p=this.r.add(new o(this.o)),this.q=this.r.add(new u(this.o)),this.r.add(this.q.onMessage(E=>this.z(E))),this.r.add(this.o.onClose(E=>this.x.fire(E))),this.q.acceptChunk(h)}endAcceptReconnection(){this.a=!1,this.h=this.g;const l=new w(3,0,this.h,A());this.p.write(l);const h=this.b.toArray();for(let E=0,D=h.length;E<D;E++)this.p.write(h[E]);this.B()}acceptDisconnect(){this.w.fire()}z(l){if(l.ack>this.d){this.d=l.ack;do{const h=this.b.peek();if(h&&h.id<=l.ack)this.b.pop();else break}while(!0)}switch(l.type){case 0:break;case 1:{if(l.id>this.g)if(l.id!==this.g+1){const h=Date.now();h-this.m>1e4&&(this.m=h,this.p.write(new w(6,0,0,A())))}else this.g=l.id,this.j=Date.now(),this.A(),this.v.fire(l.data);break}case 2:{this.u.fire(l.data);break}case 3:break;case 5:{this.w.fire();break}case 6:{const h=this.b.toArray();for(let E=0,D=h.length;E<D;E++)this.p.write(h[E]);this.B();break}case 7:{this.p.pause();break}case 8:{this.p.resume();break}case 9:break}}readEntireBuffer(){return this.q.readEntireBuffer()}flush(){this.p.flush()}send(l){const h=++this.c;this.h=this.g;const E=new w(1,h,this.h,l);this.b.push(E),this.a||(this.p.write(E),this.B())}sendControl(l){const h=new w(2,0,0,l);this.p.write(h)}A(){if(this.g<=this.h||this.k)return;const l=Date.now()-this.j;if(l>=2e3){this.C();return}this.k=setTimeout(()=>{this.k=null,this.A()},2e3-l+5)}B(){if(this.c<=this.d||this.f||this.a)return;const l=this.b.peek(),h=Date.now()-l.writtenTime,E=Date.now()-this.q.lastReadTime,D=Date.now()-this.n;if(h>=2e4&&E>=2e4&&D>=2e4&&!this.s.hasHighLoad()){this.n=Date.now(),this.y.fire({unacknowledgedMsgCount:this.b.length(),timeSinceOldestUnacknowledgedMsg:h,timeSinceLastReceivedSomeData:E});return}const m=Math.max(2e4-h,2e4-E,2e4-D,500);this.f=setTimeout(()=>{this.f=null,this.B()},m)}C(){if(this.g<=this.h)return;this.h=this.g;const l=new w(3,0,this.h,A());this.p.write(l)}D(){this.h=this.g;const l=new w(9,0,this.h,A());this.p.write(l)}}e.$Jh=d}),define(ke[187],Se([1,0,50,12,22,21,185,8,4,3,24,104,101,81]),function(me,e,C,F,f,L,M,b,v,g,A,I,$,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9p=e.$8p=void 0;class k extends y.$xh{constructor(o){super({send:i=>{try{process.send?.(i.buffer.toString("base64"))}catch{}},onMessage:v.Event.fromNodeEventEmitter(process,"message",i=>f.$fe.wrap(Buffer.from(i,"base64")))},o),process.once("disconnect",()=>this.dispose())}}e.$8p=k;class w{constructor(o,i){this.i=o,this.j=i,this.c=new Set,this.g=new Map,this.h=new v.$Rd,this.onDidProcessExit=this.h.event;const n=i&&i.timeout?i.timeout:6e4;this.b=new F.$Ug(n),this.d=null,this.f=null}getChannel(o){const i=this;return{call(n,r,a){return i.k(o,n,r,a)},listen(n,r){return i.l(o,n,r)}}}k(o,i,n,r=L.CancellationToken.None){if(!this.b)return Promise.reject(new Error("disposed"));if(r.isCancellationRequested)return Promise.reject(b.$5());this.b.cancel();const a=this.n(o),t=(0,F.$Lg)(c=>a.call(i,n,c)),s=r.onCancellationRequested(()=>t.cancel()),d=(0,g.$Pc)(()=>t.cancel());return this.c.add(d),t.finally(()=>{s.dispose(),this.c.delete(d),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}),t}l(o,i,n){if(!this.b)return v.Event.None;this.b.cancel();let r;const a=new v.$Rd({onWillAddFirstListener:()=>{r=this.n(o).listen(i,n)(a.fire,a),this.c.add(r)},onDidRemoveLastListener:()=>{this.c.delete(r),r.dispose(),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}});return a.event}get m(){if(!this.f){const o=this.j&&this.j.args?this.j.args:[],i=Object.create(null);i.env={...(0,A.$an)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.j&&this.j.env&&(i.env={...i.env,...this.j.env}),this.j&&this.j.freshExecArgv&&(i.execArgv=[]),this.j&&typeof this.j.debug=="number"&&(i.execArgv=["--nolazy","--inspect="+this.j.debug]),this.j&&typeof this.j.debugBrk=="number"&&(i.execArgv=["--nolazy","--inspect-brk="+this.j.debugBrk]),i.execArgv===void 0&&(i.execArgv=process.execArgv.filter(l=>!/^--inspect(-brk)?=/.test(l)).filter(l=>!l.startsWith("--vscode-"))),(0,$.$Gl)(i.env),this.d=(0,C.fork)(this.i,o,i);const n=new v.$Rd;v.Event.fromNodeEventEmitter(this.d,"message",l=>l)(l=>{if((0,M.$4p)(l)){(0,M.log)(l,`IPC Library: ${this.j.serverName}`);return}n.fire(f.$fe.wrap(Buffer.from(l,"base64")))});const a=this.j.useQueue?(0,I.$Il)(this.d):this.d,t=l=>this.d&&this.d.connected&&a.send(l.buffer.toString("base64")),s=n.event,d={send:t,onMessage:s};this.f=new y.$yh(d);const c=()=>this.o();process.once("exit",c),this.d.on("error",l=>console.warn('IPC "'+this.j.serverName+'" errored with '+l)),this.d.on("exit",(l,h)=>{process.removeListener("exit",c),this.c.forEach(E=>(0,g.$Mc)(E)),this.c.clear(),l!==0&&h!=="SIGTERM"&&console.warn('IPC "'+this.j.serverName+'" crashed with exit code '+l+" and signal "+h),this.b?.cancel(),this.o(),this.h.fire({code:l,signal:h})})}return this.f}n(o){let i=this.g.get(o);return i||(i=this.m.getChannel(o),this.g.set(o,i)),i}o(){this.f&&(this.d&&(this.d.kill(),this.d=null),this.f=null,this.g.clear())}dispose(){this.h.dispose(),this.b?.cancel(),this.b=void 0,this.o(),this.c.clear()}}e.$9p=w}),define(ke[188],Se([1,0,12,4,3,54,18]),function(me,e,C,F,f,L,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9o=e.$8o=e.StorageState=e.$7o=e.StorageHint=void 0;var b;(function($){$[$.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST",$[$.STORAGE_IN_MEMORY=1]="STORAGE_IN_MEMORY"})(b||(e.StorageHint=b={}));function v($){const y=$;return y?.changed instanceof Map||y?.deleted instanceof Set}e.$7o=v;var g;(function($){$[$.None=0]="None",$[$.Initialized=1]="Initialized",$[$.Closed=2]="Closed"})(g||(e.StorageState=g={}));class A extends f.$Rc{static{this.a=100}constructor(y,k=Object.create(null)){super(),this.r=y,this.s=k,this.b=this.B(new F.$Ud),this.onDidChangeStorage=this.b.event,this.c=g.None,this.f=new Map,this.g=this.B(new C.$Vg(A.a)),this.h=new Set,this.j=new Map,this.m=void 0,this.n=[],this.t()}t(){this.B(this.r.onDidChangeItemsExternal(y=>this.u(y)))}u(y){this.b.pause();try{y.changed?.forEach((k,w)=>this.w(w,k)),y.deleted?.forEach(k=>this.w(k,void 0))}finally{this.b.resume()}}w(y,k){if(this.c===g.Closed)return;let w=!1;(0,M.$Lf)(k)?w=this.f.delete(y):this.f.get(y)!==k&&(this.f.set(y,k),w=!0),w&&this.b.fire({key:y,external:!0})}get items(){return this.f}get size(){return this.f.size}async init(){this.c===g.None&&(this.c=g.Initialized,this.s.hint!==b.STORAGE_DOES_NOT_EXIST&&(this.f=await this.r.getItems()))}get(y,k){const w=this.f.get(y);return(0,M.$Lf)(w)?k:w}getBoolean(y,k){const w=this.get(y);return(0,M.$Lf)(w)?k:w==="true"}getNumber(y,k){const w=this.get(y);return(0,M.$Lf)(w)?k:parseInt(w,10)}getObject(y,k){const w=this.get(y);return(0,M.$Lf)(w)?k:(0,L.$rh)(w)}async set(y,k,w=!1){if(this.c===g.Closed)return;if((0,M.$Lf)(k))return this.delete(y,w);const u=(0,M.$Ef)(k)||Array.isArray(k)?(0,L.$qh)(k):String(k);if(this.f.get(y)!==u)return this.f.set(y,u),this.j.set(y,u),this.h.delete(y),this.b.fire({key:y,external:w}),this.D()}async delete(y,k=!1){if(!(this.c===g.Closed||!this.f.delete(y)))return this.h.has(y)||this.h.add(y),this.j.delete(y),this.b.fire({key:y,external:k}),this.D()}async optimize(){if(this.c!==g.Closed)return await this.flush(0),this.r.optimize()}async close(){return this.m||(this.m=this.y()),this.m}async y(){this.c=g.Closed;try{await this.D(0)}catch{}await this.r.close(()=>this.f)}get z(){return this.j.size>0||this.h.size>0}async C(){if(!this.z)return;const y={insert:this.j,delete:this.h};return this.h=new Set,this.j=new Map,this.r.updateItems(y).finally(()=>{if(!this.z)for(;this.n.length;)this.n.pop()?.()})}async flush(y){if(this.z)return this.D(y)}async D(y){return this.s.hint===b.STORAGE_IN_MEMORY?this.C():this.g.trigger(()=>this.C(),y)}async whenFlushed(){if(this.z)return new Promise(y=>this.n.push(y))}isInMemory(){return this.s.hint===b.STORAGE_IN_MEMORY}}e.$8o=A;class I{constructor(){this.onDidChangeItemsExternal=F.Event.None,this.a=new Map}async getItems(){return this.a}async updateItems(y){y.insert?.forEach((k,w)=>this.a.set(w,k)),y.delete?.forEach(k=>this.a.delete(k))}async optimize(){}async close(){}}e.$9o=I}),define(ke[189],Se([1,0,13,11,22]),function(me,e,C,F,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ts=e.$Ss=e.$Rs=void 0;let L;function M(){return L||(L=new TextDecoder("UTF-16LE")),L}let b;function v(){return b||(b=new TextDecoder("UTF-16BE")),b}let g;function A(){return g||(g=F.$D()?M():v()),g}e.$Rs=A;function I(k,w,u){const o=new Uint16Array(k.buffer,w,u);return u>0&&(o[0]===65279||o[0]===65534)?$(k,w,u):M().decode(o)}e.$Ss=I;function $(k,w,u){const o=[];let i=0;for(let n=0;n<u;n++){const r=f.$he(k,w);w+=2,o[i++]=String.fromCharCode(r)}return o.join("")}class y{constructor(w){this.a=w|0,this.b=new Uint16Array(this.a),this.c=null,this.d=0}reset(){this.c=null,this.d=0}build(){return this.c!==null?(this.f(),this.c.join("")):this.e()}e(){if(this.d===0)return"";const w=new Uint16Array(this.b.buffer,0,this.d);return A().decode(w)}f(){const w=this.e();this.d=0,this.c===null?this.c=[w]:this.c[this.c.length]=w}appendCharCode(w){const u=this.a-this.d;u<=1&&(u===0||C.$0e(w))&&this.f(),this.b[this.d++]=w}appendASCIICharCode(w){this.d===this.a&&this.f(),this.b[this.d++]=w}appendString(w){const u=w.length;if(this.d+u>=this.a){this.f(),this.c[this.c.length]=w;return}for(let o=0;o<u;o++)this.b[this.d++]=w.charCodeAt(o)}}e.$Ts=y}),define(ke[190],Se([1,0,22,189]),function(me,e,C,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vs=e.$Us=void 0;function f(v){return v.replace(/\n/g,"\\n").replace(/\r/g,"\\r")}class L{get oldLength(){return this.oldText.length}get oldEnd(){return this.oldPosition+this.oldText.length}get newLength(){return this.newText.length}get newEnd(){return this.newPosition+this.newText.length}constructor(g,A,I,$){this.oldPosition=g,this.oldText=A,this.newPosition=I,this.newText=$}toString(){return this.oldText.length===0?`(insert@${this.oldPosition} "${f(this.newText)}")`:this.newText.length===0?`(delete@${this.oldPosition} "${f(this.oldText)}")`:`(replace@${this.oldPosition} "${f(this.oldText)}" with "${f(this.newText)}")`}static a(g){return 4+2*g.length}static c(g,A,I){const $=A.length;C.$ke(g,$,I),I+=4;for(let y=0;y<$;y++)C.$ie(g,A.charCodeAt(y),I),I+=2;return I}static d(g,A){const I=C.$je(g,A);return A+=4,(0,F.$Ss)(g,A,I)}writeSize(){return 4+4+L.a(this.oldText)+L.a(this.newText)}write(g,A){return C.$ke(g,this.oldPosition,A),A+=4,C.$ke(g,this.newPosition,A),A+=4,A=L.c(g,this.oldText,A),A=L.c(g,this.newText,A),A}static read(g,A,I){const $=C.$je(g,A);A+=4;const y=C.$je(g,A);A+=4;const k=L.d(g,A);A+=L.a(k);const w=L.d(g,A);return A+=L.a(w),I.push(new L($,k,y,w)),A}}e.$Us=L;function M(v,g){return v===null||v.length===0?g:new b(v,g).compress()}e.$Vs=M;class b{constructor(g,A){this.a=g,this.c=A,this.d=[],this.e=0,this.f=this.a.length,this.g=0,this.h=this.c.length,this.j=0}compress(){let g=0,A=0,I=this.n(g),$=this.l(A);for(;g<this.f||A<this.h;){if(I===null){this.k($),$=this.l(++A);continue}if($===null){this.m(I),I=this.n(++g);continue}if($.oldEnd<=I.newPosition){this.k($),$=this.l(++A);continue}if(I.newEnd<=$.oldPosition){this.m(I),I=this.n(++g);continue}if($.oldPosition<I.newPosition){const[o,i]=b.r($,I.newPosition-$.oldPosition);this.k(o),$=i;continue}if(I.newPosition<$.oldPosition){const[o,i]=b.q(I,$.oldPosition-I.newPosition);this.m(o),I=i;continue}let w,u;if($.oldEnd===I.newEnd)w=I,u=$,I=this.n(++g),$=this.l(++A);else if($.oldEnd<I.newEnd){const[o,i]=b.q(I,$.oldLength);w=o,u=$,I=i,$=this.l(++A)}else{const[o,i]=b.r($,I.newLength);w=I,u=o,I=this.n(++g),$=i}this.d[this.e++]=new L(w.oldPosition,w.oldText,u.newPosition,u.newText),this.g+=w.newLength-w.oldLength,this.j+=u.newLength-u.oldLength}const y=b.s(this.d);return b.t(y)}k(g){this.d[this.e++]=b.o(this.g,g),this.j+=g.newLength-g.oldLength}l(g){return g<this.h?this.c[g]:null}m(g){this.d[this.e++]=b.p(this.j,g),this.g+=g.newLength-g.oldLength}n(g){return g<this.f?this.a[g]:null}static o(g,A){return new L(A.oldPosition-g,A.oldText,A.newPosition,A.newText)}static p(g,A){return new L(A.oldPosition,A.oldText,A.newPosition+g,A.newText)}static q(g,A){const I=g.newText.substr(0,A),$=g.newText.substr(A);return[new L(g.oldPosition,g.oldText,g.newPosition,I),new L(g.oldEnd,"",g.newPosition+A,$)]}static r(g,A){const I=g.oldText.substr(0,A),$=g.oldText.substr(A);return[new L(g.oldPosition,I,g.newPosition,g.newText),new L(g.oldPosition+A,$,g.newEnd,"")]}static s(g){if(g.length===0)return g;const A=[];let I=0,$=g[0];for(let y=1;y<g.length;y++){const k=g[y];$.oldEnd===k.oldPosition?$=new L($.oldPosition,$.oldText+k.oldText,$.newPosition,$.newText+k.newText):(A[I++]=$,$=k)}return A[I++]=$,A}static t(g){if(g.length===0)return g;const A=[];let I=0;for(let $=0;$<g.length;$++){const y=g[$];y.oldText!==y.newText&&(A[I++]=y)}return A}}}),define(ke[191],Se([1,0,34,16]),function(me,e,C,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$KE=void 0;function f(L,M,b,v,g,A){if(Array.isArray(L)){let I=0;for(const $ of L){const y=f($,M,b,v,g,A);if(y===10)return y;y>I&&(I=y)}return I}else{if(typeof L=="string")return v?L==="*"?5:L===b?10:0:0;if(L){const{language:I,pattern:$,scheme:y,hasAccessToAllModels:k,notebookType:w}=L;if(!v&&!k)return 0;w&&g&&(M=g);let u=0;if(y)if(y===M.scheme)u=10;else if(y==="*")u=5;else return 0;if(I)if(I===b)u=10;else if(I==="*")u=Math.max(u,5);else return 0;if(w)if(w===A)u=10;else if(w==="*"&&A!==void 0)u=Math.max(u,5);else return 0;if($){let o;if(typeof $=="string"?o=$:o={...$,base:(0,F.$gc)($.base)},o===M.fsPath||(0,C.$Bj)(o,M.fsPath))u=10;else return 0}return u}else return 0}}e.$KE=f}),define(ke[192],Se([1,0,4,13,29,79,128,167,190,3]),function(me,e,C,F,f,L,M,b,v,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$LB=void 0;class A extends g.$Rc{constructor($,y,k,w,u,o,i){super(),this.m=this.B(new C.$Rd),this.onDidChangeContent=this.m.event,this.f=y,this.j=!o,this.g=w,this.h=u,this.c=new M.$KB($,k,i)}equals($){return!($ instanceof A)||this.f!==$.f||this.getEOL()!==$.getEOL()?!1:this.c.equal($.c)}mightContainRTL(){return this.g}mightContainUnusualLineTerminators(){return this.h}resetMightContainUnusualLineTerminators(){this.h=!1}mightContainNonBasicASCII(){return this.j}getBOM(){return this.f}getEOL(){return this.c.getEOL()}createSnapshot($){return this.c.createSnapshot($?this.f:"")}getOffsetAt($,y){return this.c.getOffsetAt($,y)}getPositionAt($){return this.c.getPositionAt($)}getRangeAt($,y){const k=$+y,w=this.getPositionAt($),u=this.getPositionAt(k);return new f.$zs(w.lineNumber,w.column,u.lineNumber,u.column)}getValueInRange($,y=0){if($.isEmpty())return"";const k=this.n(y);return this.c.getValueInRange($,k)}getValueLengthInRange($,y=0){if($.isEmpty())return 0;if($.startLineNumber===$.endLineNumber)return $.endColumn-$.startColumn;const k=this.getOffsetAt($.startLineNumber,$.startColumn),w=this.getOffsetAt($.endLineNumber,$.endColumn);let u=0;const o=this.n(y),i=this.getEOL();if(o.length!==i.length){const n=o.length-i.length,r=$.endLineNumber-$.startLineNumber;u=n*r}return w-k+u}getCharacterCountInRange($,y=0){if(this.j){let k=0;const w=$.startLineNumber,u=$.endLineNumber;for(let o=w;o<=u;o++){const i=this.getLineContent(o),n=o===w?$.startColumn-1:0,r=o===u?$.endColumn-1:i.length;for(let a=n;a<r;a++)F.$0e(i.charCodeAt(a))?(k=k+1,a=a+1):k=k+1}return k+=this.n(y).length*(u-w),k}return this.getValueLengthInRange($,y)}getLength(){return this.c.getLength()}getLineCount(){return this.c.getLineCount()}getLinesContent(){return this.c.getLinesContent()}getLineContent($){return this.c.getLineContent($)}getLineCharCode($,y){return this.c.getLineCharCode($,y)}getCharCode($){return this.c.getCharCode($)}getLineLength($){return this.c.getLineLength($)}getLineMinColumn($){return 1}getLineMaxColumn($){return this.getLineLength($)+1}getLineFirstNonWhitespaceColumn($){const y=F.$Ue(this.getLineContent($));return y===-1?0:y+1}getLineLastNonWhitespaceColumn($){const y=F.$We(this.getLineContent($));return y===-1?0:y+2}n($){switch($){case 1:return`
`;case 2:return`\r
`;case 0:return this.getEOL();default:throw new Error("Unknown EOL preference")}}setEOL($){this.c.setEOL($)}applyEdits($,y,k){let w=this.g,u=this.h,o=this.j,i=!0,n=[];for(let l=0;l<$.length;l++){const h=$[l];i&&h._isTracked&&(i=!1);const E=h.range;if(h.text){let P=!0;o||(P=!F.$if(h.text),o=P),!w&&P&&(w=F.$hf(h.text)),!u&&P&&(u=F.$kf(h.text))}let D="",m=0,p=0,S=0;if(h.text){let P;[m,p,S,P]=(0,b.$_s)(h.text);const z=this.getEOL();P===0||P===(z===`\r
`?2:1)?D=h.text:D=h.text.replace(/\r\n|\r|\n/g,z)}n[l]={sortIndex:l,identifier:h.identifier||null,range:E,rangeOffset:this.getOffsetAt(E.startLineNumber,E.startColumn),rangeLength:this.getValueLengthInRange(E),text:D,eolCount:m,firstLineLength:p,lastLineLength:S,forceMoveMarkers:!!h.forceMoveMarkers,isAutoWhitespaceEdit:h.isAutoWhitespaceEdit||!1}}n.sort(A.u);let r=!1;for(let l=0,h=n.length-1;l<h;l++){const E=n[l].range.getEndPosition(),D=n[l+1].range.getStartPosition();if(D.isBeforeOrEqual(E)){if(D.isBefore(E))throw new Error("Overlapping ranges are not allowed!");r=!0}}i&&(n=this.s(n));const a=k||y?A._getInverseEditRanges(n):[],t=[];if(y)for(let l=0;l<n.length;l++){const h=n[l],E=a[l];if(h.isAutoWhitespaceEdit&&h.range.isEmpty())for(let D=E.startLineNumber;D<=E.endLineNumber;D++){let m="";D===E.startLineNumber&&(m=this.getLineContent(h.range.startLineNumber),F.$Ue(m)!==-1)||t.push({lineNumber:D,oldContent:m})}}let s=null;if(k){let l=0;s=[];for(let h=0;h<n.length;h++){const E=n[h],D=a[h],m=this.getValueInRange(E.range),p=E.rangeOffset+l;l+=E.text.length-m.length,s[h]={sortIndex:E.sortIndex,identifier:E.identifier,range:D,text:m,textChange:new v.$Us(E.rangeOffset,m,p,E.text)}}r||s.sort((h,E)=>h.sortIndex-E.sortIndex)}this.g=w,this.h=u,this.j=o;const d=this.t(n);let c=null;if(y&&t.length>0){t.sort((l,h)=>h.lineNumber-l.lineNumber),c=[];for(let l=0,h=t.length;l<h;l++){const E=t[l].lineNumber;if(l>0&&t[l-1].lineNumber===E)continue;const D=t[l].oldContent,m=this.getLineContent(E);m.length===0||m===D||F.$Ue(m)!==-1||c.push(E)}}return this.m.fire(),new L.$Uu(s,d,c)}s($){return $.length<1e3?$:[this._toSingleEditOperation($)]}_toSingleEditOperation($){let y=!1;const k=$[0].range,w=$[$.length-1].range,u=new f.$zs(k.startLineNumber,k.startColumn,w.endLineNumber,w.endColumn);let o=k.startLineNumber,i=k.startColumn;const n=[];for(let d=0,c=$.length;d<c;d++){const l=$[d],h=l.range;y=y||l.forceMoveMarkers,n.push(this.getValueInRange(new f.$zs(o,i,h.startLineNumber,h.startColumn))),l.text.length>0&&n.push(l.text),o=h.endLineNumber,i=h.endColumn}const r=n.join(""),[a,t,s]=(0,b.$_s)(r);return{sortIndex:0,identifier:$[0].identifier,range:u,rangeOffset:this.getOffsetAt(u.startLineNumber,u.startColumn),rangeLength:this.getValueLengthInRange(u,0),text:r,eolCount:a,firstLineLength:t,lastLineLength:s,forceMoveMarkers:y,isAutoWhitespaceEdit:!1}}t($){$.sort(A.w);const y=[];for(let k=0;k<$.length;k++){const w=$[k],u=w.range.startLineNumber,o=w.range.startColumn,i=w.range.endLineNumber,n=w.range.endColumn;if(u===i&&o===n&&w.text.length===0)continue;w.text?(this.c.delete(w.rangeOffset,w.rangeLength),this.c.insert(w.rangeOffset,w.text,!0)):this.c.delete(w.rangeOffset,w.rangeLength);const r=new f.$zs(u,o,i,n);y.push({range:r,rangeLength:w.rangeLength,text:w.text,rangeOffset:w.rangeOffset,forceMoveMarkers:w.forceMoveMarkers})}return y}findMatchesLineByLine($,y,k,w){return this.c.findMatchesLineByLine($,y,k,w)}getPieceTree(){return this.c}static _getInverseEditRange($,y){const k=$.startLineNumber,w=$.startColumn,[u,o,i]=(0,b.$_s)(y);let n;if(y.length>0){const r=u+1;r===1?n=new f.$zs(k,w,k,w+o):n=new f.$zs(k,w,k+r-1,i+1)}else n=new f.$zs(k,w,k,w);return n}static _getInverseEditRanges($){const y=[];let k=0,w=0,u=null;for(let o=0,i=$.length;o<i;o++){const n=$[o];let r,a;u?u.range.endLineNumber===n.range.startLineNumber?(r=k,a=w+(n.range.startColumn-u.range.endColumn)):(r=k+(n.range.startLineNumber-u.range.endLineNumber),a=n.range.startColumn):(r=n.range.startLineNumber,a=n.range.startColumn);let t;if(n.text.length>0){const s=n.eolCount+1;s===1?t=new f.$zs(r,a,r,a+n.firstLineLength):t=new f.$zs(r,a,r+s-1,n.lastLineLength+1)}else t=new f.$zs(r,a,r,a);k=t.endLineNumber,w=t.endColumn,y.push(t),u=n}return y}static u($,y){const k=f.$zs.compareRangesUsingEnds($.range,y.range);return k===0?$.sortIndex-y.sortIndex:k}static w($,y){const k=f.$zs.compareRangesUsingEnds($.range,y.range);return k===0?y.sortIndex-$.sortIndex:-k}}e.$LB=A}),define(ke[193],Se([1,0,13,128,192]),function(me,e,C,F,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$MB=void 0;class L{constructor(v,g,A,I,$,y,k,w,u){this.a=v,this.b=g,this.c=A,this.d=I,this.e=$,this.f=y,this.g=k,this.h=w,this.j=u}k(v){const g=this.c+this.d+this.e,A=this.c+this.e;return g===0?v===1?`
`:`\r
`:A>g/2?`\r
`:`
`}create(v){const g=this.k(v),A=this.a;if(this.j&&(g===`\r
`&&(this.c>0||this.d>0)||g===`
`&&(this.c>0||this.e>0)))for(let $=0,y=A.length;$<y;$++){const k=A[$].buffer.replace(/\r\n|\r|\n/g,g),w=(0,F.$GB)(k);A[$]=new F.$JB(k,w)}const I=new f.$LB(A,this.b,g,this.f,this.g,this.h,this.j);return{textBuffer:I,disposable:I}}getFirstLineText(v){return this.a[0].buffer.substr(0,v).split(/\r\n|\r|\n/)[0]}}class M{constructor(){this.a=[],this.b="",this.c=!1,this.d=0,this.e=[],this.f=0,this.g=0,this.h=0,this.j=!1,this.k=!1,this.l=!0}acceptChunk(v){if(v.length===0)return;this.a.length===0&&C.$qf(v)&&(this.b=C.$pf,v=v.substr(1));const g=v.charCodeAt(v.length-1);g===13||g>=55296&&g<=56319?(this.m(v.substr(0,v.length-1),!1),this.c=!0,this.d=g):(this.m(v,!1),this.c=!1,this.d=g)}m(v,g){!g&&v.length===0||(this.c?this.n(String.fromCharCode(this.d)+v):this.n(v))}n(v){const g=(0,F.$HB)(this.e,v);this.a.push(new F.$JB(v,g.lineStarts)),this.f+=g.cr,this.g+=g.lf,this.h+=g.crlf,g.isBasicASCII||(this.l=!1,this.j||(this.j=C.$hf(v)),this.k||(this.k=C.$kf(v)))}finish(v=!0){return this.o(),new L(this.a,this.b,this.f,this.g,this.h,this.j,this.k,this.l,v)}o(){if(this.a.length===0&&this.m("",!0),this.c){this.c=!1;const v=this.a[this.a.length-1];v.buffer+=String.fromCharCode(this.d);const g=(0,F.$GB)(v.buffer);v.lineStarts=g,this.d===13&&this.f++}}}e.$MB=M}),define(ke[132],Se([1,0,22,11]),function(me,e,C,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$x$=e.$w$=void 0;var f;(function(I){I[I.Full=1]="Full",I[I.Delta=2]="Delta"})(f||(f={}));function L(I){for(let $=0,y=I.length;$<y;$+=4){const k=I[$+0],w=I[$+1],u=I[$+2],o=I[$+3];I[$+0]=o,I[$+1]=u,I[$+2]=w,I[$+3]=k}}function M(I){const $=new Uint8Array(I.buffer,I.byteOffset,I.length*4);return F.$D()||L($),C.$fe.wrap($)}function b(I){const $=I.buffer;if(F.$D()||L($),$.byteOffset%4===0)return new Uint32Array($.buffer,$.byteOffset,$.length/4);{const y=new Uint8Array($.byteLength);return y.set($),new Uint32Array(y.buffer,y.byteOffset,y.length/4)}}function v(I){const $=new Uint32Array(g(I));let y=0;if($[y++]=I.id,I.type==="full")$[y++]=1,$[y++]=I.data.length,$.set(I.data,y),y+=I.data.length;else{$[y++]=2,$[y++]=I.deltas.length;for(const k of I.deltas)$[y++]=k.start,$[y++]=k.deleteCount,k.data?($[y++]=k.data.length,$.set(k.data,y),y+=k.data.length):$[y++]=0}return M($)}e.$w$=v;function g(I){let $=0;if($+=1+1,I.type==="full")$+=1+I.data.length;else{$+=1,$+=(1+1+1)*I.deltas.length;for(const y of I.deltas)y.data&&($+=y.data.length)}return $}function A(I){const $=b(I);let y=0;const k=$[y++];if($[y++]===1){const i=$[y++],n=$.subarray(y,y+i);return y+=i,{id:k,type:"full",data:n}}const u=$[y++],o=[];for(let i=0;i<u;i++){const n=$[y++],r=$[y++],a=$[y++];let t;a>0&&(t=$.subarray(y,y+a),y+=a),o[i]={start:n,deleteCount:r,data:t}}return{id:k,type:"delta",deltas:o}}e.$x$=A}),define(ke[194],Se([9,10]),function(me,e){return me.create("vs/editor/common/config/editorOptions",e)}),define(ke[133],Se([1,0,19,24,11,170,127,194]),function(me,e,C,F,f,L,M,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorOptions=e.EditorOption=e.editorOptionsRegistry=e.EDITOR_FONT_DEFAULTS=e.WrappingIndent=e.unicodeHighlightConfigKeys=e.inUntrustedWorkspace=e.filterValidationDecorations=e.RenderLineNumbersType=e.EditorLayoutInfoComputer=e.RenderMinimap=e.EditorFontVariations=e.EditorFontLigatures=e.cursorStyleToString=e.TextEditorCursorStyle=e.TextEditorCursorBlinkingStyle=e.stringSet=e.clampedFloat=e.clampedInt=e.boolean=e.ApplyUpdateResult=e.ComputeOptionsMemory=e.ConfigurationChangedEvent=e.MINIMAP_GUTTER_WIDTH=e.EditorAutoIndentStrategy=void 0;var v;(function(ue){ue[ue.None=0]="None",ue[ue.Keep=1]="Keep",ue[ue.Brackets=2]="Brackets",ue[ue.Advanced=3]="Advanced",ue[ue.Full=4]="Full"})(v||(e.EditorAutoIndentStrategy=v={})),e.MINIMAP_GUTTER_WIDTH=8;class g{constructor(ce){this.c=ce}hasChanged(ce){return this.c[ce]}}e.ConfigurationChangedEvent=g;class A{constructor(){this.stableMinimapLayoutInput=null,this.stableFitMaxMinimapScale=0,this.stableFitRemainingWidth=0}}e.ComputeOptionsMemory=A;class I{constructor(ce,Ie,Ke,Ge){this.id=ce,this.name=Ie,this.defaultValue=Ke,this.schema=Ge}applyUpdate(ce,Ie){return y(ce,Ie)}compute(ce,Ie,Ke){return Ke}}class ${constructor(ce,Ie){this.newValue=ce,this.didChange=Ie}}e.ApplyUpdateResult=$;function y(ue,ce){if(typeof ue!="object"||typeof ce!="object"||!ue||!ce)return new $(ce,ue!==ce);if(Array.isArray(ue)||Array.isArray(ce)){const Ke=Array.isArray(ue)&&Array.isArray(ce)&&C.$tb(ue,ce);return new $(ce,!Ke)}let Ie=!1;for(const Ke in ce)if(ce.hasOwnProperty(Ke)){const Ge=y(ue[Ke],ce[Ke]);Ge.didChange&&(ue[Ke]=Ge.newValue,Ie=!0)}return new $(ue,Ie)}class k{constructor(ce){this.schema=void 0,this.id=ce,this.name="_never_",this.defaultValue=void 0}applyUpdate(ce,Ie){return y(ce,Ie)}validate(ce){return this.defaultValue}}class w{constructor(ce,Ie,Ke,Ge){this.id=ce,this.name=Ie,this.defaultValue=Ke,this.schema=Ge}applyUpdate(ce,Ie){return y(ce,Ie)}validate(ce){return typeof ce>"u"?this.defaultValue:ce}compute(ce,Ie,Ke){return Ke}}function u(ue,ce){return typeof ue>"u"?ce:ue==="false"?!1:!!ue}e.boolean=u;class o extends w{constructor(ce,Ie,Ke,Ge=void 0){typeof Ge<"u"&&(Ge.type="boolean",Ge.default=Ke),super(ce,Ie,Ke,Ge)}validate(ce){return u(ce,this.defaultValue)}}function i(ue,ce,Ie,Ke){if(typeof ue>"u")return ce;let Ge=parseInt(ue,10);return isNaN(Ge)?ce:(Ge=Math.max(Ie,Ge),Ge=Math.min(Ke,Ge),Ge|0)}e.clampedInt=i;class n extends w{static clampedInt(ce,Ie,Ke,Ge){return i(ce,Ie,Ke,Ge)}constructor(ce,Ie,Ke,Ge,_e,st=void 0){typeof st<"u"&&(st.type="integer",st.default=Ke,st.minimum=Ge,st.maximum=_e),super(ce,Ie,Ke,st),this.minimum=Ge,this.maximum=_e}validate(ce){return n.clampedInt(ce,this.defaultValue,this.minimum,this.maximum)}}function r(ue,ce,Ie,Ke){if(typeof ue>"u")return ce;const Ge=a.float(ue,ce);return a.clamp(Ge,Ie,Ke)}e.clampedFloat=r;class a extends w{static clamp(ce,Ie,Ke){return ce<Ie?Ie:ce>Ke?Ke:ce}static float(ce,Ie){if(typeof ce=="number")return ce;if(typeof ce>"u")return Ie;const Ke=parseFloat(ce);return isNaN(Ke)?Ie:Ke}constructor(ce,Ie,Ke,Ge,_e){typeof _e<"u"&&(_e.type="number",_e.default=Ke),super(ce,Ie,Ke,_e),this.validationFn=Ge}validate(ce){return this.validationFn(a.float(ce,this.defaultValue))}}class t extends w{static string(ce,Ie){return typeof ce!="string"?Ie:ce}constructor(ce,Ie,Ke,Ge=void 0){typeof Ge<"u"&&(Ge.type="string",Ge.default=Ke),super(ce,Ie,Ke,Ge)}validate(ce){return t.string(ce,this.defaultValue)}}function s(ue,ce,Ie,Ke){return typeof ue!="string"?ce:Ke&&ue in Ke?Ke[ue]:Ie.indexOf(ue)===-1?ce:ue}e.stringSet=s;class d extends w{constructor(ce,Ie,Ke,Ge,_e=void 0){typeof _e<"u"&&(_e.type="string",_e.enum=Ge,_e.default=Ke),super(ce,Ie,Ke,_e),this.c=Ge}validate(ce){return s(ce,this.defaultValue,this.c)}}class c extends I{constructor(ce,Ie,Ke,Ge,_e,st,lt=void 0){typeof lt<"u"&&(lt.type="string",lt.enum=_e,lt.default=Ge),super(ce,Ie,Ke,lt),this.c=_e,this.d=st}validate(ce){return typeof ce!="string"?this.defaultValue:this.c.indexOf(ce)===-1?this.defaultValue:this.d(ce)}}function l(ue){switch(ue){case"none":return 0;case"keep":return 1;case"brackets":return 2;case"advanced":return 3;case"full":return 4}}class h extends I{constructor(){super(2,"accessibilitySupport",0,{type:"string",enum:["auto","on","off"],enumDescriptions:[b.localize(0,null),b.localize(1,null),b.localize(2,null)],default:"auto",tags:["accessibility"],description:b.localize(3,null)})}validate(ce){switch(ce){case"auto":return 0;case"off":return 1;case"on":return 2}return this.defaultValue}compute(ce,Ie,Ke){return Ke===0?ce.accessibilitySupport:Ke}}class E extends I{constructor(){const ce={insertSpace:!0,ignoreEmptyLines:!0};super(23,"comments",ce,{"editor.comments.insertSpace":{type:"boolean",default:ce.insertSpace,description:b.localize(4,null)},"editor.comments.ignoreEmptyLines":{type:"boolean",default:ce.ignoreEmptyLines,description:b.localize(5,null)}})}validate(ce){if(!ce||typeof ce!="object")return this.defaultValue;const Ie=ce;return{insertSpace:u(Ie.insertSpace,this.defaultValue.insertSpace),ignoreEmptyLines:u(Ie.ignoreEmptyLines,this.defaultValue.ignoreEmptyLines)}}}var D;(function(ue){ue[ue.Hidden=0]="Hidden",ue[ue.Blink=1]="Blink",ue[ue.Smooth=2]="Smooth",ue[ue.Phase=3]="Phase",ue[ue.Expand=4]="Expand",ue[ue.Solid=5]="Solid"})(D||(e.TextEditorCursorBlinkingStyle=D={}));function m(ue){switch(ue){case"blink":return 1;case"smooth":return 2;case"phase":return 3;case"expand":return 4;case"solid":return 5}}var p;(function(ue){ue[ue.Line=1]="Line",ue[ue.Block=2]="Block",ue[ue.Underline=3]="Underline",ue[ue.LineThin=4]="LineThin",ue[ue.BlockOutline=5]="BlockOutline",ue[ue.UnderlineThin=6]="UnderlineThin"})(p||(e.TextEditorCursorStyle=p={}));function S(ue){switch(ue){case p.Line:return"line";case p.Block:return"block";case p.Underline:return"underline";case p.LineThin:return"line-thin";case p.BlockOutline:return"block-outline";case p.UnderlineThin:return"underline-thin"}}e.cursorStyleToString=S;function P(ue){switch(ue){case"line":return p.Line;case"block":return p.Block;case"underline":return p.Underline;case"line-thin":return p.LineThin;case"block-outline":return p.BlockOutline;case"underline-thin":return p.UnderlineThin}}class z extends k{constructor(){super(140)}compute(ce,Ie,Ke){const Ge=["monaco-editor"];return Ie.get(39)&&Ge.push(Ie.get(39)),ce.extraEditorClassName&&Ge.push(ce.extraEditorClassName),Ie.get(73)==="default"?Ge.push("mouse-default"):Ie.get(73)==="copy"&&Ge.push("mouse-copy"),Ie.get(110)&&Ge.push("showUnused"),Ie.get(138)&&Ge.push("showDeprecated"),Ge.join(" ")}}class j extends o{constructor(){super(37,"emptySelectionClipboard",!0,{description:b.localize(6,null)})}compute(ce,Ie,Ke){return Ke&&ce.emptySelectionClipboard}}class R extends I{constructor(){const ce={cursorMoveOnType:!0,seedSearchStringFromSelection:"always",autoFindInSelection:"never",globalFindClipboard:!1,addExtraSpaceOnTop:!0,loop:!0};super(41,"find",ce,{"editor.find.cursorMoveOnType":{type:"boolean",default:ce.cursorMoveOnType,description:b.localize(7,null)},"editor.find.seedSearchStringFromSelection":{type:"string",enum:["never","always","selection"],default:ce.seedSearchStringFromSelection,enumDescriptions:[b.localize(8,null),b.localize(9,null),b.localize(10,null)],description:b.localize(11,null)},"editor.find.autoFindInSelection":{type:"string",enum:["never","always","multiline"],default:ce.autoFindInSelection,enumDescriptions:[b.localize(12,null),b.localize(13,null),b.localize(14,null)],description:b.localize(15,null)},"editor.find.globalFindClipboard":{type:"boolean",default:ce.globalFindClipboard,description:b.localize(16,null),included:f.$j},"editor.find.addExtraSpaceOnTop":{type:"boolean",default:ce.addExtraSpaceOnTop,description:b.localize(17,null)},"editor.find.loop":{type:"boolean",default:ce.loop,description:b.localize(18,null)}})}validate(ce){if(!ce||typeof ce!="object")return this.defaultValue;const Ie=ce;return{cursorMoveOnType:u(Ie.cursorMoveOnType,this.defaultValue.cursorMoveOnType),seedSearchStringFromSelection:typeof ce.seedSearchStringFromSelection=="boolean"?ce.seedSearchStringFromSelection?"always":"never":s(Ie.seedSearchStringFromSelection,this.defaultValue.seedSearchStringFromSelection,["never","always","selection"]),autoFindInSelection:typeof ce.autoFindInSelection=="boolean"?ce.autoFindInSelection?"always":"never":s(Ie.autoFindInSelection,this.defaultValue.autoFindInSelection,["never","always","multiline"]),globalFindClipboard:u(Ie.globalFindClipboard,this.defaultValue.globalFindClipboard),addExtraSpaceOnTop:u(Ie.addExtraSpaceOnTop,this.defaultValue.addExtraSpaceOnTop),loop:u(Ie.loop,this.defaultValue.loop)}}}class T extends I{static{this.OFF='"liga" off, "calt" off'}static{this.ON='"liga" on, "calt" on'}constructor(){super(51,"fontLigatures",T.OFF,{anyOf:[{type:"boolean",description:b.localize(19,null)},{type:"string",description:b.localize(20,null)}],description:b.localize(21,null),default:!1})}validate(ce){return typeof ce>"u"?this.defaultValue:typeof ce=="string"?ce==="false"?T.OFF:ce==="true"?T.ON:ce:ce?T.ON:T.OFF}}e.EditorFontLigatures=T;class N extends I{static{this.OFF="normal"}static{this.TRANSLATE="translate"}constructor(){super(54,"fontVariations",N.OFF,{anyOf:[{type:"boolean",description:b.localize(22,null)},{type:"string",description:b.localize(23,null)}],description:b.localize(24,null),default:!1})}validate(ce){return typeof ce>"u"?this.defaultValue:typeof ce=="string"?ce==="false"?N.OFF:ce==="true"?N.TRANSLATE:ce:ce?N.TRANSLATE:N.OFF}compute(ce,Ie,Ke){return ce.fontInfo.fontVariationSettings}}e.EditorFontVariations=N;class O extends k{constructor(){super(50)}compute(ce,Ie,Ke){return ce.fontInfo}}class W extends w{constructor(){super(52,"fontSize",e.EDITOR_FONT_DEFAULTS.fontSize,{type:"number",minimum:6,maximum:100,default:e.EDITOR_FONT_DEFAULTS.fontSize,description:b.localize(25,null)})}validate(ce){const Ie=a.float(ce,this.defaultValue);return Ie===0?e.EDITOR_FONT_DEFAULTS.fontSize:a.clamp(Ie,6,100)}compute(ce,Ie,Ke){return ce.fontInfo.fontSize}}class x extends I{static{this.c=["normal","bold","100","200","300","400","500","600","700","800","900"]}static{this.d=1}static{this.e=1e3}constructor(){super(53,"fontWeight",e.EDITOR_FONT_DEFAULTS.fontWeight,{anyOf:[{type:"number",minimum:x.d,maximum:x.e,errorMessage:b.localize(26,null)},{type:"string",pattern:"^(normal|bold|1000|[1-9][0-9]{0,2})$"},{enum:x.c}],default:e.EDITOR_FONT_DEFAULTS.fontWeight,description:b.localize(27,null)})}validate(ce){return ce==="normal"||ce==="bold"?ce:String(n.clampedInt(ce,e.EDITOR_FONT_DEFAULTS.fontWeight,x.d,x.e))}}class le extends I{constructor(){const ce={multiple:"peek",multipleDefinitions:"peek",multipleTypeDefinitions:"peek",multipleDeclarations:"peek",multipleImplementations:"peek",multipleReferences:"peek",alternativeDefinitionCommand:"editor.action.goToReferences",alternativeTypeDefinitionCommand:"editor.action.goToReferences",alternativeDeclarationCommand:"editor.action.goToReferences",alternativeImplementationCommand:"",alternativeReferenceCommand:""},Ie={type:"string",enum:["peek","gotoAndPeek","goto"],default:ce.multiple,enumDescriptions:[b.localize(28,null),b.localize(29,null),b.localize(30,null)]},Ke=["","editor.action.referenceSearch.trigger","editor.action.goToReferences","editor.action.peekImplementation","editor.action.goToImplementation","editor.action.peekTypeDefinition","editor.action.goToTypeDefinition","editor.action.peekDeclaration","editor.action.revealDeclaration","editor.action.peekDefinition","editor.action.revealDefinitionAside","editor.action.revealDefinition"];super(58,"gotoLocation",ce,{"editor.gotoLocation.multiple":{deprecationMessage:b.localize(31,null)},"editor.gotoLocation.multipleDefinitions":{description:b.localize(32,null),...Ie},"editor.gotoLocation.multipleTypeDefinitions":{description:b.localize(33,null),...Ie},"editor.gotoLocation.multipleDeclarations":{description:b.localize(34,null),...Ie},"editor.gotoLocation.multipleImplementations":{description:b.localize(35,null),...Ie},"editor.gotoLocation.multipleReferences":{description:b.localize(36,null),...Ie},"editor.gotoLocation.alternativeDefinitionCommand":{type:"string",default:ce.alternativeDefinitionCommand,enum:Ke,description:b.localize(37,null)},"editor.gotoLocation.alternativeTypeDefinitionCommand":{type:"string",default:ce.alternativeTypeDefinitionCommand,enum:Ke,description:b.localize(38,null)},"editor.gotoLocation.alternativeDeclarationCommand":{type:"string",default:ce.alternativeDeclarationCommand,enum:Ke,description:b.localize(39,null)},"editor.gotoLocation.alternativeImplementationCommand":{type:"string",default:ce.alternativeImplementationCommand,enum:Ke,description:b.localize(40,null)},"editor.gotoLocation.alternativeReferenceCommand":{type:"string",default:ce.alternativeReferenceCommand,enum:Ke,description:b.localize(41,null)}})}validate(ce){if(!ce||typeof ce!="object")return this.defaultValue;const Ie=ce;return{multiple:s(Ie.multiple,this.defaultValue.multiple,["peek","gotoAndPeek","goto"]),multipleDefinitions:Ie.multipleDefinitions??s(Ie.multipleDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleTypeDefinitions:Ie.multipleTypeDefinitions??s(Ie.multipleTypeDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleDeclarations:Ie.multipleDeclarations??s(Ie.multipleDeclarations,"peek",["peek","gotoAndPeek","goto"]),multipleImplementations:Ie.multipleImplementations??s(Ie.multipleImplementations,"peek",["peek","gotoAndPeek","goto"]),multipleReferences:Ie.multipleReferences??s(Ie.multipleReferences,"peek",["peek","gotoAndPeek","goto"]),alternativeDefinitionCommand:t.string(Ie.alternativeDefinitionCommand,this.defaultValue.alternativeDefinitionCommand),alternativeTypeDefinitionCommand:t.string(Ie.alternativeTypeDefinitionCommand,this.defaultValue.alternativeTypeDefinitionCommand),alternativeDeclarationCommand:t.string(Ie.alternativeDeclarationCommand,this.defaultValue.alternativeDeclarationCommand),alternativeImplementationCommand:t.string(Ie.alternativeImplementationCommand,this.defaultValue.alternativeImplementationCommand),alternativeReferenceCommand:t.string(Ie.alternativeReferenceCommand,this.defaultValue.alternativeReferenceCommand)}}}class G extends I{constructor(){const ce={enabled:!0,delay:300,hidingDelay:300,sticky:!0,above:!0};super(60,"hover",ce,{"editor.hover.enabled":{type:"boolean",default:ce.enabled,description:b.localize(42,null)},"editor.hover.delay":{type:"number",default:ce.delay,minimum:0,maximum:1e4,description:b.localize(43,null)},"editor.hover.sticky":{type:"boolean",default:ce.sticky,description:b.localize(44,null)},"editor.hover.hidingDelay":{type:"integer",minimum:0,default:ce.hidingDelay,description:b.localize(45,null)},"editor.hover.above":{type:"boolean",default:ce.above,description:b.localize(46,null)}})}validate(ce){if(!ce||typeof ce!="object")return this.defaultValue;const Ie=ce;return{enabled:u(Ie.enabled,this.defaultValue.enabled),delay:n.clampedInt(Ie.delay,this.defaultValue.delay,0,1e4),sticky:u(Ie.sticky,this.defaultValue.sticky),hidingDelay:n.clampedInt(Ie.hidingDelay,this.defaultValue.hidingDelay,0,6e5),above:u(Ie.above,this.defaultValue.above)}}}var J;(function(ue){ue[ue.None=0]="None",ue[ue.Text=1]="Text",ue[ue.Blocks=2]="Blocks"})(J||(e.RenderMinimap=J={}));class Q extends k{constructor(){super(143)}compute(ce,Ie,Ke){return Q.computeLayout(Ie,{memory:ce.memory,outerWidth:ce.outerWidth,outerHeight:ce.outerHeight,isDominatedByLongLines:ce.isDominatedByLongLines,lineHeight:ce.fontInfo.lineHeight,viewLineCount:ce.viewLineCount,lineNumbersDigitCount:ce.lineNumbersDigitCount,typicalHalfwidthCharacterWidth:ce.fontInfo.typicalHalfwidthCharacterWidth,maxDigitWidth:ce.fontInfo.maxDigitWidth,pixelRatio:ce.pixelRatio,glyphMarginDecorationLaneCount:ce.glyphMarginDecorationLaneCount})}static computeContainedMinimapLineCount(ce){const Ie=ce.height/ce.lineHeight,Ke=Math.floor(ce.paddingTop/ce.lineHeight);let Ge=Math.floor(ce.paddingBottom/ce.lineHeight);ce.scrollBeyondLastLine&&(Ge=Math.max(Ge,Ie-1));const _e=(Ke+ce.viewLineCount+Ge)/(ce.pixelRatio*ce.height),st=Math.floor(ce.viewLineCount/_e);return{typicalViewportLineCount:Ie,extraLinesBeforeFirstLine:Ke,extraLinesBeyondLastLine:Ge,desiredRatio:_e,minimapLineCount:st}}static c(ce,Ie){const Ke=ce.outerWidth,Ge=ce.outerHeight,_e=ce.pixelRatio;if(!ce.minimap.enabled)return{renderMinimap:0,minimapLeft:0,minimapWidth:0,minimapHeightIsEditorHeight:!1,minimapIsSampling:!1,minimapScale:1,minimapLineHeight:1,minimapCanvasInnerWidth:0,minimapCanvasInnerHeight:Math.floor(_e*Ge),minimapCanvasOuterWidth:0,minimapCanvasOuterHeight:Ge};const st=Ie.stableMinimapLayoutInput,lt=st&&ce.outerHeight===st.outerHeight&&ce.lineHeight===st.lineHeight&&ce.typicalHalfwidthCharacterWidth===st.typicalHalfwidthCharacterWidth&&ce.pixelRatio===st.pixelRatio&&ce.scrollBeyondLastLine===st.scrollBeyondLastLine&&ce.paddingTop===st.paddingTop&&ce.paddingBottom===st.paddingBottom&&ce.minimap.enabled===st.minimap.enabled&&ce.minimap.side===st.minimap.side&&ce.minimap.size===st.minimap.size&&ce.minimap.showSlider===st.minimap.showSlider&&ce.minimap.renderCharacters===st.minimap.renderCharacters&&ce.minimap.maxColumn===st.minimap.maxColumn&&ce.minimap.scale===st.minimap.scale&&ce.verticalScrollbarWidth===st.verticalScrollbarWidth&&ce.isViewportWrapping===st.isViewportWrapping,wt=ce.lineHeight,Ue=ce.typicalHalfwidthCharacterWidth,Kt=ce.scrollBeyondLastLine,Ht=ce.minimap.renderCharacters;let Et=_e>=2?Math.round(ce.minimap.scale*2):ce.minimap.scale;const Ut=ce.minimap.maxColumn,Nt=ce.minimap.size,Gt=ce.minimap.side,Bt=ce.verticalScrollbarWidth,Dt=ce.viewLineCount,Mt=ce.remainingWidth,Wt=ce.isViewportWrapping,tt=Ht?2:3;let Vt=Math.floor(_e*Ge);const qt=Vt/_e;let ut=!1,mt=!1,Ot=tt*Et,Pt=Et/_e,At=1;if(Nt==="fill"||Nt==="fit"){const{typicalViewportLineCount:Jt,extraLinesBeforeFirstLine:Me,extraLinesBeyondLastLine:Fe,desiredRatio:Ce,minimapLineCount:se}=Q.computeContainedMinimapLineCount({viewLineCount:Dt,scrollBeyondLastLine:Kt,paddingTop:ce.paddingTop,paddingBottom:ce.paddingBottom,height:Ge,lineHeight:wt,pixelRatio:_e});if(Dt/se>1)ut=!0,mt=!0,Et=1,Ot=1,Pt=Et/_e;else{let qe=!1,xe=Et+1;if(Nt==="fit"){const Qe=Math.ceil((Me+Dt+Fe)*Ot);Wt&&lt&&Mt<=Ie.stableFitRemainingWidth?(qe=!0,xe=Ie.stableFitMaxMinimapScale):qe=Qe>Vt}if(Nt==="fill"||qe){ut=!0;const Qe=Et;Ot=Math.min(wt*_e,Math.max(1,Math.floor(1/Ce))),Wt&&lt&&Mt<=Ie.stableFitRemainingWidth&&(xe=Ie.stableFitMaxMinimapScale),Et=Math.min(xe,Math.max(1,Math.floor(Ot/tt))),Et>Qe&&(At=Math.min(2,Et/Qe)),Pt=Et/_e/At,Vt=Math.ceil(Math.max(Jt,Me+Dt+Fe)*Ot),Wt?(Ie.stableMinimapLayoutInput=ce,Ie.stableFitRemainingWidth=Mt,Ie.stableFitMaxMinimapScale=Et):(Ie.stableMinimapLayoutInput=null,Ie.stableFitRemainingWidth=0)}}}const gt=Math.floor(Ut*Pt),St=Math.min(gt,Math.max(0,Math.floor((Mt-Bt-2)*Pt/(Ue+Pt)))+e.MINIMAP_GUTTER_WIDTH);let Rt=Math.floor(_e*St);const It=Rt/_e;Rt=Math.floor(Rt*At);const Je=Ht?1:2,jt=Gt==="left"?0:Ke-St-Bt;return{renderMinimap:Je,minimapLeft:jt,minimapWidth:St,minimapHeightIsEditorHeight:ut,minimapIsSampling:mt,minimapScale:Et,minimapLineHeight:Ot,minimapCanvasInnerWidth:Rt,minimapCanvasInnerHeight:Vt,minimapCanvasOuterWidth:It,minimapCanvasOuterHeight:qt}}static computeLayout(ce,Ie){const Ke=Ie.outerWidth|0,Ge=Ie.outerHeight|0,_e=Ie.lineHeight|0,st=Ie.lineNumbersDigitCount|0,lt=Ie.typicalHalfwidthCharacterWidth,wt=Ie.maxDigitWidth,Ue=Ie.pixelRatio,Kt=Ie.viewLineCount,Ht=ce.get(135),Et=Ht==="inherit"?ce.get(134):Ht,Ut=Et==="inherit"?ce.get(130):Et,Nt=ce.get(133),Gt=Ie.isDominatedByLongLines,Bt=ce.get(57),Dt=ce.get(67).renderType!==0,Mt=ce.get(68),Wt=ce.get(104),tt=ce.get(83),Vt=ce.get(72),qt=ce.get(102),ut=qt.verticalScrollbarSize,mt=qt.verticalHasArrows,Ot=qt.arrowSize,Pt=qt.horizontalScrollbarSize,At=ce.get(43),gt=ce.get(109)!=="never";let St=ce.get(65);At&&gt&&(St+=16);let Rt=0;if(Dt){const pt=Math.max(st,Mt);Rt=Math.round(pt*wt)}let It=0;Bt&&(It=_e*Ie.glyphMarginDecorationLaneCount);let Je=0,jt=Je+It,Jt=jt+Rt,Me=Jt+St;const Fe=Ke-It-Rt-St;let Ce=!1,se=!1,Te=-1;Et==="inherit"&&Gt?(Ce=!0,se=!0):Ut==="on"||Ut==="bounded"?se=!0:Ut==="wordWrapColumn"&&(Te=Nt);const qe=Q.c({outerWidth:Ke,outerHeight:Ge,lineHeight:_e,typicalHalfwidthCharacterWidth:lt,pixelRatio:Ue,scrollBeyondLastLine:Wt,paddingTop:tt.top,paddingBottom:tt.bottom,minimap:Vt,verticalScrollbarWidth:ut,viewLineCount:Kt,remainingWidth:Fe,isViewportWrapping:se},Ie.memory||new A);qe.renderMinimap!==0&&qe.minimapLeft===0&&(Je+=qe.minimapWidth,jt+=qe.minimapWidth,Jt+=qe.minimapWidth,Me+=qe.minimapWidth);const xe=Fe-qe.minimapWidth,Qe=Math.max(1,Math.floor((xe-ut-2)/lt)),ot=mt?Ot:0;return se&&(Te=Math.max(1,Qe),Ut==="bounded"&&(Te=Math.min(Te,Nt))),{width:Ke,height:Ge,glyphMarginLeft:Je,glyphMarginWidth:It,glyphMarginDecorationLaneCount:Ie.glyphMarginDecorationLaneCount,lineNumbersLeft:jt,lineNumbersWidth:Rt,decorationsLeft:Jt,decorationsWidth:St,contentLeft:Me,contentWidth:xe,minimap:qe,viewportColumn:Qe,isWordWrapMinified:Ce,isViewportWrapping:se,wrappingColumn:Te,verticalScrollbarWidth:ut,horizontalScrollbarHeight:Pt,overviewRuler:{top:ot,width:ut,height:Ge-2*ot,right:0}}}}e.EditorLayoutInfoComputer=Q;class oe extends I{constructor(){super(137,"wrappingStrategy","simple",{"editor.wrappingStrategy":{enumDescriptions:[b.localize(47,null),b.localize(48,null)],type:"string",enum:["simple","advanced"],default:"simple",description:b.localize(49,null)}})}validate(ce){return s(ce,"simple",["simple","advanced"])}compute(ce,Ie,Ke){return Ie.get(2)===2?"advanced":Ke}}class _ extends I{constructor(){const ce={enabled:!0};super(64,"lightbulb",ce,{"editor.lightbulb.enabled":{type:"boolean",default:ce.enabled,description:b.localize(50,null)}})}validate(ce){return!ce||typeof ce!="object"?this.defaultValue:{enabled:u(ce.enabled,this.defaultValue.enabled)}}}class Ee extends I{constructor(){const ce={enabled:!1,maxLineCount:5,defaultModel:"outlineModel",scrollWithEditor:!0};super(114,"stickyScroll",ce,{"editor.stickyScroll.enabled":{type:"boolean",default:ce.enabled,description:b.localize(51,null)},"editor.stickyScroll.maxLineCount":{type:"number",default:ce.maxLineCount,minimum:1,maximum:10,description:b.localize(52,null)},"editor.stickyScroll.defaultModel":{type:"string",enum:["outlineModel","foldingProviderModel","indentationModel"],default:ce.defaultModel,description:b.localize(53,null)},"editor.stickyScroll.scrollWithEditor":{type:"boolean",default:ce.scrollWithEditor,description:b.localize(54,null)}})}validate(ce){if(!ce||typeof ce!="object")return this.defaultValue;const Ie=ce;return{enabled:u(Ie.enabled,this.defaultValue.enabled),maxLineCount:n.clampedInt(Ie.maxLineCount,this.defaultValue.maxLineCount,1,10),defaultModel:s(Ie.defaultModel,this.defaultValue.defaultModel,["outlineModel","foldingProviderModel","indentationModel"]),scrollWithEditor:u(Ie.scrollWithEditor,this.defaultValue.scrollWithEditor)}}}class he extends I{constructor(){const ce={enabled:"on",fontSize:0,fontFamily:"",padding:!1};super(139,"inlayHints",ce,{"editor.inlayHints.enabled":{type:"string",default:ce.enabled,description:b.localize(55,null),enum:["on","onUnlessPressed","offUnlessPressed","off"],markdownEnumDescriptions:[b.localize(56,null),b.localize(57,null,f.$j?"Ctrl+Option":"Ctrl+Alt"),b.localize(58,null,f.$j?"Ctrl+Option":"Ctrl+Alt"),b.localize(59,null)]},"editor.inlayHints.fontSize":{type:"number",default:ce.fontSize,markdownDescription:b.localize(60,null,"`#editor.fontSize#`","`5`")},"editor.inlayHints.fontFamily":{type:"string",default:ce.fontFamily,markdownDescription:b.localize(61,null,"`#editor.fontFamily#`")},"editor.inlayHints.padding":{type:"boolean",default:ce.padding,description:b.localize(62,null)}})}validate(ce){if(!ce||typeof ce!="object")return this.defaultValue;const Ie=ce;return typeof Ie.enabled=="boolean"&&(Ie.enabled=Ie.enabled?"on":"off"),{enabled:s(Ie.enabled,this.defaultValue.enabled,["on","off","offUnlessPressed","onUnlessPressed"]),fontSize:n.clampedInt(Ie.fontSize,this.defaultValue.fontSize,0,100),fontFamily:t.string(Ie.fontFamily,this.defaultValue.fontFamily),padding:u(Ie.padding,this.defaultValue.padding)}}}class q extends I{constructor(){super(65,"lineDecorationsWidth",10)}validate(ce){return typeof ce=="string"&&/^\d+(\.\d+)?ch$/.test(ce)?-parseFloat(ce.substring(0,ce.length-2)):n.clampedInt(ce,this.defaultValue,0,1e3)}compute(ce,Ie,Ke){return Ke<0?n.clampedInt(-Ke*ce.fontInfo.typicalHalfwidthCharacterWidth,this.defaultValue,0,1e3):Ke}}class U extends a{constructor(){super(66,"lineHeight",e.EDITOR_FONT_DEFAULTS.lineHeight,ce=>a.clamp(ce,0,150),{markdownDescription:b.localize(63,null)})}compute(ce,Ie,Ke){return ce.fontInfo.lineHeight}}class ie extends I{constructor(){const ce={enabled:!0,size:"proportional",side:"right",showSlider:"mouseover",autohide:!1,renderCharacters:!0,maxColumn:120,scale:1};super(72,"minimap",ce,{"editor.minimap.enabled":{type:"boolean",default:ce.enabled,description:b.localize(64,null)},"editor.minimap.autohide":{type:"boolean",default:ce.autohide,description:b.localize(65,null)},"editor.minimap.size":{type:"string",enum:["proportional","fill","fit"],enumDescriptions:[b.localize(66,null),b.localize(67,null),b.localize(68,null)],default:ce.size,description:b.localize(69,null)},"editor.minimap.side":{type:"string",enum:["left","right"],default:ce.side,description:b.localize(70,null)},"editor.minimap.showSlider":{type:"string",enum:["always","mouseover"],default:ce.showSlider,description:b.localize(71,null)},"editor.minimap.scale":{type:"number",default:ce.scale,minimum:1,maximum:3,enum:[1,2,3],description:b.localize(72,null)},"editor.minimap.renderCharacters":{type:"boolean",default:ce.renderCharacters,description:b.localize(73,null)},"editor.minimap.maxColumn":{type:"number",default:ce.maxColumn,description:b.localize(74,null)}})}validate(ce){if(!ce||typeof ce!="object")return this.defaultValue;const Ie=ce;return{enabled:u(Ie.enabled,this.defaultValue.enabled),autohide:u(Ie.autohide,this.defaultValue.autohide),size:s(Ie.size,this.defaultValue.size,["proportional","fill","fit"]),side:s(Ie.side,this.defaultValue.side,["right","left"]),showSlider:s(Ie.showSlider,this.defaultValue.showSlider,["always","mouseover"]),renderCharacters:u(Ie.renderCharacters,this.defaultValue.renderCharacters),scale:n.clampedInt(Ie.scale,1,1,3),maxColumn:n.clampedInt(Ie.maxColumn,this.defaultValue.maxColumn,1,1e4)}}}function be(ue){return ue==="ctrlCmd"?f.$j?"metaKey":"ctrlKey":"altKey"}class H extends I{constructor(){super(83,"padding",{top:0,bottom:0},{"editor.padding.top":{type:"number",default:0,minimum:0,maximum:1e3,description:b.localize(75,null)},"editor.padding.bottom":{type:"number",default:0,minimum:0,maximum:1e3,description:b.localize(76,null)}})}validate(ce){if(!ce||typeof ce!="object")return this.defaultValue;const Ie=ce;return{top:n.clampedInt(Ie.top,0,0,1e3),bottom:n.clampedInt(Ie.bottom,0,0,1e3)}}}class Y extends I{constructor(){const ce={enabled:!0,cycle:!0};super(85,"parameterHints",ce,{"editor.parameterHints.enabled":{type:"boolean",default:ce.enabled,description:b.localize(77,null)},"editor.parameterHints.cycle":{type:"boolean",default:ce.cycle,description:b.localize(78,null)}})}validate(ce){if(!ce||typeof ce!="object")return this.defaultValue;const Ie=ce;return{enabled:u(Ie.enabled,this.defaultValue.enabled),cycle:u(Ie.cycle,this.defaultValue.cycle)}}}class Z extends k{constructor(){super(141)}compute(ce,Ie,Ke){return ce.pixelRatio}}class $e extends I{constructor(){const ce={other:"on",comments:"off",strings:"off"},Ie=[{type:"boolean"},{type:"string",enum:["on","inline","off"],enumDescriptions:[b.localize(79,null),b.localize(80,null),b.localize(81,null)]}];super(88,"quickSuggestions",ce,{type:"object",additionalProperties:!1,properties:{strings:{anyOf:Ie,default:ce.strings,description:b.localize(82,null)},comments:{anyOf:Ie,default:ce.comments,description:b.localize(83,null)},other:{anyOf:Ie,default:ce.other,description:b.localize(84,null)}},default:ce,markdownDescription:b.localize(85,null,"#editor.suggestOnTriggerCharacters#")}),this.defaultValue=ce}validate(ce){if(typeof ce=="boolean"){const Ue=ce?"on":"off";return{comments:Ue,strings:Ue,other:Ue}}if(!ce||typeof ce!="object")return this.defaultValue;const{other:Ie,comments:Ke,strings:Ge}=ce,_e=["on","inline","off"];let st,lt,wt;return typeof Ie=="boolean"?st=Ie?"on":"off":st=s(Ie,this.defaultValue.other,_e),typeof Ke=="boolean"?lt=Ke?"on":"off":lt=s(Ke,this.defaultValue.comments,_e),typeof Ge=="boolean"?wt=Ge?"on":"off":wt=s(Ge,this.defaultValue.strings,_e),{other:st,comments:lt,strings:wt}}}var ne;(function(ue){ue[ue.Off=0]="Off",ue[ue.On=1]="On",ue[ue.Relative=2]="Relative",ue[ue.Interval=3]="Interval",ue[ue.Custom=4]="Custom"})(ne||(e.RenderLineNumbersType=ne={}));class fe extends I{constructor(){super(67,"lineNumbers",{renderType:1,renderFn:null},{type:"string",enum:["off","on","relative","interval"],enumDescriptions:[b.localize(86,null),b.localize(87,null),b.localize(88,null),b.localize(89,null)],default:"on",description:b.localize(90,null)})}validate(ce){let Ie=this.defaultValue.renderType,Ke=this.defaultValue.renderFn;return typeof ce<"u"&&(typeof ce=="function"?(Ie=4,Ke=ce):ce==="interval"?Ie=3:ce==="relative"?Ie=2:ce==="on"?Ie=1:Ie=0),{renderType:Ie,renderFn:Ke}}}function te(ue){const ce=ue.get(97);return ce==="editable"?ue.get(90):ce!=="on"}e.filterValidationDecorations=te;class de extends I{constructor(){const ce=[],Ie={type:"number",description:b.localize(91,null)};super(101,"rulers",ce,{type:"array",items:{anyOf:[Ie,{type:["object"],properties:{column:Ie,color:{type:"string",description:b.localize(92,null),format:"color-hex"}}}]},default:ce,description:b.localize(93,null)})}validate(ce){if(Array.isArray(ce)){const Ie=[];for(const Ke of ce)if(typeof Ke=="number")Ie.push({column:n.clampedInt(Ke,0,0,1e4),color:null});else if(Ke&&typeof Ke=="object"){const Ge=Ke;Ie.push({column:n.clampedInt(Ge.column,0,0,1e4),color:Ge.color})}return Ie.sort((Ke,Ge)=>Ke.column-Ge.column),Ie}return this.defaultValue}}class pe extends I{constructor(){super(91,"readOnlyMessage",void 0)}validate(ce){return!ce||typeof ce!="object"?this.defaultValue:ce}}function Pe(ue,ce){if(typeof ue!="string")return ce;switch(ue){case"hidden":return 2;case"visible":return 3;default:return 1}}class B extends I{constructor(){const ce={vertical:1,horizontal:1,arrowSize:11,useShadows:!0,verticalHasArrows:!1,horizontalHasArrows:!1,horizontalScrollbarSize:12,horizontalSliderSize:12,verticalScrollbarSize:14,verticalSliderSize:14,handleMouseWheel:!0,alwaysConsumeMouseWheel:!0,scrollByPage:!1,ignoreHorizontalScrollbarInContentHeight:!1};super(102,"scrollbar",ce,{"editor.scrollbar.vertical":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[b.localize(94,null),b.localize(95,null),b.localize(96,null)],default:"auto",description:b.localize(97,null)},"editor.scrollbar.horizontal":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[b.localize(98,null),b.localize(99,null),b.localize(100,null)],default:"auto",description:b.localize(101,null)},"editor.scrollbar.verticalScrollbarSize":{type:"number",default:ce.verticalScrollbarSize,description:b.localize(102,null)},"editor.scrollbar.horizontalScrollbarSize":{type:"number",default:ce.horizontalScrollbarSize,description:b.localize(103,null)},"editor.scrollbar.scrollByPage":{type:"boolean",default:ce.scrollByPage,description:b.localize(104,null)},"editor.scrollbar.ignoreHorizontalScrollbarInContentHeight":{type:"boolean",default:ce.ignoreHorizontalScrollbarInContentHeight,description:b.localize(105,null)}})}validate(ce){if(!ce||typeof ce!="object")return this.defaultValue;const Ie=ce,Ke=n.clampedInt(Ie.horizontalScrollbarSize,this.defaultValue.horizontalScrollbarSize,0,1e3),Ge=n.clampedInt(Ie.verticalScrollbarSize,this.defaultValue.verticalScrollbarSize,0,1e3);return{arrowSize:n.clampedInt(Ie.arrowSize,this.defaultValue.arrowSize,0,1e3),vertical:Pe(Ie.vertical,this.defaultValue.vertical),horizontal:Pe(Ie.horizontal,this.defaultValue.horizontal),useShadows:u(Ie.useShadows,this.defaultValue.useShadows),verticalHasArrows:u(Ie.verticalHasArrows,this.defaultValue.verticalHasArrows),horizontalHasArrows:u(Ie.horizontalHasArrows,this.defaultValue.horizontalHasArrows),handleMouseWheel:u(Ie.handleMouseWheel,this.defaultValue.handleMouseWheel),alwaysConsumeMouseWheel:u(Ie.alwaysConsumeMouseWheel,this.defaultValue.alwaysConsumeMouseWheel),horizontalScrollbarSize:Ke,horizontalSliderSize:n.clampedInt(Ie.horizontalSliderSize,Ke,0,1e3),verticalScrollbarSize:Ge,verticalSliderSize:n.clampedInt(Ie.verticalSliderSize,Ge,0,1e3),scrollByPage:u(Ie.scrollByPage,this.defaultValue.scrollByPage),ignoreHorizontalScrollbarInContentHeight:u(Ie.ignoreHorizontalScrollbarInContentHeight,this.defaultValue.ignoreHorizontalScrollbarInContentHeight)}}}e.inUntrustedWorkspace="inUntrustedWorkspace",e.unicodeHighlightConfigKeys={allowedCharacters:"editor.unicodeHighlight.allowedCharacters",invisibleCharacters:"editor.unicodeHighlight.invisibleCharacters",nonBasicASCII:"editor.unicodeHighlight.nonBasicASCII",ambiguousCharacters:"editor.unicodeHighlight.ambiguousCharacters",includeComments:"editor.unicodeHighlight.includeComments",includeStrings:"editor.unicodeHighlight.includeStrings",allowedLocales:"editor.unicodeHighlight.allowedLocales"};class X extends I{constructor(){const ce={nonBasicASCII:e.inUntrustedWorkspace,invisibleCharacters:!0,ambiguousCharacters:!0,includeComments:e.inUntrustedWorkspace,includeStrings:!0,allowedCharacters:{},allowedLocales:{_os:!0,_vscode:!0}};super(124,"unicodeHighlight",ce,{[e.unicodeHighlightConfigKeys.nonBasicASCII]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:ce.nonBasicASCII,description:b.localize(106,null)},[e.unicodeHighlightConfigKeys.invisibleCharacters]:{restricted:!0,type:"boolean",default:ce.invisibleCharacters,description:b.localize(107,null)},[e.unicodeHighlightConfigKeys.ambiguousCharacters]:{restricted:!0,type:"boolean",default:ce.ambiguousCharacters,description:b.localize(108,null)},[e.unicodeHighlightConfigKeys.includeComments]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:ce.includeComments,description:b.localize(109,null)},[e.unicodeHighlightConfigKeys.includeStrings]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:ce.includeStrings,description:b.localize(110,null)},[e.unicodeHighlightConfigKeys.allowedCharacters]:{restricted:!0,type:"object",default:ce.allowedCharacters,description:b.localize(111,null),additionalProperties:{type:"boolean"}},[e.unicodeHighlightConfigKeys.allowedLocales]:{restricted:!0,type:"object",additionalProperties:{type:"boolean"},default:ce.allowedLocales,description:b.localize(112,null)}})}applyUpdate(ce,Ie){let Ke=!1;Ie.allowedCharacters&&ce&&(F.$en(ce.allowedCharacters,Ie.allowedCharacters)||(ce={...ce,allowedCharacters:Ie.allowedCharacters},Ke=!0)),Ie.allowedLocales&&ce&&(F.$en(ce.allowedLocales,Ie.allowedLocales)||(ce={...ce,allowedLocales:Ie.allowedLocales},Ke=!0));const Ge=super.applyUpdate(ce,Ie);return Ke?new $(Ge.newValue,!0):Ge}validate(ce){if(!ce||typeof ce!="object")return this.defaultValue;const Ie=ce;return{nonBasicASCII:ge(Ie.nonBasicASCII,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),invisibleCharacters:u(Ie.invisibleCharacters,this.defaultValue.invisibleCharacters),ambiguousCharacters:u(Ie.ambiguousCharacters,this.defaultValue.ambiguousCharacters),includeComments:ge(Ie.includeComments,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),includeStrings:ge(Ie.includeStrings,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),allowedCharacters:this.c(ce.allowedCharacters,this.defaultValue.allowedCharacters),allowedLocales:this.c(ce.allowedLocales,this.defaultValue.allowedLocales)}}c(ce,Ie){if(typeof ce!="object"||!ce)return Ie;const Ke={};for(const[Ge,_e]of Object.entries(ce))_e===!0&&(Ke[Ge]=!0);return Ke}}class re extends I{constructor(){const ce={enabled:!0,mode:"subwordSmart",showToolbar:"onHover",suppressSuggestions:!1,keepOnBlur:!1};super(62,"inlineSuggest",ce,{"editor.inlineSuggest.enabled":{type:"boolean",default:ce.enabled,description:b.localize(113,null)},"editor.inlineSuggest.showToolbar":{type:"string",default:ce.showToolbar,enum:["always","onHover"],enumDescriptions:[b.localize(114,null),b.localize(115,null)],description:b.localize(116,null)},"editor.inlineSuggest.suppressSuggestions":{type:"boolean",default:ce.suppressSuggestions,description:b.localize(117,null)}})}validate(ce){if(!ce||typeof ce!="object")return this.defaultValue;const Ie=ce;return{enabled:u(Ie.enabled,this.defaultValue.enabled),mode:s(Ie.mode,this.defaultValue.mode,["prefix","subword","subwordSmart"]),showToolbar:s(Ie.showToolbar,this.defaultValue.showToolbar,["always","onHover"]),suppressSuggestions:u(Ie.suppressSuggestions,this.defaultValue.suppressSuggestions),keepOnBlur:u(Ie.keepOnBlur,this.defaultValue.keepOnBlur)}}}class ae extends I{constructor(){const ce={enabled:L.$9r.bracketPairColorizationOptions.enabled,independentColorPoolPerBracketType:L.$9r.bracketPairColorizationOptions.independentColorPoolPerBracketType};super(15,"bracketPairColorization",ce,{"editor.bracketPairColorization.enabled":{type:"boolean",default:ce.enabled,markdownDescription:b.localize(118,null,"`#workbench.colorCustomizations#`")},"editor.bracketPairColorization.independentColorPoolPerBracketType":{type:"boolean",default:ce.independentColorPoolPerBracketType,description:b.localize(119,null)}})}validate(ce){if(!ce||typeof ce!="object")return this.defaultValue;const Ie=ce;return{enabled:u(Ie.enabled,this.defaultValue.enabled),independentColorPoolPerBracketType:u(Ie.independentColorPoolPerBracketType,this.defaultValue.independentColorPoolPerBracketType)}}}class ee extends I{constructor(){const ce={bracketPairs:!1,bracketPairsHorizontal:"active",highlightActiveBracketPair:!0,indentation:!0,highlightActiveIndentation:!0};super(16,"guides",ce,{"editor.guides.bracketPairs":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[b.localize(120,null),b.localize(121,null),b.localize(122,null)],default:ce.bracketPairs,description:b.localize(123,null)},"editor.guides.bracketPairsHorizontal":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[b.localize(124,null),b.localize(125,null),b.localize(126,null)],default:ce.bracketPairsHorizontal,description:b.localize(127,null)},"editor.guides.highlightActiveBracketPair":{type:"boolean",default:ce.highlightActiveBracketPair,description:b.localize(128,null)},"editor.guides.indentation":{type:"boolean",default:ce.indentation,description:b.localize(129,null)},"editor.guides.highlightActiveIndentation":{type:["boolean","string"],enum:[!0,"always",!1],enumDescriptions:[b.localize(130,null),b.localize(131,null),b.localize(132,null)],default:ce.highlightActiveIndentation,description:b.localize(133,null)}})}validate(ce){if(!ce||typeof ce!="object")return this.defaultValue;const Ie=ce;return{bracketPairs:ge(Ie.bracketPairs,this.defaultValue.bracketPairs,[!0,!1,"active"]),bracketPairsHorizontal:ge(Ie.bracketPairsHorizontal,this.defaultValue.bracketPairsHorizontal,[!0,!1,"active"]),highlightActiveBracketPair:u(Ie.highlightActiveBracketPair,this.defaultValue.highlightActiveBracketPair),indentation:u(Ie.indentation,this.defaultValue.indentation),highlightActiveIndentation:ge(Ie.highlightActiveIndentation,this.defaultValue.highlightActiveIndentation,[!0,!1,"always"])}}}function ge(ue,ce,Ie){const Ke=Ie.indexOf(ue);return Ke===-1?ce:Ie[Ke]}class ye extends I{constructor(){const ce={insertMode:"insert",filterGraceful:!0,snippetsPreventQuickSuggestions:!1,localityBonus:!1,shareSuggestSelections:!1,selectionMode:"always",showIcons:!0,showStatusBar:!1,preview:!1,previewMode:"subwordSmart",showInlineDetails:!0,showMethods:!0,showFunctions:!0,showConstructors:!0,showDeprecated:!0,matchOnWordStartOnly:!0,showFields:!0,showVariables:!0,showClasses:!0,showStructs:!0,showInterfaces:!0,showModules:!0,showProperties:!0,showEvents:!0,showOperators:!0,showUnits:!0,showValues:!0,showConstants:!0,showEnums:!0,showEnumMembers:!0,showKeywords:!0,showWords:!0,showColors:!0,showFiles:!0,showReferences:!0,showFolders:!0,showTypeParameters:!0,showSnippets:!0,showUsers:!0,showIssues:!0};super(117,"suggest",ce,{"editor.suggest.insertMode":{type:"string",enum:["insert","replace"],enumDescriptions:[b.localize(134,null),b.localize(135,null)],default:ce.insertMode,description:b.localize(136,null)},"editor.suggest.filterGraceful":{type:"boolean",default:ce.filterGraceful,description:b.localize(137,null)},"editor.suggest.localityBonus":{type:"boolean",default:ce.localityBonus,description:b.localize(138,null)},"editor.suggest.shareSuggestSelections":{type:"boolean",default:ce.shareSuggestSelections,markdownDescription:b.localize(139,null)},"editor.suggest.selectionMode":{type:"string",enum:["always","never","whenTriggerCharacter","whenQuickSuggestion"],enumDescriptions:[b.localize(140,null),b.localize(141,null),b.localize(142,null),b.localize(143,null)],default:ce.selectionMode,markdownDescription:b.localize(144,null)},"editor.suggest.snippetsPreventQuickSuggestions":{type:"boolean",default:ce.snippetsPreventQuickSuggestions,description:b.localize(145,null)},"editor.suggest.showIcons":{type:"boolean",default:ce.showIcons,description:b.localize(146,null)},"editor.suggest.showStatusBar":{type:"boolean",default:ce.showStatusBar,description:b.localize(147,null)},"editor.suggest.preview":{type:"boolean",default:ce.preview,description:b.localize(148,null)},"editor.suggest.showInlineDetails":{type:"boolean",default:ce.showInlineDetails,description:b.localize(149,null)},"editor.suggest.maxVisibleSuggestions":{type:"number",deprecationMessage:b.localize(150,null)},"editor.suggest.filteredTypes":{type:"object",deprecationMessage:b.localize(151,null)},"editor.suggest.showMethods":{type:"boolean",default:!0,markdownDescription:b.localize(152,null)},"editor.suggest.showFunctions":{type:"boolean",default:!0,markdownDescription:b.localize(153,null)},"editor.suggest.showConstructors":{type:"boolean",default:!0,markdownDescription:b.localize(154,null)},"editor.suggest.showDeprecated":{type:"boolean",default:!0,markdownDescription:b.localize(155,null)},"editor.suggest.matchOnWordStartOnly":{type:"boolean",default:!0,markdownDescription:b.localize(156,null)},"editor.suggest.showFields":{type:"boolean",default:!0,markdownDescription:b.localize(157,null)},"editor.suggest.showVariables":{type:"boolean",default:!0,markdownDescription:b.localize(158,null)},"editor.suggest.showClasses":{type:"boolean",default:!0,markdownDescription:b.localize(159,null)},"editor.suggest.showStructs":{type:"boolean",default:!0,markdownDescription:b.localize(160,null)},"editor.suggest.showInterfaces":{type:"boolean",default:!0,markdownDescription:b.localize(161,null)},"editor.suggest.showModules":{type:"boolean",default:!0,markdownDescription:b.localize(162,null)},"editor.suggest.showProperties":{type:"boolean",default:!0,markdownDescription:b.localize(163,null)},"editor.suggest.showEvents":{type:"boolean",default:!0,markdownDescription:b.localize(164,null)},"editor.suggest.showOperators":{type:"boolean",default:!0,markdownDescription:b.localize(165,null)},"editor.suggest.showUnits":{type:"boolean",default:!0,markdownDescription:b.localize(166,null)},"editor.suggest.showValues":{type:"boolean",default:!0,markdownDescription:b.localize(167,null)},"editor.suggest.showConstants":{type:"boolean",default:!0,markdownDescription:b.localize(168,null)},"editor.suggest.showEnums":{type:"boolean",default:!0,markdownDescription:b.localize(169,null)},"editor.suggest.showEnumMembers":{type:"boolean",default:!0,markdownDescription:b.localize(170,null)},"editor.suggest.showKeywords":{type:"boolean",default:!0,markdownDescription:b.localize(171,null)},"editor.suggest.showWords":{type:"boolean",default:!0,markdownDescription:b.localize(172,null)},"editor.suggest.showColors":{type:"boolean",default:!0,markdownDescription:b.localize(173,null)},"editor.suggest.showFiles":{type:"boolean",default:!0,markdownDescription:b.localize(174,null)},"editor.suggest.showReferences":{type:"boolean",default:!0,markdownDescription:b.localize(175,null)},"editor.suggest.showCustomcolors":{type:"boolean",default:!0,markdownDescription:b.localize(176,null)},"editor.suggest.showFolders":{type:"boolean",default:!0,markdownDescription:b.localize(177,null)},"editor.suggest.showTypeParameters":{type:"boolean",default:!0,markdownDescription:b.localize(178,null)},"editor.suggest.showSnippets":{type:"boolean",default:!0,markdownDescription:b.localize(179,null)},"editor.suggest.showUsers":{type:"boolean",default:!0,markdownDescription:b.localize(180,null)},"editor.suggest.showIssues":{type:"boolean",default:!0,markdownDescription:b.localize(181,null)}})}validate(ce){if(!ce||typeof ce!="object")return this.defaultValue;const Ie=ce;return{insertMode:s(Ie.insertMode,this.defaultValue.insertMode,["insert","replace"]),filterGraceful:u(Ie.filterGraceful,this.defaultValue.filterGraceful),snippetsPreventQuickSuggestions:u(Ie.snippetsPreventQuickSuggestions,this.defaultValue.filterGraceful),localityBonus:u(Ie.localityBonus,this.defaultValue.localityBonus),shareSuggestSelections:u(Ie.shareSuggestSelections,this.defaultValue.shareSuggestSelections),selectionMode:s(Ie.selectionMode,this.defaultValue.selectionMode,["always","never","whenQuickSuggestion","whenTriggerCharacter"]),showIcons:u(Ie.showIcons,this.defaultValue.showIcons),showStatusBar:u(Ie.showStatusBar,this.defaultValue.showStatusBar),preview:u(Ie.preview,this.defaultValue.preview),previewMode:s(Ie.previewMode,this.defaultValue.previewMode,["prefix","subword","subwordSmart"]),showInlineDetails:u(Ie.showInlineDetails,this.defaultValue.showInlineDetails),showMethods:u(Ie.showMethods,this.defaultValue.showMethods),showFunctions:u(Ie.showFunctions,this.defaultValue.showFunctions),showConstructors:u(Ie.showConstructors,this.defaultValue.showConstructors),showDeprecated:u(Ie.showDeprecated,this.defaultValue.showDeprecated),matchOnWordStartOnly:u(Ie.matchOnWordStartOnly,this.defaultValue.matchOnWordStartOnly),showFields:u(Ie.showFields,this.defaultValue.showFields),showVariables:u(Ie.showVariables,this.defaultValue.showVariables),showClasses:u(Ie.showClasses,this.defaultValue.showClasses),showStructs:u(Ie.showStructs,this.defaultValue.showStructs),showInterfaces:u(Ie.showInterfaces,this.defaultValue.showInterfaces),showModules:u(Ie.showModules,this.defaultValue.showModules),showProperties:u(Ie.showProperties,this.defaultValue.showProperties),showEvents:u(Ie.showEvents,this.defaultValue.showEvents),showOperators:u(Ie.showOperators,this.defaultValue.showOperators),showUnits:u(Ie.showUnits,this.defaultValue.showUnits),showValues:u(Ie.showValues,this.defaultValue.showValues),showConstants:u(Ie.showConstants,this.defaultValue.showConstants),showEnums:u(Ie.showEnums,this.defaultValue.showEnums),showEnumMembers:u(Ie.showEnumMembers,this.defaultValue.showEnumMembers),showKeywords:u(Ie.showKeywords,this.defaultValue.showKeywords),showWords:u(Ie.showWords,this.defaultValue.showWords),showColors:u(Ie.showColors,this.defaultValue.showColors),showFiles:u(Ie.showFiles,this.defaultValue.showFiles),showReferences:u(Ie.showReferences,this.defaultValue.showReferences),showFolders:u(Ie.showFolders,this.defaultValue.showFolders),showTypeParameters:u(Ie.showTypeParameters,this.defaultValue.showTypeParameters),showSnippets:u(Ie.showSnippets,this.defaultValue.showSnippets),showUsers:u(Ie.showUsers,this.defaultValue.showUsers),showIssues:u(Ie.showIssues,this.defaultValue.showIssues)}}}class je extends I{constructor(){super(112,"smartSelect",{selectLeadingAndTrailingWhitespace:!0,selectSubwords:!0},{"editor.smartSelect.selectLeadingAndTrailingWhitespace":{description:b.localize(182,null),default:!0,type:"boolean"},"editor.smartSelect.selectSubwords":{description:b.localize(183,null),default:!0,type:"boolean"}})}validate(ce){return!ce||typeof ce!="object"?this.defaultValue:{selectLeadingAndTrailingWhitespace:u(ce.selectLeadingAndTrailingWhitespace,this.defaultValue.selectLeadingAndTrailingWhitespace),selectSubwords:u(ce.selectSubwords,this.defaultValue.selectSubwords)}}}var We;(function(ue){ue[ue.None=0]="None",ue[ue.Same=1]="Same",ue[ue.Indent=2]="Indent",ue[ue.DeepIndent=3]="DeepIndent"})(We||(e.WrappingIndent=We={}));class et extends I{constructor(){super(136,"wrappingIndent",1,{"editor.wrappingIndent":{type:"string",enum:["none","same","indent","deepIndent"],enumDescriptions:[b.localize(184,null),b.localize(185,null),b.localize(186,null),b.localize(187,null)],description:b.localize(188,null),default:"same"}})}validate(ce){switch(ce){case"none":return 0;case"same":return 1;case"indent":return 2;case"deepIndent":return 3}return 1}compute(ce,Ie,Ke){return Ie.get(2)===2?0:Ke}}class Ze extends k{constructor(){super(144)}compute(ce,Ie,Ke){const Ge=Ie.get(143);return{isDominatedByLongLines:ce.isDominatedByLongLines,isWordWrapMinified:Ge.isWordWrapMinified,isViewportWrapping:Ge.isViewportWrapping,wrappingColumn:Ge.wrappingColumn}}}class rt extends I{constructor(){const ce={enabled:!0,showDropSelector:"afterDrop"};super(36,"dropIntoEditor",ce,{"editor.dropIntoEditor.enabled":{type:"boolean",default:ce.enabled,markdownDescription:b.localize(189,null)},"editor.dropIntoEditor.showDropSelector":{type:"string",markdownDescription:b.localize(190,null),enum:["afterDrop","never"],enumDescriptions:[b.localize(191,null),b.localize(192,null)],default:"afterDrop"}})}validate(ce){if(!ce||typeof ce!="object")return this.defaultValue;const Ie=ce;return{enabled:u(Ie.enabled,this.defaultValue.enabled),showDropSelector:s(Ie.showDropSelector,this.defaultValue.showDropSelector,["afterDrop","never"])}}}class nt extends I{constructor(){const ce={enabled:!0,showPasteSelector:"afterPaste"};super(84,"pasteAs",ce,{"editor.pasteAs.enabled":{type:"boolean",default:ce.enabled,markdownDescription:b.localize(193,null)},"editor.pasteAs.showPasteSelector":{type:"string",markdownDescription:b.localize(194,null),enum:["afterPaste","never"],enumDescriptions:[b.localize(195,null),b.localize(196,null)],default:"afterPaste"}})}validate(ce){if(!ce||typeof ce!="object")return this.defaultValue;const Ie=ce;return{enabled:u(Ie.enabled,this.defaultValue.enabled),showPasteSelector:s(Ie.showPasteSelector,this.defaultValue.showPasteSelector,["afterPaste","never"])}}}const Ae="Consolas, 'Courier New', monospace",Oe="Menlo, Monaco, 'Courier New', monospace",Ve="'Droid Sans Mono', 'monospace', monospace";e.EDITOR_FONT_DEFAULTS={fontFamily:f.$j?Oe:f.$k?Ve:Ae,fontWeight:"normal",fontSize:f.$j?12:14,lineHeight:0,letterSpacing:0},e.editorOptionsRegistry=[];function Le(ue){return e.editorOptionsRegistry[ue.id]=ue,ue}var Ye;(function(ue){ue[ue.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",ue[ue.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",ue[ue.accessibilitySupport=2]="accessibilitySupport",ue[ue.accessibilityPageSize=3]="accessibilityPageSize",ue[ue.ariaLabel=4]="ariaLabel",ue[ue.ariaRequired=5]="ariaRequired",ue[ue.autoClosingBrackets=6]="autoClosingBrackets",ue[ue.autoClosingComments=7]="autoClosingComments",ue[ue.screenReaderAnnounceInlineSuggestion=8]="screenReaderAnnounceInlineSuggestion",ue[ue.autoClosingDelete=9]="autoClosingDelete",ue[ue.autoClosingOvertype=10]="autoClosingOvertype",ue[ue.autoClosingQuotes=11]="autoClosingQuotes",ue[ue.autoIndent=12]="autoIndent",ue[ue.automaticLayout=13]="automaticLayout",ue[ue.autoSurround=14]="autoSurround",ue[ue.bracketPairColorization=15]="bracketPairColorization",ue[ue.guides=16]="guides",ue[ue.codeLens=17]="codeLens",ue[ue.codeLensFontFamily=18]="codeLensFontFamily",ue[ue.codeLensFontSize=19]="codeLensFontSize",ue[ue.colorDecorators=20]="colorDecorators",ue[ue.colorDecoratorsLimit=21]="colorDecoratorsLimit",ue[ue.columnSelection=22]="columnSelection",ue[ue.comments=23]="comments",ue[ue.contextmenu=24]="contextmenu",ue[ue.copyWithSyntaxHighlighting=25]="copyWithSyntaxHighlighting",ue[ue.cursorBlinking=26]="cursorBlinking",ue[ue.cursorSmoothCaretAnimation=27]="cursorSmoothCaretAnimation",ue[ue.cursorStyle=28]="cursorStyle",ue[ue.cursorSurroundingLines=29]="cursorSurroundingLines",ue[ue.cursorSurroundingLinesStyle=30]="cursorSurroundingLinesStyle",ue[ue.cursorWidth=31]="cursorWidth",ue[ue.disableLayerHinting=32]="disableLayerHinting",ue[ue.disableMonospaceOptimizations=33]="disableMonospaceOptimizations",ue[ue.domReadOnly=34]="domReadOnly",ue[ue.dragAndDrop=35]="dragAndDrop",ue[ue.dropIntoEditor=36]="dropIntoEditor",ue[ue.emptySelectionClipboard=37]="emptySelectionClipboard",ue[ue.experimentalWhitespaceRendering=38]="experimentalWhitespaceRendering",ue[ue.extraEditorClassName=39]="extraEditorClassName",ue[ue.fastScrollSensitivity=40]="fastScrollSensitivity",ue[ue.find=41]="find",ue[ue.fixedOverflowWidgets=42]="fixedOverflowWidgets",ue[ue.folding=43]="folding",ue[ue.foldingStrategy=44]="foldingStrategy",ue[ue.foldingHighlight=45]="foldingHighlight",ue[ue.foldingImportsByDefault=46]="foldingImportsByDefault",ue[ue.foldingMaximumRegions=47]="foldingMaximumRegions",ue[ue.unfoldOnClickAfterEndOfLine=48]="unfoldOnClickAfterEndOfLine",ue[ue.fontFamily=49]="fontFamily",ue[ue.fontInfo=50]="fontInfo",ue[ue.fontLigatures=51]="fontLigatures",ue[ue.fontSize=52]="fontSize",ue[ue.fontWeight=53]="fontWeight",ue[ue.fontVariations=54]="fontVariations",ue[ue.formatOnPaste=55]="formatOnPaste",ue[ue.formatOnType=56]="formatOnType",ue[ue.glyphMargin=57]="glyphMargin",ue[ue.gotoLocation=58]="gotoLocation",ue[ue.hideCursorInOverviewRuler=59]="hideCursorInOverviewRuler",ue[ue.hover=60]="hover",ue[ue.inDiffEditor=61]="inDiffEditor",ue[ue.inlineSuggest=62]="inlineSuggest",ue[ue.letterSpacing=63]="letterSpacing",ue[ue.lightbulb=64]="lightbulb",ue[ue.lineDecorationsWidth=65]="lineDecorationsWidth",ue[ue.lineHeight=66]="lineHeight",ue[ue.lineNumbers=67]="lineNumbers",ue[ue.lineNumbersMinChars=68]="lineNumbersMinChars",ue[ue.linkedEditing=69]="linkedEditing",ue[ue.links=70]="links",ue[ue.matchBrackets=71]="matchBrackets",ue[ue.minimap=72]="minimap",ue[ue.mouseStyle=73]="mouseStyle",ue[ue.mouseWheelScrollSensitivity=74]="mouseWheelScrollSensitivity",ue[ue.mouseWheelZoom=75]="mouseWheelZoom",ue[ue.multiCursorMergeOverlapping=76]="multiCursorMergeOverlapping",ue[ue.multiCursorModifier=77]="multiCursorModifier",ue[ue.multiCursorPaste=78]="multiCursorPaste",ue[ue.multiCursorLimit=79]="multiCursorLimit",ue[ue.occurrencesHighlight=80]="occurrencesHighlight",ue[ue.overviewRulerBorder=81]="overviewRulerBorder",ue[ue.overviewRulerLanes=82]="overviewRulerLanes",ue[ue.padding=83]="padding",ue[ue.pasteAs=84]="pasteAs",ue[ue.parameterHints=85]="parameterHints",ue[ue.peekWidgetDefaultFocus=86]="peekWidgetDefaultFocus",ue[ue.definitionLinkOpensInPeek=87]="definitionLinkOpensInPeek",ue[ue.quickSuggestions=88]="quickSuggestions",ue[ue.quickSuggestionsDelay=89]="quickSuggestionsDelay",ue[ue.readOnly=90]="readOnly",ue[ue.readOnlyMessage=91]="readOnlyMessage",ue[ue.renameOnType=92]="renameOnType",ue[ue.renderControlCharacters=93]="renderControlCharacters",ue[ue.renderFinalNewline=94]="renderFinalNewline",ue[ue.renderLineHighlight=95]="renderLineHighlight",ue[ue.renderLineHighlightOnlyWhenFocus=96]="renderLineHighlightOnlyWhenFocus",ue[ue.renderValidationDecorations=97]="renderValidationDecorations",ue[ue.renderWhitespace=98]="renderWhitespace",ue[ue.revealHorizontalRightPadding=99]="revealHorizontalRightPadding",ue[ue.roundedSelection=100]="roundedSelection",ue[ue.rulers=101]="rulers",ue[ue.scrollbar=102]="scrollbar",ue[ue.scrollBeyondLastColumn=103]="scrollBeyondLastColumn",ue[ue.scrollBeyondLastLine=104]="scrollBeyondLastLine",ue[ue.scrollPredominantAxis=105]="scrollPredominantAxis",ue[ue.selectionClipboard=106]="selectionClipboard",ue[ue.selectionHighlight=107]="selectionHighlight",ue[ue.selectOnLineNumbers=108]="selectOnLineNumbers",ue[ue.showFoldingControls=109]="showFoldingControls",ue[ue.showUnused=110]="showUnused",ue[ue.snippetSuggestions=111]="snippetSuggestions",ue[ue.smartSelect=112]="smartSelect",ue[ue.smoothScrolling=113]="smoothScrolling",ue[ue.stickyScroll=114]="stickyScroll",ue[ue.stickyTabStops=115]="stickyTabStops",ue[ue.stopRenderingLineAfter=116]="stopRenderingLineAfter",ue[ue.suggest=117]="suggest",ue[ue.suggestFontSize=118]="suggestFontSize",ue[ue.suggestLineHeight=119]="suggestLineHeight",ue[ue.suggestOnTriggerCharacters=120]="suggestOnTriggerCharacters",ue[ue.suggestSelection=121]="suggestSelection",ue[ue.tabCompletion=122]="tabCompletion",ue[ue.tabIndex=123]="tabIndex",ue[ue.unicodeHighlighting=124]="unicodeHighlighting",ue[ue.unusualLineTerminators=125]="unusualLineTerminators",ue[ue.useShadowDOM=126]="useShadowDOM",ue[ue.useTabStops=127]="useTabStops",ue[ue.wordBreak=128]="wordBreak",ue[ue.wordSeparators=129]="wordSeparators",ue[ue.wordWrap=130]="wordWrap",ue[ue.wordWrapBreakAfterCharacters=131]="wordWrapBreakAfterCharacters",ue[ue.wordWrapBreakBeforeCharacters=132]="wordWrapBreakBeforeCharacters",ue[ue.wordWrapColumn=133]="wordWrapColumn",ue[ue.wordWrapOverride1=134]="wordWrapOverride1",ue[ue.wordWrapOverride2=135]="wordWrapOverride2",ue[ue.wrappingIndent=136]="wrappingIndent",ue[ue.wrappingStrategy=137]="wrappingStrategy",ue[ue.showDeprecated=138]="showDeprecated",ue[ue.inlayHints=139]="inlayHints",ue[ue.editorClassName=140]="editorClassName",ue[ue.pixelRatio=141]="pixelRatio",ue[ue.tabFocusMode=142]="tabFocusMode",ue[ue.layoutInfo=143]="layoutInfo",ue[ue.wrappingInfo=144]="wrappingInfo",ue[ue.defaultColorDecorators=145]="defaultColorDecorators",ue[ue.colorDecoratorsActivatedOn=146]="colorDecoratorsActivatedOn",ue[ue.inlineCompletionsAccessibilityVerbose=147]="inlineCompletionsAccessibilityVerbose"})(Ye||(e.EditorOption=Ye={})),e.EditorOptions={acceptSuggestionOnCommitCharacter:Le(new o(0,"acceptSuggestionOnCommitCharacter",!0,{markdownDescription:b.localize(197,null)})),acceptSuggestionOnEnter:Le(new d(1,"acceptSuggestionOnEnter","on",["on","smart","off"],{markdownEnumDescriptions:["",b.localize(198,null),""],markdownDescription:b.localize(199,null)})),accessibilitySupport:Le(new h),accessibilityPageSize:Le(new n(3,"accessibilityPageSize",10,1,1073741824,{description:b.localize(200,null),tags:["accessibility"]})),ariaLabel:Le(new t(4,"ariaLabel",b.localize(201,null))),ariaRequired:Le(new o(5,"ariaRequired",!1,void 0)),screenReaderAnnounceInlineSuggestion:Le(new o(8,"screenReaderAnnounceInlineSuggestion",!0,{description:b.localize(202,null),tags:["accessibility"]})),autoClosingBrackets:Le(new d(6,"autoClosingBrackets","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",b.localize(203,null),b.localize(204,null),""],description:b.localize(205,null)})),autoClosingComments:Le(new d(7,"autoClosingComments","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",b.localize(206,null),b.localize(207,null),""],description:b.localize(208,null)})),autoClosingDelete:Le(new d(9,"autoClosingDelete","auto",["always","auto","never"],{enumDescriptions:["",b.localize(209,null),""],description:b.localize(210,null)})),autoClosingOvertype:Le(new d(10,"autoClosingOvertype","auto",["always","auto","never"],{enumDescriptions:["",b.localize(211,null),""],description:b.localize(212,null)})),autoClosingQuotes:Le(new d(11,"autoClosingQuotes","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",b.localize(213,null),b.localize(214,null),""],description:b.localize(215,null)})),autoIndent:Le(new c(12,"autoIndent",4,"full",["none","keep","brackets","advanced","full"],l,{enumDescriptions:[b.localize(216,null),b.localize(217,null),b.localize(218,null),b.localize(219,null),b.localize(220,null)],description:b.localize(221,null)})),automaticLayout:Le(new o(13,"automaticLayout",!1)),autoSurround:Le(new d(14,"autoSurround","languageDefined",["languageDefined","quotes","brackets","never"],{enumDescriptions:[b.localize(222,null),b.localize(223,null),b.localize(224,null),""],description:b.localize(225,null)})),bracketPairColorization:Le(new ae),bracketPairGuides:Le(new ee),stickyTabStops:Le(new o(115,"stickyTabStops",!1,{description:b.localize(226,null)})),codeLens:Le(new o(17,"codeLens",!0,{description:b.localize(227,null)})),codeLensFontFamily:Le(new t(18,"codeLensFontFamily","",{description:b.localize(228,null)})),codeLensFontSize:Le(new n(19,"codeLensFontSize",0,0,100,{type:"number",default:0,minimum:0,maximum:100,markdownDescription:b.localize(229,null)})),colorDecorators:Le(new o(20,"colorDecorators",!0,{description:b.localize(230,null)})),colorDecoratorActivatedOn:Le(new d(146,"colorDecoratorsActivatedOn","clickAndHover",["clickAndHover","hover","click"],{enumDescriptions:[b.localize(231,null),b.localize(232,null),b.localize(233,null)],description:b.localize(234,null)})),colorDecoratorsLimit:Le(new n(21,"colorDecoratorsLimit",500,1,1e6,{markdownDescription:b.localize(235,null)})),columnSelection:Le(new o(22,"columnSelection",!1,{description:b.localize(236,null)})),comments:Le(new E),contextmenu:Le(new o(24,"contextmenu",!0)),copyWithSyntaxHighlighting:Le(new o(25,"copyWithSyntaxHighlighting",!0,{description:b.localize(237,null)})),cursorBlinking:Le(new c(26,"cursorBlinking",1,"blink",["blink","smooth","phase","expand","solid"],m,{description:b.localize(238,null)})),cursorSmoothCaretAnimation:Le(new d(27,"cursorSmoothCaretAnimation","off",["off","explicit","on"],{enumDescriptions:[b.localize(239,null),b.localize(240,null),b.localize(241,null)],description:b.localize(242,null)})),cursorStyle:Le(new c(28,"cursorStyle",p.Line,"line",["line","block","underline","line-thin","block-outline","underline-thin"],P,{description:b.localize(243,null)})),cursorSurroundingLines:Le(new n(29,"cursorSurroundingLines",0,0,1073741824,{description:b.localize(244,null)})),cursorSurroundingLinesStyle:Le(new d(30,"cursorSurroundingLinesStyle","default",["default","all"],{enumDescriptions:[b.localize(245,null),b.localize(246,null)],markdownDescription:b.localize(247,null)})),cursorWidth:Le(new n(31,"cursorWidth",0,0,1073741824,{markdownDescription:b.localize(248,null)})),disableLayerHinting:Le(new o(32,"disableLayerHinting",!1)),disableMonospaceOptimizations:Le(new o(33,"disableMonospaceOptimizations",!1)),domReadOnly:Le(new o(34,"domReadOnly",!1)),dragAndDrop:Le(new o(35,"dragAndDrop",!0,{description:b.localize(249,null)})),emptySelectionClipboard:Le(new j),dropIntoEditor:Le(new rt),stickyScroll:Le(new Ee),experimentalWhitespaceRendering:Le(new d(38,"experimentalWhitespaceRendering","svg",["svg","font","off"],{enumDescriptions:[b.localize(250,null),b.localize(251,null),b.localize(252,null)],description:b.localize(253,null)})),extraEditorClassName:Le(new t(39,"extraEditorClassName","")),fastScrollSensitivity:Le(new a(40,"fastScrollSensitivity",5,ue=>ue<=0?5:ue,{markdownDescription:b.localize(254,null)})),find:Le(new R),fixedOverflowWidgets:Le(new o(42,"fixedOverflowWidgets",!1)),folding:Le(new o(43,"folding",!0,{description:b.localize(255,null)})),foldingStrategy:Le(new d(44,"foldingStrategy","auto",["auto","indentation"],{enumDescriptions:[b.localize(256,null),b.localize(257,null)],description:b.localize(258,null)})),foldingHighlight:Le(new o(45,"foldingHighlight",!0,{description:b.localize(259,null)})),foldingImportsByDefault:Le(new o(46,"foldingImportsByDefault",!1,{description:b.localize(260,null)})),foldingMaximumRegions:Le(new n(47,"foldingMaximumRegions",5e3,10,65e3,{description:b.localize(261,null)})),unfoldOnClickAfterEndOfLine:Le(new o(48,"unfoldOnClickAfterEndOfLine",!1,{description:b.localize(262,null)})),fontFamily:Le(new t(49,"fontFamily",e.EDITOR_FONT_DEFAULTS.fontFamily,{description:b.localize(263,null)})),fontInfo:Le(new O),fontLigatures2:Le(new T),fontSize:Le(new W),fontWeight:Le(new x),fontVariations:Le(new N),formatOnPaste:Le(new o(55,"formatOnPaste",!1,{description:b.localize(264,null)})),formatOnType:Le(new o(56,"formatOnType",!1,{description:b.localize(265,null)})),glyphMargin:Le(new o(57,"glyphMargin",!0,{description:b.localize(266,null)})),gotoLocation:Le(new le),hideCursorInOverviewRuler:Le(new o(59,"hideCursorInOverviewRuler",!1,{description:b.localize(267,null)})),hover:Le(new G),inDiffEditor:Le(new o(61,"inDiffEditor",!1)),letterSpacing:Le(new a(63,"letterSpacing",e.EDITOR_FONT_DEFAULTS.letterSpacing,ue=>a.clamp(ue,-5,20),{description:b.localize(268,null)})),lightbulb:Le(new _),lineDecorationsWidth:Le(new q),lineHeight:Le(new U),lineNumbers:Le(new fe),lineNumbersMinChars:Le(new n(68,"lineNumbersMinChars",5,1,300)),linkedEditing:Le(new o(69,"linkedEditing",!1,{description:b.localize(269,null)})),links:Le(new o(70,"links",!0,{description:b.localize(270,null)})),matchBrackets:Le(new d(71,"matchBrackets","always",["always","near","never"],{description:b.localize(271,null)})),minimap:Le(new ie),mouseStyle:Le(new d(73,"mouseStyle","text",["text","default","copy"])),mouseWheelScrollSensitivity:Le(new a(74,"mouseWheelScrollSensitivity",1,ue=>ue===0?1:ue,{markdownDescription:b.localize(272,null)})),mouseWheelZoom:Le(new o(75,"mouseWheelZoom",!1,{markdownDescription:b.localize(273,null)})),multiCursorMergeOverlapping:Le(new o(76,"multiCursorMergeOverlapping",!0,{description:b.localize(274,null)})),multiCursorModifier:Le(new c(77,"multiCursorModifier","altKey","alt",["ctrlCmd","alt"],be,{markdownEnumDescriptions:[b.localize(275,null),b.localize(276,null)],markdownDescription:b.localize(277,null)})),multiCursorPaste:Le(new d(78,"multiCursorPaste","spread",["spread","full"],{markdownEnumDescriptions:[b.localize(278,null),b.localize(279,null)],markdownDescription:b.localize(280,null)})),multiCursorLimit:Le(new n(79,"multiCursorLimit",1e4,1,1e5,{markdownDescription:b.localize(281,null)})),occurrencesHighlight:Le(new d(80,"occurrencesHighlight","singleFile",["off","singleFile","multiFile"],{markdownEnumDescriptions:[b.localize(282,null),b.localize(283,null),b.localize(284,null)],markdownDescription:b.localize(285,null)})),overviewRulerBorder:Le(new o(81,"overviewRulerBorder",!0,{description:b.localize(286,null)})),overviewRulerLanes:Le(new n(82,"overviewRulerLanes",3,0,3)),padding:Le(new H),pasteAs:Le(new nt),parameterHints:Le(new Y),peekWidgetDefaultFocus:Le(new d(86,"peekWidgetDefaultFocus","tree",["tree","editor"],{enumDescriptions:[b.localize(287,null),b.localize(288,null)],description:b.localize(289,null)})),definitionLinkOpensInPeek:Le(new o(87,"definitionLinkOpensInPeek",!1,{description:b.localize(290,null)})),quickSuggestions:Le(new $e),quickSuggestionsDelay:Le(new n(89,"quickSuggestionsDelay",10,0,1073741824,{description:b.localize(291,null)})),readOnly:Le(new o(90,"readOnly",!1)),readOnlyMessage:Le(new pe),renameOnType:Le(new o(92,"renameOnType",!1,{description:b.localize(292,null),markdownDeprecationMessage:b.localize(293,null)})),renderControlCharacters:Le(new o(93,"renderControlCharacters",!0,{description:b.localize(294,null),restricted:!0})),renderFinalNewline:Le(new d(94,"renderFinalNewline",f.$k?"dimmed":"on",["off","on","dimmed"],{description:b.localize(295,null)})),renderLineHighlight:Le(new d(95,"renderLineHighlight","line",["none","gutter","line","all"],{enumDescriptions:["","","",b.localize(296,null)],description:b.localize(297,null)})),renderLineHighlightOnlyWhenFocus:Le(new o(96,"renderLineHighlightOnlyWhenFocus",!1,{description:b.localize(298,null)})),renderValidationDecorations:Le(new d(97,"renderValidationDecorations","editable",["editable","on","off"])),renderWhitespace:Le(new d(98,"renderWhitespace","selection",["none","boundary","selection","trailing","all"],{enumDescriptions:["",b.localize(299,null),b.localize(300,null),b.localize(301,null),""],description:b.localize(302,null)})),revealHorizontalRightPadding:Le(new n(99,"revealHorizontalRightPadding",15,0,1e3)),roundedSelection:Le(new o(100,"roundedSelection",!0,{description:b.localize(303,null)})),rulers:Le(new de),scrollbar:Le(new B),scrollBeyondLastColumn:Le(new n(103,"scrollBeyondLastColumn",4,0,1073741824,{description:b.localize(304,null)})),scrollBeyondLastLine:Le(new o(104,"scrollBeyondLastLine",!0,{description:b.localize(305,null)})),scrollPredominantAxis:Le(new o(105,"scrollPredominantAxis",!0,{description:b.localize(306,null)})),selectionClipboard:Le(new o(106,"selectionClipboard",!0,{description:b.localize(307,null),included:f.$k})),selectionHighlight:Le(new o(107,"selectionHighlight",!0,{description:b.localize(308,null)})),selectOnLineNumbers:Le(new o(108,"selectOnLineNumbers",!0)),showFoldingControls:Le(new d(109,"showFoldingControls","mouseover",["always","never","mouseover"],{enumDescriptions:[b.localize(309,null),b.localize(310,null),b.localize(311,null)],description:b.localize(312,null)})),showUnused:Le(new o(110,"showUnused",!0,{description:b.localize(313,null)})),showDeprecated:Le(new o(138,"showDeprecated",!0,{description:b.localize(314,null)})),inlayHints:Le(new he),snippetSuggestions:Le(new d(111,"snippetSuggestions","inline",["top","bottom","inline","none"],{enumDescriptions:[b.localize(315,null),b.localize(316,null),b.localize(317,null),b.localize(318,null)],description:b.localize(319,null)})),smartSelect:Le(new je),smoothScrolling:Le(new o(113,"smoothScrolling",!1,{description:b.localize(320,null)})),stopRenderingLineAfter:Le(new n(116,"stopRenderingLineAfter",1e4,-1,1073741824)),suggest:Le(new ye),inlineSuggest:Le(new re),inlineCompletionsAccessibilityVerbose:Le(new o(147,"inlineCompletionsAccessibilityVerbose",!1,{description:b.localize(321,null)})),suggestFontSize:Le(new n(118,"suggestFontSize",0,0,1e3,{markdownDescription:b.localize(322,null,"`0`","`#editor.fontSize#`")})),suggestLineHeight:Le(new n(119,"suggestLineHeight",0,0,1e3,{markdownDescription:b.localize(323,null,"`0`","`#editor.lineHeight#`")})),suggestOnTriggerCharacters:Le(new o(120,"suggestOnTriggerCharacters",!0,{description:b.localize(324,null)})),suggestSelection:Le(new d(121,"suggestSelection","first",["first","recentlyUsed","recentlyUsedByPrefix"],{markdownEnumDescriptions:[b.localize(325,null),b.localize(326,null),b.localize(327,null)],description:b.localize(328,null)})),tabCompletion:Le(new d(122,"tabCompletion","off",["on","off","onlySnippets"],{enumDescriptions:[b.localize(329,null),b.localize(330,null),b.localize(331,null)],description:b.localize(332,null)})),tabIndex:Le(new n(123,"tabIndex",0,-1,1073741824)),unicodeHighlight:Le(new X),unusualLineTerminators:Le(new d(125,"unusualLineTerminators","prompt",["auto","off","prompt"],{enumDescriptions:[b.localize(333,null),b.localize(334,null),b.localize(335,null)],description:b.localize(336,null)})),useShadowDOM:Le(new o(126,"useShadowDOM",!0)),useTabStops:Le(new o(127,"useTabStops",!0,{description:b.localize(337,null)})),wordBreak:Le(new d(128,"wordBreak","normal",["normal","keepAll"],{markdownEnumDescriptions:[b.localize(338,null),b.localize(339,null)],description:b.localize(340,null)})),wordSeparators:Le(new t(129,"wordSeparators",M.$0r,{description:b.localize(341,null)})),wordWrap:Le(new d(130,"wordWrap","off",["off","on","wordWrapColumn","bounded"],{markdownEnumDescriptions:[b.localize(342,null),b.localize(343,null),b.localize(344,null),b.localize(345,null)],description:b.localize(346,null)})),wordWrapBreakAfterCharacters:Le(new t(131,"wordWrapBreakAfterCharacters"," 	})]?|/&.,;\xA2\xB0\u2032\u2033\u2030\u2103\u3001\u3002\uFF61\uFF64\uFFE0\uFF0C\uFF0E\uFF1A\uFF1B\uFF1F\uFF01\uFF05\u30FB\uFF65\u309D\u309E\u30FD\u30FE\u30FC\u30A1\u30A3\u30A5\u30A7\u30A9\u30C3\u30E3\u30E5\u30E7\u30EE\u30F5\u30F6\u3041\u3043\u3045\u3047\u3049\u3063\u3083\u3085\u3087\u308E\u3095\u3096\u31F0\u31F1\u31F2\u31F3\u31F4\u31F5\u31F6\u31F7\u31F8\u31F9\u31FA\u31FB\u31FC\u31FD\u31FE\u31FF\u3005\u303B\uFF67\uFF68\uFF69\uFF6A\uFF6B\uFF6C\uFF6D\uFF6E\uFF6F\uFF70\u201D\u3009\u300B\u300D\u300F\u3011\u3015\uFF09\uFF3D\uFF5D\uFF63")),wordWrapBreakBeforeCharacters:Le(new t(132,"wordWrapBreakBeforeCharacters","([{\u2018\u201C\u3008\u300A\u300C\u300E\u3010\u3014\uFF08\uFF3B\uFF5B\uFF62\xA3\xA5\uFF04\uFFE1\uFFE5+\uFF0B")),wordWrapColumn:Le(new n(133,"wordWrapColumn",80,1,1073741824,{markdownDescription:b.localize(347,null)})),wordWrapOverride1:Le(new d(134,"wordWrapOverride1","inherit",["off","on","inherit"])),wordWrapOverride2:Le(new d(135,"wordWrapOverride2","inherit",["off","on","inherit"])),editorClassName:Le(new z),defaultColorDecorators:Le(new o(145,"defaultColorDecorators",!1,{markdownDescription:b.localize(348,null)})),pixelRatio:Le(new Z),tabFocusMode:Le(new o(142,"tabFocusMode",!1,{markdownDescription:b.localize(349,null)})),layoutInfo:Le(new Q),wrappingInfo:Le(new Ze),wrappingIndent:Le(new et),wrappingStrategy:Le(new oe)}}),define(ke[195],Se([9,10]),function(me,e){return me.create("vs/editor/common/languages",e)}),define(ke[83],Se([1,0,78,2,168,29,178,195]),function(me,e,C,F,f,L,M,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExternalUriOpenerPriority=e.$qt=e.$pt=e.InlayHintKind=e.CommentState=e.CommentMode=e.CommentThreadState=e.CommentThreadCollapsibleState=e.Command=e.$ot=e.$nt=e.SymbolKinds=e.SymbolTag=e.$mt=e.$lt=e.SymbolKind=e.$kt=e.DocumentHighlightKind=e.SignatureHelpTriggerKind=e.CodeActionTriggerType=e.$jt=e.InlineCompletionTriggerKind=e.CompletionTriggerKind=e.CompletionItemInsertTextRule=e.CompletionItemTag=e.CompletionItemKinds=e.CompletionItemKind=e.$it=e.$ht=e.$gt=void 0;class v{constructor(T,N,O){this.offset=T,this.type=N,this.language=O,this._tokenBrand=void 0}toString(){return"("+this.offset+", "+this.type+")"}}e.$gt=v;class g{constructor(T,N){this.tokens=T,this.endState=N,this._tokenizationResultBrand=void 0}}e.$ht=g;class A{constructor(T,N){this.tokens=T,this.endState=N,this._encodedTokenizationResultBrand=void 0}}e.$it=A;var I;(function(R){R[R.Method=0]="Method",R[R.Function=1]="Function",R[R.Constructor=2]="Constructor",R[R.Field=3]="Field",R[R.Variable=4]="Variable",R[R.Class=5]="Class",R[R.Struct=6]="Struct",R[R.Interface=7]="Interface",R[R.Module=8]="Module",R[R.Property=9]="Property",R[R.Event=10]="Event",R[R.Operator=11]="Operator",R[R.Unit=12]="Unit",R[R.Value=13]="Value",R[R.Constant=14]="Constant",R[R.Enum=15]="Enum",R[R.EnumMember=16]="EnumMember",R[R.Keyword=17]="Keyword",R[R.Text=18]="Text",R[R.Color=19]="Color",R[R.File=20]="File",R[R.Reference=21]="Reference",R[R.Customcolor=22]="Customcolor",R[R.Folder=23]="Folder",R[R.TypeParameter=24]="TypeParameter",R[R.User=25]="User",R[R.Issue=26]="Issue",R[R.Snippet=27]="Snippet"})(I||(e.CompletionItemKind=I={}));var $;(function(R){const T=new Map;T.set(0,C.$1j.symbolMethod),T.set(1,C.$1j.symbolFunction),T.set(2,C.$1j.symbolConstructor),T.set(3,C.$1j.symbolField),T.set(4,C.$1j.symbolVariable),T.set(5,C.$1j.symbolClass),T.set(6,C.$1j.symbolStruct),T.set(7,C.$1j.symbolInterface),T.set(8,C.$1j.symbolModule),T.set(9,C.$1j.symbolProperty),T.set(10,C.$1j.symbolEvent),T.set(11,C.$1j.symbolOperator),T.set(12,C.$1j.symbolUnit),T.set(13,C.$1j.symbolValue),T.set(15,C.$1j.symbolEnum),T.set(14,C.$1j.symbolConstant),T.set(15,C.$1j.symbolEnum),T.set(16,C.$1j.symbolEnumMember),T.set(17,C.$1j.symbolKeyword),T.set(27,C.$1j.symbolSnippet),T.set(18,C.$1j.symbolText),T.set(19,C.$1j.symbolColor),T.set(20,C.$1j.symbolFile),T.set(21,C.$1j.symbolReference),T.set(22,C.$1j.symbolCustomColor),T.set(23,C.$1j.symbolFolder),T.set(24,C.$1j.symbolTypeParameter),T.set(25,C.$1j.account),T.set(26,C.$1j.issues);function N(x){let le=T.get(x);return le||(console.info("No codicon found for CompletionItemKind "+x),le=C.$1j.symbolProperty),le}R.toIcon=N;const O=new Map;O.set("method",0),O.set("function",1),O.set("constructor",2),O.set("field",3),O.set("variable",4),O.set("class",5),O.set("struct",6),O.set("interface",7),O.set("module",8),O.set("property",9),O.set("event",10),O.set("operator",11),O.set("unit",12),O.set("value",13),O.set("constant",14),O.set("enum",15),O.set("enum-member",16),O.set("enumMember",16),O.set("keyword",17),O.set("snippet",27),O.set("text",18),O.set("color",19),O.set("file",20),O.set("reference",21),O.set("customcolor",22),O.set("folder",23),O.set("type-parameter",24),O.set("typeParameter",24),O.set("account",25),O.set("issue",26);function W(x,le){let G=O.get(x);return typeof G>"u"&&!le&&(G=9),G}R.fromString=W})($||(e.CompletionItemKinds=$={}));var y;(function(R){R[R.Deprecated=1]="Deprecated"})(y||(e.CompletionItemTag=y={}));var k;(function(R){R[R.None=0]="None",R[R.KeepWhitespace=1]="KeepWhitespace",R[R.InsertAsSnippet=4]="InsertAsSnippet"})(k||(e.CompletionItemInsertTextRule=k={}));var w;(function(R){R[R.Invoke=0]="Invoke",R[R.TriggerCharacter=1]="TriggerCharacter",R[R.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(w||(e.CompletionTriggerKind=w={}));var u;(function(R){R[R.Automatic=0]="Automatic",R[R.Explicit=1]="Explicit"})(u||(e.InlineCompletionTriggerKind=u={}));class o{constructor(T,N,O,W){this.range=T,this.text=N,this.completionKind=O,this.isSnippetText=W}equals(T){return L.$zs.lift(this.range).equalsRange(T.range)&&this.text===T.text&&this.completionKind===T.completionKind&&this.isSnippetText===T.isSnippetText}}e.$jt=o;var i;(function(R){R[R.Invoke=1]="Invoke",R[R.Auto=2]="Auto"})(i||(e.CodeActionTriggerType=i={}));var n;(function(R){R[R.Invoke=1]="Invoke",R[R.TriggerCharacter=2]="TriggerCharacter",R[R.ContentChange=3]="ContentChange"})(n||(e.SignatureHelpTriggerKind=n={}));var r;(function(R){R[R.Text=0]="Text",R[R.Read=1]="Read",R[R.Write=2]="Write"})(r||(e.DocumentHighlightKind=r={}));function a(R){return R&&F.URI.isUri(R.uri)&&L.$zs.isIRange(R.range)&&(L.$zs.isIRange(R.originSelectionRange)||L.$zs.isIRange(R.targetSelectionRange))}e.$kt=a;var t;(function(R){R[R.File=0]="File",R[R.Module=1]="Module",R[R.Namespace=2]="Namespace",R[R.Package=3]="Package",R[R.Class=4]="Class",R[R.Method=5]="Method",R[R.Property=6]="Property",R[R.Field=7]="Field",R[R.Constructor=8]="Constructor",R[R.Enum=9]="Enum",R[R.Interface=10]="Interface",R[R.Function=11]="Function",R[R.Variable=12]="Variable",R[R.Constant=13]="Constant",R[R.String=14]="String",R[R.Number=15]="Number",R[R.Boolean=16]="Boolean",R[R.Array=17]="Array",R[R.Object=18]="Object",R[R.Key=19]="Key",R[R.Null=20]="Null",R[R.EnumMember=21]="EnumMember",R[R.Struct=22]="Struct",R[R.Event=23]="Event",R[R.Operator=24]="Operator",R[R.TypeParameter=25]="TypeParameter"})(t||(e.SymbolKind=t={})),e.$lt={[17]:(0,b.localize)(0,null),[16]:(0,b.localize)(1,null),[4]:(0,b.localize)(2,null),[13]:(0,b.localize)(3,null),[8]:(0,b.localize)(4,null),[9]:(0,b.localize)(5,null),[21]:(0,b.localize)(6,null),[23]:(0,b.localize)(7,null),[7]:(0,b.localize)(8,null),[0]:(0,b.localize)(9,null),[11]:(0,b.localize)(10,null),[10]:(0,b.localize)(11,null),[19]:(0,b.localize)(12,null),[5]:(0,b.localize)(13,null),[1]:(0,b.localize)(14,null),[2]:(0,b.localize)(15,null),[20]:(0,b.localize)(16,null),[15]:(0,b.localize)(17,null),[18]:(0,b.localize)(18,null),[24]:(0,b.localize)(19,null),[3]:(0,b.localize)(20,null),[6]:(0,b.localize)(21,null),[14]:(0,b.localize)(22,null),[22]:(0,b.localize)(23,null),[25]:(0,b.localize)(24,null),[12]:(0,b.localize)(25,null)};function s(R,T){return(0,b.localize)(26,null,R,e.$lt[T])}e.$mt=s;var d;(function(R){R[R.Deprecated=1]="Deprecated"})(d||(e.SymbolTag=d={}));var c;(function(R){const T=new Map;T.set(0,C.$1j.symbolFile),T.set(1,C.$1j.symbolModule),T.set(2,C.$1j.symbolNamespace),T.set(3,C.$1j.symbolPackage),T.set(4,C.$1j.symbolClass),T.set(5,C.$1j.symbolMethod),T.set(6,C.$1j.symbolProperty),T.set(7,C.$1j.symbolField),T.set(8,C.$1j.symbolConstructor),T.set(9,C.$1j.symbolEnum),T.set(10,C.$1j.symbolInterface),T.set(11,C.$1j.symbolFunction),T.set(12,C.$1j.symbolVariable),T.set(13,C.$1j.symbolConstant),T.set(14,C.$1j.symbolString),T.set(15,C.$1j.symbolNumber),T.set(16,C.$1j.symbolBoolean),T.set(17,C.$1j.symbolArray),T.set(18,C.$1j.symbolObject),T.set(19,C.$1j.symbolKey),T.set(20,C.$1j.symbolNull),T.set(21,C.$1j.symbolEnumMember),T.set(22,C.$1j.symbolStruct),T.set(23,C.$1j.symbolEvent),T.set(24,C.$1j.symbolOperator),T.set(25,C.$1j.symbolTypeParameter);function N(O){let W=T.get(O);return W||(console.info("No codicon found for SymbolKind "+O),W=C.$1j.symbolProperty),W}R.toIcon=N})(c||(e.SymbolKinds=c={}));class l{static asEditOperation(T){return f.$As.replace(L.$zs.lift(T.range),T.text)}}e.$nt=l;class h{static{this.Comment=new h("comment")}static{this.Imports=new h("imports")}static{this.Region=new h("region")}static fromValue(T){switch(T){case"comment":return h.Comment;case"imports":return h.Imports;case"region":return h.Region}return new h(T)}constructor(T){this.value=T}}e.$ot=h;var E;(function(R){function T(N){return!N||typeof N!="object"?!1:typeof N.id=="string"&&typeof N.title=="string"}R.is=T})(E||(e.Command=E={}));var D;(function(R){R[R.Collapsed=0]="Collapsed",R[R.Expanded=1]="Expanded"})(D||(e.CommentThreadCollapsibleState=D={}));var m;(function(R){R[R.Unresolved=0]="Unresolved",R[R.Resolved=1]="Resolved"})(m||(e.CommentThreadState=m={}));var p;(function(R){R[R.Editing=0]="Editing",R[R.Preview=1]="Preview"})(p||(e.CommentMode=p={}));var S;(function(R){R[R.Published=0]="Published",R[R.Draft=1]="Draft"})(S||(e.CommentState=S={}));var P;(function(R){R[R.Type=1]="Type",R[R.Parameter=2]="Parameter"})(P||(e.InlayHintKind=P={}));class z{constructor(T){this.b=T,this.a=null}dispose(){this.a&&this.a.then(T=>{T&&T.dispose()})}get tokenizationSupport(){return this.a||(this.a=this.b()),this.a}}e.$pt=z,e.$qt=new M.$$s;var j;(function(R){R[R.None=0]="None",R[R.Option=1]="Option",R[R.Default=2]="Default",R[R.Preferred=3]="Preferred"})(j||(e.ExternalUriOpenerPriority=j={}))}),define(ke[196],Se([9,10]),function(me,e){return me.create("vs/platform/configuration/common/configurationRegistry",e)}),define(ke[197],Se([9,10]),function(me,e){return me.create("vs/platform/contextkey/common/contextkey",e)}),define(ke[198],Se([9,10]),function(me,e){return me.create("vs/platform/contextkey/common/scanner",e)}),define(ke[199],Se([9,10]),function(me,e){return me.create("vs/platform/dialogs/common/dialogs",e)}),define(ke[200],Se([9,10]),function(me,e){return me.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(ke[201],Se([9,10]),function(me,e){return me.create("vs/platform/extensions/common/extensionValidator",e)}),define(ke[202],Se([9,10]),function(me,e){return me.create("vs/platform/externalTerminal/node/externalTerminalService",e)}),define(ke[203],Se([9,10]),function(me,e){return me.create("vs/platform/files/common/files",e)}),define(ke[204],Se([9,10]),function(me,e){return me.create("vs/platform/files/common/io",e)}),define(ke[205],Se([9,10]),function(me,e){return me.create("vs/platform/files/node/diskFileSystemProvider",e)}),define(ke[206],Se([9,10]),function(me,e){return me.create("vs/platform/markers/common/markers",e)}),define(ke[207],Se([9,10]),function(me,e){return me.create("vs/platform/theme/common/iconRegistry",e)}),define(ke[208],Se([9,10]),function(me,e){return me.create("vs/platform/userDataProfile/common/userDataProfile",e)}),define(ke[209],Se([9,10]),function(me,e){return me.create("vs/platform/workspace/common/workspace",e)}),define(ke[210],Se([9,10]),function(me,e){return me.create("vs/workbench/api/common/extHostChatAgents2",e)}),define(ke[211],Se([9,10]),function(me,e){return me.create("vs/workbench/api/common/extHostDiagnostics",e)}),define(ke[212],Se([9,10]),function(me,e){return me.create("vs/workbench/api/common/extHostExtensionService",e)}),define(ke[213],Se([9,10]),function(me,e){return me.create("vs/workbench/api/common/extHostLanguageFeatures",e)}),define(ke[214],Se([9,10]),function(me,e){return me.create("vs/workbench/api/common/extHostLogService",e)}),define(ke[215],Se([9,10]),function(me,e){return me.create("vs/workbench/api/common/extHostNotebook",e)}),define(ke[216],Se([9,10]),function(me,e){return me.create("vs/workbench/api/common/extHostProgress",e)}),define(ke[217],Se([9,10]),function(me,e){return me.create("vs/workbench/api/common/extHostStatusBar",e)}),define(ke[218],Se([9,10]),function(me,e){return me.create("vs/workbench/api/common/extHostTelemetry",e)}),define(ke[219],Se([9,10]),function(me,e){return me.create("vs/workbench/api/common/extHostTerminalService",e)}),define(ke[220],Se([9,10]),function(me,e){return me.create("vs/workbench/api/common/extHostTreeViews",e)}),define(ke[221],Se([9,10]),function(me,e){return me.create("vs/workbench/api/common/extHostTunnelService",e)}),define(ke[222],Se([9,10]),function(me,e){return me.create("vs/workbench/api/common/extHostWorkspace",e)}),define(ke[223],Se([9,10]),function(me,e){return me.create("vs/workbench/api/node/extHostDebugService",e)}),define(ke[224],Se([9,10]),function(me,e){return me.create("vs/workbench/common/configuration",e)}),define(ke[225],Se([9,10]),function(me,e){return me.create("vs/workbench/common/editor",e)}),define(ke[226],Se([9,10]),function(me,e){return me.create("vs/workbench/common/views",e)}),define(ke[227],Se([9,10]),function(me,e){return me.create("vs/workbench/contrib/debug/common/abstractDebugAdapter",e)}),define(ke[228],Se([9,10]),function(me,e){return me.create("vs/workbench/contrib/debug/common/debug",e)}),define(ke[229],Se([9,10]),function(me,e){return me.create("vs/workbench/contrib/debug/node/debugAdapter",e)}),define(ke[230],Se([9,10]),function(me,e){return me.create("vs/workbench/contrib/tasks/common/taskDefinitionRegistry",e)}),define(ke[231],Se([9,10]),function(me,e){return me.create("vs/workbench/contrib/tasks/common/tasks",e)}),define(ke[232],Se([9,10]),function(me,e){return me.create("vs/workbench/services/configurationResolver/common/variableResolver",e)}),define(ke[233],Se([9,10]),function(me,e){return me.create("vs/workbench/services/editor/common/editorResolverService",e)}),define(ke[234],Se([9,10]),function(me,e){return me.create("vs/workbench/services/extensions/common/extensionsRegistry",e)}),define(ke[235],Se([9,10]),function(me,e){return me.create("vs/workbench/services/remote/common/tunnelModel",e)}),define(ke[236],Se([9,10]),function(me,e){return me.create("vs/workbench/services/search/common/queryBuilder",e)}),define(ke[237],Se([1,0,8,198]),function(me,e,C,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qi=e.TokenType=void 0;var f;(function(g){g[g.LParen=0]="LParen",g[g.RParen=1]="RParen",g[g.Neg=2]="Neg",g[g.Eq=3]="Eq",g[g.NotEq=4]="NotEq",g[g.Lt=5]="Lt",g[g.LtEq=6]="LtEq",g[g.Gt=7]="Gt",g[g.GtEq=8]="GtEq",g[g.RegexOp=9]="RegexOp",g[g.RegexStr=10]="RegexStr",g[g.True=11]="True",g[g.False=12]="False",g[g.In=13]="In",g[g.Not=14]="Not",g[g.And=15]="And",g[g.Or=16]="Or",g[g.Str=17]="Str",g[g.QuotedStr=18]="QuotedStr",g[g.Error=19]="Error",g[g.EOF=20]="EOF"})(f||(e.TokenType=f={}));function L(...g){switch(g.length){case 1:return(0,F.localize)(0,null,g[0]);case 2:return(0,F.localize)(1,null,g[0],g[1]);case 3:return(0,F.localize)(2,null,g[0],g[1],g[2]);default:return}}const M=(0,F.localize)(3,null),b=(0,F.localize)(4,null);class v{constructor(){this.c="",this.d=0,this.e=0,this.f=[],this.g=[],this.m=/[a-zA-Z0-9_<>\-\./\\:\*\?\+\[\]\^,#@;"%\$\p{L}-]+/uy}static getLexeme(A){switch(A.type){case 0:return"(";case 1:return")";case 2:return"!";case 3:return A.isTripleEq?"===":"==";case 4:return A.isTripleEq?"!==":"!=";case 5:return"<";case 6:return"<=";case 7:return">=";case 8:return">=";case 9:return"=~";case 10:return A.lexeme;case 11:return"true";case 12:return"false";case 13:return"in";case 14:return"not";case 15:return"&&";case 16:return"||";case 17:return A.lexeme;case 18:return A.lexeme;case 19:return A.lexeme;case 20:return"EOF";default:throw(0,C.$7)(`unhandled token type: ${JSON.stringify(A)}; have you forgotten to add a case?`)}}static{this.a=new Set(["i","g","s","m","y","u"].map(A=>A.charCodeAt(0)))}static{this.b=new Map([["not",14],["in",13],["false",12],["true",11]])}get errors(){return this.g}reset(A){return this.c=A,this.d=0,this.e=0,this.f=[],this.g=[],this}scan(){for(;!this.r();)switch(this.d=this.e,this.i()){case 40:this.k(0);break;case 41:this.k(1);break;case 33:if(this.h(61)){const I=this.h(61);this.f.push({type:4,offset:this.d,isTripleEq:I})}else this.k(2);break;case 39:this.o();break;case 47:this.q();break;case 61:if(this.h(61)){const I=this.h(61);this.f.push({type:3,offset:this.d,isTripleEq:I})}else this.h(126)?this.k(9):this.l(L("==","=~"));break;case 60:this.k(this.h(61)?6:5);break;case 62:this.k(this.h(61)?8:7);break;case 38:this.h(38)?this.k(15):this.l(L("&&"));break;case 124:this.h(124)?this.k(16):this.l(L("||"));break;case 32:case 13:case 9:case 10:case 160:break;default:this.n()}return this.d=this.e,this.k(20),Array.from(this.f)}h(A){return this.r()||this.c.charCodeAt(this.e)!==A?!1:(this.e++,!0)}i(){return this.c.charCodeAt(this.e++)}j(){return this.r()?0:this.c.charCodeAt(this.e)}k(A){this.f.push({type:A,offset:this.d})}l(A){const I=this.d,$=this.c.substring(this.d,this.e),y={type:19,offset:this.d,lexeme:$};this.g.push({offset:I,lexeme:$,additionalInfo:A}),this.f.push(y)}n(){this.m.lastIndex=this.d;const A=this.m.exec(this.c);if(A){this.e=this.d+A[0].length;const I=this.c.substring(this.d,this.e),$=v.b.get(I);$?this.k($):this.f.push({type:17,lexeme:I,offset:this.d})}}o(){for(;this.j()!==39&&!this.r();)this.i();if(this.r()){this.l(M);return}this.i(),this.f.push({type:18,lexeme:this.c.substring(this.d+1,this.e-1),offset:this.d+1})}q(){let A=this.e,I=!1,$=!1;for(;;){if(A>=this.c.length){this.e=A,this.l(b);return}const k=this.c.charCodeAt(A);if(I)I=!1;else if(k===47&&!$){A++;break}else k===91?$=!0:k===92?I=!0:k===93&&($=!1);A++}for(;A<this.c.length&&v.a.has(this.c.charCodeAt(A));)A++;this.e=A;const y=this.c.substring(this.d,this.e);this.f.push({type:10,lexeme:y,offset:this.d})}r(){return this.e>=this.c.length}}e.$Qi=v}),define(ke[238],Se([1,0,23,39,201,386]),function(me,e,C,F,f,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xo=e.$Wo=e.$Vo=e.$Uo=e.$To=e.$So=e.$Ro=void 0;const M=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,b=/^-(\d{4})(\d{2})(\d{2})$/;function v(o){return o=o.trim(),o==="*"||M.test(o)}e.$Ro=v;function g(o){if(!v(o))return null;if(o=o.trim(),o==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const i=o.match(M);return i?{hasCaret:i[1]==="^",hasGreaterEquals:i[1]===">=",majorBase:i[2]==="x"?0:parseInt(i[2],10),majorMustEqual:i[2]!=="x",minorBase:i[4]==="x"?0:parseInt(i[4],10),minorMustEqual:i[4]!=="x",patchBase:i[6]==="x"?0:parseInt(i[6],10),patchMustEqual:i[6]!=="x",preRelease:i[8]||null}:null}e.$So=g;function A(o){if(!o)return null;const i=o.majorBase,n=o.majorMustEqual,r=o.minorBase;let a=o.minorMustEqual;const t=o.patchBase;let s=o.patchMustEqual;o.hasCaret&&(i===0||(a=!1),s=!1);let d=0;if(o.preRelease){const c=b.exec(o.preRelease);if(c){const[,l,h,E]=c;d=Date.UTC(Number(l),Number(h)-1,Number(E))}}return{majorBase:i,majorMustEqual:n,minorBase:r,minorMustEqual:a,patchBase:t,patchMustEqual:s,isMinimum:o.hasGreaterEquals,notBefore:d}}e.$To=A;function I(o,i,n){let r;typeof o=="string"?r=A(g(o)):r=o;let a;i instanceof Date?a=i.getTime():typeof i=="string"&&(a=new Date(i).getTime());let t;if(typeof n=="string"?t=A(g(n)):t=n,!r||!t)return!1;const s=r.majorBase,d=r.minorBase,c=r.patchBase;let l=t.majorBase,h=t.minorBase,E=t.patchBase;const D=t.notBefore;let m=t.majorMustEqual,p=t.minorMustEqual,S=t.patchMustEqual;return t.isMinimum?s>l?!0:s<l?!1:d>h?!0:d<h||a&&a<D?!1:c>=E:(s===1&&l===0&&(!m||!p||!S)&&(l=1,h=0,E=0,m=!0,p=!1,S=!1),s<l?!1:s>l?!m:d<h?!1:d>h?!p:c<E?!1:c>E?!S:!(a&&a<D))}e.$Uo=I;function $(o,i,n,r,a){const t=[];if(typeof r.publisher<"u"&&typeof r.publisher!="string")return t.push([F.default.Error,f.localize(0,null)]),t;if(typeof r.name!="string")return t.push([F.default.Error,f.localize(1,null,"name")]),t;if(typeof r.version!="string")return t.push([F.default.Error,f.localize(2,null,"version")]),t;if(!r.engines)return t.push([F.default.Error,f.localize(3,null,"engines")]),t;if(typeof r.engines.vscode!="string")return t.push([F.default.Error,f.localize(4,null,"engines.vscode")]),t;if(typeof r.extensionDependencies<"u"&&!u(r.extensionDependencies))return t.push([F.default.Error,f.localize(5,null,"extensionDependencies")]),t;if(typeof r.activationEvents<"u"){if(!u(r.activationEvents))return t.push([F.default.Error,f.localize(6,null,"activationEvents")]),t;if(typeof r.main>"u"&&typeof r.browser>"u")return t.push([F.default.Error,f.localize(7,null,"activationEvents","main","browser")]),t}if(typeof r.extensionKind<"u"&&typeof r.main>"u"&&t.push([F.default.Warning,f.localize(8,null,"extensionKind")]),typeof r.main<"u"){if(typeof r.main!="string")return t.push([F.default.Error,f.localize(9,null,"main")]),t;{const c=(0,C.$zg)(n,r.main);(0,C.$tg)(c,n)||t.push([F.default.Warning,f.localize(10,null,c.path,n.path)])}}if(typeof r.browser<"u"){if(typeof r.browser!="string")return t.push([F.default.Error,f.localize(11,null,"browser")]),t;{const c=(0,C.$zg)(n,r.browser);(0,C.$tg)(c,n)||t.push([F.default.Warning,f.localize(12,null,c.path,n.path)])}}if(!L.valid(r.version))return t.push([F.default.Error,f.localize(13,null)]),t;const s=[];if(!y(o,i,r,a,s))for(const c of s)t.push([F.default.Error,c]);return t}e.$Vo=$;function y(o,i,n,r,a){return r||typeof n.main>"u"&&typeof n.browser>"u"?!0:w(o,i,n.engines.vscode,a)}e.$Wo=y;function k(o,i,n){return o==="*"||w(i,n,o)}e.$Xo=k;function w(o,i,n,r=[]){const a=A(g(n));if(!a)return r.push(f.localize(14,null,n)),!1;if(a.majorBase===0){if(!a.majorMustEqual||!a.minorMustEqual)return r.push(f.localize(15,null,n)),!1}else if(!a.majorMustEqual)return r.push(f.localize(16,null,n)),!1;return I(o,i,a)?!0:(r.push(f.localize(17,null,o,n)),!1)}function u(o){if(!Array.isArray(o))return!1;for(let i=0,n=o.length;i<n;i++)if(typeof o[i]!="string")return!1;return!0}}),define(ke[105],Se([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sh=void 0;class C{constructor(f,L=[],M=!1){this.ctor=f,this.staticArguments=L,this.supportsDelayedInstantiation=M}}e.$Sh=C}),define(ke[106],Se([1,0,105]),function(me,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dr=e.$Cr=e.InstantiationType=void 0;const F=[];var f;(function(b){b[b.Eager=0]="Eager",b[b.Delayed=1]="Delayed"})(f||(e.InstantiationType=f={}));function L(b,v,g){v instanceof C.$Sh||(v=new C.$Sh(v,[],!!g)),F.push([b,v])}e.$Cr=L;function M(){return F}e.$Dr=M}),define(ke[239],Se([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$iq=e.$hq=void 0;class C{constructor(L,M){this.key=L,this.data=M,this.incoming=new Map,this.outgoing=new Map}}e.$hq=C;class F{constructor(L){this.b=L,this.a=new Map}roots(){const L=[];for(const M of this.a.values())M.outgoing.size===0&&L.push(M);return L}insertEdge(L,M){const b=this.lookupOrInsertNode(L),v=this.lookupOrInsertNode(M);b.outgoing.set(v.key,v),v.incoming.set(b.key,b)}removeNode(L){const M=this.b(L);this.a.delete(M);for(const b of this.a.values())b.outgoing.delete(M),b.incoming.delete(M)}lookupOrInsertNode(L){const M=this.b(L);let b=this.a.get(M);return b||(b=new C(M,L),this.a.set(M,b)),b}lookup(L){return this.a.get(this.b(L))}isEmpty(){return this.a.size===0}toString(){const L=[];for(const[M,b]of this.a)L.push(`${M}
	(-> incoming)[${[...b.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...b.outgoing.keys()].join(",")}]
`);return L.join(`
`)}findCycleSlow(){for(const[L,M]of this.a){const b=new Set([L]),v=this.c(M,b);if(v)return v}}c(L,M){for(const[b,v]of L.outgoing){if(M.has(b))return[...M,b].join(" -> ");M.add(b);const g=this.c(v,M);if(g)return g;M.delete(b)}}}e.$iq=F}),define(ke[5],Se([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wh=e.$Vh=e.$Uh=e._util=void 0;var C;(function(M){M.serviceIds=new Map,M.DI_TARGET="$di$target",M.DI_DEPENDENCIES="$di$dependencies";function b(v){return v[M.DI_DEPENDENCIES]||[]}M.getServiceDependencies=b})(C||(e._util=C={})),e.$Uh=f("instantiationService");function F(M,b,v){b[C.DI_TARGET]===b?b[C.DI_DEPENDENCIES].push({id:M,index:v}):(b[C.DI_DEPENDENCIES]=[{id:M,index:v}],b[C.DI_TARGET]=b)}function f(M){if(C.serviceIds.has(M))return C.serviceIds.get(M);const b=function(v,g,A){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");F(b,v,A)};return b.toString=()=>M,C.serviceIds.set(M,b),b}e.$Vh=f;function L(M){return M}e.$Wh=L}),define(ke[44],Se([1,0,18,2,5]),function(me,e,C,F,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zi=e.$yi=e.$xi=e.$wi=e.$vi=e.$ui=e.$ti=e.$si=e.ConfigurationTarget=e.$ri=e.$qi=e.$pi=void 0,e.$pi=(0,f.$Vh)("configurationService");function L(o){return o&&typeof o=="object"&&(!o.overrideIdentifier||typeof o.overrideIdentifier=="string")&&(!o.resource||o.resource instanceof F.URI)}e.$qi=L;function M(o){return o&&typeof o=="object"&&(!o.overrideIdentifiers||Array.isArray(o.overrideIdentifiers))&&!o.overrideIdentifier&&(!o.resource||o.resource instanceof F.URI)}e.$ri=M;var b;(function(o){o[o.APPLICATION=1]="APPLICATION",o[o.USER=2]="USER",o[o.USER_LOCAL=3]="USER_LOCAL",o[o.USER_REMOTE=4]="USER_REMOTE",o[o.WORKSPACE=5]="WORKSPACE",o[o.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",o[o.DEFAULT=7]="DEFAULT",o[o.MEMORY=8]="MEMORY"})(b||(e.ConfigurationTarget=b={}));function v(o){switch(o){case 1:return"APPLICATION";case 2:return"USER";case 3:return"USER_LOCAL";case 4:return"USER_REMOTE";case 5:return"WORKSPACE";case 6:return"WORKSPACE_FOLDER";case 7:return"DEFAULT";case 8:return"MEMORY"}}e.$si=v;function g(o){return o.applicationValue!==void 0||o.userValue!==void 0||o.userLocalValue!==void 0||o.userRemoteValue!==void 0||o.workspaceValue!==void 0||o.workspaceFolderValue!==void 0}e.$ti=g;function A(o,i){const n=Object.create(null);for(const r in o)I(n,r,o[r],i);return n}e.$ui=A;function I(o,i,n,r){const a=i.split("."),t=a.pop();let s=o;for(let d=0;d<a.length;d++){const c=a[d];let l=s[c];switch(typeof l){case"undefined":l=s[c]=Object.create(null);break;case"object":break;default:r(`Ignoring ${i} as ${a.slice(0,d+1).join(".")} is ${JSON.stringify(l)}`);return}s=l}if(typeof s=="object"&&s!==null)try{s[t]=n}catch{r(`Ignoring ${i} as ${a.join(".")} is ${JSON.stringify(s)}`)}else r(`Ignoring ${i} as ${a.join(".")} is ${JSON.stringify(s)}`)}e.$vi=I;function $(o,i){const n=i.split(".");y(o,n)}e.$wi=$;function y(o,i){const n=i.shift();if(i.length===0){delete o[n];return}if(Object.keys(o).indexOf(n)!==-1){const r=o[n];typeof r=="object"&&!Array.isArray(r)&&(y(r,i),Object.keys(r).length===0&&delete o[n])}}function k(o,i,n){function r(s,d){let c=s;for(const l of d){if(typeof c!="object"||c===null)return;c=c[l]}return c}const a=i.split("."),t=r(o,a);return typeof t>"u"?n:t}e.$xi=k;function w(o,i,n){Object.keys(i).forEach(r=>{r!=="__proto__"&&(r in o?C.$Ef(o[r])&&C.$Ef(i[r])?w(o[r],i[r],n):n&&(o[r]=i[r]):o[r]=i[r])})}e.$yi=w;function u(o){return o.replace(/[\[\]]/g,"")}e.$zi=u}),define(ke[45],Se([1,0,11,13,237,5,197,8]),function(me,e,C,F,f,L,M,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cj=e.$bj=e.$aj=e.$_i=e.$$i=e.$0i=e.$9i=e.$8i=e.$7i=e.$6i=e.$5i=e.$4i=e.$3i=e.$2i=e.$1i=e.$Zi=e.$Yi=e.$Xi=e.$Wi=e.$Vi=e.$Ui=e.$Ti=e.$Si=e.ContextKeyExprType=e.$Ri=void 0;const v=new Map;v.set("false",!1),v.set("true",!0),v.set("isMac",C.$j),v.set("isLinux",C.$k),v.set("isWindows",C.$i),v.set("isWeb",C.$o),v.set("isMacNative",C.$j&&!C.$o),v.set("isEdge",C.$H),v.set("isFirefox",C.$F),v.set("isChrome",C.$E),v.set("isSafari",C.$G);function g(q,U){if(v.get(q)!==void 0)throw(0,b.$6)("contextkey.setConstant(k, v) invoked with already set constant `k`");v.set(q,U)}e.$Ri=g;const A=Object.prototype.hasOwnProperty;var I;(function(q){q[q.False=0]="False",q[q.True=1]="True",q[q.Defined=2]="Defined",q[q.Not=3]="Not",q[q.Equals=4]="Equals",q[q.NotEquals=5]="NotEquals",q[q.And=6]="And",q[q.Regex=7]="Regex",q[q.NotRegex=8]="NotRegex",q[q.Or=9]="Or",q[q.In=10]="In",q[q.NotIn=11]="NotIn",q[q.Greater=12]="Greater",q[q.GreaterEquals=13]="GreaterEquals",q[q.Smaller=14]="Smaller",q[q.SmallerEquals=15]="SmallerEquals"})(I||(e.ContextKeyExprType=I={}));const $={regexParsingWithErrorRecovery:!0},y=(0,M.localize)(0,null),k=(0,M.localize)(1,null),w=(0,M.localize)(2,null),u=(0,M.localize)(3,null),o=(0,M.localize)(4,null),i=(0,M.localize)(5,null),n=(0,M.localize)(6,null),r=(0,M.localize)(7,null);class a{static{this.c=new Error}get lexingErrors(){return this.d.errors}get parsingErrors(){return this.h}constructor(U=$){this.k=U,this.d=new f.$Qi,this.f=[],this.g=0,this.h=[],this.v=/g|y/g}parse(U){if(U===""){this.h.push({message:y,offset:0,lexeme:"",additionalInfo:k});return}this.f=this.d.reset(U).scan(),this.g=0,this.h=[];try{const ie=this.l();if(!this.E()){const be=this.D(),H=be.type===17?i:void 0;throw this.h.push({message:o,offset:be.offset,lexeme:f.$Qi.getLexeme(be),additionalInfo:H}),a.c}return ie}catch(ie){if(ie!==a.c)throw ie;return}}l(){return this.m()}m(){const U=[this.o()];for(;this.y(16);){const ie=this.o();U.push(ie)}return U.length===1?U[0]:t.or(...U)}o(){const U=[this.s()];for(;this.y(15);){const ie=this.s();U.push(ie)}return U.length===1?U[0]:t.and(...U)}s(){if(this.y(2)){const U=this.D();switch(U.type){case 11:return this.z(),l.INSTANCE;case 12:return this.z(),h.INSTANCE;case 0:{this.z();const ie=this.l();return this.A(1,u),ie?.negate()}case 17:return this.z(),P.create(U.lexeme);default:throw this.B("KEY | true | false | '(' expression ')'",U)}}return this.t()}t(){const U=this.D();switch(U.type){case 11:return this.z(),t.true();case 12:return this.z(),t.false();case 0:{this.z();const ie=this.l();return this.A(1,u),ie}case 17:{const ie=U.lexeme;if(this.z(),this.y(9)){const H=this.D();if(!this.k.regexParsingWithErrorRecovery){if(this.z(),H.type!==10)throw this.B("REGEX",H);const Y=H.lexeme,Z=Y.lastIndexOf("/"),$e=Z===Y.length-1?void 0:this.w(Y.substring(Z+1));let ne;try{ne=new RegExp(Y.substring(1,Z),$e)}catch{throw this.B("REGEX",H)}return O.create(ie,ne)}switch(H.type){case 10:case 19:{const Y=[H.lexeme];this.z();let Z=this.D(),$e=0;for(let pe=0;pe<H.lexeme.length;pe++)H.lexeme.charCodeAt(pe)===40?$e++:H.lexeme.charCodeAt(pe)===41&&$e--;for(;!this.E()&&Z.type!==15&&Z.type!==16;){switch(Z.type){case 0:$e++;break;case 1:$e--;break;case 10:case 18:for(let pe=0;pe<Z.lexeme.length;pe++)Z.lexeme.charCodeAt(pe)===40?$e++:H.lexeme.charCodeAt(pe)===41&&$e--}if($e<0)break;Y.push(f.$Qi.getLexeme(Z)),this.z(),Z=this.D()}const ne=Y.join(""),fe=ne.lastIndexOf("/"),te=fe===ne.length-1?void 0:this.w(ne.substring(fe+1));let de;try{de=new RegExp(ne.substring(1,fe),te)}catch{throw this.B("REGEX",H)}return t.regex(ie,de)}case 18:{const Y=H.lexeme;this.z();let Z=null;if(!(0,F.$Fe)(Y)){const $e=Y.indexOf("/"),ne=Y.lastIndexOf("/");if($e!==ne&&$e>=0){const fe=Y.slice($e+1,ne),te=Y[ne+1]==="i"?"i":"";try{Z=new RegExp(fe,te)}catch{throw this.B("REGEX",H)}}}if(Z===null)throw this.B("REGEX",H);return O.create(ie,Z)}default:throw this.B("REGEX",this.D())}}if(this.y(14)){this.A(13,w);const H=this.u();return t.notIn(ie,H)}switch(this.D().type){case 3:{this.z();const H=this.u();if(this.x().type===18)return t.equals(ie,H);switch(H){case"true":return t.has(ie);case"false":return t.not(ie);default:return t.equals(ie,H)}}case 4:{this.z();const H=this.u();if(this.x().type===18)return t.notEquals(ie,H);switch(H){case"true":return t.not(ie);case"false":return t.has(ie);default:return t.notEquals(ie,H)}}case 5:return this.z(),T.create(ie,this.u());case 6:return this.z(),N.create(ie,this.u());case 7:return this.z(),j.create(ie,this.u());case 8:return this.z(),R.create(ie,this.u());case 13:return this.z(),t.in(ie,this.u());default:return t.has(ie)}}case 20:throw this.h.push({message:n,offset:U.offset,lexeme:"",additionalInfo:r}),a.c;default:throw this.B(`true | false | KEY 
	| KEY '=~' REGEX 
	| KEY ('==' | '!=' | '<' | '<=' | '>' | '>=' | 'in' | 'not' 'in') value`,this.D())}}u(){const U=this.D();switch(U.type){case 17:case 18:return this.z(),U.lexeme;case 11:return this.z(),"true";case 12:return this.z(),"false";case 13:return this.z(),"in";default:return""}}w(U){return U.replaceAll(this.v,"")}x(){return this.f[this.g-1]}y(U){return this.C(U)?(this.z(),!0):!1}z(){return this.E()||this.g++,this.x()}A(U,ie){if(this.C(U))return this.z();throw this.B(ie,this.D())}B(U,ie,be){const H=(0,M.localize)(8,null,U,f.$Qi.getLexeme(ie)),Y=ie.offset,Z=f.$Qi.getLexeme(ie);return this.h.push({message:H,offset:Y,lexeme:Z,additionalInfo:be}),a.c}C(U){return this.D().type===U}D(){return this.f[this.g]}E(){return this.D().type===20}}e.$Si=a;class t{static false(){return l.INSTANCE}static true(){return h.INSTANCE}static has(U){return E.create(U)}static equals(U,ie){return D.create(U,ie)}static notEquals(U,ie){return S.create(U,ie)}static regex(U,ie){return O.create(U,ie)}static in(U,ie){return m.create(U,ie)}static notIn(U,ie){return p.create(U,ie)}static not(U){return P.create(U)}static and(...U){return le.create(U,null,!0)}static or(...U){return G.create(U,null,!0)}static greater(U,ie){return j.create(U,ie)}static greaterEquals(U,ie){return R.create(U,ie)}static smaller(U,ie){return T.create(U,ie)}static smallerEquals(U,ie){return N.create(U,ie)}static{this.c=new a({regexParsingWithErrorRecovery:!1})}static deserialize(U){return U==null?void 0:this.c.parse(U)}}e.$Ti=t;function s(q){const U=new a({regexParsingWithErrorRecovery:!1});return q.map(ie=>(U.parse(ie),U.lexingErrors.length>0?U.lexingErrors.map(be=>({errorMessage:be.additionalInfo?(0,M.localize)(9,null,be.additionalInfo):(0,M.localize)(10,null),offset:be.offset,length:be.lexeme.length})):U.parsingErrors.length>0?U.parsingErrors.map(be=>({errorMessage:be.additionalInfo?`${be.message}. ${be.additionalInfo}`:be.message,offset:be.offset,length:be.lexeme.length})):[]))}e.$Ui=s;function d(q,U){const ie=q?q.substituteConstants():void 0,be=U?U.substituteConstants():void 0;return!ie&&!be?!0:!ie||!be?!1:ie.equals(be)}e.$Vi=d;function c(q,U){return q.cmp(U)}class l{static{this.INSTANCE=new l}constructor(){this.type=0}cmp(U){return this.type-U.type}equals(U){return U.type===this.type}substituteConstants(){return this}evaluate(U){return!1}serialize(){return"false"}keys(){return[]}map(U){return this}negate(){return h.INSTANCE}}e.$Wi=l;class h{static{this.INSTANCE=new h}constructor(){this.type=1}cmp(U){return this.type-U.type}equals(U){return U.type===this.type}substituteConstants(){return this}evaluate(U){return!0}serialize(){return"true"}keys(){return[]}map(U){return this}negate(){return l.INSTANCE}}e.$Xi=h;class E{static create(U,ie=null){const be=v.get(U);return typeof be=="boolean"?be?h.INSTANCE:l.INSTANCE:new E(U,ie)}constructor(U,ie){this.key=U,this.c=ie,this.type=2}cmp(U){return U.type!==this.type?this.type-U.type:Q(this.key,U.key)}equals(U){return U.type===this.type?this.key===U.key:!1}substituteConstants(){const U=v.get(this.key);return typeof U=="boolean"?U?h.INSTANCE:l.INSTANCE:this}evaluate(U){return!!U.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(U){return U.mapDefined(this.key)}negate(){return this.c||(this.c=P.create(this.key,this)),this.c}}e.$Yi=E;class D{static create(U,ie,be=null){if(typeof ie=="boolean")return ie?E.create(U,be):P.create(U,be);const H=v.get(U);return typeof H=="boolean"?ie===(H?"true":"false")?h.INSTANCE:l.INSTANCE:new D(U,ie,be)}constructor(U,ie,be){this.c=U,this.d=ie,this.f=be,this.type=4}cmp(U){return U.type!==this.type?this.type-U.type:oe(this.c,this.d,U.c,U.d)}equals(U){return U.type===this.type?this.c===U.c&&this.d===U.d:!1}substituteConstants(){const U=v.get(this.c);if(typeof U=="boolean"){const ie=U?"true":"false";return this.d===ie?h.INSTANCE:l.INSTANCE}return this}evaluate(U){return U.getValue(this.c)==this.d}serialize(){return`${this.c} == '${this.d}'`}keys(){return[this.c]}map(U){return U.mapEquals(this.c,this.d)}negate(){return this.f||(this.f=S.create(this.c,this.d,this)),this.f}}e.$Zi=D;class m{static create(U,ie){return new m(U,ie)}constructor(U,ie){this.d=U,this.f=ie,this.type=10,this.c=null}cmp(U){return U.type!==this.type?this.type-U.type:oe(this.d,this.f,U.d,U.f)}equals(U){return U.type===this.type?this.d===U.d&&this.f===U.f:!1}substituteConstants(){return this}evaluate(U){const ie=U.getValue(this.f),be=U.getValue(this.d);return Array.isArray(ie)?ie.includes(be):typeof be=="string"&&typeof ie=="object"&&ie!==null?A.call(ie,be):!1}serialize(){return`${this.d} in '${this.f}'`}keys(){return[this.d,this.f]}map(U){return U.mapIn(this.d,this.f)}negate(){return this.c||(this.c=p.create(this.d,this.f)),this.c}}e.$1i=m;class p{static create(U,ie){return new p(U,ie)}constructor(U,ie){this.d=U,this.f=ie,this.type=11,this.c=m.create(U,ie)}cmp(U){return U.type!==this.type?this.type-U.type:this.c.cmp(U.c)}equals(U){return U.type===this.type?this.c.equals(U.c):!1}substituteConstants(){return this}evaluate(U){return!this.c.evaluate(U)}serialize(){return`${this.d} not in '${this.f}'`}keys(){return this.c.keys()}map(U){return U.mapNotIn(this.d,this.f)}negate(){return this.c}}e.$2i=p;class S{static create(U,ie,be=null){if(typeof ie=="boolean")return ie?P.create(U,be):E.create(U,be);const H=v.get(U);return typeof H=="boolean"?ie===(H?"true":"false")?l.INSTANCE:h.INSTANCE:new S(U,ie,be)}constructor(U,ie,be){this.c=U,this.d=ie,this.f=be,this.type=5}cmp(U){return U.type!==this.type?this.type-U.type:oe(this.c,this.d,U.c,U.d)}equals(U){return U.type===this.type?this.c===U.c&&this.d===U.d:!1}substituteConstants(){const U=v.get(this.c);if(typeof U=="boolean"){const ie=U?"true":"false";return this.d===ie?l.INSTANCE:h.INSTANCE}return this}evaluate(U){return U.getValue(this.c)!=this.d}serialize(){return`${this.c} != '${this.d}'`}keys(){return[this.c]}map(U){return U.mapNotEquals(this.c,this.d)}negate(){return this.f||(this.f=D.create(this.c,this.d,this)),this.f}}e.$3i=S;class P{static create(U,ie=null){const be=v.get(U);return typeof be=="boolean"?be?l.INSTANCE:h.INSTANCE:new P(U,ie)}constructor(U,ie){this.c=U,this.d=ie,this.type=3}cmp(U){return U.type!==this.type?this.type-U.type:Q(this.c,U.c)}equals(U){return U.type===this.type?this.c===U.c:!1}substituteConstants(){const U=v.get(this.c);return typeof U=="boolean"?U?l.INSTANCE:h.INSTANCE:this}evaluate(U){return!U.getValue(this.c)}serialize(){return`!${this.c}`}keys(){return[this.c]}map(U){return U.mapNot(this.c)}negate(){return this.d||(this.d=E.create(this.c,this)),this.d}}e.$4i=P;function z(q,U){if(typeof q=="string"){const ie=parseFloat(q);isNaN(ie)||(q=ie)}return typeof q=="string"||typeof q=="number"?U(q):l.INSTANCE}class j{static create(U,ie,be=null){return z(ie,H=>new j(U,H,be))}constructor(U,ie,be){this.c=U,this.d=ie,this.f=be,this.type=12}cmp(U){return U.type!==this.type?this.type-U.type:oe(this.c,this.d,U.c,U.d)}equals(U){return U.type===this.type?this.c===U.c&&this.d===U.d:!1}substituteConstants(){return this}evaluate(U){return typeof this.d=="string"?!1:parseFloat(U.getValue(this.c))>this.d}serialize(){return`${this.c} > ${this.d}`}keys(){return[this.c]}map(U){return U.mapGreater(this.c,this.d)}negate(){return this.f||(this.f=N.create(this.c,this.d,this)),this.f}}e.$5i=j;class R{static create(U,ie,be=null){return z(ie,H=>new R(U,H,be))}constructor(U,ie,be){this.c=U,this.d=ie,this.f=be,this.type=13}cmp(U){return U.type!==this.type?this.type-U.type:oe(this.c,this.d,U.c,U.d)}equals(U){return U.type===this.type?this.c===U.c&&this.d===U.d:!1}substituteConstants(){return this}evaluate(U){return typeof this.d=="string"?!1:parseFloat(U.getValue(this.c))>=this.d}serialize(){return`${this.c} >= ${this.d}`}keys(){return[this.c]}map(U){return U.mapGreaterEquals(this.c,this.d)}negate(){return this.f||(this.f=T.create(this.c,this.d,this)),this.f}}e.$6i=R;class T{static create(U,ie,be=null){return z(ie,H=>new T(U,H,be))}constructor(U,ie,be){this.c=U,this.d=ie,this.f=be,this.type=14}cmp(U){return U.type!==this.type?this.type-U.type:oe(this.c,this.d,U.c,U.d)}equals(U){return U.type===this.type?this.c===U.c&&this.d===U.d:!1}substituteConstants(){return this}evaluate(U){return typeof this.d=="string"?!1:parseFloat(U.getValue(this.c))<this.d}serialize(){return`${this.c} < ${this.d}`}keys(){return[this.c]}map(U){return U.mapSmaller(this.c,this.d)}negate(){return this.f||(this.f=R.create(this.c,this.d,this)),this.f}}e.$7i=T;class N{static create(U,ie,be=null){return z(ie,H=>new N(U,H,be))}constructor(U,ie,be){this.c=U,this.d=ie,this.f=be,this.type=15}cmp(U){return U.type!==this.type?this.type-U.type:oe(this.c,this.d,U.c,U.d)}equals(U){return U.type===this.type?this.c===U.c&&this.d===U.d:!1}substituteConstants(){return this}evaluate(U){return typeof this.d=="string"?!1:parseFloat(U.getValue(this.c))<=this.d}serialize(){return`${this.c} <= ${this.d}`}keys(){return[this.c]}map(U){return U.mapSmallerEquals(this.c,this.d)}negate(){return this.f||(this.f=j.create(this.c,this.d,this)),this.f}}e.$8i=N;class O{static create(U,ie){return new O(U,ie)}constructor(U,ie){this.d=U,this.f=ie,this.type=7,this.c=null}cmp(U){if(U.type!==this.type)return this.type-U.type;if(this.d<U.d)return-1;if(this.d>U.d)return 1;const ie=this.f?this.f.source:"",be=U.f?U.f.source:"";return ie<be?-1:ie>be?1:0}equals(U){if(U.type===this.type){const ie=this.f?this.f.source:"",be=U.f?U.f.source:"";return this.d===U.d&&ie===be}return!1}substituteConstants(){return this}evaluate(U){const ie=U.getValue(this.d);return this.f?this.f.test(ie):!1}serialize(){const U=this.f?`/${this.f.source}/${this.f.flags}`:"/invalid/";return`${this.d} =~ ${U}`}keys(){return[this.d]}map(U){return U.mapRegex(this.d,this.f)}negate(){return this.c||(this.c=W.create(this)),this.c}}e.$9i=O;class W{static create(U){return new W(U)}constructor(U){this.c=U,this.type=8}cmp(U){return U.type!==this.type?this.type-U.type:this.c.cmp(U.c)}equals(U){return U.type===this.type?this.c.equals(U.c):!1}substituteConstants(){return this}evaluate(U){return!this.c.evaluate(U)}serialize(){return`!(${this.c.serialize()})`}keys(){return this.c.keys()}map(U){return new W(this.c.map(U))}negate(){return this.c}}e.$0i=W;function x(q){let U=null;for(let ie=0,be=q.length;ie<be;ie++){const H=q[ie].substituteConstants();if(q[ie]!==H&&U===null){U=[];for(let Y=0;Y<ie;Y++)U[Y]=q[Y]}U!==null&&(U[ie]=H)}return U===null?q:U}class le{static create(U,ie,be){return le.d(U,ie,be)}constructor(U,ie){this.expr=U,this.c=ie,this.type=6}cmp(U){if(U.type!==this.type)return this.type-U.type;if(this.expr.length<U.expr.length)return-1;if(this.expr.length>U.expr.length)return 1;for(let ie=0,be=this.expr.length;ie<be;ie++){const H=c(this.expr[ie],U.expr[ie]);if(H!==0)return H}return 0}equals(U){if(U.type===this.type){if(this.expr.length!==U.expr.length)return!1;for(let ie=0,be=this.expr.length;ie<be;ie++)if(!this.expr[ie].equals(U.expr[ie]))return!1;return!0}return!1}substituteConstants(){const U=x(this.expr);return U===this.expr?this:le.create(U,this.c,!1)}evaluate(U){for(let ie=0,be=this.expr.length;ie<be;ie++)if(!this.expr[ie].evaluate(U))return!1;return!0}static d(U,ie,be){const H=[];let Y=!1;for(const Z of U)if(Z){if(Z.type===1){Y=!0;continue}if(Z.type===0)return l.INSTANCE;if(Z.type===6){H.push(...Z.expr);continue}H.push(Z)}if(H.length===0&&Y)return h.INSTANCE;if(H.length!==0){if(H.length===1)return H[0];H.sort(c);for(let Z=1;Z<H.length;Z++)H[Z-1].equals(H[Z])&&(H.splice(Z,1),Z--);if(H.length===1)return H[0];for(;H.length>1;){const Z=H[H.length-1];if(Z.type!==9)break;H.pop();const $e=H.pop(),ne=H.length===0,fe=G.create(Z.expr.map(te=>le.create([te,$e],null,be)),null,ne);fe&&(H.push(fe),H.sort(c))}if(H.length===1)return H[0];if(be){for(let Z=0;Z<H.length;Z++)for(let $e=Z+1;$e<H.length;$e++)if(H[Z].negate().equals(H[$e]))return l.INSTANCE;if(H.length===1)return H[0]}return new le(H,ie)}}serialize(){return this.expr.map(U=>U.serialize()).join(" && ")}keys(){const U=[];for(const ie of this.expr)U.push(...ie.keys());return U}map(U){return new le(this.expr.map(ie=>ie.map(U)),null)}negate(){if(!this.c){const U=[];for(const ie of this.expr)U.push(ie.negate());this.c=G.create(U,this,!0)}return this.c}}e.$$i=le;class G{static create(U,ie,be){return G.d(U,ie,be)}constructor(U,ie){this.expr=U,this.c=ie,this.type=9}cmp(U){if(U.type!==this.type)return this.type-U.type;if(this.expr.length<U.expr.length)return-1;if(this.expr.length>U.expr.length)return 1;for(let ie=0,be=this.expr.length;ie<be;ie++){const H=c(this.expr[ie],U.expr[ie]);if(H!==0)return H}return 0}equals(U){if(U.type===this.type){if(this.expr.length!==U.expr.length)return!1;for(let ie=0,be=this.expr.length;ie<be;ie++)if(!this.expr[ie].equals(U.expr[ie]))return!1;return!0}return!1}substituteConstants(){const U=x(this.expr);return U===this.expr?this:G.create(U,this.c,!1)}evaluate(U){for(let ie=0,be=this.expr.length;ie<be;ie++)if(this.expr[ie].evaluate(U))return!0;return!1}static d(U,ie,be){let H=[],Y=!1;if(U){for(let Z=0,$e=U.length;Z<$e;Z++){const ne=U[Z];if(ne){if(ne.type===0){Y=!0;continue}if(ne.type===1)return h.INSTANCE;if(ne.type===9){H=H.concat(ne.expr);continue}H.push(ne)}}if(H.length===0&&Y)return l.INSTANCE;H.sort(c)}if(H.length!==0){if(H.length===1)return H[0];for(let Z=1;Z<H.length;Z++)H[Z-1].equals(H[Z])&&(H.splice(Z,1),Z--);if(H.length===1)return H[0];if(be){for(let Z=0;Z<H.length;Z++)for(let $e=Z+1;$e<H.length;$e++)if(H[Z].negate().equals(H[$e]))return h.INSTANCE;if(H.length===1)return H[0]}return new G(H,ie)}}serialize(){return this.expr.map(U=>U.serialize()).join(" || ")}keys(){const U=[];for(const ie of this.expr)U.push(...ie.keys());return U}map(U){return new G(this.expr.map(ie=>ie.map(U)),null)}negate(){if(!this.c){const U=[];for(const ie of this.expr)U.push(ie.negate());for(;U.length>1;){const ie=U.shift(),be=U.shift(),H=[];for(const Y of he(ie))for(const Z of he(be))H.push(le.create([Y,Z],null,!1));U.unshift(G.create(H,null,!1))}this.c=G.create(U,this,!0)}return this.c}}e.$_i=G;class J extends E{static{this.d=[]}static all(){return J.d.values()}constructor(U,ie,be){super(U,null),this.f=ie,typeof be=="object"?J.d.push({...be,key:U}):be!==!0&&J.d.push({key:U,description:be,type:ie!=null?typeof ie:void 0})}bindTo(U){return U.createKey(this.key,this.f)}getValue(U){return U.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(U){return D.create(this.key,U)}notEqualsTo(U){return S.create(this.key,U)}}e.$aj=J,e.$bj=(0,L.$Vh)("contextKeyService");function Q(q,U){return q<U?-1:q>U?1:0}function oe(q,U,ie,be){return q<ie?-1:q>ie?1:U<be?-1:U>be?1:0}function _(q,U){if(q.type===0||U.type===1)return!0;if(q.type===9)return U.type===9?Ee(q.expr,U.expr):!1;if(U.type===9){for(const ie of U.expr)if(_(q,ie))return!0;return!1}if(q.type===6){if(U.type===6)return Ee(U.expr,q.expr);for(const ie of q.expr)if(_(ie,U))return!0;return!1}return q.equals(U)}e.$cj=_;function Ee(q,U){let ie=0,be=0;for(;ie<q.length&&be<U.length;){const H=q[ie].cmp(U[be]);if(H<0)return!1;H===0&&ie++,be++}return ie===q.length}function he(q){return q.type===9?q.expr:[q]}}),define(ke[240],Se([1,0,23,39,199,5,102,11,24]),function(me,e,C,F,f,L,M,b,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lv=e.$Kv=e.ConfirmResult=e.$Jv=e.$Iv=e.$Hv=void 0,e.$Hv=(0,L.$Vh)("dialogService");var g;(function(w){w[w.Confirmation=1]="Confirmation",w[w.Prompt=2]="Prompt",w[w.Input=3]="Input"})(g||(g={}));class A{a(u){return this.d(u,g.Confirmation)}b(u){return this.d(u,g.Prompt)}c(u){return this.d(u,g.Input)}d(u,o){const i=[];switch(o){case g.Confirmation:{const n=u;n.primaryButton?i.push(n.primaryButton):i.push((0,f.localize)(0,null)),n.cancelButton?i.push(n.cancelButton):i.push((0,f.localize)(1,null));break}case g.Prompt:{const n=u;Array.isArray(n.buttons)&&n.buttons.length>0&&i.push(...n.buttons.map(r=>r.label)),n.cancelButton&&(n.cancelButton===!0?i.push((0,f.localize)(2,null)):typeof n.cancelButton=="string"?i.push(n.cancelButton):n.cancelButton.label?i.push(n.cancelButton.label):i.push((0,f.localize)(3,null))),i.length===0&&i.push((0,f.localize)(4,null));break}case g.Input:{const n=u;n.primaryButton?i.push(n.primaryButton):i.push((0,f.localize)(5,null)),n.cancelButton?i.push(n.cancelButton):i.push((0,f.localize)(6,null));break}}return i}e(u){if(typeof u=="string")return u;if(typeof u=="number")return u===F.default.Info?"info":u===F.default.Error?"error":u===F.default.Warning?"warning":"none"}f(u,o,i){const n=[...u.buttons??[]];u.cancelButton&&typeof u.cancelButton!="string"&&typeof u.cancelButton!="boolean"&&n.push(u.cancelButton);let r=n[o]?.run({checkboxChecked:i});return r instanceof Promise||(r=Promise.resolve(r)),{result:r,checkboxChecked:i}}}e.$Iv=A,e.$Jv=(0,L.$Vh)("fileDialogService");var I;(function(w){w[w.SAVE=0]="SAVE",w[w.DONT_SAVE=1]="DONT_SAVE",w[w.CANCEL=2]="CANCEL"})(I||(e.ConfirmResult=I={}));const $=10;function y(w){const u=[];return u.push(...w.slice(0,$).map(o=>typeof o=="string"?o:(0,C.$wg)(o))),w.length>$&&(w.length-$===1?u.push((0,f.localize)(7,null)):u.push((0,f.localize)(8,null,w.length-$))),u.push(""),u.join(`
`)}e.$Kv=y;function k(w,u){const o=(0,v.$an)(w);let i=(o.buttons??[]).map(t=>(0,M.$Ev)(t)),n=(w.buttons||[]).map((t,s)=>s),r=0,a=o.cancelId??i.length-1;if(i.length>1){const t=typeof a=="number"?i[a]:void 0;if(b.$k||b.$j){if(typeof t=="string"&&i.length>1&&a!==1){i.splice(a,1),i.splice(1,0,t);const s=n[a];n.splice(a,1),n.splice(1,0,s),a=1}b.$k&&i.length>1&&(i=i.reverse(),n=n.reverse(),r=i.length-1,typeof t=="string"&&(a=r-1))}else if(b.$i&&typeof t=="string"&&i.length>1&&a!==i.length-1){i.splice(a,1),i.push(t);const s=n[a];n.splice(a,1),n.push(s),a=i.length-1}}return o.buttons=i,o.defaultId=r,o.cancelId=a,o.noLink=!0,o.title=o.title||u.nameLong,{options:o,buttonIndeces:n}}e.$Lv=k}),define(ke[134],Se([1,0,5]),function(me,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4h=e.$3h=void 0,e.$3h=(0,C.$Vh)("environmentService"),e.$4h=(0,C.$Wh)(e.$3h)}),define(ke[135],Se([1,0,200,5]),function(me,e,C,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mo=e.$lo=e.$ko=e.$jo=e.$io=e.$ho=e.$go=e.$fo=e.$eo=e.ExtensionSignaturetErrorCode=e.ExtensionManagementErrorCode=e.$do=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.$co=e.$bo=e.$ao=e.$_n=e.$$n=e.$0n=e.$9n=e.$8n=e.$7n=e.$6n=e.$5n=e.$4n=void 0,e.$4n="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.$5n=new RegExp(e.$4n),e.$6n="__web_extension",e.$7n="skipWalkthrough",e.$8n="extensionsSync",e.$9n="dependecyOrPackExtensionInstall";function f(o){switch(o){case"win32-x64":return"Windows 64 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.$0n=f;function L(o){switch(o){case"win32-x64":return"win32-x64";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.$$n=L;function M(o,i){switch(o){case 3:return i==="x64"?"win32-x64":i==="arm64"?"win32-arm64":"unknown";case 2:return i==="x64"?"linux-x64":i==="arm64"?"linux-arm64":i==="arm"?"linux-armhf":"unknown";case"alpine":return i==="x64"?"alpine-x64":i==="arm64"?"alpine-arm64":"unknown";case 1:return i==="x64"?"darwin-x64":i==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.$_n=M;function b(o,i){return i==="web"&&!o.includes("web")}e.$ao=b;function v(o,i,n){return b(i,n)?!1:o==="undefined"||o==="universal"?!0:o==="unknown"?!1:o===n}e.$bo=v;function g(o){return o&&typeof o=="object"&&typeof o.id=="string"&&(!o.uuid||typeof o.uuid=="string")}e.$co=g;var A;(function(o){o[o.NoneOrRelevance=0]="NoneOrRelevance",o[o.LastUpdatedDate=1]="LastUpdatedDate",o[o.Title=2]="Title",o[o.PublisherName=3]="PublisherName",o[o.InstallCount=4]="InstallCount",o[o.PublishedDate=10]="PublishedDate",o[o.AverageRating=6]="AverageRating",o[o.WeightedRating=12]="WeightedRating"})(A||(e.SortBy=A={}));var I;(function(o){o[o.Default=0]="Default",o[o.Ascending=1]="Ascending",o[o.Descending=2]="Descending"})(I||(e.SortOrder=I={}));var $;(function(o){o.Install="install",o.Uninstall="uninstall"})($||(e.StatisticType=$={}));var y;(function(o){o[o.None=1]="None",o[o.Install=2]="Install",o[o.Update=3]="Update",o[o.Migrate=4]="Migrate"})(y||(e.InstallOperation=y={})),e.$do=(0,F.$Vh)("extensionGalleryService");var k;(function(o){o.Unsupported="Unsupported",o.Deprecated="Deprecated",o.Malicious="Malicious",o.Incompatible="Incompatible",o.IncompatibleTargetPlatform="IncompatibleTargetPlatform",o.ReleaseVersionNotFound="ReleaseVersionNotFound",o.Invalid="Invalid",o.Download="Download",o.Extract="Extract",o.Delete="Delete",o.Rename="Rename",o.CorruptZip="CorruptZip",o.IncompleteZip="IncompleteZip",o.Signature="Signature",o.Internal="Internal"})(k||(e.ExtensionManagementErrorCode=k={}));var w;(function(o){o.UnknownError="UnknownError",o.PackageIsInvalidZip="PackageIsInvalidZip",o.SignatureArchiveIsInvalidZip="SignatureArchiveIsInvalidZip"})(w||(e.ExtensionSignaturetErrorCode=w={}));class u extends Error{constructor(i,n){super(i),this.code=n,this.name=n}}e.$eo=u,e.$fo=(0,F.$Vh)("extensionManagementService"),e.$go="extensionsIdentifiers/disabled",e.$ho="extensionsIdentifiers/enabled",e.$io=(0,F.$Vh)("IGlobalExtensionEnablementService"),e.$jo=(0,F.$Vh)("IExtensionTipsService"),e.$ko=(0,C.localize)(0,null),e.$lo={value:e.$ko,original:"Extensions"},e.$mo={value:(0,C.localize)(1,null),original:"Preferences"}}),define(ke[241],Se([1,0,5]),function(me,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$JZb=e.$IZb=void 0,e.$IZb=(0,C.$Vh)("externalTerminal"),e.$JZb="Terminal.app"}),define(ke[242],Se([1,0,50,17,16,11,101,30,104,202,241]),function(me,e,C,F,f,L,M,b,v,g,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$D8b=e.$C8b=e.$B8b=void 0;const I=g.localize(0,null);class ${async getDefaultTerminalForPlatforms(){return{windows:y.getDefaultTerminalWindows(),linux:await w.getDefaultTerminalLinuxReady(),osx:"xterm"}}}class y extends ${static{this.b="cmd.exe"}openTerminal(r,a){return this.spawnTerminal(C,r,v.$Hl(),a)}spawnTerminal(r,a,t,s){const d=a.windowsExec||y.getDefaultTerminalWindows();s&&s[1]===":"&&(s=s[0].toUpperCase()+s.substr(1));const c=f.$mc(d,".exe").toLowerCase();if(c==="cmder")return r.spawn(d,s?[s]:void 0),Promise.resolve(void 0);const l=["/c","start","/wait"];return d.indexOf(" ")>=0&&l.push('""'),l.push(d),c==="wt"&&l.push("-d ."),new Promise((h,E)=>{const D=u(process),m=r.spawn(t,l,{cwd:s,env:D});m.on("error",E),m.on("exit",()=>h())})}runInTerminal(r,a,t,s,d){const c="windowsExec"in d&&d.windowsExec?d.windowsExec:y.getDefaultTerminalWindows();return new Promise((l,h)=>{const E=`"${a} - ${I}"`,D=`""${t.join('" "')}" & pause"`,m=Object.assign({},u(process),s);Object.keys(m).filter(j=>m[j]===null).forEach(j=>delete m[j]);const p={cwd:a,env:m,windowsVerbatimArguments:!0};let S,P;f.$mc(c,".exe")==="wt"?(S=c,P=["-d",".",y.b,"/c",D]):(S=y.b,P=["/c","start",E,"/wait",c,"/c",D]),C.spawn(S,P,p).on("error",j=>{h(o(j))}),l(void 0)})}static getDefaultTerminalWindows(){if(!y.d){const r=!!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432");y.d=`${process.env.windir?process.env.windir:"C:\\Windows"}\\${r?"Sysnative":"System32"}\\cmd.exe`}return y.d}}e.$B8b=y;class k extends ${static{this.b="/usr/bin/osascript"}openTerminal(r,a){return this.spawnTerminal(C,r,a)}runInTerminal(r,a,t,s,d){const c=d.osxExec||A.$JZb;return new Promise((l,h)=>{if(c===A.$JZb||c==="iTerm.app"){const E=c===A.$JZb?"TerminalHelper":"iTermHelper",m=[F.$gg.asFileUri(`vs/workbench/contrib/externalTerminal/node/${E}.scpt`).fsPath,"-t",r||I,"-w",a];for(const P of t)m.push("-a"),m.push(P);if(s){const P=Object.assign({},u(process),s);for(const z in P){const j=P[z];j===null?(m.push("-u"),m.push(z)):(m.push("-e"),m.push(`${z}=${j}`))}}let p="";const S=C.spawn(k.b,m);S.on("error",P=>{h(o(P))}),S.stderr.on("data",P=>{p+=P.toString()}),S.on("exit",P=>{if(P===0)l(void 0);else if(p){const z=p.split(`
`,1);h(new Error(z[0]))}else h(new Error(g.localize(1,null,E,P)))})}else h(new Error(g.localize(2,null,c)))})}spawnTerminal(r,a,t){const s=a.osxExec||A.$JZb;return new Promise((d,c)=>{const l=["-a",s];t&&l.push(t);const h=u(process),E=r.spawn("/usr/bin/open",l,{cwd:t,env:h});E.on("error",c),E.on("exit",()=>d())})}}e.$C8b=k;class w extends ${static{this.b=g.localize(3,null)}openTerminal(r,a){return this.spawnTerminal(C,r,a)}runInTerminal(r,a,t,s,d){const c=d.linuxExec?Promise.resolve(d.linuxExec):w.getDefaultTerminalLinuxReady();return new Promise((l,h)=>{const E=[];c.then(D=>{D.indexOf("gnome-terminal")>=0?E.push("-x"):E.push("-e"),E.push("bash"),E.push("-c");const m=`${i(t)}; echo; read -p "${w.b}" -n1;`;E.push(`''${m}''`);const p=Object.assign({},u(process),s);Object.keys(p).filter(j=>p[j]===null).forEach(j=>delete p[j]);const S={cwd:a,env:p};let P="";const z=C.spawn(D,E,S);z.on("error",j=>{h(o(j))}),z.stderr.on("data",j=>{P+=j.toString()}),z.on("exit",j=>{if(j===0)l(void 0);else if(P){const R=P.split(`
`,1);h(new Error(R[0]))}else h(new Error(g.localize(4,null,D,j)))})})})}static async getDefaultTerminalLinuxReady(){if(!w.d)if(!L.$k)w.d=Promise.resolve("xterm");else{const r=await b.Promises.exists("/etc/debian_version");w.d=new Promise(a=>{r?a("x-terminal-emulator"):process.env.DESKTOP_SESSION==="gnome"||process.env.DESKTOP_SESSION==="gnome-classic"?a("gnome-terminal"):process.env.DESKTOP_SESSION==="kde-plasma"?a("konsole"):process.env.COLORTERM?a(process.env.COLORTERM):process.env.TERM?a(process.env.TERM):a("xterm")})}return w.d}spawnTerminal(r,a,t){const s=a.linuxExec?Promise.resolve(a.linuxExec):w.getDefaultTerminalLinuxReady();return new Promise((d,c)=>{s.then(l=>{const h=u(process),E=r.spawn(l,[],{cwd:t,env:h});E.on("error",c),E.on("exit",()=>d())})})}}e.$D8b=w;function u(n){const r={...n.env};return(0,M.$Fl)(r),r}function o(n){return"errno"in n&&n.errno==="ENOENT"&&"path"in n&&typeof n.path=="string"?new Error(g.localize(5,null,n.path)):n}function i(n){let r="";for(const a of n)a.indexOf(" ")>=0?r+='"'+a+'"':r+=a,r+=" ";return r}}),define(ke[31],Se([1,0,77,16,13,18,2,203,5,11,17,48]),function(me,e,C,F,f,L,M,b,v,g,A,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nk=e.$Mk=e.$Lk=e.$Kk=e.$Jk=e.FileKind=e.$Ik=e.$Hk=e.$Gk=e.$Fk=e.$Ek=e.$Dk=e.$Ck=e.FileOperationResult=e.$Bk=e.$Ak=e.$zk=e.$yk=e.$xk=e.FileChangeType=e.$wk=e.FileOperation=e.$vk=e.$uk=e.$tk=e.$sk=e.$rk=e.$qk=e.FileSystemProviderErrorCode=e.$pk=e.$ok=e.$nk=e.$mk=e.$lk=e.$kk=e.$jk=e.$ik=e.$hk=e.FileSystemProviderCapabilities=e.$gk=e.FilePermission=e.FileType=e.$fk=e.$ek=void 0,e.$ek=(0,v.$Vh)("fileService");function $(_){return _.create===!0}e.$fk=$;var y;(function(_){_[_.Unknown=0]="Unknown",_[_.File=1]="File",_[_.Directory=2]="Directory",_[_.SymbolicLink=64]="SymbolicLink"})(y||(e.FileType=y={}));var k;(function(_){_[_.Readonly=1]="Readonly",_[_.Locked=2]="Locked"})(k||(e.FilePermission=k={}));function w(_){const Ee=_;return!!Ee&&typeof Ee.onDidChange=="function"}e.$gk=w;var u;(function(_){_[_.None=0]="None",_[_.FileReadWrite=2]="FileReadWrite",_[_.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",_[_.FileReadStream=16]="FileReadStream",_[_.FileFolderCopy=8]="FileFolderCopy",_[_.PathCaseSensitive=1024]="PathCaseSensitive",_[_.Readonly=2048]="Readonly",_[_.Trash=4096]="Trash",_[_.FileWriteUnlock=8192]="FileWriteUnlock",_[_.FileAtomicRead=16384]="FileAtomicRead",_[_.FileAtomicWrite=32768]="FileAtomicWrite",_[_.FileAtomicDelete=65536]="FileAtomicDelete",_[_.FileClone=131072]="FileClone"})(u||(e.FileSystemProviderCapabilities=u={}));function o(_){return!!(_.capabilities&2)}e.$hk=o;function i(_){return!!(_.capabilities&8)}e.$ik=i;function n(_){return!!(_.capabilities&131072)}e.$jk=n;function r(_){return!!(_.capabilities&4)}e.$kk=r;function a(_){return!!(_.capabilities&16)}e.$lk=a;function t(_){return o(_)?!!(_.capabilities&16384):!1}e.$mk=t;function s(_){return o(_)?!!(_.capabilities&32768):!1}e.$nk=s;function d(_){return!!(_.capabilities&65536)}e.$ok=d;function c(_){return!!(_.capabilities&2048)}e.$pk=c;var l;(function(_){_.FileExists="EntryExists",_.FileNotFound="EntryNotFound",_.FileNotADirectory="EntryNotADirectory",_.FileIsADirectory="EntryIsADirectory",_.FileExceedsStorageQuota="EntryExceedsStorageQuota",_.FileTooLarge="EntryTooLarge",_.FileWriteLocked="EntryWriteLocked",_.NoPermissions="NoPermissions",_.Unavailable="Unavailable",_.Unknown="Unknown"})(l||(e.FileSystemProviderErrorCode=l={}));class h extends Error{static create(Ee,he){const q=new h(Ee.toString(),he);return m(q,he),q}constructor(Ee,he){super(Ee),this.code=he}}e.$qk=h;function E(_,Ee){return h.create(_,Ee)}e.$rk=E;function D(_){return _||E((0,b.localize)(0,null),l.Unknown)}e.$sk=D;function m(_,Ee){return _.name=Ee?`${Ee} (FileSystemError)`:"FileSystemError",_}e.$tk=m;function p(_){if(!_)return l.Unknown;if(_ instanceof h)return _.code;const Ee=/^(.+) \(FileSystemError\)$/.exec(_.name);if(!Ee)return l.Unknown;switch(Ee[1]){case l.FileExists:return l.FileExists;case l.FileIsADirectory:return l.FileIsADirectory;case l.FileNotADirectory:return l.FileNotADirectory;case l.FileNotFound:return l.FileNotFound;case l.FileTooLarge:return l.FileTooLarge;case l.FileWriteLocked:return l.FileWriteLocked;case l.NoPermissions:return l.NoPermissions;case l.Unavailable:return l.Unavailable}return l.Unknown}e.$uk=p;function S(_){if(_ instanceof N)return _.fileOperationResult;switch(p(_)){case l.FileNotFound:return 1;case l.FileIsADirectory:return 0;case l.FileNotADirectory:return 9;case l.FileWriteLocked:return 5;case l.NoPermissions:return 6;case l.FileExists:return 4;case l.FileTooLarge:return 7;default:return 10}}e.$vk=S;var P;(function(_){_[_.CREATE=0]="CREATE",_[_.DELETE=1]="DELETE",_[_.MOVE=2]="MOVE",_[_.COPY=3]="COPY",_[_.WRITE=4]="WRITE"})(P||(e.FileOperation=P={}));class z{constructor(Ee,he,q){this.resource=Ee,this.operation=he,this.target=q}isOperation(Ee){return this.operation===Ee}}e.$wk=z;var j;(function(_){_[_.UPDATED=0]="UPDATED",_[_.ADDED=1]="ADDED",_[_.DELETED=2]="DELETED"})(j||(e.FileChangeType=j={}));class R{static{this.a=null}constructor(Ee,he){this.c=he,this.b=void 0,this.d=new I.$U(()=>{const q=C.$2h.forUris(()=>this.c);return q.fill(this.rawAdded.map(U=>[U,!0])),q}),this.f=new I.$U(()=>{const q=C.$2h.forUris(()=>this.c);return q.fill(this.rawUpdated.map(U=>[U,!0])),q}),this.g=new I.$U(()=>{const q=C.$2h.forUris(()=>this.c);return q.fill(this.rawDeleted.map(U=>[U,!0])),q}),this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[];for(const q of Ee){switch(q.type){case 1:this.rawAdded.push(q.resource);break;case 0:this.rawUpdated.push(q.resource);break;case 2:this.rawDeleted.push(q.resource);break}this.b!==R.a&&(typeof q.cId=="number"?this.b===void 0?this.b=q.cId:this.b!==q.cId&&(this.b=R.a):this.b!==void 0&&(this.b=R.a))}}contains(Ee,...he){return this.h(Ee,{includeChildren:!1},...he)}affects(Ee,...he){return this.h(Ee,{includeChildren:!0},...he)}h(Ee,he,...q){if(!Ee)return!1;const U=q.length>0;return!!((!U||q.includes(1))&&(this.d.value.get(Ee)||he.includeChildren&&this.d.value.findSuperstr(Ee))||(!U||q.includes(0))&&(this.f.value.get(Ee)||he.includeChildren&&this.f.value.findSuperstr(Ee))||(!U||q.includes(2))&&(this.g.value.findSubstr(Ee)||he.includeChildren&&this.g.value.findSuperstr(Ee)))}gotAdded(){return this.rawAdded.length>0}gotDeleted(){return this.rawDeleted.length>0}gotUpdated(){return this.rawUpdated.length>0}correlates(Ee){return this.b===Ee}hasCorrelation(){return typeof this.b=="number"}}e.$xk=R;function T(_,Ee,he){return!_||!Ee||_===Ee||Ee.length>_.length?!1:(Ee.charAt(Ee.length-1)!==F.sep&&(Ee+=F.sep),he?(0,f.$7e)(_,Ee):_.indexOf(Ee)===0)}e.$yk=T;class N extends Error{constructor(Ee,he,q){super(Ee),this.fileOperationResult=he,this.options=q}}e.$zk=N;class O extends N{constructor(Ee,he,q,U){super(Ee,he,U),this.fileOperationResult=he,this.size=q}}e.$Ak=O;class W extends N{constructor(Ee,he,q){super(Ee,2,q),this.stat=he}}e.$Bk=W;var x;(function(_){_[_.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",_[_.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",_[_.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",_[_.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",_[_.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",_[_.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",_[_.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",_[_.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",_[_.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",_[_.FILE_NOT_DIRECTORY=9]="FILE_NOT_DIRECTORY",_[_.FILE_OTHER_ERROR=10]="FILE_OTHER_ERROR"})(x||(e.FileOperationResult=x={})),e.$Ck={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.$Dk={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.$Ek="files.associations",e.$Fk="files.exclude",e.$Gk="files.readonlyInclude",e.$Hk="files.readonlyExclude",e.$Ik="files.readonlyFromPermissions";var le;(function(_){_[_.FILE=0]="FILE",_[_.FOLDER=1]="FOLDER",_[_.ROOT_FOLDER=2]="ROOT_FOLDER"})(le||(e.FileKind=le={})),e.$Jk="";function G(_){if(!(typeof _.size!="number"||typeof _.mtime!="number"))return _.mtime.toString(29)+_.size.toString(31)}e.$Kk=G;async function J(_,Ee){if(!Ee.hasProvider(M.URI.from({scheme:_.scheme})))return new Promise(he=>{const q=Ee.onDidChangeFileSystemProviderRegistrations(U=>{U.scheme===_.scheme&&U.added&&(q.dispose(),he())})})}e.$Lk=J;class Q{static{this.KB=1024}static{this.MB=Q.KB*Q.KB}static{this.GB=Q.MB*Q.KB}static{this.TB=Q.GB*Q.KB}static formatSize(Ee){return(0,L.$Gf)(Ee)||(Ee=0),Ee<Q.KB?(0,b.localize)(1,null,Ee.toFixed(0)):Ee<Q.MB?(0,b.localize)(2,null,(Ee/Q.KB).toFixed(2)):Ee<Q.GB?(0,b.localize)(3,null,(Ee/Q.MB).toFixed(2)):Ee<Q.TB?(0,b.localize)(4,null,(Ee/Q.GB).toFixed(2)):(0,b.localize)(5,null,(Ee/Q.TB).toFixed(2))}}e.$Mk=Q;function oe(_){const Ee=typeof _=="string"||_?.scheme===A.Schemas.vscodeRemote;return typeof _!="string"&&_?.scheme===A.Schemas.file?1024*Q.MB:Ee?10*Q.MB:g.$o?50*Q.MB:1024*Q.MB}e.$Nk=oe}),define(ke[243],Se([1,0,22,8,204,31]),function(me,e,C,F,f,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sp=void 0;async function M(A,I,$,y,k,w){let u;try{await b(A,I,$,y,k,w)}catch(o){u=o}finally{u&&k.errorTransformer&&(u=k.errorTransformer(u)),typeof u<"u"&&$.error(u),$.end()}}e.$Sp=M;async function b(A,I,$,y,k,w){v(w);const u=await A.open(I,{create:!1});try{v(w);let o=0,i=0,n=k&&typeof k.length=="number"?k.length:void 0,r=C.$fe.alloc(Math.min(k.bufferSize,typeof n=="number"?n:k.bufferSize)),a=k&&typeof k.position=="number"?k.position:0,t=0;do i=await A.read(u,a,r.buffer,t,r.byteLength-t),a+=i,t+=i,o+=i,typeof n=="number"&&(n-=i),t===r.byteLength&&(await $.write(y(r)),r=C.$fe.alloc(Math.min(k.bufferSize,typeof n=="number"?n:k.bufferSize)),t=0);while(i>0&&(typeof n!="number"||n>0)&&v(w)&&g(o,k));if(t>0){let s=t;typeof n=="number"&&(s=Math.min(t,n)),$.write(y(r.slice(0,s)))}}catch(o){throw(0,L.$sk)(o)}finally{await A.close(u)}}function v(A){if(A.isCancellationRequested)throw(0,F.$5)();return!0}function g(A,I){if(typeof I?.limits?.size=="number"&&A>I.limits.size)throw(0,L.$rk)((0,f.localize)(0,null),L.FileSystemProviderErrorCode.FileTooLarge);return!0}}),define(ke[84],Se([1,0,34,3,16,11,2,31]),function(me,e,C,F,f,L,M,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2p=e.$1p=e.$Zp=e.$Yp=e.$Xp=e.$Wp=e.$Vp=e.$Up=void 0;function v(o){return o.recursive===!0}e.$Up=v;class g extends F.$Rc{static{this.a=5}constructor(i,n,r,a){super(),this.h=i,this.j=n,this.m=r,this.n=a,this.c=this.B(new F.$Sc),this.f=void 0,this.g=0}s(){const i=new F.$Qc;this.c.value=i,this.b=this.r(i),this.b.setVerboseLogging(this.m),i.add(this.b.onDidChangeFile(n=>this.h(n))),i.add(this.b.onDidLogMessage(n=>this.j(n))),i.add(this.b.onDidError(n=>this.t(n)))}t(i){this.n.restartOnError?this.g<g.a&&this.f?(this.w(`restarting watcher after error: ${i}`),this.u(this.f)):this.w(`gave up attempting to restart watcher after error: ${i}`):this.w(i)}u(i){this.g++,this.s(),this.watch(i)}async watch(i){this.f=i,await this.b?.watch(i)}async setVerboseLogging(i){this.m=i,await this.b?.setVerboseLogging(i)}w(i){this.j({type:"error",message:`[File Watcher (${this.n.type})] ${i}`})}y(i){this.j({type:"trace",message:`[File Watcher (${this.n.type})] ${i}`})}dispose(){return this.b=void 0,super.dispose()}}e.$Vp=g;class A extends g{constructor(i,n,r){super(i,n,r,{type:"node.js",restartOnError:!1})}}e.$Wp=A;class I extends g{constructor(i,n,r){super(i,n,r,{type:"universal",restartOnError:!0})}}e.$Xp=I;function $(o){return o.map(i=>({type:i.type,resource:M.URI.revive(i.resource),cId:i.cId}))}e.$Yp=$;function y(o){const i=new u;for(const n of o)i.processEvent(n);return i.coalesce()}e.$Zp=y;function k(o,i){return typeof i=="string"&&!i.startsWith(C.$yj)&&!(0,f.$hc)(i)?{base:o,pattern:i}:i}e.$1p=k;function w(o,i){const n=[];for(const r of i)n.push((0,C.$Cj)(k(o,r)));return n}e.$2p=w;class u{constructor(){this.a=new Set,this.b=new Map}c(i){return L.$k?i.resource.fsPath:i.resource.fsPath.toLowerCase()}processEvent(i){const n=this.b.get(this.c(i));let r=!1;if(n){const a=n.type,t=i.type;n.resource.fsPath!==i.resource.fsPath&&(i.type===2||i.type===1)?r=!0:a===1&&t===2?(this.b.delete(this.c(i)),this.a.delete(n)):a===2&&t===1?n.type=0:a===1&&t===0||(n.type=t)}else r=!0;r&&(this.a.add(i),this.b.set(this.c(i),i))}coalesce(){const i=[],n=[];return Array.from(this.a).filter(r=>r.type!==2?(i.push(r),!1):!0).sort((r,a)=>r.resource.fsPath.length-a.resource.fsPath.length).filter(r=>n.some(a=>(0,b.$yk)(r.resource.fsPath,a,!L.$k))?!1:(n.push(r.resource.fsPath),!0)).concat(i)}}}),define(ke[244],Se([1,0,55,12,21,33,3,76,16,11,23,2,103,30,84]),function(me,e,C,F,f,L,M,b,v,g,A,I,$,y,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dq=e.$cq=void 0;class w extends M.$Rc{static{this.a=100}static{this.b=75}constructor(i,n,r,a){super(),this.m=i,this.n=n,this.r=r,this.s=a,this.c=this.B(new F.$ah({maxWorkChunkSize:100,throttleDelay:200,maxBufferedWork:1e4},t=>this.n(t))),this.f=this.B(new F.$_g(t=>this.z(t),w.b)),this.g=(0,k.$2p)(this.m.path,this.m.excludes),this.h=this.m.includes?(0,k.$2p)(this.m.path,this.m.includes):void 0,this.j=new f.$2d,this.ready=this.t()}async t(){try{const i=await this.u(this.m);if(this.j.token.isCancellationRequested)return;const n=await y.Promises.stat(i);this.B(await this.w(i,n.isDirectory()))}catch(i){i.code!=="ENOENT"?this.D(i):this.G(i)}}async u(i){let n=i.path;try{n=await y.Promises.realpath(i.path),i.path===n&&(n=await(0,$.$_p)(i.path)??i.path),i.path!==n&&this.G(`correcting a path to watch that seems to be a symbolic link or wrong casing (original: ${i.path}, real: ${n})`)}catch{}return n}async w(i,n){if(g.$j&&(0,L.$2f)(i,"/Volumes/",!0))return this.D(`Refusing to watch ${i} for changes using fs.watch() for possibly being a network share where watching is unreliable and unstable.`),M.$Rc.None;const r=new f.$2d(this.j.token),a=new M.$Qc;try{const t=I.URI.file(this.m.path),s=(0,v.$mc)(i),d=(0,C.watch)(i);a.add((0,M.$Pc)(()=>{d.removeAllListeners(),d.close()})),this.G(`Started watching: '${i}'`);const c=new Set;if(n)try{for(const h of await y.Promises.readdir(i))c.add(h)}catch(h){this.D(h)}const l=new Map;a.add((0,M.$Pc)(()=>{for(const[,h]of l)h.dispose();l.clear()})),d.on("error",(h,E)=>{this.D(`Failed to watch ${i} for changes using fs.watch() (${h}, ${E})`),this.dispose()}),d.on("change",(h,E)=>{if(r.token.isCancellationRequested)return;this.G(`[raw] ["${h}"] ${E}`);let D="";if(E&&(D=E.toString(),g.$j&&(D=(0,b.$ul)(D))),!(!D||h!=="change"&&h!=="rename"))if(n)if(h==="rename"){l.get(D)?.dispose();const m=setTimeout(async()=>{if(l.delete(D),D===s&&!await y.Promises.exists(i)){this.F("Watcher shutdown because watched path got deleted"),this.dispose();return}const p=await this.C((0,v.$ic)(i,D));if(r.token.isCancellationRequested)return;let S;p?c.has(D)?S=0:(S=1,c.add(D)):(c.delete(D),S=2),this.y({resource:(0,A.$zg)(t,D),type:S,cId:this.m.correlationId})},w.a);l.set(D,(0,M.$Pc)(()=>clearTimeout(m)))}else{let m;c.has(D)?m=0:(m=1,c.add(D)),this.y({resource:(0,A.$zg)(t,D),type:m,cId:this.m.correlationId})}else if(h==="rename"||D!==s){const m=setTimeout(async()=>{const p=await y.Promises.exists(i);r.token.isCancellationRequested||(p?(this.y({resource:t,type:0,cId:this.m.correlationId},!0),a.add(await this.w(i,!1))):(this.y({resource:t,type:2,cId:this.m.correlationId},!0),this.f.flush(),this.dispose()))},w.a);a.clear(),a.add((0,M.$Pc)(()=>clearTimeout(m)))}else this.y({resource:t,type:0,cId:this.m.correlationId},!0)})}catch(t){await y.Promises.exists(i)&&!r.token.isCancellationRequested&&this.D(`Failed to watch ${i} for changes using fs.watch() (${t.toString()})`)}return(0,M.$Pc)(()=>{r.dispose(!0),a.dispose()})}y(i,n=!1){this.j.token.isCancellationRequested||(this.s&&this.G(`${i.type===1?"[ADDED]":i.type===2?"[DELETED]":"[CHANGED]"} ${i.resource.fsPath}`),!n&&this.g.some(r=>r(i.resource.fsPath))?this.s&&this.G(` >> ignored (excluded) ${i.resource.fsPath}`):!n&&this.h&&this.h.length>0&&!this.h.some(r=>r(i.resource.fsPath))?this.s&&this.G(` >> ignored (not included) ${i.resource.fsPath}`):this.f.work(i))}z(i){const n=(0,k.$Zp)(i);if(n.length>0){if(this.s)for(const a of n)this.G(` >> normalized ${a.type===1?"[ADDED]":a.type===2?"[DELETED]":"[CHANGED]"} ${a.resource.fsPath}`);this.c.work(n)?this.c.pending>0&&this.G(`started throttling events due to large amount of file change events at once (pending: ${this.c.pending}, most recent change: ${n[0].resource.fsPath}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`):this.F(`started ignoring events due to too many file change events at once (incoming: ${n.length}, most recent change: ${n[0].resource.fsPath}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`)}}async C(i){if(g.$k)return y.Promises.exists(i);try{const n=(0,v.$mc)(i);return(await y.Promises.readdir((0,v.$lc)(i))).some(a=>a===n)}catch(n){return this.G(n),!1}}setVerboseLogging(i){this.s=i}D(i){this.j.token.isCancellationRequested||this.r?.({type:"error",message:`[File Watcher (node.js)] ${i}`})}F(i){this.j.token.isCancellationRequested||this.r?.({type:"warn",message:`[File Watcher (node.js)] ${i}`})}G(i){!this.j.token.isCancellationRequested&&this.s&&this.r?.({type:"trace",message:`[File Watcher (node.js)] ${i}`})}dispose(){this.G(`stopping file watcher on ${this.m.path}`),this.j.dispose(!0),super.dispose()}}e.$cq=w;async function u(o,i,n,r,a=512){const t=await y.Promises.open(o,"r"),s=Buffer.allocUnsafe(a),d=new f.$2d(r);let c,l=!1;const h={path:o,excludes:[],recursive:!1},E=new w(h,D=>{(async()=>{for(const{type:m}of D)if(m===0){if(l)return;l=!0;try{for(;!d.token.isCancellationRequested;){const{bytesRead:p}=await y.Promises.read(t,s,0,a,null);if(!p||d.token.isCancellationRequested)break;i(s.slice(0,p))}}catch(p){c=new Error(p),d.dispose(!0)}finally{l=!1}}})()});return await E.ready,n(),new Promise((D,m)=>{d.token.onCancellationRequested(async()=>{E.dispose();try{await y.Promises.close(t)}catch(p){c=new Error(p)}c?m(c):D()})})}e.$dq=u}),define(ke[245],Se([1,0,4,34,3,11,244]),function(me,e,C,F,f,L,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$eq=void 0;class b extends f.$Rc{constructor(){super(...arguments),this.a=this.B(new C.$Rd),this.onDidChangeFile=this.a.event,this.b=this.B(new C.$Rd),this.onDidLogMessage=this.b.event,this.onDidError=C.Event.None,this.c=new Map,this.f=!1}async watch(g){const A=this.j(g),I=A.filter(y=>{const k=this.c.get(y.path);return k?!(0,F.$Gj)(k.request.excludes,y.excludes)||!(0,F.$Gj)(k.request.includes,y.includes):!0}),$=Array.from(this.c.values()).filter(({request:y})=>!A.find(k=>k.path===y.path&&(0,F.$Gj)(k.excludes,y.excludes)&&(0,F.$Gj)(k.includes,y.includes))).map(({request:y})=>y.path);I.length&&this.m(`Request to start watching: ${I.map(y=>`${y.path} (excludes: ${y.excludes.length>0?y.excludes:"<none>"}, includes: ${y.includes&&y.includes.length>0?JSON.stringify(y.includes):"<all>"}, correlationId: ${typeof y.correlationId=="number"?y.correlationId:"<none>"})`).join(",")}`),$.length&&this.m(`Request to stop watching: ${$.join(",")}`);for(const y of $)this.h(y);for(const y of I)this.g(y)}g(g){const A=new M.$cq(g,$=>this.a.fire($),$=>this.b.fire($),this.f),I={request:g,instance:A};this.c.set(g.path,I)}async stop(){for(const[g]of this.c)this.h(g);this.c.clear()}h(g){const A=this.c.get(g);A&&(this.c.delete(g),A.instance.dispose())}j(g){const A=new Map;for(const I of g){const $=L.$k?I.path:I.path.toLowerCase();let y=A.get(I.correlationId);y||(y=new Map,A.set(I.correlationId,y)),y.set($,I)}return Array.from(A.values()).map(I=>Array.from(I.values())).flat()}async setVerboseLogging(g){this.f=g;for(const[,A]of this.c)A.instance.setVerboseLogging(g)}m(g){this.f&&this.b.fire({type:"trace",message:this.n(g)})}n(g,A){return A?`[File Watcher (node.js)] ${g} (path: ${A.request.path})`:`[File Watcher (node.js)] ${g}`}}e.$eq=b}),define(ke[246],Se([1,0,84,245]),function(me,e,C,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fq=void 0;class f extends C.$Wp{constructor(M,b,v){super(M,b,v),this.s()}r(M){return M.add(new F.$eq)}}e.$fq=f}),define(ke[247],Se([1,0,17,81,187,84]),function(me,e,C,F,f,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0p=void 0;class M extends L.$Xp{constructor(v,g,A){super(v,g,A),this.s()}r(v){const g=v.add(new f.$9p(C.$gg.asFileUri("bootstrap-fork").fsPath,{serverName:"File Watcher",args:["--type=fileWatcher"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/watcherMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));return v.add(g.onDidProcessExit(({code:A,signal:I})=>this.t(`terminated by itself with code ${A}, signal: ${I}`))),F.ProxyChannel.toService((0,F.$Ch)(g.getChannel("watcher")))}}e.$0p=M}),define(ke[107],Se([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Th=void 0;class C{constructor(...f){this.a=new Map;for(const[L,M]of f)this.set(L,M)}set(f,L){const M=this.a.get(f);return this.a.set(f,L),M}has(f){return this.a.has(f)}get(f){return this.a.get(f)}}e.$Th=C}),define(ke[248],Se([1,0,12,8,3,105,239,5,107,75]),function(me,e,C,F,f,L,M,b,v,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kq=e.$jq=void 0;const A=!1;class I extends Error{constructor(u){super("cyclic dependency between services"),this.message=u.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${u.toString()}`}}class ${constructor(u=new v.$Th,o=!1,i,n=A){this.f=u,this.g=o,this.h=i,this.i=n,this.o=new Set,this.f.set(b.$Uh,this),this._globalGraph=n?i?._globalGraph??new M.$iq(r=>r):void 0}createChild(u){return new $(u,this.g,this,this.i)}invokeFunction(u,...o){const i=k.traceInvocation(this.i,u);let n=!1;try{return u({get:a=>{if(n)throw(0,F.$7)("service accessor is only valid during the invocation of its target method");const t=this.m(a,i);if(!t)throw new Error(`[invokeFunction] unknown service '${a}'`);return t}},...o)}finally{n=!0,i.stop()}}createInstance(u,...o){let i,n;return u instanceof L.$Sh?(i=k.traceCreation(this.i,u.ctor),n=this.j(u.ctor,u.staticArguments.concat(o),i)):(i=k.traceCreation(this.i,u),n=this.j(u,o,i)),i.stop(),n}j(u,o=[],i){const n=b._util.getServiceDependencies(u).sort((t,s)=>t.index-s.index),r=[];for(const t of n){const s=this.m(t.id,i);s||this.u(`[createInstance] ${u.name} depends on UNKNOWN service ${t.id}.`,!1),r.push(s)}const a=n.length>0?n[0].index:o.length;if(o.length!==a){console.trace(`[createInstance] First service dependency of ${u.name} at position ${a+1} conflicts with ${o.length} static arguments`);const t=a-o.length;t>0?o=o.concat(new Array(t)):o=o.slice(0,a)}return Reflect.construct(u,o.concat(r))}k(u,o){if(this.f.get(u)instanceof L.$Sh)this.f.set(u,o);else if(this.h)this.h.k(u,o);else throw new Error("illegalState - setting UNKNOWN service instance")}l(u){const o=this.f.get(u);return!o&&this.h?this.h.l(u):o}m(u,o){this._globalGraph&&this.c&&this._globalGraph.insertEdge(this.c,String(u));const i=this.l(u);return i instanceof L.$Sh?this.q(u,i,o.branch(u,!0)):(o.branch(u,!1),i)}q(u,o,i){if(this.o.has(u))throw new Error(`illegal state - RECURSIVELY instantiating service '${u}'`);this.o.add(u);try{return this.r(u,o,i)}finally{this.o.delete(u)}}r(u,o,i){const n=new M.$iq(t=>t.id.toString());let r=0;const a=[{id:u,desc:o,_trace:i}];for(;a.length;){const t=a.pop();if(n.lookupOrInsertNode(t),r++>1e3)throw new I(n);for(const s of b._util.getServiceDependencies(t.desc.ctor)){const d=this.l(s.id);if(d||this.u(`[createInstance] ${u} depends on ${s.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(t.id),String(s.id)),d instanceof L.$Sh){const c={id:s.id,desc:d,_trace:t._trace.branch(s.id,!0)};n.insertEdge(t,c),a.push(c)}}}for(;;){const t=n.roots();if(t.length===0){if(!n.isEmpty())throw new I(n);break}for(const{data:s}of t){if(this.l(s.id)instanceof L.$Sh){const c=this.s(s.id,s.desc.ctor,s.desc.staticArguments,s.desc.supportsDelayedInstantiation,s._trace);this.k(s.id,c)}n.removeNode(s)}}return this.l(u)}s(u,o,i=[],n,r){if(this.f.get(u)instanceof L.$Sh)return this.t(u,o,i,n,r);if(this.h)return this.h.s(u,o,i,n,r);throw new Error(`illegalState - creating UNKNOWN service instance ${o.name}`)}t(u,o,i=[],n,r){if(n){const a=new $(void 0,this.g,this,this.i);a.c=String(u);const t=new Map,s=new C.$eh(()=>{const d=a.j(o,i,r);for(const[c,l]of t){const h=d[c];if(typeof h=="function")for(const E of l)h.apply(d,E)}return t.clear(),d});return new Proxy(Object.create(null),{get(d,c){if(!s.isInitialized&&typeof c=="string"&&(c.startsWith("onDid")||c.startsWith("onWill"))){let E=t.get(c);return E||(E=new g.$2c,t.set(c,E)),(m,p,S)=>{const P=E.push([m,p,S]);return(0,f.$Pc)(P)}}if(c in d)return d[c];const l=s.value;let h=l[c];return typeof h!="function"||(h=h.bind(l),d[c]=h),h},set(d,c,l){return s.value[c]=l,!0},getPrototypeOf(d){return o.prototype}})}else return this.j(o,i,r)}u(u,o){if(o&&console.warn(u),this.g)throw new Error(u)}}e.$jq=$;var y;(function(w){w[w.None=0]="None",w[w.Creation=1]="Creation",w[w.Invocation=2]="Invocation",w[w.Branch=3]="Branch"})(y||(y={}));class k{static{this.all=new Set}static{this.c=new class extends k{constructor(){super(0,null)}stop(){}branch(){return this}}}static traceInvocation(u,o){return u?new k(2,o.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):k.c}static traceCreation(u,o){return u?new k(1,o.name):k.c}static{this.f=0}constructor(u,o){this.type=u,this.name=o,this.g=Date.now(),this.h=[]}branch(u,o){const i=new k(3,u.toString());return this.h.push([u,o,i]),i}stop(){const u=Date.now()-this.g;k.f+=u;let o=!1;function i(r,a){const t=[],s=new Array(r+1).join("	");for(const[d,c,l]of a.h)if(c&&l){o=!0,t.push(`${s}CREATES -> ${d}`);const h=i(r+1,l);h&&t.push(h)}else t.push(`${s}uses -> ${d}`);return t.join(`
`)}const n=[`${this.type===1?"CREATE":"CALL"} ${this.name}`,`${i(1,this)}`,`DONE, took ${u.toFixed(2)}ms (grand total ${k.f.toFixed(2)}ms)`];(u>2||o)&&k.all.add(n.join(`
`))}}e.$kq=k}),define(ke[14],Se([1,0,43,4,52,3,28,11,23,18,2,45,5]),function(me,e,C,F,f,L,M,b,v,g,A,I,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uj=e.$tj=e.$sj=e.$rj=e.$qj=e.$pj=e.$oj=e.$nj=e.$mj=e.$lj=e.$kj=e.$jj=e.$ij=e.log=e.$gj=e.LogLevel=e.$fj=e.$ej=e.$dj=void 0,e.$dj=(0,$.$Vh)("logService"),e.$ej=(0,$.$Vh)("loggerService");function y(){return new Date().toISOString()}function k(m){return(0,g.$Gf)(m)}e.$fj=k;var w;(function(m){m[m.Off=0]="Off",m[m.Trace=1]="Trace",m[m.Debug=2]="Debug",m[m.Info=3]="Info",m[m.Warning=4]="Warning",m[m.Error=5]="Error"})(w||(e.LogLevel=w={})),e.$gj=w.Info;function u(m,p,S){switch(p){case w.Trace:m.trace(S);break;case w.Debug:m.debug(S);break;case w.Info:m.info(S);break;case w.Warning:m.warn(S);break;case w.Error:m.error(S);break;case w.Off:break;default:throw new Error(`Invalid log level ${p}`)}}e.log=u;function o(m,p=!1){let S="";for(let P=0;P<m.length;P++){let z=m[P];if(z instanceof Error&&(z=(0,C.$Gi)(z,p)),typeof z=="object")try{z=JSON.stringify(z)}catch{}S+=(P>0?" ":"")+z}return S}class i extends L.$Rc{constructor(){super(...arguments),this.b=e.$gj,this.c=this.B(new F.$Rd),this.onDidChangeLogLevel=this.c.event}setLevel(p){this.b!==p&&(this.b=p,this.c.fire(this.b))}getLevel(){return this.b}f(p){return this.b!==w.Off&&this.b<=p}}e.$ij=i;class n extends i{constructor(p){super(),this.h=p}f(p){return this.h||super.f(p)}trace(p,...S){this.f(w.Trace)&&this.g(w.Trace,o([p,...S],!0))}debug(p,...S){this.f(w.Debug)&&this.g(w.Debug,o([p,...S]))}info(p,...S){this.f(w.Info)&&this.g(w.Info,o([p,...S]))}warn(p,...S){this.f(w.Warning)&&this.g(w.Warning,o([p,...S]))}error(p,...S){if(this.f(w.Error))if(p instanceof Error){const P=Array.prototype.slice.call(arguments);P[0]=p.stack,this.g(w.Error,o(P))}else this.g(w.Error,o([p,...S]))}flush(){}}e.$jj=n;class r extends i{constructor(p=e.$gj){super(),this.setLevel(p),this.g=!b.$i}trace(p,...S){this.f(w.Trace)&&(this.g?console.log(`\x1B[90m[main ${y()}]\x1B[0m`,p,...S):console.log(`[main ${y()}]`,p,...S))}debug(p,...S){this.f(w.Debug)&&(this.g?console.log(`\x1B[90m[main ${y()}]\x1B[0m`,p,...S):console.log(`[main ${y()}]`,p,...S))}info(p,...S){this.f(w.Info)&&(this.g?console.log(`\x1B[90m[main ${y()}]\x1B[0m`,p,...S):console.log(`[main ${y()}]`,p,...S))}warn(p,...S){this.f(w.Warning)&&(this.g?console.warn(`\x1B[93m[main ${y()}]\x1B[0m`,p,...S):console.warn(`[main ${y()}]`,p,...S))}error(p,...S){this.f(w.Error)&&(this.g?console.error(`\x1B[91m[main ${y()}]\x1B[0m`,p,...S):console.error(`[main ${y()}]`,p,...S))}dispose(){}flush(){}}e.$kj=r;class a extends i{constructor(p=e.$gj,S=!0){super(),this.g=S,this.setLevel(p)}trace(p,...S){this.f(w.Trace)&&(this.g?console.log("%cTRACE","color: #888",p,...S):console.log(p,...S))}debug(p,...S){this.f(w.Debug)&&(this.g?console.log("%cDEBUG","background: #eee; color: #888",p,...S):console.log(p,...S))}info(p,...S){this.f(w.Info)&&(this.g?console.log("%c INFO","color: #33f",p,...S):console.log(p,...S))}warn(p,...S){this.f(w.Warning)&&(this.g?console.log("%c WARN","color: #993",p,...S):console.log(p,...S))}error(p,...S){this.f(w.Error)&&(this.g?console.log("%c  ERR","color: #f33",p,...S):console.error(p,...S))}dispose(){}flush(){}}e.$lj=a;class t extends i{constructor(p,S=e.$gj){super(),this.g=p,this.setLevel(S)}trace(p,...S){this.f(w.Trace)&&this.g.log(w.Trace,[this.h(p),...S])}debug(p,...S){this.f(w.Debug)&&this.g.log(w.Debug,[this.h(p),...S])}info(p,...S){this.f(w.Info)&&this.g.log(w.Info,[this.h(p),...S])}warn(p,...S){this.f(w.Warning)&&this.g.log(w.Warning,[this.h(p),...S])}error(p,...S){this.f(w.Error)&&this.g.log(w.Error,[this.h(p),...S])}h(p){return typeof p=="string"?p:(0,C.$Gi)(p,this.f(w.Trace))}dispose(){}flush(){}}e.$mj=t;class s extends i{constructor(p){super(),this.g=p,p.length&&this.setLevel(p[0].getLevel())}setLevel(p){for(const S of this.g)S.setLevel(p);super.setLevel(p)}trace(p,...S){for(const P of this.g)P.trace(p,...S)}debug(p,...S){for(const P of this.g)P.debug(p,...S)}info(p,...S){for(const P of this.g)P.info(p,...S)}warn(p,...S){for(const P of this.g)P.warn(p,...S)}error(p,...S){for(const P of this.g)P.error(p,...S)}flush(){for(const p of this.g)p.flush()}dispose(){for(const p of this.g)p.dispose()}}e.$nj=s;class d extends L.$Rc{constructor(p,S,P){if(super(),this.h=p,this.j=S,this.b=new M.$zc,this.c=this.B(new F.$Rd),this.onDidChangeLoggers=this.c.event,this.f=this.B(new F.$Rd),this.onDidChangeLogLevel=this.f.event,this.g=this.B(new F.$Rd),this.onDidChangeVisibility=this.g.event,P)for(const z of P)this.b.set(z.resource,{logger:void 0,info:z})}m(p){return(0,g.$Cf)(p)?[...this.b.values()].find(S=>S.info.id===p):this.b.get(p)}getLogger(p){return this.m(p)?.logger}createLogger(p,S){const P=this.n(p),z=(0,g.$Cf)(p)?p:S?.id??(0,f.$Ji)(P.toString()).toString(16);let j=this.b.get(P)?.logger;const R=S?.logLevel==="always"?w.Trace:S?.logLevel;j||(j=this.s(P,R??this.getLogLevel(P)??this.h,{...S,id:z}));const T={logger:j,info:{resource:P,id:z,logLevel:R,name:S?.name,hidden:S?.hidden,extensionId:S?.extensionId,when:S?.when}};return this.registerLogger(T.info),this.b.set(P,T),j}n(p){return(0,g.$Cf)(p)?(0,v.$zg)(this.j,`${p}.log`):p}setLogLevel(p,S){if(A.URI.isUri(p)){const P=p,z=S,j=this.b.get(P);j&&z!==j.info.logLevel&&(j.info.logLevel=z===this.h?void 0:z,j.logger?.setLevel(z),this.b.set(j.info.resource,j),this.f.fire([P,z]))}else{this.h=p;for(const[P,z]of this.b.entries())this.b.get(P)?.info.logLevel===void 0&&z.logger?.setLevel(this.h);this.f.fire(this.h)}}setVisibility(p,S){const P=this.m(p);P&&S!==!P.info.hidden&&(P.info.hidden=!S,this.b.set(P.info.resource,P),this.g.fire([P.info.resource,S]))}getLogLevel(p){let S;return p&&(S=this.b.get(p)?.info.logLevel),S??this.h}registerLogger(p){const S=this.b.get(p.resource);S?S.info.hidden!==p.hidden&&this.setVisibility(p.resource,!p.hidden):(this.b.set(p.resource,{info:p,logger:void 0}),this.c.fire({added:[p],removed:[]}))}deregisterLogger(p){const S=this.b.get(p);S&&(S.logger&&S.logger.dispose(),this.b.delete(p),this.c.fire({added:[],removed:[S.info]}))}*getRegisteredLoggers(){for(const p of this.b.values())yield p.info}getRegisteredLogger(p){return this.b.get(p)?.info}dispose(){this.b.forEach(p=>p.logger?.dispose()),this.b.clear(),super.dispose()}}e.$oj=d;class c{constructor(){this.onDidChangeLogLevel=new F.$Rd().event}setLevel(p){}getLevel(){return w.Info}trace(p,...S){}debug(p,...S){}info(p,...S){}warn(p,...S){}error(p,...S){}critical(p,...S){}dispose(){}flush(){}}e.$pj=c;class l extends c{}e.$qj=l;function h(m){if(m.verbose)return w.Trace;if(typeof m.logLevel=="string"){const p=D(m.logLevel.toLowerCase());if(p!==void 0)return p}return e.$gj}e.$rj=h;function E(m){switch(m){case w.Trace:return"trace";case w.Debug:return"debug";case w.Info:return"info";case w.Warning:return"warn";case w.Error:return"error";case w.Off:return"off"}}e.$sj=E;function D(m){switch(m){case"trace":return w.Trace;case"debug":return w.Debug;case"info":return w.Info;case"warn":return w.Warning;case"error":return w.Error;case"critical":return w.Error;case"off":return w.Off}}e.$tj=D,e.$uj=new I.$aj("logLevel",E(w.Info))}),define(ke[249],Se([1,0,19,12,8,4,3,16,84,14]),function(me,e,C,F,f,L,M,b,v,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3p=void 0;class A extends M.$Rc{constructor($,y){super(),this.a=$,this.b=y,this.c=this.B(new L.$Rd),this.onDidChangeFile=this.c.event,this.g=this.B(new L.$Rd),this.onDidWatchError=this.g.event,this.j=[],this.m=this.B(new F.$Vg(0)),this.w=[],this.y=this.B(new F.$Vg(0))}watch($,y){return y.recursive||this.b?.watcher?.forceUniversal?this.n($,y):this.z($,y)}n($,y){const k={path:this.H($),excludes:y.excludes,includes:y.includes,recursive:y.recursive,correlationId:y.correlationId},w=(0,C.$Tb)(this.j,k);return this.r(),(0,M.$Pc)(()=>{w(),this.r()})}r(){this.m.trigger(()=>this.s()).catch($=>(0,f.$Z)($))}s(){this.h||(this.h=this.B(this.t(y=>this.c.fire((0,v.$Yp)(y)),y=>this.G(y),this.a.getLevel()===g.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.h?.setVerboseLogging(this.a.getLevel()===g.LogLevel.Trace)})));const $=this.b?.watcher?.recursive?.usePolling;if($===!0)for(const y of this.j)(0,v.$Up)(y)&&(y.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);else if(Array.isArray($))for(const y of this.j)(0,v.$Up)(y)&&$.includes(y.path)&&(y.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);return this.h.watch(this.j)}z($,y){const k={path:this.H($),excludes:y.excludes,includes:y.includes,recursive:!1,correlationId:y.correlationId},w=(0,C.$Tb)(this.w,k);return this.C(),(0,M.$Pc)(()=>{w(),this.C()})}C(){this.y.trigger(()=>this.D()).catch($=>(0,f.$Z)($))}D(){return this.u||(this.u=this.B(this.F($=>this.c.fire((0,v.$Yp)($)),$=>this.G($),this.a.getLevel()===g.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.u?.setVerboseLogging(this.a.getLevel()===g.LogLevel.Trace)}))),this.u.watch(this.w)}G($){$.type==="error"&&this.g.fire($.message),this.a[$.type]($.message)}H($){return(0,b.$gc)($.fsPath)}}e.$3p=A}),define(ke[250],Se([1,0,55,387,12,28,22,4,33,3,16,11,23,98,30,205,31,243,249,43,247,246]),function(me,e,C,F,f,L,M,b,v,g,A,I,$,y,k,w,u,o,i,n,r,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gq=void 0,(()=>{try{(0,F.gracefulify)(C)}catch(s){console.error(`Error enabling graceful-fs: ${(0,n.$Gi)(s)}`)}})();class t extends i.$3p{static{this.I=!1}constructor(d,c){super(d,c),this.onDidChangeCapabilities=b.Event.None,this.N=new L.$zc(l=>$.$qg.getComparisonKey(l)),this.U=new Map,this.W=new Map,this.X=new Map}get capabilities(){return this.J||(this.J=253982,I.$k&&(this.J|=1024)),this.J}async stat(d){try{const{stat:c,symbolicLink:l}=await k.SymlinkSupport.stat(this.H(d));return{type:this.M(c,l),ctime:c.birthtime.getTime(),mtime:c.mtime.getTime(),size:c.size,permissions:c.mode&128?void 0:u.FilePermission.Locked}}catch(c){throw this.fb(c)}}async L(d){try{return await this.stat(d)}catch{return}}async readdir(d){try{const c=await k.Promises.readdir(this.H(d),{withFileTypes:!0}),l=[];return await Promise.all(c.map(async h=>{try{let E;h.isSymbolicLink()?E=(await this.stat((0,$.$zg)(d,h.name))).type:E=this.M(h),l.push([h.name,E])}catch(E){this.a.trace(E)}})),l}catch(c){throw this.fb(c)}}M(d,c){let l;return c?.dangling?l=u.FileType.Unknown:d.isFile()?l=u.FileType.File:d.isDirectory()?l=u.FileType.Directory:l=u.FileType.Unknown,c&&(l|=u.FileType.SymbolicLink),l}async O(d){const c=this.H(d);this.P(`[Disk FileSystemProvider]: createResourceLock() - request to acquire resource lock (${c})`);let l;for(;l=this.N.get(d);)this.P(`[Disk FileSystemProvider]: createResourceLock() - waiting for resource lock to be released (${c})`),await l.wait();const h=new f.$Wg;return this.N.set(d,h),this.P(`[Disk FileSystemProvider]: createResourceLock() - new resource lock created (${c})`),(0,g.$Pc)(()=>{this.P(`[Disk FileSystemProvider]: createResourceLock() - resource lock dispose() (${c})`),this.N.get(d)===h&&(this.P(`[Disk FileSystemProvider]: createResourceLock() - resource lock removed from resource-lock map (${c})`),this.N.delete(d)),this.P(`[Disk FileSystemProvider]: createResourceLock() - resource lock barrier open() (${c})`),h.open()})}async readFile(d,c){let l;try{c?.atomic&&(this.P(`[Disk FileSystemProvider]: atomic read operation started (${this.H(d)})`),l=await this.O(d));const h=this.H(d);return await k.Promises.readFile(h)}catch(h){throw this.fb(h)}finally{l?.dispose()}}P(d){t.I&&this.a.trace(d)}readFileStream(d,c,l){const h=(0,y.$6d)(E=>M.$fe.concat(E.map(D=>M.$fe.wrap(D))).buffer);return(0,o.$Sp)(this,d,h,E=>E.buffer,{...c,bufferSize:256*1024},l),h}async writeFile(d,c,l){return l?.atomic!==!1&&l?.atomic?.postfix&&await this.Q(d)?this.R(d,(0,$.$zg)((0,$.$yg)(d),`${(0,$.$wg)(d)}${l.atomic.postfix}`),c,l):this.S(d,c,l)}async Q(d){try{const c=this.H(d),{symbolicLink:l}=await k.SymlinkSupport.stat(c);if(l)return!1}catch{}return!0}async R(d,c,l,h){const E=new g.$Qc;try{E.add(await this.O(d)),E.add(await this.O(c)),await this.S(c,l,h,!0);try{await this.rename(c,d,{overwrite:!0})}catch(D){try{await this.delete(c,{recursive:!1,useTrash:!1,atomic:!1})}catch{}throw D}}finally{E.dispose()}}async S(d,c,l,h){let E;try{const D=this.H(d);if(!l.create||!l.overwrite){if(await k.Promises.exists(D)){if(!l.overwrite)throw(0,u.$rk)((0,w.localize)(0,null),u.FileSystemProviderErrorCode.FileExists)}else if(!l.create)throw(0,u.$rk)((0,w.localize)(1,null),u.FileSystemProviderErrorCode.FileNotFound)}E=await this.open(d,{create:!0,unlock:l.unlock},h),await this.write(E,0,c,0,c.byteLength)}catch(D){throw await this.gb(d,D)}finally{typeof E=="number"&&await this.close(E)}}static{this.Y=!0}static configureFlushOnWrite(d){t.Y=d}async open(d,c,l){const h=this.H(d);let E;(0,u.$fk)(c)&&!l&&(E=await this.O(d));let D;try{if((0,u.$fk)(c)&&c.unlock)try{const{stat:p}=await k.SymlinkSupport.stat(h);p.mode&128||await k.Promises.chmod(h,p.mode|128)}catch(p){p.code!=="ENOENT"&&this.a.trace(p)}let m;if((0,u.$fk)(c)){if(I.$i)try{await k.Promises.truncate(h,0),m="r+"}catch(p){p.code!=="ENOENT"&&this.a.trace(p)}m||(m="w")}else m="r";D=await k.Promises.open(h,m)}catch(m){throw E?.dispose(),(0,u.$fk)(c)?await this.gb(d,m):this.fb(m)}if(this.U.set(D,0),(0,u.$fk)(c)&&this.X.set(D,d),E){const m=this.W.get(D);this.P(`[Disk FileSystemProvider]: open() - storing lock for handle ${D} (${h})`),this.W.set(D,E),m&&(this.P(`[Disk FileSystemProvider]: open() - disposing a previous lock that was still stored on same handle ${D} (${h})`),m.dispose())}return D}async close(d){const c=this.W.get(d);try{if(this.U.delete(d),this.X.delete(d)&&t.Y)try{await k.Promises.fdatasync(d)}catch(l){t.configureFlushOnWrite(!1),this.a.error(l)}return await k.Promises.close(d)}catch(l){throw this.fb(l)}finally{c&&(this.W.get(d)===c&&(this.P(`[Disk FileSystemProvider]: close() - resource lock removed from handle-lock map ${d}`),this.W.delete(d)),this.P(`[Disk FileSystemProvider]: close() - disposing lock for handle ${d}`),c.dispose())}}async read(d,c,l,h,E){const D=this.Z(d,c);let m=null;try{m=(await k.Promises.read(d,l,h,E,D)).bytesRead}catch(p){throw this.fb(p)}finally{this.$(d,D,m)}return m}Z(d,c){return c===this.U.get(d)?null:c}$(d,c,l){const h=this.U.get(d);typeof h=="number"&&(typeof c=="number"||(typeof l=="number"?this.U.set(d,h+l):this.U.delete(d)))}async write(d,c,l,h,E){return(0,f.$fh)(()=>this.ab(d,c,l,h,E),100,3)}async ab(d,c,l,h,E){const D=this.Z(d,c);let m=null;try{m=(await k.Promises.write(d,l,h,E,D)).bytesWritten}catch(p){throw await this.gb(this.X.get(d),p)}finally{this.$(d,D,m)}return m}async mkdir(d){try{await k.Promises.mkdir(this.H(d))}catch(c){throw this.fb(c)}}async delete(d,c){try{const l=this.H(d);if(c.recursive){let h;c?.atomic!==!1&&c.atomic.postfix&&(h=(0,A.$ic)((0,A.$lc)(l),`${(0,A.$mc)(l)}${c.atomic.postfix}`)),await k.Promises.rm(l,k.RimRafMode.MOVE,h)}else try{await k.Promises.unlink(l)}catch(h){if(h.code==="EPERM"||h.code==="EISDIR"){let E=!1;try{const{stat:D,symbolicLink:m}=await k.SymlinkSupport.stat(l);E=D.isDirectory()&&!m}catch{}if(E)await k.Promises.rmdir(l);else throw h}else throw h}}catch(l){throw this.fb(l)}}async rename(d,c,l){const h=this.H(d),E=this.H(c);if(h!==E)try{await this.bb(d,c,"move",l.overwrite),await k.Promises.rename(h,E)}catch(D){throw(D.code==="EINVAL"||D.code==="EBUSY"||D.code==="ENAMETOOLONG")&&(D=new Error((0,w.localize)(2,null,(0,A.$mc)(h),(0,A.$mc)((0,A.$lc)(E)),D.toString()))),this.fb(D)}}async copy(d,c,l){const h=this.H(d),E=this.H(c);if(h!==E)try{await this.bb(d,c,"copy",l.overwrite),await k.Promises.copy(h,E,{preserveSymlinks:!0})}catch(D){throw(D.code==="EINVAL"||D.code==="EBUSY"||D.code==="ENAMETOOLONG")&&(D=new Error((0,w.localize)(3,null,(0,A.$mc)(h),(0,A.$mc)((0,A.$lc)(E)),D.toString()))),this.fb(D)}}async bb(d,c,l,h){const E=this.H(d),D=this.H(c);let m=!1;if(!!(this.capabilities&1024)||(m=(0,v.$1f)(E,D,!0)),m){if(l==="copy")throw(0,u.$rk)((0,w.localize)(4,null),u.FileSystemProviderErrorCode.FileExists);if(l==="move")return}const S=await this.L(d);if(!S)throw(0,u.$rk)((0,w.localize)(5,null),u.FileSystemProviderErrorCode.FileNotFound);const P=await this.L(c);if(P){if(!h)throw(0,u.$rk)((0,w.localize)(6,null),u.FileSystemProviderErrorCode.FileExists);S.type&u.FileType.File&&P.type&u.FileType.File||await this.delete(c,{recursive:!0,useTrash:!1,atomic:!1})}}async cloneFile(d,c){return this.cb(d,c,!1)}async cb(d,c,l){const h=this.H(d),E=this.H(c),D=!!(this.capabilities&1024);if((0,v.$1f)(h,E,!D))return;const m=new g.$Qc;try{m.add(await this.O(d)),m.add(await this.O(c)),l&&await k.Promises.mkdir((0,A.$lc)(E),{recursive:!0}),await k.Promises.copyFile(h,E)}catch(p){if(p.code==="ENOENT"&&!l)return this.cb(d,c,!0);throw this.fb(p)}finally{m.dispose()}}t(d,c,l){return new r.$0p(h=>d(h),h=>c(h),l)}F(d,c,l){return new a.$fq(h=>d(h),h=>c(h),l)}fb(d){if(d instanceof u.$qk)return d;let c=d,l;switch(d.code){case"ENOENT":l=u.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":l=u.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":l=u.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":l=u.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":l=u.FileSystemProviderErrorCode.NoPermissions;break;case"ERR_UNC_HOST_NOT_ALLOWED":c=`${d.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`,l=u.FileSystemProviderErrorCode.Unknown;break;default:l=u.FileSystemProviderErrorCode.Unknown}return(0,u.$rk)(c,l)}async gb(d,c){let l=this.fb(c);if(d&&l.code===u.FileSystemProviderErrorCode.NoPermissions)try{const{stat:h}=await k.SymlinkSupport.stat(this.H(d));h.mode&128||(l=(0,u.$rk)(c,u.FileSystemProviderErrorCode.FileWriteLocked))}catch(h){this.a.trace(h)}return l}}e.$gq=t}),define(ke[251],Se([1,0,3,14]),function(me,e,C,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$WN=void 0;class f extends C.$Rc{constructor(M,b=[]){super(),this.a=new F.$nj([M,...b]),this.B(M.onDidChangeLogLevel(v=>this.setLevel(v)))}get onDidChangeLogLevel(){return this.a.onDidChangeLogLevel}setLevel(M){this.a.setLevel(M)}getLevel(){return this.a.getLevel()}trace(M,...b){this.a.trace(M,...b)}debug(M,...b){this.a.debug(M,...b)}info(M,...b){this.a.info(M,...b)}warn(M,...b){this.a.warn(M,...b)}error(M,...b){this.a.error(M,...b)}flush(){this.a.flush()}}e.$WN=f}),define(ke[252],Se([1,0,31,14]),function(me,e,C,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$LN=void 0;var f;(function(g){g[g.Trace=0]="Trace",g[g.Debug=1]="Debug",g[g.Info=2]="Info",g[g.Warning=3]="Warning",g[g.Error=4]="Error",g[g.Critical=5]="Critical",g[g.Off=6]="Off"})(f||(f={}));async function L(g,A,I,$,y){try{const k=await new Promise((u,o)=>{me(["@vscode/spdlog"],u,o)});k.setFlushOn(f.Trace);const w=await k.createAsyncRotatingLogger(g,A,I,$);return y?w.clearFormatters():w.setPattern("%Y-%m-%d %H:%M:%S.%e [%l] %v"),w}catch(k){console.error(k)}return null}function M(g,A,I){switch(A){case F.LogLevel.Trace:g.trace(I);break;case F.LogLevel.Debug:g.debug(I);break;case F.LogLevel.Info:g.info(I);break;case F.LogLevel.Warning:g.warn(I);break;case F.LogLevel.Error:g.error(I);break;case F.LogLevel.Off:break;default:throw new Error(`Invalid log level ${A}`)}}function b(g,A){switch(A){case F.LogLevel.Trace:g.setLevel(f.Trace);break;case F.LogLevel.Debug:g.setLevel(f.Debug);break;case F.LogLevel.Info:g.setLevel(f.Info);break;case F.LogLevel.Warning:g.setLevel(f.Warning);break;case F.LogLevel.Error:g.setLevel(f.Error);break;case F.LogLevel.Off:g.setLevel(f.Off);break;default:throw new Error(`Invalid log level ${A}`)}}class v extends F.$jj{constructor(A,I,$,y,k){super(),this.m=[],this.setLevel(k),this.n=this.s(A,I,$,y),this.B(this.onDidChangeLogLevel(w=>{this.r&&b(this.r,w)}))}async s(A,I,$,y){const k=$?6:1,w=30/k*C.$Mk.MB,u=await L(A,I,w,k,y);if(u){this.r=u,b(this.r,this.getLevel());for(const{level:o,message:i}of this.m)M(this.r,o,i);this.m=[]}}g(A,I){this.r?M(this.r,A,I):this.getLevel()<=A&&this.m.push({level:A,message:I})}flush(){this.r?this.r.flush():this.n.then(()=>this.flush())}dispose(){this.r?this.u():this.n.then(()=>this.u())}u(){this.r&&(this.r.drop(),this.r=void 0)}}e.$LN=v}),define(ke[136],Se([1,0,39,206,5]),function(me,e,C,F,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ft=e.IMarkerData=e.MarkerSeverity=e.MarkerTag=void 0;var L;(function(v){v[v.Unnecessary=1]="Unnecessary",v[v.Deprecated=2]="Deprecated"})(L||(e.MarkerTag=L={}));var M;(function(v){v[v.Hint=1]="Hint",v[v.Info=2]="Info",v[v.Warning=4]="Warning",v[v.Error=8]="Error"})(M||(e.MarkerSeverity=M={})),function(v){function g(k,w){return w-k}v.compare=g;const A=Object.create(null);A[v.Error]=(0,F.localize)(0,null),A[v.Warning]=(0,F.localize)(1,null),A[v.Info]=(0,F.localize)(2,null);function I(k){return A[k]||""}v.toString=I;function $(k){switch(k){case C.default.Error:return v.Error;case C.default.Warning:return v.Warning;case C.default.Info:return v.Info;case C.default.Ignore:return v.Hint}}v.fromSeverity=$;function y(k){switch(k){case v.Error:return C.default.Error;case v.Warning:return C.default.Warning;case v.Info:return C.default.Info;case v.Hint:return C.default.Ignore}}v.toSeverity=y}(M||(e.MarkerSeverity=M={}));var b;(function(v){const g="";function A($){return I($,!0)}v.makeKey=A;function I($,y){const k=[g];return $.source?k.push($.source.replace("\xA6","\\\xA6")):k.push(g),$.code?typeof $.code=="string"?k.push($.code.replace("\xA6","\\\xA6")):k.push($.code.value.replace("\xA6","\\\xA6")):k.push(g),$.severity!==void 0&&$.severity!==null?k.push(M.toString($.severity)):k.push(g),$.message&&y?k.push($.message.replace("\xA6","\\\xA6")):k.push(g),$.startLineNumber!==void 0&&$.startLineNumber!==null?k.push($.startLineNumber.toString()):k.push(g),$.startColumn!==void 0&&$.startColumn!==null?k.push($.startColumn.toString()):k.push(g),$.endLineNumber!==void 0&&$.endLineNumber!==null?k.push($.endLineNumber.toString()):k.push(g),$.endColumn!==void 0&&$.endColumn!==null?k.push($.endColumn.toString()):k.push(g),k.push(g),k.join("\xA6")}v.makeKeyOptionalMessage=I})(b||(e.IMarkerData=b={})),e.$ft=(0,f.$Vh)("markerService")}),define(ke[253],Se([1,0,4,39,5]),function(me,e,C,F,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8u=e.$7u=e.NotificationsFilter=e.NeverShowAgainScope=e.NotificationPriority=e.$6u=e.Severity=void 0,e.Severity=F.default,e.$6u=(0,f.$Vh)("notificationService");var L;(function(A){A[A.DEFAULT=0]="DEFAULT",A[A.SILENT=1]="SILENT",A[A.URGENT=2]="URGENT"})(L||(e.NotificationPriority=L={}));var M;(function(A){A[A.WORKSPACE=0]="WORKSPACE",A[A.PROFILE=1]="PROFILE",A[A.APPLICATION=2]="APPLICATION"})(M||(e.NeverShowAgainScope=M={}));var b;(function(A){A[A.OFF=0]="OFF",A[A.SILENT=1]="SILENT",A[A.ERROR=2]="ERROR"})(b||(e.NotificationsFilter=b={}));class v{constructor(){this.progress=new g,this.onDidClose=C.Event.None,this.onDidChangeVisibility=C.Event.None}updateSeverity(I){}updateMessage(I){}updateActions(I){}close(){}}e.$7u=v;class g{infinite(){}done(){}total(I){}worked(I){}}e.$8u=g}),define(ke[137],Se([1,0,13,2,5]),function(me,e,C,F,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$RU=e.$QU=e.$PU=e.$OU=e.$NU=void 0,e.$NU=(0,f.$Vh)("openerService");function L(g,A){return F.URI.isUri(g)?(0,C.$6e)(g.scheme,A):(0,C.$7e)(g,A+":")}e.$OU=L;function M(g,...A){return A.some(I=>L(g,I))}e.$PU=M;function b(g,A){return g.with({fragment:`${A.startLineNumber},${A.startColumn}${A.endLineNumber?`-${A.endLineNumber}${A.endColumn?`,${A.endColumn}`:""}`:""}`})}e.$QU=b;function v(g){let A;const I=/^L?(\d+)(?:,(\d+))?(-L?(\d+)(?:,(\d+))?)?/.exec(g.fragment);return I&&(A={startLineNumber:parseInt(I[1]),startColumn:I[2]?parseInt(I[2]):1,endLineNumber:I[4]?parseInt(I[4]):void 0,endColumn:I[4]?I[5]?parseInt(I[5]):1:void 0},g=g.with({fragment:""})),{selection:A,uri:g}}e.$RU=v}),define(ke[254],Se([1,0,49]),function(me,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let F;const f=globalThis.vscode;if(typeof f<"u"&&typeof f.context<"u"){const L=f.context.configuration();if(L)F=L.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(globalThis._VSCODE_PRODUCT_JSON&&globalThis._VSCODE_PACKAGE_JSON){if(F=globalThis._VSCODE_PRODUCT_JSON,C.env.VSCODE_DEV&&Object.assign(F,{nameShort:`${F.nameShort} Dev`,nameLong:`${F.nameLong} Dev`,dataFolderName:`${F.dataFolderName}-dev`,serverDataFolderName:F.serverDataFolderName?`${F.serverDataFolderName}-dev`:void 0}),!F.version){const L=globalThis._VSCODE_PACKAGE_JSON;Object.assign(F,{version:L.version})}}else F={},Object.keys(F).length===0&&Object.assign(F,{version:"1.82.0-dev",nameShort:"Code - OSS Dev",nameLong:"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt",serverLicenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt"});e.default=F}),define(ke[138],Se([1,0,5]),function(me,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wj=e.$vj=void 0,e.$vj=(0,C.$Vh)("productService"),e.$wj="vscode://schemas/vscode-product"});var Be=this&&this.__param||function(me,e){return function(C,F){e(C,F,me)}};define(ke[85],Se([1,0,12,21,3,5]),function(me,e,C,F,f,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cv=e.$bv=e.$av=e.$_u=e.$$u=e.$0u=e.ProgressLocation=e.$9u=void 0,e.$9u=(0,L.$Vh)("progressService");var M;(function(I){I[I.Explorer=1]="Explorer",I[I.Scm=3]="Scm",I[I.Extensions=5]="Extensions",I[I.Window=10]="Window",I[I.Notification=15]="Notification",I[I.Dialog=20]="Dialog"})(M||(e.ProgressLocation=M={})),e.$0u=Object.freeze({total(){},worked(){},done(){}});class b{static{this.None=Object.freeze({report(){}})}get value(){return this.a}constructor($){this.b=$}report($){this.a=$,this.b(this.a)}}e.$$u=b;class v{get value(){return this.a}constructor($){this.e=$}report($){this.b?this.b.push($):this.b=[$],this.f()}async f(){if(!this.c)try{for(this.c=!0;this.b&&this.b.length;){const $=this.b.shift();this.a=$,await this.e(this.a)}}finally{this.c=!1;const $=this.d;this.d=void 0,$?.()}}drain(){return this.c?new Promise($=>{const y=this.d;this.d=()=>{y?.(),$()}}):Promise.resolve()}}e.$_u=v;let g=class extends f.$Rc{constructor($,y){super(),this.a=new C.$ih,y.withProgress($,k=>(this.b=k,this.c&&k.report(this.c),this.a.p)),this.B((0,f.$Pc)(()=>this.a.complete()))}report($){this.b?this.b.report($):this.c=$}};e.$av=g,e.$av=g=He([Be(1,e.$9u)],g);class A extends f.$Rc{constructor($){super(),this.g=$,this.a=0,this.b=this.B(new f.$Qc)}start($){this.stop();const y=++this.a,k=new F.$2d;return this.f=setTimeout(()=>{y===this.a&&(this.c=this.g.show(!0))},$),this.b.add((0,f.$Pc)(()=>clearTimeout(this.f))),this.b.add((0,f.$Pc)(()=>k.cancel())),this.b.add((0,f.$Pc)(()=>this.c?this.c.done():void 0)),{id:y,token:k.token,stop:()=>this.h(y),isCurrent:()=>this.a===y}}stop(){this.h(this.a)}h($){this.a===$&&this.b.clear()}}e.$bv=A,e.$cv=(0,L.$Vh)("editorProgressService")}),define(ke[37],Se([1,0,60,18]),function(me,e,C,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mn=void 0;class f{constructor(){this.a=new Map}add(M,b){C.ok(F.$Cf(M)),C.ok(F.$Ef(b)),C.ok(!this.a.has(M),"There is already an extension with this id"),this.a.set(M,b)}knows(M){return this.a.has(M)}as(M){return this.a.get(M)||null}}e.$mn=new f}),define(ke[108],Se([1,0,4,37]),function(me,e,C,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nn=void 0,e.$nn={JSONContribution:"base.contributions.json"};function f(b){return b.length>0&&b.charAt(b.length-1)==="#"?b.substring(0,b.length-1):b}class L{constructor(){this.b=new C.$Rd,this.onDidChangeSchema=this.b.event,this.a={}}registerSchema(v,g){this.a[f(v)]=g,this.b.fire(v)}notifySchemaChanged(v){this.b.fire(v)}getSchemaContributions(){return{schemas:this.a}}}const M=new L;F.$mn.add(e.$nn.JSONContribution,M)}),define(ke[86],Se([1,0,19,4,18,196,44,108,37]),function(me,e,C,F,f,L,M,b,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gn=e.$Fn=e.$En=e.$Dn=e.$Cn=e.$Bn=e.$An=e.$zn=e.$yn=e.$xn=e.$wn=e.$vn=e.$un=e.$tn=e.$sn=e.ConfigurationScope=e.$rn=e.EditPresentationTypes=void 0;var g;(function(a){a.Multiline="multilineText",a.Singleline="singlelineText"})(g||(e.EditPresentationTypes=g={})),e.$rn={Configuration:"base.contributions.configuration"};var A;(function(a){a[a.APPLICATION=1]="APPLICATION",a[a.MACHINE=2]="MACHINE",a[a.WINDOW=3]="WINDOW",a[a.RESOURCE=4]="RESOURCE",a[a.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",a[a.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(A||(e.ConfigurationScope=A={})),e.$sn={properties:{},patternProperties:{}},e.$tn={properties:{},patternProperties:{}},e.$un={properties:{},patternProperties:{}},e.$vn={properties:{},patternProperties:{}},e.$wn={properties:{},patternProperties:{}},e.$xn={properties:{},patternProperties:{}},e.$yn="vscode://schemas/settings/resourceLanguage",e.$zn="vscode://schemas/settings/configurationDefaults";const I=v.$mn.as(b.$nn.JSONContribution);class ${constructor(){this.h=new Set,this.i=new F.$Rd,this.onDidSchemaChange=this.i.event,this.j=new F.$Rd,this.onDidUpdateConfiguration=this.j.event,this.a=new Map,this.b={id:"defaultOverrides",title:L.localize(0,null),properties:{}},this.c=[this.b],this.g={properties:{},patternProperties:{},additionalProperties:!0,allowTrailingCommas:!0,allowComments:!0},this.d={},this.e=new Map,this.f={},I.registerSchema(e.$yn,this.g),this.v()}registerConfiguration(t,s=!0){this.registerConfigurations([t],s)}registerConfigurations(t,s=!0){const d=new Set;this.n(t,s,d),I.registerSchema(e.$yn,this.g),this.i.fire(),this.j.fire({properties:d})}deregisterConfigurations(t){const s=new Set;this.o(t,s),I.registerSchema(e.$yn,this.g),this.i.fire(),this.j.fire({properties:s})}updateConfigurations({add:t,remove:s}){const d=new Set;this.o(s,d),this.n(t,!1,d),I.registerSchema(e.$yn,this.g),this.i.fire(),this.j.fire({properties:d})}registerDefaultConfigurations(t){const s=new Set;this.k(t,s),this.i.fire(),this.j.fire({properties:s,defaultsOverrides:!0})}k(t,s){const d=[];for(const{overrides:c,source:l}of t)for(const h in c)if(s.add(h),e.$Bn.test(h)){const E=this.a.get(h),D=E?.valuesSources??new Map;if(l)for(const P of Object.keys(c[h]))D.set(P,l);const m={...E?.value||{},...c[h]};this.a.set(h,{source:l,value:m,valuesSources:D});const p=(0,M.$zi)(h),S={type:"object",default:m,description:L.localize(1,null,p),$ref:e.$yn,defaultDefaultValue:m,source:f.$Cf(l)?void 0:l,defaultValueSource:l};d.push(...w(h)),this.d[h]=S,this.b.properties[h]=S}else{this.a.set(h,{value:c[h],source:l});const E=this.d[h];E&&(this.w(h,E),this.r(h,E))}this.m(d)}deregisterDefaultConfigurations(t){const s=new Set;this.l(t,s),this.i.fire(),this.j.fire({properties:s,defaultsOverrides:!0})}l(t,s){for(const{overrides:d,source:c}of t)for(const l in d){const h=this.a.get(l),E=f.$Cf(c)?c:c?.id,D=f.$Cf(h?.source)?h?.source:h?.source?.id;if(E===D)if(s.add(l),this.a.delete(l),e.$Bn.test(l))delete this.d[l],delete this.b.properties[l];else{const m=this.d[l];m&&(this.w(l,m),this.r(l,m))}}this.u()}deltaConfiguration(t){let s=!1;const d=new Set;t.removedDefaults&&(this.l(t.removedDefaults,d),s=!0),t.addedDefaults&&(this.k(t.addedDefaults,d),s=!0),t.removedConfigurations&&this.o(t.removedConfigurations,d),t.addedConfigurations&&this.n(t.addedConfigurations,!1,d),this.i.fire(),this.j.fire({properties:d,defaultsOverrides:s})}notifyConfigurationSchemaUpdated(...t){this.i.fire()}registerOverrideIdentifiers(t){this.m(t),this.i.fire()}m(t){for(const s of t)this.h.add(s);this.u()}n(t,s,d){t.forEach(c=>{this.p(c,s,c.extensionInfo,c.restrictedProperties,void 0,d),this.c.push(c),this.q(c)})}o(t,s){const d=c=>{if(c.properties)for(const l in c.properties){s.add(l);const h=this.d[l];h?.policy?.name&&this.e.delete(h.policy.name),delete this.d[l],this.s(l,c.properties[l])}c.allOf?.forEach(l=>d(l))};for(const c of t){d(c);const l=this.c.indexOf(c);l!==-1&&this.c.splice(l,1)}}p(t,s=!0,d,c,l=3,h){l=f.$Lf(t.scope)?l:t.scope;const E=t.properties;if(E)for(const m in E){const p=E[m];if(s&&n(m,p)){delete E[m];continue}if(p.source=d,p.defaultDefaultValue=E[m].default,this.w(m,p),e.$Bn.test(m)?p.scope=void 0:(p.scope=f.$Lf(p.scope)?l:p.scope,p.restricted=f.$Lf(p.restricted)?!!c?.includes(m):p.restricted),E[m].hasOwnProperty("included")&&!E[m].included){this.f[m]=E[m],delete E[m];continue}else this.d[m]=E[m],E[m].policy?.name&&this.e.set(E[m].policy.name,m);!E[m].deprecationMessage&&E[m].markdownDeprecationMessage&&(E[m].deprecationMessage=E[m].markdownDeprecationMessage),h.add(m)}const D=t.allOf;if(D)for(const m of D)this.p(m,s,d,c,l,h)}getConfigurations(){return this.c}getConfigurationProperties(){return this.d}getPolicyConfigurations(){return this.e}getExcludedConfigurationProperties(){return this.f}getConfigurationDefaultsOverrides(){return this.a}q(t){const s=d=>{const c=d.properties;if(c)for(const h in c)this.r(h,c[h]);d.allOf?.forEach(s)};s(t)}r(t,s){switch(e.$sn.properties[t]=s,s.scope){case 1:e.$tn.properties[t]=s;break;case 2:e.$un.properties[t]=s;break;case 6:e.$vn.properties[t]=s;break;case 3:e.$wn.properties[t]=s;break;case 4:e.$xn.properties[t]=s;break;case 5:e.$xn.properties[t]=s,this.g.properties[t]=s;break}}s(t,s){switch(delete e.$sn.properties[t],s.scope){case 1:delete e.$tn.properties[t];break;case 2:delete e.$un.properties[t];break;case 6:delete e.$vn.properties[t];break;case 3:delete e.$wn.properties[t];break;case 4:case 5:delete e.$xn.properties[t],delete this.g.properties[t];break}}u(){for(const t of this.h.values()){const s=`[${t}]`,d={type:"object",description:L.localize(2,null),errorMessage:L.localize(3,null),$ref:e.$yn};this.w(s,d),e.$sn.properties[s]=d,e.$tn.properties[s]=d,e.$un.properties[s]=d,e.$vn.properties[s]=d,e.$wn.properties[s]=d,e.$xn.properties[s]=d}}v(){const t={type:"object",description:L.localize(4,null),errorMessage:L.localize(5,null),$ref:e.$yn};e.$sn.patternProperties[e.$An]=t,e.$tn.patternProperties[e.$An]=t,e.$un.patternProperties[e.$An]=t,e.$vn.patternProperties[e.$An]=t,e.$wn.patternProperties[e.$An]=t,e.$xn.patternProperties[e.$An]=t,this.i.fire()}w(t,s){const d=this.a.get(t);let c=d?.value,l=d?.source;f.$Jf(c)&&(c=s.defaultDefaultValue,l=void 0),f.$Jf(c)&&(c=o(s.type)),s.default=c,s.defaultValueSource=l}}const y="\\[([^\\]]+)\\]",k=new RegExp(y,"g");e.$An=`^(${y})+$`,e.$Bn=new RegExp(e.$An);function w(a){const t=[];if(e.$Bn.test(a)){let s=k.exec(a);for(;s?.length;){const d=s[1].trim();d&&t.push(d),s=k.exec(a)}}return(0,C.$Lb)(t)}e.$Cn=w;function u(a){return a.reduce((t,s)=>`${t}[${s}]`,"")}e.$Dn=u;function o(a){switch(Array.isArray(a)?a[0]:a){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.$En=o;const i=new $;v.$mn.add(e.$rn.Configuration,i);function n(a,t){return a.trim()?e.$Bn.test(a)?L.localize(7,null,a):i.getConfigurationProperties()[a]!==void 0?L.localize(8,null,a):t.policy?.name&&i.getPolicyConfigurations().get(t.policy?.name)!==void 0?L.localize(9,null,a,t.policy?.name,i.getPolicyConfigurations().get(t.policy?.name)):null:L.localize(6,null)}e.$Fn=n;function r(){const a=[],t=i.getConfigurationProperties();for(const s of Object.keys(t))a.push([s,t[s].scope]);return a.push(["launch",4]),a.push(["task",4]),a}e.$Gn=r}),define(ke[255],Se([1,0,19,4,160,3,28,24,18,2,44,86,37]),function(me,e,C,F,f,L,M,b,v,g,A,I,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mn=e.$Ln=e.$Kn=e.$Jn=e.$In=e.$Hn=void 0;function y(s){return Object.isFrozen(s)?s:b.$bn(s)}class k{constructor(d={},c=[],l=[],h){this.b=d,this.c=c,this.d=l,this.raw=h,this.a=new Map}get rawConfiguration(){if(!this.f)if(this.raw?.length){const d=this.raw.map(c=>{if(c instanceof k)return c;const l=new w("");return l.parseRaw(c),l.configurationModel});this.f=d.reduce((c,l)=>l===c?l:c.merge(l),d[0])}else this.f=this;return this.f}get contents(){return this.b}get overrides(){return this.d}get keys(){return this.c}isEmpty(){return this.c.length===0&&Object.keys(this.b).length===0&&this.d.length===0}getValue(d){return d?(0,A.$xi)(this.contents,d):this.contents}inspect(d,c){const l=this.rawConfiguration.getValue(d),h=c?this.rawConfiguration.getOverrideValue(d,c):void 0,E=c?this.rawConfiguration.override(c).getValue(d):l;return{value:l,override:h,merged:E}}getOverrideValue(d,c){const l=this.i(c);return l?d?(0,A.$xi)(l,d):l:void 0}getKeysForOverrideIdentifier(d){const c=[];for(const l of this.overrides)l.identifiers.includes(d)&&c.push(...l.keys);return C.$Lb(c)}getAllOverrideIdentifiers(){const d=[];for(const c of this.overrides)d.push(...c.identifiers);return C.$Lb(d)}override(d){let c=this.a.get(d);return c||(c=this.g(d),this.a.set(d,c)),c}merge(...d){const c=b.$an(this.contents),l=b.$an(this.overrides),h=[...this.keys],E=this.raw?.length?[...this.raw]:[this];for(const D of d)if(E.push(...D.raw?.length?D.raw:[D]),!D.isEmpty()){this.h(c,D.contents);for(const m of D.overrides){const[p]=l.filter(S=>C.$tb(S.identifiers,m.identifiers));p?(this.h(p.contents,m.contents),p.keys.push(...m.keys),p.keys=C.$Lb(p.keys)):l.push(b.$an(m))}for(const m of D.keys)h.indexOf(m)===-1&&h.push(m)}return new k(c,h,l,E.every(D=>D instanceof k)?void 0:E)}g(d){const c=this.i(d);if(!c||typeof c!="object"||!Object.keys(c).length)return this;const l={};for(const h of C.$Lb([...Object.keys(this.contents),...Object.keys(c)])){let E=this.contents[h];const D=c[h];D&&(typeof E=="object"&&typeof D=="object"?(E=b.$an(E),this.h(E,D)):E=D),l[h]=E}return new k(l,this.keys,this.overrides)}h(d,c){for(const l of Object.keys(c)){if(l in d&&v.$Ef(d[l])&&v.$Ef(c[l])){this.h(d[l],c[l]);continue}d[l]=b.$an(c[l])}}i(d){let c=null,l=null;const h=E=>{E&&(l?this.h(l,E):l=b.$an(E))};for(const E of this.overrides)E.identifiers.length===1&&E.identifiers[0]===d?c=E.contents:E.identifiers.includes(d)&&h(E.contents);return h(c),l}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}addValue(d,c){this.j(d,c,!0)}setValue(d,c){this.j(d,c,!1)}removeValue(d){const c=this.keys.indexOf(d);c!==-1&&(this.keys.splice(c,1),(0,A.$wi)(this.contents,d),I.$Bn.test(d)&&this.overrides.splice(this.overrides.findIndex(l=>C.$tb(l.identifiers,(0,I.$Cn)(d))),1))}j(d,c,l){(0,A.$vi)(this.contents,d,c,h=>console.error(h)),l=l||this.keys.indexOf(d)===-1,l&&this.keys.push(d),I.$Bn.test(d)&&this.overrides.push({identifiers:(0,I.$Cn)(d),keys:Object.keys(this.contents[d]),contents:(0,A.$ui)(this.contents[d],h=>console.error(h))})}}e.$Hn=k;class w{constructor(d){this.f=d,this.a=null,this.b=null,this.c=[],this.d=[]}get configurationModel(){return this.b||new k}get restrictedConfigurations(){return this.c}get errors(){return this.d}parse(d,c){if(!v.$Lf(d)){const l=this.g(d);this.parseRaw(l,c)}}reparse(d){this.a&&this.parseRaw(this.a,d)}parseRaw(d,c){this.a=d;const{contents:l,keys:h,overrides:E,restricted:D,hasExcludedProperties:m}=this.h(d,c);this.b=new k(l,h,E,m?[d]:void 0),this.c=D||[]}g(d){let c={},l=null,h=[];const E=[],D=[];function m(S){Array.isArray(h)?h.push(S):l!==null&&(h[l]=S)}const p={onObjectBegin:()=>{const S={};m(S),E.push(h),h=S,l=null},onObjectProperty:S=>{l=S},onObjectEnd:()=>{h=E.pop()},onArrayBegin:()=>{const S=[];m(S),E.push(h),h=S,l=null},onArrayEnd:()=>{h=E.pop()},onLiteralValue:m,onError:(S,P,z)=>{D.push({error:S,offset:P,length:z})}};if(d)try{f.$0m(d,p),c=h[0]||{}}catch(S){console.error(`Error while parsing settings file ${this.f}: ${S}`),this.d=[S]}return c}h(d,c){const l=$.$mn.as(I.$rn.Configuration).getConfigurationProperties(),h=this.i(d,l,!0,c);d=h.raw;const E=(0,A.$ui)(d,p=>console.error(`Conflict in settings file ${this.f}: ${p}`)),D=Object.keys(d),m=this.j(d,p=>console.error(`Conflict in settings file ${this.f}: ${p}`));return{contents:E,keys:D,overrides:m,restricted:h.restricted,hasExcludedProperties:h.hasExcludedProperties}}i(d,c,l,h){let E=!1;if(!h?.scopes&&!h?.skipRestricted&&!h?.exclude?.length)return{raw:d,restricted:[],hasExcludedProperties:E};const D={},m=[];for(const p in d)if(I.$Bn.test(p)&&l){const S=this.i(d[p],c,!1,h);D[p]=S.raw,E=E||S.hasExcludedProperties,m.push(...S.restricted)}else{const S=c[p],P=S?typeof S.scope<"u"?S.scope:3:void 0;S?.restricted&&m.push(p),!h.exclude?.includes(p)&&(h.include?.includes(p)||(P===void 0||h.scopes===void 0||h.scopes.includes(P))&&!(h.skipRestricted&&S?.restricted))?D[p]=d[p]:E=!0}return{raw:D,restricted:m,hasExcludedProperties:E}}j(d,c){const l=[];for(const h of Object.keys(d))if(I.$Bn.test(h)){const E={};for(const D in d[h])E[D]=d[h][D];l.push({identifiers:(0,I.$Cn)(h),keys:Object.keys(E),contents:(0,A.$ui)(E,c)})}return l}}e.$In=w;class u extends L.$Rc{constructor(d,c,l,h){super(),this.c=d,this.f=c,this.g=h,this.b=this.B(new F.$Rd),this.onDidChange=this.b.event,this.a=new w(this.c.toString()),this.B(this.g.watch(l.dirname(this.c))),this.B(this.g.watch(this.c)),this.B(F.Event.any(F.Event.filter(this.g.onDidFilesChange,E=>E.contains(this.c)),F.Event.filter(this.g.onDidRunOperation,E=>(E.isOperation(0)||E.isOperation(3)||E.isOperation(1)||E.isOperation(4))&&l.isEqual(E.resource,d)))(()=>this.b.fire()))}async loadConfiguration(){try{const d=await this.g.readFile(this.c);return this.a.parse(d.value.toString()||"{}",this.f),this.a.configurationModel}catch{return new k}}reparse(d){return d&&(this.f=d),this.a.reparse(this.f),this.a.configurationModel}getRestrictedSettings(){return this.a.restrictedConfigurations}}e.$Jn=u;class o{constructor(d,c,l,h,E,D,m,p,S,P,z,j,R){this.a=d,this.b=c,this.c=l,this.overrideIdentifiers=h,this.d=E,this.f=D,this.g=m,this.h=p,this.i=S,this.j=P,this.k=z,this.l=j,this.m=R}get value(){return y(this.c)}n(d,c,l){const h=d.inspect(c,l);return{get value(){return y(h.value)},get override(){return y(h.override)},get merged(){return y(h.merged)}}}get q(){return this.p||(this.p=this.n(this.d,this.a,this.b.overrideIdentifier)),this.p}get defaultValue(){return this.q.merged}get default(){return this.q.value!==void 0||this.q.override!==void 0?{value:this.q.value,override:this.q.override}:void 0}get s(){return this.r===void 0&&(this.r=this.f?this.n(this.f,this.a):null),this.r}get policyValue(){return this.s?.merged}get policy(){return this.s?.value!==void 0?{value:this.s.value}:void 0}get u(){return this.t===void 0&&(this.t=this.g?this.n(this.g,this.a):null),this.t}get applicationValue(){return this.u?.merged}get application(){return this.u?.value!==void 0||this.u?.override!==void 0?{value:this.u.value,override:this.u.override}:void 0}get w(){return this.v||(this.v=this.n(this.h,this.a,this.b.overrideIdentifier)),this.v}get userValue(){return this.w.merged}get user(){return this.w.value!==void 0||this.w.override!==void 0?{value:this.w.value,override:this.w.override}:void 0}get y(){return this.x||(this.x=this.n(this.i,this.a,this.b.overrideIdentifier)),this.x}get userLocalValue(){return this.y.merged}get userLocal(){return this.y.value!==void 0||this.y.override!==void 0?{value:this.y.value,override:this.y.override}:void 0}get A(){return this.z||(this.z=this.n(this.j,this.a,this.b.overrideIdentifier)),this.z}get userRemoteValue(){return this.A.merged}get userRemote(){return this.A.value!==void 0||this.A.override!==void 0?{value:this.A.value,override:this.A.override}:void 0}get D(){return this.B===void 0&&(this.B=this.k?this.n(this.k,this.a,this.b.overrideIdentifier):null),this.B}get workspaceValue(){return this.D?.merged}get workspace(){return this.D?.value!==void 0||this.D?.override!==void 0?{value:this.D.value,override:this.D.override}:void 0}get F(){return this.E===void 0&&(this.E=this.l?this.n(this.l,this.a,this.b.overrideIdentifier):null),this.E}get workspaceFolderValue(){return this.F?.merged}get workspaceFolder(){return this.F?.value!==void 0||this.F?.override!==void 0?{value:this.F.value,override:this.F.override}:void 0}get H(){return this.G===void 0&&(this.G=this.n(this.m,this.a,this.b.overrideIdentifier)),this.G}get memoryValue(){return this.H.merged}get memory(){return this.H.value!==void 0||this.H.override!==void 0?{value:this.H.value,override:this.H.override}:void 0}}class i{constructor(d,c,l,h,E=new k,D=new k,m=new M.$zc,p=new k,S=new M.$zc){this.c=d,this.d=c,this.f=l,this.g=h,this.h=E,this.i=D,this.j=m,this.l=p,this.m=S,this.a=null,this.b=new M.$zc,this.n=null}getValue(d,c,l){return this.p(d,c,l).getValue(d)}updateValue(d,c,l={}){let h;l.resource?(h=this.m.get(l.resource),h||(h=new k,this.m.set(l.resource,h))):h=this.l,c===void 0?h.removeValue(d):h.setValue(d,c),l.resource||(this.a=null)}inspect(d,c,l){const h=this.p(d,c,l),E=this.t(c.resource,l),D=c.resource?this.m.get(c.resource)||this.l:this.l,m=new Set;for(const p of h.overrides)for(const S of p.identifiers)h.getOverrideValue(d,S)!==void 0&&m.add(S);return new o(d,c,h.getValue(d),m.size?[...m]:void 0,this.c,this.d.isEmpty()?void 0:this.d,this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration,this.userConfiguration,this.localUserConfiguration,this.remoteUserConfiguration,l?this.i:void 0,E||void 0,D)}keys(d){const c=this.t(void 0,d);return{default:this.c.keys.slice(0),user:this.userConfiguration.keys.slice(0),workspace:this.i.keys.slice(0),workspaceFolder:c?c.keys.slice(0):[]}}updateDefaultConfiguration(d){this.c=d,this.a=null,this.b.clear()}updatePolicyConfiguration(d){this.d=d}updateApplicationConfiguration(d){this.f=d,this.a=null,this.b.clear()}updateLocalUserConfiguration(d){this.g=d,this.n=null,this.a=null,this.b.clear()}updateRemoteUserConfiguration(d){this.h=d,this.n=null,this.a=null,this.b.clear()}updateWorkspaceConfiguration(d){this.i=d,this.a=null,this.b.clear()}updateFolderConfiguration(d,c){this.j.set(d,c),this.b.delete(d)}deleteFolderConfiguration(d){this.folderConfigurations.delete(d),this.b.delete(d)}compareAndUpdateDefaultConfiguration(d,c){const l=[];if(!c){const{added:h,updated:E,removed:D}=a(this.c,d);c=[...h,...E,...D]}for(const h of c)for(const E of(0,I.$Cn)(h)){const D=this.c.getKeysForOverrideIdentifier(E),m=d.getKeysForOverrideIdentifier(E),p=[...m.filter(S=>D.indexOf(S)===-1),...D.filter(S=>m.indexOf(S)===-1),...D.filter(S=>!b.$en(this.c.override(E).getValue(S),d.override(E).getValue(S)))];l.push([E,p])}return this.updateDefaultConfiguration(d),{keys:c,overrides:l}}compareAndUpdatePolicyConfiguration(d){const{added:c,updated:l,removed:h}=a(this.d,d),E=[...c,...l,...h];return E.length&&this.updatePolicyConfiguration(d),{keys:E,overrides:[]}}compareAndUpdateApplicationConfiguration(d){const{added:c,updated:l,removed:h,overrides:E}=a(this.applicationConfiguration,d),D=[...c,...l,...h];return D.length&&this.updateApplicationConfiguration(d),{keys:D,overrides:E}}compareAndUpdateLocalUserConfiguration(d){const{added:c,updated:l,removed:h,overrides:E}=a(this.localUserConfiguration,d),D=[...c,...l,...h];return D.length&&this.updateLocalUserConfiguration(d),{keys:D,overrides:E}}compareAndUpdateRemoteUserConfiguration(d){const{added:c,updated:l,removed:h,overrides:E}=a(this.remoteUserConfiguration,d),D=[...c,...l,...h];return D.length&&this.updateRemoteUserConfiguration(d),{keys:D,overrides:E}}compareAndUpdateWorkspaceConfiguration(d){const{added:c,updated:l,removed:h,overrides:E}=a(this.workspaceConfiguration,d),D=[...c,...l,...h];return D.length&&this.updateWorkspaceConfiguration(d),{keys:D,overrides:E}}compareAndUpdateFolderConfiguration(d,c){const l=this.folderConfigurations.get(d),{added:h,updated:E,removed:D,overrides:m}=a(l,c),p=[...h,...E,...D];return(p.length||!l)&&this.updateFolderConfiguration(d,c),{keys:p,overrides:m}}compareAndDeleteFolderConfiguration(d){const c=this.folderConfigurations.get(d);if(!c)throw new Error("Unknown folder");this.deleteFolderConfiguration(d);const{added:l,updated:h,removed:E,overrides:D}=a(c,void 0);return{keys:[...l,...h,...E],overrides:D}}get defaults(){return this.c}get applicationConfiguration(){return this.f}get userConfiguration(){return this.n||(this.n=this.h.isEmpty()?this.g:this.g.merge(this.h)),this.n}get localUserConfiguration(){return this.g}get remoteUserConfiguration(){return this.h}get workspaceConfiguration(){return this.i}get folderConfigurations(){return this.j}p(d,c,l){let h=this.q(c,l);return c.overrideIdentifier&&(h=h.override(c.overrideIdentifier)),!this.d.isEmpty()&&this.d.getValue(d)!==void 0&&(h=h.merge(this.d)),h}q({resource:d},c){let l=this.r();if(c&&d){const h=c.getFolder(d);h&&(l=this.s(h.uri)||l);const E=this.m.get(d);E&&(l=l.merge(E))}return l}r(){return this.a||(this.a=this.c.merge(this.applicationConfiguration,this.userConfiguration,this.i,this.l)),this.a}s(d){let c=this.b.get(d);if(!c){const l=this.r(),h=this.j.get(d);h?(c=l.merge(h),this.b.set(d,c)):c=l}return c}t(d,c){if(c&&d){const l=c.getFolder(d);if(l)return this.j.get(l.uri)}}toData(){return{defaults:{contents:this.c.contents,overrides:this.c.overrides,keys:this.c.keys},policy:{contents:this.d.contents,overrides:this.d.overrides,keys:this.d.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this.i.contents,overrides:this.i.overrides,keys:this.i.keys},folders:[...this.j.keys()].reduce((d,c)=>{const{contents:l,overrides:h,keys:E}=this.j.get(c);return d.push([c,{contents:l,overrides:h,keys:E}]),d},[])}}allKeys(){const d=new Set;return this.c.keys.forEach(c=>d.add(c)),this.userConfiguration.keys.forEach(c=>d.add(c)),this.i.keys.forEach(c=>d.add(c)),this.j.forEach(c=>c.keys.forEach(l=>d.add(l))),[...d.values()]}u(){const d=new Set;return this.c.getAllOverrideIdentifiers().forEach(c=>d.add(c)),this.userConfiguration.getAllOverrideIdentifiers().forEach(c=>d.add(c)),this.i.getAllOverrideIdentifiers().forEach(c=>d.add(c)),this.j.forEach(c=>c.getAllOverrideIdentifiers().forEach(l=>d.add(l))),[...d.values()]}v(d){const c=new Set;return this.c.getKeysForOverrideIdentifier(d).forEach(l=>c.add(l)),this.userConfiguration.getKeysForOverrideIdentifier(d).forEach(l=>c.add(l)),this.i.getKeysForOverrideIdentifier(d).forEach(l=>c.add(l)),this.j.forEach(l=>l.getKeysForOverrideIdentifier(d).forEach(h=>c.add(h))),[...c.values()]}static parse(d){const c=this.w(d.defaults),l=this.w(d.policy),h=this.w(d.application),E=this.w(d.user),D=this.w(d.workspace),m=d.folders.reduce((p,S)=>(p.set(g.URI.revive(S[0]),this.w(S[1])),p),new M.$zc);return new i(c,l,h,E,new k,D,m,new k,new M.$zc)}static w(d){return new k(d.contents,d.keys,d.overrides)}}e.$Kn=i;function n(...s){if(s.length===0)return{keys:[],overrides:[]};if(s.length===1)return s[0];const d=new Set,c=new Map;for(const h of s)h.keys.forEach(E=>d.add(E)),h.overrides.forEach(([E,D])=>{const m=(0,M.$wc)(c,E,new Set);D.forEach(p=>m.add(p))});const l=[];return c.forEach((h,E)=>l.push([E,[...h.values()]])),{keys:[...d.values()],overrides:l}}e.$Ln=n;class r{constructor(d,c,l,h){this.change=d,this.f=c,this.g=l,this.h=h,this.a=`
`,this.b=this.a.charCodeAt(0),this.c=".".charCodeAt(0),this.affectedKeys=new Set,this.i=void 0;for(const E of d.keys)this.affectedKeys.add(E);for(const[,E]of d.overrides)for(const D of E)this.affectedKeys.add(D);this.d=this.a;for(const E of this.affectedKeys)this.d+=E+this.a}get previousConfiguration(){return!this.i&&this.f&&(this.i=i.parse(this.f.data)),this.i}affectsConfiguration(d,c){const l=this.a+d,h=this.d.indexOf(l);if(h<0)return!1;const E=h+l.length;if(E>=this.d.length)return!1;const D=this.d.charCodeAt(E);if(D!==this.b&&D!==this.c)return!1;if(c){const m=this.previousConfiguration?this.previousConfiguration.getValue(d,c,this.f?.workspace):void 0,p=this.g.getValue(d,c,this.h);return!b.$en(m,p)}return!0}}e.$Mn=r;function a(s,d){const{added:c,removed:l,updated:h}=t(d?.rawConfiguration,s?.rawConfiguration),E=[],D=s?.getAllOverrideIdentifiers()||[],m=d?.getAllOverrideIdentifiers()||[];if(d){const p=m.filter(S=>!D.includes(S));for(const S of p)E.push([S,d.getKeysForOverrideIdentifier(S)])}if(s){const p=D.filter(S=>!m.includes(S));for(const S of p)E.push([S,s.getKeysForOverrideIdentifier(S)])}if(d&&s){for(const p of D)if(m.includes(p)){const S=t({contents:s.getOverrideValue(void 0,p)||{},keys:s.getKeysForOverrideIdentifier(p)},{contents:d.getOverrideValue(void 0,p)||{},keys:d.getKeysForOverrideIdentifier(p)});E.push([p,[...S.added,...S.removed,...S.updated]])}}return{added:c,removed:l,updated:h,overrides:E}}function t(s,d){const c=s?d?s.keys.filter(E=>d.keys.indexOf(E)===-1):[...s.keys]:[],l=d?s?d.keys.filter(E=>s.keys.indexOf(E)===-1):[...d.keys]:[],h=[];if(s&&d){for(const E of d.keys)if(s.keys.indexOf(E)!==-1){const D=(0,A.$xi)(d.contents,E),m=(0,A.$xi)(s.contents,E);b.$en(D,m)||h.push(E)}}return{added:c,removed:l,updated:h}}}),define(ke[256],Se([1,0,22,4,3,82]),function(me,e,C,F,f,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9pb=e.$8pb=e.$7pb=e.$6pb=void 0;const M=(g,A,I)=>{const $=new Uint8Array(16);for(let w=0;w<16;w++)$[w]=Math.round(Math.random()*256);const y=(0,C.$ze)(C.$fe.wrap($));return[`GET ws://localhost${g}?${A}&skipWebSocketFrames=true HTTP/1.1`,"Connection: Upgrade","Upgrade: websocket",`Sec-WebSocket-Key: ${y}`].join(`\r
`)+`\r
\r
`};e.$6pb=M,e.$7pb=C.$fe.fromString(`\r
\r
`);async function b(g,A,I,$,y){g.write(C.$fe.fromString((0,e.$6pb)(A,I,$)));const k=new f.$Qc;try{return await new Promise((w,u)=>{let o;k.add(g.onData(i=>{o?o=C.$fe.concat([o,i],o.byteLength+i.byteLength):o=i;const n=o.indexOf(e.$7pb);if(n===-1)return;w(g),g.pauseData();const r=o.slice(n+e.$7pb.byteLength);r.byteLength&&y.onData.fire(r)})),k.add(g.onClose(i=>u(i??new Error("socket closed")))),k.add(g.onEnd(()=>u(new Error("socket ended"))))})}catch(w){throw g.dispose(),w}finally{k.dispose()}}e.$8pb=b;class v extends f.$Rc{constructor(A,I){super(),this.g=A,this.a=this.B(new F.$Ud),this.onData=(...$)=>(this.a.isPaused&&queueMicrotask(()=>this.a.resume()),this.a.event(...$)),this.b=this.B(new F.$Rd),this.onDidDispose=this.b.event,this.f=!1,this.B(I.onData),this.B(I.onData.event($=>this.a.fire($))),this.onClose=this.B(I.onClose).event,this.onEnd=this.B(I.onEnd).event}pauseData(){this.a.pause()}drain(){return Promise.resolve()}end(){this.f=!0,this.h()}traceSocketEvent(A,I){L.SocketDiagnostics.traceSocketEvent(this,this.g,A,I)}dispose(){this.f||this.h(),this.b.fire(),super.dispose()}}e.$9pb=v}),define(ke[64],Se([1,0,8,5]),function(me,e,C,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zk=e.$Yk=e.RemoteAuthorityResolverErrorCode=e.$Xk=e.$Wk=e.RemoteConnectionType=e.$Vk=void 0,e.$Vk=(0,F.$Vh)("remoteAuthorityResolverService");var f;(function(A){A[A.WebSocket=0]="WebSocket",A[A.Managed=1]="Managed"})(f||(e.RemoteConnectionType=f={}));class L{constructor(I){this.id=I,this.type=1}toString(){return`Managed(${this.id})`}}e.$Wk=L;class M{constructor(I,$){this.host=I,this.port=$,this.type=0}toString(){return`WebSocket(${this.host}:${this.port})`}}e.$Xk=M;var b;(function(A){A.Unknown="Unknown",A.NotAvailable="NotAvailable",A.TemporarilyNotAvailable="TemporarilyNotAvailable",A.NoResolverFound="NoResolverFound",A.InvalidAuthority="InvalidAuthority"})(b||(e.RemoteAuthorityResolverErrorCode=b={}));class v extends C.$ab{static isNotAvailable(I){return I instanceof v&&I._code===b.NotAvailable}static isTemporarilyNotAvailable(I){return I instanceof v&&I._code===b.TemporarilyNotAvailable}static isNoResolverFound(I){return I instanceof v&&I._code===b.NoResolverFound}static isInvalidAuthority(I){return I instanceof v&&I._code===b.InvalidAuthority}static isHandled(I){return I instanceof v&&I.isHandled}constructor(I,$=b.Unknown,y){super(I),this._message=I,this._code=$,this._detail=y,this.isHandled=$===b.NotAvailable&&y===!0,Object.setPrototypeOf(this,v.prototype)}}e.$Yk=v;function g(A){const I=A.indexOf("+");return I===-1?A:A.substring(0,I)}e.$Zk=g}),define(ke[65],Se([1,0,17]),function(me,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5k=e.$4k=e.$3k=e.$2k=e.$1k=void 0;function F(g){return g.scheme===C.Schemas.vscodeRemote?g.authority:void 0}e.$1k=F;function f(g){if(!g)return;const A=g.indexOf("+");return A<0?g:g.substr(0,A)}e.$2k=f;function L(g){return`/${g.quality??"oss"}-${g.commit??"dev"}`}e.$3k=L;function M(g){const{host:A,port:I}=v(g);if(typeof I>"u")throw new Error("Remote authority doesn't contain a port!");return{host:A,port:I}}e.$4k=M;function b(g,A){let{host:I,port:$}=v(g);return typeof $>"u"&&($=A),{host:I,port:$}}e.$5k=b;function v(g){const A=g.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(A)return{host:A[1],port:parseInt(A[2],10)};const I=g.match(/^(\[[0-9a-z:]+\])$/);if(I)return{host:I[1],port:void 0};const $=g.match(/(.*):(\d+)$/);return $?{host:$[1],port:parseInt($[2],10)}:{host:g,port:void 0}}}),define(ke[26],Se([1,0,13,5,65]),function(me,e,C,F,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gm=e.$fm=e.$em=e.$dm=e.$cm=e.$bm=e.$am=e.$_l=e.TargetPlatform=e.ExtensionType=e.$$l=e.$0l=e.$9l=e.$8l=e.$7l=e.$6l=void 0,e.$6l="extensions.user.cache",e.$7l="extensions.builtin.cache",e.$8l="undefined_publisher",e.$9l=["ui","workspace","web"];function L(w){if(typeof w=="object"&&w!==null&&w.supported!==!0)return w.description}e.$0l=L,e.$$l=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var M;(function(w){w[w.System=0]="System",w[w.User=1]="User"})(M||(e.ExtensionType=M={}));var b;(function(w){w.WIN32_X64="win32-x64",w.WIN32_ARM64="win32-arm64",w.LINUX_X64="linux-x64",w.LINUX_ARM64="linux-arm64",w.LINUX_ARMHF="linux-armhf",w.ALPINE_X64="alpine-x64",w.ALPINE_ARM64="alpine-arm64",w.DARWIN_X64="darwin-x64",w.DARWIN_ARM64="darwin-arm64",w.WEB="web",w.UNIVERSAL="universal",w.UNKNOWN="unknown",w.UNDEFINED="undefined"})(b||(e.TargetPlatform=b={}));class v{constructor(u){this.value=u,this._lower=u.toLowerCase()}static equals(u,o){if(typeof u>"u"||u===null)return typeof o>"u"||o===null;if(typeof o>"u"||o===null)return!1;if(typeof u=="string"||typeof o=="string"){const i=typeof u=="string"?u:u.value,n=typeof o=="string"?o:o.value;return C.$6e(i,n)}return u._lower===o._lower}static toKey(u){return typeof u=="string"?u.toLowerCase():u._lower}}e.$_l=v;class g{get size(){return this.c.size}constructor(u){if(this.c=new Set,u)for(const o of u)this.add(o)}add(u){this.c.add(v.toKey(u))}delete(u){return this.c.delete(v.toKey(u))}has(u){return this.c.has(v.toKey(u))}}e.$am=g;class A{constructor(){this.c=new Map}clear(){this.c.clear()}delete(u){this.c.delete(v.toKey(u))}get(u){return this.c.get(v.toKey(u))}has(u){return this.c.has(v.toKey(u))}set(u,o){this.c.set(v.toKey(u),o)}values(){return this.c.values()}forEach(u){this.c.forEach(u)}[Symbol.iterator](){return this.c[Symbol.iterator]()}}e.$bm=A;function I(w){return $(w)}e.$cm=I;function $(w){return w.contributes&&w.contributes.localizations?w.contributes.localizations.length>0:!1}e.$dm=$;function y(w){return w.contributes&&w.contributes.authentication?w.contributes.authentication.length>0:!1}e.$em=y;function k(w,u){if(u){const o=`onResolveRemoteAuthority:${(0,f.$2k)(u)}`;return!!w.activationEvents?.includes(o)}return!1}e.$fm=k,e.$gm=(0,F.$Vh)("IBuiltinExtensionsScannerService")}),define(ke[139],Se([1,0,8,26]),function(me,e,C,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xF=e.$wF=void 0;class f{constructor(){this.a=new Map,this.b=new WeakMap}register(M,b){this.a.set(M,b)}readActivationEvents(M){return this.b.has(M)||this.b.set(M,this.c(M)),this.b.get(M)}createActivationEventsMap(M){const b=Object.create(null);for(const v of M){const g=this.readActivationEvents(v);g.length>0&&(b[F.$_l.toKey(v.identifier)]=g)}return b}c(M){if(typeof M.main>"u"&&typeof M.browser>"u")return[];const b=Array.isArray(M.activationEvents)?M.activationEvents.slice(0):[];for(let v=0;v<b.length;v++)b[v]==="onUri"&&(b[v]=`onUri:${F.$_l.toKey(M.identifier)}`);if(!M.contributes)return b;for(const v in M.contributes){const g=this.a.get(v);if(!g)continue;const A=M.contributes[v],I=Array.isArray(A)?A:[A];try{g(I,b)}catch($){(0,C.$Z)($)}}return b}}e.$wF=f,e.$xF=new f}),define(ke[257],Se([1,0,12,22,21,8,4,3,56,38,32,82,64,65]),function(me,e,C,F,f,L,M,b,v,g,A,I,$,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hl=e.$gl=e.$fl=e.$el=e.$dl=e.$cl=e.$bl=e.$al=e.PersistentConnectionEventType=e.$_k=e.$$k=e.$0k=e.ConnectionType=void 0;const k=30*1e3;var w;(function(q){q[q.Management=1]="Management",q[q.ExtensionHost=2]="ExtensionHost",q[q.Tunnel=3]="Tunnel"})(w||(e.ConnectionType=w={}));function u(q){switch(q){case 1:return"Management";case 2:return"ExtensionHost";case 3:return"Tunnel"}}function o(q){const U=new f.$2d;return setTimeout(()=>U.cancel(),q),U.token}function i(q,U){if(q.isCancellationRequested||U.isCancellationRequested)return f.CancellationToken.Cancelled;const ie=new f.$2d;return q.onCancellationRequested(()=>ie.cancel()),U.onCancellationRequested(()=>ie.cancel()),ie.token}class n{get didTimeout(){return this.c==="timedout"}constructor(U){this.c="pending",this.d=new b.$Qc,this.promise=new Promise((ie,be)=>{this.f=ie,this.g=be}),U.isCancellationRequested?this.h():this.d.add(U.onCancellationRequested(()=>this.h()))}registerDisposable(U){this.c==="pending"?this.d.add(U):U.dispose()}h(){this.c==="pending"&&(this.d.dispose(),this.c="timedout",this.g(this.i()))}i(){const U=new Error("Time limit reached");return U.code="ETIMEDOUT",U.syscall="connect",U}resolve(U){this.c==="pending"&&(this.d.dispose(),this.c="resolved",this.f(U))}reject(U){this.c==="pending"&&(this.d.dispose(),this.c="rejected",this.g(U))}}function r(q,U){const ie=new n(U);return ie.registerDisposable(q.onControlMessage(be=>{const H=JSON.parse(be.toString()),Y=J(H);Y?ie.reject(Y):ie.resolve(H)})),ie.promise}function a(q,U,ie,be,H,Y,Z,$e){const ne=new n($e),fe=g.$Nd.create(!1);return q.info(`Creating a socket (${Z})...`),v.mark(`code/willCreateSocket/${Y}`),U.connect(ie,be,H,Z).then(te=>{ne.didTimeout?(v.mark(`code/didCreateSocketError/${Y}`),q.info(`Creating a socket (${Z}) finished after ${fe.elapsed()} ms, but this is too late and has timed out already.`),te?.dispose()):(v.mark(`code/didCreateSocketOK/${Y}`),q.info(`Creating a socket (${Z}) was successful after ${fe.elapsed()} ms.`),ne.resolve(te))},te=>{v.mark(`code/didCreateSocketError/${Y}`),q.info(`Creating a socket (${Z}) returned an error after ${fe.elapsed()} ms.`),q.error(te),ne.reject(te)}),ne.promise}function t(q,U){const ie=new n(U);return q.then(be=>{ie.didTimeout||ie.resolve(be)},be=>{ie.didTimeout||ie.reject(be)}),ie.promise}async function s(q,U,ie,be){const H=Ee(q,U);q.logService.trace(`${H} 1/6. invoking socketFactory.connect().`);let Y;try{Y=await a(q.logService,q.remoteSocketFactoryService,q.connectTo,(0,y.$3k)(q),`reconnectionToken=${q.reconnectionToken}&reconnection=${q.reconnectionProtocol?"true":"false"}`,u(U),`renderer-${u(U)}-${q.reconnectionToken}`,be)}catch(te){throw q.logService.error(`${H} socketFactory.connect() failed or timed out. Error:`),q.logService.error(te),te}q.logService.trace(`${H} 2/6. socketFactory.connect() was successful.`);let Z,$e;q.reconnectionProtocol?(q.reconnectionProtocol.beginAcceptReconnection(Y,null),Z=q.reconnectionProtocol,$e=!1):(Z=new I.$Jh({socket:Y}),$e=!0),q.logService.trace(`${H} 3/6. sending AuthRequest control message.`);const ne=await t(q.signService.createNewMessage((0,A.$ig)()),be),fe={type:"auth",auth:q.connectionToken||"00000000000000000000",data:ne.data};Z.sendControl(F.$fe.fromString(JSON.stringify(fe)));try{const te=await r(Z,i(be,o(1e4)));if(te.type!=="sign"||typeof te.data!="string"){const B=new Error("Unexpected handshake message");throw B.code="VSCODE_CONNECTION_ERROR",B}if(q.logService.trace(`${H} 4/6. received SignRequest control message.`),!await t(q.signService.validate(ne,te.signedData),be)){const B=new Error("Refused to connect to unsupported server");throw B.code="VSCODE_CONNECTION_ERROR",B}const pe=await t(q.signService.sign(te.data),be),Pe={type:"connectionType",commit:q.commit,signedData:pe,desiredConnectionType:U};return ie&&(Pe.args=ie),q.logService.trace(`${H} 5/6. sending ConnectionTypeRequest control message.`),Z.sendControl(F.$fe.fromString(JSON.stringify(Pe))),{protocol:Z,ownsProtocol:$e}}catch(te){throw te&&te.code==="ETIMEDOUT"&&(q.logService.error(`${H} the handshake timed out. Error:`),q.logService.error(te)),te&&te.code==="VSCODE_CONNECTION_ERROR"&&(q.logService.error(`${H} received error control message when negotiating connection. Error:`),q.logService.error(te)),$e&&G(Z),te}}async function d(q,U,ie,be){const H=Date.now(),Y=Ee(q,U),{protocol:Z,ownsProtocol:$e}=await s(q,U,ie,be),ne=new n(be);return ne.registerDisposable(Z.onControlMessage(fe=>{const te=JSON.parse(fe.toString()),de=J(te);de?(q.logService.error(`${Y} received error control message when negotiating connection. Error:`),q.logService.error(de),$e&&G(Z),ne.reject(de)):(q.reconnectionProtocol?.endAcceptReconnection(),q.logService.trace(`${Y} 6/6. handshake finished, connection is up and running after ${he(H)}!`),ne.resolve({protocol:Z,firstMessage:te}))})),ne.promise}async function c(q,U){const{protocol:ie}=await d(q,1,void 0,U);return{protocol:ie}}async function l(q,U,ie){const{protocol:be,firstMessage:H}=await d(q,2,U,ie),Y=H&&H.debugPort;return{protocol:be,debugPort:Y}}async function h(q,U,ie){const be=Date.now(),H=Ee(q,3),{protocol:Y}=await s(q,3,U,ie);return q.logService.trace(`${H} 6/6. handshake finished, connection is up and running after ${he(be)}!`),Y}async function E(q,U,ie){const{connectTo:be,connectionToken:H}=await q.addressProvider.getAddress();return{commit:q.commit,quality:q.quality,connectTo:be,connectionToken:H,reconnectionToken:U,reconnectionProtocol:ie,remoteSocketFactoryService:q.remoteSocketFactoryService,signService:q.signService,logService:q.logService}}async function D(q,U,ie){return p(q,async be=>{const{protocol:H}=await c(be,f.CancellationToken.None);return new x(q,U,ie,be.reconnectionToken,H)})}e.$0k=D;async function m(q,U){return p(q,async ie=>{const{protocol:be,debugPort:H}=await l(ie,U,f.CancellationToken.None);return new le(q,U,ie.reconnectionToken,be,H)})}e.$$k=m;async function p(q,U){for(let be=1;;be++)try{const H=(0,A.$ig)(),Y=await E(q,H,null);return await U(Y)}catch(H){if(be<5)q.logService.error(`[remote-connection][attempt ${be}] An error occurred in initial connection! Will retry... Error:`),q.logService.error(H);else throw q.logService.error(`[remote-connection][attempt ${be}]  An error occurred in initial connection! It will be treated as a permanent error. Error:`),q.logService.error(H),W.triggerPermanentFailure(0,0,$.$Yk.isHandled(H)),H}}async function S(q,U,ie){const be=await E(q,(0,A.$ig)(),null);return await h(be,{host:U,port:ie},f.CancellationToken.None)}e.$_k=S;function P(q){return(0,C.$Lg)(U=>new Promise((ie,be)=>{const H=setTimeout(ie,q*1e3);U.onCancellationRequested(()=>{clearTimeout(H),ie()})}))}var z;(function(q){q[q.ConnectionLost=0]="ConnectionLost",q[q.ReconnectionWait=1]="ReconnectionWait",q[q.ReconnectionRunning=2]="ReconnectionRunning",q[q.ReconnectionPermanentFailure=3]="ReconnectionPermanentFailure",q[q.ConnectionGain=4]="ConnectionGain"})(z||(e.PersistentConnectionEventType=z={}));class j{constructor(U,ie){this.reconnectionToken=U,this.millisSinceLastIncomingData=ie,this.type=0}}e.$al=j;class R{constructor(U,ie,be,H){this.reconnectionToken=U,this.millisSinceLastIncomingData=ie,this.durationSeconds=be,this.c=H,this.type=1}skipWait(){this.c.cancel()}}e.$bl=R;class T{constructor(U,ie,be){this.reconnectionToken=U,this.millisSinceLastIncomingData=ie,this.attempt=be,this.type=2}}e.$cl=T;class N{constructor(U,ie,be){this.reconnectionToken=U,this.millisSinceLastIncomingData=ie,this.attempt=be,this.type=4}}e.$dl=N;class O{constructor(U,ie,be,H){this.reconnectionToken=U,this.millisSinceLastIncomingData=ie,this.attempt=be,this.handled=H,this.type=3}}e.$el=O;class W extends b.$Rc{static triggerPermanentFailure(U,ie,be){this._permanentFailure=!0,this.f=U,this.g=ie,this.h=be,this.j.forEach(H=>H.D(this.f,this.g,this.h))}static debugTriggerReconnection(){this.j.forEach(U=>U.y())}static debugPauseSocketWriting(){this.j.forEach(U=>U.F())}static{this._permanentFailure=!1}static{this.f=0}static{this.g=0}static{this.h=!1}static{this.j=[]}get n(){return this.c||W._permanentFailure}constructor(U,ie,be,H,Y){super(),this.t=U,this.u=ie,this.reconnectionToken=be,this.protocol=H,this.w=Y,this.m=this.B(new M.$Rd),this.onDidStateChange=this.m.event,this.c=!1,this.r=!1,this.s=!1,this.m.fire(new N(this.reconnectionToken,0,0)),this.B(H.onSocketClose(Z=>{const $e=_(this.t,this.reconnectionToken,!0);Z?Z.type===0?(this.u.logService.info(`${$e} received socket close event (hadError: ${Z.hadError}).`),Z.error&&this.u.logService.error(Z.error)):(this.u.logService.info(`${$e} received socket close event (wasClean: ${Z.wasClean}, code: ${Z.code}, reason: ${Z.reason}).`),Z.event&&this.u.logService.error(Z.event)):this.u.logService.info(`${$e} received socket close event.`),this.y()})),this.B(H.onSocketTimeout(Z=>{const $e=_(this.t,this.reconnectionToken,!0);this.u.logService.info(`${$e} received socket timeout event (unacknowledgedMsgCount: ${Z.unacknowledgedMsgCount}, timeSinceOldestUnacknowledgedMsg: ${Z.timeSinceOldestUnacknowledgedMsg}, timeSinceLastReceivedSomeData: ${Z.timeSinceLastReceivedSomeData}).`),this.y()})),W.j.push(this),this.B((0,b.$Pc)(()=>{const Z=W.j.indexOf(this);Z>=0&&W.j.splice(Z,1)})),this.n&&this.D(W.f,W.g,W.h)}dispose(){super.dispose(),this.s=!0}async y(){if(!this.r)try{this.r=!0,await this.z()}finally{this.r=!1}}async z(){if(this.n||this.s)return;const U=_(this.t,this.reconnectionToken,!0);this.u.logService.info(`${U} starting reconnecting loop. You can get more information with the trace log level.`),this.m.fire(new j(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData()));const ie=[0,5,5,10,10,10,10,10,30];let be=-1;do{be++;const H=be<ie.length?ie[be]:ie[ie.length-1];try{if(H>0){const Z=P(H);this.m.fire(new R(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),H,Z)),this.u.logService.info(`${U} waiting for ${H} seconds before reconnecting...`);try{await Z}catch{}}if(this.n){this.u.logService.error(`${U} permanent failure occurred while running the reconnecting loop.`);break}this.m.fire(new T(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),be+1)),this.u.logService.info(`${U} resolving connection...`);const Y=await E(this.u,this.reconnectionToken,this.protocol);this.u.logService.info(`${U} connecting to ${Y.connectTo}...`),await this.G(Y,o(k)),this.u.logService.info(`${U} reconnected!`),this.m.fire(new N(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),be+1));break}catch(Y){if(Y.code==="VSCODE_CONNECTION_ERROR"){this.u.logService.error(`${U} A permanent error occurred in the reconnecting loop! Will give up now! Error:`),this.u.logService.error(Y),this.C(this.protocol.getMillisSinceLastIncomingData(),be+1,!1);break}if(be>360){this.u.logService.error(`${U} An error occurred while reconnecting, but it will be treated as a permanent error because the reconnection grace time has expired! Will give up now! Error:`),this.u.logService.error(Y),this.C(this.protocol.getMillisSinceLastIncomingData(),be+1,!1);break}if($.$Yk.isTemporarilyNotAvailable(Y)){this.u.logService.info(`${U} A temporarily not available error occurred while trying to reconnect, will try again...`),this.u.logService.trace(Y);continue}if((Y.code==="ETIMEDOUT"||Y.code==="ENETUNREACH"||Y.code==="ECONNREFUSED"||Y.code==="ECONNRESET")&&Y.syscall==="connect"){this.u.logService.info(`${U} A network error occurred while trying to reconnect, will try again...`),this.u.logService.trace(Y);continue}if((0,L.$3)(Y)){this.u.logService.info(`${U} A promise cancelation error occurred while trying to reconnect, will try again...`),this.u.logService.trace(Y);continue}if(Y instanceof $.$Yk){this.u.logService.error(`${U} A RemoteAuthorityResolverError occurred while trying to reconnect. Will give up now! Error:`),this.u.logService.error(Y),this.C(this.protocol.getMillisSinceLastIncomingData(),be+1,$.$Yk.isHandled(Y));break}this.u.logService.error(`${U} An unknown error occurred while trying to reconnect, since this is an unknown case, it will be treated as a permanent error! Will give up now! Error:`),this.u.logService.error(Y),this.C(this.protocol.getMillisSinceLastIncomingData(),be+1,!1);break}}while(!this.n&&!this.s)}C(U,ie,be){this.w?W.triggerPermanentFailure(U,ie,be):this.D(U,ie,be)}D(U,ie,be){this.m.fire(new O(this.reconnectionToken,U,ie,be)),G(this.protocol)}F(){this.protocol.pauseSocketWriting()}}e.$fl=W;class x extends W{constructor(U,ie,be,H,Y){super(1,U,H,Y,!0),this.client=this.B(new I.$Hh(Y,{remoteAuthority:ie,clientId:be},U.ipcLogger))}async G(U,ie){await c(U,ie)}}e.$gl=x;class le extends W{constructor(U,ie,be,H,Y){super(2,U,be,H,!1),this.H=ie,this.debugPort=Y}async G(U,ie){await l(U,this.H,ie)}}e.$hl=le;function G(q){try{q.acceptDisconnect();const U=q.getSocket();q.dispose(),U.dispose()}catch(U){(0,L.$Z)(U)}}function J(q){if(q&&q.type==="error"){const U=new Error(`Connection error: ${q.reason}`);return U.code="VSCODE_CONNECTION_ERROR",U}return null}function Q(q,U){for(;q.length<U;)q+=" ";return q}function oe(q,U){return`[remote-connection][${Q(u(q),13)}][${U.substr(0,5)}\u2026]`}function _(q,U,ie){return`${oe(q,U)}[${ie?"reconnect":"initial"}]`}function Ee(q,U){return`${_(U,q.reconnectionToken,!!q.reconnectionProtocol)}[${q.connectTo}]`}function he(q){return`${Date.now()-q} ms`}}),define(ke[258],Se([1,0,3,5]),function(me,e,C,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7k=e.$6k=void 0,e.$6k=(0,F.$Vh)("remoteSocketFactoryService");class f{constructor(){this.a={}}register(M,b){return this.a[M]??=[],this.a[M].push(b),(0,C.$Pc)(()=>{const v=this.a[M]?.indexOf(b);typeof v=="number"&&v>=0&&this.a[M]?.splice(v,1)})}b(M){return(this.a[M.type]||[]).find(v=>v.supports(M))}connect(M,b,v,g){const A=this.b(M);if(!A)throw new Error(`No socket factory found for ${M}`);return A.connect(M,b,v,g)}}e.$7k=f}),define(ke[259],Se([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$V4b=void 0;class C{constructor(){this.b=new Map}static{this.a=1}async createNewMessage(f){try{const L=await this.c();if(L){const M=String(C.a++);return this.b.set(M,L),{id:M,data:L.createNewMessage(f)}}}catch{}return{id:"",data:f}}async validate(f,L){if(!f.id)return!0;const M=this.b.get(f.id);if(!M)return!1;this.b.delete(f.id);try{return M.validate(L)==="ok"}catch{return!1}finally{M.dispose?.()}}async sign(f){try{return await this.d(f)}catch{}return f}}e.$V4b=C}),define(ke[109],Se([1,0,5]),function(me,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9k=e.$8k=void 0,e.$8k="signService",e.$9k=(0,C.$Vh)(e.$8k)}),define(ke[140],Se([1,0,259]),function(me,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$P9b=void 0;class F extends C.$V4b{c(){return this.h().then(L=>new L.validator)}d(L){return this.h().then(M=>new M.signer().sign(L))}h(){return new Promise((L,M)=>me(["vsda"],L,M))}}e.$P9b=F}),define(ke[260],Se([1,0,11,49,32]),function(me,e,C,F,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$oo=e.$no=void 0;function L(v){if(C.$u===2&&/^penguin(\.|$)/i.test(v))return"chromebook"}function M(v,g,A,I,$,y,k,w,u){const o=Object.create(null);o["common.machineId"]=y,o["common.sqmId"]=k,o.sessionID=(0,f.$ig)()+Date.now(),o.commitHash=I,o.version=$,o["common.platformVersion"]=(v||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),o["common.platform"]=(0,C.$h)(C.$u),o["common.nodePlatform"]=F.$cc,o["common.nodeArch"]=A,o["common.product"]=u||"desktop",w&&(o["common.msftInternal"]=w);let i=0;const n=Date.now();Object.defineProperties(o,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-n,enumerable:!0},"common.sequence":{get:()=>i++,enumerable:!0}}),C.$l&&(o["common.snap"]="true");const r=L(g);return r&&(o["common.platformDetail"]=r),o}e.$no=M;function b(v){const g=F.env.USERDNSDOMAIN;if(!g)return!1;const A=g.toLowerCase();return v.some(I=>A===I)}e.$oo=b}),define(ke[261],Se([1,0,5]),function(me,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.$sl=e.$rl=e.$ql=e.$pl=e.$ol=e.$nl=e.$ml=e.$ll=e.$kl=e.$jl=e.$il=void 0,e.$il=(0,C.$Vh)("telemetryService"),e.$jl=(0,C.$Vh)("customEndpointTelemetryService"),e.$kl="telemetry.currentSessionDate",e.$ll="telemetry.firstSessionDate",e.$ml="telemetry.lastSessionDate",e.$nl="telemetry.machineId",e.$ol="telemetry.sqmId",e.$pl="telemetry",e.$ql="telemetry.telemetryLevel",e.$rl="telemetry.enableCrashReporter",e.$sl="telemetry.enableTelemetry";var F;(function(L){L[L.NONE=0]="NONE",L[L.CRASH=1]="CRASH",L[L.ERROR=2]="ERROR",L[L.USAGE=3]="USAGE"})(F||(e.TelemetryLevel=F={}));var f;(function(L){L.OFF="off",L.CRASH="crash",L.ERROR="error",L.ON="all"})(f||(e.TelemetryConfiguration=f={}))}),define(ke[87],Se([1,0,24,18,4,44,65,260,261]),function(me,e,C,F,f,L,M,b,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Eo=e.$Do=e.$Co=e.$Bo=e.$Ao=e.$zo=e.$yo=e.$xo=e.$wo=e.$vo=e.$uo=e.$to=e.$so=e.$ro=e.$qo=e.$po=void 0;class g{constructor(l){this.value=l,this.isTrustedTelemetryValue=!0}}e.$po=g;class A{constructor(){this.telemetryLevel=0,this.sessionId="someValue.sessionId",this.machineId="someValue.machineId",this.firstSessionDate="someValue.firstSessionDate",this.sendErrorTelemetry=!1}publicLog(){}publicLog2(){}publicLogError(){}publicLogError2(){}setExperimentProperty(){}}e.$qo=A,e.$ro=new A;class I{async publicLog(l,h,E){}async publicLogError(l,h,E){}}e.$so=I,e.$to="telemetry",e.$uo="extensionTelemetryLog",e.$vo={log:()=>null,flush:()=>Promise.resolve(null)};function $(c,l){return f.Event.debounce(l.onDidChangeConfiguration,(E,D)=>{const m=E?new Set([...E.affectedKeys,...D.affectedKeys]):D.affectedKeys;return{...D,affectedKeys:m}},1e3,!0)(E=>{E.source!==7&&c.publicLog2("updateConfiguration",{configurationSource:(0,L.$si)(E.source),configurationKeys:Array.from(E.affectedKeys)})})}e.$wo=$;function y(c,l){return!l.isBuilt&&!l.disableTelemetry?!0:!(l.disableTelemetry||!c.enableTelemetry)}e.$xo=y;function k(c,l){return l.extensionTestsLocationURI?!0:!(l.isBuilt||l.disableTelemetry||c.enableTelemetry&&c.aiConfig?.ariaKey)}e.$yo=k;function w(c){const l=c.getValue(v.$ql),h=c.getValue(v.$rl);if(c.getValue(v.$sl)===!1||h===!1)return 0;switch(l??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}e.$zo=w;function u(c){const l={},h={},E={};n(c,E);for(let D in E){D=D.length>150?D.substr(D.length-149):D;const m=E[D];typeof m=="number"?h[D]=m:typeof m=="boolean"?h[D]=m?1:0:typeof m=="string"?(m.length>8192&&console.warn(`Telemetry property: ${D} has been trimmed to 8192, the original length is ${m.length}`),l[D]=m.substring(0,8191)):typeof m<"u"&&m!==null&&(l[D]=m)}return{properties:l,measurements:h}}e.$Ao=u;const o=new Set(["ssh-remote","dev-container","attached-container","wsl","tunnel","codespaces","amlext"]);function i(c){if(!c)return"none";const l=(0,M.$2k)(c);return o.has(l)?l:"other"}e.$Bo=i;function n(c,l,h=0,E){if(c)for(const D of Object.getOwnPropertyNames(c)){const m=c[D],p=E?E+D:D;Array.isArray(m)?l[p]=(0,C.$fn)(m):m instanceof Date?l[p]=m.toISOString():(0,F.$Ef)(m)?h<2?n(m,l,h+1,p+"."):l[p]=(0,C.$fn)(m):l[p]=m}}function r(c,l){const h=c.msftInternalDomains||[],E=l.getValue("telemetry.internalTesting");return(0,b.$oo)(h)||E}e.$Co=r;function a(c){return[c.appRoot,c.extensionsPath,c.userHome.fsPath,c.tmpDir.fsPath,c.userDataPath]}e.$Do=a;function t(c,l){if(!c||!c.includes("/")&&!c.includes("\\"))return c;let h=c;const E=[];for(const S of l)for(;;){const P=S.exec(c);if(!P)break;E.push([P.index,S.lastIndex])}const D=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,m=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let p=0;for(h="";;){const S=m.exec(c);if(!S)break;const P=E.some(([z,j])=>S.index<j&&z<m.lastIndex);!D.test(S[0])&&!P&&(h+=c.substring(p,S.index)+"<REDACTED: user-file-path>",p=m.lastIndex)}return p<c.length&&(h+=c.substr(p)),h}function s(c){if(!c)return c;const l=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/i},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const h of l)if(h.regex.test(c))return`<REDACTED: ${h.label}>`;return c}function d(c,l){return(0,C.$cn)(c,h=>{if(h instanceof g||Object.hasOwnProperty.call(h,"isTrustedTelemetryValue"))return h.value;if(typeof h=="string"){let E=h.replaceAll("%20"," ");E=t(E,l);for(const D of l)E=E.replace(D,"");return E=s(E),E}})}e.$Eo=d}),define(ke[262],Se([1,0,13,135,26,11,2,8,49,87]),function(me,e,C,F,f,L,M,b,v,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qo=e.$Po=e.$Oo=e.$No=e.$Mo=e.$Lo=e.$Ko=e.$Jo=e.$Io=e.$Ho=e.$Go=e.$Fo=void 0;function A(d,c){return d.uuid&&c.uuid?d.uuid===c.uuid:d.id===c.id?!0:(0,C.$1e)(d.id,c.id)===0}e.$Fo=A;const I=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class ${static create(c){const l=c.manifest?c.manifest.version:c.version,h=c.manifest?c.targetPlatform:c.properties.targetPlatform;return new $(c.identifier,l,h)}static parse(c){const l=I.exec(c);return l&&l[1]&&l[2]?new $({id:l[1]},l[2],l[4]||void 0):null}constructor(c,l,h="undefined"){this.version=l,this.targetPlatform=h,this.id=c.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals(c){return c instanceof $?A(this,c)&&this.version===c.version&&this.targetPlatform===c.targetPlatform:!1}}e.$Go=$;const y=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function k(d){const c=y.exec(d);return c&&c[1]?[u(c[1]),c[2]]:[u(d),void 0]}e.$Ho=k;function w(d,c){return`${d}.${c}`}e.$Io=w;function u(d){return d.toLowerCase()}e.$Jo=u;function o(d,c){return u(w(d??f.$8l,c))}e.$Ko=o;function i(d,c){const l=[],h=E=>{for(const D of l)if(D.some(m=>A(c(m),c(E))))return D;return null};for(const E of d){const D=h(E);D?D.push(E):l.push([E])}return l}e.$Lo=i;function n(d){return{id:d.identifier.id,name:d.manifest.name,galleryId:null,publisherId:d.publisherId,publisherName:d.manifest.publisher,publisherDisplayName:d.publisherDisplayName,dependencies:d.manifest.extensionDependencies&&d.manifest.extensionDependencies.length>0}}e.$Mo=n;function r(d){return{id:new g.$po(d.identifier.id),name:new g.$po(d.name),galleryId:d.identifier.uuid,publisherId:d.publisherId,publisherName:d.publisher,publisherDisplayName:d.publisherDisplayName,isPreReleaseVersion:d.properties.isPreReleaseVersion,dependencies:!!(d.properties.dependencies&&d.properties.dependencies.length>0),isSigned:d.isSigned,...d.telemetryData}}e.$No=r,e.$Oo=new f.$_l("pprice.better-merge");function a(d,c){const l=[],h=c.manifest.extensionDependencies?.slice(0)??[];for(;h.length;){const E=h.shift();if(E&&l.every(D=>!A(D.identifier,{id:E}))){const D=d.filter(m=>A(m.identifier,{id:E}));D.length===1&&(l.push(D[0]),h.push(...D[0].manifest.extensionDependencies?.slice(0)??[]))}}return l}e.$Po=a;async function t(d,c){if(!L.$k)return!1;let l;try{l=(await d.readFile(M.URI.file("/etc/os-release"))).value.toString()}catch{try{l=(await d.readFile(M.URI.file("/usr/lib/os-release"))).value.toString()}catch(E){c.debug("Error while getting the os-release file.",(0,b.$9)(E))}}return!!l&&(l.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}async function s(d,c){const l=await t(d,c),h=(0,F.$_n)(l?"alpine":L.$u,v.$dc);return c.debug("ComputeTargetPlatform:",h),h}e.$Qo=s}),define(ke[263],Se([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vr=e.$ur=e.$tr=e.$sr=e.$rr=e.$qr=void 0;function C(v){return[...v.entries()]}e.$qr=C;function F(v){return v?[...v.entries()]:[]}e.$rr=F;function f(v){return new Map(v)}e.$sr=f;function L(v){return new Map(v??[])}e.$tr=L;function M(v){return Array.from(v.entries()).map(g=>[g[0],C(g[1].map),F(g[1].descriptionMap)])}e.$ur=M;function b(v){return new Map(v.map(g=>[g[0],{map:f(g[1]),descriptionMap:L(g[2])}]))}e.$vr=b}),define(ke[264],Se([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nqb=void 0;class C{constructor(f){this.b=f,this.a=new Map}dispose(){for(const f of this.a.values())f.dispose()}startBuffering(f,L,M=5){const b=L(v=>{const g=typeof v=="string"?v:v.data;let A=this.a.get(f);if(A){A.data.push(g);return}const I=setTimeout(()=>this.flushBuffer(f),M);A={data:[g],timeoutId:I,dispose:()=>{clearTimeout(I),this.flushBuffer(f),b.dispose()}},this.a.set(f,A)});return b}stopBuffering(f){this.a.get(f)?.dispose()}flushBuffer(f){const L=this.a.get(f);L&&(this.a.delete(f),this.b(f,L.data.join("")))}}e.$nqb=C}),define(ke[265],Se([1,0,12,78,61,4,18,2,207,108,37]),function(me,e,C,F,f,L,M,b,v,g,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gw=e.$fw=e.$ew=e.$dw=e.$cw=e.$bw=e.$aw=e.$_v=e.IconFontDefinition=e.IconContribution=e.$$v=void 0,e.$$v={IconContribution:"base.contributions.icons"};var I;(function(r){function a(t,s){let d=t.defaults;for(;f.ThemeIcon.isThemeIcon(d);){const c=k.getIcon(d.id);if(!c)return;d=c.defaults}return d}r.getDefinition=a})(I||(e.IconContribution=I={}));var $;(function(r){function a(s){return{weight:s.weight,style:s.style,src:s.src.map(d=>({format:d.format,location:d.location.toString()}))}}r.toJSONObject=a;function t(s){const d=c=>(0,M.$Cf)(c)?c:void 0;if(s&&Array.isArray(s.src)&&s.src.every(c=>(0,M.$Cf)(c.format)&&(0,M.$Cf)(c.location)))return{weight:d(s.weight),style:d(s.style),src:s.src.map(c=>({format:c.format,location:b.URI.parse(c.location)}))}}r.fromJSONObject=t})($||(e.IconFontDefinition=$={}));class y{constructor(){this.a=new L.$Rd,this.onDidChange=this.a.event,this.d={definitions:{icons:{type:"object",properties:{fontId:{type:"string",description:(0,v.localize)(0,null)},fontCharacter:{type:"string",description:(0,v.localize)(1,null)}},additionalProperties:!1,defaultSnippets:[{body:{fontCharacter:"\\\\e030"}}]}},type:"object",properties:{}},this.e={type:"string",pattern:`^${f.ThemeIcon.iconNameExpression}$`,enum:[],enumDescriptions:[]},this.b={},this.f={}}registerIcon(a,t,s,d){const c=this.b[a];if(c){if(s&&!c.description){c.description=s,this.d.properties[a].markdownDescription=`${s} $(${a})`;const E=this.e.enum.indexOf(a);E!==-1&&(this.e.enumDescriptions[E]=s),this.a.fire()}return c}const l={id:a,description:s,defaults:t,deprecationMessage:d};this.b[a]=l;const h={$ref:"#/definitions/icons"};return d&&(h.deprecationMessage=d),s&&(h.markdownDescription=`${s}: $(${a})`),this.d.properties[a]=h,this.e.enum.push(a),this.e.enumDescriptions.push(s||""),this.a.fire(),{id:a}}deregisterIcon(a){delete this.b[a],delete this.d.properties[a];const t=this.e.enum.indexOf(a);t!==-1&&(this.e.enum.splice(t,1),this.e.enumDescriptions.splice(t,1)),this.a.fire()}getIcons(){return Object.keys(this.b).map(a=>this.b[a])}getIcon(a){return this.b[a]}getIconSchema(){return this.d}getIconReferenceSchema(){return this.e}registerIconFont(a,t){const s=this.f[a];return s||(this.f[a]=t,this.a.fire(),t)}deregisterIconFont(a){delete this.f[a]}getIconFont(a){return this.f[a]}toString(){const a=(c,l)=>c.id.localeCompare(l.id),t=c=>{for(;f.ThemeIcon.isThemeIcon(c.defaults);)c=this.b[c.defaults.id];return`codicon codicon-${c?c.id:""}`},s=[];s.push("| preview     | identifier                        | default codicon ID                | description"),s.push("| ----------- | --------------------------------- | --------------------------------- | --------------------------------- |");const d=Object.keys(this.b).map(c=>this.b[c]);for(const c of d.filter(l=>!!l.description).sort(a))s.push(`|<i class="${t(c)}"></i>|${c.id}|${f.ThemeIcon.isThemeIcon(c.defaults)?c.defaults.id:c.id}|${c.description||""}|`);s.push("| preview     | identifier                        "),s.push("| ----------- | --------------------------------- |");for(const c of d.filter(l=>!f.ThemeIcon.isThemeIcon(l.defaults)).sort(a))s.push(`|<i class="${t(c)}"></i>|${c.id}|`);return s.join(`
`)}}const k=new y;A.$mn.add(e.$$v.IconContribution,k);function w(r,a,t,s){return k.registerIcon(r,a,t,s)}e.$_v=w;function u(){return k}e.$aw=u;function o(){const r=(0,F.$Yj)();for(const a in r){const t="\\"+r[a].toString(16);k.registerIcon(a,{fontCharacter:t})}}o(),e.$bw="vscode://schemas/icons";const i=A.$mn.as(g.$nn.JSONContribution);i.registerSchema(e.$bw,k.getIconSchema());const n=new C.$0g(()=>i.notifySchemaChanged(e.$bw),200);k.onDidChange(()=>{n.isScheduled()||n.schedule()}),e.$cw=w("widget-close",F.$1j.close,(0,v.localize)(2,null)),e.$dw=w("goto-previous-location",F.$1j.arrowUp,(0,v.localize)(3,null)),e.$ew=w("goto-next-location",F.$1j.arrowDown,(0,v.localize)(4,null)),e.$fw=f.ThemeIcon.modify(F.$1j.sync,"spin"),e.$gw=f.ThemeIcon.modify(F.$1j.loading,"spin")}),define(ke[88],Se([1,0,4,44,5,14]),function(me,e,C,F,f,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nv=e.$mv=e.$lv=e.$kv=e.$jv=e.$iv=e.$hv=e.$gv=e.ProvidedOnAutoForward=e.$fv=e.TunnelPrivacyId=e.TunnelProtocol=e.$ev=e.$dv=void 0,e.$dv=(0,f.$Vh)("tunnelService"),e.$ev=(0,f.$Vh)("sharedTunnelsService");var M;(function(u){u.Http="http",u.Https="https"})(M||(e.TunnelProtocol=M={}));var b;(function(u){u.ConstantPrivate="constantPrivate",u.Private="private",u.Public="public"})(b||(e.TunnelPrivacyId=b={}));function v(u){return!!u.forwardPort}e.$fv=v;var g;(function(u){u[u.Notify=1]="Notify",u[u.OpenBrowser=2]="OpenBrowser",u[u.OpenPreview=3]="OpenPreview",u[u.Silent=4]="Silent",u[u.Ignore=5]="Ignore",u[u.OpenBrowserOnce=6]="OpenBrowserOnce"})(g||(e.ProvidedOnAutoForward=g={}));function A(u){if(u.scheme!=="http"&&u.scheme!=="https")return;const o=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(u.authority);if(o)return{address:o[1],port:+o[2]}}e.$gv=A,e.$hv=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function I(u){return e.$hv.indexOf(u)>=0}e.$iv=I,e.$jv=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function $(u){return e.$jv.indexOf(u)>=0}e.$kv=$;function y(u,o,i,n){if(i===1)return!1;if(i===2&&$(o)){const r=/(\d+)\.(\d+)\.(\d+)/g.exec(n);if(r?.length===4&&parseInt(r[1])>=18)return!1}return u<1024}e.$lv=y;class k{constructor(o,i,n){this.remoteAddress=o,this.localAddress=i,this.b=n,this.a=new C.$Rd,this.onDidDispose=this.a.event}dispose(){return this.a.fire(),this.b()}}e.$mv=k;let w=class{constructor(o,i){this.j=o,this.k=i,this.a=new C.$Rd,this.onTunnelOpened=this.a.event,this.b=new C.$Rd,this.onTunnelClosed=this.b.event,this.c=new C.$Rd,this.onAddedTunnelProvider=this.c.event,this.e=new Map,this.g=!1,this.h=[],this.i=new Set}get hasTunnelProvider(){return!!this.f}get l(){const o=this.k.getValue("remote.localPortHost");return!o||o==="localhost"?"127.0.0.1":"0.0.0.0"}setTunnelProvider(o){return this.f=o,o?(this.c.fire(),{dispose:()=>{this.f=void 0,this.g=!1,this.h=[]}}):(this.g=!1,this.h=[],this.c.fire(),{dispose:()=>{}})}setTunnelFeatures(o){this.g=o.elevation,this.h=o.privacyOptions}get canElevate(){return this.g}get canChangePrivacy(){return this.h.length>0}get privacyOptions(){return this.h}get tunnels(){return this.m()}async m(){const o=[],i=Array.from(this.e.values());for(const n of i){const r=Array.from(n.values());for(const a of r){const t=await a.value;t&&typeof t!="string"&&o.push(t)}}return o}async dispose(){for(const o of this.e.values()){for(const{value:i}of o.values())await i.then(n=>typeof n!="string"?n?.dispose():void 0);o.clear()}this.e.clear()}setEnvironmentTunnel(o,i,n,r,a){this.p(o,i,Promise.resolve({tunnelRemoteHost:o,tunnelRemotePort:i,localAddress:n,privacy:r,protocol:a,dispose:()=>Promise.resolve()}))}async getExistingTunnel(o,i){($(o)||I(o))&&(o=e.$hv[0]);const n=this.r(o,i);if(n)return++n.refcount,n.value}openTunnel(o,i,n,r,a,t=!1,s,d){this.j.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${i}:${n} on local port ${a}.`);const c=this.f??o;if(!c)return;if(i||(i="localhost"),r||(r=this.l),this.f&&this.i.has(n)){this.j.debug("ForwardedPorts: (TunnelService) Another call to create a tunnel with the same address has occurred before the last one completed. This call will be ignored.");return}const l=this.s(c,i,n,r,a,t,s,d);return l?l.then(h=>{if(h){if(typeof h=="string")return this.j.trace("ForwardedPorts: (TunnelService) The tunnel provider returned an error when creating the tunnel."),this.q(i,n),h}else{this.j.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.q(i,n);return}this.j.trace("ForwardedPorts: (TunnelService) New tunnel established.");const E=this.n(h);return(h.tunnelRemoteHost!==i||h.tunnelRemotePort!==n)&&this.j.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),s&&h.privacy!==s&&this.j.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Privacy mismatch."),this.a.fire(E),E}):(this.j.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),l)}n(o){return{tunnelRemotePort:o.tunnelRemotePort,tunnelRemoteHost:o.tunnelRemoteHost,tunnelLocalPort:o.tunnelLocalPort,localAddress:o.localAddress,privacy:o.privacy,protocol:o.protocol,dispose:async()=>{this.j.trace(`ForwardedPorts: (TunnelService) dispose request for ${o.tunnelRemoteHost}:${o.tunnelRemotePort} `);const i=this.e.get(o.tunnelRemoteHost);if(i){const n=i.get(o.tunnelRemotePort);n&&(n.refcount--,await this.o(o.tunnelRemoteHost,o.tunnelRemotePort,n))}}}}async o(o,i,n){if(n.refcount<=0){this.j.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${o}:${i}.`);const r=n.value.then(async a=>{a&&typeof a!="string"&&(await a.dispose(!0),this.b.fire({host:a.tunnelRemoteHost,port:a.tunnelRemotePort}))});return this.e.has(o)&&this.e.get(o).delete(i),r}}async closeTunnel(o,i){this.j.trace(`ForwardedPorts: (TunnelService) close request for ${o}:${i} `);const n=this.e.get(o);if(n&&n.has(i)){const r=n.get(i);r.refcount=0,await this.o(o,i,r)}}p(o,i,n){this.e.has(o)||this.e.set(o,new Map),this.e.get(o).set(i,{refcount:1,value:n})}async q(o,i){const n=this.e.get(o);if(n){const r=n.get(i),a=r?await r.value:void 0;(!a||typeof a=="string")&&n.delete(i),n.size===0&&this.e.delete(o)}}r(o,i){const n=[o];I(o)?(n.push(...e.$hv),n.push(...e.$jv)):$(o)&&n.push(...e.$jv);const r=n.map(a=>this.e.get(a));for(const a of r){const t=a?.get(i);if(t)return t}}canTunnel(o){return!!A(o)}t(o,i,n,r,a,t,s){this.j.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${i}:${n} on local port ${r}.`);const d=n;this.i.add(d);const c=r===void 0?n:r,l={elevationRequired:a?this.isPortPrivileged(c):!1},h={remoteAddress:{host:i,port:n},localAddressPort:r,privacy:t,public:t?t!==b.Private:void 0,protocol:s},E=o.forwardPort(h,l);return E?(this.p(i,n,E),E.finally(()=>{this.j.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),this.i.delete(d)})):this.i.delete(d),E}};e.$nv=w,e.$nv=w=He([Be(0,L.$dj),Be(1,F.$pi)],w)}),define(ke[266],Se([1,0,5]),function(me,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ok=void 0,e.$Ok=(0,C.$Vh)("IUriIdentityService")}),define(ke[267],Se([1,0,5]),function(me,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditSessionIdentityMatch=e.$ov=void 0,e.$ov=(0,C.$Vh)("editSessionIdentityService");var F;(function(f){f[f.Complete=100]="Complete",f[f.Partial=50]="Partial",f[f.None=0]="None"})(F||(e.EditSessionIdentityMatch=F={}))}),define(ke[268],Se([1,0,17]),function(me,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$J=e.$0J=e.$9J=e.$8J=e.$7J=void 0;function F(v){return v.scheme!==C.Schemas.file&&v.scheme!==C.Schemas.vscodeRemote}e.$7J=F;function f(v){if(v.folders.length)return v.folders.every(g=>F(g.uri))?v.folders[0].uri:void 0;if(v.configuration&&F(v.configuration))return v.configuration}e.$8J=f;function L(v){return f(v)?.scheme}e.$9J=L;function M(v){return f(v)?.authority}e.$0J=M;function b(v){return f(v)!==void 0}e.$$J=b}),define(ke[40],Se([1,0,209,16,77,23,2,5,17]),function(me,e,C,F,f,L,M,b,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$oi=e.$ni=e.$mi=e.$li=e.$ki=e.$ji=e.$ii=e.$hi=e.$gi=e.$fi=e.$ei=e.$di=e.$ci=e.$bi=e.$ai=e.WorkbenchState=e.$_h=e.$$h=e.$0h=e.$9h=e.$8h=e.$7h=e.$6h=e.$5h=void 0,e.$5h=(0,b.$Vh)("contextService");function g(c){const l=c;return typeof l?.id=="string"&&M.URI.isUri(l.uri)}e.$6h=g;function A(c){return typeof c?.id=="string"&&!g(c)&&!$(c)}e.$7h=A,e.$8h={id:"ext-dev"},e.$9h={id:"empty-window"};function I(c,l){if(typeof c=="string"||typeof c>"u")return typeof c=="string"?{id:(0,F.$mc)(c)}:l?e.$8h:e.$9h;const h=c;return h.configuration?{id:h.id,configPath:h.configuration}:h.folders.length===1?{id:h.id,uri:h.folders[0].uri}:{id:h.id}}e.$0h=I;function $(c){const l=c;return typeof l?.id=="string"&&M.URI.isUri(l.configPath)}e.$$h=$;function y(c){const l=c;if(l?.uri)return{id:l.id,uri:M.URI.revive(l.uri)};const h=c;if(h?.configPath)return{id:h.id,configPath:M.URI.revive(h.configPath)};if(c?.id)return{id:c.id}}e.$_h=y;var k;(function(c){c[c.EMPTY=1]="EMPTY",c[c.FOLDER=2]="FOLDER",c[c.WORKSPACE=3]="WORKSPACE"})(k||(e.WorkbenchState=k={}));function w(c){const l=c;return!!(l&&typeof l=="object"&&typeof l.id=="string"&&Array.isArray(l.folders))}e.$ai=w;function u(c){const l=c;return!!(l&&typeof l=="object"&&M.URI.isUri(l.uri)&&typeof l.name=="string"&&typeof l.toResource=="function")}e.$bi=u;class o{constructor(l,h,E,D,m){this.h=l,this.j=E,this.k=D,this.l=m,this.c=f.$2h.forUris(this.l,()=>!0),this.folders=h}update(l){this.h=l.id,this.k=l.configuration,this.j=l.transient,this.l=l.l,this.folders=l.folders}get folders(){return this.g}set folders(l){this.g=l,this.n()}get id(){return this.h}get transient(){return this.j}get configuration(){return this.k}set configuration(l){this.k=l}getFolder(l){return l&&this.c.findSubstr(l)||null}n(){this.c=f.$2h.forUris(this.l,()=>!0);for(const l of this.folders)this.c.set(l.uri,l)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.$ci=o;class i{constructor(l,h){this.raw=h,this.uri=l.uri,this.index=l.index,this.name=l.name}toResource(l){return(0,L.$zg)(this.uri,l)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.$di=i;function n(c){return new i({uri:c,index:0,name:(0,L.$vg)(c)},{uri:c.toString()})}e.$ei=n,e.$fi="code-workspace",e.$gi=`.${e.$fi}`,e.$hi=[{name:(0,C.localize)(0,null),extensions:[e.$fi]}],e.$ii="workspace.json";function r(c,l){return L.$qg.isEqualOrParent(c,l.untitledWorkspacesHome)}e.$ji=r;function a(c){let l;return M.URI.isUri(c)?l=c:l=c.configuration,l?.scheme===v.Schemas.tmp}e.$ki=a,e.$li="4064f6ec-cb38-4ad0-af64-ee6467e63c82";function t(c){return c.id===e.$li}e.$mi=t;function s(c,l){return!r(c,l)&&!a(c)}e.$ni=s;function d(c){return(typeof c=="string"?(0,F.$nc)(c):(0,L.$xg)(c))===e.$gi}e.$oi=d}),define(ke[269],Se([1,0,52,4,3,23,2,208,134,31,5,14,40,28,266,12,32,13,18]),function(me,e,C,F,f,L,M,b,v,g,A,I,$,y,k,w,u,o,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Uk=e.$Tk=e.$Sk=e.$Rk=e.$Qk=e.$Pk=e.ProfileResourceType=void 0;var n;(function(c){c.Settings="settings",c.Keybindings="keybindings",c.Snippets="snippets",c.Tasks="tasks",c.Extensions="extensions",c.GlobalState="globalState"})(n||(e.ProfileResourceType=n={}));function r(c){const l=c;return!!(l&&typeof l=="object"&&typeof l.id=="string"&&typeof l.isDefault=="boolean"&&typeof l.name=="string"&&M.URI.isUri(l.location)&&M.URI.isUri(l.globalStorageHome)&&M.URI.isUri(l.settingsResource)&&M.URI.isUri(l.keybindingsResource)&&M.URI.isUri(l.tasksResource)&&M.URI.isUri(l.snippetsHome)&&M.URI.isUri(l.extensionsResource))}e.$Pk=r,e.$Qk=(0,A.$Vh)("IUserDataProfilesService");function a(c,l){return{id:c.id,isDefault:c.isDefault,name:c.name,shortName:c.shortName,icon:c.icon,location:M.URI.revive(c.location).with({scheme:l}),globalStorageHome:M.URI.revive(c.globalStorageHome).with({scheme:l}),settingsResource:M.URI.revive(c.settingsResource).with({scheme:l}),keybindingsResource:M.URI.revive(c.keybindingsResource).with({scheme:l}),tasksResource:M.URI.revive(c.tasksResource).with({scheme:l}),snippetsHome:M.URI.revive(c.snippetsHome).with({scheme:l}),extensionsResource:M.URI.revive(c.extensionsResource).with({scheme:l}),cacheHome:M.URI.revive(c.cacheHome).with({scheme:l}),useDefaultFlags:c.useDefaultFlags,isTransient:c.isTransient}}e.$Rk=a;function t(c,l,h,E,D,m){return{id:c,name:l,location:h,isDefault:!1,shortName:D?.shortName,icon:D?.icon,globalStorageHome:m&&D?.useDefaultFlags?.globalState?m.globalStorageHome:(0,L.$zg)(h,"globalStorage"),settingsResource:m&&D?.useDefaultFlags?.settings?m.settingsResource:(0,L.$zg)(h,"settings.json"),keybindingsResource:m&&D?.useDefaultFlags?.keybindings?m.keybindingsResource:(0,L.$zg)(h,"keybindings.json"),tasksResource:m&&D?.useDefaultFlags?.tasks?m.tasksResource:(0,L.$zg)(h,"tasks.json"),snippetsHome:m&&D?.useDefaultFlags?.snippets?m.snippetsHome:(0,L.$zg)(h,"snippets"),extensionsResource:m&&D?.useDefaultFlags?.extensions?m.extensionsResource:(0,L.$zg)(h,"extensions.json"),cacheHome:(0,L.$zg)(E,c),useDefaultFlags:D?.useDefaultFlags,isTransient:D?.transient}}e.$Sk=t;let s=class extends f.$Rc{static{this.b="userDataProfiles"}static{this.c="profileAssociations"}get defaultProfile(){return this.profiles[0]}get profiles(){return[...this.C.profiles,...this.s.profiles]}constructor(l,h,E,D){super(),this.t=l,this.u=h,this.w=E,this.y=D,this.f=!0,this.h=this.B(new F.$Rd),this.onDidChangeProfiles=this.h.event,this.j=this.B(new F.$Rd),this.onWillCreateProfile=this.j.event,this.m=this.B(new F.$Rd),this.onWillRemoveProfile=this.m.event,this.n=this.B(new F.$Rd),this.onDidResetWorkspaces=this.n.event,this.r=new Map,this.s={profiles:[],workspaces:new y.$zc,emptyWindows:new Map},this.profilesHome=(0,L.$zg)(this.t.userRoamingDataHome,"profiles"),this.g=(0,L.$zg)(this.t.cacheHome,"CachedProfilesData")}init(){this.z=void 0}setEnablement(l){this.f!==l&&(this.z=void 0,this.f=l)}isEnabled(){return this.f}get C(){if(!this.z){const l=this.D(),h=[l];if(this.f)try{for(const m of this.O()){if(!m.name||!(0,i.$Cf)(m.name)||!m.location){this.y.warn("Skipping the invalid stored profile",m.location||m.name);continue}h.push(t((0,L.$wg)(m.location),m.name,m.location,this.g,{shortName:m.shortName,icon:m.icon,useDefaultFlags:m.useDefaultFlags},l))}}catch(m){this.y.error(m)}const E=new y.$zc,D=new Map;if(h.length)try{const m=this.Q();if(m.workspaces)for(const[p,S]of Object.entries(m.workspaces)){const P=M.URI.parse(p),z=h.find(j=>j.id===S);z&&E.set(P,z)}if(m.emptyWindows)for(const[p,S]of Object.entries(m.emptyWindows)){const P=h.find(z=>z.id===S);P&&D.set(p,P)}}catch(m){this.y.error(m)}this.z={profiles:h,workspaces:E,emptyWindows:D}}return this.z}D(){const l=t("__default__profile__",(0,b.localize)(0,null),this.t.userRoamingDataHome,this.g);return{...l,extensionsResource:this.S()??l.extensionsResource,isDefault:!0}}async createTransientProfile(l){const h="Temp",E=new RegExp(`${(0,o.$Je)(h)}\\s(\\d+)`);let D=0;for(const p of this.profiles){const S=E.exec(p.name),P=S?parseInt(S[1]):0;D=P>D?P:D}const m=`${h} ${D+1}`;return this.createProfile((0,C.$Ji)((0,u.$ig)()).toString(16),m,{transient:!0},l)}async createNamedProfile(l,h,E){return this.createProfile((0,C.$Ji)((0,u.$ig)()).toString(16),l,h,E)}async createProfile(l,h,E,D){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const m=await this.F(l,h,E);return D&&await this.setProfileForWorkspace(D,m),m}async F(l,h,E){if(!(0,i.$Cf)(h)||!h)throw new Error("Name of the profile is mandatory and must be of type `string`");let D=this.r.get(h);return D||(D=(async()=>{try{const m=this.profiles.find(P=>P.name===h||P.id===l);if(m)return m;const p=t(l,h,(0,L.$zg)(this.profilesHome,l),this.g,E,this.defaultProfile);await this.u.createFolder(p.location);const S=[];return this.j.fire({profile:p,join(P){S.push(P)}}),await w.Promises.settled(S),this.I([p],[],[]),p}finally{this.r.delete(h)}})(),this.r.set(h,D)),D}async updateProfile(l,h){if(!this.f)throw new Error("Profiles are disabled in the current environment.");let E=this.profiles.find(D=>D.id===l.id);if(!E)throw new Error(`Profile '${l.name}' does not exist`);return E=t(E.id,h.name??E.name,E.location,this.g,{shortName:h.shortName??E.shortName,icon:h.icon===null?void 0:h.icon??E.icon,transient:h.transient??E.isTransient,useDefaultFlags:h.useDefaultFlags??E.useDefaultFlags},this.defaultProfile),this.I([],[],[E]),E}async removeProfile(l){if(!this.f)throw new Error("Profiles are disabled in the current environment.");if(l.isDefault)throw new Error("Cannot remove default profile");const h=this.profiles.find(D=>D.id===l.id);if(!h)throw new Error(`Profile '${l.name}' does not exist`);const E=[];this.m.fire({profile:h,join(D){E.push(D)}});try{await Promise.allSettled(E)}catch(D){this.y.error(D)}for(const D of[...this.C.emptyWindows.keys()])h.id===this.C.emptyWindows.get(D)?.id&&this.C.emptyWindows.delete(D);for(const D of[...this.C.workspaces.keys()])h.id===this.C.workspaces.get(D)?.id&&this.C.workspaces.delete(D);this.M(),this.I([],[h],[]);try{await this.u.del(h.cacheHome,{recursive:!0})}catch(D){(0,g.$vk)(D)!==1&&this.y.error(D)}}async setProfileForWorkspace(l,h){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const E=this.profiles.find(D=>D.id===h.id);if(!E)throw new Error(`Profile '${h.name}' does not exist`);this.L(l,E)}unsetWorkspace(l,h){if(!this.f)throw new Error("Profiles are disabled in the current environment.");this.L(l,void 0,h)}async resetWorkspaces(){this.s.workspaces.clear(),this.s.emptyWindows.clear(),this.C.workspaces.clear(),this.C.emptyWindows.clear(),this.M(),this.n.fire()}async cleanUp(){if(this.f&&await this.u.exists(this.profilesHome)){const l=await this.u.resolve(this.profilesHome);await Promise.all((l.children||[]).filter(h=>h.isDirectory&&this.profiles.every(E=>!this.w.extUri.isEqual(E.location,h.resource))).map(h=>this.u.del(h.resource,{recursive:!0})))}}async cleanUpTransientProfiles(){if(!this.f)return;const l=this.s.profiles.filter(h=>!this.H(h));await Promise.allSettled(l.map(h=>this.removeProfile(h)))}getProfileForWorkspace(l){const h=this.G(l);return M.URI.isUri(h)?this.s.workspaces.get(h)??this.C.workspaces.get(h):this.s.emptyWindows.get(h)??this.C.emptyWindows.get(h)}G(l){return(0,$.$6h)(l)?l.uri:(0,$.$$h)(l)?l.configPath:l.id}H(l){return!!([...this.s.emptyWindows.values()].some(h=>this.w.extUri.isEqual(h.location,l.location))||[...this.s.workspaces.values()].some(h=>this.w.extUri.isEqual(h.location,l.location))||[...this.C.emptyWindows.values()].some(h=>this.w.extUri.isEqual(h.location,l.location))||[...this.C.workspaces.values()].some(h=>this.w.extUri.isEqual(h.location,l.location)))}I(l,h,E){const D=[...this.profiles,...l],m=[];this.s.profiles=[];for(let p of D)p.isDefault||h.some(S=>p.id===S.id)||(p=E.find(S=>p.id===S.id)??p,p.isTransient?this.s.profiles.push(p):m.push({location:p.location,name:p.name,shortName:p.shortName,icon:p.icon,useDefaultFlags:p.useDefaultFlags}));this.P(m),this.z=void 0,this.J(l,h,E)}J(l,h,E){this.h.fire({added:l,removed:h,updated:E,all:this.profiles})}L(l,h,E){E=h?.isTransient?!0:E,E||this.L(l,void 0,!0);const D=this.G(l),m=E?this.s:this.C;M.URI.isUri(D)?(m.workspaces.delete(D),h&&m.workspaces.set(D,h)):(m.emptyWindows.delete(D),h&&m.emptyWindows.set(D,h)),E||this.M()}M(){const l={};for(const[E,D]of this.C.workspaces.entries())l[E.toString()]=D.id;const h={};for(const[E,D]of this.C.emptyWindows.entries())h[E.toString()]=D.id;this.R({workspaces:l,emptyWindows:h}),this.z=void 0}N(l){const h={},E=this.D();if(l.workspaces)for(const[m,p]of Object.entries(l.workspaces)){const S=M.URI.parse(p);h[m]=this.w.extUri.isEqual(S,E.location)?E.id:this.w.extUri.basename(S)}const D={};if(l.emptyWindows)for(const[m,p]of Object.entries(l.emptyWindows)){const S=M.URI.parse(p);D[m]=this.w.extUri.isEqual(S,E.location)?E.id:this.w.extUri.basename(S)}return{workspaces:h,emptyWindows:D}}O(){return[]}P(l){throw new Error("not implemented")}Q(){return{}}R(l){throw new Error("not implemented")}S(){}};e.$Tk=s,e.$Tk=s=He([Be(0,v.$3h),Be(1,g.$ek),Be(2,k.$Ok),Be(3,I.$dj)],s);class d extends s{constructor(){super(...arguments),this.a=[],this.X={}}O(){return this.a}P(l){this.a=l}Q(){return this.X}R(l){this.X=l}}e.$Uk=d}),define(ke[270],Se([1,0,12,4,3,56,18,188,5,269]),function(me,e,C,F,f,L,M,b,v,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ep=e.$dp=e.$cp=e.$bp=e.$ap=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.$_o=e.$$o=e.$0o=void 0,e.$0o="__$__isNewStorageMarker",e.$$o="__$__targetStorageMarker",e.$_o=(0,v.$Vh)("storageService");var A;(function(i){i[i.NONE=0]="NONE",i[i.SHUTDOWN=1]="SHUTDOWN"})(A||(e.WillSaveStateReason=A={}));var I;(function(i){i[i.APPLICATION=-1]="APPLICATION",i[i.PROFILE=0]="PROFILE",i[i.WORKSPACE=1]="WORKSPACE"})(I||(e.StorageScope=I={}));var $;(function(i){i[i.USER=0]="USER",i[i.MACHINE=1]="MACHINE"})($||(e.StorageTarget=$={}));function y(i){const n=i.get(e.$$o);if(n)try{return JSON.parse(n)}catch{}return Object.create(null)}e.$ap=y;class k extends f.$Rc{static{this.a=60*1e3}constructor(n={flushInterval:k.a}){super(),this.m=n,this.b=this.B(new F.$Ud),this.c=this.B(new F.$Ud),this.onDidChangeTarget=this.c.event,this.f=this.B(new F.$Rd),this.onWillSaveState=this.f.event,this.h=this.B(new C.$0g(()=>this.n(),this.m.flushInterval)),this.j=this.B(new f.$Sc),this.C=void 0,this.F=void 0,this.H=void 0}onDidChangeValue(n,r,a){return F.Event.filter(this.b.event,t=>t.scope===n&&(r===void 0||t.key===r),a)}n(){this.j.value=(0,C.$bh)(()=>{this.r()&&this.flush(),this.h.schedule()})}r(){return!0}t(){(0,f.$Mc)([this.j,this.h])}initialize(){return this.g||(this.g=(async()=>{(0,L.mark)("code/willInitStorage");try{await this.O()}finally{(0,L.mark)("code/didInitStorage")}this.h.schedule()})()),this.g}u(n,r){const{key:a,external:t}=r;if(a===e.$$o){switch(n){case-1:this.H=void 0;break;case 0:this.F=void 0;break;case 1:this.C=void 0;break}this.c.fire({scope:n})}else this.b.fire({scope:n,key:a,target:this.J(n)[a],external:t})}w(n){this.f.fire({reason:n})}get(n,r,a){return this.P(r)?.get(n,a)}getBoolean(n,r,a){return this.P(r)?.getBoolean(n,a)}getNumber(n,r,a){return this.P(r)?.getNumber(n,a)}getObject(n,r,a){return this.P(r)?.getObject(n,a)}storeAll(n,r){this.y(()=>{for(const a of n)this.store(a.key,a.value,a.scope,a.target,r)})}store(n,r,a,t,s=!1){if((0,M.$Lf)(r)){this.remove(n,a,s);return}this.y(()=>{this.z(n,a,t),this.P(a)?.set(n,r,s)})}remove(n,r,a=!1){this.y(()=>{this.z(n,r,void 0),this.P(r)?.delete(n,a)})}y(n){this.b.pause(),this.c.pause();try{n()}finally{this.b.resume(),this.c.resume()}}keys(n,r){const a=[],t=this.J(n);for(const s of Object.keys(t))t[s]===r&&a.push(s);return a}z(n,r,a,t=!1){const s=this.J(r);typeof a=="number"?s[n]!==a&&(s[n]=a,this.P(r)?.set(e.$$o,JSON.stringify(s),t)):typeof s[n]=="number"&&(delete s[n],this.P(r)?.set(e.$$o,JSON.stringify(s),t))}get D(){return this.C||(this.C=this.L(1)),this.C}get G(){return this.F||(this.F=this.L(0)),this.F}get I(){return this.H||(this.H=this.L(-1)),this.H}J(n){switch(n){case-1:return this.I;case 0:return this.G;default:return this.D}}L(n){const r=this.P(n);return r?y(r):Object.create(null)}isNew(n){return this.getBoolean(e.$0o,n)===!0}async flush(n=A.NONE){this.f.fire({reason:n});const r=this.P(-1),a=this.P(0),t=this.P(1);switch(n){case A.NONE:await C.Promises.settled([r?.whenFlushed()??Promise.resolve(),a?.whenFlushed()??Promise.resolve(),t?.whenFlushed()??Promise.resolve()]);break;case A.SHUTDOWN:await C.Promises.settled([r?.flush(0)??Promise.resolve(),a?.flush(0)??Promise.resolve(),t?.flush(0)??Promise.resolve()]);break}}async log(){const n=this.P(-1)?.items??new Map,r=this.P(0)?.items??new Map,a=this.P(1)?.items??new Map;return o(n,r,a,this.Q(-1)??"",this.Q(0)??"",this.Q(1)??"")}async optimize(n){return await this.flush(),this.P(n)?.optimize()}async switch(n,r){return this.w(A.NONE),(0,g.$Pk)(n)?this.R(n,r):this.S(n,r)}M(n,r){return!(n.id===r.id||w(r)&&w(n))}N(n,r,a){this.y(()=>{const t=new Set;for(const[s,d]of n)t.add(s),r.get(s)!==d&&this.u(a,{key:s,external:!0});for(const[s]of r.items)t.has(s)||this.u(a,{key:s,external:!0})})}}e.$bp=k;function w(i){return i.isDefault||!!i.useDefaultFlags?.globalState}e.$cp=w;class u extends k{constructor(){super(),this.U=this.B(new b.$8o(new b.$9o,{hint:b.StorageHint.STORAGE_IN_MEMORY})),this.W=this.B(new b.$8o(new b.$9o,{hint:b.StorageHint.STORAGE_IN_MEMORY})),this.X=this.B(new b.$8o(new b.$9o,{hint:b.StorageHint.STORAGE_IN_MEMORY})),this.B(this.X.onDidChangeStorage(n=>this.u(1,n))),this.B(this.W.onDidChangeStorage(n=>this.u(0,n))),this.B(this.U.onDidChangeStorage(n=>this.u(-1,n)))}P(n){switch(n){case-1:return this.U;case 0:return this.W;default:return this.X}}Q(n){switch(n){case-1:return"inMemory (application)";case 0:return"inMemory (profile)";default:return"inMemory (workspace)"}}async O(){}async R(){}async S(){}r(){return!1}hasScope(n){return!1}}e.$dp=u;async function o(i,n,r,a,t,s){const d=P=>{try{return JSON.parse(P)}catch{return P}},c=new Map,l=new Map;i.forEach((P,z)=>{c.set(z,P),l.set(z,d(P))});const h=new Map,E=new Map;n.forEach((P,z)=>{h.set(z,P),E.set(z,d(P))});const D=new Map,m=new Map;r.forEach((P,z)=>{D.set(z,P),m.set(z,d(P))}),console.group(a!==t?`Storage: Application (path: ${a})`:`Storage: Application & Profile (path: ${a}, default profile)`);const p=[];if(c.forEach((P,z)=>{p.push({key:z,value:P})}),console.table(p),console.groupEnd(),console.log(l),a!==t){console.group(`Storage: Profile (path: ${t}, profile specific)`);const P=[];h.forEach((z,j)=>{P.push({key:j,value:z})}),console.table(P),console.groupEnd(),console.log(E)}console.group(`Storage: Workspace (path: ${s})`);const S=[];D.forEach((P,z)=>{S.push({key:z,value:P})}),console.table(S),console.groupEnd(),console.log(m)}e.$ep=o}),define(ke[110],Se([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ddc=void 0;class C{static{this.a=!1}constructor(f){this.d=f,this.b=new Map,this.c=1}add(f){const L=this.c++;return this.b.set(L,f),this.e(),L}get(f,L){return this.b.has(f)?this.b.get(f)[L]:void 0}delete(f){this.b.delete(f),this.e()}e(){C.a&&console.log(`${this.d} cache size - ${this.b.size}`)}}e.$Ddc=C}),define(ke[57],Se([1,0,17,23,5]),function(me,e,C,F,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hdc=e.$Gdc=void 0;class L{constructor(){this.a=new Set(Object.keys(C.Schemas)),this.b=new Map,this.extUri=new F.$og(b=>{const v=this.b.get(b.scheme);return!(v===void 0||v&1024)})}$acceptProviderInfos(b,v){v===null?this.b.delete(b.scheme):this.b.set(b.scheme,v)}isFreeScheme(b){return!this.b.has(b)&&!this.a.has(b)}getCapabilities(b){return this.b.get(b)}}e.$Gdc=L,e.$Hdc=(0,f.$Vh)("IExtHostFileSystemInfo")}),define(ke[27],Se([1,0,5]),function(me,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$PM=void 0,e.$PM=(0,C.$Vh)("IExtHostInitDataService")}),define(ke[271],Se([1,0,214,14,251,27]),function(me,e,C,F,f,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nfc=void 0;let M=class extends f.$WN{constructor(v,g,A){const I=A.remote.isRemote?"remoteexthost":v?"workerexthost":"exthost",$=A.remote.isRemote?(0,C.localize)(0,null):v?(0,C.localize)(1,null):(0,C.localize)(2,null);super(g.createLogger(I,{name:$}))}};e.$Nfc=M,e.$Nfc=M=He([Be(1,F.$ej),Be(2,L.$PM)],M)}),define(ke[272],Se([1,0,12]),function(me,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qec=e.$pec=void 0;class F{constructor(M,b,v){this.h=new Map,this.a=M,this.b=b,this.c=v,this.d=this.c.initializeExtensionStorage(this.b,this.a,Object.create(null)).then(g=>(this.f=g,this)),this.g=this.c.onDidChangeStorage(g=>{g.shared===this.b&&g.key===this.a&&(this.f=g.value)}),this.i=new C.$0g(()=>{const g=this.h;this.h=new Map,(async()=>{try{await this.c.setValue(this.b,this.a,this.f);for(const A of g.values())A.complete()}catch(A){for(const I of g.values())I.error(A)}})()},0)}keys(){return Object.entries(this.f??{}).filter(([,M])=>M!==void 0).map(([M])=>M)}get whenReady(){return this.d}get(M,b){let v=this.f[M];return typeof v>"u"&&(v=b),v}update(M,b){this.f[M]=b;const v=this.h.get(M);if(v!==void 0)return v.p;const g=new C.$ih;return this.h.set(M,g),this.i.isScheduled()||this.i.schedule(),g.p}dispose(){this.g.dispose()}}e.$pec=F;class f extends F{setKeysForSync(M){this.c.registerExtensionStorageKeysToSync({id:this.a,version:this.j.version},M)}constructor(M,b){super(M.identifier.value,!0,b),this.j=M}}e.$qec=f}),define(ke[273],Se([1,0,4,2]),function(me,e,C,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dfc=void 0;class f{constructor(M){this.c=M,this.a=new C.$Rd,this.onDidSaveNotebookDocument=this.a.event,this.b=new C.$Rd,this.onDidChangeNotebookDocument=this.b.event}$acceptModelChanged(M,b,v,g){const I=this.c.getNotebookDocument(F.URI.revive(M)).acceptModelChanged(b.value,v,g);this.b.fire(I)}$acceptDirtyStateChanged(M,b){this.c.getNotebookDocument(F.URI.revive(M)).acceptDirty(b)}$acceptModelSaved(M){const b=this.c.getNotebookDocument(F.URI.revive(M));this.a.fire(b.apiNotebook)}}e.$dfc=f}),define(ke[20],Se([1,0,5]),function(me,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$AM=e.$zM=void 0,e.$zM=(0,C.$Vh)("IExtHostRpcService");class F{constructor(L){this.getProxy=L.getProxy.bind(L),this.set=L.set.bind(L),this.dispose=L.dispose.bind(L),this.assertRegistered=L.assertRegistered.bind(L),this.drain=L.drain.bind(L)}}e.$AM=F}),define(ke[274],Se([1,0,26,4]),function(me,e,C,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xec=void 0;class f{#e;constructor(M,b){this.b=new F.$Rd,this.onDidChange=this.b.event,this.a=C.$_l.toKey(M.identifier),this.#e=b,this.#e.onDidChangePassword(v=>{v.extensionId===this.a&&this.b.fire({key:v.key})})}get(M){return this.#e.get(this.a,M)}store(M,b){return this.#e.store(this.a,M,b)}delete(M){return this.#e.delete(this.a,M)}}e.$xec=f}),define(ke[66],Se([1,0,5]),function(me,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1dc=e.$Zdc=void 0,e.$Zdc=(0,C.$Vh)("IURITransformerService");class F{constructor(L){L?(this.transformIncoming=L.transformIncoming.bind(L),this.transformOutgoing=L.transformOutgoing.bind(L),this.transformOutgoingURI=L.transformOutgoingURI.bind(L),this.transformOutgoingScheme=L.transformOutgoingScheme.bind(L)):(this.transformIncoming=M=>M,this.transformOutgoing=M=>M,this.transformOutgoingURI=M=>M,this.transformOutgoingScheme=M=>M)}}e.$1dc=F}),define(ke[275],Se([1,0,22]),function(me,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$adb=e.$_cb=void 0;class F{constructor(){this.buffers=[]}add(v){let g=this.buffers.indexOf(v);return g<0&&(g=this.buffers.length,this.buffers.push(v)),g}}function f(b,v){if(v.serializeBuffersForPostMessage){const g=new F,I=JSON.stringify(b,(y,k)=>{if(k instanceof ArrayBuffer)return{$$vscode_array_buffer_reference$$:!0,index:g.add(k)};if(ArrayBuffer.isView(k)){const w=L(k);if(w)return{$$vscode_array_buffer_reference$$:!0,index:g.add(k.buffer),view:{type:w,byteLength:k.byteLength,byteOffset:k.byteOffset}}}return k}),$=g.buffers.map(y=>{const k=new Uint8Array(y);return C.$fe.wrap(k)});return{message:I,buffers:$}}else return{message:JSON.stringify(b),buffers:[]}}e.$_cb=f;function L(b){switch(b.constructor.name){case"Int8Array":return 1;case"Uint8Array":return 2;case"Uint8ClampedArray":return 3;case"Int16Array":return 4;case"Uint16Array":return 5;case"Int32Array":return 6;case"Uint32Array":return 7;case"Float32Array":return 8;case"Float64Array":return 9;case"BigInt64Array":return 10;case"BigUint64Array":return 11}}function M(b,v){const g=v.map($=>{const y=new ArrayBuffer($.byteLength);return new Uint8Array(y).set($.buffer),y}),A=v.length?($,y)=>{if(y&&typeof y=="object"&&y.$$vscode_array_buffer_reference$$){const k=y,{index:w}=k,u=g[w];if(k.view)switch(k.view.type){case 1:return new Int8Array(u,k.view.byteOffset,k.view.byteLength/Int8Array.BYTES_PER_ELEMENT);case 2:return new Uint8Array(u,k.view.byteOffset,k.view.byteLength/Uint8Array.BYTES_PER_ELEMENT);case 3:return new Uint8ClampedArray(u,k.view.byteOffset,k.view.byteLength/Uint8ClampedArray.BYTES_PER_ELEMENT);case 4:return new Int16Array(u,k.view.byteOffset,k.view.byteLength/Int16Array.BYTES_PER_ELEMENT);case 5:return new Uint16Array(u,k.view.byteOffset,k.view.byteLength/Uint16Array.BYTES_PER_ELEMENT);case 6:return new Int32Array(u,k.view.byteOffset,k.view.byteLength/Int32Array.BYTES_PER_ELEMENT);case 7:return new Uint32Array(u,k.view.byteOffset,k.view.byteLength/Uint32Array.BYTES_PER_ELEMENT);case 8:return new Float32Array(u,k.view.byteOffset,k.view.byteLength/Float32Array.BYTES_PER_ELEMENT);case 9:return new Float64Array(u,k.view.byteOffset,k.view.byteLength/Float64Array.BYTES_PER_ELEMENT);case 10:return new BigInt64Array(u,k.view.byteOffset,k.view.byteLength/BigInt64Array.BYTES_PER_ELEMENT);case 11:return new BigUint64Array(u,k.view.byteOffset,k.view.byteLength/BigUint64Array.BYTES_PER_ELEMENT);default:throw new Error("Unknown array buffer view type")}return u}return y}:void 0;return{message:JSON.parse(b,A),arrayBuffers:g}}e.$adb=M}),define(ke[276],Se([1,0,277,388,389,62,2,14,390]),function(me,e,C,F,f,L,M,b,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jgc=void 0;const g=!1;function A(n,r,a,t,s,d){const c=d.environment.useHostProxy,l=typeof c=="boolean"?c:!d.remote.isRemote,h={resolveProxy:m=>n.resolveProxy(m),lookupProxyAuthorization:u.bind(void 0,t,s,r,{},d.remote.isRemote),getProxyURL:()=>r.getConfiguration("http").get("proxy"),getProxySupport:()=>r.getConfiguration("http").get("proxySupport")||"off",addCertificatesV1:()=>$(r),addCertificatesV2:()=>y(r),log:t,getLogLevel:()=>{const m=t.getLevel();switch(m){case b.LogLevel.Trace:return v.LogLevel.Trace;case b.LogLevel.Debug:return v.LogLevel.Debug;case b.LogLevel.Info:return v.LogLevel.Info;case b.LogLevel.Warning:return v.LogLevel.Warning;case b.LogLevel.Error:return v.LogLevel.Error;case b.LogLevel.Off:return v.LogLevel.Off;default:return p(m)}function p(S){return t.error("Unknown log level",S),v.LogLevel.Debug}},proxyResolveTelemetry:()=>{},useHostProxy:l,loadAdditionalCertificates:async()=>{const m=[];if(d.remote.isRemote&&m.push((0,v.loadSystemCertificates)({log:t})),l){t.trace("ProxyResolver#loadAdditionalCertificates: Loading certificates from main process");const p=n.loadCertificates();p.then(S=>t.trace("ProxyResolver#loadAdditionalCertificates: Loaded certificates from main process",S.length)),m.push(p)}return(await Promise.all(m)).flat()},env:process.env},E=(0,v.createProxyResolver)(h),D=I(h,E);return w(a,D)}e.$jgc=A;function I(n,r){return{http:Object.assign(C,(0,v.createHttpPatch)(n,C,r)),https:Object.assign(F,(0,v.createHttpPatch)(n,F,r)),net:Object.assign(L,(0,v.createNetPatch)(n,L)),tls:Object.assign(f,(0,v.createTlsPatch)(n,f))}}function $(n){const r=n.getConfiguration("http");return!r.get("experimental.systemCertificatesV2",g)&&!!r.get("systemCertificates")}function y(n){const r=n.getConfiguration("http");return!!r.get("experimental.systemCertificatesV2",g)&&!!r.get("systemCertificates")}const k=new Map;function w(n,r){return n.getExtensionPathIndex().then(a=>{const t=globalThis._VSCODE_NODE_MODULES.module,s=t._load;t._load=function(c,l,h){if(c==="net")return r.net;if(c==="tls")return r.tls;if(c!=="http"&&c!=="https")return s.apply(this,arguments);const E=a.findSubstr(M.URI.file(l.filename));let D=k.get(E);if(D||k.set(E,D={}),!D[c]){const m=r[c];D[c]={...m}}return D[c]}})}async function u(n,r,a,t,s,d,c,l){const h=t[d];c&&(t[d]=c),n.trace("ProxyResolver#lookupProxyAuthorization callback",`proxyURL:${d}`,`proxyAuthenticate:${c}`,`proxyAuthenticateCache:${h}`);const E=c||h,D=Array.isArray(E)?E:typeof E=="string"?[E]:[];if(i(r,D,s),D.some(m=>/^(Negotiate|Kerberos)( |$)/i.test(m))&&!l.kerberosRequested)try{l.kerberosRequested=!0;const m=await new Promise((j,R)=>{me(["kerberos"],j,R)}),p=new URL(d),S=a.getConfiguration("http").get("proxyKerberosServicePrincipal")||(process.platform==="win32"?`HTTP/${p.hostname}`:`HTTP@${p.hostname}`);return n.debug("ProxyResolver#lookupProxyAuthorization Kerberos authentication lookup",`proxyURL:${d}`,`spn:${S}`),"Negotiate "+await(await m.initializeClient(S)).step("")}catch(m){n.error("ProxyResolver#lookupProxyAuthorization Kerberos authentication failed",m)}}let o=!1;function i(n,r,a){o||!r.length||(o=!0,n.$publicLog2("proxyAuthenticationRequest",{authenticationType:r.map(t=>t.split(" ")[0]).join(","),extensionHostType:a?"remote":"local"}))}}),define(ke[278],Se([1,0,131]),function(me,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gr=void 0;function F(L){return{transformIncoming:M=>M.scheme==="vscode-remote"?{scheme:"file",path:M.path,query:M.query,fragment:M.fragment}:M.scheme==="file"?{scheme:"vscode-local",path:M.path,query:M.query,fragment:M.fragment}:M,transformOutgoing:M=>M.scheme==="file"?{scheme:"vscode-remote",authority:L,path:M.path,query:M.query,fragment:M.fragment}:M.scheme==="vscode-local"?{scheme:"file",path:M.path,query:M.query,fragment:M.fragment}:M,transformOutgoingScheme:M=>M==="file"?"vscode-remote":M==="vscode-local"?"file":M}}function f(L){return new C.$Rm(F(L))}e.$Gr=f}),define(ke[141],Se([1,0,225,18,2,3,5,37,31,17,43,180,39]),function(me,e,C,F,f,L,M,b,v,g,A,I,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$AE=e.$zE=e.$yE=e.EditorsOrder=e.$xE=e.CloseDirection=e.$wE=e.$vE=e.EditorCloseMethod=e.SideBySideEditor=e.GroupModelChangeKind=e.EditorCloseContext=e.$uE=e.$tE=e.$sE=e.$rE=e.$qE=e.$pE=e.$oE=e.$nE=e.EditorInputCapabilities=e.$mE=e.SaveReason=e.Verbosity=e.$lE=e.$kE=e.$jE=e.$iE=e.$hE=e.$gE=e.$fE=e.$eE=e.EditorPaneSelectionCompareResult=e.EditorPaneSelectionChangeReason=e.$dE=e.$cE=e.$bE=e.$aE=e.$_D=void 0,e.$_D={EditorPane:"workbench.contributions.editors",EditorFactory:"workbench.contributions.editor.inputFactories"},e.$aE={id:"default",displayName:(0,C.localize)(0,null),providerDisplayName:(0,C.localize)(1,null)},e.$bE="workbench.editor.sidebysideEditor",e.$cE="workbench.editors.textDiffEditor",e.$dE="workbench.editors.binaryResourceDiffEditor";var y;(function(he){he[he.PROGRAMMATIC=1]="PROGRAMMATIC",he[he.USER=2]="USER",he[he.EDIT=3]="EDIT",he[he.NAVIGATION=4]="NAVIGATION",he[he.JUMP=5]="JUMP"})(y||(e.EditorPaneSelectionChangeReason=y={}));var k;(function(he){he[he.IDENTICAL=1]="IDENTICAL",he[he.SIMILAR=2]="SIMILAR",he[he.DIFFERENT=3]="DIFFERENT"})(k||(e.EditorPaneSelectionCompareResult=k={}));function w(he){const q=he;return!!q&&typeof q.getSelection=="function"&&!!q.onDidChangeSelection}e.$eE=w;function u(he,q,U){for(const ie of U.visibleEditorPanes)if(ie.group.id===q&&he.matches(ie.input))return ie.getViewState()}e.$fE=u;function o(he){if(E(he))return!1;const q=he;return f.URI.isUri(q?.resource)}e.$gE=o;function i(he){if(E(he))return!1;const q=he;return q?.original!==void 0&&q.modified!==void 0}e.$hE=i;function n(he){if(E(he))return!1;const q=he;return Array.isArray(q?.resources)}e.$iE=n;function r(he){if(E(he)||i(he))return!1;const q=he;return q?.primary!==void 0&&q.secondary!==void 0}e.$jE=r;function a(he){if(E(he))return!1;const q=he;return q?q.resource===void 0||q.resource.scheme===g.Schemas.untitled||q.forceUntitled===!0:!1}e.$kE=a;function t(he){if(E(he))return!1;const q=he;return f.URI.isUri(q?.base?.resource)&&f.URI.isUri(q?.input1?.resource)&&f.URI.isUri(q?.input2?.resource)&&f.URI.isUri(q?.result?.resource)}e.$lE=t;var s;(function(he){he[he.SHORT=0]="SHORT",he[he.MEDIUM=1]="MEDIUM",he[he.LONG=2]="LONG"})(s||(e.Verbosity=s={}));var d;(function(he){he[he.EXPLICIT=1]="EXPLICIT",he[he.AUTO=2]="AUTO",he[he.FOCUS_CHANGE=3]="FOCUS_CHANGE",he[he.WINDOW_CHANGE=4]="WINDOW_CHANGE"})(d||(e.SaveReason=d={}));class c{constructor(){this.a=new Map}registerSource(q,U){let ie=this.a.get(q);return ie||(ie={source:q,label:U},this.a.set(q,ie)),ie.source}getSourceLabel(q){return this.a.get(q)?.label??q}}e.$mE=new c;var l;(function(he){he[he.None=0]="None",he[he.Readonly=2]="Readonly",he[he.Untitled=4]="Untitled",he[he.Singleton=8]="Singleton",he[he.RequiresTrust=16]="RequiresTrust",he[he.CanSplitInGroup=32]="CanSplitInGroup",he[he.ForceDescription=64]="ForceDescription",he[he.CanDropIntoEditor=128]="CanDropIntoEditor",he[he.MultipleEditors=256]="MultipleEditors",he[he.Scratchpad=512]="Scratchpad",he[he.AuxWindowUnsupported=1024]="AuxWindowUnsupported"})(l||(e.EditorInputCapabilities=l={}));class h extends L.$Rc{}e.$nE=h;function E(he){return he instanceof h}e.$oE=E;function D(he){const q=he;return f.URI.isUri(q?.preferredResource)}function m(he){const q=he;return E(q?.primary)&&E(q?.secondary)}e.$pE=m;function p(he){const q=he;return E(q?.modified)&&E(q?.original)}e.$qE=p;function S(he,q,U,ie,be){return Ee(ie,[(0,I.$Fi)({id:"workbench.action.openLargeFile",label:(0,C.localize)(2,null),run:()=>{const H={...U,limits:{size:Number.MAX_VALUE}};he.openEditor(q,H)}}),(0,I.$Fi)({id:"workbench.action.configureEditorLargeFileConfirmation",label:(0,C.localize)(3,null),run:()=>be.openUserSettings({query:"workbench.editorLargeFileConfirmation"})})],{forceMessage:!0,forceSeverity:$.default.Warning})}e.$rE=S;function P(he){return E(he?.editor)}e.$sE=P;function z(he){const q=he;return P(he)&&q?.group!==void 0}e.$tE=z;function j(he){const q=he;return typeof q?.groupId=="number"&&E(q.editor)}e.$uE=j;var R;(function(he){he[he.UNKNOWN=0]="UNKNOWN",he[he.REPLACE=1]="REPLACE",he[he.MOVE=2]="MOVE",he[he.UNPIN=3]="UNPIN"})(R||(e.EditorCloseContext=R={}));var T;(function(he){he[he.GROUP_ACTIVE=0]="GROUP_ACTIVE",he[he.GROUP_INDEX=1]="GROUP_INDEX",he[he.GROUP_LABEL=2]="GROUP_LABEL",he[he.GROUP_LOCKED=3]="GROUP_LOCKED",he[he.EDITOR_OPEN=4]="EDITOR_OPEN",he[he.EDITOR_CLOSE=5]="EDITOR_CLOSE",he[he.EDITOR_MOVE=6]="EDITOR_MOVE",he[he.EDITOR_ACTIVE=7]="EDITOR_ACTIVE",he[he.EDITOR_LABEL=8]="EDITOR_LABEL",he[he.EDITOR_CAPABILITIES=9]="EDITOR_CAPABILITIES",he[he.EDITOR_PIN=10]="EDITOR_PIN",he[he.EDITOR_STICKY=11]="EDITOR_STICKY",he[he.EDITOR_DIRTY=12]="EDITOR_DIRTY",he[he.EDITOR_WILL_DISPOSE=13]="EDITOR_WILL_DISPOSE"})(T||(e.GroupModelChangeKind=T={}));var N;(function(he){he[he.PRIMARY=1]="PRIMARY",he[he.SECONDARY=2]="SECONDARY",he[he.BOTH=3]="BOTH",he[he.ANY=4]="ANY"})(N||(e.SideBySideEditor=N={}));class O{getOriginalUri(q,U){if(!q)return;if(t(q))return e.$wE.getOriginalUri(q.result,U);if(U?.supportSideBySide){const{primary:be,secondary:H}=this.a(q);if(be&&H){if(U?.supportSideBySide===N.BOTH)return{primary:this.getOriginalUri(be,{filterByScheme:U.filterByScheme}),secondary:this.getOriginalUri(H,{filterByScheme:U.filterByScheme})};if(U?.supportSideBySide===N.ANY)return this.getOriginalUri(be,{filterByScheme:U.filterByScheme})??this.getOriginalUri(H,{filterByScheme:U.filterByScheme});q=U.supportSideBySide===N.PRIMARY?be:H}}if(i(q)||n(q)||r(q)||t(q))return;const ie=D(q)?q.preferredResource:q.resource;return!ie||!U||!U.filterByScheme?ie:this.b(ie,U.filterByScheme)}a(q){return m(q)||r(q)?{primary:q.primary,secondary:q.secondary}:p(q)||i(q)?{primary:q.modified,secondary:q.original}:{primary:void 0,secondary:void 0}}getCanonicalUri(q,U){if(!q)return;if(t(q))return e.$wE.getCanonicalUri(q.result,U);if(U?.supportSideBySide){const{primary:be,secondary:H}=this.a(q);if(be&&H){if(U?.supportSideBySide===N.BOTH)return{primary:this.getCanonicalUri(be,{filterByScheme:U.filterByScheme}),secondary:this.getCanonicalUri(H,{filterByScheme:U.filterByScheme})};if(U?.supportSideBySide===N.ANY)return this.getCanonicalUri(be,{filterByScheme:U.filterByScheme})??this.getCanonicalUri(H,{filterByScheme:U.filterByScheme});q=U.supportSideBySide===N.PRIMARY?be:H}}if(i(q)||n(q)||r(q)||t(q))return;const ie=q.resource;return!ie||!U||!U.filterByScheme?ie:this.b(ie,U.filterByScheme)}b(q,U){if(Array.isArray(U)){if(U.some(ie=>q.scheme===ie))return q}else if(U===q.scheme)return q}}var W;(function(he){he[he.UNKNOWN=0]="UNKNOWN",he[he.KEYBOARD=1]="KEYBOARD",he[he.MOUSE=2]="MOUSE"})(W||(e.EditorCloseMethod=W={}));function x(he,q,U,ie){if(!he.isSticky(q))return!1;switch(ie.preventPinnedEditorClose){case"keyboardAndMouse":return U===W.MOUSE||U===W.KEYBOARD;case"mouse":return U===W.MOUSE;case"keyboard":return U===W.KEYBOARD}return!1}e.$vE=x,e.$wE=new O;var le;(function(he){he[he.LEFT=0]="LEFT",he[he.RIGHT=1]="RIGHT"})(le||(e.CloseDirection=le={}));class G{constructor(){this.c=new Map,this.d=new Map}start(q){const U=this.a=q.get(M.$Uh);for(const[ie,be]of this.c)this.e(ie,be,U);this.c.clear()}e(q,U,ie){const be=ie.createInstance(U);this.d.set(q,be)}registerFileEditorFactory(q){if(this.b)throw new Error("Can only register one file editor factory.");this.b=q}getFileEditorFactory(){return(0,F.$Nf)(this.b)}registerEditorSerializer(q,U){if(this.c.has(q)||this.d.has(q))throw new Error(`A editor serializer with type ID '${q}' was already registered.`);return this.a?this.e(q,U,this.a):this.c.set(q,U),(0,L.$Pc)(()=>{this.c.delete(q),this.d.delete(q)})}getEditorSerializer(q){return this.d.get(typeof q=="string"?q:q.typeId)}}b.$mn.add(e.$_D.EditorFactory,new G);async function J(he,q,U){return!he||!he.length?[]:await Promise.all(he.map(async ie=>{const be=f.URI.revive(ie.fileUri);if(!be){U.info("Cannot resolve the path because it is not valid.",ie);return}if(!await q.canHandleResource(be)){U.info("Cannot resolve the path because it cannot be handled",ie);return}let Y=ie.exists,Z=ie.type;if(typeof Y!="boolean"||typeof Z!="number")try{Z=(await q.stat(be)).isDirectory?v.FileType.Directory:v.FileType.Unknown,Y=!0}catch(ne){U.error(ne),Y=!1}if(!Y&&ie.openOnlyIfExists){U.info("Cannot resolve the path because it does not exist",ie);return}if(Z===v.FileType.Directory){U.info("Cannot resolve the path because it is a directory",ie);return}const $e={...ie.options,pinned:!0};return Y?{resource:be,options:$e}:{resource:be,options:$e,forceUntitled:!0}}))}e.$xE=J;var Q;(function(he){he[he.MOST_RECENTLY_ACTIVE=0]="MOST_RECENTLY_ACTIVE",he[he.SEQUENTIAL=1]="SEQUENTIAL"})(Q||(e.EditorsOrder=Q={}));function oe(he){const q=he;if(!q)return!1;const U=q;if(U.modified)return oe(U.modified);const ie=q;return!!(ie.contributionsState&&ie.viewState&&Array.isArray(ie.cursorState))}e.$yE=oe;function _(he){return(0,A.$Hi)(he)}e.$zE=_;function Ee(he,q,U){const ie=(0,A.$Ii)(he,q);return ie.forceMessage=U?.forceMessage,ie.forceSeverity=U?.forceSeverity,ie.allowDialog=U?.allowDialog,ie}e.$AE=Ee}),define(ke[279],Se([1,0,4,226,5,3,28,37,19,24,78,265]),function(me,e,C,F,f,L,M,b,v,g,A,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$JE=e.$IE=e.TreeItemCollapsibleState=e.ViewVisibilityState=e.$HE=e.$GE=e.ViewContentGroups=e.$FE=e.$EE=e.ViewContainerLocation=e.Extensions=e.$DE=e.$CE=e.$BE=void 0,e.$BE="views",e.$CE=(0,F.localize)(0,null),e.$DE=(0,I.$_v)("default-view-icon",A.$1j.window,(0,F.localize)(1,null));var $;(function(s){s.ViewContainersRegistry="workbench.registry.view.containers",s.ViewsRegistry="workbench.registry.view"})($||(e.Extensions=$={}));var y;(function(s){s[s.Sidebar=0]="Sidebar",s[s.Panel=1]="Panel",s[s.AuxiliaryBar=2]="AuxiliaryBar"})(y||(e.ViewContainerLocation=y={})),e.$EE=[0,1,2];function k(s){switch(s){case 0:return"sidebar";case 1:return"panel";case 2:return"auxiliarybar"}}e.$FE=k;class w extends L.$Rc{constructor(){super(...arguments),this.c=this.B(new C.$Rd),this.onDidRegister=this.c.event,this.f=this.B(new C.$Rd),this.onDidDeregister=this.f.event,this.g=new Map,this.h=[]}get all(){return(0,v.$Qb)([...this.g.values()])}registerViewContainer(d,c,l){const h=this.get(d.id);if(h)return h;const E=d;return E.openCommandActionDescriptor=l?.doNotRegisterOpenCommand?void 0:E.openCommandActionDescriptor??{id:E.id},(0,M.$wc)(this.g,c,[]).push(E),l?.isDefault&&this.h.push(E),this.c.fire({viewContainer:E,viewContainerLocation:c}),E}deregisterViewContainer(d){for(const c of this.g.keys()){const l=this.g.get(c),h=l?.indexOf(d);if(h!==-1){l?.splice(h,1),l.length===0&&this.g.delete(c),this.f.fire({viewContainer:d,viewContainerLocation:c});return}}}get(d){return this.all.filter(c=>c.id===d)[0]}getViewContainers(d){return[...this.g.get(d)||[]]}getViewContainerLocation(d){return[...this.g.keys()].filter(c=>this.getViewContainers(c).filter(l=>l?.id===d.id).length>0)[0]}getDefaultViewContainer(d){return this.h.find(c=>this.getViewContainerLocation(c)===d)}}b.$mn.add($.ViewContainersRegistry,new w);var u;(function(s){s.Open="2_open",s.Debug="4_debug",s.SCM="5_scm",s.More="9_more"})(u||(e.ViewContentGroups=u={}));function o(s,d){const c=s.group??u.More,l=d.group??u.More;return c!==l?c.localeCompare(l):(s.order??5)-(d.order??5)}class i extends L.$Rc{constructor(){super(...arguments),this.c=this.B(new C.$Rd),this.onViewsRegistered=this.c.event,this.f=this.B(new C.$Rd),this.onViewsDeregistered=this.f.event,this.g=this.B(new C.$Rd),this.onDidChangeContainer=this.g.event,this.h=this.B(new C.$Rd),this.onDidChangeViewWelcomeContent=this.h.event,this.j=[],this.m=new Map,this.n=new M.$Fc}registerViews(d,c){this.registerViews2([{views:d,viewContainer:c}])}registerViews2(d){d.forEach(({views:c,viewContainer:l})=>this.r(c,l)),this.c.fire(d)}deregisterViews(d,c){const l=this.s(d,c);l.length&&this.f.fire({views:l,viewContainer:c})}moveViews(d,c){for(const l of this.m.keys())if(l!==c){const h=this.s(d,l);h.length&&(this.r(h,c),this.g.fire({views:h,from:l,to:c}))}}getViews(d){return this.m.get(d)||[]}getView(d){for(const c of this.j){const l=(this.m.get(c)||[]).filter(h=>h.id===d)[0];if(l)return l}return null}getViewContainer(d){for(const c of this.j)if((this.m.get(c)||[]).filter(h=>h.id===d)[0])return c;return null}registerViewWelcomeContent(d,c){return this.n.add(d,c),this.h.fire(d),(0,L.$Pc)(()=>{this.n.delete(d,c),this.h.fire(d)})}registerViewWelcomeContent2(d,c){const l=new Map;for(const[h,E]of c)this.n.add(d,E),l.set(h,(0,L.$Pc)(()=>{this.n.delete(d,E),this.h.fire(d)}));return this.h.fire(d),l}getViewWelcomeContent(d){const c=[];return this.n.forEach(d,l=>c.push(l)),c.sort(o)}r(d,c){let l=this.m.get(c);l||(l=[],this.m.set(c,l),this.j.push(c));for(const h of d){if(this.getView(h.id)!==null)throw new Error((0,F.localize)(2,null,h.id));l.push(h)}}s(d,c){const l=this.m.get(c);if(!l)return[];const h=[],E=[];for(const D of l)d.includes(D)?h.push(D):E.push(D);return h.length&&(E.length?this.m.set(c,E):(this.m.delete(c),this.j.splice(this.j.indexOf(c),1))),h}}b.$mn.add($.ViewsRegistry,new i),e.$GE=(0,f.$Vh)("viewsService"),e.$HE=(0,f.$Vh)("viewDescriptorService");var n;(function(s){s[s.Default=0]="Default",s[s.Expand=1]="Expand"})(n||(e.ViewVisibilityState=n={}));var r;(function(s){s[s.None=0]="None",s[s.Collapsed=1]="Collapsed",s[s.Expanded=2]="Expanded"})(r||(e.TreeItemCollapsibleState=r={}));class a{constructor(d,c){this.c=!1,this.d=!1,(0,g.$dn)(this,d),this.d=!!c,this.resolve=async l=>{if(c&&!this.c){const h=await c(l);h&&(this.tooltip=this.tooltip??h.tooltip,this.command=this.command??h.command)}l.isCancellationRequested||(this.c=!0)}}get hasResolve(){return this.d}resetResolve(){this.c=!1}asTreeItem(){return{handle:this.handle,parentHandle:this.parentHandle,collapsibleState:this.collapsibleState,label:this.label,description:this.description,icon:this.icon,iconDark:this.iconDark,themeIcon:this.themeIcon,resourceUri:this.resourceUri,tooltip:this.tooltip,contextValue:this.contextValue,command:this.command,children:this.children,accessibilityInformation:this.accessibilityInformation}}}e.$IE=a;class t extends Error{constructor(d){super((0,F.localize)(3,null,d)),this.name="NoTreeViewError"}static is(d){return d.name==="NoTreeViewError"}}e.$JE=t}),define(ke[280],Se([1,0,2,29,5]),function(me,e,C,F,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_E=e.InteractiveSessionCopyKind=e.InteractiveSessionVoteDirection=e.$$E=e.$0E=void 0;function L(g){return!!g&&typeof g=="object"&&"uri"in g&&g.uri instanceof C.URI&&"version"in g&&typeof g.version=="number"&&"ranges"in g&&Array.isArray(g.ranges)&&g.ranges.every(F.$zs.isIRange)}e.$0E=L;function M(g){return!!g&&typeof g=="object"&&"documents"in g&&Array.isArray(g.documents)&&g.documents.every(L)}e.$$E=M;var b;(function(g){g[g.Down=0]="Down",g[g.Up=1]="Up"})(b||(e.InteractiveSessionVoteDirection=b={}));var v;(function(g){g[g.Action=1]="Action",g[g.Toolbar=2]="Toolbar"})(v||(e.InteractiveSessionCopyKind=v={})),e.$_E=(0,f.$Vh)("IChatService")}),define(ke[142],Se([1,0,4,12,227]),function(me,e,C,F,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fdb=void 0;class L{constructor(){this.f=new Map,this.k=[],this.m=new C.$Rd,this.n=new C.$Rd,this.d=1}get onError(){return this.m.event}get onExit(){return this.n.event}onMessage(b){this.j&&this.m.fire(new Error("attempt to set more than one 'Message' callback")),this.j=b}onEvent(b){this.i&&this.m.fire(new Error("attempt to set more than one 'Event' callback")),this.i=b}onRequest(b){this.g&&this.m.fire(new Error("attempt to set more than one 'Request' callback")),this.g=b}sendResponse(b){b.seq>0?this.m.fire(new Error(`attempt to send more than one response for command ${b.command}`)):this.s("response",b)}sendRequest(b,v,g,A){const I={command:b};if(v&&Object.keys(v).length>0&&(I.arguments=v),this.s("request",I),typeof A=="number"){const $=setTimeout(()=>{clearTimeout($);const y=this.f.get(I.seq);if(y){this.f.delete(I.seq);const k={type:"response",seq:0,request_seq:I.seq,success:!1,command:b,message:(0,f.localize)(0,null,A,b)};y(k)}},A)}return g&&this.f.set(I.seq,g),I.seq}acceptMessage(b){this.j?this.j(b):(this.k.push(b),this.k.length===1&&this.q())}o(b,v){return b.type!=="event"||v.type!=="event"}async q(){let b;for(;this.k.length;){if((!b||this.o(this.k[0],b))&&await(0,F.$Yg)(0),b=this.k.shift(),!b)return;switch(b.type){case"event":this.i?.(b);break;case"request":this.g?.(b);break;case"response":{const v=b,g=this.f.get(v.request_seq);g&&(this.f.delete(v.request_seq),g(v));break}}}}s(b,v){v.type=b,v.seq=this.d++,this.sendMessage(v)}async u(){if(this.f.size===0)return Promise.resolve();const b=new Map;this.f.forEach((v,g)=>b.set(g,v)),await(0,F.$Yg)(500),b.forEach((v,g)=>{v({type:"response",seq:0,request_seq:g,success:!1,command:"canceled",message:"canceled"}),this.f.delete(g)})}getPendingRequestIds(){return Array.from(this.f.keys())}dispose(){this.k=[]}}e.$Fdb=L}),define(ke[281],Se([1,0,228,45,5]),function(me,e,C,F,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BreakpointWidgetContext=e.$kH=e.DebuggerString=e.DebugConfigurationProviderTriggerKind=e.$jH=e.MemoryRangeType=e.$iH=e.State=e.$hH=e.$gH=e.$fH=e.$eH=e.$dH=e.$cH=e.$bH=e.$aH=e.$_G=e.$$G=e.$0G=e.$9G=e.$8G=e.$7G=e.$6G=e.$5G=e.$4G=e.$3G=e.$2G=e.$1G=e.$ZG=e.$YG=e.$XG=e.$WG=e.$VG=e.$UG=e.$TG=e.$SG=e.$RG=e.$QG=e.$PG=e.$OG=e.$NG=e.$MG=e.$LG=e.$KG=e.$JG=e.$IG=e.$HG=e.$GG=e.$FG=e.$EG=e.$DG=e.$CG=e.$BG=e.$AG=e.$zG=e.$yG=e.$xG=e.$wG=e.$vG=e.$uG=e.$tG=e.$sG=e.$rG=e.$qG=e.$pG=e.$oG=e.$nG=e.$mG=e.$lG=e.$kG=e.$jG=e.$iG=e.$hG=e.$gG=e.$fG=void 0,e.$fG="workbench.view.debug",e.$gG="workbench.debug.variablesView",e.$hG="workbench.debug.watchExpressionsView",e.$iG="workbench.debug.callStackView",e.$jG="workbench.debug.loadedScriptsView",e.$kG="workbench.debug.breakPointsView",e.$lG="workbench.debug.disassemblyView",e.$mG="workbench.panel.repl",e.$nG="workbench.panel.repl.view",e.$oG=new F.$aj("debugType",void 0,{type:"string",description:C.localize(0,null)}),e.$pG=new F.$aj("debugConfigurationType",void 0,{type:"string",description:C.localize(1,null)}),e.$qG=new F.$aj("debugState","inactive",{type:"string",description:C.localize(2,null)}),e.$rG="debugUx",e.$sG=new F.$aj(e.$rG,"default",{type:"string",description:C.localize(3,null)}),e.$tG=new F.$aj("hasDebugged",!1,{type:"boolean",description:C.localize(4,null)}),e.$uG=new F.$aj("inDebugMode",!1,{type:"boolean",description:C.localize(5,null)}),e.$vG=new F.$aj("inDebugRepl",!1,{type:"boolean",description:C.localize(6,null)}),e.$wG=new F.$aj("breakpointWidgetVisible",!1,{type:"boolean",description:C.localize(7,null)}),e.$xG=new F.$aj("inBreakpointWidget",!1,{type:"boolean",description:C.localize(8,null)}),e.$yG=new F.$aj("breakpointsFocused",!0,{type:"boolean",description:C.localize(9,null)}),e.$zG=new F.$aj("watchExpressionsFocused",!0,{type:"boolean",description:C.localize(10,null)}),e.$AG=new F.$aj("watchExpressionsExist",!1,{type:"boolean",description:C.localize(11,null)}),e.$BG=new F.$aj("variablesFocused",!0,{type:"boolean",description:C.localize(12,null)}),e.$CG=new F.$aj("expressionSelected",!1,{type:"boolean",description:C.localize(13,null)}),e.$DG=new F.$aj("breakpointInputFocused",!1,{type:"boolean",description:C.localize(14,null)}),e.$EG=new F.$aj("callStackItemType",void 0,{type:"string",description:C.localize(15,null)}),e.$FG=new F.$aj("callStackSessionIsAttach",!1,{type:"boolean",description:C.localize(16,null)}),e.$GG=new F.$aj("callStackItemStopped",!1,{type:"boolean",description:C.localize(17,null)}),e.$HG=new F.$aj("callStackSessionHasOneThread",!1,{type:"boolean",description:C.localize(18,null)}),e.$IG=new F.$aj("watchItemType",void 0,{type:"string",description:C.localize(19,null)}),e.$JG=new F.$aj("canViewMemory",void 0,{type:"boolean",description:C.localize(20,null)}),e.$KG=new F.$aj("breakpointItemType",void 0,{type:"string",description:C.localize(21,null)}),e.$LG=new F.$aj("breakpointSupportsCondition",!1,{type:"boolean",description:C.localize(22,null)}),e.$MG=new F.$aj("loadedScriptsSupported",!1,{type:"boolean",description:C.localize(23,null)}),e.$NG=new F.$aj("loadedScriptsItemType",void 0,{type:"string",description:C.localize(24,null)}),e.$OG=new F.$aj("focusedSessionIsAttach",!1,{type:"boolean",description:C.localize(25,null)}),e.$PG=new F.$aj("focusedSessionIsNoDebug",!1,{type:"boolean",description:C.localize(26,null)}),e.$QG=new F.$aj("stepBackSupported",!1,{type:"boolean",description:C.localize(27,null)}),e.$RG=new F.$aj("restartFrameSupported",!1,{type:"boolean",description:C.localize(28,null)}),e.$SG=new F.$aj("stackFrameSupportsRestart",!1,{type:"boolean",description:C.localize(29,null)}),e.$TG=new F.$aj("jumpToCursorSupported",!1,{type:"boolean",description:C.localize(30,null)}),e.$UG=new F.$aj("stepIntoTargetsSupported",!1,{type:"boolean",description:C.localize(31,null)}),e.$VG=new F.$aj("breakpointsExist",!1,{type:"boolean",description:C.localize(32,null)}),e.$WG=new F.$aj("debuggersAvailable",!1,{type:"boolean",description:C.localize(33,null)}),e.$XG=new F.$aj("debugExtensionAvailable",!0,{type:"boolean",description:C.localize(34,null)}),e.$YG=new F.$aj("debugProtocolVariableMenuContext",void 0,{type:"string",description:C.localize(35,null)}),e.$ZG=new F.$aj("debugSetVariableSupported",!1,{type:"boolean",description:C.localize(36,null)}),e.$1G=new F.$aj("debugSetExpressionSupported",!1,{type:"boolean",description:C.localize(37,null)}),e.$2G=new F.$aj("breakWhenValueChangesSupported",!1,{type:"boolean",description:C.localize(38,null)}),e.$3G=new F.$aj("breakWhenValueIsAccessedSupported",!1,{type:"boolean",description:C.localize(39,null)}),e.$4G=new F.$aj("breakWhenValueIsReadSupported",!1,{type:"boolean",description:C.localize(40,null)}),e.$5G=new F.$aj("terminateDebuggeeSupported",!1,{type:"boolean",description:C.localize(41,null)}),e.$6G=new F.$aj("suspendDebuggeeSupported",!1,{type:"boolean",description:C.localize(42,null)}),e.$7G=new F.$aj("variableEvaluateNamePresent",!1,{type:"boolean",description:C.localize(43,null)}),e.$8G=new F.$aj("variableIsReadonly",!1,{type:"boolean",description:C.localize(44,null)}),e.$9G=new F.$aj("exceptionWidgetVisible",!1,{type:"boolean",description:C.localize(45,null)}),e.$0G=new F.$aj("multiSessionRepl",!1,{type:"boolean",description:C.localize(46,null)}),e.$$G=new F.$aj("multiSessionDebug",!1,{type:"boolean",description:C.localize(47,null)}),e.$_G=new F.$aj("disassembleRequestSupported",!1,{type:"boolean",description:C.localize(48,null)}),e.$aH=new F.$aj("disassemblyViewFocus",!1,{type:"boolean",description:C.localize(49,null)}),e.$bH=new F.$aj("languageSupportsDisassembleRequest",!1,{type:"boolean",description:C.localize(50,null)}),e.$cH=new F.$aj("focusedStackFrameHasInstructionReference",!1,{type:"boolean",description:C.localize(51,null)});const L=$=>C.localize(52,null,$);e.$dH=L,e.$eH="editor.contrib.debug",e.$fH="editor.contrib.breakpoint",e.$gH="debug",e.$hH={enum:["neverOpen","openOnSessionStart","openOnFirstSessionStart"],default:"openOnFirstSessionStart",description:C.localize(53,null)};var M;(function($){$[$.Inactive=0]="Inactive",$[$.Initializing=1]="Initializing",$[$.Stopped=2]="Stopped",$[$.Running=3]="Running"})(M||(e.State=M={}));function b($){switch($){case 1:return"initializing";case 2:return"stopped";case 3:return"running";default:return"inactive"}}e.$iH=b;var v;(function($){$[$.Valid=0]="Valid",$[$.Unreadable=1]="Unreadable",$[$.Error=2]="Error"})(v||(e.MemoryRangeType=v={})),e.$jH="vscode-debug-memory";var g;(function($){$[$.Initial=1]="Initial",$[$.Dynamic=2]="Dynamic"})(g||(e.DebugConfigurationProviderTriggerKind=g={}));var A;(function($){$.UnverifiedBreakpoints="unverifiedBreakpoints"})(A||(e.DebuggerString=A={})),e.$kH=(0,f.$Vh)("debugService");var I;(function($){$[$.CONDITION=0]="CONDITION",$[$.HIT_COUNT=1]="HIT_COUNT",$[$.LOG_MESSAGE=2]="LOG_MESSAGE"})(I||(e.BreakpointWidgetContext=I={}))}),define(ke[282],Se([1,0,13,2,16,24,17,29,21,19]),function(me,e,C,F,f,L,M,b,v,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qF=e.$pF=e.$oF=e.$nF=e.$mF=e.$lF=e.$kF=e.$jF=e.$iF=e.$hF=e.$gF=e.$fF=e.$eF=void 0;const A=/{([^}]+)}/g;function I(D,m,p){return D.replace(A,function(S,P){return m&&P.length>0&&P[0]!=="_"?S:p&&p.hasOwnProperty(P)?p[P]:S})}e.$eF=I;function $(D){const m={};for(const p of Object.keys(D))p.startsWith("!")||(m[p]=D[p]);return m}e.$fF=$;function y(D){return D.configuration.request==="attach"&&!k(D)&&(!D.parentSession||y(D.parentSession))}e.$gF=y;function k(D){let m=D.configuration.type;if(m)return m==="vslsShare"&&(m=D.configuration.adapterProxy.configuration.type),(0,C.$6e)(m,"extensionhost")||(0,C.$6e)(m,"pwa-extensionhost")?D:D.parentSession?k(D.parentSession):void 0}e.$hF=k;function w(D){return D.type&&(D.label||D.program||D.runtime)}e.$iF=w;function u(D,m,p){let S,P=0;const z=/([^()\[\]{}<>\s+\-/%~#^;=|,`!]|\->)+/g;let j=null;for(;j=z.exec(D);){const R=j.index+1,T=R+j[0].length;if(R<=m&&T>=p){S=j[0],P=R;break}}if(S){const R=/\w+/g;let T=null;for(;(T=R.exec(S))&&!(T.index+1+P+T[0].length>=p););T&&(S=S.substring(0,R.lastIndex))}return S?{start:P,end:P+S.length-1}:{start:0,end:0}}e.$jF=u;async function o(D,m,p,S){if(D.evaluatableExpressionProvider.has(m)){const P=D.evaluatableExpressionProvider.ordered(m),z=(0,g.$Gb)(await Promise.all(P.map(async j=>{try{return await j.provideEvaluatableExpression(m,p,S??v.CancellationToken.None)}catch{return}})));if(z.length>0){let j=z[0].expression;const R=z[0].range;return j||(j=m.getLineContent(p.lineNumber).substring(R.startColumn-1,R.endColumn-1)),{range:R,matchingExpression:j}}}else{const P=m.getLineContent(p.lineNumber),{start:z,end:j}=u(P,p.column,p.column),R=P.substring(z-1,j);return{matchingExpression:R,range:new b.$zs(p.lineNumber,z,p.lineNumber,z+R.length)}}return null}e.$kF=o;const i=/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/;function n(D){return!!(D&&D.match(i))}e.$lF=n;function r(D){if(typeof D.path=="string"&&!(typeof D.sourceReference=="number"&&D.sourceReference>0)){if(n(D.path))return F.URI.parse(D.path);if((0,f.$hc)(D.path))return F.URI.file(D.path)}return D.path}function a(D){if(typeof D.path=="object"){const m=F.URI.revive(D.path);if(m)return m.scheme===M.Schemas.file?m.fsPath:m.toString()}return D.path}function t(D,m){const p=m?r:a,S=(0,L.$an)(D);return d(S,(P,z)=>{P&&z&&(z.path=p(z))}),S}e.$mF=t;function s(D,m){const p=m?r:a,S=(0,L.$an)(D);return d(S,(P,z)=>{!P&&z&&(z.path=p(z))}),S}e.$nF=s;function d(D,m){switch(D.type){case"event":{const p=D;switch(p.event){case"output":m(!1,p.body.source);break;case"loadedSource":m(!1,p.body.source);break;case"breakpoint":m(!1,p.body.breakpoint.source);break;default:break}break}case"request":{const p=D;switch(p.command){case"setBreakpoints":m(!0,p.arguments.source);break;case"breakpointLocations":m(!0,p.arguments.source);break;case"source":m(!0,p.arguments.source);break;case"gotoTargets":m(!0,p.arguments.source);break;case"launchVSCode":p.arguments.args.forEach(S=>m(!1,S));break;default:break}break}case"response":{const p=D;if(p.success&&p.body)switch(p.command){case"stackTrace":p.body.stackFrames.forEach(S=>m(!1,S.source));break;case"loadedSources":p.body.sources.forEach(S=>m(!1,S));break;case"scopes":p.body.scopes.forEach(S=>m(!1,S.source));break;case"setFunctionBreakpoints":p.body.breakpoints.forEach(S=>m(!1,S.source));break;case"setBreakpoints":p.body.breakpoints.forEach(S=>m(!1,S.source));break;case"disassemble":p.body?.instructions.forEach(P=>m(!1,P.location));break;default:break}break}}}function c(D){return D.filter(m=>!m.presentation?.hidden).sort((m,p)=>m.presentation?p.presentation?m.presentation.group?p.presentation.group?m.presentation.group!==p.presentation.group?m.presentation.group.localeCompare(p.presentation.group):l(m.presentation.order,p.presentation.order):-1:p.presentation.group?1:l(m.presentation.order,p.presentation.order):-1:p.presentation?1:0)}e.$oF=c;function l(D,m){return typeof D!="number"?typeof m!="number"?0:1:typeof m!="number"?-1:D-m}async function h(D,m){const p=D.getValue("debug.saveBeforeStart",{overrideIdentifier:m.activeTextEditorLanguageId});if(p!=="none"&&(await m.saveAll(),p==="allEditorsInActiveGroup")){const S=m.activeEditorPane;S&&S.input.resource?.scheme===M.Schemas.untitled&&await m.save({editor:S.input,groupId:S.group.id})}await D.reloadConfiguration()}e.$pF=h;const E=(D,m)=>!D||!m?D===m:D.name===m.name&&D.path===m.path&&D.sourceReference===m.sourceReference;e.$qF=E}),define(ke[283],Se([1,0,50,62,24,16,11,13,30,229,142]),function(me,e,C,F,f,L,M,b,v,g,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xfc=e.$Wfc=e.$Vfc=e.$Ufc=e.$Tfc=void 0;class I extends A.$Fdb{static{this.a=`\r
\r
`}static{this.b=/\r?\n/}static{this.l=/: */}constructor(){super(),this.r=Buffer.allocUnsafe(0),this.t=-1}v(o,i){this.p=i,this.r=Buffer.allocUnsafe(0),this.t=-1,o.on("data",n=>this.w(n))}sendMessage(o){if(this.p){const i=JSON.stringify(o);this.p.write(`Content-Length: ${Buffer.byteLength(i,"utf8")}${I.a}${i}`,"utf8")}}w(o){for(this.r=Buffer.concat([this.r,o]);;){if(this.t>=0){if(this.r.length>=this.t){const i=this.r.toString("utf8",0,this.t);if(this.r=this.r.slice(this.t),this.t=-1,i.length>0)try{this.acceptMessage(JSON.parse(i))}catch(n){this.m.fire(new Error((n.message||n)+`
`+i))}continue}}else{const i=this.r.indexOf(I.a);if(i!==-1){const r=this.r.toString("utf8",0,i).split(I.b);for(const a of r){const t=a.split(I.l);t[0]==="Content-Length"&&(this.t=Number(t[1]))}this.r=this.r.slice(i+I.a.length);continue}}break}}}e.$Tfc=I;class $ extends I{startSession(){return new Promise((o,i)=>{let n=!1;this.x=this.y(()=>{this.v(this.x,this.x),o(),n=!0}),this.x.on("close",()=>{n?this.m.fire(new Error("connection closed")):i(new Error("connection closed"))}),this.x.on("error",r=>{n?this.m.fire(r):i(r)})})}async stopSession(){await this.u(),this.x&&(this.x.end(),this.x=void 0)}}e.$Ufc=$;class y extends ${constructor(o){super(),this.z=o}y(o){return F.createConnection(this.z.port,this.z.host||"127.0.0.1",o)}}e.$Vfc=y;class k extends ${constructor(o){super(),this.z=o}y(o){return F.createConnection(this.z.path,o)}}e.$Wfc=k;class w extends I{constructor(o,i){super(),this.y=o,this.z=i}async startSession(){const o=this.y.command,i=this.y.args,n=this.y.options||{};try{if(o)if(L.$hc(o)){if(!await v.Promises.exists(o))throw new Error(g.localize(0,null,o))}else o.indexOf("/")<0&&o.indexOf("\\")<0;else throw new Error(g.localize(1,null,this.z));let r=process.env;if(n.env&&Object.keys(n.env).length>0&&(r=f.$dn(f.$an(process.env),n.env)),o==="node")if(Array.isArray(i)&&i.length>0){const a=!!process.env.ELECTRON_RUN_AS_NODE||!!process.versions.electron,t={env:r,execArgv:a?["-e","delete process.env.ELECTRON_RUN_AS_NODE;require(process.argv[1])"]:[],silent:!0};n.cwd&&(t.cwd=n.cwd);const s=C.fork(i[0],i.slice(1),t);if(!s.pid)throw new Error(g.localize(2,null,i[0]));this.x=s}else throw new Error(g.localize(3,null));else{const a={env:r};n.cwd&&(a.cwd=n.cwd),this.x=C.spawn(o,i,a)}this.x.on("error",a=>{this.m.fire(a)}),this.x.on("exit",(a,t)=>{this.n.fire(a)}),this.x.stdout.on("close",()=>{this.m.fire(new Error("read error"))}),this.x.stdout.on("error",a=>{this.m.fire(a)}),this.x.stdin.on("error",a=>{this.m.fire(a)}),this.x.stderr.resume(),this.v(this.x.stdout,this.x.stdin)}catch(r){this.m.fire(r)}}async stopSession(){return this.x?(await this.u(),M.$i?new Promise((o,i)=>{const n=C.exec(`taskkill /F /T /PID ${this.x.pid}`,function(r,a,t){if(r)return i(r)});n.on("exit",o),n.on("error",i)}):(this.x.kill("SIGTERM"),Promise.resolve(void 0))):Promise.resolve(void 0)}static A(o,i){if(!o)return;const n=Object.create(null);o.runtime&&(o.runtime.indexOf("./")===0?n.runtime=L.$ic(i,o.runtime):n.runtime=o.runtime),o.runtimeArgs&&(n.runtimeArgs=o.runtimeArgs),o.program&&(L.$hc(o.program)?n.program=o.program:n.program=L.$ic(i,o.program)),o.args&&(n.args=o.args);const r=o;return r.win&&(n.win=w.A(r.win,i)),r.winx86&&(n.winx86=w.A(r.winx86,i)),r.windows&&(n.windows=w.A(r.windows,i)),r.osx&&(n.osx=w.A(r.osx,i)),r.linux&&(n.linux=w.A(r.linux,i)),n}static platformAdapterExecutable(o,i){let n=Object.create(null);i=i.toLowerCase();for(const c of o)if(c.contributes){const l=c.contributes.debuggers;l&&l.length>0&&l.filter(h=>typeof h.type=="string"&&b.$6e(h.type,i)).forEach(h=>{const E=w.A(h,c.extensionLocation.fsPath);n=f.$dn(n,E,c.isBuiltin)})}let r;M.$i&&!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432")?r=n.winx86||n.win||n.windows:M.$i?r=n.win||n.windows:M.$j?r=n.osx:M.$k&&(r=n.linux),r=r||n;const a=r.program||n.program,t=r.args||n.args,s=r.runtime||n.runtime,d=r.runtimeArgs||n.runtimeArgs;if(s)return{type:"executable",command:s,args:(d||[]).concat(typeof a=="string"?[a]:[]).concat(t||[])};if(a)return{type:"executable",command:a,args:t||[]}}}e.$Xfc=w}),define(ke[284],Se([1,0,50,33,11]),function(me,e,C,F,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zfc=e.$Yfc=void 0;function L(g,A){return new Promise((I,$)=>{let y="";const k=C.spawn(g,A);k.pid&&k.stdout.on("data",w=>{y+=w.toString()}),k.on("error",w=>{$(w)}),k.on("close",w=>{I(y)})})}async function M(g){if(g)if(f.$i){const A=await new Promise((I,$)=>{me(["@vscode/windows-process-tree"],I,$)});return new Promise(I=>{A.getProcessTree(g,$=>{I(!!$&&$.children.length>0)})})}else return L("/usr/bin/pgrep",["-lP",String(g)]).then(A=>{const I=A.trim();return!(I.length===0||I.indexOf(" tmux")>=0)},A=>!0);return Promise.resolve(!0)}e.$Yfc=M;var b;(function(g){g[g.cmd=0]="cmd",g[g.powershell=1]="powershell",g[g.bash=2]="bash"})(b||(b={}));function v(g,A,I,$,y){g=g.trim().toLowerCase();let k;g.indexOf("powershell")>=0||g.indexOf("pwsh")>=0?k=1:g.indexOf("cmd.exe")>=0?k=0:g.indexOf("bash")>=0?k=2:f.$i?k=0:k=2;let w,u=" ";switch(k){case 1:if(w=o=>(o=o.replace(/\'/g,"''"),o.length>0&&o.charAt(o.length-1)==="\\"?`'${o}\\'`:`'${o}'`),$){const o=(0,F.$7f)($);o&&(u+=`${o}:; `),u+=`cd ${w($)}; `}if(y)for(const o in y){const i=y[o];i===null?u+=`Remove-Item env:${o}; `:u+=`\${env:${o}}='${i}'; `}if(A.length>0){const o=A.shift(),i=I?o:w(o);u+=i[0]==="'"?`& ${i} `:`${i} `;for(const n of A)u+=n==="<"||n===">"||I?n:w(n),u+=" "}break;case 0:if(w=o=>(o=o.replace(/\"/g,'""'),o=o.replace(/([><!^&|])/g,"^$1"),' "'.split("").some(i=>o.includes(i))||o.length===0?`"${o}"`:o),$){const o=(0,F.$7f)($);o&&(u+=`${o}: && `),u+=`cd ${w($)} && `}if(y){u+='cmd /C "';for(const o in y){let i=y[o];i===null?u+=`set "${o}=" && `:(i=i.replace(/[&^|<>]/g,n=>`^${n}`),u+=`set "${o}=${i}" && `)}}for(const o of A)u+=o==="<"||o===">"||I?o:w(o),u+=" ";y&&(u+='"');break;case 2:{w=i=>(i=i.replace(/(["'\\\$!><#()\[\]*&^| ;{}`])/g,"\\$1"),i.length===0?'""':i);const o=i=>/[^\w@%\/+=,.:^-]/.test(i)?`'${i.replace(/'/g,"'\\''")}'`:i;if($&&(u+=`cd ${w($)} ; `),y){u+="/usr/bin/env";for(const i in y){const n=y[i];n===null?u+=` -u ${o(i)}`:u+=` ${o(`${i}=${n}`)}`}u+=" "}for(const i of A)u+=i==="<"||i===">"||I?i:w(i),u+=" ";break}}return u}e.$Zfc=v}),define(ke[111],Se([1,0,22,34,51,100,17,16,11,45]),function(me,e,C,F,f,L,M,b,v,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$DI=e.$CI=e.$BI=e.$AI=e.CellStatusbarAlignment=e.$zI=e.$yI=e.$xI=e.NotebookEditorPriority=e.$wI=e.$vI=e.$uI=e.$tI=e.CellUri=e.CellEditType=e.SelectionStateType=e.NotebookCellsChangeType=e.RendererMessagingSpec=e.NotebookRendererMatch=e.NotebookExecutionState=e.NotebookCellExecutionState=e.NotebookRunState=e.$sI=e.$rI=e.$qI=e.$pI=e.CellKind=e.$oI=e.$nI=e.$mI=void 0,e.$mI="workbench.editor.notebook",e.$nI="workbench.editor.notebookTextDiffEditor",e.$oI="workbench.editor.interactive";var A;(function(O){O[O.Markup=1]="Markup",O[O.Code=2]="Code"})(A||(e.CellKind=A={})),e.$pI=["application/json","application/javascript","text/html","image/svg+xml",L.$Vr.latex,L.$Vr.markdown,"image/png","image/jpeg",L.$Vr.text],e.$qI=[L.$Vr.latex,L.$Vr.markdown,"application/json","text/html","image/svg+xml","image/png","image/jpeg",L.$Vr.text],e.$rI=new Map([["ms-toolsai.jupyter",new Set(["jupyter-notebook","interactive"])],["ms-toolsai.jupyter-renderers",new Set(["jupyter-notebook","interactive"])]]),e.$sI="_notAvailable";var I;(function(O){O[O.Running=1]="Running",O[O.Idle=2]="Idle"})(I||(e.NotebookRunState=I={}));var $;(function(O){O[O.Unconfirmed=1]="Unconfirmed",O[O.Pending=2]="Pending",O[O.Executing=3]="Executing"})($||(e.NotebookCellExecutionState=$={}));var y;(function(O){O[O.Unconfirmed=1]="Unconfirmed",O[O.Pending=2]="Pending",O[O.Executing=3]="Executing"})(y||(e.NotebookExecutionState=y={}));var k;(function(O){O[O.WithHardKernelDependency=0]="WithHardKernelDependency",O[O.WithOptionalKernelDependency=1]="WithOptionalKernelDependency",O[O.Pure=2]="Pure",O[O.Never=3]="Never"})(k||(e.NotebookRendererMatch=k={}));var w;(function(O){O.Always="always",O.Never="never",O.Optional="optional"})(w||(e.RendererMessagingSpec=w={}));var u;(function(O){O[O.ModelChange=1]="ModelChange",O[O.Move=2]="Move",O[O.ChangeCellLanguage=5]="ChangeCellLanguage",O[O.Initialize=6]="Initialize",O[O.ChangeCellMetadata=7]="ChangeCellMetadata",O[O.Output=8]="Output",O[O.OutputItem=9]="OutputItem",O[O.ChangeCellContent=10]="ChangeCellContent",O[O.ChangeDocumentMetadata=11]="ChangeDocumentMetadata",O[O.ChangeCellInternalMetadata=12]="ChangeCellInternalMetadata",O[O.ChangeCellMime=13]="ChangeCellMime",O[O.Unknown=100]="Unknown"})(u||(e.NotebookCellsChangeType=u={}));var o;(function(O){O[O.Handle=0]="Handle",O[O.Index=1]="Index"})(o||(e.SelectionStateType=o={}));var i;(function(O){O[O.Replace=1]="Replace",O[O.Output=2]="Output",O[O.Metadata=3]="Metadata",O[O.CellLanguage=4]="CellLanguage",O[O.DocumentMetadata=5]="DocumentMetadata",O[O.Move=6]="Move",O[O.OutputItems=7]="OutputItems",O[O.PartialMetadata=8]="PartialMetadata",O[O.PartialInternalMetadata=9]="PartialInternalMetadata"})(i||(e.CellEditType=i={}));var n;(function(O){O.scheme=M.Schemas.vscodeNotebookCell;const W=["W","X","Y","Z","a","b","c","d","e","f"],x=new RegExp(`^[${W.join("")}]+`),le=7;function G(he,q){const U=q.toString(le),be=`${U.length<W.length?W[U.length-1]:"z"}${U}s${(0,C.$ze)(C.$fe.fromString(he.scheme),!0,!0)}`;return he.with({scheme:O.scheme,fragment:be})}O.generate=G;function J(he){if(he.scheme!==O.scheme)return;const q=he.fragment.indexOf("s");if(q<0)return;const U=parseInt(he.fragment.substring(0,q).replace(x,""),le),ie=(0,C.$ye)(he.fragment.substring(q+1)).toString();if(!isNaN(U))return{handle:U,notebook:he.with({scheme:ie,fragment:null})}}O.parse=J;function Q(he,q){return he.with({scheme:M.Schemas.vscodeNotebookCellOutput,fragment:`op${q??""},${he.scheme!==M.Schemas.file?he.scheme:""}`})}O.generateCellOutputUri=Q;function oe(he){if(he.scheme!==M.Schemas.vscodeNotebookCellOutput)return;const q=/^op([0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12})?\,(.*)$/i.exec(he.fragment);if(!q)return;const U=q[1]&&q[1]!==""?q[1]:void 0,ie=q[2];return{outputId:U,notebook:he.with({scheme:ie||M.Schemas.file,fragment:null})}}O.parseCellOutputUri=oe;function _(he,q,U){return O.generate(he,q).with({scheme:U})}O.generateCellPropertyUri=_;function Ee(he,q){if(he.scheme===q)return O.parse(he.with({scheme:O.scheme}))}O.parseCellPropertyUri=Ee})(n||(e.CellUri=n={}));const r=O=>v.$i?O.replace(/\//g,"\\"):O;class a{constructor(W=[],x=e.$pI){this.e=x,this.d=[...new Set(W)].map(le=>({pattern:le,matches:F.$Cj(r(le))}))}sort(W){const x=new Map(f.Iterable.map(W,G=>[G,r(G)]));let le=[];for(const{matches:G}of this.d)for(const[J,Q]of x)if(G(Q)){le.push(J),x.delete(J);break}return x.size&&(le=le.concat([...x.keys()].sort((G,J)=>this.e.indexOf(G)-this.e.indexOf(J)))),le}prioritize(W,x){const le=this.f(W);if(le===-1){this.d.unshift({pattern:W,matches:F.$Cj(r(W))});return}const G=new Set(x.map(Q=>this.f(Q,le)));G.delete(-1);const J=Array.from(G).sort();this.d.splice(le+1,0,...J.map(Q=>this.d[Q]));for(let Q=J.length-1;Q>=0;Q--)this.d.splice(J[Q],1)}toArray(){return this.d.map(W=>W.pattern)}f(W,x=this.d.length){const le=r(W);for(let G=0;G<x;G++)if(this.d[G].matches(le))return G;return-1}}e.$tI=a;function t(O,W,x,le=(G,J)=>G===J){const G=[];function J(_,Ee,he){if(Ee===0&&he.length===0)return;const q=G[G.length-1];q&&q.start+q.deleteCount===_?(q.deleteCount+=Ee,q.toInsert.push(...he)):G.push({start:_,deleteCount:Ee,toInsert:he})}let Q=0,oe=0;for(;;){if(Q===O.length){J(Q,0,W.slice(oe));break}if(oe===W.length){J(Q,O.length-Q,[]);break}const _=O[Q],Ee=W[oe];if(le(_,Ee)){Q+=1,oe+=1;continue}x(Ee)?(J(Q,1,[]),Q+=1):(J(Q,0,[Ee]),oe+=1)}return G}e.$uI=t,e.$vI=new g.$aj("notebookEditorCursorAtBoundary","none"),e.$wI=new g.$aj("notebookEditorCursorAtLineBoundary","none");var s;(function(O){O.default="default",O.option="option"})(s||(e.NotebookEditorPriority=s={}));function d(O){const W=O;return!!((typeof W.include=="string"||F.$Dj(W.include))&&(typeof W.exclude=="string"||F.$Dj(W.exclude)))}e.$xI=d;function c(O,W,x){if(Array.isArray(O.viewType)&&O.viewType.indexOf(W)>=0||O.viewType===W)return!0;if(O.filenamePattern){const le=d(O.filenamePattern)?O.filenamePattern.include:O.filenamePattern,G=d(O.filenamePattern)?O.filenamePattern.exclude:void 0;if(F.$Bj(le,(0,b.$mc)(x.fsPath).toLowerCase()))return!(G&&F.$Bj(G,(0,b.$mc)(x.fsPath).toLowerCase()))}return!1}e.$yI=c,e.$zI={displayOrder:"notebook.displayOrder",cellToolbarLocation:"notebook.cellToolbarLocation",cellToolbarVisibility:"notebook.cellToolbarVisibility",showCellStatusBar:"notebook.showCellStatusBar",textDiffEditorPreview:"notebook.diff.enablePreview",diffOverviewRuler:"notebook.diff.overviewRuler",experimentalInsertToolbarAlignment:"notebook.experimental.insertToolbarAlignment",compactView:"notebook.compactView",focusIndicator:"notebook.cellFocusIndicator",insertToolbarLocation:"notebook.insertToolbarLocation",globalToolbar:"notebook.globalToolbar",stickyScroll:"notebook.stickyScroll.enabled",undoRedoPerCell:"notebook.undoRedoPerCell",consolidatedOutputButton:"notebook.consolidatedOutputButton",showFoldingControls:"notebook.showFoldingControls",dragAndDropEnabled:"notebook.dragAndDropEnabled",cellEditorOptionsCustomizations:"notebook.editorOptionsCustomizations",consolidatedRunButton:"notebook.consolidatedRunButton",openGettingStarted:"notebook.experimental.openGettingStarted",globalToolbarShowLabel:"notebook.globalToolbarShowLabel",markupFontSize:"notebook.markup.fontSize",interactiveWindowCollapseCodeCells:"interactiveWindow.collapseCellInputCode",outputScrollingDeprecated:"notebook.experimental.outputScrolling",outputScrolling:"notebook.output.scrolling",textOutputLineLimit:"notebook.output.textLineLimit",formatOnSave:"notebook.formatOnSave.enabled",insertFinalNewline:"notebook.insertFinalNewline",formatOnCellExecution:"notebook.formatOnCellExecution",codeActionsOnSave:"notebook.codeActionsOnSave",outputWordWrap:"notebook.output.wordWrap",outputLineHeightDeprecated:"notebook.outputLineHeight",outputLineHeight:"notebook.output.lineHeight",outputFontSizeDeprecated:"notebook.outputFontSize",outputFontSize:"notebook.output.fontSize",outputFontFamilyDeprecated:"notebook.outputFontFamily",outputFontFamily:"notebook.output.fontFamily",findScope:"notebook.find.scope",logging:"notebook.logging",confirmDeleteRunningCell:"notebook.confirmDeleteRunningCell",remoteSaving:"notebook.experimental.remoteSave",gotoSymbolsAllSymbols:"notebook.gotoSymbols.showAllSymbols",scrollToRevealCell:"notebook.scrolling.revealNextCellOnExecute",anchorToFocusedCell:"notebook.scrolling.experimental.anchorToFocusedCell"};var l;(function(O){O[O.Left=1]="Left",O[O.Right=2]="Right"})(l||(e.CellStatusbarAlignment=l={}));class h{static{this.d="notebook/"}static create(W){return`${h.d}${W}`}static parse(W){if(W.startsWith(h.d))return W.substring(h.d.length)}}e.$AI=h;function E(O){return["application/vnd.code.notebook.stdout","application/vnd.code.notebook.stderr"].includes(O)}e.$BI=E;const D=new TextDecoder;function m(O){const W=[];let x=!1;for(const Q of O)(W.length===0||x)&&(W.push(Q),x=!0);let le=P(W);const G=C.$fe.concat(W.map(Q=>C.$fe.wrap(Q))),J=N(G);return le=le||J.byteLength!==G.byteLength,{data:J,didCompression:le}}e.$CI=m,e.$DI=`${String.fromCharCode(27)}[A`;const p=e.$DI.split("").map(O=>O.charCodeAt(0)),S=10;function P(O){let W=!1;return O.forEach((x,le)=>{if(le===0||x.length<e.$DI.length)return;const G=O[le-1],J=x.subarray(0,e.$DI.length);if(J[0]===p[0]&&J[1]===p[1]&&J[2]===p[2]){const Q=G.lastIndexOf(S);if(Q===-1)return;W=!0,O[le-1]=G.subarray(0,Q),O[le]=x.subarray(e.$DI.length)}}),W}function z(O){let W=O;do O=W,W=O.replace(/[^\n]\x08/gm,"");while(W.length<O.length);return O}function j(O){for(O=O.replace(/\r+\n/gm,`
`);O.search(/\r[^$]/g)>-1;){const W=O.match(/^(.*)\r+/m)[1];let x=O.match(/\r+(.*)$/m)[1];x=x+W.slice(x.length,W.length),O=O.replace(/\r+.*$/m,"\r").replace(/^.*\r/m,x)}return O}const R="\b".charCodeAt(0),T="\r".charCodeAt(0);function N(O){return!O.buffer.includes(R)&&!O.buffer.includes(T)?O:C.$fe.fromString(j(z(D.decode(O.buffer))))}}),define(ke[7],Se([1,0,19,8,80,28,100,13,18,2,32,26,31,64,111]),function(me,e,C,F,f,L,M,b,v,g,A,I,$,y,k){"use strict";var w,u,o,i,n,r,a,t,s,d,c,l,h,E,D,m,p,S;Object.defineProperty(e,"__esModule",{value:!0}),e.SpeechToTextStatus=e.RelatedInformationType=e.ChatAgentResultFeedbackKind=e.$oM=e.ChatVariableLevel=e.ChatMessageRole=e.InteractiveEditorResponseFeedbackKind=e.InteractiveSessionCopyKind=e.InteractiveSessionVoteDirection=e.$nM=e.$mM=e.$lM=e.$kM=e.$jM=e.$iM=e.$hM=e.$gM=e.$fM=e.$eM=e.$dM=e.PortAutoForwardAction=e.WorkspaceTrustState=e.ExternalUriOpenerPriority=e.$cM=e.$bM=e.$aM=e.$_L=e.$$L=e.$0L=e.$9L=e.$8L=e.TestRunProfileKind=e.TestResultState=e.$7L=e.$6L=e.StandardTokenType=e.ExtensionRuntime=e.ExtensionMode=e.$5L=e.$4L=e.$3L=e.NotebookControllerAffinity2=e.NotebookControllerAffinity=e.$2L=e.NotebookEditorRevealType=e.NotebookCellStatusBarAlignment=e.NotebookCellExecutionState=e.NotebookCellKind=e.$1L=e.$ZL=e.$YL=e.$XL=e.$WL=e.ColorThemeKind=e.$VL=e.$UL=e.ExtensionKind=e.InputBoxValidationSeverity=e.QuickPickItemKind=e.$TL=e.DebugConsoleMode=e.$SL=e.$RL=e.$QL=e.$PL=e.$OL=e.CommentThreadState=e.CommentState=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.$NL=e.$ML=e.FileChangeType=e.$LL=e.$KL=e.$JL=e.$IL=e.InlineCompletionTriggerKind=e.$HL=e.$GL=e.$FL=e.$EL=e.$DL=e.$CL=e.$BL=e.$AL=e.$zL=e.$yL=e.$xL=e.$wL=e.$vL=e.ConfigurationTarget=e.$uL=e.$tL=e.$sL=e.$rL=e.$qL=e.$pL=e.$oL=e.$nL=e.$mL=e.TreeItemCheckboxState=e.TreeItemCollapsibleState=e.$lL=e.ViewBadge=e.ProgressLocation=e.$kL=e.$jL=e.TaskScope=e.ShellQuoting=e.$iL=e.$hL=e.$gL=e.TaskPanelKind=e.TaskRevealKind=e.$fL=e.TerminalLocation=e.$eL=e.$dL=e.$cL=e.TerminalExitReason=e.SourceControlInputBoxValidationType=e.ColorFormat=e.$bL=e.$aL=e.$_K=e.$$K=e.SyntaxTokenType=e.DecorationRangeBehavior=e.TextDocumentChangeReason=e.TextEditorSelectionChangeKind=e.TextEditorRevealType=e.TextDocumentSaveReason=e.TextEditorLineNumbersStyle=e.$0K=e.StatusBarAlignment=e.ViewColumn=e.$9K=e.$8K=e.$7K=e.$6K=e.CompletionItemTag=e.CompletionItemKind=e.CompletionTriggerKind=e.$5K=e.$4K=e.InlayHintKind=e.SignatureHelpTriggerKind=e.$3K=e.$2K=e.$1K=e.$ZK=e.$YK=e.LanguageStatusSeverity=e.$XK=e.$WK=e.$VK=e.$UK=e.$TK=e.$SK=e.CodeActionTriggerKind=e.$RK=e.$QK=e.SymbolTag=e.SymbolKind=e.$PK=e.DocumentHighlightKind=e.$OK=e.$NK=e.$MK=e.$LK=e.DiagnosticSeverity=e.DiagnosticTag=e.$KK=e.$JK=e.FileEditType=e.$IK=e.$HK=e.$GK=e.EnvironmentVariableMutatorType=e.EndOfLine=e.$FK=e.$EK=e.$DK=e.$CK=e.$BK=e.$AK=e.$zK=e.TerminalQuickFixType=e.TerminalOutputAnchor=void 0;function P(K){return Object.assign(K,{apply:function(...ve){if(ve.length===0)return Reflect.construct(K,[]);{const Re=ve.length===1?[]:ve[1];return Reflect.construct(K,Re,ve[0].constructor)}},call:function(...ve){if(ve.length===0)return Reflect.construct(K,[]);{const[Re,...Xe]=ve;return Reflect.construct(K,Xe,Re.constructor)}}})}var z;(function(K){K[K.Top=0]="Top",K[K.Bottom=1]="Bottom"})(z||(e.TerminalOutputAnchor=z={}));var j;(function(K){K[K.TerminalCommand=0]="TerminalCommand",K[K.Opener=1]="Opener",K[K.Command=3]="Command"})(j||(e.TerminalQuickFixType=j={}));let R=w=class{static from(...V){let ve=V;return new w(function(){if(ve){for(const Re of ve)Re&&typeof Re.dispose=="function"&&Re.dispose();ve=void 0}})}#e;constructor(V){this.#e=V}dispose(){typeof this.#e=="function"&&(this.#e(),this.#e=void 0)}};e.$zK=R,e.$zK=R=w=He([P],R);let T=u=class{static Min(...V){if(V.length===0)throw new TypeError;let ve=V[0];for(let Re=1;Re<V.length;Re++){const Xe=V[Re];Xe.isBefore(ve)&&(ve=Xe)}return ve}static Max(...V){if(V.length===0)throw new TypeError;let ve=V[0];for(let Re=1;Re<V.length;Re++){const Xe=V[Re];Xe.isAfter(ve)&&(ve=Xe)}return ve}static isPosition(V){if(!V)return!1;if(V instanceof u)return!0;const{line:ve,character:Re}=V;return typeof ve=="number"&&typeof Re=="number"}static of(V){if(V instanceof u)return V;if(this.isPosition(V))return new u(V.line,V.character);throw new Error("Invalid argument, is NOT a position-like object")}get line(){return this.c}get character(){return this.e}constructor(V,ve){if(V<0)throw(0,F.$6)("line must be non-negative");if(ve<0)throw(0,F.$6)("character must be non-negative");this.c=V,this.e=ve}isBefore(V){return this.c<V.c?!0:V.c<this.c?!1:this.e<V.e}isBeforeOrEqual(V){return this.c<V.c?!0:V.c<this.c?!1:this.e<=V.e}isAfter(V){return!this.isBeforeOrEqual(V)}isAfterOrEqual(V){return!this.isBefore(V)}isEqual(V){return this.c===V.c&&this.e===V.e}compareTo(V){return this.c<V.c?-1:this.c>V.line?1:this.e<V.e?-1:this.e>V.e?1:0}translate(V,ve=0){if(V===null||ve===null)throw(0,F.$6)();let Re;return typeof V>"u"?Re=0:typeof V=="number"?Re=V:(Re=typeof V.lineDelta=="number"?V.lineDelta:0,ve=typeof V.characterDelta=="number"?V.characterDelta:0),Re===0&&ve===0?this:new u(this.line+Re,this.character+ve)}with(V,ve=this.character){if(V===null||ve===null)throw(0,F.$6)();let Re;return typeof V>"u"?Re=this.line:typeof V=="number"?Re=V:(Re=typeof V.line=="number"?V.line:this.line,ve=typeof V.character=="number"?V.character:this.character),Re===this.line&&ve===this.character?this:new u(Re,ve)}toJSON(){return{line:this.line,character:this.character}}};e.$AK=T,e.$AK=T=u=He([P],T);let N=o=class{static isRange(V){return V instanceof o?!0:V?T.isPosition(V.start)&&T.isPosition(V.end):!1}static of(V){if(V instanceof o)return V;if(this.isRange(V))return new o(V.start,V.end);throw new Error("Invalid argument, is NOT a range-like object")}get start(){return this.c}get end(){return this.e}constructor(V,ve,Re,Xe){let it,ct;if(typeof V=="number"&&typeof ve=="number"&&typeof Re=="number"&&typeof Xe=="number"?(it=new T(V,ve),ct=new T(Re,Xe)):T.isPosition(V)&&T.isPosition(ve)&&(it=T.of(V),ct=T.of(ve)),!it||!ct)throw new Error("Invalid arguments");it.isBefore(ct)?(this.c=it,this.e=ct):(this.c=ct,this.e=it)}contains(V){return o.isRange(V)?this.contains(V.start)&&this.contains(V.end):T.isPosition(V)?!(T.of(V).isBefore(this.c)||this.e.isBefore(V)):!1}isEqual(V){return this.c.isEqual(V.c)&&this.e.isEqual(V.e)}intersection(V){const ve=T.Max(V.start,this.c),Re=T.Min(V.end,this.e);if(!ve.isAfter(Re))return new o(ve,Re)}union(V){if(this.contains(V))return this;if(V.contains(this))return V;const ve=T.Min(V.start,this.c),Re=T.Max(V.end,this.end);return new o(ve,Re)}get isEmpty(){return this.c.isEqual(this.e)}get isSingleLine(){return this.c.line===this.e.line}with(V,ve=this.end){if(V===null||ve===null)throw(0,F.$6)();let Re;return V?T.isPosition(V)?Re=V:(Re=V.start||this.start,ve=V.end||this.end):Re=this.start,Re.isEqual(this.c)&&ve.isEqual(this.end)?this:new o(Re,ve)}toJSON(){return[this.start,this.end]}};e.$BK=N,e.$BK=N=o=He([P],N);let O=i=class extends N{static isSelection(V){return V instanceof i?!0:V?N.isRange(V)&&T.isPosition(V.anchor)&&T.isPosition(V.active)&&typeof V.isReversed=="boolean":!1}get anchor(){return this.f}get active(){return this.g}constructor(V,ve,Re,Xe){let it,ct;if(typeof V=="number"&&typeof ve=="number"&&typeof Re=="number"&&typeof Xe=="number"?(it=new T(V,ve),ct=new T(Re,Xe)):T.isPosition(V)&&T.isPosition(ve)&&(it=T.of(V),ct=T.of(ve)),!it||!ct)throw new Error("Invalid arguments");super(it,ct),this.f=it,this.g=ct}get isReversed(){return this.f===this.e}toJSON(){return{start:this.start,end:this.end,active:this.active,anchor:this.anchor}}};e.$CK=O,e.$CK=O=i=He([P],O);const W=K=>{if(typeof K!="string"||K.length===0||!/^[0-9A-Za-z_\-]+$/.test(K))throw(0,F.$6)("connectionToken")};class x{static isResolvedAuthority(V){return V&&typeof V=="object"&&typeof V.host=="string"&&typeof V.port=="number"&&(V.connectionToken===void 0||typeof V.connectionToken=="string")}constructor(V,ve,Re){if(typeof V!="string"||V.length===0)throw(0,F.$6)("host");if(typeof ve!="number"||ve===0||Math.round(ve)!==ve)throw(0,F.$6)("port");typeof Re<"u"&&W(Re),this.host=V,this.port=Math.round(ve),this.connectionToken=Re}}e.$DK=x;class le{static isManagedResolvedAuthority(V){return V&&typeof V=="object"&&typeof V.makeConnection=="function"&&(V.connectionToken===void 0||typeof V.connectionToken=="string")}constructor(V,ve){this.makeConnection=V,this.connectionToken=ve,typeof ve<"u"&&W(ve)}}e.$EK=le;class G extends Error{static NotAvailable(V,ve){return new G(V,y.RemoteAuthorityResolverErrorCode.NotAvailable,ve)}static TemporarilyNotAvailable(V){return new G(V,y.RemoteAuthorityResolverErrorCode.TemporarilyNotAvailable)}constructor(V,ve=y.RemoteAuthorityResolverErrorCode.Unknown,Re){super(V),this._message=V,this._code=ve,this._detail=Re,Object.setPrototypeOf(this,G.prototype)}}e.$FK=G;var J;(function(K){K[K.LF=1]="LF",K[K.CRLF=2]="CRLF"})(J||(e.EndOfLine=J={}));var Q;(function(K){K[K.Replace=1]="Replace",K[K.Append=2]="Append",K[K.Prepend=3]="Prepend"})(Q||(e.EnvironmentVariableMutatorType=Q={}));let oe=n=class{static isTextEdit(V){return V instanceof n?!0:V?N.isRange(V)&&typeof V.newText=="string":!1}static replace(V,ve){return new n(V,ve)}static insert(V,ve){return n.replace(new N(V,V),ve)}static delete(V){return n.replace(V,"")}static setEndOfLine(V){const ve=new n(new N(new T(0,0),new T(0,0)),"");return ve.newEol=V,ve}get range(){return this.c}set range(V){if(V&&!N.isRange(V))throw(0,F.$6)("range");this.c=V}get newText(){return this.e||""}set newText(V){if(V&&typeof V!="string")throw(0,F.$6)("newText");this.e=V}get newEol(){return this.f}set newEol(V){if(V&&typeof V!="number")throw(0,F.$6)("newEol");this.f=V}constructor(V,ve){this.c=V,this.e=ve}toJSON(){return{range:this.range,newText:this.newText,newEol:this.f}}};e.$GK=oe,e.$GK=oe=n=He([P],oe);let _=r=class{static isNotebookCellEdit(V){return V instanceof r?!0:V?_t.isNotebookRange(V)&&Array.isArray(V.newCells):!1}static replaceCells(V,ve){return new r(V,ve)}static insertCells(V,ve){return new r(new _t(V,V),ve)}static deleteCells(V){return new r(V,[])}static updateCellMetadata(V,ve){const Re=new r(new _t(V,V),[]);return Re.newCellMetadata=ve,Re}static updateNotebookMetadata(V){const ve=new r(new _t(0,0),[]);return ve.newNotebookMetadata=V,ve}constructor(V,ve){this.range=V,this.newCells=ve}};e.$HK=_,e.$HK=_=r=He([P],_);class Ee{static isSnippetTextEdit(V){return V instanceof Ee?!0:V?N.isRange(V.range)&&U.isSnippetString(V.snippet):!1}static replace(V,ve){return new Ee(V,ve)}static insert(V,ve){return Ee.replace(new N(V,V),ve)}constructor(V,ve){this.range=V,this.snippet=ve}}e.$IK=Ee;var he;(function(K){K[K.File=1]="File",K[K.Text=2]="Text",K[K.Cell=3]="Cell",K[K.CellReplace=5]="CellReplace",K[K.Snippet=6]="Snippet"})(he||(e.FileEditType=he={}));let q=class{constructor(){this.c=[]}_allEntries(){return this.c}renameFile(V,ve,Re,Xe){this.c.push({_type:1,from:V,to:ve,options:Re,metadata:Xe})}createFile(V,ve,Re){this.c.push({_type:1,from:void 0,to:V,options:ve,metadata:Re})}deleteFile(V,ve,Re){this.c.push({_type:1,from:V,to:void 0,options:ve,metadata:Re})}e(V,ve,Re){this.c.push({_type:3,metadata:Re,uri:V,edit:{editType:5,metadata:ve},notebookMetadata:ve})}f(V,ve,Re,Xe){const it=ve.start,ct=ve.end;(it!==ct||Re.length>0)&&this.c.push({_type:5,uri:V,index:it,count:ct-it,cells:Re,metadata:Xe})}g(V,ve,Re,Xe){this.c.push({_type:3,metadata:Xe,uri:V,edit:{editType:3,index:ve,metadata:Re}})}replace(V,ve,Re,Xe){this.c.push({_type:2,uri:V,edit:new oe(ve,Re),metadata:Xe})}insert(V,ve,Re,Xe){this.replace(V,new N(ve,ve),Re,Xe)}delete(V,ve,Re){this.replace(V,ve,"",Re)}has(V){return this.c.some(ve=>ve._type===2&&ve.uri.toString()===V.toString())}set(V,ve){if(ve)for(const Re of ve){if(!Re)continue;let Xe,it;Array.isArray(Re)?(Xe=Re[0],it=Re[1]):Xe=Re,_.isNotebookCellEdit(Xe)?Xe.newCellMetadata?this.g(V,Xe.range.start,Xe.newCellMetadata,it):Xe.newNotebookMetadata?this.e(V,Xe.newNotebookMetadata,it):this.f(V,Xe.range,Xe.newCells,it):Ee.isSnippetTextEdit(Xe)?this.c.push({_type:6,uri:V,range:Xe.range,edit:Xe.snippet,metadata:it}):this.c.push({_type:2,uri:V,edit:Xe,metadata:it})}else{for(let Re=0;Re<this.c.length;Re++){const Xe=this.c[Re];switch(Xe._type){case 2:case 6:case 3:case 5:Xe.uri.toString()===V.toString()&&(this.c[Re]=void 0);break}}(0,C.$Hb)(this.c)}}get(V){const ve=[];for(const Re of this.c)Re._type===2&&Re.uri.toString()===V.toString()&&ve.push(Re.edit);return ve}entries(){const V=new L.$zc;for(const ve of this.c)if(ve._type===2){let Re=V.get(ve.uri);Re||(Re=[ve.uri,[]],V.set(ve.uri,Re)),Re[1].push(ve.edit)}return[...V.values()]}get size(){return this.entries().length}toJSON(){return this.entries()}};e.$JK=q,e.$JK=q=He([P],q);let U=a=class{static isSnippetString(V){return V instanceof a?!0:V?typeof V.value=="string":!1}static c(V){return V.replace(/\$|}|\\/g,"\\$&")}constructor(V){this.e=1,this.value=V||""}appendText(V){return this.value+=a.c(V),this}appendTabstop(V=this.e++){return this.value+="$",this.value+=V,this}appendPlaceholder(V,ve=this.e++){if(typeof V=="function"){const Re=new a;Re.e=this.e,V(Re),this.e=Re.e,V=Re.value}else V=a.c(V);return this.value+="${",this.value+=ve,this.value+=":",this.value+=V,this.value+="}",this}appendChoice(V,ve=this.e++){const Re=V.map(Xe=>Xe.replace(/\$|}|\\|,/g,"\\$&")).join(",");return this.value+="${",this.value+=ve,this.value+="|",this.value+=Re,this.value+="|}",this}appendVariable(V,ve){if(typeof ve=="function"){const Re=new a;Re.e=this.e,ve(Re),this.e=Re.e,ve=Re.value}else typeof ve=="string"&&(ve=ve.replace(/\$|}/g,"\\$&"));return this.value+="${",this.value+=V,ve&&(this.value+=":",this.value+=ve),this.value+="}",this}};e.$KK=U,e.$KK=U=a=He([P],U);var ie;(function(K){K[K.Unnecessary=1]="Unnecessary",K[K.Deprecated=2]="Deprecated"})(ie||(e.DiagnosticTag=ie={}));var be;(function(K){K[K.Hint=3]="Hint",K[K.Information=2]="Information",K[K.Warning=1]="Warning",K[K.Error=0]="Error"})(be||(e.DiagnosticSeverity=be={}));let H=t=class{static isLocation(V){return V instanceof t?!0:V?N.isRange(V.range)&&g.URI.isUri(V.uri):!1}constructor(V,ve){if(this.uri=V,ve)if(N.isRange(ve))this.range=N.of(ve);else if(T.isPosition(ve))this.range=new N(ve,ve);else throw new Error("Illegal argument")}toJSON(){return{uri:this.uri,range:this.range}}};e.$LK=H,e.$LK=H=t=He([P],H);let Y=class{static is(V){return V?typeof V.message=="string"&&V.location&&N.isRange(V.location.range)&&g.URI.isUri(V.location.uri):!1}constructor(V,ve){this.location=V,this.message=ve}static isEqual(V,ve){return V===ve?!0:!V||!ve?!1:V.message===ve.message&&V.location.range.isEqual(ve.location.range)&&V.location.uri.toString()===ve.location.uri.toString()}};e.$MK=Y,e.$MK=Y=He([P],Y);let Z=class{constructor(V,ve,Re=be.Error){if(!N.isRange(V))throw new TypeError("range must be set");if(!ve)throw new TypeError("message must be set");this.range=V,this.message=ve,this.severity=Re}toJSON(){return{severity:be[this.severity],message:this.message,range:this.range,source:this.source,code:this.code}}static isEqual(V,ve){return V===ve?!0:!V||!ve?!1:V.message===ve.message&&V.severity===ve.severity&&V.code===ve.code&&V.severity===ve.severity&&V.source===ve.source&&V.range.isEqual(ve.range)&&(0,C.$tb)(V.tags,ve.tags)&&(0,C.$tb)(V.relatedInformation,ve.relatedInformation,Y.isEqual)}};e.$NK=Z,e.$NK=Z=He([P],Z);let $e=class{constructor(V,ve){if(!V)throw new Error("Illegal argument, contents must be defined");Array.isArray(V)?this.contents=V:this.contents=[V],this.range=ve}};e.$OK=$e,e.$OK=$e=He([P],$e);var ne;(function(K){K[K.Text=0]="Text",K[K.Read=1]="Read",K[K.Write=2]="Write"})(ne||(e.DocumentHighlightKind=ne={}));let fe=class{constructor(V,ve=ne.Text){this.range=V,this.kind=ve}toJSON(){return{range:this.range,kind:ne[this.kind]}}};e.$PK=fe,e.$PK=fe=He([P],fe);var te;(function(K){K[K.File=0]="File",K[K.Module=1]="Module",K[K.Namespace=2]="Namespace",K[K.Package=3]="Package",K[K.Class=4]="Class",K[K.Method=5]="Method",K[K.Property=6]="Property",K[K.Field=7]="Field",K[K.Constructor=8]="Constructor",K[K.Enum=9]="Enum",K[K.Interface=10]="Interface",K[K.Function=11]="Function",K[K.Variable=12]="Variable",K[K.Constant=13]="Constant",K[K.String=14]="String",K[K.Number=15]="Number",K[K.Boolean=16]="Boolean",K[K.Array=17]="Array",K[K.Object=18]="Object",K[K.Key=19]="Key",K[K.Null=20]="Null",K[K.EnumMember=21]="EnumMember",K[K.Struct=22]="Struct",K[K.Event=23]="Event",K[K.Operator=24]="Operator",K[K.TypeParameter=25]="TypeParameter"})(te||(e.SymbolKind=te={}));var de;(function(K){K[K.Deprecated=1]="Deprecated"})(de||(e.SymbolTag=de={}));let pe=s=class{static validate(V){if(!V.name)throw new Error("name must not be falsy")}constructor(V,ve,Re,Xe,it){this.name=V,this.kind=ve,this.containerName=it,typeof Re=="string"&&(this.containerName=Re),Xe instanceof H?this.location=Xe:Re instanceof N&&(this.location=new H(Xe,Re)),s.validate(this)}toJSON(){return{name:this.name,kind:te[this.kind],location:this.location,containerName:this.containerName}}};e.$QK=pe,e.$QK=pe=s=He([P],pe);let Pe=d=class{static validate(V){if(!V.name)throw new Error("name must not be falsy");if(!V.range.contains(V.selectionRange))throw new Error("selectionRange must be contained in fullRange");V.children?.forEach(d.validate)}constructor(V,ve,Re,Xe,it){this.name=V,this.detail=ve,this.kind=Re,this.range=Xe,this.selectionRange=it,this.children=[],d.validate(this)}};e.$RK=Pe,e.$RK=Pe=d=He([P],Pe);var B;(function(K){K[K.Invoke=1]="Invoke",K[K.Automatic=2]="Automatic"})(B||(e.CodeActionTriggerKind=B={}));let X=class{constructor(V,ve){this.title=V,this.kind=ve}};e.$SK=X,e.$SK=X=He([P],X);let re=class{static{c=this}static{this.c="."}constructor(V){this.value=V}append(V){return new c(this.value?this.value+c.c+V:V)}intersects(V){return this.contains(V)||V.contains(this)}contains(V){return this.value===V.value||V.value.startsWith(this.value+c.c)}};e.$TK=re,e.$TK=re=c=He([P],re),re.Empty=new re(""),re.QuickFix=re.Empty.append("quickfix"),re.Refactor=re.Empty.append("refactor"),re.RefactorExtract=re.Refactor.append("extract"),re.RefactorInline=re.Refactor.append("inline"),re.RefactorMove=re.Refactor.append("move"),re.RefactorRewrite=re.Refactor.append("rewrite"),re.Source=re.Empty.append("source"),re.SourceOrganizeImports=re.Source.append("organizeImports"),re.SourceFixAll=re.Source.append("fixAll"),re.Notebook=re.Empty.append("notebook");let ae=class{constructor(V,ve){if(this.range=V,this.parent=ve,ve&&!ve.range.contains(this.range))throw new Error("Invalid argument: parent must contain this range")}};e.$UK=ae,e.$UK=ae=He([P],ae);class ee{constructor(V,ve,Re,Xe,it,ct){this.kind=V,this.name=ve,this.detail=Re,this.uri=Xe,this.range=it,this.selectionRange=ct}}e.$VK=ee;class ge{constructor(V,ve){this.fromRanges=ve,this.from=V}}e.$WK=ge;class ye{constructor(V,ve){this.fromRanges=ve,this.to=V}}e.$XK=ye;var je;(function(K){K[K.Information=0]="Information",K[K.Warning=1]="Warning",K[K.Error=2]="Error"})(je||(e.LanguageStatusSeverity=je={}));let We=class{constructor(V,ve){this.range=V,this.command=ve}get isResolved(){return!!this.command}};e.$YK=We,e.$YK=We=He([P],We);let et=l=class{#e;static isMarkdownString(V){return V instanceof l?!0:V&&V.appendCodeblock&&V.appendMarkdown&&V.appendText&&V.value!==void 0}constructor(V,ve=!1){this.#e=new f.$9j(V,{supportThemeIcons:ve})}get value(){return this.#e.value}set value(V){this.#e.value=V}get isTrusted(){return this.#e.isTrusted}set isTrusted(V){this.#e.isTrusted=V}get supportThemeIcons(){return this.#e.supportThemeIcons}set supportThemeIcons(V){this.#e.supportThemeIcons=V}get supportHtml(){return this.#e.supportHtml}set supportHtml(V){this.#e.supportHtml=V}get baseUri(){return this.#e.baseUri}set baseUri(V){this.#e.baseUri=V}appendText(V){return this.#e.appendText(V),this}appendMarkdown(V){return this.#e.appendMarkdown(V),this}appendCodeblock(V,ve){return this.#e.appendCodeblock(ve??"",V),this}};e.$ZK=et,e.$ZK=et=l=He([P],et);let Ze=class{constructor(V,ve){this.label=V,this.documentation=ve}};e.$1K=Ze,e.$1K=Ze=He([P],Ze);let rt=class{constructor(V,ve){this.label=V,this.documentation=ve,this.parameters=[]}};e.$2K=rt,e.$2K=rt=He([P],rt);let nt=class{constructor(){this.activeSignature=0,this.activeParameter=0,this.signatures=[]}};e.$3K=nt,e.$3K=nt=He([P],nt);var Ae;(function(K){K[K.Invoke=1]="Invoke",K[K.TriggerCharacter=2]="TriggerCharacter",K[K.ContentChange=3]="ContentChange"})(Ae||(e.SignatureHelpTriggerKind=Ae={}));var Oe;(function(K){K[K.Type=1]="Type",K[K.Parameter=2]="Parameter"})(Oe||(e.InlayHintKind=Oe={}));let Ve=class{constructor(V){this.value=V}};e.$4K=Ve,e.$4K=Ve=He([P],Ve);let Le=class{constructor(V,ve,Re){this.position=V,this.label=ve,this.kind=Re}};e.$5K=Le,e.$5K=Le=He([P],Le);var Ye;(function(K){K[K.Invoke=0]="Invoke",K[K.TriggerCharacter=1]="TriggerCharacter",K[K.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(Ye||(e.CompletionTriggerKind=Ye={}));var ue;(function(K){K[K.Text=0]="Text",K[K.Method=1]="Method",K[K.Function=2]="Function",K[K.Constructor=3]="Constructor",K[K.Field=4]="Field",K[K.Variable=5]="Variable",K[K.Class=6]="Class",K[K.Interface=7]="Interface",K[K.Module=8]="Module",K[K.Property=9]="Property",K[K.Unit=10]="Unit",K[K.Value=11]="Value",K[K.Enum=12]="Enum",K[K.Keyword=13]="Keyword",K[K.Snippet=14]="Snippet",K[K.Color=15]="Color",K[K.File=16]="File",K[K.Reference=17]="Reference",K[K.Folder=18]="Folder",K[K.EnumMember=19]="EnumMember",K[K.Constant=20]="Constant",K[K.Struct=21]="Struct",K[K.Event=22]="Event",K[K.Operator=23]="Operator",K[K.TypeParameter=24]="TypeParameter",K[K.User=25]="User",K[K.Issue=26]="Issue"})(ue||(e.CompletionItemKind=ue={}));var ce;(function(K){K[K.Deprecated=1]="Deprecated"})(ce||(e.CompletionItemTag=ce={}));let Ie=class{constructor(V,ve){this.label=V,this.kind=ve}toJSON(){return{label:this.label,kind:this.kind&&ue[this.kind],detail:this.detail,documentation:this.documentation,sortText:this.sortText,filterText:this.filterText,preselect:this.preselect,insertText:this.insertText,textEdit:this.textEdit}}};e.$6K=Ie,e.$6K=Ie=He([P],Ie);let Ke=class{constructor(V=[],ve=!1){this.items=V,this.isIncomplete=ve}};e.$7K=Ke,e.$7K=Ke=He([P],Ke);let Ge=class{constructor(V,ve,Re){this.insertText=V,this.range=ve,this.command=Re}};e.$8K=Ge,e.$8K=Ge=He([P],Ge);let _e=class{constructor(V){this.commands=void 0,this.suppressSuggestions=void 0,this.items=V}};e.$9K=_e,e.$9K=_e=He([P],_e);var st;(function(K){K[K.Active=-1]="Active",K[K.Beside=-2]="Beside",K[K.One=1]="One",K[K.Two=2]="Two",K[K.Three=3]="Three",K[K.Four=4]="Four",K[K.Five=5]="Five",K[K.Six=6]="Six",K[K.Seven=7]="Seven",K[K.Eight=8]="Eight",K[K.Nine=9]="Nine"})(st||(e.ViewColumn=st={}));var lt;(function(K){K[K.Left=1]="Left",K[K.Right=2]="Right"})(lt||(e.StatusBarAlignment=lt={}));function wt(K,V){return`${I.$_l.toKey(K)}.${V}`}e.$0K=wt;var Ue;(function(K){K[K.Off=0]="Off",K[K.On=1]="On",K[K.Relative=2]="Relative"})(Ue||(e.TextEditorLineNumbersStyle=Ue={}));var Kt;(function(K){K[K.Manual=1]="Manual",K[K.AfterDelay=2]="AfterDelay",K[K.FocusOut=3]="FocusOut"})(Kt||(e.TextDocumentSaveReason=Kt={}));var Ht;(function(K){K[K.Default=0]="Default",K[K.InCenter=1]="InCenter",K[K.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",K[K.AtTop=3]="AtTop"})(Ht||(e.TextEditorRevealType=Ht={}));var Et;(function(K){K[K.Keyboard=1]="Keyboard",K[K.Mouse=2]="Mouse",K[K.Command=3]="Command"})(Et||(e.TextEditorSelectionChangeKind=Et={}));var Ut;(function(K){K[K.Undo=1]="Undo",K[K.Redo=2]="Redo"})(Ut||(e.TextDocumentChangeReason=Ut={}));var Nt;(function(K){K[K.OpenOpen=0]="OpenOpen",K[K.ClosedClosed=1]="ClosedClosed",K[K.OpenClosed=2]="OpenClosed",K[K.ClosedOpen=3]="ClosedOpen"})(Nt||(e.DecorationRangeBehavior=Nt={})),function(K){function V(ve){switch(ve){case"keyboard":return K.Keyboard;case"mouse":return K.Mouse;case"api":return K.Command}}K.fromValue=V}(Et||(e.TextEditorSelectionChangeKind=Et={}));var Gt;(function(K){K[K.Other=0]="Other",K[K.Comment=1]="Comment",K[K.String=2]="String",K[K.RegEx=3]="RegEx"})(Gt||(e.SyntaxTokenType=Gt={})),function(K){function V(ve){switch(ve){case K.Other:return"other";case K.Comment:return"comment";case K.String:return"string";case K.RegEx:return"regex"}return"other"}K.toString=V}(Gt||(e.SyntaxTokenType=Gt={}));let Bt=class{constructor(V,ve){if(ve&&!g.URI.isUri(ve))throw(0,F.$6)("target");if(!N.isRange(V)||V.isEmpty)throw(0,F.$6)("range");this.range=V,this.target=ve}};e.$$K=Bt,e.$$K=Bt=He([P],Bt);let Dt=class{constructor(V,ve,Re,Xe){this.red=V,this.green=ve,this.blue=Re,this.alpha=Xe}};e.$_K=Dt,e.$_K=Dt=He([P],Dt);let Mt=class{constructor(V,ve){if(ve&&!(ve instanceof Dt))throw(0,F.$6)("color");if(!N.isRange(V)||V.isEmpty)throw(0,F.$6)("range");this.range=V,this.color=ve}};e.$aL=Mt,e.$aL=Mt=He([P],Mt);let Wt=class{constructor(V){if(!V||typeof V!="string")throw(0,F.$6)("label");this.label=V}};e.$bL=Wt,e.$bL=Wt=He([P],Wt);var tt;(function(K){K[K.RGB=0]="RGB",K[K.HEX=1]="HEX",K[K.HSL=2]="HSL"})(tt||(e.ColorFormat=tt={}));var Vt;(function(K){K[K.Error=0]="Error",K[K.Warning=1]="Warning",K[K.Information=2]="Information"})(Vt||(e.SourceControlInputBoxValidationType=Vt={}));var qt;(function(K){K[K.Unknown=0]="Unknown",K[K.Shutdown=1]="Shutdown",K[K.Process=2]="Process",K[K.User=3]="User",K[K.Extension=4]="Extension"})(qt||(e.TerminalExitReason=qt={}));class ut{constructor(V,ve,Re){if(this.startIndex=V,this.length=ve,this.tooltip=Re,typeof V!="number"||V<0)throw(0,F.$6)("startIndex");if(typeof ve!="number"||ve<1)throw(0,F.$6)("length");if(Re!==void 0&&typeof Re!="string")throw(0,F.$6)("tooltip")}}e.$cL=ut;class mt{constructor(V){this.uri=V}}e.$dL=mt;class Ot{constructor(V){this.terminalCommand=V}}e.$eL=Ot;var Pt;(function(K){K[K.Panel=1]="Panel",K[K.Editor=2]="Editor"})(Pt||(e.TerminalLocation=Pt={}));class At{constructor(V){if(this.options=V,typeof V!="object")throw(0,F.$6)("options")}}e.$fL=At;var gt;(function(K){K[K.Always=1]="Always",K[K.Silent=2]="Silent",K[K.Never=3]="Never"})(gt||(e.TaskRevealKind=gt={}));var St;(function(K){K[K.Shared=1]="Shared",K[K.Dedicated=2]="Dedicated",K[K.New=3]="New"})(St||(e.TaskPanelKind=St={}));let Rt=class{static{h=this}static{this.Clean=new h("clean","Clean")}static{this.Build=new h("build","Build")}static{this.Rebuild=new h("rebuild","Rebuild")}static{this.Test=new h("test","Test")}static from(V){switch(V){case"clean":return h.Clean;case"build":return h.Build;case"rebuild":return h.Rebuild;case"test":return h.Test;default:return}}constructor(V,ve){if(this.label=ve,typeof V!="string"||typeof ve!="string")throw(0,F.$6)("name");this.c=V}get id(){return this.c}};e.$gL=Rt,e.$gL=Rt=h=He([P],Rt);function It(K){let V="";for(let ve=0;ve<K.length;ve++)V+=K[ve].replace(/,/g,",,")+",";return V}let Je=class{constructor(V,ve,Re){if(typeof V!="string")throw(0,F.$6)("process");this.e=[],this.c=V,ve!==void 0&&(Array.isArray(ve)?(this.e=ve,this.f=Re):this.f=ve)}get process(){return this.c}set process(V){if(typeof V!="string")throw(0,F.$6)("process");this.c=V}get args(){return this.e}set args(V){Array.isArray(V)||(V=[]),this.e=V}get options(){return this.f}set options(V){this.f=V}computeId(){const V=[];if(V.push("process"),this.c!==void 0&&V.push(this.c),this.e&&this.e.length>0)for(const ve of this.e)V.push(ve);return It(V)}};e.$hL=Je,e.$hL=Je=He([P],Je);let jt=class{constructor(V,ve,Re){if(this.f=[],Array.isArray(ve)){if(!V)throw(0,F.$6)("command can't be undefined or null");if(typeof V!="string"&&typeof V.value!="string")throw(0,F.$6)("command");this.e=V,this.f=ve,this.g=Re}else{if(typeof V!="string")throw(0,F.$6)("commandLine");this.c=V,this.g=ve}}get commandLine(){return this.c}set commandLine(V){if(typeof V!="string")throw(0,F.$6)("commandLine");this.c=V}get command(){return this.e?this.e:""}set command(V){if(typeof V!="string"&&typeof V.value!="string")throw(0,F.$6)("command");this.e=V}get args(){return this.f}set args(V){this.f=V||[]}get options(){return this.g}set options(V){this.g=V}computeId(){const V=[];if(V.push("shell"),this.c!==void 0&&V.push(this.c),this.e!==void 0&&V.push(typeof this.e=="string"?this.e:this.e.value),this.f&&this.f.length>0)for(const ve of this.f)V.push(typeof ve=="string"?ve:ve.value);return It(V)}};e.$iL=jt,e.$iL=jt=He([P],jt);var Jt;(function(K){K[K.Escape=1]="Escape",K[K.Strong=2]="Strong",K[K.Weak=3]="Weak"})(Jt||(e.ShellQuoting=Jt={}));var Me;(function(K){K[K.Global=1]="Global",K[K.Workspace=2]="Workspace"})(Me||(e.TaskScope=Me={}));class Fe{constructor(V){this.c=V}computeId(){return"customExecution"+(0,A.$ig)()}set callback(V){this.c=V}get callback(){return this.c}}e.$jL=Fe;let Ce=class{static{E=this}static{this.c="customExecution"}static{this.e="process"}static{this.f="shell"}static{this.g="$empty"}constructor(V,ve,Re,Xe,it,ct){this.j=!1,this.k=this.definition=V;let ft;typeof ve=="string"?(this.m=this.name=ve,this.t=this.source=Re,this.execution=Xe,ft=it,this.j=!0):ve===Me.Global||ve===Me.Workspace?(this.target=ve,this.m=this.name=Re,this.t=this.source=Xe,this.execution=it,ft=ct):(this.target=ve,this.m=this.name=Re,this.t=this.source=Xe,this.execution=it,ft=ct),typeof ft=="string"?(this.o=[ft],this.q=!0):Array.isArray(ft)?(this.o=ft,this.q=!0):(this.o=[],this.q=!1),this.r=!1,this.w=Object.create(null),this.x=Object.create(null)}get _id(){return this.h}set _id(V){this.h=V}get _deprecated(){return this.j}z(){this.h!==void 0&&(this.h=void 0,this.l=void 0,this.A())}A(){this.n instanceof Je?this.k={type:E.e,id:this.n.computeId()}:this.n instanceof jt?this.k={type:E.f,id:this.n.computeId()}:this.n instanceof Fe?this.k={type:E.c,id:this.n.computeId()}:this.k={type:E.g,id:(0,A.$ig)()}}get definition(){return this.k}set definition(V){if(V==null)throw(0,F.$6)("Kind can't be undefined or null");this.z(),this.k=V}get scope(){return this.l}set target(V){this.z(),this.l=V}get name(){return this.m}set name(V){if(typeof V!="string")throw(0,F.$6)("name");this.z(),this.m=V}get execution(){return this.n}set execution(V){V===null&&(V=void 0),this.z(),this.n=V;const ve=this.k.type;(E.g===ve||E.e===ve||E.f===ve||E.c===ve)&&this.A()}get problemMatchers(){return this.o}set problemMatchers(V){if(Array.isArray(V))this.z(),this.o=V,this.q=!0;else{this.z(),this.o=[],this.q=!1;return}}get hasDefinedMatchers(){return this.q}get isBackground(){return this.r}set isBackground(V){V!==!0&&V!==!1&&(V=!1),this.z(),this.r=V}get source(){return this.t}set source(V){if(typeof V!="string"||V.length===0)throw(0,F.$6)("source must be a string of length > 0");this.z(),this.t=V}get group(){return this.u}set group(V){V===null&&(V=void 0),this.z(),this.u=V}get detail(){return this.y}set detail(V){V===null&&(V=void 0),this.y=V}get presentationOptions(){return this.w}set presentationOptions(V){V==null&&(V=Object.create(null)),this.z(),this.w=V}get runOptions(){return this.x}set runOptions(V){V==null&&(V=Object.create(null)),this.z(),this.x=V}};e.$kL=Ce,e.$kL=Ce=E=He([P],Ce);var se;(function(K){K[K.SourceControl=1]="SourceControl",K[K.Window=10]="Window",K[K.Notification=15]="Notification"})(se||(e.ProgressLocation=se={}));var Te;(function(K){function V(ve){const Re=ve;return(0,v.$Gf)(Re.value)?Re.tooltip&&!(0,v.$Cf)(Re.tooltip)?(console.log("INVALID view badge, invalid tooltip",Re.tooltip),!1):!0:(console.log("INVALID view badge, invalid value",Re.value),!1)}K.isViewBadge=V})(Te||(e.ViewBadge=Te={}));let qe=D=class{static isTreeItem(V,ve){const Re=V;if(Re.checkboxState!==void 0){const Xe=(0,v.$Gf)(Re.checkboxState)?Re.checkboxState:(0,v.$Ef)(Re.checkboxState)&&(0,v.$Gf)(Re.checkboxState.state)?Re.checkboxState.state:void 0,it=!(0,v.$Gf)(Re.checkboxState)&&(0,v.$Ef)(Re.checkboxState)?Re.checkboxState.tooltip:void 0;if(Xe===void 0||Xe!==Qe.Checked&&Xe!==Qe.Unchecked||it!==void 0&&!(0,v.$Cf)(it))return console.log("INVALID tree item, invalid checkboxState",Re.checkboxState),!1}if(V instanceof D)return!0;if(Re.label!==void 0&&!(0,v.$Cf)(Re.label)&&!Re.label?.label)return console.log("INVALID tree item, invalid label",Re.label),!1;if(Re.id!==void 0&&!(0,v.$Cf)(Re.id))return console.log("INVALID tree item, invalid id",Re.id),!1;if(Re.iconPath!==void 0&&!(0,v.$Cf)(Re.iconPath)&&!g.URI.isUri(Re.iconPath)&&(!Re.iconPath||!(0,v.$Cf)(Re.iconPath.id))){const Xe=Re.iconPath;if(!Xe||!(0,v.$Cf)(Xe.light)&&!g.URI.isUri(Xe.light)&&!(0,v.$Cf)(Xe.dark)&&!g.URI.isUri(Xe.dark))return console.log("INVALID tree item, invalid iconPath",Re.iconPath),!1}return Re.description!==void 0&&!(0,v.$Cf)(Re.description)&&typeof Re.description!="boolean"?(console.log("INVALID tree item, invalid description",Re.description),!1):Re.resourceUri!==void 0&&!g.URI.isUri(Re.resourceUri)?(console.log("INVALID tree item, invalid resourceUri",Re.resourceUri),!1):Re.tooltip!==void 0&&!(0,v.$Cf)(Re.tooltip)&&!(Re.tooltip instanceof et)?(console.log("INVALID tree item, invalid tooltip",Re.tooltip),!1):Re.command!==void 0&&!Re.command.command?(console.log("INVALID tree item, invalid command",Re.command),!1):Re.collapsibleState!==void 0&&Re.collapsibleState<xe.None&&Re.collapsibleState>xe.Expanded?(console.log("INVALID tree item, invalid collapsibleState",Re.collapsibleState),!1):Re.contextValue!==void 0&&!(0,v.$Cf)(Re.contextValue)?(console.log("INVALID tree item, invalid contextValue",Re.contextValue),!1):Re.accessibilityInformation!==void 0&&!Re.accessibilityInformation?.label?(console.log("INVALID tree item, invalid accessibilityInformation",Re.accessibilityInformation),!1):!0}constructor(V,ve=xe.None){this.collapsibleState=ve,g.URI.isUri(V)?this.resourceUri=V:this.label=V}};e.$lL=qe,e.$lL=qe=D=He([P],qe);var xe;(function(K){K[K.None=0]="None",K[K.Collapsed=1]="Collapsed",K[K.Expanded=2]="Expanded"})(xe||(e.TreeItemCollapsibleState=xe={}));var Qe;(function(K){K[K.Unchecked=0]="Unchecked",K[K.Checked=1]="Checked"})(Qe||(e.TreeItemCheckboxState=Qe={}));let ot=class{async asString(){return typeof this.value=="string"?this.value:JSON.stringify(this.value)}asFile(){}constructor(V){this.value=V}};e.$mL=ot,e.$mL=ot=He([P],ot);class pt extends ot{}e.$nL=pt;class bt extends pt{#e;constructor(V){super(""),this.#e=V}asFile(){return this.#e}}e.$oL=bt;class vt{constructor(V,ve,Re,Xe){this.name=V,this.uri=ve,this._itemId=Re,this.c=Xe}data(){return this.c()}}e.$pL=vt;let ht=class{#e=new Map;constructor(V){for(const[ve,Re]of V??[]){const Xe=this.#e.get(this.#t(ve));Xe?Xe.push(Re):this.#e.set(this.#t(ve),[Re])}}get(V){return this.#e.get(this.#t(V))?.[0]}set(V,ve){this.#e.set(this.#t(V),[ve])}forEach(V,ve){for(const[Re,Xe]of this.#e)for(const it of Xe)V.call(ve,it,Re,this)}*[Symbol.iterator](){for(const[V,ve]of this.#e)for(const Re of ve)yield[V,Re]}#t(V){return V.toLowerCase()}};e.$qL=ht,e.$qL=ht=He([P],ht);let Lt=class{constructor(V){this.insertText=V}};e.$rL=Lt,e.$rL=Lt=He([P],Lt);let Qt=class{constructor(V,ve){this.label=ve,this.insertText=V}};e.$sL=Qt,e.$sL=Qt=He([P],Qt);let Yt=class{constructor(V,ve){this.id=V,this.color=ve}static isThemeIcon(V){return typeof V.id!="string"?(console.log("INVALID ThemeIcon, invalid id",V.id),!1):!0}};e.$tL=Yt,e.$tL=Yt=He([P],Yt),Yt.File=new Yt("file"),Yt.Folder=new Yt("folder");let si=class{constructor(V){this.id=V}};e.$uL=si,e.$uL=si=He([P],si);var Si;(function(K){K[K.Global=1]="Global",K[K.Workspace=2]="Workspace",K[K.WorkspaceFolder=3]="WorkspaceFolder"})(Si||(e.ConfigurationTarget=Si={}));let Ct=class{get base(){return this.c}set base(V){this.c=V,this.e=g.URI.file(V)}get baseUri(){return this.e}set baseUri(V){this.e=V,this.c=V.fsPath}constructor(V,ve){if(typeof V!="string"&&(!V||!g.URI.isUri(V)&&!g.URI.isUri(V.uri)))throw(0,F.$6)("base");if(typeof ve!="string")throw(0,F.$6)("pattern");typeof V=="string"?this.baseUri=g.URI.file(V):g.URI.isUri(V)?this.baseUri=V:this.baseUri=V.uri,this.pattern=ve}toJSON(){return{pattern:this.pattern,base:this.base,baseUri:this.baseUri.toJSON()}}};e.$vL=Ct,e.$vL=Ct=He([P],Ct);const Zi=new WeakMap;function ln(K,V){Zi.set(K,V)}e.$wL=ln;let kt=class{constructor(V,ve,Re,Xe){this.enabled=typeof V=="boolean"?V:!0,typeof ve=="string"&&(this.condition=ve),typeof Re=="string"&&(this.hitCondition=Re),typeof Xe=="string"&&(this.logMessage=Xe)}get id(){return this.c||(this.c=Zi.get(this)??(0,A.$ig)()),this.c}};e.$xL=kt,e.$xL=kt=He([P],kt);let gi=class extends kt{constructor(V,ve,Re,Xe,it){if(super(ve,Re,Xe,it),V===null)throw(0,F.$6)("location");this.location=V}};e.$yL=gi,e.$yL=gi=He([P],gi);let mi=class extends kt{constructor(V,ve,Re,Xe,it){super(ve,Re,Xe,it),this.functionName=V}};e.$zL=mi,e.$zL=mi=He([P],mi);let oi=class extends kt{constructor(V,ve,Re,Xe,it,ct,ft){if(super(Xe,it,ct,ft),!ve)throw(0,F.$6)("dataId");this.label=V,this.dataId=ve,this.canPersist=Re}};e.$AL=oi,e.$AL=oi=He([P],oi);let Di=class{constructor(V,ve,Re){this.command=V,this.args=ve||[],this.options=Re}};e.$BL=Di,e.$BL=Di=He([P],Di);let Ci=class{constructor(V,ve){this.port=V,this.host=ve}};e.$CL=Ci,e.$CL=Ci=He([P],Ci);let Ft=class{constructor(V){this.path=V}};e.$DL=Ft,e.$DL=Ft=He([P],Ft);let $i=class{constructor(V){this.implementation=V}};e.$EL=$i,e.$EL=$i=He([P],$i);let Ii=class{constructor(V,ve,Re){this.session=V,this.threadId=ve,this.frameId=Re}};e.$FL=Ii,e.$FL=Ii=He([P],Ii);let ai=class{constructor(V,ve){this.session=V,this.threadId=ve}};e.$GL=ai,e.$GL=ai=He([P],ai);let ci=class{constructor(V,ve){this.range=V,this.expression=ve}};e.$HL=ci,e.$HL=ci=He([P],ci);var dt;(function(K){K[K.Invoke=0]="Invoke",K[K.Automatic=1]="Automatic"})(dt||(e.InlineCompletionTriggerKind=dt={}));let Pi=class{constructor(V,ve){this.range=V,this.text=ve}};e.$IL=Pi,e.$IL=Pi=He([P],Pi);let xt=class{constructor(V,ve,Re=!0){this.range=V,this.variableName=ve,this.caseSensitiveLookup=Re}};e.$JL=xt,e.$JL=xt=He([P],xt);let ni=class{constructor(V,ve){this.range=V,this.expression=ve}};e.$KL=ni,e.$KL=ni=He([P],ni);let bi=class{constructor(V,ve){this.frameId=V,this.stoppedLocation=ve}};e.$LL=bi,e.$LL=bi=He([P],bi);var Yi;(function(K){K[K.Changed=1]="Changed",K[K.Created=2]="Created",K[K.Deleted=3]="Deleted"})(Yi||(e.FileChangeType=Yi={}));let Ai=m=class extends Error{static FileExists(V){return new m(V,$.FileSystemProviderErrorCode.FileExists,m.FileExists)}static FileNotFound(V){return new m(V,$.FileSystemProviderErrorCode.FileNotFound,m.FileNotFound)}static FileNotADirectory(V){return new m(V,$.FileSystemProviderErrorCode.FileNotADirectory,m.FileNotADirectory)}static FileIsADirectory(V){return new m(V,$.FileSystemProviderErrorCode.FileIsADirectory,m.FileIsADirectory)}static NoPermissions(V){return new m(V,$.FileSystemProviderErrorCode.NoPermissions,m.NoPermissions)}static Unavailable(V){return new m(V,$.FileSystemProviderErrorCode.Unavailable,m.Unavailable)}constructor(V,ve=$.FileSystemProviderErrorCode.Unknown,Re){super(g.URI.isUri(V)?V.toString(!0):V),this.code=Re?.name??"Unknown",(0,$.$tk)(this,ve),Object.setPrototypeOf(this,m.prototype),typeof Error.captureStackTrace=="function"&&typeof Re=="function"&&Error.captureStackTrace(this,Re)}};e.$ML=Ai,e.$ML=Ai=m=He([P],Ai);let Ri=class{constructor(V,ve,Re){this.start=V,this.end=ve,this.kind=Re}};e.$NL=Ri,e.$NL=Ri=He([P],Ri);var Li;(function(K){K[K.Comment=1]="Comment",K[K.Imports=2]="Imports",K[K.Region=3]="Region"})(Li||(e.FoldingRangeKind=Li={}));var xi;(function(K){K[K.Collapsed=0]="Collapsed",K[K.Expanded=1]="Expanded"})(xi||(e.CommentThreadCollapsibleState=xi={}));var Mi;(function(K){K[K.Editing=0]="Editing",K[K.Preview=1]="Preview"})(Mi||(e.CommentMode=Mi={}));var ui;(function(K){K[K.Published=0]="Published",K[K.Draft=1]="Draft"})(ui||(e.CommentState=ui={}));var _i;(function(K){K[K.Unresolved=0]="Unresolved",K[K.Resolved=1]="Resolved"})(_i||(e.CommentThreadState=_i={}));class Fi{constructor(V,ve=[]){this.tokenTypes=V,this.tokenModifiers=ve}}e.$OL=Fi;function Ti(K){return typeof K>"u"||(0,v.$Df)(K)}class Oi{constructor(V){if(this.c=0,this.e=0,this.f=!0,this.g=[],this.h=0,this.j=new Map,this.k=new Map,this.l=!1,V){this.l=!0;for(let ve=0,Re=V.tokenTypes.length;ve<Re;ve++)this.j.set(V.tokenTypes[ve],ve);for(let ve=0,Re=V.tokenModifiers.length;ve<Re;ve++)this.k.set(V.tokenModifiers[ve],ve)}}push(V,ve,Re,Xe,it){if(typeof V=="number"&&typeof ve=="number"&&typeof Re=="number"&&typeof Xe=="number"&&(typeof it=="number"||typeof it>"u"))return typeof it>"u"&&(it=0),this.n(V,ve,Re,Xe,it);if(N.isRange(V)&&typeof ve=="string"&&Ti(Re))return this.m(V,ve,Re);throw(0,F.$6)()}m(V,ve,Re){if(!this.l)throw new Error("Legend must be provided in constructor");if(V.start.line!==V.end.line)throw new Error("`range` cannot span multiple lines");if(!this.j.has(ve))throw new Error("`tokenType` is not in the provided legend");const Xe=V.start.line,it=V.start.character,ct=V.end.character-V.start.character,ft=this.j.get(ve);let zt=0;if(Re)for(const Zt of Re){if(!this.k.has(Zt))throw new Error("`tokenModifier` is not in the provided legend");const ei=this.k.get(Zt);zt|=1<<ei>>>0}this.n(Xe,it,ct,ft,zt)}n(V,ve,Re,Xe,it){if(this.f&&(V<this.c||V===this.c&&ve<this.e)){this.f=!1;const zt=this.g.length/5|0;let Zt=0,ei=0;for(let ii=0;ii<zt;ii++){let ri=this.g[5*ii],Qi=this.g[5*ii+1];ri===0?(ri=Zt,Qi+=ei):ri+=Zt,this.g[5*ii]=ri,this.g[5*ii+1]=Qi,Zt=ri,ei=Qi}}let ct=V,ft=ve;this.f&&this.h>0&&(ct-=this.c,ct===0&&(ft-=this.e)),this.g[this.h++]=ct,this.g[this.h++]=ft,this.g[this.h++]=Re,this.g[this.h++]=Xe,this.g[this.h++]=it,this.c=V,this.e=ve}static o(V){const ve=[],Re=V.length/5|0;for(let ft=0;ft<Re;ft++)ve[ft]=ft;ve.sort((ft,zt)=>{const Zt=V[5*ft],ei=V[5*zt];if(Zt===ei){const ii=V[5*ft+1],ri=V[5*zt+1];return ii-ri}return Zt-ei});const Xe=new Uint32Array(V.length);let it=0,ct=0;for(let ft=0;ft<Re;ft++){const zt=5*ve[ft],Zt=V[zt+0],ei=V[zt+1],ii=V[zt+2],ri=V[zt+3],Qi=V[zt+4],Dn=Zt-it,Tn=Dn===0?ei-ct:ei,Xi=5*ft;Xe[Xi+0]=Dn,Xe[Xi+1]=Tn,Xe[Xi+2]=ii,Xe[Xi+3]=ri,Xe[Xi+4]=Qi,it=Zt,ct=ei}return Xe}build(V){return this.f?new Ni(new Uint32Array(this.g),V):new Ni(Oi.o(this.g),V)}}e.$PL=Oi;class Ni{constructor(V,ve){this.resultId=ve,this.data=V}}e.$QL=Ni;class hi{constructor(V,ve,Re){this.start=V,this.deleteCount=ve,this.data=Re}}e.$RL=hi;class hn{constructor(V,ve){this.resultId=ve,this.edits=V}}e.$SL=hn;var en;(function(K){K[K.Separate=0]="Separate",K[K.MergeWithParent=1]="MergeWithParent"})(en||(e.DebugConsoleMode=en={}));let ji=class{static{this.Back={iconPath:new Yt("arrow-left")}}constructor(){}};e.$TL=ji,e.$TL=ji=He([P],ji);var pi;(function(K){K[K.Separator=-1]="Separator",K[K.Default=0]="Default"})(pi||(e.QuickPickItemKind=pi={}));var tn;(function(K){K[K.Info=1]="Info",K[K.Warning=2]="Warning",K[K.Error=3]="Error"})(tn||(e.InputBoxValidationSeverity=tn={}));var nn;(function(K){K[K.UI=1]="UI",K[K.Workspace=2]="Workspace"})(nn||(e.ExtensionKind=nn={}));class wi{static validate(V){if(typeof V.badge=="string"){let ve=(0,b.$df)(V.badge,0);if(ve<V.badge.length&&(ve+=(0,b.$df)(V.badge,ve)),V.badge.length>ve)throw new Error("The 'badge'-property must be undefined or a short character")}else if(V.badge&&!Yt.isThemeIcon(V.badge))throw new Error("The 'badge'-property is not a valid ThemeIcon");if(!V.color&&!V.badge&&!V.tooltip)throw new Error("The decoration is empty");return!0}constructor(V,ve,Re){this.badge=V,this.tooltip=ve,this.color=Re}}e.$UL=wi;let vi=class{constructor(V){this.kind=V}};e.$VL=vi,e.$VL=vi=He([P],vi);var rn;(function(K){K[K.Light=1]="Light",K[K.Dark=2]="Dark",K[K.HighContrast=3]="HighContrast",K[K.HighContrastLight=4]="HighContrastLight"})(rn||(e.ColorThemeKind=rn={}));class _t{static isNotebookRange(V){return V instanceof _t?!0:V?typeof V.start=="number"&&typeof V.end=="number":!1}get start(){return this.c}get end(){return this.e}get isEmpty(){return this.c===this.e}constructor(V,ve){if(V<0)throw(0,F.$6)("start must be positive");if(ve<0)throw(0,F.$6)("end must be positive");V<=ve?(this.c=V,this.e=ve):(this.c=ve,this.e=V)}with(V){let ve=this.c,Re=this.e;return V.start!==void 0&&(ve=V.start),V.end!==void 0&&(Re=V.end),ve===this.c&&Re===this.e?this:new _t(ve,Re)}}e.$WL=_t;class di{static validate(V){if(typeof V.kind!="number")throw new Error("NotebookCellData MUST have 'kind' property");if(typeof V.value!="string")throw new Error("NotebookCellData MUST have 'value' property");if(typeof V.languageId!="string")throw new Error("NotebookCellData MUST have 'languageId' property")}static isNotebookCellDataArray(V){return Array.isArray(V)&&V.every(ve=>di.isNotebookCellData(ve))}static isNotebookCellData(V){return!0}constructor(V,ve,Re,Xe,it,ct,ft){this.kind=V,this.value=ve,this.languageId=Re,this.mime=Xe,this.outputs=it??[],this.metadata=ct,this.executionSummary=ft,di.validate(this)}}e.$XL=di;class dn{constructor(V){this.cells=V}}e.$YL=dn;class Xt{static isNotebookCellOutputItem(V){return V instanceof Xt?!0:V?typeof V.mime=="string"&&V.data instanceof Uint8Array:!1}static error(V){const ve={name:V.name,message:V.message,stack:V.stack};return Xt.json(ve,"application/vnd.code.notebook.error")}static stdout(V){return Xt.text(V,"application/vnd.code.notebook.stdout")}static stderr(V){return Xt.text(V,"application/vnd.code.notebook.stderr")}static bytes(V,ve="application/octet-stream"){return new Xt(V,ve)}static#e=new TextEncoder;static text(V,ve=M.$Vr.text){const Re=Xt.#e.encode(String(V));return new Xt(Re,ve)}static json(V,ve="text/x-json"){const Re=JSON.stringify(V,void 0,"	");return Xt.text(Re,ve)}constructor(V,ve){this.data=V,this.mime=ve;const Re=(0,M.$Zr)(ve,!0);if(!Re)throw new Error(`INVALID mime type: ${ve}. Must be in the format "type/subtype[;optionalparameter]"`);this.mime=Re}}e.$ZL=Xt;class yi{static isNotebookCellOutput(V){return V instanceof yi?!0:!V||typeof V!="object"?!1:typeof V.id=="string"&&Array.isArray(V.items)}static ensureUniqueMimeTypes(V,ve=!1){const Re=new Set,Xe=new Set;for(let it=0;it<V.length;it++){const ct=V[it],ft=(0,M.$Zr)(ct.mime);if(!Re.has(ft)||(0,k.$BI)(ft)){Re.add(ft);continue}Xe.add(it),ve&&console.warn(`DUPLICATED mime type '${ct.mime}' will be dropped`)}return Xe.size===0?V:V.filter((it,ct)=>!Xe.has(ct))}constructor(V,ve,Re){this.items=yi.ensureUniqueMimeTypes(V,!0),typeof ve=="string"?(this.id=ve,this.metadata=Re):(this.id=(0,A.$ig)(),this.metadata=ve??Re)}}e.$1L=yi;var sn;(function(K){K[K.Markup=1]="Markup",K[K.Code=2]="Code"})(sn||(e.NotebookCellKind=sn={}));var Ei;(function(K){K[K.Idle=1]="Idle",K[K.Pending=2]="Pending",K[K.Executing=3]="Executing"})(Ei||(e.NotebookCellExecutionState=Ei={}));var zi;(function(K){K[K.Left=1]="Left",K[K.Right=2]="Right"})(zi||(e.NotebookCellStatusBarAlignment=zi={}));var ze;(function(K){K[K.Default=0]="Default",K[K.InCenter=1]="InCenter",K[K.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",K[K.AtTop=3]="AtTop"})(ze||(e.NotebookEditorRevealType=ze={}));class ti{constructor(V,ve){this.text=V,this.alignment=ve}}e.$2L=ti;var Ui;(function(K){K[K.Default=1]="Default",K[K.Preferred=2]="Preferred"})(Ui||(e.NotebookControllerAffinity=Ui={}));var $t;(function(K){K[K.Default=1]="Default",K[K.Preferred=2]="Preferred",K[K.Hidden=-1]="Hidden"})($t||(e.NotebookControllerAffinity2=$t={}));class fn{constructor(V,ve=[]){this.uri=V,this.provides=(0,C.$2b)(ve)}}e.$3L=fn;class gn{constructor(V){this.label=V}}e.$4L=gn;let ki=class{constructor(V,ve){this.label=V,this.timestamp=ve}};e.$5L=ki,e.$5L=ki=He([P],ki);var on;(function(K){K[K.Production=1]="Production",K[K.Development=2]="Development",K[K.Test=3]="Test"})(on||(e.ExtensionMode=on={}));var fi;(function(K){K[K.Node=1]="Node",K[K.Webworker=2]="Webworker"})(fi||(e.ExtensionRuntime=fi={}));var an;(function(K){K[K.Other=0]="Other",K[K.Comment=1]="Comment",K[K.String=2]="String",K[K.RegEx=3]="RegEx"})(an||(e.StandardTokenType=an={}));class mn{constructor(V,ve){this.ranges=V,this.wordPattern=ve}}e.$6L=mn;class $n{constructor(V){this.c=V}get autoForwardAction(){return this.c}}e.$7L=$n;var Bi;(function(K){K[K.Queued=1]="Queued",K[K.Running=2]="Running",K[K.Passed=3]="Passed",K[K.Failed=4]="Failed",K[K.Skipped=5]="Skipped",K[K.Errored=6]="Errored"})(Bi||(e.TestResultState=Bi={}));var cn;(function(K){K[K.Run=1]="Run",K[K.Debug=2]="Debug",K[K.Coverage=3]="Coverage"})(cn||(e.TestRunProfileKind=cn={}));let Wi=class{constructor(V=void 0,ve=void 0,Re=void 0,Xe=!1){this.include=V,this.exclude=ve,this.profile=Re,this.continuous=Xe}};e.$8L=Wi,e.$8L=Wi=He([P],Wi);let Vi=p=class{static diff(V,ve,Re){const Xe=new p(V);return Xe.expectedOutput=ve,Xe.actualOutput=Re,Xe}constructor(V){this.message=V}};e.$9L=Vi,e.$9L=Vi=p=He([P],Vi);let qi=class{constructor(V){this.id=V}};e.$0L=qi,e.$0L=qi=He([P],qi);let li=class{constructor(V,ve){this.covered=V,this.total=ve}};e.$$L=li,e.$$L=li=He([P],li);let Ki=S=class{static fromDetails(V,ve){const Re=new li(0,0),Xe=new li(0,0),it=new li(0,0);for(const ft of ve)if("branches"in ft){Re.total+=1,Re.covered+=ft.executionCount>0?1:0;for(const zt of ft.branches)Xe.total+=1,Xe.covered+=zt.executionCount>0?1:0}else it.total+=1,it.covered+=ft.executionCount>0?1:0;const ct=new S(V,Re,Xe.total>0?Xe:void 0,it.total>0?it:void 0);return ct.detailedCoverage=ve,ct}constructor(V,ve,Re,Xe){this.uri=V,this.statementCoverage=ve,this.branchCoverage=Re,this.functionCoverage=Xe}};e.$_L=Ki,e.$_L=Ki=S=He([P],Ki);let Hi=class{constructor(V,ve,Re=[]){this.executionCount=V,this.location=ve,this.branches=Re}};e.$aM=Hi,e.$aM=Hi=He([P],Hi);let Gi=class{constructor(V,ve){this.executionCount=V,this.location=ve}};e.$bM=Gi,e.$bM=Gi=He([P],Gi);let Ji=class{constructor(V,ve){this.executionCount=V,this.location=ve}};e.$cM=Ji,e.$cM=Ji=He([P],Ji);var un;(function(K){K[K.None=0]="None",K[K.Option=1]="Option",K[K.Default=2]="Default",K[K.Preferred=3]="Preferred"})(un||(e.ExternalUriOpenerPriority=un={}));var we;(function(K){K[K.Untrusted=0]="Untrusted",K[K.Trusted=1]="Trusted",K[K.Unspecified=2]="Unspecified"})(we||(e.WorkspaceTrustState=we={}));var De;(function(K){K[K.Notify=1]="Notify",K[K.OpenBrowser=2]="OpenBrowser",K[K.OpenPreview=3]="OpenPreview",K[K.Silent=4]="Silent",K[K.Ignore=5]="Ignore",K[K.OpenBrowserOnce=6]="OpenBrowserOnce"})(De||(e.PortAutoForwardAction=De={}));class Ne{constructor(V,ve,Re,Xe,it,ct){this.kind=V,this.name=ve,this.detail=Re,this.uri=Xe,this.range=it,this.selectionRange=ct}}e.$dM=Ne;class at{constructor(V){this.uri=V}}e.$eM=at;class yt{constructor(V,ve){this.original=V,this.modified=ve}}e.$fM=yt;class Tt{constructor(V,ve,Re,Xe){this.base=V,this.input1=ve,this.input2=Re,this.result=Xe}}e.$gM=Tt;class Cn{constructor(V,ve){this.uri=V,this.viewType=ve}}e.$hM=Cn;class In{constructor(V){this.viewType=V}}e.$iM=In;class Pn{constructor(V,ve){this.uri=V,this.notebookType=ve}}e.$jM=Pn;class An{constructor(V,ve,Re){this.original=V,this.modified=ve,this.notebookType=Re}}e.$kM=An;class Rn{constructor(){}}e.$lM=Rn;class Ln{constructor(V,ve){this.uri=V,this.inputBoxUri=ve}}e.$mM=Ln;class Mn{constructor(V){this.providerId=V}}e.$nM=Mn;var bn;(function(K){K[K.Down=0]="Down",K[K.Up=1]="Up"})(bn||(e.InteractiveSessionVoteDirection=bn={}));var pn;(function(K){K[K.Action=1]="Action",K[K.Toolbar=2]="Toolbar"})(pn||(e.InteractiveSessionCopyKind=pn={}));var wn;(function(K){K[K.Unhelpful=0]="Unhelpful",K[K.Helpful=1]="Helpful",K[K.Undone=2]="Undone",K[K.Accepted=3]="Accepted"})(wn||(e.InteractiveEditorResponseFeedbackKind=wn={}));var vn;(function(K){K[K.System=0]="System",K[K.User=1]="User",K[K.Assistant=2]="Assistant",K[K.Function=3]="Function"})(vn||(e.ChatMessageRole=vn={}));var yn;(function(K){K[K.Short=1]="Short",K[K.Medium=2]="Medium",K[K.Full=3]="Full"})(yn||(e.ChatVariableLevel=yn={}));class Fn{constructor(V,ve){this.role=V,this.content=ve}}e.$oM=Fn;var En;(function(K){K[K.Unhelpful=0]="Unhelpful",K[K.Helpful=1]="Helpful"})(En||(e.ChatAgentResultFeedbackKind=En={}));var kn;(function(K){K[K.SymbolInformation=1]="SymbolInformation",K[K.CommandInformation=2]="CommandInformation",K[K.SearchInformation=3]="SearchInformation",K[K.SettingInformation=4]="SettingInformation"})(kn||(e.RelatedInformationType=kn={}));var Sn;(function(K){K[K.Started=1]="Started",K[K.Recognizing=2]="Recognizing",K[K.Recognized=3]="Recognized",K[K.Stopped=4]="Stopped"})(Sn||(e.SpeechToTextStatus=Sn={}))}),define(ke[143],Se([1,0,60,17,13,176,127,7,19]),function(me,e,C,F,f,L,M,b,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$DM=e.$CM=e.$BM=void 0;const g=new Map;function A(k,w){w?g.set(k,w):g.delete(k)}e.$BM=A;function I(k){return g.get(k)}class $ extends L.$2u{constructor(w,u,o,i,n,r,a,t){super(u,o,i,n),this.c=w,this.m=r,this.q=a,this.notebook=t,this.b=!1}dispose(){(0,C.ok)(!this.b),this.b=!0,this.q=!1}equalLines(w){return(0,v.$tb)(this.f,w)}get document(){if(!this.a){const w=this;this.a={get uri(){return w.d},get fileName(){return w.d.fsPath},get isUntitled(){return w.d.scheme===F.Schemas.untitled},get languageId(){return w.m},get version(){return w.h},get isClosed(){return w.b},get isDirty(){return w.q},save(){return w.r()},getText(u){return u?w.s(u):w.getText()},get eol(){return w.g===`
`?b.EndOfLine.LF:b.EndOfLine.CRLF},get lineCount(){return w.f.length},lineAt(u){return w.t(u)},offsetAt(u){return w.u(u)},positionAt(u){return w.v(u)},validateRange(u){return w.w(u)},validatePosition(u){return w.x(u)},getWordRangeAtPosition(u,o){return w.y(u,o)}}}return Object.freeze(this.a)}_acceptLanguageId(w){(0,C.ok)(!this.b),this.m=w}_acceptIsDirty(w){(0,C.ok)(!this.b),this.q=w}r(){return this.b?Promise.reject(new Error("Document has been closed")):this.c.$trySaveDocument(this.d)}s(w){const u=this.w(w);if(u.isEmpty)return"";if(u.isSingleLine)return this.f[u.start.line].substring(u.start.character,u.end.character);const o=this.g,i=u.start.line,n=u.end.line,r=[];r.push(this.f[i].substring(u.start.character));for(let a=i+1;a<n;a++)r.push(this.f[a]);return r.push(this.f[n].substring(0,u.end.character)),r.join(o)}t(w){let u;if(w instanceof b.$AK?u=w.line:typeof w=="number"&&(u=w),typeof u!="number"||u<0||u>=this.f.length||Math.floor(u)!==u)throw new Error("Illegal value for `line`");return new y(u,this.f[u],u===this.f.length-1)}u(w){return w=this.x(w),this.l(),this.j.getPrefixSum(w.line-1)+w.character}v(w){w=Math.floor(w),w=Math.max(0,w),this.l();const u=this.j.getIndexOf(w),o=this.f[u.index].length;return new b.$AK(u.index,Math.min(u.remainder,o))}w(w){if(!(w instanceof b.$BK))throw new Error("Invalid argument");const u=this.x(w.start),o=this.x(w.end);return u===w.start&&o===w.end?w:new b.$BK(u.line,u.character,o.line,o.character)}x(w){if(!(w instanceof b.$AK))throw new Error("Invalid argument");if(this.f.length===0)return w.with(0,0);let{line:u,character:o}=w,i=!1;if(u<0)u=0,o=0,i=!0;else if(u>=this.f.length)u=this.f.length-1,o=this.f[u].length,i=!0;else{const n=this.f[u].length;o<0?(o=0,i=!0):o>n&&(o=n,i=!0)}return i?new b.$AK(u,o):w}y(w,u){const o=this.x(w);if(!u)u=I(this.m);else if((0,f.$Se)(u))throw new Error(`[getWordRangeAtPosition]: ignoring custom regexp '${u.source}' because it matches the empty string.`);const i=(0,M.$bs)(o.character+1,(0,M.$_r)(u),this.f[o.line],0);if(i)return new b.$BK(o.line,i.startColumn-1,o.line,i.endColumn-1)}}e.$CM=$;class y{constructor(w,u,o){this.a=w,this.b=u,this.c=o}get lineNumber(){return this.a}get text(){return this.b}get range(){return new b.$BK(this.a,0,this.a,this.b.length)}get rangeIncludingLineBreak(){return this.c?this.range:new b.$BK(this.a,0,this.a+1,0)}get firstNonWhitespaceCharacterIndex(){return/^(\s*)/.exec(this.b)[1].length}get isEmptyOrWhitespace(){return this.firstNonWhitespaceCharacterIndex===this.b.length}}e.$DM=y}),define(ke[285],Se([1,0,7,20,4]),function(me,e,C,F,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bfc=void 0;let L=class{constructor(b){this.a=new C.$VL(C.ColorThemeKind.Dark),this.b=new f.$Rd}get activeColorTheme(){return this.a}$onColorThemeChange(b){let v;switch(b){case"light":v=C.ColorThemeKind.Light;break;case"hcDark":v=C.ColorThemeKind.HighContrast;break;case"hcLight":v=C.ColorThemeKind.HighContrastLight;break;default:v=C.ColorThemeKind.Dark}this.a=new C.$VL(v),this.b.fire(this.a)}get onDidChangeActiveColorTheme(){return this.b.event}};e.$Bfc=L,e.$Bfc=L=He([Be(0,F.$zM)],L)}),define(ke[286],Se([1,0,5]),function(me,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$FI=e.CellExecutionUpdateType=void 0;var F;(function(f){f[f.Output=1]="Output",f[f.OutputItems=2]="OutputItems",f[f.ExecutionState=3]="ExecutionState"})(F||(e.CellExecutionUpdateType=F={})),e.$FI=(0,C.$Vh)("INotebookExecutionService")}),define(ke[287],Se([1,0,3,29,193,99]),function(me,e,C,F,f,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$UOb=void 0;class M extends C.$Rc{constructor(v,g,A){super(),this._source=v,this.b=g,this.c=A,this.a=void 0}f(v){const g=v.getLineCount();return new F.$zs(1,1,g,this.g(v,g))}g(v,g){if(g<1||g>v.getLineCount())throw new Error("Illegal value for lineNumber");return v.getLineLength(g)+1}get inputTextBuffer(){if(!this.b){const v=new f.$MB;v.acceptChunk(this._source);const g=v.finish(!0),{textBuffer:A,disposable:I}=g.create(1);this.b=A,this.B(I)}return this.b}get outputTextBuffers(){return this.a||(this.a=this.c.map(v=>{const g=new f.$MB;g.acceptChunk(v);const A=g.finish(!0),{textBuffer:I,disposable:$}=A.create(1);return this.B($),I})),this.a}findInInputs(v){const A=new L.$AB(v,!1,!1,null).parseSearchRequest();if(!A)return[];const I=this.f(this.inputTextBuffer);return this.inputTextBuffer.findMatchesLineByLine(I,A,!0,5e3)}findInOutputs(v){const A=new L.$AB(v,!1,!1,null).parseSearchRequest();return A?this.outputTextBuffers.map(I=>{const $=I.findMatchesLineByLine(this.f(I),A,!0,5e3);if($.length!==0)return{textBuffer:I,matches:$}}).filter(I=>!!I):[]}}e.$UOb=M}),define(ke[67],Se([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qJ=e.TestPosition=e.TestIdPathParts=void 0;var C;(function(L){L.Delimiter="\0"})(C||(e.TestIdPathParts=C={}));var F;(function(L){L[L.IsSame=0]="IsSame",L[L.Disconnected=1]="Disconnected",L[L.IsChild=2]="IsChild",L[L.IsParent=3]="IsParent"})(F||(e.TestPosition=F={}));class f{static fromExtHostTestItem(M,b,v=M.parent){if(M._isRoot)return new f([b]);const g=[M.id];for(let A=v;A&&A.id!==b;A=A.parent)g.push(A.id);return g.push(b),new f(g.reverse())}static isRoot(M){return!M.includes("\0")}static root(M){const b=M.indexOf("\0");return b===-1?M:M.slice(0,b)}static fromString(M){return new f(M.split("\0"))}static join(M,b){return new f([...M.path,b])}static joinToString(M,b){return M.toString()+"\0"+b}static parentId(M){const b=M.lastIndexOf("\0");return b===-1?void 0:M.slice(0,b)}static localId(M){const b=M.lastIndexOf("\0");return b===-1?M:M.slice(b+1)}static isChild(M,b){return b.startsWith(M)&&b[M.length]==="\0"}static compare(M,b){return M===b?0:f.isChild(M,b)?2:f.isChild(b,M)?3:1}constructor(M,b=M.length){if(this.path=M,this.d=b,M.length===0||b<1)throw new Error("cannot create test with empty path")}get rootId(){return new f(this.path,1)}get parentId(){return this.d>1?new f(this.path,this.d-1):void 0}get localId(){return this.path[this.d-1]}get controllerId(){return this.path[0]}get isRoot(){return this.d===1}*idsFromRoot(){for(let M=1;M<=this.d;M++)yield new f(this.path,M)}*idsToRoot(){for(let M=this.d;M>0;M--)yield new f(this.path,M)}compare(M){if(typeof M=="string")return f.compare(this.toString(),M);for(let b=0;b<M.d&&b<this.d;b++)if(M.path[b]!==this.path[b])return 1;return M.d>this.d?2:M.d<this.d?3:0}toJSON(){return this.toString()}toString(){if(!this.c){this.c=this.path[0];for(let M=1;M<this.d;M++)this.c+="\0",this.c+=this.path[M]}return this.c}}e.$qJ=f}),define(ke[89],Se([1,0,2,29,67]),function(me,e,C,F,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xJ=e.TestsDiffOp=e.TestDiffOpType=e.DetailType=e.TestResultItem=e.$wJ=e.ITestItemUpdate=e.InternalTestItem=e.TestItemExpandState=e.ITestItem=e.$vJ=e.$uJ=e.ITestTaskState=e.ITestMessage=e.ITestOutputMessage=e.$tJ=e.ITestErrorMessage=e.TestMessageType=e.IRichLocation=e.$sJ=e.$rJ=e.TestRunProfileBitset=e.ExtTestRunProfileKind=e.TestResultState=void 0;var L;(function(D){D[D.Unset=0]="Unset",D[D.Queued=1]="Queued",D[D.Running=2]="Running",D[D.Passed=3]="Passed",D[D.Failed=4]="Failed",D[D.Skipped=5]="Skipped",D[D.Errored=6]="Errored"})(L||(e.TestResultState=L={}));var M;(function(D){D[D.Run=1]="Run",D[D.Debug=2]="Debug",D[D.Coverage=3]="Coverage"})(M||(e.ExtTestRunProfileKind=M={}));var b;(function(D){D[D.Run=2]="Run",D[D.Debug=4]="Debug",D[D.Coverage=8]="Coverage",D[D.HasNonDefaultProfile=16]="HasNonDefaultProfile",D[D.HasConfigurable=32]="HasConfigurable",D[D.SupportsContinuousRun=64]="SupportsContinuousRun"})(b||(e.TestRunProfileBitset=b={})),e.$rJ=[2,4,8,16,32,64];const v=D=>"runId"in D;e.$sJ=v;var g;(function(D){D.serialize=m=>({range:m.range.toJSON(),uri:m.uri.toJSON()}),D.deserialize=m=>({range:F.$zs.lift(m.range),uri:C.URI.revive(m.uri)})})(g||(e.IRichLocation=g={}));var A;(function(D){D[D.Error=0]="Error",D[D.Output=1]="Output"})(A||(e.TestMessageType=A={}));var I;(function(D){D.serialize=m=>({message:m.message,type:0,expected:m.expected,actual:m.actual,contextValue:m.contextValue,location:m.location&&g.serialize(m.location)}),D.deserialize=m=>({message:m.message,type:0,expected:m.expected,actual:m.actual,contextValue:m.contextValue,location:m.location&&g.deserialize(m.location)})})(I||(e.ITestErrorMessage=I={}));const $=(D,m)=>`${m?"s":"e"}${D}`;e.$tJ=$;var y;(function(D){D.serialize=m=>({message:m.message,type:1,offset:m.offset,length:m.length,location:m.location&&g.serialize(m.location)}),D.deserialize=m=>({message:m.message,type:1,offset:m.offset,length:m.length,location:m.location&&g.deserialize(m.location)})})(y||(e.ITestOutputMessage=y={}));var k;(function(D){D.serialize=m=>m.type===0?I.serialize(m):y.serialize(m),D.deserialize=m=>m.type===0?I.deserialize(m):y.deserialize(m)})(k||(e.ITestMessage=k={}));var w;(function(D){D.serializeWithoutMessages=m=>({state:m.state,duration:m.duration,messages:[]}),D.serialize=m=>({state:m.state,duration:m.duration,messages:m.messages.map(k.serialize)}),D.deserialize=m=>({state:m.state,duration:m.duration,messages:m.messages.map(k.deserialize)})})(w||(e.ITestTaskState=w={}));const u="\0",o=(D,m)=>D+u+m;e.$uJ=o;const i=D=>{const m=D.indexOf(u);return{ctrlId:D.slice(0,m),tagId:D.slice(m+1)}};e.$vJ=i;var n;(function(D){D.serialize=m=>({extId:m.extId,label:m.label,tags:m.tags,busy:m.busy,children:void 0,uri:m.uri?.toJSON(),range:m.range?.toJSON()||null,description:m.description,error:m.error,sortText:m.sortText}),D.deserialize=m=>({extId:m.extId,label:m.label,tags:m.tags,busy:m.busy,children:void 0,uri:m.uri?C.URI.revive(m.uri):void 0,range:m.range?F.$zs.lift(m.range):null,description:m.description,error:m.error,sortText:m.sortText})})(n||(e.ITestItem=n={}));var r;(function(D){D[D.NotExpandable=0]="NotExpandable",D[D.Expandable=1]="Expandable",D[D.BusyExpanding=2]="BusyExpanding",D[D.Expanded=3]="Expanded"})(r||(e.TestItemExpandState=r={}));var a;(function(D){D.serialize=m=>({expand:m.expand,item:n.serialize(m.item)}),D.deserialize=m=>({controllerId:f.$qJ.root(m.item.extId),expand:m.expand,item:n.deserialize(m.item)})})(a||(e.InternalTestItem=a={}));var t;(function(D){D.serialize=m=>{let p;return m.item&&(p={},m.item.label!==void 0&&(p.label=m.item.label),m.item.tags!==void 0&&(p.tags=m.item.tags),m.item.busy!==void 0&&(p.busy=m.item.busy),m.item.uri!==void 0&&(p.uri=m.item.uri?.toJSON()),m.item.range!==void 0&&(p.range=m.item.range?.toJSON()),m.item.description!==void 0&&(p.description=m.item.description),m.item.error!==void 0&&(p.error=m.item.error),m.item.sortText!==void 0&&(p.sortText=m.item.sortText)),{extId:m.extId,expand:m.expand,item:p}},D.deserialize=m=>{let p;return m.item&&(p={},m.item.label!==void 0&&(p.label=m.item.label),m.item.tags!==void 0&&(p.tags=m.item.tags),m.item.busy!==void 0&&(p.busy=m.item.busy),m.item.range!==void 0&&(p.range=m.item.range?F.$zs.lift(m.item.range):null),m.item.description!==void 0&&(p.description=m.item.description),m.item.error!==void 0&&(p.error=m.item.error),m.item.sortText!==void 0&&(p.sortText=m.item.sortText)),{extId:m.extId,expand:m.expand,item:p}}})(t||(e.ITestItemUpdate=t={}));const s=(D,m)=>{m.expand!==void 0&&(D.expand=m.expand),m.item!==void 0&&(D.item=D.item?Object.assign(D.item,m.item):m.item)};e.$wJ=s;var d;(function(D){D.serializeWithoutMessages=m=>({...a.serialize(m),ownComputedState:m.ownComputedState,computedState:m.computedState,tasks:m.tasks.map(w.serializeWithoutMessages)}),D.serialize=m=>({...a.serialize(m),ownComputedState:m.ownComputedState,computedState:m.computedState,tasks:m.tasks.map(w.serialize)}),D.deserialize=m=>({...a.deserialize(m),ownComputedState:m.ownComputedState,computedState:m.computedState,tasks:m.tasks.map(w.deserialize),retired:!0})})(d||(e.TestResultItem=d={}));var c;(function(D){D[D.Function=0]="Function",D[D.Statement=1]="Statement"})(c||(e.DetailType=c={}));var l;(function(D){D[D.Add=0]="Add",D[D.Update=1]="Update",D[D.DocumentSynced=2]="DocumentSynced",D[D.Remove=3]="Remove",D[D.IncrementPendingExtHosts=4]="IncrementPendingExtHosts",D[D.Retire=5]="Retire",D[D.AddTag=6]="AddTag",D[D.RemoveTag=7]="RemoveTag"})(l||(e.TestDiffOpType=l={}));var h;(function(D){D.deserialize=m=>m.op===0?{op:m.op,item:a.deserialize(m.item)}:m.op===1?{op:m.op,item:t.deserialize(m.item)}:m.op===2?{op:m.op,uri:C.URI.revive(m.uri),docv:m.docv}:m,D.serialize=m=>m.op===0?{op:m.op,item:a.serialize(m.item)}:m.op===1?{op:m.op,item:t.serialize(m.item)}:m})(h||(e.TestsDiffOp=h={}));class E{constructor(){this.c=new Map,this.d=new Map,this.f=new Set,this.g=0,this.h=0,this.tags=this.c}apply(m){const p=this.o();for(const S of m)switch(S.op){case 0:this.j(a.deserialize(S.item),p);break;case 1:this.k(t.deserialize(S.item),p);break;case 3:this.l(S.itemId,p);break;case 5:this.m(S.itemId);break;case 4:this.updatePendingRoots(S.amount);break;case 6:this.c.set(S.tag.id,S.tag);break;case 7:this.c.delete(S.id);break}p.complete?.()}j(m,p){const S=f.$qJ.parentId(m.item.extId)?.toString();let P;if(!S)P=this.p(m),this.f.add(P),this.d.set(m.item.extId,P);else if(this.d.has(S)){const z=this.d.get(S);z.children.add(m.item.extId),P=this.p(m,z),this.d.set(m.item.extId,P)}else{console.error(`Test with unknown parent ID: ${JSON.stringify(m)}`);return}return p.add?.(P),m.expand===2&&this.g++,P}k(m,p){const S=this.d.get(m.extId);if(S)return m.expand!==void 0&&(S.expand===2&&this.g--,m.expand===2&&this.g++),(0,e.$wJ)(S,m),p.update?.(S),S}l(m,p){const S=this.d.get(m);if(!S)return;const P=f.$qJ.parentId(S.item.extId)?.toString();P?this.d.get(P).children.delete(S.item.extId):this.f.delete(S);const z=[[m]];for(;z.length;)for(const j of z.pop()){const R=this.d.get(j);R&&(z.push(R.children),this.d.delete(j),p.remove?.(R,R!==S),R.expand===2&&this.g--)}}m(m){}updatePendingRoots(m){this.h+=m}o(){return{}}}e.$xJ=E}),define(ke[112],Se([1,0,12,4,3,60,89,67]),function(me,e,C,F,f,L,M,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tM=e.$sM=e.$rM=e.$qM=e.$pM=e.TestItemEventOp=void 0;var v;(function(i){i[i.Upsert=0]="Upsert",i[i.SetTags=1]="SetTags",i[i.UpdateCanResolveChildren=2]="UpdateCanResolveChildren",i[i.RemoveChild=3]="RemoveChild",i[i.SetProp=4]="SetProp",i[i.Bulk=5]="Bulk",i[i.DocumentSynced=6]="DocumentSynced"})(v||(e.TestItemEventOp=v={}));const g=(i,n)=>i===n,I=Object.entries({range:(i,n)=>i===n?!0:!i||!n?!1:i.equalsRange(n),busy:g,label:g,description:g,error:g,sortText:g,tags:(i,n)=>!(i.length!==n.length||i.some(r=>!n.includes(r)))}),$=(i,n)=>{let r;for(const[a,t]of I)t(i[a],n[a])||(r?r[a]=n[a]:r={[a]:n[a]});return r};class y extends f.$Rc{get root(){return this.s.root}constructor(n){super(),this.s=n,this.f=this.B(new C.$0g(()=>this.flushDiff(),200)),this.g=this.B(new F.$Rd),this.tree=new Map,this.j=new Map,this.m=[],this.onDidGenerateDiff=this.g.event,this.root.canResolveChildren=!0,this.y(this.root,void 0)}set resolveHandler(n){this.h=n;for(const r of this.tree.values())this.I(r)}get resolveHandler(){return this.h}collectDiff(){const n=this.m;return this.m=[],n}pushDiff(n){switch(n.op){case 2:{for(const r of this.m)if(r.op===2&&r.uri===n.uri){r.docv=n.docv;return}break}case 1:{const r=this.m[this.m.length-1];if(r){if(r.op===1&&r.item.extId===n.item.extId){(0,M.$wJ)(r.item,n.item);return}if(r.op===0&&r.item.item.extId===n.item.extId){(0,M.$wJ)(r.item,n.item);return}}break}}this.m.push(n),this.f.isScheduled()||this.f.schedule()}expand(n,r){const a=this.tree.get(n);if(a){if((a.expandLevels===void 0||r>a.expandLevels)&&(a.expandLevels=r),a.expand===1){const t=this.L(a);return t.isOpen()?this.J(a,r-1):t.wait().then(()=>this.J(a,r-1))}else if(a.expand===3)return a.resolveBarrier?.isOpen()===!1?a.resolveBarrier.wait().then(()=>this.J(a,r-1)):this.J(a,r-1)}}dispose(){for(const n of this.tree.values())this.s.getApiFor(n.actual).listener=void 0;this.tree.clear(),this.m=[],super.dispose()}u(n,r){switch(r.op){case 3:this.N(b.$qJ.joinToString(n.fullId,r.id));break;case 0:this.y(r.item,n);break;case 5:for(const a of r.ops)this.u(n,a);break;case 1:this.z(r.new,r.old,n.fullId.toString());break;case 2:this.I(n);break;case 4:this.pushDiff({op:1,item:{extId:n.fullId.toString(),item:r.update}});break;case 6:this.w(n.actual.uri);break;default:(0,L.$4c)(r)}}w(n){n&&this.pushDiff({op:2,uri:n,docv:this.s.getDocumentVersion(n)})}y(n,r){const a=b.$qJ.fromExtHostTestItem(n,this.root.id,r?.actual),t=this.s.getApiFor(n);t.parent&&t.parent!==r?.actual&&this.s.getChildren(t.parent).delete(n.id);let s=this.tree.get(a.toString());if(!s){s={fullId:a,actual:n,expandLevels:r?.expandLevels?r.expandLevels-1:void 0,expand:0},n.tags.forEach(this.C,this),this.tree.set(s.fullId.toString(),s),this.F(n,r),this.pushDiff({op:0,item:{controllerId:this.s.controllerId,expand:s.expand,item:this.s.toITestItem(n)}}),this.H(n,s,r);return}if(s.actual===n){this.G(n,s,r);return}if(s.actual.uri?.toString()!==n.uri?.toString())return this.N(a.toString()),this.y(n,r);const d=this.s.getChildren(s.actual),c=s.actual,l=$(this.s.toITestItem(c),this.s.toITestItem(n));this.s.getApiFor(c).listener=void 0,s.actual=n,s.expand=0,l&&(l.hasOwnProperty("tags")&&(this.z(n.tags,c.tags,a.toString()),delete l.tags),this.u(s,{op:4,update:l})),this.H(n,s,r);for(const[h,E]of d)this.s.getChildren(n).get(E.id)||this.N(b.$qJ.joinToString(a,E.id));this.w(s.actual.uri)}z(n,r,a){const t=new Set(r.map(s=>s.id));for(const s of n)t.delete(s.id)||this.C(s);this.pushDiff({op:1,item:{extId:a,item:{tags:n.map(s=>(0,M.$uJ)(this.s.controllerId,s.id))}}}),t.forEach(this.D,this)}C(n){const r=this.j.get(n.id);r?r.refCount++:(this.j.set(n.id,{refCount:1}),this.pushDiff({op:6,tag:{id:(0,M.$uJ)(this.s.controllerId,n.id)}}))}D(n){const r=this.j.get(n);r&&!--r.refCount&&(this.j.delete(n),this.pushDiff({op:7,id:(0,M.$uJ)(this.s.controllerId,n)}))}F(n,r){this.s.getApiFor(n).parent=r&&r.actual!==this.root?r.actual:void 0}G(n,r,a){this.F(n,a);const t=this.s.getApiFor(n);t.parent=a?.actual,t.listener=s=>this.u(r,s),this.I(r)}H(n,r,a){this.G(n,r,a);for(const[t,s]of this.s.getChildren(n))this.y(s,r)}I(n){let r;this.h?n.resolveBarrier?r=n.resolveBarrier.isOpen()?3:2:r=n.actual.canResolveChildren?1:0:r=0,r!==n.expand&&(n.expand=r,this.pushDiff({op:1,item:{extId:n.fullId.toString(),expand:r}}),r===1&&n.expandLevels!==void 0&&this.L(n))}J(n,r){if(r<0)return;const a=[];for(const[t,s]of this.s.getChildren(n.actual)){const d=this.expand(b.$qJ.joinToString(n.fullId,s.id),r);(0,C.$Kg)(d)&&a.push(d)}if(a.length)return Promise.all(a).then(()=>{})}L(n){if(n.resolveBarrier)return n.resolveBarrier;if(!this.h){const s=new C.$Wg;return s.open(),s}n.expand=2,this.M(n);const r=n.resolveBarrier=new C.$Wg,a=s=>{console.error(`Unhandled error in resolveHandler of test controller "${this.s.controllerId}"`,s)};let t;try{t=this.h(n.actual===this.root?void 0:n.actual)}catch(s){a(s)}return(0,C.$Kg)(t)?t.catch(a).then(()=>{r.open(),this.I(n)}):(r.open(),this.I(n)),n.resolveBarrier}M(n){this.pushDiff({op:1,item:{extId:n.fullId.toString(),expand:n.expand}})}N(n){const r=this.tree.get(n);if(!r)throw new Error("attempting to remove non-existent child");this.pushDiff({op:3,itemId:n});const a=[r];for(;a.length;){const t=a.pop();if(t){this.s.getApiFor(t.actual).listener=void 0;for(const s of t.actual.tags)this.D(s.id);this.tree.delete(t.fullId.toString());for(const[s,d]of this.s.getChildren(t.actual))a.push(this.tree.get(b.$qJ.joinToString(t.fullId,d.id)))}}}flushDiff(){const n=this.collectDiff();n.length&&this.g.fire(n)}}e.$pM=y;class k extends Error{constructor(n){super(`Attempted to insert a duplicate test item ID ${n}`)}}e.$qM=k;class w extends Error{constructor(n){super(`TestItem with ID "${n}" is invalid. Make sure to create it from the createTestItem method.`)}}e.$rM=w;class u extends Error{constructor(n,r,a){super(`TestItem with ID "${n}" is from controller "${r}" and cannot be added as a child of an item from controller "${a}".`)}}e.$sM=u;const o=(i,n,r)=>{let a=new Map;return{get size(){return a.size},forEach(t,s){for(const d of a.values())t.call(s,d,this)},[Symbol.iterator](){return a.entries()},replace(t){const s=new Map,d=new Set(a.keys()),c={op:5,ops:[]};for(const l of t){if(!(l instanceof r))throw new w(l.id);const h=n(l).controllerId;if(h!==i.controllerId)throw new u(l.id,h,i.controllerId);if(s.has(l.id))throw new k(l.id);s.set(l.id,l),d.delete(l.id),c.ops.push({op:0,item:l})}for(const l of d.keys())c.ops.push({op:3,id:l});i.listener?.(c),a=s},add(t){if(!(t instanceof r))throw new w(t.id);a.set(t.id,t),i.listener?.({op:0,item:t})},delete(t){a.delete(t)&&i.listener?.({op:3,id:t})},get(t){return a.get(t)},toJSON(){return Array.from(a.values())}}};e.$tM=o}),define(ke[144],Se([1,0,112]),function(me,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vM=e.$uM=void 0;const F=new WeakMap,f=(M,b)=>{const v={controllerId:b};return F.set(M,v),v};e.$uM=f;const L=M=>{const b=F.get(M);if(!b)throw new C.$rM(M?.id||"<unknown>");return b};e.$vM=L}),define(ke[113],Se([1,0,17,2]),function(me,e,C,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_tb=e.$$tb=e.$0tb=e.$9tb=e.$8tb=void 0,e.$8tb="vscode-cdn.net",e.$9tb=`vscode-resource.${e.$8tb}`,e.$0tb=`'self' https://*.${e.$8tb}`;function f(b,v){return b.scheme===C.Schemas.http||b.scheme===C.Schemas.https?b:(v&&v.authority&&v.isRemote&&b.scheme===C.Schemas.file&&(b=F.URI.from({scheme:C.Schemas.vscodeRemote,authority:v.authority,path:b.path})),F.URI.from({scheme:C.Schemas.https,authority:`${b.scheme}+${L(b.authority)}.${e.$9tb}`,path:b.path,fragment:b.fragment,query:b.query}))}e.$$tb=f;function L(b){return b.replace(/./g,v=>{const g=v.charCodeAt(0);return g>=97&&g<=122||g>=65&&g<=90||g>=48&&g<=57?v:"-"+g.toString(16).padStart(4,"0")})}function M(b){return b.replace(/-([0-9a-f]{4})/g,(v,g)=>String.fromCharCode(parseInt(g,16)))}e.$_tb=M}),define(ke[288],Se([1,0,4,3,113]),function(me,e,C,F,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xdc=void 0;class L{constructor(b,v,g){this.d=b,this.e=v,this.f=g,this.a=0,this.b=new F.$Qc,this.c=new Map,this.b.add(v.onDidChangeVisibleTextEditors(()=>{const A=v.getVisibleTextEditors();for(const I of this.c.values())A.indexOf(I.editor)<0&&I.inset.dispose()}))}dispose(){this.c.forEach(b=>b.inset.dispose()),this.b.dispose()}createWebviewEditorInset(b,v,g,A,I){let $;for(const n of this.e.getVisibleTextEditors(!0))if(n.value===b){$=n;break}if(!$)throw new Error("not a visible editor");const y=this,k=this.a++,w=new C.$Rd,u=new C.$Rd,o=new class{constructor(){this.a="",this.b=Object.create(null)}asWebviewUri(n){return(0,f.$$tb)(n,y.f)}get cspSource(){return f.$0tb}set options(n){this.b=n,y.d.$setOptions(k,n)}get options(){return this.b}set html(n){this.a=n,y.d.$setHtml(k,n)}get html(){return this.a}get onDidReceiveMessage(){return w.event}postMessage(n){return y.d.$postMessage(k,n)}},i=new class{constructor(){this.editor=b,this.line=v,this.height=g,this.webview=o,this.onDidDispose=u.event}dispose(){y.c.has(k)&&(y.c.delete(k),y.d.$disposeEditorInset(k),u.fire(),u.dispose(),w.dispose())}};return this.d.$createEditorInset(k,$.id,$.value.document.uri,v+1,g,A||{},I.identifier,I.extensionLocation),this.c.set(k,{editor:b,inset:i,onDidReceiveMessage:w}),i}$onDidDispose(b){const v=this.c.get(b);v&&v.inset.dispose()}$onDidReceiveMessage(b,v){this.c.get(b)?.onDidReceiveMessage.fire(v)}}e.$Xdc=L}),define(ke[289],Se([1,0,5]),function(me,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mN=e.VariableKind=e.$lN=void 0,e.$lN=(0,C.$Vh)("configurationResolverService");var F;(function(L){L.Unknown="unknown",L.Env="env",L.Config="config",L.Command="command",L.Input="input",L.ExtensionInstallFolder="extensionInstallFolder",L.WorkspaceFolder="workspaceFolder",L.Cwd="cwd",L.WorkspaceFolderBasename="workspaceFolderBasename",L.UserHome="userHome",L.LineNumber="lineNumber",L.SelectedText="selectedText",L.File="file",L.FileWorkspaceFolder="fileWorkspaceFolder",L.FileWorkspaceFolderBasename="fileWorkspaceFolderBasename",L.RelativeFile="relativeFile",L.RelativeFileDirname="relativeFileDirname",L.FileDirname="fileDirname",L.FileExtname="fileExtname",L.FileBasename="fileBasename",L.FileBasenameNoExtension="fileBasenameNoExtension",L.FileDirnameBasename="fileDirnameBasename",L.ExecPath="execPath",L.ExecInstallFolder="execInstallFolder",L.PathSeparator="pathSeparator"})(F||(e.VariableKind=F={}));class f extends Error{constructor(M,b){super(b),this.variable=M}}e.$mN=f}),define(ke[290],Se([1,0,16,49,18,24,11,102,232,289,13]),function(me,e,C,F,f,L,M,b,v,g,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$AN=void 0;class I{static{this.VARIABLE_LHS="${"}static{this.VARIABLE_REGEXP=/\$\{(.*?)\}/g}constructor(y,k,w,u){this.h=new Map,this.a=y,this.b=k,this.g=w,u&&(this.c=u.then(o=>this.i(o)))}i(y){if(M.$i){const k=Object.create(null);return Object.keys(y).forEach(w=>{k[w.toLowerCase()]=y[w]}),k}return y}resolveWithEnvironment(y,k,w){return this.l({env:this.i(y),userHome:void 0},k?k.uri:void 0,w)}async resolveAsync(y,k){const w={env:await this.c,userHome:await this.g};return this.l(w,y?y.uri:void 0,k)}async j(y,k,w,u){const o=L.$an(k);M.$i&&o.windows?Object.keys(o.windows).forEach(n=>o[n]=o.windows[n]):M.$j&&o.osx?Object.keys(o.osx).forEach(n=>o[n]=o.osx[n]):M.$k&&o.linux&&Object.keys(o.linux).forEach(n=>o[n]=o.linux[n]),delete o.windows,delete o.osx,delete o.linux;const i={env:await this.c,userHome:await this.g};return this.l(i,y?y.uri:void 0,o,w,u)}async resolveAnyAsync(y,k,w){return this.j(y,k,w)}async resolveAnyMap(y,k,w){const u=new Map;return{newConfig:await this.j(y,k,w,u),resolvedVariables:u}}resolveWithInteractionReplace(y,k,w,u){throw new Error("resolveWithInteractionReplace not implemented.")}resolveWithInteraction(y,k,w,u){throw new Error("resolveWithInteraction not implemented.")}contributeVariable(y,k){if(this.h.has(y))throw new Error("Variable "+y+" is contributed twice.");this.h.set(y,k)}async l(y,k,w,u,o){if(f.$Cf(w))return this.m(y,k,w,u,o);if(Array.isArray(w))return Promise.all(w.map(i=>this.l(y,k,i,u,o)));if(f.$Ef(w)){const i=Object.create(null),n=await Promise.all(Object.keys(w).map(async r=>[await this.m(y,k,r,u,o),await this.l(y,k,w[r],u,o)]));for(const[r,a]of n)i[r]=a;return i}return w}m(y,k,w,u,o){return(0,A.$Xe)(w,I.VARIABLE_REGEXP,async(i,n)=>{if(n.includes(I.VARIABLE_LHS))return i;let r=await this.o(y,i,n,k,u);return o?.set(n,r),r!==i&&f.$Cf(r)&&r.match(I.VARIABLE_REGEXP)&&(r=await this.m(y,k,r,u,o)),r})}n(y){return this.b?this.b.getUriLabel(y,{noPrefix:!0}):y.fsPath}async o(y,k,w,u,o){let i;const n=w.split(":");n.length>1&&(w=n[0],i=n[1]);const r=s=>{const d=this.a.getFilePath();if(d)return(0,b.$yv)(d);throw new g.$mN(s,(0,v.localize)(0,null,k))},a=s=>{const d=r(s);if(this.a.getWorkspaceFolderPathForFile){const c=this.a.getWorkspaceFolderPathForFile();if(c)return(0,b.$yv)(c)}throw new g.$mN(s,(0,v.localize)(1,null,k,C.$mc(d)))},t=s=>{if(i){const d=this.a.getFolderUri(i);if(d)return d;throw new g.$mN(s,(0,v.localize)(2,null,k,i))}if(u)return u;throw this.a.getWorkspaceFolderCount()>1?new g.$mN(s,(0,v.localize)(3,null,k)):new g.$mN(s,(0,v.localize)(4,null,k))};switch(w){case"env":if(i){if(y.env){const s=y.env[M.$i?i.toLowerCase():i];if(f.$Cf(s))return s}return""}throw new g.$mN(g.VariableKind.Env,(0,v.localize)(5,null,k));case"config":if(i){const s=this.a.getConfigurationValue(u,i);if(f.$Lf(s))throw new g.$mN(g.VariableKind.Config,(0,v.localize)(6,null,k,i));if(f.$Ef(s))throw new g.$mN(g.VariableKind.Config,(0,v.localize)(7,null,k,i));return s}throw new g.$mN(g.VariableKind.Config,(0,v.localize)(8,null,k));case"command":return this.p(g.VariableKind.Command,k,i,o,"command");case"input":return this.p(g.VariableKind.Input,k,i,o,"input");case"extensionInstallFolder":if(i){const s=await this.a.getExtension(i);if(!s)throw new g.$mN(g.VariableKind.ExtensionInstallFolder,(0,v.localize)(9,null,k,i));return this.n(s.extensionLocation)}throw new g.$mN(g.VariableKind.ExtensionInstallFolder,(0,v.localize)(10,null,k));default:switch(w){case"workspaceRoot":case"workspaceFolder":return(0,b.$yv)(this.n(t(g.VariableKind.WorkspaceFolder)));case"cwd":return u||i?(0,b.$yv)(this.n(t(g.VariableKind.Cwd))):F.cwd();case"workspaceRootFolderName":case"workspaceFolderBasename":return(0,b.$yv)(C.$mc(this.n(t(g.VariableKind.WorkspaceFolderBasename))));case"userHome":{if(y.userHome)return y.userHome;throw new g.$mN(g.VariableKind.UserHome,(0,v.localize)(11,null,k))}case"lineNumber":{const s=this.a.getLineNumber();if(s)return s;throw new g.$mN(g.VariableKind.LineNumber,(0,v.localize)(12,null,k))}case"selectedText":{const s=this.a.getSelectedText();if(s)return s;throw new g.$mN(g.VariableKind.SelectedText,(0,v.localize)(13,null,k))}case"file":return r(g.VariableKind.File);case"fileWorkspaceFolder":return a(g.VariableKind.FileWorkspaceFolder);case"fileWorkspaceFolderBasename":return C.$mc(a(g.VariableKind.FileWorkspaceFolderBasename));case"relativeFile":return u||i?C.$kc(this.n(t(g.VariableKind.RelativeFile)),r(g.VariableKind.RelativeFile)):r(g.VariableKind.RelativeFile);case"relativeFileDirname":{const s=C.$lc(r(g.VariableKind.RelativeFileDirname));if(u||i){const d=C.$kc(this.n(t(g.VariableKind.RelativeFileDirname)),s);return d.length===0?".":d}return s}case"fileDirname":return C.$lc(r(g.VariableKind.FileDirname));case"fileExtname":return C.$nc(r(g.VariableKind.FileExtname));case"fileBasename":return C.$mc(r(g.VariableKind.FileBasename));case"fileBasenameNoExtension":{const s=C.$mc(r(g.VariableKind.FileBasenameNoExtension));return s.slice(0,s.length-C.$nc(s).length)}case"fileDirnameBasename":return C.$mc(C.$lc(r(g.VariableKind.FileDirnameBasename)));case"execPath":{const s=this.a.getExecPath();return s||k}case"execInstallFolder":{const s=this.a.getAppRoot();return s||k}case"pathSeparator":return C.sep;default:try{const s=i?`${w}:${i}`:w;return this.p(g.VariableKind.Unknown,k,s,o,void 0)}catch{return k}}}}p(y,k,w,u,o){if(w&&u){const i=o===void 0?u[w]:u[o+":"+w];if(typeof i=="string")return i;throw new g.$mN(y,(0,v.localize)(14,null,k))}return k}}e.$AN=I}),define(ke[145],Se([1,0,5,141]),function(me,e,C,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$IC=e.$HC=e.OpenEditorContext=e.GroupsOrder=e.$GC=e.MergeGroupMode=e.GroupsArrangement=e.GroupLocation=e.GroupOrientation=e.GroupDirection=e.$FC=void 0,e.$FC=(0,C.$Vh)("editorGroupsService");var f;(function(k){k[k.UP=0]="UP",k[k.DOWN=1]="DOWN",k[k.LEFT=2]="LEFT",k[k.RIGHT=3]="RIGHT"})(f||(e.GroupDirection=f={}));var L;(function(k){k[k.HORIZONTAL=0]="HORIZONTAL",k[k.VERTICAL=1]="VERTICAL"})(L||(e.GroupOrientation=L={}));var M;(function(k){k[k.FIRST=0]="FIRST",k[k.LAST=1]="LAST",k[k.NEXT=2]="NEXT",k[k.PREVIOUS=3]="PREVIOUS"})(M||(e.GroupLocation=M={}));var b;(function(k){k[k.MAXIMIZE=0]="MAXIMIZE",k[k.EXPAND=1]="EXPAND",k[k.EVEN=2]="EVEN"})(b||(e.GroupsArrangement=b={}));var v;(function(k){k[k.COPY_EDITORS=0]="COPY_EDITORS",k[k.MOVE_EDITORS=1]="MOVE_EDITORS"})(v||(e.MergeGroupMode=v={}));function g(k){const w=k;return(0,F.$oE)(w?.editor)&&(0,F.$oE)(w?.replacement)}e.$GC=g;var A;(function(k){k[k.CREATION_TIME=0]="CREATION_TIME",k[k.MOST_RECENTLY_ACTIVE=1]="MOST_RECENTLY_ACTIVE",k[k.GRID_APPEARANCE=2]="GRID_APPEARANCE"})(A||(e.GroupsOrder=A={}));var I;(function(k){k[k.NEW_EDITOR=1]="NEW_EDITOR",k[k.MOVE_EDITOR=2]="MOVE_EDITOR",k[k.COPY_EDITOR=3]="COPY_EDITOR"})(I||(e.OpenEditorContext=I={}));function $(k){const w=k;return!!w&&typeof w.id=="number"&&Array.isArray(w.editors)}e.$HC=$;function y(k){return k.getValue("workbench.editor.openSideBySideDirection")==="down"?1:3}e.$IC=y}),define(ke[291],Se([1,0,5,145]),function(me,e,C,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$MC=e.$LC=e.$KC=e.$JC=void 0,e.$JC=(0,C.$Vh)("editorService"),e.$KC=-1,e.$LC=-2;function f(L){const M=L;return typeof L=="number"||(0,F.$HC)(M)}e.$MC=f}),define(ke[146],Se([1,0,5,134]),function(me,e,C,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$UJ=void 0,e.$UJ=(0,C.$Wh)(F.$3h)}),define(ke[147],Se([1,0,26,4,16,3]),function(me,e,C,F,f,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$W5b=e.$V5b=e.$U5b=e.$T5b=e.$S5b=void 0;class M{constructor(o,i){this.versionId=o,this.removedDueToLooping=i}}e.$S5b=M;class b{static isHostExtension(o,i,n){if(i.getExtensionDescription(o))return!1;const r=n.getExtensionDescription(o);return r?!!((r.main||r.browser)&&r.api==="none"):!1}constructor(o,i){this.j=o,this.c=new F.$Rd,this.onDidChange=this.c.event,this.d=0,this.e=i,this.k()}k(){this.e.sort(k),this.f=new C.$bm,this.g=[],this.h=new Map;for(const o of this.e){if(this.f.has(o.identifier)){console.error("Extension `"+o.identifier.value+"` is already registered");continue}this.f.set(o.identifier,o),this.g.push(o);const i=this.j.readActivationEvents(o);for(const n of i)this.h.has(n)||this.h.set(n,[]),this.h.get(n).push(o)}}set(o){return this.e=o,this.k(),this.d++,this.c.fire(void 0),{versionId:this.d}}deltaExtensions(o,i){this.e=w(this.e,i),this.e=this.e.concat(o);const n=b.l(this.e);return this.e=w(this.e,n.map(r=>r.identifier)),this.k(),this.d++,this.c.fire(void 0),new M(this.d,n)}static l(o){const i=new class{constructor(){this.c=new Map,this.d=new Set,this.e=[]}addNode(s){this.d.has(s)||(this.d.add(s),this.e.push(s))}addArc(s,d){this.addNode(s),this.addNode(d),this.c.has(s)?this.c.get(s).push(d):this.c.set(s,[d])}getArcs(s){return this.c.has(s)?this.c.get(s):[]}hasOnlyGoodArcs(s,d){const c=i.getArcs(s);for(let l=0;l<c.length;l++)if(!d.has(c[l]))return!1;return!0}getNodes(){return this.e}},n=new C.$bm;for(const s of o)if(n.set(s.identifier,s),s.extensionDependencies)for(const d of s.extensionDependencies)i.addArc(C.$_l.toKey(s.identifier),C.$_l.toKey(d));const r=new Set;i.getNodes().filter(s=>i.getArcs(s).length===0).forEach(s=>r.add(s));const a=i.getNodes().filter(s=>!r.has(s));let t;do{t=!1;for(let s=0;s<a.length;s++){const d=a[s];i.hasOnlyGoodArcs(d,r)&&(a.splice(s,1),s--,r.add(d),t=!0)}}while(t);return a.map(s=>n.get(s))}containsActivationEvent(o){return this.h.has(o)}containsExtension(o){return this.f.has(o)}getExtensionDescriptionsForActivationEvent(o){const i=this.h.get(o);return i?i.slice(0):[]}getAllExtensionDescriptions(){return this.g.slice(0)}getSnapshot(){return new v(this.d,this.getAllExtensionDescriptions())}getExtensionDescription(o){const i=this.f.get(o);return i||void 0}getExtensionDescriptionByUUID(o){for(const i of this.g)if(i.uuid===o)return i}getExtensionDescriptionByIdOrUUID(o,i){return this.getExtensionDescription(o)??(i?this.getExtensionDescriptionByUUID(i):void 0)}}e.$T5b=b;class v{constructor(o,i){this.versionId=o,this.extensions=i}}e.$U5b=v;class g{constructor(o){this.d=new $,this.c=new b(o,[])}async acquireLock(o){const i=await this.d.acquire(o);return new A(this,i)}deltaExtensions(o,i,n){if(!o.isAcquiredFor(this))throw new Error("Lock is not held");return this.c.deltaExtensions(i,n)}containsActivationEvent(o){return this.c.containsActivationEvent(o)}containsExtension(o){return this.c.containsExtension(o)}getExtensionDescriptionsForActivationEvent(o){return this.c.getExtensionDescriptionsForActivationEvent(o)}getAllExtensionDescriptions(){return this.c.getAllExtensionDescriptions()}getSnapshot(){return this.c.getSnapshot()}getExtensionDescription(o){return this.c.getExtensionDescription(o)}getExtensionDescriptionByUUID(o){return this.c.getExtensionDescriptionByUUID(o)}getExtensionDescriptionByIdOrUUID(o,i){return this.c.getExtensionDescriptionByIdOrUUID(o,i)}}e.$V5b=g;class A extends L.$Rc{constructor(o,i){super(),this.f=o,this.c=!1,this.B(i)}isAcquiredFor(o){return!this.c&&this.f===o}}e.$W5b=A;class I{constructor(o){this.name=o,this.promise=new Promise((i,n)=>{this.c=i})}resolve(o){this.c(o)}}class ${constructor(){this.c=[],this.d=!1}async acquire(o){const i=new I(o);return this.c.push(i),this.e(),i.promise}e(){if(this.d||this.c.length===0)return;const o=this.c.shift();this.d=!0;let i=!0;const n=setTimeout(()=>{i&&console.warn(`The customer named ${o.name} has been holding on to the lock for 30s. This might be a problem.`)},30*1e3),r=()=>{i&&(clearTimeout(n),i=!1,this.d=!1,this.e())};o.resolve((0,L.$Pc)(r))}}var y;(function(u){u[u.Builtin=0]="Builtin",u[u.User=1]="User",u[u.Dev=2]="Dev"})(y||(y={}));function k(u,o){const i=u.isBuiltin?0:u.isUnderDevelopment?2:1,n=o.isBuiltin?0:o.isUnderDevelopment?2:1;if(i!==n)return i-n;const r=f.$fc.basename(u.extensionLocation.path),a=f.$fc.basename(o.extensionLocation.path);return r<a?-1:r>a?1:0}function w(u,o){const i=new C.$am(o);return u.filter(n=>!i.has(n.identifier))}}),define(ke[292],Se([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hm=e.$Gm=e.$Fm=e.$Em=e.$Dm=e.ExtHostConnectionType=void 0;var C;(function(A){A[A.IPC=1]="IPC",A[A.Socket=2]="Socket",A[A.MessagePort=3]="MessagePort"})(C||(e.ExtHostConnectionType=C={}));class F{static{this.ENV_KEY="VSCODE_EXTHOST_IPC_HOOK"}constructor(I){this.pipeName=I,this.type=1}serialize(I){I[F.ENV_KEY]=this.pipeName}}e.$Dm=F;class f{constructor(){this.type=2}static{this.ENV_KEY="VSCODE_EXTHOST_WILL_SEND_SOCKET"}serialize(I){I[f.ENV_KEY]="1"}}e.$Em=f;class L{constructor(){this.type=3}static{this.ENV_KEY="VSCODE_WILL_SEND_MESSAGE_PORT"}serialize(I){I[L.ENV_KEY]="1"}}e.$Fm=L;function M(A){delete A[F.ENV_KEY],delete A[f.ENV_KEY],delete A[L.ENV_KEY]}function b(A,I){M(I),A.serialize(I)}e.$Gm=b;function v(A){if(A[F.ENV_KEY])return g(A,new F(A[F.ENV_KEY]));if(A[f.ENV_KEY])return g(A,new f);if(A[L.ENV_KEY])return g(A,new L);throw new Error("No connection information defined in environment!")}e.$Hm=v;function g(A,I){return M(A),I}}),define(ke[114],Se([1,0,22]),function(me,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeLogMarkers=e.$im=e.$hm=e.MessageType=e.ExtensionHostExitCode=e.UIKind=void 0;var F;(function(g){g[g.Desktop=1]="Desktop",g[g.Web=2]="Web"})(F||(e.UIKind=F={}));var f;(function(g){g[g.VersionMismatch=55]="VersionMismatch",g[g.UnexpectedError=81]="UnexpectedError"})(f||(e.ExtensionHostExitCode=f={}));var L;(function(g){g[g.Initialized=0]="Initialized",g[g.Ready=1]="Ready",g[g.Terminate=2]="Terminate"})(L||(e.MessageType=L={}));function M(g){const A=C.$fe.alloc(1);switch(g){case 0:A.writeUInt8(1,0);break;case 1:A.writeUInt8(2,0);break;case 2:A.writeUInt8(3,0);break}return A}e.$hm=M;function b(g,A){if(g.byteLength!==1)return!1;switch(g.readUInt8(0)){case 1:return A===0;case 2:return A===1;case 3:return A===2;default:return!1}}e.$im=b;var v;(function(g){g.Start="START_NATIVE_LOG",g.End="END_NATIVE_LOG"})(v||(e.NativeLogMarkers=v={}))}),define(ke[90],Se([1,0,5,4,14,27,114,65,87,24,2,3,218]),function(me,e,C,F,f,L,M,b,v,g,A,I,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$TM=e.$SM=e.$RM=e.$QM=void 0;let y=class extends I.$Rc{constructor(o,i){super(),this.s=o,this.t=i,this.a=this.B(new F.$Rd),this.onDidChangeTelemetryEnabled=this.a.event,this.b=this.B(new F.$Rd),this.onDidChangeTelemetryConfiguration=this.b.event,this.c={usage:!0,error:!0},this.f=0,this.g=!1,this.j=!1,this.r=new Map,this.m=A.URI.revive(this.s.environment.extensionTelemetryLogResource),this.j=this.s.environment.isExtensionTelemetryLoggingOnly,this.n=i.createLogger(this.m,{id:v.$uo,name:(0,$.localize)(0,null,this.j?" (Not Sent)":""),hidden:!0}),this.B(i.onDidChangeLogLevel(n=>{(0,f.$fj)(n)&&this.u()})),this.n.info("Below are logs for extension telemetry events sent to the telemetry output channel API once the log level is set to trace."),this.n.info("===========================================================")}u(){this.t.setVisibility(this.m,this.g&&this.t.getLogLevel()===f.LogLevel.Trace)}getTelemetryConfiguration(){return this.f===3}getTelemetryDetails(){return{isCrashEnabled:this.f>=1,isErrorsEnabled:this.c.error?this.f>=2:!1,isUsageEnabled:this.c.usage?this.f>=3:!1}}instantiateLogger(o,i,n){const r=this.getTelemetryDetails(),a=new k(i,n,o,this.n,this.j,this.getBuiltInCommonProperties(o),{isUsageEnabled:r.isUsageEnabled,isErrorsEnabled:r.isErrorsEnabled}),t=this.r.get(o.identifier.value)??[];return this.r.set(o.identifier.value,[...t,a]),a.apiTelemetryLogger}$initializeTelemetryLevel(o,i,n){this.f=o,this.g=i,this.c=n??{usage:!0,error:!0},this.u()}getBuiltInCommonProperties(o){const i=Object.create(null);switch(i["common.extname"]=`${o.publisher}.${o.name}`,i["common.extversion"]=o.version,i["common.vscodemachineid"]=this.s.telemetryInfo.machineId,i["common.vscodesessionid"]=this.s.telemetryInfo.sessionId,i["common.vscodeversion"]=this.s.version,i["common.isnewappinstall"]=w(this.s.telemetryInfo.firstSessionDate),i["common.product"]=this.s.environment.appHost,this.s.uiKind){case M.UIKind.Web:i["common.uikind"]="web";break;case M.UIKind.Desktop:i["common.uikind"]="desktop";break;default:i["common.uikind"]="unknown"}return i["common.remotename"]=(0,b.$2k)((0,v.$Bo)(this.s.remote.authority)),i}$onDidChangeTelemetryLevel(o){this.h=this.getTelemetryConfiguration(),this.f=o;const i=this.getTelemetryDetails();this.r.forEach((n,r)=>{const a=n.filter(t=>!t.isDisposed);a.length===0?this.r.delete(r):this.r.set(r,a)}),this.r.forEach(n=>{for(const r of n)r.updateTelemetryEnablements(i.isUsageEnabled,i.isErrorsEnabled)}),this.h!==this.getTelemetryConfiguration()&&this.a.fire(this.getTelemetryConfiguration()),this.b.fire(this.getTelemetryDetails()),this.u()}onExtensionError(o,i){const r=this.r.get(o.value)?.filter(t=>!t.isDisposed);if(!r)return this.r.delete(o.value),!1;let a=!1;for(const t of r)t.ignoreUnhandledExtHostErrors||(t.logError(i),a=!0);return a}};e.$QM=y,e.$QM=y=He([Be(0,L.$PM),Be(1,f.$ej)],y);class k{static validateSender(o){if(typeof o!="object")throw new TypeError("TelemetrySender argument is invalid");if(typeof o.sendEventData!="function")throw new TypeError("TelemetrySender.sendEventData must be a function");if(typeof o.sendErrorData!="function")throw new TypeError("TelemetrySender.sendErrorData must be a function");if(typeof o.flush<"u"&&typeof o.flush!="function")throw new TypeError("TelemetrySender.flush must be a function or undefined")}constructor(o,i,n,r,a,t,s){this.g=n,this.h=r,this.i=a,this.j=t,this.a=new F.$Rd,this.ignoreUnhandledExtHostErrors=i?.ignoreUnhandledErrors??!1,this.b=i?.ignoreBuiltInCommonProperties??!1,this.c=i?.additionalCommonProperties,this.f=o,this.d={isUsageEnabled:s.isUsageEnabled,isErrorsEnabled:s.isErrorsEnabled}}updateTelemetryEnablements(o,i){this.e&&(this.d={isUsageEnabled:o,isErrorsEnabled:i},this.a.fire(this.e))}mixInCommonPropsAndCleanData(o){let i="properties"in o?o.properties??{}:o;return i=(0,v.$Eo)(i,[]),this.c&&(i=(0,g.$dn)(i,this.c)),this.b||(i=(0,g.$dn)(i,this.j)),"properties"in o?o.properties=i:o=i,o}k(o,i){this.f&&(this.g.publisher==="vscode"?o=this.g.name+"/"+o:o=this.g.identifier.value+"/"+o,i=this.mixInCommonPropsAndCleanData(i||{}),this.i||this.f?.sendEventData(o,i),this.h.trace(o,i))}logUsage(o,i){this.d.isUsageEnabled&&this.k(o,i)}logError(o,i){if(!(!this.d.isErrorsEnabled||!this.f))if(typeof o=="string")this.k(o,i);else{const n={name:o.name,message:o.message,stack:o.stack,cause:o.cause},r=(0,v.$Eo)(n,[]),a=new Error(r.message,{cause:r.cause});a.stack=r.stack,a.name=r.name,i=this.mixInCommonPropsAndCleanData(i||{}),this.i||this.f.sendErrorData(a,i),this.h.trace("exception",i)}}get apiTelemetryLogger(){if(!this.e){const o=this,i={logUsage:o.logUsage.bind(o),get isUsageEnabled(){return o.d.isUsageEnabled},get isErrorsEnabled(){return o.d.isErrorsEnabled},logError:o.logError.bind(o),dispose:o.dispose.bind(o),onDidChangeEnableStates:o.a.event.bind(o)};this.e=Object.freeze(i)}return this.e}get isDisposed(){return!this.f}dispose(){if(this.f?.flush){let o=this.f;this.f=void 0,Promise.resolve(o.flush()).then(o=void 0),this.e=void 0}else this.f=void 0}}e.$RM=k;function w(u){const o=Date.now()-new Date(u).getTime();return isNaN(o)?!1:o<1e3*60*60*24}e.$SM=w,e.$TM=(0,C.$Vh)("IExtHostTelemetry")}),define(ke[25],Se([1,0,4,2,262,139,26,5]),function(me,e,C,F,f,L,M,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$RF=e.$QF=e.$PF=e.ActivationKind=e.$OF=e.$NF=e.$MF=e.$LF=e.$KF=e.ExtensionHostStartup=e.$JF=e.$IF=e.$HF=e.$GF=void 0,e.$GF=Object.freeze({identifier:new M.$_l("nullExtensionDescription"),name:"Null Extension Description",version:"0.0.0",publisher:"vscode",engines:{vscode:""},extensionLocation:F.URI.parse("void:location"),isBuiltin:!1,targetPlatform:"undefined",isUserBuiltin:!1,isUnderDevelopment:!1}),e.$HF="extensions.webWorker",e.$IF=(0,b.$Vh)("extensionService");class v{constructor(a){this.dependency=a}}e.$JF=v;var g;(function(r){r[r.EagerAutoStart=1]="EagerAutoStart",r[r.EagerManualStart=2]="EagerManualStart",r[r.Lazy=3]="Lazy"})(g||(e.ExtensionHostStartup=g={}));class A{get versionId(){return this.c}get allExtensions(){return this.d}get myExtensions(){return this.e}constructor(a,t,s){this.c=a,this.d=t.slice(0),this.e=s.slice(0),this.f=null}toSnapshot(){return{versionId:this.c,allExtensions:this.d,myExtensions:this.e,activationEvents:L.$xF.createActivationEventsMap(this.d)}}set(a,t,s){if(this.c>a)throw new Error(`ExtensionHostExtensions: invalid versionId ${a} (current: ${this.c})`);const d=[],c=[],l=[],h=[],E=I(this.d),D=I(t),m=(j,R)=>j.extensionLocation.toString()===R.extensionLocation.toString()||j.isBuiltin===R.isBuiltin||j.isUserBuiltin===R.isUserBuiltin||j.isUnderDevelopment===R.isUnderDevelopment;for(const j of this.d){const R=D.get(j.identifier);if(!R){d.push(j.identifier),E.delete(j.identifier);continue}if(!m(j,R)){d.push(j.identifier),E.delete(j.identifier);continue}}for(const j of t){const R=E.get(j.identifier);if(!R){c.push(j);continue}if(!m(R,j)){d.push(R.identifier),E.delete(R.identifier);continue}}const p=new M.$am(this.e),S=new M.$am(s);for(const j of this.e)S.has(j)||l.push(j);for(const j of s)p.has(j)||h.push(j);const P=L.$xF.createActivationEventsMap(c),z={versionId:a,toRemove:d,toAdd:c,addActivationEvents:P,myToRemove:l,myToAdd:h};return this.delta(z),z}delta(a){if(this.c>=a.versionId)return null;const{toRemove:t,toAdd:s,myToRemove:d,myToAdd:c}=a,l=new M.$am(t),h=new M.$am(d);for(let E=0;E<this.d.length;E++)l.has(this.d[E].identifier)&&(this.d.splice(E,1),E--);for(let E=0;E<this.e.length;E++)h.has(this.e[E])&&(this.e.splice(E,1),E--);for(const E of s)this.d.push(E);for(const E of c)this.e.push(E);return this.f=null,a}containsExtension(a){for(const t of this.e)if(M.$_l.equals(t,a))return!0;return!1}containsActivationEvent(a){return this.f||(this.f=this.g()),this.f.has(a)}g(){const a=new Set;for(const t of this.d){if(!this.containsExtension(t.identifier))continue;const s=L.$xF.readActivationEvents(t);for(const d of s)a.add(d)}return a}}e.$KF=A;function I(r){const a=new M.$bm;for(const t of r)a.set(t.identifier,t);return a}function $(r,a){return r.enabledApiProposals?r.enabledApiProposals.includes(a):!1}e.$LF=$;function y(r,a){if(!$(r,a))throw new Error(`Extension '${r.identifier.value}' CANNOT use API proposal: ${a}.
Its package.json#enabledApiProposals-property declares: ${r.enabledApiProposals?.join(", ")??"[]"} but NOT ${a}.
 The missing proposal MUST be added and you must start in extension development mode or use the following command line switch: --enable-proposed-api ${r.identifier.value}`)}e.$MF=y;class k{constructor(a,t,s,d){this.codeLoadingTime=a,this.activateCallTime=t,this.activateResolvedTime=s,this.activationReason=d}}e.$NF=k;class w{constructor(a,t){this.description=a,this.value=t}}e.$OF=w;var u;(function(r){r[r.Normal=0]="Normal",r[r.Immediate=1]="Immediate"})(u||(e.ActivationKind=u={}));function o(r){return{type:r.isBuiltin?0:1,isBuiltin:r.isBuiltin||r.isUserBuiltin,identifier:{id:(0,f.$Ko)(r.publisher,r.name),uuid:r.uuid},manifest:r,location:r.extensionLocation,targetPlatform:r.targetPlatform,validations:[],isValid:!0}}e.$PF=o;function i(r,a){return{identifier:new M.$_l((0,f.$Io)(r.manifest.publisher,r.manifest.name)),isBuiltin:r.type===0,isUserBuiltin:r.type===1&&r.isBuiltin,isUnderDevelopment:!!a,extensionLocation:r.location,...r.manifest,uuid:r.identifier.uuid,targetPlatform:r.targetPlatform}}e.$QF=i;class n{constructor(){this.onDidRegisterExtensions=C.Event.None,this.onDidChangeExtensionsStatus=C.Event.None,this.onDidChangeExtensions=C.Event.None,this.onWillActivateByEvent=C.Event.None,this.onDidChangeResponsiveChange=C.Event.None,this.onWillStop=C.Event.None,this.extensions=[]}activateByEvent(a){return Promise.resolve(void 0)}activateById(a,t){return Promise.resolve(void 0)}activationEventIsDone(a){return!1}whenInstalledExtensionsRegistered(){return Promise.resolve(!0)}getExtension(){return Promise.resolve(void 0)}readExtensionPointContributions(a){return Promise.resolve(Object.create(null))}getExtensionsStatus(){return Object.create(null)}getInspectPorts(a,t){return Promise.resolve([])}stopExtensionHosts(){}async startExtensionHosts(){}async setRemoteEnvironment(a){}canAddExtension(){return!1}canRemoveExtension(){return!1}}e.$RF=n}),define(ke[293],Se([1,0,8,147,26,25,14,12]),function(me,e,C,F,f,L,M,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mec=e.$lec=e.$kec=e.$jec=e.$iec=e.$hec=void 0;class v{static{this.NONE=new v(!1,-1,-1,-1)}constructor(o,i,n,r){this.startup=o,this.codeLoadingTime=i,this.activateCallTime=n,this.activateResolvedTime=r}}e.$hec=v;class g{constructor(o){this.a=o,this.b=-1,this.c=-1,this.d=-1,this.f=-1,this.g=-1,this.h=-1}j(o,i){return o===-1||i===-1?-1:i-o}build(){return new v(this.a,this.j(this.b,this.c),this.j(this.d,this.f),this.j(this.g,this.h))}codeLoadingStart(){this.b=Date.now()}codeLoadingStop(){this.c=Date.now()}activateCallStart(){this.d=Date.now()}activateCallStop(){this.f=Date.now()}activateResolveStart(){this.g=Date.now()}activateResolveStop(){this.h=Date.now()}}e.$iec=g;class A{constructor(o,i,n,r,a,t){this.activationFailed=o,this.activationFailedError=i,this.activationTimes=n,this.module=r,this.exports=a,this.subscriptions=t}}e.$jec=A;class I extends A{constructor(o){super(!1,null,o,{activate:void 0,deactivate:void 0},void 0,[])}}e.$kec=I;class $ extends A{constructor(){super(!1,null,v.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.$lec=$;class y extends A{constructor(o){super(!0,o,v.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}let k=class{constructor(o,i,n,r){this.g=r,this.a=o,this.b=i,this.c=n,this.d=new f.$bm,this.f=Object.create(null)}dispose(){for(const[o,i]of this.d)i.dispose()}async waitForActivatingExtensions(){const o=[];for(const[i,n]of this.d)o.push(n.wait());await Promise.all(o)}isActivated(o){const i=this.d.get(o);return!!(i&&i.value)}getActivatedExtension(o){const i=this.d.get(o);if(!i||!i.value)throw new Error(`Extension '${o.value}' is not known or not activated`);return i.value}async activateByEvent(o,i){if(this.f[o])return;const n=this.a.getExtensionDescriptionsForActivationEvent(o);await this.h(n.map(r=>({id:r.identifier,reason:{startup:i,extensionId:r.identifier,activationEvent:o}}))),this.f[o]=!0}activateById(o,i){const n=this.a.getExtensionDescription(o);if(!n)throw new Error(`Extension '${o}' is not known`);return this.h([{id:n.identifier,reason:i}])}async h(o){const i=o.filter(n=>!this.isActivated(n.id)).map(n=>this.j(n));await Promise.all(i.map(n=>n.wait()))}j(o){if(this.d.has(o.id))return this.d.get(o.id);if(this.l(o.id))return this.k(o,null,[],null);const i=this.a.getExtensionDescription(o.id);if(!i){const a=new Error(`Cannot activate unknown extension '${o.id.value}'`),t=this.k(o,null,[],new y(a));return this.c.onExtensionActivationError(o.id,a,new L.$JF(o.id.value)),t}const n=[],r=typeof i.extensionDependencies>"u"?[]:i.extensionDependencies;for(const a of r){if(this.m(a))continue;const t=this.d.get(a);if(t){n.push(t);continue}if(this.l(a)){n.push(this.j({id:this.b.getExtensionDescription(a).identifier,reason:o.reason}));continue}const s=this.a.getExtensionDescription(a);if(s){if(!s.main&&!s.browser)continue;n.push(this.j({id:s.identifier,reason:o.reason}));continue}const d=i.displayName||i.identifier.value,c=new Error(`Cannot activate the '${d}' extension because it depends on unknown extension '${a}'`),l=this.k(o,i.displayName,[],new y(c));return this.c.onExtensionActivationError(i.identifier,c,new L.$JF(a)),l}return this.k(o,i.displayName,n,null)}k(o,i,n,r){const a=new w(o.id,i,o.reason,n,r,this.c,this.g);return this.d.set(o.id,a),a}l(o){return F.$T5b.isHostExtension(o,this.a,this.b)}m(o){const i=this.b.getExtensionDescription(o);return i?!i.main&&!i.browser:!1}};e.$mec=k,e.$mec=k=He([Be(3,M.$dj)],k);let w=class{get value(){return this.h}get friendlyName(){return this.d||this.c.value}constructor(o,i,n,r,a,t,s){this.c=o,this.d=i,this.f=n,this.g=r,this.h=a,this.j=t,this.k=s,this.a=new b.$Wg,this.b=!1,this.l()}dispose(){this.b=!0}wait(){return this.a.wait()}async l(){await this.m(),this.a.open()}async m(){if(!this.h){for(;this.g.length>0;){for(let o=0;o<this.g.length;o++){const i=this.g[o];if(i.value&&!i.value.activationFailed){this.g.splice(o,1),o--;continue}if(i.value&&i.value.activationFailed){const n=new Error(`Cannot activate the '${this.friendlyName}' extension because its dependency '${i.friendlyName}' failed to activate`);n.detail=i.value.activationFailedError,this.h=new y(n),this.j.onExtensionActivationError(this.c,n,null);return}}this.g.length>0&&await Promise.race(this.g.map(o=>o.wait()))}await this.n()}}async n(){try{this.h=await this.j.actualActivateExtension(this.c,this.f)}catch(o){const i=new Error;if(o&&o.name&&(i.name=o.name),o&&o.message?i.message=`Activating extension '${this.c.value}' failed: ${o.message}.`:i.message=`Activating extension '${this.c.value}' failed: ${o}.`,o&&o.stack&&(i.stack=o.stack),this.h=new y(i),this.b&&C.$3(o))return;this.j.onExtensionActivationError(this.c,i,null),this.k.error(`Activating extension ${this.c.value} failed due to an error:`),this.k.error(o)}}};w=He([Be(6,M.$dj)],w)}),define(ke[15],Se([1,0,19,22,165,74,80,28,161,54,100,24,18,2,29,83,136,144,141,111,67,89,291,7,25]),function(me,e,C,F,f,L,M,b,v,g,A,I,$,y,k,w,u,o,i,n,r,a,t,s,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminalQuickFix=e.ChatResponseProgress=e.InteractiveEditorResponseFeedbackKind=e.ChatVariableLevel=e.ChatVariable=e.ChatMessageRole=e.ChatMessage=e.ChatFollowup=e.ChatReplyFollowup=e.DataTransfer=e.DataTransferItem=e.ViewBadge=e.TypeHierarchyItem=e.CodeActionTriggerKind=e.TestCoverage=e.TestResults=e.TestItem=e.TestTag=e.TestMessage=e.NotebookRendererScript=e.NotebookDocumentContentOptions=e.NotebookKernelSourceAction=e.NotebookStatusBarItem=e.NotebookExclusiveDocumentPattern=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookCellData=e.NotebookData=e.NotebookCellKind=e.NotebookCellExecutionState=e.NotebookCellExecutionSummary=e.NotebookRange=e.MappedEditsContext=e.LanguageSelector=e.GlobPattern=e.TextEditorOpenOptions=e.FoldingRangeKind=e.FoldingRange=e.ProgressLocation=e.EndOfLine=e.TextEditorLineNumbersStyle=e.TextDocumentSaveReason=e.SelectionRange=e.Color=e.ColorPresentation=e.DocumentLink=e.InlayHintKind=e.InlayHintLabelPart=e.InlayHint=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.CompletionItem=e.CompletionItemKind=e.CompletionItemTag=e.CompletionContext=e.CompletionTriggerKind=e.DocumentHighlight=e.InlineValueContext=e.InlineValue=e.EvaluatableExpression=e.Hover=e.DefinitionLink=e.location=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.DocumentSymbol=e.WorkspaceSymbol=e.SymbolTag=e.SymbolKind=e.WorkspaceEdit=e.TextEdit=e.DecorationRenderOptions=e.DecorationRangeBehavior=e.ThemableDecorationRenderOptions=e.ThemableDecorationAttachmentRenderOptions=e.$yM=e.$xM=e.MarkdownString=e.$wM=e.ViewColumn=e.DiagnosticSeverity=e.DiagnosticRelatedInformation=e.Diagnostic=e.DiagnosticTag=e.DocumentSelector=e.Position=e.TokenType=e.Range=e.Selection=void 0;var c;(function(Me){function Fe(se){const{selectionStartLineNumber:Te,selectionStartColumn:qe,positionLineNumber:xe,positionColumn:Qe}=se,ot=new s.$AK(Te-1,qe-1),pt=new s.$AK(xe-1,Qe-1);return new s.$CK(ot,pt)}Me.to=Fe;function Ce(se){const{anchor:Te,active:qe}=se;return{selectionStartLineNumber:Te.line+1,selectionStartColumn:Te.character+1,positionLineNumber:qe.line+1,positionColumn:qe.character+1}}Me.from=Ce})(c||(e.Selection=c={}));var l;(function(Me){function Fe(se){if(!se)return;const{start:Te,end:qe}=se;return{startLineNumber:Te.line+1,startColumn:Te.character+1,endLineNumber:qe.line+1,endColumn:qe.character+1}}Me.from=Fe;function Ce(se){if(!se)return;const{startLineNumber:Te,startColumn:qe,endLineNumber:xe,endColumn:Qe}=se;return new s.$BK(Te-1,qe-1,xe-1,Qe-1)}Me.to=Ce})(l||(e.Range=l={}));var h;(function(Me){function Fe(Ce){switch(Ce){case 1:return s.StandardTokenType.Comment;case 0:return s.StandardTokenType.Other;case 3:return s.StandardTokenType.RegEx;case 2:return s.StandardTokenType.String}}Me.to=Fe})(h||(e.TokenType=h={}));var E;(function(Me){function Fe(se){return new s.$AK(se.lineNumber-1,se.column-1)}Me.to=Fe;function Ce(se){return{lineNumber:se.line+1,column:se.character+1}}Me.from=Ce})(E||(e.Position=E={}));var D;(function(Me){function Fe(Te,qe,xe){return(0,C.$Gb)((0,C.$2b)(Te).map(Qe=>Ce(Qe,qe,xe)))}Me.from=Fe;function Ce(Te,qe,xe){if(typeof Te=="string")return{$serialized:!0,language:Te,isBuiltin:xe?.isBuiltin};if(Te)return{$serialized:!0,language:Te.language,scheme:se(Te.scheme,qe),pattern:ue.from(Te.pattern)??void 0,exclusive:Te.exclusive,notebookType:Te.notebookType,isBuiltin:xe?.isBuiltin}}function se(Te,qe){return qe&&typeof Te=="string"?qe.transformOutgoingScheme(Te):Te}})(D||(e.DocumentSelector=D={}));var m;(function(Me){function Fe(se){switch(se){case s.DiagnosticTag.Unnecessary:return 1;case s.DiagnosticTag.Deprecated:return 2}}Me.from=Fe;function Ce(se){switch(se){case 1:return s.DiagnosticTag.Unnecessary;case 2:return s.DiagnosticTag.Deprecated;default:return}}Me.to=Ce})(m||(e.DiagnosticTag=m={}));var p;(function(Me){function Fe(se){let Te;return se.code&&((0,$.$Cf)(se.code)||(0,$.$Gf)(se.code)?Te=String(se.code):Te={value:String(se.code.value),target:se.code.target}),{...l.from(se.range),message:se.message,source:se.source,code:Te,severity:P.from(se.severity),relatedInformation:se.relatedInformation&&se.relatedInformation.map(S.from),tags:Array.isArray(se.tags)?(0,C.$Gb)(se.tags.map(m.from)):void 0}}Me.from=Fe;function Ce(se){const Te=new s.$NK(l.to(se),se.message,P.to(se.severity));return Te.source=se.source,Te.code=(0,$.$Cf)(se.code)?se.code:se.code?.value,Te.relatedInformation=se.relatedInformation&&se.relatedInformation.map(S.to),Te.tags=se.tags&&(0,C.$Gb)(se.tags.map(m.to)),Te}Me.to=Ce})(p||(e.Diagnostic=p={}));var S;(function(Me){function Fe(se){return{...l.from(se.location.range),message:se.message,resource:se.location.uri}}Me.from=Fe;function Ce(se){return new s.$MK(new s.$LK(se.resource,l.to(se)),se.message)}Me.to=Ce})(S||(e.DiagnosticRelatedInformation=S={}));var P;(function(Me){function Fe(se){switch(se){case s.DiagnosticSeverity.Error:return u.MarkerSeverity.Error;case s.DiagnosticSeverity.Warning:return u.MarkerSeverity.Warning;case s.DiagnosticSeverity.Information:return u.MarkerSeverity.Info;case s.DiagnosticSeverity.Hint:return u.MarkerSeverity.Hint}return u.MarkerSeverity.Error}Me.from=Fe;function Ce(se){switch(se){case u.MarkerSeverity.Info:return s.DiagnosticSeverity.Information;case u.MarkerSeverity.Warning:return s.DiagnosticSeverity.Warning;case u.MarkerSeverity.Error:return s.DiagnosticSeverity.Error;case u.MarkerSeverity.Hint:return s.DiagnosticSeverity.Hint;default:return s.DiagnosticSeverity.Error}}Me.to=Ce})(P||(e.DiagnosticSeverity=P={}));var z;(function(Me){function Fe(se){return typeof se=="number"&&se>=s.ViewColumn.One?se-1:se===s.ViewColumn.Beside?t.$LC:t.$KC}Me.from=Fe;function Ce(se){if(typeof se=="number"&&se>=0)return se+1;throw new Error("invalid 'EditorGroupColumn'")}Me.to=Ce})(z||(e.ViewColumn=z={}));function j(Me){return typeof Me.range<"u"}function R(Me){return Me.length===0?!0:!!j(Me[0])}e.$wM=R;var T;(function(Me){function Fe(Qe){return Qe.map(Me.from)}Me.fromMany=Fe;function Ce(Qe){return Qe&&typeof Qe=="object"&&typeof Qe.language=="string"&&typeof Qe.value=="string"}function se(Qe){let ot;if(Ce(Qe)){const{language:ht,value:Lt}=Qe;ot={value:"```"+ht+`
`+Lt+"\n```\n"}}else s.$ZK.isMarkdownString(Qe)?ot={value:Qe.value,isTrusted:Qe.isTrusted,supportThemeIcons:Qe.supportThemeIcons,supportHtml:Qe.supportHtml,baseUri:Qe.baseUri}:typeof Qe=="string"?ot={value:Qe}:ot={value:""};const pt=Object.create(null);ot.uris=pt;const bt=ht=>{try{let Lt=y.URI.parse(ht,!0);Lt=Lt.with({query:Te(Lt.query,pt)}),pt[ht]=Lt}catch{}return""},vt=new v.marked.Renderer;return vt.link=bt,vt.image=ht=>typeof ht=="string"?bt(M.$dk(ht).href):"",(0,v.marked)(ot.value,{renderer:vt}),ot}Me.from=se;function Te(Qe,ot){if(!Qe)return Qe;let pt;try{pt=(0,g.$rh)(Qe)}catch{}if(!pt)return Qe;let bt=!1;return pt=(0,I.$cn)(pt,vt=>{if(y.URI.isUri(vt)){const ht=`__uri_${Math.random().toString(16).slice(2,8)}`;return ot[ht]=vt,bt=!0,ht}else return}),bt?JSON.stringify(pt):Qe}function qe(Qe){const ot=new s.$ZK(Qe.value,Qe.supportThemeIcons);return ot.isTrusted=Qe.isTrusted,ot.supportHtml=Qe.supportHtml,ot.baseUri=Qe.baseUri?y.URI.from(Qe.baseUri):void 0,ot}Me.to=qe;function xe(Qe){if(Qe)return typeof Qe=="string"?Qe:Me.from(Qe)}Me.fromStrict=xe})(T||(e.MarkdownString=T={}));function N(Me){return R(Me)?Me.map(Fe=>({range:l.from(Fe.range),hoverMessage:Array.isArray(Fe.hoverMessage)?T.fromMany(Fe.hoverMessage):Fe.hoverMessage?T.from(Fe.hoverMessage):void 0,renderOptions:Fe.renderOptions})):Me.map(Fe=>({range:l.from(Fe)}))}e.$xM=N;function O(Me){return typeof Me>"u"?Me:typeof Me=="string"?y.URI.file(Me):Me}e.$yM=O;var W;(function(Me){function Fe(Ce){return typeof Ce>"u"?Ce:{contentText:Ce.contentText,contentIconPath:Ce.contentIconPath?O(Ce.contentIconPath):void 0,border:Ce.border,borderColor:Ce.borderColor,fontStyle:Ce.fontStyle,fontWeight:Ce.fontWeight,textDecoration:Ce.textDecoration,color:Ce.color,backgroundColor:Ce.backgroundColor,margin:Ce.margin,width:Ce.width,height:Ce.height}}Me.from=Fe})(W||(e.ThemableDecorationAttachmentRenderOptions=W={}));var x;(function(Me){function Fe(Ce){return typeof Ce>"u"?Ce:{backgroundColor:Ce.backgroundColor,outline:Ce.outline,outlineColor:Ce.outlineColor,outlineStyle:Ce.outlineStyle,outlineWidth:Ce.outlineWidth,border:Ce.border,borderColor:Ce.borderColor,borderRadius:Ce.borderRadius,borderSpacing:Ce.borderSpacing,borderStyle:Ce.borderStyle,borderWidth:Ce.borderWidth,fontStyle:Ce.fontStyle,fontWeight:Ce.fontWeight,textDecoration:Ce.textDecoration,cursor:Ce.cursor,color:Ce.color,opacity:Ce.opacity,letterSpacing:Ce.letterSpacing,gutterIconPath:Ce.gutterIconPath?O(Ce.gutterIconPath):void 0,gutterIconSize:Ce.gutterIconSize,overviewRulerColor:Ce.overviewRulerColor,before:Ce.before?W.from(Ce.before):void 0,after:Ce.after?W.from(Ce.after):void 0}}Me.from=Fe})(x||(e.ThemableDecorationRenderOptions=x={}));var le;(function(Me){function Fe(Ce){if(typeof Ce>"u")return Ce;switch(Ce){case s.DecorationRangeBehavior.OpenOpen:return 0;case s.DecorationRangeBehavior.ClosedClosed:return 1;case s.DecorationRangeBehavior.OpenClosed:return 2;case s.DecorationRangeBehavior.ClosedOpen:return 3}}Me.from=Fe})(le||(e.DecorationRangeBehavior=le={}));var G;(function(Me){function Fe(Ce){return{isWholeLine:Ce.isWholeLine,rangeBehavior:Ce.rangeBehavior?le.from(Ce.rangeBehavior):void 0,overviewRulerLane:Ce.overviewRulerLane,light:Ce.light?x.from(Ce.light):void 0,dark:Ce.dark?x.from(Ce.dark):void 0,backgroundColor:Ce.backgroundColor,outline:Ce.outline,outlineColor:Ce.outlineColor,outlineStyle:Ce.outlineStyle,outlineWidth:Ce.outlineWidth,border:Ce.border,borderColor:Ce.borderColor,borderRadius:Ce.borderRadius,borderSpacing:Ce.borderSpacing,borderStyle:Ce.borderStyle,borderWidth:Ce.borderWidth,fontStyle:Ce.fontStyle,fontWeight:Ce.fontWeight,textDecoration:Ce.textDecoration,cursor:Ce.cursor,color:Ce.color,opacity:Ce.opacity,letterSpacing:Ce.letterSpacing,gutterIconPath:Ce.gutterIconPath?O(Ce.gutterIconPath):void 0,gutterIconSize:Ce.gutterIconSize,overviewRulerColor:Ce.overviewRulerColor,before:Ce.before?W.from(Ce.before):void 0,after:Ce.after?W.from(Ce.after):void 0}}Me.from=Fe})(G||(e.DecorationRenderOptions=G={}));var J;(function(Me){function Fe(se){return{text:se.newText,eol:se.newEol&&Ae.from(se.newEol),range:l.from(se.range)}}Me.from=Fe;function Ce(se){const Te=new s.$GK(l.to(se.range),se.text);return Te.newEol=typeof se.eol>"u"?void 0:Ae.to(se.eol),Te}Me.to=Ce})(J||(e.TextEdit=J={}));var Q;(function(Me){function Fe(se,Te){const qe={edits:[]};if(se instanceof s.$JK){const xe=new b.$Ac;for(const Qe of se._allEntries())Qe._type===1&&y.URI.isUri(Qe.to)&&Qe.from===void 0&&xe.add(Qe.to);for(const Qe of se._allEntries())if(Qe._type===1){let ot;Qe.options?.contents&&(ArrayBuffer.isView(Qe.options.contents)?ot={type:"base64",value:(0,F.$ze)(F.$fe.wrap(Qe.options.contents))}:ot={type:"dataTransferItem",id:Qe.options.contents._itemId}),qe.edits.push({oldResource:Qe.from,newResource:Qe.to,options:{...Qe.options,contents:ot},metadata:Qe.metadata})}else Qe._type===2?qe.edits.push({resource:Qe.uri,textEdit:J.from(Qe.edit),versionId:xe.has(Qe.uri)?void 0:Te?.getTextDocumentVersion(Qe.uri),metadata:Qe.metadata}):Qe._type===6?qe.edits.push({resource:Qe.uri,textEdit:{range:l.from(Qe.range),text:Qe.edit.value,insertAsSnippet:!0},versionId:xe.has(Qe.uri)?void 0:Te?.getTextDocumentVersion(Qe.uri),metadata:Qe.metadata}):Qe._type===3?qe.edits.push({metadata:Qe.metadata,resource:Qe.uri,cellEdit:Qe.edit,notebookMetadata:Qe.notebookMetadata,notebookVersionId:Te?.getNotebookDocumentVersion(Qe.uri)}):Qe._type===5&&qe.edits.push({metadata:Qe.metadata,resource:Qe.uri,notebookVersionId:Te?.getNotebookDocumentVersion(Qe.uri),cellEdit:{editType:1,index:Qe.index,count:Qe.count,cells:Qe.cells.map(wt.from)}})}return qe}Me.from=Fe;function Ce(se){const Te=new s.$JK,qe=new b.$zc;for(const xe of se.edits)if(xe.textEdit){const Qe=xe,ot=y.URI.revive(Qe.resource),pt=l.to(Qe.textEdit.range),bt=Qe.textEdit.text,vt=Qe.textEdit.insertAsSnippet;let ht;vt?ht=s.$IK.replace(pt,new s.$KK(bt)):ht=s.$GK.replace(pt,bt);const Lt=qe.get(ot);Lt?Lt.push(ht):qe.set(ot,[ht])}else Te.renameFile(y.URI.revive(xe.oldResource),y.URI.revive(xe.newResource),xe.options);for(const[xe,Qe]of qe)Te.set(xe,Qe);return Te}Me.to=Ce})(Q||(e.WorkspaceEdit=Q={}));var oe;(function(Me){const Fe=Object.create(null);Fe[s.SymbolKind.File]=0,Fe[s.SymbolKind.Module]=1,Fe[s.SymbolKind.Namespace]=2,Fe[s.SymbolKind.Package]=3,Fe[s.SymbolKind.Class]=4,Fe[s.SymbolKind.Method]=5,Fe[s.SymbolKind.Property]=6,Fe[s.SymbolKind.Field]=7,Fe[s.SymbolKind.Constructor]=8,Fe[s.SymbolKind.Enum]=9,Fe[s.SymbolKind.Interface]=10,Fe[s.SymbolKind.Function]=11,Fe[s.SymbolKind.Variable]=12,Fe[s.SymbolKind.Constant]=13,Fe[s.SymbolKind.String]=14,Fe[s.SymbolKind.Number]=15,Fe[s.SymbolKind.Boolean]=16,Fe[s.SymbolKind.Array]=17,Fe[s.SymbolKind.Object]=18,Fe[s.SymbolKind.Key]=19,Fe[s.SymbolKind.Null]=20,Fe[s.SymbolKind.EnumMember]=21,Fe[s.SymbolKind.Struct]=22,Fe[s.SymbolKind.Event]=23,Fe[s.SymbolKind.Operator]=24,Fe[s.SymbolKind.TypeParameter]=25;function Ce(Te){return typeof Fe[Te]=="number"?Fe[Te]:6}Me.from=Ce;function se(Te){for(const qe in Fe)if(Fe[qe]===Te)return Number(qe);return s.SymbolKind.Property}Me.to=se})(oe||(e.SymbolKind=oe={}));var _;(function(Me){function Fe(se){switch(se){case s.SymbolTag.Deprecated:return 1}}Me.from=Fe;function Ce(se){switch(se){case 1:return s.SymbolTag.Deprecated}}Me.to=Ce})(_||(e.SymbolTag=_={}));var Ee;(function(Me){function Fe(se){return{name:se.name,kind:oe.from(se.kind),tags:se.tags&&se.tags.map(_.from),containerName:se.containerName,location:be.from(se.location)}}Me.from=Fe;function Ce(se){const Te=new s.$QK(se.name,oe.to(se.kind),se.containerName,be.to(se.location));return Te.tags=se.tags&&se.tags.map(_.to),Te}Me.to=Ce})(Ee||(e.WorkspaceSymbol=Ee={}));var he;(function(Me){function Fe(se){const Te={name:se.name||"!!MISSING: name!!",detail:se.detail,range:l.from(se.range),selectionRange:l.from(se.selectionRange),kind:oe.from(se.kind),tags:se.tags?.map(_.from)??[]};return se.children&&(Te.children=se.children.map(Fe)),Te}Me.from=Fe;function Ce(se){const Te=new s.$RK(se.name,se.detail,oe.to(se.kind),l.to(se.range),l.to(se.selectionRange));return(0,C.$Kb)(se.tags)&&(Te.tags=se.tags.map(_.to)),se.children&&(Te.children=se.children.map(Ce)),Te}Me.to=Ce})(he||(e.DocumentSymbol=he={}));var q;(function(Me){function Fe(se){const Te=new s.$VK(oe.to(se.kind),se.name,se.detail||"",y.URI.revive(se.uri),l.to(se.range),l.to(se.selectionRange));return Te._sessionId=se._sessionId,Te._itemId=se._itemId,Te}Me.to=Fe;function Ce(se,Te,qe){if(Te=Te??se._sessionId,qe=qe??se._itemId,Te===void 0||qe===void 0)throw new Error("invalid item");return{_sessionId:Te,_itemId:qe,name:se.name,detail:se.detail,kind:oe.from(se.kind),uri:se.uri,range:l.from(se.range),selectionRange:l.from(se.selectionRange),tags:se.tags?.map(_.from)}}Me.from=Ce})(q||(e.CallHierarchyItem=q={}));var U;(function(Me){function Fe(Ce){return new s.$WK(q.to(Ce.from),Ce.fromRanges.map(se=>l.to(se)))}Me.to=Fe})(U||(e.CallHierarchyIncomingCall=U={}));var ie;(function(Me){function Fe(Ce){return new s.$XK(q.to(Ce.to),Ce.fromRanges.map(se=>l.to(se)))}Me.to=Fe})(ie||(e.CallHierarchyOutgoingCall=ie={}));var be;(function(Me){function Fe(se){return{range:se.range&&l.from(se.range),uri:se.uri}}Me.from=Fe;function Ce(se){return new s.$LK(y.URI.revive(se.uri),l.to(se.range))}Me.to=Ce})(be||(e.location=be={}));var H;(function(Me){function Fe(se){const Te=se,qe=se;return{originSelectionRange:Te.originSelectionRange?l.from(Te.originSelectionRange):void 0,uri:Te.targetUri?Te.targetUri:qe.uri,range:l.from(Te.targetRange?Te.targetRange:qe.range),targetSelectionRange:Te.targetSelectionRange?l.from(Te.targetSelectionRange):void 0}}Me.from=Fe;function Ce(se){return{targetUri:y.URI.revive(se.uri),targetRange:l.to(se.range),targetSelectionRange:se.targetSelectionRange?l.to(se.targetSelectionRange):void 0,originSelectionRange:se.originSelectionRange?l.to(se.originSelectionRange):void 0}}Me.to=Ce})(H||(e.DefinitionLink=H={}));var Y;(function(Me){function Fe(se){return{range:l.from(se.range),contents:T.fromMany(se.contents)}}Me.from=Fe;function Ce(se){return new s.$OK(se.contents.map(T.to),l.to(se.range))}Me.to=Ce})(Y||(e.Hover=Y={}));var Z;(function(Me){function Fe(se){return{range:l.from(se.range),expression:se.expression}}Me.from=Fe;function Ce(se){return new s.$HL(l.to(se.range),se.expression)}Me.to=Ce})(Z||(e.EvaluatableExpression=Z={}));var $e;(function(Me){function Fe(se){if(se instanceof s.$IL)return{type:"text",range:l.from(se.range),text:se.text};if(se instanceof s.$JL)return{type:"variable",range:l.from(se.range),variableName:se.variableName,caseSensitiveLookup:se.caseSensitiveLookup};if(se instanceof s.$KL)return{type:"expression",range:l.from(se.range),expression:se.expression};throw new Error("Unknown 'InlineValue' type")}Me.from=Fe;function Ce(se){switch(se.type){case"text":return{range:l.to(se.range),text:se.text};case"variable":return{range:l.to(se.range),variableName:se.variableName,caseSensitiveLookup:se.caseSensitiveLookup};case"expression":return{range:l.to(se.range),expression:se.expression}}}Me.to=Ce})($e||(e.InlineValue=$e={}));var ne;(function(Me){function Fe(se){return{frameId:se.frameId,stoppedLocation:l.from(se.stoppedLocation)}}Me.from=Fe;function Ce(se){return new s.$LL(se.frameId,l.to(se.stoppedLocation))}Me.to=Ce})(ne||(e.InlineValueContext=ne={}));var fe;(function(Me){function Fe(se){return{range:l.from(se.range),kind:se.kind}}Me.from=Fe;function Ce(se){return new s.$PK(l.to(se.range),se.kind)}Me.to=Ce})(fe||(e.DocumentHighlight=fe={}));var te;(function(Me){function Fe(Ce){switch(Ce){case 1:return s.CompletionTriggerKind.TriggerCharacter;case 2:return s.CompletionTriggerKind.TriggerForIncompleteCompletions;case 0:default:return s.CompletionTriggerKind.Invoke}}Me.to=Fe})(te||(e.CompletionTriggerKind=te={}));var de;(function(Me){function Fe(Ce){return{triggerKind:te.to(Ce.triggerKind),triggerCharacter:Ce.triggerCharacter}}Me.to=Fe})(de||(e.CompletionContext=de={}));var pe;(function(Me){function Fe(se){switch(se){case s.CompletionItemTag.Deprecated:return 1}}Me.from=Fe;function Ce(se){switch(se){case 1:return s.CompletionItemTag.Deprecated}}Me.to=Ce})(pe||(e.CompletionItemTag=pe={}));var Pe;(function(Me){const Fe=new Map([[s.CompletionItemKind.Method,0],[s.CompletionItemKind.Function,1],[s.CompletionItemKind.Constructor,2],[s.CompletionItemKind.Field,3],[s.CompletionItemKind.Variable,4],[s.CompletionItemKind.Class,5],[s.CompletionItemKind.Interface,7],[s.CompletionItemKind.Struct,6],[s.CompletionItemKind.Module,8],[s.CompletionItemKind.Property,9],[s.CompletionItemKind.Unit,12],[s.CompletionItemKind.Value,13],[s.CompletionItemKind.Constant,14],[s.CompletionItemKind.Enum,15],[s.CompletionItemKind.EnumMember,16],[s.CompletionItemKind.Keyword,17],[s.CompletionItemKind.Snippet,27],[s.CompletionItemKind.Text,18],[s.CompletionItemKind.Color,19],[s.CompletionItemKind.File,20],[s.CompletionItemKind.Reference,21],[s.CompletionItemKind.Folder,23],[s.CompletionItemKind.Event,10],[s.CompletionItemKind.Operator,11],[s.CompletionItemKind.TypeParameter,24],[s.CompletionItemKind.Issue,26],[s.CompletionItemKind.User,25]]);function Ce(qe){return Fe.get(qe)??9}Me.from=Ce;const se=new Map([[0,s.CompletionItemKind.Method],[1,s.CompletionItemKind.Function],[2,s.CompletionItemKind.Constructor],[3,s.CompletionItemKind.Field],[4,s.CompletionItemKind.Variable],[5,s.CompletionItemKind.Class],[7,s.CompletionItemKind.Interface],[6,s.CompletionItemKind.Struct],[8,s.CompletionItemKind.Module],[9,s.CompletionItemKind.Property],[12,s.CompletionItemKind.Unit],[13,s.CompletionItemKind.Value],[14,s.CompletionItemKind.Constant],[15,s.CompletionItemKind.Enum],[16,s.CompletionItemKind.EnumMember],[17,s.CompletionItemKind.Keyword],[27,s.CompletionItemKind.Snippet],[18,s.CompletionItemKind.Text],[19,s.CompletionItemKind.Color],[20,s.CompletionItemKind.File],[21,s.CompletionItemKind.Reference],[23,s.CompletionItemKind.Folder],[10,s.CompletionItemKind.Event],[11,s.CompletionItemKind.Operator],[24,s.CompletionItemKind.TypeParameter],[25,s.CompletionItemKind.User],[26,s.CompletionItemKind.Issue]]);function Te(qe){return se.get(qe)??s.CompletionItemKind.Property}Me.to=Te})(Pe||(e.CompletionItemKind=Pe={}));var B;(function(Me){function Fe(Ce,se){const Te=new s.$6K(Ce.label);return Te.insertText=Ce.insertText,Te.kind=Pe.to(Ce.kind),Te.tags=Ce.tags?.map(pe.to),Te.detail=Ce.detail,Te.documentation=M.$$j(Ce.documentation)?T.to(Ce.documentation):Ce.documentation,Te.sortText=Ce.sortText,Te.filterText=Ce.filterText,Te.preselect=Ce.preselect,Te.commitCharacters=Ce.commitCharacters,k.$zs.isIRange(Ce.range)?Te.range=l.to(Ce.range):typeof Ce.range=="object"&&(Te.range={inserting:l.to(Ce.range.insert),replacing:l.to(Ce.range.replace)}),Te.keepWhitespace=typeof Ce.insertTextRules>"u"?!1:!!(Ce.insertTextRules&1),typeof Ce.insertTextRules<"u"&&Ce.insertTextRules&4?Te.insertText=new s.$KK(Ce.insertText):(Te.insertText=Ce.insertText,Te.textEdit=Te.range instanceof s.$BK?new s.$GK(Te.range,Te.insertText):void 0),Ce.additionalTextEdits&&Ce.additionalTextEdits.length>0&&(Te.additionalTextEdits=Ce.additionalTextEdits.map(qe=>J.to(qe))),Te.command=se&&Ce.command?se.fromInternal(Ce.command):void 0,Te}Me.to=Fe})(B||(e.CompletionItem=B={}));var X;(function(Me){function Fe(se){if(typeof se.label!="string"&&!Array.isArray(se.label))throw new TypeError("Invalid label");return{label:se.label,documentation:T.fromStrict(se.documentation)}}Me.from=Fe;function Ce(se){return{label:se.label,documentation:M.$$j(se.documentation)?T.to(se.documentation):se.documentation}}Me.to=Ce})(X||(e.ParameterInformation=X={}));var re;(function(Me){function Fe(se){return{label:se.label,documentation:T.fromStrict(se.documentation),parameters:Array.isArray(se.parameters)?se.parameters.map(X.from):[],activeParameter:se.activeParameter}}Me.from=Fe;function Ce(se){return{label:se.label,documentation:M.$$j(se.documentation)?T.to(se.documentation):se.documentation,parameters:Array.isArray(se.parameters)?se.parameters.map(X.to):[],activeParameter:se.activeParameter}}Me.to=Ce})(re||(e.SignatureInformation=re={}));var ae;(function(Me){function Fe(se){return{activeSignature:se.activeSignature,activeParameter:se.activeParameter,signatures:Array.isArray(se.signatures)?se.signatures.map(re.from):[]}}Me.from=Fe;function Ce(se){return{activeSignature:se.activeSignature,activeParameter:se.activeParameter,signatures:Array.isArray(se.signatures)?se.signatures.map(re.to):[]}}Me.to=Ce})(ae||(e.SignatureHelp=ae={}));var ee;(function(Me){function Fe(Ce,se){const Te=new s.$5K(E.to(se.position),typeof se.label=="string"?se.label:se.label.map(ge.to.bind(void 0,Ce)),se.kind&&ye.to(se.kind));return Te.textEdits=se.textEdits&&se.textEdits.map(J.to),Te.tooltip=M.$$j(se.tooltip)?T.to(se.tooltip):se.tooltip,Te.paddingLeft=se.paddingLeft,Te.paddingRight=se.paddingRight,Te}Me.to=Fe})(ee||(e.InlayHint=ee={}));var ge;(function(Me){function Fe(Ce,se){const Te=new s.$4K(se.label);return Te.tooltip=M.$$j(se.tooltip)?T.to(se.tooltip):se.tooltip,w.Command.is(se.command)&&(Te.command=Ce.fromInternal(se.command)),se.location&&(Te.location=be.to(se.location)),Te}Me.to=Fe})(ge||(e.InlayHintLabelPart=ge={}));var ye;(function(Me){function Fe(se){return se}Me.from=Fe;function Ce(se){return se}Me.to=Ce})(ye||(e.InlayHintKind=ye={}));var je;(function(Me){function Fe(se){return{range:l.from(se.range),url:se.target,tooltip:se.tooltip}}Me.from=Fe;function Ce(se){let Te;if(se.url)try{Te=typeof se.url=="string"?y.URI.parse(se.url,!0):y.URI.revive(se.url)}catch{}return new s.$$K(l.to(se.range),Te)}Me.to=Ce})(je||(e.DocumentLink=je={}));var We;(function(Me){function Fe(se){const Te=new s.$bL(se.label);return se.textEdit&&(Te.textEdit=J.to(se.textEdit)),se.additionalTextEdits&&(Te.additionalTextEdits=se.additionalTextEdits.map(qe=>J.to(qe))),Te}Me.to=Fe;function Ce(se){return{label:se.label,textEdit:se.textEdit?J.from(se.textEdit):void 0,additionalTextEdits:se.additionalTextEdits?se.additionalTextEdits.map(Te=>J.from(Te)):void 0}}Me.from=Ce})(We||(e.ColorPresentation=We={}));var et;(function(Me){function Fe(se){return new s.$_K(se[0],se[1],se[2],se[3])}Me.to=Fe;function Ce(se){return[se.red,se.green,se.blue,se.alpha]}Me.from=Ce})(et||(e.Color=et={}));var Ze;(function(Me){function Fe(se){return{range:l.from(se.range)}}Me.from=Fe;function Ce(se){return new s.$UK(l.to(se.range))}Me.to=Ce})(Ze||(e.SelectionRange=Ze={}));var rt;(function(Me){function Fe(Ce){switch(Ce){case 2:return s.TextDocumentSaveReason.AfterDelay;case 1:return s.TextDocumentSaveReason.Manual;case 3:case 4:return s.TextDocumentSaveReason.FocusOut}}Me.to=Fe})(rt||(e.TextDocumentSaveReason=rt={}));var nt;(function(Me){function Fe(se){switch(se){case s.TextEditorLineNumbersStyle.Off:return 0;case s.TextEditorLineNumbersStyle.Relative:return 2;case s.TextEditorLineNumbersStyle.On:default:return 1}}Me.from=Fe;function Ce(se){switch(se){case 0:return s.TextEditorLineNumbersStyle.Off;case 2:return s.TextEditorLineNumbersStyle.Relative;case 1:default:return s.TextEditorLineNumbersStyle.On}}Me.to=Ce})(nt||(e.TextEditorLineNumbersStyle=nt={}));var Ae;(function(Me){function Fe(se){if(se===s.EndOfLine.CRLF)return 1;if(se===s.EndOfLine.LF)return 0}Me.from=Fe;function Ce(se){if(se===1)return s.EndOfLine.CRLF;if(se===0)return s.EndOfLine.LF}Me.to=Ce})(Ae||(e.EndOfLine=Ae={}));var Oe;(function(Me){function Fe(Ce){if(typeof Ce=="object")return Ce.viewId;switch(Ce){case s.ProgressLocation.SourceControl:return 3;case s.ProgressLocation.Window:return 10;case s.ProgressLocation.Notification:return 15}throw new Error("Unknown 'ProgressLocation'")}Me.from=Fe})(Oe||(e.ProgressLocation=Oe={}));var Ve;(function(Me){function Fe(se){const Te={start:se.start+1,end:se.end+1};return se.kind&&(Te.kind=Le.from(se.kind)),Te}Me.from=Fe;function Ce(se){const Te={start:se.start-1,end:se.end-1};return se.kind&&(Te.kind=Le.to(se.kind)),Te}Me.to=Ce})(Ve||(e.FoldingRange=Ve={}));var Le;(function(Me){function Fe(se){if(se)switch(se){case s.FoldingRangeKind.Comment:return w.$ot.Comment;case s.FoldingRangeKind.Imports:return w.$ot.Imports;case s.FoldingRangeKind.Region:return w.$ot.Region}}Me.from=Fe;function Ce(se){if(se)switch(se.value){case w.$ot.Comment.value:return s.FoldingRangeKind.Comment;case w.$ot.Imports.value:return s.FoldingRangeKind.Imports;case w.$ot.Region.value:return s.FoldingRangeKind.Region}}Me.to=Ce})(Le||(e.FoldingRangeKind=Le={}));var Ye;(function(Me){function Fe(Ce){if(Ce)return{pinned:typeof Ce.preview=="boolean"?!Ce.preview:void 0,inactive:Ce.background,preserveFocus:Ce.preserveFocus,selection:typeof Ce.selection=="object"?l.from(Ce.selection):void 0,override:typeof Ce.override=="boolean"?i.$aE.id:void 0}}Me.from=Fe})(Ye||(e.TextEditorOpenOptions=Ye={}));var ue;(function(Me){function Fe(qe){return qe instanceof s.$vL?qe.toJSON():typeof qe=="string"?qe:Ce(qe)||se(qe)?new s.$vL(qe.baseUri??qe.base,qe.pattern).toJSON():qe}Me.from=Fe;function Ce(qe){const xe=qe;return xe?y.URI.isUri(xe.baseUri)&&typeof xe.pattern=="string":!1}function se(qe){const xe=qe;return xe?typeof xe.base=="string"&&typeof xe.pattern=="string":!1}function Te(qe){return typeof qe=="string"?qe:new s.$vL(y.URI.revive(qe.baseUri),qe.pattern)}Me.to=Te})(ue||(e.GlobPattern=ue={}));var ce;(function(Me){function Fe(Ce){if(Ce){if(Array.isArray(Ce))return Ce.map(Fe);if(typeof Ce=="string")return Ce;{const se=Ce;return{language:se.language,scheme:se.scheme,pattern:ue.from(se.pattern),exclusive:se.exclusive,notebookType:se.notebookType}}}else return}Me.from=Fe})(ce||(e.LanguageSelector=ce={}));var Ie;(function(Me){function Fe(se){return!!se&&typeof se=="object"&&"documents"in se&&Array.isArray(se.documents)&&se.documents.every(Te=>Array.isArray(Te)&&Te.every(qe=>qe&&typeof qe=="object"&&"uri"in qe&&y.URI.isUri(qe.uri)&&"version"in qe&&typeof qe.version=="number"&&"ranges"in qe&&Array.isArray(qe.ranges)&&qe.ranges.every(xe=>xe instanceof s.$BK)))}Me.is=Fe;function Ce(se){return{documents:se.documents.map(Te=>Te.map(qe=>({uri:y.URI.from(qe.uri),version:qe.version,ranges:qe.ranges.map(xe=>l.from(xe))})))}}Me.from=Ce})(Ie||(e.MappedEditsContext=Ie={}));var Ke;(function(Me){function Fe(se){return{start:se.start,end:se.end}}Me.from=Fe;function Ce(se){return new s.$WL(se.start,se.end)}Me.to=Ce})(Ke||(e.NotebookRange=Ke={}));var Ge;(function(Me){function Fe(se){return{timing:typeof se.runStartTime=="number"&&typeof se.runEndTime=="number"?{startTime:se.runStartTime,endTime:se.runEndTime}:void 0,executionOrder:se.executionOrder,success:se.lastRunSuccess}}Me.to=Fe;function Ce(se){return{lastRunSuccess:se.success,runStartTime:se.timing?.startTime,runEndTime:se.timing?.endTime,executionOrder:se.executionOrder}}Me.from=Ce})(Ge||(e.NotebookCellExecutionSummary=Ge={}));var _e;(function(Me){function Fe(Ce){if(Ce===n.NotebookCellExecutionState.Unconfirmed)return s.NotebookCellExecutionState.Pending;if(Ce===n.NotebookCellExecutionState.Pending)return;if(Ce===n.NotebookCellExecutionState.Executing)return s.NotebookCellExecutionState.Executing;throw new Error(`Unknown state: ${Ce}`)}Me.to=Fe})(_e||(e.NotebookCellExecutionState=_e={}));var st;(function(Me){function Fe(se){switch(se){case s.NotebookCellKind.Markup:return n.CellKind.Markup;case s.NotebookCellKind.Code:default:return n.CellKind.Code}}Me.from=Fe;function Ce(se){switch(se){case n.CellKind.Markup:return s.NotebookCellKind.Markup;case n.CellKind.Code:default:return s.NotebookCellKind.Code}}Me.to=Ce})(st||(e.NotebookCellKind=st={}));var lt;(function(Me){function Fe(se){const Te={metadata:se.metadata??Object.create(null),cells:[]};for(const qe of se.cells)s.$XL.validate(qe),Te.cells.push(wt.from(qe));return Te}Me.from=Fe;function Ce(se){const Te=new s.$YL(se.cells.map(wt.to));return(0,$.$Pf)(se.metadata)||(Te.metadata=se.metadata),Te}Me.to=Ce})(lt||(e.NotebookData=lt={}));var wt;(function(Me){function Fe(se){return{cellKind:st.from(se.kind),language:se.languageId,mime:se.mime,source:se.value,metadata:se.metadata,internalMetadata:Ge.from(se.executionSummary??{}),outputs:se.outputs?se.outputs.map(Kt.from):[]}}Me.from=Fe;function Ce(se){return new s.$XL(st.to(se.cellKind),se.source,se.language,se.mime,se.outputs?se.outputs.map(Kt.to):void 0,se.metadata,se.internalMetadata?Ge.to(se.internalMetadata):void 0)}Me.to=Ce})(wt||(e.NotebookCellData=wt={}));var Ue;(function(Me){function Fe(se){return{mime:se.mime,valueBytes:F.$fe.wrap(se.data)}}Me.from=Fe;function Ce(se){return new s.$ZL(se.valueBytes.buffer,se.mime)}Me.to=Ce})(Ue||(e.NotebookCellOutputItem=Ue={}));var Kt;(function(Me){function Fe(se){return{outputId:se.id,items:se.items.map(Ue.from),metadata:se.metadata}}Me.from=Fe;function Ce(se){const Te=se.items.map(Ue.to);return new s.$1L(Te,se.outputId,se.metadata)}Me.to=Ce})(Kt||(e.NotebookCellOutput=Kt={}));var Ht;(function(Me){function Fe(Te){return se(Te)?{include:ue.from(Te.include)??void 0,exclude:ue.from(Te.exclude)??void 0}:ue.from(Te)??void 0}Me.from=Fe;function Ce(Te){return se(Te)?{include:ue.to(Te.include),exclude:ue.to(Te.exclude)}:ue.to(Te)}Me.to=Ce;function se(Te){const qe=Te;return qe?!(0,$.$Lf)(qe.include)&&!(0,$.$Lf)(qe.exclude):!1}})(Ht||(e.NotebookExclusiveDocumentPattern=Ht={}));var Et;(function(Me){function Fe(Ce,se,Te){const qe=typeof Ce.command=="string"?{title:"",command:Ce.command}:Ce.command;return{alignment:Ce.alignment===s.NotebookCellStatusBarAlignment.Left?1:2,command:se.toInternal(qe,Te),text:Ce.text,tooltip:Ce.tooltip,accessibilityInformation:Ce.accessibilityInformation,priority:Ce.priority}}Me.from=Fe})(Et||(e.NotebookStatusBarItem=Et={}));var Ut;(function(Me){function Fe(Ce,se,Te){const qe=typeof Ce.command=="string"?{title:"",command:Ce.command}:Ce.command;return{command:se.toInternal(qe,Te),label:Ce.label,description:Ce.description,detail:Ce.detail,documentation:Ce.documentation}}Me.from=Fe})(Ut||(e.NotebookKernelSourceAction=Ut={}));var Nt;(function(Me){function Fe(Ce){return{transientOutputs:Ce?.transientOutputs??!1,transientCellMetadata:Ce?.transientCellMetadata??{},transientDocumentMetadata:Ce?.transientDocumentMetadata??{},cellContentMetadata:Ce?.cellContentMetadata??{}}}Me.from=Fe})(Nt||(e.NotebookDocumentContentOptions=Nt={}));var Gt;(function(Me){function Fe(se){return{uri:se.uri,provides:se.provides}}Me.from=Fe;function Ce(se){return new s.$3L(y.URI.revive(se.uri),se.provides)}Me.to=Ce})(Gt||(e.NotebookRendererScript=Gt={}));var Bt;(function(Me){function Fe(se){return{message:T.fromStrict(se.message)||"",type:0,expected:se.expectedOutput,actual:se.actualOutput,contextValue:se.contextValue,location:se.location&&{range:l.from(se.location.range),uri:se.location.uri}}}Me.from=Fe;function Ce(se){const Te=new s.$9L(typeof se.message=="string"?se.message:T.to(se.message));return Te.actualOutput=se.actual,Te.expectedOutput=se.expected,Te.contextValue=se.contextValue,Te.location=se.location?be.to(se.location):void 0,Te}Me.to=Ce})(Bt||(e.TestMessage=Bt={}));var Dt;(function(Me){Me.namespace=a.$uJ,Me.denamespace=a.$vJ})(Dt||(e.TestTag=Dt={}));var Mt;(function(Me){function Fe(se){const Te=(0,o.$vM)(se).controllerId;return{extId:r.$qJ.fromExtHostTestItem(se,Te).toString(),label:se.label,uri:y.URI.revive(se.uri),busy:se.busy,tags:se.tags.map(qe=>Dt.namespace(Te,qe.id)),range:k.$zs.lift(l.from(se.range)),description:se.description||null,sortText:se.sortText||null,error:se.error&&T.fromStrict(se.error)||null}}Me.from=Fe;function Ce(se){return{parent:void 0,error:void 0,id:r.$qJ.fromString(se.extId).localId,label:se.label,uri:y.URI.revive(se.uri),tags:(se.tags||[]).map(Te=>{const{tagId:qe}=Dt.denamespace(Te);return new s.$0L(qe)}),children:{add:()=>{},delete:()=>{},forEach:()=>{},*[Symbol.iterator](){},get:()=>{},replace:()=>{},size:0},range:l.to(se.range||void 0),canResolveChildren:!1,busy:se.busy,description:se.description||void 0,sortText:se.sortText||void 0}}Me.toPlain=Ce})(Mt||(e.TestItem=Mt={})),function(Me){function Fe(se){return{id:se.id}}Me.from=Fe;function Ce(se){return new s.$0L(se.id)}Me.to=Ce}(Dt||(e.TestTag=Dt={}));var Wt;(function(Me){const Fe=(se,Te)=>{const qe=[];for(const[Qe,ot]of Te)r.$qJ.compare(ot.item.extId,Qe)===2&&(Te.delete(Qe),qe.push(ot));const xe={...Mt.toPlain(se.item),parent:void 0,taskStates:se.tasks.map(Qe=>({state:Qe.state,duration:Qe.duration,messages:Qe.messages.filter(ot=>ot.type===0).map(Bt.to)})),children:qe.map(Qe=>Fe(Qe,Te))};for(const Qe of xe.children)Qe.parent=xe;return xe};function Ce(se){const Te=[],qe=new Map;for(const xe of se.items){qe.set(xe.item.extId,xe);const Qe=r.$qJ.root(xe.item.extId);se.request.targets.some(ot=>ot.controllerId===Qe&&ot.testIds.includes(xe.item.extId))&&Te.push(xe)}return{completedAt:se.completedAt,results:Te.map(xe=>Fe(xe,qe))}}Me.to=Ce})(Wt||(e.TestResults=Wt={}));var tt;(function(Me){function Fe(qe){return{covered:qe.covered,total:qe.covered}}function Ce(qe){return"line"in qe?E.from(qe):l.from(qe)}function se(qe){return"branches"in qe?{count:qe.executionCount,location:Ce(qe.location),type:1,branches:qe.branches.length?qe.branches.map(xe=>({count:xe.executionCount,location:xe.location&&Ce(xe.location)})):void 0}:{type:0,count:qe.executionCount,location:Ce(qe.location)}}Me.fromDetailed=se;function Te(qe){return{uri:qe.uri,statement:Fe(qe.statementCoverage),branch:qe.branchCoverage&&Fe(qe.branchCoverage),function:qe.functionCoverage&&Fe(qe.functionCoverage),details:qe.detailedCoverage?.map(se)}}Me.fromFile=Te})(tt||(e.TestCoverage=tt={}));var Vt;(function(Me){function Fe(Ce){switch(Ce){case 1:return s.CodeActionTriggerKind.Invoke;case 2:return s.CodeActionTriggerKind.Automatic}}Me.to=Fe})(Vt||(e.CodeActionTriggerKind=Vt={}));var qt;(function(Me){function Fe(se){const Te=new s.$dM(oe.to(se.kind),se.name,se.detail||"",y.URI.revive(se.uri),l.to(se.range),l.to(se.selectionRange));return Te._sessionId=se._sessionId,Te._itemId=se._itemId,Te}Me.to=Fe;function Ce(se,Te,qe){if(Te=Te??se._sessionId,qe=qe??se._itemId,Te===void 0||qe===void 0)throw new Error("invalid item");return{_sessionId:Te,_itemId:qe,kind:oe.from(se.kind),name:se.name,detail:se.detail??"",uri:se.uri,range:l.from(se.range),selectionRange:l.from(se.selectionRange),tags:se.tags?.map(_.from)}}Me.from=Ce})(qt||(e.TypeHierarchyItem=qt={}));var ut;(function(Me){function Fe(Ce){if(Ce)return{value:Ce.value,tooltip:Ce.tooltip}}Me.from=Fe})(ut||(e.ViewBadge=ut={}));var mt;(function(Me){function Fe(qe,xe,Qe){const ot=xe.fileData;return ot?new s.$oL(new s.$pL(ot.name,y.URI.revive(ot.uri),ot.id,(0,L.$cb)(()=>Qe(ot.id)))):qe===A.$Vr.uriList&&xe.uriListData?new s.$nL(Te(xe.uriListData)):new s.$nL(xe.asString)}Me.to=Fe;async function Ce(qe,xe){const Qe=await xe.asString();if(qe===A.$Vr.uriList)return{asString:Qe,fileData:void 0,uriListData:se(Qe)};const ot=xe.asFile();return{asString:Qe,fileData:ot?{name:ot.name,uri:ot.uri,id:ot._itemId??ot.id}:void 0}}Me.from=Ce;function se(qe){return f.$9s.split(qe).map(xe=>{if(xe.startsWith("#"))return xe;try{return y.URI.parse(xe)}catch{}return xe})}function Te(qe){return f.$9s.create(qe.map(xe=>typeof xe=="string"?xe:y.URI.revive(xe)))}})(mt||(e.DataTransferItem=mt={}));var Ot;(function(Me){function Fe(se,Te){const qe=se.items.map(([xe,Qe])=>[xe,mt.to(xe,Qe,Te)]);return new s.$qL(qe)}Me.toDataTransfer=Fe;async function Ce(se){const Te={items:[]},qe=[];for(const[xe,Qe]of se)qe.push((async()=>{Te.items.push([xe,await mt.from(xe,Qe)])})());return await Promise.all(qe),Te}Me.from=Ce})(Ot||(e.DataTransfer=Ot={}));var Pt;(function(Me){function Fe(Ce){return{kind:"reply",message:Ce.message,title:Ce.title,tooltip:Ce.tooltip}}Me.from=Fe})(Pt||(e.ChatReplyFollowup=Pt={}));var At;(function(Me){function Fe(Ce){return typeof Ce=="string"?{title:Ce,message:Ce,kind:"reply"}:"commandId"in Ce?{kind:"command",title:Ce.title??"",commandId:Ce.commandId??"",when:Ce.when??"",args:Ce.args}:Pt.from(Ce)}Me.from=Fe})(At||(e.ChatFollowup=At={}));var gt;(function(Me){function Fe(se){const Te=new s.$oM(St.to(se.role),se.content);return Te.name=se.name,Te}Me.to=Fe;function Ce(se){return{role:St.from(se.role),content:se.content,name:se.name}}Me.from=Ce})(gt||(e.ChatMessage=gt={}));var St;(function(Me){function Fe(se){switch(se){case 0:return s.ChatMessageRole.System;case 1:return s.ChatMessageRole.User;case 2:return s.ChatMessageRole.Assistant;case 3:return s.ChatMessageRole.Function}}Me.to=Fe;function Ce(se){switch(se){case s.ChatMessageRole.System:return 0;case s.ChatMessageRole.Assistant:return 2;case s.ChatMessageRole.Function:return 3;case s.ChatMessageRole.User:default:return 1}}Me.from=Ce})(St||(e.ChatMessageRole=St={}));var Rt;(function(Me){function Fe(Te){const qe={};for(const xe of Object.keys(Te))qe[xe]=Te[xe].map(Me.to);return qe}Me.objectTo=Fe;function Ce(Te){return{level:It.to(Te.level),value:Te.value,description:Te.description}}Me.to=Ce;function se(Te){return{level:It.from(Te.level),value:Te.value,description:Te.description}}Me.from=se})(Rt||(e.ChatVariable=Rt={}));var It;(function(Me){function Fe(se){switch(se){case"short":return s.ChatVariableLevel.Short;case"medium":return s.ChatVariableLevel.Medium;case"full":default:return s.ChatVariableLevel.Full}}Me.to=Fe;function Ce(se){switch(se){case s.ChatVariableLevel.Short:return"short";case s.ChatVariableLevel.Medium:return"medium";case s.ChatVariableLevel.Full:default:return"full"}}Me.from=Ce})(It||(e.ChatVariableLevel=It={}));var Je;(function(Me){function Fe(Ce){switch(Ce){case 1:return s.InteractiveEditorResponseFeedbackKind.Helpful;case 0:return s.InteractiveEditorResponseFeedbackKind.Unhelpful;case 2:return s.InteractiveEditorResponseFeedbackKind.Undone;case 3:return s.InteractiveEditorResponseFeedbackKind.Accepted}}Me.to=Fe})(Je||(e.InteractiveEditorResponseFeedbackKind=Je={}));var jt;(function(Me){function Fe(Ce,se){return"placeholder"in se&&"resolvedContent"in se?{placeholder:se.placeholder,kind:"asyncContent"}:"markdownContent"in se?((0,d.$MF)(Ce,"chatAgents2Additions"),{content:T.from(se.markdownContent),kind:"content"}):"content"in se?typeof se.content=="string"?{content:se.content,kind:"content"}:((0,d.$MF)(Ce,"chatAgents2Additions"),{content:T.from(se.content),kind:"content"}):"documents"in se?{documents:se.documents.map(Te=>({uri:Te.uri,version:Te.version,ranges:Te.ranges.map(qe=>l.from(qe))})),kind:"usedContext"}:"reference"in se?{reference:"uri"in se.reference?{uri:se.reference.uri,range:l.from(se.reference.range)}:se.reference,kind:"reference"}:"inlineReference"in se?{inlineReference:"uri"in se.inlineReference?{uri:se.inlineReference.uri,range:l.from(se.inlineReference.range)}:se.inlineReference,name:se.title,kind:"inlineReference"}:"agentName"in se?((0,d.$MF)(Ce,"chatAgents2Additions"),{agentName:se.agentName,command:se.command,kind:"agentDetection"}):{treeData:se.treeData,kind:"treeData"}}Me.from=Fe})(jt||(e.ChatResponseProgress=jt={}));var Jt;(function(Me){function Fe(Ce,se,Te){return"terminalCommand"in Ce?{terminalCommand:Ce.terminalCommand}:"uri"in Ce?{uri:Ce.uri}:se.toInternal(Ce,Te)}Me.from=Fe})(Jt||(e.TerminalQuickFix=Jt={}))}),define(ke[294],Se([1,0,2,8,7,15,75]),function(me,e,C,F,f,L,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sec=void 0;class b{constructor(g,A,I,$={timeout:1500,errors:3}){this.c=g,this.d=A,this.f=I,this.g=$,this.a=new M.$2c,this.b=new WeakMap}dispose(){this.a.clear()}getOnWillSaveTextDocumentEvent(g){return(A,I,$)=>{const k={dispose:this.a.push([A,I,g])};return Array.isArray($)&&$.push(k),k}}async $participateInSave(g,A){const I=C.URI.revive(g);let $=!1;const y=setTimeout(()=>$=!0,this.g.timeout),k=[];try{for(const w of[...this.a]){if($)break;const u=this.d.getDocument(I),o=await this.h(w,{document:u,reason:L.TextDocumentSaveReason.to(A)});k.push(o)}}finally{clearTimeout(y)}return k}h([g,A,I],$){const y=this.b.get(g);return typeof y=="number"&&y>this.g.errors?Promise.resolve(!1):this.i(I,g,A,$).then(()=>!0,k=>{if(this.c.error(`onWillSaveTextDocument-listener from extension '${I.identifier.value}' threw ERROR`),this.c.error(k),!(k instanceof Error)||k.message!=="concurrent_edits"){const w=this.b.get(g);this.b.set(g,w?w+1:1),typeof w=="number"&&w>this.g.errors&&this.c.info(`onWillSaveTextDocument-listener from extension '${I.identifier.value}' will now be IGNORED because of timeouts and/or errors`)}return!1})}i(g,A,I,$){const y=[],k=Date.now(),{document:w,reason:u}=$,{version:o}=w,i=Object.freeze({document:w,reason:u,waitUntil(n){if(Object.isFrozen(y))throw(0,F.$7)("waitUntil can not be called async");y.push(Promise.resolve(n))}});try{A.apply(I,[i])}catch(n){return Promise.reject(n)}return Object.freeze(y),new Promise((n,r)=>{const a=setTimeout(()=>r(new Error("timeout")),this.g.timeout);return Promise.all(y).then(t=>{this.c.debug(`onWillSaveTextDocument-listener from extension '${g.identifier.value}' finished after ${Date.now()-k}ms`),clearTimeout(a),n(t)}).catch(t=>{clearTimeout(a),r(t)})}).then(n=>{const r={edits:[]};for(const a of n)if(Array.isArray(a)&&a.every(t=>t instanceof f.$GK))for(const{newText:t,newEol:s,range:d}of a)r.edits.push({resource:w.uri,versionId:void 0,textEdit:{range:d&&L.Range.from(d),text:t,eol:s&&L.EndOfLine.from(s)}});if(r.edits.length!==0)return o===w.version?this.f.$tryApplyWorkspaceEdit(r):Promise.reject(new Error("concurrent_edits"))})}}e.$Sec=b}),define(ke[295],Se([1,0,17,2,15,7,111]),function(me,e,C,F,f,L,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yec=e.$Xec=void 0;class b{constructor(I,$,y,k){this.start=I,this.deletedCount=$,this.deletedItems=y,this.items=k}asApiEvent(){return{range:new L.$WL(this.start,this.start+this.deletedCount),addedCells:this.items.map(I=>I.apiCell),removedCells:this.deletedItems}}}class v{static asModelAddData(I,$){return{EOL:$.eol,lines:$.source,languageId:$.language,uri:$.uri,isDirty:!1,versionId:1,notebook:I}}constructor(I,$,y){this.notebook=I,this.h=$,this.j=y,this.handle=y.handle,this.uri=F.URI.revive(y.uri),this.cellKind=y.cellKind,this.a=y.outputs.map(f.NotebookCellOutput.to),this.e=y.internalMetadata??{},this.b=Object.freeze(y.metadata??{}),this.d=Object.freeze(f.NotebookCellExecutionSummary.to(y.internalMetadata??{}))}get internalMetadata(){return this.e}get apiCell(){if(!this.f){const I=this,$=this.h.getDocument(this.uri);if(!$)throw new Error(`MISSING extHostDocument for notebook cell: ${this.uri}`);const y={get index(){return I.notebook.getCellIndex(I)},notebook:I.notebook.apiNotebook,kind:f.NotebookCellKind.to(this.j.cellKind),document:$.document,get mime(){return I.g},set mime(k){I.g=k},get outputs(){return I.a.slice(0)},get metadata(){return I.b},get executionSummary(){return I.d}};this.f=Object.freeze(y)}return this.f}setOutputs(I){this.a=I.map(f.NotebookCellOutput.to)}setOutputItems(I,$,y){const k=y.map(f.NotebookCellOutputItem.to),w=this.a.find(u=>u.id===I);if(w&&($||(w.items.length=0),w.items.push(...k),w.items.length>1&&w.items.every(u=>M.$BI(u.mime)))){const u=new Map,o=[];w.items.forEach(i=>{let n;u.has(i.mime)?n=u.get(i.mime):(n=[],u.set(i.mime,n),o.push(i.mime)),n.push(i.data)}),w.items.length=0,o.forEach(i=>{const n=M.$CI(u.get(i));w.items.push({mime:i,data:n.data.buffer})})}}setMetadata(I){this.b=Object.freeze(I)}setInternalMetadata(I){this.e=I,this.d=Object.freeze(f.NotebookCellExecutionSummary.to(I))}setMime(I){}}e.$Xec=v;class g{static{this.a=0}constructor(I,$,y,k,w){this.k=I,this.l=$,this.m=y,this.uri=k,this.handle=g.a++,this.b=[],this.g=0,this.h=!1,this.j=!1,this.d=w.viewType,this.f=Object.freeze(w.metadata??Object.create(null)),this.r([[0,0,w.cells]],!0,void 0),this.g=w.versionId}dispose(){this.j=!0}get versionId(){return this.g}get apiNotebook(){if(!this.e){const I=this,$={get uri(){return I.uri},get version(){return I.g},get notebookType(){return I.d},get isDirty(){return I.h},get isUntitled(){return I.uri.scheme===C.Schemas.untitled},get isClosed(){return I.j},get metadata(){return I.f},get cellCount(){return I.b.length},cellAt(y){return y=I.n(y),I.b[y].apiCell},getCells(y){return(y?I.p(y):I.b).map(w=>w.apiCell)},save(){return I.q()}};this.e=Object.freeze($)}return this.e}acceptDocumentPropertiesChanged(I){I.metadata&&(this.f=Object.freeze({...this.f,...I.metadata}))}acceptDirty(I){this.h=I}acceptModelChanged(I,$,y){this.g=I.versionId,this.h=$,this.acceptDocumentPropertiesChanged({metadata:y});const k={notebook:this.apiNotebook,metadata:y,cellChanges:[],contentChanges:[]},w=[];for(const o of I.rawEvents)o.kind===M.NotebookCellsChangeType.ModelChange?this.r(o.changes,!1,k.contentChanges):o.kind===M.NotebookCellsChangeType.Move?this.s(o.index,o.length,o.newIdx,k.contentChanges):o.kind===M.NotebookCellsChangeType.Output?(this.t(o.index,o.outputs),w.push({cell:this.b[o.index].apiCell,outputs:this.b[o.index].apiCell.outputs})):o.kind===M.NotebookCellsChangeType.OutputItem?(this.u(o.index,o.outputId,o.append,o.outputItems),w.push({cell:this.b[o.index].apiCell,outputs:this.b[o.index].apiCell.outputs})):o.kind===M.NotebookCellsChangeType.ChangeCellLanguage?(this.v(o.index,o.language),w.push({cell:this.b[o.index].apiCell,document:this.b[o.index].apiCell.document})):o.kind===M.NotebookCellsChangeType.ChangeCellContent?w.push({cell:this.b[o.index].apiCell,document:this.b[o.index].apiCell.document}):o.kind===M.NotebookCellsChangeType.ChangeCellMime?this.w(o.index,o.mime):o.kind===M.NotebookCellsChangeType.ChangeCellMetadata?(this.x(o.index,o.metadata),w.push({cell:this.b[o.index].apiCell,metadata:this.b[o.index].apiCell.metadata})):o.kind===M.NotebookCellsChangeType.ChangeCellInternalMetadata&&(this.y(o.index,o.internalMetadata),w.push({cell:this.b[o.index].apiCell,executionSummary:this.b[o.index].apiCell.executionSummary}));const u=new Map;for(let o=0;o<w.length;o++){const i=w[o],n=u.get(i.cell);if(n===void 0){const r=k.cellChanges.push({document:void 0,executionSummary:void 0,metadata:void 0,outputs:void 0,...i});u.set(i.cell,r-1)}else k.cellChanges[n]={...k.cellChanges[n],...i}}return Object.freeze(k),Object.freeze(k.cellChanges),Object.freeze(k.contentChanges),k}n(I){return I=I|0,I<0?0:I>=this.b.length?this.b.length-1:I}o(I){let $=I.start|0,y=I.end|0;return $<0&&($=0),y>this.b.length&&(y=this.b.length),I.with({start:$,end:y})}p(I){I=this.o(I);const $=[];for(let y=I.start;y<I.end;y++)$.push(this.b[y]);return $}async q(){return this.j?Promise.reject(new Error("Notebook has been closed")):this.k.$trySaveNotebook(this.uri)}r(I,$,y){if(this.j)return;const k=[],w=[],u=[];if(I.reverse().forEach(o=>{const n=o[2].map(t=>{const s=new v(this,this.l,t);return $||w.push(v.asModelAddData(this.apiNotebook,t)),s}),r=new b(o[0],o[1],[],n),a=this.b.splice(o[0],o[1],...n);for(const t of a)u.push(t.uri),r.deletedItems.push(t.apiCell);k.push(r)}),this.l.acceptDocumentsAndEditorsDelta({addedDocuments:w,removedDocuments:u}),y)for(const o of k)y.push(o.asApiEvent())}s(I,$,y,k){const w=this.b.splice(I,$);this.b.splice(y,0,...w);const u=[new b(I,$,w.map(o=>o.apiCell),[]),new b(y,0,[],w)];for(const o of u)k.push(o.asApiEvent())}t(I,$){this.b[I].setOutputs($)}u(I,$,y,k){this.b[I].setOutputItems($,y,k)}v(I,$){const y=this.b[I];y.apiCell.document.languageId!==$&&this.m.$acceptModelLanguageChanged(y.uri,$)}w(I,$){const y=this.b[I];y.apiCell.mime=$}x(I,$){this.b[I].setMetadata($)}y(I,$){this.b[I].setInternalMetadata($)}getCellFromApiCell(I){return this.b.find($=>$.apiCell===I)}getCellFromIndex(I){return this.b[I]}getCell(I){return this.b.find($=>$.handle===I)}getCellIndex(I){return this.b.indexOf(I)}}e.$Yec=g}),define(ke[296],Se([1,0,4,2,15,7]),function(me,e,C,F,f,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cfc=void 0;class M{constructor(v,g,A,I={timeout:1500,errors:3}){this.b=v,this.c=g,this.d=A,this.f=I,this.a=new C.$Td}dispose(){}getOnWillSaveNotebookDocumentEvent(v){return(g,A,I)=>{const $=function(k){g.call(A,k)};return $.extension=v,this.a.event($,void 0,I)}}async $participateInSave(v,g,A){const I=F.URI.revive(v),$=this.c.getNotebookDocument(I);if(!$)throw new Error("Unable to resolve notebook document");const y=[];if(await this.a.fireAsync({notebook:$.apiNotebook,reason:f.TextDocumentSaveReason.to(g)},A,async(w,u)=>{const o=Date.now(),i=await await Promise.resolve(w);Date.now()-o>this.f.timeout&&this.b.warn("onWillSaveNotebookDocument-listener from extension",u.extension.identifier),!A.isCancellationRequested&&i&&(i instanceof L.$JK?y.push(i):this.b.warn("onWillSaveNotebookDocument-listener from extension",u.extension.identifier,"ignored due to invalid data"))}),A.isCancellationRequested)return!1;if(y.length===0)return!0;const k={edits:[]};for(const w of y){const{edits:u}=f.WorkspaceEdit.from(w);k.edits=k.edits.concat(u)}return this.d.$tryApplyWorkspaceEdit(k)}}e.$cfc=M}),define(ke[148],Se([1,0,8,15,7]),function(me,e,C,F,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zec=void 0;class L{static{this.apiEditorsToExtHost=new WeakMap}constructor(b,v,g,A,I,$){this.id=b,this.f=v,this.notebookData=g,this.a=[],this.b=[],this.d=!1,this.a=I,this.b=A,this.c=$}get apiEditor(){if(!this.e){const b=this;this.e={get notebook(){return b.notebookData.apiNotebook},get selection(){return b.a[0]},set selection(v){this.selections=[v]},get selections(){return b.a},set selections(v){if(!Array.isArray(v)||!v.every(f.$WL.isNotebookRange))throw(0,C.$6)("selections");b.a=v,b.g(v)},get visibleRanges(){return b.b},revealRange(v,g){b.f.$tryRevealRange(b.id,F.NotebookRange.from(v),g??f.NotebookEditorRevealType.Default)},get viewColumn(){return b.c}},L.apiEditorsToExtHost.set(this.e,this)}return this.e}get visible(){return this.d}_acceptVisibility(b){this.d=b}_acceptVisibleRanges(b){this.b=b}_acceptSelections(b){this.a=b}g(b){this.f.$trySetSelections(this.id,b.map(F.NotebookRange.from))}_acceptViewColumn(b){this.c=b}}e.$Zec=L}),define(ke[297],Se([1,0,8,4,14,15]),function(me,e,C,F,f,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$efc=void 0;let M=class{constructor(v,g){this.c=v,this.d=g,this.a=new F.$Rd({onListenerError:C.$1}),this.b=new F.$Rd({onListenerError:C.$1}),this.onDidChangeNotebookEditorSelection=this.a.event,this.onDidChangeNotebookEditorVisibleRanges=this.b.event}$acceptEditorPropertiesChanged(v,g){this.c.debug("ExtHostNotebook#$acceptEditorPropertiesChanged",v,g);const A=this.d.getEditorById(v);g.visibleRanges&&A._acceptVisibleRanges(g.visibleRanges.ranges.map(L.NotebookRange.to)),g.selections&&A._acceptSelections(g.selections.selections.map(L.NotebookRange.to)),g.visibleRanges&&this.b.fire({notebookEditor:A.apiEditor,visibleRanges:A.apiEditor.visibleRanges}),g.selections&&this.a.fire(Object.freeze({notebookEditor:A.apiEditor,selections:A.apiEditor.selections}))}$acceptEditorViewColumns(v){for(const g in v)this.d.getEditorById(g)._acceptViewColumn(L.ViewColumn.to(v[g]))}};e.$efc=M,e.$efc=M=He([Be(0,f.$dj)],M)}),define(ke[298],Se([1,0,15,85,216,21,59,8]),function(me,e,C,F,f,L,M,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lfc=void 0;class v{constructor($){this.b=0,this.c=new Map,this.a=$}async withProgress($,y,k){const w=this.b++,{title:u,location:o,cancellable:i}=y,n={label:(0,f.localize)(0,null,$.displayName||$.name),id:$.identifier.value};return this.a.$startProgress(w,{location:C.ProgressLocation.from(o),title:u,source:n,cancellable:i},$.isUnderDevelopment?void 0:$.identifier.value).catch(b.$1),this.d(w,k,!!i)}d($,y,k){let w;k&&(w=new L.$2d,this.c.set($,w));const u=i=>{this.a.$progressEnd(i),this.c.delete(i),w?.dispose()};let o;try{o=y(new A(this.a,$),k&&w?w.token:L.CancellationToken.None)}catch(i){throw u($),i}return o.then(i=>u($),i=>u($)),o}$acceptProgressCanceled($){const y=this.c.get($);y&&(y.cancel(),this.c.delete($))}}e.$lfc=v;function g(I,$){return I.message=$.message,typeof $.increment=="number"&&(typeof I.increment=="number"?I.increment+=$.increment:I.increment=$.increment),I}class A extends F.$$u{constructor($,y){super(k=>this.throttledReport(k)),this.c=$,this.d=y}throttledReport($){this.c.$progressReport(this.d,$)}}He([(0,M.$ph)(100,(I,$)=>g(I,$),()=>Object.create(null))],A.prototype,"throttledReport",null)}),define(ke[149],Se([1,0,29,144,67,112,89,15,2]),function(me,e,C,F,f,L,M,b,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$OM=e.$NM=e.$MM=e.$LM=void 0;const g=(n,r,a,t)=>{let s=r;return{enumerable:!0,configurable:!1,get(){return s},set(d){if(!a(s,d)){const c=s;s=d,n.listener?.(t(d,c))}}}},A=(n,r)=>n===r,I={range:(n,r)=>n===r?!0:!n||!r?!1:n.isEqual(r),label:A,description:A,sortText:A,busy:A,error:A,canResolveChildren:A,tags:(n,r)=>!(n.length!==r.length||n.some(a=>!r.find(t=>a.id===t.id)))},$=n=>r=>({op:4,update:n(r)}),y=(n,r)=>({range:(()=>{let a;const t=$(s=>({range:C.$zs.lift(b.Range.from(s))}));return{enumerable:!0,configurable:!1,get(){return a},set(s){n.listener?.({op:6}),I.range(a,s)||(a=s,n.listener?.(t(s)))}}})(),label:g(n,r,I.label,$(a=>({label:a}))),description:g(n,void 0,I.description,$(a=>({description:a}))),sortText:g(n,void 0,I.sortText,$(a=>({sortText:a}))),canResolveChildren:g(n,!1,I.canResolveChildren,a=>({op:2,state:a})),busy:g(n,!1,I.busy,$(a=>({busy:a}))),error:g(n,void 0,I.error,$(a=>({error:b.MarkdownString.fromStrict(a)||null}))),tags:g(n,[],I.tags,(a,t)=>({op:1,new:a.map(b.TestTag.from),old:t.map(b.TestTag.from)}))}),k=n=>{const r=f.$qJ.fromString(n.extId),a=new u(r.controllerId,r.localId,n.label,v.URI.revive(n.uri)||void 0);return a.range=b.Range.to(n.range||void 0),a.description=n.description||void 0,a.sortText=n.sortText||void 0,a.tags=n.tags.map(t=>b.TestTag.to({id:(0,M.$vJ)(t).tagId})),a},w=n=>{let r;for(const a of n.tests){const t=k(a.item);(0,F.$vM)(t).parent=r,r=t}return r};e.$LM=w;class u{constructor(r,a,t,s){if(a.includes("\0"))throw new Error(`Test IDs may not include the ${JSON.stringify(a)} symbol`);const d=(0,F.$uM)(this,r);Object.defineProperties(this,{id:{value:a,enumerable:!0,writable:!1},uri:{value:s,enumerable:!0,writable:!1},parent:{enumerable:!1,get(){return d.parent instanceof o?void 0:d.parent}},children:{value:(0,L.$tM)(d,F.$vM,u),enumerable:!0,writable:!1},...y(d,t)})}}e.$MM=u;class o extends u{constructor(r,a){super(r,r,a,void 0),this._isRoot=!0}}e.$NM=o;class i extends L.$pM{constructor(r,a,t){super({controllerId:r,getDocumentVersion:s=>s&&t.getDocument(s)?.version,getApiFor:F.$vM,getChildren:s=>s.children,root:new o(r,a),toITestItem:b.TestItem.from})}}e.$OM=i}),define(ke[150],Se([1,0,60,8,122,15,7]),function(me,e,C,F,f,L,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$IM=e.$HM=e.$GM=void 0;class b{static{this.c=new f.$EM("TextEditorDecorationType")}constructor($,y,k){const w=b.c.nextId();$.$registerTextEditorDecorationType(y.identifier,w,L.DecorationRenderOptions.from(k)),this.value=Object.freeze({key:w,dispose(){$.$removeTextEditorDecorationType(w)}})}}e.$GM=b;class v{constructor($,y){this.g=[],this.h=void 0,this.j=!1,this.c=$,this.d=$.version,this.e=y.undoStopBefore,this.f=y.undoStopAfter}finalize(){return this.j=!0,{documentVersionId:this.d,edits:this.g,setEndOfLine:this.h,undoStopBefore:this.e,undoStopAfter:this.f}}k(){if(this.j)throw new Error("Edit is only valid while callback runs")}replace($,y){this.k();let k=null;if($ instanceof M.$AK)k=new M.$BK($,$);else if($ instanceof M.$BK)k=$;else throw new Error("Unrecognized location");this.l(k,y,!1)}insert($,y){this.k(),this.l(new M.$BK($,$),y,!0)}delete($){this.k();let y=null;if($ instanceof M.$BK)y=$;else throw new Error("Unrecognized location");this.l(y,null,!0)}l($,y,k){const w=this.c.validateRange($);this.g.push({range:w,text:y,forceMoveMarkers:k})}setEndOfLine($){if(this.k(),$!==M.EndOfLine.LF&&$!==M.EndOfLine.CRLF)throw(0,F.$6)("endOfLine");this.h=$}}class g{constructor($,y,k,w){this.c=$,this.d=y,this._accept(k),this.e=w;const u=this;this.value={get tabSize(){return u.f},set tabSize(o){u.m(o)},get indentSize(){return u.g},set indentSize(o){u.o(o)},get insertSpaces(){return u.h},set insertSpaces(o){u.q(o)},get cursorStyle(){return u.j},set cursorStyle(o){u.s(o)},get lineNumbers(){return u.k},set lineNumbers(o){u.t(o)}}}_accept($){this.f=$.tabSize,this.g=$.indentSize,this.h=$.insertSpaces,this.j=$.cursorStyle,this.k=L.TextEditorLineNumbersStyle.to($.lineNumbers)}l($){if($==="auto")return"auto";if(typeof $=="number"){const y=Math.floor($);return y>0?y:null}if(typeof $=="string"){const y=parseInt($,10);return isNaN(y)?null:y>0?y:null}return null}m($){const y=this.l($);if(y!==null){if(typeof y=="number"){if(this.f===y)return;this.f=y}this.u("setTabSize",this.c.$trySetOptions(this.d,{tabSize:y}))}}n($){if($==="tabSize")return"tabSize";if(typeof $=="number"){const y=Math.floor($);return y>0?y:null}if(typeof $=="string"){const y=parseInt($,10);return isNaN(y)?null:y>0?y:null}return null}o($){const y=this.n($);if(y!==null){if(typeof y=="number"){if(this.g===y)return;this.g=y}this.u("setIndentSize",this.c.$trySetOptions(this.d,{indentSize:y}))}}p($){return $==="auto"?"auto":$==="false"?!1:!!$}q($){const y=this.p($);if(typeof y=="boolean"){if(this.h===y)return;this.h=y}this.u("setInsertSpaces",this.c.$trySetOptions(this.d,{insertSpaces:y}))}s($){this.j!==$&&(this.j=$,this.u("setCursorStyle",this.c.$trySetOptions(this.d,{cursorStyle:$})))}t($){this.k!==$&&(this.k=$,this.u("setLineNumbers",this.c.$trySetOptions(this.d,{lineNumbers:L.TextEditorLineNumbersStyle.from($)})))}assign($){const y={};let k=!1;if(typeof $.tabSize<"u"){const w=this.l($.tabSize);w==="auto"?(k=!0,y.tabSize=w):typeof w=="number"&&this.f!==w&&(this.f=w,k=!0,y.tabSize=w)}if(typeof $.indentSize<"u"){const w=this.n($.indentSize);w==="tabSize"?(k=!0,y.indentSize=w):typeof w=="number"&&this.g!==w&&(this.g=w,k=!0,y.indentSize=w)}if(typeof $.insertSpaces<"u"){const w=this.p($.insertSpaces);w==="auto"?(k=!0,y.insertSpaces=w):this.h!==w&&(this.h=w,k=!0,y.insertSpaces=w)}typeof $.cursorStyle<"u"&&this.j!==$.cursorStyle&&(this.j=$.cursorStyle,k=!0,y.cursorStyle=$.cursorStyle),typeof $.lineNumbers<"u"&&this.k!==$.lineNumbers&&(this.k=$.lineNumbers,k=!0,y.lineNumbers=L.TextEditorLineNumbersStyle.from($.lineNumbers)),k&&this.u("setOptions",this.c.$trySetOptions(this.d,y))}u($,y){y.catch(k=>{this.e.warn(`ExtHostTextEditorOptions '${$}' failed:'`),this.e.warn(k)})}}e.$HM=g;class A{constructor($,y,k,w,u,o,i,n){this.id=$,this.j=y,this.k=k,this.g=!1,this.h=new Set,this.c=u,this.d=new g(this.j,this.id,o,k),this.e=i,this.f=n;const r=this;this.value=Object.freeze({get document(){return w.value},set document(a){throw new F.$8("document")},get selection(){return r.c&&r.c[0]},set selection(a){if(!(a instanceof M.$CK))throw(0,F.$6)("selection");r.c=[a],r.l()},get selections(){return r.c},set selections(a){if(!Array.isArray(a)||a.some(t=>!(t instanceof M.$CK)))throw(0,F.$6)("selections");r.c=a,r.l()},get visibleRanges(){return r.e},set visibleRanges(a){throw new F.$8("visibleRanges")},get options(){return r.d.value},set options(a){r.g||r.d.assign(a)},get viewColumn(){return r.f},set viewColumn(a){throw new F.$8("viewColumn")},edit(a,t={undoStopBefore:!0,undoStopAfter:!0}){if(r.g)return Promise.reject(new Error("TextEditor#edit not possible on closed editors"));const s=new v(w.value,t);return a(s),r.m(s)},insertSnippet(a,t,s={undoStopBefore:!0,undoStopAfter:!0}){if(r.g)return Promise.reject(new Error("TextEditor#insertSnippet not possible on closed editors"));let d;if(!t||Array.isArray(t)&&t.length===0)d=r.c.map(c=>L.Range.from(c));else if(t instanceof M.$AK){const{lineNumber:c,column:l}=L.Position.from(t);d=[{startLineNumber:c,startColumn:l,endLineNumber:c,endColumn:l}]}else if(t instanceof M.$BK)d=[L.Range.from(t)];else{d=[];for(const c of t)if(c instanceof M.$BK)d.push(L.Range.from(c));else{const{lineNumber:l,column:h}=L.Position.from(c);d.push({startLineNumber:l,startColumn:h,endLineNumber:l,endColumn:h})}}return y.$tryInsertSnippet($,w.value.version,a.value,d,s)},setDecorations(a,t){const s=t.length===0;s&&!r.h.has(a.key)||(s?r.h.delete(a.key):r.h.add(a.key),r.n(()=>{if(L.$wM(t))return y.$trySetDecorations($,a.key,L.$xM(t));{const d=new Array(4*t.length);for(let c=0,l=t.length;c<l;c++){const h=t[c];d[4*c]=h.start.line+1,d[4*c+1]=h.start.character+1,d[4*c+2]=h.end.line+1,d[4*c+3]=h.end.character+1}return y.$trySetDecorationsFast($,a.key,d)}}))},revealRange(a,t){r.n(()=>y.$tryRevealRange($,L.Range.from(a),t||M.TextEditorRevealType.Default))},show(a){y.$tryShowEditor($,L.ViewColumn.from(a))},hide(){y.$tryHideEditor($)}})}dispose(){(0,C.ok)(!this.g),this.g=!0}_acceptOptions($){(0,C.ok)(!this.g),this.d._accept($)}_acceptVisibleRanges($){(0,C.ok)(!this.g),this.e=$}_acceptViewColumn($){(0,C.ok)(!this.g),this.f=$}_acceptSelections($){(0,C.ok)(!this.g),this.c=$}async l(){const $=this.c.map(L.Selection.from);return await this.n(()=>this.j.$trySetSelections(this.id,$)),this.value}m($){const y=$.finalize();if(y.edits.length===0&&!y.setEndOfLine)return Promise.resolve(!0);const k=y.edits.map(u=>u.range);k.sort((u,o)=>u.end.line===o.end.line?u.end.character===o.end.character?u.start.line===o.start.line?u.start.character-o.start.character:u.start.line-o.start.line:u.end.character-o.end.character:u.end.line-o.end.line);for(let u=0,o=k.length-1;u<o;u++){const i=k[u].end;if(k[u+1].start.isBefore(i))return Promise.reject(new Error("Overlapping ranges are not allowed!"))}const w=y.edits.map(u=>({range:L.Range.from(u.range),text:u.text,forceMoveMarkers:u.forceMoveMarkers}));return this.j.$tryApplyEdits(this.id,y.documentVersionId,w,{setEndOfLine:typeof y.setEndOfLine=="number"?L.EndOfLine.from(y.setEndOfLine):void 0,undoStopBefore:y.undoStopBefore,undoStopAfter:y.undoStopAfter})}n($){return this.g?(this.k.warn("TextEditor is closed/disposed"),Promise.resolve(void 0)):$().then(()=>this,y=>(y instanceof Error&&y.name==="DISPOSED"||this.k.warn(y),null))}}e.$IM=A}),define(ke[299],Se([1,0,220,23,2,4,3,279,12,7,18,19,15,80,21,177,25]),function(me,e,C,F,f,L,M,b,v,g,A,I,$,y,k,w,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Efc=void 0;function o(r,a){if((0,A.$Cf)(r))return{label:r};if(r&&typeof r=="object"&&typeof r.label=="string"){let t;return Array.isArray(r.highlights)&&(t=r.highlights.filter(s=>s.length===2&&typeof s[0]=="number"&&typeof s[1]=="number"),t=t.length?t:void 0),{label:r.label,highlights:t}}}class i extends M.$Rc{constructor(a,t,s){super(),this.f=a,this.g=t,this.h=s,this.a=new Map,this.b=new w.$n8;function d(c){return c&&c.$treeViewId&&(c.$treeItemHandle||c.$selectedTreeItems||c.$focusedTreeItem)}t.registerArgumentProcessor({processArgument:c=>d(c)?this.r(c):Array.isArray(c)&&c.length>0?c.map(l=>d(l)?this.r(l):l):c})}registerTreeDataProvider(a,t,s){const d=this.createTreeView(a,{treeDataProvider:t},s);return{dispose:()=>d.dispose()}}createTreeView(a,t,s){if(!t||!t.treeDataProvider)throw new Error("Options with treeDataProvider is mandatory");const d=t.dragAndDropController?.dropMimeTypes??[],c=t.dragAndDropController?.dragMimeTypes??[],l=!!t.dragAndDropController?.handleDrag,h=!!t.dragAndDropController?.handleDrop,E=this.m(a,t,s),D={showCollapseAll:!!t.showCollapseAll,canSelectMany:!!t.canSelectMany,dropMimeTypes:d,dragMimeTypes:c,hasHandleDrag:l,hasHandleDrop:h,manuallyManageCheckboxes:!!t.manageCheckboxStateManually},m=this.f.$registerTreeViewDataProvider(a,D),p={get onDidCollapseElement(){return E.onDidCollapseElement},get onDidExpandElement(){return E.onDidExpandElement},get selection(){return E.selectedElements},get onDidChangeSelection(){return E.onDidChangeSelection},get activeItem(){return(0,u.$MF)(s,"treeViewActiveItem"),E.focusedElement},get onDidChangeActiveItem(){return(0,u.$MF)(s,"treeViewActiveItem"),E.onDidChangeActiveItem},get visible(){return E.visible},get onDidChangeVisibility(){return E.onDidChangeVisibility},get onDidChangeCheckboxState(){return E.onDidChangeCheckboxState},get message(){return E.message},set message(S){(0,y.$$j)(S)&&(0,u.$MF)(s,"treeViewMarkdownMessage"),E.message=S},get title(){return E.title},set title(S){E.title=S},get description(){return E.description},set description(S){E.description=S},get badge(){return E.badge},set badge(S){S!==void 0&&g.ViewBadge.isViewBadge(S)?E.badge={value:Math.floor(Math.abs(S.value)),tooltip:S.tooltip}:S===void 0&&(E.badge=void 0)},reveal:(S,P)=>E.reveal(S,P),dispose:async()=>{await m,this.a.delete(a),E.dispose()}};return this.B(p),p}$getChildren(a,t){const s=this.a.get(a);return s?s.getChildren(t):Promise.reject(new b.$JE(a))}async $handleDrop(a,t,s,d,c,l,h,E){const D=this.a.get(a);if(!D)return Promise.reject(new b.$JE(a));const m=$.DataTransfer.toDataTransfer(s,async p=>(await this.f.$resolveDropFileData(a,t,p)).buffer);return h===a&&E&&await this.j(m,D,E,c,l),D.onDrop(m,d,c)}async j(a,t,s,d,c){const l=this.b.removeDragOperationTransfer(c);if(l)(await l)?.forEach((h,E)=>{h&&a.set(E,h)});else if(c&&t.handleDrag){const h=t.handleDrag(s,a,d);this.b.addDragOperationTransfer(c,h),await h}return a}async $handleDrag(a,t,s,d){const c=this.a.get(a);if(!c)return Promise.reject(new b.$JE(a));const l=await this.j(new g.$qL,c,t,d,s);if(!(!l||d.isCancellationRequested))return $.DataTransfer.from(l)}async $hasResolve(a){const t=this.a.get(a);if(!t)throw new b.$JE(a);return t.hasResolve}$resolve(a,t,s){const d=this.a.get(a);if(!d)throw new b.$JE(a);return d.resolveTreeItem(t,s)}$setExpanded(a,t,s){const d=this.a.get(a);if(!d)throw new b.$JE(a);d.setExpanded(t,s)}$setSelectionAndFocus(a,t,s){const d=this.a.get(a);if(!d)throw new b.$JE(a);d.setSelectionAndFocus(t,s)}$setVisible(a,t){const s=this.a.get(a);if(!s){if(!t)return;throw new b.$JE(a)}s.setVisible(t)}$changeCheckboxState(a,t){const s=this.a.get(a);if(!s)throw new b.$JE(a);s.setCheckboxState(t)}m(a,t,s){const d=this.B(new n(a,t,this.f,this.g.converter,this.h,s));return this.a.set(a,d),d}r(a){const t=this.a.get(a.$treeViewId);return t&&"$treeItemHandle"in a?t.getExtensionElement(a.$treeItemHandle):t&&"$focusedTreeItem"in a&&a.$focusedTreeItem?t.focusedElement:null}}e.$Efc=i;class n extends M.$Rc{static{this.a="0"}static{this.b="1"}get visible(){return this.r}get selectedElements(){return this.s.map(a=>this.getExtensionElement(a)).filter(a=>!(0,A.$Lf)(a))}get focusedElement(){return this.t?this.getExtensionElement(this.t):void 0}constructor(a,t,s,d,c,l){if(super(),this.I=a,this.J=s,this.L=d,this.M=c,this.N=l,this.h=void 0,this.j=new Map,this.m=new Map,this.r=!1,this.s=[],this.t=void 0,this.u=this.B(new L.$Rd),this.onDidExpandElement=this.u.event,this.w=this.B(new L.$Rd),this.onDidCollapseElement=this.w.event,this.y=this.B(new L.$Rd),this.onDidChangeSelection=this.y.event,this.z=this.B(new L.$Rd),this.onDidChangeActiveItem=this.z.event,this.C=this.B(new L.$Rd),this.onDidChangeVisibility=this.C.event,this.D=this.B(new L.$Rd),this.onDidChangeCheckboxState=this.D.event,this.F=this.B(new L.$Rd),this.G=Promise.resolve(),this.H=Promise.resolve(),this.O="",this.P="",this.Z=new k.$2d,l.contributes&&l.contributes.views)for(const m in l.contributes.views)for(const p of l.contributes.views[m])p.id===a&&(this.P=p.name);this.f=t.treeDataProvider,this.g=t.dragAndDropController,this.f.onDidChangeTreeData&&this.B(this.f.onDidChangeTreeData(m=>this.F.fire({message:!1,element:m})));let h,E;const D=L.Event.debounce(this.F.event,(m,p)=>(m||(m={message:!1,elements:[]}),p.element!==!1&&(h||(h=new Promise(S=>E=S),this.G=this.G.then(()=>h)),Array.isArray(p.element)?m.elements.push(...p.element):m.elements.push(p.element)),p.message&&(m.message=!0),m),200,!0);this.B(D(({message:m,elements:p})=>{p.length&&(this.H=this.H.then(()=>{const S=E;return h=null,this.$(p).then(()=>S())})),m&&this.J.$setMessage(this.I,$.MarkdownString.fromStrict(this.O)??"")}))}async getChildren(a){const t=a?this.getExtensionElement(a):void 0;if(a&&!t)return this.M.error(`No tree item with id '${a}' found.`),Promise.resolve([]);let s=this.X(a);return s||(s=await this.Y(t)),s?s.map(d=>d.item):void 0}getExtensionElement(a){return this.j.get(a)}reveal(a,t){t=t||{select:!0,focus:!1};const s=(0,A.$Lf)(t.select)?!0:t.select,d=(0,A.$Lf)(t.focus)?!1:t.focus,c=(0,A.$Lf)(t.expand)?!1:t.expand;return typeof this.f.getParent!="function"?Promise.reject(new Error("Required registered TreeDataProvider to implement 'getParent' method to access 'reveal' method")):a?this.G.then(()=>this.S(a)).then(l=>this.W(a,l[l.length-1]).then(h=>this.J.$reveal(this.I,{item:h.item,parentChain:l.map(E=>E.item)},{select:s,focus:d,expand:c})),l=>this.M.error(l)):this.J.$reveal(this.I,void 0,{select:s,focus:d,expand:c})}get message(){return this.O}set message(a){this.O=a,this.F.fire({message:!0,element:!1})}get title(){return this.P}set title(a){this.P=a,this.J.$setTitle(this.I,a,this.Q)}get description(){return this.Q}set description(a){this.Q=a,this.J.$setTitle(this.I,this.P,a)}get badge(){return this.R}set badge(a){this.R?.value===a?.value&&this.R?.tooltip===a?.tooltip||(this.R=$.ViewBadge.from(a),this.J.$setBadge(this.I,a))}setExpanded(a,t){const s=this.getExtensionElement(a);s&&(t?this.u.fire(Object.freeze({element:s})):this.w.fire(Object.freeze({element:s})))}setSelectionAndFocus(a,t){const s=!(0,I.$tb)(this.s,a);this.s=a;const d=this.t!==t;this.t=t,s&&this.y.fire(Object.freeze({selection:this.selectedElements})),d&&this.z.fire(Object.freeze({activeItem:this.focusedElement}))}setVisible(a){a!==this.r&&(this.r=a,this.C.fire(Object.freeze({visible:this.r})))}async setCheckboxState(a){const t=(await Promise.all(a.map(async s=>{const d=this.getExtensionElement(s.treeItemHandle);return d?{extensionItem:d,treeItem:await this.f.getTreeItem(d),newState:s.newState?g.TreeItemCheckboxState.Checked:g.TreeItemCheckboxState.Unchecked}:Promise.resolve(void 0)}))).filter(s=>s!==void 0);t.forEach(s=>{s.treeItem.checkboxState=s.newState?g.TreeItemCheckboxState.Checked:g.TreeItemCheckboxState.Unchecked}),this.D.fire({items:t.map(s=>[s.extensionItem,s.newState])})}async handleDrag(a,t,s){const d=[];for(const c of a){const l=this.getExtensionElement(c);l&&d.push(l)}if(!(!this.g?.handleDrag||d.length===0))return await this.g.handleDrag(d,t,s),t}get hasHandleDrag(){return!!this.g?.handleDrag}async onDrop(a,t,s){const d=t?this.getExtensionElement(t):void 0;if(!(!d&&t||!this.g?.handleDrop))return(0,v.$Qg)(()=>this.g?.handleDrop?this.g.handleDrop(d,a,s):void 0)}get hasResolve(){return!!this.f.resolveTreeItem}async resolveTreeItem(a,t){if(!this.f.resolveTreeItem)return;const s=this.j.get(a);if(s){const d=this.m.get(s);if(d){const c=await this.f.resolveTreeItem(d.extensionItem,s,t)??d.extensionItem;return this.hb(c),d.item.tooltip=this.eb(c.tooltip),d.item.command=this.fb(d.disposableStore,c.command),d.item}}}S(a){return this.U(a).then(t=>t?this.S(t).then(s=>this.W(t,s[s.length-1]).then(d=>(s.push(d),s))):Promise.resolve([]))}U(a){const t=this.m.get(a);return t?Promise.resolve(t.parent?this.j.get(t.parent.item.handle):void 0):(0,v.$Qg)(()=>this.f.getParent(a))}W(a,t){const s=this.m.get(a);return s?Promise.resolve(s):(0,v.$Qg)(()=>this.f.getTreeItem(a)).then(d=>this.kb(a,d,t,!0)).then(d=>this.getChildren(t?t.item.handle:void 0).then(()=>{const c=this.getExtensionElement(d);if(c){const l=this.m.get(c);if(l)return Promise.resolve(l)}throw new Error(`Cannot resolve tree item for element ${d} from extension ${this.N.identifier.value}`)}))}X(a){if(a){let t;if(typeof a=="string"){const s=this.getExtensionElement(a);t=s?this.m.get(s):void 0}else t=a;return t&&t.children||void 0}return this.h}async Y(a){this.rb(a);const t=new k.$2d(this.Z.token);try{const s=a?this.m.get(a):void 0,d=await this.f.getChildren(a);if(t.token.isCancellationRequested)return;const c=await Promise.all((0,I.$Gb)(d||[]).map(async l=>{const h=await this.f.getTreeItem(l);return h&&!t.token.isCancellationRequested?this.db(l,h,s):null}));return t.token.isCancellationRequested?void 0:(0,I.$Gb)(c)}finally{t.dispose()}}$(a){if(a.some(s=>!s))return this.Z.dispose(!0),this.Z=new k.$2d,this.tb(),this.J.$refresh(this.I);{const s=this.ab(a);if(s.length)return this.bb(s)}return Promise.resolve(void 0)}ab(a){const t=new Set,s=a.map(c=>this.m.get(c));for(const c of s)if(c&&!t.has(c.item.handle)){let l=c;for(;l&&l.parent&&s.findIndex(h=>l&&l.parent&&h&&h.item.handle===l.parent.item.handle)===-1;){const h=this.j.get(l.parent.item.handle);l=h?this.m.get(h):void 0}l&&!l.parent&&t.add(c.item.handle)}const d=[];return t.forEach(c=>{const l=this.j.get(c);if(l){const h=this.m.get(l);h&&(!h.parent||!t.has(h.parent.item.handle))&&d.push(c)}}),d}bb(a){const t={};return Promise.all(a.map(s=>this.cb(s).then(d=>{d&&(t[s]=d.item)}))).then(()=>Object.keys(t).length?this.J.$refresh(this.I,t):void 0)}cb(a){const t=this.getExtensionElement(a);if(t){const s=this.m.get(t);if(s)return this.rb(t),(0,v.$Qg)(()=>this.f.getTreeItem(t)).then(d=>{if(d){const c=this.ib(t,d,s.parent);return this.pb(t,c,s,s.parent),s.dispose(),c}return null})}return Promise.resolve(null)}db(a,t,s){const d=this.ib(a,t,s);if(t.id&&this.j.has(d.item.handle))throw new Error((0,C.localize)(0,null,t.id));return this.ob(a,d),this.qb(d,s),d}eb(a){return g.$ZK.isMarkdownString(a)?$.MarkdownString.from(a):a}fb(a,t){return t?{...this.L.toInternal(t,a),originalId:t.command}:void 0}gb(a){if(a.checkboxState===void 0)return;let t,s,d;return typeof a.checkboxState=="number"?t=a.checkboxState:(t=a.checkboxState.state,s=a.checkboxState.tooltip,d=a.checkboxState.accessibilityInformation),{isChecked:t===g.TreeItemCheckboxState.Checked,tooltip:s,accessibilityInformation:d}}hb(a){if(!g.$lL.isTreeItem(a,this.N))throw new Error(`Extension ${this.N.identifier.value} has provided an invalid tree item.`)}ib(a,t,s){this.hb(t);const d=this.B(new M.$Qc),c=this.kb(a,t,s),l=this.lb(t);return{item:{handle:c,parentHandle:s?s.item.handle:void 0,label:o(t.label,this.N),description:t.description,resourceUri:t.resourceUri,tooltip:this.eb(t.tooltip),command:this.fb(d,t.command),contextValue:t.contextValue,icon:l,iconDark:this.mb(t)||l,themeIcon:this.jb(t),collapsibleState:(0,A.$Lf)(t.collapsibleState)?g.TreeItemCollapsibleState.None:t.collapsibleState,accessibilityInformation:t.accessibilityInformation,checkbox:this.gb(t)},extensionItem:t,parent:s,children:void 0,disposableStore:d,dispose(){d.dispose()}}}jb(a){return a.iconPath instanceof g.$tL?a.iconPath:void 0}kb(a,{id:t,label:s,resourceUri:d},c,l){if(t)return`${n.b}/${t}`;const h=o(s,this.N),E=c?c.item.handle:n.a;let D=h?h.label:d?(0,F.$wg)(d):"";D=D.indexOf("/")!==-1?D.replace("/","//"):D;const m=this.m.has(a)?this.m.get(a).item.handle:void 0,p=this.X(c)||[];let S,P=0;do{if(S=`${E}/${P}:${D}`,l||!this.j.has(S)||m===S)break;P++}while(P<=p.length);return S}lb(a){if(a.iconPath&&!(a.iconPath instanceof g.$tL))return typeof a.iconPath=="string"||f.URI.isUri(a.iconPath)?this.nb(a.iconPath):this.nb(a.iconPath.light)}mb(a){if(a.iconPath&&!(a.iconPath instanceof g.$tL)&&a.iconPath.dark)return this.nb(a.iconPath.dark)}nb(a){return f.URI.isUri(a)?a:f.URI.file(a)}ob(a,t){this.j.set(t.item.handle,a),this.m.set(a,t)}pb(a,t,s,d){this.j.delete(t.item.handle),this.m.delete(a),t.item.handle!==s.item.handle&&this.j.delete(s.item.handle),this.ob(a,t);const c=this.X(d)||[],l=c.filter(h=>h.item.handle===s.item.handle)[0];l&&c.splice(c.indexOf(l),1,t)}qb(a,t){t?(t.children||(t.children=[]),t.children.push(a)):(this.h||(this.h=[]),this.h.push(a))}rb(a){if(a){const t=this.m.get(a);if(t){if(t.children)for(const s of t.children){const d=this.j.get(s.item.handle);d&&this.sb(d)}t.children=void 0}}else this.tb()}sb(a){const t=this.m.get(a);if(t){if(t.children)for(const s of t.children){const d=this.j.get(s.item.handle);d&&this.sb(d)}this.m.delete(a),this.j.delete(t.item.handle),t.dispose()}}tb(){this.h=void 0,this.j.clear(),this.m.forEach(a=>a.dispose()),this.m.clear()}dispose(){super.dispose(),this.Z.dispose(),this.tb(),this.J.$disposeTree(this.I)}}}),define(ke[300],Se([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.allApiProposals=void 0,e.allApiProposals=Object.freeze({aiRelatedInformation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.aiRelatedInformation.d.ts",authGetSessions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authGetSessions.d.ts",authSession:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authSession.d.ts",canonicalUriProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.canonicalUriProvider.d.ts",chat:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chat.d.ts",chatAgents2:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatAgents2.d.ts",chatAgents2Additions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatAgents2Additions.d.ts",chatProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatProvider.d.ts",chatRequestAccess:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatRequestAccess.d.ts",chatTab:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatTab.d.ts",chatVariables:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatVariables.d.ts",codeActionAI:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codeActionAI.d.ts",codiconDecoration:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codiconDecoration.d.ts",commentsDraftState:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentsDraftState.d.ts",contribCommentEditorActionsMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentEditorActionsMenu.d.ts",contribCommentPeekContext:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentPeekContext.d.ts",contribCommentThreadAdditionalMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentThreadAdditionalMenu.d.ts",contribEditSessions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditSessions.d.ts",contribEditorContentMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditorContentMenu.d.ts",contribLabelFormatterWorkspaceTooltip:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribLabelFormatterWorkspaceTooltip.d.ts",contribMenuBarHome:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMenuBarHome.d.ts",contribMergeEditorMenus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMergeEditorMenus.d.ts",contribNotebookStaticPreloads:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribNotebookStaticPreloads.d.ts",contribRemoteHelp:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribRemoteHelp.d.ts",contribShareMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribShareMenu.d.ts",contribStatusBarItems:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribStatusBarItems.d.ts",contribViewsRemote:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsRemote.d.ts",contribViewsWelcome:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsWelcome.d.ts",createFileSystemWatcher:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.createFileSystemWatcher.d.ts",customEditorMove:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.customEditorMove.d.ts",debugFocus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.debugFocus.d.ts",defaultChatAgent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.defaultChatAgent.d.ts",diffCommand:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffCommand.d.ts",diffContentOptions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffContentOptions.d.ts",documentFiltersExclusive:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentFiltersExclusive.d.ts",documentPaste:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentPaste.d.ts",dropMetadata:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.dropMetadata.d.ts",editSessionIdentityProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editSessionIdentityProvider.d.ts",editorInsets:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editorInsets.d.ts",extensionRuntime:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionRuntime.d.ts",extensionsAny:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionsAny.d.ts",externalUriOpener:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.externalUriOpener.d.ts",fileComments:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileComments.d.ts",fileSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileSearchProvider.d.ts",findTextInFiles:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findTextInFiles.d.ts",fsChunks:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fsChunks.d.ts",handleIssueUri:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.handleIssueUri.d.ts",idToken:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.idToken.d.ts",inlineCompletionsAdditions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.inlineCompletionsAdditions.d.ts",interactive:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactive.d.ts",interactiveUserActions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactiveUserActions.d.ts",interactiveWindow:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactiveWindow.d.ts",ipc:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.ipc.d.ts",languageStatusText:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.languageStatusText.d.ts",mappedEditsProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.mappedEditsProvider.d.ts",notebookCellExecutionState:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookCellExecutionState.d.ts",notebookControllerAffinityHidden:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookControllerAffinityHidden.d.ts",notebookDeprecated:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookDeprecated.d.ts",notebookExecution:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookExecution.d.ts",notebookKernelSource:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookKernelSource.d.ts",notebookLiveShare:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookLiveShare.d.ts",notebookMessaging:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMessaging.d.ts",notebookMime:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMime.d.ts",portsAttributes:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.portsAttributes.d.ts",profileContentHandlers:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.profileContentHandlers.d.ts",quickDiffProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickDiffProvider.d.ts",quickPickItemTooltip:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickItemTooltip.d.ts",quickPickSortByLabel:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickSortByLabel.d.ts",readonlyMessage:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.readonlyMessage.d.ts",resolvers:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.resolvers.d.ts",saveEditor:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.saveEditor.d.ts",scmActionButton:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmActionButton.d.ts",scmHistoryProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmHistoryProvider.d.ts",scmInputBoxActionButton:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmInputBoxActionButton.d.ts",scmSelectedProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmSelectedProvider.d.ts",scmTextDocument:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmTextDocument.d.ts",scmValidation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmValidation.d.ts",shareProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.shareProvider.d.ts",showLocal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.showLocal.d.ts",speech:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.speech.d.ts",tabInputTextMerge:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tabInputTextMerge.d.ts",taskPresentationGroup:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.taskPresentationGroup.d.ts",telemetry:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.telemetry.d.ts",terminalDataWriteEvent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDataWriteEvent.d.ts",terminalDimensions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDimensions.d.ts",terminalExecuteCommandEvent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalExecuteCommandEvent.d.ts",terminalQuickFixProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalQuickFixProvider.d.ts",terminalSelection:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalSelection.d.ts",testCoverage:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testCoverage.d.ts",testObserver:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testObserver.d.ts",testingActiveProfile:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testingActiveProfile.d.ts",textSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.textSearchProvider.d.ts",timeline:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.timeline.d.ts",tokenInformation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tokenInformation.d.ts",treeViewActiveItem:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewActiveItem.d.ts",treeViewMarkdownMessage:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewMarkdownMessage.d.ts",treeViewReveal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewReveal.d.ts",tunnelFactory:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnelFactory.d.ts",tunnels:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnels.d.ts",windowActivity:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.windowActivity.d.ts",workspaceTrust:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.workspaceTrust.d.ts"})}),define(ke[301],Se([1,0,234,8,39,135,108,37,26,300,138,139]),function(me,e,C,F,f,L,M,b,v,g,A,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$XF=e.$WF=e.$VF=e.$UF=e.$TF=e.$SF=void 0;const $=b.$mn.as(M.$nn.JSONContribution);class y{constructor(a,t,s){this.a=a,this.b=t,this.c=s}d(a,t){this.a({type:a,message:t,extensionId:this.b.identifier,extensionPointId:this.c})}error(a){this.d(f.default.Error,a)}warn(a){this.d(f.default.Warning,a)}info(a){this.d(f.default.Info,a)}}e.$SF=y;class k{static a(a){const t=new v.$am;for(let s=0,d=a.length;s<d;s++)t.add(a[s].description.identifier);return t}static compute(a,t){if(!a||!a.length)return new k(t,[]);if(!t||!t.length)return new k([],a);const s=this.a(a),d=this.a(t),c=t.filter(h=>!s.has(h.description.identifier)),l=a.filter(h=>!d.has(h.description.identifier));return new k(c,l)}constructor(a,t){this.added=a,this.removed=t}}e.$TF=k;class w{constructor(a,t){this.name=a,this.defaultExtensionKind=t,this.a=null,this.b=null,this.c=null}setHandler(a){if(this.a!==null)throw new Error("Handler already set!");this.a=a,this.d()}acceptUsers(a){this.c=k.compute(this.b,a),this.b=a,this.d()}d(){if(!(this.a===null||this.b===null||this.c===null))try{this.a(this.b,this.c)}catch(a){(0,F.$Z)(a)}}}e.$UF=w;const u={type:"string",enum:["ui","workspace"],enumDescriptions:[C.localize(0,null),C.localize(1,null)]},o="vscode://schemas/vscode-extensions";e.$VF={properties:{engines:{type:"object",description:C.localize(2,null),properties:{vscode:{type:"string",description:C.localize(3,null),default:"^1.22.0"}}},publisher:{description:C.localize(4,null),type:"string"},displayName:{description:C.localize(5,null),type:"string"},categories:{description:C.localize(6,null),type:"array",uniqueItems:!0,items:{oneOf:[{type:"string",enum:v.$$l},{type:"string",const:"Languages",deprecationMessage:C.localize(7,null)}]}},galleryBanner:{type:"object",description:C.localize(8,null),properties:{color:{description:C.localize(9,null),type:"string"},theme:{description:C.localize(10,null),type:"string",enum:["dark","light"]}}},contributes:{description:C.localize(11,null),type:"object",properties:{},default:{}},preview:{type:"boolean",description:C.localize(12,null)},enableProposedApi:{type:"boolean",deprecationMessage:C.localize(13,null)},enabledApiProposals:{markdownDescription:C.localize(14,null),type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(g.allApiProposals),markdownEnumDescriptions:Object.values(g.allApiProposals)}},api:{markdownDescription:C.localize(15,null),type:"string",enum:["none"],enumDescriptions:[C.localize(16,null)]},activationEvents:{description:C.localize(17,null),type:"array",items:{type:"string",defaultSnippets:[{label:"onWebviewPanel",description:C.localize(18,null),body:"onWebviewPanel:viewType"},{label:"onLanguage",description:C.localize(19,null),body:"onLanguage:${1:languageId}"},{label:"onCommand",description:C.localize(20,null),body:"onCommand:${2:commandId}"},{label:"onDebug",description:C.localize(21,null),body:"onDebug"},{label:"onDebugInitialConfigurations",description:C.localize(22,null),body:"onDebugInitialConfigurations"},{label:"onDebugDynamicConfigurations",description:C.localize(23,null),body:"onDebugDynamicConfigurations"},{label:"onDebugResolve",description:C.localize(24,null),body:"onDebugResolve:${6:type}"},{label:"onDebugAdapterProtocolTracker",description:C.localize(25,null),body:"onDebugAdapterProtocolTracker:${6:type}"},{label:"workspaceContains",description:C.localize(26,null),body:"workspaceContains:${4:filePattern}"},{label:"onStartupFinished",description:C.localize(27,null),body:"onStartupFinished"},{label:"onTaskType",description:C.localize(28,null),body:"onTaskType:${1:taskType}"},{label:"onFileSystem",description:C.localize(29,null),body:"onFileSystem:${1:scheme}"},{label:"onEditSession",description:C.localize(30,null),body:"onEditSession:${1:scheme}"},{label:"onSearch",description:C.localize(31,null),body:"onSearch:${7:scheme}"},{label:"onView",body:"onView:${5:viewId}",description:C.localize(32,null)},{label:"onUri",body:"onUri",description:C.localize(33,null)},{label:"onOpenExternalUri",body:"onOpenExternalUri",description:C.localize(34,null)},{label:"onCustomEditor",body:"onCustomEditor:${9:viewType}",description:C.localize(35,null)},{label:"onNotebook",body:"onNotebook:${1:type}",description:C.localize(36,null)},{label:"onAuthenticationRequest",body:"onAuthenticationRequest:${11:authenticationProviderId}",description:C.localize(37,null)},{label:"onRenderer",description:C.localize(38,null),body:"onRenderer:${11:rendererId}"},{label:"onTerminalProfile",body:"onTerminalProfile:${1:terminalId}",description:C.localize(39,null)},{label:"onTerminalQuickFixRequest",body:"onTerminalQuickFixRequest:${1:quickFixId}",description:C.localize(40,null)},{label:"onWalkthrough",body:"onWalkthrough:${1:walkthroughID}",description:C.localize(41,null)},{label:"onIssueReporterOpened",body:"onIssueReporterOpened",description:C.localize(42,null)},{label:"*",description:C.localize(43,null),body:"*"}]}},badges:{type:"array",description:C.localize(44,null),items:{type:"object",required:["url","href","description"],properties:{url:{type:"string",description:C.localize(45,null)},href:{type:"string",description:C.localize(46,null)},description:{type:"string",description:C.localize(47,null)}}}},markdown:{type:"string",description:C.localize(48,null),enum:["github","standard"],default:"github"},qna:{default:"marketplace",description:C.localize(49,null),anyOf:[{type:["string","boolean"],enum:["marketplace",!1]},{type:"string"}]},extensionDependencies:{description:C.localize(50,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:L.$4n}},extensionPack:{description:C.localize(51,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:L.$4n}},extensionKind:{description:C.localize(52,null),type:"array",items:u,default:["workspace"],defaultSnippets:[{body:["ui"],description:C.localize(53,null)},{body:["workspace"],description:C.localize(54,null)},{body:["ui","workspace"],description:C.localize(55,null)},{body:["workspace","ui"],description:C.localize(56,null)},{body:[],description:C.localize(57,null)}]},capabilities:{description:C.localize(58,null),type:"object",properties:{virtualWorkspaces:{description:C.localize(59,null),type:["boolean","object"],defaultSnippets:[{label:"limited",body:{supported:"${1:limited}",description:"${2}"}},{label:"false",body:{supported:!1,description:"${2}"}}],default:(!0).valueOf,properties:{supported:{markdownDescription:C.localize(60,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[C.localize(61,null),C.localize(62,null),C.localize(63,null)]},description:{type:"string",markdownDescription:C.localize(64,null)}}},untrustedWorkspaces:{description:C.localize(65,null),type:"object",required:["supported"],defaultSnippets:[{body:{supported:"${1:limited}",description:"${2}"}}],properties:{supported:{markdownDescription:C.localize(66,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[C.localize(67,null),C.localize(68,null),C.localize(69,null)]},restrictedConfigurations:{description:C.localize(70,null),type:"array",items:{type:"string"}},description:{type:"string",markdownDescription:C.localize(71,null)}}}}},sponsor:{description:C.localize(72,null),type:"object",defaultSnippets:[{body:{url:"${1:https:}"}}],properties:{url:{description:C.localize(73,null),type:"string"}}},scripts:{type:"object",properties:{"vscode:prepublish":{description:C.localize(74,null),type:"string"},"vscode:uninstall":{description:C.localize(75,null),type:"string"}}},icon:{type:"string",description:C.localize(76,null)},l10n:{type:"string",description:C.localize(77,null)},pricing:{type:"string",markdownDescription:C.localize(78,null),enum:["Free","Trial"],default:"Free"}}};class i{constructor(){this.a=new Map}registerExtensionPoint(a){if(this.a.has(a.extensionPoint))throw new Error("Duplicate extension point: "+a.extensionPoint);const t=new w(a.extensionPoint,a.defaultExtensionKind);return this.a.set(a.extensionPoint,t),a.activationEventsGenerator&&I.$xF.register(a.extensionPoint,a.activationEventsGenerator),e.$VF.properties.contributes.properties[a.extensionPoint]=a.jsonSchema,$.registerSchema(o,e.$VF),t}getExtensionPoints(){return Array.from(this.a.values())}}e.$WF=i;const n={ExtensionsRegistry:"ExtensionsRegistry"};b.$mn.add(n.ExtensionsRegistry,new i),e.$XF=b.$mn.as(n.ExtensionsRegistry),$.registerSchema(o,e.$VF),$.registerSchema(A.$wj,{properties:{extensionEnabledApiProposals:{description:C.localize(79,null),type:"object",properties:{},additionalProperties:{anyOf:[{type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(g.allApiProposals),markdownEnumDescriptions:Object.values(g.allApiProposals)}}]}}}})}),define(ke[302],Se([1,0,230,18,24,301,45,4]),function(me,e,C,F,f,L,M,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7F=void 0;const v={type:"object",additionalProperties:!1,properties:{type:{type:"string",description:C.localize(0,null)},required:{type:"array",items:{type:"string"}},properties:{type:"object",description:C.localize(1,null),additionalProperties:{$ref:"http://json-schema.org/draft-07/schema#"}},when:{type:"string",markdownDescription:C.localize(2,null),default:""}}};var g;(function($){function y(k,w,u){if(!k)return;const o=F.$Cf(k.type)?k.type:void 0;if(!o||o.length===0){u.error(C.localize(3,null));return}const i=[];if(Array.isArray(k.required))for(const n of k.required)F.$Cf(n)&&i.push(n);return{extensionId:w.value,taskType:o,required:i,properties:k.properties?f.$an(k.properties):{},when:k.when?M.$Ti.deserialize(k.when):void 0}}$.from=y})(g||(g={}));const A=L.$XF.registerExtensionPoint({extensionPoint:"taskDefinitions",activationEventsGenerator:($,y)=>{for(const k of $)k.type&&y.push(`onTaskType:${k.type}`)},jsonSchema:{description:C.localize(4,null),type:"array",items:v}});class I{constructor(){this.d=new b.$Rd,this.onDefinitionsChanged=this.d.event,this.a=Object.create(null),this.b=new Promise((y,k)=>{A.setHandler((w,u)=>{this.c=void 0;try{for(const o of u.removed){const i=o.value;for(const n of i)this.a&&n.type&&this.a[n.type]&&delete this.a[n.type]}for(const o of u.added){const i=o.value;for(const n of i){const r=g.from(n,o.description.identifier,o.collector);r&&(this.a[r.taskType]=r)}}(u.removed.length>0||u.added.length>0)&&this.d.fire()}catch{}y(void 0)})})}onReady(){return this.b}get(y){return this.a[y]}all(){return Object.keys(this.a).map(y=>this.a[y])}getJsonSchema(){if(this.c===void 0){const y=[];for(const k of this.all()){const w={type:"object",additionalProperties:!1};k.required.length>0&&(w.required=k.required.slice(0)),k.properties!==void 0?w.properties=f.$an(k.properties):w.properties=Object.create(null),w.properties.type={type:"string",enum:[k.taskType]},y.push(w)}this.c={oneOf:y}}return this.c}}e.$7F=new I}),define(ke[303],Se([1,0,231,18,23,24,45,302]),function(me,e,C,F,f,L,M,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TaskDefinition=e.TasksSchemaProperties=e.TaskSettingId=e.KeyedTaskIdentifier=e.TaskEvent=e.TaskRunSource=e.TaskRunType=e.TaskEventKind=e.$eG=e.JsonSchemaVersion=e.ExecutionEngine=e.$dG=e.$cG=e.$bG=e.$aG=e.$_F=e.RunOptions=e.RunOnOptions=e.DependsOrder=e.TaskSourceKind=e.TaskScope=e.TaskGroup=e.CommandString=e.RuntimeType=e.PresentationOptions=e.PanelKind=e.RevealProblemKind=e.RevealKind=e.CommandOptions=e.$$F=e.ShellQuoting=e.$0F=e.$9F=e.$8F=void 0,e.$8F="settings",e.$9F=new M.$aj("taskRunning",!1,C.localize(0,null)),e.$0F={value:C.localize(1,null),original:"Tasks"};var v;(function(N){N[N.Escape=1]="Escape",N[N.Strong=2]="Strong",N[N.Weak=3]="Weak"})(v||(e.ShellQuoting=v={})),e.$$F="$customized",function(N){function O(W){if(!W)return N.Strong;switch(W.toLowerCase()){case"escape":return N.Escape;case"strong":return N.Strong;case"weak":return N.Weak;default:return N.Strong}}N.from=O}(v||(e.ShellQuoting=v={}));var g;(function(N){N.defaults={cwd:"${workspaceFolder}"}})(g||(e.CommandOptions=g={}));var A;(function(N){N[N.Always=1]="Always",N[N.Silent=2]="Silent",N[N.Never=3]="Never"})(A||(e.RevealKind=A={})),function(N){function O(W){switch(W.toLowerCase()){case"always":return N.Always;case"silent":return N.Silent;case"never":return N.Never;default:return N.Always}}N.fromString=O}(A||(e.RevealKind=A={}));var I;(function(N){N[N.Never=1]="Never",N[N.OnProblem=2]="OnProblem",N[N.Always=3]="Always"})(I||(e.RevealProblemKind=I={})),function(N){function O(W){switch(W.toLowerCase()){case"always":return N.Always;case"never":return N.Never;case"onproblem":return N.OnProblem;default:return N.OnProblem}}N.fromString=O}(I||(e.RevealProblemKind=I={}));var $;(function(N){N[N.Shared=1]="Shared",N[N.Dedicated=2]="Dedicated",N[N.New=3]="New"})($||(e.PanelKind=$={})),function(N){function O(W){switch(W.toLowerCase()){case"shared":return N.Shared;case"dedicated":return N.Dedicated;case"new":return N.New;default:return N.Shared}}N.fromString=O}($||(e.PanelKind=$={}));var y;(function(N){N.defaults={echo:!0,reveal:A.Always,revealProblems:I.Never,focus:!1,panel:$.Shared,showReuseMessage:!0,clear:!1}})(y||(e.PresentationOptions=y={}));var k;(function(N){N[N.Shell=1]="Shell",N[N.Process=2]="Process",N[N.CustomExecution=3]="CustomExecution"})(k||(e.RuntimeType=k={})),function(N){function O(x){switch(x.toLowerCase()){case"shell":return N.Shell;case"process":return N.Process;case"customExecution":return N.CustomExecution;default:return N.Process}}N.fromString=O;function W(x){switch(x){case N.Shell:return"shell";case N.Process:return"process";case N.CustomExecution:return"customExecution";default:return"process"}}N.toString=W}(k||(e.RuntimeType=k={}));var w;(function(N){function O(W){return F.$Cf(W)?W:W.value}N.value=O})(w||(e.CommandString=w={}));var u;(function(N){N.Clean={_id:"clean",isDefault:!1},N.Build={_id:"build",isDefault:!1},N.Rebuild={_id:"rebuild",isDefault:!1},N.Test={_id:"test",isDefault:!1};function O(x){return x===N.Clean._id||x===N.Build._id||x===N.Rebuild._id||x===N.Test._id}N.is=O;function W(x){if(x!==void 0)return F.$Cf(x)?O(x)?{_id:x,isDefault:!1}:void 0:x}N.from=W})(u||(e.TaskGroup=u={}));var o;(function(N){N[N.Global=1]="Global",N[N.Workspace=2]="Workspace",N[N.Folder=3]="Folder"})(o||(e.TaskScope=o={}));var i;(function(N){N.Workspace="workspace",N.Extension="extension",N.InMemory="inMemory",N.WorkspaceFile="workspaceFile",N.User="user";function O(W){switch(W){case N.User:return 2;case N.WorkspaceFile:return 5;default:return 6}}N.toConfigurationTarget=O})(i||(e.TaskSourceKind=i={}));var n;(function(N){N.parallel="parallel",N.sequence="sequence"})(n||(e.DependsOrder=n={}));var r;(function(N){N[N.default=1]="default",N[N.folderOpen=2]="folderOpen"})(r||(e.RunOnOptions=r={}));var a;(function(N){N.defaults={reevaluateOnRerun:!0,runOn:r.default,instanceLimit:1}})(a||(e.RunOptions=a={}));class t{constructor(O,W,x,le,G,J){this._label="",this._id=O,W&&(this._label=W),x&&(this.type=x),this.runOptions=le,this.configurationProperties=G,this._source=J}getDefinition(O){}getMapKey(){return this._id}getKey(){}getCommonTaskId(){const O={folder:this.d(),id:this._id};return JSON.stringify(O)}clone(){return this.f(Object.assign({},this))}getWorkspaceFolder(){}getWorkspaceFileName(){}getTelemetryKind(){return"unknown"}matches(O,W=!1){if(O===void 0)return!1;if(F.$Cf(O))return O===this._label||O===this.configurationProperties.identifier||W&&O===this._id;const x=this.getDefinition(!0);return x!==void 0&&x._key===O._key}getQualifiedLabel(){const O=this.getWorkspaceFolder();return O?`${this._label} (${O.name})`:this._label}getTaskExecution(){return{id:this._id,task:this}}addTaskLoadMessages(O){this.c===void 0&&(this.c=[]),O&&(this.c=this.c.concat(O))}get taskLoadMessages(){return this.c}}e.$_F=t;class s extends t{constructor(O,W,x,le,G,J,Q,oe){super(O,x,void 0,Q,oe,W),this.command={},this._source=W,this.hasDefinedMatchers=J,G&&(this.command=G)}clone(){return new s(this._id,this._source,this._label,this.type,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}customizes(){if(this._source&&this._source.customizes)return this._source.customizes}getDefinition(O=!1){if(O&&this._source.customizes!==void 0)return this._source.customizes;{let W;switch(this.command?this.command.runtime:void 0){case k.Shell:W="shell";break;case k.Process:W="process";break;case k.CustomExecution:W="customExecution";break;case void 0:W="$composite";break;default:throw new Error("Unexpected task runtime")}return{type:W,_key:this._id,id:this._id}}}static is(O){return O instanceof s}getMapKey(){const O=this._source.config.workspaceFolder;return O?`${O.uri.toString()}|${this._id}|${this.instance}`:`${this._id}|${this.instance}`}d(){return this._source.kind===i.User?e.$8F:this._source.config.workspaceFolder?.uri.toString()}getCommonTaskId(){return this._source.customizes?super.getCommonTaskId():this.getKey()??super.getCommonTaskId()}getKey(){const O=this.d();if(!O)return;let W=this.configurationProperties.identifier;this._source.kind!==i.Workspace&&(W+=this._source.kind);const x={type:e.$$F,folder:O,id:W};return JSON.stringify(x)}getWorkspaceFolder(){return this._source.config.workspaceFolder}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?f.$wg(this._source.config.workspace.configuration):void 0}getTelemetryKind(){return this._source.customizes?"workspace>extension":"workspace"}f(O){return new s(O._id,O._source,O._label,O.type,O.command,O.hasDefinedMatchers,O.runOptions,O.configurationProperties)}}e.$aG=s;class d extends t{constructor(O,W,x,le,G,J,Q){super(O,x,le,J,Q,W),this._source=W,this.configures=G}static is(O){return O instanceof d}f(O){return O}getDefinition(){return this.configures}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?f.$wg(this._source.config.workspace.configuration):void 0}getWorkspaceFolder(){return this._source.config.workspaceFolder}d(){return this._source.kind===i.User?e.$8F:this._source.config.workspaceFolder?.uri.toString()}getKey(){const O=this.d();if(!O)return;let W=this.configurationProperties.identifier;this._source.kind!==i.Workspace&&(W+=this._source.kind);const x={type:e.$$F,folder:O,id:W};return JSON.stringify(x)}}e.$bG=d;class c extends t{constructor(O,W,x,le,G,J,Q,oe,_){super(O,x,le,oe,_,W),this.defines=G,this.hasDefinedMatchers=Q,this.command=J,this.icon=_.icon,this.hide=_.hide}clone(){return new c(this._id,this._source,this._label,this.type,this.defines,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}getDefinition(){return this.defines}static is(O){return O instanceof c}getMapKey(){const O=this._source.workspaceFolder;return O?`${this._source.scope.toString()}|${O.uri.toString()}|${this._id}|${this.instance}`:`${this._source.scope.toString()}|${this._id}|${this.instance}`}d(){if(this._source.scope===3&&this._source.workspaceFolder)return this._source.workspaceFolder.uri.toString()}getKey(){const O={type:"contributed",scope:this._source.scope,id:this._id};return O.folder=this.d(),JSON.stringify(O)}getWorkspaceFolder(){return this._source.workspaceFolder}getTelemetryKind(){return"extension"}f(O){return new c(O._id,O._source,O._label,O.type,O.defines,O.command,O.hasDefinedMatchers,O.runOptions,O.configurationProperties)}}e.$cG=c;class l extends t{constructor(O,W,x,le,G,J){super(O,x,le,G,J,W),this._source=W}clone(){return new l(this._id,this._source,this._label,this.type,this.runOptions,this.configurationProperties)}static is(O){return O instanceof l}getTelemetryKind(){return"composite"}getMapKey(){return`${this._id}|${this.instance}`}d(){}f(O){return new l(O._id,O._source,O._label,O.type,O.runOptions,O.configurationProperties)}}e.$dG=l;var h;(function(N){N[N.Process=1]="Process",N[N.Terminal=2]="Terminal"})(h||(e.ExecutionEngine=h={})),function(N){N._default=N.Terminal}(h||(e.ExecutionEngine=h={}));var E;(function(N){N[N.V0_1_0=1]="V0_1_0",N[N.V2_0_0=2]="V2_0_0"})(E||(e.JsonSchemaVersion=E={}));class D{constructor(O){this.c=new Map;for(let W=0;W<O.length;W++)this.c.set(O[W].uri.toString(),W)}compare(O,W){const x=O.getWorkspaceFolder(),le=W.getWorkspaceFolder();if(x&&le){let G=this.c.get(x.uri.toString());G=G===void 0?0:G+1;let J=this.c.get(le.uri.toString());return J=J===void 0?0:J+1,G===J?O._label.localeCompare(W._label):G-J}else return!x&&le?-1:x&&!le?1:0}}e.$eG=D;var m;(function(N){N.DependsOnStarted="dependsOnStarted",N.AcquiredInput="acquiredInput",N.Start="start",N.ProcessStarted="processStarted",N.Active="active",N.Inactive="inactive",N.Changed="changed",N.Terminated="terminated",N.ProcessEnded="processEnded",N.End="end"})(m||(e.TaskEventKind=m={}));var p;(function(N){N.SingleRun="singleRun",N.Background="background"})(p||(e.TaskRunType=p={}));var S;(function(N){N[N.System=0]="System",N[N.User=1]="User",N[N.FolderOpen=2]="FolderOpen",N[N.ConfigurationChange=3]="ConfigurationChange",N[N.Reconnect=4]="Reconnect"})(S||(e.TaskRunSource=S={}));var P;(function(N){function O(oe){return{taskId:oe._id,taskName:oe.configurationProperties.name,runType:oe.configurationProperties.isBackground?"background":"singleRun",group:oe.configurationProperties.group,__task:oe}}function W(oe,_,Ee){return{...O(oe),kind:"start",terminalId:_,resolvedVariables:Ee}}N.start=W;function x(oe,_,Ee){return{...O(oe),kind:"processStarted",terminalId:_,processId:Ee}}N.processStarted=x;function le(oe,_,Ee){return{...O(oe),kind:"processEnded",terminalId:_,exitCode:Ee}}N.processEnded=le;function G(oe,_,Ee){return{...O(oe),kind:"terminated",exitReason:Ee,terminalId:_}}N.terminated=G;function J(oe,_,Ee){return{...O(_),kind:oe,terminalId:Ee}}N.general=J;function Q(){return{kind:"changed"}}N.changed=Q})(P||(e.TaskEvent=P={}));var z;(function(N){function O(x){const le=Object.keys(x).sort();let G="";for(const J of le){let Q=x[J];Q instanceof Object?Q=O(Q):typeof Q=="string"&&(Q=Q.replace(/,/g,",,")),G+=J+","+Q+","}return G}function W(x){const G={_key:O(x),type:x.taskType};return Object.assign(G,x),G}N.create=W})(z||(e.KeyedTaskIdentifier=z={}));var j;(function(N){N.AutoDetect="task.autoDetect",N.SaveBeforeRun="task.saveBeforeRun",N.ShowDecorations="task.showDecorations",N.ProblemMatchersNeverPrompt="task.problemMatchers.neverPrompt",N.SlowProviderWarning="task.slowProviderWarning",N.QuickOpenHistory="task.quickOpen.history",N.QuickOpenDetail="task.quickOpen.detail",N.QuickOpenSkip="task.quickOpen.skip",N.QuickOpenShowAll="task.quickOpen.showAll",N.AllowAutomaticTasks="task.allowAutomaticTasks",N.Reconnection="task.reconnection",N.VerboseLogging="task.verboseLogging"})(j||(e.TaskSettingId=j={}));var R;(function(N){N.Tasks="tasks",N.SuppressTaskName="tasks.suppressTaskName",N.Windows="tasks.windows",N.Osx="tasks.osx",N.Linux="tasks.linux",N.ShowOutput="tasks.showOutput",N.IsShellCommand="tasks.isShellCommand",N.ServiceTestSetting="tasks.service.testSetting"})(R||(e.TasksSchemaProperties=R={}));var T;(function(N){function O(W,x){const le=b.$7F.get(W.type);if(le===void 0){const oe=L.$an(W);return delete oe._key,z.create(oe)}const G=Object.create(null);G.type=le.taskType;const J=new Set;le.required.forEach(oe=>J.add(oe));const Q=le.properties;for(const oe of Object.keys(Q)){const _=W[oe];if(_!=null)G[oe]=_;else if(J.has(oe)){const Ee=Q[oe];if(Ee.default!==void 0)G[oe]=L.$an(Ee.default);else switch(Ee.type){case"boolean":G[oe]=!1;break;case"number":case"integer":G[oe]=0;break;case"string":G[oe]="";break;default:x.error(C.localize(2,null,JSON.stringify(W,void 0,0),oe));return}}}return z.create(G)}N.createTaskIdentifier=O})(T||(e.TaskDefinition=T={}))}),define(ke[304],Se([1,0,8]),function(me,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Y5b=e.$X5b=void 0;class F{constructor(){this.a=null,this.b=null,this.d=null,this.f=!1,this.g=null,this.h=!1,this.i=null}get[Symbol.toStringTag](){return this.toString()}j(){return this.a||(this.a=new Promise((M,b)=>{this.b=M,this.d=b,this.f&&this.b(this.g),this.h&&this.d(this.i)})),this.a}resolveOk(M){this.f||this.h||(this.f=!0,this.g=M,this.a&&this.b(M))}resolveErr(M){this.f||this.h||(this.h=!0,this.i=M,this.a?this.d(M):(0,C.$Z)(M))}then(M,b){return this.j().then(M,b)}catch(M){return this.j().then(void 0,M)}finally(M){return this.j().finally(M)}}e.$X5b=F;class f extends F{constructor(){super(),this.h=!0,this.i=new C.$4}}e.$Y5b=f}),define(ke[68],Se([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wv=e.$vv=e.$uv=e.$tv=void 0;class C{static{this.count=0}constructor(v){this._proxyIdentifierBrand=void 0,this.sid=v,this.nid=++C.count}}e.$tv=C;const F=[];function f(b){const v=new C(b);return F[v.nid]=v,v}e.$uv=f;function L(b){return F[b].sid}e.$vv=L;class M{constructor(v){this.value=v}}e.$wv=M}),define(ke[6],Se([1,0,68]),function(me,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yK=e.$xK=e.ExtHostTestingResource=e.ISuggestResultDtoField=e.ISuggestDataDtoField=e.$wK=e.CandidatePortSource=e.NotebookEditorRevealType=e.CellOutputKind=e.WebviewMessageArrayBufferViewType=e.WebviewEditorCapabilities=e.TabModelOperationKind=e.TabInputKind=e.TextEditorRevealType=void 0;var F;(function(w){w[w.Default=0]="Default",w[w.InCenter=1]="InCenter",w[w.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",w[w.AtTop=3]="AtTop"})(F||(e.TextEditorRevealType=F={}));var f;(function(w){w[w.UnknownInput=0]="UnknownInput",w[w.TextInput=1]="TextInput",w[w.TextDiffInput=2]="TextDiffInput",w[w.TextMergeInput=3]="TextMergeInput",w[w.NotebookInput=4]="NotebookInput",w[w.NotebookDiffInput=5]="NotebookDiffInput",w[w.CustomEditorInput=6]="CustomEditorInput",w[w.WebviewEditorInput=7]="WebviewEditorInput",w[w.TerminalEditorInput=8]="TerminalEditorInput",w[w.InteractiveEditorInput=9]="InteractiveEditorInput",w[w.ChatEditorInput=10]="ChatEditorInput"})(f||(e.TabInputKind=f={}));var L;(function(w){w[w.TAB_OPEN=0]="TAB_OPEN",w[w.TAB_CLOSE=1]="TAB_CLOSE",w[w.TAB_UPDATE=2]="TAB_UPDATE",w[w.TAB_MOVE=3]="TAB_MOVE"})(L||(e.TabModelOperationKind=L={}));var M;(function(w){w[w.Editable=0]="Editable",w[w.SupportsHotExit=1]="SupportsHotExit"})(M||(e.WebviewEditorCapabilities=M={}));var b;(function(w){w[w.Int8Array=1]="Int8Array",w[w.Uint8Array=2]="Uint8Array",w[w.Uint8ClampedArray=3]="Uint8ClampedArray",w[w.Int16Array=4]="Int16Array",w[w.Uint16Array=5]="Uint16Array",w[w.Int32Array=6]="Int32Array",w[w.Uint32Array=7]="Uint32Array",w[w.Float32Array=8]="Float32Array",w[w.Float64Array=9]="Float64Array",w[w.BigInt64Array=10]="BigInt64Array",w[w.BigUint64Array=11]="BigUint64Array"})(b||(e.WebviewMessageArrayBufferViewType=b={}));var v;(function(w){w[w.Text=1]="Text",w[w.Error=2]="Error",w[w.Rich=3]="Rich"})(v||(e.CellOutputKind=v={}));var g;(function(w){w[w.Default=0]="Default",w[w.InCenter=1]="InCenter",w[w.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",w[w.AtTop=3]="AtTop"})(g||(e.NotebookEditorRevealType=g={}));var A;(function(w){w[w.None=0]="None",w[w.Process=1]="Process",w[w.Output=2]="Output"})(A||(e.CandidatePortSource=A={}));class I{static{this.a=0}static mixin(u){return u._id=I.a++,u}}e.$wK=I;var $;(function(w){w.label="a",w.kind="b",w.detail="c",w.documentation="d",w.sortText="e",w.filterText="f",w.preselect="g",w.insertText="h",w.insertTextRules="i",w.range="j",w.commitCharacters="k",w.additionalTextEdits="l",w.kindModifier="m",w.commandIdent="n",w.commandId="o",w.commandArguments="p"})($||(e.ISuggestDataDtoField=$={}));var y;(function(w){w.defaultRanges="a",w.completions="b",w.isIncomplete="c",w.duration="d"})(y||(e.ISuggestResultDtoField=y={}));var k;(function(w){w[w.Workspace=0]="Workspace",w[w.TextDocument=1]="TextDocument"})(k||(e.ExtHostTestingResource=k={})),e.$xK={MainThreadAuthentication:(0,C.$uv)("MainThreadAuthentication"),MainThreadBulkEdits:(0,C.$uv)("MainThreadBulkEdits"),MainThreadChatProvider:(0,C.$uv)("MainThreadChatProvider"),MainThreadChatAgents2:(0,C.$uv)("MainThreadChatAgents2"),MainThreadChatVariables:(0,C.$uv)("MainThreadChatVariables"),MainThreadClipboard:(0,C.$uv)("MainThreadClipboard"),MainThreadCommands:(0,C.$uv)("MainThreadCommands"),MainThreadComments:(0,C.$uv)("MainThreadComments"),MainThreadConfiguration:(0,C.$uv)("MainThreadConfiguration"),MainThreadConsole:(0,C.$uv)("MainThreadConsole"),MainThreadDebugService:(0,C.$uv)("MainThreadDebugService"),MainThreadDecorations:(0,C.$uv)("MainThreadDecorations"),MainThreadDiagnostics:(0,C.$uv)("MainThreadDiagnostics"),MainThreadDialogs:(0,C.$uv)("MainThreadDiaglogs"),MainThreadDocuments:(0,C.$uv)("MainThreadDocuments"),MainThreadDocumentContentProviders:(0,C.$uv)("MainThreadDocumentContentProviders"),MainThreadTextEditors:(0,C.$uv)("MainThreadTextEditors"),MainThreadEditorInsets:(0,C.$uv)("MainThreadEditorInsets"),MainThreadEditorTabs:(0,C.$uv)("MainThreadEditorTabs"),MainThreadErrors:(0,C.$uv)("MainThreadErrors"),MainThreadTreeViews:(0,C.$uv)("MainThreadTreeViews"),MainThreadDownloadService:(0,C.$uv)("MainThreadDownloadService"),MainThreadLanguageFeatures:(0,C.$uv)("MainThreadLanguageFeatures"),MainThreadLanguages:(0,C.$uv)("MainThreadLanguages"),MainThreadLogger:(0,C.$uv)("MainThreadLogger"),MainThreadMessageService:(0,C.$uv)("MainThreadMessageService"),MainThreadOutputService:(0,C.$uv)("MainThreadOutputService"),MainThreadProgress:(0,C.$uv)("MainThreadProgress"),MainThreadQuickDiff:(0,C.$uv)("MainThreadQuickDiff"),MainThreadQuickOpen:(0,C.$uv)("MainThreadQuickOpen"),MainThreadStatusBar:(0,C.$uv)("MainThreadStatusBar"),MainThreadSecretState:(0,C.$uv)("MainThreadSecretState"),MainThreadStorage:(0,C.$uv)("MainThreadStorage"),MainThreadSpeech:(0,C.$uv)("MainThreadSpeechProvider"),MainThreadTelemetry:(0,C.$uv)("MainThreadTelemetry"),MainThreadTerminalService:(0,C.$uv)("MainThreadTerminalService"),MainThreadWebviews:(0,C.$uv)("MainThreadWebviews"),MainThreadWebviewPanels:(0,C.$uv)("MainThreadWebviewPanels"),MainThreadWebviewViews:(0,C.$uv)("MainThreadWebviewViews"),MainThreadCustomEditors:(0,C.$uv)("MainThreadCustomEditors"),MainThreadUrls:(0,C.$uv)("MainThreadUrls"),MainThreadUriOpeners:(0,C.$uv)("MainThreadUriOpeners"),MainThreadProfileContentHandlers:(0,C.$uv)("MainThreadProfileContentHandlers"),MainThreadWorkspace:(0,C.$uv)("MainThreadWorkspace"),MainThreadFileSystem:(0,C.$uv)("MainThreadFileSystem"),MainThreadFileSystemEventService:(0,C.$uv)("MainThreadFileSystemEventService"),MainThreadExtensionService:(0,C.$uv)("MainThreadExtensionService"),MainThreadSCM:(0,C.$uv)("MainThreadSCM"),MainThreadSearch:(0,C.$uv)("MainThreadSearch"),MainThreadShare:(0,C.$uv)("MainThreadShare"),MainThreadTask:(0,C.$uv)("MainThreadTask"),MainThreadWindow:(0,C.$uv)("MainThreadWindow"),MainThreadLabelService:(0,C.$uv)("MainThreadLabelService"),MainThreadNotebook:(0,C.$uv)("MainThreadNotebook"),MainThreadNotebookDocuments:(0,C.$uv)("MainThreadNotebookDocumentsShape"),MainThreadNotebookEditors:(0,C.$uv)("MainThreadNotebookEditorsShape"),MainThreadNotebookKernels:(0,C.$uv)("MainThreadNotebookKernels"),MainThreadNotebookRenderers:(0,C.$uv)("MainThreadNotebookRenderers"),MainThreadInteractive:(0,C.$uv)("MainThreadInteractive"),MainThreadChat:(0,C.$uv)("MainThreadChat"),MainThreadInlineChat:(0,C.$uv)("MainThreadInlineChatShape"),MainThreadTheming:(0,C.$uv)("MainThreadTheming"),MainThreadTunnelService:(0,C.$uv)("MainThreadTunnelService"),MainThreadManagedSockets:(0,C.$uv)("MainThreadManagedSockets"),MainThreadTimeline:(0,C.$uv)("MainThreadTimeline"),MainThreadTesting:(0,C.$uv)("MainThreadTesting"),MainThreadLocalization:(0,C.$uv)("MainThreadLocalizationShape"),MainThreadAiRelatedInformation:(0,C.$uv)("MainThreadAiRelatedInformation"),MainThreadAiEmbeddingVector:(0,C.$uv)("MainThreadAiEmbeddingVector"),MainThreadIssueReporter:(0,C.$uv)("MainThreadIssueReporter")},e.$yK={ExtHostCommands:(0,C.$uv)("ExtHostCommands"),ExtHostConfiguration:(0,C.$uv)("ExtHostConfiguration"),ExtHostDiagnostics:(0,C.$uv)("ExtHostDiagnostics"),ExtHostDebugService:(0,C.$uv)("ExtHostDebugService"),ExtHostDecorations:(0,C.$uv)("ExtHostDecorations"),ExtHostDocumentsAndEditors:(0,C.$uv)("ExtHostDocumentsAndEditors"),ExtHostDocuments:(0,C.$uv)("ExtHostDocuments"),ExtHostDocumentContentProviders:(0,C.$uv)("ExtHostDocumentContentProviders"),ExtHostDocumentSaveParticipant:(0,C.$uv)("ExtHostDocumentSaveParticipant"),ExtHostEditors:(0,C.$uv)("ExtHostEditors"),ExtHostTreeViews:(0,C.$uv)("ExtHostTreeViews"),ExtHostFileSystem:(0,C.$uv)("ExtHostFileSystem"),ExtHostFileSystemInfo:(0,C.$uv)("ExtHostFileSystemInfo"),ExtHostFileSystemEventService:(0,C.$uv)("ExtHostFileSystemEventService"),ExtHostLanguages:(0,C.$uv)("ExtHostLanguages"),ExtHostLanguageFeatures:(0,C.$uv)("ExtHostLanguageFeatures"),ExtHostQuickOpen:(0,C.$uv)("ExtHostQuickOpen"),ExtHostQuickDiff:(0,C.$uv)("ExtHostQuickDiff"),ExtHostStatusBar:(0,C.$uv)("ExtHostStatusBar"),ExtHostShare:(0,C.$uv)("ExtHostShare"),ExtHostExtensionService:(0,C.$uv)("ExtHostExtensionService"),ExtHostLogLevelServiceShape:(0,C.$uv)("ExtHostLogLevelServiceShape"),ExtHostTerminalService:(0,C.$uv)("ExtHostTerminalService"),ExtHostSCM:(0,C.$uv)("ExtHostSCM"),ExtHostSearch:(0,C.$uv)("ExtHostSearch"),ExtHostTask:(0,C.$uv)("ExtHostTask"),ExtHostWorkspace:(0,C.$uv)("ExtHostWorkspace"),ExtHostWindow:(0,C.$uv)("ExtHostWindow"),ExtHostWebviews:(0,C.$uv)("ExtHostWebviews"),ExtHostWebviewPanels:(0,C.$uv)("ExtHostWebviewPanels"),ExtHostCustomEditors:(0,C.$uv)("ExtHostCustomEditors"),ExtHostWebviewViews:(0,C.$uv)("ExtHostWebviewViews"),ExtHostEditorInsets:(0,C.$uv)("ExtHostEditorInsets"),ExtHostEditorTabs:(0,C.$uv)("ExtHostEditorTabs"),ExtHostProgress:(0,C.$uv)("ExtHostProgress"),ExtHostComments:(0,C.$uv)("ExtHostComments"),ExtHostSecretState:(0,C.$uv)("ExtHostSecretState"),ExtHostStorage:(0,C.$uv)("ExtHostStorage"),ExtHostUrls:(0,C.$uv)("ExtHostUrls"),ExtHostUriOpeners:(0,C.$uv)("ExtHostUriOpeners"),ExtHostProfileContentHandlers:(0,C.$uv)("ExtHostProfileContentHandlers"),ExtHostOutputService:(0,C.$uv)("ExtHostOutputService"),ExtHosLabelService:(0,C.$uv)("ExtHostLabelService"),ExtHostNotebook:(0,C.$uv)("ExtHostNotebook"),ExtHostNotebookDocuments:(0,C.$uv)("ExtHostNotebookDocuments"),ExtHostNotebookEditors:(0,C.$uv)("ExtHostNotebookEditors"),ExtHostNotebookKernels:(0,C.$uv)("ExtHostNotebookKernels"),ExtHostNotebookRenderers:(0,C.$uv)("ExtHostNotebookRenderers"),ExtHostNotebookDocumentSaveParticipant:(0,C.$uv)("ExtHostNotebookDocumentSaveParticipant"),ExtHostInteractive:(0,C.$uv)("ExtHostInteractive"),ExtHostInlineChat:(0,C.$uv)("ExtHostInlineChatShape"),ExtHostChat:(0,C.$uv)("ExtHostChat"),ExtHostChatAgents2:(0,C.$uv)("ExtHostChatAgents"),ExtHostChatVariables:(0,C.$uv)("ExtHostChatVariables"),ExtHostChatProvider:(0,C.$uv)("ExtHostChatProvider"),ExtHostSpeech:(0,C.$uv)("ExtHostSpeech"),ExtHostAiRelatedInformation:(0,C.$uv)("ExtHostAiRelatedInformation"),ExtHostAiEmbeddingVector:(0,C.$uv)("ExtHostAiEmbeddingVector"),ExtHostTheming:(0,C.$uv)("ExtHostTheming"),ExtHostTunnelService:(0,C.$uv)("ExtHostTunnelService"),ExtHostManagedSockets:(0,C.$uv)("ExtHostManagedSockets"),ExtHostAuthentication:(0,C.$uv)("ExtHostAuthentication"),ExtHostTimeline:(0,C.$uv)("ExtHostTimeline"),ExtHostTesting:(0,C.$uv)("ExtHostTesting"),ExtHostTelemetry:(0,C.$uv)("ExtHostTelemetry"),ExtHostLocalization:(0,C.$uv)("ExtHostLocalization"),ExtHostIssueReporter:(0,C.$uv)("ExtHostIssueReporter")}}),define(ke[305],Se([1,0,6,7]),function(me,e,C,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Edc=void 0;class f{constructor(M){this.a=new Map,this.b=0,this.c=M.getProxy(C.$xK.MainThreadAiRelatedInformation)}async $provideAiRelatedInformation(M,b,v){if(this.a.size===0)throw new Error("No related information providers registered");const g=this.a.get(M);if(!g)throw new Error("related information provider not found");return await g.provideRelatedInformation(b,v)??[]}getRelatedInformation(M,b,v){return this.c.$getAiRelatedInformation(b,v)}registerRelatedInformationProvider(M,b,v){const g=this.b;return this.b++,this.a.set(g,v),this.c.$registerAiRelatedInformationProvider(g,b),new F.$zK(()=>{this.c.$unregisterAiRelatedInformationProvider(g),this.a.delete(g)})}}e.$Edc=f}),define(ke[91],Se([1,0,5,14,6,20]),function(me,e,C,F,f,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mdc=e.$Ldc=e.$Kdc=void 0,e.$Kdc=(0,C.$Vh)("IExtHostApiDeprecationService");let M=class{constructor(v,g){this.c=g,this.a=new Set,this.b=v.getProxy(f.$xK.MainThreadTelemetry)}report(v,g,A){const I=this.d(v,g);this.a.has(I)||(this.a.add(I),g.isUnderDevelopment&&this.c.warn(`[Deprecation Warning] '${v}' is deprecated. ${A}`),this.b.$publicLog2("extHostDeprecatedApiUsage",{extensionId:g.identifier.value,apiId:v}))}d(v,g){return`${v}-${g.identifier.value}`}};e.$Ldc=M,e.$Ldc=M=He([Be(0,L.$zM),Be(1,F.$dj)],M),e.$Mdc=Object.freeze(new class{report(b,v,g){}})}),define(ke[306],Se([1,0,4,6,7,26]),function(me,e,C,F,f,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pdc=void 0;class M{constructor(g){this.b=new Map,this.c=[],this.d=new C.$Rd,this.onDidChangeSessions=this.d.event,this.f=new b,this.g=new b,this.a=g.getProxy(F.$xK.MainThreadAuthentication)}$setProviders(g){return this.c=g,Promise.resolve()}async getSession(g,A,I,$={}){const y=L.$_l.toKey(g.identifier),k=[...I].sort().join(" ");return await this.f.getOrCreate(`${y} ${A} ${k}`,async()=>{await this.a.$ensureProvider(A);const w=g.displayName||g.name;return this.a.$getSession(A,I,y,w,$)})}async getSessions(g,A,I){const $=L.$_l.toKey(g.identifier),y=[...I].sort().join(" ");return await this.g.getOrCreate(`${$} ${y}`,async()=>{await this.a.$ensureProvider(A);const k=g.displayName||g.name;return this.a.$getSessions(A,I,$,k)})}async removeSession(g,A){const I=this.b.get(g);return I?I.provider.removeSession(A):this.a.$removeSession(g,A)}registerAuthenticationProvider(g,A,I,$){if(this.b.get(g))throw new Error(`An authentication provider with id '${g}' is already registered.`);this.b.set(g,{label:A,provider:I,options:$??{supportsMultipleAccounts:!1}}),this.c.find(k=>k.id===g)||this.c.push({id:g,label:A});const y=I.onDidChangeSessions(k=>{this.a.$sendDidChangeSessions(g,{added:k.added??[],changed:k.changed??[],removed:k.removed??[]})});return this.a.$registerAuthenticationProvider(g,A,$?.supportsMultipleAccounts??!1),new f.$zK(()=>{y.dispose(),this.b.delete(g);const k=this.c.findIndex(w=>w.id===g);k>-1&&this.c.splice(k),this.a.$unregisterAuthenticationProvider(g)})}$createSession(g,A,I){const $=this.b.get(g);if($)return Promise.resolve($.provider.createSession(A,I));throw new Error(`Unable to find authentication provider with handle: ${g}`)}$removeSession(g,A){const I=this.b.get(g);if(I)return Promise.resolve(I.provider.removeSession(A));throw new Error(`Unable to find authentication provider with handle: ${g}`)}$getSessions(g,A){const I=this.b.get(g);if(I)return Promise.resolve(I.provider.getSessions(A));throw new Error(`Unable to find authentication provider with handle: ${g}`)}$onDidChangeAuthenticationSessions(g,A){return this.d.fire({provider:{id:g,label:A}}),Promise.resolve()}}e.$Pdc=M;class b{constructor(){this.a=new Map}getOrCreate(g,A){const I=this.a.get(g);if(I)return I;const $=A().finally(()=>this.a.delete(g));return this.a.set(g,$),$}}}),define(ke[307],Se([1,0,6,20,15]),function(me,e,C,F,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qdc=void 0;let L=class{constructor(b,v){this.a=b.getProxy(C.$xK.MainThreadBulkEdits),this.b={getTextDocumentVersion:g=>v.getDocument(g)?.version,getNotebookDocumentVersion:()=>{}}}applyWorkspaceEdit(b,v,g){const A=f.WorkspaceEdit.from(b,this.b);return this.a.$tryApplyWorkspaceEdit(A,void 0,g?.isRefactoring??!1)}};e.$Qdc=L,e.$Qdc=L=He([Be(0,F.$zM)],L)}),define(ke[308],Se([1,0,4,51,3,6,15]),function(me,e,C,F,f,L,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rdc=void 0;class b{static{this.a=0}constructor(A,I){this.extension=A,this.provider=I,this.handle=b.a++}}class v{static{this.a=0}constructor(A){this.b=new Map,this.c=new Map,this.d=new C.$Rd,this.onDidPerformUserAction=this.d.event,this.e=A.getProxy(L.$xK.MainThreadChat)}registerChatProvider(A,I,$){const y=new b(A,$);return this.b.set(y.handle,y),this.e.$registerChatProvider(y.handle,I),(0,f.$Pc)(()=>{this.e.$unregisterChatProvider(y.handle),this.b.delete(y.handle)})}transferChatSession(A,I){const $=F.Iterable.find(this.c.keys(),y=>this.c.get(y)===A)??0;typeof $=="number"&&this.e.$transferChatSession($,I)}sendInteractiveRequestToProvider(A,I){this.e.$sendRequestToProvider(A,I)}async $prepareChat(A,I){const $=this.b.get(A);if(!$)return;const y=await $.provider.prepareSession(I);if(!y)return;const k=v.a++;return this.c.set(k,y),{id:k,requesterUsername:y.requester?.name,requesterAvatarIconUri:y.requester?.icon,responderUsername:y.responder?.name,responderAvatarIconUri:y.responder?.icon,inputPlaceholder:y.inputPlaceholder}}async $provideWelcomeMessage(A,I){const $=this.b.get(A);if(!$||!$.provider.provideWelcomeMessage)return;const y=await $.provider.provideWelcomeMessage(I);if(y)return y.map(k=>typeof k=="string"?k:Array.isArray(k)?k.map(w=>M.ChatReplyFollowup.from(w)):M.MarkdownString.from(k))}async $provideSampleQuestions(A,I){const $=this.b.get(A);if(!$||!$.provider.provideSampleQuestions)return;const y=await $.provider.provideSampleQuestions(I);if(y)return y?.map(k=>M.ChatReplyFollowup.from(k))}$releaseSession(A){this.c.delete(A)}async $onDidPerformUserAction(A){this.d.fire(A)}}e.$Rdc=v}),define(ke[309],Se([1,0,12,21,43,4,38,18,2,210,85,6,15,7,280,25]),function(me,e,C,F,f,L,M,b,v,g,A,I,$,y,k,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tdc=void 0;class u{static{this.a=0}constructor(n,r,a){this.i=r,this.j=a,this.b=new Map,this.g=new Map,this.h=new Map,this.d=n.getProxy(I.$xK.MainThreadChatAgents2)}createChatAgent(n,r,a){const t=u.a++,s=new o(n,r,this.d,t,a);return this.b.set(t,s),this.d.$registerAgent(t,r,{}),s.apiAgent}async $invokeAgent(n,r,a,t,s,d){this.g.delete(r);const c=this.b.get(n);if(!c)throw new Error(`[CHAT](${n}) CANNOT invoke agent because the agent is not registered`);let l=!1;function h(){if(l)throw new Error("Only valid while executing the command")}const E=new C.$ih;d.onCancellationRequested(()=>E.complete()),setTimeout(()=>E.complete(),10*1e3),this.i.allowListExtensionWhile(c.extension.identifier,E.p);const D=t.command?await c.validateSlashCommand(t.command):void 0,m=M.$Nd.create(!1);let p;try{const S=c.invoke({prompt:t.message,variables:$.ChatVariable.objectTo(t.variables),slashCommand:D},{history:s.history.map($.ChatMessage.to)},new A.$$u(P=>{h(),typeof p>"u"&&"content"in P&&(p=m.elapsed());const z=$.ChatResponseProgress.from(c.extension,P);if("placeholder"in P&&"resolvedContent"in P){const j=Promise.all([this.d.$handleProgressChunk(a,z),P.resolvedContent]);(0,C.$Mg)(j,d).then(R=>{if(!R)return;const[T,N]=R,O=$.ChatResponseProgress.from(c.extension,N);this.d.$handleProgressChunk(a,O,T??void 0)})}else this.d.$handleProgressChunk(a,z)}),d);return await(0,C.$Mg)(Promise.resolve(S).then(P=>{if(P){this.g.set(r,P);let z=this.h.get(r);z||(z=new Map,this.h.set(r,z)),z.set(a,P);const j={firstProgress:p,totalElapsed:m.elapsed()};return{errorDetails:P.errorDetails,timings:j}}else this.g.delete(r)}),d)}catch(S){return this.j.error(S,c.extension),{errorDetails:{message:(0,g.localize)(0,null,(0,f.$Gi)(S)),responseIsIncomplete:!0}}}finally{l=!0,E.complete()}}$releaseSession(n){this.g.delete(n),this.h.delete(n)}async $provideSlashCommands(n,r){const a=this.b.get(n);return a?a.provideSlashCommand(r):[]}$provideFollowups(n,r,a){const t=this.b.get(n);if(!t)return Promise.resolve([]);const s=this.g.get(r);return s?t.provideFollowups(s,a):Promise.resolve([])}$acceptFeedback(n,r,a,t){const s=this.b.get(n);if(!s)return;const d=this.h.get(r)?.get(a);if(!d)return;let c;switch(t){case k.InteractiveSessionVoteDirection.Down:c=y.ChatAgentResultFeedbackKind.Unhelpful;break;case k.InteractiveSessionVoteDirection.Up:c=y.ChatAgentResultFeedbackKind.Helpful;break}s.acceptFeedback(Object.freeze({result:d,kind:c}))}$acceptAction(n,r,a,t){const s=this.b.get(n);if(!s)return;const d=this.h.get(r)?.get(a);d&&t.action.kind!=="vote"&&s.acceptAction(Object.freeze({action:t.action,result:d}))}}e.$Tdc=u;class o{constructor(n,r,a,t,s){this.extension=n,this.r=r,this.s=a,this.t=t,this.u=s,this.o=new L.$Rd,this.q=new L.$Rd}acceptFeedback(n){this.o.fire(n)}acceptAction(n){this.q.fire(n)}async validateSlashCommand(n){this.b||(await this.provideSlashCommand(F.CancellationToken.None),(0,b.$Mf)(this.b));const r=this.b.find(a=>a.name===n);if(!r)throw new Error(`Unknown slashCommand: ${n}`);return r}async provideSlashCommand(n){if(!this.a)return[];const r=await this.a.provideSlashCommands(n);return r?(this.b=r,r.map(a=>({name:a.name,description:a.description,followupPlaceholder:a.followupPlaceholder,shouldRepopulate:a.shouldRepopulate,sampleRequest:a.sampleRequest}))):[]}async provideFollowups(n,r){if(!this.d)return[];const a=await this.d.provideFollowups(n,r);return a?a.map(t=>$.ChatFollowup.from(t)):[]}get apiAgent(){let n=!1,r=!1;const a=()=>{n||r||(r=!0,queueMicrotask(()=>{this.s.$updateAgent(this.t,{description:this.g??"",fullName:this.h,icon:this.i?this.i instanceof v.URI?this.i:"light"in this.i?this.i.light:void 0:void 0,iconDark:this.i&&"dark"in this.i?this.i.dark:void 0,themeIcon:this.i instanceof y.$tL?this.i:void 0,hasSlashCommands:this.a!==void 0,hasFollowups:this.d!==void 0,isDefault:this.j,isSecondary:this.n,helpTextPrefix:!this.k||typeof this.k=="string"?this.k:$.MarkdownString.from(this.k),helpTextPostfix:!this.l||typeof this.l=="string"?this.l:$.MarkdownString.from(this.l),sampleRequest:this.m}),r=!1}))},t=this;return{get name(){return t.r},get description(){return t.g??""},set description(s){t.g=s,a()},get fullName(){return t.h??t.extension.displayName??t.extension.name},set fullName(s){t.h=s,a()},get iconPath(){return t.i},set iconPath(s){t.i=s,a()},get slashCommandProvider(){return t.a},set slashCommandProvider(s){t.a=s,a()},get followupProvider(){return t.d},set followupProvider(s){t.d=s,a()},get isDefault(){return(0,w.$MF)(t.extension,"defaultChatAgent"),t.j},set isDefault(s){(0,w.$MF)(t.extension,"defaultChatAgent"),t.j=s,a()},get helpTextPrefix(){return(0,w.$MF)(t.extension,"defaultChatAgent"),t.k},set helpTextPrefix(s){if((0,w.$MF)(t.extension,"defaultChatAgent"),!t.j)throw new Error("helpTextPrefix is only available on the default chat agent");t.k=s,a()},get helpTextPostfix(){return(0,w.$MF)(t.extension,"defaultChatAgent"),t.l},set helpTextPostfix(s){if((0,w.$MF)(t.extension,"defaultChatAgent"),!t.j)throw new Error("helpTextPostfix is only available on the default chat agent");t.l=s,a()},get isSecondary(){return(0,w.$MF)(t.extension,"defaultChatAgent"),t.n},set isSecondary(s){(0,w.$MF)(t.extension,"defaultChatAgent"),t.n=s,a()},get sampleRequest(){return t.m},set sampleRequest(s){t.m=s,a()},get onDidReceiveFeedback(){return t.o.event},onDidPerformAction:(0,w.$LF)(this.extension,"chatAgents2Additions")?this.q.event:void 0,dispose(){n=!0,t.a=void 0,t.d=void 0,t.o.dispose(),t.s.$unregisterAgent(t.t)}}}invoke(n,r,a,t){return this.u(n,r,a,t)}}}),define(ke[310],Se([1,0,21,3,6,15,85,26,12,4]),function(me,e,C,F,f,L,M,b,v,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sdc=void 0;class A{constructor(k,w){this.stream=new v.$mh,this.stream=w??new v.$mh;const u=this;this.apiObj={option:k,response:u.stream.asyncIterable}}}class I{constructor(k,w){this.a=new g.$Rd,this.b=new Map,this.c=new v.$mh,this.d=!1;const u=this;this.apiObject={result:k,response:u.c.asyncIterable,onDidStartResponseStream:u.a.event,cancel(){w.cancel()}},k.finally(()=>{if(this.d=!0,this.b.size>0)for(const[,o]of this.b)o.stream.resolve();else this.c.resolve()})}handleFragment(k){if(this.d)return;let w=this.b.get(k.index);w||(this.b.size===0?w=new A(k.index,this.c):w=new A(k.index),this.b.set(k.index,w),this.a.fire(w.apiObj)),w.stream.emitOne(k.part)}}class ${static{this.a=1}constructor(k,w){this.d=w,this.c=new Map,this.e=new Map,this.f=new b.$bm,this.b=k.getProxy(f.$xK.MainThreadChatProvider)}registerProvider(k,w,u,o){const i=$.a++;return this.c.set(i,{extension:k,provider:u}),this.b.$registerProvider(i,w,{extension:k,displayName:o.name??k.value}),(0,F.$Pc)(()=>{this.b.$unregisterProvider(i),this.c.delete(i)})}async $provideChatResponse(k,w,u,o,i){const n=this.c.get(k);if(!n)return;const r=new M.$$u(async a=>{if(i.isCancellationRequested){this.d.warn(`[CHAT](${n.extension.value}) CANNOT send progress because the REQUEST IS CANCELLED`);return}this.b.$handleProgressChunk(w,{index:a.index,part:a.part})});return n.provider.provideChatResponse(u.map(L.ChatMessage.to),o,r,i)}allowListExtensionWhile(k,w){this.f.set(k,w),w.finally(()=>this.f.delete(k))}async requestChatResponseProvider(k,w){if(!this.f.has(k))throw new Error("Extension is NOT allowed to make chat requests");const u=this;return{get isRevoked(){return!u.f.has(k)},makeRequest(o,i,n){if(!u.f.has(k))throw new Error("Access to chat has been revoked");const r=new C.$2d(n),a=Math.random()*1e6|0,t=u.b.$fetchResponse(k,w,a,o.map(L.ChatMessage.from),i??{},r.token),s=new I(t,r);return u.e.set(a,{res:s}),t.finally(()=>{u.e.delete(a)}),s.apiObject}}}async $handleResponseFragment(k,w){const u=this.e.get(k);u&&u.res.handleFragment(w)}}e.$Sdc=$}),define(ke[311],Se([1,0,3,6,8,15]),function(me,e,C,F,f,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Udc=void 0;class M{static{this.a=0}constructor(v){this.b=new Map,this.c=v.getProxy(F.$xK.MainThreadChatVariables)}async $resolveVariable(v,g,A){const I=this.b.get(v);if(I)try{const $=await I.resolver.resolve(I.data.name,{message:g},A);if($)return $.map(L.ChatVariable.from)}catch($){(0,f.$1)($)}}registerVariableResolver(v,g,A,I){const $=M.a++;return this.b.set($,{extension:v.identifier,data:{name:g,description:A},resolver:I}),this.c.$registerVariable($,{name:g,description:A}),(0,C.$Pc)(()=>{this.b.delete($),this.c.$unregisterVariable($)})}}e.$Udc=M}),define(ke[312],Se([1,0,6]),function(me,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vdc=void 0;class F{constructor(L){const M=L.getProxy(C.$xK.MainThreadClipboard);this.value=Object.freeze({readText(){return M.$readText()},writeText(b){return M.$writeText(b)}})}}e.$Vdc=F}),define(ke[35],Se([1,0,18,7,15,24,6,19,14,54,29,53,2,3,5,20,149,22,68,43,38,87,90]),function(me,e,C,F,f,L,M,b,v,g,A,I,$,y,k,w,u,o,i,n,r,a,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ZM=e.$YM=e.$XM=e.$WM=e.$VM=e.$UM=void 0;let s=class{#e;#t;#i;constructor(D,m,p){this.b=new Map,this.c=new Map,this.#e=D.getProxy(M.$xK.MainThreadCommands),this.d=m,this.#i=p,this.#t=D.getProxy(M.$xK.MainThreadTelemetry),this.converter=new d(this,S=>{const P=this.c.get(S);return P?.result===l.Void?P:void 0},m),this.f=[{processArgument(S){return(0,g.$sh)(S)}},{processArgument(S){return(0,L.$cn)(S,function(P){if(A.$zs.isIRange(P))return f.Range.to(P);if(I.$ys.isIPosition(P))return f.Position.to(P);if(A.$zs.isIRange(P.range)&&$.URI.isUri(P.uri))return f.location.to(P);if(P instanceof o.$fe)return P.buffer.buffer;if(!Array.isArray(P))return P})}}]}registerArgumentProcessor(D){this.f.push(D)}registerApiCommand(D){const m=this.registerCommand(!1,D.id,async(...p)=>{const S=D.args.map((z,j)=>{if(!z.validate(p[j]))throw new Error(`Invalid argument '${z.name}' when running '${D.id}', received: ${typeof p[j]=="object"?JSON.stringify(p[j],null,"	"):p[j]} `);return z.convert(p[j])}),P=await this.executeCommand(D.internalId,...S);return D.result.convert(P,p,this.converter)},void 0,{description:D.description,args:D.args,returns:D.result.description});return this.c.set(D.id,D),new F.$zK(()=>{m.dispose(),this.c.delete(D.id)})}registerCommand(D,m,p,S,P,z){if(this.d.trace("ExtHostCommands#registerCommand",m),!m.trim().length)throw new Error("invalid id");if(this.b.has(m))throw new Error(`command '${m}' already exists`);return this.b.set(m,{callback:p,thisArg:S,metadata:P,extension:z}),D&&this.#e.$registerCommand(m),new F.$zK(()=>{this.b.delete(m)&&D&&this.#e.$unregisterCommand(m)})}executeCommand(D,...m){return this.d.trace("ExtHostCommands#executeCommand",D),this.g(D,m,!0)}async g(D,m,p){if(this.b.has(D))return this.#e.$fireCommandActivationEvent(D),this.h(D,m,!1);{let S=!1;const P=(0,L.$cn)(m,function(z){if(z instanceof F.$AK)return f.Position.from(z);if(z instanceof F.$BK)return f.Range.from(z);if(z instanceof F.$LK)return f.location.from(z);if(F.$WL.isNotebookRange(z))return f.NotebookRange.from(z);if(z instanceof ArrayBuffer)return S=!0,o.$fe.wrap(new Uint8Array(z));if(z instanceof Uint8Array)return S=!0,o.$fe.wrap(z);if(z instanceof o.$fe)return S=!0,z;if(!Array.isArray(z))return z});try{const z=await this.#e.$executeCommand(D,S?new i.$wv(P):P,p);return(0,g.$sh)(z)}catch(z){if(z instanceof Error&&z.message==="$executeCommand:retry")return this.g(D,m,!1);throw z}}}async h(D,m,p){const S=this.b.get(D);if(!S)throw new Error("Unknown command");const{callback:P,thisArg:z,metadata:j}=S;if(j?.args)for(let T=0;T<j.args.length;T++)try{(0,C.$Tf)(m[T],j.args[T].constraint)}catch{throw new Error(`Running the contributed command: '${D}' failed. Illegal argument '${j.args[T].name}' - ${j.args[T].description}`)}const R=r.$Nd.create();try{return await P.apply(z,m)}catch(T){if(D===this.converter.delegatingCommandId){const N=this.converter.getActualCommand(...m);N&&(D=N.command)}if(this.d.error(T,D,S.extension?.identifier),!p)throw T;if(S.extension?.identifier){const N=this.#i.onExtensionError(S.extension.identifier,T);this.d.trace("forwarded error to extension?",N,S.extension?.identifier)}throw new class extends Error{constructor(){super((0,n.$Gi)(T)),this.id=D,this.source=S.extension?.displayName??S.extension?.name}}}finally{this.j(S,D,R.elapsed())}}j(D,m,p){D.extension&&this.#t.$publicLog2("Extension:ActionExecuted",{extensionId:D.extension.identifier.value,id:new a.$po(m),duration:p})}$executeContributedCommand(D,...m){this.d.trace("ExtHostCommands#$executeContributedCommand",D);const p=this.b.get(D);return p?(m=m.map(S=>this.f.reduce((P,z)=>z.processArgument(P,p.extension?.identifier),S)),this.h(D,m,!0)):Promise.reject(new Error(`Contributed command '${D}' does not exist.`))}getCommands(D=!1){return this.d.trace("ExtHostCommands#getCommands",D),this.#e.$getCommands().then(m=>(D&&(m=m.filter(p=>p[0]!=="_")),m))}$getContributedCommandMetadata(){const D=Object.create(null);for(const[m,p]of this.b){const{metadata:S}=p;S&&(D[m]=S)}return Promise.resolve(D)}};e.$UM=s,e.$UM=s=He([Be(0,w.$zM),Be(1,v.$dj),Be(2,t.$TM)],s),e.$VM=(0,k.$Vh)("IExtHostCommands");class d{constructor(D,m,p){this.d=D,this.f=m,this.g=p,this.delegatingCommandId=`__vsc${Date.now().toString(36)} `,this.b=new Map,this.c=0,this.d.registerCommand(!0,this.delegatingCommandId,this.h,this)}toInternal(D,m){if(!D)return;const p={$ident:void 0,id:D.command,title:D.title,tooltip:D.tooltip};if(!D.command)return p;const S=this.f(D.command);if(S)p.id=S.internalId,p.arguments=S.args.map((P,z)=>P.convert(D.arguments&&D.arguments[z]));else if((0,b.$Kb)(D.arguments)){const P=`${D.command} /${++this.c}`;this.b.set(P,D),m.add((0,y.$Pc)(()=>{this.b.delete(P),this.g.trace("CommandsConverter#DISPOSE",P)})),p.$ident=P,p.id=this.delegatingCommandId,p.arguments=[P],this.g.trace("CommandsConverter#CREATE",D.command,P)}return p}fromInternal(D){return typeof D.$ident=="string"?this.b.get(D.$ident):{command:D.id,title:D.title,arguments:D.arguments}}getActualCommand(...D){return this.b.get(D[0])}h(...D){const m=this.getActualCommand(...D);return this.g.trace("CommandsConverter#EXECUTE",D[0],m?m.command:"MISSING"),m?this.d.executeCommand(m.command,...m.arguments||[]):Promise.reject(`Actual command not found, wanted to execute ${D[0]}`)}}e.$WM=d;class c{static{this.Uri=new c("uri","Uri of a text document",D=>$.URI.isUri(D),D=>D)}static{this.Position=new c("position","A position in a text document",D=>F.$AK.isPosition(D),f.Position.from)}static{this.Range=new c("range","A range in a text document",D=>F.$BK.isRange(D),f.Range.from)}static{this.Selection=new c("selection","A selection in a text document",D=>F.$CK.isSelection(D),f.Selection.from)}static{this.Number=new c("number","",D=>typeof D=="number",D=>D)}static{this.String=new c("string","",D=>typeof D=="string",D=>D)}static{this.StringArray=c.Arr(c.String)}static Arr(D){return new c(`${D.name}_array`,`Array of ${D.name}, ${D.description}`,m=>Array.isArray(m)&&m.every(p=>D.validate(p)),m=>m.map(p=>D.convert(p)))}static{this.CallHierarchyItem=new c("item","A call hierarchy item",D=>D instanceof F.$VK,f.CallHierarchyItem.from)}static{this.TypeHierarchyItem=new c("item","A type hierarchy item",D=>D instanceof F.$dM,f.TypeHierarchyItem.from)}static{this.TestItem=new c("testItem","A VS Code TestItem",D=>D instanceof u.$MM,f.TestItem.from)}constructor(D,m,p,S){this.name=D,this.description=m,this.validate=p,this.convert=S}optional(){return new c(this.name,`(optional) ${this.description}`,D=>D==null||this.validate(D),D=>D===void 0?void 0:D===null?null:this.convert(D))}with(D,m){return new c(D??this.name,m??this.description,this.validate,this.convert)}}e.$XM=c;class l{static{this.Void=new l("no result",D=>D)}constructor(D,m){this.description=D,this.convert=m}}e.$YM=l;class h{constructor(D,m,p,S,P){this.id=D,this.internalId=m,this.description=p,this.args=S,this.result=P}}e.$ZM=h}),define(ke[313],Se([1,0,19,17,2,83,132,45,137,35,15,7]),function(me,e,C,F,f,L,M,b,v,g,A,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Odc=void 0;const $=[new g.$ZM("vscode.executeDocumentHighlights","_executeDocumentHighlights","Execute document highlight provider.",[g.$XM.Uri,g.$XM.Position],new g.$YM("A promise that resolves to an array of DocumentHighlight-instances.",k(A.DocumentHighlight.to))),new g.$ZM("vscode.executeDocumentSymbolProvider","_executeDocumentSymbolProvider","Execute document symbol provider.",[g.$XM.Uri],new g.$YM("A promise that resolves to an array of SymbolInformation and DocumentSymbol instances.",(u,o)=>{if((0,C.$Jb)(u))return;class i extends I.$QK{static to(r){const a=new i(r.name,A.SymbolKind.to(r.kind),r.containerName||"",new I.$LK(o[0],A.Range.to(r.range)));return a.detail=r.detail,a.range=a.location.range,a.selectionRange=A.Range.to(r.selectionRange),a.children=r.children?r.children.map(i.to):[],a}}return u.map(i.to)})),new g.$ZM("vscode.executeFormatDocumentProvider","_executeFormatDocumentProvider","Execute document format provider.",[g.$XM.Uri,new g.$XM("options","Formatting options",u=>!0,u=>u)],new g.$YM("A promise that resolves to an array of TextEdits.",k(A.TextEdit.to))),new g.$ZM("vscode.executeFormatRangeProvider","_executeFormatRangeProvider","Execute range format provider.",[g.$XM.Uri,g.$XM.Range,new g.$XM("options","Formatting options",u=>!0,u=>u)],new g.$YM("A promise that resolves to an array of TextEdits.",k(A.TextEdit.to))),new g.$ZM("vscode.executeFormatOnTypeProvider","_executeFormatOnTypeProvider","Execute format on type provider.",[g.$XM.Uri,g.$XM.Position,new g.$XM("ch","Trigger character",u=>typeof u=="string",u=>u),new g.$XM("options","Formatting options",u=>!0,u=>u)],new g.$YM("A promise that resolves to an array of TextEdits.",k(A.TextEdit.to))),new g.$ZM("vscode.executeDefinitionProvider","_executeDefinitionProvider","Execute all definition providers.",[g.$XM.Uri,g.$XM.Position],new g.$YM("A promise that resolves to an array of Location or LocationLink instances.",w)),new g.$ZM("vscode.executeTypeDefinitionProvider","_executeTypeDefinitionProvider","Execute all type definition providers.",[g.$XM.Uri,g.$XM.Position],new g.$YM("A promise that resolves to an array of Location or LocationLink instances.",w)),new g.$ZM("vscode.executeDeclarationProvider","_executeDeclarationProvider","Execute all declaration providers.",[g.$XM.Uri,g.$XM.Position],new g.$YM("A promise that resolves to an array of Location or LocationLink instances.",w)),new g.$ZM("vscode.executeImplementationProvider","_executeImplementationProvider","Execute all implementation providers.",[g.$XM.Uri,g.$XM.Position],new g.$YM("A promise that resolves to an array of Location or LocationLink instances.",w)),new g.$ZM("vscode.executeReferenceProvider","_executeReferenceProvider","Execute all reference providers.",[g.$XM.Uri,g.$XM.Position],new g.$YM("A promise that resolves to an array of Location-instances.",k(A.location.to))),new g.$ZM("vscode.executeHoverProvider","_executeHoverProvider","Execute all hover providers.",[g.$XM.Uri,g.$XM.Position],new g.$YM("A promise that resolves to an array of Hover-instances.",k(A.Hover.to))),new g.$ZM("vscode.executeSelectionRangeProvider","_executeSelectionRangeProvider","Execute selection range provider.",[g.$XM.Uri,new g.$XM("position","A position in a text document",u=>Array.isArray(u)&&u.every(o=>I.$AK.isPosition(o)),u=>u.map(A.Position.from))],new g.$YM("A promise that resolves to an array of ranges.",u=>u.map(o=>{let i;for(const n of o.reverse())i=new I.$UK(A.Range.to(n),i);return i}))),new g.$ZM("vscode.executeWorkspaceSymbolProvider","_executeWorkspaceSymbolProvider","Execute all workspace symbol providers.",[g.$XM.String.with("query","Search string")],new g.$YM("A promise that resolves to an array of SymbolInformation-instances.",u=>u.map(A.WorkspaceSymbol.to))),new g.$ZM("vscode.prepareCallHierarchy","_executePrepareCallHierarchy","Prepare call hierarchy at a position inside a document",[g.$XM.Uri,g.$XM.Position],new g.$YM("A promise that resolves to an array of CallHierarchyItem-instances",u=>u.map(A.CallHierarchyItem.to))),new g.$ZM("vscode.provideIncomingCalls","_executeProvideIncomingCalls","Compute incoming calls for an item",[g.$XM.CallHierarchyItem],new g.$YM("A promise that resolves to an array of CallHierarchyIncomingCall-instances",u=>u.map(A.CallHierarchyIncomingCall.to))),new g.$ZM("vscode.provideOutgoingCalls","_executeProvideOutgoingCalls","Compute outgoing calls for an item",[g.$XM.CallHierarchyItem],new g.$YM("A promise that resolves to an array of CallHierarchyOutgoingCall-instances",u=>u.map(A.CallHierarchyOutgoingCall.to))),new g.$ZM("vscode.prepareRename","_executePrepareRename","Execute the prepareRename of rename provider.",[g.$XM.Uri,g.$XM.Position],new g.$YM("A promise that resolves to a range and placeholder text.",u=>{if(u)return{range:A.Range.to(u.range),placeholder:u.text}})),new g.$ZM("vscode.executeDocumentRenameProvider","_executeDocumentRenameProvider","Execute rename provider.",[g.$XM.Uri,g.$XM.Position,g.$XM.String.with("newName","The new symbol name")],new g.$YM("A promise that resolves to a WorkspaceEdit.",u=>{if(u){if(u.rejectReason)throw new Error(u.rejectReason);return A.WorkspaceEdit.to(u)}})),new g.$ZM("vscode.executeLinkProvider","_executeLinkProvider","Execute document link provider.",[g.$XM.Uri,g.$XM.Number.with("linkResolveCount","Number of links that should be resolved, only when links are unresolved.").optional()],new g.$YM("A promise that resolves to an array of DocumentLink-instances.",u=>u.map(A.DocumentLink.to))),new g.$ZM("vscode.provideDocumentSemanticTokensLegend","_provideDocumentSemanticTokensLegend","Provide semantic tokens legend for a document",[g.$XM.Uri],new g.$YM("A promise that resolves to SemanticTokensLegend.",u=>{if(u)return new I.$OL(u.tokenTypes,u.tokenModifiers)})),new g.$ZM("vscode.provideDocumentSemanticTokens","_provideDocumentSemanticTokens","Provide semantic tokens for a document",[g.$XM.Uri],new g.$YM("A promise that resolves to SemanticTokens.",u=>{if(!u)return;const o=(0,M.$x$)(u);if(o.type==="full")return new I.$QL(o.data,void 0)})),new g.$ZM("vscode.provideDocumentRangeSemanticTokensLegend","_provideDocumentRangeSemanticTokensLegend","Provide semantic tokens legend for a document range",[g.$XM.Uri,g.$XM.Range.optional()],new g.$YM("A promise that resolves to SemanticTokensLegend.",u=>{if(u)return new I.$OL(u.tokenTypes,u.tokenModifiers)})),new g.$ZM("vscode.provideDocumentRangeSemanticTokens","_provideDocumentRangeSemanticTokens","Provide semantic tokens for a document range",[g.$XM.Uri,g.$XM.Range],new g.$YM("A promise that resolves to SemanticTokens.",u=>{if(!u)return;const o=(0,M.$x$)(u);if(o.type==="full")return new I.$QL(o.data,void 0)})),new g.$ZM("vscode.executeCompletionItemProvider","_executeCompletionItemProvider","Execute completion item provider.",[g.$XM.Uri,g.$XM.Position,g.$XM.String.with("triggerCharacter","Trigger completion when the user types the character, like `,` or `(`").optional(),g.$XM.Number.with("itemResolveCount","Number of completions to resolve (too large numbers slow down completions)").optional()],new g.$YM("A promise that resolves to a CompletionList-instance.",(u,o,i)=>{if(!u)return new I.$7K([]);const n=u.suggestions.map(r=>A.CompletionItem.to(r,i));return new I.$7K(n,u.incomplete)})),new g.$ZM("vscode.executeSignatureHelpProvider","_executeSignatureHelpProvider","Execute signature help provider.",[g.$XM.Uri,g.$XM.Position,g.$XM.String.with("triggerCharacter","Trigger signature help when the user types the character, like `,` or `(`").optional()],new g.$YM("A promise that resolves to SignatureHelp.",u=>{if(u)return A.SignatureHelp.to(u)})),new g.$ZM("vscode.executeCodeLensProvider","_executeCodeLensProvider","Execute code lens provider.",[g.$XM.Uri,g.$XM.Number.with("itemResolveCount","Number of lenses that should be resolved and returned. Will only return resolved lenses, will impact performance)").optional()],new g.$YM("A promise that resolves to an array of CodeLens-instances.",(u,o,i)=>k(n=>new I.$YK(A.Range.to(n.range),n.command&&i.fromInternal(n.command)))(u))),new g.$ZM("vscode.executeCodeActionProvider","_executeCodeActionProvider","Execute code action provider.",[g.$XM.Uri,new g.$XM("rangeOrSelection","Range in a text document. Some refactoring provider requires Selection object.",u=>I.$BK.isRange(u),u=>I.$CK.isSelection(u)?A.Selection.from(u):A.Range.from(u)),g.$XM.String.with("kind","Code action kind to return code actions for").optional(),g.$XM.Number.with("itemResolveCount","Number of code actions to resolve (too large numbers slow down code actions)").optional()],new g.$YM("A promise that resolves to an array of Command-instances.",(u,o,i)=>k(n=>{if(n._isSynthetic){if(!n.command)throw new Error("Synthetic code actions must have a command");return i.fromInternal(n.command)}else{const r=new I.$SK(n.title,n.kind?new I.$TK(n.kind):void 0);return n.edit&&(r.edit=A.WorkspaceEdit.to(n.edit)),n.command&&(r.command=i.fromInternal(n.command)),r.isPreferred=n.isPreferred,r}})(u))),new g.$ZM("vscode.executeDocumentColorProvider","_executeDocumentColorProvider","Execute document color provider.",[g.$XM.Uri],new g.$YM("A promise that resolves to an array of ColorInformation objects.",u=>u?u.map(o=>new I.$aL(A.Range.to(o.range),A.Color.to(o.color))):[])),new g.$ZM("vscode.executeColorPresentationProvider","_executeColorPresentationProvider","Execute color presentation provider.",[new g.$XM("color","The color to show and insert",u=>u instanceof I.$_K,A.Color.from),new g.$XM("context","Context object with uri and range",u=>!0,u=>({uri:u.uri,range:A.Range.from(u.range)}))],new g.$YM("A promise that resolves to an array of ColorPresentation objects.",u=>u?u.map(A.ColorPresentation.to):[])),new g.$ZM("vscode.executeInlayHintProvider","_executeInlayHintProvider","Execute inlay hints provider",[g.$XM.Uri,g.$XM.Range],new g.$YM("A promise that resolves to an array of Inlay objects",(u,o,i)=>u.map(A.InlayHint.to.bind(void 0,i)))),new g.$ZM("vscode.executeFoldingRangeProvider","_executeFoldingRangeProvider","Execute folding range provider",[g.$XM.Uri],new g.$YM("A promise that resolves to an array of FoldingRange objects",(u,o)=>{if(u)return u.map(A.FoldingRange.to)})),new g.$ZM("vscode.resolveNotebookContentProviders","_resolveNotebookContentProvider","Resolve Notebook Content Providers",[],new g.$YM("A promise that resolves to an array of NotebookContentProvider static info objects.",k(u=>({viewType:u.viewType,displayName:u.displayName,options:{transientOutputs:u.options.transientOutputs,transientCellMetadata:u.options.transientCellMetadata,transientDocumentMetadata:u.options.transientDocumentMetadata},filenamePattern:u.filenamePattern.map(o=>A.NotebookExclusiveDocumentPattern.to(o))})))),new g.$ZM("vscode.executeInlineValueProvider","_executeInlineValueProvider","Execute inline value provider",[g.$XM.Uri,g.$XM.Range,new g.$XM("context","An InlineValueContext",u=>u&&typeof u.frameId=="number"&&u.stoppedLocation instanceof I.$BK,u=>A.InlineValueContext.from(u))],new g.$YM("A promise that resolves to an array of InlineValue objects",u=>u.map(A.InlineValue.to))),new g.$ZM("vscode.open","_workbench.open","Opens the provided resource in the editor. Can be a text or binary file, or an http(s) URL. If you need more control over the options for opening a text file, use vscode.window.showTextDocument instead.",[new g.$XM("uriOrString","Uri-instance or string (only http/https)",u=>f.URI.isUri(u)||typeof u=="string"&&(0,v.$PU)(u,F.Schemas.http,F.Schemas.https),u=>u),new g.$XM("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",u=>u===void 0||typeof u=="number"||typeof u=="object",u=>u&&(typeof u=="number"?[A.ViewColumn.from(u),void 0]:[A.ViewColumn.from(u.viewColumn),A.TextEditorOpenOptions.from(u)])).optional(),g.$XM.String.with("label","").optional()],g.$YM.Void),new g.$ZM("vscode.openWith","_workbench.openWith","Opens the provided resource with a specific editor.",[g.$XM.Uri.with("resource","Resource to open"),g.$XM.String.with("viewId","Custom editor view id. This should be the viewType string for custom editors or the notebookType string for notebooks. Use 'default' to use VS Code's default text editor"),new g.$XM("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",u=>u===void 0||typeof u=="number"||typeof u=="object",u=>u&&(typeof u=="number"?[A.ViewColumn.from(u),void 0]:[A.ViewColumn.from(u.viewColumn),A.TextEditorOpenOptions.from(u)])).optional()],g.$YM.Void),new g.$ZM("vscode.diff","_workbench.diff","Opens the provided resources in the diff editor to compare their contents.",[g.$XM.Uri.with("left","Left-hand side resource of the diff editor"),g.$XM.Uri.with("right","Right-hand side resource of the diff editor"),g.$XM.String.with("title","Human readable title for the diff editor").optional(),new g.$XM("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",u=>u===void 0||typeof u=="object",u=>u&&[A.ViewColumn.from(u.viewColumn),A.TextEditorOpenOptions.from(u)]).optional()],g.$YM.Void),new g.$ZM("vscode.changes","_workbench.changes","Opens a list of resources in the changes editor to compare their contents.",[g.$XM.String.with("title","Human readable title for the changes editor"),new g.$XM("resourceList","List of resources to compare",u=>{for(const o of u){if(o.length!==3)return!1;const[i,n,r]=o;if(!f.URI.isUri(i)||!f.URI.isUri(n)&&n!==void 0&&n!==null||!f.URI.isUri(r)&&r!==void 0&&r!==null)return!1}return!0},u=>u)],g.$YM.Void),new g.$ZM("vscode.prepareTypeHierarchy","_executePrepareTypeHierarchy","Prepare type hierarchy at a position inside a document",[g.$XM.Uri,g.$XM.Position],new g.$YM("A promise that resolves to an array of TypeHierarchyItem-instances",u=>u.map(A.TypeHierarchyItem.to))),new g.$ZM("vscode.provideSupertypes","_executeProvideSupertypes","Compute supertypes for an item",[g.$XM.TypeHierarchyItem],new g.$YM("A promise that resolves to an array of TypeHierarchyItem-instances",u=>u.map(A.TypeHierarchyItem.to))),new g.$ZM("vscode.provideSubtypes","_executeProvideSubtypes","Compute subtypes for an item",[g.$XM.TypeHierarchyItem],new g.$YM("A promise that resolves to an array of TypeHierarchyItem-instances",u=>u.map(A.TypeHierarchyItem.to))),new g.$ZM("vscode.revealTestInExplorer","_revealTestInExplorer","Reveals a test instance in the explorer",[g.$XM.TestItem],g.$YM.Void),new g.$ZM("vscode.experimental.editSession.continue","_workbench.editSessions.actions.continueEditSession","Continue the current edit session in a different workspace",[g.$XM.Uri.with("workspaceUri","The target workspace to continue the current edit session in")],g.$YM.Void),new g.$ZM("setContext","_setContext","Set a custom context key value that can be used in when clauses.",[g.$XM.String.with("name","The context key name"),new g.$XM("value","The context key value",()=>!0,u=>u)],g.$YM.Void),new g.$ZM("vscode.executeMappedEditsProvider","_executeMappedEditsProvider","Execute Mapped Edits Provider",[g.$XM.Uri,g.$XM.StringArray,new g.$XM("MappedEditsContext","Mapped Edits Context",u=>A.MappedEditsContext.is(u),u=>A.MappedEditsContext.from(u))],new g.$YM("A promise that resolves to a workspace edit or null",u=>u?A.WorkspaceEdit.to(u):null))];class y{static register(o){$.forEach(o.registerApiCommand,o),this.a(o)}static a(o){o.registerCommand(!1,"_validateWhenClauses",b.$Ui)}}e.$Odc=y;function k(u){return o=>{if(Array.isArray(o))return o.map(u)}}function w(u){if(!Array.isArray(u))return;const o=[];for(const i of u)L.$kt(i)?o.push(A.DefinitionLink.to(i)):o.push(A.location.to(i));return o}}),define(ke[314],Se([1,0,12,59,4,3,2,83,26,15,7,6,25]),function(me,e,C,F,f,L,M,b,v,g,A,I,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ydc=void 0;function y(k,w,u){const o=k.getProxy(I.$xK.MainThreadComments);class i{static{this.a=0}constructor(){this.b=new Map,this.c=new v.$bm,w.registerArgumentProcessor({processArgument:h=>{if(h&&h.$mid===6){const E=this.b.get(h.handle);return E?E.value:h}else if(h&&h.$mid===7){const E=this.b.get(h.commentControlHandle);if(!E)return h;const D=E.getCommentThread(h.commentThreadHandle);return D?D.value:h}else if(h&&(h.$mid===9||h.$mid===8)){const E=this.b.get(h.thread.commentControlHandle);if(!E)return h;const D=E.getCommentThread(h.thread.commentThreadHandle);return D?h.$mid===8?D.value:{thread:D.value,text:h.text}:h}else if(h&&h.$mid===10){const E=this.b.get(h.thread.commentControlHandle);if(!E)return h;const D=E.getCommentThread(h.thread.commentThreadHandle);if(!D)return h;const m=h.commentUniqueId,p=D.getCommentByUniqueId(m);return p||h}else if(h&&h.$mid===11){const E=this.b.get(h.thread.commentControlHandle);if(!E)return h;const D=E.getCommentThread(h.thread.commentThreadHandle);if(!D)return h;const m=h.text,p=h.commentUniqueId,S=D.getCommentByUniqueId(p);return S?(typeof S.body=="string"?S.body=m:S.body=new A.$ZK(m),S):h}return h}})}createCommentController(h,E,D){const m=i.a++,p=new r(h,m,E,D);this.b.set(p.handle,p);const S=this.c.get(h.identifier)||[];return S.push(p),this.c.set(h.identifier,S),p.value}async $createCommentThreadTemplate(h,E,D){const m=this.b.get(h);m&&m.$createCommentThreadTemplate(E,D)}async $updateCommentThreadTemplate(h,E,D){const m=this.b.get(h);m&&m.$updateCommentThreadTemplate(E,D)}$deleteCommentThread(h,E){this.b.get(h)?.$deleteCommentThread(E)}$provideCommentingRanges(h,E,D){const m=this.b.get(h);if(!m||!m.commentingRangeProvider)return Promise.resolve(void 0);const p=u.getDocument(M.URI.revive(E));return(0,C.$Qg)(async()=>{const S=await m.commentingRangeProvider.provideCommentingRanges(p,D);let P;return Array.isArray(S)?P={ranges:S,fileComments:!1}:S?P={ranges:S.ranges||[],fileComments:S.fileComments||!1}:P=S??void 0,P}).then(S=>{let P;return S&&(P={ranges:S.ranges.map(z=>g.Range.from(z)),fileComments:S.fileComments}),P})}$toggleReaction(h,E,D,m,p){const S=this.b.get(h);return!S||!S.reactionHandler?Promise.resolve(void 0):(0,C.$Qg)(()=>{const P=S.getCommentThread(E);if(P){const z=P.getCommentByUniqueId(m.uniqueIdInThread);if(S!==void 0&&z&&S.reactionHandler)return S.reactionHandler(z,s(p))}return Promise.resolve(void 0)})}}class n{static{this.a=0}set threadId(h){this.n=h}get threadId(){return this.n}get id(){return this.n}get resource(){return this.o}get uri(){return this.o}set range(h){(h===void 0!=(this.p===void 0)||!h||!this.p||!h.isEqual(this.p))&&(this.p=h,this.b.range=h,this.c.fire())}get range(){return this.p}set canReply(h){this.d!==h&&(this.d=h,this.b.canReply=h,this.c.fire())}get canReply(){return this.d}get label(){return this.e}set label(h){this.e=h,this.b.label=h,this.c.fire()}get contextValue(){return this.f}set contextValue(h){this.f=h,this.b.contextValue=h,this.c.fire()}get comments(){return this.q}set comments(h){this.q=h,this.b.comments=h,this.c.fire()}get collapsibleState(){return this.g}set collapsibleState(h){this.g=h,this.b.collapsibleState=h,this.c.fire()}get state(){return this.h}set state(h){this.h=h,this.b.state=h,this.c.fire()}get isDisposed(){return this.j}constructor(h,E,D,m,p,S,P,z){this.m=E,this.n=D,this.o=m,this.p=p,this.q=S,this.extensionDescription=P,this.r=z,this.handle=n.a++,this.commentHandle=0,this.b=Object.create(null),this.c=new f.$Rd,this.onDidUpdateCommentThread=this.c.event,this.d=!0,this.k=new Map,this.l=new L.$Sc,this.l.value=new L.$Qc,this.n===void 0&&(this.n=`${h}.${this.handle}`),o.$createCommentThread(E,this.handle,this.n,this.o,g.Range.from(this.p),P.identifier,this.r),this.i=[],this.j=!1,this.i.push(this.onDidUpdateCommentThread(()=>{this.eventuallyUpdateCommentThread()})),this.comments=S,this.i.push({dispose:()=>{o.$deleteCommentThread(E,this.handle)}});const j=this;this.value={get uri(){return j.uri},get range(){return j.range},set range(R){j.range=R},get comments(){return j.comments},set comments(R){j.comments=R},get collapsibleState(){return j.collapsibleState},set collapsibleState(R){j.collapsibleState=R},get canReply(){return j.canReply},set canReply(R){j.canReply=R},get contextValue(){return j.contextValue},set contextValue(R){j.contextValue=R},get label(){return j.label},set label(R){j.label=R},get state(){return j.state},set state(R){j.state=R},dispose:()=>{j.dispose()}}}s(){this.r&&(this.r=!1,this.b.isTemplate=!1)}eventuallyUpdateCommentThread(){if(this.j)return;this.s(),this.l.value||(this.l.value=new L.$Qc);const h=D=>Object.prototype.hasOwnProperty.call(this.b,D),E={};h("range")&&(E.range=g.Range.from(this.p)),h("label")&&(E.label=this.label),h("contextValue")&&(E.contextValue=this.contextValue??null),h("comments")&&(E.comments=this.q.map(D=>a(this,D,this.k,this.extensionDescription))),h("collapsibleState")&&(E.collapseState=d(this.g)),h("canReply")&&(E.canReply=this.canReply),h("state")&&(E.state=c(this.h)),h("isTemplate")&&(E.isTemplate=this.r),this.b={},o.$updateCommentThread(this.m,this.handle,this.n,this.o,E)}getCommentByUniqueId(h){for(const E of this.k){const D=E[0],m=E[1];if(h===m)return D}}dispose(){this.j=!0,this.l.dispose(),this.i.forEach(h=>h.dispose())}}He([(0,F.$oh)(100)],n.prototype,"eventuallyUpdateCommentThread",null);class r{get id(){return this.h}get label(){return this.i}get handle(){return this.g}get commentingRangeProvider(){return this.b}set commentingRangeProvider(h){this.b=h,o.$updateCommentingRanges(this.handle)}get reactionHandler(){return this.c}set reactionHandler(h){this.c=h,o.$updateCommentControllerFeatures(this.handle,{reactionHandler:!!h})}get options(){return this.d}set options(h){this.d=h,o.$updateCommentControllerFeatures(this.handle,{options:this.d})}constructor(h,E,D,m){this.f=h,this.g=E,this.h=D,this.i=m,this.a=new Map,o.$registerCommentController(this.handle,D,m,this.f.identifier.value);const p=this;this.value=Object.freeze({id:p.id,label:p.label,get options(){return p.options},set options(S){p.options=S},get commentingRangeProvider(){return p.commentingRangeProvider},set commentingRangeProvider(S){p.commentingRangeProvider=S},get reactionHandler(){return p.reactionHandler},set reactionHandler(S){p.reactionHandler=S},createCommentThread(S,P,z){return p.createCommentThread(S,P,z).value},dispose:()=>{p.dispose()}}),this.e=[],this.e.push({dispose:()=>{o.$unregisterCommentController(this.handle)}})}createCommentThread(h,E,D){E===void 0&&(0,$.$MF)(this.f,"fileComments");const m=new n(this.id,this.handle,void 0,h,E,D,this.f,!1);return this.a.set(m.handle,m),m}$createCommentThreadTemplate(h,E){const D=new n(this.id,this.handle,void 0,M.URI.revive(h),g.Range.to(E),[],this.f,!0);return D.collapsibleState=b.CommentThreadCollapsibleState.Expanded,this.a.set(D.handle,D),D}$updateCommentThreadTemplate(h,E){const D=this.a.get(h);D&&(D.range=g.Range.to(E))}$deleteCommentThread(h){this.a.get(h)?.dispose(),this.a.delete(h)}getCommentThread(h){return this.a.get(h)}dispose(){this.a.forEach(h=>{h.dispose()}),this.e.forEach(h=>h.dispose())}}function a(l,h,E,D){let m=E.get(h);return m||(m=++l.commentHandle,E.set(h,m)),h.state!==void 0&&(0,$.$MF)(D,"commentsDraftState"),{mode:h.mode,contextValue:h.contextValue,uniqueIdInThread:m,body:typeof h.body=="string"?h.body:g.MarkdownString.from(h.body),userName:h.author.name,userIconPath:h.author.iconPath,label:h.label,commentReactions:h.reactions?h.reactions.map(p=>t(p)):void 0,state:h.state,timestamp:h.timestamp?.toJSON()}}function t(l){return{label:l.label,iconPath:l.iconPath?g.$yM(l.iconPath):void 0,count:l.count,hasReacted:l.authorHasReacted}}function s(l){return{label:l.label||"",count:l.count||0,iconPath:l.iconPath?M.URI.revive(l.iconPath):"",authorHasReacted:l.hasReacted||!1}}function d(l){if(l!==void 0)switch(l){case A.CommentThreadCollapsibleState.Expanded:return b.CommentThreadCollapsibleState.Expanded;case A.CommentThreadCollapsibleState.Collapsed:return b.CommentThreadCollapsibleState.Collapsed}return b.CommentThreadCollapsibleState.Collapsed}function c(l){if(l!==void 0)switch(l){case A.CommentThreadState.Unresolved:return b.CommentThreadState.Unresolved;case A.CommentThreadState.Resolved:return b.CommentThreadState.Resolved}return b.CommentThreadState.Unresolved}return new i}e.$Ydc=y}),define(ke[315],Se([1,0,24,6,27,20]),function(me,e,C,F,f,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mfc=void 0;let M=class{constructor(A,I){this.a=A.getProxy(F.$xK.MainThreadConsole),this.b=I.consoleForward.includeStack,this.c=I.consoleForward.logNative,this.d("info","log"),this.d("log","log"),this.d("warn","warn"),this.d("error","error")}d(A,I){const $=this,y=console[A];Object.defineProperty(console,A,{set:()=>{},get:()=>function(){$.e(A,I,y,arguments)}})}e(A,I,$,y){this.a.$logExtensionHostMessage({type:"__$console",severity:I,arguments:v(y,this.b)}),this.c&&this.f(A,$,y)}};e.$Mfc=M,e.$Mfc=M=He([Be(0,L.$zM),Be(1,f.$PM)],M);const b=1e5;function v(g,A){const I=[];if(g.length)for(let $=0;$<g.length;$++){let y=g[$];if(typeof y>"u")y="undefined";else if(y instanceof Error){const k=y;k.stack?y=k.stack:y=k.toString()}I.push(y)}if(A){const $=new Error().stack;$&&I.push({__$stack:$.split(`
`).slice(3).join(`
`)})}try{const $=(0,C.$fn)(I);return $.length>b?"Output omitted for a large object that exceeds the limits":$}catch($){return`Output omitted for an object that cannot be inspected ('${$.toString()}')`}}}),define(ke[151],Se([1,0,2,6,7,5,20,14,19,13,16,25]),function(me,e,C,F,f,L,M,b,v,g,A,I){"use strict";var $;Object.defineProperty(e,"__esModule",{value:!0}),e.$Pec=e.$Oec=void 0;let y=class{static{$=this}static{this.c=0}static{this.d=250}constructor(w,u){this.h=u,this.f=new Map,this.g=w.getProxy(F.$xK.MainThreadDecorations)}registerFileDecorationProvider(w,u){const o=$.c++;this.f.set(o,{provider:w,extensionDescription:u}),this.g.$registerDecorationProvider(o,u.identifier.value);const i=w.onDidChangeFileDecorations&&w.onDidChangeFileDecorations(n=>{if(!n){this.g.$onDidChange(o,null);return}const r=(0,v.$2b)(n);if(r.length<=$.d){this.g.$onDidChange(o,r);return}this.h.warn("[Decorations] CAPPING events from decorations provider",u.identifier.value,r.length);const a=r.map(d=>({uri:d,rank:(0,g.$Ke)(d.path,"/")})),t=(0,v.$yb)(a,(d,c)=>d.rank-c.rank||(0,g.$Ye)(d.uri.path,c.uri.path)),s=[];e:for(const d of t){let c;for(const l of d){const h=(0,A.$lc)(l.uri.path);if(c!==h&&(c=h,s.push(l.uri)>=$.d))break e}}this.g.$onDidChange(o,s)});return new f.$zK(()=>{i?.dispose(),this.g.$unregisterDecorationProvider(o),this.f.delete(o)})}async $provideDecorations(w,u,o){if(!this.f.has(w))return Object.create(null);const i=Object.create(null),{provider:n,extensionDescription:r}=this.f.get(w);return await Promise.all(u.map(async a=>{try{const{uri:t,id:s}=a,d=await Promise.resolve(n.provideFileDecoration(C.URI.revive(t),o));if(!d)return;try{f.$UL.validate(d),d.badge&&typeof d.badge!="string"&&(0,I.$MF)(r,"codiconDecoration"),i[s]=[d.propagate,d.tooltip,d.badge,d.color]}catch(c){this.h.warn(`INVALID decoration from extension '${r.identifier.value}': ${c}`)}}catch(t){this.h.error(t)}})),i}};e.$Oec=y,e.$Oec=y=$=He([Be(0,M.$zM),Be(1,b.$dj)],y),e.$Pec=(0,L.$Vh)("IExtHostDecorations")}),define(ke[316],Se([1,0,211,136,2,6,7,15,4,14,28,57]),function(me,e,C,F,f,L,M,b,v,g,A,I){"use strict";var $;Object.defineProperty(e,"__esModule",{value:!0}),e.$Jdc=e.$Idc=void 0;class y{#e;#t;#i;constructor(u,o,i,n,r,a,t,s){this.d=u,this.e=o,this.f=i,this.g=n,this.h=r,this.c=!1,this.f=Math.max(n,i),this.#i=new A.$zc(d=>a.getComparisonKey(d)),this.#e=t,this.#t=s}dispose(){this.c||(this.#t.fire([...this.#i.keys()]),this.#e?.$clear(this.e),this.#i.clear(),this.c=!0)}get name(){return this.j(),this.d}set(u,o){if(!u){this.clear();return}this.j();let i=[];if(f.URI.isUri(u)){if(!o){this.delete(u);return}this.#i.set(u,o.slice()),i=[u]}else if(Array.isArray(u)){i=[];let a;u=[...u].sort(y.k);for(const t of u){const[s,d]=t;if((!a||s.toString()!==a.toString())&&(a&&this.#i.get(a).length===0&&this.#i.delete(a),a=s,i.push(s),this.#i.set(s,[])),d)this.#i.get(s)?.push(...d);else{const c=this.#i.get(s);c&&(c.length=0)}}}if(this.#t.fire(i),!this.#e)return;const n=[];let r=0;for(const a of i){let t=[];const s=this.#i.get(a);if(s)if(s.length>this.g){t=[];const d=[M.DiagnosticSeverity.Error,M.DiagnosticSeverity.Warning,M.DiagnosticSeverity.Information,M.DiagnosticSeverity.Hint];e:for(let c=0;c<4;c++)for(const l of s)if(l.severity===d[c]&&t.push({...b.Diagnostic.from(l),modelVersionId:this.h(a)})===this.g)break e;t.push({severity:F.MarkerSeverity.Info,message:(0,C.localize)(0,null,s.length-this.g),startLineNumber:t[t.length-1].startLineNumber,startColumn:t[t.length-1].startColumn,endLineNumber:t[t.length-1].endLineNumber,endColumn:t[t.length-1].endColumn})}else t=s.map(d=>({...b.Diagnostic.from(d),modelVersionId:this.h(a)}));if(n.push([a,t]),r+=t.length,r>this.f)break}this.#e.$changeMany(this.e,n)}delete(u){this.j(),this.#t.fire([u]),this.#i.delete(u),this.#e?.$changeMany(this.e,[[u,void 0]])}clear(){this.j(),this.#t.fire([...this.#i.keys()]),this.#i.clear(),this.#e?.$clear(this.e)}forEach(u,o){this.j();for(const[i,n]of this)u.call(o,i,n,this)}*[Symbol.iterator](){this.j();for(const u of this.#i.keys())yield[u,this.get(u)]}get(u){this.j();const o=this.#i.get(u);return Array.isArray(o)?Object.freeze(o.slice(0)):[]}has(u){return this.j(),Array.isArray(this.#i.get(u))}j(){if(this.c)throw new Error("illegal state - object is disposed")}static k(u,o){return u[0].toString()<o[0].toString()?-1:u[0].toString()>o[0].toString()?1:0}}e.$Idc=y;let k=class{static{$=this}static{this.c=0}static{this.d=1e3}static{this.e=1.1*$.d}static _mapper(u){const o=new A.$zc;for(const i of u)o.set(i,i);return{uris:Object.freeze(Array.from(o.values()))}}constructor(u,o,i,n){this.j=o,this.k=i,this.l=n,this.g=new Map,this.h=new v.$Vd({merge:r=>r.flat(),delay:50}),this.onDidChangeDiagnostics=v.Event.map(this.h.event,$._mapper),this.f=u.getProxy(L.$xK.MainThreadDiagnostics)}createDiagnosticCollection(u,o){const{g:i,f:n,h:r,j:a,k:t,l:s}=this,d=new class{$changeMany(h,E){n.$changeMany(h,E),a.trace("[DiagnosticCollection] change many (extension, owner, uris)",u.value,h,E.length===0?"CLEARING":E)}$clear(h){n.$clear(h),a.trace("[DiagnosticCollection] remove all (extension, owner)",u.value,h)}dispose(){n.dispose()}};let c;if(!o)o="_generated_diagnostic_collection_name_#"+$.c++,c=o;else if(!i.has(o))c=o;else{this.j.warn(`DiagnosticCollection with name '${o}' does already exist.`);do c=o+$.c++;while(i.has(c))}return new class extends y{constructor(){super(o,c,$.e,$.d,h=>s.getDocument(h)?.version,t.extUri,d,r),i.set(c,this)}dispose(){super.dispose(),i.delete(c)}}}getDiagnostics(u){if(u)return this.m(u);{const o=new Map,i=[];for(const n of this.g.values())n.forEach((r,a)=>{let t=o.get(r.toString());typeof t>"u"&&(t=i.length,o.set(r.toString(),t),i.push([r,[]])),i[t][1]=i[t][1].concat(...a)});return i}}m(u){let o=[];for(const i of this.g.values())i.has(u)&&(o=o.concat(i.get(u)));return o}$acceptMarkersChange(u){if(!this.n){const o="_generated_mirror",i=new y(o,o,Number.MAX_SAFE_INTEGER,Number.MAX_SAFE_INTEGER,n=>{},this.k.extUri,void 0,this.h);this.g.set(o,i),this.n=i}for(const[o,i]of u)this.n.set(f.URI.revive(o),i.map(b.Diagnostic.to))}};e.$Jdc=k,e.$Jdc=k=$=He([Be(1,g.$dj),Be(2,I.$Hdc)],k)}),define(ke[317],Se([1,0,2,6,25]),function(me,e,C,F,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qec=void 0;class L{constructor(b){this.a=b.getProxy(F.$xK.MainThreadDialogs)}showOpenDialog(b,v){return v?.allowUIResources&&(0,f.$MF)(b,"showLocal"),this.a.$showOpenDialog(v).then(g=>g?g.map(A=>C.URI.revive(A)):void 0)}showSaveDialog(b){return this.a.$showSaveDialog(b).then(v=>v?C.URI.revive(v):void 0)}}e.$Qec=L}),define(ke[318],Se([1,0,8,2,7,6,17,21,13]),function(me,e,C,F,f,L,M,b,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rec=void 0;class g{static{this.a=0}constructor(I,$,y){this.d=$,this.e=y,this.b=new Map,this.c=I.getProxy(L.$xK.MainThreadDocumentContentProviders)}registerTextDocumentContentProvider(I,$){if(Object.keys(M.Schemas).indexOf(I)>=0)throw new Error(`scheme '${I}' already registered`);const y=g.a++;this.b.set(y,$),this.c.$registerTextContentProvider(y,I);let k;return typeof $.onDidChange=="function"&&(k=$.onDidChange(w=>{if(w.scheme!==I){this.e.warn(`Provider for scheme '${I}' is firing event for schema '${w.scheme}' which will be IGNORED`);return}this.d.getDocument(w)&&this.$provideTextDocumentContent(y,w).then(u=>{if(!u&&typeof u!="string")return;const o=this.d.getDocument(w);if(!o)return;const i=(0,v.$Te)(u);if(!o.equalLines(i))return this.c.$onVirtualDocumentChange(w,u)},C.$Z)})),new f.$zK(()=>{this.b.delete(y)&&this.c.$unregisterTextContentProvider(y),k&&(k.dispose(),k=void 0)})}$provideTextDocumentContent(I,$){const y=this.b.get(I);return y?Promise.resolve(y.provideTextDocumentContent(F.URI.revive($),b.CancellationToken.None)):Promise.reject(new Error(`unsupported uri-scheme: ${$.scheme}`))}}e.$Rec=g}),define(ke[319],Se([1,0,4,3,2,6,143,15,18,24,7,8]),function(me,e,C,F,f,L,M,b,v,g,A,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fdc=void 0;class ${constructor(k,w){this.a=new C.$Rd({onListenerError:I.$1}),this.b=new C.$Rd({onListenerError:I.$1}),this.c=new C.$Rd({onListenerError:I.$1}),this.d=new C.$Rd({onListenerError:I.$1}),this.onDidAddDocument=this.a.event,this.onDidRemoveDocument=this.b.event,this.onDidChangeDocument=this.c.event,this.onDidSaveDocument=this.d.event,this.e=new F.$Qc,this.h=new Map,this.f=k.getProxy(L.$xK.MainThreadDocuments),this.g=w,this.g.onDidRemoveDocuments(u=>{for(const o of u)this.b.fire(o.document)},void 0,this.e),this.g.onDidAddDocuments(u=>{for(const o of u)this.a.fire(o.document)},void 0,this.e)}dispose(){this.e.dispose()}getAllDocumentData(){return[...this.g.allDocuments()]}getDocumentData(k){if(!k)return;const w=this.g.getDocument(k);if(w)return w}getDocument(k){const w=this.getDocumentData(k);if(!w?.document)throw new Error(`Unable to retrieve document from URI '${k}'`);return w.document}ensureDocumentData(k){const w=this.g.getDocument(k);if(w)return Promise.resolve(w);let u=this.h.get(k.toString());return u||(u=this.f.$tryOpenDocument(k).then(o=>{this.h.delete(k.toString());const i=f.URI.revive(o);return(0,v.$Nf)(this.g.getDocument(i))},o=>(this.h.delete(k.toString()),Promise.reject(o))),this.h.set(k.toString(),u)),u}createDocumentData(k){return this.f.$tryCreateDocument(k).then(w=>f.URI.revive(w))}$acceptModelLanguageChanged(k,w){const u=f.URI.revive(k),o=this.g.getDocument(u);if(!o)throw new Error("unknown document");this.b.fire(o.document),o._acceptLanguageId(w),this.a.fire(o.document)}$acceptModelSaved(k){const w=f.URI.revive(k),u=this.g.getDocument(w);if(!u)throw new Error("unknown document");this.$acceptDirtyStateChanged(k,!1),this.d.fire(u.document)}$acceptDirtyStateChanged(k,w){const u=f.URI.revive(k),o=this.g.getDocument(u);if(!o)throw new Error("unknown document");o._acceptIsDirty(w),this.c.fire({document:o.document,contentChanges:[],reason:void 0})}$acceptModelChanged(k,w,u){const o=f.URI.revive(k),i=this.g.getDocument(o);if(!i)throw new Error("unknown document");i._acceptIsDirty(u),i.onEvents(w);let n;w.isUndoing?n=A.TextDocumentChangeReason.Undo:w.isRedoing&&(n=A.TextDocumentChangeReason.Redo),this.c.fire((0,g.$bn)({document:i.document,contentChanges:w.changes.map(r=>({range:b.Range.to(r.range),rangeOffset:r.rangeOffset,rangeLength:r.rangeLength,text:r.text})),reason:n}))}setWordDefinitionFor(k,w){(0,M.$BM)(k,w)}}e.$Fdc=$}),define(ke[69],Se([1,0,60,4,3,2,5,6,143,20,150,15,14,28,17,51,48]),function(me,e,C,F,f,L,M,b,v,g,A,I,$,y,k,w,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$KM=e.$JM=void 0;class o{constructor(r){this.value=r,this.a=0}ref(){this.a++}unref(){return--this.a===0}}let i=class{constructor(r,a){this.h=r,this.i=a,this.a=null,this.b=new Map,this.c=new y.$zc,this.d=new F.$Rd,this.e=new F.$Rd,this.f=new F.$Rd,this.g=new F.$Rd,this.onDidAddDocuments=this.d.event,this.onDidRemoveDocuments=this.e.event,this.onDidChangeVisibleTextEditors=this.f.event,this.onDidChangeActiveTextEditor=this.g.event}$acceptDocumentsAndEditorsDelta(r){this.acceptDocumentsAndEditorsDelta(r)}acceptDocumentsAndEditorsDelta(r){const a=[],t=[],s=[];if(r.removedDocuments)for(const d of r.removedDocuments){const c=L.URI.revive(d),l=this.c.get(c);l?.unref()&&(this.c.delete(c),a.push(l.value))}if(r.addedDocuments)for(const d of r.addedDocuments){const c=L.URI.revive(d.uri);let l=this.c.get(c);if(l&&c.scheme!==k.Schemas.vscodeNotebookCell&&c.scheme!==k.Schemas.vscodeInteractiveInput)throw new Error(`document '${c} already exists!'`);l||(l=new o(new v.$CM(this.h.getProxy(b.$xK.MainThreadDocuments),c,d.lines,d.EOL,d.versionId,d.languageId,d.isDirty,d.notebook)),this.c.set(c,l),t.push(l.value)),l.ref()}if(r.removedEditors)for(const d of r.removedEditors){const c=this.b.get(d);this.b.delete(d),c&&s.push(c)}if(r.addedEditors)for(const d of r.addedEditors){const c=L.URI.revive(d.documentUri);C.ok(this.c.has(c),`document '${c}' does not exist`),C.ok(!this.b.has(d.id),`editor '${d.id}' already exists!`);const l=this.c.get(c).value,h=new A.$IM(d.id,this.h.getProxy(b.$xK.MainThreadTextEditors),this.i,new u.$U(()=>l.document),d.selections.map(I.Selection.to),d.options,d.visibleRanges.map(E=>I.Range.to(E)),typeof d.editorPosition=="number"?I.ViewColumn.to(d.editorPosition):void 0);this.b.set(d.id,h)}r.newActiveEditor!==void 0&&(C.ok(r.newActiveEditor===null||this.b.has(r.newActiveEditor),`active editor '${r.newActiveEditor}' does not exist`),this.a=r.newActiveEditor),(0,f.$Mc)(a),(0,f.$Mc)(s),r.removedDocuments&&this.e.fire(a),r.addedDocuments&&this.d.fire(t),(r.removedEditors||r.addedEditors)&&this.f.fire(this.allEditors().map(d=>d.value)),r.newActiveEditor!==void 0&&this.g.fire(this.activeEditor())}getDocument(r){return this.c.get(r)?.value}allDocuments(){return w.Iterable.map(this.c.values(),r=>r.value)}getEditor(r){return this.b.get(r)}activeEditor(r){if(!this.a)return;const a=this.b.get(this.a);return r?a:a?.value}allEditors(){return[...this.b.values()]}};e.$JM=i,e.$JM=i=He([Be(0,g.$zM),Be(1,$.$dj)],i),e.$KM=(0,M.$Vh)("IExtHostDocumentsAndEditors")}),define(ke[70],Se([1,0,73,4,18,2,5,6,20,15,7]),function(me,e,C,F,f,L,M,b,v,g,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gec=e.$fec=void 0,e.$fec=(0,M.$Vh)("IExtHostEditorTabs");class I{constructor(u,o,i){this.e=i,this.d=o,this.acceptDtoUpdate(u)}get apiObject(){if(!this.a){const u=this,o={get isActive(){return u.b.id===u.e()},get label(){return u.b.label},get input(){return u.c},get isDirty(){return u.b.isDirty},get isPinned(){return u.b.isPinned},get isPreview(){return u.b.isPreview},get group(){return u.d.apiObject}};this.a=Object.freeze(o)}return this.a}get tabId(){return this.b.id}acceptDtoUpdate(u){this.b=u,this.c=this.f()}f(){switch(this.b.input.kind){case 1:return new A.$eM(L.URI.revive(this.b.input.uri));case 2:return new A.$fM(L.URI.revive(this.b.input.original),L.URI.revive(this.b.input.modified));case 3:return new A.$gM(L.URI.revive(this.b.input.base),L.URI.revive(this.b.input.input1),L.URI.revive(this.b.input.input2),L.URI.revive(this.b.input.result));case 6:return new A.$hM(L.URI.revive(this.b.input.uri),this.b.input.viewType);case 7:return new A.$iM(this.b.input.viewType);case 4:return new A.$jM(L.URI.revive(this.b.input.uri),this.b.input.notebookType);case 5:return new A.$kM(L.URI.revive(this.b.input.original),L.URI.revive(this.b.input.modified),this.b.input.notebookType);case 8:return new A.$lM;case 9:return new A.$mM(L.URI.revive(this.b.input.uri),L.URI.revive(this.b.input.inputBoxUri));case 10:return new A.$nM(this.b.input.providerId);default:return}}}class ${constructor(u,o){this.c=[],this.d="",this.b=u,this.e=o;for(const i of u.tabs)i.isActive&&(this.d=i.id),this.c.push(new I(i,this,()=>this.activeTabId()))}get apiObject(){if(!this.a){const u=this,o={get isActive(){return u.b.groupId===u.e()},get viewColumn(){return g.ViewColumn.to(u.b.viewColumn)},get activeTab(){return u.c.find(i=>i.tabId===u.d)?.apiObject},get tabs(){return Object.freeze(u.c.map(i=>i.apiObject))}};this.a=Object.freeze(o)}return this.a}get groupId(){return this.b.groupId}get tabs(){return this.c}acceptGroupDtoUpdate(u){this.b=u}acceptTabOperation(u){if(u.kind===0){const i=new I(u.tabDto,this,()=>this.activeTabId());return this.c.splice(u.index,0,i),u.tabDto.isActive&&(this.d=i.tabId),i}else if(u.kind===1){const i=this.c.splice(u.index,1)[0];if(!i)throw new Error(`Tab close updated received for index ${u.index} which does not exist`);return i.tabId===this.d&&(this.d=""),i}else if(u.kind===3){if(u.oldIndex===void 0)throw new Error("Invalid old index on move IPC");const i=this.c.splice(u.oldIndex,1)[0];if(!i)throw new Error(`Tab move updated received for index ${u.oldIndex} which does not exist`);return this.c.splice(u.index,0,i),i}const o=this.c.find(i=>i.tabId===u.tabDto.id);if(!o)throw new Error("INVALID tab");return u.tabDto.isActive?this.d=u.tabDto.id:this.d===u.tabDto.id&&!u.tabDto.isActive&&(this.d=""),o.acceptDtoUpdate(u.tabDto),o}activeTabId(){return this.d}}let y=class{constructor(u){this.b=new F.$Rd,this.c=new F.$Rd,this.e=[],this.a=u.getProxy(b.$xK.MainThreadEditorTabs)}get tabGroups(){if(!this.f){const u=this,o={onDidChangeTabGroups:u.c.event,onDidChangeTabs:u.b.event,get all(){return Object.freeze(u.e.map(i=>i.apiObject))},get activeTabGroup(){const i=u.d;return(0,f.$Nf)(u.e.find(r=>r.groupId===i)?.apiObject)},close:async(i,n)=>{const r=Array.isArray(i)?i:[i];return r.length?k(r[0])?this.j(r,n):this.i(r,n):!0}};this.f=Object.freeze(o)}return this.f}$acceptEditorTabModel(u){const o=new Set(this.e.map(d=>d.groupId)),i=new Set(u.map(d=>d.groupId)),n=(0,C.$K)(o,i),r=this.e.filter(d=>n.removed.includes(d.groupId)).map(d=>d.apiObject),a=[],t=[];this.e=u.map(d=>{const c=new $(d,()=>this.d);return n.added.includes(c.groupId)?a.push(c.apiObject):t.push(c.apiObject),c});const s=(0,f.$Nf)(u.find(d=>d.isActive===!0)?.groupId);s!==void 0&&this.d!==s&&(this.d=s),this.c.fire(Object.freeze({opened:a,closed:r,changed:t}))}$acceptTabGroupUpdate(u){const o=this.e.find(i=>i.groupId===u.groupId);if(!o)throw new Error("Update Group IPC call received before group creation.");o.acceptGroupDtoUpdate(u),u.isActive&&(this.d=u.groupId),this.c.fire(Object.freeze({changed:[o.apiObject],opened:[],closed:[]}))}$acceptTabOperation(u){const o=this.e.find(n=>n.groupId===u.groupId);if(!o)throw new Error("Update Tabs IPC call received before group creation.");const i=o.acceptTabOperation(u);switch(u.kind){case 0:this.b.fire(Object.freeze({opened:[i.apiObject],closed:[],changed:[]}));return;case 1:this.b.fire(Object.freeze({opened:[],closed:[i.apiObject],changed:[]}));return;case 3:case 2:this.b.fire(Object.freeze({opened:[],closed:[],changed:[i.apiObject]}));return}}g(u){for(const o of this.e)for(const i of o.tabs)if(i.apiObject===u)return i}h(u){return this.e.find(o=>o.apiObject===u)}async i(u,o){const i=[];for(const n of u){const r=this.g(n);if(!r)throw new Error("Tab close: Invalid tab not found!");i.push(r.tabId)}return this.a.$closeTab(i,o)}async j(u,o){const i=[];for(const n of u){const r=this.h(n);if(!r)throw new Error("Group close: Invalid group not found!");i.push(r.groupId)}return this.a.$closeGroup(i,o)}};e.$gec=y,e.$gec=y=He([Be(0,v.$zM)],y);function k(w){return w.tabs!==void 0}}),define(ke[320],Se([1,0,6,7]),function(me,e,C,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tec=void 0;class f{constructor(M){this.a=new Map,this.b=0,this.c=M.getProxy(C.$xK.MainThreadAiEmbeddingVector)}async $provideAiEmbeddingVector(M,b,v){if(this.a.size===0)throw new Error("No embedding vector providers registered");const g=this.a.get(M);if(!g)throw new Error("Embedding vector provider not found");const A=await g.provideEmbeddingVector(b,v);if(!A)throw new Error("Embedding vector provider returned undefined");return A}registerEmbeddingVectorProvider(M,b,v){const g=this.b;return this.b++,this.a.set(g,v),this.c.$registerAiEmbeddingVectorProvider(b,g),new F.$zK(()=>{this.c.$unregisterAiEmbeddingVectorProvider(g),this.a.delete(g)})}}e.$Tec=f}),define(ke[321],Se([1,0,2,6,3,7,15,173,13,22,25,80]),function(me,e,C,F,f,L,M,b,v,g,A,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Uec=void 0;class ${constructor(){this.a=[]}add(w){this.b=void 0,this.a.push(w)}delete(w){const u=this.a.indexOf(w);u>=0&&(this.a.splice(u,1),this.b=void 0)}c(){if(!this.b){const w=this.a.sort(),u=[];let o,i,n=14,r=14;for(const a of w){let t=o?(0,v.$8e)(o,a):0;for(t===0?i=1:i=r;t<a.length;t++)t+1===a.length?(n=r,r=9):r+=1,u.push([i,a.toUpperCase().charCodeAt(t),r]),u.push([i,a.toLowerCase().charCodeAt(t),r]),i=r;o=a,r=n}u.push([9,58,10]),u.push([10,47,12]),this.b=new b.$yZ(u)}}provideDocumentLinks(w){this.c();const u=[],o=b.$zZ.computeLinks({getLineContent(i){return w.lineAt(i-1).text},getLineCount(){return w.lineCount}},this.b);for(const i of o){const n=M.DocumentLink.to(i);n.target&&u.push(n)}return u}}class y{constructor(w,u){this.i=u,this.b=new $,this.c=new Map,this.d=new Set,this.f=new Map,this.h=0,this.a=w.getProxy(F.$xK.MainThreadFileSystem)}dispose(){this.g?.dispose()}registerFileSystemProvider(w,u,o,i={}){if(y.j(o),this.d.has(u))throw new Error(`a provider for the scheme '${u}' is already registered`);this.g||(this.g=this.i.registerDocumentLinkProvider(w,"*",this.b));const n=this.h++;this.b.add(u),this.d.add(u),this.c.set(n,o);let r=2;i.isCaseSensitive&&(r+=1024),i.isReadonly&&(r+=2048),typeof o.copy=="function"&&(r+=8),typeof o.open=="function"&&typeof o.close=="function"&&typeof o.read=="function"&&typeof o.write=="function"&&((0,A.$MF)(w,"fsChunks"),r+=4);let a;i.isReadonly&&(0,I.$$j)(i.isReadonly)&&((0,A.$MF)(w,"readonlyMessage"),a={value:i.isReadonly.value,isTrusted:i.isReadonly.isTrusted,supportThemeIcons:i.isReadonly.supportThemeIcons,supportHtml:i.isReadonly.supportHtml,baseUri:i.isReadonly.baseUri,uris:i.isReadonly.uris}),this.a.$registerFileSystemProvider(n,u,r,a).catch(s=>{console.error(`FAILED to register filesystem provider of ${w.identifier.value}-extension for the scheme ${u}`),console.error(s)});const t=o.onDidChangeFile(s=>{const d=[];for(const c of s){const{uri:l,type:h}=c;if(l.scheme!==u)continue;let E;switch(h){case L.FileChangeType.Changed:E=0;break;case L.FileChangeType.Created:E=1;break;case L.FileChangeType.Deleted:E=2;break;default:throw new Error("Unknown FileChangeType")}d.push({resource:l,type:E})}this.a.$onFileSystemChange(n,d)});return(0,f.$Pc)(()=>{t.dispose(),this.b.delete(u),this.d.delete(u),this.c.delete(n),this.a.$unregisterProvider(n)})}static j(w){if(!w)throw new Error("MISSING provider");if(typeof w.watch!="function")throw new Error("Provider does NOT implement watch");if(typeof w.stat!="function")throw new Error("Provider does NOT implement stat");if(typeof w.readDirectory!="function")throw new Error("Provider does NOT implement readDirectory");if(typeof w.createDirectory!="function")throw new Error("Provider does NOT implement createDirectory");if(typeof w.readFile!="function")throw new Error("Provider does NOT implement readFile");if(typeof w.writeFile!="function")throw new Error("Provider does NOT implement writeFile");if(typeof w.delete!="function")throw new Error("Provider does NOT implement delete");if(typeof w.rename!="function")throw new Error("Provider does NOT implement rename")}static k(w){const{type:u,ctime:o,mtime:i,size:n,permissions:r}=w;return{type:u,ctime:o,mtime:i,size:n,permissions:r}}$stat(w,u){return Promise.resolve(this.l(w).stat(C.URI.revive(u))).then(o=>y.k(o))}$readdir(w,u){return Promise.resolve(this.l(w).readDirectory(C.URI.revive(u)))}$readFile(w,u){return Promise.resolve(this.l(w).readFile(C.URI.revive(u))).then(o=>g.$fe.wrap(o))}$writeFile(w,u,o,i){return Promise.resolve(this.l(w).writeFile(C.URI.revive(u),o.buffer,i))}$delete(w,u,o){return Promise.resolve(this.l(w).delete(C.URI.revive(u),o))}$rename(w,u,o,i){return Promise.resolve(this.l(w).rename(C.URI.revive(u),C.URI.revive(o),i))}$copy(w,u,o,i){const n=this.l(w);if(!n.copy)throw new Error('FileSystemProvider does not implement "copy"');return Promise.resolve(n.copy(C.URI.revive(u),C.URI.revive(o),i))}$mkdir(w,u){return Promise.resolve(this.l(w).createDirectory(C.URI.revive(u)))}$watch(w,u,o,i){const n=this.l(w).watch(C.URI.revive(o),i);this.f.set(u,n)}$unwatch(w,u){const o=this.f.get(u);o&&(o.dispose(),this.f.delete(u))}$open(w,u,o){const i=this.l(w);if(!i.open)throw new Error('FileSystemProvider does not implement "open"');return Promise.resolve(i.open(C.URI.revive(u),o))}$close(w,u){const o=this.l(w);if(!o.close)throw new Error('FileSystemProvider does not implement "close"');return Promise.resolve(o.close(u))}$read(w,u,o,i){const n=this.l(w);if(!n.read)throw new Error('FileSystemProvider does not implement "read"');const r=g.$fe.alloc(i);return Promise.resolve(n.read(u,o,r.buffer,0,i)).then(a=>r.slice(0,a))}$write(w,u,o,i){const n=this.l(w);if(!n.write)throw new Error('FileSystemProvider does not implement "write"');return Promise.resolve(n.write(u,o,i.buffer,0,i.byteLength))}l(w){const u=this.c.get(w);if(!u){const o=new Error;throw o.name="ENOPRO",o.message="no provider",o}return u}}e.$Uec=y}),define(ke[71],Se([1,0,6,31,7,22,5,20,57,3,12,23,17]),function(me,e,C,F,f,L,M,b,v,g,A,I,$){"use strict";var y;Object.defineProperty(e,"__esModule",{value:!0}),e.$8dc=e.$7dc=void 0;let k=y=class{constructor(u,o){this.b=new Map,this.c=new A.$7g,this.a=u.getProxy(C.$xK.MainThreadFileSystem);const i=this;this.value=Object.freeze({async stat(n){try{let r;const a=i.b.get(n.scheme);return a?(await i.a.$ensureActivation(n.scheme),r=await a.impl.stat(n)):r=await i.a.$stat(n),{type:r.type,ctime:r.ctime,mtime:r.mtime,size:r.size,permissions:r.permissions===F.FilePermission.Readonly?1:void 0}}catch(r){y.e(r)}},async readDirectory(n){try{const r=i.b.get(n.scheme);return r?(await i.a.$ensureActivation(n.scheme),(await r.impl.readDirectory(n)).slice()):await i.a.$readdir(n)}catch(r){return y.e(r)}},async createDirectory(n){try{const r=i.b.get(n.scheme);return r&&!r.isReadonly?(await i.a.$ensureActivation(n.scheme),await i.d(r.impl,r.extUri,n)):await i.a.$mkdir(n)}catch(r){return y.e(r)}},async readFile(n){try{const r=i.b.get(n.scheme);return r?(await i.a.$ensureActivation(n.scheme),(await r.impl.readFile(n)).slice()):(await i.a.$readFile(n)).buffer}catch(r){return y.e(r)}},async writeFile(n,r){try{const a=i.b.get(n.scheme);return a&&!a.isReadonly?(await i.a.$ensureActivation(n.scheme),await i.d(a.impl,a.extUri,a.extUri.dirname(n)),await i.c.queueFor(n).queue(()=>Promise.resolve(a.impl.writeFile(n,r,{create:!0,overwrite:!0})))):await i.a.$writeFile(n,L.$fe.wrap(r))}catch(a){return y.e(a)}},async delete(n,r){try{const a=i.b.get(n.scheme);return a&&!a.isReadonly?(await i.a.$ensureActivation(n.scheme),await a.impl.delete(n,{recursive:!1,...r})):await i.a.$delete(n,{recursive:!1,useTrash:!1,atomic:!1,...r})}catch(a){return y.e(a)}},async rename(n,r,a){try{return await i.a.$rename(n,r,{overwrite:!1,...a})}catch(t){return y.e(t)}},async copy(n,r,a){try{return await i.a.$copy(n,r,{overwrite:!1,...a})}catch(t){return y.e(t)}},isWritableFileSystem(n){const r=o.getCapabilities(n);if(typeof r=="number")return!(r&2048)}})}async d(u,o,i){const n=[];for(;!o.isEqual(i,o.dirname(i));)try{if(!((await u.stat(i)).type&F.FileType.Directory))throw f.$ML.FileExists(`Unable to create folder '${i.scheme===$.Schemas.file?i.fsPath:i.toString(!0)}' that already exists but is not a directory`);break}catch(r){if(F.$uk(r)!==F.FileSystemProviderErrorCode.FileNotFound)throw r;n.push(o.basename(i)),i=o.dirname(i)}for(let r=n.length-1;r>=0;r--){i=o.joinPath(i,n[r]);try{await u.createDirectory(i)}catch(a){if(F.$uk(a)!==F.FileSystemProviderErrorCode.FileExists)throw a}}}static e(u){if(u instanceof f.$ML)throw u;if(u instanceof F.$qk)switch(u.code){case F.FileSystemProviderErrorCode.FileExists:throw f.$ML.FileExists(u.message);case F.FileSystemProviderErrorCode.FileNotFound:throw f.$ML.FileNotFound(u.message);case F.FileSystemProviderErrorCode.FileNotADirectory:throw f.$ML.FileNotADirectory(u.message);case F.FileSystemProviderErrorCode.FileIsADirectory:throw f.$ML.FileIsADirectory(u.message);case F.FileSystemProviderErrorCode.NoPermissions:throw f.$ML.NoPermissions(u.message);case F.FileSystemProviderErrorCode.Unavailable:throw f.$ML.Unavailable(u.message);default:throw new f.$ML(u.message,u.name)}if(!(u instanceof Error))throw new f.$ML(String(u));if(u.name==="ENOPRO"||u.message.includes("ENOPRO"))throw f.$ML.Unavailable(u.message);switch(u.name){case F.FileSystemProviderErrorCode.FileExists:throw f.$ML.FileExists(u.message);case F.FileSystemProviderErrorCode.FileNotFound:throw f.$ML.FileNotFound(u.message);case F.FileSystemProviderErrorCode.FileNotADirectory:throw f.$ML.FileNotADirectory(u.message);case F.FileSystemProviderErrorCode.FileIsADirectory:throw f.$ML.FileIsADirectory(u.message);case F.FileSystemProviderErrorCode.NoPermissions:throw f.$ML.NoPermissions(u.message);case F.FileSystemProviderErrorCode.Unavailable:throw f.$ML.Unavailable(u.message);default:throw new f.$ML(u.message,u.name)}}addFileSystemProvider(u,o,i){return this.b.set(u,{impl:o,extUri:i?.isCaseSensitive?I.$pg:I.$rg,isReadonly:!!i?.isReadonly}),(0,g.$Pc)(()=>this.b.delete(u))}getFileSystemProviderExtUri(u){return this.b.get(u)?.extUri??I.$pg}};e.$7dc=k,e.$7dc=k=y=He([Be(0,b.$zM),Be(1,v.$Hdc)],k),e.$8dc=(0,M.$Vh)("IExtHostConsumerFileSystem")}),define(ke[322],Se([1,0,4,34,2,6,15,7,48]),function(me,e,C,F,f,L,M,b,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vec=void 0;class g{get ignoreCreateEvents(){return!!(this.h&1)}get ignoreChangeEvents(){return!!(this.h&2)}get ignoreDeleteEvents(){return!!(this.h&4)}constructor(y,k,w,u,o,i){this.a=Math.random(),this.b=new C.$Rd,this.c=new C.$Rd,this.d=new C.$Rd,this.h=0,i?.ignoreCreateEvents&&(this.h+=1),i?.ignoreChangeEvents&&(this.h+=2),i?.ignoreDeleteEvents&&(this.h+=4);const n=(0,F.$Cj)(o),r=typeof o=="string",a=i?.correlate,t=u(s=>{if(!(typeof s.session=="number"&&s.session!==this.a)&&!(a&&typeof s.session>"u")){if(!i?.ignoreCreateEvents)for(const d of s.created){const c=f.URI.revive(d);n(c.fsPath)&&(!r||k.getWorkspaceFolder(c))&&this.b.fire(c)}if(!i?.ignoreChangeEvents)for(const d of s.changed){const c=f.URI.revive(d);n(c.fsPath)&&(!r||k.getWorkspaceFolder(c))&&this.c.fire(c)}if(!i?.ignoreDeleteEvents)for(const d of s.deleted){const c=f.URI.revive(d);n(c.fsPath)&&(!r||k.getWorkspaceFolder(c))&&this.d.fire(c)}}});this.g=b.$zK.from(this.i(y,w,o,i,i?.correlate),this.b,this.c,this.d,t)}i(y,k,w,u,o){const i=b.$zK.from();if(typeof w=="string")return i;const n=y.getProxy(L.$xK.MainThreadFileSystemEventService);let r=!1;return(w.pattern.includes(F.$yj)||w.pattern.includes(F.$zj))&&(r=!0),n.$watch(k.identifier.value,this.a,w.baseUri,{recursive:r,excludes:u?.excludes??[]},!!o),b.$zK.from({dispose:()=>n.$unwatch(this.a)})}dispose(){this.g.dispose()}get onDidCreate(){return this.b.event}get onDidChange(){return this.c.event}get onDidDelete(){return this.d.event}}class A{constructor(y){this.a=y,this.session=this.a.session,this.b=new v.$U(()=>this.a.created.map(f.URI.revive)),this.c=new v.$U(()=>this.a.changed.map(f.URI.revive)),this.d=new v.$U(()=>this.a.deleted.map(f.URI.revive))}get created(){return this.b.value}get changed(){return this.c.value}get deleted(){return this.d.value}}class I{constructor(y,k,w){this.j=y,this.k=k,this.l=w,this.a=new C.$Rd,this.b=new C.$Rd,this.c=new C.$Rd,this.d=new C.$Rd,this.g=new C.$Td,this.h=new C.$Td,this.i=new C.$Td,this.onDidRenameFile=this.b.event,this.onDidCreateFile=this.c.event,this.onDidDeleteFile=this.d.event}createFileSystemWatcher(y,k,w,u){return new g(this.j,y,k,this.a.event,M.GlobPattern.from(w),u)}$onFileEvent(y){this.a.fire(new A(y))}$onDidRunFileOperation(y,k){switch(y){case 2:this.b.fire(Object.freeze({files:k.map(w=>({oldUri:f.URI.revive(w.source),newUri:f.URI.revive(w.target)}))}));break;case 1:this.d.fire(Object.freeze({files:k.map(w=>f.URI.revive(w.target))}));break;case 0:case 3:this.c.fire(Object.freeze({files:k.map(w=>f.URI.revive(w.target))}));break;default:}}getOnWillRenameFileEvent(y){return this.m(y,this.g)}getOnWillCreateFileEvent(y){return this.m(y,this.h)}getOnWillDeleteFileEvent(y){return this.m(y,this.i)}m(y,k){return(w,u,o)=>{const i=function(r){w.call(u,r)};return i.extension=y,k.event(i,void 0,o)}}async $onWillRunFileOperation(y,k,w,u){switch(y){case 2:return await this.n(this.g,{files:k.map(o=>({oldUri:f.URI.revive(o.source),newUri:f.URI.revive(o.target)}))},w,u);case 1:return await this.n(this.i,{files:k.map(o=>f.URI.revive(o.target))},w,u);case 0:case 3:return await this.n(this.h,{files:k.map(o=>f.URI.revive(o.target))},w,u)}}async n(y,k,w,u){const o=new Set,i=[];if(await y.fireAsync(k,u,async(r,a)=>{const t=Date.now(),s=await Promise.resolve(r);s instanceof b.$JK&&(i.push([a.extension,s]),o.add(a.extension.displayName??a.extension.identifier.value)),Date.now()-t>w&&this.k.warn("SLOW file-participant",a.extension.identifier)}),u.isCancellationRequested||i.length===0)return;const n={edits:[]};for(const[,r]of i){const{edits:a}=M.WorkspaceEdit.from(r,{getTextDocumentVersion:t=>this.l.getDocument(t)?.version,getNotebookDocumentVersion:()=>{}});n.edits=n.edits.concat(a)}return{edit:n,extensionNames:Array.from(o)}}}e.$Vec=I}),define(ke[323],Se([1,0,3,2,6,15,7,35,12]),function(me,e,C,F,f,L,M,b,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wec=void 0;class g{static{this.a=0}constructor(y,k){this.extension=y,this.provider=k,this.handle=g.a++}}class A{constructor(y){this.session=y,this.responses=[]}}class I{static{this.a=0}constructor(y,k,w,u){this.f=w,this.g=u,this.b=new Map,this.d=new Map,this.e=y.getProxy(f.$xK.MainThreadInlineChat),k.registerApiCommand(new b.$ZM("vscode.editorChat.start","inlineChat.start","Invoke a new editor chat session",[new b.$XM("Run arguments","",o=>!0,o=>{if(o)return{initialRange:o.initialRange?L.Range.from(o.initialRange):void 0,initialSelection:o.initialSelection?L.Selection.from(o.initialSelection):void 0,message:o.message,autoSend:o.autoSend,position:o.position?L.Position.from(o.position):void 0}})],b.$YM.Void))}registerProvider(y,k,w){const u=new g(y,k);return this.b.set(u.handle,u),this.e.$registerInteractiveEditorProvider(u.handle,w.label,y.identifier.value,typeof k.handleInteractiveEditorResponseFeedback=="function"),(0,C.$Pc)(()=>{this.e.$unregisterInteractiveEditorProvider(u.handle),this.b.delete(u.handle)})}async $prepareSession(y,k,w,u){const o=this.b.get(y);if(!o){this.g.warn("CANNOT prepare session because the PROVIDER IS GONE");return}const i=this.f.getDocument(F.URI.revive(k)),n=L.Selection.to(w),r=await o.provider.prepareInteractiveEditorSession({document:i,selection:n},u);if(!r)return;if(r.wholeRange&&!r.wholeRange.contains(n))throw new Error("InteractiveEditorSessionProvider returned a wholeRange that does not contain the selection.");const a=I.a++;return this.d.set(a,new A(r)),{id:a,placeholder:r.placeholder,input:r.input,slashCommands:r.slashCommands?.map(t=>({command:t.command,detail:t.detail,refer:t.refer,executeImmediately:t.executeImmediately})),wholeRange:L.Range.from(r.wholeRange),message:r.message}}async $provideResponse(y,k,w,u){const o=this.b.get(y);if(!o)return;const i=this.d.get(k.id);if(!i)return;const n={prompt:w.prompt,selection:L.Selection.to(w.selection),wholeRange:L.Range.to(w.wholeRange),attempt:w.attempt,live:w.live};let r=!1;const a={report:async l=>{if(!w.live&&l.edits?.length)throw new Error("Progress reporting is only supported for live sessions");r||u.isCancellationRequested||await this.e.$handleProgressChunk(w.requestId,{message:l.message,edits:l.edits?.map(L.TextEdit.from),editsShouldBeInstant:l.editsShouldBeInstant,slashCommand:l.slashCommand?.command,markdownFragment:M.$ZK.isMarkdownString(l.content)?l.content.value:l.content})}},t=Promise.resolve(o.provider.provideInteractiveEditorResponse(i.session,n,a,u));let s;try{s=await(0,v.$Mg)(t,u)}finally{r=!0}if(!s)return;const d=i.responses.push(s)-1,c={wholeRange:L.Range.from(s.wholeRange),placeholder:s.placeholder};if(I.h(s)){const{edits:l,contents:h}=s,E=h!==void 0?L.MarkdownString.from(h):void 0;return l instanceof M.$JK?{...c,id:d,type:"bulkEdit",edits:L.WorkspaceEdit.from(l),message:E}:{...c,id:d,type:"editorEdit",edits:l.map(L.TextEdit.from),message:E}}return{...c,id:d,type:"message",message:L.MarkdownString.from(s.contents)}}$handleFeedback(y,k,w,u){const o=this.b.get(y),i=this.d.get(k),n=i?.responses[w];if(o&&n){const r=L.InteractiveEditorResponseFeedbackKind.to(u);o.provider.handleInteractiveEditorResponseFeedback?.(i.session,n,r)}}$releaseSession(y,k){}static h(y){return typeof y=="object"&&typeof y.edits=="object"}}e.$Wec=I}),define(ke[324],Se([1,0,2,35]),function(me,e,C,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0ec=void 0;class f{constructor(M,b,v,g,A){this.a=b,this.b=v,this.c=g;const I=new F.$ZM("interactive.open","_interactive.open","Open interactive window and return notebook editor and input URI",[new F.$XM("showOptions","Show Options",$=>!0,$=>$),new F.$XM("resource","Interactive resource Uri",$=>!0,$=>$),new F.$XM("controllerId","Notebook controller Id",$=>!0,$=>$),new F.$XM("title","Interactive editor title",$=>!0,$=>$)],new F.$YM("Notebook and input URI",$=>{if(A.debug("[ExtHostInteractive] open iw with notebook editor id",$.notebookEditorId),$.notebookEditorId!==void 0){const y=this.a.getEditorById($.notebookEditorId);return A.debug("[ExtHostInteractive] notebook editor found",y.id),{notebookUri:C.URI.revive($.notebookUri),inputUri:C.URI.revive($.inputUri),notebookEditor:y.apiEditor}}return A.debug("[ExtHostInteractive] notebook editor not found, uris for the interactive document",$.notebookUri,$.inputUri),{notebookUri:C.URI.revive($.notebookUri),inputUri:C.URI.revive($.inputUri)}}));this.c.registerApiCommand(I)}$willAddInteractiveDocument(M,b,v,g){this.b.acceptDocumentsAndEditorsDelta({addedDocuments:[{EOL:b,lines:[""],languageId:v,uri:M,isDirty:!1,versionId:1,notebook:this.a.getNotebookDocument(C.URI.revive(g))?.apiNotebook}]})}$willRemoveInteractiveDocument(M,b){this.b.acceptDocumentsAndEditorsDelta({removedDocuments:[M]})}}e.$0ec=f}),define(ke[325],Se([1,0,6,7]),function(me,e,C,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$ec=void 0;class f{constructor(M){this.a=new Map,this.b=new Map,this.c=M.getProxy(C.$xK.MainThreadIssueReporter)}async $getIssueReporterUri(M,b){if(this.a.size===0)throw new Error("No issue request handlers registered");const v=this.a.get(M);if(!v)throw new Error("Issue request handler not found");const g=await v.handleIssueUrlRequest();if(!g)throw new Error("Issue request handler returned no result");return g}async $getIssueReporterData(M,b){if(this.b.size===0)throw new Error("No issue request handlers registered");const v=this.b.get(M);if(!v)throw new Error("Issue data provider not found");const g=await v.provideIssueData(b);if(!g)throw new Error("Issue data provider returned no result");return g}async $getIssueReporterTemplate(M,b){if(this.b.size===0)throw new Error("No issue request handlers registered");const v=this.b.get(M);if(!v)throw new Error("Issue data provider not found");const g=await v.provideIssueTemplate(b);if(!g)throw new Error("Issue template provider returned no result");return g}registerIssueUriRequestHandler(M,b){const v=M.identifier.value;return this.a.set(v,b),this.c.$registerIssueUriRequestHandler(v),new F.$zK(()=>{this.c.$unregisterIssueUriRequestHandler(v),this.a.delete(v)})}registerIssueDataProvider(M,b){const v=M.identifier.value;return this.b.set(v,b),this.c.$registerIssueDataProvider(v),new F.$zK(()=>{this.c.$unregisterIssueDataProvider(v),this.b.delete(v)})}}e.$$ec=f}),define(ke[326],Se([1,0,3,6]),function(me,e,C,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_ec=void 0;class f{constructor(M){this.b=0,this.a=M.getProxy(F.$xK.MainThreadLabelService)}$registerResourceLabelFormatter(M){const b=this.b++;return this.a.$registerResourceLabelFormatter(b,M),(0,C.$Pc)(()=>{this.a.$unregisterResourceLabelFormatter(b)})}}e.$_ec=f}),define(ke[327],Se([1,0,2,24,15,7,83,6,13,29,19,18,169,21,26,3,132,122,110,38,8,12,25,213]),function(me,e,C,F,f,L,M,b,v,g,A,I,$,y,k,w,u,o,i,n,r,a,t,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ndc=void 0;class d{constructor(B,X){this.d=B,this.e=X}async provideDocumentSymbols(B,X){const re=this.d.getDocument(B),ae=await this.e.provideDocumentSymbols(re,X);if(!(0,A.$Jb)(ae))return ae[0]instanceof L.$RK?ae.map(f.DocumentSymbol.from):d.f(ae)}static f(B){B=B.slice(0).sort((ae,ee)=>{let ge=ae.location.range.start.compareTo(ee.location.range.start);return ge===0&&(ge=ee.location.range.end.compareTo(ae.location.range.end)),ge});const X=[],re=[];for(const ae of B){const ee={name:ae.name||"!!MISSING: name!!",kind:f.SymbolKind.from(ae.kind),tags:ae.tags?.map(f.SymbolTag.from)||[],detail:"",containerName:ae.containerName,range:f.Range.from(ae.location.range),selectionRange:f.Range.from(ae.location.range),children:[]};for(;;){if(re.length===0){re.push(ee),X.push(ee);break}const ge=re[re.length-1];if(g.$zs.containsRange(ge.range,ee.range)&&!g.$zs.equalsRange(ge.range,ee.range)){ge.children?.push(ee),re.push(ee);break}re.pop()}}return X}}class c{static{this.d={command:"missing",title:"!!MISSING: command!!"}}constructor(B,X,re){this.g=B,this.h=X,this.j=re,this.e=new i.$Ddc("CodeLens"),this.f=new Map}async provideCodeLenses(B,X){const re=this.g.getDocument(B),ae=await this.j.provideCodeLenses(re,X);if(!ae||X.isCancellationRequested)return;const ee=this.e.add(ae),ge=new w.$Qc;this.f.set(ee,ge);const ye={cacheId:ee,lenses:[]};for(let je=0;je<ae.length;je++)ye.lenses.push({cacheId:[ee,je],range:f.Range.from(ae[je].range),command:this.h.toInternal(ae[je].command,ge)});return ye}async resolveCodeLens(B,X){const re=B.cacheId&&this.e.get(...B.cacheId);if(!re)return;let ae;if(typeof this.j.resolveCodeLens!="function"||re.isResolved?ae=re:ae=await this.j.resolveCodeLens(re,X),ae||(ae=re),X.isCancellationRequested)return;const ee=B.cacheId&&this.f.get(B.cacheId[0]);if(ee)return B.command=this.h.toInternal(ae.command??c.d,ee),B}releaseCodeLenses(B){this.f.get(B)?.dispose(),this.f.delete(B),this.e.delete(B)}}function l(Pe){return Array.isArray(Pe)?Pe.map(f.DefinitionLink.from):Pe?[f.DefinitionLink.from(Pe)]:[]}class h{constructor(B,X){this.d=B,this.e=X}async provideDefinition(B,X,re){const ae=this.d.getDocument(B),ee=f.Position.to(X),ge=await this.e.provideDefinition(ae,ee,re);return l(ge)}}class E{constructor(B,X){this.d=B,this.e=X}async provideDeclaration(B,X,re){const ae=this.d.getDocument(B),ee=f.Position.to(X),ge=await this.e.provideDeclaration(ae,ee,re);return l(ge)}}class D{constructor(B,X){this.d=B,this.e=X}async provideImplementation(B,X,re){const ae=this.d.getDocument(B),ee=f.Position.to(X),ge=await this.e.provideImplementation(ae,ee,re);return l(ge)}}class m{constructor(B,X){this.d=B,this.e=X}async provideTypeDefinition(B,X,re){const ae=this.d.getDocument(B),ee=f.Position.to(X),ge=await this.e.provideTypeDefinition(ae,ee,re);return l(ge)}}class p{constructor(B,X){this.d=B,this.e=X}async provideHover(B,X,re){const ae=this.d.getDocument(B),ee=f.Position.to(X),ge=await this.e.provideHover(ae,ee,re);if(!(!ge||(0,A.$Jb)(ge.contents)))return ge.range||(ge.range=ae.getWordRangeAtPosition(ee)),ge.range||(ge.range=new L.$BK(ee,ee)),f.Hover.from(ge)}}class S{constructor(B,X){this.d=B,this.e=X}async provideEvaluatableExpression(B,X,re){const ae=this.d.getDocument(B),ee=f.Position.to(X),ge=await this.e.provideEvaluatableExpression(ae,ee,re);if(ge)return f.EvaluatableExpression.from(ge)}}class P{constructor(B,X){this.d=B,this.e=X}async provideInlineValues(B,X,re,ae){const ee=this.d.getDocument(B),ge=await this.e.provideInlineValues(ee,f.Range.to(X),f.InlineValueContext.to(re),ae);if(Array.isArray(ge))return ge.map(ye=>f.InlineValue.from(ye))}}class z{constructor(B,X){this.d=B,this.e=X}async provideDocumentHighlights(B,X,re){const ae=this.d.getDocument(B),ee=f.Position.to(X),ge=await this.e.provideDocumentHighlights(ae,ee,re);if(Array.isArray(ge))return ge.map(f.DocumentHighlight.from)}}class j{constructor(B,X){this.d=B,this.e=X}async provideLinkedEditingRanges(B,X,re){const ae=this.d.getDocument(B),ee=f.Position.to(X),ge=await this.e.provideLinkedEditingRanges(ae,ee,re);if(ge&&Array.isArray(ge.ranges))return{ranges:(0,A.$Gb)(ge.ranges.map(f.Range.from)),wordPattern:ge.wordPattern}}}class R{constructor(B,X){this.d=B,this.e=X}async provideReferences(B,X,re,ae){const ee=this.d.getDocument(B),ge=f.Position.to(X),ye=await this.e.provideReferences(ee,ge,re,ae);if(Array.isArray(ye))return ye.map(f.location.from)}}class T{static{this.d=1e3}constructor(B,X,re,ae,ee,ge,ye){this.g=B,this.h=X,this.j=re,this.k=ae,this.l=ee,this.m=ge,this.n=ye,this.e=new i.$Ddc("CodeAction"),this.f=new Map}async provideCodeActions(B,X,re,ae){const ee=this.g.getDocument(B),ge=$.$Bs.isISelection(X)?f.Selection.to(X):f.Range.to(X),ye=[];for(const nt of this.j.getDiagnostics(B))if(ge.intersection(nt.range)&&ye.push(nt)>T.d)break;const je={diagnostics:ye,only:re.only?new L.$TK(re.only):void 0,triggerKind:f.CodeActionTriggerKind.to(re.trigger)},We=await this.k.provideCodeActions(ee,ge,je,ae);if(!(0,A.$Kb)(We)||ae.isCancellationRequested)return;const et=this.e.add(We),Ze=new w.$Qc;this.f.set(et,Ze);const rt=[];for(let nt=0;nt<We.length;nt++){const Ae=We[nt];Ae&&(T.o(Ae)?(this.n.report("CodeActionProvider.provideCodeActions - return commands",this.m,"Return 'CodeAction' instances instead."),rt.push({_isSynthetic:!0,title:Ae.title,command:this.h.toInternal(Ae,Ze)})):(je.only&&(Ae.kind?je.only.contains(Ae.kind)||this.l.warn(`${this.m.identifier.value} - Code actions of kind '${je.only.value} 'requested but returned code action is of kind '${Ae.kind.value}'. Code action will be dropped. Please check 'CodeActionContext.only' to only return requested code actions.`):this.l.warn(`${this.m.identifier.value} - Code actions of kind '${je.only.value} 'requested but returned code action does not have a 'kind'. Code action will be dropped. Please set 'CodeAction.kind'.`)),rt.push({cacheId:[et,nt],title:Ae.title,command:Ae.command&&this.h.toInternal(Ae.command,Ze),diagnostics:Ae.diagnostics&&Ae.diagnostics.map(f.Diagnostic.from),edit:Ae.edit&&f.WorkspaceEdit.from(Ae.edit,void 0),kind:Ae.kind&&Ae.kind.value,isPreferred:Ae.isPreferred,isAI:(0,t.$LF)(this.m,"codeActionAI")?Ae.isAI:!1,disabled:Ae.disabled?.reason})))}return{cacheId:et,actions:rt}}async resolveCodeAction(B,X){const[re,ae]=B,ee=this.e.get(re,ae);if(!ee||T.o(ee))return{};if(!this.k.resolveCodeAction)return{};const ge=await this.k.resolveCodeAction(ee,X)??ee;let ye;ge.edit&&(ye=f.WorkspaceEdit.from(ge.edit,void 0));let je;if(ge.command){const We=this.f.get(re);We&&(je=this.h.toInternal(ge.command,We))}return{edit:ye,command:je}}releaseCodeActions(B){this.f.get(B)?.dispose(),this.f.delete(B),this.e.delete(B)}static o(B){return typeof B.command=="string"&&typeof B.title=="string"}}class N{static toInternalProviderId(B,X){return B+"."+X}constructor(B,X,re,ae,ee){this.d=B,this.e=X,this.f=re,this.g=ae,this.h=ee}async prepareDocumentPaste(B,X,re,ae){if(!this.f.prepareDocumentPaste)return;const ee=this.e.getDocument(B),ge=X.map(We=>f.Range.to(We)),ye=f.DataTransfer.toDataTransfer(re,()=>{throw new r.$0});if(await this.f.prepareDocumentPaste(ee,ge,ye,ae),ae.isCancellationRequested)return;const je=Array.from(ye).filter(([,We])=>!(We instanceof L.$nL));return f.DataTransfer.from(je)}async providePasteEdits(B,X,re,ae,ee){if(!this.f.provideDocumentPasteEdits)return;const ge=this.e.getDocument(X),ye=re.map(et=>f.Range.to(et)),je=f.DataTransfer.toDataTransfer(ae,async et=>(await this.d.$resolvePasteFileData(this.g,B,et)).buffer),We=await this.f.provideDocumentPasteEdits(ge,ye,je,ee);if(We)return{label:We.label??(0,s.localize)(0,null,this.h.displayName||this.h.name),detail:this.h.displayName||this.h.name,yieldTo:We.yieldTo?.map(et=>"mimeType"in et?et:{providerId:N.toInternalProviderId(et.extensionId,et.providerId)}),insertText:typeof We.insertText=="string"?We.insertText:{snippet:We.insertText.value},additionalEdit:We.additionalEdit?f.WorkspaceEdit.from(We.additionalEdit,void 0):void 0}}}class O{constructor(B,X){this.d=B,this.e=X}async provideDocumentFormattingEdits(B,X,re){const ae=this.d.getDocument(B),ee=await this.e.provideDocumentFormattingEdits(ae,X,re);if(Array.isArray(ee))return ee.map(f.TextEdit.from)}}class W{constructor(B,X){this.d=B,this.e=X}async provideDocumentRangeFormattingEdits(B,X,re,ae){const ee=this.d.getDocument(B),ge=f.Range.to(X),ye=await this.e.provideDocumentRangeFormattingEdits(ee,ge,re,ae);if(Array.isArray(ye))return ye.map(f.TextEdit.from)}async provideDocumentRangesFormattingEdits(B,X,re,ae){(0,I.$Mf)(typeof this.e.provideDocumentRangesFormattingEdits=="function","INVALID invocation of `provideDocumentRangesFormattingEdits`");const ee=this.d.getDocument(B),ge=X.map(f.Range.to),ye=await this.e.provideDocumentRangesFormattingEdits(ee,ge,re,ae);if(Array.isArray(ye))return ye.map(f.TextEdit.from)}}class x{constructor(B,X){this.d=B,this.e=X,this.autoFormatTriggerCharacters=[]}async provideOnTypeFormattingEdits(B,X,re,ae,ee){const ge=this.d.getDocument(B),ye=f.Position.to(X),je=await this.e.provideOnTypeFormattingEdits(ge,ye,re,ae,ee);if(Array.isArray(je))return je.map(f.TextEdit.from)}}class le{constructor(B,X){this.e=B,this.f=X,this.d=new i.$Ddc("WorkspaceSymbols")}async provideWorkspaceSymbols(B,X){const re=await this.e.provideWorkspaceSymbols(B,X);if(!(0,A.$Kb)(re))return{symbols:[]};const ae=this.d.add(re),ee={cacheId:ae,symbols:[]};for(let ge=0;ge<re.length;ge++){const ye=re[ge];if(!ye||!ye.name){this.f.warn("INVALID SymbolInformation",ye);continue}ee.symbols.push({...f.WorkspaceSymbol.from(ye),cacheId:[ae,ge]})}return ee}async resolveWorkspaceSymbol(B,X){if(typeof this.e.resolveWorkspaceSymbol!="function"||!B.cacheId)return B;const re=this.d.get(...B.cacheId);if(re){const ae=await this.e.resolveWorkspaceSymbol(re,X);return ae&&(0,F.$dn)(B,f.WorkspaceSymbol.from(ae),!0)}}releaseWorkspaceSymbols(B){this.d.delete(B)}}class G{static supportsResolving(B){return typeof B.prepareRename=="function"}constructor(B,X,re){this.d=B,this.e=X,this.f=re}async provideRenameEdits(B,X,re,ae){const ee=this.d.getDocument(B),ge=f.Position.to(X);try{const ye=await this.e.provideRenameEdits(ee,ge,re,ae);return ye?f.WorkspaceEdit.from(ye):void 0}catch(ye){const je=G.g(ye);return je?{rejectReason:je,edits:void 0}:Promise.reject(ye)}}async resolveRenameLocation(B,X,re){if(typeof this.e.prepareRename!="function")return Promise.resolve(void 0);const ae=this.d.getDocument(B),ee=f.Position.to(X);try{const ge=await this.e.prepareRename(ae,ee,re);let ye,je;if(L.$BK.isRange(ge)?(ye=ge,je=ae.getText(ge)):(0,I.$Ef)(ge)&&(ye=ge.range,je=ge.placeholder),!ye||!je)return;if(ye.start.line>ee.line||ye.end.line<ee.line){this.f.warn("INVALID rename location: position line must be within range start/end lines");return}return{range:f.Range.from(ye),text:je}}catch(ge){const ye=G.g(ge);return ye?{rejectReason:ye,range:void 0,text:void 0}:Promise.reject(ge)}}static g(B){return typeof B=="string"?B:B instanceof Error&&typeof B.message=="string"?B.message:void 0}}class J{constructor(B,X){this.resultId=B,this.tokens=X}}class Q{constructor(B,X){this.f=B,this.g=X,this.e=1,this.d=new Map}async provideDocumentSemanticTokens(B,X,re){const ae=this.f.getDocument(B),ee=X!==0?this.d.get(X):null;let ge=typeof ee?.resultId=="string"&&typeof this.g.provideDocumentSemanticTokensEdits=="function"?await this.g.provideDocumentSemanticTokensEdits(ae,ee.resultId,re):await this.g.provideDocumentSemanticTokens(ae,re);return ee&&this.d.delete(X),ge?(ge=Q.h(ge),this.o(Q.n(ee,ge),ge)):null}async releaseDocumentSemanticColoring(B){this.d.delete(B)}static h(B){return Q.j(B)?Q.k(B)?B:new L.$QL(new Uint32Array(B.data),B.resultId):Q.l(B)?Q.m(B)?B:new L.$SL(B.edits.map(X=>new L.$RL(X.start,X.deleteCount,X.data?new Uint32Array(X.data):X.data)),B.resultId):B}static j(B){return B&&!!B.data}static k(B){return B.data instanceof Uint32Array}static l(B){return B&&Array.isArray(B.edits)}static m(B){for(const X of B.edits)if(!(X.data instanceof Uint32Array))return!1;return!0}static n(B,X){if(!Q.j(X)||!B||!B.tokens)return X;const re=B.tokens,ae=re.length,ee=X.data,ge=ee.length;let ye=0;const je=Math.min(ae,ge);for(;ye<je&&re[ye]===ee[ye];)ye++;if(ye===ae&&ye===ge)return new L.$SL([],X.resultId);let We=0;const et=je-ye;for(;We<et&&re[ae-We-1]===ee[ge-We-1];)We++;return new L.$SL([{start:ye,deleteCount:ae-ye-We,data:ee.subarray(ye,ge-We)}],X.resultId)}o(B,X){if(Q.j(B)){const re=this.e++;return this.d.set(re,new J(B.resultId,B.data)),(0,u.$w$)({id:re,type:"full",data:B.data})}if(Q.l(B)){const re=this.e++;return Q.j(X)?this.d.set(re,new J(X.resultId,X.data)):this.d.set(re,new J(B.resultId)),(0,u.$w$)({id:re,type:"delta",deltas:(B.edits||[]).map(ae=>({start:ae.start,deleteCount:ae.deleteCount,data:ae.data}))})}return null}}class oe{constructor(B,X){this.d=B,this.e=X}async provideDocumentRangeSemanticTokens(B,X,re){const ae=this.d.getDocument(B),ee=await this.e.provideDocumentRangeSemanticTokens(ae,f.Range.to(X),re);return ee?this.f(ee):null}f(B){return(0,u.$w$)({id:0,type:"full",data:B.data})}}class _{static supportsResolving(B){return typeof B.resolveCompletionItem=="function"}constructor(B,X,re,ae,ee){this.f=B,this.g=X,this.h=re,this.j=ae,this.k=ee,this.d=new i.$Ddc("CompletionItem"),this.e=new Map}async provideCompletionItems(B,X,re,ae){const ee=this.f.getDocument(B),ge=f.Position.to(X),ye=ee.getWordRangeAtPosition(ge)||new L.$BK(ge,ge),je=ye.with({end:ge}),We=new n.$Nd,et=await this.h.provideCompletionItems(ee,ge,ae,f.CompletionContext.to(re));if(!et||ae.isCancellationRequested)return;const Ze=Array.isArray(et)?new L.$7K(et):et,rt=_.supportsResolving(this.h)?this.d.add(Ze.items):this.d.add([]),nt=new w.$Qc;this.e.set(rt,nt);const Ae=[],Oe={x:rt,b:Ae,a:{replace:f.Range.from(ye),insert:f.Range.from(je)},c:Ze.isIncomplete||void 0,d:We.elapsed()};for(let Ve=0;Ve<Ze.items.length;Ve++){const Le=Ze.items[Ve],Ye=this.l(Le,[rt,Ve],je,ye);Ae.push(Ye)}return Oe}async resolveCompletionItem(B,X){if(typeof this.h.resolveCompletionItem!="function")return;const re=this.d.get(...B);if(!re)return;const ae=this.l(re,B),ee=await this.h.resolveCompletionItem(re,X);if(!ee)return;const ge=this.l(ee,B);return(ae.h!==ge.h||ae.i!==ge.i)&&this.j.report("CompletionItem.insertText",this.k,"extension MAY NOT change 'insertText' of a CompletionItem during resolve"),(ae.n!==ge.n||ae.o!==ge.o||!(0,F.$en)(ae.p,ge.p))&&this.j.report("CompletionItem.command",this.k,"extension MAY NOT change 'command' of a CompletionItem during resolve"),{...ae,d:ge.d,c:ge.c,l:ge.l,h:ge.h,i:ge.i,n:ge.n,o:ge.o,p:ge.p}}releaseCompletionItems(B){this.e.get(B)?.dispose(),this.e.delete(B),this.d.delete(B)}l(B,X,re,ae){const ee=this.e.get(X[0]);if(!ee)throw Error("DisposableStore is missing...");const ge=this.g.toInternal(B.command,ee),ye={x:X,a:B.label,b:B.kind!==void 0?f.CompletionItemKind.from(B.kind):void 0,m:B.tags&&B.tags.map(f.CompletionItemTag.from),c:B.detail,d:typeof B.documentation>"u"?void 0:f.MarkdownString.fromStrict(B.documentation),e:B.sortText!==B.label?B.sortText:void 0,f:B.filterText!==B.label?B.filterText:void 0,g:B.preselect||void 0,i:B.keepWhitespace?1:0,k:B.commitCharacters?.join(""),l:B.additionalTextEdits&&B.additionalTextEdits.map(f.TextEdit.from),n:ge?.$ident,o:ge?.id,p:ge?.$ident?void 0:ge?.arguments};B.textEdit?(this.j.report("CompletionItem.textEdit",this.k,"Use 'CompletionItem.insertText' and 'CompletionItem.range' instead."),ye.h=B.textEdit.newText):typeof B.insertText=="string"?ye.h=B.insertText:B.insertText instanceof L.$KK&&(ye.h=B.insertText.value,ye.i|=4);let je;return B.textEdit?je=B.textEdit.range:B.range&&(je=B.range),L.$BK.isRange(je)?ye.j=f.Range.from(je):je&&(!re?.isEqual(je.inserting)||!ae?.isEqual(je.replacing))&&(ye.j={insert:f.Range.from(je.inserting),replace:f.Range.from(je.replacing)}),ye}}class Ee{async provideInlineCompletions(B,X,re,ae){}disposeCompletions(B){}handleDidShowCompletionItem(B,X,re){}handlePartialAccept(B,X,re){}}class he extends Ee{constructor(B,X,re,ae){super(),this.f=B,this.g=X,this.h=re,this.j=ae,this.d=new q,this.e=(0,t.$LF)(this.f,"inlineCompletionsAdditions"),this.k={[M.InlineCompletionTriggerKind.Automatic]:L.InlineCompletionTriggerKind.Automatic,[M.InlineCompletionTriggerKind.Explicit]:L.InlineCompletionTriggerKind.Invoke}}get supportsHandleEvents(){return(0,t.$LF)(this.f,"inlineCompletionsAdditions")&&(typeof this.h.handleDidShowCompletionItem=="function"||typeof this.h.handleDidPartiallyAcceptCompletionItem=="function")}async provideInlineCompletions(B,X,re,ae){const ee=this.g.getDocument(B),ge=f.Position.to(X),ye=await this.h.provideInlineCompletionItems(ee,ge,{selectedCompletionInfo:re.selectedSuggestionInfo?{range:f.Range.to(re.selectedSuggestionInfo.range),text:re.selectedSuggestionInfo.text}:void 0,triggerKind:this.k[re.triggerKind]},ae);if(!ye||ae.isCancellationRequested)return;const je=Array.isArray(ye)?ye:ye.items,We=this.e?Array.isArray(ye)?[]:ye.commands||[]:[],et=this.e&&!Array.isArray(ye)?ye.enableForwardStability:void 0;let Ze;return{pid:this.d.createReferenceId({dispose(){Ze?.dispose()},items:je}),items:je.map((nt,Ae)=>{let Oe;nt.command&&(Ze||(Ze=new w.$Qc),Oe=this.j.toInternal(nt.command,Ze));const Ve=nt.insertText;return{insertText:typeof Ve=="string"?Ve:{snippet:Ve.value},filterText:nt.filterText,range:nt.range?f.Range.from(nt.range):void 0,command:Oe,idx:Ae,completeBracketPairs:this.e?nt.completeBracketPairs:!1}}),commands:We.map(nt=>(Ze||(Ze=new w.$Qc),this.j.toInternal(nt,Ze))),suppressSuggestions:!1,enableForwardStability:et}}disposeCompletions(B){this.d.disposeReferenceId(B)?.dispose()}handleDidShowCompletionItem(B,X,re){const ae=this.d.get(B)?.items[X];ae&&this.h.handleDidShowCompletionItem&&this.e&&this.h.handleDidShowCompletionItem(ae,re)}handlePartialAccept(B,X,re){const ae=this.d.get(B)?.items[X];ae&&this.h.handleDidPartiallyAcceptCompletionItem&&this.e&&this.h.handleDidPartiallyAcceptCompletionItem(ae,re)}}class q{constructor(){this.d=new Map,this.e=1}createReferenceId(B){const X=this.e++;return this.d.set(X,B),X}disposeReferenceId(B){const X=this.d.get(B);return this.d.delete(B),X}get(B){return this.d.get(B)}}class U{constructor(B,X){this.e=B,this.f=X,this.d=new i.$Ddc("SignatureHelp")}async provideSignatureHelp(B,X,re,ae){const ee=this.e.getDocument(B),ge=f.Position.to(X),ye=this.g(re),je=await this.f.provideSignatureHelp(ee,ge,ae,ye);if(je){const We=this.d.add([je]);return{...f.SignatureHelp.from(je),id:We}}}g(B){let X;if(B.activeSignatureHelp){const re=f.SignatureHelp.to(B.activeSignatureHelp),ae=this.d.get(B.activeSignatureHelp.id,0);ae?(X=ae,X.activeSignature=re.activeSignature,X.activeParameter=re.activeParameter):X=re}return{...B,activeSignatureHelp:X}}releaseSignatureHelp(B){this.d.delete(B)}}class ie{constructor(B,X,re,ae,ee){this.f=B,this.g=X,this.h=re,this.j=ae,this.k=ee,this.d=new i.$Ddc("InlayHints"),this.e=new Map}async provideInlayHints(B,X,re){const ae=this.f.getDocument(B),ee=f.Range.to(X),ge=await this.h.provideInlayHints(ae,ee,re);if(!Array.isArray(ge)||ge.length===0){this.j.trace(`[InlayHints] NO inlay hints from '${this.k.identifier.value}' for ${X}`);return}if(re.isCancellationRequested)return;const ye=this.d.add(ge);this.e.set(ye,new w.$Qc);const je={hints:[],cacheId:ye};for(let We=0;We<ge.length;We++)this.l(ge[We],ee)&&je.hints.push(this.m(ge[We],[ye,We]));return this.j.trace(`[InlayHints] ${je.hints.length} inlay hints from '${this.k.identifier.value}' for ${X}`),je}async resolveInlayHint(B,X){if(typeof this.h.resolveInlayHint!="function")return;const re=this.d.get(...B);if(!re)return;const ae=await this.h.resolveInlayHint(re,X);if(ae&&this.l(ae))return this.m(ae,B)}releaseHints(B){this.e.get(B)?.dispose(),this.e.delete(B),this.d.delete(B)}l(B,X){return B.label.length===0||Array.isArray(B.label)&&B.label.every(re=>re.value.length===0)?(console.log("INVALID inlay hint, empty label",B),!1):!(X&&!X.contains(B.position))}m(B,X){const re=this.e.get(X[0]);if(!re)throw Error("DisposableStore is missing...");const ae={label:"",cacheId:X,tooltip:f.MarkdownString.fromStrict(B.tooltip),position:f.Position.from(B.position),textEdits:B.textEdits&&B.textEdits.map(f.TextEdit.from),kind:B.kind&&f.InlayHintKind.from(B.kind),paddingLeft:B.paddingLeft,paddingRight:B.paddingRight};return typeof B.label=="string"?ae.label=B.label:ae.label=B.label.map(ee=>{const ge={label:ee.value};return ge.tooltip=f.MarkdownString.fromStrict(ee.tooltip),L.$LK.isLocation(ee.location)&&(ge.location=f.location.from(ee.location)),ee.command&&(ge.command=this.g.toInternal(ee.command,re)),ge}),ae}}class be{constructor(B,X){this.e=B,this.f=X,this.d=new i.$Ddc("DocumentLink")}async provideLinks(B,X){const re=this.e.getDocument(B),ae=await this.f.provideDocumentLinks(re,X);if(!(!Array.isArray(ae)||ae.length===0)&&!X.isCancellationRequested){if(typeof this.f.resolveDocumentLink!="function")return{links:ae.filter(be.g).map(f.DocumentLink.from)};{const ee=this.d.add(ae),ge={links:[],cacheId:ee};for(let ye=0;ye<ae.length;ye++){if(!be.g(ae[ye]))continue;const je=f.DocumentLink.from(ae[ye]);je.cacheId=[ee,ye],ge.links.push(je)}return ge}}}static g(B){return B.target&&B.target.path.length>5e4?(console.warn("DROPPING link because it is too long"),!1):!0}async resolveLink(B,X){if(typeof this.f.resolveDocumentLink!="function")return;const re=this.d.get(...B);if(!re)return;const ae=await this.f.resolveDocumentLink(re,X);if(!(!ae||!be.g(ae)))return f.DocumentLink.from(ae)}releaseLinks(B){this.d.delete(B)}}class H{constructor(B,X){this.d=B,this.e=X}async provideColors(B,X){const re=this.d.getDocument(B),ae=await this.e.provideDocumentColors(re,X);return Array.isArray(ae)?ae.map(ge=>({color:f.Color.from(ge.color),range:f.Range.from(ge.range)})):[]}async provideColorPresentations(B,X,re){const ae=this.d.getDocument(B),ee=f.Range.to(X.range),ge=f.Color.to(X.color),ye=await this.e.provideColorPresentations(ge,{document:ae,range:ee},re);if(Array.isArray(ye))return ye.map(f.ColorPresentation.from)}}class Y{constructor(B,X){this.d=B,this.e=X}async provideFoldingRanges(B,X,re){const ae=this.d.getDocument(B),ee=await this.e.provideFoldingRanges(ae,X,re);if(Array.isArray(ee))return ee.map(f.FoldingRange.from)}}class Z{constructor(B,X,re){this.d=B,this.e=X,this.f=re}async provideSelectionRanges(B,X,re){const ae=this.d.getDocument(B),ee=X.map(f.Position.to),ge=await this.e.provideSelectionRanges(ae,ee,re);if(!(0,A.$Kb)(ge))return[];if(ge.length!==ee.length)return this.f.warn("BAD selection ranges, provider must return ranges for each position"),[];const ye=[];for(let je=0;je<ee.length;je++){const We=[];ye.push(We);let et=ee[je],Ze=ge[je];for(;;){if(!Ze.range.contains(et))throw new Error("INVALID selection range, must contain the previous range");if(We.push(f.SelectionRange.from(Ze)),!Ze.parent)break;et=Ze.range,Ze=Ze.parent}}return ye}}class $e{constructor(B,X){this.f=B,this.g=X,this.d=new o.$EM(""),this.e=new Map}async prepareSession(B,X,re){const ae=this.f.getDocument(B),ee=f.Position.to(X),ge=await this.g.prepareCallHierarchy(ae,ee,re);if(!ge)return;const ye=this.d.nextId();return this.e.set(ye,new Map),Array.isArray(ge)?ge.map(je=>this.h(ye,je)):[this.h(ye,ge)]}async provideCallsTo(B,X,re){const ae=this.j(B,X);if(!ae)throw new Error("missing call hierarchy item");const ee=await this.g.provideCallHierarchyIncomingCalls(ae,re);if(ee)return ee.map(ge=>({from:this.h(B,ge.from),fromRanges:ge.fromRanges.map(ye=>f.Range.from(ye))}))}async provideCallsFrom(B,X,re){const ae=this.j(B,X);if(!ae)throw new Error("missing call hierarchy item");const ee=await this.g.provideCallHierarchyOutgoingCalls(ae,re);if(ee)return ee.map(ge=>({to:this.h(B,ge.to),fromRanges:ge.fromRanges.map(ye=>f.Range.from(ye))}))}releaseSession(B){this.e.delete(B)}h(B,X){const re=this.e.get(B),ae=f.CallHierarchyItem.from(X,B,re.size.toString(36));return re.set(ae._itemId,X),ae}j(B,X){return this.e.get(B)?.get(X)}}class ne{constructor(B,X){this.f=B,this.g=X,this.d=new o.$EM(""),this.e=new Map}async prepareSession(B,X,re){const ae=this.f.getDocument(B),ee=f.Position.to(X),ge=await this.g.prepareTypeHierarchy(ae,ee,re);if(!ge)return;const ye=this.d.nextId();return this.e.set(ye,new Map),Array.isArray(ge)?ge.map(je=>this.h(ye,je)):[this.h(ye,ge)]}async provideSupertypes(B,X,re){const ae=this.j(B,X);if(!ae)throw new Error("missing type hierarchy item");const ee=await this.g.provideTypeHierarchySupertypes(ae,re);if(ee)return ee.map(ge=>this.h(B,ge))}async provideSubtypes(B,X,re){const ae=this.j(B,X);if(!ae)throw new Error("missing type hierarchy item");const ee=await this.g.provideTypeHierarchySubtypes(ae,re);if(ee)return ee.map(ge=>this.h(B,ge))}releaseSession(B){this.e.delete(B)}h(B,X){const re=this.e.get(B),ae=f.TypeHierarchyItem.from(X,B,re.size.toString(36));return re.set(ae._itemId,X),ae}j(B,X){return this.e.get(B)?.get(X)}}class fe{static toInternalProviderId(B,X){return B+"."+X}constructor(B,X,re,ae,ee){this.d=B,this.e=X,this.f=re,this.g=ae,this.h=ee}async provideDocumentOnDropEdits(B,X,re,ae,ee){const ge=this.e.getDocument(X),ye=f.Position.to(re),je=f.DataTransfer.toDataTransfer(ae,async et=>(await this.d.$resolveDocumentOnDropFileData(this.g,B,et)).buffer),We=await this.f.provideDocumentDropEdits(ge,ye,je,ee);if(We)return{label:We.label??(0,s.localize)(1,null,this.h.displayName||this.h.name),yieldTo:We.yieldTo?.map(et=>"mimeType"in et?et:{providerId:fe.toInternalProviderId(et.extensionId,et.providerId)}),insertText:typeof We.insertText=="string"?We.insertText:{snippet:We.insertText.value},additionalEdit:We.additionalEdit?f.WorkspaceEdit.from(We.additionalEdit,void 0):void 0}}}class te{constructor(B,X){this.d=B,this.e=X}async provideMappedEdits(B,X,re,ae){const ee=C.URI.revive(B),ge=this.d.getDocument(ee),ye=re.documents.map(et=>et.map(Ze=>({uri:C.URI.revive(Ze.uri),version:Ze.version,ranges:Ze.ranges.map(rt=>f.Range.to(rt))}))),je={documents:ye,selections:ye[0]?.[0]?.ranges??[]},We=await this.e.provideMappedEdits(ge,X,je,ae);return We?f.WorkspaceEdit.from(We):null}}class de{constructor(B,X){this.adapter=B,this.extension=X}}class pe{static{this.d=0}constructor(B,X,re,ae,ee,ge,ye,je){this.g=X,this.h=re,this.j=ae,this.k=ee,this.l=ge,this.m=ye,this.n=je,this.f=new Map,this.e=B.getProxy(b.$xK.MainThreadLanguageFeatures)}o(B,X){return f.DocumentSelector.from(B,this.g,X)}p(B){return new L.$zK(()=>{this.f.delete(B),this.e.$unregister(B)})}q(){return pe.d++}async s(B,X,re,ae,ee,ge=!1){const ye=this.f.get(B);if(!ye||!(ye.adapter instanceof X))return ae;const je=Date.now();ge||this.l.trace(`[${ye.extension.identifier.value}] INVOKE provider '${re.toString().replace(/[\r\n]/g,"")}'`);const We=re(ye.adapter,ye.extension);return Promise.resolve(We).catch(et=>{(0,r.$3)(et)||(this.l.error(`[${ye.extension.identifier.value}] provider FAILED`),this.l.error(et),this.n.onExtensionError(ye.extension.identifier,et))}).finally(()=>{ge||this.l.trace(`[${ye.extension.identifier.value}] provider DONE after ${Date.now()-je}ms`)}),y.CancellationToken.isCancellationToken(ee)?(0,a.$Ng)(We,ee):We}t(B,X){const re=this.q();return this.f.set(re,new de(B,X)),re}static u(B){return B.displayName||B.name}registerDocumentSymbolProvider(B,X,re,ae){const ee=this.t(new d(this.h,re),B),ge=ae&&ae.label||pe.u(B);return this.e.$registerDocumentSymbolProvider(ee,this.o(X,B),ge),this.p(ee)}$provideDocumentSymbols(B,X,re){return this.s(B,d,ae=>ae.provideDocumentSymbols(C.URI.revive(X),re),void 0,re)}registerCodeLensProvider(B,X,re){const ae=this.q(),ee=typeof re.onDidChangeCodeLenses=="function"?this.q():void 0;this.f.set(ae,new de(new c(this.h,this.j.converter,re),B)),this.e.$registerCodeLensSupport(ae,this.o(X,B),ee);let ge=this.p(ae);if(ee!==void 0){const ye=re.onDidChangeCodeLenses(je=>this.e.$emitCodeLensEvent(ee));ge=L.$zK.from(ge,ye)}return ge}$provideCodeLenses(B,X,re){return this.s(B,c,ae=>ae.provideCodeLenses(C.URI.revive(X),re),void 0,re)}$resolveCodeLens(B,X,re){return this.s(B,c,ae=>ae.resolveCodeLens(X,re),void 0,void 0)}$releaseCodeLenses(B,X){this.s(B,c,re=>Promise.resolve(re.releaseCodeLenses(X)),void 0,void 0)}registerDefinitionProvider(B,X,re){const ae=this.t(new h(this.h,re),B);return this.e.$registerDefinitionSupport(ae,this.o(X,B)),this.p(ae)}$provideDefinition(B,X,re,ae){return this.s(B,h,ee=>ee.provideDefinition(C.URI.revive(X),re,ae),[],ae)}registerDeclarationProvider(B,X,re){const ae=this.t(new E(this.h,re),B);return this.e.$registerDeclarationSupport(ae,this.o(X,B)),this.p(ae)}$provideDeclaration(B,X,re,ae){return this.s(B,E,ee=>ee.provideDeclaration(C.URI.revive(X),re,ae),[],ae)}registerImplementationProvider(B,X,re){const ae=this.t(new D(this.h,re),B);return this.e.$registerImplementationSupport(ae,this.o(X,B)),this.p(ae)}$provideImplementation(B,X,re,ae){return this.s(B,D,ee=>ee.provideImplementation(C.URI.revive(X),re,ae),[],ae)}registerTypeDefinitionProvider(B,X,re){const ae=this.t(new m(this.h,re),B);return this.e.$registerTypeDefinitionSupport(ae,this.o(X,B)),this.p(ae)}$provideTypeDefinition(B,X,re,ae){return this.s(B,m,ee=>ee.provideTypeDefinition(C.URI.revive(X),re,ae),[],ae)}registerHoverProvider(B,X,re,ae){const ee=this.t(new p(this.h,re),B);return this.e.$registerHoverProvider(ee,this.o(X,B)),this.p(ee)}$provideHover(B,X,re,ae){return this.s(B,p,ee=>ee.provideHover(C.URI.revive(X),re,ae),void 0,ae)}registerEvaluatableExpressionProvider(B,X,re,ae){const ee=this.t(new S(this.h,re),B);return this.e.$registerEvaluatableExpressionProvider(ee,this.o(X,B)),this.p(ee)}$provideEvaluatableExpression(B,X,re,ae){return this.s(B,S,ee=>ee.provideEvaluatableExpression(C.URI.revive(X),re,ae),void 0,ae)}registerInlineValuesProvider(B,X,re,ae){const ee=typeof re.onDidChangeInlineValues=="function"?this.q():void 0,ge=this.t(new P(this.h,re),B);this.e.$registerInlineValuesProvider(ge,this.o(X,B),ee);let ye=this.p(ge);if(ee!==void 0){const je=re.onDidChangeInlineValues(We=>this.e.$emitInlineValuesEvent(ee));ye=L.$zK.from(ye,je)}return ye}$provideInlineValues(B,X,re,ae,ee){return this.s(B,P,ge=>ge.provideInlineValues(C.URI.revive(X),re,ae,ee),void 0,ee)}registerDocumentHighlightProvider(B,X,re){const ae=this.t(new z(this.h,re),B);return this.e.$registerDocumentHighlightProvider(ae,this.o(X,B)),this.p(ae)}$provideDocumentHighlights(B,X,re,ae){return this.s(B,z,ee=>ee.provideDocumentHighlights(C.URI.revive(X),re,ae),void 0,ae)}registerLinkedEditingRangeProvider(B,X,re){const ae=this.t(new j(this.h,re),B);return this.e.$registerLinkedEditingRangeProvider(ae,this.o(X,B)),this.p(ae)}$provideLinkedEditingRanges(B,X,re,ae){return this.s(B,j,async ee=>{const ge=await ee.provideLinkedEditingRanges(C.URI.revive(X),re,ae);if(ge)return{ranges:ge.ranges,wordPattern:ge.wordPattern?pe.w(ge.wordPattern):void 0}},void 0,ae)}registerReferenceProvider(B,X,re){const ae=this.t(new R(this.h,re),B);return this.e.$registerReferenceSupport(ae,this.o(X,B)),this.p(ae)}$provideReferences(B,X,re,ae,ee){return this.s(B,R,ge=>ge.provideReferences(C.URI.revive(X),re,ae,ee),void 0,ee)}registerCodeActionProvider(B,X,re,ae){const ee=new w.$Qc,ge=this.t(new T(this.h,this.j.converter,this.k,re,this.l,B,this.m),B);return this.e.$registerQuickFixSupport(ge,this.o(X,B),{providedKinds:ae?.providedCodeActionKinds?.map(ye=>ye.value),documentation:ae?.documentation?.map(ye=>({kind:ye.kind.value,command:this.j.converter.toInternal(ye.command,ee)}))},pe.u(B),!!re.resolveCodeAction),ee.add(this.p(ge)),ee}$provideCodeActions(B,X,re,ae,ee){return this.s(B,T,ge=>ge.provideCodeActions(C.URI.revive(X),re,ae,ee),void 0,ee)}$resolveCodeAction(B,X,re){return this.s(B,T,ae=>ae.resolveCodeAction(X,re),{},void 0)}$releaseCodeActions(B,X){this.s(B,T,re=>Promise.resolve(re.releaseCodeActions(X)),void 0,void 0)}registerDocumentFormattingEditProvider(B,X,re){const ae=this.t(new O(this.h,re),B);return this.e.$registerDocumentFormattingSupport(ae,this.o(X,B),B.identifier,B.displayName||B.name),this.p(ae)}$provideDocumentFormattingEdits(B,X,re,ae){return this.s(B,O,ee=>ee.provideDocumentFormattingEdits(C.URI.revive(X),re,ae),void 0,ae)}registerDocumentRangeFormattingEditProvider(B,X,re){const ae=typeof re.provideDocumentRangesFormattingEdits=="function",ee=this.t(new W(this.h,re),B);return this.e.$registerRangeFormattingSupport(ee,this.o(X,B),B.identifier,B.displayName||B.name,ae),this.p(ee)}$provideDocumentRangeFormattingEdits(B,X,re,ae,ee){return this.s(B,W,ge=>ge.provideDocumentRangeFormattingEdits(C.URI.revive(X),re,ae,ee),void 0,ee)}$provideDocumentRangesFormattingEdits(B,X,re,ae,ee){return this.s(B,W,ge=>ge.provideDocumentRangesFormattingEdits(C.URI.revive(X),re,ae,ee),void 0,ee)}registerOnTypeFormattingEditProvider(B,X,re,ae){const ee=this.t(new x(this.h,re),B);return this.e.$registerOnTypeFormattingSupport(ee,this.o(X,B),ae,B.identifier),this.p(ee)}$provideOnTypeFormattingEdits(B,X,re,ae,ee,ge){return this.s(B,x,ye=>ye.provideOnTypeFormattingEdits(C.URI.revive(X),re,ae,ee,ge),void 0,ge)}registerWorkspaceSymbolProvider(B,X){const re=this.t(new le(X,this.l),B);return this.e.$registerNavigateTypeSupport(re,typeof X.resolveWorkspaceSymbol=="function"),this.p(re)}$provideWorkspaceSymbols(B,X,re){return this.s(B,le,ae=>ae.provideWorkspaceSymbols(X,re),{symbols:[]},re)}$resolveWorkspaceSymbol(B,X,re){return this.s(B,le,ae=>ae.resolveWorkspaceSymbol(X,re),void 0,void 0)}$releaseWorkspaceSymbols(B,X){this.s(B,le,re=>re.releaseWorkspaceSymbols(X),void 0,void 0)}registerRenameProvider(B,X,re){const ae=this.t(new G(this.h,re,this.l),B);return this.e.$registerRenameSupport(ae,this.o(X,B),G.supportsResolving(re)),this.p(ae)}$provideRenameEdits(B,X,re,ae,ee){return this.s(B,G,ge=>ge.provideRenameEdits(C.URI.revive(X),re,ae,ee),void 0,ee)}$resolveRenameLocation(B,X,re,ae){return this.s(B,G,ee=>ee.resolveRenameLocation(C.URI.revive(X),re,ae),void 0,ae)}registerDocumentSemanticTokensProvider(B,X,re,ae){const ee=this.t(new Q(this.h,re),B),ge=typeof re.onDidChangeSemanticTokens=="function"?this.q():void 0;this.e.$registerDocumentSemanticTokensProvider(ee,this.o(X,B),ae,ge);let ye=this.p(ee);if(ge){const je=re.onDidChangeSemanticTokens(We=>this.e.$emitDocumentSemanticTokensEvent(ge));ye=L.$zK.from(ye,je)}return ye}$provideDocumentSemanticTokens(B,X,re,ae){return this.s(B,Q,ee=>ee.provideDocumentSemanticTokens(C.URI.revive(X),re,ae),null,ae)}$releaseDocumentSemanticTokens(B,X){this.s(B,Q,re=>re.releaseDocumentSemanticColoring(X),void 0,void 0)}registerDocumentRangeSemanticTokensProvider(B,X,re,ae){const ee=this.t(new oe(this.h,re),B);return this.e.$registerDocumentRangeSemanticTokensProvider(ee,this.o(X,B),ae),this.p(ee)}$provideDocumentRangeSemanticTokens(B,X,re,ae){return this.s(B,oe,ee=>ee.provideDocumentRangeSemanticTokens(C.URI.revive(X),re,ae),null,ae)}registerCompletionItemProvider(B,X,re,ae){const ee=this.t(new _(this.h,this.j.converter,re,this.m,B),B);return this.e.$registerCompletionsProvider(ee,this.o(X,B),ae,_.supportsResolving(re),B.identifier),this.p(ee)}$provideCompletionItems(B,X,re,ae,ee){return this.s(B,_,ge=>ge.provideCompletionItems(C.URI.revive(X),re,ae,ee),void 0,ee)}$resolveCompletionItem(B,X,re){return this.s(B,_,ae=>ae.resolveCompletionItem(X,re),void 0,re)}$releaseCompletionItems(B,X){this.s(B,_,re=>re.releaseCompletionItems(X),void 0,void 0)}registerInlineCompletionsProvider(B,X,re,ae){const ee=new he(B,this.h,re,this.j.converter),ge=this.t(ee,B);return this.e.$registerInlineCompletionsSupport(ge,this.o(X,B),ee.supportsHandleEvents,k.$_l.toKey(B.identifier.value),ae?.yieldTo?.map(ye=>k.$_l.toKey(ye))||[]),this.p(ge)}$provideInlineCompletions(B,X,re,ae,ee){return this.s(B,Ee,ge=>ge.provideInlineCompletions(C.URI.revive(X),re,ae,ee),void 0,ee)}$handleInlineCompletionDidShow(B,X,re,ae){this.s(B,Ee,async ee=>{ee.handleDidShowCompletionItem(X,re,ae)},void 0,void 0)}$handleInlineCompletionPartialAccept(B,X,re,ae){this.s(B,Ee,async ee=>{ee.handlePartialAccept(X,re,ae)},void 0,void 0)}$freeInlineCompletionsList(B,X){this.s(B,Ee,async re=>{re.disposeCompletions(X)},void 0,void 0)}registerSignatureHelpProvider(B,X,re,ae){const ee=Array.isArray(ae)?{triggerCharacters:ae,retriggerCharacters:[]}:ae,ge=this.t(new U(this.h,re),B);return this.e.$registerSignatureHelpProvider(ge,this.o(X,B),ee),this.p(ge)}$provideSignatureHelp(B,X,re,ae,ee){return this.s(B,U,ge=>ge.provideSignatureHelp(C.URI.revive(X),re,ae,ee),void 0,ee)}$releaseSignatureHelp(B,X){this.s(B,U,re=>re.releaseSignatureHelp(X),void 0,void 0)}registerInlayHintsProvider(B,X,re){const ae=typeof re.onDidChangeInlayHints=="function"?this.q():void 0,ee=this.t(new ie(this.h,this.j.converter,re,this.l,B),B);this.e.$registerInlayHintsProvider(ee,this.o(X,B),typeof re.resolveInlayHint=="function",ae,pe.u(B));let ge=this.p(ee);if(ae!==void 0){const ye=re.onDidChangeInlayHints(je=>this.e.$emitInlayHintsEvent(ae));ge=L.$zK.from(ge,ye)}return ge}$provideInlayHints(B,X,re,ae){return this.s(B,ie,ee=>ee.provideInlayHints(C.URI.revive(X),re,ae),void 0,ae)}$resolveInlayHint(B,X,re){return this.s(B,ie,ae=>ae.resolveInlayHint(X,re),void 0,re)}$releaseInlayHints(B,X){this.s(B,ie,re=>re.releaseHints(X),void 0,void 0)}registerDocumentLinkProvider(B,X,re){const ae=this.t(new be(this.h,re),B);return this.e.$registerDocumentLinkProvider(ae,this.o(X,B),typeof re.resolveDocumentLink=="function"),this.p(ae)}$provideDocumentLinks(B,X,re){return this.s(B,be,ae=>ae.provideLinks(C.URI.revive(X),re),void 0,re,X.scheme==="output")}$resolveDocumentLink(B,X,re){return this.s(B,be,ae=>ae.resolveLink(X,re),void 0,void 0,!0)}$releaseDocumentLinks(B,X){this.s(B,be,re=>re.releaseLinks(X),void 0,void 0,!0)}registerColorProvider(B,X,re){const ae=this.t(new H(this.h,re),B);return this.e.$registerDocumentColorProvider(ae,this.o(X,B)),this.p(ae)}$provideDocumentColors(B,X,re){return this.s(B,H,ae=>ae.provideColors(C.URI.revive(X),re),[],re)}$provideColorPresentations(B,X,re,ae){return this.s(B,H,ee=>ee.provideColorPresentations(C.URI.revive(X),re,ae),void 0,ae)}registerFoldingRangeProvider(B,X,re){const ae=this.q(),ee=typeof re.onDidChangeFoldingRanges=="function"?this.q():void 0;this.f.set(ae,new de(new Y(this.h,re),B)),this.e.$registerFoldingRangeProvider(ae,this.o(X,B),B.identifier,ee);let ge=this.p(ae);if(ee!==void 0){const ye=re.onDidChangeFoldingRanges(()=>this.e.$emitFoldingRangeEvent(ee));ge=L.$zK.from(ge,ye)}return ge}$provideFoldingRanges(B,X,re,ae){return this.s(B,Y,ee=>ee.provideFoldingRanges(C.URI.revive(X),re,ae),void 0,ae)}registerSelectionRangeProvider(B,X,re){const ae=this.t(new Z(this.h,re,this.l),B);return this.e.$registerSelectionRangeProvider(ae,this.o(X,B)),this.p(ae)}$provideSelectionRanges(B,X,re,ae){return this.s(B,Z,ee=>ee.provideSelectionRanges(C.URI.revive(X),re,ae),[],ae)}registerCallHierarchyProvider(B,X,re){const ae=this.t(new $e(this.h,re),B);return this.e.$registerCallHierarchyProvider(ae,this.o(X,B)),this.p(ae)}$prepareCallHierarchy(B,X,re,ae){return this.s(B,$e,ee=>Promise.resolve(ee.prepareSession(C.URI.revive(X),re,ae)),void 0,ae)}$provideCallHierarchyIncomingCalls(B,X,re,ae){return this.s(B,$e,ee=>ee.provideCallsTo(X,re,ae),void 0,ae)}$provideCallHierarchyOutgoingCalls(B,X,re,ae){return this.s(B,$e,ee=>ee.provideCallsFrom(X,re,ae),void 0,ae)}$releaseCallHierarchy(B,X){this.s(B,$e,re=>Promise.resolve(re.releaseSession(X)),void 0,void 0)}registerTypeHierarchyProvider(B,X,re){const ae=this.t(new ne(this.h,re),B);return this.e.$registerTypeHierarchyProvider(ae,this.o(X,B)),this.p(ae)}$prepareTypeHierarchy(B,X,re,ae){return this.s(B,ne,ee=>Promise.resolve(ee.prepareSession(C.URI.revive(X),re,ae)),void 0,ae)}$provideTypeHierarchySupertypes(B,X,re,ae){return this.s(B,ne,ee=>ee.provideSupertypes(X,re,ae),void 0,ae)}$provideTypeHierarchySubtypes(B,X,re,ae){return this.s(B,ne,ee=>ee.provideSubtypes(X,re,ae),void 0,ae)}$releaseTypeHierarchy(B,X){this.s(B,ne,re=>Promise.resolve(re.releaseSession(X)),void 0,void 0)}registerDocumentOnDropEditProvider(B,X,re,ae){const ee=this.q();this.f.set(ee,new de(new fe(this.e,this.h,re,ee,B),B));const ge=(0,t.$LF)(B,"dropMetadata")&&ae?fe.toInternalProviderId(B.identifier.value,ae.id):void 0;return this.e.$registerDocumentOnDropEditProvider(ee,this.o(X,B),ge,(0,t.$LF)(B,"dropMetadata")?ae:void 0),this.p(ee)}$provideDocumentOnDropEdits(B,X,re,ae,ee,ge){return this.s(B,fe,ye=>Promise.resolve(ye.provideDocumentOnDropEdits(X,C.URI.revive(re),ae,ee,ge)),void 0,void 0)}registerMappedEditsProvider(B,X,re){const ae=this.t(new te(this.h,re),B);return this.e.$registerMappedEditsProvider(ae,this.o(X,B)),this.p(ae)}$provideMappedEdits(B,X,re,ae,ee){return this.s(B,te,ge=>Promise.resolve(ge.provideMappedEdits(X,re,ae,ee)),null,ee)}registerDocumentPasteEditProvider(B,X,re,ae){const ee=this.q();this.f.set(ee,new de(new N(this.e,this.h,re,ee,B),B));const ge=N.toInternalProviderId(B.identifier.value,ae.id);return this.e.$registerPasteEditProvider(ee,this.o(X,B),ge,{supportsCopy:!!re.prepareDocumentPaste,supportsPaste:!!re.provideDocumentPasteEdits,copyMimeTypes:ae.copyMimeTypes,pasteMimeTypes:ae.pasteMimeTypes}),this.p(ee)}$prepareDocumentPaste(B,X,re,ae,ee){return this.s(B,N,ge=>ge.prepareDocumentPaste(C.URI.revive(X),re,ae,ee),void 0,ee)}$providePasteEdits(B,X,re,ae,ee,ge){return this.s(B,N,ye=>ye.providePasteEdits(X,C.URI.revive(re),ae,ee,ge),void 0,ge)}static w(B){return{pattern:B.source,flags:B.flags}}static y(B){return{decreaseIndentPattern:pe.w(B.decreaseIndentPattern),increaseIndentPattern:pe.w(B.increaseIndentPattern),indentNextLinePattern:B.indentNextLinePattern?pe.w(B.indentNextLinePattern):void 0,unIndentedLinePattern:B.unIndentedLinePattern?pe.w(B.unIndentedLinePattern):void 0}}static z(B){return{beforeText:pe.w(B.beforeText),afterText:B.afterText?pe.w(B.afterText):void 0,previousLineText:B.previousLineText?pe.w(B.previousLineText):void 0,action:B.action}}static B(B){return B.map(pe.z)}static C(B){return{open:B.open,close:B.close,notIn:B.notIn?B.notIn.map(X=>L.SyntaxTokenType.toString(X)):void 0}}static D(B){return B.map(pe.C)}setLanguageConfiguration(B,X,re){const{wordPattern:ae}=re;if(ae&&(0,v.$Se)(ae))throw new Error(`Invalid language configuration: wordPattern '${ae}' is not allowed to match the empty string.`);ae?this.h.setWordDefinitionFor(X,ae):this.h.setWordDefinitionFor(X,void 0),re.__electricCharacterSupport&&this.m.report("LanguageConfiguration.__electricCharacterSupport",B,"Do not use."),re.__characterPairSupport&&this.m.report("LanguageConfiguration.__characterPairSupport",B,"Do not use.");const ee=this.q(),ge={comments:re.comments,brackets:re.brackets,wordPattern:re.wordPattern?pe.w(re.wordPattern):void 0,indentationRules:re.indentationRules?pe.y(re.indentationRules):void 0,onEnterRules:re.onEnterRules?pe.B(re.onEnterRules):void 0,__electricCharacterSupport:re.__electricCharacterSupport,__characterPairSupport:re.__characterPairSupport,autoClosingPairs:re.autoClosingPairs?pe.D(re.autoClosingPairs):void 0};return this.e.$setLanguageConfiguration(ee,X,ge),this.p(ee)}$setWordDefinitions(B){for(const X of B)this.h.setWordDefinitionFor(X.languageId,new RegExp(X.regexSource,X.regexFlags))}}e.$Ndc=pe}),define(ke[328],Se([1,0,6,15,7,39,12,3,25]),function(me,e,C,F,f,L,M,b,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$afc=void 0;class g{constructor(I,$,y,k){this.c=$,this.d=y,this.e=k,this.b=[],this.f=0,this.g=new Set,this.a=I.getProxy(C.$xK.MainThreadLanguages)}$acceptLanguageIds(I){this.b=I}async getLanguages(){return this.b.slice(0)}async changeLanguage(I,$){await this.a.$changeLanguage(I,$);const y=this.c.getDocumentData(I);if(!y)throw new Error(`document '${I.toString()}' NOT found`);return y.document}async tokenAtPosition(I,$){const y=I.version,k=F.Position.from($),w=await this.a.$tokensAtPosition(I.uri,k),u={type:f.StandardTokenType.Other,range:I.getWordRangeAtPosition($)??new f.$BK($.line,$.character,$.line,$.character)};if(!w)return u;const o={range:F.Range.to(w.range),type:F.TokenType.to(w.type)};return!o.range.contains($)||y!==I.version?u:o}createLanguageStatusItem(I,$,y){const k=this.f++,w=this.a,u=this.g,o=`${I.identifier.value}/${$}`;if(u.has(o))throw new Error(`LanguageStatusItem with id '${$}' ALREADY exists`);u.add(o);const i={selector:y,id:$,name:I.displayName??I.name,severity:f.LanguageStatusSeverity.Information,command:void 0,text:"",detail:"",busy:!1};let n;const r=new b.$Qc,a=()=>{if(n?.dispose(),!u.has(o)){console.warn(`LanguageStatusItem (${$}) from ${I.identifier.value} has been disposed and CANNOT be updated anymore`);return}n=(0,M.$Zg)(()=>{r.clear(),this.a.$setLanguageStatus(k,{id:o,name:i.name??I.displayName??I.name,source:I.displayName??I.name,selector:F.DocumentSelector.from(i.selector,this.e),label:i.text,detail:i.detail??"",severity:i.severity===f.LanguageStatusSeverity.Error?L.default.Error:i.severity===f.LanguageStatusSeverity.Warning?L.default.Warning:L.default.Info,command:i.command&&this.d.toInternal(i.command,r),accessibilityInfo:i.accessibilityInformation,busy:i.busy})},0)},t={dispose(){r.dispose(),n?.dispose(),w.$removeLanguageStatus(k),u.delete(o)},get id(){return i.id},get name(){return i.name},set name(s){i.name=s,a()},get selector(){return i.selector},set selector(s){i.selector=s,a()},get text(){return i.text},set text(s){i.text=s,a()},set text2(s){(0,v.$MF)(I,"languageStatusText"),i.text=s,a()},get text2(){return(0,v.$MF)(I,"languageStatusText"),i.text},get detail(){return i.detail},set detail(s){i.detail=s,a()},get severity(){return i.severity},set severity(s){i.severity=s,a()},get accessibilityInformation(){return i.accessibilityInformation},set accessibilityInformation(s){i.accessibilityInformation=s,a()},get command(){return i.command},set command(s){i.command=s,a()},get busy(){return i.busy},set busy(s){i.busy=s,a()}};return a(),t}}e.$afc=g}),define(ke[115],Se([1,0,11,13,2,5,14,6,27,20]),function(me,e,C,F,f,L,M,b,v,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zec=e.$yec=void 0;let A=class{constructor($,y,k){this.f=k,this.d=new Map,this.a=y.getProxy(b.$xK.MainThreadLocalization),this.b=$.environment.appLanguage,this.c=this.b===C.$g}getMessage($,y){const{message:k,args:w,comment:u}=y;if(this.c)return(0,F.$He)(k,w??{});let o=k;u&&u.length>0&&(o+=`/${Array.isArray(u)?u.join(""):u}`);const i=this.d.get($)?.contents[o];return i||this.f.warn(`Using default string since no string found in i18n bundle that has the key: ${o}`),(0,F.$He)(i??k,w??{})}getBundle($){return this.d.get($)?.contents}getBundleUri($){return this.d.get($)?.uri}async initializeLocalizedMessages($){if(this.c||!$.l10n&&!$.isBuiltin||this.d.has($.identifier.value))return;let y;const k=await this.g($);if(!k){this.f.error(`No bundle location found for extension ${$.identifier.value}`);return}try{const w=await this.a.$fetchBundleContents(k),u=JSON.parse(w);y=$.isBuiltin?u.contents?.bundle:u}catch(w){this.f.error(`Failed to load translations for ${$.identifier.value} from ${k}: ${w.message}`);return}y&&this.d.set($.identifier.value,{contents:y,uri:k})}async g($){if($.isBuiltin){const y=await this.a.$fetchBuiltInBundleUri($.identifier.value,this.b);return f.URI.revive(y)}return $.l10n?f.URI.joinPath($.extensionLocation,$.l10n,`bundle.l10n.${this.b}.json`):void 0}};e.$yec=A,e.$yec=A=He([Be(0,v.$PM),Be(1,g.$zM),Be(2,M.$dj)],A),e.$zec=(0,L.$Vh)("IExtHostLocalizationService")}),define(ke[152],Se([1,0,14,6,27,20,2,54]),function(me,e,C,F,f,L,M,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lfc=void 0;let v=class extends C.$oj{constructor(I,$){super($.logLevel,$.logsLocation,$.loggers.map(y=>(0,b.$sh)(y))),this.r=I.getProxy(F.$xK.MainThreadLogger)}$setLogLevel(I,$){$?this.setLogLevel(M.URI.revive($),I):this.setLogLevel(I)}setVisibility(I,$){super.setVisibility(I,$),this.r.$setVisibility(I,$)}s(I,$,y){return new g(this.r,I,$,y)}};e.$Lfc=v,e.$Lfc=v=He([Be(0,L.$zM),Be(1,f.$PM)],v);class g extends C.$jj{constructor(I,$,y,k){super(k?.logLevel==="always"),this.r=I,this.s=$,this.m=!1,this.n=[],this.setLevel(y),this.r.$createLogger($,k).then(()=>{this.u(this.n),this.m=!0})}g(I,$){const y=[[I,$]];this.m?this.u(y):this.n.push(...y)}u(I){this.r.$log(this.s,I)}flush(){this.r.$flush(this.s)}}}),define(ke[116],Se([1,0,6,5,3,20,22]),function(me,e,C,F,f,L,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bec=e.$Aec=void 0,e.$Aec=(0,F.$Vh)("IExtHostManagedSockets");let b=class{constructor(I){this.b=0,this.c=null,this.d=new Map,this.a=I.getProxy(C.$xK.MainThreadManagedSockets)}setFactory(I,$){for(const y of this.d.values())y.dispose();this.c&&this.a.$unregisterSocketFactory(this.c.socketFactoryId),this.c=new v(I,$),this.a.$registerSocketFactory(this.c.socketFactoryId)}async $openRemoteSocket(I){if(!this.c||this.c.socketFactoryId!==I)throw new Error(`No socket factory with id ${I}`);const $=++this.b,y=await this.c.makeConnection(),k=new f.$Qc;return this.d.set($,new g($,y,k)),k.add((0,f.$Pc)(()=>this.d.delete($))),k.add(y.onDidEnd(()=>{this.a.$onDidManagedSocketEnd($),k.dispose()})),k.add(y.onDidClose(w=>{this.a.$onDidManagedSocketClose($,w?.stack??w?.message),k.dispose()})),k.add(y.onDidReceiveMessage(w=>this.a.$onDidManagedSocketHaveData($,M.$fe.wrap(w)))),$}$remoteSocketWrite(I,$){this.d.get(I)?.actual.send($.buffer)}$remoteSocketEnd(I){const $=this.d.get(I);$&&($.actual.end(),$.dispose())}async $remoteSocketDrain(I){await this.d.get(I)?.actual.drain?.()}};e.$Bec=b,e.$Bec=b=He([Be(0,L.$zM)],b);class v{constructor(I,$){this.socketFactoryId=I,this.makeConnection=$}}class g extends f.$Rc{constructor(I,$,y){super(),this.socketId=I,this.actual=$,this.B(y)}}}),define(ke[329],Se([1,0,6,14,25]),function(me,e,C,F,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bfc=void 0;function L(b){return b&&b.title}let M=class{constructor(v,g){this.b=g,this.a=v.getProxy(C.$xK.MainThreadMessageService)}showMessage(v,g,A,I,$){const y={source:{identifier:v.identifier,label:v.displayName||v.name}};let k;typeof I=="string"||L(I)?k=[I,...$]:(y.modal=I?.modal,y.useCustom=I?.useCustom,y.detail=I?.detail,k=$),y.useCustom&&(0,f.$MF)(v,"resolvers");const w=[];for(let u=0;u<k.length;u++){const o=k[u];if(typeof o=="string")w.push({title:o,handle:u,isCloseAffordance:!1});else if(typeof o=="object"){const{title:i,isCloseAffordance:n}=o;w.push({title:i,isCloseAffordance:!!n,handle:u})}else this.b.warn("Invalid message item:",o)}return this.a.$showMessage(g,A,y,w).then(u=>{if(typeof u=="number")return k[u]})}};e.$bfc=M,e.$bfc=M=He([Be(1,F.$dj)],M)}),define(ke[330],Se([1,0,19,12,21,4,3,28,2,26,14,6,35,15,7,113,286,25,68]),function(me,e,C,F,f,L,M,b,v,g,A,I,$,y,k,w,u,o,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gfc=e.$ffc=void 0;let n=class{constructor(h,E,D,m,p){this.l=E,this.m=D,this.n=m,this.o=p,this.b=new b.$zc,this.c=new b.$zc,this.e=new Map,this.f=0,this.g=new Map,this.h=0,this.i=new Map,this.j=0,this.k=new L.$Rd,this.onDidChangeNotebookCellExecutionState=this.k.event,this.a=h.getProxy(I.$xK.MainThreadNotebookKernels);const S=new $.$ZM("notebook.selectKernel","_notebook.selectKernel","Trigger kernel picker for specified notebook editor widget",[new $.$XM("options","Select kernel options",P=>!0,P=>{if(P&&"notebookEditor"in P&&"id"in P){const z=this.m.getIdByEditor(P.notebookEditor);return{id:P.id,extension:P.extension,notebookEditorId:z}}else if(P&&"notebookEditor"in P){const z=this.m.getIdByEditor(P.notebookEditor);if(z===void 0)throw new Error(`Cannot invoke 'notebook.selectKernel' for unrecognized notebook editor ${P.notebookEditor.notebook.uri.toString()}`);return{notebookEditorId:z}}return P})],$.$YM.Void);this.n.registerApiCommand(S)}createNotebookController(h,E,D,m,p,S){for(const oe of this.i.values())if(oe.controller.id===E&&g.$_l.equals(h.identifier,oe.extensionId))throw new Error(`notebook controller with id '${E}' ALREADY exist`);const P=this.j++,z=this;this.o.trace(`NotebookController[${P}], CREATED by ${h.identifier.value}, ${E}`);const j=()=>console.warn(`NO execute handler from notebook controller '${O.id}' of extension: '${h.identifier}'`);let R=!1;const T=new L.$Rd,N=new L.$Rd,O={id:c(h.identifier,E),notebookType:D,extensionId:h.identifier,extensionLocation:h.extensionLocation,label:m||h.identifier.value,preloads:S?S.map(y.NotebookRendererScript.from):[]};let W=p??j,x;this.a.$addKernel(P,O).catch(oe=>{console.log(oe),R=!0});let le=0;const G=()=>{if(R)return;const oe=++le;Promise.resolve().then(()=>{oe===le&&this.a.$updateKernel(P,O)})},J=new b.$zc,Q={get id(){return E},get notebookType(){return O.notebookType},onDidChangeSelectedNotebooks:T.event,get label(){return O.label},set label(oe){O.label=oe??h.displayName??h.name,G()},get detail(){return O.detail??""},set detail(oe){O.detail=oe,G()},get description(){return O.description??""},set description(oe){O.description=oe,G()},get supportedLanguages(){return O.supportedLanguages},set supportedLanguages(oe){O.supportedLanguages=oe,G()},get supportsExecutionOrder(){return O.supportsExecutionOrder??!1},set supportsExecutionOrder(oe){O.supportsExecutionOrder=oe,G()},get rendererScripts(){return O.preloads?O.preloads.map(y.NotebookRendererScript.to):[]},get executeHandler(){return W},set executeHandler(oe){W=oe??j},get interruptHandler(){return x},set interruptHandler(oe){x=oe,O.supportsInterrupt=!!oe,G()},createNotebookCellExecution(oe){if(R)throw new Error("notebook controller is DISPOSED");if(!J.has(oe.notebook.uri))throw z.o.trace(`NotebookController[${P}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(J.keys()).map(_=>_.toString())),new Error(`notebook controller is NOT associated to notebook: ${oe.notebook.uri.toString()}`);return z._createNotebookCellExecution(oe,c(h.identifier,this.id))},createNotebookExecution(oe){if((0,o.$MF)(h,"notebookExecution"),R)throw new Error("notebook controller is DISPOSED");if(!J.has(oe.uri))throw z.o.trace(`NotebookController[${P}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(J.keys()).map(_=>_.toString())),new Error(`notebook controller is NOT associated to notebook: ${oe.uri.toString()}`);return z._createNotebookExecution(oe,c(h.identifier,this.id))},dispose:()=>{R||(this.o.trace(`NotebookController[${P}], DISPOSED`),R=!0,this.i.delete(P),T.dispose(),N.dispose(),this.a.$removeKernel(P))},updateNotebookAffinity(oe,_){_===k.NotebookControllerAffinity2.Hidden&&(0,o.$MF)(h,"notebookControllerAffinityHidden"),z.a.$updateNotebookPriority(P,oe.uri,_)},onDidReceiveMessage:N.event,postMessage(oe,_){return(0,o.$MF)(h,"notebookMessaging"),z.a.$postMessage(P,_&&z.m.getIdByEditor(_),oe)},asWebviewUri(oe){return(0,o.$MF)(h,"notebookMessaging"),(0,w.$$tb)(oe,z.l.remote)}};return this.i.set(P,{extensionId:h.identifier,controller:Q,onDidReceiveMessage:N,onDidChangeSelection:T,associatedNotebooks:J}),Q}getIdByController(h){for(const[E,D]of this.i)if(D.controller===h)return c(D.extensionId,h.id);return null}createNotebookControllerDetectionTask(h,E){const D=this.f++,m=this;this.o.trace(`NotebookControllerDetectionTask[${D}], CREATED by ${h.identifier.value}`),this.a.$addKernelDetectionTask(D,E);const p={dispose:()=>{this.e.delete(D),m.a.$removeKernelDetectionTask(D)}};return this.e.set(D,p),p}registerKernelSourceActionProvider(h,E,D){const m=this.h++,p=typeof D.onDidChangeNotebookKernelSourceActions=="function"?m:void 0,S=this;this.g.set(m,D),this.o.trace(`NotebookKernelSourceActionProvider[${m}], CREATED by ${h.identifier.value}`),this.a.$addKernelSourceActionProvider(m,m,E);let P;return p!==void 0&&(P=D.onDidChangeNotebookKernelSourceActions(z=>this.a.$emitNotebookKernelSourceActionsChangeEvent(p))),{dispose:()=>{this.g.delete(m),S.a.$removeKernelSourceActionProvider(m,m),P?.dispose()}}}async $provideKernelSourceActions(h,E){const D=this.g.get(h);if(D){const m=new M.$Qc;return(await D.provideNotebookKernelSourceActions(E)??[]).map(S=>y.NotebookKernelSourceAction.from(S,this.n.converter,m))}return[]}$acceptNotebookAssociation(h,E,D){const m=this.i.get(h);if(m){const p=this.m.getNotebookDocument(v.URI.revive(E));D?m.associatedNotebooks.set(p.uri,!0):m.associatedNotebooks.delete(p.uri),this.o.trace(`NotebookController[${h}] ASSOCIATE notebook`,p.uri.toString(),D),m.onDidChangeSelection.fire({selected:D,notebook:p.apiNotebook})}}async $executeCells(h,E,D){const m=this.i.get(h);if(!m)return;const p=this.m.getNotebookDocument(v.URI.revive(E)),S=[];for(const P of D){const z=p.getCell(P);z&&S.push(z.apiCell)}try{this.o.trace(`NotebookController[${h}] EXECUTE cells`,p.uri.toString(),S.length),await m.controller.executeHandler.call(m.controller,S,p.apiNotebook,m.controller)}catch(P){this.o.error(`NotebookController[${h}] execute cells FAILED`,P),console.error(P)}}async $cancelCells(h,E,D){const m=this.i.get(h);if(!m)return;const p=this.m.getNotebookDocument(v.URI.revive(E));if(m.controller.interruptHandler)await m.controller.interruptHandler.call(m.controller,p.apiNotebook);else for(const S of D){const P=p.getCell(S);P&&this.b.get(P.uri)?.cancel()}if(m.controller.interruptHandler){const S=this.c.get(p.uri);D.length&&Array.isArray(S)&&S.length&&S.forEach(P=>P.dispose())}}$acceptKernelMessageFromRenderer(h,E,D){const m=this.i.get(h);if(!m)return;const p=this.m.getEditorById(E);m.onDidReceiveMessage.fire(Object.freeze({editor:p.apiEditor,message:D}))}$cellExecutionChanged(h,E,D){const p=this.m.getNotebookDocument(v.URI.revive(h)).getCell(E);if(p){const S=D?y.NotebookCellExecutionState.to(D):k.NotebookCellExecutionState.Idle;S!==void 0&&this.k.fire({cell:p.apiCell,state:S})}}_createNotebookCellExecution(h,E){if(h.index<0)throw new Error("CANNOT execute cell that has been REMOVED from notebook");const m=this.m.getNotebookDocument(h.notebook.uri).getCellFromApiCell(h);if(!m)throw new Error("invalid cell");if(this.b.has(m.uri))throw new Error(`duplicate execution for ${m.uri}`);const p=new a(E,m,this.a);this.b.set(m.uri,p);const S=p.onDidChangeState(()=>{p.state===r.Resolved&&(p.dispose(),S.dispose(),this.b.delete(m.uri))});return p.asApiObject()}_createNotebookExecution(h,E){const D=this.m.getNotebookDocument(h.uri),m=h.getCells().find(P=>{const z=D.getCellFromApiCell(P);return z&&this.b.has(z.uri)});if(m)throw new Error(`duplicate cell execution for ${m.document.uri}`);if(this.c.has(D.uri))throw new Error(`duplicate notebook execution for ${D.uri}`);const p=new s(E,D,this.a),S=p.onDidChangeState(()=>{p.state===t.Resolved&&(p.dispose(),S.dispose(),this.c.delete(D.uri))});return this.c.set(D.uri,[p,S]),p.asApiObject()}};e.$ffc=n,e.$ffc=n=He([Be(4,A.$dj)],n);var r;(function(l){l[l.Init=0]="Init",l[l.Started=1]="Started",l[l.Resolved=2]="Resolved"})(r||(r={}));class a extends M.$Rc{static{this.a=0}get state(){return this.f}constructor(h,E,D){super(),this.m=E,this.n=D,this.b=a.a++,this.c=new L.$Rd,this.onDidChangeState=this.c.event,this.f=r.Init,this.g=this.B(new f.$2d),this.h=new d(10,m=>this.s(m)),this.j=E.internalMetadata.executionOrder,this.n.$createExecution(this.b,h,this.m.notebook.uri,this.m.handle)}cancel(){this.g.cancel()}async r(h){await this.h.addItem(h)}async s(h){const E=Array.isArray(h)?h:[h];return this.n.$updateExecution(this.b,new i.$wv(E))}t(){if(this.f===r.Init)throw new Error("Must call start before modifying cell output");if(this.f===r.Resolved)throw new Error("Cannot modify cell output after calling resolve")}w(h){let E=this.m;if(h&&(E=this.m.notebook.getCellFromApiCell(h)),!E)throw new Error("INVALID cell");return E.handle}y(h){return h.map(E=>{const D=k.$1L.ensureUniqueMimeTypes(E.items,!0);return D===E.items?y.NotebookCellOutput.from(E):y.NotebookCellOutput.from({items:D,id:E.id,metadata:E.metadata})})}async z(h,E,D){const m=this.w(E),p=this.y((0,C.$2b)(h));return this.r({editType:u.CellExecutionUpdateType.Output,cellHandle:m,append:D,outputs:p})}async C(h,E,D){return h=k.$1L.ensureUniqueMimeTypes((0,C.$2b)(h),!0),this.r({editType:u.CellExecutionUpdateType.OutputItems,items:h.map(y.NotebookCellOutputItem.from),outputId:E.id,append:D})}asApiObject(){const h=this;return Object.freeze({get token(){return h.g.token},get cell(){return h.m.apiCell},get executionOrder(){return h.j},set executionOrder(D){h.j=D,h.s([{editType:u.CellExecutionUpdateType.ExecutionState,executionOrder:h.j}])},start(D){if(h.f===r.Resolved||h.f===r.Started)throw new Error("Cannot call start again");h.f=r.Started,h.c.fire(),h.s({editType:u.CellExecutionUpdateType.ExecutionState,runStartTime:D})},end(D,m){if(h.f===r.Resolved)throw new Error("Cannot call resolve twice");h.f=r.Resolved,h.c.fire(),h.h.flush(),h.n.$completeExecution(h.b,new i.$wv({runEndTime:m,lastRunSuccess:D}))},clearOutput(D){return h.t(),h.z([],D,!1)},appendOutput(D,m){return h.t(),h.z(D,m,!0)},replaceOutput(D,m){return h.t(),h.z(D,m,!1)},appendOutputItems(D,m){return h.t(),h.C(D,m,!0)},replaceOutputItems(D,m){return h.t(),h.C(D,m,!1)}})}}var t;(function(l){l[l.Init=0]="Init",l[l.Started=1]="Started",l[l.Resolved=2]="Resolved"})(t||(t={}));class s extends M.$Rc{static{this.a=0}get state(){return this.f}constructor(h,E,D){super(),this.h=E,this.j=D,this.b=s.a++,this.c=new L.$Rd,this.onDidChangeState=this.c.event,this.f=t.Init,this.g=this.B(new f.$2d),this.j.$createNotebookExecution(this.b,h,this.h.uri)}cancel(){this.g.cancel()}asApiObject(){return Object.freeze({start:()=>{if(this.f===t.Resolved||this.f===t.Started)throw new Error("Cannot call start again");this.f=t.Started,this.c.fire(),this.j.$beginNotebookExecution(this.b)},end:()=>{if(this.f===t.Resolved)throw new Error("Cannot call resolve twice");this.f=t.Resolved,this.c.fire(),this.j.$completeNotebookExecution(this.b)}})}}class d{constructor(h,E){this.e=h,this.f=E,this.a=[],this.b=Date.now()}addItem(h){return this.a.push(h),this.c||(this.c=new F.$ih,this.b=Date.now(),(0,F.$Yg)(this.e).then(()=>this.flush())),Date.now()-this.b>this.e?this.flush():this.c.p}flush(){if(this.a.length===0||!this.c)return Promise.resolve();const h=this.c;this.c=void 0;const E=this.a;return this.a=[],this.f(E).finally(()=>h.complete())}}function c(l,h){return`${l.value}/${h}`}e.$gfc=c}),define(ke[331],Se([1,0,4,6,148]),function(me,e,C,F,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hfc=void 0;class L{constructor(b,v){this.c=v,this.a=new Map,this.b=b.getProxy(F.$xK.MainThreadNotebookRenderers)}$postRendererMessage(b,v,g){const A=this.c.getEditorById(b);this.a.get(v)?.fire({editor:A.apiEditor,message:g})}createRendererMessaging(b,v){if(!b.contributes?.notebookRenderer?.some(A=>A.id===v))throw new Error(`Extensions may only call createRendererMessaging() for renderers they contribute (got ${v})`);return{onDidReceiveMessage:(A,I,$)=>this.d(v).event(A,I,$),postMessage:(A,I)=>{f.$Zec.apiEditorsToExtHost.has(A)&&([A,I]=[I,A]);const $=I&&f.$Zec.apiEditorsToExtHost.get(I);return this.b.$postMessage($?.id,v,A)}}}d(b){let v=this.a.get(b);return v||(v=new C.$Rd({onDidRemoveLastListener:()=>{v?.dispose(),this.a.delete(b)}}),this.a.set(b,v),v)}}e.$hfc=L}),define(ke[332],Se([1,0,3,18,2,25,6]),function(me,e,C,F,f,L,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kfc=void 0;class b{constructor(g){this.b=new Map,this.a=g.getProxy(M.$xK.MainThreadProfileContentHandlers)}registrProfileContentHandler(g,A,I){if((0,L.$MF)(g,"profileContentHandlers"),this.b.has(A))throw new Error(`Handler with id '${A}' already registered`);return this.b.set(A,I),this.a.$registerProfileContentHandler(A,I.name,I.description,g.identifier.value),(0,C.$Pc)(()=>{this.b.delete(A),this.a.$unregisterProfileContentHandler(A)})}async $saveProfile(g,A,I,$){const y=this.b.get(g);if(!y)throw new Error(`Unknown handler with id: ${g}`);return y.saveProfile(A,I,$)}async $readProfile(g,A,I){const $=this.b.get(g);if(!$)throw new Error(`Unknown handler with id: ${g}`);return $.readProfile((0,F.$Cf)(A)?A:f.URI.revive(A),I)}}e.$kfc=b}),define(ke[333],Se([1,0,2,6,12,15]),function(me,e,C,F,f,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mfc=void 0;class M{static{this.a=0}constructor(v,g){this.d=g,this.c=new Map,this.b=v.getProxy(F.$xK.MainThreadQuickDiff)}$provideOriginalResource(v,g,A){const I=C.URI.revive(g),$=this.c.get(v);return $?(0,f.$Qg)(()=>$.provideOriginalResource(I,A)).then(y=>y||null):Promise.resolve(null)}registerQuickDiffProvider(v,g,A,I){const $=M.a++;return this.c.set($,g),this.b.$registerQuickDiffProvider($,L.DocumentSelector.from(v,this.d),A,I),{dispose:()=>{this.b.$unregisterQuickDiffProvider($),this.c.delete($)}}}}e.$mfc=M}),define(ke[334],Se([1,0,21,4,3,6,2,7,8,19,39,61,25,15]),function(me,e,C,F,f,L,M,b,v,g,A,I,$,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nfc=void 0;function k(w,u,o){const i=w.getProxy(L.$xK.MainThreadQuickOpen);class n{constructor(E,D){this.e=new Map,this.f=0,this.a=E,this.b=D}showQuickPick(E,D,m,p=C.CancellationToken.None){this.c=void 0;const S=Promise.resolve(D),P=++this.f,z=i.$show(P,{title:m?.title,placeHolder:m?.placeHolder,matchOnDescription:m?.matchOnDescription,matchOnDetail:m?.matchOnDetail,ignoreFocusLost:m?.ignoreFocusOut,canPickMany:m?.canPickMany},p),j={},R=z.then(()=>j);return Promise.race([R,S]).then(T=>{if(T===j)return;const N=(0,$.$LF)(E,"quickPickItemTooltip");return S.then(O=>{const W=[];for(let x=0;x<O.length;x++){const le=O[x];if(typeof le=="string")W.push({label:le,handle:x});else if(le.kind===b.QuickPickItemKind.Separator)W.push({type:"separator",label:le.label});else{le.tooltip&&!N&&console.warn(`Extension '${E.identifier.value}' uses a tooltip which is proposed API that is only available when running out of dev or with the following command line switch: --enable-proposed-api ${E.identifier.value}`);const G=le.iconPath?d(le.iconPath):void 0;W.push({label:le.label,iconPath:G?.iconPath,iconClass:G?.iconClass,description:le.description,detail:le.detail,picked:le.picked,alwaysShow:le.alwaysShow,tooltip:N?y.MarkdownString.fromStrict(le.tooltip):void 0,handle:x})}}return m&&typeof m.onDidSelectItem=="function"&&(this.c=x=>{m.onDidSelectItem(O[x])}),i.$setItems(P,W),z.then(x=>{if(typeof x=="number")return O[x];if(Array.isArray(x))return x.map(le=>O[le])})})}).then(void 0,T=>{if(!(0,v.$3)(T))return i.$setError(P,T),Promise.reject(T)})}$onItemSelected(E){this.c?.(E)}showInput(E,D=C.CancellationToken.None){return this.d=E?.validateInput,i.$input(E,typeof this.d=="function",D).then(void 0,m=>{if(!(0,v.$3)(m))return Promise.reject(m)})}async $validateInput(E){if(!this.d)return;const D=await this.d(E);if(!D||typeof D=="string")return D;let m;switch(D.severity){case b.InputBoxValidationSeverity.Info:m=A.default.Info;break;case b.InputBoxValidationSeverity.Warning:m=A.default.Warning;break;case b.InputBoxValidationSeverity.Error:m=A.default.Error;break;default:m=D.message?A.default.Error:A.default.Ignore;break}return{content:D.message,severity:m}}async showWorkspaceFolderPick(E,D=C.CancellationToken.None){const m=await this.b.executeCommand("_workbench.pickWorkspaceFolder",[E]);if(!m)return;const p=await this.a.getWorkspaceFolders2();if(p)return p.find(S=>S.uri.toString()===m.uri.toString())}createQuickPick(E){const D=new c(E,()=>this.e.delete(D._id));return this.e.set(D._id,D),D}createInputBox(E){const D=new l(E,()=>this.e.delete(D._id));return this.e.set(D._id,D),D}$onDidChangeValue(E,D){this.e.get(E)?._fireDidChangeValue(D)}$onDidAccept(E){this.e.get(E)?._fireDidAccept()}$onDidChangeActive(E,D){const m=this.e.get(E);m instanceof c&&m._fireDidChangeActive(D)}$onDidChangeSelection(E,D){const m=this.e.get(E);m instanceof c&&m._fireDidChangeSelection(D)}$onDidTriggerButton(E,D){this.e.get(E)?._fireDidTriggerButton(D)}$onDidTriggerItemButton(E,D,m){const p=this.e.get(E);p instanceof c&&p._fireDidTriggerItemButton(D,m)}$onDidHide(E){this.e.get(E)?._fireDidHide()}}class r{static{this.a=1}constructor(E,D){this.x=E,this.y=D,this._id=c.a++,this.e=!1,this.f=!1,this.g=!0,this.j=!1,this.k=!0,this.l="",this.n=[],this.o=new Map,this.p=new F.$Rd,this.q=new F.$Rd,this.r=new F.$Rd,this.s=new F.$Rd,this.u={id:this._id},this.v=!1,this.w=[this.r,this.s,this.p,this.q],this.onDidChangeValue=this.q.event,this.onDidAccept=this.p.event,this.onDidTriggerButton=this.r.event,this.onDidHide=this.s.event}get title(){return this.b}set title(E){this.b=E,this.z({title:E})}get step(){return this.c}set step(E){this.c=E,this.z({step:E})}get totalSteps(){return this.d}set totalSteps(E){this.d=E,this.z({totalSteps:E})}get enabled(){return this.g}set enabled(E){this.g=E,this.z({enabled:E})}get busy(){return this.j}set busy(E){this.j=E,this.z({busy:E})}get ignoreFocusOut(){return this.k}set ignoreFocusOut(E){this.k=E,this.z({ignoreFocusOut:E})}get value(){return this.l}set value(E){this.l=E,this.z({value:E})}get placeholder(){return this.m}set placeholder(E){this.m=E,this.z({placeholder:E})}get buttons(){return this.n}set buttons(E){this.n=E.slice(),this.o.clear(),E.forEach((D,m)=>{const p=D===b.$TL.Back?-1:m;this.o.set(p,D)}),this.z({buttons:E.map((D,m)=>({...d(D.iconPath),tooltip:D.tooltip,handle:D===b.$TL.Back?-1:m}))})}show(){this.e=!0,this.f=!0,this.z({visible:!0})}hide(){this.e=!1,this.z({visible:!1})}_fireDidAccept(){this.p.fire()}_fireDidChangeValue(E){this.l=E,this.q.fire(E)}_fireDidTriggerButton(E){const D=this.o.get(E);D&&this.r.fire(D)}_fireDidHide(){this.f&&(this.f=this.e,this.s.fire())}dispose(){this.v||(this.v=!0,this._fireDidHide(),this.w=(0,f.$Mc)(this.w),this.t&&(clearTimeout(this.t),this.t=void 0),this.y(),i.$dispose(this._id))}z(E){if(!this.v){for(const D of Object.keys(E)){const m=E[D];this.u[D]=m===void 0?null:m}"visible"in this.u?(this.t&&(clearTimeout(this.t),this.t=void 0),this.A()):this.e&&!this.t&&(this.t=setTimeout(()=>{this.t=void 0,this.A()},0))}}A(){i.$createOrUpdate(this.u),this.u={id:this._id}}}function a(h){if(h instanceof b.$tL)return{id:h.id};const E=s(h),D=t(h);return{dark:typeof E=="string"?M.URI.file(E):E,light:typeof D=="string"?M.URI.file(D):D}}function t(h){return typeof h=="object"&&"light"in h?h.light:h}function s(h){return typeof h=="object"&&"dark"in h?h.dark:h}function d(h){const E=a(h);let D,m;return"id"in E?m=I.ThemeIcon.asClassName(E):D=E,{iconPath:D,iconClass:m}}class c extends r{constructor(E,D){super(E.identifier,D),this.O=E,this.B=[],this.C=new Map,this.D=new Map,this.E=!1,this.F=!0,this.G=!0,this.H=!0,this.I=!1,this.J=[],this.K=new F.$Rd,this.L=[],this.M=new F.$Rd,this.N=new F.$Rd,this.onDidChangeActive=this.K.event,this.onDidChangeSelection=this.M.event,this.onDidTriggerItemButton=this.N.event,this.w.push(this.K,this.M,this.N),this.z({type:"quickPick"})}get items(){return this.B}set items(E){this.B=E.slice(),this.C.clear(),this.D.clear(),E.forEach((p,S)=>{this.C.set(S,p),this.D.set(p,S)});const D=(0,$.$LF)(this.O,"quickPickItemTooltip"),m=[];for(let p=0;p<E.length;p++){const S=E[p];if(S.kind===b.QuickPickItemKind.Separator)m.push({type:"separator",label:S.label});else{S.tooltip&&!D&&console.warn(`Extension '${this.O.identifier.value}' uses a tooltip which is proposed API that is only available when running out of dev or with the following command line switch: --enable-proposed-api ${this.O.identifier.value}`);const P=S.iconPath?d(S.iconPath):void 0;m.push({handle:p,label:S.label,iconPath:P?.iconPath,iconClass:P?.iconClass,description:S.description,detail:S.detail,picked:S.picked,alwaysShow:S.alwaysShow,tooltip:D?y.MarkdownString.fromStrict(S.tooltip):void 0,buttons:S.buttons?.map((z,j)=>({...d(z.iconPath),tooltip:z.tooltip,handle:j}))})}}this.z({items:m})}get canSelectMany(){return this.E}set canSelectMany(E){this.E=E,this.z({canSelectMany:E})}get matchOnDescription(){return this.F}set matchOnDescription(E){this.F=E,this.z({matchOnDescription:E})}get matchOnDetail(){return this.G}set matchOnDetail(E){this.G=E,this.z({matchOnDetail:E})}get sortByLabel(){return this.H}set sortByLabel(E){this.H=E,this.z({sortByLabel:E})}get keepScrollPosition(){return this.I}set keepScrollPosition(E){this.I=E,this.z({keepScrollPosition:E})}get activeItems(){return this.J}set activeItems(E){this.J=E.filter(D=>this.D.has(D)),this.z({activeItems:this.J.map(D=>this.D.get(D))})}get selectedItems(){return this.L}set selectedItems(E){this.L=E.filter(D=>this.D.has(D)),this.z({selectedItems:this.L.map(D=>this.D.get(D))})}_fireDidChangeActive(E){const D=(0,g.$Gb)(E.map(m=>this.C.get(m)));this.J=D,this.K.fire(D)}_fireDidChangeSelection(E){const D=(0,g.$Gb)(E.map(m=>this.C.get(m)));this.L=D,this.M.fire(D)}_fireDidTriggerItemButton(E,D){const m=this.C.get(E);if(!m||!m.buttons||!m.buttons.length)return;const p=m.buttons[D];p&&this.N.fire({button:p,item:m})}}class l extends r{constructor(E,D){super(E.identifier,D),this.B=!1,this.z({type:"inputBox"})}get password(){return this.B}set password(E){this.B=E,this.z({password:E})}get prompt(){return this.C}set prompt(E){this.C=E,this.z({prompt:E})}get valueSelection(){return this.D}set valueSelection(E){this.D=E,this.z({valueSelection:E})}get validationMessage(){return this.E}set validationMessage(E){this.E=E,E?typeof E=="string"?this.z({validationMessage:E,severity:A.default.Error}):this.z({validationMessage:E.message,severity:E.severity??A.default.Error}):this.z({validationMessage:void 0,severity:A.default.Ignore})}}return new n(u,o)}e.$nfc=k}),define(ke[335],Se([1,0,2,4,59,3,12,6,19,129,14,26,61,15,25,17,11]),function(me,e,C,F,f,L,M,b,v,g,A,I,$,y,k,w,u){"use strict";var o;Object.defineProperty(e,"__esModule",{value:!0}),e.$pfc=e.$ofc=void 0;function i(j){return j instanceof C.URI}function n(j,R){return j.scheme===w.Schemas.file&&R.scheme===w.Schemas.file&&u.$k?j.toString()===R.toString():j.toString().toLowerCase()===R.toString().toLowerCase()}function r(j){if(j)return typeof j.iconPath=="string"?C.URI.file(j.iconPath):C.URI.isUri(j.iconPath)||$.ThemeIcon.isThemeIcon(j.iconPath)?j.iconPath:void 0}function a(j){if(j?.icon){if(C.URI.isUri(j.icon))return j.icon;if($.ThemeIcon.isThemeIcon(j.icon))return j.icon;{const R=j.icon;return{light:R.light,dark:R.dark}}}else return}function t(j){if(j.icon){if(C.URI.isUri(j.icon))return j.icon;if($.ThemeIcon.isThemeIcon(j.icon))return j.icon;{const R=j.icon;return{light:R.light,dark:R.dark}}}else return}function s(j,R){if(!j.iconPath&&!R.iconPath)return 0;if(j.iconPath){if(!R.iconPath)return 1}else return-1;const T=typeof j.iconPath=="string"?j.iconPath:C.URI.isUri(j.iconPath)?j.iconPath.fsPath:j.iconPath.id,N=typeof R.iconPath=="string"?R.iconPath:C.URI.isUri(R.iconPath)?R.iconPath.fsPath:R.iconPath.id;return(0,g.$xq)(T,N)}function d(j,R){let T=0;if(j.strikeThrough!==R.strikeThrough)return j.strikeThrough?1:-1;if(j.faded!==R.faded)return j.faded?1:-1;if(j.tooltip!==R.tooltip)return(j.tooltip||"").localeCompare(R.tooltip||"");if(T=s(j,R),T!==0)return T;if(j.light&&R.light)T=s(j.light,R.light);else{if(j.light)return 1;if(R.light)return-1}if(T!==0)return T;if(j.dark&&R.dark)T=s(j.dark,R.dark);else{if(j.dark)return 1;if(R.dark)return-1}return T}function c(j,R){if(j.command!==R.command)return j.command<R.command?-1:1;if(j.title!==R.title)return j.title<R.title?-1:1;if(j.tooltip!==R.tooltip){if(j.tooltip!==void 0&&R.tooltip!==void 0)return j.tooltip<R.tooltip?-1:1;if(j.tooltip!==void 0)return 1;if(R.tooltip!==void 0)return-1}if(j.arguments===R.arguments)return 0;if(j.arguments)if(R.arguments){if(j.arguments.length!==R.arguments.length)return j.arguments.length-R.arguments.length}else return 1;else return-1;for(let T=0;T<j.arguments.length;T++){const N=j.arguments[T],O=R.arguments[T];if(N!==O&&!(i(N)&&i(O)&&n(N,O)))return N<O?-1:1}return 0}function l(j,R){let T=(0,g.$xq)(j.resourceUri.fsPath,R.resourceUri.fsPath,!0);if(T!==0)return T;if(j.command&&R.command)T=c(j.command,R.command);else{if(j.command)return 1;if(R.command)return-1}if(T!==0)return T;if(j.decorations&&R.decorations)T=d(j.decorations,R.decorations);else{if(j.decorations)return 1;if(R.decorations)return-1}return T}function h(j,R){for(let T=0;T<j.length;T++)if(j[T]!==R[T])return!1;return!0}function E(j,R){return j.command===R.command&&j.title===R.title&&j.tooltip===R.tooltip&&(j.arguments&&R.arguments?h(j.arguments,R.arguments):j.arguments===R.arguments)}function D(j,R){return(0,v.$tb)(j,R,E)}function m(j,R){return j===R?!0:!j||!R?!1:j.id===R.id&&j.label===R.label&&j.upstream?.id===R.upstream?.id&&j.upstream?.label===R.upstream?.label}class p{#e;#t;get value(){return this.d}set value(R){R=R??"",this.#e.$setInputBoxValue(this.o,R),this.q(R)}get onDidChange(){return this.e.event}get placeholder(){return this.f}set placeholder(R){this.#e.$setInputBoxPlaceholder(this.o,R),this.f=R}get validateInput(){return(0,k.$MF)(this.m,"scmValidation"),this.g}set validateInput(R){if((0,k.$MF)(this.m,"scmValidation"),R&&typeof R!="function")throw new Error(`[${this.m.identifier.value}]: Invalid SCM input box validation function`);this.g=R,this.#e.$setValidationProviderIsEnabled(this.o,!!R)}get enabled(){return this.h}set enabled(R){R=!!R,this.h!==R&&(this.h=R,this.#e.$setInputBoxEnablement(this.o,R))}get visible(){return this.j}set visible(R){R=!!R,this.j!==R&&(this.j=R,this.#e.$setInputBoxVisibility(this.o,R))}get actionButton(){return(0,k.$MF)(this.m,"scmInputBoxActionButton"),this.k}set actionButton(R){(0,k.$MF)(this.m,"scmInputBoxActionButton"),this.l.value=new L.$Qc,this.k=R;const T=R!==void 0?{command:this.n.converter.toInternal(R.command,this.l.value),icon:a(R),enabled:R.enabled}:void 0;this.#e.$setInputBoxActionButton(this.o,T??null)}get document(){return(0,k.$MF)(this.m,"scmTextDocument"),this.#t.getDocument(this.p)}constructor(R,T,N,O,W,x){this.m=R,this.n=T,this.o=W,this.p=x,this.d="",this.e=new F.$Rd,this.f="",this.h=!0,this.j=!0,this.l=new L.$Sc,this.#t=N,this.#e=O}showValidationMessage(R,T){(0,k.$MF)(this.m,"scmValidation"),this.#e.$showValidationMessage(this.o,R,T)}$onInputBoxValueChange(R){this.q(R)}q(R){this.d=R,this.e.fire(R)}}e.$ofc=p;class S{static{this.d=0}get disposed(){return this.l}get id(){return this.u}get label(){return this.v}set label(R){this.v=R,this.q.$updateGroupLabel(this.t,this.handle,R)}get hideWhenEmpty(){return this.p}set hideWhenEmpty(R){this.p=R,this.q.$updateGroup(this.t,this.handle,this.features)}get features(){return{hideWhenEmpty:this.hideWhenEmpty}}get resourceStates(){return[...this.f]}set resourceStates(R){this.f=[...R],this.k.fire()}constructor(R,T,N,O,W){this.q=R,this.s=T,this.t=N,this.u=O,this.v=W,this.e=0,this.f=[],this.g=new Map,this.h=new Map,this.j=new Map,this.k=new F.$Rd,this.onDidUpdateResourceStates=this.k.event,this.l=!1,this.m=new F.$Rd,this.onDidDispose=this.m.event,this.n=[],this.o=[],this.p=void 0,this.handle=S.d++}getResourceState(R){return this.g.get(R)}$executeResourceCommand(R,T){const N=this.h.get(R);return N?(0,M.$Qg)(()=>this.s.executeCommand(N.command,...N.arguments||[],T)):Promise.resolve(void 0)}_takeResourceStateSnapshot(){const R=[...this.f].sort(l),N=(0,v.$Cb)(this.o,R,l).map(x=>{const le=x.toInsert.map(G=>{const J=this.e++;this.g.set(J,G);const Q=G.resourceUri;let oe;if(G.command)if(G.command.command==="vscode.open"||G.command.command==="vscode.diff"||G.command.command==="vscode.changes"){const Z=new L.$Qc;oe=this.s.converter.toInternal(G.command,Z),this.j.set(J,Z)}else this.h.set(J,G.command);const _=r(G.decorations),Ee=G.decorations&&r(G.decorations.light)||_,he=G.decorations&&r(G.decorations.dark)||_,q=[Ee,he],U=G.decorations&&G.decorations.tooltip||"",ie=G.decorations&&!!G.decorations.strikeThrough,be=G.decorations&&!!G.decorations.faded,H=G.contextValue||"";return{rawResource:[J,Q,q,U,ie,be,H,oe],handle:J}});return{start:x.start,deleteCount:x.deleteCount,toInsert:le}}),O=N.map(({start:x,deleteCount:le,toInsert:G})=>[x,le,G.map(J=>J.rawResource)]),W=N.reverse();for(const{start:x,deleteCount:le,toInsert:G}of W){const J=G.map(oe=>oe.handle),Q=this.n.splice(x,le,...J);for(const oe of Q)this.g.delete(oe),this.h.delete(oe),this.j.get(oe)?.dispose(),this.j.delete(oe)}return this.o=R,O}dispose(){this.l=!0,this.m.fire()}}class P{static{this.d=0}#e;get id(){return this.A}get label(){return this.B}get rootUri(){return this.C}get inputBox(){return this.f}get count(){return this.g}set count(R){this.g!==R&&(this.g=R,this.#e.$updateSourceControl(this.x,{count:R}))}get quickDiffProvider(){return this.h}set quickDiffProvider(R){this.h=R;let T;(0,k.$LF)(this.y,"quickDiffProvider")&&(T=R?.label),this.#e.$updateSourceControl(this.x,{hasQuickDiffProvider:!!R,quickDiffLabel:T})}get historyProvider(){return(0,k.$MF)(this.y,"scmHistoryProvider"),this.j}set historyProvider(R){(0,k.$MF)(this.y,"scmHistoryProvider"),this.j=R,this.k.value=new L.$Qc,this.#e.$updateSourceControl(this.x,{hasHistoryProvider:!!R}),R&&(this.k.value.add(R.onDidChangeCurrentHistoryItemGroup(()=>{m(this.l,R?.currentHistoryItemGroup)||(this.l=R?.currentHistoryItemGroup,this.#e.$onDidChangeHistoryProviderCurrentHistoryItemGroup(this.x,this.l))})),this.k.value.add(R.onDidChangeActionButton(()=>{(0,k.$MF)(this.y,"scmActionButton"),this.m.value=new L.$Qc;const T=R.actionButton!==void 0?{command:this.z.converter.toInternal(R.actionButton.command,this.m.value),description:R.actionButton.description,enabled:R.actionButton.enabled}:void 0;this.#e.$onDidChangeHistoryProviderActionButton(this.x,T??null)})))}get commitTemplate(){return this.n}set commitTemplate(R){R!==this.n&&(this.n=R,this.#e.$updateSourceControl(this.x,{commitTemplate:R}))}get acceptInputCommand(){return this.p}set acceptInputCommand(R){this.o.value=new L.$Qc,this.p=R;const T=this.z.converter.toInternal(R,this.o.value);this.#e.$updateSourceControl(this.x,{acceptInputCommand:T})}get actionButton(){return(0,k.$MF)(this.y,"scmActionButton"),this.s}set actionButton(R){(0,k.$MF)(this.y,"scmActionButton"),this.q.value=new L.$Qc,this.s=R;const T=R!==void 0?{command:this.z.converter.toInternal(R.command,this.q.value),secondaryCommands:R.secondaryCommands?.map(N=>N.map(O=>this.z.converter.toInternal(O,this.q.value))),description:R.description,enabled:R.enabled}:void 0;this.#e.$updateSourceControl(this.x,{actionButton:T??null})}get statusBarCommands(){return this.u}set statusBarCommands(R){if(this.u&&R&&D(this.u,R))return;this.t.value=new L.$Qc,this.u=R;const T=(R||[]).map(N=>this.z.converter.toInternal(N,this.t.value));this.#e.$updateSourceControl(this.x,{statusBarCommands:T})}get selected(){return this.v}constructor(R,T,N,O,W,x,le){this.y=R,this.z=O,this.A=W,this.B=x,this.C=le,this.e=new Map,this.g=void 0,this.h=void 0,this.k=new L.$Sc,this.m=new L.$Sc,this.n=void 0,this.o=new L.$Sc,this.p=void 0,this.q=new L.$Sc,this.t=new L.$Sc,this.u=void 0,this.v=!1,this.w=new F.$Rd,this.onDidChangeSelection=this.w.event,this.x=P.d++,this.D=new Map,this.E=new Set,this.#e=N;const G=C.URI.from({scheme:w.Schemas.vscodeSourceControl,path:`${W}/scm${this.x}/input`,query:le?`rootUri=${encodeURIComponent(le.toString())}`:void 0});this.f=new p(R,O,T,this.#e,this.x,G),this.#e.$registerSourceControl(this.x,W,x,le,G)}createResourceGroup(R,T){const N=new S(this.#e,this.z,this.x,R,T),O=F.Event.once(N.onDidDispose)(()=>this.D.delete(N));return this.D.set(N,O),this.eventuallyAddResourceGroups(),N}eventuallyAddResourceGroups(){const R=[],T=[];for(const[N,O]of this.D){O.dispose();const W=N.onDidUpdateResourceStates(()=>{this.E.add(N),this.eventuallyUpdateResourceStates()});F.Event.once(N.onDidDispose)(()=>{this.E.delete(N),W.dispose(),this.e.delete(N.handle),this.#e.$unregisterGroup(this.x,N.handle)}),R.push([N.handle,N.id,N.label,N.features]);const x=N._takeResourceStateSnapshot();x.length>0&&T.push([N.handle,x]),this.e.set(N.handle,N)}this.#e.$registerGroups(this.x,R,T),this.D.clear()}eventuallyUpdateResourceStates(){const R=[];this.E.forEach(T=>{const N=T._takeResourceStateSnapshot();N.length!==0&&R.push([T.handle,N])}),R.length>0&&this.#e.$spliceResourceStates(this.x,R),this.E.clear()}getResourceGroup(R){return this.e.get(R)}setSelectionState(R){this.v=R,this.w.fire(R)}dispose(){this.o.dispose(),this.q.dispose(),this.t.dispose(),this.e.forEach(R=>R.dispose()),this.#e.$unregisterSourceControl(this.x)}}He([(0,f.$oh)(100)],P.prototype,"eventuallyAddResourceGroups",null),He([(0,f.$oh)(100)],P.prototype,"eventuallyUpdateResourceStates",null);let z=class{static{o=this}static{this.d=0}get onDidChangeActiveProvider(){return this.j.event}constructor(R,T,N,O){this.l=T,this.m=N,this.n=O,this.g=new Map,this.h=new I.$bm,this.j=new F.$Rd,this.e=R.getProxy(b.$xK.MainThreadSCM),this.f=R.getProxy(b.$xK.MainThreadTelemetry),T.registerArgumentProcessor({processArgument:W=>{if(W&&W.$mid===3){const x=this.g.get(W.sourceControlHandle);if(!x)return W;const le=x.getResourceGroup(W.groupHandle);return le?le.getResourceState(W.handle):W}else if(W&&W.$mid===4){const x=this.g.get(W.sourceControlHandle);return x?x.getResourceGroup(W.groupHandle):W}else if(W&&W.$mid===5){const x=this.g.get(W.handle);return x||W}return W}})}createSourceControl(R,T,N,O){this.n.trace("ExtHostSCM#createSourceControl",R.identifier.value,T,N,O),this.f.$publicLog2("api/scm/createSourceControl",{extensionId:R.identifier.value});const W=o.d++,x=new P(R,this.m,this.e,this.l,T,N,O);this.g.set(W,x);const le=this.h.get(R.identifier)||[];return le.push(x),this.h.set(R.identifier,le),x}getLastInputBox(R){this.n.trace("ExtHostSCM#getLastInputBox",R.identifier.value);const T=this.h.get(R.identifier),N=T&&T[T.length-1];return N&&N.inputBox}$provideOriginalResource(R,T,N){const O=C.URI.revive(T);this.n.trace("ExtHostSCM#$provideOriginalResource",R,O.toString());const W=this.g.get(R);return!W||!W.quickDiffProvider||!W.quickDiffProvider.provideOriginalResource?Promise.resolve(null):(0,M.$Qg)(()=>W.quickDiffProvider.provideOriginalResource(O,N)).then(x=>x||null)}$onInputBoxValueChange(R,T){this.n.trace("ExtHostSCM#$onInputBoxValueChange",R);const N=this.g.get(R);return N&&N.inputBox.$onInputBoxValueChange(T),Promise.resolve(void 0)}$executeResourceCommand(R,T,N,O){this.n.trace("ExtHostSCM#$executeResourceCommand",R,T,N);const W=this.g.get(R);if(!W)return Promise.resolve(void 0);const x=W.getResourceGroup(T);return x?x.$executeResourceCommand(N,O):Promise.resolve(void 0)}$validateInput(R,T,N){this.n.trace("ExtHostSCM#$validateInput",R);const O=this.g.get(R);return!O||!O.inputBox.validateInput?Promise.resolve(void 0):(0,M.$Qg)(()=>O.inputBox.validateInput(T,N)).then(W=>{if(!W)return Promise.resolve(void 0);const x=y.MarkdownString.fromStrict(W.message);return x?Promise.resolve([x,W.type]):Promise.resolve(void 0)})}$setSelectedSourceControl(R){return this.n.trace("ExtHostSCM#$setSelectedSourceControl",R),R!==void 0&&this.g.get(R)?.setSelectionState(!0),this.k!==void 0&&this.g.get(this.k)?.setSelectionState(!1),this.k=R,Promise.resolve(void 0)}async $resolveHistoryItemGroupBase(R,T,N){return await this.g.get(R)?.historyProvider?.resolveHistoryItemGroupBase(T,N)??void 0}async $resolveHistoryItemGroupCommonAncestor(R,T,N,O){return await this.g.get(R)?.historyProvider?.resolveHistoryItemGroupCommonAncestor(T,N,O)??void 0}async $provideHistoryItems(R,T,N,O){return(await this.g.get(R)?.historyProvider?.provideHistoryItems(T,N,O))?.map(le=>({...le,icon:t(le)}))??void 0}async $provideHistoryItemChanges(R,T,N){return await this.g.get(R)?.historyProvider?.provideHistoryItemChanges(T,N)??void 0}};e.$pfc=z,e.$pfc=z=o=He([Be(3,A.$dj)],z)}),define(ke[117],Se([1,0,6,4,5]),function(me,e,C,F,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wec=e.$vec=void 0;class L{constructor(b){this.b=new F.$Rd,this.onDidChangePassword=this.b.event,this.a=b.getProxy(C.$xK.MainThreadSecretState)}async $onDidChangePassword(b){this.b.fire(b)}get(b,v){return this.a.$getPassword(b,v)}store(b,v,g){return this.a.$setPassword(b,v,g)}delete(b,v){return this.a.$deletePassword(b,v)}}e.$vec=L,e.$wec=(0,f.$Vh)("IExtHostSecretState")}),define(ke[336],Se([1,0,6,15,2]),function(me,e,C,F,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qfc=void 0;class L{static{this.a=0}constructor(b,v){this.d=v,this.c=new Map,this.b=b.getProxy(C.$xK.MainThreadShare)}async $provideShare(b,v,g){return await this.c.get(b)?.provideShare({selection:F.Range.to(v.selection),resourceUri:f.URI.revive(v.resourceUri)},g)??void 0}registerShareProvider(b,v){const g=L.a++;return this.c.set(g,v),this.b.$registerShareProvider(g,F.DocumentSelector.from(b,this.d),v.id,v.label,v.priority),{dispose:()=>{this.b.$unregisterShareProvider(g),this.c.delete(g)}}}}e.$qfc=L}),define(ke[337],Se([1,0,21,3,6]),function(me,e,C,F,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rfc=void 0;class L{static{this.a=1}constructor(b){this.c=new Map,this.d=new Map,this.b=b.getProxy(f.$xK.MainThreadSpeech)}async $createSpeechToTextSession(b,v){const g=this.c.get(b);if(!g)return;const A=new F.$Qc,I=new C.$2d;this.d.set(v,I);const $=A.add(g.provideSpeechToTextSession(I.token));A.add($.onDidChange(y=>{I.token.isCancellationRequested||this.b.$emitSpeechToTextEvent(v,y)})),A.add(I.token.onCancellationRequested(()=>A.dispose()))}async $cancelSpeechToTextSession(b){this.d.get(b)?.dispose(!0),this.d.delete(b)}registerProvider(b,v,g){const A=L.a++;return this.c.set(A,g),this.b.$registerProvider(A,v,{extension:b,displayName:b.value}),(0,F.$Pc)(()=>{this.b.$unregisterProvider(A),this.c.delete(A)})}}e.$rfc=L}),define(ke[338],Se([1,0,7,6,217,3,15,18]),function(me,e,C,F,f,L,M,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tfc=e.$sfc=void 0;class v{static{this.a=0}static{this.b=new Map([["statusBarItem.errorBackground",new C.$uL("statusBarItem.errorForeground")],["statusBarItem.warningBackground",new C.$uL("statusBarItem.warningForeground")]])}#e;#t;constructor($,y,k,w,u,o=C.StatusBarAlignment.Left,i){if(this.i=!1,this.k="",this.q=new L.$Qc,this.#e=$,this.#t=y,u&&w){this.c=(0,C.$0K)(w.identifier,u);const n=k.get(this.c);n&&(o=n.alignLeft?C.StatusBarAlignment.Left:C.StatusBarAlignment.Right,i=n.priority,this.j=!0,this.name=n.name,this.text=n.text,this.tooltip=n.tooltip,this.command=n.command,this.accessibilityInformation=n.accessibilityInformation)}else this.c=String(v.a++);this.e=w,this.f=u,this.g=o,this.h=this.u(i)}u($){if((0,b.$Gf)($))return $===Number.POSITIVE_INFINITY?Number.MAX_VALUE:$===Number.NEGATIVE_INFINITY?-Number.MAX_VALUE:$}get id(){return this.f??this.e.identifier.value}get alignment(){return this.g}get priority(){return this.h}get text(){return this.k}get name(){return this.m}get tooltip(){return this.l}get color(){return this.n}get backgroundColor(){return this.o}get command(){return this.r?.fromApi}get accessibilityInformation(){return this.t}set text($){this.k=$,this.v()}set name($){this.m=$,this.v()}set tooltip($){this.l=$,this.v()}set color($){this.n=$,this.v()}set backgroundColor($){$&&!v.b.has($.id)&&($=void 0),this.o=$,this.v()}set command($){this.r?.fromApi!==$&&(this.p&&this.q.add(this.p),this.p=new L.$Qc,typeof $=="string"?this.r={fromApi:$,internal:this.#t.toInternal({title:"",command:$},this.p)}:$?this.r={fromApi:$,internal:this.#t.toInternal($,this.p)}:this.r=void 0,this.v())}set accessibilityInformation($){this.t=$,this.v()}show(){this.j=!0,this.v()}hide(){clearTimeout(this.s),this.j=!1,this.#e.$disposeEntry(this.c)}v(){this.i||!this.j||(clearTimeout(this.s),this.s=setTimeout(()=>{this.s=void 0;let $;this.e?this.f?$=`${this.e.identifier.value}.${this.f}`:$=this.e.identifier.value:$=this.f;let y;this.m?y=this.m:y=(0,f.localize)(0,null,this.e.displayName||this.e.name);let k=this.n;this.o&&(k=v.b.get(this.o.id));const w=M.MarkdownString.fromStrict(this.l);this.#e.$setEntry(this.c,$,this.e?.identifier.value,y,this.k,w,this.r?.internal,k,this.o,this.g===C.StatusBarAlignment.Left,this.h,this.t),this.q.clear()},0))}dispose(){this.hide(),this.i=!0}}e.$sfc=v;class g{constructor($){this.b=[],this.a=$.createStatusBarEntry(void 0,"status.extensionMessage",C.StatusBarAlignment.Left,Number.MIN_VALUE),this.a.name=(0,f.localize)(1,null)}dispose(){this.b.length=0,this.a.dispose()}setMessage($){const y={message:$};return this.b.unshift(y),this.c(),new C.$zK(()=>{const k=this.b.indexOf(y);k>=0&&(this.b.splice(k,1),this.c())})}c(){this.b.length>0?(this.a.text=this.b[0].message,this.a.show()):this.a.hide()}}class A{constructor($,y){this.e=new Map,this.a=$.getProxy(F.$xK.MainThreadStatusBar),this.b=y,this.c=new g(this)}$acceptStaticEntries($){for(const y of $)this.e.set(y.entryId,y)}createStatusBarEntry($,y,k,w){return new v(this.a,this.b,this.e,$,y,k,w)}setStatusBarMessage($,y){const k=this.c.setMessage($);let w;return typeof y=="number"?w=setTimeout(()=>k.dispose(),y):typeof y<"u"&&y.then(()=>k.dispose(),()=>k.dispose()),new C.$zK(()=>{k.dispose(),clearTimeout(w)})}}e.$tfc=A}),define(ke[118],Se([1,0,6,4,5]),function(me,e,C,F,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$oec=e.$nec=void 0;class L{constructor(b,v){this.c=v,this.b=new F.$Rd,this.onDidChangeStorage=this.b.event,this.a=b.getProxy(C.$xK.MainThreadStorage)}registerExtensionStorageKeysToSync(b,v){this.a.$registerExtensionStorageKeysToSync(b,v)}async initializeExtensionStorage(b,v,g){const A=await this.a.$initializeExtensionStorage(b,v);let I;return A&&(I=this.d(b,v,A)),I||g}setValue(b,v,g){return this.a.$setValue(b,v,g)}$acceptValue(b,v,g){const A=this.d(b,v,g);A&&this.b.fire({shared:b,key:v,value:A})}d(b,v,g){try{return JSON.parse(g)}catch(A){this.c.error(`[extHostStorage] unexpected error parsing storage contents (extensionId: ${v}, global: ${b}): ${A}`)}}}e.$nec=L,e.$oec=(0,f.$Vh)("IExtHostStorage")}),define(ke[92],Se([1,0,5,27,14,71,2]),function(me,e,C,F,f,L,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0dc=e.$9dc=void 0,e.$9dc=(0,C.$Vh)("IExtensionStoragePaths");let b=class{constructor(g,A,I){this.d=A,this.f=I,this.a=g.workspace??void 0,this.b=g.environment,this.whenReady=this.h().then($=>this.c=$)}async g(g){return M.URI.joinPath(this.b.workspaceStorageHome,g)}async h(){if(!this.a)return Promise.resolve(void 0);const g=this.a.id,A=await this.g(g);try{return await this.f.value.stat(A),this.d.trace("[ExtHostStorage] storage dir already exists",A),A}catch{}try{return this.d.trace("[ExtHostStorage] creating dir and metadata-file",A),await this.f.value.createDirectory(A),await this.f.value.writeFile(M.URI.joinPath(A,"meta.json"),new TextEncoder().encode(JSON.stringify({id:this.a.id,configuration:M.URI.revive(this.a.configuration)?.toString(),name:this.a.name},void 0,2))),A}catch(I){this.d.error("[ExtHostStorage]",I);return}}workspaceValue(g){if(this.c)return M.URI.joinPath(this.c,g.identifier.value)}globalValue(g){return M.URI.joinPath(this.b.globalStorageHome,g.identifier.value.toLowerCase())}onWillDeactivateAll(){}};e.$0dc=b,e.$0dc=b=He([Be(0,F.$PM),Be(1,f.$dj),Be(2,L.$8dc)],b)}),define(ke[46],Se([1,0,4,6,5,2,20,3,7,219,8,263,21,32,264,61,12,15,35]),function(me,e,C,F,f,L,M,b,v,g,A,I,$,y,k,w,u,o,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uec=e.$tec=e.$sec=e.$rec=void 0,e.$rec=(0,f.$Vh)("IExtHostTerminalService");class n{constructor(m,p,S,P){this.l=m,this._id=p,this.m=S,this.n=P,this.a=!1,this.j={isInteractedWith:!1},this.isOpen=!1,this.m=Object.freeze(this.m),this.b=new Promise(j=>this.f=j);const z=this;this.value={get name(){return z.n||""},get processId(){return z.b},get creationOptions(){return z.m},get exitStatus(){return z.h},get state(){return z.j},get selection(){return z.k},sendText(j,R=!0){z.q(),z.l.$sendText(z._id,j,R)},show(j){z.q(),z.l.$show(z._id,j)},hide(){z.q(),z.l.$hide(z._id)},dispose(){z.a||(z.a=!0,z.l.$dispose(z._id))},get dimensions(){if(!(z.d===void 0||z.g===void 0))return{columns:z.d,rows:z.g}}}}async create(m,p){if(typeof this._id!="string")throw new Error("Terminal has already been created");await this.l.$createTerminal(this._id,{name:m.name,shellPath:m.shellPath??void 0,shellArgs:m.shellArgs??void 0,cwd:m.cwd??p?.cwd??void 0,env:m.env??void 0,icon:l(m.iconPath)??void 0,color:w.ThemeColor.isThemeColor(m.color)?m.color.id:void 0,initialText:m.message??void 0,strictEnv:m.strictEnv??void 0,hideFromUser:m.hideFromUser??void 0,isFeatureTerminal:p?.isFeatureTerminal??void 0,isExtensionOwnedTerminal:!0,useShellEnvironment:p?.useShellEnvironment??void 0,location:p?.location||this.o(m.location,p?.resolvedExtHostIdentifier),isTransient:m.isTransient??void 0})}async createExtensionTerminal(m,p,S,P){if(typeof this._id!="string")throw new Error("Terminal has already been created");if(await this.l.$createTerminal(this._id,{name:this.n,isExtensionCustomPtyTerminal:!0,icon:S,color:w.ThemeColor.isThemeColor(P)?P.id:void 0,location:this.o(m,p),isTransient:!0}),typeof this._id=="string")throw new Error("Terminal creation failed");return this._id}o(m,p){return typeof m=="object"?"parentTerminal"in m&&m.parentTerminal&&p?{parentTerminal:p}:"viewColumn"in m?{viewColumn:o.ViewColumn.from(m.viewColumn),preserveFocus:m.preserveFocus}:void 0:m}q(){if(this.a)throw new Error("Terminal has already been disposed")}set name(m){this.n=m}setExitStatus(m,p){this.h=Object.freeze({code:m,reason:p})}setDimensions(m,p){return m===this.d&&p===this.g||m===0||p===0?!1:(this.d=m,this.g=p,!0)}setInteractedWith(){return this.j.isInteractedWith?!1:(this.j={isInteractedWith:!0},!0)}setSelection(m){this.k=m}_setProcessId(m){this.f?(this.f(m),this.f=void 0):this.b.then(p=>{p!==m&&(this.b=Promise.resolve(m))})}}e.$sec=n;class r{get onProcessReady(){return this.b.event}constructor(m){this.g=m,this.id=0,this.shouldPersist=!1,this.a=new C.$Rd,this.onProcessData=this.a.event,this.b=new C.$Rd,this.d=new C.$Rd,this.onDidChangeProperty=this.d.event,this.f=new C.$Rd,this.onProcessExit=this.f.event}refreshProperty(m){throw new Error(`refreshProperty is not suppported in extension owned terminals. property: ${m}`)}updateProperty(m,p){throw new Error(`updateProperty is not suppported in extension owned terminals. property: ${m}, value: ${p}`)}async start(){}shutdown(){this.g.close()}input(m){this.g.handleInput?.(m)}resize(m,p){this.g.setDimensions?.({columns:m,rows:p})}clearBuffer(){}async processBinary(m){}acknowledgeDataEvent(m){}async setUnicodeVersion(m){}getInitialCwd(){return Promise.resolve("")}getCwd(){return Promise.resolve("")}startSendingEvents(m){this.g.onDidWrite(p=>this.a.fire(p)),this.g.onDidClose?.((p=void 0)=>{this.f.fire(p===void 0?void 0:p)}),this.g.onDidOverrideDimensions?.(p=>{p&&this.d.fire({type:"overrideDimensions",value:{cols:p.columns,rows:p.rows}})}),this.g.onDidChangeName?.(p=>{this.d.fire({type:"title",value:p})}),this.g.open(m||void 0),m&&this.g.setDimensions?.(m),this.b.fire({pid:-1,cwd:"",windowsPty:void 0})}}let a=1,t=class extends b.$Rc{get activeTerminal(){return this.b?.value}get terminals(){return this.f.map(m=>m.value)}constructor(m,p,S){super(),this.Q=p,this.f=[],this.g=new Map,this.h={},this.j={},this.m={},this.n=new Map,this.w=this.B(new b.$Sc),this.z=new Set,this.C=new Map,this.D=new Map,this.F=new Map,this.G=new Map,this.H=new C.$Rd,this.onDidCloseTerminal=this.H.event,this.I=new C.$Rd,this.onDidOpenTerminal=this.I.event,this.J=new C.$Rd,this.onDidChangeActiveTerminal=this.J.event,this.L=new C.$Rd,this.onDidChangeTerminalDimensions=this.L.event,this.M=new C.$Rd,this.onDidChangeTerminalState=this.M.event,this.N=new C.$Rd,this.onDidChangeShell=this.N.event,this.O=new C.$Rd({onWillAddFirstListener:()=>this.a.$startSendingDataEvents(),onDidRemoveLastListener:()=>this.a.$stopSendingDataEvents()}),this.onDidWriteTerminalData=this.O.event,this.P=new C.$Rd({onWillAddFirstListener:()=>this.a.$startSendingCommandEvents(),onDidRemoveLastListener:()=>this.a.$stopSendingCommandEvents()}),this.onDidExecuteTerminalCommand=this.P.event,this.a=S.getProxy(F.$xK.MainThreadTerminalService),this.y=new k.$nqb(this.a.$sendProcessData),this.a.$registerProcessSupport(m),this.Q.registerArgumentProcessor({processArgument:P=>{const z=j=>{const R=j;return this.W(R.instanceId)?.value};switch(P?.$mid){case 15:return z(P);default:{if(Array.isArray(P))for(let j=0;j<P.length&&P[j].$mid===15;j++)P[j]=z(P[j]);return P}}}}),this.B({dispose:()=>{for(const[P,z]of this.g)z.shutdown(!0)}})}getDefaultShell(m){return(m?this.u:this.s)?.path||""}getDefaultShellArgs(m){return(m?this.u:this.s)?.args||[]}createExtensionTerminal(m,p){const S=new n(this.a,(0,y.$ig)(),m,m.name),P=new r(m.pty);return S.createExtensionTerminal(m.location,this.R(m,p).resolvedExtHostIdentifier,l(m.iconPath),h(m.color)).then(z=>{const j=this.S(z,P);this.h[z]=j}),this.f.push(S),S.value}R(m,p){if(p=p||{},m.location&&typeof m.location=="object"&&"parentTerminal"in m.location){const S=m.location.parentTerminal;if(S){const P=this.f.find(z=>z.value===S);P&&(p.resolvedExtHostIdentifier=P._id)}}else m.location&&typeof m.location!="object"?p.location=m.location:p.location&&typeof p.location=="object"&&"splitActiveTerminal"in p.location&&(p.location={splitActiveTerminal:!0});return p}attachPtyToTerminal(m,p){if(!this.W(m))throw new Error(`Cannot resolve terminal with id ${m} for virtual process`);const P=new r(p),z=this.S(m,P);this.h[m]=z}async $acceptActiveTerminalChanged(m){const p=this.b;if(m===null){this.b=void 0,p!==this.b&&this.J.fire(this.b);return}const S=this.W(m);S&&(this.b=S,p!==this.b&&this.J.fire(this.b.value))}async $acceptTerminalProcessData(m,p){const S=this.W(m);S&&this.O.fire({terminal:S.value,data:p})}async $acceptTerminalDimensions(m,p,S){const P=this.W(m);P&&P.setDimensions(p,S)&&this.L.fire({terminal:P.value,dimensions:P.value.dimensions})}async $acceptDidExecuteCommand(m,p){const S=this.W(m);S&&this.P.fire({terminal:S.value,...p})}async $acceptTerminalMaximumDimensions(m,p,S){this.g.get(m)?.resize(p,S)}async $acceptTerminalTitleChange(m,p){const S=this.W(m);S&&(S.name=p)}async $acceptTerminalClosed(m,p,S){const P=this.Y(this.f,m);if(P!==null){const z=this.f.splice(P,1)[0];z.setExitStatus(p,S),this.H.fire(z.value)}}$acceptTerminalOpened(m,p,S,P){if(p){const R=this.Y(this.f,p);if(R!==null){this.f[R]._id=m,this.I.fire(this.terminals[R]),this.f[R].isOpen=!0;return}}const z={name:P.name,shellPath:P.executable,shellArgs:P.args,cwd:typeof P.cwd=="string"?P.cwd:L.URI.revive(P.cwd),env:P.env,hideFromUser:P.hideFromUser},j=new n(this.a,m,z,S);this.f.push(j),this.I.fire(j.value),j.isOpen=!0}async $acceptTerminalProcessId(m,p){this.W(m)?._setProcessId(p)}async $startExtensionTerminal(m,p){const S=this.W(m);if(!S)return{message:(0,g.localize)(0,null,m)};S.isOpen||await new Promise(z=>{const j=this.onDidOpenTerminal(async R=>{R===S.value&&(j.dispose(),z())})});const P=this.g.get(m);P?P.startSendingEvents(p):this.j[m]={initialDimensions:p}}S(m,p){const S=new b.$Qc;S.add(p.onProcessReady(z=>this.a.$sendProcessReady(m,z.pid,z.cwd,z.windowsPty))),S.add(p.onDidChangeProperty(z=>this.a.$sendProcessProperty(m,z))),this.y.startBuffering(m,p.onProcessData),S.add(p.onProcessExit(z=>this.U(m,z))),this.g.set(m,p);const P=this.j[m];return P&&p instanceof r&&(p.startSendingEvents(P.initialDimensions),delete this.j[m]),S}$acceptProcessAckDataEvent(m,p){this.g.get(m)?.acknowledgeDataEvent(p)}$acceptProcessInput(m,p){this.g.get(m)?.input(p)}$acceptTerminalInteraction(m){const p=this.W(m);p?.setInteractedWith()&&this.M.fire(p.value)}$acceptTerminalSelection(m,p){this.W(m)?.setSelection(p)}$acceptProcessResize(m,p,S){try{this.g.get(m)?.resize(p,S)}catch(P){if(P.code!=="EPIPE"&&P.code!=="ERR_IPC_CHANNEL_CLOSED")throw P}}$acceptProcessShutdown(m,p){this.g.get(m)?.shutdown(p)}$acceptProcessRequestInitialCwd(m){this.g.get(m)?.getInitialCwd().then(p=>this.a.$sendProcessProperty(m,{type:"initialCwd",value:p}))}$acceptProcessRequestCwd(m){this.g.get(m)?.getCwd().then(p=>this.a.$sendProcessProperty(m,{type:"cwd",value:p}))}$acceptProcessRequestLatency(m){return Promise.resolve(m)}registerLinkProvider(m){return this.z.add(m),this.z.size===1&&this.a.$startLinkProvider(),new v.$zK(()=>{this.z.delete(m),this.z.size===0&&this.a.$stopLinkProvider()})}registerProfileProvider(m,p,S){if(this.C.has(p))throw new Error(`Terminal profile provider "${p}" already registered`);return this.C.set(p,S),this.a.$registerProfileProvider(p,m.identifier.value),new v.$zK(()=>{this.C.delete(p),this.a.$unregisterProfileProvider(p)})}registerTerminalQuickFixProvider(m,p,S){if(this.D.has(m))throw new Error(`Terminal quick fix provider "${m}" is already registered`);return this.D.set(m,S),this.a.$registerQuickFixProvider(m,p),new v.$zK(()=>{this.D.delete(m),this.a.$unregisterQuickFixProvider(m)})}async $provideTerminalQuickFixes(m,p){const S=new $.$2d().token;if(S.isCancellationRequested)return;const P=this.D.get(m);if(!P)return;const z=await P.provideTerminalQuickFixes(p,S);if(z===null||Array.isArray(z)&&z.length===0)return;const j=new b.$Qc;if(this.w.value=j,!Array.isArray(z))return z?o.TerminalQuickFix.from(z,this.Q.converter,j):void 0;const R=[];for(const T of z){const N=o.TerminalQuickFix.from(T,this.Q.converter,j);N&&R.push(N)}return R}async $createContributedProfileTerminal(m,p){const S=new $.$2d().token;let P=await this.C.get(m)?.provideTerminalProfile(S);if(!S.isCancellationRequested){if(P&&!("options"in P)&&(P={options:P}),!P||!("options"in P))throw new Error(`No terminal profile options provided for id "${m}"`);if("pty"in P.options){this.createExtensionTerminal(P.options,p);return}this.createTerminalFromOptions(P.options,p)}}async $provideLinks(m,p){const S=this.W(m);if(!S)return[];this.F.delete(m),this.G.get(m)?.dispose(!0);const z=new $.$2d;this.G.set(m,z);const j=[],R={terminal:S.value,line:p},T=[];for(const W of this.z)T.push(u.Promises.withAsyncBody(async x=>{z.token.onCancellationRequested(()=>x({provider:W,links:[]}));const le=await W.provideTerminalLinks(R,z.token)||[];z.token.isCancellationRequested||x({provider:W,links:le})}));const N=await Promise.all(T);if(z.token.isCancellationRequested)return[];const O=new Map;for(const W of N)W&&W.links.length>0&&j.push(...W.links.map(x=>{const le={id:a++,startIndex:x.startIndex,length:x.length,label:x.tooltip};return O.set(le.id,{provider:W.provider,link:x}),le}));return this.F.set(m,O),j}$activateLink(m,p){const S=this.F.get(m)?.get(p);S&&S.provider.handleTerminalLink(S.link)}U(m,p){this.y.stopBuffering(m),this.g.delete(m),delete this.j[m];const S=this.h[m];S&&(S.dispose(),delete this.h[m]),this.a.$sendProcessExit(m,p)}W(m){return this.X(this.f,m)}X(m,p){const S=this.Y(m,p);return S!==null?m[S]:null}Y(m,p){const S=m.findIndex(P=>P._id===p);return S===-1?null:S}getEnvironmentVariableCollection(m){let p=this.n.get(m.identifier.value);return p||(p=new s,this.$(m.identifier.value,p)),p.getScopedEnvironmentVariableCollection(void 0)}Z(m,p){const S=(0,I.$qr)(p.map),P=(0,I.$rr)(p.descriptionMap);this.a.$setEnvironmentVariableCollection(m,p.persistent,S.length===0?void 0:S,P)}$initEnvironmentVariableCollections(m){m.forEach(p=>{const S=p[0],P=new s(p[1]);this.$(S,P)})}$acceptDefaultProfile(m,p){const S=this.s;this.s=m,this.u=p,S?.path!==m.path&&this.N.fire(m.path)}$(m,p){this.n.set(m,p),p.onDidChangeCollection(()=>{this.Z(m,p)})}};e.$tec=t,e.$tec=t=He([Be(1,i.$VM),Be(2,M.$zM)],t);class s{get persistent(){return this.b}set persistent(m){this.b=m,this.d.fire()}get onDidChangeCollection(){return this.d&&this.d.event}constructor(m){this.map=new Map,this.a=new Map,this.descriptionMap=new Map,this.b=!0,this.d=new C.$Rd,this.map=new Map(m)}getScopedEnvironmentVariableCollection(m){const p=this.h(m);let S=this.a.get(p);return S||(S=new d(this,m),this.a.set(p,S),S.onDidChangeCollection(()=>this.d.fire())),S}replace(m,p,S,P){this.f(m,{value:p,type:v.EnvironmentVariableMutatorType.Replace,options:S??{applyAtProcessCreation:!0},scope:P})}append(m,p,S,P){this.f(m,{value:p,type:v.EnvironmentVariableMutatorType.Append,options:S??{applyAtProcessCreation:!0},scope:P})}prepend(m,p,S,P){this.f(m,{value:p,type:v.EnvironmentVariableMutatorType.Prepend,options:S??{applyAtProcessCreation:!0},scope:P})}f(m,p){if(p.options&&p.options.applyAtProcessCreation===!1&&!p.options.applyAtShellIntegration)throw new Error("EnvironmentVariableMutatorOptions must apply at either process creation or shell integration");const S=this.g(m,p.scope),P=this.map.get(S),z=p.options?{applyAtProcessCreation:p.options.applyAtProcessCreation??!1,applyAtShellIntegration:p.options.applyAtShellIntegration??!1}:{applyAtProcessCreation:!0};if(!P||P.value!==p.value||P.type!==p.type||P.options?.applyAtProcessCreation!==z.applyAtProcessCreation||P.options?.applyAtShellIntegration!==z.applyAtShellIntegration||P.scope?.workspaceFolder?.index!==p.scope?.workspaceFolder?.index){const j=this.g(m,p.scope),R={variable:m,...p,options:z};this.map.set(j,R),this.d.fire()}}get(m,p){const S=this.g(m,p),P=this.map.get(S);return P?E(P):void 0}g(m,p){const S=this.h(p);return S.length?`${m}:::${S}`:m}h(m){return this.j(m?.workspaceFolder)??""}j(m){return m?m.uri.toString():void 0}getVariableMap(m){const p=new Map;for(const[S,P]of this.map)this.h(P.scope)===this.h(m)&&p.set(P.variable,E(P));return p}delete(m,p){const S=this.g(m,p);this.map.delete(S),this.d.fire()}clear(m){if(m?.workspaceFolder){for(const[p,S]of this.map)S.scope?.workspaceFolder?.index===m.workspaceFolder.index&&this.map.delete(p);this.k(m)}else this.map.clear(),this.descriptionMap.clear();this.d.fire()}setDescription(m,p){const S=this.h(p),P=this.descriptionMap.get(S);if(!P||P.description!==m){let z;typeof m=="string"?z=m:z=m?.value.split(`

`)[0];const j={description:z,scope:p};this.descriptionMap.set(S,j),this.d.fire()}}getDescription(m){const p=this.h(m);return this.descriptionMap.get(p)?.description}k(m){const p=this.h(m);this.descriptionMap.delete(p)}}class d{get persistent(){return this.b.persistent}set persistent(m){this.b.persistent=m}get onDidChangeCollection(){return this.a&&this.a.event}constructor(m,p){this.b=m,this.d=p,this.a=new C.$Rd}getScoped(m){return this.b.getScopedEnvironmentVariableCollection(m)}replace(m,p,S){this.b.replace(m,p,S,this.d)}append(m,p,S){this.b.append(m,p,S,this.d)}prepend(m,p,S){this.b.prepend(m,p,S,this.d)}get(m){return this.b.get(m,this.d)}forEach(m,p){this.b.getVariableMap(this.d).forEach((S,P)=>m.call(p,P,S,this),this.d)}[Symbol.iterator](){return this.b.getVariableMap(this.d).entries()}delete(m){this.b.delete(m,this.d),this.a.fire(void 0)}clear(){this.b.clear(this.d)}set description(m){this.b.setDescription(m,this.d)}get description(){return this.b.getDescription(this.d)}}let c=class extends t{constructor(m,p){super(!1,m,p)}createTerminal(m,p,S){throw new A.$$}createTerminalFromOptions(m,p){throw new A.$$}};e.$uec=c,e.$uec=c=He([Be(0,i.$VM),Be(1,M.$zM)],c);function l(D){if(!(!D||typeof D=="string"))return"id"in D?{id:D.id,color:D.color}:D}function h(D){return w.ThemeColor.isThemeColor(D)?D:void 0}function E(D){const m={...D};return delete m.scope,m.options=m.options??void 0,delete m.variable,m}}),define(ke[339],Se([1,0,121,12,22,21,4,74,52,3,24,18,32,6,20,149,15,7,67,112,89,25]),function(me,e,C,F,f,L,M,b,v,g,A,I,$,y,k,w,u,o,i,n,r,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Afc=e.$zfc=e.$yfc=e.$xfc=void 0;let t=class extends g.$Rc{constructor(R,T,N){super(),this.u=N,this.f=this.B(new M.$Rd),this.g=new Map,this.s=this.B(new M.$Rd),this.onResultsChanged=this.f.event,this.results=[],this.h=R.getProxy(y.$xK.MainThreadTesting),this.m=new S(this.h),this.j=new l(this.h),T.registerArgumentProcessor({processArgument:O=>{switch(O?.$mid){case 16:{const W=O,x=W.tests[W.tests.length-1].item.extId;return this.g.get(i.$qJ.root(x))?.collection.tree.get(x)?.actual??(0,w.$LM)(O)}case 18:{const{extId:W,message:x}=O;return{test:this.g.get(i.$qJ.root(W))?.collection.tree.get(W)?.actual,message:u.TestMessage.to(x)}}default:return O}}}),T.registerCommand(!1,"testing.getExplorerSelection",async()=>{const O=await T.executeCommand("_testing.getExplorerSelection"),W=x=>{const le=this.g.get(i.$qJ.root(x));if(le)return i.$qJ.isRoot(x)?le.controller:le.collection.tree.get(x)?.actual};return{include:O?.include.map(W).filter(I.$Kf)||[],exclude:O?.exclude.map(W).filter(I.$Kf)||[]}})}createTestController(R,T,N,O){if(this.g.has(T))throw new Error(`Attempt to insert a duplicate controller with ID "${T}"`);const W=new g.$Qc,x=W.add(new w.$OM(T,N,this.u));x.root.label=N;const le=new Map,G=new Set,J=this.h,Q={items:x.root.children,get label(){return N},set label(_){N=_,x.root.label=_,J.$updateController(T,{label:N})},get refreshHandler(){return O},set refreshHandler(_){O=_,J.$updateController(T,{canRefresh:!!_})},get id(){return T},createRunProfile:(_,Ee,he,q,U,ie)=>{let be=(0,v.$Ji)(_);for(;le.has(be);)be++;return new P(this.h,le,R,G,this.s.event,T,be,_,Ee,he,q,U,ie)},createTestItem(_,Ee,he){return new w.$MM(T,_,Ee,he)},createTestRun:(_,Ee,he=!0)=>this.j.createTestRun(R,T,x,_,Ee,he),invalidateTestResults:_=>{if(_===void 0)this.h.$markTestRetired(void 0);else{const Ee=_ instanceof Array?_:[_];this.h.$markTestRetired(Ee.map(he=>i.$qJ.fromExtHostTestItem(he,T).toString()))}},set resolveHandler(_){x.resolveHandler=_},get resolveHandler(){return x.resolveHandler},dispose:()=>{W.dispose()}};J.$registerTestController(T,N,!!O),W.add((0,g.$Pc)(()=>J.$unregisterTestController(T)));const oe={controller:Q,collection:x,profiles:le,extension:R,activeProfiles:G};return this.g.set(T,oe),W.add((0,g.$Pc)(()=>this.g.delete(T))),W.add(x.onDidGenerateDiff(_=>J.$publishDiff(T,_.map(r.TestsDiffOp.serialize)))),Q}createTestObserver(){return this.m.checkout()}async runTests(R,T=L.CancellationToken.None){const N=h(R);if(!N)throw new Error("The request passed to `vscode.test.runTests` must include a profile");const O=this.g.get(N.controllerId);if(!O)throw new Error("Controller not found");await this.h.$runTests({isUiTriggered:!1,targets:[{testIds:R.include?.map(W=>i.$qJ.fromExtHostTestItem(W,O.collection.root.id).toString())??[O.collection.root.id],profileGroup:z[N.kind],profileId:N.profileId,controllerId:N.controllerId}],exclude:R.exclude?.map(W=>W.id)},T)}$syncTests(){for(const{collection:R}of this.g.values())R.flushDiff();return Promise.resolve()}$provideFileCoverage(R,T,N){return(0,C.$qb)(this.j.trackers,W=>W.id===R?W.getCoverage(T):void 0)?.provideFileCoverage(N)??Promise.resolve([])}$resolveFileCoverage(R,T,N,O){return(0,C.$qb)(this.j.trackers,x=>x.id===R?x.getCoverage(T):void 0)?.resolveFileCoverage(N,O)??Promise.resolve([])}$configureRunProfile(R,T){this.g.get(R)?.profiles.get(T)?.configureHandler?.()}$setActiveRunProfiles(R){const T=new Map;for(const[N,O]of Object.entries(R)){const W=this.g.get(N);if(!W)continue;const x=new Map,le=O.filter(J=>!W.activeProfiles.has(J)),G=[...W.activeProfiles].filter(J=>!O.includes(J));for(const J of le)x.set(J,!0),W.activeProfiles.add(J);for(const J of G)x.set(J,!1),W.activeProfiles.delete(J);x.size&&T.set(N,x)}this.s.fire(T)}async $refreshTests(R,T){await this.g.get(R)?.controller.refreshHandler?.(T)}$publishTestResults(R){this.results=Object.freeze(R.map(T=>(0,A.$bn)(u.TestResults.to(T))).concat(this.results).sort((T,N)=>N.completedAt-T.completedAt).slice(0,32)),this.f.fire()}async $expandTest(R,T){const N=this.g.get(i.$qJ.fromString(R).controllerId)?.collection;N&&(await N.expand(R,T<0?1/0:T),N.flushDiff())}$acceptDiff(R){this.m.applyDiff(R.map(r.TestsDiffOp.deserialize))}async $runControllerTests(R,T){return Promise.all(R.map(N=>this.w(N,!1,T)))}async $startContinuousRun(R,T){const N=new L.$2d(T),O=await Promise.all(R.map(W=>this.w(W,!0,N.token)));return!T.isCancellationRequested&&!O.some(W=>W.error)&&await new Promise(W=>T.onCancellationRequested(W)),N.dispose(!0),O}async w(R,T,N){const O=this.g.get(R.controllerId);if(!O)return{};const{collection:W,profiles:x,extension:le}=O,G=x.get(R.profileId);if(!G)return{};const J=R.testIds.map(Ee=>W.tree.get(Ee)).filter(I.$Kf),Q=R.excludeExtIds.map(Ee=>O.collection.tree.get(Ee)).filter(I.$Kf).filter(Ee=>J.some(he=>he.fullId.compare(Ee.fullId)===2));if(!J.length)return{};const oe=new o.$8L(J.some(Ee=>Ee.actual instanceof w.$NM)?void 0:J.map(Ee=>Ee.actual),Q.map(Ee=>Ee.actual),G,T),_=(0,r.$sJ)(R)&&this.j.prepareForMainThreadTestRun(oe,E.fromInternal(R,O.collection),le,N);try{return await G.runHandler(oe,N),{}}catch(Ee){return{error:String(Ee)}}finally{_&&(_.hasRunningTasks&&!N.isCancellationRequested&&await M.Event.toPromise(_.onEnd),_.dispose())}}$cancelExtensionTestRun(R){R===void 0?this.j.cancelAllRuns():this.j.cancelRunById(R)}};e.$xfc=t,e.$xfc=t=He([Be(0,k.$zM)],t);const s=1e4;var d;(function(j){j[j.Running=0]="Running",j[j.Cancelling=1]="Cancelling",j[j.Ended=2]="Ended"})(d||(d={}));class c extends g.$Rc{get hasRunningTasks(){return this.f.size>0}get id(){return this.m.id}constructor(R,T,N){super(),this.m=R,this.s=T,this.c=0,this.f=new Map,this.g=new Set,this.j=this.B(new M.$Rd),this.onEnd=this.j.event,this.h=this.B(new L.$2d(N));const O=this.B(new F.$0g(()=>this.u(),s));this.B(this.h.token.onCancellationRequested(()=>O.schedule()))}cancel(){this.c===0?(this.h.cancel(),this.c=1):this.c===1&&this.u()}getCoverage(R){return this.f.get(R)?.coverage}createRun(R){const T=this.m.id,N=this.m.controllerId,O=(0,$.$ig)(),W=new D(this.s,T,O),x=Q=>(oe,..._)=>{if(G){console.warn(`Setting the state of test "${oe.id}" is a no-op after the run ends.`);return}this.m.isIncluded(oe)&&(this.y(oe),Q(oe,..._))},le=(Q,oe)=>{const _=oe instanceof Array?oe.map(u.TestMessage.from):[u.TestMessage.from(oe)];if(Q.uri&&Q.range){const Ee={range:u.Range.from(Q.range),uri:Q.uri};for(const he of _)he.location=he.location||Ee}this.s.$appendTestMessagesInRun(T,O,i.$qJ.fromExtHostTestItem(Q,N).toString(),_)};let G=!1;const J={isPersisted:this.m.isPersisted,token:this.h.token,name:R,get coverageProvider(){return W.coverageProvider},set coverageProvider(Q){W.coverageProvider=Q},enqueued:x(Q=>{this.s.$updateTestStateInRun(T,O,i.$qJ.fromExtHostTestItem(Q,N).toString(),1)}),skipped:x(Q=>{this.s.$updateTestStateInRun(T,O,i.$qJ.fromExtHostTestItem(Q,N).toString(),5)}),started:x(Q=>{this.s.$updateTestStateInRun(T,O,i.$qJ.fromExtHostTestItem(Q,N).toString(),2)}),errored:x((Q,oe,_)=>{le(Q,oe),this.s.$updateTestStateInRun(T,O,i.$qJ.fromExtHostTestItem(Q,N).toString(),6,_)}),failed:x((Q,oe,_)=>{le(Q,oe),this.s.$updateTestStateInRun(T,O,i.$qJ.fromExtHostTestItem(Q,N).toString(),4,_)}),passed:x((Q,oe)=>{this.s.$updateTestStateInRun(T,O,i.$qJ.fromExtHostTestItem(Q,this.m.controllerId).toString(),3,oe)}),appendOutput:(Q,oe,_)=>{G||(_&&(this.m.isIncluded(_)?this.y(_):_=void 0),this.s.$appendOutputToRun(T,O,f.$fe.fromString(Q),oe&&u.location.from(oe),_&&i.$qJ.fromExtHostTestItem(_,N).toString()))},end:()=>{G||(G=!0,this.s.$finishedTestRunTask(T,O),this.f.delete(O),this.f.size||this.w())}};return this.f.set(O,{run:J,coverage:W}),this.s.$startedTestRunTask(T,{id:O,name:R,running:!0}),J}u(){for(const{run:R}of this.f.values())R.end()}w(){this.c!==2&&(this.c=2,this.j.fire())}y(R){if(!(R instanceof w.$MM))throw new n.$rM(R.id);if(this.g.has(i.$qJ.fromExtHostTestItem(R,this.m.controllerId).toString()))return;const T=[],N=this.m.colllection.root;for(;;){const O=u.TestItem.from(R);if(T.unshift(O),this.g.has(O.extId)||(this.g.add(O.extId),R===N))break;R=R.parent||N}this.s.$addTestsToRun(this.m.controllerId,this.m.id,T)}dispose(){this.w(),super.dispose()}}class l{get trackers(){return this.c.values()}constructor(R){this.d=R,this.c=new Map}prepareForMainThreadTestRun(R,T,N,O){return this.f(R,T,N,O)}cancelRunById(R){for(const T of this.c.values())if(T.id===R){T.cancel();return}}cancelAllRuns(){for(const R of this.c.values())R.cancel()}createTestRun(R,T,N,O,W,x){const le=this.c.get(O);if(le)return le.createRun(W);const G=E.fromPublic(T,N,O,x),J=h(O);this.d.$startedExtensionTestRun({controllerId:T,continuous:!!O.continuous,profile:J&&{group:z[J.kind],id:J.profileId},exclude:O.exclude?.map(oe=>i.$qJ.fromExtHostTestItem(oe,N.root.id).toString())??[],id:G.id,include:O.include?.map(oe=>i.$qJ.fromExtHostTestItem(oe,N.root.id).toString())??[N.root.id],persist:x});const Q=this.f(O,G,R);return M.Event.once(Q.onEnd)(()=>{this.d.$finishedExtensionTestRun(G.id),Q.dispose()}),Q.createRun(W)}f(R,T,N,O){const W=new c(T,this.d,O);return this.c.set(R,W),M.Event.once(W.onEnd)(()=>this.c.delete(R)),W}}e.$yfc=l;const h=j=>{if(j.profile){if(!(j.profile instanceof P))throw new Error("TestRunRequest.profile is not an instance created from TestController.createRunProfile");return j.profile}};class E{static fromPublic(R,T,N,O){return new E(R,(0,$.$ig)(),N.include?.map(W=>i.$qJ.fromExtHostTestItem(W,R).toString())??[R],N.exclude?.map(W=>i.$qJ.fromExtHostTestItem(W,R).toString())??[],O,T)}static fromInternal(R,T){return new E(R.controllerId,R.runId,R.testIds,R.excludeExtIds,!0,T)}constructor(R,T,N,O,W,x){this.controllerId=R,this.id=T,this.isPersisted=W,this.colllection=x,this.c=N.map(le=>le+"\0"),this.d=O.map(le=>le+"\0")}isIncluded(R){const T=i.$qJ.fromExtHostTestItem(R,this.controllerId).toString()+"\0";for(const N of this.d)if(T===N||T.startsWith(N))return!1;for(const N of this.c)if(T===N||T.startsWith(N))return!0;return!1}}e.$zfc=E;class D{set coverageProvider(R){if(this.c)throw new Error("The TestCoverageProvider cannot be replaced after being provided");R&&(this.c=R,this.f.$signalCoverageAvailable(this.g,this.h))}get coverageProvider(){return this.c}constructor(R,T,N){this.f=R,this.g=T,this.h=N}async provideFileCoverage(R){if(!this.c)return[];this.d||(this.d=(async()=>this.c.provideFileCoverage(R))());try{return(await this.d)?.map(u.TestCoverage.fromFile)??[]}catch(T){throw this.d=void 0,T}}async resolveFileCoverage(R,T){const N=await this.d;let O=N?.[R];return!this.c||!N||!O?[]:(O.detailedCoverage||(O=N[R]=await this.c.resolveFileCoverage?.(O,T)??O),O.detailedCoverage?.map(u.TestCoverage.fromDetailed)??[])}}class m{get isEmpty(){return this.c.size===0&&this.f.size===0&&this.d.size===0}constructor(R){this.h=R,this.c=new Set,this.d=new Set,this.f=new Set,this.g=new Set}add(R){this.c.add(R)}update(R){Object.assign(R.revived,u.TestItem.toPlain(R.item)),this.c.has(R)||this.d.add(R)}remove(R){if(this.c.has(R)){this.c.delete(R);return}this.d.delete(R);const T=i.$qJ.parentId(R.item.extId);if(T&&this.g.has(T.toString())){this.g.add(R.item.extId);return}this.f.add(R)}getChangeEvent(){const{c:R,d:T,f:N}=this;return{get added(){return[...R].map(O=>O.revived)},get updated(){return[...T].map(O=>O.revived)},get removed(){return[...N].map(O=>O.revived)}}}complete(){this.isEmpty||this.h.fire(this.getChangeEvent())}}class p extends r.$xJ{constructor(){super(...arguments),this.q=new M.$Rd,this.onDidChangeTests=this.q.event}get rootTests(){return this.f}getMirroredTestDataById(R){return this.d.get(R)}getMirroredTestDataByReference(R){return this.d.get(R.id)}p(R,T){return{...R,revived:u.TestItem.toPlain(R.item),depth:T?T.depth+1:0,children:new Set}}o(){return new m(this.q)}}class S{constructor(R){this.d=R}checkout(){this.c||(this.c=this.f());const R=this.c;return R.observers++,{onDidChangeTest:R.tests.onDidChangeTests,get tests(){return[...R.tests.rootTests].map(T=>T.revived)},dispose:(0,b.$cb)(()=>{--R.observers===0&&(this.d.$unsubscribeFromDiffs(),this.c=void 0)})}}getMirroredTestDataByReference(R){return this.c?.tests.getMirroredTestDataByReference(R)}applyDiff(R){this.c?.tests.apply(R)}f(){const R=new p;return this.d.$subscribeToDiffs(),{observers:0,tests:R}}}class P{#e;#t;#i;#o;#r;get label(){return this.d}set label(R){R!==this.d&&(this.d=R,this.#e.$updateTestRunConfig(this.controllerId,this.profileId,{label:R}))}get supportsContinuousRun(){return this.g}set supportsContinuousRun(R){R!==this.g&&(this.g=R,this.#e.$updateTestRunConfig(this.controllerId,this.profileId,{supportsContinuousRun:R}))}get isDefault(){return this.f}set isDefault(R){R!==this.f&&(this.f=R,this.#e.$updateTestRunConfig(this.controllerId,this.profileId,{isDefault:R}))}get tag(){return this._tag}set tag(R){R?.id!==this._tag?.id&&(this._tag=R,this.#e.$updateTestRunConfig(this.controllerId,this.profileId,{tag:R?u.TestTag.namespace(this.controllerId,R.id):null}))}get configureHandler(){return this.c}set configureHandler(R){R!==this.c&&(this.c=R,this.#e.$updateTestRunConfig(this.controllerId,this.profileId,{hasConfigurationHandler:!!R}))}get isSelected(){return(0,a.$MF)(this.#t,"testingActiveProfile"),this.#i.has(this.profileId)}get onDidChangeSelected(){return(0,a.$MF)(this.#t,"testingActiveProfile"),M.Event.chain(this.#o,R=>R.map(T=>T.get(this.controllerId)?.get(this.profileId)).filter(I.$Kf))}constructor(R,T,N,O,W,x,le,G,J,Q,oe=!1,_=void 0,Ee=!1){this.controllerId=x,this.profileId=le,this.d=G,this.kind=J,this.runHandler=Q,this.f=oe,this._tag=_,this.g=Ee,this.#e=R,this.#r=T,this.#t=N,this.#i=O,this.#o=W,T.set(le,this);const he=z[J];if(typeof he!="number")throw new Error(`Unknown TestRunProfile.group ${J}`);this.#e.$publishTestRunProfile({profileId:le,controllerId:x,tag:_?u.TestTag.namespace(this.controllerId,_.id):null,label:G,group:he,isDefault:oe,hasConfigurationHandler:!1,supportsContinuousRun:Ee})}dispose(){this.#r?.delete(this.profileId)&&(this.#r=void 0,this.#e.$removeTestProfile(this.controllerId,this.profileId))}}e.$Afc=P;const z={[o.TestRunProfileKind.Coverage]:8,[o.TestRunProfileKind.Debug]:4,[o.TestRunProfileKind.Run]:2}}),define(ke[340],Se([1,0,19,8,4,6,150,15,7]),function(me,e,C,F,f,L,M,b,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wdc=void 0;class g{constructor(I,$){this.i=$,this.a=new f.$Rd({onListenerError:F.$1}),this.b=new f.$Rd({onListenerError:F.$1}),this.c=new f.$Rd({onListenerError:F.$1}),this.d=new f.$Rd({onListenerError:F.$1}),this.f=new f.$Rd({onListenerError:F.$1}),this.g=new f.$Rd({onListenerError:F.$1}),this.onDidChangeTextEditorSelection=this.a.event,this.onDidChangeTextEditorOptions=this.b.event,this.onDidChangeTextEditorVisibleRanges=this.c.event,this.onDidChangeTextEditorViewColumn=this.d.event,this.onDidChangeActiveTextEditor=this.f.event,this.onDidChangeVisibleTextEditors=this.g.event,this.h=I.getProxy(L.$xK.MainThreadTextEditors),this.i.onDidChangeVisibleTextEditors(y=>this.g.fire(y)),this.i.onDidChangeActiveTextEditor(y=>this.f.fire(y))}getActiveTextEditor(){return this.i.activeEditor()}getVisibleTextEditors(I){const $=this.i.allEditors();return I?$:$.map(y=>y.value)}async showTextDocument(I,$,y){let k;typeof $=="number"?k={position:b.ViewColumn.from($),preserveFocus:y}:typeof $=="object"?k={position:b.ViewColumn.from($.viewColumn),preserveFocus:$.preserveFocus,selection:typeof $.selection=="object"?b.Range.from($.selection):void 0,pinned:typeof $.preview=="boolean"?!$.preview:void 0}:k={preserveFocus:!1};const w=await this.h.$tryShowTextDocument(I.uri,k),u=w&&this.i.getEditor(w);if(u)return u.value;throw w?new Error(`Could NOT open editor for "${I.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${I.uri.toString()}".`)}createTextEditorDecorationType(I,$){return new M.$GM(this.h,I,$).value}$acceptEditorPropertiesChanged(I,$){const y=this.i.getEditor(I);if(!y)throw new Error("unknown text editor");if($.options&&y._acceptOptions($.options),$.selections){const k=$.selections.selections.map(b.Selection.to);y._acceptSelections(k)}if($.visibleRanges){const k=C.$Gb($.visibleRanges.map(b.Range.to));y._acceptVisibleRanges(k)}if($.options&&this.b.fire({textEditor:y.value,options:{...$.options,lineNumbers:b.TextEditorLineNumbersStyle.to($.options.lineNumbers)}}),$.selections){const k=v.TextEditorSelectionChangeKind.fromValue($.selections.source),w=$.selections.selections.map(b.Selection.to);this.a.fire({textEditor:y.value,selections:w,kind:k})}if($.visibleRanges){const k=C.$Gb($.visibleRanges.map(b.Range.to));this.c.fire({textEditor:y.value,visibleRanges:k})}}$acceptEditorPositionData(I){for(const $ in I){const y=this.i.getEditor($);if(!y)throw new Error("Unknown text editor");const k=b.ViewColumn.to(I[$]);y.value.viewColumn!==k&&(y._acceptViewColumn(k),this.d.fire({textEditor:y.value,viewColumn:k}))}}getDiffInformation(I){return Promise.resolve(this.h.$getDiffInformation(I))}}e.$Wdc=g}),define(ke[341],Se([1,0,2,5,6,3,7,15,26,18]),function(me,e,C,F,f,L,M,b,v,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dfc=e.$Cfc=void 0,e.$Cfc=(0,F.$Vh)("IExtHostTimeline");class A{constructor(y,k){this.b=new Map,this.c=new Map,this.a=y.getProxy(f.$xK.MainThreadTimeline),k.registerArgumentProcessor({processArgument:(w,u)=>{if(w&&w.$mid===12)if(this.b.get(w.source)&&v.$_l.equals(u,this.b.get(w.source)?.extension)){const o=w.uri===void 0?void 0:C.URI.revive(w.uri);return this.c.get(w.source)?.get(I(o))?.get(w.handle)}else return;return w}})}async $getTimeline(y,k,w,u){return this.b.get(y)?.provider.provideTimeline(C.URI.revive(k),w,u)}registerTimelineProvider(y,k,w,u){const o=new L.$Qc,i=this.d(k.id,u,o).bind(this);let n;k.onDidChange&&(n=k.onDidChange(a=>this.a.$emitTimelineChangeEvent({uri:void 0,reset:!0,...a,id:k.id}),this));const r=this.c;return this.f({...k,scheme:y,onDidChange:void 0,async provideTimeline(a,t,s){t?.resetCache&&(o.clear(),r.get(k.id)?.clear());const d=await k.provideTimeline(a,t,s);if(d==null)return;const c=i(a,t);return{...d,source:k.id,items:d.items.map(c)}},dispose(){for(const a of r.values())a.get(k.id)?.clear();n?.dispose(),o.dispose()}},w)}d(y,k,w){return(u,o)=>{let i;if(o?.cacheResults){let n=this.c.get(y);n===void 0&&(n=new Map,this.c.set(y,n));const r=I(u);i=n.get(r),i===void 0&&(i=new Map,n.set(r,i))}return n=>{const{iconPath:r,...a}=n,t=`${y}|${n.id??n.timestamp}`;i?.set(t,n);let s,d,c;n.iconPath&&(r instanceof M.$tL?c={id:r.id,color:r.color}:C.URI.isUri(r)?(s=r,d=r):{light:s,dark:d}=r);let l;return M.$ZK.isMarkdownString(a.tooltip)?l=b.MarkdownString.from(a.tooltip):(0,g.$Cf)(a.tooltip)?l=a.tooltip:M.$ZK.isMarkdownString(a.detail)?(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),l=b.MarkdownString.from(a.detail)):(0,g.$Cf)(a.detail)&&(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),l=a.detail),{...a,id:a.id??void 0,handle:t,source:y,command:n.command?k.toInternal(n.command,w):void 0,icon:s,iconDark:d,themeIcon:c,tooltip:l,accessibilityInformation:n.accessibilityInformation}}}}f(y,k){if(this.b.get(y.id))throw new Error(`Timeline Provider ${y.id} already exists.`);return this.a.$registerTimelineProvider({id:y.id,label:y.label,scheme:y.scheme}),this.b.set(y.id,{provider:y,extension:k}),(0,L.$Pc)(()=>{for(const u of this.c.values())u.get(y.id)?.clear();this.b.delete(y.id),this.a.$unregisterTimelineProvider(y.id),y.dispose()})}}e.$Dfc=A;function I($){return $?.toString()}}),define(ke[72],Se([1,0,21,4,3,221,5,14,88,6,27,20,7]),function(me,e,C,F,f,L,M,b,v,g,A,I,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Swb=e.$Rwb=e.TunnelDtoConverter=void 0;class y extends v.$mv{}var k;(function(u){function o(n){return{remoteAddress:n.remoteAddress,localAddress:n.localAddress,public:!!n.public,privacy:n.privacy??(n.public?v.TunnelPrivacyId.Public:v.TunnelPrivacyId.Private),protocol:n.protocol}}u.fromApiTunnel=o;function i(n){return{remoteAddress:{host:n.tunnelRemoteHost,port:n.tunnelRemotePort},localAddress:n.localAddress,public:n.privacy!==v.TunnelPrivacyId.ConstantPrivate&&n.privacy!==v.TunnelPrivacyId.ConstantPrivate,privacy:n.privacy,protocol:n.protocol}}u.fromServiceTunnel=i})(k||(e.TunnelDtoConverter=k={})),e.$Rwb=(0,M.$Vh)("IExtHostTunnelService");let w=class extends f.$Rc{constructor(o,i,n){super(),this.s=n,this.f=()=>Promise.resolve(!0),this.g=new Map,this.h=new F.$Rd,this.onDidChangeTunnels=this.h.event,this.n=0,this.r=new Map,this.a=o.getProxy(g.$xK.MainThreadTunnelService)}async openTunnel(o,i){this.s.trace(`ForwardedPorts: (ExtHostTunnelService) ${o.identifier.value} called openTunnel API for ${i.remoteAddress.host}:${i.remoteAddress.port}.`);const n=await this.a.$openTunnel(i,o.displayName);if(n){const r=new y(n.remoteAddress,n.localAddress,()=>this.a.$closeTunnel(n.remoteAddress));return this.B(r),r}}async getTunnels(){return this.a.$getTunnels()}u(){return this.n++}registerPortsAttributesProvider(o,i){const n=this.u();return this.r.set(n,{selector:o,provider:i}),this.a.$registerPortsAttributesProvider(o,n),new $.$zK(()=>{this.r.delete(n),this.a.$unregisterPortsAttributesProvider(n)})}async $providePortAttributes(o,i,n,r,a){const t=[];for(const d of o){const c=this.r.get(d);if(!c)return[];t.push(...await Promise.all(i.map(async l=>{let h;try{h=await c.provider.providePortAttributes({port:l,pid:n,commandLine:r},a)}catch{h=await c.provider.providePortAttributes(l,n,r,a)}return{providedAttributes:h,port:l}})))}const s=t.filter(d=>!!d.providedAttributes);return s.length>0?s.map(d=>({autoForwardAction:d.providedAttributes.autoForwardAction,port:d.port})):[]}async $registerCandidateFinder(o){}registerTunnelProvider(o,i){if(this.b)throw new Error("A tunnel provider has already been registered. Only the first tunnel provider to be registered will be used.");this.b=async(r,a)=>await o.provideTunnel(r,a,new C.$2d().token)??void 0;const n=i.tunnelFeatures?{elevation:!!i.tunnelFeatures?.elevation,privacyOptions:i.tunnelFeatures?.privacyOptions}:void 0;return this.a.$setTunnelProvider(n),Promise.resolve((0,f.$Pc)(()=>{this.b=void 0,this.a.$setTunnelProvider(void 0)}))}async setTunnelFactory(o,i){if(o){o.candidatePortSource!==void 0&&this.a.$setCandidatePortSource(o.candidatePortSource),o.showCandidatePort&&(this.f=o.showCandidatePort,this.a.$setCandidateFilter());const n=o.tunnelFactory??(i?this.w(i):void 0);if(n){this.b=n;let r=o.tunnelFeatures?.privacyOptions??[];o.tunnelFeatures?.public&&r.length===0&&(r=[{id:"private",label:L.localize(0,null),themeIcon:"lock"},{id:"public",label:L.localize(1,null),themeIcon:"eye"}]);const a=o.tunnelFeatures?{elevation:!!o.tunnelFeatures?.elevation,public:!!o.tunnelFeatures?.public,privacyOptions:r}:void 0;this.a.$setTunnelProvider(a)}}else this.b=void 0;return(0,f.$Pc)(()=>{this.b=void 0})}w(o){}async $closeTunnel(o,i){if(this.g.has(o.host)){const n=this.g.get(o.host);n.has(o.port)&&(i&&n.get(o.port).disposeListener.dispose(),await n.get(o.port).tunnel.dispose(),n.delete(o.port))}}async $onDidTunnelsChange(){this.h.fire()}async $forwardPort(o,i){if(this.b)try{this.s.trace("ForwardedPorts: (ExtHostTunnelService) Getting tunnel from provider.");const n=this.b(o,i);if(this.s.trace("ForwardedPorts: (ExtHostTunnelService) Got tunnel promise from provider."),n!==void 0){const r=await n;if(this.s.trace("ForwardedPorts: (ExtHostTunnelService) Successfully awaited tunnel from provider."),r===void 0){this.s.error("ForwardedPorts: (ExtHostTunnelService) Resolved tunnel is undefined");return}this.g.has(o.remoteAddress.host)||this.g.set(o.remoteAddress.host,new Map);const a=this.B(r.onDidDispose(()=>(this.s.trace("ForwardedPorts: (ExtHostTunnelService) Extension fired tunnel's onDidDispose."),this.a.$closeTunnel(r.remoteAddress))));return this.g.get(o.remoteAddress.host).set(o.remoteAddress.port,{tunnel:r,disposeListener:a}),k.fromApiTunnel(r)}else this.s.trace("ForwardedPorts: (ExtHostTunnelService) Tunnel is undefined")}catch(n){if(this.s.trace("ForwardedPorts: (ExtHostTunnelService) tunnel provider error"),n instanceof Error)return n.message}}async $applyCandidateFilter(o){const i=await Promise.all(o.map(r=>this.f(r.host,r.port,r.detail??""))),n=o.filter((r,a)=>i[a]);return this.s.trace(`ForwardedPorts: (ExtHostTunnelService) filtered from ${o.map(r=>r.port).join(", ")} to ${n.map(r=>r.port).join(", ")}`),n}};e.$Swb=w,e.$Swb=w=He([Be(0,I.$zM),Be(1,A.$PM),Be(2,b.$dj)],w)}),define(ke[342],Se([1,0,3,17,2,6]),function(me,e,C,F,f,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ffc=void 0;class M{static{this.a=new Set([F.Schemas.http,F.Schemas.https])}constructor(v){this.c=new Map,this.b=v.getProxy(L.$xK.MainThreadUriOpeners)}registerExternalUriOpener(v,g,A,I){if(this.c.has(g))throw new Error(`Opener with id '${g}' already registered`);const $=I.schemes.find(y=>!M.a.has(y));if($)throw new Error(`Scheme '${$}' is not supported. Only http and https are currently supported.`);return this.c.set(g,A),this.b.$registerUriOpener(g,I.schemes,v,I.label),(0,C.$Pc)(()=>{this.c.delete(g),this.b.$unregisterUriOpener(g)})}async $canOpenUri(v,g,A){const I=this.c.get(v);if(!I)throw new Error(`Unknown opener with id: ${v}`);const $=f.URI.revive(g);return I.canOpenExternalUri($,A)}async $openUri(v,g,A){const I=this.c.get(v);if(!I)throw new Error(`Unknown opener id: '${v}'`);return I.openExternalUri(f.URI.revive(g.resolvedUri),{sourceUri:f.URI.revive(g.sourceUri)},A)}}e.$Ffc=M}),define(ke[343],Se([1,0,6,2,3,8,26]),function(me,e,C,F,f,L,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gfc=void 0;class b{static{this.a=0}constructor(g){this.c=new M.$am,this.d=new Map,this.b=g.getProxy(C.$xK.MainThreadUrls)}registerUriHandler(g,A){const I=g.identifier;if(this.c.has(I))throw new Error(`Protocol handler already registered for extension ${I}`);const $=b.a++;return this.c.add(I),this.d.set($,A),this.b.$registerUriHandler($,I,g.displayName||g.name),(0,f.$Pc)(()=>{this.c.delete(I),this.d.delete($),this.b.$unregisterUriHandler($)})}$handleExternalUri(g,A){const I=this.d.get(g);if(!I)return Promise.resolve(void 0);try{I.handleUri(F.URI.revive(A))}catch($){(0,L.$Z)($)}return Promise.resolve(void 0)}async createAppUri(g){return F.URI.revive(await this.b.$createAppUri(g))}}e.$Gfc=b}),define(ke[93],Se([1,0,4,3,17,24,2,238,275,113,6]),function(me,e,C,F,f,L,M,b,v,g,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cec=e.$bec=e.$aec=e.$_dc=e.$$dc=void 0;class I{#e;#t;#i;#o;#r;#n;#a;#s;#c;#u;#l;#d;constructor(r,a,t,s,d,c,l){this.#a="",this.#c=!1,this.#u=!1,this._onMessageEmitter=new C.$Rd,this.onDidReceiveMessage=this._onMessageEmitter.event,this.#h=new C.$Rd,this._onDidDispose=this.#h.event,this.#e=r,this.#t=a,this.#s=t,this.#o=s,this.#r=d,this.#n=c,this.#l=$(c),this.#d=y(c),this.#i=l}#h;dispose(){this.#c=!0,this.#h.fire(),this.#h.dispose(),this._onMessageEmitter.dispose()}asWebviewUri(r){return this.#u=!0,(0,g.$$tb)(r,this.#o)}get cspSource(){const r=this.#n.extensionLocation;if(r.scheme===f.Schemas.https||r.scheme===f.Schemas.http){let a=r.toString();return a.endsWith("/")||(a+="/"),a+" "+g.$0tb}return g.$0tb}get html(){return this.a(),this.#a}set html(r){this.a(),this.#a!==r&&(this.#a=r,this.#d&&!this.#u&&/(["'])vscode-resource:([^\s'"]+?)(["'])/i.test(r)&&(this.#u=!0,this.#i.report("Webview vscode-resource: uris",this.#n,"Please migrate to use the 'webview.asWebviewUri' api instead: https://aka.ms/vscode-webview-use-aswebviewuri")),this.#t.$setHtml(this.#e,this.b(r)))}get options(){return this.a(),this.#s}set options(r){this.a(),L.$en(this.#s,r)||this.#t.$setOptions(this.#e,u(this.#n,this.#r,r)),this.#s=r}async postMessage(r){if(this.#c)return!1;const a=(0,v.$_cb)(r,{serializeBuffersForPostMessage:this.#l});return this.#t.$postMessage(this.#e,a.message,...a.buffers)}a(){if(this.#c)throw new Error("Webview is disposed")}b(r){if(!this.#d)return r;const a=this.#n.extensionLocation?.scheme===f.Schemas.vscodeRemote,t=this.#n.extensionLocation.scheme===f.Schemas.vscodeRemote?this.#n.extensionLocation.authority:void 0;return r.replace(/(["'])(?:vscode-resource):(\/\/([^\s\/'"]+?)(?=\/))?([^\s'"]+?)(["'])/gi,(s,d,c,l,h,E)=>{const D=M.URI.from({scheme:l||"file",path:decodeURIComponent(h)}),m=(0,g.$$tb)(D,{isRemote:a,authority:t}).toString();return`${d}${m}${E}`}).replace(/(["'])(?:vscode-webview-resource):(\/\/[^\s\/'"]+\/([^\s\/'"]+?)(?=\/))?([^\s'"]+?)(["'])/gi,(s,d,c,l,h,E)=>{const D=M.URI.from({scheme:l||"file",path:decodeURIComponent(h)}),m=(0,g.$$tb)(D,{isRemote:a,authority:t}).toString();return`${d}${m}${E}`})}}e.$$dc=I;function $(n){try{const r=(0,b.$To)((0,b.$So)(n.engines.vscode));return!!r&&r.majorBase>=1&&r.minorBase>=57}catch{return!1}}e.$_dc=$;function y(n){try{const r=(0,b.$To)((0,b.$So)(n.engines.vscode));return r?r.majorBase<1||r.majorBase===1&&r.minorBase<60:!1}catch{return!1}}class k extends F.$Rc{constructor(r,a,t,s,d){super(),this.c=a,this.f=t,this.g=s,this.h=d,this.b=new Map,this.a=r.getProxy(A.$xK.MainThreadWebviews)}dispose(){super.dispose();for(const r of this.b.values())r.dispose();this.b.clear()}$onMessage(r,a,t){const s=this.j(r);if(s){const{message:d}=(0,v.$adb)(a,t.value);s._onMessageEmitter.fire(d)}}$onMissingCsp(r,a){this.g.warn(`${a} created a webview without a content security policy: https://aka.ms/vscode-webview-missing-csp`)}createNewWebview(r,a,t){const s=new I(r,this.a,o(a),this.c,this.f,t,this.h);this.b.set(r,s);const d=s._onDidDispose(()=>{d.dispose(),this.deleteWebview(r)});return s}deleteWebview(r){this.b.delete(r)}j(r){return this.b.get(r)}}e.$aec=k;function w(n){return{id:n.identifier,location:n.extensionLocation}}e.$bec=w;function u(n,r,a){return{enableCommandUris:a.enableCommandUris,enableScripts:a.enableScripts,enableForms:a.enableForms,portMapping:a.portMapping,localResourceRoots:a.localResourceRoots||i(n,r)}}e.$cec=u;function o(n){return{enableCommandUris:n.enableCommandUris,enableScripts:n.enableScripts,enableForms:n.enableForms,portMapping:n.portMapping,localResourceRoots:n.localResourceRoots?.map(r=>M.URI.from(r))}}function i(n,r){return[...(r?.getWorkspaceFolders()||[]).map(a=>a.uri),n.extensionLocation]}}),define(ke[344],Se([1,0,21,52,3,17,23,2,15,93,110,6,7]),function(me,e,C,F,f,L,M,b,v,g,A,I,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$eec=void 0;class y{constructor(s,d){this.document=s,this.b=d,this.a=1,this.c=new A.$Ddc("custom documents")}addEdit(s){return this.c.add([s])}async undo(s,d){await this.f(s).undo(),d||this.disposeBackup()}async redo(s,d){await this.f(s).redo(),d||this.disposeBackup()}disposeEdits(s){for(const d of s)this.c.delete(d)}getNewBackupUri(){if(!this.b)throw new Error("Backup requires a valid storage path");const s=a(this.document.uri)+this.a++;return(0,M.$zg)(this.b,s)}updateBackup(s){this.d?.delete(),this.d=s}disposeBackup(){this.d?.delete(),this.d=void 0}f(s){const d=this.c.get(s,0);if(!d)throw new Error("No edit found");return d}}class k{constructor(){this.a=new Map}get(s,d){return this.a.get(this.b(s,d))}add(s,d,c){const l=this.b(s,d.uri);if(this.a.has(l))throw new Error(`Document already exists for viewType:${s} resource:${d.uri}`);const h=new y(d,c);return this.a.set(l,h),h}delete(s,d){const c=this.b(s,d.uri);this.a.delete(c)}b(s,d){return`${s}@@@${d}`}}var w;(function(t){t[t.Text=0]="Text",t[t.Custom=1]="Custom"})(w||(w={}));class u{constructor(){this.a=new Map}addTextProvider(s,d,c){return this.b(0,s,d,c)}addCustomProvider(s,d,c){return this.b(1,s,d,c)}get(s){return this.a.get(s)}b(s,d,c,l){if(this.a.has(d))throw new Error(`Provider for viewType:${d} already registered`);return this.a.set(d,{type:s,extension:c,provider:l}),new $.$zK(()=>this.a.delete(d))}}class o{constructor(s,d,c,l,h){this.d=d,this.f=c,this.g=l,this.h=h,this.b=new u,this.c=new k,this.a=s.getProxy(I.$xK.MainThreadCustomEditors)}registerCustomEditorProvider(s,d,c,l){const h=new f.$Qc;return n(c)?(h.add(this.b.addTextProvider(d,s,c)),this.a.$registerTextEditorProvider((0,g.$bec)(s),d,l.webviewOptions||{},{supportsMove:!!c.moveCustomTextEditor},(0,g.$_dc)(s))):(h.add(this.b.addCustomProvider(d,s,c)),i(c)&&h.add(c.onDidChangeCustomDocument(E=>{const D=this.i(d,E.document.uri);if(r(E)){const m=D.addEdit(E);this.a.$onDidEdit(E.document.uri,d,m,E.label)}else this.a.$onContentChange(E.document.uri,d)})),this.a.$registerCustomEditorProvider((0,g.$bec)(s),d,l.webviewOptions||{},!!l.supportsMultipleEditorsPerDocument,(0,g.$_dc)(s))),$.$zK.from(h,new $.$zK(()=>{this.a.$unregisterEditorProvider(d)}))}async $createCustomDocument(s,d,c,l,h){const E=this.b.get(d);if(!E)throw new Error(`No provider found for '${d}'`);if(E.type!==1)throw new Error(`Invalid provide type for '${d}'`);const D=b.URI.revive(s),m=await E.provider.openCustomDocument(D,{backupId:c,untitledDocumentData:l?.buffer},h);let p;return i(E.provider)&&this.f&&(p=this.f.workspaceValue(E.extension)??this.f.globalValue(E.extension)),this.c.add(d,m,p),{editable:i(E.provider)}}async $disposeCustomDocument(s,d){const c=this.b.get(d);if(!c)throw new Error(`No provider found for '${d}'`);if(c.type!==1)throw new Error(`Invalid provider type for '${d}'`);const l=b.URI.revive(s),{document:h}=this.i(d,l);this.c.delete(d,h),h.dispose()}async $resolveCustomEditor(s,d,c,l,h,E){const D=this.b.get(c);if(!D)throw new Error(`No provider found for '${c}'`);const m=v.ViewColumn.to(h),p=this.g.createNewWebview(d,l.contentOptions,D.extension),S=this.h.createNewWebviewPanel(d,c,l.title,m,l.options,p,l.active),P=b.URI.revive(s);switch(D.type){case 1:{const{document:z}=this.i(c,P);return D.provider.resolveCustomEditor(z,S,E)}case 0:{const z=this.d.getDocument(P);return D.provider.resolveCustomTextEditor(z,S,E)}default:throw new Error("Unknown webview provider type")}}$disposeEdits(s,d,c){this.i(d,s).disposeEdits(c)}async $onMoveCustomEditor(s,d,c){const l=this.b.get(c);if(!l)throw new Error(`No provider found for '${c}'`);if(!l.provider.moveCustomTextEditor)throw new Error(`Provider does not implement move '${c}'`);const h=this.h.getWebviewPanel(s);if(!h)throw new Error("No webview found");const E=b.URI.revive(d),D=this.d.getDocument(E);await l.provider.moveCustomTextEditor(D,h,C.CancellationToken.None)}async $undo(s,d,c,l){return this.i(d,s).undo(c,l)}async $redo(s,d,c,l){return this.i(d,s).redo(c,l)}async $revert(s,d,c){const l=this.i(d,s);await this.j(d).revertCustomDocument(l.document,c),l.disposeBackup()}async $onSave(s,d,c){const l=this.i(d,s);await this.j(d).saveCustomDocument(l.document,c),l.disposeBackup()}async $onSaveAs(s,d,c,l){const h=this.i(d,s);return this.j(d).saveCustomDocumentAs(h.document,b.URI.revive(c),l)}async $backup(s,d,c){const l=this.i(d,s),E=await this.j(d).backupCustomDocument(l.document,{destination:l.getNewBackupUri()},c);return l.updateBackup(E),E.id}i(s,d){const c=this.c.get(s,b.URI.revive(d));if(!c)throw new Error("No custom document found");return c}j(s){const c=this.b.get(s)?.provider;if(!c||!i(c))throw new Error("Custom document is not editable");return c}}e.$eec=o;function i(t){return!!t.onDidChangeCustomDocument}function n(t){return typeof t.resolveCustomTextEditor=="function"}function r(t){return typeof t.undo=="function"&&typeof t.redo=="function"}function a(t){const s=t.scheme===L.Schemas.file||t.scheme===L.Schemas.untitled?t.fsPath:t.toString();return(0,F.$Ji)(s)+""}}),define(ke[345],Se([1,0,4,3,2,32,15,93,6,7]),function(me,e,C,F,f,L,M,b,v,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dec=void 0;class A extends F.$Rc{#e;#t;#i;#o;#r;#n;#a;#s;#c;#u;#l;#d;#h;constructor(k,w,u,o){super(),this.#s=void 0,this.#c=!0,this.#l=!1,this.#d=this.B(new C.$Rd),this.onDidDispose=this.#d.event,this.#h=this.B(new C.$Rd),this.onDidChangeViewState=this.#h.event,this.#e=k,this.#t=w,this.#o=u,this.#i=o.viewType,this.#r=o.panelOptions,this.#s=o.viewColumn,this.#n=o.title,this.#u=o.active}dispose(){this.#l||(this.#l=!0,this.#d.fire(),this.#t.$disposeWebview(this.#e),this.#o.dispose(),super.dispose())}get webview(){return this.c(),this.#o}get viewType(){return this.c(),this.#i}get title(){return this.c(),this.#n}set title(k){this.c(),this.#n!==k&&(this.#n=k,this.#t.$setTitle(this.#e,k))}get iconPath(){return this.c(),this.#a}set iconPath(k){this.c(),this.#a!==k&&(this.#a=k,this.#t.$setIconPath(this.#e,f.URI.isUri(k)?{light:k,dark:k}:k))}get options(){return this.#r}get viewColumn(){if(this.c(),!(typeof this.#s=="number"&&this.#s<0))return this.#s}get active(){return this.c(),this.#u}get visible(){return this.c(),this.#c}_updateViewState(k){this.#l||(this.active!==k.active||this.visible!==k.visible||this.viewColumn!==k.viewColumn)&&(this.#u=k.active,this.#c=k.visible,this.#s=k.viewColumn,this.#h.fire({webviewPanel:this}))}reveal(k,w){this.c(),this.#t.$reveal(this.#e,{viewColumn:typeof k>"u"?void 0:M.ViewColumn.from(k),preserveFocus:!!w})}c(){if(this.#l)throw new Error("Webview is disposed")}}class I extends F.$Rc{static c(){return(0,L.$ig)()}constructor(k,w,u){super(),this.j=w,this.m=u,this.g=new Map,this.h=new Map,this.f=k.getProxy(v.$xK.MainThreadWebviewPanels)}dispose(){super.dispose(),this.g.forEach(k=>k.dispose()),this.g.clear()}createWebviewPanel(k,w,u,o,i={}){const n=typeof o=="object"?o.viewColumn:o,r={viewColumn:M.ViewColumn.from(n),preserveFocus:typeof o=="object"&&!!o.preserveFocus},a=(0,b.$_dc)(k),t=I.c();this.f.$createWebviewPanel((0,b.$bec)(k),t,w,{title:u,panelOptions:$(i),webviewOptions:(0,b.$cec)(k,this.m,i),serializeBuffersForPostMessage:a},r);const s=this.j.createNewWebview(t,i,k);return this.createNewWebviewPanel(t,w,u,n,i,s,!0)}$onDidChangeWebviewPanelViewStates(k){const w=Object.keys(k);w.sort((u,o)=>{const i=k[u],n=k[o];return i.active?1:n.active?-1:+i.visible-+n.visible});for(const u of w){const o=this.getWebviewPanel(u);if(!o)continue;const i=k[u];o._updateViewState({active:i.active,visible:i.visible,viewColumn:M.ViewColumn.to(i.position)})}}async $onDidDisposeWebviewPanel(k){this.getWebviewPanel(k)?.dispose(),this.g.delete(k),this.j.deleteWebview(k)}registerWebviewPanelSerializer(k,w,u){if(this.h.has(w))throw new Error(`Serializer for '${w}' already registered`);return this.h.set(w,{serializer:u,extension:k}),this.f.$registerSerializer(w,{serializeBuffersForPostMessage:(0,b.$_dc)(k)}),new g.$zK(()=>{this.h.delete(w),this.f.$unregisterSerializer(w)})}async $deserializeWebviewPanel(k,w,u,o){const i=this.h.get(w);if(!i)throw new Error(`No serializer found for '${w}'`);const{serializer:n,extension:r}=i,a=this.j.createNewWebview(k,u.webviewOptions,r),t=this.createNewWebviewPanel(k,w,u.title,o,u.panelOptions,a,u.active);await n.deserializeWebviewPanel(t,u.state)}createNewWebviewPanel(k,w,u,o,i,n,r){const a=new A(k,this.f,n,{viewType:w,title:u,viewColumn:o,panelOptions:i,active:r});return this.g.set(k,a),a}getWebviewPanel(k){return this.g.get(k)}}e.$dec=I;function $(y){return{enableFindWidget:y.enableFindWidget,retainContextWhenHidden:y.retainContextWhenHidden}}}),define(ke[346],Se([1,0,4,3,93,15,6,7]),function(me,e,C,F,f,L,M,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hfc=void 0;class v extends F.$Rc{#e;#t;#i;#o;#r;#n;#a;#s;#c;constructor(I,$,y,k,w,u){super(),this.#r=!1,this.#u=this.B(new C.$Rd),this.onDidChangeVisibility=this.#u.event,this.#l=this.B(new C.$Rd),this.onDidDispose=this.#l.event,this.#i=y,this.#a=k,this.#e=I,this.#t=$,this.#o=w,this.#n=u}dispose(){this.#r||(this.#r=!0,this.#l.fire(),this.#o.dispose(),super.dispose())}#u;#l;get title(){return this.a(),this.#a}set title(I){this.a(),this.#a!==I&&(this.#a=I,this.#t.$setWebviewViewTitle(this.#e,I))}get description(){return this.a(),this.#s}set description(I){this.a(),this.#s!==I&&(this.#s=I,this.#t.$setWebviewViewDescription(this.#e,I))}get visible(){return this.#n}get webview(){return this.#o}get viewType(){return this.#i}_setVisible(I){I===this.#n||this.#r||(this.#n=I,this.#u.fire())}get badge(){return this.a(),this.#c}set badge(I){this.a(),!(I?.value===this.#c?.value&&I?.tooltip===this.#c?.tooltip)&&(this.#c=L.ViewBadge.from(I),this.#t.$setWebviewViewBadge(this.#e,I))}show(I){this.a(),this.#t.$show(this.#e,!!I)}a(){if(this.#r)throw new Error("Webview is disposed")}}class g{constructor(I,$){this.d=$,this.b=new Map,this.c=new Map,this.a=I.getProxy(M.$xK.MainThreadWebviewViews)}registerWebviewViewProvider(I,$,y,k){if(this.b.has($))throw new Error(`View provider for '${$}' already registered`);return this.b.set($,{provider:y,extension:I}),this.a.$registerWebviewViewProvider((0,f.$bec)(I),$,{retainContextWhenHidden:k?.retainContextWhenHidden,serializeBuffersForPostMessage:(0,f.$_dc)(I)}),new b.$zK(()=>{this.b.delete($),this.a.$unregisterWebviewViewProvider($)})}async $resolveWebviewView(I,$,y,k,w){const u=this.b.get($);if(!u)throw new Error(`No view provider found for '${$}'`);const{provider:o,extension:i}=u,n=this.d.createNewWebview(I,{},i),r=new v(I,this.a,$,y,n,!0);this.c.set(I,r),await o.resolveWebviewView(r,{state:k},w)}async $onDidChangeWebviewViewVisibility(I,$){this.e(I)._setVisible($)}async $disposeWebviewView(I){const $=this.e(I);this.c.delete(I),$.dispose(),this.d.deleteWebview(I)}e(I){const $=this.c.get(I);if(!$)throw new Error("No webview found");return $}}e.$Hfc=g}),define(ke[153],Se([1,0,4,6,2,17,13,5,20,25]),function(me,e,C,F,f,L,M,b,v,g){"use strict";var A;Object.defineProperty(e,"__esModule",{value:!0}),e.$Jfc=e.$Ifc=void 0;let I=class{static{A=this}static{this.a={focused:!0,active:!0}}getState(y){const k=this.d;return{get focused(){return k.focused},get active(){return(0,g.$MF)(y,"windowActivity"),k.active}}}constructor(y){this.c=new C.$Rd,this.onDidChangeWindowState=this.c.event,this.d=A.a,this.b=y.getProxy(F.$xK.MainThreadWindow),this.b.$getInitialState().then(({isFocused:k,isActive:w})=>{this.onDidChangeWindowProperty("focused",k),this.onDidChangeWindowProperty("active",w)})}$onDidChangeWindowFocus(y){this.onDidChangeWindowProperty("focused",y)}$onDidChangeWindowActive(y){this.onDidChangeWindowProperty("active",y)}onDidChangeWindowProperty(y,k){k!==this.d[y]&&(this.d={...this.d,[y]:k},this.c.fire(this.d))}openUri(y,k){let w;if(typeof y=="string"){w=y;try{y=f.URI.parse(y)}catch{return Promise.reject(`Invalid uri - '${y}'`)}}return(0,M.$Fe)(y.scheme)?Promise.reject("Invalid scheme - cannot be empty"):y.scheme===L.Schemas.command?Promise.reject(`Invalid scheme '${y.scheme}'`):this.b.$openUri(y,w,k)}async asExternalUri(y,k){if((0,M.$Fe)(y.scheme))return Promise.reject("Invalid scheme - cannot be empty");const w=await this.b.$asExternalUri(y,k);return f.URI.from(w)}};e.$Ifc=I,e.$Ifc=I=A=He([Be(0,v.$zM)],I),e.$Jfc=(0,b.$Vh)("IExtHostWindow")}),define(ke[347],Se([1,0,315,27,20]),function(me,e,C,F,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lgc=void 0;const L=1024*1024;let M=class extends C.$Mfc{constructor(v,g){super(v,g),this.g=!1,this.j("stderr","error"),this.j("stdout","log")}f(v,g,A){const I=v==="error"||v==="warn"?process.stderr:process.stdout;this.g=!0,I.write(`
START_NATIVE_LOG
`),g.apply(console,A),I.write(`
END_NATIVE_LOG
`),this.g=!1}j(v,g){const A=process[v],I=A.write;let $="";Object.defineProperty(A,"write",{set:()=>{},get:()=>(y,k,w)=>{if(!this.g){$+=y.toString(k);const u=$.length>L?$.length:$.lastIndexOf(`
`);u!==-1&&(console[g]($.slice(0,u)),$=$.slice(u+1))}I.call(A,y,k,w)}})}};e.$lgc=M,e.$lgc=M=He([Be(0,f.$zM),Be(1,F.$PM)],M)}),define(ke[348],Se([1,0,71,17,14,250,31,11]),function(me,e,C,F,f,L,M,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mgc=void 0;let v=class{constructor(I,$){I.addFileSystemProvider(F.Schemas.file,new g($),{isCaseSensitive:b.$k})}};e.$mgc=v,e.$mgc=v=He([Be(0,C.$8dc),Be(1,f.$dj)],v);class g{constructor(I){this.b=I,this.a=new L.$gq(this.b)}async stat(I){const $=await this.a.stat(I);return{type:$.type,ctime:$.ctime,mtime:$.mtime,size:$.size,permissions:$.permissions===M.FilePermission.Readonly?1:void 0}}readDirectory(I){return this.a.readdir(I)}createDirectory(I){return this.a.mkdir(I)}readFile(I){return this.a.readFile(I)}writeFile(I,$,y){return this.a.writeFile(I,$,{...y,unlock:!1,atomic:!1})}delete(I,$){return this.a.delete(I,{...$,useTrash:!1,atomic:!1})}rename(I,$,y){return this.a.rename(I,$,y)}copy(I,$,y){return this.a.copy(I,$,y)}get onDidChangeFile(){throw new Error("Method not implemented.")}watch(I,$){throw new Error("Method not implemented.")}}}),define(ke[349],Se([1,0,16,63,32,35,3,6,2,20]),function(me,e,C,F,f,L,M,b,v,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kgc=void 0;let A=class extends M.$Rc{constructor($,y){super();const k=$.getProxy(b.$xK.MainThreadDownloadService);y.registerCommand(!1,"_workbench.downloadResource",async w=>{const u=v.URI.file((0,C.$ic)((0,F.tmpdir)(),(0,f.$ig)()));return await k.$download(w,u),u})}};e.$kgc=A,e.$kgc=A=He([Be(0,g.$zM),Be(1,L.$VM)],A)}),define(ke[350],Se([1,0,152,17,252,32]),function(me,e,C,F,f,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xgc=void 0;class M extends C.$Lfc{s(v,g,A){return v.scheme===F.Schemas.file?new f.$LN(A?.name||(0,L.$ig)(),v.fsPath,!A?.donotRotate,!!A?.donotUseFormatters,g):super.s(v,g,A)}registerLogger(v){super.registerLogger(v),this.r.$registerLogger(v)}deregisterLogger(v){super.deregisterLogger(v),this.r.$deregisterLogger(v)}}e.$xgc=M}),define(ke[351],Se([1,0,55,16,2,92,3,17,12,30]),function(me,e,C,F,f,L,M,b,v,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wgc=void 0;class A extends L.$0dc{constructor(){super(...arguments),this.i=null}async g(t){const s=await super.g(t);if(s.scheme!==b.Schemas.file)return s;if(this.b.skipWorkspaceStorageLock)return this.d.info(`Skipping acquiring lock for ${s.fsPath}.`),s;const d=s.fsPath;let c=0;do{let l;c===0?l=d:l=/[/\\]$/.test(d)?`${d.substr(0,d.length-1)}-${c}`:`${d}-${c}`,await I(l);const h=F.$ic(l,"vscode.lock"),E=await w(this.d,h,!1);if(E)return this.i=E,process.on("exit",()=>{E.dispose()}),f.URI.file(l);c++}while(c<10);return s}onWillDeactivateAll(){this.i?.setWillRelease(6e3)}}e.$wgc=A;async function I(a){try{await g.Promises.stat(a);return}catch{}try{await g.Promises.mkdir(a,{recursive:!0})}catch{}}const $=1e3,y=10*60*1e3;class k extends M.$Rc{constructor(t,s){super(),this.b=t,this.c=s,this.a=this.B(new v.$9g),this.a.cancelAndSet(async()=>{const d=await u(t,s);(!d||d.pid!==process.pid)&&(t.info(`Lock '${s}': The lock was lost unexpectedly.`),this.a.cancel());try{await g.Promises.utimes(s,new Date,new Date)}catch(c){t.error(c),t.info(`Lock '${s}': Could not update mtime.`)}},$)}dispose(){super.dispose();try{C.unlinkSync(this.c)}catch{}}async setWillRelease(t){this.b.info(`Lock '${this.c}': Marking the lockfile as scheduled to be released in ${t} ms.`);try{const s={pid:process.pid,willReleaseAt:Date.now()+t};await g.Promises.writeFile(this.c,JSON.stringify(s),{flag:"w"})}catch(s){this.b.error(s)}}}async function w(a,t,s){try{const c={pid:process.pid,willReleaseAt:0};await g.Promises.writeFile(t,JSON.stringify(c),{flag:"wx"})}catch(c){a.error(c)}const d=await u(a,t);return!d||d.pid!==process.pid?s?(a.info(`Lock '${t}': Could not acquire lock, giving up.`),null):(a.info(`Lock '${t}': Could not acquire lock, checking if the file is stale.`),n(a,t)):(a.info(`Lock '${t}': Lock acquired.`),new k(a,t))}async function u(a,t){let s;try{s=await g.Promises.readFile(t)}catch(d){return a.error(d),null}try{return JSON.parse(String(s))}catch(d){return a.error(d),null}}async function o(a,t){let s;try{s=await g.Promises.stat(t)}catch(d){return a.error(d),0}return s.mtime.getTime()}function i(a){try{return process.kill(a,0),!0}catch{return!1}}async function n(a,t){const s=await u(a,t);if(!s)return a.info(`Lock '${t}': Could not read pid of lock holder.`),r(a,t);if(s.willReleaseAt){let E=s.willReleaseAt-Date.now();if(E<5e3){for(E>0?a.info(`Lock '${t}': The lockfile is scheduled to be released in ${E} ms.`):a.info(`Lock '${t}': The lockfile is scheduled to have been released.`);E>0;){if(await(0,v.$Yg)(Math.min(100,E)),await o(a,t)===0)return r(a,t);E=s.willReleaseAt-Date.now()}return r(a,t)}}if(!i(s.pid))return a.info(`Lock '${t}': The pid ${s.pid} appears to be gone.`),r(a,t);const d=await o(a,t),c=Date.now()-d;if(c<=y)return a.info(`Lock '${t}': The lock does not look stale, elapsed: ${c} ms, giving up.`),null;a.info(`Lock '${t}': The lock looks stale, waiting for 2s.`),await(0,v.$Yg)(2e3);const l=await o(a,t),h=Date.now()-l;return h<=y?(a.info(`Lock '${t}': The lock does not look stale, elapsed: ${h} ms, giving up.`),null):(a.info(`Lock '${t}': The lock looks stale even after waiting for 2s.`),r(a,t))}async function r(a,t){a.info(`Lock '${t}': Deleting a stale lock.`);try{await g.Promises.unlink(t)}catch{}return w(a,t,!0)}}),define(ke[352],Se([1,0,32,20,46,35]),function(me,e,C,F,f,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rfc=void 0;let M=class extends f.$tec{constructor(v,g){super(!0,v,g)}createTerminal(v,g,A){return this.createTerminalFromOptions({name:v,shellPath:g,shellArgs:A})}createTerminalFromOptions(v,g){const A=new f.$sec(this.a,(0,C.$ig)(),v,v.name);return this.f.push(A),A.create(v,this.R(v,g)),A.value}};e.$Rfc=M,e.$Rfc=M=He([Be(0,L.$VM),Be(1,F.$zM)],M)}),define(ke[353],Se([1,0,12,22,21,8,4,3,131,304,68]),function(me,e,C,F,f,L,M,b,v,g,A){"use strict";var I;Object.defineProperty(e,"__esModule",{value:!0}),e.$25b=e.ResponsiveState=e.RequestInitiator=e.$15b=e.$Z5b=void 0;function $(S,P){try{return JSON.stringify(S,P)}catch{return"null"}}const y="$$ref$$",k={[y]:-1};class w{constructor(P,z){this.jsonString=P,this.referencedBuffers=z}}function u(S,P=null,z=!1){const j=[];return{jsonString:(z?$:JSON.stringify)(S,(T,N)=>{if(typeof N>"u")return k;if(typeof N=="object"){if(N instanceof F.$fe){const O=j.push(N)-1;return{[y]:O}}if(P)return P(T,N)}return N}),referencedBuffers:j}}e.$Z5b=u;function o(S,P,z){return JSON.parse(S,(j,R)=>{if(R){const T=R[y];if(typeof T=="number")return P[T];if(z&&R.$mid===1)return z.transformIncoming(R)}return R})}e.$15b=o;function i(S,P){return JSON.stringify(S,P)}function n(S){return S?(P,z)=>z&&z.$mid===1?S.transformOutgoing(z):z:null}var r;(function(S){S[S.LocalSide=0]="LocalSide",S[S.OtherSide=1]="OtherSide"})(r||(e.RequestInitiator=r={}));var a;(function(S){S[S.Responsive=0]="Responsive",S[S.Unresponsive=1]="Unresponsive"})(a||(e.ResponsiveState=a={}));const t=()=>{},s=Symbol.for("rpcProtocol"),d=Symbol.for("rpcProxy");class c extends b.$Rc{static{I=s}static{this.a=3*1e3}constructor(P,z=null,j=null){super(),this[I]=!0,this.b=this.B(new M.$Rd),this.onDidChangeResponsiveState=this.b.event,this.c=P,this.f=z,this.g=j,this.h=n(this.g),this.j=!1,this.m=[],this.s=[];for(let R=0,T=A.$tv.count;R<T;R++)this.m[R]=null,this.s[R]=null;this.t=0,this.u=Object.create(null),this.w={},this.y=0,this.z=0,this.C=0,this.D=this.B(new C.$0g(()=>this.H(),1e3)),this.c.onMessage(R=>this.L(R))}dispose(){this.j=!0,Object.keys(this.w).forEach(P=>{const z=this.w[P];delete this.w[P],z.resolveErr(L.$5())})}drain(){return typeof this.c.drain=="function"?this.c.drain():Promise.resolve()}F(P){this.z===0&&(this.C=Date.now()+c.a),this.z++,this.D.isScheduled()||this.D.schedule()}G(P){this.C=Date.now()+c.a,this.z--,this.z===0&&this.D.cancel(),this.I(0)}H(){this.z!==0&&(Date.now()>this.C?this.I(1):this.D.schedule())}I(P){this.y!==P&&(this.y=P,this.b.fire(this.y))}get responsiveState(){return this.y}transformIncomingURIs(P){return this.g?(0,v.$Um)(P,this.g):P}getProxy(P){const{nid:z,sid:j}=P;return this.s[z]||(this.s[z]=this.J(z,j)),this.s[z]}J(P,z){const j={get:(R,T)=>(typeof T=="string"&&!R[T]&&T.charCodeAt(0)===36&&(R[T]=(...N)=>this.U(P,T,N)),T===d?z:R[T])};return new Proxy(Object.create(null),j)}set(P,z){return this.m[P.nid]=z,z}assertRegistered(P){for(let z=0,j=P.length;z<j;z++){const R=P[z];if(!this.m[R.nid])throw new Error(`Missing proxy instance ${R.sid}`)}}L(P){if(this.j)return;const z=P.byteLength,j=h.read(P,0),R=j.readUInt8(),T=j.readUInt32();switch(R){case 1:case 2:{let{rpcId:N,method:O,args:W}=D.deserializeRequestJSONArgs(j);this.g&&(W=(0,v.$Um)(W,this.g)),this.M(z,T,N,O,W,R===2);break}case 3:case 4:{let{rpcId:N,method:O,args:W}=D.deserializeRequestMixedArgs(j);this.g&&(W=(0,v.$Um)(W,this.g)),this.M(z,T,N,O,W,R===4);break}case 5:{this.f?.logIncoming(z,T,0,"ack"),this.G(T);break}case 6:{this.N(z,T);break}case 7:{this.O(z,T,void 0);break}case 9:{let N=D.deserializeReplyOKJSON(j);this.g&&(N=(0,v.$Um)(N,this.g)),this.O(z,T,N);break}case 10:{const N=D.deserializeReplyOKJSONWithBuffers(j,this.g);this.O(z,T,N);break}case 8:{const N=D.deserializeReplyOKVSBuffer(j);this.O(z,T,N);break}case 11:{let N=D.deserializeReplyErrError(j);this.g&&(N=(0,v.$Um)(N,this.g)),this.P(z,T,N);break}case 12:{this.P(z,T,void 0);break}default:console.error("received unexpected message"),console.error(P)}}M(P,z,j,R,T,N){this.f?.logIncoming(P,z,1,`receiveRequest ${(0,A.$vv)(j)}.${R}(`,T);const O=String(z);let W,x;if(N){const G=new f.$2d;T.push(G.token),W=this.Q(j,R,T),x=()=>G.cancel()}else W=this.Q(j,R,T),x=t;this.u[O]=x;const le=D.serializeAcknowledged(z);this.f?.logOutgoing(le.byteLength,z,1,"ack"),this.c.send(le),W.then(G=>{delete this.u[O];const J=D.serializeReplyOK(z,G,this.h);this.f?.logOutgoing(J.byteLength,z,1,"reply:",G),this.c.send(J)},G=>{delete this.u[O];const J=D.serializeReplyErr(z,G);this.f?.logOutgoing(J.byteLength,z,1,"replyErr:",G),this.c.send(J)})}N(P,z){this.f?.logIncoming(P,z,1,"receiveCancel");const j=String(z);this.u[j]?.()}O(P,z,j){this.f?.logIncoming(P,z,0,"receiveReply:",j);const R=String(z);if(!this.w.hasOwnProperty(R))return;const T=this.w[R];delete this.w[R],T.resolveOk(j)}P(P,z,j){this.f?.logIncoming(P,z,0,"receiveReplyErr:",j);const R=String(z);if(!this.w.hasOwnProperty(R))return;const T=this.w[R];delete this.w[R];let N;j&&(j.$isError?(N=new Error,N.name=j.name,N.message=j.message,N.stack=j.stack):N=j),T.resolveErr(N)}Q(P,z,j){try{return Promise.resolve(this.S(P,z,j))}catch(R){return Promise.reject(R)}}S(P,z,j){const R=this.m[P];if(!R)throw new Error("Unknown actor "+(0,A.$vv)(P));const T=R[z];if(typeof T!="function")throw new Error("Unknown method "+z+" on actor "+(0,A.$vv)(P));return T.apply(R,j)}U(P,z,j){if(this.j)return new g.$Y5b;let R=null;if(j.length>0&&f.CancellationToken.isCancellationToken(j[j.length-1])&&(R=j.pop()),R&&R.isCancellationRequested)return Promise.reject(L.$5());const T=D.serializeRequestArguments(j,this.h),N=++this.t,O=String(N),W=new g.$X5b,x=new b.$Qc;R&&x.add(R.onCancellationRequested(()=>{const G=D.serializeCancel(N);this.f?.logOutgoing(G.byteLength,N,0,"cancel"),this.c.send(D.serializeCancel(N))})),this.w[O]=new l(W,x),this.F(N);const le=D.serializeRequest(N,P,z,T,!!R);return this.f?.logOutgoing(le.byteLength,N,0,`request: ${(0,A.$vv)(P)}.${z}(`,j),this.c.send(le),W}}e.$25b=c;class l{constructor(P,z){this.a=P,this.b=z}resolveOk(P){this.a.resolveOk(P),this.b.dispose()}resolveErr(P){this.a.resolveErr(P),this.b.dispose()}}class h{static alloc(P,z,j){const R=new h(F.$fe.alloc(j+1+4),0);return R.writeUInt8(P),R.writeUInt32(z),R}static read(P,z){return new h(P,z)}get buffer(){return this.a}constructor(P,z){this.a=P,this.b=z}static sizeUInt8(){return 1}static{this.sizeUInt32=4}writeUInt8(P){this.a.writeUInt8(P,this.b),this.b+=1}readUInt8(){const P=this.a.readUInt8(this.b);return this.b+=1,P}writeUInt32(P){this.a.writeUInt32BE(P,this.b),this.b+=4}readUInt32(){const P=this.a.readUInt32BE(this.b);return this.b+=4,P}static sizeShortString(P){return 1+P.byteLength}writeShortString(P){this.a.writeUInt8(P.byteLength,this.b),this.b+=1,this.a.set(P,this.b),this.b+=P.byteLength}readShortString(){const P=this.a.readUInt8(this.b);this.b+=1;const j=this.a.slice(this.b,this.b+P).toString();return this.b+=P,j}static sizeLongString(P){return 4+P.byteLength}writeLongString(P){this.a.writeUInt32BE(P.byteLength,this.b),this.b+=4,this.a.set(P,this.b),this.b+=P.byteLength}readLongString(){const P=this.a.readUInt32BE(this.b);this.b+=4;const j=this.a.slice(this.b,this.b+P).toString();return this.b+=P,j}writeBuffer(P){this.a.writeUInt32BE(P.byteLength,this.b),this.b+=4,this.a.set(P,this.b),this.b+=P.byteLength}static sizeVSBuffer(P){return 4+P.byteLength}writeVSBuffer(P){this.a.writeUInt32BE(P.byteLength,this.b),this.b+=4,this.a.set(P,this.b),this.b+=P.byteLength}readVSBuffer(){const P=this.a.readUInt32BE(this.b);this.b+=4;const z=this.a.slice(this.b,this.b+P);return this.b+=P,z}static sizeMixedArray(P){let z=0;z+=1;for(let j=0,R=P.length;j<R;j++){const T=P[j];switch(z+=1,T.type){case 1:z+=this.sizeLongString(T.value);break;case 2:z+=this.sizeVSBuffer(T.value);break;case 3:z+=this.sizeUInt32,z+=this.sizeLongString(T.value);for(let N=0;N<T.buffers.length;++N)z+=this.sizeVSBuffer(T.buffers[N]);break;case 4:break}}return z}writeMixedArray(P){this.a.writeUInt8(P.length,this.b),this.b+=1;for(let z=0,j=P.length;z<j;z++){const R=P[z];switch(R.type){case 1:this.writeUInt8(1),this.writeLongString(R.value);break;case 2:this.writeUInt8(2),this.writeVSBuffer(R.value);break;case 3:this.writeUInt8(3),this.writeUInt32(R.buffers.length),this.writeLongString(R.value);for(let T=0;T<R.buffers.length;++T)this.writeBuffer(R.buffers[T]);break;case 4:this.writeUInt8(4);break}}}readMixedArray(){const P=this.a.readUInt8(this.b);this.b+=1;const z=new Array(P);for(let j=0;j<P;j++)switch(this.readUInt8()){case 1:z[j]=this.readLongString();break;case 2:z[j]=this.readVSBuffer();break;case 3:{const T=this.readUInt32(),N=this.readLongString(),O=[];for(let W=0;W<T;++W)O.push(this.readVSBuffer());z[j]=new A.$wv(o(N,O,null));break}case 4:z[j]=void 0;break}return z}}var E;(function(S){S[S.Simple=0]="Simple",S[S.Mixed=1]="Mixed"})(E||(E={}));class D{static a(P){for(let z=0,j=P.length;z<j;z++)if(P[z]instanceof F.$fe||P[z]instanceof A.$wv||typeof P[z]>"u")return!0;return!1}static serializeRequestArguments(P,z){if(this.a(P)){const j=[];for(let R=0,T=P.length;R<T;R++){const N=P[R];if(N instanceof F.$fe)j[R]={type:2,value:N};else if(typeof N>"u")j[R]={type:4};else if(N instanceof A.$wv){const{jsonString:O,referencedBuffers:W}=u(N.value,z);j[R]={type:3,value:F.$fe.fromString(O),buffers:W}}else j[R]={type:1,value:F.$fe.fromString(i(N,z))}}return{type:1,args:j}}return{type:0,args:i(P,z)}}static serializeRequest(P,z,j,R,T){switch(R.type){case 0:return this.b(P,z,j,R.args,T);case 1:return this.c(P,z,j,R.args,T)}}static b(P,z,j,R,T){const N=F.$fe.fromString(j),O=F.$fe.fromString(R);let W=0;W+=h.sizeUInt8(),W+=h.sizeShortString(N),W+=h.sizeLongString(O);const x=h.alloc(T?2:1,P,W);return x.writeUInt8(z),x.writeShortString(N),x.writeLongString(O),x.buffer}static deserializeRequestJSONArgs(P){const z=P.readUInt8(),j=P.readShortString(),R=P.readLongString();return{rpcId:z,method:j,args:JSON.parse(R)}}static c(P,z,j,R,T){const N=F.$fe.fromString(j);let O=0;O+=h.sizeUInt8(),O+=h.sizeShortString(N),O+=h.sizeMixedArray(R);const W=h.alloc(T?4:3,P,O);return W.writeUInt8(z),W.writeShortString(N),W.writeMixedArray(R),W.buffer}static deserializeRequestMixedArgs(P){const z=P.readUInt8(),j=P.readShortString(),R=P.readMixedArray(),T=new Array(R.length);for(let N=0,O=R.length;N<O;N++){const W=R[N];typeof W=="string"?T[N]=JSON.parse(W):T[N]=W}return{rpcId:z,method:j,args:T}}static serializeAcknowledged(P){return h.alloc(5,P,0).buffer}static serializeCancel(P){return h.alloc(6,P,0).buffer}static serializeReplyOK(P,z,j){if(typeof z>"u")return this.d(P);if(z instanceof F.$fe)return this.e(P,z);if(z instanceof A.$wv){const{jsonString:R,referencedBuffers:T}=u(z.value,j,!0);return this.g(P,R,T)}else return this.f(P,$(z,j))}static d(P){return h.alloc(7,P,0).buffer}static e(P,z){let j=0;j+=h.sizeVSBuffer(z);const R=h.alloc(8,P,j);return R.writeVSBuffer(z),R.buffer}static deserializeReplyOKVSBuffer(P){return P.readVSBuffer()}static f(P,z){const j=F.$fe.fromString(z);let R=0;R+=h.sizeLongString(j);const T=h.alloc(9,P,R);return T.writeLongString(j),T.buffer}static g(P,z,j){const R=F.$fe.fromString(z);let T=0;T+=h.sizeUInt32,T+=h.sizeLongString(R);for(const O of j)T+=h.sizeVSBuffer(O);const N=h.alloc(10,P,T);N.writeUInt32(j.length),N.writeLongString(R);for(const O of j)N.writeBuffer(O);return N.buffer}static deserializeReplyOKJSON(P){const z=P.readLongString();return JSON.parse(z)}static deserializeReplyOKJSONWithBuffers(P,z){const j=P.readUInt32(),R=P.readLongString(),T=[];for(let N=0;N<j;++N)T.push(P.readVSBuffer());return new A.$wv(o(R,T,z))}static serializeReplyErr(P,z){const j=z?$(L.$2(z),null):void 0;if(typeof j!="string")return this.h(P);const R=F.$fe.fromString(j);let T=0;T+=h.sizeLongString(R);const N=h.alloc(11,P,T);return N.writeLongString(R),N.buffer}static deserializeReplyErrError(P){const z=P.readLongString();return JSON.parse(z)}static h(P){return h.alloc(12,P,0).buffer}}var m;(function(S){S[S.RequestJSONArgs=1]="RequestJSONArgs",S[S.RequestJSONArgsWithCancellation=2]="RequestJSONArgsWithCancellation",S[S.RequestMixedArgs=3]="RequestMixedArgs",S[S.RequestMixedArgsWithCancellation=4]="RequestMixedArgsWithCancellation",S[S.Acknowledged=5]="Acknowledged",S[S.Cancel=6]="Cancel",S[S.ReplyOKEmpty=7]="ReplyOKEmpty",S[S.ReplyOKVSBuffer=8]="ReplyOKVSBuffer",S[S.ReplyOKJSON=9]="ReplyOKJSON",S[S.ReplyOKJSONWithBuffers=10]="ReplyOKJSONWithBuffers",S[S.ReplyErrError=11]="ReplyErrError",S[S.ReplyErrEmpty=12]="ReplyErrEmpty"})(m||(m={}));var p;(function(S){S[S.String=1]="String",S[S.VSBuffer=2]="VSBuffer",S[S.SerializedObjectWithBuffers=3]="SerializedObjectWithBuffers",S[S.Undefined=4]="Undefined"})(p||(p={}))}),define(ke[354],Se([1,0,4,37,45,5]),function(me,e,C,F,f,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$TJ=e.$SJ=e.OutputChannelUpdateMode=e.$RJ=e.$QJ=e.$PJ=e.$OJ=e.$NJ=e.$MJ=e.$LJ=e.$KJ=e.$JJ=e.$IJ=void 0,e.$IJ="text/x-code-output",e.$JJ="output",e.$KJ="Log",e.$LJ="text/x-code-log-output",e.$MJ="log",e.$NJ="workbench.panel.output",e.$OJ=new f.$aj("inOutput",!1),e.$PJ=new f.$aj("activeLogOutput",!1),e.$QJ=new f.$aj("outputView.scrollLock",!1),e.$RJ=(0,L.$Vh)("outputService");var M;(function(v){v[v.Append=1]="Append",v[v.Replace=2]="Replace",v[v.Clear=3]="Clear"})(M||(e.OutputChannelUpdateMode=M={})),e.$SJ={OutputChannels:"workbench.contributions.outputChannels"};class b{constructor(){this.a=new Map,this.b=new C.$Rd,this.onDidRegisterChannel=this.b.event,this.c=new C.$Rd,this.onDidRemoveChannel=this.c.event}registerChannel(g){this.a.has(g.id)||(this.a.set(g.id,g),this.b.fire(g.id))}getChannels(){const g=[];return this.a.forEach(A=>g.push(A)),g}getChannel(g){return this.a.get(g)}removeChannel(g){this.a.delete(g),this.c.fire(g)}}F.$mn.add(e.$SJ.OutputChannels,new b),e.$TJ=new f.$aj("activeOutputChannel","")}),define(ke[154],Se([1,0,6,5,20,26,14,354,71,27,57,182,22,18,31,4,3]),function(me,e,C,F,f,L,M,b,v,g,A,I,$,y,k,w,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jfc=e.$ifc=void 0;class o extends M.$jj{get disposed(){return this.n}constructor(a,t,s,d,c){super(),this.id=a,this.name=t,this.r=s,this.s=d,this.extension=c,this.m=0,this.n=!1,this.visible=!1,this.setLevel(s.getLevel()),this.B(s.onDidChangeLogLevel(l=>this.setLevel(l)))}get logLevel(){return this.getLevel()}appendLine(a){this.append(a+`
`)}append(a){this.info(a)}clear(){const a=this.m;this.r.flush(),this.s.$update(this.id,b.OutputChannelUpdateMode.Clear,a)}replace(a){const t=this.m;this.info(a),this.s.$update(this.id,b.OutputChannelUpdateMode.Replace,t),this.visible&&this.r.flush()}show(a,t){this.r.flush(),this.s.$reveal(this.id,!!(typeof a=="boolean"?a:t))}hide(){this.s.$close(this.id)}g(a,t){this.m+=$.$fe.fromString(t).byteLength,(0,M.log)(this.r,a,t),this.visible&&(this.r.flush(),this.s.$update(this.id,b.OutputChannelUpdateMode.Append))}dispose(){super.dispose(),this.n||(this.s.$dispose(this.id),this.n=!0)}}class i extends o{appendLine(a){this.append(a)}}let n=class{constructor(a,t,s,d,c,l){this.i=t,this.j=s,this.k=d,this.l=c,this.m=l,this.d=new Map,this.f=1,this.g=new Map,this.h=null,this.a=a.getProxy(C.$xK.MainThreadOutputService),this.b=this.k.extUri.joinPath(t.logsLocation,`output_logging_${(0,I.$km)(new Date).replace(/-|:|\.\d+Z$/g,"")}`)}$setVisibleChannel(a){this.h=a;for(const[t,s]of this.g)s.visible=t===this.h}createOutputChannel(a,t,s){if(a=a.trim(),!a)throw new Error("illegal argument `name`. must not be falsy");const d=typeof t=="object"&&t.log,c=(0,y.$Cf)(t)?t:void 0;if((0,y.$Cf)(c)&&!c.trim())throw new Error("illegal argument `languageId`. must not be empty");let l;const h=this.i.environment.extensionLogLevel?.find(([D])=>L.$_l.equals(s.identifier,D))?.[1];h&&(l=(0,M.$tj)(h));const E=d?this.o(a,l,s):this.n(a,c,s);return E.then(D=>{this.g.set(D.id,D),D.visible=D.id===this.h}),d?this.r(a,l??this.m.getLevel(),E):this.q(a,E)}async n(a,t,s){this.c||(this.c=this.j.value.createDirectory(this.b).then(()=>this.b));const d=await this.c,c=this.k.extUri.joinPath(d,`${this.f++}-${a.replace(/[\\/:\*\?"<>\|]/g,"")}.log`),l=this.l.createLogger(c,{logLevel:"always",donotRotate:!0,donotUseFormatters:!0,hidden:!0}),h=await this.a.$register(a,c,t,s.identifier.value);return new o(h,a,l,this.a,s)}async o(a,t,s){const d=await this.p(s),c=a.replace(/[\\/:\*\?"<>\|]/g,""),l=this.k.extUri.joinPath(d,`${c}.log`),h=`${s.identifier.value}.${c}`,E=this.l.createLogger(l,{id:h,name:a,logLevel:t,extensionId:s.identifier.value});return new i(h,a,E,this.a,s)}p(a){let t=this.d.get(a.identifier.value);if(!t){const s=this.k.extUri.joinPath(this.i.logsLocation,a.identifier.value);this.d.set(a.identifier.value,t=(async()=>{try{await this.j.value.createDirectory(s)}catch(d){if((0,k.$uk)(d)!==k.FileSystemProviderErrorCode.FileExists)throw d}return s})())}return t}q(a,t){let s=!1;const d=()=>{if(s)throw new Error("Channel has been closed")};return{get name(){return a},append(c){d(),t.then(l=>l.append(c))},appendLine(c){d(),t.then(l=>l.appendLine(c))},clear(){d(),t.then(c=>c.clear())},replace(c){d(),t.then(l=>l.replace(c))},show(c,l){d(),t.then(h=>h.show(c,l))},hide(){d(),t.then(c=>c.hide())},dispose(){s=!0,t.then(c=>c.dispose())}}}r(a,t,s){const d=new u.$Qc,c=()=>{if(d.isDisposed)throw new Error("Channel has been closed")},l=d.add(new w.$Rd);function h(E){t=E,l.fire(E)}return s.then(E=>{d.add(E),E.logLevel!==t&&h(E.logLevel),d.add(E.onDidChangeLogLevel(D=>h(D)))}),{...this.q(a,s),get logLevel(){return t},onDidChangeLogLevel:l.event,trace(E,...D){c(),s.then(m=>m.trace(E,...D))},debug(E,...D){c(),s.then(m=>m.debug(E,...D))},info(E,...D){c(),s.then(m=>m.info(E,...D))},warn(E,...D){c(),s.then(m=>m.warn(E,...D))},error(E,...D){c(),s.then(m=>m.error(E,...D))},dispose(){d.dispose()}}}};e.$ifc=n,e.$ifc=n=He([Be(0,f.$zM),Be(1,g.$PM),Be(2,v.$8dc),Be(3,A.$Hdc),Be(4,M.$ej),Be(5,M.$dj)],n),e.$jfc=(0,F.$Vh)("IExtHostOutputService")}),define(ke[155],Se([1,0,5,12]),function(me,e,C,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Am=e.$zm=void 0,e.$zm=(0,C.$Vh)("remoteAgentService"),e.$Am=new class{constructor(){this.maxSampleCount=5,this.sampleDelay=2e3,this.initial=[],this.maxInitialCount=3,this.average=[],this.maxAverageCount=100,this.highLatencyMultiple=2,this.highLatencyMinThreshold=500,this.highLatencyMaxThreshold=1500,this.lastMeasurement=void 0}get latency(){return this.lastMeasurement}async measure(f){let L=1/0;for(let b=0;b<this.maxSampleCount;b++){const v=await f.getRoundTripTime();if(v===void 0)return;L=Math.min(L,v/2),await(0,F.$Yg)(this.sampleDelay)}this.average.push(L),this.average.length>this.maxAverageCount&&this.average.shift();let M;return this.initial.length<this.maxInitialCount?this.initial.push(L):M=this.initial.reduce((b,v)=>b+v,0)/this.initial.length,this.lastMeasurement={initial:M,current:L,average:this.average.reduce((b,v)=>b+v,0)/this.average.length,high:(()=>typeof M>"u"?!1:L>this.highLatencyMaxThreshold||L>this.highLatencyMinThreshold&&L>M*this.highLatencyMultiple)()},this.lastMeasurement}}}),define(ke[355],Se([1,0,224,86,37,40,44,3,4,155,11,24]),function(me,e,C,F,f,L,M,b,v,g,A,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tH=e.$sH=e.$rH=e.$qH=e.$pH=e.$oH=void 0,e.$oH=Object.freeze({id:"application",order:100,title:(0,C.localize)(0,null),type:"object"}),e.$pH=Object.freeze({id:"workbench",order:7,title:(0,C.localize)(1,null),type:"object"}),e.$qH=Object.freeze({id:"security",scope:1,title:(0,C.localize)(2,null),type:"object",order:7}),e.$rH={ConfigurationMigration:"base.contributions.configuration.migration"};class ${constructor(){this.migrations=[],this.a=new v.$Rd,this.onDidRegisterConfigurationMigration=this.a.event}registerConfigurationMigrations(o){this.migrations.push(...o)}}const y=new $;f.$mn.add(e.$rH.ConfigurationMigration,y);let k=class extends b.$Rc{constructor(o,i){super(),this.a=o,this.b=i,this.B(this.b.onDidChangeWorkspaceFolders(async n=>{for(const r of n.added)await this.f(r,y.migrations)})),this.c(y.migrations),this.B(y.onDidRegisterConfigurationMigration(n=>this.c(n)))}async c(o){await this.f(void 0,o);for(const i of this.b.getWorkspace().folders)await this.f(i,o)}async f(o,i){await Promise.all([i.map(n=>this.g(n,o?.uri))])}async g(o,i){const n=this.a.inspect(o.key,{resource:i}),r=[["userValue",2],["userLocalValue",3],["userRemoteValue",4],["workspaceValue",5],["workspaceFolderValue",6]];for(const[a,t]of r){const s=[];for(const c of n.overrideIdentifiers??[]){const l=await this.h(o,{resource:i,overrideIdentifier:c},a);for(const h of l??[]){let E=s.find(([[D,m]])=>D===h[0]&&(0,I.$en)(m.value,h[1].value));E||s.push(E=[h,[]]),E[1].push(c)}}const d=await this.h(o,{resource:i},a,n);for(const c of d??[])s.push([c,[]]);s.length&&await Promise.allSettled(s.map(async([[c,l],h])=>this.a.updateValue(c,l.value,{resource:i,overrideIdentifiers:h},t)))}}async h(o,i,n,r){const a=(r??this.a.inspect(o.key,i))[n];if(a===void 0)return;const t=d=>this.a.inspect(d,i)[n],s=await o.migrateFn(a,t);return Array.isArray(s)?s:[[o.key,s]]}};e.$sH=k,e.$sH=k=He([Be(0,M.$pi),Be(1,L.$5h)],k);let w=class extends b.$Rc{constructor(o){super(),(async()=>{if(!A.$i&&(await o.getEnvironment())?.os!==1)return;f.$mn.as(F.$rn.Configuration).registerConfiguration({...e.$qH,properties:{"security.allowedUNCHosts":{type:"array",items:{type:"string",pattern:"^[^\\\\]+$",patternErrorMessage:(0,C.localize)(3,null)},default:[],markdownDescription:(0,C.localize)(4,null),scope:2},"security.restrictUNCAccess":{type:"boolean",default:!0,markdownDescription:(0,C.localize)(5,null),scope:2}}})})()}};e.$tH=w,e.$tH=w=He([Be(0,g.$zm)],w)}),define(ke[356],Se([1,0,34,17,16,23,233,355,86,5,37]),function(me,e,C,F,f,L,M,b,v,g,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ucb=e.$tcb=e.ResolvedStatus=e.RegisteredEditorPriority=e.$scb=e.$rcb=void 0,e.$rcb=(0,g.$Vh)("editorResolverService"),e.$scb="workbench.editorAssociations";const I=A.$mn.as(v.$rn.Configuration),$={...b.$pH,properties:{"workbench.editorAssociations":{type:"object",markdownDescription:(0,M.localize)(0,null),additionalProperties:{type:"string"}}}};I.registerConfiguration($);var y;(function(o){o.builtin="builtin",o.option="option",o.exclusive="exclusive",o.default="default"})(y||(e.RegisteredEditorPriority=y={}));var k;(function(o){o[o.ABORT=1]="ABORT",o[o.NONE=2]="NONE"})(k||(e.ResolvedStatus=k={}));function w(o){switch(o){case y.exclusive:return 5;case y.default:return 4;case y.builtin:return 3;case y.option:default:return 1}}e.$tcb=w;function u(o,i){if(new Set([F.Schemas.extension,F.Schemas.webviewPanel,F.Schemas.vscodeWorkspaceTrust,F.Schemas.vscodeSettings]).has(i.scheme))return!1;const a=typeof o=="string"&&o.indexOf(f.$fc.sep)>=0?`${i.scheme}:${i.path}`:(0,L.$wg)(i);return C.$Bj(typeof o=="string"?o.toLowerCase():o,a.toLowerCase())}e.$ucb=u}),define(ke[357],Se([1,0,33,17,16,11,23,2,5,268,40,146,155]),function(me,e,C,F,f,L,M,b,v,g,A,I,$){"use strict";var y;Object.defineProperty(e,"__esModule",{value:!0}),e.$aK=e.$_J=void 0,e.$_J=(0,v.$Vh)("pathService");let k=y=class{constructor(u,o,i,n){this.d=u,this.e=o,this.f=i,this.g=n,this.a=(async()=>(await this.e.getEnvironment())?.os||L.OS)(),this.b=(async()=>{const r=await this.e.getEnvironment();return this.c=r?.userHome??u})()}hasValidBasename(u,o,i){return typeof o=="string"||typeof o>"u"?this.a.then(n=>this.h(u,n,o)):this.h(u,o,i)}h(u,o,i){return u.scheme===F.Schemas.file||u.scheme===F.Schemas.vscodeRemote?(0,C.$Zf)(i??(0,M.$wg)(u),o===1):!0}get defaultUriScheme(){return y.findDefaultUriScheme(this.f,this.g)}static findDefaultUriScheme(u,o){if(u.remoteAuthority)return F.Schemas.vscodeRemote;const i=(0,g.$9J)(o.getWorkspace());if(i)return i;const n=o.getWorkspace().folders[0];if(n)return n.uri.scheme;const r=o.getWorkspace().configuration;return r?r.scheme:F.Schemas.file}userHome(u){return u?.preferLocal?this.d:this.b}get resolvedUserHome(){return this.c}get path(){return this.a.then(u=>u===1?f.$ec:f.$fc)}async fileURI(u){let o="";if(await this.a===1&&(u=u.replace(/\\/g,"/")),u[0]==="/"&&u[1]==="/"){const n=u.indexOf("/",2);n===-1?(o=u.substring(2),u="/"):(o=u.substring(2,n),u=u.substring(n)||"/")}return b.URI.from({scheme:F.Schemas.file,authority:o,path:u,query:"",fragment:""})}};e.$aK=k,e.$aK=k=y=He([Be(1,$.$zm),Be(2,I.$UJ),Be(3,A.$5h)],k)}),define(ke[358],Se([1,0,235,19,59,4,52,3,2,44,240,14,64,270,88,40,146,25,21,18,24,45]),function(me,e,C,F,f,L,M,b,v,g,A,I,$,y,k,w,u,o,i,n,r,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6J=e.$5J=e.$4J=e.OnPortForward=e.$3J=e.$2J=e.$1J=e.$ZJ=e.$YJ=e.TunnelSource=e.TunnelCloseReason=e.$XJ=e.$WJ=e.$VJ=void 0;const t=10*1e3,s="remote.tunnels.toRestore";e.$VJ="onTunnel",e.$WJ=new a.$aj("forwardedPortsViewEnabled",!1,C.localize(0,null));function d(z){const j=z.match(/^([a-zA-Z0-9_-]+(?:\.[a-zA-Z0-9_-]+)*:)?([0-9]+)$/);if(j)return{host:j[1]?.substring(0,j[1].length-1)||"localhost",port:Number(j[2])}}e.$XJ=d;var c;(function(z){z.Other="Other",z.User="User",z.AutoForwardEnd="AutoForwardEnd"})(c||(e.TunnelCloseReason=c={}));var l;(function(z){z[z.User=0]="User",z[z.Auto=1]="Auto",z[z.Extension=2]="Extension"})(l||(e.TunnelSource=l={})),e.$YJ={source:l.User,description:C.localize(1,null)},e.$ZJ={source:l.Auto,description:C.localize(2,null)};function h(z,j,R){const T=z.get(D(j,R));if(T)return T;if((0,k.$iv)(j))for(const N of k.$hv){const O=D(N,R);if(z.has(O))return z.get(O)}else if((0,k.$kv)(j))for(const N of k.$jv){const O=D(N,R);if(z.has(O))return z.get(O)}}e.$1J=h;function E(z,j,R){const T=h(z,j,R);if(T)return T;const N=(0,k.$kv)(j)?"localhost":(0,k.$iv)(j)?"0.0.0.0":void 0;if(N)return h(z,N,R)}e.$2J=E;function D(z,j){return z+":"+j}e.$3J=D;var m;(function(z){z.Notify="notify",z.OpenBrowser="openBrowser",z.OpenBrowserOnce="openBrowserOnce",z.OpenPreview="openPreview",z.Silent="silent",z.Ignore="ignore"})(m||(e.OnPortForward=m={}));function p(z){return z&&"host"in z&&typeof z.host=="string"&&"port"in z&&typeof z.port=="number"&&(!("detail"in z)||typeof z.detail=="string")&&(!("pid"in z)||typeof z.pid=="string")}e.$4J=p;class S extends b.$Rc{static{this.c="remote.portsAttributes"}static{this.f="remote.otherPortsAttributes"}static{this.g=/^(\d+)\-(\d+)$/}static{this.h=/^([a-z0-9\-]+):(\d{1,5})$/}constructor(j){super(),this.r=j,this.j=[],this.n=new L.$Rd,this.onDidChangeAttributes=this.n.event,this.B(j.onDidChangeConfiguration(R=>{(R.affectsConfiguration(S.c)||R.affectsConfiguration(S.f))&&this.s()})),this.s()}s(){this.j=this.y(),this.n.fire()}getAttributes(j,R,T){let N=this.w(j,R,T,this.j,0);const O={label:void 0,onAutoForward:void 0,elevateIfNeeded:void 0,requireLocalPort:void 0,protocol:void 0};for(;N>=0;){const W=this.j[N];W.key===j?(O.onAutoForward=W.onAutoForward??O.onAutoForward,O.elevateIfNeeded=W.elevateIfNeeded!==void 0?W.elevateIfNeeded:O.elevateIfNeeded,O.label=W.label??O.label,O.requireLocalPort=W.requireLocalPort,O.protocol=W.protocol):(O.onAutoForward=O.onAutoForward??W.onAutoForward,O.elevateIfNeeded=O.elevateIfNeeded!==void 0?O.elevateIfNeeded:W.elevateIfNeeded,O.label=O.label??W.label,O.requireLocalPort=O.requireLocalPort!==void 0?O.requireLocalPort:void 0,O.protocol=O.protocol??W.protocol),N=this.w(j,R,T,this.j,N+1)}return O.onAutoForward!==void 0||O.elevateIfNeeded!==void 0||O.label!==void 0||O.requireLocalPort!==void 0||O.protocol!==void 0?O:this.C()}t(j){return j.start!==void 0&&j.end!==void 0}u(j){return j.host!==void 0&&j.port!==void 0&&(0,n.$Cf)(j.host)&&(0,n.$Gf)(j.port)}w(j,R,T,N,O){if(O>=N.length)return-1;const W=!(0,k.$iv)(R)&&!(0,k.$kv)(R),le=N.slice(O).findIndex(G=>(0,n.$Gf)(G.key)?W?!1:G.key===j:this.t(G.key)?W?!1:j>=G.key.start&&j<=G.key.end:this.u(G.key)?j===G.key.port&&R===G.key.host:T?G.key.test(T):!1);return le>=0?le+O:-1}y(){const j=this.r.getValue(S.c);if(!j||!(0,n.$Ef)(j))return[];const R=[];for(const N in j){if(N===void 0)continue;const O=j[N];let W;if(Number(N))W=Number(N);else if((0,n.$Cf)(N))if(S.g.test(N)){const x=N.match(S.g);W={start:Number(x[1]),end:Number(x[2])}}else if(S.h.test(N)){const x=N.match(S.h);W={host:x[1],port:Number(x[2])}}else{let x;try{x=RegExp(N)}catch{}x&&(W=x)}W&&R.push({key:W,elevateIfNeeded:O.elevateIfNeeded,onAutoForward:O.onAutoForward,label:O.label,requireLocalPort:O.requireLocalPort,protocol:O.protocol})}const T=this.r.getValue(S.f);return T&&(this.m={elevateIfNeeded:T.elevateIfNeeded,label:T.label,onAutoForward:T.onAutoForward,requireLocalPort:T.requireLocalPort,protocol:T.protocol}),this.z(R)}z(j){function R(T,N){return(0,n.$Gf)(T.key)?T.key:N.t(T.key)?T.key.start:N.u(T.key)?T.key.port:Number.MAX_VALUE}return j.sort((T,N)=>R(T,this)-R(N,this))}C(){return this.m}static providedActionToAction(j){switch(j){case k.ProvidedOnAutoForward.Notify:return m.Notify;case k.ProvidedOnAutoForward.OpenBrowser:return m.OpenBrowser;case k.ProvidedOnAutoForward.OpenBrowserOnce:return m.OpenBrowserOnce;case k.ProvidedOnAutoForward.OpenPreview:return m.OpenPreview;case k.ProvidedOnAutoForward.Silent:return m.Silent;case k.ProvidedOnAutoForward.Ignore:return m.Ignore;default:return}}async addAttributes(j,R,T){const O=this.r.inspect(S.c).userRemoteValue;let W;!O||!(0,n.$Ef)(O)?W={}:W=(0,r.$an)(O),W[`${j}`]||(W[`${j}`]={});for(const x in R)W[`${j}`][x]=R[x];return this.r.updateValue(S.c,W,T)}}e.$5J=S;let P=class extends b.$Rc{constructor(j,R,T,N,O,W,x,le,G,J){super(),this.H=j,this.I=R,this.J=T,this.L=N,this.M=O,this.N=W,this.O=x,this.P=le,this.Q=G,this.R=J,this.c=new Map,this.g=new L.$Rd,this.onForwardPort=this.g.event,this.h=new L.$Rd,this.onClosePort=this.h.event,this.j=new L.$Rd,this.onPortName=this.j.event,this.n=new L.$Rd,this.onCandidatesChanged=this.n.event,this.t=new L.$Rd,this.onEnvironmentTunnelsSet=this.t.event,this.u=!1,this.w=void 0,this.z=!1,this.C=new L.$Rd,this.D=new Map,this.F=new Map,this.G=[],this.ab=new Date,this.configPortsAttributes=new S(T),this.s=this.Z(),this.B(this.configPortsAttributes.onDidChangeAttributes(this.gb,this)),this.forwarded=new Map,this.f=new Map,this.H.tunnels.then(async Q=>{const oe=await this.getAttributes(Q.map(_=>({port:_.tunnelRemotePort,host:_.tunnelRemoteHost})));for(const _ of Q)if(_.localAddress){const Ee=D(_.tunnelRemoteHost,_.tunnelRemotePort),he=E(this.m??new Map,_.tunnelRemoteHost,_.tunnelRemotePort);this.forwarded.set(Ee,{remotePort:_.tunnelRemotePort,remoteHost:_.tunnelRemoteHost,localAddress:_.localAddress,protocol:oe?.get(_.tunnelRemotePort)?.protocol??k.TunnelProtocol.Http,localUri:await this.X(_.localAddress,oe?.get(_.tunnelRemotePort)),localPort:_.tunnelLocalPort,runningProcess:he?.detail,hasRunningProcess:!!he,pid:he?.pid,privacy:_.privacy,source:e.$YJ}),this.f.set(Ee,_)}}),this.detected=new Map,this.B(this.H.onTunnelOpened(async Q=>{const oe=D(Q.tunnelRemoteHost,Q.tunnelRemotePort);if(!E(this.forwarded,Q.tunnelRemoteHost,Q.tunnelRemotePort)&&!E(this.detected,Q.tunnelRemoteHost,Q.tunnelRemotePort)&&!E(this.c,Q.tunnelRemoteHost,Q.tunnelRemotePort)&&Q.localAddress){const _=E(this.m??new Map,Q.tunnelRemoteHost,Q.tunnelRemotePort),Ee=(await this.getAttributes([{port:Q.tunnelRemotePort,host:Q.tunnelRemoteHost}]))?.get(Q.tunnelRemotePort);this.forwarded.set(oe,{remoteHost:Q.tunnelRemoteHost,remotePort:Q.tunnelRemotePort,localAddress:Q.localAddress,protocol:Ee?.protocol??k.TunnelProtocol.Http,localUri:await this.X(Q.localAddress,Ee),localPort:Q.tunnelLocalPort,closeable:!0,runningProcess:_?.detail,hasRunningProcess:!!_,pid:_?.pid,privacy:Q.privacy,source:e.$YJ})}await this.$(),this.f.set(oe,Q),this.g.fire(this.forwarded.get(oe))})),this.B(this.H.onTunnelClosed(Q=>this.W(Q,c.Other))),this.U()}S(){return this.Q.extensions.find(j=>j.activationEvents?.includes(e.$VJ))?(this.R.createKey(e.$WJ.key,!0),!0):!1}U(){if(this.S())return;const j=this.B(this.Q.onDidRegisterExtensions(()=>{this.S()&&j.dispose()}))}async W(j,R){const T=D(j.host,j.port);this.forwarded.has(T)&&(this.forwarded.delete(T),await this.$(),this.h.fire(j))}X(j,R){if(j.startsWith("http"))return v.URI.parse(j);const T=R?.protocol??"http";return v.URI.parse(`${T}://${j}`)}async Y(){const j=this.N.getWorkspace(),R=j.configuration?(0,M.$Ji)(j.configuration.path):j.folders.length>0?(0,M.$Ji)(j.folders[0].uri.path):void 0;if(R===void 0){this.O.debug("Could not get workspace hash for forwarded ports storage key.");return}return`${s}.${this.L.remoteAuthority}.${R}`}async Z(){const j=this.I.get(s,1);if(j)return this.I.remove(s,1),await this.$(),j;const R=await this.Y();if(R)return this.I.get(R,0)}async restoreForwarded(){if(this.J.getValue("remote.restoreForwardedPorts")){const j=await this.s;if(j&&j!==this.y){const R=JSON.parse(j)??[];this.O.trace(`ForwardedPorts: (TunnelModel) restoring ports ${R.map(T=>T.remotePort).join(", ")}`);for(const T of R){const N=E(this.detected,T.remoteHost,T.remotePort);T.source.source!==l.Extension&&!N||T.source.source===l.Extension&&N?await this.cb({remote:{host:T.remoteHost,port:T.remotePort},local:T.localPort,name:T.name,privacy:T.privacy,elevateIfNeeded:!0,source:T.source}):T.source.source===l.Extension&&!N&&this.D.set(D(T.remoteHost,T.remotePort),T)}}}if(this.z=!0,this.C.fire(),!this.w){const j=await this.Y();this.w=this.B(new b.$Qc),this.w.add(this.I.onDidChangeValue(0,void 0,this.w)(async R=>{R.key===j&&(this.s=Promise.resolve(this.I.get(j,0)),await this.restoreForwarded())}))}}async $(){if(this.J.getValue("remote.restoreForwardedPorts")){const j=JSON.stringify(Array.from(this.forwarded.values()));if(j!==this.y){this.y=j;const R=await this.Y();R&&this.I.store(R,this.y,0,0)}}}async bb(j,R,T){if(!j.tunnelLocalPort||!T?.requireLocalPort||j.tunnelLocalPort===R)return;const N=new Date;if(this.ab.getTime()+t>N.getTime())return;this.ab=N;const O=C.localize(3,null,R,j.tunnelRemotePort,j.tunnelLocalPort);return this.P.info(O)}async forward(j,R){return!this.z&&this.L.remoteAuthority&&await L.Event.toPromise(this.C.event),this.cb(j,R)}async cb(j,R){await this.Q.activateByEvent(e.$VJ);const T=E(this.forwarded,j.remote.host,j.remote.port);R=R??(R!==null?(await this.getAttributes([j.remote]))?.get(j.remote.port):void 0);const N=j.local!==void 0?j.local:j.remote.port;let O;if(T)return this.eb(T,j,R);{const W=this.L.remoteAuthority,x=W?{getAddress:async()=>(await this.M.resolveAuthority(W)).authority}:void 0,le=D(j.remote.host,j.remote.port);this.c.set(le,!0),j=this.db(le,j);const G=await this.H.openTunnel(x,j.remote.host,j.remote.port,void 0,N,j.elevateIfNeeded?j.elevateIfNeeded:R?.elevateIfNeeded,j.privacy,R?.protocol);if(typeof G=="string")O=G;else if(G&&G.localAddress){const J=E(this.m??new Map,j.remote.host,j.remote.port),Q=G.protocol?G.protocol===k.TunnelProtocol.Https?k.TunnelProtocol.Https:k.TunnelProtocol.Http:R?.protocol??k.TunnelProtocol.Http,oe={remoteHost:G.tunnelRemoteHost,remotePort:G.tunnelRemotePort,localPort:G.tunnelLocalPort,name:R?.label??j.name,closeable:!0,localAddress:G.localAddress,protocol:Q,localUri:await this.X(G.localAddress,R),runningProcess:J?.detail,hasRunningProcess:!!J,pid:J?.pid,source:j.source??e.$YJ,privacy:G.privacy};return this.forwarded.set(le,oe),this.f.set(le,G),this.c.delete(le),await this.$(),await this.bb(G,N,R),this.g.fire(oe),G}this.c.delete(le)}return O}db(j,R){const T=this.D.has(j)?this.D:this.F.has(j)?this.F:void 0;if(T){const N=T.get(j);T.delete(j),N&&(R.name=N.name??R.name,R.local=("local"in N?N.local:"localPort"in N?N.localPort:void 0)??R.local,R.privacy=N.privacy??R.privacy)}return R}async eb(j,R,T){const N=T?.label??R.name;let O;(function(x){x[x.None=0]="None",x[x.Fire=1]="Fire",x[x.Reopen=2]="Reopen"})(O||(O={}));let W=O.None;switch(N!==j.name&&(j.name=N,W=O.Fire),(T?.protocol||j.protocol!==k.TunnelProtocol.Http)&&T?.protocol!==j.protocol&&(R.source=j.source,W=O.Reopen),R.privacy&&j.privacy!==R.privacy&&(W=O.Reopen),W){case O.Fire:{this.g.fire();break}case O.Reopen:await this.close(j.remoteHost,j.remotePort,c.User),await this.cb(R,T)}return E(this.f,R.remote.host,R.remote.port)}async name(j,R,T){const N=E(this.forwarded,j,R),O=D(j,R);if(N){N.name=T,await this.$(),this.j.fire({host:j,port:R});return}else this.detected.has(O)&&(this.detected.get(O).name=T,this.j.fire({host:j,port:R}))}async close(j,R,T){const N=D(j,R),O=this.forwarded.get(N);return T===c.AutoForwardEnd&&O&&O.source.source===l.Auto&&this.F.set(N,{local:O.localPort,name:O.name,privacy:O.privacy}),await this.H.closeTunnel(j,R),this.W({host:j,port:R},T)}address(j,R){const T=D(j,R);return(this.forwarded.get(T)||this.detected.get(T))?.localAddress}get environmentTunnelsSet(){return this.u}addEnvironmentTunnels(j){if(j)for(const R of j){const T=E(this.m??new Map,R.remoteAddress.host,R.remoteAddress.port),N=typeof R.localAddress=="string"?R.localAddress:D(R.localAddress.host,R.localAddress.port);this.detected.set(D(R.remoteAddress.host,R.remoteAddress.port),{remoteHost:R.remoteAddress.host,remotePort:R.remoteAddress.port,localAddress:N,protocol:k.TunnelProtocol.Http,localUri:this.X(N),closeable:!1,runningProcess:T?.detail,hasRunningProcess:!!T,pid:T?.pid,privacy:k.TunnelPrivacyId.ConstantPrivate,source:{source:l.Extension,description:C.localize(4,null)}}),this.H.setEnvironmentTunnel(R.remoteAddress.host,R.remoteAddress.port,N,k.TunnelPrivacyId.ConstantPrivate,k.TunnelProtocol.Http)}this.u=!0,this.t.fire(),this.g.fire()}setCandidateFilter(j){this.r=j}async setCandidates(j){let R=j;this.r&&(R=await this.r(j));const T=this.fb(R);this.O.trace(`ForwardedPorts: (TunnelModel) removed candidates ${Array.from(T.values()).map(N=>N.port).join(", ")}`),this.n.fire(T)}fb(j){const R=this.m??new Map,T=new Map;return this.m=T,j.forEach(N=>{const O=D(N.host,N.port);T.set(O,{host:N.host,port:N.port,detail:N.detail,pid:N.pid}),R.has(O)&&R.delete(O);const W=E(this.forwarded,N.host,N.port);W&&(W.runningProcess=N.detail,W.hasRunningProcess=!0,W.pid=N.pid)}),R.forEach((N,O)=>{const W=d(O);if(!W)return;const x=E(this.forwarded,W.host,W.port);x&&(x.runningProcess=void 0,x.hasRunningProcess=!1,x.pid=void 0);const le=E(this.detected,W.host,W.port);le&&(le.runningProcess=void 0,le.hasRunningProcess=!1,le.pid=void 0)}),R}get candidates(){return this.m?Array.from(this.m.values()):[]}get candidatesOrUndefined(){return this.m?this.candidates:void 0}async gb(){const j=Array.from(this.forwarded.values()),R=await this.getAttributes(j.map(T=>({port:T.remotePort,host:T.remoteHost})),!1);if(R)for(const T of j){const N=R.get(T.remotePort);(N?.protocol||T.protocol!==k.TunnelProtocol.Http)&&N?.protocol!==T.protocol&&await this.cb({remote:{host:T.remoteHost,port:T.remotePort},local:T.localPort,name:T.name,source:T.source},N),N&&N.label&&N.label!==T.name&&await this.name(T.remoteHost,T.remotePort,N.label)}}async getAttributes(j,R=!0){const T=new Map,N=new Map;j.forEach(G=>{const J=E(this.m??new Map,k.$hv[0],G.port)??G;if(J){T.set(G.port,J);const Q=p(J)?J.pid:void 0;N.has(Q)||N.set(Q,[]),N.get(Q)?.push(G.port)}});const O=new Map;if(j.forEach(G=>{const J=this.configPortsAttributes.getAttributes(G.port,G.host,T.get(G.port)?.detail);J&&O.set(G.port,J)}),this.G.length===0||!R)return O.size>0?O:void 0;const W=await Promise.all((0,F.$Qb)(this.G.map(G=>Array.from(N.entries()).map(J=>{const Q=J[1],oe=T.get(Q[0]);return G.providePortAttributes(Q,oe?.pid,oe?.detail,new i.$2d().token)})))),x=new Map;if(W.forEach(G=>G.forEach(J=>{J&&x.set(J.port,J)})),!O&&!x)return;const le=new Map;return j.forEach(G=>{const J=O.get(G.port),Q=x.get(G.port);le.set(G.port,{elevateIfNeeded:J?.elevateIfNeeded,label:J?.label,onAutoForward:J?.onAutoForward??S.providedActionToAction(Q?.autoForwardAction),requireLocalPort:J?.requireLocalPort,protocol:J?.protocol})}),le}addAttributesProvider(j){this.G.push(j)}};e.$6J=P,He([(0,f.$oh)(1e3)],P.prototype,"$",null),e.$6J=P=He([Be(0,k.$dv),Be(1,y.$_o),Be(2,g.$pi),Be(3,u.$UJ),Be(4,$.$Vk),Be(5,w.$5h),Be(6,I.$dj),Be(7,A.$Hv),Be(8,o.$IF),Be(9,a.$bj)],P)}),define(ke[94],Se([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchCompleteMessageType=e.$PI=e.$OI=void 0;class C{constructor(M,b){this.line=M,this.character=b}isBefore(M){return!1}isBeforeOrEqual(M){return!1}isAfter(M){return!1}isAfterOrEqual(M){return!1}isEqual(M){return!1}compareTo(M){return 0}translate(M,b){return new C(0,0)}with(M){return new C(0,0)}}e.$OI=C;class F{constructor(M,b,v,g){this.isEmpty=!1,this.isSingleLine=!1,this.start=new C(M,b),this.end=new C(v,g)}contains(M){return!1}isEqual(M){return!1}intersection(M){}union(M){return new F(0,0,0,0)}with(M){return new F(0,0,0,0)}}e.$PI=F;var f;(function(L){L[L.Information=1]="Information",L[L.Warning=2]="Warning"})(f||(e.TextSearchCompleteMessageType=f={}))}),define(ke[36],Se([1,0,19,34,24,33,13,5,16,8,94,12]),function(me,e,C,F,f,L,M,b,v,g,A,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$eJ=e.$dJ=e.$cJ=e.$bJ=e.$aJ=e.$_I=e.$$I=e.$0I=e.$9I=e.$8I=e.$7I=e.$6I=e.SearchErrorCode=e.$5I=e.$4I=e.SearchSortOrder=e.ViewMode=e.$3I=e.$2I=e.$1I=e.$ZI=e.SearchCompletionExitCode=e.$YI=e.$XI=e.$WI=e.QueryType=e.SearchProviderType=e.$VI=e.$UI=e.$TI=e.$SI=e.$RI=e.$QI=e.TextSearchCompleteMessageType=void 0,Object.defineProperty(e,"TextSearchCompleteMessageType",{enumerable:!0,get:function(){return A.TextSearchCompleteMessageType}}),e.$QI="workbench.view.search",e.$RI="workbench.panel.search",e.$SI="workbench.view.search",e.$TI="search-result",e.$UI="search.exclude";const $="\u27EA ",y=" characters skipped \u27EB",k=($.length+y.length+5)*2;e.$VI=(0,b.$Vh)("searchService");var w;(function(Q){Q[Q.file=0]="file",Q[Q.text=1]="text"})(w||(e.SearchProviderType=w={}));var u;(function(Q){Q[Q.File=1]="File",Q[Q.Text=2]="Text"})(u||(e.QueryType=u={}));function o(Q){return!!Q.preview}e.$WI=o;function i(Q){return!!Q.resource}e.$XI=i;function n(Q){return!!Q.message}e.$YI=n;var r;(function(Q){Q[Q.Normal=0]="Normal",Q[Q.NewSearchStarted=1]="NewSearchStarted"})(r||(e.SearchCompletionExitCode=r={}));class a{constructor(oe){this.resource=oe,this.results=[]}}e.$ZI=a;class t{constructor(oe,_,Ee,he){this.ranges=_,this.webviewIndex=he;const q=Array.isArray(_)?_:[_];if(Ee&&Ee.matchLines===1&&s(q)){oe=(0,M.$vf)(oe,Ee.matchLines);let U="",ie=0,be=0;const H=Math.floor(Ee.charsPerLine/5),Y=[];for(const Z of q){const $e=Math.max(Z.startColumn-H,0),ne=Z.startColumn+Ee.charsPerLine;if($e>be+H+k){const fe=$+($e-be)+y;U+=fe+oe.slice($e,ne),ie+=$e-(be+fe.length)}else U+=oe.slice(be,ne);Y.push(new c(0,Z.startColumn-ie,Z.endColumn-ie)),be=ne}this.preview={text:U,matches:Array.isArray(this.ranges)?Y:Y[0]}}else{const U=Array.isArray(_)?_[0].startLineNumber:_.startLineNumber;this.preview={text:oe,matches:(0,C.$1b)(_,ie=>new d(ie.startLineNumber-U,ie.startColumn,ie.endLineNumber-U,ie.endColumn))}}}}e.$1I=t;function s(Q){const oe=Q[0].startLineNumber;for(const _ of Q)if(_.startLineNumber!==oe||_.endLineNumber!==oe)return!1;return!0}class d{constructor(oe,_,Ee,he){this.startLineNumber=oe,this.startColumn=_,this.endLineNumber=Ee,this.endColumn=he}}e.$2I=d;class c extends d{constructor(oe,_,Ee){super(oe,_,oe,Ee)}}e.$3I=c;var l;(function(Q){Q.List="list",Q.Tree="tree"})(l||(e.ViewMode=l={}));var h;(function(Q){Q.Default="default",Q.FileNames="fileNames",Q.Type="type",Q.Modified="modified",Q.CountDescending="countDescending",Q.CountAscending="countAscending"})(h||(e.SearchSortOrder=h={}));function E(Q,oe=!0){const _=Q&&Q.files&&Q.files.exclude,Ee=oe&&Q&&Q.search&&Q.search.exclude;if(!_&&!Ee)return;if(!_||!Ee)return _||Ee;let he=Object.create(null);return he=f.$dn(he,f.$an(_)),he=f.$dn(he,f.$an(Ee),!0),he}e.$4I=E;function D(Q,oe){return Q.excludePattern&&F.$Bj(Q.excludePattern,oe)?!1:Q.includePattern||Q.usingSearchPaths?Q.includePattern&&F.$Bj(Q.includePattern,oe)?!0:Q.usingSearchPaths?!!Q.folderQueries&&Q.folderQueries.some(_=>{const Ee=_.folder.fsPath;if(L.$2f(oe,Ee)){const he=v.$kc(Ee,oe);return!_.includePattern||!!F.$Bj(_.includePattern,he)}else return!1}):!1:!0}e.$5I=D;var m;(function(Q){Q[Q.unknownEncoding=1]="unknownEncoding",Q[Q.regexParseError=2]="regexParseError",Q[Q.globParseError=3]="globParseError",Q[Q.invalidLiteral=4]="invalidLiteral",Q[Q.rgProcessError=5]="rgProcessError",Q[Q.other=6]="other",Q[Q.canceled=7]="canceled"})(m||(e.SearchErrorCode=m={}));class p extends Error{constructor(oe,_){super(oe),this.code=_}}e.$6I=p;function S(Q){const oe=Q.message;if((0,g.$3)(Q))return new p(oe,m.canceled);try{const _=JSON.parse(oe);return new p(_.message,_.code)}catch{return new p(oe,m.other)}}e.$7I=S;function P(Q){const oe={message:Q.message,code:Q.code};return new Error(JSON.stringify(oe))}e.$8I=P;function z(Q){return Q.type==="error"?!0:Q.type==="success"}e.$9I=z;function j(Q){return Q.type==="success"}e.$0I=j;function R(Q){return!!Q.path}e.$$I=R;function T(Q,oe){const _=Q.searchPath?Q.searchPath:Q.relativePath;return(0,M.$sf)(_,oe)}e.$_I=T;class N{constructor(oe){this.path=oe,this.results=[]}addMatch(oe){this.results.push(oe)}serialize(){return{path:this.path,results:this.results,numMatches:this.results.length}}}e.$aJ=N;function O(Q,oe){const _={...Q||{},...oe||{}};return Object.keys(_).filter(Ee=>{const he=_[Ee];return typeof he=="boolean"&&he})}e.$bJ=O;class W{constructor(oe,_){this.c=null,this.a={...oe.excludePattern||{},..._.excludePattern||{}},this.b=F.$Cj(this.a);let Ee=oe.includePattern;_.includePattern&&(Ee?Ee={...Ee,..._.includePattern}:Ee=_.includePattern),Ee&&(this.c=F.$Cj(Ee))}matchesExcludesSync(oe,_,Ee){return!!(this.b&&this.b(oe,_,Ee))}includedInQuerySync(oe,_,Ee){return!(this.b&&this.b(oe,_,Ee)||this.c&&!this.c(oe,_,Ee))}includedInQuery(oe,_,Ee){const he=this.b(oe,_,Ee),q=()=>this.c?!!this.c(oe,_,Ee):!0;return(0,I.$Kg)(he)?he.then(U=>U?!1:q()):q()}hasSiblingExcludeClauses(){return x(this.a)}}e.$cJ=W;function x(Q){for(const oe in Q)if(typeof Q[oe]!="boolean")return!0;return!1}function le(Q){if(!Q)return;let oe;return _=>(oe||(oe=(Q()||Promise.resolve([])).then(Ee=>Ee?J(Ee):{})),oe.then(Ee=>!!Ee[_]))}e.$dJ=le;function G(Q){if(!Q)return;let oe;return _=>{if(!oe){const Ee=Q();oe=Ee?J(Ee):{}}return!!oe[_]}}e.$eJ=G;function J(Q){const oe={};for(const _ of Q)oe[_]=!0;return oe}}),define(ke[41],Se([1,0,19,12,21,4,3,77,17,123,23,13,2,222,5,14,253,40,57,27,20,15,7,66,36,6,54]),function(me,e,C,F,f,L,M,b,v,g,A,I,$,y,k,w,u,o,i,n,r,a,t,s,d,c,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3dc=e.$2dc=void 0;function h(j,R,T){return new A.$og(N=>p(N,T)).isEqual(j,R)}function E(j,R,T){return h(j.uri,R.uri,T)?0:(0,I.$Ye)(j.uri.toString(),R.uri.toString())}function D(j,R,T){return j.index!==R.index?j.index<R.index?-1:1:h(j.uri,R.uri,T)?(0,I.$Ye)(j.name,R.name):(0,I.$Ye)(j.uri.toString(),R.uri.toString())}function m(j,R,T,N){const O=j.slice(0).sort((x,le)=>T(x,le,N)),W=R.slice(0).sort((x,le)=>T(x,le,N));return(0,C.$Db)(O,W,(x,le)=>T(x,le,N))}function p(j,R){const T=R.getCapabilities(j.scheme);return!(T&&T&1024)}class S extends o.$ci{static toExtHostWorkspace(R,T,N,O){if(!R)return{workspace:null,added:[],removed:[]};const{id:W,name:x,folders:le,configuration:G,transient:J,isUntitled:Q}=R,oe=[],_=T;T?le.forEach((U,ie)=>{const be=$.URI.revive(U.uri),H=S.o(N||T,be,O);H?(H.name=U.name,H.index=U.index,oe.push(H)):oe.push({uri:be,name:U.name,index:ie})}):oe.push(...le.map(({uri:U,name:ie,index:be})=>({uri:$.URI.revive(U),name:ie,index:be}))),oe.sort((U,ie)=>U.index<ie.index?-1:1);const Ee=new S(W,x,oe,!!J,G?$.URI.revive(G):null,!!Q,U=>p(U,O)),{added:he,removed:q}=m(_?_.workspaceFolders:[],Ee.workspaceFolders,E,O);return{workspace:Ee,added:he,removed:q}}static o(R,T,N){for(let O=0;O<R.folders.length;O++){const W=R.workspaceFolders[O];if(h(W.uri,T,N))return W}}constructor(R,T,N,O,W,x,le){super(R,N.map(G=>new o.$di(G)),O,W,le),this.t=T,this.u=x,this.q=[],this.s=b.$2h.forUris(le),N.forEach(G=>{this.q.push(G),this.s.set(G.uri,G)})}get name(){return this.t}get isUntitled(){return this.u}get workspaceFolders(){return this.q.slice(0)}getWorkspaceFolder(R,T){return T&&this.s.get(R)&&(R=(0,A.$yg)(R)),this.s.findSubstr(R)}resolveWorkspaceFolder(R){return this.s.get(R)}}let P=class{constructor(R,T,N,O,W){this.c=new L.$Rd,this.onDidChangeWorkspace=this.c.event,this.g=new L.$Rd,this.onDidGrantWorkspaceTrust=this.g.event,this.u=[],this.v=!1,this.w=new Map,this.z=0,this.A=new L.$Td,this.B=new Map,this.h=O,this.s=N,this.t=W,this.j=new g.$Wl,this.k=new F.$Wg,this.o=R.getProxy(c.$xK.MainThreadWorkspace),this.q=R.getProxy(c.$xK.MainThreadMessageService);const x=T.workspace;this.l=x?new S(x.id,x.name,[],!!x.transient,x.configuration?$.URI.revive(x.configuration):null,!!x.isUntitled,le=>p(le,N)):void 0}$initializeWorkspace(R,T){this.v=T,this.$acceptWorkspaceData(R),this.k.open()}waitForInitializeCall(){return this.k.wait()}get workspace(){return this.x}get name(){return this.x?this.x.name:void 0}get workspaceFile(){if(this.x&&this.x.configuration)return this.x.isUntitled?$.URI.from({scheme:v.Schemas.untitled,path:(0,A.$wg)((0,A.$yg)(this.x.configuration))}):this.x.configuration}get x(){return this.n||this.l}getWorkspaceFolders(){if(this.x)return this.x.workspaceFolders.slice(0)}async getWorkspaceFolders2(){if(await this.k.wait(),!!this.x)return this.x.workspaceFolders.slice(0)}updateWorkspaceFolders(R,T,N,...O){const W=[];if(Array.isArray(O)&&O.forEach(Q=>{$.URI.isUri(Q.uri)&&!W.some(oe=>h(oe.uri,Q.uri,this.s))&&W.push({uri:Q.uri,name:Q.name||(0,A.$vg)(Q.uri)})}),this.n||[T,N].some(Q=>typeof Q!="number"||Q<0)||N===0&&W.length===0)return!1;const x=this.x?this.x.workspaceFolders:[];if(T+N>x.length)return!1;const le=x.slice(0);le.splice(T,N,...W.map(Q=>({uri:Q.uri,name:Q.name||(0,A.$vg)(Q.uri),index:void 0})));for(let Q=0;Q<le.length;Q++){const oe=le[Q];if(le.some((_,Ee)=>Ee!==Q&&h(oe.uri,_.uri,this.s)))return!1}le.forEach((Q,oe)=>Q.index=oe);const{added:G,removed:J}=m(x,le,D,this.s);if(G.length===0&&J.length===0)return!1;if(this.o){const Q=R.displayName||R.name;this.o.$updateWorkspaceFolders(Q,T,N,W).then(void 0,oe=>{this.n=void 0;const _={source:{identifier:R.identifier,label:R.displayName||R.name}};this.q.$showMessage(u.Severity.Error,(0,y.localize)(0,null,Q,oe.toString()),_,[])})}return this.y(le),!0}getWorkspaceFolder(R,T){if(this.x)return this.x.getWorkspaceFolder(R,T)}async getWorkspaceFolder2(R,T){if(await this.k.wait(),!!this.x)return this.x.getWorkspaceFolder(R,T)}async resolveWorkspaceFolder(R){if(await this.k.wait(),!!this.x)return this.x.resolveWorkspaceFolder(R)}getPath(){if(!this.x)return;const{folders:R}=this.x;if(R.length!==0)return R[0].uri.fsPath}getRelativePath(R,T){let N,O="";if(typeof R=="string"?(N=$.URI.file(R),O=R):typeof R<"u"&&(N=R,O=R.fsPath),!N)return O;const W=this.getWorkspaceFolder(N,!0);if(!W)return O;typeof T>"u"&&this.x&&(T=this.x.folders.length>1);let x=(0,A.$Bg)(W.uri,N);return T&&W.name&&(x=`${W.name}/${x}`),x}y(R){this.x&&(this.n=S.toExtHostWorkspace({id:this.x.id,name:this.x.name,configuration:this.x.configuration,folders:R,isUntitled:this.x.isUntitled},this.x,void 0,this.s).workspace||void 0)}$acceptWorkspaceData(R){const{workspace:T,added:N,removed:O}=S.toExtHostWorkspace(R,this.l,this.n,this.s);this.l=T||void 0,this.n=void 0,this.c.fire(Object.freeze({added:N,removed:O}))}findFiles(R,T,N,O,W=f.CancellationToken.None){this.h.trace(`extHostWorkspace#findFiles: fileSearch, extension: ${O.value}, entryPoint: findFiles`);let x;if(T===null?x=!1:T&&(typeof T=="string"?x=T:x=T.pattern),W&&W.isCancellationRequested)return Promise.resolve([]);const{includePattern:le,folder:G}=z(a.GlobPattern.from(R));return this.o.$startFileSearch(le??null,G??null,x??null,N??null,W).then(J=>Array.isArray(J)?J.map(Q=>$.URI.revive(Q)):[])}async findTextInFiles(R,T,N,O,W=f.CancellationToken.None){this.h.trace(`extHostWorkspace#findTextInFiles: textSearch, extension: ${O.value}, entryPoint: findTextInFiles`);const x=this.j.getNext(),le=typeof T.previewOptions>"u"?{matchLines:100,charsPerLine:1e4}:T.previewOptions,{includePattern:G,folder:J}=z(a.GlobPattern.from(T.include)),Q=typeof T.exclude=="string"?T.exclude:T.exclude?T.exclude.pattern:void 0,oe={ignoreSymlinks:typeof T.followSymlinks=="boolean"?!T.followSymlinks:void 0,disregardIgnoreFiles:typeof T.useIgnoreFiles=="boolean"?!T.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof T.useGlobalIgnoreFiles=="boolean"?!T.useGlobalIgnoreFiles:void 0,disregardParentIgnoreFiles:typeof T.useParentIgnoreFiles=="boolean"?!T.useParentIgnoreFiles:void 0,disregardExcludeSettings:typeof T.useDefaultExcludes=="boolean"?!T.useDefaultExcludes:!0,fileEncoding:T.encoding,maxResults:T.maxResults,previewOptions:le,afterContext:T.afterContext,beforeContext:T.beforeContext,includePattern:G,excludePattern:Q},_=!1;if(this.u[x]=Ee=>{if(_)return;const he=$.URI.revive(Ee.resource);Ee.results.forEach(q=>{const U=(0,l.$sh)(q);(0,d.$WI)(U)?N({uri:he,preview:{text:U.preview.text,matches:(0,C.$1b)(U.preview.matches,ie=>new t.$BK(ie.startLineNumber,ie.startColumn,ie.endLineNumber,ie.endColumn))},ranges:(0,C.$1b)(U.ranges,ie=>new t.$BK(ie.startLineNumber,ie.startColumn,ie.endLineNumber,ie.endColumn))}):N({uri:he,text:U.text,lineNumber:U.lineNumber})})},W.isCancellationRequested)return{};try{const Ee=await this.o.$startTextSearch(R,J??null,oe,x,W);return delete this.u[x],Ee||{}}catch(Ee){throw delete this.u[x],Ee}}$handleTextSearchResult(R,T){this.u[T]?.(R)}async save(R){const T=await this.o.$save(R,{saveAs:!1});return $.URI.revive(T)}async saveAs(R){const T=await this.o.$save(R,{saveAs:!0});return $.URI.revive(T)}saveAll(R){return this.o.$saveAll(R)}resolveProxy(R){return this.o.$resolveProxy(R)}loadCertificates(){return this.o.$loadCertificates()}get trusted(){return this.v}requestWorkspaceTrust(R){return this.o.$requestWorkspaceTrust(R)}$onDidGrantWorkspaceTrust(){this.v||(this.v=!0,this.g.fire())}registerEditSessionIdentityProvider(R,T){if(this.w.has(R))throw new Error(`A provider has already been registered for scheme ${R}`);this.w.set(R,T);const N=this.t.transformOutgoingScheme(R),O=this.z++;return this.o.$registerEditSessionIdentityProvider(O,N),(0,M.$Pc)(()=>{this.w.delete(R),this.o.$unregisterEditSessionIdentityProvider(O)})}async $getEditSessionIdentifier(R,T){this.h.info("Getting edit session identifier for workspaceFolder",R);const N=await this.resolveWorkspaceFolder($.URI.revive(R));if(!N){this.h.warn("Unable to resolve workspace folder");return}this.h.info("Invoking #provideEditSessionIdentity for workspaceFolder",N);const O=this.w.get(N.uri.scheme);if(this.h.info(`Provider for scheme ${N.uri.scheme} is defined: `,!!O),!O)return;const W=await O.provideEditSessionIdentity(N,T);if(this.h.info("Provider returned edit session identifier: ",W),!!W)return W}async $provideEditSessionIdentityMatch(R,T,N,O){this.h.info("Getting edit session identifier for workspaceFolder",R);const W=await this.resolveWorkspaceFolder($.URI.revive(R));if(!W){this.h.warn("Unable to resolve workspace folder");return}this.h.info("Invoking #provideEditSessionIdentity for workspaceFolder",W);const x=this.w.get(W.uri.scheme);if(this.h.info(`Provider for scheme ${W.uri.scheme} is defined: `,!!x),!x)return;const le=await x.provideEditSessionIdentityMatch?.(T,N,O);if(this.h.info("Provider returned edit session identifier match result: ",le),!!le)return le}getOnWillCreateEditSessionIdentityEvent(R){return(T,N,O)=>{const W=function(le){T.call(N,le)};return W.extension=R,this.A.event(W,void 0,O)}}async $onWillCreateEditSessionIdentity(R,T,N){const O=await this.resolveWorkspaceFolder($.URI.revive(R));if(O===void 0)throw new Error("Unable to resolve workspace folder");await this.A.fireAsync({workspaceFolder:O},T,async(W,x)=>{const le=Date.now();await Promise.resolve(W),Date.now()-le>N&&this.h.warn("SLOW edit session create-participant",x.extension.identifier)}),T.isCancellationRequested}registerCanonicalUriProvider(R,T){if(this.B.has(R))throw new Error(`A provider has already been registered for scheme ${R}`);this.B.set(R,T);const N=this.t.transformOutgoingScheme(R),O=this.z++;return this.o.$registerCanonicalUriProvider(O,N),(0,M.$Pc)(()=>{this.B.delete(R),this.o.$unregisterCanonicalUriProvider(O)})}async provideCanonicalUri(R,T,N){const O=this.B.get(R.scheme);if(!O)return;const W=await O.provideCanonicalUri?.($.URI.revive(R),T,N);if(W)return W}async $provideCanonicalUri(R,T,N){return this.provideCanonicalUri($.URI.revive(R),{targetScheme:T},N)}};e.$2dc=P,e.$2dc=P=He([Be(0,r.$zM),Be(1,n.$PM),Be(2,i.$Hdc),Be(3,w.$dj),Be(4,s.$Zdc)],P),e.$3dc=(0,k.$Vh)("IExtHostWorkspace");function z(j){let R,T;return j&&(typeof j=="string"?R=j:(R=j.pattern,T=$.URI.revive(j.baseUri))),{includePattern:R,folder:T}}}),define(ke[42],Se([1,0,24,4,41,6,7,255,86,18,12,5,20,14,2]),function(me,e,C,F,f,L,M,b,v,g,A,I,$,y,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6dc=e.$5dc=e.$4dc=void 0;function w(s,d){if(d){const c=d.split(".");let l=s;for(let h=0;l&&h<c.length;h++)l=l[c[h]];return l}}function u(s){return s instanceof k.URI}function o(s){return s&&s.uri instanceof k.URI&&s.languageId&&typeof s.languageId=="string"}function i(s){return s&&!s.uri&&s.languageId&&typeof s.languageId=="string"}function n(s){return s&&s.uri instanceof k.URI&&(!s.name||typeof s.name=="string")&&(!s.index||typeof s.index=="number")}function r(s){if(u(s))return{resource:s};if(o(s))return{resource:s.uri,overrideIdentifier:s.languageId};if(i(s))return{overrideIdentifier:s.languageId};if(n(s))return{resource:s.uri};if(s===null)return{resource:null}}let a=class{constructor(d,c,l){this.a=d.getProxy(L.$xK.MainThreadConfiguration),this.c=c,this.b=l,this.d=new A.$Wg,this.e=null}getConfigProvider(){return this.d.wait().then(d=>this.e)}$initializeConfiguration(d){this.e=new t(this.a,this.c,d,this.b),this.d.open()}$acceptConfigurationChanged(d,c){this.getConfigProvider().then(l=>l.$acceptConfigurationChanged(d,c))}};e.$4dc=a,e.$4dc=a=He([Be(0,$.$zM),Be(1,f.$3dc),Be(2,y.$dj)],a);class t{constructor(d,c,l,h){this.a=new F.$Rd,this.b=d,this.f=h,this.c=c,this.e=b.$Kn.parse(l),this.d=this.k(l.configurationScopes)}get onDidChangeConfiguration(){return this.a&&this.a.event}$acceptConfigurationChanged(d,c){const l={data:this.e.toData(),workspace:this.c.workspace};this.e=b.$Kn.parse(d),this.d=this.k(d.configurationScopes),this.a.fire(this.j(c,l))}getConfiguration(d,c,l){const h=r(c)||{},E=this.g(d?w(this.e.getValue(void 0,h,this.c.workspace),d):this.e.getValue(void 0,h,this.c.workspace));d&&this.h(d,h,l?.identifier);function D(p){if(p==null)return null;if(typeof p=="boolean")return p?2:5;switch(p){case M.ConfigurationTarget.Global:return 2;case M.ConfigurationTarget.Workspace:return 5;case M.ConfigurationTarget.WorkspaceFolder:return 6}}const m={has(p){return typeof w(E,p)<"u"},get:(p,S)=>{this.h(d?`${d}.${p}`:p,h,l?.identifier);let P=w(E,p);if(typeof P>"u")P=S;else{let z;const j=(R,T)=>{if((0,g.$Ef)(R)){let N;const O=()=>{z=z||(0,C.$an)(E),N=N||w(z,T)};return new Proxy(R,{get:(W,x)=>{if(typeof x=="string"&&x.toLowerCase()==="tojson")return O(),()=>N;if(z)return N=N||w(z,T),N[x];const le=W[x];return typeof x=="string"?j(le,`${T}.${x}`):le},set:(W,x,le)=>(O(),N&&(N[x]=le),!0),deleteProperty:(W,x)=>(O(),N&&delete N[x],!0),defineProperty:(W,x,le)=>(O(),N&&Object.defineProperty(N,x,le),!0)})}return Array.isArray(R)?(0,C.$an)(R):R};P=j(P,p)}return P},update:(p,S,P,z)=>{p=d?`${d}.${p}`:p;const j=D(P);return S!==void 0?this.b.$updateConfigurationOption(j,p,S,h,z):this.b.$removeConfigurationOption(j,p,h,z)},inspect:p=>{p=d?`${d}.${p}`:p;const S=this.e.inspect(p,h,this.c.workspace);if(S)return{key:p,defaultValue:(0,C.$an)(S.policy?.value??S.default?.value),globalValue:(0,C.$an)(S.user?.value??S.application?.value),workspaceValue:(0,C.$an)(S.workspace?.value),workspaceFolderValue:(0,C.$an)(S.workspaceFolder?.value),defaultLanguageValue:(0,C.$an)(S.default?.override),globalLanguageValue:(0,C.$an)(S.user?.override??S.application?.override),workspaceLanguageValue:(0,C.$an)(S.workspace?.override),workspaceFolderLanguageValue:(0,C.$an)(S.workspaceFolder?.override),languageIds:(0,C.$an)(S.overrideIdentifiers)}}};return typeof E=="object"&&(0,C.$dn)(m,E,!1),Object.freeze(m)}g(d){const c=l=>(0,g.$Ef)(l)?new Proxy(l,{get:(h,E)=>c(h[E]),set:(h,E,D)=>{throw new Error(`TypeError: Cannot assign to read only property '${String(E)}' of object`)},deleteProperty:(h,E)=>{throw new Error(`TypeError: Cannot delete read only property '${String(E)}' of object`)},defineProperty:(h,E)=>{throw new Error(`TypeError: Cannot define property '${String(E)}' for a readonly object`)},setPrototypeOf:h=>{throw new Error("TypeError: Cannot set prototype for a readonly object")},isExtensible:()=>!1,preventExtensions:()=>!0}):l;return c(d)}h(d,c,l){const h=v.$Bn.test(d)?4:this.d.get(d),E=l?`[${l.value}] `:"";if(h===4){typeof c?.resource>"u"&&this.f.warn(`${E}Accessing a resource scoped configuration without providing a resource is not expected. To get the effective value for '${d}', provide the URI of a resource or 'null' for any resource.`);return}if(h===3){c?.resource&&this.f.warn(`${E}Accessing a window scoped configuration for a resource is not expected. To associate '${d}' to a resource, define its scope to 'resource' in configuration contributions in 'package.json'.`);return}}j(d,c){const l=new b.$Mn(d,c,this.e,this.c.workspace);return Object.freeze({affectsConfiguration:(h,E)=>l.affectsConfiguration(h,r(E))})}k(d){return d.reduce((c,l)=>(c.set(l[0],l[1]),c),new Map)}}e.$5dc=t,e.$6dc=(0,I.$Vh)("IExtHostConfiguration")}),define(ke[95],Se([1,0,2,12,4,6,7,41,69,42,21,46,20,27,5,17,11,14,91,303,8]),function(me,e,C,F,f,L,M,b,v,g,A,I,$,y,k,w,u,o,i,n,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wfc=e.$vfc=e.$ufc=e.TaskDTO=e.TaskHandleDTO=e.CustomExecutionDTO=void 0;var a;(function(j){function R(N){if(N!=null)return N}j.from=R;function T(N){if(N!=null)return N}j.to=T})(a||(a={}));var t;(function(j){function R(N){if(N!=null)return N}j.from=R;function T(N){if(N!=null)return N}j.to=T})(t||(t={}));var s;(function(j){function R(N){if(N!=null)return N}j.from=R;function T(N){if(N!=null)return N}j.to=T})(s||(s={}));var d;(function(j){function R(O){if(O){const W=O;return W&&!!W.process}else return!1}j.is=R;function T(O){if(O==null)return;const W={process:O.process,args:O.args};return O.options&&(W.options=s.from(O.options)),W}j.from=T;function N(O){if(O!=null)return new M.$hL(O.process,O.args,O.options)}j.to=N})(d||(d={}));var c;(function(j){function R(N){if(N!=null)return N}j.from=R;function T(N){if(N!=null)return N}j.to=T})(c||(c={}));var l;(function(j){function R(O){if(O){const W=O;return W&&(!!W.commandLine||!!W.command)}else return!1}j.is=R;function T(O){if(O==null)return;const W={};return O.commandLine!==void 0?W.commandLine=O.commandLine:(W.command=O.command,W.args=O.args),O.options&&(W.options=c.from(O.options)),W}j.from=T;function N(O){if(!(O==null||O.command===void 0&&O.commandLine===void 0))return O.commandLine?new M.$iL(O.commandLine,O.options):new M.$iL(O.command,O.args?O.args:[],O.options)}j.to=N})(l||(l={}));var h;(function(j){function R(O){if(O){const W=O;return W&&W.customExecution==="customExecution"}else return!1}j.is=R;function T(O){return{customExecution:"customExecution"}}j.from=T;function N(O,W){return W.get(O)}j.to=N})(h||(e.CustomExecutionDTO=h={}));var E;(function(j){function R(T,N){let O;return T.scope!==void 0&&typeof T.scope!="number"?O=T.scope.uri:T.scope!==void 0&&typeof T.scope=="number"&&(T.scope===M.TaskScope.Workspace&&N&&N.workspaceFile?O=N.workspaceFile:O=n.$8F),{id:T._id,workspaceFolder:O}}j.from=R})(E||(e.TaskHandleDTO=E={}));var D;(function(j){function R(T){if(T!=null)return{_id:T.id,isDefault:T.isDefault}}j.from=R})(D||(D={}));var m;(function(j){function R(O,W){if(O==null)return[];const x=[];for(const le of O){const G=T(le,W);G&&x.push(G)}return x}j.fromMany=R;function T(O,W){if(O==null)return;let x;O.execution instanceof M.$hL?x=d.from(O.execution):O.execution instanceof M.$iL?x=l.from(O.execution):O.execution&&O.execution instanceof M.$jL&&(x=h.from(O.execution));const le=a.from(O.definition);let G;return O.scope?typeof O.scope=="number"?G=O.scope:G=O.scope.uri:G=M.TaskScope.Workspace,!le||!G?void 0:{_id:O._id,definition:le,name:O.name,source:{extensionId:W.identifier.value,label:O.source,scope:G},execution:x,isBackground:O.isBackground,group:D.from(O.group),presentationOptions:t.from(O.presentationOptions),problemMatchers:O.problemMatchers,hasDefinedMatchers:O.hasDefinedMatchers,runOptions:O.runOptions?O.runOptions:{reevaluateOnRerun:!0},detail:O.detail}}j.from=T;async function N(O,W,x){if(O==null)return;let le;d.is(O.execution)?le=d.to(O.execution):l.is(O.execution)?le=l.to(O.execution):h.is(O.execution)&&(le=h.to(O._id,x));const G=a.to(O.definition);let J;if(O.source&&(O.source.scope!==void 0?typeof O.source.scope=="number"?J=O.source.scope:J=await W.resolveWorkspaceFolder(C.URI.revive(O.source.scope)):J=M.TaskScope.Workspace),!G||!J)return;const Q=new M.$kL(G,J,O.name,O.source.label,le,O.problemMatchers);return O.isBackground!==void 0&&(Q.isBackground=O.isBackground),O.group!==void 0&&(Q.group=M.$gL.from(O.group._id),Q.group&&O.group.isDefault&&(Q.group=new M.$gL(Q.group.id,Q.group.label),O.group.isDefault===!0&&(Q.group.isDefault=O.group.isDefault))),O.presentationOptions&&(Q.presentationOptions=t.to(O.presentationOptions)),O._id&&(Q._id=O._id),O.detail&&(Q.detail=O.detail),Q}j.to=N})(m||(e.TaskDTO=m={}));var p;(function(j){function R(N){return N}j.from=R;function T(N){if(N)return Object.assign(Object.create(null),N)}j.to=T})(p||(p={}));class S{#e;constructor(R,T,N){this._id=T,this.a=N,this.#e=R}get task(){return this.a}terminate(){this.#e.terminateTask(this)}fireDidStartProcess(R){}fireDidEndProcess(R){}}let P=class{constructor(R,T,N,O,W,x,le,G){this.q=new f.$Rd,this.r=new f.$Rd,this.s=new f.$Rd,this.t=new f.$Rd,this.a=R.getProxy(L.$xK.MainThreadTask),this.b=N,this.c=O,this.d=W,this.e=x,this.h=0,this.j=new Map,this.k=new Map,this.l=new Map,this.m=new Map,this.n=new Set,this.o=new Map,this.f=le,this.g=G,this.a.$registerSupportedExecutions(!0)}registerTaskProvider(R,T,N){if(!N)return new M.$zK(()=>{});const O=this.w();return this.j.set(O,{type:T,provider:N,extension:R}),this.a.$registerTaskProvider(O,T),new M.$zK(()=>{this.j.delete(O),this.a.$unregisterTaskProvider(O)})}registerTaskSystem(R,T){this.a.$registerTaskSystem(R,T)}fetchTasks(R){return this.a.$fetchTasks(p.from(R)).then(async T=>{const N=[];for(const O of T){const W=await m.to(O,this.b,this.m);W&&N.push(W)}return N})}get taskExecutions(){const R=[];return this.k.forEach(T=>R.push(T)),R}terminateTask(R){if(!(R instanceof S))throw new Error("No valid task execution provided");return this.a.$terminateTask(R._id)}get onDidStartTask(){return this.q.event}async $onDidStartTask(R,T,N){const O=this.m.get(R.id);O&&(this.o.set(R.id,O),this.e.attachPtyToTerminal(T,await O.callback(N))),this.p=R.id,this.q.fire({execution:await this.y(R)})}get onDidEndTask(){return this.r.event}async $OnDidEndTask(R){const T=await this.y(R);this.l.delete(R.id),this.k.delete(R.id),this.A(R),this.r.fire({execution:T})}get onDidStartTaskProcess(){return this.s.event}async $onDidStartTaskProcess(R){const T=await this.y(R.id);this.s.fire({execution:T,processId:R.processId})}get onDidEndTaskProcess(){return this.t.event}async $onDidEndTaskProcess(R){const T=await this.y(R.id);this.t.fire({execution:T,exitCode:R.exitCode})}$provideTasks(R,T){const N=this.j.get(R);if(!N)return Promise.reject(new Error("no handler found"));const O=[],W=(0,F.$Qg)(()=>N.provider.provideTasks(A.CancellationToken.None)).then(x=>this.u(T,O,N,x));return new Promise(x=>{W.then(le=>{Promise.all(O).then(()=>{x(le)})})})}async $resolveTask(R,T){const N=this.j.get(R);if(!N)return Promise.reject(new Error("no handler found"));if(T.definition.type!==N.type)throw new Error(`Unexpected: Task of type [${T.definition.type}] cannot be resolved by provider of type [${N.type}].`);const O=await m.to(T,this.b,this.m);if(!O)throw new Error("Unexpected: Task cannot be resolved.");const W=await N.provider.resolveTask(O,A.CancellationToken.None);if(!W)return;this.z(W,N);const x=m.from(W,N.extension);if(!x)throw new Error("Unexpected: Task cannot be resolved.");if(W.definition!==O.definition)throw new Error("Unexpected: The resolved task definition must be the same object as the original task definition. The task definition cannot be changed.");return h.is(x.execution)&&await this.x(x,W,!0),await this.v(x)}w(){return this.h++}async x(R,T,N){const O=await this.a.$createTaskId(R);!N&&!this.m.has(O)&&(this.n.add(O),this.o.set(O,T.execution)),this.m.set(O,T.execution)}async y(R,T){if(typeof R=="string"){const W=this.l.get(R);if(!W)throw new r.$ab("Unexpected: The specified task is missing an execution");return W}const N=this.l.get(R.id);if(N)return N;const O=new Promise((W,x)=>{function le(G,J,Q){Q?W(new S(G,J.id,Q)):x("Unexpected: Task does not exist.")}T?le(this,R,T):m.to(R.task,this.b,this.m).then(G=>le(this,R,G))});return this.l.set(R.id,O),O.then(W=>(this.k.set(R.id,W),W),W=>Promise.reject(W))}z(R,T){R._deprecated&&this.g.report("Task.constructor",T.extension,"Use the Task constructor that takes a `scope` instead.")}A(R){this.o.get(R.id)&&this.o.delete(R.id),this.n.has(R.id)&&this.p!==R.id&&(this.m.delete(R.id),this.n.delete(R.id));const N=this.n.values();let O=N.next();for(;!O.done;)!this.o.has(O.value)&&this.p!==O.value&&(this.m.delete(O.value),this.n.delete(O.value)),O=N.next()}};e.$ufc=P,e.$ufc=P=He([Be(0,$.$zM),Be(1,y.$PM),Be(2,b.$3dc),Be(3,v.$KM),Be(4,g.$6dc),Be(5,I.$rec),Be(6,o.$dj),Be(7,i.$Kdc)],P);let z=class extends P{constructor(R,T,N,O,W,x,le,G){super(R,T,N,O,W,x,le,G),this.registerTaskSystem(w.Schemas.vscodeRemote,{scheme:w.Schemas.vscodeRemote,authority:"",platform:u.$h(0)})}async executeTask(R,T){if(!T.execution)throw new Error("Tasks to execute must include an execution");const N=m.from(T,R);if(N===void 0)throw new Error("Task is not valid");if(h.is(N.execution))await this.x(N,T,!1);else throw new r.$$;const O=await this.y(await this.a.$getTaskExecution(N),T);return this.a.$executeTask(N).catch(W=>{throw new Error(W)}),O}u(R,T,N,O){const W=[];if(O)for(const x of O){if(this.z(x,N),!x.definition||!R[x.definition.type]){const G=x.source?x.source:"No task source";this.f.warn(`The task [${G}, ${x.name}] uses an undefined task type. The task will be ignored in the future.`)}const le=m.from(x,N.extension);le&&h.is(le.execution)?(W.push(le),T.push(this.x(le,x,!0))):this.f.warn("Only custom execution tasks supported.")}return{tasks:W,extension:N.extension}}async v(R){if(h.is(R.execution))return R;this.f.warn("Only custom execution tasks supported.")}async $resolveVariables(R,T){return{process:void 0,variables:Object.create(null)}}async $jsonTasksSupported(){return!1}async $findExecutable(R,T,N){}};e.$vfc=z,e.$vfc=z=He([Be(0,$.$zM),Be(1,y.$PM),Be(2,b.$3dc),Be(3,v.$KM),Be(4,g.$6dc),Be(5,I.$rec),Be(6,o.$dj),Be(7,i.$Kdc)],z),e.$wfc=(0,k.$Vh)("IExtHostTask")}),define(ke[359],Se([1,0,36,29]),function(me,e,C,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mJ=e.$lJ=e.$kJ=void 0;function f(M){return"cellResults"in M}e.$kJ=f,e.$lJ="rawCell#";function L(M,b){let v=-1;const g=[];let A=[];return M.forEach($=>{$.range.startLineNumber!==v&&A.length>0&&(g.push([...A]),A=[]),A.push($),v=$.range.endLineNumber}),A.length>0&&g.push([...A]),g.map($=>{const y=[],k=$[0].range.startLineNumber,w=$[$.length-1].range.endLineNumber;for(let u=k;u<=w;u++)y.push(b.getLineContent(u));return new C.$1I(y.join(`
`)+`
`,$.map(u=>new F.$zs(u.range.startLineNumber-1,u.range.startColumn-1,u.range.endLineNumber-1,u.range.endColumn-1)))})}e.$mJ=L}),define(ke[360],Se([1,0,215,22,4,3,28,13,18,2,31,110,6,35,15,7,68,295,148,8,24,17,287,359,356]),function(me,e,C,F,f,L,M,b,v,g,A,I,$,y,k,w,u,o,i,n,r,a,t,s,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9ec=void 0;class c{static{this.a=0}get activeNotebookEditor(){return this.k?.apiEditor}get visibleNotebookEditors(){return this.l.map(h=>h.apiEditor)}constructor(h,E,D,m,p,S){this.q=D,this.r=m,this.s=p,this.t=S,this.f=new Map,this.g=new M.$zc,this.h=new Map,this.j=new f.$Rd({onListenerError:n.$1}),this.onDidChangeActiveNotebookEditor=this.j.event,this.l=[],this.m=new f.$Rd({onListenerError:n.$1}),this.onDidOpenNotebookDocument=this.m.event,this.n=new f.$Rd({onListenerError:n.$1}),this.onDidCloseNotebookDocument=this.n.event,this.o=new f.$Rd({onListenerError:n.$1}),this.onDidChangeVisibleNotebookEditors=this.o.event,this.p=new I.$Ddc("NotebookCellStatusBarCache"),this.w=0,this.x=new Map,this.b=h.getProxy($.$xK.MainThreadNotebook),this.c=h.getProxy($.$xK.MainThreadNotebookDocuments),this.d=h.getProxy($.$xK.MainThreadNotebookEditors),this.i=E.converter,E.registerArgumentProcessor({processArgument:P=>{if(P&&P.$mid===13){const z=P.notebookEditor?.notebookUri,j=P.cell.handle,T=this.g.get(z)?.getCell(j);if(T)return T.apiCell}if(P&&P.$mid===14){const z=P.uri,j=this.g.get(z);if(j)return j.apiNotebook}return P}}),c.B(E)}getEditorById(h){const E=this.h.get(h);if(!E)throw new Error(`unknown text editor: ${h}. known editors: ${[...this.h.keys()]} `);return E}getIdByEditor(h){for(const[E,D]of this.h)if(D.apiEditor===h)return E}get notebookDocuments(){return[...this.g.values()]}getNotebookDocument(h,E){const D=this.g.get(h);if(!D&&!E)throw new Error(`NO notebook document for '${h}'`);return D}static u(h,E){if(!E)return;const D=E.filenamePattern.map(m=>k.NotebookExclusiveDocumentPattern.from(m)).filter(m=>m!==void 0);if(E.filenamePattern&&!D){console.warn(`Notebook content provider view options file name pattern is invalid ${E.filenamePattern}`);return}return{extension:h.identifier,providerDisplayName:h.displayName||h.name,displayName:E.displayName,filenamePattern:D,exclusive:E.exclusive||!1}}registerNotebookCellStatusBarItemProvider(h,E,D){const m=c.a++,p=typeof D.onDidChangeCellStatusBarItems=="function"?c.a++:void 0;this.f.set(m,D),this.b.$registerNotebookCellStatusBarItemProvider(m,p,E);let S;return p!==void 0&&(S=D.onDidChangeCellStatusBarItems(P=>this.b.$emitCellStatusBarEvent(p))),new w.$zK(()=>{this.f.delete(m),this.b.$unregisterNotebookCellStatusBarItemProvider(m,p),S?.dispose()})}async createNotebookDocument(h){const E=await this.c.$tryCreateNotebook({viewType:h.viewType,content:h.content&&k.NotebookData.from(h.content)});return g.URI.revive(E)}async openNotebookDocument(h){const E=this.g.get(h);if(E)return E.apiNotebook;const D=await this.c.$tryOpenNotebook(h),m=this.g.get(g.URI.revive(D));return(0,v.$Nf)(m?.apiNotebook)}async showNotebookDocument(h,E){g.URI.isUri(h)&&(h=await this.openNotebookDocument(h));let D;typeof E=="object"?D={position:k.ViewColumn.from(E.viewColumn),preserveFocus:E.preserveFocus,selections:E.selections&&E.selections.map(k.NotebookRange.from),pinned:typeof E.preview=="boolean"?!E.preview:void 0}:D={preserveFocus:!1};const m=await this.d.$tryShowNotebookDocument(h.uri,h.notebookType,D),p=m&&this.h.get(m)?.apiEditor;if(p)return p;throw m?new Error(`Could NOT open editor for "${h.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${h.uri.toString()}".`)}async $provideNotebookCellStatusBarItems(h,E,D,m){const p=this.f.get(h),S=g.URI.revive(E),P=this.g.get(S);if(!P||!p)return;const z=P.getCellFromIndex(D);if(!z)return;const j=await p.provideCellStatusBarItems(z.apiCell,m);if(!j)return;const R=new L.$Qc,T=this.p.add([R]),O=(Array.isArray(j)?j:[j]).map(W=>k.NotebookStatusBarItem.from(W,this.i,R));return{cacheId:T,items:O}}$releaseNotebookCellStatusBarItems(h){this.p.delete(h)}registerNotebookSerializer(h,E,D,m,p){if((0,b.$Fe)(E))throw new Error("viewType cannot be empty or just whitespace");const S=this.w++;return this.x.set(S,{viewType:E,serializer:D,options:m}),this.b.$registerNotebookSerializer(S,{id:h.identifier,location:h.extensionLocation},E,k.NotebookDocumentContentOptions.from(m),c.u(h,p)),(0,L.$Pc)(()=>{this.b.$unregisterNotebookSerializer(S)})}async $dataToNotebook(h,E,D){const m=this.x.get(h);if(!m)throw new Error("NO serializer found");const p=await m.serializer.deserializeNotebook(E.buffer,D);return new u.$wv(k.NotebookData.from(p))}async $notebookToData(h,E,D){const m=this.x.get(h);if(!m)throw new Error("NO serializer found");const p=await m.serializer.serializeNotebook(k.NotebookData.to(E.value),D);return F.$fe.wrap(p)}async $saveNotebook(h,E,D,m,p){const S=g.URI.revive(E),P=this.x.get(h);if(!P)throw new Error("NO serializer found");const z=this.g.get(S);if(!z)throw new Error("Document NOT found");if(z.versionId!==D)throw new Error("Document version mismatch");if(!this.s.value.isWritableFileSystem(S.scheme))throw new A.$zk((0,C.localize)(0,null,this.z(S)),6);await this.y(S,m);const j={metadata:(0,r.$in)(z.apiNotebook.metadata,W=>!(P.options?.transientDocumentMetadata??{})[W]),cells:[]};for(const W of z.apiNotebook.getCells()){const x=new w.$XL(W.kind,W.document.getText(),W.document.languageId,W.mime,P.options?.transientOutputs?[]:[...W.outputs],W.metadata,W.executionSummary);x.metadata=(0,r.$in)(W.metadata,le=>!(P.options?.transientCellMetadata??{})[le]),j.cells.push(x)}const R=await P.serializer.serializeNotebook(j,p);await this.s.value.writeFile(S,R);const T=this.s.getFileSystemProviderExtUri(S.scheme),N=await this.s.value.stat(S);return{name:T.basename(S),isFile:(N.type&A.FileType.File)!==0,isDirectory:(N.type&A.FileType.Directory)!==0,isSymbolicLink:(N.type&A.FileType.SymbolicLink)!==0,mtime:N.mtime,ctime:N.ctime,size:N.size,readonly:!!((N.permissions??0)&A.FilePermission.Readonly)||!this.s.value.isWritableFileSystem(S.scheme),locked:!!((N.permissions??0)&A.FilePermission.Locked),etag:A.$Kk({mtime:N.mtime,size:N.size}),children:void 0}}async $searchInNotebooks(h,E,D,m,p){const S=this.x.get(h)?.serializer;if(!S)return{limitHit:!1,results:[]};const P=new M.$Ac;await(async(N,O,W)=>{await Promise.all(N.map(async x=>await Promise.all(x.filenamePatterns.map(le=>{const G={...W,type:1,filePattern:le};return this.t.doInternalFileSearchWithCustomCallback(G,O,J=>{J.forEach(Q=>{P.has(Q)||m.some(_=>x.isFromSettings&&!_.isFromSettings?!1:_.filenamePatterns.some(Ee=>(0,d.$ucb)(Ee,Q)))||P.add(Q)})})}))))})(D,p,E);const j=new M.$zc;let R=!1;const T=Array.from(P).map(async N=>{const O=[];try{if(p.isCancellationRequested)return;if(E.maxResults&&[...j.values()].reduce((G,J)=>G+J.cellResults.length,0)>E.maxResults){R=!0;return}const W=[],x=this.g.get(N);if(x)x.apiNotebook.getCells().forEach(J=>W.push({input:J.document.getText(),outputs:J.outputs.flatMap(Q=>Q.items.map(oe=>oe.data.toString()))}));else{const G=await this.s.value.readFile(N),J=F.$fe.fromString(G.toString()),Q=await S.deserializeNotebook(J.buffer,p);if(p.isCancellationRequested)return;k.NotebookData.from(Q).cells.forEach(_=>W.push({input:_.source,outputs:_.outputs.flatMap(Ee=>Ee.items.map(he=>he.valueBytes.toString()))}))}if(p.isCancellationRequested)return;W.forEach((G,J)=>{const Q=E.contentPattern.pattern,oe=new t.$UOb(G.input,void 0,G.outputs),_=oe.findInInputs(Q),Ee=oe.findInOutputs(Q),he=Ee.flatMap(q=>(0,s.$mJ)(q.matches,q.textBuffer)).map((q,U)=>(q.webviewIndex=U,q));if(_.length>0||Ee.length>0){const q={index:J,contentResults:(0,s.$mJ)(_,oe.inputTextBuffer),webviewResults:he};O.push(q)}});const le={resource:N,cellResults:O};j.set(N,le);return}catch{return}});return await Promise.all(T),{limitHit:R,results:[...j.values()]}}async y(h,E){const D=await this.s.value.stat(h);if(typeof E?.mtime=="number"&&typeof E.etag=="string"&&E.etag!==A.$Jk&&typeof D.mtime=="number"&&typeof D.size=="number"&&E.mtime<D.mtime&&E.etag!==A.$Kk({mtime:E.mtime,size:D.size}))throw new A.$zk((0,C.localize)(1,null),3,E)}z(h){return h.scheme===a.Schemas.file?h.fsPath:h.toString()}A(h,E,D){if(this.h.has(E))throw new Error(`editor with id ALREADY EXSIST: ${E}`);const m=new i.$Zec(E,this.d,h,D.visibleRanges.map(k.NotebookRange.to),D.selections.map(k.NotebookRange.to),typeof D.viewColumn=="number"?k.ViewColumn.to(D.viewColumn):void 0);this.h.set(E,m)}$acceptDocumentAndEditorsDelta(h){if(h.value.removedDocuments)for(const D of h.value.removedDocuments){const m=g.URI.revive(D),p=this.g.get(m);p&&(p.dispose(),this.g.delete(m),this.q.$acceptDocumentsAndEditorsDelta({removedDocuments:p.apiNotebook.getCells().map(S=>S.document.uri)}),this.n.fire(p.apiNotebook));for(const S of this.h.values())S.notebookData.uri.toString()===m.toString()&&this.h.delete(S.id)}if(h.value.addedDocuments){const D=[];for(const m of h.value.addedDocuments){const p=g.URI.revive(m.uri);if(this.g.has(p))throw new Error(`adding EXISTING notebook ${p} `);const S=new o.$Yec(this.c,this.q,this.r,p,m);D.push(...m.cells.map(P=>o.$Xec.asModelAddData(S.apiNotebook,P))),this.g.get(p)?.dispose(),this.g.set(p,S),this.q.$acceptDocumentsAndEditorsDelta({addedDocuments:D}),this.m.fire(S.apiNotebook)}}if(h.value.addedEditors)for(const D of h.value.addedEditors){if(this.h.has(D.id))return;const m=g.URI.revive(D.documentUri),p=this.g.get(m);p&&this.A(p,D.id,D)}const E=[];if(h.value.removedEditors)for(const D of h.value.removedEditors){const m=this.h.get(D);m&&(this.h.delete(D),this.k?.id===m.id&&(this.k=void 0),E.push(m))}if(h.value.visibleEditors){this.l=h.value.visibleEditors.map(m=>this.h.get(m)).filter(m=>!!m);const D=new Set;this.l.forEach(m=>D.add(m.id));for(const m of this.h.values()){const p=D.has(m.id);m._acceptVisibility(p)}this.l=[...this.h.values()].map(m=>m).filter(m=>m.visible),this.o.fire(this.visibleNotebookEditors)}h.value.newActiveEditor===null?this.k=void 0:h.value.newActiveEditor&&(this.h.get(h.value.newActiveEditor)||console.error(`FAILED to find active notebook editor ${h.value.newActiveEditor}`),this.k=this.h.get(h.value.newActiveEditor)),h.value.newActiveEditor!==void 0&&this.j.fire(this.k?.apiEditor)}static B(h){const E=y.$XM.String.with("notebookType","A notebook type"),D=new y.$ZM("vscode.executeDataToNotebook","_executeDataToNotebook","Invoke notebook serializer",[E,new y.$XM("data","Bytes to convert to data",p=>p instanceof Uint8Array,p=>F.$fe.wrap(p))],new y.$YM("Notebook Data",p=>k.NotebookData.to(p.value))),m=new y.$ZM("vscode.executeNotebookToData","_executeNotebookToData","Invoke notebook serializer",[E,new y.$XM("NotebookData","Notebook data to convert to bytes",p=>!0,p=>new u.$wv(k.NotebookData.from(p)))],new y.$YM("Bytes",p=>p.buffer));h.registerApiCommand(D),h.registerApiCommand(m)}}e.$9ec=c}),define(ke[361],Se([1,0,16,21,43,34,23,38,36]),function(me,e,C,F,f,L,M,b,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1ec=void 0;class g{constructor($,y,k){this.k=$,this.l=y,this.o=k,this.e=!1,this.f=0,this.g=!1,this.a=$.filePattern,this.b=$.includePattern&&L.$Cj($.includePattern),this.c=$.maxResults||void 0,this.d=$.exists,this.h=new Set,this.j=$.excludePattern&&L.$Cj($.excludePattern)}cancel(){this.g=!0,this.h.forEach($=>$.cancel()),this.h=new Set}search($){const y=this.k.folderQueries||[];return new Promise((k,w)=>{const u=o=>{this.f++,$(o)};if(this.g)return k({limitHit:this.e});this.k.extraFileResources&&this.k.extraFileResources.forEach(o=>{const i=o.toString(),n=C.$mc(i);this.j&&this.j(i,n)||this.v(u,{base:o,basename:n})}),Promise.all(y.map(o=>this.p(o,u))).then(o=>{k({limitHit:this.e,stats:o[0]||void 0})},o=>{w(new Error((0,f.$Gi)(o)))})})}async p($,y){const k=new F.$2d,w=this.q($),u=this.r(),o=new v.$cJ(this.k,$),i=!o.hasSiblingExcludeClauses();let n;try{this.h.add(k),n=b.$Nd.create();const r=await this.l.provideFileSearchResults({pattern:this.k.filePattern||""},w,k.token),a=n.elapsed(),t=b.$Nd.create();return this.g&&!this.e||(r&&r.forEach(s=>{const d=C.$fc.relative($.folder.path,s.path);if(i){const c=C.$mc(s.path);this.v(y,{base:$.folder,relativePath:d,basename:c});return}this.s(u,$.folder,d,y)}),this.g&&!this.e)?null:(this.u(u,o,y),{providerTime:a,postProcessTime:t.elapsed()})}finally{k.dispose(),this.h.delete(k)}}q($){const y=(0,v.$bJ)(this.k.includePattern,$.includePattern),k=(0,v.$bJ)(this.k.excludePattern,$.excludePattern);return{folder:$.folder,excludes:k,includes:y,useIgnoreFiles:!$.disregardIgnoreFiles,useGlobalIgnoreFiles:!$.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!$.disregardParentIgnoreFiles,followSymlinks:!$.ignoreSymlinks,maxResults:this.k.maxResults,session:this.o}}r(){const $={rootEntries:[],pathToEntries:Object.create(null)};return $.pathToEntries["."]=$.rootEntries,$}s({pathToEntries:$},y,k,w){if(k===this.a){const o=C.$mc(this.a);this.v(w,{base:y,relativePath:this.a,basename:o})}function u(o){const i=C.$mc(o),n=C.$lc(o);let r=$[n];r||(r=$[n]=[],u(n)),r.push({base:y,relativePath:o,basename:i})}u(k)}u({rootEntries:$,pathToEntries:y},k,w){const u=this,o=this.a;function i(n){const r=(0,v.$eJ)(()=>n.map(a=>a.basename));for(let a=0,t=n.length;a<t;a++){const s=n[a],{relativePath:d,basename:c}=s;if(k.matchesExcludesSync(d,c,o!==c?r:void 0))continue;const l=y[d];if(l)i(l);else{if(d===o)continue;u.v(w,s)}if(u.e)break}}i($)}v($,y){(!this.b||y.relativePath&&this.b(y.relativePath,y.basename))&&((this.d||this.c&&this.f>=this.c)&&(this.e=!0,this.cancel()),this.e||$(y))}}class A{constructor(){this.b=new Map}static{this.a=512}fileSearch($,y,k,w){const u=this.c($.cacheKey),o=new g($,y,u&&u.token);let i=0;const n=r=>{i+=r.length,k(r.map(a=>this.d(a)))};return this.e(o,A.a,n,w).then(r=>({limitHit:r.limitHit,stats:{fromCache:!1,type:"fileSearchProvider",resultCount:i,detailStats:r.stats}}))}clearCache($){this.c($)?.cancel()}c($){if($)return this.b.has($)||this.b.set($,new F.$2d),this.b.get($)}d($){return $.relativePath?{resource:M.$zg($.base,$.relativePath)}:{resource:$.base}}e($,y,k,w){const u=w.onCancellationRequested(()=>{$.cancel()}),o=n=>{n&&(i.push(n),y>0&&i.length>=y&&(k(i),i=[]))};let i=[];return $.search(o).then(n=>(i.length&&k(i),u.dispose(),n),n=>(i.length&&k(i),u.dispose(),Promise.reject(n)))}}e.$1ec=A}),define(ke[362],Se([1,0,19,73,34,102,28,17,16,23,13,18,2,99,236,44,14,40,145,357,36]),function(me,e,C,F,f,L,M,b,v,g,A,I,$,y,k,w,u,o,i,n,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cK=e.$bK=void 0;let a=class{constructor(p,S,P,z,j){this.a=p,this.b=S,this.c=P,this.d=z,this.e=j}text(p,S,P={}){p=this.f(p,P);const z=this.a.getValue(),j=S&&S.some(T=>!this.a.getValue({resource:T}).search.useRipgrep);return{...this.h(S?.map(o.$ei),P),type:2,contentPattern:p,previewOptions:P.previewOptions,maxFileSize:P.maxFileSize,usePCRE2:z.search.usePCRE2||j||!1,beforeContext:P.beforeContext,afterContext:P.afterContext,userDisabledExcludesAndIgnoreFiles:P.disregardExcludeSettings&&P.disregardIgnoreFiles}}f(p,S){const P=this.a.getValue();p.isRegExp&&(p.pattern=p.pattern.replace(/\r?\n/g,"\\n"));const z={...p,wordSeparators:P.editor.wordSeparators};return this.j(p,S)&&(z.isCaseSensitive=!0),this.k(p)&&(z.isMultiline=!0),S.notebookSearchConfig?.includeMarkupInput&&(z.notebookInfo||(z.notebookInfo={}),z.notebookInfo.isInNotebookMarkdownInput=S.notebookSearchConfig.includeMarkupInput),S.notebookSearchConfig?.includeMarkupPreview&&(z.notebookInfo||(z.notebookInfo={}),z.notebookInfo.isInNotebookMarkdownPreview=S.notebookSearchConfig.includeMarkupPreview),S.notebookSearchConfig?.includeCodeInput&&(z.notebookInfo||(z.notebookInfo={}),z.notebookInfo.isInNotebookCellInput=S.notebookSearchConfig.includeCodeInput),S.notebookSearchConfig?.includeOutput&&(z.notebookInfo||(z.notebookInfo={}),z.notebookInfo.isInNotebookCellOutput=S.notebookSearchConfig.includeOutput),z}file(p,S={}){return{...this.h(p,S),type:1,filePattern:S.filePattern?S.filePattern.trim():S.filePattern,exists:S.exists,sortByScore:S.sortByScore,cacheKey:S.cacheKey}}g(p,S){return p?(p=Array.isArray(p)?p.map(l):l(p),S?this.parseSearchPaths(p):{pattern:s(...Array.isArray(p)?p:[p])}):{}}h(p=[],S={}){const P=this.g(S.includePattern,S.expandPatterns),z=this.g(S.excludePattern,S.expandPatterns),j=p.length>1,R=(P.searchPaths&&P.searchPaths.length?P.searchPaths.map(O=>this.q(O,S,z)):p.map(O=>this.r(O,S,z,j))).filter(O=>!!O),T={_reason:S._reason,folderQueries:R,usingSearchPaths:!!(P.searchPaths&&P.searchPaths.length),extraFileResources:S.extraFileResources,excludePattern:z.pattern,includePattern:P.pattern,onlyOpenEditors:S.onlyOpenEditors,maxResults:S.maxResults};if(S.onlyOpenEditors){const O=C.$Gb(C.$Qb(this.c.groups.map(le=>le.editors.map(G=>G.resource))));this.d.trace("QueryBuilder#commonQuery - openEditor URIs",JSON.stringify(O));const W=O.filter(le=>(0,r.$5I)(T,le.fsPath)),x=this.i(W);return this.d.trace("QueryBuilder#commonQuery - openEditor Query",JSON.stringify(x)),{...T,...x}}const N=S.extraFileResources&&S.extraFileResources.filter(O=>(0,r.$5I)(T,O.fsPath));return T.extraFileResources=N&&N.length?N:void 0,T}i(p){const S=[],P=new M.$zc,z={};let j=!1;return p.forEach(R=>{if(R.scheme===b.Schemas.walkThrough)return;if((0,g.$Dg)(R)){const N=this.b.getWorkspaceFolder(R)?.uri??R.with({path:v.$lc(R.fsPath)});let O=P.get(N);O||(j=!0,O={folder:N,includePattern:{}},S.push(O),P.set(N,O));const W=v.$kc(N.fsPath,R.fsPath);(0,I.$Nf)(O.includePattern)[W.replace(/\\/g,"/")]=!0}else R.fsPath&&(j=!0,z[R.fsPath]=!0)}),{folderQueries:S,includePattern:z,usingSearchPaths:!0,excludePattern:j?void 0:{"**/*":!0}}}j(p,S){if(S.isSmartCase){if(p.isRegExp){if(A.$tf(p.pattern,!0))return!0}else if(A.$tf(p.pattern))return!0}return!!p.isCaseSensitive}k(p){return p.isMultiline||p.isRegExp&&(0,y.$BB)(p.pattern)||p.pattern.indexOf(`
`)>=0?!0:!!p.isMultiline}parseSearchPaths(p){const S=x=>v.$hc(x)||/^\.\.?([\/\\]|$)/.test(x),z=(Array.isArray(p)?p:d(p)).map(x=>{const le=this.e.resolvedUserHome;return le?(0,L.$Av)(x,le.scheme===b.Schemas.file?le.fsPath:le.path):x}),j=F.$J(z,x=>S(x)?"searchPaths":"exprSegments"),R=(j.exprSegments||[]).map(x=>A.$Oe(x,"/")).map(x=>A.$Oe(x,"\\")).map(x=>(x[0]==="."&&(x="*"+x),c(x))),T={},N=this.m(j.searchPaths||[]);N&&N.length&&(T.searchPaths=N);const O=C.$Qb(R),W=s(...O);return W&&(T.pattern=W),T}l(p,S){return S.disregardExcludeSettings?void 0:(0,r.$4I)(p,!S.disregardSearchExcludeSettings)}m(p){if(!p||!p.length)return[];const S=p.flatMap(z=>{let{pathPortion:j,globPortion:R}=t(z);return R&&(R=h(R)),this.n(j).flatMap(N=>this.o(N,R))}),P=new Map;return S.forEach(z=>{const j=z.searchPath.toString(),R=P.get(j);R?z.pattern&&(R.pattern=R.pattern||{},R.pattern[z.pattern]=!0):P.set(j,{searchPath:z.searchPath,pattern:z.pattern?s(z.pattern):void 0})}),Array.from(P.values())}n(p){if(v.$hc(p)){const S=this.b.getWorkspace().folders;return S[0]&&S[0].uri.scheme!==b.Schemas.file?[{searchPath:S[0].uri.with({path:p})}]:[{searchPath:$.URI.file(v.$gc(p))}]}if(this.b.getWorkbenchState()===2){const S=this.b.getWorkspace().folders[0].uri;if(p=l(p),p.startsWith("../")||p===".."){const z=v.$fc.resolve(S.path,p);return[{searchPath:S.with({path:z})}]}const P=h(p);return[{searchPath:S,pattern:P}]}else{if(p==="./"||p===".\\")return[];{const S=p.replace(/^\.[\/\\]/,""),z=this.b.getWorkspace().folders.map(j=>{const R=S.match(new RegExp(`^${A.$Je(j.name)}(?:/(.*)|$)`));return R?{match:R,folder:j}:null}).filter(I.$Kf);if(z.length)return z.map(j=>{const R=j.match[1];return{searchPath:j.folder.uri,pattern:R&&h(R)}});{const j=p.match(/\.[\/\\](.+)[\/\\]?/),R=j?j[1]:p,T=k.localize(0,null,R);throw new Error(T)}}}}o(p,S){const P=p.pattern&&S?`${p.pattern}/${S}`:p.pattern||S,z=[{searchPath:p.searchPath,pattern:P}];return P&&!P.endsWith("**")&&z.push({searchPath:p.searchPath,pattern:P+"/**"}),z}q(p,S,P){const z=this.r((0,o.$ei)(p.searchPath),S,P,!1);return z?{...z,includePattern:p.pattern}:null}r(p,S,P,z){let j;const R=$.URI.isUri(p)?p:p.uri;if(P.searchPaths){const x=P.searchPaths.filter(le=>(0,g.$sg)(le.searchPath,R))[0];if(x&&!x.pattern)return null;x&&(j=x.pattern)}const T=this.a.getValue({resource:R}),O={...this.l(T,S)||{},...j||{}},W=$.URI.isUri(p)?(0,g.$wg)(p):p.name;return{folder:R,folderName:z?W:void 0,excludePattern:Object.keys(O).length>0?O:void 0,fileEncoding:T.files&&T.files.encoding,disregardIgnoreFiles:typeof S.disregardIgnoreFiles=="boolean"?S.disregardIgnoreFiles:!T.search.useIgnoreFiles,disregardGlobalIgnoreFiles:typeof S.disregardGlobalIgnoreFiles=="boolean"?S.disregardGlobalIgnoreFiles:!T.search.useGlobalIgnoreFiles,disregardParentIgnoreFiles:typeof S.disregardParentIgnoreFiles=="boolean"?S.disregardParentIgnoreFiles:!T.search.useParentIgnoreFiles,ignoreSymlinks:typeof S.ignoreSymlinks=="boolean"?S.ignoreSymlinks:!T.search.followSymlinks}}};e.$bK=a,e.$bK=a=He([Be(0,w.$pi),Be(1,o.$5h),Be(2,i.$FC),Be(3,u.$dj),Be(4,n.$_J)],a);function t(m){const p=m.match(/[\*\{\}\(\)\[\]\?]/);if(p){const S=p.index,P=m.substr(0,S).match(/[/|\\][^/\\]*$/);if(P){let z=m.substr(0,P.index);return z.match(/[/\\]/)||(z+="/"),{pathPortion:z,globPortion:m.substr((P.index||0)+1)}}}return{pathPortion:m}}function s(...m){return m.length?m.reduce((p,S)=>(p[S]=!0,p),Object.create(null)):void 0}function d(m){return f.$Aj(m,",").map(p=>p.trim()).filter(p=>!!p.length)}function c(m){return[`**/${m}/**`,`**/${m}`].map(S=>S.replace(/\*\*\/\*\*/g,"**"))}function l(m){return m.replace(/\\/g,"/")}function h(m){return l(m).replace(/^\.\//,"").replace(/\/+$/g,"")}function E(m){return m.replace(/([?*[\]])/g,"[$1]")}function D(m,p){m=C.$Lb(m,z=>z.toString());const S=[],P=p.getWorkspace();return m&&m.forEach(z=>{let j;if(p.getWorkbenchState()===2)j=(0,g.$Bg)(P.folders[0].uri,z),j&&j!=="."&&(j="./"+j);else{const R=p.getWorkspaceFolder(z);if(R){const T=R.name;if(P.folders.filter(O=>O.name===T).length===1){const O=(0,g.$Bg)(R.uri,z);O===""?j=`./${R.name}`:j=`./${R.name}/${O}`}else j=z.fsPath}}j&&S.push(E(j))}),S}e.$cK=D}),define(ke[363],Se([1,0,23,2,21,8,5,362,36,40]),function(me,e,C,F,f,L,M,b,v,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7qb=e.$6qb=void 0;const A=7e3;function I(w,u){const o=u.activationEvents;if(!o)return Promise.resolve(void 0);const i=[],n=[];for(const c of o)if(/^workspaceContains:/.test(c)){const l=c.substr(18);l.indexOf("*")>=0||l.indexOf("?")>=0||w.forceUsingSearch?n.push(l):i.push(l)}if(i.length===0&&n.length===0)return Promise.resolve(void 0);let r;const a=new Promise((c,l)=>{r=c}),t=c=>r({activationEvent:c}),s=Promise.all(i.map(c=>$(w,c,t))).then(()=>{}),d=y(w,u.identifier,n,t);return Promise.all([s,d]).then(()=>{r(void 0)}),a}e.$6qb=I;async function $(w,u,o){for(const i of w.folders)if(await w.exists(C.$zg(F.URI.revive(i),u))){o(`workspaceContains:${u}`);return}}async function y(w,u,o,i){if(o.length===0)return Promise.resolve(void 0);const n=new f.$2d,r=w.checkExists(w.folders,o,n.token),a=setTimeout(async()=>{n.cancel(),w.logService.info(`Not activating extension '${u.value}': Timed out while searching for 'workspaceContains' pattern ${o.join(",")}`)},A);let t=!1;try{t=await r}catch(s){L.$3(s)||L.$Z(s)}n.dispose(),clearTimeout(a),t&&i(`workspaceContains:${o.join(",")}`)}function k(w,u,o,i){const n=w.get(M.$Uh),r=w.get(v.$VI),t=n.createInstance(b.$bK).file(u.map(s=>(0,g.$ei)(F.URI.revive(s))),{_reason:"checkExists",includePattern:o,exists:!0});return r.fileSearch(t,i).then(s=>!!s.limitHit,s=>L.$3(s)?!1:Promise.reject(s))}e.$7qb=k}),define(ke[47],Se([1,0,212,16,56,23,12,3,77,2,14,6,42,293,118,41,25,147,8,26,22,272,7,64,5,27,92,20,107,72,46,4,363,117,274,17,115,38,11,116]),function(me,e,C,F,f,L,M,b,v,g,A,I,$,y,k,w,u,o,i,n,r,a,t,s,d,c,l,h,E,D,m,p,S,P,z,j,R,T,N,O){"use strict";var W;Object.defineProperty(e,"__esModule",{value:!0}),e.$Gec=e.$Fec=e.$Eec=e.$Dec=e.$Cec=void 0,e.$Cec=(0,d.$Vh)("IHostUtils");let x=W=class extends b.$Rc{constructor(q,U,ie,be,H,Y,Z,$e,ne,fe,te,de){super(),this.X=de,this.a=this.B(new p.$Rd),this.onDidChangeRemoteConnectionData=this.a.event,this.U=!1,this.c=U,this.g=ie,this.f=Z,this.j=be,this.m=H,this.s=Y,this.t=ne,this.u=fe,this.w=te,this.y=this.g.getProxy(I.$xK.MainThreadWorkspace),this.z=this.g.getProxy(I.$xK.MainThreadTelemetry),this.C=this.g.getProxy(I.$xK.MainThreadExtensionService),this.D=new M.$Wg,this.F=new M.$Wg,this.G=new M.$Wg,this.H=new M.$Wg,this.I=new Ee(this.f.extensions.activationEvents),this.L=new o.$T5b(this.I,this.f.extensions.allExtensions);const pe=new n.$am(this.f.extensions.myExtensions);this.J=new o.$T5b(this.I,oe(this.L,pe)),N.$t&&(this.s.info(`Creating extension host with the following global extensions: ${J(this.L)}`),this.s.info(`Creating extension host with the following local extensions: ${J(this.J)}`)),this.M=new k.$nec(this.g,this.s),this.N=new P.$vec(this.g),this.O=$e,this.h=q.createChild(new E.$Th([k.$oec,this.M],[P.$wec,this.N])),this.P=this.B(new y.$mec(this.J,this.L,{onExtensionActivationError:(Pe,B,X)=>{this.C.$onExtensionActivationError(Pe,i.$2(B),X)},actualActivateExtension:async(Pe,B)=>{if(o.$T5b.isHostExtension(Pe,this.J,this.L))return await this.C.$activateExtension(Pe,B),new y.$lec;const X=this.J.getExtensionDescription(Pe);return this.db(X,B)}},this.s)),this.Q=null,this.R=Object.create(null),this.S=!1,this.W=this.f.remote.connectionData}getRemoteConnectionData(){return this.W}async initialize(){try{await this.tb(),this.D.open(),await this.j.waitForInitializeCall(),f.mark("code/extHost/ready"),this.F.open(),this.f.autoStart&&this.rb()}catch(q){i.$Z(q)}}async Y(){this.O.onWillDeactivateAll();let q=[];try{q=this.J.getAllExtensionDescriptions().map(H=>H.identifier).filter(H=>this.isActivated(H)).map(H=>this.cb(H))}catch{}await Promise.all(q)}terminate(q,U=0){if(this.U)return;this.U=!0,this.s.info(`Extension host terminating: ${q}`),this.s.flush(),this.u.dispose(),this.P.dispose(),i.setUnexpectedErrorHandler(be=>{this.s.error(be)}),this.g.dispose();const ie=this.Y();Promise.race([(0,M.$Yg)(5e3),ie]).finally(()=>{this.c.pid?this.s.info(`Extension host with pid ${this.c.pid} exiting with code ${U}`):this.s.info(`Extension host exiting with code ${U}`),this.s.flush(),this.s.dispose(),this.c.exit(U)})}isActivated(q){return this.G.isOpen()?this.P.isActivated(q):!1}async getExtension(q){const U=await this.C.$getExtension(q);return U&&{...U,identifier:new n.$_l(U.identifier.value),extensionLocation:g.URI.revive(U.extensionLocation)}}Z(q,U){return this.P.activateByEvent(q,U)}$(q,U){return this.P.activateById(q,U)}activateByIdWithErrors(q,U){return this.$(q,U).then(()=>{const ie=this.P.getActivatedExtension(q);if(ie.activationFailed)return Promise.reject(ie.activationFailedError)})}getExtensionRegistry(){return this.G.wait().then(q=>this.J)}getExtensionExports(q){if(this.G.isOpen())return this.P.getActivatedExtension(q).exports;try{return this.P.getActivatedExtension(q).exports}catch{return null}}async ab(q){if(q.scheme===j.Schemas.file&&this.c.fsRealpath){const U=await this.c.fsRealpath(q.fsPath);return g.URI.file(U)}return q}async getExtensionPathIndex(){return this.Q||(this.Q=this.bb(this.J.getAllExtensionDescriptions()).then(q=>new _(q))),this.Q}async bb(q){const U=v.$2h.forUris(ie=>L.$qg.ignorePathCasing(ie));return await Promise.all(q.map(async ie=>{if(this.ub(ie)){const be=await this.ab(ie.extensionLocation);U.set(be,ie)}})),U}cb(q){let U=Promise.resolve(void 0);if(!this.G.isOpen()||!this.P.isActivated(q))return U;const ie=this.P.getActivatedExtension(q);if(!ie)return U;try{typeof ie.module.deactivate=="function"&&(U=Promise.resolve(ie.module.deactivate()).then(void 0,be=>(this.s.error(be),Promise.resolve(void 0))))}catch(be){this.s.error(`An error occurred when deactivating the extension '${q.value}':`),this.s.error(be)}try{(0,b.$Mc)(ie.subscriptions)}catch(be){this.s.error(`An error occurred when deactivating the subscriptions for extension '${q.value}':`),this.s.error(be)}return U}async db(q,U){return this.f.remote.isRemote?this.C.$onWillActivateExtension(q.identifier):await this.C.$onWillActivateExtension(q.identifier),this.fb(q,U).then(ie=>{const be=ie.activationTimes;return this.C.$onDidActivateExtension(q.identifier,be.codeLoadingTime,be.activateCallTime,be.activateResolvedTime,U),this.eb(q,U,"success",be),ie},ie=>{throw this.eb(q,U,"failure"),ie})}eb(q,U,ie,be){const H=G(q,U);this.z.$publicLog2("extensionActivationTimes",{...H,...be||{},outcome:ie})}fb(q,U){const ie=G(q,U);this.z.$publicLog2("activatePlugin",ie);const be=this.ub(q);if(!be)return Promise.resolve(new y.$kec(y.$hec.NONE));this.s.info(`ExtensionService#_doActivateExtension ${q.identifier.value}, startup: ${U.startup}, activationEvent: '${U.activationEvent}'${q.identifier.value!==U.extensionId.value?`, root cause: ${U.extensionId.value}`:""}`),this.s.flush();const H=new y.$iec(U.startup);return Promise.all([this.vb(q,(0,L.$zg)(q.extensionLocation,be),H),this.gb(q)]).then(Y=>(f.mark(`code/extHost/willActivateExtension/${q.identifier.value}`),W.hb(this.s,q.identifier,Y[0],Y[1],H))).then(Y=>(f.mark(`code/extHost/didActivateExtension/${q.identifier.value}`),Y))}gb(q){const U=new a.$qec(q,this.M),ie=new a.$pec(q.identifier.value,!1,this.M),be=new z.$xec(q,this.N),H=q.isUnderDevelopment?this.f.environment.extensionTestsLocationURI?t.ExtensionMode.Test:t.ExtensionMode.Development:t.ExtensionMode.Production,Y=this.f.remote.isRemote?t.ExtensionKind.Workspace:t.ExtensionKind.UI;return this.s.trace(`ExtensionService#loadExtensionContext ${q.identifier.value}`),Promise.all([U.whenReady,ie.whenReady,this.O.whenReady]).then(()=>{const Z=this;let $e,ne;const fe=(0,u.$LF)(q,"ipc")?this.f.messagePorts?.get(n.$_l.toKey(q.identifier)):void 0;return Object.freeze({globalState:U,workspaceState:ie,secrets:be,subscriptions:[],get extensionUri(){return q.extensionLocation},get extensionPath(){return q.extensionLocation.fsPath},asAbsolutePath(te){return F.$ic(q.extensionLocation.fsPath,te)},get storagePath(){return Z.O.workspaceValue(q)?.fsPath},get globalStoragePath(){return Z.O.globalValue(q).fsPath},get logPath(){return F.$ic(Z.f.logsLocation.fsPath,q.identifier.value)},get logUri(){return g.URI.joinPath(Z.f.logsLocation,q.identifier.value)},get storageUri(){return Z.O.workspaceValue(q)},get globalStorageUri(){return Z.O.globalValue(q)},get extensionMode(){return H},get extension(){return $e===void 0&&($e=new Q(Z,q.identifier,q,Y,!1)),$e},get extensionRuntime(){return(0,u.$MF)(q,"extensionRuntime"),Z.extensionRuntime},get environmentVariableCollection(){return Z.u.getEnvironmentVariableCollection(q)},get messagePassingProtocol(){if(!ne){if(!fe)return;const te=p.Event.buffer(p.Event.fromDOMEventEmitter(fe,"message",de=>de.data));fe.start(),ne={onDidReceiveMessage:te,postMessage:fe.postMessage.bind(fe)}}return ne}})})}static hb(q,U,ie,be,H){return ie=ie||{activate:void 0,deactivate:void 0},this.ib(q,U,ie,be,H).then(Y=>new y.$jec(!1,null,H.build(),ie,Y,be.subscriptions))}static ib(q,U,ie,be,H){if(typeof ie.activate=="function")try{H.activateCallStart(),q.trace(`ExtensionService#_callActivateOptional ${U.value}`);const Y=typeof global=="object"?global:self,Z=ie.activate.apply(Y,[be]);return H.activateCallStop(),H.activateResolveStart(),Promise.resolve(Z).then($e=>(H.activateResolveStop(),$e))}catch(Y){return Promise.reject(Y)}else return Promise.resolve(ie)}jb(q,U){this.$(q.identifier,{startup:!1,extensionId:q.identifier,activationEvent:U}).then(void 0,ie=>{this.s.error(ie)})}kb(q,U=0){const be=Date.now();(0,N.$B)(()=>{for(let H=U;H<q.length;H+=1){const Y=q[H];for(const Z of Y.activationEvents??[])if(Z==="onStartupFinished")if(Date.now()-be>50){this.kb(q,H);break}else this.jb(Y,Z)}})}lb(){this.C.$setPerformanceMarks(f.getMarks()),this.m.getConfigProvider().then(q=>{const U=q.getConfiguration("extensions.experimental").get("deferredStartupFinishedActivation"),ie=this.J.getAllExtensionDescriptions();if(U)this.kb(ie);else for(const be of ie)if(be.activationEvents)for(const H of be.activationEvents)H==="onStartupFinished"&&this.jb(be,H)})}mb(){const q=this.Z("*",!0).then(void 0,Y=>{this.s.error(Y)});this.B(this.j.onDidChangeWorkspace(Y=>this.nb(Y.added)));const U=this.j.workspace?this.j.workspace.folders:[],ie=this.nb(U),be=this.pb(),H=Promise.all([be,q,ie]).then(()=>{});return Promise.race([H,(0,M.$Yg)(1e4)]).then(()=>{this.lb()}),H}nb(q){return q.length===0?Promise.resolve(void 0):Promise.all(this.J.getAllExtensionDescriptions().map(U=>this.ob(q,U))).then(()=>{})}async ob(q,U){if(this.isActivated(U.identifier))return;const ie=!this.f.remote.isRemote&&!!this.f.remote.authority,be={logService:this.s,folders:q.map(Y=>Y.uri),forceUsingSearch:ie||!this.c.fsExists,exists:Y=>this.c.fsExists(Y.fsPath),checkExists:(Y,Z,$e)=>this.y.$checkExists(Y,Z,$e)},H=await(0,S.$6qb)(be,U);if(H)return this.$(U.identifier,{startup:!0,extensionId:U.identifier,activationEvent:H.activationEvent}).then(void 0,Y=>this.s.error(Y))}async pb(){if(this.f.remote.authority)return this.Z(`onResolveRemoteAuthority:${this.f.remote.authority}`,!1)}async $extensionTestsExecute(){await this.H.wait();try{return await this.qb()}catch(q){throw console.error(q),q}}async qb(){const{extensionDevelopmentLocationURI:q,extensionTestsLocationURI:U}=this.f.environment;if(!q||!U)throw new Error(C.localize(0,null));const ie=await this.vb(null,U,new y.$iec(!1));if(!ie||typeof ie.run!="function")throw new Error(C.localize(1,null,U.toString()));return new Promise((be,H)=>{const Y=(ne,fe)=>{ne?(N.$t&&this.s.error("Test runner called back with error",ne),H(ne)):(N.$t&&(fe?this.s.info(`Test runner called back with ${fe} failures.`):this.s.info("Test runner called back with successful outcome.")),be(typeof fe=="number"&&fe>0?1:0))},Z=(0,L.$ng)(U),$e=ie.run(Z,Y);$e&&$e.then&&$e.then(()=>{N.$t&&this.s.info("Test runner finished successfully."),be(0)}).catch(ne=>{N.$t&&this.s.error("Test runner finished with error",ne),H(ne instanceof Error&&ne.stack?ne.stack:String(ne))})})}rb(){if(this.S)throw new Error("Extension host is already started!");return this.S=!0,this.F.wait().then(()=>this.G.open()).then(()=>Promise.race([this.P.waitForActivatingExtensions(),(0,M.$Yg)(1e3)])).then(()=>this.mb()).then(()=>{this.H.open(),this.s.info("Eager extensions activated")})}registerRemoteAuthorityResolver(q,U){return this.R[q]=U,(0,b.$Pc)(()=>{delete this.R[q]})}async getRemoteExecServer(q){const{resolver:U}=await this.sb(q);return U?.resolveExecServer?.(q,{resolveAttempt:0})}async sb(q){const U=q.indexOf("+");if(U===-1)throw new t.$FK("Not an authority that can be resolved!",s.RemoteAuthorityResolverErrorCode.InvalidAuthority);const ie=q.substr(0,U);return await this.D.wait(),await this.Z(`onResolveRemoteAuthority:${ie}`,!1),{authorityPrefix:ie,resolver:this.R[ie]}}async $resolveAuthority(q,U){const ie=T.$Nd.create(!1),be=()=>`[resolveAuthority(${(0,s.$Zk)(q)},${U})][${ie.elapsed()}ms] `,H=ae=>this.s.info(`${be()}${ae}`),Y=ae=>this.s.warn(`${be()}${ae}`),Z=(ae,ee=void 0)=>this.s.error(`${be()}${ae}`,ee),$e=ae=>{if(ae instanceof t.$FK)return{type:"error",error:{code:ae._code,message:ae._message,detail:ae._detail}};throw ae},ne=async ae=>{H(`activating resolver for ${ae}...`);const{resolver:ee,authorityPrefix:ge}=await this.sb(ae);if(!ee)throw Z(`no resolver for ${ge}`),new t.$FK(`No remote extension installed to resolve ${ge}.`,s.RemoteAuthorityResolverErrorCode.NoResolverFound);return{resolver:ee,authorityPrefix:ge,remoteAuthority:ae}},fe=q.split(/@|%40/g).reverse();H(`activating remote resolvers ${fe.join(" -> ")}`);let te;try{te=await Promise.all(fe.map(ne)).catch(async ae=>{if(!(ae instanceof t.$FK)||ae._code!==s.RemoteAuthorityResolverErrorCode.InvalidAuthority)throw ae;return Y(`resolving nested authorities failed: ${ae.message}`),[await ne(q)]})}catch(ae){return $e(ae)}const de=new M.$9g;de.cancelAndSet(()=>H("waiting..."),1e3);let pe,Pe;for(const[ae,{authorityPrefix:ee,resolver:ge,remoteAuthority:ye}]of te.entries())try{if(ae===te.length-1)H("invoking final resolve()..."),f.mark(`code/extHost/willResolveAuthority/${ee}`),pe=await ge.resolve(ye,{resolveAttempt:U,execServer:Pe}),f.mark(`code/extHost/didResolveAuthorityOK/${ee}`),H("setting tunnel factory..."),this.B(await this.t.setTunnelFactory(ge,t.$EK.isManagedResolvedAuthority(pe)?pe:void 0));else{if(H(`invoking resolveExecServer() for ${ye}`),f.mark(`code/extHost/willResolveExecServer/${ee}`),Pe=await ge.resolveExecServer?.(ye,{resolveAttempt:U,execServer:Pe}),!Pe)throw new t.$FK(`Exec server was not available for ${ye}`,s.RemoteAuthorityResolverErrorCode.NoResolverFound);f.mark(`code/extHost/didResolveExecServerOK/${ee}`)}}catch(je){return f.mark(`code/extHost/didResolveAuthorityError/${ee}`),Z("returned an error",je),de.dispose(),$e(je)}de.dispose();const B={environmentTunnels:pe.environmentTunnels,features:pe.tunnelFeatures},X={extensionHostEnv:pe.extensionHostEnv,isTrusted:pe.isTrusted,authenticationSession:pe.authenticationSessionForInitializingExtensions?{id:pe.authenticationSessionForInitializingExtensions.id,providerId:pe.authenticationSessionForInitializingExtensions.providerId}:void 0};H(`returned ${t.$EK.isManagedResolvedAuthority(pe)?"managed authority":`${pe.host}:${pe.port}`}`);let re;if(t.$EK.isManagedResolvedAuthority(pe)){const ae=U;this.X.setFactory(ae,pe.makeConnection),re={authority:q,connectTo:new s.$Wk(ae),connectionToken:pe.connectionToken}}else re={authority:q,connectTo:new s.$Xk(pe.host,pe.port),connectionToken:pe.connectionToken};return{type:"ok",value:{authority:re,options:X,tunnelInformation:B}}}async $getCanonicalURI(q,U){this.s.info(`$getCanonicalURI invoked for authority (${(0,s.$Zk)(q)})`);const{resolver:ie}=await this.sb(q);if(!ie)return null;const be=g.URI.revive(U);if(typeof ie.getCanonicalURI>"u")return be;const H=await(0,M.$Qg)(()=>ie.getCanonicalURI(be));return H||be}$startExtensionHost(q){q.toAdd.forEach(be=>be.extensionLocation=g.URI.revive(be.extensionLocation));const{globalRegistry:U,myExtensions:ie}=le(this.I,this.L,this.J,q);return this.L.set(U.getAllExtensionDescriptions()),this.J.set(ie),N.$t&&(this.s.info(`$startExtensionHost: global extensions: ${J(this.L)}`),this.s.info(`$startExtensionHost: local extensions: ${J(this.J)}`)),this.rb()}$activateByEvent(q,U){return U===1?this.D.wait().then(ie=>this.Z(q,!1)):this.G.wait().then(ie=>this.Z(q,!1))}async $activate(q,U){return await this.G.wait(),this.J.getExtensionDescription(q)?(await this.$(q,U),!0):!1}async $deltaExtensions(q){q.toAdd.forEach(Y=>Y.extensionLocation=g.URI.revive(Y.extensionLocation));const{globalRegistry:U,myExtensions:ie}=le(this.I,this.L,this.J,q),be=await this.bb(ie);return(await this.getExtensionPathIndex()).setSearchTree(be),this.L.set(U.getAllExtensionDescriptions()),this.J.set(ie),N.$t&&(this.s.info(`$deltaExtensions: global extensions: ${J(this.L)}`),this.s.info(`$deltaExtensions: local extensions: ${J(this.J)}`)),Promise.resolve(void 0)}async $test_latency(q){return q}async $test_up(q){return q.byteLength}async $test_down(q){const U=r.$fe.alloc(q),ie=Math.random()%256;for(let be=0;be<q;be++)U.writeUInt8(ie,be);return U}async $updateRemoteConnectionData(q){this.W=q,this.a.fire()}};e.$Dec=x,e.$Dec=x=W=He([Be(0,d.$Uh),Be(1,e.$Cec),Be(2,h.$zM),Be(3,w.$3dc),Be(4,$.$6dc),Be(5,A.$dj),Be(6,c.$PM),Be(7,l.$9dc),Be(8,D.$Rwb),Be(9,m.$rec),Be(10,R.$zec),Be(11,O.$Aec)],x);function le(he,q,U,ie){he.addActivationEvents(ie.addActivationEvents);const be=new o.$T5b(he,q.getAllExtensionDescriptions());be.deltaExtensions(ie.toAdd,ie.toRemove);const H=new n.$am(U.getAllExtensionDescriptions().map(Z=>Z.identifier));for(const Z of ie.myToRemove)H.delete(Z);for(const Z of ie.myToAdd)H.add(Z);const Y=oe(be,H);return{globalRegistry:be,myExtensions:Y}}function G(he,q){return{id:he.identifier.value,name:he.name,extensionVersion:he.version,publisherDisplayName:he.publisher,activationEvents:he.activationEvents?he.activationEvents.join(","):null,isBuiltin:he.isBuiltin,reason:q.activationEvent,reasonId:q.extensionId.value}}function J(he){return he.getAllExtensionDescriptions().map(q=>q.identifier.value).join(",")}e.$Eec=(0,d.$Vh)("IExtHostExtensionService");class Q{#e;#t;#i;constructor(q,U,ie,be,H){this.#e=q,this.#t=U,this.#i=ie.identifier,this.id=ie.identifier.value,this.extensionUri=ie.extensionLocation,this.extensionPath=F.$gc((0,L.$ng)(ie.extensionLocation)),this.packageJSON=ie,this.extensionKind=be,this.isFromDifferentExtensionHost=H}get isActive(){return this.#e.isActivated(this.#i)}get exports(){if(!(this.packageJSON.api==="none"||this.isFromDifferentExtensionHost))return this.#e.getExtensionExports(this.#i)}async activate(){if(this.isFromDifferentExtensionHost)throw new Error("Cannot activate foreign extension");return await this.#e.activateByIdWithErrors(this.#i,{startup:!1,extensionId:this.#t,activationEvent:"api"}),this.exports}}e.$Fec=Q;function oe(he,q){return he.getAllExtensionDescriptions().filter(U=>q.has(U.identifier))}class _{constructor(q){this.a=q}setSearchTree(q){this.a=q}findSubstr(q){return this.a.findSubstr(q)}forEach(q){return this.a.forEach(q)}}e.$Gec=_;class Ee{constructor(q){this.a=new n.$bm,this.addActivationEvents(q)}readActivationEvents(q){return this.a.get(q.identifier)??[]}addActivationEvents(q){for(const U of Object.keys(q))this.a.set(U,q[U])}}}),define(ke[364],Se([1,0,56,2,6,42,25,26,20,27,5,47,14,13]),function(me,e,C,F,f,L,M,b,v,g,A,I,$,y){"use strict";var k;Object.defineProperty(e,"__esModule",{value:!0}),e.$Ofc=void 0;let w=class{constructor(r,a,t,s,d,c,l){this.c=r,this.d=a,this.e=t,this.f=s,this.g=d,this.h=c,this.i=l,this.a=new Map,this.b=[]}async install(){this.j(),C.mark("code/extHost/willWaitForConfig");const r=await this.f.getConfigProvider();C.mark("code/extHost/didWaitForConfig");const a=await this.g.getExtensionPathIndex();this.register(new o(this.c,a,this.d,r,this.i)),this.register(this.e.createInstance(u)),this.h.remote.isRemote&&this.register(this.e.createInstance(i,a,this.h.environment.appUriScheme))}register(r){if("nodeModuleName"in r)if(Array.isArray(r.nodeModuleName))for(const a of r.nodeModuleName)this.a.set(a,r);else this.a.set(r.nodeModuleName,r);typeof r.alternativeModuleName=="function"&&this.b.push(a=>r.alternativeModuleName(a))}};e.$Ofc=w,e.$Ofc=w=He([Be(2,A.$Uh),Be(3,L.$6dc),Be(4,I.$Eec),Be(5,g.$PM),Be(6,$.$dj)],w);let u=class{static{k=this}static{this.a=new Map([["vscode-ripgrep","@vscode/ripgrep"],["vscode-windows-registry","@vscode/windows-registry"]])}constructor(r){if(r.environment.appRoot&&k.a.size){const a=(0,y.$Je)(this.c(r.environment.appRoot.fsPath)),t="[a-z0-9_.-]",s=`@${t}+\\/${t}+|${t}+`,d="node_modules|node_modules\\.asar(?:\\.unpacked)?";this.b=new RegExp(`^(${a}/${d}\\/)(${s})(.*)$`,"i")}}alternativeModuleName(r){if(!this.b)return;const a=this.b.exec(this.c(r));if(!a)return;const[,t,s,d]=a,c=k.a.get(s);if(c!==void 0)return console.warn(`${s} as been renamed to ${c}, please update your imports`),t+c+d}c(r){return r.replace(/\\/g,"/")}};u=k=He([Be(0,g.$PM)],u);class o{constructor(r,a,t,s,d){this.c=r,this.d=a,this.e=t,this.f=s,this.g=d,this.nodeModuleName="vscode",this.a=new b.$bm}load(r,a){const t=this.d.findSubstr(a);if(t){let s=this.a.get(t.identifier);return s||(s=this.c(t,this.e,this.f),this.a.set(t.identifier,s)),s}if(!this.b){let s="";this.d.forEach((d,c)=>s+=`	${c} -> ${d.identifier.value}
`),this.g.warn(`Could not identify extension for 'vscode' require call from ${a}. These are the extension path mappings: 
${s}`),this.b=this.c(M.$GF,this.e,this.f)}return this.b}}let i=class{constructor(r,a,t){this.e=r,this.f=a,this.nodeModuleName=["open","opn"],this.d=t.getProxy(f.$xK.MainThreadTelemetry);const s=t.getProxy(f.$xK.MainThreadWindow);this.c=(d,c)=>{const l=F.URI.parse(d);return c?this.g(d,c):l.scheme==="http"||l.scheme==="https"?s.$openUri(l,d,{allowTunneling:!0}):l.scheme==="mailto"||l.scheme===this.f?s.$openUri(l,d,{}):this.g(d,c)}}load(r,a,t){const s=this.e.findSubstr(a);return s&&(this.a=s.identifier.value,this.h()),this.b=t(r),this.c}g(r,a){return this.i(),this.b(r,a)}h(){this.a&&this.d.$publicLog2("shimming.open",{extension:this.a})}i(){this.a&&this.d.$publicLog2("shimming.open.call.noForward",{extension:this.a})}};i=He([Be(2,v.$zM)],i)}),define(ke[58],Se([1,0,48,3,16,49,5,69,70,47,7,41,290,42]),function(me,e,C,F,f,L,M,b,v,g,A,I,$,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Iec=e.$Hec=void 0,e.$Hec=(0,M.$Vh)("IExtHostVariableResolverProvider");class k extends $.$AN{constructor(o,i,n,r,a,t,s){function d(){if(n){const c=n.activeEditor();if(c)return c.document.uri;const l=r.tabGroups.all.find(h=>h.isActive)?.activeTab;if(l!==void 0){if(l.input instanceof A.$fM||l.input instanceof A.$kM)return l.input.modified;if(l.input instanceof A.$eM||l.input instanceof A.$jM||l.input instanceof A.$hM)return l.input.uri}}}super({getFolderUri:c=>{const l=t.folders.filter(h=>h.name===c);if(l&&l.length>0)return l[0].uri},getWorkspaceFolderCount:()=>t.folders.length,getConfigurationValue:(c,l)=>a.getConfiguration(void 0,c).get(l),getAppRoot:()=>L.cwd(),getExecPath:()=>L.env.VSCODE_EXEC_PATH,getFilePath:()=>{const c=d();if(c)return f.$gc(c.fsPath)},getWorkspaceFolderPathForFile:()=>{if(i){const c=d();if(c){const l=i.getWorkspaceFolder(c);if(l)return f.$gc(l.uri.fsPath)}}},getSelectedText:()=>{if(n){const c=n.activeEditor();if(c&&!c.selection.isEmpty)return c.document.getText(c.selection)}},getLineNumber:()=>{if(n){const c=n.activeEditor();if(c)return String(c.selection.end.line+1)}},getExtension:c=>o.getExtension(c)},void 0,s?Promise.resolve(s):void 0,Promise.resolve(L.env))}}let w=class extends F.$Rc{constructor(o,i,n,r,a){super(),this.b=o,this.c=i,this.g=n,this.h=r,this.j=a,this.a=new C.$U(async()=>{const t=await this.h.getConfigProvider(),d={folders:await this.c.getWorkspaceFolders2()||[]};return this.B(this.c.onDidChangeWorkspace(async c=>{d.folders=await this.c.getWorkspaceFolders2()||[]})),new k(this.b,this.c,this.g,this.j,t,d,this.m())})}getResolver(){return this.a.value}m(){}};e.$Iec=w,e.$Iec=w=He([Be(0,g.$Eec),Be(1,I.$3dc),Be(2,b.$KM),Be(3,y.$6dc),Be(4,v.$fec)],w)}),define(ke[96],Se([1,0,12,4,2,5,6,70,47,20,7,41,142,282,42,58]),function(me,e,C,F,f,L,M,b,v,g,A,I,$,y,k,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nec=e.$Mec=e.$Lec=e.$Kec=e.$Jec=void 0,e.$Jec=(0,L.$Vh)("IExtHostDebugService");let u=class{get onDidStartDebugSession(){return this.m.event}get onDidTerminateDebugSession(){return this.n.event}get onDidChangeActiveDebugSession(){return this.o.event}get activeDebugSession(){return this.q}get onDidReceiveDebugSessionCustomEvent(){return this.u.event}get activeDebugConsole(){return this.v.value}constructor(s,d,c,l,h,E){this.E=d,this.F=c,this.G=l,this.H=h,this.I=E,this.l=new Map,this.d=0,this.f=[],this.g=0,this.h=[],this.i=0,this.j=[],this.B=new Map,this.C=new Map,this.m=new F.$Rd,this.n=new F.$Rd,this.o=new F.$Rd,this.u=new F.$Rd,this.k=s.getProxy(M.$xK.MainThreadDebugService),this.y=new F.$Rd,this.A=new F.$Rd,this.v=new i(this.k),this.w=new Map,this.F.getExtensionRegistry().then(D=>{D.onDidChange(m=>{this.J(D)}),this.J(D)})}asDebugSourceUri(s,d){const c=s;if(typeof c.sourceReference=="number"&&c.sourceReference>0){let l=`debug:${encodeURIComponent(c.path||"")}`,h="?";return d&&(l+=`${h}session=${encodeURIComponent(d.id)}`,h="&"),l+=`${h}ref=${c.sourceReference}`,f.URI.parse(l)}else{if(c.path)return f.URI.file(c.path);throw new Error("cannot create uri from DAP 'source' object; properties 'path' and 'sourceReference' are both missing.")}}J(s){const d=[];for(const c of s.getAllExtensionDescriptions())if(c.contributes){const l=c.contributes.debuggers;if(l&&l.length>0)for(const h of l)(0,y.$iF)(h)&&d.push(h.type)}this.k.$registerDebugTypes(d)}get stackFrameFocus(){return this.z}get onDidChangeStackFrameFocus(){return this.A.event}get onDidChangeBreakpoints(){return this.y.event}get breakpoints(){const s=[];return this.w.forEach(d=>s.push(d)),s}addBreakpoints(s){const d=s.filter(h=>{const E=h.id;return this.w.has(E)?!1:(this.w.set(E,h),!0)});this.U(d,[],[]);const c=[],l=new Map;for(const h of d)if(h instanceof A.$yL){let E=l.get(h.location.uri.toString());E||(E={type:"sourceMulti",uri:h.location.uri,lines:[]},l.set(h.location.uri.toString(),E),c.push(E)),E.lines.push({id:h.id,enabled:h.enabled,condition:h.condition,hitCondition:h.hitCondition,logMessage:h.logMessage,line:h.location.range.start.line,character:h.location.range.start.character})}else h instanceof A.$zL&&c.push({type:"function",id:h.id,enabled:h.enabled,hitCondition:h.hitCondition,logMessage:h.logMessage,condition:h.condition,functionName:h.functionName});return this.k.$registerBreakpoints(c)}removeBreakpoints(s){const d=s.filter(E=>this.w.delete(E.id));this.U([],d,[]);const c=d.filter(E=>E instanceof A.$yL).map(E=>E.id),l=d.filter(E=>E instanceof A.$zL).map(E=>E.id),h=d.filter(E=>E instanceof A.$AL).map(E=>E.id);return this.k.$unregisterBreakpoints(c,l,h)}startDebugging(s,d,c){return this.k.$startDebugging(s?s.uri:void 0,d,{parentSessionID:c.parentSession?c.parentSession.id:void 0,lifecycleManagedByParent:c.lifecycleManagedByParent,repl:c.consoleMode===A.DebugConsoleMode.MergeWithParent?"mergeWithParent":"separate",noDebug:c.noDebug,compact:c.compact,suppressSaveBeforeStart:c.suppressSaveBeforeStart,suppressDebugStatusbar:c.suppressDebugStatusbar??c.debugUI?.simple,suppressDebugToolbar:c.suppressDebugToolbar??c.debugUI?.simple,suppressDebugView:c.suppressDebugView??c.debugUI?.simple})}stopDebugging(s){return this.k.$stopDebugging(s?s.id:void 0)}registerDebugConfigurationProvider(s,d,c){if(!d)return new A.$zK(()=>{});const l=this.d++;return this.f.push({type:s,handle:l,provider:d}),this.k.$registerDebugConfigurationProvider(s,c,!!d.provideDebugConfigurations,!!d.resolveDebugConfiguration,!!d.resolveDebugConfigurationWithSubstitutedVariables,l),new A.$zK(()=>{this.f=this.f.filter(h=>h.provider!==d),this.k.$unregisterDebugConfigurationProvider(l)})}registerDebugAdapterDescriptorFactory(s,d,c){if(!c)return new A.$zK(()=>{});if(!this.Q(s,d))throw new Error(`a DebugAdapterDescriptorFactory can only be registered from the extension that defines the '${d}' debugger.`);if(this.N(d))throw new Error("a DebugAdapterDescriptorFactory can only be registered once per a type.");const l=this.g++;return this.h.push({type:d,handle:l,factory:c}),this.k.$registerDebugAdapterDescriptorFactory(d,l),new A.$zK(()=>{this.h=this.h.filter(h=>h.factory!==c),this.k.$unregisterDebugAdapterDescriptorFactory(l)})}registerDebugAdapterTrackerFactory(s,d){if(!d)return new A.$zK(()=>{});const c=this.i++;return this.j.push({type:s,handle:c,factory:d}),new A.$zK(()=>{this.j=this.j.filter(l=>l.factory!==d)})}async $runInTerminal(s,d){return Promise.resolve(void 0)}async $substituteVariables(s,d){let c;const l=await this.W(s);return l&&(c={uri:l.uri,name:l.name,index:l.index,toResource:()=>{throw new Error("Not implemented")}}),(await this.I.getResolver()).resolveAnyAsync(c,d)}K(s,d){if(s.type==="implementation")return new r(s.implementation)}L(){}async $startDASession(s,d){const c=this,l=await this.V(d);return this.S(this.N(l.type),l).then(h=>{if(!h)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${l.type}' (extension might have failed to activate)`);const E=this.M(h),D=this.K(E,l);if(!D)throw new Error(`Couldn't create a debug adapter for type '${l.type}'.`);const m=D;return this.B.set(s,m),this.R(l).then(p=>(p&&this.C.set(s,p),m.onMessage(async S=>{if(S.type==="request"&&S.command==="handshake"){const P=S,z={type:"response",seq:0,command:P.command,request_seq:P.seq,success:!0};this.D||(this.D=this.L());try{if(this.D){const j=await this.D.sign(P.arguments.value);z.body={signature:j},m.sendResponse(z)}else throw new Error("no signer")}catch(j){z.success=!1,z.message=j.message,m.sendResponse(z)}}else p&&p.onDidSendMessage&&p.onDidSendMessage(S),S=(0,y.$nF)(S,!0),c.k.$acceptDAMessage(s,S)}),m.onError(S=>{p&&p.onError&&p.onError(S),this.k.$acceptDAError(s,S.name,S.message,S.stack)}),m.onExit(S=>{p&&p.onExit&&p.onExit(S??void 0,void 0),this.k.$acceptDAExit(s,S??void 0,void 0)}),p&&p.onWillStartSession&&p.onWillStartSession(),m.startSession()))})}$sendDAMessage(s,d){d=(0,y.$mF)(d,!1);const c=this.C.get(s);c&&c.onWillReceiveMessage&&c.onWillReceiveMessage(d),this.B.get(s)?.sendMessage(d)}$stopDASession(s){const d=this.C.get(s);this.C.delete(s),d&&d.onWillStopSession&&d.onWillStopSession();const c=this.B.get(s);return this.B.delete(s),c?c.stopSession():Promise.resolve(void 0)}$acceptBreakpointsDelta(s){const d=[],c=[],l=[];if(s.added)for(const h of s.added){const E=h.id;if(E&&!this.w.has(E)){let D;if(h.type==="function")D=new A.$zL(h.functionName,h.enabled,h.condition,h.hitCondition,h.logMessage);else if(h.type==="data")D=new A.$AL(h.label,h.dataId,h.canPersist,h.enabled,h.hitCondition,h.condition,h.logMessage);else{const m=f.URI.revive(h.uri);D=new A.$yL(new A.$LK(m,new A.$AK(h.line,h.character)),h.enabled,h.condition,h.hitCondition,h.logMessage)}(0,A.$wL)(D,E),this.w.set(E,D),d.push(D)}}if(s.removed)for(const h of s.removed){const E=this.w.get(h);E&&(this.w.delete(h),c.push(E))}if(s.changed){for(const h of s.changed)if(h.id){const E=this.w.get(h.id);if(E){if(E instanceof A.$zL&&h.type==="function"){const D=E;D.enabled=h.enabled,D.condition=h.condition,D.hitCondition=h.hitCondition,D.logMessage=h.logMessage,D.functionName=h.functionName}else if(E instanceof A.$yL&&h.type==="source"){const D=E;D.enabled=h.enabled,D.condition=h.condition,D.hitCondition=h.hitCondition,D.logMessage=h.logMessage,D.location=new A.$LK(f.URI.revive(h.uri),new A.$AK(h.line,h.character))}l.push(E)}}}this.U(d,c,l)}async $acceptStackFrameFocus(s){let d;const c=s.sessionId?await this.V(s.sessionId):void 0;if(!c)throw new Error("no DebugSession found for debug focus context");s.kind==="thread"?d=new A.$GL(c,s.threadId):d=new A.$FL(c,s.threadId,s.frameId),this.z=d,this.A.fire(this.z)}$provideDebugConfigurations(s,d,c){return(0,C.$Qg)(async()=>{const l=this.P(s);if(!l)throw new Error("no DebugConfigurationProvider found");if(!l.provideDebugConfigurations)throw new Error("DebugConfigurationProvider has no method provideDebugConfigurations");const h=await this.W(d);return l.provideDebugConfigurations(h,c)}).then(l=>{if(!l)throw new Error("nothing returned from DebugConfigurationProvider.provideDebugConfigurations");return l})}$resolveDebugConfiguration(s,d,c,l){return(0,C.$Qg)(async()=>{const h=this.P(s);if(!h)throw new Error("no DebugConfigurationProvider found");if(!h.resolveDebugConfiguration)throw new Error("DebugConfigurationProvider has no method resolveDebugConfiguration");const E=await this.W(d);return h.resolveDebugConfiguration(E,c,l)})}$resolveDebugConfigurationWithSubstitutedVariables(s,d,c,l){return(0,C.$Qg)(async()=>{const h=this.P(s);if(!h)throw new Error("no DebugConfigurationProvider found");if(!h.resolveDebugConfigurationWithSubstitutedVariables)throw new Error("DebugConfigurationProvider has no method resolveDebugConfigurationWithSubstitutedVariables");const E=await this.W(d);return h.resolveDebugConfigurationWithSubstitutedVariables(E,c,l)})}async $provideDebugAdapter(s,d){const c=this.O(s);if(!c)return Promise.reject(new Error("no adapter descriptor factory found for handle"));const l=await this.V(d);return this.S(c,l).then(h=>{if(!h)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${l.type}'`);return this.M(h)})}async $acceptDebugSessionStarted(s){const d=await this.V(s);this.m.fire(d)}async $acceptDebugSessionTerminated(s){const d=await this.V(s);d&&(this.n.fire(d),this.l.delete(d.id))}async $acceptDebugSessionActiveChanged(s){this.q=s?await this.V(s):void 0,this.o.fire(this.q)}async $acceptDebugSessionNameChanged(s,d){(await this.V(s))?._acceptNameChanged(d)}async $acceptDebugSessionCustomEvent(s,d){const l={session:await this.V(s),event:d.event,body:d.body};this.u.fire(l)}M(s){if(s instanceof A.$BL)return{type:"executable",command:s.command,args:s.args,options:s.options};if(s instanceof A.$CL)return{type:"server",port:s.port,host:s.host};if(s instanceof A.$DL)return{type:"pipeServer",path:s.path};if(s instanceof A.$EL)return{type:"implementation",implementation:s.implementation};throw new Error("convertToDto unexpected type")}N(s){const d=this.h.filter(c=>c.type===s);if(d.length>0)return d[0].factory}O(s){const d=this.h.filter(c=>c.handle===s);if(d.length>0)return d[0].factory}P(s){const d=this.f.filter(c=>c.handle===s);if(d.length>0)return d[0].provider}Q(s,d){if(s.contributes){const c=s.contributes.debuggers;if(c&&c.length>0){for(const l of c)if(l.label&&l.type&&l.type===d)return!0}}return!1}R(s){const c=s.configuration.type,l=this.j.filter(h=>h.type===c||h.type==="*").map(h=>(0,C.$Qg)(()=>h.factory.createDebugAdapterTracker(s)).then(E=>E,E=>null));return Promise.race([Promise.all(l).then(h=>{const E=h.filter(D=>!!D);if(E.length>0)return new n(E)}),new Promise(h=>setTimeout(()=>h(void 0),1e3))]).catch(h=>{})}async S(s,d){const c=d.configuration.debugServer;if(typeof c=="number")return Promise.resolve(new A.$CL(c));if(s){const h=await this.F.getExtensionRegistry();return(0,C.$Qg)(()=>s.createDebugAdapterDescriptor(d,this.T(d,h))).then(E=>{if(E)return E})}const l=await this.F.getExtensionRegistry();return Promise.resolve(this.T(d,l))}T(s,d){}U(s,d,c){(s.length>0||d.length>0||c.length>0)&&this.y.fire(Object.freeze({added:s,removed:d,changed:c}))}async V(s){if(s)if(typeof s=="string"){const d=this.l.get(s);if(d)return d}else{let d=this.l.get(s.id);if(!d){const c=await this.W(s.folderUri),l=s.parent?this.l.get(s.parent):void 0;d=new o(this.k,s.id,s.type,s.name,c,s.configuration,l),this.l.set(d.id,d),this.k.$sessionCached(d.id)}return d}throw new Error("cannot find session")}W(s){if(s){const d=f.URI.revive(s);return this.E.resolveWorkspaceFolder(d)}return Promise.resolve(void 0)}};e.$Kec=u,e.$Kec=u=He([Be(0,g.$zM),Be(1,I.$3dc),Be(2,v.$Eec),Be(3,k.$6dc),Be(4,b.$fec),Be(5,w.$Hec)],u);class o{constructor(s,d,c,l,h,E,D){this.d=s,this.f=d,this.g=c,this.h=l,this.i=h,this.j=E,this.k=D}get id(){return this.f}get type(){return this.g}get name(){return this.h}set name(s){this.h=s,this.d.$setDebugSessionName(this.f,s)}get parentSession(){return this.k}_acceptNameChanged(s){this.h=s}get workspaceFolder(){return this.i}get configuration(){return this.j}customRequest(s,d){return this.d.$customDebugAdapterRequest(this.f,s,d)}getDebugProtocolBreakpoint(s){return this.d.$getDebugProtocolBreakpoint(this.f,s.id)}}e.$Lec=o;class i{constructor(s){this.value=Object.freeze({append(d){s.$appendDebugConsole(d)},appendLine(d){this.append(d+`
`)}})}}e.$Mec=i;class n{constructor(s){this.d=s}onWillStartSession(){this.d.forEach(s=>s.onWillStartSession?s.onWillStartSession():void 0)}onWillReceiveMessage(s){this.d.forEach(d=>d.onWillReceiveMessage?d.onWillReceiveMessage(s):void 0)}onDidSendMessage(s){this.d.forEach(d=>d.onDidSendMessage?d.onDidSendMessage(s):void 0)}onWillStopSession(){this.d.forEach(s=>s.onWillStopSession?s.onWillStopSession():void 0)}onError(s){this.d.forEach(d=>d.onError?d.onError(s):void 0)}onExit(s,d){this.d.forEach(c=>c.onExit?c.onExit(s,d):void 0)}}class r extends $.$Fdb{constructor(s){super(),this.h=s,s.onDidSendMessage(d=>{this.acceptMessage(d)})}startSession(){return Promise.resolve(void 0)}sendMessage(s){this.h.handleMessage(s)}stopSession(){return this.h.dispose(),Promise.resolve(void 0)}}let a=class extends u{constructor(s,d,c,l,h,E){super(s,d,c,l,h,E)}};e.$Nec=a,e.$Nec=a=He([Be(0,g.$zM),Be(1,I.$3dc),Be(2,v.$Eec),Be(3,k.$6dc),Be(4,b.$fec),Be(5,w.$Hec)],a)}),define(ke[365],Se([1,0,8,56,2,6,353,14,106,107,27,248,20,66,47,90]),function(me,e,C,F,f,L,M,b,v,g,A,I,$,y,k,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qfc=e.$Pfc=void 0;class u{static async installEarlyHandler(n){Error.stackTraceLimit=100;const r=n.get(b.$dj),t=n.get($.$zM).getProxy(L.$xK.MainThreadErrors);C.setUnexpectedErrorHandler(s=>{r.error(s);const d=C.$2(s);t.$onUnexpectedError(d)})}static async installFullHandler(n){const r=n.get(b.$dj),a=n.get($.$zM),t=n.get(k.$Eec),s=n.get(w.$TM),d=a.getProxy(L.$xK.MainThreadExtensionService),c=a.getProxy(L.$xK.MainThreadErrors),l=await t.getExtensionPathIndex(),h=new WeakMap;function E(p,S){if(h.has(p))return h.get(p).stack;let P="",z,j;for(const T of S)P+=`
	at ${T.toString()}`,j=T.getFileName(),!z&&j&&(z=l.findSubstr(f.URI.file(j)));const R=`${p.name||"Error"}: ${p.message||""}${P}`;return h.set(p,{extensionIdentifier:z?.identifier,stack:R}),R}const D=Symbol("prepareStackTrace wrapped");let m=E;Object.defineProperty(Error,"prepareStackTrace",{configurable:!1,get(){return m},set(p){if(p===E||!p||p[D]){m=p||E;return}m=function(S,P){return E(S,P),p.call(Error,S,P)},Object.assign(m,{[D]:!0})}}),C.setUnexpectedErrorHandler(p=>{r.error(p);const S=C.$2(p),P=h.get(p);if(!P?.extensionIdentifier){c.$onUnexpectedError(S);return}d.$onExtensionRuntimeError(P.extensionIdentifier,S);const z=s.onExtensionError(P.extensionIdentifier,p);r.trace("forwarded error to extension?",z,P)})}}e.$Pfc=u;class o{constructor(n,r,a,t,s){this.a=a,this.b=new M.$25b(n,null,t),r=o.e(r,this.b);const d=new g.$Th(...(0,v.$Dr)());d.set(A.$PM,{_serviceBrand:void 0,...r,messagePorts:s}),d.set($.$zM,new $.$AM(this.b)),d.set(y.$Zdc,new y.$1dc(t)),d.set(k.$Cec,a);const c=new I.$jq(d,!0);c.invokeFunction(u.installEarlyHandler),this.d=c.invokeFunction(l=>l.get(b.$dj)),F.mark("code/extHost/didCreateServices"),this.a.pid?this.d.info(`Extension host with pid ${this.a.pid} started`):this.d.info("Extension host started"),this.d.trace("initData",r),this.c=c.invokeFunction(l=>l.get(k.$Eec)),this.c.initialize(),c.invokeFunction(u.installFullHandler)}async asBrowserUri(n){const r=this.b.getProxy(L.$xK.MainThreadExtensionService);return f.URI.revive(await r.$asBrowserUri(n))}terminate(n){this.c.terminate(n)}static e(n,r){n.extensions.allExtensions.forEach(t=>{t.extensionLocation=f.URI.revive(r.transformIncomingURIs(t.extensionLocation))}),n.environment.appRoot=f.URI.revive(r.transformIncomingURIs(n.environment.appRoot));const a=n.environment.extensionDevelopmentLocationURI;return a&&(n.environment.extensionDevelopmentLocationURI=a.map(t=>f.URI.revive(r.transformIncomingURIs(t)))),n.environment.extensionTestsLocationURI=f.URI.revive(r.transformIncomingURIs(n.environment.extensionTestsLocationURI)),n.environment.globalStorageHome=f.URI.revive(r.transformIncomingURIs(n.environment.globalStorageHome)),n.environment.workspaceStorageHome=f.URI.revive(r.transformIncomingURIs(n.environment.workspaceStorageHome)),n.environment.extensionTelemetryLogResource=f.URI.revive(r.transformIncomingURIs(n.environment.extensionTelemetryLogResource)),n.nlsBaseUrl=f.URI.revive(r.transformIncomingURIs(n.nlsBaseUrl)),n.logsLocation=f.URI.revive(r.transformIncomingURIs(n.logsLocation)),n.workspace=r.transformIncomingURIs(n.workspace),n}}e.$Qfc=o}),define(ke[366],Se([1,0,12,11,223,242,140,96,70,47,20,46,7,58,41,283,284,42]),function(me,e,C,F,f,L,M,b,v,g,A,I,$,y,k,w,u,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1fc=void 0;let i=class extends b.$Kec{constructor(s,d,c,l,h,E,D){super(s,d,c,l,E,D),this.Z=h,this.X=new a}K(s,d){switch(s.type){case"server":return new w.$Vfc(s);case"pipeServer":return new w.$Wfc(s);case"executable":return new w.$Xfc(s,d.type)}return super.K(s,d)}T(s,d){const c=w.$Xfc.platformAdapterExecutable(d.getAllExtensionDescriptions(),s.type);if(c)return new $.$BL(c.command,c.args,c.options)}L(){return new M.$P9b}async $runInTerminal(s,d){if(s.kind==="integrated"){this.Y||(this.Y=this.Z.onDidCloseTerminal(R=>{this.X.onTerminalClosed(R)}));const c=await this.G.getConfigProvider(),l=this.Z.getDefaultShell(!0),h=this.Z.getDefaultShellArgs(!0),E=s.title||f.localize(0,null),D=JSON.stringify({shell:l,shellArgs:h});let m=await this.X.checkout(D,E),p,S=!1;if(m)p=s.cwd;else{const R={shellPath:l,shellArgs:h,cwd:s.cwd,name:E,iconPath:new $.$tL("debug")};S=!0,m=this.Z.createTerminalFromOptions(R,{isFeatureTerminal:!0,useShellEnvironment:!0}),this.X.insert(m,D)}m.show(!0);const P=await m.processId;S?await new Promise(R=>setTimeout(R,1e3)):c.getConfiguration("debug.terminal").get("clearBeforeReusing")&&(l.indexOf("powershell")>=0||l.indexOf("pwsh")>=0||l.indexOf("cmd.exe")>=0?m.sendText("cls"):l.indexOf("bash")>=0?m.sendText("clear"):F.$i?m.sendText("cls"):m.sendText("clear"));const z=(0,u.$Zfc)(l,s.args,!!s.argsCanBeInterpretedByShell,p,s.env);m.sendText(z);const j=this.onDidTerminateDebugSession(R=>{R.id===d&&(this.X.free(m),j.dispose())});return P}else if(s.kind==="external")return r(s,await this.G.getConfigProvider());return super.$runInTerminal(s,d)}};e.$1fc=i,e.$1fc=i=He([Be(0,A.$zM),Be(1,k.$3dc),Be(2,g.$Eec),Be(3,o.$6dc),Be(4,I.$rec),Be(5,v.$fec),Be(6,y.$Hec)],i);let n;function r(t,s){if(!n)if(F.$i)n=new L.$B8b;else if(F.$j)n=new L.$C8b;else if(F.$k)n=new L.$D8b;else throw new Error("external terminals not supported on this platform");const d=s.getConfiguration("terminal");return n.runInTerminal(t.title,t.cwd,t.args,t.env||{},d.external||{})}class a{constructor(){this.b=new Map}static{this.a=1e3}async checkout(s,d){const l=[...this.b.entries()].map(([h,E])=>(0,C.$Lg)(async D=>{if(h.name!==d||E.lastUsedAt!==-1&&await(0,u.$Yfc)(await h.processId))return null;const m=Date.now();return E.lastUsedAt+a.a>m||D.isCancellationRequested||E.config!==s?null:(E.lastUsedAt=m,h)}));return await(0,C.$3g)(l,h=>!!h)}insert(s,d){this.b.set(s,{lastUsedAt:Date.now(),config:d})}free(s){const d=this.b.get(s);d&&(d.lastUsedAt=-1)}onTerminalClosed(s){this.b.delete(s)}}}),define(ke[367],Se([1,0,16,2,104,41,69,42,40,46,20,27,95,17,14,91,23,63,58]),function(me,e,C,F,f,L,M,b,v,g,A,I,$,y,k,w,u,o,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sfc=void 0;let n=class extends $.$ufc{constructor(a,t,s,d,c,l,h,E,D){super(a,t,s,d,c,l,h,E),this.B=s,this.C=D,t.remote.isRemote&&t.remote.authority?this.registerTaskSystem(y.Schemas.vscodeRemote,{scheme:y.Schemas.vscodeRemote,authority:t.remote.authority,platform:process.platform}):this.registerTaskSystem(y.Schemas.file,{scheme:y.Schemas.file,authority:"",platform:process.platform}),this.a.$registerSupportedExecutions(!0,!0,!0)}async executeTask(a,t){const s=t;if(!t.execution&&s._id===void 0)throw new Error("Tasks to execute must include an execution");if(s._id!==void 0){const d=$.TaskHandleDTO.from(s,this.B),c=await this.a.$getTaskExecution(d);if(c.task===void 0)throw new Error("Task from execution DTO is undefined");const l=await this.y(c,t);return this.a.$executeTask(d).catch(()=>{}),l}else{const d=$.TaskDTO.from(t,a);if(d===void 0)return Promise.reject(new Error("Task is not valid"));$.CustomExecutionDTO.is(d.execution)&&await this.x(d,t,!1);const c=await this.y(await this.a.$getTaskExecution(d),t);return this.a.$executeTask(d).catch(()=>{}),c}}u(a,t,s,d){const c=[];if(d)for(const l of d){this.z(l,s),(!l.definition||!a[l.definition.type])&&this.f.warn(`The task [${l.source}, ${l.name}] uses an undefined task type. The task will be ignored in the future.`);const h=$.TaskDTO.from(l,s.extension);h&&(c.push(h),$.CustomExecutionDTO.is(h.execution)&&t.push(this.x(h,l,!0)))}return{tasks:c,extension:s.extension}}async v(a){return a}async F(a){let t=a&&a.length>0?a[0]:void 0;if(!t){const s=F.URI.file((0,o.homedir)());t=new v.$di({uri:s,name:u.$wg(s),index:0})}return{uri:t.uri,name:t.name,index:t.index,toResource:()=>{throw new Error("Not implemented")}}}async $resolveVariables(a,t){const s=F.URI.revive(a),d={process:void 0,variables:Object.create(null)},c=await this.b.resolveWorkspaceFolder(s),l=await this.b.getWorkspaceFolders2()??[],h=await this.C.getResolver(),E=c?{uri:c.uri,name:c.name,index:c.index,toResource:()=>{throw new Error("Not implemented")}}:await this.F(l);for(const D of t.variables)d.variables[D]=await h.resolveAsync(E,D);if(t.process!==void 0){let D;if(t.process.path!==void 0){D=t.process.path.split(C.$sc);for(let m=0;m<D.length;m++)D[m]=await h.resolveAsync(E,D[m])}d.process=await f.win32.findExecutable(await h.resolveAsync(E,t.process.name),t.process.cwd!==void 0?await h.resolveAsync(E,t.process.cwd):void 0,D)}return d}async $jsonTasksSupported(){return!0}async $findExecutable(a,t,s){return f.win32.findExecutable(a,t,s)}};e.$Sfc=n,e.$Sfc=n=He([Be(0,A.$zM),Be(1,I.$PM),Be(2,L.$3dc),Be(3,M.$KM),Be(4,b.$6dc),Be(5,g.$rec),Be(6,k.$dj),Be(7,w.$Kdc),Be(8,i.$Hec)],n)}),define(ke[368],Se([1,0,63,58]),function(me,e,C,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ygc=void 0;class f extends F.$Iec{m(){return(0,C.homedir)()}}e.$ygc=f}),define(ke[156],Se([1,0,19,12,21,43,17,16,23,2,36]),function(me,e,C,F,f,L,M,b,v,g,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5ec=e.$4ec=e.$3ec=e.$2ec=void 0;class I{constructor(i,n,r,a){this.d=i,this.e=n,this.f=r,this.g=a,this.a=null,this.b=!1,this.c=0}search(i,n){const r=this.d.folderQueries||[],a=new f.$2d(n);return new Promise((t,s)=>{this.a=new y(i);let d=!1;const c=(l,h)=>{if(!d&&!this.b){const E=this.h(l);w(l)&&typeof this.d.maxResults=="number"&&this.c+E>this.d.maxResults&&(this.b=!0,d=!0,a.cancel(),l=this.j(l,this.d.maxResults-this.c));const D=this.h(l);this.c+=D,(D>0||!w(l))&&this.a.add(l,h)}};Promise.all(r.map((l,h)=>this.k(l,E=>c(E,h),a.token))).then(l=>{a.dispose(),this.a.flush();const h=l.some(E=>!!E&&!!E.limitHit);t({limitHit:this.b||h,messages:(0,C.$Qb)(l.map(E=>E?.message?Array.isArray(E.message)?E.message:[E.message]:[])),stats:{type:this.g}})},l=>{a.dispose();const h=(0,L.$Gi)(l);s(new Error(h))})})}h(i){return w(i)?Array.isArray(i.ranges)?i.ranges.length:1:0}j(i,n){const r=Array.isArray(i.ranges)?i.ranges:[i.ranges],a=Array.isArray(i.preview.matches)?i.preview.matches:[i.preview.matches];return{ranges:r.slice(0,n),preview:{matches:a.slice(0,n),text:i.preview.text},uri:i.uri}}async k(i,n,r){const a=new A.$cJ(this.d,i),t=[],s={report:l=>{if(!this.l(l))return;const h=i.folder.scheme===M.Schemas.file?(0,A.$dJ)(()=>this.f.readdir(v.$yg(l.uri))):void 0,E=v.$Bg(i.folder,l.uri);if(E){const D=a.includedInQuery(E,b.$mc(E),h);(0,F.$Kg)(D)?t.push(D.then(m=>{m&&n(l)})):D&&n(l)}}},d=this.n(i),c=await this.e.provideTextSearchResults($(this.d.contentPattern),d,s,r);return t.length&&await Promise.all(t),c}l(i){if(w(i)){if(Array.isArray(i.ranges)){if(!Array.isArray(i.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same type."),!1;if(i.preview.matches.length!==i.ranges.length)return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}else if(Array.isArray(i.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}return!0}n(i){const n=(0,A.$bJ)(this.d.includePattern,i.includePattern),r=(0,A.$bJ)(this.d.excludePattern,i.excludePattern),a={folder:g.URI.from(i.folder),excludes:r,includes:n,useIgnoreFiles:!i.disregardIgnoreFiles,useGlobalIgnoreFiles:!i.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!i.disregardParentIgnoreFiles,followSymlinks:!i.ignoreSymlinks,encoding:i.fileEncoding&&this.f.toCanonicalName(i.fileEncoding),maxFileSize:this.d.maxFileSize,maxResults:this.d.maxResults,previewOptions:this.d.previewOptions,afterContext:this.d.afterContext,beforeContext:this.d.beforeContext};return a.usePCRE2=this.d.usePCRE2,a}}e.$2ec=I;function $(o){return{isCaseSensitive:o.isCaseSensitive||!1,isRegExp:o.isRegExp||!1,isWordMatch:o.isWordMatch||!1,isMultiline:o.isMultiline||!1,pattern:o.pattern}}class y{constructor(i){this.e=i,this.b=-1,this.d=null,this.a=new u(512,n=>this.g(n))}add(i,n){this.d&&(this.b!==n||!v.$sg(this.c,i.uri))&&(this.f(),this.d=null),this.d||(this.b=n,this.d={resource:i.uri,results:[]}),this.d.results.push(k(i))}f(){const i=this.d&&this.d.results?this.d.results.length:0;this.a.addItem(this.d,i)}flush(){this.f(),this.a.flush()}g(i){this.e(i)}}e.$3ec=y;function k(o){return w(o)?{preview:{matches:(0,C.$1b)(o.preview.matches,i=>({startLineNumber:i.start.line,startColumn:i.start.character,endLineNumber:i.end.line,endColumn:i.end.character})),text:o.preview.text},ranges:(0,C.$1b)(o.ranges,i=>({startLineNumber:i.start.line,startColumn:i.start.character,endLineNumber:i.end.line,endColumn:i.end.character}))}:{text:o.text,lineNumber:o.lineNumber}}function w(o){return!!o.preview}e.$4ec=w;class u{static{this.a=4e3}static{this.b=50}constructor(i,n){this.g=i,this.h=n,this.c=0,this.d=[],this.e=0}addItem(i,n){i&&this.j(i,n)}addItems(i,n){i&&this.k(i,n)}j(i,n){this.d.push(i),this.e+=n,this.l()}k(i,n){this.d=this.d.concat(i),this.e+=n,this.l()}l(){this.c<u.b?this.flush():this.e>=this.g?this.flush():this.f||(this.f=setTimeout(()=>{this.flush()},u.a))}flush(){this.e&&(this.c+=this.e,this.h(this.d),this.d=[],this.e=0,this.f&&(clearTimeout(this.f),this.f=0))}}e.$5ec=u}),define(ke[97],Se([1,0,3,6,5,361,20,66,14,2,156]),function(me,e,C,F,f,L,M,b,v,g,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8ec=e.$7ec=e.$6ec=void 0,e.$6ec=(0,f.$Vh)("IExtHostSearch");let I=class{constructor(w,u,o){this.k=w,this.l=u,this.n=o,this.c=this.k.getProxy(F.$xK.MainThreadSearch),this.d=0,this.e=new Map,this.g=new Set,this.h=new Map,this.i=new Set,this.j=new L.$1ec}o(w){return this.l.transformOutgoingScheme(w)}registerTextSearchProvider(w,u){if(this.g.has(w))throw new Error(`a text search provider for the scheme '${w}' is already registered`);this.g.add(w);const o=this.d++;return this.e.set(o,u),this.c.$registerTextSearchProvider(o,this.o(w)),(0,C.$Pc)(()=>{this.g.delete(w),this.e.delete(o),this.c.$unregisterProvider(o)})}registerFileSearchProvider(w,u){if(this.i.has(w))throw new Error(`a file search provider for the scheme '${w}' is already registered`);this.i.add(w);const o=this.d++;return this.h.set(o,u),this.c.$registerFileSearchProvider(o,this.o(w)),(0,C.$Pc)(()=>{this.i.delete(w),this.h.delete(o),this.c.$unregisterProvider(o)})}$provideFileSearchResults(w,u,o,i){const n=$(o),r=this.h.get(w);if(r)return this.j.fileSearch(n,r,a=>{this.c.$handleFileMatch(w,u,a.map(t=>t.resource))},i);throw new Error("unknown provider: "+w)}async doInternalFileSearchWithCustomCallback(w,u,o){return{messages:[]}}$clearCache(w){return this.j.clearCache(w),Promise.resolve(void 0)}$provideTextSearchResults(w,u,o,i){const n=this.e.get(w);if(!n||!n.provideTextSearchResults)throw new Error(`Unknown provider ${w}`);const r=$(o);return this.q(r,n).search(t=>this.c.$handleTextMatch(w,u,t),i)}$enableExtensionHostSearch(){}q(w,u){return new A.$2ec(w,u,{readdir:o=>Promise.resolve([]),toCanonicalName:o=>o},"textSearchProvider")}};e.$7ec=I,e.$7ec=I=He([Be(0,M.$zM),Be(1,b.$Zdc),Be(2,v.$dj)],I);function $(k){return{...k,folderQueries:k.folderQueries&&k.folderQueries.map(y),extraFileResources:k.extraFileResources&&k.extraFileResources.map(w=>g.URI.revive(w))}}e.$8ec=$;function y(k){return{...k,folder:g.URI.revive(k.folder)}}}),define(ke[369],Se([1,0,21,8,4,3,17,39,2,133,191,172,79,26,31,14,137,65,87,267,6,305,313,91,306,307,308,309,310,311,312,288,35,314,42,344,96,151,316,317,318,294,319,69,70,320,47,321,71,322,57,27,323,324,325,326,327,328,115,116,329,360,296,273,297,330,331,154,332,298,333,334,20,335,97,117,336,337,338,118,92,95,90,46,339,340,285,341,299,72,15,7,342,66,343,93,345,346,153,41,281,114,25,94]),function(me,e,C,F,f,L,M,b,v,g,A,I,$,y,k,w,u,o,i,n,r,a,t,s,d,c,l,h,E,D,m,p,S,P,z,j,R,T,N,O,W,x,le,G,J,Q,oe,_,Ee,he,q,U,ie,be,H,Y,Z,$e,ne,fe,te,de,pe,Pe,B,X,re,ae,ee,ge,ye,je,We,et,Ze,rt,nt,Ae,Oe,Ve,Le,Ye,ue,ce,Ie,Ke,Ge,_e,st,lt,wt,Ue,Kt,Ht,Et,Ut,Nt,Gt,Bt,Dt,Mt,Wt,tt,Vt){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kfc=void 0;function qt(ut){const mt=ut.get(U.$PM),Ot=ut.get(q.$Hdc),Pt=ut.get(Ee.$8dc),At=ut.get(oe.$Eec),gt=ut.get(Dt.$3dc),St=ut.get(ue.$TM),Rt=ut.get(z.$6dc),It=ut.get(Ht.$Zdc),Je=ut.get(We.$zM),jt=ut.get(Ve.$oec),Jt=ut.get(Le.$9dc),Me=ut.get(w.$ej),Fe=ut.get(w.$dj),Ce=ut.get(lt.$Rwb),se=ut.get(s.$Kdc),Te=ut.get(Bt.$Jfc),qe=ut.get(rt.$wec),xe=ut.get(J.$fec),Qe=ut.get(fe.$Aec);Je.set(r.$yK.ExtHostFileSystemInfo,Ot),Je.set(r.$yK.ExtHostLogLevelServiceShape,Me),Je.set(r.$yK.ExtHostWorkspace,gt),Je.set(r.$yK.ExtHostConfiguration,Rt),Je.set(r.$yK.ExtHostExtensionService,At),Je.set(r.$yK.ExtHostStorage,jt),Je.set(r.$yK.ExtHostTunnelService,Ce),Je.set(r.$yK.ExtHostWindow,Te),Je.set(r.$yK.ExtHostSecretState,qe),Je.set(r.$yK.ExtHostTelemetry,St),Je.set(r.$yK.ExtHostEditorTabs,xe),Je.set(r.$yK.ExtHostManagedSockets,Qe);const ot=Je.set(r.$yK.ExtHostDecorations,ut.get(T.$Pec)),pt=Je.set(r.$yK.ExtHostDocumentsAndEditors,ut.get(G.$KM)),bt=Je.set(r.$yK.ExtHostCommands,ut.get(S.$VM)),vt=Je.set(r.$yK.ExtHostTerminalService,ut.get(ce.$rec)),ht=Je.set(r.$yK.ExtHostDebugService,ut.get(R.$Jec)),Lt=Je.set(r.$yK.ExtHostSearch,ut.get(Ze.$6ec)),Qt=Je.set(r.$yK.ExtHostTask,ut.get(Ye.$wfc)),Yt=Je.set(r.$yK.ExtHostOutputService,ut.get(ae.$jfc)),si=Je.set(r.$yK.ExtHostLocalization,ut.get(ne.$zec)),Si=Je.set(r.$yK.ExtHostUrls,new Et.$Gfc(Je)),Ct=Je.set(r.$yK.ExtHostDocuments,new le.$Fdc(Je,pt)),Zi=Je.set(r.$yK.ExtHostDocumentContentProviders,new W.$Rec(Je,pt,Fe)),ln=Je.set(r.$yK.ExtHostDocumentSaveParticipant,new x.$Sec(Fe,Ct,Je.getProxy(r.$xK.MainThreadBulkEdits))),kt=Je.set(r.$yK.ExtHostNotebook,new de.$9ec(Je,bt,pt,Ct,Pt,Lt)),gi=Je.set(r.$yK.ExtHostNotebookDocuments,new Pe.$dfc(kt)),mi=Je.set(r.$yK.ExtHostNotebookEditors,new B.$efc(Fe,kt)),oi=Je.set(r.$yK.ExtHostNotebookKernels,new X.$ffc(Je,mt,kt,bt,Fe)),Di=Je.set(r.$yK.ExtHostNotebookRenderers,new re.$hfc(Je,kt)),Ci=Je.set(r.$yK.ExtHostNotebookDocumentSaveParticipant,new pe.$cfc(Fe,kt,Je.getProxy(r.$xK.MainThreadBulkEdits))),Ft=Je.set(r.$yK.ExtHostEditors,new Ke.$Wdc(Je,pt)),$i=Je.set(r.$yK.ExtHostTreeViews,new st.$Efc(Je.getProxy(r.$xK.MainThreadTreeViews),bt,Fe)),Ii=Je.set(r.$yK.ExtHostEditorInsets,new p.$Xdc(Je.getProxy(r.$xK.MainThreadEditorInsets),Ft,mt.remote)),ai=Je.set(r.$yK.ExtHostDiagnostics,new N.$Jdc(Je,Fe,Ot,pt)),ci=Je.set(r.$yK.ExtHostLanguages,new $e.$afc(Je,Ct,bt.converter,It)),dt=Je.set(r.$yK.ExtHostLanguageFeatures,new Z.$Ndc(Je,It,Ct,bt,ai,Fe,se,St)),Pi=Je.set(r.$yK.ExtHostFileSystem,new _.$Uec(Je,dt)),xt=Je.set(r.$yK.ExtHostFileSystemEventService,new he.$Vec(Je,Fe,pt)),ni=Je.set(r.$yK.ExtHostQuickOpen,(0,je.$nfc)(Je,gt,bt)),bi=Je.set(r.$yK.ExtHostSCM,new et.$pfc(Je,bt,Ct,Fe)),Yi=Je.set(r.$yK.ExtHostQuickDiff,new ye.$mfc(Je,It)),Ai=Je.set(r.$yK.ExtHostShare,new nt.$qfc(Je,It)),Ri=Je.set(r.$yK.ExtHostComments,(0,P.$Ydc)(Je,bt,Ct)),Li=Je.set(r.$yK.ExtHostProgress,new ge.$lfc(Je.getProxy(r.$xK.MainThreadProgress))),xi=Je.set(r.$yK.ExtHosLabelService,new Y.$_ec(Je)),Mi=Je.set(r.$yK.ExtHostTheming,new Ge.$Bfc(Je)),ui=Je.set(r.$yK.ExtHostAuthentication,new d.$Pdc(Je)),_i=Je.set(r.$yK.ExtHostTimeline,new _e.$Dfc(Je,bt)),Fi=Je.set(r.$yK.ExtHostWebviews,new Ut.$aec(Je,mt.remote,gt,Fe,se)),Ti=Je.set(r.$yK.ExtHostWebviewPanels,new Nt.$dec(Je,Fi,gt)),Oi=Je.set(r.$yK.ExtHostCustomEditors,new j.$eec(Je,Ct,Jt,Fi,Ti)),Ni=Je.set(r.$yK.ExtHostWebviewViews,new Gt.$Hfc(Je,Fi)),hi=Je.set(r.$yK.ExtHostTesting,new Ie.$xfc(Je,bt,pt)),hn=Je.set(r.$yK.ExtHostUriOpeners,new Kt.$Ffc(Je)),en=Je.set(r.$yK.ExtHostProfileContentHandlers,new ee.$kfc(Je));Je.set(r.$yK.ExtHostInteractive,new be.$0ec(Je,kt,pt,bt,Fe));const ji=Je.set(r.$yK.ExtHostInlineChat,new ie.$Wec(Je,bt,Ct,Fe)),pi=Je.set(r.$yK.ExtHostChatProvider,new E.$Sdc(Je,Fe)),tn=Je.set(r.$yK.ExtHostChatAgents2,new h.$Tdc(Je,pi,Fe)),nn=Je.set(r.$yK.ExtHostChatVariables,new D.$Udc(Je)),wi=Je.set(r.$yK.ExtHostChat,new l.$Rdc(Je)),vi=Je.set(r.$yK.ExtHostAiRelatedInformation,new a.$Edc(Je)),rn=Je.set(r.$yK.ExtHostAiEmbeddingVector,new Q.$Tec(Je)),_t=Je.set(r.$yK.ExtHostIssueReporter,new H.$$ec(Je)),di=Je.set(r.$yK.ExtHostStatusBar,new Oe.$tfc(Je,bt.converter)),dn=Je.set(r.$yK.ExtHostSpeech,new Ae.$rfc(Je)),Xt=Object.values(r.$yK);Je.assertRegistered(Xt);const yi=new c.$Qdc(Je,pt),sn=new m.$Vdc(Je),Ei=new te.$bfc(Je,Fe),zi=new O.$Qec(Je);return t.$Odc.register(bt),function(ze,ti,Ui){const $t=function(){let we=!ze.isUnderDevelopment;function De(){we||(Fe.info(`Extension '${ze.identifier.value}' uses a document selector without scheme. Learn more about this: https://go.microsoft.com/fwlink/?linkid=872305`),we=!0)}return function Ne(at){if(Array.isArray(at))at.forEach(Ne);else if(typeof at=="string")De();else{const yt=at;typeof yt.scheme>"u"&&De(),typeof yt.exclusive=="boolean"&&(0,tt.$MF)(ze,"documentFiltersExclusive")}return at}}(),fn={getSession(we,De,Ne){return ui.getSession(ze,we,De,Ne)},getSessions(we,De){return(0,tt.$MF)(ze,"authGetSessions"),ui.getSessions(ze,we,De)},async hasSession(we,De){return(0,tt.$MF)(ze,"authSession"),!!await ui.getSession(ze,we,De,{silent:!0})},get onDidChangeSessions(){return ui.onDidChangeSessions},registerAuthenticationProvider(we,De,Ne,at){return ui.registerAuthenticationProvider(we,De,Ne,at)}},gn={registerCommand(we,De,Ne){return bt.registerCommand(!0,we,De,Ne,void 0,ze)},registerTextEditorCommand(we,De,Ne){return bt.registerCommand(!0,we,(...at)=>{const yt=Ft.getActiveTextEditor();if(!yt){Fe.warn("Cannot execute "+we+" because there is no active text editor.");return}return yt.edit(Tt=>{De.apply(Ne,[yt,Tt,...at])}).then(Tt=>{Tt||Fe.warn("Edits from command "+we+" were not applied.")},Tt=>{Fe.warn("An error occurred while running command "+we,Tt)})},void 0,void 0,ze)},registerDiffInformationCommand:(we,De,Ne)=>((0,tt.$MF)(ze,"diffCommand"),bt.registerCommand(!0,we,async(...at)=>{const yt=pt.activeEditor(!0);if(!yt){Fe.warn("Cannot execute "+we+" because there is no active text editor.");return}const Tt=await Ft.getDiffInformation(yt.id);De.apply(Ne,[Tt,...at])},void 0,void 0,ze)),executeCommand(we,...De){return bt.executeCommand(we,...De)},getCommands(we=!1){return bt.getCommands(we)}},ki={get machineId(){return mt.telemetryInfo.machineId},get sessionId(){return mt.telemetryInfo.sessionId},get language(){return mt.environment.appLanguage},get appName(){return mt.environment.appName},get appRoot(){return mt.environment.appRoot?.fsPath??""},get appHost(){return mt.environment.appHost},get uriScheme(){return mt.environment.appUriScheme},get clipboard(){return sn.value},get shell(){return vt.getDefaultShell(!1)},get onDidChangeShell(){return vt.onDidChangeShell},get isTelemetryEnabled(){return St.getTelemetryConfiguration()},get onDidChangeTelemetryEnabled(){return St.onDidChangeTelemetryEnabled},get telemetryConfiguration(){return(0,tt.$MF)(ze,"telemetry"),St.getTelemetryDetails()},get onDidChangeTelemetryConfiguration(){return(0,tt.$MF)(ze,"telemetry"),St.onDidChangeTelemetryConfiguration},get isNewAppInstall(){return(0,ue.$SM)(mt.telemetryInfo.firstSessionDate)},createTelemetryLogger(we,De){return ue.$RM.validateSender(we),St.instantiateLogger(ze,we,De)},openExternal(we,De){return Te.openUri(we,{allowTunneling:!!mt.remote.authority,allowContributedOpeners:De?.allowContributedOpeners})},async asExternalUri(we){if(we.scheme===mt.environment.appUriScheme)return Si.createAppUri(we);try{return await Te.asExternalUri(we,{allowTunneling:!!mt.remote.authority})}catch(De){if((0,u.$OU)(we,M.Schemas.http)||(0,u.$OU)(we,M.Schemas.https))return we;throw De}},get remoteName(){return(0,o.$2k)(mt.remote.authority)},get remoteAuthority(){return(0,tt.$MF)(ze,"resolvers"),mt.remote.authority},get uiKind(){return mt.uiKind},get logLevel(){return Fe.getLevel()},get onDidChangeLogLevel(){return Fe.onDidChangeLogLevel},registerIssueUriRequestHandler(we){return(0,tt.$MF)(ze,"handleIssueUri"),_t.registerIssueUriRequestHandler(ze,we)},registerIssueDataProvider(we){return(0,tt.$MF)(ze,"handleIssueUri"),_t.registerIssueDataProvider(ze,we)},get appQuality(){return(0,tt.$MF)(ze,"resolvers"),mt.quality},get appCommit(){return(0,tt.$MF)(ze,"resolvers"),mt.commit}};mt.environment.extensionTestsLocationURI||Object.freeze(ki);const on={createTestController(we,De,Ne){return hi.createTestController(ze,we,De,Ne)},createTestObserver(){return(0,tt.$MF)(ze,"testObserver"),hi.createTestObserver()},runTests(we){return(0,tt.$MF)(ze,"testObserver"),hi.runTests(we)},get onDidChangeTestResults(){return(0,tt.$MF)(ze,"testObserver"),hi.onResultsChanged},get testResults(){return(0,tt.$MF)(ze,"testObserver"),hi.results}},fi=mt.remote.isRemote?Ue.ExtensionKind.Workspace:Ue.ExtensionKind.UI,an={getExtension(we,De){(0,tt.$LF)(ze,"extensionsAny")||(De=!1);const Ne=ti.mine.getExtensionDescription(we);if(Ne)return new oe.$Fec(At,ze.identifier,Ne,fi,!1);if(De){const at=ti.all.getExtensionDescription(we);if(at)return new oe.$Fec(At,ze.identifier,at,fi,!0)}},get all(){const we=[];for(const De of ti.mine.getAllExtensionDescriptions())we.push(new oe.$Fec(At,ze.identifier,De,fi,!1));return we},get allAcrossExtensionHosts(){(0,tt.$MF)(ze,"extensionsAny");const we=new y.$am(ti.mine.getAllExtensionDescriptions().map(Ne=>Ne.identifier)),De=[];for(const Ne of ti.all.getAllExtensionDescriptions()){const at=!we.has(Ne.identifier);De.push(new oe.$Fec(At,ze.identifier,Ne,fi,at))}return De},get onDidChange(){return(0,tt.$LF)(ze,"extensionsAny")?f.Event.any(ti.mine.onDidChange,ti.all.onDidChange):ti.mine.onDidChange}},mn={createDiagnosticCollection(we){return ai.createDiagnosticCollection(ze.identifier,we)},get onDidChangeDiagnostics(){return ai.onDidChangeDiagnostics},getDiagnostics:we=>ai.getDiagnostics(we),getLanguages(){return ci.getLanguages()},setTextDocumentLanguage(we,De){return ci.changeLanguage(we.uri,De)},match(we,De){const Ne=Ct.getDocumentData(De.uri)?.notebook;return(0,A.$KE)(wt.LanguageSelector.from(we),De.uri,De.languageId,!0,Ne?.uri,Ne?.notebookType)},registerCodeActionsProvider(we,De,Ne){return dt.registerCodeActionProvider(ze,$t(we),De,Ne)},registerDocumentPasteEditProvider(we,De,Ne){return(0,tt.$MF)(ze,"documentPaste"),dt.registerDocumentPasteEditProvider(ze,$t(we),De,Ne)},registerCodeLensProvider(we,De){return dt.registerCodeLensProvider(ze,$t(we),De)},registerDefinitionProvider(we,De){return dt.registerDefinitionProvider(ze,$t(we),De)},registerDeclarationProvider(we,De){return dt.registerDeclarationProvider(ze,$t(we),De)},registerImplementationProvider(we,De){return dt.registerImplementationProvider(ze,$t(we),De)},registerTypeDefinitionProvider(we,De){return dt.registerTypeDefinitionProvider(ze,$t(we),De)},registerHoverProvider(we,De){return dt.registerHoverProvider(ze,$t(we),De,ze.identifier)},registerEvaluatableExpressionProvider(we,De){return dt.registerEvaluatableExpressionProvider(ze,$t(we),De,ze.identifier)},registerInlineValuesProvider(we,De){return dt.registerInlineValuesProvider(ze,$t(we),De,ze.identifier)},registerDocumentHighlightProvider(we,De){return dt.registerDocumentHighlightProvider(ze,$t(we),De)},registerLinkedEditingRangeProvider(we,De){return dt.registerLinkedEditingRangeProvider(ze,$t(we),De)},registerReferenceProvider(we,De){return dt.registerReferenceProvider(ze,$t(we),De)},registerRenameProvider(we,De){return dt.registerRenameProvider(ze,$t(we),De)},registerDocumentSymbolProvider(we,De,Ne){return dt.registerDocumentSymbolProvider(ze,$t(we),De,Ne)},registerWorkspaceSymbolProvider(we){return dt.registerWorkspaceSymbolProvider(ze,we)},registerDocumentFormattingEditProvider(we,De){return dt.registerDocumentFormattingEditProvider(ze,$t(we),De)},registerDocumentRangeFormattingEditProvider(we,De){return dt.registerDocumentRangeFormattingEditProvider(ze,$t(we),De)},registerOnTypeFormattingEditProvider(we,De,Ne,...at){return dt.registerOnTypeFormattingEditProvider(ze,$t(we),De,[Ne].concat(at))},registerDocumentSemanticTokensProvider(we,De,Ne){return dt.registerDocumentSemanticTokensProvider(ze,$t(we),De,Ne)},registerDocumentRangeSemanticTokensProvider(we,De,Ne){return dt.registerDocumentRangeSemanticTokensProvider(ze,$t(we),De,Ne)},registerSignatureHelpProvider(we,De,Ne,...at){return typeof Ne=="object"?dt.registerSignatureHelpProvider(ze,$t(we),De,Ne):dt.registerSignatureHelpProvider(ze,$t(we),De,typeof Ne>"u"?[]:[Ne,...at])},registerCompletionItemProvider(we,De,...Ne){return dt.registerCompletionItemProvider(ze,$t(we),De,Ne)},registerInlineCompletionItemProvider(we,De,Ne){return De.handleDidShowCompletionItem&&(0,tt.$MF)(ze,"inlineCompletionsAdditions"),De.handleDidPartiallyAcceptCompletionItem&&(0,tt.$MF)(ze,"inlineCompletionsAdditions"),Ne&&(0,tt.$MF)(ze,"inlineCompletionsAdditions"),dt.registerInlineCompletionsProvider(ze,$t(we),De,Ne)},registerDocumentLinkProvider(we,De){return dt.registerDocumentLinkProvider(ze,$t(we),De)},registerColorProvider(we,De){return dt.registerColorProvider(ze,$t(we),De)},registerFoldingRangeProvider(we,De){return dt.registerFoldingRangeProvider(ze,$t(we),De)},registerSelectionRangeProvider(we,De){return dt.registerSelectionRangeProvider(ze,we,De)},registerCallHierarchyProvider(we,De){return dt.registerCallHierarchyProvider(ze,we,De)},registerTypeHierarchyProvider(we,De){return dt.registerTypeHierarchyProvider(ze,we,De)},setLanguageConfiguration:(we,De)=>dt.setLanguageConfiguration(ze,we,De),getTokenInformationAtPosition(we,De){return(0,tt.$MF)(ze,"tokenInformation"),ci.tokenAtPosition(we,De)},registerInlayHintsProvider(we,De){return dt.registerInlayHintsProvider(ze,we,De)},createLanguageStatusItem(we,De){return ci.createLanguageStatusItem(ze,we,De)},registerDocumentDropEditProvider(we,De,Ne){return dt.registerDocumentOnDropEditProvider(ze,we,De,(0,tt.$LF)(ze,"dropMetadata")?Ne:void 0)}},$n={get activeTextEditor(){return Ft.getActiveTextEditor()},get visibleTextEditors(){return Ft.getVisibleTextEditors()},get activeTerminal(){return vt.activeTerminal},get terminals(){return vt.terminals},async showTextDocument(we,De,Ne){const at=await(v.URI.isUri(we)?Promise.resolve(Bi.openTextDocument(we)):Promise.resolve(we));return Ft.showTextDocument(at,De,Ne)},createTextEditorDecorationType(we){return Ft.createTextEditorDecorationType(ze,we)},onDidChangeActiveTextEditor(we,De,Ne){return Ft.onDidChangeActiveTextEditor(we,De,Ne)},onDidChangeVisibleTextEditors(we,De,Ne){return Ft.onDidChangeVisibleTextEditors(we,De,Ne)},onDidChangeTextEditorSelection(we,De,Ne){return Ft.onDidChangeTextEditorSelection(we,De,Ne)},onDidChangeTextEditorOptions(we,De,Ne){return Ft.onDidChangeTextEditorOptions(we,De,Ne)},onDidChangeTextEditorVisibleRanges(we,De,Ne){return Ft.onDidChangeTextEditorVisibleRanges(we,De,Ne)},onDidChangeTextEditorViewColumn(we,De,Ne){return Ft.onDidChangeTextEditorViewColumn(we,De,Ne)},onDidCloseTerminal(we,De,Ne){return vt.onDidCloseTerminal(we,De,Ne)},onDidOpenTerminal(we,De,Ne){return vt.onDidOpenTerminal(we,De,Ne)},onDidChangeActiveTerminal(we,De,Ne){return vt.onDidChangeActiveTerminal(we,De,Ne)},onDidChangeTerminalDimensions(we,De,Ne){return(0,tt.$MF)(ze,"terminalDimensions"),vt.onDidChangeTerminalDimensions(we,De,Ne)},onDidChangeTerminalState(we,De,Ne){return vt.onDidChangeTerminalState(we,De,Ne)},onDidWriteTerminalData(we,De,Ne){return(0,tt.$MF)(ze,"terminalDataWriteEvent"),vt.onDidWriteTerminalData(we,De,Ne)},onDidExecuteTerminalCommand(we,De,Ne){return(0,tt.$MF)(ze,"terminalExecuteCommandEvent"),vt.onDidExecuteTerminalCommand(we,De,Ne)},get state(){return Te.getState(ze)},onDidChangeWindowState(we,De,Ne){return Te.onDidChangeWindowState(we,De,Ne)},showInformationMessage(we,...De){return Ei.showMessage(ze,b.default.Info,we,De[0],De.slice(1))},showWarningMessage(we,...De){return Ei.showMessage(ze,b.default.Warning,we,De[0],De.slice(1))},showErrorMessage(we,...De){return Ei.showMessage(ze,b.default.Error,we,De[0],De.slice(1))},showQuickPick(we,De,Ne){return ni.showQuickPick(ze,we,De,Ne)},showWorkspaceFolderPick(we){return ni.showWorkspaceFolderPick(we)},showInputBox(we,De){return ni.showInput(we,De)},showOpenDialog(we){return zi.showOpenDialog(ze,we)},showSaveDialog(we){return zi.showSaveDialog(we)},createStatusBarItem(we,De,Ne){let at,yt,Tt;return typeof we=="string"?(at=we,yt=De,Tt=Ne):(yt=we,Tt=De),di.createStatusBarEntry(ze,at,yt,Tt)},setStatusBarMessage(we,De){return di.setStatusBarMessage(we,De)},withScmProgress(we){return se.report("window.withScmProgress",ze,"Use 'withProgress' instead."),Li.withProgress(ze,{location:Ue.ProgressLocation.SourceControl},(De,Ne)=>we({report(at){}}))},withProgress(we,De){return Li.withProgress(ze,we,De)},createOutputChannel(we,De){return Yt.createOutputChannel(we,De,ze)},createWebviewPanel(we,De,Ne,at){return Ti.createWebviewPanel(ze,we,De,Ne,at)},createWebviewTextEditorInset(we,De,Ne,at){return(0,tt.$MF)(ze,"editorInsets"),Ii.createWebviewEditorInset(we,De,Ne,at,ze)},createTerminal(we,De,Ne){return typeof we=="object"?"pty"in we?vt.createExtensionTerminal(we):vt.createTerminalFromOptions(we):vt.createTerminal(we,De,Ne)},registerTerminalLinkProvider(we){return vt.registerLinkProvider(we)},registerTerminalProfileProvider(we,De){return vt.registerProfileProvider(ze,we,De)},registerTerminalQuickFixProvider(we,De){return(0,tt.$MF)(ze,"terminalQuickFixProvider"),vt.registerTerminalQuickFixProvider(we,ze.identifier.value,De)},registerTreeDataProvider(we,De){return $i.registerTreeDataProvider(we,De,ze)},createTreeView(we,De){return $i.createTreeView(we,De,ze)},registerWebviewPanelSerializer:(we,De)=>Ti.registerWebviewPanelSerializer(ze,we,De),registerCustomEditorProvider:(we,De,Ne={})=>Oi.registerCustomEditorProvider(ze,we,De,Ne),registerFileDecorationProvider(we){return ot.registerFileDecorationProvider(we,ze)},registerUriHandler(we){return Si.registerUriHandler(ze,we)},createQuickPick(){return ni.createQuickPick(ze)},createInputBox(){return ni.createInputBox(ze)},get activeColorTheme(){return Mi.activeColorTheme},onDidChangeActiveColorTheme(we,De,Ne){return Mi.onDidChangeActiveColorTheme(we,De,Ne)},registerWebviewViewProvider(we,De,Ne){return Ni.registerWebviewViewProvider(ze,we,De,Ne?.webviewOptions)},get activeNotebookEditor(){return kt.activeNotebookEditor},onDidChangeActiveNotebookEditor(we,De,Ne){return kt.onDidChangeActiveNotebookEditor(we,De,Ne)},get visibleNotebookEditors(){return kt.visibleNotebookEditors},get onDidChangeVisibleNotebookEditors(){return kt.onDidChangeVisibleNotebookEditors},onDidChangeNotebookEditorSelection(we,De,Ne){return mi.onDidChangeNotebookEditorSelection(we,De,Ne)},onDidChangeNotebookEditorVisibleRanges(we,De,Ne){return mi.onDidChangeNotebookEditorVisibleRanges(we,De,Ne)},showNotebookDocument(we,De){return kt.showNotebookDocument(we,De)},registerExternalUriOpener(we,De,Ne){return(0,tt.$MF)(ze,"externalUriOpener"),hn.registerExternalUriOpener(ze.identifier,we,De,Ne)},registerProfileContentHandler(we,De){return(0,tt.$MF)(ze,"profileContentHandlers"),en.registrProfileContentHandler(ze,we,De)},registerQuickDiffProvider(we,De,Ne,at){return(0,tt.$MF)(ze,"quickDiffProvider"),Yi.registerQuickDiffProvider($t(we),De,Ne,at)},get tabGroups(){return xe.tabGroups},registerShareProvider(we,De){return(0,tt.$MF)(ze,"shareProvider"),Ai.registerShareProvider($t(we),De)}},Bi={get rootPath(){return se.report("workspace.rootPath",ze,"Please use 'workspace.workspaceFolders' instead. More details: https://aka.ms/vscode-eliminating-rootpath"),gt.getPath()},set rootPath(we){throw new F.$8("rootPath")},getWorkspaceFolder(we){return gt.getWorkspaceFolder(we)},get workspaceFolders(){return gt.getWorkspaceFolders()},get name(){return gt.name},set name(we){throw new F.$8("name")},get workspaceFile(){return gt.workspaceFile},set workspaceFile(we){throw new F.$8("workspaceFile")},updateWorkspaceFolders:(we,De,...Ne)=>gt.updateWorkspaceFolders(ze,we,De||0,...Ne),onDidChangeWorkspaceFolders:function(we,De,Ne){return gt.onDidChangeWorkspace(we,De,Ne)},asRelativePath:(we,De)=>gt.getRelativePath(we,De),findFiles:(we,De,Ne,at)=>gt.findFiles(we,De,Ne,ze.identifier,at),findTextInFiles:(we,De,Ne,at)=>{(0,tt.$MF)(ze,"findTextInFiles");let yt,Tt;return typeof De=="object"?(yt=De,Tt=Ne):(yt={},Tt=De,at=Ne),gt.findTextInFiles(we,yt||{},Tt,ze.identifier,at)},save:we=>((0,tt.$MF)(ze,"saveEditor"),gt.save(we)),saveAs:we=>((0,tt.$MF)(ze,"saveEditor"),gt.saveAs(we)),saveAll:we=>gt.saveAll(we),applyEdit(we,De){return yi.applyWorkspaceEdit(we,ze,De)},createFileSystemWatcher:(we,De,Ne,at)=>{let yt;return typeof De=="boolean"?yt={ignoreCreateEvents:!!De,ignoreChangeEvents:!!Ne,ignoreDeleteEvents:!!at,correlate:!1}:De&&((0,tt.$MF)(ze,"createFileSystemWatcher"),yt={...De,correlate:!0}),xt.createFileSystemWatcher(gt,ze,we,yt)},get textDocuments(){return Ct.getAllDocumentData().map(we=>we.document)},set textDocuments(we){throw new F.$8("textDocuments")},openTextDocument(we){let De;const Ne=we;if(typeof we=="string")De=Promise.resolve(v.URI.file(we));else if(v.URI.isUri(we))De=Promise.resolve(we);else if(!Ne||typeof Ne=="object")De=Ct.createDocumentData(Ne);else throw new Error("illegal argument - uriOrFileNameOrOptions");return De.then(at=>Ct.ensureDocumentData(at).then(yt=>yt.document))},onDidOpenTextDocument:(we,De,Ne)=>Ct.onDidAddDocument(we,De,Ne),onDidCloseTextDocument:(we,De,Ne)=>Ct.onDidRemoveDocument(we,De,Ne),onDidChangeTextDocument:(we,De,Ne)=>Ct.onDidChangeDocument(we,De,Ne),onDidSaveTextDocument:(we,De,Ne)=>Ct.onDidSaveDocument(we,De,Ne),onWillSaveTextDocument:(we,De,Ne)=>ln.getOnWillSaveTextDocumentEvent(ze)(we,De,Ne),get notebookDocuments(){return kt.notebookDocuments.map(we=>we.apiNotebook)},async openNotebookDocument(we,De){let Ne;if(v.URI.isUri(we))Ne=we,await kt.openNotebookDocument(we);else if(typeof we=="string")Ne=v.URI.revive(await kt.createNotebookDocument({viewType:we,content:De}));else throw new Error("Invalid arguments");return kt.getNotebookDocument(Ne).apiNotebook},onDidSaveNotebookDocument(we,De,Ne){return gi.onDidSaveNotebookDocument(we,De,Ne)},onDidChangeNotebookDocument(we,De,Ne){return gi.onDidChangeNotebookDocument(we,De,Ne)},onWillSaveNotebookDocument(we,De,Ne){return Ci.getOnWillSaveNotebookDocumentEvent(ze)(we,De,Ne)},get onDidOpenNotebookDocument(){return kt.onDidOpenNotebookDocument},get onDidCloseNotebookDocument(){return kt.onDidCloseNotebookDocument},registerNotebookSerializer(we,De,Ne,at){return kt.registerNotebookSerializer(ze,we,De,Ne,(0,tt.$LF)(ze,"notebookLiveShare")?at:void 0)},onDidChangeConfiguration:(we,De,Ne)=>Ui.onDidChangeConfiguration(we,De,Ne),getConfiguration(we,De){return De=arguments.length===1?void 0:De,Ui.getConfiguration(we,De,ze)},registerTextDocumentContentProvider(we,De){return Zi.registerTextDocumentContentProvider(we,De)},registerTaskProvider:(we,De)=>(se.report("window.registerTaskProvider",ze,"Use the corresponding function on the 'tasks' namespace instead"),Qt.registerTaskProvider(ze,we,De)),registerFileSystemProvider(we,De,Ne){return(0,L.$Oc)(Pi.registerFileSystemProvider(ze,we,De,Ne),Pt.addFileSystemProvider(we,De,Ne))},get fs(){return Pt.value},registerFileSearchProvider:(we,De)=>((0,tt.$MF)(ze,"fileSearchProvider"),Lt.registerFileSearchProvider(we,De)),registerTextSearchProvider:(we,De)=>((0,tt.$MF)(ze,"textSearchProvider"),Lt.registerTextSearchProvider(we,De)),registerRemoteAuthorityResolver:(we,De)=>((0,tt.$MF)(ze,"resolvers"),At.registerRemoteAuthorityResolver(we,De)),registerResourceLabelFormatter:we=>((0,tt.$MF)(ze,"resolvers"),xi.$registerResourceLabelFormatter(we)),getRemoteExecServer:we=>((0,tt.$MF)(ze,"resolvers"),At.getRemoteExecServer(we)),onDidCreateFiles:(we,De,Ne)=>xt.onDidCreateFile(we,De,Ne),onDidDeleteFiles:(we,De,Ne)=>xt.onDidDeleteFile(we,De,Ne),onDidRenameFiles:(we,De,Ne)=>xt.onDidRenameFile(we,De,Ne),onWillCreateFiles:(we,De,Ne)=>xt.getOnWillCreateFileEvent(ze)(we,De,Ne),onWillDeleteFiles:(we,De,Ne)=>xt.getOnWillDeleteFileEvent(ze)(we,De,Ne),onWillRenameFiles:(we,De,Ne)=>xt.getOnWillRenameFileEvent(ze)(we,De,Ne),openTunnel:we=>((0,tt.$MF)(ze,"tunnels"),Ce.openTunnel(ze,we).then(De=>{if(!De)throw new Error("cannot open tunnel");return De})),get tunnels(){return(0,tt.$MF)(ze,"tunnels"),Ce.getTunnels()},onDidChangeTunnels:(we,De,Ne)=>((0,tt.$MF)(ze,"tunnels"),Ce.onDidChangeTunnels(we,De,Ne)),registerPortAttributesProvider:(we,De)=>((0,tt.$MF)(ze,"portsAttributes"),Ce.registerPortsAttributesProvider(we,De)),registerTunnelProvider:(we,De)=>((0,tt.$MF)(ze,"tunnelFactory"),Ce.registerTunnelProvider(we,De)),registerTimelineProvider:(we,De)=>((0,tt.$MF)(ze,"timeline"),_i.registerTimelineProvider(we,De,ze.identifier,bt.converter)),get isTrusted(){return gt.trusted},requestWorkspaceTrust:we=>((0,tt.$MF)(ze,"workspaceTrust"),gt.requestWorkspaceTrust(we)),onDidGrantWorkspaceTrust:(we,De,Ne)=>gt.onDidGrantWorkspaceTrust(we,De,Ne),registerEditSessionIdentityProvider:(we,De)=>((0,tt.$MF)(ze,"editSessionIdentityProvider"),gt.registerEditSessionIdentityProvider(we,De)),onWillCreateEditSessionIdentity:(we,De,Ne)=>((0,tt.$MF)(ze,"editSessionIdentityProvider"),gt.getOnWillCreateEditSessionIdentityEvent(ze)(we,De,Ne)),registerCanonicalUriProvider:(we,De)=>((0,tt.$MF)(ze,"canonicalUriProvider"),gt.registerCanonicalUriProvider(we,De)),getCanonicalUri:(we,De,Ne)=>((0,tt.$MF)(ze,"canonicalUriProvider"),gt.provideCanonicalUri(we,De,Ne))},cn={get inputBox(){return se.report("scm.inputBox",ze,"Use 'SourceControl.inputBox' instead"),bi.getLastInputBox(ze)},createSourceControl(we,De,Ne){return bi.createSourceControl(ze,we,De,Ne)}},Wi={createCommentController(we,De){return Ri.createCommentController(ze,we,De)}},Vi={get activeDebugSession(){return ht.activeDebugSession},get activeDebugConsole(){return ht.activeDebugConsole},get breakpoints(){return ht.breakpoints},get stackFrameFocus(){return ht.stackFrameFocus},onDidStartDebugSession(we,De,Ne){return ht.onDidStartDebugSession(we,De,Ne)},onDidTerminateDebugSession(we,De,Ne){return ht.onDidTerminateDebugSession(we,De,Ne)},onDidChangeActiveDebugSession(we,De,Ne){return ht.onDidChangeActiveDebugSession(we,De,Ne)},onDidReceiveDebugSessionCustomEvent(we,De,Ne){return ht.onDidReceiveDebugSessionCustomEvent(we,De,Ne)},onDidChangeBreakpoints(we,De,Ne){return ht.onDidChangeBreakpoints(we,De,Ne)},onDidChangeStackFrameFocus(we,De,Ne){return(0,tt.$MF)(ze,"debugFocus"),ht.onDidChangeStackFrameFocus(we,De,Ne)},registerDebugConfigurationProvider(we,De,Ne){return ht.registerDebugConfigurationProvider(we,De,Ne||Mt.DebugConfigurationProviderTriggerKind.Initial)},registerDebugAdapterDescriptorFactory(we,De){return ht.registerDebugAdapterDescriptorFactory(ze,we,De)},registerDebugAdapterTrackerFactory(we,De){return ht.registerDebugAdapterTrackerFactory(we,De)},startDebugging(we,De,Ne){return!Ne||typeof Ne=="object"&&"configuration"in Ne?ht.startDebugging(we,De,{parentSession:Ne}):ht.startDebugging(we,De,Ne||{})},stopDebugging(we){return ht.stopDebugging(we)},addBreakpoints(we){return ht.addBreakpoints(we)},removeBreakpoints(we){return ht.removeBreakpoints(we)},asDebugSourceUri(we,De){return ht.asDebugSourceUri(we,De)}},qi={registerTaskProvider:(we,De)=>Qt.registerTaskProvider(ze,we,De),fetchTasks:we=>Qt.fetchTasks(we),executeTask:we=>Qt.executeTask(ze,we),get taskExecutions(){return Qt.taskExecutions},onDidStartTask:(we,De,Ne)=>Qt.onDidStartTask(we,De,Ne),onDidEndTask:(we,De,Ne)=>Qt.onDidEndTask(we,De,Ne),onDidStartTaskProcess:(we,De,Ne)=>Qt.onDidStartTaskProcess(we,De,Ne),onDidEndTaskProcess:(we,De,Ne)=>Qt.onDidEndTaskProcess(we,De,Ne)},li={createNotebookController(we,De,Ne,at,yt){return oi.createNotebookController(ze,we,De,Ne,at,(0,tt.$LF)(ze,"notebookMessaging")?yt:void 0)},registerNotebookCellStatusBarItemProvider:(we,De)=>kt.registerNotebookCellStatusBarItemProvider(ze,we,De),createRendererMessaging(we){return Di.createRendererMessaging(ze,we)},createNotebookControllerDetectionTask(we){return(0,tt.$MF)(ze,"notebookKernelSource"),oi.createNotebookControllerDetectionTask(ze,we)},registerKernelSourceActionProvider(we,De){return(0,tt.$MF)(ze,"notebookKernelSource"),oi.registerKernelSourceActionProvider(ze,we,De)},onDidChangeNotebookCellExecutionState(we,De,Ne){return(0,tt.$MF)(ze,"notebookCellExecutionState"),oi.onDidChangeNotebookCellExecutionState(we,De,Ne)}},Ki={t(...we){if(typeof we[0]=="string"){const De=we.shift(),Ne=!we||typeof we[0]!="object"?we:we[0];return si.getMessage(ze.identifier.value,{message:De,args:Ne})}return si.getMessage(ze.identifier.value,we[0])},get bundle(){return si.getBundle(ze.identifier.value)},get uri(){return si.getBundleUri(ze.identifier.value)}},Hi={_version:1,registerInteractiveEditorSessionProvider(we,De){return(0,tt.$MF)(ze,"interactive"),ji.registerProvider(ze,we,De={label:De?.label??ze.displayName??ze.name})},registerInteractiveSessionProvider(we,De){return(0,tt.$MF)(ze,"interactive"),wi.registerChatProvider(ze,we,De)},sendInteractiveRequestToProvider(we,De){return(0,tt.$MF)(ze,"interactive"),wi.sendInteractiveRequestToProvider(we,De)},get onDidPerformUserAction(){return(0,tt.$MF)(ze,"interactiveUserActions"),wi.onDidPerformUserAction},transferChatSession(we,De){return(0,tt.$MF)(ze,"interactive"),wi.transferChatSession(we,De)}},Gi={getRelatedInformation(we,De){return(0,tt.$MF)(ze,"aiRelatedInformation"),vi.getRelatedInformation(ze,we,De)},registerRelatedInformationProvider(we,De){return(0,tt.$MF)(ze,"aiRelatedInformation"),vi.registerRelatedInformationProvider(ze,we,De)},registerEmbeddingVectorProvider(we,De){return(0,tt.$MF)(ze,"aiRelatedInformation"),rn.registerEmbeddingVectorProvider(ze,we,De)}},Ji={registerChatResponseProvider(we,De,Ne){return(0,tt.$MF)(ze,"chatProvider"),pi.registerProvider(ze.identifier,we,De,Ne)},requestChatAccess(we){return(0,tt.$MF)(ze,"chatRequestAccess"),pi.requestChatResponseProvider(ze.identifier,we)},registerVariable(we,De,Ne){return(0,tt.$MF)(ze,"chatVariables"),nn.registerVariableResolver(ze,we,De,Ne)},registerMappedEditsProvider(we,De){return(0,tt.$MF)(ze,"mappedEditsProvider"),dt.registerMappedEditsProvider(ze,we,De)},createChatAgent(we,De){return(0,tt.$MF)(ze,"chatAgents2"),tn.createChatAgent(ze,we,De)}},un={registerSpeechProvider(we,De){return(0,tt.$MF)(ze,"speech"),dn.registerProvider(ze.identifier,we,De)}};return{version:mt.version,ai:Gi,authentication:fn,commands:gn,comments:Wi,chat:Ji,debug:Vi,env:ki,extensions:an,interactive:Hi,l10n:Ki,languages:mn,notebooks:li,scm:cn,speech:un,tasks:qi,tests:on,window:$n,workspace:Bi,Breakpoint:Ue.$xL,TerminalOutputAnchor:Ue.TerminalOutputAnchor,ChatAgentResultFeedbackKind:Ue.ChatAgentResultFeedbackKind,ChatMessage:Ue.$oM,ChatMessageRole:Ue.ChatMessageRole,ChatVariableLevel:Ue.ChatVariableLevel,CallHierarchyIncomingCall:Ue.$WK,CallHierarchyItem:Ue.$VK,CallHierarchyOutgoingCall:Ue.$XK,CancellationError:F.$4,CancellationTokenSource:C.$2d,CandidatePortSource:r.CandidatePortSource,CodeAction:Ue.$SK,CodeActionKind:Ue.$TK,CodeActionTriggerKind:Ue.CodeActionTriggerKind,CodeLens:Ue.$YK,Color:Ue.$_K,ColorInformation:Ue.$aL,ColorPresentation:Ue.$bL,ColorThemeKind:Ue.ColorThemeKind,CommentMode:Ue.CommentMode,CommentState:Ue.CommentState,CommentThreadCollapsibleState:Ue.CommentThreadCollapsibleState,CommentThreadState:Ue.CommentThreadState,CompletionItem:Ue.$6K,CompletionItemKind:Ue.CompletionItemKind,CompletionItemTag:Ue.CompletionItemTag,CompletionList:Ue.$7K,CompletionTriggerKind:Ue.CompletionTriggerKind,ConfigurationTarget:Ue.ConfigurationTarget,CustomExecution:Ue.$jL,DebugAdapterExecutable:Ue.$BL,DebugAdapterInlineImplementation:Ue.$EL,DebugAdapterNamedPipeServer:Ue.$DL,DebugAdapterServer:Ue.$CL,DebugConfigurationProviderTriggerKind:Mt.DebugConfigurationProviderTriggerKind,DebugConsoleMode:Ue.DebugConsoleMode,DecorationRangeBehavior:Ue.DecorationRangeBehavior,Diagnostic:Ue.$NK,DiagnosticRelatedInformation:Ue.$MK,DiagnosticSeverity:Ue.DiagnosticSeverity,DiagnosticTag:Ue.DiagnosticTag,Disposable:Ue.$zK,DocumentHighlight:Ue.$PK,DocumentHighlightKind:Ue.DocumentHighlightKind,DocumentLink:Ue.$$K,DocumentSymbol:Ue.$RK,EndOfLine:Ue.EndOfLine,EnvironmentVariableMutatorType:Ue.EnvironmentVariableMutatorType,EvaluatableExpression:Ue.$HL,InlineValueText:Ue.$IL,InlineValueVariableLookup:Ue.$JL,InlineValueEvaluatableExpression:Ue.$KL,InlineCompletionTriggerKind:Ue.InlineCompletionTriggerKind,EventEmitter:f.$Rd,ExtensionKind:Ue.ExtensionKind,ExtensionMode:Ue.ExtensionMode,ExternalUriOpenerPriority:Ue.ExternalUriOpenerPriority,FileChangeType:Ue.FileChangeType,FileDecoration:Ue.$UL,FileDecoration2:Ue.$UL,FileSystemError:Ue.$ML,FileType:k.FileType,FilePermission:k.FilePermission,FoldingRange:Ue.$NL,FoldingRangeKind:Ue.FoldingRangeKind,FunctionBreakpoint:Ue.$zL,InlineCompletionItem:Ue.$8K,InlineCompletionList:Ue.$9K,Hover:Ue.$OK,IndentAction:I.IndentAction,Location:Ue.$LK,MarkdownString:Ue.$ZK,OverviewRulerLane:$.OverviewRulerLane,ParameterInformation:Ue.$1K,PortAutoForwardAction:Ue.PortAutoForwardAction,Position:Ue.$AK,ProcessExecution:Ue.$hL,ProgressLocation:Ue.ProgressLocation,QuickInputButtons:Ue.$TL,Range:Ue.$BK,RelativePattern:Ue.$vL,Selection:Ue.$CK,SelectionRange:Ue.$UK,SemanticTokens:Ue.$QL,SemanticTokensBuilder:Ue.$PL,SemanticTokensEdit:Ue.$RL,SemanticTokensEdits:Ue.$SL,SemanticTokensLegend:Ue.$OL,ShellExecution:Ue.$iL,ShellQuoting:Ue.ShellQuoting,SignatureHelp:Ue.$3K,SignatureHelpTriggerKind:Ue.SignatureHelpTriggerKind,SignatureInformation:Ue.$2K,SnippetString:Ue.$KK,SourceBreakpoint:Ue.$yL,StandardTokenType:Ue.StandardTokenType,StatusBarAlignment:Ue.StatusBarAlignment,SymbolInformation:Ue.$QK,SymbolKind:Ue.SymbolKind,SymbolTag:Ue.SymbolTag,Task:Ue.$kL,TaskGroup:Ue.$gL,TaskPanelKind:Ue.TaskPanelKind,TaskRevealKind:Ue.TaskRevealKind,TaskScope:Ue.TaskScope,TerminalLink:Ue.$cL,TerminalQuickFixExecuteTerminalCommand:Ue.$eL,TerminalQuickFixOpener:Ue.$dL,TerminalLocation:Ue.TerminalLocation,TerminalProfile:Ue.$fL,TerminalExitReason:Ue.TerminalExitReason,TextDocumentSaveReason:Ue.TextDocumentSaveReason,TextEdit:Ue.$GK,SnippetTextEdit:Ue.$IK,TextEditorCursorStyle:g.TextEditorCursorStyle,TextEditorLineNumbersStyle:Ue.TextEditorLineNumbersStyle,TextEditorRevealType:Ue.TextEditorRevealType,TextEditorSelectionChangeKind:Ue.TextEditorSelectionChangeKind,SyntaxTokenType:Ue.SyntaxTokenType,TextDocumentChangeReason:Ue.TextDocumentChangeReason,ThemeColor:Ue.$uL,ThemeIcon:Ue.$tL,TreeItem:Ue.$lL,TreeItemCheckboxState:Ue.TreeItemCheckboxState,TreeItemCollapsibleState:Ue.TreeItemCollapsibleState,TypeHierarchyItem:Ue.$dM,UIKind:Wt.UIKind,Uri:v.URI,ViewColumn:Ue.ViewColumn,WorkspaceEdit:Ue.$JK,DocumentDropEdit:Ue.$rL,DocumentPasteEdit:Ue.$sL,InlayHint:Ue.$5K,InlayHintLabelPart:Ue.$4K,InlayHintKind:Ue.InlayHintKind,RemoteAuthorityResolverError:Ue.$FK,ResolvedAuthority:Ue.$DK,ManagedResolvedAuthority:Ue.$EK,SourceControlInputBoxValidationType:Ue.SourceControlInputBoxValidationType,ExtensionRuntime:Ue.ExtensionRuntime,TimelineItem:Ue.$5L,NotebookRange:Ue.$WL,NotebookCellKind:Ue.NotebookCellKind,NotebookCellExecutionState:Ue.NotebookCellExecutionState,NotebookCellData:Ue.$XL,NotebookData:Ue.$YL,NotebookRendererScript:Ue.$3L,NotebookCellStatusBarAlignment:Ue.NotebookCellStatusBarAlignment,NotebookEditorRevealType:Ue.NotebookEditorRevealType,NotebookCellOutput:Ue.$1L,NotebookCellOutputItem:Ue.$ZL,NotebookCellStatusBarItem:Ue.$2L,NotebookControllerAffinity:Ue.NotebookControllerAffinity,NotebookControllerAffinity2:Ue.NotebookControllerAffinity2,NotebookEdit:Ue.$HK,NotebookKernelSourceAction:Ue.$4L,PortAttributes:Ue.$7L,LinkedEditingRanges:Ue.$6L,TestResultState:Ue.TestResultState,TestRunRequest:Ue.$8L,TestMessage:Ue.$9L,TestMessage2:Ue.$9L,TestTag:Ue.$0L,TestRunProfileKind:Ue.TestRunProfileKind,TextSearchCompleteMessageType:Vt.TextSearchCompleteMessageType,DataTransfer:Ue.$qL,DataTransferItem:Ue.$mL,CoveredCount:Ue.$$L,FileCoverage:Ue.$_L,StatementCoverage:Ue.$aM,BranchCoverage:Ue.$bM,FunctionCoverage:Ue.$cM,WorkspaceTrustState:Ue.WorkspaceTrustState,LanguageStatusSeverity:Ue.LanguageStatusSeverity,QuickPickItemKind:Ue.QuickPickItemKind,InputBoxValidationSeverity:Ue.InputBoxValidationSeverity,TabInputText:Ue.$eM,TabInputTextDiff:Ue.$fM,TabInputTextMerge:Ue.$gM,TabInputCustom:Ue.$hM,TabInputNotebook:Ue.$jM,TabInputNotebookDiff:Ue.$kM,TabInputWebview:Ue.$iM,TabInputTerminal:Ue.$lM,TabInputInteractiveWindow:Ue.$mM,TabInputChat:Ue.$nM,TelemetryTrustedValue:i.$po,LogLevel:w.LogLevel,EditSessionIdentityMatch:n.EditSessionIdentityMatch,InteractiveSessionVoteDirection:Ue.InteractiveSessionVoteDirection,InteractiveSessionCopyKind:Ue.InteractiveSessionCopyKind,InteractiveEditorResponseFeedbackKind:Ue.InteractiveEditorResponseFeedbackKind,StackFrameFocus:Ue.$FL,ThreadFocus:Ue.$GL,RelatedInformationType:Ue.RelatedInformationType,SpeechToTextStatus:Ue.SpeechToTextStatus}}}e.$Kfc=qt}),define(ke[370],Se([1,0,106,154,41,151,42,35,69,46,95,96,97,118,72,91,153,71,57,117,90,70,152,14,58,115,116]),function(me,e,C,F,f,L,M,b,v,g,A,I,$,y,k,w,u,o,i,n,r,a,t,s,d,c,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,C.$Cr)(c.$zec,c.$yec,1),(0,C.$Cr)(s.$ej,t.$Lfc,1),(0,C.$Cr)(w.$Kdc,w.$Ldc,1),(0,C.$Cr)(b.$VM,b.$UM,0),(0,C.$Cr)(M.$6dc,M.$4dc,0),(0,C.$Cr)(o.$8dc,o.$7dc,0),(0,C.$Cr)(I.$Jec,I.$Nec,0),(0,C.$Cr)(L.$Pec,L.$Oec,0),(0,C.$Cr)(v.$KM,v.$JM,0),(0,C.$Cr)(l.$Aec,l.$Bec,0),(0,C.$Cr)(i.$Hdc,i.$Gdc,0),(0,C.$Cr)(F.$jfc,F.$ifc,1),(0,C.$Cr)($.$6ec,$.$7ec,0),(0,C.$Cr)(y.$oec,y.$nec,0),(0,C.$Cr)(A.$wfc,A.$vfc,0),(0,C.$Cr)(g.$rec,g.$uec,0),(0,C.$Cr)(k.$Rwb,k.$Swb,0),(0,C.$Cr)(u.$Jfc,u.$Ifc,0),(0,C.$Cr)(f.$3dc,f.$2dc,0),(0,C.$Cr)(n.$wec,n.$vec,0),(0,C.$Cr)(r.$TM,r.$QM,0),(0,C.$Cr)(a.$fec,a.$gec,0),(0,C.$Cr)(d.$Hec,d.$Iec,0)}),define(ke[119],Se([1,0,19,14,36,94]),function(me,e,C,F,f,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4fc=e.$3fc=e.$2fc=void 0;function M(I){return I.startsWith("**")||I.startsWith("/")?I:`/${I}`}e.$2fc=M;function b(I,$,y,k){const w=(0,C.$1b)(y,v),u=new f.$1I($,w,k),o=u.preview.matches;return{ranges:(0,C.$1b)(w,g),uri:I,preview:{text:u.preview.text,matches:(0,C.$1b)(o,g)}}}e.$3fc=b;function v(I){return new f.$2I(I.start.line,I.start.character,I.end.line,I.end.character)}function g(I){return new L.$PI(I.startLineNumber,I.startColumn,I.endLineNumber,I.endColumn)}let A=class{constructor($,y){this.a=$,this.b=y}appendLine($){this.b.debug(`${this.a}#search`,$)}};e.$4fc=A,e.$4fc=A=He([Be(1,F.$dj)],A)}),define(ke[371],Se([1,0,50,16,76,33,11,13,119,372]),function(me,e,C,F,f,L,M,b,v,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7fc=e.$6fc=e.$5fc=void 0;const A=g.rgPath.replace(/\bnode_modules\.asar\b/,"node_modules.asar.unpacked");function I(n,r,a,t){const s=$(n,r,a,t),d=r.folder.fsPath;return{cmd:C.spawn(A,s.args,{cwd:d}),rgDiskPath:A,siblingClauses:s.siblingClauses,rgArgs:s,cwd:d}}e.$5fc=I;function $(n,r,a,t){const s=["--files","--hidden","--case-sensitive","--no-require-git"];k([r],a,!1).forEach(c=>{const l=(0,v.$2fc)(c);if(s.push("-g",l),M.$j){const h=(0,f.$vl)(l);h!==l&&s.push("-g",h)}});const d=y([r],t,void 0,!1);return d.globArgs.forEach(c=>{const l=`!${(0,v.$2fc)(c)}`;if(s.push("-g",l),M.$j){const h=(0,f.$vl)(l);h!==l&&s.push("-g",h)}}),r.disregardIgnoreFiles!==!1?s.push("--no-ignore"):r.disregardParentIgnoreFiles!==!1&&s.push("--no-ignore-parent"),r.ignoreSymlinks||s.push("--follow"),n.exists&&s.push("--quiet"),s.push("--no-config"),r.disregardGlobalIgnoreFiles&&s.push("--no-ignore-global"),{args:s,siblingClauses:d.siblingClauses}}function y(n,r,a,t=!0){const s=[];let d={};return n.forEach(c=>{const l=Object.assign({},c.excludePattern||{},r||{}),h=w(l,t?c.folder.fsPath:void 0,a);s.push(...h.globArgs),h.siblingClauses&&(d=Object.assign(d,h.siblingClauses))}),{globArgs:s,siblingClauses:d}}function k(n,r,a=!0){const t=[];return n.forEach(s=>{const d=Object.assign({},r||{},s.includePattern||{}),c=w(d,a?s.folder.fsPath:void 0);t.push(...c.globArgs)}),t}function w(n,r,a){const t=[],s={};return Object.keys(n).forEach(d=>{if(a&&a.has(d)||!d)return;const c=n[d];d=o(r?u(r,d):d),d.startsWith("\\\\")?d="\\\\"+d.substr(2).replace(/\\/g,"/"):d=d.replace(/\\/g,"/"),typeof c=="boolean"&&c?(d.startsWith("\\\\")&&(d+="**"),t.push(i(d))):c&&c.when&&(s[d]=c)}),{globArgs:t,siblingClauses:s}}function u(n,r){return F.$hc(r)?r:F.$ic(n,r)}e.$6fc=u;function o(n){return n=b.$Oe(n,"\\"),b.$Oe(n,"/")}function i(n){return L.$Xf(n).toLowerCase()==="c:/"?n.replace(/^c:[/\\]/i,"/"):n}e.$7fc=i}),define(ke[373],Se([1,0,50,55,16,374,19,43,34,76,33,11,38,13,18,30,36,371,130]),function(me,e,C,F,f,L,M,b,v,g,A,I,$,y,k,w,u,o,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9fc=e.$8fc=void 0;const n=new Set;process.on("exit",()=>{n.forEach(d=>d())});class r{constructor(c){this.c=null,this.h=null,this.l=!1,this.m=null,this.r=null,this.s=0,this.a=c,this.b=c.filePattern||"",this.d=c.includePattern&&v.$Cj(c.includePattern),this.f=c.maxResults||null,this.g=!!c.exists,this.v=Object.create(null),this.k=0,this.j=!1,this.o=0,this.p=0,this.q=[],this.b&&(this.c=(0,i.$Eq)(this.b).normalizedLowercase),this.u=c.excludePattern&&v.$Cj(c.excludePattern),this.t=new Map,c.folderQueries.forEach(l=>{const h=Object.assign({},l.excludePattern||{},this.a.excludePattern||{}),E=l.folder.fsPath;c.folderQueries.map(D=>D.folder.fsPath).filter(D=>D!==E).forEach(D=>{(0,A.$2f)(D,E)&&(h[f.$kc(E,D)]=!0)}),this.t.set(E,new t(h,E))})}cancel(){this.l=!0,n.forEach(c=>c())}walk(c,l,h,E,D){if(this.m=$.$Nd.create(!1),this.l)return D(null,this.j);l.forEach(m=>{const p=f.$mc(m.fsPath);this.u&&this.u(m.fsPath,p)||this.J(h,{relativePath:m.fsPath,searchPath:void 0})}),this.r=$.$Nd.create(!1),this.w(c,(m,p)=>{this.x(this.y,this,m,h,E,S=>{if(S){const P=(0,b.$Gi)(S);console.error(P),this.q.push(P),p(S,void 0)}else p(null,void 0)})},(m,p)=>{this.m.stop();const S=m?M.$Gb(m)[0]:null;D(S,this.j)})}w(c,l,h){const E=new Array(c.length),D=new Array(c.length);let m=!1,p=0;if(c.length===0)return h(null,[]);c.forEach((S,P)=>{l(S,(z,j)=>{if(z?(m=!0,E[P]=null,D[P]=z):(E[P]=j,D[P]=null),++p===c.length)return h(m?D:null,E)})})}x(c,l,...h){try{c.apply(l,h)}catch(E){h[h.length-1](E)}}y(c,l,h,E){const D=c.folder.fsPath,m=I.$j,p=()=>R&&R.kill();n.add(p);let S=W=>{n.delete(p),S=()=>{},E(W)},P="";const z=this.D(),j=(0,o.$5fc)(this.a,c,this.a.includePattern,this.t.get(c.folder.fsPath).expression),R=j.cmd,T=!Object.keys(j.siblingClauses).length,N=j.rgArgs.args.map(W=>W.match(/^-/)?W:`'${W}'`).join(" ");let O=`${j.rgDiskPath} ${N}
 - cwd: ${j.cwd}`;j.rgArgs.siblingClauses&&(O+=`
 - Sibling clauses: ${JSON.stringify(j.rgArgs.siblingClauses)}`),h({message:O}),this.s=0,this.z(R,"utf8",h,(W,x,le)=>{if(W){S(W);return}if(this.j){S();return}const J=(P+(m?g.$ul(x||""):x)).split(`
`);if(le){const Q=J.length;J[Q-1]=J[Q-1].trim(),J[Q-1]||J.pop()}else P=J.pop()||"";if(J.length&&J[0].indexOf(`
`)!==-1){S(new Error("Splitting up files failed"));return}if(this.s+=J.length,T){for(const Q of J)if(this.J(l,{base:D,relativePath:Q,searchPath:this.N(c,Q)}),this.j){p();break}(le||this.j)&&S();return}this.G(c,z,D,J,l),le&&(this.H(z,D,l),S())})}spawnFindCmd(c){const l=this.t.get(c.folder.fsPath),h=l.getBasenameTerms(),E=l.getPathTerms(),D=["-L","."];if(h.length||E.length){D.push("-not","(","(");for(const m of h)D.push("-name",m),D.push("-o");for(const m of E)D.push("-path",m),D.push("-o");D.pop(),D.push(")","-prune",")")}return D.push("-type","f"),C.spawn("find",D,{cwd:c.folder.fsPath})}readStdout(c,l,h){let E="";this.z(c,l,()=>{},(D,m,p)=>{if(D){h(D);return}E+=m,p&&h(null,E)})}z(c,l,h,E){let D=(S,P,z)=>{(S||z)&&(D=()=>{},this.r?.stop()),E(S,P,z)},m=!1;c.stdout?(this.A(c.stdout,l,D),c.stdout.once("data",()=>m=!0)):h({message:"stdout is null"});let p;c.stderr?p=this.B(c.stderr):h({message:"stderr is null"}),c.on("error",S=>{D(S)}),c.on("close",S=>{let P;!m&&(P=this.C(p,l))&&s(P)?D(new Error(`command failed with error code ${S}: ${this.C(p,l)}`)):(this.g&&S===0&&(this.j=!0),D(null,"",!0))})}A(c,l,h){const E=new L.StringDecoder(l);return c.on("data",D=>{h(null,E.write(D))}),E}B(c){const l=[];return c.on("data",h=>{l.push(h)}),l}C(c,l){const h=new L.StringDecoder(l);return c.map(E=>h.write(E)).join("")}D(){const c={rootEntries:[],pathToEntries:Object.create(null)};return c.pathToEntries["."]=c.rootEntries,c}G(c,{pathToEntries:l},h,E,D){E.indexOf(this.b)!==-1&&this.J(D,{base:h,relativePath:this.b,searchPath:this.N(c,this.b)});const m=p=>{const S=f.$mc(p),P=f.$lc(p);let z=l[P];z||(z=l[P]=[],m(P)),z.push({base:h,relativePath:p,basename:S,searchPath:this.N(c,p)})};E.forEach(m)}H({rootEntries:c,pathToEntries:l},h,E){const D=this,m=this.t.get(h),p=this.b;function S(P){D.o++;const z=(0,u.$eJ)(()=>P.map(j=>j.basename));for(let j=0,R=P.length;j<R;j++){const T=P[j],{relativePath:N,basename:O}=T;if(m.test(N,O,p!==O?z:void 0))continue;const W=l[N];if(W)S(W);else{if(D.p++,N===p)continue;D.J(E,T)}if(D.j)break}}S(c)}getStats(){return{cmdTime:this.r.elapsed(),fileWalkTime:this.m.elapsed(),directoriesWalked:this.o,filesWalked:this.p,cmdResultCount:this.s}}I(c,l,h,E,D){const m=c.folder,p=(0,u.$eJ)(()=>h);this.w(h,(S,P)=>{if(this.l||this.j)return P(null);const z=l?[l,S].join(f.sep):S;if(this.t.get(c.folder.fsPath).test(z,S,this.a.filePattern!==S?p:void 0))return P(null);const j=[m.fsPath,z].join(f.sep);F.lstat(j,(R,T)=>{if(R||this.l||this.j)return P(null);this.L(j,T,(N,O)=>N||this.l||this.j?P(null):O.isDirectory()?(this.o++,this.M(j,T,(W,x)=>W||this.l||this.j||(x=x||"",this.v[x])?P(null):(this.v[x]=!0,w.Promises.readdir(j).then(le=>{if(this.l||this.j)return P(null);this.I(c,z,le,E,G=>P(G||null))},le=>{P(null)})))):(this.p++,z===this.b||this.h&&k.$Gf(O.size)&&O.size>this.h||this.J(E,{base:m.fsPath,relativePath:z,searchPath:this.N(c,z)}),P(null,void 0)))})},S=>{const P=S&&M.$Gb(S);return D(P&&P.length>0?P[0]:void 0)})}J(c,l){this.K(l)&&(!this.d||this.d(l.relativePath,f.$mc(l.relativePath)))&&(this.k++,(this.g||this.f&&this.k>this.f)&&(this.j=!0),this.j||c(l))}K(c){if(this.b){if(this.b==="*")return!0;if(this.c)return(0,u.$_I)(c,this.c)}return!0}L(c,l,h){return l.isSymbolicLink()?F.stat(c,h):h(null,l)}M(c,l,h){return l.isSymbolicLink()?F.realpath(c,(E,D)=>E?h(E):h(null,D)):h(null,c)}N(c,l){return c.folderName?f.$ic(c.folderName,l):l}}e.$8fc=r;class a{constructor(c){this.a=c.folderQueries,this.b=c.extraFileResources||[],this.c=new r(c)}search(c,l,h){this.c.walk(this.a,this.b,c,l,(E,D)=>{h(E,{limitHit:D,stats:this.c.getStats(),messages:[]})})}cancel(){this.c.cancel()}}e.$9fc=a;class t{constructor(c,l){this.expression=c,this.c=l,this.d(c)}d(c){let l,h;Object.keys(c).filter(E=>c[E]).forEach(E=>{f.$hc(E)?(l=l||v.$xj(),l[E]=c[E]):(h=h||v.$xj(),h[E]=c[E])}),this.a=l&&v.$Cj(l,{trimForExclusions:!0}),this.b=h&&v.$Cj(h,{trimForExclusions:!0})}test(c,l,h){return this.b&&this.b(c,l,h)||this.a&&this.a(f.$ic(this.c,c),l,h)}getBasenameTerms(){const c=[];return this.a&&c.push(...v.$Ej(this.a)),this.b&&c.push(...v.$Ej(this.b)),c}getPathTerms(){const c=[];return this.a&&c.push(...v.$Fj(this.a)),this.b&&c.push(...v.$Fj(this.b)),c}}function s(d){const c=d.trim().split(`
`),l=c[0].trim();if(l.startsWith("Error parsing regex"))return l;if(l.startsWith("regex parse error"))return y.$uf(c[c.length-1].trim());if(l.startsWith("error parsing glob")||l.startsWith("unsupported encoding"))return l.charAt(0).toUpperCase()+l.substr(1);if(l==="Literal '\\n' not allowed.")return"Literal '\\n' currently not supported";if(l.startsWith("Literal "))return l}}),define(ke[375],Se([1,0,98,22,186,21]),function(me,e,C,F,f,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5C=e.$4C=e.$3C=e.$2C=e.$1C=e.$ZC=e.$YC=e.$XC=e.$WC=e.DecodeStreamErrorKind=e.$VC=e.$UC=e.$TC=e.$SC=e.$RC=e.$QC=e.$PC=e.$OC=void 0,e.$OC="utf8",e.$PC="utf8bom",e.$QC="utf16be",e.$RC="utf16le";function M(l){return[e.$OC,e.$PC,e.$QC,e.$RC].some(h=>h===l)}e.$SC=M,e.$TC=[254,255],e.$UC=[255,254],e.$VC=[239,187,191];const b=512,v=512,g=512*8,A=512*128;var I;(function(l){l[l.STREAM_IS_BINARY=1]="STREAM_IS_BINARY"})(I||(e.DecodeStreamErrorKind=I={}));class $ extends Error{constructor(h,E){super(h),this.decodeStreamErrorKind=E}}e.$WC=$;class y{static async create(h){let E;if(h!==e.$OC)E=(await(0,f.$NC)("@vscode/iconv-lite-umd","lib/iconv-lite-umd.js")).getDecoder(o(h));else{const D=new TextDecoder;E={write(m){return D.decode(m,{stream:!0})},end(){return D.decode()}}}return new y(E)}constructor(h){this.a=h}write(h){return this.a.write(h)}end(){return this.a.end()}}function k(l,h){const E=h.minBytesRequiredForDetection??h.guessEncoding?g:v;return new Promise((D,m)=>{const p=(0,C.$6d)(T=>T.join("")),S=[];let P=0,z;const j=new L.$2d,R=async()=>{try{const T=await c({buffer:F.$fe.concat(S),bytesRead:P},h.guessEncoding);if(T.seemsBinary&&h.acceptTextOnly)throw new $("Stream is binary but only text is accepted for decoding",1);T.encoding=await h.overwriteEncoding(T.encoding),z=await y.create(T.encoding);const N=z.write(F.$fe.concat(S).buffer);p.write(N),S.length=0,P=0,D({stream:p,detected:T})}catch(T){j.cancel(),p.destroy(),m(T)}};(0,C.$0d)(l,{onData:async T=>{z?p.write(z.write(T.buffer)):(S.push(T),P+=T.byteLength,P>=E&&(l.pause(),await R(),setTimeout(()=>l.resume())))},onError:T=>p.error(T),onEnd:async()=>{z||await R(),p.end(z?.end())}},j.token)})}e.$XC=k;async function w(l,h,E){const m=(await(0,f.$NC)("@vscode/iconv-lite-umd","lib/iconv-lite-umd.js")).getEncoder(o(h),E);let p=!1,S=!1;return{read(){if(S)return null;const P=l.read();if(typeof P!="string"){if(S=!0,!p&&E?.addBOM)switch(h){case e.$OC:case e.$PC:return F.$fe.wrap(Uint8Array.from(e.$VC));case e.$QC:return F.$fe.wrap(Uint8Array.from(e.$TC));case e.$RC:return F.$fe.wrap(Uint8Array.from(e.$UC))}const z=m.end();return z&&z.length>0?(p=!0,F.$fe.wrap(z)):null}return p=!0,F.$fe.wrap(m.write(P))}}}e.$YC=w;async function u(l){return(await(0,f.$NC)("@vscode/iconv-lite-umd","lib/iconv-lite-umd.js")).encodingExists(o(l))}e.$ZC=u;function o(l){return l===e.$PC||l===null?e.$OC:l}e.$1C=o;function i(l,h){if(!l||h<e.$TC.length)return null;const E=l.readUInt8(0),D=l.readUInt8(1);if(E===e.$TC[0]&&D===e.$TC[1])return e.$QC;if(E===e.$UC[0]&&D===e.$UC[1])return e.$RC;if(h<e.$VC.length)return null;const m=l.readUInt8(2);return E===e.$VC[0]&&D===e.$VC[1]&&m===e.$VC[2]?e.$PC:null}e.$2C=i;const n=["ascii","utf-16","utf-32"];async function r(l){const h=await(0,f.$NC)("jschardet","dist/jschardet.min.js"),E=l.slice(0,A),D=s(E.buffer),m=h.detect(D);if(!m||!m.encoding)return null;const p=m.encoding.toLowerCase();return 0<=n.indexOf(p)?null:t(m.encoding)}const a={ibm866:"cp866",big5:"cp950"};function t(l){const h=l.replace(/[^a-zA-Z0-9]/g,"").toLowerCase();return a[h]||h}function s(l){let h="";for(let E=0;E<l.length;E++)h+=String.fromCharCode(l[E]);return h}function d(l){switch(l){case"shiftjis":return"shift-jis";case"utf16le":return"utf-16le";case"utf16be":return"utf-16be";case"big5hkscs":return"big5-hkscs";case"eucjp":return"euc-jp";case"euckr":return"euc-kr";case"koi8r":return"koi8-r";case"koi8u":return"koi8-u";case"macroman":return"x-mac-roman";case"utf8bom":return"utf8";default:{const h=l.match(/windows(\d+)/);return h?"windows-"+h[1]:l}}}e.$3C=d;function c({buffer:l,bytesRead:h},E){let D=i(l,h),m=!1;if(D!==e.$QC&&D!==e.$RC&&l){let p=!0,S=!0,P=!1;for(let z=0;z<h&&z<b;z++){const j=z%2===1,R=l.readUInt8(z)===0;if(R&&(P=!0),p&&(j&&!R||!j&&R)&&(p=!1),S&&(j&&R||!j&&!R)&&(S=!1),R&&!p&&!S)break}P&&(p?D=e.$RC:S?D=e.$QC:m=!0)}return E&&!m&&!D&&l?r(l.slice(0,h)).then(p=>({seemsBinary:!1,encoding:p})):{seemsBinary:m,encoding:D}}e.$4C=c,e.$5C={utf8:{labelLong:"UTF-8",labelShort:"UTF-8",order:1,alias:"utf8bom"},utf8bom:{labelLong:"UTF-8 with BOM",labelShort:"UTF-8 with BOM",encodeOnly:!0,order:2,alias:"utf8"},utf16le:{labelLong:"UTF-16 LE",labelShort:"UTF-16 LE",order:3},utf16be:{labelLong:"UTF-16 BE",labelShort:"UTF-16 BE",order:4},windows1252:{labelLong:"Western (Windows 1252)",labelShort:"Windows 1252",order:5},iso88591:{labelLong:"Western (ISO 8859-1)",labelShort:"ISO 8859-1",order:6},iso88593:{labelLong:"Western (ISO 8859-3)",labelShort:"ISO 8859-3",order:7},iso885915:{labelLong:"Western (ISO 8859-15)",labelShort:"ISO 8859-15",order:8},macroman:{labelLong:"Western (Mac Roman)",labelShort:"Mac Roman",order:9},cp437:{labelLong:"DOS (CP 437)",labelShort:"CP437",order:10},windows1256:{labelLong:"Arabic (Windows 1256)",labelShort:"Windows 1256",order:11},iso88596:{labelLong:"Arabic (ISO 8859-6)",labelShort:"ISO 8859-6",order:12},windows1257:{labelLong:"Baltic (Windows 1257)",labelShort:"Windows 1257",order:13},iso88594:{labelLong:"Baltic (ISO 8859-4)",labelShort:"ISO 8859-4",order:14},iso885914:{labelLong:"Celtic (ISO 8859-14)",labelShort:"ISO 8859-14",order:15},windows1250:{labelLong:"Central European (Windows 1250)",labelShort:"Windows 1250",order:16},iso88592:{labelLong:"Central European (ISO 8859-2)",labelShort:"ISO 8859-2",order:17},cp852:{labelLong:"Central European (CP 852)",labelShort:"CP 852",order:18},windows1251:{labelLong:"Cyrillic (Windows 1251)",labelShort:"Windows 1251",order:19},cp866:{labelLong:"Cyrillic (CP 866)",labelShort:"CP 866",order:20},iso88595:{labelLong:"Cyrillic (ISO 8859-5)",labelShort:"ISO 8859-5",order:21},koi8r:{labelLong:"Cyrillic (KOI8-R)",labelShort:"KOI8-R",order:22},koi8u:{labelLong:"Cyrillic (KOI8-U)",labelShort:"KOI8-U",order:23},iso885913:{labelLong:"Estonian (ISO 8859-13)",labelShort:"ISO 8859-13",order:24},windows1253:{labelLong:"Greek (Windows 1253)",labelShort:"Windows 1253",order:25},iso88597:{labelLong:"Greek (ISO 8859-7)",labelShort:"ISO 8859-7",order:26},windows1255:{labelLong:"Hebrew (Windows 1255)",labelShort:"Windows 1255",order:27},iso88598:{labelLong:"Hebrew (ISO 8859-8)",labelShort:"ISO 8859-8",order:28},iso885910:{labelLong:"Nordic (ISO 8859-10)",labelShort:"ISO 8859-10",order:29},iso885916:{labelLong:"Romanian (ISO 8859-16)",labelShort:"ISO 8859-16",order:30},windows1254:{labelLong:"Turkish (Windows 1254)",labelShort:"Windows 1254",order:31},iso88599:{labelLong:"Turkish (ISO 8859-9)",labelShort:"ISO 8859-9",order:32},windows1258:{labelLong:"Vietnamese (Windows 1258)",labelShort:"Windows 1258",order:33},gbk:{labelLong:"Simplified Chinese (GBK)",labelShort:"GBK",order:34},gb18030:{labelLong:"Simplified Chinese (GB18030)",labelShort:"GB18030",order:35},cp950:{labelLong:"Traditional Chinese (Big5)",labelShort:"Big5",order:36},big5hkscs:{labelLong:"Traditional Chinese (Big5-HKSCS)",labelShort:"Big5-HKSCS",order:37},shiftjis:{labelLong:"Japanese (Shift JIS)",labelShort:"Shift JIS",order:38},eucjp:{labelLong:"Japanese (EUC-JP)",labelShort:"EUC-JP",order:39},euckr:{labelLong:"Korean (EUC-KR)",labelShort:"EUC-KR",order:40},windows874:{labelLong:"Thai (Windows 874)",labelShort:"Windows 874",order:41},iso885911:{labelLong:"Latin/Thai (ISO 8859-11)",labelShort:"ISO 8859-11",order:42},koi8ru:{labelLong:"Cyrillic (KOI8-RU)",labelShort:"KOI8-RU",order:43},koi8t:{labelLong:"Tajik (KOI8-T)",labelShort:"KOI8-T",order:44},gb2312:{labelLong:"Simplified Chinese (GB 2312)",labelShort:"GB 2312",order:45},cp865:{labelLong:"Nordic DOS (CP 865)",labelShort:"CP 865",order:46},cp850:{labelLong:"Western European DOS (CP 850)",labelShort:"CP 850",order:47}}}),define(ke[157],Se([1,0,375,30,156]),function(me,e,C,F,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$egc=void 0;class L extends f.$2ec{constructor(b,v,g=F,A="searchProcess"){super(b,v,{readdir:I=>g.Promises.readdir(I.fsPath),toCanonicalName:I=>(0,C.$3C)(I)},A)}}e.$egc=L}),define(ke[158],Se([1,0,50,391,374,19,73,34,16,13,2,36,94,392,372,119]),function(me,e,C,F,f,L,M,b,v,g,A,I,$,y,k,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dgc=e.$cgc=e.$bgc=e.$agc=e.$_fc=e.$$fc=e.$0fc=void 0;const u=k.rgPath.replace(/\bnode_modules\.asar\b/,"node_modules.asar.unpacked");class o{constructor(S){this.a=S}provideTextSearchResults(S,P,z,j){return this.a.appendLine(`provideTextSearchResults ${S.pattern}, ${JSON.stringify({...P,folder:P.folder.toString()})}`),new Promise((R,T)=>{j.onCancellationRequested(()=>Q());const N=s(S,P),O=P.folder.fsPath,W=N.map(q=>q.match(/^-/)?q:`'${q}'`).join(" ");this.a.appendLine(`${u} ${W}
 - cwd: ${O}`);let x=C.spawn(u,N,{cwd:O});x.on("error",q=>{console.error(q),this.a.appendLine("Error: "+(q&&q.message)),T((0,I.$8I)(new I.$6I(q&&q.message,I.SearchErrorCode.rgProcessError)))});let le=!1;const G=new r(P.maxResults,O,P.previewOptions);G.on("result",q=>{le=!0,_="",z.report(q)});let J=!1;const Q=()=>{J=!0,x?.kill(),G?.cancel()};let oe=!1;G.on("hitLimit",()=>{oe=!0,Q()});let _="";x.stdout.on("data",q=>{G.handleData(q),le||(_+=q)});let Ee=!1;x.stdout.once("data",()=>Ee=!0);let he="";x.stderr.on("data",q=>{const U=q.toString();this.a.appendLine(U),he.length+U.length<1e6&&(he+=U)}),x.on("close",()=>{if(this.a.appendLine(Ee?"Got data from stdout":"No data from stdout"),this.a.appendLine(le?"Got result from parser":"No result from parser"),_&&this.a.appendLine(`Got data without result: ${_}`),this.a.appendLine(""),J)R({limitHit:oe});else{G.flush(),x=null;let q;he&&!Ee&&(q=i(he))?T((0,I.$8I)(new I.$6I(q.message,q.code))):R({limitHit:oe})}})})}}e.$0fc=o;function i(p){const S=p.split(`
`),P=S[0].trim();if(S.some(j=>j.startsWith("regex parse error")))return new I.$6I(n(S),I.SearchErrorCode.regexParseError);const z=P.match(/grep config error: unknown encoding: (.*)/);if(z)return new I.$6I(`Unknown encoding: ${z[1]}`,I.SearchErrorCode.unknownEncoding);if(P.startsWith("error parsing glob"))return new I.$6I(P.charAt(0).toUpperCase()+P.substr(1),I.SearchErrorCode.globParseError);if(P.startsWith("the literal"))return new I.$6I(P.charAt(0).toUpperCase()+P.substr(1),I.SearchErrorCode.invalidLiteral);if(P.startsWith("PCRE2: error compiling pattern"))return new I.$6I(P,I.SearchErrorCode.regexParseError)}function n(p){const S=["Regex parse error"],P=p.filter(z=>z.startsWith("PCRE2:"));if(P.length>=1){const z=P[0].replace("PCRE2:","");if(z.indexOf(":")!==-1&&z.split(":").length>=2){const j=z.split(":")[1];S.push(":"+j)}}return S.join("")}class r extends F.EventEmitter{constructor(S,P,z){super(),this.g=S,this.h=P,this.j=z,this.a="",this.b=!1,this.c=!1,this.f=0,this.d=new f.StringDecoder}cancel(){this.b=!0}flush(){this.k(this.d.end())}on(S,P){return super.on(S,P),this}handleData(S){if(this.b)return;const P=typeof S=="string"?S:this.d.write(S);this.k(P)}k(S){let P=S.indexOf(`
`);const z=this.a+S;if(P>=0)P+=this.a.length;else{this.a=z;return}let j=0;for(;P>=0;)this.m(z.substring(j,P).trim()),j=P+1,P=z.indexOf(`
`,j);this.a=z.substring(j)}m(S){if(this.b||!S)return;let P;try{P=JSON.parse(S)}catch{throw new Error(`malformed line from rg: ${S}`)}if(P.type==="match"){const z=a(P.data.path),j=A.URI.file(v.$ic(this.h,z)),R=this.n(P.data,j);this.p(R),this.c&&(this.cancel(),this.emit("hitLimit"))}else if(P.type==="context"){const z=a(P.data.path),j=A.URI.file(v.$ic(this.h,z));this.o(P.data,j).forEach(T=>this.p(T))}}n(S,P){const z=S.line_number-1,j=a(S.lines),R=Buffer.from(j);let T=0,N=0,O=z;S.submatches.length===0&&S.submatches.push(j.length?{start:0,end:1,match:{text:j[0]}}:{start:0,end:0,match:{text:""}});const W=(0,L.$Gb)(S.submatches.map((x,le)=>{if(this.c)return null;this.f++,this.f>=this.g&&(this.c=!0);const G=a(x.match),J=R.slice(T,x.start).toString(),Q=t(J),oe=Q.numLines>0?Q.lastLineLength:Q.lastLineLength+N,_=t(G),Ee=Q.numLines+O,he=_.numLines+Ee,q=_.numLines>0?_.lastLineLength:_.lastLineLength+oe;return T=x.end,N=q,O=he,new $.$PI(Ee,oe,he,q)}));return(0,w.$3fc)(P,j,W,this.j)}o(S,P){const z=a(S.lines),j=S.line_number;return z.replace(/\r?\n$/,"").split(`
`).map((R,T)=>({text:R,uri:P,lineNumber:j+T}))}p(S){this.emit("result",S)}}e.$$fc=r;function a(p){return p.bytes?Buffer.from(p.bytes,"base64").toString():p.text}function t(p){const S=/\n/g;let P=0,z=-1,j;for(;j=S.exec(p);)P++,z=j.index;const R=z>=0?p.length-z-1:p.length;return{numLines:P,lastLineLength:R}}function s(p,S){const P=["--hidden","--no-require-git"];P.push(p.isCaseSensitive?"--case-sensitive":"--ignore-case");const{doubleStarIncludes:z,otherIncludes:j}=(0,M.$J)(S.includes,T=>T.startsWith("**")?"doubleStarIncludes":"otherIncludes");if(j&&j.length){const T=new Set;j.forEach(N=>{T.add(N)}),P.push("-g","!*"),T.forEach(N=>{d(N).map(w.$2fc).forEach(O=>{P.push("-g",O)})})}z&&z.length&&z.forEach(T=>{P.push("-g",T)}),S.excludes.map(w.$2fc).forEach(T=>P.push("-g",`!${T}`)),S.maxFileSize&&P.push("--max-filesize",S.maxFileSize+""),S.useIgnoreFiles?S.useParentIgnoreFiles||P.push("--no-ignore-parent"):P.push("--no-ignore"),S.followSymlinks&&P.push("--follow"),S.encoding&&S.encoding!=="utf8"&&P.push("--encoding",S.encoding),p.pattern==="--"&&(p.isRegExp=!0,p.pattern="\\-\\-"),p.isMultiline&&!p.isRegExp&&(p.pattern=(0,g.$Je)(p.pattern),p.isRegExp=!0),S.usePCRE2&&P.push("--pcre2"),P.push("--crlf"),p.isRegExp&&(p.pattern=c(p.pattern),P.push("--engine","auto"));let R;if(p.isWordMatch){const N=(0,g.$Re)(p.pattern,!!p.isRegExp,{wholeWord:p.isWordMatch}).source.replace(/\\\//g,"/");P.push("--regexp",N)}else if(p.isRegExp){let T=h(p.pattern);T=E(T),P.push("--regexp",T)}else R=p.pattern,P.push("--fixed-strings");return P.push("--no-config"),S.useGlobalIgnoreFiles||P.push("--no-ignore-global"),P.push("--json"),p.isMultiline&&P.push("--multiline"),S.beforeContext&&P.push("--before-context",S.beforeContext+""),S.afterContext&&P.push("--after-context",S.afterContext+""),P.push("--"),R&&P.push(R),P.push("."),P}e.$_fc=s;function d(p){return m(p).flatMap(P=>{const z=(0,b.$Aj)(P,"/");return z.map((j,R)=>z.slice(0,R+1).join("/"))})}function c(p){const S=/((?:[^\\]|^)(?:\\\\)*)\\u([a-z0-9]{4})/gi;for(;p.match(S);)p=p.replace(S,"$1\\x{$2}");const P=/((?:[^\\]|^)(?:\\\\)*)\\u\{([a-z0-9]{4})\}/gi;for(;p.match(P);)p=p.replace(P,"$1\\x{$2}");return p}e.$agc=c;const l=p=>p.type==="Assertion"&&p.kind==="lookbehind";function h(p){let S;try{S=new y.RegExpParser().parsePattern(p)}catch{return p}let P="",z=0;const j=(N,O,W)=>{P+=p.slice(z,N)+W,z=O},R=[];return new y.RegExpVisitor({onCharacterEnter(N){if(N.raw!=="\\n")return;const O=R[0];if(!O)j(N.start,N.end,"\\r?\\n");else if(!R.some(l))if(O.type==="CharacterClass")if(O.negate){const W=p.slice(O.start+2,N.start)+p.slice(N.end,O.end-1);O.parent?.type==="Quantifier"?j(O.start,O.end,W?`[^${W}]`:"."):j(O.start,O.end,"(?!\\r?\\n"+(W?`|[${W}]`:"")+")")}else{const W=p.slice(O.start+1,N.start)+p.slice(N.end,O.end-1);j(O.start,O.end,W===""?"\\r?\\n":`(?:[${W}]|\\r?\\n)`)}else O.type==="Quantifier"&&j(N.start,N.end,"(?:\\r?\\n)")},onQuantifierEnter(N){R.unshift(N)},onQuantifierLeave(){R.shift()},onCharacterClassRangeEnter(N){R.unshift(N)},onCharacterClassRangeLeave(){R.shift()},onCharacterClassEnter(N){R.unshift(N)},onCharacterClassLeave(){R.shift()},onAssertionEnter(N){l(N)&&R.push(N)},onAssertionLeave(N){R[0]===N&&R.shift()}}).visit(S),P+=p.slice(z),P}e.$bgc=h;function E(p){return p.replace(/\n/g,"\\r?\\n")}e.$cgc=E;function D(p){let S=!1,P=!1,z="",j="";for(let R=0;R<p.length;R++){const T=p[R];switch(T){case"\\":P?(S?j+="\\"+T:z+="\\"+T,P=!1):P=!0;break;case"{":if(P)S?j+=T:z+=T,P=!1;else{if(S)return{strInBraces:z+"{"+j+"{"+p.substring(R+1)};S=!0}break;case"}":if(P)S?j+=T:z+=T,P=!1;else{if(S)return{fixedStart:z,strInBraces:j,fixedEnd:p.substring(R+1)};z+=T}break;default:S?j+=(P?"\\":"")+T:z+=(P?"\\":"")+T,P=!1;break}}return{strInBraces:z+(S?"{"+j:"")}}function m(p){const{fixedStart:S,strInBraces:P,fixedEnd:z}=D(p);if(S===void 0||z===void 0)return[P];let j=(0,b.$Aj)(P,",");j.length||(j=[""]);const R=m(z);return j.flatMap(T=>{const N=S+T;return R.map(O=>N+O)})}e.$dgc=m}),define(ke[376],Se([1,0,21,158,85,17]),function(me,e,C,F,f,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hgc=void 0;class M{constructor(g){this.b=g,this.a=new Set,process.once("exit",()=>this.d())}provideTextSearchResults(g,A,I,$){const y=new F.$0fc(this.b);if(A.folder.scheme===L.Schemas.vscodeUserData){const k={...A,folder:A.folder.with({scheme:L.Schemas.file})},w=new f.$$u(u=>I.report({...u,uri:u.uri.with({scheme:A.folder.scheme})}));return this.c($,u=>y.provideTextSearchResults(g,k,w,u))}else return this.c($,k=>y.provideTextSearchResults(g,A,I,k))}async c(g,A){const I=b(g);this.a.add(I);const $=await A(I.token);return this.a.delete(I),$}d(){this.a.forEach(g=>g.cancel())}}e.$hgc=M;function b(v){const g=new C.$2d;return v.onCancellationRequested(()=>g.cancel()),g}}),define(ke[377],Se([1,0,30,158,157]),function(me,e,C,F,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fgc=void 0;class L{constructor(v){this.a=v}search(v,g,A){if((!this.a.folderQueries||!this.a.folderQueries.length)&&(!this.a.extraFileResources||!this.a.extraFileResources.length))return Promise.resolve({type:"success",limitHit:!1,stats:{type:"searchProcess"}});const I={appendLine(y){A({message:y})}},$=new f.$egc(this.a,new F.$0fc(I),C);return new Promise((y,k)=>$.search(w=>{g(w.map(M))},v).then(w=>y({limitHit:w.limitHit,type:"success",stats:w.stats}),k))}}e.$fgc=L;function M(b){return{path:b.resource&&b.resource.fsPath,results:b.results,numMatches:(b.results||[]).reduce((v,g)=>{if(g.ranges){const A=g;return v+(Array.isArray(A.ranges)?A.ranges.length:1)}else return v+1},0)}}}),define(ke[378],Se([1,0,19,12,8,4,130,16,38,2,31,36,373,377]),function(me,e,C,F,f,L,M,b,v,g,A,I,$,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ggc=void 0;class k{static{this.a=512}constructor(r="searchProcess"){this.d=r,this.b=Object.create(null)}fileSearch(r){let a;const t=o(r),s=new L.$Rd({onDidAddFirstListener:()=>{a=(0,F.$Lg)(d=>this.doFileSearchWithEngine($.$9fc,t,c=>s.fire(c),d)),a.then(d=>s.fire(d),d=>s.fire({type:"error",error:{message:d.message,stack:d.stack}}))},onDidRemoveLastListener:()=>{a.cancel()}});return s.event}textSearch(r){let a;const t=o(r),s=new L.$Rd({onDidAddFirstListener:()=>{a=(0,F.$Lg)(d=>this.f(t,c=>s.fire(c),d)),a.then(d=>s.fire(d),d=>s.fire({type:"error",error:{message:d.message,stack:d.stack}}))},onDidRemoveLastListener:()=>{a.cancel()}});return s.event}f(r,a,t){return r.maxFileSize=this.g().maxFileSize,new y.$fgc(r).search(t,a,a)}g(){return{maxFileSize:16*A.$Mk.GB}}doFileSearch(r,a,t){return this.doFileSearchWithEngine($.$9fc,r,a,t)}doFileSearchWithEngine(r,a,t,s,d=k.a){let c=0;const l=E=>{Array.isArray(E)?(c+=E.length,t(E.map(D=>this.h(D)))):E.relativePath?(c++,t(this.h(E))):t(E)};if(a.sortByScore){let E=this.l(a,l,s);if(!E){const D=a.maxResults?Object.assign({},a,{maxResults:null}):a,m=new r(D);E=this.j(m,a,t,l,s)}return new Promise((D,m)=>{E.then(([p,S])=>{const P=S.map(z=>this.h(z));this.o(P,t,d),D(p)},m)})}const h=new r(a);return this.r(h,l,d,s).then(E=>({limitHit:E.limitHit,type:"success",stats:{detailStats:E.stats,type:this.d,fromCache:!1,resultCount:c,sortingTime:void 0}}))}h(r){return{path:r.base?(0,b.$ic)(r.base,r.relativePath):r.relativePath}}j(r,a,t,s,d){const c=new L.$Rd;let l=(0,F.$Lg)(E=>{let D=[];const m=p=>{Array.isArray(p)?D=p:(s(p),c.fire(p))};return this.r(r,m,-1,E).then(p=>[p,D])}),h;if(a.cacheKey){h=this.k(a.cacheKey);const E={promise:l,event:c.event,resolved:!1};h.resultsToSearchCache[a.filePattern||""]=E,l.then(()=>{E.resolved=!0},D=>{delete h.resultsToSearchCache[a.filePattern||""]}),l=this.s(l)}return l.then(([E,D])=>{const m=h?h.scorerCache:Object.create(null),p=(typeof a.maxResults!="number"||a.maxResults>0)&&v.$Nd.create(!1);return this.n(a,D,m,d).then(S=>{const P=p?p.elapsed():-1;return[{type:"success",stats:{detailStats:E.stats,sortingTime:P,fromCache:!1,type:this.d,workspaceFolderCount:a.folderQueries.length,resultCount:S.length},messages:E.messages,limitHit:E.limitHit||typeof a.maxResults=="number"&&D.length>a.maxResults},S]})})}k(r){const a=this.b[r];return a||(this.b[r]=new w)}l(r,a,t){const s=r.cacheKey&&this.b[r.cacheKey];if(!s)return;const d=this.q(s,r.filePattern||"",a,t);if(d)return d.then(([c,l,h])=>{const E=v.$Nd.create(!1);return this.n(r,l,s.scorerCache,t).then(D=>{const m=E.elapsed(),p={fromCache:!0,detailStats:h,type:this.d,resultCount:l.length,sortingTime:m};return[{type:"success",limitHit:c.limitHit||typeof r.maxResults=="number"&&l.length>r.maxResults,stats:p},D]})})}n(r,a,t,s){const d=(0,M.$Eq)(r.filePattern||""),c=(h,E)=>(0,M.$Dq)(h,E,d,!0,u,t),l=typeof r.maxResults=="number"?r.maxResults:Number.MAX_VALUE;return C.$Fb(a,c,l,1e4,s)}o(r,a,t){if(t&&t>0)for(let s=0;s<r.length;s+=t)a(r.slice(s,s+t));else a(r)}q(r,a,t,s){const d=v.$Nd.create(!1),c=a.indexOf(b.sep)>=0;let l;for(const m in r.resultsToSearchCache)if(a.startsWith(m)){if(c&&m.indexOf(b.sep)<0&&m!=="")continue;const p=r.resultsToSearchCache[m];l={promise:this.s(p.promise),event:p.event,resolved:p.resolved};break}if(!l)return null;const h=d.elapsed(),E=v.$Nd.create(!1),D=l.event(t);return s&&s.onCancellationRequested(()=>{D.dispose()}),l.promise.then(([m,p])=>{if(s&&s.isCancellationRequested)throw(0,f.$5)();const S=[],P=(0,M.$Eq)(a).normalizedLowercase;for(const z of p)(0,I.$_I)(z,P)&&S.push(z);return[m,S,{cacheWasResolved:l.resolved,cacheLookupTime:h,cacheFilterTime:E.elapsed(),cacheEntryCount:p.length}]})}r(r,a,t,s){return new Promise((d,c)=>{let l=[];s?.onCancellationRequested(()=>r.cancel()),r.search(h=>{h&&(t?(l.push(h),t>0&&l.length>=t&&(a(l),l=[])):a(h))},h=>{a(h)},(h,E)=>{l.length&&a(l),h?c(h):d(E)})})}clearCache(r){return delete this.b[r],Promise.resolve(void 0)}s(r){return new class{get[Symbol.toStringTag](){return this.toString()}cancel(){}then(a,t){return r.then(a,t)}catch(a){return this.then(void 0,a)}finally(a){return r.finally(a)}}}}e.$ggc=k;class w{constructor(){this.resultsToSearchCache=Object.create(null),this.scorerCache=Object.create(null)}}const u=new class{getItemLabel(n){return(0,b.$mc)(n.relativePath)}getItemDescription(n){return(0,b.$lc)(n.relativePath)}getItemPath(n){return n.relativePath}};function o(n){return{...n,folderQueries:n.folderQueries&&n.folderQueries.map(i),extraFileResources:n.extraFileResources&&n.extraFileResources.map(r=>g.URI.revive(r))}}function i(n){return{...n,folder:g.URI.revive(n.folder)}}}),define(ke[379],Se([1,0,3,17,2,30,14,27,20,97,66,36,378,376,119,157]),function(me,e,C,F,f,L,M,b,v,g,A,I,$,y,k,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$igc=void 0;let u=class extends g.$7ec{constructor(i,n,r,a){super(i,r,a),this.s=L,this.t=-1,this.v=null,this.w=!1,this.x=new C.$Qc;const t=new k.$4fc("RipgrepSearchUD",this.n);this.x.add(this.registerTextSearchProvider(F.Schemas.vscodeUserData,new y.$hgc(t))),n.remote.isRemote&&n.remote.authority&&this.y()}dispose(){this.x.dispose()}$enableExtensionHostSearch(){this.y()}y(){if(this.w)return;this.w=!0;const i=new k.$4fc("RipgrepSearchEH",this.n);this.x.add(this.registerTextSearchProvider(F.Schemas.file,new y.$hgc(i))),this.x.add(this.z(F.Schemas.file,new $.$ggc("fileSearchProvider")))}z(i,n){const r=this.d++;return this.v=n,this.t=r,this.c.$registerFileSearchProvider(r,this.o(i)),(0,C.$Pc)(()=>{this.v=null,this.c.$unregisterProvider(r)})}$provideFileSearchResults(i,n,r,a){const t=(0,g.$8ec)(r);return i===this.t?this.A(i,n,t,a):super.$provideFileSearchResults(i,n,r,a)}doInternalFileSearchWithCustomCallback(i,n,r){const a=t=>{if((0,I.$$I)(t)&&(t=[t]),Array.isArray(t)){r(t.map(s=>f.URI.file(s.path)));return}t.message&&this.n.debug("ExtHostSearch",t.message)};if(!this.v)throw new Error("No internal file search handler");return this.v.doFileSearch(i,a,n)}async A(i,n,r,a){return this.doInternalFileSearchWithCustomCallback(r,a,t=>{this.c.$handleFileMatch(i,n,t)})}$clearCache(i){return this.v?.clearCache(i),super.$clearCache(i)}q(i,n){return new w.$egc(i,n,void 0,"textSearchProvider")}};e.$igc=u,e.$igc=u=He([Be(0,v.$zM),Be(1,b.$PM),Be(2,A.$Zdc),Be(3,M.$dj)],u)}),define(ke[120],Se([1,0,393,62,63,394,22,8,4,3,16,11,32,81,82]),function(me,e,C,F,f,L,M,b,v,g,A,I,$,y,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rh=e.$Qh=e.$Ph=e.$Oh=e.$Nh=e.$Mh=e.$Lh=e.$Kh=void 0;class w{traceSocketEvent(p,S){k.SocketDiagnostics.traceSocketEvent(this.socket,this.debugLabel,p,S)}constructor(p,S=""){this.f=!0,this.debugLabel=S,this.socket=p,this.traceSocketEvent("created",{type:"NodeSocket"}),this.a=P=>{if(this.traceSocketEvent("error",{code:P?.code,message:P?.message}),P){if(P.code==="EPIPE")return;(0,b.$Z)(P)}},this.socket.on("error",this.a),this.b=P=>{this.traceSocketEvent("close",{hadError:P}),this.f=!1},this.socket.on("close",this.b),this.d=()=>{this.traceSocketEvent("nodeEndReceived"),this.f=!1},this.socket.on("end",this.d)}dispose(){this.socket.off("error",this.a),this.socket.off("close",this.b),this.socket.off("end",this.d),this.socket.destroy()}onData(p){const S=P=>{this.traceSocketEvent("read",P),p(M.$fe.wrap(P))};return this.socket.on("data",S),{dispose:()=>this.socket.off("data",S)}}onClose(p){const S=P=>{p({type:0,hadError:P,error:void 0})};return this.socket.on("close",S),{dispose:()=>this.socket.off("close",S)}}onEnd(p){const S=()=>{p()};return this.socket.on("end",S),{dispose:()=>this.socket.off("end",S)}}write(p){if(!(this.socket.destroyed||!this.f))try{this.traceSocketEvent("write",p),this.socket.write(p.buffer,S=>{if(S){if(S.code==="EPIPE")return;(0,b.$Z)(S)}})}catch(S){if(S.code==="EPIPE")return;(0,b.$Z)(S)}}end(){this.traceSocketEvent("nodeEndSent"),this.socket.end()}drain(){return this.traceSocketEvent("nodeDrainBegin"),new Promise((p,S)=>{if(this.socket.bufferSize===0){this.traceSocketEvent("nodeDrainEnd"),p();return}const P=()=>{this.socket.off("close",P),this.socket.off("end",P),this.socket.off("error",P),this.socket.off("timeout",P),this.socket.off("drain",P),this.traceSocketEvent("nodeDrainEnd"),p()};this.socket.on("close",P),this.socket.on("end",P),this.socket.on("error",P),this.socket.on("timeout",P),this.socket.on("drain",P)})}}e.$Kh=w;var u;(function(m){m[m.MinHeaderByteSize=2]="MinHeaderByteSize",m[m.MaxWebSocketMessageLength=262144]="MaxWebSocketMessageLength"})(u||(u={}));var o;(function(m){m[m.PeekHeader=1]="PeekHeader",m[m.ReadHeader=2]="ReadHeader",m[m.ReadBody=3]="ReadBody",m[m.Fin=4]="Fin"})(o||(o={}));class i extends g.$Rc{get permessageDeflate(){return this.a.permessageDeflate}get recordedInflateBytes(){return this.a.recordedInflateBytes}traceSocketEvent(p,S){this.socket.traceSocketEvent(p,S)}constructor(p,S,P,z){super(),this.f=this.B(new v.$Rd),this.g=this.B(new v.$Rd),this.h=!1,this.j={state:1,readLen:2,fin:0,compressed:!1,firstFrameOfMessage:!0,mask:0,opcode:0},this.socket=p,this.traceSocketEvent("created",{type:"WebSocketNodeSocket",permessageDeflate:S,inflateBytesLength:P?.byteLength||0,recordInflateBytes:z}),this.a=this.B(new n(this,S,P,z,this.f,(j,R)=>this.m(j,R))),this.B(this.a.onError(j=>{console.error(j),(0,b.$Z)(j),this.g.fire({type:0,hadError:!0,error:j})})),this.b=new k.$Fh,this.B(this.socket.onData(j=>this.n(j))),this.B(this.socket.onClose(async j=>{this.a.isProcessingReadQueue()&&await v.Event.toPromise(this.a.onDidFinishProcessingReadQueue),this.g.fire(j)}))}dispose(){this.a.isProcessingWriteQueue()?this.B(this.a.onDidFinishProcessingWriteQueue(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(p){return this.f.event(p)}onClose(p){return this.g.event(p)}onEnd(p){return this.socket.onEnd(p)}write(p){let S=0;for(;S<p.byteLength;)this.a.writeMessage(p.slice(S,Math.min(S+262144,p.byteLength)),{compressed:!0,opcode:2}),S+=262144}m(p,{compressed:S,opcode:P}){if(this.h)return;this.traceSocketEvent("webSocketNodeSocketWrite",p);let z=2;p.byteLength<126?z+=0:p.byteLength<2**16?z+=2:z+=8;const j=M.$fe.alloc(z),R=S?64:0,T=P&15;if(j.writeUInt8(128|R|T,0),p.byteLength<126)j.writeUInt8(p.byteLength,1);else if(p.byteLength<2**16){j.writeUInt8(126,1);let N=1;j.writeUInt8(p.byteLength>>>8&255,++N),j.writeUInt8(p.byteLength>>>0&255,++N)}else{j.writeUInt8(127,1);let N=1;j.writeUInt8(0,++N),j.writeUInt8(0,++N),j.writeUInt8(0,++N),j.writeUInt8(0,++N),j.writeUInt8(p.byteLength>>>24&255,++N),j.writeUInt8(p.byteLength>>>16&255,++N),j.writeUInt8(p.byteLength>>>8&255,++N),j.writeUInt8(p.byteLength>>>0&255,++N)}this.socket.write(M.$fe.concat([j,p]))}end(){this.h=!0,this.socket.end()}n(p){if(p.byteLength!==0){for(this.b.acceptChunk(p);this.b.byteLength>=this.j.readLen;)if(this.j.state===1){const S=this.b.peek(this.j.readLen),P=S.readUInt8(0),z=(P&128)>>>7,j=(P&64)>>>6,R=P&15,T=S.readUInt8(1),N=(T&128)>>>7,O=T&127;this.j.state=2,this.j.readLen=2+(N?4:0)+(O===126?2:0)+(O===127?8:0),this.j.fin=z,this.j.firstFrameOfMessage&&(this.j.compressed=!!j),this.j.firstFrameOfMessage=!!z,this.j.mask=0,this.j.opcode=R,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{headerSize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin,opcode:this.j.opcode})}else if(this.j.state===2){const S=this.b.read(this.j.readLen),P=S.readUInt8(1),z=(P&128)>>>7;let j=P&127,R=1;j===126?j=S.readUInt8(++R)*2**8+S.readUInt8(++R):j===127&&(j=S.readUInt8(++R)*0+S.readUInt8(++R)*0+S.readUInt8(++R)*0+S.readUInt8(++R)*0+S.readUInt8(++R)*2**24+S.readUInt8(++R)*2**16+S.readUInt8(++R)*2**8+S.readUInt8(++R));let T=0;z&&(T=S.readUInt8(++R)*2**24+S.readUInt8(++R)*2**16+S.readUInt8(++R)*2**8+S.readUInt8(++R)),this.j.state=3,this.j.readLen=j,this.j.mask=T,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{bodySize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin,mask:this.j.mask,opcode:this.j.opcode})}else if(this.j.state===3){const S=this.b.read(this.j.readLen);this.traceSocketEvent("webSocketNodeSocketReadData",S),t(S,this.j.mask),this.traceSocketEvent("webSocketNodeSocketUnmaskedData",S),this.j.state=1,this.j.readLen=2,this.j.mask=0,this.j.opcode<=2?this.a.acceptFrame(S,this.j.compressed,!!this.j.fin):this.j.opcode===9&&this.a.writeMessage(S,{compressed:!1,opcode:10})}}}async drain(){this.traceSocketEvent("webSocketNodeSocketDrainBegin"),this.a.isProcessingWriteQueue()&&await v.Event.toPromise(this.a.onDidFinishProcessingWriteQueue),await this.socket.drain(),this.traceSocketEvent("webSocketNodeSocketDrainEnd")}}e.$Lh=i;class n extends g.$Rc{get permessageDeflate(){return!!(this.b&&this.f)}get recordedInflateBytes(){return this.b?this.b.recordedInflateBytes:M.$fe.alloc(0)}constructor(p,S,P,z,j,R){super(),this.n=p,this.r=j,this.s=R,this.a=this.B(new v.$Rd),this.onError=this.a.event,this.g=[],this.h=[],this.j=this.B(new v.$Rd),this.onDidFinishProcessingReadQueue=this.j.event,this.m=this.B(new v.$Rd),this.onDidFinishProcessingWriteQueue=this.m.event,this.t=!1,this.y=!1,S?(this.b=this.B(new r(this.n,z,P,{windowBits:15})),this.f=this.B(new a(this.n,{windowBits:15})),this.B(this.b.onError(T=>this.a.fire(T))),this.B(this.f.onError(T=>this.a.fire(T)))):(this.b=null,this.f=null)}writeMessage(p,S){this.g.push({data:p,options:S}),this.u()}async u(){if(!this.t){for(this.t=!0;this.g.length>0;){const{data:p,options:S}=this.g.shift();if(this.f&&S.compressed){const P=await this.w(this.f,p);this.s(P,S)}else this.s(p,{...S,compressed:!1})}this.t=!1,this.m.fire()}}isProcessingWriteQueue(){return this.t}w(p,S){return new Promise((P,z)=>{p.write(S),p.flush(j=>P(j))})}acceptFrame(p,S,P){this.h.push({data:p,isCompressed:S,isLastFrameOfMessage:P}),this.z()}async z(){if(!this.y){for(this.y=!0;this.h.length>0;){const p=this.h.shift();if(this.b&&p.isCompressed){const S=await this.C(this.b,p.data,p.isLastFrameOfMessage);this.r.fire(S)}else this.r.fire(p.data)}this.y=!1,this.j.fire()}}isProcessingReadQueue(){return this.y}C(p,S,P){return new Promise((z,j)=>{p.write(S),P&&p.write(M.$fe.fromByteArray([0,0,255,255])),p.flush(R=>z(R))})}}class r extends g.$Rc{get recordedInflateBytes(){return this.j?M.$fe.concat(this.f):M.$fe.alloc(0)}constructor(p,S,P,z){super(),this.h=p,this.j=S,this.a=this.B(new v.$Rd),this.onError=this.a.event,this.f=[],this.g=[],this.b=(0,L.createInflateRaw)(z),this.b.on("error",j=>{this.h.traceSocketEvent("zlibInflateError",{message:j?.message,code:j?.code}),this.a.fire(j)}),this.b.on("data",j=>{this.h.traceSocketEvent("zlibInflateData",j),this.g.push(M.$fe.wrap(j))}),P&&(this.h.traceSocketEvent("zlibInflateInitialWrite",P.buffer),this.b.write(P.buffer),this.b.flush(()=>{this.h.traceSocketEvent("zlibInflateInitialFlushFired"),this.g.length=0}))}write(p){this.j&&this.f.push(p.clone()),this.h.traceSocketEvent("zlibInflateWrite",p),this.b.write(p.buffer)}flush(p){this.b.flush(()=>{this.h.traceSocketEvent("zlibInflateFlushFired");const S=M.$fe.concat(this.g);this.g.length=0,p(S)})}}class a extends g.$Rc{constructor(p,S){super(),this.g=p,this.a=this.B(new v.$Rd),this.onError=this.a.event,this.f=[],this.b=(0,L.createDeflateRaw)({windowBits:15}),this.b.on("error",P=>{this.g.traceSocketEvent("zlibDeflateError",{message:P?.message,code:P?.code}),this.a.fire(P)}),this.b.on("data",P=>{this.g.traceSocketEvent("zlibDeflateData",P),this.f.push(M.$fe.wrap(P))})}write(p){this.g.traceSocketEvent("zlibDeflateWrite",p.buffer),this.b.write(p.buffer)}flush(p){this.b.flush(2,()=>{this.g.traceSocketEvent("zlibDeflateFlushFired");let S=M.$fe.concat(this.f);this.f.length=0,S=S.slice(0,S.byteLength-4),p(S)})}}function t(m,p){if(p===0)return;const S=m.byteLength>>>2;for(let N=0;N<S;N++){const O=m.readUInt32BE(N*4);m.writeUInt32BE(O^p,N*4)}const P=S*4,z=m.byteLength-P,j=p>>>24&255,R=p>>>16&255,T=p>>>8&255;z>=1&&m.writeUInt8(m.readUInt8(P)^j,P),z>=2&&m.writeUInt8(m.readUInt8(P+1)^R,P+1),z>=3&&m.writeUInt8(m.readUInt8(P+2)^T,P+2)}e.$Mh=process.env.XDG_RUNTIME_DIR;const s={[2]:107,[1]:103};function d(){const m=(0,$.$ig)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${m}-sock`;const p=process.platform!=="darwin"&&e.$Mh?e.$Mh:(0,f.tmpdir)(),S=(0,A.$ic)(p,`vscode-ipc-${m}.sock`);return l(S),S}e.$Nh=d;function c(m,p,S){const P=(0,C.createHash)("md5").update(m).digest("hex");if(process.platform==="win32")return`\\\\.\\pipe\\${P}-${S}-${p}-sock`;const z=S.substr(0,4),j=p.substr(0,6),R=P.substr(0,8);let T;return process.platform!=="darwin"&&e.$Mh&&!process.env.VSCODE_PORTABLE?T=(0,A.$ic)(e.$Mh,`vscode-${R}-${z}-${j}.sock`):T=(0,A.$ic)(m,`${z}-${j}.sock`),l(T),T}e.$Oh=c;function l(m){const p=s[I.$u];typeof p=="number"&&m.length>=p&&console.warn(`WARNING: IPC handle "${m}" is longer than ${p} chars, try a shorter --user-data-dir`)}class h extends y.$zh{static b(p){const S=v.Event.fromNodeEventEmitter(p,"connection");return v.Event.map(S,P=>({protocol:new k.$Gh(new w(P,"ipc-server-connection")),onDidClientDisconnect:v.Event.once(v.Event.fromNodeEventEmitter(P,"close"))}))}constructor(p){super(h.b(p)),this.d=p}dispose(){super.dispose(),this.d&&(this.d.close(),this.d=null)}}e.$Ph=h;function E(m){return new Promise((p,S)=>{const P=(0,F.createServer)();P.on("error",S),P.listen(m,()=>{P.removeListener("error",S),p(new h(P))})})}e.$Qh=E;function D(m,p){return new Promise((S,P)=>{const z=(0,F.createConnection)(m,()=>{z.removeListener("error",P),S(k.$Hh.fromSocket(new w(z,`ipc-client${p}`),p))});z.once("error",P)})}e.$Rh=D}),define(ke[380],Se([1,0,62,63,166,120,12,3,11,44,14,138,257,258,109,88,22]),function(me,e,C,F,f,L,M,b,v,g,A,I,$,y,k,w,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$N9b=e.$M9b=e.$L9b=e.$K9b=void 0;async function o(t,s,d,c,l){let h;for(let E=3;E&&(h?.dispose(),h=await new i(t,s,d,c,l).waitForReady(),!(l&&f.$lg[l]||!f.$lg[h.tunnelLocalPort]));E--);return h}class i extends b.$Rc{constructor(s,d,c,l,h){super(),this.m=d,this.n=h,this.privacy=w.TunnelPrivacyId.Private,this.j=new Map,this.a=s,this.b=C.createServer(),this.c=new M.$Wg,this.f=()=>this.c.open(),this.b.on("listening",this.f),this.g=E=>this.r(E),this.b.on("connection",this.g),this.h=()=>{},this.b.on("error",this.h),this.tunnelRemotePort=l,this.tunnelRemoteHost=c}async dispose(){super.dispose(),this.b.removeListener("listening",this.f),this.b.removeListener("connection",this.g),this.b.removeListener("error",this.h),this.b.close(),Array.from(this.j.values()).forEach(d=>{d()})}async waitForReady(){const s=this.n??this.tunnelRemotePort,d=(0,w.$kv)(this.m)?"0.0.0.0":"127.0.0.1";let c=await(0,f.$mg)(s,2,1e3,d),l=null;return this.b.listen(c,this.m),await this.c.wait(),l=this.b.address(),l||(c=0,this.b.listen(c,this.m),await this.c.wait(),l=this.b.address()),this.tunnelLocalPort=l.port,this.localAddress=`${this.tunnelRemoteHost==="127.0.0.1"?"127.0.0.1":"localhost"}:${l.port}`,this}async r(s){s.pause();const d=(0,w.$iv)(this.tunnelRemoteHost)||(0,w.$kv)(this.tunnelRemoteHost)?"localhost":this.tunnelRemoteHost,c=await(0,$.$_k)(this.a,d,this.tunnelRemotePort),l=c.getSocket(),h=c.readEntireBuffer();c.dispose(),h.byteLength>0&&s.write(h.buffer),s.on("end",()=>{s.localAddress&&this.j.delete(s.localAddress),l.end()}),s.on("close",()=>l.end()),s.on("error",()=>{s.localAddress&&this.j.delete(s.localAddress),l instanceof L.$Kh?l.socket.destroy():l.end()}),l instanceof L.$Kh?this.t(s,l):this.s(s,l),s.localAddress&&this.j.set(s.localAddress,()=>{s.end(),l.end()})}s(s,d){d.onClose(()=>s.destroy()),d.onEnd(()=>s.end()),d.onData(c=>s.write(c.buffer)),s.on("data",c=>d.write(u.$fe.wrap(c))),s.resume()}t(s,d){const c=d.socket;c.on("end",()=>s.end()),c.on("close",()=>s.end()),c.on("error",()=>{s.destroy()}),c.pipe(s),s.pipe(c)}}e.$K9b=i;let n=class extends w.$nv{constructor(s,d,c,l,h){super(d,h),this.u=s,this.v=c,this.w=l}isPortPrivileged(s){return(0,w.$lv)(s,this.l,v.OS,F.release())}s(s,d,c,l,h,E,D,m){const p=this.r(d,c);if(p)return++p.refcount,p.value;if((0,w.$fv)(s))return this.t(s,d,c,h,E,D,m);{this.j.trace(`ForwardedPorts: (TunnelService) Creating tunnel without provider ${d}:${c} on local port ${h}.`);const S={commit:this.w.commit,quality:this.w.quality,addressProvider:s,remoteSocketFactoryService:this.u,signService:this.v,logService:this.j,ipcLogger:null},P=o(S,l,d,c,h);return this.j.trace("ForwardedPorts: (TunnelService) Tunnel created without provider."),this.p(d,c,P),P}}};e.$L9b=n,e.$L9b=n=He([Be(0,y.$6k),Be(1,A.$dj),Be(2,k.$9k),Be(3,I.$vj),Be(4,g.$pi)],n);let r=class extends n{constructor(s,d,c,l,h){super(s,d,c,l,h)}};e.$M9b=r,e.$M9b=r=He([Be(0,y.$6k),Be(1,A.$dj),Be(2,k.$9k),Be(3,I.$vj),Be(4,g.$pi)],r);let a=class extends b.$Rc{constructor(s,d,c,l,h){super(),this.b=s,this.c=d,this.f=c,this.g=l,this.h=h,this.a=new Map}async openTunnel(s,d,c,l,h,E,D,m,p){if(this.c.trace(`ForwardedPorts: (SharedTunnelService) openTunnel request for ${c}:${l} on local port ${E}.`),!this.a.has(s)){const S=new r(this.b,this.c,this.g,this.f,this.h);this.B(S),this.a.set(s,S),S.onTunnelClosed(async()=>{(await S.tunnels).length===0&&(S.dispose(),this.a.delete(s))})}return this.a.get(s).openTunnel(d,c,l,h,E,D,m,p)}};e.$N9b=a,e.$N9b=a=He([Be(0,y.$6k),Be(1,A.$dj),Be(2,I.$vj),Be(3,k.$9k),Be(4,g.$pi)],a)}),define(ke[381],Se([1,0,120,277,55,35,2,14,40]),function(me,e,C,F,f,L,M,b,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2M=e.$1M=void 0;class g{constructor($,y,k){this.b=$,this.c=y,this.f=k,this.a=F.createServer((w,u)=>this.h(w,u)),this.g().catch(w=>(y.error(w),""))}get ipcHandlePath(){return this.f}async g(){try{this.a.listen(this.ipcHandlePath),this.a.on("error",$=>this.c.error($))}catch{this.c.error("Could not start open from terminal server.")}return this.f}h($,y){const k=(u,o)=>{y.writeHead(u,{"content-type":"application/json"}),y.end(JSON.stringify(o||null),i=>i&&this.c.error(i))},w=[];$.setEncoding("utf8"),$.on("data",u=>w.push(u)),$.on("end",async()=>{try{const u=JSON.parse(w.join(""));let o;switch(u.type){case"open":o=await this.i(u);break;case"openExternal":o=await this.j(u);break;case"status":o=await this.l(u);break;case"extensionManagement":o=await this.k(u);break;default:k(404,`Unknown message type: ${u.type}`);break}k(200,o)}catch(u){const o=u instanceof Error?u.message:JSON.stringify(u);k(500,o),this.c.error("Error while processing pipe request",u)}})}async i($){const{fileURIs:y,folderURIs:k,forceNewWindow:w,diffMode:u,mergeMode:o,addMode:i,forceReuseWindow:n,gotoLineMode:r,waitMarkerFilePath:a,remoteAuthority:t}=$,s=[];if(Array.isArray(k))for(const h of k)try{s.push({folderUri:M.URI.parse(h)})}catch{}if(Array.isArray(y))for(const h of y)try{(0,v.$oi)(h)?s.push({workspaceUri:M.URI.parse(h)}):s.push({fileUri:M.URI.parse(h)})}catch{}const d=a?M.URI.file(a):void 0,l={forceNewWindow:w,diffMode:u,mergeMode:o,addMode:i,gotoLineMode:r,forceReuseWindow:n,preferNewWindow:!n&&!d&&!i,waitMarkerFileURI:d,remoteAuthority:t};this.b.executeCommand("_remoteCLI.windowOpen",s,l)}async j($){for(const y of $.uris){const k=M.URI.parse(y),w=k.scheme==="file"?k:y;await this.b.executeCommand("_remoteCLI.openExternal",w)}}async k($){const y=w=>w?.map(u=>/\.vsix$/i.test(u)?M.URI.parse(u):u),k={list:$.list,install:y($.install),uninstall:y($.uninstall),force:$.force};return await this.b.executeCommand("_remoteCLI.manageExtensions",k)}async l($){return await this.b.executeCommand("_remoteCLI.getSystemStatus")}dispose(){this.a.close(),this.f&&process.platform!=="win32"&&f.existsSync(this.f)&&f.unlinkSync(this.f)}}e.$1M=g;let A=class extends g{constructor($,y){super($,y,(0,C.$Nh)())}};e.$2M=A,e.$2M=A=He([Be(0,L.$VM),Be(1,b.$dj)],A)}),define(ke[382],Se([1,0,56,369,364,276,47,349,2,17,7,381,103,347,348]),function(me,e,C,F,f,L,M,b,v,g,A,I,$,y,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ngc=void 0;class w extends f.$Ofc{j(){const i=this,n=globalThis._VSCODE_NODE_MODULES.module,r=n._load;n._load=function(d,c,l){return d=t(d),i.a.has(d)?i.a.get(d).load(d,v.URI.file((0,$.$bq)(c.filename)),h=>r.apply(this,[h,c,l])):r.apply(this,arguments)};const a=n._resolveLookupPaths;n._resolveLookupPaths=(s,d)=>a.call(this,t(s),d);const t=s=>{for(const d of i.b){const c=d(s);if(c){s=c;break}}return s}}}class u extends M.$Dec{constructor(){super(...arguments),this.extensionRuntime=A.ExtensionRuntime.Node}async tb(){this.h.createInstance(y.$lgc);const i=this.h.invokeFunction(F.$Kfc);if(this.h.createInstance(b.$kgc),this.f.remote.isRemote&&this.f.remote.authority){const a=this.h.createInstance(I.$2M);process.env.VSCODE_IPC_HOOK_CLI=a.ipcHandlePath}this.h.createInstance(k.$mgc),await this.h.createInstance(w,i,{mine:this.J,all:this.L}).install(),C.mark("code/extHost/didInitAPI");const r=await this.m.getConfigProvider();await(0,L.$jgc)(this.j,r,this,this.s,this.z,this.f),C.mark("code/extHost/didInitProxyResolver")}ub(i){return i.main}async vb(i,n,r){if(n.scheme!==g.Schemas.file)throw new Error(`Cannot load URI: '${n}', must be of file-scheme`);let a=null;r.codeLoadingStart(),this.s.trace(`ExtensionService#loadCommonJSModule ${n.toString(!0)}`),this.s.flush();const t=i?.identifier.value;i&&await this.w.initializeLocalizedMessages(i);try{t&&C.mark(`code/extHost/willLoadExtensionCode/${t}`),a=me.__$__nodeRequire(n.fsPath)}finally{t&&C.mark(`code/extHost/didLoadExtensionCode/${t}`),r.codeLoadingStop()}return a}async $setRemoteEnvironment(i){if(this.f.remote.isRemote)for(const n in i){const r=i[n];r===null?delete process.env[n]:process.env[n]=r}}}e.$ngc=u}),define(ke[383],Se([1,0,50,22,4,3,123,11,23,2,30,14,256,64,109,88,380,27,20,72,358]),function(me,e,C,F,f,L,M,b,v,g,A,I,$,y,k,w,u,o,i,n,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vgc=e.$ugc=e.$tgc=e.$sgc=e.$rgc=e.$qgc=e.$pgc=e.$ogc=void 0;function a(p){const S=p.trim().split(`
`),P=[];return S.forEach(j=>{const R=/\/proc\/(\d+)\/fd\/\d+ -> socket:\[(\d+)\]/.exec(j);R&&R.length>=3&&P.push({pid:parseInt(R[1],10),socket:parseInt(R[2],10)})}),P.reduce((j,R)=>(j[R.socket]=R,j),{})}e.$ogc=a;function t(...p){const S=[].concat(...p.map(d));return[...new Map(S.filter(P=>P.st==="0A").map(P=>{const z=P.local_address.split(":");return{socket:parseInt(P.inode,10),ip:s(z[0]),port:parseInt(z[1],16)}}).map(P=>[P.ip+":"+P.port,P])).values()]}e.$pgc=t;function s(p){let S="";if(p.length===8)for(let P=p.length-2;P>=0;P-=2)S+=parseInt(p.substr(P,2),16),P!==0&&(S+=".");else for(let P=0;P<p.length;P+=8){const z=p.substring(P,P+8);let j="";for(let R=8;R>=2;R-=2)j+=z.substring(R-2,R),(R===6||R===2)&&(j=parseInt(j,16).toString(16),S+=`${j}`,j="",P+R!==p.length-6&&(S+=":"))}return S}e.$qgc=s;function d(p){const S=p.trim().split(`
`),P=S.shift().trim().split(/\s+/).filter(j=>j!=="rx_queue"&&j!=="tm->when");return S.map(j=>j.trim().split(/\s+/).reduce((R,T,N)=>(R[P[N]||N]=T,R),{}))}e.$rgc=d;function c(p){return!!p.match(/.*\.vscode-server-[a-zA-Z]+\/bin.*/)||p.indexOf("out/server-main.js")!==-1||p.indexOf("_productName=VSCode")!==-1}function l(p){const S=p.trim().split(`
`),P=[];return S.forEach(z=>{const j=/^\d+\s+\D+\s+root\s+(\d+)\s+(\d+).+\d+\:\d+\:\d+\s+(.+)$/.exec(z);j&&j.length>=4&&P.push({pid:parseInt(j[1],10),ppid:parseInt(j[2]),cmd:j[3]})}),P}e.$sgc=l;async function h(p,S,P){const z=P.reduce((R,T)=>(R[T.pid]=T,R),{}),j=[];return p.forEach(({socket:R,ip:T,port:N})=>{const O=S[R]?S[R].pid:void 0,W=O?z[O]?.cmd:void 0;O&&W&&!c(W)&&j.push({host:T,port:N,detail:W,pid:O})}),j}e.$tgc=h;function E(p,S,P){const z=new Map,j=l(S);for(const R of p){const T=P.get(R.port);if(T){z.set(R.port,T);continue}const N=j.find(O=>O.cmd.includes(`${R.port}`));if(N){let O=N,W;do W=j.find(x=>x.ppid===O.pid),W&&(O=W);while(W);z.set(R.port,{host:R.ip,port:R.port,pid:O.pid,detail:O.cmd,ppid:O.ppid})}else z.set(R.port,{host:R.ip,port:R.port,ppid:Number.MAX_VALUE})}return z}e.$ugc=E;let D=class extends n.$Swb{constructor(S,P,z,j){super(S,P,z),this.D=P,this.F=j,this.y=void 0,this.z=new Map,this.C=!1,b.$k&&P.remote.isRemote&&P.remote.authority&&(this.a.$setRemoteTunnelService(process.pid),this.H())}async $registerCandidateFinder(S){if(S&&this.C)return;this.C=S;let P;this.y&&(P=this.y,await this.a.$onFoundNewCandidates(this.y));const z=new M.$Xl;let j=0;for(;this.C;){const R=new Date().getTime(),T=(await this.I()).filter(W=>(0,w.$iv)(W.host)||(0,w.$kv)(W.host));this.s.trace(`ForwardedPorts: (ExtHostTunnelService) found candidate ports ${T.map(W=>W.port).join(", ")}`);const N=new Date().getTime()-R;this.s.trace(`ForwardedPorts: (ExtHostTunnelService) candidate port scan took ${N} ms.`),j++>3&&z.update(N),(!P||JSON.stringify(P)!==JSON.stringify(T))&&(P=T,await this.a.$onFoundNewCandidates(P));const O=this.G(z.value);this.s.trace(`ForwardedPorts: (ExtHostTunnelService) next candidate port scan in ${O} ms.`),await new Promise(W=>setTimeout(()=>W(),O))}}G(S){return Math.max(S*20,2e3)}async H(){this.y=await this.I(),this.s.trace(`ForwardedPorts: (ExtHostTunnelService) Initial candidates found: ${this.y.map(S=>S.port).join(", ")}`)}async I(){let S="",P="";try{S=await A.Promises.readFile("/proc/net/tcp","utf8"),P=await A.Promises.readFile("/proc/net/tcp6","utf8")}catch{}const z=t(S,P),j=await new Promise(G=>{(0,C.exec)("ls -l /proc/[0-9]*/fd/[0-9]* | grep socket:",(J,Q,oe)=>{G(Q)})}),R=a(j),T=await A.Promises.readdir("/proc"),N=[];for(const G of T)try{const J=Number(G),Q=v.$zg(g.URI.file("/proc"),G);if((await A.Promises.stat(Q.fsPath)).isDirectory()&&!isNaN(J)){const _=await A.Promises.readlink(v.$zg(Q,"cwd").fsPath),Ee=await A.Promises.readFile(v.$zg(Q,"cmdline").fsPath,"utf8");N.push({pid:J,cwd:_,cmd:Ee})}}catch{}const O=[],W=z.filter(G=>{const J=R[G.socket];return J||O.push(G),J}),x=h(W,R,N);let le;if(this.s.trace(`ForwardedPorts: (ExtHostTunnelService) number of possible root ports ${O.length}`),O.length>0){const G=await new Promise(J=>{(0,C.exec)("ps -F -A -l | grep root",(Q,oe,_)=>{J(oe)})});this.z=E(O,G,this.z),le=Array.from(this.z.values()),this.s.trace(`ForwardedPorts: (ExtHostTunnelService) heuristic ports ${le.map(J=>J.port).join(", ")}`)}return x.then(G=>le?G.concat(le):G)}w(S){return async P=>{const z=new u.$K9b({commit:this.D.commit,quality:this.D.quality,logService:this.s,ipcLogger:null,remoteSocketFactoryService:{_serviceBrand:void 0,async connect(R,T,N,O){const W=await S.makeConnection();return m.connect(W,T,N,O)},register(){throw new Error("not implemented")}},addressProvider:{getAddress(){return Promise.resolve({connectTo:new y.$Wk(0),connectionToken:S.connectionToken})}},signService:this.F},"localhost",P.remoteAddress.host||"localhost",P.remoteAddress.port,P.localAddressPort);await z.waitForReady();const j=new f.$Rd;return{localAddress:(0,r.$XJ)(z.localAddress)??z.localAddress,remoteAddress:{port:z.tunnelRemotePort,host:z.tunnelRemoteHost},onDidDispose:j.event,dispose:()=>{z.dispose(),j.fire(),j.dispose()}}}}};e.$vgc=D,e.$vgc=D=He([Be(0,i.$zM),Be(1,o.$PM),Be(2,I.$dj),Be(3,k.$9k)],D);class m extends $.$9pb{static connect(S,P,z,j){const R=new L.$Qc,T={onClose:R.add(new f.$Rd),onData:R.add(new f.$Rd),onEnd:R.add(new f.$Rd)};R.add(S.onDidReceiveMessage(O=>T.onData.fire(F.$fe.wrap(O)))),R.add(S.onDidEnd(()=>T.onEnd.fire())),R.add(S.onDidClose(O=>T.onClose.fire({type:0,error:O,hadError:!!O})));const N=new m(S,j,T);return N.B(R),(0,$.$8pb)(N,P,z,j,T)}constructor(S,P,z){super(P,z),this.n=S}write(S){this.n.send(S.buffer)}h(){this.n.end()}async drain(){await this.n.drain?.()}}}),define(ke[384],Se([1,0,106,352,367,366,379,382,383,96,47,97,95,46,72,92,351,350,14,368,58,271,105,109,140]),function(me,e,C,F,f,L,M,b,v,g,A,I,$,y,k,w,u,o,i,n,r,a,t,s,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,C.$Cr)(A.$Eec,b.$ngc,0),(0,C.$Cr)(i.$ej,o.$xgc,1),(0,C.$Cr)(i.$dj,new t.$Sh(a.$Nfc,[!1],!0)),(0,C.$Cr)(s.$9k,d.$P9b,1),(0,C.$Cr)(w.$9dc,u.$wgc,0),(0,C.$Cr)(g.$Jec,L.$1fc,0),(0,C.$Cr)(I.$6ec,M.$igc,0),(0,C.$Cr)($.$wfc,f.$Sfc,0),(0,C.$Cr)(y.$rec,F.$Rfc,0),(0,C.$Cr)(k.$Rwb,v.$vgc,0),(0,C.$Cr)(r.$Hec,n.$ygc,0)}),define(ke[395],Se([1,0,62,396,56,8,82,120,254,114,365,22,30,103,12,133,278,292,370,384]),function(me,e,C,F,f,L,M,b,v,g,A,I,$,y,k,w,u,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),function(){for(let h=0;h<process.execArgv.length;h++)process.execArgv[h]==="--inspect-port=0"&&(process.execArgv.splice(h,1),h--)}();const i=F(process.argv.slice(2),{boolean:["transformURIs","skipWorkspaceStorageLock"],string:["useHostProxy"]});(function(){const l=globalThis._VSCODE_NODE_MODULES.module,h=l._load;l._load=function(E){if(E==="natives")throw new Error('Either the extension or an NPM dependency is using the [unsupported "natives" node module](https://go.microsoft.com/fwlink/?linkid=871887).');return h.apply(this,arguments)}})();const n=process.exit.bind(process);function r(l){process.exit=function(h){if(l)n(h);else{const E=new Error("An extension called process.exit() and this was prevented.");console.warn(E.stack)}},process.crash=function(){const h=new Error("An extension called process.crash() and this was prevented.");console.warn(h.stack)},process.env.ELECTRON_RUN_AS_NODE="1"}let a=function(l){n()};function t(){const l=(0,o.$Hm)(process.env);if(l.type===3)return new Promise((h,E)=>{const D=m=>{const p=m[0],S=new M.$Ih;p.on("message",P=>S.fire(I.$fe.wrap(P.data))),p.on("close",()=>{a("renderer closed the MessagePort")}),p.start(),h({onMessage:S.event,send:P=>p.postMessage(P.buffer)})};process.parentPort.on("message",m=>D(m.ports))});if(l.type===2)return new Promise((h,E)=>{let D=null;const m=setTimeout(()=>{a("VSCODE_EXTHOST_IPC_SOCKET timeout")},6e4),p=108e5,S=3e5,P=new k.$$g(()=>a("renderer disconnected for too long (1)"),p),z=new k.$$g(()=>a("renderer disconnected for too long (2)"),S);process.on("message",(R,T)=>{if(R&&R.type==="VSCODE_EXTHOST_IPC_SOCKET"){T.setNoDelay(!0);const N=I.$fe.wrap(Buffer.from(R.initialDataChunk,"base64"));let O;if(R.skipWebSocketFrames)O=new b.$Kh(T,"extHost-socket");else{const W=I.$fe.wrap(Buffer.from(R.inflateBytes,"base64"));O=new b.$Lh(new b.$Kh(T,"extHost-socket"),R.permessageDeflate,W,!1)}D?(P.cancel(),z.cancel(),D.beginAcceptReconnection(O,N),D.endAcceptReconnection(),D.sendResume()):(clearTimeout(m),D=new M.$Jh({socket:O,initialChunk:N}),D.sendResume(),D.onDidDispose(()=>a("renderer disconnected")),h(D),D.onSocketClose(()=>{P.schedule()}))}if(R&&R.type==="VSCODE_EXTHOST_IPC_REDUCE_GRACE_TIME"){if(z.isScheduled())return;P.isScheduled()&&z.schedule()}});const j={type:"VSCODE_EXTHOST_IPC_READY"};process.send?.(j)});{const h=l.pipeName;return new Promise((E,D)=>{const m=C.createConnection(h,()=>{m.removeListener("error",D);const p=new M.$Jh({socket:new b.$Kh(m,"extHost-renderer")});p.sendResume(),E(p)});m.once("error",D),m.on("close",()=>{a("renderer closed the socket")})})}}async function s(){const l=await t();return new class{constructor(){this.a=new M.$Ih,this.onMessage=this.a.event,this.b=!1,l.onMessage(h=>{(0,g.$im)(h,2)?(this.b=!0,a("received terminate message from renderer")):this.a.fire(h)})}send(h){this.b||l.send(h)}async drain(){if(l.drain)return l.drain()}}}function d(l){return new Promise(h=>{const E=l.onMessage(D=>{E.dispose();const m=JSON.parse(D.toString()),p=m.commit,S=v.default.commit;if(p&&S&&p!==S&&n(55),m.parentPid){let P=0;setInterval(function(){try{process.kill(m.parentPid,0),P=0}catch(j){j&&j.code==="EPERM"?(P++,P>=3&&a(`parent process ${m.parentPid} does not exist anymore (3 x EPERM): ${j.message} (code: ${j.code}) (errno: ${j.errno})`)):a(`parent process ${m.parentPid} does not exist anymore: ${j.message} (code: ${j.code}) (errno: ${j.errno})`)}},1e3);let z;try{z=globalThis._VSCODE_NODE_MODULES["native-watchdog"],z.start(m.parentPid)}catch(j){(0,L.$Z)(j)}}l.send((0,g.$hm)(0)),h({protocol:l,initData:m})});l.send((0,g.$hm)(1))})}async function c(){const l=[];process.on("unhandledRejection",(P,z)=>{l.push(z),setTimeout(()=>{const j=l.indexOf(z);j>=0&&z.catch(R=>{l.splice(j,1),(0,L.$3)(R)||(console.warn(`rejected promise not handled within 1 second: ${R}`),R&&R.stack&&console.warn(`stack trace: ${R.stack}`),P&&(0,L.$Z)(P))})},1e3)}),process.on("rejectionHandled",P=>{const z=l.indexOf(P);z>=0&&l.splice(z,1)}),process.on("uncaughtException",function(P){(0,L.$Y)(P)||(0,L.$Z)(P)}),f.mark("code/extHost/willConnectToRenderer");const h=await s();f.mark("code/extHost/didConnectToRenderer");const E=await d(h);f.mark("code/extHost/didWaitForInitData");const{initData:D}=E;r(!!D.environment.extensionTestsLocationURI),D.environment.useHostProxy=i.useHostProxy!==void 0?i.useHostProxy!=="false":void 0,D.environment.skipWorkspaceStorageLock=(0,w.boolean)(i.skipWorkspaceStorageLock,!1);const m=new class{constructor(){this.pid=process.pid}exit(z){n(z)}fsExists(z){return $.Promises.exists(z)}fsRealpath(z){return(0,y.$aq)(z)}};let p=null;D.remote.authority&&i.transformURIs&&(p=(0,u.$Gr)(D.remote.authority));const S=new A.$Qfc(E.protocol,D,m,p);a=P=>S.terminate(P)}c().catch(l=>console.log(l))})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/94959e85502687ec77e23eb0d4d4b1a827b919af/core/vs/workbench/api/node/extensionHostProcess.js.map
