/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var Pe=["exports","require","vs/base/common/uri","vs/workbench/api/common/extHost.protocol","vs/platform/instantiation/common/instantiation","vs/base/common/event","vs/base/common/lifecycle","vs/workbench/api/common/extHostTypes","vs/workbench/api/common/extHostTypeConverters","vs/nls","vs/nls!vs/workbench/api/worker/extensionHostWorker","vs/base/common/errors","vs/base/common/strings","vs/base/common/network","vs/base/common/async","vs/platform/log/common/log","vs/base/common/types","vs/workbench/api/common/extHostRpcService","vs/base/common/arrays","vs/base/common/path","vs/base/common/cancellation","vs/base/common/platform","vs/platform/extensions/common/extensions","vs/workbench/services/extensions/common/extensions","vs/base/common/buffer","vs/base/common/resources","vs/base/common/objects","vs/workbench/api/common/extHostInitDataService","vs/base/common/map","vs/editor/common/core/range","vs/platform/registry/common/platform","vs/base/common/severity","vs/workbench/api/common/extHostCommands","vs/base/common/glob","vs/platform/contextkey/common/contextkey","vs/workbench/api/common/extHostWorkspace","vs/workbench/api/common/extHostConfiguration","vs/workbench/api/common/extHostExtensionService","vs/base/common/uuid","vs/base/common/errorMessage","vs/platform/configuration/common/configuration","vs/platform/files/common/files","vs/workbench/api/common/extHostFileSystemInfo","vs/workbench/services/search/common/search","vs/base/common/lazy","vs/base/common/themables","vs/base/common/extpath","vs/platform/workspace/common/workspace","vs/workbench/contrib/testing/common/testId","vs/workbench/services/extensions/common/proxyIdentifier","vs/base/common/ternarySearchTree","vs/base/common/marshalling","vs/base/common/htmlContent","vs/base/common/assert","vs/platform/configuration/common/configurationRegistry","vs/platform/remote/common/remoteHosts","vs/platform/telemetry/common/telemetryUtils","vs/workbench/api/common/extHostUriTransformerService","vs/workbench/contrib/testing/common/testTypes","vs/workbench/api/common/extHostTelemetry","vs/base/common/stopwatch","vs/workbench/api/common/extHostDocumentsAndEditors","vs/workbench/api/common/extHostEditorTabs","vs/workbench/api/common/extHostFileSystemConsumer","vs/workbench/api/common/extHostTerminalService","vs/workbench/api/common/extHostWebview","vs/base/common/decorators","vs/base/common/iterator","vs/base/common/mime","vs/platform/instantiation/common/descriptors","vs/platform/instantiation/common/extensions","vs/platform/instantiation/common/serviceCollection","vs/platform/progress/common/progress","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/base/common/process","vs/workbench/api/common/cache","vs/workbench/contrib/notebook/common/notebookCommon","vs/workbench/contrib/testing/common/testItemCollection","vs/workbench/contrib/webview/common/webview","vs/workbench/services/extensions/common/extensionHostProtocol","vs/editor/common/languages","vs/workbench/api/common/extHostApiDeprecationService","vs/workbench/api/common/extHostLocalizationService","vs/workbench/api/common/extHostManagedSockets","vs/workbench/api/common/extHostSecretState","vs/workbench/api/common/extHostStorage","vs/workbench/api/common/extHostStoragePaths","vs/workbench/api/common/extHostTunnelService","vs/base/common/performance","vs/base/common/idGenerator","vs/base/common/codicons","vs/editor/common/model/pieceTreeTextBuffer/pieceTreeBase","vs/editor/common/model","vs/editor/common/model/textModelSearch","vs/base/common/labels","vs/editor/common/services/semanticTokensDto","vs/platform/extensionManagement/common/extensionManagement","vs/base/common/hash","vs/platform/markers/common/markers","vs/platform/opener/common/opener","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/extensionManagement/common/implicitActivationEvents","vs/workbench/common/editor","vs/workbench/api/common/extHostDocumentData","vs/workbench/api/common/extHostTestingPrivateApi","vs/workbench/services/editor/common/editorGroupsService","vs/workbench/services/extensions/common/extensionDescriptionRegistry","vs/workbench/api/common/extHostNotebookEditor","vs/workbench/api/common/extHostTestItem","vs/workbench/api/common/extHostTextEditor","vs/workbench/api/common/extHostDecorations","vs/workbench/api/common/extHostWindow","vs/workbench/api/common/extHostOutput","vs/workbench/services/remote/common/remoteAgentService","vs/workbench/services/search/common/searchExtTypes","vs/workbench/api/common/extHostTask","vs/workbench/api/common/extHostVariableResolverService","vs/workbench/api/common/extHostDebugService","vs/workbench/api/common/extHostSearch","vs/base/common/json","vs/base/common/marked/marked","vs/base/common/numbers","vs/base/common/stream","vs/base/common/filters","vs/base/common/symbols","vs/base/common/iconLabels","vs/base/common/dataTransfer","vs/editor/common/core/eolCounter","vs/editor/common/core/textModelDefaults","vs/editor/common/languages/languageConfiguration","vs/editor/common/model/pieceTreeTextBuffer/rbTreeBase","vs/editor/common/core/position","vs/editor/common/services/treeViewsDnd","vs/nls!vs/base/common/actions","vs/base/common/actions","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/base/common/comparers","vs/base/common/uriIpc","vs/editor/common/core/stringBuilder","vs/editor/common/core/textChange","vs/editor/common/languageSelector","vs/editor/common/model/pieceTreeTextBuffer/pieceTreeTextBuffer","vs/editor/common/model/pieceTreeTextBuffer/pieceTreeTextBufferBuilder","vs/nls!vs/editor/common/config/editorOptions","vs/editor/common/config/editorOptions","vs/editor/common/core/wordHelper","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/contextkey/common/contextkey","vs/nls!vs/platform/contextkey/common/scanner","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/markers/common/markers","vs/nls!vs/platform/theme/common/iconRegistry","vs/nls!vs/platform/workspace/common/workspace","vs/nls!vs/workbench/api/common/extHostChatAgents2","vs/nls!vs/workbench/api/common/extHostDiagnostics","vs/nls!vs/workbench/api/common/extHostExtensionService","vs/nls!vs/workbench/api/common/extHostLanguageFeatures","vs/nls!vs/workbench/api/common/extHostLogService","vs/nls!vs/workbench/api/common/extHostNotebook","vs/nls!vs/workbench/api/common/extHostProgress","vs/nls!vs/workbench/api/common/extHostStatusBar","vs/nls!vs/workbench/api/common/extHostTelemetry","vs/nls!vs/workbench/api/common/extHostTerminalService","vs/nls!vs/workbench/api/common/extHostTreeViews","vs/nls!vs/workbench/api/common/extHostTunnelService","vs/nls!vs/workbench/api/common/extHostWorkspace","vs/nls!vs/workbench/common/configuration","vs/nls!vs/workbench/common/editor","vs/nls!vs/workbench/common/views","vs/nls!vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/nls!vs/workbench/contrib/debug/common/debug","vs/nls!vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/nls!vs/workbench/contrib/tasks/common/tasks","vs/nls!vs/workbench/services/configurationResolver/common/variableResolver","vs/nls!vs/workbench/services/editor/common/editorResolverService","vs/nls!vs/workbench/services/extensions/common/extensionsRegistry","vs/nls!vs/workbench/services/search/common/queryBuilder","vs/platform/contextkey/common/scanner","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/graph","vs/platform/environment/common/environment","vs/platform/instantiation/common/instantiationService","vs/base/common/linkedList","vs/platform/log/common/logService","vs/platform/notification/common/notification","vs/platform/product/common/productService","vs/platform/configuration/common/configurationModels","vs/platform/telemetry/common/commonProperties","vs/platform/telemetry/common/telemetry","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/terminal/common/environmentVariableShared","vs/platform/terminal/common/terminalDataBuffering","vs/platform/theme/common/iconRegistry","vs/platform/tunnel/common/tunnel","vs/platform/workspace/common/editSessions","vs/platform/workspace/common/virtualWorkspace","vs/workbench/api/common/extHostLogService","vs/workbench/api/common/extHostMemento","vs/workbench/api/common/extHostNotebookDocuments","vs/workbench/api/common/extHostSecrets","vs/workbench/api/common/extHostWebviewMessaging","vs/workbench/common/views","vs/workbench/contrib/chat/common/chatService","vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/workbench/contrib/debug/common/debug","vs/workbench/contrib/debug/common/debugUtils","vs/workbench/api/common/extHostTheming","vs/workbench/contrib/notebook/common/notebookExecutionService","vs/workbench/contrib/search/common/cellSearchModel","vs/workbench/api/common/extHostCodeInsets","vs/workbench/services/configurationResolver/common/configurationResolver","vs/workbench/services/configurationResolver/common/variableResolver","vs/workbench/services/editor/common/editorService","vs/workbench/services/environment/common/environmentService","vs/workbench/api/common/extHostExtensionActivator","vs/base/common/functional","vs/workbench/api/common/extHostDocumentSaveParticipant","vs/workbench/api/common/extHostNotebookDocument","vs/workbench/api/common/extHostNotebookDocumentSaveParticipant","vs/workbench/api/common/extHostNotebookEditors","vs/workbench/api/common/extHostProgress","vs/workbench/api/common/extHostTreeViews","vs/workbench/services/extensions/common/extensionsApiProposals","vs/workbench/services/extensions/common/extensionsRegistry","vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/workbench/contrib/tasks/common/tasks","vs/workbench/services/extensions/common/lazyPromise","vs/workbench/api/common/extHostAiRelatedInformation","vs/workbench/api/common/extHostAuthentication","vs/workbench/api/common/extHostBulkEdits","vs/workbench/api/common/extHostChat","vs/workbench/api/common/extHostChatAgents2","vs/workbench/api/common/extHostChatProvider","vs/workbench/api/common/extHostChatVariables","vs/workbench/api/common/extHostClipboard","vs/workbench/api/common/extHostApiCommands","vs/workbench/api/common/extHostComments","vs/workbench/api/common/extHostConsoleForwarder","vs/workbench/api/common/extHostDiagnostics","vs/workbench/api/common/extHostDialogs","vs/workbench/api/common/extHostDocumentContentProviders","vs/workbench/api/common/extHostDocuments","vs/base/common/collections","vs/workbench/api/common/extHostEmbeddingVector","vs/workbench/api/common/extHostFileSystem","vs/workbench/api/common/extHostFileSystemEventService","vs/workbench/api/common/extHostInlineChat","vs/workbench/api/common/extHostInteractive","vs/workbench/api/common/extHostIssueReporter","vs/workbench/api/common/extHostLabelService","vs/workbench/api/common/extHostLanguageFeatures","vs/workbench/api/common/extHostLanguages","vs/workbench/api/common/extHostLoggerService","vs/workbench/api/common/extHostMessageService","vs/workbench/api/common/extHostNotebookKernels","vs/workbench/api/common/extHostNotebookRenderers","vs/workbench/api/common/extHostProfileContentHandler","vs/workbench/api/common/extHostQuickDiff","vs/workbench/api/common/extHostQuickOpen","vs/workbench/api/common/extHostSCM","vs/workbench/api/common/extHostShare","vs/workbench/api/common/extHostSpeech","vs/workbench/api/common/extHostStatusBar","vs/workbench/api/common/extHostTesting","vs/workbench/api/common/extHostTextEditors","vs/workbench/api/common/extHostTimeline","vs/workbench/api/common/extHostUriOpener","vs/workbench/api/common/extHostUrls","vs/workbench/api/common/extHostCustomEditors","vs/workbench/api/common/extHostWebviewPanels","vs/workbench/api/common/extHostWebviewView","vs/workbench/api/worker/extHostConsoleForwarder","vs/workbench/services/extensions/common/rpcProtocol","vs/workbench/services/extensions/worker/polyfillNestedWorker","vs/workbench/services/output/common/output","vs/workbench/common/configuration","vs/workbench/services/editor/common/editorResolverService","vs/workbench/services/path/common/pathService","vs/workbench/contrib/search/common/searchNotebookHelpers","vs/workbench/api/common/extHostNotebook","vs/workbench/services/search/common/fileSearchManager","vs/workbench/services/search/common/queryBuilder","vs/workbench/services/extensions/common/workspaceContains","vs/workbench/api/common/extHostRequireInterceptor","vs/workbench/api/common/extensionHostMain","vs/workbench/services/search/common/textSearchManager","vs/workbench/api/common/extHost.api.impl","vs/workbench/api/common/extHost.common.services","vs/workbench/api/worker/extHostExtensionService","vs/workbench/api/worker/extHost.worker.services","vs/base/common/semver/semver","vs/editor/common/model/mirrorTextModel","vs/editor/common/languages/linkComputer","vs/editor/common/core/selection","vs/base/common/arraysFind","vs/workbench/api/worker/extensionHostWorker"],Re=function(be){for(var e=[],y=0,F=be.length;y<F;y++)e[y]=Pe[be[y]];return e};define(Pe[66],Re([1,0]),function(be,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ph=e.$oh=e.$nh=void 0;function y(A){return($,E,f)=>{let C=null,D=null;if(typeof f.value=="function"?(C="value",D=f.value):typeof f.get=="function"&&(C="get",D=f.get),!D)throw new Error("not supported");f[C]=A(D,E)}}function F(A,$,E){let f=null,C=null;if(typeof E.value=="function"?(f="value",C=E.value,C.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof E.get=="function"&&(f="get",C=E.get),!C)throw new Error("not supported");const D=`$memoize$${$}`;E[f]=function(...u){return this.hasOwnProperty(D)||Object.defineProperty(this,D,{configurable:!1,enumerable:!1,writable:!1,value:C.apply(this,u)}),this[D]}}e.$nh=F;function P(A,$,E){return y((f,C)=>{const D=`$debounce$${C}`,u=`$debounce$result$${C}`;return function(...b){this[u]||(this[u]=E?E():void 0),clearTimeout(this[D]),$&&(this[u]=$(this[u],...b),b=[this[u]]),this[D]=setTimeout(()=>{f.apply(this,b),this[u]=E?E():void 0},A)}})}e.$oh=P;function M(A,$,E){return y((f,C)=>{const D=`$throttle$timer$${C}`,u=`$throttle$result$${C}`,b=`$throttle$lastRun$${C}`,p=`$throttle$pending$${C}`;return function(...g){if(this[u]||(this[u]=E?E():void 0),(this[b]===null||this[b]===void 0)&&(this[b]=-Number.MAX_VALUE),$&&(this[u]=$(this[u],...g)),this[p])return;const t=this[b]+A;t<=Date.now()?(this[b]=Date.now(),f.apply(this,[this[u]]),this[u]=E?E():void 0):(this[p]=!0,this[D]=setTimeout(()=>{this[p]=!1,this[b]=Date.now(),f.apply(this,[this[u]]),this[u]=E?E():void 0},t-Date.now()))}})}e.$ph=M}),define(Pe[89],Re([1,0]),function(be,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$FM=e.$EM=void 0;class y{constructor(P){this.a=P,this.b=0}nextId(){return this.a+ ++this.b}}e.$EM=y,e.$FM=new y("id#")}),define(Pe[119],Re([1,0]),function(be,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_m=e.$$m=e.$0m=e.$9m=e.$8m=e.$7m=e.$6m=e.$5m=e.$4m=e.$3m=e.$2m=e.$1m=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var y;(function(n){n[n.None=0]="None",n[n.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",n[n.UnexpectedEndOfString=2]="UnexpectedEndOfString",n[n.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",n[n.InvalidUnicode=4]="InvalidUnicode",n[n.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",n[n.InvalidCharacter=6]="InvalidCharacter"})(y||(e.ScanError=y={}));var F;(function(n){n[n.OpenBraceToken=1]="OpenBraceToken",n[n.CloseBraceToken=2]="CloseBraceToken",n[n.OpenBracketToken=3]="OpenBracketToken",n[n.CloseBracketToken=4]="CloseBracketToken",n[n.CommaToken=5]="CommaToken",n[n.ColonToken=6]="ColonToken",n[n.NullKeyword=7]="NullKeyword",n[n.TrueKeyword=8]="TrueKeyword",n[n.FalseKeyword=9]="FalseKeyword",n[n.StringLiteral=10]="StringLiteral",n[n.NumericLiteral=11]="NumericLiteral",n[n.LineCommentTrivia=12]="LineCommentTrivia",n[n.BlockCommentTrivia=13]="BlockCommentTrivia",n[n.LineBreakTrivia=14]="LineBreakTrivia",n[n.Trivia=15]="Trivia",n[n.Unknown=16]="Unknown",n[n.EOF=17]="EOF"})(F||(e.SyntaxKind=F={}));var P;(function(n){n[n.InvalidSymbol=1]="InvalidSymbol",n[n.InvalidNumberFormat=2]="InvalidNumberFormat",n[n.PropertyNameExpected=3]="PropertyNameExpected",n[n.ValueExpected=4]="ValueExpected",n[n.ColonExpected=5]="ColonExpected",n[n.CommaExpected=6]="CommaExpected",n[n.CloseBraceExpected=7]="CloseBraceExpected",n[n.CloseBracketExpected=8]="CloseBracketExpected",n[n.EndOfFileExpected=9]="EndOfFileExpected",n[n.InvalidCommentToken=10]="InvalidCommentToken",n[n.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",n[n.UnexpectedEndOfString=12]="UnexpectedEndOfString",n[n.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",n[n.InvalidUnicode=14]="InvalidUnicode",n[n.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",n[n.InvalidCharacter=16]="InvalidCharacter"})(P||(e.ParseErrorCode=P={}));var M;(function(n){n.DEFAULT={allowTrailingComma:!0}})(M||(e.ParseOptions=M={}));function A(n,s=!1){let a=0;const d=n.length;let v="",m=0,S=16,k=0;function h(N){let T=0,z=0;for(;T<N;){const Z=n.charCodeAt(a);if(Z>=48&&Z<=57)z=z*16+Z-48;else if(Z>=65&&Z<=70)z=z*16+Z-65+10;else if(Z>=97&&Z<=102)z=z*16+Z-97+10;else break;a++,T++}return T<N&&(z=-1),z}function w(N){a=N,v="",m=0,S=16,k=0}function I(){const N=a;if(n.charCodeAt(a)===48)a++;else for(a++;a<n.length&&f(n.charCodeAt(a));)a++;if(a<n.length&&n.charCodeAt(a)===46)if(a++,a<n.length&&f(n.charCodeAt(a)))for(a++;a<n.length&&f(n.charCodeAt(a));)a++;else return k=3,n.substring(N,a);let T=a;if(a<n.length&&(n.charCodeAt(a)===69||n.charCodeAt(a)===101))if(a++,(a<n.length&&n.charCodeAt(a)===43||n.charCodeAt(a)===45)&&a++,a<n.length&&f(n.charCodeAt(a))){for(a++;a<n.length&&f(n.charCodeAt(a));)a++;T=a}else k=3;return n.substring(N,T)}function L(){let N="",T=a;for(;;){if(a>=d){N+=n.substring(T,a),k=2;break}const z=n.charCodeAt(a);if(z===34){N+=n.substring(T,a),a++;break}if(z===92){if(N+=n.substring(T,a),a++,a>=d){k=2;break}switch(n.charCodeAt(a++)){case 34:N+='"';break;case 92:N+="\\";break;case 47:N+="/";break;case 98:N+="\b";break;case 102:N+="\f";break;case 110:N+=`
`;break;case 114:N+="\r";break;case 116:N+="	";break;case 117:{const he=h(4);he>=0?N+=String.fromCharCode(he):k=4;break}default:k=5}T=a;continue}if(z>=0&&z<=31)if(E(z)){N+=n.substring(T,a),k=2;break}else k=6;a++}return N}function V(){if(v="",k=0,m=a,a>=d)return m=d,S=17;let N=n.charCodeAt(a);if($(N)){do a++,v+=String.fromCharCode(N),N=n.charCodeAt(a);while($(N));return S=15}if(E(N))return a++,v+=String.fromCharCode(N),N===13&&n.charCodeAt(a)===10&&(a++,v+=`
`),S=14;switch(N){case 123:return a++,S=1;case 125:return a++,S=2;case 91:return a++,S=3;case 93:return a++,S=4;case 58:return a++,S=6;case 44:return a++,S=5;case 34:return a++,v=L(),S=10;case 47:{const T=a-1;if(n.charCodeAt(a+1)===47){for(a+=2;a<d&&!E(n.charCodeAt(a));)a++;return v=n.substring(T,a),S=12}if(n.charCodeAt(a+1)===42){a+=2;const z=d-1;let Z=!1;for(;a<z;){if(n.charCodeAt(a)===42&&n.charCodeAt(a+1)===47){a+=2,Z=!0;break}a++}return Z||(a++,k=1),v=n.substring(T,a),S=13}return v+=String.fromCharCode(N),a++,S=16}case 45:if(v+=String.fromCharCode(N),a++,a===d||!f(n.charCodeAt(a)))return S=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return v+=I(),S=11;default:for(;a<d&&K(N);)a++,N=n.charCodeAt(a);if(m!==a){switch(v=n.substring(m,a),v){case"true":return S=8;case"false":return S=9;case"null":return S=7}return S=16}return v+=String.fromCharCode(N),a++,S=16}}function K(N){if($(N)||E(N))return!1;switch(N){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function R(){let N;do N=V();while(N>=12&&N<=15);return N}return{setPosition:w,getPosition:()=>a,scan:s?R:V,getToken:()=>S,getTokenValue:()=>v,getTokenOffset:()=>m,getTokenLength:()=>a-m,getTokenError:()=>k}}e.$1m=A;function $(n){return n===32||n===9||n===11||n===12||n===160||n===5760||n>=8192&&n<=8203||n===8239||n===8287||n===12288||n===65279}function E(n){return n===10||n===13||n===8232||n===8233}function f(n){return n>=48&&n<=57}var C;(function(n){n[n.nullCharacter=0]="nullCharacter",n[n.maxAsciiCharacter=127]="maxAsciiCharacter",n[n.lineFeed=10]="lineFeed",n[n.carriageReturn=13]="carriageReturn",n[n.lineSeparator=8232]="lineSeparator",n[n.paragraphSeparator=8233]="paragraphSeparator",n[n.nextLine=133]="nextLine",n[n.space=32]="space",n[n.nonBreakingSpace=160]="nonBreakingSpace",n[n.enQuad=8192]="enQuad",n[n.emQuad=8193]="emQuad",n[n.enSpace=8194]="enSpace",n[n.emSpace=8195]="emSpace",n[n.threePerEmSpace=8196]="threePerEmSpace",n[n.fourPerEmSpace=8197]="fourPerEmSpace",n[n.sixPerEmSpace=8198]="sixPerEmSpace",n[n.figureSpace=8199]="figureSpace",n[n.punctuationSpace=8200]="punctuationSpace",n[n.thinSpace=8201]="thinSpace",n[n.hairSpace=8202]="hairSpace",n[n.zeroWidthSpace=8203]="zeroWidthSpace",n[n.narrowNoBreakSpace=8239]="narrowNoBreakSpace",n[n.ideographicSpace=12288]="ideographicSpace",n[n.mathematicalSpace=8287]="mathematicalSpace",n[n.ogham=5760]="ogham",n[n._=95]="_",n[n.$=36]="$",n[n._0=48]="_0",n[n._1=49]="_1",n[n._2=50]="_2",n[n._3=51]="_3",n[n._4=52]="_4",n[n._5=53]="_5",n[n._6=54]="_6",n[n._7=55]="_7",n[n._8=56]="_8",n[n._9=57]="_9",n[n.a=97]="a",n[n.b=98]="b",n[n.c=99]="c",n[n.d=100]="d",n[n.e=101]="e",n[n.f=102]="f",n[n.g=103]="g",n[n.h=104]="h",n[n.i=105]="i",n[n.j=106]="j",n[n.k=107]="k",n[n.l=108]="l",n[n.m=109]="m",n[n.n=110]="n",n[n.o=111]="o",n[n.p=112]="p",n[n.q=113]="q",n[n.r=114]="r",n[n.s=115]="s",n[n.t=116]="t",n[n.u=117]="u",n[n.v=118]="v",n[n.w=119]="w",n[n.x=120]="x",n[n.y=121]="y",n[n.z=122]="z",n[n.A=65]="A",n[n.B=66]="B",n[n.C=67]="C",n[n.D=68]="D",n[n.E=69]="E",n[n.F=70]="F",n[n.G=71]="G",n[n.H=72]="H",n[n.I=73]="I",n[n.J=74]="J",n[n.K=75]="K",n[n.L=76]="L",n[n.M=77]="M",n[n.N=78]="N",n[n.O=79]="O",n[n.P=80]="P",n[n.Q=81]="Q",n[n.R=82]="R",n[n.S=83]="S",n[n.T=84]="T",n[n.U=85]="U",n[n.V=86]="V",n[n.W=87]="W",n[n.X=88]="X",n[n.Y=89]="Y",n[n.Z=90]="Z",n[n.ampersand=38]="ampersand",n[n.asterisk=42]="asterisk",n[n.at=64]="at",n[n.backslash=92]="backslash",n[n.bar=124]="bar",n[n.caret=94]="caret",n[n.closeBrace=125]="closeBrace",n[n.closeBracket=93]="closeBracket",n[n.closeParen=41]="closeParen",n[n.colon=58]="colon",n[n.comma=44]="comma",n[n.dot=46]="dot",n[n.doubleQuote=34]="doubleQuote",n[n.equals=61]="equals",n[n.exclamation=33]="exclamation",n[n.greaterThan=62]="greaterThan",n[n.lessThan=60]="lessThan",n[n.minus=45]="minus",n[n.openBrace=123]="openBrace",n[n.openBracket=91]="openBracket",n[n.openParen=40]="openParen",n[n.percent=37]="percent",n[n.plus=43]="plus",n[n.question=63]="question",n[n.semicolon=59]="semicolon",n[n.singleQuote=39]="singleQuote",n[n.slash=47]="slash",n[n.tilde=126]="tilde",n[n.backspace=8]="backspace",n[n.formFeed=12]="formFeed",n[n.byteOrderMark=65279]="byteOrderMark",n[n.tab=9]="tab",n[n.verticalTab=11]="verticalTab"})(C||(C={}));function D(n,s){const a=[],d=new Object;let v;const m={value:{},offset:0,length:0,type:"object",parent:void 0};let S=!1;function k(h,w,I,L){m.value=h,m.offset=w,m.length=I,m.type=L,m.colonOffset=void 0,v=m}try{c(n,{onObjectBegin:(h,w)=>{if(s<=h)throw d;v=void 0,S=s>h,a.push("")},onObjectProperty:(h,w,I)=>{if(s<w||(k(h,w,I,"property"),a[a.length-1]=h,s<=w+I))throw d},onObjectEnd:(h,w)=>{if(s<=h)throw d;v=void 0,a.pop()},onArrayBegin:(h,w)=>{if(s<=h)throw d;v=void 0,a.push(0)},onArrayEnd:(h,w)=>{if(s<=h)throw d;v=void 0,a.pop()},onLiteralValue:(h,w,I)=>{if(s<w||(k(h,w,I,l(h)),s<=w+I))throw d},onSeparator:(h,w,I)=>{if(s<=w)throw d;if(h===":"&&v&&v.type==="property")v.colonOffset=w,S=!1,v=void 0;else if(h===","){const L=a[a.length-1];typeof L=="number"?a[a.length-1]=L+1:(S=!0,a[a.length-1]=""),v=void 0}}})}catch(h){if(h!==d)throw h}return{path:a,previousNode:v,isAtPropertyKey:S,matches:h=>{let w=0;for(let I=0;w<h.length&&I<a.length;I++)if(h[w]===a[I]||h[w]==="*")w++;else if(h[w]!=="**")return!1;return w===h.length}}}e.$2m=D;function u(n,s=[],a=M.DEFAULT){let d=null,v=[];const m=[];function S(h){Array.isArray(v)?v.push(h):d!==null&&(v[d]=h)}return c(n,{onObjectBegin:()=>{const h={};S(h),m.push(v),v=h,d=null},onObjectProperty:h=>{d=h},onObjectEnd:()=>{v=m.pop()},onArrayBegin:()=>{const h=[];S(h),m.push(v),v=h,d=null},onArrayEnd:()=>{v=m.pop()},onLiteralValue:S,onError:(h,w,I)=>{s.push({error:h,offset:w,length:I})}},a),v[0]}e.$3m=u;function b(n,s=[],a=M.DEFAULT){let d={type:"array",offset:-1,length:-1,children:[],parent:void 0};function v(h){d.type==="property"&&(d.length=h-d.offset,d=d.parent)}function m(h){return d.children.push(h),h}c(n,{onObjectBegin:h=>{d=m({type:"object",offset:h,length:-1,parent:d,children:[]})},onObjectProperty:(h,w,I)=>{d=m({type:"property",offset:w,length:-1,parent:d,children:[]}),d.children.push({type:"string",value:h,offset:w,length:I,parent:d})},onObjectEnd:(h,w)=>{d.length=h+w-d.offset,d=d.parent,v(h+w)},onArrayBegin:(h,w)=>{d=m({type:"array",offset:h,length:-1,parent:d,children:[]})},onArrayEnd:(h,w)=>{d.length=h+w-d.offset,d=d.parent,v(h+w)},onLiteralValue:(h,w,I)=>{m({type:l(h),offset:w,length:I,parent:d,value:h}),v(w+I)},onSeparator:(h,w,I)=>{d.type==="property"&&(h===":"?d.colonOffset=w:h===","&&v(w))},onError:(h,w,I)=>{s.push({error:h,offset:w,length:I})}},a);const k=d.children[0];return k&&delete k.parent,k}e.$4m=b;function p(n,s){if(!n)return;let a=n;for(const d of s)if(typeof d=="string"){if(a.type!=="object"||!Array.isArray(a.children))return;let v=!1;for(const m of a.children)if(Array.isArray(m.children)&&m.children[0].value===d){a=m.children[1],v=!0;break}if(!v)return}else{const v=d;if(a.type!=="array"||v<0||!Array.isArray(a.children)||v>=a.children.length)return;a=a.children[v]}return a}e.$5m=p;function g(n){if(!n.parent||!n.parent.children)return[];const s=g(n.parent);if(n.parent.type==="property"){const a=n.parent.children[0].value;s.push(a)}else if(n.parent.type==="array"){const a=n.parent.children.indexOf(n);a!==-1&&s.push(a)}return s}e.$6m=g;function t(n){switch(n.type){case"array":return n.children.map(t);case"object":{const s=Object.create(null);for(const a of n.children){const d=a.children[1];d&&(s[a.children[0].value]=t(d))}return s}case"null":case"string":case"number":case"boolean":return n.value;default:return}}e.$7m=t;function i(n,s,a=!1){return s>=n.offset&&s<n.offset+n.length||a&&s===n.offset+n.length}e.$8m=i;function r(n,s,a=!1){if(i(n,s,a)){const d=n.children;if(Array.isArray(d))for(let v=0;v<d.length&&d[v].offset<=s;v++){const m=r(d[v],s,a);if(m)return m}return n}}e.$9m=r;function c(n,s,a=M.DEFAULT){const d=A(n,!1);function v(re){return re?()=>re(d.getTokenOffset(),d.getTokenLength()):()=>!0}function m(re){return re?Ae=>re(Ae,d.getTokenOffset(),d.getTokenLength()):()=>!0}const S=v(s.onObjectBegin),k=m(s.onObjectProperty),h=v(s.onObjectEnd),w=v(s.onArrayBegin),I=v(s.onArrayEnd),L=m(s.onLiteralValue),V=m(s.onSeparator),K=v(s.onComment),R=m(s.onError),N=a&&a.disallowComments,T=a&&a.allowTrailingComma;function z(){for(;;){const re=d.scan();switch(d.getTokenError()){case 4:Z(14);break;case 5:Z(15);break;case 3:Z(13);break;case 1:N||Z(11);break;case 2:Z(12);break;case 6:Z(16);break}switch(re){case 12:case 13:N?Z(10):K();break;case 16:Z(1);break;case 15:case 14:break;default:return re}}}function Z(re,Ae=[],se=[]){if(R(re),Ae.length+se.length>0){let X=d.getToken();for(;X!==17;){if(Ae.indexOf(X)!==-1){z();break}else if(se.indexOf(X)!==-1)break;X=z()}}}function he(re){const Ae=d.getTokenValue();return re?L(Ae):k(Ae),z(),!0}function ye(){switch(d.getToken()){case 11:{let re=0;try{re=JSON.parse(d.getTokenValue()),typeof re!="number"&&(Z(2),re=0)}catch{Z(2)}L(re);break}case 7:L(null);break;case 8:L(!0);break;case 9:L(!1);break;default:return!1}return z(),!0}function De(){return d.getToken()!==10?(Z(3,[],[2,5]),!1):(he(!1),d.getToken()===6?(V(":"),z(),$e()||Z(4,[],[2,5])):Z(5,[],[2,5]),!0)}function Se(){S(),z();let re=!1;for(;d.getToken()!==2&&d.getToken()!==17;){if(d.getToken()===5){if(re||Z(4,[],[]),V(","),z(),d.getToken()===2&&T)break}else re&&Z(6,[],[]);De()||Z(4,[],[2,5]),re=!0}return h(),d.getToken()!==2?Z(7,[2],[]):z(),!0}function fe(){w(),z();let re=!1;for(;d.getToken()!==4&&d.getToken()!==17;){if(d.getToken()===5){if(re||Z(4,[],[]),V(","),z(),d.getToken()===4&&T)break}else re&&Z(6,[],[]);$e()||Z(4,[],[4,5]),re=!0}return I(),d.getToken()!==4?Z(8,[4],[]):z(),!0}function $e(){switch(d.getToken()){case 3:return fe();case 1:return Se();case 10:return he(!0);default:return ye()}}return z(),d.getToken()===17?a.allowEmptyContent?!0:(Z(4,[],[]),!1):$e()?(d.getToken()!==17&&Z(9,[],[]),!0):(Z(4,[],[]),!1)}e.$0m=c;function o(n,s){const a=A(n),d=[];let v,m=0,S;do switch(S=a.getPosition(),v=a.scan(),v){case 12:case 13:case 17:m!==S&&d.push(n.substring(m,S)),s!==void 0&&d.push(a.getTokenValue().replace(/[^\r\n]/g,s)),m=a.getPosition();break}while(v!==17);return d.join("")}e.$$m=o;function l(n){switch(typeof n){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(n){if(Array.isArray(n))return"array"}else return"null";return"object"}default:return"null"}}e.$_m=l}),function(be,e){typeof define=="function"&&define.amd?define(Pe[120],Re([0]),e):typeof exports=="object"&&typeof module<"u"?e(exports):(be=typeof globalThis<"u"?globalThis:be||self,e(be.marked={}))}(this,function(be){"use strict";function e(le,ce){for(var we=0;we<ce.length;we++){var _=ce[we];_.enumerable=_.enumerable||!1,_.configurable=!0,"value"in _&&(_.writable=!0),Object.defineProperty(le,_.key,_)}}function y(le,ce,we){return ce&&e(le.prototype,ce),we&&e(le,we),Object.defineProperty(le,"prototype",{writable:!1}),le}function F(le,ce){if(le){if(typeof le=="string")return P(le,ce);var we=Object.prototype.toString.call(le).slice(8,-1);if(we==="Object"&&le.constructor&&(we=le.constructor.name),we==="Map"||we==="Set")return Array.from(le);if(we==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(we))return P(le,ce)}}function P(le,ce){(ce==null||ce>le.length)&&(ce=le.length);for(var we=0,_=new Array(ce);we<ce;we++)_[we]=le[we];return _}function M(le,ce){var we=typeof Symbol<"u"&&le[Symbol.iterator]||le["@@iterator"];if(we)return(we=we.call(le)).next.bind(we);if(Array.isArray(le)||(we=F(le))||ce&&le&&typeof le.length=="number"){we&&(le=we);var _=0;return function(){return _>=le.length?{done:!0}:{done:!1,value:le[_++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}function A(){return{async:!1,baseUrl:null,breaks:!1,extensions:null,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}be.defaults=A();function $(le){be.defaults=le}var E=/[&<>"']/,f=/[&<>"']/g,C=/[<>"']|&(?!#?\w+;)/,D=/[<>"']|&(?!#?\w+;)/g,u={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},b=function(ce){return u[ce]};function p(le,ce){if(ce){if(E.test(le))return le.replace(f,b)}else if(C.test(le))return le.replace(D,b);return le}var g=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function t(le){return le.replace(g,function(ce,we){return we=we.toLowerCase(),we==="colon"?":":we.charAt(0)==="#"?we.charAt(1)==="x"?String.fromCharCode(parseInt(we.substring(2),16)):String.fromCharCode(+we.substring(1)):""})}var i=/(^|[^\[])\^/g;function r(le,ce){le=typeof le=="string"?le:le.source,ce=ce||"";var we={replace:function(de,te){return te=te.source||te,te=te.replace(i,"$1"),le=le.replace(de,te),we},getRegex:function(){return new RegExp(le,ce)}};return we}var c=/[^\w:]/g,o=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function l(le,ce,we){if(le){var _;try{_=decodeURIComponent(t(we)).replace(c,"").toLowerCase()}catch{return null}if(_.indexOf("javascript:")===0||_.indexOf("vbscript:")===0||_.indexOf("data:")===0)return null}ce&&!o.test(we)&&(we=v(ce,we));try{we=encodeURI(we).replace(/%25/g,"%")}catch{return null}return we}var n={},s=/^[^:]+:\/*[^/]*$/,a=/^([^:]+:)[\s\S]*$/,d=/^([^:]+:\/*[^/]*)[\s\S]*$/;function v(le,ce){n[" "+le]||(s.test(le)?n[" "+le]=le+"/":n[" "+le]=h(le,"/",!0)),le=n[" "+le];var we=le.indexOf(":")===-1;return ce.substring(0,2)==="//"?we?ce:le.replace(a,"$1")+ce:ce.charAt(0)==="/"?we?ce:le.replace(d,"$1")+ce:le+ce}var m={exec:function(){}};function S(le){for(var ce=1,we,_;ce<arguments.length;ce++){we=arguments[ce];for(_ in we)Object.prototype.hasOwnProperty.call(we,_)&&(le[_]=we[_])}return le}function k(le,ce){var we=le.replace(/\|/g,function(te,ae,me){for(var Ie=!1,O=ae;--O>=0&&me[O]==="\\";)Ie=!Ie;return Ie?"|":" |"}),_=we.split(/ \|/),de=0;if(_[0].trim()||_.shift(),_.length>0&&!_[_.length-1].trim()&&_.pop(),_.length>ce)_.splice(ce);else for(;_.length<ce;)_.push("");for(;de<_.length;de++)_[de]=_[de].trim().replace(/\\\|/g,"|");return _}function h(le,ce,we){var _=le.length;if(_===0)return"";for(var de=0;de<_;){var te=le.charAt(_-de-1);if(te===ce&&!we)de++;else if(te!==ce&&we)de++;else break}return le.slice(0,_-de)}function w(le,ce){if(le.indexOf(ce[1])===-1)return-1;for(var we=le.length,_=0,de=0;de<we;de++)if(le[de]==="\\")de++;else if(le[de]===ce[0])_++;else if(le[de]===ce[1]&&(_--,_<0))return de;return-1}function I(le){le&&le.sanitize&&!le.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function L(le,ce){if(ce<1)return"";for(var we="";ce>1;)ce&1&&(we+=le),ce>>=1,le+=le;return we+le}function V(le,ce,we,_){var de=ce.href,te=ce.title?p(ce.title):null,ae=le[1].replace(/\\([\[\]])/g,"$1");if(le[0].charAt(0)!=="!"){_.state.inLink=!0;var me={type:"link",raw:we,href:de,title:te,text:ae,tokens:_.inlineTokens(ae)};return _.state.inLink=!1,me}return{type:"image",raw:we,href:de,title:te,text:p(ae)}}function K(le,ce){var we=le.match(/^(\s+)(?:```)/);if(we===null)return ce;var _=we[1];return ce.split(`
`).map(function(de){var te=de.match(/^\s+/);if(te===null)return de;var ae=te[0];return ae.length>=_.length?de.slice(_.length):de}).join(`
`)}var R=function(){function le(we){this.options=we||be.defaults}var ce=le.prototype;return ce.space=function(_){var de=this.rules.block.newline.exec(_);if(de&&de[0].length>0)return{type:"space",raw:de[0]}},ce.code=function(_){var de=this.rules.block.code.exec(_);if(de){var te=de[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:de[0],codeBlockStyle:"indented",text:this.options.pedantic?te:h(te,`
`)}}},ce.fences=function(_){var de=this.rules.block.fences.exec(_);if(de){var te=de[0],ae=K(te,de[3]||"");return{type:"code",raw:te,lang:de[2]?de[2].trim():de[2],text:ae}}},ce.heading=function(_){var de=this.rules.block.heading.exec(_);if(de){var te=de[2].trim();if(/#$/.test(te)){var ae=h(te,"#");(this.options.pedantic||!ae||/ $/.test(ae))&&(te=ae.trim())}return{type:"heading",raw:de[0],depth:de[1].length,text:te,tokens:this.lexer.inline(te)}}},ce.hr=function(_){var de=this.rules.block.hr.exec(_);if(de)return{type:"hr",raw:de[0]}},ce.blockquote=function(_){var de=this.rules.block.blockquote.exec(_);if(de){var te=de[0].replace(/^ *>[ \t]?/gm,"");return{type:"blockquote",raw:de[0],tokens:this.lexer.blockTokens(te,[]),text:te}}},ce.list=function(_){var de=this.rules.block.list.exec(_);if(de){var te,ae,me,Ie,O,W,G,J,q,x,ue,Oe,Ue=de[1].trim(),Ze=Ue.length>1,Je={type:"list",raw:"",ordered:Ze,start:Ze?+Ue.slice(0,-1):"",loose:!1,items:[]};Ue=Ze?"\\d{1,9}\\"+Ue.slice(-1):"\\"+Ue,this.options.pedantic&&(Ue=Ze?Ue:"[*+-]");for(var tt=new RegExp("^( {0,3}"+Ue+")((?:[	 ][^\\n]*)?(?:\\n|$))");_&&(Oe=!1,!(!(de=tt.exec(_))||this.rules.block.hr.test(_)));){if(te=de[0],_=_.substring(te.length),J=de[2].split(`
`,1)[0],q=_.split(`
`,1)[0],this.options.pedantic?(Ie=2,ue=J.trimLeft()):(Ie=de[2].search(/[^ ]/),Ie=Ie>4?1:Ie,ue=J.slice(Ie),Ie+=de[1].length),W=!1,!J&&/^ *$/.test(q)&&(te+=q+`
`,_=_.substring(q.length+1),Oe=!0),!Oe)for(var _e=new RegExp("^ {0,"+Math.min(3,Ie-1)+"}(?:[*+-]|\\d{1,9}[.)])((?: [^\\n]*)?(?:\\n|$))"),et=new RegExp("^ {0,"+Math.min(3,Ie-1)+"}((?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$)"),rt=new RegExp("^ {0,"+Math.min(3,Ie-1)+"}(?:```|~~~)"),nt=new RegExp("^ {0,"+Math.min(3,Ie-1)+"}#");_&&(x=_.split(`
`,1)[0],J=x,this.options.pedantic&&(J=J.replace(/^ {1,4}(?=( {4})*[^ ])/g,"  ")),!(rt.test(J)||nt.test(J)||_e.test(J)||et.test(_)));){if(J.search(/[^ ]/)>=Ie||!J.trim())ue+=`
`+J.slice(Ie);else if(!W)ue+=`
`+J;else break;!W&&!J.trim()&&(W=!0),te+=x+`
`,_=_.substring(x.length+1)}Je.loose||(G?Je.loose=!0:/\n *\n *$/.test(te)&&(G=!0)),this.options.gfm&&(ae=/^\[[ xX]\] /.exec(ue),ae&&(me=ae[0]!=="[ ] ",ue=ue.replace(/^\[[ xX]\] +/,""))),Je.items.push({type:"list_item",raw:te,task:!!ae,checked:me,loose:!1,text:ue}),Je.raw+=te}Je.items[Je.items.length-1].raw=te.trimRight(),Je.items[Je.items.length-1].text=ue.trimRight(),Je.raw=Je.raw.trimRight();var Ne=Je.items.length;for(O=0;O<Ne;O++){this.lexer.state.top=!1,Je.items[O].tokens=this.lexer.blockTokens(Je.items[O].text,[]);var dt=Je.items[O].tokens.filter(function(Q){return Q.type==="space"}),Y=dt.every(function(Q){for(var Ee=Q.raw.split(""),Be=0,He=M(Ee),Ye;!(Ye=He()).done;){var st=Ye.value;if(st===`
`&&(Be+=1),Be>1)return!0}return!1});!Je.loose&&dt.length&&Y&&(Je.loose=!0,Je.items[O].loose=!0)}return Je}},ce.html=function(_){var de=this.rules.block.html.exec(_);if(de){var te={type:"html",raw:de[0],pre:!this.options.sanitizer&&(de[1]==="pre"||de[1]==="script"||de[1]==="style"),text:de[0]};if(this.options.sanitize){var ae=this.options.sanitizer?this.options.sanitizer(de[0]):p(de[0]);te.type="paragraph",te.text=ae,te.tokens=this.lexer.inline(ae)}return te}},ce.def=function(_){var de=this.rules.block.def.exec(_);if(de){de[3]&&(de[3]=de[3].substring(1,de[3].length-1));var te=de[1].toLowerCase().replace(/\s+/g," ");return{type:"def",tag:te,raw:de[0],href:de[2],title:de[3]}}},ce.table=function(_){var de=this.rules.block.table.exec(_);if(de){var te={type:"table",header:k(de[1]).map(function(G){return{text:G}}),align:de[2].replace(/^ *|\| *$/g,"").split(/ *\| */),rows:de[3]&&de[3].trim()?de[3].replace(/\n[ \t]*$/,"").split(`
`):[]};if(te.header.length===te.align.length){te.raw=de[0];var ae=te.align.length,me,Ie,O,W;for(me=0;me<ae;me++)/^ *-+: *$/.test(te.align[me])?te.align[me]="right":/^ *:-+: *$/.test(te.align[me])?te.align[me]="center":/^ *:-+ *$/.test(te.align[me])?te.align[me]="left":te.align[me]=null;for(ae=te.rows.length,me=0;me<ae;me++)te.rows[me]=k(te.rows[me],te.header.length).map(function(G){return{text:G}});for(ae=te.header.length,Ie=0;Ie<ae;Ie++)te.header[Ie].tokens=this.lexer.inline(te.header[Ie].text);for(ae=te.rows.length,Ie=0;Ie<ae;Ie++)for(W=te.rows[Ie],O=0;O<W.length;O++)W[O].tokens=this.lexer.inline(W[O].text);return te}}},ce.lheading=function(_){var de=this.rules.block.lheading.exec(_);if(de)return{type:"heading",raw:de[0],depth:de[2].charAt(0)==="="?1:2,text:de[1],tokens:this.lexer.inline(de[1])}},ce.paragraph=function(_){var de=this.rules.block.paragraph.exec(_);if(de){var te=de[1].charAt(de[1].length-1)===`
`?de[1].slice(0,-1):de[1];return{type:"paragraph",raw:de[0],text:te,tokens:this.lexer.inline(te)}}},ce.text=function(_){var de=this.rules.block.text.exec(_);if(de)return{type:"text",raw:de[0],text:de[0],tokens:this.lexer.inline(de[0])}},ce.escape=function(_){var de=this.rules.inline.escape.exec(_);if(de)return{type:"escape",raw:de[0],text:p(de[1])}},ce.tag=function(_){var de=this.rules.inline.tag.exec(_);if(de)return!this.lexer.state.inLink&&/^<a /i.test(de[0])?this.lexer.state.inLink=!0:this.lexer.state.inLink&&/^<\/a>/i.test(de[0])&&(this.lexer.state.inLink=!1),!this.lexer.state.inRawBlock&&/^<(pre|code|kbd|script)(\s|>)/i.test(de[0])?this.lexer.state.inRawBlock=!0:this.lexer.state.inRawBlock&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(de[0])&&(this.lexer.state.inRawBlock=!1),{type:this.options.sanitize?"text":"html",raw:de[0],inLink:this.lexer.state.inLink,inRawBlock:this.lexer.state.inRawBlock,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(de[0]):p(de[0]):de[0]}},ce.link=function(_){var de=this.rules.inline.link.exec(_);if(de){var te=de[2].trim();if(!this.options.pedantic&&/^</.test(te)){if(!/>$/.test(te))return;var ae=h(te.slice(0,-1),"\\");if((te.length-ae.length)%2===0)return}else{var me=w(de[2],"()");if(me>-1){var Ie=de[0].indexOf("!")===0?5:4,O=Ie+de[1].length+me;de[2]=de[2].substring(0,me),de[0]=de[0].substring(0,O).trim(),de[3]=""}}var W=de[2],G="";if(this.options.pedantic){var J=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(W);J&&(W=J[1],G=J[3])}else G=de[3]?de[3].slice(1,-1):"";return W=W.trim(),/^</.test(W)&&(this.options.pedantic&&!/>$/.test(te)?W=W.slice(1):W=W.slice(1,-1)),V(de,{href:W&&W.replace(this.rules.inline._escapes,"$1"),title:G&&G.replace(this.rules.inline._escapes,"$1")},de[0],this.lexer)}},ce.reflink=function(_,de){var te;if((te=this.rules.inline.reflink.exec(_))||(te=this.rules.inline.nolink.exec(_))){var ae=(te[2]||te[1]).replace(/\s+/g," ");if(ae=de[ae.toLowerCase()],!ae||!ae.href){var me=te[0].charAt(0);return{type:"text",raw:me,text:me}}return V(te,ae,te[0],this.lexer)}},ce.emStrong=function(_,de,te){te===void 0&&(te="");var ae=this.rules.inline.emStrong.lDelim.exec(_);if(ae&&!(ae[3]&&te.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u0870-\u0887\u0889-\u088E\u08A0-\u08C9\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C5D\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u1711\u171F-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4C\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7CA\uA7D0\uA7D1\uA7D3\uA7D5-\uA7D9\uA7F2-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDD70-\uDD7A\uDD7C-\uDD8A\uDD8C-\uDD92\uDD94\uDD95\uDD97-\uDDA1\uDDA3-\uDDB1\uDDB3-\uDDB9\uDDBB\uDDBC\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67\uDF80-\uDF85\uDF87-\uDFB0\uDFB2-\uDFBA]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDF70-\uDF81\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC71\uDC72\uDC75\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B\uDF40-\uDF46]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEB0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|\uD80B[\uDF90-\uDFF0]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDE70-\uDEBE\uDEC0-\uDEC9\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82B[\uDFF0-\uDFF3\uDFF5-\uDFFB\uDFFD\uDFFE]|\uD82C[\uDC00-\uDD22\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD837[\uDF00-\uDF1E]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDE90-\uDEAD\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD839[\uDFE0-\uDFE6\uDFE8-\uDFEB\uDFED\uDFEE\uDFF0-\uDFFE]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDF\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF38\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var me=ae[1]||ae[2]||"";if(!me||me&&(te===""||this.rules.inline.punctuation.exec(te))){var Ie=ae[0].length-1,O,W,G=Ie,J=0,q=ae[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(q.lastIndex=0,de=de.slice(-1*_.length+Ie);(ae=q.exec(de))!=null;)if(O=ae[1]||ae[2]||ae[3]||ae[4]||ae[5]||ae[6],!!O){if(W=O.length,ae[3]||ae[4]){G+=W;continue}else if((ae[5]||ae[6])&&Ie%3&&!((Ie+W)%3)){J+=W;continue}if(G-=W,!(G>0)){if(W=Math.min(W,W+G+J),Math.min(Ie,W)%2){var x=_.slice(1,Ie+ae.index+W);return{type:"em",raw:_.slice(0,Ie+ae.index+W+1),text:x,tokens:this.lexer.inlineTokens(x)}}var ue=_.slice(2,Ie+ae.index+W-1);return{type:"strong",raw:_.slice(0,Ie+ae.index+W+1),text:ue,tokens:this.lexer.inlineTokens(ue)}}}}}},ce.codespan=function(_){var de=this.rules.inline.code.exec(_);if(de){var te=de[2].replace(/\n/g," "),ae=/[^ ]/.test(te),me=/^ /.test(te)&&/ $/.test(te);return ae&&me&&(te=te.substring(1,te.length-1)),te=p(te,!0),{type:"codespan",raw:de[0],text:te}}},ce.br=function(_){var de=this.rules.inline.br.exec(_);if(de)return{type:"br",raw:de[0]}},ce.del=function(_){var de=this.rules.inline.del.exec(_);if(de)return{type:"del",raw:de[0],text:de[2],tokens:this.lexer.inlineTokens(de[2])}},ce.autolink=function(_,de){var te=this.rules.inline.autolink.exec(_);if(te){var ae,me;return te[2]==="@"?(ae=p(this.options.mangle?de(te[1]):te[1]),me="mailto:"+ae):(ae=p(te[1]),me=ae),{type:"link",raw:te[0],text:ae,href:me,tokens:[{type:"text",raw:ae,text:ae}]}}},ce.url=function(_,de){var te;if(te=this.rules.inline.url.exec(_)){var ae,me;if(te[2]==="@")ae=p(this.options.mangle?de(te[0]):te[0]),me="mailto:"+ae;else{var Ie;do Ie=te[0],te[0]=this.rules.inline._backpedal.exec(te[0])[0];while(Ie!==te[0]);ae=p(te[0]),te[1]==="www."?me="http://"+ae:me=ae}return{type:"link",raw:te[0],text:ae,href:me,tokens:[{type:"text",raw:ae,text:ae}]}}},ce.inlineText=function(_,de){var te=this.rules.inline.text.exec(_);if(te){var ae;return this.lexer.state.inRawBlock?ae=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(te[0]):p(te[0]):te[0]:ae=p(this.options.smartypants?de(te[0]):te[0]),{type:"text",raw:te[0],text:ae}}},le}(),N={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?=\n|$)|$)/,hr:/^ {0,3}((?:-[\t ]*){3,}|(?:_[ \t]*){3,}|(?:\*[ \t]*){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3}bull)([ \t][^\n]+?)?(?:\n|$)/,html:"^ {0,3}(?:<(script|pre|style|textarea)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:(?:\\n *)+\\n|$)|<(?!script|pre|style|textarea)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$)|</(?!script|pre|style|textarea)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$))",def:/^ {0,3}\[(label)\]: *(?:\n *)?<?([^\s>]+)>?(?:(?: +(?:\n *)?| *\n *)(title))? *(?:\n+|$)/,table:m,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html|table| +\n)[^\n]+)*)/,text:/^[^\n]+/};N._label=/(?!\s*\])(?:\\.|[^\[\]\\])+/,N._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,N.def=r(N.def).replace("label",N._label).replace("title",N._title).getRegex(),N.bullet=/(?:[*+-]|\d{1,9}[.)])/,N.listItemStart=r(/^( *)(bull) */).replace("bull",N.bullet).getRegex(),N.list=r(N.list).replace(/bull/g,N.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+N.def.source+")").getRegex(),N._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",N._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,N.html=r(N.html,"i").replace("comment",N._comment).replace("tag",N._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),N.paragraph=r(N._paragraph).replace("hr",N.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("|table","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",N._tag).getRegex(),N.blockquote=r(N.blockquote).replace("paragraph",N.paragraph).getRegex(),N.normal=S({},N),N.gfm=S({},N.normal,{table:"^ *([^\\n ].*\\|.*)\\n {0,3}(?:\\| *)?(:?-+:? *(?:\\| *:?-+:? *)*)(?:\\| *)?(?:\\n((?:(?! *\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),N.gfm.table=r(N.gfm.table).replace("hr",N.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",N._tag).getRegex(),N.gfm.paragraph=r(N._paragraph).replace("hr",N.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("table",N.gfm.table).replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",N._tag).getRegex(),N.pedantic=S({},N.normal,{html:r(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",N._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:m,paragraph:r(N.normal._paragraph).replace("hr",N.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",N.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var T={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:m,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(ref)\]/,nolink:/^!?\[(ref)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/^[^_*]*?\_\_[^_*]*?\*[^_*]*?(?=\_\_)|[^*]+(?=[^*])|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/^[^_*]*?\*\*[^_*]*?\_[^_*]*?(?=\*\*)|[^_]+(?=[^_])|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:m,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};T._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",T.punctuation=r(T.punctuation).replace(/punctuation/g,T._punctuation).getRegex(),T.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,T.escapedEmSt=/\\\*|\\_/g,T._comment=r(N._comment).replace("(?:-->|$)","-->").getRegex(),T.emStrong.lDelim=r(T.emStrong.lDelim).replace(/punct/g,T._punctuation).getRegex(),T.emStrong.rDelimAst=r(T.emStrong.rDelimAst,"g").replace(/punct/g,T._punctuation).getRegex(),T.emStrong.rDelimUnd=r(T.emStrong.rDelimUnd,"g").replace(/punct/g,T._punctuation).getRegex(),T._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,T._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,T._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,T.autolink=r(T.autolink).replace("scheme",T._scheme).replace("email",T._email).getRegex(),T._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,T.tag=r(T.tag).replace("comment",T._comment).replace("attribute",T._attribute).getRegex(),T._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,T._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,T._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,T.link=r(T.link).replace("label",T._label).replace("href",T._href).replace("title",T._title).getRegex(),T.reflink=r(T.reflink).replace("label",T._label).replace("ref",N._label).getRegex(),T.nolink=r(T.nolink).replace("ref",N._label).getRegex(),T.reflinkSearch=r(T.reflinkSearch,"g").replace("reflink",T.reflink).replace("nolink",T.nolink).getRegex(),T.normal=S({},T),T.pedantic=S({},T.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:r(/^!?\[(label)\]\((.*?)\)/).replace("label",T._label).getRegex(),reflink:r(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",T._label).getRegex()}),T.gfm=S({},T.normal,{escape:r(T.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)))/}),T.gfm.url=r(T.gfm.url,"i").replace("email",T.gfm._extended_email).getRegex(),T.breaks=S({},T.gfm,{br:r(T.br).replace("{2,}","*").getRegex(),text:r(T.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});function z(le){return le.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function Z(le){var ce="",we,_,de=le.length;for(we=0;we<de;we++)_=le.charCodeAt(we),Math.random()>.5&&(_="x"+_.toString(16)),ce+="&#"+_+";";return ce}var he=function(){function le(we){this.tokens=[],this.tokens.links=Object.create(null),this.options=we||be.defaults,this.options.tokenizer=this.options.tokenizer||new R,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options,this.tokenizer.lexer=this,this.inlineQueue=[],this.state={inLink:!1,inRawBlock:!1,top:!0};var _={block:N.normal,inline:T.normal};this.options.pedantic?(_.block=N.pedantic,_.inline=T.pedantic):this.options.gfm&&(_.block=N.gfm,this.options.breaks?_.inline=T.breaks:_.inline=T.gfm),this.tokenizer.rules=_}le.lex=function(_,de){var te=new le(de);return te.lex(_)},le.lexInline=function(_,de){var te=new le(de);return te.inlineTokens(_)};var ce=le.prototype;return ce.lex=function(_){_=_.replace(/\r\n|\r/g,`
`),this.blockTokens(_,this.tokens);for(var de;de=this.inlineQueue.shift();)this.inlineTokens(de.src,de.tokens);return this.tokens},ce.blockTokens=function(_,de){var te=this;de===void 0&&(de=[]),this.options.pedantic?_=_.replace(/\t/g,"    ").replace(/^ +$/gm,""):_=_.replace(/^( *)(\t+)/gm,function(G,J,q){return J+"    ".repeat(q.length)});for(var ae,me,Ie,O;_;)if(!(this.options.extensions&&this.options.extensions.block&&this.options.extensions.block.some(function(G){return(ae=G.call({lexer:te},_,de))?(_=_.substring(ae.raw.length),de.push(ae),!0):!1}))){if(ae=this.tokenizer.space(_)){_=_.substring(ae.raw.length),ae.raw.length===1&&de.length>0?de[de.length-1].raw+=`
`:de.push(ae);continue}if(ae=this.tokenizer.code(_)){_=_.substring(ae.raw.length),me=de[de.length-1],me&&(me.type==="paragraph"||me.type==="text")?(me.raw+=`
`+ae.raw,me.text+=`
`+ae.text,this.inlineQueue[this.inlineQueue.length-1].src=me.text):de.push(ae);continue}if(ae=this.tokenizer.fences(_)){_=_.substring(ae.raw.length),de.push(ae);continue}if(ae=this.tokenizer.heading(_)){_=_.substring(ae.raw.length),de.push(ae);continue}if(ae=this.tokenizer.hr(_)){_=_.substring(ae.raw.length),de.push(ae);continue}if(ae=this.tokenizer.blockquote(_)){_=_.substring(ae.raw.length),de.push(ae);continue}if(ae=this.tokenizer.list(_)){_=_.substring(ae.raw.length),de.push(ae);continue}if(ae=this.tokenizer.html(_)){_=_.substring(ae.raw.length),de.push(ae);continue}if(ae=this.tokenizer.def(_)){_=_.substring(ae.raw.length),me=de[de.length-1],me&&(me.type==="paragraph"||me.type==="text")?(me.raw+=`
`+ae.raw,me.text+=`
`+ae.raw,this.inlineQueue[this.inlineQueue.length-1].src=me.text):this.tokens.links[ae.tag]||(this.tokens.links[ae.tag]={href:ae.href,title:ae.title});continue}if(ae=this.tokenizer.table(_)){_=_.substring(ae.raw.length),de.push(ae);continue}if(ae=this.tokenizer.lheading(_)){_=_.substring(ae.raw.length),de.push(ae);continue}if(Ie=_,this.options.extensions&&this.options.extensions.startBlock&&function(){var G=1/0,J=_.slice(1),q=void 0;te.options.extensions.startBlock.forEach(function(x){q=x.call({lexer:this},J),typeof q=="number"&&q>=0&&(G=Math.min(G,q))}),G<1/0&&G>=0&&(Ie=_.substring(0,G+1))}(),this.state.top&&(ae=this.tokenizer.paragraph(Ie))){me=de[de.length-1],O&&me.type==="paragraph"?(me.raw+=`
`+ae.raw,me.text+=`
`+ae.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=me.text):de.push(ae),O=Ie.length!==_.length,_=_.substring(ae.raw.length);continue}if(ae=this.tokenizer.text(_)){_=_.substring(ae.raw.length),me=de[de.length-1],me&&me.type==="text"?(me.raw+=`
`+ae.raw,me.text+=`
`+ae.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=me.text):de.push(ae);continue}if(_){var W="Infinite loop on byte: "+_.charCodeAt(0);if(this.options.silent){console.error(W);break}else throw new Error(W)}}return this.state.top=!0,de},ce.inline=function(_,de){return de===void 0&&(de=[]),this.inlineQueue.push({src:_,tokens:de}),de},ce.inlineTokens=function(_,de){var te=this;de===void 0&&(de=[]);var ae,me,Ie,O=_,W,G,J;if(this.tokens.links){var q=Object.keys(this.tokens.links);if(q.length>0)for(;(W=this.tokenizer.rules.inline.reflinkSearch.exec(O))!=null;)q.includes(W[0].slice(W[0].lastIndexOf("[")+1,-1))&&(O=O.slice(0,W.index)+"["+L("a",W[0].length-2)+"]"+O.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(W=this.tokenizer.rules.inline.blockSkip.exec(O))!=null;)O=O.slice(0,W.index)+"["+L("a",W[0].length-2)+"]"+O.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(W=this.tokenizer.rules.inline.escapedEmSt.exec(O))!=null;)O=O.slice(0,W.index)+"++"+O.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;_;)if(G||(J=""),G=!1,!(this.options.extensions&&this.options.extensions.inline&&this.options.extensions.inline.some(function(ue){return(ae=ue.call({lexer:te},_,de))?(_=_.substring(ae.raw.length),de.push(ae),!0):!1}))){if(ae=this.tokenizer.escape(_)){_=_.substring(ae.raw.length),de.push(ae);continue}if(ae=this.tokenizer.tag(_)){_=_.substring(ae.raw.length),me=de[de.length-1],me&&ae.type==="text"&&me.type==="text"?(me.raw+=ae.raw,me.text+=ae.text):de.push(ae);continue}if(ae=this.tokenizer.link(_)){_=_.substring(ae.raw.length),de.push(ae);continue}if(ae=this.tokenizer.reflink(_,this.tokens.links)){_=_.substring(ae.raw.length),me=de[de.length-1],me&&ae.type==="text"&&me.type==="text"?(me.raw+=ae.raw,me.text+=ae.text):de.push(ae);continue}if(ae=this.tokenizer.emStrong(_,O,J)){_=_.substring(ae.raw.length),de.push(ae);continue}if(ae=this.tokenizer.codespan(_)){_=_.substring(ae.raw.length),de.push(ae);continue}if(ae=this.tokenizer.br(_)){_=_.substring(ae.raw.length),de.push(ae);continue}if(ae=this.tokenizer.del(_)){_=_.substring(ae.raw.length),de.push(ae);continue}if(ae=this.tokenizer.autolink(_,Z)){_=_.substring(ae.raw.length),de.push(ae);continue}if(!this.state.inLink&&(ae=this.tokenizer.url(_,Z))){_=_.substring(ae.raw.length),de.push(ae);continue}if(Ie=_,this.options.extensions&&this.options.extensions.startInline&&function(){var ue=1/0,Oe=_.slice(1),Ue=void 0;te.options.extensions.startInline.forEach(function(Ze){Ue=Ze.call({lexer:this},Oe),typeof Ue=="number"&&Ue>=0&&(ue=Math.min(ue,Ue))}),ue<1/0&&ue>=0&&(Ie=_.substring(0,ue+1))}(),ae=this.tokenizer.inlineText(Ie,z)){_=_.substring(ae.raw.length),ae.raw.slice(-1)!=="_"&&(J=ae.raw.slice(-1)),G=!0,me=de[de.length-1],me&&me.type==="text"?(me.raw+=ae.raw,me.text+=ae.text):de.push(ae);continue}if(_){var x="Infinite loop on byte: "+_.charCodeAt(0);if(this.options.silent){console.error(x);break}else throw new Error(x)}}return de},y(le,null,[{key:"rules",get:function(){return{block:N,inline:T}}}]),le}(),ye=function(){function le(we){this.options=we||be.defaults}var ce=le.prototype;return ce.code=function(_,de,te){var ae=(de||"").match(/\S*/)[0];if(this.options.highlight){var me=this.options.highlight(_,ae);me!=null&&me!==_&&(te=!0,_=me)}return _=_.replace(/\n$/,"")+`
`,ae?'<pre><code class="'+this.options.langPrefix+p(ae,!0)+'">'+(te?_:p(_,!0))+`</code></pre>
`:"<pre><code>"+(te?_:p(_,!0))+`</code></pre>
`},ce.blockquote=function(_){return`<blockquote>
`+_+`</blockquote>
`},ce.html=function(_){return _},ce.heading=function(_,de,te,ae){if(this.options.headerIds){var me=this.options.headerPrefix+ae.slug(te);return"<h"+de+' id="'+me+'">'+_+"</h"+de+`>
`}return"<h"+de+">"+_+"</h"+de+`>
`},ce.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},ce.list=function(_,de,te){var ae=de?"ol":"ul",me=de&&te!==1?' start="'+te+'"':"";return"<"+ae+me+`>
`+_+"</"+ae+`>
`},ce.listitem=function(_){return"<li>"+_+`</li>
`},ce.checkbox=function(_){return"<input "+(_?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},ce.paragraph=function(_){return"<p>"+_+`</p>
`},ce.table=function(_,de){return de&&(de="<tbody>"+de+"</tbody>"),`<table>
<thead>
`+_+`</thead>
`+de+`</table>
`},ce.tablerow=function(_){return`<tr>
`+_+`</tr>
`},ce.tablecell=function(_,de){var te=de.header?"th":"td",ae=de.align?"<"+te+' align="'+de.align+'">':"<"+te+">";return ae+_+("</"+te+`>
`)},ce.strong=function(_){return"<strong>"+_+"</strong>"},ce.em=function(_){return"<em>"+_+"</em>"},ce.codespan=function(_){return"<code>"+_+"</code>"},ce.br=function(){return this.options.xhtml?"<br/>":"<br>"},ce.del=function(_){return"<del>"+_+"</del>"},ce.link=function(_,de,te){if(_=l(this.options.sanitize,this.options.baseUrl,_),_===null)return te;var ae='<a href="'+p(_)+'"';return de&&(ae+=' title="'+de+'"'),ae+=">"+te+"</a>",ae},ce.image=function(_,de,te){if(_=l(this.options.sanitize,this.options.baseUrl,_),_===null)return te;var ae='<img src="'+_+'" alt="'+te+'"';return de&&(ae+=' title="'+de+'"'),ae+=this.options.xhtml?"/>":">",ae},ce.text=function(_){return _},le}(),De=function(){function le(){}var ce=le.prototype;return ce.strong=function(_){return _},ce.em=function(_){return _},ce.codespan=function(_){return _},ce.del=function(_){return _},ce.html=function(_){return _},ce.text=function(_){return _},ce.link=function(_,de,te){return""+te},ce.image=function(_,de,te){return""+te},ce.br=function(){return""},le}(),Se=function(){function le(){this.seen={}}var ce=le.prototype;return ce.serialize=function(_){return _.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},ce.getNextSafeSlug=function(_,de){var te=_,ae=0;if(this.seen.hasOwnProperty(te)){ae=this.seen[_];do ae++,te=_+"-"+ae;while(this.seen.hasOwnProperty(te))}return de||(this.seen[_]=ae,this.seen[te]=0),te},ce.slug=function(_,de){de===void 0&&(de={});var te=this.serialize(_);return this.getNextSafeSlug(te,de.dryrun)},le}(),fe=function(){function le(we){this.options=we||be.defaults,this.options.renderer=this.options.renderer||new ye,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new De,this.slugger=new Se}le.parse=function(_,de){var te=new le(de);return te.parse(_)},le.parseInline=function(_,de){var te=new le(de);return te.parseInline(_)};var ce=le.prototype;return ce.parse=function(_,de){de===void 0&&(de=!0);var te="",ae,me,Ie,O,W,G,J,q,x,ue,Oe,Ue,Ze,Je,tt,_e,et,rt,nt,Ne=_.length;for(ae=0;ae<Ne;ae++){if(ue=_[ae],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[ue.type]&&(nt=this.options.extensions.renderers[ue.type].call({parser:this},ue),nt!==!1||!["space","hr","heading","code","table","blockquote","list","html","paragraph","text"].includes(ue.type))){te+=nt||"";continue}switch(ue.type){case"space":continue;case"hr":{te+=this.renderer.hr();continue}case"heading":{te+=this.renderer.heading(this.parseInline(ue.tokens),ue.depth,t(this.parseInline(ue.tokens,this.textRenderer)),this.slugger);continue}case"code":{te+=this.renderer.code(ue.text,ue.lang,ue.escaped);continue}case"table":{for(q="",J="",O=ue.header.length,me=0;me<O;me++)J+=this.renderer.tablecell(this.parseInline(ue.header[me].tokens),{header:!0,align:ue.align[me]});for(q+=this.renderer.tablerow(J),x="",O=ue.rows.length,me=0;me<O;me++){for(G=ue.rows[me],J="",W=G.length,Ie=0;Ie<W;Ie++)J+=this.renderer.tablecell(this.parseInline(G[Ie].tokens),{header:!1,align:ue.align[Ie]});x+=this.renderer.tablerow(J)}te+=this.renderer.table(q,x);continue}case"blockquote":{x=this.parse(ue.tokens),te+=this.renderer.blockquote(x);continue}case"list":{for(Oe=ue.ordered,Ue=ue.start,Ze=ue.loose,O=ue.items.length,x="",me=0;me<O;me++)tt=ue.items[me],_e=tt.checked,et=tt.task,Je="",tt.task&&(rt=this.renderer.checkbox(_e),Ze?tt.tokens.length>0&&tt.tokens[0].type==="paragraph"?(tt.tokens[0].text=rt+" "+tt.tokens[0].text,tt.tokens[0].tokens&&tt.tokens[0].tokens.length>0&&tt.tokens[0].tokens[0].type==="text"&&(tt.tokens[0].tokens[0].text=rt+" "+tt.tokens[0].tokens[0].text)):tt.tokens.unshift({type:"text",text:rt}):Je+=rt),Je+=this.parse(tt.tokens,Ze),x+=this.renderer.listitem(Je,et,_e);te+=this.renderer.list(x,Oe,Ue);continue}case"html":{te+=this.renderer.html(ue.text);continue}case"paragraph":{te+=this.renderer.paragraph(this.parseInline(ue.tokens));continue}case"text":{for(x=ue.tokens?this.parseInline(ue.tokens):ue.text;ae+1<Ne&&_[ae+1].type==="text";)ue=_[++ae],x+=`
`+(ue.tokens?this.parseInline(ue.tokens):ue.text);te+=de?this.renderer.paragraph(x):x;continue}default:{var dt='Token with "'+ue.type+'" type was not found.';if(this.options.silent){console.error(dt);return}else throw new Error(dt)}}}return te},ce.parseInline=function(_,de){de=de||this.renderer;var te="",ae,me,Ie,O=_.length;for(ae=0;ae<O;ae++){if(me=_[ae],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[me.type]&&(Ie=this.options.extensions.renderers[me.type].call({parser:this},me),Ie!==!1||!["escape","html","link","image","strong","em","codespan","br","del","text"].includes(me.type))){te+=Ie||"";continue}switch(me.type){case"escape":{te+=de.text(me.text);break}case"html":{te+=de.html(me.text);break}case"link":{te+=de.link(me.href,me.title,this.parseInline(me.tokens,de));break}case"image":{te+=de.image(me.href,me.title,me.text);break}case"strong":{te+=de.strong(this.parseInline(me.tokens,de));break}case"em":{te+=de.em(this.parseInline(me.tokens,de));break}case"codespan":{te+=de.codespan(me.text);break}case"br":{te+=de.br();break}case"del":{te+=de.del(this.parseInline(me.tokens,de));break}case"text":{te+=de.text(me.text);break}default:{var W='Token with "'+me.type+'" type was not found.';if(this.options.silent){console.error(W);return}else throw new Error(W)}}}return te},le}();function $e(le,ce,we){if(typeof le>"u"||le===null)throw new Error("marked(): input parameter is undefined or null");if(typeof le!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(le)+", string expected");if(typeof ce=="function"&&(we=ce,ce=null),ce=S({},$e.defaults,ce||{}),I(ce),we){var _=ce.highlight,de;try{de=he.lex(le,ce)}catch(O){return we(O)}var te=function(W){var G;if(!W)try{ce.walkTokens&&$e.walkTokens(de,ce.walkTokens),G=fe.parse(de,ce)}catch(J){W=J}return ce.highlight=_,W?we(W):we(null,G)};if(!_||_.length<3||(delete ce.highlight,!de.length))return te();var ae=0;$e.walkTokens(de,function(O){O.type==="code"&&(ae++,setTimeout(function(){_(O.text,O.lang,function(W,G){if(W)return te(W);G!=null&&G!==O.text&&(O.text=G,O.escaped=!0),ae--,ae===0&&te()})},0))}),ae===0&&te();return}function me(O){if(O.message+=`
Please report this to https://github.com/markedjs/marked.`,ce.silent)return"<p>An error occurred:</p><pre>"+p(O.message+"",!0)+"</pre>";throw O}try{var Ie=he.lex(le,ce);if(ce.walkTokens){if(ce.async)return Promise.all($e.walkTokens(Ie,ce.walkTokens)).then(function(){return fe.parse(Ie,ce)}).catch(me);$e.walkTokens(Ie,ce.walkTokens)}return fe.parse(Ie,ce)}catch(O){me(O)}}$e.options=$e.setOptions=function(le){return S($e.defaults,le),$($e.defaults),$e},$e.getDefaults=A,$e.defaults=be.defaults,$e.use=function(){for(var le=arguments.length,ce=new Array(le),we=0;we<le;we++)ce[we]=arguments[we];var _=S.apply(void 0,[{}].concat(ce)),de=$e.defaults.extensions||{renderers:{},childTokens:{}},te;ce.forEach(function(ae){if(ae.extensions&&(te=!0,ae.extensions.forEach(function(Ie){if(!Ie.name)throw new Error("extension name required");if(Ie.renderer){var O=de.renderers?de.renderers[Ie.name]:null;O?de.renderers[Ie.name]=function(){for(var W=arguments.length,G=new Array(W),J=0;J<W;J++)G[J]=arguments[J];var q=Ie.renderer.apply(this,G);return q===!1&&(q=O.apply(this,G)),q}:de.renderers[Ie.name]=Ie.renderer}if(Ie.tokenizer){if(!Ie.level||Ie.level!=="block"&&Ie.level!=="inline")throw new Error("extension level must be 'block' or 'inline'");de[Ie.level]?de[Ie.level].unshift(Ie.tokenizer):de[Ie.level]=[Ie.tokenizer],Ie.start&&(Ie.level==="block"?de.startBlock?de.startBlock.push(Ie.start):de.startBlock=[Ie.start]:Ie.level==="inline"&&(de.startInline?de.startInline.push(Ie.start):de.startInline=[Ie.start]))}Ie.childTokens&&(de.childTokens[Ie.name]=Ie.childTokens)})),ae.renderer&&function(){var Ie=$e.defaults.renderer||new ye,O=function(J){var q=Ie[J];Ie[J]=function(){for(var x=arguments.length,ue=new Array(x),Oe=0;Oe<x;Oe++)ue[Oe]=arguments[Oe];var Ue=ae.renderer[J].apply(Ie,ue);return Ue===!1&&(Ue=q.apply(Ie,ue)),Ue}};for(var W in ae.renderer)O(W);_.renderer=Ie}(),ae.tokenizer&&function(){var Ie=$e.defaults.tokenizer||new R,O=function(J){var q=Ie[J];Ie[J]=function(){for(var x=arguments.length,ue=new Array(x),Oe=0;Oe<x;Oe++)ue[Oe]=arguments[Oe];var Ue=ae.tokenizer[J].apply(Ie,ue);return Ue===!1&&(Ue=q.apply(Ie,ue)),Ue}};for(var W in ae.tokenizer)O(W);_.tokenizer=Ie}(),ae.walkTokens){var me=$e.defaults.walkTokens;_.walkTokens=function(Ie){var O=[];return O.push(ae.walkTokens.call(this,Ie)),me&&(O=O.concat(me.call(this,Ie))),O}}te&&(_.extensions=de),$e.setOptions(_)})},$e.walkTokens=function(le,ce){for(var we=[],_=function(){var me=te.value;switch(we=we.concat(ce.call($e,me)),me.type){case"table":{for(var Ie=M(me.header),O;!(O=Ie()).done;){var W=O.value;we=we.concat($e.walkTokens(W.tokens,ce))}for(var G=M(me.rows),J;!(J=G()).done;)for(var q=J.value,x=M(q),ue;!(ue=x()).done;){var Oe=ue.value;we=we.concat($e.walkTokens(Oe.tokens,ce))}break}case"list":{we=we.concat($e.walkTokens(me.items,ce));break}default:$e.defaults.extensions&&$e.defaults.extensions.childTokens&&$e.defaults.extensions.childTokens[me.type]?$e.defaults.extensions.childTokens[me.type].forEach(function(Ue){we=we.concat($e.walkTokens(me[Ue],ce))}):me.tokens&&(we=we.concat($e.walkTokens(me.tokens,ce)))}},de=M(le),te;!(te=de()).done;)_();return we},$e.parseInline=function(le,ce){if(typeof le>"u"||le===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof le!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(le)+", string expected");ce=S({},$e.defaults,ce||{}),I(ce);try{var we=he.lexInline(le,ce);return ce.walkTokens&&$e.walkTokens(we,ce.walkTokens),fe.parseInline(we,ce)}catch(_){if(_.message+=`
Please report this to https://github.com/markedjs/marked.`,ce.silent)return"<p>An error occurred:</p><pre>"+p(_.message+"",!0)+"</pre>";throw _}},$e.Parser=fe,$e.parser=fe.parse,$e.Renderer=ye,$e.TextRenderer=De,$e.Lexer=he,$e.lexer=he.lex,$e.Tokenizer=R,$e.Slugger=Se,$e.parse=$e;var re=$e.options,Ae=$e.setOptions,se=$e.use,X=$e.walkTokens,B=$e.parseInline,ie=$e,pe=fe.parse,ne=he.lex;be.Lexer=he,be.Parser=fe,be.Renderer=ye,be.Slugger=Se,be.TextRenderer=De,be.Tokenizer=R,be.getDefaults=A,be.lexer=ne,be.marked=$e,be.options=re,be.parse=ie,be.parseInline=B,be.parser=pe,be.setOptions=Ae,be.use=se,be.walkTokens=X,Object.defineProperty(be,"__esModule",{value:!0})}),define(Pe[121],Re([1,0]),function(be,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yl=e.$Xl=e.$Wl=e.rot=e.$Ul=void 0;function y($,E,f){return Math.min(Math.max($,E),f)}e.$Ul=y;function F($,E){return(E+$%E)%E}e.rot=F;class P{constructor(){this.a=0}getNext(){return this.a++}}e.$Wl=P;class M{constructor(){this.a=1,this.b=0}update(E){return this.b=this.b+(E-this.b)/this.a,this.a+=1,this.b}get value(){return this.b}}e.$Xl=M;class A{constructor(E){this.a=0,this.b=0,this.c=[],this.d=0,this.e=0,this.c=new Array(E),this.c.fill(0,0,E)}update(E){const f=this.c[this.d];return this.c[this.d]=E,this.d=(this.d+1)%this.c.length,this.e-=f,this.e+=E,this.a<this.c.length&&(this.a+=1),this.b=this.e/this.a,this.b}get value(){return this.b}}e.$Yl=A}),function(){function be(P){const M=[];typeof P=="number"&&M.push("code/timeOrigin",P);function A(E){M.push(E,Date.now())}function $(){const E=[];for(let f=0;f<M.length;f+=2)E.push({name:M[f],startTime:M[f+1]});return E}return{mark:A,getMarks:$}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?be():{mark(P){performance.mark(P)},getMarks(){let P=performance.timeOrigin;typeof P!="number"&&(P=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const M=[{name:"code/timeOrigin",startTime:Math.round(P)}];for(const A of performance.getEntriesByType("mark"))M.push({name:A.name,startTime:Math.round(P+A.startTime)});return M}};if(typeof process=="object"){const P=performance?.timeOrigin??Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return be(P)}else return console.trace("perf-util loaded in UNKNOWN environment"),be()}function y(P){return P.MonacoPerformanceMarks||(P.MonacoPerformanceMarks=e()),P.MonacoPerformanceMarks}var F;typeof global=="object"?F=global:typeof self=="object"?F=self:F={},typeof define=="function"?define("vs/base/common/performance",[],function(){return y(F)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=y(F):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),F.perf=y(F))}(),function(be,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var y=e();for(var F in y)(typeof exports=="object"?exports:be)[F]=y[F]}}(typeof self<"u"?self:this,function(){return function(be){var e={};function y(F){if(e[F])return e[F].exports;var P=e[F]={i:F,l:!1,exports:{}};return be[F].call(P.exports,P,P.exports,y),P.l=!0,P.exports}return y.m=be,y.c=e,y.d=function(F,P,M){y.o(F,P)||Object.defineProperty(F,P,{enumerable:!0,get:M})},y.r=function(F){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(F,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(F,"__esModule",{value:!0})},y.t=function(F,P){if(1&P&&(F=y(F)),8&P||4&P&&typeof F=="object"&&F&&F.__esModule)return F;var M=Object.create(null);if(y.r(M),Object.defineProperty(M,"default",{enumerable:!0,value:F}),2&P&&typeof F!="string")for(var A in F)y.d(M,A,function($){return F[$]}.bind(null,A));return M},y.n=function(F){var P=F&&F.__esModule?function(){return F.default}:function(){return F};return y.d(P,"a",P),P},y.o=function(F,P){return Object.prototype.hasOwnProperty.call(F,P)},y.p="",y(y.s=0)}([function(be,e,y){(function(F){var P;e=be.exports=se,P=typeof F=="object"&&F.env&&F.env.NODE_DEBUG&&/\bsemver\b/i.test(F.env.NODE_DEBUG)?function(){var q=Array.prototype.slice.call(arguments,0);q.unshift("SEMVER"),console.log.apply(console,q)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var M=256,A=Number.MAX_SAFE_INTEGER||9007199254740991,$=e.re=[],E=e.src=[],f=0,C=f++;E[C]="0|[1-9]\\d*";var D=f++;E[D]="[0-9]+";var u=f++;E[u]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var b=f++;E[b]="("+E[C]+")\\.("+E[C]+")\\.("+E[C]+")";var p=f++;E[p]="("+E[D]+")\\.("+E[D]+")\\.("+E[D]+")";var g=f++;E[g]="(?:"+E[C]+"|"+E[u]+")";var t=f++;E[t]="(?:"+E[D]+"|"+E[u]+")";var i=f++;E[i]="(?:-("+E[g]+"(?:\\."+E[g]+")*))";var r=f++;E[r]="(?:-?("+E[t]+"(?:\\."+E[t]+")*))";var c=f++;E[c]="[0-9A-Za-z-]+";var o=f++;E[o]="(?:\\+("+E[c]+"(?:\\."+E[c]+")*))";var l=f++,n="v?"+E[b]+E[i]+"?"+E[o]+"?";E[l]="^"+n+"$";var s="[v=\\s]*"+E[p]+E[r]+"?"+E[o]+"?",a=f++;E[a]="^"+s+"$";var d=f++;E[d]="((?:<|>)?=?)";var v=f++;E[v]=E[D]+"|x|X|\\*";var m=f++;E[m]=E[C]+"|x|X|\\*";var S=f++;E[S]="[v=\\s]*("+E[m]+")(?:\\.("+E[m]+")(?:\\.("+E[m]+")(?:"+E[i]+")?"+E[o]+"?)?)?";var k=f++;E[k]="[v=\\s]*("+E[v]+")(?:\\.("+E[v]+")(?:\\.("+E[v]+")(?:"+E[r]+")?"+E[o]+"?)?)?";var h=f++;E[h]="^"+E[d]+"\\s*"+E[S]+"$";var w=f++;E[w]="^"+E[d]+"\\s*"+E[k]+"$";var I=f++;E[I]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var L=f++;E[L]="(?:~>?)";var V=f++;E[V]="(\\s*)"+E[L]+"\\s+",$[V]=new RegExp(E[V],"g");var K=f++;E[K]="^"+E[L]+E[S]+"$";var R=f++;E[R]="^"+E[L]+E[k]+"$";var N=f++;E[N]="(?:\\^)";var T=f++;E[T]="(\\s*)"+E[N]+"\\s+",$[T]=new RegExp(E[T],"g");var z=f++;E[z]="^"+E[N]+E[S]+"$";var Z=f++;E[Z]="^"+E[N]+E[k]+"$";var he=f++;E[he]="^"+E[d]+"\\s*("+s+")$|^$";var ye=f++;E[ye]="^"+E[d]+"\\s*("+n+")$|^$";var De=f++;E[De]="(\\s*)"+E[d]+"\\s*("+s+"|"+E[S]+")",$[De]=new RegExp(E[De],"g");var Se=f++;E[Se]="^\\s*("+E[S]+")\\s+-\\s+("+E[S]+")\\s*$";var fe=f++;E[fe]="^\\s*("+E[k]+")\\s+-\\s+("+E[k]+")\\s*$";var $e=f++;E[$e]="(<|>)?=?\\s*\\*";for(var re=0;re<35;re++)P(re,E[re]),$[re]||($[re]=new RegExp(E[re]));function Ae(q,x){if(q instanceof se)return q;if(typeof q!="string"||q.length>M||!(x?$[a]:$[l]).test(q))return null;try{return new se(q,x)}catch{return null}}function se(q,x){if(q instanceof se){if(q.loose===x)return q;q=q.version}else if(typeof q!="string")throw new TypeError("Invalid Version: "+q);if(q.length>M)throw new TypeError("version is longer than "+M+" characters");if(!(this instanceof se))return new se(q,x);P("SemVer",q,x),this.loose=x;var ue=q.trim().match(x?$[a]:$[l]);if(!ue)throw new TypeError("Invalid Version: "+q);if(this.raw=q,this.major=+ue[1],this.minor=+ue[2],this.patch=+ue[3],this.major>A||this.major<0)throw new TypeError("Invalid major version");if(this.minor>A||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>A||this.patch<0)throw new TypeError("Invalid patch version");ue[4]?this.prerelease=ue[4].split(".").map(function(Oe){if(/^[0-9]+$/.test(Oe)){var Ue=+Oe;if(Ue>=0&&Ue<A)return Ue}return Oe}):this.prerelease=[],this.build=ue[5]?ue[5].split("."):[],this.format()}e.parse=Ae,e.valid=function(q,x){var ue=Ae(q,x);return ue?ue.version:null},e.clean=function(q,x){var ue=Ae(q.trim().replace(/^[=v]+/,""),x);return ue?ue.version:null},e.SemVer=se,se.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},se.prototype.toString=function(){return this.version},se.prototype.compare=function(q){return P("SemVer.compare",this.version,this.loose,q),q instanceof se||(q=new se(q,this.loose)),this.compareMain(q)||this.comparePre(q)},se.prototype.compareMain=function(q){return q instanceof se||(q=new se(q,this.loose)),B(this.major,q.major)||B(this.minor,q.minor)||B(this.patch,q.patch)},se.prototype.comparePre=function(q){if(q instanceof se||(q=new se(q,this.loose)),this.prerelease.length&&!q.prerelease.length)return-1;if(!this.prerelease.length&&q.prerelease.length)return 1;if(!this.prerelease.length&&!q.prerelease.length)return 0;var x=0;do{var ue=this.prerelease[x],Oe=q.prerelease[x];if(P("prerelease compare",x,ue,Oe),ue===void 0&&Oe===void 0)return 0;if(Oe===void 0)return 1;if(ue===void 0)return-1;if(ue!==Oe)return B(ue,Oe)}while(++x)},se.prototype.inc=function(q,x){switch(q){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",x);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",x);break;case"prepatch":this.prerelease.length=0,this.inc("patch",x),this.inc("pre",x);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",x),this.inc("pre",x);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var ue=this.prerelease.length;--ue>=0;)typeof this.prerelease[ue]=="number"&&(this.prerelease[ue]++,ue=-2);ue===-1&&this.prerelease.push(0)}x&&(this.prerelease[0]===x?isNaN(this.prerelease[1])&&(this.prerelease=[x,0]):this.prerelease=[x,0]);break;default:throw new Error("invalid increment argument: "+q)}return this.format(),this.raw=this.version,this},e.inc=function(q,x,ue,Oe){typeof ue=="string"&&(Oe=ue,ue=void 0);try{return new se(q,ue).inc(x,Oe).version}catch{return null}},e.diff=function(q,x){if(le(q,x))return null;var ue=Ae(q),Oe=Ae(x);if(ue.prerelease.length||Oe.prerelease.length){for(var Ue in ue)if((Ue==="major"||Ue==="minor"||Ue==="patch")&&ue[Ue]!==Oe[Ue])return"pre"+Ue;return"prerelease"}for(var Ue in ue)if((Ue==="major"||Ue==="minor"||Ue==="patch")&&ue[Ue]!==Oe[Ue])return Ue},e.compareIdentifiers=B;var X=/^[0-9]+$/;function B(q,x){var ue=X.test(q),Oe=X.test(x);return ue&&Oe&&(q=+q,x=+x),ue&&!Oe?-1:Oe&&!ue?1:q<x?-1:q>x?1:0}function ie(q,x,ue){return new se(q,ue).compare(new se(x,ue))}function pe(q,x,ue){return ie(q,x,ue)>0}function ne(q,x,ue){return ie(q,x,ue)<0}function le(q,x,ue){return ie(q,x,ue)===0}function ce(q,x,ue){return ie(q,x,ue)!==0}function we(q,x,ue){return ie(q,x,ue)>=0}function _(q,x,ue){return ie(q,x,ue)<=0}function de(q,x,ue,Oe){var Ue;switch(x){case"===":typeof q=="object"&&(q=q.version),typeof ue=="object"&&(ue=ue.version),Ue=q===ue;break;case"!==":typeof q=="object"&&(q=q.version),typeof ue=="object"&&(ue=ue.version),Ue=q!==ue;break;case"":case"=":case"==":Ue=le(q,ue,Oe);break;case"!=":Ue=ce(q,ue,Oe);break;case">":Ue=pe(q,ue,Oe);break;case">=":Ue=we(q,ue,Oe);break;case"<":Ue=ne(q,ue,Oe);break;case"<=":Ue=_(q,ue,Oe);break;default:throw new TypeError("Invalid operator: "+x)}return Ue}function te(q,x){if(q instanceof te){if(q.loose===x)return q;q=q.value}if(!(this instanceof te))return new te(q,x);P("comparator",q,x),this.loose=x,this.parse(q),this.semver===ae?this.value="":this.value=this.operator+this.semver.version,P("comp",this)}e.rcompareIdentifiers=function(q,x){return B(x,q)},e.major=function(q,x){return new se(q,x).major},e.minor=function(q,x){return new se(q,x).minor},e.patch=function(q,x){return new se(q,x).patch},e.compare=ie,e.compareLoose=function(q,x){return ie(q,x,!0)},e.rcompare=function(q,x,ue){return ie(x,q,ue)},e.sort=function(q,x){return q.sort(function(ue,Oe){return e.compare(ue,Oe,x)})},e.rsort=function(q,x){return q.sort(function(ue,Oe){return e.rcompare(ue,Oe,x)})},e.gt=pe,e.lt=ne,e.eq=le,e.neq=ce,e.gte=we,e.lte=_,e.cmp=de,e.Comparator=te;var ae={};function me(q,x){if(q instanceof me)return q.loose===x?q:new me(q.raw,x);if(q instanceof te)return new me(q.value,x);if(!(this instanceof me))return new me(q,x);if(this.loose=x,this.raw=q,this.set=q.split(/\s*\|\|\s*/).map(function(ue){return this.parseRange(ue.trim())},this).filter(function(ue){return ue.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+q);this.format()}function Ie(q){return!q||q.toLowerCase()==="x"||q==="*"}function O(q,x,ue,Oe,Ue,Ze,Je,tt,_e,et,rt,nt,Ne){return((x=Ie(ue)?"":Ie(Oe)?">="+ue+".0.0":Ie(Ue)?">="+ue+"."+Oe+".0":">="+x)+" "+(tt=Ie(_e)?"":Ie(et)?"<"+(+_e+1)+".0.0":Ie(rt)?"<"+_e+"."+(+et+1)+".0":nt?"<="+_e+"."+et+"."+rt+"-"+nt:"<="+tt)).trim()}function W(q,x){for(var ue=0;ue<q.length;ue++)if(!q[ue].test(x))return!1;if(x.prerelease.length){for(ue=0;ue<q.length;ue++)if(P(q[ue].semver),q[ue].semver!==ae&&q[ue].semver.prerelease.length>0){var Oe=q[ue].semver;if(Oe.major===x.major&&Oe.minor===x.minor&&Oe.patch===x.patch)return!0}return!1}return!0}function G(q,x,ue){try{x=new me(x,ue)}catch{return!1}return x.test(q)}function J(q,x,ue,Oe){var Ue,Ze,Je,tt,_e;switch(q=new se(q,Oe),x=new me(x,Oe),ue){case">":Ue=pe,Ze=_,Je=ne,tt=">",_e=">=";break;case"<":Ue=ne,Ze=we,Je=pe,tt="<",_e="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(G(q,x,Oe))return!1;for(var et=0;et<x.set.length;++et){var rt=x.set[et],nt=null,Ne=null;if(rt.forEach(function(dt){dt.semver===ae&&(dt=new te(">=0.0.0")),nt=nt||dt,Ne=Ne||dt,Ue(dt.semver,nt.semver,Oe)?nt=dt:Je(dt.semver,Ne.semver,Oe)&&(Ne=dt)}),nt.operator===tt||nt.operator===_e||(!Ne.operator||Ne.operator===tt)&&Ze(q,Ne.semver)||Ne.operator===_e&&Je(q,Ne.semver))return!1}return!0}te.prototype.parse=function(q){var x=this.loose?$[he]:$[ye],ue=q.match(x);if(!ue)throw new TypeError("Invalid comparator: "+q);this.operator=ue[1],this.operator==="="&&(this.operator=""),ue[2]?this.semver=new se(ue[2],this.loose):this.semver=ae},te.prototype.toString=function(){return this.value},te.prototype.test=function(q){return P("Comparator.test",q,this.loose),this.semver===ae||(typeof q=="string"&&(q=new se(q,this.loose)),de(q,this.operator,this.semver,this.loose))},te.prototype.intersects=function(q,x){if(!(q instanceof te))throw new TypeError("a Comparator is required");var ue;if(this.operator==="")return ue=new me(q.value,x),G(this.value,ue,x);if(q.operator==="")return ue=new me(this.value,x),G(q.semver,ue,x);var Oe=!(this.operator!==">="&&this.operator!==">"||q.operator!==">="&&q.operator!==">"),Ue=!(this.operator!=="<="&&this.operator!=="<"||q.operator!=="<="&&q.operator!=="<"),Ze=this.semver.version===q.semver.version,Je=!(this.operator!==">="&&this.operator!=="<="||q.operator!==">="&&q.operator!=="<="),tt=de(this.semver,"<",q.semver,x)&&(this.operator===">="||this.operator===">")&&(q.operator==="<="||q.operator==="<"),_e=de(this.semver,">",q.semver,x)&&(this.operator==="<="||this.operator==="<")&&(q.operator===">="||q.operator===">");return Oe||Ue||Ze&&Je||tt||_e},e.Range=me,me.prototype.format=function(){return this.range=this.set.map(function(q){return q.join(" ").trim()}).join("||").trim(),this.range},me.prototype.toString=function(){return this.range},me.prototype.parseRange=function(q){var x=this.loose;q=q.trim(),P("range",q,x);var ue=x?$[fe]:$[Se];q=q.replace(ue,O),P("hyphen replace",q),q=q.replace($[De],"$1$2$3"),P("comparator trim",q,$[De]),q=(q=(q=q.replace($[V],"$1~")).replace($[T],"$1^")).split(/\s+/).join(" ");var Oe=x?$[he]:$[ye],Ue=q.split(" ").map(function(Ze){return function(Je,tt){return P("comp",Je),Je=function(_e,et){return _e.trim().split(/\s+/).map(function(rt){return function(nt,Ne){P("caret",nt,Ne);var dt=Ne?$[Z]:$[z];return nt.replace(dt,function(Y,Q,Ee,Be,He){var Ye;return P("caret",nt,Y,Q,Ee,Be,He),Ie(Q)?Ye="":Ie(Ee)?Ye=">="+Q+".0.0 <"+(+Q+1)+".0.0":Ie(Be)?Ye=Q==="0"?">="+Q+"."+Ee+".0 <"+Q+"."+(+Ee+1)+".0":">="+Q+"."+Ee+".0 <"+(+Q+1)+".0.0":He?(P("replaceCaret pr",He),He.charAt(0)!=="-"&&(He="-"+He),Ye=Q==="0"?Ee==="0"?">="+Q+"."+Ee+"."+Be+He+" <"+Q+"."+Ee+"."+(+Be+1):">="+Q+"."+Ee+"."+Be+He+" <"+Q+"."+(+Ee+1)+".0":">="+Q+"."+Ee+"."+Be+He+" <"+(+Q+1)+".0.0"):(P("no pr"),Ye=Q==="0"?Ee==="0"?">="+Q+"."+Ee+"."+Be+" <"+Q+"."+Ee+"."+(+Be+1):">="+Q+"."+Ee+"."+Be+" <"+Q+"."+(+Ee+1)+".0":">="+Q+"."+Ee+"."+Be+" <"+(+Q+1)+".0.0"),P("caret return",Ye),Ye})}(rt,et)}).join(" ")}(Je,tt),P("caret",Je),Je=function(_e,et){return _e.trim().split(/\s+/).map(function(rt){return function(nt,Ne){var dt=Ne?$[R]:$[K];return nt.replace(dt,function(Y,Q,Ee,Be,He){var Ye;return P("tilde",nt,Y,Q,Ee,Be,He),Ie(Q)?Ye="":Ie(Ee)?Ye=">="+Q+".0.0 <"+(+Q+1)+".0.0":Ie(Be)?Ye=">="+Q+"."+Ee+".0 <"+Q+"."+(+Ee+1)+".0":He?(P("replaceTilde pr",He),He.charAt(0)!=="-"&&(He="-"+He),Ye=">="+Q+"."+Ee+"."+Be+He+" <"+Q+"."+(+Ee+1)+".0"):Ye=">="+Q+"."+Ee+"."+Be+" <"+Q+"."+(+Ee+1)+".0",P("tilde return",Ye),Ye})}(rt,et)}).join(" ")}(Je,tt),P("tildes",Je),Je=function(_e,et){return P("replaceXRanges",_e,et),_e.split(/\s+/).map(function(rt){return function(nt,Ne){nt=nt.trim();var dt=Ne?$[w]:$[h];return nt.replace(dt,function(Y,Q,Ee,Be,He,Ye){P("xRange",nt,Y,Q,Ee,Be,He,Ye);var st=Ie(Ee),vt=st||Ie(Be),Dt=vt||Ie(He);return Q==="="&&Dt&&(Q=""),st?Y=Q===">"||Q==="<"?"<0.0.0":"*":Q&&Dt?(vt&&(Be=0),Dt&&(He=0),Q===">"?(Q=">=",vt?(Ee=+Ee+1,Be=0,He=0):Dt&&(Be=+Be+1,He=0)):Q==="<="&&(Q="<",vt?Ee=+Ee+1:Be=+Be+1),Y=Q+Ee+"."+Be+"."+He):vt?Y=">="+Ee+".0.0 <"+(+Ee+1)+".0.0":Dt&&(Y=">="+Ee+"."+Be+".0 <"+Ee+"."+(+Be+1)+".0"),P("xRange return",Y),Y})}(rt,et)}).join(" ")}(Je,tt),P("xrange",Je),Je=function(_e,et){return P("replaceStars",_e,et),_e.trim().replace($[$e],"")}(Je,tt),P("stars",Je),Je}(Ze,x)}).join(" ").split(/\s+/);return this.loose&&(Ue=Ue.filter(function(Ze){return!!Ze.match(Oe)})),Ue=Ue.map(function(Ze){return new te(Ze,x)})},me.prototype.intersects=function(q,x){if(!(q instanceof me))throw new TypeError("a Range is required");return this.set.some(function(ue){return ue.every(function(Oe){return q.set.some(function(Ue){return Ue.every(function(Ze){return Oe.intersects(Ze,x)})})})})},e.toComparators=function(q,x){return new me(q,x).set.map(function(ue){return ue.map(function(Oe){return Oe.value}).join(" ").trim().split(" ")})},me.prototype.test=function(q){if(!q)return!1;typeof q=="string"&&(q=new se(q,this.loose));for(var x=0;x<this.set.length;x++)if(W(this.set[x],q))return!0;return!1},e.satisfies=G,e.maxSatisfying=function(q,x,ue){var Oe=null,Ue=null;try{var Ze=new me(x,ue)}catch{return null}return q.forEach(function(Je){Ze.test(Je)&&(Oe&&Ue.compare(Je)!==-1||(Ue=new se(Oe=Je,ue)))}),Oe},e.minSatisfying=function(q,x,ue){var Oe=null,Ue=null;try{var Ze=new me(x,ue)}catch{return null}return q.forEach(function(Je){Ze.test(Je)&&(Oe&&Ue.compare(Je)!==1||(Ue=new se(Oe=Je,ue)))}),Oe},e.validRange=function(q,x){try{return new me(q,x).range||"*"}catch{return null}},e.ltr=function(q,x,ue){return J(q,x,"<",ue)},e.gtr=function(q,x,ue){return J(q,x,">",ue)},e.outside=J,e.prerelease=function(q,x){var ue=Ae(q,x);return ue&&ue.prerelease.length?ue.prerelease:null},e.intersects=function(q,x,ue){return q=new me(q,ue),x=new me(x,ue),q.intersects(x)},e.coerce=function(q){if(q instanceof se)return q;if(typeof q!="string")return null;var x=q.match($[I]);return x==null?null:Ae((x[1]||"0")+"."+(x[2]||"0")+"."+(x[3]||"0"))}}).call(this,y(1))},function(be,e){var y,F,P=be.exports={};function M(){throw new Error("setTimeout has not been defined")}function A(){throw new Error("clearTimeout has not been defined")}function $(t){if(y===setTimeout)return setTimeout(t,0);if((y===M||!y)&&setTimeout)return y=setTimeout,setTimeout(t,0);try{return y(t,0)}catch{try{return y.call(null,t,0)}catch{return y.call(this,t,0)}}}(function(){try{y=typeof setTimeout=="function"?setTimeout:M}catch{y=M}try{F=typeof clearTimeout=="function"?clearTimeout:A}catch{F=A}})();var E,f=[],C=!1,D=-1;function u(){C&&E&&(C=!1,E.length?f=E.concat(f):D=-1,f.length&&b())}function b(){if(!C){var t=$(u);C=!0;for(var i=f.length;i;){for(E=f,f=[];++D<i;)E&&E[D].run();D=-1,i=f.length}E=null,C=!1,function(r){if(F===clearTimeout)return clearTimeout(r);if((F===A||!F)&&clearTimeout)return F=clearTimeout,clearTimeout(r);try{F(r)}catch{try{return F.call(null,r)}catch{return F.call(this,r)}}}(t)}}function p(t,i){this.fun=t,this.array=i}function g(){}P.nextTick=function(t){var i=new Array(arguments.length-1);if(arguments.length>1)for(var r=1;r<arguments.length;r++)i[r-1]=arguments[r];f.push(new p(t,i)),f.length!==1||C||$(b)},p.prototype.run=function(){this.fun.apply(null,this.array)},P.title="browser",P.browser=!0,P.env={},P.argv=[],P.version="",P.versions={},P.on=g,P.addListener=g,P.once=g,P.off=g,P.removeListener=g,P.removeAllListeners=g,P.emit=g,P.prependListener=g,P.prependOnceListener=g,P.listeners=function(t){return[]},P.binding=function(t){throw new Error("process.binding is not supported")},P.cwd=function(){return"/"},P.chdir=function(t){throw new Error("process.chdir is not supported")},P.umask=function(){return 0}}])}),define(Pe[122],Re([1,0,11,6]),function(be,e,y,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ee=e.$de=e.$ce=e.$be=e.$ae=e.$_d=e.$$d=e.$0d=e.$9d=e.$8d=e.$7d=e.$6d=e.$5d=e.$4d=e.$3d=void 0;function P(o){const l=o;return l?typeof l.read=="function":!1}e.$3d=P;function M(o){const l=o;return l?[l.on,l.pause,l.resume,l.destroy].every(n=>typeof n=="function"):!1}e.$4d=M;function A(o){const l=o;return l?M(l.stream)&&Array.isArray(l.buffer)&&typeof l.ended=="boolean":!1}e.$5d=A;function $(o,l){return new E(o,l)}e.$6d=$;class E{constructor(l,n){this.e=l,this.f=n,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(l){if(!this.a.destroyed){if(this.a.flowing)this.g(l);else if(this.b.data.push(l),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(n=>this.d.push(n))}}error(l){this.a.destroyed||(this.a.flowing?this.h(l):this.b.error.push(l))}end(l){this.a.destroyed||(typeof l<"u"&&this.write(l),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(l){this.c.data.slice(0).forEach(n=>n(l))}h(l){this.c.error.length===0?(0,y.$Z)(l):this.c.error.slice(0).forEach(n=>n(l))}i(){this.c.end.slice(0).forEach(l=>l())}on(l,n){if(!this.a.destroyed)switch(l){case"data":this.c.data.push(n),this.resume();break;case"end":this.c.end.push(n),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(n),this.a.flowing&&this.k();break}}removeListener(l,n){if(this.a.destroyed)return;let s;switch(l){case"data":s=this.c.data;break;case"end":s=this.c.end;break;case"error":s=this.c.error;break}if(s){const a=s.indexOf(n);a>=0&&s.splice(a,1)}}j(){if(this.b.data.length>0){const l=this.e(this.b.data);this.g(l),this.b.data.length=0;const n=[...this.d];this.d.length=0,n.forEach(s=>s())}}k(){if(this.c.error.length>0){for(const l of this.b.error)this.h(l);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function f(o,l){const n=[];let s;for(;(s=o.read())!==null;)n.push(s);return l(n)}e.$7d=f;function C(o,l,n){const s=[];let a;for(;(a=o.read())!==null&&s.length<n;)s.push(a);return a===null&&s.length>0?l(s):{read:()=>{if(s.length>0)return s.shift();if(typeof a<"u"){const d=a;return a=void 0,d}return o.read()}}}e.$8d=C;function D(o,l){return new Promise((n,s)=>{const a=[];u(o,{onData:d=>{l&&a.push(d)},onError:d=>{l?s(d):n(void 0)},onEnd:()=>{n(l?l(a):void 0)}})})}e.$9d=D;function u(o,l,n){o.on("error",s=>{n?.isCancellationRequested||l.onError(s)}),o.on("end",()=>{n?.isCancellationRequested||l.onEnd()}),o.on("data",s=>{n?.isCancellationRequested||l.onData(s)})}e.$0d=u;function b(o,l){return new Promise((n,s)=>{const a=new F.$Qc,d=[],v=k=>{if(d.push(k),d.length>l)return a.dispose(),o.pause(),n({stream:o,buffer:d,ended:!1})},m=k=>(a.dispose(),s(k)),S=()=>(a.dispose(),n({stream:o,buffer:d,ended:!0}));a.add((0,F.$Pc)(()=>o.removeListener("error",m))),o.on("error",m),a.add((0,F.$Pc)(()=>o.removeListener("end",S))),o.on("end",S),a.add((0,F.$Pc)(()=>o.removeListener("data",v))),o.on("data",v)})}e.$$d=b;function p(o,l){const n=$(l);return n.end(o),n}e.$_d=p;function g(){const o=$(()=>{throw new Error("not supported")});return o.end(),o}e.$ae=g;function t(o){let l=!1;return{read:()=>l?null:(l=!0,o)}}e.$be=t;function i(o,l,n){const s=$(n);return u(o,{onData:a=>s.write(l.data(a)),onError:a=>s.error(l.error?l.error(a):a),onEnd:()=>s.end()}),s}e.$ce=i;function r(o,l,n){let s=!1;return{read:()=>{const a=l.read();return s?a:(s=!0,a!==null?n([o,a]):o)}}}e.$de=r;function c(o,l,n){let s=!1;const a=$(n);return u(l,{onData:d=>s?a.write(d):(s=!0,a.write(n([o,d]))),onError:d=>a.error(d),onEnd:()=>{s||(s=!0,a.write(o)),a.end()}}),a}e.$ee=c}),define(Pe[24],Re([1,0,44,122]),function(be,e,y,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ze=e.$ye=e.$xe=e.$we=e.$ve=e.$ue=e.$te=e.$se=e.$re=e.$qe=e.$pe=e.$oe=e.$ne=e.$me=e.$le=e.$ke=e.$je=e.$ie=e.$he=e.$ge=e.$fe=void 0;const P=typeof Buffer<"u",M=new y.$U(()=>new Uint8Array(256));let A,$;class E{static alloc(I){return P?new E(Buffer.allocUnsafe(I)):new E(new Uint8Array(I))}static wrap(I){return P&&!Buffer.isBuffer(I)&&(I=Buffer.from(I.buffer,I.byteOffset,I.byteLength)),new E(I)}static fromString(I,L){return!(L?.dontUseNodeBuffer||!1)&&P?new E(Buffer.from(I)):(A||(A=new TextEncoder),new E(A.encode(I)))}static fromByteArray(I){const L=E.alloc(I.length);for(let V=0,K=I.length;V<K;V++)L.buffer[V]=I[V];return L}static concat(I,L){if(typeof L>"u"){L=0;for(let R=0,N=I.length;R<N;R++)L+=I[R].byteLength}const V=E.alloc(L);let K=0;for(let R=0,N=I.length;R<N;R++){const T=I[R];V.set(T,K),K+=T.byteLength}return V}constructor(I){this.buffer=I,this.byteLength=this.buffer.byteLength}clone(){const I=E.alloc(this.byteLength);return I.set(this),I}toString(){return P?this.buffer.toString():($||($=new TextDecoder),$.decode(this.buffer))}slice(I,L){return new E(this.buffer.subarray(I,L))}set(I,L){if(I instanceof E)this.buffer.set(I.buffer,L);else if(I instanceof Uint8Array)this.buffer.set(I,L);else if(I instanceof ArrayBuffer)this.buffer.set(new Uint8Array(I),L);else if(ArrayBuffer.isView(I))this.buffer.set(new Uint8Array(I.buffer,I.byteOffset,I.byteLength),L);else throw new Error("Unknown argument 'array'")}readUInt32BE(I){return u(this.buffer,I)}writeUInt32BE(I,L){b(this.buffer,I,L)}readUInt32LE(I){return p(this.buffer,I)}writeUInt32LE(I,L){g(this.buffer,I,L)}readUInt8(I){return t(this.buffer,I)}writeUInt8(I,L){i(this.buffer,I,L)}indexOf(I,L=0){return f(this.buffer,I instanceof E?I.buffer:I,L)}}e.$fe=E;function f(w,I,L=0){const V=I.byteLength,K=w.byteLength;if(V===0)return 0;if(V===1)return w.indexOf(I[0]);if(V>K-L)return-1;const R=M.value;R.fill(I.length);for(let Z=0;Z<I.length;Z++)R[I[Z]]=I.length-Z-1;let N=L+I.length-1,T=N,z=-1;for(;N<K;)if(w[N]===I[T]){if(T===0){z=N;break}N--,T--}else N+=Math.max(I.length-T,R[w[N]]),T=I.length-1;return z}e.$ge=f;function C(w,I){return w[I+0]<<0>>>0|w[I+1]<<8>>>0}e.$he=C;function D(w,I,L){w[L+0]=I&255,I=I>>>8,w[L+1]=I&255}e.$ie=D;function u(w,I){return w[I]*2**24+w[I+1]*2**16+w[I+2]*2**8+w[I+3]}e.$je=u;function b(w,I,L){w[L+3]=I,I=I>>>8,w[L+2]=I,I=I>>>8,w[L+1]=I,I=I>>>8,w[L]=I}e.$ke=b;function p(w,I){return w[I+0]<<0>>>0|w[I+1]<<8>>>0|w[I+2]<<16>>>0|w[I+3]<<24>>>0}e.$le=p;function g(w,I,L){w[L+0]=I&255,I=I>>>8,w[L+1]=I&255,I=I>>>8,w[L+2]=I&255,I=I>>>8,w[L+3]=I&255}e.$me=g;function t(w,I){return w[I]}e.$ne=t;function i(w,I,L){w[L]=I}e.$oe=i;function r(w){return F.$7d(w,I=>E.concat(I))}e.$pe=r;function c(w){return F.$be(w)}e.$qe=c;function o(w){return F.$9d(w,I=>E.concat(I))}e.$re=o;async function l(w){return w.ended?E.concat(w.buffer):E.concat([...w.buffer,await o(w.stream)])}e.$se=l;function n(w){return F.$_d(w,I=>E.concat(I))}e.$te=n;function s(w){return F.$ce(w,{data:I=>typeof I=="string"?E.fromString(I):E.wrap(I)},I=>E.concat(I))}e.$ue=s;function a(w){return F.$6d(I=>E.concat(I),w)}e.$ve=a;function d(w,I){return F.$de(w,I,L=>E.concat(L))}e.$we=d;function v(w,I){return F.$ee(w,I,L=>E.concat(L))}e.$xe=v;function m(w){let I=0,L=0,V=0;const K=new Uint8Array(Math.floor(w.length/4*3)),R=T=>{switch(L){case 3:K[V++]=I|T,L=0;break;case 2:K[V++]=I|T>>>2,I=T<<6,L=3;break;case 1:K[V++]=I|T>>>4,I=T<<4,L=2;break;default:I=T<<2,L=1}};for(let T=0;T<w.length;T++){const z=w.charCodeAt(T);if(z>=65&&z<=90)R(z-65);else if(z>=97&&z<=122)R(z-97+26);else if(z>=48&&z<=57)R(z-48+52);else if(z===43||z===45)R(62);else if(z===47||z===95)R(63);else{if(z===61)break;throw new SyntaxError(`Unexpected base64 character ${w[T]}`)}}const N=V;for(;L>0;)R(0);return E.wrap(K).slice(0,N)}e.$ye=m;const S="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",k="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function h({buffer:w},I=!0,L=!1){const V=L?k:S;let K="";const R=w.byteLength%3;let N=0;for(;N<w.byteLength-R;N+=3){const T=w[N+0],z=w[N+1],Z=w[N+2];K+=V[T>>>2],K+=V[(T<<4|z>>>4)&63],K+=V[(z<<2|Z>>>6)&63],K+=V[Z&63]}if(R===1){const T=w[N+0];K+=V[T>>>2],K+=V[T<<4&63],I&&(K+="==")}else if(R===2){const T=w[N+0],z=w[N+1];K+=V[T>>>2],K+=V[(T<<4|z>>>4)&63],K+=V[z<<2&63],I&&(K+="=")}return K}e.$ze=h}),define(Pe[123],Re([1,0,28,12]),function(be,e,y,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xj=e.$Wj=e.$Vj=e.$Uj=e.FuzzyScore=e.$Tj=e.$Sj=e.$Rj=e.$Qj=e.$Pj=e.$Oj=e.$Nj=e.$Mj=e.$Lj=e.$Kj=e.$Jj=e.$Ij=e.or=void 0;function P(...te){return function(ae,me){for(let Ie=0,O=te.length;Ie<O;Ie++){const W=te[Ie](ae,me);if(W)return W}return null}}e.or=P,e.$Ij=M.bind(void 0,!1),e.$Jj=M.bind(void 0,!0);function M(te,ae,me){if(!me||me.length<ae.length)return null;let Ie;return te?Ie=F.$7e(me,ae):Ie=me.indexOf(ae)===0,Ie?ae.length>0?[{start:0,end:ae.length}]:[]:null}function A(te,ae){const me=ae.toLowerCase().indexOf(te.toLowerCase());return me===-1?null:[{start:me,end:me+te.length}]}e.$Kj=A;function $(te,ae){return E(te.toLowerCase(),ae.toLowerCase(),0,0)}e.$Lj=$;function E(te,ae,me,Ie){if(me===te.length)return[];if(Ie===ae.length)return null;if(te[me]===ae[Ie]){let O=null;return(O=E(te,ae,me+1,Ie+1))?i({start:Ie,end:Ie+1},O):null}return E(te,ae,me,Ie+1)}function f(te){return 97<=te&&te<=122}function C(te){return 65<=te&&te<=90}e.$Mj=C;function D(te){return 48<=te&&te<=57}function u(te){return te===32||te===9||te===10||te===13}const b=new Set;"()[]{}<>`'\"-/;:,.?!".split("").forEach(te=>b.add(te.charCodeAt(0)));function p(te){return u(te)||b.has(te)}function g(te,ae){return te===ae||p(te)&&p(ae)}function t(te){return f(te)||C(te)||D(te)}function i(te,ae){return ae.length===0?ae=[te]:te.end===ae[0].start?ae[0].start=te.start:ae.unshift(te),ae}function r(te,ae){for(let me=ae;me<te.length;me++){const Ie=te.charCodeAt(me);if(C(Ie)||D(Ie)||me>0&&!t(te.charCodeAt(me-1)))return me}return te.length}function c(te,ae,me,Ie){if(me===te.length)return[];if(Ie===ae.length)return null;if(te[me]!==ae[Ie].toLowerCase())return null;{let O=null,W=Ie+1;for(O=c(te,ae,me+1,Ie+1);!O&&(W=r(ae,W))<ae.length;)O=c(te,ae,me+1,W),W++;return O===null?null:i({start:Ie,end:Ie+1},O)}}function o(te){let ae=0,me=0,Ie=0,O=0,W=0;for(let ue=0;ue<te.length;ue++)W=te.charCodeAt(ue),C(W)&&ae++,f(W)&&me++,t(W)&&Ie++,D(W)&&O++;const G=ae/te.length,J=me/te.length,q=Ie/te.length,x=O/te.length;return{upperPercent:G,lowerPercent:J,alphaPercent:q,numericPercent:x}}function l(te){const{upperPercent:ae,lowerPercent:me}=te;return me===0&&ae>.6}function n(te){const{upperPercent:ae,lowerPercent:me,alphaPercent:Ie,numericPercent:O}=te;return me>.2&&ae<.8&&Ie>.6&&O<.2}function s(te){let ae=0,me=0,Ie=0,O=0;for(let W=0;W<te.length;W++)Ie=te.charCodeAt(W),C(Ie)&&ae++,f(Ie)&&me++,u(Ie)&&O++;return(ae===0||me===0)&&O===0?te.length<=30:ae<=5}function a(te,ae){if(!ae||(ae=ae.trim(),ae.length===0)||!s(te)||ae.length>60)return null;const me=o(ae);if(!n(me)){if(!l(me))return null;ae=ae.toLowerCase()}let Ie=null,O=0;for(te=te.toLowerCase();O<ae.length&&(Ie=c(te,ae,0,O))===null;)O=r(ae,O+1);return Ie}e.$Nj=a;function d(te,ae,me=!1){if(!ae||ae.length===0)return null;let Ie=null,O=0;for(te=te.toLowerCase(),ae=ae.toLowerCase();O<ae.length&&(Ie=v(te,ae,0,O,me))===null;)O=m(ae,O+1);return Ie}e.$Oj=d;function v(te,ae,me,Ie,O){if(me===te.length)return[];if(Ie===ae.length)return null;if(g(te.charCodeAt(me),ae.charCodeAt(Ie))){let W=null,G=Ie+1;if(W=v(te,ae,me+1,Ie+1,O),!O)for(;!W&&(G=m(ae,G))<ae.length;)W=v(te,ae,me+1,G,O),G++;return W?te.charCodeAt(me)!==ae.charCodeAt(Ie)?W:i({start:Ie,end:Ie+1},W):null}else return null}function m(te,ae){for(let me=ae;me<te.length;me++)if(p(te.charCodeAt(me))||me>0&&p(te.charCodeAt(me-1)))return me;return te.length}const S=P(e.$Jj,a,A),k=P(e.$Jj,a,$),h=new y.$Cc(1e4);function w(te,ae,me=!1){if(typeof te!="string"||typeof ae!="string")return null;let Ie=h.get(te);Ie||(Ie=new RegExp(F.$Pe(te),"i"),h.set(te,Ie));const O=Ie.exec(ae);return O?[{start:O.index,end:O.index+O[0].length}]:me?k(te,ae):S(te,ae)}e.$Pj=w;function I(te,ae){const me=pe(te,te.toLowerCase(),0,ae,ae.toLowerCase(),0,{firstMatchCanBeWeak:!0,boostFullMatch:!0});return me?V(me):null}e.$Qj=I;function L(te,ae,me,Ie,O,W){const G=Math.min(13,te.length);for(;me<G;me++){const J=pe(te,ae,me,Ie,O,W,{firstMatchCanBeWeak:!0,boostFullMatch:!0});if(J)return J}return[0,W]}e.$Rj=L;function V(te){if(typeof te>"u")return[];const ae=[],me=te[1];for(let Ie=te.length-1;Ie>1;Ie--){const O=te[Ie]+me,W=ae[ae.length-1];W&&W.end===O?W.end=O+1:ae.push({start:O,end:O+1})}return ae}e.$Sj=V;const K=128;function R(){const te=[],ae=[];for(let me=0;me<=K;me++)ae[me]=0;for(let me=0;me<=K;me++)te.push(ae.slice(0));return te}function N(te){const ae=[];for(let me=0;me<=te;me++)ae[me]=0;return ae}const T=N(2*K),z=N(2*K),Z=R(),he=R(),ye=R(),De=!1;function Se(te,ae,me,Ie,O){function W(J,q,x=" "){for(;J.length<q;)J=x+J;return J}let G=` |   |${Ie.split("").map(J=>W(J,3)).join("|")}
`;for(let J=0;J<=me;J++)J===0?G+=" |":G+=`${ae[J-1]}|`,G+=te[J].slice(0,O+1).map(q=>W(q.toString(),3)).join("|")+`
`;return G}function fe(te,ae,me,Ie){te=te.substr(ae),me=me.substr(Ie),console.log(Se(he,te,te.length,me,me.length)),console.log(Se(ye,te,te.length,me,me.length)),console.log(Se(Z,te,te.length,me,me.length))}function $e(te,ae){if(ae<0||ae>=te.length)return!1;const me=te.codePointAt(ae);switch(me){case 95:case 45:case 46:case 32:case 47:case 92:case 39:case 34:case 58:case 36:case 60:case 62:case 40:case 41:case 91:case 93:case 123:case 125:return!0;case void 0:return!1;default:return!!F.$mf(me)}}function re(te,ae){if(ae<0||ae>=te.length)return!1;switch(te.charCodeAt(ae)){case 32:case 9:return!0;default:return!1}}function Ae(te,ae,me){return ae[te]!==me[te]}function se(te,ae,me,Ie,O,W,G=!1){for(;ae<me&&O<W;)te[ae]===Ie[O]&&(G&&(T[ae]=O),ae+=1),O+=1;return ae===me}e.$Tj=se;var X;(function(te){te[te.Diag=1]="Diag",te[te.Left=2]="Left",te[te.LeftLeft=3]="LeftLeft"})(X||(X={}));var B;(function(te){te.Default=[-100,0];function ae(me){return!me||me.length===2&&me[0]===-100&&me[1]===0}te.isDefault=ae})(B||(e.FuzzyScore=B={}));class ie{static{this.default={boostFullMatch:!0,firstMatchCanBeWeak:!1}}constructor(ae,me){this.firstMatchCanBeWeak=ae,this.boostFullMatch=me}}e.$Uj=ie;function pe(te,ae,me,Ie,O,W,G=ie.default){const J=te.length>K?K:te.length,q=Ie.length>K?K:Ie.length;if(me>=J||W>=q||J-me>q-W||!se(ae,me,J,O,W,q,!0))return;ne(J,q,me,W,ae,O);let x=1,ue=1,Oe=me,Ue=W;const Ze=[!1];for(x=1,Oe=me;Oe<J;x++,Oe++){const rt=T[Oe],nt=z[Oe],Ne=Oe+1<J?z[Oe+1]:q;for(ue=rt-W+1,Ue=rt;Ue<Ne;ue++,Ue++){let dt=Number.MIN_SAFE_INTEGER,Y=!1;Ue<=nt&&(dt=le(te,ae,Oe,me,Ie,O,Ue,q,W,Z[x-1][ue-1]===0,Ze));let Q=0;dt!==Number.MAX_SAFE_INTEGER&&(Y=!0,Q=dt+he[x-1][ue-1]);const Ee=Ue>rt,Be=Ee?he[x][ue-1]+(Z[x][ue-1]>0?-5:0):0,He=Ue>rt+1&&Z[x][ue-1]>0,Ye=He?he[x][ue-2]+(Z[x][ue-2]>0?-5:0):0;if(He&&(!Ee||Ye>=Be)&&(!Y||Ye>=Q))he[x][ue]=Ye,ye[x][ue]=3,Z[x][ue]=0;else if(Ee&&(!Y||Be>=Q))he[x][ue]=Be,ye[x][ue]=2,Z[x][ue]=0;else if(Y)he[x][ue]=Q,ye[x][ue]=1,Z[x][ue]=Z[x-1][ue-1]+1;else throw new Error("not possible")}}if(De&&fe(te,me,Ie,W),!Ze[0]&&!G.firstMatchCanBeWeak)return;x--,ue--;const Je=[he[x][ue],W];let tt=0,_e=0;for(;x>=1;){let rt=ue;do{const nt=ye[x][rt];if(nt===3)rt=rt-2;else if(nt===2)rt=rt-1;else break}while(rt>=1);tt>1&&ae[me+x-1]===O[W+ue-1]&&!Ae(rt+W-1,Ie,O)&&tt+1>Z[x][rt]&&(rt=ue),rt===ue?tt++:tt=1,_e||(_e=rt),x--,ue=rt-1,Je.push(ue)}q===J&&G.boostFullMatch&&(Je[0]+=2);const et=_e-J;return Je[0]-=et,Je}e.$Vj=pe;function ne(te,ae,me,Ie,O,W){let G=te-1,J=ae-1;for(;G>=me&&J>=Ie;)O[G]===W[J]&&(z[G]=J,G--),J--}function le(te,ae,me,Ie,O,W,G,J,q,x,ue){if(ae[me]!==W[G])return Number.MIN_SAFE_INTEGER;let Oe=1,Ue=!1;return G===me-Ie?Oe=te[me]===O[G]?7:5:Ae(G,O,W)&&(G===0||!Ae(G-1,O,W))?(Oe=te[me]===O[G]?7:5,Ue=!0):$e(W,G)&&(G===0||!$e(W,G-1))?Oe=5:($e(W,G-1)||re(W,G-1))&&(Oe=5,Ue=!0),Oe>1&&me===Ie&&(ue[0]=!0),Ue||(Ue=Ae(G,O,W)||$e(W,G-1)||re(W,G-1)),me===Ie?G>q&&(Oe-=Ue?3:5):x?Oe+=Ue?2:0:Oe+=Ue?0:1,G+1===J&&(Oe-=Ue?3:5),Oe}function ce(te,ae,me,Ie,O,W,G){return _(te,ae,me,Ie,O,W,!0,G)}e.$Wj=ce;function we(te,ae,me,Ie,O,W,G){return _(te,ae,me,Ie,O,W,!1,G)}e.$Xj=we;function _(te,ae,me,Ie,O,W,G,J){let q=pe(te,ae,me,Ie,O,W,J);if(q&&!G)return q;if(te.length>=3){const x=Math.min(7,te.length-1);for(let ue=me+1;ue<x;ue++){const Oe=de(te,ue);if(Oe){const Ue=pe(Oe,Oe.toLowerCase(),me,Ie,O,W,J);Ue&&(Ue[0]-=3,(!q||Ue[0]>q[0])&&(q=Ue))}}}return q}function de(te,ae){if(ae+1>=te.length)return;const me=te[ae],Ie=te[ae+1];if(me!==Ie)return te.slice(0,ae)+Ie+me+te.slice(ae+2)}}),define(Pe[31],Re([1,0,12]),function(be,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var F;(function(P){P[P.Ignore=0]="Ignore",P[P.Info=1]="Info",P[P.Warning=2]="Warning",P[P.Error=3]="Error"})(F||(F={})),function(P){const M="error",A="warning",$="warn",E="info",f="ignore";function C(u){return u?y.$6e(M,u)?P.Error:y.$6e(A,u)||y.$6e($,u)?P.Warning:y.$6e(E,u)?P.Info:P.Ignore:P.Ignore}P.fromValue=C;function D(u){switch(u){case P.Error:return M;case P.Warning:return A;case P.Info:return E;default:return f}}P.toString=D}(F||(F={})),e.default=F}),define(Pe[124],Re([1,0]),function(be,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Od=void 0,e.$Od=Symbol("MicrotaskDelay")}),define(Pe[50],Re([1,0,18,12]),function(be,e,y,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2h=e.$1h=e.$Zh=e.$Yh=e.$Xh=void 0;class P{constructor(){this.b="",this.c=0}reset(b){return this.b=b,this.c=0,this}next(){return this.c+=1,this}hasNext(){return this.c<this.b.length-1}cmp(b){const p=b.charCodeAt(0),g=this.b.charCodeAt(this.c);return p-g}value(){return this.b[this.c]}}e.$Xh=P;class M{constructor(b=!0){this.e=b}reset(b){return this.b=b,this.c=0,this.d=0,this.next()}hasNext(){return this.d<this.b.length}next(){this.c=this.d;let b=!0;for(;this.d<this.b.length;this.d++)if(this.b.charCodeAt(this.d)===46)if(b)this.c++;else break;else b=!1;return this}cmp(b){return this.e?(0,F.$Ze)(b,this.b,0,b.length,this.c,this.d):(0,F.$2e)(b,this.b,0,b.length,this.c,this.d)}value(){return this.b.substring(this.c,this.d)}}e.$Yh=M;class A{constructor(b=!0,p=!0){this.f=b,this.g=p}reset(b){this.d=0,this.e=0,this.b=b,this.c=b.length;for(let p=b.length-1;p>=0;p--,this.c--){const g=this.b.charCodeAt(p);if(!(g===47||this.f&&g===92))break}return this.next()}hasNext(){return this.e<this.c}next(){this.d=this.e;let b=!0;for(;this.e<this.c;this.e++){const p=this.b.charCodeAt(this.e);if(p===47||this.f&&p===92)if(b)this.d++;else break;else b=!1}return this}cmp(b){return this.g?(0,F.$Ze)(b,this.b,0,b.length,this.d,this.e):(0,F.$2e)(b,this.b,0,b.length,this.d,this.e)}value(){return this.b.substring(this.d,this.e)}}e.$Zh=A;var $;(function(u){u[u.Scheme=1]="Scheme",u[u.Authority=2]="Authority",u[u.Path=3]="Path",u[u.Query=4]="Query",u[u.Fragment=5]="Fragment"})($||($={}));class E{constructor(b,p){this.f=b,this.g=p,this.d=[],this.e=0}reset(b){return this.c=b,this.d=[],this.c.scheme&&this.d.push(1),this.c.authority&&this.d.push(2),this.c.path&&(this.b=new A(!1,!this.f(b)),this.b.reset(b.path),this.b.value()&&this.d.push(3)),this.g(b)||(this.c.query&&this.d.push(4),this.c.fragment&&this.d.push(5)),this.e=0,this}next(){return this.d[this.e]===3&&this.b.hasNext()?this.b.next():this.e+=1,this}hasNext(){return this.d[this.e]===3&&this.b.hasNext()||this.e<this.d.length-1}cmp(b){if(this.d[this.e]===1)return(0,F.$1e)(b,this.c.scheme);if(this.d[this.e]===2)return(0,F.$1e)(b,this.c.authority);if(this.d[this.e]===3)return this.b.cmp(b);if(this.d[this.e]===4)return(0,F.$Ye)(b,this.c.query);if(this.d[this.e]===5)return(0,F.$Ye)(b,this.c.fragment);throw new Error}value(){if(this.d[this.e]===1)return this.c.scheme;if(this.d[this.e]===2)return this.c.authority;if(this.d[this.e]===3)return this.b.value();if(this.d[this.e]===4)return this.c.query;if(this.d[this.e]===5)return this.c.fragment;throw new Error}}e.$1h=E;class f{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const b=this.right;return this.right=b.left,b.left=this,this.updateHeight(),b.updateHeight(),b}rotateRight(){const b=this.left;return this.left=b.right,b.right=this,this.updateHeight(),b.updateHeight(),b}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var C;(function(u){u[u.Left=-1]="Left",u[u.Mid=0]="Mid",u[u.Right=1]="Right"})(C||(C={}));class D{static forUris(b=()=>!1,p=()=>!1){return new D(new E(b,p))}static forPaths(b=!1){return new D(new A(void 0,!b))}static forStrings(){return new D(new P)}static forConfigKeys(){return new D(new M)}constructor(b){this.b=b}clear(){this.c=void 0}fill(b,p){if(p){const g=p.slice(0);(0,y.$Wb)(g);for(const t of g)this.set(t,b)}else{const g=b.slice(0);(0,y.$Wb)(g);for(const t of g)this.set(t[0],t[1])}}set(b,p){const g=this.b.reset(b);let t;this.c||(this.c=new f,this.c.segment=g.value());const i=[];for(t=this.c;;){const c=g.cmp(t.segment);if(c>0)t.left||(t.left=new f,t.left.segment=g.value()),i.push([-1,t]),t=t.left;else if(c<0)t.right||(t.right=new f,t.right.segment=g.value()),i.push([1,t]),t=t.right;else if(g.hasNext())g.next(),t.mid||(t.mid=new f,t.mid.segment=g.value()),i.push([0,t]),t=t.mid;else break}const r=t.value;t.value=p,t.key=b;for(let c=i.length-1;c>=0;c--){const o=i[c][1];o.updateHeight();const l=o.balanceFactor();if(l<-1||l>1){const n=i[c][0],s=i[c+1][0];if(n===1&&s===1)i[c][1]=o.rotateLeft();else if(n===-1&&s===-1)i[c][1]=o.rotateRight();else if(n===1&&s===-1)o.right=i[c+1][1]=i[c+1][1].rotateRight(),i[c][1]=o.rotateLeft();else if(n===-1&&s===1)o.left=i[c+1][1]=i[c+1][1].rotateLeft(),i[c][1]=o.rotateRight();else throw new Error;if(c>0)switch(i[c-1][0]){case-1:i[c-1][1].left=i[c][1];break;case 1:i[c-1][1].right=i[c][1];break;case 0:i[c-1][1].mid=i[c][1];break}else this.c=i[0][1]}}return r}get(b){return this.d(b)?.value}d(b){const p=this.b.reset(b);let g=this.c;for(;g;){const t=p.cmp(g.segment);if(t>0)g=g.left;else if(t<0)g=g.right;else if(p.hasNext())p.next(),g=g.mid;else break}return g}has(b){const p=this.d(b);return!(p?.value===void 0&&p?.mid===void 0)}delete(b){return this.e(b,!1)}deleteSuperstr(b){return this.e(b,!0)}e(b,p){const g=this.b.reset(b),t=[];let i=this.c;for(;i;){const r=g.cmp(i.segment);if(r>0)t.push([-1,i]),i=i.left;else if(r<0)t.push([1,i]),i=i.right;else if(g.hasNext())g.next(),t.push([0,i]),i=i.mid;else break}if(i){if(p?(i.left=void 0,i.mid=void 0,i.right=void 0,i.height=1):(i.key=void 0,i.value=void 0),!i.mid&&!i.value)if(i.left&&i.right){const r=this.f(i.right);if(r.key){const{key:c,value:o,segment:l}=r;this.e(r.key,!1),i.key=c,i.value=o,i.segment=l}}else{const r=i.left??i.right;if(t.length>0){const[c,o]=t[t.length-1];switch(c){case-1:o.left=r;break;case 0:o.mid=r;break;case 1:o.right=r;break}}else this.c=r}for(let r=t.length-1;r>=0;r--){const c=t[r][1];c.updateHeight();const o=c.balanceFactor();if(o>1?(c.right.balanceFactor()>=0||(c.right=c.right.rotateRight()),t[r][1]=c.rotateLeft()):o<-1&&(c.left.balanceFactor()<=0||(c.left=c.left.rotateLeft()),t[r][1]=c.rotateRight()),r>0)switch(t[r-1][0]){case-1:t[r-1][1].left=t[r][1];break;case 1:t[r-1][1].right=t[r][1];break;case 0:t[r-1][1].mid=t[r][1];break}else this.c=t[0][1]}}}f(b){for(;b.left;)b=b.left;return b}findSubstr(b){const p=this.b.reset(b);let g=this.c,t;for(;g;){const i=p.cmp(g.segment);if(i>0)g=g.left;else if(i<0)g=g.right;else if(p.hasNext())p.next(),t=g.value||t,g=g.mid;else break}return g&&g.value||t}findSuperstr(b){return this.g(b,!1)}g(b,p){const g=this.b.reset(b);let t=this.c;for(;t;){const i=g.cmp(t.segment);if(i>0)t=t.left;else if(i<0)t=t.right;else if(g.hasNext())g.next(),t=t.mid;else return t.mid?this.h(t.mid):p?t.value:void 0}}hasElementOrSubtree(b){return this.g(b,!0)!==void 0}forEach(b){for(const[p,g]of this)b(g,p)}*[Symbol.iterator](){yield*this.h(this.c)}h(b){const p=[];return this.j(b,p),p[Symbol.iterator]()}j(b,p){b&&(b.left&&this.j(b.left,p),b.value&&p.push([b.key,b.value]),b.mid&&this.j(b.mid,p),b.right&&this.j(b.right,p))}_isBalanced(){const b=p=>{if(!p)return!0;const g=p.balanceFactor();return g<-1||g>1?!1:b(p.left)&&b(p.right)};return b(this.c)}}e.$2h=D}),define(Pe[45],Re([1,0,90]),function(be,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ThemeIcon=e.$2j=e.ThemeColor=void 0;var F;(function(A){function $(E){return E&&typeof E=="object"&&typeof E.id=="string"}A.isThemeColor=$})(F||(e.ThemeColor=F={}));function P(A){return{id:A}}e.$2j=P;var M;(function(A){A.iconNameSegment="[A-Za-z0-9]+",A.iconNameExpression="[A-Za-z0-9-]+",A.iconModifierExpression="~[A-Za-z]+",A.iconNameCharacter="[A-Za-z0-9~-]";const $=new RegExp(`^(${A.iconNameExpression})(${A.iconModifierExpression})?$`);function E(r){const c=$.exec(r.id);if(!c)return E(y.$1j.error);const[,o,l]=c,n=["codicon","codicon-"+o];return l&&n.push("codicon-modifier-"+l.substring(1)),n}A.asClassNameArray=E;function f(r){return E(r).join(" ")}A.asClassName=f;function C(r){return"."+E(r).join(".")}A.asCSSSelector=C;function D(r){return r&&typeof r=="object"&&typeof r.id=="string"&&(typeof r.color>"u"||F.isThemeColor(r.color))}A.isThemeIcon=D;const u=new RegExp(`^\\$\\((${A.iconNameExpression}(?:${A.iconModifierExpression})?)\\)$`);function b(r){const c=u.exec(r);if(!c)return;const[,o]=c;return{id:o}}A.fromString=b;function p(r){return{id:r}}A.fromId=p;function g(r,c){let o=r.id;const l=o.lastIndexOf("~");return l!==-1&&(o=o.substring(0,l)),c&&(o=`${o}~${c}`),{id:o}}A.modify=g;function t(r){const c=r.id.lastIndexOf("~");if(c!==-1)return r.id.substring(c+1)}A.getModifier=t;function i(r,c){return r.id===c.id&&r.color?.id===c.color?.id}A.isEqual=i})(M||(e.ThemeIcon=M={}))}),define(Pe[125],Re([1,0,123,12,45]),function(be,e,y,F,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8j=e.$7j=e.$6j=e.$5j=e.$4j=e.$3j=void 0;const M="$(",A=new RegExp(`\\$\\(${P.ThemeIcon.iconNameExpression}(?:${P.ThemeIcon.iconModifierExpression})?\\)`,"g"),$=new RegExp(`(\\\\)?${A.source}`,"g");function E(i){return i.replace($,(r,c)=>c?r:`\\${r}`)}e.$3j=E;const f=new RegExp(`\\\\${A.source}`,"g");function C(i){return i.replace(f,r=>`\\${r}`)}e.$4j=C;const D=new RegExp(`(\\s)?(\\\\)?${A.source}(\\s)?`,"g");function u(i){return i.indexOf(M)===-1?i:i.replace(D,(r,c,o,l)=>o?r:c||l||"")}e.$5j=u;function b(i){return i?i.replace(/\$\((.*?)\)/g,(r,c)=>` ${c} `).trim():""}e.$6j=b;const p=new RegExp(`\\$\\(${P.ThemeIcon.iconNameCharacter}+\\)`,"g");function g(i){p.lastIndex=0;let r="";const c=[];let o=0;for(;;){const l=p.lastIndex,n=p.exec(i),s=i.substring(l,n?.index);if(s.length>0){r+=s;for(let a=0;a<s.length;a++)c.push(o)}if(!n)break;o+=n[0].length}return{text:r,iconOffsets:c}}e.$7j=g;function t(i,r,c=!1){const{text:o,iconOffsets:l}=r;if(!l||l.length===0)return(0,y.$Pj)(i,o,c);const n=(0,F.$Ne)(o," "),s=o.length-n.length,a=(0,y.$Pj)(i,n,c);if(a)for(const d of a){const v=l[d.start+s]+s;d.start+=v,d.end+=v}return a}e.$8j=t}),define(Pe[38],Re([1,0]),function(be,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ig=e.$hg=void 0;const y=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function F(P){return y.test(P)}e.$hg=F,e.$ig=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let P;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?P=crypto.getRandomValues.bind(crypto):P=function($){for(let E=0;E<$.length;E++)$[E]=Math.floor(Math.random()*256);return $};const M=new Uint8Array(16),A=[];for(let $=0;$<256;$++)A.push($.toString(16).padStart(2,"0"));return function(){P(M),M[6]=M[6]&15|64,M[8]=M[8]&63|128;let E=0,f="";return f+=A[M[E++]],f+=A[M[E++]],f+=A[M[E++]],f+=A[M[E++]],f+="-",f+=A[M[E++]],f+=A[M[E++]],f+="-",f+=A[M[E++]],f+=A[M[E++]],f+="-",f+=A[M[E++]],f+=A[M[E++]],f+="-",f+=A[M[E++]],f+=A[M[E++]],f+=A[M[E++]],f+=A[M[E++]],f+=A[M[E++]],f+=A[M[E++]],f}}()}),define(Pe[126],Re([1,0,18,67,38]),function(be,e,y,F,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9s=e.$8s=e.$7s=e.$6s=e.$5s=void 0;function M(D){return{asString:async()=>D,asFile:()=>{},value:typeof D=="string"?D:void 0}}e.$5s=M;function A(D,u,b){const p={id:(0,P.$ig)(),name:D,uri:u,data:b};return{asString:async()=>"",asFile:()=>p,value:void 0}}e.$6s=A;class ${constructor(){this.a=new Map}get size(){let u=0;for(const b of this.a)u++;return u}has(u){return this.a.has(this.b(u))}matches(u){const b=[...this.a.keys()];return F.Iterable.some(this,([p,g])=>g.asFile())&&b.push("files"),C(E(u),b)}get(u){return this.a.get(this.b(u))?.[0]}append(u,b){const p=this.a.get(u);p?p.push(b):this.a.set(this.b(u),[b])}replace(u,b){this.a.set(this.b(u),[b])}delete(u){this.a.delete(this.b(u))}*[Symbol.iterator](){for(const[u,b]of this.a)for(const p of b)yield[u,p]}b(u){return E(u)}}e.$7s=$;function E(D){return D.toLowerCase()}function f(D,u){return C(E(D),u.map(E))}e.$8s=f;function C(D,u){if(D==="*/*")return u.length>0;if(u.includes(D))return!0;const b=D.match(/^([a-z]+)\/([a-z]+|\*)$/i);if(!b)return!1;const[p,g,t]=b;return t==="*"?u.some(i=>i.startsWith(g+"/")):!1}e.$9s=Object.freeze({create:D=>(0,y.$Lb)(D.map(u=>u.toString())).join(`\r
`),split:D=>D.split(`\r
`),parse:D=>e.$9s.split(D).filter(u=>!u.startsWith("#"))})}),define(Pe[127],Re([1,0]),function(be,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_s=e.StringEOL=void 0;var y;(function(P){P[P.Unknown=0]="Unknown",P[P.Invalid=3]="Invalid",P[P.LF=1]="LF",P[P.CRLF=2]="CRLF"})(y||(e.StringEOL=y={}));function F(P){let M=0,A=0,$=0,E=0;for(let f=0,C=P.length;f<C;f++){const D=P.charCodeAt(f);D===13?(M===0&&(A=f),M++,f+1<C&&P.charCodeAt(f+1)===10?(E|=2,f++):E|=3,$=f+1):D===10&&(E|=1,M===0&&(A=f),M++,$=f+1)}return M===0&&(A=P.length),[M,A,P.length-$,E]}e.$_s=F}),define(Pe[128],Re([1,0]),function(be,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9r=void 0,e.$9r={tabSize:4,indentSize:4,insertSpaces:!0,detectIndentation:!0,trimAutoWhitespace:!0,largeFileOptimizations:!0,bracketPairColorizationOptions:{enabled:!0,independentColorPoolPerBracketType:!1}}}),define(Pe[129],Re([1,0]),function(be,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wt=e.$vt=e.IndentAction=void 0;var y;(function(A){A[A.None=0]="None",A[A.Indent=1]="Indent",A[A.IndentOutdent=2]="IndentOutdent",A[A.Outdent=3]="Outdent"})(y||(e.IndentAction=y={}));class F{constructor($){if(this.e=null,this.f=!1,this.open=$.open,this.close=$.close,this.b=!0,this.c=!0,this.d=!0,Array.isArray($.notIn))for(let E=0,f=$.notIn.length;E<f;E++)switch($.notIn[E]){case"string":this.b=!1;break;case"comment":this.c=!1;break;case"regex":this.d=!1;break}}isOK($){switch($){case 0:return!0;case 1:return this.c;case 2:return this.b;case 3:return this.d}}shouldAutoClose($,E){if($.getTokenCount()===0)return!0;const f=$.findTokenIndexAtOffset(E-2),C=$.getStandardTokenType(f);return this.isOK(C)}g($,E){for(let f=$;f<=E;f++){const C=String.fromCharCode(f);if(!this.open.includes(C)&&!this.close.includes(C))return C}return null}findNeutralCharacter(){return this.f||(this.f=!0,this.e||(this.e=this.g(48,57)),this.e||(this.e=this.g(97,122)),this.e||(this.e=this.g(65,90))),this.e}}e.$vt=F;class P{constructor($){this.autoClosingPairsOpenByStart=new Map,this.autoClosingPairsOpenByEnd=new Map,this.autoClosingPairsCloseByStart=new Map,this.autoClosingPairsCloseByEnd=new Map,this.autoClosingPairsCloseSingleChar=new Map;for(const E of $)M(this.autoClosingPairsOpenByStart,E.open.charAt(0),E),M(this.autoClosingPairsOpenByEnd,E.open.charAt(E.open.length-1),E),M(this.autoClosingPairsCloseByStart,E.close.charAt(0),E),M(this.autoClosingPairsCloseByEnd,E.close.charAt(E.close.length-1),E),E.close.length===1&&E.open.length===1&&M(this.autoClosingPairsCloseSingleChar,E.close,E)}}e.$wt=P;function M(A,$,E){A.has($)?A.get($).push(E):A.set($,[E])}}),define(Pe[130],Re([1,0]),function(be,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zB=e.$yB=e.$xB=e.$wB=e.$vB=e.$uB=e.$tB=e.$sB=e.$rB=e.NodeColor=e.$qB=void 0;class y{constructor(t,i){this.piece=t,this.color=i,this.size_left=0,this.lf_left=0,this.parent=this,this.left=this,this.right=this}next(){if(this.right!==e.$rB)return P(this.right);let t=this;for(;t.parent!==e.$rB&&t.parent.left!==t;)t=t.parent;return t.parent===e.$rB?e.$rB:t.parent}prev(){if(this.left!==e.$rB)return M(this.left);let t=this;for(;t.parent!==e.$rB&&t.parent.right!==t;)t=t.parent;return t.parent===e.$rB?e.$rB:t.parent}detach(){this.parent=null,this.left=null,this.right=null}}e.$qB=y;var F;(function(g){g[g.Black=0]="Black",g[g.Red=1]="Red"})(F||(e.NodeColor=F={})),e.$rB=new y(null,0),e.$rB.parent=e.$rB,e.$rB.left=e.$rB,e.$rB.right=e.$rB,e.$rB.color=0;function P(g){for(;g.left!==e.$rB;)g=g.left;return g}e.$sB=P;function M(g){for(;g.right!==e.$rB;)g=g.right;return g}e.$tB=M;function A(g){return g===e.$rB?0:g.size_left+g.piece.length+A(g.right)}function $(g){return g===e.$rB?0:g.lf_left+g.piece.lineFeedCnt+$(g.right)}function E(){e.$rB.parent=e.$rB}function f(g,t){const i=t.right;i.size_left+=t.size_left+(t.piece?t.piece.length:0),i.lf_left+=t.lf_left+(t.piece?t.piece.lineFeedCnt:0),t.right=i.left,i.left!==e.$rB&&(i.left.parent=t),i.parent=t.parent,t.parent===e.$rB?g.root=i:t.parent.left===t?t.parent.left=i:t.parent.right=i,i.left=t,t.parent=i}e.$uB=f;function C(g,t){const i=t.left;t.left=i.right,i.right!==e.$rB&&(i.right.parent=t),i.parent=t.parent,t.size_left-=i.size_left+(i.piece?i.piece.length:0),t.lf_left-=i.lf_left+(i.piece?i.piece.lineFeedCnt:0),t.parent===e.$rB?g.root=i:t===t.parent.right?t.parent.right=i:t.parent.left=i,i.right=t,t.parent=i}e.$vB=C;function D(g,t){let i,r;if(t.left===e.$rB?(r=t,i=r.right):t.right===e.$rB?(r=t,i=r.left):(r=P(t.right),i=r.right),r===g.root){g.root=i,i.color=0,t.detach(),E(),g.root.parent=e.$rB;return}const c=r.color===1;if(r===r.parent.left?r.parent.left=i:r.parent.right=i,r===t?(i.parent=r.parent,p(g,i)):(r.parent===t?i.parent=r:i.parent=r.parent,p(g,i),r.left=t.left,r.right=t.right,r.parent=t.parent,r.color=t.color,t===g.root?g.root=r:t===t.parent.left?t.parent.left=r:t.parent.right=r,r.left!==e.$rB&&(r.left.parent=r),r.right!==e.$rB&&(r.right.parent=r),r.size_left=t.size_left,r.lf_left=t.lf_left,p(g,r)),t.detach(),i.parent.left===i){const l=A(i),n=$(i);if(l!==i.parent.size_left||n!==i.parent.lf_left){const s=l-i.parent.size_left,a=n-i.parent.lf_left;i.parent.size_left=l,i.parent.lf_left=n,b(g,i.parent,s,a)}}if(p(g,i.parent),c){E();return}let o;for(;i!==g.root&&i.color===0;)i===i.parent.left?(o=i.parent.right,o.color===1&&(o.color=0,i.parent.color=1,f(g,i.parent),o=i.parent.right),o.left.color===0&&o.right.color===0?(o.color=1,i=i.parent):(o.right.color===0&&(o.left.color=0,o.color=1,C(g,o),o=i.parent.right),o.color=i.parent.color,i.parent.color=0,o.right.color=0,f(g,i.parent),i=g.root)):(o=i.parent.left,o.color===1&&(o.color=0,i.parent.color=1,C(g,i.parent),o=i.parent.left),o.left.color===0&&o.right.color===0?(o.color=1,i=i.parent):(o.left.color===0&&(o.right.color=0,o.color=1,f(g,o),o=i.parent.left),o.color=i.parent.color,i.parent.color=0,o.left.color=0,C(g,i.parent),i=g.root));i.color=0,E()}e.$wB=D;function u(g,t){for(p(g,t);t!==g.root&&t.parent.color===1;)if(t.parent===t.parent.parent.left){const i=t.parent.parent.right;i.color===1?(t.parent.color=0,i.color=0,t.parent.parent.color=1,t=t.parent.parent):(t===t.parent.right&&(t=t.parent,f(g,t)),t.parent.color=0,t.parent.parent.color=1,C(g,t.parent.parent))}else{const i=t.parent.parent.left;i.color===1?(t.parent.color=0,i.color=0,t.parent.parent.color=1,t=t.parent.parent):(t===t.parent.left&&(t=t.parent,C(g,t)),t.parent.color=0,t.parent.parent.color=1,f(g,t.parent.parent))}g.root.color=0}e.$xB=u;function b(g,t,i,r){for(;t!==g.root&&t!==e.$rB;)t.parent.left===t&&(t.parent.size_left+=i,t.parent.lf_left+=r),t=t.parent}e.$yB=b;function p(g,t){let i=0,r=0;if(t!==g.root){for(;t!==g.root&&t===t.parent.right;)t=t.parent;if(t!==g.root)for(t=t.parent,i=A(t.left)-t.size_left,r=$(t.left)-t.lf_left,t.size_left+=i,t.lf_left+=r;t!==g.root&&(i!==0||r!==0);)t.parent.left===t&&(t.parent.size_left+=i,t.parent.lf_left+=r),t=t.parent}}e.$zB=p}),define(Pe[91],Re([1,0,131,29,92,130,93]),function(be,e,y,F,P,M,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$KB=e.$JB=e.$IB=e.$HB=e.$GB=void 0;const $=65535;function E(i){let r;return i[i.length-1]<65536?r=new Uint16Array(i.length):r=new Uint32Array(i.length),r.set(i,0),r}class f{constructor(r,c,o,l,n){this.lineStarts=r,this.cr=c,this.lf=o,this.crlf=l,this.isBasicASCII=n}}function C(i,r=!0){const c=[0];let o=1;for(let l=0,n=i.length;l<n;l++){const s=i.charCodeAt(l);s===13?l+1<n&&i.charCodeAt(l+1)===10?(c[o++]=l+2,l++):c[o++]=l+1:s===10&&(c[o++]=l+1)}return r?E(c):c}e.$GB=C;function D(i,r){i.length=0,i[0]=0;let c=1,o=0,l=0,n=0,s=!0;for(let d=0,v=r.length;d<v;d++){const m=r.charCodeAt(d);m===13?d+1<v&&r.charCodeAt(d+1)===10?(n++,i[c++]=d+2,d++):(o++,i[c++]=d+1):m===10?(l++,i[c++]=d+1):s&&m!==9&&(m<32||m>126)&&(s=!1)}const a=new f(E(i),o,l,n,s);return i.length=0,a}e.$HB=D;class u{constructor(r,c,o,l,n){this.bufferIndex=r,this.start=c,this.end=o,this.lineFeedCnt=l,this.length=n}}e.$IB=u;class b{constructor(r,c){this.buffer=r,this.lineStarts=c}}e.$JB=b;class p{constructor(r,c){this.a=[],this.c=r,this.d=c,this.b=0,r.root!==M.$rB&&r.iterate(r.root,o=>(o!==M.$rB&&this.a.push(o.piece),!0))}read(){return this.a.length===0?this.b===0?(this.b++,this.d):null:this.b>this.a.length-1?null:this.b===0?this.d+this.c.getPieceContent(this.a[this.b++]):this.c.getPieceContent(this.a[this.b++])}}class g{constructor(r){this.a=r,this.b=[]}get(r){for(let c=this.b.length-1;c>=0;c--){const o=this.b[c];if(o.nodeStartOffset<=r&&o.nodeStartOffset+o.node.piece.length>=r)return o}return null}get2(r){for(let c=this.b.length-1;c>=0;c--){const o=this.b[c];if(o.nodeStartLineNumber&&o.nodeStartLineNumber<r&&o.nodeStartLineNumber+o.node.piece.lineFeedCnt>=r)return o}return null}set(r){this.b.length>=this.a&&this.b.shift(),this.b.push(r)}validate(r){let c=!1;const o=this.b;for(let l=0;l<o.length;l++){const n=o[l];if(n.node.parent===null||n.nodeStartOffset>=r){o[l]=null,c=!0;continue}}if(c){const l=[];for(const n of o)n!==null&&l.push(n);this.b=l}}}class t{constructor(r,c,o){this.create(r,c,o)}create(r,c,o){this.a=[new b("",[0])],this.g={line:0,column:0},this.root=M.$rB,this.b=1,this.c=0,this.d=c,this.e=c.length,this.f=o;let l=null;for(let n=0,s=r.length;n<s;n++)if(r[n].buffer.length>0){r[n].lineStarts||(r[n].lineStarts=C(r[n].buffer));const a=new u(n+1,{line:0,column:0},{line:r[n].lineStarts.length-1,column:r[n].buffer.length-r[n].lineStarts[r[n].lineStarts.length-1]},r[n].lineStarts.length-1,r[n].buffer.length);this.a.push(r[n]),l=this.S(l,a)}this.h=new g(1),this.j={lineNumber:0,value:""},this.y()}normalizeEOL(r){const c=$,o=c-Math.floor(c/3),l=o*2;let n="",s=0;const a=[];if(this.iterate(this.root,d=>{const v=this.R(d),m=v.length;if(s<=o||s+m<l)return n+=v,s+=m,!0;const S=n.replace(/\r\n|\r|\n/g,r);return a.push(new b(S,C(S))),n=v,s=m,!0}),s>0){const d=n.replace(/\r\n|\r|\n/g,r);a.push(new b(d,C(d)))}this.create(a,r,!0)}getEOL(){return this.d}setEOL(r){this.d=r,this.e=this.d.length,this.normalizeEOL(r)}createSnapshot(r){return new p(this,r)}equal(r){if(this.getLength()!==r.getLength()||this.getLineCount()!==r.getLineCount())return!1;let c=0;return this.iterate(this.root,l=>{if(l===M.$rB)return!0;const n=this.R(l),s=n.length,a=r.G(c),d=r.G(c+s),v=r.getValueInRange2(a,d);return c+=s,n===v})}getOffsetAt(r,c){let o=0,l=this.root;for(;l!==M.$rB;)if(l.left!==M.$rB&&l.lf_left+1>=r)l=l.left;else if(l.lf_left+l.piece.lineFeedCnt+1>=r){o+=l.size_left;const n=this.B(l,r-l.lf_left-2);return o+=n+c-1}else r-=l.lf_left+l.piece.lineFeedCnt,o+=l.size_left+l.piece.length,l=l.right;return o}getPositionAt(r){r=Math.floor(r),r=Math.max(0,r);let c=this.root,o=0;const l=r;for(;c!==M.$rB;)if(c.size_left!==0&&c.size_left>=r)c=c.left;else if(c.size_left+c.piece.length>=r){const n=this.A(c,r-c.size_left);if(o+=c.lf_left+n.index,n.index===0){const s=this.getOffsetAt(o+1,1),a=l-s;return new y.$ys(o+1,a+1)}return new y.$ys(o+1,n.remainder+1)}else if(r-=c.size_left+c.piece.length,o+=c.lf_left+c.piece.lineFeedCnt,c.right===M.$rB){const n=this.getOffsetAt(o+1,1),s=l-r-n;return new y.$ys(o+1,s+1)}else c=c.right;return new y.$ys(1,1)}getValueInRange(r,c){if(r.startLineNumber===r.endLineNumber&&r.startColumn===r.endColumn)return"";const o=this.H(r.startLineNumber,r.startColumn),l=this.H(r.endLineNumber,r.endColumn),n=this.getValueInRange2(o,l);return c?c!==this.d||!this.f?n.replace(/\r\n|\r|\n/g,c):c===this.getEOL()&&this.f?n:n.replace(/\r\n|\r|\n/g,c):n}getValueInRange2(r,c){if(r.node===c.node){const a=r.node,d=this.a[a.piece.bufferIndex].buffer,v=this.u(a.piece.bufferIndex,a.piece.start);return d.substring(v+r.remainder,v+c.remainder)}let o=r.node;const l=this.a[o.piece.bufferIndex].buffer,n=this.u(o.piece.bufferIndex,o.piece.start);let s=l.substring(n+r.remainder,n+o.piece.length);for(o=o.next();o!==M.$rB;){const a=this.a[o.piece.bufferIndex].buffer,d=this.u(o.piece.bufferIndex,o.piece.start);if(o===c.node){s+=a.substring(d,d+c.remainder);break}else s+=a.substr(d,o.piece.length);o=o.next()}return s}getLinesContent(){const r=[];let c=0,o="",l=!1;return this.iterate(this.root,n=>{if(n===M.$rB)return!0;const s=n.piece;let a=s.length;if(a===0)return!0;const d=this.a[s.bufferIndex].buffer,v=this.a[s.bufferIndex].lineStarts,m=s.start.line,S=s.end.line;let k=v[m]+s.start.column;if(l&&(d.charCodeAt(k)===10&&(k++,a--),r[c++]=o,o="",l=!1,a===0))return!0;if(m===S)return!this.f&&d.charCodeAt(k+a-1)===13?(l=!0,o+=d.substr(k,a-1)):o+=d.substr(k,a),!0;o+=this.f?d.substring(k,Math.max(k,v[m+1]-this.e)):d.substring(k,v[m+1]).replace(/(\r\n|\r|\n)$/,""),r[c++]=o;for(let h=m+1;h<S;h++)o=this.f?d.substring(v[h],v[h+1]-this.e):d.substring(v[h],v[h+1]).replace(/(\r\n|\r|\n)$/,""),r[c++]=o;return!this.f&&d.charCodeAt(v[S]+s.end.column-1)===13?(l=!0,s.end.column===0?c--:o=d.substr(v[S],s.end.column-1)):o=d.substr(v[S],s.end.column),!0}),l&&(r[c++]=o,o=""),r[c++]=o,r}getLength(){return this.c}getLineCount(){return this.b}getLineContent(r){return this.j.lineNumber===r?this.j.value:(this.j.lineNumber=r,r===this.b?this.j.value=this.getLineRawContent(r):this.f?this.j.value=this.getLineRawContent(r,this.e):this.j.value=this.getLineRawContent(r).replace(/(\r\n|\r|\n)$/,""),this.j.value)}l(r){if(r.remainder===r.node.piece.length){const c=r.node.next();if(!c)return 0;const o=this.a[c.piece.bufferIndex],l=this.u(c.piece.bufferIndex,c.piece.start);return o.buffer.charCodeAt(l)}else{const c=this.a[r.node.piece.bufferIndex],l=this.u(r.node.piece.bufferIndex,r.node.piece.start)+r.remainder;return c.buffer.charCodeAt(l)}}getLineCharCode(r,c){const o=this.H(r,c+1);return this.l(o)}getLineLength(r){if(r===this.getLineCount()){const c=this.getOffsetAt(r,1);return this.getLength()-c}return this.getOffsetAt(r+1,1)-this.getOffsetAt(r,1)-this.e}getCharCode(r){const c=this.G(r);return this.l(c)}findMatchesInNode(r,c,o,l,n,s,a,d,v,m,S){const k=this.a[r.piece.bufferIndex],h=this.u(r.piece.bufferIndex,r.piece.start),w=this.u(r.piece.bufferIndex,n),I=this.u(r.piece.bufferIndex,s);let L;const V={line:0,column:0};let K,R;c._wordSeparators?(K=k.buffer.substring(w,I),R=N=>N+w,c.reset(0)):(K=k.buffer,R=N=>N,c.reset(w));do if(L=c.next(K),L){if(R(L.index)>=I)return m;this.s(r,R(L.index)-h,V);const N=this.t(r.piece.bufferIndex,n,V),T=V.line===n.line?V.column-n.column+l:V.column+1,z=T+L[0].length;if(S[m++]=(0,A.$CB)(new F.$zs(o+N,T,o+N,z),L,d),R(L.index)+L[0].length>=I||m>=v)return m}while(L);return m}findMatchesLineByLine(r,c,o,l){const n=[];let s=0;const a=new A.$FB(c.wordSeparators,c.regex);let d=this.H(r.startLineNumber,r.startColumn);if(d===null)return[];const v=this.H(r.endLineNumber,r.endColumn);if(v===null)return[];let m=this.s(d.node,d.remainder);const S=this.s(v.node,v.remainder);if(d.node===v.node)return this.findMatchesInNode(d.node,a,r.startLineNumber,r.startColumn,m,S,c,o,l,s,n),n;let k=r.startLineNumber,h=d.node;for(;h!==v.node;){const I=this.t(h.piece.bufferIndex,m,h.piece.end);if(I>=1){const V=this.a[h.piece.bufferIndex].lineStarts,K=this.u(h.piece.bufferIndex,h.piece.start),R=V[m.line+I],N=k===r.startLineNumber?r.startColumn:1;if(s=this.findMatchesInNode(h,a,k,N,m,this.s(h,R-K),c,o,l,s,n),s>=l)return n;k+=I}const L=k===r.startLineNumber?r.startColumn-1:0;if(k===r.endLineNumber){const V=this.getLineContent(k).substring(L,r.endColumn-1);return s=this.n(c,a,V,r.endLineNumber,L,s,n,o,l),n}if(s=this.n(c,a,this.getLineContent(k).substr(L),k,L,s,n,o,l),s>=l)return n;k++,d=this.H(k,1),h=d.node,m=this.s(d.node,d.remainder)}if(k===r.endLineNumber){const I=k===r.startLineNumber?r.startColumn-1:0,L=this.getLineContent(k).substring(I,r.endColumn-1);return s=this.n(c,a,L,r.endLineNumber,I,s,n,o,l),n}const w=k===r.startLineNumber?r.startColumn:1;return s=this.findMatchesInNode(v.node,a,k,w,m,S,c,o,l,s,n),n}n(r,c,o,l,n,s,a,d,v){const m=r.wordSeparators;if(!d&&r.simpleSearch){const k=r.simpleSearch,h=k.length,w=o.length;let I=-h;for(;(I=o.indexOf(k,I+h))!==-1;)if((!m||(0,A.$EB)(m,o,w,I,h))&&(a[s++]=new P.$Qu(new F.$zs(l,I+1+n,l,I+1+h+n),null),s>=v))return s;return s}let S;c.reset(0);do if(S=c.next(o),S&&(a[s++]=(0,A.$CB)(new F.$zs(l,S.index+1+n,l,S.index+1+S[0].length+n),S,d),s>=v))return s;while(S);return s}insert(r,c,o=!1){if(this.f=this.f&&o,this.j.lineNumber=0,this.j.value="",this.root!==M.$rB){const{node:l,remainder:n,nodeStartOffset:s}=this.G(r),a=l.piece,d=a.bufferIndex,v=this.s(l,n);if(l.piece.bufferIndex===0&&a.end.line===this.g.line&&a.end.column===this.g.column&&s+a.length===r&&c.length<$){this.F(l,c),this.y();return}if(s===r)this.o(c,l),this.h.validate(r);else if(s+l.piece.length>r){const m=[];let S=new u(a.bufferIndex,v,a.end,this.t(a.bufferIndex,v,a.end),this.u(d,a.end)-this.u(d,v));if(this.K()&&this.M(c)&&this.I(l,n)===10){const I={line:S.start.line+1,column:0};S=new u(S.bufferIndex,I,S.end,this.t(S.bufferIndex,I,S.end),S.length-1),c+=`
`}if(this.K()&&this.L(c))if(this.I(l,n-1)===13){const I=this.s(l,n-1);this.C(l,I),c="\r"+c,l.piece.length===0&&m.push(l)}else this.C(l,v);else this.C(l,v);const k=this.w(c);S.length>0&&this.S(l,S);let h=l;for(let w=0;w<k.length;w++)h=this.S(h,k[w]);this.v(m)}else this.q(c,l)}else{const l=this.w(c);let n=this.T(null,l[0]);for(let s=1;s<l.length;s++)n=this.S(n,l[s])}this.y()}delete(r,c){if(this.j.lineNumber=0,this.j.value="",c<=0||this.root===M.$rB)return;const o=this.G(r),l=this.G(r+c),n=o.node,s=l.node;if(n===s){const k=this.s(n,o.remainder),h=this.s(n,l.remainder);if(o.nodeStartOffset===r){if(c===n.piece.length){const w=n.next();(0,M.$wB)(this,n),this.N(w),this.y();return}this.D(n,h),this.h.validate(r),this.N(n),this.y();return}if(o.nodeStartOffset+n.piece.length===r+c){this.C(n,k),this.O(n),this.y();return}this.E(n,k,h),this.y();return}const a=[],d=this.s(n,o.remainder);this.C(n,d),this.h.validate(r),n.piece.length===0&&a.push(n);const v=this.s(s,l.remainder);this.D(s,v),s.piece.length===0&&a.push(s);const m=n.next();for(let k=m;k!==M.$rB&&k!==s;k=k.next())a.push(k);const S=n.piece.length===0?n.prev():n;this.v(a),this.O(S),this.y()}o(r,c){const o=[];if(this.K()&&this.M(r)&&this.L(c)){const s=c.piece,a={line:s.start.line+1,column:0},d=new u(s.bufferIndex,a,s.end,this.t(s.bufferIndex,a,s.end),s.length-1);c.piece=d,r+=`
`,(0,M.$yB)(this,c,-1,-1),c.piece.length===0&&o.push(c)}const l=this.w(r);let n=this.T(c,l[l.length-1]);for(let s=l.length-2;s>=0;s--)n=this.T(n,l[s]);this.N(n),this.v(o)}q(r,c){this.Q(r,c)&&(r+=`
`);const o=this.w(r),l=this.S(c,o[0]);let n=l;for(let s=1;s<o.length;s++)n=this.S(n,o[s]);this.N(l)}s(r,c,o){const l=r.piece,n=r.piece.bufferIndex,s=this.a[n].lineStarts,d=s[l.start.line]+l.start.column+c;let v=l.start.line,m=l.end.line,S=0,k=0,h=0;for(;v<=m&&(S=v+(m-v)/2|0,h=s[S],S!==m);)if(k=s[S+1],d<h)m=S-1;else if(d>=k)v=S+1;else break;return o?(o.line=S,o.column=d-h,null):{line:S,column:d-h}}t(r,c,o){if(o.column===0)return o.line-c.line;const l=this.a[r].lineStarts;if(o.line===l.length-1)return o.line-c.line;const n=l[o.line+1],s=l[o.line]+o.column;if(n>s+1)return o.line-c.line;const a=s-1;return this.a[r].buffer.charCodeAt(a)===13?o.line-c.line+1:o.line-c.line}u(r,c){return this.a[r].lineStarts[c.line]+c.column}v(r){for(let c=0;c<r.length;c++)(0,M.$wB)(this,r[c])}w(r){if(r.length>$){const m=[];for(;r.length>$;){const k=r.charCodeAt($-1);let h;k===13||k>=55296&&k<=56319?(h=r.substring(0,$-1),r=r.substring($-1)):(h=r.substring(0,$),r=r.substring($));const w=C(h);m.push(new u(this.a.length,{line:0,column:0},{line:w.length-1,column:h.length-w[w.length-1]},w.length-1,h.length)),this.a.push(new b(h,w))}const S=C(r);return m.push(new u(this.a.length,{line:0,column:0},{line:S.length-1,column:r.length-S[S.length-1]},S.length-1,r.length)),this.a.push(new b(r,S)),m}let c=this.a[0].buffer.length;const o=C(r,!1);let l=this.g;if(this.a[0].lineStarts[this.a[0].lineStarts.length-1]===c&&c!==0&&this.L(r)&&this.M(this.a[0].buffer)){this.g={line:this.g.line,column:this.g.column+1},l=this.g;for(let m=0;m<o.length;m++)o[m]+=c+1;this.a[0].lineStarts=this.a[0].lineStarts.concat(o.slice(1)),this.a[0].buffer+="_"+r,c+=1}else{if(c!==0)for(let m=0;m<o.length;m++)o[m]+=c;this.a[0].lineStarts=this.a[0].lineStarts.concat(o.slice(1)),this.a[0].buffer+=r}const n=this.a[0].buffer.length,s=this.a[0].lineStarts.length-1,a=n-this.a[0].lineStarts[s],d={line:s,column:a},v=new u(0,l,d,this.t(0,l,d),n-c);return this.g=d,[v]}getLinesRawContent(){return this.U(this.root)}getLineRawContent(r,c=0){let o=this.root,l="";const n=this.h.get2(r);if(n){o=n.node;const s=this.B(o,r-n.nodeStartLineNumber-1),a=this.a[o.piece.bufferIndex].buffer,d=this.u(o.piece.bufferIndex,o.piece.start);if(n.nodeStartLineNumber+o.piece.lineFeedCnt===r)l=a.substring(d+s,d+o.piece.length);else{const v=this.B(o,r-n.nodeStartLineNumber);return a.substring(d+s,d+v-c)}}else{let s=0;const a=r;for(;o!==M.$rB;)if(o.left!==M.$rB&&o.lf_left>=r-1)o=o.left;else if(o.lf_left+o.piece.lineFeedCnt>r-1){const d=this.B(o,r-o.lf_left-2),v=this.B(o,r-o.lf_left-1),m=this.a[o.piece.bufferIndex].buffer,S=this.u(o.piece.bufferIndex,o.piece.start);return s+=o.size_left,this.h.set({node:o,nodeStartOffset:s,nodeStartLineNumber:a-(r-1-o.lf_left)}),m.substring(S+d,S+v-c)}else if(o.lf_left+o.piece.lineFeedCnt===r-1){const d=this.B(o,r-o.lf_left-2),v=this.a[o.piece.bufferIndex].buffer,m=this.u(o.piece.bufferIndex,o.piece.start);l=v.substring(m+d,m+o.piece.length);break}else r-=o.lf_left+o.piece.lineFeedCnt,s+=o.size_left+o.piece.length,o=o.right}for(o=o.next();o!==M.$rB;){const s=this.a[o.piece.bufferIndex].buffer;if(o.piece.lineFeedCnt>0){const a=this.B(o,0),d=this.u(o.piece.bufferIndex,o.piece.start);return l+=s.substring(d,d+a-c),l}else{const a=this.u(o.piece.bufferIndex,o.piece.start);l+=s.substr(a,o.piece.length)}o=o.next()}return l}y(){let r=this.root,c=1,o=0;for(;r!==M.$rB;)c+=r.lf_left+r.piece.lineFeedCnt,o+=r.size_left+r.piece.length,r=r.right;this.b=c,this.c=o,this.h.validate(this.c)}A(r,c){const o=r.piece,l=this.s(r,c),n=l.line-o.start.line;if(this.u(o.bufferIndex,o.end)-this.u(o.bufferIndex,o.start)===c){const s=this.t(r.piece.bufferIndex,o.start,l);if(s!==n)return{index:s,remainder:0}}return{index:n,remainder:l.column}}B(r,c){if(c<0)return 0;const o=r.piece,l=this.a[o.bufferIndex].lineStarts,n=o.start.line+c+1;return n>o.end.line?l[o.end.line]+o.end.column-l[o.start.line]-o.start.column:l[n]-l[o.start.line]-o.start.column}C(r,c){const o=r.piece,l=o.lineFeedCnt,n=this.u(o.bufferIndex,o.end),s=c,a=this.u(o.bufferIndex,s),d=this.t(o.bufferIndex,o.start,s),v=d-l,m=a-n,S=o.length+m;r.piece=new u(o.bufferIndex,o.start,s,d,S),(0,M.$yB)(this,r,m,v)}D(r,c){const o=r.piece,l=o.lineFeedCnt,n=this.u(o.bufferIndex,o.start),s=c,a=this.t(o.bufferIndex,s,o.end),d=this.u(o.bufferIndex,s),v=a-l,m=n-d,S=o.length+m;r.piece=new u(o.bufferIndex,s,o.end,a,S),(0,M.$yB)(this,r,m,v)}E(r,c,o){const l=r.piece,n=l.start,s=l.end,a=l.length,d=l.lineFeedCnt,v=c,m=this.t(l.bufferIndex,l.start,v),S=this.u(l.bufferIndex,c)-this.u(l.bufferIndex,n);r.piece=new u(l.bufferIndex,l.start,v,m,S),(0,M.$yB)(this,r,S-a,m-d);const k=new u(l.bufferIndex,o,s,this.t(l.bufferIndex,o,s),this.u(l.bufferIndex,s)-this.u(l.bufferIndex,o)),h=this.S(r,k);this.N(h)}F(r,c){this.Q(c,r)&&(c+=`
`);const o=this.K()&&this.L(c)&&this.M(r),l=this.a[0].buffer.length;this.a[0].buffer+=c;const n=C(c,!1);for(let h=0;h<n.length;h++)n[h]+=l;if(o){const h=this.a[0].lineStarts[this.a[0].lineStarts.length-2];this.a[0].lineStarts.pop(),this.g={line:this.g.line-1,column:l-h}}this.a[0].lineStarts=this.a[0].lineStarts.concat(n.slice(1));const s=this.a[0].lineStarts.length-1,a=this.a[0].buffer.length-this.a[0].lineStarts[s],d={line:s,column:a},v=r.piece.length+c.length,m=r.piece.lineFeedCnt,S=this.t(0,r.piece.start,d),k=S-m;r.piece=new u(r.piece.bufferIndex,r.piece.start,d,S,v),this.g=d,(0,M.$yB)(this,r,c.length,k)}G(r){let c=this.root;const o=this.h.get(r);if(o)return{node:o.node,nodeStartOffset:o.nodeStartOffset,remainder:r-o.nodeStartOffset};let l=0;for(;c!==M.$rB;)if(c.size_left>r)c=c.left;else if(c.size_left+c.piece.length>=r){l+=c.size_left;const n={node:c,remainder:r-c.size_left,nodeStartOffset:l};return this.h.set(n),n}else r-=c.size_left+c.piece.length,l+=c.size_left+c.piece.length,c=c.right;return null}H(r,c){let o=this.root,l=0;for(;o!==M.$rB;)if(o.left!==M.$rB&&o.lf_left>=r-1)o=o.left;else if(o.lf_left+o.piece.lineFeedCnt>r-1){const n=this.B(o,r-o.lf_left-2),s=this.B(o,r-o.lf_left-1);return l+=o.size_left,{node:o,remainder:Math.min(n+c-1,s),nodeStartOffset:l}}else if(o.lf_left+o.piece.lineFeedCnt===r-1){const n=this.B(o,r-o.lf_left-2);if(n+c-1<=o.piece.length)return{node:o,remainder:n+c-1,nodeStartOffset:l};c-=o.piece.length-n;break}else r-=o.lf_left+o.piece.lineFeedCnt,l+=o.size_left+o.piece.length,o=o.right;for(o=o.next();o!==M.$rB;){if(o.piece.lineFeedCnt>0){const n=this.B(o,0),s=this.J(o);return{node:o,remainder:Math.min(c-1,n),nodeStartOffset:s}}else if(o.piece.length>=c-1){const n=this.J(o);return{node:o,remainder:c-1,nodeStartOffset:n}}else c-=o.piece.length;o=o.next()}return null}I(r,c){if(r.piece.lineFeedCnt<1)return-1;const o=this.a[r.piece.bufferIndex],l=this.u(r.piece.bufferIndex,r.piece.start)+c;return o.buffer.charCodeAt(l)}J(r){if(!r)return 0;let c=r.size_left;for(;r!==this.root;)r.parent.right===r&&(c+=r.parent.size_left+r.parent.piece.length),r=r.parent;return c}K(){return!(this.f&&this.d===`
`)}L(r){if(typeof r=="string")return r.charCodeAt(0)===10;if(r===M.$rB||r.piece.lineFeedCnt===0)return!1;const c=r.piece,o=this.a[c.bufferIndex].lineStarts,l=c.start.line,n=o[l]+c.start.column;return l===o.length-1||o[l+1]>n+1?!1:this.a[c.bufferIndex].buffer.charCodeAt(n)===10}M(r){return typeof r=="string"?r.charCodeAt(r.length-1)===13:r===M.$rB||r.piece.lineFeedCnt===0?!1:this.I(r,r.piece.length-1)===13}N(r){if(this.K()&&this.L(r)){const c=r.prev();this.M(c)&&this.P(c,r)}}O(r){if(this.K()&&this.M(r)){const c=r.next();this.L(c)&&this.P(r,c)}}P(r,c){const o=[],l=this.a[r.piece.bufferIndex].lineStarts;let n;r.piece.end.column===0?n={line:r.piece.end.line-1,column:l[r.piece.end.line]-l[r.piece.end.line-1]-1}:n={line:r.piece.end.line,column:r.piece.end.column-1};const s=r.piece.length-1,a=r.piece.lineFeedCnt-1;r.piece=new u(r.piece.bufferIndex,r.piece.start,n,a,s),(0,M.$yB)(this,r,-1,-1),r.piece.length===0&&o.push(r);const d={line:c.piece.start.line+1,column:0},v=c.piece.length-1,m=this.t(c.piece.bufferIndex,d,c.piece.end);c.piece=new u(c.piece.bufferIndex,d,c.piece.end,m,v),(0,M.$yB)(this,c,-1,-1),c.piece.length===0&&o.push(c);const S=this.w(`\r
`);this.S(r,S[0]);for(let k=0;k<o.length;k++)(0,M.$wB)(this,o[k])}Q(r,c){if(this.K()&&this.M(r)){const o=c.next();if(this.L(o)){if(r+=`
`,o.piece.length===1)(0,M.$wB)(this,o);else{const l=o.piece,n={line:l.start.line+1,column:0},s=l.length-1,a=this.t(l.bufferIndex,n,l.end);o.piece=new u(l.bufferIndex,n,l.end,a,s),(0,M.$yB)(this,o,-1,-1)}return!0}}return!1}iterate(r,c){if(r===M.$rB)return c(M.$rB);const o=this.iterate(r.left,c);return o&&c(r)&&this.iterate(r.right,c)}R(r){if(r===M.$rB)return"";const c=this.a[r.piece.bufferIndex],o=r.piece,l=this.u(o.bufferIndex,o.start),n=this.u(o.bufferIndex,o.end);return c.buffer.substring(l,n)}getPieceContent(r){const c=this.a[r.bufferIndex],o=this.u(r.bufferIndex,r.start),l=this.u(r.bufferIndex,r.end);return c.buffer.substring(o,l)}S(r,c){const o=new M.$qB(c,1);if(o.left=M.$rB,o.right=M.$rB,o.parent=M.$rB,o.size_left=0,o.lf_left=0,this.root===M.$rB)this.root=o,o.color=0;else if(r.right===M.$rB)r.right=o,o.parent=r;else{const n=(0,M.$sB)(r.right);n.left=o,o.parent=n}return(0,M.$xB)(this,o),o}T(r,c){const o=new M.$qB(c,1);if(o.left=M.$rB,o.right=M.$rB,o.parent=M.$rB,o.size_left=0,o.lf_left=0,this.root===M.$rB)this.root=o,o.color=0;else if(r.left===M.$rB)r.left=o,o.parent=r;else{const l=(0,M.$tB)(r.left);l.right=o,o.parent=l}return(0,M.$xB)(this,o),o}U(r){let c="";return this.iterate(r,o=>(c+=this.R(o),!0)),c}}e.$KB=t}),define(Pe[132],Re([1,0]),function(be,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$o8=e.$n8=void 0;class y{constructor(){this.a=new Map}removeDragOperationTransfer(M){if(M&&this.a.has(M)){const A=this.a.get(M);return this.a.delete(M),A}}addDragOperationTransfer(M,A){this.a.set(M,A)}}e.$n8=y;class F{constructor(M){this.identifier=M}}e.$o8=F}),define(Pe[133],Re([9,10]),function(be,e){return be.create("vs/base/common/actions",e)}),define(Pe[134],Re([1,0,5,6,133]),function(be,e,y,F,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fi=e.$Ei=e.$Di=e.$Ci=e.$Bi=e.$Ai=void 0;class M extends F.$Rc{constructor(u,b="",p="",g=!0,t){super(),this.h=this.B(new y.$Rd),this.onDidChange=this.h.event,this.w=!0,this.j=u,this.m=b,this.u=p,this.w=g,this.C=t}get id(){return this.j}get label(){return this.m}set label(u){this.D(u)}D(u){this.m!==u&&(this.m=u,this.h.fire({label:u}))}get tooltip(){return this.n||""}set tooltip(u){this.F(u)}F(u){this.n!==u&&(this.n=u,this.h.fire({tooltip:u}))}get class(){return this.u}set class(u){this.G(u)}G(u){this.u!==u&&(this.u=u,this.h.fire({class:u}))}get enabled(){return this.w}set enabled(u){this.H(u)}H(u){this.w!==u&&(this.w=u,this.h.fire({enabled:u}))}get checked(){return this.z}set checked(u){this.I(u)}I(u){this.z!==u&&(this.z=u,this.h.fire({checked:u}))}async run(u,b){this.C&&await this.C(u)}}e.$Ai=M;class A extends F.$Rc{constructor(){super(...arguments),this.f=this.B(new y.$Rd),this.onWillRun=this.f.event,this.m=this.B(new y.$Rd),this.onDidRun=this.m.event}async run(u,b){if(!u.enabled)return;this.f.fire({action:u});let p;try{await this.u(u,b)}catch(g){p=g}this.m.fire({action:u,error:p})}async u(u,b){await u.run(b)}}e.$Bi=A;class ${constructor(){this.id=$.ID,this.label="",this.tooltip="",this.class="separator",this.enabled=!1,this.checked=!1}static join(...u){let b=[];for(const p of u)p.length&&(b.length?b=[...b,new $,...p]:b=p);return b}static{this.ID="vs.actions.separator"}async run(){}}e.$Ci=$;class E{get actions(){return this.a}constructor(u,b,p,g){this.tooltip="",this.enabled=!0,this.checked=void 0,this.id=u,this.label=b,this.class=g,this.a=p}async run(){}}e.$Di=E;class f extends M{static{this.ID="vs.actions.empty"}constructor(){super(f.ID,P.localize(0,null),void 0,!1)}}e.$Ei=f;function C(D){return{id:D.id,label:D.label,class:void 0,enabled:D.enabled??!0,checked:D.checked??!1,run:async(...u)=>D.run(...u),tooltip:D.label}}e.$Fi=C}),define(Pe[135],Re([9,10]),function(be,e){return be.create("vs/base/common/date",e)}),define(Pe[136],Re([1,0,135]),function(be,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$km=e.$jm=void 0;const F=60,P=F*60,M=P*24,A=M*7,$=M*30,E=M*365;function f(D,u,b,p){typeof D!="number"&&(D=D.getTime());const g=Math.round((new Date().getTime()-D)/1e3);if(g<-30)return(0,y.localize)(0,null,f(new Date().getTime()+g*1e3,!1));if(!p&&g<30)return(0,y.localize)(1,null);let t;return g<F?(t=g,u?t===1?b?(0,y.localize)(2,null,t):(0,y.localize)(3,null,t):b?(0,y.localize)(4,null,t):(0,y.localize)(5,null,t):t===1?b?(0,y.localize)(6,null,t):(0,y.localize)(7,null,t):b?(0,y.localize)(8,null,t):(0,y.localize)(9,null,t)):g<P?(t=Math.floor(g/F),u?t===1?b?(0,y.localize)(10,null,t):(0,y.localize)(11,null,t):b?(0,y.localize)(12,null,t):(0,y.localize)(13,null,t):t===1?b?(0,y.localize)(14,null,t):(0,y.localize)(15,null,t):b?(0,y.localize)(16,null,t):(0,y.localize)(17,null,t)):g<M?(t=Math.floor(g/P),u?t===1?b?(0,y.localize)(18,null,t):(0,y.localize)(19,null,t):b?(0,y.localize)(20,null,t):(0,y.localize)(21,null,t):t===1?b?(0,y.localize)(22,null,t):(0,y.localize)(23,null,t):b?(0,y.localize)(24,null,t):(0,y.localize)(25,null,t)):g<A?(t=Math.floor(g/M),u?t===1?(0,y.localize)(26,null,t):(0,y.localize)(27,null,t):t===1?(0,y.localize)(28,null,t):(0,y.localize)(29,null,t)):g<$?(t=Math.floor(g/A),u?t===1?b?(0,y.localize)(30,null,t):(0,y.localize)(31,null,t):b?(0,y.localize)(32,null,t):(0,y.localize)(33,null,t):t===1?b?(0,y.localize)(34,null,t):(0,y.localize)(35,null,t):b?(0,y.localize)(36,null,t):(0,y.localize)(37,null,t)):g<E?(t=Math.floor(g/$),u?t===1?b?(0,y.localize)(38,null,t):(0,y.localize)(39,null,t):b?(0,y.localize)(40,null,t):(0,y.localize)(41,null,t):t===1?b?(0,y.localize)(42,null,t):(0,y.localize)(43,null,t):b?(0,y.localize)(44,null,t):(0,y.localize)(45,null,t)):(t=Math.floor(g/E),u?t===1?b?(0,y.localize)(46,null,t):(0,y.localize)(47,null,t):b?(0,y.localize)(48,null,t):(0,y.localize)(49,null,t):t===1?b?(0,y.localize)(50,null,t):(0,y.localize)(51,null,t):b?(0,y.localize)(52,null,t):(0,y.localize)(53,null,t))}e.$jm=f;function C(D){return D.getFullYear()+"-"+String(D.getMonth()+1).padStart(2,"0")+"-"+String(D.getDate()).padStart(2,"0")+"T"+String(D.getHours()).padStart(2,"0")+":"+String(D.getMinutes()).padStart(2,"0")+":"+String(D.getSeconds()).padStart(2,"0")+"."+(D.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.$km=C}),define(Pe[137],Re([9,10]),function(be,e){return be.create("vs/base/common/errorMessage",e)}),define(Pe[39],Re([1,0,18,16,137]),function(be,e,y,F,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ii=e.$Hi=e.$Gi=void 0;function M(D,u){return u&&(D.stack||D.stacktrace)?P.localize(0,null,$(D),A(D.stack)||A(D.stacktrace)):$(D)}function A(D){return Array.isArray(D)?D.join(`
`):D}function $(D){return D.code==="ERR_UNC_HOST_NOT_ALLOWED"?`${D.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`:typeof D.code=="string"&&typeof D.errno=="number"&&typeof D.syscall=="string"?P.localize(1,null,D.message):D.message||P.localize(2,null)}function E(D=null,u=!1){if(!D)return P.localize(3,null);if(Array.isArray(D)){const b=y.$Gb(D),p=E(b[0],u);return b.length>1?P.localize(4,null,p,b.length):p}if(F.$Cf(D))return D;if(D.detail){const b=D.detail;if(b.error)return M(b.error,u);if(b.exception)return M(b.exception,u)}return D.stack?M(D,u):D.message?D.message:P.localize(5,null)}e.$Gi=E;function f(D){const u=D;return u instanceof Error&&Array.isArray(u.actions)}e.$Hi=f;function C(D,u){let b;return typeof D=="string"?b=new Error(D):b=D,b.actions=u,b}e.$Ii=C}),define(Pe[138],Re([1,0,44,19]),function(be,e,y,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zq=e.$yq=e.$xq=e.$wq=e.$vq=e.$uq=e.$tq=e.$sq=e.$rq=e.$qq=e.$pq=e.$oq=e.$nq=void 0;const P=new y.$U(()=>{const k=new Intl.Collator(void 0,{numeric:!0,sensitivity:"base"});return{collator:k,collatorIsNumeric:k.resolvedOptions().numeric}}),M=new y.$U(()=>({collator:new Intl.Collator(void 0,{numeric:!0})})),A=new y.$U(()=>({collator:new Intl.Collator(void 0,{numeric:!0,sensitivity:"accent"})}));function $(k,h,w=!1){const I=k||"",L=h||"",V=P.value.collator.compare(I,L);return P.value.collatorIsNumeric&&V===0&&I!==L?I<L?-1:1:V}e.$nq=$;function E(k,h){const w=M.value.collator;return k=k||"",h=h||"",o(w,k,h)}e.$oq=E;function f(k,h){const w=M.value.collator;return k=k||"",h=h||"",a(k,h)||o(w,k,h)}e.$pq=f;function C(k,h){const w=M.value.collator;return k=k||"",h=h||"",s(k,h)||o(w,k,h)}e.$qq=C;function D(k,h){return k=k||"",h=h||"",k===h?0:k<h?-1:1}e.$rq=D;function u(k,h){const[w,I]=r(k),[L,V]=r(h);let K=P.value.collator.compare(I,V);if(K===0){if(P.value.collatorIsNumeric&&I!==V)return I<V?-1:1;if(K=P.value.collator.compare(w,L),P.value.collatorIsNumeric&&K===0&&w!==L)return w<L?-1:1}return K}e.$sq=u;function b(k,h){k=k||"",h=h||"";const w=c(k),I=c(h),L=M.value.collator,V=A.value.collator;return o(V,w,I)||o(L,k,h)}e.$tq=b;function p(k,h){k=k||"",h=h||"";const w=c(k),I=c(h),L=M.value.collator,V=A.value.collator;return o(V,w,I)||a(k,h)||o(L,k,h)}e.$uq=p;function g(k,h){k=k||"",h=h||"";const w=c(k),I=c(h),L=M.value.collator,V=A.value.collator;return o(V,w,I)||s(k,h)||o(L,k,h)}e.$vq=g;function t(k,h){k=k||"",h=h||"";const w=c(k).toLowerCase(),I=c(h).toLowerCase();return w!==I?w<I?-1:1:k!==h?k<h?-1:1:0}e.$wq=t;const i=/^(.*?)(\.([^.]*))?$/;function r(k,h=!1){const w=k?i.exec(k):[];let I=[w&&w[1]||"",w&&w[3]||""];return h&&(!I[0]&&I[1]||I[0]&&I[0].charAt(0)===".")&&(I=[I[0]+"."+I[1],""]),I}function c(k){const h=k?i.exec(k):[];return h&&h[1]&&h[1].charAt(0)!=="."&&h[3]||""}function o(k,h,w){const I=k.compare(h,w);return I!==0?I:h.length!==w.length?h.length<w.length?-1:1:0}function l(k){const h=k.charAt(0);return h.toLocaleUpperCase()!==h}function n(k){const h=k.charAt(0);return h.toLocaleLowerCase()!==h}function s(k,h){return l(k)&&n(h)?-1:n(k)&&l(h)?1:0}function a(k,h){return n(k)&&l(h)?-1:l(k)&&n(h)?1:0}function d(k,h,w=!1){return w||(k=k&&k.toLowerCase(),h=h&&h.toLowerCase()),k===h?0:k<h?-1:1}function v(k,h,w=!1){const I=k.split(F.sep),L=h.split(F.sep),V=I.length-1,K=L.length-1;let R,N;for(let T=0;;T++){if(R=V===T,N=K===T,R&&N)return $(I[T],L[T],w);if(R)return-1;if(N)return 1;const z=d(I[T],L[T],w);if(z!==0)return z}}e.$xq=v;function m(k,h,w){const I=k.toLowerCase(),L=h.toLowerCase(),V=S(k,h,w);if(V)return V;const K=I.endsWith(w),R=L.endsWith(w);if(K!==R)return K?-1:1;const N=$(I,L);return N!==0?N:I.localeCompare(L)}e.$yq=m;function S(k,h,w){const I=k.toLowerCase(),L=h.toLowerCase(),V=I.startsWith(w),K=L.startsWith(w);if(V!==K)return V?-1:1;if(V&&K){if(I.length<L.length)return-1;if(I.length>L.length)return 1}return 0}e.$zq=S}),define(Pe[46],Re([1,0,19,21,12,16]),function(be,e,y,F,P,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0f=e.$9f=e.$8f=e.$7f=e.$6f=e.$5f=e.$4f=e.$3f=e.$2f=e.$1f=e.$Zf=e.$Yf=e.$Xf=e.$Wf=e.$Vf=e.$Uf=void 0;function A(m){return m===47||m===92}e.$Uf=A;function $(m){return m.replace(/[\\/]/g,y.$fc.sep)}e.$Vf=$;function E(m){return m.indexOf("/")===-1&&(m=$(m)),/^[a-zA-Z]:(\/|$)/.test(m)&&(m="/"+m),m}e.$Wf=E;function f(m,S=y.$fc.sep){if(!m)return"";const k=m.length,h=m.charCodeAt(0);if(A(h)){if(A(m.charCodeAt(1))&&!A(m.charCodeAt(2))){let I=3;const L=I;for(;I<k&&!A(m.charCodeAt(I));I++);if(L!==I&&!A(m.charCodeAt(I+1))){for(I+=1;I<k;I++)if(A(m.charCodeAt(I)))return m.slice(0,I+1).replace(/[\\/]/g,S)}}return S}else if(i(h)&&m.charCodeAt(1)===58)return A(m.charCodeAt(2))?m.slice(0,2)+S:m.slice(0,2);let w=m.indexOf("://");if(w!==-1){for(w+=3;w<k;w++)if(A(m.charCodeAt(w)))return m.slice(0,w+1)}return""}e.$Xf=f;function C(m){if(!F.$i||!m||m.length<5)return!1;let S=m.charCodeAt(0);if(S!==92||(S=m.charCodeAt(1),S!==92))return!1;let k=2;const h=k;for(;k<m.length&&(S=m.charCodeAt(k),S!==92);k++);return!(h===k||(S=m.charCodeAt(k+1),isNaN(S)||S===92))}e.$Yf=C;const D=/[\\/:\*\?"<>\|]/g,u=/[\\/]/g,b=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function p(m,S=F.$i){const k=S?D:u;return!(!m||m.length===0||/^\s+$/.test(m)||(k.lastIndex=0,k.test(m))||S&&b.test(m)||m==="."||m===".."||S&&m[m.length-1]==="."||S&&m.length!==m.trim().length||m.length>255)}e.$Zf=p;function g(m,S,k){const h=m===S;return!k||h?h:!m||!S?!1:(0,P.$6e)(m,S)}e.$1f=g;function t(m,S,k,h=y.sep){if(m===S)return!0;if(!m||!S||S.length>m.length)return!1;if(k){if(!(0,P.$7e)(m,S))return!1;if(S.length===m.length)return!0;let I=S.length;return S.charAt(S.length-1)===h&&I--,m.charAt(I)===h}return S.charAt(S.length-1)!==h&&(S+=h),m.indexOf(S)===0}e.$2f=t;function i(m){return m>=65&&m<=90||m>=97&&m<=122}e.$3f=i;function r(m,S){return F.$i&&m.endsWith(":")&&(m+=y.sep),(0,y.$hc)(m)||(m=(0,y.$ic)(S,m)),m=(0,y.$gc)(m),F.$i?(m=(0,P.$Oe)(m,y.sep),m.endsWith(":")&&(m+=y.sep)):(m=(0,P.$Oe)(m,y.sep),m||(m=y.sep)),m}e.$4f=r;function c(m){const S=(0,y.$gc)(m);return F.$i?m.length>3?!1:o(S)&&(m.length===2||S.charCodeAt(2)===92):S===y.$fc.sep}e.$5f=c;function o(m,S=F.$i){return S?i(m.charCodeAt(0))&&m.charCodeAt(1)===58:!1}e.$6f=o;function l(m,S=F.$i){return o(m,S)?m[0]:void 0}e.$7f=l;function n(m,S,k){return S.length>m.length?-1:m===S?0:(k&&(m=m.toLowerCase(),S=S.toLowerCase()),m.indexOf(S))}e.$8f=n;function s(m){const S=m.split(":");let k,h,w;for(const I of S){const L=Number(I);(0,M.$Gf)(L)?h===void 0?h=L:w===void 0&&(w=L):k=k?[k,I].join(":"):I}if(!k)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:k,line:h!==void 0?h:void 0,column:w!==void 0?w:h!==void 0?1:void 0}}e.$9f=s;const a="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789",d="BDEFGHIJKMOQRSTUVWXYZbdefghijkmoqrstuvwxyz0123456789";function v(m,S,k=8){let h="";for(let I=0;I<k;I++){let L;I===0&&F.$i&&!S&&(k===3||k===4)?L=d:L=a,h+=L.charAt(Math.floor(Math.random()*L.length))}let w;return S?w=`${S}-${h}`:w=h,m?(0,y.$ic)(m,w):w}e.$0f=v}),define(Pe[68],Re([1,0,19]),function(be,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zr=e.$Yr=e.$Xr=e.$Wr=e.$Vr=void 0,e.$Vr=Object.freeze({text:"text/plain",binary:"application/octet-stream",unknown:"application/unknown",markdown:"text/markdown",latex:"text/latex",uriList:"text/uri-list"});const F={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},P={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function M(C){const D=(0,y.$nc)(C),u=F[D.toLowerCase()];return u!==void 0?u:A(C)}e.$Wr=M;function A(C){const D=(0,y.$nc)(C);return P[D.toLowerCase()]}e.$Xr=A;function $(C){for(const D in P)if(P[D]===C)return D}e.$Yr=$;const E=/^(.+)\/(.+?)(;.+)?$/;function f(C,D){const u=E.exec(C);return u?`${u[1].toLowerCase()}/${u[2].toLowerCase()}${u[3]??""}`:D?void 0:C}e.$Zr=f}),define(Pe[51],Re([1,0,24,2]),function(be,e,y,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sh=e.$rh=e.$qh=void 0;function P(E){return JSON.stringify(E,A)}e.$qh=P;function M(E){let f=JSON.parse(E);return f=$(f),f}e.$rh=M;function A(E,f){return f instanceof RegExp?{$mid:2,source:f.source,flags:f.flags}:f}function $(E,f=0){if(!E||f>200)return E;if(typeof E=="object"){switch(E.$mid){case 1:return F.URI.revive(E);case 2:return new RegExp(E.source,E.flags);case 17:return new Date(E.source)}if(E instanceof y.$fe||E instanceof Uint8Array)return E;if(Array.isArray(E))for(let C=0;C<E.length;++C)E[C]=$(E[C],f+1);else for(const C in E)Object.hasOwnProperty.call(E,C)&&(E[C]=$(E[C],f+1))}return E}e.$sh=$}),define(Pe[13],Re([1,0,11,21,2]),function(be,e,y,F,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.$gg=e.$fg=e.$eg=e.$dg=e.$cg=e.$bg=e.$ag=e.$_f=e.$$f=e.Schemas=void 0;var M;(function(f){f.inMemory="inmemory",f.vscode="vscode",f.internal="private",f.walkThrough="walkThrough",f.walkThroughSnippet="walkThroughSnippet",f.http="http",f.https="https",f.file="file",f.mailto="mailto",f.untitled="untitled",f.data="data",f.command="command",f.vscodeRemote="vscode-remote",f.vscodeRemoteResource="vscode-remote-resource",f.vscodeManagedRemoteResource="vscode-managed-remote-resource",f.vscodeUserData="vscode-userdata",f.vscodeCustomEditor="vscode-custom-editor",f.vscodeNotebookCell="vscode-notebook-cell",f.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",f.vscodeNotebookCellOutput="vscode-notebook-cell-output",f.vscodeInteractiveInput="vscode-interactive-input",f.vscodeSettings="vscode-settings",f.vscodeWorkspaceTrust="vscode-workspace-trust",f.vscodeTerminal="vscode-terminal",f.vscodeChatSesssion="vscode-chat-editor",f.webviewPanel="webview-panel",f.vscodeWebview="vscode-webview",f.extension="extension",f.vscodeFileResource="vscode-file",f.tmp="tmp",f.vsls="vsls",f.vscodeSourceControl="vscode-scm"})(M||(e.Schemas=M={})),e.$$f="vscode-tkn",e.$_f="tkn";class A{constructor(){this.a=Object.create(null),this.b=Object.create(null),this.c=Object.create(null),this.d="http",this.e=null,this.f=`/${M.vscodeRemoteResource}`}setPreferredWebSchema(C){this.d=C}setDelegate(C){this.e=C}setServerRootPath(C){this.f=`${C}/${M.vscodeRemoteResource}`}set(C,D,u){this.a[C]=D,this.b[C]=u}setConnectionToken(C,D){this.c[C]=D}getPreferredWebSchema(){return this.d}rewrite(C){if(this.e)try{return this.e(C)}catch(t){return y.$Z(t),C}const D=C.authority;let u=this.a[D];u&&u.indexOf(":")!==-1&&u.indexOf("[")===-1&&(u=`[${u}]`);const b=this.b[D],p=this.c[D];let g=`path=${encodeURIComponent(C.path)}`;return typeof p=="string"&&(g+=`&${e.$_f}=${encodeURIComponent(p)}`),P.URI.from({scheme:F.$o?this.d:M.vscodeRemoteResource,authority:`${u}:${b}`,path:this.f,query:g})}}e.$ag=new A,e.$bg="vs/../../extensions",e.$cg="vs/../../node_modules",e.$dg="vs/../../node_modules.asar",e.$eg="vs/../../node_modules.asar.unpacked",e.$fg="vscode-app";class ${static{this.a=e.$fg}asBrowserUri(C){const D=this.b(C,be);return this.uriToBrowserUri(D)}uriToBrowserUri(C){return C.scheme===M.vscodeRemote?e.$ag.rewrite(C):C.scheme===M.file&&(F.$m||F.$q===`${M.vscodeFileResource}://${$.a}`)?C.with({scheme:M.vscodeFileResource,authority:C.authority||$.a,query:null,fragment:null}):C}asFileUri(C){const D=this.b(C,be);return this.uriToFileUri(D)}uriToFileUri(C){return C.scheme===M.vscodeFileResource?C.with({scheme:M.file,authority:C.authority!==$.a?C.authority:null,query:null,fragment:null}):C}b(C,D){return P.URI.isUri(C)?C:P.URI.parse(D.toUrl(C))}}e.$gg=new $;var E;(function(f){const C=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);f.CoopAndCoep=Object.freeze(C.get("3"));const D="vscode-coi";function u(p){let g;typeof p=="string"?g=new URL(p).searchParams:p instanceof URL?g=p.searchParams:P.URI.isUri(p)&&(g=new URL(p.toString(!0)).searchParams);const t=g?.get(D);if(t)return C.get(t)}f.getHeadersFromQuery=u;function b(p,g,t){if(!globalThis.crossOriginIsolated)return;const i=g&&t?"3":t?"2":"1";p instanceof URLSearchParams?p.set(D,i):p[D]=i}f.addSearchParam=b})(E||(e.COI=E={}))}),define(Pe[25],Re([1,0,46,13,19,21,12,2]),function(be,e,y,F,P,M,A,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jg=e.DataUri=e.$Ig=e.$Hg=e.$Gg=e.$Fg=e.$Eg=e.$Dg=e.$Cg=e.$Bg=e.$Ag=e.$zg=e.$yg=e.$xg=e.$wg=e.$vg=e.$ug=e.$tg=e.$sg=e.$rg=e.$qg=e.$pg=e.$og=e.$ng=void 0;function E(b){return(0,$.$vc)(b,!0)}e.$ng=E;class f{constructor(p){this.a=p}compare(p,g,t=!1){return p===g?0:(0,A.$Ye)(this.getComparisonKey(p,t),this.getComparisonKey(g,t))}isEqual(p,g,t=!1){return p===g?!0:!p||!g?!1:this.getComparisonKey(p,t)===this.getComparisonKey(g,t)}getComparisonKey(p,g=!1){return p.with({path:this.a(p)?p.path.toLowerCase():void 0,fragment:g?null:void 0}).toString()}ignorePathCasing(p){return this.a(p)}isEqualOrParent(p,g,t=!1){if(p.scheme===g.scheme){if(p.scheme===F.Schemas.file)return y.$2f(E(p),E(g),this.a(p))&&p.query===g.query&&(t||p.fragment===g.fragment);if((0,e.$Eg)(p.authority,g.authority))return y.$2f(p.path,g.path,this.a(p),"/")&&p.query===g.query&&(t||p.fragment===g.fragment)}return!1}joinPath(p,...g){return $.URI.joinPath(p,...g)}basenameOrAuthority(p){return(0,e.$wg)(p)||p.authority}basename(p){return P.$fc.basename(p.path)}extname(p){return P.$fc.extname(p.path)}dirname(p){if(p.path.length===0)return p;let g;return p.scheme===F.Schemas.file?g=$.URI.file(P.$lc(E(p))).path:(g=P.$fc.dirname(p.path),p.authority&&g.length&&g.charCodeAt(0)!==47&&(console.error(`dirname("${p.toString})) resulted in a relative path`),g="/")),p.with({path:g})}normalizePath(p){if(!p.path.length)return p;let g;return p.scheme===F.Schemas.file?g=$.URI.file(P.$gc(E(p))).path:g=P.$fc.normalize(p.path),p.with({path:g})}relativePath(p,g){if(p.scheme!==g.scheme||!(0,e.$Eg)(p.authority,g.authority))return;if(p.scheme===F.Schemas.file){const r=P.$kc(E(p),E(g));return M.$i?y.$Vf(r):r}let t=p.path||"/";const i=g.path||"/";if(this.a(p)){let r=0;for(const c=Math.min(t.length,i.length);r<c&&!(t.charCodeAt(r)!==i.charCodeAt(r)&&t.charAt(r).toLowerCase()!==i.charAt(r).toLowerCase());r++);t=i.substr(0,r)+t.substr(r)}return P.$fc.relative(t,i)}resolvePath(p,g){if(p.scheme===F.Schemas.file){const t=$.URI.file(P.$jc(E(p),g));return p.with({authority:t.authority,path:t.path})}return g=y.$Wf(g),p.with({path:P.$fc.resolve(p.path,g)})}isAbsolutePath(p){return!!p.path&&p.path[0]==="/"}isEqualAuthority(p,g){return p===g||p!==void 0&&g!==void 0&&(0,A.$6e)(p,g)}hasTrailingPathSeparator(p,g=P.sep){if(p.scheme===F.Schemas.file){const t=E(p);return t.length>y.$Xf(t).length&&t[t.length-1]===g}else{const t=p.path;return t.length>1&&t.charCodeAt(t.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(p.fsPath)}}removeTrailingPathSeparator(p,g=P.sep){return(0,e.$Fg)(p,g)?p.with({path:p.path.substr(0,p.path.length-1)}):p}addTrailingPathSeparator(p,g=P.sep){let t=!1;if(p.scheme===F.Schemas.file){const i=E(p);t=i!==void 0&&i.length===y.$Xf(i).length&&i[i.length-1]===g}else{g="/";const i=p.path;t=i.length===1&&i.charCodeAt(i.length-1)===47}return!t&&!(0,e.$Fg)(p,g)?p.with({path:p.path+"/"}):p}}e.$og=f,e.$pg=new f(()=>!1),e.$qg=new f(b=>b.scheme===F.Schemas.file?!M.$k:!0),e.$rg=new f(b=>!0),e.$sg=e.$pg.isEqual.bind(e.$pg),e.$tg=e.$pg.isEqualOrParent.bind(e.$pg),e.$ug=e.$pg.getComparisonKey.bind(e.$pg),e.$vg=e.$pg.basenameOrAuthority.bind(e.$pg),e.$wg=e.$pg.basename.bind(e.$pg),e.$xg=e.$pg.extname.bind(e.$pg),e.$yg=e.$pg.dirname.bind(e.$pg),e.$zg=e.$pg.joinPath.bind(e.$pg),e.$Ag=e.$pg.normalizePath.bind(e.$pg),e.$Bg=e.$pg.relativePath.bind(e.$pg),e.$Cg=e.$pg.resolvePath.bind(e.$pg),e.$Dg=e.$pg.isAbsolutePath.bind(e.$pg),e.$Eg=e.$pg.isEqualAuthority.bind(e.$pg),e.$Fg=e.$pg.hasTrailingPathSeparator.bind(e.$pg),e.$Gg=e.$pg.removeTrailingPathSeparator.bind(e.$pg),e.$Hg=e.$pg.addTrailingPathSeparator.bind(e.$pg);function C(b,p){const g=[];for(let t=0;t<b.length;t++){const i=p(b[t]);b.some((r,c)=>c===t?!1:(0,e.$tg)(i,p(r)))||g.push(b[t])}return g}e.$Ig=C;var D;(function(b){b.META_DATA_LABEL="label",b.META_DATA_DESCRIPTION="description",b.META_DATA_SIZE="size",b.META_DATA_MIME="mime";function p(g){const t=new Map;g.path.substring(g.path.indexOf(";")+1,g.path.lastIndexOf(";")).split(";").forEach(c=>{const[o,l]=c.split(":");o&&l&&t.set(o,l)});const r=g.path.substring(0,g.path.indexOf(";"));return r&&t.set(b.META_DATA_MIME,r),t}b.parseMetaData=p})(D||(e.DataUri=D={}));function u(b,p,g){if(p){let t=b.path;return t&&t[0]!==P.$fc.sep&&(t=P.$fc.sep+t),b.with({scheme:g,authority:p,path:t})}return b.with({scheme:g})}e.$Jg=u}),define(Pe[14],Re([1,0,20,11,5,6,25,21,124]),function(be,e,y,F,P,M,A,$,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mh=e.$lh=e.$kh=e.$jh=e.Promises=e.$ih=e.$hh=e.$gh=e.$fh=e.$eh=e.$dh=e.$ch=e.$bh=e.$ah=e.$_g=e.$$g=e.$0g=e.$9g=e.$8g=e.$7g=e.$6g=e.$5g=e.$4g=e.$3g=e.$2g=e.$1g=e.$Zg=e.$Yg=e.$Xg=e.$Wg=e.$Vg=e.$Ug=e.$Tg=e.$Sg=e.$Rg=e.$Qg=e.$Pg=e.$Og=e.$Ng=e.$Mg=e.$Lg=e.$Kg=void 0;function f(pe){return!!pe&&typeof pe.then=="function"}e.$Kg=f;function C(pe){const ne=new y.$2d,le=pe(ne.token),ce=new Promise((we,_)=>{const de=ne.token.onCancellationRequested(()=>{de.dispose(),ne.dispose(),_(new F.$4)});Promise.resolve(le).then(te=>{de.dispose(),ne.dispose(),we(te)},te=>{de.dispose(),ne.dispose(),_(te)})});return new class{cancel(){ne.cancel()}then(we,_){return ce.then(we,_)}catch(we){return this.then(void 0,we)}finally(we){return ce.finally(we)}}}e.$Lg=C;function D(pe,ne,le){return new Promise((ce,we)=>{const _=ne.onCancellationRequested(()=>{_.dispose(),ce(le)});pe.then(ce,we).finally(()=>_.dispose())})}e.$Mg=D;function u(pe,ne){return new Promise((le,ce)=>{const we=ne.onCancellationRequested(()=>{we.dispose(),ce(new F.$4)});pe.then(le,ce).finally(()=>we.dispose())})}e.$Ng=u;async function b(pe){let ne=-1;const le=pe.map((ce,we)=>ce.then(_=>(ne=we,_)));try{return await Promise.race(le)}finally{pe.forEach((ce,we)=>{we!==ne&&ce.cancel()})}}e.$Og=b;function p(pe,ne,le){let ce;const we=setTimeout(()=>{ce?.(void 0),le?.()},ne);return Promise.race([pe.finally(()=>clearTimeout(we)),new Promise(_=>ce=_)])}e.$Pg=p;function g(pe){return new Promise((ne,le)=>{const ce=pe();f(ce)?ce.then(ne,le):ne(ce)})}e.$Qg=g;class t{constructor(){this.f=!1,this.a=null,this.b=null,this.d=null}queue(ne){if(this.f)return Promise.reject(new Error("Throttler is disposed"));if(this.a){if(this.d=ne,!this.b){const le=()=>{if(this.b=null,this.f)return;const ce=this.queue(this.d);return this.d=null,ce};this.b=new Promise(ce=>{this.a.then(le,le).then(ce)})}return new Promise((le,ce)=>{this.b.then(le,ce)})}return this.a=ne(),new Promise((le,ce)=>{this.a.then(we=>{this.a=null,le(we)},we=>{this.a=null,ce(we)})})}dispose(){this.f=!0}}e.$Rg=t;class i{constructor(){this.a=Promise.resolve(null)}queue(ne){return this.a=this.a.then(()=>ne(),()=>ne())}}e.$Sg=i;class r{constructor(){this.a=new Map}queue(ne,le){const we=(this.a.get(ne)??Promise.resolve()).catch(()=>{}).then(le).finally(()=>{this.a.get(ne)===we&&this.a.delete(ne)});return this.a.set(ne,we),we}}e.$Tg=r;const c=(pe,ne)=>{let le=!0;const ce=setTimeout(()=>{le=!1,ne()},pe);return{isTriggered:()=>le,dispose:()=>{clearTimeout(ce),le=!1}}},o=pe=>{let ne=!0;return queueMicrotask(()=>{ne&&(ne=!1,pe())}),{isTriggered:()=>ne,dispose:()=>{ne=!1}}};class l{constructor(ne){this.defaultDelay=ne,this.a=null,this.b=null,this.d=null,this.f=null,this.g=null}trigger(ne,le=this.defaultDelay){this.g=ne,this.h(),this.b||(this.b=new Promise((we,_)=>{this.d=we,this.f=_}).then(()=>{if(this.b=null,this.d=null,this.g){const we=this.g;return this.g=null,we()}}));const ce=()=>{this.a=null,this.d?.(null)};return this.a=le===E.$Od?o(ce):c(le,ce),this.b}isTriggered(){return!!this.a?.isTriggered()}cancel(){this.h(),this.b&&(this.f?.(new F.$4),this.b=null)}h(){this.a?.dispose(),this.a=null}dispose(){this.cancel()}}e.$Ug=l;class n{constructor(ne){this.a=new l(ne),this.b=new t}trigger(ne,le){return this.a.trigger(()=>this.b.queue(ne),le)}isTriggered(){return this.a.isTriggered()}cancel(){this.a.cancel()}dispose(){this.a.dispose(),this.b.dispose()}}e.$Vg=n;class s{constructor(){this.a=!1,this.b=new Promise((ne,le)=>{this.d=ne})}isOpen(){return this.a}open(){this.a=!0,this.d(!0)}wait(){return this.b}}e.$Wg=s;class a extends s{constructor(ne){super(),this.f=setTimeout(()=>this.open(),ne)}open(){clearTimeout(this.f),super.open()}}e.$Xg=a;function d(pe,ne){return ne?new Promise((le,ce)=>{const we=setTimeout(()=>{_.dispose(),le()},pe),_=ne.onCancellationRequested(()=>{clearTimeout(we),_.dispose(),ce(new F.$4)})}):C(le=>d(pe,le))}e.$Yg=d;function v(pe,ne=0,le){const ce=setTimeout(()=>{pe(),le&&we.dispose()},ne),we=(0,M.$Pc)(()=>{clearTimeout(ce),le?.deleteAndLeak(we)});return le?.add(we),we}e.$Zg=v;function m(pe){const ne=[];let le=0;const ce=pe.length;function we(){return le<ce?pe[le++]():null}function _(de){de!=null&&ne.push(de);const te=we();return te?te.then(_):Promise.resolve(ne)}return Promise.resolve(null).then(_)}e.$1g=m;function S(pe,ne=ce=>!!ce,le=null){let ce=0;const we=pe.length,_=()=>{if(ce>=we)return Promise.resolve(le);const de=pe[ce++];return Promise.resolve(de()).then(ae=>ne(ae)?Promise.resolve(ae):_())};return _()}e.$2g=S;function k(pe,ne=ce=>!!ce,le=null){if(pe.length===0)return Promise.resolve(le);let ce=pe.length;const we=()=>{ce=-1;for(const _ of pe)_.cancel?.()};return new Promise((_,de)=>{for(const te of pe)te.then(ae=>{--ce>=0&&ne(ae)?(we(),_(ae)):ce===0&&_(le)}).catch(ae=>{--ce>=0&&(we(),de(ae))})})}e.$3g=k;class h{constructor(ne){this.a=0,this.d=ne,this.f=[],this.b=0,this.g=new P.$Rd}get onDrained(){return this.g.event}get size(){return this.a}queue(ne){return this.a++,new Promise((le,ce)=>{this.f.push({factory:ne,c:le,e:ce}),this.h()})}h(){for(;this.f.length&&this.b<this.d;){const ne=this.f.shift();this.b++;const le=ne.factory();le.then(ne.c,ne.e),le.then(()=>this.j(),()=>this.j())}}j(){this.a--,this.b--,this.f.length>0?this.h():this.g.fire()}dispose(){this.g.dispose()}}e.$4g=h;class w extends h{constructor(){super(1)}}e.$5g=w;class I{constructor(){this.a=new De,this.b=0}queue(ne){return this.a.isRunning()?this.a.queue(()=>this.a.run(this.b++,ne())):this.a.run(this.b++,ne())}}e.$6g=I;class L{constructor(){this.a=new Map,this.b=new Set,this.d=void 0,this.f=0}async whenDrained(){if(this.g())return;const ne=new $e;return this.b.add(ne),ne.p}g(){for(const[,ne]of this.a)if(ne.size>0)return!1;return!0}queueFor(ne,le=A.$pg){const ce=le.getComparisonKey(ne);let we=this.a.get(ce);if(!we){we=new w;const _=this.f++,de=P.Event.once(we.onDrained)(()=>{we?.dispose(),this.a.delete(ce),this.h(),this.d?.deleteAndDispose(_),this.d?.size===0&&(this.d.dispose(),this.d=void 0)});this.d||(this.d=new M.$1c),this.d.set(_,de),this.a.set(ce,we)}return we}h(){this.g()&&this.j()}j(){for(const ne of this.b)ne.complete();this.b.clear()}dispose(){for(const[,ne]of this.a)ne.dispose();this.a.clear(),this.j(),this.d?.dispose()}}e.$7g=L;class V{constructor(ne,le){this.a=-1,typeof ne=="function"&&typeof le=="number"&&this.setIfNotSet(ne,le)}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearTimeout(this.a),this.a=-1)}cancelAndSet(ne,le){this.cancel(),this.a=setTimeout(()=>{this.a=-1,ne()},le)}setIfNotSet(ne,le){this.a===-1&&(this.a=setTimeout(()=>{this.a=-1,ne()},le))}}e.$8g=V;class K{constructor(){this.d=void 0}cancel(){this.d?.dispose(),this.d=void 0}cancelAndSet(ne,le,ce=globalThis){this.cancel();const we=ce.setInterval(()=>{ne()},le);this.d=(0,M.$Pc)(()=>{ce.clearInterval(we),this.d=void 0})}dispose(){this.cancel()}}e.$9g=K;class R{constructor(ne,le){this.b=-1,this.a=ne,this.d=le,this.f=this.g.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearTimeout(this.b),this.b=-1)}schedule(ne=this.d){this.cancel(),this.b=setTimeout(this.f,ne)}get delay(){return this.d}set delay(ne){this.d=ne}isScheduled(){return this.b!==-1}flush(){this.isScheduled()&&(this.cancel(),this.h())}g(){this.b=-1,this.a&&this.h()}h(){this.a?.()}}e.$0g=R;class N{constructor(ne,le){le%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${le}ms is not a multiple of 1000ms.`),this.a=ne,this.b=le,this.d=0,this.f=-1,this.g=this.h.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearInterval(this.f),this.f=-1)}schedule(ne=this.b){ne%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${ne}ms is not a multiple of 1000ms.`),this.cancel(),this.d=Math.ceil(ne/1e3),this.f=setInterval(this.g,1e3)}isScheduled(){return this.f!==-1}h(){this.d--,!(this.d>0)&&(clearInterval(this.f),this.f=-1,this.a?.())}}e.$$g=N;class T extends R{constructor(ne,le){super(ne,le),this.j=[]}work(ne){this.j.push(ne),this.isScheduled()||this.schedule()}h(){const ne=this.j;this.j=[],this.a?.(ne)}dispose(){this.j=[],super.dispose()}}e.$_g=T;class z extends M.$Rc{constructor(ne,le){super(),this.g=ne,this.h=le,this.a=[],this.b=this.B(new M.$Sc),this.f=!1}get pending(){return this.a.length}work(ne){if(this.f)return!1;if(typeof this.g.maxBufferedWork=="number"){if(this.b.value){if(this.pending+ne.length>this.g.maxBufferedWork)return!1}else if(this.pending+ne.length-this.g.maxWorkChunkSize>this.g.maxBufferedWork)return!1}for(const le of ne)this.a.push(le);return this.b.value||this.j(),!0}j(){this.h(this.a.splice(0,this.g.maxWorkChunkSize)),this.a.length>0&&(this.b.value=new R(()=>{this.b.clear(),this.j()},this.g.throttleDelay),this.b.value.schedule())}dispose(){super.dispose(),this.f=!0}}e.$ah=z,function(){typeof globalThis.requestIdleCallback!="function"||typeof globalThis.cancelIdleCallback!="function"?e.$ch=(pe,ne)=>{(0,$.$B)(()=>{if(le)return;const ce=Date.now()+15;ne(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,ce-Date.now())}}))});let le=!1;return{dispose(){le||(le=!0)}}}:e.$ch=(pe,ne,le)=>{const ce=pe.requestIdleCallback(ne,typeof le=="number"?{timeout:le}:void 0);let we=!1;return{dispose(){we||(we=!0,pe.cancelIdleCallback(ce))}}},e.$bh=pe=>(0,e.$ch)(globalThis,pe)}();class Z{constructor(ne,le){this.g=!1,this.d=()=>{try{this.j=le()}catch(ce){this.l=ce}finally{this.g=!0}},this.f=(0,e.$ch)(ne,()=>this.d())}dispose(){this.f.dispose()}get value(){if(this.g||(this.f.dispose(),this.d()),this.l)throw this.l;return this.j}get isInitialized(){return this.g}}e.$dh=Z;class he extends Z{constructor(ne){super(globalThis,ne)}}e.$eh=he;async function ye(pe,ne,le){let ce;for(let we=0;we<le;we++)try{return await pe()}catch(_){ce=_,await d(ne)}throw ce}e.$fh=ye;class De{isRunning(ne){return typeof ne=="number"?this.a?.taskId===ne:!!this.a}get running(){return this.a?.promise}cancelRunning(){this.a?.cancel()}run(ne,le,ce){return this.a={taskId:ne,cancel:()=>ce?.(),promise:le},le.then(()=>this.d(ne),()=>this.d(ne)),le}d(ne){this.a&&ne===this.a.taskId&&(this.a=void 0,this.f())}f(){if(this.b){const ne=this.b;this.b=void 0,ne.run().then(ne.promiseResolve,ne.promiseReject)}}queue(ne){if(this.b)this.b.run=ne;else{let le,ce;const we=new Promise((_,de)=>{le=_,ce=de});this.b={run:ne,promise:we,promiseResolve:le,promiseReject:ce}}return this.b.promise}hasQueued(){return!!this.b}async join(){return this.b?.promise??this.a?.promise}}e.$gh=De;class Se{constructor(ne,le=()=>Date.now()){this.d=ne,this.f=le,this.a=0,this.b=0}increment(){const ne=this.f();return ne-this.a>this.d&&(this.a=ne,this.b=0),this.b++,this.b}}e.$hh=Se;var fe;(function(pe){pe[pe.Resolved=0]="Resolved",pe[pe.Rejected=1]="Rejected"})(fe||(fe={}));class $e{get isRejected(){return this.d?.outcome===1}get isResolved(){return this.d?.outcome===0}get isSettled(){return!!this.d}get value(){return this.d?.outcome===0?this.d?.value:void 0}constructor(){this.p=new Promise((ne,le)=>{this.a=ne,this.b=le})}complete(ne){return new Promise(le=>{this.a(ne),this.d={outcome:0,value:ne},le()})}error(ne){return new Promise(le=>{this.b(ne),this.d={outcome:1,value:ne},le()})}cancel(){return this.error(new F.$4)}}e.$ih=$e;var re;(function(pe){async function ne(ce){let we;const _=await Promise.all(ce.map(de=>de.then(te=>te,te=>{we||(we=te)})));if(typeof we<"u")throw we;return _}pe.settled=ne;function le(ce){return new Promise(async(we,_)=>{try{await ce(we,_)}catch(de){_(de)}})}pe.withAsyncBody=le})(re||(e.Promises=re={}));var Ae;(function(pe){pe[pe.Initial=0]="Initial",pe[pe.DoneOK=1]="DoneOK",pe[pe.DoneError=2]="DoneError"})(Ae||(Ae={}));class se{static fromArray(ne){return new se(le=>{le.emitMany(ne)})}static fromPromise(ne){return new se(async le=>{le.emitMany(await ne)})}static fromPromises(ne){return new se(async le=>{await Promise.all(ne.map(async ce=>le.emitOne(await ce)))})}static merge(ne){return new se(async le=>{await Promise.all(ne.map(async ce=>{for await(const we of ce)le.emitOne(we)}))})}static{this.EMPTY=se.fromArray([])}constructor(ne){this.a=0,this.b=[],this.d=null,this.f=new P.$Rd,queueMicrotask(async()=>{const le={emitOne:ce=>this.g(ce),emitMany:ce=>this.h(ce),reject:ce=>this.k(ce)};try{await Promise.resolve(ne(le)),this.j()}catch(ce){this.k(ce)}finally{le.emitOne=void 0,le.emitMany=void 0,le.reject=void 0}})}[Symbol.asyncIterator](){let ne=0;return{next:async()=>{do{if(this.a===2)throw this.d;if(ne<this.b.length)return{done:!1,value:this.b[ne++]};if(this.a===1)return{done:!0,value:void 0};await P.Event.toPromise(this.f.event)}while(!0)}}}static map(ne,le){return new se(async ce=>{for await(const we of ne)ce.emitOne(le(we))})}map(ne){return se.map(this,ne)}static filter(ne,le){return new se(async ce=>{for await(const we of ne)le(we)&&ce.emitOne(we)})}filter(ne){return se.filter(this,ne)}static coalesce(ne){return se.filter(ne,le=>!!le)}coalesce(){return se.coalesce(this)}static async toPromise(ne){const le=[];for await(const ce of ne)le.push(ce);return le}toPromise(){return se.toPromise(this)}g(ne){this.a===0&&(this.b.push(ne),this.f.fire())}h(ne){this.a===0&&(this.b=this.b.concat(ne),this.f.fire())}j(){this.a===0&&(this.a=1,this.f.fire())}k(ne){this.a===0&&(this.a=2,this.d=ne,this.f.fire())}}e.$jh=se;class X extends se{constructor(ne,le){super(le),this.l=ne}cancel(){this.l.cancel()}}e.$kh=X;function B(pe){const ne=new y.$2d,le=pe(ne.token);return new X(ne,async ce=>{const we=ne.token.onCancellationRequested(()=>{we.dispose(),ne.dispose(),ce.reject(new F.$4)});try{for await(const _ of le){if(ne.token.isCancellationRequested)return;ce.emitOne(_)}we.dispose(),ne.dispose()}catch(_){we.dispose(),ne.dispose(),ce.reject(_)}})}e.$lh=B;class ie{constructor(){this.a=new $e,this.b=new se(ce=>{if(ne){ce.reject(ne);return}return le&&ce.emitMany(le),this.d=we=>ce.reject(we),this.f=we=>ce.emitOne(we),this.a.p});let ne,le;this.f=ce=>{le||(le=[]),le.push(ce)},this.d=ce=>{ne||(ne=ce)}}get asyncIterable(){return this.b}resolve(){this.a.complete()}reject(ne){this.d(ne),this.a.complete()}emitOne(ne){this.f(ne)}}e.$mh=ie}),define(Pe[33],Re([1,0,18,14,46,28,19,21,12]),function(be,e,y,F,P,M,A,$,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gj=e.$Fj=e.$Ej=e.$Dj=e.$Cj=e.$Bj=e.$Aj=e.$zj=e.$yj=e.$xj=void 0;function f(){return Object.create(null)}e.$xj=f,e.$yj="**",e.$zj="/";const C="[/\\\\]",D="[^/\\\\]",u=/\//g;function b(ye,De){switch(ye){case 0:return"";case 1:return`${D}*?`;default:return`(?:${C}|${D}+${C}${De?`|${C}${D}+`:""})*?`}}function p(ye,De){if(!ye)return[];const Se=[];let fe=!1,$e=!1,re="";for(const Ae of ye){switch(Ae){case De:if(!fe&&!$e){Se.push(re),re="";continue}break;case"{":fe=!0;break;case"}":fe=!1;break;case"[":$e=!0;break;case"]":$e=!1;break}re+=Ae}return re&&Se.push(re),Se}e.$Aj=p;function g(ye){if(!ye)return"";let De="";const Se=p(ye,e.$zj);if(Se.every(fe=>fe===e.$yj))De=".*";else{let fe=!1;Se.forEach(($e,re)=>{if($e===e.$yj){if(fe)return;De+=b(2,re===Se.length-1)}else{let Ae=!1,se="",X=!1,B="";for(const ie of $e){if(ie!=="}"&&Ae){se+=ie;continue}if(X&&(ie!=="]"||!B)){let pe;ie==="-"?pe=ie:(ie==="^"||ie==="!")&&!B?pe="^":ie===e.$zj?pe="":pe=(0,E.$Je)(ie),B+=pe;continue}switch(ie){case"{":Ae=!0;continue;case"[":X=!0;continue;case"}":{const ne=`(?:${p(se,",").map(le=>g(le)).join("|")})`;De+=ne,Ae=!1,se="";break}case"]":{De+="["+B+"]",X=!1,B="";break}case"?":De+=D;continue;case"*":De+=b(1);continue;default:De+=(0,E.$Je)(ie)}}re<Se.length-1&&(Se[re+1]!==e.$yj||re+2<Se.length)&&(De+=C)}fe=$e===e.$yj})}return De}const t=/^\*\*\/\*\.[\w\.-]+$/,i=/^\*\*\/([\w\.-]+)\/?$/,r=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,c=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,o=/^\*\*((\/[\w\.-]+)+)\/?$/,l=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,n=new M.$Cc(1e4),s=function(){return!1},a=function(){return null};function d(ye,De){if(!ye)return a;let Se;typeof ye!="string"?Se=ye.pattern:Se=ye,Se=Se.trim();const fe=`${Se}_${!!De.trimForExclusions}`;let $e=n.get(fe);if($e)return v($e,ye);let re;return t.test(Se)?$e=S(Se.substr(4),Se):(re=i.exec(m(Se,De)))?$e=k(re[1],Se):(De.trimForExclusions?c:r).test(Se)?$e=h(Se,De):(re=o.exec(m(Se,De)))?$e=w(re[1].substr(1),Se,!0):(re=l.exec(m(Se,De)))?$e=w(re[1],Se,!1):$e=I(Se),n.set(fe,$e),v($e,ye)}function v(ye,De){if(typeof De=="string")return ye;const Se=function(fe,$e){return(0,P.$2f)(fe,De.base,!$.$k)?ye((0,E.$Ne)(fe.substr(De.base.length),A.sep),$e):null};return Se.allBasenames=ye.allBasenames,Se.allPaths=ye.allPaths,Se.basenames=ye.basenames,Se.patterns=ye.patterns,Se}function m(ye,De){return De.trimForExclusions&&ye.endsWith("/**")?ye.substr(0,ye.length-2):ye}function S(ye,De){return function(Se,fe){return typeof Se=="string"&&Se.endsWith(ye)?De:null}}function k(ye,De){const Se=`/${ye}`,fe=`\\${ye}`,$e=function(Ae,se){return typeof Ae!="string"?null:se?se===ye?De:null:Ae===ye||Ae.endsWith(Se)||Ae.endsWith(fe)?De:null},re=[ye];return $e.basenames=re,$e.patterns=[De],$e.allBasenames=re,$e}function h(ye,De){const Se=Z(ye.slice(1,-1).split(",").map(se=>d(se,De)).filter(se=>se!==a),ye),fe=Se.length;if(!fe)return a;if(fe===1)return Se[0];const $e=function(se,X){for(let B=0,ie=Se.length;B<ie;B++)if(Se[B](se,X))return ye;return null},re=Se.find(se=>!!se.allBasenames);re&&($e.allBasenames=re.allBasenames);const Ae=Se.reduce((se,X)=>X.allPaths?se.concat(X.allPaths):se,[]);return Ae.length&&($e.allPaths=Ae),$e}function w(ye,De,Se){const fe=A.sep===A.$fc.sep,$e=fe?ye:ye.replace(u,A.sep),re=A.sep+$e,Ae=A.$fc.sep+ye;let se;return Se?se=function(X,B){return typeof X=="string"&&(X===$e||X.endsWith(re)||!fe&&(X===ye||X.endsWith(Ae)))?De:null}:se=function(X,B){return typeof X=="string"&&(X===$e||!fe&&X===ye)?De:null},se.allPaths=[(Se?"*/":"./")+ye],se}function I(ye){try{const De=new RegExp(`^${g(ye)}$`);return function(Se){return De.lastIndex=0,typeof Se=="string"&&De.test(Se)?ye:null}}catch{return a}}function L(ye,De,Se){return!ye||typeof De!="string"?!1:V(ye)(De,void 0,Se)}e.$Bj=L;function V(ye,De={}){if(!ye)return s;if(typeof ye=="string"||K(ye)){const Se=d(ye,De);if(Se===a)return s;const fe=function($e,re){return!!Se($e,re)};return Se.allBasenames&&(fe.allBasenames=Se.allBasenames),Se.allPaths&&(fe.allPaths=Se.allPaths),fe}return T(ye,De)}e.$Cj=V;function K(ye){const De=ye;return De?typeof De.base=="string"&&typeof De.pattern=="string":!1}e.$Dj=K;function R(ye){return ye.allBasenames||[]}e.$Ej=R;function N(ye){return ye.allPaths||[]}e.$Fj=N;function T(ye,De){const Se=Z(Object.getOwnPropertyNames(ye).map(se=>z(se,ye[se],De)).filter(se=>se!==a)),fe=Se.length;if(!fe)return a;if(!Se.some(se=>!!se.requiresSiblings)){if(fe===1)return Se[0];const se=function(ie,pe){let ne;for(let le=0,ce=Se.length;le<ce;le++){const we=Se[le](ie,pe);if(typeof we=="string")return we;(0,F.$Kg)(we)&&(ne||(ne=[]),ne.push(we))}return ne?(async()=>{for(const le of ne){const ce=await le;if(typeof ce=="string")return ce}return null})():null},X=Se.find(ie=>!!ie.allBasenames);X&&(se.allBasenames=X.allBasenames);const B=Se.reduce((ie,pe)=>pe.allPaths?ie.concat(pe.allPaths):ie,[]);return B.length&&(se.allPaths=B),se}const $e=function(se,X,B){let ie,pe;for(let ne=0,le=Se.length;ne<le;ne++){const ce=Se[ne];ce.requiresSiblings&&B&&(X||(X=(0,A.$mc)(se)),ie||(ie=X.substr(0,X.length-(0,A.$nc)(se).length)));const we=ce(se,X,ie,B);if(typeof we=="string")return we;(0,F.$Kg)(we)&&(pe||(pe=[]),pe.push(we))}return pe?(async()=>{for(const ne of pe){const le=await ne;if(typeof le=="string")return le}return null})():null},re=Se.find(se=>!!se.allBasenames);re&&($e.allBasenames=re.allBasenames);const Ae=Se.reduce((se,X)=>X.allPaths?se.concat(X.allPaths):se,[]);return Ae.length&&($e.allPaths=Ae),$e}function z(ye,De,Se){if(De===!1)return a;const fe=d(ye,Se);if(fe===a)return a;if(typeof De=="boolean")return fe;if(De){const $e=De.when;if(typeof $e=="string"){const re=(Ae,se,X,B)=>{if(!B||!fe(Ae,se))return null;const ie=$e.replace("$(basename)",()=>X),pe=B(ie);return(0,F.$Kg)(pe)?pe.then(ne=>ne?ye:null):pe?ye:null};return re.requiresSiblings=!0,re}}return fe}function Z(ye,De){const Se=ye.filter(se=>!!se.basenames);if(Se.length<2)return ye;const fe=Se.reduce((se,X)=>{const B=X.basenames;return B?se.concat(B):se},[]);let $e;if(De){$e=[];for(let se=0,X=fe.length;se<X;se++)$e.push(De)}else $e=Se.reduce((se,X)=>{const B=X.patterns;return B?se.concat(B):se},[]);const re=function(se,X){if(typeof se!="string")return null;if(!X){let ie;for(ie=se.length;ie>0;ie--){const pe=se.charCodeAt(ie-1);if(pe===47||pe===92)break}X=se.substr(ie)}const B=fe.indexOf(X);return B!==-1?$e[B]:null};re.basenames=fe,re.patterns=$e,re.allBasenames=fe;const Ae=ye.filter(se=>!se.basenames);return Ae.push(re),Ae}function he(ye,De){return(0,y.$tb)(ye,De,(Se,fe)=>typeof Se=="string"&&typeof fe=="string"?Se===fe:typeof Se!="string"&&typeof fe!="string"?Se.base===fe.base&&Se.pattern===fe.pattern:!1)}e.$Gj=he}),define(Pe[52],Re([1,0,11,125,25,12,2]),function(be,e,y,F,P,M,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dk=e.$ck=e.$bk=e.$ak=e.$_j=e.$$j=e.$0j=e.$9j=e.MarkdownStringTextNewlineStyle=void 0;var $;(function(t){t[t.Paragraph=0]="Paragraph",t[t.Break=1]="Break"})($||(e.MarkdownStringTextNewlineStyle=$={}));class E{constructor(i="",r=!1){if(this.value=i,typeof this.value!="string")throw(0,y.$6)("value");typeof r=="boolean"?(this.isTrusted=r,this.supportThemeIcons=!1,this.supportHtml=!1):(this.isTrusted=r.isTrusted??void 0,this.supportThemeIcons=r.supportThemeIcons??!1,this.supportHtml=r.supportHtml??!1)}appendText(i,r=0){return this.value+=u(this.supportThemeIcons?(0,F.$3j)(i):i).replace(/([ \t]+)/g,(c,o)=>"&nbsp;".repeat(o.length)).replace(/\>/gm,"\\>").replace(/\n/g,r===1?`\\
`:`

`),this}appendMarkdown(i){return this.value+=i,this}appendCodeblock(i,r){return this.value+="\n```",this.value+=i,this.value+=`
`,this.value+=r,this.value+="\n```\n",this}appendLink(i,r,c){return this.value+="[",this.value+=this.c(r,"]"),this.value+="](",this.value+=this.c(String(i),")"),c&&(this.value+=` "${this.c(this.c(c,'"'),")")}"`),this.value+=")",this}c(i,r){const c=new RegExp((0,M.$Je)(r),"g");return i.replace(c,(o,l)=>i.charAt(l-1)!=="\\"?`\\${o}`:o)}}e.$9j=E;function f(t){return C(t)?!t.value:Array.isArray(t)?t.every(f):!0}e.$0j=f;function C(t){return t instanceof E?!0:t&&typeof t=="object"?typeof t.value=="string"&&(typeof t.isTrusted=="boolean"||typeof t.isTrusted=="object"||t.isTrusted===void 0)&&(typeof t.supportThemeIcons=="boolean"||t.supportThemeIcons===void 0):!1}e.$$j=C;function D(t,i){return t===i?!0:!t||!i?!1:t.value===i.value&&t.isTrusted===i.isTrusted&&t.supportThemeIcons===i.supportThemeIcons&&t.supportHtml===i.supportHtml&&(t.baseUri===i.baseUri||!!t.baseUri&&!!i.baseUri&&(0,P.$sg)(A.URI.from(t.baseUri),A.URI.from(i.baseUri)))}e.$_j=D;function u(t){return t.replace(/[\\`*_{}[\]()#+\-!~]/g,"\\$&")}e.$ak=u;function b(t){return t.replace(/"/g,"&quot;")}e.$bk=b;function p(t){return t&&t.replace(/\\([\\`*_{}[\]()#+\-.!~])/g,"$1")}e.$ck=p;function g(t){const i=[],r=t.split("|").map(o=>o.trim());t=r[0];const c=r[1];if(c){const o=/height=(\d+)/.exec(c),l=/width=(\d+)/.exec(c),n=o?o[1]:"",s=l?l[1]:"",a=isFinite(parseInt(s)),d=isFinite(parseInt(n));a&&i.push(`width="${s}"`),d&&i.push(`height="${n}"`)}return{href:t,dimensions:i}}e.$dk=g}),define(Pe[94],Re([1,0,18,46,19,21,25,12]),function(be,e,y,F,P,M,A,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gv=e.$Fv=e.$Ev=e.$Dv=e.$Cv=e.$Bv=e.$Av=e.$zv=e.$yv=e.$xv=void 0;function E(d,v){const{os:m,tildify:S,relative:k}=v;if(k){const I=f(d,k,m);if(typeof I=="string")return I}let h=d.fsPath;if(m===1&&!M.$i?h=h.replace(/\//g,"\\"):m!==1&&M.$i&&(h=h.replace(/\\/g,"/")),m!==1&&S?.userHome){const I=S.userHome.fsPath;let L;d.scheme!==S.userHome.scheme&&d.path[0]===P.$fc.sep&&d.path[1]!==P.$fc.sep?L=S.userHome.with({path:d.path}).fsPath:L=h,h=u(L,I,m)}return(m===1?P.$ec:P.$fc).normalize(C(h,m===1))}e.$xv=E;function f(d,v,m){const S=m===1?P.$ec:P.$fc,k=m===3?A.$pg:A.$rg,h=v.getWorkspace(),w=(0,y.$Nb)(h.folders);if(!w)return;d.scheme!==w.uri.scheme&&d.path[0]===P.$fc.sep&&d.path[1]!==P.$fc.sep&&(d=w.uri.with({path:d.path}));const I=v.getWorkspaceFolder(d);if(!I)return;let L;if(k.isEqual(I.uri,d)?L="":L=k.relativePath(I.uri,d)??"",L&&(L=S.normalize(L)),h.folders.length>1&&!v.noPrefix){const V=I.name?I.name:k.basenameOrAuthority(I.uri);L=L?`${V} \u2022 ${L}`:V}return L}function C(d,v=M.$i){return(0,F.$6f)(d,v)?d.charAt(0).toUpperCase()+d.slice(1):d}e.$yv=C;let D=Object.create(null);function u(d,v,m=M.OS){if(m===1||!d||!v)return d;let S=D.original===v?D.normalized:void 0;S||(S=v,M.$i&&(S=(0,F.$Vf)(S)),S=`${(0,$.$Oe)(S,P.$fc.sep)}${P.$fc.sep}`,D={original:v,normalized:S});let k=d;return M.$i&&(k=(0,F.$Vf)(k)),(m===3?k.startsWith(S):(0,$.$7e)(k,S))?`~/${k.substr(S.length)}`:d}e.$zv=u;function b(d,v){return d.replace(/^~($|\/|\\)/,`${v}$1`)}e.$Av=b;const p="\u2026",g="\\\\",t="~";function i(d,v=P.sep){const m=new Array(d.length);let S=!1;for(let k=0;k<d.length;k++){const h=d[k];if(h===""){m[k]=`.${v}`;continue}if(!h){m[k]=h;continue}S=!0;let w="",I=h;I.indexOf(g)===0?(w=I.substr(0,I.indexOf(g)+g.length),I=I.substr(I.indexOf(g)+g.length)):I.indexOf(v)===0?(w=I.substr(0,I.indexOf(v)+v.length),I=I.substr(I.indexOf(v)+v.length)):I.indexOf(t)===0&&(w=I.substr(0,I.indexOf(t)+t.length),I=I.substr(I.indexOf(t)+t.length));const L=I.split(v);for(let V=1;S&&V<=L.length;V++)for(let K=L.length-V;S&&K>=0;K--){S=!1;let R=L.slice(K,K+V).join(v);for(let N=0;!S&&N<d.length;N++)if(N!==k&&d[N]&&d[N].indexOf(R)>-1){const T=K+V===L.length,z=K>0&&d[N].indexOf(v)>-1?v+R:R,Z=d[N].endsWith(z);S=!T||Z}if(!S){let N="";(L[0].endsWith(":")||w!=="")&&(K===1&&(K=0,V++,R=L[0]+v+R),K>0&&(N=L[0]+v),N=w+N),K>0&&(N=N+p+v),N=N+R,K+V<L.length&&(N=N+v+p),m[k]=N}}S&&(m[k]=h)}return m}e.$Bv=i;var r;(function(d){d[d.TEXT=0]="TEXT",d[d.VARIABLE=1]="VARIABLE",d[d.SEPARATOR=2]="SEPARATOR"})(r||(r={}));function c(d,v=Object.create(null)){const m=[];let S=!1,k="";for(const h of d)if(h==="$"||S&&h==="{")k&&m.push({value:k,type:r.TEXT}),k="",S=!0;else if(h==="}"&&S){const w=v[k];if(typeof w=="string")w.length&&m.push({value:w,type:r.VARIABLE});else if(w){const I=m[m.length-1];(!I||I.type!==r.SEPARATOR)&&m.push({value:w.label,type:r.SEPARATOR})}k="",S=!1}else k+=h;return k&&!S&&m.push({value:k,type:r.TEXT}),m.filter((h,w)=>{if(h.type===r.SEPARATOR){const I=m[w-1],L=m[w+1];return[I,L].every(V=>V&&(V.type===r.VARIABLE||V.type===r.TEXT)&&V.value.length>0)}return!0}).map(h=>h.value).join("")}e.$Cv=c;function o(d,v){return M.$j||v?d.replace(/\(&&\w\)|&&/g,"").replace(/&/g,M.$j?"&":"&&"):d.replace(/&&|&/g,m=>m==="&"?"&&":"&")}e.$Dv=o;function l(d,v){return M.$j||v?d.replace(/\(&&\w\)|&&/g,""):M.$i?d.replace(/&&|&/g,m=>m==="&"?"&&":"&"):d.replace(/&&/g,"_")}e.$Ev=l;function n(d){return d.replace(/&/g,"&&")}e.$Fv=n;function s(d){if(d.endsWith("]")){const v=d.lastIndexOf(" [",d.length-2);if(v!==-1){const m=a(d.substring(0,v));return{name:m.name,parentPath:m.parentPath+d.substring(v)}}}return a(d)}e.$Gv=s;function a(d){const v=d.indexOf("/")!==-1?P.$fc:P.$ec,m=v.basename(d),S=v.dirname(d);return m.length?{name:m,parentPath:S}:{name:S,parentPath:""}}}),define(Pe[139],Re([1,0,24,2]),function(be,e,y,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vm=e.$Um=e.$Tm=e.$Sm=e.$Rm=void 0;function P(D){return D.toJSON()}class M{constructor(u){this.a=u}transformIncoming(u){const b=this.a.transformIncoming(u);return b===u?u:P(F.URI.from(b))}transformOutgoing(u){const b=this.a.transformOutgoing(u);return b===u?u:P(F.URI.from(b))}transformOutgoingURI(u){const b=this.a.transformOutgoing(u);return b===u?u:F.URI.from(b)}transformOutgoingScheme(u){return this.a.transformOutgoingScheme(u)}}e.$Rm=M,e.$Sm=new class{transformIncoming(D){return D}transformOutgoing(D){return D}transformOutgoingURI(D){return D}transformOutgoingScheme(D){return D}};function A(D,u,b){if(!D||b>200)return null;if(typeof D=="object"){if(D instanceof F.URI)return u.transformOutgoing(D);for(const p in D)if(Object.hasOwnProperty.call(D,p)){const g=A(D[p],u,b+1);g!==null&&(D[p]=g)}}return null}function $(D,u){const b=A(D,u,0);return b===null?D:b}e.$Tm=$;function E(D,u,b,p){if(!D||p>200)return null;if(typeof D=="object"){if(D.$mid===1)return b?F.URI.revive(u.transformIncoming(D)):u.transformIncoming(D);if(D instanceof y.$fe)return null;for(const g in D)if(Object.hasOwnProperty.call(D,g)){const t=E(D[g],u,b,p+1);t!==null&&(D[g]=t)}}return null}function f(D,u){const b=E(D,u,!1,0);return b===null?D:b}e.$Um=f;function C(D,u){const b=E(D,u,!0,0);return b===null?D:b}e.$Vm=C}),define(Pe[140],Re([1,0,12,21,24]),function(be,e,y,F,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ts=e.$Ss=e.$Rs=void 0;let M;function A(){return M||(M=new TextDecoder("UTF-16LE")),M}let $;function E(){return $||($=new TextDecoder("UTF-16BE")),$}let f;function C(){return f||(f=F.$D()?A():E()),f}e.$Rs=C;function D(p,g,t){const i=new Uint16Array(p.buffer,g,t);return t>0&&(i[0]===65279||i[0]===65534)?u(p,g,t):A().decode(i)}e.$Ss=D;function u(p,g,t){const i=[];let r=0;for(let c=0;c<t;c++){const o=P.$he(p,g);g+=2,i[r++]=String.fromCharCode(o)}return i.join("")}class b{constructor(g){this.a=g|0,this.b=new Uint16Array(this.a),this.c=null,this.d=0}reset(){this.c=null,this.d=0}build(){return this.c!==null?(this.f(),this.c.join("")):this.e()}e(){if(this.d===0)return"";const g=new Uint16Array(this.b.buffer,0,this.d);return C().decode(g)}f(){const g=this.e();this.d=0,this.c===null?this.c=[g]:this.c[this.c.length]=g}appendCharCode(g){const t=this.a-this.d;t<=1&&(t===0||y.$0e(g))&&this.f(),this.b[this.d++]=g}appendASCIICharCode(g){this.d===this.a&&this.f(),this.b[this.d++]=g}appendString(g){const t=g.length;if(this.d+t>=this.a){this.f(),this.c[this.c.length]=g;return}for(let i=0;i<t;i++)this.b[this.d++]=g.charCodeAt(i)}}e.$Ts=b}),define(Pe[141],Re([1,0,24,140]),function(be,e,y,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vs=e.$Us=void 0;function P(E){return E.replace(/\n/g,"\\n").replace(/\r/g,"\\r")}class M{get oldLength(){return this.oldText.length}get oldEnd(){return this.oldPosition+this.oldText.length}get newLength(){return this.newText.length}get newEnd(){return this.newPosition+this.newText.length}constructor(f,C,D,u){this.oldPosition=f,this.oldText=C,this.newPosition=D,this.newText=u}toString(){return this.oldText.length===0?`(insert@${this.oldPosition} "${P(this.newText)}")`:this.newText.length===0?`(delete@${this.oldPosition} "${P(this.oldText)}")`:`(replace@${this.oldPosition} "${P(this.oldText)}" with "${P(this.newText)}")`}static a(f){return 4+2*f.length}static c(f,C,D){const u=C.length;y.$ke(f,u,D),D+=4;for(let b=0;b<u;b++)y.$ie(f,C.charCodeAt(b),D),D+=2;return D}static d(f,C){const D=y.$je(f,C);return C+=4,(0,F.$Ss)(f,C,D)}writeSize(){return 4+4+M.a(this.oldText)+M.a(this.newText)}write(f,C){return y.$ke(f,this.oldPosition,C),C+=4,y.$ke(f,this.newPosition,C),C+=4,C=M.c(f,this.oldText,C),C=M.c(f,this.newText,C),C}static read(f,C,D){const u=y.$je(f,C);C+=4;const b=y.$je(f,C);C+=4;const p=M.d(f,C);C+=M.a(p);const g=M.d(f,C);return C+=M.a(g),D.push(new M(u,p,b,g)),C}}e.$Us=M;function A(E,f){return E===null||E.length===0?f:new $(E,f).compress()}e.$Vs=A;class ${constructor(f,C){this.a=f,this.c=C,this.d=[],this.e=0,this.f=this.a.length,this.g=0,this.h=this.c.length,this.j=0}compress(){let f=0,C=0,D=this.n(f),u=this.l(C);for(;f<this.f||C<this.h;){if(D===null){this.k(u),u=this.l(++C);continue}if(u===null){this.m(D),D=this.n(++f);continue}if(u.oldEnd<=D.newPosition){this.k(u),u=this.l(++C);continue}if(D.newEnd<=u.oldPosition){this.m(D),D=this.n(++f);continue}if(u.oldPosition<D.newPosition){const[i,r]=$.r(u,D.newPosition-u.oldPosition);this.k(i),u=r;continue}if(D.newPosition<u.oldPosition){const[i,r]=$.q(D,u.oldPosition-D.newPosition);this.m(i),D=r;continue}let g,t;if(u.oldEnd===D.newEnd)g=D,t=u,D=this.n(++f),u=this.l(++C);else if(u.oldEnd<D.newEnd){const[i,r]=$.q(D,u.oldLength);g=i,t=u,D=r,u=this.l(++C)}else{const[i,r]=$.r(u,D.newLength);g=D,t=i,D=this.n(++f),u=r}this.d[this.e++]=new M(g.oldPosition,g.oldText,t.newPosition,t.newText),this.g+=g.newLength-g.oldLength,this.j+=t.newLength-t.oldLength}const b=$.s(this.d);return $.t(b)}k(f){this.d[this.e++]=$.o(this.g,f),this.j+=f.newLength-f.oldLength}l(f){return f<this.h?this.c[f]:null}m(f){this.d[this.e++]=$.p(this.j,f),this.g+=f.newLength-f.oldLength}n(f){return f<this.f?this.a[f]:null}static o(f,C){return new M(C.oldPosition-f,C.oldText,C.newPosition,C.newText)}static p(f,C){return new M(C.oldPosition,C.oldText,C.newPosition+f,C.newText)}static q(f,C){const D=f.newText.substr(0,C),u=f.newText.substr(C);return[new M(f.oldPosition,f.oldText,f.newPosition,D),new M(f.oldEnd,"",f.newPosition+C,u)]}static r(f,C){const D=f.oldText.substr(0,C),u=f.oldText.substr(C);return[new M(f.oldPosition,D,f.newPosition,f.newText),new M(f.oldPosition+C,u,f.newEnd,"")]}static s(f){if(f.length===0)return f;const C=[];let D=0,u=f[0];for(let b=1;b<f.length;b++){const p=f[b];u.oldEnd===p.oldPosition?u=new M(u.oldPosition,u.oldText+p.oldText,u.newPosition,u.newText+p.newText):(C[D++]=u,u=p)}return C[D++]=u,C}static t(f){if(f.length===0)return f;const C=[];let D=0;for(let u=0;u<f.length;u++){const b=f[u];b.oldText!==b.newText&&(C[D++]=b)}return C}}}),define(Pe[142],Re([1,0,33,19]),function(be,e,y,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$KE=void 0;function P(M,A,$,E,f,C){if(Array.isArray(M)){let D=0;for(const u of M){const b=P(u,A,$,E,f,C);if(b===10)return b;b>D&&(D=b)}return D}else{if(typeof M=="string")return E?M==="*"?5:M===$?10:0:0;if(M){const{language:D,pattern:u,scheme:b,hasAccessToAllModels:p,notebookType:g}=M;if(!E&&!p)return 0;g&&f&&(A=f);let t=0;if(b)if(b===A.scheme)t=10;else if(b==="*")t=5;else return 0;if(D)if(D===$)t=10;else if(D==="*")t=Math.max(t,5);else return 0;if(g)if(g===C)t=10;else if(g==="*"&&C!==void 0)t=Math.max(t,5);else return 0;if(u){let i;if(typeof u=="string"?i=u:i={...u,base:(0,F.$gc)(u.base)},i===A.fsPath||(0,y.$Bj)(i,A.fsPath))t=10;else return 0}return t}else return 0}}e.$KE=P}),define(Pe[143],Re([1,0,5,12,29,92,91,127,141,6]),function(be,e,y,F,P,M,A,$,E,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$LB=void 0;class C extends f.$Rc{constructor(u,b,p,g,t,i,r){super(),this.m=this.B(new y.$Rd),this.onDidChangeContent=this.m.event,this.f=b,this.j=!i,this.g=g,this.h=t,this.c=new A.$KB(u,p,r)}equals(u){return!(u instanceof C)||this.f!==u.f||this.getEOL()!==u.getEOL()?!1:this.c.equal(u.c)}mightContainRTL(){return this.g}mightContainUnusualLineTerminators(){return this.h}resetMightContainUnusualLineTerminators(){this.h=!1}mightContainNonBasicASCII(){return this.j}getBOM(){return this.f}getEOL(){return this.c.getEOL()}createSnapshot(u){return this.c.createSnapshot(u?this.f:"")}getOffsetAt(u,b){return this.c.getOffsetAt(u,b)}getPositionAt(u){return this.c.getPositionAt(u)}getRangeAt(u,b){const p=u+b,g=this.getPositionAt(u),t=this.getPositionAt(p);return new P.$zs(g.lineNumber,g.column,t.lineNumber,t.column)}getValueInRange(u,b=0){if(u.isEmpty())return"";const p=this.n(b);return this.c.getValueInRange(u,p)}getValueLengthInRange(u,b=0){if(u.isEmpty())return 0;if(u.startLineNumber===u.endLineNumber)return u.endColumn-u.startColumn;const p=this.getOffsetAt(u.startLineNumber,u.startColumn),g=this.getOffsetAt(u.endLineNumber,u.endColumn);let t=0;const i=this.n(b),r=this.getEOL();if(i.length!==r.length){const c=i.length-r.length,o=u.endLineNumber-u.startLineNumber;t=c*o}return g-p+t}getCharacterCountInRange(u,b=0){if(this.j){let p=0;const g=u.startLineNumber,t=u.endLineNumber;for(let i=g;i<=t;i++){const r=this.getLineContent(i),c=i===g?u.startColumn-1:0,o=i===t?u.endColumn-1:r.length;for(let l=c;l<o;l++)F.$0e(r.charCodeAt(l))?(p=p+1,l=l+1):p=p+1}return p+=this.n(b).length*(t-g),p}return this.getValueLengthInRange(u,b)}getLength(){return this.c.getLength()}getLineCount(){return this.c.getLineCount()}getLinesContent(){return this.c.getLinesContent()}getLineContent(u){return this.c.getLineContent(u)}getLineCharCode(u,b){return this.c.getLineCharCode(u,b)}getCharCode(u){return this.c.getCharCode(u)}getLineLength(u){return this.c.getLineLength(u)}getLineMinColumn(u){return 1}getLineMaxColumn(u){return this.getLineLength(u)+1}getLineFirstNonWhitespaceColumn(u){const b=F.$Ue(this.getLineContent(u));return b===-1?0:b+1}getLineLastNonWhitespaceColumn(u){const b=F.$We(this.getLineContent(u));return b===-1?0:b+2}n(u){switch(u){case 1:return`
`;case 2:return`\r
`;case 0:return this.getEOL();default:throw new Error("Unknown EOL preference")}}setEOL(u){this.c.setEOL(u)}applyEdits(u,b,p){let g=this.g,t=this.h,i=this.j,r=!0,c=[];for(let v=0;v<u.length;v++){const m=u[v];r&&m._isTracked&&(r=!1);const S=m.range;if(m.text){let L=!0;i||(L=!F.$if(m.text),i=L),!g&&L&&(g=F.$hf(m.text)),!t&&L&&(t=F.$kf(m.text))}let k="",h=0,w=0,I=0;if(m.text){let L;[h,w,I,L]=(0,$.$_s)(m.text);const V=this.getEOL();L===0||L===(V===`\r
`?2:1)?k=m.text:k=m.text.replace(/\r\n|\r|\n/g,V)}c[v]={sortIndex:v,identifier:m.identifier||null,range:S,rangeOffset:this.getOffsetAt(S.startLineNumber,S.startColumn),rangeLength:this.getValueLengthInRange(S),text:k,eolCount:h,firstLineLength:w,lastLineLength:I,forceMoveMarkers:!!m.forceMoveMarkers,isAutoWhitespaceEdit:m.isAutoWhitespaceEdit||!1}}c.sort(C.u);let o=!1;for(let v=0,m=c.length-1;v<m;v++){const S=c[v].range.getEndPosition(),k=c[v+1].range.getStartPosition();if(k.isBeforeOrEqual(S)){if(k.isBefore(S))throw new Error("Overlapping ranges are not allowed!");o=!0}}r&&(c=this.s(c));const l=p||b?C._getInverseEditRanges(c):[],n=[];if(b)for(let v=0;v<c.length;v++){const m=c[v],S=l[v];if(m.isAutoWhitespaceEdit&&m.range.isEmpty())for(let k=S.startLineNumber;k<=S.endLineNumber;k++){let h="";k===S.startLineNumber&&(h=this.getLineContent(m.range.startLineNumber),F.$Ue(h)!==-1)||n.push({lineNumber:k,oldContent:h})}}let s=null;if(p){let v=0;s=[];for(let m=0;m<c.length;m++){const S=c[m],k=l[m],h=this.getValueInRange(S.range),w=S.rangeOffset+v;v+=S.text.length-h.length,s[m]={sortIndex:S.sortIndex,identifier:S.identifier,range:k,text:h,textChange:new E.$Us(S.rangeOffset,h,w,S.text)}}o||s.sort((m,S)=>m.sortIndex-S.sortIndex)}this.g=g,this.h=t,this.j=i;const a=this.t(c);let d=null;if(b&&n.length>0){n.sort((v,m)=>m.lineNumber-v.lineNumber),d=[];for(let v=0,m=n.length;v<m;v++){const S=n[v].lineNumber;if(v>0&&n[v-1].lineNumber===S)continue;const k=n[v].oldContent,h=this.getLineContent(S);h.length===0||h===k||F.$Ue(h)!==-1||d.push(S)}}return this.m.fire(),new M.$Uu(s,a,d)}s(u){return u.length<1e3?u:[this._toSingleEditOperation(u)]}_toSingleEditOperation(u){let b=!1;const p=u[0].range,g=u[u.length-1].range,t=new P.$zs(p.startLineNumber,p.startColumn,g.endLineNumber,g.endColumn);let i=p.startLineNumber,r=p.startColumn;const c=[];for(let a=0,d=u.length;a<d;a++){const v=u[a],m=v.range;b=b||v.forceMoveMarkers,c.push(this.getValueInRange(new P.$zs(i,r,m.startLineNumber,m.startColumn))),v.text.length>0&&c.push(v.text),i=m.endLineNumber,r=m.endColumn}const o=c.join(""),[l,n,s]=(0,$.$_s)(o);return{sortIndex:0,identifier:u[0].identifier,range:t,rangeOffset:this.getOffsetAt(t.startLineNumber,t.startColumn),rangeLength:this.getValueLengthInRange(t,0),text:o,eolCount:l,firstLineLength:n,lastLineLength:s,forceMoveMarkers:b,isAutoWhitespaceEdit:!1}}t(u){u.sort(C.w);const b=[];for(let p=0;p<u.length;p++){const g=u[p],t=g.range.startLineNumber,i=g.range.startColumn,r=g.range.endLineNumber,c=g.range.endColumn;if(t===r&&i===c&&g.text.length===0)continue;g.text?(this.c.delete(g.rangeOffset,g.rangeLength),this.c.insert(g.rangeOffset,g.text,!0)):this.c.delete(g.rangeOffset,g.rangeLength);const o=new P.$zs(t,i,r,c);b.push({range:o,rangeLength:g.rangeLength,text:g.text,rangeOffset:g.rangeOffset,forceMoveMarkers:g.forceMoveMarkers})}return b}findMatchesLineByLine(u,b,p,g){return this.c.findMatchesLineByLine(u,b,p,g)}getPieceTree(){return this.c}static _getInverseEditRange(u,b){const p=u.startLineNumber,g=u.startColumn,[t,i,r]=(0,$.$_s)(b);let c;if(b.length>0){const o=t+1;o===1?c=new P.$zs(p,g,p,g+i):c=new P.$zs(p,g,p+o-1,r+1)}else c=new P.$zs(p,g,p,g);return c}static _getInverseEditRanges(u){const b=[];let p=0,g=0,t=null;for(let i=0,r=u.length;i<r;i++){const c=u[i];let o,l;t?t.range.endLineNumber===c.range.startLineNumber?(o=p,l=g+(c.range.startColumn-t.range.endColumn)):(o=p+(c.range.startLineNumber-t.range.endLineNumber),l=c.range.startColumn):(o=c.range.startLineNumber,l=c.range.startColumn);let n;if(c.text.length>0){const s=c.eolCount+1;s===1?n=new P.$zs(o,l,o,l+c.firstLineLength):n=new P.$zs(o,l,o+s-1,c.lastLineLength+1)}else n=new P.$zs(o,l,o,l);p=n.endLineNumber,g=n.endColumn,b.push(n),t=c}return b}static u(u,b){const p=P.$zs.compareRangesUsingEnds(u.range,b.range);return p===0?u.sortIndex-b.sortIndex:p}static w(u,b){const p=P.$zs.compareRangesUsingEnds(u.range,b.range);return p===0?b.sortIndex-u.sortIndex:-p}}e.$LB=C}),define(Pe[144],Re([1,0,12,91,143]),function(be,e,y,F,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$MB=void 0;class M{constructor(E,f,C,D,u,b,p,g,t){this.a=E,this.b=f,this.c=C,this.d=D,this.e=u,this.f=b,this.g=p,this.h=g,this.j=t}k(E){const f=this.c+this.d+this.e,C=this.c+this.e;return f===0?E===1?`
`:`\r
`:C>f/2?`\r
`:`
`}create(E){const f=this.k(E),C=this.a;if(this.j&&(f===`\r
`&&(this.c>0||this.d>0)||f===`
`&&(this.c>0||this.e>0)))for(let u=0,b=C.length;u<b;u++){const p=C[u].buffer.replace(/\r\n|\r|\n/g,f),g=(0,F.$GB)(p);C[u]=new F.$JB(p,g)}const D=new P.$LB(C,this.b,f,this.f,this.g,this.h,this.j);return{textBuffer:D,disposable:D}}getFirstLineText(E){return this.a[0].buffer.substr(0,E).split(/\r\n|\r|\n/)[0]}}class A{constructor(){this.a=[],this.b="",this.c=!1,this.d=0,this.e=[],this.f=0,this.g=0,this.h=0,this.j=!1,this.k=!1,this.l=!0}acceptChunk(E){if(E.length===0)return;this.a.length===0&&y.$qf(E)&&(this.b=y.$pf,E=E.substr(1));const f=E.charCodeAt(E.length-1);f===13||f>=55296&&f<=56319?(this.m(E.substr(0,E.length-1),!1),this.c=!0,this.d=f):(this.m(E,!1),this.c=!1,this.d=f)}m(E,f){!f&&E.length===0||(this.c?this.n(String.fromCharCode(this.d)+E):this.n(E))}n(E){const f=(0,F.$HB)(this.e,E);this.a.push(new F.$JB(E,f.lineStarts)),this.f+=f.cr,this.g+=f.lf,this.h+=f.crlf,f.isBasicASCII||(this.l=!1,this.j||(this.j=y.$hf(E)),this.k||(this.k=y.$kf(E)))}finish(E=!0){return this.o(),new M(this.a,this.b,this.f,this.g,this.h,this.j,this.k,this.l,E)}o(){if(this.a.length===0&&this.m("",!0),this.c){this.c=!1;const E=this.a[this.a.length-1];E.buffer+=String.fromCharCode(this.d);const f=(0,F.$GB)(E.buffer);E.lineStarts=f,this.d===13&&this.f++}}}e.$MB=A}),define(Pe[95],Re([1,0,24,21]),function(be,e,y,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$x$=e.$w$=void 0;var P;(function(D){D[D.Full=1]="Full",D[D.Delta=2]="Delta"})(P||(P={}));function M(D){for(let u=0,b=D.length;u<b;u+=4){const p=D[u+0],g=D[u+1],t=D[u+2],i=D[u+3];D[u+0]=i,D[u+1]=t,D[u+2]=g,D[u+3]=p}}function A(D){const u=new Uint8Array(D.buffer,D.byteOffset,D.length*4);return F.$D()||M(u),y.$fe.wrap(u)}function $(D){const u=D.buffer;if(F.$D()||M(u),u.byteOffset%4===0)return new Uint32Array(u.buffer,u.byteOffset,u.length/4);{const b=new Uint8Array(u.byteLength);return b.set(u),new Uint32Array(b.buffer,b.byteOffset,b.length/4)}}function E(D){const u=new Uint32Array(f(D));let b=0;if(u[b++]=D.id,D.type==="full")u[b++]=1,u[b++]=D.data.length,u.set(D.data,b),b+=D.data.length;else{u[b++]=2,u[b++]=D.deltas.length;for(const p of D.deltas)u[b++]=p.start,u[b++]=p.deleteCount,p.data?(u[b++]=p.data.length,u.set(p.data,b),b+=p.data.length):u[b++]=0}return A(u)}e.$w$=E;function f(D){let u=0;if(u+=1+1,D.type==="full")u+=1+D.data.length;else{u+=1,u+=(1+1+1)*D.deltas.length;for(const b of D.deltas)b.data&&(u+=b.data.length)}return u}function C(D){const u=$(D);let b=0;const p=u[b++];if(u[b++]===1){const r=u[b++],c=u.subarray(b,b+r);return b+=r,{id:p,type:"full",data:c}}const t=u[b++],i=[];for(let r=0;r<t;r++){const c=u[b++],o=u[b++],l=u[b++];let n;l>0&&(n=u.subarray(b,b+l),b+=l),i[r]={start:c,deleteCount:o,data:n}}return{id:p,type:"delta",deltas:i}}e.$x$=C}),define(Pe[145],Re([9,10]),function(be,e){return be.create("vs/editor/common/config/editorOptions",e)}),define(Pe[146],Re([1,0,18,26,21,128,147,145]),function(be,e,y,F,P,M,A,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorOptions=e.EditorOption=e.editorOptionsRegistry=e.EDITOR_FONT_DEFAULTS=e.WrappingIndent=e.unicodeHighlightConfigKeys=e.inUntrustedWorkspace=e.filterValidationDecorations=e.RenderLineNumbersType=e.EditorLayoutInfoComputer=e.RenderMinimap=e.EditorFontVariations=e.EditorFontLigatures=e.cursorStyleToString=e.TextEditorCursorStyle=e.TextEditorCursorBlinkingStyle=e.stringSet=e.clampedFloat=e.clampedInt=e.boolean=e.ApplyUpdateResult=e.ComputeOptionsMemory=e.ConfigurationChangedEvent=e.MINIMAP_GUTTER_WIDTH=e.EditorAutoIndentStrategy=void 0;var E;(function(Y){Y[Y.None=0]="None",Y[Y.Keep=1]="Keep",Y[Y.Brackets=2]="Brackets",Y[Y.Advanced=3]="Advanced",Y[Y.Full=4]="Full"})(E||(e.EditorAutoIndentStrategy=E={})),e.MINIMAP_GUTTER_WIDTH=8;class f{constructor(Q){this.c=Q}hasChanged(Q){return this.c[Q]}}e.ConfigurationChangedEvent=f;class C{constructor(){this.stableMinimapLayoutInput=null,this.stableFitMaxMinimapScale=0,this.stableFitRemainingWidth=0}}e.ComputeOptionsMemory=C;class D{constructor(Q,Ee,Be,He){this.id=Q,this.name=Ee,this.defaultValue=Be,this.schema=He}applyUpdate(Q,Ee){return b(Q,Ee)}compute(Q,Ee,Be){return Be}}class u{constructor(Q,Ee){this.newValue=Q,this.didChange=Ee}}e.ApplyUpdateResult=u;function b(Y,Q){if(typeof Y!="object"||typeof Q!="object"||!Y||!Q)return new u(Q,Y!==Q);if(Array.isArray(Y)||Array.isArray(Q)){const Be=Array.isArray(Y)&&Array.isArray(Q)&&y.$tb(Y,Q);return new u(Q,!Be)}let Ee=!1;for(const Be in Q)if(Q.hasOwnProperty(Be)){const He=b(Y[Be],Q[Be]);He.didChange&&(Y[Be]=He.newValue,Ee=!0)}return new u(Y,Ee)}class p{constructor(Q){this.schema=void 0,this.id=Q,this.name="_never_",this.defaultValue=void 0}applyUpdate(Q,Ee){return b(Q,Ee)}validate(Q){return this.defaultValue}}class g{constructor(Q,Ee,Be,He){this.id=Q,this.name=Ee,this.defaultValue=Be,this.schema=He}applyUpdate(Q,Ee){return b(Q,Ee)}validate(Q){return typeof Q>"u"?this.defaultValue:Q}compute(Q,Ee,Be){return Be}}function t(Y,Q){return typeof Y>"u"?Q:Y==="false"?!1:!!Y}e.boolean=t;class i extends g{constructor(Q,Ee,Be,He=void 0){typeof He<"u"&&(He.type="boolean",He.default=Be),super(Q,Ee,Be,He)}validate(Q){return t(Q,this.defaultValue)}}function r(Y,Q,Ee,Be){if(typeof Y>"u")return Q;let He=parseInt(Y,10);return isNaN(He)?Q:(He=Math.max(Ee,He),He=Math.min(Be,He),He|0)}e.clampedInt=r;class c extends g{static clampedInt(Q,Ee,Be,He){return r(Q,Ee,Be,He)}constructor(Q,Ee,Be,He,Ye,st=void 0){typeof st<"u"&&(st.type="integer",st.default=Be,st.minimum=He,st.maximum=Ye),super(Q,Ee,Be,st),this.minimum=He,this.maximum=Ye}validate(Q){return c.clampedInt(Q,this.defaultValue,this.minimum,this.maximum)}}function o(Y,Q,Ee,Be){if(typeof Y>"u")return Q;const He=l.float(Y,Q);return l.clamp(He,Ee,Be)}e.clampedFloat=o;class l extends g{static clamp(Q,Ee,Be){return Q<Ee?Ee:Q>Be?Be:Q}static float(Q,Ee){if(typeof Q=="number")return Q;if(typeof Q>"u")return Ee;const Be=parseFloat(Q);return isNaN(Be)?Ee:Be}constructor(Q,Ee,Be,He,Ye){typeof Ye<"u"&&(Ye.type="number",Ye.default=Be),super(Q,Ee,Be,Ye),this.validationFn=He}validate(Q){return this.validationFn(l.float(Q,this.defaultValue))}}class n extends g{static string(Q,Ee){return typeof Q!="string"?Ee:Q}constructor(Q,Ee,Be,He=void 0){typeof He<"u"&&(He.type="string",He.default=Be),super(Q,Ee,Be,He)}validate(Q){return n.string(Q,this.defaultValue)}}function s(Y,Q,Ee,Be){return typeof Y!="string"?Q:Be&&Y in Be?Be[Y]:Ee.indexOf(Y)===-1?Q:Y}e.stringSet=s;class a extends g{constructor(Q,Ee,Be,He,Ye=void 0){typeof Ye<"u"&&(Ye.type="string",Ye.enum=He,Ye.default=Be),super(Q,Ee,Be,Ye),this.c=He}validate(Q){return s(Q,this.defaultValue,this.c)}}class d extends D{constructor(Q,Ee,Be,He,Ye,st,vt=void 0){typeof vt<"u"&&(vt.type="string",vt.enum=Ye,vt.default=He),super(Q,Ee,Be,vt),this.c=Ye,this.d=st}validate(Q){return typeof Q!="string"?this.defaultValue:this.c.indexOf(Q)===-1?this.defaultValue:this.d(Q)}}function v(Y){switch(Y){case"none":return 0;case"keep":return 1;case"brackets":return 2;case"advanced":return 3;case"full":return 4}}class m extends D{constructor(){super(2,"accessibilitySupport",0,{type:"string",enum:["auto","on","off"],enumDescriptions:[$.localize(0,null),$.localize(1,null),$.localize(2,null)],default:"auto",tags:["accessibility"],description:$.localize(3,null)})}validate(Q){switch(Q){case"auto":return 0;case"off":return 1;case"on":return 2}return this.defaultValue}compute(Q,Ee,Be){return Be===0?Q.accessibilitySupport:Be}}class S extends D{constructor(){const Q={insertSpace:!0,ignoreEmptyLines:!0};super(23,"comments",Q,{"editor.comments.insertSpace":{type:"boolean",default:Q.insertSpace,description:$.localize(4,null)},"editor.comments.ignoreEmptyLines":{type:"boolean",default:Q.ignoreEmptyLines,description:$.localize(5,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const Ee=Q;return{insertSpace:t(Ee.insertSpace,this.defaultValue.insertSpace),ignoreEmptyLines:t(Ee.ignoreEmptyLines,this.defaultValue.ignoreEmptyLines)}}}var k;(function(Y){Y[Y.Hidden=0]="Hidden",Y[Y.Blink=1]="Blink",Y[Y.Smooth=2]="Smooth",Y[Y.Phase=3]="Phase",Y[Y.Expand=4]="Expand",Y[Y.Solid=5]="Solid"})(k||(e.TextEditorCursorBlinkingStyle=k={}));function h(Y){switch(Y){case"blink":return 1;case"smooth":return 2;case"phase":return 3;case"expand":return 4;case"solid":return 5}}var w;(function(Y){Y[Y.Line=1]="Line",Y[Y.Block=2]="Block",Y[Y.Underline=3]="Underline",Y[Y.LineThin=4]="LineThin",Y[Y.BlockOutline=5]="BlockOutline",Y[Y.UnderlineThin=6]="UnderlineThin"})(w||(e.TextEditorCursorStyle=w={}));function I(Y){switch(Y){case w.Line:return"line";case w.Block:return"block";case w.Underline:return"underline";case w.LineThin:return"line-thin";case w.BlockOutline:return"block-outline";case w.UnderlineThin:return"underline-thin"}}e.cursorStyleToString=I;function L(Y){switch(Y){case"line":return w.Line;case"block":return w.Block;case"underline":return w.Underline;case"line-thin":return w.LineThin;case"block-outline":return w.BlockOutline;case"underline-thin":return w.UnderlineThin}}class V extends p{constructor(){super(140)}compute(Q,Ee,Be){const He=["monaco-editor"];return Ee.get(39)&&He.push(Ee.get(39)),Q.extraEditorClassName&&He.push(Q.extraEditorClassName),Ee.get(73)==="default"?He.push("mouse-default"):Ee.get(73)==="copy"&&He.push("mouse-copy"),Ee.get(110)&&He.push("showUnused"),Ee.get(138)&&He.push("showDeprecated"),He.join(" ")}}class K extends i{constructor(){super(37,"emptySelectionClipboard",!0,{description:$.localize(6,null)})}compute(Q,Ee,Be){return Be&&Q.emptySelectionClipboard}}class R extends D{constructor(){const Q={cursorMoveOnType:!0,seedSearchStringFromSelection:"always",autoFindInSelection:"never",globalFindClipboard:!1,addExtraSpaceOnTop:!0,loop:!0};super(41,"find",Q,{"editor.find.cursorMoveOnType":{type:"boolean",default:Q.cursorMoveOnType,description:$.localize(7,null)},"editor.find.seedSearchStringFromSelection":{type:"string",enum:["never","always","selection"],default:Q.seedSearchStringFromSelection,enumDescriptions:[$.localize(8,null),$.localize(9,null),$.localize(10,null)],description:$.localize(11,null)},"editor.find.autoFindInSelection":{type:"string",enum:["never","always","multiline"],default:Q.autoFindInSelection,enumDescriptions:[$.localize(12,null),$.localize(13,null),$.localize(14,null)],description:$.localize(15,null)},"editor.find.globalFindClipboard":{type:"boolean",default:Q.globalFindClipboard,description:$.localize(16,null),included:P.$j},"editor.find.addExtraSpaceOnTop":{type:"boolean",default:Q.addExtraSpaceOnTop,description:$.localize(17,null)},"editor.find.loop":{type:"boolean",default:Q.loop,description:$.localize(18,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const Ee=Q;return{cursorMoveOnType:t(Ee.cursorMoveOnType,this.defaultValue.cursorMoveOnType),seedSearchStringFromSelection:typeof Q.seedSearchStringFromSelection=="boolean"?Q.seedSearchStringFromSelection?"always":"never":s(Ee.seedSearchStringFromSelection,this.defaultValue.seedSearchStringFromSelection,["never","always","selection"]),autoFindInSelection:typeof Q.autoFindInSelection=="boolean"?Q.autoFindInSelection?"always":"never":s(Ee.autoFindInSelection,this.defaultValue.autoFindInSelection,["never","always","multiline"]),globalFindClipboard:t(Ee.globalFindClipboard,this.defaultValue.globalFindClipboard),addExtraSpaceOnTop:t(Ee.addExtraSpaceOnTop,this.defaultValue.addExtraSpaceOnTop),loop:t(Ee.loop,this.defaultValue.loop)}}}class N extends D{static{this.OFF='"liga" off, "calt" off'}static{this.ON='"liga" on, "calt" on'}constructor(){super(51,"fontLigatures",N.OFF,{anyOf:[{type:"boolean",description:$.localize(19,null)},{type:"string",description:$.localize(20,null)}],description:$.localize(21,null),default:!1})}validate(Q){return typeof Q>"u"?this.defaultValue:typeof Q=="string"?Q==="false"?N.OFF:Q==="true"?N.ON:Q:Q?N.ON:N.OFF}}e.EditorFontLigatures=N;class T extends D{static{this.OFF="normal"}static{this.TRANSLATE="translate"}constructor(){super(54,"fontVariations",T.OFF,{anyOf:[{type:"boolean",description:$.localize(22,null)},{type:"string",description:$.localize(23,null)}],description:$.localize(24,null),default:!1})}validate(Q){return typeof Q>"u"?this.defaultValue:typeof Q=="string"?Q==="false"?T.OFF:Q==="true"?T.TRANSLATE:Q:Q?T.TRANSLATE:T.OFF}compute(Q,Ee,Be){return Q.fontInfo.fontVariationSettings}}e.EditorFontVariations=T;class z extends p{constructor(){super(50)}compute(Q,Ee,Be){return Q.fontInfo}}class Z extends g{constructor(){super(52,"fontSize",e.EDITOR_FONT_DEFAULTS.fontSize,{type:"number",minimum:6,maximum:100,default:e.EDITOR_FONT_DEFAULTS.fontSize,description:$.localize(25,null)})}validate(Q){const Ee=l.float(Q,this.defaultValue);return Ee===0?e.EDITOR_FONT_DEFAULTS.fontSize:l.clamp(Ee,6,100)}compute(Q,Ee,Be){return Q.fontInfo.fontSize}}class he extends D{static{this.c=["normal","bold","100","200","300","400","500","600","700","800","900"]}static{this.d=1}static{this.e=1e3}constructor(){super(53,"fontWeight",e.EDITOR_FONT_DEFAULTS.fontWeight,{anyOf:[{type:"number",minimum:he.d,maximum:he.e,errorMessage:$.localize(26,null)},{type:"string",pattern:"^(normal|bold|1000|[1-9][0-9]{0,2})$"},{enum:he.c}],default:e.EDITOR_FONT_DEFAULTS.fontWeight,description:$.localize(27,null)})}validate(Q){return Q==="normal"||Q==="bold"?Q:String(c.clampedInt(Q,e.EDITOR_FONT_DEFAULTS.fontWeight,he.d,he.e))}}class ye extends D{constructor(){const Q={multiple:"peek",multipleDefinitions:"peek",multipleTypeDefinitions:"peek",multipleDeclarations:"peek",multipleImplementations:"peek",multipleReferences:"peek",alternativeDefinitionCommand:"editor.action.goToReferences",alternativeTypeDefinitionCommand:"editor.action.goToReferences",alternativeDeclarationCommand:"editor.action.goToReferences",alternativeImplementationCommand:"",alternativeReferenceCommand:""},Ee={type:"string",enum:["peek","gotoAndPeek","goto"],default:Q.multiple,enumDescriptions:[$.localize(28,null),$.localize(29,null),$.localize(30,null)]},Be=["","editor.action.referenceSearch.trigger","editor.action.goToReferences","editor.action.peekImplementation","editor.action.goToImplementation","editor.action.peekTypeDefinition","editor.action.goToTypeDefinition","editor.action.peekDeclaration","editor.action.revealDeclaration","editor.action.peekDefinition","editor.action.revealDefinitionAside","editor.action.revealDefinition"];super(58,"gotoLocation",Q,{"editor.gotoLocation.multiple":{deprecationMessage:$.localize(31,null)},"editor.gotoLocation.multipleDefinitions":{description:$.localize(32,null),...Ee},"editor.gotoLocation.multipleTypeDefinitions":{description:$.localize(33,null),...Ee},"editor.gotoLocation.multipleDeclarations":{description:$.localize(34,null),...Ee},"editor.gotoLocation.multipleImplementations":{description:$.localize(35,null),...Ee},"editor.gotoLocation.multipleReferences":{description:$.localize(36,null),...Ee},"editor.gotoLocation.alternativeDefinitionCommand":{type:"string",default:Q.alternativeDefinitionCommand,enum:Be,description:$.localize(37,null)},"editor.gotoLocation.alternativeTypeDefinitionCommand":{type:"string",default:Q.alternativeTypeDefinitionCommand,enum:Be,description:$.localize(38,null)},"editor.gotoLocation.alternativeDeclarationCommand":{type:"string",default:Q.alternativeDeclarationCommand,enum:Be,description:$.localize(39,null)},"editor.gotoLocation.alternativeImplementationCommand":{type:"string",default:Q.alternativeImplementationCommand,enum:Be,description:$.localize(40,null)},"editor.gotoLocation.alternativeReferenceCommand":{type:"string",default:Q.alternativeReferenceCommand,enum:Be,description:$.localize(41,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const Ee=Q;return{multiple:s(Ee.multiple,this.defaultValue.multiple,["peek","gotoAndPeek","goto"]),multipleDefinitions:Ee.multipleDefinitions??s(Ee.multipleDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleTypeDefinitions:Ee.multipleTypeDefinitions??s(Ee.multipleTypeDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleDeclarations:Ee.multipleDeclarations??s(Ee.multipleDeclarations,"peek",["peek","gotoAndPeek","goto"]),multipleImplementations:Ee.multipleImplementations??s(Ee.multipleImplementations,"peek",["peek","gotoAndPeek","goto"]),multipleReferences:Ee.multipleReferences??s(Ee.multipleReferences,"peek",["peek","gotoAndPeek","goto"]),alternativeDefinitionCommand:n.string(Ee.alternativeDefinitionCommand,this.defaultValue.alternativeDefinitionCommand),alternativeTypeDefinitionCommand:n.string(Ee.alternativeTypeDefinitionCommand,this.defaultValue.alternativeTypeDefinitionCommand),alternativeDeclarationCommand:n.string(Ee.alternativeDeclarationCommand,this.defaultValue.alternativeDeclarationCommand),alternativeImplementationCommand:n.string(Ee.alternativeImplementationCommand,this.defaultValue.alternativeImplementationCommand),alternativeReferenceCommand:n.string(Ee.alternativeReferenceCommand,this.defaultValue.alternativeReferenceCommand)}}}class De extends D{constructor(){const Q={enabled:!0,delay:300,hidingDelay:300,sticky:!0,above:!0};super(60,"hover",Q,{"editor.hover.enabled":{type:"boolean",default:Q.enabled,description:$.localize(42,null)},"editor.hover.delay":{type:"number",default:Q.delay,minimum:0,maximum:1e4,description:$.localize(43,null)},"editor.hover.sticky":{type:"boolean",default:Q.sticky,description:$.localize(44,null)},"editor.hover.hidingDelay":{type:"integer",minimum:0,default:Q.hidingDelay,description:$.localize(45,null)},"editor.hover.above":{type:"boolean",default:Q.above,description:$.localize(46,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const Ee=Q;return{enabled:t(Ee.enabled,this.defaultValue.enabled),delay:c.clampedInt(Ee.delay,this.defaultValue.delay,0,1e4),sticky:t(Ee.sticky,this.defaultValue.sticky),hidingDelay:c.clampedInt(Ee.hidingDelay,this.defaultValue.hidingDelay,0,6e5),above:t(Ee.above,this.defaultValue.above)}}}var Se;(function(Y){Y[Y.None=0]="None",Y[Y.Text=1]="Text",Y[Y.Blocks=2]="Blocks"})(Se||(e.RenderMinimap=Se={}));class fe extends p{constructor(){super(143)}compute(Q,Ee,Be){return fe.computeLayout(Ee,{memory:Q.memory,outerWidth:Q.outerWidth,outerHeight:Q.outerHeight,isDominatedByLongLines:Q.isDominatedByLongLines,lineHeight:Q.fontInfo.lineHeight,viewLineCount:Q.viewLineCount,lineNumbersDigitCount:Q.lineNumbersDigitCount,typicalHalfwidthCharacterWidth:Q.fontInfo.typicalHalfwidthCharacterWidth,maxDigitWidth:Q.fontInfo.maxDigitWidth,pixelRatio:Q.pixelRatio,glyphMarginDecorationLaneCount:Q.glyphMarginDecorationLaneCount})}static computeContainedMinimapLineCount(Q){const Ee=Q.height/Q.lineHeight,Be=Math.floor(Q.paddingTop/Q.lineHeight);let He=Math.floor(Q.paddingBottom/Q.lineHeight);Q.scrollBeyondLastLine&&(He=Math.max(He,Ee-1));const Ye=(Be+Q.viewLineCount+He)/(Q.pixelRatio*Q.height),st=Math.floor(Q.viewLineCount/Ye);return{typicalViewportLineCount:Ee,extraLinesBeforeFirstLine:Be,extraLinesBeyondLastLine:He,desiredRatio:Ye,minimapLineCount:st}}static c(Q,Ee){const Be=Q.outerWidth,He=Q.outerHeight,Ye=Q.pixelRatio;if(!Q.minimap.enabled)return{renderMinimap:0,minimapLeft:0,minimapWidth:0,minimapHeightIsEditorHeight:!1,minimapIsSampling:!1,minimapScale:1,minimapLineHeight:1,minimapCanvasInnerWidth:0,minimapCanvasInnerHeight:Math.floor(Ye*He),minimapCanvasOuterWidth:0,minimapCanvasOuterHeight:He};const st=Ee.stableMinimapLayoutInput,vt=st&&Q.outerHeight===st.outerHeight&&Q.lineHeight===st.lineHeight&&Q.typicalHalfwidthCharacterWidth===st.typicalHalfwidthCharacterWidth&&Q.pixelRatio===st.pixelRatio&&Q.scrollBeyondLastLine===st.scrollBeyondLastLine&&Q.paddingTop===st.paddingTop&&Q.paddingBottom===st.paddingBottom&&Q.minimap.enabled===st.minimap.enabled&&Q.minimap.side===st.minimap.side&&Q.minimap.size===st.minimap.size&&Q.minimap.showSlider===st.minimap.showSlider&&Q.minimap.renderCharacters===st.minimap.renderCharacters&&Q.minimap.maxColumn===st.minimap.maxColumn&&Q.minimap.scale===st.minimap.scale&&Q.verticalScrollbarWidth===st.verticalScrollbarWidth&&Q.isViewportWrapping===st.isViewportWrapping,Dt=Q.lineHeight,ze=Q.typicalHalfwidthCharacterWidth,Kt=Q.scrollBeyondLastLine,Ht=Q.minimap.renderCharacters;let yt=Ye>=2?Math.round(Q.minimap.scale*2):Q.minimap.scale;const jt=Q.minimap.maxColumn,zt=Q.minimap.size,Gt=Q.minimap.side,Bt=Q.verticalScrollbarWidth,St=Q.viewLineCount,Lt=Q.remainingWidth,Vt=Q.isViewportWrapping,Xe=Ht?2:3;let Wt=Math.floor(Ye*He);const qt=Wt/Ye;let ct=!1,gt=!1,Ot=Xe*yt,Pt=yt/Ye,Rt=1;if(zt==="fill"||zt==="fit"){const{typicalViewportLineCount:Jt,extraLinesBeforeFirstLine:Ce,extraLinesBeyondLastLine:Me,desiredRatio:ve,minimapLineCount:H}=fe.computeContainedMinimapLineCount({viewLineCount:St,scrollBeyondLastLine:Kt,paddingTop:Q.paddingTop,paddingBottom:Q.paddingBottom,height:He,lineHeight:Dt,pixelRatio:Ye});if(St/H>1)ct=!0,gt=!0,yt=1,Ot=1,Pt=yt/Ye;else{let je=!1,Qe=yt+1;if(zt==="fit"){const qe=Math.ceil((Ce+St+Me)*Ot);Vt&&vt&&Lt<=Ee.stableFitRemainingWidth?(je=!0,Qe=Ee.stableFitMaxMinimapScale):je=qe>Wt}if(zt==="fill"||je){ct=!0;const qe=yt;Ot=Math.min(Dt*Ye,Math.max(1,Math.floor(1/ve))),Vt&&vt&&Lt<=Ee.stableFitRemainingWidth&&(Qe=Ee.stableFitMaxMinimapScale),yt=Math.min(Qe,Math.max(1,Math.floor(Ot/Xe))),yt>qe&&(Rt=Math.min(2,yt/qe)),Pt=yt/Ye/Rt,Wt=Math.ceil(Math.max(Jt,Ce+St+Me)*Ot),Vt?(Ee.stableMinimapLayoutInput=Q,Ee.stableFitRemainingWidth=Lt,Ee.stableFitMaxMinimapScale=yt):(Ee.stableMinimapLayoutInput=null,Ee.stableFitRemainingWidth=0)}}}const ft=Math.floor(jt*Pt),kt=Math.min(ft,Math.max(0,Math.floor((Lt-Bt-2)*Pt/(ze+Pt)))+e.MINIMAP_GUTTER_WIDTH);let At=Math.floor(Ye*kt);const Ct=At/Ye;At=Math.floor(At*Rt);const We=Ht?1:2,Nt=Gt==="left"?0:Be-kt-Bt;return{renderMinimap:We,minimapLeft:Nt,minimapWidth:kt,minimapHeightIsEditorHeight:ct,minimapIsSampling:gt,minimapScale:yt,minimapLineHeight:Ot,minimapCanvasInnerWidth:At,minimapCanvasInnerHeight:Wt,minimapCanvasOuterWidth:Ct,minimapCanvasOuterHeight:qt}}static computeLayout(Q,Ee){const Be=Ee.outerWidth|0,He=Ee.outerHeight|0,Ye=Ee.lineHeight|0,st=Ee.lineNumbersDigitCount|0,vt=Ee.typicalHalfwidthCharacterWidth,Dt=Ee.maxDigitWidth,ze=Ee.pixelRatio,Kt=Ee.viewLineCount,Ht=Q.get(135),yt=Ht==="inherit"?Q.get(134):Ht,jt=yt==="inherit"?Q.get(130):yt,zt=Q.get(133),Gt=Ee.isDominatedByLongLines,Bt=Q.get(57),St=Q.get(67).renderType!==0,Lt=Q.get(68),Vt=Q.get(104),Xe=Q.get(83),Wt=Q.get(72),qt=Q.get(102),ct=qt.verticalScrollbarSize,gt=qt.verticalHasArrows,Ot=qt.arrowSize,Pt=qt.horizontalScrollbarSize,Rt=Q.get(43),ft=Q.get(109)!=="never";let kt=Q.get(65);Rt&&ft&&(kt+=16);let At=0;if(St){const pt=Math.max(st,Lt);At=Math.round(pt*Dt)}let Ct=0;Bt&&(Ct=Ye*Ee.glyphMarginDecorationLaneCount);let We=0,Nt=We+Ct,Jt=Nt+At,Ce=Jt+kt;const Me=Be-Ct-At-kt;let ve=!1,H=!1,Le=-1;yt==="inherit"&&Gt?(ve=!0,H=!0):jt==="on"||jt==="bounded"?H=!0:jt==="wordWrapColumn"&&(Le=zt);const je=fe.c({outerWidth:Be,outerHeight:He,lineHeight:Ye,typicalHalfwidthCharacterWidth:vt,pixelRatio:ze,scrollBeyondLastLine:Vt,paddingTop:Xe.top,paddingBottom:Xe.bottom,minimap:Wt,verticalScrollbarWidth:ct,viewLineCount:Kt,remainingWidth:Me,isViewportWrapping:H},Ee.memory||new C);je.renderMinimap!==0&&je.minimapLeft===0&&(We+=je.minimapWidth,Nt+=je.minimapWidth,Jt+=je.minimapWidth,Ce+=je.minimapWidth);const Qe=Me-je.minimapWidth,qe=Math.max(1,Math.floor((Qe-ct-2)/vt)),it=gt?Ot:0;return H&&(Le=Math.max(1,qe),jt==="bounded"&&(Le=Math.min(Le,zt))),{width:Be,height:He,glyphMarginLeft:We,glyphMarginWidth:Ct,glyphMarginDecorationLaneCount:Ee.glyphMarginDecorationLaneCount,lineNumbersLeft:Nt,lineNumbersWidth:At,decorationsLeft:Jt,decorationsWidth:kt,contentLeft:Ce,contentWidth:Qe,minimap:je,viewportColumn:qe,isWordWrapMinified:ve,isViewportWrapping:H,wrappingColumn:Le,verticalScrollbarWidth:ct,horizontalScrollbarHeight:Pt,overviewRuler:{top:it,width:ct,height:He-2*it,right:0}}}}e.EditorLayoutInfoComputer=fe;class $e extends D{constructor(){super(137,"wrappingStrategy","simple",{"editor.wrappingStrategy":{enumDescriptions:[$.localize(47,null),$.localize(48,null)],type:"string",enum:["simple","advanced"],default:"simple",description:$.localize(49,null)}})}validate(Q){return s(Q,"simple",["simple","advanced"])}compute(Q,Ee,Be){return Ee.get(2)===2?"advanced":Be}}class re extends D{constructor(){const Q={enabled:!0};super(64,"lightbulb",Q,{"editor.lightbulb.enabled":{type:"boolean",default:Q.enabled,description:$.localize(50,null)}})}validate(Q){return!Q||typeof Q!="object"?this.defaultValue:{enabled:t(Q.enabled,this.defaultValue.enabled)}}}class Ae extends D{constructor(){const Q={enabled:!1,maxLineCount:5,defaultModel:"outlineModel",scrollWithEditor:!0};super(114,"stickyScroll",Q,{"editor.stickyScroll.enabled":{type:"boolean",default:Q.enabled,description:$.localize(51,null)},"editor.stickyScroll.maxLineCount":{type:"number",default:Q.maxLineCount,minimum:1,maximum:10,description:$.localize(52,null)},"editor.stickyScroll.defaultModel":{type:"string",enum:["outlineModel","foldingProviderModel","indentationModel"],default:Q.defaultModel,description:$.localize(53,null)},"editor.stickyScroll.scrollWithEditor":{type:"boolean",default:Q.scrollWithEditor,description:$.localize(54,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const Ee=Q;return{enabled:t(Ee.enabled,this.defaultValue.enabled),maxLineCount:c.clampedInt(Ee.maxLineCount,this.defaultValue.maxLineCount,1,10),defaultModel:s(Ee.defaultModel,this.defaultValue.defaultModel,["outlineModel","foldingProviderModel","indentationModel"]),scrollWithEditor:t(Ee.scrollWithEditor,this.defaultValue.scrollWithEditor)}}}class se extends D{constructor(){const Q={enabled:"on",fontSize:0,fontFamily:"",padding:!1};super(139,"inlayHints",Q,{"editor.inlayHints.enabled":{type:"string",default:Q.enabled,description:$.localize(55,null),enum:["on","onUnlessPressed","offUnlessPressed","off"],markdownEnumDescriptions:[$.localize(56,null),$.localize(57,null,P.$j?"Ctrl+Option":"Ctrl+Alt"),$.localize(58,null,P.$j?"Ctrl+Option":"Ctrl+Alt"),$.localize(59,null)]},"editor.inlayHints.fontSize":{type:"number",default:Q.fontSize,markdownDescription:$.localize(60,null,"`#editor.fontSize#`","`5`")},"editor.inlayHints.fontFamily":{type:"string",default:Q.fontFamily,markdownDescription:$.localize(61,null,"`#editor.fontFamily#`")},"editor.inlayHints.padding":{type:"boolean",default:Q.padding,description:$.localize(62,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const Ee=Q;return typeof Ee.enabled=="boolean"&&(Ee.enabled=Ee.enabled?"on":"off"),{enabled:s(Ee.enabled,this.defaultValue.enabled,["on","off","offUnlessPressed","onUnlessPressed"]),fontSize:c.clampedInt(Ee.fontSize,this.defaultValue.fontSize,0,100),fontFamily:n.string(Ee.fontFamily,this.defaultValue.fontFamily),padding:t(Ee.padding,this.defaultValue.padding)}}}class X extends D{constructor(){super(65,"lineDecorationsWidth",10)}validate(Q){return typeof Q=="string"&&/^\d+(\.\d+)?ch$/.test(Q)?-parseFloat(Q.substring(0,Q.length-2)):c.clampedInt(Q,this.defaultValue,0,1e3)}compute(Q,Ee,Be){return Be<0?c.clampedInt(-Be*Q.fontInfo.typicalHalfwidthCharacterWidth,this.defaultValue,0,1e3):Be}}class B extends l{constructor(){super(66,"lineHeight",e.EDITOR_FONT_DEFAULTS.lineHeight,Q=>l.clamp(Q,0,150),{markdownDescription:$.localize(63,null)})}compute(Q,Ee,Be){return Q.fontInfo.lineHeight}}class ie extends D{constructor(){const Q={enabled:!0,size:"proportional",side:"right",showSlider:"mouseover",autohide:!1,renderCharacters:!0,maxColumn:120,scale:1};super(72,"minimap",Q,{"editor.minimap.enabled":{type:"boolean",default:Q.enabled,description:$.localize(64,null)},"editor.minimap.autohide":{type:"boolean",default:Q.autohide,description:$.localize(65,null)},"editor.minimap.size":{type:"string",enum:["proportional","fill","fit"],enumDescriptions:[$.localize(66,null),$.localize(67,null),$.localize(68,null)],default:Q.size,description:$.localize(69,null)},"editor.minimap.side":{type:"string",enum:["left","right"],default:Q.side,description:$.localize(70,null)},"editor.minimap.showSlider":{type:"string",enum:["always","mouseover"],default:Q.showSlider,description:$.localize(71,null)},"editor.minimap.scale":{type:"number",default:Q.scale,minimum:1,maximum:3,enum:[1,2,3],description:$.localize(72,null)},"editor.minimap.renderCharacters":{type:"boolean",default:Q.renderCharacters,description:$.localize(73,null)},"editor.minimap.maxColumn":{type:"number",default:Q.maxColumn,description:$.localize(74,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const Ee=Q;return{enabled:t(Ee.enabled,this.defaultValue.enabled),autohide:t(Ee.autohide,this.defaultValue.autohide),size:s(Ee.size,this.defaultValue.size,["proportional","fill","fit"]),side:s(Ee.side,this.defaultValue.side,["right","left"]),showSlider:s(Ee.showSlider,this.defaultValue.showSlider,["always","mouseover"]),renderCharacters:t(Ee.renderCharacters,this.defaultValue.renderCharacters),scale:c.clampedInt(Ee.scale,1,1,3),maxColumn:c.clampedInt(Ee.maxColumn,this.defaultValue.maxColumn,1,1e4)}}}function pe(Y){return Y==="ctrlCmd"?P.$j?"metaKey":"ctrlKey":"altKey"}class ne extends D{constructor(){super(83,"padding",{top:0,bottom:0},{"editor.padding.top":{type:"number",default:0,minimum:0,maximum:1e3,description:$.localize(75,null)},"editor.padding.bottom":{type:"number",default:0,minimum:0,maximum:1e3,description:$.localize(76,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const Ee=Q;return{top:c.clampedInt(Ee.top,0,0,1e3),bottom:c.clampedInt(Ee.bottom,0,0,1e3)}}}class le extends D{constructor(){const Q={enabled:!0,cycle:!0};super(85,"parameterHints",Q,{"editor.parameterHints.enabled":{type:"boolean",default:Q.enabled,description:$.localize(77,null)},"editor.parameterHints.cycle":{type:"boolean",default:Q.cycle,description:$.localize(78,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const Ee=Q;return{enabled:t(Ee.enabled,this.defaultValue.enabled),cycle:t(Ee.cycle,this.defaultValue.cycle)}}}class ce extends p{constructor(){super(141)}compute(Q,Ee,Be){return Q.pixelRatio}}class we extends D{constructor(){const Q={other:"on",comments:"off",strings:"off"},Ee=[{type:"boolean"},{type:"string",enum:["on","inline","off"],enumDescriptions:[$.localize(79,null),$.localize(80,null),$.localize(81,null)]}];super(88,"quickSuggestions",Q,{type:"object",additionalProperties:!1,properties:{strings:{anyOf:Ee,default:Q.strings,description:$.localize(82,null)},comments:{anyOf:Ee,default:Q.comments,description:$.localize(83,null)},other:{anyOf:Ee,default:Q.other,description:$.localize(84,null)}},default:Q,markdownDescription:$.localize(85,null,"#editor.suggestOnTriggerCharacters#")}),this.defaultValue=Q}validate(Q){if(typeof Q=="boolean"){const ze=Q?"on":"off";return{comments:ze,strings:ze,other:ze}}if(!Q||typeof Q!="object")return this.defaultValue;const{other:Ee,comments:Be,strings:He}=Q,Ye=["on","inline","off"];let st,vt,Dt;return typeof Ee=="boolean"?st=Ee?"on":"off":st=s(Ee,this.defaultValue.other,Ye),typeof Be=="boolean"?vt=Be?"on":"off":vt=s(Be,this.defaultValue.comments,Ye),typeof He=="boolean"?Dt=He?"on":"off":Dt=s(He,this.defaultValue.strings,Ye),{other:st,comments:vt,strings:Dt}}}var _;(function(Y){Y[Y.Off=0]="Off",Y[Y.On=1]="On",Y[Y.Relative=2]="Relative",Y[Y.Interval=3]="Interval",Y[Y.Custom=4]="Custom"})(_||(e.RenderLineNumbersType=_={}));class de extends D{constructor(){super(67,"lineNumbers",{renderType:1,renderFn:null},{type:"string",enum:["off","on","relative","interval"],enumDescriptions:[$.localize(86,null),$.localize(87,null),$.localize(88,null),$.localize(89,null)],default:"on",description:$.localize(90,null)})}validate(Q){let Ee=this.defaultValue.renderType,Be=this.defaultValue.renderFn;return typeof Q<"u"&&(typeof Q=="function"?(Ee=4,Be=Q):Q==="interval"?Ee=3:Q==="relative"?Ee=2:Q==="on"?Ee=1:Ee=0),{renderType:Ee,renderFn:Be}}}function te(Y){const Q=Y.get(97);return Q==="editable"?Y.get(90):Q!=="on"}e.filterValidationDecorations=te;class ae extends D{constructor(){const Q=[],Ee={type:"number",description:$.localize(91,null)};super(101,"rulers",Q,{type:"array",items:{anyOf:[Ee,{type:["object"],properties:{column:Ee,color:{type:"string",description:$.localize(92,null),format:"color-hex"}}}]},default:Q,description:$.localize(93,null)})}validate(Q){if(Array.isArray(Q)){const Ee=[];for(const Be of Q)if(typeof Be=="number")Ee.push({column:c.clampedInt(Be,0,0,1e4),color:null});else if(Be&&typeof Be=="object"){const He=Be;Ee.push({column:c.clampedInt(He.column,0,0,1e4),color:He.color})}return Ee.sort((Be,He)=>Be.column-He.column),Ee}return this.defaultValue}}class me extends D{constructor(){super(91,"readOnlyMessage",void 0)}validate(Q){return!Q||typeof Q!="object"?this.defaultValue:Q}}function Ie(Y,Q){if(typeof Y!="string")return Q;switch(Y){case"hidden":return 2;case"visible":return 3;default:return 1}}class O extends D{constructor(){const Q={vertical:1,horizontal:1,arrowSize:11,useShadows:!0,verticalHasArrows:!1,horizontalHasArrows:!1,horizontalScrollbarSize:12,horizontalSliderSize:12,verticalScrollbarSize:14,verticalSliderSize:14,handleMouseWheel:!0,alwaysConsumeMouseWheel:!0,scrollByPage:!1,ignoreHorizontalScrollbarInContentHeight:!1};super(102,"scrollbar",Q,{"editor.scrollbar.vertical":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[$.localize(94,null),$.localize(95,null),$.localize(96,null)],default:"auto",description:$.localize(97,null)},"editor.scrollbar.horizontal":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[$.localize(98,null),$.localize(99,null),$.localize(100,null)],default:"auto",description:$.localize(101,null)},"editor.scrollbar.verticalScrollbarSize":{type:"number",default:Q.verticalScrollbarSize,description:$.localize(102,null)},"editor.scrollbar.horizontalScrollbarSize":{type:"number",default:Q.horizontalScrollbarSize,description:$.localize(103,null)},"editor.scrollbar.scrollByPage":{type:"boolean",default:Q.scrollByPage,description:$.localize(104,null)},"editor.scrollbar.ignoreHorizontalScrollbarInContentHeight":{type:"boolean",default:Q.ignoreHorizontalScrollbarInContentHeight,description:$.localize(105,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const Ee=Q,Be=c.clampedInt(Ee.horizontalScrollbarSize,this.defaultValue.horizontalScrollbarSize,0,1e3),He=c.clampedInt(Ee.verticalScrollbarSize,this.defaultValue.verticalScrollbarSize,0,1e3);return{arrowSize:c.clampedInt(Ee.arrowSize,this.defaultValue.arrowSize,0,1e3),vertical:Ie(Ee.vertical,this.defaultValue.vertical),horizontal:Ie(Ee.horizontal,this.defaultValue.horizontal),useShadows:t(Ee.useShadows,this.defaultValue.useShadows),verticalHasArrows:t(Ee.verticalHasArrows,this.defaultValue.verticalHasArrows),horizontalHasArrows:t(Ee.horizontalHasArrows,this.defaultValue.horizontalHasArrows),handleMouseWheel:t(Ee.handleMouseWheel,this.defaultValue.handleMouseWheel),alwaysConsumeMouseWheel:t(Ee.alwaysConsumeMouseWheel,this.defaultValue.alwaysConsumeMouseWheel),horizontalScrollbarSize:Be,horizontalSliderSize:c.clampedInt(Ee.horizontalSliderSize,Be,0,1e3),verticalScrollbarSize:He,verticalSliderSize:c.clampedInt(Ee.verticalSliderSize,He,0,1e3),scrollByPage:t(Ee.scrollByPage,this.defaultValue.scrollByPage),ignoreHorizontalScrollbarInContentHeight:t(Ee.ignoreHorizontalScrollbarInContentHeight,this.defaultValue.ignoreHorizontalScrollbarInContentHeight)}}}e.inUntrustedWorkspace="inUntrustedWorkspace",e.unicodeHighlightConfigKeys={allowedCharacters:"editor.unicodeHighlight.allowedCharacters",invisibleCharacters:"editor.unicodeHighlight.invisibleCharacters",nonBasicASCII:"editor.unicodeHighlight.nonBasicASCII",ambiguousCharacters:"editor.unicodeHighlight.ambiguousCharacters",includeComments:"editor.unicodeHighlight.includeComments",includeStrings:"editor.unicodeHighlight.includeStrings",allowedLocales:"editor.unicodeHighlight.allowedLocales"};class W extends D{constructor(){const Q={nonBasicASCII:e.inUntrustedWorkspace,invisibleCharacters:!0,ambiguousCharacters:!0,includeComments:e.inUntrustedWorkspace,includeStrings:!0,allowedCharacters:{},allowedLocales:{_os:!0,_vscode:!0}};super(124,"unicodeHighlight",Q,{[e.unicodeHighlightConfigKeys.nonBasicASCII]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:Q.nonBasicASCII,description:$.localize(106,null)},[e.unicodeHighlightConfigKeys.invisibleCharacters]:{restricted:!0,type:"boolean",default:Q.invisibleCharacters,description:$.localize(107,null)},[e.unicodeHighlightConfigKeys.ambiguousCharacters]:{restricted:!0,type:"boolean",default:Q.ambiguousCharacters,description:$.localize(108,null)},[e.unicodeHighlightConfigKeys.includeComments]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:Q.includeComments,description:$.localize(109,null)},[e.unicodeHighlightConfigKeys.includeStrings]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:Q.includeStrings,description:$.localize(110,null)},[e.unicodeHighlightConfigKeys.allowedCharacters]:{restricted:!0,type:"object",default:Q.allowedCharacters,description:$.localize(111,null),additionalProperties:{type:"boolean"}},[e.unicodeHighlightConfigKeys.allowedLocales]:{restricted:!0,type:"object",additionalProperties:{type:"boolean"},default:Q.allowedLocales,description:$.localize(112,null)}})}applyUpdate(Q,Ee){let Be=!1;Ee.allowedCharacters&&Q&&(F.$en(Q.allowedCharacters,Ee.allowedCharacters)||(Q={...Q,allowedCharacters:Ee.allowedCharacters},Be=!0)),Ee.allowedLocales&&Q&&(F.$en(Q.allowedLocales,Ee.allowedLocales)||(Q={...Q,allowedLocales:Ee.allowedLocales},Be=!0));const He=super.applyUpdate(Q,Ee);return Be?new u(He.newValue,!0):He}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const Ee=Q;return{nonBasicASCII:x(Ee.nonBasicASCII,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),invisibleCharacters:t(Ee.invisibleCharacters,this.defaultValue.invisibleCharacters),ambiguousCharacters:t(Ee.ambiguousCharacters,this.defaultValue.ambiguousCharacters),includeComments:x(Ee.includeComments,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),includeStrings:x(Ee.includeStrings,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),allowedCharacters:this.c(Q.allowedCharacters,this.defaultValue.allowedCharacters),allowedLocales:this.c(Q.allowedLocales,this.defaultValue.allowedLocales)}}c(Q,Ee){if(typeof Q!="object"||!Q)return Ee;const Be={};for(const[He,Ye]of Object.entries(Q))Ye===!0&&(Be[He]=!0);return Be}}class G extends D{constructor(){const Q={enabled:!0,mode:"subwordSmart",showToolbar:"onHover",suppressSuggestions:!1,keepOnBlur:!1};super(62,"inlineSuggest",Q,{"editor.inlineSuggest.enabled":{type:"boolean",default:Q.enabled,description:$.localize(113,null)},"editor.inlineSuggest.showToolbar":{type:"string",default:Q.showToolbar,enum:["always","onHover"],enumDescriptions:[$.localize(114,null),$.localize(115,null)],description:$.localize(116,null)},"editor.inlineSuggest.suppressSuggestions":{type:"boolean",default:Q.suppressSuggestions,description:$.localize(117,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const Ee=Q;return{enabled:t(Ee.enabled,this.defaultValue.enabled),mode:s(Ee.mode,this.defaultValue.mode,["prefix","subword","subwordSmart"]),showToolbar:s(Ee.showToolbar,this.defaultValue.showToolbar,["always","onHover"]),suppressSuggestions:t(Ee.suppressSuggestions,this.defaultValue.suppressSuggestions),keepOnBlur:t(Ee.keepOnBlur,this.defaultValue.keepOnBlur)}}}class J extends D{constructor(){const Q={enabled:M.$9r.bracketPairColorizationOptions.enabled,independentColorPoolPerBracketType:M.$9r.bracketPairColorizationOptions.independentColorPoolPerBracketType};super(15,"bracketPairColorization",Q,{"editor.bracketPairColorization.enabled":{type:"boolean",default:Q.enabled,markdownDescription:$.localize(118,null,"`#workbench.colorCustomizations#`")},"editor.bracketPairColorization.independentColorPoolPerBracketType":{type:"boolean",default:Q.independentColorPoolPerBracketType,description:$.localize(119,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const Ee=Q;return{enabled:t(Ee.enabled,this.defaultValue.enabled),independentColorPoolPerBracketType:t(Ee.independentColorPoolPerBracketType,this.defaultValue.independentColorPoolPerBracketType)}}}class q extends D{constructor(){const Q={bracketPairs:!1,bracketPairsHorizontal:"active",highlightActiveBracketPair:!0,indentation:!0,highlightActiveIndentation:!0};super(16,"guides",Q,{"editor.guides.bracketPairs":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[$.localize(120,null),$.localize(121,null),$.localize(122,null)],default:Q.bracketPairs,description:$.localize(123,null)},"editor.guides.bracketPairsHorizontal":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[$.localize(124,null),$.localize(125,null),$.localize(126,null)],default:Q.bracketPairsHorizontal,description:$.localize(127,null)},"editor.guides.highlightActiveBracketPair":{type:"boolean",default:Q.highlightActiveBracketPair,description:$.localize(128,null)},"editor.guides.indentation":{type:"boolean",default:Q.indentation,description:$.localize(129,null)},"editor.guides.highlightActiveIndentation":{type:["boolean","string"],enum:[!0,"always",!1],enumDescriptions:[$.localize(130,null),$.localize(131,null),$.localize(132,null)],default:Q.highlightActiveIndentation,description:$.localize(133,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const Ee=Q;return{bracketPairs:x(Ee.bracketPairs,this.defaultValue.bracketPairs,[!0,!1,"active"]),bracketPairsHorizontal:x(Ee.bracketPairsHorizontal,this.defaultValue.bracketPairsHorizontal,[!0,!1,"active"]),highlightActiveBracketPair:t(Ee.highlightActiveBracketPair,this.defaultValue.highlightActiveBracketPair),indentation:t(Ee.indentation,this.defaultValue.indentation),highlightActiveIndentation:x(Ee.highlightActiveIndentation,this.defaultValue.highlightActiveIndentation,[!0,!1,"always"])}}}function x(Y,Q,Ee){const Be=Ee.indexOf(Y);return Be===-1?Q:Ee[Be]}class ue extends D{constructor(){const Q={insertMode:"insert",filterGraceful:!0,snippetsPreventQuickSuggestions:!1,localityBonus:!1,shareSuggestSelections:!1,selectionMode:"always",showIcons:!0,showStatusBar:!1,preview:!1,previewMode:"subwordSmart",showInlineDetails:!0,showMethods:!0,showFunctions:!0,showConstructors:!0,showDeprecated:!0,matchOnWordStartOnly:!0,showFields:!0,showVariables:!0,showClasses:!0,showStructs:!0,showInterfaces:!0,showModules:!0,showProperties:!0,showEvents:!0,showOperators:!0,showUnits:!0,showValues:!0,showConstants:!0,showEnums:!0,showEnumMembers:!0,showKeywords:!0,showWords:!0,showColors:!0,showFiles:!0,showReferences:!0,showFolders:!0,showTypeParameters:!0,showSnippets:!0,showUsers:!0,showIssues:!0};super(117,"suggest",Q,{"editor.suggest.insertMode":{type:"string",enum:["insert","replace"],enumDescriptions:[$.localize(134,null),$.localize(135,null)],default:Q.insertMode,description:$.localize(136,null)},"editor.suggest.filterGraceful":{type:"boolean",default:Q.filterGraceful,description:$.localize(137,null)},"editor.suggest.localityBonus":{type:"boolean",default:Q.localityBonus,description:$.localize(138,null)},"editor.suggest.shareSuggestSelections":{type:"boolean",default:Q.shareSuggestSelections,markdownDescription:$.localize(139,null)},"editor.suggest.selectionMode":{type:"string",enum:["always","never","whenTriggerCharacter","whenQuickSuggestion"],enumDescriptions:[$.localize(140,null),$.localize(141,null),$.localize(142,null),$.localize(143,null)],default:Q.selectionMode,markdownDescription:$.localize(144,null)},"editor.suggest.snippetsPreventQuickSuggestions":{type:"boolean",default:Q.snippetsPreventQuickSuggestions,description:$.localize(145,null)},"editor.suggest.showIcons":{type:"boolean",default:Q.showIcons,description:$.localize(146,null)},"editor.suggest.showStatusBar":{type:"boolean",default:Q.showStatusBar,description:$.localize(147,null)},"editor.suggest.preview":{type:"boolean",default:Q.preview,description:$.localize(148,null)},"editor.suggest.showInlineDetails":{type:"boolean",default:Q.showInlineDetails,description:$.localize(149,null)},"editor.suggest.maxVisibleSuggestions":{type:"number",deprecationMessage:$.localize(150,null)},"editor.suggest.filteredTypes":{type:"object",deprecationMessage:$.localize(151,null)},"editor.suggest.showMethods":{type:"boolean",default:!0,markdownDescription:$.localize(152,null)},"editor.suggest.showFunctions":{type:"boolean",default:!0,markdownDescription:$.localize(153,null)},"editor.suggest.showConstructors":{type:"boolean",default:!0,markdownDescription:$.localize(154,null)},"editor.suggest.showDeprecated":{type:"boolean",default:!0,markdownDescription:$.localize(155,null)},"editor.suggest.matchOnWordStartOnly":{type:"boolean",default:!0,markdownDescription:$.localize(156,null)},"editor.suggest.showFields":{type:"boolean",default:!0,markdownDescription:$.localize(157,null)},"editor.suggest.showVariables":{type:"boolean",default:!0,markdownDescription:$.localize(158,null)},"editor.suggest.showClasses":{type:"boolean",default:!0,markdownDescription:$.localize(159,null)},"editor.suggest.showStructs":{type:"boolean",default:!0,markdownDescription:$.localize(160,null)},"editor.suggest.showInterfaces":{type:"boolean",default:!0,markdownDescription:$.localize(161,null)},"editor.suggest.showModules":{type:"boolean",default:!0,markdownDescription:$.localize(162,null)},"editor.suggest.showProperties":{type:"boolean",default:!0,markdownDescription:$.localize(163,null)},"editor.suggest.showEvents":{type:"boolean",default:!0,markdownDescription:$.localize(164,null)},"editor.suggest.showOperators":{type:"boolean",default:!0,markdownDescription:$.localize(165,null)},"editor.suggest.showUnits":{type:"boolean",default:!0,markdownDescription:$.localize(166,null)},"editor.suggest.showValues":{type:"boolean",default:!0,markdownDescription:$.localize(167,null)},"editor.suggest.showConstants":{type:"boolean",default:!0,markdownDescription:$.localize(168,null)},"editor.suggest.showEnums":{type:"boolean",default:!0,markdownDescription:$.localize(169,null)},"editor.suggest.showEnumMembers":{type:"boolean",default:!0,markdownDescription:$.localize(170,null)},"editor.suggest.showKeywords":{type:"boolean",default:!0,markdownDescription:$.localize(171,null)},"editor.suggest.showWords":{type:"boolean",default:!0,markdownDescription:$.localize(172,null)},"editor.suggest.showColors":{type:"boolean",default:!0,markdownDescription:$.localize(173,null)},"editor.suggest.showFiles":{type:"boolean",default:!0,markdownDescription:$.localize(174,null)},"editor.suggest.showReferences":{type:"boolean",default:!0,markdownDescription:$.localize(175,null)},"editor.suggest.showCustomcolors":{type:"boolean",default:!0,markdownDescription:$.localize(176,null)},"editor.suggest.showFolders":{type:"boolean",default:!0,markdownDescription:$.localize(177,null)},"editor.suggest.showTypeParameters":{type:"boolean",default:!0,markdownDescription:$.localize(178,null)},"editor.suggest.showSnippets":{type:"boolean",default:!0,markdownDescription:$.localize(179,null)},"editor.suggest.showUsers":{type:"boolean",default:!0,markdownDescription:$.localize(180,null)},"editor.suggest.showIssues":{type:"boolean",default:!0,markdownDescription:$.localize(181,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const Ee=Q;return{insertMode:s(Ee.insertMode,this.defaultValue.insertMode,["insert","replace"]),filterGraceful:t(Ee.filterGraceful,this.defaultValue.filterGraceful),snippetsPreventQuickSuggestions:t(Ee.snippetsPreventQuickSuggestions,this.defaultValue.filterGraceful),localityBonus:t(Ee.localityBonus,this.defaultValue.localityBonus),shareSuggestSelections:t(Ee.shareSuggestSelections,this.defaultValue.shareSuggestSelections),selectionMode:s(Ee.selectionMode,this.defaultValue.selectionMode,["always","never","whenQuickSuggestion","whenTriggerCharacter"]),showIcons:t(Ee.showIcons,this.defaultValue.showIcons),showStatusBar:t(Ee.showStatusBar,this.defaultValue.showStatusBar),preview:t(Ee.preview,this.defaultValue.preview),previewMode:s(Ee.previewMode,this.defaultValue.previewMode,["prefix","subword","subwordSmart"]),showInlineDetails:t(Ee.showInlineDetails,this.defaultValue.showInlineDetails),showMethods:t(Ee.showMethods,this.defaultValue.showMethods),showFunctions:t(Ee.showFunctions,this.defaultValue.showFunctions),showConstructors:t(Ee.showConstructors,this.defaultValue.showConstructors),showDeprecated:t(Ee.showDeprecated,this.defaultValue.showDeprecated),matchOnWordStartOnly:t(Ee.matchOnWordStartOnly,this.defaultValue.matchOnWordStartOnly),showFields:t(Ee.showFields,this.defaultValue.showFields),showVariables:t(Ee.showVariables,this.defaultValue.showVariables),showClasses:t(Ee.showClasses,this.defaultValue.showClasses),showStructs:t(Ee.showStructs,this.defaultValue.showStructs),showInterfaces:t(Ee.showInterfaces,this.defaultValue.showInterfaces),showModules:t(Ee.showModules,this.defaultValue.showModules),showProperties:t(Ee.showProperties,this.defaultValue.showProperties),showEvents:t(Ee.showEvents,this.defaultValue.showEvents),showOperators:t(Ee.showOperators,this.defaultValue.showOperators),showUnits:t(Ee.showUnits,this.defaultValue.showUnits),showValues:t(Ee.showValues,this.defaultValue.showValues),showConstants:t(Ee.showConstants,this.defaultValue.showConstants),showEnums:t(Ee.showEnums,this.defaultValue.showEnums),showEnumMembers:t(Ee.showEnumMembers,this.defaultValue.showEnumMembers),showKeywords:t(Ee.showKeywords,this.defaultValue.showKeywords),showWords:t(Ee.showWords,this.defaultValue.showWords),showColors:t(Ee.showColors,this.defaultValue.showColors),showFiles:t(Ee.showFiles,this.defaultValue.showFiles),showReferences:t(Ee.showReferences,this.defaultValue.showReferences),showFolders:t(Ee.showFolders,this.defaultValue.showFolders),showTypeParameters:t(Ee.showTypeParameters,this.defaultValue.showTypeParameters),showSnippets:t(Ee.showSnippets,this.defaultValue.showSnippets),showUsers:t(Ee.showUsers,this.defaultValue.showUsers),showIssues:t(Ee.showIssues,this.defaultValue.showIssues)}}}class Oe extends D{constructor(){super(112,"smartSelect",{selectLeadingAndTrailingWhitespace:!0,selectSubwords:!0},{"editor.smartSelect.selectLeadingAndTrailingWhitespace":{description:$.localize(182,null),default:!0,type:"boolean"},"editor.smartSelect.selectSubwords":{description:$.localize(183,null),default:!0,type:"boolean"}})}validate(Q){return!Q||typeof Q!="object"?this.defaultValue:{selectLeadingAndTrailingWhitespace:t(Q.selectLeadingAndTrailingWhitespace,this.defaultValue.selectLeadingAndTrailingWhitespace),selectSubwords:t(Q.selectSubwords,this.defaultValue.selectSubwords)}}}var Ue;(function(Y){Y[Y.None=0]="None",Y[Y.Same=1]="Same",Y[Y.Indent=2]="Indent",Y[Y.DeepIndent=3]="DeepIndent"})(Ue||(e.WrappingIndent=Ue={}));class Ze extends D{constructor(){super(136,"wrappingIndent",1,{"editor.wrappingIndent":{type:"string",enum:["none","same","indent","deepIndent"],enumDescriptions:[$.localize(184,null),$.localize(185,null),$.localize(186,null),$.localize(187,null)],description:$.localize(188,null),default:"same"}})}validate(Q){switch(Q){case"none":return 0;case"same":return 1;case"indent":return 2;case"deepIndent":return 3}return 1}compute(Q,Ee,Be){return Ee.get(2)===2?0:Be}}class Je extends p{constructor(){super(144)}compute(Q,Ee,Be){const He=Ee.get(143);return{isDominatedByLongLines:Q.isDominatedByLongLines,isWordWrapMinified:He.isWordWrapMinified,isViewportWrapping:He.isViewportWrapping,wrappingColumn:He.wrappingColumn}}}class tt extends D{constructor(){const Q={enabled:!0,showDropSelector:"afterDrop"};super(36,"dropIntoEditor",Q,{"editor.dropIntoEditor.enabled":{type:"boolean",default:Q.enabled,markdownDescription:$.localize(189,null)},"editor.dropIntoEditor.showDropSelector":{type:"string",markdownDescription:$.localize(190,null),enum:["afterDrop","never"],enumDescriptions:[$.localize(191,null),$.localize(192,null)],default:"afterDrop"}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const Ee=Q;return{enabled:t(Ee.enabled,this.defaultValue.enabled),showDropSelector:s(Ee.showDropSelector,this.defaultValue.showDropSelector,["afterDrop","never"])}}}class _e extends D{constructor(){const Q={enabled:!0,showPasteSelector:"afterPaste"};super(84,"pasteAs",Q,{"editor.pasteAs.enabled":{type:"boolean",default:Q.enabled,markdownDescription:$.localize(193,null)},"editor.pasteAs.showPasteSelector":{type:"string",markdownDescription:$.localize(194,null),enum:["afterPaste","never"],enumDescriptions:[$.localize(195,null),$.localize(196,null)],default:"afterPaste"}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const Ee=Q;return{enabled:t(Ee.enabled,this.defaultValue.enabled),showPasteSelector:s(Ee.showPasteSelector,this.defaultValue.showPasteSelector,["afterPaste","never"])}}}const et="Consolas, 'Courier New', monospace",rt="Menlo, Monaco, 'Courier New', monospace",nt="'Droid Sans Mono', 'monospace', monospace";e.EDITOR_FONT_DEFAULTS={fontFamily:P.$j?rt:P.$k?nt:et,fontWeight:"normal",fontSize:P.$j?12:14,lineHeight:0,letterSpacing:0},e.editorOptionsRegistry=[];function Ne(Y){return e.editorOptionsRegistry[Y.id]=Y,Y}var dt;(function(Y){Y[Y.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",Y[Y.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",Y[Y.accessibilitySupport=2]="accessibilitySupport",Y[Y.accessibilityPageSize=3]="accessibilityPageSize",Y[Y.ariaLabel=4]="ariaLabel",Y[Y.ariaRequired=5]="ariaRequired",Y[Y.autoClosingBrackets=6]="autoClosingBrackets",Y[Y.autoClosingComments=7]="autoClosingComments",Y[Y.screenReaderAnnounceInlineSuggestion=8]="screenReaderAnnounceInlineSuggestion",Y[Y.autoClosingDelete=9]="autoClosingDelete",Y[Y.autoClosingOvertype=10]="autoClosingOvertype",Y[Y.autoClosingQuotes=11]="autoClosingQuotes",Y[Y.autoIndent=12]="autoIndent",Y[Y.automaticLayout=13]="automaticLayout",Y[Y.autoSurround=14]="autoSurround",Y[Y.bracketPairColorization=15]="bracketPairColorization",Y[Y.guides=16]="guides",Y[Y.codeLens=17]="codeLens",Y[Y.codeLensFontFamily=18]="codeLensFontFamily",Y[Y.codeLensFontSize=19]="codeLensFontSize",Y[Y.colorDecorators=20]="colorDecorators",Y[Y.colorDecoratorsLimit=21]="colorDecoratorsLimit",Y[Y.columnSelection=22]="columnSelection",Y[Y.comments=23]="comments",Y[Y.contextmenu=24]="contextmenu",Y[Y.copyWithSyntaxHighlighting=25]="copyWithSyntaxHighlighting",Y[Y.cursorBlinking=26]="cursorBlinking",Y[Y.cursorSmoothCaretAnimation=27]="cursorSmoothCaretAnimation",Y[Y.cursorStyle=28]="cursorStyle",Y[Y.cursorSurroundingLines=29]="cursorSurroundingLines",Y[Y.cursorSurroundingLinesStyle=30]="cursorSurroundingLinesStyle",Y[Y.cursorWidth=31]="cursorWidth",Y[Y.disableLayerHinting=32]="disableLayerHinting",Y[Y.disableMonospaceOptimizations=33]="disableMonospaceOptimizations",Y[Y.domReadOnly=34]="domReadOnly",Y[Y.dragAndDrop=35]="dragAndDrop",Y[Y.dropIntoEditor=36]="dropIntoEditor",Y[Y.emptySelectionClipboard=37]="emptySelectionClipboard",Y[Y.experimentalWhitespaceRendering=38]="experimentalWhitespaceRendering",Y[Y.extraEditorClassName=39]="extraEditorClassName",Y[Y.fastScrollSensitivity=40]="fastScrollSensitivity",Y[Y.find=41]="find",Y[Y.fixedOverflowWidgets=42]="fixedOverflowWidgets",Y[Y.folding=43]="folding",Y[Y.foldingStrategy=44]="foldingStrategy",Y[Y.foldingHighlight=45]="foldingHighlight",Y[Y.foldingImportsByDefault=46]="foldingImportsByDefault",Y[Y.foldingMaximumRegions=47]="foldingMaximumRegions",Y[Y.unfoldOnClickAfterEndOfLine=48]="unfoldOnClickAfterEndOfLine",Y[Y.fontFamily=49]="fontFamily",Y[Y.fontInfo=50]="fontInfo",Y[Y.fontLigatures=51]="fontLigatures",Y[Y.fontSize=52]="fontSize",Y[Y.fontWeight=53]="fontWeight",Y[Y.fontVariations=54]="fontVariations",Y[Y.formatOnPaste=55]="formatOnPaste",Y[Y.formatOnType=56]="formatOnType",Y[Y.glyphMargin=57]="glyphMargin",Y[Y.gotoLocation=58]="gotoLocation",Y[Y.hideCursorInOverviewRuler=59]="hideCursorInOverviewRuler",Y[Y.hover=60]="hover",Y[Y.inDiffEditor=61]="inDiffEditor",Y[Y.inlineSuggest=62]="inlineSuggest",Y[Y.letterSpacing=63]="letterSpacing",Y[Y.lightbulb=64]="lightbulb",Y[Y.lineDecorationsWidth=65]="lineDecorationsWidth",Y[Y.lineHeight=66]="lineHeight",Y[Y.lineNumbers=67]="lineNumbers",Y[Y.lineNumbersMinChars=68]="lineNumbersMinChars",Y[Y.linkedEditing=69]="linkedEditing",Y[Y.links=70]="links",Y[Y.matchBrackets=71]="matchBrackets",Y[Y.minimap=72]="minimap",Y[Y.mouseStyle=73]="mouseStyle",Y[Y.mouseWheelScrollSensitivity=74]="mouseWheelScrollSensitivity",Y[Y.mouseWheelZoom=75]="mouseWheelZoom",Y[Y.multiCursorMergeOverlapping=76]="multiCursorMergeOverlapping",Y[Y.multiCursorModifier=77]="multiCursorModifier",Y[Y.multiCursorPaste=78]="multiCursorPaste",Y[Y.multiCursorLimit=79]="multiCursorLimit",Y[Y.occurrencesHighlight=80]="occurrencesHighlight",Y[Y.overviewRulerBorder=81]="overviewRulerBorder",Y[Y.overviewRulerLanes=82]="overviewRulerLanes",Y[Y.padding=83]="padding",Y[Y.pasteAs=84]="pasteAs",Y[Y.parameterHints=85]="parameterHints",Y[Y.peekWidgetDefaultFocus=86]="peekWidgetDefaultFocus",Y[Y.definitionLinkOpensInPeek=87]="definitionLinkOpensInPeek",Y[Y.quickSuggestions=88]="quickSuggestions",Y[Y.quickSuggestionsDelay=89]="quickSuggestionsDelay",Y[Y.readOnly=90]="readOnly",Y[Y.readOnlyMessage=91]="readOnlyMessage",Y[Y.renameOnType=92]="renameOnType",Y[Y.renderControlCharacters=93]="renderControlCharacters",Y[Y.renderFinalNewline=94]="renderFinalNewline",Y[Y.renderLineHighlight=95]="renderLineHighlight",Y[Y.renderLineHighlightOnlyWhenFocus=96]="renderLineHighlightOnlyWhenFocus",Y[Y.renderValidationDecorations=97]="renderValidationDecorations",Y[Y.renderWhitespace=98]="renderWhitespace",Y[Y.revealHorizontalRightPadding=99]="revealHorizontalRightPadding",Y[Y.roundedSelection=100]="roundedSelection",Y[Y.rulers=101]="rulers",Y[Y.scrollbar=102]="scrollbar",Y[Y.scrollBeyondLastColumn=103]="scrollBeyondLastColumn",Y[Y.scrollBeyondLastLine=104]="scrollBeyondLastLine",Y[Y.scrollPredominantAxis=105]="scrollPredominantAxis",Y[Y.selectionClipboard=106]="selectionClipboard",Y[Y.selectionHighlight=107]="selectionHighlight",Y[Y.selectOnLineNumbers=108]="selectOnLineNumbers",Y[Y.showFoldingControls=109]="showFoldingControls",Y[Y.showUnused=110]="showUnused",Y[Y.snippetSuggestions=111]="snippetSuggestions",Y[Y.smartSelect=112]="smartSelect",Y[Y.smoothScrolling=113]="smoothScrolling",Y[Y.stickyScroll=114]="stickyScroll",Y[Y.stickyTabStops=115]="stickyTabStops",Y[Y.stopRenderingLineAfter=116]="stopRenderingLineAfter",Y[Y.suggest=117]="suggest",Y[Y.suggestFontSize=118]="suggestFontSize",Y[Y.suggestLineHeight=119]="suggestLineHeight",Y[Y.suggestOnTriggerCharacters=120]="suggestOnTriggerCharacters",Y[Y.suggestSelection=121]="suggestSelection",Y[Y.tabCompletion=122]="tabCompletion",Y[Y.tabIndex=123]="tabIndex",Y[Y.unicodeHighlighting=124]="unicodeHighlighting",Y[Y.unusualLineTerminators=125]="unusualLineTerminators",Y[Y.useShadowDOM=126]="useShadowDOM",Y[Y.useTabStops=127]="useTabStops",Y[Y.wordBreak=128]="wordBreak",Y[Y.wordSeparators=129]="wordSeparators",Y[Y.wordWrap=130]="wordWrap",Y[Y.wordWrapBreakAfterCharacters=131]="wordWrapBreakAfterCharacters",Y[Y.wordWrapBreakBeforeCharacters=132]="wordWrapBreakBeforeCharacters",Y[Y.wordWrapColumn=133]="wordWrapColumn",Y[Y.wordWrapOverride1=134]="wordWrapOverride1",Y[Y.wordWrapOverride2=135]="wordWrapOverride2",Y[Y.wrappingIndent=136]="wrappingIndent",Y[Y.wrappingStrategy=137]="wrappingStrategy",Y[Y.showDeprecated=138]="showDeprecated",Y[Y.inlayHints=139]="inlayHints",Y[Y.editorClassName=140]="editorClassName",Y[Y.pixelRatio=141]="pixelRatio",Y[Y.tabFocusMode=142]="tabFocusMode",Y[Y.layoutInfo=143]="layoutInfo",Y[Y.wrappingInfo=144]="wrappingInfo",Y[Y.defaultColorDecorators=145]="defaultColorDecorators",Y[Y.colorDecoratorsActivatedOn=146]="colorDecoratorsActivatedOn",Y[Y.inlineCompletionsAccessibilityVerbose=147]="inlineCompletionsAccessibilityVerbose"})(dt||(e.EditorOption=dt={})),e.EditorOptions={acceptSuggestionOnCommitCharacter:Ne(new i(0,"acceptSuggestionOnCommitCharacter",!0,{markdownDescription:$.localize(197,null)})),acceptSuggestionOnEnter:Ne(new a(1,"acceptSuggestionOnEnter","on",["on","smart","off"],{markdownEnumDescriptions:["",$.localize(198,null),""],markdownDescription:$.localize(199,null)})),accessibilitySupport:Ne(new m),accessibilityPageSize:Ne(new c(3,"accessibilityPageSize",10,1,1073741824,{description:$.localize(200,null),tags:["accessibility"]})),ariaLabel:Ne(new n(4,"ariaLabel",$.localize(201,null))),ariaRequired:Ne(new i(5,"ariaRequired",!1,void 0)),screenReaderAnnounceInlineSuggestion:Ne(new i(8,"screenReaderAnnounceInlineSuggestion",!0,{description:$.localize(202,null),tags:["accessibility"]})),autoClosingBrackets:Ne(new a(6,"autoClosingBrackets","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",$.localize(203,null),$.localize(204,null),""],description:$.localize(205,null)})),autoClosingComments:Ne(new a(7,"autoClosingComments","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",$.localize(206,null),$.localize(207,null),""],description:$.localize(208,null)})),autoClosingDelete:Ne(new a(9,"autoClosingDelete","auto",["always","auto","never"],{enumDescriptions:["",$.localize(209,null),""],description:$.localize(210,null)})),autoClosingOvertype:Ne(new a(10,"autoClosingOvertype","auto",["always","auto","never"],{enumDescriptions:["",$.localize(211,null),""],description:$.localize(212,null)})),autoClosingQuotes:Ne(new a(11,"autoClosingQuotes","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",$.localize(213,null),$.localize(214,null),""],description:$.localize(215,null)})),autoIndent:Ne(new d(12,"autoIndent",4,"full",["none","keep","brackets","advanced","full"],v,{enumDescriptions:[$.localize(216,null),$.localize(217,null),$.localize(218,null),$.localize(219,null),$.localize(220,null)],description:$.localize(221,null)})),automaticLayout:Ne(new i(13,"automaticLayout",!1)),autoSurround:Ne(new a(14,"autoSurround","languageDefined",["languageDefined","quotes","brackets","never"],{enumDescriptions:[$.localize(222,null),$.localize(223,null),$.localize(224,null),""],description:$.localize(225,null)})),bracketPairColorization:Ne(new J),bracketPairGuides:Ne(new q),stickyTabStops:Ne(new i(115,"stickyTabStops",!1,{description:$.localize(226,null)})),codeLens:Ne(new i(17,"codeLens",!0,{description:$.localize(227,null)})),codeLensFontFamily:Ne(new n(18,"codeLensFontFamily","",{description:$.localize(228,null)})),codeLensFontSize:Ne(new c(19,"codeLensFontSize",0,0,100,{type:"number",default:0,minimum:0,maximum:100,markdownDescription:$.localize(229,null)})),colorDecorators:Ne(new i(20,"colorDecorators",!0,{description:$.localize(230,null)})),colorDecoratorActivatedOn:Ne(new a(146,"colorDecoratorsActivatedOn","clickAndHover",["clickAndHover","hover","click"],{enumDescriptions:[$.localize(231,null),$.localize(232,null),$.localize(233,null)],description:$.localize(234,null)})),colorDecoratorsLimit:Ne(new c(21,"colorDecoratorsLimit",500,1,1e6,{markdownDescription:$.localize(235,null)})),columnSelection:Ne(new i(22,"columnSelection",!1,{description:$.localize(236,null)})),comments:Ne(new S),contextmenu:Ne(new i(24,"contextmenu",!0)),copyWithSyntaxHighlighting:Ne(new i(25,"copyWithSyntaxHighlighting",!0,{description:$.localize(237,null)})),cursorBlinking:Ne(new d(26,"cursorBlinking",1,"blink",["blink","smooth","phase","expand","solid"],h,{description:$.localize(238,null)})),cursorSmoothCaretAnimation:Ne(new a(27,"cursorSmoothCaretAnimation","off",["off","explicit","on"],{enumDescriptions:[$.localize(239,null),$.localize(240,null),$.localize(241,null)],description:$.localize(242,null)})),cursorStyle:Ne(new d(28,"cursorStyle",w.Line,"line",["line","block","underline","line-thin","block-outline","underline-thin"],L,{description:$.localize(243,null)})),cursorSurroundingLines:Ne(new c(29,"cursorSurroundingLines",0,0,1073741824,{description:$.localize(244,null)})),cursorSurroundingLinesStyle:Ne(new a(30,"cursorSurroundingLinesStyle","default",["default","all"],{enumDescriptions:[$.localize(245,null),$.localize(246,null)],markdownDescription:$.localize(247,null)})),cursorWidth:Ne(new c(31,"cursorWidth",0,0,1073741824,{markdownDescription:$.localize(248,null)})),disableLayerHinting:Ne(new i(32,"disableLayerHinting",!1)),disableMonospaceOptimizations:Ne(new i(33,"disableMonospaceOptimizations",!1)),domReadOnly:Ne(new i(34,"domReadOnly",!1)),dragAndDrop:Ne(new i(35,"dragAndDrop",!0,{description:$.localize(249,null)})),emptySelectionClipboard:Ne(new K),dropIntoEditor:Ne(new tt),stickyScroll:Ne(new Ae),experimentalWhitespaceRendering:Ne(new a(38,"experimentalWhitespaceRendering","svg",["svg","font","off"],{enumDescriptions:[$.localize(250,null),$.localize(251,null),$.localize(252,null)],description:$.localize(253,null)})),extraEditorClassName:Ne(new n(39,"extraEditorClassName","")),fastScrollSensitivity:Ne(new l(40,"fastScrollSensitivity",5,Y=>Y<=0?5:Y,{markdownDescription:$.localize(254,null)})),find:Ne(new R),fixedOverflowWidgets:Ne(new i(42,"fixedOverflowWidgets",!1)),folding:Ne(new i(43,"folding",!0,{description:$.localize(255,null)})),foldingStrategy:Ne(new a(44,"foldingStrategy","auto",["auto","indentation"],{enumDescriptions:[$.localize(256,null),$.localize(257,null)],description:$.localize(258,null)})),foldingHighlight:Ne(new i(45,"foldingHighlight",!0,{description:$.localize(259,null)})),foldingImportsByDefault:Ne(new i(46,"foldingImportsByDefault",!1,{description:$.localize(260,null)})),foldingMaximumRegions:Ne(new c(47,"foldingMaximumRegions",5e3,10,65e3,{description:$.localize(261,null)})),unfoldOnClickAfterEndOfLine:Ne(new i(48,"unfoldOnClickAfterEndOfLine",!1,{description:$.localize(262,null)})),fontFamily:Ne(new n(49,"fontFamily",e.EDITOR_FONT_DEFAULTS.fontFamily,{description:$.localize(263,null)})),fontInfo:Ne(new z),fontLigatures2:Ne(new N),fontSize:Ne(new Z),fontWeight:Ne(new he),fontVariations:Ne(new T),formatOnPaste:Ne(new i(55,"formatOnPaste",!1,{description:$.localize(264,null)})),formatOnType:Ne(new i(56,"formatOnType",!1,{description:$.localize(265,null)})),glyphMargin:Ne(new i(57,"glyphMargin",!0,{description:$.localize(266,null)})),gotoLocation:Ne(new ye),hideCursorInOverviewRuler:Ne(new i(59,"hideCursorInOverviewRuler",!1,{description:$.localize(267,null)})),hover:Ne(new De),inDiffEditor:Ne(new i(61,"inDiffEditor",!1)),letterSpacing:Ne(new l(63,"letterSpacing",e.EDITOR_FONT_DEFAULTS.letterSpacing,Y=>l.clamp(Y,-5,20),{description:$.localize(268,null)})),lightbulb:Ne(new re),lineDecorationsWidth:Ne(new X),lineHeight:Ne(new B),lineNumbers:Ne(new de),lineNumbersMinChars:Ne(new c(68,"lineNumbersMinChars",5,1,300)),linkedEditing:Ne(new i(69,"linkedEditing",!1,{description:$.localize(269,null)})),links:Ne(new i(70,"links",!0,{description:$.localize(270,null)})),matchBrackets:Ne(new a(71,"matchBrackets","always",["always","near","never"],{description:$.localize(271,null)})),minimap:Ne(new ie),mouseStyle:Ne(new a(73,"mouseStyle","text",["text","default","copy"])),mouseWheelScrollSensitivity:Ne(new l(74,"mouseWheelScrollSensitivity",1,Y=>Y===0?1:Y,{markdownDescription:$.localize(272,null)})),mouseWheelZoom:Ne(new i(75,"mouseWheelZoom",!1,{markdownDescription:$.localize(273,null)})),multiCursorMergeOverlapping:Ne(new i(76,"multiCursorMergeOverlapping",!0,{description:$.localize(274,null)})),multiCursorModifier:Ne(new d(77,"multiCursorModifier","altKey","alt",["ctrlCmd","alt"],pe,{markdownEnumDescriptions:[$.localize(275,null),$.localize(276,null)],markdownDescription:$.localize(277,null)})),multiCursorPaste:Ne(new a(78,"multiCursorPaste","spread",["spread","full"],{markdownEnumDescriptions:[$.localize(278,null),$.localize(279,null)],markdownDescription:$.localize(280,null)})),multiCursorLimit:Ne(new c(79,"multiCursorLimit",1e4,1,1e5,{markdownDescription:$.localize(281,null)})),occurrencesHighlight:Ne(new a(80,"occurrencesHighlight","singleFile",["off","singleFile","multiFile"],{markdownEnumDescriptions:[$.localize(282,null),$.localize(283,null),$.localize(284,null)],markdownDescription:$.localize(285,null)})),overviewRulerBorder:Ne(new i(81,"overviewRulerBorder",!0,{description:$.localize(286,null)})),overviewRulerLanes:Ne(new c(82,"overviewRulerLanes",3,0,3)),padding:Ne(new ne),pasteAs:Ne(new _e),parameterHints:Ne(new le),peekWidgetDefaultFocus:Ne(new a(86,"peekWidgetDefaultFocus","tree",["tree","editor"],{enumDescriptions:[$.localize(287,null),$.localize(288,null)],description:$.localize(289,null)})),definitionLinkOpensInPeek:Ne(new i(87,"definitionLinkOpensInPeek",!1,{description:$.localize(290,null)})),quickSuggestions:Ne(new we),quickSuggestionsDelay:Ne(new c(89,"quickSuggestionsDelay",10,0,1073741824,{description:$.localize(291,null)})),readOnly:Ne(new i(90,"readOnly",!1)),readOnlyMessage:Ne(new me),renameOnType:Ne(new i(92,"renameOnType",!1,{description:$.localize(292,null),markdownDeprecationMessage:$.localize(293,null)})),renderControlCharacters:Ne(new i(93,"renderControlCharacters",!0,{description:$.localize(294,null),restricted:!0})),renderFinalNewline:Ne(new a(94,"renderFinalNewline",P.$k?"dimmed":"on",["off","on","dimmed"],{description:$.localize(295,null)})),renderLineHighlight:Ne(new a(95,"renderLineHighlight","line",["none","gutter","line","all"],{enumDescriptions:["","","",$.localize(296,null)],description:$.localize(297,null)})),renderLineHighlightOnlyWhenFocus:Ne(new i(96,"renderLineHighlightOnlyWhenFocus",!1,{description:$.localize(298,null)})),renderValidationDecorations:Ne(new a(97,"renderValidationDecorations","editable",["editable","on","off"])),renderWhitespace:Ne(new a(98,"renderWhitespace","selection",["none","boundary","selection","trailing","all"],{enumDescriptions:["",$.localize(299,null),$.localize(300,null),$.localize(301,null),""],description:$.localize(302,null)})),revealHorizontalRightPadding:Ne(new c(99,"revealHorizontalRightPadding",15,0,1e3)),roundedSelection:Ne(new i(100,"roundedSelection",!0,{description:$.localize(303,null)})),rulers:Ne(new ae),scrollbar:Ne(new O),scrollBeyondLastColumn:Ne(new c(103,"scrollBeyondLastColumn",4,0,1073741824,{description:$.localize(304,null)})),scrollBeyondLastLine:Ne(new i(104,"scrollBeyondLastLine",!0,{description:$.localize(305,null)})),scrollPredominantAxis:Ne(new i(105,"scrollPredominantAxis",!0,{description:$.localize(306,null)})),selectionClipboard:Ne(new i(106,"selectionClipboard",!0,{description:$.localize(307,null),included:P.$k})),selectionHighlight:Ne(new i(107,"selectionHighlight",!0,{description:$.localize(308,null)})),selectOnLineNumbers:Ne(new i(108,"selectOnLineNumbers",!0)),showFoldingControls:Ne(new a(109,"showFoldingControls","mouseover",["always","never","mouseover"],{enumDescriptions:[$.localize(309,null),$.localize(310,null),$.localize(311,null)],description:$.localize(312,null)})),showUnused:Ne(new i(110,"showUnused",!0,{description:$.localize(313,null)})),showDeprecated:Ne(new i(138,"showDeprecated",!0,{description:$.localize(314,null)})),inlayHints:Ne(new se),snippetSuggestions:Ne(new a(111,"snippetSuggestions","inline",["top","bottom","inline","none"],{enumDescriptions:[$.localize(315,null),$.localize(316,null),$.localize(317,null),$.localize(318,null)],description:$.localize(319,null)})),smartSelect:Ne(new Oe),smoothScrolling:Ne(new i(113,"smoothScrolling",!1,{description:$.localize(320,null)})),stopRenderingLineAfter:Ne(new c(116,"stopRenderingLineAfter",1e4,-1,1073741824)),suggest:Ne(new ue),inlineSuggest:Ne(new G),inlineCompletionsAccessibilityVerbose:Ne(new i(147,"inlineCompletionsAccessibilityVerbose",!1,{description:$.localize(321,null)})),suggestFontSize:Ne(new c(118,"suggestFontSize",0,0,1e3,{markdownDescription:$.localize(322,null,"`0`","`#editor.fontSize#`")})),suggestLineHeight:Ne(new c(119,"suggestLineHeight",0,0,1e3,{markdownDescription:$.localize(323,null,"`0`","`#editor.lineHeight#`")})),suggestOnTriggerCharacters:Ne(new i(120,"suggestOnTriggerCharacters",!0,{description:$.localize(324,null)})),suggestSelection:Ne(new a(121,"suggestSelection","first",["first","recentlyUsed","recentlyUsedByPrefix"],{markdownEnumDescriptions:[$.localize(325,null),$.localize(326,null),$.localize(327,null)],description:$.localize(328,null)})),tabCompletion:Ne(new a(122,"tabCompletion","off",["on","off","onlySnippets"],{enumDescriptions:[$.localize(329,null),$.localize(330,null),$.localize(331,null)],description:$.localize(332,null)})),tabIndex:Ne(new c(123,"tabIndex",0,-1,1073741824)),unicodeHighlight:Ne(new W),unusualLineTerminators:Ne(new a(125,"unusualLineTerminators","prompt",["auto","off","prompt"],{enumDescriptions:[$.localize(333,null),$.localize(334,null),$.localize(335,null)],description:$.localize(336,null)})),useShadowDOM:Ne(new i(126,"useShadowDOM",!0)),useTabStops:Ne(new i(127,"useTabStops",!0,{description:$.localize(337,null)})),wordBreak:Ne(new a(128,"wordBreak","normal",["normal","keepAll"],{markdownEnumDescriptions:[$.localize(338,null),$.localize(339,null)],description:$.localize(340,null)})),wordSeparators:Ne(new n(129,"wordSeparators",A.$0r,{description:$.localize(341,null)})),wordWrap:Ne(new a(130,"wordWrap","off",["off","on","wordWrapColumn","bounded"],{markdownEnumDescriptions:[$.localize(342,null),$.localize(343,null),$.localize(344,null),$.localize(345,null)],description:$.localize(346,null)})),wordWrapBreakAfterCharacters:Ne(new n(131,"wordWrapBreakAfterCharacters"," 	})]?|/&.,;\xA2\xB0\u2032\u2033\u2030\u2103\u3001\u3002\uFF61\uFF64\uFFE0\uFF0C\uFF0E\uFF1A\uFF1B\uFF1F\uFF01\uFF05\u30FB\uFF65\u309D\u309E\u30FD\u30FE\u30FC\u30A1\u30A3\u30A5\u30A7\u30A9\u30C3\u30E3\u30E5\u30E7\u30EE\u30F5\u30F6\u3041\u3043\u3045\u3047\u3049\u3063\u3083\u3085\u3087\u308E\u3095\u3096\u31F0\u31F1\u31F2\u31F3\u31F4\u31F5\u31F6\u31F7\u31F8\u31F9\u31FA\u31FB\u31FC\u31FD\u31FE\u31FF\u3005\u303B\uFF67\uFF68\uFF69\uFF6A\uFF6B\uFF6C\uFF6D\uFF6E\uFF6F\uFF70\u201D\u3009\u300B\u300D\u300F\u3011\u3015\uFF09\uFF3D\uFF5D\uFF63")),wordWrapBreakBeforeCharacters:Ne(new n(132,"wordWrapBreakBeforeCharacters","([{\u2018\u201C\u3008\u300A\u300C\u300E\u3010\u3014\uFF08\uFF3B\uFF5B\uFF62\xA3\xA5\uFF04\uFFE1\uFFE5+\uFF0B")),wordWrapColumn:Ne(new c(133,"wordWrapColumn",80,1,1073741824,{markdownDescription:$.localize(347,null)})),wordWrapOverride1:Ne(new a(134,"wordWrapOverride1","inherit",["off","on","inherit"])),wordWrapOverride2:Ne(new a(135,"wordWrapOverride2","inherit",["off","on","inherit"])),editorClassName:Ne(new V),defaultColorDecorators:Ne(new i(145,"defaultColorDecorators",!1,{markdownDescription:$.localize(348,null)})),pixelRatio:Ne(new ce),tabFocusMode:Ne(new i(142,"tabFocusMode",!1,{markdownDescription:$.localize(349,null)})),layoutInfo:Ne(new fe),wrappingInfo:Ne(new Je),wrappingIndent:Ne(new Ze),wrappingStrategy:Ne(new $e)}}),define(Pe[148],Re([9,10]),function(be,e){return be.create("vs/platform/configuration/common/configurationRegistry",e)}),define(Pe[149],Re([9,10]),function(be,e){return be.create("vs/platform/contextkey/common/contextkey",e)}),define(Pe[150],Re([9,10]),function(be,e){return be.create("vs/platform/contextkey/common/scanner",e)}),define(Pe[151],Re([9,10]),function(be,e){return be.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(Pe[152],Re([9,10]),function(be,e){return be.create("vs/platform/extensions/common/extensionValidator",e)}),define(Pe[153],Re([9,10]),function(be,e){return be.create("vs/platform/files/common/files",e)}),define(Pe[154],Re([9,10]),function(be,e){return be.create("vs/platform/markers/common/markers",e)}),define(Pe[155],Re([9,10]),function(be,e){return be.create("vs/platform/theme/common/iconRegistry",e)}),define(Pe[156],Re([9,10]),function(be,e){return be.create("vs/platform/workspace/common/workspace",e)}),define(Pe[157],Re([9,10]),function(be,e){return be.create("vs/workbench/api/common/extHostChatAgents2",e)}),define(Pe[158],Re([9,10]),function(be,e){return be.create("vs/workbench/api/common/extHostDiagnostics",e)}),define(Pe[159],Re([9,10]),function(be,e){return be.create("vs/workbench/api/common/extHostExtensionService",e)}),define(Pe[160],Re([9,10]),function(be,e){return be.create("vs/workbench/api/common/extHostLanguageFeatures",e)}),define(Pe[161],Re([9,10]),function(be,e){return be.create("vs/workbench/api/common/extHostLogService",e)}),define(Pe[162],Re([9,10]),function(be,e){return be.create("vs/workbench/api/common/extHostNotebook",e)}),define(Pe[163],Re([9,10]),function(be,e){return be.create("vs/workbench/api/common/extHostProgress",e)}),define(Pe[164],Re([9,10]),function(be,e){return be.create("vs/workbench/api/common/extHostStatusBar",e)}),define(Pe[165],Re([9,10]),function(be,e){return be.create("vs/workbench/api/common/extHostTelemetry",e)}),define(Pe[166],Re([9,10]),function(be,e){return be.create("vs/workbench/api/common/extHostTerminalService",e)}),define(Pe[167],Re([9,10]),function(be,e){return be.create("vs/workbench/api/common/extHostTreeViews",e)}),define(Pe[168],Re([9,10]),function(be,e){return be.create("vs/workbench/api/common/extHostTunnelService",e)}),define(Pe[169],Re([9,10]),function(be,e){return be.create("vs/workbench/api/common/extHostWorkspace",e)}),define(Pe[170],Re([9,10]),function(be,e){return be.create("vs/workbench/common/configuration",e)}),define(Pe[171],Re([9,10]),function(be,e){return be.create("vs/workbench/common/editor",e)}),define(Pe[172],Re([9,10]),function(be,e){return be.create("vs/workbench/common/views",e)}),define(Pe[173],Re([9,10]),function(be,e){return be.create("vs/workbench/contrib/debug/common/abstractDebugAdapter",e)}),define(Pe[174],Re([9,10]),function(be,e){return be.create("vs/workbench/contrib/debug/common/debug",e)}),define(Pe[175],Re([9,10]),function(be,e){return be.create("vs/workbench/contrib/tasks/common/taskDefinitionRegistry",e)}),define(Pe[176],Re([9,10]),function(be,e){return be.create("vs/workbench/contrib/tasks/common/tasks",e)}),define(Pe[177],Re([9,10]),function(be,e){return be.create("vs/workbench/services/configurationResolver/common/variableResolver",e)}),define(Pe[178],Re([9,10]),function(be,e){return be.create("vs/workbench/services/editor/common/editorResolverService",e)}),define(Pe[179],Re([9,10]),function(be,e){return be.create("vs/workbench/services/extensions/common/extensionsRegistry",e)}),define(Pe[180],Re([9,10]),function(be,e){return be.create("vs/workbench/services/search/common/queryBuilder",e)}),define(Pe[181],Re([1,0,11,150]),function(be,e,y,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qi=e.TokenType=void 0;var P;(function(f){f[f.LParen=0]="LParen",f[f.RParen=1]="RParen",f[f.Neg=2]="Neg",f[f.Eq=3]="Eq",f[f.NotEq=4]="NotEq",f[f.Lt=5]="Lt",f[f.LtEq=6]="LtEq",f[f.Gt=7]="Gt",f[f.GtEq=8]="GtEq",f[f.RegexOp=9]="RegexOp",f[f.RegexStr=10]="RegexStr",f[f.True=11]="True",f[f.False=12]="False",f[f.In=13]="In",f[f.Not=14]="Not",f[f.And=15]="And",f[f.Or=16]="Or",f[f.Str=17]="Str",f[f.QuotedStr=18]="QuotedStr",f[f.Error=19]="Error",f[f.EOF=20]="EOF"})(P||(e.TokenType=P={}));function M(...f){switch(f.length){case 1:return(0,F.localize)(0,null,f[0]);case 2:return(0,F.localize)(1,null,f[0],f[1]);case 3:return(0,F.localize)(2,null,f[0],f[1],f[2]);default:return}}const A=(0,F.localize)(3,null),$=(0,F.localize)(4,null);class E{constructor(){this.c="",this.d=0,this.e=0,this.f=[],this.g=[],this.m=/[a-zA-Z0-9_<>\-\./\\:\*\?\+\[\]\^,#@;"%\$\p{L}-]+/uy}static getLexeme(C){switch(C.type){case 0:return"(";case 1:return")";case 2:return"!";case 3:return C.isTripleEq?"===":"==";case 4:return C.isTripleEq?"!==":"!=";case 5:return"<";case 6:return"<=";case 7:return">=";case 8:return">=";case 9:return"=~";case 10:return C.lexeme;case 11:return"true";case 12:return"false";case 13:return"in";case 14:return"not";case 15:return"&&";case 16:return"||";case 17:return C.lexeme;case 18:return C.lexeme;case 19:return C.lexeme;case 20:return"EOF";default:throw(0,y.$7)(`unhandled token type: ${JSON.stringify(C)}; have you forgotten to add a case?`)}}static{this.a=new Set(["i","g","s","m","y","u"].map(C=>C.charCodeAt(0)))}static{this.b=new Map([["not",14],["in",13],["false",12],["true",11]])}get errors(){return this.g}reset(C){return this.c=C,this.d=0,this.e=0,this.f=[],this.g=[],this}scan(){for(;!this.r();)switch(this.d=this.e,this.i()){case 40:this.k(0);break;case 41:this.k(1);break;case 33:if(this.h(61)){const D=this.h(61);this.f.push({type:4,offset:this.d,isTripleEq:D})}else this.k(2);break;case 39:this.o();break;case 47:this.q();break;case 61:if(this.h(61)){const D=this.h(61);this.f.push({type:3,offset:this.d,isTripleEq:D})}else this.h(126)?this.k(9):this.l(M("==","=~"));break;case 60:this.k(this.h(61)?6:5);break;case 62:this.k(this.h(61)?8:7);break;case 38:this.h(38)?this.k(15):this.l(M("&&"));break;case 124:this.h(124)?this.k(16):this.l(M("||"));break;case 32:case 13:case 9:case 10:case 160:break;default:this.n()}return this.d=this.e,this.k(20),Array.from(this.f)}h(C){return this.r()||this.c.charCodeAt(this.e)!==C?!1:(this.e++,!0)}i(){return this.c.charCodeAt(this.e++)}j(){return this.r()?0:this.c.charCodeAt(this.e)}k(C){this.f.push({type:C,offset:this.d})}l(C){const D=this.d,u=this.c.substring(this.d,this.e),b={type:19,offset:this.d,lexeme:u};this.g.push({offset:D,lexeme:u,additionalInfo:C}),this.f.push(b)}n(){this.m.lastIndex=this.d;const C=this.m.exec(this.c);if(C){this.e=this.d+C[0].length;const D=this.c.substring(this.d,this.e),u=E.b.get(D);u?this.k(u):this.f.push({type:17,lexeme:D,offset:this.d})}}o(){for(;this.j()!==39&&!this.r();)this.i();if(this.r()){this.l(A);return}this.i(),this.f.push({type:18,lexeme:this.c.substring(this.d+1,this.e-1),offset:this.d+1})}q(){let C=this.e,D=!1,u=!1;for(;;){if(C>=this.c.length){this.e=C,this.l($);return}const p=this.c.charCodeAt(C);if(D)D=!1;else if(p===47&&!u){C++;break}else p===91?u=!0:p===92?D=!0:p===93&&(u=!1);C++}for(;C<this.c.length&&E.a.has(this.c.charCodeAt(C));)C++;this.e=C;const b=this.c.substring(this.d,this.e);this.f.push({type:10,lexeme:b,offset:this.d})}r(){return this.e>=this.c.length}}e.$Qi=E}),define(Pe[182],Re([1,0,25,31,152,294]),function(be,e,y,F,P,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xo=e.$Wo=e.$Vo=e.$Uo=e.$To=e.$So=e.$Ro=void 0;const A=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,$=/^-(\d{4})(\d{2})(\d{2})$/;function E(i){return i=i.trim(),i==="*"||A.test(i)}e.$Ro=E;function f(i){if(!E(i))return null;if(i=i.trim(),i==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const r=i.match(A);return r?{hasCaret:r[1]==="^",hasGreaterEquals:r[1]===">=",majorBase:r[2]==="x"?0:parseInt(r[2],10),majorMustEqual:r[2]!=="x",minorBase:r[4]==="x"?0:parseInt(r[4],10),minorMustEqual:r[4]!=="x",patchBase:r[6]==="x"?0:parseInt(r[6],10),patchMustEqual:r[6]!=="x",preRelease:r[8]||null}:null}e.$So=f;function C(i){if(!i)return null;const r=i.majorBase,c=i.majorMustEqual,o=i.minorBase;let l=i.minorMustEqual;const n=i.patchBase;let s=i.patchMustEqual;i.hasCaret&&(r===0||(l=!1),s=!1);let a=0;if(i.preRelease){const d=$.exec(i.preRelease);if(d){const[,v,m,S]=d;a=Date.UTC(Number(v),Number(m)-1,Number(S))}}return{majorBase:r,majorMustEqual:c,minorBase:o,minorMustEqual:l,patchBase:n,patchMustEqual:s,isMinimum:i.hasGreaterEquals,notBefore:a}}e.$To=C;function D(i,r,c){let o;typeof i=="string"?o=C(f(i)):o=i;let l;r instanceof Date?l=r.getTime():typeof r=="string"&&(l=new Date(r).getTime());let n;if(typeof c=="string"?n=C(f(c)):n=c,!o||!n)return!1;const s=o.majorBase,a=o.minorBase,d=o.patchBase;let v=n.majorBase,m=n.minorBase,S=n.patchBase;const k=n.notBefore;let h=n.majorMustEqual,w=n.minorMustEqual,I=n.patchMustEqual;return n.isMinimum?s>v?!0:s<v?!1:a>m?!0:a<m||l&&l<k?!1:d>=S:(s===1&&v===0&&(!h||!w||!I)&&(v=1,m=0,S=0,h=!0,w=!1,I=!1),s<v?!1:s>v?!h:a<m?!1:a>m?!w:d<S?!1:d>S?!I:!(l&&l<k))}e.$Uo=D;function u(i,r,c,o,l){const n=[];if(typeof o.publisher<"u"&&typeof o.publisher!="string")return n.push([F.default.Error,P.localize(0,null)]),n;if(typeof o.name!="string")return n.push([F.default.Error,P.localize(1,null,"name")]),n;if(typeof o.version!="string")return n.push([F.default.Error,P.localize(2,null,"version")]),n;if(!o.engines)return n.push([F.default.Error,P.localize(3,null,"engines")]),n;if(typeof o.engines.vscode!="string")return n.push([F.default.Error,P.localize(4,null,"engines.vscode")]),n;if(typeof o.extensionDependencies<"u"&&!t(o.extensionDependencies))return n.push([F.default.Error,P.localize(5,null,"extensionDependencies")]),n;if(typeof o.activationEvents<"u"){if(!t(o.activationEvents))return n.push([F.default.Error,P.localize(6,null,"activationEvents")]),n;if(typeof o.main>"u"&&typeof o.browser>"u")return n.push([F.default.Error,P.localize(7,null,"activationEvents","main","browser")]),n}if(typeof o.extensionKind<"u"&&typeof o.main>"u"&&n.push([F.default.Warning,P.localize(8,null,"extensionKind")]),typeof o.main<"u"){if(typeof o.main!="string")return n.push([F.default.Error,P.localize(9,null,"main")]),n;{const d=(0,y.$zg)(c,o.main);(0,y.$tg)(d,c)||n.push([F.default.Warning,P.localize(10,null,d.path,c.path)])}}if(typeof o.browser<"u"){if(typeof o.browser!="string")return n.push([F.default.Error,P.localize(11,null,"browser")]),n;{const d=(0,y.$zg)(c,o.browser);(0,y.$tg)(d,c)||n.push([F.default.Warning,P.localize(12,null,d.path,c.path)])}}if(!M.valid(o.version))return n.push([F.default.Error,P.localize(13,null)]),n;const s=[];if(!b(i,r,o,l,s))for(const d of s)n.push([F.default.Error,d]);return n}e.$Vo=u;function b(i,r,c,o,l){return o||typeof c.main>"u"&&typeof c.browser>"u"?!0:g(i,r,c.engines.vscode,l)}e.$Wo=b;function p(i,r,c){return i==="*"||g(r,c,i)}e.$Xo=p;function g(i,r,c,o=[]){const l=C(f(c));if(!l)return o.push(P.localize(14,null,c)),!1;if(l.majorBase===0){if(!l.majorMustEqual||!l.minorMustEqual)return o.push(P.localize(15,null,c)),!1}else if(!l.majorMustEqual)return o.push(P.localize(16,null,c)),!1;return D(i,r,l)?!0:(o.push(P.localize(17,null,i,c)),!1)}function t(i){if(!Array.isArray(i))return!1;for(let r=0,c=i.length;r<c;r++)if(typeof i[r]!="string")return!1;return!0}}),define(Pe[69],Re([1,0]),function(be,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sh=void 0;class y{constructor(P,M=[],A=!1){this.ctor=P,this.staticArguments=M,this.supportsDelayedInstantiation=A}}e.$Sh=y}),define(Pe[70],Re([1,0,69]),function(be,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dr=e.$Cr=e.InstantiationType=void 0;const F=[];var P;(function($){$[$.Eager=0]="Eager",$[$.Delayed=1]="Delayed"})(P||(e.InstantiationType=P={}));function M($,E,f){E instanceof y.$Sh||(E=new y.$Sh(E,[],!!f)),F.push([$,E])}e.$Cr=M;function A(){return F}e.$Dr=A}),define(Pe[183],Re([1,0]),function(be,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$iq=e.$hq=void 0;class y{constructor(M,A){this.key=M,this.data=A,this.incoming=new Map,this.outgoing=new Map}}e.$hq=y;class F{constructor(M){this.b=M,this.a=new Map}roots(){const M=[];for(const A of this.a.values())A.outgoing.size===0&&M.push(A);return M}insertEdge(M,A){const $=this.lookupOrInsertNode(M),E=this.lookupOrInsertNode(A);$.outgoing.set(E.key,E),E.incoming.set($.key,$)}removeNode(M){const A=this.b(M);this.a.delete(A);for(const $ of this.a.values())$.outgoing.delete(A),$.incoming.delete(A)}lookupOrInsertNode(M){const A=this.b(M);let $=this.a.get(A);return $||($=new y(A,M),this.a.set(A,$)),$}lookup(M){return this.a.get(this.b(M))}isEmpty(){return this.a.size===0}toString(){const M=[];for(const[A,$]of this.a)M.push(`${A}
	(-> incoming)[${[...$.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...$.outgoing.keys()].join(",")}]
`);return M.join(`
`)}findCycleSlow(){for(const[M,A]of this.a){const $=new Set([M]),E=this.c(A,$);if(E)return E}}c(M,A){for(const[$,E]of M.outgoing){if(A.has($))return[...A,$].join(" -> ");A.add($);const f=this.c(E,A);if(f)return f;A.delete($)}}}e.$iq=F}),define(Pe[4],Re([1,0]),function(be,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wh=e.$Vh=e.$Uh=e._util=void 0;var y;(function(A){A.serviceIds=new Map,A.DI_TARGET="$di$target",A.DI_DEPENDENCIES="$di$dependencies";function $(E){return E[A.DI_DEPENDENCIES]||[]}A.getServiceDependencies=$})(y||(e._util=y={})),e.$Uh=P("instantiationService");function F(A,$,E){$[y.DI_TARGET]===$?$[y.DI_DEPENDENCIES].push({id:A,index:E}):($[y.DI_DEPENDENCIES]=[{id:A,index:E}],$[y.DI_TARGET]=$)}function P(A){if(y.serviceIds.has(A))return y.serviceIds.get(A);const $=function(E,f,C){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");F($,E,C)};return $.toString=()=>A,y.serviceIds.set(A,$),$}e.$Vh=P;function M(A){return A}e.$Wh=M}),define(Pe[40],Re([1,0,16,2,4]),function(be,e,y,F,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zi=e.$yi=e.$xi=e.$wi=e.$vi=e.$ui=e.$ti=e.$si=e.ConfigurationTarget=e.$ri=e.$qi=e.$pi=void 0,e.$pi=(0,P.$Vh)("configurationService");function M(i){return i&&typeof i=="object"&&(!i.overrideIdentifier||typeof i.overrideIdentifier=="string")&&(!i.resource||i.resource instanceof F.URI)}e.$qi=M;function A(i){return i&&typeof i=="object"&&(!i.overrideIdentifiers||Array.isArray(i.overrideIdentifiers))&&!i.overrideIdentifier&&(!i.resource||i.resource instanceof F.URI)}e.$ri=A;var $;(function(i){i[i.APPLICATION=1]="APPLICATION",i[i.USER=2]="USER",i[i.USER_LOCAL=3]="USER_LOCAL",i[i.USER_REMOTE=4]="USER_REMOTE",i[i.WORKSPACE=5]="WORKSPACE",i[i.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",i[i.DEFAULT=7]="DEFAULT",i[i.MEMORY=8]="MEMORY"})($||(e.ConfigurationTarget=$={}));function E(i){switch(i){case 1:return"APPLICATION";case 2:return"USER";case 3:return"USER_LOCAL";case 4:return"USER_REMOTE";case 5:return"WORKSPACE";case 6:return"WORKSPACE_FOLDER";case 7:return"DEFAULT";case 8:return"MEMORY"}}e.$si=E;function f(i){return i.applicationValue!==void 0||i.userValue!==void 0||i.userLocalValue!==void 0||i.userRemoteValue!==void 0||i.workspaceValue!==void 0||i.workspaceFolderValue!==void 0}e.$ti=f;function C(i,r){const c=Object.create(null);for(const o in i)D(c,o,i[o],r);return c}e.$ui=C;function D(i,r,c,o){const l=r.split("."),n=l.pop();let s=i;for(let a=0;a<l.length;a++){const d=l[a];let v=s[d];switch(typeof v){case"undefined":v=s[d]=Object.create(null);break;case"object":break;default:o(`Ignoring ${r} as ${l.slice(0,a+1).join(".")} is ${JSON.stringify(v)}`);return}s=v}if(typeof s=="object"&&s!==null)try{s[n]=c}catch{o(`Ignoring ${r} as ${l.join(".")} is ${JSON.stringify(s)}`)}else o(`Ignoring ${r} as ${l.join(".")} is ${JSON.stringify(s)}`)}e.$vi=D;function u(i,r){const c=r.split(".");b(i,c)}e.$wi=u;function b(i,r){const c=r.shift();if(r.length===0){delete i[c];return}if(Object.keys(i).indexOf(c)!==-1){const o=i[c];typeof o=="object"&&!Array.isArray(o)&&(b(o,r),Object.keys(o).length===0&&delete i[c])}}function p(i,r,c){function o(s,a){let d=s;for(const v of a){if(typeof d!="object"||d===null)return;d=d[v]}return d}const l=r.split("."),n=o(i,l);return typeof n>"u"?c:n}e.$xi=p;function g(i,r,c){Object.keys(r).forEach(o=>{o!=="__proto__"&&(o in i?y.$Ef(i[o])&&y.$Ef(r[o])?g(i[o],r[o],c):c&&(i[o]=r[o]):i[o]=r[o])})}e.$yi=g;function t(i){return i.replace(/[\[\]]/g,"")}e.$zi=t}),define(Pe[34],Re([1,0,21,12,181,4,149,11]),function(be,e,y,F,P,M,A,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cj=e.$bj=e.$aj=e.$_i=e.$$i=e.$0i=e.$9i=e.$8i=e.$7i=e.$6i=e.$5i=e.$4i=e.$3i=e.$2i=e.$1i=e.$Zi=e.$Yi=e.$Xi=e.$Wi=e.$Vi=e.$Ui=e.$Ti=e.$Si=e.ContextKeyExprType=e.$Ri=void 0;const E=new Map;E.set("false",!1),E.set("true",!0),E.set("isMac",y.$j),E.set("isLinux",y.$k),E.set("isWindows",y.$i),E.set("isWeb",y.$o),E.set("isMacNative",y.$j&&!y.$o),E.set("isEdge",y.$H),E.set("isFirefox",y.$F),E.set("isChrome",y.$E),E.set("isSafari",y.$G);function f(X,B){if(E.get(X)!==void 0)throw(0,$.$6)("contextkey.setConstant(k, v) invoked with already set constant `k`");E.set(X,B)}e.$Ri=f;const C=Object.prototype.hasOwnProperty;var D;(function(X){X[X.False=0]="False",X[X.True=1]="True",X[X.Defined=2]="Defined",X[X.Not=3]="Not",X[X.Equals=4]="Equals",X[X.NotEquals=5]="NotEquals",X[X.And=6]="And",X[X.Regex=7]="Regex",X[X.NotRegex=8]="NotRegex",X[X.Or=9]="Or",X[X.In=10]="In",X[X.NotIn=11]="NotIn",X[X.Greater=12]="Greater",X[X.GreaterEquals=13]="GreaterEquals",X[X.Smaller=14]="Smaller",X[X.SmallerEquals=15]="SmallerEquals"})(D||(e.ContextKeyExprType=D={}));const u={regexParsingWithErrorRecovery:!0},b=(0,A.localize)(0,null),p=(0,A.localize)(1,null),g=(0,A.localize)(2,null),t=(0,A.localize)(3,null),i=(0,A.localize)(4,null),r=(0,A.localize)(5,null),c=(0,A.localize)(6,null),o=(0,A.localize)(7,null);class l{static{this.c=new Error}get lexingErrors(){return this.d.errors}get parsingErrors(){return this.h}constructor(B=u){this.k=B,this.d=new P.$Qi,this.f=[],this.g=0,this.h=[],this.v=/g|y/g}parse(B){if(B===""){this.h.push({message:b,offset:0,lexeme:"",additionalInfo:p});return}this.f=this.d.reset(B).scan(),this.g=0,this.h=[];try{const ie=this.l();if(!this.E()){const pe=this.D(),ne=pe.type===17?r:void 0;throw this.h.push({message:i,offset:pe.offset,lexeme:P.$Qi.getLexeme(pe),additionalInfo:ne}),l.c}return ie}catch(ie){if(ie!==l.c)throw ie;return}}l(){return this.m()}m(){const B=[this.o()];for(;this.y(16);){const ie=this.o();B.push(ie)}return B.length===1?B[0]:n.or(...B)}o(){const B=[this.s()];for(;this.y(15);){const ie=this.s();B.push(ie)}return B.length===1?B[0]:n.and(...B)}s(){if(this.y(2)){const B=this.D();switch(B.type){case 11:return this.z(),v.INSTANCE;case 12:return this.z(),m.INSTANCE;case 0:{this.z();const ie=this.l();return this.A(1,t),ie?.negate()}case 17:return this.z(),L.create(B.lexeme);default:throw this.B("KEY | true | false | '(' expression ')'",B)}}return this.t()}t(){const B=this.D();switch(B.type){case 11:return this.z(),n.true();case 12:return this.z(),n.false();case 0:{this.z();const ie=this.l();return this.A(1,t),ie}case 17:{const ie=B.lexeme;if(this.z(),this.y(9)){const ne=this.D();if(!this.k.regexParsingWithErrorRecovery){if(this.z(),ne.type!==10)throw this.B("REGEX",ne);const le=ne.lexeme,ce=le.lastIndexOf("/"),we=ce===le.length-1?void 0:this.w(le.substring(ce+1));let _;try{_=new RegExp(le.substring(1,ce),we)}catch{throw this.B("REGEX",ne)}return z.create(ie,_)}switch(ne.type){case 10:case 19:{const le=[ne.lexeme];this.z();let ce=this.D(),we=0;for(let me=0;me<ne.lexeme.length;me++)ne.lexeme.charCodeAt(me)===40?we++:ne.lexeme.charCodeAt(me)===41&&we--;for(;!this.E()&&ce.type!==15&&ce.type!==16;){switch(ce.type){case 0:we++;break;case 1:we--;break;case 10:case 18:for(let me=0;me<ce.lexeme.length;me++)ce.lexeme.charCodeAt(me)===40?we++:ne.lexeme.charCodeAt(me)===41&&we--}if(we<0)break;le.push(P.$Qi.getLexeme(ce)),this.z(),ce=this.D()}const _=le.join(""),de=_.lastIndexOf("/"),te=de===_.length-1?void 0:this.w(_.substring(de+1));let ae;try{ae=new RegExp(_.substring(1,de),te)}catch{throw this.B("REGEX",ne)}return n.regex(ie,ae)}case 18:{const le=ne.lexeme;this.z();let ce=null;if(!(0,F.$Fe)(le)){const we=le.indexOf("/"),_=le.lastIndexOf("/");if(we!==_&&we>=0){const de=le.slice(we+1,_),te=le[_+1]==="i"?"i":"";try{ce=new RegExp(de,te)}catch{throw this.B("REGEX",ne)}}}if(ce===null)throw this.B("REGEX",ne);return z.create(ie,ce)}default:throw this.B("REGEX",this.D())}}if(this.y(14)){this.A(13,g);const ne=this.u();return n.notIn(ie,ne)}switch(this.D().type){case 3:{this.z();const ne=this.u();if(this.x().type===18)return n.equals(ie,ne);switch(ne){case"true":return n.has(ie);case"false":return n.not(ie);default:return n.equals(ie,ne)}}case 4:{this.z();const ne=this.u();if(this.x().type===18)return n.notEquals(ie,ne);switch(ne){case"true":return n.not(ie);case"false":return n.has(ie);default:return n.notEquals(ie,ne)}}case 5:return this.z(),N.create(ie,this.u());case 6:return this.z(),T.create(ie,this.u());case 7:return this.z(),K.create(ie,this.u());case 8:return this.z(),R.create(ie,this.u());case 13:return this.z(),n.in(ie,this.u());default:return n.has(ie)}}case 20:throw this.h.push({message:c,offset:B.offset,lexeme:"",additionalInfo:o}),l.c;default:throw this.B(`true | false | KEY 
	| KEY '=~' REGEX 
	| KEY ('==' | '!=' | '<' | '<=' | '>' | '>=' | 'in' | 'not' 'in') value`,this.D())}}u(){const B=this.D();switch(B.type){case 17:case 18:return this.z(),B.lexeme;case 11:return this.z(),"true";case 12:return this.z(),"false";case 13:return this.z(),"in";default:return""}}w(B){return B.replaceAll(this.v,"")}x(){return this.f[this.g-1]}y(B){return this.C(B)?(this.z(),!0):!1}z(){return this.E()||this.g++,this.x()}A(B,ie){if(this.C(B))return this.z();throw this.B(ie,this.D())}B(B,ie,pe){const ne=(0,A.localize)(8,null,B,P.$Qi.getLexeme(ie)),le=ie.offset,ce=P.$Qi.getLexeme(ie);return this.h.push({message:ne,offset:le,lexeme:ce,additionalInfo:pe}),l.c}C(B){return this.D().type===B}D(){return this.f[this.g]}E(){return this.D().type===20}}e.$Si=l;class n{static false(){return v.INSTANCE}static true(){return m.INSTANCE}static has(B){return S.create(B)}static equals(B,ie){return k.create(B,ie)}static notEquals(B,ie){return I.create(B,ie)}static regex(B,ie){return z.create(B,ie)}static in(B,ie){return h.create(B,ie)}static notIn(B,ie){return w.create(B,ie)}static not(B){return L.create(B)}static and(...B){return ye.create(B,null,!0)}static or(...B){return De.create(B,null,!0)}static greater(B,ie){return K.create(B,ie)}static greaterEquals(B,ie){return R.create(B,ie)}static smaller(B,ie){return N.create(B,ie)}static smallerEquals(B,ie){return T.create(B,ie)}static{this.c=new l({regexParsingWithErrorRecovery:!1})}static deserialize(B){return B==null?void 0:this.c.parse(B)}}e.$Ti=n;function s(X){const B=new l({regexParsingWithErrorRecovery:!1});return X.map(ie=>(B.parse(ie),B.lexingErrors.length>0?B.lexingErrors.map(pe=>({errorMessage:pe.additionalInfo?(0,A.localize)(9,null,pe.additionalInfo):(0,A.localize)(10,null),offset:pe.offset,length:pe.lexeme.length})):B.parsingErrors.length>0?B.parsingErrors.map(pe=>({errorMessage:pe.additionalInfo?`${pe.message}. ${pe.additionalInfo}`:pe.message,offset:pe.offset,length:pe.lexeme.length})):[]))}e.$Ui=s;function a(X,B){const ie=X?X.substituteConstants():void 0,pe=B?B.substituteConstants():void 0;return!ie&&!pe?!0:!ie||!pe?!1:ie.equals(pe)}e.$Vi=a;function d(X,B){return X.cmp(B)}class v{static{this.INSTANCE=new v}constructor(){this.type=0}cmp(B){return this.type-B.type}equals(B){return B.type===this.type}substituteConstants(){return this}evaluate(B){return!1}serialize(){return"false"}keys(){return[]}map(B){return this}negate(){return m.INSTANCE}}e.$Wi=v;class m{static{this.INSTANCE=new m}constructor(){this.type=1}cmp(B){return this.type-B.type}equals(B){return B.type===this.type}substituteConstants(){return this}evaluate(B){return!0}serialize(){return"true"}keys(){return[]}map(B){return this}negate(){return v.INSTANCE}}e.$Xi=m;class S{static create(B,ie=null){const pe=E.get(B);return typeof pe=="boolean"?pe?m.INSTANCE:v.INSTANCE:new S(B,ie)}constructor(B,ie){this.key=B,this.c=ie,this.type=2}cmp(B){return B.type!==this.type?this.type-B.type:fe(this.key,B.key)}equals(B){return B.type===this.type?this.key===B.key:!1}substituteConstants(){const B=E.get(this.key);return typeof B=="boolean"?B?m.INSTANCE:v.INSTANCE:this}evaluate(B){return!!B.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(B){return B.mapDefined(this.key)}negate(){return this.c||(this.c=L.create(this.key,this)),this.c}}e.$Yi=S;class k{static create(B,ie,pe=null){if(typeof ie=="boolean")return ie?S.create(B,pe):L.create(B,pe);const ne=E.get(B);return typeof ne=="boolean"?ie===(ne?"true":"false")?m.INSTANCE:v.INSTANCE:new k(B,ie,pe)}constructor(B,ie,pe){this.c=B,this.d=ie,this.f=pe,this.type=4}cmp(B){return B.type!==this.type?this.type-B.type:$e(this.c,this.d,B.c,B.d)}equals(B){return B.type===this.type?this.c===B.c&&this.d===B.d:!1}substituteConstants(){const B=E.get(this.c);if(typeof B=="boolean"){const ie=B?"true":"false";return this.d===ie?m.INSTANCE:v.INSTANCE}return this}evaluate(B){return B.getValue(this.c)==this.d}serialize(){return`${this.c} == '${this.d}'`}keys(){return[this.c]}map(B){return B.mapEquals(this.c,this.d)}negate(){return this.f||(this.f=I.create(this.c,this.d,this)),this.f}}e.$Zi=k;class h{static create(B,ie){return new h(B,ie)}constructor(B,ie){this.d=B,this.f=ie,this.type=10,this.c=null}cmp(B){return B.type!==this.type?this.type-B.type:$e(this.d,this.f,B.d,B.f)}equals(B){return B.type===this.type?this.d===B.d&&this.f===B.f:!1}substituteConstants(){return this}evaluate(B){const ie=B.getValue(this.f),pe=B.getValue(this.d);return Array.isArray(ie)?ie.includes(pe):typeof pe=="string"&&typeof ie=="object"&&ie!==null?C.call(ie,pe):!1}serialize(){return`${this.d} in '${this.f}'`}keys(){return[this.d,this.f]}map(B){return B.mapIn(this.d,this.f)}negate(){return this.c||(this.c=w.create(this.d,this.f)),this.c}}e.$1i=h;class w{static create(B,ie){return new w(B,ie)}constructor(B,ie){this.d=B,this.f=ie,this.type=11,this.c=h.create(B,ie)}cmp(B){return B.type!==this.type?this.type-B.type:this.c.cmp(B.c)}equals(B){return B.type===this.type?this.c.equals(B.c):!1}substituteConstants(){return this}evaluate(B){return!this.c.evaluate(B)}serialize(){return`${this.d} not in '${this.f}'`}keys(){return this.c.keys()}map(B){return B.mapNotIn(this.d,this.f)}negate(){return this.c}}e.$2i=w;class I{static create(B,ie,pe=null){if(typeof ie=="boolean")return ie?L.create(B,pe):S.create(B,pe);const ne=E.get(B);return typeof ne=="boolean"?ie===(ne?"true":"false")?v.INSTANCE:m.INSTANCE:new I(B,ie,pe)}constructor(B,ie,pe){this.c=B,this.d=ie,this.f=pe,this.type=5}cmp(B){return B.type!==this.type?this.type-B.type:$e(this.c,this.d,B.c,B.d)}equals(B){return B.type===this.type?this.c===B.c&&this.d===B.d:!1}substituteConstants(){const B=E.get(this.c);if(typeof B=="boolean"){const ie=B?"true":"false";return this.d===ie?v.INSTANCE:m.INSTANCE}return this}evaluate(B){return B.getValue(this.c)!=this.d}serialize(){return`${this.c} != '${this.d}'`}keys(){return[this.c]}map(B){return B.mapNotEquals(this.c,this.d)}negate(){return this.f||(this.f=k.create(this.c,this.d,this)),this.f}}e.$3i=I;class L{static create(B,ie=null){const pe=E.get(B);return typeof pe=="boolean"?pe?v.INSTANCE:m.INSTANCE:new L(B,ie)}constructor(B,ie){this.c=B,this.d=ie,this.type=3}cmp(B){return B.type!==this.type?this.type-B.type:fe(this.c,B.c)}equals(B){return B.type===this.type?this.c===B.c:!1}substituteConstants(){const B=E.get(this.c);return typeof B=="boolean"?B?v.INSTANCE:m.INSTANCE:this}evaluate(B){return!B.getValue(this.c)}serialize(){return`!${this.c}`}keys(){return[this.c]}map(B){return B.mapNot(this.c)}negate(){return this.d||(this.d=S.create(this.c,this)),this.d}}e.$4i=L;function V(X,B){if(typeof X=="string"){const ie=parseFloat(X);isNaN(ie)||(X=ie)}return typeof X=="string"||typeof X=="number"?B(X):v.INSTANCE}class K{static create(B,ie,pe=null){return V(ie,ne=>new K(B,ne,pe))}constructor(B,ie,pe){this.c=B,this.d=ie,this.f=pe,this.type=12}cmp(B){return B.type!==this.type?this.type-B.type:$e(this.c,this.d,B.c,B.d)}equals(B){return B.type===this.type?this.c===B.c&&this.d===B.d:!1}substituteConstants(){return this}evaluate(B){return typeof this.d=="string"?!1:parseFloat(B.getValue(this.c))>this.d}serialize(){return`${this.c} > ${this.d}`}keys(){return[this.c]}map(B){return B.mapGreater(this.c,this.d)}negate(){return this.f||(this.f=T.create(this.c,this.d,this)),this.f}}e.$5i=K;class R{static create(B,ie,pe=null){return V(ie,ne=>new R(B,ne,pe))}constructor(B,ie,pe){this.c=B,this.d=ie,this.f=pe,this.type=13}cmp(B){return B.type!==this.type?this.type-B.type:$e(this.c,this.d,B.c,B.d)}equals(B){return B.type===this.type?this.c===B.c&&this.d===B.d:!1}substituteConstants(){return this}evaluate(B){return typeof this.d=="string"?!1:parseFloat(B.getValue(this.c))>=this.d}serialize(){return`${this.c} >= ${this.d}`}keys(){return[this.c]}map(B){return B.mapGreaterEquals(this.c,this.d)}negate(){return this.f||(this.f=N.create(this.c,this.d,this)),this.f}}e.$6i=R;class N{static create(B,ie,pe=null){return V(ie,ne=>new N(B,ne,pe))}constructor(B,ie,pe){this.c=B,this.d=ie,this.f=pe,this.type=14}cmp(B){return B.type!==this.type?this.type-B.type:$e(this.c,this.d,B.c,B.d)}equals(B){return B.type===this.type?this.c===B.c&&this.d===B.d:!1}substituteConstants(){return this}evaluate(B){return typeof this.d=="string"?!1:parseFloat(B.getValue(this.c))<this.d}serialize(){return`${this.c} < ${this.d}`}keys(){return[this.c]}map(B){return B.mapSmaller(this.c,this.d)}negate(){return this.f||(this.f=R.create(this.c,this.d,this)),this.f}}e.$7i=N;class T{static create(B,ie,pe=null){return V(ie,ne=>new T(B,ne,pe))}constructor(B,ie,pe){this.c=B,this.d=ie,this.f=pe,this.type=15}cmp(B){return B.type!==this.type?this.type-B.type:$e(this.c,this.d,B.c,B.d)}equals(B){return B.type===this.type?this.c===B.c&&this.d===B.d:!1}substituteConstants(){return this}evaluate(B){return typeof this.d=="string"?!1:parseFloat(B.getValue(this.c))<=this.d}serialize(){return`${this.c} <= ${this.d}`}keys(){return[this.c]}map(B){return B.mapSmallerEquals(this.c,this.d)}negate(){return this.f||(this.f=K.create(this.c,this.d,this)),this.f}}e.$8i=T;class z{static create(B,ie){return new z(B,ie)}constructor(B,ie){this.d=B,this.f=ie,this.type=7,this.c=null}cmp(B){if(B.type!==this.type)return this.type-B.type;if(this.d<B.d)return-1;if(this.d>B.d)return 1;const ie=this.f?this.f.source:"",pe=B.f?B.f.source:"";return ie<pe?-1:ie>pe?1:0}equals(B){if(B.type===this.type){const ie=this.f?this.f.source:"",pe=B.f?B.f.source:"";return this.d===B.d&&ie===pe}return!1}substituteConstants(){return this}evaluate(B){const ie=B.getValue(this.d);return this.f?this.f.test(ie):!1}serialize(){const B=this.f?`/${this.f.source}/${this.f.flags}`:"/invalid/";return`${this.d} =~ ${B}`}keys(){return[this.d]}map(B){return B.mapRegex(this.d,this.f)}negate(){return this.c||(this.c=Z.create(this)),this.c}}e.$9i=z;class Z{static create(B){return new Z(B)}constructor(B){this.c=B,this.type=8}cmp(B){return B.type!==this.type?this.type-B.type:this.c.cmp(B.c)}equals(B){return B.type===this.type?this.c.equals(B.c):!1}substituteConstants(){return this}evaluate(B){return!this.c.evaluate(B)}serialize(){return`!(${this.c.serialize()})`}keys(){return this.c.keys()}map(B){return new Z(this.c.map(B))}negate(){return this.c}}e.$0i=Z;function he(X){let B=null;for(let ie=0,pe=X.length;ie<pe;ie++){const ne=X[ie].substituteConstants();if(X[ie]!==ne&&B===null){B=[];for(let le=0;le<ie;le++)B[le]=X[le]}B!==null&&(B[ie]=ne)}return B===null?X:B}class ye{static create(B,ie,pe){return ye.d(B,ie,pe)}constructor(B,ie){this.expr=B,this.c=ie,this.type=6}cmp(B){if(B.type!==this.type)return this.type-B.type;if(this.expr.length<B.expr.length)return-1;if(this.expr.length>B.expr.length)return 1;for(let ie=0,pe=this.expr.length;ie<pe;ie++){const ne=d(this.expr[ie],B.expr[ie]);if(ne!==0)return ne}return 0}equals(B){if(B.type===this.type){if(this.expr.length!==B.expr.length)return!1;for(let ie=0,pe=this.expr.length;ie<pe;ie++)if(!this.expr[ie].equals(B.expr[ie]))return!1;return!0}return!1}substituteConstants(){const B=he(this.expr);return B===this.expr?this:ye.create(B,this.c,!1)}evaluate(B){for(let ie=0,pe=this.expr.length;ie<pe;ie++)if(!this.expr[ie].evaluate(B))return!1;return!0}static d(B,ie,pe){const ne=[];let le=!1;for(const ce of B)if(ce){if(ce.type===1){le=!0;continue}if(ce.type===0)return v.INSTANCE;if(ce.type===6){ne.push(...ce.expr);continue}ne.push(ce)}if(ne.length===0&&le)return m.INSTANCE;if(ne.length!==0){if(ne.length===1)return ne[0];ne.sort(d);for(let ce=1;ce<ne.length;ce++)ne[ce-1].equals(ne[ce])&&(ne.splice(ce,1),ce--);if(ne.length===1)return ne[0];for(;ne.length>1;){const ce=ne[ne.length-1];if(ce.type!==9)break;ne.pop();const we=ne.pop(),_=ne.length===0,de=De.create(ce.expr.map(te=>ye.create([te,we],null,pe)),null,_);de&&(ne.push(de),ne.sort(d))}if(ne.length===1)return ne[0];if(pe){for(let ce=0;ce<ne.length;ce++)for(let we=ce+1;we<ne.length;we++)if(ne[ce].negate().equals(ne[we]))return v.INSTANCE;if(ne.length===1)return ne[0]}return new ye(ne,ie)}}serialize(){return this.expr.map(B=>B.serialize()).join(" && ")}keys(){const B=[];for(const ie of this.expr)B.push(...ie.keys());return B}map(B){return new ye(this.expr.map(ie=>ie.map(B)),null)}negate(){if(!this.c){const B=[];for(const ie of this.expr)B.push(ie.negate());this.c=De.create(B,this,!0)}return this.c}}e.$$i=ye;class De{static create(B,ie,pe){return De.d(B,ie,pe)}constructor(B,ie){this.expr=B,this.c=ie,this.type=9}cmp(B){if(B.type!==this.type)return this.type-B.type;if(this.expr.length<B.expr.length)return-1;if(this.expr.length>B.expr.length)return 1;for(let ie=0,pe=this.expr.length;ie<pe;ie++){const ne=d(this.expr[ie],B.expr[ie]);if(ne!==0)return ne}return 0}equals(B){if(B.type===this.type){if(this.expr.length!==B.expr.length)return!1;for(let ie=0,pe=this.expr.length;ie<pe;ie++)if(!this.expr[ie].equals(B.expr[ie]))return!1;return!0}return!1}substituteConstants(){const B=he(this.expr);return B===this.expr?this:De.create(B,this.c,!1)}evaluate(B){for(let ie=0,pe=this.expr.length;ie<pe;ie++)if(this.expr[ie].evaluate(B))return!0;return!1}static d(B,ie,pe){let ne=[],le=!1;if(B){for(let ce=0,we=B.length;ce<we;ce++){const _=B[ce];if(_){if(_.type===0){le=!0;continue}if(_.type===1)return m.INSTANCE;if(_.type===9){ne=ne.concat(_.expr);continue}ne.push(_)}}if(ne.length===0&&le)return v.INSTANCE;ne.sort(d)}if(ne.length!==0){if(ne.length===1)return ne[0];for(let ce=1;ce<ne.length;ce++)ne[ce-1].equals(ne[ce])&&(ne.splice(ce,1),ce--);if(ne.length===1)return ne[0];if(pe){for(let ce=0;ce<ne.length;ce++)for(let we=ce+1;we<ne.length;we++)if(ne[ce].negate().equals(ne[we]))return m.INSTANCE;if(ne.length===1)return ne[0]}return new De(ne,ie)}}serialize(){return this.expr.map(B=>B.serialize()).join(" || ")}keys(){const B=[];for(const ie of this.expr)B.push(...ie.keys());return B}map(B){return new De(this.expr.map(ie=>ie.map(B)),null)}negate(){if(!this.c){const B=[];for(const ie of this.expr)B.push(ie.negate());for(;B.length>1;){const ie=B.shift(),pe=B.shift(),ne=[];for(const le of se(ie))for(const ce of se(pe))ne.push(ye.create([le,ce],null,!1));B.unshift(De.create(ne,null,!1))}this.c=De.create(B,this,!0)}return this.c}}e.$_i=De;class Se extends S{static{this.d=[]}static all(){return Se.d.values()}constructor(B,ie,pe){super(B,null),this.f=ie,typeof pe=="object"?Se.d.push({...pe,key:B}):pe!==!0&&Se.d.push({key:B,description:pe,type:ie!=null?typeof ie:void 0})}bindTo(B){return B.createKey(this.key,this.f)}getValue(B){return B.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(B){return k.create(this.key,B)}notEqualsTo(B){return I.create(this.key,B)}}e.$aj=Se,e.$bj=(0,M.$Vh)("contextKeyService");function fe(X,B){return X<B?-1:X>B?1:0}function $e(X,B,ie,pe){return X<ie?-1:X>ie?1:B<pe?-1:B>pe?1:0}function re(X,B){if(X.type===0||B.type===1)return!0;if(X.type===9)return B.type===9?Ae(X.expr,B.expr):!1;if(B.type===9){for(const ie of B.expr)if(re(X,ie))return!0;return!1}if(X.type===6){if(B.type===6)return Ae(B.expr,X.expr);for(const ie of X.expr)if(re(ie,B))return!0;return!1}return X.equals(B)}e.$cj=re;function Ae(X,B){let ie=0,pe=0;for(;ie<X.length&&pe<B.length;){const ne=X[ie].cmp(B[pe]);if(ne<0)return!1;ne===0&&ie++,pe++}return ie===X.length}function se(X){return X.type===9?X.expr:[X]}}),define(Pe[184],Re([1,0,4]),function(be,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4h=e.$3h=void 0,e.$3h=(0,y.$Vh)("environmentService"),e.$4h=(0,y.$Wh)(e.$3h)}),define(Pe[96],Re([1,0,151,4]),function(be,e,y,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mo=e.$lo=e.$ko=e.$jo=e.$io=e.$ho=e.$go=e.$fo=e.$eo=e.ExtensionSignaturetErrorCode=e.ExtensionManagementErrorCode=e.$do=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.$co=e.$bo=e.$ao=e.$_n=e.$$n=e.$0n=e.$9n=e.$8n=e.$7n=e.$6n=e.$5n=e.$4n=void 0,e.$4n="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.$5n=new RegExp(e.$4n),e.$6n="__web_extension",e.$7n="skipWalkthrough",e.$8n="extensionsSync",e.$9n="dependecyOrPackExtensionInstall";function P(i){switch(i){case"win32-x64":return"Windows 64 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.$0n=P;function M(i){switch(i){case"win32-x64":return"win32-x64";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.$$n=M;function A(i,r){switch(i){case 3:return r==="x64"?"win32-x64":r==="arm64"?"win32-arm64":"unknown";case 2:return r==="x64"?"linux-x64":r==="arm64"?"linux-arm64":r==="arm"?"linux-armhf":"unknown";case"alpine":return r==="x64"?"alpine-x64":r==="arm64"?"alpine-arm64":"unknown";case 1:return r==="x64"?"darwin-x64":r==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.$_n=A;function $(i,r){return r==="web"&&!i.includes("web")}e.$ao=$;function E(i,r,c){return $(r,c)?!1:i==="undefined"||i==="universal"?!0:i==="unknown"?!1:i===c}e.$bo=E;function f(i){return i&&typeof i=="object"&&typeof i.id=="string"&&(!i.uuid||typeof i.uuid=="string")}e.$co=f;var C;(function(i){i[i.NoneOrRelevance=0]="NoneOrRelevance",i[i.LastUpdatedDate=1]="LastUpdatedDate",i[i.Title=2]="Title",i[i.PublisherName=3]="PublisherName",i[i.InstallCount=4]="InstallCount",i[i.PublishedDate=10]="PublishedDate",i[i.AverageRating=6]="AverageRating",i[i.WeightedRating=12]="WeightedRating"})(C||(e.SortBy=C={}));var D;(function(i){i[i.Default=0]="Default",i[i.Ascending=1]="Ascending",i[i.Descending=2]="Descending"})(D||(e.SortOrder=D={}));var u;(function(i){i.Install="install",i.Uninstall="uninstall"})(u||(e.StatisticType=u={}));var b;(function(i){i[i.None=1]="None",i[i.Install=2]="Install",i[i.Update=3]="Update",i[i.Migrate=4]="Migrate"})(b||(e.InstallOperation=b={})),e.$do=(0,F.$Vh)("extensionGalleryService");var p;(function(i){i.Unsupported="Unsupported",i.Deprecated="Deprecated",i.Malicious="Malicious",i.Incompatible="Incompatible",i.IncompatibleTargetPlatform="IncompatibleTargetPlatform",i.ReleaseVersionNotFound="ReleaseVersionNotFound",i.Invalid="Invalid",i.Download="Download",i.Extract="Extract",i.Delete="Delete",i.Rename="Rename",i.CorruptZip="CorruptZip",i.IncompleteZip="IncompleteZip",i.Signature="Signature",i.Internal="Internal"})(p||(e.ExtensionManagementErrorCode=p={}));var g;(function(i){i.UnknownError="UnknownError",i.PackageIsInvalidZip="PackageIsInvalidZip",i.SignatureArchiveIsInvalidZip="SignatureArchiveIsInvalidZip"})(g||(e.ExtensionSignaturetErrorCode=g={}));class t extends Error{constructor(r,c){super(r),this.code=c,this.name=c}}e.$eo=t,e.$fo=(0,F.$Vh)("extensionManagementService"),e.$go="extensionsIdentifiers/disabled",e.$ho="extensionsIdentifiers/enabled",e.$io=(0,F.$Vh)("IGlobalExtensionEnablementService"),e.$jo=(0,F.$Vh)("IExtensionTipsService"),e.$ko=(0,y.localize)(0,null),e.$lo={value:e.$ko,original:"Extensions"},e.$mo={value:(0,y.localize)(1,null),original:"Preferences"}}),define(Pe[41],Re([1,0,50,19,12,16,2,153,4,21,13,44]),function(be,e,y,F,P,M,A,$,E,f,C,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nk=e.$Mk=e.$Lk=e.$Kk=e.$Jk=e.FileKind=e.$Ik=e.$Hk=e.$Gk=e.$Fk=e.$Ek=e.$Dk=e.$Ck=e.FileOperationResult=e.$Bk=e.$Ak=e.$zk=e.$yk=e.$xk=e.FileChangeType=e.$wk=e.FileOperation=e.$vk=e.$uk=e.$tk=e.$sk=e.$rk=e.$qk=e.FileSystemProviderErrorCode=e.$pk=e.$ok=e.$nk=e.$mk=e.$lk=e.$kk=e.$jk=e.$ik=e.$hk=e.FileSystemProviderCapabilities=e.$gk=e.FilePermission=e.FileType=e.$fk=e.$ek=void 0,e.$ek=(0,E.$Vh)("fileService");function u(re){return re.create===!0}e.$fk=u;var b;(function(re){re[re.Unknown=0]="Unknown",re[re.File=1]="File",re[re.Directory=2]="Directory",re[re.SymbolicLink=64]="SymbolicLink"})(b||(e.FileType=b={}));var p;(function(re){re[re.Readonly=1]="Readonly",re[re.Locked=2]="Locked"})(p||(e.FilePermission=p={}));function g(re){const Ae=re;return!!Ae&&typeof Ae.onDidChange=="function"}e.$gk=g;var t;(function(re){re[re.None=0]="None",re[re.FileReadWrite=2]="FileReadWrite",re[re.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",re[re.FileReadStream=16]="FileReadStream",re[re.FileFolderCopy=8]="FileFolderCopy",re[re.PathCaseSensitive=1024]="PathCaseSensitive",re[re.Readonly=2048]="Readonly",re[re.Trash=4096]="Trash",re[re.FileWriteUnlock=8192]="FileWriteUnlock",re[re.FileAtomicRead=16384]="FileAtomicRead",re[re.FileAtomicWrite=32768]="FileAtomicWrite",re[re.FileAtomicDelete=65536]="FileAtomicDelete",re[re.FileClone=131072]="FileClone"})(t||(e.FileSystemProviderCapabilities=t={}));function i(re){return!!(re.capabilities&2)}e.$hk=i;function r(re){return!!(re.capabilities&8)}e.$ik=r;function c(re){return!!(re.capabilities&131072)}e.$jk=c;function o(re){return!!(re.capabilities&4)}e.$kk=o;function l(re){return!!(re.capabilities&16)}e.$lk=l;function n(re){return i(re)?!!(re.capabilities&16384):!1}e.$mk=n;function s(re){return i(re)?!!(re.capabilities&32768):!1}e.$nk=s;function a(re){return!!(re.capabilities&65536)}e.$ok=a;function d(re){return!!(re.capabilities&2048)}e.$pk=d;var v;(function(re){re.FileExists="EntryExists",re.FileNotFound="EntryNotFound",re.FileNotADirectory="EntryNotADirectory",re.FileIsADirectory="EntryIsADirectory",re.FileExceedsStorageQuota="EntryExceedsStorageQuota",re.FileTooLarge="EntryTooLarge",re.FileWriteLocked="EntryWriteLocked",re.NoPermissions="NoPermissions",re.Unavailable="Unavailable",re.Unknown="Unknown"})(v||(e.FileSystemProviderErrorCode=v={}));class m extends Error{static create(Ae,se){const X=new m(Ae.toString(),se);return h(X,se),X}constructor(Ae,se){super(Ae),this.code=se}}e.$qk=m;function S(re,Ae){return m.create(re,Ae)}e.$rk=S;function k(re){return re||S((0,$.localize)(0,null),v.Unknown)}e.$sk=k;function h(re,Ae){return re.name=Ae?`${Ae} (FileSystemError)`:"FileSystemError",re}e.$tk=h;function w(re){if(!re)return v.Unknown;if(re instanceof m)return re.code;const Ae=/^(.+) \(FileSystemError\)$/.exec(re.name);if(!Ae)return v.Unknown;switch(Ae[1]){case v.FileExists:return v.FileExists;case v.FileIsADirectory:return v.FileIsADirectory;case v.FileNotADirectory:return v.FileNotADirectory;case v.FileNotFound:return v.FileNotFound;case v.FileTooLarge:return v.FileTooLarge;case v.FileWriteLocked:return v.FileWriteLocked;case v.NoPermissions:return v.NoPermissions;case v.Unavailable:return v.Unavailable}return v.Unknown}e.$uk=w;function I(re){if(re instanceof T)return re.fileOperationResult;switch(w(re)){case v.FileNotFound:return 1;case v.FileIsADirectory:return 0;case v.FileNotADirectory:return 9;case v.FileWriteLocked:return 5;case v.NoPermissions:return 6;case v.FileExists:return 4;case v.FileTooLarge:return 7;default:return 10}}e.$vk=I;var L;(function(re){re[re.CREATE=0]="CREATE",re[re.DELETE=1]="DELETE",re[re.MOVE=2]="MOVE",re[re.COPY=3]="COPY",re[re.WRITE=4]="WRITE"})(L||(e.FileOperation=L={}));class V{constructor(Ae,se,X){this.resource=Ae,this.operation=se,this.target=X}isOperation(Ae){return this.operation===Ae}}e.$wk=V;var K;(function(re){re[re.UPDATED=0]="UPDATED",re[re.ADDED=1]="ADDED",re[re.DELETED=2]="DELETED"})(K||(e.FileChangeType=K={}));class R{static{this.a=null}constructor(Ae,se){this.c=se,this.b=void 0,this.d=new D.$U(()=>{const X=y.$2h.forUris(()=>this.c);return X.fill(this.rawAdded.map(B=>[B,!0])),X}),this.f=new D.$U(()=>{const X=y.$2h.forUris(()=>this.c);return X.fill(this.rawUpdated.map(B=>[B,!0])),X}),this.g=new D.$U(()=>{const X=y.$2h.forUris(()=>this.c);return X.fill(this.rawDeleted.map(B=>[B,!0])),X}),this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[];for(const X of Ae){switch(X.type){case 1:this.rawAdded.push(X.resource);break;case 0:this.rawUpdated.push(X.resource);break;case 2:this.rawDeleted.push(X.resource);break}this.b!==R.a&&(typeof X.cId=="number"?this.b===void 0?this.b=X.cId:this.b!==X.cId&&(this.b=R.a):this.b!==void 0&&(this.b=R.a))}}contains(Ae,...se){return this.h(Ae,{includeChildren:!1},...se)}affects(Ae,...se){return this.h(Ae,{includeChildren:!0},...se)}h(Ae,se,...X){if(!Ae)return!1;const B=X.length>0;return!!((!B||X.includes(1))&&(this.d.value.get(Ae)||se.includeChildren&&this.d.value.findSuperstr(Ae))||(!B||X.includes(0))&&(this.f.value.get(Ae)||se.includeChildren&&this.f.value.findSuperstr(Ae))||(!B||X.includes(2))&&(this.g.value.findSubstr(Ae)||se.includeChildren&&this.g.value.findSuperstr(Ae)))}gotAdded(){return this.rawAdded.length>0}gotDeleted(){return this.rawDeleted.length>0}gotUpdated(){return this.rawUpdated.length>0}correlates(Ae){return this.b===Ae}hasCorrelation(){return typeof this.b=="number"}}e.$xk=R;function N(re,Ae,se){return!re||!Ae||re===Ae||Ae.length>re.length?!1:(Ae.charAt(Ae.length-1)!==F.sep&&(Ae+=F.sep),se?(0,P.$7e)(re,Ae):re.indexOf(Ae)===0)}e.$yk=N;class T extends Error{constructor(Ae,se,X){super(Ae),this.fileOperationResult=se,this.options=X}}e.$zk=T;class z extends T{constructor(Ae,se,X,B){super(Ae,se,B),this.fileOperationResult=se,this.size=X}}e.$Ak=z;class Z extends T{constructor(Ae,se,X){super(Ae,2,X),this.stat=se}}e.$Bk=Z;var he;(function(re){re[re.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",re[re.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",re[re.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",re[re.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",re[re.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",re[re.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",re[re.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",re[re.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",re[re.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",re[re.FILE_NOT_DIRECTORY=9]="FILE_NOT_DIRECTORY",re[re.FILE_OTHER_ERROR=10]="FILE_OTHER_ERROR"})(he||(e.FileOperationResult=he={})),e.$Ck={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.$Dk={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.$Ek="files.associations",e.$Fk="files.exclude",e.$Gk="files.readonlyInclude",e.$Hk="files.readonlyExclude",e.$Ik="files.readonlyFromPermissions";var ye;(function(re){re[re.FILE=0]="FILE",re[re.FOLDER=1]="FOLDER",re[re.ROOT_FOLDER=2]="ROOT_FOLDER"})(ye||(e.FileKind=ye={})),e.$Jk="";function De(re){if(!(typeof re.size!="number"||typeof re.mtime!="number"))return re.mtime.toString(29)+re.size.toString(31)}e.$Kk=De;async function Se(re,Ae){if(!Ae.hasProvider(A.URI.from({scheme:re.scheme})))return new Promise(se=>{const X=Ae.onDidChangeFileSystemProviderRegistrations(B=>{B.scheme===re.scheme&&B.added&&(X.dispose(),se())})})}e.$Lk=Se;class fe{static{this.KB=1024}static{this.MB=fe.KB*fe.KB}static{this.GB=fe.MB*fe.KB}static{this.TB=fe.GB*fe.KB}static formatSize(Ae){return(0,M.$Gf)(Ae)||(Ae=0),Ae<fe.KB?(0,$.localize)(1,null,Ae.toFixed(0)):Ae<fe.MB?(0,$.localize)(2,null,(Ae/fe.KB).toFixed(2)):Ae<fe.GB?(0,$.localize)(3,null,(Ae/fe.MB).toFixed(2)):Ae<fe.TB?(0,$.localize)(4,null,(Ae/fe.GB).toFixed(2)):(0,$.localize)(5,null,(Ae/fe.TB).toFixed(2))}}e.$Mk=fe;function $e(re){const Ae=typeof re=="string"||re?.scheme===C.Schemas.vscodeRemote;return typeof re!="string"&&re?.scheme===C.Schemas.file?1024*fe.MB:Ae?10*fe.MB:f.$o?50*fe.MB:1024*fe.MB}e.$Nk=$e}),define(Pe[71],Re([1,0]),function(be,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Th=void 0;class y{constructor(...P){this.a=new Map;for(const[M,A]of P)this.set(M,A)}set(P,M){const A=this.a.get(P);return this.a.set(P,M),A}has(P){return this.a.has(P)}get(P){return this.a.get(P)}}e.$Th=y}),define(Pe[185],Re([1,0,14,11,6,69,183,4,71,186]),function(be,e,y,F,P,M,A,$,E,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kq=e.$jq=void 0;const C=!1;class D extends Error{constructor(t){super("cyclic dependency between services"),this.message=t.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${t.toString()}`}}class u{constructor(t=new E.$Th,i=!1,r,c=C){this.f=t,this.g=i,this.h=r,this.i=c,this.o=new Set,this.f.set($.$Uh,this),this._globalGraph=c?r?._globalGraph??new A.$iq(o=>o):void 0}createChild(t){return new u(t,this.g,this,this.i)}invokeFunction(t,...i){const r=p.traceInvocation(this.i,t);let c=!1;try{return t({get:l=>{if(c)throw(0,F.$7)("service accessor is only valid during the invocation of its target method");const n=this.m(l,r);if(!n)throw new Error(`[invokeFunction] unknown service '${l}'`);return n}},...i)}finally{c=!0,r.stop()}}createInstance(t,...i){let r,c;return t instanceof M.$Sh?(r=p.traceCreation(this.i,t.ctor),c=this.j(t.ctor,t.staticArguments.concat(i),r)):(r=p.traceCreation(this.i,t),c=this.j(t,i,r)),r.stop(),c}j(t,i=[],r){const c=$._util.getServiceDependencies(t).sort((n,s)=>n.index-s.index),o=[];for(const n of c){const s=this.m(n.id,r);s||this.u(`[createInstance] ${t.name} depends on UNKNOWN service ${n.id}.`,!1),o.push(s)}const l=c.length>0?c[0].index:i.length;if(i.length!==l){console.trace(`[createInstance] First service dependency of ${t.name} at position ${l+1} conflicts with ${i.length} static arguments`);const n=l-i.length;n>0?i=i.concat(new Array(n)):i=i.slice(0,l)}return Reflect.construct(t,i.concat(o))}k(t,i){if(this.f.get(t)instanceof M.$Sh)this.f.set(t,i);else if(this.h)this.h.k(t,i);else throw new Error("illegalState - setting UNKNOWN service instance")}l(t){const i=this.f.get(t);return!i&&this.h?this.h.l(t):i}m(t,i){this._globalGraph&&this.c&&this._globalGraph.insertEdge(this.c,String(t));const r=this.l(t);return r instanceof M.$Sh?this.q(t,r,i.branch(t,!0)):(i.branch(t,!1),r)}q(t,i,r){if(this.o.has(t))throw new Error(`illegal state - RECURSIVELY instantiating service '${t}'`);this.o.add(t);try{return this.r(t,i,r)}finally{this.o.delete(t)}}r(t,i,r){const c=new A.$iq(n=>n.id.toString());let o=0;const l=[{id:t,desc:i,_trace:r}];for(;l.length;){const n=l.pop();if(c.lookupOrInsertNode(n),o++>1e3)throw new D(c);for(const s of $._util.getServiceDependencies(n.desc.ctor)){const a=this.l(s.id);if(a||this.u(`[createInstance] ${t} depends on ${s.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(n.id),String(s.id)),a instanceof M.$Sh){const d={id:s.id,desc:a,_trace:n._trace.branch(s.id,!0)};c.insertEdge(n,d),l.push(d)}}}for(;;){const n=c.roots();if(n.length===0){if(!c.isEmpty())throw new D(c);break}for(const{data:s}of n){if(this.l(s.id)instanceof M.$Sh){const d=this.s(s.id,s.desc.ctor,s.desc.staticArguments,s.desc.supportsDelayedInstantiation,s._trace);this.k(s.id,d)}c.removeNode(s)}}return this.l(t)}s(t,i,r=[],c,o){if(this.f.get(t)instanceof M.$Sh)return this.t(t,i,r,c,o);if(this.h)return this.h.s(t,i,r,c,o);throw new Error(`illegalState - creating UNKNOWN service instance ${i.name}`)}t(t,i,r=[],c,o){if(c){const l=new u(void 0,this.g,this,this.i);l.c=String(t);const n=new Map,s=new y.$eh(()=>{const a=l.j(i,r,o);for(const[d,v]of n){const m=a[d];if(typeof m=="function")for(const S of v)m.apply(a,S)}return n.clear(),a});return new Proxy(Object.create(null),{get(a,d){if(!s.isInitialized&&typeof d=="string"&&(d.startsWith("onDid")||d.startsWith("onWill"))){let S=n.get(d);return S||(S=new f.$2c,n.set(d,S)),(h,w,I)=>{const L=S.push([h,w,I]);return(0,P.$Pc)(L)}}if(d in a)return a[d];const v=s.value;let m=v[d];return typeof m!="function"||(m=m.bind(v),a[d]=m),m},set(a,d,v){return s.value[d]=v,!0},getPrototypeOf(a){return i.prototype}})}else return this.j(i,r,o)}u(t,i){if(i&&console.warn(t),this.g)throw new Error(t)}}e.$jq=u;var b;(function(g){g[g.None=0]="None",g[g.Creation=1]="Creation",g[g.Invocation=2]="Invocation",g[g.Branch=3]="Branch"})(b||(b={}));class p{static{this.all=new Set}static{this.c=new class extends p{constructor(){super(0,null)}stop(){}branch(){return this}}}static traceInvocation(t,i){return t?new p(2,i.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):p.c}static traceCreation(t,i){return t?new p(1,i.name):p.c}static{this.f=0}constructor(t,i){this.type=t,this.name=i,this.g=Date.now(),this.h=[]}branch(t,i){const r=new p(3,t.toString());return this.h.push([t,i,r]),r}stop(){const t=Date.now()-this.g;p.f+=t;let i=!1;function r(o,l){const n=[],s=new Array(o+1).join("	");for(const[a,d,v]of l.h)if(d&&v){i=!0,n.push(`${s}CREATES -> ${a}`);const m=r(o+1,v);m&&n.push(m)}else n.push(`${s}uses -> ${a}`);return n.join(`
`)}const c=[`${this.type===1?"CREATE":"CALL"} ${this.name}`,`${r(1,this)}`,`DONE, took ${t.toFixed(2)}ms (grand total ${p.f.toFixed(2)}ms)`];(t>2||i)&&p.all.add(c.join(`
`))}}e.$kq=p}),define(Pe[15],Re([1,0,39,5,97,6,28,21,25,16,2,34,4]),function(be,e,y,F,P,M,A,$,E,f,C,D,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uj=e.$tj=e.$sj=e.$rj=e.$qj=e.$pj=e.$oj=e.$nj=e.$mj=e.$lj=e.$kj=e.$jj=e.$ij=e.log=e.$gj=e.LogLevel=e.$fj=e.$ej=e.$dj=void 0,e.$dj=(0,u.$Vh)("logService"),e.$ej=(0,u.$Vh)("loggerService");function b(){return new Date().toISOString()}function p(h){return(0,f.$Gf)(h)}e.$fj=p;var g;(function(h){h[h.Off=0]="Off",h[h.Trace=1]="Trace",h[h.Debug=2]="Debug",h[h.Info=3]="Info",h[h.Warning=4]="Warning",h[h.Error=5]="Error"})(g||(e.LogLevel=g={})),e.$gj=g.Info;function t(h,w,I){switch(w){case g.Trace:h.trace(I);break;case g.Debug:h.debug(I);break;case g.Info:h.info(I);break;case g.Warning:h.warn(I);break;case g.Error:h.error(I);break;case g.Off:break;default:throw new Error(`Invalid log level ${w}`)}}e.log=t;function i(h,w=!1){let I="";for(let L=0;L<h.length;L++){let V=h[L];if(V instanceof Error&&(V=(0,y.$Gi)(V,w)),typeof V=="object")try{V=JSON.stringify(V)}catch{}I+=(L>0?" ":"")+V}return I}class r extends M.$Rc{constructor(){super(...arguments),this.b=e.$gj,this.c=this.B(new F.$Rd),this.onDidChangeLogLevel=this.c.event}setLevel(w){this.b!==w&&(this.b=w,this.c.fire(this.b))}getLevel(){return this.b}f(w){return this.b!==g.Off&&this.b<=w}}e.$ij=r;class c extends r{constructor(w){super(),this.h=w}f(w){return this.h||super.f(w)}trace(w,...I){this.f(g.Trace)&&this.g(g.Trace,i([w,...I],!0))}debug(w,...I){this.f(g.Debug)&&this.g(g.Debug,i([w,...I]))}info(w,...I){this.f(g.Info)&&this.g(g.Info,i([w,...I]))}warn(w,...I){this.f(g.Warning)&&this.g(g.Warning,i([w,...I]))}error(w,...I){if(this.f(g.Error))if(w instanceof Error){const L=Array.prototype.slice.call(arguments);L[0]=w.stack,this.g(g.Error,i(L))}else this.g(g.Error,i([w,...I]))}flush(){}}e.$jj=c;class o extends r{constructor(w=e.$gj){super(),this.setLevel(w),this.g=!$.$i}trace(w,...I){this.f(g.Trace)&&(this.g?console.log(`\x1B[90m[main ${b()}]\x1B[0m`,w,...I):console.log(`[main ${b()}]`,w,...I))}debug(w,...I){this.f(g.Debug)&&(this.g?console.log(`\x1B[90m[main ${b()}]\x1B[0m`,w,...I):console.log(`[main ${b()}]`,w,...I))}info(w,...I){this.f(g.Info)&&(this.g?console.log(`\x1B[90m[main ${b()}]\x1B[0m`,w,...I):console.log(`[main ${b()}]`,w,...I))}warn(w,...I){this.f(g.Warning)&&(this.g?console.warn(`\x1B[93m[main ${b()}]\x1B[0m`,w,...I):console.warn(`[main ${b()}]`,w,...I))}error(w,...I){this.f(g.Error)&&(this.g?console.error(`\x1B[91m[main ${b()}]\x1B[0m`,w,...I):console.error(`[main ${b()}]`,w,...I))}dispose(){}flush(){}}e.$kj=o;class l extends r{constructor(w=e.$gj,I=!0){super(),this.g=I,this.setLevel(w)}trace(w,...I){this.f(g.Trace)&&(this.g?console.log("%cTRACE","color: #888",w,...I):console.log(w,...I))}debug(w,...I){this.f(g.Debug)&&(this.g?console.log("%cDEBUG","background: #eee; color: #888",w,...I):console.log(w,...I))}info(w,...I){this.f(g.Info)&&(this.g?console.log("%c INFO","color: #33f",w,...I):console.log(w,...I))}warn(w,...I){this.f(g.Warning)&&(this.g?console.log("%c WARN","color: #993",w,...I):console.log(w,...I))}error(w,...I){this.f(g.Error)&&(this.g?console.log("%c  ERR","color: #f33",w,...I):console.error(w,...I))}dispose(){}flush(){}}e.$lj=l;class n extends r{constructor(w,I=e.$gj){super(),this.g=w,this.setLevel(I)}trace(w,...I){this.f(g.Trace)&&this.g.log(g.Trace,[this.h(w),...I])}debug(w,...I){this.f(g.Debug)&&this.g.log(g.Debug,[this.h(w),...I])}info(w,...I){this.f(g.Info)&&this.g.log(g.Info,[this.h(w),...I])}warn(w,...I){this.f(g.Warning)&&this.g.log(g.Warning,[this.h(w),...I])}error(w,...I){this.f(g.Error)&&this.g.log(g.Error,[this.h(w),...I])}h(w){return typeof w=="string"?w:(0,y.$Gi)(w,this.f(g.Trace))}dispose(){}flush(){}}e.$mj=n;class s extends r{constructor(w){super(),this.g=w,w.length&&this.setLevel(w[0].getLevel())}setLevel(w){for(const I of this.g)I.setLevel(w);super.setLevel(w)}trace(w,...I){for(const L of this.g)L.trace(w,...I)}debug(w,...I){for(const L of this.g)L.debug(w,...I)}info(w,...I){for(const L of this.g)L.info(w,...I)}warn(w,...I){for(const L of this.g)L.warn(w,...I)}error(w,...I){for(const L of this.g)L.error(w,...I)}flush(){for(const w of this.g)w.flush()}dispose(){for(const w of this.g)w.dispose()}}e.$nj=s;class a extends M.$Rc{constructor(w,I,L){if(super(),this.h=w,this.j=I,this.b=new A.$zc,this.c=this.B(new F.$Rd),this.onDidChangeLoggers=this.c.event,this.f=this.B(new F.$Rd),this.onDidChangeLogLevel=this.f.event,this.g=this.B(new F.$Rd),this.onDidChangeVisibility=this.g.event,L)for(const V of L)this.b.set(V.resource,{logger:void 0,info:V})}m(w){return(0,f.$Cf)(w)?[...this.b.values()].find(I=>I.info.id===w):this.b.get(w)}getLogger(w){return this.m(w)?.logger}createLogger(w,I){const L=this.n(w),V=(0,f.$Cf)(w)?w:I?.id??(0,P.$Ji)(L.toString()).toString(16);let K=this.b.get(L)?.logger;const R=I?.logLevel==="always"?g.Trace:I?.logLevel;K||(K=this.s(L,R??this.getLogLevel(L)??this.h,{...I,id:V}));const N={logger:K,info:{resource:L,id:V,logLevel:R,name:I?.name,hidden:I?.hidden,extensionId:I?.extensionId,when:I?.when}};return this.registerLogger(N.info),this.b.set(L,N),K}n(w){return(0,f.$Cf)(w)?(0,E.$zg)(this.j,`${w}.log`):w}setLogLevel(w,I){if(C.URI.isUri(w)){const L=w,V=I,K=this.b.get(L);K&&V!==K.info.logLevel&&(K.info.logLevel=V===this.h?void 0:V,K.logger?.setLevel(V),this.b.set(K.info.resource,K),this.f.fire([L,V]))}else{this.h=w;for(const[L,V]of this.b.entries())this.b.get(L)?.info.logLevel===void 0&&V.logger?.setLevel(this.h);this.f.fire(this.h)}}setVisibility(w,I){const L=this.m(w);L&&I!==!L.info.hidden&&(L.info.hidden=!I,this.b.set(L.info.resource,L),this.g.fire([L.info.resource,I]))}getLogLevel(w){let I;return w&&(I=this.b.get(w)?.info.logLevel),I??this.h}registerLogger(w){const I=this.b.get(w.resource);I?I.info.hidden!==w.hidden&&this.setVisibility(w.resource,!w.hidden):(this.b.set(w.resource,{info:w,logger:void 0}),this.c.fire({added:[w],removed:[]}))}deregisterLogger(w){const I=this.b.get(w);I&&(I.logger&&I.logger.dispose(),this.b.delete(w),this.c.fire({added:[],removed:[I.info]}))}*getRegisteredLoggers(){for(const w of this.b.values())yield w.info}getRegisteredLogger(w){return this.b.get(w)?.info}dispose(){this.b.forEach(w=>w.logger?.dispose()),this.b.clear(),super.dispose()}}e.$oj=a;class d{constructor(){this.onDidChangeLogLevel=new F.$Rd().event}setLevel(w){}getLevel(){return g.Info}trace(w,...I){}debug(w,...I){}info(w,...I){}warn(w,...I){}error(w,...I){}critical(w,...I){}dispose(){}flush(){}}e.$pj=d;class v extends d{}e.$qj=v;function m(h){if(h.verbose)return g.Trace;if(typeof h.logLevel=="string"){const w=k(h.logLevel.toLowerCase());if(w!==void 0)return w}return e.$gj}e.$rj=m;function S(h){switch(h){case g.Trace:return"trace";case g.Debug:return"debug";case g.Info:return"info";case g.Warning:return"warn";case g.Error:return"error";case g.Off:return"off"}}e.$sj=S;function k(h){switch(h){case"trace":return g.Trace;case"debug":return g.Debug;case"info":return g.Info;case"warn":return g.Warning;case"error":return g.Error;case"critical":return g.Error;case"off":return g.Off}}e.$tj=k,e.$uj=new D.$aj("logLevel",S(g.Info))}),define(Pe[187],Re([1,0,6,15]),function(be,e,y,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$WN=void 0;class P extends y.$Rc{constructor(A,$=[]){super(),this.a=new F.$nj([A,...$]),this.B(A.onDidChangeLogLevel(E=>this.setLevel(E)))}get onDidChangeLogLevel(){return this.a.onDidChangeLogLevel}setLevel(A){this.a.setLevel(A)}getLevel(){return this.a.getLevel()}trace(A,...$){this.a.trace(A,...$)}debug(A,...$){this.a.debug(A,...$)}info(A,...$){this.a.info(A,...$)}warn(A,...$){this.a.warn(A,...$)}error(A,...$){this.a.error(A,...$)}flush(){this.a.flush()}}e.$WN=P}),define(Pe[98],Re([1,0,31,154,4]),function(be,e,y,F,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ft=e.IMarkerData=e.MarkerSeverity=e.MarkerTag=void 0;var M;(function(E){E[E.Unnecessary=1]="Unnecessary",E[E.Deprecated=2]="Deprecated"})(M||(e.MarkerTag=M={}));var A;(function(E){E[E.Hint=1]="Hint",E[E.Info=2]="Info",E[E.Warning=4]="Warning",E[E.Error=8]="Error"})(A||(e.MarkerSeverity=A={})),function(E){function f(p,g){return g-p}E.compare=f;const C=Object.create(null);C[E.Error]=(0,F.localize)(0,null),C[E.Warning]=(0,F.localize)(1,null),C[E.Info]=(0,F.localize)(2,null);function D(p){return C[p]||""}E.toString=D;function u(p){switch(p){case y.default.Error:return E.Error;case y.default.Warning:return E.Warning;case y.default.Info:return E.Info;case y.default.Ignore:return E.Hint}}E.fromSeverity=u;function b(p){switch(p){case E.Error:return y.default.Error;case E.Warning:return y.default.Warning;case E.Info:return y.default.Info;case E.Hint:return y.default.Ignore}}E.toSeverity=b}(A||(e.MarkerSeverity=A={}));var $;(function(E){const f="";function C(u){return D(u,!0)}E.makeKey=C;function D(u,b){const p=[f];return u.source?p.push(u.source.replace("\xA6","\\\xA6")):p.push(f),u.code?typeof u.code=="string"?p.push(u.code.replace("\xA6","\\\xA6")):p.push(u.code.value.replace("\xA6","\\\xA6")):p.push(f),u.severity!==void 0&&u.severity!==null?p.push(A.toString(u.severity)):p.push(f),u.message&&b?p.push(u.message.replace("\xA6","\\\xA6")):p.push(f),u.startLineNumber!==void 0&&u.startLineNumber!==null?p.push(u.startLineNumber.toString()):p.push(f),u.startColumn!==void 0&&u.startColumn!==null?p.push(u.startColumn.toString()):p.push(f),u.endLineNumber!==void 0&&u.endLineNumber!==null?p.push(u.endLineNumber.toString()):p.push(f),u.endColumn!==void 0&&u.endColumn!==null?p.push(u.endColumn.toString()):p.push(f),p.push(f),p.join("\xA6")}E.makeKeyOptionalMessage=D})($||(e.IMarkerData=$={})),e.$ft=(0,P.$Vh)("markerService")}),define(Pe[188],Re([1,0,5,31,4]),function(be,e,y,F,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8u=e.$7u=e.NotificationsFilter=e.NeverShowAgainScope=e.NotificationPriority=e.$6u=e.Severity=void 0,e.Severity=F.default,e.$6u=(0,P.$Vh)("notificationService");var M;(function(C){C[C.DEFAULT=0]="DEFAULT",C[C.SILENT=1]="SILENT",C[C.URGENT=2]="URGENT"})(M||(e.NotificationPriority=M={}));var A;(function(C){C[C.WORKSPACE=0]="WORKSPACE",C[C.PROFILE=1]="PROFILE",C[C.APPLICATION=2]="APPLICATION"})(A||(e.NeverShowAgainScope=A={}));var $;(function(C){C[C.OFF=0]="OFF",C[C.SILENT=1]="SILENT",C[C.ERROR=2]="ERROR"})($||(e.NotificationsFilter=$={}));class E{constructor(){this.progress=new f,this.onDidClose=y.Event.None,this.onDidChangeVisibility=y.Event.None}updateSeverity(D){}updateMessage(D){}updateActions(D){}close(){}}e.$7u=E;class f{infinite(){}done(){}total(D){}worked(D){}}e.$8u=f}),define(Pe[99],Re([1,0,12,2,4]),function(be,e,y,F,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$RU=e.$QU=e.$PU=e.$OU=e.$NU=void 0,e.$NU=(0,P.$Vh)("openerService");function M(f,C){return F.URI.isUri(f)?(0,y.$6e)(f.scheme,C):(0,y.$7e)(f,C+":")}e.$OU=M;function A(f,...C){return C.some(D=>M(f,D))}e.$PU=A;function $(f,C){return f.with({fragment:`${C.startLineNumber},${C.startColumn}${C.endLineNumber?`-${C.endLineNumber}${C.endColumn?`,${C.endColumn}`:""}`:""}`})}e.$QU=$;function E(f){let C;const D=/^L?(\d+)(?:,(\d+))?(-L?(\d+)(?:,(\d+))?)?/.exec(f.fragment);return D&&(C={startLineNumber:parseInt(D[1]),startColumn:D[2]?parseInt(D[2]):1,endLineNumber:D[4]?parseInt(D[4]):void 0,endColumn:D[4]?D[5]?parseInt(D[5]):1:void 0},f=f.with({fragment:""})),{selection:C,uri:f}}e.$RU=E}),define(Pe[189],Re([1,0,4]),function(be,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wj=e.$vj=void 0,e.$vj=(0,y.$Vh)("productService"),e.$wj="vscode://schemas/vscode-product"});var Ke=this&&this.__decorate||function(be,e,y,F){var P=arguments.length,M=P<3?e:F===null?F=Object.getOwnPropertyDescriptor(e,y):F,A;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")M=Reflect.decorate(be,e,y,F);else for(var $=be.length-1;$>=0;$--)(A=be[$])&&(M=(P<3?A(M):P>3?A(e,y,M):A(e,y))||M);return P>3&&M&&Object.defineProperty(e,y,M),M},Ve=this&&this.__param||function(be,e){return function(y,F){e(y,F,be)}};define(Pe[72],Re([1,0,14,20,6,4]),function(be,e,y,F,P,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cv=e.$bv=e.$av=e.$_u=e.$$u=e.$0u=e.ProgressLocation=e.$9u=void 0,e.$9u=(0,M.$Vh)("progressService");var A;(function(D){D[D.Explorer=1]="Explorer",D[D.Scm=3]="Scm",D[D.Extensions=5]="Extensions",D[D.Window=10]="Window",D[D.Notification=15]="Notification",D[D.Dialog=20]="Dialog"})(A||(e.ProgressLocation=A={})),e.$0u=Object.freeze({total(){},worked(){},done(){}});class ${static{this.None=Object.freeze({report(){}})}get value(){return this.a}constructor(u){this.b=u}report(u){this.a=u,this.b(this.a)}}e.$$u=$;class E{get value(){return this.a}constructor(u){this.e=u}report(u){this.b?this.b.push(u):this.b=[u],this.f()}async f(){if(!this.c)try{for(this.c=!0;this.b&&this.b.length;){const u=this.b.shift();this.a=u,await this.e(this.a)}}finally{this.c=!1;const u=this.d;this.d=void 0,u?.()}}drain(){return this.c?new Promise(u=>{const b=this.d;this.d=()=>{b?.(),u()}}):Promise.resolve()}}e.$_u=E;let f=class extends P.$Rc{constructor(u,b){super(),this.a=new y.$ih,b.withProgress(u,p=>(this.b=p,this.c&&p.report(this.c),this.a.p)),this.B((0,P.$Pc)(()=>this.a.complete()))}report(u){this.b?this.b.report(u):this.c=u}};e.$av=f,e.$av=f=Ke([Ve(1,e.$9u)],f);class C extends P.$Rc{constructor(u){super(),this.g=u,this.a=0,this.b=this.B(new P.$Qc)}start(u){this.stop();const b=++this.a,p=new F.$2d;return this.f=setTimeout(()=>{b===this.a&&(this.c=this.g.show(!0))},u),this.b.add((0,P.$Pc)(()=>clearTimeout(this.f))),this.b.add((0,P.$Pc)(()=>p.cancel())),this.b.add((0,P.$Pc)(()=>this.c?this.c.done():void 0)),{id:b,token:p.token,stop:()=>this.h(b),isCurrent:()=>this.a===b}}stop(){this.h(this.a)}h(u){this.a===u&&this.b.clear()}}e.$bv=C,e.$cv=(0,M.$Vh)("editorProgressService")}),define(Pe[30],Re([1,0,53,16]),function(be,e,y,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mn=void 0;class P{constructor(){this.a=new Map}add(A,$){y.ok(F.$Cf(A)),y.ok(F.$Ef($)),y.ok(!this.a.has(A),"There is already an extension with this id"),this.a.set(A,$)}knows(A){return this.a.has(A)}as(A){return this.a.get(A)||null}}e.$mn=new P}),define(Pe[73],Re([1,0,5,30]),function(be,e,y,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nn=void 0,e.$nn={JSONContribution:"base.contributions.json"};function P($){return $.length>0&&$.charAt($.length-1)==="#"?$.substring(0,$.length-1):$}class M{constructor(){this.b=new y.$Rd,this.onDidChangeSchema=this.b.event,this.a={}}registerSchema(E,f){this.a[P(E)]=f,this.b.fire(E)}notifySchemaChanged(E){this.b.fire(E)}getSchemaContributions(){return{schemas:this.a}}}const A=new M;F.$mn.add(e.$nn.JSONContribution,A)}),define(Pe[54],Re([1,0,18,5,16,148,40,73,30]),function(be,e,y,F,P,M,A,$,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gn=e.$Fn=e.$En=e.$Dn=e.$Cn=e.$Bn=e.$An=e.$zn=e.$yn=e.$xn=e.$wn=e.$vn=e.$un=e.$tn=e.$sn=e.ConfigurationScope=e.$rn=e.EditPresentationTypes=void 0;var f;(function(l){l.Multiline="multilineText",l.Singleline="singlelineText"})(f||(e.EditPresentationTypes=f={})),e.$rn={Configuration:"base.contributions.configuration"};var C;(function(l){l[l.APPLICATION=1]="APPLICATION",l[l.MACHINE=2]="MACHINE",l[l.WINDOW=3]="WINDOW",l[l.RESOURCE=4]="RESOURCE",l[l.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",l[l.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(C||(e.ConfigurationScope=C={})),e.$sn={properties:{},patternProperties:{}},e.$tn={properties:{},patternProperties:{}},e.$un={properties:{},patternProperties:{}},e.$vn={properties:{},patternProperties:{}},e.$wn={properties:{},patternProperties:{}},e.$xn={properties:{},patternProperties:{}},e.$yn="vscode://schemas/settings/resourceLanguage",e.$zn="vscode://schemas/settings/configurationDefaults";const D=E.$mn.as($.$nn.JSONContribution);class u{constructor(){this.h=new Set,this.i=new F.$Rd,this.onDidSchemaChange=this.i.event,this.j=new F.$Rd,this.onDidUpdateConfiguration=this.j.event,this.a=new Map,this.b={id:"defaultOverrides",title:M.localize(0,null),properties:{}},this.c=[this.b],this.g={properties:{},patternProperties:{},additionalProperties:!0,allowTrailingCommas:!0,allowComments:!0},this.d={},this.e=new Map,this.f={},D.registerSchema(e.$yn,this.g),this.v()}registerConfiguration(n,s=!0){this.registerConfigurations([n],s)}registerConfigurations(n,s=!0){const a=new Set;this.n(n,s,a),D.registerSchema(e.$yn,this.g),this.i.fire(),this.j.fire({properties:a})}deregisterConfigurations(n){const s=new Set;this.o(n,s),D.registerSchema(e.$yn,this.g),this.i.fire(),this.j.fire({properties:s})}updateConfigurations({add:n,remove:s}){const a=new Set;this.o(s,a),this.n(n,!1,a),D.registerSchema(e.$yn,this.g),this.i.fire(),this.j.fire({properties:a})}registerDefaultConfigurations(n){const s=new Set;this.k(n,s),this.i.fire(),this.j.fire({properties:s,defaultsOverrides:!0})}k(n,s){const a=[];for(const{overrides:d,source:v}of n)for(const m in d)if(s.add(m),e.$Bn.test(m)){const S=this.a.get(m),k=S?.valuesSources??new Map;if(v)for(const L of Object.keys(d[m]))k.set(L,v);const h={...S?.value||{},...d[m]};this.a.set(m,{source:v,value:h,valuesSources:k});const w=(0,A.$zi)(m),I={type:"object",default:h,description:M.localize(1,null,w),$ref:e.$yn,defaultDefaultValue:h,source:P.$Cf(v)?void 0:v,defaultValueSource:v};a.push(...g(m)),this.d[m]=I,this.b.properties[m]=I}else{this.a.set(m,{value:d[m],source:v});const S=this.d[m];S&&(this.w(m,S),this.r(m,S))}this.m(a)}deregisterDefaultConfigurations(n){const s=new Set;this.l(n,s),this.i.fire(),this.j.fire({properties:s,defaultsOverrides:!0})}l(n,s){for(const{overrides:a,source:d}of n)for(const v in a){const m=this.a.get(v),S=P.$Cf(d)?d:d?.id,k=P.$Cf(m?.source)?m?.source:m?.source?.id;if(S===k)if(s.add(v),this.a.delete(v),e.$Bn.test(v))delete this.d[v],delete this.b.properties[v];else{const h=this.d[v];h&&(this.w(v,h),this.r(v,h))}}this.u()}deltaConfiguration(n){let s=!1;const a=new Set;n.removedDefaults&&(this.l(n.removedDefaults,a),s=!0),n.addedDefaults&&(this.k(n.addedDefaults,a),s=!0),n.removedConfigurations&&this.o(n.removedConfigurations,a),n.addedConfigurations&&this.n(n.addedConfigurations,!1,a),this.i.fire(),this.j.fire({properties:a,defaultsOverrides:s})}notifyConfigurationSchemaUpdated(...n){this.i.fire()}registerOverrideIdentifiers(n){this.m(n),this.i.fire()}m(n){for(const s of n)this.h.add(s);this.u()}n(n,s,a){n.forEach(d=>{this.p(d,s,d.extensionInfo,d.restrictedProperties,void 0,a),this.c.push(d),this.q(d)})}o(n,s){const a=d=>{if(d.properties)for(const v in d.properties){s.add(v);const m=this.d[v];m?.policy?.name&&this.e.delete(m.policy.name),delete this.d[v],this.s(v,d.properties[v])}d.allOf?.forEach(v=>a(v))};for(const d of n){a(d);const v=this.c.indexOf(d);v!==-1&&this.c.splice(v,1)}}p(n,s=!0,a,d,v=3,m){v=P.$Lf(n.scope)?v:n.scope;const S=n.properties;if(S)for(const h in S){const w=S[h];if(s&&c(h,w)){delete S[h];continue}if(w.source=a,w.defaultDefaultValue=S[h].default,this.w(h,w),e.$Bn.test(h)?w.scope=void 0:(w.scope=P.$Lf(w.scope)?v:w.scope,w.restricted=P.$Lf(w.restricted)?!!d?.includes(h):w.restricted),S[h].hasOwnProperty("included")&&!S[h].included){this.f[h]=S[h],delete S[h];continue}else this.d[h]=S[h],S[h].policy?.name&&this.e.set(S[h].policy.name,h);!S[h].deprecationMessage&&S[h].markdownDeprecationMessage&&(S[h].deprecationMessage=S[h].markdownDeprecationMessage),m.add(h)}const k=n.allOf;if(k)for(const h of k)this.p(h,s,a,d,v,m)}getConfigurations(){return this.c}getConfigurationProperties(){return this.d}getPolicyConfigurations(){return this.e}getExcludedConfigurationProperties(){return this.f}getConfigurationDefaultsOverrides(){return this.a}q(n){const s=a=>{const d=a.properties;if(d)for(const m in d)this.r(m,d[m]);a.allOf?.forEach(s)};s(n)}r(n,s){switch(e.$sn.properties[n]=s,s.scope){case 1:e.$tn.properties[n]=s;break;case 2:e.$un.properties[n]=s;break;case 6:e.$vn.properties[n]=s;break;case 3:e.$wn.properties[n]=s;break;case 4:e.$xn.properties[n]=s;break;case 5:e.$xn.properties[n]=s,this.g.properties[n]=s;break}}s(n,s){switch(delete e.$sn.properties[n],s.scope){case 1:delete e.$tn.properties[n];break;case 2:delete e.$un.properties[n];break;case 6:delete e.$vn.properties[n];break;case 3:delete e.$wn.properties[n];break;case 4:case 5:delete e.$xn.properties[n],delete this.g.properties[n];break}}u(){for(const n of this.h.values()){const s=`[${n}]`,a={type:"object",description:M.localize(2,null),errorMessage:M.localize(3,null),$ref:e.$yn};this.w(s,a),e.$sn.properties[s]=a,e.$tn.properties[s]=a,e.$un.properties[s]=a,e.$vn.properties[s]=a,e.$wn.properties[s]=a,e.$xn.properties[s]=a}}v(){const n={type:"object",description:M.localize(4,null),errorMessage:M.localize(5,null),$ref:e.$yn};e.$sn.patternProperties[e.$An]=n,e.$tn.patternProperties[e.$An]=n,e.$un.patternProperties[e.$An]=n,e.$vn.patternProperties[e.$An]=n,e.$wn.patternProperties[e.$An]=n,e.$xn.patternProperties[e.$An]=n,this.i.fire()}w(n,s){const a=this.a.get(n);let d=a?.value,v=a?.source;P.$Jf(d)&&(d=s.defaultDefaultValue,v=void 0),P.$Jf(d)&&(d=i(s.type)),s.default=d,s.defaultValueSource=v}}const b="\\[([^\\]]+)\\]",p=new RegExp(b,"g");e.$An=`^(${b})+$`,e.$Bn=new RegExp(e.$An);function g(l){const n=[];if(e.$Bn.test(l)){let s=p.exec(l);for(;s?.length;){const a=s[1].trim();a&&n.push(a),s=p.exec(l)}}return(0,y.$Lb)(n)}e.$Cn=g;function t(l){return l.reduce((n,s)=>`${n}[${s}]`,"")}e.$Dn=t;function i(l){switch(Array.isArray(l)?l[0]:l){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.$En=i;const r=new u;E.$mn.add(e.$rn.Configuration,r);function c(l,n){return l.trim()?e.$Bn.test(l)?M.localize(7,null,l):r.getConfigurationProperties()[l]!==void 0?M.localize(8,null,l):n.policy?.name&&r.getPolicyConfigurations().get(n.policy?.name)!==void 0?M.localize(9,null,l,n.policy?.name,r.getPolicyConfigurations().get(n.policy?.name)):null:M.localize(6,null)}e.$Fn=c;function o(){const l=[],n=r.getConfigurationProperties();for(const s of Object.keys(n))l.push([s,n[s].scope]);return l.push(["launch",4]),l.push(["task",4]),l}e.$Gn=o}),define(Pe[190],Re([1,0,18,5,119,6,28,26,16,2,40,54,30]),function(be,e,y,F,P,M,A,$,E,f,C,D,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mn=e.$Ln=e.$Kn=e.$Jn=e.$In=e.$Hn=void 0;function b(s){return Object.isFrozen(s)?s:$.$bn(s)}class p{constructor(a={},d=[],v=[],m){this.b=a,this.c=d,this.d=v,this.raw=m,this.a=new Map}get rawConfiguration(){if(!this.f)if(this.raw?.length){const a=this.raw.map(d=>{if(d instanceof p)return d;const v=new g("");return v.parseRaw(d),v.configurationModel});this.f=a.reduce((d,v)=>v===d?v:d.merge(v),a[0])}else this.f=this;return this.f}get contents(){return this.b}get overrides(){return this.d}get keys(){return this.c}isEmpty(){return this.c.length===0&&Object.keys(this.b).length===0&&this.d.length===0}getValue(a){return a?(0,C.$xi)(this.contents,a):this.contents}inspect(a,d){const v=this.rawConfiguration.getValue(a),m=d?this.rawConfiguration.getOverrideValue(a,d):void 0,S=d?this.rawConfiguration.override(d).getValue(a):v;return{value:v,override:m,merged:S}}getOverrideValue(a,d){const v=this.i(d);return v?a?(0,C.$xi)(v,a):v:void 0}getKeysForOverrideIdentifier(a){const d=[];for(const v of this.overrides)v.identifiers.includes(a)&&d.push(...v.keys);return y.$Lb(d)}getAllOverrideIdentifiers(){const a=[];for(const d of this.overrides)a.push(...d.identifiers);return y.$Lb(a)}override(a){let d=this.a.get(a);return d||(d=this.g(a),this.a.set(a,d)),d}merge(...a){const d=$.$an(this.contents),v=$.$an(this.overrides),m=[...this.keys],S=this.raw?.length?[...this.raw]:[this];for(const k of a)if(S.push(...k.raw?.length?k.raw:[k]),!k.isEmpty()){this.h(d,k.contents);for(const h of k.overrides){const[w]=v.filter(I=>y.$tb(I.identifiers,h.identifiers));w?(this.h(w.contents,h.contents),w.keys.push(...h.keys),w.keys=y.$Lb(w.keys)):v.push($.$an(h))}for(const h of k.keys)m.indexOf(h)===-1&&m.push(h)}return new p(d,m,v,S.every(k=>k instanceof p)?void 0:S)}g(a){const d=this.i(a);if(!d||typeof d!="object"||!Object.keys(d).length)return this;const v={};for(const m of y.$Lb([...Object.keys(this.contents),...Object.keys(d)])){let S=this.contents[m];const k=d[m];k&&(typeof S=="object"&&typeof k=="object"?(S=$.$an(S),this.h(S,k)):S=k),v[m]=S}return new p(v,this.keys,this.overrides)}h(a,d){for(const v of Object.keys(d)){if(v in a&&E.$Ef(a[v])&&E.$Ef(d[v])){this.h(a[v],d[v]);continue}a[v]=$.$an(d[v])}}i(a){let d=null,v=null;const m=S=>{S&&(v?this.h(v,S):v=$.$an(S))};for(const S of this.overrides)S.identifiers.length===1&&S.identifiers[0]===a?d=S.contents:S.identifiers.includes(a)&&m(S.contents);return m(d),v}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}addValue(a,d){this.j(a,d,!0)}setValue(a,d){this.j(a,d,!1)}removeValue(a){const d=this.keys.indexOf(a);d!==-1&&(this.keys.splice(d,1),(0,C.$wi)(this.contents,a),D.$Bn.test(a)&&this.overrides.splice(this.overrides.findIndex(v=>y.$tb(v.identifiers,(0,D.$Cn)(a))),1))}j(a,d,v){(0,C.$vi)(this.contents,a,d,m=>console.error(m)),v=v||this.keys.indexOf(a)===-1,v&&this.keys.push(a),D.$Bn.test(a)&&this.overrides.push({identifiers:(0,D.$Cn)(a),keys:Object.keys(this.contents[a]),contents:(0,C.$ui)(this.contents[a],m=>console.error(m))})}}e.$Hn=p;class g{constructor(a){this.f=a,this.a=null,this.b=null,this.c=[],this.d=[]}get configurationModel(){return this.b||new p}get restrictedConfigurations(){return this.c}get errors(){return this.d}parse(a,d){if(!E.$Lf(a)){const v=this.g(a);this.parseRaw(v,d)}}reparse(a){this.a&&this.parseRaw(this.a,a)}parseRaw(a,d){this.a=a;const{contents:v,keys:m,overrides:S,restricted:k,hasExcludedProperties:h}=this.h(a,d);this.b=new p(v,m,S,h?[a]:void 0),this.c=k||[]}g(a){let d={},v=null,m=[];const S=[],k=[];function h(I){Array.isArray(m)?m.push(I):v!==null&&(m[v]=I)}const w={onObjectBegin:()=>{const I={};h(I),S.push(m),m=I,v=null},onObjectProperty:I=>{v=I},onObjectEnd:()=>{m=S.pop()},onArrayBegin:()=>{const I=[];h(I),S.push(m),m=I,v=null},onArrayEnd:()=>{m=S.pop()},onLiteralValue:h,onError:(I,L,V)=>{k.push({error:I,offset:L,length:V})}};if(a)try{P.$0m(a,w),d=m[0]||{}}catch(I){console.error(`Error while parsing settings file ${this.f}: ${I}`),this.d=[I]}return d}h(a,d){const v=u.$mn.as(D.$rn.Configuration).getConfigurationProperties(),m=this.i(a,v,!0,d);a=m.raw;const S=(0,C.$ui)(a,w=>console.error(`Conflict in settings file ${this.f}: ${w}`)),k=Object.keys(a),h=this.j(a,w=>console.error(`Conflict in settings file ${this.f}: ${w}`));return{contents:S,keys:k,overrides:h,restricted:m.restricted,hasExcludedProperties:m.hasExcludedProperties}}i(a,d,v,m){let S=!1;if(!m?.scopes&&!m?.skipRestricted&&!m?.exclude?.length)return{raw:a,restricted:[],hasExcludedProperties:S};const k={},h=[];for(const w in a)if(D.$Bn.test(w)&&v){const I=this.i(a[w],d,!1,m);k[w]=I.raw,S=S||I.hasExcludedProperties,h.push(...I.restricted)}else{const I=d[w],L=I?typeof I.scope<"u"?I.scope:3:void 0;I?.restricted&&h.push(w),!m.exclude?.includes(w)&&(m.include?.includes(w)||(L===void 0||m.scopes===void 0||m.scopes.includes(L))&&!(m.skipRestricted&&I?.restricted))?k[w]=a[w]:S=!0}return{raw:k,restricted:h,hasExcludedProperties:S}}j(a,d){const v=[];for(const m of Object.keys(a))if(D.$Bn.test(m)){const S={};for(const k in a[m])S[k]=a[m][k];v.push({identifiers:(0,D.$Cn)(m),keys:Object.keys(S),contents:(0,C.$ui)(S,d)})}return v}}e.$In=g;class t extends M.$Rc{constructor(a,d,v,m){super(),this.c=a,this.f=d,this.g=m,this.b=this.B(new F.$Rd),this.onDidChange=this.b.event,this.a=new g(this.c.toString()),this.B(this.g.watch(v.dirname(this.c))),this.B(this.g.watch(this.c)),this.B(F.Event.any(F.Event.filter(this.g.onDidFilesChange,S=>S.contains(this.c)),F.Event.filter(this.g.onDidRunOperation,S=>(S.isOperation(0)||S.isOperation(3)||S.isOperation(1)||S.isOperation(4))&&v.isEqual(S.resource,a)))(()=>this.b.fire()))}async loadConfiguration(){try{const a=await this.g.readFile(this.c);return this.a.parse(a.value.toString()||"{}",this.f),this.a.configurationModel}catch{return new p}}reparse(a){return a&&(this.f=a),this.a.reparse(this.f),this.a.configurationModel}getRestrictedSettings(){return this.a.restrictedConfigurations}}e.$Jn=t;class i{constructor(a,d,v,m,S,k,h,w,I,L,V,K,R){this.a=a,this.b=d,this.c=v,this.overrideIdentifiers=m,this.d=S,this.f=k,this.g=h,this.h=w,this.i=I,this.j=L,this.k=V,this.l=K,this.m=R}get value(){return b(this.c)}n(a,d,v){const m=a.inspect(d,v);return{get value(){return b(m.value)},get override(){return b(m.override)},get merged(){return b(m.merged)}}}get q(){return this.p||(this.p=this.n(this.d,this.a,this.b.overrideIdentifier)),this.p}get defaultValue(){return this.q.merged}get default(){return this.q.value!==void 0||this.q.override!==void 0?{value:this.q.value,override:this.q.override}:void 0}get s(){return this.r===void 0&&(this.r=this.f?this.n(this.f,this.a):null),this.r}get policyValue(){return this.s?.merged}get policy(){return this.s?.value!==void 0?{value:this.s.value}:void 0}get u(){return this.t===void 0&&(this.t=this.g?this.n(this.g,this.a):null),this.t}get applicationValue(){return this.u?.merged}get application(){return this.u?.value!==void 0||this.u?.override!==void 0?{value:this.u.value,override:this.u.override}:void 0}get w(){return this.v||(this.v=this.n(this.h,this.a,this.b.overrideIdentifier)),this.v}get userValue(){return this.w.merged}get user(){return this.w.value!==void 0||this.w.override!==void 0?{value:this.w.value,override:this.w.override}:void 0}get y(){return this.x||(this.x=this.n(this.i,this.a,this.b.overrideIdentifier)),this.x}get userLocalValue(){return this.y.merged}get userLocal(){return this.y.value!==void 0||this.y.override!==void 0?{value:this.y.value,override:this.y.override}:void 0}get A(){return this.z||(this.z=this.n(this.j,this.a,this.b.overrideIdentifier)),this.z}get userRemoteValue(){return this.A.merged}get userRemote(){return this.A.value!==void 0||this.A.override!==void 0?{value:this.A.value,override:this.A.override}:void 0}get D(){return this.B===void 0&&(this.B=this.k?this.n(this.k,this.a,this.b.overrideIdentifier):null),this.B}get workspaceValue(){return this.D?.merged}get workspace(){return this.D?.value!==void 0||this.D?.override!==void 0?{value:this.D.value,override:this.D.override}:void 0}get F(){return this.E===void 0&&(this.E=this.l?this.n(this.l,this.a,this.b.overrideIdentifier):null),this.E}get workspaceFolderValue(){return this.F?.merged}get workspaceFolder(){return this.F?.value!==void 0||this.F?.override!==void 0?{value:this.F.value,override:this.F.override}:void 0}get H(){return this.G===void 0&&(this.G=this.n(this.m,this.a,this.b.overrideIdentifier)),this.G}get memoryValue(){return this.H.merged}get memory(){return this.H.value!==void 0||this.H.override!==void 0?{value:this.H.value,override:this.H.override}:void 0}}class r{constructor(a,d,v,m,S=new p,k=new p,h=new A.$zc,w=new p,I=new A.$zc){this.c=a,this.d=d,this.f=v,this.g=m,this.h=S,this.i=k,this.j=h,this.l=w,this.m=I,this.a=null,this.b=new A.$zc,this.n=null}getValue(a,d,v){return this.p(a,d,v).getValue(a)}updateValue(a,d,v={}){let m;v.resource?(m=this.m.get(v.resource),m||(m=new p,this.m.set(v.resource,m))):m=this.l,d===void 0?m.removeValue(a):m.setValue(a,d),v.resource||(this.a=null)}inspect(a,d,v){const m=this.p(a,d,v),S=this.t(d.resource,v),k=d.resource?this.m.get(d.resource)||this.l:this.l,h=new Set;for(const w of m.overrides)for(const I of w.identifiers)m.getOverrideValue(a,I)!==void 0&&h.add(I);return new i(a,d,m.getValue(a),h.size?[...h]:void 0,this.c,this.d.isEmpty()?void 0:this.d,this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration,this.userConfiguration,this.localUserConfiguration,this.remoteUserConfiguration,v?this.i:void 0,S||void 0,k)}keys(a){const d=this.t(void 0,a);return{default:this.c.keys.slice(0),user:this.userConfiguration.keys.slice(0),workspace:this.i.keys.slice(0),workspaceFolder:d?d.keys.slice(0):[]}}updateDefaultConfiguration(a){this.c=a,this.a=null,this.b.clear()}updatePolicyConfiguration(a){this.d=a}updateApplicationConfiguration(a){this.f=a,this.a=null,this.b.clear()}updateLocalUserConfiguration(a){this.g=a,this.n=null,this.a=null,this.b.clear()}updateRemoteUserConfiguration(a){this.h=a,this.n=null,this.a=null,this.b.clear()}updateWorkspaceConfiguration(a){this.i=a,this.a=null,this.b.clear()}updateFolderConfiguration(a,d){this.j.set(a,d),this.b.delete(a)}deleteFolderConfiguration(a){this.folderConfigurations.delete(a),this.b.delete(a)}compareAndUpdateDefaultConfiguration(a,d){const v=[];if(!d){const{added:m,updated:S,removed:k}=l(this.c,a);d=[...m,...S,...k]}for(const m of d)for(const S of(0,D.$Cn)(m)){const k=this.c.getKeysForOverrideIdentifier(S),h=a.getKeysForOverrideIdentifier(S),w=[...h.filter(I=>k.indexOf(I)===-1),...k.filter(I=>h.indexOf(I)===-1),...k.filter(I=>!$.$en(this.c.override(S).getValue(I),a.override(S).getValue(I)))];v.push([S,w])}return this.updateDefaultConfiguration(a),{keys:d,overrides:v}}compareAndUpdatePolicyConfiguration(a){const{added:d,updated:v,removed:m}=l(this.d,a),S=[...d,...v,...m];return S.length&&this.updatePolicyConfiguration(a),{keys:S,overrides:[]}}compareAndUpdateApplicationConfiguration(a){const{added:d,updated:v,removed:m,overrides:S}=l(this.applicationConfiguration,a),k=[...d,...v,...m];return k.length&&this.updateApplicationConfiguration(a),{keys:k,overrides:S}}compareAndUpdateLocalUserConfiguration(a){const{added:d,updated:v,removed:m,overrides:S}=l(this.localUserConfiguration,a),k=[...d,...v,...m];return k.length&&this.updateLocalUserConfiguration(a),{keys:k,overrides:S}}compareAndUpdateRemoteUserConfiguration(a){const{added:d,updated:v,removed:m,overrides:S}=l(this.remoteUserConfiguration,a),k=[...d,...v,...m];return k.length&&this.updateRemoteUserConfiguration(a),{keys:k,overrides:S}}compareAndUpdateWorkspaceConfiguration(a){const{added:d,updated:v,removed:m,overrides:S}=l(this.workspaceConfiguration,a),k=[...d,...v,...m];return k.length&&this.updateWorkspaceConfiguration(a),{keys:k,overrides:S}}compareAndUpdateFolderConfiguration(a,d){const v=this.folderConfigurations.get(a),{added:m,updated:S,removed:k,overrides:h}=l(v,d),w=[...m,...S,...k];return(w.length||!v)&&this.updateFolderConfiguration(a,d),{keys:w,overrides:h}}compareAndDeleteFolderConfiguration(a){const d=this.folderConfigurations.get(a);if(!d)throw new Error("Unknown folder");this.deleteFolderConfiguration(a);const{added:v,updated:m,removed:S,overrides:k}=l(d,void 0);return{keys:[...v,...m,...S],overrides:k}}get defaults(){return this.c}get applicationConfiguration(){return this.f}get userConfiguration(){return this.n||(this.n=this.h.isEmpty()?this.g:this.g.merge(this.h)),this.n}get localUserConfiguration(){return this.g}get remoteUserConfiguration(){return this.h}get workspaceConfiguration(){return this.i}get folderConfigurations(){return this.j}p(a,d,v){let m=this.q(d,v);return d.overrideIdentifier&&(m=m.override(d.overrideIdentifier)),!this.d.isEmpty()&&this.d.getValue(a)!==void 0&&(m=m.merge(this.d)),m}q({resource:a},d){let v=this.r();if(d&&a){const m=d.getFolder(a);m&&(v=this.s(m.uri)||v);const S=this.m.get(a);S&&(v=v.merge(S))}return v}r(){return this.a||(this.a=this.c.merge(this.applicationConfiguration,this.userConfiguration,this.i,this.l)),this.a}s(a){let d=this.b.get(a);if(!d){const v=this.r(),m=this.j.get(a);m?(d=v.merge(m),this.b.set(a,d)):d=v}return d}t(a,d){if(d&&a){const v=d.getFolder(a);if(v)return this.j.get(v.uri)}}toData(){return{defaults:{contents:this.c.contents,overrides:this.c.overrides,keys:this.c.keys},policy:{contents:this.d.contents,overrides:this.d.overrides,keys:this.d.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this.i.contents,overrides:this.i.overrides,keys:this.i.keys},folders:[...this.j.keys()].reduce((a,d)=>{const{contents:v,overrides:m,keys:S}=this.j.get(d);return a.push([d,{contents:v,overrides:m,keys:S}]),a},[])}}allKeys(){const a=new Set;return this.c.keys.forEach(d=>a.add(d)),this.userConfiguration.keys.forEach(d=>a.add(d)),this.i.keys.forEach(d=>a.add(d)),this.j.forEach(d=>d.keys.forEach(v=>a.add(v))),[...a.values()]}u(){const a=new Set;return this.c.getAllOverrideIdentifiers().forEach(d=>a.add(d)),this.userConfiguration.getAllOverrideIdentifiers().forEach(d=>a.add(d)),this.i.getAllOverrideIdentifiers().forEach(d=>a.add(d)),this.j.forEach(d=>d.getAllOverrideIdentifiers().forEach(v=>a.add(v))),[...a.values()]}v(a){const d=new Set;return this.c.getKeysForOverrideIdentifier(a).forEach(v=>d.add(v)),this.userConfiguration.getKeysForOverrideIdentifier(a).forEach(v=>d.add(v)),this.i.getKeysForOverrideIdentifier(a).forEach(v=>d.add(v)),this.j.forEach(v=>v.getKeysForOverrideIdentifier(a).forEach(m=>d.add(m))),[...d.values()]}static parse(a){const d=this.w(a.defaults),v=this.w(a.policy),m=this.w(a.application),S=this.w(a.user),k=this.w(a.workspace),h=a.folders.reduce((w,I)=>(w.set(f.URI.revive(I[0]),this.w(I[1])),w),new A.$zc);return new r(d,v,m,S,new p,k,h,new p,new A.$zc)}static w(a){return new p(a.contents,a.keys,a.overrides)}}e.$Kn=r;function c(...s){if(s.length===0)return{keys:[],overrides:[]};if(s.length===1)return s[0];const a=new Set,d=new Map;for(const m of s)m.keys.forEach(S=>a.add(S)),m.overrides.forEach(([S,k])=>{const h=(0,A.$wc)(d,S,new Set);k.forEach(w=>h.add(w))});const v=[];return d.forEach((m,S)=>v.push([S,[...m.values()]])),{keys:[...a.values()],overrides:v}}e.$Ln=c;class o{constructor(a,d,v,m){this.change=a,this.f=d,this.g=v,this.h=m,this.a=`
`,this.b=this.a.charCodeAt(0),this.c=".".charCodeAt(0),this.affectedKeys=new Set,this.i=void 0;for(const S of a.keys)this.affectedKeys.add(S);for(const[,S]of a.overrides)for(const k of S)this.affectedKeys.add(k);this.d=this.a;for(const S of this.affectedKeys)this.d+=S+this.a}get previousConfiguration(){return!this.i&&this.f&&(this.i=r.parse(this.f.data)),this.i}affectsConfiguration(a,d){const v=this.a+a,m=this.d.indexOf(v);if(m<0)return!1;const S=m+v.length;if(S>=this.d.length)return!1;const k=this.d.charCodeAt(S);if(k!==this.b&&k!==this.c)return!1;if(d){const h=this.previousConfiguration?this.previousConfiguration.getValue(a,d,this.f?.workspace):void 0,w=this.g.getValue(a,d,this.h);return!$.$en(h,w)}return!0}}e.$Mn=o;function l(s,a){const{added:d,removed:v,updated:m}=n(a?.rawConfiguration,s?.rawConfiguration),S=[],k=s?.getAllOverrideIdentifiers()||[],h=a?.getAllOverrideIdentifiers()||[];if(a){const w=h.filter(I=>!k.includes(I));for(const I of w)S.push([I,a.getKeysForOverrideIdentifier(I)])}if(s){const w=k.filter(I=>!h.includes(I));for(const I of w)S.push([I,s.getKeysForOverrideIdentifier(I)])}if(a&&s){for(const w of k)if(h.includes(w)){const I=n({contents:s.getOverrideValue(void 0,w)||{},keys:s.getKeysForOverrideIdentifier(w)},{contents:a.getOverrideValue(void 0,w)||{},keys:a.getKeysForOverrideIdentifier(w)});S.push([w,[...I.added,...I.removed,...I.updated]])}}return{added:d,removed:v,updated:m,overrides:S}}function n(s,a){const d=s?a?s.keys.filter(S=>a.keys.indexOf(S)===-1):[...s.keys]:[],v=a?s?a.keys.filter(S=>s.keys.indexOf(S)===-1):[...a.keys]:[],m=[];if(s&&a){for(const S of a.keys)if(s.keys.indexOf(S)!==-1){const k=(0,C.$xi)(a.contents,S),h=(0,C.$xi)(s.contents,S);$.$en(k,h)||m.push(S)}}return{added:d,removed:v,updated:m}}}),define(Pe[100],Re([1,0,11,4]),function(be,e,y,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zk=e.$Yk=e.RemoteAuthorityResolverErrorCode=e.$Xk=e.$Wk=e.RemoteConnectionType=e.$Vk=void 0,e.$Vk=(0,F.$Vh)("remoteAuthorityResolverService");var P;(function(C){C[C.WebSocket=0]="WebSocket",C[C.Managed=1]="Managed"})(P||(e.RemoteConnectionType=P={}));class M{constructor(D){this.id=D,this.type=1}toString(){return`Managed(${this.id})`}}e.$Wk=M;class A{constructor(D,u){this.host=D,this.port=u,this.type=0}toString(){return`WebSocket(${this.host}:${this.port})`}}e.$Xk=A;var $;(function(C){C.Unknown="Unknown",C.NotAvailable="NotAvailable",C.TemporarilyNotAvailable="TemporarilyNotAvailable",C.NoResolverFound="NoResolverFound",C.InvalidAuthority="InvalidAuthority"})($||(e.RemoteAuthorityResolverErrorCode=$={}));class E extends y.$ab{static isNotAvailable(D){return D instanceof E&&D._code===$.NotAvailable}static isTemporarilyNotAvailable(D){return D instanceof E&&D._code===$.TemporarilyNotAvailable}static isNoResolverFound(D){return D instanceof E&&D._code===$.NoResolverFound}static isInvalidAuthority(D){return D instanceof E&&D._code===$.InvalidAuthority}static isHandled(D){return D instanceof E&&D.isHandled}constructor(D,u=$.Unknown,b){super(D),this._message=D,this._code=u,this._detail=b,this.isHandled=u===$.NotAvailable&&b===!0,Object.setPrototypeOf(this,E.prototype)}}e.$Yk=E;function f(C){const D=C.indexOf("+");return D===-1?C:C.substring(0,D)}e.$Zk=f}),define(Pe[55],Re([1,0,13]),function(be,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5k=e.$4k=e.$3k=e.$2k=e.$1k=void 0;function F(f){return f.scheme===y.Schemas.vscodeRemote?f.authority:void 0}e.$1k=F;function P(f){if(!f)return;const C=f.indexOf("+");return C<0?f:f.substr(0,C)}e.$2k=P;function M(f){return`/${f.quality??"oss"}-${f.commit??"dev"}`}e.$3k=M;function A(f){const{host:C,port:D}=E(f);if(typeof D>"u")throw new Error("Remote authority doesn't contain a port!");return{host:C,port:D}}e.$4k=A;function $(f,C){let{host:D,port:u}=E(f);return typeof u>"u"&&(u=C),{host:D,port:u}}e.$5k=$;function E(f){const C=f.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(C)return{host:C[1],port:parseInt(C[2],10)};const D=f.match(/^(\[[0-9a-z:]+\])$/);if(D)return{host:D[1],port:void 0};const u=f.match(/(.*):(\d+)$/);return u?{host:u[1],port:parseInt(u[2],10)}:{host:f,port:void 0}}}),define(Pe[22],Re([1,0,12,4,55]),function(be,e,y,F,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gm=e.$fm=e.$em=e.$dm=e.$cm=e.$bm=e.$am=e.$_l=e.TargetPlatform=e.ExtensionType=e.$$l=e.$0l=e.$9l=e.$8l=e.$7l=e.$6l=void 0,e.$6l="extensions.user.cache",e.$7l="extensions.builtin.cache",e.$8l="undefined_publisher",e.$9l=["ui","workspace","web"];function M(g){if(typeof g=="object"&&g!==null&&g.supported!==!0)return g.description}e.$0l=M,e.$$l=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var A;(function(g){g[g.System=0]="System",g[g.User=1]="User"})(A||(e.ExtensionType=A={}));var $;(function(g){g.WIN32_X64="win32-x64",g.WIN32_ARM64="win32-arm64",g.LINUX_X64="linux-x64",g.LINUX_ARM64="linux-arm64",g.LINUX_ARMHF="linux-armhf",g.ALPINE_X64="alpine-x64",g.ALPINE_ARM64="alpine-arm64",g.DARWIN_X64="darwin-x64",g.DARWIN_ARM64="darwin-arm64",g.WEB="web",g.UNIVERSAL="universal",g.UNKNOWN="unknown",g.UNDEFINED="undefined"})($||(e.TargetPlatform=$={}));class E{constructor(t){this.value=t,this._lower=t.toLowerCase()}static equals(t,i){if(typeof t>"u"||t===null)return typeof i>"u"||i===null;if(typeof i>"u"||i===null)return!1;if(typeof t=="string"||typeof i=="string"){const r=typeof t=="string"?t:t.value,c=typeof i=="string"?i:i.value;return y.$6e(r,c)}return t._lower===i._lower}static toKey(t){return typeof t=="string"?t.toLowerCase():t._lower}}e.$_l=E;class f{get size(){return this.c.size}constructor(t){if(this.c=new Set,t)for(const i of t)this.add(i)}add(t){this.c.add(E.toKey(t))}delete(t){return this.c.delete(E.toKey(t))}has(t){return this.c.has(E.toKey(t))}}e.$am=f;class C{constructor(){this.c=new Map}clear(){this.c.clear()}delete(t){this.c.delete(E.toKey(t))}get(t){return this.c.get(E.toKey(t))}has(t){return this.c.has(E.toKey(t))}set(t,i){this.c.set(E.toKey(t),i)}values(){return this.c.values()}forEach(t){this.c.forEach(t)}[Symbol.iterator](){return this.c[Symbol.iterator]()}}e.$bm=C;function D(g){return u(g)}e.$cm=D;function u(g){return g.contributes&&g.contributes.localizations?g.contributes.localizations.length>0:!1}e.$dm=u;function b(g){return g.contributes&&g.contributes.authentication?g.contributes.authentication.length>0:!1}e.$em=b;function p(g,t){if(t){const i=`onResolveRemoteAuthority:${(0,P.$2k)(t)}`;return!!g.activationEvents?.includes(i)}return!1}e.$fm=p,e.$gm=(0,F.$Vh)("IBuiltinExtensionsScannerService")}),define(Pe[101],Re([1,0,11,22]),function(be,e,y,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xF=e.$wF=void 0;class P{constructor(){this.a=new Map,this.b=new WeakMap}register(A,$){this.a.set(A,$)}readActivationEvents(A){return this.b.has(A)||this.b.set(A,this.c(A)),this.b.get(A)}createActivationEventsMap(A){const $=Object.create(null);for(const E of A){const f=this.readActivationEvents(E);f.length>0&&($[F.$_l.toKey(E.identifier)]=f)}return $}c(A){if(typeof A.main>"u"&&typeof A.browser>"u")return[];const $=Array.isArray(A.activationEvents)?A.activationEvents.slice(0):[];for(let E=0;E<$.length;E++)$[E]==="onUri"&&($[E]=`onUri:${F.$_l.toKey(A.identifier)}`);if(!A.contributes)return $;for(const E in A.contributes){const f=this.a.get(E);if(!f)continue;const C=A.contributes[E],D=Array.isArray(C)?C:[C];try{f(D,$)}catch(u){(0,y.$Z)(u)}}return $}}e.$wF=P,e.$xF=new P}),define(Pe[191],Re([1,0,21,74,38]),function(be,e,y,F,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$oo=e.$no=void 0;function M(E){if(y.$u===2&&/^penguin(\.|$)/i.test(E))return"chromebook"}function A(E,f,C,D,u,b,p,g,t){const i=Object.create(null);i["common.machineId"]=b,i["common.sqmId"]=p,i.sessionID=(0,P.$ig)()+Date.now(),i.commitHash=D,i.version=u,i["common.platformVersion"]=(E||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),i["common.platform"]=(0,y.$h)(y.$u),i["common.nodePlatform"]=F.$cc,i["common.nodeArch"]=C,i["common.product"]=t||"desktop",g&&(i["common.msftInternal"]=g);let r=0;const c=Date.now();Object.defineProperties(i,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-c,enumerable:!0},"common.sequence":{get:()=>r++,enumerable:!0}}),y.$l&&(i["common.snap"]="true");const o=M(f);return o&&(i["common.platformDetail"]=o),i}e.$no=A;function $(E){const f=F.env.USERDNSDOMAIN;if(!f)return!1;const C=f.toLowerCase();return E.some(D=>C===D)}e.$oo=$}),define(Pe[192],Re([1,0,4]),function(be,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.$sl=e.$rl=e.$ql=e.$pl=e.$ol=e.$nl=e.$ml=e.$ll=e.$kl=e.$jl=e.$il=void 0,e.$il=(0,y.$Vh)("telemetryService"),e.$jl=(0,y.$Vh)("customEndpointTelemetryService"),e.$kl="telemetry.currentSessionDate",e.$ll="telemetry.firstSessionDate",e.$ml="telemetry.lastSessionDate",e.$nl="telemetry.machineId",e.$ol="telemetry.sqmId",e.$pl="telemetry",e.$ql="telemetry.telemetryLevel",e.$rl="telemetry.enableCrashReporter",e.$sl="telemetry.enableTelemetry";var F;(function(M){M[M.NONE=0]="NONE",M[M.CRASH=1]="CRASH",M[M.ERROR=2]="ERROR",M[M.USAGE=3]="USAGE"})(F||(e.TelemetryLevel=F={}));var P;(function(M){M.OFF="off",M.CRASH="crash",M.ERROR="error",M.ON="all"})(P||(e.TelemetryConfiguration=P={}))}),define(Pe[56],Re([1,0,26,16,5,40,55,191,192]),function(be,e,y,F,P,M,A,$,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Eo=e.$Do=e.$Co=e.$Bo=e.$Ao=e.$zo=e.$yo=e.$xo=e.$wo=e.$vo=e.$uo=e.$to=e.$so=e.$ro=e.$qo=e.$po=void 0;class f{constructor(v){this.value=v,this.isTrustedTelemetryValue=!0}}e.$po=f;class C{constructor(){this.telemetryLevel=0,this.sessionId="someValue.sessionId",this.machineId="someValue.machineId",this.firstSessionDate="someValue.firstSessionDate",this.sendErrorTelemetry=!1}publicLog(){}publicLog2(){}publicLogError(){}publicLogError2(){}setExperimentProperty(){}}e.$qo=C,e.$ro=new C;class D{async publicLog(v,m,S){}async publicLogError(v,m,S){}}e.$so=D,e.$to="telemetry",e.$uo="extensionTelemetryLog",e.$vo={log:()=>null,flush:()=>Promise.resolve(null)};function u(d,v){return P.Event.debounce(v.onDidChangeConfiguration,(S,k)=>{const h=S?new Set([...S.affectedKeys,...k.affectedKeys]):k.affectedKeys;return{...k,affectedKeys:h}},1e3,!0)(S=>{S.source!==7&&d.publicLog2("updateConfiguration",{configurationSource:(0,M.$si)(S.source),configurationKeys:Array.from(S.affectedKeys)})})}e.$wo=u;function b(d,v){return!v.isBuilt&&!v.disableTelemetry?!0:!(v.disableTelemetry||!d.enableTelemetry)}e.$xo=b;function p(d,v){return v.extensionTestsLocationURI?!0:!(v.isBuilt||v.disableTelemetry||d.enableTelemetry&&d.aiConfig?.ariaKey)}e.$yo=p;function g(d){const v=d.getValue(E.$ql),m=d.getValue(E.$rl);if(d.getValue(E.$sl)===!1||m===!1)return 0;switch(v??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}e.$zo=g;function t(d){const v={},m={},S={};c(d,S);for(let k in S){k=k.length>150?k.substr(k.length-149):k;const h=S[k];typeof h=="number"?m[k]=h:typeof h=="boolean"?m[k]=h?1:0:typeof h=="string"?(h.length>8192&&console.warn(`Telemetry property: ${k} has been trimmed to 8192, the original length is ${h.length}`),v[k]=h.substring(0,8191)):typeof h<"u"&&h!==null&&(v[k]=h)}return{properties:v,measurements:m}}e.$Ao=t;const i=new Set(["ssh-remote","dev-container","attached-container","wsl","tunnel","codespaces","amlext"]);function r(d){if(!d)return"none";const v=(0,A.$2k)(d);return i.has(v)?v:"other"}e.$Bo=r;function c(d,v,m=0,S){if(d)for(const k of Object.getOwnPropertyNames(d)){const h=d[k],w=S?S+k:k;Array.isArray(h)?v[w]=(0,y.$fn)(h):h instanceof Date?v[w]=h.toISOString():(0,F.$Ef)(h)?m<2?c(h,v,m+1,w+"."):v[w]=(0,y.$fn)(h):v[w]=h}}function o(d,v){const m=d.msftInternalDomains||[],S=v.getValue("telemetry.internalTesting");return(0,$.$oo)(m)||S}e.$Co=o;function l(d){return[d.appRoot,d.extensionsPath,d.userHome.fsPath,d.tmpDir.fsPath,d.userDataPath]}e.$Do=l;function n(d,v){if(!d||!d.includes("/")&&!d.includes("\\"))return d;let m=d;const S=[];for(const I of v)for(;;){const L=I.exec(d);if(!L)break;S.push([L.index,I.lastIndex])}const k=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,h=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let w=0;for(m="";;){const I=h.exec(d);if(!I)break;const L=S.some(([V,K])=>I.index<K&&V<h.lastIndex);!k.test(I[0])&&!L&&(m+=d.substring(w,I.index)+"<REDACTED: user-file-path>",w=h.lastIndex)}return w<d.length&&(m+=d.substr(w)),m}function s(d){if(!d)return d;const v=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/i},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const m of v)if(m.regex.test(d))return`<REDACTED: ${m.label}>`;return d}function a(d,v){return(0,y.$cn)(d,m=>{if(m instanceof f||Object.hasOwnProperty.call(m,"isTrustedTelemetryValue"))return m.value;if(typeof m=="string"){let S=m.replaceAll("%20"," ");S=n(S,v);for(const k of v)S=S.replace(k,"");return S=s(S),S}})}e.$Eo=a}),define(Pe[193],Re([1,0,12,96,22,21,2,11,74,56]),function(be,e,y,F,P,M,A,$,E,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qo=e.$Po=e.$Oo=e.$No=e.$Mo=e.$Lo=e.$Ko=e.$Jo=e.$Io=e.$Ho=e.$Go=e.$Fo=void 0;function C(a,d){return a.uuid&&d.uuid?a.uuid===d.uuid:a.id===d.id?!0:(0,y.$1e)(a.id,d.id)===0}e.$Fo=C;const D=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class u{static create(d){const v=d.manifest?d.manifest.version:d.version,m=d.manifest?d.targetPlatform:d.properties.targetPlatform;return new u(d.identifier,v,m)}static parse(d){const v=D.exec(d);return v&&v[1]&&v[2]?new u({id:v[1]},v[2],v[4]||void 0):null}constructor(d,v,m="undefined"){this.version=v,this.targetPlatform=m,this.id=d.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals(d){return d instanceof u?C(this,d)&&this.version===d.version&&this.targetPlatform===d.targetPlatform:!1}}e.$Go=u;const b=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function p(a){const d=b.exec(a);return d&&d[1]?[t(d[1]),d[2]]:[t(a),void 0]}e.$Ho=p;function g(a,d){return`${a}.${d}`}e.$Io=g;function t(a){return a.toLowerCase()}e.$Jo=t;function i(a,d){return t(g(a??P.$8l,d))}e.$Ko=i;function r(a,d){const v=[],m=S=>{for(const k of v)if(k.some(h=>C(d(h),d(S))))return k;return null};for(const S of a){const k=m(S);k?k.push(S):v.push([S])}return v}e.$Lo=r;function c(a){return{id:a.identifier.id,name:a.manifest.name,galleryId:null,publisherId:a.publisherId,publisherName:a.manifest.publisher,publisherDisplayName:a.publisherDisplayName,dependencies:a.manifest.extensionDependencies&&a.manifest.extensionDependencies.length>0}}e.$Mo=c;function o(a){return{id:new f.$po(a.identifier.id),name:new f.$po(a.name),galleryId:a.identifier.uuid,publisherId:a.publisherId,publisherName:a.publisher,publisherDisplayName:a.publisherDisplayName,isPreReleaseVersion:a.properties.isPreReleaseVersion,dependencies:!!(a.properties.dependencies&&a.properties.dependencies.length>0),isSigned:a.isSigned,...a.telemetryData}}e.$No=o,e.$Oo=new P.$_l("pprice.better-merge");function l(a,d){const v=[],m=d.manifest.extensionDependencies?.slice(0)??[];for(;m.length;){const S=m.shift();if(S&&v.every(k=>!C(k.identifier,{id:S}))){const k=a.filter(h=>C(h.identifier,{id:S}));k.length===1&&(v.push(k[0]),m.push(...k[0].manifest.extensionDependencies?.slice(0)??[]))}}return v}e.$Po=l;async function n(a,d){if(!M.$k)return!1;let v;try{v=(await a.readFile(A.URI.file("/etc/os-release"))).value.toString()}catch{try{v=(await a.readFile(A.URI.file("/usr/lib/os-release"))).value.toString()}catch(S){d.debug("Error while getting the os-release file.",(0,$.$9)(S))}}return!!v&&(v.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}async function s(a,d){const v=await n(a,d),m=(0,F.$_n)(v?"alpine":M.$u,E.$dc);return d.debug("ComputeTargetPlatform:",m),m}e.$Qo=s}),define(Pe[194],Re([1,0]),function(be,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vr=e.$ur=e.$tr=e.$sr=e.$rr=e.$qr=void 0;function y(E){return[...E.entries()]}e.$qr=y;function F(E){return E?[...E.entries()]:[]}e.$rr=F;function P(E){return new Map(E)}e.$sr=P;function M(E){return new Map(E??[])}e.$tr=M;function A(E){return Array.from(E.entries()).map(f=>[f[0],y(f[1].map),F(f[1].descriptionMap)])}e.$ur=A;function $(E){return new Map(E.map(f=>[f[0],{map:P(f[1]),descriptionMap:M(f[2])}]))}e.$vr=$}),define(Pe[195],Re([1,0]),function(be,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nqb=void 0;class y{constructor(P){this.b=P,this.a=new Map}dispose(){for(const P of this.a.values())P.dispose()}startBuffering(P,M,A=5){const $=M(E=>{const f=typeof E=="string"?E:E.data;let C=this.a.get(P);if(C){C.data.push(f);return}const D=setTimeout(()=>this.flushBuffer(P),A);C={data:[f],timeoutId:D,dispose:()=>{clearTimeout(D),this.flushBuffer(P),$.dispose()}},this.a.set(P,C)});return $}stopBuffering(P){this.a.get(P)?.dispose()}flushBuffer(P){const M=this.a.get(P);M&&(this.a.delete(P),this.b(P,M.data.join("")))}}e.$nqb=y}),define(Pe[196],Re([1,0,14,90,45,5,16,2,155,73,30]),function(be,e,y,F,P,M,A,$,E,f,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gw=e.$fw=e.$ew=e.$dw=e.$cw=e.$bw=e.$aw=e.$_v=e.IconFontDefinition=e.IconContribution=e.$$v=void 0,e.$$v={IconContribution:"base.contributions.icons"};var D;(function(o){function l(n,s){let a=n.defaults;for(;P.ThemeIcon.isThemeIcon(a);){const d=p.getIcon(a.id);if(!d)return;a=d.defaults}return a}o.getDefinition=l})(D||(e.IconContribution=D={}));var u;(function(o){function l(s){return{weight:s.weight,style:s.style,src:s.src.map(a=>({format:a.format,location:a.location.toString()}))}}o.toJSONObject=l;function n(s){const a=d=>(0,A.$Cf)(d)?d:void 0;if(s&&Array.isArray(s.src)&&s.src.every(d=>(0,A.$Cf)(d.format)&&(0,A.$Cf)(d.location)))return{weight:a(s.weight),style:a(s.style),src:s.src.map(d=>({format:d.format,location:$.URI.parse(d.location)}))}}o.fromJSONObject=n})(u||(e.IconFontDefinition=u={}));class b{constructor(){this.a=new M.$Rd,this.onDidChange=this.a.event,this.d={definitions:{icons:{type:"object",properties:{fontId:{type:"string",description:(0,E.localize)(0,null)},fontCharacter:{type:"string",description:(0,E.localize)(1,null)}},additionalProperties:!1,defaultSnippets:[{body:{fontCharacter:"\\\\e030"}}]}},type:"object",properties:{}},this.e={type:"string",pattern:`^${P.ThemeIcon.iconNameExpression}$`,enum:[],enumDescriptions:[]},this.b={},this.f={}}registerIcon(l,n,s,a){const d=this.b[l];if(d){if(s&&!d.description){d.description=s,this.d.properties[l].markdownDescription=`${s} $(${l})`;const S=this.e.enum.indexOf(l);S!==-1&&(this.e.enumDescriptions[S]=s),this.a.fire()}return d}const v={id:l,description:s,defaults:n,deprecationMessage:a};this.b[l]=v;const m={$ref:"#/definitions/icons"};return a&&(m.deprecationMessage=a),s&&(m.markdownDescription=`${s}: $(${l})`),this.d.properties[l]=m,this.e.enum.push(l),this.e.enumDescriptions.push(s||""),this.a.fire(),{id:l}}deregisterIcon(l){delete this.b[l],delete this.d.properties[l];const n=this.e.enum.indexOf(l);n!==-1&&(this.e.enum.splice(n,1),this.e.enumDescriptions.splice(n,1)),this.a.fire()}getIcons(){return Object.keys(this.b).map(l=>this.b[l])}getIcon(l){return this.b[l]}getIconSchema(){return this.d}getIconReferenceSchema(){return this.e}registerIconFont(l,n){const s=this.f[l];return s||(this.f[l]=n,this.a.fire(),n)}deregisterIconFont(l){delete this.f[l]}getIconFont(l){return this.f[l]}toString(){const l=(d,v)=>d.id.localeCompare(v.id),n=d=>{for(;P.ThemeIcon.isThemeIcon(d.defaults);)d=this.b[d.defaults.id];return`codicon codicon-${d?d.id:""}`},s=[];s.push("| preview     | identifier                        | default codicon ID                | description"),s.push("| ----------- | --------------------------------- | --------------------------------- | --------------------------------- |");const a=Object.keys(this.b).map(d=>this.b[d]);for(const d of a.filter(v=>!!v.description).sort(l))s.push(`|<i class="${n(d)}"></i>|${d.id}|${P.ThemeIcon.isThemeIcon(d.defaults)?d.defaults.id:d.id}|${d.description||""}|`);s.push("| preview     | identifier                        "),s.push("| ----------- | --------------------------------- |");for(const d of a.filter(v=>!P.ThemeIcon.isThemeIcon(v.defaults)).sort(l))s.push(`|<i class="${n(d)}"></i>|${d.id}|`);return s.join(`
`)}}const p=new b;C.$mn.add(e.$$v.IconContribution,p);function g(o,l,n,s){return p.registerIcon(o,l,n,s)}e.$_v=g;function t(){return p}e.$aw=t;function i(){const o=(0,F.$Yj)();for(const l in o){const n="\\"+o[l].toString(16);p.registerIcon(l,{fontCharacter:n})}}i(),e.$bw="vscode://schemas/icons";const r=C.$mn.as(f.$nn.JSONContribution);r.registerSchema(e.$bw,p.getIconSchema());const c=new y.$0g(()=>r.notifySchemaChanged(e.$bw),200);p.onDidChange(()=>{c.isScheduled()||c.schedule()}),e.$cw=g("widget-close",F.$1j.close,(0,E.localize)(2,null)),e.$dw=g("goto-previous-location",F.$1j.arrowUp,(0,E.localize)(3,null)),e.$ew=g("goto-next-location",F.$1j.arrowDown,(0,E.localize)(4,null)),e.$fw=P.ThemeIcon.modify(F.$1j.sync,"spin"),e.$gw=P.ThemeIcon.modify(F.$1j.loading,"spin")}),define(Pe[197],Re([1,0,5,40,4,15]),function(be,e,y,F,P,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nv=e.$mv=e.$lv=e.$kv=e.$jv=e.$iv=e.$hv=e.$gv=e.ProvidedOnAutoForward=e.$fv=e.TunnelPrivacyId=e.TunnelProtocol=e.$ev=e.$dv=void 0,e.$dv=(0,P.$Vh)("tunnelService"),e.$ev=(0,P.$Vh)("sharedTunnelsService");var A;(function(t){t.Http="http",t.Https="https"})(A||(e.TunnelProtocol=A={}));var $;(function(t){t.ConstantPrivate="constantPrivate",t.Private="private",t.Public="public"})($||(e.TunnelPrivacyId=$={}));function E(t){return!!t.forwardPort}e.$fv=E;var f;(function(t){t[t.Notify=1]="Notify",t[t.OpenBrowser=2]="OpenBrowser",t[t.OpenPreview=3]="OpenPreview",t[t.Silent=4]="Silent",t[t.Ignore=5]="Ignore",t[t.OpenBrowserOnce=6]="OpenBrowserOnce"})(f||(e.ProvidedOnAutoForward=f={}));function C(t){if(t.scheme!=="http"&&t.scheme!=="https")return;const i=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(t.authority);if(i)return{address:i[1],port:+i[2]}}e.$gv=C,e.$hv=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function D(t){return e.$hv.indexOf(t)>=0}e.$iv=D,e.$jv=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function u(t){return e.$jv.indexOf(t)>=0}e.$kv=u;function b(t,i,r,c){if(r===1)return!1;if(r===2&&u(i)){const o=/(\d+)\.(\d+)\.(\d+)/g.exec(c);if(o?.length===4&&parseInt(o[1])>=18)return!1}return t<1024}e.$lv=b;class p{constructor(i,r,c){this.remoteAddress=i,this.localAddress=r,this.b=c,this.a=new y.$Rd,this.onDidDispose=this.a.event}dispose(){return this.a.fire(),this.b()}}e.$mv=p;let g=class{constructor(i,r){this.j=i,this.k=r,this.a=new y.$Rd,this.onTunnelOpened=this.a.event,this.b=new y.$Rd,this.onTunnelClosed=this.b.event,this.c=new y.$Rd,this.onAddedTunnelProvider=this.c.event,this.e=new Map,this.g=!1,this.h=[],this.i=new Set}get hasTunnelProvider(){return!!this.f}get l(){const i=this.k.getValue("remote.localPortHost");return!i||i==="localhost"?"127.0.0.1":"0.0.0.0"}setTunnelProvider(i){return this.f=i,i?(this.c.fire(),{dispose:()=>{this.f=void 0,this.g=!1,this.h=[]}}):(this.g=!1,this.h=[],this.c.fire(),{dispose:()=>{}})}setTunnelFeatures(i){this.g=i.elevation,this.h=i.privacyOptions}get canElevate(){return this.g}get canChangePrivacy(){return this.h.length>0}get privacyOptions(){return this.h}get tunnels(){return this.m()}async m(){const i=[],r=Array.from(this.e.values());for(const c of r){const o=Array.from(c.values());for(const l of o){const n=await l.value;n&&typeof n!="string"&&i.push(n)}}return i}async dispose(){for(const i of this.e.values()){for(const{value:r}of i.values())await r.then(c=>typeof c!="string"?c?.dispose():void 0);i.clear()}this.e.clear()}setEnvironmentTunnel(i,r,c,o,l){this.p(i,r,Promise.resolve({tunnelRemoteHost:i,tunnelRemotePort:r,localAddress:c,privacy:o,protocol:l,dispose:()=>Promise.resolve()}))}async getExistingTunnel(i,r){(u(i)||D(i))&&(i=e.$hv[0]);const c=this.r(i,r);if(c)return++c.refcount,c.value}openTunnel(i,r,c,o,l,n=!1,s,a){this.j.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${r}:${c} on local port ${l}.`);const d=this.f??i;if(!d)return;if(r||(r="localhost"),o||(o=this.l),this.f&&this.i.has(c)){this.j.debug("ForwardedPorts: (TunnelService) Another call to create a tunnel with the same address has occurred before the last one completed. This call will be ignored.");return}const v=this.s(d,r,c,o,l,n,s,a);return v?v.then(m=>{if(m){if(typeof m=="string")return this.j.trace("ForwardedPorts: (TunnelService) The tunnel provider returned an error when creating the tunnel."),this.q(r,c),m}else{this.j.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.q(r,c);return}this.j.trace("ForwardedPorts: (TunnelService) New tunnel established.");const S=this.n(m);return(m.tunnelRemoteHost!==r||m.tunnelRemotePort!==c)&&this.j.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),s&&m.privacy!==s&&this.j.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Privacy mismatch."),this.a.fire(S),S}):(this.j.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),v)}n(i){return{tunnelRemotePort:i.tunnelRemotePort,tunnelRemoteHost:i.tunnelRemoteHost,tunnelLocalPort:i.tunnelLocalPort,localAddress:i.localAddress,privacy:i.privacy,protocol:i.protocol,dispose:async()=>{this.j.trace(`ForwardedPorts: (TunnelService) dispose request for ${i.tunnelRemoteHost}:${i.tunnelRemotePort} `);const r=this.e.get(i.tunnelRemoteHost);if(r){const c=r.get(i.tunnelRemotePort);c&&(c.refcount--,await this.o(i.tunnelRemoteHost,i.tunnelRemotePort,c))}}}}async o(i,r,c){if(c.refcount<=0){this.j.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${i}:${r}.`);const o=c.value.then(async l=>{l&&typeof l!="string"&&(await l.dispose(!0),this.b.fire({host:l.tunnelRemoteHost,port:l.tunnelRemotePort}))});return this.e.has(i)&&this.e.get(i).delete(r),o}}async closeTunnel(i,r){this.j.trace(`ForwardedPorts: (TunnelService) close request for ${i}:${r} `);const c=this.e.get(i);if(c&&c.has(r)){const o=c.get(r);o.refcount=0,await this.o(i,r,o)}}p(i,r,c){this.e.has(i)||this.e.set(i,new Map),this.e.get(i).set(r,{refcount:1,value:c})}async q(i,r){const c=this.e.get(i);if(c){const o=c.get(r),l=o?await o.value:void 0;(!l||typeof l=="string")&&c.delete(r),c.size===0&&this.e.delete(i)}}r(i,r){const c=[i];D(i)?(c.push(...e.$hv),c.push(...e.$jv)):u(i)&&c.push(...e.$jv);const o=c.map(l=>this.e.get(l));for(const l of o){const n=l?.get(r);if(n)return n}}canTunnel(i){return!!C(i)}t(i,r,c,o,l,n,s){this.j.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${r}:${c} on local port ${o}.`);const a=c;this.i.add(a);const d=o===void 0?c:o,v={elevationRequired:l?this.isPortPrivileged(d):!1},m={remoteAddress:{host:r,port:c},localAddressPort:o,privacy:n,public:n?n!==$.Private:void 0,protocol:s},S=i.forwardPort(m,v);return S?(this.p(r,c,S),S.finally(()=>{this.j.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),this.i.delete(a)})):this.i.delete(a),S}};e.$nv=g,e.$nv=g=Ke([Ve(0,M.$dj),Ve(1,F.$pi)],g)}),define(Pe[198],Re([1,0,4]),function(be,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditSessionIdentityMatch=e.$ov=void 0,e.$ov=(0,y.$Vh)("editSessionIdentityService");var F;(function(P){P[P.Complete=100]="Complete",P[P.Partial=50]="Partial",P[P.None=0]="None"})(F||(e.EditSessionIdentityMatch=F={}))}),define(Pe[199],Re([1,0,13]),function(be,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$J=e.$0J=e.$9J=e.$8J=e.$7J=void 0;function F(E){return E.scheme!==y.Schemas.file&&E.scheme!==y.Schemas.vscodeRemote}e.$7J=F;function P(E){if(E.folders.length)return E.folders.every(f=>F(f.uri))?E.folders[0].uri:void 0;if(E.configuration&&F(E.configuration))return E.configuration}e.$8J=P;function M(E){return P(E)?.scheme}e.$9J=M;function A(E){return P(E)?.authority}e.$0J=A;function $(E){return P(E)!==void 0}e.$$J=$}),define(Pe[47],Re([1,0,156,19,50,25,2,4,13]),function(be,e,y,F,P,M,A,$,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$oi=e.$ni=e.$mi=e.$li=e.$ki=e.$ji=e.$ii=e.$hi=e.$gi=e.$fi=e.$ei=e.$di=e.$ci=e.$bi=e.$ai=e.WorkbenchState=e.$_h=e.$$h=e.$0h=e.$9h=e.$8h=e.$7h=e.$6h=e.$5h=void 0,e.$5h=(0,$.$Vh)("contextService");function f(d){const v=d;return typeof v?.id=="string"&&A.URI.isUri(v.uri)}e.$6h=f;function C(d){return typeof d?.id=="string"&&!f(d)&&!u(d)}e.$7h=C,e.$8h={id:"ext-dev"},e.$9h={id:"empty-window"};function D(d,v){if(typeof d=="string"||typeof d>"u")return typeof d=="string"?{id:(0,F.$mc)(d)}:v?e.$8h:e.$9h;const m=d;return m.configuration?{id:m.id,configPath:m.configuration}:m.folders.length===1?{id:m.id,uri:m.folders[0].uri}:{id:m.id}}e.$0h=D;function u(d){const v=d;return typeof v?.id=="string"&&A.URI.isUri(v.configPath)}e.$$h=u;function b(d){const v=d;if(v?.uri)return{id:v.id,uri:A.URI.revive(v.uri)};const m=d;if(m?.configPath)return{id:m.id,configPath:A.URI.revive(m.configPath)};if(d?.id)return{id:d.id}}e.$_h=b;var p;(function(d){d[d.EMPTY=1]="EMPTY",d[d.FOLDER=2]="FOLDER",d[d.WORKSPACE=3]="WORKSPACE"})(p||(e.WorkbenchState=p={}));function g(d){const v=d;return!!(v&&typeof v=="object"&&typeof v.id=="string"&&Array.isArray(v.folders))}e.$ai=g;function t(d){const v=d;return!!(v&&typeof v=="object"&&A.URI.isUri(v.uri)&&typeof v.name=="string"&&typeof v.toResource=="function")}e.$bi=t;class i{constructor(v,m,S,k,h){this.h=v,this.j=S,this.k=k,this.l=h,this.c=P.$2h.forUris(this.l,()=>!0),this.folders=m}update(v){this.h=v.id,this.k=v.configuration,this.j=v.transient,this.l=v.l,this.folders=v.folders}get folders(){return this.g}set folders(v){this.g=v,this.n()}get id(){return this.h}get transient(){return this.j}get configuration(){return this.k}set configuration(v){this.k=v}getFolder(v){return v&&this.c.findSubstr(v)||null}n(){this.c=P.$2h.forUris(this.l,()=>!0);for(const v of this.folders)this.c.set(v.uri,v)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.$ci=i;class r{constructor(v,m){this.raw=m,this.uri=v.uri,this.index=v.index,this.name=v.name}toResource(v){return(0,M.$zg)(this.uri,v)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.$di=r;function c(d){return new r({uri:d,index:0,name:(0,M.$vg)(d)},{uri:d.toString()})}e.$ei=c,e.$fi="code-workspace",e.$gi=`.${e.$fi}`,e.$hi=[{name:(0,y.localize)(0,null),extensions:[e.$fi]}],e.$ii="workspace.json";function o(d,v){return M.$qg.isEqualOrParent(d,v.untitledWorkspacesHome)}e.$ji=o;function l(d){let v;return A.URI.isUri(d)?v=d:v=d.configuration,v?.scheme===E.Schemas.tmp}e.$ki=l,e.$li="4064f6ec-cb38-4ad0-af64-ee6467e63c82";function n(d){return d.id===e.$li}e.$mi=n;function s(d,v){return!o(d,v)&&!l(d)}e.$ni=s;function a(d){return(typeof d=="string"?(0,F.$nc)(d):(0,M.$xg)(d))===e.$gi}e.$oi=a}),define(Pe[75],Re([1,0]),function(be,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ddc=void 0;class y{static{this.a=!1}constructor(P){this.d=P,this.b=new Map,this.c=1}add(P){const M=this.c++;return this.b.set(M,P),this.e(),M}get(P,M){return this.b.has(P)?this.b.get(P)[M]:void 0}delete(P){this.b.delete(P),this.e()}e(){y.a&&console.log(`${this.d} cache size - ${this.b.size}`)}}e.$Ddc=y}),define(Pe[42],Re([1,0,13,25,4]),function(be,e,y,F,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hdc=e.$Gdc=void 0;class M{constructor(){this.a=new Set(Object.keys(y.Schemas)),this.b=new Map,this.extUri=new F.$og($=>{const E=this.b.get($.scheme);return!(E===void 0||E&1024)})}$acceptProviderInfos($,E){E===null?this.b.delete($.scheme):this.b.set($.scheme,E)}isFreeScheme($){return!this.b.has($)&&!this.a.has($)}getCapabilities($){return this.b.get($)}}e.$Gdc=M,e.$Hdc=(0,P.$Vh)("IExtHostFileSystemInfo")}),define(Pe[27],Re([1,0,4]),function(be,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$PM=void 0,e.$PM=(0,y.$Vh)("IExtHostInitDataService")}),define(Pe[200],Re([1,0,161,15,187,27]),function(be,e,y,F,P,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nfc=void 0;let A=class extends P.$WN{constructor(E,f,C){const D=C.remote.isRemote?"remoteexthost":E?"workerexthost":"exthost",u=C.remote.isRemote?(0,y.localize)(0,null):E?(0,y.localize)(1,null):(0,y.localize)(2,null);super(f.createLogger(D,{name:u}))}};e.$Nfc=A,e.$Nfc=A=Ke([Ve(1,F.$ej),Ve(2,M.$PM)],A)}),define(Pe[201],Re([1,0,14]),function(be,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qec=e.$pec=void 0;class F{constructor(A,$,E){this.h=new Map,this.a=A,this.b=$,this.c=E,this.d=this.c.initializeExtensionStorage(this.b,this.a,Object.create(null)).then(f=>(this.f=f,this)),this.g=this.c.onDidChangeStorage(f=>{f.shared===this.b&&f.key===this.a&&(this.f=f.value)}),this.i=new y.$0g(()=>{const f=this.h;this.h=new Map,(async()=>{try{await this.c.setValue(this.b,this.a,this.f);for(const C of f.values())C.complete()}catch(C){for(const D of f.values())D.error(C)}})()},0)}keys(){return Object.entries(this.f??{}).filter(([,A])=>A!==void 0).map(([A])=>A)}get whenReady(){return this.d}get(A,$){let E=this.f[A];return typeof E>"u"&&(E=$),E}update(A,$){this.f[A]=$;const E=this.h.get(A);if(E!==void 0)return E.p;const f=new y.$ih;return this.h.set(A,f),this.i.isScheduled()||this.i.schedule(),f.p}dispose(){this.g.dispose()}}e.$pec=F;class P extends F{setKeysForSync(A){this.c.registerExtensionStorageKeysToSync({id:this.a,version:this.j.version},A)}constructor(A,$){super(A.identifier.value,!0,$),this.j=A}}e.$qec=P}),define(Pe[202],Re([1,0,5,2]),function(be,e,y,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dfc=void 0;class P{constructor(A){this.c=A,this.a=new y.$Rd,this.onDidSaveNotebookDocument=this.a.event,this.b=new y.$Rd,this.onDidChangeNotebookDocument=this.b.event}$acceptModelChanged(A,$,E,f){const D=this.c.getNotebookDocument(F.URI.revive(A)).acceptModelChanged($.value,E,f);this.b.fire(D)}$acceptDirtyStateChanged(A,$){this.c.getNotebookDocument(F.URI.revive(A)).acceptDirty($)}$acceptModelSaved(A){const $=this.c.getNotebookDocument(F.URI.revive(A));this.a.fire($.apiNotebook)}}e.$dfc=P}),define(Pe[17],Re([1,0,4]),function(be,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$AM=e.$zM=void 0,e.$zM=(0,y.$Vh)("IExtHostRpcService");class F{constructor(M){this.getProxy=M.getProxy.bind(M),this.set=M.set.bind(M),this.dispose=M.dispose.bind(M),this.assertRegistered=M.assertRegistered.bind(M),this.drain=M.drain.bind(M)}}e.$AM=F}),define(Pe[203],Re([1,0,22,5]),function(be,e,y,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xec=void 0;class P{#e;constructor(A,$){this.b=new F.$Rd,this.onDidChange=this.b.event,this.a=y.$_l.toKey(A.identifier),this.#e=$,this.#e.onDidChangePassword(E=>{E.extensionId===this.a&&this.b.fire({key:E.key})})}get(A){return this.#e.get(this.a,A)}store(A,$){return this.#e.store(this.a,A,$)}delete(A){return this.#e.delete(this.a,A)}}e.$xec=P}),define(Pe[57],Re([1,0,4]),function(be,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1dc=e.$Zdc=void 0,e.$Zdc=(0,y.$Vh)("IURITransformerService");class F{constructor(M){M?(this.transformIncoming=M.transformIncoming.bind(M),this.transformOutgoing=M.transformOutgoing.bind(M),this.transformOutgoingURI=M.transformOutgoingURI.bind(M),this.transformOutgoingScheme=M.transformOutgoingScheme.bind(M)):(this.transformIncoming=A=>A,this.transformOutgoing=A=>A,this.transformOutgoingURI=A=>A,this.transformOutgoingScheme=A=>A)}}e.$1dc=F}),define(Pe[204],Re([1,0,24]),function(be,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$adb=e.$_cb=void 0;class F{constructor(){this.buffers=[]}add(E){let f=this.buffers.indexOf(E);return f<0&&(f=this.buffers.length,this.buffers.push(E)),f}}function P($,E){if(E.serializeBuffersForPostMessage){const f=new F,D=JSON.stringify($,(b,p)=>{if(p instanceof ArrayBuffer)return{$$vscode_array_buffer_reference$$:!0,index:f.add(p)};if(ArrayBuffer.isView(p)){const g=M(p);if(g)return{$$vscode_array_buffer_reference$$:!0,index:f.add(p.buffer),view:{type:g,byteLength:p.byteLength,byteOffset:p.byteOffset}}}return p}),u=f.buffers.map(b=>{const p=new Uint8Array(b);return y.$fe.wrap(p)});return{message:D,buffers:u}}else return{message:JSON.stringify($),buffers:[]}}e.$_cb=P;function M($){switch($.constructor.name){case"Int8Array":return 1;case"Uint8Array":return 2;case"Uint8ClampedArray":return 3;case"Int16Array":return 4;case"Uint16Array":return 5;case"Int32Array":return 6;case"Uint32Array":return 7;case"Float32Array":return 8;case"Float64Array":return 9;case"BigInt64Array":return 10;case"BigUint64Array":return 11}}function A($,E){const f=E.map(u=>{const b=new ArrayBuffer(u.byteLength);return new Uint8Array(b).set(u.buffer),b}),C=E.length?(u,b)=>{if(b&&typeof b=="object"&&b.$$vscode_array_buffer_reference$$){const p=b,{index:g}=p,t=f[g];if(p.view)switch(p.view.type){case 1:return new Int8Array(t,p.view.byteOffset,p.view.byteLength/Int8Array.BYTES_PER_ELEMENT);case 2:return new Uint8Array(t,p.view.byteOffset,p.view.byteLength/Uint8Array.BYTES_PER_ELEMENT);case 3:return new Uint8ClampedArray(t,p.view.byteOffset,p.view.byteLength/Uint8ClampedArray.BYTES_PER_ELEMENT);case 4:return new Int16Array(t,p.view.byteOffset,p.view.byteLength/Int16Array.BYTES_PER_ELEMENT);case 5:return new Uint16Array(t,p.view.byteOffset,p.view.byteLength/Uint16Array.BYTES_PER_ELEMENT);case 6:return new Int32Array(t,p.view.byteOffset,p.view.byteLength/Int32Array.BYTES_PER_ELEMENT);case 7:return new Uint32Array(t,p.view.byteOffset,p.view.byteLength/Uint32Array.BYTES_PER_ELEMENT);case 8:return new Float32Array(t,p.view.byteOffset,p.view.byteLength/Float32Array.BYTES_PER_ELEMENT);case 9:return new Float64Array(t,p.view.byteOffset,p.view.byteLength/Float64Array.BYTES_PER_ELEMENT);case 10:return new BigInt64Array(t,p.view.byteOffset,p.view.byteLength/BigInt64Array.BYTES_PER_ELEMENT);case 11:return new BigUint64Array(t,p.view.byteOffset,p.view.byteLength/BigUint64Array.BYTES_PER_ELEMENT);default:throw new Error("Unknown array buffer view type")}return t}return b}:void 0;return{message:JSON.parse($,C),arrayBuffers:f}}e.$adb=A}),define(Pe[102],Re([1,0,171,16,2,6,4,30,41,13,39,134,31]),function(be,e,y,F,P,M,A,$,E,f,C,D,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$AE=e.$zE=e.$yE=e.EditorsOrder=e.$xE=e.CloseDirection=e.$wE=e.$vE=e.EditorCloseMethod=e.SideBySideEditor=e.GroupModelChangeKind=e.EditorCloseContext=e.$uE=e.$tE=e.$sE=e.$rE=e.$qE=e.$pE=e.$oE=e.$nE=e.EditorInputCapabilities=e.$mE=e.SaveReason=e.Verbosity=e.$lE=e.$kE=e.$jE=e.$iE=e.$hE=e.$gE=e.$fE=e.$eE=e.EditorPaneSelectionCompareResult=e.EditorPaneSelectionChangeReason=e.$dE=e.$cE=e.$bE=e.$aE=e.$_D=void 0,e.$_D={EditorPane:"workbench.contributions.editors",EditorFactory:"workbench.contributions.editor.inputFactories"},e.$aE={id:"default",displayName:(0,y.localize)(0,null),providerDisplayName:(0,y.localize)(1,null)},e.$bE="workbench.editor.sidebysideEditor",e.$cE="workbench.editors.textDiffEditor",e.$dE="workbench.editors.binaryResourceDiffEditor";var b;(function(se){se[se.PROGRAMMATIC=1]="PROGRAMMATIC",se[se.USER=2]="USER",se[se.EDIT=3]="EDIT",se[se.NAVIGATION=4]="NAVIGATION",se[se.JUMP=5]="JUMP"})(b||(e.EditorPaneSelectionChangeReason=b={}));var p;(function(se){se[se.IDENTICAL=1]="IDENTICAL",se[se.SIMILAR=2]="SIMILAR",se[se.DIFFERENT=3]="DIFFERENT"})(p||(e.EditorPaneSelectionCompareResult=p={}));function g(se){const X=se;return!!X&&typeof X.getSelection=="function"&&!!X.onDidChangeSelection}e.$eE=g;function t(se,X,B){for(const ie of B.visibleEditorPanes)if(ie.group.id===X&&se.matches(ie.input))return ie.getViewState()}e.$fE=t;function i(se){if(S(se))return!1;const X=se;return P.URI.isUri(X?.resource)}e.$gE=i;function r(se){if(S(se))return!1;const X=se;return X?.original!==void 0&&X.modified!==void 0}e.$hE=r;function c(se){if(S(se))return!1;const X=se;return Array.isArray(X?.resources)}e.$iE=c;function o(se){if(S(se)||r(se))return!1;const X=se;return X?.primary!==void 0&&X.secondary!==void 0}e.$jE=o;function l(se){if(S(se))return!1;const X=se;return X?X.resource===void 0||X.resource.scheme===f.Schemas.untitled||X.forceUntitled===!0:!1}e.$kE=l;function n(se){if(S(se))return!1;const X=se;return P.URI.isUri(X?.base?.resource)&&P.URI.isUri(X?.input1?.resource)&&P.URI.isUri(X?.input2?.resource)&&P.URI.isUri(X?.result?.resource)}e.$lE=n;var s;(function(se){se[se.SHORT=0]="SHORT",se[se.MEDIUM=1]="MEDIUM",se[se.LONG=2]="LONG"})(s||(e.Verbosity=s={}));var a;(function(se){se[se.EXPLICIT=1]="EXPLICIT",se[se.AUTO=2]="AUTO",se[se.FOCUS_CHANGE=3]="FOCUS_CHANGE",se[se.WINDOW_CHANGE=4]="WINDOW_CHANGE"})(a||(e.SaveReason=a={}));class d{constructor(){this.a=new Map}registerSource(X,B){let ie=this.a.get(X);return ie||(ie={source:X,label:B},this.a.set(X,ie)),ie.source}getSourceLabel(X){return this.a.get(X)?.label??X}}e.$mE=new d;var v;(function(se){se[se.None=0]="None",se[se.Readonly=2]="Readonly",se[se.Untitled=4]="Untitled",se[se.Singleton=8]="Singleton",se[se.RequiresTrust=16]="RequiresTrust",se[se.CanSplitInGroup=32]="CanSplitInGroup",se[se.ForceDescription=64]="ForceDescription",se[se.CanDropIntoEditor=128]="CanDropIntoEditor",se[se.MultipleEditors=256]="MultipleEditors",se[se.Scratchpad=512]="Scratchpad",se[se.AuxWindowUnsupported=1024]="AuxWindowUnsupported"})(v||(e.EditorInputCapabilities=v={}));class m extends M.$Rc{}e.$nE=m;function S(se){return se instanceof m}e.$oE=S;function k(se){const X=se;return P.URI.isUri(X?.preferredResource)}function h(se){const X=se;return S(X?.primary)&&S(X?.secondary)}e.$pE=h;function w(se){const X=se;return S(X?.modified)&&S(X?.original)}e.$qE=w;function I(se,X,B,ie,pe){return Ae(ie,[(0,D.$Fi)({id:"workbench.action.openLargeFile",label:(0,y.localize)(2,null),run:()=>{const ne={...B,limits:{size:Number.MAX_VALUE}};se.openEditor(X,ne)}}),(0,D.$Fi)({id:"workbench.action.configureEditorLargeFileConfirmation",label:(0,y.localize)(3,null),run:()=>pe.openUserSettings({query:"workbench.editorLargeFileConfirmation"})})],{forceMessage:!0,forceSeverity:u.default.Warning})}e.$rE=I;function L(se){return S(se?.editor)}e.$sE=L;function V(se){const X=se;return L(se)&&X?.group!==void 0}e.$tE=V;function K(se){const X=se;return typeof X?.groupId=="number"&&S(X.editor)}e.$uE=K;var R;(function(se){se[se.UNKNOWN=0]="UNKNOWN",se[se.REPLACE=1]="REPLACE",se[se.MOVE=2]="MOVE",se[se.UNPIN=3]="UNPIN"})(R||(e.EditorCloseContext=R={}));var N;(function(se){se[se.GROUP_ACTIVE=0]="GROUP_ACTIVE",se[se.GROUP_INDEX=1]="GROUP_INDEX",se[se.GROUP_LABEL=2]="GROUP_LABEL",se[se.GROUP_LOCKED=3]="GROUP_LOCKED",se[se.EDITOR_OPEN=4]="EDITOR_OPEN",se[se.EDITOR_CLOSE=5]="EDITOR_CLOSE",se[se.EDITOR_MOVE=6]="EDITOR_MOVE",se[se.EDITOR_ACTIVE=7]="EDITOR_ACTIVE",se[se.EDITOR_LABEL=8]="EDITOR_LABEL",se[se.EDITOR_CAPABILITIES=9]="EDITOR_CAPABILITIES",se[se.EDITOR_PIN=10]="EDITOR_PIN",se[se.EDITOR_STICKY=11]="EDITOR_STICKY",se[se.EDITOR_DIRTY=12]="EDITOR_DIRTY",se[se.EDITOR_WILL_DISPOSE=13]="EDITOR_WILL_DISPOSE"})(N||(e.GroupModelChangeKind=N={}));var T;(function(se){se[se.PRIMARY=1]="PRIMARY",se[se.SECONDARY=2]="SECONDARY",se[se.BOTH=3]="BOTH",se[se.ANY=4]="ANY"})(T||(e.SideBySideEditor=T={}));class z{getOriginalUri(X,B){if(!X)return;if(n(X))return e.$wE.getOriginalUri(X.result,B);if(B?.supportSideBySide){const{primary:pe,secondary:ne}=this.a(X);if(pe&&ne){if(B?.supportSideBySide===T.BOTH)return{primary:this.getOriginalUri(pe,{filterByScheme:B.filterByScheme}),secondary:this.getOriginalUri(ne,{filterByScheme:B.filterByScheme})};if(B?.supportSideBySide===T.ANY)return this.getOriginalUri(pe,{filterByScheme:B.filterByScheme})??this.getOriginalUri(ne,{filterByScheme:B.filterByScheme});X=B.supportSideBySide===T.PRIMARY?pe:ne}}if(r(X)||c(X)||o(X)||n(X))return;const ie=k(X)?X.preferredResource:X.resource;return!ie||!B||!B.filterByScheme?ie:this.b(ie,B.filterByScheme)}a(X){return h(X)||o(X)?{primary:X.primary,secondary:X.secondary}:w(X)||r(X)?{primary:X.modified,secondary:X.original}:{primary:void 0,secondary:void 0}}getCanonicalUri(X,B){if(!X)return;if(n(X))return e.$wE.getCanonicalUri(X.result,B);if(B?.supportSideBySide){const{primary:pe,secondary:ne}=this.a(X);if(pe&&ne){if(B?.supportSideBySide===T.BOTH)return{primary:this.getCanonicalUri(pe,{filterByScheme:B.filterByScheme}),secondary:this.getCanonicalUri(ne,{filterByScheme:B.filterByScheme})};if(B?.supportSideBySide===T.ANY)return this.getCanonicalUri(pe,{filterByScheme:B.filterByScheme})??this.getCanonicalUri(ne,{filterByScheme:B.filterByScheme});X=B.supportSideBySide===T.PRIMARY?pe:ne}}if(r(X)||c(X)||o(X)||n(X))return;const ie=X.resource;return!ie||!B||!B.filterByScheme?ie:this.b(ie,B.filterByScheme)}b(X,B){if(Array.isArray(B)){if(B.some(ie=>X.scheme===ie))return X}else if(B===X.scheme)return X}}var Z;(function(se){se[se.UNKNOWN=0]="UNKNOWN",se[se.KEYBOARD=1]="KEYBOARD",se[se.MOUSE=2]="MOUSE"})(Z||(e.EditorCloseMethod=Z={}));function he(se,X,B,ie){if(!se.isSticky(X))return!1;switch(ie.preventPinnedEditorClose){case"keyboardAndMouse":return B===Z.MOUSE||B===Z.KEYBOARD;case"mouse":return B===Z.MOUSE;case"keyboard":return B===Z.KEYBOARD}return!1}e.$vE=he,e.$wE=new z;var ye;(function(se){se[se.LEFT=0]="LEFT",se[se.RIGHT=1]="RIGHT"})(ye||(e.CloseDirection=ye={}));class De{constructor(){this.c=new Map,this.d=new Map}start(X){const B=this.a=X.get(A.$Uh);for(const[ie,pe]of this.c)this.e(ie,pe,B);this.c.clear()}e(X,B,ie){const pe=ie.createInstance(B);this.d.set(X,pe)}registerFileEditorFactory(X){if(this.b)throw new Error("Can only register one file editor factory.");this.b=X}getFileEditorFactory(){return(0,F.$Nf)(this.b)}registerEditorSerializer(X,B){if(this.c.has(X)||this.d.has(X))throw new Error(`A editor serializer with type ID '${X}' was already registered.`);return this.a?this.e(X,B,this.a):this.c.set(X,B),(0,M.$Pc)(()=>{this.c.delete(X),this.d.delete(X)})}getEditorSerializer(X){return this.d.get(typeof X=="string"?X:X.typeId)}}$.$mn.add(e.$_D.EditorFactory,new De);async function Se(se,X,B){return!se||!se.length?[]:await Promise.all(se.map(async ie=>{const pe=P.URI.revive(ie.fileUri);if(!pe){B.info("Cannot resolve the path because it is not valid.",ie);return}if(!await X.canHandleResource(pe)){B.info("Cannot resolve the path because it cannot be handled",ie);return}let le=ie.exists,ce=ie.type;if(typeof le!="boolean"||typeof ce!="number")try{ce=(await X.stat(pe)).isDirectory?E.FileType.Directory:E.FileType.Unknown,le=!0}catch(_){B.error(_),le=!1}if(!le&&ie.openOnlyIfExists){B.info("Cannot resolve the path because it does not exist",ie);return}if(ce===E.FileType.Directory){B.info("Cannot resolve the path because it is a directory",ie);return}const we={...ie.options,pinned:!0};return le?{resource:pe,options:we}:{resource:pe,options:we,forceUntitled:!0}}))}e.$xE=Se;var fe;(function(se){se[se.MOST_RECENTLY_ACTIVE=0]="MOST_RECENTLY_ACTIVE",se[se.SEQUENTIAL=1]="SEQUENTIAL"})(fe||(e.EditorsOrder=fe={}));function $e(se){const X=se;if(!X)return!1;const B=X;if(B.modified)return $e(B.modified);const ie=X;return!!(ie.contributionsState&&ie.viewState&&Array.isArray(ie.cursorState))}e.$yE=$e;function re(se){return(0,C.$Hi)(se)}e.$zE=re;function Ae(se,X,B){const ie=(0,C.$Ii)(se,X);return ie.forceMessage=B?.forceMessage,ie.forceSeverity=B?.forceSeverity,ie.allowDialog=B?.allowDialog,ie}e.$AE=Ae}),define(Pe[205],Re([1,0,5,172,4,6,28,30,18,26,90,196]),function(be,e,y,F,P,M,A,$,E,f,C,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$JE=e.$IE=e.TreeItemCollapsibleState=e.ViewVisibilityState=e.$HE=e.$GE=e.ViewContentGroups=e.$FE=e.$EE=e.ViewContainerLocation=e.Extensions=e.$DE=e.$CE=e.$BE=void 0,e.$BE="views",e.$CE=(0,F.localize)(0,null),e.$DE=(0,D.$_v)("default-view-icon",C.$1j.window,(0,F.localize)(1,null));var u;(function(s){s.ViewContainersRegistry="workbench.registry.view.containers",s.ViewsRegistry="workbench.registry.view"})(u||(e.Extensions=u={}));var b;(function(s){s[s.Sidebar=0]="Sidebar",s[s.Panel=1]="Panel",s[s.AuxiliaryBar=2]="AuxiliaryBar"})(b||(e.ViewContainerLocation=b={})),e.$EE=[0,1,2];function p(s){switch(s){case 0:return"sidebar";case 1:return"panel";case 2:return"auxiliarybar"}}e.$FE=p;class g extends M.$Rc{constructor(){super(...arguments),this.c=this.B(new y.$Rd),this.onDidRegister=this.c.event,this.f=this.B(new y.$Rd),this.onDidDeregister=this.f.event,this.g=new Map,this.h=[]}get all(){return(0,E.$Qb)([...this.g.values()])}registerViewContainer(a,d,v){const m=this.get(a.id);if(m)return m;const S=a;return S.openCommandActionDescriptor=v?.doNotRegisterOpenCommand?void 0:S.openCommandActionDescriptor??{id:S.id},(0,A.$wc)(this.g,d,[]).push(S),v?.isDefault&&this.h.push(S),this.c.fire({viewContainer:S,viewContainerLocation:d}),S}deregisterViewContainer(a){for(const d of this.g.keys()){const v=this.g.get(d),m=v?.indexOf(a);if(m!==-1){v?.splice(m,1),v.length===0&&this.g.delete(d),this.f.fire({viewContainer:a,viewContainerLocation:d});return}}}get(a){return this.all.filter(d=>d.id===a)[0]}getViewContainers(a){return[...this.g.get(a)||[]]}getViewContainerLocation(a){return[...this.g.keys()].filter(d=>this.getViewContainers(d).filter(v=>v?.id===a.id).length>0)[0]}getDefaultViewContainer(a){return this.h.find(d=>this.getViewContainerLocation(d)===a)}}$.$mn.add(u.ViewContainersRegistry,new g);var t;(function(s){s.Open="2_open",s.Debug="4_debug",s.SCM="5_scm",s.More="9_more"})(t||(e.ViewContentGroups=t={}));function i(s,a){const d=s.group??t.More,v=a.group??t.More;return d!==v?d.localeCompare(v):(s.order??5)-(a.order??5)}class r extends M.$Rc{constructor(){super(...arguments),this.c=this.B(new y.$Rd),this.onViewsRegistered=this.c.event,this.f=this.B(new y.$Rd),this.onViewsDeregistered=this.f.event,this.g=this.B(new y.$Rd),this.onDidChangeContainer=this.g.event,this.h=this.B(new y.$Rd),this.onDidChangeViewWelcomeContent=this.h.event,this.j=[],this.m=new Map,this.n=new A.$Fc}registerViews(a,d){this.registerViews2([{views:a,viewContainer:d}])}registerViews2(a){a.forEach(({views:d,viewContainer:v})=>this.r(d,v)),this.c.fire(a)}deregisterViews(a,d){const v=this.s(a,d);v.length&&this.f.fire({views:v,viewContainer:d})}moveViews(a,d){for(const v of this.m.keys())if(v!==d){const m=this.s(a,v);m.length&&(this.r(m,d),this.g.fire({views:m,from:v,to:d}))}}getViews(a){return this.m.get(a)||[]}getView(a){for(const d of this.j){const v=(this.m.get(d)||[]).filter(m=>m.id===a)[0];if(v)return v}return null}getViewContainer(a){for(const d of this.j)if((this.m.get(d)||[]).filter(m=>m.id===a)[0])return d;return null}registerViewWelcomeContent(a,d){return this.n.add(a,d),this.h.fire(a),(0,M.$Pc)(()=>{this.n.delete(a,d),this.h.fire(a)})}registerViewWelcomeContent2(a,d){const v=new Map;for(const[m,S]of d)this.n.add(a,S),v.set(m,(0,M.$Pc)(()=>{this.n.delete(a,S),this.h.fire(a)}));return this.h.fire(a),v}getViewWelcomeContent(a){const d=[];return this.n.forEach(a,v=>d.push(v)),d.sort(i)}r(a,d){let v=this.m.get(d);v||(v=[],this.m.set(d,v),this.j.push(d));for(const m of a){if(this.getView(m.id)!==null)throw new Error((0,F.localize)(2,null,m.id));v.push(m)}}s(a,d){const v=this.m.get(d);if(!v)return[];const m=[],S=[];for(const k of v)a.includes(k)?m.push(k):S.push(k);return m.length&&(S.length?this.m.set(d,S):(this.m.delete(d),this.j.splice(this.j.indexOf(d),1))),m}}$.$mn.add(u.ViewsRegistry,new r),e.$GE=(0,P.$Vh)("viewsService"),e.$HE=(0,P.$Vh)("viewDescriptorService");var c;(function(s){s[s.Default=0]="Default",s[s.Expand=1]="Expand"})(c||(e.ViewVisibilityState=c={}));var o;(function(s){s[s.None=0]="None",s[s.Collapsed=1]="Collapsed",s[s.Expanded=2]="Expanded"})(o||(e.TreeItemCollapsibleState=o={}));class l{constructor(a,d){this.c=!1,this.d=!1,(0,f.$dn)(this,a),this.d=!!d,this.resolve=async v=>{if(d&&!this.c){const m=await d(v);m&&(this.tooltip=this.tooltip??m.tooltip,this.command=this.command??m.command)}v.isCancellationRequested||(this.c=!0)}}get hasResolve(){return this.d}resetResolve(){this.c=!1}asTreeItem(){return{handle:this.handle,parentHandle:this.parentHandle,collapsibleState:this.collapsibleState,label:this.label,description:this.description,icon:this.icon,iconDark:this.iconDark,themeIcon:this.themeIcon,resourceUri:this.resourceUri,tooltip:this.tooltip,contextValue:this.contextValue,command:this.command,children:this.children,accessibilityInformation:this.accessibilityInformation}}}e.$IE=l;class n extends Error{constructor(a){super((0,F.localize)(3,null,a)),this.name="NoTreeViewError"}static is(a){return a.name==="NoTreeViewError"}}e.$JE=n}),define(Pe[206],Re([1,0,2,29,4]),function(be,e,y,F,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_E=e.InteractiveSessionCopyKind=e.InteractiveSessionVoteDirection=e.$$E=e.$0E=void 0;function M(f){return!!f&&typeof f=="object"&&"uri"in f&&f.uri instanceof y.URI&&"version"in f&&typeof f.version=="number"&&"ranges"in f&&Array.isArray(f.ranges)&&f.ranges.every(F.$zs.isIRange)}e.$0E=M;function A(f){return!!f&&typeof f=="object"&&"documents"in f&&Array.isArray(f.documents)&&f.documents.every(M)}e.$$E=A;var $;(function(f){f[f.Down=0]="Down",f[f.Up=1]="Up"})($||(e.InteractiveSessionVoteDirection=$={}));var E;(function(f){f[f.Action=1]="Action",f[f.Toolbar=2]="Toolbar"})(E||(e.InteractiveSessionCopyKind=E={})),e.$_E=(0,P.$Vh)("IChatService")}),define(Pe[207],Re([1,0,5,14,173]),function(be,e,y,F,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fdb=void 0;class M{constructor(){this.f=new Map,this.k=[],this.m=new y.$Rd,this.n=new y.$Rd,this.d=1}get onError(){return this.m.event}get onExit(){return this.n.event}onMessage($){this.j&&this.m.fire(new Error("attempt to set more than one 'Message' callback")),this.j=$}onEvent($){this.i&&this.m.fire(new Error("attempt to set more than one 'Event' callback")),this.i=$}onRequest($){this.g&&this.m.fire(new Error("attempt to set more than one 'Request' callback")),this.g=$}sendResponse($){$.seq>0?this.m.fire(new Error(`attempt to send more than one response for command ${$.command}`)):this.s("response",$)}sendRequest($,E,f,C){const D={command:$};if(E&&Object.keys(E).length>0&&(D.arguments=E),this.s("request",D),typeof C=="number"){const u=setTimeout(()=>{clearTimeout(u);const b=this.f.get(D.seq);if(b){this.f.delete(D.seq);const p={type:"response",seq:0,request_seq:D.seq,success:!1,command:$,message:(0,P.localize)(0,null,C,$)};b(p)}},C)}return f&&this.f.set(D.seq,f),D.seq}acceptMessage($){this.j?this.j($):(this.k.push($),this.k.length===1&&this.q())}o($,E){return $.type!=="event"||E.type!=="event"}async q(){let $;for(;this.k.length;){if((!$||this.o(this.k[0],$))&&await(0,F.$Yg)(0),$=this.k.shift(),!$)return;switch($.type){case"event":this.i?.($);break;case"request":this.g?.($);break;case"response":{const E=$,f=this.f.get(E.request_seq);f&&(this.f.delete(E.request_seq),f(E));break}}}}s($,E){E.type=$,E.seq=this.d++,this.sendMessage(E)}async u(){if(this.f.size===0)return Promise.resolve();const $=new Map;this.f.forEach((E,f)=>$.set(f,E)),await(0,F.$Yg)(500),$.forEach((E,f)=>{E({type:"response",seq:0,request_seq:f,success:!1,command:"canceled",message:"canceled"}),this.f.delete(f)})}getPendingRequestIds(){return Array.from(this.f.keys())}dispose(){this.k=[]}}e.$Fdb=M}),define(Pe[208],Re([1,0,174,34,4]),function(be,e,y,F,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BreakpointWidgetContext=e.$kH=e.DebuggerString=e.DebugConfigurationProviderTriggerKind=e.$jH=e.MemoryRangeType=e.$iH=e.State=e.$hH=e.$gH=e.$fH=e.$eH=e.$dH=e.$cH=e.$bH=e.$aH=e.$_G=e.$$G=e.$0G=e.$9G=e.$8G=e.$7G=e.$6G=e.$5G=e.$4G=e.$3G=e.$2G=e.$1G=e.$ZG=e.$YG=e.$XG=e.$WG=e.$VG=e.$UG=e.$TG=e.$SG=e.$RG=e.$QG=e.$PG=e.$OG=e.$NG=e.$MG=e.$LG=e.$KG=e.$JG=e.$IG=e.$HG=e.$GG=e.$FG=e.$EG=e.$DG=e.$CG=e.$BG=e.$AG=e.$zG=e.$yG=e.$xG=e.$wG=e.$vG=e.$uG=e.$tG=e.$sG=e.$rG=e.$qG=e.$pG=e.$oG=e.$nG=e.$mG=e.$lG=e.$kG=e.$jG=e.$iG=e.$hG=e.$gG=e.$fG=void 0,e.$fG="workbench.view.debug",e.$gG="workbench.debug.variablesView",e.$hG="workbench.debug.watchExpressionsView",e.$iG="workbench.debug.callStackView",e.$jG="workbench.debug.loadedScriptsView",e.$kG="workbench.debug.breakPointsView",e.$lG="workbench.debug.disassemblyView",e.$mG="workbench.panel.repl",e.$nG="workbench.panel.repl.view",e.$oG=new F.$aj("debugType",void 0,{type:"string",description:y.localize(0,null)}),e.$pG=new F.$aj("debugConfigurationType",void 0,{type:"string",description:y.localize(1,null)}),e.$qG=new F.$aj("debugState","inactive",{type:"string",description:y.localize(2,null)}),e.$rG="debugUx",e.$sG=new F.$aj(e.$rG,"default",{type:"string",description:y.localize(3,null)}),e.$tG=new F.$aj("hasDebugged",!1,{type:"boolean",description:y.localize(4,null)}),e.$uG=new F.$aj("inDebugMode",!1,{type:"boolean",description:y.localize(5,null)}),e.$vG=new F.$aj("inDebugRepl",!1,{type:"boolean",description:y.localize(6,null)}),e.$wG=new F.$aj("breakpointWidgetVisible",!1,{type:"boolean",description:y.localize(7,null)}),e.$xG=new F.$aj("inBreakpointWidget",!1,{type:"boolean",description:y.localize(8,null)}),e.$yG=new F.$aj("breakpointsFocused",!0,{type:"boolean",description:y.localize(9,null)}),e.$zG=new F.$aj("watchExpressionsFocused",!0,{type:"boolean",description:y.localize(10,null)}),e.$AG=new F.$aj("watchExpressionsExist",!1,{type:"boolean",description:y.localize(11,null)}),e.$BG=new F.$aj("variablesFocused",!0,{type:"boolean",description:y.localize(12,null)}),e.$CG=new F.$aj("expressionSelected",!1,{type:"boolean",description:y.localize(13,null)}),e.$DG=new F.$aj("breakpointInputFocused",!1,{type:"boolean",description:y.localize(14,null)}),e.$EG=new F.$aj("callStackItemType",void 0,{type:"string",description:y.localize(15,null)}),e.$FG=new F.$aj("callStackSessionIsAttach",!1,{type:"boolean",description:y.localize(16,null)}),e.$GG=new F.$aj("callStackItemStopped",!1,{type:"boolean",description:y.localize(17,null)}),e.$HG=new F.$aj("callStackSessionHasOneThread",!1,{type:"boolean",description:y.localize(18,null)}),e.$IG=new F.$aj("watchItemType",void 0,{type:"string",description:y.localize(19,null)}),e.$JG=new F.$aj("canViewMemory",void 0,{type:"boolean",description:y.localize(20,null)}),e.$KG=new F.$aj("breakpointItemType",void 0,{type:"string",description:y.localize(21,null)}),e.$LG=new F.$aj("breakpointSupportsCondition",!1,{type:"boolean",description:y.localize(22,null)}),e.$MG=new F.$aj("loadedScriptsSupported",!1,{type:"boolean",description:y.localize(23,null)}),e.$NG=new F.$aj("loadedScriptsItemType",void 0,{type:"string",description:y.localize(24,null)}),e.$OG=new F.$aj("focusedSessionIsAttach",!1,{type:"boolean",description:y.localize(25,null)}),e.$PG=new F.$aj("focusedSessionIsNoDebug",!1,{type:"boolean",description:y.localize(26,null)}),e.$QG=new F.$aj("stepBackSupported",!1,{type:"boolean",description:y.localize(27,null)}),e.$RG=new F.$aj("restartFrameSupported",!1,{type:"boolean",description:y.localize(28,null)}),e.$SG=new F.$aj("stackFrameSupportsRestart",!1,{type:"boolean",description:y.localize(29,null)}),e.$TG=new F.$aj("jumpToCursorSupported",!1,{type:"boolean",description:y.localize(30,null)}),e.$UG=new F.$aj("stepIntoTargetsSupported",!1,{type:"boolean",description:y.localize(31,null)}),e.$VG=new F.$aj("breakpointsExist",!1,{type:"boolean",description:y.localize(32,null)}),e.$WG=new F.$aj("debuggersAvailable",!1,{type:"boolean",description:y.localize(33,null)}),e.$XG=new F.$aj("debugExtensionAvailable",!0,{type:"boolean",description:y.localize(34,null)}),e.$YG=new F.$aj("debugProtocolVariableMenuContext",void 0,{type:"string",description:y.localize(35,null)}),e.$ZG=new F.$aj("debugSetVariableSupported",!1,{type:"boolean",description:y.localize(36,null)}),e.$1G=new F.$aj("debugSetExpressionSupported",!1,{type:"boolean",description:y.localize(37,null)}),e.$2G=new F.$aj("breakWhenValueChangesSupported",!1,{type:"boolean",description:y.localize(38,null)}),e.$3G=new F.$aj("breakWhenValueIsAccessedSupported",!1,{type:"boolean",description:y.localize(39,null)}),e.$4G=new F.$aj("breakWhenValueIsReadSupported",!1,{type:"boolean",description:y.localize(40,null)}),e.$5G=new F.$aj("terminateDebuggeeSupported",!1,{type:"boolean",description:y.localize(41,null)}),e.$6G=new F.$aj("suspendDebuggeeSupported",!1,{type:"boolean",description:y.localize(42,null)}),e.$7G=new F.$aj("variableEvaluateNamePresent",!1,{type:"boolean",description:y.localize(43,null)}),e.$8G=new F.$aj("variableIsReadonly",!1,{type:"boolean",description:y.localize(44,null)}),e.$9G=new F.$aj("exceptionWidgetVisible",!1,{type:"boolean",description:y.localize(45,null)}),e.$0G=new F.$aj("multiSessionRepl",!1,{type:"boolean",description:y.localize(46,null)}),e.$$G=new F.$aj("multiSessionDebug",!1,{type:"boolean",description:y.localize(47,null)}),e.$_G=new F.$aj("disassembleRequestSupported",!1,{type:"boolean",description:y.localize(48,null)}),e.$aH=new F.$aj("disassemblyViewFocus",!1,{type:"boolean",description:y.localize(49,null)}),e.$bH=new F.$aj("languageSupportsDisassembleRequest",!1,{type:"boolean",description:y.localize(50,null)}),e.$cH=new F.$aj("focusedStackFrameHasInstructionReference",!1,{type:"boolean",description:y.localize(51,null)});const M=u=>y.localize(52,null,u);e.$dH=M,e.$eH="editor.contrib.debug",e.$fH="editor.contrib.breakpoint",e.$gH="debug",e.$hH={enum:["neverOpen","openOnSessionStart","openOnFirstSessionStart"],default:"openOnFirstSessionStart",description:y.localize(53,null)};var A;(function(u){u[u.Inactive=0]="Inactive",u[u.Initializing=1]="Initializing",u[u.Stopped=2]="Stopped",u[u.Running=3]="Running"})(A||(e.State=A={}));function $(u){switch(u){case 1:return"initializing";case 2:return"stopped";case 3:return"running";default:return"inactive"}}e.$iH=$;var E;(function(u){u[u.Valid=0]="Valid",u[u.Unreadable=1]="Unreadable",u[u.Error=2]="Error"})(E||(e.MemoryRangeType=E={})),e.$jH="vscode-debug-memory";var f;(function(u){u[u.Initial=1]="Initial",u[u.Dynamic=2]="Dynamic"})(f||(e.DebugConfigurationProviderTriggerKind=f={}));var C;(function(u){u.UnverifiedBreakpoints="unverifiedBreakpoints"})(C||(e.DebuggerString=C={})),e.$kH=(0,P.$Vh)("debugService");var D;(function(u){u[u.CONDITION=0]="CONDITION",u[u.HIT_COUNT=1]="HIT_COUNT",u[u.LOG_MESSAGE=2]="LOG_MESSAGE"})(D||(e.BreakpointWidgetContext=D={}))}),define(Pe[209],Re([1,0,12,2,19,26,13,29,20,18]),function(be,e,y,F,P,M,A,$,E,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qF=e.$pF=e.$oF=e.$nF=e.$mF=e.$lF=e.$kF=e.$jF=e.$iF=e.$hF=e.$gF=e.$fF=e.$eF=void 0;const C=/{([^}]+)}/g;function D(k,h,w){return k.replace(C,function(I,L){return h&&L.length>0&&L[0]!=="_"?I:w&&w.hasOwnProperty(L)?w[L]:I})}e.$eF=D;function u(k){const h={};for(const w of Object.keys(k))w.startsWith("!")||(h[w]=k[w]);return h}e.$fF=u;function b(k){return k.configuration.request==="attach"&&!p(k)&&(!k.parentSession||b(k.parentSession))}e.$gF=b;function p(k){let h=k.configuration.type;if(h)return h==="vslsShare"&&(h=k.configuration.adapterProxy.configuration.type),(0,y.$6e)(h,"extensionhost")||(0,y.$6e)(h,"pwa-extensionhost")?k:k.parentSession?p(k.parentSession):void 0}e.$hF=p;function g(k){return k.type&&(k.label||k.program||k.runtime)}e.$iF=g;function t(k,h,w){let I,L=0;const V=/([^()\[\]{}<>\s+\-/%~#^;=|,`!]|\->)+/g;let K=null;for(;K=V.exec(k);){const R=K.index+1,N=R+K[0].length;if(R<=h&&N>=w){I=K[0],L=R;break}}if(I){const R=/\w+/g;let N=null;for(;(N=R.exec(I))&&!(N.index+1+L+N[0].length>=w););N&&(I=I.substring(0,R.lastIndex))}return I?{start:L,end:L+I.length-1}:{start:0,end:0}}e.$jF=t;async function i(k,h,w,I){if(k.evaluatableExpressionProvider.has(h)){const L=k.evaluatableExpressionProvider.ordered(h),V=(0,f.$Gb)(await Promise.all(L.map(async K=>{try{return await K.provideEvaluatableExpression(h,w,I??E.CancellationToken.None)}catch{return}})));if(V.length>0){let K=V[0].expression;const R=V[0].range;return K||(K=h.getLineContent(w.lineNumber).substring(R.startColumn-1,R.endColumn-1)),{range:R,matchingExpression:K}}}else{const L=h.getLineContent(w.lineNumber),{start:V,end:K}=t(L,w.column,w.column),R=L.substring(V-1,K);return{matchingExpression:R,range:new $.$zs(w.lineNumber,V,w.lineNumber,V+R.length)}}return null}e.$kF=i;const r=/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/;function c(k){return!!(k&&k.match(r))}e.$lF=c;function o(k){if(typeof k.path=="string"&&!(typeof k.sourceReference=="number"&&k.sourceReference>0)){if(c(k.path))return F.URI.parse(k.path);if((0,P.$hc)(k.path))return F.URI.file(k.path)}return k.path}function l(k){if(typeof k.path=="object"){const h=F.URI.revive(k.path);if(h)return h.scheme===A.Schemas.file?h.fsPath:h.toString()}return k.path}function n(k,h){const w=h?o:l,I=(0,M.$an)(k);return a(I,(L,V)=>{L&&V&&(V.path=w(V))}),I}e.$mF=n;function s(k,h){const w=h?o:l,I=(0,M.$an)(k);return a(I,(L,V)=>{!L&&V&&(V.path=w(V))}),I}e.$nF=s;function a(k,h){switch(k.type){case"event":{const w=k;switch(w.event){case"output":h(!1,w.body.source);break;case"loadedSource":h(!1,w.body.source);break;case"breakpoint":h(!1,w.body.breakpoint.source);break;default:break}break}case"request":{const w=k;switch(w.command){case"setBreakpoints":h(!0,w.arguments.source);break;case"breakpointLocations":h(!0,w.arguments.source);break;case"source":h(!0,w.arguments.source);break;case"gotoTargets":h(!0,w.arguments.source);break;case"launchVSCode":w.arguments.args.forEach(I=>h(!1,I));break;default:break}break}case"response":{const w=k;if(w.success&&w.body)switch(w.command){case"stackTrace":w.body.stackFrames.forEach(I=>h(!1,I.source));break;case"loadedSources":w.body.sources.forEach(I=>h(!1,I));break;case"scopes":w.body.scopes.forEach(I=>h(!1,I.source));break;case"setFunctionBreakpoints":w.body.breakpoints.forEach(I=>h(!1,I.source));break;case"setBreakpoints":w.body.breakpoints.forEach(I=>h(!1,I.source));break;case"disassemble":w.body?.instructions.forEach(L=>h(!1,L.location));break;default:break}break}}}function d(k){return k.filter(h=>!h.presentation?.hidden).sort((h,w)=>h.presentation?w.presentation?h.presentation.group?w.presentation.group?h.presentation.group!==w.presentation.group?h.presentation.group.localeCompare(w.presentation.group):v(h.presentation.order,w.presentation.order):-1:w.presentation.group?1:v(h.presentation.order,w.presentation.order):-1:w.presentation?1:0)}e.$oF=d;function v(k,h){return typeof k!="number"?typeof h!="number"?0:1:typeof h!="number"?-1:k-h}async function m(k,h){const w=k.getValue("debug.saveBeforeStart",{overrideIdentifier:h.activeTextEditorLanguageId});if(w!=="none"&&(await h.saveAll(),w==="allEditorsInActiveGroup")){const I=h.activeEditorPane;I&&I.input.resource?.scheme===A.Schemas.untitled&&await h.save({editor:I.input,groupId:I.group.id})}await k.reloadConfiguration()}e.$pF=m;const S=(k,h)=>!k||!h?k===h:k.name===h.name&&k.path===h.path&&k.sourceReference===h.sourceReference;e.$qF=S}),define(Pe[76],Re([1,0,24,33,67,68,13,19,21,34]),function(be,e,y,F,P,M,A,$,E,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$DI=e.$CI=e.$BI=e.$AI=e.CellStatusbarAlignment=e.$zI=e.$yI=e.$xI=e.NotebookEditorPriority=e.$wI=e.$vI=e.$uI=e.$tI=e.CellUri=e.CellEditType=e.SelectionStateType=e.NotebookCellsChangeType=e.RendererMessagingSpec=e.NotebookRendererMatch=e.NotebookExecutionState=e.NotebookCellExecutionState=e.NotebookRunState=e.$sI=e.$rI=e.$qI=e.$pI=e.CellKind=e.$oI=e.$nI=e.$mI=void 0,e.$mI="workbench.editor.notebook",e.$nI="workbench.editor.notebookTextDiffEditor",e.$oI="workbench.editor.interactive";var C;(function(z){z[z.Markup=1]="Markup",z[z.Code=2]="Code"})(C||(e.CellKind=C={})),e.$pI=["application/json","application/javascript","text/html","image/svg+xml",M.$Vr.latex,M.$Vr.markdown,"image/png","image/jpeg",M.$Vr.text],e.$qI=[M.$Vr.latex,M.$Vr.markdown,"application/json","text/html","image/svg+xml","image/png","image/jpeg",M.$Vr.text],e.$rI=new Map([["ms-toolsai.jupyter",new Set(["jupyter-notebook","interactive"])],["ms-toolsai.jupyter-renderers",new Set(["jupyter-notebook","interactive"])]]),e.$sI="_notAvailable";var D;(function(z){z[z.Running=1]="Running",z[z.Idle=2]="Idle"})(D||(e.NotebookRunState=D={}));var u;(function(z){z[z.Unconfirmed=1]="Unconfirmed",z[z.Pending=2]="Pending",z[z.Executing=3]="Executing"})(u||(e.NotebookCellExecutionState=u={}));var b;(function(z){z[z.Unconfirmed=1]="Unconfirmed",z[z.Pending=2]="Pending",z[z.Executing=3]="Executing"})(b||(e.NotebookExecutionState=b={}));var p;(function(z){z[z.WithHardKernelDependency=0]="WithHardKernelDependency",z[z.WithOptionalKernelDependency=1]="WithOptionalKernelDependency",z[z.Pure=2]="Pure",z[z.Never=3]="Never"})(p||(e.NotebookRendererMatch=p={}));var g;(function(z){z.Always="always",z.Never="never",z.Optional="optional"})(g||(e.RendererMessagingSpec=g={}));var t;(function(z){z[z.ModelChange=1]="ModelChange",z[z.Move=2]="Move",z[z.ChangeCellLanguage=5]="ChangeCellLanguage",z[z.Initialize=6]="Initialize",z[z.ChangeCellMetadata=7]="ChangeCellMetadata",z[z.Output=8]="Output",z[z.OutputItem=9]="OutputItem",z[z.ChangeCellContent=10]="ChangeCellContent",z[z.ChangeDocumentMetadata=11]="ChangeDocumentMetadata",z[z.ChangeCellInternalMetadata=12]="ChangeCellInternalMetadata",z[z.ChangeCellMime=13]="ChangeCellMime",z[z.Unknown=100]="Unknown"})(t||(e.NotebookCellsChangeType=t={}));var i;(function(z){z[z.Handle=0]="Handle",z[z.Index=1]="Index"})(i||(e.SelectionStateType=i={}));var r;(function(z){z[z.Replace=1]="Replace",z[z.Output=2]="Output",z[z.Metadata=3]="Metadata",z[z.CellLanguage=4]="CellLanguage",z[z.DocumentMetadata=5]="DocumentMetadata",z[z.Move=6]="Move",z[z.OutputItems=7]="OutputItems",z[z.PartialMetadata=8]="PartialMetadata",z[z.PartialInternalMetadata=9]="PartialInternalMetadata"})(r||(e.CellEditType=r={}));var c;(function(z){z.scheme=A.Schemas.vscodeNotebookCell;const Z=["W","X","Y","Z","a","b","c","d","e","f"],he=new RegExp(`^[${Z.join("")}]+`),ye=7;function De(se,X){const B=X.toString(ye),pe=`${B.length<Z.length?Z[B.length-1]:"z"}${B}s${(0,y.$ze)(y.$fe.fromString(se.scheme),!0,!0)}`;return se.with({scheme:z.scheme,fragment:pe})}z.generate=De;function Se(se){if(se.scheme!==z.scheme)return;const X=se.fragment.indexOf("s");if(X<0)return;const B=parseInt(se.fragment.substring(0,X).replace(he,""),ye),ie=(0,y.$ye)(se.fragment.substring(X+1)).toString();if(!isNaN(B))return{handle:B,notebook:se.with({scheme:ie,fragment:null})}}z.parse=Se;function fe(se,X){return se.with({scheme:A.Schemas.vscodeNotebookCellOutput,fragment:`op${X??""},${se.scheme!==A.Schemas.file?se.scheme:""}`})}z.generateCellOutputUri=fe;function $e(se){if(se.scheme!==A.Schemas.vscodeNotebookCellOutput)return;const X=/^op([0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12})?\,(.*)$/i.exec(se.fragment);if(!X)return;const B=X[1]&&X[1]!==""?X[1]:void 0,ie=X[2];return{outputId:B,notebook:se.with({scheme:ie||A.Schemas.file,fragment:null})}}z.parseCellOutputUri=$e;function re(se,X,B){return z.generate(se,X).with({scheme:B})}z.generateCellPropertyUri=re;function Ae(se,X){if(se.scheme===X)return z.parse(se.with({scheme:z.scheme}))}z.parseCellPropertyUri=Ae})(c||(e.CellUri=c={}));const o=z=>E.$i?z.replace(/\//g,"\\"):z;class l{constructor(Z=[],he=e.$pI){this.e=he,this.d=[...new Set(Z)].map(ye=>({pattern:ye,matches:F.$Cj(o(ye))}))}sort(Z){const he=new Map(P.Iterable.map(Z,De=>[De,o(De)]));let ye=[];for(const{matches:De}of this.d)for(const[Se,fe]of he)if(De(fe)){ye.push(Se),he.delete(Se);break}return he.size&&(ye=ye.concat([...he.keys()].sort((De,Se)=>this.e.indexOf(De)-this.e.indexOf(Se)))),ye}prioritize(Z,he){const ye=this.f(Z);if(ye===-1){this.d.unshift({pattern:Z,matches:F.$Cj(o(Z))});return}const De=new Set(he.map(fe=>this.f(fe,ye)));De.delete(-1);const Se=Array.from(De).sort();this.d.splice(ye+1,0,...Se.map(fe=>this.d[fe]));for(let fe=Se.length-1;fe>=0;fe--)this.d.splice(Se[fe],1)}toArray(){return this.d.map(Z=>Z.pattern)}f(Z,he=this.d.length){const ye=o(Z);for(let De=0;De<he;De++)if(this.d[De].matches(ye))return De;return-1}}e.$tI=l;function n(z,Z,he,ye=(De,Se)=>De===Se){const De=[];function Se(re,Ae,se){if(Ae===0&&se.length===0)return;const X=De[De.length-1];X&&X.start+X.deleteCount===re?(X.deleteCount+=Ae,X.toInsert.push(...se)):De.push({start:re,deleteCount:Ae,toInsert:se})}let fe=0,$e=0;for(;;){if(fe===z.length){Se(fe,0,Z.slice($e));break}if($e===Z.length){Se(fe,z.length-fe,[]);break}const re=z[fe],Ae=Z[$e];if(ye(re,Ae)){fe+=1,$e+=1;continue}he(Ae)?(Se(fe,1,[]),fe+=1):(Se(fe,0,[Ae]),$e+=1)}return De}e.$uI=n,e.$vI=new f.$aj("notebookEditorCursorAtBoundary","none"),e.$wI=new f.$aj("notebookEditorCursorAtLineBoundary","none");var s;(function(z){z.default="default",z.option="option"})(s||(e.NotebookEditorPriority=s={}));function a(z){const Z=z;return!!((typeof Z.include=="string"||F.$Dj(Z.include))&&(typeof Z.exclude=="string"||F.$Dj(Z.exclude)))}e.$xI=a;function d(z,Z,he){if(Array.isArray(z.viewType)&&z.viewType.indexOf(Z)>=0||z.viewType===Z)return!0;if(z.filenamePattern){const ye=a(z.filenamePattern)?z.filenamePattern.include:z.filenamePattern,De=a(z.filenamePattern)?z.filenamePattern.exclude:void 0;if(F.$Bj(ye,(0,$.$mc)(he.fsPath).toLowerCase()))return!(De&&F.$Bj(De,(0,$.$mc)(he.fsPath).toLowerCase()))}return!1}e.$yI=d,e.$zI={displayOrder:"notebook.displayOrder",cellToolbarLocation:"notebook.cellToolbarLocation",cellToolbarVisibility:"notebook.cellToolbarVisibility",showCellStatusBar:"notebook.showCellStatusBar",textDiffEditorPreview:"notebook.diff.enablePreview",diffOverviewRuler:"notebook.diff.overviewRuler",experimentalInsertToolbarAlignment:"notebook.experimental.insertToolbarAlignment",compactView:"notebook.compactView",focusIndicator:"notebook.cellFocusIndicator",insertToolbarLocation:"notebook.insertToolbarLocation",globalToolbar:"notebook.globalToolbar",stickyScroll:"notebook.stickyScroll.enabled",undoRedoPerCell:"notebook.undoRedoPerCell",consolidatedOutputButton:"notebook.consolidatedOutputButton",showFoldingControls:"notebook.showFoldingControls",dragAndDropEnabled:"notebook.dragAndDropEnabled",cellEditorOptionsCustomizations:"notebook.editorOptionsCustomizations",consolidatedRunButton:"notebook.consolidatedRunButton",openGettingStarted:"notebook.experimental.openGettingStarted",globalToolbarShowLabel:"notebook.globalToolbarShowLabel",markupFontSize:"notebook.markup.fontSize",interactiveWindowCollapseCodeCells:"interactiveWindow.collapseCellInputCode",outputScrollingDeprecated:"notebook.experimental.outputScrolling",outputScrolling:"notebook.output.scrolling",textOutputLineLimit:"notebook.output.textLineLimit",formatOnSave:"notebook.formatOnSave.enabled",insertFinalNewline:"notebook.insertFinalNewline",formatOnCellExecution:"notebook.formatOnCellExecution",codeActionsOnSave:"notebook.codeActionsOnSave",outputWordWrap:"notebook.output.wordWrap",outputLineHeightDeprecated:"notebook.outputLineHeight",outputLineHeight:"notebook.output.lineHeight",outputFontSizeDeprecated:"notebook.outputFontSize",outputFontSize:"notebook.output.fontSize",outputFontFamilyDeprecated:"notebook.outputFontFamily",outputFontFamily:"notebook.output.fontFamily",findScope:"notebook.find.scope",logging:"notebook.logging",confirmDeleteRunningCell:"notebook.confirmDeleteRunningCell",remoteSaving:"notebook.experimental.remoteSave",gotoSymbolsAllSymbols:"notebook.gotoSymbols.showAllSymbols",scrollToRevealCell:"notebook.scrolling.revealNextCellOnExecute",anchorToFocusedCell:"notebook.scrolling.experimental.anchorToFocusedCell"};var v;(function(z){z[z.Left=1]="Left",z[z.Right=2]="Right"})(v||(e.CellStatusbarAlignment=v={}));class m{static{this.d="notebook/"}static create(Z){return`${m.d}${Z}`}static parse(Z){if(Z.startsWith(m.d))return Z.substring(m.d.length)}}e.$AI=m;function S(z){return["application/vnd.code.notebook.stdout","application/vnd.code.notebook.stderr"].includes(z)}e.$BI=S;const k=new TextDecoder;function h(z){const Z=[];let he=!1;for(const fe of z)(Z.length===0||he)&&(Z.push(fe),he=!0);let ye=L(Z);const De=y.$fe.concat(Z.map(fe=>y.$fe.wrap(fe))),Se=T(De);return ye=ye||Se.byteLength!==De.byteLength,{data:Se,didCompression:ye}}e.$CI=h,e.$DI=`${String.fromCharCode(27)}[A`;const w=e.$DI.split("").map(z=>z.charCodeAt(0)),I=10;function L(z){let Z=!1;return z.forEach((he,ye)=>{if(ye===0||he.length<e.$DI.length)return;const De=z[ye-1],Se=he.subarray(0,e.$DI.length);if(Se[0]===w[0]&&Se[1]===w[1]&&Se[2]===w[2]){const fe=De.lastIndexOf(I);if(fe===-1)return;Z=!0,z[ye-1]=De.subarray(0,fe),z[ye]=he.subarray(e.$DI.length)}}),Z}function V(z){let Z=z;do z=Z,Z=z.replace(/[^\n]\x08/gm,"");while(Z.length<z.length);return z}function K(z){for(z=z.replace(/\r+\n/gm,`
`);z.search(/\r[^$]/g)>-1;){const Z=z.match(/^(.*)\r+/m)[1];let he=z.match(/\r+(.*)$/m)[1];he=he+Z.slice(he.length,Z.length),z=z.replace(/\r+.*$/m,"\r").replace(/^.*\r/m,he)}return z}const R="\b".charCodeAt(0),N="\r".charCodeAt(0);function T(z){return!z.buffer.includes(R)&&!z.buffer.includes(N)?z:y.$fe.fromString(K(V(k.decode(z.buffer))))}}),define(Pe[7],Re([1,0,18,11,52,28,68,12,16,2,38,22,41,100,76]),function(be,e,y,F,P,M,A,$,E,f,C,D,u,b,p){"use strict";var g,t,i,r,c,o,l,n,s,a,d,v,m,S,k,h,w,I;Object.defineProperty(e,"__esModule",{value:!0}),e.SpeechToTextStatus=e.RelatedInformationType=e.ChatAgentResultFeedbackKind=e.$oM=e.ChatVariableLevel=e.ChatMessageRole=e.InteractiveEditorResponseFeedbackKind=e.InteractiveSessionCopyKind=e.InteractiveSessionVoteDirection=e.$nM=e.$mM=e.$lM=e.$kM=e.$jM=e.$iM=e.$hM=e.$gM=e.$fM=e.$eM=e.$dM=e.PortAutoForwardAction=e.WorkspaceTrustState=e.ExternalUriOpenerPriority=e.$cM=e.$bM=e.$aM=e.$_L=e.$$L=e.$0L=e.$9L=e.$8L=e.TestRunProfileKind=e.TestResultState=e.$7L=e.$6L=e.StandardTokenType=e.ExtensionRuntime=e.ExtensionMode=e.$5L=e.$4L=e.$3L=e.NotebookControllerAffinity2=e.NotebookControllerAffinity=e.$2L=e.NotebookEditorRevealType=e.NotebookCellStatusBarAlignment=e.NotebookCellExecutionState=e.NotebookCellKind=e.$1L=e.$ZL=e.$YL=e.$XL=e.$WL=e.ColorThemeKind=e.$VL=e.$UL=e.ExtensionKind=e.InputBoxValidationSeverity=e.QuickPickItemKind=e.$TL=e.DebugConsoleMode=e.$SL=e.$RL=e.$QL=e.$PL=e.$OL=e.CommentThreadState=e.CommentState=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.$NL=e.$ML=e.FileChangeType=e.$LL=e.$KL=e.$JL=e.$IL=e.InlineCompletionTriggerKind=e.$HL=e.$GL=e.$FL=e.$EL=e.$DL=e.$CL=e.$BL=e.$AL=e.$zL=e.$yL=e.$xL=e.$wL=e.$vL=e.ConfigurationTarget=e.$uL=e.$tL=e.$sL=e.$rL=e.$qL=e.$pL=e.$oL=e.$nL=e.$mL=e.TreeItemCheckboxState=e.TreeItemCollapsibleState=e.$lL=e.ViewBadge=e.ProgressLocation=e.$kL=e.$jL=e.TaskScope=e.ShellQuoting=e.$iL=e.$hL=e.$gL=e.TaskPanelKind=e.TaskRevealKind=e.$fL=e.TerminalLocation=e.$eL=e.$dL=e.$cL=e.TerminalExitReason=e.SourceControlInputBoxValidationType=e.ColorFormat=e.$bL=e.$aL=e.$_K=e.$$K=e.SyntaxTokenType=e.DecorationRangeBehavior=e.TextDocumentChangeReason=e.TextEditorSelectionChangeKind=e.TextEditorRevealType=e.TextDocumentSaveReason=e.TextEditorLineNumbersStyle=e.$0K=e.StatusBarAlignment=e.ViewColumn=e.$9K=e.$8K=e.$7K=e.$6K=e.CompletionItemTag=e.CompletionItemKind=e.CompletionTriggerKind=e.$5K=e.$4K=e.InlayHintKind=e.SignatureHelpTriggerKind=e.$3K=e.$2K=e.$1K=e.$ZK=e.$YK=e.LanguageStatusSeverity=e.$XK=e.$WK=e.$VK=e.$UK=e.$TK=e.$SK=e.CodeActionTriggerKind=e.$RK=e.$QK=e.SymbolTag=e.SymbolKind=e.$PK=e.DocumentHighlightKind=e.$OK=e.$NK=e.$MK=e.$LK=e.DiagnosticSeverity=e.DiagnosticTag=e.$KK=e.$JK=e.FileEditType=e.$IK=e.$HK=e.$GK=e.EnvironmentVariableMutatorType=e.EndOfLine=e.$FK=e.$EK=e.$DK=e.$CK=e.$BK=e.$AK=e.$zK=e.TerminalQuickFixType=e.TerminalOutputAnchor=void 0;function L(j){return Object.assign(j,{apply:function(...oe){if(oe.length===0)return Reflect.construct(j,[]);{const ke=oe.length===1?[]:oe[1];return Reflect.construct(j,ke,oe[0].constructor)}},call:function(...oe){if(oe.length===0)return Reflect.construct(j,[]);{const[ke,...Ge]=oe;return Reflect.construct(j,Ge,ke.constructor)}}})}var V;(function(j){j[j.Top=0]="Top",j[j.Bottom=1]="Bottom"})(V||(e.TerminalOutputAnchor=V={}));var K;(function(j){j[j.TerminalCommand=0]="TerminalCommand",j[j.Opener=1]="Opener",j[j.Command=3]="Command"})(K||(e.TerminalQuickFixType=K={}));let R=g=class{static from(...U){let oe=U;return new g(function(){if(oe){for(const ke of oe)ke&&typeof ke.dispose=="function"&&ke.dispose();oe=void 0}})}#e;constructor(U){this.#e=U}dispose(){typeof this.#e=="function"&&(this.#e(),this.#e=void 0)}};e.$zK=R,e.$zK=R=g=Ke([L],R);let N=t=class{static Min(...U){if(U.length===0)throw new TypeError;let oe=U[0];for(let ke=1;ke<U.length;ke++){const Ge=U[ke];Ge.isBefore(oe)&&(oe=Ge)}return oe}static Max(...U){if(U.length===0)throw new TypeError;let oe=U[0];for(let ke=1;ke<U.length;ke++){const Ge=U[ke];Ge.isAfter(oe)&&(oe=Ge)}return oe}static isPosition(U){if(!U)return!1;if(U instanceof t)return!0;const{line:oe,character:ke}=U;return typeof oe=="number"&&typeof ke=="number"}static of(U){if(U instanceof t)return U;if(this.isPosition(U))return new t(U.line,U.character);throw new Error("Invalid argument, is NOT a position-like object")}get line(){return this.c}get character(){return this.e}constructor(U,oe){if(U<0)throw(0,F.$6)("line must be non-negative");if(oe<0)throw(0,F.$6)("character must be non-negative");this.c=U,this.e=oe}isBefore(U){return this.c<U.c?!0:U.c<this.c?!1:this.e<U.e}isBeforeOrEqual(U){return this.c<U.c?!0:U.c<this.c?!1:this.e<=U.e}isAfter(U){return!this.isBeforeOrEqual(U)}isAfterOrEqual(U){return!this.isBefore(U)}isEqual(U){return this.c===U.c&&this.e===U.e}compareTo(U){return this.c<U.c?-1:this.c>U.line?1:this.e<U.e?-1:this.e>U.e?1:0}translate(U,oe=0){if(U===null||oe===null)throw(0,F.$6)();let ke;return typeof U>"u"?ke=0:typeof U=="number"?ke=U:(ke=typeof U.lineDelta=="number"?U.lineDelta:0,oe=typeof U.characterDelta=="number"?U.characterDelta:0),ke===0&&oe===0?this:new t(this.line+ke,this.character+oe)}with(U,oe=this.character){if(U===null||oe===null)throw(0,F.$6)();let ke;return typeof U>"u"?ke=this.line:typeof U=="number"?ke=U:(ke=typeof U.line=="number"?U.line:this.line,oe=typeof U.character=="number"?U.character:this.character),ke===this.line&&oe===this.character?this:new t(ke,oe)}toJSON(){return{line:this.line,character:this.character}}};e.$AK=N,e.$AK=N=t=Ke([L],N);let T=i=class{static isRange(U){return U instanceof i?!0:U?N.isPosition(U.start)&&N.isPosition(U.end):!1}static of(U){if(U instanceof i)return U;if(this.isRange(U))return new i(U.start,U.end);throw new Error("Invalid argument, is NOT a range-like object")}get start(){return this.c}get end(){return this.e}constructor(U,oe,ke,Ge){let xe,at;if(typeof U=="number"&&typeof oe=="number"&&typeof ke=="number"&&typeof Ge=="number"?(xe=new N(U,oe),at=new N(ke,Ge)):N.isPosition(U)&&N.isPosition(oe)&&(xe=N.of(U),at=N.of(oe)),!xe||!at)throw new Error("Invalid arguments");xe.isBefore(at)?(this.c=xe,this.e=at):(this.c=at,this.e=xe)}contains(U){return i.isRange(U)?this.contains(U.start)&&this.contains(U.end):N.isPosition(U)?!(N.of(U).isBefore(this.c)||this.e.isBefore(U)):!1}isEqual(U){return this.c.isEqual(U.c)&&this.e.isEqual(U.e)}intersection(U){const oe=N.Max(U.start,this.c),ke=N.Min(U.end,this.e);if(!oe.isAfter(ke))return new i(oe,ke)}union(U){if(this.contains(U))return this;if(U.contains(this))return U;const oe=N.Min(U.start,this.c),ke=N.Max(U.end,this.end);return new i(oe,ke)}get isEmpty(){return this.c.isEqual(this.e)}get isSingleLine(){return this.c.line===this.e.line}with(U,oe=this.end){if(U===null||oe===null)throw(0,F.$6)();let ke;return U?N.isPosition(U)?ke=U:(ke=U.start||this.start,oe=U.end||this.end):ke=this.start,ke.isEqual(this.c)&&oe.isEqual(this.end)?this:new i(ke,oe)}toJSON(){return[this.start,this.end]}};e.$BK=T,e.$BK=T=i=Ke([L],T);let z=r=class extends T{static isSelection(U){return U instanceof r?!0:U?T.isRange(U)&&N.isPosition(U.anchor)&&N.isPosition(U.active)&&typeof U.isReversed=="boolean":!1}get anchor(){return this.f}get active(){return this.g}constructor(U,oe,ke,Ge){let xe,at;if(typeof U=="number"&&typeof oe=="number"&&typeof ke=="number"&&typeof Ge=="number"?(xe=new N(U,oe),at=new N(ke,Ge)):N.isPosition(U)&&N.isPosition(oe)&&(xe=N.of(U),at=N.of(oe)),!xe||!at)throw new Error("Invalid arguments");super(xe,at),this.f=xe,this.g=at}get isReversed(){return this.f===this.e}toJSON(){return{start:this.start,end:this.end,active:this.active,anchor:this.anchor}}};e.$CK=z,e.$CK=z=r=Ke([L],z);const Z=j=>{if(typeof j!="string"||j.length===0||!/^[0-9A-Za-z_\-]+$/.test(j))throw(0,F.$6)("connectionToken")};class he{static isResolvedAuthority(U){return U&&typeof U=="object"&&typeof U.host=="string"&&typeof U.port=="number"&&(U.connectionToken===void 0||typeof U.connectionToken=="string")}constructor(U,oe,ke){if(typeof U!="string"||U.length===0)throw(0,F.$6)("host");if(typeof oe!="number"||oe===0||Math.round(oe)!==oe)throw(0,F.$6)("port");typeof ke<"u"&&Z(ke),this.host=U,this.port=Math.round(oe),this.connectionToken=ke}}e.$DK=he;class ye{static isManagedResolvedAuthority(U){return U&&typeof U=="object"&&typeof U.makeConnection=="function"&&(U.connectionToken===void 0||typeof U.connectionToken=="string")}constructor(U,oe){this.makeConnection=U,this.connectionToken=oe,typeof oe<"u"&&Z(oe)}}e.$EK=ye;class De extends Error{static NotAvailable(U,oe){return new De(U,b.RemoteAuthorityResolverErrorCode.NotAvailable,oe)}static TemporarilyNotAvailable(U){return new De(U,b.RemoteAuthorityResolverErrorCode.TemporarilyNotAvailable)}constructor(U,oe=b.RemoteAuthorityResolverErrorCode.Unknown,ke){super(U),this._message=U,this._code=oe,this._detail=ke,Object.setPrototypeOf(this,De.prototype)}}e.$FK=De;var Se;(function(j){j[j.LF=1]="LF",j[j.CRLF=2]="CRLF"})(Se||(e.EndOfLine=Se={}));var fe;(function(j){j[j.Replace=1]="Replace",j[j.Append=2]="Append",j[j.Prepend=3]="Prepend"})(fe||(e.EnvironmentVariableMutatorType=fe={}));let $e=c=class{static isTextEdit(U){return U instanceof c?!0:U?T.isRange(U)&&typeof U.newText=="string":!1}static replace(U,oe){return new c(U,oe)}static insert(U,oe){return c.replace(new T(U,U),oe)}static delete(U){return c.replace(U,"")}static setEndOfLine(U){const oe=new c(new T(new N(0,0),new N(0,0)),"");return oe.newEol=U,oe}get range(){return this.c}set range(U){if(U&&!T.isRange(U))throw(0,F.$6)("range");this.c=U}get newText(){return this.e||""}set newText(U){if(U&&typeof U!="string")throw(0,F.$6)("newText");this.e=U}get newEol(){return this.f}set newEol(U){if(U&&typeof U!="number")throw(0,F.$6)("newEol");this.f=U}constructor(U,oe){this.c=U,this.e=oe}toJSON(){return{range:this.range,newText:this.newText,newEol:this.f}}};e.$GK=$e,e.$GK=$e=c=Ke([L],$e);let re=o=class{static isNotebookCellEdit(U){return U instanceof o?!0:U?_t.isNotebookRange(U)&&Array.isArray(U.newCells):!1}static replaceCells(U,oe){return new o(U,oe)}static insertCells(U,oe){return new o(new _t(U,U),oe)}static deleteCells(U){return new o(U,[])}static updateCellMetadata(U,oe){const ke=new o(new _t(U,U),[]);return ke.newCellMetadata=oe,ke}static updateNotebookMetadata(U){const oe=new o(new _t(0,0),[]);return oe.newNotebookMetadata=U,oe}constructor(U,oe){this.range=U,this.newCells=oe}};e.$HK=re,e.$HK=re=o=Ke([L],re);class Ae{static isSnippetTextEdit(U){return U instanceof Ae?!0:U?T.isRange(U.range)&&B.isSnippetString(U.snippet):!1}static replace(U,oe){return new Ae(U,oe)}static insert(U,oe){return Ae.replace(new T(U,U),oe)}constructor(U,oe){this.range=U,this.snippet=oe}}e.$IK=Ae;var se;(function(j){j[j.File=1]="File",j[j.Text=2]="Text",j[j.Cell=3]="Cell",j[j.CellReplace=5]="CellReplace",j[j.Snippet=6]="Snippet"})(se||(e.FileEditType=se={}));let X=class{constructor(){this.c=[]}_allEntries(){return this.c}renameFile(U,oe,ke,Ge){this.c.push({_type:1,from:U,to:oe,options:ke,metadata:Ge})}createFile(U,oe,ke){this.c.push({_type:1,from:void 0,to:U,options:oe,metadata:ke})}deleteFile(U,oe,ke){this.c.push({_type:1,from:U,to:void 0,options:oe,metadata:ke})}e(U,oe,ke){this.c.push({_type:3,metadata:ke,uri:U,edit:{editType:5,metadata:oe},notebookMetadata:oe})}f(U,oe,ke,Ge){const xe=oe.start,at=oe.end;(xe!==at||ke.length>0)&&this.c.push({_type:5,uri:U,index:xe,count:at-xe,cells:ke,metadata:Ge})}g(U,oe,ke,Ge){this.c.push({_type:3,metadata:Ge,uri:U,edit:{editType:3,index:oe,metadata:ke}})}replace(U,oe,ke,Ge){this.c.push({_type:2,uri:U,edit:new $e(oe,ke),metadata:Ge})}insert(U,oe,ke,Ge){this.replace(U,new T(oe,oe),ke,Ge)}delete(U,oe,ke){this.replace(U,oe,"",ke)}has(U){return this.c.some(oe=>oe._type===2&&oe.uri.toString()===U.toString())}set(U,oe){if(oe)for(const ke of oe){if(!ke)continue;let Ge,xe;Array.isArray(ke)?(Ge=ke[0],xe=ke[1]):Ge=ke,re.isNotebookCellEdit(Ge)?Ge.newCellMetadata?this.g(U,Ge.range.start,Ge.newCellMetadata,xe):Ge.newNotebookMetadata?this.e(U,Ge.newNotebookMetadata,xe):this.f(U,Ge.range,Ge.newCells,xe):Ae.isSnippetTextEdit(Ge)?this.c.push({_type:6,uri:U,range:Ge.range,edit:Ge.snippet,metadata:xe}):this.c.push({_type:2,uri:U,edit:Ge,metadata:xe})}else{for(let ke=0;ke<this.c.length;ke++){const Ge=this.c[ke];switch(Ge._type){case 2:case 6:case 3:case 5:Ge.uri.toString()===U.toString()&&(this.c[ke]=void 0);break}}(0,y.$Hb)(this.c)}}get(U){const oe=[];for(const ke of this.c)ke._type===2&&ke.uri.toString()===U.toString()&&oe.push(ke.edit);return oe}entries(){const U=new M.$zc;for(const oe of this.c)if(oe._type===2){let ke=U.get(oe.uri);ke||(ke=[oe.uri,[]],U.set(oe.uri,ke)),ke[1].push(oe.edit)}return[...U.values()]}get size(){return this.entries().length}toJSON(){return this.entries()}};e.$JK=X,e.$JK=X=Ke([L],X);let B=l=class{static isSnippetString(U){return U instanceof l?!0:U?typeof U.value=="string":!1}static c(U){return U.replace(/\$|}|\\/g,"\\$&")}constructor(U){this.e=1,this.value=U||""}appendText(U){return this.value+=l.c(U),this}appendTabstop(U=this.e++){return this.value+="$",this.value+=U,this}appendPlaceholder(U,oe=this.e++){if(typeof U=="function"){const ke=new l;ke.e=this.e,U(ke),this.e=ke.e,U=ke.value}else U=l.c(U);return this.value+="${",this.value+=oe,this.value+=":",this.value+=U,this.value+="}",this}appendChoice(U,oe=this.e++){const ke=U.map(Ge=>Ge.replace(/\$|}|\\|,/g,"\\$&")).join(",");return this.value+="${",this.value+=oe,this.value+="|",this.value+=ke,this.value+="|}",this}appendVariable(U,oe){if(typeof oe=="function"){const ke=new l;ke.e=this.e,oe(ke),this.e=ke.e,oe=ke.value}else typeof oe=="string"&&(oe=oe.replace(/\$|}/g,"\\$&"));return this.value+="${",this.value+=U,oe&&(this.value+=":",this.value+=oe),this.value+="}",this}};e.$KK=B,e.$KK=B=l=Ke([L],B);var ie;(function(j){j[j.Unnecessary=1]="Unnecessary",j[j.Deprecated=2]="Deprecated"})(ie||(e.DiagnosticTag=ie={}));var pe;(function(j){j[j.Hint=3]="Hint",j[j.Information=2]="Information",j[j.Warning=1]="Warning",j[j.Error=0]="Error"})(pe||(e.DiagnosticSeverity=pe={}));let ne=n=class{static isLocation(U){return U instanceof n?!0:U?T.isRange(U.range)&&f.URI.isUri(U.uri):!1}constructor(U,oe){if(this.uri=U,oe)if(T.isRange(oe))this.range=T.of(oe);else if(N.isPosition(oe))this.range=new T(oe,oe);else throw new Error("Illegal argument")}toJSON(){return{uri:this.uri,range:this.range}}};e.$LK=ne,e.$LK=ne=n=Ke([L],ne);let le=class{static is(U){return U?typeof U.message=="string"&&U.location&&T.isRange(U.location.range)&&f.URI.isUri(U.location.uri):!1}constructor(U,oe){this.location=U,this.message=oe}static isEqual(U,oe){return U===oe?!0:!U||!oe?!1:U.message===oe.message&&U.location.range.isEqual(oe.location.range)&&U.location.uri.toString()===oe.location.uri.toString()}};e.$MK=le,e.$MK=le=Ke([L],le);let ce=class{constructor(U,oe,ke=pe.Error){if(!T.isRange(U))throw new TypeError("range must be set");if(!oe)throw new TypeError("message must be set");this.range=U,this.message=oe,this.severity=ke}toJSON(){return{severity:pe[this.severity],message:this.message,range:this.range,source:this.source,code:this.code}}static isEqual(U,oe){return U===oe?!0:!U||!oe?!1:U.message===oe.message&&U.severity===oe.severity&&U.code===oe.code&&U.severity===oe.severity&&U.source===oe.source&&U.range.isEqual(oe.range)&&(0,y.$tb)(U.tags,oe.tags)&&(0,y.$tb)(U.relatedInformation,oe.relatedInformation,le.isEqual)}};e.$NK=ce,e.$NK=ce=Ke([L],ce);let we=class{constructor(U,oe){if(!U)throw new Error("Illegal argument, contents must be defined");Array.isArray(U)?this.contents=U:this.contents=[U],this.range=oe}};e.$OK=we,e.$OK=we=Ke([L],we);var _;(function(j){j[j.Text=0]="Text",j[j.Read=1]="Read",j[j.Write=2]="Write"})(_||(e.DocumentHighlightKind=_={}));let de=class{constructor(U,oe=_.Text){this.range=U,this.kind=oe}toJSON(){return{range:this.range,kind:_[this.kind]}}};e.$PK=de,e.$PK=de=Ke([L],de);var te;(function(j){j[j.File=0]="File",j[j.Module=1]="Module",j[j.Namespace=2]="Namespace",j[j.Package=3]="Package",j[j.Class=4]="Class",j[j.Method=5]="Method",j[j.Property=6]="Property",j[j.Field=7]="Field",j[j.Constructor=8]="Constructor",j[j.Enum=9]="Enum",j[j.Interface=10]="Interface",j[j.Function=11]="Function",j[j.Variable=12]="Variable",j[j.Constant=13]="Constant",j[j.String=14]="String",j[j.Number=15]="Number",j[j.Boolean=16]="Boolean",j[j.Array=17]="Array",j[j.Object=18]="Object",j[j.Key=19]="Key",j[j.Null=20]="Null",j[j.EnumMember=21]="EnumMember",j[j.Struct=22]="Struct",j[j.Event=23]="Event",j[j.Operator=24]="Operator",j[j.TypeParameter=25]="TypeParameter"})(te||(e.SymbolKind=te={}));var ae;(function(j){j[j.Deprecated=1]="Deprecated"})(ae||(e.SymbolTag=ae={}));let me=s=class{static validate(U){if(!U.name)throw new Error("name must not be falsy")}constructor(U,oe,ke,Ge,xe){this.name=U,this.kind=oe,this.containerName=xe,typeof ke=="string"&&(this.containerName=ke),Ge instanceof ne?this.location=Ge:ke instanceof T&&(this.location=new ne(Ge,ke)),s.validate(this)}toJSON(){return{name:this.name,kind:te[this.kind],location:this.location,containerName:this.containerName}}};e.$QK=me,e.$QK=me=s=Ke([L],me);let Ie=a=class{static validate(U){if(!U.name)throw new Error("name must not be falsy");if(!U.range.contains(U.selectionRange))throw new Error("selectionRange must be contained in fullRange");U.children?.forEach(a.validate)}constructor(U,oe,ke,Ge,xe){this.name=U,this.detail=oe,this.kind=ke,this.range=Ge,this.selectionRange=xe,this.children=[],a.validate(this)}};e.$RK=Ie,e.$RK=Ie=a=Ke([L],Ie);var O;(function(j){j[j.Invoke=1]="Invoke",j[j.Automatic=2]="Automatic"})(O||(e.CodeActionTriggerKind=O={}));let W=class{constructor(U,oe){this.title=U,this.kind=oe}};e.$SK=W,e.$SK=W=Ke([L],W);let G=class{static{d=this}static{this.c="."}constructor(U){this.value=U}append(U){return new d(this.value?this.value+d.c+U:U)}intersects(U){return this.contains(U)||U.contains(this)}contains(U){return this.value===U.value||U.value.startsWith(this.value+d.c)}};e.$TK=G,e.$TK=G=d=Ke([L],G),G.Empty=new G(""),G.QuickFix=G.Empty.append("quickfix"),G.Refactor=G.Empty.append("refactor"),G.RefactorExtract=G.Refactor.append("extract"),G.RefactorInline=G.Refactor.append("inline"),G.RefactorMove=G.Refactor.append("move"),G.RefactorRewrite=G.Refactor.append("rewrite"),G.Source=G.Empty.append("source"),G.SourceOrganizeImports=G.Source.append("organizeImports"),G.SourceFixAll=G.Source.append("fixAll"),G.Notebook=G.Empty.append("notebook");let J=class{constructor(U,oe){if(this.range=U,this.parent=oe,oe&&!oe.range.contains(this.range))throw new Error("Invalid argument: parent must contain this range")}};e.$UK=J,e.$UK=J=Ke([L],J);class q{constructor(U,oe,ke,Ge,xe,at){this.kind=U,this.name=oe,this.detail=ke,this.uri=Ge,this.range=xe,this.selectionRange=at}}e.$VK=q;class x{constructor(U,oe){this.fromRanges=oe,this.from=U}}e.$WK=x;class ue{constructor(U,oe){this.fromRanges=oe,this.to=U}}e.$XK=ue;var Oe;(function(j){j[j.Information=0]="Information",j[j.Warning=1]="Warning",j[j.Error=2]="Error"})(Oe||(e.LanguageStatusSeverity=Oe={}));let Ue=class{constructor(U,oe){this.range=U,this.command=oe}get isResolved(){return!!this.command}};e.$YK=Ue,e.$YK=Ue=Ke([L],Ue);let Ze=v=class{#e;static isMarkdownString(U){return U instanceof v?!0:U&&U.appendCodeblock&&U.appendMarkdown&&U.appendText&&U.value!==void 0}constructor(U,oe=!1){this.#e=new P.$9j(U,{supportThemeIcons:oe})}get value(){return this.#e.value}set value(U){this.#e.value=U}get isTrusted(){return this.#e.isTrusted}set isTrusted(U){this.#e.isTrusted=U}get supportThemeIcons(){return this.#e.supportThemeIcons}set supportThemeIcons(U){this.#e.supportThemeIcons=U}get supportHtml(){return this.#e.supportHtml}set supportHtml(U){this.#e.supportHtml=U}get baseUri(){return this.#e.baseUri}set baseUri(U){this.#e.baseUri=U}appendText(U){return this.#e.appendText(U),this}appendMarkdown(U){return this.#e.appendMarkdown(U),this}appendCodeblock(U,oe){return this.#e.appendCodeblock(oe??"",U),this}};e.$ZK=Ze,e.$ZK=Ze=v=Ke([L],Ze);let Je=class{constructor(U,oe){this.label=U,this.documentation=oe}};e.$1K=Je,e.$1K=Je=Ke([L],Je);let tt=class{constructor(U,oe){this.label=U,this.documentation=oe,this.parameters=[]}};e.$2K=tt,e.$2K=tt=Ke([L],tt);let _e=class{constructor(){this.activeSignature=0,this.activeParameter=0,this.signatures=[]}};e.$3K=_e,e.$3K=_e=Ke([L],_e);var et;(function(j){j[j.Invoke=1]="Invoke",j[j.TriggerCharacter=2]="TriggerCharacter",j[j.ContentChange=3]="ContentChange"})(et||(e.SignatureHelpTriggerKind=et={}));var rt;(function(j){j[j.Type=1]="Type",j[j.Parameter=2]="Parameter"})(rt||(e.InlayHintKind=rt={}));let nt=class{constructor(U){this.value=U}};e.$4K=nt,e.$4K=nt=Ke([L],nt);let Ne=class{constructor(U,oe,ke){this.position=U,this.label=oe,this.kind=ke}};e.$5K=Ne,e.$5K=Ne=Ke([L],Ne);var dt;(function(j){j[j.Invoke=0]="Invoke",j[j.TriggerCharacter=1]="TriggerCharacter",j[j.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(dt||(e.CompletionTriggerKind=dt={}));var Y;(function(j){j[j.Text=0]="Text",j[j.Method=1]="Method",j[j.Function=2]="Function",j[j.Constructor=3]="Constructor",j[j.Field=4]="Field",j[j.Variable=5]="Variable",j[j.Class=6]="Class",j[j.Interface=7]="Interface",j[j.Module=8]="Module",j[j.Property=9]="Property",j[j.Unit=10]="Unit",j[j.Value=11]="Value",j[j.Enum=12]="Enum",j[j.Keyword=13]="Keyword",j[j.Snippet=14]="Snippet",j[j.Color=15]="Color",j[j.File=16]="File",j[j.Reference=17]="Reference",j[j.Folder=18]="Folder",j[j.EnumMember=19]="EnumMember",j[j.Constant=20]="Constant",j[j.Struct=21]="Struct",j[j.Event=22]="Event",j[j.Operator=23]="Operator",j[j.TypeParameter=24]="TypeParameter",j[j.User=25]="User",j[j.Issue=26]="Issue"})(Y||(e.CompletionItemKind=Y={}));var Q;(function(j){j[j.Deprecated=1]="Deprecated"})(Q||(e.CompletionItemTag=Q={}));let Ee=class{constructor(U,oe){this.label=U,this.kind=oe}toJSON(){return{label:this.label,kind:this.kind&&Y[this.kind],detail:this.detail,documentation:this.documentation,sortText:this.sortText,filterText:this.filterText,preselect:this.preselect,insertText:this.insertText,textEdit:this.textEdit}}};e.$6K=Ee,e.$6K=Ee=Ke([L],Ee);let Be=class{constructor(U=[],oe=!1){this.items=U,this.isIncomplete=oe}};e.$7K=Be,e.$7K=Be=Ke([L],Be);let He=class{constructor(U,oe,ke){this.insertText=U,this.range=oe,this.command=ke}};e.$8K=He,e.$8K=He=Ke([L],He);let Ye=class{constructor(U){this.commands=void 0,this.suppressSuggestions=void 0,this.items=U}};e.$9K=Ye,e.$9K=Ye=Ke([L],Ye);var st;(function(j){j[j.Active=-1]="Active",j[j.Beside=-2]="Beside",j[j.One=1]="One",j[j.Two=2]="Two",j[j.Three=3]="Three",j[j.Four=4]="Four",j[j.Five=5]="Five",j[j.Six=6]="Six",j[j.Seven=7]="Seven",j[j.Eight=8]="Eight",j[j.Nine=9]="Nine"})(st||(e.ViewColumn=st={}));var vt;(function(j){j[j.Left=1]="Left",j[j.Right=2]="Right"})(vt||(e.StatusBarAlignment=vt={}));function Dt(j,U){return`${D.$_l.toKey(j)}.${U}`}e.$0K=Dt;var ze;(function(j){j[j.Off=0]="Off",j[j.On=1]="On",j[j.Relative=2]="Relative"})(ze||(e.TextEditorLineNumbersStyle=ze={}));var Kt;(function(j){j[j.Manual=1]="Manual",j[j.AfterDelay=2]="AfterDelay",j[j.FocusOut=3]="FocusOut"})(Kt||(e.TextDocumentSaveReason=Kt={}));var Ht;(function(j){j[j.Default=0]="Default",j[j.InCenter=1]="InCenter",j[j.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",j[j.AtTop=3]="AtTop"})(Ht||(e.TextEditorRevealType=Ht={}));var yt;(function(j){j[j.Keyboard=1]="Keyboard",j[j.Mouse=2]="Mouse",j[j.Command=3]="Command"})(yt||(e.TextEditorSelectionChangeKind=yt={}));var jt;(function(j){j[j.Undo=1]="Undo",j[j.Redo=2]="Redo"})(jt||(e.TextDocumentChangeReason=jt={}));var zt;(function(j){j[j.OpenOpen=0]="OpenOpen",j[j.ClosedClosed=1]="ClosedClosed",j[j.OpenClosed=2]="OpenClosed",j[j.ClosedOpen=3]="ClosedOpen"})(zt||(e.DecorationRangeBehavior=zt={})),function(j){function U(oe){switch(oe){case"keyboard":return j.Keyboard;case"mouse":return j.Mouse;case"api":return j.Command}}j.fromValue=U}(yt||(e.TextEditorSelectionChangeKind=yt={}));var Gt;(function(j){j[j.Other=0]="Other",j[j.Comment=1]="Comment",j[j.String=2]="String",j[j.RegEx=3]="RegEx"})(Gt||(e.SyntaxTokenType=Gt={})),function(j){function U(oe){switch(oe){case j.Other:return"other";case j.Comment:return"comment";case j.String:return"string";case j.RegEx:return"regex"}return"other"}j.toString=U}(Gt||(e.SyntaxTokenType=Gt={}));let Bt=class{constructor(U,oe){if(oe&&!f.URI.isUri(oe))throw(0,F.$6)("target");if(!T.isRange(U)||U.isEmpty)throw(0,F.$6)("range");this.range=U,this.target=oe}};e.$$K=Bt,e.$$K=Bt=Ke([L],Bt);let St=class{constructor(U,oe,ke,Ge){this.red=U,this.green=oe,this.blue=ke,this.alpha=Ge}};e.$_K=St,e.$_K=St=Ke([L],St);let Lt=class{constructor(U,oe){if(oe&&!(oe instanceof St))throw(0,F.$6)("color");if(!T.isRange(U)||U.isEmpty)throw(0,F.$6)("range");this.range=U,this.color=oe}};e.$aL=Lt,e.$aL=Lt=Ke([L],Lt);let Vt=class{constructor(U){if(!U||typeof U!="string")throw(0,F.$6)("label");this.label=U}};e.$bL=Vt,e.$bL=Vt=Ke([L],Vt);var Xe;(function(j){j[j.RGB=0]="RGB",j[j.HEX=1]="HEX",j[j.HSL=2]="HSL"})(Xe||(e.ColorFormat=Xe={}));var Wt;(function(j){j[j.Error=0]="Error",j[j.Warning=1]="Warning",j[j.Information=2]="Information"})(Wt||(e.SourceControlInputBoxValidationType=Wt={}));var qt;(function(j){j[j.Unknown=0]="Unknown",j[j.Shutdown=1]="Shutdown",j[j.Process=2]="Process",j[j.User=3]="User",j[j.Extension=4]="Extension"})(qt||(e.TerminalExitReason=qt={}));class ct{constructor(U,oe,ke){if(this.startIndex=U,this.length=oe,this.tooltip=ke,typeof U!="number"||U<0)throw(0,F.$6)("startIndex");if(typeof oe!="number"||oe<1)throw(0,F.$6)("length");if(ke!==void 0&&typeof ke!="string")throw(0,F.$6)("tooltip")}}e.$cL=ct;class gt{constructor(U){this.uri=U}}e.$dL=gt;class Ot{constructor(U){this.terminalCommand=U}}e.$eL=Ot;var Pt;(function(j){j[j.Panel=1]="Panel",j[j.Editor=2]="Editor"})(Pt||(e.TerminalLocation=Pt={}));class Rt{constructor(U){if(this.options=U,typeof U!="object")throw(0,F.$6)("options")}}e.$fL=Rt;var ft;(function(j){j[j.Always=1]="Always",j[j.Silent=2]="Silent",j[j.Never=3]="Never"})(ft||(e.TaskRevealKind=ft={}));var kt;(function(j){j[j.Shared=1]="Shared",j[j.Dedicated=2]="Dedicated",j[j.New=3]="New"})(kt||(e.TaskPanelKind=kt={}));let At=class{static{m=this}static{this.Clean=new m("clean","Clean")}static{this.Build=new m("build","Build")}static{this.Rebuild=new m("rebuild","Rebuild")}static{this.Test=new m("test","Test")}static from(U){switch(U){case"clean":return m.Clean;case"build":return m.Build;case"rebuild":return m.Rebuild;case"test":return m.Test;default:return}}constructor(U,oe){if(this.label=oe,typeof U!="string"||typeof oe!="string")throw(0,F.$6)("name");this.c=U}get id(){return this.c}};e.$gL=At,e.$gL=At=m=Ke([L],At);function Ct(j){let U="";for(let oe=0;oe<j.length;oe++)U+=j[oe].replace(/,/g,",,")+",";return U}let We=class{constructor(U,oe,ke){if(typeof U!="string")throw(0,F.$6)("process");this.e=[],this.c=U,oe!==void 0&&(Array.isArray(oe)?(this.e=oe,this.f=ke):this.f=oe)}get process(){return this.c}set process(U){if(typeof U!="string")throw(0,F.$6)("process");this.c=U}get args(){return this.e}set args(U){Array.isArray(U)||(U=[]),this.e=U}get options(){return this.f}set options(U){this.f=U}computeId(){const U=[];if(U.push("process"),this.c!==void 0&&U.push(this.c),this.e&&this.e.length>0)for(const oe of this.e)U.push(oe);return Ct(U)}};e.$hL=We,e.$hL=We=Ke([L],We);let Nt=class{constructor(U,oe,ke){if(this.f=[],Array.isArray(oe)){if(!U)throw(0,F.$6)("command can't be undefined or null");if(typeof U!="string"&&typeof U.value!="string")throw(0,F.$6)("command");this.e=U,this.f=oe,this.g=ke}else{if(typeof U!="string")throw(0,F.$6)("commandLine");this.c=U,this.g=oe}}get commandLine(){return this.c}set commandLine(U){if(typeof U!="string")throw(0,F.$6)("commandLine");this.c=U}get command(){return this.e?this.e:""}set command(U){if(typeof U!="string"&&typeof U.value!="string")throw(0,F.$6)("command");this.e=U}get args(){return this.f}set args(U){this.f=U||[]}get options(){return this.g}set options(U){this.g=U}computeId(){const U=[];if(U.push("shell"),this.c!==void 0&&U.push(this.c),this.e!==void 0&&U.push(typeof this.e=="string"?this.e:this.e.value),this.f&&this.f.length>0)for(const oe of this.f)U.push(typeof oe=="string"?oe:oe.value);return Ct(U)}};e.$iL=Nt,e.$iL=Nt=Ke([L],Nt);var Jt;(function(j){j[j.Escape=1]="Escape",j[j.Strong=2]="Strong",j[j.Weak=3]="Weak"})(Jt||(e.ShellQuoting=Jt={}));var Ce;(function(j){j[j.Global=1]="Global",j[j.Workspace=2]="Workspace"})(Ce||(e.TaskScope=Ce={}));class Me{constructor(U){this.c=U}computeId(){return"customExecution"+(0,C.$ig)()}set callback(U){this.c=U}get callback(){return this.c}}e.$jL=Me;let ve=class{static{S=this}static{this.c="customExecution"}static{this.e="process"}static{this.f="shell"}static{this.g="$empty"}constructor(U,oe,ke,Ge,xe,at){this.j=!1,this.k=this.definition=U;let ht;typeof oe=="string"?(this.m=this.name=oe,this.t=this.source=ke,this.execution=Ge,ht=xe,this.j=!0):oe===Ce.Global||oe===Ce.Workspace?(this.target=oe,this.m=this.name=ke,this.t=this.source=Ge,this.execution=xe,ht=at):(this.target=oe,this.m=this.name=ke,this.t=this.source=Ge,this.execution=xe,ht=at),typeof ht=="string"?(this.o=[ht],this.q=!0):Array.isArray(ht)?(this.o=ht,this.q=!0):(this.o=[],this.q=!1),this.r=!1,this.w=Object.create(null),this.x=Object.create(null)}get _id(){return this.h}set _id(U){this.h=U}get _deprecated(){return this.j}z(){this.h!==void 0&&(this.h=void 0,this.l=void 0,this.A())}A(){this.n instanceof We?this.k={type:S.e,id:this.n.computeId()}:this.n instanceof Nt?this.k={type:S.f,id:this.n.computeId()}:this.n instanceof Me?this.k={type:S.c,id:this.n.computeId()}:this.k={type:S.g,id:(0,C.$ig)()}}get definition(){return this.k}set definition(U){if(U==null)throw(0,F.$6)("Kind can't be undefined or null");this.z(),this.k=U}get scope(){return this.l}set target(U){this.z(),this.l=U}get name(){return this.m}set name(U){if(typeof U!="string")throw(0,F.$6)("name");this.z(),this.m=U}get execution(){return this.n}set execution(U){U===null&&(U=void 0),this.z(),this.n=U;const oe=this.k.type;(S.g===oe||S.e===oe||S.f===oe||S.c===oe)&&this.A()}get problemMatchers(){return this.o}set problemMatchers(U){if(Array.isArray(U))this.z(),this.o=U,this.q=!0;else{this.z(),this.o=[],this.q=!1;return}}get hasDefinedMatchers(){return this.q}get isBackground(){return this.r}set isBackground(U){U!==!0&&U!==!1&&(U=!1),this.z(),this.r=U}get source(){return this.t}set source(U){if(typeof U!="string"||U.length===0)throw(0,F.$6)("source must be a string of length > 0");this.z(),this.t=U}get group(){return this.u}set group(U){U===null&&(U=void 0),this.z(),this.u=U}get detail(){return this.y}set detail(U){U===null&&(U=void 0),this.y=U}get presentationOptions(){return this.w}set presentationOptions(U){U==null&&(U=Object.create(null)),this.z(),this.w=U}get runOptions(){return this.x}set runOptions(U){U==null&&(U=Object.create(null)),this.z(),this.x=U}};e.$kL=ve,e.$kL=ve=S=Ke([L],ve);var H;(function(j){j[j.SourceControl=1]="SourceControl",j[j.Window=10]="Window",j[j.Notification=15]="Notification"})(H||(e.ProgressLocation=H={}));var Le;(function(j){function U(oe){const ke=oe;return(0,E.$Gf)(ke.value)?ke.tooltip&&!(0,E.$Cf)(ke.tooltip)?(console.log("INVALID view badge, invalid tooltip",ke.tooltip),!1):!0:(console.log("INVALID view badge, invalid value",ke.value),!1)}j.isViewBadge=U})(Le||(e.ViewBadge=Le={}));let je=k=class{static isTreeItem(U,oe){const ke=U;if(ke.checkboxState!==void 0){const Ge=(0,E.$Gf)(ke.checkboxState)?ke.checkboxState:(0,E.$Ef)(ke.checkboxState)&&(0,E.$Gf)(ke.checkboxState.state)?ke.checkboxState.state:void 0,xe=!(0,E.$Gf)(ke.checkboxState)&&(0,E.$Ef)(ke.checkboxState)?ke.checkboxState.tooltip:void 0;if(Ge===void 0||Ge!==qe.Checked&&Ge!==qe.Unchecked||xe!==void 0&&!(0,E.$Cf)(xe))return console.log("INVALID tree item, invalid checkboxState",ke.checkboxState),!1}if(U instanceof k)return!0;if(ke.label!==void 0&&!(0,E.$Cf)(ke.label)&&!ke.label?.label)return console.log("INVALID tree item, invalid label",ke.label),!1;if(ke.id!==void 0&&!(0,E.$Cf)(ke.id))return console.log("INVALID tree item, invalid id",ke.id),!1;if(ke.iconPath!==void 0&&!(0,E.$Cf)(ke.iconPath)&&!f.URI.isUri(ke.iconPath)&&(!ke.iconPath||!(0,E.$Cf)(ke.iconPath.id))){const Ge=ke.iconPath;if(!Ge||!(0,E.$Cf)(Ge.light)&&!f.URI.isUri(Ge.light)&&!(0,E.$Cf)(Ge.dark)&&!f.URI.isUri(Ge.dark))return console.log("INVALID tree item, invalid iconPath",ke.iconPath),!1}return ke.description!==void 0&&!(0,E.$Cf)(ke.description)&&typeof ke.description!="boolean"?(console.log("INVALID tree item, invalid description",ke.description),!1):ke.resourceUri!==void 0&&!f.URI.isUri(ke.resourceUri)?(console.log("INVALID tree item, invalid resourceUri",ke.resourceUri),!1):ke.tooltip!==void 0&&!(0,E.$Cf)(ke.tooltip)&&!(ke.tooltip instanceof Ze)?(console.log("INVALID tree item, invalid tooltip",ke.tooltip),!1):ke.command!==void 0&&!ke.command.command?(console.log("INVALID tree item, invalid command",ke.command),!1):ke.collapsibleState!==void 0&&ke.collapsibleState<Qe.None&&ke.collapsibleState>Qe.Expanded?(console.log("INVALID tree item, invalid collapsibleState",ke.collapsibleState),!1):ke.contextValue!==void 0&&!(0,E.$Cf)(ke.contextValue)?(console.log("INVALID tree item, invalid contextValue",ke.contextValue),!1):ke.accessibilityInformation!==void 0&&!ke.accessibilityInformation?.label?(console.log("INVALID tree item, invalid accessibilityInformation",ke.accessibilityInformation),!1):!0}constructor(U,oe=Qe.None){this.collapsibleState=oe,f.URI.isUri(U)?this.resourceUri=U:this.label=U}};e.$lL=je,e.$lL=je=k=Ke([L],je);var Qe;(function(j){j[j.None=0]="None",j[j.Collapsed=1]="Collapsed",j[j.Expanded=2]="Expanded"})(Qe||(e.TreeItemCollapsibleState=Qe={}));var qe;(function(j){j[j.Unchecked=0]="Unchecked",j[j.Checked=1]="Checked"})(qe||(e.TreeItemCheckboxState=qe={}));let it=class{async asString(){return typeof this.value=="string"?this.value:JSON.stringify(this.value)}asFile(){}constructor(U){this.value=U}};e.$mL=it,e.$mL=it=Ke([L],it);class pt extends it{}e.$nL=pt;class $t extends pt{#e;constructor(U){super(""),this.#e=U}asFile(){return this.#e}}e.$oL=$t;class bt{constructor(U,oe,ke,Ge){this.name=U,this.uri=oe,this._itemId=ke,this.c=Ge}data(){return this.c()}}e.$pL=bt;let ut=class{#e=new Map;constructor(U){for(const[oe,ke]of U??[]){const Ge=this.#e.get(this.#t(oe));Ge?Ge.push(ke):this.#e.set(this.#t(oe),[ke])}}get(U){return this.#e.get(this.#t(U))?.[0]}set(U,oe){this.#e.set(this.#t(U),[oe])}forEach(U,oe){for(const[ke,Ge]of this.#e)for(const xe of Ge)U.call(oe,xe,ke,this)}*[Symbol.iterator](){for(const[U,oe]of this.#e)for(const ke of oe)yield[U,ke]}#t(U){return U.toLowerCase()}};e.$qL=ut,e.$qL=ut=Ke([L],ut);let Mt=class{constructor(U){this.insertText=U}};e.$rL=Mt,e.$rL=Mt=Ke([L],Mt);let Qt=class{constructor(U,oe){this.label=oe,this.insertText=U}};e.$sL=Qt,e.$sL=Qt=Ke([L],Qt);let Yt=class{constructor(U,oe){this.id=U,this.color=oe}static isThemeIcon(U){return typeof U.id!="string"?(console.log("INVALID ThemeIcon, invalid id",U.id),!1):!0}};e.$tL=Yt,e.$tL=Yt=Ke([L],Yt),Yt.File=new Yt("file"),Yt.Folder=new Yt("folder");let si=class{constructor(U){this.id=U}};e.$uL=si,e.$uL=si=Ke([L],si);var ki;(function(j){j[j.Global=1]="Global",j[j.Workspace=2]="Workspace",j[j.WorkspaceFolder=3]="WorkspaceFolder"})(ki||(e.ConfigurationTarget=ki={}));let It=class{get base(){return this.c}set base(U){this.c=U,this.e=f.URI.file(U)}get baseUri(){return this.e}set baseUri(U){this.e=U,this.c=U.fsPath}constructor(U,oe){if(typeof U!="string"&&(!U||!f.URI.isUri(U)&&!f.URI.isUri(U.uri)))throw(0,F.$6)("base");if(typeof oe!="string")throw(0,F.$6)("pattern");typeof U=="string"?this.baseUri=f.URI.file(U):f.URI.isUri(U)?this.baseUri=U:this.baseUri=U.uri,this.pattern=oe}toJSON(){return{pattern:this.pattern,base:this.base,baseUri:this.baseUri.toJSON()}}};e.$vL=It,e.$vL=It=Ke([L],It);const Zi=new WeakMap;function ln(j,U){Zi.set(j,U)}e.$wL=ln;let Et=class{constructor(U,oe,ke,Ge){this.enabled=typeof U=="boolean"?U:!0,typeof oe=="string"&&(this.condition=oe),typeof ke=="string"&&(this.hitCondition=ke),typeof Ge=="string"&&(this.logMessage=Ge)}get id(){return this.c||(this.c=Zi.get(this)??(0,C.$ig)()),this.c}};e.$xL=Et,e.$xL=Et=Ke([L],Et);let gi=class extends Et{constructor(U,oe,ke,Ge,xe){if(super(oe,ke,Ge,xe),U===null)throw(0,F.$6)("location");this.location=U}};e.$yL=gi,e.$yL=gi=Ke([L],gi);let mi=class extends Et{constructor(U,oe,ke,Ge,xe){super(oe,ke,Ge,xe),this.functionName=U}};e.$zL=mi,e.$zL=mi=Ke([L],mi);let oi=class extends Et{constructor(U,oe,ke,Ge,xe,at,ht){if(super(Ge,xe,at,ht),!oe)throw(0,F.$6)("dataId");this.label=U,this.dataId=oe,this.canPersist=ke}};e.$AL=oi,e.$AL=oi=Ke([L],oi);let Si=class{constructor(U,oe,ke){this.command=U,this.args=oe||[],this.options=ke}};e.$BL=Si,e.$BL=Si=Ke([L],Si);let Ii=class{constructor(U,oe){this.port=U,this.host=oe}};e.$CL=Ii,e.$CL=Ii=Ke([L],Ii);let Ft=class{constructor(U){this.path=U}};e.$DL=Ft,e.$DL=Ft=Ke([L],Ft);let $i=class{constructor(U){this.implementation=U}};e.$EL=$i,e.$EL=$i=Ke([L],$i);let Ci=class{constructor(U,oe,ke){this.session=U,this.threadId=oe,this.frameId=ke}};e.$FL=Ci,e.$FL=Ci=Ke([L],Ci);let ai=class{constructor(U,oe){this.session=U,this.threadId=oe}};e.$GL=ai,e.$GL=ai=Ke([L],ai);let ci=class{constructor(U,oe){this.range=U,this.expression=oe}};e.$HL=ci,e.$HL=ci=Ke([L],ci);var lt;(function(j){j[j.Invoke=0]="Invoke",j[j.Automatic=1]="Automatic"})(lt||(e.InlineCompletionTriggerKind=lt={}));let Pi=class{constructor(U,oe){this.range=U,this.text=oe}};e.$IL=Pi,e.$IL=Pi=Ke([L],Pi);let xt=class{constructor(U,oe,ke=!0){this.range=U,this.variableName=oe,this.caseSensitiveLookup=ke}};e.$JL=xt,e.$JL=xt=Ke([L],xt);let ni=class{constructor(U,oe){this.range=U,this.expression=oe}};e.$KL=ni,e.$KL=ni=Ke([L],ni);let pi=class{constructor(U,oe){this.frameId=U,this.stoppedLocation=oe}};e.$LL=pi,e.$LL=pi=Ke([L],pi);var Yi;(function(j){j[j.Changed=1]="Changed",j[j.Created=2]="Created",j[j.Deleted=3]="Deleted"})(Yi||(e.FileChangeType=Yi={}));let Ri=h=class extends Error{static FileExists(U){return new h(U,u.FileSystemProviderErrorCode.FileExists,h.FileExists)}static FileNotFound(U){return new h(U,u.FileSystemProviderErrorCode.FileNotFound,h.FileNotFound)}static FileNotADirectory(U){return new h(U,u.FileSystemProviderErrorCode.FileNotADirectory,h.FileNotADirectory)}static FileIsADirectory(U){return new h(U,u.FileSystemProviderErrorCode.FileIsADirectory,h.FileIsADirectory)}static NoPermissions(U){return new h(U,u.FileSystemProviderErrorCode.NoPermissions,h.NoPermissions)}static Unavailable(U){return new h(U,u.FileSystemProviderErrorCode.Unavailable,h.Unavailable)}constructor(U,oe=u.FileSystemProviderErrorCode.Unknown,ke){super(f.URI.isUri(U)?U.toString(!0):U),this.code=ke?.name??"Unknown",(0,u.$tk)(this,oe),Object.setPrototypeOf(this,h.prototype),typeof Error.captureStackTrace=="function"&&typeof ke=="function"&&Error.captureStackTrace(this,ke)}};e.$ML=Ri,e.$ML=Ri=h=Ke([L],Ri);let Ai=class{constructor(U,oe,ke){this.start=U,this.end=oe,this.kind=ke}};e.$NL=Ai,e.$NL=Ai=Ke([L],Ai);var Mi;(function(j){j[j.Comment=1]="Comment",j[j.Imports=2]="Imports",j[j.Region=3]="Region"})(Mi||(e.FoldingRangeKind=Mi={}));var xi;(function(j){j[j.Collapsed=0]="Collapsed",j[j.Expanded=1]="Expanded"})(xi||(e.CommentThreadCollapsibleState=xi={}));var Li;(function(j){j[j.Editing=0]="Editing",j[j.Preview=1]="Preview"})(Li||(e.CommentMode=Li={}));var ui;(function(j){j[j.Published=0]="Published",j[j.Draft=1]="Draft"})(ui||(e.CommentState=ui={}));var _i;(function(j){j[j.Unresolved=0]="Unresolved",j[j.Resolved=1]="Resolved"})(_i||(e.CommentThreadState=_i={}));class Fi{constructor(U,oe=[]){this.tokenTypes=U,this.tokenModifiers=oe}}e.$OL=Fi;function Ti(j){return typeof j>"u"||(0,E.$Df)(j)}class Oi{constructor(U){if(this.c=0,this.e=0,this.f=!0,this.g=[],this.h=0,this.j=new Map,this.k=new Map,this.l=!1,U){this.l=!0;for(let oe=0,ke=U.tokenTypes.length;oe<ke;oe++)this.j.set(U.tokenTypes[oe],oe);for(let oe=0,ke=U.tokenModifiers.length;oe<ke;oe++)this.k.set(U.tokenModifiers[oe],oe)}}push(U,oe,ke,Ge,xe){if(typeof U=="number"&&typeof oe=="number"&&typeof ke=="number"&&typeof Ge=="number"&&(typeof xe=="number"||typeof xe>"u"))return typeof xe>"u"&&(xe=0),this.n(U,oe,ke,Ge,xe);if(T.isRange(U)&&typeof oe=="string"&&Ti(ke))return this.m(U,oe,ke);throw(0,F.$6)()}m(U,oe,ke){if(!this.l)throw new Error("Legend must be provided in constructor");if(U.start.line!==U.end.line)throw new Error("`range` cannot span multiple lines");if(!this.j.has(oe))throw new Error("`tokenType` is not in the provided legend");const Ge=U.start.line,xe=U.start.character,at=U.end.character-U.start.character,ht=this.j.get(oe);let Ut=0;if(ke)for(const Zt of ke){if(!this.k.has(Zt))throw new Error("`tokenModifier` is not in the provided legend");const ei=this.k.get(Zt);Ut|=1<<ei>>>0}this.n(Ge,xe,at,ht,Ut)}n(U,oe,ke,Ge,xe){if(this.f&&(U<this.c||U===this.c&&oe<this.e)){this.f=!1;const Ut=this.g.length/5|0;let Zt=0,ei=0;for(let ii=0;ii<Ut;ii++){let ri=this.g[5*ii],Qi=this.g[5*ii+1];ri===0?(ri=Zt,Qi+=ei):ri+=Zt,this.g[5*ii]=ri,this.g[5*ii+1]=Qi,Zt=ri,ei=Qi}}let at=U,ht=oe;this.f&&this.h>0&&(at-=this.c,at===0&&(ht-=this.e)),this.g[this.h++]=at,this.g[this.h++]=ht,this.g[this.h++]=ke,this.g[this.h++]=Ge,this.g[this.h++]=xe,this.c=U,this.e=oe}static o(U){const oe=[],ke=U.length/5|0;for(let ht=0;ht<ke;ht++)oe[ht]=ht;oe.sort((ht,Ut)=>{const Zt=U[5*ht],ei=U[5*Ut];if(Zt===ei){const ii=U[5*ht+1],ri=U[5*Ut+1];return ii-ri}return Zt-ei});const Ge=new Uint32Array(U.length);let xe=0,at=0;for(let ht=0;ht<ke;ht++){const Ut=5*oe[ht],Zt=U[Ut+0],ei=U[Ut+1],ii=U[Ut+2],ri=U[Ut+3],Qi=U[Ut+4],Sn=Zt-xe,Tn=Sn===0?ei-at:ei,Xi=5*ht;Ge[Xi+0]=Sn,Ge[Xi+1]=Tn,Ge[Xi+2]=ii,Ge[Xi+3]=ri,Ge[Xi+4]=Qi,xe=Zt,at=ei}return Ge}build(U){return this.f?new zi(new Uint32Array(this.g),U):new zi(Oi.o(this.g),U)}}e.$PL=Oi;class zi{constructor(U,oe){this.resultId=oe,this.data=U}}e.$QL=zi;class hi{constructor(U,oe,ke){this.start=U,this.deleteCount=oe,this.data=ke}}e.$RL=hi;class hn{constructor(U,oe){this.resultId=oe,this.edits=U}}e.$SL=hn;var en;(function(j){j[j.Separate=0]="Separate",j[j.MergeWithParent=1]="MergeWithParent"})(en||(e.DebugConsoleMode=en={}));let Ni=class{static{this.Back={iconPath:new Yt("arrow-left")}}constructor(){}};e.$TL=Ni,e.$TL=Ni=Ke([L],Ni);var vi;(function(j){j[j.Separator=-1]="Separator",j[j.Default=0]="Default"})(vi||(e.QuickPickItemKind=vi={}));var tn;(function(j){j[j.Info=1]="Info",j[j.Warning=2]="Warning",j[j.Error=3]="Error"})(tn||(e.InputBoxValidationSeverity=tn={}));var nn;(function(j){j[j.UI=1]="UI",j[j.Workspace=2]="Workspace"})(nn||(e.ExtensionKind=nn={}));class bi{static validate(U){if(typeof U.badge=="string"){let oe=(0,$.$df)(U.badge,0);if(oe<U.badge.length&&(oe+=(0,$.$df)(U.badge,oe)),U.badge.length>oe)throw new Error("The 'badge'-property must be undefined or a short character")}else if(U.badge&&!Yt.isThemeIcon(U.badge))throw new Error("The 'badge'-property is not a valid ThemeIcon");if(!U.color&&!U.badge&&!U.tooltip)throw new Error("The decoration is empty");return!0}constructor(U,oe,ke){this.badge=U,this.tooltip=oe,this.color=ke}}e.$UL=bi;let wi=class{constructor(U){this.kind=U}};e.$VL=wi,e.$VL=wi=Ke([L],wi);var rn;(function(j){j[j.Light=1]="Light",j[j.Dark=2]="Dark",j[j.HighContrast=3]="HighContrast",j[j.HighContrastLight=4]="HighContrastLight"})(rn||(e.ColorThemeKind=rn={}));class _t{static isNotebookRange(U){return U instanceof _t?!0:U?typeof U.start=="number"&&typeof U.end=="number":!1}get start(){return this.c}get end(){return this.e}get isEmpty(){return this.c===this.e}constructor(U,oe){if(U<0)throw(0,F.$6)("start must be positive");if(oe<0)throw(0,F.$6)("end must be positive");U<=oe?(this.c=U,this.e=oe):(this.c=oe,this.e=U)}with(U){let oe=this.c,ke=this.e;return U.start!==void 0&&(oe=U.start),U.end!==void 0&&(ke=U.end),oe===this.c&&ke===this.e?this:new _t(oe,ke)}}e.$WL=_t;class di{static validate(U){if(typeof U.kind!="number")throw new Error("NotebookCellData MUST have 'kind' property");if(typeof U.value!="string")throw new Error("NotebookCellData MUST have 'value' property");if(typeof U.languageId!="string")throw new Error("NotebookCellData MUST have 'languageId' property")}static isNotebookCellDataArray(U){return Array.isArray(U)&&U.every(oe=>di.isNotebookCellData(oe))}static isNotebookCellData(U){return!0}constructor(U,oe,ke,Ge,xe,at,ht){this.kind=U,this.value=oe,this.languageId=ke,this.mime=Ge,this.outputs=xe??[],this.metadata=at,this.executionSummary=ht,di.validate(this)}}e.$XL=di;class dn{constructor(U){this.cells=U}}e.$YL=dn;class Xt{static isNotebookCellOutputItem(U){return U instanceof Xt?!0:U?typeof U.mime=="string"&&U.data instanceof Uint8Array:!1}static error(U){const oe={name:U.name,message:U.message,stack:U.stack};return Xt.json(oe,"application/vnd.code.notebook.error")}static stdout(U){return Xt.text(U,"application/vnd.code.notebook.stdout")}static stderr(U){return Xt.text(U,"application/vnd.code.notebook.stderr")}static bytes(U,oe="application/octet-stream"){return new Xt(U,oe)}static#e=new TextEncoder;static text(U,oe=A.$Vr.text){const ke=Xt.#e.encode(String(U));return new Xt(ke,oe)}static json(U,oe="text/x-json"){const ke=JSON.stringify(U,void 0,"	");return Xt.text(ke,oe)}constructor(U,oe){this.data=U,this.mime=oe;const ke=(0,A.$Zr)(oe,!0);if(!ke)throw new Error(`INVALID mime type: ${oe}. Must be in the format "type/subtype[;optionalparameter]"`);this.mime=ke}}e.$ZL=Xt;class yi{static isNotebookCellOutput(U){return U instanceof yi?!0:!U||typeof U!="object"?!1:typeof U.id=="string"&&Array.isArray(U.items)}static ensureUniqueMimeTypes(U,oe=!1){const ke=new Set,Ge=new Set;for(let xe=0;xe<U.length;xe++){const at=U[xe],ht=(0,A.$Zr)(at.mime);if(!ke.has(ht)||(0,p.$BI)(ht)){ke.add(ht);continue}Ge.add(xe),oe&&console.warn(`DUPLICATED mime type '${at.mime}' will be dropped`)}return Ge.size===0?U:U.filter((xe,at)=>!Ge.has(at))}constructor(U,oe,ke){this.items=yi.ensureUniqueMimeTypes(U,!0),typeof oe=="string"?(this.id=oe,this.metadata=ke):(this.id=(0,C.$ig)(),this.metadata=oe??ke)}}e.$1L=yi;var sn;(function(j){j[j.Markup=1]="Markup",j[j.Code=2]="Code"})(sn||(e.NotebookCellKind=sn={}));var Ei;(function(j){j[j.Idle=1]="Idle",j[j.Pending=2]="Pending",j[j.Executing=3]="Executing"})(Ei||(e.NotebookCellExecutionState=Ei={}));var Ui;(function(j){j[j.Left=1]="Left",j[j.Right=2]="Right"})(Ui||(e.NotebookCellStatusBarAlignment=Ui={}));var Te;(function(j){j[j.Default=0]="Default",j[j.InCenter=1]="InCenter",j[j.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",j[j.AtTop=3]="AtTop"})(Te||(e.NotebookEditorRevealType=Te={}));class ti{constructor(U,oe){this.text=U,this.alignment=oe}}e.$2L=ti;var ji;(function(j){j[j.Default=1]="Default",j[j.Preferred=2]="Preferred"})(ji||(e.NotebookControllerAffinity=ji={}));var mt;(function(j){j[j.Default=1]="Default",j[j.Preferred=2]="Preferred",j[j.Hidden=-1]="Hidden"})(mt||(e.NotebookControllerAffinity2=mt={}));class fn{constructor(U,oe=[]){this.uri=U,this.provides=(0,y.$2b)(oe)}}e.$3L=fn;class gn{constructor(U){this.label=U}}e.$4L=gn;let Di=class{constructor(U,oe){this.label=U,this.timestamp=oe}};e.$5L=Di,e.$5L=Di=Ke([L],Di);var on;(function(j){j[j.Production=1]="Production",j[j.Development=2]="Development",j[j.Test=3]="Test"})(on||(e.ExtensionMode=on={}));var fi;(function(j){j[j.Node=1]="Node",j[j.Webworker=2]="Webworker"})(fi||(e.ExtensionRuntime=fi={}));var an;(function(j){j[j.Other=0]="Other",j[j.Comment=1]="Comment",j[j.String=2]="String",j[j.RegEx=3]="RegEx"})(an||(e.StandardTokenType=an={}));class mn{constructor(U,oe){this.ranges=U,this.wordPattern=oe}}e.$6L=mn;class $n{constructor(U){this.c=U}get autoForwardAction(){return this.c}}e.$7L=$n;var Bi;(function(j){j[j.Queued=1]="Queued",j[j.Running=2]="Running",j[j.Passed=3]="Passed",j[j.Failed=4]="Failed",j[j.Skipped=5]="Skipped",j[j.Errored=6]="Errored"})(Bi||(e.TestResultState=Bi={}));var cn;(function(j){j[j.Run=1]="Run",j[j.Debug=2]="Debug",j[j.Coverage=3]="Coverage"})(cn||(e.TestRunProfileKind=cn={}));let Vi=class{constructor(U=void 0,oe=void 0,ke=void 0,Ge=!1){this.include=U,this.exclude=oe,this.profile=ke,this.continuous=Ge}};e.$8L=Vi,e.$8L=Vi=Ke([L],Vi);let Wi=w=class{static diff(U,oe,ke){const Ge=new w(U);return Ge.expectedOutput=oe,Ge.actualOutput=ke,Ge}constructor(U){this.message=U}};e.$9L=Wi,e.$9L=Wi=w=Ke([L],Wi);let qi=class{constructor(U){this.id=U}};e.$0L=qi,e.$0L=qi=Ke([L],qi);let li=class{constructor(U,oe){this.covered=U,this.total=oe}};e.$$L=li,e.$$L=li=Ke([L],li);let Ki=I=class{static fromDetails(U,oe){const ke=new li(0,0),Ge=new li(0,0),xe=new li(0,0);for(const ht of oe)if("branches"in ht){ke.total+=1,ke.covered+=ht.executionCount>0?1:0;for(const Ut of ht.branches)Ge.total+=1,Ge.covered+=Ut.executionCount>0?1:0}else xe.total+=1,xe.covered+=ht.executionCount>0?1:0;const at=new I(U,ke,Ge.total>0?Ge:void 0,xe.total>0?xe:void 0);return at.detailedCoverage=oe,at}constructor(U,oe,ke,Ge){this.uri=U,this.statementCoverage=oe,this.branchCoverage=ke,this.functionCoverage=Ge}};e.$_L=Ki,e.$_L=Ki=I=Ke([L],Ki);let Hi=class{constructor(U,oe,ke=[]){this.executionCount=U,this.location=oe,this.branches=ke}};e.$aM=Hi,e.$aM=Hi=Ke([L],Hi);let Gi=class{constructor(U,oe){this.executionCount=U,this.location=oe}};e.$bM=Gi,e.$bM=Gi=Ke([L],Gi);let Ji=class{constructor(U,oe){this.executionCount=U,this.location=oe}};e.$cM=Ji,e.$cM=Ji=Ke([L],Ji);var un;(function(j){j[j.None=0]="None",j[j.Option=1]="Option",j[j.Default=2]="Default",j[j.Preferred=3]="Preferred"})(un||(e.ExternalUriOpenerPriority=un={}));var ee;(function(j){j[j.Untrusted=0]="Untrusted",j[j.Trusted=1]="Trusted",j[j.Unspecified=2]="Unspecified"})(ee||(e.WorkspaceTrustState=ee={}));var ge;(function(j){j[j.Notify=1]="Notify",j[j.OpenBrowser=2]="OpenBrowser",j[j.OpenPreview=3]="OpenPreview",j[j.Silent=4]="Silent",j[j.Ignore=5]="Ignore",j[j.OpenBrowserOnce=6]="OpenBrowserOnce"})(ge||(e.PortAutoForwardAction=ge={}));class Fe{constructor(U,oe,ke,Ge,xe,at){this.kind=U,this.name=oe,this.detail=ke,this.uri=Ge,this.range=xe,this.selectionRange=at}}e.$dM=Fe;class ot{constructor(U){this.uri=U}}e.$eM=ot;class wt{constructor(U,oe){this.original=U,this.modified=oe}}e.$fM=wt;class Tt{constructor(U,oe,ke,Ge){this.base=U,this.input1=oe,this.input2=ke,this.result=Ge}}e.$gM=Tt;class In{constructor(U,oe){this.uri=U,this.viewType=oe}}e.$hM=In;class Cn{constructor(U){this.viewType=U}}e.$iM=Cn;class Pn{constructor(U,oe){this.uri=U,this.notebookType=oe}}e.$jM=Pn;class Rn{constructor(U,oe,ke){this.original=U,this.modified=oe,this.notebookType=ke}}e.$kM=Rn;class An{constructor(){}}e.$lM=An;class Mn{constructor(U,oe){this.uri=U,this.inputBoxUri=oe}}e.$mM=Mn;class Ln{constructor(U){this.providerId=U}}e.$nM=Ln;var pn;(function(j){j[j.Down=0]="Down",j[j.Up=1]="Up"})(pn||(e.InteractiveSessionVoteDirection=pn={}));var vn;(function(j){j[j.Action=1]="Action",j[j.Toolbar=2]="Toolbar"})(vn||(e.InteractiveSessionCopyKind=vn={}));var bn;(function(j){j[j.Unhelpful=0]="Unhelpful",j[j.Helpful=1]="Helpful",j[j.Undone=2]="Undone",j[j.Accepted=3]="Accepted"})(bn||(e.InteractiveEditorResponseFeedbackKind=bn={}));var wn;(function(j){j[j.System=0]="System",j[j.User=1]="User",j[j.Assistant=2]="Assistant",j[j.Function=3]="Function"})(wn||(e.ChatMessageRole=wn={}));var yn;(function(j){j[j.Short=1]="Short",j[j.Medium=2]="Medium",j[j.Full=3]="Full"})(yn||(e.ChatVariableLevel=yn={}));class Fn{constructor(U,oe){this.role=U,this.content=oe}}e.$oM=Fn;var En;(function(j){j[j.Unhelpful=0]="Unhelpful",j[j.Helpful=1]="Helpful"})(En||(e.ChatAgentResultFeedbackKind=En={}));var Dn;(function(j){j[j.SymbolInformation=1]="SymbolInformation",j[j.CommandInformation=2]="CommandInformation",j[j.SearchInformation=3]="SearchInformation",j[j.SettingInformation=4]="SettingInformation"})(Dn||(e.RelatedInformationType=Dn={}));var kn;(function(j){j[j.Started=1]="Started",j[j.Recognizing=2]="Recognizing",j[j.Recognized=3]="Recognized",j[j.Stopped=4]="Stopped"})(kn||(e.SpeechToTextStatus=kn={}))}),define(Pe[103],Re([1,0,53,13,12,295,147,7,18]),function(be,e,y,F,P,M,A,$,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$DM=e.$CM=e.$BM=void 0;const f=new Map;function C(p,g){g?f.set(p,g):f.delete(p)}e.$BM=C;function D(p){return f.get(p)}class u extends M.$2u{constructor(g,t,i,r,c,o,l,n){super(t,i,r,c),this.c=g,this.m=o,this.q=l,this.notebook=n,this.b=!1}dispose(){(0,y.ok)(!this.b),this.b=!0,this.q=!1}equalLines(g){return(0,E.$tb)(this.f,g)}get document(){if(!this.a){const g=this;this.a={get uri(){return g.d},get fileName(){return g.d.fsPath},get isUntitled(){return g.d.scheme===F.Schemas.untitled},get languageId(){return g.m},get version(){return g.h},get isClosed(){return g.b},get isDirty(){return g.q},save(){return g.r()},getText(t){return t?g.s(t):g.getText()},get eol(){return g.g===`
`?$.EndOfLine.LF:$.EndOfLine.CRLF},get lineCount(){return g.f.length},lineAt(t){return g.t(t)},offsetAt(t){return g.u(t)},positionAt(t){return g.v(t)},validateRange(t){return g.w(t)},validatePosition(t){return g.x(t)},getWordRangeAtPosition(t,i){return g.y(t,i)}}}return Object.freeze(this.a)}_acceptLanguageId(g){(0,y.ok)(!this.b),this.m=g}_acceptIsDirty(g){(0,y.ok)(!this.b),this.q=g}r(){return this.b?Promise.reject(new Error("Document has been closed")):this.c.$trySaveDocument(this.d)}s(g){const t=this.w(g);if(t.isEmpty)return"";if(t.isSingleLine)return this.f[t.start.line].substring(t.start.character,t.end.character);const i=this.g,r=t.start.line,c=t.end.line,o=[];o.push(this.f[r].substring(t.start.character));for(let l=r+1;l<c;l++)o.push(this.f[l]);return o.push(this.f[c].substring(0,t.end.character)),o.join(i)}t(g){let t;if(g instanceof $.$AK?t=g.line:typeof g=="number"&&(t=g),typeof t!="number"||t<0||t>=this.f.length||Math.floor(t)!==t)throw new Error("Illegal value for `line`");return new b(t,this.f[t],t===this.f.length-1)}u(g){return g=this.x(g),this.l(),this.j.getPrefixSum(g.line-1)+g.character}v(g){g=Math.floor(g),g=Math.max(0,g),this.l();const t=this.j.getIndexOf(g),i=this.f[t.index].length;return new $.$AK(t.index,Math.min(t.remainder,i))}w(g){if(!(g instanceof $.$BK))throw new Error("Invalid argument");const t=this.x(g.start),i=this.x(g.end);return t===g.start&&i===g.end?g:new $.$BK(t.line,t.character,i.line,i.character)}x(g){if(!(g instanceof $.$AK))throw new Error("Invalid argument");if(this.f.length===0)return g.with(0,0);let{line:t,character:i}=g,r=!1;if(t<0)t=0,i=0,r=!0;else if(t>=this.f.length)t=this.f.length-1,i=this.f[t].length,r=!0;else{const c=this.f[t].length;i<0?(i=0,r=!0):i>c&&(i=c,r=!0)}return r?new $.$AK(t,i):g}y(g,t){const i=this.x(g);if(!t)t=D(this.m);else if((0,P.$Se)(t))throw new Error(`[getWordRangeAtPosition]: ignoring custom regexp '${t.source}' because it matches the empty string.`);const r=(0,A.$bs)(i.character+1,(0,A.$_r)(t),this.f[i.line],0);if(r)return new $.$BK(i.line,r.startColumn-1,i.line,r.endColumn-1)}}e.$CM=u;class b{constructor(g,t,i){this.a=g,this.b=t,this.c=i}get lineNumber(){return this.a}get text(){return this.b}get range(){return new $.$BK(this.a,0,this.a,this.b.length)}get rangeIncludingLineBreak(){return this.c?this.range:new $.$BK(this.a,0,this.a+1,0)}get firstNonWhitespaceCharacterIndex(){return/^(\s*)/.exec(this.b)[1].length}get isEmptyOrWhitespace(){return this.firstNonWhitespaceCharacterIndex===this.b.length}}e.$DM=b}),define(Pe[210],Re([1,0,7,17,5]),function(be,e,y,F,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bfc=void 0;let M=class{constructor($){this.a=new y.$VL(y.ColorThemeKind.Dark),this.b=new P.$Rd}get activeColorTheme(){return this.a}$onColorThemeChange($){let E;switch($){case"light":E=y.ColorThemeKind.Light;break;case"hcDark":E=y.ColorThemeKind.HighContrast;break;case"hcLight":E=y.ColorThemeKind.HighContrastLight;break;default:E=y.ColorThemeKind.Dark}this.a=new y.$VL(E),this.b.fire(this.a)}get onDidChangeActiveColorTheme(){return this.b.event}};e.$Bfc=M,e.$Bfc=M=Ke([Ve(0,F.$zM)],M)}),define(Pe[211],Re([1,0,4]),function(be,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$FI=e.CellExecutionUpdateType=void 0;var F;(function(P){P[P.Output=1]="Output",P[P.OutputItems=2]="OutputItems",P[P.ExecutionState=3]="ExecutionState"})(F||(e.CellExecutionUpdateType=F={})),e.$FI=(0,y.$Vh)("INotebookExecutionService")}),define(Pe[212],Re([1,0,6,29,144,93]),function(be,e,y,F,P,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$UOb=void 0;class A extends y.$Rc{constructor(E,f,C){super(),this._source=E,this.b=f,this.c=C,this.a=void 0}f(E){const f=E.getLineCount();return new F.$zs(1,1,f,this.g(E,f))}g(E,f){if(f<1||f>E.getLineCount())throw new Error("Illegal value for lineNumber");return E.getLineLength(f)+1}get inputTextBuffer(){if(!this.b){const E=new P.$MB;E.acceptChunk(this._source);const f=E.finish(!0),{textBuffer:C,disposable:D}=f.create(1);this.b=C,this.B(D)}return this.b}get outputTextBuffers(){return this.a||(this.a=this.c.map(E=>{const f=new P.$MB;f.acceptChunk(E);const C=f.finish(!0),{textBuffer:D,disposable:u}=C.create(1);return this.B(u),D})),this.a}findInInputs(E){const C=new M.$AB(E,!1,!1,null).parseSearchRequest();if(!C)return[];const D=this.f(this.inputTextBuffer);return this.inputTextBuffer.findMatchesLineByLine(D,C,!0,5e3)}findInOutputs(E){const C=new M.$AB(E,!1,!1,null).parseSearchRequest();return C?this.outputTextBuffers.map(D=>{const u=D.findMatchesLineByLine(this.f(D),C,!0,5e3);if(u.length!==0)return{textBuffer:D,matches:u}}).filter(D=>!!D):[]}}e.$UOb=A}),define(Pe[48],Re([1,0]),function(be,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qJ=e.TestPosition=e.TestIdPathParts=void 0;var y;(function(M){M.Delimiter="\0"})(y||(e.TestIdPathParts=y={}));var F;(function(M){M[M.IsSame=0]="IsSame",M[M.Disconnected=1]="Disconnected",M[M.IsChild=2]="IsChild",M[M.IsParent=3]="IsParent"})(F||(e.TestPosition=F={}));class P{static fromExtHostTestItem(A,$,E=A.parent){if(A._isRoot)return new P([$]);const f=[A.id];for(let C=E;C&&C.id!==$;C=C.parent)f.push(C.id);return f.push($),new P(f.reverse())}static isRoot(A){return!A.includes("\0")}static root(A){const $=A.indexOf("\0");return $===-1?A:A.slice(0,$)}static fromString(A){return new P(A.split("\0"))}static join(A,$){return new P([...A.path,$])}static joinToString(A,$){return A.toString()+"\0"+$}static parentId(A){const $=A.lastIndexOf("\0");return $===-1?void 0:A.slice(0,$)}static localId(A){const $=A.lastIndexOf("\0");return $===-1?A:A.slice($+1)}static isChild(A,$){return $.startsWith(A)&&$[A.length]==="\0"}static compare(A,$){return A===$?0:P.isChild(A,$)?2:P.isChild($,A)?3:1}constructor(A,$=A.length){if(this.path=A,this.d=$,A.length===0||$<1)throw new Error("cannot create test with empty path")}get rootId(){return new P(this.path,1)}get parentId(){return this.d>1?new P(this.path,this.d-1):void 0}get localId(){return this.path[this.d-1]}get controllerId(){return this.path[0]}get isRoot(){return this.d===1}*idsFromRoot(){for(let A=1;A<=this.d;A++)yield new P(this.path,A)}*idsToRoot(){for(let A=this.d;A>0;A--)yield new P(this.path,A)}compare(A){if(typeof A=="string")return P.compare(this.toString(),A);for(let $=0;$<A.d&&$<this.d;$++)if(A.path[$]!==this.path[$])return 1;return A.d>this.d?2:A.d<this.d?3:0}toJSON(){return this.toString()}toString(){if(!this.c){this.c=this.path[0];for(let A=1;A<this.d;A++)this.c+="\0",this.c+=this.path[A]}return this.c}}e.$qJ=P}),define(Pe[58],Re([1,0,2,29,48]),function(be,e,y,F,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xJ=e.TestsDiffOp=e.TestDiffOpType=e.DetailType=e.TestResultItem=e.$wJ=e.ITestItemUpdate=e.InternalTestItem=e.TestItemExpandState=e.ITestItem=e.$vJ=e.$uJ=e.ITestTaskState=e.ITestMessage=e.ITestOutputMessage=e.$tJ=e.ITestErrorMessage=e.TestMessageType=e.IRichLocation=e.$sJ=e.$rJ=e.TestRunProfileBitset=e.ExtTestRunProfileKind=e.TestResultState=void 0;var M;(function(k){k[k.Unset=0]="Unset",k[k.Queued=1]="Queued",k[k.Running=2]="Running",k[k.Passed=3]="Passed",k[k.Failed=4]="Failed",k[k.Skipped=5]="Skipped",k[k.Errored=6]="Errored"})(M||(e.TestResultState=M={}));var A;(function(k){k[k.Run=1]="Run",k[k.Debug=2]="Debug",k[k.Coverage=3]="Coverage"})(A||(e.ExtTestRunProfileKind=A={}));var $;(function(k){k[k.Run=2]="Run",k[k.Debug=4]="Debug",k[k.Coverage=8]="Coverage",k[k.HasNonDefaultProfile=16]="HasNonDefaultProfile",k[k.HasConfigurable=32]="HasConfigurable",k[k.SupportsContinuousRun=64]="SupportsContinuousRun"})($||(e.TestRunProfileBitset=$={})),e.$rJ=[2,4,8,16,32,64];const E=k=>"runId"in k;e.$sJ=E;var f;(function(k){k.serialize=h=>({range:h.range.toJSON(),uri:h.uri.toJSON()}),k.deserialize=h=>({range:F.$zs.lift(h.range),uri:y.URI.revive(h.uri)})})(f||(e.IRichLocation=f={}));var C;(function(k){k[k.Error=0]="Error",k[k.Output=1]="Output"})(C||(e.TestMessageType=C={}));var D;(function(k){k.serialize=h=>({message:h.message,type:0,expected:h.expected,actual:h.actual,contextValue:h.contextValue,location:h.location&&f.serialize(h.location)}),k.deserialize=h=>({message:h.message,type:0,expected:h.expected,actual:h.actual,contextValue:h.contextValue,location:h.location&&f.deserialize(h.location)})})(D||(e.ITestErrorMessage=D={}));const u=(k,h)=>`${h?"s":"e"}${k}`;e.$tJ=u;var b;(function(k){k.serialize=h=>({message:h.message,type:1,offset:h.offset,length:h.length,location:h.location&&f.serialize(h.location)}),k.deserialize=h=>({message:h.message,type:1,offset:h.offset,length:h.length,location:h.location&&f.deserialize(h.location)})})(b||(e.ITestOutputMessage=b={}));var p;(function(k){k.serialize=h=>h.type===0?D.serialize(h):b.serialize(h),k.deserialize=h=>h.type===0?D.deserialize(h):b.deserialize(h)})(p||(e.ITestMessage=p={}));var g;(function(k){k.serializeWithoutMessages=h=>({state:h.state,duration:h.duration,messages:[]}),k.serialize=h=>({state:h.state,duration:h.duration,messages:h.messages.map(p.serialize)}),k.deserialize=h=>({state:h.state,duration:h.duration,messages:h.messages.map(p.deserialize)})})(g||(e.ITestTaskState=g={}));const t="\0",i=(k,h)=>k+t+h;e.$uJ=i;const r=k=>{const h=k.indexOf(t);return{ctrlId:k.slice(0,h),tagId:k.slice(h+1)}};e.$vJ=r;var c;(function(k){k.serialize=h=>({extId:h.extId,label:h.label,tags:h.tags,busy:h.busy,children:void 0,uri:h.uri?.toJSON(),range:h.range?.toJSON()||null,description:h.description,error:h.error,sortText:h.sortText}),k.deserialize=h=>({extId:h.extId,label:h.label,tags:h.tags,busy:h.busy,children:void 0,uri:h.uri?y.URI.revive(h.uri):void 0,range:h.range?F.$zs.lift(h.range):null,description:h.description,error:h.error,sortText:h.sortText})})(c||(e.ITestItem=c={}));var o;(function(k){k[k.NotExpandable=0]="NotExpandable",k[k.Expandable=1]="Expandable",k[k.BusyExpanding=2]="BusyExpanding",k[k.Expanded=3]="Expanded"})(o||(e.TestItemExpandState=o={}));var l;(function(k){k.serialize=h=>({expand:h.expand,item:c.serialize(h.item)}),k.deserialize=h=>({controllerId:P.$qJ.root(h.item.extId),expand:h.expand,item:c.deserialize(h.item)})})(l||(e.InternalTestItem=l={}));var n;(function(k){k.serialize=h=>{let w;return h.item&&(w={},h.item.label!==void 0&&(w.label=h.item.label),h.item.tags!==void 0&&(w.tags=h.item.tags),h.item.busy!==void 0&&(w.busy=h.item.busy),h.item.uri!==void 0&&(w.uri=h.item.uri?.toJSON()),h.item.range!==void 0&&(w.range=h.item.range?.toJSON()),h.item.description!==void 0&&(w.description=h.item.description),h.item.error!==void 0&&(w.error=h.item.error),h.item.sortText!==void 0&&(w.sortText=h.item.sortText)),{extId:h.extId,expand:h.expand,item:w}},k.deserialize=h=>{let w;return h.item&&(w={},h.item.label!==void 0&&(w.label=h.item.label),h.item.tags!==void 0&&(w.tags=h.item.tags),h.item.busy!==void 0&&(w.busy=h.item.busy),h.item.range!==void 0&&(w.range=h.item.range?F.$zs.lift(h.item.range):null),h.item.description!==void 0&&(w.description=h.item.description),h.item.error!==void 0&&(w.error=h.item.error),h.item.sortText!==void 0&&(w.sortText=h.item.sortText)),{extId:h.extId,expand:h.expand,item:w}}})(n||(e.ITestItemUpdate=n={}));const s=(k,h)=>{h.expand!==void 0&&(k.expand=h.expand),h.item!==void 0&&(k.item=k.item?Object.assign(k.item,h.item):h.item)};e.$wJ=s;var a;(function(k){k.serializeWithoutMessages=h=>({...l.serialize(h),ownComputedState:h.ownComputedState,computedState:h.computedState,tasks:h.tasks.map(g.serializeWithoutMessages)}),k.serialize=h=>({...l.serialize(h),ownComputedState:h.ownComputedState,computedState:h.computedState,tasks:h.tasks.map(g.serialize)}),k.deserialize=h=>({...l.deserialize(h),ownComputedState:h.ownComputedState,computedState:h.computedState,tasks:h.tasks.map(g.deserialize),retired:!0})})(a||(e.TestResultItem=a={}));var d;(function(k){k[k.Function=0]="Function",k[k.Statement=1]="Statement"})(d||(e.DetailType=d={}));var v;(function(k){k[k.Add=0]="Add",k[k.Update=1]="Update",k[k.DocumentSynced=2]="DocumentSynced",k[k.Remove=3]="Remove",k[k.IncrementPendingExtHosts=4]="IncrementPendingExtHosts",k[k.Retire=5]="Retire",k[k.AddTag=6]="AddTag",k[k.RemoveTag=7]="RemoveTag"})(v||(e.TestDiffOpType=v={}));var m;(function(k){k.deserialize=h=>h.op===0?{op:h.op,item:l.deserialize(h.item)}:h.op===1?{op:h.op,item:n.deserialize(h.item)}:h.op===2?{op:h.op,uri:y.URI.revive(h.uri),docv:h.docv}:h,k.serialize=h=>h.op===0?{op:h.op,item:l.serialize(h.item)}:h.op===1?{op:h.op,item:n.serialize(h.item)}:h})(m||(e.TestsDiffOp=m={}));class S{constructor(){this.c=new Map,this.d=new Map,this.f=new Set,this.g=0,this.h=0,this.tags=this.c}apply(h){const w=this.o();for(const I of h)switch(I.op){case 0:this.j(l.deserialize(I.item),w);break;case 1:this.k(n.deserialize(I.item),w);break;case 3:this.l(I.itemId,w);break;case 5:this.m(I.itemId);break;case 4:this.updatePendingRoots(I.amount);break;case 6:this.c.set(I.tag.id,I.tag);break;case 7:this.c.delete(I.id);break}w.complete?.()}j(h,w){const I=P.$qJ.parentId(h.item.extId)?.toString();let L;if(!I)L=this.p(h),this.f.add(L),this.d.set(h.item.extId,L);else if(this.d.has(I)){const V=this.d.get(I);V.children.add(h.item.extId),L=this.p(h,V),this.d.set(h.item.extId,L)}else{console.error(`Test with unknown parent ID: ${JSON.stringify(h)}`);return}return w.add?.(L),h.expand===2&&this.g++,L}k(h,w){const I=this.d.get(h.extId);if(I)return h.expand!==void 0&&(I.expand===2&&this.g--,h.expand===2&&this.g++),(0,e.$wJ)(I,h),w.update?.(I),I}l(h,w){const I=this.d.get(h);if(!I)return;const L=P.$qJ.parentId(I.item.extId)?.toString();L?this.d.get(L).children.delete(I.item.extId):this.f.delete(I);const V=[[h]];for(;V.length;)for(const K of V.pop()){const R=this.d.get(K);R&&(V.push(R.children),this.d.delete(K),w.remove?.(R,R!==I),R.expand===2&&this.g--)}}m(h){}updatePendingRoots(h){this.h+=h}o(){return{}}}e.$xJ=S}),define(Pe[77],Re([1,0,14,5,6,53,58,48]),function(be,e,y,F,P,M,A,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tM=e.$sM=e.$rM=e.$qM=e.$pM=e.TestItemEventOp=void 0;var E;(function(r){r[r.Upsert=0]="Upsert",r[r.SetTags=1]="SetTags",r[r.UpdateCanResolveChildren=2]="UpdateCanResolveChildren",r[r.RemoveChild=3]="RemoveChild",r[r.SetProp=4]="SetProp",r[r.Bulk=5]="Bulk",r[r.DocumentSynced=6]="DocumentSynced"})(E||(e.TestItemEventOp=E={}));const f=(r,c)=>r===c,D=Object.entries({range:(r,c)=>r===c?!0:!r||!c?!1:r.equalsRange(c),busy:f,label:f,description:f,error:f,sortText:f,tags:(r,c)=>!(r.length!==c.length||r.some(o=>!c.includes(o)))}),u=(r,c)=>{let o;for(const[l,n]of D)n(r[l],c[l])||(o?o[l]=c[l]:o={[l]:c[l]});return o};class b extends P.$Rc{get root(){return this.s.root}constructor(c){super(),this.s=c,this.f=this.B(new y.$0g(()=>this.flushDiff(),200)),this.g=this.B(new F.$Rd),this.tree=new Map,this.j=new Map,this.m=[],this.onDidGenerateDiff=this.g.event,this.root.canResolveChildren=!0,this.y(this.root,void 0)}set resolveHandler(c){this.h=c;for(const o of this.tree.values())this.I(o)}get resolveHandler(){return this.h}collectDiff(){const c=this.m;return this.m=[],c}pushDiff(c){switch(c.op){case 2:{for(const o of this.m)if(o.op===2&&o.uri===c.uri){o.docv=c.docv;return}break}case 1:{const o=this.m[this.m.length-1];if(o){if(o.op===1&&o.item.extId===c.item.extId){(0,A.$wJ)(o.item,c.item);return}if(o.op===0&&o.item.item.extId===c.item.extId){(0,A.$wJ)(o.item,c.item);return}}break}}this.m.push(c),this.f.isScheduled()||this.f.schedule()}expand(c,o){const l=this.tree.get(c);if(l){if((l.expandLevels===void 0||o>l.expandLevels)&&(l.expandLevels=o),l.expand===1){const n=this.L(l);return n.isOpen()?this.J(l,o-1):n.wait().then(()=>this.J(l,o-1))}else if(l.expand===3)return l.resolveBarrier?.isOpen()===!1?l.resolveBarrier.wait().then(()=>this.J(l,o-1)):this.J(l,o-1)}}dispose(){for(const c of this.tree.values())this.s.getApiFor(c.actual).listener=void 0;this.tree.clear(),this.m=[],super.dispose()}u(c,o){switch(o.op){case 3:this.N($.$qJ.joinToString(c.fullId,o.id));break;case 0:this.y(o.item,c);break;case 5:for(const l of o.ops)this.u(c,l);break;case 1:this.z(o.new,o.old,c.fullId.toString());break;case 2:this.I(c);break;case 4:this.pushDiff({op:1,item:{extId:c.fullId.toString(),item:o.update}});break;case 6:this.w(c.actual.uri);break;default:(0,M.$4c)(o)}}w(c){c&&this.pushDiff({op:2,uri:c,docv:this.s.getDocumentVersion(c)})}y(c,o){const l=$.$qJ.fromExtHostTestItem(c,this.root.id,o?.actual),n=this.s.getApiFor(c);n.parent&&n.parent!==o?.actual&&this.s.getChildren(n.parent).delete(c.id);let s=this.tree.get(l.toString());if(!s){s={fullId:l,actual:c,expandLevels:o?.expandLevels?o.expandLevels-1:void 0,expand:0},c.tags.forEach(this.C,this),this.tree.set(s.fullId.toString(),s),this.F(c,o),this.pushDiff({op:0,item:{controllerId:this.s.controllerId,expand:s.expand,item:this.s.toITestItem(c)}}),this.H(c,s,o);return}if(s.actual===c){this.G(c,s,o);return}if(s.actual.uri?.toString()!==c.uri?.toString())return this.N(l.toString()),this.y(c,o);const a=this.s.getChildren(s.actual),d=s.actual,v=u(this.s.toITestItem(d),this.s.toITestItem(c));this.s.getApiFor(d).listener=void 0,s.actual=c,s.expand=0,v&&(v.hasOwnProperty("tags")&&(this.z(c.tags,d.tags,l.toString()),delete v.tags),this.u(s,{op:4,update:v})),this.H(c,s,o);for(const[m,S]of a)this.s.getChildren(c).get(S.id)||this.N($.$qJ.joinToString(l,S.id));this.w(s.actual.uri)}z(c,o,l){const n=new Set(o.map(s=>s.id));for(const s of c)n.delete(s.id)||this.C(s);this.pushDiff({op:1,item:{extId:l,item:{tags:c.map(s=>(0,A.$uJ)(this.s.controllerId,s.id))}}}),n.forEach(this.D,this)}C(c){const o=this.j.get(c.id);o?o.refCount++:(this.j.set(c.id,{refCount:1}),this.pushDiff({op:6,tag:{id:(0,A.$uJ)(this.s.controllerId,c.id)}}))}D(c){const o=this.j.get(c);o&&!--o.refCount&&(this.j.delete(c),this.pushDiff({op:7,id:(0,A.$uJ)(this.s.controllerId,c)}))}F(c,o){this.s.getApiFor(c).parent=o&&o.actual!==this.root?o.actual:void 0}G(c,o,l){this.F(c,l);const n=this.s.getApiFor(c);n.parent=l?.actual,n.listener=s=>this.u(o,s),this.I(o)}H(c,o,l){this.G(c,o,l);for(const[n,s]of this.s.getChildren(c))this.y(s,o)}I(c){let o;this.h?c.resolveBarrier?o=c.resolveBarrier.isOpen()?3:2:o=c.actual.canResolveChildren?1:0:o=0,o!==c.expand&&(c.expand=o,this.pushDiff({op:1,item:{extId:c.fullId.toString(),expand:o}}),o===1&&c.expandLevels!==void 0&&this.L(c))}J(c,o){if(o<0)return;const l=[];for(const[n,s]of this.s.getChildren(c.actual)){const a=this.expand($.$qJ.joinToString(c.fullId,s.id),o);(0,y.$Kg)(a)&&l.push(a)}if(l.length)return Promise.all(l).then(()=>{})}L(c){if(c.resolveBarrier)return c.resolveBarrier;if(!this.h){const s=new y.$Wg;return s.open(),s}c.expand=2,this.M(c);const o=c.resolveBarrier=new y.$Wg,l=s=>{console.error(`Unhandled error in resolveHandler of test controller "${this.s.controllerId}"`,s)};let n;try{n=this.h(c.actual===this.root?void 0:c.actual)}catch(s){l(s)}return(0,y.$Kg)(n)?n.catch(l).then(()=>{o.open(),this.I(c)}):(o.open(),this.I(c)),c.resolveBarrier}M(c){this.pushDiff({op:1,item:{extId:c.fullId.toString(),expand:c.expand}})}N(c){const o=this.tree.get(c);if(!o)throw new Error("attempting to remove non-existent child");this.pushDiff({op:3,itemId:c});const l=[o];for(;l.length;){const n=l.pop();if(n){this.s.getApiFor(n.actual).listener=void 0;for(const s of n.actual.tags)this.D(s.id);this.tree.delete(n.fullId.toString());for(const[s,a]of this.s.getChildren(n.actual))l.push(this.tree.get($.$qJ.joinToString(n.fullId,a.id)))}}}flushDiff(){const c=this.collectDiff();c.length&&this.g.fire(c)}}e.$pM=b;class p extends Error{constructor(c){super(`Attempted to insert a duplicate test item ID ${c}`)}}e.$qM=p;class g extends Error{constructor(c){super(`TestItem with ID "${c}" is invalid. Make sure to create it from the createTestItem method.`)}}e.$rM=g;class t extends Error{constructor(c,o,l){super(`TestItem with ID "${c}" is from controller "${o}" and cannot be added as a child of an item from controller "${l}".`)}}e.$sM=t;const i=(r,c,o)=>{let l=new Map;return{get size(){return l.size},forEach(n,s){for(const a of l.values())n.call(s,a,this)},[Symbol.iterator](){return l.entries()},replace(n){const s=new Map,a=new Set(l.keys()),d={op:5,ops:[]};for(const v of n){if(!(v instanceof o))throw new g(v.id);const m=c(v).controllerId;if(m!==r.controllerId)throw new t(v.id,m,r.controllerId);if(s.has(v.id))throw new p(v.id);s.set(v.id,v),a.delete(v.id),d.ops.push({op:0,item:v})}for(const v of a.keys())d.ops.push({op:3,id:v});r.listener?.(d),l=s},add(n){if(!(n instanceof o))throw new g(n.id);l.set(n.id,n),r.listener?.({op:0,item:n})},delete(n){l.delete(n)&&r.listener?.({op:3,id:n})},get(n){return l.get(n)},toJSON(){return Array.from(l.values())}}};e.$tM=i}),define(Pe[104],Re([1,0,77]),function(be,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vM=e.$uM=void 0;const F=new WeakMap,P=(A,$)=>{const E={controllerId:$};return F.set(A,E),E};e.$uM=P;const M=A=>{const $=F.get(A);if(!$)throw new y.$rM(A?.id||"<unknown>");return $};e.$vM=M}),define(Pe[78],Re([1,0,13,2]),function(be,e,y,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_tb=e.$$tb=e.$0tb=e.$9tb=e.$8tb=void 0,e.$8tb="vscode-cdn.net",e.$9tb=`vscode-resource.${e.$8tb}`,e.$0tb=`'self' https://*.${e.$8tb}`;function P($,E){return $.scheme===y.Schemas.http||$.scheme===y.Schemas.https?$:(E&&E.authority&&E.isRemote&&$.scheme===y.Schemas.file&&($=F.URI.from({scheme:y.Schemas.vscodeRemote,authority:E.authority,path:$.path})),F.URI.from({scheme:y.Schemas.https,authority:`${$.scheme}+${M($.authority)}.${e.$9tb}`,path:$.path,fragment:$.fragment,query:$.query}))}e.$$tb=P;function M($){return $.replace(/./g,E=>{const f=E.charCodeAt(0);return f>=97&&f<=122||f>=65&&f<=90||f>=48&&f<=57?E:"-"+f.toString(16).padStart(4,"0")})}function A($){return $.replace(/-([0-9a-f]{4})/g,(E,f)=>String.fromCharCode(parseInt(f,16)))}e.$_tb=A}),define(Pe[213],Re([1,0,5,6,78]),function(be,e,y,F,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xdc=void 0;class M{constructor($,E,f){this.d=$,this.e=E,this.f=f,this.a=0,this.b=new F.$Qc,this.c=new Map,this.b.add(E.onDidChangeVisibleTextEditors(()=>{const C=E.getVisibleTextEditors();for(const D of this.c.values())C.indexOf(D.editor)<0&&D.inset.dispose()}))}dispose(){this.c.forEach($=>$.inset.dispose()),this.b.dispose()}createWebviewEditorInset($,E,f,C,D){let u;for(const c of this.e.getVisibleTextEditors(!0))if(c.value===$){u=c;break}if(!u)throw new Error("not a visible editor");const b=this,p=this.a++,g=new y.$Rd,t=new y.$Rd,i=new class{constructor(){this.a="",this.b=Object.create(null)}asWebviewUri(c){return(0,P.$$tb)(c,b.f)}get cspSource(){return P.$0tb}set options(c){this.b=c,b.d.$setOptions(p,c)}get options(){return this.b}set html(c){this.a=c,b.d.$setHtml(p,c)}get html(){return this.a}get onDidReceiveMessage(){return g.event}postMessage(c){return b.d.$postMessage(p,c)}},r=new class{constructor(){this.editor=$,this.line=E,this.height=f,this.webview=i,this.onDidDispose=t.event}dispose(){b.c.has(p)&&(b.c.delete(p),b.d.$disposeEditorInset(p),t.fire(),t.dispose(),g.dispose())}};return this.d.$createEditorInset(p,u.id,u.value.document.uri,E+1,f,C||{},D.identifier,D.extensionLocation),this.c.set(p,{editor:$,inset:r,onDidReceiveMessage:g}),r}$onDidDispose($){const E=this.c.get($);E&&E.inset.dispose()}$onDidReceiveMessage($,E){this.c.get($)?.onDidReceiveMessage.fire(E)}}e.$Xdc=M}),define(Pe[214],Re([1,0,4]),function(be,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mN=e.VariableKind=e.$lN=void 0,e.$lN=(0,y.$Vh)("configurationResolverService");var F;(function(M){M.Unknown="unknown",M.Env="env",M.Config="config",M.Command="command",M.Input="input",M.ExtensionInstallFolder="extensionInstallFolder",M.WorkspaceFolder="workspaceFolder",M.Cwd="cwd",M.WorkspaceFolderBasename="workspaceFolderBasename",M.UserHome="userHome",M.LineNumber="lineNumber",M.SelectedText="selectedText",M.File="file",M.FileWorkspaceFolder="fileWorkspaceFolder",M.FileWorkspaceFolderBasename="fileWorkspaceFolderBasename",M.RelativeFile="relativeFile",M.RelativeFileDirname="relativeFileDirname",M.FileDirname="fileDirname",M.FileExtname="fileExtname",M.FileBasename="fileBasename",M.FileBasenameNoExtension="fileBasenameNoExtension",M.FileDirnameBasename="fileDirnameBasename",M.ExecPath="execPath",M.ExecInstallFolder="execInstallFolder",M.PathSeparator="pathSeparator"})(F||(e.VariableKind=F={}));class P extends Error{constructor(A,$){super($),this.variable=A}}e.$mN=P}),define(Pe[215],Re([1,0,19,74,16,26,21,94,177,214,12]),function(be,e,y,F,P,M,A,$,E,f,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$AN=void 0;class D{static{this.VARIABLE_LHS="${"}static{this.VARIABLE_REGEXP=/\$\{(.*?)\}/g}constructor(b,p,g,t){this.h=new Map,this.a=b,this.b=p,this.g=g,t&&(this.c=t.then(i=>this.i(i)))}i(b){if(A.$i){const p=Object.create(null);return Object.keys(b).forEach(g=>{p[g.toLowerCase()]=b[g]}),p}return b}resolveWithEnvironment(b,p,g){return this.l({env:this.i(b),userHome:void 0},p?p.uri:void 0,g)}async resolveAsync(b,p){const g={env:await this.c,userHome:await this.g};return this.l(g,b?b.uri:void 0,p)}async j(b,p,g,t){const i=M.$an(p);A.$i&&i.windows?Object.keys(i.windows).forEach(c=>i[c]=i.windows[c]):A.$j&&i.osx?Object.keys(i.osx).forEach(c=>i[c]=i.osx[c]):A.$k&&i.linux&&Object.keys(i.linux).forEach(c=>i[c]=i.linux[c]),delete i.windows,delete i.osx,delete i.linux;const r={env:await this.c,userHome:await this.g};return this.l(r,b?b.uri:void 0,i,g,t)}async resolveAnyAsync(b,p,g){return this.j(b,p,g)}async resolveAnyMap(b,p,g){const t=new Map;return{newConfig:await this.j(b,p,g,t),resolvedVariables:t}}resolveWithInteractionReplace(b,p,g,t){throw new Error("resolveWithInteractionReplace not implemented.")}resolveWithInteraction(b,p,g,t){throw new Error("resolveWithInteraction not implemented.")}contributeVariable(b,p){if(this.h.has(b))throw new Error("Variable "+b+" is contributed twice.");this.h.set(b,p)}async l(b,p,g,t,i){if(P.$Cf(g))return this.m(b,p,g,t,i);if(Array.isArray(g))return Promise.all(g.map(r=>this.l(b,p,r,t,i)));if(P.$Ef(g)){const r=Object.create(null),c=await Promise.all(Object.keys(g).map(async o=>[await this.m(b,p,o,t,i),await this.l(b,p,g[o],t,i)]));for(const[o,l]of c)r[o]=l;return r}return g}m(b,p,g,t,i){return(0,C.$Xe)(g,D.VARIABLE_REGEXP,async(r,c)=>{if(c.includes(D.VARIABLE_LHS))return r;let o=await this.o(b,r,c,p,t);return i?.set(c,o),o!==r&&P.$Cf(o)&&o.match(D.VARIABLE_REGEXP)&&(o=await this.m(b,p,o,t,i)),o})}n(b){return this.b?this.b.getUriLabel(b,{noPrefix:!0}):b.fsPath}async o(b,p,g,t,i){let r;const c=g.split(":");c.length>1&&(g=c[0],r=c[1]);const o=s=>{const a=this.a.getFilePath();if(a)return(0,$.$yv)(a);throw new f.$mN(s,(0,E.localize)(0,null,p))},l=s=>{const a=o(s);if(this.a.getWorkspaceFolderPathForFile){const d=this.a.getWorkspaceFolderPathForFile();if(d)return(0,$.$yv)(d)}throw new f.$mN(s,(0,E.localize)(1,null,p,y.$mc(a)))},n=s=>{if(r){const a=this.a.getFolderUri(r);if(a)return a;throw new f.$mN(s,(0,E.localize)(2,null,p,r))}if(t)return t;throw this.a.getWorkspaceFolderCount()>1?new f.$mN(s,(0,E.localize)(3,null,p)):new f.$mN(s,(0,E.localize)(4,null,p))};switch(g){case"env":if(r){if(b.env){const s=b.env[A.$i?r.toLowerCase():r];if(P.$Cf(s))return s}return""}throw new f.$mN(f.VariableKind.Env,(0,E.localize)(5,null,p));case"config":if(r){const s=this.a.getConfigurationValue(t,r);if(P.$Lf(s))throw new f.$mN(f.VariableKind.Config,(0,E.localize)(6,null,p,r));if(P.$Ef(s))throw new f.$mN(f.VariableKind.Config,(0,E.localize)(7,null,p,r));return s}throw new f.$mN(f.VariableKind.Config,(0,E.localize)(8,null,p));case"command":return this.p(f.VariableKind.Command,p,r,i,"command");case"input":return this.p(f.VariableKind.Input,p,r,i,"input");case"extensionInstallFolder":if(r){const s=await this.a.getExtension(r);if(!s)throw new f.$mN(f.VariableKind.ExtensionInstallFolder,(0,E.localize)(9,null,p,r));return this.n(s.extensionLocation)}throw new f.$mN(f.VariableKind.ExtensionInstallFolder,(0,E.localize)(10,null,p));default:switch(g){case"workspaceRoot":case"workspaceFolder":return(0,$.$yv)(this.n(n(f.VariableKind.WorkspaceFolder)));case"cwd":return t||r?(0,$.$yv)(this.n(n(f.VariableKind.Cwd))):F.cwd();case"workspaceRootFolderName":case"workspaceFolderBasename":return(0,$.$yv)(y.$mc(this.n(n(f.VariableKind.WorkspaceFolderBasename))));case"userHome":{if(b.userHome)return b.userHome;throw new f.$mN(f.VariableKind.UserHome,(0,E.localize)(11,null,p))}case"lineNumber":{const s=this.a.getLineNumber();if(s)return s;throw new f.$mN(f.VariableKind.LineNumber,(0,E.localize)(12,null,p))}case"selectedText":{const s=this.a.getSelectedText();if(s)return s;throw new f.$mN(f.VariableKind.SelectedText,(0,E.localize)(13,null,p))}case"file":return o(f.VariableKind.File);case"fileWorkspaceFolder":return l(f.VariableKind.FileWorkspaceFolder);case"fileWorkspaceFolderBasename":return y.$mc(l(f.VariableKind.FileWorkspaceFolderBasename));case"relativeFile":return t||r?y.$kc(this.n(n(f.VariableKind.RelativeFile)),o(f.VariableKind.RelativeFile)):o(f.VariableKind.RelativeFile);case"relativeFileDirname":{const s=y.$lc(o(f.VariableKind.RelativeFileDirname));if(t||r){const a=y.$kc(this.n(n(f.VariableKind.RelativeFileDirname)),s);return a.length===0?".":a}return s}case"fileDirname":return y.$lc(o(f.VariableKind.FileDirname));case"fileExtname":return y.$nc(o(f.VariableKind.FileExtname));case"fileBasename":return y.$mc(o(f.VariableKind.FileBasename));case"fileBasenameNoExtension":{const s=y.$mc(o(f.VariableKind.FileBasenameNoExtension));return s.slice(0,s.length-y.$nc(s).length)}case"fileDirnameBasename":return y.$mc(y.$lc(o(f.VariableKind.FileDirnameBasename)));case"execPath":{const s=this.a.getExecPath();return s||p}case"execInstallFolder":{const s=this.a.getAppRoot();return s||p}case"pathSeparator":return y.sep;default:try{const s=r?`${g}:${r}`:g;return this.p(f.VariableKind.Unknown,p,s,i,void 0)}catch{return p}}}}p(b,p,g,t,i){if(g&&t){const r=i===void 0?t[g]:t[i+":"+g];if(typeof r=="string")return r;throw new f.$mN(b,(0,E.localize)(14,null,p))}return p}}e.$AN=D}),define(Pe[105],Re([1,0,4,102]),function(be,e,y,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$IC=e.$HC=e.OpenEditorContext=e.GroupsOrder=e.$GC=e.MergeGroupMode=e.GroupsArrangement=e.GroupLocation=e.GroupOrientation=e.GroupDirection=e.$FC=void 0,e.$FC=(0,y.$Vh)("editorGroupsService");var P;(function(p){p[p.UP=0]="UP",p[p.DOWN=1]="DOWN",p[p.LEFT=2]="LEFT",p[p.RIGHT=3]="RIGHT"})(P||(e.GroupDirection=P={}));var M;(function(p){p[p.HORIZONTAL=0]="HORIZONTAL",p[p.VERTICAL=1]="VERTICAL"})(M||(e.GroupOrientation=M={}));var A;(function(p){p[p.FIRST=0]="FIRST",p[p.LAST=1]="LAST",p[p.NEXT=2]="NEXT",p[p.PREVIOUS=3]="PREVIOUS"})(A||(e.GroupLocation=A={}));var $;(function(p){p[p.MAXIMIZE=0]="MAXIMIZE",p[p.EXPAND=1]="EXPAND",p[p.EVEN=2]="EVEN"})($||(e.GroupsArrangement=$={}));var E;(function(p){p[p.COPY_EDITORS=0]="COPY_EDITORS",p[p.MOVE_EDITORS=1]="MOVE_EDITORS"})(E||(e.MergeGroupMode=E={}));function f(p){const g=p;return(0,F.$oE)(g?.editor)&&(0,F.$oE)(g?.replacement)}e.$GC=f;var C;(function(p){p[p.CREATION_TIME=0]="CREATION_TIME",p[p.MOST_RECENTLY_ACTIVE=1]="MOST_RECENTLY_ACTIVE",p[p.GRID_APPEARANCE=2]="GRID_APPEARANCE"})(C||(e.GroupsOrder=C={}));var D;(function(p){p[p.NEW_EDITOR=1]="NEW_EDITOR",p[p.MOVE_EDITOR=2]="MOVE_EDITOR",p[p.COPY_EDITOR=3]="COPY_EDITOR"})(D||(e.OpenEditorContext=D={}));function u(p){const g=p;return!!g&&typeof g.id=="number"&&Array.isArray(g.editors)}e.$HC=u;function b(p){return p.getValue("workbench.editor.openSideBySideDirection")==="down"?1:3}e.$IC=b}),define(Pe[216],Re([1,0,4,105]),function(be,e,y,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$MC=e.$LC=e.$KC=e.$JC=void 0,e.$JC=(0,y.$Vh)("editorService"),e.$KC=-1,e.$LC=-2;function P(M){const A=M;return typeof M=="number"||(0,F.$HC)(A)}e.$MC=P}),define(Pe[217],Re([1,0,4,184]),function(be,e,y,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$UJ=void 0,e.$UJ=(0,y.$Wh)(F.$3h)}),define(Pe[106],Re([1,0,22,5,19,6]),function(be,e,y,F,P,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$W5b=e.$V5b=e.$U5b=e.$T5b=e.$S5b=void 0;class A{constructor(i,r){this.versionId=i,this.removedDueToLooping=r}}e.$S5b=A;class ${static isHostExtension(i,r,c){if(r.getExtensionDescription(i))return!1;const o=c.getExtensionDescription(i);return o?!!((o.main||o.browser)&&o.api==="none"):!1}constructor(i,r){this.j=i,this.c=new F.$Rd,this.onDidChange=this.c.event,this.d=0,this.e=r,this.k()}k(){this.e.sort(p),this.f=new y.$bm,this.g=[],this.h=new Map;for(const i of this.e){if(this.f.has(i.identifier)){console.error("Extension `"+i.identifier.value+"` is already registered");continue}this.f.set(i.identifier,i),this.g.push(i);const r=this.j.readActivationEvents(i);for(const c of r)this.h.has(c)||this.h.set(c,[]),this.h.get(c).push(i)}}set(i){return this.e=i,this.k(),this.d++,this.c.fire(void 0),{versionId:this.d}}deltaExtensions(i,r){this.e=g(this.e,r),this.e=this.e.concat(i);const c=$.l(this.e);return this.e=g(this.e,c.map(o=>o.identifier)),this.k(),this.d++,this.c.fire(void 0),new A(this.d,c)}static l(i){const r=new class{constructor(){this.c=new Map,this.d=new Set,this.e=[]}addNode(s){this.d.has(s)||(this.d.add(s),this.e.push(s))}addArc(s,a){this.addNode(s),this.addNode(a),this.c.has(s)?this.c.get(s).push(a):this.c.set(s,[a])}getArcs(s){return this.c.has(s)?this.c.get(s):[]}hasOnlyGoodArcs(s,a){const d=r.getArcs(s);for(let v=0;v<d.length;v++)if(!a.has(d[v]))return!1;return!0}getNodes(){return this.e}},c=new y.$bm;for(const s of i)if(c.set(s.identifier,s),s.extensionDependencies)for(const a of s.extensionDependencies)r.addArc(y.$_l.toKey(s.identifier),y.$_l.toKey(a));const o=new Set;r.getNodes().filter(s=>r.getArcs(s).length===0).forEach(s=>o.add(s));const l=r.getNodes().filter(s=>!o.has(s));let n;do{n=!1;for(let s=0;s<l.length;s++){const a=l[s];r.hasOnlyGoodArcs(a,o)&&(l.splice(s,1),s--,o.add(a),n=!0)}}while(n);return l.map(s=>c.get(s))}containsActivationEvent(i){return this.h.has(i)}containsExtension(i){return this.f.has(i)}getExtensionDescriptionsForActivationEvent(i){const r=this.h.get(i);return r?r.slice(0):[]}getAllExtensionDescriptions(){return this.g.slice(0)}getSnapshot(){return new E(this.d,this.getAllExtensionDescriptions())}getExtensionDescription(i){const r=this.f.get(i);return r||void 0}getExtensionDescriptionByUUID(i){for(const r of this.g)if(r.uuid===i)return r}getExtensionDescriptionByIdOrUUID(i,r){return this.getExtensionDescription(i)??(r?this.getExtensionDescriptionByUUID(r):void 0)}}e.$T5b=$;class E{constructor(i,r){this.versionId=i,this.extensions=r}}e.$U5b=E;class f{constructor(i){this.d=new u,this.c=new $(i,[])}async acquireLock(i){const r=await this.d.acquire(i);return new C(this,r)}deltaExtensions(i,r,c){if(!i.isAcquiredFor(this))throw new Error("Lock is not held");return this.c.deltaExtensions(r,c)}containsActivationEvent(i){return this.c.containsActivationEvent(i)}containsExtension(i){return this.c.containsExtension(i)}getExtensionDescriptionsForActivationEvent(i){return this.c.getExtensionDescriptionsForActivationEvent(i)}getAllExtensionDescriptions(){return this.c.getAllExtensionDescriptions()}getSnapshot(){return this.c.getSnapshot()}getExtensionDescription(i){return this.c.getExtensionDescription(i)}getExtensionDescriptionByUUID(i){return this.c.getExtensionDescriptionByUUID(i)}getExtensionDescriptionByIdOrUUID(i,r){return this.c.getExtensionDescriptionByIdOrUUID(i,r)}}e.$V5b=f;class C extends M.$Rc{constructor(i,r){super(),this.f=i,this.c=!1,this.B(r)}isAcquiredFor(i){return!this.c&&this.f===i}}e.$W5b=C;class D{constructor(i){this.name=i,this.promise=new Promise((r,c)=>{this.c=r})}resolve(i){this.c(i)}}class u{constructor(){this.c=[],this.d=!1}async acquire(i){const r=new D(i);return this.c.push(r),this.e(),r.promise}e(){if(this.d||this.c.length===0)return;const i=this.c.shift();this.d=!0;let r=!0;const c=setTimeout(()=>{r&&console.warn(`The customer named ${i.name} has been holding on to the lock for 30s. This might be a problem.`)},30*1e3),o=()=>{r&&(clearTimeout(c),r=!1,this.d=!1,this.e())};i.resolve((0,M.$Pc)(o))}}var b;(function(t){t[t.Builtin=0]="Builtin",t[t.User=1]="User",t[t.Dev=2]="Dev"})(b||(b={}));function p(t,i){const r=t.isBuiltin?0:t.isUnderDevelopment?2:1,c=i.isBuiltin?0:i.isUnderDevelopment?2:1;if(r!==c)return r-c;const o=P.$fc.basename(t.extensionLocation.path),l=P.$fc.basename(i.extensionLocation.path);return o<l?-1:o>l?1:0}function g(t,i){const r=new y.$am(i);return t.filter(c=>!r.has(c.identifier))}}),define(Pe[79],Re([1,0,24]),function(be,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeLogMarkers=e.$im=e.$hm=e.MessageType=e.ExtensionHostExitCode=e.UIKind=void 0;var F;(function(f){f[f.Desktop=1]="Desktop",f[f.Web=2]="Web"})(F||(e.UIKind=F={}));var P;(function(f){f[f.VersionMismatch=55]="VersionMismatch",f[f.UnexpectedError=81]="UnexpectedError"})(P||(e.ExtensionHostExitCode=P={}));var M;(function(f){f[f.Initialized=0]="Initialized",f[f.Ready=1]="Ready",f[f.Terminate=2]="Terminate"})(M||(e.MessageType=M={}));function A(f){const C=y.$fe.alloc(1);switch(f){case 0:C.writeUInt8(1,0);break;case 1:C.writeUInt8(2,0);break;case 2:C.writeUInt8(3,0);break}return C}e.$hm=A;function $(f,C){if(f.byteLength!==1)return!1;switch(f.readUInt8(0)){case 1:return C===0;case 2:return C===1;case 3:return C===2;default:return!1}}e.$im=$;var E;(function(f){f.Start="START_NATIVE_LOG",f.End="END_NATIVE_LOG"})(E||(e.NativeLogMarkers=E={}))}),define(Pe[59],Re([1,0,4,5,15,27,79,55,56,26,2,6,165]),function(be,e,y,F,P,M,A,$,E,f,C,D,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$TM=e.$SM=e.$RM=e.$QM=void 0;let b=class extends D.$Rc{constructor(i,r){super(),this.s=i,this.t=r,this.a=this.B(new F.$Rd),this.onDidChangeTelemetryEnabled=this.a.event,this.b=this.B(new F.$Rd),this.onDidChangeTelemetryConfiguration=this.b.event,this.c={usage:!0,error:!0},this.f=0,this.g=!1,this.j=!1,this.r=new Map,this.m=C.URI.revive(this.s.environment.extensionTelemetryLogResource),this.j=this.s.environment.isExtensionTelemetryLoggingOnly,this.n=r.createLogger(this.m,{id:E.$uo,name:(0,u.localize)(0,null,this.j?" (Not Sent)":""),hidden:!0}),this.B(r.onDidChangeLogLevel(c=>{(0,P.$fj)(c)&&this.u()})),this.n.info("Below are logs for extension telemetry events sent to the telemetry output channel API once the log level is set to trace."),this.n.info("===========================================================")}u(){this.t.setVisibility(this.m,this.g&&this.t.getLogLevel()===P.LogLevel.Trace)}getTelemetryConfiguration(){return this.f===3}getTelemetryDetails(){return{isCrashEnabled:this.f>=1,isErrorsEnabled:this.c.error?this.f>=2:!1,isUsageEnabled:this.c.usage?this.f>=3:!1}}instantiateLogger(i,r,c){const o=this.getTelemetryDetails(),l=new p(r,c,i,this.n,this.j,this.getBuiltInCommonProperties(i),{isUsageEnabled:o.isUsageEnabled,isErrorsEnabled:o.isErrorsEnabled}),n=this.r.get(i.identifier.value)??[];return this.r.set(i.identifier.value,[...n,l]),l.apiTelemetryLogger}$initializeTelemetryLevel(i,r,c){this.f=i,this.g=r,this.c=c??{usage:!0,error:!0},this.u()}getBuiltInCommonProperties(i){const r=Object.create(null);switch(r["common.extname"]=`${i.publisher}.${i.name}`,r["common.extversion"]=i.version,r["common.vscodemachineid"]=this.s.telemetryInfo.machineId,r["common.vscodesessionid"]=this.s.telemetryInfo.sessionId,r["common.vscodeversion"]=this.s.version,r["common.isnewappinstall"]=g(this.s.telemetryInfo.firstSessionDate),r["common.product"]=this.s.environment.appHost,this.s.uiKind){case A.UIKind.Web:r["common.uikind"]="web";break;case A.UIKind.Desktop:r["common.uikind"]="desktop";break;default:r["common.uikind"]="unknown"}return r["common.remotename"]=(0,$.$2k)((0,E.$Bo)(this.s.remote.authority)),r}$onDidChangeTelemetryLevel(i){this.h=this.getTelemetryConfiguration(),this.f=i;const r=this.getTelemetryDetails();this.r.forEach((c,o)=>{const l=c.filter(n=>!n.isDisposed);l.length===0?this.r.delete(o):this.r.set(o,l)}),this.r.forEach(c=>{for(const o of c)o.updateTelemetryEnablements(r.isUsageEnabled,r.isErrorsEnabled)}),this.h!==this.getTelemetryConfiguration()&&this.a.fire(this.getTelemetryConfiguration()),this.b.fire(this.getTelemetryDetails()),this.u()}onExtensionError(i,r){const o=this.r.get(i.value)?.filter(n=>!n.isDisposed);if(!o)return this.r.delete(i.value),!1;let l=!1;for(const n of o)n.ignoreUnhandledExtHostErrors||(n.logError(r),l=!0);return l}};e.$QM=b,e.$QM=b=Ke([Ve(0,M.$PM),Ve(1,P.$ej)],b);class p{static validateSender(i){if(typeof i!="object")throw new TypeError("TelemetrySender argument is invalid");if(typeof i.sendEventData!="function")throw new TypeError("TelemetrySender.sendEventData must be a function");if(typeof i.sendErrorData!="function")throw new TypeError("TelemetrySender.sendErrorData must be a function");if(typeof i.flush<"u"&&typeof i.flush!="function")throw new TypeError("TelemetrySender.flush must be a function or undefined")}constructor(i,r,c,o,l,n,s){this.g=c,this.h=o,this.i=l,this.j=n,this.a=new F.$Rd,this.ignoreUnhandledExtHostErrors=r?.ignoreUnhandledErrors??!1,this.b=r?.ignoreBuiltInCommonProperties??!1,this.c=r?.additionalCommonProperties,this.f=i,this.d={isUsageEnabled:s.isUsageEnabled,isErrorsEnabled:s.isErrorsEnabled}}updateTelemetryEnablements(i,r){this.e&&(this.d={isUsageEnabled:i,isErrorsEnabled:r},this.a.fire(this.e))}mixInCommonPropsAndCleanData(i){let r="properties"in i?i.properties??{}:i;return r=(0,E.$Eo)(r,[]),this.c&&(r=(0,f.$dn)(r,this.c)),this.b||(r=(0,f.$dn)(r,this.j)),"properties"in i?i.properties=r:i=r,i}k(i,r){this.f&&(this.g.publisher==="vscode"?i=this.g.name+"/"+i:i=this.g.identifier.value+"/"+i,r=this.mixInCommonPropsAndCleanData(r||{}),this.i||this.f?.sendEventData(i,r),this.h.trace(i,r))}logUsage(i,r){this.d.isUsageEnabled&&this.k(i,r)}logError(i,r){if(!(!this.d.isErrorsEnabled||!this.f))if(typeof i=="string")this.k(i,r);else{const c={name:i.name,message:i.message,stack:i.stack,cause:i.cause},o=(0,E.$Eo)(c,[]),l=new Error(o.message,{cause:o.cause});l.stack=o.stack,l.name=o.name,r=this.mixInCommonPropsAndCleanData(r||{}),this.i||this.f.sendErrorData(l,r),this.h.trace("exception",r)}}get apiTelemetryLogger(){if(!this.e){const i=this,r={logUsage:i.logUsage.bind(i),get isUsageEnabled(){return i.d.isUsageEnabled},get isErrorsEnabled(){return i.d.isErrorsEnabled},logError:i.logError.bind(i),dispose:i.dispose.bind(i),onDidChangeEnableStates:i.a.event.bind(i)};this.e=Object.freeze(r)}return this.e}get isDisposed(){return!this.f}dispose(){if(this.f?.flush){let i=this.f;this.f=void 0,Promise.resolve(i.flush()).then(i=void 0),this.e=void 0}else this.f=void 0}}e.$RM=p;function g(t){const i=Date.now()-new Date(t).getTime();return isNaN(i)?!1:i<1e3*60*60*24}e.$SM=g,e.$TM=(0,y.$Vh)("IExtHostTelemetry")}),define(Pe[23],Re([1,0,5,2,193,101,22,4]),function(be,e,y,F,P,M,A,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$RF=e.$QF=e.$PF=e.ActivationKind=e.$OF=e.$NF=e.$MF=e.$LF=e.$KF=e.ExtensionHostStartup=e.$JF=e.$IF=e.$HF=e.$GF=void 0,e.$GF=Object.freeze({identifier:new A.$_l("nullExtensionDescription"),name:"Null Extension Description",version:"0.0.0",publisher:"vscode",engines:{vscode:""},extensionLocation:F.URI.parse("void:location"),isBuiltin:!1,targetPlatform:"undefined",isUserBuiltin:!1,isUnderDevelopment:!1}),e.$HF="extensions.webWorker",e.$IF=(0,$.$Vh)("extensionService");class E{constructor(l){this.dependency=l}}e.$JF=E;var f;(function(o){o[o.EagerAutoStart=1]="EagerAutoStart",o[o.EagerManualStart=2]="EagerManualStart",o[o.Lazy=3]="Lazy"})(f||(e.ExtensionHostStartup=f={}));class C{get versionId(){return this.c}get allExtensions(){return this.d}get myExtensions(){return this.e}constructor(l,n,s){this.c=l,this.d=n.slice(0),this.e=s.slice(0),this.f=null}toSnapshot(){return{versionId:this.c,allExtensions:this.d,myExtensions:this.e,activationEvents:M.$xF.createActivationEventsMap(this.d)}}set(l,n,s){if(this.c>l)throw new Error(`ExtensionHostExtensions: invalid versionId ${l} (current: ${this.c})`);const a=[],d=[],v=[],m=[],S=D(this.d),k=D(n),h=(K,R)=>K.extensionLocation.toString()===R.extensionLocation.toString()||K.isBuiltin===R.isBuiltin||K.isUserBuiltin===R.isUserBuiltin||K.isUnderDevelopment===R.isUnderDevelopment;for(const K of this.d){const R=k.get(K.identifier);if(!R){a.push(K.identifier),S.delete(K.identifier);continue}if(!h(K,R)){a.push(K.identifier),S.delete(K.identifier);continue}}for(const K of n){const R=S.get(K.identifier);if(!R){d.push(K);continue}if(!h(R,K)){a.push(R.identifier),S.delete(R.identifier);continue}}const w=new A.$am(this.e),I=new A.$am(s);for(const K of this.e)I.has(K)||v.push(K);for(const K of s)w.has(K)||m.push(K);const L=M.$xF.createActivationEventsMap(d),V={versionId:l,toRemove:a,toAdd:d,addActivationEvents:L,myToRemove:v,myToAdd:m};return this.delta(V),V}delta(l){if(this.c>=l.versionId)return null;const{toRemove:n,toAdd:s,myToRemove:a,myToAdd:d}=l,v=new A.$am(n),m=new A.$am(a);for(let S=0;S<this.d.length;S++)v.has(this.d[S].identifier)&&(this.d.splice(S,1),S--);for(let S=0;S<this.e.length;S++)m.has(this.e[S])&&(this.e.splice(S,1),S--);for(const S of s)this.d.push(S);for(const S of d)this.e.push(S);return this.f=null,l}containsExtension(l){for(const n of this.e)if(A.$_l.equals(n,l))return!0;return!1}containsActivationEvent(l){return this.f||(this.f=this.g()),this.f.has(l)}g(){const l=new Set;for(const n of this.d){if(!this.containsExtension(n.identifier))continue;const s=M.$xF.readActivationEvents(n);for(const a of s)l.add(a)}return l}}e.$KF=C;function D(o){const l=new A.$bm;for(const n of o)l.set(n.identifier,n);return l}function u(o,l){return o.enabledApiProposals?o.enabledApiProposals.includes(l):!1}e.$LF=u;function b(o,l){if(!u(o,l))throw new Error(`Extension '${o.identifier.value}' CANNOT use API proposal: ${l}.
Its package.json#enabledApiProposals-property declares: ${o.enabledApiProposals?.join(", ")??"[]"} but NOT ${l}.
 The missing proposal MUST be added and you must start in extension development mode or use the following command line switch: --enable-proposed-api ${o.identifier.value}`)}e.$MF=b;class p{constructor(l,n,s,a){this.codeLoadingTime=l,this.activateCallTime=n,this.activateResolvedTime=s,this.activationReason=a}}e.$NF=p;class g{constructor(l,n){this.description=l,this.value=n}}e.$OF=g;var t;(function(o){o[o.Normal=0]="Normal",o[o.Immediate=1]="Immediate"})(t||(e.ActivationKind=t={}));function i(o){return{type:o.isBuiltin?0:1,isBuiltin:o.isBuiltin||o.isUserBuiltin,identifier:{id:(0,P.$Ko)(o.publisher,o.name),uuid:o.uuid},manifest:o,location:o.extensionLocation,targetPlatform:o.targetPlatform,validations:[],isValid:!0}}e.$PF=i;function r(o,l){return{identifier:new A.$_l((0,P.$Io)(o.manifest.publisher,o.manifest.name)),isBuiltin:o.type===0,isUserBuiltin:o.type===1&&o.isBuiltin,isUnderDevelopment:!!l,extensionLocation:o.location,...o.manifest,uuid:o.identifier.uuid,targetPlatform:o.targetPlatform}}e.$QF=r;class c{constructor(){this.onDidRegisterExtensions=y.Event.None,this.onDidChangeExtensionsStatus=y.Event.None,this.onDidChangeExtensions=y.Event.None,this.onWillActivateByEvent=y.Event.None,this.onDidChangeResponsiveChange=y.Event.None,this.onWillStop=y.Event.None,this.extensions=[]}activateByEvent(l){return Promise.resolve(void 0)}activateById(l,n){return Promise.resolve(void 0)}activationEventIsDone(l){return!1}whenInstalledExtensionsRegistered(){return Promise.resolve(!0)}getExtension(){return Promise.resolve(void 0)}readExtensionPointContributions(l){return Promise.resolve(Object.create(null))}getExtensionsStatus(){return Object.create(null)}getInspectPorts(l,n){return Promise.resolve([])}stopExtensionHosts(){}async startExtensionHosts(){}async setRemoteEnvironment(l){}canAddExtension(){return!1}canRemoveExtension(){return!1}}e.$RF=c}),define(Pe[218],Re([1,0,11,106,22,23,15,14]),function(be,e,y,F,P,M,A,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mec=e.$lec=e.$kec=e.$jec=e.$iec=e.$hec=void 0;class E{static{this.NONE=new E(!1,-1,-1,-1)}constructor(i,r,c,o){this.startup=i,this.codeLoadingTime=r,this.activateCallTime=c,this.activateResolvedTime=o}}e.$hec=E;class f{constructor(i){this.a=i,this.b=-1,this.c=-1,this.d=-1,this.f=-1,this.g=-1,this.h=-1}j(i,r){return i===-1||r===-1?-1:r-i}build(){return new E(this.a,this.j(this.b,this.c),this.j(this.d,this.f),this.j(this.g,this.h))}codeLoadingStart(){this.b=Date.now()}codeLoadingStop(){this.c=Date.now()}activateCallStart(){this.d=Date.now()}activateCallStop(){this.f=Date.now()}activateResolveStart(){this.g=Date.now()}activateResolveStop(){this.h=Date.now()}}e.$iec=f;class C{constructor(i,r,c,o,l,n){this.activationFailed=i,this.activationFailedError=r,this.activationTimes=c,this.module=o,this.exports=l,this.subscriptions=n}}e.$jec=C;class D extends C{constructor(i){super(!1,null,i,{activate:void 0,deactivate:void 0},void 0,[])}}e.$kec=D;class u extends C{constructor(){super(!1,null,E.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.$lec=u;class b extends C{constructor(i){super(!0,i,E.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}let p=class{constructor(i,r,c,o){this.g=o,this.a=i,this.b=r,this.c=c,this.d=new P.$bm,this.f=Object.create(null)}dispose(){for(const[i,r]of this.d)r.dispose()}async waitForActivatingExtensions(){const i=[];for(const[r,c]of this.d)i.push(c.wait());await Promise.all(i)}isActivated(i){const r=this.d.get(i);return!!(r&&r.value)}getActivatedExtension(i){const r=this.d.get(i);if(!r||!r.value)throw new Error(`Extension '${i.value}' is not known or not activated`);return r.value}async activateByEvent(i,r){if(this.f[i])return;const c=this.a.getExtensionDescriptionsForActivationEvent(i);await this.h(c.map(o=>({id:o.identifier,reason:{startup:r,extensionId:o.identifier,activationEvent:i}}))),this.f[i]=!0}activateById(i,r){const c=this.a.getExtensionDescription(i);if(!c)throw new Error(`Extension '${i}' is not known`);return this.h([{id:c.identifier,reason:r}])}async h(i){const r=i.filter(c=>!this.isActivated(c.id)).map(c=>this.j(c));await Promise.all(r.map(c=>c.wait()))}j(i){if(this.d.has(i.id))return this.d.get(i.id);if(this.l(i.id))return this.k(i,null,[],null);const r=this.a.getExtensionDescription(i.id);if(!r){const l=new Error(`Cannot activate unknown extension '${i.id.value}'`),n=this.k(i,null,[],new b(l));return this.c.onExtensionActivationError(i.id,l,new M.$JF(i.id.value)),n}const c=[],o=typeof r.extensionDependencies>"u"?[]:r.extensionDependencies;for(const l of o){if(this.m(l))continue;const n=this.d.get(l);if(n){c.push(n);continue}if(this.l(l)){c.push(this.j({id:this.b.getExtensionDescription(l).identifier,reason:i.reason}));continue}const s=this.a.getExtensionDescription(l);if(s){if(!s.main&&!s.browser)continue;c.push(this.j({id:s.identifier,reason:i.reason}));continue}const a=r.displayName||r.identifier.value,d=new Error(`Cannot activate the '${a}' extension because it depends on unknown extension '${l}'`),v=this.k(i,r.displayName,[],new b(d));return this.c.onExtensionActivationError(r.identifier,d,new M.$JF(l)),v}return this.k(i,r.displayName,c,null)}k(i,r,c,o){const l=new g(i.id,r,i.reason,c,o,this.c,this.g);return this.d.set(i.id,l),l}l(i){return F.$T5b.isHostExtension(i,this.a,this.b)}m(i){const r=this.b.getExtensionDescription(i);return r?!r.main&&!r.browser:!1}};e.$mec=p,e.$mec=p=Ke([Ve(3,A.$dj)],p);let g=class{get value(){return this.h}get friendlyName(){return this.d||this.c.value}constructor(i,r,c,o,l,n,s){this.c=i,this.d=r,this.f=c,this.g=o,this.h=l,this.j=n,this.k=s,this.a=new $.$Wg,this.b=!1,this.l()}dispose(){this.b=!0}wait(){return this.a.wait()}async l(){await this.m(),this.a.open()}async m(){if(!this.h){for(;this.g.length>0;){for(let i=0;i<this.g.length;i++){const r=this.g[i];if(r.value&&!r.value.activationFailed){this.g.splice(i,1),i--;continue}if(r.value&&r.value.activationFailed){const c=new Error(`Cannot activate the '${this.friendlyName}' extension because its dependency '${r.friendlyName}' failed to activate`);c.detail=r.value.activationFailedError,this.h=new b(c),this.j.onExtensionActivationError(this.c,c,null);return}}this.g.length>0&&await Promise.race(this.g.map(i=>i.wait()))}await this.n()}}async n(){try{this.h=await this.j.actualActivateExtension(this.c,this.f)}catch(i){const r=new Error;if(i&&i.name&&(r.name=i.name),i&&i.message?r.message=`Activating extension '${this.c.value}' failed: ${i.message}.`:r.message=`Activating extension '${this.c.value}' failed: ${i}.`,i&&i.stack&&(r.stack=i.stack),this.h=new b(r),this.b&&y.$3(i))return;this.j.onExtensionActivationError(this.c,r,null),this.k.error(`Activating extension ${this.c.value} failed due to an error:`),this.k.error(i)}}};g=Ke([Ve(6,A.$dj)],g)}),define(Pe[8],Re([1,0,18,24,126,219,52,28,120,51,68,26,16,2,29,80,98,104,102,76,48,58,216,7,23]),function(be,e,y,F,P,M,A,$,E,f,C,D,u,b,p,g,t,i,r,c,o,l,n,s,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminalQuickFix=e.ChatResponseProgress=e.InteractiveEditorResponseFeedbackKind=e.ChatVariableLevel=e.ChatVariable=e.ChatMessageRole=e.ChatMessage=e.ChatFollowup=e.ChatReplyFollowup=e.DataTransfer=e.DataTransferItem=e.ViewBadge=e.TypeHierarchyItem=e.CodeActionTriggerKind=e.TestCoverage=e.TestResults=e.TestItem=e.TestTag=e.TestMessage=e.NotebookRendererScript=e.NotebookDocumentContentOptions=e.NotebookKernelSourceAction=e.NotebookStatusBarItem=e.NotebookExclusiveDocumentPattern=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookCellData=e.NotebookData=e.NotebookCellKind=e.NotebookCellExecutionState=e.NotebookCellExecutionSummary=e.NotebookRange=e.MappedEditsContext=e.LanguageSelector=e.GlobPattern=e.TextEditorOpenOptions=e.FoldingRangeKind=e.FoldingRange=e.ProgressLocation=e.EndOfLine=e.TextEditorLineNumbersStyle=e.TextDocumentSaveReason=e.SelectionRange=e.Color=e.ColorPresentation=e.DocumentLink=e.InlayHintKind=e.InlayHintLabelPart=e.InlayHint=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.CompletionItem=e.CompletionItemKind=e.CompletionItemTag=e.CompletionContext=e.CompletionTriggerKind=e.DocumentHighlight=e.InlineValueContext=e.InlineValue=e.EvaluatableExpression=e.Hover=e.DefinitionLink=e.location=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.DocumentSymbol=e.WorkspaceSymbol=e.SymbolTag=e.SymbolKind=e.WorkspaceEdit=e.TextEdit=e.DecorationRenderOptions=e.DecorationRangeBehavior=e.ThemableDecorationRenderOptions=e.ThemableDecorationAttachmentRenderOptions=e.$yM=e.$xM=e.MarkdownString=e.$wM=e.ViewColumn=e.DiagnosticSeverity=e.DiagnosticRelatedInformation=e.Diagnostic=e.DiagnosticTag=e.DocumentSelector=e.Position=e.TokenType=e.Range=e.Selection=void 0;var d;(function(Ce){function Me(H){const{selectionStartLineNumber:Le,selectionStartColumn:je,positionLineNumber:Qe,positionColumn:qe}=H,it=new s.$AK(Le-1,je-1),pt=new s.$AK(Qe-1,qe-1);return new s.$CK(it,pt)}Ce.to=Me;function ve(H){const{anchor:Le,active:je}=H;return{selectionStartLineNumber:Le.line+1,selectionStartColumn:Le.character+1,positionLineNumber:je.line+1,positionColumn:je.character+1}}Ce.from=ve})(d||(e.Selection=d={}));var v;(function(Ce){function Me(H){if(!H)return;const{start:Le,end:je}=H;return{startLineNumber:Le.line+1,startColumn:Le.character+1,endLineNumber:je.line+1,endColumn:je.character+1}}Ce.from=Me;function ve(H){if(!H)return;const{startLineNumber:Le,startColumn:je,endLineNumber:Qe,endColumn:qe}=H;return new s.$BK(Le-1,je-1,Qe-1,qe-1)}Ce.to=ve})(v||(e.Range=v={}));var m;(function(Ce){function Me(ve){switch(ve){case 1:return s.StandardTokenType.Comment;case 0:return s.StandardTokenType.Other;case 3:return s.StandardTokenType.RegEx;case 2:return s.StandardTokenType.String}}Ce.to=Me})(m||(e.TokenType=m={}));var S;(function(Ce){function Me(H){return new s.$AK(H.lineNumber-1,H.column-1)}Ce.to=Me;function ve(H){return{lineNumber:H.line+1,column:H.character+1}}Ce.from=ve})(S||(e.Position=S={}));var k;(function(Ce){function Me(Le,je,Qe){return(0,y.$Gb)((0,y.$2b)(Le).map(qe=>ve(qe,je,Qe)))}Ce.from=Me;function ve(Le,je,Qe){if(typeof Le=="string")return{$serialized:!0,language:Le,isBuiltin:Qe?.isBuiltin};if(Le)return{$serialized:!0,language:Le.language,scheme:H(Le.scheme,je),pattern:Y.from(Le.pattern)??void 0,exclusive:Le.exclusive,notebookType:Le.notebookType,isBuiltin:Qe?.isBuiltin}}function H(Le,je){return je&&typeof Le=="string"?je.transformOutgoingScheme(Le):Le}})(k||(e.DocumentSelector=k={}));var h;(function(Ce){function Me(H){switch(H){case s.DiagnosticTag.Unnecessary:return 1;case s.DiagnosticTag.Deprecated:return 2}}Ce.from=Me;function ve(H){switch(H){case 1:return s.DiagnosticTag.Unnecessary;case 2:return s.DiagnosticTag.Deprecated;default:return}}Ce.to=ve})(h||(e.DiagnosticTag=h={}));var w;(function(Ce){function Me(H){let Le;return H.code&&((0,u.$Cf)(H.code)||(0,u.$Gf)(H.code)?Le=String(H.code):Le={value:String(H.code.value),target:H.code.target}),{...v.from(H.range),message:H.message,source:H.source,code:Le,severity:L.from(H.severity),relatedInformation:H.relatedInformation&&H.relatedInformation.map(I.from),tags:Array.isArray(H.tags)?(0,y.$Gb)(H.tags.map(h.from)):void 0}}Ce.from=Me;function ve(H){const Le=new s.$NK(v.to(H),H.message,L.to(H.severity));return Le.source=H.source,Le.code=(0,u.$Cf)(H.code)?H.code:H.code?.value,Le.relatedInformation=H.relatedInformation&&H.relatedInformation.map(I.to),Le.tags=H.tags&&(0,y.$Gb)(H.tags.map(h.to)),Le}Ce.to=ve})(w||(e.Diagnostic=w={}));var I;(function(Ce){function Me(H){return{...v.from(H.location.range),message:H.message,resource:H.location.uri}}Ce.from=Me;function ve(H){return new s.$MK(new s.$LK(H.resource,v.to(H)),H.message)}Ce.to=ve})(I||(e.DiagnosticRelatedInformation=I={}));var L;(function(Ce){function Me(H){switch(H){case s.DiagnosticSeverity.Error:return t.MarkerSeverity.Error;case s.DiagnosticSeverity.Warning:return t.MarkerSeverity.Warning;case s.DiagnosticSeverity.Information:return t.MarkerSeverity.Info;case s.DiagnosticSeverity.Hint:return t.MarkerSeverity.Hint}return t.MarkerSeverity.Error}Ce.from=Me;function ve(H){switch(H){case t.MarkerSeverity.Info:return s.DiagnosticSeverity.Information;case t.MarkerSeverity.Warning:return s.DiagnosticSeverity.Warning;case t.MarkerSeverity.Error:return s.DiagnosticSeverity.Error;case t.MarkerSeverity.Hint:return s.DiagnosticSeverity.Hint;default:return s.DiagnosticSeverity.Error}}Ce.to=ve})(L||(e.DiagnosticSeverity=L={}));var V;(function(Ce){function Me(H){return typeof H=="number"&&H>=s.ViewColumn.One?H-1:H===s.ViewColumn.Beside?n.$LC:n.$KC}Ce.from=Me;function ve(H){if(typeof H=="number"&&H>=0)return H+1;throw new Error("invalid 'EditorGroupColumn'")}Ce.to=ve})(V||(e.ViewColumn=V={}));function K(Ce){return typeof Ce.range<"u"}function R(Ce){return Ce.length===0?!0:!!K(Ce[0])}e.$wM=R;var N;(function(Ce){function Me(qe){return qe.map(Ce.from)}Ce.fromMany=Me;function ve(qe){return qe&&typeof qe=="object"&&typeof qe.language=="string"&&typeof qe.value=="string"}function H(qe){let it;if(ve(qe)){const{language:ut,value:Mt}=qe;it={value:"```"+ut+`
`+Mt+"\n```\n"}}else s.$ZK.isMarkdownString(qe)?it={value:qe.value,isTrusted:qe.isTrusted,supportThemeIcons:qe.supportThemeIcons,supportHtml:qe.supportHtml,baseUri:qe.baseUri}:typeof qe=="string"?it={value:qe}:it={value:""};const pt=Object.create(null);it.uris=pt;const $t=ut=>{try{let Mt=b.URI.parse(ut,!0);Mt=Mt.with({query:Le(Mt.query,pt)}),pt[ut]=Mt}catch{}return""},bt=new E.marked.Renderer;return bt.link=$t,bt.image=ut=>typeof ut=="string"?$t(A.$dk(ut).href):"",(0,E.marked)(it.value,{renderer:bt}),it}Ce.from=H;function Le(qe,it){if(!qe)return qe;let pt;try{pt=(0,f.$rh)(qe)}catch{}if(!pt)return qe;let $t=!1;return pt=(0,D.$cn)(pt,bt=>{if(b.URI.isUri(bt)){const ut=`__uri_${Math.random().toString(16).slice(2,8)}`;return it[ut]=bt,$t=!0,ut}else return}),$t?JSON.stringify(pt):qe}function je(qe){const it=new s.$ZK(qe.value,qe.supportThemeIcons);return it.isTrusted=qe.isTrusted,it.supportHtml=qe.supportHtml,it.baseUri=qe.baseUri?b.URI.from(qe.baseUri):void 0,it}Ce.to=je;function Qe(qe){if(qe)return typeof qe=="string"?qe:Ce.from(qe)}Ce.fromStrict=Qe})(N||(e.MarkdownString=N={}));function T(Ce){return R(Ce)?Ce.map(Me=>({range:v.from(Me.range),hoverMessage:Array.isArray(Me.hoverMessage)?N.fromMany(Me.hoverMessage):Me.hoverMessage?N.from(Me.hoverMessage):void 0,renderOptions:Me.renderOptions})):Ce.map(Me=>({range:v.from(Me)}))}e.$xM=T;function z(Ce){return typeof Ce>"u"?Ce:typeof Ce=="string"?b.URI.file(Ce):Ce}e.$yM=z;var Z;(function(Ce){function Me(ve){return typeof ve>"u"?ve:{contentText:ve.contentText,contentIconPath:ve.contentIconPath?z(ve.contentIconPath):void 0,border:ve.border,borderColor:ve.borderColor,fontStyle:ve.fontStyle,fontWeight:ve.fontWeight,textDecoration:ve.textDecoration,color:ve.color,backgroundColor:ve.backgroundColor,margin:ve.margin,width:ve.width,height:ve.height}}Ce.from=Me})(Z||(e.ThemableDecorationAttachmentRenderOptions=Z={}));var he;(function(Ce){function Me(ve){return typeof ve>"u"?ve:{backgroundColor:ve.backgroundColor,outline:ve.outline,outlineColor:ve.outlineColor,outlineStyle:ve.outlineStyle,outlineWidth:ve.outlineWidth,border:ve.border,borderColor:ve.borderColor,borderRadius:ve.borderRadius,borderSpacing:ve.borderSpacing,borderStyle:ve.borderStyle,borderWidth:ve.borderWidth,fontStyle:ve.fontStyle,fontWeight:ve.fontWeight,textDecoration:ve.textDecoration,cursor:ve.cursor,color:ve.color,opacity:ve.opacity,letterSpacing:ve.letterSpacing,gutterIconPath:ve.gutterIconPath?z(ve.gutterIconPath):void 0,gutterIconSize:ve.gutterIconSize,overviewRulerColor:ve.overviewRulerColor,before:ve.before?Z.from(ve.before):void 0,after:ve.after?Z.from(ve.after):void 0}}Ce.from=Me})(he||(e.ThemableDecorationRenderOptions=he={}));var ye;(function(Ce){function Me(ve){if(typeof ve>"u")return ve;switch(ve){case s.DecorationRangeBehavior.OpenOpen:return 0;case s.DecorationRangeBehavior.ClosedClosed:return 1;case s.DecorationRangeBehavior.OpenClosed:return 2;case s.DecorationRangeBehavior.ClosedOpen:return 3}}Ce.from=Me})(ye||(e.DecorationRangeBehavior=ye={}));var De;(function(Ce){function Me(ve){return{isWholeLine:ve.isWholeLine,rangeBehavior:ve.rangeBehavior?ye.from(ve.rangeBehavior):void 0,overviewRulerLane:ve.overviewRulerLane,light:ve.light?he.from(ve.light):void 0,dark:ve.dark?he.from(ve.dark):void 0,backgroundColor:ve.backgroundColor,outline:ve.outline,outlineColor:ve.outlineColor,outlineStyle:ve.outlineStyle,outlineWidth:ve.outlineWidth,border:ve.border,borderColor:ve.borderColor,borderRadius:ve.borderRadius,borderSpacing:ve.borderSpacing,borderStyle:ve.borderStyle,borderWidth:ve.borderWidth,fontStyle:ve.fontStyle,fontWeight:ve.fontWeight,textDecoration:ve.textDecoration,cursor:ve.cursor,color:ve.color,opacity:ve.opacity,letterSpacing:ve.letterSpacing,gutterIconPath:ve.gutterIconPath?z(ve.gutterIconPath):void 0,gutterIconSize:ve.gutterIconSize,overviewRulerColor:ve.overviewRulerColor,before:ve.before?Z.from(ve.before):void 0,after:ve.after?Z.from(ve.after):void 0}}Ce.from=Me})(De||(e.DecorationRenderOptions=De={}));var Se;(function(Ce){function Me(H){return{text:H.newText,eol:H.newEol&&et.from(H.newEol),range:v.from(H.range)}}Ce.from=Me;function ve(H){const Le=new s.$GK(v.to(H.range),H.text);return Le.newEol=typeof H.eol>"u"?void 0:et.to(H.eol),Le}Ce.to=ve})(Se||(e.TextEdit=Se={}));var fe;(function(Ce){function Me(H,Le){const je={edits:[]};if(H instanceof s.$JK){const Qe=new $.$Ac;for(const qe of H._allEntries())qe._type===1&&b.URI.isUri(qe.to)&&qe.from===void 0&&Qe.add(qe.to);for(const qe of H._allEntries())if(qe._type===1){let it;qe.options?.contents&&(ArrayBuffer.isView(qe.options.contents)?it={type:"base64",value:(0,F.$ze)(F.$fe.wrap(qe.options.contents))}:it={type:"dataTransferItem",id:qe.options.contents._itemId}),je.edits.push({oldResource:qe.from,newResource:qe.to,options:{...qe.options,contents:it},metadata:qe.metadata})}else qe._type===2?je.edits.push({resource:qe.uri,textEdit:Se.from(qe.edit),versionId:Qe.has(qe.uri)?void 0:Le?.getTextDocumentVersion(qe.uri),metadata:qe.metadata}):qe._type===6?je.edits.push({resource:qe.uri,textEdit:{range:v.from(qe.range),text:qe.edit.value,insertAsSnippet:!0},versionId:Qe.has(qe.uri)?void 0:Le?.getTextDocumentVersion(qe.uri),metadata:qe.metadata}):qe._type===3?je.edits.push({metadata:qe.metadata,resource:qe.uri,cellEdit:qe.edit,notebookMetadata:qe.notebookMetadata,notebookVersionId:Le?.getNotebookDocumentVersion(qe.uri)}):qe._type===5&&je.edits.push({metadata:qe.metadata,resource:qe.uri,notebookVersionId:Le?.getNotebookDocumentVersion(qe.uri),cellEdit:{editType:1,index:qe.index,count:qe.count,cells:qe.cells.map(Dt.from)}})}return je}Ce.from=Me;function ve(H){const Le=new s.$JK,je=new $.$zc;for(const Qe of H.edits)if(Qe.textEdit){const qe=Qe,it=b.URI.revive(qe.resource),pt=v.to(qe.textEdit.range),$t=qe.textEdit.text,bt=qe.textEdit.insertAsSnippet;let ut;bt?ut=s.$IK.replace(pt,new s.$KK($t)):ut=s.$GK.replace(pt,$t);const Mt=je.get(it);Mt?Mt.push(ut):je.set(it,[ut])}else Le.renameFile(b.URI.revive(Qe.oldResource),b.URI.revive(Qe.newResource),Qe.options);for(const[Qe,qe]of je)Le.set(Qe,qe);return Le}Ce.to=ve})(fe||(e.WorkspaceEdit=fe={}));var $e;(function(Ce){const Me=Object.create(null);Me[s.SymbolKind.File]=0,Me[s.SymbolKind.Module]=1,Me[s.SymbolKind.Namespace]=2,Me[s.SymbolKind.Package]=3,Me[s.SymbolKind.Class]=4,Me[s.SymbolKind.Method]=5,Me[s.SymbolKind.Property]=6,Me[s.SymbolKind.Field]=7,Me[s.SymbolKind.Constructor]=8,Me[s.SymbolKind.Enum]=9,Me[s.SymbolKind.Interface]=10,Me[s.SymbolKind.Function]=11,Me[s.SymbolKind.Variable]=12,Me[s.SymbolKind.Constant]=13,Me[s.SymbolKind.String]=14,Me[s.SymbolKind.Number]=15,Me[s.SymbolKind.Boolean]=16,Me[s.SymbolKind.Array]=17,Me[s.SymbolKind.Object]=18,Me[s.SymbolKind.Key]=19,Me[s.SymbolKind.Null]=20,Me[s.SymbolKind.EnumMember]=21,Me[s.SymbolKind.Struct]=22,Me[s.SymbolKind.Event]=23,Me[s.SymbolKind.Operator]=24,Me[s.SymbolKind.TypeParameter]=25;function ve(Le){return typeof Me[Le]=="number"?Me[Le]:6}Ce.from=ve;function H(Le){for(const je in Me)if(Me[je]===Le)return Number(je);return s.SymbolKind.Property}Ce.to=H})($e||(e.SymbolKind=$e={}));var re;(function(Ce){function Me(H){switch(H){case s.SymbolTag.Deprecated:return 1}}Ce.from=Me;function ve(H){switch(H){case 1:return s.SymbolTag.Deprecated}}Ce.to=ve})(re||(e.SymbolTag=re={}));var Ae;(function(Ce){function Me(H){return{name:H.name,kind:$e.from(H.kind),tags:H.tags&&H.tags.map(re.from),containerName:H.containerName,location:pe.from(H.location)}}Ce.from=Me;function ve(H){const Le=new s.$QK(H.name,$e.to(H.kind),H.containerName,pe.to(H.location));return Le.tags=H.tags&&H.tags.map(re.to),Le}Ce.to=ve})(Ae||(e.WorkspaceSymbol=Ae={}));var se;(function(Ce){function Me(H){const Le={name:H.name||"!!MISSING: name!!",detail:H.detail,range:v.from(H.range),selectionRange:v.from(H.selectionRange),kind:$e.from(H.kind),tags:H.tags?.map(re.from)??[]};return H.children&&(Le.children=H.children.map(Me)),Le}Ce.from=Me;function ve(H){const Le=new s.$RK(H.name,H.detail,$e.to(H.kind),v.to(H.range),v.to(H.selectionRange));return(0,y.$Kb)(H.tags)&&(Le.tags=H.tags.map(re.to)),H.children&&(Le.children=H.children.map(ve)),Le}Ce.to=ve})(se||(e.DocumentSymbol=se={}));var X;(function(Ce){function Me(H){const Le=new s.$VK($e.to(H.kind),H.name,H.detail||"",b.URI.revive(H.uri),v.to(H.range),v.to(H.selectionRange));return Le._sessionId=H._sessionId,Le._itemId=H._itemId,Le}Ce.to=Me;function ve(H,Le,je){if(Le=Le??H._sessionId,je=je??H._itemId,Le===void 0||je===void 0)throw new Error("invalid item");return{_sessionId:Le,_itemId:je,name:H.name,detail:H.detail,kind:$e.from(H.kind),uri:H.uri,range:v.from(H.range),selectionRange:v.from(H.selectionRange),tags:H.tags?.map(re.from)}}Ce.from=ve})(X||(e.CallHierarchyItem=X={}));var B;(function(Ce){function Me(ve){return new s.$WK(X.to(ve.from),ve.fromRanges.map(H=>v.to(H)))}Ce.to=Me})(B||(e.CallHierarchyIncomingCall=B={}));var ie;(function(Ce){function Me(ve){return new s.$XK(X.to(ve.to),ve.fromRanges.map(H=>v.to(H)))}Ce.to=Me})(ie||(e.CallHierarchyOutgoingCall=ie={}));var pe;(function(Ce){function Me(H){return{range:H.range&&v.from(H.range),uri:H.uri}}Ce.from=Me;function ve(H){return new s.$LK(b.URI.revive(H.uri),v.to(H.range))}Ce.to=ve})(pe||(e.location=pe={}));var ne;(function(Ce){function Me(H){const Le=H,je=H;return{originSelectionRange:Le.originSelectionRange?v.from(Le.originSelectionRange):void 0,uri:Le.targetUri?Le.targetUri:je.uri,range:v.from(Le.targetRange?Le.targetRange:je.range),targetSelectionRange:Le.targetSelectionRange?v.from(Le.targetSelectionRange):void 0}}Ce.from=Me;function ve(H){return{targetUri:b.URI.revive(H.uri),targetRange:v.to(H.range),targetSelectionRange:H.targetSelectionRange?v.to(H.targetSelectionRange):void 0,originSelectionRange:H.originSelectionRange?v.to(H.originSelectionRange):void 0}}Ce.to=ve})(ne||(e.DefinitionLink=ne={}));var le;(function(Ce){function Me(H){return{range:v.from(H.range),contents:N.fromMany(H.contents)}}Ce.from=Me;function ve(H){return new s.$OK(H.contents.map(N.to),v.to(H.range))}Ce.to=ve})(le||(e.Hover=le={}));var ce;(function(Ce){function Me(H){return{range:v.from(H.range),expression:H.expression}}Ce.from=Me;function ve(H){return new s.$HL(v.to(H.range),H.expression)}Ce.to=ve})(ce||(e.EvaluatableExpression=ce={}));var we;(function(Ce){function Me(H){if(H instanceof s.$IL)return{type:"text",range:v.from(H.range),text:H.text};if(H instanceof s.$JL)return{type:"variable",range:v.from(H.range),variableName:H.variableName,caseSensitiveLookup:H.caseSensitiveLookup};if(H instanceof s.$KL)return{type:"expression",range:v.from(H.range),expression:H.expression};throw new Error("Unknown 'InlineValue' type")}Ce.from=Me;function ve(H){switch(H.type){case"text":return{range:v.to(H.range),text:H.text};case"variable":return{range:v.to(H.range),variableName:H.variableName,caseSensitiveLookup:H.caseSensitiveLookup};case"expression":return{range:v.to(H.range),expression:H.expression}}}Ce.to=ve})(we||(e.InlineValue=we={}));var _;(function(Ce){function Me(H){return{frameId:H.frameId,stoppedLocation:v.from(H.stoppedLocation)}}Ce.from=Me;function ve(H){return new s.$LL(H.frameId,v.to(H.stoppedLocation))}Ce.to=ve})(_||(e.InlineValueContext=_={}));var de;(function(Ce){function Me(H){return{range:v.from(H.range),kind:H.kind}}Ce.from=Me;function ve(H){return new s.$PK(v.to(H.range),H.kind)}Ce.to=ve})(de||(e.DocumentHighlight=de={}));var te;(function(Ce){function Me(ve){switch(ve){case 1:return s.CompletionTriggerKind.TriggerCharacter;case 2:return s.CompletionTriggerKind.TriggerForIncompleteCompletions;case 0:default:return s.CompletionTriggerKind.Invoke}}Ce.to=Me})(te||(e.CompletionTriggerKind=te={}));var ae;(function(Ce){function Me(ve){return{triggerKind:te.to(ve.triggerKind),triggerCharacter:ve.triggerCharacter}}Ce.to=Me})(ae||(e.CompletionContext=ae={}));var me;(function(Ce){function Me(H){switch(H){case s.CompletionItemTag.Deprecated:return 1}}Ce.from=Me;function ve(H){switch(H){case 1:return s.CompletionItemTag.Deprecated}}Ce.to=ve})(me||(e.CompletionItemTag=me={}));var Ie;(function(Ce){const Me=new Map([[s.CompletionItemKind.Method,0],[s.CompletionItemKind.Function,1],[s.CompletionItemKind.Constructor,2],[s.CompletionItemKind.Field,3],[s.CompletionItemKind.Variable,4],[s.CompletionItemKind.Class,5],[s.CompletionItemKind.Interface,7],[s.CompletionItemKind.Struct,6],[s.CompletionItemKind.Module,8],[s.CompletionItemKind.Property,9],[s.CompletionItemKind.Unit,12],[s.CompletionItemKind.Value,13],[s.CompletionItemKind.Constant,14],[s.CompletionItemKind.Enum,15],[s.CompletionItemKind.EnumMember,16],[s.CompletionItemKind.Keyword,17],[s.CompletionItemKind.Snippet,27],[s.CompletionItemKind.Text,18],[s.CompletionItemKind.Color,19],[s.CompletionItemKind.File,20],[s.CompletionItemKind.Reference,21],[s.CompletionItemKind.Folder,23],[s.CompletionItemKind.Event,10],[s.CompletionItemKind.Operator,11],[s.CompletionItemKind.TypeParameter,24],[s.CompletionItemKind.Issue,26],[s.CompletionItemKind.User,25]]);function ve(je){return Me.get(je)??9}Ce.from=ve;const H=new Map([[0,s.CompletionItemKind.Method],[1,s.CompletionItemKind.Function],[2,s.CompletionItemKind.Constructor],[3,s.CompletionItemKind.Field],[4,s.CompletionItemKind.Variable],[5,s.CompletionItemKind.Class],[7,s.CompletionItemKind.Interface],[6,s.CompletionItemKind.Struct],[8,s.CompletionItemKind.Module],[9,s.CompletionItemKind.Property],[12,s.CompletionItemKind.Unit],[13,s.CompletionItemKind.Value],[14,s.CompletionItemKind.Constant],[15,s.CompletionItemKind.Enum],[16,s.CompletionItemKind.EnumMember],[17,s.CompletionItemKind.Keyword],[27,s.CompletionItemKind.Snippet],[18,s.CompletionItemKind.Text],[19,s.CompletionItemKind.Color],[20,s.CompletionItemKind.File],[21,s.CompletionItemKind.Reference],[23,s.CompletionItemKind.Folder],[10,s.CompletionItemKind.Event],[11,s.CompletionItemKind.Operator],[24,s.CompletionItemKind.TypeParameter],[25,s.CompletionItemKind.User],[26,s.CompletionItemKind.Issue]]);function Le(je){return H.get(je)??s.CompletionItemKind.Property}Ce.to=Le})(Ie||(e.CompletionItemKind=Ie={}));var O;(function(Ce){function Me(ve,H){const Le=new s.$6K(ve.label);return Le.insertText=ve.insertText,Le.kind=Ie.to(ve.kind),Le.tags=ve.tags?.map(me.to),Le.detail=ve.detail,Le.documentation=A.$$j(ve.documentation)?N.to(ve.documentation):ve.documentation,Le.sortText=ve.sortText,Le.filterText=ve.filterText,Le.preselect=ve.preselect,Le.commitCharacters=ve.commitCharacters,p.$zs.isIRange(ve.range)?Le.range=v.to(ve.range):typeof ve.range=="object"&&(Le.range={inserting:v.to(ve.range.insert),replacing:v.to(ve.range.replace)}),Le.keepWhitespace=typeof ve.insertTextRules>"u"?!1:!!(ve.insertTextRules&1),typeof ve.insertTextRules<"u"&&ve.insertTextRules&4?Le.insertText=new s.$KK(ve.insertText):(Le.insertText=ve.insertText,Le.textEdit=Le.range instanceof s.$BK?new s.$GK(Le.range,Le.insertText):void 0),ve.additionalTextEdits&&ve.additionalTextEdits.length>0&&(Le.additionalTextEdits=ve.additionalTextEdits.map(je=>Se.to(je))),Le.command=H&&ve.command?H.fromInternal(ve.command):void 0,Le}Ce.to=Me})(O||(e.CompletionItem=O={}));var W;(function(Ce){function Me(H){if(typeof H.label!="string"&&!Array.isArray(H.label))throw new TypeError("Invalid label");return{label:H.label,documentation:N.fromStrict(H.documentation)}}Ce.from=Me;function ve(H){return{label:H.label,documentation:A.$$j(H.documentation)?N.to(H.documentation):H.documentation}}Ce.to=ve})(W||(e.ParameterInformation=W={}));var G;(function(Ce){function Me(H){return{label:H.label,documentation:N.fromStrict(H.documentation),parameters:Array.isArray(H.parameters)?H.parameters.map(W.from):[],activeParameter:H.activeParameter}}Ce.from=Me;function ve(H){return{label:H.label,documentation:A.$$j(H.documentation)?N.to(H.documentation):H.documentation,parameters:Array.isArray(H.parameters)?H.parameters.map(W.to):[],activeParameter:H.activeParameter}}Ce.to=ve})(G||(e.SignatureInformation=G={}));var J;(function(Ce){function Me(H){return{activeSignature:H.activeSignature,activeParameter:H.activeParameter,signatures:Array.isArray(H.signatures)?H.signatures.map(G.from):[]}}Ce.from=Me;function ve(H){return{activeSignature:H.activeSignature,activeParameter:H.activeParameter,signatures:Array.isArray(H.signatures)?H.signatures.map(G.to):[]}}Ce.to=ve})(J||(e.SignatureHelp=J={}));var q;(function(Ce){function Me(ve,H){const Le=new s.$5K(S.to(H.position),typeof H.label=="string"?H.label:H.label.map(x.to.bind(void 0,ve)),H.kind&&ue.to(H.kind));return Le.textEdits=H.textEdits&&H.textEdits.map(Se.to),Le.tooltip=A.$$j(H.tooltip)?N.to(H.tooltip):H.tooltip,Le.paddingLeft=H.paddingLeft,Le.paddingRight=H.paddingRight,Le}Ce.to=Me})(q||(e.InlayHint=q={}));var x;(function(Ce){function Me(ve,H){const Le=new s.$4K(H.label);return Le.tooltip=A.$$j(H.tooltip)?N.to(H.tooltip):H.tooltip,g.Command.is(H.command)&&(Le.command=ve.fromInternal(H.command)),H.location&&(Le.location=pe.to(H.location)),Le}Ce.to=Me})(x||(e.InlayHintLabelPart=x={}));var ue;(function(Ce){function Me(H){return H}Ce.from=Me;function ve(H){return H}Ce.to=ve})(ue||(e.InlayHintKind=ue={}));var Oe;(function(Ce){function Me(H){return{range:v.from(H.range),url:H.target,tooltip:H.tooltip}}Ce.from=Me;function ve(H){let Le;if(H.url)try{Le=typeof H.url=="string"?b.URI.parse(H.url,!0):b.URI.revive(H.url)}catch{}return new s.$$K(v.to(H.range),Le)}Ce.to=ve})(Oe||(e.DocumentLink=Oe={}));var Ue;(function(Ce){function Me(H){const Le=new s.$bL(H.label);return H.textEdit&&(Le.textEdit=Se.to(H.textEdit)),H.additionalTextEdits&&(Le.additionalTextEdits=H.additionalTextEdits.map(je=>Se.to(je))),Le}Ce.to=Me;function ve(H){return{label:H.label,textEdit:H.textEdit?Se.from(H.textEdit):void 0,additionalTextEdits:H.additionalTextEdits?H.additionalTextEdits.map(Le=>Se.from(Le)):void 0}}Ce.from=ve})(Ue||(e.ColorPresentation=Ue={}));var Ze;(function(Ce){function Me(H){return new s.$_K(H[0],H[1],H[2],H[3])}Ce.to=Me;function ve(H){return[H.red,H.green,H.blue,H.alpha]}Ce.from=ve})(Ze||(e.Color=Ze={}));var Je;(function(Ce){function Me(H){return{range:v.from(H.range)}}Ce.from=Me;function ve(H){return new s.$UK(v.to(H.range))}Ce.to=ve})(Je||(e.SelectionRange=Je={}));var tt;(function(Ce){function Me(ve){switch(ve){case 2:return s.TextDocumentSaveReason.AfterDelay;case 1:return s.TextDocumentSaveReason.Manual;case 3:case 4:return s.TextDocumentSaveReason.FocusOut}}Ce.to=Me})(tt||(e.TextDocumentSaveReason=tt={}));var _e;(function(Ce){function Me(H){switch(H){case s.TextEditorLineNumbersStyle.Off:return 0;case s.TextEditorLineNumbersStyle.Relative:return 2;case s.TextEditorLineNumbersStyle.On:default:return 1}}Ce.from=Me;function ve(H){switch(H){case 0:return s.TextEditorLineNumbersStyle.Off;case 2:return s.TextEditorLineNumbersStyle.Relative;case 1:default:return s.TextEditorLineNumbersStyle.On}}Ce.to=ve})(_e||(e.TextEditorLineNumbersStyle=_e={}));var et;(function(Ce){function Me(H){if(H===s.EndOfLine.CRLF)return 1;if(H===s.EndOfLine.LF)return 0}Ce.from=Me;function ve(H){if(H===1)return s.EndOfLine.CRLF;if(H===0)return s.EndOfLine.LF}Ce.to=ve})(et||(e.EndOfLine=et={}));var rt;(function(Ce){function Me(ve){if(typeof ve=="object")return ve.viewId;switch(ve){case s.ProgressLocation.SourceControl:return 3;case s.ProgressLocation.Window:return 10;case s.ProgressLocation.Notification:return 15}throw new Error("Unknown 'ProgressLocation'")}Ce.from=Me})(rt||(e.ProgressLocation=rt={}));var nt;(function(Ce){function Me(H){const Le={start:H.start+1,end:H.end+1};return H.kind&&(Le.kind=Ne.from(H.kind)),Le}Ce.from=Me;function ve(H){const Le={start:H.start-1,end:H.end-1};return H.kind&&(Le.kind=Ne.to(H.kind)),Le}Ce.to=ve})(nt||(e.FoldingRange=nt={}));var Ne;(function(Ce){function Me(H){if(H)switch(H){case s.FoldingRangeKind.Comment:return g.$ot.Comment;case s.FoldingRangeKind.Imports:return g.$ot.Imports;case s.FoldingRangeKind.Region:return g.$ot.Region}}Ce.from=Me;function ve(H){if(H)switch(H.value){case g.$ot.Comment.value:return s.FoldingRangeKind.Comment;case g.$ot.Imports.value:return s.FoldingRangeKind.Imports;case g.$ot.Region.value:return s.FoldingRangeKind.Region}}Ce.to=ve})(Ne||(e.FoldingRangeKind=Ne={}));var dt;(function(Ce){function Me(ve){if(ve)return{pinned:typeof ve.preview=="boolean"?!ve.preview:void 0,inactive:ve.background,preserveFocus:ve.preserveFocus,selection:typeof ve.selection=="object"?v.from(ve.selection):void 0,override:typeof ve.override=="boolean"?r.$aE.id:void 0}}Ce.from=Me})(dt||(e.TextEditorOpenOptions=dt={}));var Y;(function(Ce){function Me(je){return je instanceof s.$vL?je.toJSON():typeof je=="string"?je:ve(je)||H(je)?new s.$vL(je.baseUri??je.base,je.pattern).toJSON():je}Ce.from=Me;function ve(je){const Qe=je;return Qe?b.URI.isUri(Qe.baseUri)&&typeof Qe.pattern=="string":!1}function H(je){const Qe=je;return Qe?typeof Qe.base=="string"&&typeof Qe.pattern=="string":!1}function Le(je){return typeof je=="string"?je:new s.$vL(b.URI.revive(je.baseUri),je.pattern)}Ce.to=Le})(Y||(e.GlobPattern=Y={}));var Q;(function(Ce){function Me(ve){if(ve){if(Array.isArray(ve))return ve.map(Me);if(typeof ve=="string")return ve;{const H=ve;return{language:H.language,scheme:H.scheme,pattern:Y.from(H.pattern),exclusive:H.exclusive,notebookType:H.notebookType}}}else return}Ce.from=Me})(Q||(e.LanguageSelector=Q={}));var Ee;(function(Ce){function Me(H){return!!H&&typeof H=="object"&&"documents"in H&&Array.isArray(H.documents)&&H.documents.every(Le=>Array.isArray(Le)&&Le.every(je=>je&&typeof je=="object"&&"uri"in je&&b.URI.isUri(je.uri)&&"version"in je&&typeof je.version=="number"&&"ranges"in je&&Array.isArray(je.ranges)&&je.ranges.every(Qe=>Qe instanceof s.$BK)))}Ce.is=Me;function ve(H){return{documents:H.documents.map(Le=>Le.map(je=>({uri:b.URI.from(je.uri),version:je.version,ranges:je.ranges.map(Qe=>v.from(Qe))})))}}Ce.from=ve})(Ee||(e.MappedEditsContext=Ee={}));var Be;(function(Ce){function Me(H){return{start:H.start,end:H.end}}Ce.from=Me;function ve(H){return new s.$WL(H.start,H.end)}Ce.to=ve})(Be||(e.NotebookRange=Be={}));var He;(function(Ce){function Me(H){return{timing:typeof H.runStartTime=="number"&&typeof H.runEndTime=="number"?{startTime:H.runStartTime,endTime:H.runEndTime}:void 0,executionOrder:H.executionOrder,success:H.lastRunSuccess}}Ce.to=Me;function ve(H){return{lastRunSuccess:H.success,runStartTime:H.timing?.startTime,runEndTime:H.timing?.endTime,executionOrder:H.executionOrder}}Ce.from=ve})(He||(e.NotebookCellExecutionSummary=He={}));var Ye;(function(Ce){function Me(ve){if(ve===c.NotebookCellExecutionState.Unconfirmed)return s.NotebookCellExecutionState.Pending;if(ve===c.NotebookCellExecutionState.Pending)return;if(ve===c.NotebookCellExecutionState.Executing)return s.NotebookCellExecutionState.Executing;throw new Error(`Unknown state: ${ve}`)}Ce.to=Me})(Ye||(e.NotebookCellExecutionState=Ye={}));var st;(function(Ce){function Me(H){switch(H){case s.NotebookCellKind.Markup:return c.CellKind.Markup;case s.NotebookCellKind.Code:default:return c.CellKind.Code}}Ce.from=Me;function ve(H){switch(H){case c.CellKind.Markup:return s.NotebookCellKind.Markup;case c.CellKind.Code:default:return s.NotebookCellKind.Code}}Ce.to=ve})(st||(e.NotebookCellKind=st={}));var vt;(function(Ce){function Me(H){const Le={metadata:H.metadata??Object.create(null),cells:[]};for(const je of H.cells)s.$XL.validate(je),Le.cells.push(Dt.from(je));return Le}Ce.from=Me;function ve(H){const Le=new s.$YL(H.cells.map(Dt.to));return(0,u.$Pf)(H.metadata)||(Le.metadata=H.metadata),Le}Ce.to=ve})(vt||(e.NotebookData=vt={}));var Dt;(function(Ce){function Me(H){return{cellKind:st.from(H.kind),language:H.languageId,mime:H.mime,source:H.value,metadata:H.metadata,internalMetadata:He.from(H.executionSummary??{}),outputs:H.outputs?H.outputs.map(Kt.from):[]}}Ce.from=Me;function ve(H){return new s.$XL(st.to(H.cellKind),H.source,H.language,H.mime,H.outputs?H.outputs.map(Kt.to):void 0,H.metadata,H.internalMetadata?He.to(H.internalMetadata):void 0)}Ce.to=ve})(Dt||(e.NotebookCellData=Dt={}));var ze;(function(Ce){function Me(H){return{mime:H.mime,valueBytes:F.$fe.wrap(H.data)}}Ce.from=Me;function ve(H){return new s.$ZL(H.valueBytes.buffer,H.mime)}Ce.to=ve})(ze||(e.NotebookCellOutputItem=ze={}));var Kt;(function(Ce){function Me(H){return{outputId:H.id,items:H.items.map(ze.from),metadata:H.metadata}}Ce.from=Me;function ve(H){const Le=H.items.map(ze.to);return new s.$1L(Le,H.outputId,H.metadata)}Ce.to=ve})(Kt||(e.NotebookCellOutput=Kt={}));var Ht;(function(Ce){function Me(Le){return H(Le)?{include:Y.from(Le.include)??void 0,exclude:Y.from(Le.exclude)??void 0}:Y.from(Le)??void 0}Ce.from=Me;function ve(Le){return H(Le)?{include:Y.to(Le.include),exclude:Y.to(Le.exclude)}:Y.to(Le)}Ce.to=ve;function H(Le){const je=Le;return je?!(0,u.$Lf)(je.include)&&!(0,u.$Lf)(je.exclude):!1}})(Ht||(e.NotebookExclusiveDocumentPattern=Ht={}));var yt;(function(Ce){function Me(ve,H,Le){const je=typeof ve.command=="string"?{title:"",command:ve.command}:ve.command;return{alignment:ve.alignment===s.NotebookCellStatusBarAlignment.Left?1:2,command:H.toInternal(je,Le),text:ve.text,tooltip:ve.tooltip,accessibilityInformation:ve.accessibilityInformation,priority:ve.priority}}Ce.from=Me})(yt||(e.NotebookStatusBarItem=yt={}));var jt;(function(Ce){function Me(ve,H,Le){const je=typeof ve.command=="string"?{title:"",command:ve.command}:ve.command;return{command:H.toInternal(je,Le),label:ve.label,description:ve.description,detail:ve.detail,documentation:ve.documentation}}Ce.from=Me})(jt||(e.NotebookKernelSourceAction=jt={}));var zt;(function(Ce){function Me(ve){return{transientOutputs:ve?.transientOutputs??!1,transientCellMetadata:ve?.transientCellMetadata??{},transientDocumentMetadata:ve?.transientDocumentMetadata??{},cellContentMetadata:ve?.cellContentMetadata??{}}}Ce.from=Me})(zt||(e.NotebookDocumentContentOptions=zt={}));var Gt;(function(Ce){function Me(H){return{uri:H.uri,provides:H.provides}}Ce.from=Me;function ve(H){return new s.$3L(b.URI.revive(H.uri),H.provides)}Ce.to=ve})(Gt||(e.NotebookRendererScript=Gt={}));var Bt;(function(Ce){function Me(H){return{message:N.fromStrict(H.message)||"",type:0,expected:H.expectedOutput,actual:H.actualOutput,contextValue:H.contextValue,location:H.location&&{range:v.from(H.location.range),uri:H.location.uri}}}Ce.from=Me;function ve(H){const Le=new s.$9L(typeof H.message=="string"?H.message:N.to(H.message));return Le.actualOutput=H.actual,Le.expectedOutput=H.expected,Le.contextValue=H.contextValue,Le.location=H.location?pe.to(H.location):void 0,Le}Ce.to=ve})(Bt||(e.TestMessage=Bt={}));var St;(function(Ce){Ce.namespace=l.$uJ,Ce.denamespace=l.$vJ})(St||(e.TestTag=St={}));var Lt;(function(Ce){function Me(H){const Le=(0,i.$vM)(H).controllerId;return{extId:o.$qJ.fromExtHostTestItem(H,Le).toString(),label:H.label,uri:b.URI.revive(H.uri),busy:H.busy,tags:H.tags.map(je=>St.namespace(Le,je.id)),range:p.$zs.lift(v.from(H.range)),description:H.description||null,sortText:H.sortText||null,error:H.error&&N.fromStrict(H.error)||null}}Ce.from=Me;function ve(H){return{parent:void 0,error:void 0,id:o.$qJ.fromString(H.extId).localId,label:H.label,uri:b.URI.revive(H.uri),tags:(H.tags||[]).map(Le=>{const{tagId:je}=St.denamespace(Le);return new s.$0L(je)}),children:{add:()=>{},delete:()=>{},forEach:()=>{},*[Symbol.iterator](){},get:()=>{},replace:()=>{},size:0},range:v.to(H.range||void 0),canResolveChildren:!1,busy:H.busy,description:H.description||void 0,sortText:H.sortText||void 0}}Ce.toPlain=ve})(Lt||(e.TestItem=Lt={})),function(Ce){function Me(H){return{id:H.id}}Ce.from=Me;function ve(H){return new s.$0L(H.id)}Ce.to=ve}(St||(e.TestTag=St={}));var Vt;(function(Ce){const Me=(H,Le)=>{const je=[];for(const[qe,it]of Le)o.$qJ.compare(it.item.extId,qe)===2&&(Le.delete(qe),je.push(it));const Qe={...Lt.toPlain(H.item),parent:void 0,taskStates:H.tasks.map(qe=>({state:qe.state,duration:qe.duration,messages:qe.messages.filter(it=>it.type===0).map(Bt.to)})),children:je.map(qe=>Me(qe,Le))};for(const qe of Qe.children)qe.parent=Qe;return Qe};function ve(H){const Le=[],je=new Map;for(const Qe of H.items){je.set(Qe.item.extId,Qe);const qe=o.$qJ.root(Qe.item.extId);H.request.targets.some(it=>it.controllerId===qe&&it.testIds.includes(Qe.item.extId))&&Le.push(Qe)}return{completedAt:H.completedAt,results:Le.map(Qe=>Me(Qe,je))}}Ce.to=ve})(Vt||(e.TestResults=Vt={}));var Xe;(function(Ce){function Me(je){return{covered:je.covered,total:je.covered}}function ve(je){return"line"in je?S.from(je):v.from(je)}function H(je){return"branches"in je?{count:je.executionCount,location:ve(je.location),type:1,branches:je.branches.length?je.branches.map(Qe=>({count:Qe.executionCount,location:Qe.location&&ve(Qe.location)})):void 0}:{type:0,count:je.executionCount,location:ve(je.location)}}Ce.fromDetailed=H;function Le(je){return{uri:je.uri,statement:Me(je.statementCoverage),branch:je.branchCoverage&&Me(je.branchCoverage),function:je.functionCoverage&&Me(je.functionCoverage),details:je.detailedCoverage?.map(H)}}Ce.fromFile=Le})(Xe||(e.TestCoverage=Xe={}));var Wt;(function(Ce){function Me(ve){switch(ve){case 1:return s.CodeActionTriggerKind.Invoke;case 2:return s.CodeActionTriggerKind.Automatic}}Ce.to=Me})(Wt||(e.CodeActionTriggerKind=Wt={}));var qt;(function(Ce){function Me(H){const Le=new s.$dM($e.to(H.kind),H.name,H.detail||"",b.URI.revive(H.uri),v.to(H.range),v.to(H.selectionRange));return Le._sessionId=H._sessionId,Le._itemId=H._itemId,Le}Ce.to=Me;function ve(H,Le,je){if(Le=Le??H._sessionId,je=je??H._itemId,Le===void 0||je===void 0)throw new Error("invalid item");return{_sessionId:Le,_itemId:je,kind:$e.from(H.kind),name:H.name,detail:H.detail??"",uri:H.uri,range:v.from(H.range),selectionRange:v.from(H.selectionRange),tags:H.tags?.map(re.from)}}Ce.from=ve})(qt||(e.TypeHierarchyItem=qt={}));var ct;(function(Ce){function Me(ve){if(ve)return{value:ve.value,tooltip:ve.tooltip}}Ce.from=Me})(ct||(e.ViewBadge=ct={}));var gt;(function(Ce){function Me(je,Qe,qe){const it=Qe.fileData;return it?new s.$oL(new s.$pL(it.name,b.URI.revive(it.uri),it.id,(0,M.$cb)(()=>qe(it.id)))):je===C.$Vr.uriList&&Qe.uriListData?new s.$nL(Le(Qe.uriListData)):new s.$nL(Qe.asString)}Ce.to=Me;async function ve(je,Qe){const qe=await Qe.asString();if(je===C.$Vr.uriList)return{asString:qe,fileData:void 0,uriListData:H(qe)};const it=Qe.asFile();return{asString:qe,fileData:it?{name:it.name,uri:it.uri,id:it._itemId??it.id}:void 0}}Ce.from=ve;function H(je){return P.$9s.split(je).map(Qe=>{if(Qe.startsWith("#"))return Qe;try{return b.URI.parse(Qe)}catch{}return Qe})}function Le(je){return P.$9s.create(je.map(Qe=>typeof Qe=="string"?Qe:b.URI.revive(Qe)))}})(gt||(e.DataTransferItem=gt={}));var Ot;(function(Ce){function Me(H,Le){const je=H.items.map(([Qe,qe])=>[Qe,gt.to(Qe,qe,Le)]);return new s.$qL(je)}Ce.toDataTransfer=Me;async function ve(H){const Le={items:[]},je=[];for(const[Qe,qe]of H)je.push((async()=>{Le.items.push([Qe,await gt.from(Qe,qe)])})());return await Promise.all(je),Le}Ce.from=ve})(Ot||(e.DataTransfer=Ot={}));var Pt;(function(Ce){function Me(ve){return{kind:"reply",message:ve.message,title:ve.title,tooltip:ve.tooltip}}Ce.from=Me})(Pt||(e.ChatReplyFollowup=Pt={}));var Rt;(function(Ce){function Me(ve){return typeof ve=="string"?{title:ve,message:ve,kind:"reply"}:"commandId"in ve?{kind:"command",title:ve.title??"",commandId:ve.commandId??"",when:ve.when??"",args:ve.args}:Pt.from(ve)}Ce.from=Me})(Rt||(e.ChatFollowup=Rt={}));var ft;(function(Ce){function Me(H){const Le=new s.$oM(kt.to(H.role),H.content);return Le.name=H.name,Le}Ce.to=Me;function ve(H){return{role:kt.from(H.role),content:H.content,name:H.name}}Ce.from=ve})(ft||(e.ChatMessage=ft={}));var kt;(function(Ce){function Me(H){switch(H){case 0:return s.ChatMessageRole.System;case 1:return s.ChatMessageRole.User;case 2:return s.ChatMessageRole.Assistant;case 3:return s.ChatMessageRole.Function}}Ce.to=Me;function ve(H){switch(H){case s.ChatMessageRole.System:return 0;case s.ChatMessageRole.Assistant:return 2;case s.ChatMessageRole.Function:return 3;case s.ChatMessageRole.User:default:return 1}}Ce.from=ve})(kt||(e.ChatMessageRole=kt={}));var At;(function(Ce){function Me(Le){const je={};for(const Qe of Object.keys(Le))je[Qe]=Le[Qe].map(Ce.to);return je}Ce.objectTo=Me;function ve(Le){return{level:Ct.to(Le.level),value:Le.value,description:Le.description}}Ce.to=ve;function H(Le){return{level:Ct.from(Le.level),value:Le.value,description:Le.description}}Ce.from=H})(At||(e.ChatVariable=At={}));var Ct;(function(Ce){function Me(H){switch(H){case"short":return s.ChatVariableLevel.Short;case"medium":return s.ChatVariableLevel.Medium;case"full":default:return s.ChatVariableLevel.Full}}Ce.to=Me;function ve(H){switch(H){case s.ChatVariableLevel.Short:return"short";case s.ChatVariableLevel.Medium:return"medium";case s.ChatVariableLevel.Full:default:return"full"}}Ce.from=ve})(Ct||(e.ChatVariableLevel=Ct={}));var We;(function(Ce){function Me(ve){switch(ve){case 1:return s.InteractiveEditorResponseFeedbackKind.Helpful;case 0:return s.InteractiveEditorResponseFeedbackKind.Unhelpful;case 2:return s.InteractiveEditorResponseFeedbackKind.Undone;case 3:return s.InteractiveEditorResponseFeedbackKind.Accepted}}Ce.to=Me})(We||(e.InteractiveEditorResponseFeedbackKind=We={}));var Nt;(function(Ce){function Me(ve,H){return"placeholder"in H&&"resolvedContent"in H?{placeholder:H.placeholder,kind:"asyncContent"}:"markdownContent"in H?((0,a.$MF)(ve,"chatAgents2Additions"),{content:N.from(H.markdownContent),kind:"content"}):"content"in H?typeof H.content=="string"?{content:H.content,kind:"content"}:((0,a.$MF)(ve,"chatAgents2Additions"),{content:N.from(H.content),kind:"content"}):"documents"in H?{documents:H.documents.map(Le=>({uri:Le.uri,version:Le.version,ranges:Le.ranges.map(je=>v.from(je))})),kind:"usedContext"}:"reference"in H?{reference:"uri"in H.reference?{uri:H.reference.uri,range:v.from(H.reference.range)}:H.reference,kind:"reference"}:"inlineReference"in H?{inlineReference:"uri"in H.inlineReference?{uri:H.inlineReference.uri,range:v.from(H.inlineReference.range)}:H.inlineReference,name:H.title,kind:"inlineReference"}:"agentName"in H?((0,a.$MF)(ve,"chatAgents2Additions"),{agentName:H.agentName,command:H.command,kind:"agentDetection"}):{treeData:H.treeData,kind:"treeData"}}Ce.from=Me})(Nt||(e.ChatResponseProgress=Nt={}));var Jt;(function(Ce){function Me(ve,H,Le){return"terminalCommand"in ve?{terminalCommand:ve.terminalCommand}:"uri"in ve?{uri:ve.uri}:H.toInternal(ve,Le)}Ce.from=Me})(Jt||(e.TerminalQuickFix=Jt={}))}),define(Pe[220],Re([1,0,2,11,7,8,186]),function(be,e,y,F,P,M,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sec=void 0;class ${constructor(f,C,D,u={timeout:1500,errors:3}){this.c=f,this.d=C,this.f=D,this.g=u,this.a=new A.$2c,this.b=new WeakMap}dispose(){this.a.clear()}getOnWillSaveTextDocumentEvent(f){return(C,D,u)=>{const p={dispose:this.a.push([C,D,f])};return Array.isArray(u)&&u.push(p),p}}async $participateInSave(f,C){const D=y.URI.revive(f);let u=!1;const b=setTimeout(()=>u=!0,this.g.timeout),p=[];try{for(const g of[...this.a]){if(u)break;const t=this.d.getDocument(D),i=await this.h(g,{document:t,reason:M.TextDocumentSaveReason.to(C)});p.push(i)}}finally{clearTimeout(b)}return p}h([f,C,D],u){const b=this.b.get(f);return typeof b=="number"&&b>this.g.errors?Promise.resolve(!1):this.i(D,f,C,u).then(()=>!0,p=>{if(this.c.error(`onWillSaveTextDocument-listener from extension '${D.identifier.value}' threw ERROR`),this.c.error(p),!(p instanceof Error)||p.message!=="concurrent_edits"){const g=this.b.get(f);this.b.set(f,g?g+1:1),typeof g=="number"&&g>this.g.errors&&this.c.info(`onWillSaveTextDocument-listener from extension '${D.identifier.value}' will now be IGNORED because of timeouts and/or errors`)}return!1})}i(f,C,D,u){const b=[],p=Date.now(),{document:g,reason:t}=u,{version:i}=g,r=Object.freeze({document:g,reason:t,waitUntil(c){if(Object.isFrozen(b))throw(0,F.$7)("waitUntil can not be called async");b.push(Promise.resolve(c))}});try{C.apply(D,[r])}catch(c){return Promise.reject(c)}return Object.freeze(b),new Promise((c,o)=>{const l=setTimeout(()=>o(new Error("timeout")),this.g.timeout);return Promise.all(b).then(n=>{this.c.debug(`onWillSaveTextDocument-listener from extension '${f.identifier.value}' finished after ${Date.now()-p}ms`),clearTimeout(l),c(n)}).catch(n=>{clearTimeout(l),o(n)})}).then(c=>{const o={edits:[]};for(const l of c)if(Array.isArray(l)&&l.every(n=>n instanceof P.$GK))for(const{newText:n,newEol:s,range:a}of l)o.edits.push({resource:g.uri,versionId:void 0,textEdit:{range:a&&M.Range.from(a),text:n,eol:s&&M.EndOfLine.from(s)}});if(o.edits.length!==0)return i===g.version?this.f.$tryApplyWorkspaceEdit(o):Promise.reject(new Error("concurrent_edits"))})}}e.$Sec=$}),define(Pe[221],Re([1,0,13,2,8,7,76]),function(be,e,y,F,P,M,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yec=e.$Xec=void 0;class ${constructor(D,u,b,p){this.start=D,this.deletedCount=u,this.deletedItems=b,this.items=p}asApiEvent(){return{range:new M.$WL(this.start,this.start+this.deletedCount),addedCells:this.items.map(D=>D.apiCell),removedCells:this.deletedItems}}}class E{static asModelAddData(D,u){return{EOL:u.eol,lines:u.source,languageId:u.language,uri:u.uri,isDirty:!1,versionId:1,notebook:D}}constructor(D,u,b){this.notebook=D,this.h=u,this.j=b,this.handle=b.handle,this.uri=F.URI.revive(b.uri),this.cellKind=b.cellKind,this.a=b.outputs.map(P.NotebookCellOutput.to),this.e=b.internalMetadata??{},this.b=Object.freeze(b.metadata??{}),this.d=Object.freeze(P.NotebookCellExecutionSummary.to(b.internalMetadata??{}))}get internalMetadata(){return this.e}get apiCell(){if(!this.f){const D=this,u=this.h.getDocument(this.uri);if(!u)throw new Error(`MISSING extHostDocument for notebook cell: ${this.uri}`);const b={get index(){return D.notebook.getCellIndex(D)},notebook:D.notebook.apiNotebook,kind:P.NotebookCellKind.to(this.j.cellKind),document:u.document,get mime(){return D.g},set mime(p){D.g=p},get outputs(){return D.a.slice(0)},get metadata(){return D.b},get executionSummary(){return D.d}};this.f=Object.freeze(b)}return this.f}setOutputs(D){this.a=D.map(P.NotebookCellOutput.to)}setOutputItems(D,u,b){const p=b.map(P.NotebookCellOutputItem.to),g=this.a.find(t=>t.id===D);if(g&&(u||(g.items.length=0),g.items.push(...p),g.items.length>1&&g.items.every(t=>A.$BI(t.mime)))){const t=new Map,i=[];g.items.forEach(r=>{let c;t.has(r.mime)?c=t.get(r.mime):(c=[],t.set(r.mime,c),i.push(r.mime)),c.push(r.data)}),g.items.length=0,i.forEach(r=>{const c=A.$CI(t.get(r));g.items.push({mime:r,data:c.data.buffer})})}}setMetadata(D){this.b=Object.freeze(D)}setInternalMetadata(D){this.e=D,this.d=Object.freeze(P.NotebookCellExecutionSummary.to(D))}setMime(D){}}e.$Xec=E;class f{static{this.a=0}constructor(D,u,b,p,g){this.k=D,this.l=u,this.m=b,this.uri=p,this.handle=f.a++,this.b=[],this.g=0,this.h=!1,this.j=!1,this.d=g.viewType,this.f=Object.freeze(g.metadata??Object.create(null)),this.r([[0,0,g.cells]],!0,void 0),this.g=g.versionId}dispose(){this.j=!0}get versionId(){return this.g}get apiNotebook(){if(!this.e){const D=this,u={get uri(){return D.uri},get version(){return D.g},get notebookType(){return D.d},get isDirty(){return D.h},get isUntitled(){return D.uri.scheme===y.Schemas.untitled},get isClosed(){return D.j},get metadata(){return D.f},get cellCount(){return D.b.length},cellAt(b){return b=D.n(b),D.b[b].apiCell},getCells(b){return(b?D.p(b):D.b).map(g=>g.apiCell)},save(){return D.q()}};this.e=Object.freeze(u)}return this.e}acceptDocumentPropertiesChanged(D){D.metadata&&(this.f=Object.freeze({...this.f,...D.metadata}))}acceptDirty(D){this.h=D}acceptModelChanged(D,u,b){this.g=D.versionId,this.h=u,this.acceptDocumentPropertiesChanged({metadata:b});const p={notebook:this.apiNotebook,metadata:b,cellChanges:[],contentChanges:[]},g=[];for(const i of D.rawEvents)i.kind===A.NotebookCellsChangeType.ModelChange?this.r(i.changes,!1,p.contentChanges):i.kind===A.NotebookCellsChangeType.Move?this.s(i.index,i.length,i.newIdx,p.contentChanges):i.kind===A.NotebookCellsChangeType.Output?(this.t(i.index,i.outputs),g.push({cell:this.b[i.index].apiCell,outputs:this.b[i.index].apiCell.outputs})):i.kind===A.NotebookCellsChangeType.OutputItem?(this.u(i.index,i.outputId,i.append,i.outputItems),g.push({cell:this.b[i.index].apiCell,outputs:this.b[i.index].apiCell.outputs})):i.kind===A.NotebookCellsChangeType.ChangeCellLanguage?(this.v(i.index,i.language),g.push({cell:this.b[i.index].apiCell,document:this.b[i.index].apiCell.document})):i.kind===A.NotebookCellsChangeType.ChangeCellContent?g.push({cell:this.b[i.index].apiCell,document:this.b[i.index].apiCell.document}):i.kind===A.NotebookCellsChangeType.ChangeCellMime?this.w(i.index,i.mime):i.kind===A.NotebookCellsChangeType.ChangeCellMetadata?(this.x(i.index,i.metadata),g.push({cell:this.b[i.index].apiCell,metadata:this.b[i.index].apiCell.metadata})):i.kind===A.NotebookCellsChangeType.ChangeCellInternalMetadata&&(this.y(i.index,i.internalMetadata),g.push({cell:this.b[i.index].apiCell,executionSummary:this.b[i.index].apiCell.executionSummary}));const t=new Map;for(let i=0;i<g.length;i++){const r=g[i],c=t.get(r.cell);if(c===void 0){const o=p.cellChanges.push({document:void 0,executionSummary:void 0,metadata:void 0,outputs:void 0,...r});t.set(r.cell,o-1)}else p.cellChanges[c]={...p.cellChanges[c],...r}}return Object.freeze(p),Object.freeze(p.cellChanges),Object.freeze(p.contentChanges),p}n(D){return D=D|0,D<0?0:D>=this.b.length?this.b.length-1:D}o(D){let u=D.start|0,b=D.end|0;return u<0&&(u=0),b>this.b.length&&(b=this.b.length),D.with({start:u,end:b})}p(D){D=this.o(D);const u=[];for(let b=D.start;b<D.end;b++)u.push(this.b[b]);return u}async q(){return this.j?Promise.reject(new Error("Notebook has been closed")):this.k.$trySaveNotebook(this.uri)}r(D,u,b){if(this.j)return;const p=[],g=[],t=[];if(D.reverse().forEach(i=>{const c=i[2].map(n=>{const s=new E(this,this.l,n);return u||g.push(E.asModelAddData(this.apiNotebook,n)),s}),o=new $(i[0],i[1],[],c),l=this.b.splice(i[0],i[1],...c);for(const n of l)t.push(n.uri),o.deletedItems.push(n.apiCell);p.push(o)}),this.l.acceptDocumentsAndEditorsDelta({addedDocuments:g,removedDocuments:t}),b)for(const i of p)b.push(i.asApiEvent())}s(D,u,b,p){const g=this.b.splice(D,u);this.b.splice(b,0,...g);const t=[new $(D,u,g.map(i=>i.apiCell),[]),new $(b,0,[],g)];for(const i of t)p.push(i.asApiEvent())}t(D,u){this.b[D].setOutputs(u)}u(D,u,b,p){this.b[D].setOutputItems(u,b,p)}v(D,u){const b=this.b[D];b.apiCell.document.languageId!==u&&this.m.$acceptModelLanguageChanged(b.uri,u)}w(D,u){const b=this.b[D];b.apiCell.mime=u}x(D,u){this.b[D].setMetadata(u)}y(D,u){this.b[D].setInternalMetadata(u)}getCellFromApiCell(D){return this.b.find(u=>u.apiCell===D)}getCellFromIndex(D){return this.b[D]}getCell(D){return this.b.find(u=>u.handle===D)}getCellIndex(D){return this.b.indexOf(D)}}e.$Yec=f}),define(Pe[222],Re([1,0,5,2,8,7]),function(be,e,y,F,P,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cfc=void 0;class A{constructor(E,f,C,D={timeout:1500,errors:3}){this.b=E,this.c=f,this.d=C,this.f=D,this.a=new y.$Td}dispose(){}getOnWillSaveNotebookDocumentEvent(E){return(f,C,D)=>{const u=function(p){f.call(C,p)};return u.extension=E,this.a.event(u,void 0,D)}}async $participateInSave(E,f,C){const D=F.URI.revive(E),u=this.c.getNotebookDocument(D);if(!u)throw new Error("Unable to resolve notebook document");const b=[];if(await this.a.fireAsync({notebook:u.apiNotebook,reason:P.TextDocumentSaveReason.to(f)},C,async(g,t)=>{const i=Date.now(),r=await await Promise.resolve(g);Date.now()-i>this.f.timeout&&this.b.warn("onWillSaveNotebookDocument-listener from extension",t.extension.identifier),!C.isCancellationRequested&&r&&(r instanceof M.$JK?b.push(r):this.b.warn("onWillSaveNotebookDocument-listener from extension",t.extension.identifier,"ignored due to invalid data"))}),C.isCancellationRequested)return!1;if(b.length===0)return!0;const p={edits:[]};for(const g of b){const{edits:t}=P.WorkspaceEdit.from(g);p.edits=p.edits.concat(t)}return this.d.$tryApplyWorkspaceEdit(p)}}e.$cfc=A}),define(Pe[107],Re([1,0,11,8,7]),function(be,e,y,F,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zec=void 0;class M{static{this.apiEditorsToExtHost=new WeakMap}constructor($,E,f,C,D,u){this.id=$,this.f=E,this.notebookData=f,this.a=[],this.b=[],this.d=!1,this.a=D,this.b=C,this.c=u}get apiEditor(){if(!this.e){const $=this;this.e={get notebook(){return $.notebookData.apiNotebook},get selection(){return $.a[0]},set selection(E){this.selections=[E]},get selections(){return $.a},set selections(E){if(!Array.isArray(E)||!E.every(P.$WL.isNotebookRange))throw(0,y.$6)("selections");$.a=E,$.g(E)},get visibleRanges(){return $.b},revealRange(E,f){$.f.$tryRevealRange($.id,F.NotebookRange.from(E),f??P.NotebookEditorRevealType.Default)},get viewColumn(){return $.c}},M.apiEditorsToExtHost.set(this.e,this)}return this.e}get visible(){return this.d}_acceptVisibility($){this.d=$}_acceptVisibleRanges($){this.b=$}_acceptSelections($){this.a=$}g($){this.f.$trySetSelections(this.id,$.map(F.NotebookRange.from))}_acceptViewColumn($){this.c=$}}e.$Zec=M}),define(Pe[223],Re([1,0,11,5,15,8]),function(be,e,y,F,P,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$efc=void 0;let A=class{constructor(E,f){this.c=E,this.d=f,this.a=new F.$Rd({onListenerError:y.$1}),this.b=new F.$Rd({onListenerError:y.$1}),this.onDidChangeNotebookEditorSelection=this.a.event,this.onDidChangeNotebookEditorVisibleRanges=this.b.event}$acceptEditorPropertiesChanged(E,f){this.c.debug("ExtHostNotebook#$acceptEditorPropertiesChanged",E,f);const C=this.d.getEditorById(E);f.visibleRanges&&C._acceptVisibleRanges(f.visibleRanges.ranges.map(M.NotebookRange.to)),f.selections&&C._acceptSelections(f.selections.selections.map(M.NotebookRange.to)),f.visibleRanges&&this.b.fire({notebookEditor:C.apiEditor,visibleRanges:C.apiEditor.visibleRanges}),f.selections&&this.a.fire(Object.freeze({notebookEditor:C.apiEditor,selections:C.apiEditor.selections}))}$acceptEditorViewColumns(E){for(const f in E)this.d.getEditorById(f)._acceptViewColumn(M.ViewColumn.to(E[f]))}};e.$efc=A,e.$efc=A=Ke([Ve(0,P.$dj)],A)}),define(Pe[224],Re([1,0,8,72,163,20,66,11]),function(be,e,y,F,P,M,A,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lfc=void 0;class E{constructor(u){this.b=0,this.c=new Map,this.a=u}async withProgress(u,b,p){const g=this.b++,{title:t,location:i,cancellable:r}=b,c={label:(0,P.localize)(0,null,u.displayName||u.name),id:u.identifier.value};return this.a.$startProgress(g,{location:y.ProgressLocation.from(i),title:t,source:c,cancellable:r},u.isUnderDevelopment?void 0:u.identifier.value).catch($.$1),this.d(g,p,!!r)}d(u,b,p){let g;p&&(g=new M.$2d,this.c.set(u,g));const t=r=>{this.a.$progressEnd(r),this.c.delete(r),g?.dispose()};let i;try{i=b(new C(this.a,u),p&&g?g.token:M.CancellationToken.None)}catch(r){throw t(u),r}return i.then(r=>t(u),r=>t(u)),i}$acceptProgressCanceled(u){const b=this.c.get(u);b&&(b.cancel(),this.c.delete(u))}}e.$lfc=E;function f(D,u){return D.message=u.message,typeof u.increment=="number"&&(typeof D.increment=="number"?D.increment+=u.increment:D.increment=u.increment),D}class C extends F.$$u{constructor(u,b){super(p=>this.throttledReport(p)),this.c=u,this.d=b}throttledReport(u){this.c.$progressReport(this.d,u)}}Ke([(0,A.$ph)(100,(D,u)=>f(D,u),()=>Object.create(null))],C.prototype,"throttledReport",null)}),define(Pe[108],Re([1,0,29,104,48,77,58,8,2]),function(be,e,y,F,P,M,A,$,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$OM=e.$NM=e.$MM=e.$LM=void 0;const f=(c,o,l,n)=>{let s=o;return{enumerable:!0,configurable:!1,get(){return s},set(a){if(!l(s,a)){const d=s;s=a,c.listener?.(n(a,d))}}}},C=(c,o)=>c===o,D={range:(c,o)=>c===o?!0:!c||!o?!1:c.isEqual(o),label:C,description:C,sortText:C,busy:C,error:C,canResolveChildren:C,tags:(c,o)=>!(c.length!==o.length||c.some(l=>!o.find(n=>l.id===n.id)))},u=c=>o=>({op:4,update:c(o)}),b=(c,o)=>({range:(()=>{let l;const n=u(s=>({range:y.$zs.lift($.Range.from(s))}));return{enumerable:!0,configurable:!1,get(){return l},set(s){c.listener?.({op:6}),D.range(l,s)||(l=s,c.listener?.(n(s)))}}})(),label:f(c,o,D.label,u(l=>({label:l}))),description:f(c,void 0,D.description,u(l=>({description:l}))),sortText:f(c,void 0,D.sortText,u(l=>({sortText:l}))),canResolveChildren:f(c,!1,D.canResolveChildren,l=>({op:2,state:l})),busy:f(c,!1,D.busy,u(l=>({busy:l}))),error:f(c,void 0,D.error,u(l=>({error:$.MarkdownString.fromStrict(l)||null}))),tags:f(c,[],D.tags,(l,n)=>({op:1,new:l.map($.TestTag.from),old:n.map($.TestTag.from)}))}),p=c=>{const o=P.$qJ.fromString(c.extId),l=new t(o.controllerId,o.localId,c.label,E.URI.revive(c.uri)||void 0);return l.range=$.Range.to(c.range||void 0),l.description=c.description||void 0,l.sortText=c.sortText||void 0,l.tags=c.tags.map(n=>$.TestTag.to({id:(0,A.$vJ)(n).tagId})),l},g=c=>{let o;for(const l of c.tests){const n=p(l.item);(0,F.$vM)(n).parent=o,o=n}return o};e.$LM=g;class t{constructor(o,l,n,s){if(l.includes("\0"))throw new Error(`Test IDs may not include the ${JSON.stringify(l)} symbol`);const a=(0,F.$uM)(this,o);Object.defineProperties(this,{id:{value:l,enumerable:!0,writable:!1},uri:{value:s,enumerable:!0,writable:!1},parent:{enumerable:!1,get(){return a.parent instanceof i?void 0:a.parent}},children:{value:(0,M.$tM)(a,F.$vM,t),enumerable:!0,writable:!1},...b(a,n)})}}e.$MM=t;class i extends t{constructor(o,l){super(o,o,l,void 0),this._isRoot=!0}}e.$NM=i;class r extends M.$pM{constructor(o,l,n){super({controllerId:o,getDocumentVersion:s=>s&&n.getDocument(s)?.version,getApiFor:F.$vM,getChildren:s=>s.children,root:new i(o,l),toITestItem:$.TestItem.from})}}e.$OM=r}),define(Pe[109],Re([1,0,53,11,89,8,7]),function(be,e,y,F,P,M,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$IM=e.$HM=e.$GM=void 0;class ${static{this.c=new P.$EM("TextEditorDecorationType")}constructor(u,b,p){const g=$.c.nextId();u.$registerTextEditorDecorationType(b.identifier,g,M.DecorationRenderOptions.from(p)),this.value=Object.freeze({key:g,dispose(){u.$removeTextEditorDecorationType(g)}})}}e.$GM=$;class E{constructor(u,b){this.g=[],this.h=void 0,this.j=!1,this.c=u,this.d=u.version,this.e=b.undoStopBefore,this.f=b.undoStopAfter}finalize(){return this.j=!0,{documentVersionId:this.d,edits:this.g,setEndOfLine:this.h,undoStopBefore:this.e,undoStopAfter:this.f}}k(){if(this.j)throw new Error("Edit is only valid while callback runs")}replace(u,b){this.k();let p=null;if(u instanceof A.$AK)p=new A.$BK(u,u);else if(u instanceof A.$BK)p=u;else throw new Error("Unrecognized location");this.l(p,b,!1)}insert(u,b){this.k(),this.l(new A.$BK(u,u),b,!0)}delete(u){this.k();let b=null;if(u instanceof A.$BK)b=u;else throw new Error("Unrecognized location");this.l(b,null,!0)}l(u,b,p){const g=this.c.validateRange(u);this.g.push({range:g,text:b,forceMoveMarkers:p})}setEndOfLine(u){if(this.k(),u!==A.EndOfLine.LF&&u!==A.EndOfLine.CRLF)throw(0,F.$6)("endOfLine");this.h=u}}class f{constructor(u,b,p,g){this.c=u,this.d=b,this._accept(p),this.e=g;const t=this;this.value={get tabSize(){return t.f},set tabSize(i){t.m(i)},get indentSize(){return t.g},set indentSize(i){t.o(i)},get insertSpaces(){return t.h},set insertSpaces(i){t.q(i)},get cursorStyle(){return t.j},set cursorStyle(i){t.s(i)},get lineNumbers(){return t.k},set lineNumbers(i){t.t(i)}}}_accept(u){this.f=u.tabSize,this.g=u.indentSize,this.h=u.insertSpaces,this.j=u.cursorStyle,this.k=M.TextEditorLineNumbersStyle.to(u.lineNumbers)}l(u){if(u==="auto")return"auto";if(typeof u=="number"){const b=Math.floor(u);return b>0?b:null}if(typeof u=="string"){const b=parseInt(u,10);return isNaN(b)?null:b>0?b:null}return null}m(u){const b=this.l(u);if(b!==null){if(typeof b=="number"){if(this.f===b)return;this.f=b}this.u("setTabSize",this.c.$trySetOptions(this.d,{tabSize:b}))}}n(u){if(u==="tabSize")return"tabSize";if(typeof u=="number"){const b=Math.floor(u);return b>0?b:null}if(typeof u=="string"){const b=parseInt(u,10);return isNaN(b)?null:b>0?b:null}return null}o(u){const b=this.n(u);if(b!==null){if(typeof b=="number"){if(this.g===b)return;this.g=b}this.u("setIndentSize",this.c.$trySetOptions(this.d,{indentSize:b}))}}p(u){return u==="auto"?"auto":u==="false"?!1:!!u}q(u){const b=this.p(u);if(typeof b=="boolean"){if(this.h===b)return;this.h=b}this.u("setInsertSpaces",this.c.$trySetOptions(this.d,{insertSpaces:b}))}s(u){this.j!==u&&(this.j=u,this.u("setCursorStyle",this.c.$trySetOptions(this.d,{cursorStyle:u})))}t(u){this.k!==u&&(this.k=u,this.u("setLineNumbers",this.c.$trySetOptions(this.d,{lineNumbers:M.TextEditorLineNumbersStyle.from(u)})))}assign(u){const b={};let p=!1;if(typeof u.tabSize<"u"){const g=this.l(u.tabSize);g==="auto"?(p=!0,b.tabSize=g):typeof g=="number"&&this.f!==g&&(this.f=g,p=!0,b.tabSize=g)}if(typeof u.indentSize<"u"){const g=this.n(u.indentSize);g==="tabSize"?(p=!0,b.indentSize=g):typeof g=="number"&&this.g!==g&&(this.g=g,p=!0,b.indentSize=g)}if(typeof u.insertSpaces<"u"){const g=this.p(u.insertSpaces);g==="auto"?(p=!0,b.insertSpaces=g):this.h!==g&&(this.h=g,p=!0,b.insertSpaces=g)}typeof u.cursorStyle<"u"&&this.j!==u.cursorStyle&&(this.j=u.cursorStyle,p=!0,b.cursorStyle=u.cursorStyle),typeof u.lineNumbers<"u"&&this.k!==u.lineNumbers&&(this.k=u.lineNumbers,p=!0,b.lineNumbers=M.TextEditorLineNumbersStyle.from(u.lineNumbers)),p&&this.u("setOptions",this.c.$trySetOptions(this.d,b))}u(u,b){b.catch(p=>{this.e.warn(`ExtHostTextEditorOptions '${u}' failed:'`),this.e.warn(p)})}}e.$HM=f;class C{constructor(u,b,p,g,t,i,r,c){this.id=u,this.j=b,this.k=p,this.g=!1,this.h=new Set,this.c=t,this.d=new f(this.j,this.id,i,p),this.e=r,this.f=c;const o=this;this.value=Object.freeze({get document(){return g.value},set document(l){throw new F.$8("document")},get selection(){return o.c&&o.c[0]},set selection(l){if(!(l instanceof A.$CK))throw(0,F.$6)("selection");o.c=[l],o.l()},get selections(){return o.c},set selections(l){if(!Array.isArray(l)||l.some(n=>!(n instanceof A.$CK)))throw(0,F.$6)("selections");o.c=l,o.l()},get visibleRanges(){return o.e},set visibleRanges(l){throw new F.$8("visibleRanges")},get options(){return o.d.value},set options(l){o.g||o.d.assign(l)},get viewColumn(){return o.f},set viewColumn(l){throw new F.$8("viewColumn")},edit(l,n={undoStopBefore:!0,undoStopAfter:!0}){if(o.g)return Promise.reject(new Error("TextEditor#edit not possible on closed editors"));const s=new E(g.value,n);return l(s),o.m(s)},insertSnippet(l,n,s={undoStopBefore:!0,undoStopAfter:!0}){if(o.g)return Promise.reject(new Error("TextEditor#insertSnippet not possible on closed editors"));let a;if(!n||Array.isArray(n)&&n.length===0)a=o.c.map(d=>M.Range.from(d));else if(n instanceof A.$AK){const{lineNumber:d,column:v}=M.Position.from(n);a=[{startLineNumber:d,startColumn:v,endLineNumber:d,endColumn:v}]}else if(n instanceof A.$BK)a=[M.Range.from(n)];else{a=[];for(const d of n)if(d instanceof A.$BK)a.push(M.Range.from(d));else{const{lineNumber:v,column:m}=M.Position.from(d);a.push({startLineNumber:v,startColumn:m,endLineNumber:v,endColumn:m})}}return b.$tryInsertSnippet(u,g.value.version,l.value,a,s)},setDecorations(l,n){const s=n.length===0;s&&!o.h.has(l.key)||(s?o.h.delete(l.key):o.h.add(l.key),o.n(()=>{if(M.$wM(n))return b.$trySetDecorations(u,l.key,M.$xM(n));{const a=new Array(4*n.length);for(let d=0,v=n.length;d<v;d++){const m=n[d];a[4*d]=m.start.line+1,a[4*d+1]=m.start.character+1,a[4*d+2]=m.end.line+1,a[4*d+3]=m.end.character+1}return b.$trySetDecorationsFast(u,l.key,a)}}))},revealRange(l,n){o.n(()=>b.$tryRevealRange(u,M.Range.from(l),n||A.TextEditorRevealType.Default))},show(l){b.$tryShowEditor(u,M.ViewColumn.from(l))},hide(){b.$tryHideEditor(u)}})}dispose(){(0,y.ok)(!this.g),this.g=!0}_acceptOptions(u){(0,y.ok)(!this.g),this.d._accept(u)}_acceptVisibleRanges(u){(0,y.ok)(!this.g),this.e=u}_acceptViewColumn(u){(0,y.ok)(!this.g),this.f=u}_acceptSelections(u){(0,y.ok)(!this.g),this.c=u}async l(){const u=this.c.map(M.Selection.from);return await this.n(()=>this.j.$trySetSelections(this.id,u)),this.value}m(u){const b=u.finalize();if(b.edits.length===0&&!b.setEndOfLine)return Promise.resolve(!0);const p=b.edits.map(t=>t.range);p.sort((t,i)=>t.end.line===i.end.line?t.end.character===i.end.character?t.start.line===i.start.line?t.start.character-i.start.character:t.start.line-i.start.line:t.end.character-i.end.character:t.end.line-i.end.line);for(let t=0,i=p.length-1;t<i;t++){const r=p[t].end;if(p[t+1].start.isBefore(r))return Promise.reject(new Error("Overlapping ranges are not allowed!"))}const g=b.edits.map(t=>({range:M.Range.from(t.range),text:t.text,forceMoveMarkers:t.forceMoveMarkers}));return this.j.$tryApplyEdits(this.id,b.documentVersionId,g,{setEndOfLine:typeof b.setEndOfLine=="number"?M.EndOfLine.from(b.setEndOfLine):void 0,undoStopBefore:b.undoStopBefore,undoStopAfter:b.undoStopAfter})}n(u){return this.g?(this.k.warn("TextEditor is closed/disposed"),Promise.resolve(void 0)):u().then(()=>this,b=>(b instanceof Error&&b.name==="DISPOSED"||this.k.warn(b),null))}}e.$IM=C}),define(Pe[225],Re([1,0,167,25,2,5,6,205,14,7,16,18,8,52,20,132,23]),function(be,e,y,F,P,M,A,$,E,f,C,D,u,b,p,g,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Efc=void 0;function i(o,l){if((0,C.$Cf)(o))return{label:o};if(o&&typeof o=="object"&&typeof o.label=="string"){let n;return Array.isArray(o.highlights)&&(n=o.highlights.filter(s=>s.length===2&&typeof s[0]=="number"&&typeof s[1]=="number"),n=n.length?n:void 0),{label:o.label,highlights:n}}}class r extends A.$Rc{constructor(l,n,s){super(),this.f=l,this.g=n,this.h=s,this.a=new Map,this.b=new g.$n8;function a(d){return d&&d.$treeViewId&&(d.$treeItemHandle||d.$selectedTreeItems||d.$focusedTreeItem)}n.registerArgumentProcessor({processArgument:d=>a(d)?this.r(d):Array.isArray(d)&&d.length>0?d.map(v=>a(v)?this.r(v):v):d})}registerTreeDataProvider(l,n,s){const a=this.createTreeView(l,{treeDataProvider:n},s);return{dispose:()=>a.dispose()}}createTreeView(l,n,s){if(!n||!n.treeDataProvider)throw new Error("Options with treeDataProvider is mandatory");const a=n.dragAndDropController?.dropMimeTypes??[],d=n.dragAndDropController?.dragMimeTypes??[],v=!!n.dragAndDropController?.handleDrag,m=!!n.dragAndDropController?.handleDrop,S=this.m(l,n,s),k={showCollapseAll:!!n.showCollapseAll,canSelectMany:!!n.canSelectMany,dropMimeTypes:a,dragMimeTypes:d,hasHandleDrag:v,hasHandleDrop:m,manuallyManageCheckboxes:!!n.manageCheckboxStateManually},h=this.f.$registerTreeViewDataProvider(l,k),w={get onDidCollapseElement(){return S.onDidCollapseElement},get onDidExpandElement(){return S.onDidExpandElement},get selection(){return S.selectedElements},get onDidChangeSelection(){return S.onDidChangeSelection},get activeItem(){return(0,t.$MF)(s,"treeViewActiveItem"),S.focusedElement},get onDidChangeActiveItem(){return(0,t.$MF)(s,"treeViewActiveItem"),S.onDidChangeActiveItem},get visible(){return S.visible},get onDidChangeVisibility(){return S.onDidChangeVisibility},get onDidChangeCheckboxState(){return S.onDidChangeCheckboxState},get message(){return S.message},set message(I){(0,b.$$j)(I)&&(0,t.$MF)(s,"treeViewMarkdownMessage"),S.message=I},get title(){return S.title},set title(I){S.title=I},get description(){return S.description},set description(I){S.description=I},get badge(){return S.badge},set badge(I){I!==void 0&&f.ViewBadge.isViewBadge(I)?S.badge={value:Math.floor(Math.abs(I.value)),tooltip:I.tooltip}:I===void 0&&(S.badge=void 0)},reveal:(I,L)=>S.reveal(I,L),dispose:async()=>{await h,this.a.delete(l),S.dispose()}};return this.B(w),w}$getChildren(l,n){const s=this.a.get(l);return s?s.getChildren(n):Promise.reject(new $.$JE(l))}async $handleDrop(l,n,s,a,d,v,m,S){const k=this.a.get(l);if(!k)return Promise.reject(new $.$JE(l));const h=u.DataTransfer.toDataTransfer(s,async w=>(await this.f.$resolveDropFileData(l,n,w)).buffer);return m===l&&S&&await this.j(h,k,S,d,v),k.onDrop(h,a,d)}async j(l,n,s,a,d){const v=this.b.removeDragOperationTransfer(d);if(v)(await v)?.forEach((m,S)=>{m&&l.set(S,m)});else if(d&&n.handleDrag){const m=n.handleDrag(s,l,a);this.b.addDragOperationTransfer(d,m),await m}return l}async $handleDrag(l,n,s,a){const d=this.a.get(l);if(!d)return Promise.reject(new $.$JE(l));const v=await this.j(new f.$qL,d,n,a,s);if(!(!v||a.isCancellationRequested))return u.DataTransfer.from(v)}async $hasResolve(l){const n=this.a.get(l);if(!n)throw new $.$JE(l);return n.hasResolve}$resolve(l,n,s){const a=this.a.get(l);if(!a)throw new $.$JE(l);return a.resolveTreeItem(n,s)}$setExpanded(l,n,s){const a=this.a.get(l);if(!a)throw new $.$JE(l);a.setExpanded(n,s)}$setSelectionAndFocus(l,n,s){const a=this.a.get(l);if(!a)throw new $.$JE(l);a.setSelectionAndFocus(n,s)}$setVisible(l,n){const s=this.a.get(l);if(!s){if(!n)return;throw new $.$JE(l)}s.setVisible(n)}$changeCheckboxState(l,n){const s=this.a.get(l);if(!s)throw new $.$JE(l);s.setCheckboxState(n)}m(l,n,s){const a=this.B(new c(l,n,this.f,this.g.converter,this.h,s));return this.a.set(l,a),a}r(l){const n=this.a.get(l.$treeViewId);return n&&"$treeItemHandle"in l?n.getExtensionElement(l.$treeItemHandle):n&&"$focusedTreeItem"in l&&l.$focusedTreeItem?n.focusedElement:null}}e.$Efc=r;class c extends A.$Rc{static{this.a="0"}static{this.b="1"}get visible(){return this.r}get selectedElements(){return this.s.map(l=>this.getExtensionElement(l)).filter(l=>!(0,C.$Lf)(l))}get focusedElement(){return this.t?this.getExtensionElement(this.t):void 0}constructor(l,n,s,a,d,v){if(super(),this.I=l,this.J=s,this.L=a,this.M=d,this.N=v,this.h=void 0,this.j=new Map,this.m=new Map,this.r=!1,this.s=[],this.t=void 0,this.u=this.B(new M.$Rd),this.onDidExpandElement=this.u.event,this.w=this.B(new M.$Rd),this.onDidCollapseElement=this.w.event,this.y=this.B(new M.$Rd),this.onDidChangeSelection=this.y.event,this.z=this.B(new M.$Rd),this.onDidChangeActiveItem=this.z.event,this.C=this.B(new M.$Rd),this.onDidChangeVisibility=this.C.event,this.D=this.B(new M.$Rd),this.onDidChangeCheckboxState=this.D.event,this.F=this.B(new M.$Rd),this.G=Promise.resolve(),this.H=Promise.resolve(),this.O="",this.P="",this.Z=new p.$2d,v.contributes&&v.contributes.views)for(const h in v.contributes.views)for(const w of v.contributes.views[h])w.id===l&&(this.P=w.name);this.f=n.treeDataProvider,this.g=n.dragAndDropController,this.f.onDidChangeTreeData&&this.B(this.f.onDidChangeTreeData(h=>this.F.fire({message:!1,element:h})));let m,S;const k=M.Event.debounce(this.F.event,(h,w)=>(h||(h={message:!1,elements:[]}),w.element!==!1&&(m||(m=new Promise(I=>S=I),this.G=this.G.then(()=>m)),Array.isArray(w.element)?h.elements.push(...w.element):h.elements.push(w.element)),w.message&&(h.message=!0),h),200,!0);this.B(k(({message:h,elements:w})=>{w.length&&(this.H=this.H.then(()=>{const I=S;return m=null,this.$(w).then(()=>I())})),h&&this.J.$setMessage(this.I,u.MarkdownString.fromStrict(this.O)??"")}))}async getChildren(l){const n=l?this.getExtensionElement(l):void 0;if(l&&!n)return this.M.error(`No tree item with id '${l}' found.`),Promise.resolve([]);let s=this.X(l);return s||(s=await this.Y(n)),s?s.map(a=>a.item):void 0}getExtensionElement(l){return this.j.get(l)}reveal(l,n){n=n||{select:!0,focus:!1};const s=(0,C.$Lf)(n.select)?!0:n.select,a=(0,C.$Lf)(n.focus)?!1:n.focus,d=(0,C.$Lf)(n.expand)?!1:n.expand;return typeof this.f.getParent!="function"?Promise.reject(new Error("Required registered TreeDataProvider to implement 'getParent' method to access 'reveal' method")):l?this.G.then(()=>this.S(l)).then(v=>this.W(l,v[v.length-1]).then(m=>this.J.$reveal(this.I,{item:m.item,parentChain:v.map(S=>S.item)},{select:s,focus:a,expand:d})),v=>this.M.error(v)):this.J.$reveal(this.I,void 0,{select:s,focus:a,expand:d})}get message(){return this.O}set message(l){this.O=l,this.F.fire({message:!0,element:!1})}get title(){return this.P}set title(l){this.P=l,this.J.$setTitle(this.I,l,this.Q)}get description(){return this.Q}set description(l){this.Q=l,this.J.$setTitle(this.I,this.P,l)}get badge(){return this.R}set badge(l){this.R?.value===l?.value&&this.R?.tooltip===l?.tooltip||(this.R=u.ViewBadge.from(l),this.J.$setBadge(this.I,l))}setExpanded(l,n){const s=this.getExtensionElement(l);s&&(n?this.u.fire(Object.freeze({element:s})):this.w.fire(Object.freeze({element:s})))}setSelectionAndFocus(l,n){const s=!(0,D.$tb)(this.s,l);this.s=l;const a=this.t!==n;this.t=n,s&&this.y.fire(Object.freeze({selection:this.selectedElements})),a&&this.z.fire(Object.freeze({activeItem:this.focusedElement}))}setVisible(l){l!==this.r&&(this.r=l,this.C.fire(Object.freeze({visible:this.r})))}async setCheckboxState(l){const n=(await Promise.all(l.map(async s=>{const a=this.getExtensionElement(s.treeItemHandle);return a?{extensionItem:a,treeItem:await this.f.getTreeItem(a),newState:s.newState?f.TreeItemCheckboxState.Checked:f.TreeItemCheckboxState.Unchecked}:Promise.resolve(void 0)}))).filter(s=>s!==void 0);n.forEach(s=>{s.treeItem.checkboxState=s.newState?f.TreeItemCheckboxState.Checked:f.TreeItemCheckboxState.Unchecked}),this.D.fire({items:n.map(s=>[s.extensionItem,s.newState])})}async handleDrag(l,n,s){const a=[];for(const d of l){const v=this.getExtensionElement(d);v&&a.push(v)}if(!(!this.g?.handleDrag||a.length===0))return await this.g.handleDrag(a,n,s),n}get hasHandleDrag(){return!!this.g?.handleDrag}async onDrop(l,n,s){const a=n?this.getExtensionElement(n):void 0;if(!(!a&&n||!this.g?.handleDrop))return(0,E.$Qg)(()=>this.g?.handleDrop?this.g.handleDrop(a,l,s):void 0)}get hasResolve(){return!!this.f.resolveTreeItem}async resolveTreeItem(l,n){if(!this.f.resolveTreeItem)return;const s=this.j.get(l);if(s){const a=this.m.get(s);if(a){const d=await this.f.resolveTreeItem(a.extensionItem,s,n)??a.extensionItem;return this.hb(d),a.item.tooltip=this.eb(d.tooltip),a.item.command=this.fb(a.disposableStore,d.command),a.item}}}S(l){return this.U(l).then(n=>n?this.S(n).then(s=>this.W(n,s[s.length-1]).then(a=>(s.push(a),s))):Promise.resolve([]))}U(l){const n=this.m.get(l);return n?Promise.resolve(n.parent?this.j.get(n.parent.item.handle):void 0):(0,E.$Qg)(()=>this.f.getParent(l))}W(l,n){const s=this.m.get(l);return s?Promise.resolve(s):(0,E.$Qg)(()=>this.f.getTreeItem(l)).then(a=>this.kb(l,a,n,!0)).then(a=>this.getChildren(n?n.item.handle:void 0).then(()=>{const d=this.getExtensionElement(a);if(d){const v=this.m.get(d);if(v)return Promise.resolve(v)}throw new Error(`Cannot resolve tree item for element ${a} from extension ${this.N.identifier.value}`)}))}X(l){if(l){let n;if(typeof l=="string"){const s=this.getExtensionElement(l);n=s?this.m.get(s):void 0}else n=l;return n&&n.children||void 0}return this.h}async Y(l){this.rb(l);const n=new p.$2d(this.Z.token);try{const s=l?this.m.get(l):void 0,a=await this.f.getChildren(l);if(n.token.isCancellationRequested)return;const d=await Promise.all((0,D.$Gb)(a||[]).map(async v=>{const m=await this.f.getTreeItem(v);return m&&!n.token.isCancellationRequested?this.db(v,m,s):null}));return n.token.isCancellationRequested?void 0:(0,D.$Gb)(d)}finally{n.dispose()}}$(l){if(l.some(s=>!s))return this.Z.dispose(!0),this.Z=new p.$2d,this.tb(),this.J.$refresh(this.I);{const s=this.ab(l);if(s.length)return this.bb(s)}return Promise.resolve(void 0)}ab(l){const n=new Set,s=l.map(d=>this.m.get(d));for(const d of s)if(d&&!n.has(d.item.handle)){let v=d;for(;v&&v.parent&&s.findIndex(m=>v&&v.parent&&m&&m.item.handle===v.parent.item.handle)===-1;){const m=this.j.get(v.parent.item.handle);v=m?this.m.get(m):void 0}v&&!v.parent&&n.add(d.item.handle)}const a=[];return n.forEach(d=>{const v=this.j.get(d);if(v){const m=this.m.get(v);m&&(!m.parent||!n.has(m.parent.item.handle))&&a.push(d)}}),a}bb(l){const n={};return Promise.all(l.map(s=>this.cb(s).then(a=>{a&&(n[s]=a.item)}))).then(()=>Object.keys(n).length?this.J.$refresh(this.I,n):void 0)}cb(l){const n=this.getExtensionElement(l);if(n){const s=this.m.get(n);if(s)return this.rb(n),(0,E.$Qg)(()=>this.f.getTreeItem(n)).then(a=>{if(a){const d=this.ib(n,a,s.parent);return this.pb(n,d,s,s.parent),s.dispose(),d}return null})}return Promise.resolve(null)}db(l,n,s){const a=this.ib(l,n,s);if(n.id&&this.j.has(a.item.handle))throw new Error((0,y.localize)(0,null,n.id));return this.ob(l,a),this.qb(a,s),a}eb(l){return f.$ZK.isMarkdownString(l)?u.MarkdownString.from(l):l}fb(l,n){return n?{...this.L.toInternal(n,l),originalId:n.command}:void 0}gb(l){if(l.checkboxState===void 0)return;let n,s,a;return typeof l.checkboxState=="number"?n=l.checkboxState:(n=l.checkboxState.state,s=l.checkboxState.tooltip,a=l.checkboxState.accessibilityInformation),{isChecked:n===f.TreeItemCheckboxState.Checked,tooltip:s,accessibilityInformation:a}}hb(l){if(!f.$lL.isTreeItem(l,this.N))throw new Error(`Extension ${this.N.identifier.value} has provided an invalid tree item.`)}ib(l,n,s){this.hb(n);const a=this.B(new A.$Qc),d=this.kb(l,n,s),v=this.lb(n);return{item:{handle:d,parentHandle:s?s.item.handle:void 0,label:i(n.label,this.N),description:n.description,resourceUri:n.resourceUri,tooltip:this.eb(n.tooltip),command:this.fb(a,n.command),contextValue:n.contextValue,icon:v,iconDark:this.mb(n)||v,themeIcon:this.jb(n),collapsibleState:(0,C.$Lf)(n.collapsibleState)?f.TreeItemCollapsibleState.None:n.collapsibleState,accessibilityInformation:n.accessibilityInformation,checkbox:this.gb(n)},extensionItem:n,parent:s,children:void 0,disposableStore:a,dispose(){a.dispose()}}}jb(l){return l.iconPath instanceof f.$tL?l.iconPath:void 0}kb(l,{id:n,label:s,resourceUri:a},d,v){if(n)return`${c.b}/${n}`;const m=i(s,this.N),S=d?d.item.handle:c.a;let k=m?m.label:a?(0,F.$wg)(a):"";k=k.indexOf("/")!==-1?k.replace("/","//"):k;const h=this.m.has(l)?this.m.get(l).item.handle:void 0,w=this.X(d)||[];let I,L=0;do{if(I=`${S}/${L}:${k}`,v||!this.j.has(I)||h===I)break;L++}while(L<=w.length);return I}lb(l){if(l.iconPath&&!(l.iconPath instanceof f.$tL))return typeof l.iconPath=="string"||P.URI.isUri(l.iconPath)?this.nb(l.iconPath):this.nb(l.iconPath.light)}mb(l){if(l.iconPath&&!(l.iconPath instanceof f.$tL)&&l.iconPath.dark)return this.nb(l.iconPath.dark)}nb(l){return P.URI.isUri(l)?l:P.URI.file(l)}ob(l,n){this.j.set(n.item.handle,l),this.m.set(l,n)}pb(l,n,s,a){this.j.delete(n.item.handle),this.m.delete(l),n.item.handle!==s.item.handle&&this.j.delete(s.item.handle),this.ob(l,n);const d=this.X(a)||[],v=d.filter(m=>m.item.handle===s.item.handle)[0];v&&d.splice(d.indexOf(v),1,n)}qb(l,n){n?(n.children||(n.children=[]),n.children.push(l)):(this.h||(this.h=[]),this.h.push(l))}rb(l){if(l){const n=this.m.get(l);if(n){if(n.children)for(const s of n.children){const a=this.j.get(s.item.handle);a&&this.sb(a)}n.children=void 0}}else this.tb()}sb(l){const n=this.m.get(l);if(n){if(n.children)for(const s of n.children){const a=this.j.get(s.item.handle);a&&this.sb(a)}this.m.delete(l),this.j.delete(n.item.handle),n.dispose()}}tb(){this.h=void 0,this.j.clear(),this.m.forEach(l=>l.dispose()),this.m.clear()}dispose(){super.dispose(),this.Z.dispose(),this.tb(),this.J.$disposeTree(this.I)}}}),define(Pe[226],Re([1,0]),function(be,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.allApiProposals=void 0,e.allApiProposals=Object.freeze({aiRelatedInformation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.aiRelatedInformation.d.ts",authGetSessions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authGetSessions.d.ts",authSession:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authSession.d.ts",canonicalUriProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.canonicalUriProvider.d.ts",chat:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chat.d.ts",chatAgents2:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatAgents2.d.ts",chatAgents2Additions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatAgents2Additions.d.ts",chatProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatProvider.d.ts",chatRequestAccess:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatRequestAccess.d.ts",chatTab:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatTab.d.ts",chatVariables:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatVariables.d.ts",codeActionAI:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codeActionAI.d.ts",codiconDecoration:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codiconDecoration.d.ts",commentsDraftState:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentsDraftState.d.ts",contribCommentEditorActionsMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentEditorActionsMenu.d.ts",contribCommentPeekContext:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentPeekContext.d.ts",contribCommentThreadAdditionalMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentThreadAdditionalMenu.d.ts",contribEditSessions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditSessions.d.ts",contribEditorContentMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditorContentMenu.d.ts",contribLabelFormatterWorkspaceTooltip:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribLabelFormatterWorkspaceTooltip.d.ts",contribMenuBarHome:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMenuBarHome.d.ts",contribMergeEditorMenus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMergeEditorMenus.d.ts",contribNotebookStaticPreloads:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribNotebookStaticPreloads.d.ts",contribRemoteHelp:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribRemoteHelp.d.ts",contribShareMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribShareMenu.d.ts",contribStatusBarItems:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribStatusBarItems.d.ts",contribViewsRemote:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsRemote.d.ts",contribViewsWelcome:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsWelcome.d.ts",createFileSystemWatcher:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.createFileSystemWatcher.d.ts",customEditorMove:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.customEditorMove.d.ts",debugFocus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.debugFocus.d.ts",defaultChatAgent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.defaultChatAgent.d.ts",diffCommand:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffCommand.d.ts",diffContentOptions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffContentOptions.d.ts",documentFiltersExclusive:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentFiltersExclusive.d.ts",documentPaste:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentPaste.d.ts",dropMetadata:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.dropMetadata.d.ts",editSessionIdentityProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editSessionIdentityProvider.d.ts",editorInsets:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editorInsets.d.ts",extensionRuntime:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionRuntime.d.ts",extensionsAny:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionsAny.d.ts",externalUriOpener:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.externalUriOpener.d.ts",fileComments:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileComments.d.ts",fileSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileSearchProvider.d.ts",findTextInFiles:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findTextInFiles.d.ts",fsChunks:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fsChunks.d.ts",handleIssueUri:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.handleIssueUri.d.ts",idToken:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.idToken.d.ts",inlineCompletionsAdditions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.inlineCompletionsAdditions.d.ts",interactive:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactive.d.ts",interactiveUserActions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactiveUserActions.d.ts",interactiveWindow:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactiveWindow.d.ts",ipc:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.ipc.d.ts",languageStatusText:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.languageStatusText.d.ts",mappedEditsProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.mappedEditsProvider.d.ts",notebookCellExecutionState:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookCellExecutionState.d.ts",notebookControllerAffinityHidden:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookControllerAffinityHidden.d.ts",notebookDeprecated:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookDeprecated.d.ts",notebookExecution:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookExecution.d.ts",notebookKernelSource:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookKernelSource.d.ts",notebookLiveShare:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookLiveShare.d.ts",notebookMessaging:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMessaging.d.ts",notebookMime:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMime.d.ts",portsAttributes:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.portsAttributes.d.ts",profileContentHandlers:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.profileContentHandlers.d.ts",quickDiffProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickDiffProvider.d.ts",quickPickItemTooltip:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickItemTooltip.d.ts",quickPickSortByLabel:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickSortByLabel.d.ts",readonlyMessage:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.readonlyMessage.d.ts",resolvers:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.resolvers.d.ts",saveEditor:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.saveEditor.d.ts",scmActionButton:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmActionButton.d.ts",scmHistoryProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmHistoryProvider.d.ts",scmInputBoxActionButton:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmInputBoxActionButton.d.ts",scmSelectedProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmSelectedProvider.d.ts",scmTextDocument:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmTextDocument.d.ts",scmValidation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmValidation.d.ts",shareProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.shareProvider.d.ts",showLocal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.showLocal.d.ts",speech:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.speech.d.ts",tabInputTextMerge:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tabInputTextMerge.d.ts",taskPresentationGroup:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.taskPresentationGroup.d.ts",telemetry:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.telemetry.d.ts",terminalDataWriteEvent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDataWriteEvent.d.ts",terminalDimensions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDimensions.d.ts",terminalExecuteCommandEvent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalExecuteCommandEvent.d.ts",terminalQuickFixProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalQuickFixProvider.d.ts",terminalSelection:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalSelection.d.ts",testCoverage:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testCoverage.d.ts",testObserver:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testObserver.d.ts",testingActiveProfile:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testingActiveProfile.d.ts",textSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.textSearchProvider.d.ts",timeline:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.timeline.d.ts",tokenInformation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tokenInformation.d.ts",treeViewActiveItem:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewActiveItem.d.ts",treeViewMarkdownMessage:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewMarkdownMessage.d.ts",treeViewReveal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewReveal.d.ts",tunnelFactory:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnelFactory.d.ts",tunnels:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnels.d.ts",windowActivity:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.windowActivity.d.ts",workspaceTrust:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.workspaceTrust.d.ts"})}),define(Pe[227],Re([1,0,179,11,31,96,73,30,22,226,189,101]),function(be,e,y,F,P,M,A,$,E,f,C,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$XF=e.$WF=e.$VF=e.$UF=e.$TF=e.$SF=void 0;const u=$.$mn.as(A.$nn.JSONContribution);class b{constructor(l,n,s){this.a=l,this.b=n,this.c=s}d(l,n){this.a({type:l,message:n,extensionId:this.b.identifier,extensionPointId:this.c})}error(l){this.d(P.default.Error,l)}warn(l){this.d(P.default.Warning,l)}info(l){this.d(P.default.Info,l)}}e.$SF=b;class p{static a(l){const n=new E.$am;for(let s=0,a=l.length;s<a;s++)n.add(l[s].description.identifier);return n}static compute(l,n){if(!l||!l.length)return new p(n,[]);if(!n||!n.length)return new p([],l);const s=this.a(l),a=this.a(n),d=n.filter(m=>!s.has(m.description.identifier)),v=l.filter(m=>!a.has(m.description.identifier));return new p(d,v)}constructor(l,n){this.added=l,this.removed=n}}e.$TF=p;class g{constructor(l,n){this.name=l,this.defaultExtensionKind=n,this.a=null,this.b=null,this.c=null}setHandler(l){if(this.a!==null)throw new Error("Handler already set!");this.a=l,this.d()}acceptUsers(l){this.c=p.compute(this.b,l),this.b=l,this.d()}d(){if(!(this.a===null||this.b===null||this.c===null))try{this.a(this.b,this.c)}catch(l){(0,F.$Z)(l)}}}e.$UF=g;const t={type:"string",enum:["ui","workspace"],enumDescriptions:[y.localize(0,null),y.localize(1,null)]},i="vscode://schemas/vscode-extensions";e.$VF={properties:{engines:{type:"object",description:y.localize(2,null),properties:{vscode:{type:"string",description:y.localize(3,null),default:"^1.22.0"}}},publisher:{description:y.localize(4,null),type:"string"},displayName:{description:y.localize(5,null),type:"string"},categories:{description:y.localize(6,null),type:"array",uniqueItems:!0,items:{oneOf:[{type:"string",enum:E.$$l},{type:"string",const:"Languages",deprecationMessage:y.localize(7,null)}]}},galleryBanner:{type:"object",description:y.localize(8,null),properties:{color:{description:y.localize(9,null),type:"string"},theme:{description:y.localize(10,null),type:"string",enum:["dark","light"]}}},contributes:{description:y.localize(11,null),type:"object",properties:{},default:{}},preview:{type:"boolean",description:y.localize(12,null)},enableProposedApi:{type:"boolean",deprecationMessage:y.localize(13,null)},enabledApiProposals:{markdownDescription:y.localize(14,null),type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(f.allApiProposals),markdownEnumDescriptions:Object.values(f.allApiProposals)}},api:{markdownDescription:y.localize(15,null),type:"string",enum:["none"],enumDescriptions:[y.localize(16,null)]},activationEvents:{description:y.localize(17,null),type:"array",items:{type:"string",defaultSnippets:[{label:"onWebviewPanel",description:y.localize(18,null),body:"onWebviewPanel:viewType"},{label:"onLanguage",description:y.localize(19,null),body:"onLanguage:${1:languageId}"},{label:"onCommand",description:y.localize(20,null),body:"onCommand:${2:commandId}"},{label:"onDebug",description:y.localize(21,null),body:"onDebug"},{label:"onDebugInitialConfigurations",description:y.localize(22,null),body:"onDebugInitialConfigurations"},{label:"onDebugDynamicConfigurations",description:y.localize(23,null),body:"onDebugDynamicConfigurations"},{label:"onDebugResolve",description:y.localize(24,null),body:"onDebugResolve:${6:type}"},{label:"onDebugAdapterProtocolTracker",description:y.localize(25,null),body:"onDebugAdapterProtocolTracker:${6:type}"},{label:"workspaceContains",description:y.localize(26,null),body:"workspaceContains:${4:filePattern}"},{label:"onStartupFinished",description:y.localize(27,null),body:"onStartupFinished"},{label:"onTaskType",description:y.localize(28,null),body:"onTaskType:${1:taskType}"},{label:"onFileSystem",description:y.localize(29,null),body:"onFileSystem:${1:scheme}"},{label:"onEditSession",description:y.localize(30,null),body:"onEditSession:${1:scheme}"},{label:"onSearch",description:y.localize(31,null),body:"onSearch:${7:scheme}"},{label:"onView",body:"onView:${5:viewId}",description:y.localize(32,null)},{label:"onUri",body:"onUri",description:y.localize(33,null)},{label:"onOpenExternalUri",body:"onOpenExternalUri",description:y.localize(34,null)},{label:"onCustomEditor",body:"onCustomEditor:${9:viewType}",description:y.localize(35,null)},{label:"onNotebook",body:"onNotebook:${1:type}",description:y.localize(36,null)},{label:"onAuthenticationRequest",body:"onAuthenticationRequest:${11:authenticationProviderId}",description:y.localize(37,null)},{label:"onRenderer",description:y.localize(38,null),body:"onRenderer:${11:rendererId}"},{label:"onTerminalProfile",body:"onTerminalProfile:${1:terminalId}",description:y.localize(39,null)},{label:"onTerminalQuickFixRequest",body:"onTerminalQuickFixRequest:${1:quickFixId}",description:y.localize(40,null)},{label:"onWalkthrough",body:"onWalkthrough:${1:walkthroughID}",description:y.localize(41,null)},{label:"onIssueReporterOpened",body:"onIssueReporterOpened",description:y.localize(42,null)},{label:"*",description:y.localize(43,null),body:"*"}]}},badges:{type:"array",description:y.localize(44,null),items:{type:"object",required:["url","href","description"],properties:{url:{type:"string",description:y.localize(45,null)},href:{type:"string",description:y.localize(46,null)},description:{type:"string",description:y.localize(47,null)}}}},markdown:{type:"string",description:y.localize(48,null),enum:["github","standard"],default:"github"},qna:{default:"marketplace",description:y.localize(49,null),anyOf:[{type:["string","boolean"],enum:["marketplace",!1]},{type:"string"}]},extensionDependencies:{description:y.localize(50,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:M.$4n}},extensionPack:{description:y.localize(51,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:M.$4n}},extensionKind:{description:y.localize(52,null),type:"array",items:t,default:["workspace"],defaultSnippets:[{body:["ui"],description:y.localize(53,null)},{body:["workspace"],description:y.localize(54,null)},{body:["ui","workspace"],description:y.localize(55,null)},{body:["workspace","ui"],description:y.localize(56,null)},{body:[],description:y.localize(57,null)}]},capabilities:{description:y.localize(58,null),type:"object",properties:{virtualWorkspaces:{description:y.localize(59,null),type:["boolean","object"],defaultSnippets:[{label:"limited",body:{supported:"${1:limited}",description:"${2}"}},{label:"false",body:{supported:!1,description:"${2}"}}],default:(!0).valueOf,properties:{supported:{markdownDescription:y.localize(60,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[y.localize(61,null),y.localize(62,null),y.localize(63,null)]},description:{type:"string",markdownDescription:y.localize(64,null)}}},untrustedWorkspaces:{description:y.localize(65,null),type:"object",required:["supported"],defaultSnippets:[{body:{supported:"${1:limited}",description:"${2}"}}],properties:{supported:{markdownDescription:y.localize(66,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[y.localize(67,null),y.localize(68,null),y.localize(69,null)]},restrictedConfigurations:{description:y.localize(70,null),type:"array",items:{type:"string"}},description:{type:"string",markdownDescription:y.localize(71,null)}}}}},sponsor:{description:y.localize(72,null),type:"object",defaultSnippets:[{body:{url:"${1:https:}"}}],properties:{url:{description:y.localize(73,null),type:"string"}}},scripts:{type:"object",properties:{"vscode:prepublish":{description:y.localize(74,null),type:"string"},"vscode:uninstall":{description:y.localize(75,null),type:"string"}}},icon:{type:"string",description:y.localize(76,null)},l10n:{type:"string",description:y.localize(77,null)},pricing:{type:"string",markdownDescription:y.localize(78,null),enum:["Free","Trial"],default:"Free"}}};class r{constructor(){this.a=new Map}registerExtensionPoint(l){if(this.a.has(l.extensionPoint))throw new Error("Duplicate extension point: "+l.extensionPoint);const n=new g(l.extensionPoint,l.defaultExtensionKind);return this.a.set(l.extensionPoint,n),l.activationEventsGenerator&&D.$xF.register(l.extensionPoint,l.activationEventsGenerator),e.$VF.properties.contributes.properties[l.extensionPoint]=l.jsonSchema,u.registerSchema(i,e.$VF),n}getExtensionPoints(){return Array.from(this.a.values())}}e.$WF=r;const c={ExtensionsRegistry:"ExtensionsRegistry"};$.$mn.add(c.ExtensionsRegistry,new r),e.$XF=$.$mn.as(c.ExtensionsRegistry),u.registerSchema(i,e.$VF),u.registerSchema(C.$wj,{properties:{extensionEnabledApiProposals:{description:y.localize(79,null),type:"object",properties:{},additionalProperties:{anyOf:[{type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(f.allApiProposals),markdownEnumDescriptions:Object.values(f.allApiProposals)}}]}}}})}),define(Pe[228],Re([1,0,175,16,26,227,34,5]),function(be,e,y,F,P,M,A,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7F=void 0;const E={type:"object",additionalProperties:!1,properties:{type:{type:"string",description:y.localize(0,null)},required:{type:"array",items:{type:"string"}},properties:{type:"object",description:y.localize(1,null),additionalProperties:{$ref:"http://json-schema.org/draft-07/schema#"}},when:{type:"string",markdownDescription:y.localize(2,null),default:""}}};var f;(function(u){function b(p,g,t){if(!p)return;const i=F.$Cf(p.type)?p.type:void 0;if(!i||i.length===0){t.error(y.localize(3,null));return}const r=[];if(Array.isArray(p.required))for(const c of p.required)F.$Cf(c)&&r.push(c);return{extensionId:g.value,taskType:i,required:r,properties:p.properties?P.$an(p.properties):{},when:p.when?A.$Ti.deserialize(p.when):void 0}}u.from=b})(f||(f={}));const C=M.$XF.registerExtensionPoint({extensionPoint:"taskDefinitions",activationEventsGenerator:(u,b)=>{for(const p of u)p.type&&b.push(`onTaskType:${p.type}`)},jsonSchema:{description:y.localize(4,null),type:"array",items:E}});class D{constructor(){this.d=new $.$Rd,this.onDefinitionsChanged=this.d.event,this.a=Object.create(null),this.b=new Promise((b,p)=>{C.setHandler((g,t)=>{this.c=void 0;try{for(const i of t.removed){const r=i.value;for(const c of r)this.a&&c.type&&this.a[c.type]&&delete this.a[c.type]}for(const i of t.added){const r=i.value;for(const c of r){const o=f.from(c,i.description.identifier,i.collector);o&&(this.a[o.taskType]=o)}}(t.removed.length>0||t.added.length>0)&&this.d.fire()}catch{}b(void 0)})})}onReady(){return this.b}get(b){return this.a[b]}all(){return Object.keys(this.a).map(b=>this.a[b])}getJsonSchema(){if(this.c===void 0){const b=[];for(const p of this.all()){const g={type:"object",additionalProperties:!1};p.required.length>0&&(g.required=p.required.slice(0)),p.properties!==void 0?g.properties=P.$an(p.properties):g.properties=Object.create(null),g.properties.type={type:"string",enum:[p.taskType]},b.push(g)}this.c={oneOf:b}}return this.c}}e.$7F=new D}),define(Pe[229],Re([1,0,176,16,25,26,34,228]),function(be,e,y,F,P,M,A,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TaskDefinition=e.TasksSchemaProperties=e.TaskSettingId=e.KeyedTaskIdentifier=e.TaskEvent=e.TaskRunSource=e.TaskRunType=e.TaskEventKind=e.$eG=e.JsonSchemaVersion=e.ExecutionEngine=e.$dG=e.$cG=e.$bG=e.$aG=e.$_F=e.RunOptions=e.RunOnOptions=e.DependsOrder=e.TaskSourceKind=e.TaskScope=e.TaskGroup=e.CommandString=e.RuntimeType=e.PresentationOptions=e.PanelKind=e.RevealProblemKind=e.RevealKind=e.CommandOptions=e.$$F=e.ShellQuoting=e.$0F=e.$9F=e.$8F=void 0,e.$8F="settings",e.$9F=new A.$aj("taskRunning",!1,y.localize(0,null)),e.$0F={value:y.localize(1,null),original:"Tasks"};var E;(function(T){T[T.Escape=1]="Escape",T[T.Strong=2]="Strong",T[T.Weak=3]="Weak"})(E||(e.ShellQuoting=E={})),e.$$F="$customized",function(T){function z(Z){if(!Z)return T.Strong;switch(Z.toLowerCase()){case"escape":return T.Escape;case"strong":return T.Strong;case"weak":return T.Weak;default:return T.Strong}}T.from=z}(E||(e.ShellQuoting=E={}));var f;(function(T){T.defaults={cwd:"${workspaceFolder}"}})(f||(e.CommandOptions=f={}));var C;(function(T){T[T.Always=1]="Always",T[T.Silent=2]="Silent",T[T.Never=3]="Never"})(C||(e.RevealKind=C={})),function(T){function z(Z){switch(Z.toLowerCase()){case"always":return T.Always;case"silent":return T.Silent;case"never":return T.Never;default:return T.Always}}T.fromString=z}(C||(e.RevealKind=C={}));var D;(function(T){T[T.Never=1]="Never",T[T.OnProblem=2]="OnProblem",T[T.Always=3]="Always"})(D||(e.RevealProblemKind=D={})),function(T){function z(Z){switch(Z.toLowerCase()){case"always":return T.Always;case"never":return T.Never;case"onproblem":return T.OnProblem;default:return T.OnProblem}}T.fromString=z}(D||(e.RevealProblemKind=D={}));var u;(function(T){T[T.Shared=1]="Shared",T[T.Dedicated=2]="Dedicated",T[T.New=3]="New"})(u||(e.PanelKind=u={})),function(T){function z(Z){switch(Z.toLowerCase()){case"shared":return T.Shared;case"dedicated":return T.Dedicated;case"new":return T.New;default:return T.Shared}}T.fromString=z}(u||(e.PanelKind=u={}));var b;(function(T){T.defaults={echo:!0,reveal:C.Always,revealProblems:D.Never,focus:!1,panel:u.Shared,showReuseMessage:!0,clear:!1}})(b||(e.PresentationOptions=b={}));var p;(function(T){T[T.Shell=1]="Shell",T[T.Process=2]="Process",T[T.CustomExecution=3]="CustomExecution"})(p||(e.RuntimeType=p={})),function(T){function z(he){switch(he.toLowerCase()){case"shell":return T.Shell;case"process":return T.Process;case"customExecution":return T.CustomExecution;default:return T.Process}}T.fromString=z;function Z(he){switch(he){case T.Shell:return"shell";case T.Process:return"process";case T.CustomExecution:return"customExecution";default:return"process"}}T.toString=Z}(p||(e.RuntimeType=p={}));var g;(function(T){function z(Z){return F.$Cf(Z)?Z:Z.value}T.value=z})(g||(e.CommandString=g={}));var t;(function(T){T.Clean={_id:"clean",isDefault:!1},T.Build={_id:"build",isDefault:!1},T.Rebuild={_id:"rebuild",isDefault:!1},T.Test={_id:"test",isDefault:!1};function z(he){return he===T.Clean._id||he===T.Build._id||he===T.Rebuild._id||he===T.Test._id}T.is=z;function Z(he){if(he!==void 0)return F.$Cf(he)?z(he)?{_id:he,isDefault:!1}:void 0:he}T.from=Z})(t||(e.TaskGroup=t={}));var i;(function(T){T[T.Global=1]="Global",T[T.Workspace=2]="Workspace",T[T.Folder=3]="Folder"})(i||(e.TaskScope=i={}));var r;(function(T){T.Workspace="workspace",T.Extension="extension",T.InMemory="inMemory",T.WorkspaceFile="workspaceFile",T.User="user";function z(Z){switch(Z){case T.User:return 2;case T.WorkspaceFile:return 5;default:return 6}}T.toConfigurationTarget=z})(r||(e.TaskSourceKind=r={}));var c;(function(T){T.parallel="parallel",T.sequence="sequence"})(c||(e.DependsOrder=c={}));var o;(function(T){T[T.default=1]="default",T[T.folderOpen=2]="folderOpen"})(o||(e.RunOnOptions=o={}));var l;(function(T){T.defaults={reevaluateOnRerun:!0,runOn:o.default,instanceLimit:1}})(l||(e.RunOptions=l={}));class n{constructor(z,Z,he,ye,De,Se){this._label="",this._id=z,Z&&(this._label=Z),he&&(this.type=he),this.runOptions=ye,this.configurationProperties=De,this._source=Se}getDefinition(z){}getMapKey(){return this._id}getKey(){}getCommonTaskId(){const z={folder:this.d(),id:this._id};return JSON.stringify(z)}clone(){return this.f(Object.assign({},this))}getWorkspaceFolder(){}getWorkspaceFileName(){}getTelemetryKind(){return"unknown"}matches(z,Z=!1){if(z===void 0)return!1;if(F.$Cf(z))return z===this._label||z===this.configurationProperties.identifier||Z&&z===this._id;const he=this.getDefinition(!0);return he!==void 0&&he._key===z._key}getQualifiedLabel(){const z=this.getWorkspaceFolder();return z?`${this._label} (${z.name})`:this._label}getTaskExecution(){return{id:this._id,task:this}}addTaskLoadMessages(z){this.c===void 0&&(this.c=[]),z&&(this.c=this.c.concat(z))}get taskLoadMessages(){return this.c}}e.$_F=n;class s extends n{constructor(z,Z,he,ye,De,Se,fe,$e){super(z,he,void 0,fe,$e,Z),this.command={},this._source=Z,this.hasDefinedMatchers=Se,De&&(this.command=De)}clone(){return new s(this._id,this._source,this._label,this.type,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}customizes(){if(this._source&&this._source.customizes)return this._source.customizes}getDefinition(z=!1){if(z&&this._source.customizes!==void 0)return this._source.customizes;{let Z;switch(this.command?this.command.runtime:void 0){case p.Shell:Z="shell";break;case p.Process:Z="process";break;case p.CustomExecution:Z="customExecution";break;case void 0:Z="$composite";break;default:throw new Error("Unexpected task runtime")}return{type:Z,_key:this._id,id:this._id}}}static is(z){return z instanceof s}getMapKey(){const z=this._source.config.workspaceFolder;return z?`${z.uri.toString()}|${this._id}|${this.instance}`:`${this._id}|${this.instance}`}d(){return this._source.kind===r.User?e.$8F:this._source.config.workspaceFolder?.uri.toString()}getCommonTaskId(){return this._source.customizes?super.getCommonTaskId():this.getKey()??super.getCommonTaskId()}getKey(){const z=this.d();if(!z)return;let Z=this.configurationProperties.identifier;this._source.kind!==r.Workspace&&(Z+=this._source.kind);const he={type:e.$$F,folder:z,id:Z};return JSON.stringify(he)}getWorkspaceFolder(){return this._source.config.workspaceFolder}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?P.$wg(this._source.config.workspace.configuration):void 0}getTelemetryKind(){return this._source.customizes?"workspace>extension":"workspace"}f(z){return new s(z._id,z._source,z._label,z.type,z.command,z.hasDefinedMatchers,z.runOptions,z.configurationProperties)}}e.$aG=s;class a extends n{constructor(z,Z,he,ye,De,Se,fe){super(z,he,ye,Se,fe,Z),this._source=Z,this.configures=De}static is(z){return z instanceof a}f(z){return z}getDefinition(){return this.configures}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?P.$wg(this._source.config.workspace.configuration):void 0}getWorkspaceFolder(){return this._source.config.workspaceFolder}d(){return this._source.kind===r.User?e.$8F:this._source.config.workspaceFolder?.uri.toString()}getKey(){const z=this.d();if(!z)return;let Z=this.configurationProperties.identifier;this._source.kind!==r.Workspace&&(Z+=this._source.kind);const he={type:e.$$F,folder:z,id:Z};return JSON.stringify(he)}}e.$bG=a;class d extends n{constructor(z,Z,he,ye,De,Se,fe,$e,re){super(z,he,ye,$e,re,Z),this.defines=De,this.hasDefinedMatchers=fe,this.command=Se,this.icon=re.icon,this.hide=re.hide}clone(){return new d(this._id,this._source,this._label,this.type,this.defines,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}getDefinition(){return this.defines}static is(z){return z instanceof d}getMapKey(){const z=this._source.workspaceFolder;return z?`${this._source.scope.toString()}|${z.uri.toString()}|${this._id}|${this.instance}`:`${this._source.scope.toString()}|${this._id}|${this.instance}`}d(){if(this._source.scope===3&&this._source.workspaceFolder)return this._source.workspaceFolder.uri.toString()}getKey(){const z={type:"contributed",scope:this._source.scope,id:this._id};return z.folder=this.d(),JSON.stringify(z)}getWorkspaceFolder(){return this._source.workspaceFolder}getTelemetryKind(){return"extension"}f(z){return new d(z._id,z._source,z._label,z.type,z.defines,z.command,z.hasDefinedMatchers,z.runOptions,z.configurationProperties)}}e.$cG=d;class v extends n{constructor(z,Z,he,ye,De,Se){super(z,he,ye,De,Se,Z),this._source=Z}clone(){return new v(this._id,this._source,this._label,this.type,this.runOptions,this.configurationProperties)}static is(z){return z instanceof v}getTelemetryKind(){return"composite"}getMapKey(){return`${this._id}|${this.instance}`}d(){}f(z){return new v(z._id,z._source,z._label,z.type,z.runOptions,z.configurationProperties)}}e.$dG=v;var m;(function(T){T[T.Process=1]="Process",T[T.Terminal=2]="Terminal"})(m||(e.ExecutionEngine=m={})),function(T){T._default=T.Terminal}(m||(e.ExecutionEngine=m={}));var S;(function(T){T[T.V0_1_0=1]="V0_1_0",T[T.V2_0_0=2]="V2_0_0"})(S||(e.JsonSchemaVersion=S={}));class k{constructor(z){this.c=new Map;for(let Z=0;Z<z.length;Z++)this.c.set(z[Z].uri.toString(),Z)}compare(z,Z){const he=z.getWorkspaceFolder(),ye=Z.getWorkspaceFolder();if(he&&ye){let De=this.c.get(he.uri.toString());De=De===void 0?0:De+1;let Se=this.c.get(ye.uri.toString());return Se=Se===void 0?0:Se+1,De===Se?z._label.localeCompare(Z._label):De-Se}else return!he&&ye?-1:he&&!ye?1:0}}e.$eG=k;var h;(function(T){T.DependsOnStarted="dependsOnStarted",T.AcquiredInput="acquiredInput",T.Start="start",T.ProcessStarted="processStarted",T.Active="active",T.Inactive="inactive",T.Changed="changed",T.Terminated="terminated",T.ProcessEnded="processEnded",T.End="end"})(h||(e.TaskEventKind=h={}));var w;(function(T){T.SingleRun="singleRun",T.Background="background"})(w||(e.TaskRunType=w={}));var I;(function(T){T[T.System=0]="System",T[T.User=1]="User",T[T.FolderOpen=2]="FolderOpen",T[T.ConfigurationChange=3]="ConfigurationChange",T[T.Reconnect=4]="Reconnect"})(I||(e.TaskRunSource=I={}));var L;(function(T){function z($e){return{taskId:$e._id,taskName:$e.configurationProperties.name,runType:$e.configurationProperties.isBackground?"background":"singleRun",group:$e.configurationProperties.group,__task:$e}}function Z($e,re,Ae){return{...z($e),kind:"start",terminalId:re,resolvedVariables:Ae}}T.start=Z;function he($e,re,Ae){return{...z($e),kind:"processStarted",terminalId:re,processId:Ae}}T.processStarted=he;function ye($e,re,Ae){return{...z($e),kind:"processEnded",terminalId:re,exitCode:Ae}}T.processEnded=ye;function De($e,re,Ae){return{...z($e),kind:"terminated",exitReason:Ae,terminalId:re}}T.terminated=De;function Se($e,re,Ae){return{...z(re),kind:$e,terminalId:Ae}}T.general=Se;function fe(){return{kind:"changed"}}T.changed=fe})(L||(e.TaskEvent=L={}));var V;(function(T){function z(he){const ye=Object.keys(he).sort();let De="";for(const Se of ye){let fe=he[Se];fe instanceof Object?fe=z(fe):typeof fe=="string"&&(fe=fe.replace(/,/g,",,")),De+=Se+","+fe+","}return De}function Z(he){const De={_key:z(he),type:he.taskType};return Object.assign(De,he),De}T.create=Z})(V||(e.KeyedTaskIdentifier=V={}));var K;(function(T){T.AutoDetect="task.autoDetect",T.SaveBeforeRun="task.saveBeforeRun",T.ShowDecorations="task.showDecorations",T.ProblemMatchersNeverPrompt="task.problemMatchers.neverPrompt",T.SlowProviderWarning="task.slowProviderWarning",T.QuickOpenHistory="task.quickOpen.history",T.QuickOpenDetail="task.quickOpen.detail",T.QuickOpenSkip="task.quickOpen.skip",T.QuickOpenShowAll="task.quickOpen.showAll",T.AllowAutomaticTasks="task.allowAutomaticTasks",T.Reconnection="task.reconnection",T.VerboseLogging="task.verboseLogging"})(K||(e.TaskSettingId=K={}));var R;(function(T){T.Tasks="tasks",T.SuppressTaskName="tasks.suppressTaskName",T.Windows="tasks.windows",T.Osx="tasks.osx",T.Linux="tasks.linux",T.ShowOutput="tasks.showOutput",T.IsShellCommand="tasks.isShellCommand",T.ServiceTestSetting="tasks.service.testSetting"})(R||(e.TasksSchemaProperties=R={}));var N;(function(T){function z(Z,he){const ye=$.$7F.get(Z.type);if(ye===void 0){const $e=M.$an(Z);return delete $e._key,V.create($e)}const De=Object.create(null);De.type=ye.taskType;const Se=new Set;ye.required.forEach($e=>Se.add($e));const fe=ye.properties;for(const $e of Object.keys(fe)){const re=Z[$e];if(re!=null)De[$e]=re;else if(Se.has($e)){const Ae=fe[$e];if(Ae.default!==void 0)De[$e]=M.$an(Ae.default);else switch(Ae.type){case"boolean":De[$e]=!1;break;case"number":case"integer":De[$e]=0;break;case"string":De[$e]="";break;default:he.error(y.localize(2,null,JSON.stringify(Z,void 0,0),$e));return}}}return V.create(De)}T.createTaskIdentifier=z})(N||(e.TaskDefinition=N={}))}),define(Pe[230],Re([1,0,11]),function(be,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Y5b=e.$X5b=void 0;class F{constructor(){this.a=null,this.b=null,this.d=null,this.f=!1,this.g=null,this.h=!1,this.i=null}get[Symbol.toStringTag](){return this.toString()}j(){return this.a||(this.a=new Promise((A,$)=>{this.b=A,this.d=$,this.f&&this.b(this.g),this.h&&this.d(this.i)})),this.a}resolveOk(A){this.f||this.h||(this.f=!0,this.g=A,this.a&&this.b(A))}resolveErr(A){this.f||this.h||(this.h=!0,this.i=A,this.a?this.d(A):(0,y.$Z)(A))}then(A,$){return this.j().then(A,$)}catch(A){return this.j().then(void 0,A)}finally(A){return this.j().finally(A)}}e.$X5b=F;class P extends F{constructor(){super(),this.h=!0,this.i=new y.$4}}e.$Y5b=P}),define(Pe[49],Re([1,0]),function(be,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wv=e.$vv=e.$uv=e.$tv=void 0;class y{static{this.count=0}constructor(E){this._proxyIdentifierBrand=void 0,this.sid=E,this.nid=++y.count}}e.$tv=y;const F=[];function P($){const E=new y($);return F[E.nid]=E,E}e.$uv=P;function M($){return F[$].sid}e.$vv=M;class A{constructor(E){this.value=E}}e.$wv=A}),define(Pe[3],Re([1,0,49]),function(be,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yK=e.$xK=e.ExtHostTestingResource=e.ISuggestResultDtoField=e.ISuggestDataDtoField=e.$wK=e.CandidatePortSource=e.NotebookEditorRevealType=e.CellOutputKind=e.WebviewMessageArrayBufferViewType=e.WebviewEditorCapabilities=e.TabModelOperationKind=e.TabInputKind=e.TextEditorRevealType=void 0;var F;(function(g){g[g.Default=0]="Default",g[g.InCenter=1]="InCenter",g[g.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",g[g.AtTop=3]="AtTop"})(F||(e.TextEditorRevealType=F={}));var P;(function(g){g[g.UnknownInput=0]="UnknownInput",g[g.TextInput=1]="TextInput",g[g.TextDiffInput=2]="TextDiffInput",g[g.TextMergeInput=3]="TextMergeInput",g[g.NotebookInput=4]="NotebookInput",g[g.NotebookDiffInput=5]="NotebookDiffInput",g[g.CustomEditorInput=6]="CustomEditorInput",g[g.WebviewEditorInput=7]="WebviewEditorInput",g[g.TerminalEditorInput=8]="TerminalEditorInput",g[g.InteractiveEditorInput=9]="InteractiveEditorInput",g[g.ChatEditorInput=10]="ChatEditorInput"})(P||(e.TabInputKind=P={}));var M;(function(g){g[g.TAB_OPEN=0]="TAB_OPEN",g[g.TAB_CLOSE=1]="TAB_CLOSE",g[g.TAB_UPDATE=2]="TAB_UPDATE",g[g.TAB_MOVE=3]="TAB_MOVE"})(M||(e.TabModelOperationKind=M={}));var A;(function(g){g[g.Editable=0]="Editable",g[g.SupportsHotExit=1]="SupportsHotExit"})(A||(e.WebviewEditorCapabilities=A={}));var $;(function(g){g[g.Int8Array=1]="Int8Array",g[g.Uint8Array=2]="Uint8Array",g[g.Uint8ClampedArray=3]="Uint8ClampedArray",g[g.Int16Array=4]="Int16Array",g[g.Uint16Array=5]="Uint16Array",g[g.Int32Array=6]="Int32Array",g[g.Uint32Array=7]="Uint32Array",g[g.Float32Array=8]="Float32Array",g[g.Float64Array=9]="Float64Array",g[g.BigInt64Array=10]="BigInt64Array",g[g.BigUint64Array=11]="BigUint64Array"})($||(e.WebviewMessageArrayBufferViewType=$={}));var E;(function(g){g[g.Text=1]="Text",g[g.Error=2]="Error",g[g.Rich=3]="Rich"})(E||(e.CellOutputKind=E={}));var f;(function(g){g[g.Default=0]="Default",g[g.InCenter=1]="InCenter",g[g.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",g[g.AtTop=3]="AtTop"})(f||(e.NotebookEditorRevealType=f={}));var C;(function(g){g[g.None=0]="None",g[g.Process=1]="Process",g[g.Output=2]="Output"})(C||(e.CandidatePortSource=C={}));class D{static{this.a=0}static mixin(t){return t._id=D.a++,t}}e.$wK=D;var u;(function(g){g.label="a",g.kind="b",g.detail="c",g.documentation="d",g.sortText="e",g.filterText="f",g.preselect="g",g.insertText="h",g.insertTextRules="i",g.range="j",g.commitCharacters="k",g.additionalTextEdits="l",g.kindModifier="m",g.commandIdent="n",g.commandId="o",g.commandArguments="p"})(u||(e.ISuggestDataDtoField=u={}));var b;(function(g){g.defaultRanges="a",g.completions="b",g.isIncomplete="c",g.duration="d"})(b||(e.ISuggestResultDtoField=b={}));var p;(function(g){g[g.Workspace=0]="Workspace",g[g.TextDocument=1]="TextDocument"})(p||(e.ExtHostTestingResource=p={})),e.$xK={MainThreadAuthentication:(0,y.$uv)("MainThreadAuthentication"),MainThreadBulkEdits:(0,y.$uv)("MainThreadBulkEdits"),MainThreadChatProvider:(0,y.$uv)("MainThreadChatProvider"),MainThreadChatAgents2:(0,y.$uv)("MainThreadChatAgents2"),MainThreadChatVariables:(0,y.$uv)("MainThreadChatVariables"),MainThreadClipboard:(0,y.$uv)("MainThreadClipboard"),MainThreadCommands:(0,y.$uv)("MainThreadCommands"),MainThreadComments:(0,y.$uv)("MainThreadComments"),MainThreadConfiguration:(0,y.$uv)("MainThreadConfiguration"),MainThreadConsole:(0,y.$uv)("MainThreadConsole"),MainThreadDebugService:(0,y.$uv)("MainThreadDebugService"),MainThreadDecorations:(0,y.$uv)("MainThreadDecorations"),MainThreadDiagnostics:(0,y.$uv)("MainThreadDiagnostics"),MainThreadDialogs:(0,y.$uv)("MainThreadDiaglogs"),MainThreadDocuments:(0,y.$uv)("MainThreadDocuments"),MainThreadDocumentContentProviders:(0,y.$uv)("MainThreadDocumentContentProviders"),MainThreadTextEditors:(0,y.$uv)("MainThreadTextEditors"),MainThreadEditorInsets:(0,y.$uv)("MainThreadEditorInsets"),MainThreadEditorTabs:(0,y.$uv)("MainThreadEditorTabs"),MainThreadErrors:(0,y.$uv)("MainThreadErrors"),MainThreadTreeViews:(0,y.$uv)("MainThreadTreeViews"),MainThreadDownloadService:(0,y.$uv)("MainThreadDownloadService"),MainThreadLanguageFeatures:(0,y.$uv)("MainThreadLanguageFeatures"),MainThreadLanguages:(0,y.$uv)("MainThreadLanguages"),MainThreadLogger:(0,y.$uv)("MainThreadLogger"),MainThreadMessageService:(0,y.$uv)("MainThreadMessageService"),MainThreadOutputService:(0,y.$uv)("MainThreadOutputService"),MainThreadProgress:(0,y.$uv)("MainThreadProgress"),MainThreadQuickDiff:(0,y.$uv)("MainThreadQuickDiff"),MainThreadQuickOpen:(0,y.$uv)("MainThreadQuickOpen"),MainThreadStatusBar:(0,y.$uv)("MainThreadStatusBar"),MainThreadSecretState:(0,y.$uv)("MainThreadSecretState"),MainThreadStorage:(0,y.$uv)("MainThreadStorage"),MainThreadSpeech:(0,y.$uv)("MainThreadSpeechProvider"),MainThreadTelemetry:(0,y.$uv)("MainThreadTelemetry"),MainThreadTerminalService:(0,y.$uv)("MainThreadTerminalService"),MainThreadWebviews:(0,y.$uv)("MainThreadWebviews"),MainThreadWebviewPanels:(0,y.$uv)("MainThreadWebviewPanels"),MainThreadWebviewViews:(0,y.$uv)("MainThreadWebviewViews"),MainThreadCustomEditors:(0,y.$uv)("MainThreadCustomEditors"),MainThreadUrls:(0,y.$uv)("MainThreadUrls"),MainThreadUriOpeners:(0,y.$uv)("MainThreadUriOpeners"),MainThreadProfileContentHandlers:(0,y.$uv)("MainThreadProfileContentHandlers"),MainThreadWorkspace:(0,y.$uv)("MainThreadWorkspace"),MainThreadFileSystem:(0,y.$uv)("MainThreadFileSystem"),MainThreadFileSystemEventService:(0,y.$uv)("MainThreadFileSystemEventService"),MainThreadExtensionService:(0,y.$uv)("MainThreadExtensionService"),MainThreadSCM:(0,y.$uv)("MainThreadSCM"),MainThreadSearch:(0,y.$uv)("MainThreadSearch"),MainThreadShare:(0,y.$uv)("MainThreadShare"),MainThreadTask:(0,y.$uv)("MainThreadTask"),MainThreadWindow:(0,y.$uv)("MainThreadWindow"),MainThreadLabelService:(0,y.$uv)("MainThreadLabelService"),MainThreadNotebook:(0,y.$uv)("MainThreadNotebook"),MainThreadNotebookDocuments:(0,y.$uv)("MainThreadNotebookDocumentsShape"),MainThreadNotebookEditors:(0,y.$uv)("MainThreadNotebookEditorsShape"),MainThreadNotebookKernels:(0,y.$uv)("MainThreadNotebookKernels"),MainThreadNotebookRenderers:(0,y.$uv)("MainThreadNotebookRenderers"),MainThreadInteractive:(0,y.$uv)("MainThreadInteractive"),MainThreadChat:(0,y.$uv)("MainThreadChat"),MainThreadInlineChat:(0,y.$uv)("MainThreadInlineChatShape"),MainThreadTheming:(0,y.$uv)("MainThreadTheming"),MainThreadTunnelService:(0,y.$uv)("MainThreadTunnelService"),MainThreadManagedSockets:(0,y.$uv)("MainThreadManagedSockets"),MainThreadTimeline:(0,y.$uv)("MainThreadTimeline"),MainThreadTesting:(0,y.$uv)("MainThreadTesting"),MainThreadLocalization:(0,y.$uv)("MainThreadLocalizationShape"),MainThreadAiRelatedInformation:(0,y.$uv)("MainThreadAiRelatedInformation"),MainThreadAiEmbeddingVector:(0,y.$uv)("MainThreadAiEmbeddingVector"),MainThreadIssueReporter:(0,y.$uv)("MainThreadIssueReporter")},e.$yK={ExtHostCommands:(0,y.$uv)("ExtHostCommands"),ExtHostConfiguration:(0,y.$uv)("ExtHostConfiguration"),ExtHostDiagnostics:(0,y.$uv)("ExtHostDiagnostics"),ExtHostDebugService:(0,y.$uv)("ExtHostDebugService"),ExtHostDecorations:(0,y.$uv)("ExtHostDecorations"),ExtHostDocumentsAndEditors:(0,y.$uv)("ExtHostDocumentsAndEditors"),ExtHostDocuments:(0,y.$uv)("ExtHostDocuments"),ExtHostDocumentContentProviders:(0,y.$uv)("ExtHostDocumentContentProviders"),ExtHostDocumentSaveParticipant:(0,y.$uv)("ExtHostDocumentSaveParticipant"),ExtHostEditors:(0,y.$uv)("ExtHostEditors"),ExtHostTreeViews:(0,y.$uv)("ExtHostTreeViews"),ExtHostFileSystem:(0,y.$uv)("ExtHostFileSystem"),ExtHostFileSystemInfo:(0,y.$uv)("ExtHostFileSystemInfo"),ExtHostFileSystemEventService:(0,y.$uv)("ExtHostFileSystemEventService"),ExtHostLanguages:(0,y.$uv)("ExtHostLanguages"),ExtHostLanguageFeatures:(0,y.$uv)("ExtHostLanguageFeatures"),ExtHostQuickOpen:(0,y.$uv)("ExtHostQuickOpen"),ExtHostQuickDiff:(0,y.$uv)("ExtHostQuickDiff"),ExtHostStatusBar:(0,y.$uv)("ExtHostStatusBar"),ExtHostShare:(0,y.$uv)("ExtHostShare"),ExtHostExtensionService:(0,y.$uv)("ExtHostExtensionService"),ExtHostLogLevelServiceShape:(0,y.$uv)("ExtHostLogLevelServiceShape"),ExtHostTerminalService:(0,y.$uv)("ExtHostTerminalService"),ExtHostSCM:(0,y.$uv)("ExtHostSCM"),ExtHostSearch:(0,y.$uv)("ExtHostSearch"),ExtHostTask:(0,y.$uv)("ExtHostTask"),ExtHostWorkspace:(0,y.$uv)("ExtHostWorkspace"),ExtHostWindow:(0,y.$uv)("ExtHostWindow"),ExtHostWebviews:(0,y.$uv)("ExtHostWebviews"),ExtHostWebviewPanels:(0,y.$uv)("ExtHostWebviewPanels"),ExtHostCustomEditors:(0,y.$uv)("ExtHostCustomEditors"),ExtHostWebviewViews:(0,y.$uv)("ExtHostWebviewViews"),ExtHostEditorInsets:(0,y.$uv)("ExtHostEditorInsets"),ExtHostEditorTabs:(0,y.$uv)("ExtHostEditorTabs"),ExtHostProgress:(0,y.$uv)("ExtHostProgress"),ExtHostComments:(0,y.$uv)("ExtHostComments"),ExtHostSecretState:(0,y.$uv)("ExtHostSecretState"),ExtHostStorage:(0,y.$uv)("ExtHostStorage"),ExtHostUrls:(0,y.$uv)("ExtHostUrls"),ExtHostUriOpeners:(0,y.$uv)("ExtHostUriOpeners"),ExtHostProfileContentHandlers:(0,y.$uv)("ExtHostProfileContentHandlers"),ExtHostOutputService:(0,y.$uv)("ExtHostOutputService"),ExtHosLabelService:(0,y.$uv)("ExtHostLabelService"),ExtHostNotebook:(0,y.$uv)("ExtHostNotebook"),ExtHostNotebookDocuments:(0,y.$uv)("ExtHostNotebookDocuments"),ExtHostNotebookEditors:(0,y.$uv)("ExtHostNotebookEditors"),ExtHostNotebookKernels:(0,y.$uv)("ExtHostNotebookKernels"),ExtHostNotebookRenderers:(0,y.$uv)("ExtHostNotebookRenderers"),ExtHostNotebookDocumentSaveParticipant:(0,y.$uv)("ExtHostNotebookDocumentSaveParticipant"),ExtHostInteractive:(0,y.$uv)("ExtHostInteractive"),ExtHostInlineChat:(0,y.$uv)("ExtHostInlineChatShape"),ExtHostChat:(0,y.$uv)("ExtHostChat"),ExtHostChatAgents2:(0,y.$uv)("ExtHostChatAgents"),ExtHostChatVariables:(0,y.$uv)("ExtHostChatVariables"),ExtHostChatProvider:(0,y.$uv)("ExtHostChatProvider"),ExtHostSpeech:(0,y.$uv)("ExtHostSpeech"),ExtHostAiRelatedInformation:(0,y.$uv)("ExtHostAiRelatedInformation"),ExtHostAiEmbeddingVector:(0,y.$uv)("ExtHostAiEmbeddingVector"),ExtHostTheming:(0,y.$uv)("ExtHostTheming"),ExtHostTunnelService:(0,y.$uv)("ExtHostTunnelService"),ExtHostManagedSockets:(0,y.$uv)("ExtHostManagedSockets"),ExtHostAuthentication:(0,y.$uv)("ExtHostAuthentication"),ExtHostTimeline:(0,y.$uv)("ExtHostTimeline"),ExtHostTesting:(0,y.$uv)("ExtHostTesting"),ExtHostTelemetry:(0,y.$uv)("ExtHostTelemetry"),ExtHostLocalization:(0,y.$uv)("ExtHostLocalization"),ExtHostIssueReporter:(0,y.$uv)("ExtHostIssueReporter")}}),define(Pe[231],Re([1,0,3,7]),function(be,e,y,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Edc=void 0;class P{constructor(A){this.a=new Map,this.b=0,this.c=A.getProxy(y.$xK.MainThreadAiRelatedInformation)}async $provideAiRelatedInformation(A,$,E){if(this.a.size===0)throw new Error("No related information providers registered");const f=this.a.get(A);if(!f)throw new Error("related information provider not found");return await f.provideRelatedInformation($,E)??[]}getRelatedInformation(A,$,E){return this.c.$getAiRelatedInformation($,E)}registerRelatedInformationProvider(A,$,E){const f=this.b;return this.b++,this.a.set(f,E),this.c.$registerAiRelatedInformationProvider(f,$),new F.$zK(()=>{this.c.$unregisterAiRelatedInformationProvider(f),this.a.delete(f)})}}e.$Edc=P}),define(Pe[81],Re([1,0,4,15,3,17]),function(be,e,y,F,P,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mdc=e.$Ldc=e.$Kdc=void 0,e.$Kdc=(0,y.$Vh)("IExtHostApiDeprecationService");let A=class{constructor(E,f){this.c=f,this.a=new Set,this.b=E.getProxy(P.$xK.MainThreadTelemetry)}report(E,f,C){const D=this.d(E,f);this.a.has(D)||(this.a.add(D),f.isUnderDevelopment&&this.c.warn(`[Deprecation Warning] '${E}' is deprecated. ${C}`),this.b.$publicLog2("extHostDeprecatedApiUsage",{extensionId:f.identifier.value,apiId:E}))}d(E,f){return`${E}-${f.identifier.value}`}};e.$Ldc=A,e.$Ldc=A=Ke([Ve(0,M.$zM),Ve(1,F.$dj)],A),e.$Mdc=Object.freeze(new class{report($,E,f){}})}),define(Pe[232],Re([1,0,5,3,7,22]),function(be,e,y,F,P,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pdc=void 0;class A{constructor(f){this.b=new Map,this.c=[],this.d=new y.$Rd,this.onDidChangeSessions=this.d.event,this.f=new $,this.g=new $,this.a=f.getProxy(F.$xK.MainThreadAuthentication)}$setProviders(f){return this.c=f,Promise.resolve()}async getSession(f,C,D,u={}){const b=M.$_l.toKey(f.identifier),p=[...D].sort().join(" ");return await this.f.getOrCreate(`${b} ${C} ${p}`,async()=>{await this.a.$ensureProvider(C);const g=f.displayName||f.name;return this.a.$getSession(C,D,b,g,u)})}async getSessions(f,C,D){const u=M.$_l.toKey(f.identifier),b=[...D].sort().join(" ");return await this.g.getOrCreate(`${u} ${b}`,async()=>{await this.a.$ensureProvider(C);const p=f.displayName||f.name;return this.a.$getSessions(C,D,u,p)})}async removeSession(f,C){const D=this.b.get(f);return D?D.provider.removeSession(C):this.a.$removeSession(f,C)}registerAuthenticationProvider(f,C,D,u){if(this.b.get(f))throw new Error(`An authentication provider with id '${f}' is already registered.`);this.b.set(f,{label:C,provider:D,options:u??{supportsMultipleAccounts:!1}}),this.c.find(p=>p.id===f)||this.c.push({id:f,label:C});const b=D.onDidChangeSessions(p=>{this.a.$sendDidChangeSessions(f,{added:p.added??[],changed:p.changed??[],removed:p.removed??[]})});return this.a.$registerAuthenticationProvider(f,C,u?.supportsMultipleAccounts??!1),new P.$zK(()=>{b.dispose(),this.b.delete(f);const p=this.c.findIndex(g=>g.id===f);p>-1&&this.c.splice(p),this.a.$unregisterAuthenticationProvider(f)})}$createSession(f,C,D){const u=this.b.get(f);if(u)return Promise.resolve(u.provider.createSession(C,D));throw new Error(`Unable to find authentication provider with handle: ${f}`)}$removeSession(f,C){const D=this.b.get(f);if(D)return Promise.resolve(D.provider.removeSession(C));throw new Error(`Unable to find authentication provider with handle: ${f}`)}$getSessions(f,C){const D=this.b.get(f);if(D)return Promise.resolve(D.provider.getSessions(C));throw new Error(`Unable to find authentication provider with handle: ${f}`)}$onDidChangeAuthenticationSessions(f,C){return this.d.fire({provider:{id:f,label:C}}),Promise.resolve()}}e.$Pdc=A;class ${constructor(){this.a=new Map}getOrCreate(f,C){const D=this.a.get(f);if(D)return D;const u=C().finally(()=>this.a.delete(f));return this.a.set(f,u),u}}}),define(Pe[233],Re([1,0,3,17,8]),function(be,e,y,F,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qdc=void 0;let M=class{constructor($,E){this.a=$.getProxy(y.$xK.MainThreadBulkEdits),this.b={getTextDocumentVersion:f=>E.getDocument(f)?.version,getNotebookDocumentVersion:()=>{}}}applyWorkspaceEdit($,E,f){const C=P.WorkspaceEdit.from($,this.b);return this.a.$tryApplyWorkspaceEdit(C,void 0,f?.isRefactoring??!1)}};e.$Qdc=M,e.$Qdc=M=Ke([Ve(0,F.$zM)],M)}),define(Pe[234],Re([1,0,5,67,6,3,8]),function(be,e,y,F,P,M,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rdc=void 0;class ${static{this.a=0}constructor(C,D){this.extension=C,this.provider=D,this.handle=$.a++}}class E{static{this.a=0}constructor(C){this.b=new Map,this.c=new Map,this.d=new y.$Rd,this.onDidPerformUserAction=this.d.event,this.e=C.getProxy(M.$xK.MainThreadChat)}registerChatProvider(C,D,u){const b=new $(C,u);return this.b.set(b.handle,b),this.e.$registerChatProvider(b.handle,D),(0,P.$Pc)(()=>{this.e.$unregisterChatProvider(b.handle),this.b.delete(b.handle)})}transferChatSession(C,D){const u=F.Iterable.find(this.c.keys(),b=>this.c.get(b)===C)??0;typeof u=="number"&&this.e.$transferChatSession(u,D)}sendInteractiveRequestToProvider(C,D){this.e.$sendRequestToProvider(C,D)}async $prepareChat(C,D){const u=this.b.get(C);if(!u)return;const b=await u.provider.prepareSession(D);if(!b)return;const p=E.a++;return this.c.set(p,b),{id:p,requesterUsername:b.requester?.name,requesterAvatarIconUri:b.requester?.icon,responderUsername:b.responder?.name,responderAvatarIconUri:b.responder?.icon,inputPlaceholder:b.inputPlaceholder}}async $provideWelcomeMessage(C,D){const u=this.b.get(C);if(!u||!u.provider.provideWelcomeMessage)return;const b=await u.provider.provideWelcomeMessage(D);if(b)return b.map(p=>typeof p=="string"?p:Array.isArray(p)?p.map(g=>A.ChatReplyFollowup.from(g)):A.MarkdownString.from(p))}async $provideSampleQuestions(C,D){const u=this.b.get(C);if(!u||!u.provider.provideSampleQuestions)return;const b=await u.provider.provideSampleQuestions(D);if(b)return b?.map(p=>A.ChatReplyFollowup.from(p))}$releaseSession(C){this.c.delete(C)}async $onDidPerformUserAction(C){this.d.fire(C)}}e.$Rdc=E}),define(Pe[235],Re([1,0,14,20,39,5,60,16,2,157,72,3,8,7,206,23]),function(be,e,y,F,P,M,A,$,E,f,C,D,u,b,p,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tdc=void 0;class t{static{this.a=0}constructor(c,o,l){this.i=o,this.j=l,this.b=new Map,this.g=new Map,this.h=new Map,this.d=c.getProxy(D.$xK.MainThreadChatAgents2)}createChatAgent(c,o,l){const n=t.a++,s=new i(c,o,this.d,n,l);return this.b.set(n,s),this.d.$registerAgent(n,o,{}),s.apiAgent}async $invokeAgent(c,o,l,n,s,a){this.g.delete(o);const d=this.b.get(c);if(!d)throw new Error(`[CHAT](${c}) CANNOT invoke agent because the agent is not registered`);let v=!1;function m(){if(v)throw new Error("Only valid while executing the command")}const S=new y.$ih;a.onCancellationRequested(()=>S.complete()),setTimeout(()=>S.complete(),10*1e3),this.i.allowListExtensionWhile(d.extension.identifier,S.p);const k=n.command?await d.validateSlashCommand(n.command):void 0,h=A.$Nd.create(!1);let w;try{const I=d.invoke({prompt:n.message,variables:u.ChatVariable.objectTo(n.variables),slashCommand:k},{history:s.history.map(u.ChatMessage.to)},new C.$$u(L=>{m(),typeof w>"u"&&"content"in L&&(w=h.elapsed());const V=u.ChatResponseProgress.from(d.extension,L);if("placeholder"in L&&"resolvedContent"in L){const K=Promise.all([this.d.$handleProgressChunk(l,V),L.resolvedContent]);(0,y.$Mg)(K,a).then(R=>{if(!R)return;const[N,T]=R,z=u.ChatResponseProgress.from(d.extension,T);this.d.$handleProgressChunk(l,z,N??void 0)})}else this.d.$handleProgressChunk(l,V)}),a);return await(0,y.$Mg)(Promise.resolve(I).then(L=>{if(L){this.g.set(o,L);let V=this.h.get(o);V||(V=new Map,this.h.set(o,V)),V.set(l,L);const K={firstProgress:w,totalElapsed:h.elapsed()};return{errorDetails:L.errorDetails,timings:K}}else this.g.delete(o)}),a)}catch(I){return this.j.error(I,d.extension),{errorDetails:{message:(0,f.localize)(0,null,(0,P.$Gi)(I)),responseIsIncomplete:!0}}}finally{v=!0,S.complete()}}$releaseSession(c){this.g.delete(c),this.h.delete(c)}async $provideSlashCommands(c,o){const l=this.b.get(c);return l?l.provideSlashCommand(o):[]}$provideFollowups(c,o,l){const n=this.b.get(c);if(!n)return Promise.resolve([]);const s=this.g.get(o);return s?n.provideFollowups(s,l):Promise.resolve([])}$acceptFeedback(c,o,l,n){const s=this.b.get(c);if(!s)return;const a=this.h.get(o)?.get(l);if(!a)return;let d;switch(n){case p.InteractiveSessionVoteDirection.Down:d=b.ChatAgentResultFeedbackKind.Unhelpful;break;case p.InteractiveSessionVoteDirection.Up:d=b.ChatAgentResultFeedbackKind.Helpful;break}s.acceptFeedback(Object.freeze({result:a,kind:d}))}$acceptAction(c,o,l,n){const s=this.b.get(c);if(!s)return;const a=this.h.get(o)?.get(l);a&&n.action.kind!=="vote"&&s.acceptAction(Object.freeze({action:n.action,result:a}))}}e.$Tdc=t;class i{constructor(c,o,l,n,s){this.extension=c,this.r=o,this.s=l,this.t=n,this.u=s,this.o=new M.$Rd,this.q=new M.$Rd}acceptFeedback(c){this.o.fire(c)}acceptAction(c){this.q.fire(c)}async validateSlashCommand(c){this.b||(await this.provideSlashCommand(F.CancellationToken.None),(0,$.$Mf)(this.b));const o=this.b.find(l=>l.name===c);if(!o)throw new Error(`Unknown slashCommand: ${c}`);return o}async provideSlashCommand(c){if(!this.a)return[];const o=await this.a.provideSlashCommands(c);return o?(this.b=o,o.map(l=>({name:l.name,description:l.description,followupPlaceholder:l.followupPlaceholder,shouldRepopulate:l.shouldRepopulate,sampleRequest:l.sampleRequest}))):[]}async provideFollowups(c,o){if(!this.d)return[];const l=await this.d.provideFollowups(c,o);return l?l.map(n=>u.ChatFollowup.from(n)):[]}get apiAgent(){let c=!1,o=!1;const l=()=>{c||o||(o=!0,queueMicrotask(()=>{this.s.$updateAgent(this.t,{description:this.g??"",fullName:this.h,icon:this.i?this.i instanceof E.URI?this.i:"light"in this.i?this.i.light:void 0:void 0,iconDark:this.i&&"dark"in this.i?this.i.dark:void 0,themeIcon:this.i instanceof b.$tL?this.i:void 0,hasSlashCommands:this.a!==void 0,hasFollowups:this.d!==void 0,isDefault:this.j,isSecondary:this.n,helpTextPrefix:!this.k||typeof this.k=="string"?this.k:u.MarkdownString.from(this.k),helpTextPostfix:!this.l||typeof this.l=="string"?this.l:u.MarkdownString.from(this.l),sampleRequest:this.m}),o=!1}))},n=this;return{get name(){return n.r},get description(){return n.g??""},set description(s){n.g=s,l()},get fullName(){return n.h??n.extension.displayName??n.extension.name},set fullName(s){n.h=s,l()},get iconPath(){return n.i},set iconPath(s){n.i=s,l()},get slashCommandProvider(){return n.a},set slashCommandProvider(s){n.a=s,l()},get followupProvider(){return n.d},set followupProvider(s){n.d=s,l()},get isDefault(){return(0,g.$MF)(n.extension,"defaultChatAgent"),n.j},set isDefault(s){(0,g.$MF)(n.extension,"defaultChatAgent"),n.j=s,l()},get helpTextPrefix(){return(0,g.$MF)(n.extension,"defaultChatAgent"),n.k},set helpTextPrefix(s){if((0,g.$MF)(n.extension,"defaultChatAgent"),!n.j)throw new Error("helpTextPrefix is only available on the default chat agent");n.k=s,l()},get helpTextPostfix(){return(0,g.$MF)(n.extension,"defaultChatAgent"),n.l},set helpTextPostfix(s){if((0,g.$MF)(n.extension,"defaultChatAgent"),!n.j)throw new Error("helpTextPostfix is only available on the default chat agent");n.l=s,l()},get isSecondary(){return(0,g.$MF)(n.extension,"defaultChatAgent"),n.n},set isSecondary(s){(0,g.$MF)(n.extension,"defaultChatAgent"),n.n=s,l()},get sampleRequest(){return n.m},set sampleRequest(s){n.m=s,l()},get onDidReceiveFeedback(){return n.o.event},onDidPerformAction:(0,g.$LF)(this.extension,"chatAgents2Additions")?this.q.event:void 0,dispose(){c=!0,n.a=void 0,n.d=void 0,n.o.dispose(),n.s.$unregisterAgent(n.t)}}}invoke(c,o,l,n){return this.u(c,o,l,n)}}}),define(Pe[236],Re([1,0,20,6,3,8,72,22,14,5]),function(be,e,y,F,P,M,A,$,E,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sdc=void 0;class C{constructor(p,g){this.stream=new E.$mh,this.stream=g??new E.$mh;const t=this;this.apiObj={option:p,response:t.stream.asyncIterable}}}class D{constructor(p,g){this.a=new f.$Rd,this.b=new Map,this.c=new E.$mh,this.d=!1;const t=this;this.apiObject={result:p,response:t.c.asyncIterable,onDidStartResponseStream:t.a.event,cancel(){g.cancel()}},p.finally(()=>{if(this.d=!0,this.b.size>0)for(const[,i]of this.b)i.stream.resolve();else this.c.resolve()})}handleFragment(p){if(this.d)return;let g=this.b.get(p.index);g||(this.b.size===0?g=new C(p.index,this.c):g=new C(p.index),this.b.set(p.index,g),this.a.fire(g.apiObj)),g.stream.emitOne(p.part)}}class u{static{this.a=1}constructor(p,g){this.d=g,this.c=new Map,this.e=new Map,this.f=new $.$bm,this.b=p.getProxy(P.$xK.MainThreadChatProvider)}registerProvider(p,g,t,i){const r=u.a++;return this.c.set(r,{extension:p,provider:t}),this.b.$registerProvider(r,g,{extension:p,displayName:i.name??p.value}),(0,F.$Pc)(()=>{this.b.$unregisterProvider(r),this.c.delete(r)})}async $provideChatResponse(p,g,t,i,r){const c=this.c.get(p);if(!c)return;const o=new A.$$u(async l=>{if(r.isCancellationRequested){this.d.warn(`[CHAT](${c.extension.value}) CANNOT send progress because the REQUEST IS CANCELLED`);return}this.b.$handleProgressChunk(g,{index:l.index,part:l.part})});return c.provider.provideChatResponse(t.map(M.ChatMessage.to),i,o,r)}allowListExtensionWhile(p,g){this.f.set(p,g),g.finally(()=>this.f.delete(p))}async requestChatResponseProvider(p,g){if(!this.f.has(p))throw new Error("Extension is NOT allowed to make chat requests");const t=this;return{get isRevoked(){return!t.f.has(p)},makeRequest(i,r,c){if(!t.f.has(p))throw new Error("Access to chat has been revoked");const o=new y.$2d(c),l=Math.random()*1e6|0,n=t.b.$fetchResponse(p,g,l,i.map(M.ChatMessage.from),r??{},o.token),s=new D(n,o);return t.e.set(l,{res:s}),n.finally(()=>{t.e.delete(l)}),s.apiObject}}}async $handleResponseFragment(p,g){const t=this.e.get(p);t&&t.res.handleFragment(g)}}e.$Sdc=u}),define(Pe[237],Re([1,0,6,3,11,8]),function(be,e,y,F,P,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Udc=void 0;class A{static{this.a=0}constructor(E){this.b=new Map,this.c=E.getProxy(F.$xK.MainThreadChatVariables)}async $resolveVariable(E,f,C){const D=this.b.get(E);if(D)try{const u=await D.resolver.resolve(D.data.name,{message:f},C);if(u)return u.map(M.ChatVariable.from)}catch(u){(0,P.$1)(u)}}registerVariableResolver(E,f,C,D){const u=A.a++;return this.b.set(u,{extension:E.identifier,data:{name:f,description:C},resolver:D}),this.c.$registerVariable(u,{name:f,description:C}),(0,y.$Pc)(()=>{this.b.delete(u),this.c.$unregisterVariable(u)})}}e.$Udc=A}),define(Pe[238],Re([1,0,3]),function(be,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vdc=void 0;class F{constructor(M){const A=M.getProxy(y.$xK.MainThreadClipboard);this.value=Object.freeze({readText(){return A.$readText()},writeText($){return A.$writeText($)}})}}e.$Vdc=F}),define(Pe[32],Re([1,0,16,7,8,26,3,18,15,51,29,131,2,6,4,17,108,24,49,39,60,56,59]),function(be,e,y,F,P,M,A,$,E,f,C,D,u,b,p,g,t,i,r,c,o,l,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ZM=e.$YM=e.$XM=e.$WM=e.$VM=e.$UM=void 0;let s=class{#e;#t;#i;constructor(k,h,w){this.b=new Map,this.c=new Map,this.#e=k.getProxy(A.$xK.MainThreadCommands),this.d=h,this.#i=w,this.#t=k.getProxy(A.$xK.MainThreadTelemetry),this.converter=new a(this,I=>{const L=this.c.get(I);return L?.result===v.Void?L:void 0},h),this.f=[{processArgument(I){return(0,f.$sh)(I)}},{processArgument(I){return(0,M.$cn)(I,function(L){if(C.$zs.isIRange(L))return P.Range.to(L);if(D.$ys.isIPosition(L))return P.Position.to(L);if(C.$zs.isIRange(L.range)&&u.URI.isUri(L.uri))return P.location.to(L);if(L instanceof i.$fe)return L.buffer.buffer;if(!Array.isArray(L))return L})}}]}registerArgumentProcessor(k){this.f.push(k)}registerApiCommand(k){const h=this.registerCommand(!1,k.id,async(...w)=>{const I=k.args.map((V,K)=>{if(!V.validate(w[K]))throw new Error(`Invalid argument '${V.name}' when running '${k.id}', received: ${typeof w[K]=="object"?JSON.stringify(w[K],null,"	"):w[K]} `);return V.convert(w[K])}),L=await this.executeCommand(k.internalId,...I);return k.result.convert(L,w,this.converter)},void 0,{description:k.description,args:k.args,returns:k.result.description});return this.c.set(k.id,k),new F.$zK(()=>{h.dispose(),this.c.delete(k.id)})}registerCommand(k,h,w,I,L,V){if(this.d.trace("ExtHostCommands#registerCommand",h),!h.trim().length)throw new Error("invalid id");if(this.b.has(h))throw new Error(`command '${h}' already exists`);return this.b.set(h,{callback:w,thisArg:I,metadata:L,extension:V}),k&&this.#e.$registerCommand(h),new F.$zK(()=>{this.b.delete(h)&&k&&this.#e.$unregisterCommand(h)})}executeCommand(k,...h){return this.d.trace("ExtHostCommands#executeCommand",k),this.g(k,h,!0)}async g(k,h,w){if(this.b.has(k))return this.#e.$fireCommandActivationEvent(k),this.h(k,h,!1);{let I=!1;const L=(0,M.$cn)(h,function(V){if(V instanceof F.$AK)return P.Position.from(V);if(V instanceof F.$BK)return P.Range.from(V);if(V instanceof F.$LK)return P.location.from(V);if(F.$WL.isNotebookRange(V))return P.NotebookRange.from(V);if(V instanceof ArrayBuffer)return I=!0,i.$fe.wrap(new Uint8Array(V));if(V instanceof Uint8Array)return I=!0,i.$fe.wrap(V);if(V instanceof i.$fe)return I=!0,V;if(!Array.isArray(V))return V});try{const V=await this.#e.$executeCommand(k,I?new r.$wv(L):L,w);return(0,f.$sh)(V)}catch(V){if(V instanceof Error&&V.message==="$executeCommand:retry")return this.g(k,h,!1);throw V}}}async h(k,h,w){const I=this.b.get(k);if(!I)throw new Error("Unknown command");const{callback:L,thisArg:V,metadata:K}=I;if(K?.args)for(let N=0;N<K.args.length;N++)try{(0,y.$Tf)(h[N],K.args[N].constraint)}catch{throw new Error(`Running the contributed command: '${k}' failed. Illegal argument '${K.args[N].name}' - ${K.args[N].description}`)}const R=o.$Nd.create();try{return await L.apply(V,h)}catch(N){if(k===this.converter.delegatingCommandId){const T=this.converter.getActualCommand(...h);T&&(k=T.command)}if(this.d.error(N,k,I.extension?.identifier),!w)throw N;if(I.extension?.identifier){const T=this.#i.onExtensionError(I.extension.identifier,N);this.d.trace("forwarded error to extension?",T,I.extension?.identifier)}throw new class extends Error{constructor(){super((0,c.$Gi)(N)),this.id=k,this.source=I.extension?.displayName??I.extension?.name}}}finally{this.j(I,k,R.elapsed())}}j(k,h,w){k.extension&&this.#t.$publicLog2("Extension:ActionExecuted",{extensionId:k.extension.identifier.value,id:new l.$po(h),duration:w})}$executeContributedCommand(k,...h){this.d.trace("ExtHostCommands#$executeContributedCommand",k);const w=this.b.get(k);return w?(h=h.map(I=>this.f.reduce((L,V)=>V.processArgument(L,w.extension?.identifier),I)),this.h(k,h,!0)):Promise.reject(new Error(`Contributed command '${k}' does not exist.`))}getCommands(k=!1){return this.d.trace("ExtHostCommands#getCommands",k),this.#e.$getCommands().then(h=>(k&&(h=h.filter(w=>w[0]!=="_")),h))}$getContributedCommandMetadata(){const k=Object.create(null);for(const[h,w]of this.b){const{metadata:I}=w;I&&(k[h]=I)}return Promise.resolve(k)}};e.$UM=s,e.$UM=s=Ke([Ve(0,g.$zM),Ve(1,E.$dj),Ve(2,n.$TM)],s),e.$VM=(0,p.$Vh)("IExtHostCommands");class a{constructor(k,h,w){this.d=k,this.f=h,this.g=w,this.delegatingCommandId=`__vsc${Date.now().toString(36)} `,this.b=new Map,this.c=0,this.d.registerCommand(!0,this.delegatingCommandId,this.h,this)}toInternal(k,h){if(!k)return;const w={$ident:void 0,id:k.command,title:k.title,tooltip:k.tooltip};if(!k.command)return w;const I=this.f(k.command);if(I)w.id=I.internalId,w.arguments=I.args.map((L,V)=>L.convert(k.arguments&&k.arguments[V]));else if((0,$.$Kb)(k.arguments)){const L=`${k.command} /${++this.c}`;this.b.set(L,k),h.add((0,b.$Pc)(()=>{this.b.delete(L),this.g.trace("CommandsConverter#DISPOSE",L)})),w.$ident=L,w.id=this.delegatingCommandId,w.arguments=[L],this.g.trace("CommandsConverter#CREATE",k.command,L)}return w}fromInternal(k){return typeof k.$ident=="string"?this.b.get(k.$ident):{command:k.id,title:k.title,arguments:k.arguments}}getActualCommand(...k){return this.b.get(k[0])}h(...k){const h=this.getActualCommand(...k);return this.g.trace("CommandsConverter#EXECUTE",k[0],h?h.command:"MISSING"),h?this.d.executeCommand(h.command,...h.arguments||[]):Promise.reject(`Actual command not found, wanted to execute ${k[0]}`)}}e.$WM=a;class d{static{this.Uri=new d("uri","Uri of a text document",k=>u.URI.isUri(k),k=>k)}static{this.Position=new d("position","A position in a text document",k=>F.$AK.isPosition(k),P.Position.from)}static{this.Range=new d("range","A range in a text document",k=>F.$BK.isRange(k),P.Range.from)}static{this.Selection=new d("selection","A selection in a text document",k=>F.$CK.isSelection(k),P.Selection.from)}static{this.Number=new d("number","",k=>typeof k=="number",k=>k)}static{this.String=new d("string","",k=>typeof k=="string",k=>k)}static{this.StringArray=d.Arr(d.String)}static Arr(k){return new d(`${k.name}_array`,`Array of ${k.name}, ${k.description}`,h=>Array.isArray(h)&&h.every(w=>k.validate(w)),h=>h.map(w=>k.convert(w)))}static{this.CallHierarchyItem=new d("item","A call hierarchy item",k=>k instanceof F.$VK,P.CallHierarchyItem.from)}static{this.TypeHierarchyItem=new d("item","A type hierarchy item",k=>k instanceof F.$dM,P.TypeHierarchyItem.from)}static{this.TestItem=new d("testItem","A VS Code TestItem",k=>k instanceof t.$MM,P.TestItem.from)}constructor(k,h,w,I){this.name=k,this.description=h,this.validate=w,this.convert=I}optional(){return new d(this.name,`(optional) ${this.description}`,k=>k==null||this.validate(k),k=>k===void 0?void 0:k===null?null:this.convert(k))}with(k,h){return new d(k??this.name,h??this.description,this.validate,this.convert)}}e.$XM=d;class v{static{this.Void=new v("no result",k=>k)}constructor(k,h){this.description=k,this.convert=h}}e.$YM=v;class m{constructor(k,h,w,I,L){this.id=k,this.internalId=h,this.description=w,this.args=I,this.result=L}}e.$ZM=m}),define(Pe[239],Re([1,0,18,13,2,80,95,34,99,32,8,7]),function(be,e,y,F,P,M,A,$,E,f,C,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Odc=void 0;const u=[new f.$ZM("vscode.executeDocumentHighlights","_executeDocumentHighlights","Execute document highlight provider.",[f.$XM.Uri,f.$XM.Position],new f.$YM("A promise that resolves to an array of DocumentHighlight-instances.",p(C.DocumentHighlight.to))),new f.$ZM("vscode.executeDocumentSymbolProvider","_executeDocumentSymbolProvider","Execute document symbol provider.",[f.$XM.Uri],new f.$YM("A promise that resolves to an array of SymbolInformation and DocumentSymbol instances.",(t,i)=>{if((0,y.$Jb)(t))return;class r extends D.$QK{static to(o){const l=new r(o.name,C.SymbolKind.to(o.kind),o.containerName||"",new D.$LK(i[0],C.Range.to(o.range)));return l.detail=o.detail,l.range=l.location.range,l.selectionRange=C.Range.to(o.selectionRange),l.children=o.children?o.children.map(r.to):[],l}}return t.map(r.to)})),new f.$ZM("vscode.executeFormatDocumentProvider","_executeFormatDocumentProvider","Execute document format provider.",[f.$XM.Uri,new f.$XM("options","Formatting options",t=>!0,t=>t)],new f.$YM("A promise that resolves to an array of TextEdits.",p(C.TextEdit.to))),new f.$ZM("vscode.executeFormatRangeProvider","_executeFormatRangeProvider","Execute range format provider.",[f.$XM.Uri,f.$XM.Range,new f.$XM("options","Formatting options",t=>!0,t=>t)],new f.$YM("A promise that resolves to an array of TextEdits.",p(C.TextEdit.to))),new f.$ZM("vscode.executeFormatOnTypeProvider","_executeFormatOnTypeProvider","Execute format on type provider.",[f.$XM.Uri,f.$XM.Position,new f.$XM("ch","Trigger character",t=>typeof t=="string",t=>t),new f.$XM("options","Formatting options",t=>!0,t=>t)],new f.$YM("A promise that resolves to an array of TextEdits.",p(C.TextEdit.to))),new f.$ZM("vscode.executeDefinitionProvider","_executeDefinitionProvider","Execute all definition providers.",[f.$XM.Uri,f.$XM.Position],new f.$YM("A promise that resolves to an array of Location or LocationLink instances.",g)),new f.$ZM("vscode.executeTypeDefinitionProvider","_executeTypeDefinitionProvider","Execute all type definition providers.",[f.$XM.Uri,f.$XM.Position],new f.$YM("A promise that resolves to an array of Location or LocationLink instances.",g)),new f.$ZM("vscode.executeDeclarationProvider","_executeDeclarationProvider","Execute all declaration providers.",[f.$XM.Uri,f.$XM.Position],new f.$YM("A promise that resolves to an array of Location or LocationLink instances.",g)),new f.$ZM("vscode.executeImplementationProvider","_executeImplementationProvider","Execute all implementation providers.",[f.$XM.Uri,f.$XM.Position],new f.$YM("A promise that resolves to an array of Location or LocationLink instances.",g)),new f.$ZM("vscode.executeReferenceProvider","_executeReferenceProvider","Execute all reference providers.",[f.$XM.Uri,f.$XM.Position],new f.$YM("A promise that resolves to an array of Location-instances.",p(C.location.to))),new f.$ZM("vscode.executeHoverProvider","_executeHoverProvider","Execute all hover providers.",[f.$XM.Uri,f.$XM.Position],new f.$YM("A promise that resolves to an array of Hover-instances.",p(C.Hover.to))),new f.$ZM("vscode.executeSelectionRangeProvider","_executeSelectionRangeProvider","Execute selection range provider.",[f.$XM.Uri,new f.$XM("position","A position in a text document",t=>Array.isArray(t)&&t.every(i=>D.$AK.isPosition(i)),t=>t.map(C.Position.from))],new f.$YM("A promise that resolves to an array of ranges.",t=>t.map(i=>{let r;for(const c of i.reverse())r=new D.$UK(C.Range.to(c),r);return r}))),new f.$ZM("vscode.executeWorkspaceSymbolProvider","_executeWorkspaceSymbolProvider","Execute all workspace symbol providers.",[f.$XM.String.with("query","Search string")],new f.$YM("A promise that resolves to an array of SymbolInformation-instances.",t=>t.map(C.WorkspaceSymbol.to))),new f.$ZM("vscode.prepareCallHierarchy","_executePrepareCallHierarchy","Prepare call hierarchy at a position inside a document",[f.$XM.Uri,f.$XM.Position],new f.$YM("A promise that resolves to an array of CallHierarchyItem-instances",t=>t.map(C.CallHierarchyItem.to))),new f.$ZM("vscode.provideIncomingCalls","_executeProvideIncomingCalls","Compute incoming calls for an item",[f.$XM.CallHierarchyItem],new f.$YM("A promise that resolves to an array of CallHierarchyIncomingCall-instances",t=>t.map(C.CallHierarchyIncomingCall.to))),new f.$ZM("vscode.provideOutgoingCalls","_executeProvideOutgoingCalls","Compute outgoing calls for an item",[f.$XM.CallHierarchyItem],new f.$YM("A promise that resolves to an array of CallHierarchyOutgoingCall-instances",t=>t.map(C.CallHierarchyOutgoingCall.to))),new f.$ZM("vscode.prepareRename","_executePrepareRename","Execute the prepareRename of rename provider.",[f.$XM.Uri,f.$XM.Position],new f.$YM("A promise that resolves to a range and placeholder text.",t=>{if(t)return{range:C.Range.to(t.range),placeholder:t.text}})),new f.$ZM("vscode.executeDocumentRenameProvider","_executeDocumentRenameProvider","Execute rename provider.",[f.$XM.Uri,f.$XM.Position,f.$XM.String.with("newName","The new symbol name")],new f.$YM("A promise that resolves to a WorkspaceEdit.",t=>{if(t){if(t.rejectReason)throw new Error(t.rejectReason);return C.WorkspaceEdit.to(t)}})),new f.$ZM("vscode.executeLinkProvider","_executeLinkProvider","Execute document link provider.",[f.$XM.Uri,f.$XM.Number.with("linkResolveCount","Number of links that should be resolved, only when links are unresolved.").optional()],new f.$YM("A promise that resolves to an array of DocumentLink-instances.",t=>t.map(C.DocumentLink.to))),new f.$ZM("vscode.provideDocumentSemanticTokensLegend","_provideDocumentSemanticTokensLegend","Provide semantic tokens legend for a document",[f.$XM.Uri],new f.$YM("A promise that resolves to SemanticTokensLegend.",t=>{if(t)return new D.$OL(t.tokenTypes,t.tokenModifiers)})),new f.$ZM("vscode.provideDocumentSemanticTokens","_provideDocumentSemanticTokens","Provide semantic tokens for a document",[f.$XM.Uri],new f.$YM("A promise that resolves to SemanticTokens.",t=>{if(!t)return;const i=(0,A.$x$)(t);if(i.type==="full")return new D.$QL(i.data,void 0)})),new f.$ZM("vscode.provideDocumentRangeSemanticTokensLegend","_provideDocumentRangeSemanticTokensLegend","Provide semantic tokens legend for a document range",[f.$XM.Uri,f.$XM.Range.optional()],new f.$YM("A promise that resolves to SemanticTokensLegend.",t=>{if(t)return new D.$OL(t.tokenTypes,t.tokenModifiers)})),new f.$ZM("vscode.provideDocumentRangeSemanticTokens","_provideDocumentRangeSemanticTokens","Provide semantic tokens for a document range",[f.$XM.Uri,f.$XM.Range],new f.$YM("A promise that resolves to SemanticTokens.",t=>{if(!t)return;const i=(0,A.$x$)(t);if(i.type==="full")return new D.$QL(i.data,void 0)})),new f.$ZM("vscode.executeCompletionItemProvider","_executeCompletionItemProvider","Execute completion item provider.",[f.$XM.Uri,f.$XM.Position,f.$XM.String.with("triggerCharacter","Trigger completion when the user types the character, like `,` or `(`").optional(),f.$XM.Number.with("itemResolveCount","Number of completions to resolve (too large numbers slow down completions)").optional()],new f.$YM("A promise that resolves to a CompletionList-instance.",(t,i,r)=>{if(!t)return new D.$7K([]);const c=t.suggestions.map(o=>C.CompletionItem.to(o,r));return new D.$7K(c,t.incomplete)})),new f.$ZM("vscode.executeSignatureHelpProvider","_executeSignatureHelpProvider","Execute signature help provider.",[f.$XM.Uri,f.$XM.Position,f.$XM.String.with("triggerCharacter","Trigger signature help when the user types the character, like `,` or `(`").optional()],new f.$YM("A promise that resolves to SignatureHelp.",t=>{if(t)return C.SignatureHelp.to(t)})),new f.$ZM("vscode.executeCodeLensProvider","_executeCodeLensProvider","Execute code lens provider.",[f.$XM.Uri,f.$XM.Number.with("itemResolveCount","Number of lenses that should be resolved and returned. Will only return resolved lenses, will impact performance)").optional()],new f.$YM("A promise that resolves to an array of CodeLens-instances.",(t,i,r)=>p(c=>new D.$YK(C.Range.to(c.range),c.command&&r.fromInternal(c.command)))(t))),new f.$ZM("vscode.executeCodeActionProvider","_executeCodeActionProvider","Execute code action provider.",[f.$XM.Uri,new f.$XM("rangeOrSelection","Range in a text document. Some refactoring provider requires Selection object.",t=>D.$BK.isRange(t),t=>D.$CK.isSelection(t)?C.Selection.from(t):C.Range.from(t)),f.$XM.String.with("kind","Code action kind to return code actions for").optional(),f.$XM.Number.with("itemResolveCount","Number of code actions to resolve (too large numbers slow down code actions)").optional()],new f.$YM("A promise that resolves to an array of Command-instances.",(t,i,r)=>p(c=>{if(c._isSynthetic){if(!c.command)throw new Error("Synthetic code actions must have a command");return r.fromInternal(c.command)}else{const o=new D.$SK(c.title,c.kind?new D.$TK(c.kind):void 0);return c.edit&&(o.edit=C.WorkspaceEdit.to(c.edit)),c.command&&(o.command=r.fromInternal(c.command)),o.isPreferred=c.isPreferred,o}})(t))),new f.$ZM("vscode.executeDocumentColorProvider","_executeDocumentColorProvider","Execute document color provider.",[f.$XM.Uri],new f.$YM("A promise that resolves to an array of ColorInformation objects.",t=>t?t.map(i=>new D.$aL(C.Range.to(i.range),C.Color.to(i.color))):[])),new f.$ZM("vscode.executeColorPresentationProvider","_executeColorPresentationProvider","Execute color presentation provider.",[new f.$XM("color","The color to show and insert",t=>t instanceof D.$_K,C.Color.from),new f.$XM("context","Context object with uri and range",t=>!0,t=>({uri:t.uri,range:C.Range.from(t.range)}))],new f.$YM("A promise that resolves to an array of ColorPresentation objects.",t=>t?t.map(C.ColorPresentation.to):[])),new f.$ZM("vscode.executeInlayHintProvider","_executeInlayHintProvider","Execute inlay hints provider",[f.$XM.Uri,f.$XM.Range],new f.$YM("A promise that resolves to an array of Inlay objects",(t,i,r)=>t.map(C.InlayHint.to.bind(void 0,r)))),new f.$ZM("vscode.executeFoldingRangeProvider","_executeFoldingRangeProvider","Execute folding range provider",[f.$XM.Uri],new f.$YM("A promise that resolves to an array of FoldingRange objects",(t,i)=>{if(t)return t.map(C.FoldingRange.to)})),new f.$ZM("vscode.resolveNotebookContentProviders","_resolveNotebookContentProvider","Resolve Notebook Content Providers",[],new f.$YM("A promise that resolves to an array of NotebookContentProvider static info objects.",p(t=>({viewType:t.viewType,displayName:t.displayName,options:{transientOutputs:t.options.transientOutputs,transientCellMetadata:t.options.transientCellMetadata,transientDocumentMetadata:t.options.transientDocumentMetadata},filenamePattern:t.filenamePattern.map(i=>C.NotebookExclusiveDocumentPattern.to(i))})))),new f.$ZM("vscode.executeInlineValueProvider","_executeInlineValueProvider","Execute inline value provider",[f.$XM.Uri,f.$XM.Range,new f.$XM("context","An InlineValueContext",t=>t&&typeof t.frameId=="number"&&t.stoppedLocation instanceof D.$BK,t=>C.InlineValueContext.from(t))],new f.$YM("A promise that resolves to an array of InlineValue objects",t=>t.map(C.InlineValue.to))),new f.$ZM("vscode.open","_workbench.open","Opens the provided resource in the editor. Can be a text or binary file, or an http(s) URL. If you need more control over the options for opening a text file, use vscode.window.showTextDocument instead.",[new f.$XM("uriOrString","Uri-instance or string (only http/https)",t=>P.URI.isUri(t)||typeof t=="string"&&(0,E.$PU)(t,F.Schemas.http,F.Schemas.https),t=>t),new f.$XM("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",t=>t===void 0||typeof t=="number"||typeof t=="object",t=>t&&(typeof t=="number"?[C.ViewColumn.from(t),void 0]:[C.ViewColumn.from(t.viewColumn),C.TextEditorOpenOptions.from(t)])).optional(),f.$XM.String.with("label","").optional()],f.$YM.Void),new f.$ZM("vscode.openWith","_workbench.openWith","Opens the provided resource with a specific editor.",[f.$XM.Uri.with("resource","Resource to open"),f.$XM.String.with("viewId","Custom editor view id. This should be the viewType string for custom editors or the notebookType string for notebooks. Use 'default' to use VS Code's default text editor"),new f.$XM("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",t=>t===void 0||typeof t=="number"||typeof t=="object",t=>t&&(typeof t=="number"?[C.ViewColumn.from(t),void 0]:[C.ViewColumn.from(t.viewColumn),C.TextEditorOpenOptions.from(t)])).optional()],f.$YM.Void),new f.$ZM("vscode.diff","_workbench.diff","Opens the provided resources in the diff editor to compare their contents.",[f.$XM.Uri.with("left","Left-hand side resource of the diff editor"),f.$XM.Uri.with("right","Right-hand side resource of the diff editor"),f.$XM.String.with("title","Human readable title for the diff editor").optional(),new f.$XM("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",t=>t===void 0||typeof t=="object",t=>t&&[C.ViewColumn.from(t.viewColumn),C.TextEditorOpenOptions.from(t)]).optional()],f.$YM.Void),new f.$ZM("vscode.changes","_workbench.changes","Opens a list of resources in the changes editor to compare their contents.",[f.$XM.String.with("title","Human readable title for the changes editor"),new f.$XM("resourceList","List of resources to compare",t=>{for(const i of t){if(i.length!==3)return!1;const[r,c,o]=i;if(!P.URI.isUri(r)||!P.URI.isUri(c)&&c!==void 0&&c!==null||!P.URI.isUri(o)&&o!==void 0&&o!==null)return!1}return!0},t=>t)],f.$YM.Void),new f.$ZM("vscode.prepareTypeHierarchy","_executePrepareTypeHierarchy","Prepare type hierarchy at a position inside a document",[f.$XM.Uri,f.$XM.Position],new f.$YM("A promise that resolves to an array of TypeHierarchyItem-instances",t=>t.map(C.TypeHierarchyItem.to))),new f.$ZM("vscode.provideSupertypes","_executeProvideSupertypes","Compute supertypes for an item",[f.$XM.TypeHierarchyItem],new f.$YM("A promise that resolves to an array of TypeHierarchyItem-instances",t=>t.map(C.TypeHierarchyItem.to))),new f.$ZM("vscode.provideSubtypes","_executeProvideSubtypes","Compute subtypes for an item",[f.$XM.TypeHierarchyItem],new f.$YM("A promise that resolves to an array of TypeHierarchyItem-instances",t=>t.map(C.TypeHierarchyItem.to))),new f.$ZM("vscode.revealTestInExplorer","_revealTestInExplorer","Reveals a test instance in the explorer",[f.$XM.TestItem],f.$YM.Void),new f.$ZM("vscode.experimental.editSession.continue","_workbench.editSessions.actions.continueEditSession","Continue the current edit session in a different workspace",[f.$XM.Uri.with("workspaceUri","The target workspace to continue the current edit session in")],f.$YM.Void),new f.$ZM("setContext","_setContext","Set a custom context key value that can be used in when clauses.",[f.$XM.String.with("name","The context key name"),new f.$XM("value","The context key value",()=>!0,t=>t)],f.$YM.Void),new f.$ZM("vscode.executeMappedEditsProvider","_executeMappedEditsProvider","Execute Mapped Edits Provider",[f.$XM.Uri,f.$XM.StringArray,new f.$XM("MappedEditsContext","Mapped Edits Context",t=>C.MappedEditsContext.is(t),t=>C.MappedEditsContext.from(t))],new f.$YM("A promise that resolves to a workspace edit or null",t=>t?C.WorkspaceEdit.to(t):null))];class b{static register(i){u.forEach(i.registerApiCommand,i),this.a(i)}static a(i){i.registerCommand(!1,"_validateWhenClauses",$.$Ui)}}e.$Odc=b;function p(t){return i=>{if(Array.isArray(i))return i.map(t)}}function g(t){if(!Array.isArray(t))return;const i=[];for(const r of t)M.$kt(r)?i.push(C.DefinitionLink.to(r)):i.push(C.location.to(r));return i}}),define(Pe[240],Re([1,0,14,66,5,6,2,80,22,8,7,3,23]),function(be,e,y,F,P,M,A,$,E,f,C,D,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ydc=void 0;function b(p,g,t){const i=p.getProxy(D.$xK.MainThreadComments);class r{static{this.a=0}constructor(){this.b=new Map,this.c=new E.$bm,g.registerArgumentProcessor({processArgument:m=>{if(m&&m.$mid===6){const S=this.b.get(m.handle);return S?S.value:m}else if(m&&m.$mid===7){const S=this.b.get(m.commentControlHandle);if(!S)return m;const k=S.getCommentThread(m.commentThreadHandle);return k?k.value:m}else if(m&&(m.$mid===9||m.$mid===8)){const S=this.b.get(m.thread.commentControlHandle);if(!S)return m;const k=S.getCommentThread(m.thread.commentThreadHandle);return k?m.$mid===8?k.value:{thread:k.value,text:m.text}:m}else if(m&&m.$mid===10){const S=this.b.get(m.thread.commentControlHandle);if(!S)return m;const k=S.getCommentThread(m.thread.commentThreadHandle);if(!k)return m;const h=m.commentUniqueId,w=k.getCommentByUniqueId(h);return w||m}else if(m&&m.$mid===11){const S=this.b.get(m.thread.commentControlHandle);if(!S)return m;const k=S.getCommentThread(m.thread.commentThreadHandle);if(!k)return m;const h=m.text,w=m.commentUniqueId,I=k.getCommentByUniqueId(w);return I?(typeof I.body=="string"?I.body=h:I.body=new C.$ZK(h),I):m}return m}})}createCommentController(m,S,k){const h=r.a++,w=new o(m,h,S,k);this.b.set(w.handle,w);const I=this.c.get(m.identifier)||[];return I.push(w),this.c.set(m.identifier,I),w.value}async $createCommentThreadTemplate(m,S,k){const h=this.b.get(m);h&&h.$createCommentThreadTemplate(S,k)}async $updateCommentThreadTemplate(m,S,k){const h=this.b.get(m);h&&h.$updateCommentThreadTemplate(S,k)}$deleteCommentThread(m,S){this.b.get(m)?.$deleteCommentThread(S)}$provideCommentingRanges(m,S,k){const h=this.b.get(m);if(!h||!h.commentingRangeProvider)return Promise.resolve(void 0);const w=t.getDocument(A.URI.revive(S));return(0,y.$Qg)(async()=>{const I=await h.commentingRangeProvider.provideCommentingRanges(w,k);let L;return Array.isArray(I)?L={ranges:I,fileComments:!1}:I?L={ranges:I.ranges||[],fileComments:I.fileComments||!1}:L=I??void 0,L}).then(I=>{let L;return I&&(L={ranges:I.ranges.map(V=>f.Range.from(V)),fileComments:I.fileComments}),L})}$toggleReaction(m,S,k,h,w){const I=this.b.get(m);return!I||!I.reactionHandler?Promise.resolve(void 0):(0,y.$Qg)(()=>{const L=I.getCommentThread(S);if(L){const V=L.getCommentByUniqueId(h.uniqueIdInThread);if(I!==void 0&&V&&I.reactionHandler)return I.reactionHandler(V,s(w))}return Promise.resolve(void 0)})}}class c{static{this.a=0}set threadId(m){this.n=m}get threadId(){return this.n}get id(){return this.n}get resource(){return this.o}get uri(){return this.o}set range(m){(m===void 0!=(this.p===void 0)||!m||!this.p||!m.isEqual(this.p))&&(this.p=m,this.b.range=m,this.c.fire())}get range(){return this.p}set canReply(m){this.d!==m&&(this.d=m,this.b.canReply=m,this.c.fire())}get canReply(){return this.d}get label(){return this.e}set label(m){this.e=m,this.b.label=m,this.c.fire()}get contextValue(){return this.f}set contextValue(m){this.f=m,this.b.contextValue=m,this.c.fire()}get comments(){return this.q}set comments(m){this.q=m,this.b.comments=m,this.c.fire()}get collapsibleState(){return this.g}set collapsibleState(m){this.g=m,this.b.collapsibleState=m,this.c.fire()}get state(){return this.h}set state(m){this.h=m,this.b.state=m,this.c.fire()}get isDisposed(){return this.j}constructor(m,S,k,h,w,I,L,V){this.m=S,this.n=k,this.o=h,this.p=w,this.q=I,this.extensionDescription=L,this.r=V,this.handle=c.a++,this.commentHandle=0,this.b=Object.create(null),this.c=new P.$Rd,this.onDidUpdateCommentThread=this.c.event,this.d=!0,this.k=new Map,this.l=new M.$Sc,this.l.value=new M.$Qc,this.n===void 0&&(this.n=`${m}.${this.handle}`),i.$createCommentThread(S,this.handle,this.n,this.o,f.Range.from(this.p),L.identifier,this.r),this.i=[],this.j=!1,this.i.push(this.onDidUpdateCommentThread(()=>{this.eventuallyUpdateCommentThread()})),this.comments=I,this.i.push({dispose:()=>{i.$deleteCommentThread(S,this.handle)}});const K=this;this.value={get uri(){return K.uri},get range(){return K.range},set range(R){K.range=R},get comments(){return K.comments},set comments(R){K.comments=R},get collapsibleState(){return K.collapsibleState},set collapsibleState(R){K.collapsibleState=R},get canReply(){return K.canReply},set canReply(R){K.canReply=R},get contextValue(){return K.contextValue},set contextValue(R){K.contextValue=R},get label(){return K.label},set label(R){K.label=R},get state(){return K.state},set state(R){K.state=R},dispose:()=>{K.dispose()}}}s(){this.r&&(this.r=!1,this.b.isTemplate=!1)}eventuallyUpdateCommentThread(){if(this.j)return;this.s(),this.l.value||(this.l.value=new M.$Qc);const m=k=>Object.prototype.hasOwnProperty.call(this.b,k),S={};m("range")&&(S.range=f.Range.from(this.p)),m("label")&&(S.label=this.label),m("contextValue")&&(S.contextValue=this.contextValue??null),m("comments")&&(S.comments=this.q.map(k=>l(this,k,this.k,this.extensionDescription))),m("collapsibleState")&&(S.collapseState=a(this.g)),m("canReply")&&(S.canReply=this.canReply),m("state")&&(S.state=d(this.h)),m("isTemplate")&&(S.isTemplate=this.r),this.b={},i.$updateCommentThread(this.m,this.handle,this.n,this.o,S)}getCommentByUniqueId(m){for(const S of this.k){const k=S[0],h=S[1];if(m===h)return k}}dispose(){this.j=!0,this.l.dispose(),this.i.forEach(m=>m.dispose())}}Ke([(0,F.$oh)(100)],c.prototype,"eventuallyUpdateCommentThread",null);class o{get id(){return this.h}get label(){return this.i}get handle(){return this.g}get commentingRangeProvider(){return this.b}set commentingRangeProvider(m){this.b=m,i.$updateCommentingRanges(this.handle)}get reactionHandler(){return this.c}set reactionHandler(m){this.c=m,i.$updateCommentControllerFeatures(this.handle,{reactionHandler:!!m})}get options(){return this.d}set options(m){this.d=m,i.$updateCommentControllerFeatures(this.handle,{options:this.d})}constructor(m,S,k,h){this.f=m,this.g=S,this.h=k,this.i=h,this.a=new Map,i.$registerCommentController(this.handle,k,h,this.f.identifier.value);const w=this;this.value=Object.freeze({id:w.id,label:w.label,get options(){return w.options},set options(I){w.options=I},get commentingRangeProvider(){return w.commentingRangeProvider},set commentingRangeProvider(I){w.commentingRangeProvider=I},get reactionHandler(){return w.reactionHandler},set reactionHandler(I){w.reactionHandler=I},createCommentThread(I,L,V){return w.createCommentThread(I,L,V).value},dispose:()=>{w.dispose()}}),this.e=[],this.e.push({dispose:()=>{i.$unregisterCommentController(this.handle)}})}createCommentThread(m,S,k){S===void 0&&(0,u.$MF)(this.f,"fileComments");const h=new c(this.id,this.handle,void 0,m,S,k,this.f,!1);return this.a.set(h.handle,h),h}$createCommentThreadTemplate(m,S){const k=new c(this.id,this.handle,void 0,A.URI.revive(m),f.Range.to(S),[],this.f,!0);return k.collapsibleState=$.CommentThreadCollapsibleState.Expanded,this.a.set(k.handle,k),k}$updateCommentThreadTemplate(m,S){const k=this.a.get(m);k&&(k.range=f.Range.to(S))}$deleteCommentThread(m){this.a.get(m)?.dispose(),this.a.delete(m)}getCommentThread(m){return this.a.get(m)}dispose(){this.a.forEach(m=>{m.dispose()}),this.e.forEach(m=>m.dispose())}}function l(v,m,S,k){let h=S.get(m);return h||(h=++v.commentHandle,S.set(m,h)),m.state!==void 0&&(0,u.$MF)(k,"commentsDraftState"),{mode:m.mode,contextValue:m.contextValue,uniqueIdInThread:h,body:typeof m.body=="string"?m.body:f.MarkdownString.from(m.body),userName:m.author.name,userIconPath:m.author.iconPath,label:m.label,commentReactions:m.reactions?m.reactions.map(w=>n(w)):void 0,state:m.state,timestamp:m.timestamp?.toJSON()}}function n(v){return{label:v.label,iconPath:v.iconPath?f.$yM(v.iconPath):void 0,count:v.count,hasReacted:v.authorHasReacted}}function s(v){return{label:v.label||"",count:v.count||0,iconPath:v.iconPath?A.URI.revive(v.iconPath):"",authorHasReacted:v.hasReacted||!1}}function a(v){if(v!==void 0)switch(v){case C.CommentThreadCollapsibleState.Expanded:return $.CommentThreadCollapsibleState.Expanded;case C.CommentThreadCollapsibleState.Collapsed:return $.CommentThreadCollapsibleState.Collapsed}return $.CommentThreadCollapsibleState.Collapsed}function d(v){if(v!==void 0)switch(v){case C.CommentThreadState.Unresolved:return $.CommentThreadState.Unresolved;case C.CommentThreadState.Resolved:return $.CommentThreadState.Resolved}return $.CommentThreadState.Unresolved}return new r}e.$Ydc=b}),define(Pe[241],Re([1,0,26,3,27,17]),function(be,e,y,F,P,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mfc=void 0;let A=class{constructor(C,D){this.a=C.getProxy(F.$xK.MainThreadConsole),this.b=D.consoleForward.includeStack,this.c=D.consoleForward.logNative,this.d("info","log"),this.d("log","log"),this.d("warn","warn"),this.d("error","error")}d(C,D){const u=this,b=console[C];Object.defineProperty(console,C,{set:()=>{},get:()=>function(){u.e(C,D,b,arguments)}})}e(C,D,u,b){this.a.$logExtensionHostMessage({type:"__$console",severity:D,arguments:E(b,this.b)}),this.c&&this.f(C,u,b)}};e.$Mfc=A,e.$Mfc=A=Ke([Ve(0,M.$zM),Ve(1,P.$PM)],A);const $=1e5;function E(f,C){const D=[];if(f.length)for(let u=0;u<f.length;u++){let b=f[u];if(typeof b>"u")b="undefined";else if(b instanceof Error){const p=b;p.stack?b=p.stack:b=p.toString()}D.push(b)}if(C){const u=new Error().stack;u&&D.push({__$stack:u.split(`
`).slice(3).join(`
`)})}try{const u=(0,y.$fn)(D);return u.length>$?"Output omitted for a large object that exceeds the limits":u}catch(u){return`Output omitted for an object that cannot be inspected ('${u.toString()}')`}}}),define(Pe[110],Re([1,0,2,3,7,4,17,15,18,12,19,23]),function(be,e,y,F,P,M,A,$,E,f,C,D){"use strict";var u;Object.defineProperty(e,"__esModule",{value:!0}),e.$Pec=e.$Oec=void 0;let b=class{static{u=this}static{this.c=0}static{this.d=250}constructor(g,t){this.h=t,this.f=new Map,this.g=g.getProxy(F.$xK.MainThreadDecorations)}registerFileDecorationProvider(g,t){const i=u.c++;this.f.set(i,{provider:g,extensionDescription:t}),this.g.$registerDecorationProvider(i,t.identifier.value);const r=g.onDidChangeFileDecorations&&g.onDidChangeFileDecorations(c=>{if(!c){this.g.$onDidChange(i,null);return}const o=(0,E.$2b)(c);if(o.length<=u.d){this.g.$onDidChange(i,o);return}this.h.warn("[Decorations] CAPPING events from decorations provider",t.identifier.value,o.length);const l=o.map(a=>({uri:a,rank:(0,f.$Ke)(a.path,"/")})),n=(0,E.$yb)(l,(a,d)=>a.rank-d.rank||(0,f.$Ye)(a.uri.path,d.uri.path)),s=[];e:for(const a of n){let d;for(const v of a){const m=(0,C.$lc)(v.uri.path);if(d!==m&&(d=m,s.push(v.uri)>=u.d))break e}}this.g.$onDidChange(i,s)});return new P.$zK(()=>{r?.dispose(),this.g.$unregisterDecorationProvider(i),this.f.delete(i)})}async $provideDecorations(g,t,i){if(!this.f.has(g))return Object.create(null);const r=Object.create(null),{provider:c,extensionDescription:o}=this.f.get(g);return await Promise.all(t.map(async l=>{try{const{uri:n,id:s}=l,a=await Promise.resolve(c.provideFileDecoration(y.URI.revive(n),i));if(!a)return;try{P.$UL.validate(a),a.badge&&typeof a.badge!="string"&&(0,D.$MF)(o,"codiconDecoration"),r[s]=[a.propagate,a.tooltip,a.badge,a.color]}catch(d){this.h.warn(`INVALID decoration from extension '${o.identifier.value}': ${d}`)}}catch(n){this.h.error(n)}})),r}};e.$Oec=b,e.$Oec=b=u=Ke([Ve(0,A.$zM),Ve(1,$.$dj)],b),e.$Pec=(0,M.$Vh)("IExtHostDecorations")}),define(Pe[242],Re([1,0,158,98,2,3,7,8,5,15,28,42]),function(be,e,y,F,P,M,A,$,E,f,C,D){"use strict";var u;Object.defineProperty(e,"__esModule",{value:!0}),e.$Jdc=e.$Idc=void 0;class b{#e;#t;#i;constructor(t,i,r,c,o,l,n,s){this.d=t,this.e=i,this.f=r,this.g=c,this.h=o,this.c=!1,this.f=Math.max(c,r),this.#i=new C.$zc(a=>l.getComparisonKey(a)),this.#e=n,this.#t=s}dispose(){this.c||(this.#t.fire([...this.#i.keys()]),this.#e?.$clear(this.e),this.#i.clear(),this.c=!0)}get name(){return this.j(),this.d}set(t,i){if(!t){this.clear();return}this.j();let r=[];if(P.URI.isUri(t)){if(!i){this.delete(t);return}this.#i.set(t,i.slice()),r=[t]}else if(Array.isArray(t)){r=[];let l;t=[...t].sort(b.k);for(const n of t){const[s,a]=n;if((!l||s.toString()!==l.toString())&&(l&&this.#i.get(l).length===0&&this.#i.delete(l),l=s,r.push(s),this.#i.set(s,[])),a)this.#i.get(s)?.push(...a);else{const d=this.#i.get(s);d&&(d.length=0)}}}if(this.#t.fire(r),!this.#e)return;const c=[];let o=0;for(const l of r){let n=[];const s=this.#i.get(l);if(s)if(s.length>this.g){n=[];const a=[A.DiagnosticSeverity.Error,A.DiagnosticSeverity.Warning,A.DiagnosticSeverity.Information,A.DiagnosticSeverity.Hint];e:for(let d=0;d<4;d++)for(const v of s)if(v.severity===a[d]&&n.push({...$.Diagnostic.from(v),modelVersionId:this.h(l)})===this.g)break e;n.push({severity:F.MarkerSeverity.Info,message:(0,y.localize)(0,null,s.length-this.g),startLineNumber:n[n.length-1].startLineNumber,startColumn:n[n.length-1].startColumn,endLineNumber:n[n.length-1].endLineNumber,endColumn:n[n.length-1].endColumn})}else n=s.map(a=>({...$.Diagnostic.from(a),modelVersionId:this.h(l)}));if(c.push([l,n]),o+=n.length,o>this.f)break}this.#e.$changeMany(this.e,c)}delete(t){this.j(),this.#t.fire([t]),this.#i.delete(t),this.#e?.$changeMany(this.e,[[t,void 0]])}clear(){this.j(),this.#t.fire([...this.#i.keys()]),this.#i.clear(),this.#e?.$clear(this.e)}forEach(t,i){this.j();for(const[r,c]of this)t.call(i,r,c,this)}*[Symbol.iterator](){this.j();for(const t of this.#i.keys())yield[t,this.get(t)]}get(t){this.j();const i=this.#i.get(t);return Array.isArray(i)?Object.freeze(i.slice(0)):[]}has(t){return this.j(),Array.isArray(this.#i.get(t))}j(){if(this.c)throw new Error("illegal state - object is disposed")}static k(t,i){return t[0].toString()<i[0].toString()?-1:t[0].toString()>i[0].toString()?1:0}}e.$Idc=b;let p=class{static{u=this}static{this.c=0}static{this.d=1e3}static{this.e=1.1*u.d}static _mapper(t){const i=new C.$zc;for(const r of t)i.set(r,r);return{uris:Object.freeze(Array.from(i.values()))}}constructor(t,i,r,c){this.j=i,this.k=r,this.l=c,this.g=new Map,this.h=new E.$Vd({merge:o=>o.flat(),delay:50}),this.onDidChangeDiagnostics=E.Event.map(this.h.event,u._mapper),this.f=t.getProxy(M.$xK.MainThreadDiagnostics)}createDiagnosticCollection(t,i){const{g:r,f:c,h:o,j:l,k:n,l:s}=this,a=new class{$changeMany(m,S){c.$changeMany(m,S),l.trace("[DiagnosticCollection] change many (extension, owner, uris)",t.value,m,S.length===0?"CLEARING":S)}$clear(m){c.$clear(m),l.trace("[DiagnosticCollection] remove all (extension, owner)",t.value,m)}dispose(){c.dispose()}};let d;if(!i)i="_generated_diagnostic_collection_name_#"+u.c++,d=i;else if(!r.has(i))d=i;else{this.j.warn(`DiagnosticCollection with name '${i}' does already exist.`);do d=i+u.c++;while(r.has(d))}return new class extends b{constructor(){super(i,d,u.e,u.d,m=>s.getDocument(m)?.version,n.extUri,a,o),r.set(d,this)}dispose(){super.dispose(),r.delete(d)}}}getDiagnostics(t){if(t)return this.m(t);{const i=new Map,r=[];for(const c of this.g.values())c.forEach((o,l)=>{let n=i.get(o.toString());typeof n>"u"&&(n=r.length,i.set(o.toString(),n),r.push([o,[]])),r[n][1]=r[n][1].concat(...l)});return r}}m(t){let i=[];for(const r of this.g.values())r.has(t)&&(i=i.concat(r.get(t)));return i}$acceptMarkersChange(t){if(!this.n){const i="_generated_mirror",r=new b(i,i,Number.MAX_SAFE_INTEGER,Number.MAX_SAFE_INTEGER,c=>{},this.k.extUri,void 0,this.h);this.g.set(i,r),this.n=r}for(const[i,r]of t)this.n.set(P.URI.revive(i),r.map($.Diagnostic.to))}};e.$Jdc=p,e.$Jdc=p=u=Ke([Ve(1,f.$dj),Ve(2,D.$Hdc)],p)}),define(Pe[243],Re([1,0,2,3,23]),function(be,e,y,F,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qec=void 0;class M{constructor($){this.a=$.getProxy(F.$xK.MainThreadDialogs)}showOpenDialog($,E){return E?.allowUIResources&&(0,P.$MF)($,"showLocal"),this.a.$showOpenDialog(E).then(f=>f?f.map(C=>y.URI.revive(C)):void 0)}showSaveDialog($){return this.a.$showSaveDialog($).then(E=>E?y.URI.revive(E):void 0)}}e.$Qec=M}),define(Pe[244],Re([1,0,11,2,7,3,13,20,12]),function(be,e,y,F,P,M,A,$,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rec=void 0;class f{static{this.a=0}constructor(D,u,b){this.d=u,this.e=b,this.b=new Map,this.c=D.getProxy(M.$xK.MainThreadDocumentContentProviders)}registerTextDocumentContentProvider(D,u){if(Object.keys(A.Schemas).indexOf(D)>=0)throw new Error(`scheme '${D}' already registered`);const b=f.a++;this.b.set(b,u),this.c.$registerTextContentProvider(b,D);let p;return typeof u.onDidChange=="function"&&(p=u.onDidChange(g=>{if(g.scheme!==D){this.e.warn(`Provider for scheme '${D}' is firing event for schema '${g.scheme}' which will be IGNORED`);return}this.d.getDocument(g)&&this.$provideTextDocumentContent(b,g).then(t=>{if(!t&&typeof t!="string")return;const i=this.d.getDocument(g);if(!i)return;const r=(0,E.$Te)(t);if(!i.equalLines(r))return this.c.$onVirtualDocumentChange(g,t)},y.$Z)})),new P.$zK(()=>{this.b.delete(b)&&this.c.$unregisterTextContentProvider(b),p&&(p.dispose(),p=void 0)})}$provideTextDocumentContent(D,u){const b=this.b.get(D);return b?Promise.resolve(b.provideTextDocumentContent(F.URI.revive(u),$.CancellationToken.None)):Promise.reject(new Error(`unsupported uri-scheme: ${u.scheme}`))}}e.$Rec=f}),define(Pe[245],Re([1,0,5,6,2,3,103,8,16,26,7,11]),function(be,e,y,F,P,M,A,$,E,f,C,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fdc=void 0;class u{constructor(p,g){this.a=new y.$Rd({onListenerError:D.$1}),this.b=new y.$Rd({onListenerError:D.$1}),this.c=new y.$Rd({onListenerError:D.$1}),this.d=new y.$Rd({onListenerError:D.$1}),this.onDidAddDocument=this.a.event,this.onDidRemoveDocument=this.b.event,this.onDidChangeDocument=this.c.event,this.onDidSaveDocument=this.d.event,this.e=new F.$Qc,this.h=new Map,this.f=p.getProxy(M.$xK.MainThreadDocuments),this.g=g,this.g.onDidRemoveDocuments(t=>{for(const i of t)this.b.fire(i.document)},void 0,this.e),this.g.onDidAddDocuments(t=>{for(const i of t)this.a.fire(i.document)},void 0,this.e)}dispose(){this.e.dispose()}getAllDocumentData(){return[...this.g.allDocuments()]}getDocumentData(p){if(!p)return;const g=this.g.getDocument(p);if(g)return g}getDocument(p){const g=this.getDocumentData(p);if(!g?.document)throw new Error(`Unable to retrieve document from URI '${p}'`);return g.document}ensureDocumentData(p){const g=this.g.getDocument(p);if(g)return Promise.resolve(g);let t=this.h.get(p.toString());return t||(t=this.f.$tryOpenDocument(p).then(i=>{this.h.delete(p.toString());const r=P.URI.revive(i);return(0,E.$Nf)(this.g.getDocument(r))},i=>(this.h.delete(p.toString()),Promise.reject(i))),this.h.set(p.toString(),t)),t}createDocumentData(p){return this.f.$tryCreateDocument(p).then(g=>P.URI.revive(g))}$acceptModelLanguageChanged(p,g){const t=P.URI.revive(p),i=this.g.getDocument(t);if(!i)throw new Error("unknown document");this.b.fire(i.document),i._acceptLanguageId(g),this.a.fire(i.document)}$acceptModelSaved(p){const g=P.URI.revive(p),t=this.g.getDocument(g);if(!t)throw new Error("unknown document");this.$acceptDirtyStateChanged(p,!1),this.d.fire(t.document)}$acceptDirtyStateChanged(p,g){const t=P.URI.revive(p),i=this.g.getDocument(t);if(!i)throw new Error("unknown document");i._acceptIsDirty(g),this.c.fire({document:i.document,contentChanges:[],reason:void 0})}$acceptModelChanged(p,g,t){const i=P.URI.revive(p),r=this.g.getDocument(i);if(!r)throw new Error("unknown document");r._acceptIsDirty(t),r.onEvents(g);let c;g.isUndoing?c=C.TextDocumentChangeReason.Undo:g.isRedoing&&(c=C.TextDocumentChangeReason.Redo),this.c.fire((0,f.$bn)({document:r.document,contentChanges:g.changes.map(o=>({range:$.Range.to(o.range),rangeOffset:o.rangeOffset,rangeLength:o.rangeLength,text:o.text})),reason:c}))}setWordDefinitionFor(p,g){(0,A.$BM)(p,g)}}e.$Fdc=u}),define(Pe[61],Re([1,0,53,5,6,2,4,3,103,17,109,8,15,28,13,67,44]),function(be,e,y,F,P,M,A,$,E,f,C,D,u,b,p,g,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$KM=e.$JM=void 0;class i{constructor(o){this.value=o,this.a=0}ref(){this.a++}unref(){return--this.a===0}}let r=class{constructor(o,l){this.h=o,this.i=l,this.a=null,this.b=new Map,this.c=new b.$zc,this.d=new F.$Rd,this.e=new F.$Rd,this.f=new F.$Rd,this.g=new F.$Rd,this.onDidAddDocuments=this.d.event,this.onDidRemoveDocuments=this.e.event,this.onDidChangeVisibleTextEditors=this.f.event,this.onDidChangeActiveTextEditor=this.g.event}$acceptDocumentsAndEditorsDelta(o){this.acceptDocumentsAndEditorsDelta(o)}acceptDocumentsAndEditorsDelta(o){const l=[],n=[],s=[];if(o.removedDocuments)for(const a of o.removedDocuments){const d=M.URI.revive(a),v=this.c.get(d);v?.unref()&&(this.c.delete(d),l.push(v.value))}if(o.addedDocuments)for(const a of o.addedDocuments){const d=M.URI.revive(a.uri);let v=this.c.get(d);if(v&&d.scheme!==p.Schemas.vscodeNotebookCell&&d.scheme!==p.Schemas.vscodeInteractiveInput)throw new Error(`document '${d} already exists!'`);v||(v=new i(new E.$CM(this.h.getProxy($.$xK.MainThreadDocuments),d,a.lines,a.EOL,a.versionId,a.languageId,a.isDirty,a.notebook)),this.c.set(d,v),n.push(v.value)),v.ref()}if(o.removedEditors)for(const a of o.removedEditors){const d=this.b.get(a);this.b.delete(a),d&&s.push(d)}if(o.addedEditors)for(const a of o.addedEditors){const d=M.URI.revive(a.documentUri);y.ok(this.c.has(d),`document '${d}' does not exist`),y.ok(!this.b.has(a.id),`editor '${a.id}' already exists!`);const v=this.c.get(d).value,m=new C.$IM(a.id,this.h.getProxy($.$xK.MainThreadTextEditors),this.i,new t.$U(()=>v.document),a.selections.map(D.Selection.to),a.options,a.visibleRanges.map(S=>D.Range.to(S)),typeof a.editorPosition=="number"?D.ViewColumn.to(a.editorPosition):void 0);this.b.set(a.id,m)}o.newActiveEditor!==void 0&&(y.ok(o.newActiveEditor===null||this.b.has(o.newActiveEditor),`active editor '${o.newActiveEditor}' does not exist`),this.a=o.newActiveEditor),(0,P.$Mc)(l),(0,P.$Mc)(s),o.removedDocuments&&this.e.fire(l),o.addedDocuments&&this.d.fire(n),(o.removedEditors||o.addedEditors)&&this.f.fire(this.allEditors().map(a=>a.value)),o.newActiveEditor!==void 0&&this.g.fire(this.activeEditor())}getDocument(o){return this.c.get(o)?.value}allDocuments(){return g.Iterable.map(this.c.values(),o=>o.value)}getEditor(o){return this.b.get(o)}activeEditor(o){if(!this.a)return;const l=this.b.get(this.a);return o?l:l?.value}allEditors(){return[...this.b.values()]}};e.$JM=r,e.$JM=r=Ke([Ve(0,f.$zM),Ve(1,u.$dj)],r),e.$KM=(0,A.$Vh)("IExtHostDocumentsAndEditors")}),define(Pe[62],Re([1,0,246,5,16,2,4,3,17,8,7]),function(be,e,y,F,P,M,A,$,E,f,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gec=e.$fec=void 0,e.$fec=(0,A.$Vh)("IExtHostEditorTabs");class D{constructor(t,i,r){this.e=r,this.d=i,this.acceptDtoUpdate(t)}get apiObject(){if(!this.a){const t=this,i={get isActive(){return t.b.id===t.e()},get label(){return t.b.label},get input(){return t.c},get isDirty(){return t.b.isDirty},get isPinned(){return t.b.isPinned},get isPreview(){return t.b.isPreview},get group(){return t.d.apiObject}};this.a=Object.freeze(i)}return this.a}get tabId(){return this.b.id}acceptDtoUpdate(t){this.b=t,this.c=this.f()}f(){switch(this.b.input.kind){case 1:return new C.$eM(M.URI.revive(this.b.input.uri));case 2:return new C.$fM(M.URI.revive(this.b.input.original),M.URI.revive(this.b.input.modified));case 3:return new C.$gM(M.URI.revive(this.b.input.base),M.URI.revive(this.b.input.input1),M.URI.revive(this.b.input.input2),M.URI.revive(this.b.input.result));case 6:return new C.$hM(M.URI.revive(this.b.input.uri),this.b.input.viewType);case 7:return new C.$iM(this.b.input.viewType);case 4:return new C.$jM(M.URI.revive(this.b.input.uri),this.b.input.notebookType);case 5:return new C.$kM(M.URI.revive(this.b.input.original),M.URI.revive(this.b.input.modified),this.b.input.notebookType);case 8:return new C.$lM;case 9:return new C.$mM(M.URI.revive(this.b.input.uri),M.URI.revive(this.b.input.inputBoxUri));case 10:return new C.$nM(this.b.input.providerId);default:return}}}class u{constructor(t,i){this.c=[],this.d="",this.b=t,this.e=i;for(const r of t.tabs)r.isActive&&(this.d=r.id),this.c.push(new D(r,this,()=>this.activeTabId()))}get apiObject(){if(!this.a){const t=this,i={get isActive(){return t.b.groupId===t.e()},get viewColumn(){return f.ViewColumn.to(t.b.viewColumn)},get activeTab(){return t.c.find(r=>r.tabId===t.d)?.apiObject},get tabs(){return Object.freeze(t.c.map(r=>r.apiObject))}};this.a=Object.freeze(i)}return this.a}get groupId(){return this.b.groupId}get tabs(){return this.c}acceptGroupDtoUpdate(t){this.b=t}acceptTabOperation(t){if(t.kind===0){const r=new D(t.tabDto,this,()=>this.activeTabId());return this.c.splice(t.index,0,r),t.tabDto.isActive&&(this.d=r.tabId),r}else if(t.kind===1){const r=this.c.splice(t.index,1)[0];if(!r)throw new Error(`Tab close updated received for index ${t.index} which does not exist`);return r.tabId===this.d&&(this.d=""),r}else if(t.kind===3){if(t.oldIndex===void 0)throw new Error("Invalid old index on move IPC");const r=this.c.splice(t.oldIndex,1)[0];if(!r)throw new Error(`Tab move updated received for index ${t.oldIndex} which does not exist`);return this.c.splice(t.index,0,r),r}const i=this.c.find(r=>r.tabId===t.tabDto.id);if(!i)throw new Error("INVALID tab");return t.tabDto.isActive?this.d=t.tabDto.id:this.d===t.tabDto.id&&!t.tabDto.isActive&&(this.d=""),i.acceptDtoUpdate(t.tabDto),i}activeTabId(){return this.d}}let b=class{constructor(t){this.b=new F.$Rd,this.c=new F.$Rd,this.e=[],this.a=t.getProxy($.$xK.MainThreadEditorTabs)}get tabGroups(){if(!this.f){const t=this,i={onDidChangeTabGroups:t.c.event,onDidChangeTabs:t.b.event,get all(){return Object.freeze(t.e.map(r=>r.apiObject))},get activeTabGroup(){const r=t.d;return(0,P.$Nf)(t.e.find(o=>o.groupId===r)?.apiObject)},close:async(r,c)=>{const o=Array.isArray(r)?r:[r];return o.length?p(o[0])?this.j(o,c):this.i(o,c):!0}};this.f=Object.freeze(i)}return this.f}$acceptEditorTabModel(t){const i=new Set(this.e.map(a=>a.groupId)),r=new Set(t.map(a=>a.groupId)),c=(0,y.$K)(i,r),o=this.e.filter(a=>c.removed.includes(a.groupId)).map(a=>a.apiObject),l=[],n=[];this.e=t.map(a=>{const d=new u(a,()=>this.d);return c.added.includes(d.groupId)?l.push(d.apiObject):n.push(d.apiObject),d});const s=(0,P.$Nf)(t.find(a=>a.isActive===!0)?.groupId);s!==void 0&&this.d!==s&&(this.d=s),this.c.fire(Object.freeze({opened:l,closed:o,changed:n}))}$acceptTabGroupUpdate(t){const i=this.e.find(r=>r.groupId===t.groupId);if(!i)throw new Error("Update Group IPC call received before group creation.");i.acceptGroupDtoUpdate(t),t.isActive&&(this.d=t.groupId),this.c.fire(Object.freeze({changed:[i.apiObject],opened:[],closed:[]}))}$acceptTabOperation(t){const i=this.e.find(c=>c.groupId===t.groupId);if(!i)throw new Error("Update Tabs IPC call received before group creation.");const r=i.acceptTabOperation(t);switch(t.kind){case 0:this.b.fire(Object.freeze({opened:[r.apiObject],closed:[],changed:[]}));return;case 1:this.b.fire(Object.freeze({opened:[],closed:[r.apiObject],changed:[]}));return;case 3:case 2:this.b.fire(Object.freeze({opened:[],closed:[],changed:[r.apiObject]}));return}}g(t){for(const i of this.e)for(const r of i.tabs)if(r.apiObject===t)return r}h(t){return this.e.find(i=>i.apiObject===t)}async i(t,i){const r=[];for(const c of t){const o=this.g(c);if(!o)throw new Error("Tab close: Invalid tab not found!");r.push(o.tabId)}return this.a.$closeTab(r,i)}async j(t,i){const r=[];for(const c of t){const o=this.h(c);if(!o)throw new Error("Group close: Invalid group not found!");r.push(o.groupId)}return this.a.$closeGroup(r,i)}};e.$gec=b,e.$gec=b=Ke([Ve(0,E.$zM)],b);function p(g){return g.tabs!==void 0}}),define(Pe[247],Re([1,0,3,7]),function(be,e,y,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tec=void 0;class P{constructor(A){this.a=new Map,this.b=0,this.c=A.getProxy(y.$xK.MainThreadAiEmbeddingVector)}async $provideAiEmbeddingVector(A,$,E){if(this.a.size===0)throw new Error("No embedding vector providers registered");const f=this.a.get(A);if(!f)throw new Error("Embedding vector provider not found");const C=await f.provideEmbeddingVector($,E);if(!C)throw new Error("Embedding vector provider returned undefined");return C}registerEmbeddingVectorProvider(A,$,E){const f=this.b;return this.b++,this.a.set(f,E),this.c.$registerAiEmbeddingVectorProvider($,f),new F.$zK(()=>{this.c.$unregisterAiEmbeddingVectorProvider(f),this.a.delete(f)})}}e.$Tec=P}),define(Pe[248],Re([1,0,2,3,6,7,8,296,12,24,23,52]),function(be,e,y,F,P,M,A,$,E,f,C,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Uec=void 0;class u{constructor(){this.a=[]}add(g){this.b=void 0,this.a.push(g)}delete(g){const t=this.a.indexOf(g);t>=0&&(this.a.splice(t,1),this.b=void 0)}c(){if(!this.b){const g=this.a.sort(),t=[];let i,r,c=14,o=14;for(const l of g){let n=i?(0,E.$8e)(i,l):0;for(n===0?r=1:r=o;n<l.length;n++)n+1===l.length?(c=o,o=9):o+=1,t.push([r,l.toUpperCase().charCodeAt(n),o]),t.push([r,l.toLowerCase().charCodeAt(n),o]),r=o;i=l,o=c}t.push([9,58,10]),t.push([10,47,12]),this.b=new $.$yZ(t)}}provideDocumentLinks(g){this.c();const t=[],i=$.$zZ.computeLinks({getLineContent(r){return g.lineAt(r-1).text},getLineCount(){return g.lineCount}},this.b);for(const r of i){const c=A.DocumentLink.to(r);c.target&&t.push(c)}return t}}class b{constructor(g,t){this.i=t,this.b=new u,this.c=new Map,this.d=new Set,this.f=new Map,this.h=0,this.a=g.getProxy(F.$xK.MainThreadFileSystem)}dispose(){this.g?.dispose()}registerFileSystemProvider(g,t,i,r={}){if(b.j(i),this.d.has(t))throw new Error(`a provider for the scheme '${t}' is already registered`);this.g||(this.g=this.i.registerDocumentLinkProvider(g,"*",this.b));const c=this.h++;this.b.add(t),this.d.add(t),this.c.set(c,i);let o=2;r.isCaseSensitive&&(o+=1024),r.isReadonly&&(o+=2048),typeof i.copy=="function"&&(o+=8),typeof i.open=="function"&&typeof i.close=="function"&&typeof i.read=="function"&&typeof i.write=="function"&&((0,C.$MF)(g,"fsChunks"),o+=4);let l;r.isReadonly&&(0,D.$$j)(r.isReadonly)&&((0,C.$MF)(g,"readonlyMessage"),l={value:r.isReadonly.value,isTrusted:r.isReadonly.isTrusted,supportThemeIcons:r.isReadonly.supportThemeIcons,supportHtml:r.isReadonly.supportHtml,baseUri:r.isReadonly.baseUri,uris:r.isReadonly.uris}),this.a.$registerFileSystemProvider(c,t,o,l).catch(s=>{console.error(`FAILED to register filesystem provider of ${g.identifier.value}-extension for the scheme ${t}`),console.error(s)});const n=i.onDidChangeFile(s=>{const a=[];for(const d of s){const{uri:v,type:m}=d;if(v.scheme!==t)continue;let S;switch(m){case M.FileChangeType.Changed:S=0;break;case M.FileChangeType.Created:S=1;break;case M.FileChangeType.Deleted:S=2;break;default:throw new Error("Unknown FileChangeType")}a.push({resource:v,type:S})}this.a.$onFileSystemChange(c,a)});return(0,P.$Pc)(()=>{n.dispose(),this.b.delete(t),this.d.delete(t),this.c.delete(c),this.a.$unregisterProvider(c)})}static j(g){if(!g)throw new Error("MISSING provider");if(typeof g.watch!="function")throw new Error("Provider does NOT implement watch");if(typeof g.stat!="function")throw new Error("Provider does NOT implement stat");if(typeof g.readDirectory!="function")throw new Error("Provider does NOT implement readDirectory");if(typeof g.createDirectory!="function")throw new Error("Provider does NOT implement createDirectory");if(typeof g.readFile!="function")throw new Error("Provider does NOT implement readFile");if(typeof g.writeFile!="function")throw new Error("Provider does NOT implement writeFile");if(typeof g.delete!="function")throw new Error("Provider does NOT implement delete");if(typeof g.rename!="function")throw new Error("Provider does NOT implement rename")}static k(g){const{type:t,ctime:i,mtime:r,size:c,permissions:o}=g;return{type:t,ctime:i,mtime:r,size:c,permissions:o}}$stat(g,t){return Promise.resolve(this.l(g).stat(y.URI.revive(t))).then(i=>b.k(i))}$readdir(g,t){return Promise.resolve(this.l(g).readDirectory(y.URI.revive(t)))}$readFile(g,t){return Promise.resolve(this.l(g).readFile(y.URI.revive(t))).then(i=>f.$fe.wrap(i))}$writeFile(g,t,i,r){return Promise.resolve(this.l(g).writeFile(y.URI.revive(t),i.buffer,r))}$delete(g,t,i){return Promise.resolve(this.l(g).delete(y.URI.revive(t),i))}$rename(g,t,i,r){return Promise.resolve(this.l(g).rename(y.URI.revive(t),y.URI.revive(i),r))}$copy(g,t,i,r){const c=this.l(g);if(!c.copy)throw new Error('FileSystemProvider does not implement "copy"');return Promise.resolve(c.copy(y.URI.revive(t),y.URI.revive(i),r))}$mkdir(g,t){return Promise.resolve(this.l(g).createDirectory(y.URI.revive(t)))}$watch(g,t,i,r){const c=this.l(g).watch(y.URI.revive(i),r);this.f.set(t,c)}$unwatch(g,t){const i=this.f.get(t);i&&(i.dispose(),this.f.delete(t))}$open(g,t,i){const r=this.l(g);if(!r.open)throw new Error('FileSystemProvider does not implement "open"');return Promise.resolve(r.open(y.URI.revive(t),i))}$close(g,t){const i=this.l(g);if(!i.close)throw new Error('FileSystemProvider does not implement "close"');return Promise.resolve(i.close(t))}$read(g,t,i,r){const c=this.l(g);if(!c.read)throw new Error('FileSystemProvider does not implement "read"');const o=f.$fe.alloc(r);return Promise.resolve(c.read(t,i,o.buffer,0,r)).then(l=>o.slice(0,l))}$write(g,t,i,r){const c=this.l(g);if(!c.write)throw new Error('FileSystemProvider does not implement "write"');return Promise.resolve(c.write(t,i,r.buffer,0,r.byteLength))}l(g){const t=this.c.get(g);if(!t){const i=new Error;throw i.name="ENOPRO",i.message="no provider",i}return t}}e.$Uec=b}),define(Pe[63],Re([1,0,3,41,7,24,4,17,42,6,14,25,13]),function(be,e,y,F,P,M,A,$,E,f,C,D,u){"use strict";var b;Object.defineProperty(e,"__esModule",{value:!0}),e.$8dc=e.$7dc=void 0;let p=b=class{constructor(t,i){this.b=new Map,this.c=new C.$7g,this.a=t.getProxy(y.$xK.MainThreadFileSystem);const r=this;this.value=Object.freeze({async stat(c){try{let o;const l=r.b.get(c.scheme);return l?(await r.a.$ensureActivation(c.scheme),o=await l.impl.stat(c)):o=await r.a.$stat(c),{type:o.type,ctime:o.ctime,mtime:o.mtime,size:o.size,permissions:o.permissions===F.FilePermission.Readonly?1:void 0}}catch(o){b.e(o)}},async readDirectory(c){try{const o=r.b.get(c.scheme);return o?(await r.a.$ensureActivation(c.scheme),(await o.impl.readDirectory(c)).slice()):await r.a.$readdir(c)}catch(o){return b.e(o)}},async createDirectory(c){try{const o=r.b.get(c.scheme);return o&&!o.isReadonly?(await r.a.$ensureActivation(c.scheme),await r.d(o.impl,o.extUri,c)):await r.a.$mkdir(c)}catch(o){return b.e(o)}},async readFile(c){try{const o=r.b.get(c.scheme);return o?(await r.a.$ensureActivation(c.scheme),(await o.impl.readFile(c)).slice()):(await r.a.$readFile(c)).buffer}catch(o){return b.e(o)}},async writeFile(c,o){try{const l=r.b.get(c.scheme);return l&&!l.isReadonly?(await r.a.$ensureActivation(c.scheme),await r.d(l.impl,l.extUri,l.extUri.dirname(c)),await r.c.queueFor(c).queue(()=>Promise.resolve(l.impl.writeFile(c,o,{create:!0,overwrite:!0})))):await r.a.$writeFile(c,M.$fe.wrap(o))}catch(l){return b.e(l)}},async delete(c,o){try{const l=r.b.get(c.scheme);return l&&!l.isReadonly?(await r.a.$ensureActivation(c.scheme),await l.impl.delete(c,{recursive:!1,...o})):await r.a.$delete(c,{recursive:!1,useTrash:!1,atomic:!1,...o})}catch(l){return b.e(l)}},async rename(c,o,l){try{return await r.a.$rename(c,o,{overwrite:!1,...l})}catch(n){return b.e(n)}},async copy(c,o,l){try{return await r.a.$copy(c,o,{overwrite:!1,...l})}catch(n){return b.e(n)}},isWritableFileSystem(c){const o=i.getCapabilities(c);if(typeof o=="number")return!(o&2048)}})}async d(t,i,r){const c=[];for(;!i.isEqual(r,i.dirname(r));)try{if(!((await t.stat(r)).type&F.FileType.Directory))throw P.$ML.FileExists(`Unable to create folder '${r.scheme===u.Schemas.file?r.fsPath:r.toString(!0)}' that already exists but is not a directory`);break}catch(o){if(F.$uk(o)!==F.FileSystemProviderErrorCode.FileNotFound)throw o;c.push(i.basename(r)),r=i.dirname(r)}for(let o=c.length-1;o>=0;o--){r=i.joinPath(r,c[o]);try{await t.createDirectory(r)}catch(l){if(F.$uk(l)!==F.FileSystemProviderErrorCode.FileExists)throw l}}}static e(t){if(t instanceof P.$ML)throw t;if(t instanceof F.$qk)switch(t.code){case F.FileSystemProviderErrorCode.FileExists:throw P.$ML.FileExists(t.message);case F.FileSystemProviderErrorCode.FileNotFound:throw P.$ML.FileNotFound(t.message);case F.FileSystemProviderErrorCode.FileNotADirectory:throw P.$ML.FileNotADirectory(t.message);case F.FileSystemProviderErrorCode.FileIsADirectory:throw P.$ML.FileIsADirectory(t.message);case F.FileSystemProviderErrorCode.NoPermissions:throw P.$ML.NoPermissions(t.message);case F.FileSystemProviderErrorCode.Unavailable:throw P.$ML.Unavailable(t.message);default:throw new P.$ML(t.message,t.name)}if(!(t instanceof Error))throw new P.$ML(String(t));if(t.name==="ENOPRO"||t.message.includes("ENOPRO"))throw P.$ML.Unavailable(t.message);switch(t.name){case F.FileSystemProviderErrorCode.FileExists:throw P.$ML.FileExists(t.message);case F.FileSystemProviderErrorCode.FileNotFound:throw P.$ML.FileNotFound(t.message);case F.FileSystemProviderErrorCode.FileNotADirectory:throw P.$ML.FileNotADirectory(t.message);case F.FileSystemProviderErrorCode.FileIsADirectory:throw P.$ML.FileIsADirectory(t.message);case F.FileSystemProviderErrorCode.NoPermissions:throw P.$ML.NoPermissions(t.message);case F.FileSystemProviderErrorCode.Unavailable:throw P.$ML.Unavailable(t.message);default:throw new P.$ML(t.message,t.name)}}addFileSystemProvider(t,i,r){return this.b.set(t,{impl:i,extUri:r?.isCaseSensitive?D.$pg:D.$rg,isReadonly:!!r?.isReadonly}),(0,f.$Pc)(()=>this.b.delete(t))}getFileSystemProviderExtUri(t){return this.b.get(t)?.extUri??D.$pg}};e.$7dc=p,e.$7dc=p=b=Ke([Ve(0,$.$zM),Ve(1,E.$Hdc)],p),e.$8dc=(0,A.$Vh)("IExtHostConsumerFileSystem")}),define(Pe[249],Re([1,0,5,33,2,3,8,7,44]),function(be,e,y,F,P,M,A,$,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vec=void 0;class f{get ignoreCreateEvents(){return!!(this.h&1)}get ignoreChangeEvents(){return!!(this.h&2)}get ignoreDeleteEvents(){return!!(this.h&4)}constructor(b,p,g,t,i,r){this.a=Math.random(),this.b=new y.$Rd,this.c=new y.$Rd,this.d=new y.$Rd,this.h=0,r?.ignoreCreateEvents&&(this.h+=1),r?.ignoreChangeEvents&&(this.h+=2),r?.ignoreDeleteEvents&&(this.h+=4);const c=(0,F.$Cj)(i),o=typeof i=="string",l=r?.correlate,n=t(s=>{if(!(typeof s.session=="number"&&s.session!==this.a)&&!(l&&typeof s.session>"u")){if(!r?.ignoreCreateEvents)for(const a of s.created){const d=P.URI.revive(a);c(d.fsPath)&&(!o||p.getWorkspaceFolder(d))&&this.b.fire(d)}if(!r?.ignoreChangeEvents)for(const a of s.changed){const d=P.URI.revive(a);c(d.fsPath)&&(!o||p.getWorkspaceFolder(d))&&this.c.fire(d)}if(!r?.ignoreDeleteEvents)for(const a of s.deleted){const d=P.URI.revive(a);c(d.fsPath)&&(!o||p.getWorkspaceFolder(d))&&this.d.fire(d)}}});this.g=$.$zK.from(this.i(b,g,i,r,r?.correlate),this.b,this.c,this.d,n)}i(b,p,g,t,i){const r=$.$zK.from();if(typeof g=="string")return r;const c=b.getProxy(M.$xK.MainThreadFileSystemEventService);let o=!1;return(g.pattern.includes(F.$yj)||g.pattern.includes(F.$zj))&&(o=!0),c.$watch(p.identifier.value,this.a,g.baseUri,{recursive:o,excludes:t?.excludes??[]},!!i),$.$zK.from({dispose:()=>c.$unwatch(this.a)})}dispose(){this.g.dispose()}get onDidCreate(){return this.b.event}get onDidChange(){return this.c.event}get onDidDelete(){return this.d.event}}class C{constructor(b){this.a=b,this.session=this.a.session,this.b=new E.$U(()=>this.a.created.map(P.URI.revive)),this.c=new E.$U(()=>this.a.changed.map(P.URI.revive)),this.d=new E.$U(()=>this.a.deleted.map(P.URI.revive))}get created(){return this.b.value}get changed(){return this.c.value}get deleted(){return this.d.value}}class D{constructor(b,p,g){this.j=b,this.k=p,this.l=g,this.a=new y.$Rd,this.b=new y.$Rd,this.c=new y.$Rd,this.d=new y.$Rd,this.g=new y.$Td,this.h=new y.$Td,this.i=new y.$Td,this.onDidRenameFile=this.b.event,this.onDidCreateFile=this.c.event,this.onDidDeleteFile=this.d.event}createFileSystemWatcher(b,p,g,t){return new f(this.j,b,p,this.a.event,A.GlobPattern.from(g),t)}$onFileEvent(b){this.a.fire(new C(b))}$onDidRunFileOperation(b,p){switch(b){case 2:this.b.fire(Object.freeze({files:p.map(g=>({oldUri:P.URI.revive(g.source),newUri:P.URI.revive(g.target)}))}));break;case 1:this.d.fire(Object.freeze({files:p.map(g=>P.URI.revive(g.target))}));break;case 0:case 3:this.c.fire(Object.freeze({files:p.map(g=>P.URI.revive(g.target))}));break;default:}}getOnWillRenameFileEvent(b){return this.m(b,this.g)}getOnWillCreateFileEvent(b){return this.m(b,this.h)}getOnWillDeleteFileEvent(b){return this.m(b,this.i)}m(b,p){return(g,t,i)=>{const r=function(o){g.call(t,o)};return r.extension=b,p.event(r,void 0,i)}}async $onWillRunFileOperation(b,p,g,t){switch(b){case 2:return await this.n(this.g,{files:p.map(i=>({oldUri:P.URI.revive(i.source),newUri:P.URI.revive(i.target)}))},g,t);case 1:return await this.n(this.i,{files:p.map(i=>P.URI.revive(i.target))},g,t);case 0:case 3:return await this.n(this.h,{files:p.map(i=>P.URI.revive(i.target))},g,t)}}async n(b,p,g,t){const i=new Set,r=[];if(await b.fireAsync(p,t,async(o,l)=>{const n=Date.now(),s=await Promise.resolve(o);s instanceof $.$JK&&(r.push([l.extension,s]),i.add(l.extension.displayName??l.extension.identifier.value)),Date.now()-n>g&&this.k.warn("SLOW file-participant",l.extension.identifier)}),t.isCancellationRequested||r.length===0)return;const c={edits:[]};for(const[,o]of r){const{edits:l}=A.WorkspaceEdit.from(o,{getTextDocumentVersion:n=>this.l.getDocument(n)?.version,getNotebookDocumentVersion:()=>{}});c.edits=c.edits.concat(l)}return{edit:c,extensionNames:Array.from(i)}}}e.$Vec=D}),define(Pe[250],Re([1,0,6,2,3,8,7,32,14]),function(be,e,y,F,P,M,A,$,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wec=void 0;class f{static{this.a=0}constructor(b,p){this.extension=b,this.provider=p,this.handle=f.a++}}class C{constructor(b){this.session=b,this.responses=[]}}class D{static{this.a=0}constructor(b,p,g,t){this.f=g,this.g=t,this.b=new Map,this.d=new Map,this.e=b.getProxy(P.$xK.MainThreadInlineChat),p.registerApiCommand(new $.$ZM("vscode.editorChat.start","inlineChat.start","Invoke a new editor chat session",[new $.$XM("Run arguments","",i=>!0,i=>{if(i)return{initialRange:i.initialRange?M.Range.from(i.initialRange):void 0,initialSelection:i.initialSelection?M.Selection.from(i.initialSelection):void 0,message:i.message,autoSend:i.autoSend,position:i.position?M.Position.from(i.position):void 0}})],$.$YM.Void))}registerProvider(b,p,g){const t=new f(b,p);return this.b.set(t.handle,t),this.e.$registerInteractiveEditorProvider(t.handle,g.label,b.identifier.value,typeof p.handleInteractiveEditorResponseFeedback=="function"),(0,y.$Pc)(()=>{this.e.$unregisterInteractiveEditorProvider(t.handle),this.b.delete(t.handle)})}async $prepareSession(b,p,g,t){const i=this.b.get(b);if(!i){this.g.warn("CANNOT prepare session because the PROVIDER IS GONE");return}const r=this.f.getDocument(F.URI.revive(p)),c=M.Selection.to(g),o=await i.provider.prepareInteractiveEditorSession({document:r,selection:c},t);if(!o)return;if(o.wholeRange&&!o.wholeRange.contains(c))throw new Error("InteractiveEditorSessionProvider returned a wholeRange that does not contain the selection.");const l=D.a++;return this.d.set(l,new C(o)),{id:l,placeholder:o.placeholder,input:o.input,slashCommands:o.slashCommands?.map(n=>({command:n.command,detail:n.detail,refer:n.refer,executeImmediately:n.executeImmediately})),wholeRange:M.Range.from(o.wholeRange),message:o.message}}async $provideResponse(b,p,g,t){const i=this.b.get(b);if(!i)return;const r=this.d.get(p.id);if(!r)return;const c={prompt:g.prompt,selection:M.Selection.to(g.selection),wholeRange:M.Range.to(g.wholeRange),attempt:g.attempt,live:g.live};let o=!1;const l={report:async v=>{if(!g.live&&v.edits?.length)throw new Error("Progress reporting is only supported for live sessions");o||t.isCancellationRequested||await this.e.$handleProgressChunk(g.requestId,{message:v.message,edits:v.edits?.map(M.TextEdit.from),editsShouldBeInstant:v.editsShouldBeInstant,slashCommand:v.slashCommand?.command,markdownFragment:A.$ZK.isMarkdownString(v.content)?v.content.value:v.content})}},n=Promise.resolve(i.provider.provideInteractiveEditorResponse(r.session,c,l,t));let s;try{s=await(0,E.$Mg)(n,t)}finally{o=!0}if(!s)return;const a=r.responses.push(s)-1,d={wholeRange:M.Range.from(s.wholeRange),placeholder:s.placeholder};if(D.h(s)){const{edits:v,contents:m}=s,S=m!==void 0?M.MarkdownString.from(m):void 0;return v instanceof A.$JK?{...d,id:a,type:"bulkEdit",edits:M.WorkspaceEdit.from(v),message:S}:{...d,id:a,type:"editorEdit",edits:v.map(M.TextEdit.from),message:S}}return{...d,id:a,type:"message",message:M.MarkdownString.from(s.contents)}}$handleFeedback(b,p,g,t){const i=this.b.get(b),r=this.d.get(p),c=r?.responses[g];if(i&&c){const o=M.InteractiveEditorResponseFeedbackKind.to(t);i.provider.handleInteractiveEditorResponseFeedback?.(r.session,c,o)}}$releaseSession(b,p){}static h(b){return typeof b=="object"&&typeof b.edits=="object"}}e.$Wec=D}),define(Pe[251],Re([1,0,2,32]),function(be,e,y,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0ec=void 0;class P{constructor(A,$,E,f,C){this.a=$,this.b=E,this.c=f;const D=new F.$ZM("interactive.open","_interactive.open","Open interactive window and return notebook editor and input URI",[new F.$XM("showOptions","Show Options",u=>!0,u=>u),new F.$XM("resource","Interactive resource Uri",u=>!0,u=>u),new F.$XM("controllerId","Notebook controller Id",u=>!0,u=>u),new F.$XM("title","Interactive editor title",u=>!0,u=>u)],new F.$YM("Notebook and input URI",u=>{if(C.debug("[ExtHostInteractive] open iw with notebook editor id",u.notebookEditorId),u.notebookEditorId!==void 0){const b=this.a.getEditorById(u.notebookEditorId);return C.debug("[ExtHostInteractive] notebook editor found",b.id),{notebookUri:y.URI.revive(u.notebookUri),inputUri:y.URI.revive(u.inputUri),notebookEditor:b.apiEditor}}return C.debug("[ExtHostInteractive] notebook editor not found, uris for the interactive document",u.notebookUri,u.inputUri),{notebookUri:y.URI.revive(u.notebookUri),inputUri:y.URI.revive(u.inputUri)}}));this.c.registerApiCommand(D)}$willAddInteractiveDocument(A,$,E,f){this.b.acceptDocumentsAndEditorsDelta({addedDocuments:[{EOL:$,lines:[""],languageId:E,uri:A,isDirty:!1,versionId:1,notebook:this.a.getNotebookDocument(y.URI.revive(f))?.apiNotebook}]})}$willRemoveInteractiveDocument(A,$){this.b.acceptDocumentsAndEditorsDelta({removedDocuments:[A]})}}e.$0ec=P}),define(Pe[252],Re([1,0,3,7]),function(be,e,y,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$ec=void 0;class P{constructor(A){this.a=new Map,this.b=new Map,this.c=A.getProxy(y.$xK.MainThreadIssueReporter)}async $getIssueReporterUri(A,$){if(this.a.size===0)throw new Error("No issue request handlers registered");const E=this.a.get(A);if(!E)throw new Error("Issue request handler not found");const f=await E.handleIssueUrlRequest();if(!f)throw new Error("Issue request handler returned no result");return f}async $getIssueReporterData(A,$){if(this.b.size===0)throw new Error("No issue request handlers registered");const E=this.b.get(A);if(!E)throw new Error("Issue data provider not found");const f=await E.provideIssueData($);if(!f)throw new Error("Issue data provider returned no result");return f}async $getIssueReporterTemplate(A,$){if(this.b.size===0)throw new Error("No issue request handlers registered");const E=this.b.get(A);if(!E)throw new Error("Issue data provider not found");const f=await E.provideIssueTemplate($);if(!f)throw new Error("Issue template provider returned no result");return f}registerIssueUriRequestHandler(A,$){const E=A.identifier.value;return this.a.set(E,$),this.c.$registerIssueUriRequestHandler(E),new F.$zK(()=>{this.c.$unregisterIssueUriRequestHandler(E),this.a.delete(E)})}registerIssueDataProvider(A,$){const E=A.identifier.value;return this.b.set(E,$),this.c.$registerIssueDataProvider(E),new F.$zK(()=>{this.c.$unregisterIssueDataProvider(E),this.b.delete(E)})}}e.$$ec=P}),define(Pe[253],Re([1,0,6,3]),function(be,e,y,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_ec=void 0;class P{constructor(A){this.b=0,this.a=A.getProxy(F.$xK.MainThreadLabelService)}$registerResourceLabelFormatter(A){const $=this.b++;return this.a.$registerResourceLabelFormatter($,A),(0,y.$Pc)(()=>{this.a.$unregisterResourceLabelFormatter($)})}}e.$_ec=P}),define(Pe[254],Re([1,0,2,26,8,7,80,3,12,29,18,16,297,20,22,6,95,89,75,60,11,14,23,160]),function(be,e,y,F,P,M,A,$,E,f,C,D,u,b,p,g,t,i,r,c,o,l,n,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ndc=void 0;class a{constructor(O,W){this.d=O,this.e=W}async provideDocumentSymbols(O,W){const G=this.d.getDocument(O),J=await this.e.provideDocumentSymbols(G,W);if(!(0,C.$Jb)(J))return J[0]instanceof M.$RK?J.map(P.DocumentSymbol.from):a.f(J)}static f(O){O=O.slice(0).sort((J,q)=>{let x=J.location.range.start.compareTo(q.location.range.start);return x===0&&(x=q.location.range.end.compareTo(J.location.range.end)),x});const W=[],G=[];for(const J of O){const q={name:J.name||"!!MISSING: name!!",kind:P.SymbolKind.from(J.kind),tags:J.tags?.map(P.SymbolTag.from)||[],detail:"",containerName:J.containerName,range:P.Range.from(J.location.range),selectionRange:P.Range.from(J.location.range),children:[]};for(;;){if(G.length===0){G.push(q),W.push(q);break}const x=G[G.length-1];if(f.$zs.containsRange(x.range,q.range)&&!f.$zs.equalsRange(x.range,q.range)){x.children?.push(q),G.push(q);break}G.pop()}}return W}}class d{static{this.d={command:"missing",title:"!!MISSING: command!!"}}constructor(O,W,G){this.g=O,this.h=W,this.j=G,this.e=new r.$Ddc("CodeLens"),this.f=new Map}async provideCodeLenses(O,W){const G=this.g.getDocument(O),J=await this.j.provideCodeLenses(G,W);if(!J||W.isCancellationRequested)return;const q=this.e.add(J),x=new g.$Qc;this.f.set(q,x);const ue={cacheId:q,lenses:[]};for(let Oe=0;Oe<J.length;Oe++)ue.lenses.push({cacheId:[q,Oe],range:P.Range.from(J[Oe].range),command:this.h.toInternal(J[Oe].command,x)});return ue}async resolveCodeLens(O,W){const G=O.cacheId&&this.e.get(...O.cacheId);if(!G)return;let J;if(typeof this.j.resolveCodeLens!="function"||G.isResolved?J=G:J=await this.j.resolveCodeLens(G,W),J||(J=G),W.isCancellationRequested)return;const q=O.cacheId&&this.f.get(O.cacheId[0]);if(q)return O.command=this.h.toInternal(J.command??d.d,q),O}releaseCodeLenses(O){this.f.get(O)?.dispose(),this.f.delete(O),this.e.delete(O)}}function v(Ie){return Array.isArray(Ie)?Ie.map(P.DefinitionLink.from):Ie?[P.DefinitionLink.from(Ie)]:[]}class m{constructor(O,W){this.d=O,this.e=W}async provideDefinition(O,W,G){const J=this.d.getDocument(O),q=P.Position.to(W),x=await this.e.provideDefinition(J,q,G);return v(x)}}class S{constructor(O,W){this.d=O,this.e=W}async provideDeclaration(O,W,G){const J=this.d.getDocument(O),q=P.Position.to(W),x=await this.e.provideDeclaration(J,q,G);return v(x)}}class k{constructor(O,W){this.d=O,this.e=W}async provideImplementation(O,W,G){const J=this.d.getDocument(O),q=P.Position.to(W),x=await this.e.provideImplementation(J,q,G);return v(x)}}class h{constructor(O,W){this.d=O,this.e=W}async provideTypeDefinition(O,W,G){const J=this.d.getDocument(O),q=P.Position.to(W),x=await this.e.provideTypeDefinition(J,q,G);return v(x)}}class w{constructor(O,W){this.d=O,this.e=W}async provideHover(O,W,G){const J=this.d.getDocument(O),q=P.Position.to(W),x=await this.e.provideHover(J,q,G);if(!(!x||(0,C.$Jb)(x.contents)))return x.range||(x.range=J.getWordRangeAtPosition(q)),x.range||(x.range=new M.$BK(q,q)),P.Hover.from(x)}}class I{constructor(O,W){this.d=O,this.e=W}async provideEvaluatableExpression(O,W,G){const J=this.d.getDocument(O),q=P.Position.to(W),x=await this.e.provideEvaluatableExpression(J,q,G);if(x)return P.EvaluatableExpression.from(x)}}class L{constructor(O,W){this.d=O,this.e=W}async provideInlineValues(O,W,G,J){const q=this.d.getDocument(O),x=await this.e.provideInlineValues(q,P.Range.to(W),P.InlineValueContext.to(G),J);if(Array.isArray(x))return x.map(ue=>P.InlineValue.from(ue))}}class V{constructor(O,W){this.d=O,this.e=W}async provideDocumentHighlights(O,W,G){const J=this.d.getDocument(O),q=P.Position.to(W),x=await this.e.provideDocumentHighlights(J,q,G);if(Array.isArray(x))return x.map(P.DocumentHighlight.from)}}class K{constructor(O,W){this.d=O,this.e=W}async provideLinkedEditingRanges(O,W,G){const J=this.d.getDocument(O),q=P.Position.to(W),x=await this.e.provideLinkedEditingRanges(J,q,G);if(x&&Array.isArray(x.ranges))return{ranges:(0,C.$Gb)(x.ranges.map(P.Range.from)),wordPattern:x.wordPattern}}}class R{constructor(O,W){this.d=O,this.e=W}async provideReferences(O,W,G,J){const q=this.d.getDocument(O),x=P.Position.to(W),ue=await this.e.provideReferences(q,x,G,J);if(Array.isArray(ue))return ue.map(P.location.from)}}class N{static{this.d=1e3}constructor(O,W,G,J,q,x,ue){this.g=O,this.h=W,this.j=G,this.k=J,this.l=q,this.m=x,this.n=ue,this.e=new r.$Ddc("CodeAction"),this.f=new Map}async provideCodeActions(O,W,G,J){const q=this.g.getDocument(O),x=u.$Bs.isISelection(W)?P.Selection.to(W):P.Range.to(W),ue=[];for(const _e of this.j.getDiagnostics(O))if(x.intersection(_e.range)&&ue.push(_e)>N.d)break;const Oe={diagnostics:ue,only:G.only?new M.$TK(G.only):void 0,triggerKind:P.CodeActionTriggerKind.to(G.trigger)},Ue=await this.k.provideCodeActions(q,x,Oe,J);if(!(0,C.$Kb)(Ue)||J.isCancellationRequested)return;const Ze=this.e.add(Ue),Je=new g.$Qc;this.f.set(Ze,Je);const tt=[];for(let _e=0;_e<Ue.length;_e++){const et=Ue[_e];et&&(N.o(et)?(this.n.report("CodeActionProvider.provideCodeActions - return commands",this.m,"Return 'CodeAction' instances instead."),tt.push({_isSynthetic:!0,title:et.title,command:this.h.toInternal(et,Je)})):(Oe.only&&(et.kind?Oe.only.contains(et.kind)||this.l.warn(`${this.m.identifier.value} - Code actions of kind '${Oe.only.value} 'requested but returned code action is of kind '${et.kind.value}'. Code action will be dropped. Please check 'CodeActionContext.only' to only return requested code actions.`):this.l.warn(`${this.m.identifier.value} - Code actions of kind '${Oe.only.value} 'requested but returned code action does not have a 'kind'. Code action will be dropped. Please set 'CodeAction.kind'.`)),tt.push({cacheId:[Ze,_e],title:et.title,command:et.command&&this.h.toInternal(et.command,Je),diagnostics:et.diagnostics&&et.diagnostics.map(P.Diagnostic.from),edit:et.edit&&P.WorkspaceEdit.from(et.edit,void 0),kind:et.kind&&et.kind.value,isPreferred:et.isPreferred,isAI:(0,n.$LF)(this.m,"codeActionAI")?et.isAI:!1,disabled:et.disabled?.reason})))}return{cacheId:Ze,actions:tt}}async resolveCodeAction(O,W){const[G,J]=O,q=this.e.get(G,J);if(!q||N.o(q))return{};if(!this.k.resolveCodeAction)return{};const x=await this.k.resolveCodeAction(q,W)??q;let ue;x.edit&&(ue=P.WorkspaceEdit.from(x.edit,void 0));let Oe;if(x.command){const Ue=this.f.get(G);Ue&&(Oe=this.h.toInternal(x.command,Ue))}return{edit:ue,command:Oe}}releaseCodeActions(O){this.f.get(O)?.dispose(),this.f.delete(O),this.e.delete(O)}static o(O){return typeof O.command=="string"&&typeof O.title=="string"}}class T{static toInternalProviderId(O,W){return O+"."+W}constructor(O,W,G,J,q){this.d=O,this.e=W,this.f=G,this.g=J,this.h=q}async prepareDocumentPaste(O,W,G,J){if(!this.f.prepareDocumentPaste)return;const q=this.e.getDocument(O),x=W.map(Ue=>P.Range.to(Ue)),ue=P.DataTransfer.toDataTransfer(G,()=>{throw new o.$0});if(await this.f.prepareDocumentPaste(q,x,ue,J),J.isCancellationRequested)return;const Oe=Array.from(ue).filter(([,Ue])=>!(Ue instanceof M.$nL));return P.DataTransfer.from(Oe)}async providePasteEdits(O,W,G,J,q){if(!this.f.provideDocumentPasteEdits)return;const x=this.e.getDocument(W),ue=G.map(Ze=>P.Range.to(Ze)),Oe=P.DataTransfer.toDataTransfer(J,async Ze=>(await this.d.$resolvePasteFileData(this.g,O,Ze)).buffer),Ue=await this.f.provideDocumentPasteEdits(x,ue,Oe,q);if(Ue)return{label:Ue.label??(0,s.localize)(0,null,this.h.displayName||this.h.name),detail:this.h.displayName||this.h.name,yieldTo:Ue.yieldTo?.map(Ze=>"mimeType"in Ze?Ze:{providerId:T.toInternalProviderId(Ze.extensionId,Ze.providerId)}),insertText:typeof Ue.insertText=="string"?Ue.insertText:{snippet:Ue.insertText.value},additionalEdit:Ue.additionalEdit?P.WorkspaceEdit.from(Ue.additionalEdit,void 0):void 0}}}class z{constructor(O,W){this.d=O,this.e=W}async provideDocumentFormattingEdits(O,W,G){const J=this.d.getDocument(O),q=await this.e.provideDocumentFormattingEdits(J,W,G);if(Array.isArray(q))return q.map(P.TextEdit.from)}}class Z{constructor(O,W){this.d=O,this.e=W}async provideDocumentRangeFormattingEdits(O,W,G,J){const q=this.d.getDocument(O),x=P.Range.to(W),ue=await this.e.provideDocumentRangeFormattingEdits(q,x,G,J);if(Array.isArray(ue))return ue.map(P.TextEdit.from)}async provideDocumentRangesFormattingEdits(O,W,G,J){(0,D.$Mf)(typeof this.e.provideDocumentRangesFormattingEdits=="function","INVALID invocation of `provideDocumentRangesFormattingEdits`");const q=this.d.getDocument(O),x=W.map(P.Range.to),ue=await this.e.provideDocumentRangesFormattingEdits(q,x,G,J);if(Array.isArray(ue))return ue.map(P.TextEdit.from)}}class he{constructor(O,W){this.d=O,this.e=W,this.autoFormatTriggerCharacters=[]}async provideOnTypeFormattingEdits(O,W,G,J,q){const x=this.d.getDocument(O),ue=P.Position.to(W),Oe=await this.e.provideOnTypeFormattingEdits(x,ue,G,J,q);if(Array.isArray(Oe))return Oe.map(P.TextEdit.from)}}class ye{constructor(O,W){this.e=O,this.f=W,this.d=new r.$Ddc("WorkspaceSymbols")}async provideWorkspaceSymbols(O,W){const G=await this.e.provideWorkspaceSymbols(O,W);if(!(0,C.$Kb)(G))return{symbols:[]};const J=this.d.add(G),q={cacheId:J,symbols:[]};for(let x=0;x<G.length;x++){const ue=G[x];if(!ue||!ue.name){this.f.warn("INVALID SymbolInformation",ue);continue}q.symbols.push({...P.WorkspaceSymbol.from(ue),cacheId:[J,x]})}return q}async resolveWorkspaceSymbol(O,W){if(typeof this.e.resolveWorkspaceSymbol!="function"||!O.cacheId)return O;const G=this.d.get(...O.cacheId);if(G){const J=await this.e.resolveWorkspaceSymbol(G,W);return J&&(0,F.$dn)(O,P.WorkspaceSymbol.from(J),!0)}}releaseWorkspaceSymbols(O){this.d.delete(O)}}class De{static supportsResolving(O){return typeof O.prepareRename=="function"}constructor(O,W,G){this.d=O,this.e=W,this.f=G}async provideRenameEdits(O,W,G,J){const q=this.d.getDocument(O),x=P.Position.to(W);try{const ue=await this.e.provideRenameEdits(q,x,G,J);return ue?P.WorkspaceEdit.from(ue):void 0}catch(ue){const Oe=De.g(ue);return Oe?{rejectReason:Oe,edits:void 0}:Promise.reject(ue)}}async resolveRenameLocation(O,W,G){if(typeof this.e.prepareRename!="function")return Promise.resolve(void 0);const J=this.d.getDocument(O),q=P.Position.to(W);try{const x=await this.e.prepareRename(J,q,G);let ue,Oe;if(M.$BK.isRange(x)?(ue=x,Oe=J.getText(x)):(0,D.$Ef)(x)&&(ue=x.range,Oe=x.placeholder),!ue||!Oe)return;if(ue.start.line>q.line||ue.end.line<q.line){this.f.warn("INVALID rename location: position line must be within range start/end lines");return}return{range:P.Range.from(ue),text:Oe}}catch(x){const ue=De.g(x);return ue?{rejectReason:ue,range:void 0,text:void 0}:Promise.reject(x)}}static g(O){return typeof O=="string"?O:O instanceof Error&&typeof O.message=="string"?O.message:void 0}}class Se{constructor(O,W){this.resultId=O,this.tokens=W}}class fe{constructor(O,W){this.f=O,this.g=W,this.e=1,this.d=new Map}async provideDocumentSemanticTokens(O,W,G){const J=this.f.getDocument(O),q=W!==0?this.d.get(W):null;let x=typeof q?.resultId=="string"&&typeof this.g.provideDocumentSemanticTokensEdits=="function"?await this.g.provideDocumentSemanticTokensEdits(J,q.resultId,G):await this.g.provideDocumentSemanticTokens(J,G);return q&&this.d.delete(W),x?(x=fe.h(x),this.o(fe.n(q,x),x)):null}async releaseDocumentSemanticColoring(O){this.d.delete(O)}static h(O){return fe.j(O)?fe.k(O)?O:new M.$QL(new Uint32Array(O.data),O.resultId):fe.l(O)?fe.m(O)?O:new M.$SL(O.edits.map(W=>new M.$RL(W.start,W.deleteCount,W.data?new Uint32Array(W.data):W.data)),O.resultId):O}static j(O){return O&&!!O.data}static k(O){return O.data instanceof Uint32Array}static l(O){return O&&Array.isArray(O.edits)}static m(O){for(const W of O.edits)if(!(W.data instanceof Uint32Array))return!1;return!0}static n(O,W){if(!fe.j(W)||!O||!O.tokens)return W;const G=O.tokens,J=G.length,q=W.data,x=q.length;let ue=0;const Oe=Math.min(J,x);for(;ue<Oe&&G[ue]===q[ue];)ue++;if(ue===J&&ue===x)return new M.$SL([],W.resultId);let Ue=0;const Ze=Oe-ue;for(;Ue<Ze&&G[J-Ue-1]===q[x-Ue-1];)Ue++;return new M.$SL([{start:ue,deleteCount:J-ue-Ue,data:q.subarray(ue,x-Ue)}],W.resultId)}o(O,W){if(fe.j(O)){const G=this.e++;return this.d.set(G,new Se(O.resultId,O.data)),(0,t.$w$)({id:G,type:"full",data:O.data})}if(fe.l(O)){const G=this.e++;return fe.j(W)?this.d.set(G,new Se(W.resultId,W.data)):this.d.set(G,new Se(O.resultId)),(0,t.$w$)({id:G,type:"delta",deltas:(O.edits||[]).map(J=>({start:J.start,deleteCount:J.deleteCount,data:J.data}))})}return null}}class $e{constructor(O,W){this.d=O,this.e=W}async provideDocumentRangeSemanticTokens(O,W,G){const J=this.d.getDocument(O),q=await this.e.provideDocumentRangeSemanticTokens(J,P.Range.to(W),G);return q?this.f(q):null}f(O){return(0,t.$w$)({id:0,type:"full",data:O.data})}}class re{static supportsResolving(O){return typeof O.resolveCompletionItem=="function"}constructor(O,W,G,J,q){this.f=O,this.g=W,this.h=G,this.j=J,this.k=q,this.d=new r.$Ddc("CompletionItem"),this.e=new Map}async provideCompletionItems(O,W,G,J){const q=this.f.getDocument(O),x=P.Position.to(W),ue=q.getWordRangeAtPosition(x)||new M.$BK(x,x),Oe=ue.with({end:x}),Ue=new c.$Nd,Ze=await this.h.provideCompletionItems(q,x,J,P.CompletionContext.to(G));if(!Ze||J.isCancellationRequested)return;const Je=Array.isArray(Ze)?new M.$7K(Ze):Ze,tt=re.supportsResolving(this.h)?this.d.add(Je.items):this.d.add([]),_e=new g.$Qc;this.e.set(tt,_e);const et=[],rt={x:tt,b:et,a:{replace:P.Range.from(ue),insert:P.Range.from(Oe)},c:Je.isIncomplete||void 0,d:Ue.elapsed()};for(let nt=0;nt<Je.items.length;nt++){const Ne=Je.items[nt],dt=this.l(Ne,[tt,nt],Oe,ue);et.push(dt)}return rt}async resolveCompletionItem(O,W){if(typeof this.h.resolveCompletionItem!="function")return;const G=this.d.get(...O);if(!G)return;const J=this.l(G,O),q=await this.h.resolveCompletionItem(G,W);if(!q)return;const x=this.l(q,O);return(J.h!==x.h||J.i!==x.i)&&this.j.report("CompletionItem.insertText",this.k,"extension MAY NOT change 'insertText' of a CompletionItem during resolve"),(J.n!==x.n||J.o!==x.o||!(0,F.$en)(J.p,x.p))&&this.j.report("CompletionItem.command",this.k,"extension MAY NOT change 'command' of a CompletionItem during resolve"),{...J,d:x.d,c:x.c,l:x.l,h:x.h,i:x.i,n:x.n,o:x.o,p:x.p}}releaseCompletionItems(O){this.e.get(O)?.dispose(),this.e.delete(O),this.d.delete(O)}l(O,W,G,J){const q=this.e.get(W[0]);if(!q)throw Error("DisposableStore is missing...");const x=this.g.toInternal(O.command,q),ue={x:W,a:O.label,b:O.kind!==void 0?P.CompletionItemKind.from(O.kind):void 0,m:O.tags&&O.tags.map(P.CompletionItemTag.from),c:O.detail,d:typeof O.documentation>"u"?void 0:P.MarkdownString.fromStrict(O.documentation),e:O.sortText!==O.label?O.sortText:void 0,f:O.filterText!==O.label?O.filterText:void 0,g:O.preselect||void 0,i:O.keepWhitespace?1:0,k:O.commitCharacters?.join(""),l:O.additionalTextEdits&&O.additionalTextEdits.map(P.TextEdit.from),n:x?.$ident,o:x?.id,p:x?.$ident?void 0:x?.arguments};O.textEdit?(this.j.report("CompletionItem.textEdit",this.k,"Use 'CompletionItem.insertText' and 'CompletionItem.range' instead."),ue.h=O.textEdit.newText):typeof O.insertText=="string"?ue.h=O.insertText:O.insertText instanceof M.$KK&&(ue.h=O.insertText.value,ue.i|=4);let Oe;return O.textEdit?Oe=O.textEdit.range:O.range&&(Oe=O.range),M.$BK.isRange(Oe)?ue.j=P.Range.from(Oe):Oe&&(!G?.isEqual(Oe.inserting)||!J?.isEqual(Oe.replacing))&&(ue.j={insert:P.Range.from(Oe.inserting),replace:P.Range.from(Oe.replacing)}),ue}}class Ae{async provideInlineCompletions(O,W,G,J){}disposeCompletions(O){}handleDidShowCompletionItem(O,W,G){}handlePartialAccept(O,W,G){}}class se extends Ae{constructor(O,W,G,J){super(),this.f=O,this.g=W,this.h=G,this.j=J,this.d=new X,this.e=(0,n.$LF)(this.f,"inlineCompletionsAdditions"),this.k={[A.InlineCompletionTriggerKind.Automatic]:M.InlineCompletionTriggerKind.Automatic,[A.InlineCompletionTriggerKind.Explicit]:M.InlineCompletionTriggerKind.Invoke}}get supportsHandleEvents(){return(0,n.$LF)(this.f,"inlineCompletionsAdditions")&&(typeof this.h.handleDidShowCompletionItem=="function"||typeof this.h.handleDidPartiallyAcceptCompletionItem=="function")}async provideInlineCompletions(O,W,G,J){const q=this.g.getDocument(O),x=P.Position.to(W),ue=await this.h.provideInlineCompletionItems(q,x,{selectedCompletionInfo:G.selectedSuggestionInfo?{range:P.Range.to(G.selectedSuggestionInfo.range),text:G.selectedSuggestionInfo.text}:void 0,triggerKind:this.k[G.triggerKind]},J);if(!ue||J.isCancellationRequested)return;const Oe=Array.isArray(ue)?ue:ue.items,Ue=this.e?Array.isArray(ue)?[]:ue.commands||[]:[],Ze=this.e&&!Array.isArray(ue)?ue.enableForwardStability:void 0;let Je;return{pid:this.d.createReferenceId({dispose(){Je?.dispose()},items:Oe}),items:Oe.map((_e,et)=>{let rt;_e.command&&(Je||(Je=new g.$Qc),rt=this.j.toInternal(_e.command,Je));const nt=_e.insertText;return{insertText:typeof nt=="string"?nt:{snippet:nt.value},filterText:_e.filterText,range:_e.range?P.Range.from(_e.range):void 0,command:rt,idx:et,completeBracketPairs:this.e?_e.completeBracketPairs:!1}}),commands:Ue.map(_e=>(Je||(Je=new g.$Qc),this.j.toInternal(_e,Je))),suppressSuggestions:!1,enableForwardStability:Ze}}disposeCompletions(O){this.d.disposeReferenceId(O)?.dispose()}handleDidShowCompletionItem(O,W,G){const J=this.d.get(O)?.items[W];J&&this.h.handleDidShowCompletionItem&&this.e&&this.h.handleDidShowCompletionItem(J,G)}handlePartialAccept(O,W,G){const J=this.d.get(O)?.items[W];J&&this.h.handleDidPartiallyAcceptCompletionItem&&this.e&&this.h.handleDidPartiallyAcceptCompletionItem(J,G)}}class X{constructor(){this.d=new Map,this.e=1}createReferenceId(O){const W=this.e++;return this.d.set(W,O),W}disposeReferenceId(O){const W=this.d.get(O);return this.d.delete(O),W}get(O){return this.d.get(O)}}class B{constructor(O,W){this.e=O,this.f=W,this.d=new r.$Ddc("SignatureHelp")}async provideSignatureHelp(O,W,G,J){const q=this.e.getDocument(O),x=P.Position.to(W),ue=this.g(G),Oe=await this.f.provideSignatureHelp(q,x,J,ue);if(Oe){const Ue=this.d.add([Oe]);return{...P.SignatureHelp.from(Oe),id:Ue}}}g(O){let W;if(O.activeSignatureHelp){const G=P.SignatureHelp.to(O.activeSignatureHelp),J=this.d.get(O.activeSignatureHelp.id,0);J?(W=J,W.activeSignature=G.activeSignature,W.activeParameter=G.activeParameter):W=G}return{...O,activeSignatureHelp:W}}releaseSignatureHelp(O){this.d.delete(O)}}class ie{constructor(O,W,G,J,q){this.f=O,this.g=W,this.h=G,this.j=J,this.k=q,this.d=new r.$Ddc("InlayHints"),this.e=new Map}async provideInlayHints(O,W,G){const J=this.f.getDocument(O),q=P.Range.to(W),x=await this.h.provideInlayHints(J,q,G);if(!Array.isArray(x)||x.length===0){this.j.trace(`[InlayHints] NO inlay hints from '${this.k.identifier.value}' for ${W}`);return}if(G.isCancellationRequested)return;const ue=this.d.add(x);this.e.set(ue,new g.$Qc);const Oe={hints:[],cacheId:ue};for(let Ue=0;Ue<x.length;Ue++)this.l(x[Ue],q)&&Oe.hints.push(this.m(x[Ue],[ue,Ue]));return this.j.trace(`[InlayHints] ${Oe.hints.length} inlay hints from '${this.k.identifier.value}' for ${W}`),Oe}async resolveInlayHint(O,W){if(typeof this.h.resolveInlayHint!="function")return;const G=this.d.get(...O);if(!G)return;const J=await this.h.resolveInlayHint(G,W);if(J&&this.l(J))return this.m(J,O)}releaseHints(O){this.e.get(O)?.dispose(),this.e.delete(O),this.d.delete(O)}l(O,W){return O.label.length===0||Array.isArray(O.label)&&O.label.every(G=>G.value.length===0)?(console.log("INVALID inlay hint, empty label",O),!1):!(W&&!W.contains(O.position))}m(O,W){const G=this.e.get(W[0]);if(!G)throw Error("DisposableStore is missing...");const J={label:"",cacheId:W,tooltip:P.MarkdownString.fromStrict(O.tooltip),position:P.Position.from(O.position),textEdits:O.textEdits&&O.textEdits.map(P.TextEdit.from),kind:O.kind&&P.InlayHintKind.from(O.kind),paddingLeft:O.paddingLeft,paddingRight:O.paddingRight};return typeof O.label=="string"?J.label=O.label:J.label=O.label.map(q=>{const x={label:q.value};return x.tooltip=P.MarkdownString.fromStrict(q.tooltip),M.$LK.isLocation(q.location)&&(x.location=P.location.from(q.location)),q.command&&(x.command=this.g.toInternal(q.command,G)),x}),J}}class pe{constructor(O,W){this.e=O,this.f=W,this.d=new r.$Ddc("DocumentLink")}async provideLinks(O,W){const G=this.e.getDocument(O),J=await this.f.provideDocumentLinks(G,W);if(!(!Array.isArray(J)||J.length===0)&&!W.isCancellationRequested){if(typeof this.f.resolveDocumentLink!="function")return{links:J.filter(pe.g).map(P.DocumentLink.from)};{const q=this.d.add(J),x={links:[],cacheId:q};for(let ue=0;ue<J.length;ue++){if(!pe.g(J[ue]))continue;const Oe=P.DocumentLink.from(J[ue]);Oe.cacheId=[q,ue],x.links.push(Oe)}return x}}}static g(O){return O.target&&O.target.path.length>5e4?(console.warn("DROPPING link because it is too long"),!1):!0}async resolveLink(O,W){if(typeof this.f.resolveDocumentLink!="function")return;const G=this.d.get(...O);if(!G)return;const J=await this.f.resolveDocumentLink(G,W);if(!(!J||!pe.g(J)))return P.DocumentLink.from(J)}releaseLinks(O){this.d.delete(O)}}class ne{constructor(O,W){this.d=O,this.e=W}async provideColors(O,W){const G=this.d.getDocument(O),J=await this.e.provideDocumentColors(G,W);return Array.isArray(J)?J.map(x=>({color:P.Color.from(x.color),range:P.Range.from(x.range)})):[]}async provideColorPresentations(O,W,G){const J=this.d.getDocument(O),q=P.Range.to(W.range),x=P.Color.to(W.color),ue=await this.e.provideColorPresentations(x,{document:J,range:q},G);if(Array.isArray(ue))return ue.map(P.ColorPresentation.from)}}class le{constructor(O,W){this.d=O,this.e=W}async provideFoldingRanges(O,W,G){const J=this.d.getDocument(O),q=await this.e.provideFoldingRanges(J,W,G);if(Array.isArray(q))return q.map(P.FoldingRange.from)}}class ce{constructor(O,W,G){this.d=O,this.e=W,this.f=G}async provideSelectionRanges(O,W,G){const J=this.d.getDocument(O),q=W.map(P.Position.to),x=await this.e.provideSelectionRanges(J,q,G);if(!(0,C.$Kb)(x))return[];if(x.length!==q.length)return this.f.warn("BAD selection ranges, provider must return ranges for each position"),[];const ue=[];for(let Oe=0;Oe<q.length;Oe++){const Ue=[];ue.push(Ue);let Ze=q[Oe],Je=x[Oe];for(;;){if(!Je.range.contains(Ze))throw new Error("INVALID selection range, must contain the previous range");if(Ue.push(P.SelectionRange.from(Je)),!Je.parent)break;Ze=Je.range,Je=Je.parent}}return ue}}class we{constructor(O,W){this.f=O,this.g=W,this.d=new i.$EM(""),this.e=new Map}async prepareSession(O,W,G){const J=this.f.getDocument(O),q=P.Position.to(W),x=await this.g.prepareCallHierarchy(J,q,G);if(!x)return;const ue=this.d.nextId();return this.e.set(ue,new Map),Array.isArray(x)?x.map(Oe=>this.h(ue,Oe)):[this.h(ue,x)]}async provideCallsTo(O,W,G){const J=this.j(O,W);if(!J)throw new Error("missing call hierarchy item");const q=await this.g.provideCallHierarchyIncomingCalls(J,G);if(q)return q.map(x=>({from:this.h(O,x.from),fromRanges:x.fromRanges.map(ue=>P.Range.from(ue))}))}async provideCallsFrom(O,W,G){const J=this.j(O,W);if(!J)throw new Error("missing call hierarchy item");const q=await this.g.provideCallHierarchyOutgoingCalls(J,G);if(q)return q.map(x=>({to:this.h(O,x.to),fromRanges:x.fromRanges.map(ue=>P.Range.from(ue))}))}releaseSession(O){this.e.delete(O)}h(O,W){const G=this.e.get(O),J=P.CallHierarchyItem.from(W,O,G.size.toString(36));return G.set(J._itemId,W),J}j(O,W){return this.e.get(O)?.get(W)}}class _{constructor(O,W){this.f=O,this.g=W,this.d=new i.$EM(""),this.e=new Map}async prepareSession(O,W,G){const J=this.f.getDocument(O),q=P.Position.to(W),x=await this.g.prepareTypeHierarchy(J,q,G);if(!x)return;const ue=this.d.nextId();return this.e.set(ue,new Map),Array.isArray(x)?x.map(Oe=>this.h(ue,Oe)):[this.h(ue,x)]}async provideSupertypes(O,W,G){const J=this.j(O,W);if(!J)throw new Error("missing type hierarchy item");const q=await this.g.provideTypeHierarchySupertypes(J,G);if(q)return q.map(x=>this.h(O,x))}async provideSubtypes(O,W,G){const J=this.j(O,W);if(!J)throw new Error("missing type hierarchy item");const q=await this.g.provideTypeHierarchySubtypes(J,G);if(q)return q.map(x=>this.h(O,x))}releaseSession(O){this.e.delete(O)}h(O,W){const G=this.e.get(O),J=P.TypeHierarchyItem.from(W,O,G.size.toString(36));return G.set(J._itemId,W),J}j(O,W){return this.e.get(O)?.get(W)}}class de{static toInternalProviderId(O,W){return O+"."+W}constructor(O,W,G,J,q){this.d=O,this.e=W,this.f=G,this.g=J,this.h=q}async provideDocumentOnDropEdits(O,W,G,J,q){const x=this.e.getDocument(W),ue=P.Position.to(G),Oe=P.DataTransfer.toDataTransfer(J,async Ze=>(await this.d.$resolveDocumentOnDropFileData(this.g,O,Ze)).buffer),Ue=await this.f.provideDocumentDropEdits(x,ue,Oe,q);if(Ue)return{label:Ue.label??(0,s.localize)(1,null,this.h.displayName||this.h.name),yieldTo:Ue.yieldTo?.map(Ze=>"mimeType"in Ze?Ze:{providerId:de.toInternalProviderId(Ze.extensionId,Ze.providerId)}),insertText:typeof Ue.insertText=="string"?Ue.insertText:{snippet:Ue.insertText.value},additionalEdit:Ue.additionalEdit?P.WorkspaceEdit.from(Ue.additionalEdit,void 0):void 0}}}class te{constructor(O,W){this.d=O,this.e=W}async provideMappedEdits(O,W,G,J){const q=y.URI.revive(O),x=this.d.getDocument(q),ue=G.documents.map(Ze=>Ze.map(Je=>({uri:y.URI.revive(Je.uri),version:Je.version,ranges:Je.ranges.map(tt=>P.Range.to(tt))}))),Oe={documents:ue,selections:ue[0]?.[0]?.ranges??[]},Ue=await this.e.provideMappedEdits(x,W,Oe,J);return Ue?P.WorkspaceEdit.from(Ue):null}}class ae{constructor(O,W){this.adapter=O,this.extension=W}}class me{static{this.d=0}constructor(O,W,G,J,q,x,ue,Oe){this.g=W,this.h=G,this.j=J,this.k=q,this.l=x,this.m=ue,this.n=Oe,this.f=new Map,this.e=O.getProxy($.$xK.MainThreadLanguageFeatures)}o(O,W){return P.DocumentSelector.from(O,this.g,W)}p(O){return new M.$zK(()=>{this.f.delete(O),this.e.$unregister(O)})}q(){return me.d++}async s(O,W,G,J,q,x=!1){const ue=this.f.get(O);if(!ue||!(ue.adapter instanceof W))return J;const Oe=Date.now();x||this.l.trace(`[${ue.extension.identifier.value}] INVOKE provider '${G.toString().replace(/[\r\n]/g,"")}'`);const Ue=G(ue.adapter,ue.extension);return Promise.resolve(Ue).catch(Ze=>{(0,o.$3)(Ze)||(this.l.error(`[${ue.extension.identifier.value}] provider FAILED`),this.l.error(Ze),this.n.onExtensionError(ue.extension.identifier,Ze))}).finally(()=>{x||this.l.trace(`[${ue.extension.identifier.value}] provider DONE after ${Date.now()-Oe}ms`)}),b.CancellationToken.isCancellationToken(q)?(0,l.$Ng)(Ue,q):Ue}t(O,W){const G=this.q();return this.f.set(G,new ae(O,W)),G}static u(O){return O.displayName||O.name}registerDocumentSymbolProvider(O,W,G,J){const q=this.t(new a(this.h,G),O),x=J&&J.label||me.u(O);return this.e.$registerDocumentSymbolProvider(q,this.o(W,O),x),this.p(q)}$provideDocumentSymbols(O,W,G){return this.s(O,a,J=>J.provideDocumentSymbols(y.URI.revive(W),G),void 0,G)}registerCodeLensProvider(O,W,G){const J=this.q(),q=typeof G.onDidChangeCodeLenses=="function"?this.q():void 0;this.f.set(J,new ae(new d(this.h,this.j.converter,G),O)),this.e.$registerCodeLensSupport(J,this.o(W,O),q);let x=this.p(J);if(q!==void 0){const ue=G.onDidChangeCodeLenses(Oe=>this.e.$emitCodeLensEvent(q));x=M.$zK.from(x,ue)}return x}$provideCodeLenses(O,W,G){return this.s(O,d,J=>J.provideCodeLenses(y.URI.revive(W),G),void 0,G)}$resolveCodeLens(O,W,G){return this.s(O,d,J=>J.resolveCodeLens(W,G),void 0,void 0)}$releaseCodeLenses(O,W){this.s(O,d,G=>Promise.resolve(G.releaseCodeLenses(W)),void 0,void 0)}registerDefinitionProvider(O,W,G){const J=this.t(new m(this.h,G),O);return this.e.$registerDefinitionSupport(J,this.o(W,O)),this.p(J)}$provideDefinition(O,W,G,J){return this.s(O,m,q=>q.provideDefinition(y.URI.revive(W),G,J),[],J)}registerDeclarationProvider(O,W,G){const J=this.t(new S(this.h,G),O);return this.e.$registerDeclarationSupport(J,this.o(W,O)),this.p(J)}$provideDeclaration(O,W,G,J){return this.s(O,S,q=>q.provideDeclaration(y.URI.revive(W),G,J),[],J)}registerImplementationProvider(O,W,G){const J=this.t(new k(this.h,G),O);return this.e.$registerImplementationSupport(J,this.o(W,O)),this.p(J)}$provideImplementation(O,W,G,J){return this.s(O,k,q=>q.provideImplementation(y.URI.revive(W),G,J),[],J)}registerTypeDefinitionProvider(O,W,G){const J=this.t(new h(this.h,G),O);return this.e.$registerTypeDefinitionSupport(J,this.o(W,O)),this.p(J)}$provideTypeDefinition(O,W,G,J){return this.s(O,h,q=>q.provideTypeDefinition(y.URI.revive(W),G,J),[],J)}registerHoverProvider(O,W,G,J){const q=this.t(new w(this.h,G),O);return this.e.$registerHoverProvider(q,this.o(W,O)),this.p(q)}$provideHover(O,W,G,J){return this.s(O,w,q=>q.provideHover(y.URI.revive(W),G,J),void 0,J)}registerEvaluatableExpressionProvider(O,W,G,J){const q=this.t(new I(this.h,G),O);return this.e.$registerEvaluatableExpressionProvider(q,this.o(W,O)),this.p(q)}$provideEvaluatableExpression(O,W,G,J){return this.s(O,I,q=>q.provideEvaluatableExpression(y.URI.revive(W),G,J),void 0,J)}registerInlineValuesProvider(O,W,G,J){const q=typeof G.onDidChangeInlineValues=="function"?this.q():void 0,x=this.t(new L(this.h,G),O);this.e.$registerInlineValuesProvider(x,this.o(W,O),q);let ue=this.p(x);if(q!==void 0){const Oe=G.onDidChangeInlineValues(Ue=>this.e.$emitInlineValuesEvent(q));ue=M.$zK.from(ue,Oe)}return ue}$provideInlineValues(O,W,G,J,q){return this.s(O,L,x=>x.provideInlineValues(y.URI.revive(W),G,J,q),void 0,q)}registerDocumentHighlightProvider(O,W,G){const J=this.t(new V(this.h,G),O);return this.e.$registerDocumentHighlightProvider(J,this.o(W,O)),this.p(J)}$provideDocumentHighlights(O,W,G,J){return this.s(O,V,q=>q.provideDocumentHighlights(y.URI.revive(W),G,J),void 0,J)}registerLinkedEditingRangeProvider(O,W,G){const J=this.t(new K(this.h,G),O);return this.e.$registerLinkedEditingRangeProvider(J,this.o(W,O)),this.p(J)}$provideLinkedEditingRanges(O,W,G,J){return this.s(O,K,async q=>{const x=await q.provideLinkedEditingRanges(y.URI.revive(W),G,J);if(x)return{ranges:x.ranges,wordPattern:x.wordPattern?me.w(x.wordPattern):void 0}},void 0,J)}registerReferenceProvider(O,W,G){const J=this.t(new R(this.h,G),O);return this.e.$registerReferenceSupport(J,this.o(W,O)),this.p(J)}$provideReferences(O,W,G,J,q){return this.s(O,R,x=>x.provideReferences(y.URI.revive(W),G,J,q),void 0,q)}registerCodeActionProvider(O,W,G,J){const q=new g.$Qc,x=this.t(new N(this.h,this.j.converter,this.k,G,this.l,O,this.m),O);return this.e.$registerQuickFixSupport(x,this.o(W,O),{providedKinds:J?.providedCodeActionKinds?.map(ue=>ue.value),documentation:J?.documentation?.map(ue=>({kind:ue.kind.value,command:this.j.converter.toInternal(ue.command,q)}))},me.u(O),!!G.resolveCodeAction),q.add(this.p(x)),q}$provideCodeActions(O,W,G,J,q){return this.s(O,N,x=>x.provideCodeActions(y.URI.revive(W),G,J,q),void 0,q)}$resolveCodeAction(O,W,G){return this.s(O,N,J=>J.resolveCodeAction(W,G),{},void 0)}$releaseCodeActions(O,W){this.s(O,N,G=>Promise.resolve(G.releaseCodeActions(W)),void 0,void 0)}registerDocumentFormattingEditProvider(O,W,G){const J=this.t(new z(this.h,G),O);return this.e.$registerDocumentFormattingSupport(J,this.o(W,O),O.identifier,O.displayName||O.name),this.p(J)}$provideDocumentFormattingEdits(O,W,G,J){return this.s(O,z,q=>q.provideDocumentFormattingEdits(y.URI.revive(W),G,J),void 0,J)}registerDocumentRangeFormattingEditProvider(O,W,G){const J=typeof G.provideDocumentRangesFormattingEdits=="function",q=this.t(new Z(this.h,G),O);return this.e.$registerRangeFormattingSupport(q,this.o(W,O),O.identifier,O.displayName||O.name,J),this.p(q)}$provideDocumentRangeFormattingEdits(O,W,G,J,q){return this.s(O,Z,x=>x.provideDocumentRangeFormattingEdits(y.URI.revive(W),G,J,q),void 0,q)}$provideDocumentRangesFormattingEdits(O,W,G,J,q){return this.s(O,Z,x=>x.provideDocumentRangesFormattingEdits(y.URI.revive(W),G,J,q),void 0,q)}registerOnTypeFormattingEditProvider(O,W,G,J){const q=this.t(new he(this.h,G),O);return this.e.$registerOnTypeFormattingSupport(q,this.o(W,O),J,O.identifier),this.p(q)}$provideOnTypeFormattingEdits(O,W,G,J,q,x){return this.s(O,he,ue=>ue.provideOnTypeFormattingEdits(y.URI.revive(W),G,J,q,x),void 0,x)}registerWorkspaceSymbolProvider(O,W){const G=this.t(new ye(W,this.l),O);return this.e.$registerNavigateTypeSupport(G,typeof W.resolveWorkspaceSymbol=="function"),this.p(G)}$provideWorkspaceSymbols(O,W,G){return this.s(O,ye,J=>J.provideWorkspaceSymbols(W,G),{symbols:[]},G)}$resolveWorkspaceSymbol(O,W,G){return this.s(O,ye,J=>J.resolveWorkspaceSymbol(W,G),void 0,void 0)}$releaseWorkspaceSymbols(O,W){this.s(O,ye,G=>G.releaseWorkspaceSymbols(W),void 0,void 0)}registerRenameProvider(O,W,G){const J=this.t(new De(this.h,G,this.l),O);return this.e.$registerRenameSupport(J,this.o(W,O),De.supportsResolving(G)),this.p(J)}$provideRenameEdits(O,W,G,J,q){return this.s(O,De,x=>x.provideRenameEdits(y.URI.revive(W),G,J,q),void 0,q)}$resolveRenameLocation(O,W,G,J){return this.s(O,De,q=>q.resolveRenameLocation(y.URI.revive(W),G,J),void 0,J)}registerDocumentSemanticTokensProvider(O,W,G,J){const q=this.t(new fe(this.h,G),O),x=typeof G.onDidChangeSemanticTokens=="function"?this.q():void 0;this.e.$registerDocumentSemanticTokensProvider(q,this.o(W,O),J,x);let ue=this.p(q);if(x){const Oe=G.onDidChangeSemanticTokens(Ue=>this.e.$emitDocumentSemanticTokensEvent(x));ue=M.$zK.from(ue,Oe)}return ue}$provideDocumentSemanticTokens(O,W,G,J){return this.s(O,fe,q=>q.provideDocumentSemanticTokens(y.URI.revive(W),G,J),null,J)}$releaseDocumentSemanticTokens(O,W){this.s(O,fe,G=>G.releaseDocumentSemanticColoring(W),void 0,void 0)}registerDocumentRangeSemanticTokensProvider(O,W,G,J){const q=this.t(new $e(this.h,G),O);return this.e.$registerDocumentRangeSemanticTokensProvider(q,this.o(W,O),J),this.p(q)}$provideDocumentRangeSemanticTokens(O,W,G,J){return this.s(O,$e,q=>q.provideDocumentRangeSemanticTokens(y.URI.revive(W),G,J),null,J)}registerCompletionItemProvider(O,W,G,J){const q=this.t(new re(this.h,this.j.converter,G,this.m,O),O);return this.e.$registerCompletionsProvider(q,this.o(W,O),J,re.supportsResolving(G),O.identifier),this.p(q)}$provideCompletionItems(O,W,G,J,q){return this.s(O,re,x=>x.provideCompletionItems(y.URI.revive(W),G,J,q),void 0,q)}$resolveCompletionItem(O,W,G){return this.s(O,re,J=>J.resolveCompletionItem(W,G),void 0,G)}$releaseCompletionItems(O,W){this.s(O,re,G=>G.releaseCompletionItems(W),void 0,void 0)}registerInlineCompletionsProvider(O,W,G,J){const q=new se(O,this.h,G,this.j.converter),x=this.t(q,O);return this.e.$registerInlineCompletionsSupport(x,this.o(W,O),q.supportsHandleEvents,p.$_l.toKey(O.identifier.value),J?.yieldTo?.map(ue=>p.$_l.toKey(ue))||[]),this.p(x)}$provideInlineCompletions(O,W,G,J,q){return this.s(O,Ae,x=>x.provideInlineCompletions(y.URI.revive(W),G,J,q),void 0,q)}$handleInlineCompletionDidShow(O,W,G,J){this.s(O,Ae,async q=>{q.handleDidShowCompletionItem(W,G,J)},void 0,void 0)}$handleInlineCompletionPartialAccept(O,W,G,J){this.s(O,Ae,async q=>{q.handlePartialAccept(W,G,J)},void 0,void 0)}$freeInlineCompletionsList(O,W){this.s(O,Ae,async G=>{G.disposeCompletions(W)},void 0,void 0)}registerSignatureHelpProvider(O,W,G,J){const q=Array.isArray(J)?{triggerCharacters:J,retriggerCharacters:[]}:J,x=this.t(new B(this.h,G),O);return this.e.$registerSignatureHelpProvider(x,this.o(W,O),q),this.p(x)}$provideSignatureHelp(O,W,G,J,q){return this.s(O,B,x=>x.provideSignatureHelp(y.URI.revive(W),G,J,q),void 0,q)}$releaseSignatureHelp(O,W){this.s(O,B,G=>G.releaseSignatureHelp(W),void 0,void 0)}registerInlayHintsProvider(O,W,G){const J=typeof G.onDidChangeInlayHints=="function"?this.q():void 0,q=this.t(new ie(this.h,this.j.converter,G,this.l,O),O);this.e.$registerInlayHintsProvider(q,this.o(W,O),typeof G.resolveInlayHint=="function",J,me.u(O));let x=this.p(q);if(J!==void 0){const ue=G.onDidChangeInlayHints(Oe=>this.e.$emitInlayHintsEvent(J));x=M.$zK.from(x,ue)}return x}$provideInlayHints(O,W,G,J){return this.s(O,ie,q=>q.provideInlayHints(y.URI.revive(W),G,J),void 0,J)}$resolveInlayHint(O,W,G){return this.s(O,ie,J=>J.resolveInlayHint(W,G),void 0,G)}$releaseInlayHints(O,W){this.s(O,ie,G=>G.releaseHints(W),void 0,void 0)}registerDocumentLinkProvider(O,W,G){const J=this.t(new pe(this.h,G),O);return this.e.$registerDocumentLinkProvider(J,this.o(W,O),typeof G.resolveDocumentLink=="function"),this.p(J)}$provideDocumentLinks(O,W,G){return this.s(O,pe,J=>J.provideLinks(y.URI.revive(W),G),void 0,G,W.scheme==="output")}$resolveDocumentLink(O,W,G){return this.s(O,pe,J=>J.resolveLink(W,G),void 0,void 0,!0)}$releaseDocumentLinks(O,W){this.s(O,pe,G=>G.releaseLinks(W),void 0,void 0,!0)}registerColorProvider(O,W,G){const J=this.t(new ne(this.h,G),O);return this.e.$registerDocumentColorProvider(J,this.o(W,O)),this.p(J)}$provideDocumentColors(O,W,G){return this.s(O,ne,J=>J.provideColors(y.URI.revive(W),G),[],G)}$provideColorPresentations(O,W,G,J){return this.s(O,ne,q=>q.provideColorPresentations(y.URI.revive(W),G,J),void 0,J)}registerFoldingRangeProvider(O,W,G){const J=this.q(),q=typeof G.onDidChangeFoldingRanges=="function"?this.q():void 0;this.f.set(J,new ae(new le(this.h,G),O)),this.e.$registerFoldingRangeProvider(J,this.o(W,O),O.identifier,q);let x=this.p(J);if(q!==void 0){const ue=G.onDidChangeFoldingRanges(()=>this.e.$emitFoldingRangeEvent(q));x=M.$zK.from(x,ue)}return x}$provideFoldingRanges(O,W,G,J){return this.s(O,le,q=>q.provideFoldingRanges(y.URI.revive(W),G,J),void 0,J)}registerSelectionRangeProvider(O,W,G){const J=this.t(new ce(this.h,G,this.l),O);return this.e.$registerSelectionRangeProvider(J,this.o(W,O)),this.p(J)}$provideSelectionRanges(O,W,G,J){return this.s(O,ce,q=>q.provideSelectionRanges(y.URI.revive(W),G,J),[],J)}registerCallHierarchyProvider(O,W,G){const J=this.t(new we(this.h,G),O);return this.e.$registerCallHierarchyProvider(J,this.o(W,O)),this.p(J)}$prepareCallHierarchy(O,W,G,J){return this.s(O,we,q=>Promise.resolve(q.prepareSession(y.URI.revive(W),G,J)),void 0,J)}$provideCallHierarchyIncomingCalls(O,W,G,J){return this.s(O,we,q=>q.provideCallsTo(W,G,J),void 0,J)}$provideCallHierarchyOutgoingCalls(O,W,G,J){return this.s(O,we,q=>q.provideCallsFrom(W,G,J),void 0,J)}$releaseCallHierarchy(O,W){this.s(O,we,G=>Promise.resolve(G.releaseSession(W)),void 0,void 0)}registerTypeHierarchyProvider(O,W,G){const J=this.t(new _(this.h,G),O);return this.e.$registerTypeHierarchyProvider(J,this.o(W,O)),this.p(J)}$prepareTypeHierarchy(O,W,G,J){return this.s(O,_,q=>Promise.resolve(q.prepareSession(y.URI.revive(W),G,J)),void 0,J)}$provideTypeHierarchySupertypes(O,W,G,J){return this.s(O,_,q=>q.provideSupertypes(W,G,J),void 0,J)}$provideTypeHierarchySubtypes(O,W,G,J){return this.s(O,_,q=>q.provideSubtypes(W,G,J),void 0,J)}$releaseTypeHierarchy(O,W){this.s(O,_,G=>Promise.resolve(G.releaseSession(W)),void 0,void 0)}registerDocumentOnDropEditProvider(O,W,G,J){const q=this.q();this.f.set(q,new ae(new de(this.e,this.h,G,q,O),O));const x=(0,n.$LF)(O,"dropMetadata")&&J?de.toInternalProviderId(O.identifier.value,J.id):void 0;return this.e.$registerDocumentOnDropEditProvider(q,this.o(W,O),x,(0,n.$LF)(O,"dropMetadata")?J:void 0),this.p(q)}$provideDocumentOnDropEdits(O,W,G,J,q,x){return this.s(O,de,ue=>Promise.resolve(ue.provideDocumentOnDropEdits(W,y.URI.revive(G),J,q,x)),void 0,void 0)}registerMappedEditsProvider(O,W,G){const J=this.t(new te(this.h,G),O);return this.e.$registerMappedEditsProvider(J,this.o(W,O)),this.p(J)}$provideMappedEdits(O,W,G,J,q){return this.s(O,te,x=>Promise.resolve(x.provideMappedEdits(W,G,J,q)),null,q)}registerDocumentPasteEditProvider(O,W,G,J){const q=this.q();this.f.set(q,new ae(new T(this.e,this.h,G,q,O),O));const x=T.toInternalProviderId(O.identifier.value,J.id);return this.e.$registerPasteEditProvider(q,this.o(W,O),x,{supportsCopy:!!G.prepareDocumentPaste,supportsPaste:!!G.provideDocumentPasteEdits,copyMimeTypes:J.copyMimeTypes,pasteMimeTypes:J.pasteMimeTypes}),this.p(q)}$prepareDocumentPaste(O,W,G,J,q){return this.s(O,T,x=>x.prepareDocumentPaste(y.URI.revive(W),G,J,q),void 0,q)}$providePasteEdits(O,W,G,J,q,x){return this.s(O,T,ue=>ue.providePasteEdits(W,y.URI.revive(G),J,q,x),void 0,x)}static w(O){return{pattern:O.source,flags:O.flags}}static y(O){return{decreaseIndentPattern:me.w(O.decreaseIndentPattern),increaseIndentPattern:me.w(O.increaseIndentPattern),indentNextLinePattern:O.indentNextLinePattern?me.w(O.indentNextLinePattern):void 0,unIndentedLinePattern:O.unIndentedLinePattern?me.w(O.unIndentedLinePattern):void 0}}static z(O){return{beforeText:me.w(O.beforeText),afterText:O.afterText?me.w(O.afterText):void 0,previousLineText:O.previousLineText?me.w(O.previousLineText):void 0,action:O.action}}static B(O){return O.map(me.z)}static C(O){return{open:O.open,close:O.close,notIn:O.notIn?O.notIn.map(W=>M.SyntaxTokenType.toString(W)):void 0}}static D(O){return O.map(me.C)}setLanguageConfiguration(O,W,G){const{wordPattern:J}=G;if(J&&(0,E.$Se)(J))throw new Error(`Invalid language configuration: wordPattern '${J}' is not allowed to match the empty string.`);J?this.h.setWordDefinitionFor(W,J):this.h.setWordDefinitionFor(W,void 0),G.__electricCharacterSupport&&this.m.report("LanguageConfiguration.__electricCharacterSupport",O,"Do not use."),G.__characterPairSupport&&this.m.report("LanguageConfiguration.__characterPairSupport",O,"Do not use.");const q=this.q(),x={comments:G.comments,brackets:G.brackets,wordPattern:G.wordPattern?me.w(G.wordPattern):void 0,indentationRules:G.indentationRules?me.y(G.indentationRules):void 0,onEnterRules:G.onEnterRules?me.B(G.onEnterRules):void 0,__electricCharacterSupport:G.__electricCharacterSupport,__characterPairSupport:G.__characterPairSupport,autoClosingPairs:G.autoClosingPairs?me.D(G.autoClosingPairs):void 0};return this.e.$setLanguageConfiguration(q,W,x),this.p(q)}$setWordDefinitions(O){for(const W of O)this.h.setWordDefinitionFor(W.languageId,new RegExp(W.regexSource,W.regexFlags))}}e.$Ndc=me}),define(Pe[255],Re([1,0,3,8,7,31,14,6,23]),function(be,e,y,F,P,M,A,$,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$afc=void 0;class f{constructor(D,u,b,p){this.c=u,this.d=b,this.e=p,this.b=[],this.f=0,this.g=new Set,this.a=D.getProxy(y.$xK.MainThreadLanguages)}$acceptLanguageIds(D){this.b=D}async getLanguages(){return this.b.slice(0)}async changeLanguage(D,u){await this.a.$changeLanguage(D,u);const b=this.c.getDocumentData(D);if(!b)throw new Error(`document '${D.toString()}' NOT found`);return b.document}async tokenAtPosition(D,u){const b=D.version,p=F.Position.from(u),g=await this.a.$tokensAtPosition(D.uri,p),t={type:P.StandardTokenType.Other,range:D.getWordRangeAtPosition(u)??new P.$BK(u.line,u.character,u.line,u.character)};if(!g)return t;const i={range:F.Range.to(g.range),type:F.TokenType.to(g.type)};return!i.range.contains(u)||b!==D.version?t:i}createLanguageStatusItem(D,u,b){const p=this.f++,g=this.a,t=this.g,i=`${D.identifier.value}/${u}`;if(t.has(i))throw new Error(`LanguageStatusItem with id '${u}' ALREADY exists`);t.add(i);const r={selector:b,id:u,name:D.displayName??D.name,severity:P.LanguageStatusSeverity.Information,command:void 0,text:"",detail:"",busy:!1};let c;const o=new $.$Qc,l=()=>{if(c?.dispose(),!t.has(i)){console.warn(`LanguageStatusItem (${u}) from ${D.identifier.value} has been disposed and CANNOT be updated anymore`);return}c=(0,A.$Zg)(()=>{o.clear(),this.a.$setLanguageStatus(p,{id:i,name:r.name??D.displayName??D.name,source:D.displayName??D.name,selector:F.DocumentSelector.from(r.selector,this.e),label:r.text,detail:r.detail??"",severity:r.severity===P.LanguageStatusSeverity.Error?M.default.Error:r.severity===P.LanguageStatusSeverity.Warning?M.default.Warning:M.default.Info,command:r.command&&this.d.toInternal(r.command,o),accessibilityInfo:r.accessibilityInformation,busy:r.busy})},0)},n={dispose(){o.dispose(),c?.dispose(),g.$removeLanguageStatus(p),t.delete(i)},get id(){return r.id},get name(){return r.name},set name(s){r.name=s,l()},get selector(){return r.selector},set selector(s){r.selector=s,l()},get text(){return r.text},set text(s){r.text=s,l()},set text2(s){(0,E.$MF)(D,"languageStatusText"),r.text=s,l()},get text2(){return(0,E.$MF)(D,"languageStatusText"),r.text},get detail(){return r.detail},set detail(s){r.detail=s,l()},get severity(){return r.severity},set severity(s){r.severity=s,l()},get accessibilityInformation(){return r.accessibilityInformation},set accessibilityInformation(s){r.accessibilityInformation=s,l()},get command(){return r.command},set command(s){r.command=s,l()},get busy(){return r.busy},set busy(s){r.busy=s,l()}};return l(),n}}e.$afc=f}),define(Pe[82],Re([1,0,21,12,2,4,15,3,27,17]),function(be,e,y,F,P,M,A,$,E,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zec=e.$yec=void 0;let C=class{constructor(u,b,p){this.f=p,this.d=new Map,this.a=b.getProxy($.$xK.MainThreadLocalization),this.b=u.environment.appLanguage,this.c=this.b===y.$g}getMessage(u,b){const{message:p,args:g,comment:t}=b;if(this.c)return(0,F.$He)(p,g??{});let i=p;t&&t.length>0&&(i+=`/${Array.isArray(t)?t.join(""):t}`);const r=this.d.get(u)?.contents[i];return r||this.f.warn(`Using default string since no string found in i18n bundle that has the key: ${i}`),(0,F.$He)(r??p,g??{})}getBundle(u){return this.d.get(u)?.contents}getBundleUri(u){return this.d.get(u)?.uri}async initializeLocalizedMessages(u){if(this.c||!u.l10n&&!u.isBuiltin||this.d.has(u.identifier.value))return;let b;const p=await this.g(u);if(!p){this.f.error(`No bundle location found for extension ${u.identifier.value}`);return}try{const g=await this.a.$fetchBundleContents(p),t=JSON.parse(g);b=u.isBuiltin?t.contents?.bundle:t}catch(g){this.f.error(`Failed to load translations for ${u.identifier.value} from ${p}: ${g.message}`);return}b&&this.d.set(u.identifier.value,{contents:b,uri:p})}async g(u){if(u.isBuiltin){const b=await this.a.$fetchBuiltInBundleUri(u.identifier.value,this.b);return P.URI.revive(b)}return u.l10n?P.URI.joinPath(u.extensionLocation,u.l10n,`bundle.l10n.${this.b}.json`):void 0}};e.$yec=C,e.$yec=C=Ke([Ve(0,E.$PM),Ve(1,f.$zM),Ve(2,A.$dj)],C),e.$zec=(0,M.$Vh)("IExtHostLocalizationService")}),define(Pe[256],Re([1,0,15,3,27,17,2,51]),function(be,e,y,F,P,M,A,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lfc=void 0;let E=class extends y.$oj{constructor(D,u){super(u.logLevel,u.logsLocation,u.loggers.map(b=>(0,$.$sh)(b))),this.r=D.getProxy(F.$xK.MainThreadLogger)}$setLogLevel(D,u){u?this.setLogLevel(A.URI.revive(u),D):this.setLogLevel(D)}setVisibility(D,u){super.setVisibility(D,u),this.r.$setVisibility(D,u)}s(D,u,b){return new f(this.r,D,u,b)}};e.$Lfc=E,e.$Lfc=E=Ke([Ve(0,M.$zM),Ve(1,P.$PM)],E);class f extends y.$jj{constructor(D,u,b,p){super(p?.logLevel==="always"),this.r=D,this.s=u,this.m=!1,this.n=[],this.setLevel(b),this.r.$createLogger(u,p).then(()=>{this.u(this.n),this.m=!0})}g(D,u){const b=[[D,u]];this.m?this.u(b):this.n.push(...b)}u(D){this.r.$log(this.s,D)}flush(){this.r.$flush(this.s)}}}),define(Pe[83],Re([1,0,3,4,6,17,24]),function(be,e,y,F,P,M,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bec=e.$Aec=void 0,e.$Aec=(0,F.$Vh)("IExtHostManagedSockets");let $=class{constructor(D){this.b=0,this.c=null,this.d=new Map,this.a=D.getProxy(y.$xK.MainThreadManagedSockets)}setFactory(D,u){for(const b of this.d.values())b.dispose();this.c&&this.a.$unregisterSocketFactory(this.c.socketFactoryId),this.c=new E(D,u),this.a.$registerSocketFactory(this.c.socketFactoryId)}async $openRemoteSocket(D){if(!this.c||this.c.socketFactoryId!==D)throw new Error(`No socket factory with id ${D}`);const u=++this.b,b=await this.c.makeConnection(),p=new P.$Qc;return this.d.set(u,new f(u,b,p)),p.add((0,P.$Pc)(()=>this.d.delete(u))),p.add(b.onDidEnd(()=>{this.a.$onDidManagedSocketEnd(u),p.dispose()})),p.add(b.onDidClose(g=>{this.a.$onDidManagedSocketClose(u,g?.stack??g?.message),p.dispose()})),p.add(b.onDidReceiveMessage(g=>this.a.$onDidManagedSocketHaveData(u,A.$fe.wrap(g)))),u}$remoteSocketWrite(D,u){this.d.get(D)?.actual.send(u.buffer)}$remoteSocketEnd(D){const u=this.d.get(D);u&&(u.actual.end(),u.dispose())}async $remoteSocketDrain(D){await this.d.get(D)?.actual.drain?.()}};e.$Bec=$,e.$Bec=$=Ke([Ve(0,M.$zM)],$);class E{constructor(D,u){this.socketFactoryId=D,this.makeConnection=u}}class f extends P.$Rc{constructor(D,u,b){super(),this.socketId=D,this.actual=u,this.B(b)}}}),define(Pe[257],Re([1,0,3,15,23]),function(be,e,y,F,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bfc=void 0;function M($){return $&&$.title}let A=class{constructor(E,f){this.b=f,this.a=E.getProxy(y.$xK.MainThreadMessageService)}showMessage(E,f,C,D,u){const b={source:{identifier:E.identifier,label:E.displayName||E.name}};let p;typeof D=="string"||M(D)?p=[D,...u]:(b.modal=D?.modal,b.useCustom=D?.useCustom,b.detail=D?.detail,p=u),b.useCustom&&(0,P.$MF)(E,"resolvers");const g=[];for(let t=0;t<p.length;t++){const i=p[t];if(typeof i=="string")g.push({title:i,handle:t,isCloseAffordance:!1});else if(typeof i=="object"){const{title:r,isCloseAffordance:c}=i;g.push({title:r,isCloseAffordance:!!c,handle:t})}else this.b.warn("Invalid message item:",i)}return this.a.$showMessage(f,C,b,g).then(t=>{if(typeof t=="number")return p[t]})}};e.$bfc=A,e.$bfc=A=Ke([Ve(1,F.$dj)],A)}),define(Pe[258],Re([1,0,18,14,20,5,6,28,2,22,15,3,32,8,7,78,211,23,49]),function(be,e,y,F,P,M,A,$,E,f,C,D,u,b,p,g,t,i,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gfc=e.$ffc=void 0;let c=class{constructor(m,S,k,h,w){this.l=S,this.m=k,this.n=h,this.o=w,this.b=new $.$zc,this.c=new $.$zc,this.e=new Map,this.f=0,this.g=new Map,this.h=0,this.i=new Map,this.j=0,this.k=new M.$Rd,this.onDidChangeNotebookCellExecutionState=this.k.event,this.a=m.getProxy(D.$xK.MainThreadNotebookKernels);const I=new u.$ZM("notebook.selectKernel","_notebook.selectKernel","Trigger kernel picker for specified notebook editor widget",[new u.$XM("options","Select kernel options",L=>!0,L=>{if(L&&"notebookEditor"in L&&"id"in L){const V=this.m.getIdByEditor(L.notebookEditor);return{id:L.id,extension:L.extension,notebookEditorId:V}}else if(L&&"notebookEditor"in L){const V=this.m.getIdByEditor(L.notebookEditor);if(V===void 0)throw new Error(`Cannot invoke 'notebook.selectKernel' for unrecognized notebook editor ${L.notebookEditor.notebook.uri.toString()}`);return{notebookEditorId:V}}return L})],u.$YM.Void);this.n.registerApiCommand(I)}createNotebookController(m,S,k,h,w,I){for(const $e of this.i.values())if($e.controller.id===S&&f.$_l.equals(m.identifier,$e.extensionId))throw new Error(`notebook controller with id '${S}' ALREADY exist`);const L=this.j++,V=this;this.o.trace(`NotebookController[${L}], CREATED by ${m.identifier.value}, ${S}`);const K=()=>console.warn(`NO execute handler from notebook controller '${z.id}' of extension: '${m.identifier}'`);let R=!1;const N=new M.$Rd,T=new M.$Rd,z={id:d(m.identifier,S),notebookType:k,extensionId:m.identifier,extensionLocation:m.extensionLocation,label:h||m.identifier.value,preloads:I?I.map(b.NotebookRendererScript.from):[]};let Z=w??K,he;this.a.$addKernel(L,z).catch($e=>{console.log($e),R=!0});let ye=0;const De=()=>{if(R)return;const $e=++ye;Promise.resolve().then(()=>{$e===ye&&this.a.$updateKernel(L,z)})},Se=new $.$zc,fe={get id(){return S},get notebookType(){return z.notebookType},onDidChangeSelectedNotebooks:N.event,get label(){return z.label},set label($e){z.label=$e??m.displayName??m.name,De()},get detail(){return z.detail??""},set detail($e){z.detail=$e,De()},get description(){return z.description??""},set description($e){z.description=$e,De()},get supportedLanguages(){return z.supportedLanguages},set supportedLanguages($e){z.supportedLanguages=$e,De()},get supportsExecutionOrder(){return z.supportsExecutionOrder??!1},set supportsExecutionOrder($e){z.supportsExecutionOrder=$e,De()},get rendererScripts(){return z.preloads?z.preloads.map(b.NotebookRendererScript.to):[]},get executeHandler(){return Z},set executeHandler($e){Z=$e??K},get interruptHandler(){return he},set interruptHandler($e){he=$e,z.supportsInterrupt=!!$e,De()},createNotebookCellExecution($e){if(R)throw new Error("notebook controller is DISPOSED");if(!Se.has($e.notebook.uri))throw V.o.trace(`NotebookController[${L}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(Se.keys()).map(re=>re.toString())),new Error(`notebook controller is NOT associated to notebook: ${$e.notebook.uri.toString()}`);return V._createNotebookCellExecution($e,d(m.identifier,this.id))},createNotebookExecution($e){if((0,i.$MF)(m,"notebookExecution"),R)throw new Error("notebook controller is DISPOSED");if(!Se.has($e.uri))throw V.o.trace(`NotebookController[${L}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(Se.keys()).map(re=>re.toString())),new Error(`notebook controller is NOT associated to notebook: ${$e.uri.toString()}`);return V._createNotebookExecution($e,d(m.identifier,this.id))},dispose:()=>{R||(this.o.trace(`NotebookController[${L}], DISPOSED`),R=!0,this.i.delete(L),N.dispose(),T.dispose(),this.a.$removeKernel(L))},updateNotebookAffinity($e,re){re===p.NotebookControllerAffinity2.Hidden&&(0,i.$MF)(m,"notebookControllerAffinityHidden"),V.a.$updateNotebookPriority(L,$e.uri,re)},onDidReceiveMessage:T.event,postMessage($e,re){return(0,i.$MF)(m,"notebookMessaging"),V.a.$postMessage(L,re&&V.m.getIdByEditor(re),$e)},asWebviewUri($e){return(0,i.$MF)(m,"notebookMessaging"),(0,g.$$tb)($e,V.l.remote)}};return this.i.set(L,{extensionId:m.identifier,controller:fe,onDidReceiveMessage:T,onDidChangeSelection:N,associatedNotebooks:Se}),fe}getIdByController(m){for(const[S,k]of this.i)if(k.controller===m)return d(k.extensionId,m.id);return null}createNotebookControllerDetectionTask(m,S){const k=this.f++,h=this;this.o.trace(`NotebookControllerDetectionTask[${k}], CREATED by ${m.identifier.value}`),this.a.$addKernelDetectionTask(k,S);const w={dispose:()=>{this.e.delete(k),h.a.$removeKernelDetectionTask(k)}};return this.e.set(k,w),w}registerKernelSourceActionProvider(m,S,k){const h=this.h++,w=typeof k.onDidChangeNotebookKernelSourceActions=="function"?h:void 0,I=this;this.g.set(h,k),this.o.trace(`NotebookKernelSourceActionProvider[${h}], CREATED by ${m.identifier.value}`),this.a.$addKernelSourceActionProvider(h,h,S);let L;return w!==void 0&&(L=k.onDidChangeNotebookKernelSourceActions(V=>this.a.$emitNotebookKernelSourceActionsChangeEvent(w))),{dispose:()=>{this.g.delete(h),I.a.$removeKernelSourceActionProvider(h,h),L?.dispose()}}}async $provideKernelSourceActions(m,S){const k=this.g.get(m);if(k){const h=new A.$Qc;return(await k.provideNotebookKernelSourceActions(S)??[]).map(I=>b.NotebookKernelSourceAction.from(I,this.n.converter,h))}return[]}$acceptNotebookAssociation(m,S,k){const h=this.i.get(m);if(h){const w=this.m.getNotebookDocument(E.URI.revive(S));k?h.associatedNotebooks.set(w.uri,!0):h.associatedNotebooks.delete(w.uri),this.o.trace(`NotebookController[${m}] ASSOCIATE notebook`,w.uri.toString(),k),h.onDidChangeSelection.fire({selected:k,notebook:w.apiNotebook})}}async $executeCells(m,S,k){const h=this.i.get(m);if(!h)return;const w=this.m.getNotebookDocument(E.URI.revive(S)),I=[];for(const L of k){const V=w.getCell(L);V&&I.push(V.apiCell)}try{this.o.trace(`NotebookController[${m}] EXECUTE cells`,w.uri.toString(),I.length),await h.controller.executeHandler.call(h.controller,I,w.apiNotebook,h.controller)}catch(L){this.o.error(`NotebookController[${m}] execute cells FAILED`,L),console.error(L)}}async $cancelCells(m,S,k){const h=this.i.get(m);if(!h)return;const w=this.m.getNotebookDocument(E.URI.revive(S));if(h.controller.interruptHandler)await h.controller.interruptHandler.call(h.controller,w.apiNotebook);else for(const I of k){const L=w.getCell(I);L&&this.b.get(L.uri)?.cancel()}if(h.controller.interruptHandler){const I=this.c.get(w.uri);k.length&&Array.isArray(I)&&I.length&&I.forEach(L=>L.dispose())}}$acceptKernelMessageFromRenderer(m,S,k){const h=this.i.get(m);if(!h)return;const w=this.m.getEditorById(S);h.onDidReceiveMessage.fire(Object.freeze({editor:w.apiEditor,message:k}))}$cellExecutionChanged(m,S,k){const w=this.m.getNotebookDocument(E.URI.revive(m)).getCell(S);if(w){const I=k?b.NotebookCellExecutionState.to(k):p.NotebookCellExecutionState.Idle;I!==void 0&&this.k.fire({cell:w.apiCell,state:I})}}_createNotebookCellExecution(m,S){if(m.index<0)throw new Error("CANNOT execute cell that has been REMOVED from notebook");const h=this.m.getNotebookDocument(m.notebook.uri).getCellFromApiCell(m);if(!h)throw new Error("invalid cell");if(this.b.has(h.uri))throw new Error(`duplicate execution for ${h.uri}`);const w=new l(S,h,this.a);this.b.set(h.uri,w);const I=w.onDidChangeState(()=>{w.state===o.Resolved&&(w.dispose(),I.dispose(),this.b.delete(h.uri))});return w.asApiObject()}_createNotebookExecution(m,S){const k=this.m.getNotebookDocument(m.uri),h=m.getCells().find(L=>{const V=k.getCellFromApiCell(L);return V&&this.b.has(V.uri)});if(h)throw new Error(`duplicate cell execution for ${h.document.uri}`);if(this.c.has(k.uri))throw new Error(`duplicate notebook execution for ${k.uri}`);const w=new s(S,k,this.a),I=w.onDidChangeState(()=>{w.state===n.Resolved&&(w.dispose(),I.dispose(),this.c.delete(k.uri))});return this.c.set(k.uri,[w,I]),w.asApiObject()}};e.$ffc=c,e.$ffc=c=Ke([Ve(4,C.$dj)],c);var o;(function(v){v[v.Init=0]="Init",v[v.Started=1]="Started",v[v.Resolved=2]="Resolved"})(o||(o={}));class l extends A.$Rc{static{this.a=0}get state(){return this.f}constructor(m,S,k){super(),this.m=S,this.n=k,this.b=l.a++,this.c=new M.$Rd,this.onDidChangeState=this.c.event,this.f=o.Init,this.g=this.B(new P.$2d),this.h=new a(10,h=>this.s(h)),this.j=S.internalMetadata.executionOrder,this.n.$createExecution(this.b,m,this.m.notebook.uri,this.m.handle)}cancel(){this.g.cancel()}async r(m){await this.h.addItem(m)}async s(m){const S=Array.isArray(m)?m:[m];return this.n.$updateExecution(this.b,new r.$wv(S))}t(){if(this.f===o.Init)throw new Error("Must call start before modifying cell output");if(this.f===o.Resolved)throw new Error("Cannot modify cell output after calling resolve")}w(m){let S=this.m;if(m&&(S=this.m.notebook.getCellFromApiCell(m)),!S)throw new Error("INVALID cell");return S.handle}y(m){return m.map(S=>{const k=p.$1L.ensureUniqueMimeTypes(S.items,!0);return k===S.items?b.NotebookCellOutput.from(S):b.NotebookCellOutput.from({items:k,id:S.id,metadata:S.metadata})})}async z(m,S,k){const h=this.w(S),w=this.y((0,y.$2b)(m));return this.r({editType:t.CellExecutionUpdateType.Output,cellHandle:h,append:k,outputs:w})}async C(m,S,k){return m=p.$1L.ensureUniqueMimeTypes((0,y.$2b)(m),!0),this.r({editType:t.CellExecutionUpdateType.OutputItems,items:m.map(b.NotebookCellOutputItem.from),outputId:S.id,append:k})}asApiObject(){const m=this;return Object.freeze({get token(){return m.g.token},get cell(){return m.m.apiCell},get executionOrder(){return m.j},set executionOrder(k){m.j=k,m.s([{editType:t.CellExecutionUpdateType.ExecutionState,executionOrder:m.j}])},start(k){if(m.f===o.Resolved||m.f===o.Started)throw new Error("Cannot call start again");m.f=o.Started,m.c.fire(),m.s({editType:t.CellExecutionUpdateType.ExecutionState,runStartTime:k})},end(k,h){if(m.f===o.Resolved)throw new Error("Cannot call resolve twice");m.f=o.Resolved,m.c.fire(),m.h.flush(),m.n.$completeExecution(m.b,new r.$wv({runEndTime:h,lastRunSuccess:k}))},clearOutput(k){return m.t(),m.z([],k,!1)},appendOutput(k,h){return m.t(),m.z(k,h,!0)},replaceOutput(k,h){return m.t(),m.z(k,h,!1)},appendOutputItems(k,h){return m.t(),m.C(k,h,!0)},replaceOutputItems(k,h){return m.t(),m.C(k,h,!1)}})}}var n;(function(v){v[v.Init=0]="Init",v[v.Started=1]="Started",v[v.Resolved=2]="Resolved"})(n||(n={}));class s extends A.$Rc{static{this.a=0}get state(){return this.f}constructor(m,S,k){super(),this.h=S,this.j=k,this.b=s.a++,this.c=new M.$Rd,this.onDidChangeState=this.c.event,this.f=n.Init,this.g=this.B(new P.$2d),this.j.$createNotebookExecution(this.b,m,this.h.uri)}cancel(){this.g.cancel()}asApiObject(){return Object.freeze({start:()=>{if(this.f===n.Resolved||this.f===n.Started)throw new Error("Cannot call start again");this.f=n.Started,this.c.fire(),this.j.$beginNotebookExecution(this.b)},end:()=>{if(this.f===n.Resolved)throw new Error("Cannot call resolve twice");this.f=n.Resolved,this.c.fire(),this.j.$completeNotebookExecution(this.b)}})}}class a{constructor(m,S){this.e=m,this.f=S,this.a=[],this.b=Date.now()}addItem(m){return this.a.push(m),this.c||(this.c=new F.$ih,this.b=Date.now(),(0,F.$Yg)(this.e).then(()=>this.flush())),Date.now()-this.b>this.e?this.flush():this.c.p}flush(){if(this.a.length===0||!this.c)return Promise.resolve();const m=this.c;this.c=void 0;const S=this.a;return this.a=[],this.f(S).finally(()=>m.complete())}}function d(v,m){return`${v.value}/${m}`}e.$gfc=d}),define(Pe[259],Re([1,0,5,3,107]),function(be,e,y,F,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hfc=void 0;class M{constructor($,E){this.c=E,this.a=new Map,this.b=$.getProxy(F.$xK.MainThreadNotebookRenderers)}$postRendererMessage($,E,f){const C=this.c.getEditorById($);this.a.get(E)?.fire({editor:C.apiEditor,message:f})}createRendererMessaging($,E){if(!$.contributes?.notebookRenderer?.some(C=>C.id===E))throw new Error(`Extensions may only call createRendererMessaging() for renderers they contribute (got ${E})`);return{onDidReceiveMessage:(C,D,u)=>this.d(E).event(C,D,u),postMessage:(C,D)=>{P.$Zec.apiEditorsToExtHost.has(C)&&([C,D]=[D,C]);const u=D&&P.$Zec.apiEditorsToExtHost.get(D);return this.b.$postMessage(u?.id,E,C)}}}d($){let E=this.a.get($);return E||(E=new y.$Rd({onDidRemoveLastListener:()=>{E?.dispose(),this.a.delete($)}}),this.a.set($,E),E)}}e.$hfc=M}),define(Pe[260],Re([1,0,6,16,2,23,3]),function(be,e,y,F,P,M,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kfc=void 0;class ${constructor(f){this.b=new Map,this.a=f.getProxy(A.$xK.MainThreadProfileContentHandlers)}registrProfileContentHandler(f,C,D){if((0,M.$MF)(f,"profileContentHandlers"),this.b.has(C))throw new Error(`Handler with id '${C}' already registered`);return this.b.set(C,D),this.a.$registerProfileContentHandler(C,D.name,D.description,f.identifier.value),(0,y.$Pc)(()=>{this.b.delete(C),this.a.$unregisterProfileContentHandler(C)})}async $saveProfile(f,C,D,u){const b=this.b.get(f);if(!b)throw new Error(`Unknown handler with id: ${f}`);return b.saveProfile(C,D,u)}async $readProfile(f,C,D){const u=this.b.get(f);if(!u)throw new Error(`Unknown handler with id: ${f}`);return u.readProfile((0,F.$Cf)(C)?C:P.URI.revive(C),D)}}e.$kfc=$}),define(Pe[261],Re([1,0,2,3,14,8]),function(be,e,y,F,P,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mfc=void 0;class A{static{this.a=0}constructor(E,f){this.d=f,this.c=new Map,this.b=E.getProxy(F.$xK.MainThreadQuickDiff)}$provideOriginalResource(E,f,C){const D=y.URI.revive(f),u=this.c.get(E);return u?(0,P.$Qg)(()=>u.provideOriginalResource(D,C)).then(b=>b||null):Promise.resolve(null)}registerQuickDiffProvider(E,f,C,D){const u=A.a++;return this.c.set(u,f),this.b.$registerQuickDiffProvider(u,M.DocumentSelector.from(E,this.d),C,D),{dispose:()=>{this.b.$unregisterQuickDiffProvider(u),this.c.delete(u)}}}}e.$mfc=A}),define(Pe[262],Re([1,0,20,5,6,3,2,7,11,18,31,45,23,8]),function(be,e,y,F,P,M,A,$,E,f,C,D,u,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nfc=void 0;function p(g,t,i){const r=g.getProxy(M.$xK.MainThreadQuickOpen);class c{constructor(S,k){this.e=new Map,this.f=0,this.a=S,this.b=k}showQuickPick(S,k,h,w=y.CancellationToken.None){this.c=void 0;const I=Promise.resolve(k),L=++this.f,V=r.$show(L,{title:h?.title,placeHolder:h?.placeHolder,matchOnDescription:h?.matchOnDescription,matchOnDetail:h?.matchOnDetail,ignoreFocusLost:h?.ignoreFocusOut,canPickMany:h?.canPickMany},w),K={},R=V.then(()=>K);return Promise.race([R,I]).then(N=>{if(N===K)return;const T=(0,u.$LF)(S,"quickPickItemTooltip");return I.then(z=>{const Z=[];for(let he=0;he<z.length;he++){const ye=z[he];if(typeof ye=="string")Z.push({label:ye,handle:he});else if(ye.kind===$.QuickPickItemKind.Separator)Z.push({type:"separator",label:ye.label});else{ye.tooltip&&!T&&console.warn(`Extension '${S.identifier.value}' uses a tooltip which is proposed API that is only available when running out of dev or with the following command line switch: --enable-proposed-api ${S.identifier.value}`);const De=ye.iconPath?a(ye.iconPath):void 0;Z.push({label:ye.label,iconPath:De?.iconPath,iconClass:De?.iconClass,description:ye.description,detail:ye.detail,picked:ye.picked,alwaysShow:ye.alwaysShow,tooltip:T?b.MarkdownString.fromStrict(ye.tooltip):void 0,handle:he})}}return h&&typeof h.onDidSelectItem=="function"&&(this.c=he=>{h.onDidSelectItem(z[he])}),r.$setItems(L,Z),V.then(he=>{if(typeof he=="number")return z[he];if(Array.isArray(he))return he.map(ye=>z[ye])})})}).then(void 0,N=>{if(!(0,E.$3)(N))return r.$setError(L,N),Promise.reject(N)})}$onItemSelected(S){this.c?.(S)}showInput(S,k=y.CancellationToken.None){return this.d=S?.validateInput,r.$input(S,typeof this.d=="function",k).then(void 0,h=>{if(!(0,E.$3)(h))return Promise.reject(h)})}async $validateInput(S){if(!this.d)return;const k=await this.d(S);if(!k||typeof k=="string")return k;let h;switch(k.severity){case $.InputBoxValidationSeverity.Info:h=C.default.Info;break;case $.InputBoxValidationSeverity.Warning:h=C.default.Warning;break;case $.InputBoxValidationSeverity.Error:h=C.default.Error;break;default:h=k.message?C.default.Error:C.default.Ignore;break}return{content:k.message,severity:h}}async showWorkspaceFolderPick(S,k=y.CancellationToken.None){const h=await this.b.executeCommand("_workbench.pickWorkspaceFolder",[S]);if(!h)return;const w=await this.a.getWorkspaceFolders2();if(w)return w.find(I=>I.uri.toString()===h.uri.toString())}createQuickPick(S){const k=new d(S,()=>this.e.delete(k._id));return this.e.set(k._id,k),k}createInputBox(S){const k=new v(S,()=>this.e.delete(k._id));return this.e.set(k._id,k),k}$onDidChangeValue(S,k){this.e.get(S)?._fireDidChangeValue(k)}$onDidAccept(S){this.e.get(S)?._fireDidAccept()}$onDidChangeActive(S,k){const h=this.e.get(S);h instanceof d&&h._fireDidChangeActive(k)}$onDidChangeSelection(S,k){const h=this.e.get(S);h instanceof d&&h._fireDidChangeSelection(k)}$onDidTriggerButton(S,k){this.e.get(S)?._fireDidTriggerButton(k)}$onDidTriggerItemButton(S,k,h){const w=this.e.get(S);w instanceof d&&w._fireDidTriggerItemButton(k,h)}$onDidHide(S){this.e.get(S)?._fireDidHide()}}class o{static{this.a=1}constructor(S,k){this.x=S,this.y=k,this._id=d.a++,this.e=!1,this.f=!1,this.g=!0,this.j=!1,this.k=!0,this.l="",this.n=[],this.o=new Map,this.p=new F.$Rd,this.q=new F.$Rd,this.r=new F.$Rd,this.s=new F.$Rd,this.u={id:this._id},this.v=!1,this.w=[this.r,this.s,this.p,this.q],this.onDidChangeValue=this.q.event,this.onDidAccept=this.p.event,this.onDidTriggerButton=this.r.event,this.onDidHide=this.s.event}get title(){return this.b}set title(S){this.b=S,this.z({title:S})}get step(){return this.c}set step(S){this.c=S,this.z({step:S})}get totalSteps(){return this.d}set totalSteps(S){this.d=S,this.z({totalSteps:S})}get enabled(){return this.g}set enabled(S){this.g=S,this.z({enabled:S})}get busy(){return this.j}set busy(S){this.j=S,this.z({busy:S})}get ignoreFocusOut(){return this.k}set ignoreFocusOut(S){this.k=S,this.z({ignoreFocusOut:S})}get value(){return this.l}set value(S){this.l=S,this.z({value:S})}get placeholder(){return this.m}set placeholder(S){this.m=S,this.z({placeholder:S})}get buttons(){return this.n}set buttons(S){this.n=S.slice(),this.o.clear(),S.forEach((k,h)=>{const w=k===$.$TL.Back?-1:h;this.o.set(w,k)}),this.z({buttons:S.map((k,h)=>({...a(k.iconPath),tooltip:k.tooltip,handle:k===$.$TL.Back?-1:h}))})}show(){this.e=!0,this.f=!0,this.z({visible:!0})}hide(){this.e=!1,this.z({visible:!1})}_fireDidAccept(){this.p.fire()}_fireDidChangeValue(S){this.l=S,this.q.fire(S)}_fireDidTriggerButton(S){const k=this.o.get(S);k&&this.r.fire(k)}_fireDidHide(){this.f&&(this.f=this.e,this.s.fire())}dispose(){this.v||(this.v=!0,this._fireDidHide(),this.w=(0,P.$Mc)(this.w),this.t&&(clearTimeout(this.t),this.t=void 0),this.y(),r.$dispose(this._id))}z(S){if(!this.v){for(const k of Object.keys(S)){const h=S[k];this.u[k]=h===void 0?null:h}"visible"in this.u?(this.t&&(clearTimeout(this.t),this.t=void 0),this.A()):this.e&&!this.t&&(this.t=setTimeout(()=>{this.t=void 0,this.A()},0))}}A(){r.$createOrUpdate(this.u),this.u={id:this._id}}}function l(m){if(m instanceof $.$tL)return{id:m.id};const S=s(m),k=n(m);return{dark:typeof S=="string"?A.URI.file(S):S,light:typeof k=="string"?A.URI.file(k):k}}function n(m){return typeof m=="object"&&"light"in m?m.light:m}function s(m){return typeof m=="object"&&"dark"in m?m.dark:m}function a(m){const S=l(m);let k,h;return"id"in S?h=D.ThemeIcon.asClassName(S):k=S,{iconPath:k,iconClass:h}}class d extends o{constructor(S,k){super(S.identifier,k),this.O=S,this.B=[],this.C=new Map,this.D=new Map,this.E=!1,this.F=!0,this.G=!0,this.H=!0,this.I=!1,this.J=[],this.K=new F.$Rd,this.L=[],this.M=new F.$Rd,this.N=new F.$Rd,this.onDidChangeActive=this.K.event,this.onDidChangeSelection=this.M.event,this.onDidTriggerItemButton=this.N.event,this.w.push(this.K,this.M,this.N),this.z({type:"quickPick"})}get items(){return this.B}set items(S){this.B=S.slice(),this.C.clear(),this.D.clear(),S.forEach((w,I)=>{this.C.set(I,w),this.D.set(w,I)});const k=(0,u.$LF)(this.O,"quickPickItemTooltip"),h=[];for(let w=0;w<S.length;w++){const I=S[w];if(I.kind===$.QuickPickItemKind.Separator)h.push({type:"separator",label:I.label});else{I.tooltip&&!k&&console.warn(`Extension '${this.O.identifier.value}' uses a tooltip which is proposed API that is only available when running out of dev or with the following command line switch: --enable-proposed-api ${this.O.identifier.value}`);const L=I.iconPath?a(I.iconPath):void 0;h.push({handle:w,label:I.label,iconPath:L?.iconPath,iconClass:L?.iconClass,description:I.description,detail:I.detail,picked:I.picked,alwaysShow:I.alwaysShow,tooltip:k?b.MarkdownString.fromStrict(I.tooltip):void 0,buttons:I.buttons?.map((V,K)=>({...a(V.iconPath),tooltip:V.tooltip,handle:K}))})}}this.z({items:h})}get canSelectMany(){return this.E}set canSelectMany(S){this.E=S,this.z({canSelectMany:S})}get matchOnDescription(){return this.F}set matchOnDescription(S){this.F=S,this.z({matchOnDescription:S})}get matchOnDetail(){return this.G}set matchOnDetail(S){this.G=S,this.z({matchOnDetail:S})}get sortByLabel(){return this.H}set sortByLabel(S){this.H=S,this.z({sortByLabel:S})}get keepScrollPosition(){return this.I}set keepScrollPosition(S){this.I=S,this.z({keepScrollPosition:S})}get activeItems(){return this.J}set activeItems(S){this.J=S.filter(k=>this.D.has(k)),this.z({activeItems:this.J.map(k=>this.D.get(k))})}get selectedItems(){return this.L}set selectedItems(S){this.L=S.filter(k=>this.D.has(k)),this.z({selectedItems:this.L.map(k=>this.D.get(k))})}_fireDidChangeActive(S){const k=(0,f.$Gb)(S.map(h=>this.C.get(h)));this.J=k,this.K.fire(k)}_fireDidChangeSelection(S){const k=(0,f.$Gb)(S.map(h=>this.C.get(h)));this.L=k,this.M.fire(k)}_fireDidTriggerItemButton(S,k){const h=this.C.get(S);if(!h||!h.buttons||!h.buttons.length)return;const w=h.buttons[k];w&&this.N.fire({button:w,item:h})}}class v extends o{constructor(S,k){super(S.identifier,k),this.B=!1,this.z({type:"inputBox"})}get password(){return this.B}set password(S){this.B=S,this.z({password:S})}get prompt(){return this.C}set prompt(S){this.C=S,this.z({prompt:S})}get valueSelection(){return this.D}set valueSelection(S){this.D=S,this.z({valueSelection:S})}get validationMessage(){return this.E}set validationMessage(S){this.E=S,S?typeof S=="string"?this.z({validationMessage:S,severity:C.default.Error}):this.z({validationMessage:S.message,severity:S.severity??C.default.Error}):this.z({validationMessage:void 0,severity:C.default.Ignore})}}return new c(t,i)}e.$nfc=p}),define(Pe[263],Re([1,0,2,5,66,6,14,3,18,138,15,22,45,8,23,13,21]),function(be,e,y,F,P,M,A,$,E,f,C,D,u,b,p,g,t){"use strict";var i;Object.defineProperty(e,"__esModule",{value:!0}),e.$pfc=e.$ofc=void 0;function r(K){return K instanceof y.URI}function c(K,R){return K.scheme===g.Schemas.file&&R.scheme===g.Schemas.file&&t.$k?K.toString()===R.toString():K.toString().toLowerCase()===R.toString().toLowerCase()}function o(K){if(K)return typeof K.iconPath=="string"?y.URI.file(K.iconPath):y.URI.isUri(K.iconPath)||u.ThemeIcon.isThemeIcon(K.iconPath)?K.iconPath:void 0}function l(K){if(K?.icon){if(y.URI.isUri(K.icon))return K.icon;if(u.ThemeIcon.isThemeIcon(K.icon))return K.icon;{const R=K.icon;return{light:R.light,dark:R.dark}}}else return}function n(K){if(K.icon){if(y.URI.isUri(K.icon))return K.icon;if(u.ThemeIcon.isThemeIcon(K.icon))return K.icon;{const R=K.icon;return{light:R.light,dark:R.dark}}}else return}function s(K,R){if(!K.iconPath&&!R.iconPath)return 0;if(K.iconPath){if(!R.iconPath)return 1}else return-1;const N=typeof K.iconPath=="string"?K.iconPath:y.URI.isUri(K.iconPath)?K.iconPath.fsPath:K.iconPath.id,T=typeof R.iconPath=="string"?R.iconPath:y.URI.isUri(R.iconPath)?R.iconPath.fsPath:R.iconPath.id;return(0,f.$xq)(N,T)}function a(K,R){let N=0;if(K.strikeThrough!==R.strikeThrough)return K.strikeThrough?1:-1;if(K.faded!==R.faded)return K.faded?1:-1;if(K.tooltip!==R.tooltip)return(K.tooltip||"").localeCompare(R.tooltip||"");if(N=s(K,R),N!==0)return N;if(K.light&&R.light)N=s(K.light,R.light);else{if(K.light)return 1;if(R.light)return-1}if(N!==0)return N;if(K.dark&&R.dark)N=s(K.dark,R.dark);else{if(K.dark)return 1;if(R.dark)return-1}return N}function d(K,R){if(K.command!==R.command)return K.command<R.command?-1:1;if(K.title!==R.title)return K.title<R.title?-1:1;if(K.tooltip!==R.tooltip){if(K.tooltip!==void 0&&R.tooltip!==void 0)return K.tooltip<R.tooltip?-1:1;if(K.tooltip!==void 0)return 1;if(R.tooltip!==void 0)return-1}if(K.arguments===R.arguments)return 0;if(K.arguments)if(R.arguments){if(K.arguments.length!==R.arguments.length)return K.arguments.length-R.arguments.length}else return 1;else return-1;for(let N=0;N<K.arguments.length;N++){const T=K.arguments[N],z=R.arguments[N];if(T!==z&&!(r(T)&&r(z)&&c(T,z)))return T<z?-1:1}return 0}function v(K,R){let N=(0,f.$xq)(K.resourceUri.fsPath,R.resourceUri.fsPath,!0);if(N!==0)return N;if(K.command&&R.command)N=d(K.command,R.command);else{if(K.command)return 1;if(R.command)return-1}if(N!==0)return N;if(K.decorations&&R.decorations)N=a(K.decorations,R.decorations);else{if(K.decorations)return 1;if(R.decorations)return-1}return N}function m(K,R){for(let N=0;N<K.length;N++)if(K[N]!==R[N])return!1;return!0}function S(K,R){return K.command===R.command&&K.title===R.title&&K.tooltip===R.tooltip&&(K.arguments&&R.arguments?m(K.arguments,R.arguments):K.arguments===R.arguments)}function k(K,R){return(0,E.$tb)(K,R,S)}function h(K,R){return K===R?!0:!K||!R?!1:K.id===R.id&&K.label===R.label&&K.upstream?.id===R.upstream?.id&&K.upstream?.label===R.upstream?.label}class w{#e;#t;get value(){return this.d}set value(R){R=R??"",this.#e.$setInputBoxValue(this.o,R),this.q(R)}get onDidChange(){return this.e.event}get placeholder(){return this.f}set placeholder(R){this.#e.$setInputBoxPlaceholder(this.o,R),this.f=R}get validateInput(){return(0,p.$MF)(this.m,"scmValidation"),this.g}set validateInput(R){if((0,p.$MF)(this.m,"scmValidation"),R&&typeof R!="function")throw new Error(`[${this.m.identifier.value}]: Invalid SCM input box validation function`);this.g=R,this.#e.$setValidationProviderIsEnabled(this.o,!!R)}get enabled(){return this.h}set enabled(R){R=!!R,this.h!==R&&(this.h=R,this.#e.$setInputBoxEnablement(this.o,R))}get visible(){return this.j}set visible(R){R=!!R,this.j!==R&&(this.j=R,this.#e.$setInputBoxVisibility(this.o,R))}get actionButton(){return(0,p.$MF)(this.m,"scmInputBoxActionButton"),this.k}set actionButton(R){(0,p.$MF)(this.m,"scmInputBoxActionButton"),this.l.value=new M.$Qc,this.k=R;const N=R!==void 0?{command:this.n.converter.toInternal(R.command,this.l.value),icon:l(R),enabled:R.enabled}:void 0;this.#e.$setInputBoxActionButton(this.o,N??null)}get document(){return(0,p.$MF)(this.m,"scmTextDocument"),this.#t.getDocument(this.p)}constructor(R,N,T,z,Z,he){this.m=R,this.n=N,this.o=Z,this.p=he,this.d="",this.e=new F.$Rd,this.f="",this.h=!0,this.j=!0,this.l=new M.$Sc,this.#t=T,this.#e=z}showValidationMessage(R,N){(0,p.$MF)(this.m,"scmValidation"),this.#e.$showValidationMessage(this.o,R,N)}$onInputBoxValueChange(R){this.q(R)}q(R){this.d=R,this.e.fire(R)}}e.$ofc=w;class I{static{this.d=0}get disposed(){return this.l}get id(){return this.u}get label(){return this.v}set label(R){this.v=R,this.q.$updateGroupLabel(this.t,this.handle,R)}get hideWhenEmpty(){return this.p}set hideWhenEmpty(R){this.p=R,this.q.$updateGroup(this.t,this.handle,this.features)}get features(){return{hideWhenEmpty:this.hideWhenEmpty}}get resourceStates(){return[...this.f]}set resourceStates(R){this.f=[...R],this.k.fire()}constructor(R,N,T,z,Z){this.q=R,this.s=N,this.t=T,this.u=z,this.v=Z,this.e=0,this.f=[],this.g=new Map,this.h=new Map,this.j=new Map,this.k=new F.$Rd,this.onDidUpdateResourceStates=this.k.event,this.l=!1,this.m=new F.$Rd,this.onDidDispose=this.m.event,this.n=[],this.o=[],this.p=void 0,this.handle=I.d++}getResourceState(R){return this.g.get(R)}$executeResourceCommand(R,N){const T=this.h.get(R);return T?(0,A.$Qg)(()=>this.s.executeCommand(T.command,...T.arguments||[],N)):Promise.resolve(void 0)}_takeResourceStateSnapshot(){const R=[...this.f].sort(v),T=(0,E.$Cb)(this.o,R,v).map(he=>{const ye=he.toInsert.map(De=>{const Se=this.e++;this.g.set(Se,De);const fe=De.resourceUri;let $e;if(De.command)if(De.command.command==="vscode.open"||De.command.command==="vscode.diff"||De.command.command==="vscode.changes"){const ce=new M.$Qc;$e=this.s.converter.toInternal(De.command,ce),this.j.set(Se,ce)}else this.h.set(Se,De.command);const re=o(De.decorations),Ae=De.decorations&&o(De.decorations.light)||re,se=De.decorations&&o(De.decorations.dark)||re,X=[Ae,se],B=De.decorations&&De.decorations.tooltip||"",ie=De.decorations&&!!De.decorations.strikeThrough,pe=De.decorations&&!!De.decorations.faded,ne=De.contextValue||"";return{rawResource:[Se,fe,X,B,ie,pe,ne,$e],handle:Se}});return{start:he.start,deleteCount:he.deleteCount,toInsert:ye}}),z=T.map(({start:he,deleteCount:ye,toInsert:De})=>[he,ye,De.map(Se=>Se.rawResource)]),Z=T.reverse();for(const{start:he,deleteCount:ye,toInsert:De}of Z){const Se=De.map($e=>$e.handle),fe=this.n.splice(he,ye,...Se);for(const $e of fe)this.g.delete($e),this.h.delete($e),this.j.get($e)?.dispose(),this.j.delete($e)}return this.o=R,z}dispose(){this.l=!0,this.m.fire()}}class L{static{this.d=0}#e;get id(){return this.A}get label(){return this.B}get rootUri(){return this.C}get inputBox(){return this.f}get count(){return this.g}set count(R){this.g!==R&&(this.g=R,this.#e.$updateSourceControl(this.x,{count:R}))}get quickDiffProvider(){return this.h}set quickDiffProvider(R){this.h=R;let N;(0,p.$LF)(this.y,"quickDiffProvider")&&(N=R?.label),this.#e.$updateSourceControl(this.x,{hasQuickDiffProvider:!!R,quickDiffLabel:N})}get historyProvider(){return(0,p.$MF)(this.y,"scmHistoryProvider"),this.j}set historyProvider(R){(0,p.$MF)(this.y,"scmHistoryProvider"),this.j=R,this.k.value=new M.$Qc,this.#e.$updateSourceControl(this.x,{hasHistoryProvider:!!R}),R&&(this.k.value.add(R.onDidChangeCurrentHistoryItemGroup(()=>{h(this.l,R?.currentHistoryItemGroup)||(this.l=R?.currentHistoryItemGroup,this.#e.$onDidChangeHistoryProviderCurrentHistoryItemGroup(this.x,this.l))})),this.k.value.add(R.onDidChangeActionButton(()=>{(0,p.$MF)(this.y,"scmActionButton"),this.m.value=new M.$Qc;const N=R.actionButton!==void 0?{command:this.z.converter.toInternal(R.actionButton.command,this.m.value),description:R.actionButton.description,enabled:R.actionButton.enabled}:void 0;this.#e.$onDidChangeHistoryProviderActionButton(this.x,N??null)})))}get commitTemplate(){return this.n}set commitTemplate(R){R!==this.n&&(this.n=R,this.#e.$updateSourceControl(this.x,{commitTemplate:R}))}get acceptInputCommand(){return this.p}set acceptInputCommand(R){this.o.value=new M.$Qc,this.p=R;const N=this.z.converter.toInternal(R,this.o.value);this.#e.$updateSourceControl(this.x,{acceptInputCommand:N})}get actionButton(){return(0,p.$MF)(this.y,"scmActionButton"),this.s}set actionButton(R){(0,p.$MF)(this.y,"scmActionButton"),this.q.value=new M.$Qc,this.s=R;const N=R!==void 0?{command:this.z.converter.toInternal(R.command,this.q.value),secondaryCommands:R.secondaryCommands?.map(T=>T.map(z=>this.z.converter.toInternal(z,this.q.value))),description:R.description,enabled:R.enabled}:void 0;this.#e.$updateSourceControl(this.x,{actionButton:N??null})}get statusBarCommands(){return this.u}set statusBarCommands(R){if(this.u&&R&&k(this.u,R))return;this.t.value=new M.$Qc,this.u=R;const N=(R||[]).map(T=>this.z.converter.toInternal(T,this.t.value));this.#e.$updateSourceControl(this.x,{statusBarCommands:N})}get selected(){return this.v}constructor(R,N,T,z,Z,he,ye){this.y=R,this.z=z,this.A=Z,this.B=he,this.C=ye,this.e=new Map,this.g=void 0,this.h=void 0,this.k=new M.$Sc,this.m=new M.$Sc,this.n=void 0,this.o=new M.$Sc,this.p=void 0,this.q=new M.$Sc,this.t=new M.$Sc,this.u=void 0,this.v=!1,this.w=new F.$Rd,this.onDidChangeSelection=this.w.event,this.x=L.d++,this.D=new Map,this.E=new Set,this.#e=T;const De=y.URI.from({scheme:g.Schemas.vscodeSourceControl,path:`${Z}/scm${this.x}/input`,query:ye?`rootUri=${encodeURIComponent(ye.toString())}`:void 0});this.f=new w(R,z,N,this.#e,this.x,De),this.#e.$registerSourceControl(this.x,Z,he,ye,De)}createResourceGroup(R,N){const T=new I(this.#e,this.z,this.x,R,N),z=F.Event.once(T.onDidDispose)(()=>this.D.delete(T));return this.D.set(T,z),this.eventuallyAddResourceGroups(),T}eventuallyAddResourceGroups(){const R=[],N=[];for(const[T,z]of this.D){z.dispose();const Z=T.onDidUpdateResourceStates(()=>{this.E.add(T),this.eventuallyUpdateResourceStates()});F.Event.once(T.onDidDispose)(()=>{this.E.delete(T),Z.dispose(),this.e.delete(T.handle),this.#e.$unregisterGroup(this.x,T.handle)}),R.push([T.handle,T.id,T.label,T.features]);const he=T._takeResourceStateSnapshot();he.length>0&&N.push([T.handle,he]),this.e.set(T.handle,T)}this.#e.$registerGroups(this.x,R,N),this.D.clear()}eventuallyUpdateResourceStates(){const R=[];this.E.forEach(N=>{const T=N._takeResourceStateSnapshot();T.length!==0&&R.push([N.handle,T])}),R.length>0&&this.#e.$spliceResourceStates(this.x,R),this.E.clear()}getResourceGroup(R){return this.e.get(R)}setSelectionState(R){this.v=R,this.w.fire(R)}dispose(){this.o.dispose(),this.q.dispose(),this.t.dispose(),this.e.forEach(R=>R.dispose()),this.#e.$unregisterSourceControl(this.x)}}Ke([(0,P.$oh)(100)],L.prototype,"eventuallyAddResourceGroups",null),Ke([(0,P.$oh)(100)],L.prototype,"eventuallyUpdateResourceStates",null);let V=class{static{i=this}static{this.d=0}get onDidChangeActiveProvider(){return this.j.event}constructor(R,N,T,z){this.l=N,this.m=T,this.n=z,this.g=new Map,this.h=new D.$bm,this.j=new F.$Rd,this.e=R.getProxy($.$xK.MainThreadSCM),this.f=R.getProxy($.$xK.MainThreadTelemetry),N.registerArgumentProcessor({processArgument:Z=>{if(Z&&Z.$mid===3){const he=this.g.get(Z.sourceControlHandle);if(!he)return Z;const ye=he.getResourceGroup(Z.groupHandle);return ye?ye.getResourceState(Z.handle):Z}else if(Z&&Z.$mid===4){const he=this.g.get(Z.sourceControlHandle);return he?he.getResourceGroup(Z.groupHandle):Z}else if(Z&&Z.$mid===5){const he=this.g.get(Z.handle);return he||Z}return Z}})}createSourceControl(R,N,T,z){this.n.trace("ExtHostSCM#createSourceControl",R.identifier.value,N,T,z),this.f.$publicLog2("api/scm/createSourceControl",{extensionId:R.identifier.value});const Z=i.d++,he=new L(R,this.m,this.e,this.l,N,T,z);this.g.set(Z,he);const ye=this.h.get(R.identifier)||[];return ye.push(he),this.h.set(R.identifier,ye),he}getLastInputBox(R){this.n.trace("ExtHostSCM#getLastInputBox",R.identifier.value);const N=this.h.get(R.identifier),T=N&&N[N.length-1];return T&&T.inputBox}$provideOriginalResource(R,N,T){const z=y.URI.revive(N);this.n.trace("ExtHostSCM#$provideOriginalResource",R,z.toString());const Z=this.g.get(R);return!Z||!Z.quickDiffProvider||!Z.quickDiffProvider.provideOriginalResource?Promise.resolve(null):(0,A.$Qg)(()=>Z.quickDiffProvider.provideOriginalResource(z,T)).then(he=>he||null)}$onInputBoxValueChange(R,N){this.n.trace("ExtHostSCM#$onInputBoxValueChange",R);const T=this.g.get(R);return T&&T.inputBox.$onInputBoxValueChange(N),Promise.resolve(void 0)}$executeResourceCommand(R,N,T,z){this.n.trace("ExtHostSCM#$executeResourceCommand",R,N,T);const Z=this.g.get(R);if(!Z)return Promise.resolve(void 0);const he=Z.getResourceGroup(N);return he?he.$executeResourceCommand(T,z):Promise.resolve(void 0)}$validateInput(R,N,T){this.n.trace("ExtHostSCM#$validateInput",R);const z=this.g.get(R);return!z||!z.inputBox.validateInput?Promise.resolve(void 0):(0,A.$Qg)(()=>z.inputBox.validateInput(N,T)).then(Z=>{if(!Z)return Promise.resolve(void 0);const he=b.MarkdownString.fromStrict(Z.message);return he?Promise.resolve([he,Z.type]):Promise.resolve(void 0)})}$setSelectedSourceControl(R){return this.n.trace("ExtHostSCM#$setSelectedSourceControl",R),R!==void 0&&this.g.get(R)?.setSelectionState(!0),this.k!==void 0&&this.g.get(this.k)?.setSelectionState(!1),this.k=R,Promise.resolve(void 0)}async $resolveHistoryItemGroupBase(R,N,T){return await this.g.get(R)?.historyProvider?.resolveHistoryItemGroupBase(N,T)??void 0}async $resolveHistoryItemGroupCommonAncestor(R,N,T,z){return await this.g.get(R)?.historyProvider?.resolveHistoryItemGroupCommonAncestor(N,T,z)??void 0}async $provideHistoryItems(R,N,T,z){return(await this.g.get(R)?.historyProvider?.provideHistoryItems(N,T,z))?.map(ye=>({...ye,icon:n(ye)}))??void 0}async $provideHistoryItemChanges(R,N,T){return await this.g.get(R)?.historyProvider?.provideHistoryItemChanges(N,T)??void 0}};e.$pfc=V,e.$pfc=V=i=Ke([Ve(3,C.$dj)],V)}),define(Pe[84],Re([1,0,3,5,4]),function(be,e,y,F,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wec=e.$vec=void 0;class M{constructor($){this.b=new F.$Rd,this.onDidChangePassword=this.b.event,this.a=$.getProxy(y.$xK.MainThreadSecretState)}async $onDidChangePassword($){this.b.fire($)}get($,E){return this.a.$getPassword($,E)}store($,E,f){return this.a.$setPassword($,E,f)}delete($,E){return this.a.$deletePassword($,E)}}e.$vec=M,e.$wec=(0,P.$Vh)("IExtHostSecretState")}),define(Pe[264],Re([1,0,3,8,2]),function(be,e,y,F,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qfc=void 0;class M{static{this.a=0}constructor($,E){this.d=E,this.c=new Map,this.b=$.getProxy(y.$xK.MainThreadShare)}async $provideShare($,E,f){return await this.c.get($)?.provideShare({selection:F.Range.to(E.selection),resourceUri:P.URI.revive(E.resourceUri)},f)??void 0}registerShareProvider($,E){const f=M.a++;return this.c.set(f,E),this.b.$registerShareProvider(f,F.DocumentSelector.from($,this.d),E.id,E.label,E.priority),{dispose:()=>{this.b.$unregisterShareProvider(f),this.c.delete(f)}}}}e.$qfc=M}),define(Pe[265],Re([1,0,20,6,3]),function(be,e,y,F,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rfc=void 0;class M{static{this.a=1}constructor($){this.c=new Map,this.d=new Map,this.b=$.getProxy(P.$xK.MainThreadSpeech)}async $createSpeechToTextSession($,E){const f=this.c.get($);if(!f)return;const C=new F.$Qc,D=new y.$2d;this.d.set(E,D);const u=C.add(f.provideSpeechToTextSession(D.token));C.add(u.onDidChange(b=>{D.token.isCancellationRequested||this.b.$emitSpeechToTextEvent(E,b)})),C.add(D.token.onCancellationRequested(()=>C.dispose()))}async $cancelSpeechToTextSession($){this.d.get($)?.dispose(!0),this.d.delete($)}registerProvider($,E,f){const C=M.a++;return this.c.set(C,f),this.b.$registerProvider(C,E,{extension:$,displayName:$.value}),(0,F.$Pc)(()=>{this.b.$unregisterProvider(C),this.c.delete(C)})}}e.$rfc=M}),define(Pe[266],Re([1,0,7,3,164,6,8,16]),function(be,e,y,F,P,M,A,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tfc=e.$sfc=void 0;class E{static{this.a=0}static{this.b=new Map([["statusBarItem.errorBackground",new y.$uL("statusBarItem.errorForeground")],["statusBarItem.warningBackground",new y.$uL("statusBarItem.warningForeground")]])}#e;#t;constructor(u,b,p,g,t,i=y.StatusBarAlignment.Left,r){if(this.i=!1,this.k="",this.q=new M.$Qc,this.#e=u,this.#t=b,t&&g){this.c=(0,y.$0K)(g.identifier,t);const c=p.get(this.c);c&&(i=c.alignLeft?y.StatusBarAlignment.Left:y.StatusBarAlignment.Right,r=c.priority,this.j=!0,this.name=c.name,this.text=c.text,this.tooltip=c.tooltip,this.command=c.command,this.accessibilityInformation=c.accessibilityInformation)}else this.c=String(E.a++);this.e=g,this.f=t,this.g=i,this.h=this.u(r)}u(u){if((0,$.$Gf)(u))return u===Number.POSITIVE_INFINITY?Number.MAX_VALUE:u===Number.NEGATIVE_INFINITY?-Number.MAX_VALUE:u}get id(){return this.f??this.e.identifier.value}get alignment(){return this.g}get priority(){return this.h}get text(){return this.k}get name(){return this.m}get tooltip(){return this.l}get color(){return this.n}get backgroundColor(){return this.o}get command(){return this.r?.fromApi}get accessibilityInformation(){return this.t}set text(u){this.k=u,this.v()}set name(u){this.m=u,this.v()}set tooltip(u){this.l=u,this.v()}set color(u){this.n=u,this.v()}set backgroundColor(u){u&&!E.b.has(u.id)&&(u=void 0),this.o=u,this.v()}set command(u){this.r?.fromApi!==u&&(this.p&&this.q.add(this.p),this.p=new M.$Qc,typeof u=="string"?this.r={fromApi:u,internal:this.#t.toInternal({title:"",command:u},this.p)}:u?this.r={fromApi:u,internal:this.#t.toInternal(u,this.p)}:this.r=void 0,this.v())}set accessibilityInformation(u){this.t=u,this.v()}show(){this.j=!0,this.v()}hide(){clearTimeout(this.s),this.j=!1,this.#e.$disposeEntry(this.c)}v(){this.i||!this.j||(clearTimeout(this.s),this.s=setTimeout(()=>{this.s=void 0;let u;this.e?this.f?u=`${this.e.identifier.value}.${this.f}`:u=this.e.identifier.value:u=this.f;let b;this.m?b=this.m:b=(0,P.localize)(0,null,this.e.displayName||this.e.name);let p=this.n;this.o&&(p=E.b.get(this.o.id));const g=A.MarkdownString.fromStrict(this.l);this.#e.$setEntry(this.c,u,this.e?.identifier.value,b,this.k,g,this.r?.internal,p,this.o,this.g===y.StatusBarAlignment.Left,this.h,this.t),this.q.clear()},0))}dispose(){this.hide(),this.i=!0}}e.$sfc=E;class f{constructor(u){this.b=[],this.a=u.createStatusBarEntry(void 0,"status.extensionMessage",y.StatusBarAlignment.Left,Number.MIN_VALUE),this.a.name=(0,P.localize)(1,null)}dispose(){this.b.length=0,this.a.dispose()}setMessage(u){const b={message:u};return this.b.unshift(b),this.c(),new y.$zK(()=>{const p=this.b.indexOf(b);p>=0&&(this.b.splice(p,1),this.c())})}c(){this.b.length>0?(this.a.text=this.b[0].message,this.a.show()):this.a.hide()}}class C{constructor(u,b){this.e=new Map,this.a=u.getProxy(F.$xK.MainThreadStatusBar),this.b=b,this.c=new f(this)}$acceptStaticEntries(u){for(const b of u)this.e.set(b.entryId,b)}createStatusBarEntry(u,b,p,g){return new E(this.a,this.b,this.e,u,b,p,g)}setStatusBarMessage(u,b){const p=this.c.setMessage(u);let g;return typeof b=="number"?g=setTimeout(()=>p.dispose(),b):typeof b<"u"&&b.then(()=>p.dispose(),()=>p.dispose()),new y.$zK(()=>{p.dispose(),clearTimeout(g)})}}e.$tfc=C}),define(Pe[85],Re([1,0,3,5,4]),function(be,e,y,F,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$oec=e.$nec=void 0;class M{constructor($,E){this.c=E,this.b=new F.$Rd,this.onDidChangeStorage=this.b.event,this.a=$.getProxy(y.$xK.MainThreadStorage)}registerExtensionStorageKeysToSync($,E){this.a.$registerExtensionStorageKeysToSync($,E)}async initializeExtensionStorage($,E,f){const C=await this.a.$initializeExtensionStorage($,E);let D;return C&&(D=this.d($,E,C)),D||f}setValue($,E,f){return this.a.$setValue($,E,f)}$acceptValue($,E,f){const C=this.d($,E,f);C&&this.b.fire({shared:$,key:E,value:C})}d($,E,f){try{return JSON.parse(f)}catch(C){this.c.error(`[extHostStorage] unexpected error parsing storage contents (extensionId: ${E}, global: ${$}): ${C}`)}}}e.$nec=M,e.$oec=(0,P.$Vh)("IExtHostStorage")}),define(Pe[86],Re([1,0,4,27,15,63,2]),function(be,e,y,F,P,M,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0dc=e.$9dc=void 0,e.$9dc=(0,y.$Vh)("IExtensionStoragePaths");let $=class{constructor(f,C,D){this.d=C,this.f=D,this.a=f.workspace??void 0,this.b=f.environment,this.whenReady=this.h().then(u=>this.c=u)}async g(f){return A.URI.joinPath(this.b.workspaceStorageHome,f)}async h(){if(!this.a)return Promise.resolve(void 0);const f=this.a.id,C=await this.g(f);try{return await this.f.value.stat(C),this.d.trace("[ExtHostStorage] storage dir already exists",C),C}catch{}try{return this.d.trace("[ExtHostStorage] creating dir and metadata-file",C),await this.f.value.createDirectory(C),await this.f.value.writeFile(A.URI.joinPath(C,"meta.json"),new TextEncoder().encode(JSON.stringify({id:this.a.id,configuration:A.URI.revive(this.a.configuration)?.toString(),name:this.a.name},void 0,2))),C}catch(D){this.d.error("[ExtHostStorage]",D);return}}workspaceValue(f){if(this.c)return A.URI.joinPath(this.c,f.identifier.value)}globalValue(f){return A.URI.joinPath(this.b.globalStorageHome,f.identifier.value.toLowerCase())}onWillDeactivateAll(){}};e.$0dc=$,e.$0dc=$=Ke([Ve(0,F.$PM),Ve(1,P.$dj),Ve(2,M.$8dc)],$)}),define(Pe[64],Re([1,0,5,3,4,2,17,6,7,166,11,194,20,38,195,45,14,8,32]),function(be,e,y,F,P,M,A,$,E,f,C,D,u,b,p,g,t,i,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uec=e.$tec=e.$sec=e.$rec=void 0,e.$rec=(0,P.$Vh)("IExtHostTerminalService");class c{constructor(h,w,I,L){this.l=h,this._id=w,this.m=I,this.n=L,this.a=!1,this.j={isInteractedWith:!1},this.isOpen=!1,this.m=Object.freeze(this.m),this.b=new Promise(K=>this.f=K);const V=this;this.value={get name(){return V.n||""},get processId(){return V.b},get creationOptions(){return V.m},get exitStatus(){return V.h},get state(){return V.j},get selection(){return V.k},sendText(K,R=!0){V.q(),V.l.$sendText(V._id,K,R)},show(K){V.q(),V.l.$show(V._id,K)},hide(){V.q(),V.l.$hide(V._id)},dispose(){V.a||(V.a=!0,V.l.$dispose(V._id))},get dimensions(){if(!(V.d===void 0||V.g===void 0))return{columns:V.d,rows:V.g}}}}async create(h,w){if(typeof this._id!="string")throw new Error("Terminal has already been created");await this.l.$createTerminal(this._id,{name:h.name,shellPath:h.shellPath??void 0,shellArgs:h.shellArgs??void 0,cwd:h.cwd??w?.cwd??void 0,env:h.env??void 0,icon:v(h.iconPath)??void 0,color:g.ThemeColor.isThemeColor(h.color)?h.color.id:void 0,initialText:h.message??void 0,strictEnv:h.strictEnv??void 0,hideFromUser:h.hideFromUser??void 0,isFeatureTerminal:w?.isFeatureTerminal??void 0,isExtensionOwnedTerminal:!0,useShellEnvironment:w?.useShellEnvironment??void 0,location:w?.location||this.o(h.location,w?.resolvedExtHostIdentifier),isTransient:h.isTransient??void 0})}async createExtensionTerminal(h,w,I,L){if(typeof this._id!="string")throw new Error("Terminal has already been created");if(await this.l.$createTerminal(this._id,{name:this.n,isExtensionCustomPtyTerminal:!0,icon:I,color:g.ThemeColor.isThemeColor(L)?L.id:void 0,location:this.o(h,w),isTransient:!0}),typeof this._id=="string")throw new Error("Terminal creation failed");return this._id}o(h,w){return typeof h=="object"?"parentTerminal"in h&&h.parentTerminal&&w?{parentTerminal:w}:"viewColumn"in h?{viewColumn:i.ViewColumn.from(h.viewColumn),preserveFocus:h.preserveFocus}:void 0:h}q(){if(this.a)throw new Error("Terminal has already been disposed")}set name(h){this.n=h}setExitStatus(h,w){this.h=Object.freeze({code:h,reason:w})}setDimensions(h,w){return h===this.d&&w===this.g||h===0||w===0?!1:(this.d=h,this.g=w,!0)}setInteractedWith(){return this.j.isInteractedWith?!1:(this.j={isInteractedWith:!0},!0)}setSelection(h){this.k=h}_setProcessId(h){this.f?(this.f(h),this.f=void 0):this.b.then(w=>{w!==h&&(this.b=Promise.resolve(h))})}}e.$sec=c;class o{get onProcessReady(){return this.b.event}constructor(h){this.g=h,this.id=0,this.shouldPersist=!1,this.a=new y.$Rd,this.onProcessData=this.a.event,this.b=new y.$Rd,this.d=new y.$Rd,this.onDidChangeProperty=this.d.event,this.f=new y.$Rd,this.onProcessExit=this.f.event}refreshProperty(h){throw new Error(`refreshProperty is not suppported in extension owned terminals. property: ${h}`)}updateProperty(h,w){throw new Error(`updateProperty is not suppported in extension owned terminals. property: ${h}, value: ${w}`)}async start(){}shutdown(){this.g.close()}input(h){this.g.handleInput?.(h)}resize(h,w){this.g.setDimensions?.({columns:h,rows:w})}clearBuffer(){}async processBinary(h){}acknowledgeDataEvent(h){}async setUnicodeVersion(h){}getInitialCwd(){return Promise.resolve("")}getCwd(){return Promise.resolve("")}startSendingEvents(h){this.g.onDidWrite(w=>this.a.fire(w)),this.g.onDidClose?.((w=void 0)=>{this.f.fire(w===void 0?void 0:w)}),this.g.onDidOverrideDimensions?.(w=>{w&&this.d.fire({type:"overrideDimensions",value:{cols:w.columns,rows:w.rows}})}),this.g.onDidChangeName?.(w=>{this.d.fire({type:"title",value:w})}),this.g.open(h||void 0),h&&this.g.setDimensions?.(h),this.b.fire({pid:-1,cwd:"",windowsPty:void 0})}}let l=1,n=class extends $.$Rc{get activeTerminal(){return this.b?.value}get terminals(){return this.f.map(h=>h.value)}constructor(h,w,I){super(),this.Q=w,this.f=[],this.g=new Map,this.h={},this.j={},this.m={},this.n=new Map,this.w=this.B(new $.$Sc),this.z=new Set,this.C=new Map,this.D=new Map,this.F=new Map,this.G=new Map,this.H=new y.$Rd,this.onDidCloseTerminal=this.H.event,this.I=new y.$Rd,this.onDidOpenTerminal=this.I.event,this.J=new y.$Rd,this.onDidChangeActiveTerminal=this.J.event,this.L=new y.$Rd,this.onDidChangeTerminalDimensions=this.L.event,this.M=new y.$Rd,this.onDidChangeTerminalState=this.M.event,this.N=new y.$Rd,this.onDidChangeShell=this.N.event,this.O=new y.$Rd({onWillAddFirstListener:()=>this.a.$startSendingDataEvents(),onDidRemoveLastListener:()=>this.a.$stopSendingDataEvents()}),this.onDidWriteTerminalData=this.O.event,this.P=new y.$Rd({onWillAddFirstListener:()=>this.a.$startSendingCommandEvents(),onDidRemoveLastListener:()=>this.a.$stopSendingCommandEvents()}),this.onDidExecuteTerminalCommand=this.P.event,this.a=I.getProxy(F.$xK.MainThreadTerminalService),this.y=new p.$nqb(this.a.$sendProcessData),this.a.$registerProcessSupport(h),this.Q.registerArgumentProcessor({processArgument:L=>{const V=K=>{const R=K;return this.W(R.instanceId)?.value};switch(L?.$mid){case 15:return V(L);default:{if(Array.isArray(L))for(let K=0;K<L.length&&L[K].$mid===15;K++)L[K]=V(L[K]);return L}}}}),this.B({dispose:()=>{for(const[L,V]of this.g)V.shutdown(!0)}})}getDefaultShell(h){return(h?this.u:this.s)?.path||""}getDefaultShellArgs(h){return(h?this.u:this.s)?.args||[]}createExtensionTerminal(h,w){const I=new c(this.a,(0,b.$ig)(),h,h.name),L=new o(h.pty);return I.createExtensionTerminal(h.location,this.R(h,w).resolvedExtHostIdentifier,v(h.iconPath),m(h.color)).then(V=>{const K=this.S(V,L);this.h[V]=K}),this.f.push(I),I.value}R(h,w){if(w=w||{},h.location&&typeof h.location=="object"&&"parentTerminal"in h.location){const I=h.location.parentTerminal;if(I){const L=this.f.find(V=>V.value===I);L&&(w.resolvedExtHostIdentifier=L._id)}}else h.location&&typeof h.location!="object"?w.location=h.location:w.location&&typeof w.location=="object"&&"splitActiveTerminal"in w.location&&(w.location={splitActiveTerminal:!0});return w}attachPtyToTerminal(h,w){if(!this.W(h))throw new Error(`Cannot resolve terminal with id ${h} for virtual process`);const L=new o(w),V=this.S(h,L);this.h[h]=V}async $acceptActiveTerminalChanged(h){const w=this.b;if(h===null){this.b=void 0,w!==this.b&&this.J.fire(this.b);return}const I=this.W(h);I&&(this.b=I,w!==this.b&&this.J.fire(this.b.value))}async $acceptTerminalProcessData(h,w){const I=this.W(h);I&&this.O.fire({terminal:I.value,data:w})}async $acceptTerminalDimensions(h,w,I){const L=this.W(h);L&&L.setDimensions(w,I)&&this.L.fire({terminal:L.value,dimensions:L.value.dimensions})}async $acceptDidExecuteCommand(h,w){const I=this.W(h);I&&this.P.fire({terminal:I.value,...w})}async $acceptTerminalMaximumDimensions(h,w,I){this.g.get(h)?.resize(w,I)}async $acceptTerminalTitleChange(h,w){const I=this.W(h);I&&(I.name=w)}async $acceptTerminalClosed(h,w,I){const L=this.Y(this.f,h);if(L!==null){const V=this.f.splice(L,1)[0];V.setExitStatus(w,I),this.H.fire(V.value)}}$acceptTerminalOpened(h,w,I,L){if(w){const R=this.Y(this.f,w);if(R!==null){this.f[R]._id=h,this.I.fire(this.terminals[R]),this.f[R].isOpen=!0;return}}const V={name:L.name,shellPath:L.executable,shellArgs:L.args,cwd:typeof L.cwd=="string"?L.cwd:M.URI.revive(L.cwd),env:L.env,hideFromUser:L.hideFromUser},K=new c(this.a,h,V,I);this.f.push(K),this.I.fire(K.value),K.isOpen=!0}async $acceptTerminalProcessId(h,w){this.W(h)?._setProcessId(w)}async $startExtensionTerminal(h,w){const I=this.W(h);if(!I)return{message:(0,f.localize)(0,null,h)};I.isOpen||await new Promise(V=>{const K=this.onDidOpenTerminal(async R=>{R===I.value&&(K.dispose(),V())})});const L=this.g.get(h);L?L.startSendingEvents(w):this.j[h]={initialDimensions:w}}S(h,w){const I=new $.$Qc;I.add(w.onProcessReady(V=>this.a.$sendProcessReady(h,V.pid,V.cwd,V.windowsPty))),I.add(w.onDidChangeProperty(V=>this.a.$sendProcessProperty(h,V))),this.y.startBuffering(h,w.onProcessData),I.add(w.onProcessExit(V=>this.U(h,V))),this.g.set(h,w);const L=this.j[h];return L&&w instanceof o&&(w.startSendingEvents(L.initialDimensions),delete this.j[h]),I}$acceptProcessAckDataEvent(h,w){this.g.get(h)?.acknowledgeDataEvent(w)}$acceptProcessInput(h,w){this.g.get(h)?.input(w)}$acceptTerminalInteraction(h){const w=this.W(h);w?.setInteractedWith()&&this.M.fire(w.value)}$acceptTerminalSelection(h,w){this.W(h)?.setSelection(w)}$acceptProcessResize(h,w,I){try{this.g.get(h)?.resize(w,I)}catch(L){if(L.code!=="EPIPE"&&L.code!=="ERR_IPC_CHANNEL_CLOSED")throw L}}$acceptProcessShutdown(h,w){this.g.get(h)?.shutdown(w)}$acceptProcessRequestInitialCwd(h){this.g.get(h)?.getInitialCwd().then(w=>this.a.$sendProcessProperty(h,{type:"initialCwd",value:w}))}$acceptProcessRequestCwd(h){this.g.get(h)?.getCwd().then(w=>this.a.$sendProcessProperty(h,{type:"cwd",value:w}))}$acceptProcessRequestLatency(h){return Promise.resolve(h)}registerLinkProvider(h){return this.z.add(h),this.z.size===1&&this.a.$startLinkProvider(),new E.$zK(()=>{this.z.delete(h),this.z.size===0&&this.a.$stopLinkProvider()})}registerProfileProvider(h,w,I){if(this.C.has(w))throw new Error(`Terminal profile provider "${w}" already registered`);return this.C.set(w,I),this.a.$registerProfileProvider(w,h.identifier.value),new E.$zK(()=>{this.C.delete(w),this.a.$unregisterProfileProvider(w)})}registerTerminalQuickFixProvider(h,w,I){if(this.D.has(h))throw new Error(`Terminal quick fix provider "${h}" is already registered`);return this.D.set(h,I),this.a.$registerQuickFixProvider(h,w),new E.$zK(()=>{this.D.delete(h),this.a.$unregisterQuickFixProvider(h)})}async $provideTerminalQuickFixes(h,w){const I=new u.$2d().token;if(I.isCancellationRequested)return;const L=this.D.get(h);if(!L)return;const V=await L.provideTerminalQuickFixes(w,I);if(V===null||Array.isArray(V)&&V.length===0)return;const K=new $.$Qc;if(this.w.value=K,!Array.isArray(V))return V?i.TerminalQuickFix.from(V,this.Q.converter,K):void 0;const R=[];for(const N of V){const T=i.TerminalQuickFix.from(N,this.Q.converter,K);T&&R.push(T)}return R}async $createContributedProfileTerminal(h,w){const I=new u.$2d().token;let L=await this.C.get(h)?.provideTerminalProfile(I);if(!I.isCancellationRequested){if(L&&!("options"in L)&&(L={options:L}),!L||!("options"in L))throw new Error(`No terminal profile options provided for id "${h}"`);if("pty"in L.options){this.createExtensionTerminal(L.options,w);return}this.createTerminalFromOptions(L.options,w)}}async $provideLinks(h,w){const I=this.W(h);if(!I)return[];this.F.delete(h),this.G.get(h)?.dispose(!0);const V=new u.$2d;this.G.set(h,V);const K=[],R={terminal:I.value,line:w},N=[];for(const Z of this.z)N.push(t.Promises.withAsyncBody(async he=>{V.token.onCancellationRequested(()=>he({provider:Z,links:[]}));const ye=await Z.provideTerminalLinks(R,V.token)||[];V.token.isCancellationRequested||he({provider:Z,links:ye})}));const T=await Promise.all(N);if(V.token.isCancellationRequested)return[];const z=new Map;for(const Z of T)Z&&Z.links.length>0&&K.push(...Z.links.map(he=>{const ye={id:l++,startIndex:he.startIndex,length:he.length,label:he.tooltip};return z.set(ye.id,{provider:Z.provider,link:he}),ye}));return this.F.set(h,z),K}$activateLink(h,w){const I=this.F.get(h)?.get(w);I&&I.provider.handleTerminalLink(I.link)}U(h,w){this.y.stopBuffering(h),this.g.delete(h),delete this.j[h];const I=this.h[h];I&&(I.dispose(),delete this.h[h]),this.a.$sendProcessExit(h,w)}W(h){return this.X(this.f,h)}X(h,w){const I=this.Y(h,w);return I!==null?h[I]:null}Y(h,w){const I=h.findIndex(L=>L._id===w);return I===-1?null:I}getEnvironmentVariableCollection(h){let w=this.n.get(h.identifier.value);return w||(w=new s,this.$(h.identifier.value,w)),w.getScopedEnvironmentVariableCollection(void 0)}Z(h,w){const I=(0,D.$qr)(w.map),L=(0,D.$rr)(w.descriptionMap);this.a.$setEnvironmentVariableCollection(h,w.persistent,I.length===0?void 0:I,L)}$initEnvironmentVariableCollections(h){h.forEach(w=>{const I=w[0],L=new s(w[1]);this.$(I,L)})}$acceptDefaultProfile(h,w){const I=this.s;this.s=h,this.u=w,I?.path!==h.path&&this.N.fire(h.path)}$(h,w){this.n.set(h,w),w.onDidChangeCollection(()=>{this.Z(h,w)})}};e.$tec=n,e.$tec=n=Ke([Ve(1,r.$VM),Ve(2,A.$zM)],n);class s{get persistent(){return this.b}set persistent(h){this.b=h,this.d.fire()}get onDidChangeCollection(){return this.d&&this.d.event}constructor(h){this.map=new Map,this.a=new Map,this.descriptionMap=new Map,this.b=!0,this.d=new y.$Rd,this.map=new Map(h)}getScopedEnvironmentVariableCollection(h){const w=this.h(h);let I=this.a.get(w);return I||(I=new a(this,h),this.a.set(w,I),I.onDidChangeCollection(()=>this.d.fire())),I}replace(h,w,I,L){this.f(h,{value:w,type:E.EnvironmentVariableMutatorType.Replace,options:I??{applyAtProcessCreation:!0},scope:L})}append(h,w,I,L){this.f(h,{value:w,type:E.EnvironmentVariableMutatorType.Append,options:I??{applyAtProcessCreation:!0},scope:L})}prepend(h,w,I,L){this.f(h,{value:w,type:E.EnvironmentVariableMutatorType.Prepend,options:I??{applyAtProcessCreation:!0},scope:L})}f(h,w){if(w.options&&w.options.applyAtProcessCreation===!1&&!w.options.applyAtShellIntegration)throw new Error("EnvironmentVariableMutatorOptions must apply at either process creation or shell integration");const I=this.g(h,w.scope),L=this.map.get(I),V=w.options?{applyAtProcessCreation:w.options.applyAtProcessCreation??!1,applyAtShellIntegration:w.options.applyAtShellIntegration??!1}:{applyAtProcessCreation:!0};if(!L||L.value!==w.value||L.type!==w.type||L.options?.applyAtProcessCreation!==V.applyAtProcessCreation||L.options?.applyAtShellIntegration!==V.applyAtShellIntegration||L.scope?.workspaceFolder?.index!==w.scope?.workspaceFolder?.index){const K=this.g(h,w.scope),R={variable:h,...w,options:V};this.map.set(K,R),this.d.fire()}}get(h,w){const I=this.g(h,w),L=this.map.get(I);return L?S(L):void 0}g(h,w){const I=this.h(w);return I.length?`${h}:::${I}`:h}h(h){return this.j(h?.workspaceFolder)??""}j(h){return h?h.uri.toString():void 0}getVariableMap(h){const w=new Map;for(const[I,L]of this.map)this.h(L.scope)===this.h(h)&&w.set(L.variable,S(L));return w}delete(h,w){const I=this.g(h,w);this.map.delete(I),this.d.fire()}clear(h){if(h?.workspaceFolder){for(const[w,I]of this.map)I.scope?.workspaceFolder?.index===h.workspaceFolder.index&&this.map.delete(w);this.k(h)}else this.map.clear(),this.descriptionMap.clear();this.d.fire()}setDescription(h,w){const I=this.h(w),L=this.descriptionMap.get(I);if(!L||L.description!==h){let V;typeof h=="string"?V=h:V=h?.value.split(`

`)[0];const K={description:V,scope:w};this.descriptionMap.set(I,K),this.d.fire()}}getDescription(h){const w=this.h(h);return this.descriptionMap.get(w)?.description}k(h){const w=this.h(h);this.descriptionMap.delete(w)}}class a{get persistent(){return this.b.persistent}set persistent(h){this.b.persistent=h}get onDidChangeCollection(){return this.a&&this.a.event}constructor(h,w){this.b=h,this.d=w,this.a=new y.$Rd}getScoped(h){return this.b.getScopedEnvironmentVariableCollection(h)}replace(h,w,I){this.b.replace(h,w,I,this.d)}append(h,w,I){this.b.append(h,w,I,this.d)}prepend(h,w,I){this.b.prepend(h,w,I,this.d)}get(h){return this.b.get(h,this.d)}forEach(h,w){this.b.getVariableMap(this.d).forEach((I,L)=>h.call(w,L,I,this),this.d)}[Symbol.iterator](){return this.b.getVariableMap(this.d).entries()}delete(h){this.b.delete(h,this.d),this.a.fire(void 0)}clear(){this.b.clear(this.d)}set description(h){this.b.setDescription(h,this.d)}get description(){return this.b.getDescription(this.d)}}let d=class extends n{constructor(h,w){super(!1,h,w)}createTerminal(h,w,I){throw new C.$$}createTerminalFromOptions(h,w){throw new C.$$}};e.$uec=d,e.$uec=d=Ke([Ve(0,r.$VM),Ve(1,A.$zM)],d);function v(k){if(!(!k||typeof k=="string"))return"id"in k?{id:k.id,color:k.color}:k}function m(k){return g.ThemeColor.isThemeColor(k)?k:void 0}function S(k){const h={...k};return delete h.scope,h.options=h.options??void 0,delete h.variable,h}}),define(Pe[267],Re([1,0,298,14,24,20,5,219,97,6,26,16,38,3,17,108,8,7,48,77,58,23]),function(be,e,y,F,P,M,A,$,E,f,C,D,u,b,p,g,t,i,r,c,o,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Afc=e.$zfc=e.$yfc=e.$xfc=void 0;let n=class extends f.$Rc{constructor(R,N,T){super(),this.u=T,this.f=this.B(new A.$Rd),this.g=new Map,this.s=this.B(new A.$Rd),this.onResultsChanged=this.f.event,this.results=[],this.h=R.getProxy(b.$xK.MainThreadTesting),this.m=new I(this.h),this.j=new v(this.h),N.registerArgumentProcessor({processArgument:z=>{switch(z?.$mid){case 16:{const Z=z,he=Z.tests[Z.tests.length-1].item.extId;return this.g.get(r.$qJ.root(he))?.collection.tree.get(he)?.actual??(0,g.$LM)(z)}case 18:{const{extId:Z,message:he}=z;return{test:this.g.get(r.$qJ.root(Z))?.collection.tree.get(Z)?.actual,message:t.TestMessage.to(he)}}default:return z}}}),N.registerCommand(!1,"testing.getExplorerSelection",async()=>{const z=await N.executeCommand("_testing.getExplorerSelection"),Z=he=>{const ye=this.g.get(r.$qJ.root(he));if(ye)return r.$qJ.isRoot(he)?ye.controller:ye.collection.tree.get(he)?.actual};return{include:z?.include.map(Z).filter(D.$Kf)||[],exclude:z?.exclude.map(Z).filter(D.$Kf)||[]}})}createTestController(R,N,T,z){if(this.g.has(N))throw new Error(`Attempt to insert a duplicate controller with ID "${N}"`);const Z=new f.$Qc,he=Z.add(new g.$OM(N,T,this.u));he.root.label=T;const ye=new Map,De=new Set,Se=this.h,fe={items:he.root.children,get label(){return T},set label(re){T=re,he.root.label=re,Se.$updateController(N,{label:T})},get refreshHandler(){return z},set refreshHandler(re){z=re,Se.$updateController(N,{canRefresh:!!re})},get id(){return N},createRunProfile:(re,Ae,se,X,B,ie)=>{let pe=(0,E.$Ji)(re);for(;ye.has(pe);)pe++;return new L(this.h,ye,R,De,this.s.event,N,pe,re,Ae,se,X,B,ie)},createTestItem(re,Ae,se){return new g.$MM(N,re,Ae,se)},createTestRun:(re,Ae,se=!0)=>this.j.createTestRun(R,N,he,re,Ae,se),invalidateTestResults:re=>{if(re===void 0)this.h.$markTestRetired(void 0);else{const Ae=re instanceof Array?re:[re];this.h.$markTestRetired(Ae.map(se=>r.$qJ.fromExtHostTestItem(se,N).toString()))}},set resolveHandler(re){he.resolveHandler=re},get resolveHandler(){return he.resolveHandler},dispose:()=>{Z.dispose()}};Se.$registerTestController(N,T,!!z),Z.add((0,f.$Pc)(()=>Se.$unregisterTestController(N)));const $e={controller:fe,collection:he,profiles:ye,extension:R,activeProfiles:De};return this.g.set(N,$e),Z.add((0,f.$Pc)(()=>this.g.delete(N))),Z.add(he.onDidGenerateDiff(re=>Se.$publishDiff(N,re.map(o.TestsDiffOp.serialize)))),fe}createTestObserver(){return this.m.checkout()}async runTests(R,N=M.CancellationToken.None){const T=m(R);if(!T)throw new Error("The request passed to `vscode.test.runTests` must include a profile");const z=this.g.get(T.controllerId);if(!z)throw new Error("Controller not found");await this.h.$runTests({isUiTriggered:!1,targets:[{testIds:R.include?.map(Z=>r.$qJ.fromExtHostTestItem(Z,z.collection.root.id).toString())??[z.collection.root.id],profileGroup:V[T.kind],profileId:T.profileId,controllerId:T.controllerId}],exclude:R.exclude?.map(Z=>Z.id)},N)}$syncTests(){for(const{collection:R}of this.g.values())R.flushDiff();return Promise.resolve()}$provideFileCoverage(R,N,T){return(0,y.$qb)(this.j.trackers,Z=>Z.id===R?Z.getCoverage(N):void 0)?.provideFileCoverage(T)??Promise.resolve([])}$resolveFileCoverage(R,N,T,z){return(0,y.$qb)(this.j.trackers,he=>he.id===R?he.getCoverage(N):void 0)?.resolveFileCoverage(T,z)??Promise.resolve([])}$configureRunProfile(R,N){this.g.get(R)?.profiles.get(N)?.configureHandler?.()}$setActiveRunProfiles(R){const N=new Map;for(const[T,z]of Object.entries(R)){const Z=this.g.get(T);if(!Z)continue;const he=new Map,ye=z.filter(Se=>!Z.activeProfiles.has(Se)),De=[...Z.activeProfiles].filter(Se=>!z.includes(Se));for(const Se of ye)he.set(Se,!0),Z.activeProfiles.add(Se);for(const Se of De)he.set(Se,!1),Z.activeProfiles.delete(Se);he.size&&N.set(T,he)}this.s.fire(N)}async $refreshTests(R,N){await this.g.get(R)?.controller.refreshHandler?.(N)}$publishTestResults(R){this.results=Object.freeze(R.map(N=>(0,C.$bn)(t.TestResults.to(N))).concat(this.results).sort((N,T)=>T.completedAt-N.completedAt).slice(0,32)),this.f.fire()}async $expandTest(R,N){const T=this.g.get(r.$qJ.fromString(R).controllerId)?.collection;T&&(await T.expand(R,N<0?1/0:N),T.flushDiff())}$acceptDiff(R){this.m.applyDiff(R.map(o.TestsDiffOp.deserialize))}async $runControllerTests(R,N){return Promise.all(R.map(T=>this.w(T,!1,N)))}async $startContinuousRun(R,N){const T=new M.$2d(N),z=await Promise.all(R.map(Z=>this.w(Z,!0,T.token)));return!N.isCancellationRequested&&!z.some(Z=>Z.error)&&await new Promise(Z=>N.onCancellationRequested(Z)),T.dispose(!0),z}async w(R,N,T){const z=this.g.get(R.controllerId);if(!z)return{};const{collection:Z,profiles:he,extension:ye}=z,De=he.get(R.profileId);if(!De)return{};const Se=R.testIds.map(Ae=>Z.tree.get(Ae)).filter(D.$Kf),fe=R.excludeExtIds.map(Ae=>z.collection.tree.get(Ae)).filter(D.$Kf).filter(Ae=>Se.some(se=>se.fullId.compare(Ae.fullId)===2));if(!Se.length)return{};const $e=new i.$8L(Se.some(Ae=>Ae.actual instanceof g.$NM)?void 0:Se.map(Ae=>Ae.actual),fe.map(Ae=>Ae.actual),De,N),re=(0,o.$sJ)(R)&&this.j.prepareForMainThreadTestRun($e,S.fromInternal(R,z.collection),ye,T);try{return await De.runHandler($e,T),{}}catch(Ae){return{error:String(Ae)}}finally{re&&(re.hasRunningTasks&&!T.isCancellationRequested&&await A.Event.toPromise(re.onEnd),re.dispose())}}$cancelExtensionTestRun(R){R===void 0?this.j.cancelAllRuns():this.j.cancelRunById(R)}};e.$xfc=n,e.$xfc=n=Ke([Ve(0,p.$zM)],n);const s=1e4;var a;(function(K){K[K.Running=0]="Running",K[K.Cancelling=1]="Cancelling",K[K.Ended=2]="Ended"})(a||(a={}));class d extends f.$Rc{get hasRunningTasks(){return this.f.size>0}get id(){return this.m.id}constructor(R,N,T){super(),this.m=R,this.s=N,this.c=0,this.f=new Map,this.g=new Set,this.j=this.B(new A.$Rd),this.onEnd=this.j.event,this.h=this.B(new M.$2d(T));const z=this.B(new F.$0g(()=>this.u(),s));this.B(this.h.token.onCancellationRequested(()=>z.schedule()))}cancel(){this.c===0?(this.h.cancel(),this.c=1):this.c===1&&this.u()}getCoverage(R){return this.f.get(R)?.coverage}createRun(R){const N=this.m.id,T=this.m.controllerId,z=(0,u.$ig)(),Z=new k(this.s,N,z),he=fe=>($e,...re)=>{if(De){console.warn(`Setting the state of test "${$e.id}" is a no-op after the run ends.`);return}this.m.isIncluded($e)&&(this.y($e),fe($e,...re))},ye=(fe,$e)=>{const re=$e instanceof Array?$e.map(t.TestMessage.from):[t.TestMessage.from($e)];if(fe.uri&&fe.range){const Ae={range:t.Range.from(fe.range),uri:fe.uri};for(const se of re)se.location=se.location||Ae}this.s.$appendTestMessagesInRun(N,z,r.$qJ.fromExtHostTestItem(fe,T).toString(),re)};let De=!1;const Se={isPersisted:this.m.isPersisted,token:this.h.token,name:R,get coverageProvider(){return Z.coverageProvider},set coverageProvider(fe){Z.coverageProvider=fe},enqueued:he(fe=>{this.s.$updateTestStateInRun(N,z,r.$qJ.fromExtHostTestItem(fe,T).toString(),1)}),skipped:he(fe=>{this.s.$updateTestStateInRun(N,z,r.$qJ.fromExtHostTestItem(fe,T).toString(),5)}),started:he(fe=>{this.s.$updateTestStateInRun(N,z,r.$qJ.fromExtHostTestItem(fe,T).toString(),2)}),errored:he((fe,$e,re)=>{ye(fe,$e),this.s.$updateTestStateInRun(N,z,r.$qJ.fromExtHostTestItem(fe,T).toString(),6,re)}),failed:he((fe,$e,re)=>{ye(fe,$e),this.s.$updateTestStateInRun(N,z,r.$qJ.fromExtHostTestItem(fe,T).toString(),4,re)}),passed:he((fe,$e)=>{this.s.$updateTestStateInRun(N,z,r.$qJ.fromExtHostTestItem(fe,this.m.controllerId).toString(),3,$e)}),appendOutput:(fe,$e,re)=>{De||(re&&(this.m.isIncluded(re)?this.y(re):re=void 0),this.s.$appendOutputToRun(N,z,P.$fe.fromString(fe),$e&&t.location.from($e),re&&r.$qJ.fromExtHostTestItem(re,T).toString()))},end:()=>{De||(De=!0,this.s.$finishedTestRunTask(N,z),this.f.delete(z),this.f.size||this.w())}};return this.f.set(z,{run:Se,coverage:Z}),this.s.$startedTestRunTask(N,{id:z,name:R,running:!0}),Se}u(){for(const{run:R}of this.f.values())R.end()}w(){this.c!==2&&(this.c=2,this.j.fire())}y(R){if(!(R instanceof g.$MM))throw new c.$rM(R.id);if(this.g.has(r.$qJ.fromExtHostTestItem(R,this.m.controllerId).toString()))return;const N=[],T=this.m.colllection.root;for(;;){const z=t.TestItem.from(R);if(N.unshift(z),this.g.has(z.extId)||(this.g.add(z.extId),R===T))break;R=R.parent||T}this.s.$addTestsToRun(this.m.controllerId,this.m.id,N)}dispose(){this.w(),super.dispose()}}class v{get trackers(){return this.c.values()}constructor(R){this.d=R,this.c=new Map}prepareForMainThreadTestRun(R,N,T,z){return this.f(R,N,T,z)}cancelRunById(R){for(const N of this.c.values())if(N.id===R){N.cancel();return}}cancelAllRuns(){for(const R of this.c.values())R.cancel()}createTestRun(R,N,T,z,Z,he){const ye=this.c.get(z);if(ye)return ye.createRun(Z);const De=S.fromPublic(N,T,z,he),Se=m(z);this.d.$startedExtensionTestRun({controllerId:N,continuous:!!z.continuous,profile:Se&&{group:V[Se.kind],id:Se.profileId},exclude:z.exclude?.map($e=>r.$qJ.fromExtHostTestItem($e,T.root.id).toString())??[],id:De.id,include:z.include?.map($e=>r.$qJ.fromExtHostTestItem($e,T.root.id).toString())??[T.root.id],persist:he});const fe=this.f(z,De,R);return A.Event.once(fe.onEnd)(()=>{this.d.$finishedExtensionTestRun(De.id),fe.dispose()}),fe.createRun(Z)}f(R,N,T,z){const Z=new d(N,this.d,z);return this.c.set(R,Z),A.Event.once(Z.onEnd)(()=>this.c.delete(R)),Z}}e.$yfc=v;const m=K=>{if(K.profile){if(!(K.profile instanceof L))throw new Error("TestRunRequest.profile is not an instance created from TestController.createRunProfile");return K.profile}};class S{static fromPublic(R,N,T,z){return new S(R,(0,u.$ig)(),T.include?.map(Z=>r.$qJ.fromExtHostTestItem(Z,R).toString())??[R],T.exclude?.map(Z=>r.$qJ.fromExtHostTestItem(Z,R).toString())??[],z,N)}static fromInternal(R,N){return new S(R.controllerId,R.runId,R.testIds,R.excludeExtIds,!0,N)}constructor(R,N,T,z,Z,he){this.controllerId=R,this.id=N,this.isPersisted=Z,this.colllection=he,this.c=T.map(ye=>ye+"\0"),this.d=z.map(ye=>ye+"\0")}isIncluded(R){const N=r.$qJ.fromExtHostTestItem(R,this.controllerId).toString()+"\0";for(const T of this.d)if(N===T||N.startsWith(T))return!1;for(const T of this.c)if(N===T||N.startsWith(T))return!0;return!1}}e.$zfc=S;class k{set coverageProvider(R){if(this.c)throw new Error("The TestCoverageProvider cannot be replaced after being provided");R&&(this.c=R,this.f.$signalCoverageAvailable(this.g,this.h))}get coverageProvider(){return this.c}constructor(R,N,T){this.f=R,this.g=N,this.h=T}async provideFileCoverage(R){if(!this.c)return[];this.d||(this.d=(async()=>this.c.provideFileCoverage(R))());try{return(await this.d)?.map(t.TestCoverage.fromFile)??[]}catch(N){throw this.d=void 0,N}}async resolveFileCoverage(R,N){const T=await this.d;let z=T?.[R];return!this.c||!T||!z?[]:(z.detailedCoverage||(z=T[R]=await this.c.resolveFileCoverage?.(z,N)??z),z.detailedCoverage?.map(t.TestCoverage.fromDetailed)??[])}}class h{get isEmpty(){return this.c.size===0&&this.f.size===0&&this.d.size===0}constructor(R){this.h=R,this.c=new Set,this.d=new Set,this.f=new Set,this.g=new Set}add(R){this.c.add(R)}update(R){Object.assign(R.revived,t.TestItem.toPlain(R.item)),this.c.has(R)||this.d.add(R)}remove(R){if(this.c.has(R)){this.c.delete(R);return}this.d.delete(R);const N=r.$qJ.parentId(R.item.extId);if(N&&this.g.has(N.toString())){this.g.add(R.item.extId);return}this.f.add(R)}getChangeEvent(){const{c:R,d:N,f:T}=this;return{get added(){return[...R].map(z=>z.revived)},get updated(){return[...N].map(z=>z.revived)},get removed(){return[...T].map(z=>z.revived)}}}complete(){this.isEmpty||this.h.fire(this.getChangeEvent())}}class w extends o.$xJ{constructor(){super(...arguments),this.q=new A.$Rd,this.onDidChangeTests=this.q.event}get rootTests(){return this.f}getMirroredTestDataById(R){return this.d.get(R)}getMirroredTestDataByReference(R){return this.d.get(R.id)}p(R,N){return{...R,revived:t.TestItem.toPlain(R.item),depth:N?N.depth+1:0,children:new Set}}o(){return new h(this.q)}}class I{constructor(R){this.d=R}checkout(){this.c||(this.c=this.f());const R=this.c;return R.observers++,{onDidChangeTest:R.tests.onDidChangeTests,get tests(){return[...R.tests.rootTests].map(N=>N.revived)},dispose:(0,$.$cb)(()=>{--R.observers===0&&(this.d.$unsubscribeFromDiffs(),this.c=void 0)})}}getMirroredTestDataByReference(R){return this.c?.tests.getMirroredTestDataByReference(R)}applyDiff(R){this.c?.tests.apply(R)}f(){const R=new w;return this.d.$subscribeToDiffs(),{observers:0,tests:R}}}class L{#e;#t;#i;#o;#r;get label(){return this.d}set label(R){R!==this.d&&(this.d=R,this.#e.$updateTestRunConfig(this.controllerId,this.profileId,{label:R}))}get supportsContinuousRun(){return this.g}set supportsContinuousRun(R){R!==this.g&&(this.g=R,this.#e.$updateTestRunConfig(this.controllerId,this.profileId,{supportsContinuousRun:R}))}get isDefault(){return this.f}set isDefault(R){R!==this.f&&(this.f=R,this.#e.$updateTestRunConfig(this.controllerId,this.profileId,{isDefault:R}))}get tag(){return this._tag}set tag(R){R?.id!==this._tag?.id&&(this._tag=R,this.#e.$updateTestRunConfig(this.controllerId,this.profileId,{tag:R?t.TestTag.namespace(this.controllerId,R.id):null}))}get configureHandler(){return this.c}set configureHandler(R){R!==this.c&&(this.c=R,this.#e.$updateTestRunConfig(this.controllerId,this.profileId,{hasConfigurationHandler:!!R}))}get isSelected(){return(0,l.$MF)(this.#t,"testingActiveProfile"),this.#i.has(this.profileId)}get onDidChangeSelected(){return(0,l.$MF)(this.#t,"testingActiveProfile"),A.Event.chain(this.#o,R=>R.map(N=>N.get(this.controllerId)?.get(this.profileId)).filter(D.$Kf))}constructor(R,N,T,z,Z,he,ye,De,Se,fe,$e=!1,re=void 0,Ae=!1){this.controllerId=he,this.profileId=ye,this.d=De,this.kind=Se,this.runHandler=fe,this.f=$e,this._tag=re,this.g=Ae,this.#e=R,this.#r=N,this.#t=T,this.#i=z,this.#o=Z,N.set(ye,this);const se=V[Se];if(typeof se!="number")throw new Error(`Unknown TestRunProfile.group ${Se}`);this.#e.$publishTestRunProfile({profileId:ye,controllerId:he,tag:re?t.TestTag.namespace(this.controllerId,re.id):null,label:De,group:se,isDefault:$e,hasConfigurationHandler:!1,supportsContinuousRun:Ae})}dispose(){this.#r?.delete(this.profileId)&&(this.#r=void 0,this.#e.$removeTestProfile(this.controllerId,this.profileId))}}e.$Afc=L;const V={[i.TestRunProfileKind.Coverage]:8,[i.TestRunProfileKind.Debug]:4,[i.TestRunProfileKind.Run]:2}}),define(Pe[268],Re([1,0,18,11,5,3,109,8,7]),function(be,e,y,F,P,M,A,$,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wdc=void 0;class f{constructor(D,u){this.i=u,this.a=new P.$Rd({onListenerError:F.$1}),this.b=new P.$Rd({onListenerError:F.$1}),this.c=new P.$Rd({onListenerError:F.$1}),this.d=new P.$Rd({onListenerError:F.$1}),this.f=new P.$Rd({onListenerError:F.$1}),this.g=new P.$Rd({onListenerError:F.$1}),this.onDidChangeTextEditorSelection=this.a.event,this.onDidChangeTextEditorOptions=this.b.event,this.onDidChangeTextEditorVisibleRanges=this.c.event,this.onDidChangeTextEditorViewColumn=this.d.event,this.onDidChangeActiveTextEditor=this.f.event,this.onDidChangeVisibleTextEditors=this.g.event,this.h=D.getProxy(M.$xK.MainThreadTextEditors),this.i.onDidChangeVisibleTextEditors(b=>this.g.fire(b)),this.i.onDidChangeActiveTextEditor(b=>this.f.fire(b))}getActiveTextEditor(){return this.i.activeEditor()}getVisibleTextEditors(D){const u=this.i.allEditors();return D?u:u.map(b=>b.value)}async showTextDocument(D,u,b){let p;typeof u=="number"?p={position:$.ViewColumn.from(u),preserveFocus:b}:typeof u=="object"?p={position:$.ViewColumn.from(u.viewColumn),preserveFocus:u.preserveFocus,selection:typeof u.selection=="object"?$.Range.from(u.selection):void 0,pinned:typeof u.preview=="boolean"?!u.preview:void 0}:p={preserveFocus:!1};const g=await this.h.$tryShowTextDocument(D.uri,p),t=g&&this.i.getEditor(g);if(t)return t.value;throw g?new Error(`Could NOT open editor for "${D.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${D.uri.toString()}".`)}createTextEditorDecorationType(D,u){return new A.$GM(this.h,D,u).value}$acceptEditorPropertiesChanged(D,u){const b=this.i.getEditor(D);if(!b)throw new Error("unknown text editor");if(u.options&&b._acceptOptions(u.options),u.selections){const p=u.selections.selections.map($.Selection.to);b._acceptSelections(p)}if(u.visibleRanges){const p=y.$Gb(u.visibleRanges.map($.Range.to));b._acceptVisibleRanges(p)}if(u.options&&this.b.fire({textEditor:b.value,options:{...u.options,lineNumbers:$.TextEditorLineNumbersStyle.to(u.options.lineNumbers)}}),u.selections){const p=E.TextEditorSelectionChangeKind.fromValue(u.selections.source),g=u.selections.selections.map($.Selection.to);this.a.fire({textEditor:b.value,selections:g,kind:p})}if(u.visibleRanges){const p=y.$Gb(u.visibleRanges.map($.Range.to));this.c.fire({textEditor:b.value,visibleRanges:p})}}$acceptEditorPositionData(D){for(const u in D){const b=this.i.getEditor(u);if(!b)throw new Error("Unknown text editor");const p=$.ViewColumn.to(D[u]);b.value.viewColumn!==p&&(b._acceptViewColumn(p),this.d.fire({textEditor:b.value,viewColumn:p}))}}getDiffInformation(D){return Promise.resolve(this.h.$getDiffInformation(D))}}e.$Wdc=f}),define(Pe[269],Re([1,0,2,4,3,6,7,8,22,16]),function(be,e,y,F,P,M,A,$,E,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dfc=e.$Cfc=void 0,e.$Cfc=(0,F.$Vh)("IExtHostTimeline");class C{constructor(b,p){this.b=new Map,this.c=new Map,this.a=b.getProxy(P.$xK.MainThreadTimeline),p.registerArgumentProcessor({processArgument:(g,t)=>{if(g&&g.$mid===12)if(this.b.get(g.source)&&E.$_l.equals(t,this.b.get(g.source)?.extension)){const i=g.uri===void 0?void 0:y.URI.revive(g.uri);return this.c.get(g.source)?.get(D(i))?.get(g.handle)}else return;return g}})}async $getTimeline(b,p,g,t){return this.b.get(b)?.provider.provideTimeline(y.URI.revive(p),g,t)}registerTimelineProvider(b,p,g,t){const i=new M.$Qc,r=this.d(p.id,t,i).bind(this);let c;p.onDidChange&&(c=p.onDidChange(l=>this.a.$emitTimelineChangeEvent({uri:void 0,reset:!0,...l,id:p.id}),this));const o=this.c;return this.f({...p,scheme:b,onDidChange:void 0,async provideTimeline(l,n,s){n?.resetCache&&(i.clear(),o.get(p.id)?.clear());const a=await p.provideTimeline(l,n,s);if(a==null)return;const d=r(l,n);return{...a,source:p.id,items:a.items.map(d)}},dispose(){for(const l of o.values())l.get(p.id)?.clear();c?.dispose(),i.dispose()}},g)}d(b,p,g){return(t,i)=>{let r;if(i?.cacheResults){let c=this.c.get(b);c===void 0&&(c=new Map,this.c.set(b,c));const o=D(t);r=c.get(o),r===void 0&&(r=new Map,c.set(o,r))}return c=>{const{iconPath:o,...l}=c,n=`${b}|${c.id??c.timestamp}`;r?.set(n,c);let s,a,d;c.iconPath&&(o instanceof A.$tL?d={id:o.id,color:o.color}:y.URI.isUri(o)?(s=o,a=o):{light:s,dark:a}=o);let v;return A.$ZK.isMarkdownString(l.tooltip)?v=$.MarkdownString.from(l.tooltip):(0,f.$Cf)(l.tooltip)?v=l.tooltip:A.$ZK.isMarkdownString(l.detail)?(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),v=$.MarkdownString.from(l.detail)):(0,f.$Cf)(l.detail)&&(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),v=l.detail),{...l,id:l.id??void 0,handle:n,source:b,command:c.command?p.toInternal(c.command,g):void 0,icon:s,iconDark:a,themeIcon:d,tooltip:v,accessibilityInformation:c.accessibilityInformation}}}}f(b,p){if(this.b.get(b.id))throw new Error(`Timeline Provider ${b.id} already exists.`);return this.a.$registerTimelineProvider({id:b.id,label:b.label,scheme:b.scheme}),this.b.set(b.id,{provider:b,extension:p}),(0,M.$Pc)(()=>{for(const t of this.c.values())t.get(b.id)?.clear();this.b.delete(b.id),this.a.$unregisterTimelineProvider(b.id),b.dispose()})}}e.$Dfc=C;function D(u){return u?.toString()}}),define(Pe[87],Re([1,0,20,5,6,168,4,15,197,3,27,17,7]),function(be,e,y,F,P,M,A,$,E,f,C,D,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Swb=e.$Rwb=e.TunnelDtoConverter=void 0;class b extends E.$mv{}var p;(function(t){function i(c){return{remoteAddress:c.remoteAddress,localAddress:c.localAddress,public:!!c.public,privacy:c.privacy??(c.public?E.TunnelPrivacyId.Public:E.TunnelPrivacyId.Private),protocol:c.protocol}}t.fromApiTunnel=i;function r(c){return{remoteAddress:{host:c.tunnelRemoteHost,port:c.tunnelRemotePort},localAddress:c.localAddress,public:c.privacy!==E.TunnelPrivacyId.ConstantPrivate&&c.privacy!==E.TunnelPrivacyId.ConstantPrivate,privacy:c.privacy,protocol:c.protocol}}t.fromServiceTunnel=r})(p||(e.TunnelDtoConverter=p={})),e.$Rwb=(0,A.$Vh)("IExtHostTunnelService");let g=class extends P.$Rc{constructor(i,r,c){super(),this.s=c,this.f=()=>Promise.resolve(!0),this.g=new Map,this.h=new F.$Rd,this.onDidChangeTunnels=this.h.event,this.n=0,this.r=new Map,this.a=i.getProxy(f.$xK.MainThreadTunnelService)}async openTunnel(i,r){this.s.trace(`ForwardedPorts: (ExtHostTunnelService) ${i.identifier.value} called openTunnel API for ${r.remoteAddress.host}:${r.remoteAddress.port}.`);const c=await this.a.$openTunnel(r,i.displayName);if(c){const o=new b(c.remoteAddress,c.localAddress,()=>this.a.$closeTunnel(c.remoteAddress));return this.B(o),o}}async getTunnels(){return this.a.$getTunnels()}u(){return this.n++}registerPortsAttributesProvider(i,r){const c=this.u();return this.r.set(c,{selector:i,provider:r}),this.a.$registerPortsAttributesProvider(i,c),new u.$zK(()=>{this.r.delete(c),this.a.$unregisterPortsAttributesProvider(c)})}async $providePortAttributes(i,r,c,o,l){const n=[];for(const a of i){const d=this.r.get(a);if(!d)return[];n.push(...await Promise.all(r.map(async v=>{let m;try{m=await d.provider.providePortAttributes({port:v,pid:c,commandLine:o},l)}catch{m=await d.provider.providePortAttributes(v,c,o,l)}return{providedAttributes:m,port:v}})))}const s=n.filter(a=>!!a.providedAttributes);return s.length>0?s.map(a=>({autoForwardAction:a.providedAttributes.autoForwardAction,port:a.port})):[]}async $registerCandidateFinder(i){}registerTunnelProvider(i,r){if(this.b)throw new Error("A tunnel provider has already been registered. Only the first tunnel provider to be registered will be used.");this.b=async(o,l)=>await i.provideTunnel(o,l,new y.$2d().token)??void 0;const c=r.tunnelFeatures?{elevation:!!r.tunnelFeatures?.elevation,privacyOptions:r.tunnelFeatures?.privacyOptions}:void 0;return this.a.$setTunnelProvider(c),Promise.resolve((0,P.$Pc)(()=>{this.b=void 0,this.a.$setTunnelProvider(void 0)}))}async setTunnelFactory(i,r){if(i){i.candidatePortSource!==void 0&&this.a.$setCandidatePortSource(i.candidatePortSource),i.showCandidatePort&&(this.f=i.showCandidatePort,this.a.$setCandidateFilter());const c=i.tunnelFactory??(r?this.w(r):void 0);if(c){this.b=c;let o=i.tunnelFeatures?.privacyOptions??[];i.tunnelFeatures?.public&&o.length===0&&(o=[{id:"private",label:M.localize(0,null),themeIcon:"lock"},{id:"public",label:M.localize(1,null),themeIcon:"eye"}]);const l=i.tunnelFeatures?{elevation:!!i.tunnelFeatures?.elevation,public:!!i.tunnelFeatures?.public,privacyOptions:o}:void 0;this.a.$setTunnelProvider(l)}}else this.b=void 0;return(0,P.$Pc)(()=>{this.b=void 0})}w(i){}async $closeTunnel(i,r){if(this.g.has(i.host)){const c=this.g.get(i.host);c.has(i.port)&&(r&&c.get(i.port).disposeListener.dispose(),await c.get(i.port).tunnel.dispose(),c.delete(i.port))}}async $onDidTunnelsChange(){this.h.fire()}async $forwardPort(i,r){if(this.b)try{this.s.trace("ForwardedPorts: (ExtHostTunnelService) Getting tunnel from provider.");const c=this.b(i,r);if(this.s.trace("ForwardedPorts: (ExtHostTunnelService) Got tunnel promise from provider."),c!==void 0){const o=await c;if(this.s.trace("ForwardedPorts: (ExtHostTunnelService) Successfully awaited tunnel from provider."),o===void 0){this.s.error("ForwardedPorts: (ExtHostTunnelService) Resolved tunnel is undefined");return}this.g.has(i.remoteAddress.host)||this.g.set(i.remoteAddress.host,new Map);const l=this.B(o.onDidDispose(()=>(this.s.trace("ForwardedPorts: (ExtHostTunnelService) Extension fired tunnel's onDidDispose."),this.a.$closeTunnel(o.remoteAddress))));return this.g.get(i.remoteAddress.host).set(i.remoteAddress.port,{tunnel:o,disposeListener:l}),p.fromApiTunnel(o)}else this.s.trace("ForwardedPorts: (ExtHostTunnelService) Tunnel is undefined")}catch(c){if(this.s.trace("ForwardedPorts: (ExtHostTunnelService) tunnel provider error"),c instanceof Error)return c.message}}async $applyCandidateFilter(i){const r=await Promise.all(i.map(o=>this.f(o.host,o.port,o.detail??""))),c=i.filter((o,l)=>r[l]);return this.s.trace(`ForwardedPorts: (ExtHostTunnelService) filtered from ${i.map(o=>o.port).join(", ")} to ${c.map(o=>o.port).join(", ")}`),c}};e.$Swb=g,e.$Swb=g=Ke([Ve(0,D.$zM),Ve(1,C.$PM),Ve(2,$.$dj)],g)}),define(Pe[270],Re([1,0,6,13,2,3]),function(be,e,y,F,P,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ffc=void 0;class A{static{this.a=new Set([F.Schemas.http,F.Schemas.https])}constructor(E){this.c=new Map,this.b=E.getProxy(M.$xK.MainThreadUriOpeners)}registerExternalUriOpener(E,f,C,D){if(this.c.has(f))throw new Error(`Opener with id '${f}' already registered`);const u=D.schemes.find(b=>!A.a.has(b));if(u)throw new Error(`Scheme '${u}' is not supported. Only http and https are currently supported.`);return this.c.set(f,C),this.b.$registerUriOpener(f,D.schemes,E,D.label),(0,y.$Pc)(()=>{this.c.delete(f),this.b.$unregisterUriOpener(f)})}async $canOpenUri(E,f,C){const D=this.c.get(E);if(!D)throw new Error(`Unknown opener with id: ${E}`);const u=P.URI.revive(f);return D.canOpenExternalUri(u,C)}async $openUri(E,f,C){const D=this.c.get(E);if(!D)throw new Error(`Unknown opener id: '${E}'`);return D.openExternalUri(P.URI.revive(f.resolvedUri),{sourceUri:P.URI.revive(f.sourceUri)},C)}}e.$Ffc=A}),define(Pe[271],Re([1,0,3,2,6,11,22]),function(be,e,y,F,P,M,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gfc=void 0;class ${static{this.a=0}constructor(f){this.c=new A.$am,this.d=new Map,this.b=f.getProxy(y.$xK.MainThreadUrls)}registerUriHandler(f,C){const D=f.identifier;if(this.c.has(D))throw new Error(`Protocol handler already registered for extension ${D}`);const u=$.a++;return this.c.add(D),this.d.set(u,C),this.b.$registerUriHandler(u,D,f.displayName||f.name),(0,P.$Pc)(()=>{this.c.delete(D),this.d.delete(u),this.b.$unregisterUriHandler(u)})}$handleExternalUri(f,C){const D=this.d.get(f);if(!D)return Promise.resolve(void 0);try{D.handleUri(F.URI.revive(C))}catch(u){(0,M.$Z)(u)}return Promise.resolve(void 0)}async createAppUri(f){return F.URI.revive(await this.b.$createAppUri(f))}}e.$Gfc=$}),define(Pe[65],Re([1,0,5,6,13,26,2,182,204,78,3]),function(be,e,y,F,P,M,A,$,E,f,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cec=e.$bec=e.$aec=e.$_dc=e.$$dc=void 0;class D{#e;#t;#i;#o;#r;#n;#a;#s;#c;#u;#l;#d;constructor(o,l,n,s,a,d,v){this.#a="",this.#c=!1,this.#u=!1,this._onMessageEmitter=new y.$Rd,this.onDidReceiveMessage=this._onMessageEmitter.event,this.#h=new y.$Rd,this._onDidDispose=this.#h.event,this.#e=o,this.#t=l,this.#s=n,this.#o=s,this.#r=a,this.#n=d,this.#l=u(d),this.#d=b(d),this.#i=v}#h;dispose(){this.#c=!0,this.#h.fire(),this.#h.dispose(),this._onMessageEmitter.dispose()}asWebviewUri(o){return this.#u=!0,(0,f.$$tb)(o,this.#o)}get cspSource(){const o=this.#n.extensionLocation;if(o.scheme===P.Schemas.https||o.scheme===P.Schemas.http){let l=o.toString();return l.endsWith("/")||(l+="/"),l+" "+f.$0tb}return f.$0tb}get html(){return this.a(),this.#a}set html(o){this.a(),this.#a!==o&&(this.#a=o,this.#d&&!this.#u&&/(["'])vscode-resource:([^\s'"]+?)(["'])/i.test(o)&&(this.#u=!0,this.#i.report("Webview vscode-resource: uris",this.#n,"Please migrate to use the 'webview.asWebviewUri' api instead: https://aka.ms/vscode-webview-use-aswebviewuri")),this.#t.$setHtml(this.#e,this.b(o)))}get options(){return this.a(),this.#s}set options(o){this.a(),M.$en(this.#s,o)||this.#t.$setOptions(this.#e,t(this.#n,this.#r,o)),this.#s=o}async postMessage(o){if(this.#c)return!1;const l=(0,E.$_cb)(o,{serializeBuffersForPostMessage:this.#l});return this.#t.$postMessage(this.#e,l.message,...l.buffers)}a(){if(this.#c)throw new Error("Webview is disposed")}b(o){if(!this.#d)return o;const l=this.#n.extensionLocation?.scheme===P.Schemas.vscodeRemote,n=this.#n.extensionLocation.scheme===P.Schemas.vscodeRemote?this.#n.extensionLocation.authority:void 0;return o.replace(/(["'])(?:vscode-resource):(\/\/([^\s\/'"]+?)(?=\/))?([^\s'"]+?)(["'])/gi,(s,a,d,v,m,S)=>{const k=A.URI.from({scheme:v||"file",path:decodeURIComponent(m)}),h=(0,f.$$tb)(k,{isRemote:l,authority:n}).toString();return`${a}${h}${S}`}).replace(/(["'])(?:vscode-webview-resource):(\/\/[^\s\/'"]+\/([^\s\/'"]+?)(?=\/))?([^\s'"]+?)(["'])/gi,(s,a,d,v,m,S)=>{const k=A.URI.from({scheme:v||"file",path:decodeURIComponent(m)}),h=(0,f.$$tb)(k,{isRemote:l,authority:n}).toString();return`${a}${h}${S}`})}}e.$$dc=D;function u(c){try{const o=(0,$.$To)((0,$.$So)(c.engines.vscode));return!!o&&o.majorBase>=1&&o.minorBase>=57}catch{return!1}}e.$_dc=u;function b(c){try{const o=(0,$.$To)((0,$.$So)(c.engines.vscode));return o?o.majorBase<1||o.majorBase===1&&o.minorBase<60:!1}catch{return!1}}class p extends F.$Rc{constructor(o,l,n,s,a){super(),this.c=l,this.f=n,this.g=s,this.h=a,this.b=new Map,this.a=o.getProxy(C.$xK.MainThreadWebviews)}dispose(){super.dispose();for(const o of this.b.values())o.dispose();this.b.clear()}$onMessage(o,l,n){const s=this.j(o);if(s){const{message:a}=(0,E.$adb)(l,n.value);s._onMessageEmitter.fire(a)}}$onMissingCsp(o,l){this.g.warn(`${l} created a webview without a content security policy: https://aka.ms/vscode-webview-missing-csp`)}createNewWebview(o,l,n){const s=new D(o,this.a,i(l),this.c,this.f,n,this.h);this.b.set(o,s);const a=s._onDidDispose(()=>{a.dispose(),this.deleteWebview(o)});return s}deleteWebview(o){this.b.delete(o)}j(o){return this.b.get(o)}}e.$aec=p;function g(c){return{id:c.identifier,location:c.extensionLocation}}e.$bec=g;function t(c,o,l){return{enableCommandUris:l.enableCommandUris,enableScripts:l.enableScripts,enableForms:l.enableForms,portMapping:l.portMapping,localResourceRoots:l.localResourceRoots||r(c,o)}}e.$cec=t;function i(c){return{enableCommandUris:c.enableCommandUris,enableScripts:c.enableScripts,enableForms:c.enableForms,portMapping:c.portMapping,localResourceRoots:c.localResourceRoots?.map(o=>A.URI.from(o))}}function r(c,o){return[...(o?.getWorkspaceFolders()||[]).map(l=>l.uri),c.extensionLocation]}}),define(Pe[272],Re([1,0,20,97,6,13,25,2,8,65,75,3,7]),function(be,e,y,F,P,M,A,$,E,f,C,D,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$eec=void 0;class b{constructor(s,a){this.document=s,this.b=a,this.a=1,this.c=new C.$Ddc("custom documents")}addEdit(s){return this.c.add([s])}async undo(s,a){await this.f(s).undo(),a||this.disposeBackup()}async redo(s,a){await this.f(s).redo(),a||this.disposeBackup()}disposeEdits(s){for(const a of s)this.c.delete(a)}getNewBackupUri(){if(!this.b)throw new Error("Backup requires a valid storage path");const s=l(this.document.uri)+this.a++;return(0,A.$zg)(this.b,s)}updateBackup(s){this.d?.delete(),this.d=s}disposeBackup(){this.d?.delete(),this.d=void 0}f(s){const a=this.c.get(s,0);if(!a)throw new Error("No edit found");return a}}class p{constructor(){this.a=new Map}get(s,a){return this.a.get(this.b(s,a))}add(s,a,d){const v=this.b(s,a.uri);if(this.a.has(v))throw new Error(`Document already exists for viewType:${s} resource:${a.uri}`);const m=new b(a,d);return this.a.set(v,m),m}delete(s,a){const d=this.b(s,a.uri);this.a.delete(d)}b(s,a){return`${s}@@@${a}`}}var g;(function(n){n[n.Text=0]="Text",n[n.Custom=1]="Custom"})(g||(g={}));class t{constructor(){this.a=new Map}addTextProvider(s,a,d){return this.b(0,s,a,d)}addCustomProvider(s,a,d){return this.b(1,s,a,d)}get(s){return this.a.get(s)}b(s,a,d,v){if(this.a.has(a))throw new Error(`Provider for viewType:${a} already registered`);return this.a.set(a,{type:s,extension:d,provider:v}),new u.$zK(()=>this.a.delete(a))}}class i{constructor(s,a,d,v,m){this.d=a,this.f=d,this.g=v,this.h=m,this.b=new t,this.c=new p,this.a=s.getProxy(D.$xK.MainThreadCustomEditors)}registerCustomEditorProvider(s,a,d,v){const m=new P.$Qc;return c(d)?(m.add(this.b.addTextProvider(a,s,d)),this.a.$registerTextEditorProvider((0,f.$bec)(s),a,v.webviewOptions||{},{supportsMove:!!d.moveCustomTextEditor},(0,f.$_dc)(s))):(m.add(this.b.addCustomProvider(a,s,d)),r(d)&&m.add(d.onDidChangeCustomDocument(S=>{const k=this.i(a,S.document.uri);if(o(S)){const h=k.addEdit(S);this.a.$onDidEdit(S.document.uri,a,h,S.label)}else this.a.$onContentChange(S.document.uri,a)})),this.a.$registerCustomEditorProvider((0,f.$bec)(s),a,v.webviewOptions||{},!!v.supportsMultipleEditorsPerDocument,(0,f.$_dc)(s))),u.$zK.from(m,new u.$zK(()=>{this.a.$unregisterEditorProvider(a)}))}async $createCustomDocument(s,a,d,v,m){const S=this.b.get(a);if(!S)throw new Error(`No provider found for '${a}'`);if(S.type!==1)throw new Error(`Invalid provide type for '${a}'`);const k=$.URI.revive(s),h=await S.provider.openCustomDocument(k,{backupId:d,untitledDocumentData:v?.buffer},m);let w;return r(S.provider)&&this.f&&(w=this.f.workspaceValue(S.extension)??this.f.globalValue(S.extension)),this.c.add(a,h,w),{editable:r(S.provider)}}async $disposeCustomDocument(s,a){const d=this.b.get(a);if(!d)throw new Error(`No provider found for '${a}'`);if(d.type!==1)throw new Error(`Invalid provider type for '${a}'`);const v=$.URI.revive(s),{document:m}=this.i(a,v);this.c.delete(a,m),m.dispose()}async $resolveCustomEditor(s,a,d,v,m,S){const k=this.b.get(d);if(!k)throw new Error(`No provider found for '${d}'`);const h=E.ViewColumn.to(m),w=this.g.createNewWebview(a,v.contentOptions,k.extension),I=this.h.createNewWebviewPanel(a,d,v.title,h,v.options,w,v.active),L=$.URI.revive(s);switch(k.type){case 1:{const{document:V}=this.i(d,L);return k.provider.resolveCustomEditor(V,I,S)}case 0:{const V=this.d.getDocument(L);return k.provider.resolveCustomTextEditor(V,I,S)}default:throw new Error("Unknown webview provider type")}}$disposeEdits(s,a,d){this.i(a,s).disposeEdits(d)}async $onMoveCustomEditor(s,a,d){const v=this.b.get(d);if(!v)throw new Error(`No provider found for '${d}'`);if(!v.provider.moveCustomTextEditor)throw new Error(`Provider does not implement move '${d}'`);const m=this.h.getWebviewPanel(s);if(!m)throw new Error("No webview found");const S=$.URI.revive(a),k=this.d.getDocument(S);await v.provider.moveCustomTextEditor(k,m,y.CancellationToken.None)}async $undo(s,a,d,v){return this.i(a,s).undo(d,v)}async $redo(s,a,d,v){return this.i(a,s).redo(d,v)}async $revert(s,a,d){const v=this.i(a,s);await this.j(a).revertCustomDocument(v.document,d),v.disposeBackup()}async $onSave(s,a,d){const v=this.i(a,s);await this.j(a).saveCustomDocument(v.document,d),v.disposeBackup()}async $onSaveAs(s,a,d,v){const m=this.i(a,s);return this.j(a).saveCustomDocumentAs(m.document,$.URI.revive(d),v)}async $backup(s,a,d){const v=this.i(a,s),S=await this.j(a).backupCustomDocument(v.document,{destination:v.getNewBackupUri()},d);return v.updateBackup(S),S.id}i(s,a){const d=this.c.get(s,$.URI.revive(a));if(!d)throw new Error("No custom document found");return d}j(s){const d=this.b.get(s)?.provider;if(!d||!r(d))throw new Error("Custom document is not editable");return d}}e.$eec=i;function r(n){return!!n.onDidChangeCustomDocument}function c(n){return typeof n.resolveCustomTextEditor=="function"}function o(n){return typeof n.undo=="function"&&typeof n.redo=="function"}function l(n){const s=n.scheme===M.Schemas.file||n.scheme===M.Schemas.untitled?n.fsPath:n.toString();return(0,F.$Ji)(s)+""}}),define(Pe[273],Re([1,0,5,6,2,38,8,65,3,7]),function(be,e,y,F,P,M,A,$,E,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dec=void 0;class C extends F.$Rc{#e;#t;#i;#o;#r;#n;#a;#s;#c;#u;#l;#d;#h;constructor(p,g,t,i){super(),this.#s=void 0,this.#c=!0,this.#l=!1,this.#d=this.B(new y.$Rd),this.onDidDispose=this.#d.event,this.#h=this.B(new y.$Rd),this.onDidChangeViewState=this.#h.event,this.#e=p,this.#t=g,this.#o=t,this.#i=i.viewType,this.#r=i.panelOptions,this.#s=i.viewColumn,this.#n=i.title,this.#u=i.active}dispose(){this.#l||(this.#l=!0,this.#d.fire(),this.#t.$disposeWebview(this.#e),this.#o.dispose(),super.dispose())}get webview(){return this.c(),this.#o}get viewType(){return this.c(),this.#i}get title(){return this.c(),this.#n}set title(p){this.c(),this.#n!==p&&(this.#n=p,this.#t.$setTitle(this.#e,p))}get iconPath(){return this.c(),this.#a}set iconPath(p){this.c(),this.#a!==p&&(this.#a=p,this.#t.$setIconPath(this.#e,P.URI.isUri(p)?{light:p,dark:p}:p))}get options(){return this.#r}get viewColumn(){if(this.c(),!(typeof this.#s=="number"&&this.#s<0))return this.#s}get active(){return this.c(),this.#u}get visible(){return this.c(),this.#c}_updateViewState(p){this.#l||(this.active!==p.active||this.visible!==p.visible||this.viewColumn!==p.viewColumn)&&(this.#u=p.active,this.#c=p.visible,this.#s=p.viewColumn,this.#h.fire({webviewPanel:this}))}reveal(p,g){this.c(),this.#t.$reveal(this.#e,{viewColumn:typeof p>"u"?void 0:A.ViewColumn.from(p),preserveFocus:!!g})}c(){if(this.#l)throw new Error("Webview is disposed")}}class D extends F.$Rc{static c(){return(0,M.$ig)()}constructor(p,g,t){super(),this.j=g,this.m=t,this.g=new Map,this.h=new Map,this.f=p.getProxy(E.$xK.MainThreadWebviewPanels)}dispose(){super.dispose(),this.g.forEach(p=>p.dispose()),this.g.clear()}createWebviewPanel(p,g,t,i,r={}){const c=typeof i=="object"?i.viewColumn:i,o={viewColumn:A.ViewColumn.from(c),preserveFocus:typeof i=="object"&&!!i.preserveFocus},l=(0,$.$_dc)(p),n=D.c();this.f.$createWebviewPanel((0,$.$bec)(p),n,g,{title:t,panelOptions:u(r),webviewOptions:(0,$.$cec)(p,this.m,r),serializeBuffersForPostMessage:l},o);const s=this.j.createNewWebview(n,r,p);return this.createNewWebviewPanel(n,g,t,c,r,s,!0)}$onDidChangeWebviewPanelViewStates(p){const g=Object.keys(p);g.sort((t,i)=>{const r=p[t],c=p[i];return r.active?1:c.active?-1:+r.visible-+c.visible});for(const t of g){const i=this.getWebviewPanel(t);if(!i)continue;const r=p[t];i._updateViewState({active:r.active,visible:r.visible,viewColumn:A.ViewColumn.to(r.position)})}}async $onDidDisposeWebviewPanel(p){this.getWebviewPanel(p)?.dispose(),this.g.delete(p),this.j.deleteWebview(p)}registerWebviewPanelSerializer(p,g,t){if(this.h.has(g))throw new Error(`Serializer for '${g}' already registered`);return this.h.set(g,{serializer:t,extension:p}),this.f.$registerSerializer(g,{serializeBuffersForPostMessage:(0,$.$_dc)(p)}),new f.$zK(()=>{this.h.delete(g),this.f.$unregisterSerializer(g)})}async $deserializeWebviewPanel(p,g,t,i){const r=this.h.get(g);if(!r)throw new Error(`No serializer found for '${g}'`);const{serializer:c,extension:o}=r,l=this.j.createNewWebview(p,t.webviewOptions,o),n=this.createNewWebviewPanel(p,g,t.title,i,t.panelOptions,l,t.active);await c.deserializeWebviewPanel(n,t.state)}createNewWebviewPanel(p,g,t,i,r,c,o){const l=new C(p,this.f,c,{viewType:g,title:t,viewColumn:i,panelOptions:r,active:o});return this.g.set(p,l),l}getWebviewPanel(p){return this.g.get(p)}}e.$dec=D;function u(b){return{enableFindWidget:b.enableFindWidget,retainContextWhenHidden:b.retainContextWhenHidden}}}),define(Pe[274],Re([1,0,5,6,65,8,3,7]),function(be,e,y,F,P,M,A,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hfc=void 0;class E extends F.$Rc{#e;#t;#i;#o;#r;#n;#a;#s;#c;constructor(D,u,b,p,g,t){super(),this.#r=!1,this.#u=this.B(new y.$Rd),this.onDidChangeVisibility=this.#u.event,this.#l=this.B(new y.$Rd),this.onDidDispose=this.#l.event,this.#i=b,this.#a=p,this.#e=D,this.#t=u,this.#o=g,this.#n=t}dispose(){this.#r||(this.#r=!0,this.#l.fire(),this.#o.dispose(),super.dispose())}#u;#l;get title(){return this.a(),this.#a}set title(D){this.a(),this.#a!==D&&(this.#a=D,this.#t.$setWebviewViewTitle(this.#e,D))}get description(){return this.a(),this.#s}set description(D){this.a(),this.#s!==D&&(this.#s=D,this.#t.$setWebviewViewDescription(this.#e,D))}get visible(){return this.#n}get webview(){return this.#o}get viewType(){return this.#i}_setVisible(D){D===this.#n||this.#r||(this.#n=D,this.#u.fire())}get badge(){return this.a(),this.#c}set badge(D){this.a(),!(D?.value===this.#c?.value&&D?.tooltip===this.#c?.tooltip)&&(this.#c=M.ViewBadge.from(D),this.#t.$setWebviewViewBadge(this.#e,D))}show(D){this.a(),this.#t.$show(this.#e,!!D)}a(){if(this.#r)throw new Error("Webview is disposed")}}class f{constructor(D,u){this.d=u,this.b=new Map,this.c=new Map,this.a=D.getProxy(A.$xK.MainThreadWebviewViews)}registerWebviewViewProvider(D,u,b,p){if(this.b.has(u))throw new Error(`View provider for '${u}' already registered`);return this.b.set(u,{provider:b,extension:D}),this.a.$registerWebviewViewProvider((0,P.$bec)(D),u,{retainContextWhenHidden:p?.retainContextWhenHidden,serializeBuffersForPostMessage:(0,P.$_dc)(D)}),new $.$zK(()=>{this.b.delete(u),this.a.$unregisterWebviewViewProvider(u)})}async $resolveWebviewView(D,u,b,p,g){const t=this.b.get(u);if(!t)throw new Error(`No view provider found for '${u}'`);const{provider:i,extension:r}=t,c=this.d.createNewWebview(D,{},r),o=new E(D,this.a,u,b,c,!0);this.c.set(D,o),await i.resolveWebviewView(o,{state:p},g)}async $onDidChangeWebviewViewVisibility(D,u){this.e(D)._setVisible(u)}async $disposeWebviewView(D){const u=this.e(D);this.c.delete(D),u.dispose(),this.d.deleteWebview(D)}e(D){const u=this.c.get(D);if(!u)throw new Error("No webview found");return u}}e.$Hfc=f}),define(Pe[111],Re([1,0,5,3,2,13,12,4,17,23]),function(be,e,y,F,P,M,A,$,E,f){"use strict";var C;Object.defineProperty(e,"__esModule",{value:!0}),e.$Jfc=e.$Ifc=void 0;let D=class{static{C=this}static{this.a={focused:!0,active:!0}}getState(b){const p=this.d;return{get focused(){return p.focused},get active(){return(0,f.$MF)(b,"windowActivity"),p.active}}}constructor(b){this.c=new y.$Rd,this.onDidChangeWindowState=this.c.event,this.d=C.a,this.b=b.getProxy(F.$xK.MainThreadWindow),this.b.$getInitialState().then(({isFocused:p,isActive:g})=>{this.onDidChangeWindowProperty("focused",p),this.onDidChangeWindowProperty("active",g)})}$onDidChangeWindowFocus(b){this.onDidChangeWindowProperty("focused",b)}$onDidChangeWindowActive(b){this.onDidChangeWindowProperty("active",b)}onDidChangeWindowProperty(b,p){p!==this.d[b]&&(this.d={...this.d,[b]:p},this.c.fire(this.d))}openUri(b,p){let g;if(typeof b=="string"){g=b;try{b=P.URI.parse(b)}catch{return Promise.reject(`Invalid uri - '${b}'`)}}return(0,A.$Fe)(b.scheme)?Promise.reject("Invalid scheme - cannot be empty"):b.scheme===M.Schemas.command?Promise.reject(`Invalid scheme '${b.scheme}'`):this.b.$openUri(b,g,p)}async asExternalUri(b,p){if((0,A.$Fe)(b.scheme))return Promise.reject("Invalid scheme - cannot be empty");const g=await this.b.$asExternalUri(b,p);return P.URI.from(g)}};e.$Ifc=D,e.$Ifc=D=C=Ke([Ve(0,E.$zM)],D),e.$Jfc=(0,$.$Vh)("IExtHostWindow")}),define(Pe[275],Re([1,0,241,27,17]),function(be,e,y,F,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Uhc=void 0;let M=class extends y.$Mfc{constructor($,E){super($,E)}f($,E,f){E.apply(console,f)}};e.$Uhc=M,e.$Uhc=M=Ke([Ve(0,P.$zM),Ve(1,F.$PM)],M)}),define(Pe[276],Re([1,0,14,24,20,11,5,6,139,230,49]),function(be,e,y,F,P,M,A,$,E,f,C){"use strict";var D;Object.defineProperty(e,"__esModule",{value:!0}),e.$25b=e.ResponsiveState=e.RequestInitiator=e.$15b=e.$Z5b=void 0;function u(I,L){try{return JSON.stringify(I,L)}catch{return"null"}}const b="$$ref$$",p={[b]:-1};class g{constructor(L,V){this.jsonString=L,this.referencedBuffers=V}}function t(I,L=null,V=!1){const K=[];return{jsonString:(V?u:JSON.stringify)(I,(N,T)=>{if(typeof T>"u")return p;if(typeof T=="object"){if(T instanceof F.$fe){const z=K.push(T)-1;return{[b]:z}}if(L)return L(N,T)}return T}),referencedBuffers:K}}e.$Z5b=t;function i(I,L,V){return JSON.parse(I,(K,R)=>{if(R){const N=R[b];if(typeof N=="number")return L[N];if(V&&R.$mid===1)return V.transformIncoming(R)}return R})}e.$15b=i;function r(I,L){return JSON.stringify(I,L)}function c(I){return I?(L,V)=>V&&V.$mid===1?I.transformOutgoing(V):V:null}var o;(function(I){I[I.LocalSide=0]="LocalSide",I[I.OtherSide=1]="OtherSide"})(o||(e.RequestInitiator=o={}));var l;(function(I){I[I.Responsive=0]="Responsive",I[I.Unresponsive=1]="Unresponsive"})(l||(e.ResponsiveState=l={}));const n=()=>{},s=Symbol.for("rpcProtocol"),a=Symbol.for("rpcProxy");class d extends $.$Rc{static{D=s}static{this.a=3*1e3}constructor(L,V=null,K=null){super(),this[D]=!0,this.b=this.B(new A.$Rd),this.onDidChangeResponsiveState=this.b.event,this.c=L,this.f=V,this.g=K,this.h=c(this.g),this.j=!1,this.m=[],this.s=[];for(let R=0,N=C.$tv.count;R<N;R++)this.m[R]=null,this.s[R]=null;this.t=0,this.u=Object.create(null),this.w={},this.y=0,this.z=0,this.C=0,this.D=this.B(new y.$0g(()=>this.H(),1e3)),this.c.onMessage(R=>this.L(R))}dispose(){this.j=!0,Object.keys(this.w).forEach(L=>{const V=this.w[L];delete this.w[L],V.resolveErr(M.$5())})}drain(){return typeof this.c.drain=="function"?this.c.drain():Promise.resolve()}F(L){this.z===0&&(this.C=Date.now()+d.a),this.z++,this.D.isScheduled()||this.D.schedule()}G(L){this.C=Date.now()+d.a,this.z--,this.z===0&&this.D.cancel(),this.I(0)}H(){this.z!==0&&(Date.now()>this.C?this.I(1):this.D.schedule())}I(L){this.y!==L&&(this.y=L,this.b.fire(this.y))}get responsiveState(){return this.y}transformIncomingURIs(L){return this.g?(0,E.$Um)(L,this.g):L}getProxy(L){const{nid:V,sid:K}=L;return this.s[V]||(this.s[V]=this.J(V,K)),this.s[V]}J(L,V){const K={get:(R,N)=>(typeof N=="string"&&!R[N]&&N.charCodeAt(0)===36&&(R[N]=(...T)=>this.U(L,N,T)),N===a?V:R[N])};return new Proxy(Object.create(null),K)}set(L,V){return this.m[L.nid]=V,V}assertRegistered(L){for(let V=0,K=L.length;V<K;V++){const R=L[V];if(!this.m[R.nid])throw new Error(`Missing proxy instance ${R.sid}`)}}L(L){if(this.j)return;const V=L.byteLength,K=m.read(L,0),R=K.readUInt8(),N=K.readUInt32();switch(R){case 1:case 2:{let{rpcId:T,method:z,args:Z}=k.deserializeRequestJSONArgs(K);this.g&&(Z=(0,E.$Um)(Z,this.g)),this.M(V,N,T,z,Z,R===2);break}case 3:case 4:{let{rpcId:T,method:z,args:Z}=k.deserializeRequestMixedArgs(K);this.g&&(Z=(0,E.$Um)(Z,this.g)),this.M(V,N,T,z,Z,R===4);break}case 5:{this.f?.logIncoming(V,N,0,"ack"),this.G(N);break}case 6:{this.N(V,N);break}case 7:{this.O(V,N,void 0);break}case 9:{let T=k.deserializeReplyOKJSON(K);this.g&&(T=(0,E.$Um)(T,this.g)),this.O(V,N,T);break}case 10:{const T=k.deserializeReplyOKJSONWithBuffers(K,this.g);this.O(V,N,T);break}case 8:{const T=k.deserializeReplyOKVSBuffer(K);this.O(V,N,T);break}case 11:{let T=k.deserializeReplyErrError(K);this.g&&(T=(0,E.$Um)(T,this.g)),this.P(V,N,T);break}case 12:{this.P(V,N,void 0);break}default:console.error("received unexpected message"),console.error(L)}}M(L,V,K,R,N,T){this.f?.logIncoming(L,V,1,`receiveRequest ${(0,C.$vv)(K)}.${R}(`,N);const z=String(V);let Z,he;if(T){const De=new P.$2d;N.push(De.token),Z=this.Q(K,R,N),he=()=>De.cancel()}else Z=this.Q(K,R,N),he=n;this.u[z]=he;const ye=k.serializeAcknowledged(V);this.f?.logOutgoing(ye.byteLength,V,1,"ack"),this.c.send(ye),Z.then(De=>{delete this.u[z];const Se=k.serializeReplyOK(V,De,this.h);this.f?.logOutgoing(Se.byteLength,V,1,"reply:",De),this.c.send(Se)},De=>{delete this.u[z];const Se=k.serializeReplyErr(V,De);this.f?.logOutgoing(Se.byteLength,V,1,"replyErr:",De),this.c.send(Se)})}N(L,V){this.f?.logIncoming(L,V,1,"receiveCancel");const K=String(V);this.u[K]?.()}O(L,V,K){this.f?.logIncoming(L,V,0,"receiveReply:",K);const R=String(V);if(!this.w.hasOwnProperty(R))return;const N=this.w[R];delete this.w[R],N.resolveOk(K)}P(L,V,K){this.f?.logIncoming(L,V,0,"receiveReplyErr:",K);const R=String(V);if(!this.w.hasOwnProperty(R))return;const N=this.w[R];delete this.w[R];let T;K&&(K.$isError?(T=new Error,T.name=K.name,T.message=K.message,T.stack=K.stack):T=K),N.resolveErr(T)}Q(L,V,K){try{return Promise.resolve(this.S(L,V,K))}catch(R){return Promise.reject(R)}}S(L,V,K){const R=this.m[L];if(!R)throw new Error("Unknown actor "+(0,C.$vv)(L));const N=R[V];if(typeof N!="function")throw new Error("Unknown method "+V+" on actor "+(0,C.$vv)(L));return N.apply(R,K)}U(L,V,K){if(this.j)return new f.$Y5b;let R=null;if(K.length>0&&P.CancellationToken.isCancellationToken(K[K.length-1])&&(R=K.pop()),R&&R.isCancellationRequested)return Promise.reject(M.$5());const N=k.serializeRequestArguments(K,this.h),T=++this.t,z=String(T),Z=new f.$X5b,he=new $.$Qc;R&&he.add(R.onCancellationRequested(()=>{const De=k.serializeCancel(T);this.f?.logOutgoing(De.byteLength,T,0,"cancel"),this.c.send(k.serializeCancel(T))})),this.w[z]=new v(Z,he),this.F(T);const ye=k.serializeRequest(T,L,V,N,!!R);return this.f?.logOutgoing(ye.byteLength,T,0,`request: ${(0,C.$vv)(L)}.${V}(`,K),this.c.send(ye),Z}}e.$25b=d;class v{constructor(L,V){this.a=L,this.b=V}resolveOk(L){this.a.resolveOk(L),this.b.dispose()}resolveErr(L){this.a.resolveErr(L),this.b.dispose()}}class m{static alloc(L,V,K){const R=new m(F.$fe.alloc(K+1+4),0);return R.writeUInt8(L),R.writeUInt32(V),R}static read(L,V){return new m(L,V)}get buffer(){return this.a}constructor(L,V){this.a=L,this.b=V}static sizeUInt8(){return 1}static{this.sizeUInt32=4}writeUInt8(L){this.a.writeUInt8(L,this.b),this.b+=1}readUInt8(){const L=this.a.readUInt8(this.b);return this.b+=1,L}writeUInt32(L){this.a.writeUInt32BE(L,this.b),this.b+=4}readUInt32(){const L=this.a.readUInt32BE(this.b);return this.b+=4,L}static sizeShortString(L){return 1+L.byteLength}writeShortString(L){this.a.writeUInt8(L.byteLength,this.b),this.b+=1,this.a.set(L,this.b),this.b+=L.byteLength}readShortString(){const L=this.a.readUInt8(this.b);this.b+=1;const K=this.a.slice(this.b,this.b+L).toString();return this.b+=L,K}static sizeLongString(L){return 4+L.byteLength}writeLongString(L){this.a.writeUInt32BE(L.byteLength,this.b),this.b+=4,this.a.set(L,this.b),this.b+=L.byteLength}readLongString(){const L=this.a.readUInt32BE(this.b);this.b+=4;const K=this.a.slice(this.b,this.b+L).toString();return this.b+=L,K}writeBuffer(L){this.a.writeUInt32BE(L.byteLength,this.b),this.b+=4,this.a.set(L,this.b),this.b+=L.byteLength}static sizeVSBuffer(L){return 4+L.byteLength}writeVSBuffer(L){this.a.writeUInt32BE(L.byteLength,this.b),this.b+=4,this.a.set(L,this.b),this.b+=L.byteLength}readVSBuffer(){const L=this.a.readUInt32BE(this.b);this.b+=4;const V=this.a.slice(this.b,this.b+L);return this.b+=L,V}static sizeMixedArray(L){let V=0;V+=1;for(let K=0,R=L.length;K<R;K++){const N=L[K];switch(V+=1,N.type){case 1:V+=this.sizeLongString(N.value);break;case 2:V+=this.sizeVSBuffer(N.value);break;case 3:V+=this.sizeUInt32,V+=this.sizeLongString(N.value);for(let T=0;T<N.buffers.length;++T)V+=this.sizeVSBuffer(N.buffers[T]);break;case 4:break}}return V}writeMixedArray(L){this.a.writeUInt8(L.length,this.b),this.b+=1;for(let V=0,K=L.length;V<K;V++){const R=L[V];switch(R.type){case 1:this.writeUInt8(1),this.writeLongString(R.value);break;case 2:this.writeUInt8(2),this.writeVSBuffer(R.value);break;case 3:this.writeUInt8(3),this.writeUInt32(R.buffers.length),this.writeLongString(R.value);for(let N=0;N<R.buffers.length;++N)this.writeBuffer(R.buffers[N]);break;case 4:this.writeUInt8(4);break}}}readMixedArray(){const L=this.a.readUInt8(this.b);this.b+=1;const V=new Array(L);for(let K=0;K<L;K++)switch(this.readUInt8()){case 1:V[K]=this.readLongString();break;case 2:V[K]=this.readVSBuffer();break;case 3:{const N=this.readUInt32(),T=this.readLongString(),z=[];for(let Z=0;Z<N;++Z)z.push(this.readVSBuffer());V[K]=new C.$wv(i(T,z,null));break}case 4:V[K]=void 0;break}return V}}var S;(function(I){I[I.Simple=0]="Simple",I[I.Mixed=1]="Mixed"})(S||(S={}));class k{static a(L){for(let V=0,K=L.length;V<K;V++)if(L[V]instanceof F.$fe||L[V]instanceof C.$wv||typeof L[V]>"u")return!0;return!1}static serializeRequestArguments(L,V){if(this.a(L)){const K=[];for(let R=0,N=L.length;R<N;R++){const T=L[R];if(T instanceof F.$fe)K[R]={type:2,value:T};else if(typeof T>"u")K[R]={type:4};else if(T instanceof C.$wv){const{jsonString:z,referencedBuffers:Z}=t(T.value,V);K[R]={type:3,value:F.$fe.fromString(z),buffers:Z}}else K[R]={type:1,value:F.$fe.fromString(r(T,V))}}return{type:1,args:K}}return{type:0,args:r(L,V)}}static serializeRequest(L,V,K,R,N){switch(R.type){case 0:return this.b(L,V,K,R.args,N);case 1:return this.c(L,V,K,R.args,N)}}static b(L,V,K,R,N){const T=F.$fe.fromString(K),z=F.$fe.fromString(R);let Z=0;Z+=m.sizeUInt8(),Z+=m.sizeShortString(T),Z+=m.sizeLongString(z);const he=m.alloc(N?2:1,L,Z);return he.writeUInt8(V),he.writeShortString(T),he.writeLongString(z),he.buffer}static deserializeRequestJSONArgs(L){const V=L.readUInt8(),K=L.readShortString(),R=L.readLongString();return{rpcId:V,method:K,args:JSON.parse(R)}}static c(L,V,K,R,N){const T=F.$fe.fromString(K);let z=0;z+=m.sizeUInt8(),z+=m.sizeShortString(T),z+=m.sizeMixedArray(R);const Z=m.alloc(N?4:3,L,z);return Z.writeUInt8(V),Z.writeShortString(T),Z.writeMixedArray(R),Z.buffer}static deserializeRequestMixedArgs(L){const V=L.readUInt8(),K=L.readShortString(),R=L.readMixedArray(),N=new Array(R.length);for(let T=0,z=R.length;T<z;T++){const Z=R[T];typeof Z=="string"?N[T]=JSON.parse(Z):N[T]=Z}return{rpcId:V,method:K,args:N}}static serializeAcknowledged(L){return m.alloc(5,L,0).buffer}static serializeCancel(L){return m.alloc(6,L,0).buffer}static serializeReplyOK(L,V,K){if(typeof V>"u")return this.d(L);if(V instanceof F.$fe)return this.e(L,V);if(V instanceof C.$wv){const{jsonString:R,referencedBuffers:N}=t(V.value,K,!0);return this.g(L,R,N)}else return this.f(L,u(V,K))}static d(L){return m.alloc(7,L,0).buffer}static e(L,V){let K=0;K+=m.sizeVSBuffer(V);const R=m.alloc(8,L,K);return R.writeVSBuffer(V),R.buffer}static deserializeReplyOKVSBuffer(L){return L.readVSBuffer()}static f(L,V){const K=F.$fe.fromString(V);let R=0;R+=m.sizeLongString(K);const N=m.alloc(9,L,R);return N.writeLongString(K),N.buffer}static g(L,V,K){const R=F.$fe.fromString(V);let N=0;N+=m.sizeUInt32,N+=m.sizeLongString(R);for(const z of K)N+=m.sizeVSBuffer(z);const T=m.alloc(10,L,N);T.writeUInt32(K.length),T.writeLongString(R);for(const z of K)T.writeBuffer(z);return T.buffer}static deserializeReplyOKJSON(L){const V=L.readLongString();return JSON.parse(V)}static deserializeReplyOKJSONWithBuffers(L,V){const K=L.readUInt32(),R=L.readLongString(),N=[];for(let T=0;T<K;++T)N.push(L.readVSBuffer());return new C.$wv(i(R,N,V))}static serializeReplyErr(L,V){const K=V?u(M.$2(V),null):void 0;if(typeof K!="string")return this.h(L);const R=F.$fe.fromString(K);let N=0;N+=m.sizeLongString(R);const T=m.alloc(11,L,N);return T.writeLongString(R),T.buffer}static deserializeReplyErrError(L){const V=L.readLongString();return JSON.parse(V)}static h(L){return m.alloc(12,L,0).buffer}}var h;(function(I){I[I.RequestJSONArgs=1]="RequestJSONArgs",I[I.RequestJSONArgsWithCancellation=2]="RequestJSONArgsWithCancellation",I[I.RequestMixedArgs=3]="RequestMixedArgs",I[I.RequestMixedArgsWithCancellation=4]="RequestMixedArgsWithCancellation",I[I.Acknowledged=5]="Acknowledged",I[I.Cancel=6]="Cancel",I[I.ReplyOKEmpty=7]="ReplyOKEmpty",I[I.ReplyOKVSBuffer=8]="ReplyOKVSBuffer",I[I.ReplyOKJSON=9]="ReplyOKJSON",I[I.ReplyOKJSONWithBuffers=10]="ReplyOKJSONWithBuffers",I[I.ReplyErrError=11]="ReplyErrError",I[I.ReplyErrEmpty=12]="ReplyErrEmpty"})(h||(h={}));var w;(function(I){I[I.String=1]="String",I[I.VSBuffer=2]="VSBuffer",I[I.SerializedObjectWithBuffers=3]="SerializedObjectWithBuffers",I[I.Undefined=4]="Undefined"})(w||(w={}))}),define(Pe[277],Re([1,0]),function(be,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Whc=void 0;const y=function(M){const A=$=>{globalThis.removeEventListener("message",A);const E=$.data;Object.defineProperties(globalThis,{postMessage:{value(f,C){E.postMessage(f,C)}},onmessage:{get(){return E.onmessage},set(f){E.onmessage=f}}}),E.addEventListener("message",f=>{globalThis.dispatchEvent(new MessageEvent("message",{data:f.data,ports:f.ports?[...f.ports]:void 0}))}),E.start(),globalThis.Worker=class{constructor(){throw new TypeError("Nested workers from within nested worker are NOT supported.")}},importScripts(M)};globalThis.addEventListener("message",A)}.toString();class F extends EventTarget{constructor(M,A,$){super(),this.onmessage=null,this.onmessageerror=null,this.onerror=null;const E=`((${y})('${A}'))`,f=new Blob([E],{type:"application/javascript"}),C=URL.createObjectURL(f),D=new MessageChannel,u=C,b={type:"_newWorker",id:u,port:D.port2,url:C,options:$};M(b,[D.port2]),this.postMessage=D.port1.postMessage.bind(D.port1),this.terminate=()=>{M({type:"_terminateWorker",id:u}),URL.revokeObjectURL(C),D.port1.close(),D.port2.close()},Object.defineProperties(this,{onmessage:{get(){return D.port1.onmessage},set(p){D.port1.onmessage=p}},onmessageerror:{get(){return D.port1.onmessageerror},set(p){D.port1.onmessageerror=p}}}),D.port1.addEventListener("messageerror",p=>{const g=new MessageEvent("messageerror",{data:p.data});this.dispatchEvent(g)}),D.port1.addEventListener("message",p=>{const g=new MessageEvent("message",{data:p.data});this.dispatchEvent(g)}),D.port1.start()}}e.$Whc=F}),define(Pe[278],Re([1,0,5,30,34,4]),function(be,e,y,F,P,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$TJ=e.$SJ=e.OutputChannelUpdateMode=e.$RJ=e.$QJ=e.$PJ=e.$OJ=e.$NJ=e.$MJ=e.$LJ=e.$KJ=e.$JJ=e.$IJ=void 0,e.$IJ="text/x-code-output",e.$JJ="output",e.$KJ="Log",e.$LJ="text/x-code-log-output",e.$MJ="log",e.$NJ="workbench.panel.output",e.$OJ=new P.$aj("inOutput",!1),e.$PJ=new P.$aj("activeLogOutput",!1),e.$QJ=new P.$aj("outputView.scrollLock",!1),e.$RJ=(0,M.$Vh)("outputService");var A;(function(E){E[E.Append=1]="Append",E[E.Replace=2]="Replace",E[E.Clear=3]="Clear"})(A||(e.OutputChannelUpdateMode=A={})),e.$SJ={OutputChannels:"workbench.contributions.outputChannels"};class ${constructor(){this.a=new Map,this.b=new y.$Rd,this.onDidRegisterChannel=this.b.event,this.c=new y.$Rd,this.onDidRemoveChannel=this.c.event}registerChannel(f){this.a.has(f.id)||(this.a.set(f.id,f),this.b.fire(f.id))}getChannels(){const f=[];return this.a.forEach(C=>f.push(C)),f}getChannel(f){return this.a.get(f)}removeChannel(f){this.a.delete(f),this.c.fire(f)}}F.$mn.add(e.$SJ.OutputChannels,new $),e.$TJ=new P.$aj("activeOutputChannel","")}),define(Pe[112],Re([1,0,3,4,17,22,15,278,63,27,42,136,24,16,41,5,6]),function(be,e,y,F,P,M,A,$,E,f,C,D,u,b,p,g,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jfc=e.$ifc=void 0;class i extends A.$jj{get disposed(){return this.n}constructor(l,n,s,a,d){super(),this.id=l,this.name=n,this.r=s,this.s=a,this.extension=d,this.m=0,this.n=!1,this.visible=!1,this.setLevel(s.getLevel()),this.B(s.onDidChangeLogLevel(v=>this.setLevel(v)))}get logLevel(){return this.getLevel()}appendLine(l){this.append(l+`
`)}append(l){this.info(l)}clear(){const l=this.m;this.r.flush(),this.s.$update(this.id,$.OutputChannelUpdateMode.Clear,l)}replace(l){const n=this.m;this.info(l),this.s.$update(this.id,$.OutputChannelUpdateMode.Replace,n),this.visible&&this.r.flush()}show(l,n){this.r.flush(),this.s.$reveal(this.id,!!(typeof l=="boolean"?l:n))}hide(){this.s.$close(this.id)}g(l,n){this.m+=u.$fe.fromString(n).byteLength,(0,A.log)(this.r,l,n),this.visible&&(this.r.flush(),this.s.$update(this.id,$.OutputChannelUpdateMode.Append))}dispose(){super.dispose(),this.n||(this.s.$dispose(this.id),this.n=!0)}}class r extends i{appendLine(l){this.append(l)}}let c=class{constructor(l,n,s,a,d,v){this.i=n,this.j=s,this.k=a,this.l=d,this.m=v,this.d=new Map,this.f=1,this.g=new Map,this.h=null,this.a=l.getProxy(y.$xK.MainThreadOutputService),this.b=this.k.extUri.joinPath(n.logsLocation,`output_logging_${(0,D.$km)(new Date).replace(/-|:|\.\d+Z$/g,"")}`)}$setVisibleChannel(l){this.h=l;for(const[n,s]of this.g)s.visible=n===this.h}createOutputChannel(l,n,s){if(l=l.trim(),!l)throw new Error("illegal argument `name`. must not be falsy");const a=typeof n=="object"&&n.log,d=(0,b.$Cf)(n)?n:void 0;if((0,b.$Cf)(d)&&!d.trim())throw new Error("illegal argument `languageId`. must not be empty");let v;const m=this.i.environment.extensionLogLevel?.find(([k])=>M.$_l.equals(s.identifier,k))?.[1];m&&(v=(0,A.$tj)(m));const S=a?this.o(l,v,s):this.n(l,d,s);return S.then(k=>{this.g.set(k.id,k),k.visible=k.id===this.h}),a?this.r(l,v??this.m.getLevel(),S):this.q(l,S)}async n(l,n,s){this.c||(this.c=this.j.value.createDirectory(this.b).then(()=>this.b));const a=await this.c,d=this.k.extUri.joinPath(a,`${this.f++}-${l.replace(/[\\/:\*\?"<>\|]/g,"")}.log`),v=this.l.createLogger(d,{logLevel:"always",donotRotate:!0,donotUseFormatters:!0,hidden:!0}),m=await this.a.$register(l,d,n,s.identifier.value);return new i(m,l,v,this.a,s)}async o(l,n,s){const a=await this.p(s),d=l.replace(/[\\/:\*\?"<>\|]/g,""),v=this.k.extUri.joinPath(a,`${d}.log`),m=`${s.identifier.value}.${d}`,S=this.l.createLogger(v,{id:m,name:l,logLevel:n,extensionId:s.identifier.value});return new r(m,l,S,this.a,s)}p(l){let n=this.d.get(l.identifier.value);if(!n){const s=this.k.extUri.joinPath(this.i.logsLocation,l.identifier.value);this.d.set(l.identifier.value,n=(async()=>{try{await this.j.value.createDirectory(s)}catch(a){if((0,p.$uk)(a)!==p.FileSystemProviderErrorCode.FileExists)throw a}return s})())}return n}q(l,n){let s=!1;const a=()=>{if(s)throw new Error("Channel has been closed")};return{get name(){return l},append(d){a(),n.then(v=>v.append(d))},appendLine(d){a(),n.then(v=>v.appendLine(d))},clear(){a(),n.then(d=>d.clear())},replace(d){a(),n.then(v=>v.replace(d))},show(d,v){a(),n.then(m=>m.show(d,v))},hide(){a(),n.then(d=>d.hide())},dispose(){s=!0,n.then(d=>d.dispose())}}}r(l,n,s){const a=new t.$Qc,d=()=>{if(a.isDisposed)throw new Error("Channel has been closed")},v=a.add(new g.$Rd);function m(S){n=S,v.fire(S)}return s.then(S=>{a.add(S),S.logLevel!==n&&m(S.logLevel),a.add(S.onDidChangeLogLevel(k=>m(k)))}),{...this.q(l,s),get logLevel(){return n},onDidChangeLogLevel:v.event,trace(S,...k){d(),s.then(h=>h.trace(S,...k))},debug(S,...k){d(),s.then(h=>h.debug(S,...k))},info(S,...k){d(),s.then(h=>h.info(S,...k))},warn(S,...k){d(),s.then(h=>h.warn(S,...k))},error(S,...k){d(),s.then(h=>h.error(S,...k))},dispose(){a.dispose()}}}};e.$ifc=c,e.$ifc=c=Ke([Ve(0,P.$zM),Ve(1,f.$PM),Ve(2,E.$8dc),Ve(3,C.$Hdc),Ve(4,A.$ej),Ve(5,A.$dj)],c),e.$jfc=(0,F.$Vh)("IExtHostOutputService")}),define(Pe[113],Re([1,0,4,14]),function(be,e,y,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Am=e.$zm=void 0,e.$zm=(0,y.$Vh)("remoteAgentService"),e.$Am=new class{constructor(){this.maxSampleCount=5,this.sampleDelay=2e3,this.initial=[],this.maxInitialCount=3,this.average=[],this.maxAverageCount=100,this.highLatencyMultiple=2,this.highLatencyMinThreshold=500,this.highLatencyMaxThreshold=1500,this.lastMeasurement=void 0}get latency(){return this.lastMeasurement}async measure(P){let M=1/0;for(let $=0;$<this.maxSampleCount;$++){const E=await P.getRoundTripTime();if(E===void 0)return;M=Math.min(M,E/2),await(0,F.$Yg)(this.sampleDelay)}this.average.push(M),this.average.length>this.maxAverageCount&&this.average.shift();let A;return this.initial.length<this.maxInitialCount?this.initial.push(M):A=this.initial.reduce(($,E)=>$+E,0)/this.initial.length,this.lastMeasurement={initial:A,current:M,average:this.average.reduce(($,E)=>$+E,0)/this.average.length,high:(()=>typeof A>"u"?!1:M>this.highLatencyMaxThreshold||M>this.highLatencyMinThreshold&&M>A*this.highLatencyMultiple)()},this.lastMeasurement}}}),define(Pe[279],Re([1,0,170,54,30,47,40,6,5,113,21,26]),function(be,e,y,F,P,M,A,$,E,f,C,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tH=e.$sH=e.$rH=e.$qH=e.$pH=e.$oH=void 0,e.$oH=Object.freeze({id:"application",order:100,title:(0,y.localize)(0,null),type:"object"}),e.$pH=Object.freeze({id:"workbench",order:7,title:(0,y.localize)(1,null),type:"object"}),e.$qH=Object.freeze({id:"security",scope:1,title:(0,y.localize)(2,null),type:"object",order:7}),e.$rH={ConfigurationMigration:"base.contributions.configuration.migration"};class u{constructor(){this.migrations=[],this.a=new E.$Rd,this.onDidRegisterConfigurationMigration=this.a.event}registerConfigurationMigrations(i){this.migrations.push(...i)}}const b=new u;P.$mn.add(e.$rH.ConfigurationMigration,b);let p=class extends $.$Rc{constructor(i,r){super(),this.a=i,this.b=r,this.B(this.b.onDidChangeWorkspaceFolders(async c=>{for(const o of c.added)await this.f(o,b.migrations)})),this.c(b.migrations),this.B(b.onDidRegisterConfigurationMigration(c=>this.c(c)))}async c(i){await this.f(void 0,i);for(const r of this.b.getWorkspace().folders)await this.f(r,i)}async f(i,r){await Promise.all([r.map(c=>this.g(c,i?.uri))])}async g(i,r){const c=this.a.inspect(i.key,{resource:r}),o=[["userValue",2],["userLocalValue",3],["userRemoteValue",4],["workspaceValue",5],["workspaceFolderValue",6]];for(const[l,n]of o){const s=[];for(const d of c.overrideIdentifiers??[]){const v=await this.h(i,{resource:r,overrideIdentifier:d},l);for(const m of v??[]){let S=s.find(([[k,h]])=>k===m[0]&&(0,D.$en)(h.value,m[1].value));S||s.push(S=[m,[]]),S[1].push(d)}}const a=await this.h(i,{resource:r},l,c);for(const d of a??[])s.push([d,[]]);s.length&&await Promise.allSettled(s.map(async([[d,v],m])=>this.a.updateValue(d,v.value,{resource:r,overrideIdentifiers:m},n)))}}async h(i,r,c,o){const l=(o??this.a.inspect(i.key,r))[c];if(l===void 0)return;const n=a=>this.a.inspect(a,r)[c],s=await i.migrateFn(l,n);return Array.isArray(s)?s:[[i.key,s]]}};e.$sH=p,e.$sH=p=Ke([Ve(0,A.$pi),Ve(1,M.$5h)],p);let g=class extends $.$Rc{constructor(i){super(),(async()=>{if(!C.$i&&(await i.getEnvironment())?.os!==1)return;P.$mn.as(F.$rn.Configuration).registerConfiguration({...e.$qH,properties:{"security.allowedUNCHosts":{type:"array",items:{type:"string",pattern:"^[^\\\\]+$",patternErrorMessage:(0,y.localize)(3,null)},default:[],markdownDescription:(0,y.localize)(4,null),scope:2},"security.restrictUNCAccess":{type:"boolean",default:!0,markdownDescription:(0,y.localize)(5,null),scope:2}}})})()}};e.$tH=g,e.$tH=g=Ke([Ve(0,f.$zm)],g)}),define(Pe[280],Re([1,0,33,13,19,25,178,279,54,4,30]),function(be,e,y,F,P,M,A,$,E,f,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ucb=e.$tcb=e.ResolvedStatus=e.RegisteredEditorPriority=e.$scb=e.$rcb=void 0,e.$rcb=(0,f.$Vh)("editorResolverService"),e.$scb="workbench.editorAssociations";const D=C.$mn.as(E.$rn.Configuration),u={...$.$pH,properties:{"workbench.editorAssociations":{type:"object",markdownDescription:(0,A.localize)(0,null),additionalProperties:{type:"string"}}}};D.registerConfiguration(u);var b;(function(i){i.builtin="builtin",i.option="option",i.exclusive="exclusive",i.default="default"})(b||(e.RegisteredEditorPriority=b={}));var p;(function(i){i[i.ABORT=1]="ABORT",i[i.NONE=2]="NONE"})(p||(e.ResolvedStatus=p={}));function g(i){switch(i){case b.exclusive:return 5;case b.default:return 4;case b.builtin:return 3;case b.option:default:return 1}}e.$tcb=g;function t(i,r){if(new Set([F.Schemas.extension,F.Schemas.webviewPanel,F.Schemas.vscodeWorkspaceTrust,F.Schemas.vscodeSettings]).has(r.scheme))return!1;const l=typeof i=="string"&&i.indexOf(P.$fc.sep)>=0?`${r.scheme}:${r.path}`:(0,M.$wg)(r);return y.$Bj(typeof i=="string"?i.toLowerCase():i,l.toLowerCase())}e.$ucb=t}),define(Pe[281],Re([1,0,46,13,19,21,25,2,4,199,47,217,113]),function(be,e,y,F,P,M,A,$,E,f,C,D,u){"use strict";var b;Object.defineProperty(e,"__esModule",{value:!0}),e.$aK=e.$_J=void 0,e.$_J=(0,E.$Vh)("pathService");let p=b=class{constructor(t,i,r,c){this.d=t,this.e=i,this.f=r,this.g=c,this.a=(async()=>(await this.e.getEnvironment())?.os||M.OS)(),this.b=(async()=>{const o=await this.e.getEnvironment();return this.c=o?.userHome??t})()}hasValidBasename(t,i,r){return typeof i=="string"||typeof i>"u"?this.a.then(c=>this.h(t,c,i)):this.h(t,i,r)}h(t,i,r){return t.scheme===F.Schemas.file||t.scheme===F.Schemas.vscodeRemote?(0,y.$Zf)(r??(0,A.$wg)(t),i===1):!0}get defaultUriScheme(){return b.findDefaultUriScheme(this.f,this.g)}static findDefaultUriScheme(t,i){if(t.remoteAuthority)return F.Schemas.vscodeRemote;const r=(0,f.$9J)(i.getWorkspace());if(r)return r;const c=i.getWorkspace().folders[0];if(c)return c.uri.scheme;const o=i.getWorkspace().configuration;return o?o.scheme:F.Schemas.file}userHome(t){return t?.preferLocal?this.d:this.b}get resolvedUserHome(){return this.c}get path(){return this.a.then(t=>t===1?P.$ec:P.$fc)}async fileURI(t){let i="";if(await this.a===1&&(t=t.replace(/\\/g,"/")),t[0]==="/"&&t[1]==="/"){const c=t.indexOf("/",2);c===-1?(i=t.substring(2),t="/"):(i=t.substring(2,c),t=t.substring(c)||"/")}return $.URI.from({scheme:F.Schemas.file,authority:i,path:t,query:"",fragment:""})}};e.$aK=p,e.$aK=p=b=Ke([Ve(1,u.$zm),Ve(2,D.$UJ),Ve(3,C.$5h)],p)}),define(Pe[114],Re([1,0]),function(be,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchCompleteMessageType=e.$PI=e.$OI=void 0;class y{constructor(A,$){this.line=A,this.character=$}isBefore(A){return!1}isBeforeOrEqual(A){return!1}isAfter(A){return!1}isAfterOrEqual(A){return!1}isEqual(A){return!1}compareTo(A){return 0}translate(A,$){return new y(0,0)}with(A){return new y(0,0)}}e.$OI=y;class F{constructor(A,$,E,f){this.isEmpty=!1,this.isSingleLine=!1,this.start=new y(A,$),this.end=new y(E,f)}contains(A){return!1}isEqual(A){return!1}intersection(A){}union(A){return new F(0,0,0,0)}with(A){return new F(0,0,0,0)}}e.$PI=F;var P;(function(M){M[M.Information=1]="Information",M[M.Warning=2]="Warning"})(P||(e.TextSearchCompleteMessageType=P={}))}),define(Pe[43],Re([1,0,18,33,26,46,12,4,19,11,114,14]),function(be,e,y,F,P,M,A,$,E,f,C,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$eJ=e.$dJ=e.$cJ=e.$bJ=e.$aJ=e.$_I=e.$$I=e.$0I=e.$9I=e.$8I=e.$7I=e.$6I=e.SearchErrorCode=e.$5I=e.$4I=e.SearchSortOrder=e.ViewMode=e.$3I=e.$2I=e.$1I=e.$ZI=e.SearchCompletionExitCode=e.$YI=e.$XI=e.$WI=e.QueryType=e.SearchProviderType=e.$VI=e.$UI=e.$TI=e.$SI=e.$RI=e.$QI=e.TextSearchCompleteMessageType=void 0,Object.defineProperty(e,"TextSearchCompleteMessageType",{enumerable:!0,get:function(){return C.TextSearchCompleteMessageType}}),e.$QI="workbench.view.search",e.$RI="workbench.panel.search",e.$SI="workbench.view.search",e.$TI="search-result",e.$UI="search.exclude";const u="\u27EA ",b=" characters skipped \u27EB",p=(u.length+b.length+5)*2;e.$VI=(0,$.$Vh)("searchService");var g;(function(fe){fe[fe.file=0]="file",fe[fe.text=1]="text"})(g||(e.SearchProviderType=g={}));var t;(function(fe){fe[fe.File=1]="File",fe[fe.Text=2]="Text"})(t||(e.QueryType=t={}));function i(fe){return!!fe.preview}e.$WI=i;function r(fe){return!!fe.resource}e.$XI=r;function c(fe){return!!fe.message}e.$YI=c;var o;(function(fe){fe[fe.Normal=0]="Normal",fe[fe.NewSearchStarted=1]="NewSearchStarted"})(o||(e.SearchCompletionExitCode=o={}));class l{constructor($e){this.resource=$e,this.results=[]}}e.$ZI=l;class n{constructor($e,re,Ae,se){this.ranges=re,this.webviewIndex=se;const X=Array.isArray(re)?re:[re];if(Ae&&Ae.matchLines===1&&s(X)){$e=(0,A.$vf)($e,Ae.matchLines);let B="",ie=0,pe=0;const ne=Math.floor(Ae.charsPerLine/5),le=[];for(const ce of X){const we=Math.max(ce.startColumn-ne,0),_=ce.startColumn+Ae.charsPerLine;if(we>pe+ne+p){const de=u+(we-pe)+b;B+=de+$e.slice(we,_),ie+=we-(pe+de.length)}else B+=$e.slice(pe,_);le.push(new d(0,ce.startColumn-ie,ce.endColumn-ie)),pe=_}this.preview={text:B,matches:Array.isArray(this.ranges)?le:le[0]}}else{const B=Array.isArray(re)?re[0].startLineNumber:re.startLineNumber;this.preview={text:$e,matches:(0,y.$1b)(re,ie=>new a(ie.startLineNumber-B,ie.startColumn,ie.endLineNumber-B,ie.endColumn))}}}}e.$1I=n;function s(fe){const $e=fe[0].startLineNumber;for(const re of fe)if(re.startLineNumber!==$e||re.endLineNumber!==$e)return!1;return!0}class a{constructor($e,re,Ae,se){this.startLineNumber=$e,this.startColumn=re,this.endLineNumber=Ae,this.endColumn=se}}e.$2I=a;class d extends a{constructor($e,re,Ae){super($e,re,$e,Ae)}}e.$3I=d;var v;(function(fe){fe.List="list",fe.Tree="tree"})(v||(e.ViewMode=v={}));var m;(function(fe){fe.Default="default",fe.FileNames="fileNames",fe.Type="type",fe.Modified="modified",fe.CountDescending="countDescending",fe.CountAscending="countAscending"})(m||(e.SearchSortOrder=m={}));function S(fe,$e=!0){const re=fe&&fe.files&&fe.files.exclude,Ae=$e&&fe&&fe.search&&fe.search.exclude;if(!re&&!Ae)return;if(!re||!Ae)return re||Ae;let se=Object.create(null);return se=P.$dn(se,P.$an(re)),se=P.$dn(se,P.$an(Ae),!0),se}e.$4I=S;function k(fe,$e){return fe.excludePattern&&F.$Bj(fe.excludePattern,$e)?!1:fe.includePattern||fe.usingSearchPaths?fe.includePattern&&F.$Bj(fe.includePattern,$e)?!0:fe.usingSearchPaths?!!fe.folderQueries&&fe.folderQueries.some(re=>{const Ae=re.folder.fsPath;if(M.$2f($e,Ae)){const se=E.$kc(Ae,$e);return!re.includePattern||!!F.$Bj(re.includePattern,se)}else return!1}):!1:!0}e.$5I=k;var h;(function(fe){fe[fe.unknownEncoding=1]="unknownEncoding",fe[fe.regexParseError=2]="regexParseError",fe[fe.globParseError=3]="globParseError",fe[fe.invalidLiteral=4]="invalidLiteral",fe[fe.rgProcessError=5]="rgProcessError",fe[fe.other=6]="other",fe[fe.canceled=7]="canceled"})(h||(e.SearchErrorCode=h={}));class w extends Error{constructor($e,re){super($e),this.code=re}}e.$6I=w;function I(fe){const $e=fe.message;if((0,f.$3)(fe))return new w($e,h.canceled);try{const re=JSON.parse($e);return new w(re.message,re.code)}catch{return new w($e,h.other)}}e.$7I=I;function L(fe){const $e={message:fe.message,code:fe.code};return new Error(JSON.stringify($e))}e.$8I=L;function V(fe){return fe.type==="error"?!0:fe.type==="success"}e.$9I=V;function K(fe){return fe.type==="success"}e.$0I=K;function R(fe){return!!fe.path}e.$$I=R;function N(fe,$e){const re=fe.searchPath?fe.searchPath:fe.relativePath;return(0,A.$sf)(re,$e)}e.$_I=N;class T{constructor($e){this.path=$e,this.results=[]}addMatch($e){this.results.push($e)}serialize(){return{path:this.path,results:this.results,numMatches:this.results.length}}}e.$aJ=T;function z(fe,$e){const re={...fe||{},...$e||{}};return Object.keys(re).filter(Ae=>{const se=re[Ae];return typeof se=="boolean"&&se})}e.$bJ=z;class Z{constructor($e,re){this.c=null,this.a={...$e.excludePattern||{},...re.excludePattern||{}},this.b=F.$Cj(this.a);let Ae=$e.includePattern;re.includePattern&&(Ae?Ae={...Ae,...re.includePattern}:Ae=re.includePattern),Ae&&(this.c=F.$Cj(Ae))}matchesExcludesSync($e,re,Ae){return!!(this.b&&this.b($e,re,Ae))}includedInQuerySync($e,re,Ae){return!(this.b&&this.b($e,re,Ae)||this.c&&!this.c($e,re,Ae))}includedInQuery($e,re,Ae){const se=this.b($e,re,Ae),X=()=>this.c?!!this.c($e,re,Ae):!0;return(0,D.$Kg)(se)?se.then(B=>B?!1:X()):X()}hasSiblingExcludeClauses(){return he(this.a)}}e.$cJ=Z;function he(fe){for(const $e in fe)if(typeof fe[$e]!="boolean")return!0;return!1}function ye(fe){if(!fe)return;let $e;return re=>($e||($e=(fe()||Promise.resolve([])).then(Ae=>Ae?Se(Ae):{})),$e.then(Ae=>!!Ae[re]))}e.$dJ=ye;function De(fe){if(!fe)return;let $e;return re=>{if(!$e){const Ae=fe();$e=Ae?Se(Ae):{}}return!!$e[re]}}e.$eJ=De;function Se(fe){const $e={};for(const re of fe)$e[re]=!0;return $e}}),define(Pe[35],Re([1,0,18,14,20,5,6,50,13,121,25,12,2,169,4,15,188,47,42,27,17,8,7,57,43,3,51]),function(be,e,y,F,P,M,A,$,E,f,C,D,u,b,p,g,t,i,r,c,o,l,n,s,a,d,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3dc=e.$2dc=void 0;function m(K,R,N){return new C.$og(T=>w(T,N)).isEqual(K,R)}function S(K,R,N){return m(K.uri,R.uri,N)?0:(0,D.$Ye)(K.uri.toString(),R.uri.toString())}function k(K,R,N){return K.index!==R.index?K.index<R.index?-1:1:m(K.uri,R.uri,N)?(0,D.$Ye)(K.name,R.name):(0,D.$Ye)(K.uri.toString(),R.uri.toString())}function h(K,R,N,T){const z=K.slice(0).sort((he,ye)=>N(he,ye,T)),Z=R.slice(0).sort((he,ye)=>N(he,ye,T));return(0,y.$Db)(z,Z,(he,ye)=>N(he,ye,T))}function w(K,R){const N=R.getCapabilities(K.scheme);return!(N&&N&1024)}class I extends i.$ci{static toExtHostWorkspace(R,N,T,z){if(!R)return{workspace:null,added:[],removed:[]};const{id:Z,name:he,folders:ye,configuration:De,transient:Se,isUntitled:fe}=R,$e=[],re=N;N?ye.forEach((B,ie)=>{const pe=u.URI.revive(B.uri),ne=I.o(T||N,pe,z);ne?(ne.name=B.name,ne.index=B.index,$e.push(ne)):$e.push({uri:pe,name:B.name,index:ie})}):$e.push(...ye.map(({uri:B,name:ie,index:pe})=>({uri:u.URI.revive(B),name:ie,index:pe}))),$e.sort((B,ie)=>B.index<ie.index?-1:1);const Ae=new I(Z,he,$e,!!Se,De?u.URI.revive(De):null,!!fe,B=>w(B,z)),{added:se,removed:X}=h(re?re.workspaceFolders:[],Ae.workspaceFolders,S,z);return{workspace:Ae,added:se,removed:X}}static o(R,N,T){for(let z=0;z<R.folders.length;z++){const Z=R.workspaceFolders[z];if(m(Z.uri,N,T))return Z}}constructor(R,N,T,z,Z,he,ye){super(R,T.map(De=>new i.$di(De)),z,Z,ye),this.t=N,this.u=he,this.q=[],this.s=$.$2h.forUris(ye),T.forEach(De=>{this.q.push(De),this.s.set(De.uri,De)})}get name(){return this.t}get isUntitled(){return this.u}get workspaceFolders(){return this.q.slice(0)}getWorkspaceFolder(R,N){return N&&this.s.get(R)&&(R=(0,C.$yg)(R)),this.s.findSubstr(R)}resolveWorkspaceFolder(R){return this.s.get(R)}}let L=class{constructor(R,N,T,z,Z){this.c=new M.$Rd,this.onDidChangeWorkspace=this.c.event,this.g=new M.$Rd,this.onDidGrantWorkspaceTrust=this.g.event,this.u=[],this.v=!1,this.w=new Map,this.z=0,this.A=new M.$Td,this.B=new Map,this.h=z,this.s=T,this.t=Z,this.j=new f.$Wl,this.k=new F.$Wg,this.o=R.getProxy(d.$xK.MainThreadWorkspace),this.q=R.getProxy(d.$xK.MainThreadMessageService);const he=N.workspace;this.l=he?new I(he.id,he.name,[],!!he.transient,he.configuration?u.URI.revive(he.configuration):null,!!he.isUntitled,ye=>w(ye,T)):void 0}$initializeWorkspace(R,N){this.v=N,this.$acceptWorkspaceData(R),this.k.open()}waitForInitializeCall(){return this.k.wait()}get workspace(){return this.x}get name(){return this.x?this.x.name:void 0}get workspaceFile(){if(this.x&&this.x.configuration)return this.x.isUntitled?u.URI.from({scheme:E.Schemas.untitled,path:(0,C.$wg)((0,C.$yg)(this.x.configuration))}):this.x.configuration}get x(){return this.n||this.l}getWorkspaceFolders(){if(this.x)return this.x.workspaceFolders.slice(0)}async getWorkspaceFolders2(){if(await this.k.wait(),!!this.x)return this.x.workspaceFolders.slice(0)}updateWorkspaceFolders(R,N,T,...z){const Z=[];if(Array.isArray(z)&&z.forEach(fe=>{u.URI.isUri(fe.uri)&&!Z.some($e=>m($e.uri,fe.uri,this.s))&&Z.push({uri:fe.uri,name:fe.name||(0,C.$vg)(fe.uri)})}),this.n||[N,T].some(fe=>typeof fe!="number"||fe<0)||T===0&&Z.length===0)return!1;const he=this.x?this.x.workspaceFolders:[];if(N+T>he.length)return!1;const ye=he.slice(0);ye.splice(N,T,...Z.map(fe=>({uri:fe.uri,name:fe.name||(0,C.$vg)(fe.uri),index:void 0})));for(let fe=0;fe<ye.length;fe++){const $e=ye[fe];if(ye.some((re,Ae)=>Ae!==fe&&m($e.uri,re.uri,this.s)))return!1}ye.forEach((fe,$e)=>fe.index=$e);const{added:De,removed:Se}=h(he,ye,k,this.s);if(De.length===0&&Se.length===0)return!1;if(this.o){const fe=R.displayName||R.name;this.o.$updateWorkspaceFolders(fe,N,T,Z).then(void 0,$e=>{this.n=void 0;const re={source:{identifier:R.identifier,label:R.displayName||R.name}};this.q.$showMessage(t.Severity.Error,(0,b.localize)(0,null,fe,$e.toString()),re,[])})}return this.y(ye),!0}getWorkspaceFolder(R,N){if(this.x)return this.x.getWorkspaceFolder(R,N)}async getWorkspaceFolder2(R,N){if(await this.k.wait(),!!this.x)return this.x.getWorkspaceFolder(R,N)}async resolveWorkspaceFolder(R){if(await this.k.wait(),!!this.x)return this.x.resolveWorkspaceFolder(R)}getPath(){if(!this.x)return;const{folders:R}=this.x;if(R.length!==0)return R[0].uri.fsPath}getRelativePath(R,N){let T,z="";if(typeof R=="string"?(T=u.URI.file(R),z=R):typeof R<"u"&&(T=R,z=R.fsPath),!T)return z;const Z=this.getWorkspaceFolder(T,!0);if(!Z)return z;typeof N>"u"&&this.x&&(N=this.x.folders.length>1);let he=(0,C.$Bg)(Z.uri,T);return N&&Z.name&&(he=`${Z.name}/${he}`),he}y(R){this.x&&(this.n=I.toExtHostWorkspace({id:this.x.id,name:this.x.name,configuration:this.x.configuration,folders:R,isUntitled:this.x.isUntitled},this.x,void 0,this.s).workspace||void 0)}$acceptWorkspaceData(R){const{workspace:N,added:T,removed:z}=I.toExtHostWorkspace(R,this.l,this.n,this.s);this.l=N||void 0,this.n=void 0,this.c.fire(Object.freeze({added:T,removed:z}))}findFiles(R,N,T,z,Z=P.CancellationToken.None){this.h.trace(`extHostWorkspace#findFiles: fileSearch, extension: ${z.value}, entryPoint: findFiles`);let he;if(N===null?he=!1:N&&(typeof N=="string"?he=N:he=N.pattern),Z&&Z.isCancellationRequested)return Promise.resolve([]);const{includePattern:ye,folder:De}=V(l.GlobPattern.from(R));return this.o.$startFileSearch(ye??null,De??null,he??null,T??null,Z).then(Se=>Array.isArray(Se)?Se.map(fe=>u.URI.revive(fe)):[])}async findTextInFiles(R,N,T,z,Z=P.CancellationToken.None){this.h.trace(`extHostWorkspace#findTextInFiles: textSearch, extension: ${z.value}, entryPoint: findTextInFiles`);const he=this.j.getNext(),ye=typeof N.previewOptions>"u"?{matchLines:100,charsPerLine:1e4}:N.previewOptions,{includePattern:De,folder:Se}=V(l.GlobPattern.from(N.include)),fe=typeof N.exclude=="string"?N.exclude:N.exclude?N.exclude.pattern:void 0,$e={ignoreSymlinks:typeof N.followSymlinks=="boolean"?!N.followSymlinks:void 0,disregardIgnoreFiles:typeof N.useIgnoreFiles=="boolean"?!N.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof N.useGlobalIgnoreFiles=="boolean"?!N.useGlobalIgnoreFiles:void 0,disregardParentIgnoreFiles:typeof N.useParentIgnoreFiles=="boolean"?!N.useParentIgnoreFiles:void 0,disregardExcludeSettings:typeof N.useDefaultExcludes=="boolean"?!N.useDefaultExcludes:!0,fileEncoding:N.encoding,maxResults:N.maxResults,previewOptions:ye,afterContext:N.afterContext,beforeContext:N.beforeContext,includePattern:De,excludePattern:fe},re=!1;if(this.u[he]=Ae=>{if(re)return;const se=u.URI.revive(Ae.resource);Ae.results.forEach(X=>{const B=(0,v.$sh)(X);(0,a.$WI)(B)?T({uri:se,preview:{text:B.preview.text,matches:(0,y.$1b)(B.preview.matches,ie=>new n.$BK(ie.startLineNumber,ie.startColumn,ie.endLineNumber,ie.endColumn))},ranges:(0,y.$1b)(B.ranges,ie=>new n.$BK(ie.startLineNumber,ie.startColumn,ie.endLineNumber,ie.endColumn))}):T({uri:se,text:B.text,lineNumber:B.lineNumber})})},Z.isCancellationRequested)return{};try{const Ae=await this.o.$startTextSearch(R,Se??null,$e,he,Z);return delete this.u[he],Ae||{}}catch(Ae){throw delete this.u[he],Ae}}$handleTextSearchResult(R,N){this.u[N]?.(R)}async save(R){const N=await this.o.$save(R,{saveAs:!1});return u.URI.revive(N)}async saveAs(R){const N=await this.o.$save(R,{saveAs:!0});return u.URI.revive(N)}saveAll(R){return this.o.$saveAll(R)}resolveProxy(R){return this.o.$resolveProxy(R)}loadCertificates(){return this.o.$loadCertificates()}get trusted(){return this.v}requestWorkspaceTrust(R){return this.o.$requestWorkspaceTrust(R)}$onDidGrantWorkspaceTrust(){this.v||(this.v=!0,this.g.fire())}registerEditSessionIdentityProvider(R,N){if(this.w.has(R))throw new Error(`A provider has already been registered for scheme ${R}`);this.w.set(R,N);const T=this.t.transformOutgoingScheme(R),z=this.z++;return this.o.$registerEditSessionIdentityProvider(z,T),(0,A.$Pc)(()=>{this.w.delete(R),this.o.$unregisterEditSessionIdentityProvider(z)})}async $getEditSessionIdentifier(R,N){this.h.info("Getting edit session identifier for workspaceFolder",R);const T=await this.resolveWorkspaceFolder(u.URI.revive(R));if(!T){this.h.warn("Unable to resolve workspace folder");return}this.h.info("Invoking #provideEditSessionIdentity for workspaceFolder",T);const z=this.w.get(T.uri.scheme);if(this.h.info(`Provider for scheme ${T.uri.scheme} is defined: `,!!z),!z)return;const Z=await z.provideEditSessionIdentity(T,N);if(this.h.info("Provider returned edit session identifier: ",Z),!!Z)return Z}async $provideEditSessionIdentityMatch(R,N,T,z){this.h.info("Getting edit session identifier for workspaceFolder",R);const Z=await this.resolveWorkspaceFolder(u.URI.revive(R));if(!Z){this.h.warn("Unable to resolve workspace folder");return}this.h.info("Invoking #provideEditSessionIdentity for workspaceFolder",Z);const he=this.w.get(Z.uri.scheme);if(this.h.info(`Provider for scheme ${Z.uri.scheme} is defined: `,!!he),!he)return;const ye=await he.provideEditSessionIdentityMatch?.(N,T,z);if(this.h.info("Provider returned edit session identifier match result: ",ye),!!ye)return ye}getOnWillCreateEditSessionIdentityEvent(R){return(N,T,z)=>{const Z=function(ye){N.call(T,ye)};return Z.extension=R,this.A.event(Z,void 0,z)}}async $onWillCreateEditSessionIdentity(R,N,T){const z=await this.resolveWorkspaceFolder(u.URI.revive(R));if(z===void 0)throw new Error("Unable to resolve workspace folder");await this.A.fireAsync({workspaceFolder:z},N,async(Z,he)=>{const ye=Date.now();await Promise.resolve(Z),Date.now()-ye>T&&this.h.warn("SLOW edit session create-participant",he.extension.identifier)}),N.isCancellationRequested}registerCanonicalUriProvider(R,N){if(this.B.has(R))throw new Error(`A provider has already been registered for scheme ${R}`);this.B.set(R,N);const T=this.t.transformOutgoingScheme(R),z=this.z++;return this.o.$registerCanonicalUriProvider(z,T),(0,A.$Pc)(()=>{this.B.delete(R),this.o.$unregisterCanonicalUriProvider(z)})}async provideCanonicalUri(R,N,T){const z=this.B.get(R.scheme);if(!z)return;const Z=await z.provideCanonicalUri?.(u.URI.revive(R),N,T);if(Z)return Z}async $provideCanonicalUri(R,N,T){return this.provideCanonicalUri(u.URI.revive(R),{targetScheme:N},T)}};e.$2dc=L,e.$2dc=L=Ke([Ve(0,o.$zM),Ve(1,c.$PM),Ve(2,r.$Hdc),Ve(3,g.$dj),Ve(4,s.$Zdc)],L),e.$3dc=(0,p.$Vh)("IExtHostWorkspace");function V(K){let R,N;return K&&(typeof K=="string"?R=K:(R=K.pattern,N=u.URI.revive(K.baseUri))),{includePattern:R,folder:N}}}),define(Pe[36],Re([1,0,26,5,35,3,7,190,54,16,14,4,17,15,2]),function(be,e,y,F,P,M,A,$,E,f,C,D,u,b,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6dc=e.$5dc=e.$4dc=void 0;function g(s,a){if(a){const d=a.split(".");let v=s;for(let m=0;v&&m<d.length;m++)v=v[d[m]];return v}}function t(s){return s instanceof p.URI}function i(s){return s&&s.uri instanceof p.URI&&s.languageId&&typeof s.languageId=="string"}function r(s){return s&&!s.uri&&s.languageId&&typeof s.languageId=="string"}function c(s){return s&&s.uri instanceof p.URI&&(!s.name||typeof s.name=="string")&&(!s.index||typeof s.index=="number")}function o(s){if(t(s))return{resource:s};if(i(s))return{resource:s.uri,overrideIdentifier:s.languageId};if(r(s))return{overrideIdentifier:s.languageId};if(c(s))return{resource:s.uri};if(s===null)return{resource:null}}let l=class{constructor(a,d,v){this.a=a.getProxy(M.$xK.MainThreadConfiguration),this.c=d,this.b=v,this.d=new C.$Wg,this.e=null}getConfigProvider(){return this.d.wait().then(a=>this.e)}$initializeConfiguration(a){this.e=new n(this.a,this.c,a,this.b),this.d.open()}$acceptConfigurationChanged(a,d){this.getConfigProvider().then(v=>v.$acceptConfigurationChanged(a,d))}};e.$4dc=l,e.$4dc=l=Ke([Ve(0,u.$zM),Ve(1,P.$3dc),Ve(2,b.$dj)],l);class n{constructor(a,d,v,m){this.a=new F.$Rd,this.b=a,this.f=m,this.c=d,this.e=$.$Kn.parse(v),this.d=this.k(v.configurationScopes)}get onDidChangeConfiguration(){return this.a&&this.a.event}$acceptConfigurationChanged(a,d){const v={data:this.e.toData(),workspace:this.c.workspace};this.e=$.$Kn.parse(a),this.d=this.k(a.configurationScopes),this.a.fire(this.j(d,v))}getConfiguration(a,d,v){const m=o(d)||{},S=this.g(a?g(this.e.getValue(void 0,m,this.c.workspace),a):this.e.getValue(void 0,m,this.c.workspace));a&&this.h(a,m,v?.identifier);function k(w){if(w==null)return null;if(typeof w=="boolean")return w?2:5;switch(w){case A.ConfigurationTarget.Global:return 2;case A.ConfigurationTarget.Workspace:return 5;case A.ConfigurationTarget.WorkspaceFolder:return 6}}const h={has(w){return typeof g(S,w)<"u"},get:(w,I)=>{this.h(a?`${a}.${w}`:w,m,v?.identifier);let L=g(S,w);if(typeof L>"u")L=I;else{let V;const K=(R,N)=>{if((0,f.$Ef)(R)){let T;const z=()=>{V=V||(0,y.$an)(S),T=T||g(V,N)};return new Proxy(R,{get:(Z,he)=>{if(typeof he=="string"&&he.toLowerCase()==="tojson")return z(),()=>T;if(V)return T=T||g(V,N),T[he];const ye=Z[he];return typeof he=="string"?K(ye,`${N}.${he}`):ye},set:(Z,he,ye)=>(z(),T&&(T[he]=ye),!0),deleteProperty:(Z,he)=>(z(),T&&delete T[he],!0),defineProperty:(Z,he,ye)=>(z(),T&&Object.defineProperty(T,he,ye),!0)})}return Array.isArray(R)?(0,y.$an)(R):R};L=K(L,w)}return L},update:(w,I,L,V)=>{w=a?`${a}.${w}`:w;const K=k(L);return I!==void 0?this.b.$updateConfigurationOption(K,w,I,m,V):this.b.$removeConfigurationOption(K,w,m,V)},inspect:w=>{w=a?`${a}.${w}`:w;const I=this.e.inspect(w,m,this.c.workspace);if(I)return{key:w,defaultValue:(0,y.$an)(I.policy?.value??I.default?.value),globalValue:(0,y.$an)(I.user?.value??I.application?.value),workspaceValue:(0,y.$an)(I.workspace?.value),workspaceFolderValue:(0,y.$an)(I.workspaceFolder?.value),defaultLanguageValue:(0,y.$an)(I.default?.override),globalLanguageValue:(0,y.$an)(I.user?.override??I.application?.override),workspaceLanguageValue:(0,y.$an)(I.workspace?.override),workspaceFolderLanguageValue:(0,y.$an)(I.workspaceFolder?.override),languageIds:(0,y.$an)(I.overrideIdentifiers)}}};return typeof S=="object"&&(0,y.$dn)(h,S,!1),Object.freeze(h)}g(a){const d=v=>(0,f.$Ef)(v)?new Proxy(v,{get:(m,S)=>d(m[S]),set:(m,S,k)=>{throw new Error(`TypeError: Cannot assign to read only property '${String(S)}' of object`)},deleteProperty:(m,S)=>{throw new Error(`TypeError: Cannot delete read only property '${String(S)}' of object`)},defineProperty:(m,S)=>{throw new Error(`TypeError: Cannot define property '${String(S)}' for a readonly object`)},setPrototypeOf:m=>{throw new Error("TypeError: Cannot set prototype for a readonly object")},isExtensible:()=>!1,preventExtensions:()=>!0}):v;return d(a)}h(a,d,v){const m=E.$Bn.test(a)?4:this.d.get(a),S=v?`[${v.value}] `:"";if(m===4){typeof d?.resource>"u"&&this.f.warn(`${S}Accessing a resource scoped configuration without providing a resource is not expected. To get the effective value for '${a}', provide the URI of a resource or 'null' for any resource.`);return}if(m===3){d?.resource&&this.f.warn(`${S}Accessing a window scoped configuration for a resource is not expected. To associate '${a}' to a resource, define its scope to 'resource' in configuration contributions in 'package.json'.`);return}}j(a,d){const v=new $.$Mn(a,d,this.e,this.c.workspace);return Object.freeze({affectsConfiguration:(m,S)=>v.affectsConfiguration(m,o(S))})}k(a){return a.reduce((d,v)=>(d.set(v[0],v[1]),d),new Map)}}e.$5dc=n,e.$6dc=(0,D.$Vh)("IExtHostConfiguration")}),define(Pe[115],Re([1,0,2,14,5,3,7,35,61,36,20,64,17,27,4,13,21,15,81,229,11]),function(be,e,y,F,P,M,A,$,E,f,C,D,u,b,p,g,t,i,r,c,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wfc=e.$vfc=e.$ufc=e.TaskDTO=e.TaskHandleDTO=e.CustomExecutionDTO=void 0;var l;(function(K){function R(T){if(T!=null)return T}K.from=R;function N(T){if(T!=null)return T}K.to=N})(l||(l={}));var n;(function(K){function R(T){if(T!=null)return T}K.from=R;function N(T){if(T!=null)return T}K.to=N})(n||(n={}));var s;(function(K){function R(T){if(T!=null)return T}K.from=R;function N(T){if(T!=null)return T}K.to=N})(s||(s={}));var a;(function(K){function R(z){if(z){const Z=z;return Z&&!!Z.process}else return!1}K.is=R;function N(z){if(z==null)return;const Z={process:z.process,args:z.args};return z.options&&(Z.options=s.from(z.options)),Z}K.from=N;function T(z){if(z!=null)return new A.$hL(z.process,z.args,z.options)}K.to=T})(a||(a={}));var d;(function(K){function R(T){if(T!=null)return T}K.from=R;function N(T){if(T!=null)return T}K.to=N})(d||(d={}));var v;(function(K){function R(z){if(z){const Z=z;return Z&&(!!Z.commandLine||!!Z.command)}else return!1}K.is=R;function N(z){if(z==null)return;const Z={};return z.commandLine!==void 0?Z.commandLine=z.commandLine:(Z.command=z.command,Z.args=z.args),z.options&&(Z.options=d.from(z.options)),Z}K.from=N;function T(z){if(!(z==null||z.command===void 0&&z.commandLine===void 0))return z.commandLine?new A.$iL(z.commandLine,z.options):new A.$iL(z.command,z.args?z.args:[],z.options)}K.to=T})(v||(v={}));var m;(function(K){function R(z){if(z){const Z=z;return Z&&Z.customExecution==="customExecution"}else return!1}K.is=R;function N(z){return{customExecution:"customExecution"}}K.from=N;function T(z,Z){return Z.get(z)}K.to=T})(m||(e.CustomExecutionDTO=m={}));var S;(function(K){function R(N,T){let z;return N.scope!==void 0&&typeof N.scope!="number"?z=N.scope.uri:N.scope!==void 0&&typeof N.scope=="number"&&(N.scope===A.TaskScope.Workspace&&T&&T.workspaceFile?z=T.workspaceFile:z=c.$8F),{id:N._id,workspaceFolder:z}}K.from=R})(S||(e.TaskHandleDTO=S={}));var k;(function(K){function R(N){if(N!=null)return{_id:N.id,isDefault:N.isDefault}}K.from=R})(k||(k={}));var h;(function(K){function R(z,Z){if(z==null)return[];const he=[];for(const ye of z){const De=N(ye,Z);De&&he.push(De)}return he}K.fromMany=R;function N(z,Z){if(z==null)return;let he;z.execution instanceof A.$hL?he=a.from(z.execution):z.execution instanceof A.$iL?he=v.from(z.execution):z.execution&&z.execution instanceof A.$jL&&(he=m.from(z.execution));const ye=l.from(z.definition);let De;return z.scope?typeof z.scope=="number"?De=z.scope:De=z.scope.uri:De=A.TaskScope.Workspace,!ye||!De?void 0:{_id:z._id,definition:ye,name:z.name,source:{extensionId:Z.identifier.value,label:z.source,scope:De},execution:he,isBackground:z.isBackground,group:k.from(z.group),presentationOptions:n.from(z.presentationOptions),problemMatchers:z.problemMatchers,hasDefinedMatchers:z.hasDefinedMatchers,runOptions:z.runOptions?z.runOptions:{reevaluateOnRerun:!0},detail:z.detail}}K.from=N;async function T(z,Z,he){if(z==null)return;let ye;a.is(z.execution)?ye=a.to(z.execution):v.is(z.execution)?ye=v.to(z.execution):m.is(z.execution)&&(ye=m.to(z._id,he));const De=l.to(z.definition);let Se;if(z.source&&(z.source.scope!==void 0?typeof z.source.scope=="number"?Se=z.source.scope:Se=await Z.resolveWorkspaceFolder(y.URI.revive(z.source.scope)):Se=A.TaskScope.Workspace),!De||!Se)return;const fe=new A.$kL(De,Se,z.name,z.source.label,ye,z.problemMatchers);return z.isBackground!==void 0&&(fe.isBackground=z.isBackground),z.group!==void 0&&(fe.group=A.$gL.from(z.group._id),fe.group&&z.group.isDefault&&(fe.group=new A.$gL(fe.group.id,fe.group.label),z.group.isDefault===!0&&(fe.group.isDefault=z.group.isDefault))),z.presentationOptions&&(fe.presentationOptions=n.to(z.presentationOptions)),z._id&&(fe._id=z._id),z.detail&&(fe.detail=z.detail),fe}K.to=T})(h||(e.TaskDTO=h={}));var w;(function(K){function R(T){return T}K.from=R;function N(T){if(T)return Object.assign(Object.create(null),T)}K.to=N})(w||(w={}));class I{#e;constructor(R,N,T){this._id=N,this.a=T,this.#e=R}get task(){return this.a}terminate(){this.#e.terminateTask(this)}fireDidStartProcess(R){}fireDidEndProcess(R){}}let L=class{constructor(R,N,T,z,Z,he,ye,De){this.q=new P.$Rd,this.r=new P.$Rd,this.s=new P.$Rd,this.t=new P.$Rd,this.a=R.getProxy(M.$xK.MainThreadTask),this.b=T,this.c=z,this.d=Z,this.e=he,this.h=0,this.j=new Map,this.k=new Map,this.l=new Map,this.m=new Map,this.n=new Set,this.o=new Map,this.f=ye,this.g=De,this.a.$registerSupportedExecutions(!0)}registerTaskProvider(R,N,T){if(!T)return new A.$zK(()=>{});const z=this.w();return this.j.set(z,{type:N,provider:T,extension:R}),this.a.$registerTaskProvider(z,N),new A.$zK(()=>{this.j.delete(z),this.a.$unregisterTaskProvider(z)})}registerTaskSystem(R,N){this.a.$registerTaskSystem(R,N)}fetchTasks(R){return this.a.$fetchTasks(w.from(R)).then(async N=>{const T=[];for(const z of N){const Z=await h.to(z,this.b,this.m);Z&&T.push(Z)}return T})}get taskExecutions(){const R=[];return this.k.forEach(N=>R.push(N)),R}terminateTask(R){if(!(R instanceof I))throw new Error("No valid task execution provided");return this.a.$terminateTask(R._id)}get onDidStartTask(){return this.q.event}async $onDidStartTask(R,N,T){const z=this.m.get(R.id);z&&(this.o.set(R.id,z),this.e.attachPtyToTerminal(N,await z.callback(T))),this.p=R.id,this.q.fire({execution:await this.y(R)})}get onDidEndTask(){return this.r.event}async $OnDidEndTask(R){const N=await this.y(R);this.l.delete(R.id),this.k.delete(R.id),this.A(R),this.r.fire({execution:N})}get onDidStartTaskProcess(){return this.s.event}async $onDidStartTaskProcess(R){const N=await this.y(R.id);this.s.fire({execution:N,processId:R.processId})}get onDidEndTaskProcess(){return this.t.event}async $onDidEndTaskProcess(R){const N=await this.y(R.id);this.t.fire({execution:N,exitCode:R.exitCode})}$provideTasks(R,N){const T=this.j.get(R);if(!T)return Promise.reject(new Error("no handler found"));const z=[],Z=(0,F.$Qg)(()=>T.provider.provideTasks(C.CancellationToken.None)).then(he=>this.u(N,z,T,he));return new Promise(he=>{Z.then(ye=>{Promise.all(z).then(()=>{he(ye)})})})}async $resolveTask(R,N){const T=this.j.get(R);if(!T)return Promise.reject(new Error("no handler found"));if(N.definition.type!==T.type)throw new Error(`Unexpected: Task of type [${N.definition.type}] cannot be resolved by provider of type [${T.type}].`);const z=await h.to(N,this.b,this.m);if(!z)throw new Error("Unexpected: Task cannot be resolved.");const Z=await T.provider.resolveTask(z,C.CancellationToken.None);if(!Z)return;this.z(Z,T);const he=h.from(Z,T.extension);if(!he)throw new Error("Unexpected: Task cannot be resolved.");if(Z.definition!==z.definition)throw new Error("Unexpected: The resolved task definition must be the same object as the original task definition. The task definition cannot be changed.");return m.is(he.execution)&&await this.x(he,Z,!0),await this.v(he)}w(){return this.h++}async x(R,N,T){const z=await this.a.$createTaskId(R);!T&&!this.m.has(z)&&(this.n.add(z),this.o.set(z,N.execution)),this.m.set(z,N.execution)}async y(R,N){if(typeof R=="string"){const Z=this.l.get(R);if(!Z)throw new o.$ab("Unexpected: The specified task is missing an execution");return Z}const T=this.l.get(R.id);if(T)return T;const z=new Promise((Z,he)=>{function ye(De,Se,fe){fe?Z(new I(De,Se.id,fe)):he("Unexpected: Task does not exist.")}N?ye(this,R,N):h.to(R.task,this.b,this.m).then(De=>ye(this,R,De))});return this.l.set(R.id,z),z.then(Z=>(this.k.set(R.id,Z),Z),Z=>Promise.reject(Z))}z(R,N){R._deprecated&&this.g.report("Task.constructor",N.extension,"Use the Task constructor that takes a `scope` instead.")}A(R){this.o.get(R.id)&&this.o.delete(R.id),this.n.has(R.id)&&this.p!==R.id&&(this.m.delete(R.id),this.n.delete(R.id));const T=this.n.values();let z=T.next();for(;!z.done;)!this.o.has(z.value)&&this.p!==z.value&&(this.m.delete(z.value),this.n.delete(z.value)),z=T.next()}};e.$ufc=L,e.$ufc=L=Ke([Ve(0,u.$zM),Ve(1,b.$PM),Ve(2,$.$3dc),Ve(3,E.$KM),Ve(4,f.$6dc),Ve(5,D.$rec),Ve(6,i.$dj),Ve(7,r.$Kdc)],L);let V=class extends L{constructor(R,N,T,z,Z,he,ye,De){super(R,N,T,z,Z,he,ye,De),this.registerTaskSystem(g.Schemas.vscodeRemote,{scheme:g.Schemas.vscodeRemote,authority:"",platform:t.$h(0)})}async executeTask(R,N){if(!N.execution)throw new Error("Tasks to execute must include an execution");const T=h.from(N,R);if(T===void 0)throw new Error("Task is not valid");if(m.is(T.execution))await this.x(T,N,!1);else throw new o.$$;const z=await this.y(await this.a.$getTaskExecution(T),N);return this.a.$executeTask(T).catch(Z=>{throw new Error(Z)}),z}u(R,N,T,z){const Z=[];if(z)for(const he of z){if(this.z(he,T),!he.definition||!R[he.definition.type]){const De=he.source?he.source:"No task source";this.f.warn(`The task [${De}, ${he.name}] uses an undefined task type. The task will be ignored in the future.`)}const ye=h.from(he,T.extension);ye&&m.is(ye.execution)?(Z.push(ye),N.push(this.x(ye,he,!0))):this.f.warn("Only custom execution tasks supported.")}return{tasks:Z,extension:T.extension}}async v(R){if(m.is(R.execution))return R;this.f.warn("Only custom execution tasks supported.")}async $resolveVariables(R,N){return{process:void 0,variables:Object.create(null)}}async $jsonTasksSupported(){return!1}async $findExecutable(R,N,T){}};e.$vfc=V,e.$vfc=V=Ke([Ve(0,u.$zM),Ve(1,b.$PM),Ve(2,$.$3dc),Ve(3,E.$KM),Ve(4,f.$6dc),Ve(5,D.$rec),Ve(6,i.$dj),Ve(7,r.$Kdc)],V),e.$wfc=(0,p.$Vh)("IExtHostTask")}),define(Pe[282],Re([1,0,43,29]),function(be,e,y,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mJ=e.$lJ=e.$kJ=void 0;function P(A){return"cellResults"in A}e.$kJ=P,e.$lJ="rawCell#";function M(A,$){let E=-1;const f=[];let C=[];return A.forEach(u=>{u.range.startLineNumber!==E&&C.length>0&&(f.push([...C]),C=[]),C.push(u),E=u.range.endLineNumber}),C.length>0&&f.push([...C]),f.map(u=>{const b=[],p=u[0].range.startLineNumber,g=u[u.length-1].range.endLineNumber;for(let t=p;t<=g;t++)b.push($.getLineContent(t));return new y.$1I(b.join(`
`)+`
`,u.map(t=>new F.$zs(t.range.startLineNumber-1,t.range.startColumn-1,t.range.endLineNumber-1,t.range.endColumn-1)))})}e.$mJ=M}),define(Pe[283],Re([1,0,162,24,5,6,28,12,16,2,41,75,3,32,8,7,49,221,107,11,26,13,212,282,280]),function(be,e,y,F,P,M,A,$,E,f,C,D,u,b,p,g,t,i,r,c,o,l,n,s,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9ec=void 0;class d{static{this.a=0}get activeNotebookEditor(){return this.k?.apiEditor}get visibleNotebookEditors(){return this.l.map(m=>m.apiEditor)}constructor(m,S,k,h,w,I){this.q=k,this.r=h,this.s=w,this.t=I,this.f=new Map,this.g=new A.$zc,this.h=new Map,this.j=new P.$Rd({onListenerError:c.$1}),this.onDidChangeActiveNotebookEditor=this.j.event,this.l=[],this.m=new P.$Rd({onListenerError:c.$1}),this.onDidOpenNotebookDocument=this.m.event,this.n=new P.$Rd({onListenerError:c.$1}),this.onDidCloseNotebookDocument=this.n.event,this.o=new P.$Rd({onListenerError:c.$1}),this.onDidChangeVisibleNotebookEditors=this.o.event,this.p=new D.$Ddc("NotebookCellStatusBarCache"),this.w=0,this.x=new Map,this.b=m.getProxy(u.$xK.MainThreadNotebook),this.c=m.getProxy(u.$xK.MainThreadNotebookDocuments),this.d=m.getProxy(u.$xK.MainThreadNotebookEditors),this.i=S.converter,S.registerArgumentProcessor({processArgument:L=>{if(L&&L.$mid===13){const V=L.notebookEditor?.notebookUri,K=L.cell.handle,N=this.g.get(V)?.getCell(K);if(N)return N.apiCell}if(L&&L.$mid===14){const V=L.uri,K=this.g.get(V);if(K)return K.apiNotebook}return L}}),d.B(S)}getEditorById(m){const S=this.h.get(m);if(!S)throw new Error(`unknown text editor: ${m}. known editors: ${[...this.h.keys()]} `);return S}getIdByEditor(m){for(const[S,k]of this.h)if(k.apiEditor===m)return S}get notebookDocuments(){return[...this.g.values()]}getNotebookDocument(m,S){const k=this.g.get(m);if(!k&&!S)throw new Error(`NO notebook document for '${m}'`);return k}static u(m,S){if(!S)return;const k=S.filenamePattern.map(h=>p.NotebookExclusiveDocumentPattern.from(h)).filter(h=>h!==void 0);if(S.filenamePattern&&!k){console.warn(`Notebook content provider view options file name pattern is invalid ${S.filenamePattern}`);return}return{extension:m.identifier,providerDisplayName:m.displayName||m.name,displayName:S.displayName,filenamePattern:k,exclusive:S.exclusive||!1}}registerNotebookCellStatusBarItemProvider(m,S,k){const h=d.a++,w=typeof k.onDidChangeCellStatusBarItems=="function"?d.a++:void 0;this.f.set(h,k),this.b.$registerNotebookCellStatusBarItemProvider(h,w,S);let I;return w!==void 0&&(I=k.onDidChangeCellStatusBarItems(L=>this.b.$emitCellStatusBarEvent(w))),new g.$zK(()=>{this.f.delete(h),this.b.$unregisterNotebookCellStatusBarItemProvider(h,w),I?.dispose()})}async createNotebookDocument(m){const S=await this.c.$tryCreateNotebook({viewType:m.viewType,content:m.content&&p.NotebookData.from(m.content)});return f.URI.revive(S)}async openNotebookDocument(m){const S=this.g.get(m);if(S)return S.apiNotebook;const k=await this.c.$tryOpenNotebook(m),h=this.g.get(f.URI.revive(k));return(0,E.$Nf)(h?.apiNotebook)}async showNotebookDocument(m,S){f.URI.isUri(m)&&(m=await this.openNotebookDocument(m));let k;typeof S=="object"?k={position:p.ViewColumn.from(S.viewColumn),preserveFocus:S.preserveFocus,selections:S.selections&&S.selections.map(p.NotebookRange.from),pinned:typeof S.preview=="boolean"?!S.preview:void 0}:k={preserveFocus:!1};const h=await this.d.$tryShowNotebookDocument(m.uri,m.notebookType,k),w=h&&this.h.get(h)?.apiEditor;if(w)return w;throw h?new Error(`Could NOT open editor for "${m.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${m.uri.toString()}".`)}async $provideNotebookCellStatusBarItems(m,S,k,h){const w=this.f.get(m),I=f.URI.revive(S),L=this.g.get(I);if(!L||!w)return;const V=L.getCellFromIndex(k);if(!V)return;const K=await w.provideCellStatusBarItems(V.apiCell,h);if(!K)return;const R=new M.$Qc,N=this.p.add([R]),z=(Array.isArray(K)?K:[K]).map(Z=>p.NotebookStatusBarItem.from(Z,this.i,R));return{cacheId:N,items:z}}$releaseNotebookCellStatusBarItems(m){this.p.delete(m)}registerNotebookSerializer(m,S,k,h,w){if((0,$.$Fe)(S))throw new Error("viewType cannot be empty or just whitespace");const I=this.w++;return this.x.set(I,{viewType:S,serializer:k,options:h}),this.b.$registerNotebookSerializer(I,{id:m.identifier,location:m.extensionLocation},S,p.NotebookDocumentContentOptions.from(h),d.u(m,w)),(0,M.$Pc)(()=>{this.b.$unregisterNotebookSerializer(I)})}async $dataToNotebook(m,S,k){const h=this.x.get(m);if(!h)throw new Error("NO serializer found");const w=await h.serializer.deserializeNotebook(S.buffer,k);return new t.$wv(p.NotebookData.from(w))}async $notebookToData(m,S,k){const h=this.x.get(m);if(!h)throw new Error("NO serializer found");const w=await h.serializer.serializeNotebook(p.NotebookData.to(S.value),k);return F.$fe.wrap(w)}async $saveNotebook(m,S,k,h,w){const I=f.URI.revive(S),L=this.x.get(m);if(!L)throw new Error("NO serializer found");const V=this.g.get(I);if(!V)throw new Error("Document NOT found");if(V.versionId!==k)throw new Error("Document version mismatch");if(!this.s.value.isWritableFileSystem(I.scheme))throw new C.$zk((0,y.localize)(0,null,this.z(I)),6);await this.y(I,h);const K={metadata:(0,o.$in)(V.apiNotebook.metadata,Z=>!(L.options?.transientDocumentMetadata??{})[Z]),cells:[]};for(const Z of V.apiNotebook.getCells()){const he=new g.$XL(Z.kind,Z.document.getText(),Z.document.languageId,Z.mime,L.options?.transientOutputs?[]:[...Z.outputs],Z.metadata,Z.executionSummary);he.metadata=(0,o.$in)(Z.metadata,ye=>!(L.options?.transientCellMetadata??{})[ye]),K.cells.push(he)}const R=await L.serializer.serializeNotebook(K,w);await this.s.value.writeFile(I,R);const N=this.s.getFileSystemProviderExtUri(I.scheme),T=await this.s.value.stat(I);return{name:N.basename(I),isFile:(T.type&C.FileType.File)!==0,isDirectory:(T.type&C.FileType.Directory)!==0,isSymbolicLink:(T.type&C.FileType.SymbolicLink)!==0,mtime:T.mtime,ctime:T.ctime,size:T.size,readonly:!!((T.permissions??0)&C.FilePermission.Readonly)||!this.s.value.isWritableFileSystem(I.scheme),locked:!!((T.permissions??0)&C.FilePermission.Locked),etag:C.$Kk({mtime:T.mtime,size:T.size}),children:void 0}}async $searchInNotebooks(m,S,k,h,w){const I=this.x.get(m)?.serializer;if(!I)return{limitHit:!1,results:[]};const L=new A.$Ac;await(async(T,z,Z)=>{await Promise.all(T.map(async he=>await Promise.all(he.filenamePatterns.map(ye=>{const De={...Z,type:1,filePattern:ye};return this.t.doInternalFileSearchWithCustomCallback(De,z,Se=>{Se.forEach(fe=>{L.has(fe)||h.some(re=>he.isFromSettings&&!re.isFromSettings?!1:re.filenamePatterns.some(Ae=>(0,a.$ucb)(Ae,fe)))||L.add(fe)})})}))))})(k,w,S);const K=new A.$zc;let R=!1;const N=Array.from(L).map(async T=>{const z=[];try{if(w.isCancellationRequested)return;if(S.maxResults&&[...K.values()].reduce((De,Se)=>De+Se.cellResults.length,0)>S.maxResults){R=!0;return}const Z=[],he=this.g.get(T);if(he)he.apiNotebook.getCells().forEach(Se=>Z.push({input:Se.document.getText(),outputs:Se.outputs.flatMap(fe=>fe.items.map($e=>$e.data.toString()))}));else{const De=await this.s.value.readFile(T),Se=F.$fe.fromString(De.toString()),fe=await I.deserializeNotebook(Se.buffer,w);if(w.isCancellationRequested)return;p.NotebookData.from(fe).cells.forEach(re=>Z.push({input:re.source,outputs:re.outputs.flatMap(Ae=>Ae.items.map(se=>se.valueBytes.toString()))}))}if(w.isCancellationRequested)return;Z.forEach((De,Se)=>{const fe=S.contentPattern.pattern,$e=new n.$UOb(De.input,void 0,De.outputs),re=$e.findInInputs(fe),Ae=$e.findInOutputs(fe),se=Ae.flatMap(X=>(0,s.$mJ)(X.matches,X.textBuffer)).map((X,B)=>(X.webviewIndex=B,X));if(re.length>0||Ae.length>0){const X={index:Se,contentResults:(0,s.$mJ)(re,$e.inputTextBuffer),webviewResults:se};z.push(X)}});const ye={resource:T,cellResults:z};K.set(T,ye);return}catch{return}});return await Promise.all(N),{limitHit:R,results:[...K.values()]}}async y(m,S){const k=await this.s.value.stat(m);if(typeof S?.mtime=="number"&&typeof S.etag=="string"&&S.etag!==C.$Jk&&typeof k.mtime=="number"&&typeof k.size=="number"&&S.mtime<k.mtime&&S.etag!==C.$Kk({mtime:S.mtime,size:k.size}))throw new C.$zk((0,y.localize)(1,null),3,S)}z(m){return m.scheme===l.Schemas.file?m.fsPath:m.toString()}A(m,S,k){if(this.h.has(S))throw new Error(`editor with id ALREADY EXSIST: ${S}`);const h=new r.$Zec(S,this.d,m,k.visibleRanges.map(p.NotebookRange.to),k.selections.map(p.NotebookRange.to),typeof k.viewColumn=="number"?p.ViewColumn.to(k.viewColumn):void 0);this.h.set(S,h)}$acceptDocumentAndEditorsDelta(m){if(m.value.removedDocuments)for(const k of m.value.removedDocuments){const h=f.URI.revive(k),w=this.g.get(h);w&&(w.dispose(),this.g.delete(h),this.q.$acceptDocumentsAndEditorsDelta({removedDocuments:w.apiNotebook.getCells().map(I=>I.document.uri)}),this.n.fire(w.apiNotebook));for(const I of this.h.values())I.notebookData.uri.toString()===h.toString()&&this.h.delete(I.id)}if(m.value.addedDocuments){const k=[];for(const h of m.value.addedDocuments){const w=f.URI.revive(h.uri);if(this.g.has(w))throw new Error(`adding EXISTING notebook ${w} `);const I=new i.$Yec(this.c,this.q,this.r,w,h);k.push(...h.cells.map(L=>i.$Xec.asModelAddData(I.apiNotebook,L))),this.g.get(w)?.dispose(),this.g.set(w,I),this.q.$acceptDocumentsAndEditorsDelta({addedDocuments:k}),this.m.fire(I.apiNotebook)}}if(m.value.addedEditors)for(const k of m.value.addedEditors){if(this.h.has(k.id))return;const h=f.URI.revive(k.documentUri),w=this.g.get(h);w&&this.A(w,k.id,k)}const S=[];if(m.value.removedEditors)for(const k of m.value.removedEditors){const h=this.h.get(k);h&&(this.h.delete(k),this.k?.id===h.id&&(this.k=void 0),S.push(h))}if(m.value.visibleEditors){this.l=m.value.visibleEditors.map(h=>this.h.get(h)).filter(h=>!!h);const k=new Set;this.l.forEach(h=>k.add(h.id));for(const h of this.h.values()){const w=k.has(h.id);h._acceptVisibility(w)}this.l=[...this.h.values()].map(h=>h).filter(h=>h.visible),this.o.fire(this.visibleNotebookEditors)}m.value.newActiveEditor===null?this.k=void 0:m.value.newActiveEditor&&(this.h.get(m.value.newActiveEditor)||console.error(`FAILED to find active notebook editor ${m.value.newActiveEditor}`),this.k=this.h.get(m.value.newActiveEditor)),m.value.newActiveEditor!==void 0&&this.j.fire(this.k?.apiEditor)}static B(m){const S=b.$XM.String.with("notebookType","A notebook type"),k=new b.$ZM("vscode.executeDataToNotebook","_executeDataToNotebook","Invoke notebook serializer",[S,new b.$XM("data","Bytes to convert to data",w=>w instanceof Uint8Array,w=>F.$fe.wrap(w))],new b.$YM("Notebook Data",w=>p.NotebookData.to(w.value))),h=new b.$ZM("vscode.executeNotebookToData","_executeNotebookToData","Invoke notebook serializer",[S,new b.$XM("NotebookData","Notebook data to convert to bytes",w=>!0,w=>new t.$wv(p.NotebookData.from(w)))],new b.$YM("Bytes",w=>w.buffer));m.registerApiCommand(k),m.registerApiCommand(h)}}e.$9ec=d}),define(Pe[284],Re([1,0,19,20,39,33,25,60,43]),function(be,e,y,F,P,M,A,$,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1ec=void 0;class f{constructor(u,b,p){this.k=u,this.l=b,this.o=p,this.e=!1,this.f=0,this.g=!1,this.a=u.filePattern,this.b=u.includePattern&&M.$Cj(u.includePattern),this.c=u.maxResults||void 0,this.d=u.exists,this.h=new Set,this.j=u.excludePattern&&M.$Cj(u.excludePattern)}cancel(){this.g=!0,this.h.forEach(u=>u.cancel()),this.h=new Set}search(u){const b=this.k.folderQueries||[];return new Promise((p,g)=>{const t=i=>{this.f++,u(i)};if(this.g)return p({limitHit:this.e});this.k.extraFileResources&&this.k.extraFileResources.forEach(i=>{const r=i.toString(),c=y.$mc(r);this.j&&this.j(r,c)||this.v(t,{base:i,basename:c})}),Promise.all(b.map(i=>this.p(i,t))).then(i=>{p({limitHit:this.e,stats:i[0]||void 0})},i=>{g(new Error((0,P.$Gi)(i)))})})}async p(u,b){const p=new F.$2d,g=this.q(u),t=this.r(),i=new E.$cJ(this.k,u),r=!i.hasSiblingExcludeClauses();let c;try{this.h.add(p),c=$.$Nd.create();const o=await this.l.provideFileSearchResults({pattern:this.k.filePattern||""},g,p.token),l=c.elapsed(),n=$.$Nd.create();return this.g&&!this.e||(o&&o.forEach(s=>{const a=y.$fc.relative(u.folder.path,s.path);if(r){const d=y.$mc(s.path);this.v(b,{base:u.folder,relativePath:a,basename:d});return}this.s(t,u.folder,a,b)}),this.g&&!this.e)?null:(this.u(t,i,b),{providerTime:l,postProcessTime:n.elapsed()})}finally{p.dispose(),this.h.delete(p)}}q(u){const b=(0,E.$bJ)(this.k.includePattern,u.includePattern),p=(0,E.$bJ)(this.k.excludePattern,u.excludePattern);return{folder:u.folder,excludes:p,includes:b,useIgnoreFiles:!u.disregardIgnoreFiles,useGlobalIgnoreFiles:!u.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!u.disregardParentIgnoreFiles,followSymlinks:!u.ignoreSymlinks,maxResults:this.k.maxResults,session:this.o}}r(){const u={rootEntries:[],pathToEntries:Object.create(null)};return u.pathToEntries["."]=u.rootEntries,u}s({pathToEntries:u},b,p,g){if(p===this.a){const i=y.$mc(this.a);this.v(g,{base:b,relativePath:this.a,basename:i})}function t(i){const r=y.$mc(i),c=y.$lc(i);let o=u[c];o||(o=u[c]=[],t(c)),o.push({base:b,relativePath:i,basename:r})}t(p)}u({rootEntries:u,pathToEntries:b},p,g){const t=this,i=this.a;function r(c){const o=(0,E.$eJ)(()=>c.map(l=>l.basename));for(let l=0,n=c.length;l<n;l++){const s=c[l],{relativePath:a,basename:d}=s;if(p.matchesExcludesSync(a,d,i!==d?o:void 0))continue;const v=b[a];if(v)r(v);else{if(a===i)continue;t.v(g,s)}if(t.e)break}}r(u)}v(u,b){(!this.b||b.relativePath&&this.b(b.relativePath,b.basename))&&((this.d||this.c&&this.f>=this.c)&&(this.e=!0,this.cancel()),this.e||u(b))}}class C{constructor(){this.b=new Map}static{this.a=512}fileSearch(u,b,p,g){const t=this.c(u.cacheKey),i=new f(u,b,t&&t.token);let r=0;const c=o=>{r+=o.length,p(o.map(l=>this.d(l)))};return this.e(i,C.a,c,g).then(o=>({limitHit:o.limitHit,stats:{fromCache:!1,type:"fileSearchProvider",resultCount:r,detailStats:o.stats}}))}clearCache(u){this.c(u)?.cancel()}c(u){if(u)return this.b.has(u)||this.b.set(u,new F.$2d),this.b.get(u)}d(u){return u.relativePath?{resource:A.$zg(u.base,u.relativePath)}:{resource:u.base}}e(u,b,p,g){const t=g.onCancellationRequested(()=>{u.cancel()}),i=c=>{c&&(r.push(c),b>0&&r.length>=b&&(p(r),r=[]))};let r=[];return u.search(i).then(c=>(r.length&&p(r),t.dispose(),c),c=>(r.length&&p(r),t.dispose(),Promise.reject(c)))}}e.$1ec=C}),define(Pe[285],Re([1,0,18,246,33,94,28,13,19,25,12,16,2,93,180,40,15,47,105,281,43]),function(be,e,y,F,P,M,A,$,E,f,C,D,u,b,p,g,t,i,r,c,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cK=e.$bK=void 0;let l=class{constructor(w,I,L,V,K){this.a=w,this.b=I,this.c=L,this.d=V,this.e=K}text(w,I,L={}){w=this.f(w,L);const V=this.a.getValue(),K=I&&I.some(N=>!this.a.getValue({resource:N}).search.useRipgrep);return{...this.h(I?.map(i.$ei),L),type:2,contentPattern:w,previewOptions:L.previewOptions,maxFileSize:L.maxFileSize,usePCRE2:V.search.usePCRE2||K||!1,beforeContext:L.beforeContext,afterContext:L.afterContext,userDisabledExcludesAndIgnoreFiles:L.disregardExcludeSettings&&L.disregardIgnoreFiles}}f(w,I){const L=this.a.getValue();w.isRegExp&&(w.pattern=w.pattern.replace(/\r?\n/g,"\\n"));const V={...w,wordSeparators:L.editor.wordSeparators};return this.j(w,I)&&(V.isCaseSensitive=!0),this.k(w)&&(V.isMultiline=!0),I.notebookSearchConfig?.includeMarkupInput&&(V.notebookInfo||(V.notebookInfo={}),V.notebookInfo.isInNotebookMarkdownInput=I.notebookSearchConfig.includeMarkupInput),I.notebookSearchConfig?.includeMarkupPreview&&(V.notebookInfo||(V.notebookInfo={}),V.notebookInfo.isInNotebookMarkdownPreview=I.notebookSearchConfig.includeMarkupPreview),I.notebookSearchConfig?.includeCodeInput&&(V.notebookInfo||(V.notebookInfo={}),V.notebookInfo.isInNotebookCellInput=I.notebookSearchConfig.includeCodeInput),I.notebookSearchConfig?.includeOutput&&(V.notebookInfo||(V.notebookInfo={}),V.notebookInfo.isInNotebookCellOutput=I.notebookSearchConfig.includeOutput),V}file(w,I={}){return{...this.h(w,I),type:1,filePattern:I.filePattern?I.filePattern.trim():I.filePattern,exists:I.exists,sortByScore:I.sortByScore,cacheKey:I.cacheKey}}g(w,I){return w?(w=Array.isArray(w)?w.map(v):v(w),I?this.parseSearchPaths(w):{pattern:s(...Array.isArray(w)?w:[w])}):{}}h(w=[],I={}){const L=this.g(I.includePattern,I.expandPatterns),V=this.g(I.excludePattern,I.expandPatterns),K=w.length>1,R=(L.searchPaths&&L.searchPaths.length?L.searchPaths.map(z=>this.q(z,I,V)):w.map(z=>this.r(z,I,V,K))).filter(z=>!!z),N={_reason:I._reason,folderQueries:R,usingSearchPaths:!!(L.searchPaths&&L.searchPaths.length),extraFileResources:I.extraFileResources,excludePattern:V.pattern,includePattern:L.pattern,onlyOpenEditors:I.onlyOpenEditors,maxResults:I.maxResults};if(I.onlyOpenEditors){const z=y.$Gb(y.$Qb(this.c.groups.map(ye=>ye.editors.map(De=>De.resource))));this.d.trace("QueryBuilder#commonQuery - openEditor URIs",JSON.stringify(z));const Z=z.filter(ye=>(0,o.$5I)(N,ye.fsPath)),he=this.i(Z);return this.d.trace("QueryBuilder#commonQuery - openEditor Query",JSON.stringify(he)),{...N,...he}}const T=I.extraFileResources&&I.extraFileResources.filter(z=>(0,o.$5I)(N,z.fsPath));return N.extraFileResources=T&&T.length?T:void 0,N}i(w){const I=[],L=new A.$zc,V={};let K=!1;return w.forEach(R=>{if(R.scheme===$.Schemas.walkThrough)return;if((0,f.$Dg)(R)){const T=this.b.getWorkspaceFolder(R)?.uri??R.with({path:E.$lc(R.fsPath)});let z=L.get(T);z||(K=!0,z={folder:T,includePattern:{}},I.push(z),L.set(T,z));const Z=E.$kc(T.fsPath,R.fsPath);(0,D.$Nf)(z.includePattern)[Z.replace(/\\/g,"/")]=!0}else R.fsPath&&(K=!0,V[R.fsPath]=!0)}),{folderQueries:I,includePattern:V,usingSearchPaths:!0,excludePattern:K?void 0:{"**/*":!0}}}j(w,I){if(I.isSmartCase){if(w.isRegExp){if(C.$tf(w.pattern,!0))return!0}else if(C.$tf(w.pattern))return!0}return!!w.isCaseSensitive}k(w){return w.isMultiline||w.isRegExp&&(0,b.$BB)(w.pattern)||w.pattern.indexOf(`
`)>=0?!0:!!w.isMultiline}parseSearchPaths(w){const I=he=>E.$hc(he)||/^\.\.?([\/\\]|$)/.test(he),V=(Array.isArray(w)?w:a(w)).map(he=>{const ye=this.e.resolvedUserHome;return ye?(0,M.$Av)(he,ye.scheme===$.Schemas.file?ye.fsPath:ye.path):he}),K=F.$J(V,he=>I(he)?"searchPaths":"exprSegments"),R=(K.exprSegments||[]).map(he=>C.$Oe(he,"/")).map(he=>C.$Oe(he,"\\")).map(he=>(he[0]==="."&&(he="*"+he),d(he))),N={},T=this.m(K.searchPaths||[]);T&&T.length&&(N.searchPaths=T);const z=y.$Qb(R),Z=s(...z);return Z&&(N.pattern=Z),N}l(w,I){return I.disregardExcludeSettings?void 0:(0,o.$4I)(w,!I.disregardSearchExcludeSettings)}m(w){if(!w||!w.length)return[];const I=w.flatMap(V=>{let{pathPortion:K,globPortion:R}=n(V);return R&&(R=m(R)),this.n(K).flatMap(T=>this.o(T,R))}),L=new Map;return I.forEach(V=>{const K=V.searchPath.toString(),R=L.get(K);R?V.pattern&&(R.pattern=R.pattern||{},R.pattern[V.pattern]=!0):L.set(K,{searchPath:V.searchPath,pattern:V.pattern?s(V.pattern):void 0})}),Array.from(L.values())}n(w){if(E.$hc(w)){const I=this.b.getWorkspace().folders;return I[0]&&I[0].uri.scheme!==$.Schemas.file?[{searchPath:I[0].uri.with({path:w})}]:[{searchPath:u.URI.file(E.$gc(w))}]}if(this.b.getWorkbenchState()===2){const I=this.b.getWorkspace().folders[0].uri;if(w=v(w),w.startsWith("../")||w===".."){const V=E.$fc.resolve(I.path,w);return[{searchPath:I.with({path:V})}]}const L=m(w);return[{searchPath:I,pattern:L}]}else{if(w==="./"||w===".\\")return[];{const I=w.replace(/^\.[\/\\]/,""),V=this.b.getWorkspace().folders.map(K=>{const R=I.match(new RegExp(`^${C.$Je(K.name)}(?:/(.*)|$)`));return R?{match:R,folder:K}:null}).filter(D.$Kf);if(V.length)return V.map(K=>{const R=K.match[1];return{searchPath:K.folder.uri,pattern:R&&m(R)}});{const K=w.match(/\.[\/\\](.+)[\/\\]?/),R=K?K[1]:w,N=p.localize(0,null,R);throw new Error(N)}}}}o(w,I){const L=w.pattern&&I?`${w.pattern}/${I}`:w.pattern||I,V=[{searchPath:w.searchPath,pattern:L}];return L&&!L.endsWith("**")&&V.push({searchPath:w.searchPath,pattern:L+"/**"}),V}q(w,I,L){const V=this.r((0,i.$ei)(w.searchPath),I,L,!1);return V?{...V,includePattern:w.pattern}:null}r(w,I,L,V){let K;const R=u.URI.isUri(w)?w:w.uri;if(L.searchPaths){const he=L.searchPaths.filter(ye=>(0,f.$sg)(ye.searchPath,R))[0];if(he&&!he.pattern)return null;he&&(K=he.pattern)}const N=this.a.getValue({resource:R}),z={...this.l(N,I)||{},...K||{}},Z=u.URI.isUri(w)?(0,f.$wg)(w):w.name;return{folder:R,folderName:V?Z:void 0,excludePattern:Object.keys(z).length>0?z:void 0,fileEncoding:N.files&&N.files.encoding,disregardIgnoreFiles:typeof I.disregardIgnoreFiles=="boolean"?I.disregardIgnoreFiles:!N.search.useIgnoreFiles,disregardGlobalIgnoreFiles:typeof I.disregardGlobalIgnoreFiles=="boolean"?I.disregardGlobalIgnoreFiles:!N.search.useGlobalIgnoreFiles,disregardParentIgnoreFiles:typeof I.disregardParentIgnoreFiles=="boolean"?I.disregardParentIgnoreFiles:!N.search.useParentIgnoreFiles,ignoreSymlinks:typeof I.ignoreSymlinks=="boolean"?I.ignoreSymlinks:!N.search.followSymlinks}}};e.$bK=l,e.$bK=l=Ke([Ve(0,g.$pi),Ve(1,i.$5h),Ve(2,r.$FC),Ve(3,t.$dj),Ve(4,c.$_J)],l);function n(h){const w=h.match(/[\*\{\}\(\)\[\]\?]/);if(w){const I=w.index,L=h.substr(0,I).match(/[/|\\][^/\\]*$/);if(L){let V=h.substr(0,L.index);return V.match(/[/\\]/)||(V+="/"),{pathPortion:V,globPortion:h.substr((L.index||0)+1)}}}return{pathPortion:h}}function s(...h){return h.length?h.reduce((w,I)=>(w[I]=!0,w),Object.create(null)):void 0}function a(h){return P.$Aj(h,",").map(w=>w.trim()).filter(w=>!!w.length)}function d(h){return[`**/${h}/**`,`**/${h}`].map(I=>I.replace(/\*\*\/\*\*/g,"**"))}function v(h){return h.replace(/\\/g,"/")}function m(h){return v(h).replace(/^\.\//,"").replace(/\/+$/g,"")}function S(h){return h.replace(/([?*[\]])/g,"[$1]")}function k(h,w){h=y.$Lb(h,V=>V.toString());const I=[],L=w.getWorkspace();return h&&h.forEach(V=>{let K;if(w.getWorkbenchState()===2)K=(0,f.$Bg)(L.folders[0].uri,V),K&&K!=="."&&(K="./"+K);else{const R=w.getWorkspaceFolder(V);if(R){const N=R.name;if(L.folders.filter(z=>z.name===N).length===1){const z=(0,f.$Bg)(R.uri,V);z===""?K=`./${R.name}`:K=`./${R.name}/${z}`}else K=V.fsPath}}K&&I.push(S(K))}),I}e.$cK=k}),define(Pe[286],Re([1,0,25,2,20,11,4,285,43,47]),function(be,e,y,F,P,M,A,$,E,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7qb=e.$6qb=void 0;const C=7e3;function D(g,t){const i=t.activationEvents;if(!i)return Promise.resolve(void 0);const r=[],c=[];for(const d of i)if(/^workspaceContains:/.test(d)){const v=d.substr(18);v.indexOf("*")>=0||v.indexOf("?")>=0||g.forceUsingSearch?c.push(v):r.push(v)}if(r.length===0&&c.length===0)return Promise.resolve(void 0);let o;const l=new Promise((d,v)=>{o=d}),n=d=>o({activationEvent:d}),s=Promise.all(r.map(d=>u(g,d,n))).then(()=>{}),a=b(g,t.identifier,c,n);return Promise.all([s,a]).then(()=>{o(void 0)}),l}e.$6qb=D;async function u(g,t,i){for(const r of g.folders)if(await g.exists(y.$zg(F.URI.revive(r),t))){i(`workspaceContains:${t}`);return}}async function b(g,t,i,r){if(i.length===0)return Promise.resolve(void 0);const c=new P.$2d,o=g.checkExists(g.folders,i,c.token),l=setTimeout(async()=>{c.cancel(),g.logService.info(`Not activating extension '${t.value}': Timed out while searching for 'workspaceContains' pattern ${i.join(",")}`)},C);let n=!1;try{n=await o}catch(s){M.$3(s)||M.$Z(s)}c.dispose(),clearTimeout(l),n&&r(`workspaceContains:${i.join(",")}`)}function p(g,t,i,r){const c=g.get(A.$Uh),o=g.get(E.$VI),n=c.createInstance($.$bK).file(t.map(s=>(0,f.$ei)(F.URI.revive(s))),{_reason:"checkExists",includePattern:i,exists:!0});return o.fileSearch(n,r).then(s=>!!s.limitHit,s=>M.$3(s)?!1:Promise.reject(s))}e.$7qb=p}),define(Pe[37],Re([1,0,159,19,88,25,14,6,50,2,15,3,36,218,85,35,23,106,11,22,24,201,7,100,4,27,86,17,71,87,64,5,286,84,203,13,82,60,21,83]),function(be,e,y,F,P,M,A,$,E,f,C,D,u,b,p,g,t,i,r,c,o,l,n,s,a,d,v,m,S,k,h,w,I,L,V,K,R,N,T,z){"use strict";var Z;Object.defineProperty(e,"__esModule",{value:!0}),e.$Gec=e.$Fec=e.$Eec=e.$Dec=e.$Cec=void 0,e.$Cec=(0,a.$Vh)("IHostUtils");let he=Z=class extends $.$Rc{constructor(X,B,ie,pe,ne,le,ce,we,_,de,te,ae){super(),this.X=ae,this.a=this.B(new w.$Rd),this.onDidChangeRemoteConnectionData=this.a.event,this.U=!1,this.c=B,this.g=ie,this.f=ce,this.j=pe,this.m=ne,this.s=le,this.t=_,this.u=de,this.w=te,this.y=this.g.getProxy(D.$xK.MainThreadWorkspace),this.z=this.g.getProxy(D.$xK.MainThreadTelemetry),this.C=this.g.getProxy(D.$xK.MainThreadExtensionService),this.D=new A.$Wg,this.F=new A.$Wg,this.G=new A.$Wg,this.H=new A.$Wg,this.I=new Ae(this.f.extensions.activationEvents),this.L=new i.$T5b(this.I,this.f.extensions.allExtensions);const me=new c.$am(this.f.extensions.myExtensions);this.J=new i.$T5b(this.I,$e(this.L,me)),T.$t&&(this.s.info(`Creating extension host with the following global extensions: ${Se(this.L)}`),this.s.info(`Creating extension host with the following local extensions: ${Se(this.J)}`)),this.M=new p.$nec(this.g,this.s),this.N=new L.$vec(this.g),this.O=we,this.h=X.createChild(new S.$Th([p.$oec,this.M],[L.$wec,this.N])),this.P=this.B(new b.$mec(this.J,this.L,{onExtensionActivationError:(Ie,O,W)=>{this.C.$onExtensionActivationError(Ie,r.$2(O),W)},actualActivateExtension:async(Ie,O)=>{if(i.$T5b.isHostExtension(Ie,this.J,this.L))return await this.C.$activateExtension(Ie,O),new b.$lec;const W=this.J.getExtensionDescription(Ie);return this.db(W,O)}},this.s)),this.Q=null,this.R=Object.create(null),this.S=!1,this.W=this.f.remote.connectionData}getRemoteConnectionData(){return this.W}async initialize(){try{await this.tb(),this.D.open(),await this.j.waitForInitializeCall(),P.mark("code/extHost/ready"),this.F.open(),this.f.autoStart&&this.rb()}catch(X){r.$Z(X)}}async Y(){this.O.onWillDeactivateAll();let X=[];try{X=this.J.getAllExtensionDescriptions().map(ne=>ne.identifier).filter(ne=>this.isActivated(ne)).map(ne=>this.cb(ne))}catch{}await Promise.all(X)}terminate(X,B=0){if(this.U)return;this.U=!0,this.s.info(`Extension host terminating: ${X}`),this.s.flush(),this.u.dispose(),this.P.dispose(),r.setUnexpectedErrorHandler(pe=>{this.s.error(pe)}),this.g.dispose();const ie=this.Y();Promise.race([(0,A.$Yg)(5e3),ie]).finally(()=>{this.c.pid?this.s.info(`Extension host with pid ${this.c.pid} exiting with code ${B}`):this.s.info(`Extension host exiting with code ${B}`),this.s.flush(),this.s.dispose(),this.c.exit(B)})}isActivated(X){return this.G.isOpen()?this.P.isActivated(X):!1}async getExtension(X){const B=await this.C.$getExtension(X);return B&&{...B,identifier:new c.$_l(B.identifier.value),extensionLocation:f.URI.revive(B.extensionLocation)}}Z(X,B){return this.P.activateByEvent(X,B)}$(X,B){return this.P.activateById(X,B)}activateByIdWithErrors(X,B){return this.$(X,B).then(()=>{const ie=this.P.getActivatedExtension(X);if(ie.activationFailed)return Promise.reject(ie.activationFailedError)})}getExtensionRegistry(){return this.G.wait().then(X=>this.J)}getExtensionExports(X){if(this.G.isOpen())return this.P.getActivatedExtension(X).exports;try{return this.P.getActivatedExtension(X).exports}catch{return null}}async ab(X){if(X.scheme===K.Schemas.file&&this.c.fsRealpath){const B=await this.c.fsRealpath(X.fsPath);return f.URI.file(B)}return X}async getExtensionPathIndex(){return this.Q||(this.Q=this.bb(this.J.getAllExtensionDescriptions()).then(X=>new re(X))),this.Q}async bb(X){const B=E.$2h.forUris(ie=>M.$qg.ignorePathCasing(ie));return await Promise.all(X.map(async ie=>{if(this.ub(ie)){const pe=await this.ab(ie.extensionLocation);B.set(pe,ie)}})),B}cb(X){let B=Promise.resolve(void 0);if(!this.G.isOpen()||!this.P.isActivated(X))return B;const ie=this.P.getActivatedExtension(X);if(!ie)return B;try{typeof ie.module.deactivate=="function"&&(B=Promise.resolve(ie.module.deactivate()).then(void 0,pe=>(this.s.error(pe),Promise.resolve(void 0))))}catch(pe){this.s.error(`An error occurred when deactivating the extension '${X.value}':`),this.s.error(pe)}try{(0,$.$Mc)(ie.subscriptions)}catch(pe){this.s.error(`An error occurred when deactivating the subscriptions for extension '${X.value}':`),this.s.error(pe)}return B}async db(X,B){return this.f.remote.isRemote?this.C.$onWillActivateExtension(X.identifier):await this.C.$onWillActivateExtension(X.identifier),this.fb(X,B).then(ie=>{const pe=ie.activationTimes;return this.C.$onDidActivateExtension(X.identifier,pe.codeLoadingTime,pe.activateCallTime,pe.activateResolvedTime,B),this.eb(X,B,"success",pe),ie},ie=>{throw this.eb(X,B,"failure"),ie})}eb(X,B,ie,pe){const ne=De(X,B);this.z.$publicLog2("extensionActivationTimes",{...ne,...pe||{},outcome:ie})}fb(X,B){const ie=De(X,B);this.z.$publicLog2("activatePlugin",ie);const pe=this.ub(X);if(!pe)return Promise.resolve(new b.$kec(b.$hec.NONE));this.s.info(`ExtensionService#_doActivateExtension ${X.identifier.value}, startup: ${B.startup}, activationEvent: '${B.activationEvent}'${X.identifier.value!==B.extensionId.value?`, root cause: ${B.extensionId.value}`:""}`),this.s.flush();const ne=new b.$iec(B.startup);return Promise.all([this.vb(X,(0,M.$zg)(X.extensionLocation,pe),ne),this.gb(X)]).then(le=>(P.mark(`code/extHost/willActivateExtension/${X.identifier.value}`),Z.hb(this.s,X.identifier,le[0],le[1],ne))).then(le=>(P.mark(`code/extHost/didActivateExtension/${X.identifier.value}`),le))}gb(X){const B=new l.$qec(X,this.M),ie=new l.$pec(X.identifier.value,!1,this.M),pe=new V.$xec(X,this.N),ne=X.isUnderDevelopment?this.f.environment.extensionTestsLocationURI?n.ExtensionMode.Test:n.ExtensionMode.Development:n.ExtensionMode.Production,le=this.f.remote.isRemote?n.ExtensionKind.Workspace:n.ExtensionKind.UI;return this.s.trace(`ExtensionService#loadExtensionContext ${X.identifier.value}`),Promise.all([B.whenReady,ie.whenReady,this.O.whenReady]).then(()=>{const ce=this;let we,_;const de=(0,t.$LF)(X,"ipc")?this.f.messagePorts?.get(c.$_l.toKey(X.identifier)):void 0;return Object.freeze({globalState:B,workspaceState:ie,secrets:pe,subscriptions:[],get extensionUri(){return X.extensionLocation},get extensionPath(){return X.extensionLocation.fsPath},asAbsolutePath(te){return F.$ic(X.extensionLocation.fsPath,te)},get storagePath(){return ce.O.workspaceValue(X)?.fsPath},get globalStoragePath(){return ce.O.globalValue(X).fsPath},get logPath(){return F.$ic(ce.f.logsLocation.fsPath,X.identifier.value)},get logUri(){return f.URI.joinPath(ce.f.logsLocation,X.identifier.value)},get storageUri(){return ce.O.workspaceValue(X)},get globalStorageUri(){return ce.O.globalValue(X)},get extensionMode(){return ne},get extension(){return we===void 0&&(we=new fe(ce,X.identifier,X,le,!1)),we},get extensionRuntime(){return(0,t.$MF)(X,"extensionRuntime"),ce.extensionRuntime},get environmentVariableCollection(){return ce.u.getEnvironmentVariableCollection(X)},get messagePassingProtocol(){if(!_){if(!de)return;const te=w.Event.buffer(w.Event.fromDOMEventEmitter(de,"message",ae=>ae.data));de.start(),_={onDidReceiveMessage:te,postMessage:de.postMessage.bind(de)}}return _}})})}static hb(X,B,ie,pe,ne){return ie=ie||{activate:void 0,deactivate:void 0},this.ib(X,B,ie,pe,ne).then(le=>new b.$jec(!1,null,ne.build(),ie,le,pe.subscriptions))}static ib(X,B,ie,pe,ne){if(typeof ie.activate=="function")try{ne.activateCallStart(),X.trace(`ExtensionService#_callActivateOptional ${B.value}`);const le=typeof global=="object"?global:self,ce=ie.activate.apply(le,[pe]);return ne.activateCallStop(),ne.activateResolveStart(),Promise.resolve(ce).then(we=>(ne.activateResolveStop(),we))}catch(le){return Promise.reject(le)}else return Promise.resolve(ie)}jb(X,B){this.$(X.identifier,{startup:!1,extensionId:X.identifier,activationEvent:B}).then(void 0,ie=>{this.s.error(ie)})}kb(X,B=0){const pe=Date.now();(0,T.$B)(()=>{for(let ne=B;ne<X.length;ne+=1){const le=X[ne];for(const ce of le.activationEvents??[])if(ce==="onStartupFinished")if(Date.now()-pe>50){this.kb(X,ne);break}else this.jb(le,ce)}})}lb(){this.C.$setPerformanceMarks(P.getMarks()),this.m.getConfigProvider().then(X=>{const B=X.getConfiguration("extensions.experimental").get("deferredStartupFinishedActivation"),ie=this.J.getAllExtensionDescriptions();if(B)this.kb(ie);else for(const pe of ie)if(pe.activationEvents)for(const ne of pe.activationEvents)ne==="onStartupFinished"&&this.jb(pe,ne)})}mb(){const X=this.Z("*",!0).then(void 0,le=>{this.s.error(le)});this.B(this.j.onDidChangeWorkspace(le=>this.nb(le.added)));const B=this.j.workspace?this.j.workspace.folders:[],ie=this.nb(B),pe=this.pb(),ne=Promise.all([pe,X,ie]).then(()=>{});return Promise.race([ne,(0,A.$Yg)(1e4)]).then(()=>{this.lb()}),ne}nb(X){return X.length===0?Promise.resolve(void 0):Promise.all(this.J.getAllExtensionDescriptions().map(B=>this.ob(X,B))).then(()=>{})}async ob(X,B){if(this.isActivated(B.identifier))return;const ie=!this.f.remote.isRemote&&!!this.f.remote.authority,pe={logService:this.s,folders:X.map(le=>le.uri),forceUsingSearch:ie||!this.c.fsExists,exists:le=>this.c.fsExists(le.fsPath),checkExists:(le,ce,we)=>this.y.$checkExists(le,ce,we)},ne=await(0,I.$6qb)(pe,B);if(ne)return this.$(B.identifier,{startup:!0,extensionId:B.identifier,activationEvent:ne.activationEvent}).then(void 0,le=>this.s.error(le))}async pb(){if(this.f.remote.authority)return this.Z(`onResolveRemoteAuthority:${this.f.remote.authority}`,!1)}async $extensionTestsExecute(){await this.H.wait();try{return await this.qb()}catch(X){throw console.error(X),X}}async qb(){const{extensionDevelopmentLocationURI:X,extensionTestsLocationURI:B}=this.f.environment;if(!X||!B)throw new Error(y.localize(0,null));const ie=await this.vb(null,B,new b.$iec(!1));if(!ie||typeof ie.run!="function")throw new Error(y.localize(1,null,B.toString()));return new Promise((pe,ne)=>{const le=(_,de)=>{_?(T.$t&&this.s.error("Test runner called back with error",_),ne(_)):(T.$t&&(de?this.s.info(`Test runner called back with ${de} failures.`):this.s.info("Test runner called back with successful outcome.")),pe(typeof de=="number"&&de>0?1:0))},ce=(0,M.$ng)(B),we=ie.run(ce,le);we&&we.then&&we.then(()=>{T.$t&&this.s.info("Test runner finished successfully."),pe(0)}).catch(_=>{T.$t&&this.s.error("Test runner finished with error",_),ne(_ instanceof Error&&_.stack?_.stack:String(_))})})}rb(){if(this.S)throw new Error("Extension host is already started!");return this.S=!0,this.F.wait().then(()=>this.G.open()).then(()=>Promise.race([this.P.waitForActivatingExtensions(),(0,A.$Yg)(1e3)])).then(()=>this.mb()).then(()=>{this.H.open(),this.s.info("Eager extensions activated")})}registerRemoteAuthorityResolver(X,B){return this.R[X]=B,(0,$.$Pc)(()=>{delete this.R[X]})}async getRemoteExecServer(X){const{resolver:B}=await this.sb(X);return B?.resolveExecServer?.(X,{resolveAttempt:0})}async sb(X){const B=X.indexOf("+");if(B===-1)throw new n.$FK("Not an authority that can be resolved!",s.RemoteAuthorityResolverErrorCode.InvalidAuthority);const ie=X.substr(0,B);return await this.D.wait(),await this.Z(`onResolveRemoteAuthority:${ie}`,!1),{authorityPrefix:ie,resolver:this.R[ie]}}async $resolveAuthority(X,B){const ie=N.$Nd.create(!1),pe=()=>`[resolveAuthority(${(0,s.$Zk)(X)},${B})][${ie.elapsed()}ms] `,ne=J=>this.s.info(`${pe()}${J}`),le=J=>this.s.warn(`${pe()}${J}`),ce=(J,q=void 0)=>this.s.error(`${pe()}${J}`,q),we=J=>{if(J instanceof n.$FK)return{type:"error",error:{code:J._code,message:J._message,detail:J._detail}};throw J},_=async J=>{ne(`activating resolver for ${J}...`);const{resolver:q,authorityPrefix:x}=await this.sb(J);if(!q)throw ce(`no resolver for ${x}`),new n.$FK(`No remote extension installed to resolve ${x}.`,s.RemoteAuthorityResolverErrorCode.NoResolverFound);return{resolver:q,authorityPrefix:x,remoteAuthority:J}},de=X.split(/@|%40/g).reverse();ne(`activating remote resolvers ${de.join(" -> ")}`);let te;try{te=await Promise.all(de.map(_)).catch(async J=>{if(!(J instanceof n.$FK)||J._code!==s.RemoteAuthorityResolverErrorCode.InvalidAuthority)throw J;return le(`resolving nested authorities failed: ${J.message}`),[await _(X)]})}catch(J){return we(J)}const ae=new A.$9g;ae.cancelAndSet(()=>ne("waiting..."),1e3);let me,Ie;for(const[J,{authorityPrefix:q,resolver:x,remoteAuthority:ue}]of te.entries())try{if(J===te.length-1)ne("invoking final resolve()..."),P.mark(`code/extHost/willResolveAuthority/${q}`),me=await x.resolve(ue,{resolveAttempt:B,execServer:Ie}),P.mark(`code/extHost/didResolveAuthorityOK/${q}`),ne("setting tunnel factory..."),this.B(await this.t.setTunnelFactory(x,n.$EK.isManagedResolvedAuthority(me)?me:void 0));else{if(ne(`invoking resolveExecServer() for ${ue}`),P.mark(`code/extHost/willResolveExecServer/${q}`),Ie=await x.resolveExecServer?.(ue,{resolveAttempt:B,execServer:Ie}),!Ie)throw new n.$FK(`Exec server was not available for ${ue}`,s.RemoteAuthorityResolverErrorCode.NoResolverFound);P.mark(`code/extHost/didResolveExecServerOK/${q}`)}}catch(Oe){return P.mark(`code/extHost/didResolveAuthorityError/${q}`),ce("returned an error",Oe),ae.dispose(),we(Oe)}ae.dispose();const O={environmentTunnels:me.environmentTunnels,features:me.tunnelFeatures},W={extensionHostEnv:me.extensionHostEnv,isTrusted:me.isTrusted,authenticationSession:me.authenticationSessionForInitializingExtensions?{id:me.authenticationSessionForInitializingExtensions.id,providerId:me.authenticationSessionForInitializingExtensions.providerId}:void 0};ne(`returned ${n.$EK.isManagedResolvedAuthority(me)?"managed authority":`${me.host}:${me.port}`}`);let G;if(n.$EK.isManagedResolvedAuthority(me)){const J=B;this.X.setFactory(J,me.makeConnection),G={authority:X,connectTo:new s.$Wk(J),connectionToken:me.connectionToken}}else G={authority:X,connectTo:new s.$Xk(me.host,me.port),connectionToken:me.connectionToken};return{type:"ok",value:{authority:G,options:W,tunnelInformation:O}}}async $getCanonicalURI(X,B){this.s.info(`$getCanonicalURI invoked for authority (${(0,s.$Zk)(X)})`);const{resolver:ie}=await this.sb(X);if(!ie)return null;const pe=f.URI.revive(B);if(typeof ie.getCanonicalURI>"u")return pe;const ne=await(0,A.$Qg)(()=>ie.getCanonicalURI(pe));return ne||pe}$startExtensionHost(X){X.toAdd.forEach(pe=>pe.extensionLocation=f.URI.revive(pe.extensionLocation));const{globalRegistry:B,myExtensions:ie}=ye(this.I,this.L,this.J,X);return this.L.set(B.getAllExtensionDescriptions()),this.J.set(ie),T.$t&&(this.s.info(`$startExtensionHost: global extensions: ${Se(this.L)}`),this.s.info(`$startExtensionHost: local extensions: ${Se(this.J)}`)),this.rb()}$activateByEvent(X,B){return B===1?this.D.wait().then(ie=>this.Z(X,!1)):this.G.wait().then(ie=>this.Z(X,!1))}async $activate(X,B){return await this.G.wait(),this.J.getExtensionDescription(X)?(await this.$(X,B),!0):!1}async $deltaExtensions(X){X.toAdd.forEach(le=>le.extensionLocation=f.URI.revive(le.extensionLocation));const{globalRegistry:B,myExtensions:ie}=ye(this.I,this.L,this.J,X),pe=await this.bb(ie);return(await this.getExtensionPathIndex()).setSearchTree(pe),this.L.set(B.getAllExtensionDescriptions()),this.J.set(ie),T.$t&&(this.s.info(`$deltaExtensions: global extensions: ${Se(this.L)}`),this.s.info(`$deltaExtensions: local extensions: ${Se(this.J)}`)),Promise.resolve(void 0)}async $test_latency(X){return X}async $test_up(X){return X.byteLength}async $test_down(X){const B=o.$fe.alloc(X),ie=Math.random()%256;for(let pe=0;pe<X;pe++)B.writeUInt8(ie,pe);return B}async $updateRemoteConnectionData(X){this.W=X,this.a.fire()}};e.$Dec=he,e.$Dec=he=Z=Ke([Ve(0,a.$Uh),Ve(1,e.$Cec),Ve(2,m.$zM),Ve(3,g.$3dc),Ve(4,u.$6dc),Ve(5,C.$dj),Ve(6,d.$PM),Ve(7,v.$9dc),Ve(8,k.$Rwb),Ve(9,h.$rec),Ve(10,R.$zec),Ve(11,z.$Aec)],he);function ye(se,X,B,ie){se.addActivationEvents(ie.addActivationEvents);const pe=new i.$T5b(se,X.getAllExtensionDescriptions());pe.deltaExtensions(ie.toAdd,ie.toRemove);const ne=new c.$am(B.getAllExtensionDescriptions().map(ce=>ce.identifier));for(const ce of ie.myToRemove)ne.delete(ce);for(const ce of ie.myToAdd)ne.add(ce);const le=$e(pe,ne);return{globalRegistry:pe,myExtensions:le}}function De(se,X){return{id:se.identifier.value,name:se.name,extensionVersion:se.version,publisherDisplayName:se.publisher,activationEvents:se.activationEvents?se.activationEvents.join(","):null,isBuiltin:se.isBuiltin,reason:X.activationEvent,reasonId:X.extensionId.value}}function Se(se){return se.getAllExtensionDescriptions().map(X=>X.identifier.value).join(",")}e.$Eec=(0,a.$Vh)("IExtHostExtensionService");class fe{#e;#t;#i;constructor(X,B,ie,pe,ne){this.#e=X,this.#t=B,this.#i=ie.identifier,this.id=ie.identifier.value,this.extensionUri=ie.extensionLocation,this.extensionPath=F.$gc((0,M.$ng)(ie.extensionLocation)),this.packageJSON=ie,this.extensionKind=pe,this.isFromDifferentExtensionHost=ne}get isActive(){return this.#e.isActivated(this.#i)}get exports(){if(!(this.packageJSON.api==="none"||this.isFromDifferentExtensionHost))return this.#e.getExtensionExports(this.#i)}async activate(){if(this.isFromDifferentExtensionHost)throw new Error("Cannot activate foreign extension");return await this.#e.activateByIdWithErrors(this.#i,{startup:!1,extensionId:this.#t,activationEvent:"api"}),this.exports}}e.$Fec=fe;function $e(se,X){return se.getAllExtensionDescriptions().filter(B=>X.has(B.identifier))}class re{constructor(X){this.a=X}setSearchTree(X){this.a=X}findSubstr(X){return this.a.findSubstr(X)}forEach(X){return this.a.forEach(X)}}e.$Gec=re;class Ae{constructor(X){this.a=new c.$bm,this.addActivationEvents(X)}readActivationEvents(X){return this.a.get(X.identifier)??[]}addActivationEvents(X){for(const B of Object.keys(X))this.a.set(B,X[B])}}}),define(Pe[287],Re([1,0,88,2,3,36,23,22,17,27,4,37,15,12]),function(be,e,y,F,P,M,A,$,E,f,C,D,u,b){"use strict";var p;Object.defineProperty(e,"__esModule",{value:!0}),e.$Ofc=void 0;let g=class{constructor(o,l,n,s,a,d,v){this.c=o,this.d=l,this.e=n,this.f=s,this.g=a,this.h=d,this.i=v,this.a=new Map,this.b=[]}async install(){this.j(),y.mark("code/extHost/willWaitForConfig");const o=await this.f.getConfigProvider();y.mark("code/extHost/didWaitForConfig");const l=await this.g.getExtensionPathIndex();this.register(new i(this.c,l,this.d,o,this.i)),this.register(this.e.createInstance(t)),this.h.remote.isRemote&&this.register(this.e.createInstance(r,l,this.h.environment.appUriScheme))}register(o){if("nodeModuleName"in o)if(Array.isArray(o.nodeModuleName))for(const l of o.nodeModuleName)this.a.set(l,o);else this.a.set(o.nodeModuleName,o);typeof o.alternativeModuleName=="function"&&this.b.push(l=>o.alternativeModuleName(l))}};e.$Ofc=g,e.$Ofc=g=Ke([Ve(2,C.$Uh),Ve(3,M.$6dc),Ve(4,D.$Eec),Ve(5,f.$PM),Ve(6,u.$dj)],g);let t=class{static{p=this}static{this.a=new Map([["vscode-ripgrep","@vscode/ripgrep"],["vscode-windows-registry","@vscode/windows-registry"]])}constructor(o){if(o.environment.appRoot&&p.a.size){const l=(0,b.$Je)(this.c(o.environment.appRoot.fsPath)),n="[a-z0-9_.-]",s=`@${n}+\\/${n}+|${n}+`,a="node_modules|node_modules\\.asar(?:\\.unpacked)?";this.b=new RegExp(`^(${l}/${a}\\/)(${s})(.*)$`,"i")}}alternativeModuleName(o){if(!this.b)return;const l=this.b.exec(this.c(o));if(!l)return;const[,n,s,a]=l,d=p.a.get(s);if(d!==void 0)return console.warn(`${s} as been renamed to ${d}, please update your imports`),n+d+a}c(o){return o.replace(/\\/g,"/")}};t=p=Ke([Ve(0,f.$PM)],t);class i{constructor(o,l,n,s,a){this.c=o,this.d=l,this.e=n,this.f=s,this.g=a,this.nodeModuleName="vscode",this.a=new $.$bm}load(o,l){const n=this.d.findSubstr(l);if(n){let s=this.a.get(n.identifier);return s||(s=this.c(n,this.e,this.f),this.a.set(n.identifier,s)),s}if(!this.b){let s="";this.d.forEach((a,d)=>s+=`	${d} -> ${a.identifier.value}
`),this.g.warn(`Could not identify extension for 'vscode' require call from ${l}. These are the extension path mappings: 
${s}`),this.b=this.c(A.$GF,this.e,this.f)}return this.b}}let r=class{constructor(o,l,n){this.e=o,this.f=l,this.nodeModuleName=["open","opn"],this.d=n.getProxy(P.$xK.MainThreadTelemetry);const s=n.getProxy(P.$xK.MainThreadWindow);this.c=(a,d)=>{const v=F.URI.parse(a);return d?this.g(a,d):v.scheme==="http"||v.scheme==="https"?s.$openUri(v,a,{allowTunneling:!0}):v.scheme==="mailto"||v.scheme===this.f?s.$openUri(v,a,{}):this.g(a,d)}}load(o,l,n){const s=this.e.findSubstr(l);return s&&(this.a=s.identifier.value,this.h()),this.b=n(o),this.c}g(o,l){return this.i(),this.b(o,l)}h(){this.a&&this.d.$publicLog2("shimming.open",{extension:this.a})}i(){this.a&&this.d.$publicLog2("shimming.open.call.noForward",{extension:this.a})}};r=Ke([Ve(2,E.$zM)],r)}),define(Pe[116],Re([1,0,44,6,19,74,4,61,62,37,7,35,215,36]),function(be,e,y,F,P,M,A,$,E,f,C,D,u,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Iec=e.$Hec=void 0,e.$Hec=(0,A.$Vh)("IExtHostVariableResolverProvider");class p extends u.$AN{constructor(i,r,c,o,l,n,s){function a(){if(c){const d=c.activeEditor();if(d)return d.document.uri;const v=o.tabGroups.all.find(m=>m.isActive)?.activeTab;if(v!==void 0){if(v.input instanceof C.$fM||v.input instanceof C.$kM)return v.input.modified;if(v.input instanceof C.$eM||v.input instanceof C.$jM||v.input instanceof C.$hM)return v.input.uri}}}super({getFolderUri:d=>{const v=n.folders.filter(m=>m.name===d);if(v&&v.length>0)return v[0].uri},getWorkspaceFolderCount:()=>n.folders.length,getConfigurationValue:(d,v)=>l.getConfiguration(void 0,d).get(v),getAppRoot:()=>M.cwd(),getExecPath:()=>M.env.VSCODE_EXEC_PATH,getFilePath:()=>{const d=a();if(d)return P.$gc(d.fsPath)},getWorkspaceFolderPathForFile:()=>{if(r){const d=a();if(d){const v=r.getWorkspaceFolder(d);if(v)return P.$gc(v.uri.fsPath)}}},getSelectedText:()=>{if(c){const d=c.activeEditor();if(d&&!d.selection.isEmpty)return d.document.getText(d.selection)}},getLineNumber:()=>{if(c){const d=c.activeEditor();if(d)return String(d.selection.end.line+1)}},getExtension:d=>i.getExtension(d)},void 0,s?Promise.resolve(s):void 0,Promise.resolve(M.env))}}let g=class extends F.$Rc{constructor(i,r,c,o,l){super(),this.b=i,this.c=r,this.g=c,this.h=o,this.j=l,this.a=new y.$U(async()=>{const n=await this.h.getConfigProvider(),a={folders:await this.c.getWorkspaceFolders2()||[]};return this.B(this.c.onDidChangeWorkspace(async d=>{a.folders=await this.c.getWorkspaceFolders2()||[]})),new p(this.b,this.c,this.g,this.j,n,a,this.m())})}getResolver(){return this.a.value}m(){}};e.$Iec=g,e.$Iec=g=Ke([Ve(0,f.$Eec),Ve(1,D.$3dc),Ve(2,$.$KM),Ve(3,b.$6dc),Ve(4,E.$fec)],g)}),define(Pe[117],Re([1,0,14,5,2,4,3,62,37,17,7,35,207,209,36,116]),function(be,e,y,F,P,M,A,$,E,f,C,D,u,b,p,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nec=e.$Mec=e.$Lec=e.$Kec=e.$Jec=void 0,e.$Jec=(0,M.$Vh)("IExtHostDebugService");let t=class{get onDidStartDebugSession(){return this.m.event}get onDidTerminateDebugSession(){return this.n.event}get onDidChangeActiveDebugSession(){return this.o.event}get activeDebugSession(){return this.q}get onDidReceiveDebugSessionCustomEvent(){return this.u.event}get activeDebugConsole(){return this.v.value}constructor(s,a,d,v,m,S){this.E=a,this.F=d,this.G=v,this.H=m,this.I=S,this.l=new Map,this.d=0,this.f=[],this.g=0,this.h=[],this.i=0,this.j=[],this.B=new Map,this.C=new Map,this.m=new F.$Rd,this.n=new F.$Rd,this.o=new F.$Rd,this.u=new F.$Rd,this.k=s.getProxy(A.$xK.MainThreadDebugService),this.y=new F.$Rd,this.A=new F.$Rd,this.v=new r(this.k),this.w=new Map,this.F.getExtensionRegistry().then(k=>{k.onDidChange(h=>{this.J(k)}),this.J(k)})}asDebugSourceUri(s,a){const d=s;if(typeof d.sourceReference=="number"&&d.sourceReference>0){let v=`debug:${encodeURIComponent(d.path||"")}`,m="?";return a&&(v+=`${m}session=${encodeURIComponent(a.id)}`,m="&"),v+=`${m}ref=${d.sourceReference}`,P.URI.parse(v)}else{if(d.path)return P.URI.file(d.path);throw new Error("cannot create uri from DAP 'source' object; properties 'path' and 'sourceReference' are both missing.")}}J(s){const a=[];for(const d of s.getAllExtensionDescriptions())if(d.contributes){const v=d.contributes.debuggers;if(v&&v.length>0)for(const m of v)(0,b.$iF)(m)&&a.push(m.type)}this.k.$registerDebugTypes(a)}get stackFrameFocus(){return this.z}get onDidChangeStackFrameFocus(){return this.A.event}get onDidChangeBreakpoints(){return this.y.event}get breakpoints(){const s=[];return this.w.forEach(a=>s.push(a)),s}addBreakpoints(s){const a=s.filter(m=>{const S=m.id;return this.w.has(S)?!1:(this.w.set(S,m),!0)});this.U(a,[],[]);const d=[],v=new Map;for(const m of a)if(m instanceof C.$yL){let S=v.get(m.location.uri.toString());S||(S={type:"sourceMulti",uri:m.location.uri,lines:[]},v.set(m.location.uri.toString(),S),d.push(S)),S.lines.push({id:m.id,enabled:m.enabled,condition:m.condition,hitCondition:m.hitCondition,logMessage:m.logMessage,line:m.location.range.start.line,character:m.location.range.start.character})}else m instanceof C.$zL&&d.push({type:"function",id:m.id,enabled:m.enabled,hitCondition:m.hitCondition,logMessage:m.logMessage,condition:m.condition,functionName:m.functionName});return this.k.$registerBreakpoints(d)}removeBreakpoints(s){const a=s.filter(S=>this.w.delete(S.id));this.U([],a,[]);const d=a.filter(S=>S instanceof C.$yL).map(S=>S.id),v=a.filter(S=>S instanceof C.$zL).map(S=>S.id),m=a.filter(S=>S instanceof C.$AL).map(S=>S.id);return this.k.$unregisterBreakpoints(d,v,m)}startDebugging(s,a,d){return this.k.$startDebugging(s?s.uri:void 0,a,{parentSessionID:d.parentSession?d.parentSession.id:void 0,lifecycleManagedByParent:d.lifecycleManagedByParent,repl:d.consoleMode===C.DebugConsoleMode.MergeWithParent?"mergeWithParent":"separate",noDebug:d.noDebug,compact:d.compact,suppressSaveBeforeStart:d.suppressSaveBeforeStart,suppressDebugStatusbar:d.suppressDebugStatusbar??d.debugUI?.simple,suppressDebugToolbar:d.suppressDebugToolbar??d.debugUI?.simple,suppressDebugView:d.suppressDebugView??d.debugUI?.simple})}stopDebugging(s){return this.k.$stopDebugging(s?s.id:void 0)}registerDebugConfigurationProvider(s,a,d){if(!a)return new C.$zK(()=>{});const v=this.d++;return this.f.push({type:s,handle:v,provider:a}),this.k.$registerDebugConfigurationProvider(s,d,!!a.provideDebugConfigurations,!!a.resolveDebugConfiguration,!!a.resolveDebugConfigurationWithSubstitutedVariables,v),new C.$zK(()=>{this.f=this.f.filter(m=>m.provider!==a),this.k.$unregisterDebugConfigurationProvider(v)})}registerDebugAdapterDescriptorFactory(s,a,d){if(!d)return new C.$zK(()=>{});if(!this.Q(s,a))throw new Error(`a DebugAdapterDescriptorFactory can only be registered from the extension that defines the '${a}' debugger.`);if(this.N(a))throw new Error("a DebugAdapterDescriptorFactory can only be registered once per a type.");const v=this.g++;return this.h.push({type:a,handle:v,factory:d}),this.k.$registerDebugAdapterDescriptorFactory(a,v),new C.$zK(()=>{this.h=this.h.filter(m=>m.factory!==d),this.k.$unregisterDebugAdapterDescriptorFactory(v)})}registerDebugAdapterTrackerFactory(s,a){if(!a)return new C.$zK(()=>{});const d=this.i++;return this.j.push({type:s,handle:d,factory:a}),new C.$zK(()=>{this.j=this.j.filter(v=>v.factory!==a)})}async $runInTerminal(s,a){return Promise.resolve(void 0)}async $substituteVariables(s,a){let d;const v=await this.W(s);return v&&(d={uri:v.uri,name:v.name,index:v.index,toResource:()=>{throw new Error("Not implemented")}}),(await this.I.getResolver()).resolveAnyAsync(d,a)}K(s,a){if(s.type==="implementation")return new o(s.implementation)}L(){}async $startDASession(s,a){const d=this,v=await this.V(a);return this.S(this.N(v.type),v).then(m=>{if(!m)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${v.type}' (extension might have failed to activate)`);const S=this.M(m),k=this.K(S,v);if(!k)throw new Error(`Couldn't create a debug adapter for type '${v.type}'.`);const h=k;return this.B.set(s,h),this.R(v).then(w=>(w&&this.C.set(s,w),h.onMessage(async I=>{if(I.type==="request"&&I.command==="handshake"){const L=I,V={type:"response",seq:0,command:L.command,request_seq:L.seq,success:!0};this.D||(this.D=this.L());try{if(this.D){const K=await this.D.sign(L.arguments.value);V.body={signature:K},h.sendResponse(V)}else throw new Error("no signer")}catch(K){V.success=!1,V.message=K.message,h.sendResponse(V)}}else w&&w.onDidSendMessage&&w.onDidSendMessage(I),I=(0,b.$nF)(I,!0),d.k.$acceptDAMessage(s,I)}),h.onError(I=>{w&&w.onError&&w.onError(I),this.k.$acceptDAError(s,I.name,I.message,I.stack)}),h.onExit(I=>{w&&w.onExit&&w.onExit(I??void 0,void 0),this.k.$acceptDAExit(s,I??void 0,void 0)}),w&&w.onWillStartSession&&w.onWillStartSession(),h.startSession()))})}$sendDAMessage(s,a){a=(0,b.$mF)(a,!1);const d=this.C.get(s);d&&d.onWillReceiveMessage&&d.onWillReceiveMessage(a),this.B.get(s)?.sendMessage(a)}$stopDASession(s){const a=this.C.get(s);this.C.delete(s),a&&a.onWillStopSession&&a.onWillStopSession();const d=this.B.get(s);return this.B.delete(s),d?d.stopSession():Promise.resolve(void 0)}$acceptBreakpointsDelta(s){const a=[],d=[],v=[];if(s.added)for(const m of s.added){const S=m.id;if(S&&!this.w.has(S)){let k;if(m.type==="function")k=new C.$zL(m.functionName,m.enabled,m.condition,m.hitCondition,m.logMessage);else if(m.type==="data")k=new C.$AL(m.label,m.dataId,m.canPersist,m.enabled,m.hitCondition,m.condition,m.logMessage);else{const h=P.URI.revive(m.uri);k=new C.$yL(new C.$LK(h,new C.$AK(m.line,m.character)),m.enabled,m.condition,m.hitCondition,m.logMessage)}(0,C.$wL)(k,S),this.w.set(S,k),a.push(k)}}if(s.removed)for(const m of s.removed){const S=this.w.get(m);S&&(this.w.delete(m),d.push(S))}if(s.changed){for(const m of s.changed)if(m.id){const S=this.w.get(m.id);if(S){if(S instanceof C.$zL&&m.type==="function"){const k=S;k.enabled=m.enabled,k.condition=m.condition,k.hitCondition=m.hitCondition,k.logMessage=m.logMessage,k.functionName=m.functionName}else if(S instanceof C.$yL&&m.type==="source"){const k=S;k.enabled=m.enabled,k.condition=m.condition,k.hitCondition=m.hitCondition,k.logMessage=m.logMessage,k.location=new C.$LK(P.URI.revive(m.uri),new C.$AK(m.line,m.character))}v.push(S)}}}this.U(a,d,v)}async $acceptStackFrameFocus(s){let a;const d=s.sessionId?await this.V(s.sessionId):void 0;if(!d)throw new Error("no DebugSession found for debug focus context");s.kind==="thread"?a=new C.$GL(d,s.threadId):a=new C.$FL(d,s.threadId,s.frameId),this.z=a,this.A.fire(this.z)}$provideDebugConfigurations(s,a,d){return(0,y.$Qg)(async()=>{const v=this.P(s);if(!v)throw new Error("no DebugConfigurationProvider found");if(!v.provideDebugConfigurations)throw new Error("DebugConfigurationProvider has no method provideDebugConfigurations");const m=await this.W(a);return v.provideDebugConfigurations(m,d)}).then(v=>{if(!v)throw new Error("nothing returned from DebugConfigurationProvider.provideDebugConfigurations");return v})}$resolveDebugConfiguration(s,a,d,v){return(0,y.$Qg)(async()=>{const m=this.P(s);if(!m)throw new Error("no DebugConfigurationProvider found");if(!m.resolveDebugConfiguration)throw new Error("DebugConfigurationProvider has no method resolveDebugConfiguration");const S=await this.W(a);return m.resolveDebugConfiguration(S,d,v)})}$resolveDebugConfigurationWithSubstitutedVariables(s,a,d,v){return(0,y.$Qg)(async()=>{const m=this.P(s);if(!m)throw new Error("no DebugConfigurationProvider found");if(!m.resolveDebugConfigurationWithSubstitutedVariables)throw new Error("DebugConfigurationProvider has no method resolveDebugConfigurationWithSubstitutedVariables");const S=await this.W(a);return m.resolveDebugConfigurationWithSubstitutedVariables(S,d,v)})}async $provideDebugAdapter(s,a){const d=this.O(s);if(!d)return Promise.reject(new Error("no adapter descriptor factory found for handle"));const v=await this.V(a);return this.S(d,v).then(m=>{if(!m)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${v.type}'`);return this.M(m)})}async $acceptDebugSessionStarted(s){const a=await this.V(s);this.m.fire(a)}async $acceptDebugSessionTerminated(s){const a=await this.V(s);a&&(this.n.fire(a),this.l.delete(a.id))}async $acceptDebugSessionActiveChanged(s){this.q=s?await this.V(s):void 0,this.o.fire(this.q)}async $acceptDebugSessionNameChanged(s,a){(await this.V(s))?._acceptNameChanged(a)}async $acceptDebugSessionCustomEvent(s,a){const v={session:await this.V(s),event:a.event,body:a.body};this.u.fire(v)}M(s){if(s instanceof C.$BL)return{type:"executable",command:s.command,args:s.args,options:s.options};if(s instanceof C.$CL)return{type:"server",port:s.port,host:s.host};if(s instanceof C.$DL)return{type:"pipeServer",path:s.path};if(s instanceof C.$EL)return{type:"implementation",implementation:s.implementation};throw new Error("convertToDto unexpected type")}N(s){const a=this.h.filter(d=>d.type===s);if(a.length>0)return a[0].factory}O(s){const a=this.h.filter(d=>d.handle===s);if(a.length>0)return a[0].factory}P(s){const a=this.f.filter(d=>d.handle===s);if(a.length>0)return a[0].provider}Q(s,a){if(s.contributes){const d=s.contributes.debuggers;if(d&&d.length>0){for(const v of d)if(v.label&&v.type&&v.type===a)return!0}}return!1}R(s){const d=s.configuration.type,v=this.j.filter(m=>m.type===d||m.type==="*").map(m=>(0,y.$Qg)(()=>m.factory.createDebugAdapterTracker(s)).then(S=>S,S=>null));return Promise.race([Promise.all(v).then(m=>{const S=m.filter(k=>!!k);if(S.length>0)return new c(S)}),new Promise(m=>setTimeout(()=>m(void 0),1e3))]).catch(m=>{})}async S(s,a){const d=a.configuration.debugServer;if(typeof d=="number")return Promise.resolve(new C.$CL(d));if(s){const m=await this.F.getExtensionRegistry();return(0,y.$Qg)(()=>s.createDebugAdapterDescriptor(a,this.T(a,m))).then(S=>{if(S)return S})}const v=await this.F.getExtensionRegistry();return Promise.resolve(this.T(a,v))}T(s,a){}U(s,a,d){(s.length>0||a.length>0||d.length>0)&&this.y.fire(Object.freeze({added:s,removed:a,changed:d}))}async V(s){if(s)if(typeof s=="string"){const a=this.l.get(s);if(a)return a}else{let a=this.l.get(s.id);if(!a){const d=await this.W(s.folderUri),v=s.parent?this.l.get(s.parent):void 0;a=new i(this.k,s.id,s.type,s.name,d,s.configuration,v),this.l.set(a.id,a),this.k.$sessionCached(a.id)}return a}throw new Error("cannot find session")}W(s){if(s){const a=P.URI.revive(s);return this.E.resolveWorkspaceFolder(a)}return Promise.resolve(void 0)}};e.$Kec=t,e.$Kec=t=Ke([Ve(0,f.$zM),Ve(1,D.$3dc),Ve(2,E.$Eec),Ve(3,p.$6dc),Ve(4,$.$fec),Ve(5,g.$Hec)],t);class i{constructor(s,a,d,v,m,S,k){this.d=s,this.f=a,this.g=d,this.h=v,this.i=m,this.j=S,this.k=k}get id(){return this.f}get type(){return this.g}get name(){return this.h}set name(s){this.h=s,this.d.$setDebugSessionName(this.f,s)}get parentSession(){return this.k}_acceptNameChanged(s){this.h=s}get workspaceFolder(){return this.i}get configuration(){return this.j}customRequest(s,a){return this.d.$customDebugAdapterRequest(this.f,s,a)}getDebugProtocolBreakpoint(s){return this.d.$getDebugProtocolBreakpoint(this.f,s.id)}}e.$Lec=i;class r{constructor(s){this.value=Object.freeze({append(a){s.$appendDebugConsole(a)},appendLine(a){this.append(a+`
`)}})}}e.$Mec=r;class c{constructor(s){this.d=s}onWillStartSession(){this.d.forEach(s=>s.onWillStartSession?s.onWillStartSession():void 0)}onWillReceiveMessage(s){this.d.forEach(a=>a.onWillReceiveMessage?a.onWillReceiveMessage(s):void 0)}onDidSendMessage(s){this.d.forEach(a=>a.onDidSendMessage?a.onDidSendMessage(s):void 0)}onWillStopSession(){this.d.forEach(s=>s.onWillStopSession?s.onWillStopSession():void 0)}onError(s){this.d.forEach(a=>a.onError?a.onError(s):void 0)}onExit(s,a){this.d.forEach(d=>d.onExit?d.onExit(s,a):void 0)}}class o extends u.$Fdb{constructor(s){super(),this.h=s,s.onDidSendMessage(a=>{this.acceptMessage(a)})}startSession(){return Promise.resolve(void 0)}sendMessage(s){this.h.handleMessage(s)}stopSession(){return this.h.dispose(),Promise.resolve(void 0)}}let l=class extends t{constructor(s,a,d,v,m,S){super(s,a,d,v,m,S)}};e.$Nec=l,e.$Nec=l=Ke([Ve(0,f.$zM),Ve(1,D.$3dc),Ve(2,E.$Eec),Ve(3,p.$6dc),Ve(4,$.$fec),Ve(5,g.$Hec)],l)}),define(Pe[288],Re([1,0,11,88,2,3,276,15,70,71,27,185,17,57,37,59]),function(be,e,y,F,P,M,A,$,E,f,C,D,u,b,p,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qfc=e.$Pfc=void 0;class t{static async installEarlyHandler(c){Error.stackTraceLimit=100;const o=c.get($.$dj),n=c.get(u.$zM).getProxy(M.$xK.MainThreadErrors);y.setUnexpectedErrorHandler(s=>{o.error(s);const a=y.$2(s);n.$onUnexpectedError(a)})}static async installFullHandler(c){const o=c.get($.$dj),l=c.get(u.$zM),n=c.get(p.$Eec),s=c.get(g.$TM),a=l.getProxy(M.$xK.MainThreadExtensionService),d=l.getProxy(M.$xK.MainThreadErrors),v=await n.getExtensionPathIndex(),m=new WeakMap;function S(w,I){if(m.has(w))return m.get(w).stack;let L="",V,K;for(const N of I)L+=`
	at ${N.toString()}`,K=N.getFileName(),!V&&K&&(V=v.findSubstr(P.URI.file(K)));const R=`${w.name||"Error"}: ${w.message||""}${L}`;return m.set(w,{extensionIdentifier:V?.identifier,stack:R}),R}const k=Symbol("prepareStackTrace wrapped");let h=S;Object.defineProperty(Error,"prepareStackTrace",{configurable:!1,get(){return h},set(w){if(w===S||!w||w[k]){h=w||S;return}h=function(I,L){return S(I,L),w.call(Error,I,L)},Object.assign(h,{[k]:!0})}}),y.setUnexpectedErrorHandler(w=>{o.error(w);const I=y.$2(w),L=m.get(w);if(!L?.extensionIdentifier){d.$onUnexpectedError(I);return}a.$onExtensionRuntimeError(L.extensionIdentifier,I);const V=s.onExtensionError(L.extensionIdentifier,w);o.trace("forwarded error to extension?",V,L)})}}e.$Pfc=t;class i{constructor(c,o,l,n,s){this.a=l,this.b=new A.$25b(c,null,n),o=i.e(o,this.b);const a=new f.$Th(...(0,E.$Dr)());a.set(C.$PM,{_serviceBrand:void 0,...o,messagePorts:s}),a.set(u.$zM,new u.$AM(this.b)),a.set(b.$Zdc,new b.$1dc(n)),a.set(p.$Cec,l);const d=new D.$jq(a,!0);d.invokeFunction(t.installEarlyHandler),this.d=d.invokeFunction(v=>v.get($.$dj)),F.mark("code/extHost/didCreateServices"),this.a.pid?this.d.info(`Extension host with pid ${this.a.pid} started`):this.d.info("Extension host started"),this.d.trace("initData",o),this.c=d.invokeFunction(v=>v.get(p.$Eec)),this.c.initialize(),d.invokeFunction(t.installFullHandler)}async asBrowserUri(c){const o=this.b.getProxy(M.$xK.MainThreadExtensionService);return P.URI.revive(await o.$asBrowserUri(c))}terminate(c){this.c.terminate(c)}static e(c,o){c.extensions.allExtensions.forEach(n=>{n.extensionLocation=P.URI.revive(o.transformIncomingURIs(n.extensionLocation))}),c.environment.appRoot=P.URI.revive(o.transformIncomingURIs(c.environment.appRoot));const l=c.environment.extensionDevelopmentLocationURI;return l&&(c.environment.extensionDevelopmentLocationURI=l.map(n=>P.URI.revive(o.transformIncomingURIs(n)))),c.environment.extensionTestsLocationURI=P.URI.revive(o.transformIncomingURIs(c.environment.extensionTestsLocationURI)),c.environment.globalStorageHome=P.URI.revive(o.transformIncomingURIs(c.environment.globalStorageHome)),c.environment.workspaceStorageHome=P.URI.revive(o.transformIncomingURIs(c.environment.workspaceStorageHome)),c.environment.extensionTelemetryLogResource=P.URI.revive(o.transformIncomingURIs(c.environment.extensionTelemetryLogResource)),c.nlsBaseUrl=P.URI.revive(o.transformIncomingURIs(c.nlsBaseUrl)),c.logsLocation=P.URI.revive(o.transformIncomingURIs(c.logsLocation)),c.workspace=o.transformIncomingURIs(c.workspace),c}}e.$Qfc=i}),define(Pe[289],Re([1,0,18,14,20,39,13,19,25,2,43]),function(be,e,y,F,P,M,A,$,E,f,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5ec=e.$4ec=e.$3ec=e.$2ec=void 0;class D{constructor(r,c,o,l){this.d=r,this.e=c,this.f=o,this.g=l,this.a=null,this.b=!1,this.c=0}search(r,c){const o=this.d.folderQueries||[],l=new P.$2d(c);return new Promise((n,s)=>{this.a=new b(r);let a=!1;const d=(v,m)=>{if(!a&&!this.b){const S=this.h(v);g(v)&&typeof this.d.maxResults=="number"&&this.c+S>this.d.maxResults&&(this.b=!0,a=!0,l.cancel(),v=this.j(v,this.d.maxResults-this.c));const k=this.h(v);this.c+=k,(k>0||!g(v))&&this.a.add(v,m)}};Promise.all(o.map((v,m)=>this.k(v,S=>d(S,m),l.token))).then(v=>{l.dispose(),this.a.flush();const m=v.some(S=>!!S&&!!S.limitHit);n({limitHit:this.b||m,messages:(0,y.$Qb)(v.map(S=>S?.message?Array.isArray(S.message)?S.message:[S.message]:[])),stats:{type:this.g}})},v=>{l.dispose();const m=(0,M.$Gi)(v);s(new Error(m))})})}h(r){return g(r)?Array.isArray(r.ranges)?r.ranges.length:1:0}j(r,c){const o=Array.isArray(r.ranges)?r.ranges:[r.ranges],l=Array.isArray(r.preview.matches)?r.preview.matches:[r.preview.matches];return{ranges:o.slice(0,c),preview:{matches:l.slice(0,c),text:r.preview.text},uri:r.uri}}async k(r,c,o){const l=new C.$cJ(this.d,r),n=[],s={report:v=>{if(!this.l(v))return;const m=r.folder.scheme===A.Schemas.file?(0,C.$dJ)(()=>this.f.readdir(E.$yg(v.uri))):void 0,S=E.$Bg(r.folder,v.uri);if(S){const k=l.includedInQuery(S,$.$mc(S),m);(0,F.$Kg)(k)?n.push(k.then(h=>{h&&c(v)})):k&&c(v)}}},a=this.n(r),d=await this.e.provideTextSearchResults(u(this.d.contentPattern),a,s,o);return n.length&&await Promise.all(n),d}l(r){if(g(r)){if(Array.isArray(r.ranges)){if(!Array.isArray(r.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same type."),!1;if(r.preview.matches.length!==r.ranges.length)return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}else if(Array.isArray(r.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}return!0}n(r){const c=(0,C.$bJ)(this.d.includePattern,r.includePattern),o=(0,C.$bJ)(this.d.excludePattern,r.excludePattern),l={folder:f.URI.from(r.folder),excludes:o,includes:c,useIgnoreFiles:!r.disregardIgnoreFiles,useGlobalIgnoreFiles:!r.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!r.disregardParentIgnoreFiles,followSymlinks:!r.ignoreSymlinks,encoding:r.fileEncoding&&this.f.toCanonicalName(r.fileEncoding),maxFileSize:this.d.maxFileSize,maxResults:this.d.maxResults,previewOptions:this.d.previewOptions,afterContext:this.d.afterContext,beforeContext:this.d.beforeContext};return l.usePCRE2=this.d.usePCRE2,l}}e.$2ec=D;function u(i){return{isCaseSensitive:i.isCaseSensitive||!1,isRegExp:i.isRegExp||!1,isWordMatch:i.isWordMatch||!1,isMultiline:i.isMultiline||!1,pattern:i.pattern}}class b{constructor(r){this.e=r,this.b=-1,this.d=null,this.a=new t(512,c=>this.g(c))}add(r,c){this.d&&(this.b!==c||!E.$sg(this.c,r.uri))&&(this.f(),this.d=null),this.d||(this.b=c,this.d={resource:r.uri,results:[]}),this.d.results.push(p(r))}f(){const r=this.d&&this.d.results?this.d.results.length:0;this.a.addItem(this.d,r)}flush(){this.f(),this.a.flush()}g(r){this.e(r)}}e.$3ec=b;function p(i){return g(i)?{preview:{matches:(0,y.$1b)(i.preview.matches,r=>({startLineNumber:r.start.line,startColumn:r.start.character,endLineNumber:r.end.line,endColumn:r.end.character})),text:i.preview.text},ranges:(0,y.$1b)(i.ranges,r=>({startLineNumber:r.start.line,startColumn:r.start.character,endLineNumber:r.end.line,endColumn:r.end.character}))}:{text:i.text,lineNumber:i.lineNumber}}function g(i){return!!i.preview}e.$4ec=g;class t{static{this.a=4e3}static{this.b=50}constructor(r,c){this.g=r,this.h=c,this.c=0,this.d=[],this.e=0}addItem(r,c){r&&this.j(r,c)}addItems(r,c){r&&this.k(r,c)}j(r,c){this.d.push(r),this.e+=c,this.l()}k(r,c){this.d=this.d.concat(r),this.e+=c,this.l()}l(){this.c<t.b?this.flush():this.e>=this.g?this.flush():this.f||(this.f=setTimeout(()=>{this.flush()},t.a))}flush(){this.e&&(this.c+=this.e,this.h(this.d),this.d=[],this.e=0,this.f&&(clearTimeout(this.f),this.f=0))}}e.$5ec=t}),define(Pe[118],Re([1,0,6,3,4,284,17,57,15,2,289]),function(be,e,y,F,P,M,A,$,E,f,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8ec=e.$7ec=e.$6ec=void 0,e.$6ec=(0,P.$Vh)("IExtHostSearch");let D=class{constructor(g,t,i){this.k=g,this.l=t,this.n=i,this.c=this.k.getProxy(F.$xK.MainThreadSearch),this.d=0,this.e=new Map,this.g=new Set,this.h=new Map,this.i=new Set,this.j=new M.$1ec}o(g){return this.l.transformOutgoingScheme(g)}registerTextSearchProvider(g,t){if(this.g.has(g))throw new Error(`a text search provider for the scheme '${g}' is already registered`);this.g.add(g);const i=this.d++;return this.e.set(i,t),this.c.$registerTextSearchProvider(i,this.o(g)),(0,y.$Pc)(()=>{this.g.delete(g),this.e.delete(i),this.c.$unregisterProvider(i)})}registerFileSearchProvider(g,t){if(this.i.has(g))throw new Error(`a file search provider for the scheme '${g}' is already registered`);this.i.add(g);const i=this.d++;return this.h.set(i,t),this.c.$registerFileSearchProvider(i,this.o(g)),(0,y.$Pc)(()=>{this.i.delete(g),this.h.delete(i),this.c.$unregisterProvider(i)})}$provideFileSearchResults(g,t,i,r){const c=u(i),o=this.h.get(g);if(o)return this.j.fileSearch(c,o,l=>{this.c.$handleFileMatch(g,t,l.map(n=>n.resource))},r);throw new Error("unknown provider: "+g)}async doInternalFileSearchWithCustomCallback(g,t,i){return{messages:[]}}$clearCache(g){return this.j.clearCache(g),Promise.resolve(void 0)}$provideTextSearchResults(g,t,i,r){const c=this.e.get(g);if(!c||!c.provideTextSearchResults)throw new Error(`Unknown provider ${g}`);const o=u(i);return this.q(o,c).search(n=>this.c.$handleTextMatch(g,t,n),r)}$enableExtensionHostSearch(){}q(g,t){return new C.$2ec(g,t,{readdir:i=>Promise.resolve([]),toCanonicalName:i=>i},"textSearchProvider")}};e.$7ec=D,e.$7ec=D=Ke([Ve(0,A.$zM),Ve(1,$.$Zdc),Ve(2,E.$dj)],D);function u(p){return{...p,folderQueries:p.folderQueries&&p.folderQueries.map(b),extraFileResources:p.extraFileResources&&p.extraFileResources.map(g=>f.URI.revive(g))}}e.$8ec=u;function b(p){return{...p,folder:f.URI.revive(p.folder)}}}),define(Pe[290],Re([1,0,20,11,5,6,13,31,2,146,142,129,92,22,41,15,99,55,56,198,3,231,239,81,232,233,234,235,236,237,238,213,32,240,36,272,117,110,242,243,244,220,245,61,62,247,37,248,63,249,42,27,250,251,252,253,254,255,82,83,257,283,222,202,223,258,259,112,260,224,261,262,17,263,118,84,264,265,266,85,86,115,59,64,267,268,210,269,225,87,8,7,270,57,271,65,273,274,111,35,208,79,23,114]),function(be,e,y,F,P,M,A,$,E,f,C,D,u,b,p,g,t,i,r,c,o,l,n,s,a,d,v,m,S,k,h,w,I,L,V,K,R,N,T,z,Z,he,ye,De,Se,fe,$e,re,Ae,se,X,B,ie,pe,ne,le,ce,we,_,de,te,ae,me,Ie,O,W,G,J,q,x,ue,Oe,Ue,Ze,Je,tt,_e,et,rt,nt,Ne,dt,Y,Q,Ee,Be,He,Ye,st,vt,Dt,ze,Kt,Ht,yt,jt,zt,Gt,Bt,St,Lt,Vt,Xe,Wt){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kfc=void 0;function qt(ct){const gt=ct.get(B.$PM),Ot=ct.get(X.$Hdc),Pt=ct.get(Ae.$8dc),Rt=ct.get($e.$Eec),ft=ct.get(St.$3dc),kt=ct.get(Y.$TM),At=ct.get(V.$6dc),Ct=ct.get(Ht.$Zdc),We=ct.get(Ue.$zM),Nt=ct.get(nt.$oec),Jt=ct.get(Ne.$9dc),Ce=ct.get(g.$ej),Me=ct.get(g.$dj),ve=ct.get(vt.$Rwb),H=ct.get(s.$Kdc),Le=ct.get(Bt.$Jfc),je=ct.get(tt.$wec),Qe=ct.get(Se.$fec),qe=ct.get(de.$Aec);We.set(o.$yK.ExtHostFileSystemInfo,Ot),We.set(o.$yK.ExtHostLogLevelServiceShape,Ce),We.set(o.$yK.ExtHostWorkspace,ft),We.set(o.$yK.ExtHostConfiguration,At),We.set(o.$yK.ExtHostExtensionService,Rt),We.set(o.$yK.ExtHostStorage,Nt),We.set(o.$yK.ExtHostTunnelService,ve),We.set(o.$yK.ExtHostWindow,Le),We.set(o.$yK.ExtHostSecretState,je),We.set(o.$yK.ExtHostTelemetry,kt),We.set(o.$yK.ExtHostEditorTabs,Qe),We.set(o.$yK.ExtHostManagedSockets,qe);const it=We.set(o.$yK.ExtHostDecorations,ct.get(N.$Pec)),pt=We.set(o.$yK.ExtHostDocumentsAndEditors,ct.get(De.$KM)),$t=We.set(o.$yK.ExtHostCommands,ct.get(I.$VM)),bt=We.set(o.$yK.ExtHostTerminalService,ct.get(Q.$rec)),ut=We.set(o.$yK.ExtHostDebugService,ct.get(R.$Jec)),Mt=We.set(o.$yK.ExtHostSearch,ct.get(Je.$6ec)),Qt=We.set(o.$yK.ExtHostTask,ct.get(dt.$wfc)),Yt=We.set(o.$yK.ExtHostOutputService,ct.get(J.$jfc)),si=We.set(o.$yK.ExtHostLocalization,ct.get(_.$zec)),ki=We.set(o.$yK.ExtHostUrls,new yt.$Gfc(We)),It=We.set(o.$yK.ExtHostDocuments,new ye.$Fdc(We,pt)),Zi=We.set(o.$yK.ExtHostDocumentContentProviders,new Z.$Rec(We,pt,Me)),ln=We.set(o.$yK.ExtHostDocumentSaveParticipant,new he.$Sec(Me,It,We.getProxy(o.$xK.MainThreadBulkEdits))),Et=We.set(o.$yK.ExtHostNotebook,new ae.$9ec(We,$t,pt,It,Pt,Mt)),gi=We.set(o.$yK.ExtHostNotebookDocuments,new Ie.$dfc(Et)),mi=We.set(o.$yK.ExtHostNotebookEditors,new O.$efc(Me,Et)),oi=We.set(o.$yK.ExtHostNotebookKernels,new W.$ffc(We,gt,Et,$t,Me)),Si=We.set(o.$yK.ExtHostNotebookRenderers,new G.$hfc(We,Et)),Ii=We.set(o.$yK.ExtHostNotebookDocumentSaveParticipant,new me.$cfc(Me,Et,We.getProxy(o.$xK.MainThreadBulkEdits))),Ft=We.set(o.$yK.ExtHostEditors,new Be.$Wdc(We,pt)),$i=We.set(o.$yK.ExtHostTreeViews,new st.$Efc(We.getProxy(o.$xK.MainThreadTreeViews),$t,Me)),Ci=We.set(o.$yK.ExtHostEditorInsets,new w.$Xdc(We.getProxy(o.$xK.MainThreadEditorInsets),Ft,gt.remote)),ai=We.set(o.$yK.ExtHostDiagnostics,new T.$Jdc(We,Me,Ot,pt)),ci=We.set(o.$yK.ExtHostLanguages,new we.$afc(We,It,$t.converter,Ct)),lt=We.set(o.$yK.ExtHostLanguageFeatures,new ce.$Ndc(We,Ct,It,$t,ai,Me,H,kt)),Pi=We.set(o.$yK.ExtHostFileSystem,new re.$Uec(We,lt)),xt=We.set(o.$yK.ExtHostFileSystemEventService,new se.$Vec(We,Me,pt)),ni=We.set(o.$yK.ExtHostQuickOpen,(0,Oe.$nfc)(We,ft,$t)),pi=We.set(o.$yK.ExtHostSCM,new Ze.$pfc(We,$t,It,Me)),Yi=We.set(o.$yK.ExtHostQuickDiff,new ue.$mfc(We,Ct)),Ri=We.set(o.$yK.ExtHostShare,new _e.$qfc(We,Ct)),Ai=We.set(o.$yK.ExtHostComments,(0,L.$Ydc)(We,$t,It)),Mi=We.set(o.$yK.ExtHostProgress,new x.$lfc(We.getProxy(o.$xK.MainThreadProgress))),xi=We.set(o.$yK.ExtHosLabelService,new le.$_ec(We)),Li=We.set(o.$yK.ExtHostTheming,new He.$Bfc(We)),ui=We.set(o.$yK.ExtHostAuthentication,new a.$Pdc(We)),_i=We.set(o.$yK.ExtHostTimeline,new Ye.$Dfc(We,$t)),Fi=We.set(o.$yK.ExtHostWebviews,new jt.$aec(We,gt.remote,ft,Me,H)),Ti=We.set(o.$yK.ExtHostWebviewPanels,new zt.$dec(We,Fi,ft)),Oi=We.set(o.$yK.ExtHostCustomEditors,new K.$eec(We,It,Jt,Fi,Ti)),zi=We.set(o.$yK.ExtHostWebviewViews,new Gt.$Hfc(We,Fi)),hi=We.set(o.$yK.ExtHostTesting,new Ee.$xfc(We,$t,pt)),hn=We.set(o.$yK.ExtHostUriOpeners,new Kt.$Ffc(We)),en=We.set(o.$yK.ExtHostProfileContentHandlers,new q.$kfc(We));We.set(o.$yK.ExtHostInteractive,new pe.$0ec(We,Et,pt,$t,Me));const Ni=We.set(o.$yK.ExtHostInlineChat,new ie.$Wec(We,$t,It,Me)),vi=We.set(o.$yK.ExtHostChatProvider,new S.$Sdc(We,Me)),tn=We.set(o.$yK.ExtHostChatAgents2,new m.$Tdc(We,vi,Me)),nn=We.set(o.$yK.ExtHostChatVariables,new k.$Udc(We)),bi=We.set(o.$yK.ExtHostChat,new v.$Rdc(We)),wi=We.set(o.$yK.ExtHostAiRelatedInformation,new l.$Edc(We)),rn=We.set(o.$yK.ExtHostAiEmbeddingVector,new fe.$Tec(We)),_t=We.set(o.$yK.ExtHostIssueReporter,new ne.$$ec(We)),di=We.set(o.$yK.ExtHostStatusBar,new rt.$tfc(We,$t.converter)),dn=We.set(o.$yK.ExtHostSpeech,new et.$rfc(We)),Xt=Object.values(o.$yK);We.assertRegistered(Xt);const yi=new d.$Qdc(We,pt),sn=new h.$Vdc(We),Ei=new te.$bfc(We,Me),Ui=new z.$Qec(We);return n.$Odc.register($t),function(Te,ti,ji){const mt=function(){let ee=!Te.isUnderDevelopment;function ge(){ee||(Me.info(`Extension '${Te.identifier.value}' uses a document selector without scheme. Learn more about this: https://go.microsoft.com/fwlink/?linkid=872305`),ee=!0)}return function Fe(ot){if(Array.isArray(ot))ot.forEach(Fe);else if(typeof ot=="string")ge();else{const wt=ot;typeof wt.scheme>"u"&&ge(),typeof wt.exclusive=="boolean"&&(0,Xe.$MF)(Te,"documentFiltersExclusive")}return ot}}(),fn={getSession(ee,ge,Fe){return ui.getSession(Te,ee,ge,Fe)},getSessions(ee,ge){return(0,Xe.$MF)(Te,"authGetSessions"),ui.getSessions(Te,ee,ge)},async hasSession(ee,ge){return(0,Xe.$MF)(Te,"authSession"),!!await ui.getSession(Te,ee,ge,{silent:!0})},get onDidChangeSessions(){return ui.onDidChangeSessions},registerAuthenticationProvider(ee,ge,Fe,ot){return ui.registerAuthenticationProvider(ee,ge,Fe,ot)}},gn={registerCommand(ee,ge,Fe){return $t.registerCommand(!0,ee,ge,Fe,void 0,Te)},registerTextEditorCommand(ee,ge,Fe){return $t.registerCommand(!0,ee,(...ot)=>{const wt=Ft.getActiveTextEditor();if(!wt){Me.warn("Cannot execute "+ee+" because there is no active text editor.");return}return wt.edit(Tt=>{ge.apply(Fe,[wt,Tt,...ot])}).then(Tt=>{Tt||Me.warn("Edits from command "+ee+" were not applied.")},Tt=>{Me.warn("An error occurred while running command "+ee,Tt)})},void 0,void 0,Te)},registerDiffInformationCommand:(ee,ge,Fe)=>((0,Xe.$MF)(Te,"diffCommand"),$t.registerCommand(!0,ee,async(...ot)=>{const wt=pt.activeEditor(!0);if(!wt){Me.warn("Cannot execute "+ee+" because there is no active text editor.");return}const Tt=await Ft.getDiffInformation(wt.id);ge.apply(Fe,[Tt,...ot])},void 0,void 0,Te)),executeCommand(ee,...ge){return $t.executeCommand(ee,...ge)},getCommands(ee=!1){return $t.getCommands(ee)}},Di={get machineId(){return gt.telemetryInfo.machineId},get sessionId(){return gt.telemetryInfo.sessionId},get language(){return gt.environment.appLanguage},get appName(){return gt.environment.appName},get appRoot(){return gt.environment.appRoot?.fsPath??""},get appHost(){return gt.environment.appHost},get uriScheme(){return gt.environment.appUriScheme},get clipboard(){return sn.value},get shell(){return bt.getDefaultShell(!1)},get onDidChangeShell(){return bt.onDidChangeShell},get isTelemetryEnabled(){return kt.getTelemetryConfiguration()},get onDidChangeTelemetryEnabled(){return kt.onDidChangeTelemetryEnabled},get telemetryConfiguration(){return(0,Xe.$MF)(Te,"telemetry"),kt.getTelemetryDetails()},get onDidChangeTelemetryConfiguration(){return(0,Xe.$MF)(Te,"telemetry"),kt.onDidChangeTelemetryConfiguration},get isNewAppInstall(){return(0,Y.$SM)(gt.telemetryInfo.firstSessionDate)},createTelemetryLogger(ee,ge){return Y.$RM.validateSender(ee),kt.instantiateLogger(Te,ee,ge)},openExternal(ee,ge){return Le.openUri(ee,{allowTunneling:!!gt.remote.authority,allowContributedOpeners:ge?.allowContributedOpeners})},async asExternalUri(ee){if(ee.scheme===gt.environment.appUriScheme)return ki.createAppUri(ee);try{return await Le.asExternalUri(ee,{allowTunneling:!!gt.remote.authority})}catch(ge){if((0,t.$OU)(ee,A.Schemas.http)||(0,t.$OU)(ee,A.Schemas.https))return ee;throw ge}},get remoteName(){return(0,i.$2k)(gt.remote.authority)},get remoteAuthority(){return(0,Xe.$MF)(Te,"resolvers"),gt.remote.authority},get uiKind(){return gt.uiKind},get logLevel(){return Me.getLevel()},get onDidChangeLogLevel(){return Me.onDidChangeLogLevel},registerIssueUriRequestHandler(ee){return(0,Xe.$MF)(Te,"handleIssueUri"),_t.registerIssueUriRequestHandler(Te,ee)},registerIssueDataProvider(ee){return(0,Xe.$MF)(Te,"handleIssueUri"),_t.registerIssueDataProvider(Te,ee)},get appQuality(){return(0,Xe.$MF)(Te,"resolvers"),gt.quality},get appCommit(){return(0,Xe.$MF)(Te,"resolvers"),gt.commit}};gt.environment.extensionTestsLocationURI||Object.freeze(Di);const on={createTestController(ee,ge,Fe){return hi.createTestController(Te,ee,ge,Fe)},createTestObserver(){return(0,Xe.$MF)(Te,"testObserver"),hi.createTestObserver()},runTests(ee){return(0,Xe.$MF)(Te,"testObserver"),hi.runTests(ee)},get onDidChangeTestResults(){return(0,Xe.$MF)(Te,"testObserver"),hi.onResultsChanged},get testResults(){return(0,Xe.$MF)(Te,"testObserver"),hi.results}},fi=gt.remote.isRemote?ze.ExtensionKind.Workspace:ze.ExtensionKind.UI,an={getExtension(ee,ge){(0,Xe.$LF)(Te,"extensionsAny")||(ge=!1);const Fe=ti.mine.getExtensionDescription(ee);if(Fe)return new $e.$Fec(Rt,Te.identifier,Fe,fi,!1);if(ge){const ot=ti.all.getExtensionDescription(ee);if(ot)return new $e.$Fec(Rt,Te.identifier,ot,fi,!0)}},get all(){const ee=[];for(const ge of ti.mine.getAllExtensionDescriptions())ee.push(new $e.$Fec(Rt,Te.identifier,ge,fi,!1));return ee},get allAcrossExtensionHosts(){(0,Xe.$MF)(Te,"extensionsAny");const ee=new b.$am(ti.mine.getAllExtensionDescriptions().map(Fe=>Fe.identifier)),ge=[];for(const Fe of ti.all.getAllExtensionDescriptions()){const ot=!ee.has(Fe.identifier);ge.push(new $e.$Fec(Rt,Te.identifier,Fe,fi,ot))}return ge},get onDidChange(){return(0,Xe.$LF)(Te,"extensionsAny")?P.Event.any(ti.mine.onDidChange,ti.all.onDidChange):ti.mine.onDidChange}},mn={createDiagnosticCollection(ee){return ai.createDiagnosticCollection(Te.identifier,ee)},get onDidChangeDiagnostics(){return ai.onDidChangeDiagnostics},getDiagnostics:ee=>ai.getDiagnostics(ee),getLanguages(){return ci.getLanguages()},setTextDocumentLanguage(ee,ge){return ci.changeLanguage(ee.uri,ge)},match(ee,ge){const Fe=It.getDocumentData(ge.uri)?.notebook;return(0,C.$KE)(Dt.LanguageSelector.from(ee),ge.uri,ge.languageId,!0,Fe?.uri,Fe?.notebookType)},registerCodeActionsProvider(ee,ge,Fe){return lt.registerCodeActionProvider(Te,mt(ee),ge,Fe)},registerDocumentPasteEditProvider(ee,ge,Fe){return(0,Xe.$MF)(Te,"documentPaste"),lt.registerDocumentPasteEditProvider(Te,mt(ee),ge,Fe)},registerCodeLensProvider(ee,ge){return lt.registerCodeLensProvider(Te,mt(ee),ge)},registerDefinitionProvider(ee,ge){return lt.registerDefinitionProvider(Te,mt(ee),ge)},registerDeclarationProvider(ee,ge){return lt.registerDeclarationProvider(Te,mt(ee),ge)},registerImplementationProvider(ee,ge){return lt.registerImplementationProvider(Te,mt(ee),ge)},registerTypeDefinitionProvider(ee,ge){return lt.registerTypeDefinitionProvider(Te,mt(ee),ge)},registerHoverProvider(ee,ge){return lt.registerHoverProvider(Te,mt(ee),ge,Te.identifier)},registerEvaluatableExpressionProvider(ee,ge){return lt.registerEvaluatableExpressionProvider(Te,mt(ee),ge,Te.identifier)},registerInlineValuesProvider(ee,ge){return lt.registerInlineValuesProvider(Te,mt(ee),ge,Te.identifier)},registerDocumentHighlightProvider(ee,ge){return lt.registerDocumentHighlightProvider(Te,mt(ee),ge)},registerLinkedEditingRangeProvider(ee,ge){return lt.registerLinkedEditingRangeProvider(Te,mt(ee),ge)},registerReferenceProvider(ee,ge){return lt.registerReferenceProvider(Te,mt(ee),ge)},registerRenameProvider(ee,ge){return lt.registerRenameProvider(Te,mt(ee),ge)},registerDocumentSymbolProvider(ee,ge,Fe){return lt.registerDocumentSymbolProvider(Te,mt(ee),ge,Fe)},registerWorkspaceSymbolProvider(ee){return lt.registerWorkspaceSymbolProvider(Te,ee)},registerDocumentFormattingEditProvider(ee,ge){return lt.registerDocumentFormattingEditProvider(Te,mt(ee),ge)},registerDocumentRangeFormattingEditProvider(ee,ge){return lt.registerDocumentRangeFormattingEditProvider(Te,mt(ee),ge)},registerOnTypeFormattingEditProvider(ee,ge,Fe,...ot){return lt.registerOnTypeFormattingEditProvider(Te,mt(ee),ge,[Fe].concat(ot))},registerDocumentSemanticTokensProvider(ee,ge,Fe){return lt.registerDocumentSemanticTokensProvider(Te,mt(ee),ge,Fe)},registerDocumentRangeSemanticTokensProvider(ee,ge,Fe){return lt.registerDocumentRangeSemanticTokensProvider(Te,mt(ee),ge,Fe)},registerSignatureHelpProvider(ee,ge,Fe,...ot){return typeof Fe=="object"?lt.registerSignatureHelpProvider(Te,mt(ee),ge,Fe):lt.registerSignatureHelpProvider(Te,mt(ee),ge,typeof Fe>"u"?[]:[Fe,...ot])},registerCompletionItemProvider(ee,ge,...Fe){return lt.registerCompletionItemProvider(Te,mt(ee),ge,Fe)},registerInlineCompletionItemProvider(ee,ge,Fe){return ge.handleDidShowCompletionItem&&(0,Xe.$MF)(Te,"inlineCompletionsAdditions"),ge.handleDidPartiallyAcceptCompletionItem&&(0,Xe.$MF)(Te,"inlineCompletionsAdditions"),Fe&&(0,Xe.$MF)(Te,"inlineCompletionsAdditions"),lt.registerInlineCompletionsProvider(Te,mt(ee),ge,Fe)},registerDocumentLinkProvider(ee,ge){return lt.registerDocumentLinkProvider(Te,mt(ee),ge)},registerColorProvider(ee,ge){return lt.registerColorProvider(Te,mt(ee),ge)},registerFoldingRangeProvider(ee,ge){return lt.registerFoldingRangeProvider(Te,mt(ee),ge)},registerSelectionRangeProvider(ee,ge){return lt.registerSelectionRangeProvider(Te,ee,ge)},registerCallHierarchyProvider(ee,ge){return lt.registerCallHierarchyProvider(Te,ee,ge)},registerTypeHierarchyProvider(ee,ge){return lt.registerTypeHierarchyProvider(Te,ee,ge)},setLanguageConfiguration:(ee,ge)=>lt.setLanguageConfiguration(Te,ee,ge),getTokenInformationAtPosition(ee,ge){return(0,Xe.$MF)(Te,"tokenInformation"),ci.tokenAtPosition(ee,ge)},registerInlayHintsProvider(ee,ge){return lt.registerInlayHintsProvider(Te,ee,ge)},createLanguageStatusItem(ee,ge){return ci.createLanguageStatusItem(Te,ee,ge)},registerDocumentDropEditProvider(ee,ge,Fe){return lt.registerDocumentOnDropEditProvider(Te,ee,ge,(0,Xe.$LF)(Te,"dropMetadata")?Fe:void 0)}},$n={get activeTextEditor(){return Ft.getActiveTextEditor()},get visibleTextEditors(){return Ft.getVisibleTextEditors()},get activeTerminal(){return bt.activeTerminal},get terminals(){return bt.terminals},async showTextDocument(ee,ge,Fe){const ot=await(E.URI.isUri(ee)?Promise.resolve(Bi.openTextDocument(ee)):Promise.resolve(ee));return Ft.showTextDocument(ot,ge,Fe)},createTextEditorDecorationType(ee){return Ft.createTextEditorDecorationType(Te,ee)},onDidChangeActiveTextEditor(ee,ge,Fe){return Ft.onDidChangeActiveTextEditor(ee,ge,Fe)},onDidChangeVisibleTextEditors(ee,ge,Fe){return Ft.onDidChangeVisibleTextEditors(ee,ge,Fe)},onDidChangeTextEditorSelection(ee,ge,Fe){return Ft.onDidChangeTextEditorSelection(ee,ge,Fe)},onDidChangeTextEditorOptions(ee,ge,Fe){return Ft.onDidChangeTextEditorOptions(ee,ge,Fe)},onDidChangeTextEditorVisibleRanges(ee,ge,Fe){return Ft.onDidChangeTextEditorVisibleRanges(ee,ge,Fe)},onDidChangeTextEditorViewColumn(ee,ge,Fe){return Ft.onDidChangeTextEditorViewColumn(ee,ge,Fe)},onDidCloseTerminal(ee,ge,Fe){return bt.onDidCloseTerminal(ee,ge,Fe)},onDidOpenTerminal(ee,ge,Fe){return bt.onDidOpenTerminal(ee,ge,Fe)},onDidChangeActiveTerminal(ee,ge,Fe){return bt.onDidChangeActiveTerminal(ee,ge,Fe)},onDidChangeTerminalDimensions(ee,ge,Fe){return(0,Xe.$MF)(Te,"terminalDimensions"),bt.onDidChangeTerminalDimensions(ee,ge,Fe)},onDidChangeTerminalState(ee,ge,Fe){return bt.onDidChangeTerminalState(ee,ge,Fe)},onDidWriteTerminalData(ee,ge,Fe){return(0,Xe.$MF)(Te,"terminalDataWriteEvent"),bt.onDidWriteTerminalData(ee,ge,Fe)},onDidExecuteTerminalCommand(ee,ge,Fe){return(0,Xe.$MF)(Te,"terminalExecuteCommandEvent"),bt.onDidExecuteTerminalCommand(ee,ge,Fe)},get state(){return Le.getState(Te)},onDidChangeWindowState(ee,ge,Fe){return Le.onDidChangeWindowState(ee,ge,Fe)},showInformationMessage(ee,...ge){return Ei.showMessage(Te,$.default.Info,ee,ge[0],ge.slice(1))},showWarningMessage(ee,...ge){return Ei.showMessage(Te,$.default.Warning,ee,ge[0],ge.slice(1))},showErrorMessage(ee,...ge){return Ei.showMessage(Te,$.default.Error,ee,ge[0],ge.slice(1))},showQuickPick(ee,ge,Fe){return ni.showQuickPick(Te,ee,ge,Fe)},showWorkspaceFolderPick(ee){return ni.showWorkspaceFolderPick(ee)},showInputBox(ee,ge){return ni.showInput(ee,ge)},showOpenDialog(ee){return Ui.showOpenDialog(Te,ee)},showSaveDialog(ee){return Ui.showSaveDialog(ee)},createStatusBarItem(ee,ge,Fe){let ot,wt,Tt;return typeof ee=="string"?(ot=ee,wt=ge,Tt=Fe):(wt=ee,Tt=ge),di.createStatusBarEntry(Te,ot,wt,Tt)},setStatusBarMessage(ee,ge){return di.setStatusBarMessage(ee,ge)},withScmProgress(ee){return H.report("window.withScmProgress",Te,"Use 'withProgress' instead."),Mi.withProgress(Te,{location:ze.ProgressLocation.SourceControl},(ge,Fe)=>ee({report(ot){}}))},withProgress(ee,ge){return Mi.withProgress(Te,ee,ge)},createOutputChannel(ee,ge){return Yt.createOutputChannel(ee,ge,Te)},createWebviewPanel(ee,ge,Fe,ot){return Ti.createWebviewPanel(Te,ee,ge,Fe,ot)},createWebviewTextEditorInset(ee,ge,Fe,ot){return(0,Xe.$MF)(Te,"editorInsets"),Ci.createWebviewEditorInset(ee,ge,Fe,ot,Te)},createTerminal(ee,ge,Fe){return typeof ee=="object"?"pty"in ee?bt.createExtensionTerminal(ee):bt.createTerminalFromOptions(ee):bt.createTerminal(ee,ge,Fe)},registerTerminalLinkProvider(ee){return bt.registerLinkProvider(ee)},registerTerminalProfileProvider(ee,ge){return bt.registerProfileProvider(Te,ee,ge)},registerTerminalQuickFixProvider(ee,ge){return(0,Xe.$MF)(Te,"terminalQuickFixProvider"),bt.registerTerminalQuickFixProvider(ee,Te.identifier.value,ge)},registerTreeDataProvider(ee,ge){return $i.registerTreeDataProvider(ee,ge,Te)},createTreeView(ee,ge){return $i.createTreeView(ee,ge,Te)},registerWebviewPanelSerializer:(ee,ge)=>Ti.registerWebviewPanelSerializer(Te,ee,ge),registerCustomEditorProvider:(ee,ge,Fe={})=>Oi.registerCustomEditorProvider(Te,ee,ge,Fe),registerFileDecorationProvider(ee){return it.registerFileDecorationProvider(ee,Te)},registerUriHandler(ee){return ki.registerUriHandler(Te,ee)},createQuickPick(){return ni.createQuickPick(Te)},createInputBox(){return ni.createInputBox(Te)},get activeColorTheme(){return Li.activeColorTheme},onDidChangeActiveColorTheme(ee,ge,Fe){return Li.onDidChangeActiveColorTheme(ee,ge,Fe)},registerWebviewViewProvider(ee,ge,Fe){return zi.registerWebviewViewProvider(Te,ee,ge,Fe?.webviewOptions)},get activeNotebookEditor(){return Et.activeNotebookEditor},onDidChangeActiveNotebookEditor(ee,ge,Fe){return Et.onDidChangeActiveNotebookEditor(ee,ge,Fe)},get visibleNotebookEditors(){return Et.visibleNotebookEditors},get onDidChangeVisibleNotebookEditors(){return Et.onDidChangeVisibleNotebookEditors},onDidChangeNotebookEditorSelection(ee,ge,Fe){return mi.onDidChangeNotebookEditorSelection(ee,ge,Fe)},onDidChangeNotebookEditorVisibleRanges(ee,ge,Fe){return mi.onDidChangeNotebookEditorVisibleRanges(ee,ge,Fe)},showNotebookDocument(ee,ge){return Et.showNotebookDocument(ee,ge)},registerExternalUriOpener(ee,ge,Fe){return(0,Xe.$MF)(Te,"externalUriOpener"),hn.registerExternalUriOpener(Te.identifier,ee,ge,Fe)},registerProfileContentHandler(ee,ge){return(0,Xe.$MF)(Te,"profileContentHandlers"),en.registrProfileContentHandler(Te,ee,ge)},registerQuickDiffProvider(ee,ge,Fe,ot){return(0,Xe.$MF)(Te,"quickDiffProvider"),Yi.registerQuickDiffProvider(mt(ee),ge,Fe,ot)},get tabGroups(){return Qe.tabGroups},registerShareProvider(ee,ge){return(0,Xe.$MF)(Te,"shareProvider"),Ri.registerShareProvider(mt(ee),ge)}},Bi={get rootPath(){return H.report("workspace.rootPath",Te,"Please use 'workspace.workspaceFolders' instead. More details: https://aka.ms/vscode-eliminating-rootpath"),ft.getPath()},set rootPath(ee){throw new F.$8("rootPath")},getWorkspaceFolder(ee){return ft.getWorkspaceFolder(ee)},get workspaceFolders(){return ft.getWorkspaceFolders()},get name(){return ft.name},set name(ee){throw new F.$8("name")},get workspaceFile(){return ft.workspaceFile},set workspaceFile(ee){throw new F.$8("workspaceFile")},updateWorkspaceFolders:(ee,ge,...Fe)=>ft.updateWorkspaceFolders(Te,ee,ge||0,...Fe),onDidChangeWorkspaceFolders:function(ee,ge,Fe){return ft.onDidChangeWorkspace(ee,ge,Fe)},asRelativePath:(ee,ge)=>ft.getRelativePath(ee,ge),findFiles:(ee,ge,Fe,ot)=>ft.findFiles(ee,ge,Fe,Te.identifier,ot),findTextInFiles:(ee,ge,Fe,ot)=>{(0,Xe.$MF)(Te,"findTextInFiles");let wt,Tt;return typeof ge=="object"?(wt=ge,Tt=Fe):(wt={},Tt=ge,ot=Fe),ft.findTextInFiles(ee,wt||{},Tt,Te.identifier,ot)},save:ee=>((0,Xe.$MF)(Te,"saveEditor"),ft.save(ee)),saveAs:ee=>((0,Xe.$MF)(Te,"saveEditor"),ft.saveAs(ee)),saveAll:ee=>ft.saveAll(ee),applyEdit(ee,ge){return yi.applyWorkspaceEdit(ee,Te,ge)},createFileSystemWatcher:(ee,ge,Fe,ot)=>{let wt;return typeof ge=="boolean"?wt={ignoreCreateEvents:!!ge,ignoreChangeEvents:!!Fe,ignoreDeleteEvents:!!ot,correlate:!1}:ge&&((0,Xe.$MF)(Te,"createFileSystemWatcher"),wt={...ge,correlate:!0}),xt.createFileSystemWatcher(ft,Te,ee,wt)},get textDocuments(){return It.getAllDocumentData().map(ee=>ee.document)},set textDocuments(ee){throw new F.$8("textDocuments")},openTextDocument(ee){let ge;const Fe=ee;if(typeof ee=="string")ge=Promise.resolve(E.URI.file(ee));else if(E.URI.isUri(ee))ge=Promise.resolve(ee);else if(!Fe||typeof Fe=="object")ge=It.createDocumentData(Fe);else throw new Error("illegal argument - uriOrFileNameOrOptions");return ge.then(ot=>It.ensureDocumentData(ot).then(wt=>wt.document))},onDidOpenTextDocument:(ee,ge,Fe)=>It.onDidAddDocument(ee,ge,Fe),onDidCloseTextDocument:(ee,ge,Fe)=>It.onDidRemoveDocument(ee,ge,Fe),onDidChangeTextDocument:(ee,ge,Fe)=>It.onDidChangeDocument(ee,ge,Fe),onDidSaveTextDocument:(ee,ge,Fe)=>It.onDidSaveDocument(ee,ge,Fe),onWillSaveTextDocument:(ee,ge,Fe)=>ln.getOnWillSaveTextDocumentEvent(Te)(ee,ge,Fe),get notebookDocuments(){return Et.notebookDocuments.map(ee=>ee.apiNotebook)},async openNotebookDocument(ee,ge){let Fe;if(E.URI.isUri(ee))Fe=ee,await Et.openNotebookDocument(ee);else if(typeof ee=="string")Fe=E.URI.revive(await Et.createNotebookDocument({viewType:ee,content:ge}));else throw new Error("Invalid arguments");return Et.getNotebookDocument(Fe).apiNotebook},onDidSaveNotebookDocument(ee,ge,Fe){return gi.onDidSaveNotebookDocument(ee,ge,Fe)},onDidChangeNotebookDocument(ee,ge,Fe){return gi.onDidChangeNotebookDocument(ee,ge,Fe)},onWillSaveNotebookDocument(ee,ge,Fe){return Ii.getOnWillSaveNotebookDocumentEvent(Te)(ee,ge,Fe)},get onDidOpenNotebookDocument(){return Et.onDidOpenNotebookDocument},get onDidCloseNotebookDocument(){return Et.onDidCloseNotebookDocument},registerNotebookSerializer(ee,ge,Fe,ot){return Et.registerNotebookSerializer(Te,ee,ge,Fe,(0,Xe.$LF)(Te,"notebookLiveShare")?ot:void 0)},onDidChangeConfiguration:(ee,ge,Fe)=>ji.onDidChangeConfiguration(ee,ge,Fe),getConfiguration(ee,ge){return ge=arguments.length===1?void 0:ge,ji.getConfiguration(ee,ge,Te)},registerTextDocumentContentProvider(ee,ge){return Zi.registerTextDocumentContentProvider(ee,ge)},registerTaskProvider:(ee,ge)=>(H.report("window.registerTaskProvider",Te,"Use the corresponding function on the 'tasks' namespace instead"),Qt.registerTaskProvider(Te,ee,ge)),registerFileSystemProvider(ee,ge,Fe){return(0,M.$Oc)(Pi.registerFileSystemProvider(Te,ee,ge,Fe),Pt.addFileSystemProvider(ee,ge,Fe))},get fs(){return Pt.value},registerFileSearchProvider:(ee,ge)=>((0,Xe.$MF)(Te,"fileSearchProvider"),Mt.registerFileSearchProvider(ee,ge)),registerTextSearchProvider:(ee,ge)=>((0,Xe.$MF)(Te,"textSearchProvider"),Mt.registerTextSearchProvider(ee,ge)),registerRemoteAuthorityResolver:(ee,ge)=>((0,Xe.$MF)(Te,"resolvers"),Rt.registerRemoteAuthorityResolver(ee,ge)),registerResourceLabelFormatter:ee=>((0,Xe.$MF)(Te,"resolvers"),xi.$registerResourceLabelFormatter(ee)),getRemoteExecServer:ee=>((0,Xe.$MF)(Te,"resolvers"),Rt.getRemoteExecServer(ee)),onDidCreateFiles:(ee,ge,Fe)=>xt.onDidCreateFile(ee,ge,Fe),onDidDeleteFiles:(ee,ge,Fe)=>xt.onDidDeleteFile(ee,ge,Fe),onDidRenameFiles:(ee,ge,Fe)=>xt.onDidRenameFile(ee,ge,Fe),onWillCreateFiles:(ee,ge,Fe)=>xt.getOnWillCreateFileEvent(Te)(ee,ge,Fe),onWillDeleteFiles:(ee,ge,Fe)=>xt.getOnWillDeleteFileEvent(Te)(ee,ge,Fe),onWillRenameFiles:(ee,ge,Fe)=>xt.getOnWillRenameFileEvent(Te)(ee,ge,Fe),openTunnel:ee=>((0,Xe.$MF)(Te,"tunnels"),ve.openTunnel(Te,ee).then(ge=>{if(!ge)throw new Error("cannot open tunnel");return ge})),get tunnels(){return(0,Xe.$MF)(Te,"tunnels"),ve.getTunnels()},onDidChangeTunnels:(ee,ge,Fe)=>((0,Xe.$MF)(Te,"tunnels"),ve.onDidChangeTunnels(ee,ge,Fe)),registerPortAttributesProvider:(ee,ge)=>((0,Xe.$MF)(Te,"portsAttributes"),ve.registerPortsAttributesProvider(ee,ge)),registerTunnelProvider:(ee,ge)=>((0,Xe.$MF)(Te,"tunnelFactory"),ve.registerTunnelProvider(ee,ge)),registerTimelineProvider:(ee,ge)=>((0,Xe.$MF)(Te,"timeline"),_i.registerTimelineProvider(ee,ge,Te.identifier,$t.converter)),get isTrusted(){return ft.trusted},requestWorkspaceTrust:ee=>((0,Xe.$MF)(Te,"workspaceTrust"),ft.requestWorkspaceTrust(ee)),onDidGrantWorkspaceTrust:(ee,ge,Fe)=>ft.onDidGrantWorkspaceTrust(ee,ge,Fe),registerEditSessionIdentityProvider:(ee,ge)=>((0,Xe.$MF)(Te,"editSessionIdentityProvider"),ft.registerEditSessionIdentityProvider(ee,ge)),onWillCreateEditSessionIdentity:(ee,ge,Fe)=>((0,Xe.$MF)(Te,"editSessionIdentityProvider"),ft.getOnWillCreateEditSessionIdentityEvent(Te)(ee,ge,Fe)),registerCanonicalUriProvider:(ee,ge)=>((0,Xe.$MF)(Te,"canonicalUriProvider"),ft.registerCanonicalUriProvider(ee,ge)),getCanonicalUri:(ee,ge,Fe)=>((0,Xe.$MF)(Te,"canonicalUriProvider"),ft.provideCanonicalUri(ee,ge,Fe))},cn={get inputBox(){return H.report("scm.inputBox",Te,"Use 'SourceControl.inputBox' instead"),pi.getLastInputBox(Te)},createSourceControl(ee,ge,Fe){return pi.createSourceControl(Te,ee,ge,Fe)}},Vi={createCommentController(ee,ge){return Ai.createCommentController(Te,ee,ge)}},Wi={get activeDebugSession(){return ut.activeDebugSession},get activeDebugConsole(){return ut.activeDebugConsole},get breakpoints(){return ut.breakpoints},get stackFrameFocus(){return ut.stackFrameFocus},onDidStartDebugSession(ee,ge,Fe){return ut.onDidStartDebugSession(ee,ge,Fe)},onDidTerminateDebugSession(ee,ge,Fe){return ut.onDidTerminateDebugSession(ee,ge,Fe)},onDidChangeActiveDebugSession(ee,ge,Fe){return ut.onDidChangeActiveDebugSession(ee,ge,Fe)},onDidReceiveDebugSessionCustomEvent(ee,ge,Fe){return ut.onDidReceiveDebugSessionCustomEvent(ee,ge,Fe)},onDidChangeBreakpoints(ee,ge,Fe){return ut.onDidChangeBreakpoints(ee,ge,Fe)},onDidChangeStackFrameFocus(ee,ge,Fe){return(0,Xe.$MF)(Te,"debugFocus"),ut.onDidChangeStackFrameFocus(ee,ge,Fe)},registerDebugConfigurationProvider(ee,ge,Fe){return ut.registerDebugConfigurationProvider(ee,ge,Fe||Lt.DebugConfigurationProviderTriggerKind.Initial)},registerDebugAdapterDescriptorFactory(ee,ge){return ut.registerDebugAdapterDescriptorFactory(Te,ee,ge)},registerDebugAdapterTrackerFactory(ee,ge){return ut.registerDebugAdapterTrackerFactory(ee,ge)},startDebugging(ee,ge,Fe){return!Fe||typeof Fe=="object"&&"configuration"in Fe?ut.startDebugging(ee,ge,{parentSession:Fe}):ut.startDebugging(ee,ge,Fe||{})},stopDebugging(ee){return ut.stopDebugging(ee)},addBreakpoints(ee){return ut.addBreakpoints(ee)},removeBreakpoints(ee){return ut.removeBreakpoints(ee)},asDebugSourceUri(ee,ge){return ut.asDebugSourceUri(ee,ge)}},qi={registerTaskProvider:(ee,ge)=>Qt.registerTaskProvider(Te,ee,ge),fetchTasks:ee=>Qt.fetchTasks(ee),executeTask:ee=>Qt.executeTask(Te,ee),get taskExecutions(){return Qt.taskExecutions},onDidStartTask:(ee,ge,Fe)=>Qt.onDidStartTask(ee,ge,Fe),onDidEndTask:(ee,ge,Fe)=>Qt.onDidEndTask(ee,ge,Fe),onDidStartTaskProcess:(ee,ge,Fe)=>Qt.onDidStartTaskProcess(ee,ge,Fe),onDidEndTaskProcess:(ee,ge,Fe)=>Qt.onDidEndTaskProcess(ee,ge,Fe)},li={createNotebookController(ee,ge,Fe,ot,wt){return oi.createNotebookController(Te,ee,ge,Fe,ot,(0,Xe.$LF)(Te,"notebookMessaging")?wt:void 0)},registerNotebookCellStatusBarItemProvider:(ee,ge)=>Et.registerNotebookCellStatusBarItemProvider(Te,ee,ge),createRendererMessaging(ee){return Si.createRendererMessaging(Te,ee)},createNotebookControllerDetectionTask(ee){return(0,Xe.$MF)(Te,"notebookKernelSource"),oi.createNotebookControllerDetectionTask(Te,ee)},registerKernelSourceActionProvider(ee,ge){return(0,Xe.$MF)(Te,"notebookKernelSource"),oi.registerKernelSourceActionProvider(Te,ee,ge)},onDidChangeNotebookCellExecutionState(ee,ge,Fe){return(0,Xe.$MF)(Te,"notebookCellExecutionState"),oi.onDidChangeNotebookCellExecutionState(ee,ge,Fe)}},Ki={t(...ee){if(typeof ee[0]=="string"){const ge=ee.shift(),Fe=!ee||typeof ee[0]!="object"?ee:ee[0];return si.getMessage(Te.identifier.value,{message:ge,args:Fe})}return si.getMessage(Te.identifier.value,ee[0])},get bundle(){return si.getBundle(Te.identifier.value)},get uri(){return si.getBundleUri(Te.identifier.value)}},Hi={_version:1,registerInteractiveEditorSessionProvider(ee,ge){return(0,Xe.$MF)(Te,"interactive"),Ni.registerProvider(Te,ee,ge={label:ge?.label??Te.displayName??Te.name})},registerInteractiveSessionProvider(ee,ge){return(0,Xe.$MF)(Te,"interactive"),bi.registerChatProvider(Te,ee,ge)},sendInteractiveRequestToProvider(ee,ge){return(0,Xe.$MF)(Te,"interactive"),bi.sendInteractiveRequestToProvider(ee,ge)},get onDidPerformUserAction(){return(0,Xe.$MF)(Te,"interactiveUserActions"),bi.onDidPerformUserAction},transferChatSession(ee,ge){return(0,Xe.$MF)(Te,"interactive"),bi.transferChatSession(ee,ge)}},Gi={getRelatedInformation(ee,ge){return(0,Xe.$MF)(Te,"aiRelatedInformation"),wi.getRelatedInformation(Te,ee,ge)},registerRelatedInformationProvider(ee,ge){return(0,Xe.$MF)(Te,"aiRelatedInformation"),wi.registerRelatedInformationProvider(Te,ee,ge)},registerEmbeddingVectorProvider(ee,ge){return(0,Xe.$MF)(Te,"aiRelatedInformation"),rn.registerEmbeddingVectorProvider(Te,ee,ge)}},Ji={registerChatResponseProvider(ee,ge,Fe){return(0,Xe.$MF)(Te,"chatProvider"),vi.registerProvider(Te.identifier,ee,ge,Fe)},requestChatAccess(ee){return(0,Xe.$MF)(Te,"chatRequestAccess"),vi.requestChatResponseProvider(Te.identifier,ee)},registerVariable(ee,ge,Fe){return(0,Xe.$MF)(Te,"chatVariables"),nn.registerVariableResolver(Te,ee,ge,Fe)},registerMappedEditsProvider(ee,ge){return(0,Xe.$MF)(Te,"mappedEditsProvider"),lt.registerMappedEditsProvider(Te,ee,ge)},createChatAgent(ee,ge){return(0,Xe.$MF)(Te,"chatAgents2"),tn.createChatAgent(Te,ee,ge)}},un={registerSpeechProvider(ee,ge){return(0,Xe.$MF)(Te,"speech"),dn.registerProvider(Te.identifier,ee,ge)}};return{version:gt.version,ai:Gi,authentication:fn,commands:gn,comments:Vi,chat:Ji,debug:Wi,env:Di,extensions:an,interactive:Hi,l10n:Ki,languages:mn,notebooks:li,scm:cn,speech:un,tasks:qi,tests:on,window:$n,workspace:Bi,Breakpoint:ze.$xL,TerminalOutputAnchor:ze.TerminalOutputAnchor,ChatAgentResultFeedbackKind:ze.ChatAgentResultFeedbackKind,ChatMessage:ze.$oM,ChatMessageRole:ze.ChatMessageRole,ChatVariableLevel:ze.ChatVariableLevel,CallHierarchyIncomingCall:ze.$WK,CallHierarchyItem:ze.$VK,CallHierarchyOutgoingCall:ze.$XK,CancellationError:F.$4,CancellationTokenSource:y.$2d,CandidatePortSource:o.CandidatePortSource,CodeAction:ze.$SK,CodeActionKind:ze.$TK,CodeActionTriggerKind:ze.CodeActionTriggerKind,CodeLens:ze.$YK,Color:ze.$_K,ColorInformation:ze.$aL,ColorPresentation:ze.$bL,ColorThemeKind:ze.ColorThemeKind,CommentMode:ze.CommentMode,CommentState:ze.CommentState,CommentThreadCollapsibleState:ze.CommentThreadCollapsibleState,CommentThreadState:ze.CommentThreadState,CompletionItem:ze.$6K,CompletionItemKind:ze.CompletionItemKind,CompletionItemTag:ze.CompletionItemTag,CompletionList:ze.$7K,CompletionTriggerKind:ze.CompletionTriggerKind,ConfigurationTarget:ze.ConfigurationTarget,CustomExecution:ze.$jL,DebugAdapterExecutable:ze.$BL,DebugAdapterInlineImplementation:ze.$EL,DebugAdapterNamedPipeServer:ze.$DL,DebugAdapterServer:ze.$CL,DebugConfigurationProviderTriggerKind:Lt.DebugConfigurationProviderTriggerKind,DebugConsoleMode:ze.DebugConsoleMode,DecorationRangeBehavior:ze.DecorationRangeBehavior,Diagnostic:ze.$NK,DiagnosticRelatedInformation:ze.$MK,DiagnosticSeverity:ze.DiagnosticSeverity,DiagnosticTag:ze.DiagnosticTag,Disposable:ze.$zK,DocumentHighlight:ze.$PK,DocumentHighlightKind:ze.DocumentHighlightKind,DocumentLink:ze.$$K,DocumentSymbol:ze.$RK,EndOfLine:ze.EndOfLine,EnvironmentVariableMutatorType:ze.EnvironmentVariableMutatorType,EvaluatableExpression:ze.$HL,InlineValueText:ze.$IL,InlineValueVariableLookup:ze.$JL,InlineValueEvaluatableExpression:ze.$KL,InlineCompletionTriggerKind:ze.InlineCompletionTriggerKind,EventEmitter:P.$Rd,ExtensionKind:ze.ExtensionKind,ExtensionMode:ze.ExtensionMode,ExternalUriOpenerPriority:ze.ExternalUriOpenerPriority,FileChangeType:ze.FileChangeType,FileDecoration:ze.$UL,FileDecoration2:ze.$UL,FileSystemError:ze.$ML,FileType:p.FileType,FilePermission:p.FilePermission,FoldingRange:ze.$NL,FoldingRangeKind:ze.FoldingRangeKind,FunctionBreakpoint:ze.$zL,InlineCompletionItem:ze.$8K,InlineCompletionList:ze.$9K,Hover:ze.$OK,IndentAction:D.IndentAction,Location:ze.$LK,MarkdownString:ze.$ZK,OverviewRulerLane:u.OverviewRulerLane,ParameterInformation:ze.$1K,PortAutoForwardAction:ze.PortAutoForwardAction,Position:ze.$AK,ProcessExecution:ze.$hL,ProgressLocation:ze.ProgressLocation,QuickInputButtons:ze.$TL,Range:ze.$BK,RelativePattern:ze.$vL,Selection:ze.$CK,SelectionRange:ze.$UK,SemanticTokens:ze.$QL,SemanticTokensBuilder:ze.$PL,SemanticTokensEdit:ze.$RL,SemanticTokensEdits:ze.$SL,SemanticTokensLegend:ze.$OL,ShellExecution:ze.$iL,ShellQuoting:ze.ShellQuoting,SignatureHelp:ze.$3K,SignatureHelpTriggerKind:ze.SignatureHelpTriggerKind,SignatureInformation:ze.$2K,SnippetString:ze.$KK,SourceBreakpoint:ze.$yL,StandardTokenType:ze.StandardTokenType,StatusBarAlignment:ze.StatusBarAlignment,SymbolInformation:ze.$QK,SymbolKind:ze.SymbolKind,SymbolTag:ze.SymbolTag,Task:ze.$kL,TaskGroup:ze.$gL,TaskPanelKind:ze.TaskPanelKind,TaskRevealKind:ze.TaskRevealKind,TaskScope:ze.TaskScope,TerminalLink:ze.$cL,TerminalQuickFixExecuteTerminalCommand:ze.$eL,TerminalQuickFixOpener:ze.$dL,TerminalLocation:ze.TerminalLocation,TerminalProfile:ze.$fL,TerminalExitReason:ze.TerminalExitReason,TextDocumentSaveReason:ze.TextDocumentSaveReason,TextEdit:ze.$GK,SnippetTextEdit:ze.$IK,TextEditorCursorStyle:f.TextEditorCursorStyle,TextEditorLineNumbersStyle:ze.TextEditorLineNumbersStyle,TextEditorRevealType:ze.TextEditorRevealType,TextEditorSelectionChangeKind:ze.TextEditorSelectionChangeKind,SyntaxTokenType:ze.SyntaxTokenType,TextDocumentChangeReason:ze.TextDocumentChangeReason,ThemeColor:ze.$uL,ThemeIcon:ze.$tL,TreeItem:ze.$lL,TreeItemCheckboxState:ze.TreeItemCheckboxState,TreeItemCollapsibleState:ze.TreeItemCollapsibleState,TypeHierarchyItem:ze.$dM,UIKind:Vt.UIKind,Uri:E.URI,ViewColumn:ze.ViewColumn,WorkspaceEdit:ze.$JK,DocumentDropEdit:ze.$rL,DocumentPasteEdit:ze.$sL,InlayHint:ze.$5K,InlayHintLabelPart:ze.$4K,InlayHintKind:ze.InlayHintKind,RemoteAuthorityResolverError:ze.$FK,ResolvedAuthority:ze.$DK,ManagedResolvedAuthority:ze.$EK,SourceControlInputBoxValidationType:ze.SourceControlInputBoxValidationType,ExtensionRuntime:ze.ExtensionRuntime,TimelineItem:ze.$5L,NotebookRange:ze.$WL,NotebookCellKind:ze.NotebookCellKind,NotebookCellExecutionState:ze.NotebookCellExecutionState,NotebookCellData:ze.$XL,NotebookData:ze.$YL,NotebookRendererScript:ze.$3L,NotebookCellStatusBarAlignment:ze.NotebookCellStatusBarAlignment,NotebookEditorRevealType:ze.NotebookEditorRevealType,NotebookCellOutput:ze.$1L,NotebookCellOutputItem:ze.$ZL,NotebookCellStatusBarItem:ze.$2L,NotebookControllerAffinity:ze.NotebookControllerAffinity,NotebookControllerAffinity2:ze.NotebookControllerAffinity2,NotebookEdit:ze.$HK,NotebookKernelSourceAction:ze.$4L,PortAttributes:ze.$7L,LinkedEditingRanges:ze.$6L,TestResultState:ze.TestResultState,TestRunRequest:ze.$8L,TestMessage:ze.$9L,TestMessage2:ze.$9L,TestTag:ze.$0L,TestRunProfileKind:ze.TestRunProfileKind,TextSearchCompleteMessageType:Wt.TextSearchCompleteMessageType,DataTransfer:ze.$qL,DataTransferItem:ze.$mL,CoveredCount:ze.$$L,FileCoverage:ze.$_L,StatementCoverage:ze.$aM,BranchCoverage:ze.$bM,FunctionCoverage:ze.$cM,WorkspaceTrustState:ze.WorkspaceTrustState,LanguageStatusSeverity:ze.LanguageStatusSeverity,QuickPickItemKind:ze.QuickPickItemKind,InputBoxValidationSeverity:ze.InputBoxValidationSeverity,TabInputText:ze.$eM,TabInputTextDiff:ze.$fM,TabInputTextMerge:ze.$gM,TabInputCustom:ze.$hM,TabInputNotebook:ze.$jM,TabInputNotebookDiff:ze.$kM,TabInputWebview:ze.$iM,TabInputTerminal:ze.$lM,TabInputInteractiveWindow:ze.$mM,TabInputChat:ze.$nM,TelemetryTrustedValue:r.$po,LogLevel:g.LogLevel,EditSessionIdentityMatch:c.EditSessionIdentityMatch,InteractiveSessionVoteDirection:ze.InteractiveSessionVoteDirection,InteractiveSessionCopyKind:ze.InteractiveSessionCopyKind,InteractiveEditorResponseFeedbackKind:ze.InteractiveEditorResponseFeedbackKind,StackFrameFocus:ze.$FL,ThreadFocus:ze.$GL,RelatedInformationType:ze.RelatedInformationType,SpeechToTextStatus:ze.SpeechToTextStatus}}}e.$Kfc=qt}),define(Pe[291],Re([1,0,70,112,35,110,36,32,61,64,115,117,118,85,87,81,111,63,42,84,59,62,256,15,116,82,83]),function(be,e,y,F,P,M,A,$,E,f,C,D,u,b,p,g,t,i,r,c,o,l,n,s,a,d,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,y.$Cr)(d.$zec,d.$yec,1),(0,y.$Cr)(s.$ej,n.$Lfc,1),(0,y.$Cr)(g.$Kdc,g.$Ldc,1),(0,y.$Cr)($.$VM,$.$UM,0),(0,y.$Cr)(A.$6dc,A.$4dc,0),(0,y.$Cr)(i.$8dc,i.$7dc,0),(0,y.$Cr)(D.$Jec,D.$Nec,0),(0,y.$Cr)(M.$Pec,M.$Oec,0),(0,y.$Cr)(E.$KM,E.$JM,0),(0,y.$Cr)(v.$Aec,v.$Bec,0),(0,y.$Cr)(r.$Hdc,r.$Gdc,0),(0,y.$Cr)(F.$jfc,F.$ifc,1),(0,y.$Cr)(u.$6ec,u.$7ec,0),(0,y.$Cr)(b.$oec,b.$nec,0),(0,y.$Cr)(C.$wfc,C.$vfc,0),(0,y.$Cr)(f.$rec,f.$uec,0),(0,y.$Cr)(p.$Rwb,p.$Swb,0),(0,y.$Cr)(t.$Jfc,t.$Ifc,0),(0,y.$Cr)(P.$3dc,P.$2dc,0),(0,y.$Cr)(c.$wec,c.$vec,0),(0,y.$Cr)(o.$TM,o.$QM,0),(0,y.$Cr)(l.$fec,l.$gec,0),(0,y.$Cr)(a.$Hec,a.$Iec,0)}),define(Pe[292],Re([1,0,290,37,2,287,7,14,275]),function(be,e,y,F,P,M,A,$,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vhc=void 0;class f extends M.$Ofc{j(){}getModule(b,p){for(const g of this.b){const t=g(b);if(t){b=t;break}}if(this.a.has(b))return this.a.get(b).load(b,p,()=>{throw new Error("CANNOT LOAD MODULE from here.")})}}class C extends F.$Dec{constructor(){super(...arguments),this.extensionRuntime=A.ExtensionRuntime.Webworker}async tb(){this.h.createInstance(E.$Uhc);const b=this.h.invokeFunction(y.$Kfc);this.r=this.h.createInstance(f,b,{mine:this.J,all:this.L}),await this.r.install(),performance.mark("code/extHost/didInitAPI"),await this.zb()}ub(b){return b.browser}async vb(b,p,g){p=p.with({path:D(p.path,".js")});const t=b?.identifier.value;t&&performance.mark(`code/extHost/willFetchExtensionCode/${t}`);const i=P.URI.revive(await this.C.$asBrowserUri(p)),r=await fetch(i.toString(!0));if(t&&performance.mark(`code/extHost/didFetchExtensionCode/${t}`),r.status!==200)throw new Error(r.statusText);const c=await r.text(),o=`${p.toString(!0)}#vscode-extension`,l=`${c}
//# sourceURL=${o}`;let n;try{n=new Function("module","exports","require",l)}catch(v){throw console.error(t?`Loading code for extension ${t} failed: ${v.message}`:`Loading code failed: ${v.message}`),console.error(`${p.toString(!0)}${typeof v.line=="number"?` line ${v.line}`:""}${typeof v.column=="number"?` column ${v.column}`:""}`),console.error(v),v}b&&await this.w.initializeLocalizedMessages(b);const s={},a={exports:s},d=v=>{const m=this.r.getModule(v,p);if(m===void 0)throw new Error(`Cannot load module '${v}'`);return m};try{return g.codeLoadingStart(),t&&performance.mark(`code/extHost/willLoadExtensionCode/${t}`),n(a,s,d),a.exports!==s?a.exports:s}finally{t&&performance.mark(`code/extHost/didLoadExtensionCode/${t}`),g.codeLoadingStop()}}async $setRemoteEnvironment(b){}async zb(b=5e3){if(!this.f.environment.isExtensionDevelopmentDebug)return;const p=Date.now()+b;for(;Date.now()<p&&!("__jsDebugIsReady"in globalThis);)await(0,$.$Yg)(10)}}e.$Vhc=C;function D(u,b){return u.endsWith(b)?u:u+b}}),define(Pe[293],Re([1,0,69,70,15,37,200,86,292]),function(be,e,y,F,P,M,A,$,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,F.$Cr)(P.$dj,new y.$Sh(A.$Nfc,[!0],!0)),(0,F.$Cr)(M.$Eec,E.$Vhc,0),(0,F.$Cr)($.$9dc,$.$0dc,0)}),define(Pe[299],Re([1,0,24,5,79,288,277,19,88,13,2,291,293]),function(be,e,y,F,P,M,A,$,E,f,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.create=void 0;const D=self.close.bind(self);self.close=()=>console.trace("'close' has been blocked");const u=postMessage.bind(self);self.postMessage=()=>console.trace("'postMessage' has been blocked");function b(n){return/^(file|vscode-remote):/i.test(n)}const p=fetch.bind(self);function g(n){self.fetch=async function(s,a){return s instanceof Request||b(String(s))&&(s=(await n(C.URI.parse(String(s)))).toString(!0)),p(s,a)},self.XMLHttpRequest=class extends XMLHttpRequest{open(s,a,d,v,m){(async()=>(b(a.toString())&&(a=(await n(C.URI.parse(a.toString()))).toString(!0)),super.open(s,a,d??!0,v,m)))()}}}if(self.importScripts=()=>{throw new Error("'importScripts' has been blocked")},self.addEventListener=()=>console.trace("'addEventListener' has been blocked"),self.AMDLoader=void 0,self.NLSLoaderPlugin=void 0,self.define=void 0,self.require=void 0,self.webkitRequestFileSystem=void 0,self.webkitRequestFileSystemSync=void 0,self.webkitResolveLocalFileSystemSyncURL=void 0,self.webkitResolveLocalFileSystemURL=void 0,self.Worker){const n=self.Worker;Worker=function(s,a){if(/^file:/i.test(s.toString()))s=f.$gg.uriToBrowserUri(C.URI.parse(s.toString())).toString(!0);else if(/^vscode-remote:/i.test(s.toString()))throw new Error("Creating workers from remote extensions is currently not supported.");const v=`(${function(h){function w(V){return typeof V=="string"||V instanceof URL?String(V).replace(/^file:\/\//i,"vscode-file://vscode-app"):V}const I=fetch.bind(self);self.fetch=function(V,K){return V instanceof Request?I(V,K):I(w(V),K)},self.XMLHttpRequest=class extends XMLHttpRequest{open(V,K,R,N,T){return super.open(V,w(K),R??!0,N,T)}};const L=importScripts.bind(self);self.importScripts=(...V)=>{L(...V.map(w))},L(h)}.toString()}('${s}'))`;a=a||{},a.name=a.name||$.$mc(s.toString());const m=new Blob([v],{type:"application/javascript"}),S=URL.createObjectURL(m);return new n(S,a)}}else self.Worker=class extends A.$Whc{constructor(n,s){super(u,n,{name:$.$mc(n.toString()),...s})}};const t=new class{constructor(){this.pid=void 0}exit(n){D()}};class i{constructor(){const s=new MessageChannel,a=new F.$Rd;let d=!1;u(s.port2,[s.port2]),s.port1.onmessage=v=>{const{data:m}=v;if(!(m instanceof ArrayBuffer)){console.warn("UNKNOWN data received",m);return}const S=y.$fe.wrap(new Uint8Array(m,0,m.byteLength));if((0,P.$im)(S,2)){d=!0,c("received terminate message from renderer");return}a.fire(S)},this.protocol={onMessage:a.event,send:v=>{if(!d){const m=v.buffer.buffer.slice(v.buffer.byteOffset,v.buffer.byteOffset+v.buffer.byteLength);s.port1.postMessage(m,[m])}}}}}function r(n){return new Promise(s=>{const a=n.onMessage(d=>{a.dispose();const v=JSON.parse(d.toString());n.send((0,P.$hm)(0)),s({protocol:n,initData:v})});n.send((0,P.$hm)(1))})}let c=n=>D();function o(n){return!!n&&typeof n=="object"&&n.type==="vscode.init"&&n.data instanceof Map}function l(){E.mark("code/extHost/willConnectToRenderer");const n=new i;return{onmessage(s){o(s)&&r(n.protocol).then(a=>{E.mark("code/extHost/didWaitForInitData");const d=new M.$Qfc(a.protocol,a.initData,t,null,s.data);g(v=>d.asBrowserUri(v)),c=v=>d.terminate(v)})}}}e.create=l})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/94959e85502687ec77e23eb0d4d4b1a827b919af/core/vs/workbench/api/worker/extensionHostWorker.js.map
