/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var G=["require","exports","vs/base/common/lifecycle","vs/base/common/platform","vs/base/common/observableInternal/logging","vs/base/common/observableInternal/base","vs/base/common/errors","vs/editor/common/tokens/lineTokens","vs/base/common/uri","vs/base/common/observableInternal/autorun","vs/base/common/observableInternal/derived","vs/base/common/observable","vs/base/common/buffer","vs/editor/common/core/eolCounter","vs/editor/common/encodedTokenAttributes","vs/editor/common/core/lineRange","vs/editor/common/tokens/contiguousMultilineTokensBuilder","vs/base/common/network","vs/base/common/resources","vs/base/common/async","vs/editor/common/languages/nullTokenize","vs/base/common/amd","vs/base/common/observableInternal/utils","vs/base/common/stream","vs/base/common/symbols","vs/editor/common/model/fixedArray","vs/base/common/arrays","vs/editor/common/tokens/contiguousTokensEditing","vs/editor/common/tokens/contiguousMultilineTokens","vs/base/common/extpath","vs/base/common/path","vs/base/common/strings","vs/amdX","vs/base/common/event","vs/editor/common/languages","vs/editor/common/model/textModelTokens","vs/base/common/stopwatch","vs/workbench/services/textMate/browser/tokenizationSupport/textMateTokenizationSupport","vs/workbench/services/textMate/browser/tokenizationSupport/tokenizationSupportWithLineLimit","vs/workbench/services/textMate/browser/backgroundTokenization/worker/textMateWorkerTokenizer","vs/workbench/services/textMate/common/TMScopeRegistry","vs/workbench/services/textMate/common/TMGrammarFactory","vs/base/common/assert","vs/base/common/lazy","vs/editor/common/core/position","vs/base/common/types","vs/base/common/cancellation","vs/editor/common/core/offsetRange","vs/editor/common/model/mirrorTextModel","vs/workbench/services/textMate/browser/backgroundTokenization/worker/textMateTokenizationWorker.worker"],V=function(p){for(var e=[],N=0,T=p.length;N<T;N++)e[N]=G[p[N]];return e};define(G[21],V([0,1]),function(p,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$T=e.$S=void 0,e.$S=!1;class N{static get(){const v=new Map,A=new Map,s=new Map,c=new Map;function t(f,i){f.has(i.detail)||f.set(i.detail,-i.timestamp)}function r(f,i){const n=f.get(i.detail);n&&(n>=0||f.set(i.detail,n+i.timestamp))}let h=[];typeof p=="function"&&typeof p.getStats=="function"&&(h=p.getStats().slice(0).sort((f,i)=>f.timestamp-i.timestamp));for(const f of h)switch(f.type){case 10:t(v,f);break;case 11:case 12:r(v,f);break;case 21:t(A,f);break;case 22:r(A,f);break;case 33:t(s,f);break;case 34:r(s,f);break;case 31:t(c,f);break;case 32:r(c,f);break}let u=0;s.forEach(f=>u+=f);function l(f){const i=[];return f.forEach((n,a)=>i.push([a,n])),i}return{amdLoad:l(v),amdInvoke:l(A),nodeRequire:l(s),nodeEval:l(c),nodeRequireTotal:u}}static toMarkdownTable(v,A){let s="";const c=[];return v.forEach((t,r)=>{c[r]=t.length}),A.forEach(t=>{t.forEach((r,h)=>{typeof r>"u"&&(r=t[h]="-");const u=r.toString().length;c[h]=Math.max(u,c[h])})}),v.forEach((t,r)=>{s+=`| ${t+" ".repeat(c[r]-t.toString().length)} `}),s+=`|
`,v.forEach((t,r)=>{s+=`| ${"-".repeat(c[r])} `}),s+=`|
`,A.forEach(t=>{t.forEach((r,h)=>{typeof r<"u"&&(s+=`| ${r+" ".repeat(c[h]-r.toString().length)} `)}),s+=`|
`}),s}}e.$T=N}),define(G[4],V([0,1]),function(p,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rd=e.$qd=e.$pd=void 0;let N;function T(n){N=n}e.$pd=T;function v(){return N}e.$qd=v;class A{constructor(){this.a=0,this.d=new WeakMap}b(a){return s([c(f("|  ",this.a)),a])}c(a){return a.hadValue?a.didChange?[c(" "),r(h(a.oldValue,70),{color:"red",strikeThrough:!0}),c(" "),r(h(a.newValue,60),{color:"green"})]:[c(" (unchanged)")]:[c(" "),r(h(a.newValue,60),{color:"green"}),c(" (initial)")]}handleObservableChanged(a,b){console.log(...this.b([t("observable value changed"),r(a.debugName,{color:"BlueViolet"}),...this.c(b)]))}formatChanges(a){if(a.size!==0)return r(" (changed deps: "+[...a].map(b=>b.debugName).join(", ")+")",{color:"gray"})}handleDerivedCreated(a){const b=a.handleChange;this.d.set(a,new Set),a.handleChange=(C,B)=>(this.d.get(a).add(C),b.apply(a,[C,B]))}handleDerivedRecomputed(a,b){const C=this.d.get(a);console.log(...this.b([t("derived recomputed"),r(a.debugName,{color:"BlueViolet"}),...this.c(b),this.formatChanges(C),{data:[{fn:a._computeFn}]}])),C.clear()}handleFromEventObservableTriggered(a,b){console.log(...this.b([t("observable from event triggered"),r(a.debugName,{color:"BlueViolet"}),...this.c(b),{data:[{fn:a._getValue}]}]))}handleAutorunCreated(a){const b=a.handleChange;this.d.set(a,new Set),a.handleChange=(C,B)=>(this.d.get(a).add(C),b.apply(a,[C,B]))}handleAutorunTriggered(a){const b=this.d.get(a);console.log(...this.b([t("autorun"),r(a.debugName,{color:"BlueViolet"}),this.formatChanges(b),{data:[{fn:a._runFn}]}])),b.clear(),this.a++}handleAutorunFinished(a){this.a--}handleBeginTransaction(a){let b=a.getDebugName();b===void 0&&(b=""),console.log(...this.b([t("transaction"),r(b,{color:"BlueViolet"}),{data:[{fn:a._fn}]}])),this.a++}handleEndTransaction(){this.a--}}e.$rd=A;function s(n){const a=new Array,b=[];let C="";function B(I){if("length"in I)for(const g of I)g&&B(g);else"text"in I?(C+=`%c${I.text}`,a.push(I.style),I.data&&b.push(...I.data)):"data"in I&&b.push(...I.data)}B(n);const L=[C,...a];return L.push(...b),L}function c(n){return r(n,{color:"black"})}function t(n){return r(i(`${n}: `,10),{color:"black",bold:!0})}function r(n,a={color:"black"}){function b(B){return Object.entries(B).reduce((L,[I,g])=>`${L}${I}:${g};`,"")}const C={color:a.color};return a.strikeThrough&&(C["text-decoration"]="line-through"),a.bold&&(C["font-weight"]="bold"),{text:n,style:b(C)}}function h(n,a){switch(typeof n){case"number":return""+n;case"string":return n.length+2<=a?`"${n}"`:`"${n.substr(0,a-7)}"+...`;case"boolean":return n?"true":"false";case"undefined":return"undefined";case"object":return n===null?"null":Array.isArray(n)?u(n,a):l(n,a);case"symbol":return n.toString();case"function":return`[[Function${n.name?" "+n.name:""}]]`;default:return""+n}}function u(n,a){let b="[ ",C=!0;for(const B of n){if(C||(b+=", "),b.length-5>a){b+="...";break}C=!1,b+=`${h(B,a-b.length)}`}return b+=" ]",b}function l(n,a){let b="{ ",C=!0;for(const[B,L]of Object.entries(n)){if(C||(b+=", "),b.length-5>a){b+="...";break}C=!1,b+=`${B}: ${h(L,a-b.length)}`}return b+=" }",b}function f(n,a){let b="";for(let C=1;C<=a;C++)b+=n;return b}function i(n,a){for(;n.length<a;)n+=" ";return n}}),define(G[5],V([0,1,4]),function(p,e,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Md=e.$Ld=e.$Kd=e.$Jd=e.$Id=e.$Hd=e.$Gd=e.$Fd=e.$Ed=e.$Dd=e.$Cd=e.$Bd=e.$Ad=e.$zd=e.$yd=void 0;let T;function v(m){T=m}e.$yd=v;let A;function s(m){A=m}e.$zd=s;class c{get TChange(){return null}reportChanges(){this.get()}read(k){return k?k.readObservable(this):this.get()}map(k,F){const S=F===void 0?void 0:k,d=F===void 0?k:F;return A({owner:S,debugName:()=>{const M=E(d);if(M!==void 0)return M;const z=/^\s*\(?\s*([a-zA-Z_$][a-zA-Z_$0-9]*)\s*\)?\s*=>\s*\1(?:\??)\.([a-zA-Z_$][a-zA-Z_$0-9]*)\s*$/.exec(d.toString());if(z)return`${this.debugName}.${z[2]}`;if(!S)return`${this.debugName} (mapped)`}},M=>d(this.read(M),M))}recomputeInitiallyAndOnChange(k,F){return k.add(T(this,F)),this}}e.$Ad=c;class t extends c{constructor(){super(...arguments),this.c=new Set}addObserver(k){const F=this.c.size;this.c.add(k),F===0&&this.f()}removeObserver(k){this.c.delete(k)&&this.c.size===0&&this.g()}f(){}g(){}}e.$Bd=t;function r(m,k){const F=new i(m,k);try{m(F)}finally{F.finish()}}e.$Cd=r;let h;function u(m){if(h)m(h);else{const k=new i(m,void 0);h=k;try{m(k)}finally{k.finish(),h=void 0}}}e.$Dd=u;async function l(m,k){const F=new i(m,k);try{await m(F)}finally{F.finish()}}e.$Ed=l;function f(m,k,F){m?k(m):r(k,F)}e.$Fd=f;class i{constructor(k,F){this._fn=k,this.b=F,this.a=[],(0,N.$qd)()?.handleBeginTransaction(this)}getDebugName(){return this.b?this.b():E(this._fn)}updateObserver(k,F){this.a.push({observer:k,observable:F}),k.beginUpdate(F)}finish(){const k=this.a;for(let F=0;F<k.length;F++){const{observer:S,observable:d}=k[F];S.endUpdate(d)}this.a=null,(0,N.$qd)()?.handleEndTransaction()}}e.$Gd=i;const n=new Map,a=new WeakMap;function b(m,k,F,S,d){const M=a.get(m);if(M)return M;const D=C(m,k,F,S,d);if(D){let z=n.get(D)??0;z++,n.set(D,z);const W=z===1?D:`${D}#${z}`;return a.set(m,W),W}}e.$Hd=b;function C(m,k,F,S,d){const M=a.get(m);if(M)return M;const D=S?I(S)+".":"";let z;if(k!==void 0)if(typeof k=="function"){if(z=k(),z!==void 0)return D+z}else return D+k;if(F!==void 0&&(z=E(F),z!==void 0))return D+z;if(S!==void 0){for(const W in S)if(S[W]===d)return D+W}}const B=new Map,L=new WeakMap;function I(m){const k=L.get(m);if(k)return k;const F=g(m);let S=B.get(F)??0;S++,B.set(F,S);const d=S===1?F:`${F}#${S}`;return L.set(m,d),d}function g(m){const k=m.constructor;return k?k.name:"Object"}function E(m){const k=m.toString(),S=/\/\*\*\s*@description\s*([^*]*)\*\//.exec(k);return(S?S[1]:void 0)?.trim()}e.$Id=E;function w(m,k){return typeof m=="string"?new O(void 0,m,k):new O(m,void 0,k)}e.$Jd=w;class O extends t{get debugName(){return b(this,this.d,void 0,this.b,this)??"ObservableValue"}constructor(k,F,S){super(),this.b=k,this.d=F,this.a=S}get(){return this.a}set(k,F,S){if(this.a===k)return;let d;F||(F=d=new i(()=>{},()=>`Setting ${this.debugName}`));try{const M=this.a;this.e(k),(0,N.$qd)()?.handleObservableChanged(this,{oldValue:M,newValue:k,change:S,didChange:!0,hadValue:!0});for(const D of this.c)F.updateObserver(D,this),D.handleChange(this,S)}finally{d&&d.finish()}}toString(){return`${this.debugName}: ${this.a}`}e(k){this.a=k}}e.$Kd=O;function U(m,k){return typeof m=="string"?new $(void 0,m,k):new $(m,void 0,k)}e.$Ld=U;class $ extends O{e(k){this.a!==k&&(this.a&&this.a.dispose(),this.a=k)}dispose(){this.a?.dispose()}}e.$Md=$}),define(G[9],V([0,1,42,2,5,4]),function(p,e,N,T,v,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bd=e.$ad=e.$_c=e.$$c=e.$0c=e.$9c=e.$8c=void 0;function s(i){return new l(void 0,i,void 0,void 0)}e.$8c=s;function c(i,n){return new l(i.debugName,n,void 0,void 0)}e.$9c=c;function t(i,n){return new l(i.debugName,n,i.createEmptyChangeSummary,i.handleChange)}e.$0c=t;function r(i,n){const a=new T.$Qc,b=t({debugName:i.debugName??(()=>(0,v.$Id)(n)),createEmptyChangeSummary:i.createEmptyChangeSummary,handleChange:i.handleChange},(C,B)=>{a.clear(),n(C,B,a)});return(0,T.$Pc)(()=>{b.dispose(),a.dispose()})}e.$$c=r;function h(i){const n=new T.$Qc,a=c({debugName:()=>(0,v.$Id)(i)||"(anonymous)"},b=>{n.clear(),i(b,n)});return(0,T.$Pc)(()=>{a.dispose(),n.dispose()})}e.$_c=h;var u;(function(i){i[i.dependenciesMightHaveChanged=1]="dependenciesMightHaveChanged",i[i.stale=2]="stale",i[i.upToDate=3]="upToDate"})(u||(u={}));class l{get debugName(){if(typeof this.h=="string")return this.h;if(typeof this.h=="function"){const a=this.h();if(a!==void 0)return a}const n=(0,v.$Id)(this._runFn);return n!==void 0?n:"(anonymous)"}constructor(n,a,b,C){this.h=n,this._runFn=a,this.i=b,this.j=C,this.a=2,this.b=0,this.c=!1,this.e=new Set,this.f=new Set,this.g=this.i?.(),(0,A.$qd)()?.handleAutorunCreated(this),this.k(),(0,T.$Ic)(this)}dispose(){this.c=!0;for(const n of this.e)n.removeObserver(this);this.e.clear(),(0,T.$Jc)(this)}k(){if(this.a===3)return;const n=this.f;this.f=this.e,this.e=n,this.a=3;const a=this.c;try{if(!a){(0,A.$qd)()?.handleAutorunTriggered(this);const b=this.g;this.g=this.i?.(),this._runFn(this,b)}}finally{a||(0,A.$qd)()?.handleAutorunFinished(this);for(const b of this.f)b.removeObserver(this);this.f.clear()}}toString(){return`Autorun<${this.debugName}>`}beginUpdate(){this.a===3&&(this.a=1),this.b++}endUpdate(){if(this.b===1)do{if(this.a===1){this.a=3;for(const n of this.e)if(n.reportChanges(),this.a===2)break}this.k()}while(this.a!==3);this.b--,(0,N.$6c)(()=>this.b>=0)}handlePossibleChange(n){this.a===3&&this.e.has(n)&&!this.f.has(n)&&(this.a=1)}handleChange(n,a){this.e.has(n)&&!this.f.has(n)&&(!this.j||this.j({changedObservable:n,change:a,didChange:C=>C===n},this.g))&&(this.a=2)}readObservable(n){if(this.c)return n.get();n.addObserver(this);const a=n.get();return this.e.add(n),this.f.delete(n),a}}e.$ad=l,function(i){i.Observer=l}(s||(e.$8c=s={}));function f(i,n){let a;return c({debugName:()=>(0,v.$Id)(n)},b=>{const C=i.read(b),B=a;a=C,n({lastValue:B,newValue:C})})}e.$bd=f}),define(G[10],V([0,1,6,2,5,4]),function(p,e,N,T,v,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xd=e.$wd=e.$vd=e.$ud=e.$td=e.$sd=void 0;const s=(i,n)=>i===n;function c(i,n){return n!==void 0?new f(i,void 0,n,void 0,void 0,void 0,s):new f(void 0,void 0,i,void 0,void 0,void 0,s)}e.$sd=c;function t(i,n){return new f(i.owner,i.debugName,n,void 0,void 0,void 0,i.equalityComparer??s)}e.$td=t;function r(i,n){return new f(i.owner,i.debugName,n,i.createEmptyChangeSummary,i.handleChange,void 0,i.equalityComparer??s)}e.$ud=r;function h(i,n){let a,b;n===void 0?(a=i,b=void 0):(b=i,a=n);const C=new T.$Qc;return new f(b,()=>(0,v.$Id)(a)??"(anonymous)",B=>(C.clear(),a(B,C)),void 0,void 0,()=>C.dispose(),s)}e.$vd=h;function u(i,n){let a,b;n===void 0?(a=i,b=void 0):(b=i,a=n);const C=new T.$Qc;return new f(b,()=>(0,v.$Id)(a)??"(anonymous)",B=>{C.clear();const L=a(B);return L&&C.add(L),L},void 0,void 0,()=>C.dispose(),s)}e.$wd=u,(0,v.$zd)(t);var l;(function(i){i[i.initial=0]="initial",i[i.dependenciesMightHaveChanged=1]="dependenciesMightHaveChanged",i[i.stale=2]="stale",i[i.upToDate=3]="upToDate"})(l||(l={}));class f extends v.$Bd{get debugName(){return(0,v.$Hd)(this,this.p,this._computeFn,this.n,this)??"(anonymous)"}constructor(n,a,b,C,B,L=void 0,I){super(),this.n=n,this.p=a,this._computeFn=b,this.q=C,this.s=B,this.t=L,this.u=I,this.e=0,this.h=void 0,this.j=0,this.k=new Set,this.l=new Set,this.m=void 0,this.m=this.q?.(),(0,A.$qd)()?.handleDerivedCreated(this)}g(){this.e=0,this.h=void 0;for(const n of this.k)n.removeObserver(this);this.k.clear(),this.t?.()}get(){if(this.c.size===0){const n=this._computeFn(this,this.q?.());return this.g(),n}else{do{if(this.e===1){for(const n of this.k)if(n.reportChanges(),this.e===2)break}this.e===1&&(this.e=3),this.w()}while(this.e!==3);return this.h}}w(){if(this.e===3)return;const n=this.l;this.l=this.k,this.k=n;const a=this.e!==0,b=this.h;this.e=3;const C=this.m;this.m=this.q?.();try{this.h=this._computeFn(this,C)}finally{for(const L of this.l)L.removeObserver(this);this.l.clear()}const B=a&&!this.u(b,this.h);if((0,A.$qd)()?.handleDerivedRecomputed(this,{oldValue:b,newValue:this.h,change:void 0,didChange:B,hadValue:a}),B)for(const L of this.c)L.handleChange(this,void 0)}toString(){return`LazyDerived<${this.debugName}>`}beginUpdate(n){this.j++;const a=this.j===1;if(this.e===3&&(this.e=1,!a))for(const b of this.c)b.handlePossibleChange(this);if(a)for(const b of this.c)b.beginUpdate(this)}endUpdate(n){if(this.j--,this.j===0){const a=[...this.c];for(const b of a)b.endUpdate(this)}if(this.j<0)throw new N.$bb}handlePossibleChange(n){if(this.e===3&&this.k.has(n)&&!this.l.has(n)){this.e=1;for(const a of this.c)a.handlePossibleChange(this)}}handleChange(n,a){if(this.k.has(n)&&!this.l.has(n)){const b=this.s?this.s({changedObservable:n,change:a,didChange:B=>B===n},this.m):!0,C=this.e===3;if(b&&(this.e===1||C)&&(this.e=2,C))for(const B of this.c)B.handlePossibleChange(this)}}readObservable(n){n.addObserver(this);const a=n.get();return this.k.add(n),this.l.delete(n),a}addObserver(n){const a=!this.c.has(n)&&this.j>0;super.addObserver(n),a&&n.beginUpdate(this)}removeObserver(n){const a=this.c.has(n)&&this.j>0;super.removeObserver(n),a&&n.endUpdate(this)}}e.$xd=f}),define(G[22],V([0,1,2,9,5,10,4]),function(p,e,N,T,v,A,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$od=e.$nd=e.$md=e.$ld=e.$kd=e.$jd=e.$id=e.$hd=e.$gd=e.$fd=e.$ed=e.$dd=e.$cd=void 0;function c(w){return new t(w)}e.$cd=c;class t extends v.$Ad{constructor(O){super(),this.a=O}get debugName(){return this.toString()}get(){return this.a}addObserver(O){}removeObserver(O){}toString(){return`Const: ${this.a}`}}function r(w){const O=(0,v.$Jd)("promiseValue",{});return w.then(U=>{O.set({value:U},void 0)}),O}e.$dd=r;function h(w,O){return new Promise(U=>{let $=!1,m=!1;const k=w.map(S=>({isFinished:O(S),state:S})),F=(0,T.$8c)(S=>{const{isFinished:d,state:M}=k.read(S);d&&($?F.dispose():m=!0,U(M))});$=!0,m&&F.dispose()})}e.$ed=h;function u(w,O){return new l(w,O)}e.$fd=u;class l extends v.$Bd{constructor(O,U){super(),this.h=O,this._getValue=U,this.b=!1,this.l=$=>{const m=this._getValue($),k=this.a,F=!this.b||k!==m;let S=!1;F&&(this.a=m,this.b&&(S=!0,(0,v.$Fd)(l.globalTransaction,d=>{(0,s.$qd)()?.handleFromEventObservableTriggered(this,{oldValue:k,newValue:m,change:void 0,didChange:F,hadValue:this.b});for(const M of this.c)d.updateObserver(M,this),M.handleChange(this,void 0)},()=>{const d=this.j();return"Event fired"+(d?`: ${d}`:"")})),this.b=!0),S||(0,s.$qd)()?.handleFromEventObservableTriggered(this,{oldValue:k,newValue:m,change:void 0,didChange:F,hadValue:this.b})}}j(){return(0,v.$Id)(this._getValue)}get debugName(){const O=this.j();return"From Event"+(O?`: ${O}`:"")}f(){this.e=this.h(this.l)}g(){this.e.dispose(),this.e=void 0,this.b=!1,this.a=void 0}get(){return this.e?(this.b||this.l(void 0),this.a):this._getValue(void 0)}}e.$gd=l,function(w){w.Observer=l;function O(U,$){let m=!1;l.globalTransaction===void 0&&(l.globalTransaction=U,m=!0);try{$()}finally{m&&(l.globalTransaction=void 0)}}w.batchEventsGlobally=O}(u||(e.$fd=u={}));function f(w,O){return new i(w,O)}e.$hd=f;class i extends v.$Bd{constructor(O,U){super(),this.debugName=O,this.b=U,this.h=()=>{(0,v.$Cd)($=>{for(const m of this.c)$.updateObserver(m,this),m.handleChange(this,void 0)},()=>this.debugName)}}f(){this.a=this.b(this.h)}g(){this.a.dispose(),this.a=void 0}get(){}}function n(w){return typeof w=="string"?new a(w):new a(void 0,w)}e.$id=n;class a extends v.$Bd{get debugName(){return(0,v.$Hd)(this,this.a,void 0,this.b,this)??"Observable Signal"}constructor(O,U){super(),this.a=O,this.b=U}trigger(O,U){if(!O){(0,v.$Cd)($=>{this.trigger($,U)},()=>`Trigger signal ${this.debugName}`);return}for(const $ of this.c)O.updateObserver($,this),$.handleChange(this,U)}get(){}}function b(w,O,U){const $=(0,v.$Jd)("debounced",void 0);let m;return U.add((0,T.$8c)(k=>{const F=w.read(k);m&&clearTimeout(m),m=setTimeout(()=>{(0,v.$Cd)(S=>{$.set(F,S)})},O)})),$}e.$jd=b;function C(w,O,U){const $=(0,v.$Jd)("triggeredRecently",!1);let m;return U.add(w(()=>{$.set(!0,void 0),m&&clearTimeout(m),m=setTimeout(()=>{$.set(!1,void 0)},O)})),$}e.$kd=C;function B(w){const O=new I(!1,void 0);return w.addObserver(O),(0,N.$Pc)(()=>{w.removeObserver(O)})}e.$ld=B;function L(w,O){const U=new I(!0,O);return w.addObserver(U),O?O(w.get()):w.reportChanges(),(0,N.$Pc)(()=>{w.removeObserver(U)})}e.$md=L,(0,v.$yd)(L);class I{constructor(O,U){this.b=O,this.c=U,this.a=0}beginUpdate(O){this.a++}endUpdate(O){this.a--,this.a===0&&this.b&&(this.c?this.c(O.get()):O.reportChanges())}handlePossibleChange(O){}handleChange(O,U){}}function g(w){let O;return(0,A.$sd)($=>(O=w($,O),O))}e.$nd=g;function E(w,O){let U;const $=(0,v.$Jd)("derivedObservableWithWritableCache.counter",0),m=(0,A.$sd)(w,k=>($.read(k),U=O(k,U),U));return Object.assign(m,{clearCache:k=>{U=void 0,$.set($.get()+1,k)}})}e.$od=E}),define(G[11],V([0,1,5,10,9,22,4]),function(p,e,N,T,v,A,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.wasEventTriggeredRecently=e.waitForState=e.observableSignalFromEvent=e.observableSignal=e.observableFromPromise=e.observableFromEvent=e.recomputeInitiallyAndOnChange=e.keepObserved=e.derivedObservableWithWritableCache=e.derivedObservableWithCache=e.debouncedObservable=e.constObservable=e.autorunWithStoreHandleChanges=e.autorunOpts=e.autorunWithStore=e.autorunHandleChanges=e.autorunDelta=e.autorun=e.derivedWithStore=e.derivedHandleChanges=e.derivedOpts=e.derived=e.subtransaction=e.transaction=e.disposableObservableValue=e.observableValue=void 0,Object.defineProperty(e,"observableValue",{enumerable:!0,get:function(){return N.$Jd}}),Object.defineProperty(e,"disposableObservableValue",{enumerable:!0,get:function(){return N.$Ld}}),Object.defineProperty(e,"transaction",{enumerable:!0,get:function(){return N.$Cd}}),Object.defineProperty(e,"subtransaction",{enumerable:!0,get:function(){return N.$Fd}}),Object.defineProperty(e,"derived",{enumerable:!0,get:function(){return T.$sd}}),Object.defineProperty(e,"derivedOpts",{enumerable:!0,get:function(){return T.$td}}),Object.defineProperty(e,"derivedHandleChanges",{enumerable:!0,get:function(){return T.$ud}}),Object.defineProperty(e,"derivedWithStore",{enumerable:!0,get:function(){return T.$vd}}),Object.defineProperty(e,"autorun",{enumerable:!0,get:function(){return v.$8c}}),Object.defineProperty(e,"autorunDelta",{enumerable:!0,get:function(){return v.$bd}}),Object.defineProperty(e,"autorunHandleChanges",{enumerable:!0,get:function(){return v.$0c}}),Object.defineProperty(e,"autorunWithStore",{enumerable:!0,get:function(){return v.$_c}}),Object.defineProperty(e,"autorunOpts",{enumerable:!0,get:function(){return v.$9c}}),Object.defineProperty(e,"autorunWithStoreHandleChanges",{enumerable:!0,get:function(){return v.$$c}}),Object.defineProperty(e,"constObservable",{enumerable:!0,get:function(){return A.$cd}}),Object.defineProperty(e,"debouncedObservable",{enumerable:!0,get:function(){return A.$jd}}),Object.defineProperty(e,"derivedObservableWithCache",{enumerable:!0,get:function(){return A.$nd}}),Object.defineProperty(e,"derivedObservableWithWritableCache",{enumerable:!0,get:function(){return A.$od}}),Object.defineProperty(e,"keepObserved",{enumerable:!0,get:function(){return A.$ld}}),Object.defineProperty(e,"recomputeInitiallyAndOnChange",{enumerable:!0,get:function(){return A.$md}}),Object.defineProperty(e,"observableFromEvent",{enumerable:!0,get:function(){return A.$fd}}),Object.defineProperty(e,"observableFromPromise",{enumerable:!0,get:function(){return A.$dd}}),Object.defineProperty(e,"observableSignal",{enumerable:!0,get:function(){return A.$id}}),Object.defineProperty(e,"observableSignalFromEvent",{enumerable:!0,get:function(){return A.$hd}}),Object.defineProperty(e,"waitForState",{enumerable:!0,get:function(){return A.$ed}}),Object.defineProperty(e,"wasEventTriggeredRecently",{enumerable:!0,get:function(){return A.$kd}}),!1&&(0,s.$pd)(new s.$rd)}),define(G[23],V([0,1,6,2]),function(p,e,N,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ee=e.$de=e.$ce=e.$be=e.$ae=e.$_d=e.$$d=e.$0d=e.$9d=e.$8d=e.$7d=e.$6d=e.$5d=e.$4d=e.$3d=void 0;function v(L){const I=L;return I?typeof I.read=="function":!1}e.$3d=v;function A(L){const I=L;return I?[I.on,I.pause,I.resume,I.destroy].every(g=>typeof g=="function"):!1}e.$4d=A;function s(L){const I=L;return I?A(I.stream)&&Array.isArray(I.buffer)&&typeof I.ended=="boolean":!1}e.$5d=s;function c(L,I){return new t(L,I)}e.$6d=c;class t{constructor(I,g){this.e=I,this.f=g,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(I){if(!this.a.destroyed){if(this.a.flowing)this.g(I);else if(this.b.data.push(I),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(g=>this.d.push(g))}}error(I){this.a.destroyed||(this.a.flowing?this.h(I):this.b.error.push(I))}end(I){this.a.destroyed||(typeof I<"u"&&this.write(I),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(I){this.c.data.slice(0).forEach(g=>g(I))}h(I){this.c.error.length===0?(0,N.$Z)(I):this.c.error.slice(0).forEach(g=>g(I))}i(){this.c.end.slice(0).forEach(I=>I())}on(I,g){if(!this.a.destroyed)switch(I){case"data":this.c.data.push(g),this.resume();break;case"end":this.c.end.push(g),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(g),this.a.flowing&&this.k();break}}removeListener(I,g){if(this.a.destroyed)return;let E;switch(I){case"data":E=this.c.data;break;case"end":E=this.c.end;break;case"error":E=this.c.error;break}if(E){const w=E.indexOf(g);w>=0&&E.splice(w,1)}}j(){if(this.b.data.length>0){const I=this.e(this.b.data);this.g(I),this.b.data.length=0;const g=[...this.d];this.d.length=0,g.forEach(E=>E())}}k(){if(this.c.error.length>0){for(const I of this.b.error)this.h(I);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function r(L,I){const g=[];let E;for(;(E=L.read())!==null;)g.push(E);return I(g)}e.$7d=r;function h(L,I,g){const E=[];let w;for(;(w=L.read())!==null&&E.length<g;)E.push(w);return w===null&&E.length>0?I(E):{read:()=>{if(E.length>0)return E.shift();if(typeof w<"u"){const O=w;return w=void 0,O}return L.read()}}}e.$8d=h;function u(L,I){return new Promise((g,E)=>{const w=[];l(L,{onData:O=>{I&&w.push(O)},onError:O=>{I?E(O):g(void 0)},onEnd:()=>{g(I?I(w):void 0)}})})}e.$9d=u;function l(L,I,g){L.on("error",E=>{g?.isCancellationRequested||I.onError(E)}),L.on("end",()=>{g?.isCancellationRequested||I.onEnd()}),L.on("data",E=>{g?.isCancellationRequested||I.onData(E)})}e.$0d=l;function f(L,I){return new Promise((g,E)=>{const w=new T.$Qc,O=[],U=k=>{if(O.push(k),O.length>I)return w.dispose(),L.pause(),g({stream:L,buffer:O,ended:!1})},$=k=>(w.dispose(),E(k)),m=()=>(w.dispose(),g({stream:L,buffer:O,ended:!0}));w.add((0,T.$Pc)(()=>L.removeListener("error",$))),L.on("error",$),w.add((0,T.$Pc)(()=>L.removeListener("end",m))),L.on("end",m),w.add((0,T.$Pc)(()=>L.removeListener("data",U))),L.on("data",U)})}e.$$d=f;function i(L,I){const g=c(I);return g.end(L),g}e.$_d=i;function n(){const L=c(()=>{throw new Error("not supported")});return L.end(),L}e.$ae=n;function a(L){let I=!1;return{read:()=>I?null:(I=!0,L)}}e.$be=a;function b(L,I,g){const E=c(g);return l(L,{onData:w=>E.write(I.data(w)),onError:w=>E.error(I.error?I.error(w):w),onEnd:()=>E.end()}),E}e.$ce=b;function C(L,I,g){let E=!1;return{read:()=>{const w=I.read();return E?w:(E=!0,w!==null?g([L,w]):L)}}}e.$de=C;function B(L,I,g){let E=!1;const w=c(g);return l(I,{onData:O=>E?w.write(O):(E=!0,w.write(g([L,O]))),onError:O=>w.error(O),onEnd:()=>{E||(E=!0,w.write(L)),w.end()}}),w}e.$ee=B}),define(G[12],V([0,1,43,23]),function(p,e,N,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ze=e.$ye=e.$xe=e.$we=e.$ve=e.$ue=e.$te=e.$se=e.$re=e.$qe=e.$pe=e.$oe=e.$ne=e.$me=e.$le=e.$ke=e.$je=e.$ie=e.$he=e.$ge=e.$fe=void 0;const v=typeof Buffer<"u",A=new N.$U(()=>new Uint8Array(256));let s,c;class t{static alloc(d){return v?new t(Buffer.allocUnsafe(d)):new t(new Uint8Array(d))}static wrap(d){return v&&!Buffer.isBuffer(d)&&(d=Buffer.from(d.buffer,d.byteOffset,d.byteLength)),new t(d)}static fromString(d,M){return!(M?.dontUseNodeBuffer||!1)&&v?new t(Buffer.from(d)):(s||(s=new TextEncoder),new t(s.encode(d)))}static fromByteArray(d){const M=t.alloc(d.length);for(let D=0,z=d.length;D<z;D++)M.buffer[D]=d[D];return M}static concat(d,M){if(typeof M>"u"){M=0;for(let W=0,H=d.length;W<H;W++)M+=d[W].byteLength}const D=t.alloc(M);let z=0;for(let W=0,H=d.length;W<H;W++){const K=d[W];D.set(K,z),z+=K.byteLength}return D}constructor(d){this.buffer=d,this.byteLength=this.buffer.byteLength}clone(){const d=t.alloc(this.byteLength);return d.set(this),d}toString(){return v?this.buffer.toString():(c||(c=new TextDecoder),c.decode(this.buffer))}slice(d,M){return new t(this.buffer.subarray(d,M))}set(d,M){if(d instanceof t)this.buffer.set(d.buffer,M);else if(d instanceof Uint8Array)this.buffer.set(d,M);else if(d instanceof ArrayBuffer)this.buffer.set(new Uint8Array(d),M);else if(ArrayBuffer.isView(d))this.buffer.set(new Uint8Array(d.buffer,d.byteOffset,d.byteLength),M);else throw new Error("Unknown argument 'array'")}readUInt32BE(d){return l(this.buffer,d)}writeUInt32BE(d,M){f(this.buffer,d,M)}readUInt32LE(d){return i(this.buffer,d)}writeUInt32LE(d,M){n(this.buffer,d,M)}readUInt8(d){return a(this.buffer,d)}writeUInt8(d,M){b(this.buffer,d,M)}indexOf(d,M=0){return r(this.buffer,d instanceof t?d.buffer:d,M)}}e.$fe=t;function r(S,d,M=0){const D=d.byteLength,z=S.byteLength;if(D===0)return 0;if(D===1)return S.indexOf(d[0]);if(D>z-M)return-1;const W=A.value;W.fill(d.length);for(let X=0;X<d.length;X++)W[d[X]]=d.length-X-1;let H=M+d.length-1,K=H,_=-1;for(;H<z;)if(S[H]===d[K]){if(K===0){_=H;break}H--,K--}else H+=Math.max(d.length-K,W[S[H]]),K=d.length-1;return _}e.$ge=r;function h(S,d){return S[d+0]<<0>>>0|S[d+1]<<8>>>0}e.$he=h;function u(S,d,M){S[M+0]=d&255,d=d>>>8,S[M+1]=d&255}e.$ie=u;function l(S,d){return S[d]*2**24+S[d+1]*2**16+S[d+2]*2**8+S[d+3]}e.$je=l;function f(S,d,M){S[M+3]=d,d=d>>>8,S[M+2]=d,d=d>>>8,S[M+1]=d,d=d>>>8,S[M]=d}e.$ke=f;function i(S,d){return S[d+0]<<0>>>0|S[d+1]<<8>>>0|S[d+2]<<16>>>0|S[d+3]<<24>>>0}e.$le=i;function n(S,d,M){S[M+0]=d&255,d=d>>>8,S[M+1]=d&255,d=d>>>8,S[M+2]=d&255,d=d>>>8,S[M+3]=d&255}e.$me=n;function a(S,d){return S[d]}e.$ne=a;function b(S,d,M){S[M]=d}e.$oe=b;function C(S){return T.$7d(S,d=>t.concat(d))}e.$pe=C;function B(S){return T.$be(S)}e.$qe=B;function L(S){return T.$9d(S,d=>t.concat(d))}e.$re=L;async function I(S){return S.ended?t.concat(S.buffer):t.concat([...S.buffer,await L(S.stream)])}e.$se=I;function g(S){return T.$_d(S,d=>t.concat(d))}e.$te=g;function E(S){return T.$ce(S,{data:d=>typeof d=="string"?t.fromString(d):t.wrap(d)},d=>t.concat(d))}e.$ue=E;function w(S){return T.$6d(d=>t.concat(d),S)}e.$ve=w;function O(S,d){return T.$de(S,d,M=>t.concat(M))}e.$we=O;function U(S,d){return T.$ee(S,d,M=>t.concat(M))}e.$xe=U;function $(S){let d=0,M=0,D=0;const z=new Uint8Array(Math.floor(S.length/4*3)),W=K=>{switch(M){case 3:z[D++]=d|K,M=0;break;case 2:z[D++]=d|K>>>2,d=K<<6,M=3;break;case 1:z[D++]=d|K>>>4,d=K<<4,M=2;break;default:d=K<<2,M=1}};for(let K=0;K<S.length;K++){const _=S.charCodeAt(K);if(_>=65&&_<=90)W(_-65);else if(_>=97&&_<=122)W(_-97+26);else if(_>=48&&_<=57)W(_-48+52);else if(_===43||_===45)W(62);else if(_===47||_===95)W(63);else{if(_===61)break;throw new SyntaxError(`Unexpected base64 character ${S[K]}`)}}const H=D;for(;M>0;)W(0);return t.wrap(z).slice(0,H)}e.$ye=$;const m="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",k="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function F({buffer:S},d=!0,M=!1){const D=M?k:m;let z="";const W=S.byteLength%3;let H=0;for(;H<S.byteLength-W;H+=3){const K=S[H+0],_=S[H+1],X=S[H+2];z+=D[K>>>2],z+=D[(K<<4|_>>>4)&63],z+=D[(_<<2|X>>>6)&63],z+=D[X&63]}if(W===1){const K=S[H+0];z+=D[K>>>2],z+=D[K<<4&63],d&&(z+="==")}else if(W===2){const K=S[H+0],_=S[H+1];z+=D[K>>>2],z+=D[(K<<4|_>>>4)&63],z+=D[_<<2&63],d&&(z+="=")}return z}e.$ze=F}),define(G[24],V([0,1]),function(p,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Od=void 0,e.$Od=Symbol("MicrotaskDelay")}),define(G[13],V([0,1]),function(p,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_s=e.StringEOL=void 0;var N;(function(v){v[v.Unknown=0]="Unknown",v[v.Invalid=3]="Invalid",v[v.LF=1]="LF",v[v.CRLF=2]="CRLF"})(N||(e.StringEOL=N={}));function T(v){let A=0,s=0,c=0,t=0;for(let r=0,h=v.length;r<h;r++){const u=v.charCodeAt(r);u===13?(A===0&&(s=r),A++,r+1<h&&v.charCodeAt(r+1)===10?(t|=2,r++):t|=3,c=r+1):u===10&&(t|=1,A===0&&(s=r),A++,c=r+1)}return A===0&&(s=v.length),[A,s,v.length-c,t]}e.$_s=T}),define(G[14],V([0,1]),function(p,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0s=e.MetadataConsts=e.StandardTokenType=e.ColorId=e.FontStyle=e.LanguageId=void 0;var N;(function(t){t[t.Null=0]="Null",t[t.PlainText=1]="PlainText"})(N||(e.LanguageId=N={}));var T;(function(t){t[t.NotSet=-1]="NotSet",t[t.None=0]="None",t[t.Italic=1]="Italic",t[t.Bold=2]="Bold",t[t.Underline=4]="Underline",t[t.Strikethrough=8]="Strikethrough"})(T||(e.FontStyle=T={}));var v;(function(t){t[t.None=0]="None",t[t.DefaultForeground=1]="DefaultForeground",t[t.DefaultBackground=2]="DefaultBackground"})(v||(e.ColorId=v={}));var A;(function(t){t[t.Other=0]="Other",t[t.Comment=1]="Comment",t[t.String=2]="String",t[t.RegEx=3]="RegEx"})(A||(e.StandardTokenType=A={}));var s;(function(t){t[t.LANGUAGEID_MASK=255]="LANGUAGEID_MASK",t[t.TOKEN_TYPE_MASK=768]="TOKEN_TYPE_MASK",t[t.BALANCED_BRACKETS_MASK=1024]="BALANCED_BRACKETS_MASK",t[t.FONT_STYLE_MASK=30720]="FONT_STYLE_MASK",t[t.FOREGROUND_MASK=16744448]="FOREGROUND_MASK",t[t.BACKGROUND_MASK=4278190080]="BACKGROUND_MASK",t[t.ITALIC_MASK=2048]="ITALIC_MASK",t[t.BOLD_MASK=4096]="BOLD_MASK",t[t.UNDERLINE_MASK=8192]="UNDERLINE_MASK",t[t.STRIKETHROUGH_MASK=16384]="STRIKETHROUGH_MASK",t[t.SEMANTIC_USE_ITALIC=1]="SEMANTIC_USE_ITALIC",t[t.SEMANTIC_USE_BOLD=2]="SEMANTIC_USE_BOLD",t[t.SEMANTIC_USE_UNDERLINE=4]="SEMANTIC_USE_UNDERLINE",t[t.SEMANTIC_USE_STRIKETHROUGH=8]="SEMANTIC_USE_STRIKETHROUGH",t[t.SEMANTIC_USE_FOREGROUND=16]="SEMANTIC_USE_FOREGROUND",t[t.SEMANTIC_USE_BACKGROUND=32]="SEMANTIC_USE_BACKGROUND",t[t.LANGUAGEID_OFFSET=0]="LANGUAGEID_OFFSET",t[t.TOKEN_TYPE_OFFSET=8]="TOKEN_TYPE_OFFSET",t[t.BALANCED_BRACKETS_OFFSET=10]="BALANCED_BRACKETS_OFFSET",t[t.FONT_STYLE_OFFSET=11]="FONT_STYLE_OFFSET",t[t.FOREGROUND_OFFSET=15]="FOREGROUND_OFFSET",t[t.BACKGROUND_OFFSET=24]="BACKGROUND_OFFSET"})(s||(e.MetadataConsts=s={}));class c{static getLanguageId(r){return(r&255)>>>0}static getTokenType(r){return(r&768)>>>8}static containsBalancedBrackets(r){return(r&1024)!==0}static getFontStyle(r){return(r&30720)>>>11}static getForeground(r){return(r&16744448)>>>15}static getBackground(r){return(r&4278190080)>>>24}static getClassNameFromMetadata(r){let u="mtk"+this.getForeground(r);const l=this.getFontStyle(r);return l&1&&(u+=" mtki"),l&2&&(u+=" mtkb"),l&4&&(u+=" mtku"),l&8&&(u+=" mtks"),u}static getInlineStyleFromMetadata(r,h){const u=this.getForeground(r),l=this.getFontStyle(r);let f=`color: ${h[u]};`;l&1&&(f+="font-style: italic;"),l&2&&(f+="font-weight: bold;");let i="";return l&4&&(i+=" underline"),l&8&&(i+=" line-through"),i&&(f+=`text-decoration:${i};`),f}static getPresentationFromMetadata(r){const h=this.getForeground(r),u=this.getFontStyle(r);return{foreground:h,italic:!!(u&1),bold:!!(u&2),underline:!!(u&4),strikethrough:!!(u&8)}}}e.$0s=c}),define(G[25],V([0,1,26]),function(p,e,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$QB=void 0;class T{constructor(s){this.b=s,this.a=[]}get(s){return s<this.a.length?this.a[s]:this.b}set(s,c){for(;s>=this.a.length;)this.a[this.a.length]=this.b;this.a[s]=c}replace(s,c,t){if(s>=this.a.length)return;if(c===0){this.insert(s,t);return}else if(t===0){this.delete(s,c);return}const r=this.a.slice(0,s),h=this.a.slice(s+c),u=v(t,this.b);this.a=r.concat(u,h)}delete(s,c){c===0||s>=this.a.length||this.a.splice(s,c)}insert(s,c){if(c===0||s>=this.a.length)return;const t=[];for(let r=0;r<c;r++)t[r]=this.b;this.a=(0,N.$Vb)(this.a,s,t)}}e.$QB=T;function v(A,s){const c=[];for(let t=0;t<A;t++)c[t]=s;return c}}),define(G[7],V([0,1,14]),function(p,e,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$at=void 0;class T{static{this.defaultTokenMetadata=(0<<11|1<<15|2<<24)>>>0}static createEmpty(s,c){const t=T.defaultTokenMetadata,r=new Uint32Array(2);return r[0]=s.length,r[1]=t,new T(r,s,c)}constructor(s,c,t){this._lineTokensBrand=void 0,this.a=s,this.b=this.a.length>>>1,this.c=c,this.d=t}equals(s){return s instanceof T?this.slicedEquals(s,0,this.b):!1}slicedEquals(s,c,t){if(this.c!==s.c||this.b!==s.b)return!1;const r=c<<1,h=r+(t<<1);for(let u=r;u<h;u++)if(this.a[u]!==s.a[u])return!1;return!0}getLineContent(){return this.c}getCount(){return this.b}getStartOffset(s){return s>0?this.a[s-1<<1]:0}getMetadata(s){return this.a[(s<<1)+1]}getLanguageId(s){const c=this.a[(s<<1)+1],t=N.$0s.getLanguageId(c);return this.d.decodeLanguageId(t)}getStandardTokenType(s){const c=this.a[(s<<1)+1];return N.$0s.getTokenType(c)}getForeground(s){const c=this.a[(s<<1)+1];return N.$0s.getForeground(c)}getClassName(s){const c=this.a[(s<<1)+1];return N.$0s.getClassNameFromMetadata(c)}getInlineStyle(s,c){const t=this.a[(s<<1)+1];return N.$0s.getInlineStyleFromMetadata(t,c)}getPresentation(s){const c=this.a[(s<<1)+1];return N.$0s.getPresentationFromMetadata(c)}getEndOffset(s){return this.a[s<<1]}findTokenIndexAtOffset(s){return T.findIndexInTokensArray(this.a,s)}inflate(){return this}sliceAndInflate(s,c,t){return new v(this,s,c,t)}static convertToEndOffset(s,c){const r=(s.length>>>1)-1;for(let h=0;h<r;h++)s[h<<1]=s[h+1<<1];s[r<<1]=c}static findIndexInTokensArray(s,c){if(s.length<=2)return 0;let t=0,r=(s.length>>>1)-1;for(;t<r;){const h=t+Math.floor((r-t)/2),u=s[h<<1];if(u===c)return h+1;u<c?t=h+1:u>c&&(r=h)}return t}withInserted(s){if(s.length===0)return this;let c=0,t=0,r="";const h=new Array;let u=0;for(;;){const l=c<this.b?this.a[c<<1]:-1,f=t<s.length?s[t]:null;if(l!==-1&&(f===null||l<=f.offset)){r+=this.c.substring(u,l);const i=this.a[(c<<1)+1];h.push(r.length,i),c++,u=l}else if(f){if(f.offset>u){r+=this.c.substring(u,f.offset);const i=this.a[(c<<1)+1];h.push(r.length,i),u=f.offset}r+=f.text,h.push(r.length,f.tokenMetadata),t++}else break}return new T(new Uint32Array(h),r,this.d)}}e.$at=T;class v{constructor(s,c,t,r){this.a=s,this.b=c,this.c=t,this.d=r,this.e=s.findTokenIndexAtOffset(c),this.f=0;for(let h=this.e,u=s.getCount();h<u&&!(s.getStartOffset(h)>=t);h++)this.f++}getMetadata(s){return this.a.getMetadata(this.e+s)}getLanguageId(s){return this.a.getLanguageId(this.e+s)}getLineContent(){return this.a.getLineContent().substring(this.b,this.c)}equals(s){return s instanceof v?this.b===s.b&&this.c===s.c&&this.d===s.d&&this.a.slicedEquals(s.a,this.e,this.f):!1}getCount(){return this.f}getForeground(s){return this.a.getForeground(this.e+s)}getEndOffset(s){const c=this.a.getEndOffset(this.e+s);return Math.min(this.c,c)-this.b+this.d}getClassName(s){return this.a.getClassName(this.e+s)}getInlineStyle(s,c){return this.a.getInlineStyle(this.e+s,c)}getPresentation(s){return this.a.getPresentation(this.e+s)}findTokenIndexAtOffset(s){return this.a.findTokenIndexAtOffset(s+this.b-this.d)-this.e}}}),define(G[27],V([0,1,7]),function(p,e,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dt=e.$ct=e.$bt=void 0,e.$bt=new Uint32Array(0).buffer;class T{static deleteBeginning(s,c){return s===null||s===e.$bt?s:T.delete(s,0,c)}static deleteEnding(s,c){if(s===null||s===e.$bt)return s;const t=v(s),r=t[t.length-2];return T.delete(s,c,r)}static delete(s,c,t){if(s===null||s===e.$bt||c===t)return s;const r=v(s),h=r.length>>>1;if(c===0&&r[r.length-2]===t)return e.$bt;const u=N.$at.findIndexInTokensArray(r,c),l=u>0?r[u-1<<1]:0,f=r[u<<1];if(t<f){const C=t-c;for(let B=u;B<h;B++)r[B<<1]-=C;return s}let i,n;l!==c?(r[u<<1]=c,i=u+1<<1,n=c):(i=u<<1,n=l);const a=t-c;for(let C=u+1;C<h;C++){const B=r[C<<1]-a;B>n&&(r[i++]=B,r[i++]=r[(C<<1)+1],n=B)}if(i===r.length)return s;const b=new Uint32Array(i);return b.set(r.subarray(0,i),0),b.buffer}static append(s,c){if(c===e.$bt)return s;if(s===e.$bt)return c;if(s===null)return s;if(c===null)return null;const t=v(s),r=v(c),h=r.length>>>1,u=new Uint32Array(t.length+r.length);u.set(t,0);let l=t.length;const f=t[t.length-2];for(let i=0;i<h;i++)u[l++]=r[i<<1]+f,u[l++]=r[(i<<1)+1];return u.buffer}static insert(s,c,t){if(s===null||s===e.$bt)return s;const r=v(s),h=r.length>>>1;let u=N.$at.findIndexInTokensArray(r,c);u>0&&r[u-1<<1]===c&&u--;for(let l=u;l<h;l++)r[l<<1]+=t;return s}}e.$ct=T;function v(A){return A instanceof Uint32Array?A:new Uint32Array(A)}e.$dt=v}),define(G[28],V([0,1,26,12,44,13,27,15]),function(p,e,N,T,v,A,s,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$et=void 0;class t{static deserialize(h,u,l){const f=new Uint32Array(h.buffer),i=(0,T.$je)(h,u);u+=4;const n=(0,T.$je)(h,u);u+=4;const a=[];for(let b=0;b<n;b++){const C=(0,T.$je)(h,u);u+=4,a.push(f.subarray(u/4,u/4+C/4)),u+=C}return l.push(new t(i,a)),u}get startLineNumber(){return this.a}get endLineNumber(){return this.a+this.b.length-1}constructor(h,u){this.a=h,this.b=u}getLineRange(){return new c.$Is(this.a,this.a+this.b.length)}getLineTokens(h){return this.b[h-this.a]}appendLineTokens(h){this.b.push(h)}serializeSize(){let h=0;h+=4,h+=4;for(let u=0;u<this.b.length;u++){const l=this.b[u];if(!(l instanceof Uint32Array))throw new Error("Not supported!");h+=4,h+=l.byteLength}return h}serialize(h,u){(0,T.$ke)(h,this.a,u),u+=4,(0,T.$ke)(h,this.b.length,u),u+=4;for(let l=0;l<this.b.length;l++){const f=this.b[l];if(!(f instanceof Uint32Array))throw new Error("Not supported!");(0,T.$ke)(h,f.byteLength,u),u+=4,h.set(new Uint8Array(f.buffer),u),u+=f.byteLength}return u}applyEdit(h,u){const[l,f]=(0,A.$_s)(u);this.c(h),this.d(new v.$ys(h.startLineNumber,h.startColumn),l,f)}c(h){if(h.startLineNumber===h.endLineNumber&&h.startColumn===h.endColumn)return;const u=h.startLineNumber-this.a,l=h.endLineNumber-this.a;if(l<0){const f=l-u;this.a-=f;return}if(!(u>=this.b.length)){if(u<0&&l>=this.b.length){this.a=0,this.b=[];return}if(u===l){this.b[u]=s.$ct.delete(this.b[u],h.startColumn-1,h.endColumn-1);return}if(u>=0)if(this.b[u]=s.$ct.deleteEnding(this.b[u],h.startColumn-1),l<this.b.length){const f=s.$ct.deleteBeginning(this.b[l],h.endColumn-1);this.b[u]=s.$ct.append(this.b[u],f),this.b.splice(u+1,l-u)}else this.b[u]=s.$ct.append(this.b[u],null),this.b=this.b.slice(0,u+1);else{const f=-u;this.a-=f,this.b[l]=s.$ct.deleteBeginning(this.b[l],h.endColumn-1),this.b=this.b.slice(l)}}}d(h,u,l){if(u===0&&l===0)return;const f=h.lineNumber-this.a;if(f<0){this.a+=u;return}if(!(f>=this.b.length)){if(u===0){this.b[f]=s.$ct.insert(this.b[f],h.column-1,l);return}this.b[f]=s.$ct.deleteEnding(this.b[f],h.column-1),this.b[f]=s.$ct.insert(this.b[f],h.column-1,l),this.e(h.lineNumber,u)}}e(h,u){if(u===0)return;const l=[];for(let f=0;f<u;f++)l[f]=null;this.b=N.$Vb(this.b,h,l)}}e.$et=t}),define(G[16],V([0,1,12,28]),function(p,e,N,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$RB=void 0;class v{static deserialize(s){let c=0;const t=(0,N.$je)(s,c);c+=4;const r=[];for(let h=0;h<t;h++)c=T.$et.deserialize(s,c,r);return r}constructor(){this.a=[]}add(s,c){if(this.a.length>0){const t=this.a[this.a.length-1];if(t.endLineNumber+1===s){t.appendLineTokens(c);return}}this.a.push(new T.$et(s,[c]))}finalize(){return this.a}serialize(){const s=this.b(),c=new Uint8Array(s);return this.c(c),c}b(){let s=0;s+=4;for(let c=0;c<this.a.length;c++)s+=this.a[c].serializeSize();return s}c(s){let c=0;(0,N.$ke)(s,this.a.length,c),c+=4;for(let t=0;t<this.a.length;t++)c=this.a[t].serialize(s,c)}}e.$RB=v}),define(G[29],V([0,1,30,3,31,45]),function(p,e,N,T,v,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0f=e.$9f=e.$8f=e.$7f=e.$6f=e.$5f=e.$4f=e.$3f=e.$2f=e.$1f=e.$Zf=e.$Yf=e.$Xf=e.$Wf=e.$Vf=e.$Uf=void 0;function s($){return $===47||$===92}e.$Uf=s;function c($){return $.replace(/[\\/]/g,N.$fc.sep)}e.$Vf=c;function t($){return $.indexOf("/")===-1&&($=c($)),/^[a-zA-Z]:(\/|$)/.test($)&&($="/"+$),$}e.$Wf=t;function r($,m=N.$fc.sep){if(!$)return"";const k=$.length,F=$.charCodeAt(0);if(s(F)){if(s($.charCodeAt(1))&&!s($.charCodeAt(2))){let d=3;const M=d;for(;d<k&&!s($.charCodeAt(d));d++);if(M!==d&&!s($.charCodeAt(d+1))){for(d+=1;d<k;d++)if(s($.charCodeAt(d)))return $.slice(0,d+1).replace(/[\\/]/g,m)}}return m}else if(b(F)&&$.charCodeAt(1)===58)return s($.charCodeAt(2))?$.slice(0,2)+m:$.slice(0,2);let S=$.indexOf("://");if(S!==-1){for(S+=3;S<k;S++)if(s($.charCodeAt(S)))return $.slice(0,S+1)}return""}e.$Xf=r;function h($){if(!T.$i||!$||$.length<5)return!1;let m=$.charCodeAt(0);if(m!==92||(m=$.charCodeAt(1),m!==92))return!1;let k=2;const F=k;for(;k<$.length&&(m=$.charCodeAt(k),m!==92);k++);return!(F===k||(m=$.charCodeAt(k+1),isNaN(m)||m===92))}e.$Yf=h;const u=/[\\/:\*\?"<>\|]/g,l=/[\\/]/g,f=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function i($,m=T.$i){const k=m?u:l;return!(!$||$.length===0||/^\s+$/.test($)||(k.lastIndex=0,k.test($))||m&&f.test($)||$==="."||$===".."||m&&$[$.length-1]==="."||m&&$.length!==$.trim().length||$.length>255)}e.$Zf=i;function n($,m,k){const F=$===m;return!k||F?F:!$||!m?!1:(0,v.$6e)($,m)}e.$1f=n;function a($,m,k,F=N.sep){if($===m)return!0;if(!$||!m||m.length>$.length)return!1;if(k){if(!(0,v.$7e)($,m))return!1;if(m.length===$.length)return!0;let d=m.length;return m.charAt(m.length-1)===F&&d--,$.charAt(d)===F}return m.charAt(m.length-1)!==F&&(m+=F),$.indexOf(m)===0}e.$2f=a;function b($){return $>=65&&$<=90||$>=97&&$<=122}e.$3f=b;function C($,m){return T.$i&&$.endsWith(":")&&($+=N.sep),(0,N.$hc)($)||($=(0,N.$ic)(m,$)),$=(0,N.$gc)($),T.$i?($=(0,v.$Oe)($,N.sep),$.endsWith(":")&&($+=N.sep)):($=(0,v.$Oe)($,N.sep),$||($=N.sep)),$}e.$4f=C;function B($){const m=(0,N.$gc)($);return T.$i?$.length>3?!1:L(m)&&($.length===2||m.charCodeAt(2)===92):m===N.$fc.sep}e.$5f=B;function L($,m=T.$i){return m?b($.charCodeAt(0))&&$.charCodeAt(1)===58:!1}e.$6f=L;function I($,m=T.$i){return L($,m)?$[0]:void 0}e.$7f=I;function g($,m,k){return m.length>$.length?-1:$===m?0:(k&&($=$.toLowerCase(),m=m.toLowerCase()),$.indexOf(m))}e.$8f=g;function E($){const m=$.split(":");let k,F,S;for(const d of m){const M=Number(d);(0,A.$Gf)(M)?F===void 0?F=M:S===void 0&&(S=M):k=k?[k,d].join(":"):d}if(!k)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:k,line:F!==void 0?F:void 0,column:S!==void 0?S:F!==void 0?1:void 0}}e.$9f=E;const w="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789",O="BDEFGHIJKMOQRSTUVWXYZbdefghijkmoqrstuvwxyz0123456789";function U($,m,k=8){let F="";for(let d=0;d<k;d++){let M;d===0&&T.$i&&!m&&(k===3||k===4)?M=O:M=w,F+=M.charAt(Math.floor(Math.random()*M.length))}let S;return m?S=`${m}-${F}`:S=F,$?(0,N.$ic)($,S):S}e.$0f=U}),define(G[17],V([0,1,6,3,8]),function(p,e,N,T,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.$gg=e.$fg=e.$eg=e.$dg=e.$cg=e.$bg=e.$ag=e.$_f=e.$$f=e.Schemas=void 0;var A;(function(r){r.inMemory="inmemory",r.vscode="vscode",r.internal="private",r.walkThrough="walkThrough",r.walkThroughSnippet="walkThroughSnippet",r.http="http",r.https="https",r.file="file",r.mailto="mailto",r.untitled="untitled",r.data="data",r.command="command",r.vscodeRemote="vscode-remote",r.vscodeRemoteResource="vscode-remote-resource",r.vscodeManagedRemoteResource="vscode-managed-remote-resource",r.vscodeUserData="vscode-userdata",r.vscodeCustomEditor="vscode-custom-editor",r.vscodeNotebookCell="vscode-notebook-cell",r.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",r.vscodeNotebookCellOutput="vscode-notebook-cell-output",r.vscodeInteractiveInput="vscode-interactive-input",r.vscodeSettings="vscode-settings",r.vscodeWorkspaceTrust="vscode-workspace-trust",r.vscodeTerminal="vscode-terminal",r.vscodeChatSesssion="vscode-chat-editor",r.webviewPanel="webview-panel",r.vscodeWebview="vscode-webview",r.extension="extension",r.vscodeFileResource="vscode-file",r.tmp="tmp",r.vsls="vsls",r.vscodeSourceControl="vscode-scm"})(A||(e.Schemas=A={})),e.$$f="vscode-tkn",e.$_f="tkn";class s{constructor(){this.a=Object.create(null),this.b=Object.create(null),this.c=Object.create(null),this.d="http",this.e=null,this.f=`/${A.vscodeRemoteResource}`}setPreferredWebSchema(h){this.d=h}setDelegate(h){this.e=h}setServerRootPath(h){this.f=`${h}/${A.vscodeRemoteResource}`}set(h,u,l){this.a[h]=u,this.b[h]=l}setConnectionToken(h,u){this.c[h]=u}getPreferredWebSchema(){return this.d}rewrite(h){if(this.e)try{return this.e(h)}catch(a){return N.$Z(a),h}const u=h.authority;let l=this.a[u];l&&l.indexOf(":")!==-1&&l.indexOf("[")===-1&&(l=`[${l}]`);const f=this.b[u],i=this.c[u];let n=`path=${encodeURIComponent(h.path)}`;return typeof i=="string"&&(n+=`&${e.$_f}=${encodeURIComponent(i)}`),v.URI.from({scheme:T.$o?this.d:A.vscodeRemoteResource,authority:`${l}:${f}`,path:this.f,query:n})}}e.$ag=new s,e.$bg="vs/../../extensions",e.$cg="vs/../../node_modules",e.$dg="vs/../../node_modules.asar",e.$eg="vs/../../node_modules.asar.unpacked",e.$fg="vscode-app";class c{static{this.a=e.$fg}asBrowserUri(h){const u=this.b(h,p);return this.uriToBrowserUri(u)}uriToBrowserUri(h){return h.scheme===A.vscodeRemote?e.$ag.rewrite(h):h.scheme===A.file&&(T.$m||T.$q===`${A.vscodeFileResource}://${c.a}`)?h.with({scheme:A.vscodeFileResource,authority:h.authority||c.a,query:null,fragment:null}):h}asFileUri(h){const u=this.b(h,p);return this.uriToFileUri(u)}uriToFileUri(h){return h.scheme===A.vscodeFileResource?h.with({scheme:A.file,authority:h.authority!==c.a?h.authority:null,query:null,fragment:null}):h}b(h,u){return v.URI.isUri(h)?h:v.URI.parse(u.toUrl(h))}}e.$gg=new c;var t;(function(r){const h=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);r.CoopAndCoep=Object.freeze(h.get("3"));const u="vscode-coi";function l(i){let n;typeof i=="string"?n=new URL(i).searchParams:i instanceof URL?n=i.searchParams:v.URI.isUri(i)&&(n=new URL(i.toString(!0)).searchParams);const a=n?.get(u);if(a)return h.get(a)}r.getHeadersFromQuery=l;function f(i,n,a){if(!globalThis.crossOriginIsolated)return;const b=n&&a?"3":a?"2":"1";i instanceof URLSearchParams?i.set(u,b):i[u]=b}r.addSearchParam=f})(t||(e.COI=t={}))}),define(G[32],V([0,1,21,17,3,8]),function(p,e,N,T,v,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$NC=void 0;class s{constructor(l,f,i){this.id=l,this.dependencies=f,this.callback=i}}class c{static{this.INSTANCE=new c}constructor(){this.a=typeof self=="object"&&self.constructor&&self.constructor.name==="DedicatedWorkerGlobalScope",this.b=typeof document=="object",this.c=[],this.d=!1}g(){this.d||(this.d=!0,globalThis.define=(l,f,i)=>{typeof l!="string"&&(i=f,f=l,l=null),(typeof f!="object"||!Array.isArray(f))&&(i=f,f=null),this.c.push(new s(l,f,i))},globalThis.define.amd=!0,this.b?this.f=window.trustedTypes?.createPolicy("amdLoader",{createScriptURL(l){if(l.startsWith(window.location.origin)||l.startsWith("vscode-file://vscode-app"))return l;throw new Error(`[trusted_script_src] Invalid script url: ${l}`)}}):this.a&&(this.f=globalThis.trustedTypes?.createPolicy("amdLoader",{createScriptURL(l){return l}})))}async load(l){this.g();const f=await(this.a?this.i(l):this.b?this.h(l):this.j(l));if(!f)throw new Error(`Did not receive a define call from script ${l}`);if(Array.isArray(f.dependencies)&&f.dependencies.length>0)throw new Error(`Cannot resolve dependencies for script ${l}. The dependencies are: ${f.dependencies.join(", ")}`);return typeof f.callback=="function"?f.callback([]):f.callback}h(l){return new Promise((f,i)=>{const n=document.createElement("script");n.setAttribute("async","async"),n.setAttribute("type","text/javascript");const a=()=>{n.removeEventListener("load",b),n.removeEventListener("error",C)},b=B=>{a(),f(this.c.pop())},C=B=>{a(),i(B)};n.addEventListener("load",b),n.addEventListener("error",C),this.f&&(l=this.f.createScriptURL(l)),n.setAttribute("src",l),window.document.getElementsByTagName("head")[0].appendChild(n)})}i(l){return new Promise((f,i)=>{try{this.f&&(l=this.f.createScriptURL(l)),importScripts(l),f(this.c.pop())}catch(n){i(n)}})}async j(l){try{const f=globalThis._VSCODE_NODE_MODULES.fs,i=globalThis._VSCODE_NODE_MODULES.vm,n=globalThis._VSCODE_NODE_MODULES.module,a=A.URI.parse(l).fsPath,b=f.readFileSync(a).toString(),C=n.wrap(b.replace(/^#!.*/,""));return new i.Script(C).runInThisContext().apply(),this.c.pop()}catch(f){throw f}}}const t=new Map;let r={};typeof globalThis.require=="object"&&(r=globalThis.require.paths??{});async function h(u,l,f){if(N.$S){f===void 0&&(f=!!(globalThis._VSCODE_PRODUCT_JSON??globalThis.vscode?.context?.configuration()?.product)?.commit),r[u]&&(u=r[u]);const i=`${u}/${l}`;if(t.has(i))return t.get(i);let n;if(/^\w[\w\d+.-]*:\/\//.test(i))n=i;else{const B=`${f&&!v.$o?T.$dg:T.$cg}/${i}`;n=T.$gg.asBrowserUri(B).toString(!0)}const a=c.INSTANCE.load(n);return t.set(i,a),a}else return await new Promise((i,n)=>{p([u],i,n)})}e.$NC=h}),define(G[18],V([0,1,29,17,30,3,31,8]),function(p,e,N,T,v,A,s,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jg=e.DataUri=e.$Ig=e.$Hg=e.$Gg=e.$Fg=e.$Eg=e.$Dg=e.$Cg=e.$Bg=e.$Ag=e.$zg=e.$yg=e.$xg=e.$wg=e.$vg=e.$ug=e.$tg=e.$sg=e.$rg=e.$qg=e.$pg=e.$og=e.$ng=void 0;function t(f){return(0,c.$vc)(f,!0)}e.$ng=t;class r{constructor(i){this.a=i}compare(i,n,a=!1){return i===n?0:(0,s.$Ye)(this.getComparisonKey(i,a),this.getComparisonKey(n,a))}isEqual(i,n,a=!1){return i===n?!0:!i||!n?!1:this.getComparisonKey(i,a)===this.getComparisonKey(n,a)}getComparisonKey(i,n=!1){return i.with({path:this.a(i)?i.path.toLowerCase():void 0,fragment:n?null:void 0}).toString()}ignorePathCasing(i){return this.a(i)}isEqualOrParent(i,n,a=!1){if(i.scheme===n.scheme){if(i.scheme===T.Schemas.file)return N.$2f(t(i),t(n),this.a(i))&&i.query===n.query&&(a||i.fragment===n.fragment);if((0,e.$Eg)(i.authority,n.authority))return N.$2f(i.path,n.path,this.a(i),"/")&&i.query===n.query&&(a||i.fragment===n.fragment)}return!1}joinPath(i,...n){return c.URI.joinPath(i,...n)}basenameOrAuthority(i){return(0,e.$wg)(i)||i.authority}basename(i){return v.$fc.basename(i.path)}extname(i){return v.$fc.extname(i.path)}dirname(i){if(i.path.length===0)return i;let n;return i.scheme===T.Schemas.file?n=c.URI.file(v.$lc(t(i))).path:(n=v.$fc.dirname(i.path),i.authority&&n.length&&n.charCodeAt(0)!==47&&(console.error(`dirname("${i.toString})) resulted in a relative path`),n="/")),i.with({path:n})}normalizePath(i){if(!i.path.length)return i;let n;return i.scheme===T.Schemas.file?n=c.URI.file(v.$gc(t(i))).path:n=v.$fc.normalize(i.path),i.with({path:n})}relativePath(i,n){if(i.scheme!==n.scheme||!(0,e.$Eg)(i.authority,n.authority))return;if(i.scheme===T.Schemas.file){const C=v.$kc(t(i),t(n));return A.$i?N.$Vf(C):C}let a=i.path||"/";const b=n.path||"/";if(this.a(i)){let C=0;for(const B=Math.min(a.length,b.length);C<B&&!(a.charCodeAt(C)!==b.charCodeAt(C)&&a.charAt(C).toLowerCase()!==b.charAt(C).toLowerCase());C++);a=b.substr(0,C)+a.substr(C)}return v.$fc.relative(a,b)}resolvePath(i,n){if(i.scheme===T.Schemas.file){const a=c.URI.file(v.$jc(t(i),n));return i.with({authority:a.authority,path:a.path})}return n=N.$Wf(n),i.with({path:v.$fc.resolve(i.path,n)})}isAbsolutePath(i){return!!i.path&&i.path[0]==="/"}isEqualAuthority(i,n){return i===n||i!==void 0&&n!==void 0&&(0,s.$6e)(i,n)}hasTrailingPathSeparator(i,n=v.sep){if(i.scheme===T.Schemas.file){const a=t(i);return a.length>N.$Xf(a).length&&a[a.length-1]===n}else{const a=i.path;return a.length>1&&a.charCodeAt(a.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(i.fsPath)}}removeTrailingPathSeparator(i,n=v.sep){return(0,e.$Fg)(i,n)?i.with({path:i.path.substr(0,i.path.length-1)}):i}addTrailingPathSeparator(i,n=v.sep){let a=!1;if(i.scheme===T.Schemas.file){const b=t(i);a=b!==void 0&&b.length===N.$Xf(b).length&&b[b.length-1]===n}else{n="/";const b=i.path;a=b.length===1&&b.charCodeAt(b.length-1)===47}return!a&&!(0,e.$Fg)(i,n)?i.with({path:i.path+"/"}):i}}e.$og=r,e.$pg=new r(()=>!1),e.$qg=new r(f=>f.scheme===T.Schemas.file?!A.$k:!0),e.$rg=new r(f=>!0),e.$sg=e.$pg.isEqual.bind(e.$pg),e.$tg=e.$pg.isEqualOrParent.bind(e.$pg),e.$ug=e.$pg.getComparisonKey.bind(e.$pg),e.$vg=e.$pg.basenameOrAuthority.bind(e.$pg),e.$wg=e.$pg.basename.bind(e.$pg),e.$xg=e.$pg.extname.bind(e.$pg),e.$yg=e.$pg.dirname.bind(e.$pg),e.$zg=e.$pg.joinPath.bind(e.$pg),e.$Ag=e.$pg.normalizePath.bind(e.$pg),e.$Bg=e.$pg.relativePath.bind(e.$pg),e.$Cg=e.$pg.resolvePath.bind(e.$pg),e.$Dg=e.$pg.isAbsolutePath.bind(e.$pg),e.$Eg=e.$pg.isEqualAuthority.bind(e.$pg),e.$Fg=e.$pg.hasTrailingPathSeparator.bind(e.$pg),e.$Gg=e.$pg.removeTrailingPathSeparator.bind(e.$pg),e.$Hg=e.$pg.addTrailingPathSeparator.bind(e.$pg);function h(f,i){const n=[];for(let a=0;a<f.length;a++){const b=i(f[a]);f.some((C,B)=>B===a?!1:(0,e.$tg)(b,i(C)))||n.push(f[a])}return n}e.$Ig=h;var u;(function(f){f.META_DATA_LABEL="label",f.META_DATA_DESCRIPTION="description",f.META_DATA_SIZE="size",f.META_DATA_MIME="mime";function i(n){const a=new Map;n.path.substring(n.path.indexOf(";")+1,n.path.lastIndexOf(";")).split(";").forEach(B=>{const[L,I]=B.split(":");L&&I&&a.set(L,I)});const C=n.path.substring(0,n.path.indexOf(";"));return C&&a.set(f.META_DATA_MIME,C),a}f.parseMetaData=i})(u||(e.DataUri=u={}));function l(f,i,n){if(i){let a=f.path;return a&&a[0]!==v.$fc.sep&&(a=v.$fc.sep+a),f.with({scheme:n,authority:i,path:a})}return f.with({scheme:n})}e.$Jg=l}),define(G[19],V([0,1,46,6,33,2,18,3,24]),function(p,e,N,T,v,A,s,c,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mh=e.$lh=e.$kh=e.$jh=e.Promises=e.$ih=e.$hh=e.$gh=e.$fh=e.$eh=e.$dh=e.$ch=e.$bh=e.$ah=e.$_g=e.$$g=e.$0g=e.$9g=e.$8g=e.$7g=e.$6g=e.$5g=e.$4g=e.$3g=e.$2g=e.$1g=e.$Zg=e.$Yg=e.$Xg=e.$Wg=e.$Vg=e.$Ug=e.$Tg=e.$Sg=e.$Rg=e.$Qg=e.$Pg=e.$Og=e.$Ng=e.$Mg=e.$Lg=e.$Kg=void 0;function r(R){return!!R&&typeof R.then=="function"}e.$Kg=r;function h(R){const o=new N.$2d,y=R(o.token),P=new Promise((j,q)=>{const Z=o.token.onCancellationRequested(()=>{Z.dispose(),o.dispose(),q(new T.$4)});Promise.resolve(y).then(Q=>{Z.dispose(),o.dispose(),j(Q)},Q=>{Z.dispose(),o.dispose(),q(Q)})});return new class{cancel(){o.cancel()}then(j,q){return P.then(j,q)}catch(j){return this.then(void 0,j)}finally(j){return P.finally(j)}}}e.$Lg=h;function u(R,o,y){return new Promise((P,j)=>{const q=o.onCancellationRequested(()=>{q.dispose(),P(y)});R.then(P,j).finally(()=>q.dispose())})}e.$Mg=u;function l(R,o){return new Promise((y,P)=>{const j=o.onCancellationRequested(()=>{j.dispose(),P(new T.$4)});R.then(y,P).finally(()=>j.dispose())})}e.$Ng=l;async function f(R){let o=-1;const y=R.map((P,j)=>P.then(q=>(o=j,q)));try{return await Promise.race(y)}finally{R.forEach((P,j)=>{j!==o&&P.cancel()})}}e.$Og=f;function i(R,o,y){let P;const j=setTimeout(()=>{P?.(void 0),y?.()},o);return Promise.race([R.finally(()=>clearTimeout(j)),new Promise(q=>P=q)])}e.$Pg=i;function n(R){return new Promise((o,y)=>{const P=R();r(P)?P.then(o,y):o(P)})}e.$Qg=n;class a{constructor(){this.f=!1,this.a=null,this.b=null,this.d=null}queue(o){if(this.f)return Promise.reject(new Error("Throttler is disposed"));if(this.a){if(this.d=o,!this.b){const y=()=>{if(this.b=null,this.f)return;const P=this.queue(this.d);return this.d=null,P};this.b=new Promise(P=>{this.a.then(y,y).then(P)})}return new Promise((y,P)=>{this.b.then(y,P)})}return this.a=o(),new Promise((y,P)=>{this.a.then(j=>{this.a=null,y(j)},j=>{this.a=null,P(j)})})}dispose(){this.f=!0}}e.$Rg=a;class b{constructor(){this.a=Promise.resolve(null)}queue(o){return this.a=this.a.then(()=>o(),()=>o())}}e.$Sg=b;class C{constructor(){this.a=new Map}queue(o,y){const j=(this.a.get(o)??Promise.resolve()).catch(()=>{}).then(y).finally(()=>{this.a.get(o)===j&&this.a.delete(o)});return this.a.set(o,j),j}}e.$Tg=C;const B=(R,o)=>{let y=!0;const P=setTimeout(()=>{y=!1,o()},R);return{isTriggered:()=>y,dispose:()=>{clearTimeout(P),y=!1}}},L=R=>{let o=!0;return queueMicrotask(()=>{o&&(o=!1,R())}),{isTriggered:()=>o,dispose:()=>{o=!1}}};class I{constructor(o){this.defaultDelay=o,this.a=null,this.b=null,this.d=null,this.f=null,this.g=null}trigger(o,y=this.defaultDelay){this.g=o,this.h(),this.b||(this.b=new Promise((j,q)=>{this.d=j,this.f=q}).then(()=>{if(this.b=null,this.d=null,this.g){const j=this.g;return this.g=null,j()}}));const P=()=>{this.a=null,this.d?.(null)};return this.a=y===t.$Od?L(P):B(y,P),this.b}isTriggered(){return!!this.a?.isTriggered()}cancel(){this.h(),this.b&&(this.f?.(new T.$4),this.b=null)}h(){this.a?.dispose(),this.a=null}dispose(){this.cancel()}}e.$Ug=I;class g{constructor(o){this.a=new I(o),this.b=new a}trigger(o,y){return this.a.trigger(()=>this.b.queue(o),y)}isTriggered(){return this.a.isTriggered()}cancel(){this.a.cancel()}dispose(){this.a.dispose(),this.b.dispose()}}e.$Vg=g;class E{constructor(){this.a=!1,this.b=new Promise((o,y)=>{this.d=o})}isOpen(){return this.a}open(){this.a=!0,this.d(!0)}wait(){return this.b}}e.$Wg=E;class w extends E{constructor(o){super(),this.f=setTimeout(()=>this.open(),o)}open(){clearTimeout(this.f),super.open()}}e.$Xg=w;function O(R,o){return o?new Promise((y,P)=>{const j=setTimeout(()=>{q.dispose(),y()},R),q=o.onCancellationRequested(()=>{clearTimeout(j),q.dispose(),P(new T.$4)})}):h(y=>O(R,y))}e.$Yg=O;function U(R,o=0,y){const P=setTimeout(()=>{R(),y&&j.dispose()},o),j=(0,A.$Pc)(()=>{clearTimeout(P),y?.deleteAndLeak(j)});return y?.add(j),j}e.$Zg=U;function $(R){const o=[];let y=0;const P=R.length;function j(){return y<P?R[y++]():null}function q(Z){Z!=null&&o.push(Z);const Q=j();return Q?Q.then(q):Promise.resolve(o)}return Promise.resolve(null).then(q)}e.$1g=$;function m(R,o=P=>!!P,y=null){let P=0;const j=R.length,q=()=>{if(P>=j)return Promise.resolve(y);const Z=R[P++];return Promise.resolve(Z()).then(J=>o(J)?Promise.resolve(J):q())};return q()}e.$2g=m;function k(R,o=P=>!!P,y=null){if(R.length===0)return Promise.resolve(y);let P=R.length;const j=()=>{P=-1;for(const q of R)q.cancel?.()};return new Promise((q,Z)=>{for(const Q of R)Q.then(J=>{--P>=0&&o(J)?(j(),q(J)):P===0&&q(y)}).catch(J=>{--P>=0&&(j(),Z(J))})})}e.$3g=k;class F{constructor(o){this.a=0,this.d=o,this.f=[],this.b=0,this.g=new v.$Rd}get onDrained(){return this.g.event}get size(){return this.a}queue(o){return this.a++,new Promise((y,P)=>{this.f.push({factory:o,c:y,e:P}),this.h()})}h(){for(;this.f.length&&this.b<this.d;){const o=this.f.shift();this.b++;const y=o.factory();y.then(o.c,o.e),y.then(()=>this.j(),()=>this.j())}}j(){this.a--,this.b--,this.f.length>0?this.h():this.g.fire()}dispose(){this.g.dispose()}}e.$4g=F;class S extends F{constructor(){super(1)}}e.$5g=S;class d{constructor(){this.a=new ee,this.b=0}queue(o){return this.a.isRunning()?this.a.queue(()=>this.a.run(this.b++,o())):this.a.run(this.b++,o())}}e.$6g=d;class M{constructor(){this.a=new Map,this.b=new Set,this.d=void 0,this.f=0}async whenDrained(){if(this.g())return;const o=new x;return this.b.add(o),o.p}g(){for(const[,o]of this.a)if(o.size>0)return!1;return!0}queueFor(o,y=s.$pg){const P=y.getComparisonKey(o);let j=this.a.get(P);if(!j){j=new S;const q=this.f++,Z=v.Event.once(j.onDrained)(()=>{j?.dispose(),this.a.delete(P),this.h(),this.d?.deleteAndDispose(q),this.d?.size===0&&(this.d.dispose(),this.d=void 0)});this.d||(this.d=new A.$1c),this.d.set(q,Z),this.a.set(P,j)}return j}h(){this.g()&&this.j()}j(){for(const o of this.b)o.complete();this.b.clear()}dispose(){for(const[,o]of this.a)o.dispose();this.a.clear(),this.j(),this.d?.dispose()}}e.$7g=M;class D{constructor(o,y){this.a=-1,typeof o=="function"&&typeof y=="number"&&this.setIfNotSet(o,y)}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearTimeout(this.a),this.a=-1)}cancelAndSet(o,y){this.cancel(),this.a=setTimeout(()=>{this.a=-1,o()},y)}setIfNotSet(o,y){this.a===-1&&(this.a=setTimeout(()=>{this.a=-1,o()},y))}}e.$8g=D;class z{constructor(){this.d=void 0}cancel(){this.d?.dispose(),this.d=void 0}cancelAndSet(o,y,P=globalThis){this.cancel();const j=P.setInterval(()=>{o()},y);this.d=(0,A.$Pc)(()=>{P.clearInterval(j),this.d=void 0})}dispose(){this.cancel()}}e.$9g=z;class W{constructor(o,y){this.b=-1,this.a=o,this.d=y,this.f=this.g.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearTimeout(this.b),this.b=-1)}schedule(o=this.d){this.cancel(),this.b=setTimeout(this.f,o)}get delay(){return this.d}set delay(o){this.d=o}isScheduled(){return this.b!==-1}flush(){this.isScheduled()&&(this.cancel(),this.h())}g(){this.b=-1,this.a&&this.h()}h(){this.a?.()}}e.$0g=W;class H{constructor(o,y){y%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${y}ms is not a multiple of 1000ms.`),this.a=o,this.b=y,this.d=0,this.f=-1,this.g=this.h.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearInterval(this.f),this.f=-1)}schedule(o=this.b){o%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${o}ms is not a multiple of 1000ms.`),this.cancel(),this.d=Math.ceil(o/1e3),this.f=setInterval(this.g,1e3)}isScheduled(){return this.f!==-1}h(){this.d--,!(this.d>0)&&(clearInterval(this.f),this.f=-1,this.a?.())}}e.$$g=H;class K extends W{constructor(o,y){super(o,y),this.j=[]}work(o){this.j.push(o),this.isScheduled()||this.schedule()}h(){const o=this.j;this.j=[],this.a?.(o)}dispose(){this.j=[],super.dispose()}}e.$_g=K;class _ extends A.$Rc{constructor(o,y){super(),this.g=o,this.h=y,this.a=[],this.b=this.B(new A.$Sc),this.f=!1}get pending(){return this.a.length}work(o){if(this.f)return!1;if(typeof this.g.maxBufferedWork=="number"){if(this.b.value){if(this.pending+o.length>this.g.maxBufferedWork)return!1}else if(this.pending+o.length-this.g.maxWorkChunkSize>this.g.maxBufferedWork)return!1}for(const y of o)this.a.push(y);return this.b.value||this.j(),!0}j(){this.h(this.a.splice(0,this.g.maxWorkChunkSize)),this.a.length>0&&(this.b.value=new W(()=>{this.b.clear(),this.j()},this.g.throttleDelay),this.b.value.schedule())}dispose(){super.dispose(),this.f=!0}}e.$ah=_,function(){typeof globalThis.requestIdleCallback!="function"||typeof globalThis.cancelIdleCallback!="function"?e.$ch=(R,o)=>{(0,c.$B)(()=>{if(y)return;const P=Date.now()+15;o(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,P-Date.now())}}))});let y=!1;return{dispose(){y||(y=!0)}}}:e.$ch=(R,o,y)=>{const P=R.requestIdleCallback(o,typeof y=="number"?{timeout:y}:void 0);let j=!1;return{dispose(){j||(j=!0,R.cancelIdleCallback(P))}}},e.$bh=R=>(0,e.$ch)(globalThis,R)}();class X{constructor(o,y){this.g=!1,this.d=()=>{try{this.j=y()}catch(P){this.l=P}finally{this.g=!0}},this.f=(0,e.$ch)(o,()=>this.d())}dispose(){this.f.dispose()}get value(){if(this.g||(this.f.dispose(),this.d()),this.l)throw this.l;return this.j}get isInitialized(){return this.g}}e.$dh=X;class re extends X{constructor(o){super(globalThis,o)}}e.$eh=re;async function ae(R,o,y){let P;for(let j=0;j<y;j++)try{return await R()}catch(q){P=q,await O(o)}throw P}e.$fh=ae;class ee{isRunning(o){return typeof o=="number"?this.a?.taskId===o:!!this.a}get running(){return this.a?.promise}cancelRunning(){this.a?.cancel()}run(o,y,P){return this.a={taskId:o,cancel:()=>P?.(),promise:y},y.then(()=>this.d(o),()=>this.d(o)),y}d(o){this.a&&o===this.a.taskId&&(this.a=void 0,this.f())}f(){if(this.b){const o=this.b;this.b=void 0,o.run().then(o.promiseResolve,o.promiseReject)}}queue(o){if(this.b)this.b.run=o;else{let y,P;const j=new Promise((q,Z)=>{y=q,P=Z});this.b={run:o,promise:j,promiseResolve:y,promiseReject:P}}return this.b.promise}hasQueued(){return!!this.b}async join(){return this.b?.promise??this.a?.promise}}e.$gh=ee;class he{constructor(o,y=()=>Date.now()){this.d=o,this.f=y,this.a=0,this.b=0}increment(){const o=this.f();return o-this.a>this.d&&(this.a=o,this.b=0),this.b++,this.b}}e.$hh=he;var te;(function(R){R[R.Resolved=0]="Resolved",R[R.Rejected=1]="Rejected"})(te||(te={}));class x{get isRejected(){return this.d?.outcome===1}get isResolved(){return this.d?.outcome===0}get isSettled(){return!!this.d}get value(){return this.d?.outcome===0?this.d?.value:void 0}constructor(){this.p=new Promise((o,y)=>{this.a=o,this.b=y})}complete(o){return new Promise(y=>{this.a(o),this.d={outcome:0,value:o},y()})}error(o){return new Promise(y=>{this.b(o),this.d={outcome:1,value:o},y()})}cancel(){return this.error(new T.$4)}}e.$ih=x;var ne;(function(R){async function o(P){let j;const q=await Promise.all(P.map(Z=>Z.then(Q=>Q,Q=>{j||(j=Q)})));if(typeof j<"u")throw j;return q}R.settled=o;function y(P){return new Promise(async(j,q)=>{try{await P(j,q)}catch(Z){q(Z)}})}R.withAsyncBody=y})(ne||(e.Promises=ne={}));var ie;(function(R){R[R.Initial=0]="Initial",R[R.DoneOK=1]="DoneOK",R[R.DoneError=2]="DoneError"})(ie||(ie={}));class Y{static fromArray(o){return new Y(y=>{y.emitMany(o)})}static fromPromise(o){return new Y(async y=>{y.emitMany(await o)})}static fromPromises(o){return new Y(async y=>{await Promise.all(o.map(async P=>y.emitOne(await P)))})}static merge(o){return new Y(async y=>{await Promise.all(o.map(async P=>{for await(const j of P)y.emitOne(j)}))})}static{this.EMPTY=Y.fromArray([])}constructor(o){this.a=0,this.b=[],this.d=null,this.f=new v.$Rd,queueMicrotask(async()=>{const y={emitOne:P=>this.g(P),emitMany:P=>this.h(P),reject:P=>this.k(P)};try{await Promise.resolve(o(y)),this.j()}catch(P){this.k(P)}finally{y.emitOne=void 0,y.emitMany=void 0,y.reject=void 0}})}[Symbol.asyncIterator](){let o=0;return{next:async()=>{do{if(this.a===2)throw this.d;if(o<this.b.length)return{done:!1,value:this.b[o++]};if(this.a===1)return{done:!0,value:void 0};await v.Event.toPromise(this.f.event)}while(!0)}}}static map(o,y){return new Y(async P=>{for await(const j of o)P.emitOne(y(j))})}map(o){return Y.map(this,o)}static filter(o,y){return new Y(async P=>{for await(const j of o)y(j)&&P.emitOne(j)})}filter(o){return Y.filter(this,o)}static coalesce(o){return Y.filter(o,y=>!!y)}coalesce(){return Y.coalesce(this)}static async toPromise(o){const y=[];for await(const P of o)y.push(P);return y}toPromise(){return Y.toPromise(this)}g(o){this.a===0&&(this.b.push(o),this.f.fire())}h(o){this.a===0&&(this.b=this.b.concat(o),this.f.fire())}j(){this.a===0&&(this.a=1,this.f.fire())}k(o){this.a===0&&(this.a=2,this.d=o,this.f.fire())}}e.$jh=Y;class se extends Y{constructor(o,y){super(y),this.l=o}cancel(){this.l.cancel()}}e.$kh=se;function ue(R){const o=new N.$2d,y=R(o.token);return new se(o,async P=>{const j=o.token.onCancellationRequested(()=>{j.dispose(),o.dispose(),P.reject(new T.$4)});try{for await(const q of y){if(o.token.isCancellationRequested)return;P.emitOne(q)}j.dispose(),o.dispose()}catch(q){j.dispose(),o.dispose(),P.reject(q)}})}e.$lh=ue;class oe{constructor(){this.a=new x,this.b=new Y(P=>{if(o){P.reject(o);return}return y&&P.emitMany(y),this.d=j=>P.reject(j),this.f=j=>P.emitOne(j),this.a.p});let o,y;this.f=P=>{y||(y=[]),y.push(P)},this.d=P=>{o||(o=P)}}get asyncIterable(){return this.b}resolve(){this.a.complete()}reject(o){this.d(o),this.a.complete()}emitOne(o){this.f(o)}}e.$mh=oe}),define(G[20],V([0,1,34]),function(p,e,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$PB=e.$OB=e.$NB=void 0,e.$NB=new class{clone(){return this}equals(A){return this===A}};function T(A,s){return new N.$ht([new N.$gt(0,"",A)],s)}e.$OB=T;function v(A,s){const c=new Uint32Array(2);return c[0]=0,c[1]=(A<<0|0<<8|0<<11|1<<15|2<<24)>>>0,new N.$it(c,s===null?e.$NB:s)}e.$PB=v}),define(G[35],V([0,1,19,6,3,36,13,15,47,20,25,16,7]),function(p,e,N,T,v,A,s,c,t,r,h,u,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$XB=e.$WB=e.$VB=e.$UB=e.$TB=e.$SB=void 0;var f;(function(I){I[I.CHEAP_TOKENIZATION_LENGTH_LIMIT=2048]="CHEAP_TOKENIZATION_LENGTH_LIMIT"})(f||(f={}));class i{constructor(g,E){this.tokenizationSupport=E,this.a=this.tokenizationSupport.getInitialState(),this.store=new a(g)}getStartState(g){return this.store.getStartState(g,this.a)}getFirstInvalidLine(){return this.store.getFirstInvalidLine(this.a)}}e.$SB=i;class n extends i{constructor(g,E,w,O){super(g,E),this._textModel=w,this._languageIdCodec=O}updateTokensUntilLine(g,E){const w=this._textModel.getLanguageId();for(;;){const O=this.getFirstInvalidLine();if(!O||O.lineNumber>E)break;const U=this._textModel.getLineContent(O.lineNumber),$=B(this._languageIdCodec,w,this.tokenizationSupport,U,!0,O.startState);g.add(O.lineNumber,$.tokens),this.store.setEndState(O.lineNumber,$.endState)}}getTokenTypeIfInsertingCharacter(g,E){const w=this.getStartState(g.lineNumber);if(!w)return 0;const O=this._textModel.getLanguageId(),U=this._textModel.getLineContent(g.lineNumber),$=U.substring(0,g.column-1)+E+U.substring(g.column-1),m=B(this._languageIdCodec,O,this.tokenizationSupport,$,!0,w),k=new l.$at(m.tokens,$,this._languageIdCodec);if(k.getCount()===0)return 0;const F=k.findTokenIndexAtOffset(g.column-1);return k.getStandardTokenType(F)}tokenizeLineWithEdit(g,E,w){const O=g.lineNumber,U=g.column,$=this.getStartState(O);if(!$)return null;const m=this._textModel.getLineContent(O),k=m.substring(0,U-1)+w+m.substring(U-1+E),F=this._textModel.getLanguageIdAtPosition(O,0),S=B(this._languageIdCodec,F,this.tokenizationSupport,k,!0,$);return new l.$at(S.tokens,k,this._languageIdCodec)}isCheapToTokenize(g){const E=this.store.getFirstInvalidEndStateLineNumberOrMax();return g<E||g===E&&this._textModel.getLineLength(g)<2048}tokenizeHeuristically(g,E,w){if(w<=this.store.getFirstInvalidEndStateLineNumberOrMax())return{heuristicTokens:!1};if(E<=this.store.getFirstInvalidEndStateLineNumberOrMax())return this.updateTokensUntilLine(g,w),{heuristicTokens:!1};let O=this.b(E);const U=this._textModel.getLanguageId();for(let $=E;$<=w;$++){const m=this._textModel.getLineContent($),k=B(this._languageIdCodec,U,this.tokenizationSupport,m,!0,O);g.add($,k.tokens),O=k.endState}return{heuristicTokens:!0}}b(g){let E=this._textModel.getLineFirstNonWhitespaceColumn(g);const w=[];let O=null;for(let m=g-1;E>1&&m>=1;m--){const k=this._textModel.getLineFirstNonWhitespaceColumn(m);if(k!==0&&k<E&&(w.push(this._textModel.getLineContent(m)),E=k,O=this.getStartState(m),O))break}O||(O=this.tokenizationSupport.getInitialState()),w.reverse();const U=this._textModel.getLanguageId();let $=O;for(const m of w)$=B(this._languageIdCodec,U,this.tokenizationSupport,m,!1,$).endState;return $}}e.$TB=n;class a{constructor(g){this.d=g,this.a=new b,this.b=new C,this.b.addRange(new t.$Gs(1,g+1))}getEndState(g){return this.a.getEndState(g)}setEndState(g,E){if(!E)throw new T.$bb("Cannot set null/undefined state");this.b.delete(g);const w=this.a.setEndState(g,E);return w&&g<this.d&&this.b.addRange(new t.$Gs(g+1,g+2)),w}acceptChange(g,E){this.d+=E-g.length,this.a.acceptChange(g,E),this.b.addRangeAndResize(new t.$Gs(g.startLineNumber,g.endLineNumberExclusive),E)}acceptChanges(g){for(const E of g){const[w]=(0,s.$_s)(E.text);this.acceptChange(new c.$Is(E.range.startLineNumber,E.range.endLineNumber+1),w+1)}}invalidateEndStateRange(g){this.b.addRange(new t.$Gs(g.startLineNumber,g.endLineNumberExclusive))}getFirstInvalidEndStateLineNumber(){return this.b.min}getFirstInvalidEndStateLineNumberOrMax(){return this.getFirstInvalidEndStateLineNumber()||Number.MAX_SAFE_INTEGER}allStatesValid(){return this.b.min===null}getStartState(g,E){return g===1?E:this.getEndState(g-1)}getFirstInvalidLine(g){const E=this.getFirstInvalidEndStateLineNumber();if(E===null)return null;const w=this.getStartState(E,g);if(!w)throw new T.$bb("Start state must be defined");return{lineNumber:E,startState:w}}}e.$UB=a;class b{constructor(){this.a=new h.$QB(null)}getEndState(g){return this.a.get(g)}setEndState(g,E){const w=this.a.get(g);return w&&w.equals(E)?!1:(this.a.set(g,E),!0)}acceptChange(g,E){let w=g.length;E>0&&w>0&&(w--,E--),this.a.replace(g.startLineNumber,w,E)}acceptChanges(g){for(const E of g){const[w]=(0,s.$_s)(E.text);this.acceptChange(new c.$Is(E.range.startLineNumber,E.range.endLineNumber+1),w+1)}}}e.$VB=b;class C{constructor(){this.a=[]}getRanges(){return this.a}get min(){return this.a.length===0?null:this.a[0].start}removeMin(){if(this.a.length===0)return null;const g=this.a[0];return g.start+1===g.endExclusive?this.a.shift():this.a[0]=new t.$Gs(g.start+1,g.endExclusive),g.start}delete(g){const E=this.a.findIndex(w=>w.contains(g));if(E!==-1){const w=this.a[E];w.start===g?w.endExclusive===g+1?this.a.splice(E,1):this.a[E]=new t.$Gs(g+1,w.endExclusive):w.endExclusive===g+1?this.a[E]=new t.$Gs(w.start,g):this.a.splice(E,1,new t.$Gs(w.start,g),new t.$Gs(g+1,w.endExclusive))}}addRange(g){t.$Gs.addRange(g,this.a)}addRangeAndResize(g,E){let w=0;for(;!(w>=this.a.length||g.start<=this.a[w].endExclusive);)w++;let O=w;for(;!(O>=this.a.length||g.endExclusive<this.a[O].start);)O++;const U=E-g.length;for(let $=O;$<this.a.length;$++)this.a[$]=this.a[$].delta(U);if(w===O){const $=new t.$Gs(g.start,g.start+E);$.isEmpty||this.a.splice(w,0,$)}else{const $=Math.min(g.start,this.a[w].start),m=Math.max(g.endExclusive,this.a[O-1].endExclusive),k=new t.$Gs($,m+U);k.isEmpty?this.a.splice(w,O-w):this.a.splice(w,O-w,k)}}toString(){return this.a.map(g=>g.toString()).join(" + ")}}e.$WB=C;function B(I,g,E,w,O,U){let $=null;if(E)try{$=E.tokenizeEncoded(w,O,U.clone())}catch(m){(0,T.$Z)(m)}return $||($=(0,r.$PB)(I.encodeLanguageId(g),U)),l.$at.convertToEndOffset($.tokens,w.length),$}class L{constructor(g,E){this.b=g,this.d=E,this.a=!1,this.f=!1}dispose(){this.a=!0}handleChanges(){this.g()}g(){this.f||!this.b._textModel.isAttachedToEditor()||!this.k()||(this.f=!0,(0,N.$bh)(g=>{this.f=!1,this.h(g)}))}h(g){const E=Date.now()+g.timeRemaining(),w=()=>{this.a||!this.b._textModel.isAttachedToEditor()||!this.k()||(this.j(),Date.now()<E?(0,v.$B)(w):this.g())};w()}j(){const g=this.b._textModel.getLineCount(),E=new u.$RB,w=A.$Nd.create(!1);do if(w.elapsed()>1||this.l(E)>=g)break;while(this.k());this.d.setTokens(E.finalize()),this.checkFinished()}k(){return this.b?!this.b.store.allStatesValid():!1}l(g){const E=this.b?.getFirstInvalidLine();return E?(this.b.updateTokensUntilLine(g,E.lineNumber),E.lineNumber):this.b._textModel.getLineCount()+1}checkFinished(){this.a||this.b.store.allStatesValid()&&this.d.backgroundTokenizationFinished()}requestTokens(g,E){this.b.store.invalidateEndStateRange(new c.$Is(g,E))}}e.$XB=L}),define(G[37],V([0,1,33,2,36,14,34]),function(p,e,N,T,v,A,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rFb=void 0;class c extends T.$Rc{constructor(r,h,u,l,f,i,n){super(),this.c=r,this.f=h,this.g=u,this.h=l,this.j=f,this.m=i,this.n=n,this.a=[],this.b=this.B(new N.$Rd),this.onDidEncounterLanguage=this.b.event}get backgroundTokenizerShouldOnlyVerifyTokens(){return this.j()}getInitialState(){return this.f}tokenize(r,h,u){throw new Error("Not supported!")}createBackgroundTokenizer(r,h){if(this.h)return this.h(r,h)}tokenizeEncoded(r,h,u){const l=Math.random()*1e4<1,f=this.n||l,i=f?new v.$Nd(!0):void 0,n=this.c.tokenizeLine2(r,u,500);if(f){const b=i.elapsed();(l||b>32)&&this.m(b,r.length,l)}if(n.stoppedEarly)return console.warn(`Time limit reached when tokenizing line: ${r.substring(0,100)}`),new s.$it(n.tokens,u);if(this.g){const b=this.a,C=n.tokens;for(let B=0,L=C.length>>>1;B<L;B++){const I=C[(B<<1)+1],g=A.$0s.getLanguageId(I);b[g]||(b[g]=!0,this.b.fire(g))}}let a;return u.equals(n.ruleStack)?a=u:a=n.ruleStack,new s.$it(n.tokens,a)}}e.$rFb=c}),define(G[38],V([0,1,20,2,11]),function(p,e,N,T,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sFb=void 0;class A extends T.$Rc{get backgroundTokenizerShouldOnlyVerifyTokens(){return this.b.backgroundTokenizerShouldOnlyVerifyTokens}constructor(c,t,r){super(),this.a=c,this.b=t,this.c=r,this.B((0,v.keepObserved)(this.c))}getInitialState(){return this.b.getInitialState()}tokenize(c,t,r){throw new Error("Not supported!")}tokenizeEncoded(c,t,r){return c.length>=this.c.get()?(0,N.$PB)(this.a,r):this.b.tokenizeEncoded(c,t,r)}createBackgroundTokenizer(c,t){if(this.b.createBackgroundTokenizer)return this.b.createBackgroundTokenizer(c,t)}}e.$sFb=A}),define(G[39],V([0,1,32,19,11,3,15,48,35,16,7,37,38]),function(p,e,N,T,v,A,s,c,t,r,h,u,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xFb=void 0;class f extends c.$2u{constructor(a,b,C,B,L,I,g,E){super(a,b,C,B),this.s=L,this.t=I,this.u=g,this.a=null,this.b=!1,this.c=(0,v.observableValue)(this,-1),this.q=new T.$0g(()=>this.w(),10),this.c.set(E,void 0),this.v()}dispose(){this.b=!0,super.dispose()}onLanguageId(a,b){this.t=a,this.u=b,this.v()}onEvents(a){super.onEvents(a),this.a?.store.acceptChanges(a.changes),this.q.schedule()}acceptMaxTokenizationLineLength(a){this.c.set(a,void 0)}retokenize(a,b){this.a&&(this.a.store.invalidateEndStateRange(new s.$Is(a,b)),this.q.schedule())}async v(){this.a=null;const a=this.t,b=this.u,C=await this.s.getOrCreateGrammar(a,b);if(!(this.b||a!==this.t||b!==this.u||!C)){if(C.grammar){const B=new l.$sFb(this.u,new u.$rFb(C.grammar,C.initialState,!1,void 0,()=>!1,(L,I,g)=>{this.s.reportTokenizationTime(L,a,C.sourceExtensionId,I,g)},!1),this.c);this.a=new t.$SB(this.f.length,B)}else this.a=null;this.w()}}async w(){if(this.b||!this.a)return;if(!this.m){const{diffStateStacksRefEq:b}=await(0,N.$NC)("vscode-textmate","release/main.js");this.m=b}const a=new Date().getTime();for(;;){let b=0;const C=new r.$RB,B=new i;for(;;){const g=this.a.getFirstInvalidLine();if(g===null||b>200)break;b++;const E=this.f[g.lineNumber-1],w=this.a.tokenizationSupport.tokenizeEncoded(E,!0,g.startState);if(this.a.store.setEndState(g.lineNumber,w.endState)){const U=this.m(g.startState,w.endState);B.setState(g.lineNumber,U)}else B.setState(g.lineNumber,null);if(h.$at.convertToEndOffset(w.tokens,E.length),C.add(g.lineNumber,w.tokens),new Date().getTime()-a>20)break}if(b===0)break;const L=B.getStateDeltas();if(this.s.setTokensAndStates(this.h,C.serialize(),L),new Date().getTime()-a>20){(0,A.$B)(()=>this.w());return}}}}e.$xFb=f;class i{constructor(){this.a=-1,this.b=[]}setState(a,b){a===this.a+1?this.b[this.b.length-1].stateDeltas.push(b):this.b.push({startLineNumber:a,stateDeltas:[b]}),this.a=a}getStateDeltas(){return this.b}}}),define(G[40],V([0,1,18]),function(p,e,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uFb=void 0;class T{constructor(){this.a=Object.create(null)}reset(){this.a=Object.create(null)}register(A){if(this.a[A.scopeName]){const s=this.a[A.scopeName];N.$sg(s.location,A.location)||console.warn(`Overwriting grammar scope name to file mapping for scope ${A.scopeName}.
Old grammar file: ${s.location.toString()}.
New grammar file: ${A.location.toString()}`)}this.a[A.scopeName]=A}getGrammarDefinition(A){return this.a[A]||null}}e.$uFb=T}),define(G[41],V([0,1,2,40]),function(p,e,N,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wFb=e.$vFb=void 0,e.$vFb="No TM Grammar registered for this language.";class v extends N.$Rc{constructor(s,c,t,r){super(),this.a=s,this.b=t.INITIAL,this.c=new T.$uFb,this.f={},this.g={},this.h=new Map,this.j=this.B(new t.Registry({onigLib:r,loadGrammar:async h=>{const u=this.c.getGrammarDefinition(h);if(!u)return this.a.logTrace(`No grammar found for scope ${h}`),null;const l=u.location;try{const f=await this.a.readFile(l);return t.parseRawGrammar(f,l.path)}catch(f){return this.a.logError(`Unable to load and parse grammar for scope ${h} from ${l}`,f),null}},getInjections:h=>{const u=h.split(".");let l=[];for(let f=1;f<=u.length;f++){const i=u.slice(0,f).join(".");l=[...l,...this.f[i]||[]]}return l}}));for(const h of c){if(this.c.register(h),h.injectTo){for(const u of h.injectTo){let l=this.f[u];l||(this.f[u]=l=[]),l.push(h.scopeName)}if(h.embeddedLanguages)for(const u of h.injectTo){let l=this.g[u];l||(this.g[u]=l=[]),l.push(h.embeddedLanguages)}}h.language&&this.h.set(h.language,h.scopeName)}}has(s){return this.h.has(s)}setTheme(s,c){this.j.setTheme(s,c)}getColorMap(){return this.j.getColorMap()}async createGrammar(s,c){const t=this.h.get(s);if(typeof t!="string")throw new Error(e.$vFb);const r=this.c.getGrammarDefinition(t);if(!r)throw new Error(e.$vFb);const h=r.embeddedLanguages;if(this.g[t]){const f=this.g[t];for(const i of f)for(const n of Object.keys(i))h[n]=i[n]}const u=Object.keys(h).length>0;let l;try{l=await this.j.loadGrammarWithConfiguration(t,c,{embeddedLanguages:h,tokenTypes:r.tokenTypes,balancedBracketSelectors:r.balancedBracketSelectors,unbalancedBracketSelectors:r.unbalancedBracketSelectors})}catch(f){throw f.message&&f.message.startsWith("No grammar provided for")?new Error(e.$vFb):f}return{languageId:s,grammar:l,initialState:this.b,containsEmbeddedLanguages:u,sourceExtensionId:r.sourceExtensionId}}}e.$wFb=v}),define(G[49],V([0,1,8,41,39]),function(p,e,N,T,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextMateTokenizationWorker=e.create=void 0;function A(c,t){return new s(c,t)}e.create=A;class s{constructor(t,r){this.f=r,this.b=new Map,this.c=[],this.a=t.host;const h=r.grammarDefinitions.map(u=>({location:N.URI.revive(u.location),language:u.language,scopeName:u.scopeName,embeddedLanguages:u.embeddedLanguages,tokenTypes:u.tokenTypes,injectTo:u.injectTo,balancedBracketSelectors:u.balancedBracketSelectors,unbalancedBracketSelectors:u.unbalancedBracketSelectors,sourceExtensionId:u.sourceExtensionId}));this.d=this.g(h)}async g(t){const r=this.f.textmateMainUri,h=await new Promise((n,a)=>{p([r],n,a)}),u=await new Promise((n,a)=>{p([this.f.onigurumaMainUri],n,a)}),f=await(await fetch(this.f.onigurumaWASMUri)).arrayBuffer();await u.loadWASM(f);const i=Promise.resolve({createOnigScanner:n=>u.createOnigScanner(n),createOnigString:n=>u.createOnigString(n)});return new T.$wFb({logTrace:n=>{},logError:(n,a)=>console.error(n,a),readFile:n=>this.a.readFile(n)},t,h,i)}acceptNewModel(t){const r=N.URI.revive(t.uri),h=this;this.b.set(t.controllerId,new v.$xFb(r,t.lines,t.EOL,t.versionId,{async getOrCreateGrammar(u,l){const f=await h.d;return f?(h.c[l]||(h.c[l]=f.createGrammar(u,l)),h.c[l]):Promise.resolve(null)},setTokensAndStates(u,l,f){h.a.setTokensAndStates(t.controllerId,u,l,f)},reportTokenizationTime(u,l,f,i,n){h.a.reportTokenizationTime(u,l,f,i,n)}},t.languageId,t.encodedLanguageId,t.maxTokenizationLineLength))}acceptModelChanged(t,r){this.b.get(t).onEvents(r)}retokenize(t,r,h){this.b.get(t).retokenize(r,h)}acceptModelLanguageChanged(t,r,h){this.b.get(t).onLanguageId(r,h)}acceptRemovedModel(t){const r=this.b.get(t);r&&(r.dispose(),this.b.delete(t))}async acceptTheme(t,r){(await this.d)?.setTheme(t,r)}acceptMaxTokenizationLineLength(t,r){this.b.get(t).acceptMaxTokenizationLineLength(r)}}e.TextMateTokenizationWorker=s})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/94959e85502687ec77e23eb0d4d4b1a827b919af/core/vs/workbench/services/textMate/browser/backgroundTokenization/worker/textMateTokenizationWorker.worker.js.map
